import { IgrStrategyBasedIndicator } from "./igr-strategy-based-indicator";
import { FastStochasticOscillatorIndicator } from "./FastStochasticOscillatorIndicator";
/**
 * Represents a IgxDataChartComponent Fast Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*/
export class IgrFastStochasticOscillatorIndicator extends IgrStrategyBasedIndicator {
    createImplementation() {
        return new FastStochasticOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the moving average period for the current FastStochasticOscillatorIndicator object.
     * The typical, and initial, value for FastStochasticOscillatorIndicator periods is 14.
    */
    get period() {
        return this.i.qx;
    }
    set period(v) {
        this.i.qx = +v;
    }
}
//# sourceMappingURL=igr-fast-stochastic-oscillator-indicator.js.map
