/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgrSeriesViewer`.
*/
export class IgrScalerParams {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The series reference value.
     * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
    */
    get referenceValue() {
        return this.i.b;
    }
    set referenceValue(v) {
        this.i.b = +v;
    }
}
//# sourceMappingURL=igr-scaler-params.js.map
