import { IgrSplineSeriesBase } from "./igr-spline-series-base";
import { SplineAreaSeries } from "./SplineAreaSeries";
/**
 * Represents a IgxDataChartComponent spline area series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineAreaSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"
* />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSplineAreaSeries({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* ```
*/
export class IgrSplineAreaSeries extends IgrSplineSeriesBase {
    createImplementation() {
        return new SplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
}
//# sourceMappingURL=igr-spline-area-series.js.map
