import { IgrSeries } from "./igr-series";
import { CalloutSeriesSelectingEventArgs as CalloutSeriesSelectingEventArgs_internal } from "./CalloutSeriesSelectingEventArgs";
/**
 * Represents event arguments for selecting callout layer
*/
var IgrCalloutSeriesSelectingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutSeriesSelectingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutSeriesSelectingEventArgs.prototype.createImplementation = function () {
        return new CalloutSeriesSelectingEventArgs_internal();
    };
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutSeriesSelectingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCalloutSeriesSelectingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "series", {
        /**
         * Gets or sets series object assositated with callout layer
        */
        get: function () {
            if (this.i.a == null) {
                return null;
            }
            if (!this.i.a.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.a);
                if (e) {
                    e._implementation = this.i.a;
                }
                this.i.a.externalObject = e;
            }
            return this.i.a.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "seriesName", {
        /**
         * Gets or sets series name assositated with callout layer
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutSeriesSelectingEventArgs;
}());
export { IgrCalloutSeriesSelectingEventArgs };
//# sourceMappingURL=igr-callout-series-selecting-event-args.js.map
