import { Type } from "igniteui-react-core";
/**
 * Describes available modes of interpolation on a color scale.
 */
export declare enum ColorScaleInterpolationMode {
    /**
     * Select one of the colors in the palette.
     */
    Select = 0,
    /**
     * Interpolate between colors in the palette using RGB interpolation.
     */
    InterpolateRGB = 1,
    /**
     * Interpolate between colors in the palette using HSV interpolation.
     */
    InterpolateHSV = 2
}
/**
 * @hidden
 */
export declare let ColorScaleInterpolationMode_$type: Type;
