import { Type } from "igniteui-react-core";
/**
 * Gets or sets how to select the final value to annotate.
 */
export declare enum FinalValueSelectionMode {
    /**
     * A mode is selected automatically
     */
    Auto = 0,
    /**
     * Displays the last value visible.
     */
    FinalVisible = 1,
    /**
     * Displays an interploated last value for when the series leaves view.
     */
    FinalVisibleInterpolated = 2,
    /**
     * Displays the last value in the series, whether visible or not.
     */
    Final = 3
}
/**
 * @hidden
 */
export declare let FinalValueSelectionMode_$type: Type;
