import { IgrSizeScale } from "./igr-size-scale";
import { IgrBrushScale } from "./igr-brush-scale";
import { IgrScatterBase, IIgrScatterBaseProps } from "./igr-scatter-base";
import { BubbleSeries } from "./BubbleSeries";
/**
 * Represents a IgxDataChartComponent bubble series.
*/
export declare class IgrBubbleSeries extends IgrScatterBase<IIgrBubbleSeriesProps> {
    protected createImplementation(): BubbleSeries;
    /**
                                 * @hidden
                                 */
    readonly i: BubbleSeries;
    constructor(props: IIgrBubbleSeriesProps);
    /**
     * Gets or sets the radius mapping property for the current series object.
    */
    radiusMemberPath: string;
    /**
     * Gets or sets the radius size scale for the bubbles.
    */
    radiusScale: IgrSizeScale;
    /**
     * Gets or sets the Label mapping property for the current series object.
    */
    labelMemberPath: string;
    /**
     * Gets or sets the fill mapping property for the current series object.
    */
    fillMemberPath: string;
    /**
     * Gets or sets the brush scale for the marker brush.
    */
    fillScale: IgrBrushScale;
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    readonly isMarkerlessDisplayPreferred: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getItemValue(item: any, memberPathName: string): any;
}
export interface IIgrBubbleSeriesProps extends IIgrScatterBaseProps {
    /**
     * Gets or sets the radius mapping property for the current series object.
    */
    radiusMemberPath?: string;
    /**
     * Gets or sets the radius size scale for the bubbles.
    */
    radiusScale?: IgrSizeScale;
    /**
     * Gets or sets the Label mapping property for the current series object.
    */
    labelMemberPath?: string;
    /**
     * Gets or sets the fill mapping property for the current series object.
    */
    fillMemberPath?: string;
    /**
     * Gets or sets the brush scale for the marker brush.
    */
    fillScale?: IgrBrushScale;
}
