import { UnknownValuePlotting } from "igniteui-react-core";
import { IgrPolarLineSeriesBase, IIgrPolarLineSeriesBaseProps } from "./igr-polar-line-series-base";
import { PolarLineSeries } from "./PolarLineSeries";
/**
 * Represents a IgxDataChartComponent polar line series.
*/
export declare class IgrPolarLineSeries extends IgrPolarLineSeriesBase<IIgrPolarLineSeriesProps> {
    protected createImplementation(): PolarLineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: PolarLineSeries;
    constructor(props: IIgrPolarLineSeriesProps);
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
}
export interface IIgrPolarLineSeriesProps extends IIgrPolarLineSeriesBaseProps {
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting?: UnknownValuePlotting | string;
}
