import { IgrAnchoredRadialSeries, IIgrAnchoredRadialSeriesProps } from "./igr-anchored-radial-series";
import { RadialColumnSeries } from "./RadialColumnSeries";
/**
 * Represents a IgxDataChartComponent radial column series.
 * Compare values across categories by using radial rectangles.
*/
export declare class IgrRadialColumnSeries extends IgrAnchoredRadialSeries<IIgrRadialColumnSeriesProps> {
    protected createImplementation(): RadialColumnSeries;
    /**
                                 * @hidden
                                 */
    readonly i: RadialColumnSeries;
    constructor(props: IIgrRadialColumnSeriesProps);
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX: number;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY: number;
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate(): void;
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan(): number;
}
export interface IIgrRadialColumnSeriesProps extends IIgrAnchoredRadialSeriesProps {
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    radiusX?: number | string;
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    radiusY?: number | string;
}
