import { IgSize } from "igniteui-react-core";
import { IgPoint } from "igniteui-react-core";
import { IgrRingSeriesBase } from "./igr-ring-series-base";
import { Ring as Ring_internal } from "./Ring";
/**
 * Represents data for Ring.RingControl element.
*/
export declare class IgrRing {
    protected createImplementation(): Ring_internal;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: Ring_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the index of ring in the chart.
    */
    index: number;
    /**
     * Gets the inner extend of the ring in percentage.
    */
    innerExtend: number;
    /**
     * Gets the size of the ring.
    */
    controlSize: IgSize;
    /**
     * Gets the center point of the ring.
    */
    center: IgPoint;
    /**
     * Gets reference to ring series.
    */
    ringSeries: IgrRingSeriesBase;
    /**
     * Gets the ring breadth.
    */
    ringBreadth: number;
    /**
     * Renders the arcs.
    
    */
    renderArcs(): boolean;
    /**
     * Prepares data needed to create Arcs.
    
    */
    prepareArcs(): void;
}
