import { IgrStyle } from "igniteui-react-core";
import { IgrShapeSeriesBase, IIgrShapeSeriesBaseProps } from "./igr-shape-series-base";
import { ScatterPolylineSeries } from "./ScatterPolylineSeries";
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
export declare class IgrScatterPolylineSeries extends IgrShapeSeriesBase<IIgrScatterPolylineSeriesProps> {
    protected createImplementation(): ScatterPolylineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: ScatterPolylineSeries;
    constructor(props: IIgrScatterPolylineSeriesProps);
    /**
     * The default style to apply to all Shapes in the series.
    */
    shapeStyle: IgrStyle;
}
export interface IIgrScatterPolylineSeriesProps extends IIgrShapeSeriesBaseProps {
    /**
     * The default style to apply to all Shapes in the series.
    */
    shapeStyle?: IgrStyle;
}
