import { IgrSplineSeriesBase, IIgrSplineSeriesBaseProps } from "./igr-spline-series-base";
import { SplineSeries } from "./SplineSeries";
/**
 * Represents a IgxDataChartComponent spline series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSplineAreaSeries({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* ```
*/
export declare class IgrSplineSeries extends IgrSplineSeriesBase<IIgrSplineSeriesProps> {
    protected createImplementation(): SplineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: SplineSeries;
    constructor(props: IIgrSplineSeriesProps);
}
export interface IIgrSplineSeriesProps extends IIgrSplineSeriesBaseProps {
}
