import { __extends, __values, __generator, __spread } from 'tslib';
import { Type, markEnum, markType, Base, PropertyChangedEventArgs, PropertyUpdatedEventArgs, FrameworkElement, INotifyPropertyChanged_$type, markDep, DependencyProperty, PropertyMetadata, CanvasViewRenderer, typeCast, IEquatable$1_$type, truncate, log10, ObservableCollection$1, EventArgs, Rect, DependencyObject, List$1, logBase, typeGetValue, Number_$type, isNaN_, TypeRegistrar, ContentControl, Dictionary$2, String_$type, DVContainer, Point_$type, dateNow, CanvasRenderScheduler, delegateCombine, runOn, DoubleAnimator, SRProvider, delegateRemove, fromEnum, fromEn, PointUtil, MouseEventArgs, MouseButtonEventArgs, enumGetBox, toEnum, RectChangedEventArgs, Size, MathUtil, DeviceUtils, NotifyCollectionChangedEventArgs, stringIsNullOrEmpty, FastItemsSource, defaultDVDateParse, FontUtil, Control, ILegendOwner_$type, IInternalLegendOwner_$type, IChartLegend_$type, Boolean_$type, Brush, DataTemplate, Visibility_$type, InteractionState_$type, ModifierKeys_$type, HorizontalAlignment_$type, Line, Path, Rectangle, PathFigureCollection, PathFigure, LineSegment, PathGeometry, GeometryGroup, Thickness, TextBlock, ISchedulableRender_$type, ArgumentNullException, stringEmpty, Tuple$2, DomWrapper_$type, RenderingContext, BrushCollection, CssGradientUtil, isInfinity, VerticalAlignment_$type, FastReflectionHelper, Pool$1, RectangleGeometry, LineGeometry, BrushUtilCore, Delegate_$type, DoubleCollection, RectUtil, RotateTransform, TransformGroup, Panel, IFastItemsSource_$type, IFastItemsSourceProvider_$type, IEnumerable_$type, AngleSimplifier, TranslateTransform, Canvas, Binding, DataContext, ILegendSeries_$type, ILegendTemplateProvider_$type, PenLineCap_$type, Color, Style, FastItemsSourceReference, stringFormat, EasingFunctions, DataTemplatePassInfo, DataTemplateRenderInfo, DataTemplateMeasureInfo, callStaticConstructors, BrushUtil, HashSet$1, LinkedList$1, LinkedListNode$1, FastItemObjectColumn, LabelCollisionManager, QuadTreeBoundingBox, Date_$type, LabelCollisionInfo, HashPool$2, DOMExecutionContext, PointCollection, Polygon, Polyline, ensureBool, NamePatcher, isValidProp, getModifiedProps, ensureEnum, brushToString, stringToBrush, colorToString, stringToColor, toSpinal, initializePropertiesFromCss, toPoint, fromPoint, fromRect, InterpolationUtil, ArrayAccessHelper, Array_$type, LinearGradientBrush, ColorUtil, round10N, NotImplementedException, SyncableObservableCollection$2, IgCollection, SyncableObservableCollection$1, Random, intDivide, Clipper, NotSupportedException, TrendLineType_$type, EnumUtil, PolyLineSegment, FastFlattener, IUnknownValuePlotting_$type, UnknownValuePlotting_$type, getEnumerator, IEnumerable$1_$type, ReadOnlyCollection$1, IList$1_$type, Numeric, ArrayExtension, DataSeriesAdapter, getInstanceType, DataSeriesType_$type, BaseError, ObservableColorCollection, BrushCollectionUtil, IDataSeriesAdapterRule_$type, SimpleCategorySeriesRule, SubCollectionsRule, fromBrushCollection, toBrushCollection, toRect, addPaletteThemeEntry, addTextThemeEntry, addBrushPaletteThemeEntry, ReactRenderer, DataSeriesType, IgrDataContext, ReactWrapper, numberToString2, GeometryUtil, PolygonUtil, boxArray$1, toNullable, IgrDVInteractivityModule, Flattener, LeastSquaresFit, TrendCalculators, IgrPropertyUpdatedEventArgs, RectData, PointData, StringBuilder, LegendItemHelper, DOMEventProxy, ObjectCollection, UIElement, IList_$type, SweepDirection_$type, EllipseGeometry, PathSegmentCollection, ArcSegment, PrimitiveAppearanceData, LabelAppearanceData, AppearanceHelper, PathVisualData, BezierSegment, SizeData, DomRenderer_$type, fromSize, toSize, ContentChildrenManager, CollectionAdapter, NotifyCollectionChangedAction, dateAddDays, dateFromValues, dateGetMonth, dateAddHours, dateAddMinutes, dateAddSeconds, dateMaxValue, timeSpanFromDays, dateAddYears, dateAddMonths, timeSpanFromHours, timeSpanFromMinutes, timeSpanFromSeconds, timeSpanFromMilliseconds, timeSpanFromTicks, Extensions, getBoxIfEnum, dateMinValue, FastItemDateTimeColumn, dateSubtract, dateAdd, dateFromTicks, IDictionary$2_$type, IDictionary_$type, KeyValuePair$2, IEnumerator$1_$type, IEnumerator_$type, timeSpanTicks, dateToStringFormat, timeSpanInit3, timeSpanInit1, dateGetTimeOfDay, timeSpanTotalMilliseconds, SpiralFlattener, stringEndsWith, IFastItemColumn$1_$type, EnumeratorWrapper, stringStartsWith, stringReplace, stringJoin, SimpleFinancialPriceSeriesRule, IgrTemplateContainer, IgrTemplateContentModule, CanvasGestureDOMEventProxy, FontInfo, IZoomSlider_$type, IgrRectChangedEventArgs, ILegendContext_$type, CompareUtil, SmartPlacer, SmartPlaceableWrapper$1, RearrangedList$1, IErrorBarCalculator_$type, ErrorBarCalculatorReference_$type, IScaleLegendSeries_$type, arrayShallowClone, Stack$1, fromColorCollection, toColorCollection, IgrTriangulationStatusEventArgs, Triangulator, TriangulationStatusEventArgs, FastItemIntColumn, PointCollectionUtil, InvalidOperationException, PolySimplification, IgrStyle, PlatformConstants, IOverviewPlusDetailControl_$type, IChartItemLegend_$type, Shape, IChartScaleLegend_$type, IgrObjectCollection, PrimitiveVisualDataList, ColorData, PolygonVisualData, PolyLineVisualData, RectangleVisualData, LineVisualData, DictionaryUtil, Queue$1 } from 'igniteui-react-core';
import { Component, createElement, Fragment, Children } from 'react';
import { createPortal } from 'react-dom';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IAnnotationLayerProxy_$type = /*@__PURE__*/ new Type(null, 'IAnnotationLayerProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for performing hit testing in the chart/map.
 */
var ChartHitTestMode = /*@__PURE__*/ (function (ChartHitTestMode) {
    /**
     * Automatically decide the appropriate hit test mode for the content.
     */
    ChartHitTestMode[ChartHitTestMode["Auto"] = 0] = "Auto";
    /**
     * Use a computational based approach to determine which series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
     */
    ChartHitTestMode[ChartHitTestMode["Computational"] = 1] = "Computational";
    /**
     * Use a color encoded off screen buffer for hit testing. This can have extremely rare false positives where the wrong series is hit (this is due to our inability to disable anti-aliasing in our color buffer), but should always be O(1) time for determining a hit series. This increases frame render time, however. Consider using this if hit testing time is degrading performance.
     */
    ChartHitTestMode[ChartHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
    /**
     * Let each series decide which hit testing mode to use individually based on their own hit test mode.
     */
    ChartHitTestMode[ChartHitTestMode["Mixed"] = 3] = "Mixed";
    /**
     * Let each series decide which hit testing mode to use individually based on their own hit test mode, but evaluate all computational hits before evaluating any color encoding hits.
     */
    ChartHitTestMode[ChartHitTestMode["MixedFavoringComputational"] = 4] = "MixedFavoringComputational";
    return ChartHitTestMode;
})({});
/**
 * @hidden
 */
var ChartHitTestMode_$type = /*@__PURE__*/ markEnum('ChartHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2|Mixed,3|MixedFavoringComputational,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of UI response to user panning and zooming operations.
 */
var WindowResponse = /*@__PURE__*/ (function (WindowResponse) {
    /**
     * Defer the view update until after the user action is complete.
     */
    WindowResponse[WindowResponse["Deferred"] = 0] = "Deferred";
    /**
     * Update the view immediately while the user action is happening.
     */
    WindowResponse[WindowResponse["Immediate"] = 1] = "Immediate";
    return WindowResponse;
})({});
/**
 * @hidden
 */
var WindowResponse_$type = /*@__PURE__*/ markEnum('WindowResponse', 'Deferred,0|Immediate,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesViewerComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerComponentsFromView, _super);
    function SeriesViewerComponentsFromView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    SeriesViewerComponentsFromView.$t = markType(SeriesViewerComponentsFromView, 'SeriesViewerComponentsFromView');
    return SeriesViewerComponentsFromView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SyncSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncSettings, _super);
    function SyncSettings() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        return _this;
    }
    SyncSettings.prototype.ai = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    SyncSettings.$t = markType(SyncSettings, 'SyncSettings', FrameworkElement.$, [INotifyPropertyChanged_$type]);
    SyncSettings.$$p = markDep(DependencyProperty, PropertyMetadata, SyncSettings, 'ai', ['SyncChannel', [2, null], 'SynchronizeHorizontally', [0, true], 'SynchronizeVertically', [0, true]]);
    return SyncSettings;
}(FrameworkElement));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesViewerComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerComponentsForView, _super);
    function SeriesViewerComponentsForView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SeriesViewerComponentsForView.$t = markType(SeriesViewerComponentsForView, 'SeriesViewerComponentsForView');
    return SeriesViewerComponentsForView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions for axis title in respect to axis labels
 */
var AxisTitlePosition = /*@__PURE__*/ (function (AxisTitlePosition) {
    /**
     * Displays the axis title in automatically selected position based on orientation and location of the axis:
     * <para/> - left title position for vertical axis located on left of the chart,
     * <para/> - right title position for vertical axis located on right of the chart,
     * <para/> - top title position for horizontal axis located on top of the chart,
     * <para/> - bottom title position for horizontal axis located on bottom of the chart,
     */
    AxisTitlePosition[AxisTitlePosition["Auto"] = 0] = "Auto";
    /**
     * Displays the axis title to the left of labels on vertical axis
     */
    AxisTitlePosition[AxisTitlePosition["Left"] = 1] = "Left";
    /**
     * Displays the axis title to the right of labels on vertical axis
     */
    AxisTitlePosition[AxisTitlePosition["Right"] = 2] = "Right";
    /**
     * Displays the axis title on top of labels on horizontal axis
     */
    AxisTitlePosition[AxisTitlePosition["Top"] = 3] = "Top";
    /**
     * Displays the axis title on bottom of labels on horizontal axis
     */
    AxisTitlePosition[AxisTitlePosition["Bottom"] = 4] = "Bottom";
    return AxisTitlePosition;
})({});
/**
 * @hidden
 */
var AxisTitlePosition_$type = /*@__PURE__*/ markEnum('AxisTitlePosition', 'Auto,0|Left,1|Right,2|Top,3|Bottom,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CoercionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CoercionInfo, _super);
    function CoercionInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = null;
        return _this;
    }
    CoercionInfo.$t = markType(CoercionInfo, 'CoercionInfo');
    return CoercionInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChartContentType_$type = /*@__PURE__*/ markEnum('ChartContentType', 'Series,0|Axis,1|Background,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITileZoomTile_$type = /*@__PURE__*/ new Type(null, 'ITileZoomTile');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RenderSurface = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RenderSurface, _super);
    function RenderSurface() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    RenderSurface.$t = markType(RenderSurface, 'RenderSurface');
    return RenderSurface;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LabelPanelsArrangeState = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LabelPanelsArrangeState, _super);
    function LabelPanelsArrangeState() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = 0;
        _this.h = 0;
        _this.b = 0;
        _this.e = 0;
        _this.f = 0;
        _this.g = 0;
        _this.c = 0;
        _this.d = 0;
        return _this;
    }
    LabelPanelsArrangeState.$t = markType(LabelPanelsArrangeState, 'LabelPanelsArrangeState');
    return LabelPanelsArrangeState;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerTemplates, _super);
    function MarkerTemplates() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MarkerTemplates.n = function (a, b, c) {
        a.beginPath();
        var d = b.actualItemBrush;
        var e = b.outline;
        if (d != null) {
            if (d.isGradient) {
                var f = c.availableWidth / 2;
                var g = c.availableHeight / 2;
                var h = c.xPosition - f;
                var i = c.yPosition - f;
                h += c.renderOffsetX;
                i += c.renderOffsetY;
                var j = CanvasViewRenderer.j(a, d, h, i, h + c.availableWidth, i + c.availableHeight, b.thickness, false);
                a.fillStyle = j;
            }
            else {
                if (a.fillStyle != d._fill) {
                    a.fillStyle = d._fill;
                }
            }
        }
        if (b.outline != null) {
            if (b.outline.isGradient) {
                var k = c.availableWidth / 2;
                var l = c.availableHeight / 2;
                var m = c.xPosition - k;
                var n = c.yPosition - k;
                m += c.renderOffsetX;
                n += c.renderOffsetY;
                var o = CanvasViewRenderer.j(a, b.outline, m, n, m + c.availableWidth, n + c.availableHeight, b.thickness, true);
                a.strokeStyle = o;
            }
            else {
                if (a.strokeStyle != b.outline._fill) {
                    a.strokeStyle = b.outline._fill;
                }
            }
            a.lineWidth = b.thickness;
        }
    };
    MarkerTemplates.a = function (a, b) {
        if (b.actualItemBrush != null) {
            a.fill();
        }
        if (b.outline != null) {
            a.stroke();
        }
        a.closePath();
    };
    MarkerTemplates.b = function (a) {
        a.isConstant = true;
        a.width = 8;
        a.height = 8;
    };
    MarkerTemplates.d = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = Math.min(a.availableWidth, a.availableHeight) / 2;
        b.arc(a.xPosition, a.yPosition, d, 0, (Math.PI * 2), false);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.m = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f, g);
        b.lineTo(f + e, g + a.availableHeight);
        b.lineTo(f + a.availableWidth, g + 0);
        b.lineTo(f, g);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.j = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f, g + a.availableHeight);
        b.lineTo(f + e, g + 0);
        b.lineTo(f + a.availableWidth, g + a.availableHeight);
        b.lineTo(f, g + a.availableHeight);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.k = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.rect(f, g, a.availableWidth, a.availableHeight);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.c = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var left_ = (a.xPosition - e);
        var top_ = (a.yPosition - d);
        b.rect((left_ | 0), (top_ | 0), a.availableWidth, a.availableHeight);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.e = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + 0, g + d);
        b.lineTo(f + e, g + a.availableHeight);
        b.lineTo(f + a.availableWidth, g + d);
        b.lineTo(f + e, g + 0);
        b.lineTo(f + 0, g + d);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.h = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((0.1956000030040741 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((1.6499999761581421 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((6.3499999046325684 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.f = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + (a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.l = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((2.5856 / 8) * a.availableHeight));
        b.lineTo(f + ((0 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
        b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
        b.lineTo(f + ((8 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((2.5855998992919922 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.i = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((2.8243999481201172 / 8) * a.availableWidth), g + ((2.382 / 8) * a.availableHeight));
        b.lineTo(f + ((0.1956 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((2.0980000495910645 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
        b.lineTo(f + ((1.6488000154495239 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((6.3512 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((5.9019999504089355 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
        b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((5.1756000518798828 / 8) * a.availableWidth), g + ((2.3819999694824219 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.g = function (a) {
        var b = a.context;
        var c = a.data;
        MarkerTemplates.n(b, c, a);
        var d = (a.availableHeight / 2);
        var e = (a.availableWidth / 2);
        var f = (a.xPosition - e);
        var g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((2.268 / 8) * a.availableHeight));
        b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((2 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
        b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((6 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((2.2679998874664307 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    };
    MarkerTemplates.$t = markType(MarkerTemplates, 'MarkerTemplates');
    return MarkerTemplates;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available locations of the axis labels in the chart.
 */
var AxisLabelsLocation = /*@__PURE__*/ (function (AxisLabelsLocation) {
    /**
     * Places the axis labels at the top, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideTop"] = 0] = "OutsideTop";
    /**
     * Places the axis labels at the bottom, outside of the plotting area
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideBottom"] = 1] = "OutsideBottom";
    /**
     * Places the axis labels to the left, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideLeft"] = 2] = "OutsideLeft";
    /**
     * Places the axis labels to the right, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideRight"] = 3] = "OutsideRight";
    /**
     * Places the axis labels inside the plotting area above the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideTop"] = 4] = "InsideTop";
    /**
     * Places the axis labels inside the plotting area below the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideBottom"] = 5] = "InsideBottom";
    /**
     * Places the axis labels inside the plotting area and to the left of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideLeft"] = 6] = "InsideLeft";
    /**
     * Places the axis labels inside the plotting area and to the right of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideRight"] = 7] = "InsideRight";
    return AxisLabelsLocation;
})({});
/**
 * @hidden
 */
var AxisLabelsLocation_$type = /*@__PURE__*/ markEnum('AxisLabelsLocation', 'OutsideTop,0|OutsideBottom,1|OutsideLeft,2|OutsideRight,3|InsideTop,4|InsideBottom,5|InsideLeft,6|InsideRight,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IProvidesViewport_$type = /*@__PURE__*/ new Type(null, 'IProvidesViewport');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PointerTooltipStyle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointerTooltipStyle, _super);
    function PointerTooltipStyle() {
        var _this = _super.call(this) || this;
        _this.b = 0;
        _this.a = 0;
        _this.d = null;
        _this.c = null;
        _this.b = NaN;
        _this.a = NaN;
        return _this;
    }
    PointerTooltipStyle.$t = markType(PointerTooltipStyle, 'PointerTooltipStyle');
    return PointerTooltipStyle;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultPaletteInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultPaletteInfo, _super);
    function DefaultPaletteInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.f = null;
        _this.b = null;
        _this.c = null;
        _this.g = null;
        _this.d = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.h = null;
        _this.i = null;
        return _this;
    }
    DefaultPaletteInfo.$t = markType(DefaultPaletteInfo, 'DefaultPaletteInfo');
    return DefaultPaletteInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisRange = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisRange, _super);
    function AxisRange(a, b) {
        var _this = _super.call(this) || this;
        _this.c = 0;
        _this.b = 0;
        _this.c = a;
        _this.b = b;
        return _this;
    }
    AxisRange.prototype.equals = function (a) {
        return a != null && this.c == a.c && this.b == a.b;
    };
    AxisRange.prototype.equals1 = function (a) {
        return this.equals(typeCast(AxisRange.$, a));
    };
    AxisRange.prototype.getHashCode = function () {
        return _super.prototype.getHashCode.call(this);
    };
    AxisRange.$t = markType(AxisRange, 'AxisRange', Base.$, [IEquatable$1_$type.specialize(-1)]).initSelfReferences();
    return AxisRange;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Snapper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Snapper, _super);
    function Snapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 7;
        _this.a = false;
        return _this;
    }
    Object.defineProperty(Snapper.prototype, "f", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Snapper.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            this.a = a;
        },
        enumerable: true,
        configurable: true
    });
    Snapper.d = function (a, b) {
        var c = 1;
        if (b > 0) {
            for (; b > 0; --b) {
                c *= a;
            }
        }
        else {
            for (; b < 0; ++b) {
                c /= a;
            }
        }
        return c;
    };
    Snapper.e = function (a, b) {
        var c = truncate(Math.floor(log10(a)));
        var d = a / Math.pow(10, c);
        if (b) {
            var e = d < 1.5 ? 1 : d < 3 ? 2 : d < 7 ? 5 : 10;
            return e * Math.pow(10, c);
        }
        else {
            var f = d <= 1 ? 1 : d <= 2 ? 2 : d <= 5 ? 5 : 10;
            return f * Math.pow(10, c);
        }
    };
    Snapper.$t = markType(Snapper, 'Snapper');
    return Snapper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LinearNumericSnapper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LinearNumericSnapper, _super);
    function LinearNumericSnapper(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.g = 0;
        _this.j = 0;
        _this.i = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    if (f > 0) {
                        _this.f = f;
                        _this.b = true;
                    }
                    _this.k(c, d, e, 10);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    if (g > 0) {
                        _this.f = g;
                        _this.b = true;
                    }
                    _this.k(c, d, e, f);
                }
                break;
        }
        return _this;
    }
    LinearNumericSnapper.prototype.k = function (a, b, c, d) {
        this.g = NaN;
        this.j = 0;
        this.i = 0;
        var e = 0;
        if (c < 100) {
            e = 4;
        }
        else {
            e = Math.min(d, truncate((c / this.f)));
        }
        if (e > 0) {
            var f = this.h(a, b, e);
            if (this.b && f > e) {
                this.g = NaN;
                f = this.h(a, b, e - 1);
            }
            e = f;
            if (c / e > this.f * 10) {
                this.i = 10;
            }
            else {
                if (c / e > this.f * 5) {
                    this.i = 5;
                }
                else {
                    if (c / e > this.f * 2) {
                        this.i = 2;
                    }
                }
            }
            this.j = Math.max(-truncate(Math.floor(log10(this.g))), 0);
        }
    };
    LinearNumericSnapper.prototype.h = function (a, b, c) {
        var d = Snapper.e(b - a, false);
        this.g = Snapper.e(d / (c - 1), true);
        var e = Math.floor(a / this.g) * this.g;
        var f = Math.ceil(b / this.g) * this.g;
        var g = truncate(Math.round((f - e) / this.g));
        return g;
    };
    LinearNumericSnapper.$t = markType(LinearNumericSnapper, 'LinearNumericSnapper', Snapper.$);
    return LinearNumericSnapper;
}(Snapper));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IAxisAnnotation_$type = /*@__PURE__*/ new Type(null, 'IAxisAnnotation');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisAnnotationCollection, _super);
    function AxisAnnotationCollection() {
        var _this = _super.call(this, IAxisAnnotation_$type, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    AxisAnnotationCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    AxisAnnotationCollection.$t = markType(AxisAnnotationCollection, 'AxisAnnotationCollection', ObservableCollection$1.$.specialize(IAxisAnnotation_$type));
    return AxisAnnotationCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LabelPosition = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LabelPosition, _super);
    function LabelPosition(a) {
        var _this = _super.call(this) || this;
        _this.c = 0;
        _this.a = false;
        _this.d = null;
        _this.b = false;
        _this.c = a;
        return _this;
    }
    LabelPosition.$t = markType(LabelPosition, 'LabelPosition');
    return LabelPosition;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LabelFontHeuristics = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LabelFontHeuristics, _super);
    function LabelFontHeuristics() {
        var _this = _super.call(this) || this;
        _this.a = 0;
        _this.d = 0;
        _this.b = 0;
        _this.c = 0;
        _this.a = NaN;
        _this.d = NaN;
        _this.b = NaN;
        _this.c = NaN;
        return _this;
    }
    LabelFontHeuristics.$t = markType(LabelFontHeuristics, 'LabelFontHeuristics');
    return LabelFontHeuristics;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisComponentsFromView, _super);
    function AxisComponentsFromView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.d = null;
        _this.c = null;
        return _this;
    }
    AxisComponentsFromView.$t = markType(AxisComponentsFromView, 'AxisComponentsFromView');
    return AxisComponentsFromView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisRangeChangedEventArgs, _super);
    function AxisRangeChangedEventArgs(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    _this = _super.call(this) || this;
                    _this._oldMinimumValue = 0;
                    _this._minimumValue = 0;
                    _this._oldMaximumValue = 0;
                    _this._maximumValue = 0;
                    _this.oldMinimumValue = c;
                    _this.minimumValue = d;
                    _this.oldMaximumValue = e;
                    _this.maximumValue = f;
                }
                break;
            case 1:
                {
                    _this = _super.call(this) || this;
                    _this._oldMinimumValue = 0;
                    _this._minimumValue = 0;
                    _this._oldMaximumValue = 0;
                    _this._maximumValue = 0;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(AxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
        get: function () {
            return this._oldMinimumValue;
        },
        set: function (a) {
            this._oldMinimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisRangeChangedEventArgs.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
        get: function () {
            return this._oldMaximumValue;
        },
        set: function (a) {
            this._oldMaximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisRangeChangedEventArgs.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisRangeChangedEventArgs.$t = markType(AxisRangeChangedEventArgs, 'AxisRangeChangedEventArgs', EventArgs.$);
    return AxisRangeChangedEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PathRenderingInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PathRenderingInfo, _super);
    function PathRenderingInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        _this.e = null;
        _this.d = null;
        _this.f = null;
        _this.a = false;
        return _this;
    }
    Object.defineProperty(PathRenderingInfo.prototype, "c", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            if (a < 0) {
                this.b = a * -1;
            }
            else {
                this.b = a;
            }
        },
        enumerable: true,
        configurable: true
    });
    PathRenderingInfo.$t = markType(PathRenderingInfo, 'PathRenderingInfo');
    return PathRenderingInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RenderRequestedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RenderRequestedEventArgs, _super);
    function RenderRequestedEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._animate = false;
        return _this;
    }
    Object.defineProperty(RenderRequestedEventArgs.prototype, "animate", {
        get: function () {
            return this._animate;
        },
        set: function (a) {
            this._animate = a;
        },
        enumerable: true,
        configurable: true
    });
    RenderRequestedEventArgs.$t = markType(RenderRequestedEventArgs, 'RenderRequestedEventArgs', EventArgs.$);
    return RenderRequestedEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScalerParams = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScalerParams, _super);
    function ScalerParams(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.d = null;
        _this.c = null;
        _this.a = false;
        _this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    _this.e = c;
                    _this.d = d;
                    _this.c = f;
                    _this.a = e;
                    _this.b = NaN;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = [c, d, e, Rect.empty];
                    {
                        var h = f[0];
                        var i = f[1];
                        var j = f[2];
                        var k = f[3];
                        _this.e = h;
                        _this.d = i;
                        _this.c = k;
                        _this.a = j;
                        _this.b = NaN;
                    }
                }
                break;
        }
        return _this;
    }
    ScalerParams.$t = markType(ScalerParams, 'ScalerParams');
    return ScalerParams;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryMode_$type = /*@__PURE__*/ markEnum('CategoryMode', 'Mode0,0|Mode1,1|Mode2,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes of displaying elements in the chart grid, such as gridlines.
 */
var GridMode = /*@__PURE__*/ (function (GridMode) {
    /**
     * No chart grid.
     */
    GridMode[GridMode["None"] = 0] = "None";
    /**
     * Chart grid should be rendered before or in front of the data series.
     */
    GridMode[GridMode["BeforeSeries"] = 1] = "BeforeSeries";
    /**
     * Chart grid should be rendered behind or in back of the data series.
     */
    GridMode[GridMode["BehindSeries"] = 2] = "BehindSeries";
    return GridMode;
})({});
/**
 * @hidden
 */
var GridMode_$type = /*@__PURE__*/ markEnum('GridMode', 'None,0|BeforeSeries,1|BehindSeries,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TickmarkValues, _super);
    function TickmarkValues() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.o = 0;
        _this.m = 0;
        _this.n = 0;
        _this.l = 0;
        _this.p = 0;
        _this.q = 0;
        _this.r = 0;
        return _this;
    }
    TickmarkValues.prototype.s = function (a) {
        this.o = a.m;
    };
    TickmarkValues.$t = markType(TickmarkValues, 'TickmarkValues', DependencyObject.$);
    return TickmarkValues;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IScaler_$type = /*@__PURE__*/ new Type(null, 'IScaler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ICategoryScaler_$type = /*@__PURE__*/ new Type(null, 'ICategoryScaler', null, [IScaler_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeInfo, _super);
    function RangeInfo() {
        var _this = _super.call(this) || this;
        _this.d = 0;
        _this.c = 0;
        _this.a = 0;
        _this.b = 0;
        _this.e = 0;
        _this.a = -1;
        _this.e = -1;
        return _this;
    }
    RangeInfo.$t = markType(RangeInfo, 'RangeInfo');
    return RangeInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisRenderingParametersBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisRenderingParametersBase, _super);
    function AxisRenderingParametersBase() {
        var _this = _super.call(this) || this;
        _this.o = 0;
        _this.z = null;
        _this.aa = null;
        _this.y = null;
        _this.x = null;
        _this.k = null;
        _this.e = null;
        _this.f = null;
        _this.w = null;
        _this.u = null;
        _this.v = null;
        _this.t = null;
        _this.m = 0;
        _this.l = 0;
        _this.n = 0;
        _this.r = 0;
        _this.s = null;
        _this.p = 0;
        _this.g = false;
        _this.h = false;
        _this.j = false;
        _this.b = null;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.q = 0;
        _this.k = new List$1(RangeInfo.$, 0);
        return _this;
    }
    AxisRenderingParametersBase.prototype.i = function () {
        return false;
    };
    AxisRenderingParametersBase.$t = markType(AxisRenderingParametersBase, 'AxisRenderingParametersBase');
    return AxisRenderingParametersBase;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumericAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAxisRenderingParameters, _super);
    function NumericAxisRenderingParameters() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ab = false;
        return _this;
    }
    NumericAxisRenderingParameters.prototype.i = function () {
        return true;
    };
    NumericAxisRenderingParameters.$t = markType(NumericAxisRenderingParameters, 'NumericAxisRenderingParameters', AxisRenderingParametersBase.$);
    return NumericAxisRenderingParameters;
}(AxisRenderingParametersBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LogarithmicNumericSnapper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LogarithmicNumericSnapper, _super);
    function LogarithmicNumericSnapper(a, b, c, d) {
        var _this = _super.call(this) || this;
        _this.g = 0;
        _this.h = 0;
        _this.g = 1;
        _this.h = c;
        return _this;
    }
    LogarithmicNumericSnapper.$t = markType(LogarithmicNumericSnapper, 'LogarithmicNumericSnapper', Snapper.$);
    return LogarithmicNumericSnapper;
}(Snapper));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LogarithmicTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LogarithmicTickmarkValues, _super);
    function LogarithmicTickmarkValues() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.t = null;
        _this.u = null;
        return _this;
    }
    LogarithmicTickmarkValues.prototype.s = function (a) {
        _super.prototype.s.call(this, a);
        var b = new LogarithmicNumericSnapper(a.n, a.m, this.x, a.k);
        this.m = 1;
        this.r = truncate(b.h);
        this.p = truncate(Math.floor(logBase(Math.max(4.94065645841247E-324, a.n), this.x)));
        this.q = truncate(Math.ceil(logBase(Math.max(4.94065645841247E-324, a.m), this.x)));
    };
    Object.defineProperty(LogarithmicTickmarkValues.prototype, "x", {
        get: function () {
            return typeGetValue(this.c(LogarithmicTickmarkValues.z));
        },
        set: function (a) {
            this.h(LogarithmicTickmarkValues.z, a);
        },
        enumerable: true,
        configurable: true
    });
    LogarithmicTickmarkValues.prototype.v = function (a) {
        var b = a * this.m;
        return Math.pow(this.x, b);
    };
    LogarithmicTickmarkValues.prototype.j = function () {
        var a = this.p;
        var b = this.q;
        var c = this.o;
        var d = 0;
        for (var e = a; e <= b; ++e) {
            var f = this.v(e);
            if (f <= c) {
                d++;
            }
        }
        if (this.t == null || this.t.length != d) {
            this.t = new Array(d);
        }
        var g = this.t;
        var h = 0;
        for (var i = a; i <= b; ++i) {
            var j = this.v(i);
            if (j <= c) {
                g[h] = j;
                h++;
            }
        }
        return g;
    };
    LogarithmicTickmarkValues.prototype.k = function () {
        var a = this.p;
        var b = this.q;
        var c = this.x;
        var d = this.r;
        var e = this.o;
        var f = 0;
        for (var g = a; g <= b; ++g) {
            var h = this.v(g);
            var i = Math.pow(c, g);
            for (var j = 1; j < this.r - 1; ++j) {
                var k = h + j * i;
                if (k <= e) {
                    f++;
                }
            }
        }
        if (this.u == null || this.u.length != f) {
            this.u = new Array(f);
        }
        var l = this.u;
        var m = 0;
        for (var n = a; n <= b; ++n) {
            var o = this.v(n);
            var p = Math.pow(c, n);
            for (var q = 1; q < this.r - 1; ++q) {
                var r = o + q * p;
                if (r <= e) {
                    l[m] = r;
                    m++;
                }
            }
        }
        return l;
    };
    LogarithmicTickmarkValues.$t = markType(LogarithmicTickmarkValues, 'LogarithmicTickmarkValues', TickmarkValues.$);
    LogarithmicTickmarkValues.z = DependencyProperty.i("LogarithmBase", Number_$type, LogarithmicTickmarkValues.$, new PropertyMetadata(2, 10, function (a, b) {
    }));
    return LogarithmicTickmarkValues;
}(TickmarkValues));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LinearTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LinearTickmarkValues, _super);
    function LinearTickmarkValues() {
        var _this = _super.call(this) || this;
        _this.y = 0;
        _this.x = 0;
        _this.t = null;
        _this.u = null;
        _this.y = 0;
        return _this;
    }
    LinearTickmarkValues.prototype.s = function (a) {
        _super.prototype.s.call(this, a);
        var b;
        if (this.y != 0) {
            b = new LinearNumericSnapper(1, a.n, a.m, a.k, this.y, a.h);
        }
        else {
            b = new LinearNumericSnapper(0, a.n, a.m, a.k, a.h);
        }
        this.m = b.g;
        if ((a.d) && a.l > 0 && (a.m - a.n) / a.l < 1000) {
            this.m = a.l;
        }
        if (a.i != -1) {
            this.m = a.i;
        }
        if (this.m == 0) {
            this.p = 0;
            this.q = 0;
        }
        else {
            this.p = truncate(Math.floor((a.n - a.g) / this.m));
            this.q = truncate(Math.ceil((a.m - a.g) / this.m));
        }
        this.r = b.i;
        if (a.p != -1) {
            this.r = a.p;
        }
        this.n = a.j;
        this.x = a.g;
    };
    LinearTickmarkValues.prototype.j = function () {
        var a = 0;
        var b = this.p;
        if (!isNaN_(this.m)) {
            a = this.q - b + 1;
            if (a < 0) {
                a = 0;
            }
        }
        if (this.t == null || this.t.length != a) {
            this.t = new Array(a);
        }
        var c = this.t;
        for (var d = 0; d < a; ++d) {
            var e = this.x + (d + b) * this.m;
            c[d] = e;
        }
        return c;
    };
    LinearTickmarkValues.prototype.k = function () {
        if (this.n > 0) {
            return this.w();
        }
        return this.v();
    };
    LinearTickmarkValues.prototype.v = function () {
        var a = this.p;
        var b = this.q;
        var c = this.r;
        var d = this.m;
        var e = this.x;
        var f = this.o;
        var g = d / c;
        var h = 0;
        for (var i = a; i < b; ++i) {
            for (var j = 1; j < c; ++j) {
                var k = e + i * d + (j * g);
                if (k <= f) {
                    h++;
                }
            }
        }
        if (this.u == null || this.u.length != h) {
            this.u = new Array(h);
        }
        var l = this.u;
        var m = 0;
        for (var n = a; n < b; ++n) {
            for (var o = 1; o < c; ++o) {
                var p = e + n * d + (o * g);
                if (p <= this.o) {
                    l[m] = p;
                    m++;
                }
            }
        }
        return l;
    };
    LinearTickmarkValues.prototype.w = function () {
        var a = this.p;
        var b = this.q;
        var c = this.r;
        var d = this.m;
        var e = this.x;
        var f = this.o;
        var g = d / c;
        var h = 0;
        for (var i = a; i < b; ++i) {
            var j = e + i * this.m;
            var k = this.o;
            if (i + 1 <= this.q) {
                k = this.x + ((i + 1) * this.m);
            }
            if (k > this.o) {
                k = this.o;
            }
            while (j < k) {
                j += this.n;
                if (j < k) {
                    h++;
                }
            }
        }
        if (this.u == null || this.u.length != h) {
            this.u = new Array(h);
        }
        var l = this.u;
        var m = 0;
        for (var n = a; n < b; ++n) {
            var o = e + n * this.m;
            var p = this.o;
            if (n + 1 <= this.q) {
                p = this.x + ((n + 1) * this.m);
            }
            if (p > this.o) {
                p = this.o;
            }
            while (o < p) {
                o += this.n;
                if (o < p) {
                    l[m] = o;
                    m++;
                }
            }
        }
        return l;
    };
    LinearTickmarkValues.$t = markType(LinearTickmarkValues, 'LinearTickmarkValues', TickmarkValues.$);
    return LinearTickmarkValues;
}(TickmarkValues));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAxisRenderingParameters, _super);
    function CategoryAxisRenderingParameters() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ae = 0;
        _this.ab = 0;
        _this.ad = false;
        _this.af = 0;
        _this.ac = false;
        return _this;
    }
    CategoryAxisRenderingParameters.$t = markType(CategoryAxisRenderingParameters, 'CategoryAxisRenderingParameters', AxisRenderingParametersBase.$);
    return CategoryAxisRenderingParameters;
}(AxisRenderingParametersBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TickmarkValuesInitializationParameters = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TickmarkValuesInitializationParameters, _super);
    function TickmarkValuesInitializationParameters() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.n = 0;
        _this.m = 0;
        _this.g = 0;
        _this.f = 0;
        _this.k = 0;
        _this.d = false;
        _this.l = 0;
        _this.i = 0;
        _this.p = 0;
        _this.a = 0;
        _this.q = 0;
        _this.r = null;
        _this.s = null;
        _this.e = false;
        _this.o = null;
        _this.b = null;
        _this.c = null;
        _this.j = 0;
        _this.h = 0;
        return _this;
    }
    TickmarkValuesInitializationParameters.$t = markType(TickmarkValuesInitializationParameters, 'TickmarkValuesInitializationParameters');
    return TickmarkValuesInitializationParameters;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumberAbbreviatorFactory = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumberAbbreviatorFactory, _super);
    function NumberAbbreviatorFactory() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberAbbreviatorFactory.a = function (a) {
        if (!TypeRegistrar.isRegistered("NumberAbbreviator")) {
            return null;
        }
        var b = TypeRegistrar.create("NumberAbbreviator");
        return b;
    };
    NumberAbbreviatorFactory.$t = markType(NumberAbbreviatorFactory, 'NumberAbbreviatorFactory');
    return NumberAbbreviatorFactory;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available highlighting states
 */
var HighlightingState = /*@__PURE__*/ (function (HighlightingState) {
    /**
     * Highlight is transitioning out.
     */
    HighlightingState[HighlightingState["outward"] = 0] = "outward";
    /**
     * Highlight is transitioning in.
     */
    HighlightingState[HighlightingState["inward"] = 1] = "inward";
    /**
     * Highlight is active and not transitioning in or out.
     */
    HighlightingState[HighlightingState["Static"] = 2] = "Static";
    return HighlightingState;
})({});
/**
 * @hidden
 */
var HighlightingState_$type = /*@__PURE__*/ markEnum('HighlightingState', 'Out:outward,0|In:inward,1|Static,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Marker = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Marker, _super);
    function Marker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.am = null;
        _this.an = null;
        _this.ak = 0;
        _this.al = 0;
        _this.ai = 0;
        _this.aj = 0;
        return _this;
    }
    Marker.$t = markType(Marker, 'Marker', ContentControl.$);
    return Marker;
}(ContentControl));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of speeds used when transitioning in a series.
 */
var TransitionInSpeedType = /*@__PURE__*/ (function (TransitionInSpeedType) {
    /**
     * A speed type is automatically selected.
     */
    TransitionInSpeedType[TransitionInSpeedType["Auto"] = 0] = "Auto";
    /**
     * All speeds are normal, data points will arrive at the same time.
     */
    TransitionInSpeedType[TransitionInSpeedType["Normal"] = 1] = "Normal";
    /**
     * Data points will arrive later if their value is further from the start point.
     */
    TransitionInSpeedType[TransitionInSpeedType["ValueScaled"] = 2] = "ValueScaled";
    /**
     * Data points will arrive later if their index is further from the axis origin.
     */
    TransitionInSpeedType[TransitionInSpeedType["IndexScaled"] = 3] = "IndexScaled";
    /**
     * Data points will arrive at random times.
     */
    TransitionInSpeedType[TransitionInSpeedType["Random"] = 4] = "Random";
    return TransitionInSpeedType;
})({});
/**
 * @hidden
 */
var TransitionInSpeedType_$type = /*@__PURE__*/ markEnum('TransitionInSpeedType', 'Auto,0|Normal,1|ValueScaled,2|IndexScaled,3|Random,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for performing hit testing in the chart/map.
 */
var SeriesHitTestMode = /*@__PURE__*/ (function (SeriesHitTestMode) {
    /**
     * Automatically decide the appropriate hit test mode for the series.
     */
    SeriesHitTestMode[SeriesHitTestMode["Auto"] = 0] = "Auto";
    /**
     * Use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
     */
    SeriesHitTestMode[SeriesHitTestMode["Computational"] = 1] = "Computational";
    /**
     * Use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
     */
    SeriesHitTestMode[SeriesHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
    return SeriesHitTestMode;
})({});
/**
 * @hidden
 */
var SeriesHitTestMode_$type = /*@__PURE__*/ markEnum('SeriesHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesComponentsForView, _super);
    function SeriesComponentsForView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SeriesComponentsForView.$t = markType(SeriesComponentsForView, 'SeriesComponentsForView');
    return SeriesComponentsForView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesComponentsFromView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesComponentsFromView, _super);
    function SeriesComponentsFromView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SeriesComponentsFromView.$t = markType(SeriesComponentsFromView, 'SeriesComponentsFromView');
    return SeriesComponentsFromView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var MarkerType = /*@__PURE__*/ (function (MarkerType) {
    /**
     * Marker hasn't been set.
     */
    MarkerType[MarkerType["Unset"] = 0] = "Unset";
    /**
     * No markerItems.
     */
    MarkerType[MarkerType["None"] = 1] = "None";
    /**
     * Automatic marker shape.
     */
    MarkerType[MarkerType["Automatic"] = 2] = "Automatic";
    /**
     * Circle marker shape.
     */
    MarkerType[MarkerType["Circle"] = 3] = "Circle";
    /**
     * Flat-top triangle marker shape.
     */
    MarkerType[MarkerType["Triangle"] = 4] = "Triangle";
    /**
     * Flat-base triangle marker shape.
     */
    MarkerType[MarkerType["Pyramid"] = 5] = "Pyramid";
    /**
     * Square marker shape.
     */
    MarkerType[MarkerType["Square"] = 6] = "Square";
    /**
     * Diamond marker shape.
     */
    MarkerType[MarkerType["Diamond"] = 7] = "Diamond";
    /**
     * Pentagon marker shape.
     */
    MarkerType[MarkerType["Pentagon"] = 8] = "Pentagon";
    /**
     * Hexagon marker shape.
     */
    MarkerType[MarkerType["Hexagon"] = 9] = "Hexagon";
    /**
     * Four-pointed star marker shape.
     */
    MarkerType[MarkerType["Tetragram"] = 10] = "Tetragram";
    /**
     * Five-pointed star marker shape.
     */
    MarkerType[MarkerType["Pentagram"] = 11] = "Pentagram";
    /**
     * Six-pointed star marker shape.
     */
    MarkerType[MarkerType["Hexagram"] = 12] = "Hexagram";
    /**
     * Renders transparent circular markers.
     */
    MarkerType[MarkerType["Hidden"] = 13] = "Hidden";
    return MarkerType;
})({});
/**
 * @hidden
 */
var MarkerType_$type = /*@__PURE__*/ markEnum('MarkerType', 'Unset,0|None,1|Automatic,2|Circle,3|Triangle,4|Pyramid,5|Square,6|Diamond,7|Pentagon,8|Hexagon,9|Tetragram,10|Pentagram,11|Hexagram,12|Hidden,13');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesViewer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewer, _super);
    function SeriesViewer() {
        var _this = _super.call(this) || this;
        _this._widget = null;
        _this.bn = null;
        _this.by = null;
        _this.a0 = null;
        _this.bh = null;
        _this.a3 = new SeriesCollection();
        _this._skipDataCleanup = false;
        _this.bo = null;
        _this.al = null;
        _this.mh = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.seriesCursorMouseMove = null;
        _this.seriesMouseLeftButtonDown = null;
        _this.seriesMouseLeftButtonUp = null;
        _this.seriesMouseMove = null;
        _this.seriesMouseEnter = null;
        _this.seriesMouseLeave = null;
        _this.mp = Rect.empty;
        _this.mn = Rect.empty;
        _this.b1 = true;
        _this.mm = null;
        _this.cb = false;
        _this.ez = 30;
        _this.a5 = new SeriesViewerComponentsForView();
        _this.an = 0;
        _this.am = 1;
        _this.seriesAnimating = null;
        _this.b3 = false;
        _this.bf = 0;
        _this.b7 = false;
        _this.ch = false;
        _this.b2 = false;
        _this.g0 = null;
        _this.b8 = false;
        _this.windowRectChanged = null;
        _this.sizeChanged = null;
        _this.cn = false;
        _this.actualWindowRectChanged = null;
        _this.gridAreaRectChanged = null;
        _this.cj = false;
        _this._syncChannel = null;
        _this.a7 = null;
        _this.cm = false;
        _this.di = false;
        _this.e1 = 0;
        _this.b9 = false;
        _this.dg = false;
        _this.mo = Rect.empty;
        _this.dn = new Date();
        _this.dk = false;
        _this.refreshCompleted = null;
        _this.fb = null;
        _this.fa = null;
        _this.l3 = null;
        _this.l2 = null;
        _this.d7 = NaN;
        _this.d5 = NaN;
        _this.d6 = NaN;
        _this.d4 = NaN;
        _this.d3 = NaN;
        _this.d1 = NaN;
        _this.d2 = NaN;
        _this.d0 = NaN;
        _this.e8 = null;
        _this.ah = null;
        _this.ai = null;
        _this.ag = null;
        _this.b6 = false;
        _this.b0 = false;
        _this._syncSettings = null;
        _this.destroyed = false;
        _this.e7 = null;
        _this.dl = new Dictionary$2(String_$type, Base.$, 0);
        _this.c6 = false;
        _this.d8 = NaN;
        _this.dx = NaN;
        _this.dz = NaN;
        _this.dv = NaN;
        _this.du = 20;
        _this.dt = NaN;
        _this.b4 = true;
        _this.dy = NaN;
        _this.dw = NaN;
        _this.e9 = null;
        _this.dq = 1;
        _this.dp = NaN;
        _this.ml = null;
        _this.dr = 0;
        _this.ds = 0;
        _this.kx = null;
        _this.ar = null;
        _this.cq = false;
        _this.cr = false;
        _this.co = false;
        _this.b5 = false;
        _this.e0 = 0;
        _this.cf = false;
        _this.ct = false;
        _this.seriesDataUpdated = null;
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        _this.ml = Rect.empty;
        _this.mh = { $type: Point_$type, x: NaN, y: NaN };
        _this.dn = dateNow();
        _this.cq = false;
        _this.cr = false;
        _this.ah = new CanvasRenderScheduler();
        _this.ai = new CanvasRenderScheduler();
        _this.ag = new CanvasRenderScheduler();
        SeriesViewer.m0 = new Rect(0, 0, 0, 1, 1);
        _this.syncSettings = ((function () {
            var $ret = new SyncSettings();
            $ret.synchronizeHorizontally = true;
            $ret.synchronizeVertically = true;
            return $ret;
        })());
        _this.bn = _this.bm();
        _this.i1(_this.bn);
        _this.bn.cx();
        _this.kb();
        _this.hq();
        _this.actualSyncLink = new SyncLink();
        _this.ki(null, _this.actualSyncLink);
        _this.al = new ChartContentManager(_this);
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.jd(a, b.propertyName, b.oldValue, b.newValue); });
        var a = _this.series;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.j2));
        var b = _this.series;
        b.collectionResetting = delegateCombine(b.collectionResetting, runOn(_this, _this.j3));
        _this.bo = new DoubleAnimator(0, 1, _this.e5);
        var c = _this.bo;
        c.propertyChanged = delegateCombine(c.propertyChanged, runOn(_this, _this.hp));
        _this.bn.bu();
        _this.hs();
        _this.hr();
        return _this;
    }
    Object.defineProperty(SeriesViewer.prototype, "widget", {
        get: function () {
            return this._widget;
        },
        set: function (a) {
            this._widget = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.staticInit = function () {
        SeriesViewer.m0 = new Rect(0, 0, 0, 1, 1);
    };
    Object.defineProperty(SeriesViewer.prototype, "bz", {
        get: function () {
            if (this.by == null) {
                this.by = new SRProvider(this.bn.i.ae);
            }
            return this.by;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "a1", {
        get: function () {
            var _this = this;
            if (this.a0 == null) {
                this.a0 = DVContainer.instance.createInstance(ISeriesViewerInteractionManager_$type, function () { return _this.bz.n; });
            }
            return this.a0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "cv", {
        get: function () {
            return DVContainer.instance.checkLoaded("InteractivityFactoryManager");
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.hq = function () {
        if (this.bh != null && this.bi == null) {
            var a = this.bi;
            a.thumbnailSizeChanged = delegateRemove(a.thumbnailSizeChanged, runOn(this, this.i9));
        }
        if (this.bi != null) {
            var b = this.bi;
            b.thumbnailSizeChanged = delegateCombine(b.thumbnailSizeChanged, runOn(this, this.i9));
        }
        if (this.e9 != null) {
            this.bi.backgroundImageUri = this.e9;
        }
        if (this.bi != null) {
            this.bi.initializeScalingRatio(this.ea);
        }
        if (this.bh == null && this.bi != null) {
            this.h2();
        }
        this.bh = this.bi;
    };
    SeriesViewer.prototype.i9 = function (a, b) {
        var e_1, _a;
        this.bi.surfaceIsDirty = true;
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.dl = true;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    SeriesViewer.prototype.hr = function () {
        this.bn.ch();
        if (this.bi != null) {
            this.bi.initializeScalingRatio(this.ea);
        }
    };
    Object.defineProperty(SeriesViewer.prototype, "series", {
        get: function () {
            return this.a3;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.j2 = function (a, b) {
        var e_2, _a, e_3, _b;
        this.cf = this.cl();
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    c.bn = null;
                    c.bs = null;
                    this.jw(c);
                    this.bn.dq(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    if (!this.bn.ao(d)) {
                        this.kc(d);
                        this.bn.bm(d);
                        d.bs = this;
                        d.bn = this.actualSyncLink;
                        d.jr();
                    }
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
        }
        this.h1();
        this.ig();
    };
    Object.defineProperty(SeriesViewer.prototype, "skipDataCleanup", {
        get: function () {
            return this._skipDataCleanup;
        },
        set: function (a) {
            this._skipDataCleanup = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.jw = function (a) {
        if (!this.skipDataCleanup) {
            if (typeCast(Series.$, a) !== null) {
                a.itemsSource = null;
            }
            else if (typeCast(CategoryAxisBase.$, a) !== null) {
                a.itemsSource = null;
            }
        }
        this.jy(a.name, true);
    };
    SeriesViewer.prototype.j3 = function (a, b) {
        var e_4, _a;
        this.cf = this.cl();
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.bn = null;
                c.bs = null;
                this.jw(c);
                this.bn.dq(c);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
    };
    SeriesViewer.prototype.hu = function (a, b, c, d) {
        var e = this.m3;
        var f = e.width;
        var g = e.height;
        var h = f / g;
        var i = a / b;
        if (isNaN_(h)) {
            return {
                p0: a,
                p1: b
            };
        }
        if (isNaN_(i) || c || d || Math.abs(h - i) > 0.0001) {
            if (c && d) {
                if (a > b) {
                    b = a / h;
                }
                else {
                    a = b * h;
                }
            }
            else if (c) {
                b = a / h;
            }
            else {
                a = b * h;
            }
        }
        if (b > 1) {
            var j = 1 / b;
            b = 1;
            a = a * j;
        }
        if (a > 1) {
            var k = 1 / a;
            a = 1;
            b = b * k;
        }
        return {
            p0: a,
            p1: b
        };
    };
    SeriesViewer.prototype.cl = function () {
        return false;
    };
    Object.defineProperty(SeriesViewer.prototype, "cs", {
        get: function () {
            return this.a0 != null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "az", {
        get: function () {
            return this.a1.f$b;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.hp = function (a, b) {
        this.ke(this.bo.o);
    };
    SeriesViewer.prototype.ke = function (a) {
        var b = this.az.tick(a);
        if (a == 1 && b && this.bo.r > 0) {
            this.bo.v();
        }
        var c = this.az.dirtySeries;
        for (var d = 0; d < c.count; d++) {
            var e = c._inner[d];
            e.ix();
        }
        if (!b) {
            this.bo.w();
        }
    };
    SeriesViewer.prototype.ho = function () {
        this.bn.cd();
        this.hn();
        for (var a = 0; a < this.series.count; a++) {
            if (this.series._inner[a].cj) {
            }
        }
    };
    SeriesViewer.prototype.l6 = function (a) {
        return null;
    };
    SeriesViewer.prototype.mc = function (a) {
        return null;
    };
    SeriesViewer.prototype.ma = function (a) {
        return null;
    };
    SeriesViewer.prototype.mb = function (a) {
        return null;
    };
    Object.defineProperty(SeriesViewer.prototype, "mi", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            if (PointUtil.notEquals(this.mh, a)) {
                var b = this.mh;
                this.mh = a;
                this.jh("CrosshairPoint", b, this.mh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "cu", {
        get: function () {
            return this.bg == 1 || this.bg == 2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "legend", {
        get: function () {
            return this.c(SeriesViewer.la);
        },
        set: function (a) {
            this.h(SeriesViewer.la, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "cd", {
        get: function () {
            return this.c(SeriesViewer.kz);
        },
        set: function (a) {
            this.h(SeriesViewer.kz, a);
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.jh = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    SeriesViewer.prototype.ii = function () {
        this.ij(this.series);
    };
    SeriesViewer.prototype.ij = function (a) {
        var e_5, _a;
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = b.aw;
                if (c == null) {
                    continue;
                }
                var d = b.jw;
                if (d == null) {
                    continue;
                }
                if (c.containsChild(d)) {
                    c.removeChild(d);
                }
                if (!c.containsChild(d) && b.lz != 1) {
                    c.addChildInOrder(d, b);
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    SeriesViewer.prototype.it = function (a, b, c) {
        this.jm(a, b, typeCast(MouseEventArgs.$, c));
    };
    SeriesViewer.prototype.ix = function (a, b, c) {
        this.jq(a, b, typeCast(MouseEventArgs.$, c));
    };
    SeriesViewer.prototype.iu = function (a, b, c) {
        this.jn(a, b, typeCast(MouseEventArgs.$, c));
    };
    SeriesViewer.prototype.iv = function (a, b, c) {
        this.jo(a, b, typeCast(MouseButtonEventArgs.$, c));
    };
    SeriesViewer.prototype.iw = function (a, b, c) {
        var d = typeCast(MouseButtonEventArgs.$, c);
        if (d != null) {
            this.jp(a, b, typeCast(MouseButtonEventArgs.$, c));
        }
    };
    SeriesViewer.prototype.iy = function (a, b, c) {
    };
    SeriesViewer.prototype.iz = function (a, b, c) {
    };
    SeriesViewer.prototype.jk = function (a, b) {
        if (this.seriesCursorMouseMove != null && this.ch) {
            this.seriesCursorMouseMove(this, new ChartCursorEventArgs(this, a, b));
        }
    };
    SeriesViewer.prototype.jo = function (a, b, c) {
        if (this.seriesMouseLeftButtonDown != null) {
            this.seriesMouseLeftButtonDown(this, new DataChartMouseButtonEventArgs(this, a, b, c));
        }
    };
    SeriesViewer.prototype.jp = function (a, b, c) {
        if (this.seriesMouseLeftButtonUp != null) {
            this.seriesMouseLeftButtonUp(this, new DataChartMouseButtonEventArgs(this, a, b, c));
        }
    };
    SeriesViewer.prototype.jq = function (a, b, c) {
        if (this.seriesMouseMove != null) {
            this.seriesMouseMove(this, new ChartMouseEventArgs(this, a, b, c));
        }
    };
    SeriesViewer.prototype.jm = function (a, b, c) {
        if (this.seriesMouseEnter != null) {
            this.seriesMouseEnter(this, new ChartMouseEventArgs(this, a, b, c));
        }
    };
    SeriesViewer.prototype.jn = function (a, b, c) {
        if (this.seriesMouseLeave != null) {
            this.seriesMouseLeave(this, new ChartMouseEventArgs(this, a, b, c));
        }
    };
    SeriesViewer.prototype.get_m3 = function () {
        return this.mp;
    };
    Object.defineProperty(SeriesViewer.prototype, "m3", {
        get: function () {
            return this.get_m3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "mu", {
        get: function () {
            return this.mn;
        },
        set: function (a) {
            this.mn = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.my = function (a, b, c) {
        var d = c;
        var e = b;
        var f = (d.left - e.left) / e.width;
        var g = (d.top - e.top) / e.height;
        var h = (d.right - e.left) / e.width;
        var i = (d.bottom - e.top) / e.height;
        f = a.left + f * a.width;
        g = a.top + g * a.height;
        h = a.left + h * a.width;
        i = a.top + i * a.height;
        return new Rect(0, f, g, h - f, i - g);
    };
    SeriesViewer.prototype.get_mt = function () {
        if (this.b1) {
            this.b1 = false;
            var a = this.mw(this.m3, this.mu, this.mq);
            this.mm = a;
        }
        return this.mm;
    };
    Object.defineProperty(SeriesViewer.prototype, "mt", {
        get: function () {
            return this.get_mt();
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.mw = function (a, b, c) {
        var d = b;
        var e = c;
        var f = a;
        if (f.isEmpty) {
            return Rect.empty;
        }
        if (d.isEmpty) {
            return a;
        }
        var g = (d.left - f.left) / f.width;
        var h = (d.right - f.left) / f.width;
        var i = (d.top - f.top) / f.height;
        var j = (d.bottom - f.top) / f.height;
        g = f.left + (g - e.left) / e.width * f.width;
        h = f.left + (h - e.left) / e.width * f.width;
        i = f.top + (i - e.top) / e.height * f.height;
        j = f.top + (j - e.top) / e.height * f.height;
        var k = new Rect(0, g, i, h - g, j - i);
        k.intersect(f);
        return k;
    };
    SeriesViewer.prototype.ms = function (a) {
        this.b1 = true;
        return Rect.empty;
    };
    SeriesViewer.prototype.mx = function () {
        return this.m3;
    };
    SeriesViewer.prototype.ka = function (a) {
        a.i1 = this.m3;
    };
    Object.defineProperty(SeriesViewer.prototype, "e2", {
        get: function () {
            return this.ez;
        },
        set: function (a) {
            this.ez = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.jc = function (a, b) {
        if (!b.isEmpty) {
            this.mp = b;
            this.mn = this.ms(this.mp);
            this.bn.ei(this.mp);
        }
        if (this.cl()) {
            if (this.actualSyncLink != null) {
                this.kl(this.mq, false);
            }
        }
        this.is(a, b);
    };
    SeriesViewer.prototype.a6 = function () {
        return this.a5;
    };
    Object.defineProperty(SeriesViewer.prototype, "ap", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.jh("ContentHitTestMode", enumGetBox(ChartHitTestMode_$type, b), enumGetBox(ChartHitTestMode_$type, this.an));
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.js = function () {
        this.ao = this.aq();
    };
    SeriesViewer.prototype.aq = function () {
        if (!this.cv) {
            return 1;
        }
        return this.a1.f$a(this);
    };
    Object.defineProperty(SeriesViewer.prototype, "ao", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.jh("ActualContentHitTestMode", enumGetBox(ChartHitTestMode_$type, b), enumGetBox(ChartHitTestMode_$type, this.am));
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.jj = function (a) {
        if (this.seriesAnimating != null) {
            this.seriesAnimating(a);
        }
    };
    SeriesViewer.prototype.c2 = function () {
        return this.c3() || this.c4();
    };
    SeriesViewer.prototype.onDetachedFromUI = function () {
        this.bn.cv();
        SyncManager.e(this);
    };
    SeriesViewer.prototype.onAttachedToUI = function () {
        this.bn.cp();
        SyncManager.c(this);
    };
    Object.defineProperty(SeriesViewer.prototype, "bg", {
        get: function () {
            return this.bf;
        },
        set: function (a) {
            if (this.bg != a) {
                this.bf = a;
                if (this.cv) {
                    this.a1.f$ae(this);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.il = function (a) {
        this.hf(this.mk(a));
    };
    SeriesViewer.prototype.im = function (a) {
        this.hf({ $type: Point_$type, x: NaN, y: NaN });
    };
    SeriesViewer.prototype.c9 = function (a, b) {
        return this.a1.f$e(this, a, b);
    };
    SeriesViewer.prototype.ia = function (a) {
        this.a1.f$n(this, a);
    };
    SeriesViewer.prototype.c8 = function (a) {
        return this.a1.f$d(this, a);
    };
    Object.defineProperty(SeriesViewer.prototype, "ce", {
        get: function () {
            return this.b2;
        },
        set: function (a) {
            this.b2 = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.get_cw = function () {
        return this.cf || this.dh();
    };
    Object.defineProperty(SeriesViewer.prototype, "cw", {
        get: function () {
            return this.get_cw();
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.ic = function (a) {
        this.a1.f$p(this, a);
    };
    Object.defineProperty(SeriesViewer.prototype, "ck", {
        get: function () {
            return this.b2;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.ir = function (a) {
        this.a1.f$ac(this, a);
    };
    SeriesViewer.prototype.id = function (a, b) {
        this.a1.f$q(this, a, b);
    };
    SeriesViewer.prototype.ib = function (a) {
        this.a1.f$o(this, a);
    };
    Object.defineProperty(SeriesViewer.prototype, "da", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            this.b7 = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.i7 = function () {
        this.a1.f$aj(this);
    };
    SeriesViewer.prototype.iq = function (a) {
        this.a1.f$ab(this, a);
    };
    SeriesViewer.prototype.i8 = function (a, b, c, d) {
        this.a1.f$ak(this, a, b, c, d);
    };
    SeriesViewer.prototype.ip = function (a) {
        this.a1.f$aa(this, a);
    };
    SeriesViewer.prototype.i4 = function (a, b, c, d) {
        this.a1.f$ag(this, a, b, c, d);
    };
    SeriesViewer.prototype.ik = function (a) {
        this.a1.f$x(this, a);
    };
    SeriesViewer.prototype.io = function (a) {
        this.a1.f$z(this, a);
    };
    SeriesViewer.prototype.ie = function (a) {
        this.a1.f$r(this, a);
    };
    SeriesViewer.prototype.i3 = function (a, b, c, d) {
        this.a1.f$af(this, a, b, c, d);
    };
    SeriesViewer.prototype.ih = function (a) {
        this.bn.eb(a.height);
    };
    SeriesViewer.prototype.hn = function () {
        if (this.b2) {
            this.hf({ $type: Point_$type, x: NaN, y: NaN });
            this.bn.ca();
        }
        this.b2 = false;
    };
    SeriesViewer.prototype.h7 = function (a, b) {
        this.a1.f$m(this, a, b);
    };
    SeriesViewer.prototype.bd = function (a) {
        var b = this.bn.j != null && this.bn.j.ai ? this.be : this.bc;
        if (b != 3) {
            return b;
        }
        return this.bn.k(a);
    };
    SeriesViewer.prototype.i6 = function () {
        this.a1.f$ai(this);
    };
    SeriesViewer.prototype.i5 = function () {
        this.a1.f$ah(this);
    };
    SeriesViewer.prototype.j7 = function () {
        this.a1.f$am(this);
    };
    SeriesViewer.prototype.hj = function () {
        this.a1.f$j(this);
    };
    SeriesViewer.prototype.he = function () {
        this.hd();
    };
    SeriesViewer.prototype.hd = function () {
        if (this.cv) {
            this.a1.f$g(this);
        }
    };
    SeriesViewer.prototype.ja = function () {
    };
    SeriesViewer.prototype.jv = function () {
    };
    SeriesViewer.prototype.jt = function () {
        for (var a = 0; a < this.series.count; a++) {
            this.series._inner[a].jd(false);
        }
        this.hm(false, false);
    };
    SeriesViewer.prototype.h6 = function (a, b) {
        this.a1.f$l(this, a, b);
    };
    Object.defineProperty(SeriesViewer.prototype, "df", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            this.b8 = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.h5 = function (a, b) {
        this.a1.f$k(this, a, b);
    };
    SeriesViewer.prototype.kj = function (a, b) {
        if (b.propertyName == SyncSettings.$$p[0]) {
            SyncManager.b(this, b.oldValue, b.newValue);
        }
    };
    SeriesViewer.prototype.ki = function (a, b) {
        var e_6, _a;
        if (a != null) {
            a.ab.remove(this);
            a.propertyUpdated = delegateRemove(a.propertyUpdated, this.propertyUpdated);
        }
        if (b != null) {
            b.ab.add(this);
            b.propertyUpdated = delegateCombine(b.propertyUpdated, this.propertyUpdated);
        }
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.bn = this.actualSyncLink;
                c.bs = this;
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
    };
    SeriesViewer.prototype.hf = function (a) {
        this.actualSyncLink.ak(this, a);
    };
    SeriesViewer.prototype.kl = function (a, b) {
        this.km(a, b, false);
    };
    SeriesViewer.prototype.km = function (a, b, c) {
        if (!b) {
            this.actualSyncLink.ap(this, a, c);
        }
        else {
            if (!this.c3() && !this.c4()) {
                return;
            }
            var d = !a.isEmpty && !isNaN_(a.x) && !isNaN_(a.y) && !isNaN_(a.width) && !isNaN_(a.height);
            var e = a;
            if (d && !this.c3()) {
                e = new Rect(0, 0, a.y, 1, a.height);
            }
            if (d && !this.c4()) {
                e = new Rect(0, a.x, 0, a.width, 1);
            }
            this.actualSyncLink.ao(this, e);
        }
    };
    SeriesViewer.prototype.jb = function (a, b) {
        if (!b) {
            this.actualSyncLink.al(this, a);
        }
        else {
            if (!this.c3() && !this.c4()) {
                return;
            }
            var c = !a.isEmpty && !isNaN_(a.x) && !isNaN_(a.y) && !isNaN_(a.width) && !isNaN_(a.height);
            var d = a;
            if (c && !this.c3()) {
                d = new Rect(0, 0, a.y, 1, a.height);
            }
            if (c && !this.c4()) {
                d = new Rect(0, a.x, 0, a.width, 1);
            }
            this.actualSyncLink.al(this, d);
        }
    };
    Object.defineProperty(SeriesViewer.prototype, "c0", {
        get: function () {
            return this.actualSyncLink != null;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype._dm = function () {
        var _a, _b, a, e_7_1;
        var e_7, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    if (this.actualSyncLink == null) {
                        return [2 /*return*/, undefined];
                    }
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(this.actualSyncLink.ag)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    a = _b.value;
                    return [4 /*yield*/, a];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_7_1 = _d.sent();
                    e_7 = { error: e_7_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_7)
                            throw e_7.error;
                    }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/];
            }
        });
    };
    SeriesViewer.prototype.dm = function () {
        var _this = this;
        return toEnum(function () { return _this._dm(); });
    };
    SeriesViewer.prototype.mk = function (a) {
        var b = this.m3;
        var c = this.mq.left + this.mq.width * a.x / b.width;
        var d = this.mq.top + this.mq.height * a.y / b.height;
        return { $type: Point_$type, x: c, y: d };
    };
    SeriesViewer.prototype.m2 = function (a) {
        var b = this.m3;
        var c = this.mq.left + this.mq.width * a.left / b.width;
        var d = this.mq.top + this.mq.height * a.top / b.height;
        var e = this.mq.left + this.mq.width * a.right / b.width;
        var f = this.mq.top + this.mq.height * a.bottom / b.height;
        return new Rect(0, c, d, e - c, f - d);
    };
    SeriesViewer.prototype.jr = function (a, b) {
        if (this.windowRectChanged != null && Rect.l_op_Inequality(a, b)) {
            this.windowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    };
    SeriesViewer.prototype.i2 = function (a, b) {
        this.jr(a, b);
    };
    SeriesViewer.prototype.i0 = function (a, b) {
        if (this.sizeChanged != null && Size.l_op_Inequality(a, b)) {
            this.sizeChanged(this, new RectChangedEventArgs(new Rect(1, 0, 0, a), new Rect(1, 0, 0, b)));
        }
    };
    SeriesViewer.prototype.dc = function (a, b) {
        if (a.width != b.width || a.height != b.height || a.x != b.x || a.y != b.y) {
            return true;
        }
        return false;
    };
    SeriesViewer.prototype.jf = function (a, b) {
        if (this.actualWindowRectChanged != null && this.dc(a, b)) {
            this.actualWindowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    };
    SeriesViewer.prototype.j1 = function () {
        this.bn.du();
    };
    SeriesViewer.prototype.jg = function (a, b) {
        if (this.gridAreaRectChanged != null && Rect.l_op_Inequality(a, b)) {
            this.gridAreaRectChanged(this, new RectChangedEventArgs(a, b));
        }
    };
    SeriesViewer.prototype.get_cx = function () {
        return false;
    };
    Object.defineProperty(SeriesViewer.prototype, "cx", {
        get: function () {
            return this.get_cx();
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.is = function (a, b) {
        this.jg(a, b);
        if (this.cv) {
            this.a1.f$al(this);
        }
        if (this.cx && (Rect.l_op_Equality(a, null) || a.isEmpty || a.width == 0 || a.height == 0)) {
            this.kl(this.m4, false);
        }
        else {
            this.hs();
        }
    };
    Object.defineProperty(SeriesViewer.prototype, "syncChannel", {
        get: function () {
            return this._syncChannel;
        },
        set: function (a) {
            this._syncChannel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "actualSyncLink", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            this.jh("ActualSyncLink", b, this.a7);
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.ht = function () {
        this.bn.dv();
    };
    Object.defineProperty(SeriesViewer.prototype, "bi", {
        get: function () {
            return this.bn.h().a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.kf = function (a) {
        if (this.bi != null) {
            this.bi.mobileMode = a;
        }
    };
    SeriesViewer.prototype.cg = function () {
        return this.bg == 0 && !this.b7 && !this.b8;
    };
    SeriesViewer.prototype.cc = function () {
        if (this.actualSyncLink != null && this.actualSyncLink.ag.count > 0) {
            var a = true;
            a = this.cg();
            if (!a) {
                return false;
            }
            for (var b = 0; b < this.actualSyncLink.ag.count; b++) {
                if (!this.actualSyncLink.ag.item(b).cg()) {
                    return false;
                }
            }
            return true;
        }
        else {
            return this.cg();
        }
    };
    SeriesViewer.prototype.notifyCrosshairUpdate = function () {
    };
    SeriesViewer.prototype.kk = function (a, b) {
        var c = this.ex;
        this.m4 = new Rect(0, this.eb, this.ec, MathUtil.b(a, c, 1), MathUtil.b(b, c, 1));
    };
    SeriesViewer.prototype.eg = function () {
        return 1;
    };
    SeriesViewer.prototype.eh = function () {
        return 1;
    };
    SeriesViewer.prototype.jd = function (a, b, c, d) {
        switch (b) {
            case SeriesViewer.$$p[25]:
                this.bn.db();
                break;
            case SeriesViewer.$$p[22]:
                this.bn.db();
                break;
            case "ActualContentHitTestMode":
                this.h3();
                break;
            case "ContentHitTestMode":
                this.js();
                break;
            case SeriesViewer.$$p[24]:
                this.bn.c9(c, d);
                this.bn.db();
                break;
            case SeriesViewer.$$p[21]:
                this.bn.c5(c, d);
                this.bn.db();
                break;
            case "TitleTextStyle":
            case "TitleTextColor":
            case "SubtitleTextStyle":
            case "SubtitleTextColor":
            case "TitleTopMargin":
            case "TitleLeftMargin":
            case "TitleRightMargin":
            case "TitleBottomMargin":
            case "SubtitleTopMargin":
            case "SubtitleLeftMargin":
            case "SubtitleRightMargin":
            case "SubtitleBottomMargin":
                this.bn.db();
                break;
            case "PixelScalingRatio":
                if (isNaN_(DeviceUtils.a(this.ek))) {
                    this.hr();
                }
                else {
                    this.ea = DeviceUtils.a(this.ek);
                }
                break;
            case "InteractionPixelScalingRatio":
                this.d9 = this.ei;
                break;
            case "ActualPixelScalingRatio":
                this.bn.dh();
                break;
            case SeriesViewer.$$p[9]:
                this.bn.ci();
                break;
            case "ActualSyncLink":
                this.ki(typeCast(SyncLink.$, c), typeCast(SyncLink.$, d));
                break;
            case SeriesViewer.$$p[2]:
                if (!this.cm) {
                    this.di = true;
                }
                if (this.m7 == 0) {
                    this.ch = true;
                }
                else {
                    this.ch = this.ca;
                }
                if (this.cv) {
                    this.a1.f$al(this);
                }
                break;
            case "CrosshairPoint":
                if (this.cv) {
                    this.a1.f$al(this);
                }
                this.notifyCrosshairUpdate();
                break;
            case SeriesViewer.$$p[31]:
                if (this.actualSyncLink != null) {
                    this.e1++;
                    this.kl(d, false);
                    this.e1--;
                }
                if (!this.m4.equals1(c) && this.e1 == 0) {
                    this.i2(c, this.m4);
                }
                this.hs();
                break;
            case SeriesViewer.$$p[28]:
                this.eb = this.ev;
                break;
            case SeriesViewer.$$p[29]:
                this.ec = this.ew;
                break;
            case "ActualWindowPositionVertical":
            case "ActualWindowPositionHorizontal":
                if (!this.dg) {
                    this.kk(this.eg(), this.eh());
                }
                break;
            case SeriesViewer.$$p[10]:
                this.bn.cy();
                break;
            case SeriesViewer.$$p[8]:
                this.bo.r = this.e5;
                break;
            case SeriesViewer.$$p[11]:
                this.kh();
                break;
            case "ActualWindowRect":
                this.b1 = true;
                if (!Base.equalsStatic(d, c)) {
                    this.g9();
                }
                if (d.width == 1 && d.height == 1 && c.isEmpty) {
                    this.dk = true;
                }
                this.jf(c, d);
                break;
            case SeriesViewer.$$p[15]:
                this.bn.c3(d);
                break;
            case SeriesViewer.$$p[27]:
                this.cb = this.dj;
                break;
            case SeriesViewer.$$p[33]:
                this.e2 = this.e6;
                this.hd();
                break;
            case SeriesViewer.$$p[17]:
                this.a1.f$ad(this);
                break;
        }
    };
    SeriesViewer.prototype.kh = function () {
        this.b9 = this.m8 == 0;
        this.bn.dg();
        this.kg();
        this.bn.ee();
        this.ht();
    };
    SeriesViewer.prototype.h3 = function () {
        this.bn.co();
    };
    SeriesViewer.prototype.kg = function () {
        if (this.bi == null) {
            return;
        }
        this.bi.isZoomable = this.c2();
    };
    Object.defineProperty(SeriesViewer.prototype, "mz", {
        get: function () {
            return this.mo;
        },
        set: function (a) {
            var b = this.mo;
            this.mo = a;
            if (this.mo.isEmpty) {
                this.bn.cc();
            }
            else {
                this.bn.ef(this.m3, this.m1(this.mz));
                this.bn.d4();
                this.jh("PreviewRect", b, this.mo);
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.j9 = function () {
        this.eb = this.mq.x;
        this.ec = this.mq.y;
    };
    SeriesViewer.prototype.g9 = function () {
        this.dk = false;
        this.dn = dateNow();
        if (this.cs) {
            this.az.clear();
        }
        if (this.bo.f()) {
            this.bo.w();
        }
        var a = this.dg;
        this.dg = true;
        this.j9();
        this.dg = a;
        this.bn.cd();
        this.bn.eh(this.mq);
    };
    SeriesViewer.prototype.m1 = function (a) {
        if (this.m3.isEmpty) {
            return Rect.empty;
        }
        var b = this.m3;
        var c = b.left + (b.width * (a.left - this.mq.left) / this.mq.width);
        var d = b.top + (b.height * (a.top - this.mq.top) / this.mq.height);
        var e = b.left + (b.width * (a.right - this.mq.left) / this.mq.width);
        var f = b.top + (b.height * (a.bottom - this.mq.top) / this.mq.height);
        return new Rect(0, c, d, e - c, f - d);
    };
    SeriesViewer.prototype.ji = function () {
        if (this.refreshCompleted != null && !this.destroyed) {
            this.refreshCompleted(this, new EventArgs());
        }
    };
    SeriesViewer.prototype.i1 = function (a) {
        this.kg();
    };
    Object.defineProperty(SeriesViewer.prototype, "gx", {
        get: function () {
            return this.fb;
        },
        set: function (a) {
            var b = this.fb;
            this.fb = a;
            this.jh("TitleTextStyle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "gl", {
        get: function () {
            return this.fa;
        },
        set: function (a) {
            var b = this.fa;
            this.fa = a;
            this.jh("SubtitleTextStyle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "mg", {
        get: function () {
            return this.l3;
        },
        set: function (a) {
            var b = this.l3;
            this.l3 = a;
            this.jh("TitleTextColor", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "mf", {
        get: function () {
            return this.l2;
        },
        set: function (a) {
            var b = this.l2;
            this.l2 = a;
            this.jh("SubtitleTextColor", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "et", {
        get: function () {
            return this.d7;
        },
        set: function (a) {
            var b = this.d7;
            this.d7 = a;
            this.jh("TitleTopMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "er", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.d5;
            this.d5 = a;
            this.jh("TitleLeftMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "es", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            this.jh("TitleRightMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "eq", {
        get: function () {
            return this.d4;
        },
        set: function (a) {
            var b = this.d4;
            this.d4 = a;
            this.jh("TitleBottomMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ep", {
        get: function () {
            return this.d3;
        },
        set: function (a) {
            var b = this.d3;
            this.d3 = a;
            this.jh("SubtitleTopMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "en", {
        get: function () {
            return this.d1;
        },
        set: function (a) {
            var b = this.d1;
            this.d1 = a;
            this.jh("SubtitleLeftMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "eo", {
        get: function () {
            return this.d2;
        },
        set: function (a) {
            var b = this.d2;
            this.d2 = a;
            this.jh("SubtitleRightMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "em", {
        get: function () {
            return this.d0;
        },
        set: function (a) {
            var b = this.d0;
            this.d0 = a;
            this.jh("SubtitleBottomMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.m5 = function () {
        return this.bn.e8();
    };
    SeriesViewer.prototype.m6 = function () {
        return this.bn.e9();
    };
    SeriesViewer.prototype.aj = function (a) {
        return this.bn.c(a);
    };
    SeriesViewer.prototype.ak = function (a) {
        return this.bn.d(a);
    };
    SeriesViewer.prototype.getFontHeight = function () {
        return this.bn.a7;
    };
    SeriesViewer.prototype.provideContainer = function (a) {
        this.bn.ct(a);
    };
    SeriesViewer.prototype.h8 = function (a, b) {
        this.bn.cu(a, b);
    };
    SeriesViewer.prototype.notifyContainerResized = function () {
        this.bn.cn();
    };
    SeriesViewer.prototype.mv = function () {
        return this.bn.e2();
    };
    SeriesViewer.prototype.hk = function () {
        this.bn.b1();
    };
    SeriesViewer.prototype.mj = function () {
        return this.bn.ez();
    };
    SeriesViewer.prototype.bq = function () {
        return this.bn.r();
    };
    SeriesViewer.prototype.bp = function () {
        return this.bn.o();
    };
    SeriesViewer.prototype.l7 = function () {
        return this.bn.er();
    };
    SeriesViewer.prototype.l8 = function () {
        return this.bn.eu();
    };
    SeriesViewer.prototype.hb = function (a) {
        this.bn.bm(a);
    };
    SeriesViewer.prototype.jx = function (a) {
        this.bn.dq(a);
    };
    Object.defineProperty(SeriesViewer.prototype, "c7", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.bn.ck(this.b6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ca", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.bn.bh(this.b0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "syncSettings", {
        get: function () {
            return this._syncSettings;
        },
        set: function (a) {
            this._syncSettings = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.ha = function (a) {
        this.bn.bk(a);
    };
    SeriesViewer.prototype.jz = function (a) {
        this.bn.dr(a);
    };
    SeriesViewer.prototype.h0 = function (source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        var d = this.actualSyncLink.ae(source_);
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    SeriesViewer.prototype.hv = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        var a = this.actualSyncLink.ae(source_);
        if (a == null) {
            return;
        }
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    };
    SeriesViewer.prototype.hy = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        var c = this.actualSyncLink.ae(source_);
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    SeriesViewer.prototype.hz = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        var c = this.actualSyncLink.ae(source_);
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    SeriesViewer.prototype.destroy = function () {
        this.destroyed = true;
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.series.count; b++) {
            a.add(this.series._inner[b]);
        }
        for (var c = 0; c < a.count; c++) {
            if (a._inner[c].bi != null) {
                a._inner[c].bi.ag();
            }
            this.series.remove(a._inner[c]);
            this.jy(a._inner[c].name, true);
            a._inner[c].itemsSource = null;
            a._inner[c].i0(null, null);
        }
        this.hi();
        this.j0();
        this.onDetachedFromUI();
        this.bn.ct(null);
    };
    SeriesViewer.prototype.hi = function () {
    };
    SeriesViewer.prototype.j6 = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        this.e7 = source_;
        this.kd();
    };
    SeriesViewer.prototype.j0 = function () {
        this.e7 = null;
        this.kd();
    };
    SeriesViewer.prototype.j5 = function (a, source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (stringIsNullOrEmpty(a) == false) {
            if (!this.dl.containsKey(a)) {
                this.dl.addItem(a, source_);
            }
            else {
                this.dl.item(a, source_);
            }
        }
        this.kd();
    };
    SeriesViewer.prototype.jy = function (a, b) {
        if (stringIsNullOrEmpty(a) == false) {
            if (this.dl.containsKey(a)) {
                this.dl.removeItem(a);
            }
        }
        if (!b) {
            this.kd();
        }
    };
    SeriesViewer.prototype.j4 = function (a, b) {
        if (a.itemsSource != b) {
            a.itemsSource = b;
        }
    };
    SeriesViewer.prototype.kc = function (a) {
        if (!this.c6) {
            return;
        }
        if (typeCast(Series.$, a) !== null) {
            var b = a;
            if (this.dl.containsKey(b.name)) {
                var c = this.dl.item(b.name);
                this.j4(b, c);
            }
            else {
                this.j4(b, this.e7);
            }
        }
        if (typeCast(CategoryAxisBase.$, a) !== null) {
            var d = a;
            if (this.dl.containsKey(d.name)) {
                var e = this.dl.item(d.name);
                if (d.itemsSource != e) {
                    d.itemsSource = e;
                }
            }
            else {
                if (d.itemsSource != this.e7) {
                    d.itemsSource = this.e7;
                }
            }
        }
    };
    SeriesViewer.prototype.kd = function () {
        var e_8, _a;
        if (!this.c6) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                this.kc(a);
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
    };
    Object.defineProperty(SeriesViewer.prototype, "eu", {
        get: function () {
            return this.d8;
        },
        set: function (a) {
            this.d8 = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ej", {
        get: function () {
            return this.dx;
        },
        set: function (a) {
            this.dx = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "el", {
        get: function () {
            return this.dz;
        },
        set: function (a) {
            this.dz = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ef", {
        get: function () {
            return this.dv;
        },
        set: function (a) {
            this.dv = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ee", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            this.du = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ed", {
        get: function () {
            return this.dt;
        },
        set: function (a) {
            this.dt = a;
            this.ht();
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.dd = function () {
        return false;
    };
    Object.defineProperty(SeriesViewer.prototype, "cp", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            this.jh("IsAntiAliasingEnabledDuringInteraction", b, this.b4);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ek", {
        get: function () {
            return this.dy;
        },
        set: function (a) {
            var b = this.dy;
            this.dy = a;
            this.jh("PixelScalingRatio", b, this.dy);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ei", {
        get: function () {
            return this.dw;
        },
        set: function (a) {
            var b = this.dw;
            this.dw = a;
            this.jh("InteractionPixelScalingRatio", b, this.dw);
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.bb = function (a, b) {
        var c = new CoercionInfo();
        c.b = a;
        c.a = null;
        var d = FastItemsSource.f(a);
        if (d.d == null) {
            return c;
        }
        if (b != null) {
            var methods_ = b;
            var key_ = d.d;
            var val_ = null;
            if (typeof methods_[key_] != 'undefined') {
                val_ = methods_[key_];
            }
            ;
            c.b = d.c;
            c.a = val_;
        }
        else if (d.d == "defaultDateParse") {
            var e = defaultDVDateParse;
            c.b = d.c;
            c.a = e;
        }
        return c;
    };
    Object.defineProperty(SeriesViewer.prototype, "f1", {
        get: function () {
            return this.e9;
        },
        set: function (a) {
            this.e9 = a;
            if (this.bi == null) {
                return;
            }
            this.bi.backgroundImageUri = this.e9;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ea", {
        get: function () {
            return this.dq;
        },
        set: function (a) {
            var b = this.dq;
            this.dq = a;
            this.jh("ActualPixelScalingRatio", b, this.dq);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "d9", {
        get: function () {
            return this.dp;
        },
        set: function (a) {
            var b = this.dp;
            this.dp = a;
            this.jh("ActualInteractionPixelScalingRatio", b, this.dp);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "mq", {
        get: function () {
            return this.ml;
        },
        set: function (a) {
            var b = Rect.l_op_Inequality(this.ml, a);
            if (b) {
                var c = this.ml;
                this.ml = a;
                this.jh("ActualWindowRect", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.hs = function () {
        this.mq = this.mr();
    };
    SeriesViewer.prototype.mr = function () {
        return new Rect(0, Math.min(1, Math.max(0, this.m4.left)), Math.min(1, Math.max(0, this.m4.top)), Math.min(1, Math.max(0, this.m4.width)), Math.min(1, Math.max(0, this.m4.height)));
    };
    Object.defineProperty(SeriesViewer.prototype, "eb", {
        get: function () {
            return this.dr;
        },
        set: function (a) {
            var b = this.dr;
            this.dr = a;
            this.jh("ActualWindowPositionHorizontal", b, this.dr);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewer.prototype, "ec", {
        get: function () {
            return this.ds;
        },
        set: function (a) {
            var b = this.ds;
            this.ds = a;
            this.jh("ActualWindowPositionVertical", b, this.ds);
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.h2 = function () {
        if (this.b9 && this.bi != null) {
            this.bi.surfaceIsDirty = true;
            this.bi.doRefresh(false);
        }
        this.he();
    };
    SeriesViewer.prototype.h1 = function () {
        if (this.b9 && this.bi != null) {
            this.bi.surfaceIsDirty = true;
            this.bi.doRefresh(false);
        }
        this.he();
    };
    SeriesViewer.prototype.flush = function () {
        this.hm(true, true);
    };
    SeriesViewer.prototype.hm = function (a, b) {
        this.al.x();
        if (a) {
            this.bn.b2();
            this.al.x();
        }
        this.ah.i();
        if (b) {
            this.bn.a.i();
        }
        this.dk = true;
    };
    SeriesViewer.prototype.dh = function () {
        return false;
    };
    SeriesViewer.prototype.ju = function (a, b) {
        if (this.kx != null) {
            this.j8(this.kx);
            this.kx = null;
            this.ar = null;
        }
        this.kx = a;
        this.ar = this.al.k(2, a, b);
    };
    SeriesViewer.prototype.j8 = function (a) {
        this.al.ac(2, a);
        this.kx = null;
        this.ar = null;
    };
    SeriesViewer.prototype.hg = function () {
        this.al.ab(2, this.kx, this.ar, false);
    };
    SeriesViewer.prototype.ig = function () {
        var a = false;
        var b = false;
        var c = false;
        for (var d = 0; d < this.series.count; d++) {
            var e = this.series._inner[d];
            if (e.cm) {
                a = true;
            }
            if (e.cn) {
                b = true;
            }
            if (e.cj) {
                c = true;
            }
        }
        this.cq = a;
        this.cr = b;
        this.co = c;
    };
    Object.defineProperty(SeriesViewer.prototype, "c1", {
        get: function () {
            return this.b9;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewer.prototype.hc = function () {
        this.bn.bn();
        for (var a = 0; a < this.series.count; a++) {
            this.series._inner[a].io();
        }
    };
    SeriesViewer.prototype.c5 = function () {
        return this.bn.ak();
    };
    SeriesViewer.prototype.e4 = function () {
        var a = this.e0;
        this.e0++;
        return a;
    };
    SeriesViewer.prototype.bt = function () {
        if (this.gx == null) {
            return null;
        }
        return FontUtil.toFontInfo(this.bn.i.ae, this.gx);
    };
    SeriesViewer.prototype.bs = function () {
        if (this.gl == null) {
            return null;
        }
        return FontUtil.toFontInfo(this.bn.i.ae, this.gl);
    };
    SeriesViewer.prototype.kb = function () {
        var a = false;
        a = this.ca;
        this.cm = true;
        this.ch = (a && !this.di) || this.m7 == 0;
        this.cm = false;
    };
    SeriesViewer.prototype.jl = function () {
        if (this.seriesDataUpdated != null) {
            this.seriesDataUpdated(this, EventArgs.empty);
        }
    };
    SeriesViewer.$t = markType(SeriesViewer, 'SeriesViewer', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type, IInternalLegendOwner_$type]);
    SeriesViewer.la = DependencyProperty.i("Legend", IChartLegend_$type, SeriesViewer.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(SeriesViewer.$, a);
        c.jh("Legend", b.oldValue, b.newValue);
    }));
    SeriesViewer.kz = DependencyProperty.i("AnimateSeriesWhenAxisRangeChanges", Boolean_$type, SeriesViewer.$, new PropertyMetadata(2, false, function (a, b) {
        var c = typeCast(SeriesViewer.$, a);
        c.jh("AnimateSeriesWhenAxisRangeChanges", b.oldValue, b.newValue);
    }));
    SeriesViewer.m0 = Rect.empty;
    SeriesViewer.$$p = markDep(DependencyProperty, PropertyMetadata, SeriesViewer, 'jh', ['ActualPlotAreaBorderBrush:l4:ky', [Brush.$, null], 'CircleMarkerTemplate:kn:k0', [DataTemplate.$, null], 'CrosshairVisibility:m7:k1', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'DefaultInteraction:bc:k2', [InteractionState_$type, enumGetBox(InteractionState_$type, 3)], 'DiamondMarkerTemplate:ko:k3', [DataTemplate.$, null], 'DragModifier:l0:k4', [ModifierKeys_$type, enumGetBox(ModifierKeys_$type, 2)], 'HexagonMarkerTemplate:kp:k5', [DataTemplate.$, null], 'HexagramMarkerTemplate:kq:k6', [DataTemplate.$, null], 'HighlightingTransitionDuration:e5:k7', [1, 300], 'IsPagePanningAllowed:cy:k8', [0, true], 'IsSurfaceInteractionDisabled:cz:k9', [0, false], 'OverviewPlusDetailPaneVisibility:m8:lb', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'PanModifier:l1:lc', [ModifierKeys_$type, enumGetBox(ModifierKeys_$type, 4)], 'PentagonMarkerTemplate:kr:ld', [DataTemplate.$, null], 'PentagramMarkerTemplate:ks:le', [DataTemplate.$, null], 'PlotAreaBackground:md:lf', [Brush.$, null], 'PlotAreaBorderBrush:me:lg', [Brush.$, null], 'PreferHigherResolutionTiles:db:lh', [0, false], 'PyramidMarkerTemplate:kt:li', [DataTemplate.$, null], 'RightButtonDefaultInteraction:be:lj', [InteractionState_$type, enumGetBox(InteractionState_$type, 3)], 'SquareMarkerTemplate:ku:lk', [DataTemplate.$, null], 'SubtitleHorizontalAlignment:ly:ll', [HorizontalAlignment_$type, enumGetBox(HorizontalAlignment_$type, 1)], 'Subtitle:ge:lm', [2, null], 'TetragramMarkerTemplate:kv:ln', [DataTemplate.$, null], 'TitleHorizontalAlignment:lz:lo', [HorizontalAlignment_$type, enumGetBox(HorizontalAlignment_$type, 1)], 'Title:gq:lp', [2, null], 'TriangleMarkerTemplate:kw:lq', [DataTemplate.$, null], 'UseTiledZooming:dj:lr', [0, false], 'WindowPositionHorizontal:ev:ls', [1, NaN], 'WindowPositionVertical:ew:lt', [1, NaN], 'WindowRectMinWidth:ex:lu', [1, 0.0001], 'WindowRect:m4:lv', [Rect.$, new Rect(0, 0, 0, 1, 1)], 'WindowResponse:ba:lw', [WindowResponse_$type, enumGetBox(WindowResponse_$type, 1)], 'ZoomTileCacheSize:e6:lx', [1, 30]]);
    return SeriesViewer;
}(Control));
/**
 * @hidden
 */
var SeriesViewerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerView, _super);
    function SeriesViewerView(a) {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.a = null;
        _this.l = null;
        _this.m = null;
        _this.f = null;
        _this.b = null;
        _this.ag = false;
        _this.e7 = null;
        _this.e6 = null;
        _this.e5 = null;
        _this.e4 = null;
        _this.g = new SeriesViewerComponentsFromView();
        _this.i = null;
        _this.u = null;
        _this.x = null;
        _this.w = null;
        _this.v = null;
        _this.al = false;
        _this.am = false;
        _this.bg = null;
        _this.j = null;
        _this.a7 = 0;
        _this.a6 = 0;
        _this.a5 = 0;
        _this.e0 = Rect.empty;
        _this.ah = false;
        _this.az = 0;
        _this.ax = 0;
        _this.ay = 0;
        _this.aw = 0;
        _this.ai = true;
        _this.y = false;
        _this.a0 = NaN;
        _this.e1 = Rect.empty;
        _this.z = false;
        _this.ad = false;
        _this.ac = false;
        _this.at = false;
        _this.ek = null;
        _this.ej = null;
        _this.ab = false;
        _this.aa = false;
        _this.ae = true;
        _this.av = null;
        _this.ap = false;
        _this.be = 0;
        _this.af = true;
        _this.a6 = 0;
        _this.a5 = 0;
        _this.n = a;
        _this.n.mi = { $type: Point_$type, x: NaN, y: NaN };
        _this.n.ba = 1;
        _this.i = new SeriesViewerViewManager(_this);
        _this.e4 = ((function () {
            var $ret = new Line();
            $ret.visibility = 1;
            return $ret;
        })());
        _this.e5 = ((function () {
            var $ret = new Line();
            $ret.visibility = 1;
            return $ret;
        })());
        return _this;
    }
    SeriesViewerView.prototype.ch = function () {
        this.i.a8();
    };
    SeriesViewerView.prototype.cx = function () {
        this.n.cm = true;
        this.n.m7 = 1;
        this.n.cm = false;
        this.e6 = new Path();
        this.e7 = new Rectangle();
        this.e7._visibility = 1;
        this.dy();
        this.f = new SeriesCollection();
        this.b = new AxisCollection();
        this.a = new CanvasRenderScheduler();
        this.a.l(this);
        this.a.e.add(this.n.ai);
        if (this.n.m8 == 0) {
            this.cg();
        }
        var a = this.n;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, runOn(this, this.cm));
        var b = this.n;
        b.gridAreaRectChanged = delegateCombine(b.gridAreaRectChanged, runOn(this, this.cl));
        this.m = new OverviewPlusDetailViewportHost(this);
        this.dg();
    };
    SeriesViewerView.prototype.cg = function () {
        if (this.l == null) {
            this.l = this.i.g();
        }
        this.n.bi.provideContext(this.x);
        this.n.bi.provideContainer(this.bg);
        this.n.bi.provideEventSource(this.j);
        this.l.world = new Rect(0, 0, 0, 1, 1);
        this.l.window = this.n.m4;
        this.l.surfaceViewer = TypeRegistrar.create("SeriesViewerSurfaceViewer", this.n, this);
        this.l.viewScheduler = this.a;
        this.ee();
        var a = this.l;
        a.windowChanging = delegateCombine(a.windowChanging, runOn(this, this.df));
        var b = this.l;
        b.windowChanged = delegateCombine(b.windowChanged, runOn(this, this.de));
    };
    SeriesViewerView.prototype.df = function (a, b) {
        var c = b.newValue;
        if (this.l != null) {
            c = this.l.changeRect(b.oldValue, b.newValue, this.n.c3(), this.n.c4(), this.l.world);
        }
        if (c.isEmpty) {
            this.l.window = b.oldValue;
        }
        else if (!c.equals1(b.newValue)) {
            this.l.window = c;
        }
        if (this.n.ba == 1) {
            var d = this.n.m3.width / this.n.m3.height;
            c = new Rect(0, c.left / d, c.top, c.width / d, c.height);
            this.n.m4 = c;
        }
    };
    SeriesViewerView.prototype.de = function (a, b) {
        var c = b.newValue;
        if (this.l != null) {
            c = this.l.changeRect(b.oldValue, b.newValue, this.n.c3(), this.n.c4(), this.l.world);
        }
        if (c.isEmpty) {
            c = b.oldValue;
        }
        else if (!c.equals1(b.newValue)) {
            this.l.window = c;
        }
        var d = this.n.m3.width / this.n.m3.height;
        c = new Rect(0, c.left / d, c.top, c.width / d, c.height);
        this.n.m4 = c;
    };
    SeriesViewerView.prototype.ee = function () {
        if (this.l == null) {
            return;
        }
        if (this.n.m8 != 0) {
            return;
        }
        var a = 1;
        if (this.n.m3.isEmpty == false) {
            a = this.n.m3.width / this.n.m3.height;
        }
        var b = this.l.world;
        var c = new Rect(0, 0, 0, a, 1);
        this.l.world = c;
        if (b.width != c.width || b.height != c.height || b.x != c.x || b.y != c.y) {
            this.l.surfaceViewer.isDirty = true;
        }
        this.l.window = new Rect(0, this.n.m4.left * a, this.n.m4.top, this.n.m4.width * a, this.n.m4.height);
    };
    SeriesViewerView.prototype.cm = function (a, b) {
        this.ee();
    };
    SeriesViewerView.prototype.cl = function (a, b) {
        this.ee();
    };
    SeriesViewerView.prototype.b4 = function (a, b, c) {
        var e_9, _a;
        var d = true;
        try {
            for (var _b = __values(fromEnum(this.n.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (d && e.dl) {
                    d = false;
                    c.a.k(0, 0, a, b);
                }
                e.jf(new Rect(0, 0, 0, a, b), c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
    };
    SeriesViewerView.prototype.dx = function () {
        this.i.bk();
    };
    SeriesViewerView.prototype.b6 = function () {
    };
    SeriesViewerView.prototype.dz = function () {
        this.i.bl();
    };
    SeriesViewerView.prototype.cd = function () {
        for (var a = 0; a < this.n.series.count; a++) {
            this.n.series._inner[a].bi.am();
        }
    };
    SeriesViewerView.prototype.b5 = function () {
    };
    SeriesViewerView.prototype.b7 = function () {
    };
    SeriesViewerView.prototype.dq = function (a) {
        var _this = this;
        var b = this.f.indexOf(a);
        if (b >= 0) {
            this.f.removeAt(b);
        }
        if (a.isStacked) {
            a.h7(function (c) {
                c.bs = null;
                b = _this.f.indexOf(c);
                if (b >= 0) {
                    _this.f.removeAt(b);
                }
                return true;
            });
        }
        this.n.js();
        a.i0(null, null);
        this.c4();
    };
    SeriesViewerView.prototype.c4 = function () {
        if (this.n.destroyed) {
            return;
        }
        if (this.f.count == 0) {
            if (this.w != null && Rect.l_op_Inequality(this.n.m3, null) && !this.n.m3.isEmpty) {
                if (this.n.ea != 1) {
                    this.w.z();
                    this.w.aa(this.n.ea, this.n.ea);
                }
                this.w.k(this.n.m3.left, this.n.m3.top, this.n.m3.width, this.n.m3.height);
                if (this.n.ea != 1) {
                    this.w.y();
                }
            }
        }
        this.n.ah.n();
    };
    SeriesViewerView.prototype.ao = function (a) {
        a.iv(a.bi.br, this.e0);
        return this.f.contains(a);
    };
    Object.defineProperty(SeriesViewerView.prototype, "as", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            this.ag = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.bm = function (a) {
        var _this = this;
        if (!this.f.contains(a)) {
            this.f.add(a);
            if (a.isStacked) {
                a.h7(function (b) {
                    _this.f.add(b);
                    return true;
                });
            }
            this.n.js();
        }
        a.i0(this.w, this.v);
        this.n.ht();
    };
    SeriesViewerView.prototype.dk = function (a) {
        this.v = a;
        for (var b = 0; b < this.f.count; b++) {
            this.f._inner[b].i0(this.w, this.v);
        }
        for (var c = 0; c < this.b.count; c++) {
            this.b._inner[c].gv(this.w, this.v);
        }
    };
    SeriesViewerView.prototype.bu = function () {
    };
    SeriesViewerView.prototype.bq = function () {
        this.b8();
        this.cd();
    };
    SeriesViewerView.prototype.b8 = function () {
        this.e7._visibility = 1;
        this.cj();
    };
    SeriesViewerView.prototype.b3 = function () {
    };
    SeriesViewerView.prototype.di = function () {
    };
    SeriesViewerView.prototype.d0 = function () {
        this.e7._visibility = 0;
        this.cj();
    };
    SeriesViewerView.prototype.d8 = function (a) {
        this.e7.o = a.top + this.n.m3.top;
        this.e7.n = a.left + this.n.m3.left;
        this.e7.width = a.width;
        this.e7.height = a.height;
        this.e7._stroke = this.i.b1();
        this.e7._fill = null;
        this.e7.ac = 0.5;
        this.cj();
    };
    SeriesViewerView.prototype.bt = function () {
    };
    SeriesViewerView.prototype.c7 = function () {
    };
    SeriesViewerView.prototype.eg = function (a, b, c, d) {
        this.e5.ak = a;
        this.e5.am = b;
        this.e5.al = c;
        this.e5.an = d;
        this.cj();
    };
    SeriesViewerView.prototype.d5 = function () {
        this.e5._visibility = 0;
        this.cj();
    };
    SeriesViewerView.prototype.ce = function () {
        if (this.e5._visibility == 0) {
            this.e5._visibility = 1;
            this.cj();
        }
    };
    SeriesViewerView.prototype.d9 = function (a, b, c, d) {
        this.e4.ak = a;
        this.e4.am = b;
        this.e4.al = c;
        this.e4.an = d;
        this.cj();
    };
    SeriesViewerView.prototype.d1 = function () {
        this.e4._visibility = 0;
        this.cj();
    };
    SeriesViewerView.prototype.b9 = function () {
        if (this.e4._visibility == 0) {
            this.e4._visibility = 1;
            this.cj();
        }
    };
    SeriesViewerView.prototype.cc = function () {
        this.e6._visibility = 1;
        this.cj();
    };
    SeriesViewerView.prototype.ex = function (a) {
        var b = new PathFigureCollection();
        var c = new PathFigure();
        c._isClosed = true;
        c._startPoint = { $type: Point_$type, x: a.left, y: a.top };
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.top }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.top }));
        b.add(c);
        return b;
    };
    SeriesViewerView.prototype.ey = function (a) {
        var b = new PathFigureCollection();
        var c = new PathFigure();
        c._isClosed = true;
        c._startPoint = { $type: Point_$type, x: a.left, y: a.top };
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.top }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.top }));
        b.add(c);
        return b;
    };
    SeriesViewerView.prototype.ef = function (a, b) {
        b.intersect(a);
        var c = new PathGeometry();
        c.c = this.ey(a);
        var d = new PathGeometry();
        d.c = this.ex(b);
        var e = new GeometryGroup();
        e.d.add(c);
        e.d.add(d);
        this.e6.ak = e;
        this.e6._fill = this.i.b1();
        this.e6._opacity = 0.1;
        this.cj();
    };
    SeriesViewerView.prototype.d4 = function () {
        this.e6._visibility = 0;
        this.cj();
    };
    SeriesViewerView.prototype.eh = function (a) {
    };
    SeriesViewerView.prototype.dn = function (a) {
        var b = this.b.indexOf(a);
        this.b.removeAt(b);
        a.gv(null, null);
        this.dv();
        this.n.jy(a.name, true);
    };
    SeriesViewerView.prototype.dp = function (a) {
    };
    SeriesViewerView.prototype.bl = function (a) {
        if (!this.b.contains(a)) {
            this.b.add(a);
        }
        a.gv(this.w, this.v);
        this.dv();
    };
    SeriesViewerView.prototype.bi = function (a) {
    };
    SeriesViewerView.prototype.h = function () {
        this.g.a = this.l;
        return this.g;
    };
    SeriesViewerView.au = function (a) {
        var b = a.bs.series;
        var c = new List$1(Series.$, 0);
        for (var d = 0; d < b.count; d++) {
            c.add(b._inner[d]);
            if (b._inner[d].isStacked) {
                b._inner[d].h7(function (e) {
                    c.add(e);
                    return true;
                });
            }
        }
        return c;
    };
    SeriesViewerView.prototype.du = function () {
        this.n.m4 = new Rect(0, 0, 0, 1, 1);
    };
    SeriesViewerView.prototype.ct = function (a) {
        var e_10, _a, e_11, _b;
        var _this = this;
        if (a == this.bg) {
            return;
        }
        if (a == null) {
            if (this.j != null) {
                this.j.aq();
            }
            this.i.be(null);
            this.u = null;
            this.x = null;
            this.w = null;
            this.v = null;
            this.j = null;
            if (this.n.bi != null) {
                this.n.bi.provideContext(null);
                this.n.bi.provideContainer(null);
                this.n.bi.provideEventSource(null);
            }
            return;
        }
        this.bg = a;
        if (this.as) {
            this.a.e.add(this.n.ah);
        }
        this.i.be(a);
        this.u = this.i.t;
        this.x = this.i.w;
        this.w = this.i.v;
        this.v = this.i.u;
        this.al = false;
        try {
            this.al = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (b) {
        }
        this.am = false;
        try {
            this.am = (window.navigator.pointerEnabled);
        }
        catch (c) {
        }
        if (this.al || this.am) {
            this.at = true;
        }
        this.j = this.i.f;
        if (this.j != null) {
            this.j.bf = this.n.m3;
            this.j.ak = runOn(this, this.aq);
            var d = this.j;
            d.onContactCompleted = delegateCombine(d.onContactCompleted, runOn(this, this.cq));
            var e = this.j;
            e.onContactMoved = delegateCombine(e.onContactMoved, runOn(this, this.cr));
            var f = this.j;
            f.onContactStarted = delegateCombine(f.onContactStarted, runOn(this, this.cs));
            var g = this.j;
            g.onDragCompleted = delegateCombine(g.onDragCompleted, runOn(this.n, this.n.ib));
            var h = this.j;
            h.onFlingStarted = delegateCombine(h.onFlingStarted, runOn(this, this.aj));
            var i = this.j;
            i.onDragDelta = delegateCombine(i.onDragDelta, function (i) { return _this.n.ic(i); });
            var j = this.j;
            j.onDragStarted = delegateCombine(j.onDragStarted, function (j) { return _this.n.id(j, true); });
            var k = this.j;
            k.onKeyDown = delegateCombine(k.onKeyDown, runOn(this.n, this.n.c8));
            var l = this.j;
            l.onMouseDown = delegateCombine(l.onMouseDown, runOn(this, this.cz));
            var m = this.j;
            m.onMouseLeave = delegateCombine(m.onMouseLeave, runOn(this, this.c0));
            var n = this.j;
            n.onMouseOver = delegateCombine(n.onMouseOver, runOn(this, this.c1));
            var o = this.j;
            o.onMouseUp = delegateCombine(o.onMouseUp, runOn(this, this.c2));
            var p = this.j;
            p.onMouseWheel = delegateCombine(p.onMouseWheel, runOn(this.n, this.n.c9));
            if (this.j.aj) {
                var q = this.j;
                q.onZoomDelta = delegateCombine(q.onZoomDelta, function (q, r, s, t) { return _this.n.i4(q, r, s, t); });
                var r = this.j;
                r.onZoomStarted = delegateCombine(r.onZoomStarted, function (r, s, t, u) { return _this.n.i8(r, s, t, u); });
                var s = this.j;
                s.onZoomCompleted = delegateCombine(s.onZoomCompleted, function (s, t, u, v) { return _this.n.i3(s, t, u, v); });
            }
            else {
                var t = this.j;
                t.onPinchDelta = delegateCombine(t.onPinchDelta, function (t, u) { return _this.n.ip(u); });
                var u = this.j;
                u.onPinchStarted = delegateCombine(u.onPinchStarted, function (u, v) { return _this.n.iq(u); });
                var v = this.j;
                v.onGestureCompleted = delegateCombine(v.onGestureCompleted, function (v, w) { return _this.n.ie(v); });
            }
            var w = this.j;
            w.onDoubleTap = delegateCombine(w.onDoubleTap, function (w) { return _this.n.ia(w); });
            var x = this.j;
            x.onHold = delegateCombine(x.onHold, runOn(this, this.cw));
        }
        if (this.n.bi != null) {
            this.n.bi.provideContext(this.x);
            this.n.bi.provideContainer(a);
            this.n.bi.provideEventSource(this.j);
        }
        try {
            for (var _c = __values(fromEnum(this.b)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var y = _d.value;
                y.a2.aw();
                this.bl(y);
            }
        }
        catch (e_10_1) {
            e_10 = { error: e_10_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_10)
                    throw e_10.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(this.f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var z = _f.value;
                this.bm(z);
            }
        }
        catch (e_11_1) {
            e_11 = { error: e_11_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_11)
                    throw e_11.error;
            }
        }
    };
    SeriesViewerView.prototype.aj = function (a, b, c) {
        if (this.n.ce) {
            return false;
        }
        return true;
    };
    SeriesViewerView.prototype.cr = function (a, b) {
        this.n.h6(a, b);
    };
    SeriesViewerView.prototype.cs = function (a, b) {
        this.n.a1.f$s(this.n, a, b);
    };
    SeriesViewerView.prototype.cw = function (a) {
        this.n.ir(a);
    };
    SeriesViewerView.prototype.cq = function (a, b) {
        this.n.h5(a, b);
    };
    SeriesViewerView.prototype.dl = function (a) {
    };
    SeriesViewerView.prototype.get_an = function () {
        return false;
    };
    Object.defineProperty(SeriesViewerView.prototype, "an", {
        get: function () {
            return this.get_an();
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.d7 = function () {
        this.a7 = FontUtil.getCurrentFontHeight(this.i.ae, this.n.getFontInfo());
    };
    SeriesViewerView.prototype.e = function (a, b, c, d) {
        var _this = this;
        return {
            ret: ((function () { var e = _this.n.a1.f$c(_this.n, _this.f, _this.v, a, b, c, d); c = e.p5; return e.ret; })()),
            p2: c
        };
    };
    SeriesViewerView.prototype.bb = function () {
        return this.a6;
    };
    SeriesViewerView.prototype.ba = function () {
        return this.a5;
    };
    SeriesViewerView.prototype.cn = function () {
        this.i.bb();
    };
    SeriesViewerView.prototype.cu = function (a, b) {
        var c = this.a6;
        var d = this.a5;
        if (this.a6 != a) {
            this.ah = true;
        }
        this.a6 = a;
        if (this.a5 != b) {
            this.ah = true;
        }
        this.a5 = b;
        if (this.ah) {
            var e = new Size(1, c, d);
            var f = new Size(1, a, b);
            this.n.i0(e, f);
        }
        this.db();
        this.dv();
        this.n.ah.n();
    };
    SeriesViewerView.prototype.dv = function () {
        this.ae = true;
        this.n.al.y();
    };
    SeriesViewerView.prototype.bz = function () {
        var e_12, _a, e_13, _b, e_14, _c, e_15, _d;
        var _this = this;
        if (this.a6 == 0 || this.a5 == 0) {
            return;
        }
        this.ae = false;
        this.y = false;
        if (this.ai) {
            this.da();
            this.c6();
            this.ai = false;
            this.cj();
        }
        var a = this.a6;
        var b = this.a5;
        var c = this.n.ej;
        var d = this.n.el;
        var e = this.n.ef;
        var f = this.n.eu;
        var g = this.n.ed;
        var h = this.n.ee;
        if (isNaN_(g)) {
            g = this.a7 / 2;
        }
        if (isNaN_(h)) {
            h = 0;
        }
        var i = this.n.dd();
        var j = new List$1(AxisLabelPanelBase.$, 0);
        try {
            for (var _e = __values(fromEnum(this.b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var k = _f.value;
                if (k.at != null) {
                    j.add(k.at);
                    k.at.bo = function () { return _this.ah; };
                }
            }
        }
        catch (e_12_1) {
            e_12 = { error: e_12_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_a = _e.return))
                    _a.call(_e);
            }
            finally {
                if (e_12)
                    throw e_12.error;
            }
        }
        if (i) {
            var l = false;
            var m = false;
            var n = false;
            var o = false;
            try {
                for (var _g = __values(fromEnum(j)), _h = _g.next(); !_h.done; _h = _g.next()) {
                    var p = _h.value;
                    if (LabelPanelArranger.b(p) == 2 && (p.ac.aw == null || p.ac.aw.visibility == 0)) {
                        l = true;
                    }
                    if (LabelPanelArranger.b(p) == 3 && (p.ac.aw == null || p.ac.aw.visibility == 0)) {
                        m = true;
                    }
                    if (LabelPanelArranger.b(p) == 0 && (p.ac.aw == null || p.ac.aw.visibility == 0)) {
                        n = true;
                    }
                    if (LabelPanelArranger.b(p) == 1 && (p.ac.aw == null || p.ac.aw.visibility == 0)) {
                        o = true;
                    }
                    if (p.ac != null && p.ac.aw != null) {
                        p.ac.aw.c = p.ac.aw.location;
                    }
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_h && !_h.done && (_b = _g.return))
                        _b.call(_g);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
            if (l || m) {
                if (!n && isNaN_(f)) {
                    f = g;
                }
                if (!o && isNaN_(e)) {
                    e = g;
                }
            }
            if (o || n) {
                if (!l && isNaN_(c)) {
                    c = h;
                }
                if (!m && isNaN_(d)) {
                    d = h;
                }
            }
        }
        if (isNaN_(f)) {
            f = 0;
        }
        if (isNaN_(c)) {
            c = 0;
        }
        if (isNaN_(d)) {
            d = 0;
        }
        if (isNaN_(e)) {
            e = 0;
        }
        var q = this.bd();
        f += q;
        var r = this.bc();
        f += r;
        var s = new Rect(0, c, f, a - (c + d), b - (f + e));
        s = LabelPanelArranger.e(j, s);
        var t = new Size(1, Math.max(0, a - (c + d)), Math.max(0, b - (f + e)));
        if (this.n.cl() && s.width != s.height) {
            if (s.width < s.height) {
                f += (s.height - s.width) / 2;
                s.top = s.top + ((s.height - s.width) / 2);
                t.height = t.height - (s.height - s.width);
                s.height = s.width;
            }
            else {
                c += (s.width - s.height) / 2;
                s.left = s.left + ((s.width - s.height) / 2);
                t.width = t.width - (s.width - s.height);
                s.width = s.height;
            }
        }
        this.az = f - (q + r);
        this.ax = c;
        this.ay = d;
        this.aw = e;
        this.e0 = s;
        var u = ((function () {
            var $ret = new LabelPanelsArrangeState();
            $ret.f = c;
            $ret.c = c;
            $ret.a = f + t.height;
            $ret.b = f + t.height;
            $ret.g = c + t.width;
            $ret.d = c + t.width;
            $ret.h = f;
            $ret.e = f;
            return $ret;
        })());
        LabelPanelArranger.d(j, u, this.e0, function (v, w) {
            if (!v.cn.equals1(w)) {
                v.cn = w;
                v.ac.a2.ad();
            }
        });
        var v = false;
        if (this.ah) {
            this.ah = false;
            v = true;
        }
        this.n.jc(this.n.m3, this.e0);
        try {
            for (var _j = __values(fromEnum(this.b)), _k = _j.next(); !_k.done; _k = _j.next()) {
                var w = _k.value;
                if (Rect.l_op_Equality(w.i1, null) || w.i1.isEmpty) {
                    this.y = true;
                }
                if (w.i1.equals1(this.e0) && !this.i.y()) {
                    continue;
                }
                w.gp(w.i1, this.e0);
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_k && !_k.done && (_c = _j.return))
                    _c.call(_j);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        try {
            for (var _l = __values(fromEnum(this.f)), _m = _l.next(); !_m.done; _m = _l.next()) {
                var x = _m.value;
                if (Rect.l_op_Equality(x.bi.br, null) || x.bi.br.isEmpty) {
                    this.y = true;
                }
                if (x.bi.br.equals1(this.e0) && !this.i.y()) {
                    continue;
                }
                x.iv(x.bi.br, this.e0);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_m && !_m.done && (_d = _l.return))
                    _d.call(_l);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        this.ec();
        this.dm(this.e0);
        this.i.ba(false);
    };
    SeriesViewerView.prototype.ec = function () {
        if (this.n.bi != null && !this.e0.isEmpty) {
            var a = this.n.bi;
            var b = (this.n.ca) ? this.e0.width : Number.POSITIVE_INFINITY;
            var c = (this.n.ca) ? this.e0.height : Number.POSITIVE_INFINITY;
            var d = a.getDesiredSize(new Size(1, b, c));
            this.n.bi.arrange(new Rect(0, this.e0.right - d.width, this.e0.bottom - d.height, d.width, d.height));
            this.ee();
        }
    };
    SeriesViewerView.prototype.t = function () {
        var a = this.n.getFontInfo();
        var b = this.q();
        if (this.n.bt() != null) {
            a = this.n.bt();
        }
        else if (b != null) {
            a = b;
        }
        return a;
    };
    SeriesViewerView.prototype.s = function () {
        var a = this.n.getFontInfo();
        var b = this.p();
        if (this.n.bs() != null) {
            a = this.n.bs();
        }
        else if (b != null) {
            a = b;
        }
        return a;
    };
    SeriesViewerView.prototype.ew = function () {
        var a = this.n.getFontBrush();
        var b = this.et();
        if (this.n.mg != null) {
            a = this.n.mg;
        }
        else if (b != null) {
            a = b;
        }
        return a;
    };
    SeriesViewerView.prototype.ev = function () {
        var a = this.n.getFontBrush();
        var b = this.es();
        if (this.n.mf != null) {
            a = this.n.mf;
        }
        else if (b != null) {
            a = b;
        }
        return a;
    };
    SeriesViewerView.prototype.bd = function () {
        if (this.n.gq == null || !(typeCast(XamDataChart.$, this.n) !== null)) {
            return 0;
        }
        var a = this.t();
        var b = 0;
        b = FontUtil.getCurrentFontHeight(this.i.ae, a);
        var c = this.fb();
        b += c.top + c.bottom;
        return b;
    };
    SeriesViewerView.prototype.bc = function () {
        if (this.n.ge == null || !(typeCast(XamDataChart.$, this.n) !== null)) {
            return 0;
        }
        if (!isNaN_(this.a0)) {
            return this.a0;
        }
        var a = this.s();
        this.a0 = FontUtil.getCurrentFontHeight(this.i.ae, a);
        var b = this.fa();
        this.a0 += b.top + b.bottom;
        return this.a0;
    };
    SeriesViewerView.prototype.fb = function () {
        var a = this.i.cc();
        var b = isNaN_(this.n.et) ? a.top : this.n.et;
        var c = isNaN_(this.n.er) ? a.left : this.n.er;
        var d = isNaN_(this.n.es) ? a.right : this.n.es;
        var e = isNaN_(this.n.eq) ? a.bottom : this.n.eq;
        return new Thickness(1, c, b, d, e);
    };
    SeriesViewerView.prototype.fa = function () {
        var a = this.i.cb();
        var b = isNaN_(this.n.ep) ? a.top : this.n.ep;
        var c = isNaN_(this.n.en) ? a.left : this.n.en;
        var d = isNaN_(this.n.eo) ? a.right : this.n.eo;
        var e = isNaN_(this.n.em) ? a.bottom : this.n.em;
        return new Thickness(1, c, b, d, e);
    };
    SeriesViewerView.prototype.dm = function (a) {
    };
    SeriesViewerView.prototype.cj = function () {
        if (!this.ad) {
            this.ad = true;
            this.a.n();
        }
    };
    SeriesViewerView.prototype.ds = function () {
        if (this.x == null) {
            return;
        }
        if (this.x.d) {
            if (this.n.ea != 1) {
                this.x.z();
                this.x.aa(this.n.ea, this.n.ea);
            }
            if (!this.e1.isEmpty) {
                if (!this.as) {
                    this.x.k(this.e1.left, this.e1.top, this.e1.width, this.e1.height);
                }
            }
        }
        this.dt();
        if (this.x.d) {
            if (this.n.ea != 1) {
                this.x.y();
            }
        }
    };
    SeriesViewerView.prototype.isValid = function () {
        return true;
    };
    SeriesViewerView.prototype.preRender = function () {
        this.i.a4(this.a6, this.a5);
        this.dj();
    };
    SeriesViewerView.prototype.dj = function () {
    };
    SeriesViewerView.prototype.dt = function () {
        if (this.x.d) {
            this.e1 = new Rect(0, 0, 0, this.a6, this.a5);
            if (this.av != null && this.av.count > 0) {
                this.cb();
                this.x.z();
                this.x.ae(this.n.m3);
                if (!this.as) {
                    this.x.k(this.n.m3.left, this.n.m3.top, this.n.m3.width, this.n.m3.height);
                }
            }
            this.x.r(this.e4);
            this.x.r(this.e5);
            this.x.s(this.e6);
            this.x.v(this.e7);
            this.x.ac(this.t());
            if (this.ek != null) {
                this.ek.am = this.ew();
                this.x.w(this.ek);
            }
            this.x.ac(this.s());
            if (this.ej != null) {
                this.ej.am = this.ev();
                this.x.w(this.ej);
            }
            if (this.av != null && this.av.count > 0) {
                this.i.bj(this.av);
                this.x.y();
            }
            if (this.ap) {
                this.d3();
                this.ap = false;
                this.av.clear();
                this.n.a1.f$h(this.n);
                this.cj();
            }
        }
    };
    SeriesViewerView.prototype.cv = function () {
        this.i.bf();
    };
    SeriesViewerView.prototype.cp = function () {
        this.i.bd();
    };
    SeriesViewerView.prototype.e2 = function () {
        return new Rect(0, 0, 0, this.a6, this.a5);
    };
    SeriesViewerView.prototype.ez = function () {
        return this.i.b6();
    };
    SeriesViewerView.prototype.dy = function () {
        this.n.kn = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.d;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kw = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.m;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kt = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.j;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.ku = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.k;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.ko = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.e;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kr = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.h;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kp = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.f;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kv = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.l;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.ks = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.i;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.kq = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.g;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
    };
    SeriesViewerView.prototype.d6 = function () {
        this.i.bn();
        this.dw();
        var a = this.a7;
        this.d7();
        if (a != this.a7) {
            this.n.ht();
        }
    };
    SeriesViewerView.prototype.dg = function () {
        if (this.n.m8 == 0) {
            this.cg();
            this.n.hq();
        }
        if (this.n.bi != null) {
            var a = this.n.m8;
            this.n.bi.visibility = a;
            this.n.bi.doRefresh(false);
        }
    };
    SeriesViewerView.prototype.aq = function (a) {
        return this.n.a1.f$f(this.n, a);
    };
    SeriesViewerView.prototype.c1 = function (a, b, c) {
        this.n.a1.f$v(this.n, this.f, this.v, a, b, c);
    };
    SeriesViewerView.prototype.c0 = function (a) {
        this.n.a1.f$u(this.n, a);
    };
    SeriesViewerView.prototype.cz = function (a) {
        this.n.a1.f$t(this.n, this.j, a);
    };
    SeriesViewerView.prototype.c2 = function (a) {
        this.n.a1.f$w(this.n, this.j, a);
    };
    SeriesViewerView.prototype.dw = function () {
    };
    Object.defineProperty(SeriesViewerView.prototype, "eq", {
        get: function () {
            return this.j.bc;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.ei = function (a) {
        if (this.j != null) {
            this.j.bf = this.n.m3;
        }
    };
    SeriesViewerView.prototype.ck = function (a) {
        this.n.a1.f$y(this.n, a);
        this.n.ca = a;
    };
    SeriesViewerView.prototype.bh = function (a) {
        this.n.kb();
        this.i.bu(a);
        if (this.n.bi != null) {
            this.n.bi.mobileMode = a;
        }
        this.ed();
    };
    SeriesViewerView.prototype.ed = function () {
        this.n.kh();
    };
    Object.defineProperty(SeriesViewerView.prototype, "isDirty", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            this.ad = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.undirty = function (a) {
        this.ad = false;
        this.ds();
    };
    Object.defineProperty(SeriesViewerView.prototype, "index", {
        get: function () {
            return 10;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.postRender = function () {
    };
    SeriesViewerView.prototype.b2 = function () {
        this.dv();
    };
    SeriesViewerView.prototype.ca = function () {
        this.i.a7();
    };
    SeriesViewerView.prototype.d2 = function () {
        this.i.bm();
    };
    SeriesViewerView.prototype.bs = function (a) {
        this.i.aw();
    };
    SeriesViewerView.prototype.bj = function (a) {
        this.i.as(a);
    };
    SeriesViewerView.prototype.ea = function (a) {
        this.i.bs(a);
    };
    SeriesViewerView.prototype.eb = function (a) {
        this.i.bt(a);
    };
    SeriesViewerView.prototype.bk = function (a) {
        this.i.at(a);
    };
    SeriesViewerView.prototype.dr = function (a) {
        this.i.bi(a);
    };
    SeriesViewerView.prototype.c3 = function (a) {
        this.n.ah.n();
    };
    SeriesViewerView.prototype.br = function (a) {
    };
    SeriesViewerView.prototype.k = function (a) {
        if (this.n.ca) {
            return 2;
        }
        else {
            return 1;
        }
    };
    SeriesViewerView.prototype.cy = function () {
        if (this.j != null) {
            this.j.ac = this.n.cz;
        }
        if (this.l != null) {
            this.l.isSurfaceInteractionDisabled = this.n.cz;
        }
    };
    SeriesViewerView.prototype.a9 = function (a, b) {
        if (a == null || this.x == null) {
            return 0;
        }
        this.x.ac(b);
        return this.x.e(a);
    };
    SeriesViewerView.prototype.a8 = function (a, b) {
        if (a == null) {
            return 0;
        }
        var c = 0;
        c = FontUtil.getCurrentFontHeight(this.i.ae, b);
        return c;
    };
    SeriesViewerView.prototype.db = function () {
        this.ai = true;
        this.dv();
        this.cj();
    };
    SeriesViewerView.prototype.el = function (a, b, c, d) {
        if (a == null) {
            return null;
        }
        var e = ((function () {
            var $ret = new TextBlock();
            $ret.ak = a;
            $ret.o = b.top;
            return $ret;
        })());
        var f = this.a9(e, c);
        e.o = b.top;
        var g = this.a8(a, c);
        e.m = f;
        e.l = g;
        switch (d) {
            case 0:
                e.n = b.left;
                break;
            case 2:
                e.n = Math.max((this.a6 - b.right) - f, b.left);
                break;
            default:
            case 1:
            case 3:
                var h = (this.a6 / 2) - (f / 2);
                h += b.left;
                h -= b.right;
                e.n = h;
                break;
        }
        return e;
    };
    SeriesViewerView.prototype.da = function () {
        this.ek = typeCast(XamDataChart.$, this.n) !== null ? this.el(this.n.gq, this.fb(), this.t(), this.ep()) : null;
    };
    SeriesViewerView.prototype.c6 = function () {
        this.a0 = NaN;
        this.ej = typeCast(XamDataChart.$, this.n) !== null ? this.el(this.n.ge, this.fa(), this.s(), this.eo()) : null;
        if (this.ej != null) {
            this.ej.o += this.bd();
        }
    };
    SeriesViewerView.prototype.c = function (a) {
        var b = this.i.c();
        if (b == 0) {
            var c = LabelPanelArranger.b(a.at);
            if (a.ag == null) {
                if (c == 4) {
                    return 4;
                }
                if (c == 5) {
                    return 3;
                }
            }
            else {
                if (c == 4) {
                    return 3;
                }
                if (c == 5) {
                    return 4;
                }
            }
            if (c == 0) {
                return 3;
            }
            return 4;
        }
        return b;
    };
    SeriesViewerView.prototype.d = function (a) {
        var b = this.i.d();
        if (b == 0) {
            var c = LabelPanelArranger.b(a.at);
            if (a.ag == null) {
                if (c == 7) {
                    return 1;
                }
                if (c == 6) {
                    return 2;
                }
            }
            else {
                if (c == 7) {
                    return 2;
                }
                if (c == 6) {
                    return 1;
                }
            }
            if (c == 3) {
                return 2;
            }
            return 1;
        }
        return b;
    };
    SeriesViewerView.prototype.dc = function () {
        if (!isNaN_(this.n.d9)) {
            if (!isNaN_(DeviceUtils.a(this.n.ek))) {
                this.n.ea = DeviceUtils.a(this.n.ek);
            }
            else {
                this.ch();
            }
        }
        if (!this.n.cp) {
            this.i.a3();
        }
    };
    SeriesViewerView.prototype.dd = function () {
        if (!isNaN_(DeviceUtils.a(this.n.d9))) {
            this.n.ea = DeviceUtils.a(this.n.d9);
        }
        if (!this.n.cp) {
            this.i.a2();
        }
    };
    SeriesViewerView.prototype.r = function () {
        return this.i.r();
    };
    SeriesViewerView.prototype.eu = function () {
        return this.i.b5();
    };
    SeriesViewerView.prototype.o = function () {
        return this.i.q();
    };
    SeriesViewerView.prototype.er = function () {
        return this.i.b4();
    };
    SeriesViewerView.prototype.q = function () {
        return this.i.p();
    };
    SeriesViewerView.prototype.p = function () {
        return this.i.o();
    };
    SeriesViewerView.prototype.et = function () {
        return this.i.b3();
    };
    SeriesViewerView.prototype.es = function () {
        return this.i.b2();
    };
    Object.defineProperty(SeriesViewerView.prototype, "a2", {
        get: function () {
            return this.ax;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerView.prototype, "a3", {
        get: function () {
            return this.ay;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerView.prototype, "a4", {
        get: function () {
            return this.az;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerView.prototype, "a1", {
        get: function () {
            return this.aw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerView.prototype, "en", {
        get: function () {
            return this.ek;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerView.prototype, "em", {
        get: function () {
            return this.ej;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerView.prototype.e3 = function () {
        return new Rect(0, 0, 0, this.a6, this.a5);
    };
    SeriesViewerView.prototype.e9 = function () {
        return this.i.ce();
    };
    SeriesViewerView.prototype.e8 = function () {
        return this.i.cd();
    };
    SeriesViewerView.prototype.c5 = function (a, b) {
        this.aa = true;
    };
    SeriesViewerView.prototype.c9 = function (a, b) {
        this.ab = true;
    };
    SeriesViewerView.prototype.ep = function () {
        if (this.ab) {
            return this.n.lz;
        }
        else {
            var a = 1;
            switch (this.i.ar()) {
                case "left":
                    a = 0;
                    break;
                case "right":
                    a = 2;
                    break;
            }
            return a;
        }
    };
    SeriesViewerView.prototype.eo = function () {
        if (this.aa) {
            return this.n.ly;
        }
        else {
            var a = 1;
            switch (this.i.aq()) {
                case "left":
                    a = 0;
                    break;
                case "right":
                    a = 2;
                    break;
            }
            return a;
        }
    };
    SeriesViewerView.prototype.bn = function () {
        if (this.ae) {
            this.bz();
            if (this.y) {
                this.n.al.x();
            }
            if (this.ae) {
                this.bz();
            }
        }
    };
    SeriesViewerView.prototype.ak = function () {
        if (this.n.dk) {
            return false;
        }
        if ((dateNow().getTime() - this.n.dn.getTime()) < 300) {
            return true;
        }
        return false;
    };
    SeriesViewerView.prototype.b1 = function () {
        this.i.a4(this.a6, this.a5);
    };
    SeriesViewerView.prototype.ci = function () {
        this.i.a9(this.n.cy);
    };
    SeriesViewerView.prototype.ar = function (a) {
        var b = this.n.mq;
        var c = b.top > 0;
        var d = b.left > 0;
        var e = b.right < 1;
        var f = b.bottom < 1;
        var g = a.y < 0;
        var h = a.y > 0;
        var i = a.x < 0;
        var j = a.x > 0;
        if (c && g) {
            return true;
        }
        if (d && i) {
            return true;
        }
        if (f && h) {
            return true;
        }
        if (j && e) {
            return true;
        }
        return false;
    };
    SeriesViewerView.prototype.dh = function () {
        this.i.bh();
        this.n.ah.n();
        this.n.ai.n();
        this.n.ag.n();
        this.a.n();
    };
    SeriesViewerView.prototype.b0 = function (a, b, c) {
        this.ap = false;
        if (this.av == null) {
            this.av = new List$1(ITileZoomTile_$type, 0);
        }
        for (var d = 0; d < this.av.count; d++) {
            while (d < this.av.count && !a.containsKey(this.av._inner[d].content)) {
                this.av.removeAt(d);
            }
        }
        for (var e = 0; e < b.count; e++) {
            this.av.add(b._inner[e]);
        }
        this.cj();
    };
    SeriesViewerView.prototype.bf = function (a, b, c) {
        return this.i.an(a, b, c);
    };
    SeriesViewerView.prototype.bx = function () {
        this.i.a0();
    };
    SeriesViewerView.prototype.by = function (a) {
        this.i.a1(a);
    };
    SeriesViewerView.prototype.cf = function () {
        if (this.av == null) {
            return;
        }
        this.ap = true;
        this.cj();
    };
    SeriesViewerView.prototype.bv = function () {
        this.i.ay();
    };
    SeriesViewerView.prototype.bo = function () {
        this.i.au();
    };
    SeriesViewerView.prototype.bw = function (a) {
        this.i.az(a);
    };
    SeriesViewerView.prototype.bp = function () {
        this.i.av();
    };
    SeriesViewerView.prototype.cb = function () {
        if (this.af) {
            this.af = false;
            this.w.k(this.n.m3.left, this.n.m3.top, this.n.m3.width, this.n.m3.height);
            this.n.ah.c = true;
        }
    };
    SeriesViewerView.prototype.d3 = function () {
        if (!this.af) {
            this.af = true;
            this.n.ah.c = false;
            this.n.ah.o(this.w, this.v);
        }
    };
    SeriesViewerView.prototype.c8 = function () {
    };
    SeriesViewerView.prototype.co = function () {
        this.i.bc();
    };
    SeriesViewerView.$t = markType(SeriesViewerView, 'SeriesViewerView', Base.$, [ISchedulableRender_$type]);
    return SeriesViewerView;
}(Base));
/**
 * @hidden
 */
var OverviewPlusDetailViewportHost = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OverviewPlusDetailViewportHost, _super);
    function OverviewPlusDetailViewportHost(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        return _this;
    }
    OverviewPlusDetailViewportHost.prototype.getViewInfo = function (a, b) {
        a = new Rect(0, 0, 0, this.a.l.worldRectViewport.width, this.a.l.worldRectViewport.height);
        b = SeriesViewer.m0;
        return {
            p0: a,
            p1: b
        };
    };
    OverviewPlusDetailViewportHost.prototype.getEffectiveViewport = function () {
        if (!this.a.n.cx) {
            if (this.a.n.mu.isEmpty) {
                return this.a.n.mu;
            }
            return this.a.n.my(this.a.l.previewViewportdRect, this.a.n.m3, this.a.n.mu);
        }
        return Rect.empty;
    };
    OverviewPlusDetailViewportHost.$t = markType(OverviewPlusDetailViewportHost, 'OverviewPlusDetailViewportHost', Base.$, [IProvidesViewport_$type]);
    return OverviewPlusDetailViewportHost;
}(Base));
/**
 * @hidden
 */
var SeriesViewerViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerViewManager, _super);
    function SeriesViewerViewManager(a) {
        var _this = _super.call(this) || this;
        _this.ae = null;
        _this.af = null;
        _this.aj = null;
        _this.ai = null;
        _this.ag = null;
        _this.ak = null;
        _this.t = null;
        _this.w = null;
        _this.v = null;
        _this.u = null;
        _this.x = null;
        _this.f = null;
        _this.j = null;
        _this.ah = null;
        _this.ab = 0;
        _this.aa = 0;
        _this.ac = 1;
        _this.ad = 0;
        _this.l = null;
        _this.b8 = new Thickness(0, 0);
        _this.ap = null;
        _this.ao = stringEmpty();
        _this.b7 = new Thickness(0, 0);
        _this.by = null;
        _this.bx = null;
        _this.k = null;
        _this.a = 0;
        _this.b = 0;
        _this.n = null;
        _this.b0 = null;
        _this.m = null;
        _this.bz = null;
        _this.b9 = new Thickness(0, 0);
        _this.ca = new Thickness(0, 0);
        _this.h = null;
        _this.z = new Dictionary$2(String_$type, Tuple$2.$.specialize(DomWrapper_$type, RenderingContext.$), 0);
        _this.al = -1;
        _this.am = -1;
        _this.s = null;
        _this.j = a;
        return _this;
    }
    SeriesViewerViewManager.prototype.bh = function () {
    };
    SeriesViewerViewManager.prototype.be = function (a) {
        if (a == null) {
            if (this.f != null) {
                this.f.aq();
            }
            this.ae = null;
            if (this.af != null) {
                this.af.remove();
            }
            this.af = null;
            if (this.aj != null) {
                this.aj.remove();
            }
            this.aj = null;
            if (this.ai != null) {
                this.ai.remove();
            }
            this.ai = null;
            if (this.ag != null) {
                this.ag.remove();
            }
            this.ag = null;
            if (this.ak != null) {
                this.ak.remove();
            }
            this.ak = null;
            this.t = null;
            this.w = null;
            this.v = null;
            this.u = null;
            if (this.ah != null) {
                this.ah.remove();
            }
            this.ah = null;
            this.f = null;
            this.j.n.bo.u(null);
            this.j.n.ah.j(null);
            this.j.n.ai.j(null);
            this.j.n.ag.j(null);
            this.j.a.j(null);
            return;
        }
        this.ae = a;
        this.j.n.bo.u(this.ae);
        this.j.n.ah.j(this.ae);
        this.j.n.ai.j(this.ae);
        this.j.n.ag.j(this.ae);
        this.j.a.j(this.ae);
        this.j.n.al.z(this.ae);
        this.bg();
        this.ae.rootWrapper.setStyleProperty("position", "relative");
        this.af = this.ae.createElement("canvas");
        this.af.setStyleProperty("position", "absolute");
        this.af.setStyleProperty("top", "0px");
        this.af.setStyleProperty("left", "0px");
        this.aj = this.ae.createElement("canvas");
        this.aj.setStyleProperty("position", "absolute");
        this.aj.setStyleProperty("top", "0px");
        this.aj.setStyleProperty("left", "0px");
        this.ai = this.ae.createElement("canvas");
        this.ai.setStyleProperty("position", "absolute");
        this.ai.setStyleProperty("top", "0px");
        this.ai.setStyleProperty("left", "0px");
        this.ag = this.ae.createElement("canvas");
        this.ag.setStyleProperty("position", "absolute");
        this.ag.setStyleProperty("top", "0px");
        this.ag.setStyleProperty("left", "0px");
        this.ak = this.ae.createElement("canvas");
        this.ak.setStyleProperty("position", "absolute");
        this.ak.setStyleProperty("top", "0px");
        this.ak.setStyleProperty("left", "0px");
        this.ae.append(this.af);
        this.ae.append(this.ai);
        this.ae.append(this.aj);
        this.t = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.af));
        this.w = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.aj));
        this.v = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ai));
        if (this.j.n.ao != 1) {
            this.u = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
            this.s = this.u;
        }
        else {
            this.u = new RenderingContext(null, null);
        }
        this.x = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ak));
        this.j.dl(this.t);
        this.j.cu(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
        {
            if ((TypeRegistrar.isRegistered('CanvasGestureDOMEventProxy'))) {
                var overlayCanvas_ = this.aj;
                var container_ = this.ae;
                this.f = (TypeRegistrar.create('CanvasGestureDOMEventProxy', overlayCanvas_, container_, false));
            }
            else {
                this.f = null;
            }
            if (this.f != null) {
                this.f.al = runOn(this.j, this.j.ar);
            }
        }
        this.ah = this.ae.createElement("div");
        this.ah.hide();
        this.ah.setStyleProperty("position", "absolute");
        this.ah.setStyleProperty("z-index", "10000");
        this.ah.addClass(this.j.n.g0);
        this.ae.append(this.ah);
    };
    SeriesViewerViewManager.bw = function (a, b) {
        b();
        return;
    };
    SeriesViewerViewManager.prototype.bg = function () {
        this.j.dw();
        this.j.d7();
        this.bn();
    };
    SeriesViewerViewManager.prototype.a8 = function () {
        var a = this.j.n.ek;
        var b = this.j.n.ea;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.j.n.ea = window.devicePixelRatio;
        }
    };
    SeriesViewerViewManager.prototype.g = function () {
        if ((TypeRegistrar.isRegistered('XamOverviewPlusDetailPane'))) {
            var overlayCanvas_ = this.aj;
            var container_ = this.ae;
            return (TypeRegistrar.create('XamOverviewPlusDetailPane'));
        }
        return null;
    };
    SeriesViewerViewManager.prototype.bk = function () {
        this.aj.setStyleProperty("cursor", "default");
    };
    SeriesViewerViewManager.prototype.bl = function () {
        this.aj.setStyleProperty("cursor", "pointer");
    };
    SeriesViewerViewManager.prototype.b1 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "#000000";
            return $ret;
        })());
    };
    SeriesViewerViewManager.prototype.ax = function (a, b, c) {
        this.ab = a;
        this.aa = b;
        this.ac = c;
        var d = a;
        var e = b;
        if (c != 1) {
            d = Math.round(a * c);
            e = Math.round(b * c);
        }
        if (this.af != null) {
            this.af.setAttribute("width", d.toString());
            this.af.setAttribute("height", e.toString());
            this.af.setStyleProperty("width", a.toString() + "px");
            this.af.setStyleProperty("height", b.toString() + "px");
        }
        if (this.aj != null) {
            this.aj.setAttribute("width", d.toString());
            this.aj.setAttribute("height", e.toString());
            this.aj.setStyleProperty("width", a.toString() + "px");
            this.aj.setStyleProperty("height", b.toString() + "px");
            this.aj.setAttribute("tabindex", "0");
            this.aj.setStyleProperty("outline", "0");
        }
        if (this.ai != null) {
            this.ai.setAttribute("width", d.toString());
            this.ai.setAttribute("height", e.toString());
            this.ai.setStyleProperty("width", a.toString() + "px");
            this.ai.setStyleProperty("height", b.toString() + "px");
        }
        if (this.ag != null) {
            this.ag.setAttribute("width", d.toString());
            this.ag.setAttribute("height", e.toString());
            this.ag.setStyleProperty("width", a.toString() + "px");
            this.ag.setStyleProperty("height", b.toString() + "px");
        }
        if (this.ak != null) {
            this.ak.setAttribute("width", d.toString());
            this.ak.setAttribute("height", e.toString());
            this.ak.setStyleProperty("width", a.toString() + "px");
            this.ak.setStyleProperty("height", b.toString() + "px");
        }
        this.j.n.ah.n();
        this.j.n.ai.n();
        this.j.n.ag.n();
    };
    SeriesViewerViewManager.prototype.b6 = function () {
        if (this.f == null) {
            return { $type: Point_$type, x: 0, y: 0 };
        }
        var a = this.f.be(this.ae.rootWrapper);
        return { $type: Point_$type, x: a.left, y: a.top };
    };
    SeriesViewerViewManager.prototype.y = function () {
        return false;
    };
    SeriesViewerViewManager.prototype.ba = function (a) {
    };
    SeriesViewerViewManager.prototype.a6 = function (a, b, c, d, e) {
        var f = this.e();
        a = f.a;
        b = f.f;
        c = f.k;
        d = f.h;
        e = f.i;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    };
    SeriesViewerViewManager.prototype.e = function () {
        var e_16, _a;
        var a = new DefaultPaletteInfo();
        a.a = new BrushCollection();
        a.f = new BrushCollection();
        a.b = new BrushCollection();
        a.c = new BrushCollection();
        var b = new List$1(String_$type, 0);
        b.add("background-image");
        this.ae.startCSSQuery();
        var c = this.ae.getCssDefaultValuesForClassCollection("ui-chart-fill-palette-", b.toArray());
        var d = c.length;
        var e = this.ae.getCssDefaultValuesForClassCollection("ui-chart-outline-palette-", b.toArray());
        var f = e.length;
        var g = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-fill-palette-", b.toArray());
        var h = g.length;
        var i = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-outline-palette-", b.toArray());
        var j = i.length;
        for (var k = 0; k < d; k++) {
            a.a.add(CssGradientUtil.brushFromGradientString(c[k][0]));
        }
        for (var l = 0; l < f; l++) {
            a.f.add(CssGradientUtil.brushFromGradientString(e[l][0]));
        }
        for (var m = 0; m < h; m++) {
            a.b.add(CssGradientUtil.brushFromGradientString(g[m][0]));
        }
        for (var n = 0; n < j; n++) {
            a.c.add(CssGradientUtil.brushFromGradientString(i[n][0]));
        }
        b.clear();
        var o = 0;
        var p = 0;
        var q = Math.min(d, f);
        var r = null;
        if (d == 0) {
            b.add("background-color");
        }
        if (f == 0) {
            b.add("border-top-color");
            p = d == 0 ? 1 : 0;
        }
        if (b.count > 0) {
            r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-palette-", b.toArray());
            q = r.length;
        }
        if (d == 0) {
            if (q > 0) {
                for (var s = 0; s < q; s++) {
                    var t = new Brush();
                    t._fill = r[s][o];
                    a.a.add(t);
                }
            }
            else {
                a.a.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#50a8be";
                    return $ret;
                })()));
                a.a.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#fc6754";
                    return $ret;
                })()));
                a.a.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#fec33c";
                    return $ret;
                })()));
                a.a.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#3c6399";
                    return $ret;
                })()));
                a.a.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#91af49";
                    return $ret;
                })()));
            }
        }
        if (f == 0) {
            if (q > 0) {
                for (var u = 0; u < q; u++) {
                    var v = new Brush();
                    v._fill = r[u][p];
                    a.f.add(v);
                }
            }
            else {
                a.f.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#B1BFC9";
                    return $ret;
                })()));
                a.f.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#798995";
                    return $ret;
                })()));
                a.f.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#4F606C";
                    return $ret;
                })()));
                a.f.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#374650";
                    return $ret;
                })()));
                a.f.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#162C3B";
                    return $ret;
                })()));
            }
        }
        b.clear();
        var w = Math.min(h, j);
        if (h == 0) {
            b.add("background-color");
        }
        if (j == 0) {
            b.add("border-top-color");
            p = h == 0 ? 1 : 0;
        }
        if (b.count > 0) {
            r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-palette-", b.toArray());
            w = r.length;
        }
        if (h == 0) {
            if (w > 0) {
                var _loop_1 = function (x) {
                    var y = ((function () {
                        var $ret = new Brush();
                        $ret.fill = r[x][o];
                        return $ret;
                    })());
                    a.b.add(y);
                };
                for (var x = 0; x < w; x++) {
                    _loop_1(x);
                }
            }
            else {
                a.b.add(((function () {
                    var $ret = new Brush();
                    $ret.fill = "#FFFFFF";
                    return $ret;
                })()));
            }
        }
        if (j == 0) {
            if (w > 0) {
                var _loop_2 = function (z) {
                    var aa = ((function () {
                        var $ret = new Brush();
                        $ret.fill = r[z][p];
                        return $ret;
                    })());
                    a.c.add(aa);
                };
                for (var z = 0; z < w; z++) {
                    _loop_2(z);
                }
            }
            else {
                try {
                    for (var _b = __values(fromEnum(a.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var ab = _c.value;
                        a.c.add(ab);
                    }
                }
                catch (e_16_1) {
                    e_16 = { error: e_16_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_16)
                            throw e_16.error;
                    }
                }
            }
        }
        var ac = this.ae.getCssDefaultPropertyValue("ui-chart-axis", "border-top-color");
        if (ac != null) {
            a.i = new Brush();
            a.i._fill = ac;
        }
        else {
            var ad = new Brush();
            ad._fill = "#989EA3";
            a.i = ad;
        }
        a.k = new Brush();
        a.k._fill = this.ae.getCssDefaultPropertyValue("", "color");
        a.j = a.k;
        var ae = this.ae.getCssDefaultPropertyValue("ui-chart-crosshair", "border-top-color");
        if (ae != null) {
            a.j = new Brush();
            a.j._fill = ae;
        }
        this.ae.endCSSQuery();
        a.h = FontUtil.getFont(this.ae);
        var af = ((function () {
            var $ret = new Brush();
            $ret.fill = "#C62828";
            return $ret;
        })());
        a.d = new BrushCollection();
        a.d.add(af);
        a.e = new BrushCollection();
        a.e.add(af);
        return a;
    };
    SeriesViewerViewManager.prototype.a5 = function (a, b, c, d, e, f) {
        this.ae.startCSSQuery();
        var g = this.ae.getCssDefaultPropertyValue("ui-chart-area-fill-opacity", "opacity");
        a = g != null ? parseFloat(g) : 1;
        b = new Array(4);
        var h = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-top");
        var i = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-right");
        var j = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-bottom");
        var k = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-left");
        b[0] = h != null ? parseFloat(h) : NaN;
        b[1] = i != null ? parseFloat(i) : NaN;
        b[2] = j != null ? parseFloat(j) : NaN;
        b[3] = k != null ? parseFloat(k) : NaN;
        c = d = null;
        var l = this.ae.getCssDefaultPropertyValue("ui-chart-axis-stroke", "border-top-color");
        if (l != null) {
            var m = new Brush();
            m._fill = l;
            c = m;
        }
        var n = this.ae.getCssDefaultPropertyValue("ui-chart-axis-major-line", "border-top-color");
        if (n != null) {
            var o = new Brush();
            o._fill = n;
            d = o;
        }
        var p = this.ae.getCssDefaultPropertyValue("ui-chart-aligned-gridlines", "visibility");
        f = p != null && p == "visible";
        var q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "height");
        if (q != null) {
            e = parseFloat(q);
            if (Math.abs(e) > 4000) {
                e = 0;
            }
        }
        else {
            q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "width");
            e = q != null ? parseFloat(q) : 0;
        }
        this.ae.endCSSQuery();
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d,
            p4: e,
            p5: f
        };
    };
    SeriesViewerViewManager.prototype.aw = function () {
        this.ah.removeChildren();
    };
    SeriesViewerViewManager.prototype.bs = function (x_) {
        var box_ = this.ah;
        var offset_ = this.f.be(this.ah);
        var a = this.b6();
        x_ = a.x + this.j.n.m3.left + x_;
        box_.setOffset(x_, this.j.n.m3.top + this.ad + a.y);
    };
    SeriesViewerViewManager.prototype.bt = function (y_) {
        this.ad = y_;
        var box_ = this.ah;
        var offset_ = this.ah.getOffset();
        var a = this.b6();
        y_ = this.j.n.m3.top + this.ad + a.y;
        box_.setOffset(offset_.left, y_);
    };
    SeriesViewerViewManager.prototype.as = function (a) {
        var b = a;
        b.show();
        this.ah.append(b);
    };
    SeriesViewerViewManager.prototype.a7 = function () {
        this.ah.hide();
    };
    SeriesViewerViewManager.prototype.bm = function () {
        this.ah.show();
    };
    SeriesViewerViewManager.prototype.at = function (a) {
        this.ae.appendToBody(a);
    };
    SeriesViewerViewManager.prototype.bi = function (a) {
        a.remove();
    };
    SeriesViewerViewManager.prototype.bb = function () {
        if (this.ae == null) {
            return;
        }
        this.a8();
        this.j.cu(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
    };
    SeriesViewerViewManager.prototype.p = function () {
        return this.l;
    };
    SeriesViewerViewManager.prototype.cc = function () {
        return this.b8;
    };
    SeriesViewerViewManager.prototype.ar = function () {
        return this.ap;
    };
    SeriesViewerViewManager.prototype.aq = function () {
        return this.ao;
    };
    SeriesViewerViewManager.prototype.cb = function () {
        return this.b7;
    };
    SeriesViewerViewManager.prototype.b3 = function () {
        return this.by;
    };
    SeriesViewerViewManager.prototype.b2 = function () {
        return this.bx;
    };
    SeriesViewerViewManager.prototype.o = function () {
        return this.k;
    };
    SeriesViewerViewManager.prototype.c = function () {
        return this.a;
    };
    SeriesViewerViewManager.prototype.d = function () {
        return this.b;
    };
    SeriesViewerViewManager.prototype.r = function () {
        return this.n;
    };
    SeriesViewerViewManager.prototype.b5 = function () {
        return this.b0;
    };
    SeriesViewerViewManager.prototype.q = function () {
        return this.m;
    };
    SeriesViewerViewManager.prototype.b4 = function () {
        return this.bz;
    };
    SeriesViewerViewManager.prototype.cd = function () {
        return this.b9;
    };
    SeriesViewerViewManager.prototype.ce = function () {
        return this.ca;
    };
    SeriesViewerViewManager.prototype.bn = function () {
        this.ae.startCSSQuery();
        this.bp();
        this.bo();
        this.br();
        this.bq();
        this.bv();
        this.ae.endCSSQuery();
    };
    SeriesViewerViewManager.prototype.bv = function () {
        var a = "ui-chart-pointer-tooltip";
        var b = this.ae.getCssDefaultPropertyValue(a, "background-color");
        var c = this.ae.getCssDefaultPropertyValue(a, "border-top-color");
        var d = this.ae.getCssDefaultPropertyValue(a, "border-top-left-radius");
        var e = this.ae.getCssDefaultPropertyValue(a, "border-top-width");
        var f = new PointerTooltipStyle();
        f.a = d != null ? parseFloat(d) : 0;
        f.c = b != null ? Brush.create(b) : ((function () {
            var $ret = new Brush();
            $ret.fill = "white";
            return $ret;
        })());
        f.d = c != null ? Brush.create(c) : ((function () {
            var $ret = new Brush();
            $ret.fill = "gray";
            return $ret;
        })());
        f.b = e != null ? parseFloat(e) : 0;
        this.h = f;
    };
    SeriesViewerViewManager.prototype.bp = function () {
        var _this = this;
        var a = "ui-chart-title";
        this.l = FontUtil.getFontForClass(this.ae, a);
        this.by = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        this.ap = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (this.ap == null) {
            this.ap = "center";
        }
        var b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        var c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        var d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        var e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        var f = b != null ? parseFloat(b) : 0;
        var g = c != null ? parseFloat(c) : 0;
        var h = d != null ? parseFloat(d) : 0;
        var i = e != null ? parseFloat(e) : 0;
        this.b8 = new Thickness(1, h, f, i, g);
    };
    SeriesViewerViewManager.prototype.bo = function () {
        var _this = this;
        var a = "ui-chart-subtitle";
        this.k = FontUtil.getFontForClass(this.ae, a);
        this.bx = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        this.ao = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (this.ao == null) {
            this.ao = "center";
        }
        var b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        var c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        var d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        var e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        var f = b != null ? parseFloat(b) : 0;
        var g = c != null ? parseFloat(c) : 0;
        var h = d != null ? parseFloat(d) : 0;
        var i = e != null ? parseFloat(e) : 0;
        this.b7 = new Thickness(1, h, f, i, g);
    };
    SeriesViewerViewManager.prototype.bq = function () {
        var _this = this;
        var a = "ui-chart-horizontal-axis-title";
        this.m = FontUtil.getFontForClass(this.ae, a);
        this.bz = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        var b = this.ae.getCssDefaultPropertyValue(a, "vertical-align");
        if (b == null) {
            this.a = 0;
        }
        else if (b.toLowerCase() == "bottom") {
            this.a = 4;
        }
        else {
            this.a = 3;
        }
        var c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        var d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        var e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        var f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        var g = c != null ? parseFloat(c) : 2;
        var h = d != null ? parseFloat(d) : 2;
        var i = e != null ? parseFloat(e) : 2;
        var j = f != null ? parseFloat(f) : 2;
        this.b9 = new Thickness(1, i, g, j, h);
    };
    SeriesViewerViewManager.prototype.br = function () {
        var _this = this;
        var a = "ui-chart-vertical-axis-title";
        this.n = FontUtil.getFontForClass(this.ae, a);
        this.b0 = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        var b = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (b == null) {
            this.b = 0;
        }
        else if (b.toLowerCase() == "right") {
            this.b = 2;
        }
        else {
            this.b = 1;
        }
        var c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        var d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        var e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        var f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        var g = c != null ? parseFloat(c) : 0;
        var h = d != null ? parseFloat(d) : 0;
        var i = e != null ? parseFloat(e) : 0;
        var j = f != null ? parseFloat(f) : 0;
        this.ca = new Thickness(1, i, g, j, h);
    };
    SeriesViewerViewManager.prototype.a4 = function (a, b) {
        var c = this.j.n.ea;
        if (a != this.ab || b != this.aa || c != this.ac) {
            this.ax(a, b, this.j.n.ea);
            this.j.n.ah.i();
            this.j.a.i();
        }
    };
    SeriesViewerViewManager.prototype.i = function () {
        return this.h;
    };
    SeriesViewerViewManager.prototype.a9 = function (a) {
        if (this.f == null) {
            return;
        }
        this.f.aa = a;
        this.f.al = runOn(this.j, this.j.ar);
    };
    SeriesViewerViewManager.prototype.an = function (a, b, c) {
        var _this = this;
        var d;
        if (!((function () { var e = _this.z.tryGetValue(b.iD.toString(), d); d = e.p1; return e.ret; })())) {
            var e = this.ae.createElement("canvas");
            e.setAttribute("width", c.toString());
            e.setAttribute("height", c.toString());
            e.setStyleProperty("width", c.toString() + "px");
            e.setStyleProperty("height", c.toString() + "px");
            var f = this.ae.get2DCanvasContext(e);
            var g = new RenderingContext(new CanvasViewRenderer(), f);
            var h = new Tuple$2(DomWrapper_$type, RenderingContext.$, e, g);
            d = h;
            this.z.addItem(b.iD.toString(), d);
        }
        var i = new Rect(0, 0, 0, c, c);
        var j = new RenderSurface();
        j.a = d.d;
        for (var k = 0; k < this.j.n.series.count; k++) {
            var l = this.j.n.series._inner[k];
            l.jc(i, a, j, "tile", 1);
        }
        this.j.n.ag.i();
        return d.c;
    };
    SeriesViewerViewManager.prototype.a1 = function (a) {
        this.z.removeItem(a.iD.toString());
    };
    SeriesViewerViewManager.prototype.a0 = function () {
        this.z.clear();
    };
    SeriesViewerViewManager.prototype.bj = function (a) {
        for (var b = 0; b < a.count; b++) {
            var c = a._inner[b];
            var d = c.content;
            this.j.x.m(d.getNativeElement(), 1, c.xPosition + this.j.n.m3.left, c.yPosition + this.j.n.m3.top, c.width, c.height);
        }
    };
    SeriesViewerViewManager.prototype.ay = function () {
        var _this = this;
        if (this.al != -1) {
            this.au();
        }
        if (this.ae != null) {
            this.al = this.ae.setTimeout(function () { return _this.j.n.a1.f$i(_this.j.n); }, 5000);
        }
        else {
            this.al = window.setTimeout(function () { return _this.j.n.a1.f$i(_this.j.n); }, 5000);
        }
    };
    SeriesViewerViewManager.prototype.au = function () {
        if (this.al != -1) {
            if (this.ae != null) {
                this.ae.clearTimeout(this.al);
            }
            else {
                window.clearTimeout(this.al);
            }
            this.al = -1;
        }
    };
    SeriesViewerViewManager.prototype.az = function (a) {
        var _this = this;
        if (this.am != -1) {
            this.av();
        }
        if (this.ae != null) {
            this.ae.setTimeout(function () { return _this.j.n.hj(); }, a);
        }
        else {
            this.am = window.setTimeout(function () { return _this.j.n.hj(); }, a);
        }
    };
    SeriesViewerViewManager.prototype.av = function () {
        if (this.am != -1) {
            if (this.ae != null) {
                this.ae.clearTimeout(this.am);
            }
            else {
                window.clearTimeout(this.am);
            }
            this.am = -1;
        }
    };
    SeriesViewerViewManager.prototype.bc = function () {
        if (this.j.n.ao != 1) {
            if (this.s == null) {
                this.u = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
                this.s = this.u;
            }
            else {
                this.u = this.s;
            }
        }
        else {
            this.u = new RenderingContext(null, null);
        }
        this.j.dk(this.u);
    };
    SeriesViewerViewManager.prototype.bu = function (a) {
        if (this.ae != null) {
            var b = "igTouch";
            if (a) {
                this.ae.rootWrapper.addClass(b);
            }
            else {
                this.ae.rootWrapper.removeClass(b);
            }
        }
    };
    SeriesViewerViewManager.prototype.a2 = function () {
    };
    SeriesViewerViewManager.prototype.a3 = function () {
    };
    SeriesViewerViewManager.prototype.bf = function () {
        if (this.f != null) {
            this.f.bb(this.aj, "");
        }
    };
    SeriesViewerViewManager.prototype.bd = function () {
        this.a8();
        if (this.f != null) {
            this.f.ap(this.aj, "");
        }
    };
    SeriesViewerViewManager.$t = markType(SeriesViewerViewManager, 'SeriesViewerViewManager');
    return SeriesViewerViewManager;
}(Base));
/**
 * @hidden
 */
var AutoRangeCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AutoRangeCalculator, _super);
    function AutoRangeCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AutoRangeCalculator.a = function (a, b, c, d, e, f, g) {
        f = !isNaN_(b) && !isInfinity(b) ? b : Number.POSITIVE_INFINITY;
        g = !isNaN_(c) && !isInfinity(c) ? c : Number.NEGATIVE_INFINITY;
        var h = f;
        var i = g;
        if (isInfinity(h) || isInfinity(i)) {
            if (a != null) {
                var j = a.jb();
                if (j != null) {
                    h = Math.min(h, j.c);
                    i = Math.max(i, j.b);
                }
            }
        }
        if (!isInfinity(h) && !isInfinity(i)) {
            if (h == i && h != 0) {
                h *= h > 0 ? 0.9 : 1.1;
                i *= i > 0 ? 1.1 : 0.9;
            }
            if (h == i && h == 0) {
                i = 1;
            }
            if (b > c) {
                var k = c;
                c = b;
                b = k;
            }
            var l = isNaN_(b) || isInfinity(b) ? h : b;
            var m = isNaN_(c) || isInfinity(c) ? i : c;
            if (d) {
                if (l <= 0) {
                    if (m > 1) {
                        l = 1;
                    }
                    else {
                        l = Math.pow(e, Math.floor(logBase(m, e)));
                    }
                }
                if (isNaN_(b) || isInfinity(b)) {
                    var n = logBase(l, e);
                    h = Math.pow(e, Math.floor(n));
                }
                else {
                    h = l;
                }
                if (isNaN_(c) || isInfinity(c)) {
                    i = Math.pow(e, Math.ceil(logBase(m, e)));
                }
                else {
                    i = m;
                }
            }
            else {
                var o = Math.pow(10, Math.floor(log10(m - l)) - 1);
                var p = a.dv();
                if (a != null && p > 0 && (!a.js && !a.jr)) {
                    var q = new LinearNumericSnapper(0, h, i, p, a.d9());
                    o = q.g;
                }
                if ((isNaN_(b) || isInfinity(b)) && !isNaN_(h) && !isNaN_(o) && o != 0) {
                    {
                        h = o * Math.floor(h / o);
                    }
                }
                else {
                    h = l;
                }
                if ((isNaN_(c) || isInfinity(c)) && !isNaN_(i) && !isNaN_(o) && o != 0) {
                    var r = Math.ceil(i / o);
                    {
                        i = o * r;
                    }
                }
                else {
                    i = m;
                }
            }
        }
        f = h;
        g = i;
        return {
            p5: f,
            p6: g
        };
    };
    AutoRangeCalculator.$t = markType(AutoRangeCalculator, 'AutoRangeCalculator');
    return AutoRangeCalculator;
}(Base));
/**
 * @hidden
 */
var IAxisAnnotationManager_$type = /*@__PURE__*/ new Type(null, 'IAxisAnnotationManager');
/**
 * @hidden
 */
var AxisLabelSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelSettings, _super);
    function AxisLabelSettings() {
        var _this = _super.call(this) || this;
        _this.aa = null;
        _this.ax = null;
        _this.b = 1;
        _this.a2 = 0;
        _this.h = true;
        _this.c = 0;
        _this.a = null;
        _this.m = 0;
        _this.o = NaN;
        _this.p = 2;
        _this.q = 2;
        _this.r = 2;
        _this.n = 2;
        _this.au = 0;
        _this.az = 1;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.f = null;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.aq(a, b.propertyName, b.oldValue, b.newValue); });
        return _this;
    }
    Object.defineProperty(AxisLabelSettings.prototype, "textStyle", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.aa;
            this.aa = a;
            this.ar("TextStyle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "textColor", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            this.ar("TextColor", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "location", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            this.ar("Location", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, a));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "visibility", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            this.ar("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, a));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "showFirstLabel", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            this.ar("ShowFirstLabel", b, a);
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelSettings.prototype.registerAxis = function (a) {
        this.a = a;
    };
    AxisLabelSettings.prototype.unregisterAxis = function (a) {
        this.a = null;
    };
    Object.defineProperty(AxisLabelSettings.prototype, "angle", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            this.ar("Angle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "extent", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            this.ar("Extent", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "margin", {
        set: function (a) {
            this.topMargin = this.rightMargin = this.bottomMargin = this.leftMargin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "leftMargin", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            this.p = a;
            this.ar("LeftMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "rightMargin", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.q;
            this.q = a;
            this.ar("RightMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "topMargin", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            this.ar("TopMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "bottomMargin", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            this.ar("BottomMargin", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "horizontalAlignment", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            this.ar("HorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelSettings.prototype, "verticalAlignment", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            this.ar("VerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelSettings.prototype.ar = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    AxisLabelSettings.prototype.aq = function (a, b, c, d) {
        switch (b) {
            case "Location":
                this.c = this.location;
                break;
        }
        if (this.a == null || this.a.bd == null) {
            return;
        }
        switch (b) {
            case "Angle":
                this.a.cg = true;
                this.a.g5();
                break;
            case "TextStyle":
                this.f = null;
                this.a.cg = true;
                if (this.a.bf != null) {
                    this.a.bf.ht();
                }
                this.a.g5();
                break;
            case "Location":
            case "Extent":
            case "Visibility":
            case "HorizontalAlignment":
            case "VerticalAlignment":
            case "TopMargin":
            case "RightMargin":
            case "BottomMargin":
            case "LeftMargin":
            case "ShowFirstLabel":
                this.a.cg = true;
                if (this.a.bf != null) {
                    this.a.bf.ht();
                }
                this.a.g5();
                break;
            case "TextColor":
                this.a.g5();
                break;
        }
    };
    AxisLabelSettings.prototype.j = function () {
        return this.m != 0;
    };
    AxisLabelSettings.prototype.k = function () {
        return !isNaN_(this.o);
    };
    Object.defineProperty(AxisLabelSettings.prototype, "i", {
        get: function () {
            return this.textStyle != null;
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelSettings.prototype.g = function (a) {
        if (this.f == null) {
            this.f = FontUtil.toFontInfo(a, this.textStyle);
        }
        return this.f;
    };
    AxisLabelSettings.$t = markType(AxisLabelSettings, 'AxisLabelSettings', Base.$, [INotifyPropertyChanged_$type]);
    AxisLabelSettings.extentPropertyDefault = NaN;
    return AxisLabelSettings;
}(Base));
/**
 * @hidden
 */
var TitleSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TitleSettings, _super);
    function TitleSettings() {
        var _this = _super.call(this) || this;
        _this.a4 = 0;
        _this.horizontalAlignment = 1;
        _this.leftMargin = NaN;
        _this.rightMargin = NaN;
        _this.topMargin = NaN;
        _this.bottomMargin = NaN;
        return _this;
    }
    Object.defineProperty(TitleSettings.prototype, "position", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            this.ar("AxisTitlePosition", enumGetBox(AxisTitlePosition_$type, b), enumGetBox(AxisTitlePosition_$type, a));
        },
        enumerable: true,
        configurable: true
    });
    TitleSettings.prototype.aq = function (a, b, c, d) {
        _super.prototype.aq.call(this, a, b, c, d);
        if (this.a == null || this.a.bf == null) {
            return;
        }
        switch (b) {
            case "AxisTitlePosition":
                this.a.cg = true;
                this.a.g5();
                break;
        }
    };
    TitleSettings.$t = markType(TitleSettings, 'TitleSettings', AxisLabelSettings.$);
    return TitleSettings;
}(AxisLabelSettings));
/**
 * @hidden
 */
var Axis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Axis, _super);
    function Axis() {
        var _this = _super.call(this) || this;
        _this.a2 = null;
        _this.bq = null;
        _this.a6 = null;
        _this.a4 = null;
        _this.hj = null;
        _this.bk = null;
        _this.be = null;
        _this.bp = null;
        _this.bu = false;
        _this.c3 = NaN;
        _this.cy = 50;
        _this.c9 = 0;
        _this.c6 = 150;
        _this.ap = 0;
        _this.c2 = NaN;
        _this.dd = 0;
        _this.c8 = 0;
        _this.c5 = 180;
        _this.bh = null;
        _this.bg = null;
        _this.fa = "Verdana";
        _this.c4 = NaN;
        _this.df = 0;
        _this.da = 8;
        _this.c7 = 16;
        _this.ev = -1;
        _this.eu = 1;
        _this.et = 3;
        _this.ew = 0;
        _this.i7 = 0;
        _this.dc = 0;
        _this.db = 2;
        _this.hk = null;
        _this.dg = 0;
        _this.b9 = false;
        _this.rangeChanged = null;
        _this.ai = new AxisAnnotationCollection();
        _this.aj = new AxisAnnotationCollection();
        _this.iu = Rect.empty;
        _this.i0 = null;
        _this.cv = null;
        _this.cw = null;
        _this.at = null;
        _this.bt = false;
        _this.a3 = null;
        _this.es = null;
        _this._coercionMethods = null;
        _this.bs = false;
        _this.cj = false;
        _this.cq = false;
        _this.renderRequested = null;
        _this.a9 = null;
        _this.c0 = NaN;
        _this.c1 = -1;
        _this.ch = false;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.cx = null;
        _this.ct = new Dictionary$2(String_$type, String_$type, 0);
        _this.cs = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
        _this.i6 = new Size();
        _this.am = new AxisComponentsForView();
        _this.di = 0;
        _this.cz = 0;
        _this.bo = null;
        _this.bn = null;
        _this.bm = null;
        _this.au = new AxisLabelSettings();
        _this.er = null;
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        _this.di = NaN;
        _this.a2 = _this.a1();
        _this.gs(_this.a2);
        _this.a2.ag();
        _this.bo = ((function () {
            var $ret = new Pool$1(TextBlock.$);
            $ret.create = runOn(_this.a2, _this.a2.ax);
            $ret.activate = runOn(_this.a2, _this.a2.aq);
            $ret.disactivate = runOn(_this.a2, _this.a2.as);
            $ret.destroy = runOn(_this.a2, _this.a2.ar);
            return $ret;
        })());
        _this.bn = ((function () {
            var $ret = new Pool$1(TextBlock.$);
            $ret.create = runOn(_this.a2, _this.a2.ax);
            $ret.activate = runOn(_this.a2, _this.a2.aq);
            $ret.disactivate = runOn(_this.a2, _this.a2.as);
            $ret.destroy = runOn(_this.a2, _this.a2.ar);
            return $ret;
        })());
        _this.bm = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this.a2, _this.a2.bc);
            $ret.activate = runOn(_this.a2, _this.a2.p);
            $ret.disactivate = runOn(_this.a2, _this.a2.r);
            $ret.destroy = runOn(_this.a2, _this.a2.q);
            return $ret;
        })());
        _this.i0 = Rect.empty;
        _this.cv = new List$1(Base.$, 0);
        _this.cw = new List$1(LabelPosition.$, 0);
        _this.at = _this.as();
        _this.at.af = _this.aw;
        _this.at.ac = _this;
        _this.cx = new List$1(Series.$, 0);
        var a = _this.ai;
        a.collectionResetting = delegateCombine(a.collectionResetting, runOn(_this, _this.gc));
        var b = _this.ai;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.gb));
        var c = _this.aj;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(_this, _this.ge));
        var d = _this.aj;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(_this, _this.gd));
        _this.ab = Axis.$;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (e, f) { return _this.gu(e, f.propertyName, f.oldValue, f.newValue); });
        _this.bp = function (e, f) {
            if (_this.bf == null || !_this.bf.cn) {
                _this.hi(f.oldRect, f.newRect);
            }
        };
        _this.a2.v();
        return _this;
    }
    Axis.prototype.a1 = function () {
        return new AxisView(this);
    };
    Axis.prototype.gs = function (a) {
    };
    Axis.prototype.gf = function () {
        if (this.b1) {
            this.a5.onAddAnnotations(this);
        }
    };
    Object.defineProperty(Axis.prototype, "br", {
        get: function () {
            if (this.bq == null) {
                this.bq = new SRProvider(this.es);
            }
            if (this.bq.l == null) {
                this.bq.l = this.es;
            }
            return this.bq;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "a7", {
        get: function () {
            var _this = this;
            if (this.a6 == null) {
                this.a6 = DVContainer.instance.createInstance(IAxisVisualDataManager_$type, function () { return _this.br.q; });
            }
            return this.a6;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.dv = function () {
        return this.i1.width;
    };
    Axis.prototype.e9 = function () {
        return null;
    };
    Axis.prototype.e8 = function () {
        return null;
    };
    Axis.prototype.get_b2 = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "b2", {
        get: function () {
            return this.get_b2();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_ca = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "ca", {
        get: function () {
            return this.get_ca();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_b0 = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "b0", {
        get: function () {
            return this.get_b0();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_cc = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "cc", {
        get: function () {
            return this.get_cc();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_cf = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "cf", {
        get: function () {
            return this.get_cf();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_cd = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "cd", {
        get: function () {
            return this.get_cd();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_b5 = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "b5", {
        get: function () {
            return this.get_b5();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_cb = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "cb", {
        get: function () {
            return this.get_cb();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_b3 = function () {
        return false;
    };
    Object.defineProperty(Axis.prototype, "b3", {
        get: function () {
            return this.get_b3();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_b4 = function () {
        return true;
    };
    Object.defineProperty(Axis.prototype, "b4", {
        get: function () {
            return this.get_b4();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.ah = function () {
        return this.ag;
    };
    Object.defineProperty(Axis.prototype, "a5", {
        get: function () {
            var _this = this;
            if (this.a4 == null) {
                this.a4 = DVContainer.instance.createInstance(IAxisAnnotationManager_$type, function () { return _this.br.n; });
                this.a4.owner = this;
            }
            return this.a4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "b1", {
        get: function () {
            return DVContainer.instance.checkLoaded("AnnotationFactoryManager");
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.gd = function (a, b) {
        if (!this.b1) {
            return;
        }
        this.a5.onAutoAnnotionsChanged(this, this.aj, b);
    };
    Axis.prototype.ge = function (a, b) {
        if (!this.b1) {
            return;
        }
        this.a5.onAutoAnnotionsReset(this, this.aj, b);
    };
    Axis.prototype.gb = function (a, b) {
        if (!this.b1) {
            return;
        }
        this.a5.onAnnotionsChanged(this, this.ai, b);
    };
    Axis.prototype.gc = function (a, b) {
        if (!this.b1) {
            return;
        }
        this.a5.onAnnotionsReset(this, this.ai, b);
    };
    Axis.prototype.provideRenderer = function (a) {
        this.es = a;
        this.gg();
        this.at.af = this.aw;
    };
    Axis.prototype.gp = function (a, b) {
        if (!a.equals1(b)) {
            this.hh(a, b);
        }
    };
    Axis.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.a2.aj();
    };
    Object.defineProperty(Axis.prototype, "bl", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            if (this.bl != a) {
                var b = this.bl;
                this.bk = a;
                this.g0("FastItemsSourceProvider", b, this.bk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "bf", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            if (this.bf != a) {
                var b = this.bf;
                this.be = a;
                this.g0("SeriesViewer", b, this.be);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "bd", {
        get: function () {
            return typeCast(XamDataChart.$, this.bf);
        },
        set: function (a) {
            this.bf = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "cp", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            if (this.bu == a) {
                return;
            }
            this.bu = a;
            var b = null;
            if (this.at != null && Rect.l_op_Inequality(this.at.cn, null)) {
                b = this.at.cn;
            }
            this.at = this.as();
            this.at.ac = this;
            this.at.af = this.aw;
            if (Rect.l_op_Inequality(b, null)) {
                this.at.cn = b;
            }
            if (this.bf != null && this.bf.bn != null) {
                this.at.ae.ak(this.bf.bn.w);
                this.g4(true);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ed", {
        get: function () {
            return this.c3;
        },
        set: function (a) {
            var b = this.c3;
            if (b != a) {
                this.c3 = a;
                this.de = a;
                this.g4(true);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "de", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            this.cy = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ej", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            this.c9 = a;
            this.g4(true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "eg", {
        get: function () {
            return this.c6;
        },
        set: function (a) {
            this.c6 = a;
            this.g4(true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            if (b != a) {
                this.ap = a;
                this.g4(true);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ec", {
        get: function () {
            return this.c2;
        },
        set: function (a) {
            this.c2 = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ei", {
        get: function () {
            return this.c8;
        },
        set: function (a) {
            this.c8 = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ef", {
        get: function () {
            return this.c5;
        },
        set: function (a) {
            this.c5 = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "bj", {
        get: function () {
            if (this.bh == null) {
                if (this.bg == null) {
                    this.bg = this.a2.i();
                }
                return this.bg;
            }
            return this.bh;
        },
        set: function (a) {
            this.bh = a;
            this.c4 = FontUtil.getFontSize(this.bh);
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "fy", {
        get: function () {
            return this.fa;
        },
        set: function (a) {
            this.fa = a;
            var b = this.c4;
            if (isNaN_(b)) {
                b = 12;
            }
            this.bj.n = a;
            this.bj.d = b;
            this.at.bz();
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ee", {
        get: function () {
            return this.c4;
        },
        set: function (a) {
            this.c4 = a;
            this.bj = FontUtil.getFontWithNewFontSize(this.bj, this.c4);
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ek", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            this.da = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "eh", {
        get: function () {
            return this.c7;
        },
        set: function (a) {
            this.c7 = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "e0", {
        get: function () {
            return this.ev;
        },
        set: function (a) {
            this.ev = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ez", {
        get: function () {
            return this.eu;
        },
        set: function (a) {
            this.eu = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ey", {
        get: function () {
            return this.et;
        },
        set: function (a) {
            this.et = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "ja", {
        get: function () {
            return this.i7;
        },
        set: function (a) {
            this.i7 = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "em", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            this.dc = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "el", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            this.db = a;
            this.g3();
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.hb = function () {
        this.at.ce();
    };
    Axis.prototype.g3 = function () {
        this.g4(false);
    };
    Axis.prototype.g4 = function (a) {
        if (a) {
            this.at.cd();
        }
        this.cg = true;
        this.g2();
    };
    Axis.prototype.hd = function () {
        if (this.eo > 0) {
            this.dg = this.eo;
            return;
        }
        var a = typeCast(XamDataChart.$, this.bf);
        if (a != null && isNaN_(this.eo) && this.b2 && (this.cf || this.az == 0)) {
            this.dg = a.nj.ff;
            return;
        }
        this.dg = 0;
    };
    Object.defineProperty(Axis.prototype, "co", {
        get: function () {
            return this.c(Axis.ic);
        },
        set: function (a) {
            this.h(Axis.ic, a);
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.dk = function () {
        return 0;
    };
    Axis.prototype.id = function () {
        if (this.cf) {
            return 2;
        }
        return 0;
    };
    Axis.prototype.i8 = function () {
        return 1;
    };
    Axis.prototype.ie = function () {
        return 1;
    };
    Axis.prototype.i9 = function () {
        return 1;
    };
    Axis.prototype.dm = function () {
        if (this.cf) {
            return DeviceUtils.g(5);
        }
        return 0;
    };
    Axis.prototype.dp = function () {
        if (!this.cf && !this.b0) {
            return DeviceUtils.g(5);
        }
        return 0;
    };
    Axis.prototype.dn = function () {
        if (this.cf) {
            return DeviceUtils.g(5);
        }
        return 0;
    };
    Axis.prototype.dl = function () {
        if (!this.cf && !this.b0) {
            return DeviceUtils.g(5);
        }
        return 0;
    };
    Axis.prototype.ds = function () {
        return NaN;
    };
    Axis.prototype.du = function () {
        return NaN;
    };
    Axis.prototype.dt = function () {
        return NaN;
    };
    Axis.prototype.dr = function () {
        return NaN;
    };
    Axis.prototype.ax = function () {
        if (this.cf) {
            return 2;
        }
        if (this.cc) {
            return 5;
        }
        return 1;
    };
    Axis.prototype.ay = function () {
        return 1;
    };
    Axis.prototype.g1 = function (a) {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, a);
        }
    };
    Axis.prototype.dq = function () {
        if (this.cf) {
            return -90;
        }
        return 0;
    };
    Axis.prototype.dj = function () {
        return NaN;
    };
    Object.defineProperty(Axis.prototype, "ak", {
        get: function () {
            return this.ai;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "al", {
        get: function () {
            return this.aj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "i1", {
        get: function () {
            if (this.i0.isEmpty) {
                return this.iu;
            }
            return this.i0;
        },
        set: function (a) {
            this.iu = a;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.he = function () {
        var a = 0;
        var b = typeCast(XamDataChart.$, this.bf);
        if (b != null && b.ng == 0) {
            a = 1;
        }
        this.a2.av(a);
    };
    Axis.prototype.cr = function (a, b, c) {
        return this.bf != null;
    };
    Axis.prototype.ce = function () {
        var a = Rect.empty;
        if (this.bf != null) {
            a = this.bf.m4;
        }
        return this.cr(this.i1, a, this.a2);
    };
    Axis.prototype.hh = function (a, b) {
        this.i1 = b;
        this.cg = true;
        this.cl();
        this.g6(false);
        if (this.bf != null) {
            this.bf.al.ad(1, this, this.a3, b);
        }
    };
    Object.defineProperty(Axis.prototype, "cg", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            this.bt = a;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.iy = function () {
        if (this.bf == null || this.bf.mu.isEmpty) {
            return Rect.empty;
        }
        var a = this.bf.mu;
        var b = this.i1;
        var c = (a.left - b.left) / b.width;
        var d = (a.top - b.top) / b.height;
        var e = (a.right - b.left) / b.width;
        var f = (a.bottom - b.top) / b.height;
        return new Rect(0, c, d, e - c, f - d);
    };
    Axis.prototype.hi = function (a, b) {
        this.cg = true;
        this.g6(true);
    };
    Axis.prototype.g2 = function () {
        this.g6(false);
    };
    Axis.prototype.gu = function (a, b, c, d) {
        var e_17, _a;
        switch (b) {
            case "SeriesViewer":
                var e = typeCast(SeriesViewer.$, c);
                if (e != null) {
                    this.es = null;
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, this.bp);
                    e.al.ac(1, this);
                    this.a2.aa(e);
                }
                var f = typeCast(SeriesViewer.$, d);
                if (f != null) {
                    this.es = f.bn.i.ae;
                    f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, this.bp);
                    this.a3 = f.al.k(1, this, runOn(this, this.gk));
                    if (this.aw == null && this.es != null) {
                        this.provideRenderer(this.es);
                    }
                    this.a2.u(f);
                    if (this.ch && !this.a3.e) {
                        this.ch = false;
                        this.cl();
                    }
                    this.hc();
                    this.hd();
                }
                break;
            case Axis.$$p[7]:
                this.g6(false);
                break;
            case Axis.$$p[8]:
                this.b9 = this.b8;
                var g = new AxisRangeChangedEventArgs(0, 0, 0, 1, 1);
                this.gj(g);
                try {
                    for (var _b = __values(fromEnum(this.cx)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        h.ib();
                        if (h.bs != null) {
                            h.ik();
                        }
                    }
                }
                catch (e_17_1) {
                    e_17 = { error: e_17_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_17)
                            throw e_17.error;
                    }
                }
                break;
            case Axis.$$p[9]:
                this.a2.ah();
                if (typeCast(DataTemplate.$, d) !== null) {
                    this.cq = true;
                }
                else {
                    this.cq = false;
                }
                this.cg = true;
                this.g9();
                this.g6(false);
                break;
            case Axis.$$p[13]:
            case Axis.$$p[16]:
            case Axis.$$p[20]:
                this.g6(false);
                break;
            case Axis.$$p[10]:
                var i = typeCast(AxisLabelSettings.$, d);
                if (i != null) {
                    i.registerAxis(this);
                    this.au = i;
                }
                else {
                    this.au = new AxisLabelSettings();
                }
                if (this.at != null) {
                    this.at.af = this.au;
                }
                if (this.a2.m()) {
                    this.a2.w(this.au);
                }
                this.cg = true;
                this.g6(false);
                break;
            case Axis.$$p[25]:
                this.a2.ak();
                break;
            case Axis.$$p[26]:
                var j = typeCast(TitleSettings.$, d);
                if (j != null) {
                    j.registerAxis(this);
                }
                else {
                    j = new TitleSettings();
                }
                if (this.hk != null) {
                    this.hk.dataContext = j;
                }
                this.a2.ak();
                this.g6(false);
                break;
            case Axis.$$p[21]:
                this.cg = true;
                this.hd();
                this.a2.ad();
                this.g6(false);
                break;
            case Axis.$$p[5]:
            case "UseEnhancedIntervalManagement":
                this.cg = true;
                this.g6(false);
                break;
            case Axis.$$p[3]:
                if (this.bf != null) {
                    this.bf.ht();
                }
                break;
            case Axis.$$p[15]:
                this.hc();
                if (d != null) {
                    this.cj = true;
                    this.g6(false);
                }
                else {
                    this.cj = false;
                }
                break;
            case Axis.$$p[4]:
                if (this.ag != null) {
                    this.ag.g5();
                }
                break;
            case Axis.$$p[19]:
            case Axis.$$p[12]:
                this.hc();
                this.g6(false);
                break;
            case Axis.$$p[18]:
            case Axis.$$p[11]:
            case Axis.$$p[14]:
            case Axis.$$p[6]:
            case Axis.$$p[23]:
            case Axis.$$p[24]:
            case Axis.$$p[22]:
            case Axis.$$p[2]:
            case Axis.$$p[0]:
            case Axis.$$p[1]:
            case Axis.$$p[17]:
                this.g6(false);
                break;
            case "MinExtent":
                this.a2.ad();
                break;
        }
    };
    Object.defineProperty(Axis.prototype, "coercionMethods", {
        get: function () {
            return this._coercionMethods;
        },
        set: function (a) {
            this._coercionMethods = a;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.get_expectFunctions = function () {
        return this.bs;
    };
    Axis.prototype.set_expectFunctions = function (a) {
        this.bs = a;
    };
    Object.defineProperty(Axis.prototype, "expectFunctions", {
        get: function () {
            return this.get_expectFunctions();
        },
        set: function (a) {
            this.set_expectFunctions(a);
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.g9 = function () {
        this.bo.count = 0;
        this.bn.count = 0;
        this.bm.count = 0;
        if (this.a2.m()) {
            this.a2.an();
        }
    };
    Axis.prototype.gr = function (a, b, c, d) {
        var e = Math.min(b, c);
        var f = Math.max(b, c);
        if (e < d.bottom && f > d.top) {
            var g = new RectangleGeometry();
            g.e = new Rect(0, d.left, e, d.width, f - e);
            a.add(g);
        }
    };
    Axis.prototype.gq = function (a, b, c, d, e) {
        var f = b <= c.bottom && b >= c.top;
        if (!e && f) {
            f = !this.b7(b, d.c, c, false);
        }
        if (f) {
            if (d.a) {
                b = this.dh(b, c.top, c.bottom, d);
            }
            var g = new LineGeometry();
            g.d = { $type: Point_$type, x: c.left, y: b };
            g.c = { $type: Point_$type, x: c.right, y: b };
            a.add(g);
        }
    };
    Axis.prototype.hg = function (a, b, c, d) {
        var e = Math.min(b, c);
        var f = Math.max(b, c);
        if (f > d.left && e < d.right) {
            var g = new RectangleGeometry();
            g.e = new Rect(0, e, d.top, f - e, d.height);
            a.add(g);
        }
    };
    Axis.prototype.hf = function (a, b, c, d, e) {
        var f = b >= c.left && b <= c.right;
        if (!f) {
            var g = truncate(Math.round(b));
            var h = truncate(Math.round(c.left));
            var i = truncate(Math.round(c.right));
            if (g >= h && g <= i) {
                f = true;
            }
        }
        if (!e && f) {
            f = !this.b7(b, d.c, c, true);
        }
        if (f) {
            if (d.a) {
                b = this.dh(b, c.left, c.right, d);
            }
            var j = new LineGeometry();
            j.d = { $type: Point_$type, x: b, y: c.top };
            j.c = { $type: Point_$type, x: b, y: c.bottom };
            a.add(j);
        }
    };
    Axis.prototype.b7 = function (a, b, c, d) {
        var e_18, _a;
        var e = false;
        var f = typeCast(XamDataChart.$, this.bf);
        if (f != null && f.nu && !c.isEmpty) {
            try {
                for (var _b = __values(fromEnum(f.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    if (g._visibility != 0 || g.en < 1 || g.ii == null || BrushUtilCore.a(g.ii) || g.i1.isEmpty) {
                        continue;
                    }
                    if (g.ag != null && g.by()) {
                        var h = this.cf ? c.left : c.top;
                        var i = 0;
                        var j = g.ha(h, i, g.bf.m4, c, g.iw(), d ? c.left : c.top, d ? c.right : c.bottom);
                        h = j.p0;
                        i = j.p1;
                        var k = Rect.empty;
                        var l = Rect.empty;
                        if (d && g.cf) {
                            k = new Rect(0, h - (g.en / 2), g.i1.top, g.en, g.i1.height);
                            l = new Rect(0, a - (b / 2), c.top, b, c.height);
                        }
                        else if (!d && !g.cf) {
                            k = new Rect(0, g.i1.left, h - (g.en / 2), g.i1.width, g.en);
                            l = new Rect(0, c.left, a - (b / 2), c.width, b);
                        }
                        if (k.left <= l.right && l.left <= k.right && k.top <= l.bottom && l.top <= k.bottom) {
                            e = true;
                            break;
                        }
                    }
                    else {
                        var m = Rect.empty;
                        var n = Rect.empty;
                        if (d && g.cf) {
                            m = new Rect(0, g.i1.left, g.i1.top, g.en, g.i1.height);
                            n = new Rect(0, a - (b / 2), c.top, b, c.height);
                        }
                        else if (!d && !g.cf) {
                            m = new Rect(0, g.i1.left, g.i1.bottom - (g.en / 2), g.i1.width, g.en);
                            n = new Rect(0, c.left, a - (b / 2), c.width, b);
                        }
                        if (m.left <= n.right && n.left <= m.right && m.top <= n.bottom && n.top <= m.bottom) {
                            e = true;
                            break;
                        }
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        return e;
    };
    Axis.prototype.ha = function (a, b, c, d, e, f, g) {
        var h = Math.abs(f - g);
        a = this.e2;
        a = this.ag.eb(a);
        var i = typeCast(CategoryAxisBase.$, this.ag);
        if (i != null && i.categoryMode == 2) {
            var j = 0.5 * i.getCategorySize(c, d, e);
            var k = i.az == 0;
            if (i.b8 == k) {
                j = -j;
            }
            a = a + j;
        }
        b = a - f;
        if (a < f) {
            a = f;
        }
        else if (a > g) {
            a = g;
        }
        if (b < 0) {
            b = 0;
        }
        else if (b > h) {
            b = h;
        }
        return {
            p0: a,
            p1: b
        };
    };
    Axis.prototype.dh = function (a, b, c, d) {
        var e = a;
        if (d != null && d.c > 0) {
            var f = d.c % 2;
            if (f == 0 || f == 1) {
                var g = 1;
                e = Math.floor(a);
                if (e + 0.5 < a) {
                    g = -1;
                    e = Math.ceil(a);
                }
                if (f == 1) {
                    e += 0.5 * g;
                }
                if (e >= c) {
                    e -= 1;
                }
                else if (e <= b) {
                    e += 1;
                }
            }
        }
        return e;
    };
    Axis.prototype.gi = function (a) {
        this.a2.z(a);
    };
    Axis.prototype.gh = function () {
        this.bo.count = 0;
        this.bn.count = 0;
        this.bm.count = 0;
        this.a2.x();
        this.cv.clear();
        this.cw.clear();
    };
    Axis.prototype.g5 = function () {
        this.g6(false);
    };
    Axis.prototype.g6 = function (a) {
        if (this.bf != null) {
            this.bf.al.ab(1, this, this.a3, a);
            if (this.renderRequested != null) {
                var b = new RenderRequestedEventArgs();
                b.animate = a;
                this.renderRequested(this, b);
                a = b.animate;
            }
        }
    };
    Axis.prototype.ea = function () {
        if (this.a9 == null) {
            return -1;
        }
        if (isNaN_(this.a9.a)) {
            return -1;
        }
        if (this.aw != null && (this.aw.angle != 0)) {
            return -1;
        }
        return Math.max(Axis.d5, this.a9.a);
    };
    Axis.prototype.d8 = function () {
        if (this.a9 == null) {
            return -1;
        }
        if (isNaN_(this.a9.c) && isNaN_(this.c0)) {
            return -1;
        }
        if (this.aw != null && (this.aw.angle != 0)) {
            return -1;
        }
        var a = this.a9.c;
        if (!isNaN_(this.c0) && this.ex == -1) {
            return this.c0;
        }
        return Math.max(Axis.d5, this.a9.c);
    };
    Axis.prototype.d9 = function () {
        if (this.cf) {
            return this.ea();
        }
        else {
            return this.d8();
        }
    };
    Object.defineProperty(Axis.prototype, "ck", {
        get: function () {
            return this.ex == -1;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.gk = function (a) {
        if (this.a2.l()) {
            return;
        }
        var b = 0;
        var c = 0;
        if (this.cw != null && this.cw.count > 0) {
            b = this.cw._inner[this.cw.count - 1].c;
            c = this.cw.count;
        }
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        this.g7(a);
        if (!this.cf && this.cg && this.co && this.ck) {
            if (this.bw()) {
                this.g7(a);
            }
        }
        var d = 1;
        var e = 0;
        if (this.cw != null && this.cw.count > 0) {
            d = this.cw._inner[this.cw.count - 1].c;
            e = this.cw.count;
        }
        if (this.cp) {
            this.cg = true;
        }
        var f = false;
        if (d != b || e != c || this.cg) {
            this.cg = false;
            if (this.a2.m()) {
                this.a2.ad();
                f = true;
            }
        }
        this.a2.ac();
        if (!f) {
            this.gl();
        }
    };
    Axis.prototype.bw = function () {
        if (!isNaN_(this.c0) || this.cv == null || this.cv.count == 0) {
            return false;
        }
        var a = this.bi();
        if (a == null) {
            return false;
        }
        var b = -1.7976931348623157E+308;
        for (var c = 0; c < this.cv.count; c++) {
            var d = this.cv._inner[c];
            if (typeof d === 'string') {
                var e = FontUtil.measureStringWidth(d, a, this.a2.j);
                b = Math.max(e, b);
            }
        }
        b += 5;
        if (this.aw != null) {
            b += this.aw.leftMargin + this.aw.rightMargin;
        }
        this.c0 = b;
        return true;
    };
    Axis.prototype.g8 = function () {
        this.c0 = NaN;
        this.g6(false);
    };
    Axis.prototype.a8 = function () {
        var a = this.bi();
        if (a == null) {
            return null;
        }
        var b = "W";
        var c = FontUtil.measureStringWidth(b, a, this.a2.j);
        if (this.c1 != c || this.a9 == null) {
            this.c1 = c;
            var d = FontUtil.getCurrentFontHeight(this.bf.bn.i.ae, a);
            if (this.a9 == null) {
                this.a9 = new LabelFontHeuristics();
            }
            this.a9.a = d;
            this.a9.b = this.ex;
            this.a9.d = c;
            this.a9.c = this.a9.d * this.a9.b;
        }
        return this.a9;
    };
    Axis.prototype.bi = function () {
        var a = null;
        if (this.bf != null) {
            a = this.bf.getFontInfo();
        }
        if (this.aw != null && this.aw.i) {
            if (this.bf != null) {
                a = this.aw.g(this.bf.bn.i.ae);
            }
        }
        return a;
    };
    Axis.prototype.gl = function () {
        if (!this.a2.m()) {
            return;
        }
        if (!this.bz()) {
            this.a2.ab();
        }
    };
    Axis.prototype.cl = function () {
        return this.cm(false);
    };
    Axis.prototype.cm = function (a) {
        if (a || this.bf == null) {
            var b = this.cn();
            if (b) {
                this.cg = true;
            }
            this.ch = false;
            return b;
        }
        if (!this.ch) {
            this.ch = true;
            this.bf.al.aa(this, this.a3);
        }
        return false;
    };
    Axis.prototype.cn = function () {
        return false;
    };
    Axis.prototype.g7 = function (a) {
        if (this.hk != null) {
            if ((this.bc == null || this.bc.visibility == 0) && (this.aw == null || this.aw.visibility == 0) && this.f7 != null) {
                this.hk._visibility = 0;
            }
            else {
                this.hk._visibility = 1;
            }
        }
    };
    Axis.prototype.hc = function () {
        var e_19, _a, e_20, _b;
        var a = typeCast(XamDataChart.$, this.bf);
        if (a == null) {
            return;
        }
        var b = null, c = null, d = null;
        if (this.b2 && !this.b0) {
            b = a.po;
            try {
                for (var _c = __values(fromEnum(this.cx)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    if (e.c4 || e.c2 || e.c0 || e.c2) {
                        c = a.pm;
                        d = a.pn;
                        break;
                    }
                }
            }
            catch (e_19_1) {
                e_19 = { error: e_19_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_19)
                        throw e_19.error;
                }
            }
        }
        else if (this.ca && !this.b0) {
            c = a.pm;
            d = a.pn;
            b = this.ag != null ? a.po : null;
            try {
                for (var _e = __values(fromEnum(this.cx)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var f = _f.value;
                    if (f.c4 || f.c2 || f.c0 || f.c2) {
                        b = a.po;
                        break;
                    }
                }
            }
            catch (e_20_1) {
                e_20 = { error: e_20_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_20)
                        throw e_20.error;
                }
            }
        }
        else if (this.b0 || this.az == 3) {
            b = a.po;
            c = a.pm;
            d = a.pn;
        }
        this.ii = this.im != null ? this.im : b;
        this.ig = this.ij != null ? this.ij : c;
        this.ih = this.ik != null ? this.ik : d;
    };
    Axis.prototype.g0 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    Axis.prototype.ci = function (a) {
        var b = this.cx.contains(a);
        if (!b) {
            this.cx.add(a);
        }
        this.hc();
        return !b;
    };
    Axis.prototype.bv = function (a) {
        var b = this.cx.contains(a);
        if (b) {
            this.cx.remove(a);
        }
        this.hc();
        return b;
    };
    Axis.prototype.e4 = function (a, b) {
        var c = this.fv(b);
        if (c == Axis.$$p[9]) {
            return this.e5(a, b, this.e7);
        }
        return null;
    };
    Axis.prototype.fv = function (a) {
        if (!this.ct.containsKey(a)) {
            var b = a.charAt(0).toUpperCase() + a.substr(1);
            this.ct.addItem(a, b);
        }
        return this.ct.item(a);
    };
    Axis.prototype.e5 = function (a, b, c) {
        var d = null;
        if (!this.cs.containsKey(b)) {
            d = new FastReflectionHelper(false, c);
            this.cs.addItem(b, d);
        }
        else {
            d = this.cs.item(b);
        }
        d.propertyName = c;
        return d.getPropertyValue(a);
    };
    Axis.prototype.e6 = function (a) {
        return this.a2.n(a);
    };
    Axis.prototype.fj = function (a) {
        return this.a2.o(a);
    };
    Axis.prototype.d7 = function () {
        return NaN;
    };
    Axis.prototype.dw = function (a, b) {
        return 0;
    };
    Axis.prototype.dx = function (a, b, c) {
        return 0;
    };
    Axis.prototype.ix = function (a) {
        if (this.bf == null) {
            return Rect.empty;
        }
        if (!a.equals1(this.i1)) {
            return Rect.empty;
        }
        return this.bf.mu;
    };
    Axis.prototype.iw = function () {
        if (this.bf == null) {
            return Rect.empty;
        }
        return this.bf.mu;
    };
    Axis.prototype.iv = function () {
        if (this.bf == null || this.bf.mt.isEmpty) {
            return this.i1;
        }
        return this.bf.mt;
    };
    Axis.prototype.iz = function (a, b) {
        if (b.isEmpty) {
            return a;
        }
        return b;
    };
    Axis.prototype.dy = function (a, b, c) {
        var d = this.ix(c);
        var e = new ScalerParams(0, b, c, this.b8, d);
        return this.dw(a, e);
    };
    Axis.prototype.gn = function (a, b, c, d) {
    };
    Axis.prototype.gm = function (a, b, c, d, e) {
    };
    Axis.prototype.dz = function (a, b) {
        return 0;
    };
    Axis.prototype.d0 = function (a, b, c) {
        return 0;
    };
    Axis.prototype.d1 = function (a, b, c) {
        var d = this.ix(c);
        var e = new ScalerParams(0, b, c, this.b8, d);
        return this.dz(a, e);
    };
    Axis.prototype.go = function (a, b, c, d) {
    };
    Axis.prototype.eb = function (a) {
        var b = this.iw();
        var c = new ScalerParams(0, this.bf.m4, this.i1, this.b8, b);
        return this.dw(a, c);
    };
    Axis.prototype.gt = function () {
        this.i0 = new Rect(0, 0, 0, this.i6.width, this.i6.height);
    };
    Axis.prototype.an = function () {
        this.am.a = this.at;
        return this.am;
    };
    Object.defineProperty(Axis.prototype, "d4", {
        get: function () {
            return this.cz;
        },
        set: function (a) {
            var b = this.d4;
            if (a != b) {
                this.cz = a;
                this.g0("MinExtent", b, this.d4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.bz = function () {
        if (!isNaN_(this.di)) {
            return true;
        }
        if (this.aw == null) {
            return false;
        }
        else {
            return this.aw.k();
        }
    };
    Axis.prototype.d2 = function () {
        if (!isNaN_(this.di)) {
            return this.di;
        }
        if (this.aw == null) {
            return 50;
        }
        return this.aw.extent;
    };
    Axis.prototype.gg = function () {
        this.a2.t();
    };
    Axis.prototype.gj = function (a) {
        this.g1(a);
    };
    Object.defineProperty(Axis.prototype, "i2", {
        get: function () {
            return this.ao().a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "i3", {
        get: function () {
            return this.ao().b;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "i5", {
        get: function () {
            return this.a2.c().d;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Axis.prototype, "i4", {
        get: function () {
            return this.ao().c;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.bb = function () {
        return SyncManager.a(this.be);
    };
    Axis.prototype.ao = function () {
        return this.a2.c();
    };
    Object.defineProperty(Axis.prototype, "av", {
        get: function () {
            return this.au;
        },
        enumerable: true,
        configurable: true
    });
    Axis.prototype.gv = function (a, b) {
        if (this.at != null) {
            this.at.b9(a);
        }
        this.a2.af(a, b);
    };
    Axis.prototype.by = function () {
        return this.e2 != null;
    };
    Axis.prototype.e3 = function () {
        return this.a7.exportVisualData(this);
    };
    Axis.prototype._cu = function () {
        var a, b;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = 0;
                    _a.label = 1;
                case 1:
                    if (!(a < this.cx.count))
                        return [3 /*break*/, 4];
                    b = this.cx._inner[a];
                    return [4 /*yield*/, b];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    a++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    Axis.prototype.cu = function () {
        var _this = this;
        return toEnum(function () { return _this._cu(); });
    };
    Axis.prototype.gw = function (a) {
    };
    Axis.prototype.gz = function (a) {
    };
    Axis.prototype.gy = function (a) {
    };
    Axis.prototype.it = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        if (this.cf) {
            var f = new LineGeometry();
            f.d = { $type: Point_$type, x: c.left, y: a };
            f.c = { $type: Point_$type, x: c.right, y: a };
            return f;
        }
        else {
            var g = new LineGeometry();
            g.d = { $type: Point_$type, x: a, y: c.bottom };
            g.c = { $type: Point_$type, x: a, y: c.top };
            return g;
        }
    };
    Axis.$t = markType(Axis, 'Axis', Control.$, [INotifyPropertyChanged_$type]);
    Axis.ic = DependencyProperty.i("UseEnhancedIntervalManagement", Boolean_$type, Axis.$, new PropertyMetadata(2, false, function (a, b) { return a.g0("UseEnhancedIntervalManagement", b.oldValue, b.newValue); }));
    Axis.d5 = 7;
    Axis.$$p = markDep(DependencyProperty, PropertyMetadata, Axis, 'g0', ['ActualMajorStroke:ig:hl', [Brush.$], 'ActualMinorStroke:ih:hm', [Brush.$], 'ActualStroke:ii:hn', [Brush.$], 'CrossingAxis:ag:ho', [Axis.$], 'CrossingValue:e2:hp', [4, null], 'EnhancedIntervalMinimumCharacters:ex:hq', [1, -1], 'FormatLabel:ar:hr', [Delegate_$type], 'IsDisabled:b6:hs', [0, false], 'IsInverted:b8:ht', [0, false], 'Label:e7:hu', [4, null], 'LabelSettings:aw:hv', [AxisLabelSettings.$, null], 'MajorStrokeDashArray:ip:hw', [DoubleCollection.$], 'MajorStroke:ij:hx', [Brush.$], 'MajorStrokeThickness:d3:hy', [1, 1], 'MinorStrokeDashArray:iq:hz', [DoubleCollection.$], 'MinorStroke:ik:h0', [Brush.$], 'MinorStrokeThickness:d6:h1', [1, 1], 'Strip:il:h2', [Brush.$], 'StrokeDashArray:ir:h3', [DoubleCollection.$], 'Stroke:im:h4', [Brush.$], 'StrokeThickness:en:h5', [1, DeviceUtils.g(2)], 'TickLength:eo:h6', [1, NaN], 'TickStrokeDashArray:is:h7', [DoubleCollection.$], 'TickStroke:io:h8', [Brush.$], 'TickStrokeThickness:ep:h9', [1, DeviceUtils.g(2)], 'Title:f7:ia', [2], 'TitleSettings:bc:ib', [TitleSettings.$, null]]);
    return Axis;
}(Control));
/**
 * @hidden
 */
var AxisCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisCollection, _super);
    function AxisCollection() {
        var _this = _super.call(this, Axis.$, 0) || this;
        _this.collectionResetting = null;
        _this.propertyChanged = delegateCombine(_this.propertyChanged, function (a, b) {
            if (b.propertyName == "Name") {
                for (var c = 0; c < _this.count; ++c) {
                    if (_this._inner[c].name == b.propertyName) {
                        _this.ac(new NotifyCollectionChangedEventArgs(2, 2, _this._inner[c], _this._inner[c], c));
                    }
                }
            }
        });
        return _this;
    }
    AxisCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    AxisCollection.$t = markType(AxisCollection, 'AxisCollection', ObservableCollection$1.$.specialize(Axis.$));
    return AxisCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var AxisLabelManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelManager, _super);
    function AxisLabelManager() {
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.f = null;
        _this.b = null;
        _this.a = null;
        _this.c = null;
        _this.c = function (a) {
        };
        return _this;
    }
    AxisLabelManager.prototype.m = function (a, b) {
        this.e.clear();
        this.f.clear();
        this.b.ac = this.a;
        this.b.cp = a;
        this.b.co = b;
        if (b.isEmpty || a.isEmpty) {
            this.r(0);
            this.a.bn.count = 0;
            this.a.bm.count = 0;
        }
        if (this.a.bo.count == 0 && this.a.bn.count == 0) {
            this.b.ab.clear();
        }
    };
    AxisLabelManager.prototype.i = function (a, b) {
        this.e.add1(a);
        this.f.add(b);
    };
    AxisLabelManager.prototype.s = function () {
        this.b.a1 = this.e;
        this.b.a2 = this.f;
    };
    AxisLabelManager.j = function (a) {
        AxisLabelManager.k(a, false);
    };
    AxisLabelManager.k = function (a, b) {
    };
    AxisLabelManager.l = function (a) {
        AxisLabelManager.k(a, true);
    };
    AxisLabelManager.prototype.h = function (a) {
        this.b.ab.add(a);
    };
    AxisLabelManager.prototype.q = function (a) {
        this.b.bn = a;
    };
    AxisLabelManager.prototype.n = function (a) {
        this.c(a);
    };
    AxisLabelManager.prototype.t = function (a) {
        var b = this.a.bo.item(a);
        return b;
    };
    AxisLabelManager.prototype.r = function (a) {
        if (this.a == null) {
            return;
        }
        this.a.bo.count = a;
    };
    Object.defineProperty(AxisLabelManager.prototype, "d", {
        get: function () {
            if (this.a == null || this.a.aw == null) {
                return false;
            }
            return this.a.aw.visibility != 0;
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelManager.prototype.p = function () {
        this.a.bo.count = 0;
        this.a.bn.count = 0;
        this.a.bm.count = 0;
        this.a.at.a3.clear();
    };
    AxisLabelManager.prototype.o = function () {
        this.a.cg = true;
    };
    AxisLabelManager.prototype.g = function () {
        this.a.gf();
    };
    AxisLabelManager.$t = markType(AxisLabelManager, 'AxisLabelManager');
    return AxisLabelManager;
}(Base));
/**
 * @hidden
 */
var AxisLabelPanelBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelPanelBase, _super);
    function AxisLabelPanelBase() {
        var _this = _super.call(this) || this;
        _this.cl = null;
        _this.bn = 0;
        _this.ac = null;
        _this.aj = false;
        _this.ax = null;
        _this.a2 = null;
        _this.co = null;
        _this.ck = Rect.empty;
        _this.cj = null;
        _this.a4 = 0;
        _this.bo = null;
        _this.a3 = null;
        _this.a0 = null;
        _this.af = null;
        _this.am = false;
        _this.ap = false;
        _this.aq = false;
        _this.ar = false;
        _this.bq = null;
        _this.ak = false;
        _this.a5 = 50;
        _this.a6 = 0;
        _this.a7 = 0;
        _this.a6 = NaN;
        _this.co = Rect.empty;
        _this.cn = Rect.empty;
        _this.ae = _this.ad();
        _this.b8(_this.ae);
        _this.ae.am();
        _this.a3 = new List$1(FrameworkElement.$, 0);
        _this.a2 = new List$1(LabelPosition.$, 0);
        _this.a0 = new List$1(Rect.$, 0);
        _this.aq = false;
        _this.ap = false;
        _this.ar = false;
        _this.am = false;
        _this.aj = false;
        return _this;
    }
    AxisLabelPanelBase.prototype.ad = function () {
        return new AxisLabelPanelBaseView(this);
    };
    AxisLabelPanelBase.prototype.b8 = function (a) {
    };
    AxisLabelPanelBase.prototype.bz = function () {
    };
    AxisLabelPanelBase.prototype.ce = function () {
    };
    AxisLabelPanelBase.prototype.cd = function () {
    };
    Object.defineProperty(AxisLabelPanelBase.prototype, "at", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            this.aj = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelPanelBase.prototype, "a1", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b == null && b != a) {
                this.b5();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelPanelBase.prototype, "cp", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            this.ch(b, this.ck);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelPanelBase.prototype, "cn", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            this.b4(b, this.cj);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelPanelBase.prototype, "a8", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            this.a4 = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelPanelBase.prototype.al = function (a, b) {
        for (var c = 0; c < a.count - 1; c++) {
            if (b._inner[c]) {
                continue;
            }
            for (var d = c; d < a.count - 1; d++) {
                if (b._inner[d + 1]) {
                    continue;
                }
                if (a._inner[c].intersectsWith(a._inner[d + 1])) {
                    return true;
                }
            }
        }
        return false;
    };
    AxisLabelPanelBase.prototype.bp = function (a, b, c) {
        return {
            ret: 0,
            p1: b
        };
    };
    AxisLabelPanelBase.prototype.ay = function () {
        return null;
    };
    AxisLabelPanelBase.prototype.bx = function () {
    };
    AxisLabelPanelBase.prototype.bt = function (a) {
    };
    AxisLabelPanelBase.prototype.bd = function () {
        return this.af != null ? this.af.angle : 0;
    };
    AxisLabelPanelBase.prototype.bh = function () {
        return this.ac.bc != null ? this.ac.bc.angle : 0;
    };
    AxisLabelPanelBase.prototype.ao = function (a, b) {
        if (a == 0 && !this.ac.b0 && this.af != null) {
            if (this.ac.cf) {
                if (!this.af.showFirstLabel && this.ac.bf.eh() == 1) {
                    return false;
                }
            }
            else {
                if (!this.af.showFirstLabel && this.ac.bf.eg() == 1) {
                    return false;
                }
            }
        }
        return true;
    };
    AxisLabelPanelBase.prototype.bc = function (a) {
        return this.ae.m(a);
    };
    AxisLabelPanelBase.prototype.bm = function (a) {
        return this.ae.w(a);
    };
    AxisLabelPanelBase.prototype.be = function (a) {
        return this.ae.n(a);
    };
    AxisLabelPanelBase.prototype.bb = function (a) {
        return this.ae.l(a);
    };
    AxisLabelPanelBase.prototype.an = function () {
        return false;
    };
    AxisLabelPanelBase.prototype.ch = function (a, b) {
    };
    AxisLabelPanelBase.prototype.b4 = function (a, b) {
    };
    AxisLabelPanelBase.prototype.az = function () {
        if (this.ab.count < 1 || this.a2.count == 0) {
            return new List$1(Rect.$, 0);
        }
        this.a3 = new List$1(FrameworkElement.$, 0);
        this.a0 = new List$1(Rect.$, 0);
        this.bx();
        this.ae.ae();
        var a = this.bd();
        if (a % 360 == 0) {
            this.ap = false;
        }
        if (this.a3.count == 0) {
            return new List$1(Rect.$, 0);
        }
        this.a0 = this.ay();
        this.aj = true;
        return this.a0;
    };
    AxisLabelPanelBase.prototype.bg = function (a, b) {
        var c = a * (Math.PI / 180);
        var d = Math.abs(b.width * Math.cos(c)) + Math.abs(b.height * Math.sin(c));
        return d;
    };
    AxisLabelPanelBase.prototype.bf = function (a, b) {
        var c = a * (Math.PI / 180);
        var d = Math.abs(b.height * Math.cos(c)) + Math.abs(b.width * Math.sin(c));
        return d;
    };
    AxisLabelPanelBase.prototype.bk = function () {
        var a = this.ae.k();
        return a;
    };
    AxisLabelPanelBase.prototype.bi = function () {
        var a = this.ae.j();
        return a;
    };
    AxisLabelPanelBase.prototype.bj = function () {
        if (this.ac.f7 == null || (this.ac.bc != null && this.ac.bc.visibility == 1)) {
            return 0;
        }
        var a = this.bi();
        var b = this.bk();
        var c = new Rect(0, 0, 0, b, a);
        var d = this.bh();
        var e = RectUtil.w(c, d);
        return e.height + this.ae.v() + this.ae.s();
    };
    AxisLabelPanelBase.prototype.bl = function () {
        if (this.ac.f7 == null || (this.ac.bc != null && this.ac.bc.visibility == 1)) {
            return 0;
        }
        var a = this.bi();
        var b = this.bk();
        var c = new Rect(0, 0, 0, b, a);
        var d = this.bh();
        var e = RectUtil.w(c, d);
        return e.width + this.ae.t() + this.ae.u();
    };
    AxisLabelPanelBase.prototype.cq = function (a) {
        if (this.ac == null || this.ab.count == 0) {
            return a;
        }
        this.bw(a);
        this.b0();
        this.bv(a);
        this.a0 = this.az();
        if (this.a3.count != this.a0.count) {
            return a;
        }
        var b = this.ae.p();
        var c = this.ae.r();
        var d = this.ae.q();
        var e = this.ae.o();
        if (this.ap) {
            for (var f = 0; f < this.a3.count; f++) {
                if (this.ao(f, this.a0._inner[f])) {
                    this.ae.aa(this.a3._inner[f], this.a0._inner[f], b, c, d, e);
                }
                this.cb(this.a3._inner[f], this.bd());
            }
        }
        for (var g = 0; g < this.a3.count; g++) {
            if (!this.ap) {
                this.ae.ad(this.a3._inner[g]);
            }
            if (this.ao(g, this.a0._inner[g])) {
                this.ae.aa(this.a3._inner[g], this.a0._inner[g], b, c, d, e);
            }
            else {
                this.ae.aa(this.a3._inner[g], new Rect(0, 0, 0, 0, 0), b, c, d, e);
            }
        }
        if (this.ac.bn.count > 0) {
            this.ac.a5.arrangeAnnotations(this.ac, this.ae, this.a3, this.a0, this.ap, this.bd(), b, c, d, e);
        }
        this.bt(a);
        return a;
    };
    AxisLabelPanelBase.prototype.cm = function () {
        return Rect.empty;
    };
    AxisLabelPanelBase.prototype.bw = function (a) {
        if (this.ac.hk == null) {
            return;
        }
        this.ae.ah(this.ac.hk, new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        var b = Math.abs(this.bh() - 0) > 1E-06;
        var c = this.cm();
        var d = c.left + (c.width / 2);
        var e = c.top + (c.height / 2);
        var f = this.bk() + this.ae.t() + this.ae.u();
        var g = this.bi() + this.ae.v() + this.ae.s();
        var h = f / 2;
        var i = g / 2;
        var j = new Rect(0, d - h, e - i, f, g);
        if (b) {
            this.cc(this.ac.hk);
        }
        else {
            this.ae.ad(this.ac.hk);
        }
        this.ae.aa(this.ac.hk, j, this.ae.t(), this.ae.v(), this.ae.u(), this.ae.s());
        if ((this.ac.bc == null || this.ac.bc.visibility == 0) && (this.ac.aw == null || this.ac.aw.visibility == 0) && this.ac.f7 != null) {
            this.ac.hk._visibility = 0;
        }
        else {
            this.ac.hk._visibility = 1;
            this.ae.aa(this.ac.hk, new Rect(0, 0, 0, 0, 0), 0, 0, 0, 0);
        }
    };
    AxisLabelPanelBase.prototype.bv = function (a) {
        this.ae.ab(a);
    };
    AxisLabelPanelBase.prototype.b0 = function () {
    };
    AxisLabelPanelBase.prototype.aw = function () {
        if (typeCast(CategoryAxisBase.$, this.ac) !== null) {
            return this.ac.jm;
        }
        if (typeCast(NumericAxisBase.$, this.ac) !== null) {
            var a = new List$1(Number_$type, 0);
            var d = this.ac.jk.j();
            for (var c = 0; c < d.length; c++) {
                var b = d[c];
                var e = this.ac.iw();
                var f = new ScalerParams(0, this.ac.bf.m4, this.ac.i1, this.ac.b9, e);
                a.add(this.ac.dw(b, f));
            }
            return a;
        }
        return null;
    };
    Object.defineProperty(AxisLabelPanelBase.prototype, "ag", {
        get: function () {
            var a = this.af != null ? this.af.c : this.ah();
            if (this.ac.ag == null) {
                if (a == 4) {
                    a = 5;
                }
                else if (a == 5) {
                    a = 4;
                }
                else if (a == 6) {
                    a = 7;
                }
                else if (a == 7) {
                    a = 6;
                }
            }
            return a;
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelPanelBase.prototype.cg = function (a, b, c, d, e, f) {
        var g = b;
        var h = b;
        if (f != null) {
            var i = f.c / 2;
            g -= i;
            h += i;
        }
        if (h >= e.left && g <= e.right) {
            if (f.a) {
                b = this.ac.dh(b, e.left, e.right, f);
            }
            var j = new LineGeometry();
            j.d = { $type: Point_$type, x: b, y: c };
            j.c = { $type: Point_$type, x: b, y: d };
            a.add(j);
        }
    };
    AxisLabelPanelBase.prototype.b3 = function (a, b, c, d, e, f) {
        if (b <= e.bottom && b >= e.top) {
            if (f.a) {
                b = this.ac.dh(b, e.top, e.bottom, f);
            }
            var g = new LineGeometry();
            g.d = { $type: Point_$type, x: c, y: b };
            g.c = { $type: Point_$type, x: d, y: b };
            a.add(g);
        }
    };
    AxisLabelPanelBase.prototype.cb = function (a, b) {
        var c = this.bd();
        this.ae.ai(a, c);
    };
    AxisLabelPanelBase.prototype.cc = function (a) {
        var b = this.bh();
        this.b2(a, b);
    };
    AxisLabelPanelBase.prototype.b2 = function (a, b) {
        var c = typeCast(FrameworkElement.$, a);
        var d = this.bi();
        var e = this.bk();
        var f = 0.5 * e;
        var g = 0.5 * d;
        var h = ((function () {
            var $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = f;
            $ret.l = g;
            return $ret;
        })());
        var i = new TransformGroup();
        i.j.add(h);
        c.j = i;
    };
    AxisLabelPanelBase.prototype.cr = function (a) {
        var e_21, _a;
        if ((this.ab.contains(this.ac.hk) == false) && this.ac.hk != null) {
            this.ab.add(this.ac.hk);
            AxisLabelManager.l(this.ac.hk);
        }
        try {
            for (var _b = __values(fromEnum(this.ab)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b != this.ac.hk && b != this.ae.av) {
                    this.ae.ag(b);
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        var c = (this.ac == null || this.a5 <= 0 || isNaN_(this.a5)) ? 50 : this.a5;
        if (this.ac != null && (this.ac.cx == null || this.ac.cx.count == 0)) {
            if (this.ac.bz()) {
                c = this.ac.d2();
            }
        }
        var d = this.an();
        c = Math.min(c, d ? a.height : a.width);
        c = isInfinity(c) ? 50 : c;
        return d ? new Size(1, 50, c) : new Size(1, c, 50);
    };
    Object.defineProperty(AxisLabelPanelBase.prototype, "a9", {
        get: function () {
            return this.c(AxisLabelPanelBase.ci);
        },
        set: function (a) {
            this.h(AxisLabelPanelBase.ci, a);
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelPanelBase.prototype.ai = function (a) {
        if (a == null) {
            return this.ac.bf.aj(this.ac);
        }
        if (a.position == 0) {
            if (this.ac != null && this.ac.bf != null) {
                return this.ac.bf.aj(this.ac);
            }
            return 4;
        }
        return a.position;
    };
    AxisLabelPanelBase.prototype.ah = function () {
        return 1;
    };
    AxisLabelPanelBase.prototype.as = function (a) {
        return true;
    };
    AxisLabelPanelBase.prototype._au = function () {
        var _a, _b, a, e_22_1;
        var e_22, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 5, 6, 7]);
                    _a = __values(fromEnum(this.ab)), _b = _a.next();
                    _d.label = 1;
                case 1:
                    if (!!_b.done)
                        return [3 /*break*/, 4];
                    a = _b.value;
                    if (!(a != this.ac.hk && a != this.ae.av))
                        return [3 /*break*/, 3];
                    return [4 /*yield*/, a];
                case 2:
                    _d.sent();
                    _d.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_22_1 = _d.sent();
                    e_22 = { error: e_22_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_22)
                            throw e_22.error;
                    }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    AxisLabelPanelBase.prototype.au = function () {
        var _this = this;
        return toEnum(function () { return _this._au(); });
    };
    AxisLabelPanelBase.prototype.bs = function (a, b, c, d, e) {
        var f = this.ae.x(b, c, d, e);
        return f;
    };
    AxisLabelPanelBase.prototype.by = function (a) {
        if (this.bq == null || this.bc(this.bq) < this.bc(a)) {
            this.bq = a;
        }
    };
    AxisLabelPanelBase.prototype.b7 = function (a) {
        this.a3.add(a);
    };
    AxisLabelPanelBase.prototype._av = function () {
        var a, b;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = 0;
                    _a.label = 1;
                case 1:
                    if (!(a < this.ac.bo.count))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, this.ac.bo.item(a)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    a++;
                    return [3 /*break*/, 1];
                case 4:
                    b = 0;
                    _a.label = 5;
                case 5:
                    if (!(b < this.ac.bn.count))
                        return [3 /*break*/, 8];
                    return [4 /*yield*/, this.ac.bn.item(b)];
                case 6:
                    _a.sent();
                    _a.label = 7;
                case 7:
                    b++;
                    return [3 /*break*/, 5];
                case 8: return [2 /*return*/];
            }
        });
    };
    AxisLabelPanelBase.prototype.av = function () {
        var _this = this;
        return toEnum(function () { return _this._av(); });
    };
    AxisLabelPanelBase.prototype.b1 = function () {
        this.ae.af();
        this.cf();
    };
    AxisLabelPanelBase.prototype.cf = function () {
        this.a0 = this.az();
    };
    AxisLabelPanelBase.prototype.b5 = function () {
    };
    AxisLabelPanelBase.prototype.ba = function (a) {
        return this.a5;
    };
    AxisLabelPanelBase.prototype.b6 = function () {
        this.ae.aj();
    };
    AxisLabelPanelBase.prototype.b9 = function (a) {
        this.ae.ak(a);
    };
    AxisLabelPanelBase.prototype.bu = function () {
        this.ae.y();
    };
    AxisLabelPanelBase.prototype.ca = function () {
        this.ae.an();
    };
    AxisLabelPanelBase.$t = markType(AxisLabelPanelBase, 'AxisLabelPanelBase', Panel.$);
    AxisLabelPanelBase.ci = DependencyProperty.i("Extent", Number_$type, AxisLabelPanelBase.$, new PropertyMetadata(2, 50, function (a, b) { return a.a5 = b.newValue; }));
    return AxisLabelPanelBase;
}(Panel));
/**
 * @hidden
 */
var CategoryAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAxisBase, _super);
    function CategoryAxisBase() {
        var _this = _super.call(this) || this;
        _this.jm = null;
        _this.je = null;
        _this.jx = 0;
        _this.jy = 0;
        _this.jc = 0;
        _this.j0 = 0;
        _this.jg = false;
        _this.jm = new List$1(Number_$type, 0);
        return _this;
    }
    CategoryAxisBase.prototype.a1 = function () {
        return new CategoryAxisBaseView(this);
    };
    CategoryAxisBase.prototype.get_b4 = function () {
        return false;
    };
    CategoryAxisBase.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.jb = a;
    };
    CategoryAxisBase.prototype.cr = function (a, b, c) {
        var d = _super.prototype.cr.call(this, a, b, c);
        if (!d) {
            return false;
        }
        return this.itemsSource != null && this.jy > 0;
    };
    CategoryAxisBase.prototype.kj = function () {
        if (this.jf != null && this.bl != null && this.itemsSource != null) {
            this.jf = this.bl.releaseFastItemsSource(this.itemsSource);
        }
    };
    CategoryAxisBase.prototype.ki = function () {
        if (this.jf == null && this.bl != null && this.itemsSource != null) {
            this.jf = this.bl.getFastItemsSource(this.itemsSource);
        }
    };
    CategoryAxisBase.prototype.get_b2 = function () {
        return true;
    };
    CategoryAxisBase.prototype.ku = function (a, b, c) {
        if (this.b0) {
            return Rect.empty;
        }
        return this.kv(a, b, c, this.cf);
    };
    CategoryAxisBase.prototype.kv = function (a, b, c, d) {
        var e = 0;
        var f = a.x;
        var g = this.i1.left;
        var h = this.i1.right;
        if (d) {
            f = a.y;
            g = this.i1.top;
            h = this.i1.bottom;
        }
        var i = this.jm;
        if ((d && !this.b8) || (!d && this.b8)) {
            i = new List$1(Number_$type, 0);
            for (var j = this.jm.count - 1; j >= 0; j--) {
                i.add(this.jm._inner[j]);
            }
        }
        if (this.categoryMode == 0) {
            if (b) {
                var k = void 0;
                if (d) {
                    k = new Rect(0, this.i1.left, a.y - c / 2, this.i1.width, c);
                }
                else {
                    k = new Rect(0, a.x - c / 2, this.i1.top, c, this.i1.height);
                }
                k.intersect(this.i1);
                return k;
            }
            else {
                if (f > h) {
                    return Rect.empty;
                }
                if (f < g) {
                    return Rect.empty;
                }
                var l = 1.7976931348623157E+308;
                var m = -1;
                for (e = 0; e < i.count; e++) {
                    var n = Math.abs(i._inner[e] - f);
                    if (n < l) {
                        l = n;
                        m = e;
                    }
                }
                if (m == -1) {
                    return Rect.empty;
                }
                var o = i._inner[m];
                var p = void 0;
                if (d) {
                    p = new Rect(0, this.i1.left, o - c / 2, this.i1.width, c);
                }
                else {
                    p = new Rect(0, o - c / 2, this.i1.top, c, this.i1.height);
                }
                p.intersect(this.i1);
                return p;
            }
        }
        else {
            for (e = 0; e < i.count; e++) {
                if (i._inner[e] > f) {
                    break;
                }
            }
            if (e == 0) {
                return Rect.empty;
            }
            if (f > h) {
                return Rect.empty;
            }
            if (f < g) {
                return Rect.empty;
            }
            var q = this.i1.right;
            if (d) {
                q = this.i1.bottom;
            }
            if (e < i.count) {
                q = i._inner[e];
            }
            if (d) {
                return new Rect(0, this.i1.left, i._inner[e - 1], this.i1.width, q - i._inner[e - 1]);
            }
            else {
                return new Rect(0, i._inner[e - 1], this.i1.top, q - i._inner[e - 1], this.i1.height);
            }
        }
    };
    Object.defineProperty(CategoryAxisBase.prototype, "itemsSource", {
        get: function () {
            return this.c(CategoryAxisBase.kr);
        },
        set: function (a) {
            this.h(CategoryAxisBase.kr, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAxisBase.prototype, "jz", {
        get: function () {
            return this.jx;
        },
        set: function (a) {
            this.jx = a;
            this.jy = this.jx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAxisBase.prototype, "categoryMode", {
        get: function () {
            return this.jc;
        },
        set: function (a) {
            if (this.jc != a) {
                var b = this.jc;
                this.jc = a;
                this.g0("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAxisBase.prototype, "j1", {
        get: function () {
            return this.j0;
        },
        set: function (a) {
            if (a != this.j0) {
                var b = this.j0;
                this.j0 = a;
                this.g0("GroupCount", b, this.j0);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryAxisBase.prototype.dz = function (a, b) {
        return NaN;
    };
    CategoryAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        return NaN;
    };
    CategoryAxisBase.prototype.getCategorySize = function (a, b, c) {
        return NaN;
    };
    CategoryAxisBase.prototype.jr = function (a, b, c) {
        return NaN;
    };
    CategoryAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return NaN;
    };
    CategoryAxisBase.prototype.jw = function (a) {
        var b = this.bf.m4;
        var c = this.i1;
        var d = this.iw();
        var e = new ScalerParams(0, b, c, this.b8, d);
        return this.dz(a, e);
    };
    CategoryAxisBase.prototype._jl = function () {
        var _a, _b, a, e_23_1, _c, _d, b, _e, _f, c, e_24_1, e_25_1;
        var e_23, _g, e_25, _h, e_24, _j;
        return __generator(this, function (_k) {
            switch (_k.label) {
                case 0:
                    _k.trys.push([0, 5, 6, 7]);
                    _a = __values(fromEnum(this.cx)), _b = _a.next();
                    _k.label = 1;
                case 1:
                    if (!!_b.done)
                        return [3 /*break*/, 4];
                    a = _b.value;
                    return [4 /*yield*/, a];
                case 2:
                    _k.sent();
                    _k.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_23_1 = _k.sent();
                    e_23 = { error: e_23_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_g = _a.return))
                            _g.call(_a);
                    }
                    finally {
                        if (e_23)
                            throw e_23.error;
                    }
                    return [7 /*endfinally*/];
                case 7:
                    if (!(this.bf != null && this.bf.c0 && this.ji(this.bf)))
                        return [3 /*break*/, 21];
                    _k.label = 8;
                case 8:
                    _k.trys.push([8, 19, 20, 21]);
                    _c = __values(fromEnum(this.bf.dm())), _d = _c.next();
                    _k.label = 9;
                case 9:
                    if (!!_d.done)
                        return [3 /*break*/, 18];
                    b = _d.value;
                    if (!(b != this.bf))
                        return [3 /*break*/, 17];
                    _k.label = 10;
                case 10:
                    _k.trys.push([10, 15, 16, 17]);
                    _e = (e_24 = void 0, __values(fromEnum(b.series))), _f = _e.next();
                    _k.label = 11;
                case 11:
                    if (!!_f.done)
                        return [3 /*break*/, 14];
                    c = _f.value;
                    return [4 /*yield*/, c];
                case 12:
                    _k.sent();
                    _k.label = 13;
                case 13:
                    _f = _e.next();
                    return [3 /*break*/, 11];
                case 14: return [3 /*break*/, 17];
                case 15:
                    e_24_1 = _k.sent();
                    e_24 = { error: e_24_1 };
                    return [3 /*break*/, 17];
                case 16:
                    try {
                        if (_f && !_f.done && (_j = _e.return))
                            _j.call(_e);
                    }
                    finally {
                        if (e_24)
                            throw e_24.error;
                    }
                    return [7 /*endfinally*/];
                case 17:
                    _d = _c.next();
                    return [3 /*break*/, 9];
                case 18: return [3 /*break*/, 21];
                case 19:
                    e_25_1 = _k.sent();
                    e_25 = { error: e_25_1 };
                    return [3 /*break*/, 21];
                case 20:
                    try {
                        if (_d && !_d.done && (_h = _c.return))
                            _h.call(_c);
                    }
                    finally {
                        if (e_25)
                            throw e_25.error;
                    }
                    return [7 /*endfinally*/];
                case 21: return [2 /*return*/];
            }
        });
    };
    CategoryAxisBase.prototype.jl = function () {
        var _this = this;
        return toEnum(function () { return _this._jl(); });
    };
    CategoryAxisBase.prototype.jh = function (a) {
        return this.cx.contains(a);
    };
    CategoryAxisBase.prototype.ji = function (a) {
        return false;
    };
    CategoryAxisBase.prototype._jk = function () {
        var a, _a, _b, b, c, _c, _d, d, e_26_1, e_27_1;
        var e_27, _e, e_26, _f;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    a = typeCast(XamDataChart.$, this.bf);
                    if (!(a != null && a.c0 && this.ji(a)))
                        return [3 /*break*/, 14];
                    _g.label = 1;
                case 1:
                    _g.trys.push([1, 12, 13, 14]);
                    _a = __values(fromEnum(a.dm())), _b = _a.next();
                    _g.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 11];
                    b = _b.value;
                    if (!(b != this.bf))
                        return [3 /*break*/, 10];
                    c = typeCast(XamDataChart.$, b);
                    if (!(c != null))
                        return [3 /*break*/, 10];
                    _g.label = 3;
                case 3:
                    _g.trys.push([3, 8, 9, 10]);
                    _c = (e_26 = void 0, __values(fromEnum(c.axes))), _d = _c.next();
                    _g.label = 4;
                case 4:
                    if (!!_d.done)
                        return [3 /*break*/, 7];
                    d = _d.value;
                    if (!(typeCast(CategoryAxisBase.$, d) !== null))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, typeCast(CategoryAxisBase.$, d)];
                case 5:
                    _g.sent();
                    _g.label = 6;
                case 6:
                    _d = _c.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_26_1 = _g.sent();
                    e_26 = { error: e_26_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (_d && !_d.done && (_f = _c.return))
                            _f.call(_c);
                    }
                    finally {
                        if (e_26)
                            throw e_26.error;
                    }
                    return [7 /*endfinally*/];
                case 10:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 11: return [3 /*break*/, 14];
                case 12:
                    e_27_1 = _g.sent();
                    e_27 = { error: e_27_1 };
                    return [3 /*break*/, 14];
                case 13:
                    try {
                        if (_b && !_b.done && (_e = _a.return))
                            _e.call(_a);
                    }
                    finally {
                        if (e_27)
                            throw e_27.error;
                    }
                    return [7 /*endfinally*/];
                case 14: return [2 /*return*/];
            }
        });
    };
    CategoryAxisBase.prototype.jk = function () {
        var _this = this;
        return toEnum(function () { return _this._jk(); });
    };
    CategoryAxisBase.prototype.kn = function (a) {
        var e_28, _a, e_29, _b;
        if (this.jg) {
            return;
        }
        try {
            this.jg = true;
            var b = 0;
            var c = 0;
            var d = false;
            try {
                for (var _c = __values(fromEnum(this.jl())), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    if (!e.cl && !e.c2 && !e.cr) {
                        continue;
                    }
                    var f = e;
                    var g = f.preferredCategoryMode(this);
                    if (g == 2) {
                        b = 2;
                        d = true;
                        if (this.jh(e)) {
                            c++;
                        }
                    }
                    if (g == 1 && !d) {
                        b = 1;
                    }
                }
            }
            catch (e_28_1) {
                e_28 = { error: e_28_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_28)
                        throw e_28.error;
                }
            }
            var h = this.jj;
            try {
                for (var _e = __values(fromEnum(this.jk())), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    if (i.jj) {
                        h = true;
                    }
                    if (a) {
                        i.kn(false);
                    }
                }
            }
            catch (e_29_1) {
                e_29 = { error: e_29_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_29)
                        throw e_29.error;
                }
            }
            if (b == 0 && h) {
                b = 2;
                if (c == 0) {
                    c = 1;
                }
            }
            this.categoryMode = b;
            this.j1 = c;
        }
        finally {
            this.jg = false;
        }
    };
    CategoryAxisBase.prototype.gu = function (a, b, c, d) {
        var e_30, _a, e_31, _b, e_32, _c;
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSourceProvider":
                if ((typeCast(IFastItemsSourceProvider_$type, c)) != null) {
                    this.jf = c.releaseFastItemsSource(this.itemsSource);
                }
                if ((typeCast(IFastItemsSourceProvider_$type, d)) != null) {
                    this.jf = d.getFastItemsSource(this.itemsSource);
                }
                this.jz = 0;
                if (this.jf != null) {
                    this.jz = this.jf.count;
                }
                this.kn(true);
                break;
            case "ItemsSource":
                if (this.bl != null) {
                    this.jf = this.bl.getFastItemsSource(this.itemsSource);
                }
                break;
            case CategoryAxisBase.$$p[0]:
                var e = typeCast(IFastItemsSource_$type, c);
                this.ka();
                this.cg = true;
                if (e != null) {
                    e.event = delegateRemove(e.event, runOn(this, this.kd));
                }
                this.jz = 0;
                if (this.jf != null) {
                    this.jz = this.jf.count;
                }
                if (this.jf != null) {
                    var f = this.jf;
                    f.event = delegateCombine(f.event, runOn(this, this.kd));
                    this.g6(false);
                    try {
                        for (var _d = __values(fromEnum(this.cu())), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var g = _e.value;
                            g.jd(false);
                            if (g.bs != null) {
                                g.ik();
                            }
                        }
                    }
                    catch (e_30_1) {
                        e_30 = { error: e_30_1 };
                    }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return))
                                _a.call(_d);
                        }
                        finally {
                            if (e_30)
                                throw e_30.error;
                        }
                    }
                }
                else {
                    this.gh();
                    try {
                        for (var _f = __values(fromEnum(this.cu())), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var h = _g.value;
                            h.hv(true, h.bi);
                            if (h.bs != null) {
                                h.ik();
                            }
                        }
                    }
                    catch (e_31_1) {
                        e_31 = { error: e_31_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_31)
                                throw e_31.error;
                        }
                    }
                }
                break;
            case "ItemsCount":
                this.g1(new AxisRangeChangedEventArgs(0, 0, 0, typeGetValue((c)) - 1, typeGetValue((d)) - 1));
                this.g6(false);
                break;
            case CategoryAxisBase.$$p[3]:
                this.cg = true;
                this.ko();
                this.g6(false);
                this.kb();
                break;
            case "CategoryMode":
                this.cg = true;
                this.g6(false);
                this.kl();
                this.kb();
                break;
            case CategoryAxisBase.$$p[2]:
            case CategoryAxisBase.$$p[1]:
                this.cg = true;
                try {
                    for (var _h = __values(fromEnum(this.cu())), _j = _h.next(); !_j.done; _j = _h.next()) {
                        var i = _j.value;
                        i.dl = true;
                        var j = typeCast(IHasCategoryModePreference_$type, i);
                        if (j != null && j.preferredCategoryMode(this) == 2) {
                            i.jd(false);
                        }
                    }
                }
                catch (e_32_1) {
                    e_32 = { error: e_32_1 };
                }
                finally {
                    try {
                        if (_j && !_j.done && (_c = _h.return))
                            _c.call(_h);
                    }
                    finally {
                        if (e_32)
                            throw e_32.error;
                    }
                }
                this.g6(false);
                if (this.bf != null) {
                    this.bf.h1();
                }
                break;
            case Axis.$$p[4]:
            case Axis.$$p[3]:
                this.cg = true;
                this.g6(true);
                break;
        }
    };
    CategoryAxisBase.prototype.kb = function () {
        var e_33, _a;
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.jd(false);
            }
        }
        catch (e_33_1) {
            e_33 = { error: e_33_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_33)
                    throw e_33.error;
            }
        }
    };
    CategoryAxisBase.prototype.kd = function (a, b) {
        this.kk(b);
    };
    CategoryAxisBase.prototype.kk = function (a) {
        switch (a.action) {
            case 3:
            case 0:
            case 1:
            case 2:
            case 4:
                if (this.jf != null) {
                    this.jz = this.jf.count;
                }
                this.g6(false);
                break;
        }
        if (this.jf != null) {
            this.jz = this.jf.count;
        }
    };
    CategoryAxisBase.prototype.ko = function () {
        var e_34, _a;
        var a = false, b = false;
        try {
            for (var _b = __values(fromEnum(this.cx)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = typeCast(IHasCategoryModePreference_$type, c);
                if (d == null) {
                    continue;
                }
                var e = d.preferredCategoryMode(this);
                a = a || e == 1;
                b = b || e == 2;
            }
        }
        catch (e_34_1) {
            e_34 = { error: e_34_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_34)
                    throw e_34.error;
            }
        }
        var f = b ? 2 : a ? 1 : 0;
        if (f == 0 && this.jj) {
            f = 1;
            if (this.j1 == 0) {
                this.j1 = 1;
            }
        }
        this.categoryMode = f;
    };
    CategoryAxisBase.prototype.ci = function (a) {
        var e_35, _a;
        var b = _super.prototype.ci.call(this, a);
        if (b) {
            this.kn(true);
            var c = typeCast(IHasCategoryModePreference_$type, a);
            if (c != null && c.preferredCategoryMode(this) == 2) {
                try {
                    for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        var e = typeCast(IHasCategoryModePreference_$type, d);
                        if (e != null && e != c && e.preferredCategoryMode(this) == 2) {
                            d.jd(false);
                        }
                    }
                }
                catch (e_35_1) {
                    e_35 = { error: e_35_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_35)
                            throw e_35.error;
                    }
                }
            }
            this.g6(false);
            this.cl();
        }
        return b;
    };
    CategoryAxisBase.prototype.bv = function (a) {
        var e_36, _a;
        var b = _super.prototype.bv.call(this, a);
        if (b) {
            this.kn(true);
            var c = typeCast(IHasCategoryModePreference_$type, a);
            if (c != null && c.preferredCategoryMode(this) != 0) {
                try {
                    for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        var e = typeCast(IHasCategoryModePreference_$type, d);
                        if (e != null) {
                            d.jd(false);
                        }
                    }
                }
                catch (e_36_1) {
                    e_36 = { error: e_36_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_36)
                            throw e_36.error;
                    }
                }
            }
            this.g6(false);
        }
        return b;
    };
    CategoryAxisBase.prototype.kl = function () {
        var e_37, _a;
        var a = null;
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b.cl) {
                    var c = b.am(this);
                    if (c != null && c.ag == this) {
                        a = c;
                    }
                }
            }
        }
        catch (e_37_1) {
            e_37 = { error: e_37_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_37)
                    throw e_37.error;
            }
        }
        if (a != null) {
            a.g5();
        }
    };
    CategoryAxisBase.prototype.ka = function () {
        this.je = this.jf;
    };
    CategoryAxisBase.prototype.km = function () {
        var a = this.aw;
        if (a == null) {
            a = new AxisLabelSettings();
        }
        if (a.visibility == 1) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
        }
        else {
            var b = 0;
            b = this.jb.bf(this.cv);
            this.bo.count = b;
        }
    };
    CategoryAxisBase.prototype.kc = function (a) {
        if (this.jf != null) {
            this.jf.handleCollectionChanged(a);
        }
    };
    CategoryAxisBase.prototype.kh = function (a, b, c) {
        this.kc(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    CategoryAxisBase.prototype.ke = function () {
        this.kc(new NotifyCollectionChangedEventArgs(0, 4));
    };
    CategoryAxisBase.prototype.kf = function (a, b) {
        this.kc(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    CategoryAxisBase.prototype.kg = function (a, b) {
        this.kc(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    CategoryAxisBase.prototype.js = function (a, b, c, d) {
        return this.jt(a, b, c, d, this.categoryMode);
    };
    CategoryAxisBase.prototype.jt = function (a, b, c, d, e) {
        var f = 0;
        var g = e;
        if (g == 0 && this.categoryMode != 0) {
            g = 1;
        }
        switch (g) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * this.getCategorySize(a, b, c);
                break;
            case 2:
                f = this.getGroupCenter(d, a, b, c);
                break;
        }
        if (this.cf != this.b8) {
            f *= -1;
        }
        return f;
    };
    CategoryAxisBase.prototype.getSeriesOffset = function (a, b, c, d, e) {
        return this.jt(a, b, c, d, e);
    };
    Object.defineProperty(CategoryAxisBase.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAxisBase.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    CategoryAxisBase.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    CategoryAxisBase.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    CategoryAxisBase.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(CategoryAxisBase.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAxisBase.$t = markType(CategoryAxisBase, 'CategoryAxisBase', Axis.$, [ICategoryScaler_$type]);
    CategoryAxisBase.kr = DependencyProperty.i("ItemsSource", IEnumerable_$type, CategoryAxisBase.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(CategoryAxisBase.$, a);
        if (c.bl != null) {
            c.bl.releaseFastItemsSource(b.oldValue);
        }
        a.g0("ItemsSource", b.oldValue, b.newValue);
    }));
    CategoryAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAxisBase, 'g0', ['FastItemsSource:jf:kp', [IFastItemsSource_$type], 'Gap:jo:kq', [1, 0.2], 'Overlap:jv:ks', [1, 0], 'UseClusteringMode:jj:kt', [0, false]]);
    return CategoryAxisBase;
}(Axis));
/**
 * @hidden
 */
var HorizontalAxisLabelPanelBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAxisLabelPanelBase, _super);
    function HorizontalAxisLabelPanelBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c4 = 0;
        _this.c1 = 0;
        _this.c3 = 0;
        _this.c2 = 0;
        return _this;
    }
    HorizontalAxisLabelPanelBase.prototype.ad = function () {
        return new HorizontalAxisLabelPanelBaseView(this);
    };
    HorizontalAxisLabelPanelBase.prototype.b8 = function (a) {
        _super.prototype.b8.call(this, a);
        this.cs = a;
    };
    HorizontalAxisLabelPanelBase.prototype.bx = function () {
        this.cs.az();
    };
    HorizontalAxisLabelPanelBase.prototype.cu = function () {
        return this.af != null && this.af.j() && this.bd() % 360 != 0;
    };
    HorizontalAxisLabelPanelBase.prototype.cv = function () {
        return this.am && !this.ap;
    };
    HorizontalAxisLabelPanelBase.prototype.an = function () {
        return true;
    };
    HorizontalAxisLabelPanelBase.prototype.ay = function () {
        var _this = this;
        var a = new List$1(Rect.$, 0);
        var b = new List$1(Boolean_$type, 0);
        this.aq = false;
        this.ap = false;
        this.ar = false;
        var c = this.af != null ? (this.af.angle) : 0;
        var d = c * Math.PI / 180;
        if (this.cu()) {
            this.ap = true;
        }
        this.am = false;
        this.c6(a, b, d);
        this.am = this.am || this.al(a, b);
        if (this.am) {
            this.c8(a, b);
        }
        else {
            this.c9();
        }
        var e = this.ac.bz();
        if (!e) {
            this.c5(c);
        }
        else {
            this.ae.ac();
        }
        if (this.ap) {
            for (var f = 0; f < a.count; f++) {
                var g = a._inner[f];
                g.x = this.a2._inner[f].c;
                a._inner[f] = g;
            }
        }
        var h = 0;
        if (this.cv()) {
            h = ((function () { var i = _this.bp(_this.c1, a, b); a = i.p1; return i.ret; })());
        }
        if (this.am && !this.aq) {
            if (h > 0) {
                if (this.cs.ay()) {
                    this.ar = true;
                }
            }
        }
        if (this.am && this.ct()) {
            var i = this.cn.width;
            var j = this.cz();
            var k = this.cy();
            var l = this.a2.count > 1 ? this.a2._inner[1].c - this.a2._inner[0].c : i;
            var m = Math.abs(l * 0.8);
            var n = 0;
            var o = Math.abs(Math.atan(this.c1 / l) * 180 / Math.PI);
            var p = this.ae.p();
            var q = this.ae.q();
            for (var r = 0; r < a.count; r++) {
                if (this.ak) {
                    if (r > 0 && r < a.count - 1) {
                        var s = this.a2.count > 1 ? this.a2._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                        var t = this.a2.count > 1 ? a._inner[r + 1].x - this.a2._inner[r].c : i;
                        m = Math.abs(Math.min(Math.abs(s * 2), Math.abs(t * 2)) * 0.8);
                    }
                    else {
                        if (r == 0) {
                            var u = this.a2.count > 1 ? a._inner[r + 1].x - this.a2._inner[r].c : i;
                            m = Math.abs((l * 2) * 0.8);
                        }
                        if (r == a.count - 1) {
                            var v = this.a2.count > 1 ? this.a2._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                            m = Math.abs((v * 2) * 0.8);
                        }
                    }
                }
                var w = Math.min(a._inner[r].width, m);
                n = this.ap ? this.a2._inner[r].c : this.a2._inner[r].c - w / 2;
                var x = AngleSimplifier.a(c);
                var y = (x >= o && x <= 180 - o) || (x >= 180 + o && x <= 360 - o);
                var z = a._inner[r];
                if (this.ap && y) {
                    var aa = this.bm(this.a3._inner[r]);
                    m = Math.min(j / Math.abs(Math.sin(d)), aa);
                }
                z.x = n;
                z.width = Math.min(m, z.width);
                a._inner[r] = z;
                if (!(typeCast(TextBlock.$, this.a3._inner[r]) !== null)) {
                    this.a3._inner[r].width = Math.min(m, z.width);
                }
                var ab = typeCast(TextBlock.$, this.a3._inner[r]);
                if (ab != null) {
                    var ac = this.bs(r, ab, m, p, q);
                    if (this.ar) {
                        ab.height = k;
                    }
                    else if (!Base.equalsStatic(ab.ak, ac)) {
                        ab.ak = ac;
                        this.a3._inner[r].width = Math.min(m, this.bc(this.a3._inner[r]));
                        this.c3 = Math.min(this.c3, this.a3._inner[r].width);
                    }
                }
            }
            if (!e) {
                this.c5(c);
            }
        }
        if (this.cw()) {
            this.c7(a);
        }
        return a;
    };
    HorizontalAxisLabelPanelBase.prototype.c6 = function (a, b, c) {
        var d = this.bj();
        var e = this.c0();
        this.c1 = -1.7976931348623157E+308;
        this.c4 = -1.7976931348623157E+308;
        this.c2 = -1.7976931348623157E+308;
        this.c3 = -1.7976931348623157E+308;
        var f = this.ae.p();
        var g = this.ae.q();
        var h = this.ae.r();
        var i = this.ae.o();
        var j = this.cn.top;
        var k = (this.cn.height - d);
        var l = false;
        for (var m = 0; m < this.a3.count; m++) {
            if (!this.a2._inner[m].a) {
                l = true;
            }
        }
        for (var n = 0; n < this.a3.count; n++) {
            if (this.a2 == null || n >= this.a2.count) {
                break;
            }
            var o = void 0, p = void 0, q = void 0, r = void 0, s = void 0, t = void 0;
            var u = this.a3._inner[n];
            s = this.bc(u);
            t = this.bb(u);
            r = s + this.ae.p() + this.ae.q();
            q = t + h + i;
            var v = this.a2._inner[n].a;
            if (this.ap) {
                o = this.a2._inner[n].c;
            }
            else {
                o = this.a2._inner[n].c - r / 2;
            }
            p = j + e;
            if (!v || !l) {
                this.c1 = Math.max(q, this.c1);
                this.c4 = Math.max(r, this.c4);
                this.c2 = Math.max(t, this.c2);
                this.c3 = Math.max(s, this.c3);
            }
            var w = new Rect(0, o, p, r, q);
            a.add(w);
            b.add(v);
            var x = r * Math.abs(Math.sin(c));
            this.am = this.am || x > k;
        }
    };
    HorizontalAxisLabelPanelBase.prototype.c5 = function (a) {
        var b = a * (Math.PI / 180);
        var c = Math.abs(this.c3 * Math.sin(b)) + Math.abs(this.c2 * Math.cos(b));
        c += this.ae.r() + this.ae.o();
        var d = this.bj();
        this.a9 = (c) + (d) + this.ac.dg;
    };
    HorizontalAxisLabelPanelBase.prototype.c7 = function (a) {
        this.cs.a0(a);
    };
    HorizontalAxisLabelPanelBase.prototype.c8 = function (a, b) {
    };
    HorizontalAxisLabelPanelBase.prototype.c9 = function () {
    };
    HorizontalAxisLabelPanelBase.prototype.cb = function (a, b) {
        var c = a.l;
        var d = a.m;
        var e = 0;
        var f = c / 2;
        var g = new TransformGroup();
        var h = AngleSimplifier.a(this.bd());
        var i = ((function () {
            var $ret = new RotateTransform();
            $ret.j = h;
            $ret.k = e;
            $ret.l = f;
            return $ret;
        })());
        var j = 0;
        var k = 0;
        if (h != 0 && h != 360) {
            if (h > 0 && h < 180) {
                j = -Math.sin(MathUtil.k(h)) * (c / 2);
            }
            else {
                i.k = d;
                k = -d;
                j = -Math.sin(MathUtil.k(h - 180)) * (c / 2);
            }
        }
        var l = ((function () {
            var $ret = new TranslateTransform();
            $ret.k = j;
            $ret.j = k;
            return $ret;
        })());
        g.j.add(i);
        g.j.add(l);
        a.j = g;
    };
    HorizontalAxisLabelPanelBase.prototype.cw = function () {
        return !this.aq && !this.ap;
    };
    HorizontalAxisLabelPanelBase.prototype.ct = function () {
        return true;
    };
    HorizontalAxisLabelPanelBase.prototype.bp = function (a, b, c) {
        var d = 0;
        var e = new List$1(Rect.$, 0);
        var f = this.c0() + this.cn.top;
        var g = this.cz();
        var h = f + g;
        if (a * 3 <= this.a5) {
            d = 3;
        }
        else if (a * 2 <= this.a5) {
            d = 2;
        }
        else {
            return {
                ret: d,
                p1: b
            };
        }
        var i = 0;
        for (var j = 0; j < b.count; j++) {
            var k = RectUtil.p(b._inner[j]);
            if (!c._inner[j]) {
                if (i % d == 0) {
                    k.y = f;
                }
                else if (i % d == d - 1) {
                    k.y = h - k.height;
                }
                else {
                    k.y = (f + (g / 2)) - k.height / 2;
                }
                i++;
            }
            e.add(k);
        }
        this.am = this.al(e, c);
        if (!this.am) {
            this.aq = true;
            b = e;
        }
        return {
            ret: d,
            p1: b
        };
    };
    HorizontalAxisLabelPanelBase.prototype.cm = function () {
        var a = this.ai(this.ac.bc);
        var b = this.bj();
        var c = this.ag;
        var d = 0;
        if (a == 3) {
            d += this.cn.top;
            if (c == 1 || c == 5) {
                d += this.ac.dg;
            }
        }
        else {
            d = this.cn.bottom - b;
            if (c == 4 || c == 0) {
                d -= this.ac.dg;
            }
        }
        var e = this.bl();
        var f = 0;
        var g = this.ac.bc == null ? 1 : this.ac.bc.horizontalAlignment;
        if (g == 0) {
            f = this.cn.left;
        }
        else if (g == 2) {
            f = this.cn.right - e;
        }
        else {
            f = (this.cn.left + (this.cn.width / 2)) - (e / 2);
        }
        return new Rect(0, f, d, e, b);
    };
    HorizontalAxisLabelPanelBase.prototype.c0 = function () {
        var a = 0;
        var b = this.ai(this.ac.bc);
        if (b == 3) {
            a += this.bj();
        }
        var c = this.ag;
        if (c == 1 || c == 5) {
            a += this.ac.dg;
        }
        return a;
    };
    HorizontalAxisLabelPanelBase.prototype.cx = function () {
        var a = 0;
        var b = this.ai(this.ac.bc);
        if (b == 4) {
            a += this.bj();
        }
        var c = this.ag;
        if (c == 0 || c == 4) {
            a += this.ac.dg;
        }
        return a;
    };
    HorizontalAxisLabelPanelBase.prototype.cz = function () {
        var a = (this.a5 - this.c0()) - this.cx();
        if (a < 0) {
            a = 0;
        }
        return a;
    };
    HorizontalAxisLabelPanelBase.prototype.cy = function () {
        var a = ((this.cz() - this.ae.r()) - this.ae.o());
        if (a < 0) {
            a = 0;
        }
        return a;
    };
    HorizontalAxisLabelPanelBase.prototype.b0 = function () {
        var e_38, _a;
        var a = this.ae.at();
        this.ac.gi(a);
        if (this.af != null && this.af.visibility != 0) {
            return;
        }
        var b = this.ac.dg;
        if (b == 0) {
            return;
        }
        var c = this.aw();
        if (c == null) {
            return;
        }
        var d = this.cn.top;
        var e;
        var f = this.ag;
        if (f == 0 || f == 4) {
            d = this.cn.bottom;
            e = d - this.ac.dg;
        }
        else {
            e = d + this.ac.dg;
        }
        var g = this.ae.b();
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                this.cg(a, h, d, e, this.co, g);
            }
        }
        catch (e_38_1) {
            e_38 = { error: e_38_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_38)
                    throw e_38.error;
            }
        }
        if (!this.ab.contains(this.ae.av)) {
            this.ab.add(this.ae.av);
        }
    };
    HorizontalAxisLabelPanelBase.$t = markType(HorizontalAxisLabelPanelBase, 'HorizontalAxisLabelPanelBase', AxisLabelPanelBase.$);
    return HorizontalAxisLabelPanelBase;
}(AxisLabelPanelBase));
/**
 * @hidden
 */
var HorizontalAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAxisLabelPanel, _super);
    function HorizontalAxisLabelPanel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalAxisLabelPanel.prototype.ah = function () {
        return 1;
    };
    HorizontalAxisLabelPanel.prototype.as = function (a) {
        return a == 5 || a == 4 || a == 1 || a == 0;
    };
    HorizontalAxisLabelPanel.$t = markType(HorizontalAxisLabelPanel, 'HorizontalAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
    return HorizontalAxisLabelPanel;
}(HorizontalAxisLabelPanelBase));
/**
 * @hidden
 */
var NumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAxisBase, _super);
    function NumericAxisBase() {
        var _this = _super.call(this) || this;
        _this.jy = 0;
        _this.ka = 0;
        _this.j1 = 0;
        _this.jx = 0;
        _this.j9 = 0;
        _this.j0 = 0;
        _this.jw = 0;
        _this.jz = 0;
        _this.jn = false;
        _this.kh = 0;
        _this.jf = null;
        _this.jv = false;
        _this.jj = null;
        _this.jm = false;
        _this.kh = 10;
        return _this;
    }
    NumericAxisBase.prototype.a1 = function () {
        return new NumericAxisBaseView(this);
    };
    NumericAxisBase.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.jc = a;
    };
    NumericAxisBase.prototype.get_ca = function () {
        return true;
    };
    Object.defineProperty(NumericAxisBase.prototype, "j4", {
        get: function () {
            return this.jy;
        },
        set: function (a) {
            if (this.j4 != a) {
                var b = this.jy;
                this.jy = a;
                this.ka = Math.log(this.j4);
                this.g0("ActualMinimumValue", b, this.j4);
            }
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.prototype.e9 = function () {
        return this.kc;
    };
    Object.defineProperty(NumericAxisBase.prototype, "j7", {
        get: function () {
            return this.j1;
        },
        set: function (a) {
            if (this.j7 != a) {
                var b = this.j1;
                this.j1 = a;
                this.g0("ActualVisibleMinimumValue", b, this.j7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "j3", {
        get: function () {
            return this.jx;
        },
        set: function (a) {
            if (this.j3 != a) {
                var b = this.jx;
                this.jx = a;
                this.j9 = Math.log(this.j3);
                this.g0("ActualMaximumValue", b, this.j3);
            }
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.prototype.e8 = function () {
        return this.j3;
    };
    Object.defineProperty(NumericAxisBase.prototype, "j6", {
        get: function () {
            return this.j0;
        },
        set: function (a) {
            if (this.j6 != a) {
                var b = this.j0;
                this.j0 = a;
                this.g0("ActualVisibleMaximumValue", b, this.j6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "j2", {
        get: function () {
            return this.jw;
        },
        set: function (a) {
            if (this.j2 != a) {
                var b = this.jw;
                this.jw = a;
                this.g0("ActualInterval", b, this.j2);
            }
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.prototype.d7 = function () {
        return this.j2;
    };
    Object.defineProperty(NumericAxisBase.prototype, "j5", {
        get: function () {
            return this.jz;
        },
        set: function (a) {
            if (this.j5 != a) {
                var b = this.jz;
                this.jz = a;
                this.g0("ActualMinorInterval", b, this.j5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "jp", {
        get: function () {
            return this.jn;
        },
        set: function (a) {
            if (this.jp != a) {
                var b = this.jn;
                if (b != a) {
                    this.jn = a;
                    this.g0("ActualIsLogarithmic", b, this.jp);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "ju", {
        get: function () {
            return this.jp && this.j4 > 0 && this.kh > 1;
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        if (this.ju && this.bf != null) {
            var b = this.iw();
            var c = this.iv();
            var d = this.jg(this.i1, this.bf.mq, b, c);
            if (d == null) {
                return;
            }
            var _loop_3 = function (e) {
                var f = this_1.kg;
                var g = d.k._inner[e];
                var h = Math.min(g.d, g.c);
                var i = Math.max(g.d, g.c);
                var j = Math.floor(logBase(h, f));
                var k = Math.ceil(logBase(i, f));
                if (k - j < 2) {
                    if (typeCast(LogarithmicTickmarkValues.$, this_1.jj) !== null) {
                        this_1.jj = new LinearTickmarkValues();
                    }
                }
                else {
                    this_1.jj = this_1.jl != null ? this_1.jl : ((function () {
                        var $ret = new LogarithmicTickmarkValues();
                        $ret.x = f;
                        return $ret;
                    })());
                }
            };
            var this_1 = this;
            for (var e = 0; e < d.k.count; e++) {
                _loop_3(e);
            }
        }
    };
    NumericAxisBase.prototype.gz = function (a) {
        _super.prototype.gz.call(this, a);
        this.kc = a;
    };
    NumericAxisBase.prototype.gy = function (a) {
        _super.prototype.gz.call(this, a);
        this.kb = a;
    };
    NumericAxisBase.prototype.gu = function (a, b, c, d) {
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[4]:
                this.cl();
                this.g6(false);
                break;
            case NumericAxisBase.$$p[3]:
                this.cl();
                this.g6(false);
                break;
            case NumericAxisBase.$$p[1]:
                this.jv = true;
                this.jp = this.jt;
                break;
            case Axis.$$p[4]:
            case Axis.$$p[3]:
            case NumericAxisBase.$$p[0]:
            case NumericAxisBase.$$p[5]:
                this.cg = true;
                this.g6(false);
                break;
            case NumericAxisBase.$$p[2]:
                this.jv = true;
                this.kh = this.kg;
                if (this.jp) {
                    this.cl();
                    this.k1();
                    this.g6(false);
                }
                break;
            case NumericAxisBase.$$p[6]:
                var e = new AxisRangeChangedEventArgs(0, this.j4, this.j4, this.j3, this.j3);
                this.g1(e);
                this.cg = true;
                this.g6(false);
                break;
            case Axis.$$p[10]:
                this.jf = this.jd();
                this.cg = true;
                this.g6(false);
                break;
            case "TickmarkValues":
                this.k3();
                break;
            case "ActualIsLogarithmic":
                this.cl();
                this.k1();
                this.cg = true;
                this.k3();
                this.g6(false);
                break;
            case "ActualTickmarkValues":
                this.cg = true;
                this.g6(false);
                break;
            case "AbbreviateLargeNumbers":
                this.g6(false);
                break;
        }
    };
    NumericAxisBase.prototype.k1 = function () {
        var e_39, _a;
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.jd(false);
            }
        }
        catch (e_39_1) {
            e_39 = { error: e_39_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_39)
                    throw e_39.error;
            }
        }
    };
    NumericAxisBase.prototype.jb = function () {
        var e_40, _a;
        var a = new AxisRange(Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY);
        var b = false;
        if (this.bf != null) {
            try {
                for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = c.an(this);
                    if (d != null) {
                        b = true;
                        a = new AxisRange(Math.min(a.c, d.c), Math.max(a.b, d.b));
                    }
                }
            }
            catch (e_40_1) {
                e_40 = { error: e_40_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_40)
                        throw e_40.error;
                }
            }
        }
        if (b) {
            return a;
        }
        return null;
    };
    NumericAxisBase.prototype.kz = function (a, b, c, d, e, f, g) {
        var h = AutoRangeCalculator.a(a, b, c, d, e, f, g);
        f = h.p5;
        g = h.p6;
        return {
            p5: f,
            p6: g
        };
    };
    NumericAxisBase.prototype.cn = function () {
        var a = this.jp && !isNaN_(this.kg) && !isInfinity(this.kg) && this.kg > 1;
        var b;
        var c;
        var d = this.kz(this, this.kc, this.kb, a, this.kg, b, c);
        b = d.p5;
        c = d.p6;
        if (b != this.j4 || c != this.j3 || this.jv) {
            this.jv = false;
            var e = new AxisRangeChangedEventArgs(0, this.j4, b, this.j3, c);
            this.j4 = b;
            this.j3 = c;
            this.g1(e);
            this.k2(e);
            this.g6(true);
            return true;
        }
        return false;
    };
    NumericAxisBase.prototype.k2 = function (a) {
    };
    NumericAxisBase.prototype.ci = function (a) {
        var b = _super.prototype.ci.call(this, a);
        if (b) {
            this.cl();
        }
        return b;
    };
    NumericAxisBase.prototype.bv = function (a) {
        var b = _super.prototype.bv.call(this, a);
        if (b) {
            this.cl();
        }
        return b;
    };
    NumericAxisBase.prototype.je = function (a) {
        return new NumericAxisRenderer(a);
    };
    NumericAxisBase.prototype.jd = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new AxisLabelManager();
            $ret.a = _this;
            $ret.f = _this.cw;
            $ret.e = _this.cv;
            $ret.b = _this.at;
            return $ret;
        })());
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        var b = this.je(a);
        b.u = function () {
            var c = _this.a2.ay();
            var d = _this.a2.a1();
            var e = _this.a2.az();
            var f = _this.a2.a0();
            _this.he();
            _this.gi(c);
            _this.gi(d);
            _this.gi(e);
            _this.gi(f);
        };
        b.o = function (c, d) { return !d.isEmpty && !c.isEmpty; };
        b.d = function (c, d, e, f) { return _this.jg(c, d, e, f); };
        b.g = function (c) { return _this.e6(c); };
        return b;
    };
    NumericAxisBase.prototype.jh = function () {
        return new NumericAxisRenderingParameters();
    };
    NumericAxisBase.prototype.k0 = function () {
    };
    NumericAxisBase.prototype.ji = function () {
        return null;
    };
    NumericAxisBase.prototype.jg = function (a, b, c, d) {
        var e = this.jh();
        var f = this.a2.ay();
        var g = this.a2.a1();
        var h = this.a2.az();
        var i = this.a2.a0();
        var j = this.a2.e();
        var k = this.a2.f();
        var l = this.a2.g();
        e.t = f;
        e.w = g;
        e.u = h;
        e.v = i;
        e.a = j;
        e.c = k;
        e.d = l;
        e.l = this.j3;
        e.m = this.j4;
        e.h = this.jr;
        e.f = this.jk;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.o = this.d9();
        e.g = this.jq();
        e.p = this.j8;
        e.q = this.kd;
        e.s = this.e7;
        if (this.e7 == null && this.ar != null) {
            e.s = "Format";
        }
        e.j = this.cj;
        e.ab = this.jo;
        return e;
    };
    NumericAxisBase.prototype.kf = function (a) {
        var b = this.iw();
        var c = new ScalerParams(0, this.bf.mq, this.i1, this.b8, b);
        return this.dz(a, c);
    };
    NumericAxisBase.prototype.jq = function () {
        return !isNaN_(this.j8);
    };
    Object.defineProperty(NumericAxisBase.prototype, "js", {
        get: function () {
            return !isNaN_(this.kc);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "jr", {
        get: function () {
            return !isNaN_(this.kb);
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.prototype.k3 = function () {
        if (this.jl != null) {
            this.jk = this.jl;
        }
        else if (this.jp) {
            this.jk = new LogarithmicTickmarkValues();
            this.jc.bf();
        }
        else {
            this.jk = new LinearTickmarkValues();
        }
    };
    Object.defineProperty(NumericAxisBase.prototype, "jl", {
        get: function () {
            return typeCast(TickmarkValues.$, this.c(NumericAxisBase.lb));
        },
        set: function (a) {
            this.h(NumericAxisBase.lb, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "jk", {
        get: function () {
            if (this.jj == null) {
                this.k3();
            }
            return this.jj;
        },
        set: function (a) {
            var b = this.jj;
            var c = b != a;
            if (c) {
                this.jj = a;
                this.g0("ActualTickmarkValues", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NumericAxisBase.prototype, "jo", {
        get: function () {
            return this.jm;
        },
        set: function (a) {
            var b = this.jo;
            if (a != b) {
                this.jm = a;
                this.g0("AbbreviateLargeNumbers", b, this.jo);
            }
        },
        enumerable: true,
        configurable: true
    });
    NumericAxisBase.$t = markType(NumericAxisBase, 'NumericAxisBase', Axis.$);
    NumericAxisBase.lb = DependencyProperty.i("TickmarkValues", TickmarkValues.$, NumericAxisBase.$, new PropertyMetadata(1, function (a, b) { return a.g0("TickmarkValues", b.oldValue, b.newValue); }));
    NumericAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAxisBase, 'g0', ['Interval:j8:k4', [1, NaN], 'IsLogarithmic:jt:k5', [0, false], 'LogarithmBase:kg:k6', [1, 10], 'MaximumValue:kb:k7', [1, NaN], 'MinimumValue:kc:k8', [1, NaN], 'MinorInterval:kd:k9', [1, NaN], 'ReferenceValue:ke:la', [1, 0]]);
    return NumericAxisBase;
}(Axis));
/**
 * @hidden
 */
var NumericScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericScaler, _super);
    function NumericScaler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.o = 0;
        _this.n = 0;
        _this.m = 0;
        return _this;
    }
    NumericScaler.prototype.y = function (a) {
        this.l = a;
    };
    NumericScaler.prototype.x = function (a) {
        this.k = a;
    };
    NumericScaler.prototype.w = function (a, b, c) {
        switch (a) {
            case NumericScaler.$$p[1]:
                this.o = this.l;
                this.z();
                break;
            case NumericScaler.$$p[0]:
                this.n = this.k;
                this.z();
                break;
        }
    };
    NumericScaler.prototype.z = function () {
        if (isNaN_(this.l) || isNaN_(this.k) || isInfinity(this.l) || isInfinity(this.k) || this.l < (-7.9228162514264338E+28) || this.k > (7.9228162514264338E+28)) {
            this.m = this.k - this.l;
        }
        else {
            this.m = this.k - this.l;
        }
    };
    NumericScaler.prototype.j = function (a, b, c, d) {
        var e = new List$1(Number_$type, 2, a.count);
        for (var f = b; f < c; f++) {
            e.add(this.q(a.item(f), d));
        }
        return e;
    };
    NumericScaler.prototype.v = function (a, b, c, d) {
        for (var e = b; e < c; e++) {
            a.item(e, this.p(a.item(e), d));
        }
    };
    NumericScaler.prototype.u = function (a, b, c, d, e) {
        for (var f = 0; f < b.count; f++) {
            var g = b.item(f);
            for (var h = c; h < d; h++) {
                a.item(h)[g] = this.p(a.item(h)[g], e);
            }
        }
    };
    NumericScaler.$t = markType(NumericScaler, 'NumericScaler', DependencyObject.$);
    NumericScaler.ac = new Rect(0, 0, 0, 1, 1);
    NumericScaler.$$p = markDep(DependencyProperty, PropertyMetadata, NumericScaler, 'w', ['ActualMaximumValue:k:aa', [1, NaN], 'ActualMinimumValue:l:ab', [1, NaN]]);
    return NumericScaler;
}(DependencyObject));
/**
 * @hidden
 */
var AxisRendererBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisRendererBase, _super);
    function AxisRendererBase(a) {
        var _this = _super.call(this) || this;
        _this.u = null;
        _this.o = null;
        _this.v = null;
        _this.m = null;
        _this.l = null;
        _this.k = null;
        _this.q = null;
        _this.n = null;
        _this.j = null;
        _this.e = null;
        _this.p = null;
        _this.h = null;
        _this.t = null;
        _this.b = null;
        _this.g = null;
        _this.d = null;
        _this.r = null;
        _this.a = null;
        _this.f = null;
        _this.i = null;
        _this.u = function () {
        };
        _this.o = function (b, c) { return false; };
        _this.v = function () {
        };
        _this.m = function (b, c) { return c; };
        _this.l = function (b, c, d, e) {
        };
        _this.k = function (b, c, d) {
        };
        _this.q = function (b, c) { return false; };
        _this.n = function (b, c) { return _this.q(b, c); };
        _this.j = function (b) {
        };
        _this.e = function (b) {
        };
        _this.p = function (b, c, d) { return false; };
        _this.h = function (b, c) { return new LabelPosition(c); };
        _this.t = function (b, c) { return c; };
        _this.g = function (b) { return null; };
        _this.r = function (b, c, d, e) { return c; };
        _this.a = function (b, c, d, e) { return c; };
        _this.b = a;
        _this.d = function (b, c, d, e) { return null; };
        return _this;
    }
    AxisRendererBase.prototype.c = function (a, b, c, d, e) {
        var e_41, _a;
        this.x(c, b);
        if (this.o(b, c)) {
            this.v();
            var f_1 = this.d(b, c, d, e);
            this.x(c, b);
            if (f_1 == null) {
                this.aa();
                return null;
            }
            if (f_1.k.count > 1 && !f_1.g) {
                this.ab(f_1);
            }
            var _loop_4 = function (g) {
                f_1.e = g;
                if (isNaN_(g.c) || isInfinity(g.c) || isNaN_(g.d) || isInfinity(g.d)) {
                    return "continue";
                }
                if (g.d == g.c) {
                    return "continue";
                }
                this_2.e(f_1);
                this_2.b.n(f_1.r);
                var h = 0;
                var i = 0;
                var j = false;
                var k = function (l) { return l; };
                if (this_2.f != null) {
                    k = this_2.i;
                }
                if (typeCast(CategoryAxisRenderingParameters.$, f_1) !== null) {
                    h = f_1.ab;
                    i = f_1.af;
                    j = f_1.ac;
                }
                f_1.f = this_2.s(f_1);
                f_1.f.s(((function () {
                    var $ret = new TickmarkValuesInitializationParameters();
                    $ret.n = f_1.e.d;
                    $ret.m = f_1.e.c;
                    $ret.g = f_1.m;
                    $ret.f = f_1.l;
                    $ret.k = f_1.e.b;
                    $ret.d = f_1.g;
                    $ret.l = f_1.p;
                    $ret.j = f_1.q;
                    $ret.h = f_1.o;
                    $ret.i = f_1.e.a;
                    $ret.p = f_1.e.e;
                    $ret.a = h;
                    $ret.q = i;
                    $ret.s = f_1.aa;
                    $ret.r = f_1.z;
                    $ret.e = j;
                    $ret.c = k;
                    return $ret;
                })()));
                this_2.y(f_1);
            };
            var this_2 = this;
            try {
                for (var _b = __values(fromEnum(f_1.k)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    _loop_4(g);
                }
            }
            catch (e_41_1) {
                e_41 = { error: e_41_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_41)
                        throw e_41.error;
                }
            }
            this.z();
            return f_1;
        }
        return null;
    };
    AxisRendererBase.prototype.aa = function () {
        this.b.p();
    };
    AxisRendererBase.prototype.ab = function (a) {
        var e_42, _a, e_43, _b;
        var b = -1.7976931348623157E+308;
        var c = -2147483648;
        var d = 0;
        var e = 0;
        var f = false;
        var g = function (h) { return h; };
        if (this.f != null) {
            g = this.i;
        }
        if (typeCast(CategoryAxisRenderingParameters.$, a) !== null) {
            d = a.ab;
            e = a.af;
            f = a.ac;
        }
        var _loop_5 = function (h) {
            a.e = h;
            a.f.s(((function () {
                var $ret = new TickmarkValuesInitializationParameters();
                $ret.n = h.d;
                $ret.m = h.c;
                $ret.g = a.m;
                $ret.f = a.l;
                $ret.k = h.b;
                $ret.d = a.g;
                $ret.l = a.p;
                $ret.i = h.a;
                $ret.p = h.e;
                $ret.h = a.o;
                $ret.j = a.q;
                $ret.a = d;
                $ret.q = e;
                $ret.s = a.aa;
                $ret.r = a.z;
                $ret.e = f;
                $ret.c = g;
                return $ret;
            })()));
            h.a = a.f.m;
            h.e = a.f.r;
            if (!isNaN_(a.f.m)) {
                b = Math.max(b, a.f.m);
                c = Math.max(c, a.f.r);
            }
        };
        try {
            for (var _c = __values(fromEnum(a.k)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var h = _d.value;
                _loop_5(h);
            }
        }
        catch (e_42_1) {
            e_42 = { error: e_42_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_42)
                    throw e_42.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a.k)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var i = _f.value;
                if (i.a == b) {
                    i.a = -1;
                    i.e = -1;
                }
                else {
                    i.a = b;
                    i.e = c;
                }
            }
        }
        catch (e_43_1) {
            e_43 = { error: e_43_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_43)
                    throw e_43.error;
            }
        }
    };
    AxisRendererBase.prototype.x = function (a, b) {
        this.u();
        this.b.m(a, b);
        this.b.s();
    };
    AxisRendererBase.prototype.z = function () {
        var e_44, _a;
        this.b.s();
        var a = false;
        if (this.b.d) {
            this.b.r(0);
        }
        else {
            var b = 0;
            try {
                for (var _b = __values(fromEnum(this.b.e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    var d = typeCast(FrameworkElement.$, c);
                    if (d == null) {
                        d = this.b.t(b);
                        var e = d.ak;
                        var f = c.toString();
                        var g = 0;
                        var h = 0;
                        if (e != null) {
                            g = e.length;
                        }
                        if (f != null) {
                            h = f.length;
                        }
                        if (g != h) {
                            a = true;
                        }
                        d.ak = f;
                        b++;
                    }
                    else {
                        this.b.h(d);
                    }
                }
            }
            catch (e_44_1) {
                e_44 = { error: e_44_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_44)
                        throw e_44.error;
                }
            }
            if (a) {
                this.b.o();
            }
            this.b.g();
            this.b.r(b);
        }
    };
    AxisRendererBase.prototype.s = function (a) {
        return a.f;
    };
    AxisRendererBase.prototype.y = function (a) {
        var b = a.f.j();
        var c = a.f.k();
        this.b.q(this.m(a, a.f.m));
        this.j(a);
        for (var d = 0; d < b.length; d++) {
            var e = a.f.p + d;
            var f = b[d];
            var g = f;
            var h = 0;
            if (d < b.length - 1) {
                h = b[d + 1];
            }
            else {
                h = Number.POSITIVE_INFINITY;
            }
            g = this.r(a, g, e, a.f.m);
            h = this.r(a, h, e, a.f.m);
            var i = this.m(a, g);
            var j = this.m(a, h);
            if (this.q(a, i)) {
                if (e % 2 == 0 && this.n(a, j) && !isInfinity(j)) {
                    this.l(a, a.w, i, j);
                }
                a.b = a.c;
                this.k(a, a.u, i);
                a.b = null;
            }
            i = this.a(a, i, e, a.f.m);
            if (!isNaN_(i) && !isInfinity(i) && this.p(a, i, d == b.length - 1)) {
                var k = this.w(a, g, e, a.f.m);
                if (k != null) {
                    this.b.i(k, this.h(a, i));
                }
            }
        }
        if (a.j) {
            for (var l = 0; l < c.length; l++) {
                var m = c[l];
                var n = this.m(a, m);
                a.b = a.d;
                this.k(a, a.v, n);
                a.b = null;
            }
        }
    };
    AxisRendererBase.prototype.w = function (a, b, c, d) {
        return null;
    };
    AxisRendererBase.$t = markType(AxisRendererBase, 'AxisRendererBase');
    return AxisRendererBase;
}(Base));
/**
 * @hidden
 */
var NumericAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAxisRenderer, _super);
    function NumericAxisRenderer(a) {
        var _this = _super.call(this, a) || this;
        _this.ac = null;
        _this.ad = false;
        return _this;
    }
    NumericAxisRenderer.prototype.w = function (a, b, c, d) {
        var e;
        if (a.s != null) {
            e = this.g(b);
        }
        else {
            b = Math.round(b * 1000000) / 1000000;
            if (a.i() && a.ab) {
                return this.ae(b);
            }
            e = b.toString();
        }
        return e;
    };
    NumericAxisRenderer.prototype.ae = function (a) {
        if (this.ad) {
            return a.toString();
        }
        if (this.ac == null) {
            this.ac = NumberAbbreviatorFactory.a(this.b.a.br);
            if (this.ac == null) {
                this.ad = true;
                return a.toString();
            }
        }
        return this.ac.abbreviate(a);
    };
    NumericAxisRenderer.$t = markType(NumericAxisRenderer, 'NumericAxisRenderer', AxisRendererBase.$);
    return NumericAxisRenderer;
}(AxisRendererBase));
/**
 * @hidden
 */
var VerticalAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAxisLabelPanel, _super);
    function VerticalAxisLabelPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c1 = 0;
        _this.cy = 0;
        _this.c0 = 0;
        _this.cz = 0;
        return _this;
    }
    VerticalAxisLabelPanel.prototype.ad = function () {
        return new VerticalAxisLabelPanelView(this);
    };
    VerticalAxisLabelPanel.prototype.b8 = function (a) {
        _super.prototype.b8.call(this, a);
        this.cs = a;
    };
    VerticalAxisLabelPanel.prototype.bx = function () {
        this.cs.ay();
    };
    VerticalAxisLabelPanel.prototype.bh = function () {
        return this.ac.bc != null ? this.ac.bc.angle : -90;
    };
    VerticalAxisLabelPanel.prototype.cu = function () {
        var a = 0;
        var b = this.ai(this.ac.bc);
        if (b == 1) {
            a += this.bl();
        }
        var c = this.ag;
        if (c == 3 || c == 7) {
            a += this.ac.dg;
        }
        return a;
    };
    VerticalAxisLabelPanel.prototype.cw = function () {
        var a = 0;
        var b = this.ai(this.ac.bc);
        if (b == 2) {
            a += this.bl();
        }
        var c = this.ag;
        if (c == 2 || c == 6) {
            a += this.ac.dg;
        }
        return a;
    };
    VerticalAxisLabelPanel.prototype.cx = function () {
        var a = (this.a5 - this.cu()) - this.cw();
        if (a < 0) {
            a = 0;
        }
        return a;
    };
    VerticalAxisLabelPanel.prototype.cv = function () {
        var a = ((this.cx() - this.ae.p()) - this.ae.q());
        if (a < 0) {
            a = 0;
        }
        return a;
    };
    VerticalAxisLabelPanel.prototype.ay = function () {
        var a = new List$1(Rect.$, 0);
        this.aq = false;
        this.ap = false;
        if (this.af != null && this.af.j() && this.bd() % 360 != 0) {
            this.ap = true;
        }
        this.c1 = -1.7976931348623157E+308;
        this.cy = -1.7976931348623157E+308;
        this.c0 = -1.7976931348623157E+308;
        this.cz = -1.7976931348623157E+308;
        var b = this.ae.p();
        var c = this.ae.r();
        var d = this.ae.q();
        var e = this.ae.o();
        var f = this.cu();
        var g = false;
        if (!isNaN_(this.a6)) {
            this.c1 = Math.max(this.a6, this.c1);
            this.c0 = Math.max(this.a7, this.c0);
        }
        for (var h = 0; h < this.a3.count; h++) {
            var i = this.a3._inner[h];
            var j = this.a2._inner[h].a;
            var k = this.bb(i);
            var l = this.bc(i);
            var m = k + c + e;
            var n = l + b + d;
            var o = this.cn.left + f;
            var p = this.a2._inner[h].c - m / 2;
            if (j) {
                var q = this.a6;
                if ((isNaN_(this.a6) || n > this.a6 || this.a2._inner[h].b) && !g) {
                    if (this.a2._inner[h].b) {
                        g = true;
                    }
                    this.a2._inner[h].b = false;
                    this.a6 = n;
                    this.a7 = l;
                }
                this.c1 = Math.max(this.a6, this.c1);
                this.cy = Math.max(m, this.cy);
                this.c0 = Math.max(this.a7, this.c0);
                this.cz = Math.max(k, this.cz);
            }
            else {
                this.c1 = Math.max(n, this.c1);
                this.cy = Math.max(m, this.cy);
                this.c0 = Math.max(l, this.c0);
                this.cz = Math.max(k, this.cz);
            }
            var r = new Rect(0, o, p, n, m);
            a.add(r);
        }
        var s = 0;
        if (this.ap) {
            s = this.bd() % 360;
            if (s < 0) {
                s += 360;
            }
        }
        var t = this.ac.bz();
        if (!t) {
            this.c2(s, b, d);
        }
        else {
            this.ae.ac();
        }
        if (this.ap) {
            for (var u = 0; u < a.count; u++) {
                var v = a._inner[u];
                v.y = this.a2._inner[u].c - this.cy / 2;
                a._inner[u] = v;
            }
        }
        var w = false;
        if (!this.ap && this.c1 <= this.a5) {
            w = true;
        }
        if (!w) {
            var x = this.cn.height;
            var y = this.cx();
            var z = y;
            var aa = this.a2.count > 1 ? Math.abs(this.a2._inner[1].c - this.a2._inner[0].c) : x;
            var ab = Math.abs(Math.asin(aa / this.c1) * (180 / Math.PI));
            var ac = (s >= ab && s <= 180 - ab) || (s - 180 >= ab && s - 180 <= 180 - ab);
            for (var ad = 0; ad < a.count; ad++) {
                if (this.ap) {
                    var ae = s * (Math.PI / 180);
                    var af = this.bm(this.a3._inner[ad]);
                    z = Math.min(y / Math.abs(Math.cos(ae)), af);
                    if (ac) {
                        var ag = void 0;
                        if (s > 0 && s < 90) {
                            ag = (Math.PI / 180) * (90 - s);
                        }
                        else if (s > 270 && s < 360) {
                            ag = (Math.PI / 180) * (s - 270);
                        }
                        else {
                            ag = 0;
                        }
                        z = aa / Math.cos(ag);
                    }
                }
                var ah = a._inner[ad];
                ah.width = Math.min(ah.width, z);
                a._inner[ad] = ah;
                if (!(typeCast(TextBlock.$, this.a3._inner[ad]) !== null)) {
                    this.a3._inner[ad].width = z;
                }
                var ai = typeCast(TextBlock.$, this.a3._inner[ad]);
                if (ai != null) {
                    var aj = this.bs(ad, ai, z, b, d);
                    if (!Base.equalsStatic(ai.ak, aj)) {
                        ai.ak = aj;
                        this.a3._inner[ad].width = z;
                    }
                }
            }
            if (!t) {
                this.c2(s, b, d);
            }
        }
        if (this.ct()) {
            this.c3(a);
        }
        return a;
    };
    VerticalAxisLabelPanel.prototype.c2 = function (a, b, c) {
        var d = a * (Math.PI / 180);
        var e = Math.abs(this.c0 * Math.cos(d)) + Math.abs(this.cz * Math.sin(d));
        var f = this.bl();
        var g = (e + b + c) + (f) + this.ac.dg;
        this.a9 = Math.max(this.ac.d4, g);
    };
    VerticalAxisLabelPanel.prototype.c3 = function (a) {
        this.cs.az(a, this.c1);
    };
    VerticalAxisLabelPanel.prototype.cb = function (a, b) {
        var c = 0;
        var d = this.cz / 2;
        var e = new TransformGroup();
        var f = AngleSimplifier.a(this.bd());
        var g = ((function () {
            var $ret = new RotateTransform();
            $ret.j = f;
            $ret.k = c;
            $ret.l = d;
            return $ret;
        })());
        var h = 0;
        var i = 0;
        if (f != 0 && f != 360) {
            f -= 90;
            if (f > 0 && f < 180) {
                g.k = this.c0;
                h = -this.c0 + this.cz / 2;
                h = h + Math.sin(MathUtil.k(f - 180)) * (this.cz / 2);
            }
            else {
                if (f >= 180) {
                    h = h - Math.cos(MathUtil.k(f)) * (this.cz / 2);
                }
                else {
                    h = h + Math.cos(MathUtil.k(f)) * (this.cz / 2);
                }
            }
        }
        var j = ((function () {
            var $ret = new TranslateTransform();
            $ret.j = h;
            $ret.k = i;
            return $ret;
        })());
        e.j.add(g);
        e.j.add(j);
        a.j = e;
    };
    VerticalAxisLabelPanel.prototype.ct = function () {
        return !this.aq && !this.ap;
    };
    VerticalAxisLabelPanel.prototype.cm = function () {
        var a = this.ai(this.ac.bc);
        var b = this.bl();
        var c = this.ag;
        var d = 0;
        if (a == 1) {
            d += this.cn.left;
            if (c == 3 || c == 7) {
                d += this.ac.dg;
            }
        }
        else {
            d = this.cn.right - b;
            if (c == 6 || c == 2) {
                d -= this.ac.dg;
            }
        }
        var e = this.bj();
        var f = 0;
        var g = this.ac.bc == null ? 1 : this.ac.bc.verticalAlignment;
        if (g == 0) {
            f = this.cn.top;
        }
        else if (g == 2) {
            f = this.cn.bottom - e;
        }
        else {
            f = (this.cn.top + (this.cn.height / 2)) - (e / 2);
        }
        return new Rect(0, d, f, b, e);
    };
    VerticalAxisLabelPanel.prototype.ai = function (a) {
        if (a == null) {
            return this.ac.bf.ak(this.ac);
        }
        if (a.position == 0) {
            if (this.ac != null && this.ac.bf != null) {
                return this.ac.bf.ak(this.ac);
            }
            return 1;
        }
        return a.position;
    };
    VerticalAxisLabelPanel.prototype.ah = function () {
        return 2;
    };
    VerticalAxisLabelPanel.prototype.as = function (a) {
        return a == 2 || a == 3 || a == 6 || a == 7;
    };
    VerticalAxisLabelPanel.prototype.b0 = function () {
        var e_45, _a;
        var a = this.ae.at();
        this.ac.gi(a);
        if (this.af != null && this.af.visibility != 0) {
            return;
        }
        var b = this.ac.dg;
        if (b == 0) {
            return;
        }
        var c = this.aw();
        if (c == null) {
            return;
        }
        var d = this.cn.left;
        var e;
        var f = this.ag;
        if (f == 2 || f == 6) {
            d = this.cn.right;
            e = d - b;
        }
        else {
            e = d + b;
        }
        var g = this.ae.b();
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                this.b3(a, h, d, e, this.co, g);
            }
        }
        catch (e_45_1) {
            e_45 = { error: e_45_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_45)
                    throw e_45.error;
            }
        }
        if (!this.ab.contains(this.ae.av)) {
            this.ab.add(this.ae.av);
        }
    };
    VerticalAxisLabelPanel.$t = markType(VerticalAxisLabelPanel, 'VerticalAxisLabelPanel', AxisLabelPanelBase.$);
    return VerticalAxisLabelPanel;
}(AxisLabelPanelBase));
/**
 * @hidden
 */
var IHasCategoryAxis_$type = /*@__PURE__*/ new Type(null, 'IHasCategoryAxis');
/**
 * @hidden
 */
var IHasCategoryModePreference_$type = /*@__PURE__*/ new Type(null, 'IHasCategoryModePreference', null, [IHasCategoryAxis_$type]);
/**
 * @hidden
 */
var IHighlightingManager_$type = /*@__PURE__*/ new Type(null, 'IHighlightingManager');
/**
 * @hidden
 */
var HighlightingInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighlightingInfo, _super);
    function HighlightingInfo() {
        var _this = _super.call(this) || this;
        _this.f = 0;
        _this.e = 0;
        _this.a = 0;
        _this.d = 0;
        _this.c = false;
        _this.b = null;
        _this.a = HighlightingState.outward;
        _this.d = 0;
        _this.c = false;
        return _this;
    }
    HighlightingInfo.$t = markType(HighlightingInfo, 'HighlightingInfo');
    return HighlightingInfo;
}(Base));
/**
 * @hidden
 */
var ISeriesInteractionManager_$type = /*@__PURE__*/ new Type(null, 'ISeriesInteractionManager');
/**
 * @hidden
 */
var ISeriesViewerInteractionManager_$type = /*@__PURE__*/ new Type(null, 'ISeriesViewerInteractionManager');
/**
 * @hidden
 */
var IDataChartVisualDataManager_$type = /*@__PURE__*/ new Type(null, 'IDataChartVisualDataManager');
/**
 * @hidden
 */
var IAxisVisualDataManager_$type = /*@__PURE__*/ new Type(null, 'IAxisVisualDataManager');
/**
 * @hidden
 */
var ISeriesVisualDataManager_$type = /*@__PURE__*/ new Type(null, 'ISeriesVisualDataManager');
/**
 * @hidden
 */
var XamDataChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamDataChart, _super);
    function XamDataChart() {
        var _this = _super.call(this) || this;
        _this._xsr = null;
        _this.nh = null;
        _this.nx = 1;
        _this.ny = 1;
        _this.nd = new AxisCollection();
        _this.axisRangeChanged = null;
        _this.nk = null;
        _this.n0 = 0;
        _this.n2 = 0;
        _this.n1 = 0;
        _this.nz = 0;
        _this.ab = XamDataChart.$;
        var a = _this.axes;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.oz));
        var b = _this.axes;
        b.collectionResetting = delegateCombine(b.collectionResetting, runOn(_this, _this.o0));
        return _this;
    }
    Object.defineProperty(XamDataChart.prototype, "XSRP", {
        get: function () {
            if (this._xsr == null) {
                this._xsr = new SRProvider(this.bn.i.ae);
            }
            return this._xsr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDataChart.prototype, "ni", {
        get: function () {
            var _this = this;
            if (this.nh == null) {
                this.nh = DVContainer.instance.createInstance(IDataChartVisualDataManager_$type, function () { return _this.XSRP.q; });
            }
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    XamDataChart.staticInit = function () {
        XamDataChart.n6 = -1.7976931348623157E+308;
        XamDataChart.n5 = 1.7976931348623157E+308;
    };
    XamDataChart.od = function (a) {
        if (a.bs == null) {
            return -1;
        }
        if (!a.cw) {
            return -1;
        }
        var b = XamDataChartView.au(a);
        if (b.count == 0) {
            return -1;
        }
        var c = -1;
        for (var d = 0; d < b.count; d++) {
            c = Math.max(c, b._inner[d].fh);
        }
        var e = c + 1;
        if (a.cs) {
            e = a.e7();
            if (e == -1) {
                return -1;
            }
            var f = a.a6();
            e = f.fh + e;
        }
        return e;
    };
    XamDataChart.prototype.jd = function (a, b, c, d) {
        var e_46, _a, e_47, _b, e_48, _c;
        _super.prototype.jd.call(this, a, b, c, d);
        switch (b) {
            case XamDataChart.$$p[15]:
                this.n3 = this.ob;
                break;
            case XamDataChart.$$p[16]:
                this.n4 = this.oc;
                break;
            case "ActualWindowScaleHorizontal":
            case "ActualWindowScaleVertical":
                if (!this.dg) {
                    this.kk(this.eg(), this.eh());
                }
                break;
            case XamDataChart.$$p[5]:
                this.bn.fg(d);
                {
                    try {
                        for (var _d = __values(fromEnum(this.axes)), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var e = _e.value;
                            e.g5();
                        }
                    }
                    catch (e_46_1) {
                        e_46 = { error: e_46_1 };
                    }
                    finally {
                        try {
                            if (_e && !_e.done && (_a = _d.return))
                                _a.call(_d);
                        }
                        finally {
                            if (e_46)
                                throw e_46.error;
                        }
                    }
                }
                break;
            case XamDataChart.$$p[6]:
                this.nr = this.nq;
                break;
            case XamDataChart.$$p[14]:
                this.nt = this.nv;
                break;
            case XamDataChart.$$p[7]:
            case XamDataChart.$$p[9]:
                this.kg();
                break;
            case XamDataChart.$$p[0]:
            case XamDataChart.$$p[13]:
                if (c != d) {
                    try {
                        for (var _f = __values(fromEnum(this.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var f = _g.value;
                            f.cg = true;
                            f.g5();
                        }
                    }
                    catch (e_47_1) {
                        e_47 = { error: e_47_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_47)
                                throw e_47.error;
                        }
                    }
                }
                break;
            case XamDataChart.$$p[4]:
            case XamDataChart.$$p[2]:
            case XamDataChart.$$p[3]:
                try {
                    for (var _h = __values(fromEnum(this.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                        var g = _j.value;
                        g.hc();
                    }
                }
                catch (e_48_1) {
                    e_48 = { error: e_48_1 };
                }
                finally {
                    try {
                        if (_j && !_j.done && (_c = _h.return))
                            _c.call(_h);
                    }
                    finally {
                        if (e_48)
                            throw e_48.error;
                    }
                }
                break;
        }
    };
    XamDataChart.prototype.o2 = function () {
        var e_49, _a, e_50, _b;
        this.mu = this.ms(this.m3);
        try {
            for (var _c = __values(fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                a.cg = true;
                a.g5();
            }
        }
        catch (e_49_1) {
            e_49 = { error: e_49_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_49)
                    throw e_49.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var b = _f.value;
                b.jd(false);
            }
        }
        catch (e_50_1) {
            e_50 = { error: e_50_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_50)
                    throw e_50.error;
            }
        }
    };
    XamDataChart.prototype.eg = function () {
        return this.n3;
    };
    XamDataChart.prototype.eh = function () {
        return this.n4;
    };
    XamDataChart.prototype.j9 = function () {
        _super.prototype.j9.call(this);
        this.n3 = this.mq.width;
        this.n4 = this.mq.height;
    };
    Object.defineProperty(XamDataChart.prototype, "n3", {
        get: function () {
            return this.nx;
        },
        set: function (a) {
            var b = this.nx;
            this.nx = a;
            this.jh("ActualWindowScaleHorizontal", b, this.nx);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDataChart.prototype, "n4", {
        get: function () {
            return this.ny;
        },
        set: function (a) {
            var b = this.ny;
            this.ny = a;
            this.jh("ActualWindowScaleVertical", b, this.ny);
        },
        enumerable: true,
        configurable: true
    });
    XamDataChart.prototype.c3 = function () {
        return this.nr;
    };
    XamDataChart.prototype.c4 = function () {
        return this.nt;
    };
    Object.defineProperty(XamDataChart.prototype, "axes", {
        get: function () {
            return this.nd;
        },
        enumerable: true,
        configurable: true
    });
    XamDataChart.prototype.oz = function (a, b) {
        var e_51, _a, e_52, _b, e_53, _c;
        if (b.oldItems != null) {
            try {
                for (var _d = __values(fromEn(b.oldItems)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var c = _e.value;
                    if (c != null) {
                        c.bl = null;
                        c.bf = null;
                        this.jw(c);
                        this.bn.dn(c);
                        c.rangeChanged = delegateRemove(c.rangeChanged, runOn(this, this.o1));
                        this.bn.dp(c);
                        if (c.cx != null) {
                            try {
                                for (var _f = (e_52 = void 0, __values(fromEnum(c.cu()))), _g = _f.next(); !_g.done; _g = _f.next()) {
                                    var d = _g.value;
                                    d.jd(false);
                                }
                            }
                            catch (e_52_1) {
                                e_52 = { error: e_52_1 };
                            }
                            finally {
                                try {
                                    if (_g && !_g.done && (_b = _f.return))
                                        _b.call(_f);
                                }
                                finally {
                                    if (e_52)
                                        throw e_52.error;
                                }
                            }
                        }
                    }
                }
            }
            catch (e_51_1) {
                e_51 = { error: e_51_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_51)
                        throw e_51.error;
                }
            }
            if (this.axes.count == 0) {
                this.j1();
            }
        }
        if (b.newItems != null) {
            try {
                for (var _h = __values(fromEn(b.newItems)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var e = _j.value;
                    if (e != null) {
                        this.kc(e);
                        e.bl = this.actualSyncLink;
                        e.bf = this;
                        e.a2.aw();
                        this.bn.bl(e);
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.o1));
                        this.bn.bi(e);
                    }
                }
            }
            catch (e_53_1) {
                e_53 = { error: e_53_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_53)
                        throw e_53.error;
                }
            }
        }
        this.h1();
    };
    XamDataChart.prototype.o0 = function (a, b) {
        var e_54, _a, e_55, _b, e_56, _c, e_57, _d;
        var c = new List$1(Series.$, 0);
        try {
            for (var _e = __values(fromEnum(this.axes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var d = _f.value;
                if (d.cx != null) {
                    try {
                        for (var _g = (e_55 = void 0, __values(fromEnum(d.cu()))), _h = _g.next(); !_h.done; _h = _g.next()) {
                            var e = _h.value;
                            if (!c.contains(e)) {
                                c.add(e);
                            }
                        }
                    }
                    catch (e_55_1) {
                        e_55 = { error: e_55_1 };
                    }
                    finally {
                        try {
                            if (_h && !_h.done && (_b = _g.return))
                                _b.call(_g);
                        }
                        finally {
                            if (e_55)
                                throw e_55.error;
                        }
                    }
                }
                d.bl = null;
                d.bf = null;
                this.jw(d);
                this.bn.dn(d);
                d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.o1));
                this.bn.dp(d);
                this.j1();
            }
        }
        catch (e_54_1) {
            e_54 = { error: e_54_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_a = _e.return))
                    _a.call(_e);
            }
            finally {
                if (e_54)
                    throw e_54.error;
            }
        }
        try {
            for (var _j = __values(fromEnum(this.series)), _k = _j.next(); !_k.done; _k = _j.next()) {
                var f = _k.value;
                if (!c.contains(f)) {
                    c.add(f);
                }
            }
        }
        catch (e_56_1) {
            e_56 = { error: e_56_1 };
        }
        finally {
            try {
                if (_k && !_k.done && (_c = _j.return))
                    _c.call(_j);
            }
            finally {
                if (e_56)
                    throw e_56.error;
            }
        }
        try {
            for (var _l = __values(fromEnum(c)), _m = _l.next(); !_m.done; _m = _l.next()) {
                var g = _m.value;
                g.jd(false);
            }
        }
        catch (e_57_1) {
            e_57 = { error: e_57_1 };
        }
        finally {
            try {
                if (_m && !_m.done && (_d = _l.return))
                    _d.call(_l);
            }
            finally {
                if (e_57)
                    throw e_57.error;
            }
        }
    };
    XamDataChart.prototype.o1 = function (a, b) {
        var e_58, _a, e_59, _b, e_60, _c;
        var c = typeCast(Axis.$, a);
        if (c == null) {
            return;
        }
        this.h1();
        if (this.axisRangeChanged != null) {
            this.axisRangeChanged(this, new ChartAxisRangeChangedEventArgs(this, c, b.oldMinimumValue, b.minimumValue, b.oldMaximumValue, b.maximumValue));
        }
        if (c.ag != null) {
            c.ag.g2();
        }
        c.g2();
        var d = this.cd;
        if (typeCast(CategoryAxisBase.$, c) !== null) {
            d = true;
        }
        try {
            for (var _d = __values(fromEnum(c.cu())), _e = _d.next(); !_e.done; _e = _d.next()) {
                var e = _e.value;
                e.dl = true;
                this.h1();
                e.jd(d);
            }
        }
        catch (e_58_1) {
            e_58 = { error: e_58_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_58)
                    throw e_58.error;
            }
        }
        if (c.bf != null) {
            try {
                for (var _f = __values(fromEnum(c.bf.series)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var f = _g.value;
                    XamDataChart.o3(c, d, f);
                }
            }
            catch (e_59_1) {
                e_59 = { error: e_59_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_59)
                        throw e_59.error;
                }
            }
        }
        try {
            for (var _h = __values(fromEnum(this.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var g = _j.value;
                if (g != c && g.ag != null && g.ag == c) {
                    g.g2();
                }
            }
        }
        catch (e_60_1) {
            e_60 = { error: e_60_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_60)
                    throw e_60.error;
            }
        }
    };
    XamDataChart.o3 = function (a, b, c) {
    };
    XamDataChart.prototype.ki = function (a, b) {
        var e_61, _a;
        _super.prototype.ki.call(this, a, b);
        if (this.axes == null) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.bl = this.actualSyncLink;
                c.bf = this;
            }
        }
        catch (e_61_1) {
            e_61 = { error: e_61_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_61)
                    throw e_61.error;
            }
        }
    };
    XamDataChart.prototype.getFontInfo = function () {
        this.nk = this.nj.fd;
        return this.nk;
    };
    XamDataChart.prototype.o4 = function () {
        var e_62, _a, e_63, _b;
        this.bn.d6();
        try {
            for (var _c = __values(fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                a.g6(false);
            }
        }
        catch (e_62_1) {
            e_62 = { error: e_62_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_62)
                    throw e_62.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var b = _f.value;
                b.bi.bg();
                b.jd(false);
            }
        }
        catch (e_63_1) {
            e_63 = { error: e_63_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_63)
                    throw e_63.error;
            }
        }
    };
    XamDataChart.prototype.getFontBrush = function () {
        return this.nj.fl;
    };
    XamDataChart.prototype.hi = function () {
        _super.prototype.hi.call(this);
        var a = new List$1(Axis.$, 0);
        for (var b = 0; b < this.axes.count; b++) {
            a.add(this.axes._inner[b]);
        }
        for (var c = 0; c < a.count; c++) {
            this.axes.remove(a._inner[c]);
            if (typeCast(CategoryAxisBase.$, a._inner[c]) !== null) {
                var d = a._inner[c];
                this.jy(d.name, true);
                d.itemsSource = null;
            }
            a._inner[c].gv(null, null);
        }
    };
    XamDataChart.prototype.l5 = function () {
        return this.nj.fh;
    };
    XamDataChart.prototype.dd = function () {
        return true;
    };
    XamDataChart.prototype.kd = function () {
        var e_64, _a;
        _super.prototype.kd.call(this);
        if (!this.c6) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                this.kc(a);
            }
        }
        catch (e_64_1) {
            e_64 = { error: e_64_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_64)
                    throw e_64.error;
            }
        }
    };
    XamDataChart.prototype.l6 = function (a) {
        return this.pp(a, this.m9);
    };
    XamDataChart.prototype.pp = function (a, b) {
        if (b != null && b.count > 0) {
            return b.item(a % b.count);
        }
        else {
            return null;
        }
    };
    XamDataChart.prototype.ma = function (a) {
        return this.pp(a, this.na);
    };
    XamDataChart.prototype.mb = function (a) {
        return this.pp(a, this.nb);
    };
    XamDataChart.prototype.mc = function (a) {
        return this.pp(a, this.nc);
    };
    XamDataChart.prototype.cl = function () {
        if (this.ns) {
            return true;
        }
        return this.np();
    };
    XamDataChart.prototype.np = function () {
        for (var a = 0; a < this.series.count; a++) {
            if (this.series._inner[a].c2 || this.series._inner[a].c0) {
                return true;
            }
        }
        for (var b = 0; b < this.axes.count; b++) {
            if (this.axes._inner[b].b0 || this.axes._inner[b].cc) {
                return true;
            }
        }
        return false;
    };
    XamDataChart.prototype.bm = function () {
        return new XamDataChartView(this);
    };
    XamDataChart.prototype.i1 = function (a) {
        _super.prototype.i1.call(this, a);
        this.nj = a;
    };
    XamDataChart.prototype.jt = function () {
        for (var a = 0; a < this.nd.count; a++) {
            this.nd._inner[a].cg = true;
            this.nd._inner[a].g6(false);
        }
        _super.prototype.jt.call(this);
    };
    Object.defineProperty(XamDataChart.prototype, "n8", {
        get: function () {
            return this.n0;
        },
        set: function (a) {
            this.n0 = a;
            this.o2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDataChart.prototype, "oa", {
        get: function () {
            return this.n2;
        },
        set: function (a) {
            this.n2 = a;
            this.o2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDataChart.prototype, "n9", {
        get: function () {
            return this.n1;
        },
        set: function (a) {
            this.n1 = a;
            this.o2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDataChart.prototype, "n7", {
        get: function () {
            return this.nz;
        },
        set: function (a) {
            this.nz = a;
            this.o2();
        },
        enumerable: true,
        configurable: true
    });
    XamDataChart.prototype.ms = function (a) {
        var b = _super.prototype.ms.call(this, a);
        if (a.isEmpty) {
            return Rect.empty;
        }
        if (this.n8 == 0 && this.oa == 0 && this.n9 == 0 && this.n7 == 0) {
            return Rect.empty;
        }
        if (this.n8 + this.n9 >= a.width || this.oa + this.n7 >= a.height) {
            return Rect.empty;
        }
        var c = new Rect(0, a.left + this.n8, a.top + this.oa, a.width - this.n8 - this.n9, a.height - this.oa - this.n7);
        return c;
    };
    XamDataChart.prototype.mx = function () {
        var a = this.m3;
        var b = this.m4;
        var c = this.mu;
        if (c.isEmpty || a.isEmpty) {
            return a;
        }
        if (c.containsRect(a)) {
            return a;
        }
        if (a.containsRect(c)) {
            return c;
        }
        return a;
    };
    XamDataChart.prototype.oe = function () {
        return this.ni.exportVisualData(this);
    };
    XamDataChart.prototype.om = function () {
        var cvd_ = this.oe();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    };
    XamDataChart.prototype.ja = function () {
        _super.prototype.ja.call(this);
        for (var a = 0; a < this.axes.count; a++) {
            var b = this.axes._inner[a];
            var c = 50;
            if (!isNaN_(b.at.a9)) {
                c = b.at.a9;
            }
            b.di = c;
        }
    };
    XamDataChart.prototype.jv = function () {
        _super.prototype.jv.call(this);
        for (var a = 0; a < this.axes.count; a++) {
            var b = this.axes._inner[a];
            b.di = NaN;
            b.cg = true;
            b.g6(false);
        }
    };
    XamDataChart.prototype.nw = function (a) {
        var e_65, _a;
        var b = new List$1(Axis.$, 0);
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.am(a);
                if (d != null) {
                    b.add(d);
                }
            }
        }
        catch (e_65_1) {
            e_65 = { error: e_65_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_65)
                    throw e_65.error;
            }
        }
        return b;
    };
    XamDataChart.$t = markType(XamDataChart, 'XamDataChart', SeriesViewer.$);
    XamDataChart.n6 = 0;
    XamDataChart.n5 = 0;
    XamDataChart.$$p = markDep(DependencyProperty, PropertyMetadata, XamDataChart, 'jh', ['AlignsGridLinesToPixels:nn:o5', [0, true], 'Brushes:m9:o6', [BrushCollection.$, null], 'DefaultAxisMajorStroke:pm:o7', [Brush.$, null], 'DefaultAxisMinorStroke:pn:o8', [Brush.$, null], 'DefaultAxisStroke:po:o9', [Brush.$, null], 'GridMode:ng:pa', [GridMode_$type, enumGetBox(GridMode_$type, 2)], 'HorizontalZoomable:nq:pb', [0, false], 'IsHorizontalZoomEnabled:nr:pc', [0, false], 'IsSquare:ns:pd', [0, false], 'IsVerticalZoomEnabled:nt:pe', [0, false], 'MarkerBrushes:na:pf', [BrushCollection.$, null], 'MarkerOutlines:nb:pg', [BrushCollection.$, null], 'Outlines:nc:ph', [BrushCollection.$, null], 'ShouldClipGridlines:nu:pi', [0, true], 'VerticalZoomable:nv:pj', [0, false], 'WindowScaleHorizontal:ob:pk', [1, NaN], 'WindowScaleVertical:oc:pl', [1, NaN]]);
    return XamDataChart;
}(SeriesViewer));
/**
 * @hidden
 */
var LabelPanelArranger = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LabelPanelArranger, _super);
    function LabelPanelArranger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LabelPanelArranger.e = function (a, b) {
        var e_66, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.ac;
                var e = d.ag;
                e = LabelPanelArranger.a(c, d, e);
                var f = LabelPanelArranger.b(c);
                var g = 0;
                var h = 0;
                var i = 0;
                if (d.bz()) {
                    c.ae.ac();
                    i = c.a9;
                }
                else {
                    i = c.ba(b);
                }
                g = i;
                h = i;
                if (c.ac.aw != null && c.ac.aw.visibility != 0) {
                    h = 0;
                    g = 0;
                }
                if (c.an()) {
                    switch (f) {
                        case 0:
                            b.y = Math.max(0, b.top + h);
                            b.height = Math.max(0, b.height - h);
                            d.aw.c = 0;
                            break;
                        case 4:
                            if (e != null && (c.a8 - b.top < h && typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                                d.aw.c = 5;
                            }
                            else {
                                d.aw.c = 4;
                            }
                            break;
                        case 5:
                            if (e != null && (b.bottom - c.a8 < h && typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                                if (d.aw != null) {
                                    d.aw.c = 4;
                                }
                            }
                            else {
                                if (d.aw != null) {
                                    d.aw.c = 5;
                                }
                            }
                            break;
                        case 1:
                        default:
                            if (d.aw != null) {
                                d.aw.c = 1;
                            }
                            b.height = Math.max(0, b.height - h);
                            break;
                    }
                }
                if (typeCast(VerticalAxisLabelPanel.$, c) !== null) {
                    switch (f) {
                        case 3:
                            b.width = Math.max(0, b.width - g);
                            d.aw.c = 3;
                            break;
                        case 6:
                            if (e != null && c.a8 - b.left < g) {
                                d.aw.c = 7;
                            }
                            else {
                                d.aw.c = 6;
                            }
                            break;
                        case 7:
                            if (e != null && b.right - c.a8 < g) {
                                d.aw.c = 6;
                            }
                            else {
                                d.aw.c = 7;
                            }
                            break;
                        case 2:
                        default:
                            if (d.aw != null) {
                                d.aw.c = 2;
                            }
                            b.x = Math.max(0, b.left + g);
                            b.width = Math.max(0, b.width - g);
                            break;
                    }
                }
                if (c.ac.b0) {
                    if (d.aw != null) {
                        d.aw.c = f;
                    }
                }
            }
        }
        catch (e_66_1) {
            e_66 = { error: e_66_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_66)
                    throw e_66.error;
            }
        }
        return b;
    };
    LabelPanelArranger.a = function (a, b, c) {
        return b.ah();
    };
    LabelPanelArranger.b = function (a) {
        if (a == null) {
            return 1;
        }
        else {
            var b = a.ac;
            if (b != null && b.aw != null) {
                var c = b.aw.c;
                if (!a.as(c)) {
                    return a.ah();
                }
                return c;
            }
            else {
                return a.ah();
            }
        }
    };
    LabelPanelArranger.c = function (a, b, c, d) {
        var e = a.ac;
        var f = e.ag;
        f = LabelPanelArranger.a(a, e, f);
        var g = LabelPanelArranger.b(a);
        var h;
        var i = a.ba(c);
        var j = Math.max(0, i);
        var k = Math.max(0, i);
        if (a.ac != null && a.ac.aw != null && a.ac.aw.visibility == 1) {
            return;
        }
        switch (g) {
            case 3:
                b.g = b.g - k;
                b.d = b.d - k;
                h = new Rect(0, b.g, c.top, k, c.height);
                d(a, h);
                break;
            case 2:
                h = new Rect(0, b.f, c.top, k, c.height);
                d(a, h);
                b.f = b.f + k;
                b.c = b.c + k;
                break;
            case 7:
                if (f != null) {
                    h = new Rect(0, b.f + a.a8, c.top, k, c.height);
                }
                else {
                    b.d = b.d - k;
                    h = new Rect(0, b.d, c.top, k, c.height);
                }
                d(a, h);
                break;
            case 6:
                if (f != null) {
                    h = new Rect(0, b.f + a.a8 - k, c.top, k, c.height);
                }
                else {
                    h = new Rect(0, b.c, c.top, k, c.height);
                    b.c = b.c + k;
                }
                d(a, h);
                break;
            case 1:
                b.a = b.a - j;
                b.b = b.b - j;
                h = new Rect(0, c.left, b.a, c.width, j);
                d(a, h);
                break;
            case 0:
                h = new Rect(0, c.left, b.h, c.width, j);
                d(a, h);
                b.h = b.h + j;
                b.e = b.e + j;
                break;
            case 5:
                if (f != null) {
                    h = new Rect(0, c.left, b.h + a.a8, c.width, j);
                }
                else {
                    b.b = b.b - j;
                    h = new Rect(0, c.left, b.b, c.width, j);
                }
                d(a, h);
                break;
            case 4:
                if (f != null) {
                    h = new Rect(0, c.left, b.h + a.a8 - j, c.width, j);
                }
                else {
                    h = new Rect(0, c.left, b.e, c.width, j);
                    b.e = b.e + j;
                }
                d(a, h);
                break;
        }
        if (a.ac.b0) {
            h = new Rect(0, c.left, c.top, c.width, c.height);
            d(a, h);
        }
    };
    LabelPanelArranger.d = function (a, b, c, d) {
        var e_67, _a, e_68, _b, e_69, _c;
        var e = new List$1(AxisLabelPanelBase.$, 0);
        var f = new List$1(AxisLabelPanelBase.$, 0);
        try {
            for (var _d = __values(fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var g = _e.value;
                var h = LabelPanelArranger.b(g);
                switch (h) {
                    case 1:
                    case 2:
                    case 0:
                    case 3:
                        f.add(g);
                        break;
                    case 5:
                    case 6:
                    case 4:
                    case 7:
                        e.add(g);
                        break;
                }
            }
        }
        catch (e_67_1) {
            e_67 = { error: e_67_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_67)
                    throw e_67.error;
            }
        }
        try {
            for (var _f = __values(fromEnum(f)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var i = _g.value;
                LabelPanelArranger.c(i, b, c, d);
            }
        }
        catch (e_68_1) {
            e_68 = { error: e_68_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_68)
                    throw e_68.error;
            }
        }
        try {
            for (var _h = __values(fromEnum(e)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var j = _j.value;
                LabelPanelArranger.c(j, b, c, d);
            }
        }
        catch (e_69_1) {
            e_69 = { error: e_69_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_69)
                    throw e_69.error;
            }
        }
    };
    LabelPanelArranger.$t = markType(LabelPanelArranger, 'LabelPanelArranger');
    return LabelPanelArranger;
}(Base));
/**
 * @hidden
 */
var ChartContentManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartContentManager, _super);
    function ChartContentManager(a) {
        var _this = _super.call(this) || this;
        _this.l = null;
        _this.q = new Dictionary$2(ChartContentType_$type, Dictionary$2.$.specialize(DependencyObject.$, ContentInfo.$), 0);
        _this.s = new List$1(Series.$, 0);
        _this.m = false;
        _this.u = null;
        _this.p = false;
        _this.n = false;
        _this.o = false;
        _this.o = true;
        _this.n = true;
        _this.q.addItem(0, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        _this.q.addItem(1, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        _this.q.addItem(2, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        _this.l = a;
        return _this;
    }
    Object.defineProperty(ChartContentManager.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            this.s = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartContentManager.prototype.k = function (a, b, c) {
        var d = this.j(a, b);
        d.a = c;
        return d;
    };
    ChartContentManager.prototype.ac = function (a, b) {
        var c = this.q.item(a);
        if (c.containsKey(b)) {
            c.removeItem(b);
        }
        var d = typeCast(Series.$, b);
        if (d != null && this.t.contains(d)) {
            this.t.remove(d);
        }
    };
    ChartContentManager.prototype.z = function (a) {
        var b = this.u;
        this.u = a;
        if (this.m && b == null && this.u != null) {
            this.u.setTimeout(runOn(this, this.v), 0);
        }
    };
    ChartContentManager.prototype.y = function () {
        if (!this.m) {
            this.m = true;
            if (this.u != null) {
                this.u.setTimeout(runOn(this, this.v), 0);
            }
            else {
            }
        }
    };
    ChartContentManager.prototype.ab = function (a, b, c, d) {
        var e = c;
        if (!e.c) {
            e.b = d;
        }
        else {
            if (!d) {
                e.b = false;
            }
        }
        if (!e.c) {
            e.c = true;
            this.y();
        }
    };
    ChartContentManager.prototype.j = function (a, b) {
        var c = this.q.item(a);
        var d = null;
        if (!((function () { var e = c.tryGetValue(b, d); d = e.p1; return e.ret; })())) {
            d = new ContentInfo();
            d.h = b;
            c.addItem(b, d);
            var e = typeCast(Series.$, b);
            if (e != null && !this.t.contains(e)) {
                if (e.cs) {
                    var f = e.a6();
                    var g = this.t.indexOf(f) + 1;
                    g += e.fb();
                    if (this.t.count <= g || f.fg() == 0 || g == -1) {
                        this.t.add(e);
                    }
                    else {
                        this.t.insert(g, e);
                    }
                }
                else {
                    this.t.add(e);
                }
            }
        }
        return d;
    };
    ChartContentManager.prototype.x = function () {
        this.v();
    };
    ChartContentManager.prototype.v = function () {
        var e_70, _a;
        if (this.l == null || this.q == null) {
            return;
        }
        if (!this.m) {
            return;
        }
        this.m = false;
        if (this.l != null) {
            this.l.hc();
        }
        try {
            for (var _b = __values(fromEnum(this.r())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.f();
            }
        }
        catch (e_70_1) {
            e_70 = { error: e_70_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_70)
                    throw e_70.error;
            }
        }
        if (!this.m) {
            this.l.ji();
        }
    };
    ChartContentManager.prototype._r = function () {
        var a, _a, _b, b, e_71_1, c, _c, _d, d, _e, _f, e, _g, _h, f, e_72_1, _j, _k, g, e_73_1;
        var e_71, _l, e_74, _m, e_75, _o, e_72, _p, e_73, _q;
        return __generator(this, function (_s) {
            switch (_s.label) {
                case 0:
                    a = null;
                    a = this.q.item(1);
                    _s.label = 1;
                case 1:
                    _s.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(a.values)), _b = _a.next();
                    _s.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    b = _b.value;
                    return [4 /*yield*/, b];
                case 3:
                    _s.sent();
                    _s.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_71_1 = _s.sent();
                    e_71 = { error: e_71_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_l = _a.return))
                            _l.call(_a);
                    }
                    finally {
                        if (e_71)
                            throw e_71.error;
                    }
                    return [7 /*endfinally*/];
                case 8:
                    a = this.q.item(0);
                    c = new List$1(ContentInfo.$, 0);
                    try {
                        for (_c = __values(fromEnum(this.t)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            d = _d.value;
                            if (!d.cj) {
                                c.add(a.item(d));
                            }
                        }
                    }
                    catch (e_74_1) {
                        e_74 = { error: e_74_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_m = _c.return))
                                _m.call(_c);
                        }
                        finally {
                            if (e_74)
                                throw e_74.error;
                        }
                    }
                    try {
                        for (_e = __values(fromEnum(this.t)), _f = _e.next(); !_f.done; _f = _e.next()) {
                            e = _f.value;
                            if (e.cj) {
                                c.add(a.item(e));
                            }
                        }
                    }
                    catch (e_75_1) {
                        e_75 = { error: e_75_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_o = _e.return))
                                _o.call(_e);
                        }
                        finally {
                            if (e_75)
                                throw e_75.error;
                        }
                    }
                    _s.label = 9;
                case 9:
                    _s.trys.push([9, 14, 15, 16]);
                    _g = __values(fromEnum(c)), _h = _g.next();
                    _s.label = 10;
                case 10:
                    if (!!_h.done)
                        return [3 /*break*/, 13];
                    f = _h.value;
                    return [4 /*yield*/, f];
                case 11:
                    _s.sent();
                    _s.label = 12;
                case 12:
                    _h = _g.next();
                    return [3 /*break*/, 10];
                case 13: return [3 /*break*/, 16];
                case 14:
                    e_72_1 = _s.sent();
                    e_72 = { error: e_72_1 };
                    return [3 /*break*/, 16];
                case 15:
                    try {
                        if (_h && !_h.done && (_p = _g.return))
                            _p.call(_g);
                    }
                    finally {
                        if (e_72)
                            throw e_72.error;
                    }
                    return [7 /*endfinally*/];
                case 16:
                    a = this.q.item(2);
                    _s.label = 17;
                case 17:
                    _s.trys.push([17, 22, 23, 24]);
                    _j = __values(fromEnum(a.values)), _k = _j.next();
                    _s.label = 18;
                case 18:
                    if (!!_k.done)
                        return [3 /*break*/, 21];
                    g = _k.value;
                    return [4 /*yield*/, g];
                case 19:
                    _s.sent();
                    _s.label = 20;
                case 20:
                    _k = _j.next();
                    return [3 /*break*/, 18];
                case 21: return [3 /*break*/, 24];
                case 22:
                    e_73_1 = _s.sent();
                    e_73 = { error: e_73_1 };
                    return [3 /*break*/, 24];
                case 23:
                    try {
                        if (_k && !_k.done && (_q = _j.return))
                            _q.call(_j);
                    }
                    finally {
                        if (e_73)
                            throw e_73.error;
                    }
                    return [7 /*endfinally*/];
                case 24: return [2 /*return*/];
            }
        });
    };
    ChartContentManager.prototype.r = function () {
        var _this = this;
        return toEnum(function () { return _this._r(); });
    };
    ChartContentManager.prototype.w = function (a) {
        var e_76, _a, e_77, _b, e_78, _c;
        try {
            for (var _d = __values(fromEnum(this.q.item(1).values)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var b = _e.value;
                b.h.gt();
            }
        }
        catch (e_76_1) {
            e_76 = { error: e_76_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_76)
                    throw e_76.error;
            }
        }
        try {
            for (var _f = __values(fromEnum(this.q.item(1).values)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var c = _g.value;
                c.f();
            }
        }
        catch (e_77_1) {
            e_77 = { error: e_77_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_77)
                    throw e_77.error;
            }
        }
        try {
            for (var _h = __values(fromEnum(this.q.item(1).values)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var d = _j.value;
                d.h.i0 = Rect.empty;
            }
        }
        catch (e_78_1) {
            e_78 = { error: e_78_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_78)
                    throw e_78.error;
            }
        }
    };
    ChartContentManager.prototype.ad = function (a, b, c, d) {
        c.i = d;
    };
    ChartContentManager.prototype.aa = function (a, b) {
        if (!b.e) {
            b.e = true;
            this.y();
        }
    };
    ChartContentManager.$t = markType(ChartContentManager, 'ChartContentManager', DependencyObject.$);
    return ChartContentManager;
}(DependencyObject));
/**
 * @hidden
 */
var ContentInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContentInfo, _super);
    function ContentInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.h = null;
        _this.a = null;
        _this.b = false;
        _this.c = false;
        _this.i = null;
        _this.e = false;
        return _this;
    }
    Object.defineProperty(ContentInfo.prototype, "d", {
        get: function () {
            if (this.i.isEmpty) {
                return false;
            }
            if (this.i.width == 0 && this.i.height == 0) {
                return false;
            }
            return true;
        },
        enumerable: true,
        configurable: true
    });
    ContentInfo.prototype.g = function () {
        if (this.e && typeCast(Axis.$, this.h) !== null) {
            this.e = false;
            var a = this.c;
            this.c = true;
            var b = this.h.cm(true);
            if (!b) {
                this.c = a;
            }
        }
    };
    ContentInfo.prototype.f = function () {
        this.g();
        if (typeCast(Axis.$, this.h) !== null) {
            var a = typeCast(Axis.$, this.h);
            if (a.ag != null) {
                var b = a.ag;
                if (b.a3 != null && b.a3.e) {
                    b.a3.g();
                }
            }
        }
        if (this.c) {
            this.c = false;
            this.a(this.b);
            this.b = false;
        }
    };
    ContentInfo.$t = markType(ContentInfo, 'ContentInfo');
    return ContentInfo;
}(Base));
/**
 * @hidden
 */
var Series = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Series, _super);
    function Series() {
        var _this = _super.call(this) || this;
        _this.bi = null;
        _this.fk = 0;
        _this.lp = null;
        _this.e3 = null;
        _this.b1 = null;
        _this.a1 = null;
        _this.az = null;
        _this.bt = null;
        _this.jx = null;
        _this.dy = new Dictionary$2(String_$type, String_$type, 0);
        _this.dx = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.renderRequested = null;
        _this.dm = false;
        _this.bh = null;
        _this.aq = null;
        _this.b6 = true;
        _this.de = false;
        _this.df = false;
        _this.b7 = false;
        _this.cd = false;
        _this.bm = null;
        _this.br = null;
        _this.d3 = null;
        _this.a4 = null;
        _this.b0 = null;
        _this.e0 = null;
        _this.jv = null;
        _this.av = null;
        _this.bl = 0;
        _this.bj = 0;
        _this.bk = 0;
        _this.cf = false;
        _this.b9 = false;
        _this.b5 = false;
        _this.fn = null;
        _this.a7 = new SeriesComponentsForView();
        _this.b8 = false;
        _this.fz = null;
        _this.e2 = null;
        _this._coercionMethods = null;
        _this.b4 = false;
        _this.bb = 0;
        _this.ba = 0;
        _this.b3 = null;
        _this.lf = { $type: Point_$type, x: NaN, y: NaN };
        _this.d4 = NaN;
        _this.d5 = NaN;
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        _this.fk = Series.e5++;
        _this.dl = true;
        _this.lp = Rect.empty;
        _this.bi = _this.bf();
        _this.bi.br = Rect.empty;
        _this.iu(_this.bi);
        _this.bi.k = true;
        _this.bi.ap();
        _this.bi.k = false;
        _this.ab = Series.$;
        _this.b0 = function (a, b) {
            if (_this.bs == null || !_this.bs.cn) {
                _this.jt(b.oldRect, b.newRect);
            }
        };
        _this.a4 = function (a, b) { return _this.iz(a, b.propertyName, b.oldValue, b.newValue); };
        _this.e0 = function (a, b) {
            if (_this.bs != null) {
                _this.dl = true;
                _this.bs.h2();
            }
            _this.hy(b.action, b.position, b.count, b.propertyName);
        };
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.iz(a, b.propertyName, b.oldValue, b.newValue); });
        _this.jx = new Canvas();
        _this.bt = new DoubleAnimator(0, 1, _this.fi);
        var a = _this.bt;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(_this, _this.ho));
        _this.g(Series.k2, ((function () {
            var $ret = new Binding(1, "Visibility");
            $ret.d = _this;
            return $ret;
        })()));
        _this.bc = _this.bd();
        return _this;
    }
    Object.defineProperty(Series.prototype, "e4", {
        get: function () {
            return this.e3;
        },
        set: function (a) {
            this.e3 = a;
            this.bt.u(this.e3);
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.provideRenderer = function (a) {
        this.e4 = a;
    };
    Series.prototype.gv = function () {
        return this.a0.a$q(this);
    };
    Series.prototype.ho = function (a, b) {
        this.ez = this.bt.o;
    };
    Object.defineProperty(Series.prototype, "b2", {
        get: function () {
            if (this.b1 == null) {
                this.b1 = new SRProvider(this.e4);
            }
            if (this.b1.l == null) {
                this.b1.l = this.e4;
            }
            return this.b1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "a2", {
        get: function () {
            var _this = this;
            if (this.a1 == null) {
                this.a1 = DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, function () { return _this.b2.q; });
            }
            return this.a1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "dz", {
        get: function () {
            return this.a0.a$h;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "a0", {
        get: function () {
            var _this = this;
            if (this.az == null) {
                this.az = DVContainer.instance.createInstance(ISeriesInteractionManager_$type, function () { return _this.b2.n; });
                if (this.toolTip != null) {
                    this.az.a$ah(this, this.toolTip);
                }
            }
            return this.az;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "cx", {
        get: function () {
            return DVContainer.instance.checkLoaded("InteractivityFactoryManager");
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.iu = function (a) {
    };
    Series.prototype.is = function () {
        this.hp(this.aw, this.aw);
        if (this.bz == null && this.bn != null && this.itemsSource != null) {
            this.bz = this.bn.getFastItemsSource(this.itemsSource);
        }
        this.bi.as();
    };
    Series.prototype.it = function () {
        this.hu();
        if (this.bz != null && this.bn != null && this.itemsSource != null) {
            this.bz = this.bn.releaseFastItemsSource(this.itemsSource);
        }
        this.bi.at();
    };
    Series.prototype.bg = function () {
        return this.bf();
    };
    Series.prototype.bf = function () {
        return new SeriesView(this);
    };
    Series.prototype.dt = function () {
        return false;
    };
    Series.prototype.fs = function (a, b) {
        return null;
    };
    Series.prototype.gu = function (a) {
        if (!this.dy.containsKey(a)) {
            var b = a.charAt(0).toUpperCase() + a.substr(1);
            this.dy.addItem(a, b);
        }
        return this.dy.item(a);
    };
    Series.prototype.ft = function (a, b, c) {
        var d = null;
        if (!this.dx.containsKey(b)) {
            d = new FastReflectionHelper(false, c);
            this.dx.addItem(b, d);
        }
        else {
            d = this.dx.item(b);
        }
        d.propertyName = c;
        return d.getPropertyValue(a);
    };
    Series.prototype.eb = function (a) {
        return this.e8(a);
    };
    Series.prototype.fa = function (a) {
        return -1;
    };
    Series.prototype.get_c1 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c1", {
        get: function () {
            return this.get_c1();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ap = function () {
        return null;
    };
    Series.prototype.e8 = function (a) {
        return -1;
    };
    Series.prototype.fp = function (a) {
        return null;
    };
    Series.prototype.fu = function (a, b) {
        return a.fp(b);
    };
    Series.prototype.e7 = function () {
        return -1;
    };
    Series.prototype.fb = function () {
        return -1;
    };
    Series.prototype.fg = function () {
        return -1;
    };
    Object.defineProperty(Series.prototype, "container", {
        get: function () {
            return this.bs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "hasSubItems", {
        get: function () {
            return this.ci();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ci = function () {
        return false;
    };
    Series.prototype.forSubItems = function (a) {
        this.h6(a);
    };
    Series.prototype.h6 = function (a) {
    };
    Series.prototype.h7 = function (a) {
    };
    Series.prototype.k9 = function () {
        return null;
    };
    Series.prototype.resolveLegendIndex = function () {
        return this.fh;
    };
    Series.prototype.a6 = function () {
        return null;
    };
    Series.prototype.get_cj = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cj", {
        get: function () {
            return this.get_cj();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_isVertical = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "isVertical", {
        get: function () {
            return this.get_isVertical();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cs = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cs", {
        get: function () {
            return this.get_cs();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_ck = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "ck", {
        get: function () {
            return this.get_ck();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c0 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c0", {
        get: function () {
            return this.get_c0();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c4 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c4", {
        get: function () {
            return this.get_c4();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c2 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c2", {
        get: function () {
            return this.get_c2();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_isStacked = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "isStacked", {
        get: function () {
            return this.get_isStacked();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cr = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cr", {
        get: function () {
            return this.get_cr();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c3 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c3", {
        get: function () {
            return this.get_c3();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cl = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cl", {
        get: function () {
            return this.get_cl();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_ct = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "ct", {
        get: function () {
            return this.get_ct();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c5 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c5", {
        get: function () {
            return this.get_c5();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_c6 = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "c6", {
        get: function () {
            return this.get_c6();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.a5 = function () {
        return null;
    };
    Series.prototype.get_cm = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cm", {
        get: function () {
            return this.get_cm();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cn = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cn", {
        get: function () {
            return this.get_cn();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.d9 = function (a, b, c, d, e) {
        return Number.POSITIVE_INFINITY;
    };
    Series.prototype.ea = function (a, b, c, d, e, f, g) {
        return this.a0.a$i(this, a, b, c, d, e, f, g);
    };
    Series.prototype.get_dv = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "dv", {
        get: function () {
            return this.get_dv();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ep = function (a, b, c, d, e, f, g, h) {
        return this.a0.a$l(this, a, b, c, d, e, f, g, h);
    };
    Series.prototype.ef = function (a, b, c, d, e, f, g, h) {
        return this.a0.a$k(this, a, b, c, d, e, f, g, h);
    };
    Series.prototype.ff = function (a, b, c, d, e) {
        return this.a0.a$n(this, a, b, c, d, e);
    };
    Series.prototype.ee = function (a) {
        return (a ? 10 : 3);
    };
    Series.prototype.ah = function (a) {
        return null;
    };
    Series.prototype.ai = function (a) {
        return null;
    };
    Series.prototype.dg = function (a, b) {
        return this.a0.a$d(this, a, b);
    };
    Series.prototype.aj = function (a, b, c, d, e, f) {
        return this.a0.a$a(this, a, b, c, d, e, f);
    };
    Series.prototype.di = function (a, b, c) {
        return this.a0.a$e(this, a, b, c);
    };
    Series.prototype.dj = function (a, b) {
        return this.a0.a$f(this, a, b);
    };
    Series.prototype.fd = function (a, b, c, d, e) {
        return this.a0.a$m(this, a, b, c, d, e);
    };
    Series.prototype.ed = function (a, b) {
        return this.a0.a$j(this, a, b);
    };
    Series.prototype.fe = function (a, b) {
        return -1;
    };
    Series.prototype.fc = function (a, b) {
        return -1;
    };
    Series.prototype.en = function (a, b, c) {
        return NaN;
    };
    Series.prototype.ll = function (a, b, c) {
        return { $type: Point_$type, x: NaN, y: NaN };
    };
    Series.prototype.lu = function (a) {
        return Rect.empty;
    };
    Series.prototype.ak = function (a) {
        var b = this.lu(a);
        if (!b.isEmpty) {
            var c = new Array(1);
            c[0] = b;
            return c;
        }
        return null;
    };
    Series.prototype.lv = function (a) {
        return this.lu(this.lo(a));
    };
    Series.prototype.al = function (a) {
        return this.ak(this.lo(a));
    };
    Series.prototype.lw = function (a) {
        return Rect.empty;
    };
    Series.prototype.lx = function (a) {
        return this.lw(this.lo(a));
    };
    Series.prototype.dk = function (a, b) {
        return this.a0.a$g(this, a, b);
    };
    Series.prototype.ln = function (a, b, c, d, e, f, g, h, i) {
        return this.a0.a$aj(this, a, b, c, d, e, f, g, h, i);
    };
    Series.prototype.ej = function (a, b, c) {
        return this.en(a, b, c);
    };
    Series.prototype.lh = function (a, b, c) {
        return this.ll(a, b, c);
    };
    Series.prototype.el = function (a, b, c) {
        return this.en(a, b, c);
    };
    Series.prototype.lj = function (a, b, c) {
        return this.ll(a, b, c);
    };
    Series.prototype.lm = function (a, b, c) {
        var d = this.lo(a);
        return this.ll(d, b, c);
    };
    Series.prototype.eo = function (a, b, c) {
        var d = this.lo(a);
        return this.en(d, b, c);
    };
    Series.prototype.li = function (a, b, c) {
        var d = this.lo(a);
        return this.lh(d, b, c);
    };
    Series.prototype.ek = function (a, b, c) {
        var d = this.lo(a);
        return this.ej(d, b, c);
    };
    Series.prototype.lk = function (a, b, c) {
        var d = this.lo(a);
        return this.lj(d, b, c);
    };
    Series.prototype.em = function (a, b, c) {
        var d = this.lo(a);
        return this.el(d, b, c);
    };
    Series.prototype.e9 = function (a) {
        var b = this.lo(a);
        return this.e8(b);
    };
    Series.prototype.eg = function () {
        return 0;
    };
    Series.prototype.ec = function (a) {
        var b = this.lo(a);
        return this.eb(b);
    };
    Series.prototype.fq = function (a) {
        var b = this.lo(a);
        return this.fp(b);
    };
    Series.prototype.ch = function (a, b, c) {
        return false;
    };
    Series.prototype.raisePropertyChanged = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    Series.prototype.get_hasMarkers = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "hasMarkers", {
        get: function () {
            return this.get_hasMarkers();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ia = function () {
    };
    Series.prototype.k6 = function () {
        return null;
    };
    Series.prototype.k7 = function () {
        return null;
    };
    Series.prototype.jz = function () {
        return null;
    };
    Series.prototype.lo = function (a) {
        var b = this.bs != null ? this.bs.mt : this.bi.br;
        var c = this.bi.bs;
        var d = { $type: Point_$type, x: c.left + c.width * (a.x - b.left) / b.width, y: c.top + c.height * (a.y - b.top) / b.height };
        return d;
    };
    Series.prototype.lg = function (a) {
        var b = this.bs != null ? this.bs.mt : this.bi.br;
        var c = this.bi.bs;
        var d = b.left + (a.x - c.left) / c.width * b.width;
        var e = b.top + (a.y - c.top) / c.height * b.height;
        return { $type: Point_$type, x: d, y: e };
    };
    Series.prototype.fv = function (a, b) {
        var c = this.bi.c(a);
        var d = c != null ? c.item : null;
        if (d == null) {
            var e = this.lo(b);
            d = this.fp(e);
        }
        return d;
    };
    Series.prototype.c9 = function (a) {
        return false;
    };
    Series.prototype.an = function (a) {
        return new AxisRange(NaN, NaN);
    };
    Series.prototype.ao = function () {
        return new AxisRange(NaN, NaN);
    };
    Series.prototype.jd = function (a) {
        this.de = false;
        if (this.bs != null) {
            this.bs.al.ab(0, this, this.aq, a);
            if (this.renderRequested != null) {
                var b = new RenderRequestedEventArgs();
                b.animate = a;
                this.renderRequested(this, b);
                a = b.animate;
            }
        }
    };
    Series.prototype.h1 = function (a) {
        this.je(a);
        this.de = false;
    };
    Series.prototype.je = function (a) {
        if (this.dp && !this.dc()) {
            this.dn = false;
        }
    };
    Series.prototype.hs = function () {
        if (this.dm && !this.dp) {
            this.bt.r = truncate(Math.max(this.eq(), this.er()));
            this.hw();
        }
    };
    Series.prototype.hw = function () {
    };
    Series.prototype.jf = function (a, b) {
        if (this.bh == null) {
            this.bh = this.bf();
            this.bh.n = true;
            if (this.bs != null) {
                this.bs.ai.l(this.bh);
                this.bh.a = this.bs.ai;
            }
            this.bh.ap();
        }
        this.bh.br = a;
    };
    Series.prototype.jc = function (a, b, c, d, e) {
        this.a0.a$r(this, a, b, d, e);
    };
    Series.prototype.getEffectiveViewport1 = function (a) {
        if (this.bs == null) {
            return Rect.empty;
        }
        if (a.m) {
            return this.bs.mu;
        }
        if (a.n) {
            if (this.bs.mu.isEmpty) {
                return this.bs.mu;
            }
            var b = this.bs.my(a.br, this.bs.m3, this.bs.mu);
            return b;
        }
        return this.bs.mu;
    };
    Series.prototype.lq = function (a) {
        if (this.bs == null || this.bs.mt.isEmpty) {
            return a.br;
        }
        if (a.m) {
            return a.br;
        }
        if (a.n) {
            if (this.bs.mu.isEmpty) {
                return a.br;
            }
            if (this.bs.mt.equals1(this.bs.m3)) {
                return a.br;
            }
            var b = this.bs.my(a.br, this.bs.m3, this.bs.mu);
            var c = this.bs.mw(a.br, b, this.bs.mq);
            return c;
        }
        return this.bs.mt;
    };
    Series.prototype.lt = function (a) {
        if (!this.ly.equals1(a)) {
            return Rect.empty;
        }
        return this.getEffectiveViewport();
    };
    Series.prototype.ls = function (a) {
        if (this.bs == null || this.bs.mu.isEmpty) {
            return Rect.empty;
        }
        var b = this.bs.mu;
        var c = a.br;
        var d = (b.left - c.left) / c.width;
        var e = (b.top - c.top) / c.height;
        var f = (b.right - c.left) / c.width;
        var g = (b.bottom - c.top) / c.height;
        return new Rect(0, d, e, f - d, g - e);
    };
    Series.prototype.getEffectiveViewport = function () {
        return this.getEffectiveViewport1(this.bi);
    };
    Series.prototype.i7 = function () {
        this.i8(null);
    };
    Series.prototype.i8 = function (a) {
        if (this.cx) {
            this.a0.a$ac(this, a);
        }
    };
    Series.prototype.i9 = function (a) {
        if (this.cx) {
            this.a0.a$ad(this, a, this.bs);
        }
    };
    Series.prototype.getViewInfo = function (a, b) {
        a = this.bi.br;
        b = this.bi.bs;
        return {
            p0: a,
            p1: b
        };
    };
    Series.prototype.dw = function (a, b, c) {
        if (a.width == 0 || a.height == 0) {
            return false;
        }
        if (this.cs) {
            return true;
        }
        return this._visibility == 0;
    };
    Series.prototype.hv = function (a, b) {
        if (a) {
            this.dl = true;
        }
    };
    Series.prototype.cb = function () {
        return this.cc(this.bi);
    };
    Series.prototype.cc = function (a) {
        var b = a.br;
        var c = a.bs;
        if (!this.dw(b, c, a)) {
            this.hv(true, a);
            return true;
        }
        return false;
    };
    Series.prototype.iv = function (a, b) {
        this.bi.br = b;
        this.js(a, b);
        if (this.bs != null) {
            this.bs.al.ad(0, this, this.aq, b);
        }
    };
    Series.prototype.jt = function (a, b) {
    };
    Series.prototype.js = function (a, b) {
    };
    Object.defineProperty(Series.prototype, "dl", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            this.b6 = a;
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.h5 = function (a) {
        a.h2();
    };
    Series.prototype.il = function () {
        this.df = false;
        this.dl = true;
        if (this.bs != null) {
            this.bs.h2();
        }
    };
    Series.prototype.ik = function () {
        this.df = false;
        this.dl = true;
        if (this.bs != null) {
            this.bs.h1();
        }
    };
    Series.prototype.get_cw = function () {
        return true;
    };
    Object.defineProperty(Series.prototype, "cw", {
        get: function () {
            return this.get_cw();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_isUsableInLegend = function () {
        return true;
    };
    Object.defineProperty(Series.prototype, "isUsableInLegend", {
        get: function () {
            return this.get_isUsableInLegend();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.iq = function () {
        this.bi.al();
    };
    Series.prototype.im = function () {
        this.iw();
    };
    Series.prototype.iw = function () {
        this.bi.aw();
        this.iy(false);
    };
    Series.prototype.ix = function () {
        this.bi.aw();
        this.iy(true);
    };
    Series.prototype.c8 = function () {
        return false;
    };
    Series.prototype.iy = function (a) {
        if (this.aq == null || this.aq.c) {
            return;
        }
        var b = this.bi.br;
        var c = this.bi.bs;
        var d = this.dw(b, c, this.bi);
        var e = this.bs != null && this.bs.c1 && this.bh != null && this.dw(this.bh.br, this.bh.bs, this.bh);
        if (d) {
            if (a) {
                this.de = !this.c8();
                this.h1(false);
            }
            else {
                this.jd(false);
                this.de = !this.c8();
            }
        }
        if (e) {
            if (!this.dl) {
                this.ik();
                this.df = true;
            }
        }
    };
    Object.defineProperty(Series.prototype, "dn", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            this.b7 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "dp", {
        get: function () {
            if (this.dn == false) {
                return false;
            }
            return this.er() > 0;
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case "SyncLink":
                if (typeCast(SyncLink.$, c) !== null) {
                    var e = c;
                    e.propertyUpdated = delegateRemove(e.propertyUpdated, this.a4);
                    this.i6(typeCast(IFastItemsSourceProvider_$type, c));
                }
                if (typeCast(SyncLink.$, d) !== null) {
                    var f = d;
                    f.propertyUpdated = delegateCombine(f.propertyUpdated, this.a4);
                    this.i5(typeCast(IFastItemsSourceProvider_$type, d));
                }
                if (this.fh == -1) {
                    this.fh = XamDataChart.od(this);
                }
                break;
            case XamDataChart.$$p[1]:
            case XamDataChart.$$p[11]:
            case XamDataChart.$$p[10]:
            case XamDataChart.$$p[12]:
                this.h2();
                break;
            case "SeriesViewer":
                if (typeCast(SeriesViewer.$, c) !== null) {
                    this.e4 = null;
                    var g = c;
                    g.windowRectChanged = delegateRemove(g.windowRectChanged, this.b0);
                    var h = c.series;
                    h.collectionChanged = delegateRemove(h.collectionChanged, this.d3);
                    var i = c;
                    i.propertyUpdated = delegateRemove(i.propertyUpdated, this.a4);
                    c.al.ac(0, this);
                    this.i8(c);
                    this.bi.ah(c);
                }
                if (typeCast(SeriesViewer.$, d) !== null) {
                    this.e4 = d.bn.i.ae;
                    var j = d;
                    j.windowRectChanged = delegateCombine(j.windowRectChanged, this.b0);
                    var k = d.series;
                    k.collectionChanged = delegateCombine(k.collectionChanged, this.d3);
                    var l = d;
                    l.propertyUpdated = delegateCombine(l.propertyUpdated, this.a4);
                    this.aq = d.al.k(0, this, runOn(this, this.h1));
                    this.bi.ad(d);
                    this.jn();
                    this.h3();
                    this.fk = this.bs.e4();
                }
                if (this.bs == null) {
                    this.externalObject._ensureTooltipDestroyed();
                    this.bt.w();
                }
                if (this.fh != -1) {
                    this.jo();
                }
                if (this.fh == -1 || d == null) {
                    this.fh = XamDataChart.od(this);
                }
                this.aw = this.ax();
                this.hq(typeCast(XamDataChart.$, c), typeCast(XamDataChart.$, d));
                break;
            case Series.$$p[23]:
                if (this.bi != null) {
                    this.bi.av();
                }
                break;
            case "HitTestMode":
                this.bc = this.bd();
                break;
            case "ActualHitTestMode":
                if (this.bs != null) {
                    this.bs.js();
                }
                break;
            case "LegendItemBadgeTemplate":
            case "LegendItemTemplate":
                this.bi.bg();
                break;
            case Series.$$p[4]:
            case Series.$$p[14]:
            case Series.$$p[5]:
            case Series.$$p[6]:
                this.h2();
                this.iw();
                break;
            case "Index":
                if (typeGetValue(c) != typeGetValue(d)) {
                    this.h2();
                    this.iw();
                }
                break;
            case "RadiusX":
            case "RadiusY":
            case "RoundedCornersLocation":
                this.iw();
                break;
            case Series.$$p[3]:
                this.jn();
                this.iw();
                break;
            case Series.$$p[21]:
            case Series.$$p[7]:
            case Series.$$p[12]:
                this.iw();
                break;
            case Series.$$p[9]:
                this.iq();
                this.iw();
                break;
            case Series.$$p[31]:
            case Series.$$p[17]:
            case Series.$$p[16]:
            case Series.$$p[18]:
            case Series.$$p[19]:
                this.iw();
                break;
            case Series.$$p[1]:
            case Series.$$p[2]:
            case Series.$$p[22]:
                this.iw();
                this.bi.bg();
                if (this.toolTip != null && this.az != null) {
                    this.a0.a$ah(this, this.toolTip);
                }
                break;
            case "Visibility":
                this.bi.bh();
                break;
            case "ItemsSource":
                if (this.bn != null) {
                    this.i5(this.bn);
                }
                break;
            case Series.$$p[8]:
                if (c != d && d != null) {
                    this.dn = true;
                }
                this.il();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    var m = c;
                    m.event = delegateRemove(m.event, this.e0);
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    var n = d;
                    n.event = delegateCombine(n.event, this.e0);
                }
                break;
            case "Legend":
                if (d != null) {
                    if (a == this) {
                        d.seriesOwner = this;
                    }
                    else if (typeCast(XamDataChart.$, a) !== null) {
                        d.chartOwner = a;
                    }
                }
                this.aw = this.ax();
                break;
            case "ActualLegend":
                this.hp(typeCast(IChartLegend_$type, c), typeCast(IChartLegend_$type, d));
                break;
            case "LegendItem":
                this.hr(typeCast(Control.$, c), typeCast(Control.$, d));
                break;
            case Series.$$p[11]:
                this.bi.aq();
                break;
            case Series.$$p[24]:
                if (this.az != null) {
                    this.a0.a$ah(this, this.toolTip);
                }
                break;
            case "CrosshairPoint":
                if (this.bs != null) {
                    if (!this.cd) {
                        this.bs.jk(this, this.fp(this.bs.mi));
                    }
                }
                break;
            case Series.$$p[15]:
                this.jd(false);
                this.ik();
                break;
            case Series.$$p[25]:
            case Series.$$p[26]:
                this.bt.w();
                this.bt.r = this.fi;
                this.bt.b = this.bu;
                this.jd(false);
                break;
            case "DiscreteLegendItemTemplate":
                this.jd(false);
                break;
            case "VisibilityProxy":
                if (c != d) {
                    this.jd(false);
                }
                this.ik();
                this.bi.bh();
                break;
            case Series.$$p[10]:
                this.b9 = this.cg();
                this.jd(false);
                break;
            case Series.$$p[20]:
                this.h3();
                break;
            case "FinalValue":
                this.jq();
                break;
        }
    };
    Series.prototype.h3 = function () {
        if (this.bs != null && (this.externalObject.owner)) {
            var sv_ = this.bs;
            this.externalObject.owner._ensureDefaultTooltip(this.externalObject);
            ;
        }
    };
    Series.prototype.cg = function () {
        return this.cu && this.cv;
    };
    Series.prototype.get_cv = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cv", {
        get: function () {
            return this.get_cv();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.h0 = function (a) {
        a.cd = true;
    };
    Object.defineProperty(Series.prototype, "bn", {
        get: function () {
            return this.bm;
        },
        set: function (a) {
            if (this.bn != a) {
                var b = this.bn;
                this.bm = a;
                this.raisePropertyChanged("SyncLink", b, this.bn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "bs", {
        get: function () {
            return this.br;
        },
        set: function (a) {
            if (this.bs != a) {
                var b = this.bs;
                this.br = a;
                this.raisePropertyChanged("SeriesViewer", b, this.br);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "bq", {
        get: function () {
            return typeCast(XamDataChart.$, this.bs);
        },
        set: function (a) {
            this.bs = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "itemsSource", {
        get: function () {
            return this.c(Series.kd);
        },
        set: function (a) {
            this.h(Series.kd, a);
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.hy = function (a, b, c, d) {
        if (this.bs != null) {
            this.bs.jl();
        }
    };
    Object.defineProperty(Series.prototype, "legend", {
        get: function () {
            return this.c(Series.kh);
        },
        set: function (a) {
            this.h(Series.kh, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "jw", {
        get: function () {
            if (this.jv == null && this.aw != null) {
                this.jv = this.ju();
            }
            return this.jv;
        },
        set: function (a) {
            if (this.jw != a) {
                var b = this.jw;
                this.jv = a;
                this.raisePropertyChanged("LegendItem", b, this.jv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.fw = function () {
        return this.ju();
    };
    Series.prototype.ju = function () {
        var _this = this;
        var a = typeCast(ContentControl.$, this.jv);
        var b = this.legendItemTemplate;
        if (b == null) {
            b = this.bi.bi(this.bl);
        }
        if (b != null) {
            if (a == null) {
                a = new ContentControl();
            }
            a.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = null;
                return $ret;
            })());
            a.ah = b;
        }
        else {
            a = null;
        }
        return a;
    };
    Object.defineProperty(Series.prototype, "aw", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            if (this.aw != a) {
                var b = this.av;
                this.av = a;
                this.raisePropertyChanged("ActualLegend", b, this.av);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "legendItemBadgeTemplate", {
        get: function () {
            return this.c(Series.ke);
        },
        set: function (a) {
            this.h(Series.ke, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "legendItemTemplate", {
        get: function () {
            return this.c(Series.kf);
        },
        set: function (a) {
            this.h(Series.kf, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "jy", {
        get: function () {
            return this.c(Series.j7);
        },
        set: function (a) {
            this.h(Series.j7, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "fh", {
        get: function () {
            return typeGetValue(this.c(Series.ka));
        },
        set: function (a) {
            this.h(Series.ka, a);
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.jr = function () {
        this.jo();
    };
    Series.prototype.h2 = function () {
        this.jo();
    };
    Series.prototype.jo = function () {
        this.ik();
        if (this.fh < 0) {
            return;
        }
        if (this.k5 != null) {
            this.bi.a4();
            this.bi.ae();
        }
        else {
            this.k3 = this.bs == null ? null : this.bs.l6(this.fh);
        }
        if (this.k8 != null) {
            this.bi.a5();
            this.bi.af();
        }
        else {
            this.k4 = this.bs == null ? null : this.bs.mc(this.fh);
        }
    };
    Series.prototype.ca = function () {
        return this.bt.f();
    };
    Series.prototype.jl = function () {
        this.bt.v();
    };
    Series.prototype.get_cq = function () {
        return true;
    };
    Object.defineProperty(Series.prototype, "cq", {
        get: function () {
            return this.get_cq();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.jn = function () {
        var a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? a.nj.fe : this.d7;
        }
    };
    Object.defineProperty(Series.prototype, "co", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            this.b5 = a;
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.as = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new DataContext();
            $ret.series = _this;
            $ret.item = a;
            return $ret;
        })());
    };
    Series.prototype.bo = function () {
        return 1;
    };
    Series.prototype.jb = function () {
        this.bi.a0();
    };
    Series.prototype.jg = function () {
        this.dn = true;
        this.jd(true);
    };
    Series.prototype.ja = function () {
        this.ht();
    };
    Series.prototype.ht = function () {
    };
    Series.prototype.ib = function () {
    };
    Series._d1 = function (a, b, c) {
        var d;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    d = b;
                    _a.label = 1;
                case 1:
                    if (!(d < c))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, a(d)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    d++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    Series.d1 = function (a, b, c) {
        return toEnum(function () { return Series._d1(a, b, c); });
    };
    Series.d0 = function (a, b) {
        return Series.d1(a, 0, b);
    };
    Series.prototype.a8 = function () {
        return this.a7;
    };
    Series.prototype.jh = function (a) {
        this.jp(a);
    };
    Series.prototype.eq = function () {
        return this.fi;
    };
    Series.prototype.er = function () {
        return this.fj;
    };
    Series.prototype.get_dq = function () {
        return this.b8;
    };
    Series.prototype.set_dq = function (a) {
        this.b8 = a;
    };
    Object.defineProperty(Series.prototype, "dq", {
        get: function () {
            return this.get_dq();
        },
        set: function (a) {
            this.set_dq(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "db", {
        get: function () {
            return this.dq;
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.at = function (a, b) {
        return null;
    };
    Series.prototype.au = function (a, b) {
        return null;
    };
    Series.prototype.ir = function (a, b, c) {
        this.a0.a$w(this, a, b, c);
    };
    Series.prototype.jk = function (a) {
        this.a0.a$ag(this, a);
    };
    Series.prototype.hq = function (a, b) {
        if (this.aw != null && this.jw != null) {
            if (b == null && this.aw.containsChild(this.jw)) {
                this.aw.removeChild(this.jw);
            }
            if (b != null && !this.aw.containsChild(this.jw) && this.lz != 1) {
                this.aw.addChildInOrder(this.jw, this);
            }
        }
    };
    Series.prototype.hu = function () {
        if (this.aw == null || this.jw == null) {
            return;
        }
        this.aw.removeChild(this.jw);
    };
    Series.prototype.hp = function (a, b) {
        if (this.jw != null) {
            if (a != null && a.containsChild(this.jw)) {
                a.removeChild(this.jw);
            }
            if (this.bs != null && b != null && !b.containsChild(this.jw) && this.lz != 1) {
                b.addChildInOrder(this.jw, this);
            }
        }
    };
    Series.prototype.hr = function (a, b) {
        if (this.aw != null) {
            if (a != null && this.aw.containsChild(a)) {
                this.aw.removeChild(a);
            }
            if (this.bs != null && b != null && this.lz != 1) {
                this.aw.addChildInOrder(b, this);
            }
        }
    };
    Series.prototype.i6 = function (a) {
        this.bz = a.releaseFastItemsSource(this.itemsSource);
    };
    Series.prototype.i5 = function (a) {
        this.bz = a.getFastItemsSource(this.itemsSource);
    };
    Series.prototype.ax = function () {
        if (this.legend != null) {
            return this.legend;
        }
        if (this.bs != null && this.bs.legend != null) {
            return this.bs.legend;
        }
        return null;
    };
    Series.prototype.dc = function () {
        return false;
    };
    Series.prototype.da = function (a) {
        return (a && this.eq() > 0) || this.ca() || (this.dp && this.dc() && this.er() > 0);
    };
    Series.prototype.hz = function (a) {
        if (a != null) {
            a.bv(this);
        }
    };
    Series.prototype.i4 = function (a) {
        if (a != null) {
            a.ci(this);
        }
    };
    Series.prototype.a9 = function () {
        return this.bi.g();
    };
    Series.prototype.jp = function (a) {
        this.bi.a6(a);
    };
    Series.prototype.jj = function (a, b) {
        this.a0.a$af(this, a, b);
    };
    Series.prototype.get_ds = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "ds", {
        get: function () {
            return this.get_ds();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.i0 = function (a, b) {
        this.bi.ao(a, b);
    };
    Series.prototype.i2 = function (a) {
        this.iv(this.ly, a);
    };
    Series.prototype.h9 = function (a) {
        if (this.bz != null) {
            this.bz.handleCollectionChanged(a);
        }
    };
    Series.prototype.ii = function (a, b, c) {
        this.h9(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    Series.prototype.ie = function () {
        this.h9(new NotifyCollectionChangedEventArgs(0, 4));
    };
    Series.prototype.ig = function (a, b) {
        this.h9(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    Series.prototype.ih = function (a, b) {
        this.h9(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    Series.prototype.jm = function () {
        this.jd(false);
    };
    Series.prototype.dh = function (a, b) {
        return false;
    };
    Series.prototype.get_coercionMethods = function () {
        return this._coercionMethods;
    };
    Series.prototype.set_coercionMethods = function (a) {
        this._coercionMethods = a;
    };
    Object.defineProperty(Series.prototype, "coercionMethods", {
        get: function () {
            return this.get_coercionMethods();
        },
        set: function (a) {
            this.set_coercionMethods(a);
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_expectFunctions = function () {
        return this.b4;
    };
    Series.prototype.set_expectFunctions = function (a) {
        this.b4 = a;
    };
    Object.defineProperty(Series.prototype, "expectFunctions", {
        get: function () {
            return this.get_expectFunctions();
        },
        set: function (a) {
            this.set_expectFunctions(a);
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ar = function (a, b) {
        return null;
    };
    Object.defineProperty(Series.prototype, "be", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.raisePropertyChanged("HitTestMode", enumGetBox(SeriesHitTestMode_$type, b), enumGetBox(SeriesHitTestMode_$type, this.bb));
            }
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.bd = function () {
        return this.be == 0 ? 2 : this.be;
    };
    Object.defineProperty(Series.prototype, "bc", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.raisePropertyChanged("ActualHitTestMode", enumGetBox(SeriesHitTestMode_$type, b), enumGetBox(SeriesHitTestMode_$type, this.ba));
            }
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.bw = function (a) {
        if (a == null) {
            return this.bz.registerColumn(null, null, false);
        }
        var b = null;
        var c = SeriesViewer.bb(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumn(a, b, this.expectFunctions);
    };
    Series.prototype.bx = function (a) {
        if (a == null) {
            return this.bz.registerColumnInt(null, null, false);
        }
        var b = null;
        var c = SeriesViewer.bb(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumnInt(a, b, this.expectFunctions);
    };
    Series.prototype.by = function (a) {
        if (a == null) {
            return this.bz.registerColumnObject(null, null, false);
        }
        var b = null;
        var c = SeriesViewer.bb(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumnObject(a, b, this.expectFunctions);
    };
    Object.defineProperty(Series.prototype, "ly", {
        get: function () {
            return this.bi != null ? this.bi.br : Rect.empty;
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cz = function () {
        return false;
    };
    Object.defineProperty(Series.prototype, "cz", {
        get: function () {
            return this.get_cz();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.get_cy = function () {
        return true;
    };
    Object.defineProperty(Series.prototype, "cy", {
        get: function () {
            return this.get_cy();
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.ji = function (a, b) {
    };
    Series.prototype.hx = function (a, b) {
        this.a2.copyVisualData(a, b);
    };
    Series.prototype.fo = function () {
        var a = this.a2.exportVisualData(this, this.ly);
        this.h4(a);
        this.bi.ai(a);
        return a;
    };
    Series.prototype.h4 = function (a) {
    };
    Series.prototype.ic = function (a) {
        if (this.lf.x != a.x || this.lf.y != a.y) {
            this.lf = a;
            this.ip(a);
        }
    };
    Series.prototype.ip = function (a) {
    };
    Series.prototype.id = function () {
    };
    Series.prototype.ij = function () {
    };
    Series.prototype.am = function (a) {
        return null;
    };
    Series.prototype.ag = function () {
        return null;
    };
    Series.prototype.eh = function () {
        return NaN;
    };
    Series.ei = function (a, b) {
        if (a == null || a.count == 0) {
            return NaN;
        }
        if (b != null && b.i$b != null) {
            if (b.i$b.count != a.count) {
                return NaN;
            }
            for (var c = 0; c < a.count; c++) {
                if (!isNaN_(a.item(b.i$b._inner[c])) && a.item(b.i$b._inner[c]) != 0) {
                    return a.item(b.i$b._inner[c]);
                }
            }
        }
        for (var d = 0; d < a.count; d++) {
            if (!isNaN_(a.item(d)) && a.item(d) != 0) {
                return a.item(d);
            }
        }
        return NaN;
    };
    Series.prototype.io = function () {
    };
    Object.defineProperty(Series.prototype, "d8", {
        get: function () {
            return this.d4;
        },
        set: function (a) {
            var b = this.d8;
            if (a != b) {
                this.d4 = a;
                this.raisePropertyChanged("FinalValue", b, this.d8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Series.prototype, "et", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.et;
            if (a != b) {
                this.d5 = a;
                this.raisePropertyChanged("PercentChange", b, this.et);
            }
        },
        enumerable: true,
        configurable: true
    });
    Series.prototype.jq = function () {
        var a = this.eh();
        this.et = (this.d8 - a) / a * 100;
    };
    Series.prototype.fr = function (a) {
        return null;
    };
    Series.$t = markType(Series, 'Series', Control.$, [INotifyPropertyChanged_$type, IProvidesViewport_$type, ILegendSeries_$type, ILegendOwner_$type, ILegendTemplateProvider_$type]);
    Series.e5 = 0;
    Series.k2 = DependencyProperty.i("VisibilityProxy", Visibility_$type, Series.$, new PropertyMetadata(2, enumGetBox(Visibility_$type, 0), function (a, b) { return a.raisePropertyChanged("VisibilityProxy", b.oldValue, b.newValue); }));
    Series.kd = DependencyProperty.i("ItemsSource", IEnumerable_$type, Series.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(Series.$, a);
        if (c.bn != null) {
            c.bn.releaseFastItemsSource(b.oldValue);
        }
        a.raisePropertyChanged("ItemsSource", b.oldValue, b.newValue);
    }));
    Series.kh = DependencyProperty.i("Legend", IChartLegend_$type, Series.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(Series.$, a);
        c.raisePropertyChanged("Legend", b.oldValue, b.newValue);
    }));
    Series.ke = DependencyProperty.i("LegendItemBadgeTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(Series.$, a);
        c.raisePropertyChanged("LegendItemBadgeTemplate", b.oldValue, b.newValue);
        if (c.jw != null) {
            c.jw = c.ju();
        }
    }));
    Series.kf = DependencyProperty.i("LegendItemTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(Series.$, a);
        c.raisePropertyChanged("LegendItemTemplate", b.oldValue, b.newValue);
        if (c.jw != null) {
            c.jw = c.ju();
        }
    }));
    Series.j7 = DependencyProperty.i("DiscreteLegendItemTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, function (a, b) {
        var c = typeCast(Series.$, a);
        c.raisePropertyChanged("DiscreteLegendItemTemplate", b.oldValue, b.newValue);
    }));
    Series.ka = DependencyProperty.i("Index", Number_$type, Series.$, new PropertyMetadata(2, -1, function (a, b) {
        var c = typeCast(Series.$, a);
        c.raisePropertyChanged("Index", b.oldValue, b.newValue);
        if (c.jw != null) {
            c.jw = c.ju();
        }
    }));
    Series.$$p = markDep(DependencyProperty, PropertyMetadata, Series, 'raisePropertyChanged', ['ActualAreaFillOpacity:d6:j0', [1, 1], 'ActualBrush:k3:j1', [Brush.$], 'ActualOutline:k4:j2', [Brush.$], 'AreaFillOpacity:d7:j3', [1, NaN], 'Brush:k5:j4', [Brush.$, null], 'DashArray:lb:j5', [DoubleCollection.$], 'DashCap:lc:j6', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'EndCap:ld:j8', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'FastItemsSource:bz:j9', [IFastItemsSource_$type], 'IsDropShadowEnabled:cp:kb', [0, false], 'IsHighlightingEnabled:cu:kc', [0, false], 'LegendItemVisibility:lz:kg', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'MiterLimit:es:ki', [1, 0], 'MouseOverEnabled:c7:kj', [0, true], 'Outline:k8:kk', [Brush.$, null], 'Resolution:eu:kl', [1, 1], 'ShadowBlur:ev:km', [1, NaN], 'ShadowColor:la:kn', [Color.$], 'ShadowOffsetX:ew:ko', [1, NaN], 'ShadowOffsetY:ex:kp', [1, NaN], 'ShowDefaultTooltip:dd:kq', [0, false], 'StartCap:le:kr', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'Thickness:ey:ks', [1, DeviceUtils.g(2)], 'Title:fx:kt', [4, "Series Title"], 'ToolTip::ku', [4, null], 'TransitionDuration:fi:kv', [1, 0], 'TransitionEasingFunction:bu:kw', [Delegate_$type, null], 'TransitionInDuration:fj:kx', [1, 1000], 'TransitionInEasingFunction:bv:ky', [Delegate_$type, null], 'TransitionInSpeedType:bp:kz', [TransitionInSpeedType_$type, enumGetBox(TransitionInSpeedType_$type, 0)], 'TransitionProgress:ez:k0', [1, 0], 'UseSingleShadow:du:k1', [0, true]]);
    return Series;
}(Control));
/**
 * @hidden
 */
var MarkerSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerSeries, _super);
    function MarkerSeries() {
        var _this = _super.call(this) || this;
        _this.mj = null;
        return _this;
    }
    MarkerSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.l0 = a;
    };
    MarkerSeries.prototype.get_hasMarkers = function () {
        return true;
    };
    MarkerSeries.prototype.k6 = function () {
        return this.mv;
    };
    MarkerSeries.prototype.k7 = function () {
        return this.mw;
    };
    MarkerSeries.prototype.jz = function () {
        return this.mj;
    };
    Object.defineProperty(MarkerSeries, "ml", {
        get: function () {
            if (MarkerSeries.mh == null) {
                MarkerSeries.mh = new DataTemplate();
            }
            return MarkerSeries.mh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerSeries.prototype, "mx", {
        get: function () {
            return this.c(MarkerSeries.mp);
        },
        set: function (a) {
            this.h(MarkerSeries.mp, a);
        },
        enumerable: true,
        configurable: true
    });
    MarkerSeries.prototype.l3 = function () {
        return this.mj != null && ((this.l1 != 1 && this.l1 != 0) || this.mk != null);
    };
    MarkerSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "MarkerBrush":
            case MarkerSeries.$$p[6]:
            case MarkerSeries.$$p[3]:
            case MarkerSeries.$$p[5]:
                this.jo();
                this.iw();
                break;
            case MarkerSeries.$$p[2]:
                this.mj = d;
                if (c == MarkerSeries.ml || d == MarkerSeries.ml || (c == null || d != null)) {
                    this.l0.cd();
                    var e = typeCast(MarkerSeriesView.$, this.bh);
                    if (e != null) {
                        e.cd();
                    }
                    this.jd(false);
                }
                this.bi.bg();
                if (this.toolTip != null && this.cx) {
                    this.a0.a$ah(this, this.toolTip);
                }
                this.ik();
                break;
            case MarkerSeries.$$p[7]:
                this.l0.ck(this.l5);
                this.jd(false);
                break;
            case MarkerSeries.$$p[0]:
            case MarkerSeries.$$p[1]:
                if (this.l3()) {
                    this.jd(false);
                }
                break;
        }
    };
    MarkerSeries.ma = function (a) {
        switch (a) {
            case 3:
            case 13: return SeriesViewer.$$p[1];
            case 4: return SeriesViewer.$$p[26];
            case 5: return SeriesViewer.$$p[18];
            case 6: return SeriesViewer.$$p[20];
            case 7: return SeriesViewer.$$p[4];
            case 8: return SeriesViewer.$$p[13];
            case 9: return SeriesViewer.$$p[6];
            case 10: return SeriesViewer.$$p[23];
            case 11: return SeriesViewer.$$p[14];
            case 12: return SeriesViewer.$$p[7];
            default:
            case 0:
            case 1: return null;
        }
    };
    MarkerSeries.l2 = function (a, b) {
        var c = a.bs != null ? b : 1;
        if (c == 2) {
            var d = [3, 4, 8, 10, 7, 6, 9, 11, 5, 12];
            c = a.fh >= 0 ? d[a.fh % d.length] : 1;
        }
        return c;
    };
    MarkerSeries.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        if (this.l0.bz()) {
            this.l0.cb();
            this.l0.b5();
        }
        else {
            var a = MarkerSeries.l2(this, this.l1);
            var b = MarkerSeries.ma(a);
            if (b == null) {
                this.mi = MarkerSeries.ml;
            }
            else {
                this.l0.b8(b);
            }
        }
        if (this.mx != null && this.l1 != 13) {
            this.l0.b9();
            this.l0.b6();
        }
        else {
            if (this.l1 == 13) {
                this.mv = this.bi.bn();
            }
            else {
                this.mv = this.bs == null ? null : this.bs.ma(this.fh);
            }
        }
        if (this.my != null) {
            this.l0.ca();
            this.l0.b7();
        }
        else {
            if (this.l1 == 13) {
                this.mw = this.bi.bn();
            }
            else {
                this.mw = this.bs == null ? null : this.bs.mb(this.fh);
            }
        }
    };
    MarkerSeries.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportMarkerVisualData(this, a);
    };
    MarkerSeries.prototype.l4 = function (a, b) {
        if (this.hasMarkers && this.l3()) {
            var c = this.lx(a);
            if (c.isEmpty) {
                return false;
            }
            var d = RectUtil.r(c, this.ee(b));
            if (d.containsPoint(a)) {
                return true;
            }
        }
        return false;
    };
    MarkerSeries.prototype.ar = function (a, b) {
        var c = this.l0.bv(a);
        var d = null;
        if (c != null) {
            d = c.content;
        }
        return d;
    };
    MarkerSeries.$t = markType(MarkerSeries, 'MarkerSeries', Series.$);
    MarkerSeries.mh = null;
    MarkerSeries.mp = DependencyProperty.i("MarkerBrush", Brush.$, MarkerSeries.$, new PropertyMetadata(1, function (a, b) {
        var c = (typeCast(MarkerSeries.$, a));
        c.raisePropertyChanged("MarkerBrush", b.oldValue, b.newValue);
    }));
    MarkerSeries.$$p = markDep(DependencyProperty, PropertyMetadata, MarkerSeries, 'raisePropertyChanged', ['ActualMarkerBrush:mv:mm', [Brush.$], 'ActualMarkerOutline:mw:mn', [Brush.$], 'ActualMarkerTemplate:mi:mo', [DataTemplate.$, null], 'MarkerOutline:my:mq', [Brush.$], 'MarkerStyle:mz:mr', [Style.$], 'MarkerTemplate:mk:ms', [DataTemplate.$, null], 'MarkerType:l1:mt', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'UseLightweightMarkers:l5:mu', [0, false]]);
    return MarkerSeries;
}(Series));
/**
 * @hidden
 */
var SyncLink = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncLink, _super);
    function SyncLink() {
        var _this = _super.call(this) || this;
        _this.ai = null;
        _this.af = new Dictionary$2(IEnumerable_$type, FastItemsSourceReference.$, 0);
        _this.aq = null;
        _this.ab = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.am(a, b.propertyName, b.oldValue, b.newValue); });
        _this.ab = new ChartCollection();
        var a = _this.ab;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.aj));
        _this.aq = new Rect(0, 0, 0, 1, 1);
        return _this;
    }
    SyncLink.prototype.am = function (a, b, c, d) {
    };
    SyncLink.prototype.releaseFastItemsSource = function (a) {
        var _this = this;
        if (a != null) {
            var b_1 = null;
            if (((function () { var c = _this.af.tryGetValue(a, b_1); b_1 = c.p1; return c.ret; })())) {
                --b_1.b;
                if (b_1.b == 0) {
                    this.af.removeItem(a);
                }
            }
        }
        return null;
    };
    SyncLink.ad = function (a) {
        return ((function () {
            var $ret = new FastItemsSource();
            $ret.e = a;
            return $ret;
        })());
    };
    SyncLink.prototype.getFastItemsSource = function (a) {
        var _this = this;
        if (SyncLink.ah == null) {
            SyncLink.ah = SyncLink.ad;
        }
        var b = null;
        if (a != null) {
            var c_1 = null;
            if (!((function () { var d = _this.af.tryGetValue(a, c_1); c_1 = d.p1; return d.ret; })())) {
                b = SyncLink.ah(a);
                c_1 = new FastItemsSourceReference(b);
                this.af.addItem(a, c_1);
            }
            c_1.b++;
            b = c_1.a;
        }
        return b;
    };
    SyncLink.prototype.ae = function (a) {
        var _this = this;
        var b = null;
        if (a != null) {
            var c_2 = null;
            if (!((function () { var d = _this.af.tryGetValue(a, c_2); c_2 = d.p1; return d.ret; })())) {
                return null;
            }
            b = c_2.a;
        }
        return b;
    };
    SyncLink.prototype.ar = function (a, b, c) {
        return this.as(a, b, c, false);
    };
    SyncLink.prototype.as = function (a, b, c, d) {
        if (!c.isEmpty) {
            c = new Rect(0, c.left, c.top, c.width, c.height);
            var e = a.ex;
            if (b == a) {
                if (!d) {
                    if (!b.c3()) {
                        c.x = b.m4.x;
                        c.width = b.m4.width;
                    }
                    if (!b.c4()) {
                        c.y = b.m4.y;
                        c.height = b.m4.height;
                    }
                }
            }
            else {
                var f = SyncManager.a(b);
                if (f == null || !f.synchronizeHorizontally) {
                    c.x = b.m4.x;
                    c.width = b.m4.width;
                }
                if (f == null || !f.synchronizeVertically) {
                    c.y = b.m4.y;
                    c.height = b.m4.height;
                }
            }
            var g = 0.5 * (c.left + c.right);
            var h = 0.5 * (c.top + c.bottom);
            var i = c.width;
            var j = c.height;
            var k = MathUtil.b(c.width, e, 1);
            var l = MathUtil.b(c.height, e, 1);
            if (a.dh() && !a.m3.isEmpty) {
                var m = a.m3;
                var n = m.width / m.height;
                var o = k * m.width;
                var p = l * m.height;
                var q = o / p;
                if (q != n) {
                    if (p * n > o) {
                        o = p * n;
                        k = o / m.width;
                    }
                    else {
                        p = o / n;
                        l = p / m.height;
                    }
                }
            }
            else if (a.cl()) {
                var r = false;
                var s = false;
                if (Math.abs(k - a.mq.width) > e) {
                    r = true;
                }
                if (Math.abs(l - a.mq.height) > e) {
                    s = true;
                }
                var t = a.hu(k, l, r, s);
                k = t.p0;
                l = t.p1;
                k = MathUtil.b(k, e, 1);
                l = MathUtil.b(l, e, 1);
            }
            var u = k != i;
            var v = l != j;
            var w = u ? g - 0.5 * k : c.left;
            var x = v ? h - 0.5 * l : c.top;
            var y = u ? g + 0.5 * k : c.right;
            var z = v ? h + 0.5 * l : c.bottom;
            if (w < 0) {
                w = 0;
                y = w + k;
            }
            if (y > 1) {
                y = 1;
                w = y - k;
            }
            if (x < 0) {
                x = 0;
                z = x + l;
            }
            if (z > 1) {
                z = 1;
                x = z - l;
            }
            c = new Rect(0, w, x, y - w, z - x);
        }
        return c;
    };
    Object.defineProperty(SyncLink.prototype, "ag", {
        get: function () {
            return this.ab;
        },
        enumerable: true,
        configurable: true
    });
    SyncLink.prototype.aj = function (a, b) {
        var e_79, _a;
        if (b.newItems != null) {
            try {
                for (var _b = __values(fromEn(b.newItems)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (c.m4.isEmpty) {
                        c.m4 = this.ar(null, c, this.aq);
                    }
                }
            }
            catch (e_79_1) {
                e_79 = { error: e_79_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_79)
                        throw e_79.error;
                }
            }
        }
    };
    SyncLink.prototype.ak = function (a, b) {
        var e_80, _a;
        try {
            for (var _b = __values(fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c == a) {
                    c.mi = { $type: Point_$type, x: b.x, y: b.y };
                }
                else {
                    var d = { $type: Point_$type, x: b.x, y: b.y };
                    var e = SyncManager.a(c);
                    if (e == null || !e.synchronizeHorizontally) {
                        d.x = NaN;
                    }
                    if (e == null || !e.synchronizeVertically) {
                        d.y = NaN;
                    }
                    c.mi = d;
                }
            }
        }
        catch (e_80_1) {
            e_80 = { error: e_80_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_80)
                    throw e_80.error;
            }
        }
    };
    SyncLink.prototype.al = function (a, b) {
        var e_81, _a;
        try {
            for (var _b = __values(fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.mz = this.ar(a, c, b);
            }
        }
        catch (e_81_1) {
            e_81 = { error: e_81_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_81)
                    throw e_81.error;
            }
        }
    };
    SyncLink.prototype.ao = function (a, b) {
        this.ap(a, b, false);
    };
    SyncLink.prototype.ap = function (a, b, c) {
        var e_82, _a;
        var d = b.isEmpty || isNaN_(b.x) || isNaN_(b.y) || isNaN_(b.width) || isNaN_(b.height);
        if (!d && !a.cj) {
            try {
                for (var _b = __values(fromEnum(this.ag)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    e.cj = true;
                    e.m4 = this.as(a, e, b, c);
                    e.cj = false;
                }
            }
            catch (e_82_1) {
                e_82 = { error: e_82_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_82)
                        throw e_82.error;
                }
            }
        }
    };
    SyncLink.prototype.an = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    SyncLink.$t = markType(SyncLink, 'SyncLink', FrameworkElement.$, [INotifyPropertyChanged_$type, IFastItemsSourceProvider_$type]);
    SyncLink.ah = null;
    return SyncLink;
}(FrameworkElement));
/**
 * @hidden
 */
var SyncLinkManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncLinkManager, _super);
    function SyncLinkManager() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.d = new Dictionary$2(String_$type, SyncLink.$, 0);
        return _this;
    }
    SyncLinkManager.instance = function () {
        if (SyncLinkManager.b == null) {
            SyncLinkManager.b = new SyncLinkManager();
        }
        return SyncLinkManager.b;
    };
    Object.defineProperty(SyncLinkManager.prototype, "e", {
        get: function () {
            return this.d.count;
        },
        enumerable: true,
        configurable: true
    });
    SyncLinkManager.prototype.getLink = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.d.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
            return b;
        }
        b = new SyncLink();
        b.ai = a;
        this.d.addItem(a, b);
        return b;
    };
    SyncLinkManager.prototype.releaseLink = function (a) {
        if (a.ag.count == 0 && a.ai != null && this.d.containsKey(a.ai)) {
            this.d.removeItem(a.ai);
        }
    };
    SyncLinkManager.$t = markType(SyncLinkManager, 'SyncLinkManager');
    SyncLinkManager.b = null;
    return SyncLinkManager;
}(Base));
/**
 * @hidden
 */
var SyncManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncManager, _super);
    function SyncManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SyncManager.e = function (a) {
        var b = SyncManager.a(a);
        if (b == null) {
            return;
        }
        if (!a.c0) {
            return;
        }
        if (a.syncChannel != b.syncChannel) {
            return;
        }
        SyncManager.b(a, a.syncChannel, null);
    };
    SyncManager.c = function (a) {
        var b = SyncManager.a(a);
        if (b == null) {
            return;
        }
        if (a.c0 && a.syncChannel == b.syncChannel) {
            return;
        }
        var c = null;
        if (a.c0) {
            c = a.syncChannel;
        }
        SyncManager.b(a, c, b.syncChannel);
    };
    SyncManager.b = function (a, b, c) {
        if (a != null) {
            if (stringIsNullOrEmpty(c)) {
                var d = a.actualSyncLink;
                a.actualSyncLink = null;
                a.actualSyncLink = new SyncLink();
                if (d != null) {
                    SyncLinkManager.instance().releaseLink(d);
                }
                a.syncChannel = null;
            }
            else {
                if (!stringIsNullOrEmpty(b)) {
                    var e = a.actualSyncLink;
                    a.actualSyncLink = null;
                    if (e != null) {
                        SyncLinkManager.instance().releaseLink(e);
                    }
                }
                a.actualSyncLink = SyncLinkManager.instance().getLink(c);
                a.syncChannel = c;
            }
        }
    };
    SyncManager.d = function (a, b) {
        a.syncSettings = b;
    };
    SyncManager.a = function (a) {
        return a.syncSettings;
    };
    SyncManager.$t = markType(SyncManager, 'SyncManager');
    return SyncManager;
}(Base));
/**
 * @hidden
 */
var ChartCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartCollection, _super);
    function ChartCollection() {
        var _this = _super.call(this, SeriesViewer.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    ChartCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    ChartCollection.$t = markType(ChartCollection, 'ChartCollection', ObservableCollection$1.$.specialize(SeriesViewer.$));
    return ChartCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var SeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesCollection, _super);
    function SeriesCollection() {
        var _this = _super.call(this, Series.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    SeriesCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    SeriesCollection.$t = markType(SeriesCollection, 'SeriesCollection', ObservableCollection$1.$.specialize(Series.$));
    return SeriesCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var ChartCursorEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartCursorEventArgs, _super);
    function ChartCursorEventArgs(a, b, c) {
        var _this = _super.call(this) || this;
        _this._item = null;
        _this._series = null;
        _this._seriesViewer = null;
        _this.seriesViewer = a;
        _this.series = b;
        _this.item = c;
        return _this;
    }
    ChartCursorEventArgs.prototype.toString = function () {
        return this.seriesViewer.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "");
    };
    Object.defineProperty(ChartCursorEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartCursorEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartCursorEventArgs.prototype, "seriesViewer", {
        get: function () {
            return this._seriesViewer;
        },
        set: function (a) {
            this._seriesViewer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartCursorEventArgs.prototype, "chart", {
        get: function () {
            return typeCast(XamDataChart.$, this.seriesViewer);
        },
        enumerable: true,
        configurable: true
    });
    ChartCursorEventArgs.$t = markType(ChartCursorEventArgs, 'ChartCursorEventArgs', EventArgs.$);
    return ChartCursorEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var DataChartMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataChartMouseButtonEventArgs, _super);
    function DataChartMouseButtonEventArgs(a, b, c, d) {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this._item = null;
        _this._series = null;
        _this._chart = null;
        _this.chart = a;
        _this.series = b;
        _this.item = c;
        _this.g = d;
        return _this;
    }
    DataChartMouseButtonEventArgs.prototype.toString = function () {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    };
    Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "handled", {
        get: function () {
            return this.g.handled;
        },
        set: function (a) {
            this.g.handled = a;
        },
        enumerable: true,
        configurable: true
    });
    DataChartMouseButtonEventArgs.prototype.getPosition = function (a) {
        return this.g.getPosition(a);
    };
    Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "originalSource", {
        get: function () {
            return this.g.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataChartMouseButtonEventArgs.prototype, "chart", {
        get: function () {
            return this._chart;
        },
        set: function (a) {
            this._chart = a;
        },
        enumerable: true,
        configurable: true
    });
    DataChartMouseButtonEventArgs.$t = markType(DataChartMouseButtonEventArgs, 'DataChartMouseButtonEventArgs', EventArgs.$);
    return DataChartMouseButtonEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var ChartMouseEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartMouseEventArgs, _super);
    function ChartMouseEventArgs(a, b, c, d) {
        var _this = _super.call(this) || this;
        _this.f = null;
        _this._item = null;
        _this._series = null;
        _this._chart = null;
        _this.chart = a;
        _this.series = b;
        _this.item = c;
        _this.f = d;
        return _this;
    }
    ChartMouseEventArgs.prototype.toString = function () {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    };
    ChartMouseEventArgs.prototype.getPosition = function (a) {
        return this.f.getPosition(a);
    };
    Object.defineProperty(ChartMouseEventArgs.prototype, "originalSource", {
        get: function () {
            return this.f.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "chart", {
        get: function () {
            return this._chart;
        },
        set: function (a) {
            this._chart = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartMouseEventArgs.$t = markType(ChartMouseEventArgs, 'ChartMouseEventArgs', EventArgs.$);
    return ChartMouseEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var AxisComponentsForView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisComponentsForView, _super);
    function AxisComponentsForView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    AxisComponentsForView.$t = markType(AxisComponentsForView, 'AxisComponentsForView');
    return AxisComponentsForView;
}(Base));
/**
 * @hidden
 */
var AxisLabelPanelBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelPanelBaseView, _super);
    function AxisLabelPanelBaseView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.av = null;
        _this.e = null;
        _this.au = Rect.empty;
        _this.c = null;
        _this.h = 0;
        _this.i = NaN;
        _this.a = a;
        return _this;
    }
    AxisLabelPanelBaseView.prototype.aa = function (a, b, c, d, e, f) {
        var g = typeCast(FrameworkElement.$, a);
        if (g != null) {
            g._visibility = 0;
            if (b.width == 0 && b.height == 0) {
                g._visibility = 1;
            }
            var h = b.height - (d + f);
            var i = b.width - (c + e);
            g.n = b.left + c;
            g.o = b.top + d;
            if (i < 0) {
                i = 0;
            }
            if (h < 0) {
                h = 0;
            }
            g.l = h;
            g.m = i;
            if (g.j != null) {
                var j = g.j;
                var k = j.j._inner[0];
                k.k = k.k + g.n;
                k.l = k.l + g.o;
            }
        }
    };
    AxisLabelPanelBaseView.prototype.z = function (a, b, c, d, e, f, g, h) {
        var i = Math.max(e, Math.max(f, Math.max(g, h)));
        var j = new Thickness(0, i);
        if (this.a.ap) {
            j = new Thickness(0, Math.sqrt((i * i) / 2));
        }
        var k = c.d;
        if (isNaN_(k.left) || isNaN_(k.top) || isNaN_(k.right) || isNaN_(k.bottom)) {
            k = j;
        }
        if (k.left > j.left || k.top > j.top || k.right > j.right || k.bottom > j.bottom) {
            k = j;
        }
        var l = new Rect(0, d.left - k.left, d.top - k.top, d.width + k.left + k.right, d.height + k.top + k.bottom);
        var m = a.j;
        a.j = null;
        this.aa(a, l, e, f, g, h);
        a.j = m;
        a.width = a.m;
        a.height = a.l;
    };
    AxisLabelPanelBaseView.prototype.ad = function (a) {
        var b = a;
        b.j = null;
    };
    AxisLabelPanelBaseView.prototype.ag = function (a) {
    };
    AxisLabelPanelBaseView.prototype.ah = function (a, b) {
    };
    AxisLabelPanelBaseView.prototype.ai = function (a, b) {
        var c = typeCast(FrameworkElement.$, a);
        var d = 0;
        var e = 0;
        var f = new TransformGroup();
        var g = ((function () {
            var $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = d;
            $ret.l = e;
            return $ret;
        })());
        f.j.add(g);
        c.j = f;
    };
    AxisLabelPanelBaseView.prototype.aq = function (a, b, c, d, e, f, g, h, i) {
        var j = Math.max(e, Math.max(f, Math.max(g, h)));
        var k = new Thickness(0, j);
        if (this.a.ap) {
            k = new Thickness(0, Math.sqrt((j * j) / 2));
        }
        var l = c.d;
        if (isNaN_(l.left) || isNaN_(l.top) || isNaN_(l.right) || isNaN_(l.bottom)) {
            l = k;
        }
        if (l.left > k.left || l.top > k.top || l.right > k.right || l.bottom > k.bottom) {
            l = k;
        }
        var m = b.j;
        var n = new TransformGroup();
        var o = a.n + l.left;
        var p = a.o + l.top;
        n.j.add(m);
        a.j = n;
    };
    AxisLabelPanelBaseView.prototype.x = function (a, b, c, d) {
        var e = a.ak.length;
        var f = a.ak;
        var g = a.ak;
        while ((this.m(a) + c + d) > b && e > 0) {
            e--;
            f = f.substr(0, e) + "\u2026";
            a.ak = f;
        }
        a.ak = g;
        return f;
    };
    AxisLabelPanelBaseView.prototype.ae = function () {
        var e_83, _a;
        if (this.e == null) {
            return;
        }
        var a = this.g();
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(FrameworkElement.$, b);
                if (c != null) {
                    this.a.b7(c);
                }
                this.a.by(b);
            }
        }
        catch (e_83_1) {
            e_83 = { error: e_83_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_83)
                    throw e_83.error;
            }
        }
    };
    AxisLabelPanelBaseView.prototype.g = function () {
        var a = this.a.av();
        var b = this.a.au();
        if (!this.a.ac.cq) {
            return a;
        }
        else {
            return b;
        }
    };
    AxisLabelPanelBaseView.prototype.l = function (a) {
        return this.h;
    };
    AxisLabelPanelBaseView.prototype.n = function (a) {
        return this.l(a) + this.r() + this.o();
    };
    AxisLabelPanelBaseView.prototype.am = function () {
        this.av = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
    };
    AxisLabelPanelBaseView.prototype.m = function (a) {
        var b = a;
        if (b != null && b.ak != null) {
            return this.e.e(b);
        }
        return 0;
    };
    AxisLabelPanelBaseView.prototype.w = function (a) {
        var b = a;
        if (b != null && b.ak != null) {
            return this.m(a) + this.p() + this.q();
        }
        return 0;
    };
    AxisLabelPanelBaseView.prototype.ac = function () {
        this.a.a9 = this.a.ac.d2();
    };
    AxisLabelPanelBaseView.prototype.aj = function () {
        this.af();
        this.a.cr(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
    };
    AxisLabelPanelBaseView.prototype.f = function () {
        return this.e;
    };
    AxisLabelPanelBaseView.prototype.ak = function (a) {
        this.e = a;
    };
    AxisLabelPanelBaseView.prototype.y = function () {
        if (this.a.cn.isEmpty) {
            return;
        }
        var a = this.a.a5;
        this.a.cq(new Size(1, this.a.cn.width, this.a.cn.height));
        if (this.a.a5 != a) {
            this.a.ac.bd.ht();
            this.al();
        }
    };
    AxisLabelPanelBaseView.prototype.al = function () {
    };
    AxisLabelPanelBaseView.prototype.ao = function (a) {
        this.e.w(a);
    };
    AxisLabelPanelBaseView.prototype.an = function () {
        var e_84, _a, e_85, _b;
        if (this.e == null) {
            return;
        }
        if (this.e.d) {
            if (this.a.ac.bf != null && this.a.ac.bf.ea != 1) {
                this.e.z();
                this.e.aa(this.a.ac.bf.ea, this.a.ac.bf.ea);
            }
            this.af();
            this.au = this.a.cn;
            var a = this.a.ac.bd.getFontBrush();
            if (this.a.af != null && this.a.af.textColor != null) {
                a = this.a.af.textColor;
            }
            if (this.a.j != null) {
                this.e.z();
                this.e.j(this.a.j);
            }
            var b = false;
            try {
                for (var _c = __values(fromEnum(this.g())), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = typeCast(TextBlock.$, c);
                    if (d != null) {
                        if (d.s != 0) {
                            b = true;
                            continue;
                        }
                        d.am = a;
                        if (d.j != null) {
                            this.e.z();
                            this.e.j(d.j);
                        }
                        this.ao(d);
                        if (d.j != null) {
                            this.e.y();
                        }
                    }
                }
            }
            catch (e_84_1) {
                e_84 = { error: e_84_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_84)
                        throw e_84.error;
                }
            }
            if (b) {
                try {
                    for (var _e = __values(fromEnum(this.a.ab)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var e = _f.value;
                        var f = typeCast(Rectangle.$, e);
                        if (f != null) {
                            if (f.s == 0) {
                                continue;
                            }
                            if (f.j != null) {
                                this.e.z();
                                this.e.j(f.j);
                            }
                            this.e.v(f);
                            if (f.j != null) {
                                this.e.y();
                            }
                        }
                        var g = typeCast(TextBlock.$, e);
                        if (g != null) {
                            if (g.s == 0) {
                                continue;
                            }
                            if (g.j != null) {
                                this.e.z();
                                this.e.j(g.j);
                            }
                            if (g.am == null) {
                                g.am = a;
                            }
                            this.e.w(g);
                            if (g.j != null) {
                                this.e.y();
                            }
                        }
                    }
                }
                catch (e_85_1) {
                    e_85 = { error: e_85_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_85)
                            throw e_85.error;
                    }
                }
            }
            if (this.a.j != null) {
                this.e.y();
            }
            this.ap();
            a = this.as();
            this.e.ac(this.d());
            var h = this.a.ac.hk;
            if (h != null) {
                h.am = a;
                if (h.j != null) {
                    this.e.z();
                    this.e.j(h.j);
                }
                this.e.w(h);
                if (h.j != null) {
                    this.e.y();
                }
            }
            if (this.a.ac.bf != null && this.a.ac.bf.ea != 1) {
                this.e.y();
            }
        }
    };
    AxisLabelPanelBaseView.prototype.d = function () {
        var a = this.a.ac.bf.getFontInfo();
        if (this.a.ac.bc != null && this.a.ac.bc.textStyle != null) {
            a = this.a.ac.bc.g(this.a.ac.bf.bn.i.ae);
        }
        else {
            var b = this.a.ac.bf.bp();
            if (b != null) {
                a = b;
            }
        }
        return a;
    };
    AxisLabelPanelBaseView.prototype.as = function () {
        var a = this.a.ac.bd.getFontBrush();
        if (this.a.ac.bc != null && this.a.ac.bc.textColor != null) {
            a = this.a.ac.bc.textColor;
        }
        else {
            var b = this.a.ac.bf.l7();
            if (b != null) {
                a = b;
            }
        }
        return a;
    };
    AxisLabelPanelBaseView.prototype.af = function () {
        if (this.e == null) {
            return;
        }
        var a = this.a.ac.bf.getFontInfo();
        if (this.a.af != null && this.a.af.textStyle != null) {
            a = this.a.af.g(this.a.ac.bf.bn.i.ae);
        }
        if (this.c != a) {
            this.c = a;
            this.ar();
        }
        this.e.ac(a);
    };
    AxisLabelPanelBaseView.prototype.ar = function () {
        if (this.a.ac != null && this.a.ac.bf != null) {
            if (this.a.af == null || this.a.af.textStyle == null) {
                this.h = this.a.ac.bf.bn.a7;
                return;
            }
            if (this.h == 0) {
                this.h = this.a.ac.bf.bn.a7;
            }
            var a = this.h;
            var b = this.a.ac.bf.getFontInfo();
            if (this.a.af != null && this.a.af.textStyle != null) {
                b = this.a.af.g(this.a.ac.bf.bn.i.ae);
            }
            var c = FontUtil.getCurrentFontHeight(this.a.ac.bf.bn.i.ae, b);
            this.h = c;
            if (a != this.h) {
                this.a.ac.bf.ht();
            }
        }
    };
    AxisLabelPanelBaseView.prototype.j = function () {
        if (this.a.ac.f7 == null) {
            return 0;
        }
        if (this.a.ac.bc != null && this.a.ac.bc.visibility == 1) {
            return 0;
        }
        if (!isNaN_(this.i)) {
            return this.i;
        }
        var a = this.d();
        if (this.a.ac.bf == null) {
            return this.h;
        }
        this.i = FontUtil.getCurrentFontHeight(this.a.ac.bf.bn.i.ae, a);
        return this.i;
    };
    AxisLabelPanelBaseView.prototype.k = function () {
        if (this.a.ac.bc != null && this.a.ac.bc.visibility == 1) {
            return 0;
        }
        if (this.e == null) {
            return 0;
        }
        var a = this.a.ac.hk;
        if (a != null && a.ak != null) {
            this.e.ac(this.d());
            var b = this.e.e(a);
            this.af();
            return b;
        }
        return 0;
    };
    AxisLabelPanelBaseView.prototype.ap = function () {
        if (this.a.ab.count == 0) {
            return;
        }
        if (this.a.ac.io == null) {
            this.av._stroke = this.a.ac.bd.l5();
        }
        else {
            this.av._stroke = this.a.ac.io;
        }
        this.av.ac = this.a.ac.ep;
        this.e.s(this.av);
    };
    AxisLabelPanelBaseView.prototype.ab = function (a) {
    };
    AxisLabelPanelBaseView.prototype.aw = function () {
        return this.a.ac.bf.m5();
    };
    AxisLabelPanelBaseView.prototype.v = function () {
        if (this.a.ac.bc != null && !isNaN_(this.a.ac.bc.topMargin)) {
            return Math.max(0, this.a.ac.bc.topMargin);
        }
        else {
            return this.aw().top;
        }
    };
    AxisLabelPanelBaseView.prototype.s = function () {
        if (this.a.ac.bc != null && !isNaN_(this.a.ac.bc.bottomMargin)) {
            return Math.max(0, this.a.ac.bc.bottomMargin);
        }
        else {
            return this.aw().bottom;
        }
    };
    AxisLabelPanelBaseView.prototype.t = function () {
        if (this.a.ac.bc != null && !isNaN_(this.a.ac.bc.leftMargin)) {
            return Math.max(0, this.a.ac.bc.leftMargin);
        }
        else {
            return this.aw().left;
        }
    };
    AxisLabelPanelBaseView.prototype.u = function () {
        if (this.a.ac.bc != null && !isNaN_(this.a.ac.bc.rightMargin)) {
            return Math.max(0, this.a.ac.bc.rightMargin);
        }
        else {
            return this.aw().right;
        }
    };
    AxisLabelPanelBaseView.prototype.at = function () {
        return this.av.ak.d;
    };
    AxisLabelPanelBaseView.prototype.b = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new PathRenderingInfo();
            $ret.e = _this.a.ac.io;
            $ret.c = _this.a.ac.ep;
            return $ret;
        })());
        if (this.a.ac != null && typeCast(XamDataChart.$, this.a.ac.bd) !== null) {
            var b = this.a.ac.bd;
            if (b.nn && b.bg != 2 && b.bg != 1) {
                a.a = true;
            }
        }
        return a;
    };
    AxisLabelPanelBaseView.prototype.r = function () {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.topMargin);
    };
    AxisLabelPanelBaseView.prototype.p = function () {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.leftMargin);
    };
    AxisLabelPanelBaseView.prototype.q = function () {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.rightMargin);
    };
    AxisLabelPanelBaseView.prototype.o = function () {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.bottomMargin);
    };
    AxisLabelPanelBaseView.$t = markType(AxisLabelPanelBaseView, 'AxisLabelPanelBaseView');
    return AxisLabelPanelBaseView;
}(Base));
/**
 * @hidden
 */
var AxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisView, _super);
    function AxisView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a7 = null;
        _this.a8 = null;
        _this.ba = null;
        _this.a9 = null;
        _this.b = new AxisComponentsFromView();
        _this.h = null;
        _this.k = null;
        _this.j = null;
        _this._isDirty = false;
        _this.bb = null;
        _this.a5 = Rect.empty;
        _this.a = a;
        _this.bb = new Rectangle();
        return _this;
    }
    AxisView.prototype.ag = function () {
        this.a7 = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.ba = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            $ret.stroke = null;
            return $ret;
        })());
        this.a8 = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
        this.a9 = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
        this.a.d3 = 1;
        this.a.en = 1;
    };
    AxisView.prototype.ai = function (a) {
    };
    AxisView.prototype.ax = function () {
        var a = new TextBlock();
        return a;
    };
    AxisView.prototype.aq = function (a) {
        a._visibility = 0;
        a.s = 0;
        if (a.x == null) {
            this.a.at.ab.add(a);
        }
    };
    AxisView.prototype.as = function (a) {
        a._visibility = 1;
    };
    AxisView.prototype.ar = function (a) {
        if (this.a.at.ab.contains(a)) {
            this.a.at.ab.remove(a);
        }
    };
    AxisView.prototype.bc = function () {
        var a = new Rectangle();
        return a;
    };
    AxisView.prototype.p = function (a) {
        if (a.x == null) {
            this.d.ab.add(a);
        }
        a._visibility = 0;
    };
    AxisView.prototype.r = function (a) {
        a._visibility = 1;
    };
    AxisView.prototype.q = function (a) {
        if (this.a.at.ab.contains(a)) {
            this.a.at.ab.remove(a);
        }
    };
    AxisView.prototype.aj = function () {
    };
    AxisView.prototype.m = function () {
        return true;
    };
    Object.defineProperty(AxisView.prototype, "index", {
        get: function () {
            if (this.a.bf != null && this.a.bf.cx) {
                return this.a.bf.series.count + 1;
            }
            var a = typeCast(XamDataChart.$, this.a.bd);
            var b = 0;
            if (a == null) {
                return 0;
            }
            if (a != null && a.ng == 1) {
                var c = 0;
                for (var d = 0; d < this.a.bf.series.count; d++) {
                    if (this.a.bf.series._inner[d].isStacked) {
                        c += this.a.bf.series._inner[d].fg();
                    }
                    else {
                        c++;
                    }
                }
                b = c;
            }
            return b + a.axes.indexOf(this.a);
        },
        enumerable: true,
        configurable: true
    });
    AxisView.prototype.ad = function () {
        this.d.b6();
        this.d.bu();
    };
    AxisView.prototype.ab = function () {
        this.d.b1();
    };
    AxisView.prototype.x = function () {
        if (this.d != null) {
            this.d.ab.clear();
        }
        this.z(this.a7.ak.d);
        this.z(this.ba.ak.d);
        this.z(this.a8.ak.d);
        this.z(this.a9.ak.d);
        this.ae();
    };
    AxisView.prototype.av = function (a) {
        this.a7._visibility = a;
        this.a8._visibility = a;
        this.ba._visibility = a;
        this.a9._visibility = a;
    };
    AxisView.prototype.an = function () {
    };
    AxisView.prototype.w = function (a) {
        this.a.cg = true;
        if (this.a.bf != null) {
            this.a.bf.ht();
        }
        this.a.g5();
    };
    AxisView.prototype.c = function () {
        this.b.a = this.a7;
        this.b.b = this.a8;
        this.b.c = this.a9;
        this.b.d = this.ba;
        return this.b;
    };
    AxisView.prototype.z = function (a) {
        if (a != null) {
            a.clear();
        }
    };
    AxisView.prototype.ay = function () {
        return this.a7.ak.d;
    };
    AxisView.prototype.e = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new PathRenderingInfo();
            $ret.e = _this.a.im;
            $ret.c = _this.a.en;
            $ret.f = _this.a.ir;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bd) !== null) {
            var b = this.a.bd;
            if (b.nn && b.bg != 2 && b.bg != 1) {
                a.a = true;
            }
        }
        return a;
    };
    AxisView.prototype.a1 = function () {
        return this.ba.ak.d;
    };
    AxisView.prototype.az = function () {
        return this.a8.ak.d;
    };
    AxisView.prototype.f = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new PathRenderingInfo();
            $ret.e = _this.a.ij;
            $ret.c = _this.a.d3;
            $ret.f = _this.a.ip;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bd) !== null) {
            var b = this.a.bd;
            if (b.nn && b.bg != 2 && b.bg != 1) {
                a.a = true;
            }
        }
        return a;
    };
    AxisView.prototype.a0 = function () {
        return this.a9.ak.d;
    };
    AxisView.prototype.g = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new PathRenderingInfo();
            $ret.e = _this.a.ik;
            $ret.c = _this.a.d6;
            $ret.f = _this.a.iq;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bd) !== null) {
            var b = this.a.bd;
            if (b.nn && b.bg != 2 && b.bg != 1) {
                a.a = true;
            }
        }
        return a;
    };
    Object.defineProperty(AxisView.prototype, "d", {
        get: function () {
            return this.a.an().a;
        },
        enumerable: true,
        configurable: true
    });
    AxisView.prototype.at = function (a, b, c) {
        this.d.ac = a;
        this.d.cp = b;
        this.d.co = c;
        this.ae();
    };
    AxisView.prototype.y = function () {
        this.d.ab.clear();
        this.ae();
    };
    AxisView.prototype.ap = function (a) {
        this.d.bn = a;
        this.ae();
    };
    AxisView.prototype.au = function (a, b) {
        this.d.a1 = a;
        this.d.a2 = b;
    };
    AxisView.prototype.ao = function (a) {
        this.d.a8 = a;
    };
    AxisView.prototype.v = function () {
    };
    AxisView.prototype.o = function (a) {
        return null;
    };
    AxisView.prototype.n = function (dataItem_) {
        if (this.a.ar != null) {
            return this.a.ar(dataItem_);
        }
        var label_ = this.a.e7;
        var a = typeof dataItem_ === 'number' && typeof label_ === 'string';
        var labelValue_ = null;
        if (this.h != null) {
            labelValue_ = this.h.getPropertyValue(dataItem_);
            if ((labelValue_ === undefined)) {
                labelValue_ = label_;
            }
        }
        else {
            labelValue_ = a ? stringFormat(label_, dataItem_) : (typeof dataItem_[label_] != 'undefined') ? dataItem_[label_] : label_;
            ;
        }
        if (this.a.expectFunctions) {
            if ((typeof (labelValue_) == 'function')) {
                labelValue_ = labelValue_();
            }
        }
        return labelValue_;
    };
    AxisView.prototype.af = function (a, b) {
        this.j = a;
        this.k = b;
    };
    Object.defineProperty(AxisView.prototype, "isDirty", {
        get: function () {
            return this._isDirty;
        },
        set: function (a) {
            this._isDirty = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisView.prototype.ae = function () {
        if (this.a.bd == null || this.j == null) {
            return;
        }
        if (!this.isDirty) {
            this.isDirty = true;
            this.a.bd.ah.n();
        }
    };
    AxisView.prototype.undirty = function (a) {
        this.isDirty = false;
        this.al(a);
    };
    AxisView.prototype.al = function (a) {
        if (this.j == null) {
            return;
        }
        if (this.j.d) {
            if (this.a.bf != null && this.a.bf.ea != 1) {
                this.j.z();
                this.j.aa(this.a.bf.ea, this.a.bf.ea);
            }
            var b = this.a.bd.mv();
            if (a) {
                this.j.k(b.left, b.top, b.width, b.height);
            }
            if (a) {
                if (this.a.bf.md != null && !this.a.i1.isEmpty) {
                    this.bb.o = this.a.i1.top;
                    this.bb.n = this.a.i1.left;
                    this.bb.width = this.a.i1.width;
                    this.bb.height = this.a.i1.height;
                    this.bb._fill = this.a.bf.md;
                    this.j.v(this.bb);
                }
            }
            this.j.z();
            this.j.ae(this.a.i1);
            this.am();
            this.j.y();
            if (this.a.bf != null && this.a.bf.ea != 1) {
                this.j.y();
            }
        }
        if (this.k.d) {
            if (this.a.bf != null && this.a.bf.ea != 1) {
                this.k.z();
                this.k.aa(this.a.bf.ea, this.a.bf.ea);
            }
            var c = this.a5;
            var d = this.a.bd.mv();
            if (!c.isEmpty && a) {
                this.k.k(d.left, d.top, d.width, d.height);
            }
            if (this.a.bf != null && this.a.bf.ea != 1) {
                this.k.y();
            }
        }
    };
    AxisView.prototype.postRender = function () {
        this.d.ca();
    };
    AxisView.prototype.am = function () {
        if (this.j.d) {
            this.a7._stroke = this.a.ii;
            this.ba._fill = this.a.il;
            this.a9._stroke = this.a.ih;
            this.a8._stroke = this.a.ig;
            this.a9.ac = this.a.d6;
            this.a8.ac = this.a.d3;
            this.a7.ac = this.a.en;
            this.a9.ai = this.a.iq;
            this.a8.ai = this.a.ip;
            this.a7.ai = this.a.ir;
            this.a5 = this.a.i1;
            this.j.s(this.a7);
            this.j.s(this.ba);
            this.j.s(this.a8);
            this.j.s(this.a9);
        }
    };
    AxisView.prototype.ac = function () {
        this.ae();
    };
    AxisView.prototype.aa = function (a) {
        if (a != null) {
            a.ah.r(this);
            a.bn.cj();
        }
    };
    AxisView.prototype.u = function (a) {
        if (a != null) {
            a.ah.l(this);
            this.ae();
        }
    };
    AxisView.prototype.i = function () {
        if (this.a.bf == null || this.a.bf.bn.i.ae == null) {
            return null;
        }
        return FontUtil.getFont(this.a.bf.bn.i.ae);
    };
    AxisView.prototype.l = function () {
        return this.j == null;
    };
    AxisView.prototype.ak = function () {
        if (this.a.b0 || this.a.cc) {
            return;
        }
        if (this.a.f7 == null) {
            this.a.hk = null;
            this.a.cg = true;
            this.a.g5();
            return;
        }
        if (this.a.hk == null) {
            var a = new TextBlock();
            a.ak = this.a.f7;
            a.dataContext = this.a.bc;
            this.a.hk = a;
        }
        else {
            this.a.hk.ak = this.a.f7;
            this.a.hk.dataContext = this.a.bc;
        }
        this.a.cg = true;
        this.a.g5();
    };
    AxisView.prototype.t = function () {
        var a;
        var b = new AxisLabelSettings();
        if (this.a.b0) {
            a = "ui-angular-axis-labels";
            b.margin = 0;
        }
        else if (this.a.cf) {
            a = "ui-vertical-axis-labels";
            b.location = 2;
        }
        else if (this.a.az == 3) {
            a = "ui-radial-axis-labels";
            b.location = 5;
        }
        else {
            a = "ui-horizontal-axis-labels";
            b.location = 1;
        }
        this.s(b, a);
    };
    AxisView.prototype.aw = function () {
        if (this.a.bf == null) {
            return;
        }
        var a = this.a.bf.nj;
        var b = a.fk;
        var c = a.fj;
        if (this.a.im == null) {
            if (b == null) {
                this.a.im = a.fh;
            }
            else if (b.color.l != 0) {
                this.a.im = b;
            }
        }
        if (this.a.ij == null) {
            if (c == null) {
                this.a.ij = a.fh;
            }
            else if (c.color.l != 0) {
                this.a.ij = c;
            }
        }
    };
    AxisView.prototype.s = function (a, b) {
        this.a.es.startCSSQuery();
        var c = this.a.es.getCssDefaultPropertyValue(b, "margin-top");
        var d = this.a.es.getCssDefaultPropertyValue(b, "margin-right");
        var e = this.a.es.getCssDefaultPropertyValue(b, "margin-bottom");
        var f = this.a.es.getCssDefaultPropertyValue(b, "margin-left");
        var g = this.a.es.getCssDefaultPropertyValue(b, "text-align");
        var h = this.a.es.getCssDefaultPropertyValue(b, "vertical-align");
        var i = this.a.es.getCssDefaultPropertyValue(b, "color");
        this.a.es.endCSSQuery();
        if (c != null) {
            a.topMargin = parseFloat(c);
        }
        if (d != null) {
            a.rightMargin = parseFloat(d);
        }
        if (e != null) {
            a.bottomMargin = parseFloat(e);
        }
        if (f != null) {
            a.leftMargin = parseFloat(f);
        }
        if (i != null) {
            if (a.textColor == null) {
                a.textColor = new Brush();
            }
            a.textColor._fill = i;
        }
        if (g != null) {
            switch (g) {
                case "right":
                    a.horizontalAlignment = 2;
                    break;
                case "left":
                    a.horizontalAlignment = 0;
                    break;
                default:
                    a.horizontalAlignment = 1;
                    break;
            }
        }
        if (h != null) {
            switch (h) {
                case "top":
                    a.verticalAlignment = 0;
                    break;
                case "bottom":
                    a.verticalAlignment = 2;
                    break;
                default:
                    a.verticalAlignment = 1;
                    break;
            }
        }
        this.a.aw = a;
    };
    AxisView.prototype.preRender = function () {
        if (this.a.bf != null) {
            this.a.bf.hk();
        }
    };
    AxisView.prototype.isValid = function () {
        return this.a != null && !this.a.i1.isEmpty;
    };
    AxisView.prototype.a2 = function (a) {
        return { $type: Point_$type, x: a.n, y: a.o };
    };
    AxisView.prototype.a3 = function () {
        return { $type: Point_$type, x: this.a.at.cn.left, y: this.a.at.cn.top };
    };
    AxisView.prototype.a6 = function () {
        var a = this.a.at.cn;
        return a;
    };
    AxisView.prototype.a4 = function (a) {
        return { $type: Point_$type, x: a.n, y: a.o };
    };
    AxisView.prototype.bd = function (a) {
        var b = this.a.at.ae.t();
        var c = this.a.at.ae.v();
        var d = this.a.at.ae.u();
        var e = this.a.at.ae.s();
        return new Thickness(1, b, c, d, e);
    };
    AxisView.prototype.ah = function () {
        if (FastReflectionHelper.needsHelper(this.a.e7)) {
            this.h = new FastReflectionHelper(true, this.a.e7);
        }
        else {
            this.h = null;
        }
    };
    AxisView.$t = markType(AxisView, 'AxisView', Base.$, [ISchedulableRender_$type]);
    return AxisView;
}(Base));
/**
 * @hidden
 */
var CategoryAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAxisBaseView, _super);
    function CategoryAxisBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.be = null;
        _this.be = a;
        return _this;
    }
    CategoryAxisBaseView.prototype.o = function (a) {
        var b = 0;
        if (this.be.categoryMode == 0) {
            b = truncate(Math.round(a));
        }
        else {
            b = truncate(Math.floor(a));
        }
        if (b < 0 || b > this.a.jz - 1) {
            return null;
        }
        var c = this.a.jf.item(b);
        var d = this.n(c);
        if (d == null) {
            return null;
        }
        return d.toString();
    };
    CategoryAxisBaseView.prototype.bf = function (a) {
        var b = 0;
        var c = false;
        for (var d = 0; d < a.count; d++) {
            var e = typeCast(FrameworkElement.$, a._inner[d]);
            if (e == null) {
                e = this.a.bo.item(d);
                var f = a._inner[d] == null ? "" : a._inner[d].toString();
                var g = e.ak;
                var h = 0;
                var i = 0;
                if (g != null) {
                    h = g.length;
                }
                if (f != null) {
                    i = f.length;
                }
                if (h != i) {
                    c = true;
                }
                e.ak = f;
                b++;
            }
            else {
                this.d.ab.add(e);
            }
        }
        if (c) {
            this.a.cg = true;
        }
        this.a.gf();
        return b;
    };
    CategoryAxisBaseView.$t = markType(CategoryAxisBaseView, 'CategoryAxisBaseView', AxisView.$);
    return CategoryAxisBaseView;
}(AxisView));
/**
 * @hidden
 */
var HorizontalAxisLabelPanelBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAxisLabelPanelBaseView, _super);
    function HorizontalAxisLabelPanelBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.ax = null;
        _this.ax = a;
        return _this;
    }
    HorizontalAxisLabelPanelBaseView.prototype.az = function () {
    };
    HorizontalAxisLabelPanelBaseView.prototype.ay = function () {
        return false;
    };
    HorizontalAxisLabelPanelBaseView.prototype.a0 = function (a) {
        var b = this.a.bj();
        var c, d;
        c = this.ax.c0();
        d = this.ax.cx();
        var e = this.a.af != null ? this.a.af.verticalAlignment : 1;
        var f = this.a.a5;
        var g = a.count;
        var h = this.a.cn;
        var i = this.ax.cz();
        var j = i / 2;
        for (var k = 0; k < g; k++) {
            var l = a._inner[k];
            var m = l.height / 2;
            switch (e) {
                case 0:
                    l.y = h.top + c;
                    break;
                case 1:
                case 3:
                    l.y = (h.top + c + j) - m;
                    break;
                case 2:
                    l.y = (h.bottom - d) - l.height;
                    break;
            }
        }
    };
    HorizontalAxisLabelPanelBaseView.$t = markType(HorizontalAxisLabelPanelBaseView, 'HorizontalAxisLabelPanelBaseView', AxisLabelPanelBaseView.$);
    return HorizontalAxisLabelPanelBaseView;
}(AxisLabelPanelBaseView));
/**
 * @hidden
 */
var NumericAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAxisBaseView, _super);
    function NumericAxisBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.be = null;
        _this.be = a;
        return _this;
    }
    NumericAxisBaseView.prototype.bf = function () {
    };
    NumericAxisBaseView.prototype.o = function (a) {
        var b = this.be.jf.d(this.be.i1, this.be.bf.mq, this.be.iw(), this.be.iv());
        return this.be.jf.w(b, a, -1, NaN);
    };
    NumericAxisBaseView.$t = markType(NumericAxisBaseView, 'NumericAxisBaseView', AxisView.$);
    return NumericAxisBaseView;
}(AxisView));
/**
 * @hidden
 */
var VerticalAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAxisLabelPanelView, _super);
    function VerticalAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.ax = null;
        _this.ax = a;
        return _this;
    }
    VerticalAxisLabelPanelView.prototype.ay = function () {
    };
    VerticalAxisLabelPanelView.prototype.d = function () {
        var a = this.a.ac.bf.getFontInfo();
        if (this.a.ac.bc != null && this.a.ac.bc.textStyle != null) {
            a = this.a.ac.bc.g(this.a.ac.bf.bn.i.ae);
        }
        else {
            var b = this.a.ac.bf.bq();
            if (b != null) {
                a = b;
            }
        }
        return a;
    };
    VerticalAxisLabelPanelView.prototype.aw = function () {
        return this.a.ac.bf.m6();
    };
    VerticalAxisLabelPanelView.prototype.as = function () {
        var a = this.a.ac.bd.getFontBrush();
        if (this.a.ac.bc != null && this.a.ac.bc.textColor != null) {
            a = this.a.ac.bc.textColor;
        }
        else {
            var b = this.a.ac.bf.l8();
            if (b != null) {
                a = b;
            }
        }
        return a;
    };
    VerticalAxisLabelPanelView.prototype.az = function (a, b) {
        var c, d;
        c = this.ax.cu();
        d = this.ax.cw();
        var e = this.a.af != null ? this.a.af.horizontalAlignment : 1;
        var f = this.a.a5;
        var g = this.ax.cx();
        var h = g / 2;
        var i = this.a.cn;
        for (var j = 0; j < a.count; j++) {
            var k = a._inner[j];
            var l = k.width / 2;
            switch (e) {
                case 0:
                    k.x = i.left + c;
                    break;
                case 1:
                case 3:
                    k.x = (i.left + c + h) - l;
                    break;
                case 2:
                    k.x = (i.right - d) - k.width;
                    break;
            }
        }
    };
    VerticalAxisLabelPanelView.$t = markType(VerticalAxisLabelPanelView, 'VerticalAxisLabelPanelView', AxisLabelPanelBaseView.$);
    return VerticalAxisLabelPanelView;
}(AxisLabelPanelBaseView));
/**
 * @hidden
 */
var XamDataChartView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamDataChartView, _super);
    function XamDataChartView(a) {
        var _this = _super.call(this, a) || this;
        _this.fc = null;
        _this.fl = null;
        _this.fh = null;
        _this.fi = null;
        _this.fk = null;
        _this.fj = null;
        _this.fe = 0;
        _this.ff = 0;
        _this.fd = null;
        _this.fc = a;
        return _this;
    }
    XamDataChartView.prototype.fg = function (a) {
        this.n.ah.p();
    };
    XamDataChartView.prototype.dj = function () {
        _super.prototype.dj.call(this);
        if (this.b.count == 0 && this.w != null) {
            if (this.n.ea != 1) {
                this.w.z();
                this.w.aa(this.n.ea, this.n.ea);
            }
            this.w.k(0, 0, this.a6, this.a5);
            if (this.n.ea != 1) {
                this.w.y();
            }
        }
    };
    XamDataChartView.prototype.dw = function () {
        var e_86, _a;
        var a, b;
        var c = 1, d = 0;
        var e = false;
        var f = this.i.e();
        var g;
        var h = this.i.a5(c, g, a, b, d, e);
        c = h.p0;
        g = h.p1;
        a = h.p2;
        b = h.p3;
        d = h.p4;
        e = h.p5;
        if (isNaN_(this.n.eu)) {
            this.n.eu = g[0];
        }
        if (isNaN_(this.n.el)) {
            this.n.el = g[1];
        }
        if (isNaN_(this.n.ef)) {
            this.n.ef = g[2];
        }
        if (isNaN_(this.n.ej)) {
            this.n.ej = g[3];
        }
        this.fc.po = f.i;
        this.fc.pm = f.i;
        this.fc.pn = f.i;
        this.fc.nn = e;
        this.fk = a;
        this.fj = b;
        this.fc.m9 = f.a;
        this.fc.nc = f.f;
        this.fc.na = f.b != null ? f.b : new BrushCollection();
        this.fc.nb = f.c != null ? f.c : new BrushCollection();
        if (this.fc.na.count == 0) {
            for (var i = 0; i < f.a.count; i++) {
                this.fc.na.add(f.a.item(i));
            }
        }
        if (f.c.count == 0) {
            for (var j = 0; j < f.f.count; j++) {
                this.fc.nb.add(f.f.item(j));
            }
        }
        this.fi = f.j;
        this.fl = f.k;
        this.fd = f.h;
        this.fh = f.i;
        this.fe = c;
        try {
            for (var _b = __values(fromEnum(this.fc.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var k = _c.value;
                k.jn();
            }
        }
        catch (e_86_1) {
            e_86 = { error: e_86_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_86)
                    throw e_86.error;
            }
        }
        this.ff = d;
    };
    XamDataChartView.prototype.dt = function () {
        this.e4.ac = this.e5.ac = DeviceUtils.g(1.4);
        this.e4._stroke = this.e5._stroke = this.fi;
        _super.prototype.dt.call(this);
    };
    XamDataChartView.$t = markType(XamDataChartView, 'XamDataChartView', SeriesViewerView.$);
    return XamDataChartView;
}(SeriesViewerView));
/**
 * @hidden
 */
var SeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesView, _super);
    function SeriesView(a) {
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.p = false;
        _this.d = null;
        _this._isDirty = false;
        _this.bt = null;
        _this.bk = null;
        _this.s = 0;
        _this.bo = Rect.empty;
        _this.bj = new Brush();
        _this.f = new SeriesComponentsFromView();
        _this.h = null;
        _this.i = null;
        _this.bp = null;
        _this.bq = null;
        _this.j = false;
        _this.a = null;
        _this.o = false;
        _this.k = false;
        _this.m = false;
        _this.aa = null;
        _this.s = NaN;
        _this.o = true;
        _this.e = a;
        _this.n = false;
        _this.bt = new Rectangle();
        _this.p = false;
        return _this;
    }
    SeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.e.a0.a$p(this.e);
    };
    SeriesView.prototype.am = function () {
        if (this.e.cx) {
            this.e.a0.a$s(this.e);
        }
    };
    SeriesView.prototype.ap = function () {
        if (!this.n) {
            this.e.bl = 0;
            this.e.bj = 0;
            this.e.bk = 1;
            this.d = new DataContext();
            this.d.series = this.e;
            this.e.bv = EasingFunctions.cubicEase;
            this.ac();
        }
    };
    SeriesView.prototype.getEffectiveViewport = function () {
        return this.e.getEffectiveViewport1(this);
    };
    SeriesView.prototype.aw = function () {
        this.an();
    };
    SeriesView.prototype.ag = function () {
    };
    Object.defineProperty(SeriesView.prototype, "t", {
        get: function () {
            if (this.e.bs != null) {
                return this.e.bs.bn.i.ae;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesView.prototype, "isDirty", {
        get: function () {
            return this._isDirty;
        },
        set: function (a) {
            this._isDirty = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesView.prototype.get_index = function () {
        if (this.e == null || this.e.bs == null) {
            return 0;
        }
        if (this.e.bs.cx) {
            if (this.e.ct) {
                return this.e.bs.series.indexOf(this.e);
            }
            else {
                var a = this.e.bs.series.indexOf(this.e);
                if (a >= 0) {
                    return a;
                }
                for (var b = 0; b < this.e.bs.series.count; b++) {
                    if (this.e.bs.series._inner[b].ct) {
                        var c = this.e.bs.series._inner[b].a5();
                        if (c == this.e) {
                            return b;
                        }
                    }
                }
                return a;
            }
        }
        var d = typeCast(XamDataChart.$, this.e.bq);
        var e = 0;
        if (d != null) {
            if (d.ng == 2 || d.ng == 0) {
                e = d.axes.count;
            }
        }
        var f = 0;
        for (var g = 0; g < this.e.bs.series.count; g++) {
            if (this.e.bs.series._inner[g] == this.e) {
                break;
            }
            if (this.e.bs.series._inner[g].isStacked) {
                f += this.e.bs.series._inner[g].fg();
            }
            else {
                f++;
            }
        }
        return e + f;
    };
    Object.defineProperty(SeriesView.prototype, "index", {
        get: function () {
            return this.get_index();
        },
        enumerable: true,
        configurable: true
    });
    SeriesView.prototype.an = function () {
        if (this.e.bs == null) {
            return;
        }
        if (!this.isDirty) {
            this.isDirty = true;
            this.a.o(this.h, this.i);
        }
    };
    SeriesView.prototype.undirty = function (a) {
        this.isDirty = false;
        this.a1(a);
    };
    SeriesView.prototype.ar = function () {
        this.an();
    };
    SeriesView.prototype.bn = function () {
        if (this.bk == null) {
            this.bk = ((function () {
                var $ret = new Brush();
                $ret.color = Color.u(0, 0, 0, 0);
                return $ret;
            })());
        }
        return this.bk;
    };
    SeriesView.prototype.r = function () {
        if (!isNaN_(this.s)) {
            return this.s;
        }
        if (this.e.bs != null) {
            return this.e.bs.ea;
        }
        else {
            return 1;
        }
    };
    SeriesView.prototype.a1 = function (a) {
        if (this.h == null) {
            return;
        }
        if (this.bo.isEmpty) {
            this.bo = this.br;
        }
        var b = this.bo;
        var c = this.e.bs.mv();
        var d = c.left;
        var e = c.top;
        var f = c.width;
        var g = c.height;
        var h = this.r();
        if (this.m) {
            d = this.br.left;
            e = this.br.top;
            f = this.br.width;
            g = this.br.height;
        }
        if (this.h.d) {
            if (h != 1) {
                this.h.z();
                this.h.aa(h, h);
            }
            if (a) {
                this.h.k(d, e, f, g);
            }
            if (a) {
                if (this.e.bs.md != null && !this.br.isEmpty) {
                    this.bt.o = this.br.top;
                    this.bt.n = this.br.left;
                    this.bt.width = this.br.width;
                    this.bt.height = this.br.height;
                    this.bt._fill = this.e.bs.md;
                    this.h.v(this.bt);
                }
            }
            if (h != 1) {
                this.h.y();
            }
        }
        if (this.i != null && this.o) {
            if (this.i.d) {
                if (this.e.bs != null && h != 1) {
                    this.i.z();
                    this.i.aa(h, h);
                }
                if (!b.isEmpty && a) {
                    this.i.k(b.left, b.top, b.width, b.height);
                }
                this.a7(true);
                this.a3(this.i, true);
                this.a2(this.i, true);
                if (h != 1) {
                    this.i.y();
                }
            }
        }
        if (this.h.d && this.o) {
            if (h != 1) {
                this.h.z();
                this.h.aa(h, h);
            }
            this.h.z();
            if (!this.n && Rect.l_op_Inequality(this.e.lp, null) && !this.e.lp.isEmpty && (this.e.lp.width != 1 || this.e.lp.height != 1)) {
                this.h.ae(new Rect(0, this.br.left + this.br.width * this.e.lp.left, this.br.top + this.br.height * this.e.lp.top, this.br.width * this.e.lp.width, this.br.height * this.e.lp.height));
            }
            else {
                this.h.ae(this.br);
            }
            this.a7(false);
            this.h.ad(this.e._opacity);
            if (this.e.cp && this.e.cq && !this.n) {
                if (this.e.du) {
                    this.h.o(this.e.la.colorString, 0, this.e.ew, this.e.ex);
                    var i = this.e.bs.bn.i.x;
                    var j = this.e.bs.bn.i.ak;
                    if (h != 1) {
                        i.z();
                        i.aa(h, h);
                    }
                    i.k(c.left, c.top, c.width, c.height);
                    this.a3(i, false);
                    this.a2(i, false);
                    this.h.m(j.getNativeElement(), 1, 0, 0, c.width, c.height);
                    if (h != 1) {
                        i.y();
                    }
                }
                else {
                    this.h.o(this.e.la.colorString, this.e.ev, this.e.ew, this.e.ex);
                    this.a3(this.h, false);
                    this.a2(this.h, false);
                }
                this.h.l();
            }
            else {
                this.a3(this.h, false);
                this.a2(this.h, false);
            }
            this.h.ad(1);
            this.h.y();
            if (h != 1) {
                this.h.y();
            }
        }
    };
    SeriesView.prototype.ba = function (a, b, c) {
        if (c) {
            this.bc(a, b);
        }
        else {
            this.bb(a, b);
        }
    };
    SeriesView.prototype.bd = function (a, b, c) {
        if (c) {
            this.bf(a, b);
        }
        else {
            this.be(a, b);
        }
    };
    SeriesView.prototype.x = function (a, b) {
        if (b) {
            return this.y(a);
        }
        else {
            return this.z(a);
        }
    };
    SeriesView.prototype.y = function (a) {
        return null;
    };
    SeriesView.prototype.z = function (a) {
        return null;
    };
    SeriesView.prototype.bb = function (a, b) {
    };
    SeriesView.prototype.be = function (a, b) {
    };
    SeriesView.prototype.bc = function (a, b) {
    };
    SeriesView.prototype.bf = function (a, b) {
    };
    SeriesView.prototype.a7 = function (a) {
        if (a) {
            this.a9();
        }
        else {
            this.a8();
        }
    };
    SeriesView.prototype.a8 = function () {
    };
    SeriesView.prototype.a9 = function () {
    };
    SeriesView.prototype.bm = function (a) {
        return this.bl();
    };
    SeriesView.prototype.bl = function () {
        var a = this.e.fk;
        var num_ = (a + 1) * 1000;
        var b = ((num_ & 0x3F) << 2);
        num_ = (num_ >> 6);
        var c = ((num_ & 0x3F) << 2);
        num_ = (num_ >> 6);
        var d = ((num_ & 0x3F) << 2);
        this.bj._fill = "rgb(" + b + "," + c + "," + d + ")";
        return this.bj;
    };
    SeriesView.prototype.a3 = function (a, b) {
        this.bo = this.br;
    };
    SeriesView.prototype.a2 = function (a, b) {
    };
    SeriesView.prototype.au = function () {
    };
    SeriesView.prototype.aj = function () {
    };
    SeriesView.prototype.ak = function () {
    };
    SeriesView.prototype.g = function () {
        return this.f;
    };
    SeriesView.prototype.a6 = function (a) {
    };
    SeriesView.prototype.q = function () {
        return true;
    };
    SeriesView.prototype.at = function () {
    };
    SeriesView.prototype.as = function () {
    };
    SeriesView.prototype.a4 = function () {
        this.e.k3 = null;
    };
    SeriesView.prototype.ae = function () {
        this.e.k3 = this.e.k5;
    };
    SeriesView.prototype.a5 = function () {
        this.e.k4 = null;
    };
    SeriesView.prototype.af = function () {
        this.e.k4 = this.e.k8;
    };
    SeriesView.prototype.c = function (a) {
        if (typeCast(DataContext.$, a) !== null) {
            return a;
        }
        return null;
    };
    SeriesView.prototype.ao = function (a, b) {
        this.h = a;
        this.i = b;
    };
    Object.defineProperty(SeriesView.prototype, "br", {
        get: function () {
            return this.bp;
        },
        set: function (a) {
            this.bp = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesView.prototype.get_bs = function () {
        if (this.m) {
            return this.bq;
        }
        else if (this.n) {
            return XamDataChart.m0;
        }
        else {
            return this.e.bs != null ? this.e.bs.mq : Rect.empty;
        }
    };
    Object.defineProperty(SeriesView.prototype, "bs", {
        get: function () {
            return this.get_bs();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesView.prototype, "n", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesView.prototype.ah = function (a) {
        if (a != null) {
            this.a.r(this);
            if (this.e.bh != null) {
                this.e.bh.a.r(this.e.bh);
            }
        }
    };
    SeriesView.prototype.ad = function (a) {
        var e_87, _a;
        if (a != null) {
            if (this.e.ds) {
                this.h = this.e.bs.bn.x;
                a.bn.a.l(this);
                this.a = a.bn.a;
            }
            else {
                this.h = this.e.bs.bn.w;
                a.ah.l(this);
                this.a = a.ah;
            }
            if (this.e.bh != null) {
                a.ai.l(this.e.bh);
                this.e.bh.a = a.ai;
                this.e.bh.an();
            }
            if (this.e.cx) {
                try {
                    for (var _b = __values(fromEnum(this.e.a0.a$h.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var b = _c.value;
                        a.ag.l(this.e.a0.a$h.item(b));
                        this.e.a0.a$h.item(b).a = a.ag;
                        this.e.a0.a$h.item(b).an();
                    }
                }
                catch (e_87_1) {
                    e_87 = { error: e_87_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_87)
                            throw e_87.error;
                    }
                }
            }
            this.an();
        }
    };
    SeriesView.prototype.postRender = function () {
        this.ax();
    };
    SeriesView.prototype.ax = function () {
    };
    SeriesView.prototype.b = function (a) {
        return null;
    };
    SeriesView.prototype.az = function (a) {
        this.e.bh.h = a.a;
    };
    SeriesView.prototype.ai = function (a) {
    };
    SeriesView.prototype.bg = function () {
        if (this.k) {
            return;
        }
        if (this.e.bs != null) {
            var a = (this.e.legend != null) ? this.e.legend : this.e.bs.legend;
            if (a != null && this.e.jw != null && a.containsChild(this.e.jw)) {
                a.removeChild(this.e.jw);
                var b = this.e.fw();
                b.content.actualItemBrush = this.e.k3;
                b.content.outline = this.e.k8;
                b.content.thickness = this.e.ey;
                a.addChildInOrder(this.e.jw, this.e);
            }
        }
    };
    SeriesView.prototype.aq = function () {
        this.e.hp(this.e.aw, this.e.aw);
    };
    SeriesView.prototype.av = function () {
        this.bg();
    };
    SeriesView.prototype.getViewInfo = function (a, b) {
        a = this.br;
        b = this.bs;
        return {
            p0: a,
            p1: b
        };
    };
    SeriesView.prototype.l = function () {
        return this.h != null;
    };
    SeriesView.prototype.bh = function () {
        this.o = this.e._visibility == 0;
        this.an();
    };
    SeriesView.prototype.a0 = function () {
        this.e.a0.a$ae(this.e);
    };
    SeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    };
    SeriesView.prototype.al = function () {
    };
    SeriesView.prototype.preRender = function () {
        if (this.e.bs != null && !this.n) {
            this.e.bs.hk();
        }
    };
    SeriesView.prototype.isValid = function () {
        return true;
    };
    SeriesView.prototype.ay = function (a) {
        this.h = a.a;
    };
    SeriesView.prototype.bi = function (type_) {
        var legendTemplates_ = TypeRegistrar.get("LegendTemplates");
        var a = (legendTemplates_.resolveLegendItemTemplate(type_));
        return a;
    };
    SeriesView.$t = markType(SeriesView, 'SeriesView', Base.$, [ISchedulableRender_$type, IProvidesViewport_$type]);
    return SeriesView;
}(Base));
/**
 * @hidden
 */
var MarkerSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerSeriesView, _super);
    function MarkerSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.by = null;
        _this.b2 = 1;
        _this.b4 = 2;
        _this.b3 = 3;
        _this.b1 = null;
        _this.b0 = false;
        _this.bu = new Marker();
        _this.cl = null;
        _this.bu = new Marker();
        _this.bu.content = new DataContext();
        _this.by = a;
        return _this;
    }
    MarkerSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.b1 = new List$1(Marker.$, 0);
        this.cl = ((function () {
            var $ret = new DataTemplate();
            $ret.render = MarkerTemplates.c;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
    };
    MarkerSeriesView.prototype.cd = function () {
        var e_88, _a;
        try {
            for (var _b = __values(fromEnum(this.b1)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ah = this.by.mj;
            }
        }
        catch (e_88_1) {
            e_88 = { error: e_88_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_88)
                    throw e_88.error;
            }
        }
        this.an();
    };
    MarkerSeriesView.prototype.ck = function (a) {
    };
    MarkerSeriesView.prototype.bx = function () {
        var _this = this;
        var a = new Marker();
        a.content = ((function () {
            var $ret = new DataContext();
            $ret.series = _this.e;
            return $ret;
        })());
        a.ah = this.by.mj;
        this.b1.add(a);
        return a;
    };
    MarkerSeriesView.prototype.cg = function (a) {
        a._visibility = 0;
    };
    MarkerSeriesView.prototype.ci = function (a) {
        a._visibility = 1;
    };
    MarkerSeriesView.prototype.ch = function (a) {
        this.b1.remove(a);
    };
    MarkerSeriesView.prototype.bz = function () {
        return this.by.mk != null;
    };
    MarkerSeriesView.prototype.cb = function () {
        this.by.mi = null;
    };
    MarkerSeriesView.prototype.b5 = function () {
        this.by.mi = this.by.mk;
    };
    MarkerSeriesView.prototype.cm = function (a) {
        var b = a.n;
        var c = a.o;
        var d = a.m;
        var e = a.l;
        return new Rect(0, b - d / 2, c - d / 2, d, e);
    };
    MarkerSeriesView.prototype.b8 = function (a) {
        switch (a) {
            case SeriesViewer.$$p[1]:
                this.by.mi = this.by.bs.kn;
                break;
            case SeriesViewer.$$p[26]:
                this.by.mi = this.by.bs.kw;
                break;
            case SeriesViewer.$$p[18]:
                this.by.mi = this.by.bs.kt;
                break;
            case SeriesViewer.$$p[20]:
                this.by.mi = this.by.bs.ku;
                break;
            case SeriesViewer.$$p[4]:
                this.by.mi = this.by.bs.ko;
                break;
            case SeriesViewer.$$p[13]:
                this.by.mi = this.by.bs.kr;
                break;
            case SeriesViewer.$$p[6]:
                this.by.mi = this.by.bs.kp;
                break;
            case SeriesViewer.$$p[23]:
                this.by.mi = this.by.bs.kv;
                break;
            case SeriesViewer.$$p[14]:
                this.by.mi = this.by.bs.ks;
                break;
            case SeriesViewer.$$p[7]:
                this.by.mi = this.by.bs.kq;
                break;
        }
    };
    MarkerSeriesView.prototype.b9 = function () {
        this.by.mv = null;
    };
    MarkerSeriesView.prototype.b6 = function () {
        this.by.mv = this.by.mx;
    };
    MarkerSeriesView.prototype.ca = function () {
        this.by.mw = null;
    };
    MarkerSeriesView.prototype.b7 = function () {
        this.by.mw = this.by.my;
    };
    MarkerSeriesView.prototype.cj = function () {
        this.an();
    };
    MarkerSeriesView.prototype.be = function (a, b) {
        _super.prototype.be.call(this, a, b);
        if (!this.b0) {
            var c = a;
            var d = c.content;
            if (d != null) {
                d.actualItemBrush = this.by.mv;
                if (d.itemBrush != null) {
                    d.actualItemBrush = d.itemBrush;
                }
                d.outline = this.by.mw;
                d.thickness = this.b4;
            }
        }
    };
    MarkerSeriesView.prototype.bf = function (a, b) {
        _super.prototype.bf.call(this, a, b);
        var c = a;
        this.bu._visibility = c._visibility;
        this.bu.ah = c.ah;
        this.bu.width = c.width;
        this.bu.height = c.height;
        this.bu.m = c.m;
        this.bu.l = c.l;
        this.bu.n = c.n;
        this.bu.o = c.o;
        var d = this.bm(b);
        var e = this.bu.content;
        var f = c.content;
        e.item = f.item;
        e.series = f.series;
        e.thickness = f.thickness;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = this.b2 + this.b3;
        }
    };
    MarkerSeriesView.prototype.b = function (a) {
        if (a >= 0 && a < this.b1.count) {
            return this.b1._inner[a].content;
        }
        return _super.prototype.b.call(this, a);
    };
    MarkerSeriesView.prototype.a2 = function (a, b) {
        _super.prototype.a2.call(this, a, b);
        if (a.d) {
            var c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.g();
            c.viewportTop = this.br.top;
            c.viewportLeft = this.br.left;
            c.viewportWidth = this.br.width;
            c.viewportHeight = this.br.height;
            c.passID = "Markers";
            var d = new DataTemplateRenderInfo();
            d.isHitTestRender = b;
            d.passInfo = c;
            var e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            var f = false;
            var g = a.g();
            e.context = g;
            d.context = g;
            var h = 0;
            var i = 0;
            if (this.by.mj != null && this.by.mj.passStarting != null) {
                this.by.mj.passStarting(c);
            }
            for (var j = 0; j < this.b1.count; j++) {
                var k = this.b1._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bd(k, j, b);
                if (b) {
                    k = this.bu;
                }
                if (!f) {
                    e.data = k.content;
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    var l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.p(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.by.mj != null && this.by.mj.passCompleted != null) {
                this.by.mj.passCompleted(c);
            }
        }
    };
    MarkerSeriesView.prototype.ce = function (a) {
        a.create = runOn(this, this.bx);
        a.destroy = runOn(this, this.ch);
        a.activate = runOn(this, this.cg);
        a.disactivate = runOn(this, this.ci);
    };
    MarkerSeriesView.prototype.cf = function (a) {
        a.create = runOn(this, this.bx);
        a.destroy = runOn(this, this.ch);
        a.activate = runOn(this, this.cg);
        a.disactivate = runOn(this, this.ci);
    };
    MarkerSeriesView.prototype.bv = function (a) {
        var b = this.bw(a, 0);
        if (b == null) {
            b = this.bw(a, 3);
        }
        return b;
    };
    MarkerSeriesView.prototype.bw = function (a, b) {
        var c;
        var d;
        var e;
        var f;
        for (var g = this.b1.count - 1; g >= 0; g--) {
            var h = this.b1._inner[g];
            if (h._visibility == 1 || h._opacity == 0) {
                continue;
            }
            c = (h.m / 2) + b;
            d = (h.l / 2) + b;
            e = h.ai;
            f = h.aj;
            if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                return h;
            }
        }
        return null;
    };
    MarkerSeriesView.$t = markType(MarkerSeriesView, 'MarkerSeriesView', SeriesView.$);
    return MarkerSeriesView;
}(SeriesView));
/**
 * @hidden
 */
var ChartAxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartAxisRangeChangedEventArgs, _super);
    function ChartAxisRangeChangedEventArgs(a, b, c, d, e, f) {
        var _this = _super.call(this) || this;
        _this._chart = null;
        _this._axis = null;
        _this._oldMinimumValue = 0;
        _this._minimumValue = 0;
        _this._oldMaximumValue = 0;
        _this._maximumValue = 0;
        _this.chart = a;
        _this.axis = b;
        _this.oldMinimumValue = c;
        _this.minimumValue = d;
        _this.oldMaximumValue = e;
        _this.maximumValue = f;
        return _this;
    }
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "chart", {
        get: function () {
            return this._chart;
        },
        set: function (a) {
            this._chart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "axis", {
        get: function () {
            return this._axis;
        },
        set: function (a) {
            this._axis = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
        get: function () {
            return this._oldMinimumValue;
        },
        set: function (a) {
            this._oldMinimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
        get: function () {
            return this._oldMaximumValue;
        },
        set: function (a) {
            this._oldMaximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartAxisRangeChangedEventArgs.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartAxisRangeChangedEventArgs.$t = markType(ChartAxisRangeChangedEventArgs, 'ChartAxisRangeChangedEventArgs', EventArgs.$);
    return ChartAxisRangeChangedEventArgs;
}(EventArgs));
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnnotationLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayer, _super);
    function AnnotationLayer() {
        var _this = _super.call(this) || this;
        _this.m3 = null;
        _this.l2 = null;
        _this.l1 = null;
        _this.l3 = null;
        _this.m1 = { $type: Point_$type, x: NaN, y: NaN };
        _this.l4 = false;
        _this.m3 = { $type: Point_$type, x: NaN, y: NaN };
        return _this;
    }
    AnnotationLayer.prototype.bf = function () {
        return new AnnotationLayerView(this);
    };
    AnnotationLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.l0 = a;
    };
    AnnotationLayer.prototype.l8 = function (a) {
        if (a == null) {
            return false;
        }
        if (a.cj) {
            return false;
        }
        if (a.c6) {
            return false;
        }
        if (a == this) {
            return false;
        }
        return a.dw(a.bi.br, a.bi.bs, a.bi);
    };
    AnnotationLayer.prototype.get_cm = function () {
        return this.l5;
    };
    AnnotationLayer.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    AnnotationLayer.prototype.get_cw = function () {
        return this.ma || this.mb;
    };
    AnnotationLayer.prototype.get_isUsableInLegend = function () {
        return this.mb;
    };
    AnnotationLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = c;
                var f = d;
                if (e != null) {
                    this.mu(e.series);
                    var g = e.series;
                    g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.mr));
                    if (typeCast(XamDataChart.$, e) !== null) {
                        var h = e;
                        this.mt(h.axes);
                        var i = h.axes;
                        i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.mh));
                    }
                }
                if (f != null) {
                    this.mp(f.series);
                    var j = f.series;
                    j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.mr));
                    if (typeCast(XamDataChart.$, f) !== null) {
                        var k = f;
                        this.mo(k.axes);
                        var l = k.axes;
                        l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.mh));
                    }
                }
                break;
            case AnnotationLayer.$$p[3]:
            case AnnotationLayer.$$p[2]:
                if (this.cw) {
                    if (this.fh == -1) {
                        this.fh = XamDataChart.od(this);
                    }
                }
                else {
                    this.fh = -1;
                    this.k3 = null;
                    this.k4 = null;
                }
                if (this.bs != null) {
                    this.bs.ii();
                }
                this.jd(true);
                break;
            case "TransitionProgress":
                this.l3.c(this.ez, this.l2, this.l1);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.mq(this.l1, this.bi);
                }
                else {
                    this.mq(this.l3, this.bi);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case AnnotationLayer.$$p[1]:
                if (this.bs != null) {
                    this.bs.ig();
                }
                break;
            case AnnotationLayer.$$p[0]:
                this.m3 = this.m2;
                this.ip(this.m2);
                break;
            case "ShouldRenderAsOverlay":
                if (this.bs != null) {
                    this.bi.ah(this.bs);
                    this.bi.ad(this.bs);
                }
                break;
        }
    };
    AnnotationLayer.prototype.mu = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.ms));
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.mt = function (a) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.mi));
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.mp = function (a) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (!(b == this)) {
                    b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.ms));
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.mo = function (a) {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.mi));
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.l6 = function (a) {
        if (a == null) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.mi = function (a, b) {
        if (this.l6(a)) {
            this.mk(a, b.animate);
        }
    };
    AnnotationLayer.prototype.l7 = function (a) {
        if (a == null) {
            return false;
        }
        if (a.cj) {
            return false;
        }
        return true;
    };
    AnnotationLayer.prototype.ms = function (a, b) {
        if (this.l7(a)) {
            this.ml(a, b.animate);
        }
    };
    AnnotationLayer.prototype.mk = function (a, b) {
    };
    AnnotationLayer.prototype.ml = function (a, b) {
    };
    AnnotationLayer.prototype.mr = function (a, b) {
        this.mm(b);
    };
    AnnotationLayer.prototype.mh = function (a, b) {
        this.mj(b);
    };
    AnnotationLayer.prototype.mz = function () {
        if (this.k3 != null) {
            return this.k3;
        }
        return this.k5;
    };
    AnnotationLayer.prototype.m0 = function () {
        if (this.k4 != null) {
            return this.k4;
        }
        return this.k8;
    };
    AnnotationLayer.prototype.mj = function (a) {
        var e_5, _a, e_6, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.mi));
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.mi));
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.mm = function (a) {
        var e_7, _a, e_8, _b;
        if (a.oldItems != null) {
            try {
                for (var _c = __values(fromEn(a.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.ms));
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        if (a.newItems != null) {
            try {
                for (var _e = __values(fromEn(a.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.ms));
                }
            }
            catch (e_8_1) {
                e_8 = { error: e_8_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_8)
                        throw e_8.error;
                }
            }
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.jt = function (a, b) {
        this.jd(false);
    };
    AnnotationLayer.prototype.js = function (a, b) {
        this.jd(true);
    };
    AnnotationLayer.prototype.je = function (a) {
        _super.prototype.je.call(this, a);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.da(a) && !this.de) {
            var b = this.l2;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.l2 = this.l3;
                this.l3 = b;
            }
            else {
                this.l2 = this.l1;
                this.l1 = b;
            }
            this.mn(this.l1, this.bi);
            this.jl();
        }
        else {
            if (!this.de) {
                this.mn(this.l1, this.bi);
            }
            this.mq(this.l1, this.bi);
        }
    };
    AnnotationLayer.prototype.get_cj = function () {
        return true;
    };
    AnnotationLayer.prototype.mn = function (a, b) {
    };
    AnnotationLayer.prototype.mq = function (a, b) {
        this.l0.by();
    };
    AnnotationLayer.prototype.mg = function (a) {
        var b = { $type: Point_$type, x: this.m1.x, y: this.m1.y };
        if (a.isVertical) {
            if (isNaN_(this.m1.y)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.m1.x)) {
                b.x = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        else {
            if (isNaN_(this.m1.x)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.m1.y)) {
                b.y = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        return new Tuple$2(Boolean_$type, Point_$type, true, b);
    };
    AnnotationLayer.prototype.ip = function (a) {
        _super.prototype.ip.call(this, a);
        if (isNaN_(this.m3.x) && isNaN_(this.m3.y)) {
            if (isNaN_(a.x) && isNaN_(a.y)) {
                this.l0.bx();
                return;
            }
            else {
                this.l0.bz();
                this.m1 = a;
            }
        }
        else {
            this.l0.bz();
            this.m1 = this.m3;
        }
        this.jd(true);
    };
    AnnotationLayer.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (!this.bi.q()) {
            return d = false;
        }
        return d;
    };
    AnnotationLayer.prototype.get_ds = function () {
        return this.l9;
    };
    Object.defineProperty(AnnotationLayer.prototype, "l9", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            var b = this.l4;
            this.l4 = a;
            this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.l4);
        },
        enumerable: true,
        configurable: true
    });
    AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
    AnnotationLayer.$$p = markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:m2:mv', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:l5:mw', [0, true], 'UseIndex:ma:mx', [0, false], 'UseLegend:mb:my', [0, false]]);
    return AnnotationLayer;
}(Series));
/**
 * @hidden
 */
var AnnotationLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayerView, _super);
    function AnnotationLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.bu = null;
        _this.bv = false;
        _this.bw = -1;
        _this.bu = a;
        return _this;
    }
    AnnotationLayerView.prototype.b0 = function () {
        if (this.bv) {
            this.bv = false;
            this.bw = -1;
            this.bu.m1 = { $type: Point_$type, x: NaN, y: NaN };
            this.bu.jd(true);
        }
    };
    AnnotationLayerView.prototype.bx = function () {
        this.bv = true;
        if (this.e.e4 != null) {
            this.e.e4.setTimeout(runOn(this, this.b0), 300);
        }
        else {
            this.bw = window.setTimeout(runOn(this, this.b0), 300);
        }
    };
    AnnotationLayerView.prototype.bz = function () {
        if (this.bv == true) {
            this.bv = false;
            if (this.bw != -1) {
                window.clearTimeout(this.bw);
                this.bw = -1;
            }
        }
    };
    AnnotationLayerView.prototype.by = function () {
        this.an();
    };
    AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
    return AnnotationLayerView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available collision modes of callout layers.
 */
var CalloutCollisionMode = /*@__PURE__*/ (function (CalloutCollisionMode) {
    /**
     * Automatically decide the collision strategy.
     */
    CalloutCollisionMode[CalloutCollisionMode["Auto"] = 0] = "Auto";
    /**
     * Use a simulated annealing based collision strategy. This is higher quality, but takes longer, and is performed time-sliced in the background until an acceptable quality is reached.
     */
    CalloutCollisionMode[CalloutCollisionMode["SimulatedAnnealing"] = 1] = "SimulatedAnnealing";
    /**
     * Use a greedy algorithm to avoid collisions. This is cheap and predictable, but of comparatively low quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["Greedy"] = 2] = "Greedy";
    /**
     * Use a greedy algorithm with localized center of mass hints to avoid collisions. This is relatively cheap to perform, compared to the simulated annealing approach, but is of comparatively lower quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["GreedyCenterOfMass"] = 3] = "GreedyCenterOfMass";
    return CalloutCollisionMode;
})({});
/**
 * @hidden
 */
var CalloutCollisionMode_$type = /*@__PURE__*/ markEnum('CalloutCollisionMode', 'Auto,0|SimulatedAnnealing,1|Greedy,2|GreedyCenterOfMass,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Frame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Frame, _super);
    function Frame() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Frame.a = function (a, b, c, d) {
        var e = c.count;
        var f = d.count;
        var g = Math.max(e, f);
        var h = 1 - b;
        if (a.count < g) {
            a.s(a.count, new Array(g - a.count));
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (var i = 0; i < Math.min(e, f); ++i) {
            a._inner[i] = { $type: Point_$type, x: c._inner[i].x * h + d._inner[i].x * b, y: c._inner[i].y * h + d._inner[i].y * b };
        }
        if (e < f) {
            var j = e > 0 ? c._inner[e - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (var k = e; k < f; ++k) {
                a._inner[k] = { $type: Point_$type, x: j.x * h + d._inner[k].x * b, y: j.y * h + d._inner[k].y * b };
            }
        }
        if (e > f) {
            var l = f > 0 ? d._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (var m = f; m < e; ++m) {
                a._inner[m] = { $type: Point_$type, x: c._inner[m].x * h + l.x * b, y: c._inner[m].y * h + l.y * b };
            }
        }
    };
    Frame.d = function (a, b, c, d, e) {
        var f = c.count;
        var g = d.count;
        var h = Math.max(f, g);
        var i = 1 - b;
        if (a.count < h) {
            a.s(a.count, new Array(h - a.count));
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        var j;
        var k;
        for (var l = 0; l < Math.min(f, g); ++l) {
            j = b * e._inner[l];
            j = j > 1 ? 1 : j;
            k = 1 - j;
            a._inner[l] = { $type: Point_$type, x: c._inner[l].x * k + d._inner[l].x * j, y: c._inner[l].y * k + d._inner[l].y * j };
        }
        if (f < g) {
            var m = f > 0 ? c._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (var n = f; n < g; ++n) {
                j = b * e._inner[n];
                j = j > 1 ? 1 : j;
                k = 1 - j;
                a._inner[n] = { $type: Point_$type, x: m.x * k + d._inner[n].x * j, y: m.y * k + d._inner[n].y * j };
            }
        }
        if (f > g) {
            var o = g > 0 ? d._inner[g - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (var p = g; p < f; ++p) {
                j = b * e._inner[p];
                j = j > 1 ? 1 : j;
                k = 1 - j;
                a._inner[p] = { $type: Point_$type, x: c._inner[p].x * k + o.x * j, y: c._inner[p].y * k + o.y * j };
            }
        }
    };
    Frame.b = function (a, b, c, d) {
        var e = c.count;
        var f = d.count;
        var g = Math.max(e, f);
        var h = 1 - b;
        if (a.count < g) {
            var i = new Array(g - a.count);
            for (var j = 0; j < g - a.count; j++) {
                i[j] = 0;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (var k = 0; k < Math.min(e, f); ++k) {
            a._inner[k] = c._inner[k] * h + d._inner[k] * b;
        }
        if (e < f) {
            var l = e > 0 ? c._inner[e - 1] : 0;
            for (var m = e; m < f; ++m) {
                a._inner[m] = l * h + d._inner[m] * b;
            }
        }
        if (e > f) {
            var n = f > 0 ? d._inner[f - 1] : 0;
            for (var o = f; o < e; ++o) {
                a._inner[o] = c._inner[o] * h + n * b;
            }
        }
    };
    Frame.e = function (a, b, c, d, e) {
        var f = c.count;
        var g = d.count;
        var h = Math.max(f, g);
        var i = 1 - b;
        if (a.count < h) {
            var j = new Array(h - a.count);
            for (var k = 0; k < h - a.count; k++) {
                j[k] = 0;
            }
            a.s(a.count, j);
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        var l;
        var m;
        for (var n = 0; n < Math.min(f, g); ++n) {
            l = b * e._inner[n];
            l = l > 1 ? 1 : l;
            m = 1 - l;
            a._inner[n] = c._inner[n] * m + d._inner[n] * l;
        }
        if (f < g) {
            var o = f > 0 ? c._inner[f - 1] : 0;
            for (var p = f; p < g; ++p) {
                l = b * e._inner[p];
                l = l > 1 ? 1 : l;
                m = 1 - l;
                a._inner[p] = o * m + d._inner[p] * l;
            }
        }
        if (f > g) {
            var q = g > 0 ? d._inner[g - 1] : 0;
            for (var r = g; r < f; ++r) {
                l = b * e._inner[r];
                l = l > 1 ? 1 : l;
                m = 1 - l;
                a._inner[r] = c._inner[r] * m + q * l;
            }
        }
    };
    Frame.$t = markType(Frame, 'Frame');
    return Frame;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FrameExtended = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FrameExtended, _super);
    function FrameExtended() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FrameExtended.b = function (a, b, c, d) {
        var e = BrushUtil.k(b, a, c, d);
        return e;
    };
    FrameExtended.a = function (a, b, c, d, e) {
        var f = c.count;
        var g = d.count;
        var h = Math.max(f, g);
        var i = ((function () {
            var $ret = new Brush();
            $ret.fill = "transparent";
            return $ret;
        })());
        var j = 1 - b;
        if (a.count < h) {
            var k = new Array(h - a.count);
            for (var l = 0; l < h - a.count; l++) {
                k[l] = new Brush();
            }
            a.s(a.count, k);
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        for (var m = 0; m < Math.min(f, g); ++m) {
            a._inner[m] = FrameExtended.b(b, c._inner[m], d._inner[m], e);
        }
        if (f < g) {
            var n = f > 0 ? c._inner[f - 1] : i;
            for (var o = f; o < g; ++o) {
                a._inner[o] = FrameExtended.b(b, n, d._inner[o], e);
            }
        }
        if (f > g) {
            var p = g > 0 ? d._inner[g - 1] : i;
            for (var q = g; q < f; ++q) {
                a._inner[q] = FrameExtended.b(b, c._inner[q], p, e);
            }
        }
    };
    FrameExtended.$t = markType(FrameExtended, 'FrameExtended');
    return FrameExtended;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutLayerFrame, _super);
    function CalloutLayerFrame() {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.m = null;
        _this.q = null;
        _this.o = null;
        _this.h = null;
        _this.g = null;
        _this.f = null;
        _this.n = null;
        _this.j = null;
        _this.l = null;
        _this.k = null;
        _this.i = null;
        _this.t = null;
        _this.u = null;
        _this.r = null;
        _this.s = null;
        _this.p = new List$1(Base.$, 0);
        _this.m = new List$1(Base.$, 0);
        _this.q = new List$1(Base.$, 0);
        _this.o = new List$1(Brush.$, 0);
        _this.h = new List$1(Brush.$, 0);
        _this.g = new List$1(Brush.$, 0);
        _this.f = new List$1(Brush.$, 0);
        _this.n = new List$1(Number_$type, 0);
        _this.j = new List$1(Number_$type, 0);
        _this.l = new List$1(Number_$type, 0);
        _this.k = new List$1(Number_$type, 0);
        _this.i = new List$1(Number_$type, 0);
        _this.t = new List$1(Number_$type, 0);
        _this.u = new List$1(Number_$type, 0);
        _this.r = new List$1(Number_$type, 0);
        _this.s = new List$1(Number_$type, 0);
        return _this;
    }
    CalloutLayerFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        FrameExtended.a(this.o, a, d.o, e.o, 0);
        FrameExtended.a(this.f, a, d.f, e.f, 0);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        FrameExtended.a(this.g, a, d.g, e.g, 0);
        Frame.b(this.j, a, d.j, e.j);
        Frame.b(this.l, a, d.l, e.l);
        Frame.b(this.k, a, d.k, e.k);
        Frame.b(this.i, a, d.i, e.i);
        Frame.b(this.n, a, d.n, e.n);
        Frame.b(this.t, a, d.t, e.t);
        Frame.b(this.u, a, d.u, e.u);
        Frame.b(this.r, a, d.r, e.r);
        Frame.b(this.s, a, d.s, e.s);
        CalloutLayerFrame.v(this.p, a, d.p, e.p);
        CalloutLayerFrame.v(this.m, a, d.m, e.m);
        CalloutLayerFrame.v(this.q, a, d.q, e.q);
    };
    CalloutLayerFrame.v = function (a, b, c, d) {
        var e = c.count;
        var f = d.count;
        var g = Math.max(e, f);
        var h = 1 - b;
        if (a.count < g) {
            var i = new Array(g - a.count);
            for (var j = 0; j < g - a.count; j++) {
                i[j] = null;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (var k = 0; k < Math.min(e, f); ++k) {
            if (b == 0) {
                a._inner[k] = c._inner[k];
            }
            else {
                a._inner[k] = d._inner[k];
            }
        }
        if (e < f) {
            var l = e > 0 ? c._inner[e - 1] : null;
            for (var m = e; m < f; ++m) {
                if (b == 0) {
                    a._inner[m] = l;
                }
                else {
                    a._inner[m] = d._inner[m];
                }
            }
        }
        if (e > f) {
            var n = f > 0 ? d._inner[f - 1] : null;
            for (var o = f; o < e; ++o) {
                if (b == 0) {
                    a._inner[o] = c._inner[o];
                }
                else {
                    a._inner[o] = n;
                }
            }
        }
    };
    CalloutLayerFrame.$t = markType(CalloutLayerFrame, 'CalloutLayerFrame', Frame.$);
    return CalloutLayerFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutAnnotation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutAnnotation, _super);
    function CalloutAnnotation() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propertyChanged = null;
        _this.k = null;
        _this._formatLabel = null;
        _this.m = false;
        return _this;
    }
    CalloutAnnotation.prototype.an = function (a, b, c) {
        this.am(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    CalloutAnnotation.prototype.am = function (a, b, c) {
        this.m = true;
    };
    Object.defineProperty(CalloutAnnotation.prototype, "formatLabel", {
        get: function () {
            return this._formatLabel;
        },
        set: function (a) {
            this._formatLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutAnnotation.prototype, "backgroundPadding", {
        get: function () {
            return new Thickness(1, this.backgroundPaddingLeft, this.backgroundPaddingTop, this.backgroundPaddingRight, this.backgroundPaddingBottom);
        },
        set: function (a) {
            this.backgroundPaddingLeft = a.left;
            this.backgroundPaddingTop = a.top;
            this.backgroundPaddingRight = a.right;
            this.backgroundPaddingBottom = a.bottom;
        },
        enumerable: true,
        configurable: true
    });
    CalloutAnnotation.$t = markType(CalloutAnnotation, 'CalloutAnnotation', DependencyObject.$, [INotifyPropertyChanged_$type]);
    CalloutAnnotation.$$p = markDep(DependencyProperty, PropertyMetadata, CalloutAnnotation, 'an', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [Brush.$, null], 'Content', [4, null], 'Key', [4, null], 'LeaderBrush', [Brush.$, null], 'Outline', [Brush.$, null], 'Series', [Series.$, null], 'StrokeThickness', [1, 0], 'TextColor', [Brush.$, null], 'Text', [2, null], 'XValue', [4, 0], 'YValue', [4, 0]]);
    return CalloutAnnotation;
}(DependencyObject));
/**
 * @hidden
 */
var CalloutAnnotationWrapper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutAnnotationWrapper, _super);
    function CalloutAnnotationWrapper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        return _this;
    }
    Object.defineProperty(CalloutAnnotationWrapper.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            this.a = a;
            this.a.k = this;
        },
        enumerable: true,
        configurable: true
    });
    CalloutAnnotationWrapper.prototype.equals = function (a) {
        var b = typeCast(CalloutAnnotationWrapper.$, a);
        if (b == null) {
            return _super.prototype.equals.call(this, a);
        }
        if (b.b == null && this.b == null) {
            return _super.prototype.equals.call(this, a);
        }
        if (b.b == null) {
            return false;
        }
        if (this.b.key != null || b.b.key != null) {
            return Base.equalsStatic(this.b.key, b.b.key);
        }
        return _super.prototype.equals.call(this, a);
    };
    CalloutAnnotationWrapper.prototype.getHashCode = function () {
        if (this.b == null || this.b.key == null) {
            return _super.prototype.getHashCode.call(this);
        }
        return Base.getHashCodeStatic(this.b.key);
    };
    CalloutAnnotationWrapper.$t = markType(CalloutAnnotationWrapper, 'CalloutAnnotationWrapper');
    return CalloutAnnotationWrapper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesPointOfInterest = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesPointOfInterest, _super);
    function SeriesPointOfInterest() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.c = null;
        _this.a = null;
        _this.d = null;
        return _this;
    }
    SeriesPointOfInterest.$t = markType(SeriesPointOfInterest, 'SeriesPointOfInterest');
    return SeriesPointOfInterest;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutSeriesSelectingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutSeriesSelectingEventArgs, _super);
    function CalloutSeriesSelectingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.d = null;
        _this._item = null;
        _this.a = null;
        _this.e = null;
        return _this;
    }
    Object.defineProperty(CalloutSeriesSelectingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutSeriesSelectingEventArgs.$t = markType(CalloutSeriesSelectingEventArgs, 'CalloutSeriesSelectingEventArgs');
    return CalloutSeriesSelectingEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutStyleUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutStyleUpdatingEventArgs, _super);
    function CalloutStyleUpdatingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._xValue = null;
        _this._yValue = null;
        _this._item = null;
        _this._series = null;
        _this._background = null;
        _this._textColor = null;
        _this._outline = null;
        _this._leaderBrush = null;
        _this._strokeThickness = 0;
        return _this;
    }
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "xValue", {
        get: function () {
            return this._xValue;
        },
        set: function (a) {
            this._xValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "yValue", {
        get: function () {
            return this._yValue;
        },
        set: function (a) {
            this._yValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "background", {
        get: function () {
            return this._background;
        },
        set: function (a) {
            this._background = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "textColor", {
        get: function () {
            return this._textColor;
        },
        set: function (a) {
            this._textColor = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "outline", {
        get: function () {
            return this._outline;
        },
        set: function (a) {
            this._outline = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "leaderBrush", {
        get: function () {
            return this._leaderBrush;
        },
        set: function (a) {
            this._leaderBrush = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutStyleUpdatingEventArgs.prototype, "strokeThickness", {
        get: function () {
            return this._strokeThickness;
        },
        set: function (a) {
            this._strokeThickness = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutStyleUpdatingEventArgs.$t = markType(CalloutStyleUpdatingEventArgs, 'CalloutStyleUpdatingEventArgs');
    return CalloutStyleUpdatingEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutContentUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutContentUpdatingEventArgs, _super);
    function CalloutContentUpdatingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.d = null;
        _this._item = null;
        _this.a = null;
        return _this;
    }
    Object.defineProperty(CalloutContentUpdatingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutContentUpdatingEventArgs.$t = markType(CalloutContentUpdatingEventArgs, 'CalloutContentUpdatingEventArgs');
    return CalloutContentUpdatingEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutLabelUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutLabelUpdatingEventArgs, _super);
    function CalloutLabelUpdatingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.d = null;
        _this._item = null;
        _this.b = null;
        return _this;
    }
    Object.defineProperty(CalloutLabelUpdatingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutLabelUpdatingEventArgs.$t = markType(CalloutLabelUpdatingEventArgs, 'CalloutLabelUpdatingEventArgs');
    return CalloutLabelUpdatingEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutKey = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutKey, _super);
    function CalloutKey(a, b) {
        var _this = _super.call(this) || this;
        _this._item = null;
        _this.a = null;
        _this.item = a;
        _this.a = b;
        return _this;
    }
    Object.defineProperty(CalloutKey.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutKey.prototype.getHashCode = function () {
        return Base.getHashCodeStatic(this.item) ^ Base.getHashCodeStatic(this.a);
    };
    CalloutKey.prototype.equals = function (a) {
        var b = typeCast(CalloutKey.$, a);
        if (b == null) {
            return _super.prototype.equals.call(this, a);
        }
        return this.item == b.item && this.a == b.a;
    };
    CalloutKey.$t = markType(CalloutKey, 'CalloutKey');
    return CalloutKey;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutViewHelper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutViewHelper, _super);
    function CalloutViewHelper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CalloutViewHelper.a = function (a, b, c, d, e, f, g, h) {
        var i = Math.sqrt((c - a) * (c - a) + (d - b) * (d - b));
        var j = (c - a) / i;
        var k = (d - b) / i;
        var l = a - e;
        var m = b - f;
        var n = g - e;
        var o = h - f;
        var p = -k;
        var q = j;
        var r = n * p + o * q;
        var s = n * m - o * l;
        var t = l * p + m * q;
        var u = s / r;
        var v = t / r;
        if (u >= 0 && v >= 0 && v <= 1) {
            return u;
        }
        return Number.POSITIVE_INFINITY;
    };
    CalloutViewHelper.b = function (a, b, c, d) {
        var e = a.x;
        var f = a.y;
        var g = 0;
        var h = 0;
        var i = 0;
        var j = 0;
        var k = 0;
        var l = 0;
        if (e < 0) {
            g = -e;
            k = g;
            e = 0;
        }
        if (f < 0) {
            h = -f;
            l = h;
            f = 0;
        }
        if (e > b) {
            i = e - b;
        }
        if (f > c) {
            j = f - c;
        }
        var m = new Thickness(1, g, h, i, j);
        var n = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k, l + c);
        var o = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k + b, l);
        var p = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l + c, k + b, l + c);
        var q = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k + b, l, k + b, l + c);
        var r = Math.min(n, Math.min(o, Math.min(p, q)));
        var s = 0;
        var t = 0;
        if (isInfinity(r)) {
            s = e;
            t = f;
        }
        else {
            var u = k + b / 2;
            var v = l + c / 2;
            var w = e;
            var x = f;
            var y = Math.sqrt((u - w) * (u - w) + (v - x) * (v - x));
            var z = (u - w) / y;
            var aa = (v - x) / y;
            s = w + z * r;
            t = x + aa * r;
        }
        d.ak = e;
        d.am = f;
        d.al = s;
        d.an = t;
        return m;
    };
    CalloutViewHelper.$t = markType(CalloutViewHelper, 'CalloutViewHelper');
    return CalloutViewHelper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutLayer, _super);
    function CalloutLayer() {
        var _this = _super.call(this) || this;
        _this.calloutStyleUpdating = null;
        _this.nf = null;
        _this.ng = null;
        _this.nh = null;
        _this.ne = null;
        _this.nd = null;
        _this.n3 = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        _this.n6 = new List$1(CalloutAnnotationWrapper.$, 0);
        _this.n7 = new List$1(CalloutAnnotationWrapper.$, 0);
        _this.nb = null;
        _this.n4 = new LinkedList$1(CalloutAnnotationWrapper.$);
        _this.n1 = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
        _this.nn = null;
        _this.qw = new Rect(0, 0, 0, 1, 1);
        _this.nt = false;
        _this.oh = 0;
        _this.qv = Rect.empty;
        _this.ns = false;
        _this.calloutContentUpdating = null;
        _this.calloutLabelUpdating = null;
        _this.calloutSeriesSelecting = null;
        _this.n5 = new List$1(SeriesPointOfInterest.$, 0);
        _this.nv = false;
        _this.nw = false;
        _this.n9 = 0;
        _this.nu = false;
        _this.nr = true;
        FastItemObjectColumn.m();
        _this.ma = true;
        var a = new CalloutLayerFrame();
        var b = new CalloutLayerFrame();
        var c = new CalloutLayerFrame();
        var d = _this.fi / 1000;
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = CalloutLayer.$;
        return _this;
    }
    CalloutLayer.prototype.po = function (a, b) {
        this.n7.clear();
        this.jd(false);
    };
    CalloutLayer.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        var e = this.n2();
        switch (a) {
            case 3:
                this.p0(b, e);
                break;
            case 1:
                for (var f = b; f < b + c; f++) {
                    var g = new CalloutAnnotation();
                    var h = new CalloutAnnotationWrapper();
                    h.b = g;
                    h.b.series = this.na;
                    this.n7.insert(f, h);
                    this.p0(f, e);
                }
                break;
            case 0:
                this.n7.v(b, c);
                break;
            case 2:
                for (var i = b; i < b + c; i++) {
                    this.p0(i, e);
                }
                break;
            case 4:
                this.n7.clear();
                for (var j = 0; j < this.bz.count; j++) {
                    var k = new CalloutAnnotation();
                    var l = new CalloutAnnotationWrapper();
                    l.b = k;
                    l.b.series = this.na;
                    this.n7.add(l);
                    this.p0(j, e);
                }
                break;
        }
        this.jd(true);
    };
    CalloutLayer.prototype.da = function (a) {
        return false;
    };
    CalloutLayer.prototype.n2 = function () {
        var a = new Dictionary$2(String_$type, Series.$, 0);
        if (this.bs != null) {
            for (var b = 0; b < this.bs.series.count; b++) {
                var c = this.bs.series._inner[b];
                if (c.name != null && !a.containsKey(c.name)) {
                    a.addItem(c.name, c);
                }
            }
        }
        return a;
    };
    CalloutLayer.prototype.p0 = function (a, b) {
        var _this = this;
        if (this.nm == null || this.nk == null) {
            return;
        }
        var c = a;
        if (this.nl != null) {
            c = this.nl.item(a);
        }
        var d = this.nm.item(a);
        var e = this.nk.item(a);
        var f = this.n7._inner[a];
        f.b.xValue = c;
        f.b.yValue = d;
        f.b.text = e != null ? e.toString() : "";
        if (this.nj != null) {
            f.b.key = this.nj.item(a);
        }
        if (this.ni != null) {
            f.b.content = this.ni.item(a);
        }
        else {
            f.b.content = this.bz.item(a);
        }
        if (this.calloutSeriesSelecting != null) {
            var g = ((function () {
                var $ret = new CalloutSeriesSelectingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = _this.bz.item(a);
                return $ret;
            })());
            this.calloutSeriesSelecting(this, g);
            if (g.a != null) {
                f.b.series = g.a;
            }
            else if (g.e != null) {
                if (b.containsKey(g.e)) {
                    f.b.series = b.item(g.e);
                }
            }
        }
        this.p1(f);
    };
    CalloutLayer.prototype.p1 = function (a) {
        var b = new Thickness(0, 3);
        if (isNaN_(this.qy.left) || isNaN_(this.qy.top) || isNaN_(this.qy.right) || isNaN_(this.qy.bottom)) {
            b = new Thickness(0, 3);
        }
        else {
            b = this.qy;
        }
        var c = this.qr != null ? this.qr : this.m7.ce(a.b.series);
        var d = this.qu != null ? this.qu : this.m7.ch();
        var e = this.qt != null ? this.qt : this.m7.cg();
        var f = this.qs != null ? this.qs : this.m7.cf(a.b.series);
        var g = isNaN_(this.of) ? 0 : this.of;
        if (this.nz && this.calloutStyleUpdating != null) {
            var h = new CalloutStyleUpdatingEventArgs();
            h.item = a.b.content;
            h.xValue = a.b.xValue;
            h.yValue = a.b.yValue;
            h.series = a.b.series;
            h.background = c;
            h.textColor = d;
            h.outline = e;
            h.leaderBrush = f;
            h.strokeThickness = g;
            this.calloutStyleUpdating(this, h);
            c = h.background;
            d = h.textColor;
            e = h.outline;
            f = h.leaderBrush;
            g = h.strokeThickness;
        }
        a.b.backgroundPadding = b;
        a.b.background = c;
        a.b.textColor = d;
        a.b.outline = e;
        a.b.leaderBrush = f;
        a.b.strokeThickness = g;
    };
    CalloutLayer.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == CalloutLayer.$$p[19]) {
            return this.ft(a, b, this.pc);
        }
        if (c == CalloutLayer.$$p[23]) {
            return this.ft(a, b, this.pj);
        }
        if (c == CalloutLayer.$$p[24]) {
            return this.ft(a, b, this.pm);
        }
        if (c == CalloutLayer.$$p[18]) {
            return this.ft(a, b, this.o9);
        }
        if (c == CalloutLayer.$$p[14]) {
            return this.ft(a, b, this.o3);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(CalloutLayer.prototype, "nk", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            if (this.nf != a) {
                var b = this.nf;
                this.nf = a;
                this.raisePropertyChanged("LabelColumn", b, this.nf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLayer.prototype, "nl", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            if (this.ng != a) {
                var b = this.ng;
                this.ng = a;
                this.raisePropertyChanged("XColumn", b, this.ng);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLayer.prototype, "nm", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            if (this.nh != a) {
                var b = this.nh;
                this.nh = a;
                this.raisePropertyChanged("YColumn", b, this.nh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLayer.prototype, "nj", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            if (this.ne != a) {
                var b = this.ne;
                this.ne = a;
                this.raisePropertyChanged("KeyColumn", b, this.ne);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLayer.prototype, "ni", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            if (this.nd != a) {
                var b = this.nd;
                this.nd = a;
                this.raisePropertyChanged("ContentColumn", b, this.nd);
            }
        },
        enumerable: true,
        configurable: true
    });
    CalloutLayer.prototype.pq = function (a, b) {
        if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
            var c = a.k;
            if (!this.n3.contains(c)) {
                this.n6.add(c);
                this.jd(false);
            }
        }
    };
    CalloutLayer.prototype.bf = function () {
        return new CalloutLayerView(this);
    };
    CalloutLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m7 = a;
    };
    Object.defineProperty(CalloutLayer.prototype, "qy", {
        get: function () {
            return new Thickness(1, this.ob, this.od, this.oc, this.oa);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutLayer.prototype, "nc", {
        get: function () {
            if (this.nb == null) {
                this.nb = FontUtil.toFontInfo(this.e4, this.pf);
            }
            return this.nb;
        },
        enumerable: true,
        configurable: true
    });
    CalloutLayer.prototype.ml = function (a, b) {
        if (this.na == null || this.na == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    CalloutLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        c.p.clear();
        c.q.clear();
        c.m.clear();
        c.f.clear();
        c.h.clear();
        c.g.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.u.clear();
        c.r.clear();
        c.s.clear();
        var d = this.n8();
        var e = new List$1(CalloutAnnotationWrapper.$, 0);
        if (this.nx) {
            if (this.l8(this.na)) {
                this.px(this.na, c, e);
            }
            else {
                try {
                    for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        if (this.l8(f)) {
                            this.px(f, c, e);
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        }
        this.pw(c, d, e);
    };
    CalloutLayer.prototype.jt = function (a, b) {
        _super.prototype.jt.call(this, a, b);
        var c = b.width - this.qw.width;
        var d = b.height - this.qw.height;
        var e = 0;
        if (Math.abs(c) > Math.abs(d)) {
            e = c;
            this.n9 = c * this.ly.width;
        }
        else {
            e = d;
            this.n9 = d * this.ly.height;
        }
        if (e > 0 && this.n9 > 5) {
            this.nw = true;
        }
        if (e < 0 && this.n9 > 5) {
            this.nv = true;
        }
    };
    CalloutLayer.prototype.js = function (a, b) {
        _super.prototype.js.call(this, a, b);
        if (!a.equals1(b)) {
            this.nu = true;
        }
    };
    Object.defineProperty(CalloutLayer.prototype, "qx", {
        get: function () {
            return this.qv;
        },
        set: function (a) {
            this.qv = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutLayer.prototype.pw = function (a, b, c) {
        var e_2, _a;
        if (this.bs != null) {
            this.qw = this.bs.mq;
        }
        if (this.ly.isEmpty) {
            return;
        }
        this.qx = new Rect(0, this.ly.left, this.ly.top, this.ly.width, this.ly.height);
        if (this.nn != null && this.o0 != null && this.o0 != this.nn.ak) {
            this.ps();
        }
        if (this.nn == null) {
            var d = this.no();
            if (d != null) {
                this.nn = d;
                var e = this.nn;
                e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.pp));
            }
            else {
                var f = this.lq(this.bi);
                var g = 0;
                if (this.na != null) {
                    if (this.na.isVertical) {
                        g = 2;
                    }
                }
                else {
                    var h = false;
                    if (this.bs != null && this.bs.series.count > 0) {
                        h = true;
                        try {
                            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var i = _c.value;
                                if (!i.cj) {
                                    if (!i.isVertical) {
                                        h = false;
                                    }
                                }
                            }
                        }
                        catch (e_2_1) {
                            e_2 = { error: e_2_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_2)
                                    throw e_2.error;
                            }
                        }
                    }
                    if (h) {
                        g = 2;
                    }
                }
                this.nn = new LabelCollisionManager(this.ly.right, this.ly.bottom, this.ly, this.m7.b4(), this.oe, this.np(), g, this.ol(), this.ok(), this.ny);
                if (this.o0 != null) {
                    this.nn.ak = this.o0;
                    this.nn.ai = this;
                }
                var j = this.nn;
                j.labelsMoved = delegateCombine(j.labelsMoved, runOn(this, this.pp));
            }
        }
        if (this.nv) {
            this.nv = false;
            if (this.nn.ag > 2) {
                this.nt = true;
            }
        }
        if (this.nw) {
            this.nw = false;
            if (this.n9 > 5) {
                this.nt = true;
            }
        }
        if (this.nu) {
            this.nu = false;
            this.nn.ax(this.ly.right, this.ly.bottom, this.ly);
            this.nt = true;
        }
        var k = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        var l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        var m = new List$1(CalloutAnnotationWrapper.$, 0);
        var n = new List$1(CalloutAnnotationWrapper.$, 0);
        var o = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (var p = 0; p < b.count; p++) {
            o.add_1(b._inner[p]);
        }
        for (var q = 0; q < c.count; q++) {
            o.add_1(c._inner[q]);
        }
        var r = this.n4.c;
        while (r != null) {
            var s = r.a;
            if (!o.contains(r.c)) {
                n.add(r.c);
                l.add_1(r.c);
                var t = r.c.b;
                t.propertyChanged = delegateRemove(t.propertyChanged, runOn(this, this.pq));
                this.n4.h(r);
                this.n1.removeItem(r.c);
                this.nn.aw(r.c.c);
            }
            r = s;
        }
        for (var u = 0; u < b.count; u++) {
            if (!this.n1.containsKey(b._inner[u])) {
                this.n4.f(b._inner[u]);
                var v = b._inner[u].b;
                v.propertyChanged = delegateCombine(v.propertyChanged, runOn(this, this.pq));
                this.n1.addItem(b._inner[u], this.n4.d);
                m.add(b._inner[u]);
                k.add_1(b._inner[u]);
                this.nt = true;
            }
        }
        for (var w = 0; w < c.count; w++) {
            if (!this.n1.containsKey(c._inner[w])) {
                this.n4.f(c._inner[w]);
                this.n1.addItem(c._inner[w], this.n4.d);
                var x = c._inner[w].b;
                x.propertyChanged = delegateCombine(x.propertyChanged, runOn(this, this.pq));
                m.add(c._inner[w]);
                k.add_1(c._inner[w]);
                this.nt = true;
            }
        }
        if (this.n6.count > 0) {
            this.nt = true;
            this.n6.clear();
            this.n3.clear();
        }
        r = this.n4.c;
        while (r != null) {
            var y = this.nq(r.c);
            if (y == null) {
                return;
            }
            if (!Base.equalsStatic(y, r.c.c.c)) {
                var z = false;
                if (r.c.c.c == null) {
                    z = true;
                }
                var aa = r.c.c;
                aa.o = y.b;
                aa.p = y.c;
                if (!isNaN_(aa.o) && !isNaN_(aa.p)) {
                    aa.n = y.e;
                    aa.m = y.d;
                    if (aa.b == null) {
                        this.nn.p(aa);
                    }
                    if (z) {
                        this.nn.al(aa);
                    }
                    else {
                        this.nn.at(aa);
                    }
                }
            }
            r = r.a;
        }
        var ab = this.nn.ah();
        var ac = this.nn.q();
        if (this.nt && (ab != 0 || ac)) {
            this.nt = false;
            this.oh = 0x7FFFFFFF;
            if (this.o0 != null) {
                var ad = true;
                for (var ae = 0; ae < this.bs.series.count; ae++) {
                    var af = this.bs.series._inner[ae];
                    if (af.cj && typeCast(CalloutLayer.$, af) !== null) {
                        var ag = af;
                        if (ag.o0 == this.o0) {
                            if (!ag.qx.equals1(this.nn.az)) {
                                ad = false;
                                break;
                            }
                        }
                    }
                }
                if (ad) {
                    this.nn.ay();
                }
                else {
                    this.nn.am();
                }
            }
            else {
                this.nn.ay();
            }
        }
        var ah = this.n4.c;
        while (ah != null) {
            var ai = ah.c;
            a.m.add1(ai);
            a.f.add(ai.b.background);
            a.h.add(ai.b.outline);
            a.g.add(ai.b.leaderBrush);
            a.j.add(ai.b.backgroundPadding.left);
            a.l.add(ai.b.backgroundPadding.top);
            a.k.add(ai.b.backgroundPadding.right);
            a.i.add(ai.b.backgroundPadding.bottom);
            a.n.add(ai.b.strokeThickness);
            a.o.add(ai.b.textColor);
            a.p.add1(ai.b.text);
            a.q.add1(ai.b.content);
            var aj = ai.c;
            a.t.add(ai.c.o - (ai.c.g - ai.c.l));
            a.u.add(ai.c.p - (ai.c.h - ai.c.k));
            a.r.add(ai.c.g - ai.c.l);
            a.s.add(ai.c.h - ai.c.k);
            ah = ah.a;
        }
    };
    CalloutLayer.prototype.ps = function () {
        if (this.nn != null) {
            var a = this.n4.c;
            while (a != null) {
                var b = a.c.c;
                if (b != null) {
                    this.nn.aw(b);
                }
                a = a.a;
            }
            var c = this.nn;
            c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.pp));
            this.nn = null;
        }
        this.pr();
    };
    CalloutLayer.prototype.no = function () {
        if (this.bs == null) {
            return null;
        }
        for (var a = 0; a < this.bs.series.count; a++) {
            var b = this.bs.series._inner[a];
            if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                var c = b;
                if (c != this) {
                    if (c.o0 != null && c.o0 == this.o0) {
                        if (c.nn != null) {
                            return c.nn;
                        }
                    }
                }
            }
        }
        return null;
    };
    CalloutLayer.prototype.ok = function () {
        return 20000;
    };
    CalloutLayer.prototype.ol = function () {
        return 300;
    };
    CalloutLayer.prototype.np = function () {
        switch (this.m4) {
            case 0: return 2;
            case 2: return 1;
            case 3: return 2;
            case 1: return 0;
        }
        return 2;
    };
    CalloutLayer.prototype.pp = function (a) {
        var b = this.nn.ah();
        if (b < this.oh) {
            this.oh = b;
            this.jd(false);
        }
    };
    CalloutLayer.prototype.nq = function (a) {
        var b = this.na;
        if (a.b.series != null) {
            b = a.b.series;
        }
        if (b == null) {
            for (var c = 0; c < this.bs.series.count; c++) {
                var d = this.bs.series._inner[c];
                if (!d.cj) {
                    b = d;
                    break;
                }
            }
        }
        if (b == null) {
            return null;
        }
        var e = b.ag();
        var f = b.eh();
        var g = null;
        var h = null;
        for (var i = 0; i < e.length; i++) {
            if (e[i].cf) {
                h = e[i];
            }
            else {
                g = e[i];
            }
        }
        if (g == null || h == null) {
            return null;
        }
        if (!g.ce() || !h.ce()) {
            return null;
        }
        var j = 0;
        var k = 0;
        if (g.b2 && g.categoryMode != 0) {
            if (b.cr) {
                j = b.getOffsetValue();
            }
            else if (b.cl) {
                j = b.getOffsetValue();
            }
        }
        if (h.b2 && h.categoryMode != 0) {
            if (b.cl) {
                k = b.getOffsetValue();
            }
        }
        var l = new ScalerParams(0, this.bs.mq, g.i1, g.b8, g.iw());
        l.b = f;
        var m = new ScalerParams(0, this.bs.mq, h.i1, h.b8, h.iw());
        m.b = f;
        var n = g.dw(this.og(a.b.xValue), l) + j;
        var o = h.dw(this.og(a.b.yValue), m) + k;
        var p = new QuadTreeBoundingBox();
        p.b = n;
        p.c = o;
        p.e = 3;
        p.d = 3;
        p.g = a.b;
        return p;
    };
    CalloutLayer.prototype.og = function (a) {
        if (typeCast(Date_$type, a) !== null) {
            return a.getTime();
        }
        if (a == null) {
            return 0;
        }
        return a;
    };
    CalloutLayer.prototype.n8 = function () {
        var a = new List$1(CalloutAnnotationWrapper.$, 0);
        for (var b = 0; b < this.n7.count; b++) {
            if (stringIsNullOrEmpty(this.n7._inner[b].b.text)) {
                continue;
            }
            if (this.n7._inner[b].c == null) {
                var c = new LabelCollisionInfo();
                this.n7._inner[b].c = c;
                var d = this.m7.cj(this.om(this.n7._inner[b]), this.n7._inner[b].b.backgroundPadding);
                c.k = d.height / 2;
                c.l = d.width / 2;
            }
            var e = this.nq(this.n7._inner[b]);
            if (e == null || e.b < this.ly.left || e.b > this.ly.right || e.c < this.ly.top || e.c > this.ly.bottom) {
                continue;
            }
            a.add(this.n7._inner[b]);
        }
        return a;
    };
    CalloutLayer.prototype.om = function (a) {
        return a.b.text;
    };
    CalloutLayer.prototype.l8 = function (a) {
        if (!_super.prototype.l8.call(this, a)) {
            return false;
        }
        return true;
    };
    CalloutLayer.prototype.io = function () {
        _super.prototype.io.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.nr) {
            this.nr = false;
            this.pu();
        }
        if (this.ca()) {
            this.pz(this.l3, false);
        }
        else {
            this.pz(this.l1, false);
        }
    };
    CalloutLayer.prototype.pv = function () {
        if (!this.ns) {
            this.ns = true;
            this.jd(true);
        }
    };
    CalloutLayer.prototype.px = function (a, b, c) {
        if (a.ch(this.n5, this.n0, this.oi)) {
            var d = this.n5;
            var _loop_1 = function (e) {
                var f = d._inner[e];
                var g = f.a.item != null ? f.a.item : f.a;
                var h = a;
                var i = new CalloutKey(g, h);
                var j = new CalloutAnnotationWrapper();
                var k = new CalloutAnnotation();
                j.b = k;
                k.key = i;
                var l = false;
                var m = false;
                if (this_1.ns) {
                    this_1.ns = false;
                    m = true;
                }
                if (this_1.n1.containsKey(j)) {
                    j = this_1.n1.item(j).c;
                    k = j.b;
                }
                else {
                    if (!m) {
                        l = true;
                    }
                }
                var n = k.xValue;
                var o = k.yValue;
                if (this_1.og(n) != this_1.og(f.b)) {
                    k.xValue = f.b;
                }
                if (this_1.og(o) != this_1.og(f.c)) {
                    k.yValue = f.c;
                }
                k.series = a;
                if (l && this_1.calloutLabelUpdating != null) {
                    var p = ((function () {
                        var $ret = new CalloutLabelUpdatingEventArgs();
                        $ret.c = k.xValue;
                        $ret.d = k.yValue;
                        $ret.item = g;
                        return $ret;
                    })());
                    this_1.calloutLabelUpdating(this_1, p);
                    if (p.b != null && !Base.equalsStatic(p.b, j.b.text)) {
                        var q = p.b;
                        j.b.text = q != null ? q.toString() : "";
                    }
                }
                else {
                    if (f.d != null) {
                        k.text = f.d;
                    }
                }
                if (k.text == null) {
                    return "continue";
                }
                if (l) {
                    if (this_1.calloutContentUpdating != null) {
                        var r = ((function () {
                            var $ret = new CalloutContentUpdatingEventArgs();
                            $ret.c = k.xValue;
                            $ret.d = k.yValue;
                            $ret.item = g;
                            $ret.a = g;
                            return $ret;
                        })());
                        this_1.calloutContentUpdating(this_1, r);
                        if (r.a != null && r.a != j.b.content) {
                            j.b.content = r.a;
                        }
                    }
                    else {
                        if (g != null && g != j.b.content) {
                            j.b.content = g;
                        }
                    }
                }
                if (l) {
                    this_1.p1(j);
                }
                if (j.c == null) {
                    var s = new LabelCollisionInfo();
                    j.c = s;
                    var t = this_1.m7.cj(this_1.om(j), j.b.backgroundPadding);
                    s.k = t.height / 2;
                    s.l = t.width / 2;
                }
                var u = this_1.nq(j);
                if (u == null || u.b < this_1.ly.left || u.b > this_1.ly.right || u.c < this_1.ly.top || u.c > this_1.ly.bottom) {
                    return "continue";
                }
                c.add(j);
            };
            var this_1 = this;
            for (var e = 0; e < this.n5.count; e++) {
                _loop_1(e);
            }
        }
    };
    CalloutLayer.prototype.bd = function () {
        return 1;
    };
    CalloutLayer.prototype.ar = function (a, b) {
        var c = this.nn.d(a, b);
        if (c == null) {
            return null;
        }
        return c.u;
    };
    CalloutLayer.prototype.dh = function (a, b) {
        if (this.nn == null) {
            return false;
        }
        return this.nn.d(a, b) != null;
    };
    CalloutLayer.prototype.pz = function (a, b) {
        var e_3, _a;
        var c = 0;
        var d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (c = 0; c < a.p.count; c++) {
            var e = a.m._inner[c];
            if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                continue;
            }
            var f = this.m7.b6.item(e);
            d.add_1(e);
            if (f.f != a.p._inner[c]) {
                f.f = a.p._inner[c];
                var g = f.s();
            }
            f.c = a.n._inner[c];
            f.k = a.f._inner[c];
            f.n = a.o._inner[c];
            f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
            f.l = a.g._inner[c];
            f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
            this.m7.cc(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
            this.m7.cd(f, e, a.q._inner[c]);
            f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
        }
        var h = new List$1(CalloutAnnotationWrapper.$, 0);
        try {
            for (var _b = __values(fromEnum(this.m7.b6.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                if (!d.contains(i)) {
                    h.add(i);
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        for (var j = 0; j < h.count; j++) {
            this.m7.b6.g(h._inner[j]);
        }
    };
    CalloutLayer.prototype.mq = function (a, b) {
        _super.prototype.mq.call(this, a, b);
        if (this.ca()) {
            this.pz(this.l3, true);
        }
        else {
            this.pz(this.l1, false);
        }
    };
    CalloutLayer.prototype.c8 = function () {
        return true;
    };
    CalloutLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case CalloutLayer.$$p[21]:
                this.nb = null;
                this.jd(true);
                break;
            case CalloutLayer.$$p[20]:
                this.jd(true);
                break;
            case CalloutLayer.$$p[13]:
                this.jd(true);
                break;
            case "SeriesViewer":
                if (c != null) {
                    var e = c;
                    e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.py));
                }
                if (d != null) {
                    var f = d;
                    f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.py));
                }
                if (d == null) {
                    this.ps();
                }
                break;
            case CalloutLayer.$$p[15]:
            case CalloutLayer.$$p[16]:
            case CalloutLayer.$$p[1]:
            case CalloutLayer.$$p[5]:
            case CalloutLayer.$$p[4]:
            case CalloutLayer.$$p[7]:
            case CalloutLayer.$$p[9]:
            case CalloutLayer.$$p[8]:
            case CalloutLayer.$$p[6]:
            case CalloutLayer.$$p[11]:
            case CalloutLayer.$$p[12]:
                this.pt();
                break;
            case CalloutLayer.$$p[19]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nk);
                    this.nk = this.by(this.pc);
                }
                break;
            case "LabelColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[14]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ni);
                    this.ni = this.by(this.o3);
                }
                break;
            case "ContentColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[23]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nl);
                    this.nl = stringIsNullOrEmpty(this.pj) == false ? this.by(this.pj) : null;
                }
                break;
            case "XColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[24]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nm);
                    this.nm = this.by(this.pm);
                }
                break;
            case "YColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[18]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nj);
                    this.nj = this.by(this.o9);
                }
                break;
            case "KeyColumn":
                this.pt();
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nk);
                    c.deregisterColumn(this.ni);
                    c.deregisterColumn(this.nl);
                    c.deregisterColumn(this.nm);
                    c.deregisterColumn(this.nj);
                    this.nk = null;
                    this.ni = null;
                    this.nl = null;
                    this.nm = null;
                    this.nj = null;
                    this.n7.clear();
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nk = this.by(this.pc);
                    this.ni = this.by(this.o3);
                    if (stringIsNullOrEmpty(this.pj) == false) {
                        this.nl = this.by(this.pj);
                    }
                    this.nm = this.by(this.pm);
                    this.nj = this.by(this.o9);
                }
                this.pt();
                break;
        }
    };
    CalloutLayer.prototype.py = function (a) {
        if (a.cj) {
            return;
        }
        if ((a == this.na || this.na == null) && this.nx) {
            this.jd(false);
        }
    };
    CalloutLayer.prototype.pt = function () {
        if (this.nr == false) {
            this.nr = true;
            this.jd(false);
        }
    };
    CalloutLayer.prototype.pr = function () {
        this.m7.b6.clear();
        this.n4.g();
        this.n1.clear();
    };
    CalloutLayer.prototype.pu = function () {
        if (this.nm == null || this.nk == null) {
            var a = this.n4.c;
            while (a != null) {
                this.p1(a.c);
                a = a.a;
            }
            return;
        }
        var b = this.n2();
        for (var c = 0; c < this.nm.count; c++) {
            var d = void 0;
            if (this.n7.count <= c) {
                var e = new CalloutAnnotation();
                d = new CalloutAnnotationWrapper();
                d.b = e;
                d.b.series = this.na;
                this.n7.add(d);
            }
            else {
                d = this.n7._inner[c];
            }
            this.p0(c, b);
        }
    };
    CalloutLayer.$t = markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
    CalloutLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:oi:p2', [1, 5], 'CalloutBackground:qr:p3', [Brush.$, null], 'CalloutCollisionMode:m4:p4', [CalloutCollisionMode_$type, enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:oj:p5', [1, -1], 'CalloutLeaderBrush:qs:p6', [Brush.$, null], 'CalloutOutline:qt:p7', [Brush.$, null], 'CalloutPaddingBottom:oa:p8', [1, NaN], 'CalloutPaddingLeft:ob:p9', [1, NaN], 'CalloutPaddingRight:oc:qa', [1, NaN], 'CalloutPaddingTop:od:qb', [1, NaN], 'CalloutPositionPadding:oe:qc', [1, 10], 'CalloutStrokeThickness:of:qd', [1, NaN], 'CalloutTextColor:qu:qe', [Brush.$, null], 'CollisionChannel:o0:qf', [2, null], 'ContentMemberPath:o3:qg', [2, null], 'IsAutoCalloutBehaviorEnabled:nx:qh', [0, false], 'IsCalloutOffsettingEnabled:ny:qi', [0, true], 'IsCustomCalloutStyleEnabled:nz:qj', [0, false], 'KeyMemberPath:o9:qk', [2, null], 'LabelMemberPath:pc:ql', [2, null], 'TargetSeries:na:qm', [Series.$, null], 'TextStyle:pf:qn', [2, null], 'UseValueForAutoCalloutLabels:n0:qo', [0, true], 'XMemberPath:pj:qp', [2, null], 'YMemberPath:pm:qq', [2, null]]);
    return CalloutLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var CalloutLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutLayerView, _super);
    function CalloutLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b7 = null;
        _this.b6 = null;
        _this.b8 = NaN;
        _this.b2 = null;
        _this.b1 = a;
        _this.b7 = new List$1(CalloutView.$, 0);
        return _this;
    }
    CalloutLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b6 = ((function () {
            var $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
            $ret.create = runOn(_this, _this.b3);
            $ret.activate = runOn(_this, _this.b9);
            $ret.disactivate = runOn(_this, _this.cb);
            $ret.destroy = runOn(_this, _this.ca);
            return $ret;
        })());
    };
    CalloutLayerView.prototype.b3 = function () {
        var a = new CalloutView(this);
        this.b7.add(a);
        return a;
    };
    CalloutLayerView.prototype.b9 = function (a) {
        a.w = 0;
    };
    CalloutLayerView.prototype.cb = function (a) {
        a.w = 1;
    };
    CalloutLayerView.prototype.ca = function (a) {
        this.b7.remove(a);
    };
    CalloutLayerView.prototype.ci = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    CalloutLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        a.ac(this.b5());
        if (a.d && !b) {
            for (var c = 0; c < this.b7.count; c++) {
                var d = this.b7._inner[c];
                if (d.w == 0) {
                    d.h(a);
                }
            }
        }
    };
    CalloutLayerView.prototype.b5 = function () {
        if (this.b1.nc != null) {
            return this.b1.nc;
        }
        return this.e.bs.getFontInfo();
    };
    CalloutLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b7.count; b++) {
            var c = this.b7._inner[b];
            if (c.w != 0) {
                continue;
            }
            c.g(this.b1, this.b5(), a);
        }
    };
    CalloutLayerView.prototype.ck = function (a) {
        if (isNaN_(this.b8)) {
            this.b8 = this.e.bs.bn.a7;
        }
        return new Size(1, this.h.f(a.ak), this.b8);
    };
    CalloutLayerView.prototype.cj = function (a, b) {
        if (this.b2 == null) {
            this.b2 = new CalloutView(this);
        }
        this.b2.f = a;
        this.b2.v = b;
        var c = this.b2.s();
        this.b2.f = null;
        return c;
    };
    CalloutLayerView.prototype.b4 = function () {
        return new DOMExecutionContext(this.e.bs.bn.i.ae);
    };
    CalloutLayerView.prototype.cc = function (a, b, c) {
        a.d = b;
        a.e = c;
    };
    CalloutLayerView.prototype.cd = function (a, b, c) {
        a.i(this.e, b, c);
    };
    CalloutLayerView.prototype.ce = function (a) {
        if (a != null) {
            return this.ci(a.k3);
        }
        return this.e.k3;
    };
    CalloutLayerView.prototype.ch = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    };
    CalloutLayerView.prototype.cg = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    };
    CalloutLayerView.prototype.cf = function (a) {
        if (a != null) {
            return this.ci(a.k3);
        }
        return this.e.k3;
    };
    CalloutLayerView.$t = markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
    return CalloutLayerView;
}(AnnotationLayerView));
/**
 * @hidden
 */
var CalloutView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutView, _super);
    function CalloutView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.w = 0;
        _this.j = null;
        _this.r = null;
        _this.o = { $type: Point_$type, x: 0, y: 0 };
        _this.q = null;
        _this.u = new Thickness(0, 0);
        _this.t = null;
        _this.d = 0;
        _this.e = 0;
        _this.b = null;
        _this.q = new Line();
        _this.q.ab = false;
        _this.q._stroke = ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 0, 0, 0);
            return $ret;
        })());
        _this.q.ac = 2;
        _this.j = new TextBlock();
        _this.r = new Rectangle();
        _this.r.ac = 0;
        _this.a = a;
        _this.w = 0;
        return _this;
    }
    CalloutView.prototype.h = function (a) {
        a.z();
        a.af(this.d, this.e);
        var b = new TranslateTransform();
        b.j = this.t.left;
        b.k = this.t.top;
        this.r.j = b;
        a.r(this.q);
        a.z();
        this.r.width = this.j.m + this.u.left + this.u.right;
        this.r.height = this.j.l + this.u.top + this.u.bottom;
        a.j(this.r.j);
        a.v(this.r);
        this.j.o = this.u.top;
        this.j.n = this.u.left;
        a.w(this.j);
        a.y();
        a.y();
    };
    Object.defineProperty(CalloutView.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            if (this.o.x != a.x || this.o.y != a.y) {
                var b = this.s();
                var c = b.height;
                var d = b.width;
                this.o = a;
                var e = CalloutViewHelper.b(this.p, d, c, this.q);
                this.t = e;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "n", {
        get: function () {
            return this.j.am;
        },
        set: function (a) {
            this.j.am = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "m", {
        get: function () {
            return this.r._stroke;
        },
        set: function (a) {
            this.r._stroke = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "l", {
        get: function () {
            return this.q._stroke;
        },
        set: function (a) {
            this.q._stroke = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "k", {
        get: function () {
            return this.r._fill;
        },
        set: function (a) {
            this.r._fill = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "c", {
        get: function () {
            return this.r.ac;
        },
        set: function (a) {
            this.r.ac = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "v", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            this.u = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutView.prototype, "f", {
        get: function () {
            return this.j.ak;
        },
        set: function (a) {
            if (a == null) {
                this.j.ak = "";
            }
            else {
                this.j.ak = a.toString();
            }
            var b = this.s();
            var c = b.height;
            var d = b.width;
            var e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        },
        enumerable: true,
        configurable: true
    });
    CalloutView.prototype.s = function () {
        var a = this.a.ck(this.j);
        this.j.m = a.width;
        this.j.l = a.height;
        return new Size(1, a.width + this.u.left + this.u.right, a.height + this.u.top + this.u.bottom);
    };
    CalloutView.prototype.i = function (a, b, c) {
        if (this.b == null) {
            this.b = new DataContext();
        }
        this.b.series = a;
        this.b.item = c;
        if (b.c != null) {
            b.c.u = this.b;
        }
    };
    CalloutView.prototype.g = function (a, b, c) {
        a.a2.exportCalloutData(this.d, this.e, this.t.left, this.t.top, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
    };
    CalloutView.$t = markType(CalloutView, 'CalloutView');
    return CalloutView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnnotationLayerProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationLayerProxy, _super);
    function AnnotationLayerProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnnotationLayerProxy.prototype.matchesType = function (a) {
        if (!a.cj) {
            return false;
        }
        return true;
    };
    AnnotationLayerProxy.prototype.setContentMemberPath = function (a, b) {
        a.o3 = b;
    };
    AnnotationLayerProxy.prototype.setHorizontalLineVisibility = function (a, b) {
        a.pk = b;
    };
    AnnotationLayerProxy.prototype.setIsAxisAnnotationEnabled = function (a, b) {
        a.na = b;
    };
    AnnotationLayerProxy.prototype.setLabelMemberPath = function (a, b) {
        a.pc = b;
    };
    AnnotationLayerProxy.prototype.setUseInterpolation = function (a, b) {
        a.nc = b;
    };
    AnnotationLayerProxy.prototype.setVerticalLineVisibility = function (a, b) {
        a.pl = b;
    };
    AnnotationLayerProxy.prototype.setXMemberPath = function (a, b) {
        a.pj = b;
    };
    AnnotationLayerProxy.prototype.setYMemberPath = function (a, b) {
        a.pm = b;
    };
    AnnotationLayerProxy.prototype.setTargetSeries = function (a, b) {
        a.na = b;
    };
    AnnotationLayerProxy.prototype.setCollisionChannel = function (a, b) {
        a.o0 = b;
    };
    AnnotationLayerProxy.prototype.isCalloutLayer = function (a) {
        if (typeCast(CalloutLayer.$, a) !== null) {
            return true;
        }
        return false;
    };
    AnnotationLayerProxy.prototype.addCalloutStyleUpdating = function (a, b) {
        var c = a;
        c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
    };
    AnnotationLayerProxy.prototype.removeCalloutStyleUpdating = function (a, b) {
        var c = a;
        c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
    };
    AnnotationLayerProxy.prototype.setCalloutStyleUpdatingEventEnabled = function (a, b) {
        a.nz = b;
    };
    AnnotationLayerProxy.$t = markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);
    return AnnotationLayerProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAnnotationLayerProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAnnotationLayerProxyModule() {
    }
    IgrAnnotationLayerProxyModule.register = function () {
        TypeRegistrar.register('AnnotationLayerProxy', AnnotationLayerProxy.$type);
    };
    return IgrAnnotationLayerProxyModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
var CategoryTooltipLayerPosition = /*@__PURE__*/ (function (CategoryTooltipLayerPosition) {
    /**
     * A position is selected automatically
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["Auto"] = 0] = "Auto";
    /**
     * Displays at the outside start of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideStart"] = 1] = "OutsideStart";
    /**
     * Displays at the inside start of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideStart"] = 2] = "InsideStart";
    /**
     * Displays at the inside end of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideEnd"] = 3] = "InsideEnd";
    /**
     * Displays at the outside end of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideEnd"] = 4] = "OutsideEnd";
    return CategoryTooltipLayerPosition;
})({});
/**
 * @hidden
 */
var CategoryTooltipLayerPosition_$type = /*@__PURE__*/ markEnum('CategoryTooltipLayerPosition', 'Auto,0|OutsideStart,1|InsideStart,2|InsideEnd,3|OutsideEnd,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryToolTipLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryToolTipLayerFrame, _super);
    function CategoryToolTipLayerFrame() {
        var _this = _super.call(this) || this;
        _this.f = 0;
        _this.k = 0;
        _this.h = 0;
        _this.g = 0;
        _this.j = 0;
        _this.i = 0;
        _this.k = NaN;
        _this.l = NaN;
        _this.g = NaN;
        _this.h = NaN;
        _this.j = NaN;
        _this.i = NaN;
        return _this;
    }
    Object.defineProperty(CategoryToolTipLayerFrame.prototype, "l", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryToolTipLayerFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        if (isNaN_(d.k)) {
            this.k = e.k;
        }
        else {
            this.k = d.k + (e.k - d.k) * a;
        }
        if (isNaN_(d.l)) {
            this.l = e.l;
        }
        else {
            this.l = d.l + (e.l - d.l) * a;
        }
        if (isNaN_(d.g)) {
            this.g = e.g;
        }
        else {
            this.g = d.g + (e.g - d.g) * a;
        }
        if (isNaN_(d.h)) {
            this.h = e.h;
        }
        else {
            this.h = d.h + (e.h - d.h) * a;
        }
        if (isNaN_(d.j)) {
            this.j = e.j;
        }
        else {
            this.j = d.j + (e.j - d.j) * a;
        }
        if (isNaN_(d.i)) {
            this.i = e.k;
        }
        else {
            this.i = d.i + (e.i - d.i) * a;
        }
    };
    CategoryToolTipLayerFrame.$t = markType(CategoryToolTipLayerFrame, 'CategoryToolTipLayerFrame', Frame.$);
    return CategoryToolTipLayerFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTooltipSeriesInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTooltipSeriesInfo, _super);
    function CategoryTooltipSeriesInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.a = null;
        _this.b = null;
        return _this;
    }
    CategoryTooltipSeriesInfo.$t = markType(CategoryTooltipSeriesInfo, 'CategoryTooltipSeriesInfo');
    return CategoryTooltipSeriesInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions to anchor the pointer to the PointerTooltip.
 */
var PointerTooltipPointerLocation = /*@__PURE__*/ (function (PointerTooltipPointerLocation) {
    /**
     * The anchor is decided automatically.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["Auto"] = 0] = "Auto";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopLeft"] = 1] = "TopLeft";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopMiddle"] = 2] = "TopMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopRight"] = 3] = "TopRight";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightTop"] = 4] = "RightTop";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightMiddle"] = 5] = "RightMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightBottom"] = 6] = "RightBottom";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomRight"] = 7] = "BottomRight";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomMiddle"] = 8] = "BottomMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomLeft"] = 9] = "BottomLeft";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftBottom"] = 10] = "LeftBottom";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftMiddle"] = 11] = "LeftMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftTop"] = 12] = "LeftTop";
    return PointerTooltipPointerLocation;
})({});
/**
 * @hidden
 */
var PointerTooltipPointerLocation_$type = /*@__PURE__*/ markEnum('PointerTooltipPointerLocation', 'Auto,0|TopLeft,1|TopMiddle,2|TopRight,3|RightTop,4|RightMiddle,5|RightBottom,6|BottomRight,7|BottomMiddle,8|BottomLeft,9|LeftBottom,10|LeftMiddle,11|LeftTop,12');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PointerTooltip = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointerTooltip, _super);
    function PointerTooltip() {
        var _this = _super.call(this) || this;
        _this.aq = null;
        _this.ai = null;
        _this.am = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.bw = null;
        _this.cq = null;
        _this.cr = null;
        _this.au = false;
        _this.cf = { $type: Point_$type, x: NaN, y: NaN };
        _this.ak = 0;
        _this.aw = 0;
        _this.av = 0;
        _this.ao = null;
        _this.as = false;
        _this.ap = null;
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        _this.ab = PointerTooltip.$;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.br(a, b.propertyName, b.oldValue, b.newValue); });
        _this.am = new PointerTooltipView(_this);
        return _this;
    }
    Object.defineProperty(PointerTooltip.prototype, "ar", {
        get: function () {
            if (this.aq == null) {
                this.aq = new SRProvider(this.am.j);
            }
            return this.aq;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltip.prototype, "aj", {
        get: function () {
            var _this = this;
            if (this.ai == null) {
                this.ai = DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, function () { return _this.ar.q; });
            }
            return this.ai;
        },
        enumerable: true,
        configurable: true
    });
    PointerTooltip.prototype.bt = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    PointerTooltip.prototype.br = function (a, b, c, d) {
        switch (b) {
            case PointerTooltip.$$p[15]:
                this.bq();
                break;
            case PointerTooltip.$$p[16]:
                this.bq();
                break;
        }
    };
    PointerTooltip.prototype.bn = function () {
        if (this.am.d(this.content)) {
            this.bq();
        }
    };
    PointerTooltip.prototype.bq = function () {
        this.au = true;
    };
    PointerTooltip.prototype.at = function (a, b) {
        if (Math.abs(a - b) < 1E-05) {
            return true;
        }
        return false;
    };
    PointerTooltip.prototype.cs = function (a) {
        this.au = false;
        var b = 0;
        var c = 0;
        var d = this.am.x(a);
        b = d.width;
        c = d.height;
        if (this.ak == this.al && this.at(this.cf.x, this.cn.x) && this.at(this.cf.y, this.cn.y)) {
            this.a0 = b;
            this.az = c;
            if (this.ct == 0) {
                b += this.aw;
                c += this.av;
                this.ay = this.a0 + this.aw;
                this.ax = this.az + this.av;
            }
            return new Size(1, b, c);
        }
        var e = { $type: Point_$type, x: 0, y: 0 };
        var f = { $type: Point_$type, x: b * 0.5, y: 0 };
        var g = { $type: Point_$type, x: b, y: 0 };
        var h = { $type: Point_$type, x: b, y: c };
        var i = { $type: Point_$type, x: b * 0.5, y: c };
        var j = { $type: Point_$type, x: 0, y: c };
        var k = { $type: Point_$type, x: 0, y: c * 0.5 };
        var l = { $type: Point_$type, x: b, y: c * 0.5 };
        var m = b;
        var n = c;
        var o = b;
        var p = c;
        var q = { $type: Point_$type, x: 0, y: 0 };
        var r = { $type: Point_$type, x: 0, y: 0 };
        var s = { $type: Point_$type, x: 0, y: 0 };
        var t = { $type: Point_$type, x: 0, y: 0 };
        var u = this.a1;
        var v = this.a2;
        var w = this.al;
        var x = this.cn;
        var y = 0;
        var z = 0;
        var aa = Math.pow(e.x - x.x, 2) + Math.pow(e.y - x.y, 2);
        var ab = Math.pow(f.x - x.x, 2) + Math.pow(f.y - x.y, 2);
        var ac = Math.pow(g.x - x.x, 2) + Math.pow(g.y - x.y, 2);
        var ad = Math.pow(l.x - x.x, 2) + Math.pow(l.y - x.y, 2);
        var ae = Math.pow(h.x - x.x, 2) + Math.pow(h.y - x.y, 2);
        var af = Math.pow(i.x - x.x, 2) + Math.pow(i.y - x.y, 2);
        var ag = Math.pow(j.x - x.x, 2) + Math.pow(j.y - x.y, 2);
        var ah = Math.pow(k.x - x.x, 2) + Math.pow(k.y - x.y, 2);
        var ai = 1.7976931348623157E+308;
        ai = Math.min(ai, aa);
        ai = Math.min(ai, ab);
        ai = Math.min(ai, ac);
        ai = Math.min(ai, ad);
        ai = Math.min(ai, ae);
        ai = Math.min(ai, af);
        ai = Math.min(ai, ag);
        ai = Math.min(ai, ah);
        if (w == 0) {
            if (ai == aa) {
                w = 12;
                if (x.x >= e.x) {
                    w = 1;
                }
            }
            if (ai == ah) {
                w = 11;
            }
            if (ai == ag) {
                w = 10;
                if (x.x >= j.x) {
                    w = 9;
                }
            }
            if (ai == ac) {
                w = 4;
                if (x.x <= g.x) {
                    w = 3;
                }
            }
            if (ai == ad) {
                w = 5;
            }
            if (ai == ae) {
                w = 6;
                if (x.x <= h.x) {
                    w = 7;
                }
            }
            if (ai == ab) {
                w = 2;
            }
            if (ai == af) {
                w = 8;
            }
        }
        var aj = DeviceUtils.g(3);
        switch (w) {
            case 1:
                q = { $type: Point_$type, x: e.x + u, y: e.y };
                r = { $type: Point_$type, x: e.x + u + v, y: e.y };
                s = { $type: Point_$type, x: e.x + u, y: e.y + aj };
                t = { $type: Point_$type, x: e.x + u + v, y: e.y + aj };
                break;
            case 2:
                q = { $type: Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y };
                r = { $type: Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y };
                s = { $type: Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y + aj };
                t = { $type: Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y + aj };
                break;
            case 3:
                q = { $type: Point_$type, x: g.x - u, y: e.y };
                r = { $type: Point_$type, x: (g.x - u) - v, y: e.y };
                s = { $type: Point_$type, x: g.x - u, y: e.y + aj };
                t = { $type: Point_$type, x: (g.x - u) - v, y: e.y + aj };
                break;
            case 4:
                q = { $type: Point_$type, x: g.x, y: g.y + u };
                r = { $type: Point_$type, x: g.x, y: g.y + u + v };
                s = { $type: Point_$type, x: g.x - aj, y: g.y + u };
                t = { $type: Point_$type, x: g.x - aj, y: g.y + u + v };
                break;
            case 5:
                q = { $type: Point_$type, x: g.x, y: ((g.y + h.y) / 2) - (v / 2) };
                r = { $type: Point_$type, x: g.x, y: ((g.y + h.y) / 2) + (v / 2) };
                s = { $type: Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) - (v / 2) };
                t = { $type: Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) + (v / 2) };
                break;
            case 6:
                q = { $type: Point_$type, x: h.x, y: h.y - u };
                r = { $type: Point_$type, x: h.x, y: h.y - u - v };
                s = { $type: Point_$type, x: h.x - aj, y: h.y - u };
                t = { $type: Point_$type, x: h.x - aj, y: h.y - u - v };
                break;
            case 7:
                q = { $type: Point_$type, x: h.x - u, y: h.y };
                r = { $type: Point_$type, x: (h.x - u) - v, y: h.y };
                s = { $type: Point_$type, x: h.x - u, y: h.y - aj };
                t = { $type: Point_$type, x: (h.x - u) - v, y: h.y - aj };
                break;
            case 8:
                q = { $type: Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y };
                r = { $type: Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y };
                s = { $type: Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y - aj };
                t = { $type: Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y - aj };
                break;
            case 9:
                q = { $type: Point_$type, x: j.x + u, y: j.y };
                r = { $type: Point_$type, x: j.x + u + v, y: j.y };
                s = { $type: Point_$type, x: j.x + u, y: j.y - aj };
                t = { $type: Point_$type, x: j.x + u + v, y: j.y - aj };
                break;
            case 10:
                q = { $type: Point_$type, x: e.x, y: j.y - u };
                r = { $type: Point_$type, x: e.x, y: (j.y - u) - v };
                s = { $type: Point_$type, x: e.x + aj, y: j.y - u };
                t = { $type: Point_$type, x: e.x + aj, y: (j.y - u) - v };
                break;
            case 11:
                q = { $type: Point_$type, x: e.x, y: ((e.y + j.y) / 2) - (v / 2) };
                r = { $type: Point_$type, x: e.x, y: ((e.y + j.y) / 2) + (v / 2) };
                s = { $type: Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) - (v / 2) };
                t = { $type: Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) + (v / 2) };
                break;
            case 12:
                q = { $type: Point_$type, x: e.x, y: e.y + u };
                r = { $type: Point_$type, x: e.x, y: e.y + u + v };
                s = { $type: Point_$type, x: e.x + aj, y: e.y + u };
                t = { $type: Point_$type, x: e.x + aj, y: e.y + u + v };
                break;
        }
        var ak = { $type: Point_$type, x: x.x, y: x.y };
        if (ak.y < e.y) {
            var al = e.y - ak.y;
            ak = { $type: Point_$type, x: ak.x, y: 0 };
            p += al;
            e = { $type: Point_$type, x: e.x, y: e.y + al };
            g = { $type: Point_$type, x: g.x, y: g.y + al };
            j = { $type: Point_$type, x: j.x, y: j.y + al };
            h = { $type: Point_$type, x: h.x, y: h.y + al };
            q = { $type: Point_$type, x: q.x, y: q.y + al };
            r = { $type: Point_$type, x: r.x, y: r.y + al };
            s = { $type: Point_$type, x: s.x, y: s.y + al };
            t = { $type: Point_$type, x: t.x, y: t.y + al };
        }
        else {
            p = Math.max(ak.y, n);
        }
        if (ak.x < e.x) {
            var am = e.x - ak.x;
            ak = { $type: Point_$type, x: 0, y: ak.y };
            o += am;
            e = { $type: Point_$type, x: e.x + am, y: e.y };
            g = { $type: Point_$type, x: g.x + am, y: g.y };
            j = { $type: Point_$type, x: j.x + am, y: j.y };
            h = { $type: Point_$type, x: h.x + am, y: h.y };
            q = { $type: Point_$type, x: q.x + am, y: q.y };
            r = { $type: Point_$type, x: r.x + am, y: r.y };
            s = { $type: Point_$type, x: s.x + am, y: s.y };
            t = { $type: Point_$type, x: t.x + am, y: t.y };
        }
        else {
            o = Math.max(ak.x, m);
        }
        y = o - m;
        z = p - n;
        this.aw = y;
        this.av = z;
        this.ak = this.al;
        this.cf = this.cn;
        this.cm = ak;
        this.ck = q;
        this.cl = r;
        this.a0 = m;
        this.az = n;
        this.ay = o;
        this.ax = p;
        this.ci = e;
        this.cj = g;
        this.ch = h;
        this.cg = j;
        var an = new PointCollection(0);
        an.add(t);
        an.add(this.cl);
        an.add(this.cm);
        an.add(this.ck);
        an.add(s);
        this.cp = an;
        if (this.cq != null) {
            this.cq.ak = an;
        }
        var ao = new PointCollection(0);
        ao.add(this.cl);
        ao.add(this.cm);
        ao.add(this.ck);
        this.co = ao;
        if (this.cr != null) {
            this.cr.ak = ao;
        }
        if (this.ct == 1) {
            return new Size(1, b, c);
        }
        return new Size(1, o, p);
    };
    PointerTooltip.prototype.bo = function () {
        this.bv();
        this.am.r();
    };
    PointerTooltip.prototype.bp = function () {
        this._visibility = 1;
        this.am.s();
    };
    PointerTooltip.prototype.bu = function (a, b) {
        if (this.au) {
            this.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        this.am.v(a, b);
    };
    PointerTooltip.prototype.bs = function (a) {
        this.am.u(a);
    };
    PointerTooltip.prototype.bm = function () {
        if (!this.as) {
            if (this.ao != null && this.am.l != null) {
                this.as = true;
                this.ao.ap(this.am.l, "pointerTooltip" + Base.getHashCodeStatic(this));
            }
        }
    };
    PointerTooltip.prototype.bv = function () {
        if (this.as) {
            if (this.ao != null && this.am.l != null) {
                this.as = false;
                this.ao.bb(this.am.l, "pointerTooltip" + Base.getHashCodeStatic(this));
            }
            this.ao = null;
        }
    };
    PointerTooltip.prototype.a3 = function () {
        if (this._visibility == 1) {
            return null;
        }
        return this.am.q();
    };
    PointerTooltip.$t = markType(PointerTooltip, 'PointerTooltip', ContentControl.$, [INotifyPropertyChanged_$type]);
    PointerTooltip.$$p = markDep(DependencyProperty, PropertyMetadata, PointerTooltip, 'bt', ['ActualBoxBottomLeftPosition:cg:bx', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxBottomRightPosition:ch:by', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxFullHeight:ax:bz', [1, 0], 'ActualBoxFullWidth:ay:b0', [1, 0], 'ActualBoxHeight:az:b1', [1, 0], 'ActualBoxTopLeftPosition:ci:b2', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxTopRightPosition:cj:b3', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxWidth:a0:b4', [1, 0], 'ActualPointerFirstPosition:ck:b5', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualPointerSecondPosition:cl:b6', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualPointerStartPosition:cm:b7', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'PointerInset:a1:b8', [1, DeviceUtils.g(7.5)], 'PointerLocation:al:b9', [PointerTooltipPointerLocation_$type, enumGetBox(PointerTooltipPointerLocation_$type, 0)], 'PointerOutlinePoints:co:ca', [PointCollection.$, null], 'PointerPoints:cp:cb', [PointCollection.$, null], 'PointerPosition:cn:cc', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'PointerVisibility:ct:cd', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'PointerWidth:a2:ce', [1, DeviceUtils.g(5)]]);
    return PointerTooltip;
}(ContentControl));
/**
 * @hidden
 */
var PointerTooltipView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointerTooltipView, _super);
    function PointerTooltipView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.n = null;
        _this.p = null;
        _this.o = null;
        _this.l = null;
        _this.k = null;
        _this.b = null;
        _this.m = null;
        _this.w = null;
        _this.c = false;
        _this.i = 0;
        _this.h = 0;
        _this.g = -1;
        _this.e = -1;
        _this.f = 1;
        _this.j = null;
        _this.a = a;
        _this.a.cq = new Polygon();
        _this.a.cr = new Polyline();
        _this.l = null;
        _this.t();
        return _this;
    }
    PointerTooltipView.prototype.t = function () {
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != this.f) {
            this.f = window.devicePixelRatio;
        }
    };
    PointerTooltipView.prototype.x = function (a) {
        var b = this.a.content;
        b = b.clone();
        var c = new Size(1, 0, 0);
        if (this.n == null) {
            this.n = this.j.createElement("div");
            this.n.addClass("ui-chart-pointer-tooltip-container");
            this.n.setStyleProperty("position", "absolute");
            this.n.setStyleProperty("visibility", "hidden");
            this.n.setStyleProperty("top", "0px");
            this.n.setStyleProperty("left", "0px");
            this.p = this.j.createElement("div");
            this.p.setStyleProperty("position", "relative");
            this.o = this.j.createElement("div");
            this.o.addClass("ui-chart-pointer-tooltip-content-container");
            this.o.setStyleProperty("position", "absolute");
            this.o.setStyleProperty("top", "0px");
            this.o.setStyleProperty("left", "0px");
            this.n.append(this.p);
            this.p.append(this.o);
        }
        this.n.remove();
        this.j.appendToBody(this.n);
        this.o.append(b);
        c = new Size(1, this.o.outerWidthWithMargin(), this.o.outerHeightWithMargin());
        this.n.remove();
        b.remove();
        return c;
    };
    PointerTooltipView.prototype.v = function (a, b) {
        if (this.l == null) {
            this.l = this.j.createElement("div");
            this.l.addClass("ui-chart-pointer-tooltip-container");
            this.l.setStyleProperty("position", "absolute");
            this.l.setStyleProperty("top", "0px");
            this.l.setStyleProperty("left", "0px");
            var c = this.j.createElement("div");
            c.setStyleProperty("position", "relative");
            this.k = this.j.createElement("canvas");
            this.k.setStyleProperty("position", "absolute");
            this.k.setStyleProperty("top", "0px");
            this.k.setStyleProperty("left", "0px");
            this.m = this.j.createElement("div");
            this.m.addClass("ui-chart-pointer-tooltip-content-container");
            this.m.setStyleProperty("position", "absolute");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            c.append(this.k);
            c.append(this.m);
            this.l.append(c);
            this.b = new RenderingContext(new CanvasViewRenderer(), this.j.get2DCanvasContext(this.k));
            this.l.hide();
            this.j.appendToBody(this.l);
        }
        this.a.bm();
        if (this.a._visibility == 1 && this.c) {
            this.l.hide();
            this.c = false;
            return;
        }
        var d = null;
        if (this.a.content != null) {
            d = this.a.content;
            d.remove();
        }
        this.m.removeChildren();
        if (d != null) {
            var cont_ = this.m;
            var xPos_ = this.a.ci.x.toString() + "px";
            var yPos_ = this.a.ci.y.toString() + "px";
            cont_.setRawStyleProperty("left", xPos_);
            cont_.setRawStyleProperty("top", yPos_);
            this.m.append(d);
        }
        var e = this.a.ap;
        var f = 1;
        this.t();
        if (e != null) {
            f = !isNaN_(e.b) ? e.b : 1;
        }
        var g = truncate(Math.ceil(this.a.ay + (f * 2)));
        var h = truncate(Math.ceil(this.a.ax + (f * 2)));
        if (g != this.i || h != this.h) {
            this.k.setStyleProperty("width", g.toString() + "px");
            this.k.setStyleProperty("height", h.toString() + "px");
            this.k.setAttribute("width", (g * this.f).toString());
            this.k.setAttribute("height", (h * this.f).toString());
            this.i = g;
            this.h = h;
        }
        if (this.b.d && this.f != 1) {
            this.b.z();
            this.b.aa(this.f, this.f);
        }
        this.b.k(0, 0, this.i, this.h);
        var i = new Rectangle();
        i.width = this.a.a0;
        i.height = this.a.az;
        i.n = this.a.ci.x;
        i.o = this.a.ci.y;
        if (e != null) {
            i._fill = e.c != null ? e.c : ((function () {
                var $ret = new Brush();
                $ret.fill = "white";
                return $ret;
            })());
            i._stroke = e.d != null ? e.d : ((function () {
                var $ret = new Brush();
                $ret.fill = "black";
                return $ret;
            })());
            i.ac = !isNaN_(e.b) ? e.b : 1;
            i.am = !isNaN_(e.a) ? e.a : 0;
            i.an = !isNaN_(e.a) ? e.a : 0;
        }
        else {
            i._fill = ((function () {
                var $ret = new Brush();
                $ret.fill = "white";
                return $ret;
            })());
            i._stroke = ((function () {
                var $ret = new Brush();
                $ret.fill = "black";
                return $ret;
            })());
            i.ac = 1;
        }
        this.w = i;
        var j = this.a.cq;
        var k = this.a.cr;
        j._fill = i._fill;
        k._stroke = i._stroke;
        this.b.v(i);
        this.b.t(j);
        this.b.u(k);
        var x_ = a + "px";
        var y_ = b + "px";
        var container_ = this.l;
        container_.setRawStyleProperty("left", x_);
        container_.setRawStyleProperty("top", y_);
        if (this.a._visibility == 0 && !this.c) {
            this.l.show();
            this.c = true;
        }
        if (this.b.d && this.f != 1) {
            this.b.y();
        }
    };
    PointerTooltipView.prototype.q = function () {
        return this.a.aj.exportPointerTooltipData(this.a.cq, this.a.cr, this.w, new Rect(0, 0, 0, this.a.ay, this.a.ax));
    };
    PointerTooltipView.prototype.d = function (a) {
        var b = this.g;
        var c = this.e;
        var d = this.x(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        if (d.width != b || d.height != c) {
            return true;
        }
        return false;
    };
    PointerTooltipView.prototype.r = function () {
        this.j = null;
        this.l.hide();
        this.l.remove();
        this.l = null;
        this.n = null;
        this.p = null;
        this.o = null;
        this.l = null;
        this.k = null;
        this.m = null;
    };
    PointerTooltipView.prototype.s = function () {
        this.l.hide();
    };
    PointerTooltipView.prototype.u = function (a) {
        this.j = a;
    };
    PointerTooltipView.$t = markType(PointerTooltipView, 'PointerTooltipView');
    return PointerTooltipView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryToolTipLayer, _super);
    function CategoryToolTipLayer() {
        var _this = _super.call(this) || this;
        var a = new CategoryToolTipLayerFrame();
        var b = new CategoryToolTipLayerFrame();
        var c = new CategoryToolTipLayerFrame();
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = CategoryToolTipLayer.$;
        return _this;
    }
    CategoryToolTipLayer.prototype.bf = function () {
        return new CategoryToolTipLayerView(this);
    };
    CategoryToolTipLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m6 = a;
    };
    CategoryToolTipLayer.prototype.get_cn = function () {
        return true;
    };
    CategoryToolTipLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case CategoryToolTipLayer.$$p[0]:
                this.jd(true);
                break;
            case CategoryToolTipLayer.$$p[2]:
                this.jd(true);
                break;
            case CategoryToolTipLayer.$$p[1]:
                this.jd(true);
                break;
            case "SeriesViewer":
                this.m6.cc();
                break;
        }
    };
    CategoryToolTipLayer.prototype.mk = function (a, b) {
        if (this.m4 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    CategoryToolTipLayer.prototype.ml = function (a, b) {
        if (!this.aq.c) {
            this.jd(b);
        }
    };
    CategoryToolTipLayer.prototype.mn = function (a, b) {
        var e_1, _a, e_2, _b;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        var d = this.m8;
        c.l = NaN;
        c.k = NaN;
        c.g = NaN;
        c.h = NaN;
        c.k = NaN;
        c.l = NaN;
        if (isNaN_(this.m1.x) && isNaN_(this.m1.y)) {
            this.m6.ca(this.m6.b7());
            return;
        }
        if (this.m4 != null) {
            var e = this.m4;
            if (e == null || !e.b2 || e.b0) {
                return;
            }
            if (!e.ce()) {
                return;
            }
            var f = e;
            var g = this.m7(f.cx, d);
            this.nd(g, c, d);
        }
        else {
            if (typeCast(XamDataChart.$, this.bs) !== null) {
                var h = this.bs;
                var i = true;
                var j = false;
                var k = new List$1(Series.$, 0);
                try {
                    for (var _c = __values(fromEnum(h.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var l = _d.value;
                        if (l.b2 && !l.b0) {
                            if (!l.ce()) {
                                continue;
                            }
                            if (i) {
                                i = false;
                                j = l.cf;
                            }
                            else {
                                if (l.cf != j) {
                                    continue;
                                }
                            }
                            try {
                                for (var _e = (e_2 = void 0, __values(fromEnum(l.cx))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    var m = _f.value;
                                    k.add(m);
                                }
                            }
                            catch (e_2_1) {
                                e_2 = { error: e_2_1 };
                            }
                            finally {
                                try {
                                    if (_f && !_f.done && (_b = _e.return))
                                        _b.call(_e);
                                }
                                finally {
                                    if (e_2)
                                        throw e_2.error;
                                }
                            }
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                var n = this.m7(k, d);
                this.nd(n, c, d);
            }
        }
    };
    CategoryToolTipLayer.prototype.m7 = function (a, b) {
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        var e = new List$1(DataContext.$, 0);
        var f = new List$1(Base.$, 0);
        var g = false;
        var h = true;
        for (var i = 0; i < a.count; i++) {
            var j = a.item(i);
            if (!j.cr && !j.cl) {
                continue;
            }
            if (j.isStacked) {
                continue;
            }
            var k = j;
            if (!k.categoryAxis.ce()) {
                continue;
            }
            if (h) {
                g = j.isVertical;
            }
            else {
                if (g != j.isVertical) {
                    continue;
                }
            }
            var l = this.mg(j);
            if (!l.c) {
                continue;
            }
            var m = j.ll(l.d, b, false);
            if (g) {
                if (!isNaN_(m.y)) {
                    c = Math.min(c, m.y);
                    d = Math.max(d, m.y);
                }
            }
            else {
                if (!isNaN_(m.x)) {
                    c = Math.min(c, m.x);
                    d = Math.max(d, m.x);
                }
            }
            var n = this.m9(j);
            if (n == null) {
                continue;
            }
            var o = null;
            var p = j.fp(this.m1);
            if (j.co && p != null) {
                o = j.as(p);
            }
            else {
                o = new DataContext();
                o.item = p;
                o.series = j;
            }
            e.add(o);
            f.add1(n);
        }
        var q = 0;
        var r = 0;
        if (g) {
            r = (c + d) / 2;
            q = this.ly.right;
            if (this.m5 == 2 || this.m5 == 1) {
                q = this.ly.left;
            }
            if (r < 0 || r > this.ly.bottom) {
                r = NaN;
            }
        }
        else {
            q = (c + d) / 2;
            r = this.ly.top;
            if (this.m5 == 2 || this.m5 == 1) {
                r = this.ly.bottom;
            }
            if (q < 0 || q > this.ly.right) {
                q = NaN;
            }
        }
        var s = new CategoryTooltipSeriesInfo();
        s.c = { $type: Point_$type, x: q, y: r };
        s.a = e;
        s.b = f;
        return s;
    };
    CategoryToolTipLayer.prototype.ia = function () {
        this.m1 = { $type: Point_$type, x: NaN, y: NaN };
        this.bi.am();
    };
    CategoryToolTipLayer.prototype.nd = function (a, b, c) {
        var d = a.c;
        var e = a.a;
        var f = a.b;
        d = this.m6.cd(d);
        var g = 0;
        var h = this.bi.br;
        var i = this.m6.b7();
        this.m6.b9();
        var j = false;
        if (e.count == 0) {
            this.bi.am();
            return;
        }
        var k = false;
        for (var l = 0; l < e.count; l++) {
            var m = e._inner[l].series;
            j = m.isVertical;
            var n = e._inner[l];
            var o = f._inner[l];
            if (this.m6.b4(m, o, n)) {
                k = true;
            }
            g++;
        }
        if (!k) {
            this.m6.ca(i);
            return;
        }
        var p = this.m6.ce(i);
        var q = 0;
        var r = 0;
        var s = 0;
        var t = 0;
        var u = false;
        var v = false;
        var w = this.m5;
        if (w == 2 || w == 3) {
            v = true;
        }
        if (w == 2 || w == 1) {
            u = true;
        }
        var x = this.m6.cf();
        if (j) {
            if (!u && !v && d.x + (p.width + DeviceUtils.g(10)) > x.width) {
                v = true;
            }
            if (u && !v && d.x - (p.width + DeviceUtils.g(10)) < 0) {
                v = true;
            }
        }
        else {
            if (!u && !v && d.y - (p.height + 10) < 0) {
                v = true;
            }
            if (u && !v && d.y + (p.height + 10) > x.height) {
                v = true;
            }
        }
        var y = DeviceUtils.g(10);
        var z = DeviceUtils.g(5);
        if (!u) {
            if (!j) {
                z = p.height + y;
            }
            if (v) {
                if (j) {
                    z = z + p.width + y;
                }
                else {
                    z = 0;
                }
            }
        }
        else {
            if (j) {
                z = p.width + y;
                if (v) {
                    z = 0;
                }
            }
            else {
                z = DeviceUtils.g(5);
                if (v) {
                    z = z + p.height + y;
                }
            }
        }
        if (j) {
            r = 0 - (y + DeviceUtils.g(5));
            if (u) {
                r = (r * -1) + p.width;
            }
            q = p.height / 2;
            t = d.y - p.height / 2;
            s = d.x - z;
        }
        else {
            q = p.height + DeviceUtils.g(10) + DeviceUtils.g(5);
            if (u) {
                q = 0 - (y + DeviceUtils.g(5));
            }
            r = p.width / 2;
            s = d.x - p.width / 2;
            t = d.y - z;
        }
        if (j) {
            if (t < 0) {
                q -= 0 - t;
                t = 0;
            }
            if (t + p.height > x.height) {
                q += (t + p.height) - x.height;
                t = x.height - p.height;
            }
        }
        else {
            if (s < 0) {
                r -= 0 - s;
                s = 0;
            }
            if (s + p.width > x.width) {
                r += (s + p.width) - x.width;
                s = x.width - p.width;
            }
        }
        b.k = s;
        b.l = t;
        b.g = r;
        b.h = q;
        b.j = p.width;
        b.i = p.height;
    };
    CategoryToolTipLayer.prototype.m9 = function (a) {
        return a.toolTip;
    };
    CategoryToolTipLayer.prototype.mq = function (a, b) {
        _super.prototype.mq.call(this, a, b);
        var c = a;
        var d = b.br.left;
        var e = b.br.right;
        var f = b.br.top;
        var g = b.br.bottom;
        var h = this.m6.b7();
        if (isNaN_(c.k) || isNaN_(c.l) || isNaN_(c.g) || isNaN_(c.h)) {
            this.m6.ca(h);
            return;
        }
        var i = c.k;
        var j = c.l;
        var k = c.g;
        var l = c.h;
        this.m6.cb(h, i, j, k, l);
    };
    CategoryToolTipLayer.prototype.c8 = function () {
        return true;
    };
    CategoryToolTipLayer.$t = markType(CategoryToolTipLayer, 'CategoryToolTipLayer', AnnotationLayer.$);
    CategoryToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryToolTipLayer, 'raisePropertyChanged', ['TargetAxis:m4:ne', [Axis.$, null], 'ToolTipPosition:m5:nf', [CategoryTooltipLayerPosition_$type, enumGetBox(CategoryTooltipLayerPosition_$type, 0)], 'UseInterpolation:m8:ng', [0, false]]);
    return CategoryToolTipLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var CategoryToolTipLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryToolTipLayerView, _super);
    function CategoryToolTipLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this._tooltips = null;
        _this.b5 = null;
        _this.b3 = false;
        _this._htmlTest = null;
        _this.b1 = a;
        _this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
        return _this;
    }
    CategoryToolTipLayerView.prototype.b7 = function () {
        if (this.b2 == null) {
            this.b2 = new PointerTooltip();
            this.b2.bs(this.e.e4);
            this.b2.ao = this.e.bs.bn.j;
            this._tooltips = this.e.e4.createElement("div");
            this.b5 = this.e.e4.createElement("div");
            this.b2._visibility = 0;
        }
        return this.b2;
    };
    CategoryToolTipLayerView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (this.b2 != null) {
            this.b2._visibility = 1;
        }
    };
    CategoryToolTipLayerView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        if (this.b2 != null) {
            this.b2.bo();
            this.b2 = null;
        }
    };
    Object.defineProperty(CategoryToolTipLayerView.prototype, "htmlTest", {
        get: function () {
            return this._htmlTest;
        },
        set: function (a) {
            this._htmlTest = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryToolTipLayerView.prototype.b4 = function (a, b, c) {
        if (a.fz == "default") {
            a.fz = a.bi.getDefaultTooltipTemplate();
        }
        var template_ = a.fz;
        var context_ = c;
        if (a.toolTip == null) {
            return false;
        }
        var tooltip_ = a.toolTip;
        if ((tooltip_.updateToolTip)) {
            tooltip_._inPointer = true;
            tooltip_.updateToolTip(context_, true);
            tooltip_.setStyleProperty('position', 'relative');
            tooltip_.setStyleProperty('left', '');
            tooltip_.setStyleProperty('top', '');
            tooltip_.remove();
        }
        this._tooltips.append(a.toolTip);
        return true;
    };
    CategoryToolTipLayerView.prototype.ce = function (a) {
        var b = a;
        b.content = this._tooltips;
        var c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        b.ct = 1;
        var d = b.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        b.ct = 0;
        return d;
    };
    CategoryToolTipLayerView.prototype.cd = function (a) {
        var b = 0;
        var c = 0;
        if (this.e.bs != null) {
            var d = this.e.bs.mj();
            b += d.x;
            c += d.y;
        }
        return { $type: Point_$type, x: b + a.x, y: c + a.y };
    };
    CategoryToolTipLayerView.prototype.cb = function (a, b, c, d, e) {
        var f = a;
        var g = f.content;
        f.cn = { $type: Point_$type, x: d, y: e };
        f._visibility = 0;
        f.n = b;
        f.o = c;
    };
    CategoryToolTipLayerView.prototype.cf = function () {
        var a = (window.innerWidth);
        var b = (window.innerHeight);
        return new Size(1, a, b);
    };
    CategoryToolTipLayerView.prototype.ca = function (a) {
        this._tooltips.removeChildren();
        this.b5.removeChildren();
        this.b2._visibility = 1;
    };
    CategoryToolTipLayerView.prototype.b9 = function () {
        if (this._tooltips != null) {
            this._tooltips.removeChildren();
        }
    };
    CategoryToolTipLayerView.prototype.cc = function () {
    };
    CategoryToolTipLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            return;
        }
        var c = null;
        if (this.e.bs != null) {
            c = this.e.bs.bn.i.i();
        }
        var d = 0;
        var e = 0;
        var f = this.e.bs;
        if (f != null) {
            var g = f.bn.i.b6();
            d += g.x;
            e += g.y;
        }
        if (this.b2 != null) {
            this.b2.ap = c;
            this.b2.bu(this.b2.n, this.b2.o);
        }
    };
    CategoryToolTipLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        var b = this.b2;
        var c = 0;
        var d = 0;
        if (this.e.bs != null) {
            var e = this.e.bs.mj();
            c += e.x;
            d += e.y;
        }
        var f = b.a3();
        var g = b.n - c;
        var h = b.o - d;
        var i = new List$1(String_$type, 0);
        var j = this._tooltips.getChildCount();
        for (var k = 0; k < j; k++) {
            var indexliteral_ = k.toString();
            var l = this._tooltips.getChildAt(k).getText();
            var m = l.toString();
            i.add(m);
        }
        this.e.a2.addPointerTooltipData(a, f, g, h, i);
    };
    CategoryToolTipLayerView.$t = markType(CategoryToolTipLayerView, 'CategoryToolTipLayerView', AnnotationLayerView.$);
    return CategoryToolTipLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * EventArgs class for RenderRequested events.
*
* Use the `RenderRequested` class for RenderRequested events.
*
* ```ts
* <IgrDataChart
* 		dataSource={this.data}
* 		ref={this.onChartRef}
* 		width="100%"
* 		height="100%" >
* <IgrCategoryXAxis name="xAxis" label="Country" />
* <IgrNumericYAxis name="yAxis" minimumValue={0} />
* <IgrColumnSeries name="series1"
* 		xAxisName="xAxis"
* 		yAxisName="yAxis"
* 		valueMemberPath="Coal"
* 		renderRequested= {this.OnRenderRequested}/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series1 = new IgrColumnSeries({ name: "series1" });
* series1.valueMemberPath = "USA";
* series1.title = "USA";
* series1.xAxisName = "xAxis";
* series1.yAxisName = "yAxis";
* series1.renderRequested = this.OnRenderRequested;
*
* public OnRenderRequested =( s:IgrSeries, e:RenderRequestedEventArgs) => {
*
*   }
* ```
*/
var IgrRenderRequestedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrRenderRequestedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrRenderRequestedEventArgs.prototype.createImplementation = function () {
        return new RenderRequestedEventArgs();
    };
    Object.defineProperty(IgrRenderRequestedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrRenderRequestedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrRenderRequestedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrRenderRequestedEventArgs.prototype, "animate", {
        /**
         * True if animation is requested.
        *
        * Use the `animate` property true if the animation is requested.
        *
        * ```ts
        * e.animation = true;
        * ```
        */
        get: function () {
            return this.i.animate;
        },
        set: function (v) {
            this.i.animate = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrRenderRequestedEventArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents the base class for all IgxDataChartComponent series.
*/
var IgrSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSeries, _super);
    function IgrSeries(props) {
        var _this = _super.call(this, props) || this;
        _this._chartLevelData = null;
        _this._dataSource = null;
        _this._tooltipTemplate = null;
        _this._tooltipContent = null;
        _this._tooltipContainerTemplate = null;
        _this._renderer = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._renderRequested = null;
        _this._renderRequested_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    Object.defineProperty(IgrSeries.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype.onImplementationCreated = function () {
    };
    IgrSeries.prototype.createImplementation = function () {
        return null;
    };
    IgrSeries.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    {
                        this[p] = this.props[p];
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    Object.defineProperty(IgrSeries.prototype, "seriesInternal", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrSeries.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrSeries.prototype, "name", {
        get: function () {
            return this.i.name;
        },
        set: function (value) {
            this.i.name = value;
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype.provideData = function (data) {
        this._chartLevelData = data;
        this.updateDataSource();
    };
    IgrSeries.prototype.onUpdateDataSource = function (dataSource) {
        return dataSource;
    };
    IgrSeries.prototype.updateDataSource = function () {
        if (this._dataSource == null) {
            this.i.itemsSource = this.onUpdateDataSource(this._chartLevelData);
        }
        else {
            this.i.itemsSource = this.onUpdateDataSource(this._dataSource);
        }
    };
    Object.defineProperty(IgrSeries.prototype, "dataSource", {
        get: function () {
            if (this._dataSource != null) {
                return this._dataSource;
            }
            return this.i.itemsSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.updateDataSource();
            //console.log("setting axis data source: " + value)
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype.bindAxes = function (axes) {
    };
    Object.defineProperty(IgrSeries.prototype, "tooltipTemplate", {
        get: function () {
            return this._tooltipTemplate;
        },
        set: function (value) {
            this._tooltipTemplate = value;
            if (value == null) {
                if (this._tooltipContent !== null) {
                    //this._tooltipContent.destroy();
                    this._tooltipContent = null;
                }
            }
            if (this._tooltipContent != null) {
                this._tooltipContent.template = this._tooltipTemplate;
            }
            else {
                if (this.owner != null) {
                    this.owner._ensureTooltipCreated(this);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "tooltipContainerTemplate", {
        get: function () {
            return this._tooltipContainerTemplate;
        },
        set: function (value) {
            this._tooltipContainerTemplate = value;
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            var tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.tooltipTemplate = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip);
        }
    };
    IgrSeries.prototype._ensureTooltipDestroyed = function () {
        if (this._tooltipContent !== null) {
            //this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    };
    IgrSeries.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
    };
    IgrSeries._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrSeries.prototype, "isAnnotationLayer", {
        /**
     * Gets whether the series is an annotation layer.
    *
    * ```ts
    * let isAnnotationLayer: boolean = this.series.isAnnotationLayer;
    * ```
    */
        get: function () {
            return this.i.cj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isVertical", {
        /**
         * Gets whether the current series is oriented vertically.
        *
        * ```ts
        * let isVertical: boolean = this.series.isVertical;
        * ```
        */
        get: function () {
            return this.i.isVertical;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        *
        * ```ts
        * let isFragment: boolean = this.series.isFragment;
        * ```
        */
        get: function () {
            return this.i.cs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        *
        * ```ts
        * let isAreaorLine: boolean = this.series.isAreaorLine;
        * ```
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isPolar", {
        /**
         * Gets whether the current series is a polar type series.
        *
        * ```ts
        * let isPolar: boolean = this.series.isPolar;
        * ```
        */
        get: function () {
            return this.i.c0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isScatter", {
        /**
         * Gets whether the current series is a scatter type series.
        *
        * ```ts
        * let isScatter: boolean = this.series.isScatter;
        * ```
        */
        get: function () {
            return this.i.c4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isRadial", {
        /**
         * Gets whether the current series is a radial type series.
        *
        * ```ts
        * let isRadial: boolean = this.series.isRadial;
        * ```
        */
        get: function () {
            return this.i.c2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isStacked", {
        /**
         * Gets whether the current series is a stacked type series.
        *
        * ```ts
        * let isStacked: boolean = this.series.isStacked;
        * ```
        */
        get: function () {
            return this.i.isStacked;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isFinancial", {
        /**
         * Gets whether the current series is a financial type series.
        *
        * ```ts
        * let isFinancial: boolean = this.series.isFinancial;
        * ```
        */
        get: function () {
            return this.i.cr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isRange", {
        /**
         * Gets whether the current series is a range type series.
        *
        * ```ts
        * let isRange: boolean = this.series.isRange;
        * ```
        */
        get: function () {
            return this.i.c3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isCategory", {
        /**
         * Gets whether the current series is a category type series.
        *
        * ```ts
        * let isCategory: boolean = this.series.isCategory;
        * ```
        */
        get: function () {
            return this.i.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isGeographic", {
        /**
         * Gets whether the current seires is a geogrpahic series.
        *
        * ```ts
        * let isGeographic: boolean = this.series.isGeographic;
        * ```
        */
        get: function () {
            return this.i.ct;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isShape", {
        /**
         * Gets whether the current series is a shape type series.
        */
        get: function () {
            return this.i.c5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isValueOverlay", {
        /**
         * Gets whether the series is a value overlay.
        */
        get: function () {
            return this.i.c6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isDefaultCrosshairBehaviorDisabled", {
        /**
         * Gets whether the default crosshair behavior should be disabled if this series is present.
        *
        * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `CrosshairVisibility` to true.
        *
        * ```ts
        * let isDefaultCrosshairBehaviorDisabled: boolean = this.series.isDefaultCrosshairBehaviorDisabled;
        * ```
        */
        get: function () {
            return this.i.cm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behavior should be disabled if this series is present.
        *
        * ```ts
        *  let isDefaultTooltipBehaviorDisabled: boolean = this.series.isDefaultTooltipBehaviorDisabled;
        * ```
        */
        get: function () {
            return this.i.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "hasMarkers", {
        /**
         * Returns whether the current series supports visual markers.
        *
        * ```ts
        * let hasMarkers: boolean = this.series.hasMarkers;
        * ```
        */
        get: function () {
            return this.i.hasMarkers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isIndexed", {
        /**
         * Gets if the series uses an index, which can be used to auto-assign it a color.
        *
        * ```ts
        * let isIndexed: boolean = this.series.isIndexed;
        * ```
        */
        get: function () {
            return this.i.cw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isUsableInLegend", {
        /**
         * Gets if the series should appear in any legends.
        *
        * ```ts
        * let isUsableInLegend: boolean = this.series.isUsableInLegend;
        * ```
        */
        get: function () {
            return this.i.isUsableInLegend;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the legend item visibility for the current series object.
        *
        * The `LegendItemVisibilty` can be used to exclude only certain `IgrSeries` from the `IgrLegend`.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     legendItemVisibility= "collapsed" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.lz;
        },
        set: function (v) {
            this.i.lz = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "discreteLegendItemTemplate", {
        /**
         * Gets or sets the DiscreteLegendItemTemplate property.
         * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.jy;
        },
        set: function (v) {
            this.i.jy = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "transitionEasingFunction", {
        /**
         * Gets or sets the easing function used to morph the current series.
        *
        * The `TransitioninDuration` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgrSeries`. To play an initial animation see `transitionInDuration`.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isDropShadowEnabled=true
        *     markerType="circle"
        *    transitionEasingFunction ="cubicEase"
        *    isTransitionInEnabled= {true}  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.transitionEasingFunction =  EasingFunctions.cubicEase;
        * ```
        */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "transitionInEasingFunction", {
        /**
         * Gets or sets the EasingFunction used to morph the current series during the initial transition.
        *
        * The `transitionInEasingFunction` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isDropShadowEnabled=true
        *     markerType="circle"
        *    transitionInEasingFunction ="cubicEase"
        *    isTransitionInEnabled= {true}  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.transitionInEasingFunction =  EasingFunctions.cubicEase;
        * ```
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "transitionDuration", {
        /**
         * Gets or sets the duration of the current series's morph.
        *
        * The `transitionDuration` can be used to play animation when data is added or removed from a `IgrSeries`. To play an initial animation see `transitionInDuration`.
        *
        * ```ts
        * this.series.transitionDuration = 500;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isTransitionInEnabled=true
        *     transitionInSpeedType="indexScaled"
        *     transitionDuration= {500}
        *     transitionInDuration = {500} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.fi;
        },
        set: function (v) {
            this.i.fi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "resolution", {
        /**
         * Gets or sets the current series object's rendering resolution.
        *
        * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
        *
        * ```ts
        * this.series.resolution = 1.5;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     resolution= {1.5} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.eu;
        },
        set: function (v) {
            this.i.eu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "title", {
        /**
         * Gets or sets the Title property.
         * The legend item control is created according to the Title on-demand by
         * the series object itself.
        *
        * The `IgrSeries` `title` may be used in tooltips and legends.
        *
        * ```ts
        * this.series.title = "InStock Items";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *    title="InStock Items" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.fx;
        },
        set: function (v) {
            this.i.fx = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "brush", {
        /**
         * Gets or sets the brush to use for the series.
        *
        * The `brush` along with the `outline` and `Negative Brush` can be used to affect the visuals of the `IgrSeries`.
        *
        * ```ts
        * this.series.brush = "red";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.k5);
        },
        set: function (v) {
            this.i.k5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "actualBrush", {
        /**
         * Gets the effective brush for the current series object.
        *
        * ```ts
        * let actualBrush: string = series.actualBrush;
        * ```
        */
        get: function () {
            return brushToString(this.i.k3);
        },
        set: function (v) {
            this.i.k3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "outline", {
        /**
         * Gets or sets the brush to use for the outline of the series.
         * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
        *
        * The `outline` along with the `brush` and `NegativeBrush` can be used to affect the visuals of the `IgrSeries`.
        *
        * ```ts
        * this.series.brush = "red";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.k8);
        },
        set: function (v) {
            this.i.k8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "actualOutline", {
        /**
         * Gets the effective outline for the current series object.
        *
        * ```ts
        * let actualOutline: string = series.ActualOutline;
        * ```
        */
        get: function () {
            return brushToString(this.i.k4);
        },
        set: function (v) {
            this.i.k4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "thickness", {
        /**
         * Gets or sets the width of the current series object's line thickness.
        *
        * Depending on the `IgrSeries` type, this can be the main brush used, or just the outline. For example, when using a `IgrLineSeries` it will affect the thickness of the lines drawn, whereas when using a `IgrColumnSeries` it will affect the outer border thickness of the columns.
        *
        * ```ts
        * this.series.thickness=5;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     thickness= {5} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ey;
        },
        set: function (v) {
            this.i.ey = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isHighlightingEnabled", {
        /**
         * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
        *
        * ```ts
        * this.series.isHighlightingEnabled = true;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isHighlightingEnabled="true" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.cu;
        },
        set: function (v) {
            this.i.cu = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isDropShadowEnabled", {
        /**
         * Gets or sets whether drop shadow should be enabled for this series.
        *
        * `isDropShadowEnabled` is used to decide whether drop shadow should be enabled for this series.
        *
        * ```ts
        * this.series.isDropShadowEnabled = true;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isDropShadowEnabled="true" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.cp;
        },
        set: function (v) {
            this.i.cp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "shadowBlur", {
        /**
         * Gets or sets the shadow blur.
         * This property is ignored when Series.UseSingleShadow is set to true.
        *
        * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```ts
        * this.series.shadowBlur = 7;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     shadowBlur={7}
        *     shadowColor="blue" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ev;
        },
        set: function (v) {
            this.i.ev = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "shadowColor", {
        /**
         * Gets or sets the drop shadow color.
        *
        * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```ts
        * this.series.shadowColor = "blue";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     shadowBlur="7"
        *     shadowColor="blue" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return colorToString(this.i.la);
        },
        set: function (v) {
            this.i.la = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "useSingleShadow", {
        /**
         * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
         * When this property is set to true, no Series.ShadowBlur is applied.
        *
        * ```ts
        * this.series.useSingleShadow = true;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isDropShadowEnabled=true
        *     markerType="circle"
        *     useSingleShadow= {true} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.du;
        },
        set: function (v) {
            this.i.du = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "shadowOffsetX", {
        /**
         * Gets or sets the drop shadow x-offset.
        *
        * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```ts
        * this.series.shadowOffsetX = 10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     shadowOffsetX= {10}
        *     shadowOffsetY={10] />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ew;
        },
        set: function (v) {
            this.i.ew = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "shadowOffsetY", {
        /**
         * Gets or sets the drop shadow y-offset.
        *
        * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```ts
        * this.series.shadowOffsetY = 10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     shadowOffsetX= {10}
        *     shadowOffsetY= {10} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ex;
        },
        set: function (v) {
            this.i.ex = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "areaFillOpacity", {
        /**
         * Gets or sets the opacity applied to the area fill visual.
         * This property only applies to series that have area visual.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *    actualAreaFillOpacity= {1} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.d7;
        },
        set: function (v) {
            this.i.d7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "actualAreaFillOpacity", {
        /**
         * Gets the actual opacity applied to the area fill visual.
        *
        * ```ts
        * let actualFillOpacity: number = series.actualAreaFillOpacity;
        * ```
        */
        get: function () {
            return this.i.d6;
        },
        set: function (v) {
            this.i.d6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isDefaultToolTipSelected", {
        /**
         * Gets if the default tooltip has been selected for display.
        *
        * To use the default tooltip set `showDefaultTooltip` to true.
        *
        * ```ts
        * let isDefaultToolTipSelected: boolean = this.series.isDefaultToolTipSelected;
        * ```
        */
        get: function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "showDefaultTooltip", {
        /**
         * Gets or sets whether default tooltip will be shown.
        *
        * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     showDefaultTooltip ="true"
        *     title="InStock Items" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.showDefaultTooltip ="true";
        * ```
        */
        get: function () {
            return this.i.dd;
        },
        set: function (v) {
            this.i.dd = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "transitionInDuration", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInDuration` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
        *
        * ```ts
        * this.series.transitionDuration = 500;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isTransitionInEnabled= {true}
        *     transitionInSpeedType="indexScaled"
        *     transitionDuration={500}
        *     transitionInDuration= {500} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.fj;
        },
        set: function (v) {
            this.i.fj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "transitionInSpeedType", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInSpeedType` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
        *
        * ```ts
        * this.series.transitionInSpeedType = TransitionInSpeedType.IndexScaled;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     isTransitionInEnabled=true
        *     transitionInSpeedType="indexScaled"
        *     transitionDuration=500
        *     transitionInDuration=500 />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = ensureEnum(TransitionInSpeedType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "mouseOverEnabled", {
        /**
         * Gets or sets the whether the chart reacts to mouse move events.
        */
        get: function () {
            return this.i.c7;
        },
        set: function (v) {
            this.i.c7 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "coercionMethods", {
        /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be reimported into the chart.
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * cMethods: any = {
        *     ValueCoercion: function(value:number): number {return value+2;}
        *  }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrScatterPolygonSeries
        *      name="series1"
        *      shapeMemberPath="Points"
        *      title="House Floor Plan"
        *      brush="Gray"
        *      outline="Black"
        * 	 coercionMethods = {this.ValueCoercion} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.coercionMethods;
        },
        set: function (v) {
            this.i.coercionMethods = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "expectFunctions", {
        /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        *
        * `expectFunctions` is used to decide whether the series should expect that its data source members need to be called as functions to get their values.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="MyFunction"
        *     expectFunctions={true} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.expectFunctions=true;
        * ```
        */
        get: function () {
            return this.i.expectFunctions;
        },
        set: function (v) {
            this.i.expectFunctions = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "hitTestMode", {
        /**
         * Method of hit testing to use when pointing to items in this series.
        *
        * The `hitTestMode` can be set to either:
        *
        * -   `Auto`: automatically decide the appropriate hit test mode for the series.
        * -   `ColorEncoded`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
        * -   `Computational`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
        *
        * ```ts
        * this.series.hitTestMode = SeriesHitTestMode.Computational;
        * ```
        */
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = ensureEnum(SeriesHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "actualHitTestMode", {
        /**
         * Resolved method of hit testing to use when pointing to items in the chart.
        *
        * ```ts
        * let hitTestMode: SeriesHitTestMode = this.series.actualHitTestMode;
        * ```
        */
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = ensureEnum(SeriesHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isNegativeColorSupported", {
        /**
         * Overridden by derived series classes to indicate when negative colors are supported or not.
        */
        get: function () {
            return this.i.cz;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "finalValue", {
        /**
         * The final value of this series.
        */
        get: function () {
            return this.i.d8;
        },
        set: function (v) {
            this.i.d8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "percentChange", {
        /**
         * The percent change from the beginning to the end of this series.
        */
        get: function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeries.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrSeries.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrSeries.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Series");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Gets the brush for tooltip labels.

*/
    IgrSeries.prototype.resolveTooltipBrush = function () {
        var iv = this.i.gv();
        return (iv);
    };
    IgrSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    *
    * ```ts
    * let index: number = this.series.getExactItemIndex({x:.5,y:.5});
    * ```
    */
    IgrSeries.prototype.getExactItemIndex = function (world) {
        var iv = this.i.eb(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item item index associated with the specified world position
    
    *
    * ```ts
    * let index: number = this.series.getItemIndex({x:.5,y:.5});
    * ```
    */
    IgrSeries.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * ```ts
    * let item: number = this.series.getItem({x:.5,y:.5});
    * ```
    */
    IgrSeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    IgrSeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrSeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrSeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrSeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgrSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    IgrSeries.prototype.getSeriesValueMarkerBoundingBox = function (world) {
        var iv = this.i.lw(toPoint(world));
        return fromRect(iv);
    };
    IgrSeries.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrSeries.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lh(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrSeries.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrSeries.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lj(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrSeries.prototype.getSeriesValuePositionFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.lm(toPoint(mouse), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrSeries.prototype.getSeriesValueFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.eo(toPoint(mouse), useInterpolation, skipUnknowns);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * ```ts
    * let span: number = this.series.getItemSpan();
    * ```
    */
    IgrSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    /**
     * Hides any internal tooltips presented by the series, if any.
    
    */
    IgrSeries.prototype.hideToolTips = function () {
        this.i.ia();
    };
    /**
     * Converts a point from coordinates within the series plot area to a world position within axis space.
    
    * @param seriesPoint  * The pixel location within the plot area of the series.
    *
    * ```ts
    * this.series.toWorldPosition({x:500,y:500});
    * ```
    */
    IgrSeries.prototype.toWorldPosition = function (seriesPoint) {
        var iv = this.i.lo(toPoint(seriesPoint));
        return fromPoint(iv);
    };
    /**
     * Converts a point from world coordinates to coordinates within the viewport of the series.
    
    * @param world  * The world position from which to convert.
    */
    IgrSeries.prototype.fromWorldPosition = function (world) {
        var iv = this.i.lg(toPoint(world));
        return fromPoint(iv);
    };
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    *
    * ```ts
    * this.series.scrollIntoView(dataItem);
    * ```
    */
    IgrSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Renders the series.
    
    * @param animate  * True if the change should be animated.
    *
    * ```ts
    * this.series.renderSeries(true);
    * ```
    */
    IgrSeries.prototype.renderSeries = function (animate) {
        this.i.jd(animate);
    };
    /**
     * Gets the effective viewport, adjusted to account for margins and other factors.
    
    */
    IgrSeries.prototype.getEffectiveViewport = function () {
        var iv = this.i.getEffectiveViewport();
        return fromRect(iv);
    };
    /**
     * Removes all alternate views of this series.
    
    */
    IgrSeries.prototype.removeAllAlternateViews = function () {
        this.i.i7();
    };
    /**
     * Removes an alternate view of this series.
    
    * @param viewIdentifier  * The string identifier for the view to remove.
    */
    IgrSeries.prototype.removeAlternateView = function (viewIdentifier) {
        this.i.i9(viewIdentifier);
    };
    /**
     * Replays the assigned transition in animation, if any.
    
    *
    * ```ts
    * this.series.replayTransitionIn();
    * ```
    */
    IgrSeries.prototype.replayTransitionIn = function () {
        this.i.jg();
    };
    /**
     * Call to null out the axes of the series;
    
    */
    IgrSeries.prototype.removeAxes = function () {
        this.i.ja();
    };
    /**
     * Simulates a pointer hover over the series surface.
    
    * @param point  * The pointer position relative to the series viewport over which to hover.
    *
    * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
    *
    * ```ts
    * this.series.simulateHover({x:250,y:250});
    * ```
    */
    IgrSeries.prototype.simulateHover = function (point) {
        this.i.jk(toPoint(point));
    };
    /**
     * Called when this series' Style is updated.
    
    */
    IgrSeries.prototype.styleUpdated = function () {
        this.i.jm();
    };
    IgrSeries.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.ji(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    /**
     * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
    
    * @param point  * The cursor point, in world coordinates.
    *
    * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
    *
    * ```ts
    * this.crosshair.moveCursorPoint({x:.5,y:.5});
    * ```
    */
    IgrSeries.prototype.moveCursorPoint = function (point) {
        this.i.ic(toPoint(point));
    };
    Object.defineProperty(IgrSeries.prototype, "renderRequested", {
        /**
         * This event is raised every time a render has been requested from a series.
        *
        * ```ts
        *  const series1 = new IgrAreaSeries({ name: "series1" });
        * series1.valueMemberPath = "USA";
        * series1.title = "USA";
        * series1.xAxisName = "xAxis";
        * series1.yAxisName = "yAxis";
        * series1.renderRequested= this.onRenderRequested;
        *
        * public onRenderRequested =( s:IgrSeries, e: RenderRequestedEventArgs) => {
        *           }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     shadowBlur="7"
        *     shadowColor="blue"
        * 	renderRequested= {this.onRenderRequested}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this._renderRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._renderRequested_wrapped !== null) {
                this.i.renderRequested = delegateRemove(this.i.renderRequested, this._renderRequested_wrapped);
                this._renderRequested_wrapped = null;
                this._renderRequested = null;
            }
            this._renderRequested = ev;
            this._renderRequested_wrapped = function (o, e) {
                var outerArgs = new IgrRenderRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRenderRequested) {
                    _this.beforeRenderRequested(_this, outerArgs);
                }
                if (_this._renderRequested) {
                    _this._renderRequested(_this, outerArgs);
                }
            };
            this.i.renderRequested = delegateCombine(this.i.renderRequested, this._renderRequested_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSeries;
}(Component));

/**
 * Represents the base class for annotation layer types. Annotations will usually disable some of the default hover/touch behaviors of the chart when they are introduced to the series collection.
 * In return they provide some valuable information as the cursor is moved by hovering over the chart, or performing a press-hold-drag interaction in touch mode.
*/
var IgrAnnotationLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAnnotationLayer, _super);
    function IgrAnnotationLayer(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrAnnotationLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "useIndex", {
        /**
         * Gets or sets whether this series should take up an index for auto brush coloring.
        */
        get: function () {
            return this.i.ma;
        },
        set: function (v) {
            this.i.ma = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "useLegend", {
        /**
         * Gets or sets whether this series interacts with the chart legend.
        */
        get: function () {
            return this.i.mb;
        },
        set: function (v) {
            this.i.mb = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "cursorPosition", {
        /**
         * Gets or sets the world position to use instead of the pointer position for this annotation layer. If you set this value, rather than responding to the pointer, this layer will be fixed on the provided world position.
         * A world position has x and y values that range from 0 to 1 that represent the global position of the cursor relative to the entire ranges of the axes. The default of (NaN, NaN) means that the layer should react to pointer movement.
        */
        get: function () {
            return fromPoint(this.i.m2);
        },
        set: function (v) {
            this.i.m2 = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "isDefaultCrosshairDisabled", {
        /**
         * Gets or sets whether the series viewer's default crosshair should be disabled by the presence of this layer.
        */
        get: function () {
            return this.i.l5;
        },
        set: function (v) {
            this.i.l5 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "isDefaultCrosshairBehaviorDisabled", {
        /**
         * Gets whether or not the default crosshair behavior is disabled.
        */
        get: function () {
            return this.i.cm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "isIndexed", {
        /**
         * Gets if the series uses an index, which can be used to auto-assign it a color.
        */
        get: function () {
            return this.i.cw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "isUsableInLegend", {
        /**
         * Gets if the series should appear in any legends.
        */
        get: function () {
            return this.i.isUsableInLegend;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "isAnnotationLayer", {
        /**
         * Gets whether this series is an annotation layer.
        */
        get: function () {
            return this.i.cj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnnotationLayer.prototype, "shouldRenderAsOverlay", {
        /**
         * Gets or sets whether this layer renders as an overlay or not.
        */
        get: function () {
            return this.i.l9;
        },
        set: function (v) {
            this.i.l9 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrAnnotationLayer;
}(IgrSeries));

/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
var IgrCategoryToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryToolTipLayer, _super);
    function IgrCategoryToolTipLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryToolTipLayer.prototype.createImplementation = function () {
        return new CategoryToolTipLayer();
    };
    Object.defineProperty(IgrCategoryToolTipLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryToolTipLayer.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
        */
        get: function () {
            return this.i.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryToolTipLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing the tooltips.
        */
        get: function () {
            return this.i.m8;
        },
        set: function (v) {
            this.i.m8 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    IgrCategoryToolTipLayer.prototype.hideToolTips = function () {
        this.i.ia();
    };
    return IgrCategoryToolTipLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryToolTipLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryToolTipLayerModule() {
    }
    IgrCategoryToolTipLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrCategoryToolTipLayer", IgrCategoryToolTipLayer);
        TypeRegistrar.register("CategoryToolTipLayer", CategoryToolTipLayer.$type);
    };
    return IgrCategoryToolTipLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryToolTipCollisionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryToolTipCollisionInfo, _super);
    function CategoryToolTipCollisionInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.c = 0;
        _this.b = 0;
        _this.a = 0;
        return _this;
    }
    CategoryToolTipCollisionInfo.$t = markType(CategoryToolTipCollisionInfo, 'CategoryToolTipCollisionInfo');
    return CategoryToolTipCollisionInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemTooltipLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemTooltipLayerFrame, _super);
    function ItemTooltipLayerFrame() {
        var _this = _super.call(this) || this;
        _this.o = null;
        _this.n = null;
        _this.g = null;
        _this.f = null;
        _this.l = null;
        _this.j = null;
        _this.i = null;
        _this.m = null;
        _this.k = null;
        _this.h = null;
        _this.o = new List$1(Number_$type, 0);
        _this.n = new List$1(Number_$type, 0);
        _this.g = new List$1(Number_$type, 0);
        _this.f = new List$1(Number_$type, 0);
        _this.l = new List$1(Base.$, 0);
        _this.j = new List$1(Base.$, 0);
        _this.i = new List$1(Base.$, 0);
        _this.m = new List$1(Number_$type, 0);
        _this.k = new List$1(Number_$type, 0);
        _this.h = new List$1(Brush.$, 0);
        return _this;
    }
    ItemTooltipLayerFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        Frame.b(this.o, a, d.o, e.o);
        Frame.b(this.n, a, d.n, e.n);
        Frame.b(this.g, a, d.g, e.g);
        Frame.b(this.f, a, d.f, e.f);
        Frame.b(this.m, a, d.m, e.m);
        Frame.b(this.k, a, d.k, e.k);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        InterpolationUtil.c(Base.$, this.l, a, d.l, e.l, function () { return null; }, function (f, g, h, i) { return i; });
        InterpolationUtil.c(Base.$, this.j, a, d.j, e.j, function () { return null; }, function (f, g, h, i) { return i; });
        InterpolationUtil.c(Base.$, this.i, a, d.i, e.i, function () { return null; }, function (f, g, h, i) { return i; });
    };
    ItemTooltipLayerFrame.$t = markType(ItemTooltipLayerFrame, 'ItemTooltipLayerFrame', Frame.$);
    return ItemTooltipLayerFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemTooltipCollisionInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemTooltipCollisionInfo, _super);
    function ItemTooltipCollisionInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = null;
        _this.d = 0;
        _this.c = 0;
        _this.a = 0;
        _this.b = 0;
        return _this;
    }
    ItemTooltipCollisionInfo.$t = markType(ItemTooltipCollisionInfo, 'ItemTooltipCollisionInfo');
    return ItemTooltipCollisionInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemToolTipLayer, _super);
    function ItemToolTipLayer() {
        var _this = _super.call(this) || this;
        var a = new ItemTooltipLayerFrame();
        var b = new ItemTooltipLayerFrame();
        var c = new ItemTooltipLayerFrame();
        var d = _this.fi / 1000;
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = ItemToolTipLayer.$;
        return _this;
    }
    ItemToolTipLayer.prototype.bf = function () {
        return new ItemToolTipLayerView(this);
    };
    ItemToolTipLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m4 = a;
    };
    ItemToolTipLayer.prototype.get_cn = function () {
        return true;
    };
    ItemToolTipLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ItemToolTipLayer.$$p[1]:
                this.jd(true);
                break;
            case ItemToolTipLayer.$$p[2]:
                this.jd(true);
                break;
            case ItemToolTipLayer.$$p[0]:
                this.jd(true);
                break;
        }
    };
    ItemToolTipLayer.prototype.ml = function (a, b) {
        if (this.m5 == null || this.m5 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    ItemToolTipLayer.prototype.l8 = function (a) {
        if (!_super.prototype.l8.call(this, a)) {
            return false;
        }
        var b = this.mg(a);
        if (!b.c) {
            return false;
        }
        return true;
    };
    ItemToolTipLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        var d = this.m4.b2;
        var e = this.m8;
        var f = this.m7;
        c.o.clear();
        c.i.clear();
        c.n.clear();
        c.g.clear();
        c.f.clear();
        c.l.clear();
        c.j.clear();
        c.m.clear();
        c.k.clear();
        c.h.clear();
        if (isNaN_(this.m1.x) && isNaN_(this.m1.y)) {
            d.count = 0;
            return;
        }
        var g = 0;
        if (this.l8(this.m5)) {
            this.ne(this.m5, c, e, f, 0);
            g++;
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    if (this.l8(h)) {
                        this.ne(h, c, e, f, g);
                        g++;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            this.nd(c);
        }
        d.count = g;
    };
    ItemToolTipLayer.prototype.nd = function (a) {
        var b = new List$1(ItemTooltipCollisionInfo.$, 0);
        for (var c = 0; c < a.f.count; c++) {
            var d = new ItemTooltipCollisionInfo();
            d.d = c;
            d.e = { $type: Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
            d.c = a.m._inner[c];
            d.a = a.k._inner[c];
            d.b = a.o._inner[c];
            if (isNaN_(d.e.x) || isNaN_(d.e.y)) {
                continue;
            }
            b.add(d);
        }
        b.aa(function (e, f) {
            if (e.e.y < f.e.y) {
                return -1;
            }
            if (e.e.y > f.e.y) {
                return 1;
            }
            if (e.b < f.b) {
                return -1;
            }
            if (e.b > f.b) {
                return 1;
            }
            return 0;
        });
        var e = this.m6(b);
        if (!e) {
            return;
        }
        for (var f = 0; f < b.count - 1; f++) {
            var g = b._inner[f];
            var h = b._inner[f + 1];
            var i = new Rect(0, g.e.x, g.e.y, g.c, g.a);
            var j = new Rect(0, h.e.x, h.e.y, h.c, h.a);
            if (i.intersectsWith(j) || i.top > j.bottom) {
                h.e = { $type: Point_$type, x: h.e.x, y: i.bottom + 1 };
            }
        }
        if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.bi.br.height) {
            b._inner[b.count - 1].e = { $type: Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.bi.br.height) };
        }
        for (var k = b.count - 1; k >= 1; k--) {
            var l = b._inner[k];
            var m = b._inner[k - 1];
            var n = new Rect(0, l.e.x, l.e.y, l.c, l.a);
            var o = new Rect(0, m.e.x, m.e.y, m.c, m.a);
            if (n.intersectsWith(o) || n.top < o.bottom) {
                m.e = { $type: Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
            }
        }
        for (var p = 0; p < b.count; p++) {
            var q = b._inner[p].d;
            var r = b._inner[p];
            a.f._inner[q] = r.e.x;
            a.g._inner[q] = r.e.y;
        }
    };
    ItemToolTipLayer.prototype.m6 = function (a) {
        if (a.count <= 1) {
            return false;
        }
        var b = this.bi.br;
        for (var c = 0; c < a.count - 1; c++) {
            var d = a._inner[c];
            var e = a._inner[c + 1];
            var f = new Rect(0, d.e.x, d.e.y, d.c, d.a);
            var g = new Rect(0, e.e.x, e.e.y, e.c, e.a);
            if (f.intersectsWith(g)) {
                return true;
            }
        }
        return false;
    };
    ItemToolTipLayer.prototype.ne = function (a, b, c, d, e) {
        var f = this.mg(a);
        if (!f.c) {
            return;
        }
        var g = a.ll(f.d, c, d);
        var h = this.m4.b2;
        var i = this.m9(a);
        var j = this.m1;
        if (!c) {
            j = this.lo(g);
        }
        var k = a.fp(j);
        var l = h.item(e);
        var m = this.bi.br;
        var n = null;
        if (a.co && k != null) {
            n = a.as(k);
        }
        else {
            n = new DataContext();
            n.item = k;
            n.series = a;
        }
        if (!this.m4.b3(a, l, i, n)) {
            return;
        }
        var o = this.m4.cd(l, i, n);
        b.i.add1(l);
        b.j.add1(n);
        b.l.add1(i);
        var p = g.x;
        var q = g.x;
        q = Math.max(q, m.left);
        q = Math.min(q, m.right);
        b.n.add(q);
        var r = g.y;
        r = Math.max(r, m.top);
        r = Math.min(r, m.bottom);
        b.o.add(r);
        var s = DeviceUtils.g(10);
        var t = g.x + s;
        if (t + o.width > m.right) {
            t = (p - o.width) - s;
        }
        if (t < m.left) {
            t = m.left;
        }
        b.f.add(t);
        var u = (g.y - o.height) - s;
        if (u + o.height > m.bottom) {
            u = (m.bottom - o.height) - s;
        }
        if (u < m.top) {
            u = m.top;
        }
        b.g.add(u);
        b.m.add(o.width);
        b.k.add(o.height);
        var v = this.k3;
        if (v == null) {
            v = this.k5;
        }
        if (v == null) {
            v = a.k3;
        }
        b.h.add(v);
    };
    ItemToolTipLayer.prototype.m9 = function (a) {
        return a.toolTip;
    };
    ItemToolTipLayer.prototype.ia = function () {
        this.m1 = { $type: Point_$type, x: NaN, y: NaN };
        this.m4.cb();
    };
    ItemToolTipLayer.prototype.mq = function (a, b) {
        _super.prototype.mq.call(this, a, b);
        var c = a;
        var d = c.o.count;
        var e = b.br.left;
        var f = b.br.right;
        var g = b.br.top;
        var h = b.br.bottom;
        for (var i = 0; i < d; i++) {
            if (isNaN_(c.n._inner[i]) || isNaN_(c.o._inner[i]) || isNaN_(c.f._inner[i]) || isNaN_(c.g._inner[i]) || c.l._inner[i] == null || c.j._inner[i] == null) {
                this.m4.ca(c.i._inner[i]);
                continue;
            }
            var j = c.f._inner[i];
            var k = c.g._inner[i];
            var l = c.m._inner[i];
            var m = c.k._inner[i];
            var n = false;
            if (j < e && Math.abs(j - e) > 1) {
                n = true;
            }
            if (k < g && Math.abs(k - g) > 1) {
                n = true;
            }
            if ((j + l) > f && Math.abs((j + l) - f) > 1) {
                n = true;
            }
            if ((k + m) > h && Math.abs((k + m) - h) > 1) {
                n = true;
            }
            if (n) {
                this.m4.ca(c.i._inner[i]);
                continue;
            }
            var o = c.i._inner[i];
            var p = Math.min(c.f._inner[i], c.n._inner[i]);
            var q = Math.min(c.g._inner[i], c.o._inner[i]);
            var r = c.n._inner[i] - c.f._inner[i];
            var s = c.o._inner[i] - c.g._inner[i];
            this.m4.cc(o, p, q, r, s);
        }
    };
    ItemToolTipLayer.prototype.c8 = function () {
        return true;
    };
    ItemToolTipLayer.$t = markType(ItemToolTipLayer, 'ItemToolTipLayer', AnnotationLayer.$);
    ItemToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, ItemToolTipLayer, 'raisePropertyChanged', ['SkipUnknownValues:m7:nf', [0, true], 'TargetSeries:m5:ng', [Series.$, null], 'UseInterpolation:m8:nh', [0, false]]);
    return ItemToolTipLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var ItemToolTipLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemToolTipLayerView, _super);
    function ItemToolTipLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this.b4 = null;
        _this._htmlTest = null;
        _this.b1 = a;
        _this.b4 = new List$1(PointerTooltip.$, 0);
        return _this;
    }
    ItemToolTipLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b2 = ((function () {
            var $ret = new Pool$1(Base.$);
            $ret.create = runOn(_this, _this.b5);
            $ret.activate = runOn(_this, _this.b7);
            $ret.disactivate = runOn(_this, _this.b9);
            $ret.destroy = runOn(_this, _this.b8);
            return $ret;
        })());
        this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
    };
    ItemToolTipLayerView.prototype.ag = function () {
        _super.prototype.ag.call(this);
        for (var a = 0; a < this.b2.a.count; a++) {
            this.b2.a._inner[a].bo();
        }
        for (var b = 0; b < this.b2.b.count; b++) {
            this.b2.b._inner[b].bo();
        }
        this.b2.clear();
    };
    ItemToolTipLayerView.prototype.b5 = function () {
        var a = new PointerTooltip();
        a.bs(this.e.e4);
        a._visibility = 1;
        a.ao = this.e.bs.bn.j;
        this.b4.add(a);
        return a;
    };
    ItemToolTipLayerView.prototype.b7 = function (a) {
        var b = a;
    };
    ItemToolTipLayerView.prototype.b9 = function (a) {
        var b = a;
        b._visibility = 1;
    };
    ItemToolTipLayerView.prototype.b8 = function (a) {
        var b = a;
        b.bv();
        b.content = null;
        this.b4.remove1(a);
    };
    Object.defineProperty(ItemToolTipLayerView.prototype, "htmlTest", {
        get: function () {
            return this._htmlTest;
        },
        set: function (a) {
            this._htmlTest = a;
        },
        enumerable: true,
        configurable: true
    });
    ItemToolTipLayerView.prototype.b3 = function (a, b, c, d) {
        var e = b;
        if (a.fz == "default") {
            a.fz = a.bi.getDefaultTooltipTemplate();
        }
        var template_ = a.fz;
        var context_ = d;
        if (a.toolTip == null) {
            return false;
        }
        var tooltip_ = a.toolTip;
        if ((tooltip_.updateToolTip)) {
            tooltip_._inPointer = true;
            tooltip_.updateToolTip(context_, true);
            tooltip_.setStyleProperty('position', 'relative');
            tooltip_.setStyleProperty('left', '');
            tooltip_.setStyleProperty('top', '');
        }
        e.content = a.toolTip;
        return true;
    };
    ItemToolTipLayerView.prototype.cd = function (a, b, c) {
        var d = a;
        var e = d.content;
        var f = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        d.ct = 1;
        var g = d.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        d.ct = 0;
        return g;
    };
    ItemToolTipLayerView.prototype.cc = function (a, b, c, d, e) {
        var f = null;
        if (this.e.bs != null) {
            f = this.e.bs.bn.i.i();
        }
        var g = a;
        g.ap = f;
        var h = g.content;
        g.cn = { $type: Point_$type, x: d, y: e };
        g._visibility = 0;
        g.n = b;
        g.o = c;
    };
    ItemToolTipLayerView.prototype.ca = function (a) {
        if (a != null) {
            var b = a;
            b._visibility = 1;
        }
    };
    ItemToolTipLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            return;
        }
        var c = 0;
        var d = 0;
        var e = this.e.bs;
        if (e != null) {
            var f = e.bn.i.b6();
            c += f.x;
            d += f.y;
        }
        for (var g = 0; g < this.b4.count; g++) {
            this.b4._inner[g].bu(this.b4._inner[g].n + c, this.b4._inner[g].o + d);
        }
    };
    ItemToolTipLayerView.prototype.ai = function (a) {
        var e_2, _a;
        _super.prototype.ai.call(this, a);
        try {
            for (var _b = __values(fromEnum(this.b2.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var tooltip_ = _c.value;
                if (tooltip_._visibility != 0) {
                    continue;
                }
                var b = tooltip_;
                var c = b.a3();
                var d = b.n;
                var e = b.o;
                var f = new List$1(String_$type, 0);
                var g = typeCast(DomWrapper_$type, b.content);
                if (g != null) {
                    var h = g.getText();
                    f.add(h);
                }
                this.e.a2.addPointerTooltipData(a, c, d, e, f);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    ItemToolTipLayerView.prototype.cb = function () {
        for (var a = 0; a < this.b4.count; a++) {
            this.ca(this.b4._inner[a]);
        }
    };
    ItemToolTipLayerView.$t = markType(ItemToolTipLayerView, 'ItemToolTipLayerView', AnnotationLayerView.$);
    return ItemToolTipLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an annotation layer that displays tooltips for all target series individually.
*/
var IgrItemToolTipLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrItemToolTipLayer, _super);
    function IgrItemToolTipLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrItemToolTipLayer.prototype.createImplementation = function () {
        return new ItemToolTipLayer();
    };
    Object.defineProperty(IgrItemToolTipLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrItemToolTipLayer.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
        */
        get: function () {
            return this.i.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrItemToolTipLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing the tooltips.
        */
        get: function () {
            return this.i.m8;
        },
        set: function (v) {
            this.i.m8 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrItemToolTipLayer.prototype, "skipUnknownValues", {
        /**
         * Gets or sets whether to skip past unknown values when searching for series values.
        */
        get: function () {
            return this.i.m7;
        },
        set: function (v) {
            this.i.m7 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    IgrItemToolTipLayer.prototype.hideToolTips = function () {
        this.i.ia();
    };
    return IgrItemToolTipLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrItemToolTipLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrItemToolTipLayerModule() {
    }
    IgrItemToolTipLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrItemToolTipLayer", IgrItemToolTipLayer);
        TypeRegistrar.register("ItemToolTipLayer", ItemToolTipLayer.$type);
    };
    return IgrItemToolTipLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisAnnotationFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisAnnotationFrame, _super);
    function AxisAnnotationFrame() {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.h = null;
        _this.g = null;
        _this.m = null;
        _this.j = null;
        _this.l = null;
        _this.k = null;
        _this.i = null;
        _this.y = null;
        _this.s = null;
        _this.r = null;
        _this.x = null;
        _this.u = null;
        _this.w = null;
        _this.v = null;
        _this.t = null;
        _this.p = null;
        _this.aa = null;
        _this.o = null;
        _this.z = null;
        _this.f = null;
        _this.q = null;
        _this.n = new List$1(Brush.$, 0);
        _this.g = new List$1(Brush.$, 0);
        _this.h = new List$1(Brush.$, 0);
        _this.j = new List$1(Number_$type, 0);
        _this.k = new List$1(Number_$type, 0);
        _this.l = new List$1(Number_$type, 0);
        _this.i = new List$1(Number_$type, 0);
        _this.m = new List$1(Number_$type, 0);
        _this.y = new List$1(Brush.$, 0);
        _this.r = new List$1(Brush.$, 0);
        _this.s = new List$1(Brush.$, 0);
        _this.u = new List$1(Number_$type, 0);
        _this.v = new List$1(Number_$type, 0);
        _this.w = new List$1(Number_$type, 0);
        _this.t = new List$1(Number_$type, 0);
        _this.x = new List$1(Number_$type, 0);
        _this.f = new List$1(Axis.$, 0);
        _this.q = new List$1(Axis.$, 0);
        _this.p = new List$1(Number_$type, 0);
        _this.o = new List$1(Number_$type, 0);
        _this.aa = new List$1(Number_$type, 0);
        _this.z = new List$1(Number_$type, 0);
        return _this;
    }
    AxisAnnotationFrame.ab = function (a, b, c, d) {
        var e = c.count;
        var f = d.count;
        var g = Math.max(e, f);
        var h = 1 - b;
        if (a.count < g) {
            var i = new Array(g - a.count);
            for (var j = 0; j < g - a.count; j++) {
                i[j] = null;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (var k = 0; k < Math.min(e, f); ++k) {
            if (b == 0) {
                a._inner[k] = c._inner[k];
            }
            else {
                a._inner[k] = d._inner[k];
            }
        }
        if (e < f) {
            var l = e > 0 ? c._inner[e - 1] : null;
            for (var m = e; m < f; ++m) {
                if (b == 0) {
                    a._inner[m] = l;
                }
                else {
                    a._inner[m] = d._inner[m];
                }
            }
        }
        if (e > f) {
            var n = f > 0 ? d._inner[f - 1] : null;
            for (var o = f; o < e; ++o) {
                if (b == 0) {
                    a._inner[o] = c._inner[o];
                }
                else {
                    a._inner[o] = n;
                }
            }
        }
    };
    AxisAnnotationFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        FrameExtended.a(this.n, a, d.n, e.n, 0);
        FrameExtended.a(this.g, a, d.g, e.g, 0);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        Frame.b(this.j, a, d.j, e.j);
        Frame.b(this.k, a, d.k, e.k);
        Frame.b(this.l, a, d.l, e.l);
        Frame.b(this.i, a, d.i, e.i);
        Frame.b(this.m, a, d.m, e.m);
        FrameExtended.a(this.y, a, d.y, e.y, 0);
        FrameExtended.a(this.r, a, d.r, e.r, 0);
        FrameExtended.a(this.s, a, d.s, e.s, 0);
        Frame.b(this.u, a, d.u, e.u);
        Frame.b(this.v, a, d.v, e.v);
        Frame.b(this.w, a, d.w, e.w);
        Frame.b(this.t, a, d.t, e.t);
        Frame.b(this.x, a, d.x, e.x);
        AxisAnnotationFrame.ab(this.f, a, d.f, e.f);
        AxisAnnotationFrame.ab(this.q, a, d.q, e.q);
    };
    AxisAnnotationFrame.$t = markType(AxisAnnotationFrame, 'AxisAnnotationFrame', Frame.$);
    return AxisAnnotationFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisAnnotation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisAnnotation, _super);
    function AxisAnnotation() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propertyChanged = null;
        _this.k = false;
        _this._formatLabel = null;
        _this.j = false;
        return _this;
    }
    AxisAnnotation.prototype.resetCachedExtent = function () {
        this.k = true;
    };
    AxisAnnotation.prototype.checkForExtentReset = function (a) {
        if (this.k) {
            this.k = false;
            a();
        }
    };
    AxisAnnotation.prototype.aa = function (a, b, c) {
        this.z(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    AxisAnnotation.prototype.z = function (a, b, c) {
        this.j = true;
    };
    AxisAnnotation.prototype.resolveLabelValue = function () {
        if (this.text != null) {
            return this.text;
        }
        if (this.formatLabel != null) {
            return this.formatLabel(this.value);
        }
        if (this.value == null) {
            return null;
        }
        return this.value.toString();
    };
    Object.defineProperty(AxisAnnotation.prototype, "formatLabel", {
        get: function () {
            return this._formatLabel;
        },
        set: function (a) {
            this._formatLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisAnnotation.prototype, "backgroundPadding", {
        get: function () {
            return new Thickness(1, this.backgroundPaddingLeft, this.backgroundPaddingTop, this.backgroundPaddingRight, this.backgroundPaddingBottom);
        },
        set: function (a) {
            this.backgroundPaddingLeft = a.left;
            this.backgroundPaddingTop = a.top;
            this.backgroundPaddingRight = a.right;
            this.backgroundPaddingBottom = a.bottom;
        },
        enumerable: true,
        configurable: true
    });
    AxisAnnotation.$t = markType(AxisAnnotation, 'AxisAnnotation', DependencyObject.$, [INotifyPropertyChanged_$type, IAxisAnnotation_$type]);
    AxisAnnotation.$$p = markDep(DependencyProperty, PropertyMetadata, AxisAnnotation, 'aa', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [Brush.$, null], 'Outline', [Brush.$, null], 'StrokeThickness', [1, 0], 'TextColor', [Brush.$, null], 'Text', [2, null], 'Value', [4, null]]);
    return AxisAnnotation;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LinearCategorySnapper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LinearCategorySnapper, _super);
    function LinearCategorySnapper(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.g = 0;
        _this.h = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = [c, d, e, NaN, 0, f];
                    {
                        var i = g[0];
                        var j = g[1];
                        var k = g[2];
                        var l = g[3];
                        var m = g[4];
                        var n = g[5];
                        if (n > 0) {
                            _this.f = n;
                            _this.b = true;
                        }
                        _this.g = l;
                        _this.h = 0;
                        var o = Math.min(10, truncate((k / _this.f)));
                        if (o > 0) {
                            var p = _this.i(i, j, o);
                            if (_this.b && p > o) {
                                _this.g = l;
                                p = _this.i(i, j, o - 1);
                            }
                            o = p;
                            if (k / o > _this.f * 10) {
                                _this.h = 10;
                            }
                            else {
                                if (k / o > _this.f * 5) {
                                    _this.h = 5;
                                }
                                else {
                                    if (k / o > _this.f * 2) {
                                        _this.h = 2;
                                    }
                                }
                            }
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    var h = _rest[5];
                    if (h > 0) {
                        _this.f = h;
                        _this.b = true;
                    }
                    _this.g = f;
                    _this.h = 0;
                    var i = Math.min(10, truncate((e / _this.f)));
                    if (i > 0) {
                        var j = _this.i(c, d, i);
                        if (_this.b && j > i) {
                            _this.g = f;
                            j = _this.i(c, d, i - 1);
                        }
                        i = j;
                        if (e / i > _this.f * 10) {
                            _this.h = 10;
                        }
                        else {
                            if (e / i > _this.f * 5) {
                                _this.h = 5;
                            }
                            else {
                                if (e / i > _this.f * 2) {
                                    _this.h = 2;
                                }
                            }
                        }
                    }
                }
                break;
        }
        return _this;
    }
    LinearCategorySnapper.prototype.i = function (a, b, c) {
        var d = Snapper.e(b - a, false);
        if (isNaN_(this.g)) {
            this.g = Snapper.e(d / (c - 1), true);
        }
        if (this.g < 1) {
            this.g = 1;
        }
        var e = Math.floor(a / this.g) * this.g;
        var f = Math.ceil(b / this.g) * this.g;
        var g = truncate(Math.round((f - e) / this.g));
        return g;
    };
    LinearCategorySnapper.$t = markType(LinearCategorySnapper, 'LinearCategorySnapper', Snapper.$);
    return LinearCategorySnapper;
}(Snapper));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available scaling behaviors of a numeric axis.
 */
var NumericScaleMode = /*@__PURE__*/ (function (NumericScaleMode) {
    /**
     * Scale values on a linear number line.
     */
    NumericScaleMode[NumericScaleMode["Linear"] = 0] = "Linear";
    /**
     * Scale values on a logarithmic number line.
     */
    NumericScaleMode[NumericScaleMode["Logarithmic"] = 1] = "Logarithmic";
    return NumericScaleMode;
})({});
/**
 * @hidden
 */
var NumericScaleMode_$type = /*@__PURE__*/ markEnum('NumericScaleMode', 'Linear,0|Logarithmic,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LogarithmicScaler, _super);
    function LogarithmicScaler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ae = 0;
        _this.ad = 0;
        return _this;
    }
    LogarithmicScaler.prototype.w = function (a, b, c) {
        _super.prototype.w.call(this, a, b, c);
        switch (a) {
            case NumericScaler.$$p[1]:
                this.ae = Math.log(this.l);
                break;
            case NumericScaler.$$p[0]:
                this.ad = Math.log(this.k);
                break;
        }
    };
    LogarithmicScaler.prototype.t = function (a, b, c, d, e) {
        var f;
        var g;
        var h = AutoRangeCalculator.a(a, b, c, true, a.kg, f, g);
        f = h.p5;
        g = h.p6;
        d = f;
        e = g;
        return {
            p3: d,
            p4: e
        };
    };
    LogarithmicScaler.$t = markType(LogarithmicScaler, 'LogarithmicScaler', NumericScaler.$);
    return LogarithmicScaler;
}(NumericScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StraightNumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StraightNumericAxisBase, _super);
    function StraightNumericAxisBase() {
        var _this = _super.call(this) || this;
        _this.le = null;
        _this.li = false;
        _this.ls();
        return _this;
    }
    StraightNumericAxisBase.prototype.a1 = function () {
        return new StraightNumericAxisBaseView(this);
    };
    StraightNumericAxisBase.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.lh = a;
    };
    Object.defineProperty(StraightNumericAxisBase.prototype, "lg", {
        get: function () {
            return this.c(StraightNumericAxisBase.lu);
        },
        set: function (a) {
            this.h(StraightNumericAxisBase.lu, a);
        },
        enumerable: true,
        configurable: true
    });
    StraightNumericAxisBase.lq = function (a, b) {
        var c = typeCast(StraightNumericAxisBase.$, a);
        c.ls();
        c.g0("Scaler", b.oldValue, b.newValue);
    };
    StraightNumericAxisBase.prototype.lf = function () {
        return null;
    };
    StraightNumericAxisBase.prototype.get_ld = function () {
        if (this.le == null) {
            this.ls();
        }
        return this.le;
    };
    StraightNumericAxisBase.prototype.set_ld = function (a) {
        var b = this.le != a;
        if (b) {
            var c = this.le;
            this.le = a;
            this.g0("ActualScaler", c, a);
        }
    };
    Object.defineProperty(StraightNumericAxisBase.prototype, "ld", {
        get: function () {
            return this.get_ld();
        },
        set: function (a) {
            this.set_ld(a);
        },
        enumerable: true,
        configurable: true
    });
    StraightNumericAxisBase.prototype.kz = function (a, b, c, d, e, f, g) {
        var h = this.ld.t(a, b, c, f, g);
        f = h.p3;
        g = h.p4;
        return {
            p5: f,
            p6: g
        };
    };
    StraightNumericAxisBase.prototype.lr = function (a) {
        var b = this.li;
        this.li = true;
        a();
        this.li = b;
    };
    StraightNumericAxisBase.prototype.ls = function () {
        var a = this.lg;
        if (a == null) {
            a = this.ji();
        }
        this.ld = a;
        if (this.ld == null) {
            throw new ArgumentNullException(0, "ActualScaler");
        }
        this.ln();
    };
    StraightNumericAxisBase.prototype.ln = function () {
        this.lh.bh();
    };
    StraightNumericAxisBase.prototype.gu = function (a, b, c, d) {
        if (this.li) {
            return;
        }
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[2]:
                this.ls();
                break;
            case NumericAxisBase.$$p[1]:
                this.ls();
                break;
            case StraightNumericAxisBase.$$p[0]:
                this.ls();
                break;
            case "Scaler":
                this.ls();
                break;
            case "ActualScaler":
                this.jp = typeCast(LogarithmicScaler.$, this.ld) !== null;
                this.ln();
                this.cl();
                this.g6(false);
                break;
            case "ActualMaximumValue":
                this.lo();
                break;
            case "ActualMinimumValue":
                this.lp();
                this.ls();
                break;
        }
    };
    StraightNumericAxisBase.prototype.lp = function () {
        this.ld.y(this.j4);
    };
    StraightNumericAxisBase.prototype.lo = function () {
        this.ld.x(this.j3);
    };
    StraightNumericAxisBase.prototype.lj = function (a, b) {
        if (a < this.j4) {
            a = this.j4;
        }
        else if (a > this.j3) {
            a = this.j3;
        }
        if (!b.cf) {
            return (a - this.j4) / (this.j3 - this.j4);
        }
        else {
            return (a - this.j3) / (this.j4 - this.j3);
        }
    };
    StraightNumericAxisBase.$t = markType(StraightNumericAxisBase, 'StraightNumericAxisBase', NumericAxisBase.$);
    StraightNumericAxisBase.lu = DependencyProperty.i("Scaler", NumericScaler.$, StraightNumericAxisBase.$, new PropertyMetadata(2, null, StraightNumericAxisBase.lq));
    StraightNumericAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, StraightNumericAxisBase, 'g0', ['ScaleMode:lc:lt', [NumericScaleMode_$type, enumGetBox(NumericScaleMode_$type, 0)]]);
    return StraightNumericAxisBase;
}(NumericAxisBase));
/**
 * @hidden
 */
var StraightNumericAxisBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StraightNumericAxisBaseView, _super);
    function StraightNumericAxisBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    StraightNumericAxisBaseView.prototype.bh = function () {
        this.bg.ld.x(this.bg.j3);
        this.bg.ld.y(this.bg.j4);
    };
    StraightNumericAxisBaseView.$t = markType(StraightNumericAxisBaseView, 'StraightNumericAxisBaseView', NumericAxisBaseView.$);
    return StraightNumericAxisBaseView;
}(NumericAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VerticalLogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalLogarithmicScaler, _super);
    function VerticalLogarithmicScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VerticalLogarithmicScaler.prototype.q = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.ag(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ag(a, b.e, b.d, b.a);
    };
    VerticalLogarithmicScaler.prototype.p = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.af(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.af(a, b.e, b.d, b.a);
    };
    VerticalLogarithmicScaler.prototype.af = function (a, b, c, d) {
        if (isNaN_(a)) {
            return NaN;
        }
        var e;
        if (a <= 0) {
            e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
        }
        else {
            e = (Math.log(a) - this.ae) / (this.ad - this.ae);
        }
        if (!d) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    };
    VerticalLogarithmicScaler.prototype.ag = function (a, b, c, d) {
        var e = b.top + b.height * (a - c.top) / c.height;
        if (!d) {
            e = 1 - e;
        }
        return Math.exp(e * (this.ad - this.ae) + this.ae);
    };
    VerticalLogarithmicScaler.$t = markType(VerticalLogarithmicScaler, 'VerticalLogarithmicScaler', LogarithmicScaler.$);
    return VerticalLogarithmicScaler;
}(LogarithmicScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LinearScaler, _super);
    function LinearScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LinearScaler.prototype.t = function (a, b, c, d, e) {
        var f;
        var g;
        var h = AutoRangeCalculator.a(a, b, c, false, -1, f, g);
        f = h.p5;
        g = h.p6;
        d = f;
        e = g;
        return {
            p3: d,
            p4: e
        };
    };
    LinearScaler.$t = markType(LinearScaler, 'LinearScaler', NumericScaler.$);
    return LinearScaler;
}(NumericScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VerticalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalLinearScaler, _super);
    function VerticalLinearScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VerticalLinearScaler.prototype.q = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.ae(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ae(a, b.e, b.d, b.a);
    };
    VerticalLinearScaler.prototype.p = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.ad(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.ad(a, b.e, b.d, b.a);
    };
    VerticalLinearScaler.prototype.v = function (a, b, c, d) {
        var e;
        var f = d.e;
        var g = d.d;
        var h = d.c;
        var i = d.a;
        var j = !h.isEmpty;
        var k = this.m;
        var l = this.o;
        var m = h.top;
        var n = h.height;
        var o = f.top;
        var p = f.height;
        var q = g.top;
        var r = g.height;
        var s = 0;
        var t = 1;
        var u = ArrayAccessHelper.b(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        for (var w = b; w < c; w++) {
            if (v) {
                e = u[w];
            }
            else {
                e = a.item(w);
            }
            if (j) {
                var x = (e - l) / (k);
                if (!i) {
                    x = 1 - x;
                }
                x = m + n * (x - s) / t;
                var y = (x - (o * r)) / p;
                if (v) {
                    u[w] = y;
                }
                else {
                    a.item(w, y);
                }
            }
            else {
                var z = (e - l) / (k);
                if (!i) {
                    z = 1 - z;
                }
                z = q + r * (z - o) / p;
                if (v) {
                    u[w] = z;
                }
                else {
                    a.item(w, z);
                }
            }
        }
    };
    VerticalLinearScaler.prototype.ad = function (a, b, c, d) {
        var e = (a - this.o) / (this.m);
        if (!d) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    };
    VerticalLinearScaler.prototype.ae = function (a, b, c, d) {
        var e = b.top + b.height * (a - c.top) / c.height;
        if (!d) {
            e = 1 - e;
        }
        return this.o + e * (this.m);
    };
    VerticalLinearScaler.$t = markType(VerticalLinearScaler, 'VerticalLinearScaler', LinearScaler.$);
    return VerticalLinearScaler;
}(LinearScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FastVerticalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FastVerticalLinearScaler, _super);
    function FastVerticalLinearScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FastVerticalLinearScaler.prototype.u = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.m;
        var m = this.o;
        var n = i.top;
        var o = i.height;
        var p = g.top;
        var q = g.height;
        var r = h.top;
        var s = h.height;
        var t = 0;
        var u = 1;
        var v = ArrayAccessHelper.a(a);
        var w = false;
        if (v != null) {
            w = true;
        }
        var x;
        for (var y = 0; y < b.count; y++) {
            x = b.item(y);
            for (var z = c; z < d; z++) {
                if (w) {
                    f = v[z];
                }
                else {
                    f = a.item(z);
                }
                if (k) {
                    var aa = (f[x] - m) / (l);
                    if (!j) {
                        aa = 1 - aa;
                    }
                    aa = n + o * (aa - t) / u;
                    var ab = (aa - (p * s)) / q;
                    f[x] = ab;
                }
                else {
                    var ac = (f[x] - m) / (l);
                    if (!j) {
                        ac = 1 - ac;
                    }
                    ac = r + s * (ac - p) / q;
                    f[x] = ac;
                }
            }
        }
    };
    FastVerticalLinearScaler.$t = markType(FastVerticalLinearScaler, 'FastVerticalLinearScaler', VerticalLinearScaler.$);
    return FastVerticalLinearScaler;
}(VerticalLinearScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumericYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericYAxis, _super);
    function NumericYAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericYAxis.$;
        _this.jf = _this.jd();
        return _this;
    }
    NumericYAxis.prototype.a1 = function () {
        return new NumericYAxisView(this);
    };
    NumericYAxis.prototype.as = function () {
        return new VerticalAxisLabelPanel();
    };
    NumericYAxis.prototype.get_cf = function () {
        return true;
    };
    NumericYAxis.prototype.dv = function () {
        return this.i1.height;
    };
    NumericYAxis.prototype.dw = function (a, b) {
        if (this.le != null) {
            return this.le.p(a, b);
        }
        return this.ld.p(a, b);
    };
    NumericYAxis.prototype.gn = function (a, b, c, d) {
        if (this.le != null) {
            this.le.v(a, b, c, d);
            return;
        }
        this.ld.v(a, b, c, d);
    };
    NumericYAxis.prototype.gm = function (a, b, c, d, e) {
        if (this.le != null) {
            this.le.u(a, b, c, d, e);
            return;
        }
        this.ld.u(a, b, c, d, e);
    };
    NumericYAxis.prototype.dz = function (a, b) {
        if (this.le != null) {
            return this.le.q(a, b);
        }
        return this.ld.q(a, b);
    };
    NumericYAxis.prototype.go = function (a, b, c, d) {
        if (this.le != null) {
            this.le.j(a, b, c, d);
            return;
        }
        this.ld.j(a, b, c, d);
    };
    NumericYAxis.prototype.lv = function (a, b) {
        if (this.bf == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.lj(a, this);
        var d = this.lj(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bf.m4 = new Rect(0, this.bf.m4.x, d, this.bf.m4.width, c - d);
    };
    NumericYAxis.prototype.jd = function () {
        var _this = this;
        var a = _super.prototype.jd.call(this);
        a.b.c = function (b) {
            if (_this.aw == null || _this.aw.visibility == 0) {
                _this.at.a8 = b;
                if (_this.aw != null && (_this.aw.location == 7 || _this.aw.location == 6)) {
                    _this.bf.ht();
                }
            }
        };
        a.k = function (b, c, d) { return _this.gq(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.gr(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.b9, d);
            return _this.dw(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.hf(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = _this.aw != null && (_this.aw.location == 7 || _this.aw.location == 3) ? b.z.right : b.z.left;
            var c = b.y;
            var d = new ScalerParams(0, b.aa, b.z, _this.b9, c);
            if (_this.ag != null && _this.ag.bf != null) {
                var e = b.n;
                var f = b.r;
                var g = _this.ha(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    };
    NumericYAxis.prototype.jg = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.jg.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.b8, c);
        var h = NaN;
        var i = NaN;
        if (!this.b8 && b.top == 0) {
            i = this.j3;
        }
        else if (this.b8 && b.bottom == 1) {
            h = this.j3;
        }
        if (isNaN_(h)) {
            h = this.dz(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.dz(e.top, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.j7 = j;
        this.j6 = k;
        var l = ((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    };
    NumericYAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = this.i1;
        var d = this.iw();
        var e = this.iv();
        var f = this.jf.c(a, c, b, d, e);
        if (f != null) {
            this.j2 = f.f.m;
            this.j5 = f.f.l;
        }
    };
    NumericYAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        if (b.height != a.height) {
            this.cl();
        }
    };
    NumericYAxis.prototype.get_az = function () {
        return 1;
    };
    Object.defineProperty(NumericYAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    NumericYAxis.prototype.ji = function () {
        if (this.jt) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.lc) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    };
    NumericYAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    NumericYAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    NumericYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    NumericYAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    NumericYAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(NumericYAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericYAxis;
}(StraightNumericAxisBase));
/**
 * @hidden
 */
var NumericYAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericYAxisView, _super);
    function NumericYAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bi = null;
        _this.bi = a;
        return _this;
    }
    NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);
    return NumericYAxisView;
}(StraightNumericAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxis, _super);
    function CategoryXAxis() {
        var _this = _super.call(this) || this;
        _this.k9 = 1;
        _this.k8 = 1;
        _this.kz = 0;
        _this.k0 = 0;
        _this.jm = new List$1(Number_$type, 0);
        _this.ab = CategoryXAxis.$;
        return _this;
    }
    CategoryXAxis.prototype.a1 = function () {
        return new CategoryXAxisView(this);
    };
    CategoryXAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.kx = a;
    };
    Object.defineProperty(CategoryXAxis.prototype, "lb", {
        get: function () {
            return this.k9;
        },
        set: function (a) {
            this.k9 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "la", {
        get: function () {
            return this.k8;
        },
        set: function (a) {
            this.k8 = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.as = function () {
        if (this.cp) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    CategoryXAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.iz(b, c);
        return d.width / (this.jy * a.width);
    };
    CategoryXAxis.prototype.jr = function (a, b, c) {
        var d = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.jv)) {
            e = Math.min(this.jv, 1);
        }
        else {
            e = 0;
        }
        ;
        var f = 1 - 0.5 * d;
        var g = this.j1 == 0 ? 1 : this.j1;
        var h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    };
    CategoryXAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.j1 > 1) {
            var f = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.jv)) {
                g = Math.min(this.jv, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.j1 - (this.j1 - 1) * g);
            var j = (h - i) / (this.j1 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryXAxis.prototype.dj = function () {
        return this.k6;
    };
    CategoryXAxis.prototype.lg = function (a) {
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        b = b.copy();
        var c = this.i1;
        var d = this.iy();
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, e, e, this.b8, d);
        var g = !b.isEmpty && !c.isEmpty && this.jf != null ? this.jf.indexOf(a) : -1;
        var h = g > -1 ? this.dw(g, f) : NaN;
        if (!isNaN_(h) && this.bf.c0) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.bf.km(b, false, true);
        }
    };
    CategoryXAxis.prototype.dw = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.k5(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.k5(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.kw = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryXAxis.prototype.gm = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.jy - 1 : this.jy;
        if (l < 0) {
            l = 0;
        }
        var m = i.left;
        var n = i.width;
        var o = g.left;
        var p = g.width;
        var q = h.left;
        var r = h.width;
        var s = 0;
        var t = 1;
        var u = this.kw(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    var aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    CategoryXAxis.prototype.dx = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = this.k5(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.k5(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.k5 = function (a, b, c, d) {
        var e = d == 0 ? this.jy - 1 : this.jy;
        if (e < 0) {
            e = 0;
        }
        var f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.b9) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    };
    CategoryXAxis.prototype.dz = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryXAxis.prototype.d0 = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + (a - c.left) * b.width / c.width;
        if (this.b9) {
            e = 1 - e;
        }
        var f = d == 0 ? this.jy - 1 : this.jy;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryXAxis.prototype.lh = function (a, b) {
        if (a == NaN || b == NaN || this.jf == null || this.jf.count == 0) {
            return;
        }
        var c = a / this.jf.count;
        var d = (b + 1) / this.jf.count;
        this.bf.m4 = new Rect(0, c, this.bf.m4.y, d - c, this.bf.m4.height);
    };
    CategoryXAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = this.i1;
        var d = this.iw();
        var e = this.iv();
        var f = new ScalerParams(0, b, c, this.b8, d);
        var g = this.a2.ay();
        var h = this.a2.a1();
        var i = this.a2.az();
        var j = this.a2.a0();
        var k = this.a2.e();
        var l = this.a2.f();
        var m = this.a2.g();
        var n = this.jf;
        var o = this.ky();
        this.he();
        this.gi(g);
        this.gi(h);
        this.gi(i);
        this.gi(j);
        this.cv.clear();
        this.cw.clear();
        this.jm.clear();
        this.a2.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
        }
        if (this.bo.count == 0 && this.bn.count == 0) {
            this.a2.y();
        }
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
            this.a2.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var p = this.dz(e.left, f);
            var q = this.dz(e.right, f);
            if (this.b8) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            var r = c.bottom;
            var s = r - c.top;
            if (this.ag != null) {
                var t = typeCast(NumericYAxis.$, this.ag);
                if (t != null) {
                    var u = this.ha(r, s, b, c, d, c.top, c.bottom);
                    r = u.p0;
                    s = u.p1;
                }
            }
            this.gq(g, r, c, k, true);
            this.a2.ao(s);
            var v = Math.min(p, q);
            var w = Math.max(p, q);
            var x = new LinearCategorySnapper(1, v, w, e.width, this.k6, this.categoryMode, this.d9());
            var y = Math.floor((v - 0) / x.g);
            var z = Math.ceil((w - 0) / x.g);
            this.k1 = x.g;
            if (!isNaN_(y) && !isNaN_(z)) {
                var aa = truncate(y);
                var ab = truncate(z);
                var ac = this.k4(0 + aa * x.g, f);
                var ad = this.dw(x.g, f);
                var ae = Math.abs(ad - this.dw(0, f));
                this.a2.ap(ad);
                var af = truncate(Math.ceil(e.right));
                var ag = truncate(Math.floor(e.left));
                var ah = this.k7;
                var ai = ah > 0 && ah < x.g;
                var aj = c.right;
                var ak = this.jm;
                var al = x.g;
                var am = truncate(al);
                var an = this.j1;
                var ao = this.b8;
                var ap = this.categoryMode;
                for (var aq = aa; aq <= ab; ++aq) {
                    var ar = this.k4(0 + (aq + 1) * x.g, f);
                    if (ac <= aj) {
                        if (aq % 2 == 0) {
                            this.hg(h, ac, ar, c);
                        }
                        this.hf(i, ac, c, l, false);
                        ak.add(ac);
                    }
                    if (this.categoryMode != 0 && this.j1 != 0 && this.cj) {
                        if (ai) {
                            var as = ae * this.k7;
                            if (this.b8) {
                                var at = ac;
                                while (at - as > ar) {
                                    at -= as;
                                    if (Math.abs(at - ar) < 0.0001) {
                                        break;
                                    }
                                    this.hf(j, at, c, m, false);
                                }
                            }
                            else {
                                var au = ac;
                                while (au + as < ar) {
                                    au += as;
                                    if (Math.abs(au - ar) < 0.0001) {
                                        break;
                                    }
                                    this.hf(j, au, c, m, false);
                                }
                            }
                            this.k2 = this.k7;
                        }
                        else {
                            for (var av = 0; av < truncate(x.g); av++) {
                                for (var aw = 0; aw < this.j1; aw++) {
                                    var ax = this.getGroupCenter(aw, b, c, d);
                                    if (this.b8) {
                                        ax = -ax;
                                    }
                                    var ay = this.dw(av + aq * x.g, f) + ax;
                                    this.hf(j, ay, c, m, false);
                                }
                            }
                            this.k2 = 0.5;
                        }
                    }
                    var az = this.k3(aq * al, ac, ap == 0, f);
                    var a0 = truncate(Math.round(az));
                    if (a0 >= ag && a0 <= af) {
                        var a1 = 0;
                        if (al >= 1) {
                            a1 = aq * truncate(Math.floor(al));
                        }
                        else {
                            if ((aq * al) * 2 % 2 == 0) {
                                a1 = truncate(Math.floor(aq * al));
                            }
                            else {
                                a1 = -1;
                            }
                        }
                        if (o != null && a1 < n.count && a1 >= 0) {
                            var a2 = o.getItem(a1);
                            var a3 = this.e6(a2);
                            if (!isNaN_(az) && !isInfinity(az) && a3 != null) {
                                if ((typeof a3 === 'string') && Base.equalsStatic(a3, "")) {
                                }
                                else {
                                    this.cv.add1(a3);
                                    this.cw.add(new LabelPosition(az));
                                }
                            }
                        }
                    }
                    ac = ar;
                }
            }
            if ((this.aw == null || this.aw.visibility == 0) && this.ag != null) {
                if (this.aw != null && (this.aw.location == 4 || this.aw.location == 5)) {
                    this.bf.ht();
                }
            }
            this.a2.au(this.cv, this.cw);
            this.km();
        }
    };
    CategoryXAxis.prototype.cn = function () {
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        if (this.jf == null) {
            return false;
        }
        var a = this.jf.count;
        if (a != this.la) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.la, a);
            this.la = a;
            this.g1(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryXAxis.prototype, "k6", {
        get: function () {
            return this.c(CategoryXAxis.li);
        },
        set: function (a) {
            this.h(CategoryXAxis.li, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "k1", {
        get: function () {
            return this.kz;
        },
        set: function (a) {
            if (this.k1 != a) {
                var b = this.kz;
                this.kz = a;
                this.g0("ActualInterval", b, this.k1);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.d7 = function () {
        return this.k1;
    };
    Object.defineProperty(CategoryXAxis.prototype, "k7", {
        get: function () {
            return this.c(CategoryXAxis.lj);
        },
        set: function (a) {
            this.h(CategoryXAxis.lj, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryXAxis.prototype, "k2", {
        get: function () {
            return this.k0;
        },
        set: function (a) {
            if (this.k2 != a) {
                var b = this.k0;
                this.k0 = a;
                this.g0("ActualMinorInterval", b, this.k2);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.ji = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.bb();
        if (b == null) {
            return false;
        }
        return b.synchronizeHorizontally;
    };
    CategoryXAxis.prototype.get_az = function () {
        return 0;
    };
    Object.defineProperty(CategoryXAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.ky = function () {
        return this.jf;
    };
    CategoryXAxis.prototype.k4 = function (a, b) {
        return this.dw(a, b);
    };
    CategoryXAxis.prototype.k3 = function (a, b, c, d) {
        if (!c) {
            var e = this.k4(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    };
    Object.defineProperty(CategoryXAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    CategoryXAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(CategoryXAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
    CategoryXAxis.li = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.g0("Interval", b.oldValue, b.newValue);
        a.g6(false);
    }));
    CategoryXAxis.lj = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryXAxis.$, a)).g0("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryXAxis.$, a)).g6(false);
    }));
    return CategoryXAxis;
}(CategoryAxisBase));
/**
 * @hidden
 */
var CategoryXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryXAxisView, _super);
    function CategoryXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
    return CategoryXAxisView;
}(CategoryAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisAnnotationFrameManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisAnnotationFrameManager, _super);
    function AxisAnnotationFrameManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AxisAnnotationFrameManager.e = function (a, b, c) {
        var d = new Color();
        if (typeCast(LinearGradientBrush.$, a) !== null) {
            if (a.gradientStops == null || a.gradientStops.length < 1) {
                var e = new Brush();
                e.color = b;
                return e;
            }
            d = a.gradientStops[0].color;
        }
        else {
            d = a.color;
        }
        var f = ColorUtil.a(d);
        var g = ColorUtil.a(c);
        var h = ColorUtil.a(b);
        var i = (f[3] + 0.05) / (h[3] + 0.05);
        var j = (g[3] + 0.05) / (f[3] + 0.05);
        if (i > j) {
            var k = new Brush();
            k.color = b;
        }
        var l = new Brush();
        l.color = c;
        return l;
    };
    AxisAnnotationFrameManager.c = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r) {
        var s = c.ag();
        var t = null;
        var u = null;
        for (var v = 0; v < s.length; v++) {
            if (s[v].cf) {
                u = s[v];
            }
            else {
                t = s[v];
            }
        }
        var w = Color.u(255, 102, 102, 102);
        var x = Color.u(255, 255, 255, 255);
        if (t != null) {
            var y = new ScalerParams(1, d.mq, t.i1, t.b8);
            y.c = e;
            var z = t.dz(b.x, y);
            a.p.add(z);
            a.o.add(z);
            if (g != null) {
                a.g.add(g);
            }
            else {
                a.g.add(f);
            }
            if (h != null) {
                a.n.add(h);
            }
            else {
                a.n.add(AxisAnnotationFrameManager.e(a.g._inner[a.g.count - 1], w, x));
            }
            a.j.add(j.left);
            a.l.add(j.top);
            a.k.add(j.right);
            a.i.add(j.bottom);
            if (k != null) {
                a.m.add(k);
            }
            else {
                a.m.add(NaN);
            }
            if (i != null) {
                a.h.add(i);
            }
            else {
                a.h.add(null);
            }
            if (q) {
                a.f.add(t);
            }
            else {
                a.f.add(null);
            }
        }
        if (u != null) {
            var aa = new ScalerParams(1, d.mq, u.i1, u.b8);
            aa.c = e;
            var ab = u.dz(b.y, aa);
            a.aa.add(ab);
            a.z.add(ab);
            if (l != null) {
                a.r.add(l);
            }
            else {
                a.r.add(f);
            }
            if (m != null) {
                a.y.add(m);
            }
            else {
                a.y.add(AxisAnnotationFrameManager.e(a.r._inner[a.r.count - 1], w, x));
            }
            a.u.add(o.left);
            a.w.add(o.top);
            a.v.add(o.right);
            a.t.add(o.bottom);
            if (p != null) {
                a.x.add(p);
            }
            else {
                a.x.add(NaN);
            }
            if (n != null) {
                a.s.add(n);
            }
            else {
                a.s.add(null);
            }
            if (r) {
                a.q.add(u);
            }
            else {
                a.q.add(null);
            }
        }
    };
    AxisAnnotationFrameManager.b = function (a) {
        a.f.clear();
        a.q.clear();
        a.p.clear();
        a.aa.clear();
        a.o.clear();
        a.z.clear();
        a.g.clear();
        a.h.clear();
        a.j.clear();
        a.l.clear();
        a.k.clear();
        a.i.clear();
        a.m.clear();
        a.n.clear();
        a.r.clear();
        a.s.clear();
        a.u.clear();
        a.w.clear();
        a.v.clear();
        a.t.clear();
        a.x.clear();
        a.y.clear();
    };
    AxisAnnotationFrameManager.a = function (a, b, c) {
        if (!b.ca) {
            return a;
        }
        var d = 0;
        if (c >= 0) {
            d = c;
        }
        else {
            var e = b.d7();
            d = e == 0 ? 0 : truncate(Math.max(-Math.floor(log10(e)), 0));
            d += 1;
        }
        return round10N(a, d);
    };
    AxisAnnotationFrameManager.d = function (a, b, c, d, e, f, g, h, i, j) {
        var k = new List$1(Axis.$, 0);
        var l = new HashSet$1(Axis.$, 0);
        var m = new Dictionary$2(Axis.$, Number_$type, 0);
        var _loop_1 = function (n) {
            var o = b.f._inner[n];
            if (o != null) {
                if (!l.contains(o)) {
                    k.add(o);
                    m.item(o, 0);
                    l.add_1(o);
                }
                var p = void 0;
                if (!d.containsKey(o)) {
                    p = new Pool$1(AxisAnnotation.$);
                    p.create = function () { return new AxisAnnotation(); };
                    p.destroy = function (q) {
                    };
                    p.activate = function (q) { return o.al.add(q); };
                    p.disactivate = function (q) { return o.al.remove(q); };
                    d.item(o, p);
                    e.add(o);
                }
                else {
                    p = d.item(o);
                }
                var q = p.item(m.item(o));
                m.item(o, m.item(o) + 1);
                q.j = false;
                q.value = b.o._inner[n];
                var r = b.p._inner[n];
                if (i != null) {
                    var s = i(r);
                    q.text = s;
                }
                else {
                    r = AxisAnnotationFrameManager.a(r, o, g);
                    q.text = o.fj(r);
                }
                q.textColor = b.n._inner[n];
                q.background = b.g._inner[n];
                q.backgroundPadding = new Thickness(1, b.j._inner[n], b.l._inner[n], b.k._inner[n], b.i._inner[n]);
                q.outline = b.h._inner[n];
                q.strokeThickness = b.m._inner[n];
                if (q.j) {
                    q.j = false;
                    c = true;
                }
            }
        };
        for (var n = 0; n < b.p.count; n++) {
            _loop_1(n);
        }
        var _loop_2 = function (t) {
            var u = b.q._inner[t];
            if (u != null) {
                if (!l.contains(u)) {
                    k.add(u);
                    m.item(u, 0);
                    l.add_1(u);
                }
                var v = void 0;
                if (!d.containsKey(u)) {
                    v = new Pool$1(AxisAnnotation.$);
                    v.create = function () { return new AxisAnnotation(); };
                    v.destroy = function (w) {
                    };
                    v.activate = function (w) { return u.al.add(w); };
                    v.disactivate = function (w) { return u.al.remove(w); };
                    d.item(u, v);
                    e.add(u);
                }
                else {
                    v = d.item(u);
                }
                var w = v.item(m.item(u));
                m.item(u, m.item(u) + 1);
                w.j = false;
                var x = b.aa._inner[t];
                w.value = b.z._inner[t];
                if (j != null) {
                    var y = j(x);
                    w.text = y;
                }
                else {
                    x = AxisAnnotationFrameManager.a(x, u, h);
                    w.text = u.fj(x);
                }
                w.textColor = b.y._inner[t];
                w.background = b.r._inner[t];
                w.backgroundPadding = new Thickness(1, b.u._inner[t], b.w._inner[t], b.v._inner[t], b.t._inner[t]);
                w.outline = b.s._inner[t];
                w.strokeThickness = b.x._inner[t];
                if (w.j) {
                    w.j = false;
                    c = true;
                }
            }
        };
        for (var t = 0; t < b.aa.count; t++) {
            _loop_2(t);
        }
        for (var z = 0; z < k.count; z++) {
            if (d.containsKey(k._inner[z])) {
                var aa = d.item(k._inner[z]);
                aa.count = m.item(k._inner[z]);
            }
        }
        for (var ab = e.count - 1; ab >= 0; ab--) {
            if (!l.contains(e._inner[ab])) {
                c = true;
                var ac = d.item(e._inner[ab]);
                ac.count = 0;
                ac.activate = null;
                ac.create = null;
                ac.destroy = null;
                ac.disactivate = null;
                d.removeItem(e._inner[ab]);
                e.removeAt(ab);
            }
        }
        if (c && f) {
            for (var ad = 0; ad < k.count; ad++) {
                var ae = k._inner[ad];
                if (ae.a3.c) {
                    ae.gk(true);
                    ae.a3.c = false;
                }
            }
        }
    };
    AxisAnnotationFrameManager.$t = markType(AxisAnnotationFrameManager, 'AxisAnnotationFrameManager');
    return AxisAnnotationFrameManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlay, _super);
    function ValueOverlay() {
        var _this = _super.call(this) || this;
        _this.mg = 0;
        _this.mh = 0;
        _this.md = 0;
        _this.l1 = null;
        _this.l7 = null;
        _this.l6 = null;
        _this.ab = ValueOverlay.$;
        return _this;
    }
    ValueOverlay.prototype.en = function (a, b, c) {
        return this.mi;
    };
    ValueOverlay.prototype.me = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        var d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    ValueOverlay.prototype.ll = function (a, b, c) {
        if (this.l0 == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.mf();
        var e = NaN;
        var f = NaN;
        var g = NaN;
        var h = { $type: Point_$type, x: 0.5, y: 0.5 };
        var i = NaN;
        switch (this.l0.az) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
            case 3:
                g = this.me(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    };
    ValueOverlay.prototype.e8 = function (a) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.fp = function (a) {
        return this;
    };
    ValueOverlay.prototype.c9 = function (a) {
        return false;
    };
    ValueOverlay.prototype.an = function (a) {
        var b = typeCast(NumericAxisBase.$, a);
        var c = this.mi;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    };
    ValueOverlay.prototype.je = function (a) {
        this.hv(true, this.bi);
        if (!this.l5()) {
            return;
        }
        if (this.da(a)) {
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                var b = this.mg;
                this.mg = this.mh;
                this.mh = b;
            }
            else {
                this.mg = this.md;
            }
            this.md = this.mf();
            this.jl();
        }
        else {
            this.md = this.mf();
            this.mz(this.md, this.l3);
        }
    };
    ValueOverlay.prototype.mf = function () {
        var a, b;
        var c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, a, b, this.l0.b8, d);
        return this.l0.dw(this.mi, e);
    };
    ValueOverlay.prototype.mz = function (a, b) {
        if (this.l0 == null) {
            return;
        }
        var c = typeCast(CategoryAxisBase.$, this.l0);
        if (c != null && !c.b5) {
            if (this.mi > c.jz - 1) {
                return;
            }
            if (c.categoryMode == 2) {
                var d = this.getEffectiveViewport1(b);
                var e = 0.5 * c.getCategorySize(b.bs, b.br, d);
                var f = false;
                if (c.cf && !c.b8) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.b8) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        var g = typeCast(NumericAxisBase.$, this.l0);
        if (g != null) {
            if (this.mi < g.j4 || this.mi > g.j3) {
                return;
            }
            if (g.ju && this.mi < 0) {
                return;
            }
        }
        var h;
        switch (this.l0.az) {
            case 2:
            case 3:
                h = this.l0.it(a, b.bs, b.br, this.getEffectiveViewport1(b), this.lq(b));
                break;
            default:
                h = this.l0.it(a, b.bs, b.br);
                break;
        }
        if (h != null) {
            b.bv(h);
        }
        if (this.l4) {
            this.m0(a, this.ca());
        }
    };
    ValueOverlay.prototype.dw = function (a, b, c) {
        var d = true;
        d = _super.prototype.dw.call(this, a, b, c);
        if (!c.l() || b.isEmpty || a.isEmpty || this.l0 == null || this.l0.bf == null) {
            d = false;
        }
        return d;
    };
    ValueOverlay.prototype.jt = function (a, b) {
        this.jd(false);
    };
    ValueOverlay.prototype.js = function (a, b) {
        this.jd(false);
    };
    ValueOverlay.prototype.hy = function (a, b, c, d) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[10]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.jd(false);
                this.ik();
                break;
            case "TransitionProgress":
                this.mh = this.mg + this.ez * (this.md - this.mg);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.mz(this.md, this.l3);
                }
                else {
                    this.mz(this.mh, this.l3);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case ValueOverlay.$$p[12]:
                var e = typeCast(NumericAxisBase.$, this.l0);
                if (e != null) {
                    e.cl();
                }
                this.jd(true);
                this.il();
                break;
            case ValueOverlay.$$p[11]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[2]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[8]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
                this.jd(true);
                break;
        }
    };
    ValueOverlay.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.l0 != null) {
            this.l0.g6(false);
        }
    };
    ValueOverlay.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.bu();
    };
    ValueOverlay.prototype.l5 = function () {
        if (this.l0 == null || this.l0.bf == null || isNaN_(this.mi) || this._visibility == 1) {
            return false;
        }
        var a = typeCast(CategoryAxisBase.$, this.l0);
        if (a != null && a.jz == 0) {
            return false;
        }
        return true;
    };
    ValueOverlay.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
        get: function () {
            return typeCast(CategoryAxisBase.$, this.l0);
        },
        enumerable: true,
        configurable: true
    });
    ValueOverlay.prototype.bf = function () {
        return new ValueOverlayView(this);
    };
    ValueOverlay.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.l3 = typeCast(ValueOverlayView.$, a);
    };
    ValueOverlay.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh) || !this.l5()) {
            return;
        }
        var c = this.getEffectiveViewport1(this.bi);
        var d = this.l0.dw(this.mi, new ScalerParams(0, this.bh.bs, a, this.l0.b8, c));
        this.mz(d, typeCast(ValueOverlayView.$, this.bh));
        this.dl = false;
    };
    ValueOverlay.prototype.getOffsetValue = function () {
        return 0;
    };
    ValueOverlay.prototype.getCategoryWidth = function () {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "nh", {
        get: function () {
            return new Thickness(1, this.l9, this.mb, this.ma, this.l8);
        },
        enumerable: true,
        configurable: true
    });
    ValueOverlay.prototype.ag = function () {
        return [this.l0];
    };
    ValueOverlay.prototype.m0 = function (a, b) {
        if (isNaN_(a)) {
            return;
        }
        var c = false;
        if (this.l6 == null) {
            c = true;
            this.l7 = new List$1(Axis.$, 0);
            this.l6 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.l1 = new AxisAnnotationFrame();
        var d = this.k3;
        if (d == null) {
            d = this.k5;
        }
        var e = this.l0.cf;
        AxisAnnotationFrameManager.c(this.l1, { $type: Point_$type, x: a, y: a }, this, this.bs, this.getEffectiveViewport(), d, this.ne, this.ng, this.nf, this.nh, this.mc, this.ne, this.ng, this.nf, this.nh, this.mc, !this.l0.cf, this.l0.cf);
        AxisAnnotationFrameManager.d(this, this.l1, c, this.l6, this.l7, b, this.mj, this.mj, this.l2, this.l2);
    };
    ValueOverlay.prototype.get_c6 = function () {
        return true;
    };
    ValueOverlay.prototype.mv = function (a) {
        if (this.l0 != null) {
            return this.l0.fj(a);
        }
        return null;
    };
    Object.defineProperty(ValueOverlay.prototype, "mx", {
        get: function () {
            var a = this.mv(this.mi);
            return a != null ? a : stringFormat("{0:0.##}", this.mi);
        },
        enumerable: true,
        configurable: true
    });
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackground:ne:m1', [Brush.$, null], 'AxisAnnotationFormatLabel:l2:m2', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:mj:m3', [1, -1], 'AxisAnnotationOutline:nf:m4', [Brush.$, null], 'AxisAnnotationPaddingBottom:l8:m5', [1, NaN], 'AxisAnnotationPaddingLeft:l9:m6', [1, NaN], 'AxisAnnotationPaddingRight:ma:m7', [1, NaN], 'AxisAnnotationPaddingTop:mb:m8', [1, NaN], 'AxisAnnotationStrokeThickness:mc:m9', [1, NaN], 'AxisAnnotationTextColor:ng:na', [Brush.$, null], 'Axis:l0:nb', [Axis.$, null], 'IsAxisAnnotationEnabled:l4:nc', [0, false], 'Value:mi:nd', [1, 0]]);
    return ValueOverlay;
}(Series));
/**
 * @hidden
 */
var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlayView, _super);
    function ValueOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.bw = null;
        _this.bw = new Path();
        return _this;
    }
    ValueOverlayView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.bw._stroke = this.e.k3;
        this.bw.ac = this.e.ey;
        this.bw.ai = this.e.lb;
        this.bw.ad = this.e.lc;
    };
    ValueOverlayView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.bw._stroke = a;
        this.bw.ac = this.e.ey + 3;
        this.bw._stroke = a;
        this.bw.ac = this.e.ey + 3;
    };
    ValueOverlayView.prototype.bv = function (a) {
        this.bw.ak = a;
        this.an();
    };
    ValueOverlayView.prototype.bu = function () {
        this.bw.ak = null;
        this.an();
    };
    ValueOverlayView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.bw);
        }
    };
    ValueOverlayView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.bw, "ValueOverlayPath", []);
    };
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Provides data for Axis RangeChanged events.
*
* The `AxisRangeChangedEventArgs` event fire when the axis range changes.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
* 		<IgrCategoryXAxis name="xAxis" label="Date" />
* 		<IgrNumericYAxis  name="yAxis" rangeChanaged={this.yAxisRangeChanged} />
*     <IgrFinancialPriceSeries
* 		name="series2"
* 		xAxisName="xAxis"
* 		yAxisName="yAxis"
* 		displayType="Candlestick"
* 		lowMemberPath="Low"
* 		highMemberPath="High"
* 		openMemberPath="Open"
* 		closeMemberPath="Close"
* 		volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
*   axis.rangeChanged.bind(this.yAxisRangeChanged);
*   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) =>  {
*
*    }
* ```
*/
var IgrAxisRangeChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrAxisRangeChangedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrAxisRangeChangedEventArgs.prototype.createImplementation = function () {
        return new AxisRangeChangedEventArgs(0);
    };
    Object.defineProperty(IgrAxisRangeChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxisRangeChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrAxisRangeChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrAxisRangeChangedEventArgs.prototype, "oldMinimumValue", {
        /**
         * Gets the minimum value before the range changed. The reported minimum is the effective,
         * not the set value.
        *
        * The `oldMinimumValue` property is used to gets the minimum value before the range changed.
        */
        get: function () {
            return this.i.oldMinimumValue;
        },
        set: function (v) {
            this.i.oldMinimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisRangeChangedEventArgs.prototype, "minimumValue", {
        /**
         * Gets the minimum value after the range changed. The reported minimum is the effective,
         * not the set value.
        *
        * The `minimumValue` property is used to getsthe minimum value after the range changed.
        *
        * ```ts
        *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
        * 	let maxVal= e.maximumValue
        * 	let minVal= e.minimumValue
        *
        *     }
        * ```
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisRangeChangedEventArgs.prototype, "oldMaximumValue", {
        /**
         * Gets the maximum value before the range changed. The reported maximum is the effective,
         * not the set value.
        *
        * The `oldMaximumValue` property is used to gets the maximum value before the range changed.
        */
        get: function () {
            return this.i.oldMaximumValue;
        },
        set: function (v) {
            this.i.oldMaximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisRangeChangedEventArgs.prototype, "maximumValue", {
        /**
         * Gets the maximum value after the range changed. The reported maximum is the effective,
         * not the set value.
        *
        * The `maximumValue` property is used to gets the maximum value after the range changed.
        *
        * ```ts
        *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
        * 	let maxVal= e.maximumValue
        * 	let minVal= e.minimumValue
        *
        *     }
        * ```
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAxisRangeChangedEventArgs;
}());

/**
 * Represents an axis annotation
*/
var IgrAxisAnnotation = /** @class */ /*@__PURE__*/ (function () {
    function IgrAxisAnnotation() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrAxisAnnotation.prototype.createImplementation = function () {
        return new AxisAnnotation();
    };
    Object.defineProperty(IgrAxisAnnotation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxisAnnotation.prototype.onImplementationCreated = function () {
    };
    IgrAxisAnnotation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrAxisAnnotation.prototype, "value", {
        /**
         * Gets or sets the value at which this annotation is displayed on the axis.
        */
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "text", {
        /**
         * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
        */
        get: function () {
            return this.i.text;
        },
        set: function (v) {
            this.i.text = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
        */
        get: function () {
            return this.i.formatLabel;
        },
        set: function (v) {
            this.i.formatLabel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text in the annotation.
        */
        get: function () {
            return brushToString(this.i.textColor);
        },
        set: function (v) {
            this.i.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "background", {
        /**
         * Gets or sets the background to use for tha axis annotation box.
        */
        get: function () {
            return brushToString(this.i.background);
        },
        set: function (v) {
            this.i.background = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "outline", {
        /**
         * Gets or sets the Outline to use for tha axis annotation box.
        */
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "strokeThickness", {
        /**
         * Gets or sets the border stroke thickness to use for tha axis annotation box.
        */
        get: function () {
            return this.i.strokeThickness;
        },
        set: function (v) {
            this.i.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "backgroundPaddingLeft", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingLeft;
        },
        set: function (v) {
            this.i.backgroundPaddingLeft = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "backgroundPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingTop;
        },
        set: function (v) {
            this.i.backgroundPaddingTop = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "backgroundPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingRight;
        },
        set: function (v) {
            this.i.backgroundPaddingRight = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxisAnnotation.prototype, "backgroundPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingBottom;
        },
        set: function (v) {
            this.i.backgroundPaddingBottom = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxisAnnotation.prototype.resetCachedExtent = function () {
        this.i.resetCachedExtent();
    };
    IgrAxisAnnotation.prototype.resolveLabelValue = function () {
        var iv = this.i.resolveLabelValue();
        return (iv);
    };
    return IgrAxisAnnotation;
}());

var IgrAxisAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAxisAnnotationCollection, _super);
    function IgrAxisAnnotationCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrAxisAnnotation.$type) {
            IgrAxisAnnotation.$type = markType(IgrAxisAnnotation, "AxisAnnotation");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrAxisAnnotationCollection.prototype._createInnerColl = function () {
        if (!IgrAxisAnnotation.$type) {
            IgrAxisAnnotation.$type = markType(IgrAxisAnnotation, "AxisAnnotation");
        }
        var coll = new SyncableObservableCollection$2(IgrAxisAnnotation.$type, IAxisAnnotation_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrAxisAnnotation();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    };
    return IgrAxisAnnotationCollection;
}(IgCollection));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents the base class from which all axis types are derived.
*
* The `IgrAxis` is an array of axis objects.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*  </IgrDataChart>
* ```
*/
var IgrAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAxis, _super);
    function IgrAxis(props) {
        var _this = _super.call(this, props) || this;
        _this._renderer = null;
        _this._annotations = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._rangeChanged = null;
        _this._rangeChanged_wrapped = null;
        _this._renderRequested = null;
        _this._renderRequested_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    Object.defineProperty(IgrAxis.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.onImplementationCreated = function () {
    };
    IgrAxis.prototype.componentDidMount = function () {
        var e_1, _a;
        {
            try {
                for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var p = _c.value;
                    {
                        if (isValidProp(this, p)) {
                            {
                                this[p] = this.props[p];
                            }
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    Object.defineProperty(IgrAxis.prototype, "crossingAxisName", {
        get: function () {
            return this._crossingAxisName;
        },
        set: function (value) {
            this._crossingAxisName = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "axisInternal", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.createImplementation = function () {
        return null;
    };
    IgrAxis.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrAxis.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrAxis.prototype, "name", {
        get: function () {
            return this.i.name;
        },
        set: function (value) {
            this.i.name = value;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.provideData = function (data) {
    };
    IgrAxis.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
    };
    IgrAxis._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrAxis.prototype, "isCategory", {
        /**
     * Gets or sets if the current axis is of category axis type
    */
        get: function () {
            return this.i.b2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isNumeric", {
        /**
         * Gets or sets if the current axis is of numeric axis type
        *
        *     Gets or sets if the current axis is of numeric axis type
        */
        get: function () {
            return this.i.ca;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isAngular", {
        /**
         * Gets if the current axis is of angular axis type
        */
        get: function () {
            return this.i.b0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isRadial", {
        /**
         * Gets or sets if the current axis is of radial axis type
        */
        get: function () {
            return this.i.cc;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isVertical", {
        /**
         * Gets if the current axis is a vertical axis.
        */
        get: function () {
            return this.i.cf;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isSorting", {
        /**
         * Gets or sets if the current axis is sorting data items
        */
        get: function () {
            return this.i.cd;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isDateTime", {
        /**
         * Gets or sets if the current axis is of date time axis type
        */
        get: function () {
            return this.i.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isPiecewise", {
        /**
         * Gets or sets if the axis is a piecewise scaling function.
        */
        get: function () {
            return this.i.cb;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isCategoryDateTime", {
        /**
         * Gets if the current axis is of category date time axis type
        */
        get: function () {
            return this.i.b3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isContinuous", {
        /**
         * Gets if the current axis is a continuous rather than a discrete scale
        */
        get: function () {
            return this.i.b4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        *
        * The `formatLabel` function takes an object that produces a formatted label for displaying in the chart.
        *
        * ```ts
        * <IgrDataChart dataSource={this.data}   >
        *     <IgrCategoryXAxis
        * 		name="xAxis"
        * 		FormatLabel="xAxis_FormatLabel" />
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ar;
        },
        set: function (v) {
            this.i.ar = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "title", {
        /**
         * Gets or sets the Title property.
        *
        * Use `title` property to display the title of the component.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return this.i.f7;
        },
        set: function (v) {
            this.i.f7 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "stroke", {
        /**
         * Gets or sets the Stroke property.
         * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
        *
        * Use `stroke` property to set the stroke of the chart.
        *
        * ```ts
        * <IgrCategoryChart
        *         ref={this.onChartRef}
        *         width="100%"
        *         height="100%"
        *         dataSource={this.data}
        *         titleTopMargin={5}
        *         xAxisStroke="gray"/>
        * ```
        */
        get: function () {
            return brushToString(this.i.im);
        },
        set: function (v) {
            this.i.im = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "actualStroke", {
        /**
         * Gets or sets the effective stroke used for the axis.
        */
        get: function () {
            return brushToString(this.i.ii);
        },
        set: function (v) {
            this.i.ii = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "strokeThickness", {
        /**
         * Gets or sets the StrokeThickness property.
        *
        * Use `strokeThickness` property for the thickness of the stroke.
        *
        * ```ts
        * <IgrCategoryChart
        *         ref={this.onChartRef}
        *         width="100%"
        *         height="100%"
        *         dataSource={this.data}
        *         titleTopMargin={5}
        *         xAxisStrokeThickness={2}>
        * ```
        */
        get: function () {
            return this.i.en;
        },
        set: function (v) {
            this.i.en = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "strip", {
        /**
         * Gets or sets the Strip property.
        *
        * Use `strip` property to set the strip of the chart.
        *
        * ```ts
        * <IgrCategoryChart
        *         ref={this.onChartRef}
        *         width="100%"
        *         height="100%"
        *         dataSource={this.data}
        *         titleTopMargin={5}
        *         xAxisStrip="gray"/>
        * ```
        */
        get: function () {
            return brushToString(this.i.il);
        },
        set: function (v) {
            this.i.il = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "majorStroke", {
        /**
         * Gets or sets the MajorStroke property.
         * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
        *
        * Gets or sets the `majorStroke` using this property.
        *
        * ```ts
        * <IgrNumericYAxis name="yAxis"
        *     interval={100}
        *     majorStroke="black"
        *     majorStrokeThickness={1}
        *     minorInterval={25}
        *     minorStroke="gray"
        *     minorStrokeThickness={0.5} />
        * ```
        */
        get: function () {
            return brushToString(this.i.ij);
        },
        set: function (v) {
            this.i.ij = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "actualMajorStroke", {
        /**
         * Gets or sets the ActualMajorStroke property.
        *
        * The `actualMajorStroke` property is used for ActualMajorStroke of the axis.
        */
        get: function () {
            return brushToString(this.i.ig);
        },
        set: function (v) {
            this.i.ig = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "majorStrokeThickness", {
        /**
         * Gets or sets the MajorStrokeThickness property.
        *
        * Gets or sets the `majorStrokeThickness` using this property.
        *
        * ```ts
        * <IgrNumericYAxis name="yAxis"
        *     interval={100}
        *     majorStroke="black"
        *     majorStrokeThickness={1}
        *     minorInterval={25}
        *     minorStroke="gray"
        *     minorStrokeThickness={0.5} />
        * ```
        */
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "minorStroke", {
        /**
         * Gets or sets the MinorStroke property.
        *
        * Gets or sets the minorStroke thickness using `minorStrokeThickness` property.
        *
        * ```ts
        * <IgrNumericYAxis name="yAxis"
        *     interval={100}
        *     majorStroke="black"
        *     majorStrokeThickness={1}
        *     minorInterval={25}
        *     minorStroke="gray"
        *     minorStrokeThickness={0.5} />
        * ```
        */
        get: function () {
            return brushToString(this.i.ik);
        },
        set: function (v) {
            this.i.ik = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "actualMinorStroke", {
        /**
         * Gets or sets the ActualMinorStroke property.
        *
        * The `actualMinorStroke` property is used for ActualMinorStroke of the axis.
        */
        get: function () {
            return brushToString(this.i.ih);
        },
        set: function (v) {
            this.i.ih = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "minorStrokeThickness", {
        /**
         * Gets or sets the MinorStrokeThickness property.
        */
        get: function () {
            return this.i.d6;
        },
        set: function (v) {
            this.i.d6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "tickStroke", {
        /**
         * Gets or sets the TickStroke property.
        *
        * Use `tickStroke` property for the color of the tickmarks.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     tickLength={10}
        *     tickStrokeThickness={0.5}
        *     tickStroke="black" />
        * ```
        */
        get: function () {
            return brushToString(this.i.io);
        },
        set: function (v) {
            this.i.io = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "tickStrokeThickness", {
        /**
         * Gets or sets the TickStrokeThickness property.
        *
        * Use `tickStrokeThickness` property for thickness of the stroke tickmarks.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     tickLength={10}
        *     tickStrokeThickness={0.5}
        *     tickStroke="black" />
        * ```
        */
        get: function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "tickLength", {
        /**
         * Gets or sets the TickLength property.
        *
        * Use `tickLength` property for The length of the tickmarks to display for this axis.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     tickLength={10}
        *     tickStrokeThickness={0.5}
        *     tickStroke="black" />
        * ```
        */
        get: function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isDisabled", {
        /**
         * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
        *
        * The `isDisabled` property is used to decide if the axis will not be rendered.
        */
        get: function () {
            return this.i.b6;
        },
        set: function (v) {
            this.i.b6 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "isInverted", {
        /**
         * Gets or sets the IsInverted property.
        *
        * Gets or sets the `isInverted` property.
        */
        get: function () {
            return this.i.b8;
        },
        set: function (v) {
            this.i.b8 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "useEnhancedIntervalManagement", {
        /**
         * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
        *
        * Use `useEnhancedIntervalManagement` property to gets/sets whether to use more advanced heuristics when determining the initial number of labels to render,
        * before resolving collisions, etc.
        */
        get: function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "enhancedIntervalMinimumCharacters", {
        /**
         * Gets or sets the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
        *
        * The `enhancedIntervalMinimumCharacters` property is used to set the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics.
        */
        get: function () {
            return this.i.ex;
        },
        set: function (v) {
            this.i.ex = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelTextStyle", {
        /**
         * Gets or sets the text style to use for axis labels.
        *
        * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		titleTextStyle="12pt Verdana" />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return this.i.aw ? this.i.aw.textStyle : null;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.textStyle = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelTextColor", {
        /**
         * The color of the {0}.
        *
        * The `labelTextColor` property Overrides the color of the text used for the axis labels.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		labelTextColor="gray"  />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return brushToString(this.i.aw ? this.i.aw.textColor : null);
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelLocation", {
        /**
         * Gets or sets the location of the {0}.
        *
        * The `Location` property is used for the location.
        */
        get: function () {
            return this.i.aw ? this.i.aw.location : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.location = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelVisibility", {
        /**
         * Gets or sets the visibility of the {0}.
        *
        * The `Visibility` property is used for the visibility of the axis.
        */
        get: function () {
            return this.i.aw ? this.i.aw.visibility : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.visibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelShowFirstLabel", {
        /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        *
        * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
        */
        get: function () {
            return this.i.aw ? this.i.aw.showFirstLabel : false;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.showFirstLabel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelAngle", {
        /**
         * Gets or sets the angle of the {0}.
        *
        * The `Angle` property is used to set the angle of the axis.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		titleAngle={90} />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return this.i.aw ? this.i.aw.angle : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.angle = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelExtent", {
        /**
         * Distance between the axis and the edge of the control.
        *
        * The `Extent` property is used for the extent.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"/>
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.aw ? this.i.aw.extent : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.extent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelLeftMargin", {
        /**
         * Margin applied to the left of the {0}.
        *
        * The `labelLeftMargin` property is used for the left margin of the labels.
        */
        get: function () {
            return this.i.aw ? this.i.aw.leftMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.leftMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelRightMargin", {
        /**
         * Margin applied to the right of the {0}.
        *
        * The `labelRightMargin` property is used for the right margin of the labels.
        */
        get: function () {
            return this.i.aw ? this.i.aw.rightMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.rightMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelTopMargin", {
        /**
         * Margin applied above the {0}.
        *
        * The `labelTopMargin` property is used for the top margin of the labels.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     label="Country"
        *     labelTextStyle="9pt Verdana"
        *     labelTopMargin={5}
        *     labelTextColor="gray" />
        * ```
        */
        get: function () {
            return this.i.aw ? this.i.aw.topMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.topMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelBottomMargin", {
        /**
         * Margin applied below the {0}.
        *
        * The `labelBottomMargin` is used to set the bottom margin of the labels.
        */
        get: function () {
            return this.i.aw ? this.i.aw.bottomMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.bottomMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment of the {0}.
        *
        * The `HorizontalAlignment` property is used for the horizontal alignment.
        */
        get: function () {
            return this.i.aw ? this.i.aw.horizontalAlignment : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "labelVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment of the {0}.
        *
        * The `VerticalAlignment` property is used for the vertical alignment of the axis.
        */
        get: function () {
            return this.i.aw ? this.i.aw.verticalAlignment : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.aw.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.ensureLabelSettings = function () {
        if (this.i.aw) {
            return;
        }
        this.i.aw = new AxisLabelSettings();
        this.i.aw.location = this.i.ax();
        this.i.aw.angle = this.i.dk();
        this.i.aw.leftMargin = this.i.dm();
        this.i.aw.rightMargin = this.i.dn();
        this.i.aw.topMargin = this.i.dp();
        this.i.aw.bottomMargin = this.i.dl();
        this.i.aw.horizontalAlignment = this.i.id();
        this.i.aw.verticalAlignment = this.i.i8();
    };
    Object.defineProperty(IgrAxis.prototype, "crossingAxis", {
        /**
         * Gets or sets the CrossingAxis property.
        *
        * The `crossingAxis` property is used for CrossingAxis .
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis"
        * 		 crossingAxisName= "xAxis"
        * 		crossingValue= {700}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            if (this.i.ag == null) {
                return null;
            }
            if (!this.i.ag.externalObject) {
                var e = IgrAxis._createFromInternal(this.i.ag);
                if (e) {
                    e._implementation = this.i.ag;
                }
                this.i.ag.externalObject = e;
            }
            return this.i.ag.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ag = null : this.i.ag = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "crossingValue", {
        /**
         * Gets or sets the CrossingValue property.
        *
        * The `crossingValue` property is used for CrossingValue of the axis.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis"
        * 		 crossingAxis= "xAxis"
        * 		crossingValue= {700}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.e2;
        },
        set: function (v) {
            this.i.e2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titlePosition", {
        /**
         * Gets or sets the title position relative to the axis labels.
        */
        get: function () {
            return this.i.bc ? this.i.bc.position : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.position = ensureEnum(AxisTitlePosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleTextStyle", {
        /**
         * Gets or sets the text style to use for axis labels.
        *
        * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		titleTextStyle="12pt Verdana" />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return this.i.bc ? this.i.bc.textStyle : null;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.textStyle = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleTextColor", {
        /**
         * The color of the {0}.
        *
        * The `labelTextColor` property Overrides the color of the text used for the axis labels.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		labelTextColor="gray"  />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return brushToString(this.i.bc ? this.i.bc.textColor : null);
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleLocation", {
        /**
         * Gets or sets the location of the {0}.
        *
        * The `Location` property is used for the location.
        */
        get: function () {
            return this.i.bc ? this.i.bc.location : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.location = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleVisibility", {
        /**
         * Gets or sets the visibility of the {0}.
        *
        * The `Visibility` property is used for the visibility of the axis.
        */
        get: function () {
            return this.i.bc ? this.i.bc.visibility : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.visibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleShowFirstLabel", {
        /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        *
        * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
        */
        get: function () {
            return this.i.bc ? this.i.bc.showFirstLabel : false;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.showFirstLabel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleAngle", {
        /**
         * Gets or sets the angle of the {0}.
        *
        * The `Angle` property is used to set the angle of the axis.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"
        * 		titleAngle={90} />
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     title="Country"
        *     titleTextColor="gray"
        *     titleTextStyle="12pt Verdana"
        *     titleAngle={90} />
        * ```
        */
        get: function () {
            return this.i.bc ? this.i.bc.angle : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.angle = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleExtent", {
        /**
         * Distance between the axis and the edge of the control.
        *
        * The `Extent` property is used for the extent.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		label="Year"/>
        *     <IgrNumericYAxis  name="yAxis" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.bc ? this.i.bc.extent : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.extent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleLeftMargin", {
        /**
         * Margin applied to the left of the {0}.
        *
        * The `labelLeftMargin` property is used for the left margin of the labels.
        */
        get: function () {
            return this.i.bc ? this.i.bc.leftMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.leftMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleRightMargin", {
        /**
         * Margin applied to the right of the {0}.
        *
        * The `labelRightMargin` property is used for the right margin of the labels.
        */
        get: function () {
            return this.i.bc ? this.i.bc.rightMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.rightMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleTopMargin", {
        /**
         * Margin applied above the {0}.
        *
        * The `labelTopMargin` property is used for the top margin of the labels.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     label="Country"
        *     labelTextStyle="9pt Verdana"
        *     labelTopMargin={5}
        *     labelTextColor="gray" />
        * ```
        */
        get: function () {
            return this.i.bc ? this.i.bc.topMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.topMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleBottomMargin", {
        /**
         * Margin applied below the {0}.
        *
        * The `labelBottomMargin` is used to set the bottom margin of the labels.
        */
        get: function () {
            return this.i.bc ? this.i.bc.bottomMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.bottomMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment of the {0}.
        *
        * The `HorizontalAlignment` property is used for the horizontal alignment.
        */
        get: function () {
            return this.i.bc ? this.i.bc.horizontalAlignment : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "titleVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment of the {0}.
        *
        * The `VerticalAlignment` property is used for the vertical alignment of the axis.
        */
        get: function () {
            return this.i.bc ? this.i.bc.verticalAlignment : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.bc.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.ensureTitleSettings = function () {
        if (this.i.bc) {
            return;
        }
        this.i.bc = new TitleSettings();
        this.i.bc.location = this.i.ay();
        this.i.bc.angle = this.i.dq();
        this.i.bc.leftMargin = this.i.ds();
        this.i.bc.rightMargin = this.i.dt();
        this.i.bc.topMargin = this.i.du();
        this.i.bc.bottomMargin = this.i.dr();
        this.i.bc.horizontalAlignment = this.i.ie();
        this.i.bc.verticalAlignment = this.i.i9();
    };
    Object.defineProperty(IgrAxis.prototype, "annotations", {
        /**
         * Gets the current annotations for the axis.
        */
        get: function () {
            if (this._annotations === null) {
                var coll = new IgrAxisAnnotationCollection();
                var innerColl = this.i.ak;
                if (!innerColl) {
                    innerColl = new AxisAnnotationCollection();
                }
                this._annotations = coll._fromInner(innerColl);
            }
            return this._annotations;
        },
        set: function (v) {
            if (this._annotations !== null) {
                this._annotations._setSyncTarget(null);
                this._annotations = null;
            }
            var coll = new IgrAxisAnnotationCollection();
            this._annotations = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(IAxisAnnotation_$type);
            var innerColl = this.i.ak;
            if (!innerColl) {
                innerColl = new AxisAnnotationCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._annotations._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "coercionMethods", {
        /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be re-imported into the chart.
        *
        * The	`coercionMethods` methods is to use when loading data from data sources. Should be specified before setting any member paths, if being used.
        * Setting it later will not cause data to be reimported into the chart.
        */
        get: function () {
            return this.i.coercionMethods;
        },
        set: function (v) {
            this.i.coercionMethods = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "expectFunctions", {
        /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        */
        get: function () {
            return this.i.expectFunctions;
        },
        set: function (v) {
            this.i.expectFunctions = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "label", {
        /**
         * Gets or sets the axis label format string.
        *
        * The `label` property is used for label mapping of the axis labels.
        *
        * ```ts
        * <IgrCategoryXAxis name="xAxis"
        *     label="Country"
        *     labelTextStyle="9pt Verdana"
        *     labelTopMargin={5}
        *     labelTextColor="gray" />
        * ```
        */
        get: function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrAxis.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrAxis.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Axis");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this.crossingAxis && this.crossingAxis._styling) {
            this.crossingAxis._styling(container, component, this);
        }
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Renders the axis with no animation.

*/
    IgrAxis.prototype.renderAxis = function () {
        this.i.g5();
    };
    /**
     * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
    
    */
    IgrAxis.prototype.resetCachedEnhancedInterval = function () {
        this.i.g8();
    };
    IgrAxis.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.e4(item, memberPathName);
        return (iv);
    };
    /**
     * Gets the label for a data item.
    
    * @param value  * The unscaled value to get a label for.
    */
    IgrAxis.prototype.getValueLabel = function (value) {
        var iv = this.i.fj(value);
        return (iv);
    };
    /**
     * Scales a value from axis space into screen space.
    
    * @param unscaledValue  * The unscaled axis value to scale.
    */
    IgrAxis.prototype.scaleValue = function (unscaledValue) {
        var iv = this.i.eb(unscaledValue);
        return (iv);
    };
    Object.defineProperty(IgrAxis.prototype, "rangeChanged", {
        /**
         * Occurs when the axis range changes.
        */
        get: function () {
            return this._rangeChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._rangeChanged_wrapped !== null) {
                this.i.rangeChanged = delegateRemove(this.i.rangeChanged, this._rangeChanged_wrapped);
                this._rangeChanged_wrapped = null;
                this._rangeChanged = null;
            }
            this._rangeChanged = ev;
            this._rangeChanged_wrapped = function (o, e) {
                var outerArgs = new IgrAxisRangeChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRangeChanged) {
                    _this.beforeRangeChanged(_this, outerArgs);
                }
                if (_this._rangeChanged) {
                    _this._rangeChanged(_this, outerArgs);
                }
            };
            this.i.rangeChanged = delegateCombine(this.i.rangeChanged, this._rangeChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAxis.prototype, "renderRequested", {
        /**
         * This event is raised every time a render has been requested from a series.
        */
        get: function () {
            return this._renderRequested;
        },
        set: function (ev) {
            var _this = this;
            if (this._renderRequested_wrapped !== null) {
                this.i.renderRequested = delegateRemove(this.i.renderRequested, this._renderRequested_wrapped);
                this._renderRequested_wrapped = null;
                this._renderRequested = null;
            }
            this._renderRequested = ev;
            this._renderRequested_wrapped = function (o, e) {
                var outerArgs = new IgrRenderRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeRenderRequested) {
                    _this.beforeRenderRequested(_this, outerArgs);
                }
                if (_this._renderRequested) {
                    _this._renderRequested(_this, outerArgs);
                }
            };
            this.i.renderRequested = delegateCombine(this.i.renderRequested, this._renderRequested_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrAxis;
}(Component));

/**
 * Represents the class of the value overlay. The value overlay is a line or circle representing a value on an axis.
*/
var IgrValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrValueOverlay, _super);
    function IgrValueOverlay(props) {
        var _this = _super.call(this, props) || this;
        _this._axisName = null;
        return _this;
    }
    IgrValueOverlay.prototype.createImplementation = function () {
        return new ValueOverlay();
    };
    Object.defineProperty(IgrValueOverlay.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axis", {
        /**
         * Gets or sets the axis used by the value overlay.
        */
        get: function () {
            if (this.i.l0 == null) {
                return null;
            }
            if (!this.i.l0.externalObject) {
                var e = IgrAxis._createFromInternal(this.i.l0);
                if (e) {
                    e._implementation = this.i.l0;
                }
                this.i.l0.externalObject = e;
            }
            return this.i.l0.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l0 = null : this.i.l0 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisName", {
        /**
        * Gets or sets the name to use to resolve axis from markup.
        */
        get: function () {
            return this._axisName;
        },
        set: function (v) {
            this._axisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "value", {
        /**
         * Gets or sets the value of the overlay.
        */
        get: function () {
            return this.i.mi;
        },
        set: function (v) {
            this.i.mi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "isAxisAnnotationEnabled", {
        /**
         * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
        */
        get: function () {
            return this.i.l4;
        },
        set: function (v) {
            this.i.l4 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationFormatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for the axis annotation.
        */
        get: function () {
            return this.i.l2;
        },
        set: function (v) {
            this.i.l2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationTextColor", {
        /**
         * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.ng);
        },
        set: function (v) {
            this.i.ng = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationBackground", {
        /**
         * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.ne);
        },
        set: function (v) {
            this.i.ne = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationInterpolatedValuePrecision", {
        /**
         * Gets or sets the precision to use displaying values for interpolated positions.
        */
        get: function () {
            return this.i.mj;
        },
        set: function (v) {
            this.i.mj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationOutline", {
        /**
         * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.nf);
        },
        set: function (v) {
            this.i.nf = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationPaddingLeft", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.l9;
        },
        set: function (v) {
            this.i.l9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.mb;
        },
        set: function (v) {
            this.i.mb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.ma;
        },
        set: function (v) {
            this.i.ma = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.l8;
        },
        set: function (v) {
            this.i.l8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "axisAnnotationStrokeThickness", {
        /**
         * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.mc;
        },
        set: function (v) {
            this.i.mc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "isValueOverlay", {
        /**
         * Gets whether the series is a value overlay.
        */
        get: function () {
            return this.i.c6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueOverlay.prototype, "labelResolved", {
        get: function () {
            return this.i.mx;
        },
        enumerable: true,
        configurable: true
    });
    IgrValueOverlay.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.axisName && this.axisName.length > 0 &&
                axes[i].name == this.axisName) {
                this.axis = axes[i];
            }
        }
    };
    IgrValueOverlay.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.axis && this.axis._styling) {
            this.axis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrValueOverlay.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrValueOverlay.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Gets the item item index associated with the specified world position
    
    * @param world
    */
    IgrValueOverlay.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrValueOverlay.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    */
    IgrValueOverlay.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Gets the label for a data item.
    
    * @param value  * The unscaled value to get a label for.
    */
    IgrValueOverlay.prototype.getLabel = function (value) {
        var iv = this.i.mv(value);
        return (iv);
    };
    return IgrValueOverlay;
}(IgrSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrValueOverlayModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrValueOverlayModule() {
    }
    IgrValueOverlayModule.register = function () {
        TypeRegistrar.registerCons("IgrValueOverlay", IgrValueOverlay);
        TypeRegistrar.register("ValueOverlay", ValueOverlay.$type);
    };
    return IgrValueOverlayModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IAnnotationInfoProvider_$type = /*@__PURE__*/ new Type(null, 'IAnnotationInfoProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnnotationInfoProvider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationInfoProvider, _super);
    function AnnotationInfoProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnnotationInfoProvider.$t = markType(AnnotationInfoProvider, 'AnnotationInfoProvider');
    return AnnotationInfoProvider;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisAnnotationManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisAnnotationManager, _super);
    function AxisAnnotationManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._owner = null;
        return _this;
    }
    Object.defineProperty(AxisAnnotationManager.prototype, "owner", {
        get: function () {
            return this._owner;
        },
        set: function (a) {
            this._owner = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisAnnotationManager.prototype.onAddAnnotations = function (a) {
        var b = 0;
        for (var c = 0; c < a.al.count; c++) {
            b = this.a(a, a.al._inner[c], b);
        }
        for (var d = 0; d < a.ak.count; d++) {
            b = this.a(a, a.ak._inner[d], b);
        }
        a.bm.count = b;
        a.bn.count = b;
    };
    AxisAnnotationManager.prototype.a = function (a, b, c) {
        var d = NaN;
        d = b.value;
        var e = new LabelPosition(a.eb(d));
        if (a.b3) {
            var f = a;
            if (f.categoryMode == 2) {
                var g = a.bf.mq;
                var h = a.i1;
                var i = a.iw();
                e.c += a.b8 ? -f.getCategorySize(g, h, i) * 0.5 : f.getCategorySize(g, h, i) * 0.5;
            }
        }
        var j = e.c;
        if (a.cf) {
            if (e.c > a.i1.bottom || e.c < a.i1.top) {
                return c;
            }
        }
        else {
            if (e.c > a.i1.right || e.c < a.i1.left) {
                return c;
            }
        }
        var k = a.bm.item(c);
        var l = a.bn.item(c);
        var m = 100 + c * 2;
        c++;
        l.ak = b.resolveLabelValue();
        if (b.textColor != null) {
            l.am = b.textColor;
        }
        k._fill = b.background;
        k._stroke = b.outline;
        k.ac = b.strokeThickness;
        k.s = m;
        l.s = m + 1;
        b.checkForExtentReset(function () { return e.b = true; });
        e.a = true;
        e.d = b.backgroundPadding;
        a.cw.add(e);
        a.cv.add1(l.ak);
        return c;
    };
    AxisAnnotationManager.prototype.arrangeAnnotations = function (a, b, c, d, e, f, g, h, i, j) {
        for (var k = 0; k < a.bn.count; k++) {
            var l = a.bm.item(k);
            var m = -1;
            for (var n = c.count - 1; n >= 0; n--) {
                if (c._inner[n] == a.bn.item(k)) {
                    m = n;
                    break;
                }
            }
            if (m == -1) {
                continue;
            }
            if (e) {
                b.z(l, a.bn.item(k), a.cw._inner[m], d._inner[m], g, h, i, j);
                b.aq(l, a.bn.item(k), a.cw._inner[m], d._inner[m], g, h, i, j, f);
            }
            else {
                b.z(l, a.bn.item(k), a.cw._inner[m], d._inner[m], g, h, i, j);
            }
        }
    };
    AxisAnnotationManager.prototype.b = function (a, b) {
        this.owner.cg = true;
        this.owner.g5();
    };
    AxisAnnotationManager.prototype.c = function (a) {
        if (a.oldItems != null) {
            for (var b = 0; b < a.oldItems.count; b++) {
                var c = a.oldItems.item(b);
                if (c == null) {
                    continue;
                }
                var d = c;
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
            }
        }
        if (a.newItems != null) {
            for (var e = 0; e < a.newItems.count; e++) {
                var f = a.newItems.item(e);
                if (f == null) {
                    continue;
                }
                var g = f;
                g.propertyChanged = delegateCombine(g.propertyChanged, runOn(this, this.b));
            }
        }
        this.owner.cg = true;
        this.owner.g5();
    };
    AxisAnnotationManager.prototype.onAnnotionsChanged = function (a, b, c) {
        this.c(c);
    };
    AxisAnnotationManager.prototype.onAnnotionsReset = function (a, b, c) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    AxisAnnotationManager.prototype.onAutoAnnotionsChanged = function (a, b, c) {
        this.c(c);
    };
    AxisAnnotationManager.prototype.onAutoAnnotionsReset = function (a, b, c) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    AxisAnnotationManager.$t = markType(AxisAnnotationManager, 'AxisAnnotationManager', Base.$, [IAxisAnnotationManager_$type]);
    return AxisAnnotationManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnnotationFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnnotationFactoryManager, _super);
    function AnnotationFactoryManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnnotationFactoryManager.register = function () {
        if (!AnnotationFactoryManager.a) {
            DVContainer.instance.registerFactory(IAnnotationInfoProvider_$type, function () { return new AnnotationInfoProvider(); });
            DVContainer.instance.registerFactory(IAxisAnnotationManager_$type, function () { return new AxisAnnotationManager(); });
            AnnotationFactoryManager.a = true;
        }
    };
    AnnotationFactoryManager.$t = markType(AnnotationFactoryManager, 'AnnotationFactoryManager');
    AnnotationFactoryManager.a = false;
    return AnnotationFactoryManager;
}(Base));

/**
 * Represents a callout annotation
*/
var IgrCalloutAnnotation = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutAnnotation() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutAnnotation.prototype.createImplementation = function () {
        return new CalloutAnnotation();
    };
    Object.defineProperty(IgrCalloutAnnotation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutAnnotation.prototype.onImplementationCreated = function () {
    };
    IgrCalloutAnnotation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutAnnotation.prototype, "xValue", {
        /**
         * Gets or sets the XValue at which this annotation is displayed on the axis.
        */
        get: function () {
            return this.i.xValue;
        },
        set: function (v) {
            this.i.xValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "yValue", {
        /**
         * Gets or sets the YValue at which this annotation is displayed on the axis.
        */
        get: function () {
            return this.i.yValue;
        },
        set: function (v) {
            this.i.yValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "text", {
        /**
         * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
        */
        get: function () {
            return this.i.text;
        },
        set: function (v) {
            this.i.text = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "key", {
        /**
         * Gets or sets the Key that should be annotated.
        */
        get: function () {
            return this.i.key;
        },
        set: function (v) {
            this.i.key = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "content", {
        /**
         * Gets or sets the Content that should be annotated.
        */
        get: function () {
            return this.i.content;
        },
        set: function (v) {
            this.i.content = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "series", {
        /**
         * Gets or sets the series to which the callout pertains to. Leave unset for an automatic value.
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
        */
        get: function () {
            return this.i.formatLabel;
        },
        set: function (v) {
            this.i.formatLabel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text in the annotation.
        */
        get: function () {
            return brushToString(this.i.textColor);
        },
        set: function (v) {
            this.i.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "background", {
        /**
         * Gets or sets the background to use for tha axis annotation box.
        */
        get: function () {
            return brushToString(this.i.background);
        },
        set: function (v) {
            this.i.background = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "outline", {
        /**
         * Gets or sets the Outline to use for tha axis annotation box.
        */
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "leaderBrush", {
        /**
         * Gets or sets the LeaderBrush to use for tha axis annotation box.
        */
        get: function () {
            return brushToString(this.i.leaderBrush);
        },
        set: function (v) {
            this.i.leaderBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "strokeThickness", {
        /**
         * Gets or sets the border stroke thickness to use for tha axis annotation box.
        */
        get: function () {
            return this.i.strokeThickness;
        },
        set: function (v) {
            this.i.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "backgroundPaddingLeft", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingLeft;
        },
        set: function (v) {
            this.i.backgroundPaddingLeft = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "backgroundPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingTop;
        },
        set: function (v) {
            this.i.backgroundPaddingTop = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "backgroundPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingRight;
        },
        set: function (v) {
            this.i.backgroundPaddingRight = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutAnnotation.prototype, "backgroundPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.backgroundPaddingBottom;
        },
        set: function (v) {
            this.i.backgroundPaddingBottom = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutAnnotation;
}());

var IgrCalloutAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCalloutAnnotationCollection, _super);
    function IgrCalloutAnnotationCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrCalloutAnnotation.$type) {
            IgrCalloutAnnotation.$type = markType(IgrCalloutAnnotation, "IgrCalloutAnnotation");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrCalloutAnnotationCollection.prototype._createInnerColl = function () {
        if (!IgrCalloutAnnotation.$type) {
            IgrCalloutAnnotation.$type = markType(IgrCalloutAnnotation, "IgrCalloutAnnotation");
        }
        var coll = new SyncableObservableCollection$2(IgrCalloutAnnotation.$type, CalloutAnnotation.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrCalloutAnnotation();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrCalloutAnnotationCollection;
}(IgCollection));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutAnnotationCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutAnnotationCollection, _super);
    function CalloutAnnotationCollection() {
        var _this = _super.call(this, CalloutAnnotation.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    CalloutAnnotationCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    CalloutAnnotationCollection.$t = markType(CalloutAnnotationCollection, 'CalloutAnnotationCollection', ObservableCollection$1.$.specialize(CalloutAnnotation.$));
    return CalloutAnnotationCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryHighlightFrameRect = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryHighlightFrameRect, _super);
    function CategoryHighlightFrameRect() {
        var _this = _super.call(this) || this;
        _this.f = 0;
        _this.e = 0;
        _this.b = 0;
        _this.c = 0;
        _this.a = 0;
        _this.g = null;
        _this.h = null;
        _this.d = 0;
        _this.f = 0;
        _this.e = NaN;
        _this.b = NaN;
        _this.c = NaN;
        _this.b = NaN;
        _this.a = NaN;
        _this.d = NaN;
        return _this;
    }
    CategoryHighlightFrameRect.$t = markType(CategoryHighlightFrameRect, 'CategoryHighlightFrameRect');
    return CategoryHighlightFrameRect;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DictInterpolator$3 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DictInterpolator$3, _super);
    function DictInterpolator$3($tKey, $tValue, $tFrame, a, b, c, d) {
        var _this = _super.call(this) || this;
        _this.$tKey = null;
        _this.$tValue = null;
        _this.$tFrame = null;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.$tKey = $tKey;
        _this.$tValue = $tValue;
        _this.$tFrame = $tFrame;
        _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue, _this.$tFrame);
        _this.a = a;
        _this.c = b;
        _this.d = c;
        _this.b = d;
        return _this;
    }
    DictInterpolator$3.prototype.e = function (a, b, c, d, e, f) {
        var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
        var g = new List$1(this.$tKey, 0);
        var _loop_1 = function (h) {
            var i;
            var j;
            var k = a.item(h);
            var l = ((function () { var m = c.tryGetValue(h, i); i = m.p1; return m.ret; })());
            var m = ((function () { var n = d.tryGetValue(h, j); j = n.p1; return n.ret; })());
            if (!l && !m) {
                g.add(h);
            }
            else {
                this_1.a(k, b, i, j, e, f);
                if (!this_1.d(k)) {
                    g.add(h);
                }
            }
        };
        var this_1 = this;
        try {
            for (var _e = __values(fromEnum(a.keys)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var h = _f.value;
                _loop_1(h);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_a = _e.return))
                    _a.call(_e);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _g = __values(fromEnum(g)), _h = _g.next(); !_h.done; _h = _g.next()) {
                var n = _h.value;
                a.removeItem(n);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_h && !_h.done && (_b = _g.return))
                    _b.call(_g);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        var _loop_2 = function (o) {
            var p = c.item(o);
            var q = void 0;
            var r;
            var s = d.tryGetValue(o, q);
            q = s.p1;
            var t = ((function () { var u = a.tryGetValue(o, r); r = u.p1; return u.ret; })());
            if (!t) {
                r = this_2.b();
                this_2.a(r, b, p, q, e, f);
                if (!this_2.d(r)) {
                    return "continue";
                }
                a.addItem(this_2.c(r), r);
            }
        };
        var this_2 = this;
        try {
            for (var _j = __values(fromEnum(c.keys)), _k = _j.next(); !_k.done; _k = _j.next()) {
                var o = _k.value;
                _loop_2(o);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_k && !_k.done && (_c = _j.return))
                    _c.call(_j);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        var _loop_3 = function (u) {
            var v = d.item(u);
            var w;
            var x;
            var y = ((function () { var z = c.tryGetValue(u, w); w = z.p1; return z.ret; })());
            var z = ((function () { var aa = a.tryGetValue(u, x); x = aa.p1; return aa.ret; })());
            if (!z && !y) {
                x = this_3.b();
                this_3.a(x, b, w, v, e, f);
                if (!this_3.d(x)) {
                    return "continue";
                }
                a.addItem(this_3.c(x), x);
            }
        };
        var this_3 = this;
        try {
            for (var _l = __values(fromEnum(d.keys)), _m = _l.next(); !_m.done; _m = _l.next()) {
                var u = _m.value;
                _loop_3(u);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_m && !_m.done && (_d = _l.return))
                    _d.call(_l);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
    };
    DictInterpolator$3.$t = markType(DictInterpolator$3, 'DictInterpolator$3');
    return DictInterpolator$3;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryHighlightLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryHighlightLayerFrame, _super);
    function CategoryHighlightLayerFrame() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.f = null;
        _this.g = new Dictionary$2(Number_$type, CategoryHighlightFrameRect.$, 0);
        _this.f = new DictInterpolator$3(Number_$type, CategoryHighlightFrameRect.$, CategoryHighlightLayerFrame.$, runOn(_this, _this.h), function (a) { return a.f; }, function (a) { return true; }, function () { return new CategoryHighlightFrameRect(); });
        return _this;
    }
    CategoryHighlightLayerFrame.prototype.h = function (a, b, c, d, e, f) {
        if (d != null) {
            a.f = d.f;
        }
        else if (c != null) {
            a.f = c.f;
        }
        else {
            a.f = 0;
        }
        if (c == null || isNaN_(c.e)) {
            a.e = d != null ? d.e : NaN;
        }
        else if (d == null || isNaN_(d.e)) {
            a.e = NaN;
        }
        else {
            a.e = c.e + b * (d.e - c.e);
        }
        if (c == null || isNaN_(c.b)) {
            a.b = d != null ? d.b : NaN;
        }
        else if (d == null || isNaN_(d.b)) {
            a.b = NaN;
        }
        else {
            a.b = c.b + b * (d.b - c.b);
        }
        if (c == null || isNaN_(c.c)) {
            a.c = d != null ? d.c : NaN;
        }
        else if (d == null || isNaN_(d.c)) {
            a.c = NaN;
        }
        else {
            a.c = c.c + b * (d.c - c.c);
        }
        if (c == null || isNaN_(c.a)) {
            a.a = d != null ? d.a : NaN;
        }
        else if (d == null || isNaN_(d.a)) {
            a.a = NaN;
        }
        else {
            a.a = c.a + b * (d.a - c.a);
        }
        if (c == null || isNaN_(c.d)) {
            a.d = d != null ? d.d : NaN;
        }
        else if (d == null || isNaN_(d.d)) {
            a.d = NaN;
        }
        else {
            a.d = c.d + b * (d.d - c.d);
        }
        if (c == null || c.g == null) {
            a.g = d != null ? d.g : null;
        }
        else if (d == null || d.g == null) {
            a.g = null;
        }
        else {
            a.g = BrushUtil.k(c.g, b, d.g, 0);
        }
        if (c == null || c.h == null) {
            a.h = d != null ? d.h : null;
        }
        else if (d == null || d.h == null) {
            a.h = null;
        }
        else {
            a.h = BrushUtil.k(c.h, b, d.h, 0);
        }
    };
    CategoryHighlightLayerFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        this.f.e(this.g, a, d.g, e.g, d, e);
    };
    CategoryHighlightLayerFrame.$t = markType(CategoryHighlightLayerFrame, 'CategoryHighlightLayerFrame', Frame.$);
    return CategoryHighlightLayerFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryHighlightLayer, _super);
    function CategoryHighlightLayer() {
        var _this = _super.call(this) || this;
        var a = new CategoryHighlightLayerFrame();
        var b = new CategoryHighlightLayerFrame();
        var c = new CategoryHighlightLayerFrame();
        var d = _this.fi / 1000;
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = CategoryHighlightLayer.$;
        return _this;
    }
    CategoryHighlightLayer.prototype.bf = function () {
        return new CategoryHighlightLayerView(this);
    };
    CategoryHighlightLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m5 = a;
    };
    Object.defineProperty(CategoryHighlightLayer.prototype, "m8", {
        get: function () {
            return this.c(CategoryHighlightLayer.nf);
        },
        set: function (a) {
            this.h(CategoryHighlightLayer.nf, a);
        },
        enumerable: true,
        configurable: true
    });
    CategoryHighlightLayer.prototype.mk = function (a, b) {
        if (this.m4 == null || this.m4 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    CategoryHighlightLayer.prototype.m6 = function (a) {
        return a != null && a.ce();
    };
    CategoryHighlightLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        c.g.clear();
        var d = this.m7;
        if (isNaN_(this.m1.x) && isNaN_(this.m1.y)) {
            return;
        }
        if (this.m4 != null) {
            if (this.m6(this.m4)) {
                this.nd(this.m4, c, d);
            }
        }
        else {
            if (typeCast(XamDataChart.$, this.bs) !== null) {
                var e = this.bs;
                try {
                    for (var _b = __values(fromEnum(e.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var f = _c.value;
                        if (typeCast(CategoryAxisBase.$, f) !== null && this.m6(f)) {
                            this.nd(f, c, d);
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        }
    };
    CategoryHighlightLayer.prototype.nd = function (a, b, c) {
        if (this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return;
        }
        var d = this.m1.x;
        if (a.cf && isNaN_(d)) {
            d = 0;
        }
        d = this.bi.br.left + this.bi.br.width * (d - this.bi.bs.left) / this.bi.bs.width;
        var e = this.m1.y;
        if (!a.cf && isNaN_(e)) {
            e = 0;
        }
        e = this.bi.br.top + this.bi.br.height * (e - this.bi.bs.top) / this.bi.bs.height;
        var f = a.ku({ $type: Point_$type, x: d, y: e }, c, this.m8);
        this.nc(f, b, a);
    };
    CategoryHighlightLayer.prototype.nc = function (a, b, c) {
        var d = new CategoryHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.g = this.mz();
        d.h = this.m0();
        if (d.g == null) {
            d.g = this.m5.b9(c.ii);
        }
        if (d.h == null) {
            d.h = this.m5.b9(c.ii);
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryHighlightLayer.prototype.mq = function (a, b) {
        var e_2, _a;
        _super.prototype.mq.call(this, a, b);
        var c = this.m5.b2;
        var d = a;
        var e = 0;
        try {
            for (var _b = __values(fromEnum(d.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                var g = c.item(e);
                this.ne(f, g);
                e++;
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.count = e;
    };
    CategoryHighlightLayer.prototype.c8 = function () {
        return true;
    };
    CategoryHighlightLayer.prototype.ne = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.m5.b4(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.g;
        b._stroke = a.h;
        b.ac = a.d;
        if (this.lb != null) {
            b.ai = this.lb;
        }
        else {
            b.ai = null;
        }
        b.ad = this.lc;
    };
    CategoryHighlightLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case CategoryHighlightLayer.$$p[0]:
                this.jd(true);
                break;
            case CategoryHighlightLayer.$$p[1]:
                this.jd(true);
                break;
        }
    };
    CategoryHighlightLayer.$t = markType(CategoryHighlightLayer, 'CategoryHighlightLayer', AnnotationLayer.$);
    CategoryHighlightLayer.nf = DependencyProperty.i("BAndHighlightWidth", Number_$type, CategoryHighlightLayer.$, new PropertyMetadata(2, 10, function (a, b) { return a.raisePropertyChanged("BAndHighlightWidth", b.oldValue, b.newValue); }));
    CategoryHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryHighlightLayer, 'raisePropertyChanged', ['TargetAxis:m4:ng', [CategoryAxisBase.$, null], 'UseInterpolation:m7:nh', [0, false]]);
    return CategoryHighlightLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var CategoryHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryHighlightLayerView, _super);
    function CategoryHighlightLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this.b3 = null;
        _this.b1 = a;
        _this.b3 = new List$1(Rectangle.$, 0);
        return _this;
    }
    CategoryHighlightLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b2 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.ca);
            $ret.activate = runOn(_this, _this.b5);
            $ret.disactivate = runOn(_this, _this.b7);
            $ret.destroy = runOn(_this, _this.b6);
            return $ret;
        })());
    };
    CategoryHighlightLayerView.prototype.ca = function () {
        var a = new Rectangle();
        a.ab = false;
        this.b3.add(a);
        return a;
    };
    CategoryHighlightLayerView.prototype.b5 = function (a) {
        a._visibility = 0;
    };
    CategoryHighlightLayerView.prototype.b7 = function (a) {
        a._visibility = 1;
    };
    CategoryHighlightLayerView.prototype.b6 = function (a) {
        this.b3.remove(a);
    };
    CategoryHighlightLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    CategoryHighlightLayerView.prototype.b9 = function (a) {
        if (a != null) {
            var b = BrushUtil.l(a, 0.3);
            if (b.isGradient) {
                var c = b;
                if (c.gradientStops != null) {
                    for (var d = 0; d < c.gradientStops.length; d++) {
                        var e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.2)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l) * 0.2)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    };
    CategoryHighlightLayerView.prototype.b4 = function (a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    };
    CategoryHighlightLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b3.count; c++) {
                var d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
        }
    };
    CategoryHighlightLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b3.count; b++) {
            this.e.a2.exportRectangleData(a, this.b3._inner[b], "cihRect", ["Main", "CategoryItem"]);
        }
    };
    CategoryHighlightLayerView.$t = markType(CategoryHighlightLayerView, 'CategoryHighlightLayerView', AnnotationLayerView.$);
    return CategoryHighlightLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents the base class for all IgxDataChartComponent category-based axes.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrColumnSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* 	this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
* 	this.columnSeries1.dataSource = this.categoryData;
* 	this.columnSeries1.xAxis = this.categoryXAxis;
* 	this.columnSeries1.yAxis = this.numericYAxis;
* 	this.columnSeries1.xAxisName = "categoryXAxis";
* 	this.columnSeries1.yAxisName = "numericYAxis";
* 	this.columnSeries1.valueMemberPath = "USA";
* ```
*/
var IgrCategoryAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryAxisBase, _super);
    function IgrCategoryAxisBase(props) {
        var _this = _super.call(this, props) || this;
        _this._chartLevelData = null;
        _this._dataSource = null;
        return _this;
    }
    IgrCategoryAxisBase.prototype.provideData = function (data) {
        this._chartLevelData = data;
        this.updateDataSource();
    };
    IgrCategoryAxisBase.prototype.updateDataSource = function () {
        if (this._dataSource == null) {
            this.i.itemsSource = this._chartLevelData;
        }
        else {
            this.i.itemsSource = this._dataSource;
        }
    };
    Object.defineProperty(IgrCategoryAxisBase.prototype, "dataSource", {
        get: function () {
            if (this._dataSource != null) {
                return this._dataSource;
            }
            return this.i.itemsSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.updateDataSource();
            //console.log("setting axis data source: " + value)
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "i", {
        /**
                                 * @hidden
                                 */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "isContinuous", {
        /**
     * Gets if the current axis is a continuous rather than a discrete scale
    */
        get: function () {
            return this.i.b4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "isCategory", {
        /**
         * Checks if the axis is of category axis type
        */
        get: function () {
            return this.i.b2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "itemsCount", {
        /**
         * Gets the number of items in the current category axis items source.
        */
        get: function () {
            return this.i.jz;
        },
        set: function (v) {
            this.i.jz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "gap", {
        /**
         * Gets or sets the amount of space between adjacent categories for the current axis object.
         * The gap is silently clamped to the range [0, 1] when used.
        *
        * Use the `gap` property to configure the spacing between items on a category axis with item spacing.
        *
        * A `gap` of 0 allocates no space between items.  A `gap` of 1 allocates a space between items equal to the width of one item.
        *
        * To set the item spacing to 75% the width of one item, set the `gap` to 0.75, as in this code:
        *
        * ```ts
        *  <IgrDataChart
        * 	ref={this.onChartRef}
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" gap={0.4} />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.jo;
        },
        set: function (v) {
            this.i.jo = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "overlap", {
        /**
         * Gets or sets the amount of overlap between adjacent categories for the current axis object.
         * The overlap is silently clamped to the range [-1, 1] when used.
        *
        * Use the `overlap` property to configure the spacing between items on a category axis with item spacing and more than one series.
        *
        * An `overlap` of 0 places grouped items adjacent to each other.  An `overlap` of 1 places grouped items in the same axis space, completely overlapping.  An `overlap` of -1 places a space between grouped items equal to the width of one item.
        *
        * To place grouped items with 75% overlap, set the `overlap` to 0.75, as in this code:
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" overlap={1} />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.jv;
        },
        set: function (v) {
            this.i.jv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAxisBase.prototype, "useClusteringMode", {
        /**
         * Gets or sets whether the category axis should use clustering display mode even if no series are present that would force clustering mode.
        *
        * `useClusteringMode` applies grouping and spacing to a category axis equivalent to the grouping that occurs when grouping series, such as ColumnSeries, are used.
        *
        * Try setting it on an axis displaying financial series to adjust the spacing on the left and right sides of the axis:
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" useClusteringMode={2} />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.jj;
        },
        set: function (v) {
            this.i.jj = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryAxisBase.prototype.getCategoryBoundingBox = function (point, useInterpolation, singularWidth) {
        var iv = this.i.ku(toPoint(point), useInterpolation, singularWidth);
        return fromRect(iv);
    };
    IgrCategoryAxisBase.prototype.getCategoryBoundingBoxHelper = function (point, useInterpolation, singularWidth, isVertical) {
        var iv = this.i.kv(toPoint(point), useInterpolation, singularWidth, isVertical);
        return fromRect(iv);
    };
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    */
    IgrCategoryAxisBase.prototype.unscaleValue = function (unscaledValue) {
        var iv = this.i.jw(unscaledValue);
        return (iv);
    };
    IgrCategoryAxisBase.prototype.notifySetItem = function (index, oldItem, newItem) {
        this.i.kh(index, oldItem, newItem);
    };
    /**
     * Used to manually notify the axis that the data source has reset or cleared its items.
    
    */
    IgrCategoryAxisBase.prototype.notifyClearItems = function () {
        this.i.ke();
    };
    IgrCategoryAxisBase.prototype.notifyInsertItem = function (index, newItem) {
        this.i.kf(index, newItem);
    };
    IgrCategoryAxisBase.prototype.notifyRemoveItem = function (index, oldItem) {
        this.i.kg(index, oldItem);
    };
    return IgrCategoryAxisBase;
}(IgrAxis));

/**
 * Represents an annotation layer that targets a category axis, or all category axes in the chart.
 * If the axis contains any series that are aligned between major gridlines of the axis (column, waterfall, etc) this will render a shape that fills the current category.
 * Otherwise it will render a band with an adjustable thickness at the closest gridline to the pointer position.
 * Setting UseIterpolation to true will cause the x position in the latter case to become affixed to the x position of the pointer.
*/
var IgrCategoryHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryHighlightLayer, _super);
    function IgrCategoryHighlightLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryHighlightLayer.prototype.createImplementation = function () {
        return new CategoryHighlightLayer();
    };
    Object.defineProperty(IgrCategoryHighlightLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryHighlightLayer.prototype, "targetAxis", {
        /**
         * Gets or sets the axis to target this annotation to. If null, this annotation targets all category axes simultaneously.
        */
        get: function () {
            if (this.i.m4 == null) {
                return null;
            }
            if (!this.i.m4.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.m4);
                if (e) {
                    e._implementation = this.i.m4;
                }
                this.i.m4.externalObject = e;
            }
            return this.i.m4.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m4 = null : this.i.m4 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryHighlightLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
        */
        get: function () {
            return this.i.m7;
        },
        set: function (v) {
            this.i.m7 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryHighlightLayer.prototype, "bandHighlightWidth", {
        /**
         * Gets or sets the width to use for the highlight region if drawing a band rather than filling a category.
        */
        get: function () {
            return this.i.m8;
        },
        set: function (v) {
            this.i.m8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryHighlightLayer.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.targetAxis && this.targetAxis._styling) {
            this.targetAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    return IgrCategoryHighlightLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryHighlightLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryHighlightLayerModule() {
    }
    IgrCategoryHighlightLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrCategoryHighlightLayer", IgrCategoryHighlightLayer);
        TypeRegistrar.register("CategoryHighlightLayer", CategoryHighlightLayer.$type);
    };
    return IgrCategoryHighlightLayerModule;
}());

var IgrCalloutStyleUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutStyleUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutStyleUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutStyleUpdatingEventArgs();
    };
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutStyleUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCalloutStyleUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "xValue", {
        get: function () {
            return this.i.xValue;
        },
        set: function (v) {
            this.i.xValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "yValue", {
        get: function () {
            return this.i.yValue;
        },
        set: function (v) {
            this.i.yValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "series", {
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "background", {
        get: function () {
            return brushToString(this.i.background);
        },
        set: function (v) {
            this.i.background = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "textColor", {
        get: function () {
            return brushToString(this.i.textColor);
        },
        set: function (v) {
            this.i.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "outline", {
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "leaderBrush", {
        get: function () {
            return brushToString(this.i.leaderBrush);
        },
        set: function (v) {
            this.i.leaderBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutStyleUpdatingEventArgs.prototype, "strokeThickness", {
        get: function () {
            return this.i.strokeThickness;
        },
        set: function (v) {
            this.i.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutStyleUpdatingEventArgs;
}());

/**
 * Represents event arguments for updating content of callout layer
*/
var IgrCalloutContentUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutContentUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutContentUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutContentUpdatingEventArgs();
    };
    Object.defineProperty(IgrCalloutContentUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutContentUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCalloutContentUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutContentUpdatingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutContentUpdatingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutContentUpdatingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutContentUpdatingEventArgs.prototype, "content", {
        /**
         * Gets or sets content displayed by callout layer
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutContentUpdatingEventArgs;
}());

/**
 * Represents event arguments for updating label of callout layer
*/
var IgrCalloutLabelUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutLabelUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutLabelUpdatingEventArgs.prototype.createImplementation = function () {
        return new CalloutLabelUpdatingEventArgs();
    };
    Object.defineProperty(IgrCalloutLabelUpdatingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutLabelUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCalloutLabelUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutLabelUpdatingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLabelUpdatingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLabelUpdatingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLabelUpdatingEventArgs.prototype, "label", {
        /**
         * Gets or sets label displayed by callout layer
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutLabelUpdatingEventArgs;
}());

/**
 * Represents event arguments for selecting callout layer
*/
var IgrCalloutSeriesSelectingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutSeriesSelectingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrCalloutSeriesSelectingEventArgs.prototype.createImplementation = function () {
        return new CalloutSeriesSelectingEventArgs();
    };
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutSeriesSelectingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCalloutSeriesSelectingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "xValue", {
        /**
         * Gets data X-value assositated with callout layer
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "yValue", {
        /**
         * Gets data Y-value assositated with callout layer
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "item", {
        /**
         * Gets data item assositated with callout layer
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "series", {
        /**
         * Gets or sets series object assositated with callout layer
        */
        get: function () {
            if (this.i.a == null) {
                return null;
            }
            if (!this.i.a.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.a);
                if (e) {
                    e._implementation = this.i.a;
                }
                this.i.a.externalObject = e;
            }
            return this.i.a.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutSeriesSelectingEventArgs.prototype, "seriesName", {
        /**
         * Gets or sets series name assositated with callout layer
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutSeriesSelectingEventArgs;
}());

/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
var IgrCalloutLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCalloutLayer, _super);
    function IgrCalloutLayer(props) {
        var _this = _super.call(this, props) || this;
        _this._calloutStyleUpdating = null;
        _this._calloutStyleUpdating_wrapped = null;
        _this._calloutContentUpdating = null;
        _this._calloutContentUpdating_wrapped = null;
        _this._calloutLabelUpdating = null;
        _this._calloutLabelUpdating_wrapped = null;
        _this._calloutSeriesSelecting = null;
        _this._calloutSeriesSelecting_wrapped = null;
        return _this;
    }
    IgrCalloutLayer.prototype.createImplementation = function () {
        return new CalloutLayer();
    };
    Object.defineProperty(IgrCalloutLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "labelMemberPath", {
        /**
         * Gets or sets the label mapping property for the callouts.
        */
        get: function () {
            return this.i.pc;
        },
        set: function (v) {
            this.i.pc = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "xMemberPath", {
        /**
         * Gets or sets the label mapping property for the callouts.
        */
        get: function () {
            return this.i.pj;
        },
        set: function (v) {
            this.i.pj = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "yMemberPath", {
        /**
         * Gets or sets the label mapping property for the callouts.
        */
        get: function () {
            return this.i.pm;
        },
        set: function (v) {
            this.i.pm = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "keyMemberPath", {
        /**
         * Gets or sets the key mapping property for the callouts.
        */
        get: function () {
            return this.i.o9;
        },
        set: function (v) {
            this.i.o9 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "isCalloutOffsettingEnabled", {
        /**
         * Gets or sets whether to allow the callouts to be variable distances from the target points, for suppporting collision modes.
        */
        get: function () {
            return this.i.ny;
        },
        set: function (v) {
            this.i.ny = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "contentMemberPath", {
        /**
         * Gets or sets the content mapping property for the callouts.
        */
        get: function () {
            return this.i.o3;
        },
        set: function (v) {
            this.i.o3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "targetSeries", {
        /**
         * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
        */
        get: function () {
            if (this.i.na == null) {
                return null;
            }
            if (!this.i.na.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.na);
                if (e) {
                    e._implementation = this.i.na;
                }
                this.i.na.externalObject = e;
            }
            return this.i.na.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.na = null : this.i.na = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "collisionChannel", {
        /**
         * Gets or sets a channel name to identify other callout layers within the chart to share collision information with.
        */
        get: function () {
            return this.i.o0;
        },
        set: function (v) {
            this.i.o0 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "isAutoCalloutBehaviorEnabled", {
        /**
         * Gets or sets how to select the final value to annotate.
        */
        get: function () {
            return this.i.nx;
        },
        set: function (v) {
            this.i.nx = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "useValueForAutoCalloutLabels", {
        /**
         * Gets or sets whether to use values, rather than labels for auto callout labels.
        */
        get: function () {
            return this.i.n0;
        },
        set: function (v) {
            this.i.n0 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "isCustomCalloutStyleEnabled", {
        /**
         * Gets or sets whether to allow for custom callout styles.
        */
        get: function () {
            return this.i.nz;
        },
        set: function (v) {
            this.i.nz = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "autoCalloutLabelPrecision", {
        /**
         * Gets or sets the precision to use when values are used for the auto callout labels.
        */
        get: function () {
            return this.i.oi;
        },
        set: function (v) {
            this.i.oi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutTextColor", {
        /**
         * Gets or sets the color to use for the callout text. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.qu);
        },
        set: function (v) {
            this.i.qu = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutBackground", {
        /**
         * Gets or sets the brush that specifies how the backgrounds for the callouts of the layer are painted. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.qr);
        },
        set: function (v) {
            this.i.qr = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutInterpolatedValuePrecision", {
        /**
         * Gets or sets the precision to use displaying values for interpolated crosshair positions.
        */
        get: function () {
            return this.i.oj;
        },
        set: function (v) {
            this.i.oj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutOutline", {
        /**
         * Gets or sets the brush that specifies how the outlines for the callouts of the layer are painted.
        */
        get: function () {
            return brushToString(this.i.qt);
        },
        set: function (v) {
            this.i.qt = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutLeaderBrush", {
        /**
         * Gets or sets the brush that specifies how the leader lines for the callouts of the layer are painted.
        */
        get: function () {
            return brushToString(this.i.qs);
        },
        set: function (v) {
            this.i.qs = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutPaddingLeft", {
        /**
         * Gets or sets the left padding to use withing the callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.ob;
        },
        set: function (v) {
            this.i.ob = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutPaddingTop", {
        /**
         * Gets or sets the top padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.od;
        },
        set: function (v) {
            this.i.od = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutPaddingRight", {
        /**
         * Gets or sets the right padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.oc;
        },
        set: function (v) {
            this.i.oc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutPaddingBottom", {
        /**
         * Gets or sets the bottom padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.oa;
        },
        set: function (v) {
            this.i.oa = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutCollisionMode", {
        /**
         * Gets or sets the strategy to use for avoiding collisions between the callouts in this layer. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.m4;
        },
        set: function (v) {
            this.i.m4 = ensureEnum(CalloutCollisionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutPositionPadding", {
        /**
         * Gets or sets the padding to add to the callout positioning. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.oe;
        },
        set: function (v) {
            this.i.oe = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutStrokeThickness", {
        /**
         * Gets or sets the stroke thickness for the callout backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.of;
        },
        set: function (v) {
            this.i.of = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "textStyle", {
        /**
         * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.pf;
        },
        set: function (v) {
            this.i.pf = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalloutLayer.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrCalloutLayer.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Invalidates content of callout layer
    
    */
    IgrCalloutLayer.prototype.invalidateCalloutContent = function () {
        this.i.pv();
    };
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutStyleUpdating", {
        /**
         * Event raised when updating style of callout layer
        */
        get: function () {
            return this._calloutStyleUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._calloutStyleUpdating_wrapped !== null) {
                this.i.calloutStyleUpdating = delegateRemove(this.i.calloutStyleUpdating, this._calloutStyleUpdating_wrapped);
                this._calloutStyleUpdating_wrapped = null;
                this._calloutStyleUpdating = null;
            }
            this._calloutStyleUpdating = ev;
            this._calloutStyleUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrCalloutStyleUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalloutStyleUpdating) {
                    _this.beforeCalloutStyleUpdating(_this, outerArgs);
                }
                if (_this._calloutStyleUpdating) {
                    _this._calloutStyleUpdating(_this, outerArgs);
                }
            };
            this.i.calloutStyleUpdating = delegateCombine(this.i.calloutStyleUpdating, this._calloutStyleUpdating_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutContentUpdating", {
        /**
         * Raised to allow you to decide on the content for an automatically created callout.
        */
        get: function () {
            return this._calloutContentUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._calloutContentUpdating_wrapped !== null) {
                this.i.calloutContentUpdating = delegateRemove(this.i.calloutContentUpdating, this._calloutContentUpdating_wrapped);
                this._calloutContentUpdating_wrapped = null;
                this._calloutContentUpdating = null;
            }
            this._calloutContentUpdating = ev;
            this._calloutContentUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrCalloutContentUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalloutContentUpdating) {
                    _this.beforeCalloutContentUpdating(_this, outerArgs);
                }
                if (_this._calloutContentUpdating) {
                    _this._calloutContentUpdating(_this, outerArgs);
                }
            };
            this.i.calloutContentUpdating = delegateCombine(this.i.calloutContentUpdating, this._calloutContentUpdating_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutLabelUpdating", {
        /**
         * Raised to allow you to decide on the label for an automatically created callout.
        */
        get: function () {
            return this._calloutLabelUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._calloutLabelUpdating_wrapped !== null) {
                this.i.calloutLabelUpdating = delegateRemove(this.i.calloutLabelUpdating, this._calloutLabelUpdating_wrapped);
                this._calloutLabelUpdating_wrapped = null;
                this._calloutLabelUpdating = null;
            }
            this._calloutLabelUpdating = ev;
            this._calloutLabelUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrCalloutLabelUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalloutLabelUpdating) {
                    _this.beforeCalloutLabelUpdating(_this, outerArgs);
                }
                if (_this._calloutLabelUpdating) {
                    _this._calloutLabelUpdating(_this, outerArgs);
                }
            };
            this.i.calloutLabelUpdating = delegateCombine(this.i.calloutLabelUpdating, this._calloutLabelUpdating_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCalloutLayer.prototype, "calloutSeriesSelecting", {
        /**
         * Raised to allow you to select a target series for a data bound callout.
        */
        get: function () {
            return this._calloutSeriesSelecting;
        },
        set: function (ev) {
            var _this = this;
            if (this._calloutSeriesSelecting_wrapped !== null) {
                this.i.calloutSeriesSelecting = delegateRemove(this.i.calloutSeriesSelecting, this._calloutSeriesSelecting_wrapped);
                this._calloutSeriesSelecting_wrapped = null;
                this._calloutSeriesSelecting = null;
            }
            this._calloutSeriesSelecting = ev;
            this._calloutSeriesSelecting_wrapped = function (o, e) {
                var outerArgs = new IgrCalloutSeriesSelectingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalloutSeriesSelecting) {
                    _this.beforeCalloutSeriesSelecting(_this, outerArgs);
                }
                if (_this._calloutSeriesSelecting) {
                    _this._calloutSeriesSelecting(_this, outerArgs);
                }
            };
            this.i.calloutSeriesSelecting = delegateCombine(this.i.calloutSeriesSelecting, this._calloutSeriesSelecting_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrCalloutLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCalloutLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalloutLayerModule() {
    }
    IgrCalloutLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrCalloutLayer", IgrCalloutLayer);
        TypeRegistrar.register("CalloutLayer", CalloutLayer.$type);
    };
    return IgrCalloutLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinalValueLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayerFrame, _super);
    function FinalValueLayerFrame() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinalValueLayerFrame.$t = markType(FinalValueLayerFrame, 'FinalValueLayerFrame', AxisAnnotationFrame.$);
    return FinalValueLayerFrame;
}(AxisAnnotationFrame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Gets or sets how to select the final value to annotate.
 */
var FinalValueSelectionMode = /*@__PURE__*/ (function (FinalValueSelectionMode) {
    /**
     * A mode is selected automatically
     */
    FinalValueSelectionMode[FinalValueSelectionMode["Auto"] = 0] = "Auto";
    /**
     * Displays the last value visible.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["FinalVisible"] = 1] = "FinalVisible";
    /**
     * Displays an interploated last value for when the series leaves view.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["FinalVisibleInterpolated"] = 2] = "FinalVisibleInterpolated";
    /**
     * Displays the last value in the series, whether visible or not.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["Final"] = 3] = "Final";
    return FinalValueSelectionMode;
})({});
/**
 * @hidden
 */
var FinalValueSelectionMode_$type = /*@__PURE__*/ markEnum('FinalValueSelectionMode', 'Auto,0|FinalVisible,1|FinalVisibleInterpolated,2|Final,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayer, _super);
    function FinalValueLayer() {
        var _this = _super.call(this) || this;
        _this.axisAnnotationFormatLabel = null;
        _this.na = null;
        _this.m9 = null;
        var a = new FinalValueLayerFrame();
        var b = new FinalValueLayerFrame();
        var c = new FinalValueLayerFrame();
        var d = _this.fi / 1000;
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = FinalValueLayer.$;
        return _this;
    }
    FinalValueLayer.prototype.bf = function () {
        return new FinalValueLayerView(this);
    };
    FinalValueLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m5 = a;
    };
    Object.defineProperty(FinalValueLayer.prototype, "n9", {
        get: function () {
            return new Thickness(1, this.nc, this.ne, this.nd, this.nb);
        },
        enumerable: true,
        configurable: true
    });
    FinalValueLayer.prototype.m8 = function () {
        return this.axisAnnotationFormatLabel != null;
    };
    FinalValueLayer.prototype.ml = function (a, b) {
        if (this.m7 == null || this.m7 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    FinalValueLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        c.f.clear();
        c.q.clear();
        c.p.clear();
        c.aa.clear();
        c.o.clear();
        c.z.clear();
        c.g.clear();
        c.h.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.m.clear();
        c.n.clear();
        c.r.clear();
        c.s.clear();
        c.u.clear();
        c.w.clear();
        c.v.clear();
        c.t.clear();
        c.x.clear();
        c.y.clear();
        if (this.l8(this.m7)) {
            this.ns(this.m7, c);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (this.l8(d)) {
                        this.ns(d, c);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    FinalValueLayer.prototype.l8 = function (a) {
        if (!_super.prototype.l8.call(this, a)) {
            return false;
        }
        return true;
    };
    FinalValueLayer.prototype.io = function () {
        _super.prototype.io.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.nt(this.l3, false);
        }
        else {
            this.nt(this.l1, false);
        }
    };
    FinalValueLayer.prototype.n8 = function (a) {
        var b = NaN;
        var c = NaN;
        var d = this.m6;
        if (d == 0) {
            d = 1;
        }
        var e = false;
        if (d == 2) {
            e = true;
        }
        if (a.isVertical) {
            var f = a.ap();
            if (f != null) {
                if (d == 1 || d == 2) {
                    if (f.b8) {
                        c = a.lo({ $type: Point_$type, x: this.ly.right, y: this.ly.bottom }).y;
                    }
                    else {
                        c = a.lo({ $type: Point_$type, x: this.ly.right, y: this.ly.top }).y;
                    }
                }
                else {
                    if (f.b8) {
                        c = 1;
                    }
                    else {
                        c = 0;
                    }
                }
            }
            return a.ll({ $type: Point_$type, x: 0, y: c }, e, true);
        }
        else {
            var g = a.ap();
            if (g != null) {
                if (d == 1 || d == 2) {
                    if (g.b8) {
                        b = a.lo({ $type: Point_$type, x: this.ly.left, y: this.ly.top }).x;
                    }
                    else {
                        b = a.lo({ $type: Point_$type, x: this.ly.right, y: this.ly.top }).x;
                    }
                }
                else {
                    if (g.b8) {
                        b = 0;
                    }
                    else {
                        b = 1;
                    }
                }
            }
            if (a.cr) {
                return a.ll({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
            else {
                return a.ll({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
        }
    };
    FinalValueLayer.prototype.ns = function (a, b) {
        var c = this.n8(a);
        var d = this.lo(c);
        var e = this.k3;
        if (e == null) {
            e = this.k5;
        }
        if (e == null) {
            e = a.k3;
            if (e != null) {
                e = this.m5.b2(e);
            }
        }
        AxisAnnotationFrameManager.c(b, c, a, this.bs, this.getEffectiveViewport(), e, this.n5, this.n7, this.n6, this.n9, this.nf, this.n5, this.n7, this.n6, this.n9, this.nf, a.isVertical, !a.isVertical);
    };
    FinalValueLayer.prototype.nt = function (a, b) {
        var c = false;
        if (this.m9 == null) {
            c = true;
            this.na = new List$1(Axis.$, 0);
            this.m9 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.m9, this.na, b, this.ng, this.ng, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
    };
    FinalValueLayer.prototype.mq = function (a, b) {
        _super.prototype.mq.call(this, a, b);
        if (this.ca()) {
            this.nt(this.l3, true);
        }
        else {
            this.nt(this.l1, false);
        }
    };
    FinalValueLayer.prototype.c8 = function () {
        return true;
    };
    FinalValueLayer.prototype.iz = function (a, b, c, d) {
        var e_2, _a;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case FinalValueLayer.$$p[10]:
                this.jd(true);
                break;
            case FinalValueLayer.$$p[0]:
            case FinalValueLayer.$$p[2]:
            case FinalValueLayer.$$p[4]:
            case FinalValueLayer.$$p[6]:
            case FinalValueLayer.$$p[5]:
            case FinalValueLayer.$$p[3]:
            case FinalValueLayer.$$p[7]:
            case FinalValueLayer.$$p[8]:
            case FinalValueLayer.$$p[9]:
                this.jd(true);
                break;
            case "SeriesViewer":
                var e = this.na;
                var f = this.m9;
                if (f != null) {
                    var _loop_1 = function (g) {
                        var h = g.value;
                        h.c(function (i) { return g.key.ak.remove(i); });
                        h.clear();
                    };
                    try {
                        for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var g = _c.value;
                            _loop_1(g);
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                    e.clear();
                    f.clear();
                }
                break;
        }
    };
    FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
    FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackground:n5:nu', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:ng:nv', [1, -1], 'AxisAnnotationOutline:n6:nw', [Brush.$, null], 'AxisAnnotationPaddingBottom:nb:nx', [1, NaN], 'AxisAnnotationPaddingLeft:nc:ny', [1, NaN], 'AxisAnnotationPaddingRight:nd:nz', [1, NaN], 'AxisAnnotationPaddingTop:ne:n0', [1, NaN], 'AxisAnnotationStrokeThickness:nf:n1', [1, NaN], 'AxisAnnotationTextColor:n7:n2', [Brush.$, null], 'FinalValueSelectionMode:m6:n3', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeries:m7:n4', [Series.$, null]]);
    return FinalValueLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var FinalValueLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinalValueLayerView, _super);
    function FinalValueLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b1 = a;
        return _this;
    }
    FinalValueLayerView.prototype.ap = function () {
        _super.prototype.ap.call(this);
    };
    FinalValueLayerView.prototype.b2 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    FinalValueLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
    };
    FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);
    return FinalValueLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
var IgrFinalValueLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinalValueLayer, _super);
    function IgrFinalValueLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrFinalValueLayer.prototype.createImplementation = function () {
        return new FinalValueLayer();
    };
    Object.defineProperty(IgrFinalValueLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "targetSeries", {
        /**
         * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
        */
        get: function () {
            if (this.i.m7 == null) {
                return null;
            }
            if (!this.i.m7.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.m7);
                if (e) {
                    e._implementation = this.i.m7;
                }
                this.i.m7.externalObject = e;
            }
            return this.i.m7.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m7 = null : this.i.m7 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "finalValueSelectionMode", {
        /**
         * Gets or sets how to select the final value to annotate.
        */
        get: function () {
            return this.i.m6;
        },
        set: function (v) {
            this.i.m6 = ensureEnum(FinalValueSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationTextColor", {
        /**
         * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.n7);
        },
        set: function (v) {
            this.i.n7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationBackground", {
        /**
         * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.n5);
        },
        set: function (v) {
            this.i.n5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationInterpolatedValuePrecision", {
        /**
         * Gets or sets the precision to use displaying values for interpolated crosshair positions.
        */
        get: function () {
            return this.i.ng;
        },
        set: function (v) {
            this.i.ng = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationOutline", {
        /**
         * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.n6);
        },
        set: function (v) {
            this.i.n6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationPaddingLeft", {
        /**
         * Gets or sets the left padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nc;
        },
        set: function (v) {
            this.i.nc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.ne;
        },
        set: function (v) {
            this.i.ne = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nd;
        },
        set: function (v) {
            this.i.nd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nb;
        },
        set: function (v) {
            this.i.nb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinalValueLayer.prototype, "axisAnnotationStrokeThickness", {
        /**
         * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.nf;
        },
        set: function (v) {
            this.i.nf = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinalValueLayer.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    };
    return IgrFinalValueLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinalValueLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinalValueLayerModule() {
    }
    IgrFinalValueLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrFinalValueLayer", IgrFinalValueLayer);
        TypeRegistrar.register("FinalValueLayer", FinalValueLayer.$type);
    };
    return IgrFinalValueLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CrosshairLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayerFrame, _super);
    function CrosshairLayerFrame() {
        var _this = _super.call(this) || this;
        _this.ad = null;
        _this.ae = null;
        _this.ac = null;
        _this.af = null;
        _this.ad = new List$1(Number_$type, 0);
        _this.ae = new List$1(Number_$type, 0);
        _this.ac = new List$1(Brush.$, 0);
        _this.af = new List$1(Brush.$, 0);
        return _this;
    }
    CrosshairLayerFrame.prototype.c = function (a, b, c) {
        _super.prototype.c.call(this, a, b, c);
        var d = b;
        var e = c;
        Frame.b(this.ad, a, d.ad, e.ad);
        Frame.b(this.ae, a, d.ae, e.ae);
        FrameExtended.a(this.ac, a, d.ac, e.ac, 0);
        FrameExtended.a(this.af, a, d.af, e.af, 0);
    };
    CrosshairLayerFrame.$t = markType(CrosshairLayerFrame, 'CrosshairLayerFrame', AxisAnnotationFrame.$);
    return CrosshairLayerFrame;
}(AxisAnnotationFrame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemHighlightFrameRect = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemHighlightFrameRect, _super);
    function ItemHighlightFrameRect() {
        var _this = _super.call(this) || this;
        _this.f = 0;
        _this.e = 0;
        _this.b = 0;
        _this.c = 0;
        _this.a = 0;
        _this.i = null;
        _this.j = null;
        _this.h = null;
        _this.g = null;
        _this.d = 0;
        _this.f = 0;
        _this.e = NaN;
        _this.b = NaN;
        _this.c = NaN;
        _this.b = NaN;
        _this.a = NaN;
        _this.d = NaN;
        return _this;
    }
    ItemHighlightFrameRect.$t = markType(ItemHighlightFrameRect, 'ItemHighlightFrameRect');
    return ItemHighlightFrameRect;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available shapes for a category item highlight.
 */
var CategoryItemHighlightType = /*@__PURE__*/ (function (CategoryItemHighlightType) {
    /**
     * The default depends on the series being highlighted.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Auto"] = 0] = "Auto";
    /**
     * The highlight should use a marker shape.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Marker"] = 1] = "Marker";
    /**
     * The highlight should use a filled band shape.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Shape"] = 2] = "Shape";
    return CategoryItemHighlightType;
})({});
/**
 * @hidden
 */
var CategoryItemHighlightType_$type = /*@__PURE__*/ markEnum('CategoryItemHighlightType', 'Auto,0|Marker,1|Shape,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryItemHighlightLayerFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayerFrame, _super);
    function CategoryItemHighlightLayerFrame() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.f = null;
        _this.g = new Dictionary$2(Number_$type, ItemHighlightFrameRect.$, 0);
        _this.f = new DictInterpolator$3(Number_$type, ItemHighlightFrameRect.$, CategoryItemHighlightLayerFrame.$, runOn(_this, _this.h), function (a) { return a.f; }, function (a) { return true; }, function () { return new ItemHighlightFrameRect(); });
        return _this;
    }
    CategoryItemHighlightLayerFrame.prototype.h = function (a, b, c, d, e, f) {
        if (d != null) {
            a.f = d.f;
        }
        else if (c != null) {
            a.f = c.f;
        }
        else {
            a.f = 0;
        }
        if (c == null || isNaN_(c.e)) {
            a.e = d != null ? d.e : NaN;
        }
        else if (d == null || isNaN_(d.e)) {
            a.e = NaN;
        }
        else {
            a.e = c.e + b * (d.e - c.e);
        }
        if (c == null || isNaN_(c.b)) {
            a.b = d != null ? d.b : NaN;
        }
        else if (d == null || isNaN_(d.b)) {
            a.b = NaN;
        }
        else {
            a.b = c.b + b * (d.b - c.b);
        }
        if (c == null || isNaN_(c.c)) {
            a.c = d != null ? d.c : NaN;
        }
        else if (d == null || isNaN_(d.c)) {
            a.c = NaN;
        }
        else {
            a.c = c.c + b * (d.c - c.c);
        }
        if (c == null || isNaN_(c.a)) {
            a.a = d != null ? d.a : NaN;
        }
        else if (d == null || isNaN_(d.a)) {
            a.a = NaN;
        }
        else {
            a.a = c.a + b * (d.a - c.a);
        }
        if (c == null || isNaN_(c.d)) {
            a.d = d != null ? d.d : NaN;
        }
        else if (d == null || isNaN_(d.d)) {
            a.d = NaN;
        }
        else {
            a.d = c.d + b * (d.d - c.d);
        }
        if (c == null || c.i == null) {
            a.i = d != null ? d.i : null;
        }
        else if (d == null || d.i == null) {
            a.i = null;
        }
        else {
            a.i = BrushUtil.k(c.i, b, d.i, 0);
        }
        if (c == null || c.j == null) {
            a.j = d != null ? d.j : null;
        }
        else if (d == null || d.j == null) {
            a.j = null;
        }
        else {
            a.j = BrushUtil.k(c.j, b, d.j, 0);
        }
        if (c == null || c.h == null) {
            a.h = d != null ? d.h : null;
        }
        else if (d == null || d.j == null) {
            a.h = null;
        }
        else {
            a.h = d.h;
        }
        if (c == null || c.g == null) {
            a.g = d != null ? d.g : null;
        }
        else if (d == null || d.j == null) {
            a.g = null;
        }
        else {
            a.g = d.g;
        }
    };
    CategoryItemHighlightLayerFrame.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        this.f.e(this.g, a, d.g, e.g, d, e);
    };
    CategoryItemHighlightLayerFrame.$t = markType(CategoryItemHighlightLayerFrame, 'CategoryItemHighlightLayerFrame', Frame.$);
    return CategoryItemHighlightLayerFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryItemHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayer, _super);
    function CategoryItemHighlightLayer() {
        var _this = _super.call(this) || this;
        _this.m9 = false;
        _this.m8 = true;
        _this.nc = 10;
        var a = new CategoryItemHighlightLayerFrame();
        var b = new CategoryItemHighlightLayerFrame();
        var c = new CategoryItemHighlightLayerFrame();
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = CategoryItemHighlightLayer.$;
        return _this;
    }
    CategoryItemHighlightLayer.prototype.bf = function () {
        return new CategoryItemHighlightLayerView(this);
    };
    CategoryItemHighlightLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m4 = a;
    };
    CategoryItemHighlightLayer.prototype.ml = function (a, b) {
        if (this.m7 == null || this.m7 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    CategoryItemHighlightLayer.prototype.l8 = function (a) {
        if (!_super.prototype.l8.call(this, a)) {
            return false;
        }
        var b = this.mg(a);
        if (!b.c) {
            return false;
        }
        return true;
    };
    CategoryItemHighlightLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        var d = this.nb;
        c.g.clear();
        if (isNaN_(this.m1.x) && isNaN_(this.m1.y)) {
            return;
        }
        if (this.l8(this.m7)) {
            this.nm(this.m7, c, d);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    if (this.l8(e)) {
                        this.nm(e, c, d);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CategoryItemHighlightLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case CategoryItemHighlightLayer.$$p[4]:
                this.jd(true);
                break;
            case CategoryItemHighlightLayer.$$p[5]:
                this.m9 = d;
                this.jd(true);
                break;
            case CategoryItemHighlightLayer.$$p[1]:
                this.jd(true);
                break;
            case CategoryItemHighlightLayer.$$p[0]:
                this.nc = this.nd;
                this.jd(true);
                break;
            case CategoryItemHighlightLayer.$$p[3]:
                this.m8 = d;
                this.jd(true);
                break;
        }
    };
    CategoryItemHighlightLayer.prototype.nm = function (a, b, c) {
        if (this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return;
        }
        if (!a.cl && !a.cr) {
            return;
        }
        var d = a;
        if (d.categoryAxis == null) {
            return;
        }
        var e = this.m1.x;
        e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
        var f = this.m1.y;
        f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
        var g = this.na;
        var h = true;
        var i = typeCast(IHasCategoryModePreference_$type, a);
        var j = 0;
        if (i != null) {
            j = i.preferredCategoryMode(d.categoryAxis);
            if (j == 2) {
                h = false;
            }
        }
        var k = true;
        if (!h || this.m5 == 2) {
            k = false;
        }
        if (this.m5 == 1) {
            k = true;
        }
        var l = this.mg(a);
        if (!l.c) {
            return;
        }
        if (k) {
            var m = a.ll(l.d, this.nb, g);
            if (j != 0 && !d.categoryAxis.cd) {
                var n = m.x;
                if (a.cr) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
                else if (a.cl) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
            }
            if (!isNaN_(m.x) && !isNaN_(m.y)) {
                m = this.lo(m);
            }
            this.nk(m, b, a);
        }
        else {
            var o = a.ll(l.d, this.nb, g);
            var p = void 0;
            var q = this.getEffectiveViewport1(this.bi);
            if (a.isVertical) {
                var r = o.y;
                var s = d.categoryAxis;
                var t = this.nc;
                if (j != 0) {
                    t = s.jr(this.bi.bs, this.bi.br, q);
                }
                if (isNaN_(t) || isInfinity(t)) {
                    return;
                }
                p = new Rect(0, this.ly.left, r - t / 2, this.ly.width, t);
            }
            else {
                var u = o.x;
                var v = d.categoryAxis;
                var w = this.nc;
                if (j != 0) {
                    w = v.jr(this.bi.bs, this.bi.br, q);
                }
                if (isNaN_(w) || isInfinity(w)) {
                    return;
                }
                p = new Rect(0, u - w / 2, this.ly.top, w, this.ly.height);
            }
            p.intersect(this.bi.br);
            this.nl(p, b, a);
        }
    };
    CategoryItemHighlightLayer.prototype.nk = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.x;
        d.e = a.y;
        d.i = this.mz();
        d.j = this.m0();
        if (d.i == null) {
            if (c.hasMarkers) {
                d.i = this.m4.cf(c.k6());
            }
            else {
                d.i = this.m4.cf(c.k3);
            }
        }
        if (d.j == null) {
            if (c.hasMarkers) {
                d.j = this.m4.cf(c.k7());
            }
            else {
                d.j = this.m4.cf(c.k4);
            }
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        d.g = this.m6(c, a);
        var e = (typeCast(MarkerSeries.$, c) !== null) ? c.mi : null;
        if (e == null || e == MarkerSeries.ml) {
            var f = MarkerSeries.l2(c, 2);
            switch (f) {
                case 3:
                case 13:
                    e = this.bs.kn;
                    break;
                case 4:
                    e = this.bs.kw;
                    break;
                case 5:
                    e = this.bs.kt;
                    break;
                case 6:
                    e = this.bs.ku;
                    break;
                case 7:
                    e = this.bs.ko;
                    break;
                case 8:
                    e = this.bs.kr;
                    break;
                case 9:
                    e = this.bs.kp;
                    break;
                case 10:
                    e = this.bs.kv;
                    break;
                case 11:
                    e = this.bs.ks;
                    break;
                case 12:
                    e = this.bs.kq;
                    break;
            }
        }
        d.h = this.np != null ? this.np : e;
        if (!isNaN_(d.b) && !isNaN_(d.e)) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.m6 = function (a, b) {
        var c = a.fp(b);
        var d = a.eb(b);
        if (this.nb && d != Math.floor(d)) {
            c = null;
        }
        return ((function () {
            var $ret = new DataContext();
            $ret.series = a;
            $ret.item = c;
            return $ret;
        })());
    };
    CategoryItemHighlightLayer.prototype.nl = function (a, b, c) {
        var d = new ItemHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.i = this.mz();
        d.j = this.m0();
        if (d.i == null) {
            if (c != null) {
                d.i = this.m4.cg(c.k3);
            }
        }
        if (d.j == null) {
            if (c != null) {
                d.j = this.m4.cg(c.k4);
            }
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    };
    CategoryItemHighlightLayer.prototype.mq = function (a, b) {
        var e_2, _a;
        _super.prototype.mq.call(this, a, b);
        var c = this.m4.b3;
        var d = this.m4.b2;
        var e = 0;
        var f = 0;
        var g = a;
        try {
            for (var _b = __values(fromEnum(g.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                if (h.h != null) {
                    var i = d.item(f);
                    this.nn(h, i);
                    f++;
                }
                else {
                    var j = c.item(e);
                    this.no(h, j);
                    e++;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.count = e;
        d.count = f;
    };
    CategoryItemHighlightLayer.prototype.nn = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
            b._visibility = 1;
            return;
        }
        var c = { $type: Point_$type, x: a.b, y: a.e };
        var d = a.g;
        d.itemBrush = a.i;
        var e = d.series.ll(c, this.ca() || this.m9, this.m8);
        if (isNaN_(e.x) || isNaN_(e.y)) {
            b._visibility = 1;
            return;
        }
        this.m4.b9(b, e.x, e.y);
        b.ah = a.h;
        b.content = a.g;
    };
    CategoryItemHighlightLayer.prototype.no = function (a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.m4.ca(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.i;
        b._stroke = a.j;
        b.ac = a.d;
        if (this.lb != null) {
            b.ai = this.lb;
        }
        else {
            b.ai = null;
        }
        b.ad = this.lc;
    };
    CategoryItemHighlightLayer.prototype.c8 = function () {
        return true;
    };
    CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
    CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:nd:nq', [1, 10], 'HighlightType:m5:nr', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerTemplate:np:ns', [DataTemplate.$, null], 'SkipUnknownValues:na:nt', [0, true], 'TargetSeries:m7:nu', [Series.$, null], 'UseInterpolation:nb:nv', [0, false]]);
    return CategoryItemHighlightLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var CategoryItemHighlightLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryItemHighlightLayerView, _super);
    function CategoryItemHighlightLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b3 = null;
        _this.b2 = null;
        _this.b4 = null;
        _this.b5 = null;
        _this.b1 = a;
        _this.b4 = new List$1(ContentControl.$, 0);
        _this.b5 = new List$1(Rectangle.$, 0);
        return _this;
    }
    CategoryItemHighlightLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b3 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.ch);
            $ret.activate = runOn(_this, _this.cb);
            $ret.disactivate = runOn(_this, _this.cd);
            $ret.destroy = runOn(_this, _this.cc);
            return $ret;
        })());
        this.b2 = ((function () {
            var $ret = new Pool$1(ContentControl.$);
            $ret.create = runOn(_this, _this.ce);
            $ret.activate = runOn(_this, _this.b6);
            $ret.disactivate = runOn(_this, _this.b8);
            $ret.destroy = runOn(_this, _this.b7);
            return $ret;
        })());
    };
    CategoryItemHighlightLayerView.prototype.ch = function () {
        var a = new Rectangle();
        a.ab = false;
        this.b5.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.cb = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.cd = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.cc = function (a) {
        this.b5.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.ce = function () {
        var a = new Marker();
        this.b4.add(a);
        return a;
    };
    CategoryItemHighlightLayerView.prototype.b6 = function (a) {
        a._visibility = 0;
    };
    CategoryItemHighlightLayerView.prototype.b8 = function (a) {
        a._visibility = 1;
    };
    CategoryItemHighlightLayerView.prototype.b7 = function (a) {
        this.b4.remove(a);
    };
    CategoryItemHighlightLayerView.prototype.cf = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.3);
    };
    CategoryItemHighlightLayerView.prototype.cg = function (a) {
        if (a != null) {
            var b = BrushUtil.l(a, 0.3);
            if (b.isGradient) {
                var c = b;
                if (c.gradientStops != null) {
                    for (var d = 0; d < c.gradientStops.length; d++) {
                        var e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    };
    CategoryItemHighlightLayerView.prototype.ca = function (a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    };
    CategoryItemHighlightLayerView.prototype.b9 = function (a, b, c) {
        a.n = b;
        a.o = c;
    };
    CategoryItemHighlightLayerView.prototype.be = function (a, b) {
        _super.prototype.be.call(this, a, b);
        var c = a;
        var d = c.content;
        if (d != null) {
            if (d.itemBrush != null) {
                d.actualItemBrush = d.itemBrush;
            }
            var e = d.series;
            if (e.hasMarkers) {
                d.outline = e.k7();
            }
            d.thickness = 0.5;
        }
    };
    CategoryItemHighlightLayerView.prototype.a3 = function (a, b) {
        var e_3, _a;
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b5.count; c++) {
                var d = this.b5._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
            if (this.b4.count > 0) {
                var e = new DataTemplatePassInfo();
                e.isHitTestRender = b;
                e.context = a.g();
                e.viewportTop = this.br.top;
                e.viewportLeft = this.br.left;
                e.viewportWidth = this.br.width;
                e.viewportHeight = this.br.height;
                e.passID = "ItemMarkers";
                var f = new DataTemplateRenderInfo();
                f.isHitTestRender = b;
                f.passInfo = e;
                var g = new DataTemplateMeasureInfo();
                g.passInfo = e;
                var h = false;
                var i = a.g();
                g.context = i;
                f.context = i;
                g.renderContext = a;
                f.renderContext = a;
                var j = 0;
                var k = 0;
                var l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                for (var m = 0; m < this.b4.count; m++) {
                    var n = this.b4._inner[m];
                    var o = n.ah;
                    if (!l.containsKey(o)) {
                        l.addItem(o, o);
                        if (o != null && o.passStarting != null) {
                            o.passStarting(e);
                        }
                    }
                    if (n._visibility == 1) {
                        continue;
                    }
                    this.bd(n, m, b);
                    if (!h) {
                        g.data = n.content;
                        g.width = n.width;
                        g.height = n.height;
                        if (o.measure != null) {
                            g.data = n.content;
                            o.measure(g);
                            h = g.isConstant;
                            if (h) {
                                j = g.width;
                                k = g.height;
                            }
                        }
                        f.availableWidth = g.width;
                        f.availableHeight = g.height;
                    }
                    else {
                        f.availableWidth = j;
                        f.availableHeight = k;
                    }
                    if (!isNaN_(n.width) && !isInfinity(n.width)) {
                        f.availableWidth = n.width;
                    }
                    if (!isNaN_(n.height) && !isInfinity(n.height)) {
                        f.availableHeight = n.height;
                    }
                    a.p(f, n);
                    n.m = f.availableWidth;
                    n.l = f.availableHeight;
                }
                try {
                    for (var _b = __values(fromEnum(l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var p = _c.value;
                        if (p != null && p.passCompleted != null) {
                            p.passCompleted(e);
                        }
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
        }
    };
    CategoryItemHighlightLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b5.count; b++) {
            this.e.a2.exportRectangleData(a, this.b5._inner[b], "catItemRect", ["Main", "CategoryItem"]);
        }
        for (var c = 0; c < this.b4.count; c++) {
            this.e.a2.exportMarkerVisualDataFromMarker(this.e, a, this.b4._inner[c]);
        }
    };
    CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);
    return CategoryItemHighlightLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an annotation layer that highlights items in a series that use a category axis
 * either by drawing a banded shape at their position, or by rendering a marker at their position.
 * Depending on the type of series, the default highlight will be affected. To override
 * the type of highlight used, you can set the HighlightType property.
*/
var IgrCategoryItemHighlightLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryItemHighlightLayer, _super);
    function IgrCategoryItemHighlightLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryItemHighlightLayer.prototype.createImplementation = function () {
        return new CategoryItemHighlightLayer();
    };
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "targetSeries", {
        /**
         * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
        */
        get: function () {
            if (this.i.m7 == null) {
                return null;
            }
            if (!this.i.m7.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.m7);
                if (e) {
                    e._implementation = this.i.m7;
                }
                this.i.m7.externalObject = e;
            }
            return this.i.m7.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m7 = null : this.i.m7 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
        */
        get: function () {
            return this.i.nb;
        },
        set: function (v) {
            this.i.nb = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "highlightType", {
        /**
         * Gets or sets which type of highlight shape to use when highlighting items.
        */
        get: function () {
            return this.i.m5;
        },
        set: function (v) {
            this.i.m5 = ensureEnum(CategoryItemHighlightType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "markerTemplate", {
        /**
         * Gets or sets the template to use for marker visuals for the current series object.
        */
        get: function () {
            return this.i.np;
        },
        set: function (v) {
            this.i.np = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "bandHighlightWidth", {
        /**
         * Gets or sets the width to use for the highlight region if highlighting items in a grid aligned series (line, spline, etc), with a banded shape.
        */
        get: function () {
            return this.i.nd;
        },
        set: function (v) {
            this.i.nd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryItemHighlightLayer.prototype, "skipUnknownValues", {
        /**
         * Gets or sets whether to skip unknown values when searching for series values.
        */
        get: function () {
            return this.i.na;
        },
        set: function (v) {
            this.i.na = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryItemHighlightLayer.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    };
    return IgrCategoryItemHighlightLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryItemHighlightLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryItemHighlightLayerModule() {
    }
    IgrCategoryItemHighlightLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrCategoryItemHighlightLayer", IgrCategoryItemHighlightLayer);
        TypeRegistrar.register("CategoryItemHighlightLayer", CategoryItemHighlightLayer.$type);
    };
    return IgrCategoryItemHighlightLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.ne = null;
        _this.nd = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.fi / 1000;
        _this.l2 = a;
        _this.l1 = b;
        _this.l3 = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.bf = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m6 = a;
    };
    CrosshairLayer.prototype.m8 = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.m9 = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "pi", {
        get: function () {
            return new Thickness(1, this.ng, this.ni, this.nh, this.nf);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "pj", {
        get: function () {
            return new Thickness(1, this.nl, this.nn, this.nm, this.nk);
        },
        enumerable: true,
        configurable: true
    });
    CrosshairLayer.prototype.ml = function (a, b) {
        if (this.m7 == null || this.m7 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    };
    CrosshairLayer.prototype.mn = function (a, b) {
        var e_1, _a;
        _super.prototype.mn.call(this, a, b);
        var c = a;
        var d = this.nc;
        var e = this.nb;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.l8(this.m7)) {
            this.oi(this.m7, c, d, e);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.l8(f)) {
                        this.oi(f, c, d, e);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CrosshairLayer.prototype.l8 = function (a) {
        if (!_super.prototype.l8.call(this, a)) {
            return false;
        }
        var b = this.mg(a);
        if (!b.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.io = function () {
        _super.prototype.io.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.oj(this.l3, false);
        }
        else {
            this.oj(this.l1, false);
        }
    };
    CrosshairLayer.prototype.oi = function (a, b, c, d) {
        var e = this.mg(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.ll(f, c, d);
        var g = this.k3;
        if (g == null) {
            g = this.k5;
        }
        if (g == null) {
            g = a.k3;
            if (g != null) {
                g = this.m6.b8(g);
            }
        }
        var h = g;
        var i = g;
        if (this.pa != null) {
            h = this.pa;
        }
        if (this.pb != null) {
            i = this.pb;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.na) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.pc, this.pe, this.pd, this.pi, this.nj, this.pf, this.ph, this.pg, this.pj, this.no, this.pl == 0, this.pk == 0);
        }
    };
    CrosshairLayer.prototype.oj = function (a, b) {
        var c = false;
        if (this.nd == null) {
            c = true;
            this.ne = new List$1(Axis.$, 0);
            this.nd = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.nd, this.ne, b, this.np, this.nq, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.oh = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.ey;
        f.ai = this.lb;
        f.ad = this.lc;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.mq = function (a, b) {
        _super.prototype.mq.call(this, a, b);
        var c = this.m6.b2;
        var d = a;
        var e = d.ad.count;
        var f = 0;
        var g = b.br.left;
        var h = b.br.right;
        var i = b.br.top;
        var j = b.br.bottom;
        var k = this.pl == 0;
        var l = this.pk == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.ad._inner[m]);
            var o = Math.floor(d.ae._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.oh(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.ak = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.oh(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.ak = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.oj(this.l3, true);
        }
        else {
            this.oj(this.l1, false);
        }
    };
    CrosshairLayer.prototype.c8 = function () {
        return true;
    };
    CrosshairLayer.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.jd(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:pa:ok', [Brush.$, null], 'HorizontalLineVisibility:pk:ol', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:na:om', [0, false], 'SkipUnknownValues:nb:on', [0, true], 'TargetSeries:m7:oo', [Series.$, null], 'UseInterpolation:nc:op', [0, true], 'VerticalLineStroke:pb:oq', [Brush.$, null], 'VerticalLineVisibility:pl:or', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:pc:os', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:np:ot', [1, -1], 'XAxisAnnotationOutline:pd:ou', [Brush.$, null], 'XAxisAnnotationPaddingBottom:nf:ov', [1, NaN], 'XAxisAnnotationPaddingLeft:ng:ow', [1, NaN], 'XAxisAnnotationPaddingRight:nh:ox', [1, NaN], 'XAxisAnnotationPaddingTop:ni:oy', [1, NaN], 'XAxisAnnotationStrokeThickness:nj:oz', [1, NaN], 'XAxisAnnotationTextColor:pe:o0', [Brush.$, null], 'YAxisAnnotationBackground:pf:o1', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:nq:o2', [1, -1], 'YAxisAnnotationOutline:pg:o3', [Brush.$, null], 'YAxisAnnotationPaddingBottom:nk:o4', [1, NaN], 'YAxisAnnotationPaddingLeft:nl:o5', [1, NaN], 'YAxisAnnotationPaddingRight:nm:o6', [1, NaN], 'YAxisAnnotationPaddingTop:nn:o7', [1, NaN], 'YAxisAnnotationStrokeThickness:no:o8', [1, NaN], 'YAxisAnnotationTextColor:ph:o9', [Brush.$, null]]);
    return CrosshairLayer;
}(AnnotationLayer));
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this.b3 = null;
        _this.b1 = a;
        _this.b3 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b2 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.b9);
            $ret.activate = runOn(_this, _this.b4);
            $ret.disactivate = runOn(_this, _this.b6);
            $ret.destroy = runOn(_this, _this.b5);
            return $ret;
        })());
    };
    CrosshairLayerView.prototype.b9 = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    };
    CrosshairLayerView.prototype.b4 = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.b6 = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.b5 = function (a) {
        this.b3.remove(a);
    };
    CrosshairLayerView.prototype.b7 = function (a, b, c, d) {
        if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.ak = e;
        }
    };
    CrosshairLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    CrosshairLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b3.count; c++) {
                var d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
var IgrCrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCrosshairLayer, _super);
    function IgrCrosshairLayer(props) {
        return _super.call(this, props) || this;
    }
    IgrCrosshairLayer.prototype.createImplementation = function () {
        return new CrosshairLayer();
    };
    Object.defineProperty(IgrCrosshairLayer.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "horizontalLineStroke", {
        /**
         * Gets or sets the color to use for the horizontal line. Leave null for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pa);
        },
        set: function (v) {
            this.i.pa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "verticalLineStroke", {
        /**
         * Gets or sets the color to use for vertical line. Leave null for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pb);
        },
        set: function (v) {
            this.i.pb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "targetSeries", {
        /**
         * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
        */
        get: function () {
            if (this.i.m7 == null) {
                return null;
            }
            if (!this.i.m7.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.m7);
                if (e) {
                    e._implementation = this.i.m7;
                }
                this.i.m7.externalObject = e;
            }
            return this.i.m7.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m7 = null : this.i.m7 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "useInterpolation", {
        /**
         * Gets or sets whether to use value interpolation when drawing a line through the best value for the cursor position.
        */
        get: function () {
            return this.i.nc;
        },
        set: function (v) {
            this.i.nc = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "isAxisAnnotationEnabled", {
        /**
         * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
        */
        get: function () {
            return this.i.na;
        },
        set: function (v) {
            this.i.na = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationTextColor", {
        /**
         * Gets or sets the color to use for the x axis annotation text. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pe);
        },
        set: function (v) {
            this.i.pe = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationBackground", {
        /**
         * Gets or sets the color to use for the x axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pc);
        },
        set: function (v) {
            this.i.pc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationInterpolatedValuePrecision", {
        /**
         * Gets or sets the precision to use displaying values for interpolated crosshair positions.
        */
        get: function () {
            return this.i.np;
        },
        set: function (v) {
            this.i.np = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationOutline", {
        /**
         * Gets or sets the color to use for the x axis annotation outline. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pd);
        },
        set: function (v) {
            this.i.pd = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationPaddingLeft", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.ng;
        },
        set: function (v) {
            this.i.ng = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.ni;
        },
        set: function (v) {
            this.i.ni = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nh;
        },
        set: function (v) {
            this.i.nh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nf;
        },
        set: function (v) {
            this.i.nf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationPaddingLeft", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nl;
        },
        set: function (v) {
            this.i.nl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationPaddingTop", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nn;
        },
        set: function (v) {
            this.i.nn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationPaddingRight", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nm;
        },
        set: function (v) {
            this.i.nm = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationPaddingBottom", {
        /**
         * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
        */
        get: function () {
            return this.i.nk;
        },
        set: function (v) {
            this.i.nk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "xAxisAnnotationStrokeThickness", {
        /**
         * Gets or sets the stroke thickness for the x axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.nj;
        },
        set: function (v) {
            this.i.nj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationTextColor", {
        /**
         * Gets or sets the color to use for the y axis annotation text. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.ph);
        },
        set: function (v) {
            this.i.ph = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationBackground", {
        /**
         * Gets or sets the color to use for the y axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pf);
        },
        set: function (v) {
            this.i.pf = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationInterpolatedValuePrecision", {
        /**
         * Gets or sets the precision to use displaying values for interpolated crosshair positions.
        */
        get: function () {
            return this.i.nq;
        },
        set: function (v) {
            this.i.nq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationOutline", {
        /**
         * Gets or sets the color to use for the y axis annotation outline. Leave unset for an automatic value.
        */
        get: function () {
            return brushToString(this.i.pg);
        },
        set: function (v) {
            this.i.pg = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "yAxisAnnotationStrokeThickness", {
        /**
         * Gets or sets the stroke thickness for the y axis annotation backing. Leave unset for an automatic value.
        */
        get: function () {
            return this.i.no;
        },
        set: function (v) {
            this.i.no = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "verticalLineVisibility", {
        /**
         * Gets or sets whether to display the vertical line.
        */
        get: function () {
            return this.i.pl;
        },
        set: function (v) {
            this.i.pl = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "horizontalLineVisibility", {
        /**
         * Gets or sets whether to display the horizontal line.
        */
        get: function () {
            return this.i.pk;
        },
        set: function (v) {
            this.i.pk = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCrosshairLayer.prototype, "skipUnknownValues", {
        /**
         * Gets or sets whether to skip unknown values when searching for series values.
        */
        get: function () {
            return this.i.nb;
        },
        set: function (v) {
            this.i.nb = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrCrosshairLayer.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    };
    return IgrCrosshairLayer;
}(IgrAnnotationLayer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCrosshairLayerModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCrosshairLayerModule() {
    }
    IgrCrosshairLayerModule.register = function () {
        IgrAnnotationLayerProxyModule.register();
        TypeRegistrar.registerCons("IgrCrosshairLayer", IgrCrosshairLayer);
        TypeRegistrar.register("CrosshairLayer", CrosshairLayer.$type);
    };
    return IgrCrosshairLayerModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHorizontalAnchoredCategorySeriesProxy_$type = /*@__PURE__*/ new Type(null, 'IHorizontalAnchoredCategorySeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IBucketizer_$type = /*@__PURE__*/ new Type(null, 'IBucketizer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ISortingAxis_$type = /*@__PURE__*/ new Type(null, 'ISortingAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ISupportsErrorBars_$type = /*@__PURE__*/ new Type(null, 'ISupportsErrorBars');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ISupportsMarkers_$type = /*@__PURE__*/ new Type(null, 'ISupportsMarkers');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultSupportsMarkers = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultSupportsMarkers, _super);
    function DefaultSupportsMarkers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefaultSupportsMarkers.prototype, "shouldDisplayMarkers", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    DefaultSupportsMarkers.prototype.updateMarkerCount = function (a) {
    };
    DefaultSupportsMarkers.prototype.updateMarkerTemplate = function (a, b, c) {
    };
    DefaultSupportsMarkers.$t = markType(DefaultSupportsMarkers, 'DefaultSupportsMarkers', Base.$, [ISupportsMarkers_$type]);
    return DefaultSupportsMarkers;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultProvidesViewport = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultProvidesViewport, _super);
    function DefaultProvidesViewport() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultProvidesViewport.prototype.getViewInfo = function (a, b) {
        a = Rect.empty;
        b = Rect.empty;
        return {
            p0: a,
            p1: b
        };
    };
    DefaultProvidesViewport.prototype.getEffectiveViewport = function () {
        return Rect.empty;
    };
    DefaultProvidesViewport.$t = markType(DefaultProvidesViewport, 'DefaultProvidesViewport', Base.$, [IProvidesViewport_$type]);
    return DefaultProvidesViewport;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultSupportsErrorBars = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultSupportsErrorBars, _super);
    function DefaultSupportsErrorBars() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefaultSupportsErrorBars.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultSupportsErrorBars.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return null;
        },
        enumerable: true,
        configurable: true
    });
    DefaultSupportsErrorBars.$t = markType(DefaultSupportsErrorBars, 'DefaultSupportsErrorBars', Base.$, [ISupportsErrorBars_$type]);
    return DefaultSupportsErrorBars;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FramePreparer, _super);
    function FramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.a = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        _this.c = new DefaultSupportsMarkers();
                        _this.a = new DefaultProvidesViewport();
                        _this.b = new DefaultSupportsErrorBars();
                        if (f != null) {
                            _this.c = f;
                        }
                        if (g != null) {
                            _this.a = g;
                        }
                        if (h != null) {
                            _this.b = h;
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    _this.c = new DefaultSupportsMarkers();
                    _this.a = new DefaultProvidesViewport();
                    _this.b = new DefaultSupportsErrorBars();
                    if (c != null) {
                        _this.c = c;
                    }
                    if (d != null) {
                        _this.a = d;
                    }
                    if (e != null) {
                        _this.b = e;
                    }
                }
                break;
        }
        return _this;
    }
    FramePreparer.$t = markType(FramePreparer, 'FramePreparer');
    return FramePreparer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IIsCategoryBased_$type = /*@__PURE__*/ new Type(null, 'IIsCategoryBased');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFrame, _super);
    function CategoryFrame(a) {
        var _this = _super.call(this) || this;
        _this.z = null;
        _this.f = new List$1(Array_$type, 0);
        _this.k = new List$1(Number_$type, 0);
        _this.l = new List$1(Number_$type, 0);
        _this.m = new List$1(Point_$type, 0);
        _this.n = new List$1(Number_$type, 0);
        _this.p = new List$1(Point_$type, 0);
        _this.q = new List$1(Number_$type, 0);
        _this.i = new List$1(Point_$type, 0);
        _this.j = new List$1(Number_$type, 0);
        _this.h = new List$1(Number_$type, 0);
        _this.g = new List$1(Number_$type, 0);
        _this.o = new List$1(Number_$type, 0);
        _this.t = 0;
        _this.s = 0;
        _this.aa = null;
        _this.z = new Rect(0, 0, 0, 1, 1);
        _this.s = a;
        _this.w();
        return _this;
    }
    CategoryFrame.prototype.c = function (a, b, c) {
        this.w();
        var d = typeCast(CategoryFrame.$, b);
        var e = typeCast(CategoryFrame.$, c);
        var f = d.f.count;
        var g = e.f.count;
        var h = Math.max(f, g);
        var i = Math.max(d.m.count, e.m.count);
        var j = Math.max(d.p.count, e.p.count);
        var k = Math.max(d.k.count, e.k.count);
        var l = Math.max(d.i.count, e.i.count);
        var m = d.o.count > 0;
        if (m) {
            this.x(this.o, a, d.o, e.o, h);
        }
        var n = d.n.count > 0;
        if (n) {
            this.x(this.n, a, d.n, e.n, i);
        }
        var o = d.q.count > 0;
        if (o) {
            this.x(this.q, a, d.q, e.q, j);
        }
        var p = d.l.count > 0;
        if (p) {
            this.x(this.l, a, d.l, e.l, k);
        }
        var q = d.j.count > 0;
        if (q) {
            this.x(this.j, a, d.j, e.j, l);
        }
        if (this.f.count < h) {
            while (this.f.count < h) {
                this.f.add(new Array(this.s));
            }
        }
        if (this.f.count > h) {
            this.f.v(h, this.f.count - h);
        }
        if (m) {
            var r = 0;
            for (var s = 0; s < Math.min(f, g); ++s) {
                var t = this.f._inner[s];
                r = a * this.o._inner[s];
                r = r > 1 ? 1 : r;
                for (var u = 0; u < this.s; ++u) {
                    t[u] = d.f._inner[s][u] + r * (e.f._inner[s][u] - d.f._inner[s][u]);
                }
            }
        }
        else {
            for (var v = 0; v < Math.min(f, g); ++v) {
                var w = this.f._inner[v];
                for (var x = 0; x < this.s; ++x) {
                    w[x] = d.f._inner[v][x] + a * (e.f._inner[v][x] - d.f._inner[v][x]);
                }
            }
        }
        if (f < g) {
            var y = new Array(this.s);
            for (var z = this.s - 1; z >= 0; --z) {
                y[z] = d.f.count > 0 ? d.f._inner[d.f.count - 1][z] : 0;
            }
            if (m) {
                var aa = 0;
                for (var ab = f; ab < g; ++ab) {
                    var ac = this.f._inner[ab];
                    aa = a * this.o._inner[ab];
                    aa = aa > 1 ? 1 : aa;
                    for (var ad = this.s - 1; ad >= 0; --ad) {
                        ac[ad] = y[ad] + aa * (e.f._inner[ab][ad] - y[ad]);
                    }
                }
            }
            else {
                for (var ae = f; ae < g; ++ae) {
                    var af = this.f._inner[ae];
                    for (var ag = this.s - 1; ag >= 0; --ag) {
                        af[ag] = y[ag] + a * (e.f._inner[ae][ag] - y[ag]);
                    }
                }
            }
        }
        if (f > g) {
            var ah = new Array(this.s);
            for (var ai = this.s - 1; ai >= 0; --ai) {
                ah[ai] = e.f.count > 0 ? e.f._inner[e.f.count - 1][ai] : 0;
            }
            if (m) {
                var aj = 0;
                for (var ak = g; ak < f; ++ak) {
                    var al = this.f._inner[ak];
                    aj = a * this.o._inner[ak];
                    aj = aj > 1 ? 1 : aj;
                    for (var am = this.s - 1; am >= 0; --am) {
                        al[am] = d.f._inner[ak][am] + aj * (ah[am] - d.f._inner[ak][am]);
                    }
                }
            }
            else {
                for (var an = g; an < f; ++an) {
                    var ao = this.f._inner[an];
                    for (var ap = this.s - 1; ap >= 0; --ap) {
                        ao[ap] = d.f._inner[an][ap] + a * (ah[ap] - d.f._inner[an][ap]);
                    }
                }
            }
        }
        if (n) {
            Frame.d(this.m, a, d.m, e.m, this.n);
        }
        else {
            Frame.a(this.m, a, d.m, e.m);
        }
        if (o) {
            Frame.d(this.p, a, d.p, e.p, this.q);
        }
        else {
            Frame.a(this.p, a, d.p, e.p);
        }
        if (p) {
            Frame.d(this.i, a, d.i, e.i, this.l);
        }
        else {
            Frame.a(this.i, a, d.i, e.i);
        }
        if (q) {
            Frame.e(this.h, a, d.h, e.h, this.j);
            Frame.e(this.g, a, d.g, e.g, this.j);
        }
        else {
            Frame.b(this.h, a, d.h, e.h);
            Frame.b(this.g, a, d.g, e.g);
        }
        var aq = d.aa;
        var ar = e.aa;
        if (Rect.l_op_Equality(aq, null)) {
            aq = this.z;
        }
        if (Rect.l_op_Equality(ar, null)) {
            ar = this.z;
        }
        var as = aq.left + (ar.left - aq.left) * a;
        var at = aq.top + (ar.top - aq.top) * a;
        var au = Math.max(0, aq.width + (ar.width - aq.width) * a);
        var av = Math.max(0, aq.height + (ar.height - aq.height) * a);
        this.aa = new Rect(0, as, at, au, av);
    };
    CategoryFrame.prototype.x = function (a, b, c, d, e) {
        if (d.count == 0) {
            for (var f = 0; f < c.count; f++) {
                d.add(c._inner[f]);
            }
        }
        else {
            Frame.b(a, b, c, d);
        }
        if (a.count < e) {
            var g = a.count;
            for (var h = 0; h < e - g; h++) {
                a.add(1);
            }
        }
    };
    CategoryFrame.prototype.v = function () {
        this.o.clear();
        this.q.clear();
        this.n.clear();
        this.l.clear();
        this.j.clear();
    };
    CategoryFrame.prototype.u = function () {
        this.w();
        this.v();
        this.aa = this.z;
    };
    CategoryFrame.prototype.y = function () {
        this.u();
        this.f.clear();
        this.i.clear();
        this.k.clear();
        this.m.clear();
        this.p.clear();
    };
    CategoryFrame.prototype.w = function () {
        CategoryFrame.r++;
        if (CategoryFrame.r >= (0x7FFFFFFF - 1)) {
            CategoryFrame.r = 0;
        }
        this.t = CategoryFrame.r;
    };
    CategoryFrame.$t = markType(CategoryFrame, 'CategoryFrame', Frame.$);
    CategoryFrame.r = 0;
    return CategoryFrame;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PreparationParams = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PreparationParams, _super);
    function PreparationParams() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = 0;
        _this.j = 0;
        _this.h = 0;
        _this.g = 0;
        _this.m = null;
        _this.l = null;
        _this.k = null;
        _this.b = null;
        _this.d = null;
        _this.c = null;
        _this.a = null;
        _this.e = false;
        _this.f = false;
        return _this;
    }
    PreparationParams.$t = markType(PreparationParams, 'PreparationParams');
    return PreparationParams;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IDateTimeAxis_$type = /*@__PURE__*/ new Type(null, 'IDateTimeAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHasTrendline_$type = /*@__PURE__*/ new Type(null, 'IHasTrendline');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHasCategoryTrendline_$type = /*@__PURE__*/ new Type(null, 'IHasCategoryTrendline', null, [IHasTrendline_$type]);
/**
 * @hidden
 */
var IPreparesCategoryTrendline_$type = /*@__PURE__*/ new Type(null, 'IPreparesCategoryTrendline');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHasSingleValueCategory_$type = /*@__PURE__*/ new Type(null, 'IHasSingleValueCategory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultCategoryTrendlinePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultCategoryTrendlinePreparer, _super);
    function DefaultCategoryTrendlinePreparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultCategoryTrendlinePreparer.prototype.prepareLine = function (a, b, c, d) {
    };
    DefaultCategoryTrendlinePreparer.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
    };
    DefaultCategoryTrendlinePreparer.$t = markType(DefaultCategoryTrendlinePreparer, 'DefaultCategoryTrendlinePreparer', Base.$, [IPreparesCategoryTrendline_$type]);
    return DefaultCategoryTrendlinePreparer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultCategoryTrendlineHost = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultCategoryTrendlineHost, _super);
    function DefaultCategoryTrendlineHost() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = new DefaultCategoryTrendlinePreparer();
        return _this;
    }
    Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendlinePreparer", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendLineType", {
        get: function () {
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "trendLinePeriod", {
        get: function () {
            return 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultCategoryTrendlineHost.prototype, "isVertical", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    DefaultCategoryTrendlineHost.$t = markType(DefaultCategoryTrendlineHost, 'DefaultCategoryTrendlineHost', Base.$, [IHasCategoryTrendline_$type]);
    return DefaultCategoryTrendlineHost;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultSingleValueProvider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultSingleValueProvider, _super);
    function DefaultSingleValueProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefaultSingleValueProvider.prototype, "valueColumn", {
        get: function () {
            return new List$1(Number_$type, 0);
        },
        enumerable: true,
        configurable: true
    });
    DefaultSingleValueProvider.$t = markType(DefaultSingleValueProvider, 'DefaultSingleValueProvider', Base.$, [IHasSingleValueCategory_$type]);
    return DefaultSingleValueProvider;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValuesHolder, _super);
    function ValuesHolder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = 0;
        _this.b = 0;
        _this.c = 0;
        _this.d = 0;
        return _this;
    }
    ValuesHolder.$t = markType(ValuesHolder, 'ValuesHolder');
    return ValuesHolder;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SingleValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SingleValuesHolder, _super);
    function SingleValuesHolder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = null;
        return _this;
    }
    SingleValuesHolder.prototype.get_e = function () {
        if (this.f != null) {
            return this.f.count;
        }
        return 0;
    };
    Object.defineProperty(SingleValuesHolder.prototype, "e", {
        get: function () {
            return this.get_e();
        },
        enumerable: true,
        configurable: true
    });
    SingleValuesHolder.$t = markType(SingleValuesHolder, 'SingleValuesHolder', ValuesHolder.$);
    return SingleValuesHolder;
}(ValuesHolder));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ICategorySeriesInteractionManager_$type = /*@__PURE__*/ new Type(null, 'ICategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available transition effects that can applied to initial rendering of a series
 */
var CategoryTransitionInMode = /*@__PURE__*/ (function (CategoryTransitionInMode) {
    /**
     * Series transitions in an automatically chosen based on type of series and its orientation
     */
    CategoryTransitionInMode[CategoryTransitionInMode["Auto"] = 0] = "Auto";
    /**
     * Series transitions in from the reference value of the value axis.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["FromZero"] = 1] = "FromZero";
    /**
     * Series sweeps in from the left
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromLeft"] = 2] = "SweepFromLeft";
    /**
     * Series sweeps in from the right
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromRight"] = 3] = "SweepFromRight";
    /**
     * Series sweeps in from the top.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromTop"] = 4] = "SweepFromTop";
    /**
     * Series sweeps in from the bottom.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromBottom"] = 5] = "SweepFromBottom";
    /**
     * Series sweeps in from the center.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCenter"] = 6] = "SweepFromCenter";
    /**
     * Series accordions in from the left.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromLeft"] = 7] = "AccordionFromLeft";
    /**
     * Series accordions in from the right.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromRight"] = 8] = "AccordionFromRight";
    /**
     * Series accordions in from the top.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromTop"] = 9] = "AccordionFromTop";
    /**
     * Series accordions in from the bottom.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromBottom"] = 10] = "AccordionFromBottom";
    /**
     * Series expands from the value midpoints.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["Expand"] = 11] = "Expand";
    /**
     * Series sweeps in from the category axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMinimum"] = 12] = "SweepFromCategoryAxisMinimum";
    /**
     * Series sweeps in from the category axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMaximum"] = 13] = "SweepFromCategoryAxisMaximum";
    /**
     * Series sweeps in from the value axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMinimum"] = 14] = "SweepFromValueAxisMinimum";
    /**
     * Series sweeps in from the value axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMaximum"] = 15] = "SweepFromValueAxisMaximum";
    /**
     * Series accordions in from the category axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMinimum"] = 16] = "AccordionFromCategoryAxisMinimum";
    /**
     * Series accordions in from the category axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMaximum"] = 17] = "AccordionFromCategoryAxisMaximum";
    /**
     * Series accordions in from the value axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMinimum"] = 18] = "AccordionFromValueAxisMinimum";
    /**
     * Series accordions in from the value axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMaximum"] = 19] = "AccordionFromValueAxisMaximum";
    return CategoryTransitionInMode;
})({});
/**
 * @hidden
 */
var CategoryTransitionInMode_$type = /*@__PURE__*/ markEnum('CategoryTransitionInMode', 'Auto,0|FromZero,1|SweepFromLeft,2|SweepFromRight,3|SweepFromTop,4|SweepFromBottom,5|SweepFromCenter,6|AccordionFromLeft,7|AccordionFromRight,8|AccordionFromTop,9|AccordionFromBottom,10|Expand,11|SweepFromCategoryAxisMinimum,12|SweepFromCategoryAxisMaximum,13|SweepFromValueAxisMinimum,14|SweepFromValueAxisMaximum,15|AccordionFromCategoryAxisMinimum,16|AccordionFromCategoryAxisMaximum,17|AccordionFromValueAxisMinimum,18|AccordionFromValueAxisMaximum,19');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTransitionSourceFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTransitionSourceFramePreparer, _super);
    function CategoryTransitionSourceFramePreparer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = new Random(0);
        return _this;
    }
    CategoryTransitionSourceFramePreparer.prototype.p = function (a, b, c, d, e, f, g, h, i, j, k) {
        a.aa = new Rect(0, 0, 0, 1, 1);
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        var l = false;
        var m = false;
        if (e != null) {
            l = e.b8;
        }
        if (d != null) {
            m = d.b8;
        }
        var n = f;
        if (n == 0) {
            n = g;
        }
        switch (n) {
            case 1:
                var o = j();
                this.t(a, b, o, c);
                break;
            case 7:
                this.r(a, b, false, c, k);
                break;
            case 9:
                this.s(a, b, true, c, k);
                break;
            case 10:
                this.s(a, b, false, c, k);
                break;
            case 8:
                this.r(a, b, true, c, k);
                break;
            case 2:
                this.u(a, b, false);
                break;
            case 3:
                this.u(a, b, true);
                break;
            case 4:
                this.v(a, b, true);
                break;
            case 5:
                this.v(a, b, false);
                break;
            case 6:
                this.j(a, b);
                a.aa = new Rect(0, 0.5, 0.5, 0, 0);
                break;
            case 16:
                if (c) {
                    this.s(a, b, l, c, k);
                }
                else {
                    this.r(a, b, m, c, k);
                }
                break;
            case 17:
                if (c) {
                    this.s(a, b, !l, c, k);
                }
                else {
                    this.r(a, b, !m, c, k);
                }
                break;
            case 18:
                if (c) {
                    this.r(a, b, m, c, k);
                }
                else {
                    this.s(a, b, l, c, k);
                }
                break;
            case 19:
                if (c) {
                    this.r(a, b, !m, c, k);
                }
                else {
                    this.s(a, b, !l, c, k);
                }
                break;
            case 12:
                if (c) {
                    this.v(a, b, l);
                }
                else {
                    this.u(a, b, m);
                }
                break;
            case 13:
                if (c) {
                    this.v(a, b, !l);
                }
                else {
                    this.u(a, b, !m);
                }
                break;
            case 14:
                if (c) {
                    this.u(a, b, m);
                }
                else {
                    this.v(a, b, l);
                }
                break;
            case 15:
                if (c) {
                    this.u(a, b, !m);
                }
                else {
                    this.v(a, b, !l);
                }
                break;
            case 11:
                this.q(a, b);
                break;
        }
        if (h == 0) {
            h = i;
        }
        a.v();
        b.v();
        switch (h) {
            case 3:
                this.b(a.f.count, n, a.o, b.o, d, e, c, k);
                this.b(a.m.count, n, a.n, b.n, d, e, c, k);
                this.b(a.p.count, n, a.q, b.q, d, e, c, k);
                this.b(a.i.count, n, a.l, b.l, d, e, c, k);
                this.b(a.h.count, n, a.j, b.j, d, e, c, k);
                break;
            case 2:
                var p = j();
                this.d(a.f.count, p, n, a.f, b.f, a.o, b.o, d, e, c, k);
                this.f(a.m.count, p, n, a.m, b.m, a.n, b.n, d, e, c, k);
                this.f(a.p.count, p, n, a.p, b.p, a.q, b.q, d, e, c, k);
                this.f(a.i.count, p, n, a.i, b.i, a.l, b.l, d, e, c, k);
                this.e(a.h.count, p, n, a.h, b.h, a.j, b.j, d, e, c, k);
                break;
            case 4:
                this.c(a.f.count, n, a.o, b.o);
                this.c(a.m.count, n, a.n, b.n);
                this.c(a.p.count, n, a.q, b.q);
                this.c(a.i.count, n, a.l, b.l);
                this.c(a.h.count, n, a.j, b.j);
                break;
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.c = function (a, b, c, d) {
        if (a == 0) {
            return;
        }
        for (var e = 0; e < a; e++) {
            c.add(1 + this.a.nextDouble());
            d.add(1 + this.a.nextDouble());
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.d = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        var l = false;
        var m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.b8;
        }
        var n = k.bottom;
        var o = k.bottom;
        var p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        var q;
        for (var r = 0; r < a; r++) {
            q = e._inner[r];
            for (var s = 1; s < q.length; s++) {
                if (isNaN_(q[s]) || isInfinity(q[s])) {
                    continue;
                }
                n = Math.max(n, Math.abs(b - q[s]));
            }
        }
        var t;
        var u;
        var v;
        for (var w = 0; w < a; w++) {
            q = e._inner[w];
            t = Math.abs(q[1] - b);
            u = Math.abs(q[1] - b);
            for (var x = 1; x < q.length; x++) {
                if (isNaN_(q[x]) || isInfinity(q[x])) {
                    continue;
                }
                t = Math.max(Math.abs(q[x] - b), t);
                u = Math.min(Math.abs(q[x] - b), u);
            }
            var y = (t + u) / 2;
            if (isNaN_(y) || n == 0) {
                v = 1;
            }
            else {
                v = y / n;
            }
            f.add(2 - v);
            g.add(2 - v);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.f = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        var l = false;
        var m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.b8;
        }
        var n = k.bottom;
        var o = k.bottom;
        var p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        var q;
        for (var r = 0; r < a; r++) {
            q = e._inner[r];
            if (j) {
                if (isNaN_(q.x) || isInfinity(q.x)) {
                    continue;
                }
                n = Math.max(n, Math.abs(q.x - b));
            }
            else {
                if (isNaN_(q.y) || isInfinity(q.y)) {
                    continue;
                }
                n = Math.max(n, Math.abs(q.y - b));
            }
        }
        var s;
        for (var t = 0; t < a; t++) {
            q = e._inner[t];
            var u = void 0;
            if (j) {
                u = q.x;
            }
            else {
                u = q.y;
            }
            if (isNaN_(u) || isInfinity(u) || n == 0) {
                s = 1;
            }
            else {
                s = Math.abs(u - b) / n;
            }
            f.add(2 - s);
            g.add(2 - s);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.e = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        var l = false;
        var m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.b8;
        }
        var n = k.bottom;
        var o = k.bottom;
        var p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        var q;
        for (var r = 0; r < a; r++) {
            q = e._inner[r];
            if (isNaN_(q) || isInfinity(q)) {
                continue;
            }
            n = Math.max(n, Math.abs(q - b));
        }
        var s;
        for (var t = 0; t < a; t++) {
            q = e._inner[t];
            var u = void 0;
            u = q;
            if (n == 0 || isNaN_(u) || isInfinity(u)) {
                s = 1;
            }
            else {
                s = Math.abs(u - b) / n;
            }
            f.add(2 - s);
            g.add(2 - s);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.b = function (a, b, c, d, e, f, g, h) {
        if (a == 0) {
            return;
        }
        var i = e;
        if (g) {
            i = f;
        }
        var j = false;
        if (i != null) {
            j = i.b8;
        }
        var k;
        for (var l = 0; l < a; l++) {
            if (a == 1) {
                k = 1;
            }
            else {
                k = l / (a - 1);
            }
            k = 1 - k;
            c.add(1 + k);
            d.add(1 + k);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.q = function (a, b) {
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        this.g(a.f, b.f);
        this.h(a.k, b.k);
        this.k(a.m, b.m);
        this.k(a.p, b.p);
        this.k(a.i, b.i);
        this.h(a.h, b.h);
        this.h(a.g, b.g);
        var c = a.f.count;
        var d = a.f;
        var e;
        var f;
        var g;
        var h;
        for (var i = 0; i < c; i++) {
            e = d._inner[i];
            f = e[1];
            g = e[1];
            for (var j = 2; j < e.length; j++) {
                f = Math.min(f, e[j]);
                g = Math.max(g, e[j]);
            }
            h = (f + g) / 2;
            for (var k = 1; k < e.length; k++) {
                e[k] = h;
            }
        }
        var l = a.h.count;
        var m = a.h;
        var n = a.g;
        for (var o = 0; o < l; o++) {
            m._inner[o] = 0;
            n._inner[o] = 0;
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.u = function (a, b, c) {
        if (c) {
            this.j(a, b);
            a.aa = new Rect(0, 1, 0, 0, 1);
        }
        else {
            this.j(a, b);
            a.aa = new Rect(0, 0, 0, 0, 1);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.v = function (a, b, c) {
        if (c) {
            this.j(a, b);
            a.aa = new Rect(0, 0, 0, 1, 0);
        }
        else {
            this.j(a, b);
            a.aa = new Rect(0, 0, 1, 1, 0);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.j = function (a, b) {
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        this.g(a.f, b.f);
        this.h(a.k, b.k);
        this.k(a.m, b.m);
        this.k(a.p, b.p);
        this.k(a.i, b.i);
        this.h(a.h, b.h);
        this.h(a.g, b.g);
    };
    CategoryTransitionSourceFramePreparer.prototype.o = function (a, b, c, d, e) {
        var f = b.count;
        var g;
        var h;
        for (var i = 0; i < f; i++) {
            g = b._inner[i];
            if (e) {
                if (c) {
                    h = { $type: Point_$type, x: d, y: g.y };
                }
                else {
                    h = { $type: Point_$type, x: g.x, y: d };
                }
            }
            else {
                if (c) {
                    h = { $type: Point_$type, x: g.x, y: d };
                }
                else {
                    h = { $type: Point_$type, x: d, y: g.y };
                }
            }
            a.add(h);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.k = function (a, b) {
        var c = b.count;
        var d;
        var e;
        for (var f = 0; f < c; f++) {
            d = b._inner[f];
            e = { $type: Point_$type, x: d.x, y: d.y };
            a.add(e);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.g = function (a, b) {
        var c = b.count;
        var d = b;
        var e;
        var f;
        var g = a;
        for (var h = 0; h < c; h++) {
            f = d._inner[h];
            e = new Array(f.length);
            for (var i = 0; i < e.length; i++) {
                e[i] = f[i];
            }
            g.add(e);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.l = function (a, b, c, d, e) {
        var f = b.count;
        var g = b;
        var h;
        var i;
        var j = a;
        for (var k = 0; k < f; k++) {
            i = g._inner[k];
            h = new Array(i.length);
            if (e) {
                h[0] = i[0];
                for (var l = 1; l < h.length; l++) {
                    h[l] = d;
                }
            }
            else {
                h[0] = d;
                for (var m = 1; m < h.length; m++) {
                    h[m] = i[m];
                }
            }
            j.add(h);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.n = function (a, b) {
        var c = b.count;
        var d;
        for (var e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.i = function (a, b) {
        var c = b.count;
        var d;
        for (var e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.h = function (a, b) {
        var c = b.count;
        var d;
        for (var e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.m = function (a, b, c, d, e) {
        var f = b.count;
        var g;
        for (var h = 0; h < f; h++) {
            g = b._inner[h];
            a.add(g);
        }
    };
    CategoryTransitionSourceFramePreparer.prototype.r = function (a, b, c, d, e) {
        var f = e.right;
        if (!c) {
            f = e.left;
        }
        var g = false;
        if (d) {
            g = true;
        }
        this.l(a.f, b.f, d, f, g);
        this.m(a.k, b.k, d, f, g);
        this.o(a.m, b.m, d, f, g);
        this.o(a.p, b.p, d, f, g);
        this.o(a.i, b.i, d, f, g);
        this.m(a.h, b.h, d, f, g);
        this.m(a.g, b.g, d, f, g);
    };
    CategoryTransitionSourceFramePreparer.prototype.s = function (a, b, c, d, e) {
        var f = e.bottom;
        if (c) {
            f = e.top;
        }
        var g = true;
        if (d) {
            g = false;
        }
        this.l(a.f, b.f, d, f, g);
        this.m(a.k, b.k, d, f, g);
        this.o(a.m, b.m, d, f, g);
        this.o(a.p, b.p, d, f, g);
        this.o(a.i, b.i, d, f, g);
        this.m(a.h, b.h, d, f, g);
        this.m(a.g, b.g, d, f, g);
    };
    CategoryTransitionSourceFramePreparer.prototype.t = function (a, b, c, d) {
        this.l(a.f, b.f, d, c, true);
        this.m(a.k, b.k, d, c, true);
        this.o(a.m, b.m, d, c, true);
        this.o(a.p, b.p, d, c, true);
        this.o(a.i, b.i, d, c, true);
        this.m(a.h, b.h, d, c, true);
        this.m(a.g, b.g, d, c, true);
    };
    CategoryTransitionSourceFramePreparer.$t = markType(CategoryTransitionSourceFramePreparer, 'CategoryTransitionSourceFramePreparer');
    return CategoryTransitionSourceFramePreparer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AssigningCategoryStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AssigningCategoryStyleEventArgsBase, _super);
    function AssigningCategoryStyleEventArgsBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.m = 0;
        _this.l = 0;
        _this.h = new Date();
        _this.g = new Date();
        _this.a = null;
        _this.n = null;
        _this.o = null;
        _this.j = 0;
        _this.b = null;
        _this.i = 0;
        _this.k = 0;
        _this.d = false;
        _this.c = false;
        _this.e = false;
        _this.f = false;
        return _this;
    }
    AssigningCategoryStyleEventArgsBase.$t = markType(AssigningCategoryStyleEventArgsBase, 'AssigningCategoryStyleEventArgsBase');
    return AssigningCategoryStyleEventArgsBase;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AssigningCategoryStyleEventArgs, _super);
    function AssigningCategoryStyleEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.r = 0;
        _this.s = null;
        _this.t = 0;
        _this.p = 0;
        _this.q = 0;
        return _this;
    }
    AssigningCategoryStyleEventArgs.$t = markType(AssigningCategoryStyleEventArgs, 'AssigningCategoryStyleEventArgs', AssigningCategoryStyleEventArgsBase.$);
    return AssigningCategoryStyleEventArgs;
}(AssigningCategoryStyleEventArgsBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AssigningCategoryMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AssigningCategoryMarkerStyleEventArgs, _super);
    function AssigningCategoryMarkerStyleEventArgs() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AssigningCategoryMarkerStyleEventArgs.$t = markType(AssigningCategoryMarkerStyleEventArgs, 'AssigningCategoryMarkerStyleEventArgs', AssigningCategoryStyleEventArgsBase.$);
    return AssigningCategoryMarkerStyleEventArgs;
}(AssigningCategoryStyleEventArgsBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategorySeriesRenderManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeriesRenderManager, _super);
    function CategorySeriesRenderManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ah = null;
        _this.ai = null;
        _this.l = 0;
        _this.an = null;
        _this.ap = 0;
        _this.j = 0;
        _this.k = 0;
        _this.i = 0;
        _this.h = 0;
        _this.ar = 0;
        _this.aq = 0;
        _this.al = null;
        _this.am = null;
        _this.r = 0;
        _this.ao = null;
        _this.as = 0;
        _this.p = 0;
        _this.q = 0;
        _this.o = 0;
        _this.n = 0;
        _this.au = 0;
        _this.at = 0;
        _this.aj = null;
        _this.ak = null;
        _this.m = 0;
        _this.f = false;
        _this.e = false;
        _this.af = null;
        _this.ag = null;
        _this.g = 0;
        _this.c = null;
        _this.b = null;
        _this.d = null;
        _this.s = 0;
        _this.t = 0;
        return _this;
    }
    CategorySeriesRenderManager.prototype.w = function (a, b, c, d, e) {
        this.s = d;
        this.t = e;
        this.e = false;
        this.aj = a.mv;
        this.ak = a.mw;
        this.m = 1;
        this.af = this.aj;
        this.ag = this.ak;
        this.g = this.m;
        var f = b;
        this.b = null;
        if (f) {
            this.b = new AssigningCategoryMarkerStyleEventArgs();
            this.b.i = 0;
            this.b.k = 0;
            if (a.bs != null && a.b9) {
                this.b.i = a.bs.az.maxMarkerHighlightingProgress;
                this.b.k = a.bs.az.sumMarkerHighlightingProgress;
            }
            this.b.a = c;
        }
    };
    CategorySeriesRenderManager.prototype.x = function (a, b, c, d, e, f) {
        this.s = e;
        this.t = f;
        this.f = false;
        this.al = a.k3;
        this.am = a.k4;
        this.r = a.ey;
        this.ao = a.lb;
        this.as = a.lc;
        this.p = 0;
        this.q = 0;
        this.o = 1;
        this.n = a.es;
        this.au = a.le;
        this.at = a.ld;
        this.ah = this.al;
        this.ai = this.am;
        this.l = this.r;
        this.an = this.ao;
        this.ap = this.as;
        this.j = this.p;
        this.k = this.q;
        this.i = this.o;
        this.h = this.n;
        this.ar = this.au;
        this.aq = this.at;
        this.d = c;
        var g = b;
        this.c = null;
        if (g) {
            this.c = new AssigningCategoryStyleEventArgs();
            this.c.i = 0;
            this.c.k = 0;
            if (a.bs != null && a.b9) {
                this.c.i = a.bs.az.maxHighlightingProgress;
                this.c.k = a.bs.az.sumHighlightingProgress;
            }
            this.c.a = d;
        }
    };
    CategorySeriesRenderManager.prototype.ae = function (a, b, c, d, e) {
        var f = this.ah;
        if (e) {
            f = this.ai;
        }
        if (c) {
            a._fill = f;
        }
        else {
            if (b) {
                a._stroke = f;
            }
            else {
                a._fill = f;
                a._stroke = this.ai;
            }
            a.ac = this.l;
            a.ai = this.an;
            a.ad = this.ap;
            if (d) {
            }
        }
        a._opacity = this.i;
    };
    CategorySeriesRenderManager.prototype.ad = function (a, b) {
        a._opacity = this.g;
        b.itemBrush = this.af;
        b.actualItemBrush = b.itemBrush;
        b.outline = this.ag;
        b.thickness = DeviceUtils.g(2);
    };
    CategorySeriesRenderManager.prototype.a = function (a, b) {
        var c = this.s;
        var d = Math.min(b * c, a - 1);
        var e = Math.min(d + c - 1, a - 1);
        var f = new Array(2);
        f[0] = Math.min(d + this.t * c, a - 1);
        f[1] = Math.min(e + this.t * c, a - 1);
        return f;
    };
    CategorySeriesRenderManager.prototype.u = function (a) {
        if (a == null) {
            return;
        }
        if (a.b == null) {
            return;
        }
        this.ah = a.b.a0.a$ai(a.b, a, this.ah);
        this.ai = a.b.a0.a$ai(a.b, a, this.ai);
    };
    CategorySeriesRenderManager.prototype.v = function (a) {
        if (a == null) {
            return;
        }
        if (a.b == null) {
            return;
        }
        this.af = a.b.a0.a$ai(a.b, a, this.af);
        this.ag = a.b.a0.a$ai(a.b, a, this.ag);
    };
    CategorySeriesRenderManager.prototype.y = function (a, b, c, d, e, f, g, h, i) {
        if (d == -1) {
            if (b) {
                a.c = true;
                a.h = f.e9();
                a.g = f.e8();
            }
            else {
                a.c = false;
                a.m = 0;
                a.l = e - 1;
            }
        }
        else {
            if (b) {
                var longStart_ = truncate(f.dz(c._inner[d][0], g));
                var longEnd_ = longStart_;
                if (d + 1 < c.count) {
                    longEnd_ = truncate(f.dz(c._inner[d + 1][0], g));
                }
                a.c = true;
                a.h = (new Date(longStart_));
                a.g = (new Date(longEnd_));
                if (f.b8) {
                    var j = a.g;
                    a.g = a.h;
                    a.h = j;
                }
                if (i) {
                    a.m = d;
                    a.l = d;
                }
                else {
                    var k = this.a(e, d);
                    a.m = k[0];
                    a.l = k[1];
                }
            }
            else {
                if (i) {
                    a.m = d;
                    a.l = d;
                }
                else {
                    var l = this.a(e, d);
                    a.c = false;
                    a.m = l[0];
                    a.l = l[1];
                }
            }
        }
    };
    CategorySeriesRenderManager.prototype.ac = function (a, b, c, d, e, f, g) {
        this.ah = this.al;
        this.ai = this.am;
        this.l = this.r;
        this.an = this.ao;
        this.ap = this.as;
        this.j = this.p;
        this.k = this.q;
        this.i = this.o;
        var h = this.c;
        var i = d.cd;
        this.y(h, i, a, b, c, d, e, f, false);
        h.n = this.ah;
        h.o = this.ai;
        h.r = this.l;
        h.s = this.an;
        h.t = this.ap;
        h.p = this.j;
        h.q = this.k;
        h.j = this.i;
        h.e = this.f;
        h.d = false;
    };
    CategorySeriesRenderManager.prototype.aa = function (a, b, c) {
        var d = this.c;
        this.ah = d.n;
        this.ai = d.o;
        this.l = d.r;
        this.an = d.s;
        this.ap = d.t;
        this.j = d.p;
        this.k = d.q;
        this.i = d.j;
        if (c && !d.d && !b) {
            this.u(a);
        }
    };
    CategorySeriesRenderManager.prototype.ab = function (a, b, c, d, e, f, g) {
        this.af = this.aj;
        this.ag = this.ak;
        this.g = this.m;
        var h = this.b;
        var i = d.cd;
        this.y(h, i, a, b, c, d, e, f, true);
        h.n = this.af;
        h.o = this.ag;
        h.j = this.g;
        h.e = this.e;
        h.d = false;
    };
    CategorySeriesRenderManager.prototype.z = function (a, b, c) {
        var d = this.b;
        this.af = d.n;
        this.ag = d.o;
        this.g = d.j;
        if (c && !d.d && !b) {
            this.v(a);
        }
    };
    CategorySeriesRenderManager.$t = markType(CategorySeriesRenderManager, 'CategorySeriesRenderManager');
    return CategorySeriesRenderManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryBucketCalculator, _super);
    function CategoryBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.e = 0;
        _this.f = 0;
        _this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.c = a;
        _this.e = -1;
        _this.d = 0;
        return _this;
    }
    CategoryBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    CategoryBucketCalculator.prototype.g = function (a) {
        var b = this.c.bs;
        var c = this.c.br;
        var d = this.c.cp;
        var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        var f = d.bz;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        var g = d.getEffectiveViewport1(this.c);
        var h = d.lq(this.c);
        var i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            var j = new ScalerParams(0, b, c, e.b8, g);
            var k = Math.floor(e.d0(h.left, j, 0));
            var l = Math.ceil(e.d0(h.right, j, 0));
            if (e.b8) {
                l = Math.ceil(e.d0(h.left, j, 0));
                k = Math.floor(e.d0(h.right, j, 0));
            }
            var m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    };
    CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cp.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    CategoryBucketCalculator.prototype.cacheValues = function () {
    };
    CategoryBucketCalculator.prototype.unCacheValues = function () {
    };
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
}(Base));
/**
 * @hidden
 */
var CategoryFramePreparerBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparerBase, _super);
    function CategoryFramePreparerBase(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, g, h, i) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new List$1(Array_$type, 0);
                        _this.p = new List$1(Number_$type, 0);
                        _this.n = new List$1(Number_$type, 0);
                        _this.h = f;
                        _this.g = j;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, d, e, f) || this;
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                    _this.h = c;
                    _this.g = g;
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparerBase.prototype.i = function (a) {
        var b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        var c;
        var d;
        var e;
        var f;
        var g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        var h;
        var i;
        var j;
        var k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.cs) && this.g != null) {
            b.e = true;
        }
        return b;
    };
    CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
        return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    };
    CategoryFramePreparerBase.prototype.s = function (a) {
        return this.r(a.b, a.m, a.l, a.k);
    };
    CategoryFramePreparerBase.prototype.d = function (a, b) {
        var c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        var d = this.c.shouldDisplayMarkers;
        var e = false;
        var f = this.s(c);
        var g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            var h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            var i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            var j = c.i;
            var k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            var l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        var m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    };
    CategoryFramePreparerBase.prototype.v = function (a, b) {
    };
    Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h = null;
        var i = false;
        var j = a.d != null;
        var k = a.m;
        var l = a.l;
        var m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.ju;
        var n = a.f;
        var o = this.h.mayContainUnknowns;
        var p = this.o;
        var q = this.n;
        var r = this.p;
        p.clear();
        q.clear();
        r.clear();
        var s = this.g;
        var t = this.h.provideCollisionDetector();
        var u = 0;
        var v = a.k;
        var w = new ScalerParams(0, k, l, a.b.j$a, v);
        var x = ((function () {
            var $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, _this.h) !== null ? _this.h.eh() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        var y = a.i;
        var z = a.j;
        var aa = a.a.f;
        var ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        var _loop_1 = function (ac) {
            var ad = void 0;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            var ae = !m || (m && ad[1] > 0);
            var af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    var ag = ac * a.h;
                    var ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    var ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this_1.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
            out_ac_1 = ac;
        };
        var this_1 = this, out_ac_1;
        for (var ac = y; ac <= z; ++ac) {
            _loop_1(ac);
            ac = out_ac_1;
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            var aj = p.count;
            var ak = void 0;
            for (var al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    };
    CategoryFramePreparerBase.prototype.k = function () {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.ck;
        }
        return false;
    };
    CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
        var h;
        f = null;
        e = false;
        var i = typeCast(CategorySeries.$, this.h);
        var j = a.l;
        var k = a.m;
        var l = a.k;
        var m = new ScalerParams(0, k, j, a.b.j$a, l);
        var n = new ScalerParams(0, k, j, a.c.j$a, l);
        var o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.bz != null && i.bz.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        var p = a.d.i$b._inner[b];
        var q = a.d.i$d(p);
        var r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    var s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                var t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                var u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        var v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    };
    CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.o;
        var l = k.count;
        if (f) {
            var m = a.c.j$b(a.c.ke, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            var n = a.a.k;
            var o = n.count;
            for (var p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    };
    CategoryFramePreparerBase.prototype.w = function (a, b, c) {
    };
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
}(FramePreparer));
/**
 * @hidden
 */
var CategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryFramePreparer, _super);
    function CategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = null;
                        _this.ab = null;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = null;
                    _this.ab = null;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    CategoryFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        var c = this.ab.valueColumn;
        b.f = c;
        return b;
    };
    CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    };
    CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (var p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (var q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (var r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    };
    CategoryFramePreparer.prototype.w = function (a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        this.aa.trendlinePreparer.prepareLine(this.aa, a, b, c);
    };
    CategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = f.item(b);
        var h = g;
        if (d) {
            var i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    };
    CategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        if (b < e.count) {
            var f = void 0;
            if (c) {
                var g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    };
    CategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
}(CategoryFramePreparerBase));
/**
 * @hidden
 */
var CategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeries, _super);
    function CategorySeries() {
        var _this = _super.call(this) || this;
        _this.nb = null;
        _this.no = null;
        _this.ns = false;
        _this.nr = false;
        _this.assigningCategoryStyle = null;
        _this.assigningCategoryMarkerStyle = null;
        _this.nm = null;
        _this.nn = null;
        _this.m8 = new CategoryFrame(3);
        _this.na = new CategoryFrame(3);
        _this.m7 = new CategoryFrame(3);
        _this.m9 = new CategoryFrame(3);
        _this.ne = null;
        _this.ni = null;
        _this.ne = new CategorySeriesRenderManager();
        _this.ni = new CategoryTransitionSourceFramePreparer();
        _this.ns = false;
        _this.nr = false;
        _this.ab = CategorySeries.$;
        return _this;
    }
    CategorySeries.prototype.bf = function () {
        var a = new CategorySeriesView(this);
        return a;
    };
    Object.defineProperty(CategorySeries.prototype, "np", {
        get: function () {
            var _this = this;
            if (this.no == null) {
                this.no = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.no;
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ch = function (a, b, c) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.fetchXAxis();
        var f = new ScalerParams(1, this.bs.mq, this.ly, e.b8);
        f.c = d;
        var g = this.fetchYAxis();
        var h = new ScalerParams(1, this.bs.mq, this.ly, g.b8);
        h.c = d;
        var i = this.bs.mq;
        var j = this.ly;
        var k = this.currentMode2Index;
        var l = 0;
        if (e.b5 && e.b3) {
            l = e.getSeriesOffset(i, j, d, k, e.categoryMode);
        }
        a.clear();
        this.l0.cc(function (m) {
            if (m._visibility == 0) {
                var n = new SeriesPointOfInterest();
                var o = m.n;
                var p = m.o;
                if (o < _this.ly.left || o > _this.ly.right || p < _this.ly.top || p > _this.ly.bottom) {
                    return;
                }
                if (e.b2 && !e.b5 && e.categoryMode != 0) {
                    n.b = m.ak;
                }
                else {
                    n.b = e.dz(o, f);
                }
                if (g.b2 && !g.b5 && g.categoryMode != 0) {
                    n.c = m.ak;
                }
                else {
                    n.c = g.dz(p, h);
                }
                n.a = m.content;
                if (b) {
                    n.d = _this.oa(n.c, c);
                }
                else {
                    n.d = e.fj(m.ak);
                }
                a.add(n);
            }
        });
        return true;
    };
    CategorySeries.prototype.oa = function (a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    };
    CategorySeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.nf = a;
    };
    CategorySeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
        get: function () {
            return this.m6();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.m6 = function () {
        return this.fetchXAxis();
    };
    CategorySeries.prototype.nq = function () {
        return this.fetchYAxis();
    };
    CategorySeries.prototype.get_cl = function () {
        return true;
    };
    CategorySeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.nf.cn.g(this.eu);
    };
    CategorySeries.prototype.nz = function () {
        return (this.assigningCategoryStyle != null && this.ns) || this.cu;
    };
    CategorySeries.prototype.n0 = function () {
        return (this.assigningCategoryMarkerStyle != null && this.nr) || this.cu;
    };
    CategorySeries.prototype.on = function (a) {
        if (this.assigningCategoryStyle != null && this.ns) {
            this.assigningCategoryStyle(this, a);
        }
    };
    CategorySeries.prototype.om = function (a) {
        if (this.assigningCategoryMarkerStyle != null && this.nr) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    };
    CategorySeries.prototype.m0 = function (a, b) {
        return null;
    };
    CategorySeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        if (a) {
            this.oh(b);
        }
    };
    CategorySeries.prototype.a8 = function () {
        var a = _super.prototype.a8.call(this);
        return a;
    };
    CategorySeries.prototype.ib = function () {
        _super.prototype.ib.call(this);
        var a = this.fetchXAxis();
        if (a != null) {
            a.g6(false);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.g6(false);
        }
    };
    CategorySeries.prototype.jt = function (a, b) {
        _super.prototype.jt.call(this, a, b);
        this.nf.cn.g(this.eu);
        this.jd(false);
    };
    CategorySeries.prototype.js = function (a, b) {
        if (this.dm && this.ez < 0.05 && (this.bs == null || !this.bs.c5())) {
            this.dn = true;
        }
        _super.prototype.js.call(this, a, b);
        this.nf.cn.g(this.eu);
        this.jd(false);
    };
    CategorySeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = this.fetchYAxis();
                var f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.hz(f);
                    this.hz(e);
                }
                if (c == null && d != null) {
                    this.i4(f);
                    this.i4(e);
                }
                this.nf.cn.g(this.eu);
                this.jd(false);
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.nf.cn.g(this.eu);
                }
                this.jd(false);
                break;
            case "TransitionProgress":
                this.na.c(this.ez, this.m8, this.m7);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.m7.v();
                    this.oo(this.m7, this.nf);
                    if (this.dm) {
                        this.dm = false;
                        this.hw();
                        this.bt.r = truncate(this.eq());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.oo(this.na, this.nf);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case "ErrorBarSettings":
                this.ik();
                break;
            case CategorySeries.$$p[4]:
                this.jd(false);
                break;
            case CategorySeries.$$p[1]:
                this.ns = this.nu();
                this.jd(false);
                break;
            case CategorySeries.$$p[0]:
                this.nr = this.nt();
                this.jd(false);
                break;
        }
    };
    CategorySeries.prototype.nu = function () {
        return this.nx;
    };
    CategorySeries.prototype.nt = function () {
        return this.nw;
    };
    CategorySeries.prototype.n5 = function (a) {
        return this.ed(a, this.fetchXAxis());
    };
    CategorySeries.prototype.get_c1 = function () {
        return typeCast(ISortingAxis_$type, this.m6()) !== null;
    };
    CategorySeries.prototype.ap = function () {
        return this.m6();
    };
    CategorySeries.prototype.fa = function (a) {
        return this.np.b$d(this, a);
    };
    CategorySeries.prototype.fp = function (a) {
        return this.np.b$f(this, a);
    };
    CategorySeries.prototype.e8 = function (a) {
        var b = truncate(Math.round(this.eb(a)));
        return b;
    };
    CategorySeries.prototype.eb = function (a) {
        return this.np.b$c(this, a);
    };
    CategorySeries.prototype.get_nv = function () {
        return false;
    };
    Object.defineProperty(CategorySeries.prototype, "nv", {
        get: function () {
            return this.get_nv();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.au = function (a, b) {
        var c = this.nl(a, b, this.nn);
        this.nn = c;
        return c;
    };
    CategorySeries.prototype.get_cv = function () {
        return true;
    };
    CategorySeries.prototype.at = function (a, b) {
        if (this.nv) {
            var c = this.nk(a, b, this.nm);
            this.nm = c;
            return c;
        }
        else {
            var d = this.nj(a, b, this.nm);
            this.nm = d;
            return d;
        }
    };
    CategorySeries.prototype.n4 = function () {
        return this.nf.cq.a;
    };
    CategorySeries.prototype.nl = function (a, b, c) {
        if (!this.l3()) {
            return null;
        }
        var d = this.m7;
        if (this.ca()) {
            d = this.na;
        }
        var e = this.n4();
        return this.np.b$b(this, e, d.f, a, b, c);
    };
    CategorySeries.prototype.nk = function (a, b, c) {
        var d = this.nf.cn.e;
        var e = this.nf.cn.f;
        var f = this.nf.cn.d;
        var g = this.m7;
        if (this.ca()) {
            g = this.na;
        }
        return this.np.b$a(this, g.f, d, e, f, a, b, c);
    };
    CategorySeries.prototype.nj = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    CategorySeries.prototype.oj = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.ne.ab(a, b, c, d, e, f, g);
        var h = this.ne.b;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, true);
            h.b = i;
        }
        h.f = f;
        this.om(h);
        this.ne.z(i, f, g);
    };
    CategorySeries.prototype.ok = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.ne.ac(a, b, c, d, e, f, g);
        var h = this.ne.c;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.on(h);
        this.ne.aa(i, f, g);
    };
    CategorySeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        d = d && this.n3(this.fetchXAxis());
        d = d && this.n3(this.fetchYAxis());
        var e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.bz == null) {
            d = false;
        }
        if (!d) {
            e.cn.d = 0;
        }
        return d;
    };
    CategorySeries.prototype.n3 = function (a) {
        if (a == null || a.bf == null) {
            return false;
        }
        var b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.jy < 1) {
                return false;
            }
        }
        else {
            var c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.j4 != c.j3;
            }
        }
        return true;
    };
    CategorySeries.prototype.dc = function () {
        return this.ny;
    };
    CategorySeries.prototype.ng = function () {
        return 12;
    };
    CategorySeries.prototype.hw = function () {
        _super.prototype.hw.call(this);
        this.m8.v();
        this.m7.v();
        this.na.v();
    };
    CategorySeries.prototype.je = function (a) {
        _super.prototype.je.call(this, a);
        this.nf.cn.g(this.eu);
        if (this.cc(this.bi)) {
            this.m7.y();
            this.na.y();
            this.m8.y();
            return;
        }
        if (this.de) {
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.oo(this.na, this.nf);
            }
            else {
                this.oo(this.m7, this.nf);
            }
            return;
        }
        if (this.da(a)) {
            var b = this.m8;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.m8 = this.na;
                this.na = b;
            }
            else {
                this.m8 = this.m7;
                this.m7 = b;
            }
            this.ol(this.m7, this.nf);
            if (this.dp) {
                this.bt.w();
                this.bt.r = truncate(this.er());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.ni.p(this.m8, this.m7, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.nh, this.ng(), this.bp, this.bo(), runOn(this, this.n6), this.nf.br);
            }
            this.hs();
            this.jl();
            if (this.dp) {
                this.dn = false;
                this.dm = true;
            }
        }
        else {
            this.ol(this.m7, this.nf);
            this.oo(this.m7, this.nf);
        }
    };
    CategorySeries.prototype.bo = function () {
        return 3;
    };
    CategorySeries.prototype.n6 = function () {
        if (this.isVertical) {
            return this.ly.left;
        }
        return this.ly.bottom;
    };
    CategorySeries.prototype.n9 = function () {
        var e_1, _a;
        var a = 0;
        var b = this.fetchXAxis();
        try {
            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c == this) {
                    return a;
                }
                var d = typeCast(CategorySeries.$, c);
                if (d != null) {
                    var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                    if (e == b && d.preferredCategoryMode(e) == 2) {
                        a++;
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.fetchXAxis();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.fetchYAxis();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.oi = function (a, b) {
        this.ne.w(this, this.n0(), runOn(this, this.m0), this.n7(a), this.n8(a));
        var c = this.ne.b;
        var d = c != null;
        var e = this.m6();
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bs, a.br, e.b8, f);
        var h = this.bz == null ? 0 : this.bz.count;
        var i = a;
        var j = b.f;
        var k = i.cn.e;
        var l = i.cn.f;
        var m = i.cn.d;
        var n = k * m;
        for (var o = 0; o < a.cq.count; o++) {
            var p = a.cq.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.oj(j, r, h, e, g, a.n);
            }
            this.ne.ad(p, q);
        }
    };
    CategorySeries.prototype.oo = function (a, b) {
        this.lp = a.aa;
        b.ar();
    };
    CategorySeries.prototype.ol = function (a, b) {
        a.u();
    };
    CategorySeries.prototype.n7 = function (a) {
        return a.cn.d;
    };
    CategorySeries.prototype.n8 = function (a) {
        return a.cn.e;
    };
    CategorySeries.prototype.oh = function (a) {
        var b = a;
        b.cq.count = 0;
    };
    CategorySeries.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        var c = typeCast(CategorySeriesView.$, this.bh);
        c.cn.g(this.eu);
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        this.op();
        this.dl = false;
    };
    CategorySeries.prototype.op = function () {
        var a = typeCast(CategorySeriesView.$, this.bh);
        if (!this.df) {
            this.ol(this.m9, a);
        }
        this.df = false;
        this.oo(this.m9, a);
    };
    CategorySeries.prototype.nc = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cn);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.bs.bn.m, this, b.cn);
            }
        }
        else {
            return this.nb;
        }
    };
    CategorySeries.prototype.am = function (a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    };
    CategorySeries.prototype.ag = function () {
        return [this.fetchXAxis(), this.fetchYAxis()];
    };
    CategorySeries.m1 = function (a, b, c, d, e) {
        var f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            var h = c.bottom + 10;
            var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            var j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    };
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:nw:oq', [0, false], 'IsCustomCategoryStyleAllowed:nx:or', [0, false], 'IsTransitionInEnabled:ny:os', [0, false], 'TransitionInMode:nh:ot', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:n2:ou', [0, false]]);
    return CategorySeries;
}(MarkerSeries));
/**
 * @hidden
 */
var CategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeriesView, _super);
    function CategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cp = null;
        _this.cs = 0;
        _this.cn = null;
        _this.cq = null;
        _this.cs = -1;
        _this.cp = a;
        _this.cn = _this.co();
        _this.cq = ((function () {
            var $ret = new Pool$1(Marker.$);
            $ret.create = runOn(_this, _this.bx);
            $ret.activate = runOn(_this, _this.cg);
            $ret.disactivate = runOn(_this, _this.ci);
            $ret.destroy = runOn(_this, _this.ch);
            return $ret;
        })());
        return _this;
    }
    CategorySeriesView.prototype.cr = function (a) {
        if (this.cs != a.t) {
            return true;
        }
        return false;
    };
    CategorySeriesView.prototype.cu = function (a) {
        this.cs = a.t;
    };
    CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
        if (!this.by.l5) {
            var d = this.cq.item(a);
            var e = d.content;
            e.item = this.e.bz.item(b);
            d.ak = b;
            d.al = c;
        }
    };
    CategorySeriesView.prototype.co = function () {
        return new CategoryBucketCalculator(this);
    };
    Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
        get: function () {
            return this.cp.l3();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeriesView.prototype.updateMarkerCount = function (a) {
        this.cq.count = a;
    };
    CategorySeriesView.prototype.cc = function (a) {
        this.cq.c(a);
    };
    CategorySeriesView.prototype.ct = function () {
    };
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
}(MarkerSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrendLineSeries_$type = /*@__PURE__*/ new Type(null, 'ITrendLineSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IAnchoredCategorySeriesInteractionManager_$type = /*@__PURE__*/ new Type(null, 'IAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of collision avoidance of category series' markers.
 */
var CategorySeriesMarkerCollisionAvoidance = /*@__PURE__*/ (function (CategorySeriesMarkerCollisionAvoidance) {
    /**
     * Collision avoidance is disabled.
     */
    CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["None"] = 0] = "None";
    /**
     * Items colliding with other items will be hidden from view.
     */
    CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["Omit"] = 1] = "Omit";
    return CategorySeriesMarkerCollisionAvoidance;
})({});
/**
 * @hidden
 */
var CategorySeriesMarkerCollisionAvoidance_$type = /*@__PURE__*/ markEnum('CategorySeriesMarkerCollisionAvoidance', 'None,0|Omit,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Determines the item returned in hit-testing when mousing over an object which represents several consolidated items.
 */
var ConsolidatedItemHitTestBehavior = /*@__PURE__*/ (function (ConsolidatedItemHitTestBehavior) {
    /**
     * Returns the item based on the X-location only.  Will return one of the consolidated items.
     */
    ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["Basic"] = 0] = "Basic";
    /**
     * Returns the item with the nearest Y-location out of all the items with a matching X-location.
     */
    ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["NearestY"] = 1] = "NearestY";
    return ConsolidatedItemHitTestBehavior;
})({});
/**
 * @hidden
 */
var ConsolidatedItemHitTestBehavior_$type = /*@__PURE__*/ markEnum('ConsolidatedItemHitTestBehavior', 'Basic,0|NearestY,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryMarkerManager, _super);
    function CategoryMarkerManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CategoryMarkerManager.b = function (a, b, c, d) {
        var e = a.l3();
        if (c == null) {
            return;
        }
        if (e) {
            for (var f = 0; f < b.count; ++f) {
                CategoryMarkerManager.a(c, f, b, d);
            }
            c.count = b.count;
        }
    };
    CategoryMarkerManager.a = function (a, b, c, d) {
        a.item(b).n = c._inner[b].x;
        a.item(b).o = c._inner[b].y;
    };
    CategoryMarkerManager.$t = markType(CategoryMarkerManager, 'CategoryMarkerManager');
    return CategoryMarkerManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IDetectsCollisions_$type = /*@__PURE__*/ new Type(null, 'IDetectsCollisions');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CollisionAvoider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CollisionAvoider, _super);
    function CollisionAvoider() {
        var _this = _super.call(this) || this;
        _this.a = new List$1(Rect.$, 0);
        return _this;
    }
    CollisionAvoider.prototype.tryAdd = function (a) {
        for (var b = this.a.count - 1; b >= 0; --b) {
            if (a.left > this.a._inner[b].right) {
                break;
            }
            if (this.a._inner[b].intersectsWith(a)) {
                return false;
            }
        }
        if (this.a.count == 0 || a.right >= this.a._inner[this.a.count - 1].right) {
            this.a.add(a);
        }
        else {
            this.a.add(a);
            this.a.aa(function (c, d) { return Math.sign(c.right - d.right); });
        }
        return true;
    };
    CollisionAvoider.prototype.clear = function () {
        this.a.clear();
    };
    CollisionAvoider.$t = markType(CollisionAvoider, 'CollisionAvoider', Base.$, [IDetectsCollisions_$type]);
    return CollisionAvoider;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NonCollisionAvoider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NonCollisionAvoider, _super);
    function NonCollisionAvoider() {
        return _super.call(this) || this;
    }
    NonCollisionAvoider.staticInit = function () {
        NonCollisionAvoider.a = new NonCollisionAvoider();
    };
    NonCollisionAvoider.prototype.clear = function () {
    };
    NonCollisionAvoider.prototype.tryAdd = function (a) {
        return true;
    };
    NonCollisionAvoider.$t = markType(NonCollisionAvoider, 'NonCollisionAvoider', Base.$, [IDetectsCollisions_$type]);
    NonCollisionAvoider.a = null;
    return NonCollisionAvoider;
}(Base));
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTrendLineManagerFactory = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTrendLineManagerFactory, _super);
    function CategoryTrendLineManagerFactory() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CategoryTrendLineManagerFactory.a = function (a, b, c, d, e) {
        if (b != null && typeCast(ISortingAxis_$type, b) !== null) {
            if (a != null) {
                a.g$f();
            }
            if (!TypeRegistrar.isRegistered("SortingTrendLineManager")) {
                throw new NotSupportedException(1, e.p);
            }
            var f = TypeRegistrar.create("SortingTrendLineManager", (function (g) {
                var h = g;
                var i = typeCast(ISortingAxis_$type, b);
                if (i != null) {
                    g = Math.min(g, i.i$b.count - 1);
                    h = i.i$b._inner[g];
                }
                return i.i$d(h);
            }), (function (g, h, i) {
                var j = d.getEffectiveViewport1(d.bi);
                var k = new ScalerParams(0, i, h, b.b8, j);
                return b.dz(g, k);
            }));
            f.g$c(c, d);
            return f;
        }
        else if (a == null || a.g$a != 0) {
            if (a != null) {
                a.g$f();
            }
            if (!TypeRegistrar.isRegistered("CategoryTrendLineManager")) {
                throw new NotSupportedException(1, e.p);
            }
            var g = TypeRegistrar.create("CategoryTrendLineManager");
            g.g$c(c, d);
            return g;
        }
        return a;
    };
    CategoryTrendLineManagerFactory.$t = markType(CategoryTrendLineManagerFactory, 'CategoryTrendLineManagerFactory');
    return CategoryTrendLineManagerFactory;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeries, _super);
    function AnchoredCategorySeries() {
        var _this = _super.call(this) || this;
        _this.o2 = null;
        _this.o6 = false;
        _this.o4 = null;
        _this.oz = null;
        _this.o9 = null;
        _this.nb = new CategoryFramePreparer(1, _this, _this.nf, _this, _this, _this.nf.cn);
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeries.prototype, "o3", {
        get: function () {
            var _this = this;
            if (this.o2 == null) {
                this.o2 = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.o2;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    AnchoredCategorySeries.prototype.bf = function () {
        var a = new AnchoredCategorySeriesView(this);
        return a;
    };
    AnchoredCategorySeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oy = a;
    };
    AnchoredCategorySeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == AnchoredCategorySeries.$$p[2]) {
            return this.ft(a, b, this.pd);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
        get: function () {
            return this.o4;
        },
        set: function (a) {
            if (this.o4 != a) {
                var b = this.o4;
                this.o4 = a;
                if (!this.o6) {
                    this.raisePropertyChanged("ValueColumn", b, this.o4);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "pv", {
        get: function () {
            return this.c(AnchoredCategorySeries.pk);
        },
        set: function (a) {
            this.h(AnchoredCategorySeries.pk, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.c9 = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.fetchXAxis();
        var d = this.fetchYAxis();
        var e = this.ls(this.bi);
        var f = c != null ? this.nb.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.o3.c$a(this, this.valueColumn, c, d, f, a);
    };
    AnchoredCategorySeries.prototype.ov = function (a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cd;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    };
    AnchoredCategorySeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.oy.cz && this.oy.cy.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bw(this.pd);
                }
                var e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.cl()) {
                    this.oy.cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bw(this.pd);
                }
                this.o9 = this.pd;
                break;
            case "ValueColumn":
                if (this.oy.cz) {
                    this.oy.cy.g$i();
                }
                var f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.cl()) {
                    this.oy.cn.g(this.eu);
                    this.jd(false);
                }
                this.pj();
                this.jq();
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case "ErrorBarSettings":
                this.jd(false);
                break;
            case "TrendLineType":
                this.ik();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.jd(false);
                break;
        }
    };
    AnchoredCategorySeries.prototype.an = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    AnchoredCategorySeries.prototype.hy = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.oy.cn.g(this.eu);
                break;
        }
        if (this.oy.cz) {
            this.oy.cy.g$e(a, b, c, d);
        }
        this.pj();
        this.jq();
    };
    AnchoredCategorySeries.prototype.n6 = function () {
        return this.o7(this.nf);
    };
    AnchoredCategorySeries.prototype.o7 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(a);
        var f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            var g = new ScalerParams(0, c, d, f.b8, e);
            if (f.cf) {
                g.b = this.eh();
            }
            b = f.dw(f.ke, g);
        }
        return b;
    };
    AnchoredCategorySeries.prototype.pi = function (a, b, c) {
        var d = this.o7(c);
        if (a.count > 0) {
            var e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    };
    AnchoredCategorySeries.prototype.ow = function (a, b, c, d) {
        return this.ox(a, b, c, d, false);
    };
    AnchoredCategorySeries.prototype.ox = function (a, b, c, d, e) {
        return CategorySeries.m1(a, b, c, d, e);
    };
    AnchoredCategorySeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cn.d < 1) {
            d = false;
        }
        return d;
    };
    AnchoredCategorySeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.ct();
        if (c.cz) {
            c.cy.g$d();
        }
    };
    AnchoredCategorySeries.prototype.ol = function (a, b) {
        _super.prototype.ol.call(this, a, b);
        this.nc(b).d(a, b);
    };
    AnchoredCategorySeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = typeCast(AnchoredCategorySeriesView.$, b);
        c.b0 = true;
        if (c.cz) {
            c.cy.g$g(a.p);
        }
        if (this.l3()) {
            CategoryMarkerManager.b(this, a.m, b.cq, this.l5);
            this.oi(b, a);
            b.cj();
        }
        this.pf(a, b);
    };
    AnchoredCategorySeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.cn.g(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.oz == null) {
            this.oz = new CategoryFrame(3);
        }
        this.oz.u();
        this.ol(this.oz, g);
        this.oo(this.oz, g);
    };
    AnchoredCategorySeries.prototype.pf = function (a, b) {
    };
    AnchoredCategorySeries.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.oy.c3();
        if (this.trendLineBrush != null) {
            this.oy.c1();
        }
        else {
            this.oy.c0();
        }
    };
    AnchoredCategorySeries.prototype.fv = function (a, b) {
        if (this.oy.cz && a == this.oy.cy.g$j) {
            return null;
        }
        return _super.prototype.fv.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.oy.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.n9();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
        if (this.o0 == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.a;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
        get: function () {
            return this.oy.cz ? this.oy.cy : null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        if (this.oy.cz) {
            this.a2.exportTrendlineData(this, a, this.oy.cy.g$j);
        }
    };
    AnchoredCategorySeries.prototype.fp = function (a) {
        var _this = this;
        var b = this.fetchXAxis();
        var c = this.fetchYAxis();
        return this.o3.c$b(this, a, this.n7(this.bi), this.valueColumn, b, c, this.o1 == 1, function (d) { return _super.prototype.fp.call(_this, d); });
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.eh = function () {
        return Series.ei(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    };
    AnchoredCategorySeries.prototype.ao = function () {
        if (this.valueColumn == null) {
            return null;
        }
        var a = this.m6();
        var b = new ScalerParams(0, this.bs.mq, this.bs.m3, a.b8, this.getEffectiveViewport());
        var c = (a.dz(this.bs.m3.left, b));
        var d = (a.dz(this.bs.m3.right, b));
        var e = null;
        if (a.cd) {
            e = a;
            c = e.i$f(c);
            d = e.i$f(d);
        }
        else {
            c = Math.floor(c);
            d = Math.ceil(d);
        }
        if (isNaN_(c) || isNaN_(d)) {
            return null;
        }
        c = Math.max(0, Math.min(this.valueColumn.count - 1, c));
        d = Math.max(0, Math.min(this.valueColumn.count - 1, d));
        var f = 1.7976931348623157E+308;
        var g = -1.7976931348623157E+308;
        for (var h = truncate(c); h <= truncate(d); h++) {
            var i = h;
            if (e != null) {
                i = e.i$b._inner[h];
            }
            f = Math.min(f, this.valueColumn.item(i));
            g = Math.max(g, this.valueColumn.item(i));
        }
        return new AxisRange(f, g);
    };
    AnchoredCategorySeries.prototype.pj = function () {
        this.d8 = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.pk = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:o1:pl', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:o0:pm', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:pd:pu', [2, null], 'TrendLineType::ps', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::pr', [1, 1.5], 'TrendLinePeriod::pq', [1, 7], 'TrendLineBrush::pn', [Brush.$, null], 'TrendLineZIndex:o8:pt', [1, 1001], 'TrendLineDashArray:pw:po', [DoubleCollection.$], 'TrendLineDashCap:px:pp', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
}(CategorySeries));
/**
 * @hidden
 */
var AnchoredCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategoryBucketCalculator, _super);
    function AnchoredCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 0;
        var h = 0;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.cw.valueColumn.count;
        this.h = this.i.cw.valueColumn.asArray();
    };
    AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
}(CategoryBucketCalculator));
/**
 * @hidden
 */
var AnchoredCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeriesView, _super);
    function AnchoredCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cw = a;
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cy", {
        get: function () {
            if (this.cx == null) {
                this.cx = CategoryTrendLineManagerFactory.a(this.cx, this.e.ap(), this.e.jx, this.e, this.e.b2);
            }
            return this.cx;
        },
        set: function (a) {
            this.cx = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cz", {
        get: function () {
            return this.cx != null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeriesView.prototype.c3 = function () {
        this.cw.pv = null;
    };
    AnchoredCategorySeriesView.prototype.c1 = function () {
        this.cw.pv = this.cw.trendLineBrush;
    };
    AnchoredCategorySeriesView.prototype.c0 = function () {
        this.cw.pv = this.cw.k3;
    };
    AnchoredCategorySeriesView.prototype.co = function () {
        return new AnchoredCategoryBucketCalculator(this);
    };
    AnchoredCategorySeriesView.prototype.c2 = function () {
        this.cn.cacheValues();
    };
    AnchoredCategorySeriesView.prototype.c4 = function () {
        this.cn.unCacheValues();
    };
    AnchoredCategorySeriesView.prototype.c5 = function (a) {
        var b = this.cq.item(a);
        return this.cm(b);
    };
    AnchoredCategorySeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cw.trendLineType != 0 && !b) {
                var c = this.cy.g$j;
                c.ac = this.cw.trendLineThickness;
                c._stroke = this.cw.pv;
                c.ai = this.cw.pw;
                c.ad = this.cw.px;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.cw.o3.c$c(this.e, this.cw.pd);
    };
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
}(CategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHorizontalAnchoredCategorySeriesInteractionManager_$type = /*@__PURE__*/ new Type(null, 'IHorizontalAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAnchoredCategorySeries, _super);
    function HorizontalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.p2 = null;
        _this.py = null;
        _this.p4 = null;
        _this.p0 = 0;
        return _this;
    }
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "p3", {
        get: function () {
            var _this = this;
            if (this.p2 == null) {
                this.p2 = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.p2;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    HorizontalAnchoredCategorySeries.prototype.m6 = function () {
        return this.py;
    };
    HorizontalAnchoredCategorySeries.prototype.nq = function () {
        return this.p4;
    };
    HorizontalAnchoredCategorySeries.prototype.lw = function (a) {
        if (this.m7 == null || this.m7.m.count == 0 || !this.hasMarkers || !this.l3()) {
            return Rect.empty;
        }
        return this.p3.d$d(this, this.m7.m, a, runOn(this, this.qg));
    };
    HorizontalAnchoredCategorySeries.prototype.qg = function (a) {
        return this.oy.c5(a);
    };
    HorizontalAnchoredCategorySeries.prototype.p8 = function (a, b, c) {
        return this.p3.d$c(this, this.nq(), a, b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.ah = function (a) {
        return this.p3.d$a(this, this.m7.f, this.n7(this.bi), this.n8(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.ai = function (a) {
        return this.p3.d$b(this, this.m7.f, this.n7(this.bi), this.n8(this.bi), a);
    };
    HorizontalAnchoredCategorySeries.prototype.dh = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.nb.r(this.m6(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var a = this.getEffectiveViewport1(this.bi);
        return this.m6().getCategorySize(this.bi.bs, this.bi.br, a);
    };
    HorizontalAnchoredCategorySeries.prototype.en = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.m6();
        var f = new ScalerParams(0, this.bs.mq, this.bi.br, e.b8, d);
        var g = this.nb.r(e, this.bs.mq, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.n5), b, c);
    };
    HorizontalAnchoredCategorySeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    };
    HorizontalAnchoredCategorySeries.prototype.d9 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.m6(), d, e, this.valueColumn.count, runOn(this, this.n5));
    };
    HorizontalAnchoredCategorySeries.prototype.ll = function (a, b, c) {
        if (this.m6() == null || this.nq() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.ln(a, b, c, this.nb.r(this.m6(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.nq(), this.m6(), null, null, null);
    };
    HorizontalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.py;
    };
    HorizontalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.p4;
    };
    HorizontalAnchoredCategorySeries.prototype.pg = function (a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.ph = function (a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    };
    HorizontalAnchoredCategorySeries.prototype.n1 = function () {
        return this.p4 != null && this.p4.cl();
    };
    HorizontalAnchoredCategorySeries.prototype.qc = function (a) {
        this.py = a;
    };
    HorizontalAnchoredCategorySeries.prototype.qd = function (a) {
        this.p4 = a;
    };
    HorizontalAnchoredCategorySeries.prototype.m0 = function (a, b) {
        return this.ov(a, b, this.py);
    };
    HorizontalAnchoredCategorySeries.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.qc(this.xAxis);
                if (this.oy.cz) {
                    this.oy.cy = CategoryTrendLineManagerFactory.a(this.oy.cy, this.py, this.jx, this, this.b2);
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oy.cy = CategoryTrendLineManagerFactory.a(this.oy.cy, this.py, this.jx, this, this.b2);
                }
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.qc(this.xAxis);
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                    this.ik();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.qd(this.yAxis);
                    this.nf.cn.g(this.eu);
                    this.n1();
                    this.jd(false);
                    this.ik();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.kn(true);
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        if (this.py != null && typeCast(ISortingAxis_$type, this.py) !== null) {
            this.py.i$i();
        }
        switch (a) {
            case 4:
                if (this.py != null) {
                    this.py.cl();
                }
                if (this.p4 != null && !this.p4.cl()) {
                    this.jd(true);
                }
                break;
            case 1:
                if (this.py != null) {
                    this.py.cl();
                }
                if (this.p4 != null && !this.p4.cl()) {
                    this.jd(true);
                }
                break;
            case 0:
                if (this.py != null) {
                    this.py.cl();
                }
                if (this.p4 != null && !this.p4.cl()) {
                    this.jd(true);
                }
                break;
            case 2:
                if (this.o9 != null && this.oy.cn.d > 0 && this.p4 != null && !this.p4.cl()) {
                    this.jd(true);
                }
                break;
            case 3:
                if (d == this.o9) {
                    if (this.py != null) {
                        this.py.cl();
                    }
                    if (this.p4 != null && !this.p4.cl()) {
                        this.jd(true);
                    }
                }
                break;
        }
    };
    HorizontalAnchoredCategorySeries.prototype.p6 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeries.prototype.p7 = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "p1", {
        get: function () {
            return this.p0;
        },
        set: function (a) {
            var b = this.p1;
            if (a != b) {
                this.p0 = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.p1));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
    HorizontalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::qe', [CategoryAxisBase.$, null], 'YAxis::qf', [NumericYAxis.$, null]]);
    return HorizontalAnchoredCategorySeries;
}(AnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalAnchoredCategorySeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAnchoredCategorySeriesProxy, _super);
    function HorizontalAnchoredCategorySeriesProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalAnchoredCategorySeriesProxy.prototype.matchesType = function (a) {
        return typeCast(HorizontalAnchoredCategorySeries.$, a) !== null;
    };
    HorizontalAnchoredCategorySeriesProxy.prototype.setCategoryMode = function (a, b) {
        a.p1 = b;
    };
    HorizontalAnchoredCategorySeriesProxy.prototype.setValueMemberPath = function (a, b) {
        a.pd = b;
    };
    HorizontalAnchoredCategorySeriesProxy.prototype.setXAxis = function (a, b) {
        a.xAxis = b;
    };
    HorizontalAnchoredCategorySeriesProxy.prototype.setYAxis = function (a, b) {
        a.yAxis = b;
    };
    HorizontalAnchoredCategorySeriesProxy.$t = markType(HorizontalAnchoredCategorySeriesProxy, 'HorizontalAnchoredCategorySeriesProxy', Base.$, [IHorizontalAnchoredCategorySeriesProxy_$type]);
    return HorizontalAnchoredCategorySeriesProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrHorizontalAnchoredCategorySeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrHorizontalAnchoredCategorySeriesProxyModule() {
    }
    IgrHorizontalAnchoredCategorySeriesProxyModule.register = function () {
        TypeRegistrar.register('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy.$type);
    };
    return IgrHorizontalAnchoredCategorySeriesProxyModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum used to determine positioning logic for data items which have been consolidated into a single visual element.
 */
var ConsolidatedItemsPosition = /*@__PURE__*/ (function (ConsolidatedItemsPosition) {
    /**
     * Consolidated Items should be positioned using their minimum value.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Minimum"] = 0] = "Minimum";
    /**
     * Consolidated Items should be positioned using their maximum value.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Maximum"] = 1] = "Maximum";
    /**
     * Consolidated Items should be positioned at the midpoint of the range.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Median"] = 2] = "Median";
    /**
     * Consolidated Items should be positioned using the value nearest to the reference value of the corresponding axis.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMinimum"] = 3] = "RelativeMinimum";
    /**
     * Consolidated Items should be positioned using the value farthest from the reference value of the corresponding axis.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMaximum"] = 4] = "RelativeMaximum";
    return ConsolidatedItemsPosition;
})({});
/**
 * @hidden
 */
var ConsolidatedItemsPosition_$type = /*@__PURE__*/ markEnum('ConsolidatedItemsPosition', 'Minimum,0|Maximum,1|Median,2|RelativeMinimum,3|RelativeMaximum,4');

/**
 * Represents the base class for all IgxDataChartComponent numeric axes.
*/
var IgrNumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumericAxisBase, _super);
    function IgrNumericAxisBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrNumericAxisBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "isNumeric", {
        /**
         * Gets or sets if the current axis is of numeric axis type
        */
        get: function () {
            return this.i.ca;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "minimumValue", {
        /**
         * Gets or sets the MinimumValue property.
        *
        * Used to set the minimum value of a numeric axis. To get the minimum value in effect on a numeric axis use `actualMinimumValue`.
        *
        * ```ts
        * this.yAxis.minimumValue = 0;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900}
        * 	labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.kc;
        },
        set: function (v) {
            this.i.kc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualMinimumValue", {
        /**
         * Gets the effective minimum value for the current numeric axis object.
        *
        * ```ts
        * let effectiveMinValue: number = yAxis.actualMinimumValue;
        * ```
        */
        get: function () {
            return this.i.j4;
        },
        set: function (v) {
            this.i.j4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualVisibleMinimumValue", {
        /**
         * Gets the effective minimum value for the current numeric axis object.
        *
        * The `actualVisibleMinimumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMinimumValue` may differ from the `actualMinimumValue`, for example when the chart is zoomed.
        *
        * ```ts
        * let effectiveVisibleMinValue: number = yAxis.actualVisibleMinimumValue;
        * ```
        */
        get: function () {
            return this.i.j7;
        },
        set: function (v) {
            this.i.j7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "maximumValue", {
        /**
         * Gets or sets the MaximumValue property.
        *
        * Used to set the maximum value of a numeric axis. To get the maximum value in effect on a numeric axis use `actualMaximumValue`.
        *
        * ```ts
        * this.yAxis.maximumValue = 80;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900}
        * 	labelLocation="OutsideLeft"
        *     interval={300} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.kb;
        },
        set: function (v) {
            this.i.kb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualMaximumValue", {
        /**
         * Gets the effective maximum value for the current numeric axis object.
        *
        * ```ts
        * let effectiveMaxValue: number = yAxis.actualMaximumValue;
        * ```
        */
        get: function () {
            return this.i.j3;
        },
        set: function (v) {
            this.i.j3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualVisibleMaximumValue", {
        /**
         * Gets the effective visible maximum value for the current numeric axis object.
        *
        * The `actualVisibleMaximumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMaximumValue` may differ from the `actualMaximumValue`, for example when the chart is zoomed.
        *
        * ```ts
        * let effectiveVisibleMaxValue: number = yAxis.actualVisibleMaximumValue;
        * ```
        */
        get: function () {
            return this.i.j6;
        },
        set: function (v) {
            this.i.j6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "interval", {
        /**
         * Gets or sets the Interval property.
        *
        * The `interval` is used to get or set the numeric axis major interval which specifies how frequent major gridlines and axis labels are rendered on an axis.
        *
        * ```ts
        * this.yAxis.interval = 20;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900}
        * 	labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.j8;
        },
        set: function (v) {
            this.i.j8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        *
        * ```ts
        * let effectiveInterval: number = yAxis.actualInterval;
        * ```
        */
        get: function () {
            return this.i.j2;
        },
        set: function (v) {
            this.i.j2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "minorInterval", {
        /**
         * Gets or sets the MinorInterval property.
        *
        * The `minorInterval` is used to get or set the numeric axis minor interval which specifies how frequent minor gridlines are rendered on an axis. Please note, in order for minor gridlines to be displayed the following may also need to be set: `MinorStroke`, `MinorStrokeThickness`.
        *
        * ```ts
        * this.yAxis.minorInterval = 2.5;
        * this.yAxis.minorStroke = 'blue';
        * this.yAxis.minorStrokeThickness = 1;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900}
        * 	minorInterval= 2.5
        *     minorStroke="blue" />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.kd;
        },
        set: function (v) {
            this.i.kd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        *
        * ```ts
        * let effectiveMinorInterval: number = yAxis.actualMinorInterval;
        * ```
        */
        get: function () {
            return this.i.j5;
        },
        set: function (v) {
            this.i.j5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "referenceValue", {
        /**
         * Gets or sets the ReferenceValue property.
        *
        * Used to get or set a reference value on a numeric axis which when used with an area, bar, or column series will result in the series shapes being drawn above or below the specified value.
        *
        * ```ts
        * this.yAxis.referenceValue = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     referenceValue= {30} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ke;
        },
        set: function (v) {
            this.i.ke = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "isLogarithmic", {
        /**
         * Gets or sets the IsLogarithmic property.
        *
        * `isLogarithmic` is used to get or set whether the numeric axis scaler is in linear or logarithmic mode. For logarithmic scaling, this can be used in conjunction with `logarithmBase` to further define the logarithmic scale.
        *
        * ```ts
        * this.yAxis.isLogarithmic= true;
        * this.yAxis.logarithmBase = 2;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        * 	IsLogarithmic="True"
        *     LogarithmBase={2}/>
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.jt;
        },
        set: function (v) {
            this.i.jt = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "actualIsLogarithmic", {
        /**
         * Determines if the axis has a valid logarithmic scale.
        *
        * ```ts
        * let effectiveLogarithmic: boolean = this.yAxis.actualIsLogarithmic
        * ```
        */
        get: function () {
            return this.i.jp;
        },
        set: function (v) {
            this.i.jp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "logarithmBase", {
        /**
         * Gets or sets the LogarithmBase property.
        *
        * `logarithmBase` is used to get or set logarithm base when a numeric axis is in Logarithmic scale mode. For logarithmic scaling, this is used in conjunction with `isLogarithmic` or `ScaleMode` to set logarithmic scaling.
        *
        * ```ts
        * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
        * this.yAxis.logarithmBase = 2;
        * ```
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        * 	<IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        * 	ScaleMode="Logarithmic"
        *     LogarithmBase={2}/>
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.kg;
        },
        set: function (v) {
            this.i.kg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "hasUserMinimum", {
        /**
         * Determines if the axis has a user-defined minimum.
        *
        *  `hasUserMaximum` is used to determine if a numeric axis has a user definied maximum value.
        *
        * ```ts
        * let hasSetMaximum: boolean = this.yAxis.hasUserMaximum;
        * ```
        */
        get: function () {
            return this.i.js;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "hasUserMaximum", {
        /**
         * Determines if the axis has a user-defined maximum.
        *
        *  `hasUserMinimum` is used to determine if a numeric axis has a user definied minium value.
        *
        * ```ts
        * let hasSetMinimum: boolean = this.yAxis.hasUserMinimum;
        * ```
        */
        get: function () {
            return this.i.jr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAxisBase.prototype, "abbreviateLargeNumbers", {
        /**
         * A boolean indicating whether or not to abbreviate large numbers.
        */
        get: function () {
            return this.i.jo;
        },
        set: function (v) {
            this.i.jo = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    *
    * Unscales a value from screen space into axis space.
    *
    * ```ts
    * let dataValue: number = this.yAxis.unscaleValue(pixel);
    * ```
    */
    IgrNumericAxisBase.prototype.unscaleValue = function (unscaledValue) {
        var iv = this.i.kf(unscaledValue);
        return (iv);
    };
    return IgrNumericAxisBase;
}(IgrAxis));

/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
var IgrStraightNumericAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStraightNumericAxisBase, _super);
    function IgrStraightNumericAxisBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrStraightNumericAxisBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStraightNumericAxisBase.prototype, "scaleMode", {
        /**
         * Gets or sets the axis scale mode.
        *
        * `scaleMode` can be used on numeric axes to allow scaling data values using built-in scalers. The available scalers are linear or logarithmic.
        *
        * ```ts
        * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis"
        * 	scaleMode="logarithmic" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.lc;
        },
        set: function (v) {
            this.i.lc = ensureEnum(NumericScaleMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrStraightNumericAxisBase;
}(IgrNumericAxisBase));

/**
 * Represents a IgxDataChartComponent numeric Y axis.
*
* The `IgrNumericYAxis` treats the data as continuously varying numerical data items. Labels on this axis are placed along the Y-axis. Location of labels varies according to the value in a data column that is mapped using the `YMemberPath` property for Scatter Series or `ValueMemberPath` property for Category Series.
*
* ```ts
* <IgrDataChart >
*
*     <IgrCategoryXAxis name="xAxis"
*     interval={12} labelLocation="OutsideBottom"
*     label="Year"  overlap={1} gap={0.4}  />
*
*     <IgrNumericYAxis  name="yAxis"
*     title="Expanse | Revenue"
*     minimumValue={-900} labelLocation="OutsideLeft"
*     maximumValue={900}
*     interval={300} />
*
*
*     <IgrLineSeries name="series1"
*     valueMemberPath="Revenue"
*     xAxisName="xAxisMonths"
*     yAxisName="yAxisLeft"
* 	consolidatedItemHitTestBehavior="Basic"  />
* </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrColumnSeries({ name: "series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "xAxis";
* this.series.yAxisName = "yAxis";
* ```
*/
var IgrNumericYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumericYAxis, _super);
    function IgrNumericYAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrNumericYAxis.prototype.createImplementation = function () {
        return new NumericYAxis();
    };
    Object.defineProperty(IgrNumericYAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericYAxis.prototype, "isVertical", {
        /**
         * Gets if the current axis is of vertical axis
        */
        get: function () {
            return this.i.cf;
        },
        enumerable: true,
        configurable: true
    });
    IgrNumericYAxis.prototype.scrollRangeIntoView = function (minimum, maximum) {
        this.i.lv(minimum, maximum);
    };
    return IgrNumericYAxis;
}(IgrStraightNumericAxisBase));

/**
 * Contains contextual information about a highlighting.
*/
var IgrHighlightingInfo = /** @class */ /*@__PURE__*/ (function () {
    function IgrHighlightingInfo() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrHighlightingInfo.prototype.createImplementation = function () {
        return new HighlightingInfo();
    };
    Object.defineProperty(IgrHighlightingInfo.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrHighlightingInfo.prototype.onImplementationCreated = function () {
    };
    IgrHighlightingInfo.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrHighlightingInfo.prototype, "startIndex", {
        /**
         * The index of the first highlighted item.
        *
        * You can use `startIndex` to get or set the first highlighted item for the series.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighlightingInfo.prototype, "endIndex", {
        /**
         * The index of the last highlighted item.
        *
        * You can use the `endIndex` to get or set the last highlighted item for the series.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighlightingInfo.prototype, "state", {
        /**
         * The state of the highlighting.
        *
        * You can use the `state` to get or set the transitioning state of the highlighting, between In, Out, or Static.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(HighlightingState_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighlightingInfo.prototype, "progress", {
        /**
         * A number between 0 and 1 representing the progress of the highlighting.
        *
        * You can use the `progress` property to set a number between 0 and 1 representing the progress of the highlighting.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighlightingInfo.prototype, "isMarker", {
        /**
         * True if this HighlightingInfo represents a marker highlighting.
        *
        * You can set the `isMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighlightingInfo.prototype, "series", {
        /**
         * The series in context.
        *
        * You can use the `series` property to get the series in context.
        */
        get: function () {
            if (this.i.b == null) {
                return null;
            }
            if (!this.i.b.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.b);
                if (e) {
                    e._implementation = this.i.b;
                }
                this.i.b.externalObject = e;
            }
            return this.i.b.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrHighlightingInfo;
}());

/**
 * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
*/
var IgrAssigningCategoryStyleEventArgsBase = /** @class */ /*@__PURE__*/ (function () {
    function IgrAssigningCategoryStyleEventArgsBase() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrAssigningCategoryStyleEventArgsBase.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrAssigningCategoryStyleEventArgsBase.prototype.onImplementationCreated = function () {
    };
    IgrAssigningCategoryStyleEventArgsBase.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "startIndex", {
        /**
         * Gets the start index
        */
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "endIndex", {
        /**
         * Gets the end index
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "startDate", {
        /**
         * Gets the start date
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "endDate", {
        /**
         * Gets the end date
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "getItems", {
        /**
         * Gets a function that will return the items associated with this event.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "fill", {
        /**
         * Gets or sets fill brush to use for the current item.
        */
        get: function () {
            return brushToString(this.i.n);
        },
        set: function (v) {
            this.i.n = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "stroke", {
        /**
         * Gets or sets stroke to use for the current item.
        */
        get: function () {
            return brushToString(this.i.o);
        },
        set: function (v) {
            this.i.o = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "opacity", {
        /**
         * Gets or sets opacity to use for the current item.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "highlightingInfo", {
        /**
         * Gets or sets highlighting info
        */
        get: function () {
            if (this.i.b == null) {
                return null;
            }
            if (!this.i.b.externalObject) {
                var e = new IgrHighlightingInfo();
                e._implementation = this.i.b;
                this.i.b.externalObject = e;
            }
            return this.i.b.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "maxAllSeriesHighlightingProgress", {
        /**
         * Gets the max highlighting progress from all series.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "sumAllSeriesHighlightingProgress", {
        /**
         * Gets the sum of highlighting progress from all series.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "highlightingHandled", {
        /**
         * Gets or sets if highlighting was handled by this event handler, and whether internal highlighting logic should be skipped.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "hasDateRange", {
        /**
         * Gets if this event has a valid date range
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "isNegativeShape", {
        /**
         * Gets if the current shape is identified as a negative shape if this series supports discrete negative shapes.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgsBase.prototype, "isThumbnail", {
        /**
         * Gets if the current event is being raised for the thumbnail image.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrAssigningCategoryStyleEventArgsBase;
}());

/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low"
* 		isCustomCategoryStyleAllowed="true"
* 		assigningCategoryMarkerStyle= {this.onAssigningCategoryStyle} />
*  </IgrDataChart>
* ```
*
* ```ts
*  series1.assigningCategoryStyle = this.onAssigningCategoryStyle ;
*  public onAssigningCategoryStyle =( s:IgrCategorySeries , e: AssigningCategoryStyleEventArgs) => {
*
*   }
* ```
*/
var IgrAssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAssigningCategoryStyleEventArgs, _super);
    function IgrAssigningCategoryStyleEventArgs() {
        return _super.call(this) || this;
    }
    IgrAssigningCategoryStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryStyleEventArgs();
    };
    Object.defineProperty(IgrAssigningCategoryStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgs.prototype, "strokeThickness", {
        /**
         * Gets or sets stroke thickness to use for the current item.
        *
        * Used the `strokeThickness` proprty  for the current item thickness.
        *
        * ```ts
        * public onAssigningCategoryMarkerStyle =( s:IgrCategorySeries , e: AssigningCategoryStyleEventArgs) => {
        *     e.strokeThickness = 5;
        * }
        * ```
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgs.prototype, "radiusX", {
        /**
         * Gets or sets corner radius X to use for the current item, if applicable.
        *
        * Use the `radiusX` property to round the corners of the column.
        *
        * ```ts
        * public onAssigningCategoryMarkerStyle =( s:IgrCategorySeries, e: AssigningCategoryStyleEventArgs) => {
        *   e.radiusX = 5;
        *   }
        * ```
        */
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAssigningCategoryStyleEventArgs.prototype, "radiusY", {
        /**
         * Gets or sets corner radius Y to use for the current item, if applicable.
        *
        * Use the `radiusY` property for the y-radius of the ellipse that is used to round the corners of the column.
        *
        * ```ts
        *  public onAssigningCategoryMarkerStyle =( s:IgrCategorySeries<IIgrRangeAreaSeriesProps>, e: AssigningCategoryStyleEventArgs) => {
        * 	e.radiusY = 5;
        * }
        * ```
        */
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAssigningCategoryStyleEventArgs;
}(IgrAssigningCategoryStyleEventArgsBase));

/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low"
* 		isCustomCategoryStyleAllowed="true"
* 		assigningCategoryMarkerStyle= {this.onAssigningCategoryMarkerStyle} />
*  </IgrDataChart>
* ```
*
* ```ts
* series1.assigningCategoryMarkerStyle= this.onAssigningCategoryMarkerStyle ;
* public onAssigningCategoryMarkerStyle =( s:IgrCategorySeries, e: AssigningCategoryStyleEventArgs) => {
*
* }
* ```
*/
var IgrAssigningCategoryMarkerStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAssigningCategoryMarkerStyleEventArgs, _super);
    function IgrAssigningCategoryMarkerStyleEventArgs() {
        return _super.call(this) || this;
    }
    IgrAssigningCategoryMarkerStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryMarkerStyleEventArgs();
    };
    Object.defineProperty(IgrAssigningCategoryMarkerStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAssigningCategoryMarkerStyleEventArgs;
}(IgrAssigningCategoryStyleEventArgsBase));

/**
 * Represents the base class for series containing markers.
*
* MarkerSeries represents the base class for series containing markers.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrColumnSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMarkerSeries({name: "series"});
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "timeXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.volumeMemberPath="Volume";
* ```
*/
var IgrMarkerSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMarkerSeries, _super);
    function IgrMarkerSeries(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrMarkerSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "hasMarkers", {
        /**
         * Returns whether the current series supports visual markers.
        *
        * `hasMarkers` property is overriden, it returns whether the current series supports visual markers. You can use it like this:
        *
        * ```ts
        *  let gotMarkers: boolean = this.series.hasMarkers;
        * ```
        */
        get: function () {
            return this.i.hasMarkers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "markerType", {
        /**
         * Gets or sets the marker type for the current series object.
         * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
        *
        * `markerType` property gets or sets the marker type for the current series object. For example, you can set it like this:
        *
        * ```ts
        * this.series.markerType = "circle";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	markerType = "circle"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.l1;
        },
        set: function (v) {
            this.i.l1 = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "markerTemplate", {
        /**
         * Gets or sets the MarkerTemplate for the current series object.
        *
        * `markerTemplate` property gets or sets the MarkerTemplate for the current series object. For example, you can use it like this:
        */
        get: function () {
            return this.i.mk;
        },
        set: function (v) {
            this.i.mk = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "actualMarkerTemplate", {
        /**
         * Gets the effective marker template for the current series object.
        *
        * `actualMarkerTemplate` property gets the effective marker template for the current series object. You can use it like this:
        */
        get: function () {
            return this.i.mi;
        },
        set: function (v) {
            this.i.mi = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "markerBrush", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
        *
        * `markerBrush` property gets or sets the brush that specifies how the current series object's marker interiors are painted. You can use it like this:
        *
        * ```ts
        * this.series.markerBrush = "red";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	markerBrush = "blue" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.mx);
        },
        set: function (v) {
            this.i.mx = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "actualMarkerBrush", {
        /**
         * Gets the effective marker brush for the current series object.
        *
        * `actualMarkerBrush` property gets the effective marker brush for the current series object. For example, you can use it like this:
        *
        * ```ts
        *  let effectiveMarkerBrush: string = this.series.actualMarkerBrush;
        *
        * ```
        */
        get: function () {
            return brushToString(this.i.mv);
        },
        set: function (v) {
            this.i.mv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "markerOutline", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
        *
        * `markerOutline` property gets or sets the brush that specifies how the current series object's marker outlines are painted. You can use it like this:
        *
        * ```ts
        * this.series.markerOutline = "red";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	markerOutline = "blue" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.my);
        },
        set: function (v) {
            this.i.my = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMarkerSeries.prototype, "actualMarkerOutline", {
        /**
         * Gets the effective marker outline for the current series object.
        *
        *     `ActualMarkerOutline` property gets the effective marker outline for the current series object. You can use it like this:
        *
        * ```ts
        *  let effectiveMarkerOutline: string = this.series.actualMarkerOutline;
        *
        * ```
        */
        get: function () {
            return brushToString(this.i.mw);
        },
        set: function (v) {
            this.i.mw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrMarkerSeries;
}(IgrSeries));

/**
 * Represents the base class for IgxDataChartComponent category series.
*
* `IgrCategorySeries` class represents the base class for IgxDataChartComponent category series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrColumnSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.columnSeries2 = new IgrColumnSeries({ name: "colSeries2" });
* this.columnSeries2.dataSource = this.categoryData;
* this.columnSeries2.xAxis = this.categoryXAxis;
* this.columnSeries2.yAxis = this.numericYAxis;
* this.columnSeries2.xAxisName = "categoryXAxis";
* this.columnSeries2.yAxisName = "numericYAxis";
* this.columnSeries2.valueMemberPath = "RUS";
* ```
*/
var IgrCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategorySeries, _super);
    function IgrCategorySeries(props) {
        var _this = _super.call(this, props) || this;
        _this._assigningCategoryStyle = null;
        _this._assigningCategoryStyle_wrapped = null;
        _this._assigningCategoryMarkerStyle = null;
        _this._assigningCategoryMarkerStyle_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgrCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "isCategory", {
        /**
         * Gets whether or not this series is Category series
        */
        get: function () {
            return this.i.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "isCustomCategoryStyleAllowed", {
        /**
         * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
        */
        get: function () {
            return this.i.nx;
        },
        set: function (v) {
            this.i.nx = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "isCustomCategoryMarkerStyleAllowed", {
        /**
         * Gets or sets whether this category series should allow custom style overrides of its individual marker visuals.
        */
        get: function () {
            return this.i.nw;
        },
        set: function (v) {
            this.i.nw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "useHighMarkerFidelity", {
        /**
         * Sets or Gets whether to increase marker fidelity for extreme data shapes that have lots of Y variation over short X intervals.
        *
        * Set `useHighMarkerFidelity` when your data has high variation along the y-axis within a short span of this x-axis.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	useHighMarkerFidelity="true"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *       this.columnSeries2.useHighMarkerFidelity= "true";
        * ```
        */
        get: function () {
            return this.i.n2;
        },
        set: function (v) {
            this.i.n2 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "transitionInMode", {
        /**
         * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
         * Note: Transitions are not currently supported for stacked series.
        *
        * `transitionInMode` controls the direction of the transition-in animation.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	transitionInMode="accordionfromRight"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *
        * 	this.columnSeries2.transitionInMode= "accordionfromRight";
        * ```
        */
        get: function () {
            return this.i.nh;
        },
        set: function (v) {
            this.i.nh = ensureEnum(CategoryTransitionInMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "isTransitionInEnabled", {
        /**
         * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
         * Note: Transitions are not currently supported for stacked series.
        *
        * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
        *
        * ```ts
        * this.columnSeries2 = new IgrColumnSeries({ name: "colSeries2" });
        * this.columnSeries2.dataSource = this.categoryData;
        * this.columnSeries2.xAxis = this.categoryXAxis;
        * this.columnSeries2.yAxis = this.numericYAxis;
        * this.columnSeries2.xAxisName = "categoryXAxis";
        * this.columnSeries2.yAxisName = "numericYAxis";
        * this.columnSeries2.valueMemberPath = "RUS";
        * this.columnSeries2.isTransitionInEnabled= "true";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * 	isTransitionInEnabled="true"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ny;
        },
        set: function (v) {
            this.i.ny = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrCategorySeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrCategorySeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrCategorySeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item based on world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrCategorySeries.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    IgrCategorySeries.prototype.getExactItemIndex = function (world) {
        var iv = this.i.eb(toPoint(world));
        return (iv);
    };
    Object.defineProperty(IgrCategorySeries.prototype, "assigningCategoryStyle", {
        /**
         * Event raised when Assigning Category Style
        */
        get: function () {
            return this._assigningCategoryStyle;
        },
        set: function (ev) {
            var _this = this;
            if (this._assigningCategoryStyle_wrapped !== null) {
                this.i.assigningCategoryStyle = delegateRemove(this.i.assigningCategoryStyle, this._assigningCategoryStyle_wrapped);
                this._assigningCategoryStyle_wrapped = null;
                this._assigningCategoryStyle = null;
            }
            this._assigningCategoryStyle = ev;
            this._assigningCategoryStyle_wrapped = function (o, e) {
                var outerArgs = new IgrAssigningCategoryStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeAssigningCategoryStyle) {
                    _this.beforeAssigningCategoryStyle(_this, outerArgs);
                }
                if (_this._assigningCategoryStyle) {
                    _this._assigningCategoryStyle(_this, outerArgs);
                }
            };
            this.i.assigningCategoryStyle = delegateCombine(this.i.assigningCategoryStyle, this._assigningCategoryStyle_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategorySeries.prototype, "assigningCategoryMarkerStyle", {
        /**
         * Event raised when Assigning Category Marker Style
        */
        get: function () {
            return this._assigningCategoryMarkerStyle;
        },
        set: function (ev) {
            var _this = this;
            if (this._assigningCategoryMarkerStyle_wrapped !== null) {
                this.i.assigningCategoryMarkerStyle = delegateRemove(this.i.assigningCategoryMarkerStyle, this._assigningCategoryMarkerStyle_wrapped);
                this._assigningCategoryMarkerStyle_wrapped = null;
                this._assigningCategoryMarkerStyle = null;
            }
            this._assigningCategoryMarkerStyle = ev;
            this._assigningCategoryMarkerStyle_wrapped = function (o, e) {
                var outerArgs = new IgrAssigningCategoryMarkerStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeAssigningCategoryMarkerStyle) {
                    _this.beforeAssigningCategoryMarkerStyle(_this, outerArgs);
                }
                if (_this._assigningCategoryMarkerStyle) {
                    _this._assigningCategoryMarkerStyle(_this, outerArgs);
                }
            };
            this.i.assigningCategoryMarkerStyle = delegateCombine(this.i.assigningCategoryMarkerStyle, this._assigningCategoryMarkerStyle_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrCategorySeries;
}(IgrMarkerSeries));

/**
 * Represents the base class for all IgxDataChartComponent anchored category/value series.
*
* The `IgrAnchoredCategorySeries` represents the base class for all IgxDataChartComponent anchored category/value series.
*
* ```ts
* <IgrDataChart >
*
*
*     <IgrCategoryXAxis name="xAxisYears"
*     interval={12} labelLocation="OutsideBottom"
*     label="Year"  overlap={1} gap={0.4}  />
*
*     <IgrCategoryXAxis name="xAxisMonths"
*     interval={1}  labelLocation="OutsideBottom"
*     label="Month" overlap={1} gap={0.4}/>
*
*     <IgrNumericYAxis  name="yAxisLeft"
*     title="Expanse | Revenue"
*     minimumValue={-900} labelLocation="OutsideLeft"
*     maximumValue={900}
*     interval={300} />
*
*     <IgrNumericYAxis  name="yAxisRight"
*     title="Profit (%)"
*     minimumValue={0}  labelLocation="OutsideRight"
*     maximumValue={100} />
*
*
*     <IgrLineSeries name="series1"
*     valueMemberPath="Revenue"
*     xAxisName="xAxisMonths"
*     yAxisName="yAxisLeft" />
*  </IgrDataChart>
* ```
*/
var IgrAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAnchoredCategorySeries, _super);
    function IgrAnchoredCategorySeries(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "valueMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        *
        * The `valueMemberPath` property is used for the value mapping property of the current series object.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.pd;
        },
        set: function (v) {
            this.i.pd = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current series object.
        *
        * The `trendLineType` property is used for the current series object's trend type.'
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	trendLineType="SimpleAverage" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineType= "CubicFit";
        * ```
        */
        get: function () {
            return this.i.trendLineType;
        },
        set: function (v) {
            this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush to use to draw the trend line.
        *
        * The `trendLineBrush` property is used to brush the trend line.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	trendLineBrush="Gray"  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineBrush="red";
        * ```
        */
        get: function () {
            return brushToString(this.i.trendLineBrush);
        },
        set: function (v) {
            this.i.trendLineBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this series.
        *
        * The `actualTrendLineBrush` property is used to gets the effective `trendLineBrush` for this series.
        */
        get: function () {
            return brushToString(this.i.pv);
        },
        set: function (v) {
            this.i.pv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current series object's trend line.
        *
        * The `trendLineThickness` property is used for thickness of the current series object's trend line.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	trendLineThickness ="2" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineThickness= 2;
        * ```
        */
        get: function () {
            return this.i.trendLineThickness;
        },
        set: function (v) {
            this.i.trendLineThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the trend line period for the current series.
         * The typical, and initial, value for trend line period is 7.
        *
        * The `trendLinePeriod` property is used for trend line period of the current series.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	trendLinePeriod ="2" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLinePeriod= 7;
        * ```
        */
        get: function () {
            return this.i.trendLinePeriod;
        },
        set: function (v) {
            this.i.trendLinePeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "markerCollisionAvoidance", {
        /**
         * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
        *
        * The `markerCollisionAvoidance` property controls the technique the chart uses to avoid overlapping markers.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	markerCollisionAvoidance="fade"  />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.o0;
        },
        set: function (v) {
            this.i.o0 = ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredCategorySeries.prototype, "consolidatedItemHitTestBehavior", {
        /**
         * Determines the item returned in hit-testing when the pointer is over an object which represents several consolidated items.
        *
        * The `consolidatedItemHitTestBehavior` property is used to determines returned item in hit-testing when the pointer is over an object which represents several consolidated items.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrLineSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	consolidatedItemHitTestBehavior="Basic"  />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.o1;
        },
        set: function (v) {
            this.i.o1 = ensureEnum(ConsolidatedItemHitTestBehavior_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgrAnchoredCategorySeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` method is used to notifies the target axis or series that it should scroll the requested data item into view.
    *
    * ```ts
    * this.series.scrollIntoView(dataItem);
    * ```
    */
    IgrAnchoredCategorySeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * The `getItem` method is used to gets the item that is the best match for the specified world coordinates.
    *
    * ```ts
    * let item: number = this.series.getItem({x:.5,y:.5});
    * ```
    */
    IgrAnchoredCategorySeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    return IgrAnchoredCategorySeries;
}(IgrCategorySeries));

/**
 * Base class for anchored category series with a category x-axis and a numeric y-axis.
*
* Instantiate HorizontalAnchoredCategorySeries
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrColumnSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
* this.columnSeries1.dataSource = this.categoryData;
* this.columnSeries1.xAxis = this.categoryXAxis;
* this.columnSeries1.yAxis = this.numericYAxis;
* this.columnSeries1.xAxisName = "categoryXAxis";
* this.columnSeries1.yAxisName = "numericYAxis";
* this.columnSeries1.valueMemberPath = "USA";
* ```
*/
var IgrHorizontalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHorizontalAnchoredCategorySeries, _super);
    function IgrHorizontalAnchoredCategorySeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrHorizontalAnchoredCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalAnchoredCategorySeries.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for this series.
        *
        * Instantiate xAxis
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
        * this.columnSeries1.dataSource = this.categoryData;
        * this.columnSeries1.xAxis = this.categoryXAxis;
        * this.columnSeries1.yAxis = this.numericYAxis;
        * this.columnSeries1.xAxisName = "categoryXAxis";
        * this.columnSeries1.yAxisName = "numericYAxis";
        * this.columnSeries1.valueMemberPath = "USA";
        * ```
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalAnchoredCategorySeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalAnchoredCategorySeries.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for this series.
        *
        * Instantiate yAxis
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
        * this.columnSeries1.dataSource = this.categoryData;
        * this.columnSeries1.xAxis = this.categoryXAxis;
        * this.columnSeries1.yAxis = this.numericYAxis;
        * this.columnSeries1.xAxisName = "categoryXAxis";
        * this.columnSeries1.yAxisName = "numericYAxis";
        * this.columnSeries1.valueMemberPath = "USA";
        * ```
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalAnchoredCategorySeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrHorizontalAnchoredCategorySeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrHorizontalAnchoredCategorySeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *     var x = financialSeries.GetSeriesValueMarkerBoundingBox(new IgxPoint());
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalAnchoredCategorySeries.prototype.getSeriesValueMarkerBoundingBox = function (world) {
        var iv = this.i.lw(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
    *
    * <!-- Angular JS -->
    *
    *       var g = series.getOffsetValue();
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgrHorizontalAnchoredCategorySeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrHorizontalAnchoredCategorySeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrHorizontalAnchoredCategorySeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrHorizontalAnchoredCategorySeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    */
    IgrHorizontalAnchoredCategorySeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.p6(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalAnchoredCategorySeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.p7(axis);
        return (iv);
    };
    return IgrHorizontalAnchoredCategorySeries;
}(IgrAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PointSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointSeries, _super);
    function PointSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PointSeries.$;
        return _this;
    }
    PointSeries.prototype.bf = function () {
        return new PointSeriesView(this);
    };
    PointSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qh = a;
    };
    PointSeries.prototype.dh = function (a, b) {
        var c = this.ll(this.lo(a), true, false);
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    PointSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
    };
    PointSeries.prototype.get_cy = function () {
        return false;
    };
    Object.defineProperty(PointSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    PointSeries.$t = markType(PointSeries, 'PointSeries', HorizontalAnchoredCategorySeries.$);
    return PointSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var PointSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointSeriesView, _super);
    function PointSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c6 = a;
        return _this;
    }
    PointSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.by.l1 = 2;
            this.e.bj = 4;
        }
    };
    PointSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    };
    PointSeriesView.$t = markType(PointSeriesView, 'PointSeriesView', AnchoredCategorySeriesView.$);
    return PointSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent point series.
*
* You can use the `IgrPointSeries` plot a value along a category or date.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrPointSeries
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* const series1 = new IgrPointSeries({ name: "series1" });
* series1.xAxisName = "xAxis";
* series1.yAxisName = "yAxis";
* series1.markerType = MarkerType.Circle;
* series1.valueMemberPath = "USA";
* ```
*/
var IgrPointSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPointSeries, _super);
    function IgrPointSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPointSeries.prototype.createImplementation = function () {
        return new PointSeries();
    };
    Object.defineProperty(IgrPointSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPointSeries.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPointSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPointSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPointSeriesModule() {
    }
    IgrPointSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrPointSeries", IgrPointSeries);
        TypeRegistrar.register("PointSeries", PointSeries.$type);
    };
    return IgrPointSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryLineRasterizer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryLineRasterizer, _super);
    function CategoryLineRasterizer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = false;
        _this.n = new PointCollection(0);
        return _this;
    }
    Object.defineProperty(CategoryLineRasterizer.prototype, "o", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            this.n = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryLineRasterizer.prototype.m = function (a, b, c, d, e, f, g, h, i, j) {
        var k = new PathGeometry();
        var l = new PathGeometry();
        var m = new PathGeometry();
        a.ak = k;
        b.ak = l;
        c.ak = m;
        k.c = new PathFigureCollection();
        l.c = new PathFigureCollection();
        m.c = new PathFigureCollection();
        var n = new List$1(PolyLineSegment.$, 0);
        var o = new List$1(PolyLineSegment.$, 0);
        var p = new List$1(PolyLineSegment.$, 0);
        var q = new List$1(PolyLineSegment.$, 0);
        if (g == 0 || g == 1) {
            var r = g == 1 ? h : null;
            var s = 0;
            for (var t = 0; t < d; t++) {
                if (isNaN_(e._inner[t][1])) {
                    var u = t - s;
                    var v = (g == 0 && u > 0) || (g == 1 && u > 1);
                    if (v) {
                        if (g == 1 || n.count == 0) {
                            var w = new PolyLineSegment();
                            var x = new PolyLineSegment();
                            var y = new PolyLineSegment();
                            var z = new PolyLineSegment();
                            n.add(w);
                            o.add(x);
                            p.add(y);
                            q.add(z);
                        }
                        this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, t - 1, e, f, r, i, j);
                    }
                    s = t + 1;
                }
            }
            if (g == 1 || n.count == 0) {
                var aa = new PolyLineSegment();
                var ab = new PolyLineSegment();
                var ac = new PolyLineSegment();
                var ad = new PolyLineSegment();
                n.add(aa);
                o.add(ad);
                p.add(ab);
                q.add(ac);
            }
            this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, d - 1, e, f, r, i, j);
            if (r == null && n.count == 1 && h != null) {
                this.d(n._inner[0], h);
                if (o.count == 1) {
                    this.d(o._inner[0], h);
                }
            }
        }
        else {
            n.add(new PolyLineSegment());
            o.add(new PolyLineSegment());
            p.add(new PolyLineSegment());
            q.add(new PolyLineSegment());
            this.k(n._inner[0]._points, o._inner[0]._points, p._inner[0]._points, q._inner[0]._points, d, e, f, h, i, j);
        }
        var _loop_1 = function (ae) {
            var e_1, _a;
            var af = n._inner[ae];
            var ag = o._inner[ae];
            var ah = p._inner[ae];
            var ai = q._inner[ae];
            if (af._points.count > 0) {
                var aj = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = af._points._inner[0];
                    return $ret;
                })());
                aj._segments.add(af);
                k.c.add(aj);
            }
            if (ag._points.count > 0) {
                var ak = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = ag._points._inner[0];
                    return $ret;
                })());
                ak._segments.add(ag);
                m.c.add(ak);
            }
            if (ah._points.count > 0 && ai._points.count > 0) {
                var al_1 = new PolyLineSegment();
                if (h != null) {
                    var am = h.f;
                    h.f = true;
                    h.i = al_1._points;
                    h.k(ah._points, false);
                    h.k(ai._points, true);
                    h.i = null;
                    h.f = am;
                }
                else {
                    try {
                        for (var _b = (e_1 = void 0, __values(fromEnum(ah._points))), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var an = _c.value;
                            al_1._points.add(an);
                        }
                    }
                    catch (e_1_1) {
                        e_1 = { error: e_1_1 };
                    }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return))
                                _a.call(_b);
                        }
                        finally {
                            if (e_1)
                                throw e_1.error;
                        }
                    }
                    for (var ao = ai._points.count - 1; ao >= 0; ao--) {
                        al_1._points.add(ai._points._inner[ao]);
                    }
                }
                if (al_1._points.count > 0) {
                    var ap = ((function () {
                        var $ret = new PathFigure();
                        $ret.startPoint = al_1._points._inner[0];
                        return $ret;
                    })());
                    ap._segments.add(al_1);
                    l.c.add(ap);
                }
            }
        };
        for (var ae = 0; ae < n.count; ae++) {
            _loop_1(ae);
        }
    };
    CategoryLineRasterizer.prototype.d = function (a, b) {
        var c = a._points;
        b.i = a._points = new PointCollection(0);
        b.k(c, false);
        b.i = null;
    };
    CategoryLineRasterizer.prototype.k = function (a, b, c, d, e, f, g, h, i, j) {
        this.l(a, b, c, d, 0, e - 1, f, g, h, i, j);
    };
    CategoryLineRasterizer.prototype.e = function (a, b, c, d, e, f, g) {
        var h = FastFlattener.a(new List$1(Number_$type, 0), d, e, f, b, c, g);
        var i = ArrayAccessHelper.c(h);
        var j = ArrayAccessHelper.a(d);
        var k = i != null;
        var l = j != null;
        var m = 0;
        var n = h.count;
        var o;
        var p;
        var q;
        if (e) {
            for (var r = 0; r < n; r++) {
                m = k ? i[r] : h.item(r);
                o = l ? j[m] : d._inner[m];
                p = o[0];
                q = o[1];
                var s = { $type: Point_$type, x: p, y: q };
                a.add(s);
            }
        }
        else if (f) {
            for (var t = 0; t < n; t++) {
                m = k ? i[t] : h.item(t);
                o = l ? j[m] : d._inner[m];
                p = o[0];
                q = o[2];
                var u = { $type: Point_$type, x: p, y: q };
                a.add(u);
            }
        }
        else {
            for (var v = 0; v < n; v++) {
                m = k ? i[v] : h.item(v);
                o = l ? j[m] : d._inner[m];
                p = o[2];
                q = o[3];
                var w = { $type: Point_$type, x: p, y: q };
                a.add(w);
            }
        }
    };
    CategoryLineRasterizer.prototype.b = function (a, b, c, d) {
        c.i = a;
        c.k(b, false);
        c.i = null;
    };
    CategoryLineRasterizer.prototype.c = function (a, b, c, d, e) {
        var f = c.f;
        c.f = e;
        this.b(a, b, c, d);
        c.f = f;
    };
    CategoryLineRasterizer.prototype.l = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (f > -1) {
            if (j == 1 && !this.a) {
                var l = new PointCollection(0);
                this.e(l, e, f, g, true, h, k);
                if (i != null) {
                    this.b(a, l, i, k);
                }
                else {
                    this.f(a, l);
                }
            }
            else {
                var m = new PointCollection(0);
                var n = new PointCollection(0);
                this.e(m, e, f, g, true, h, k);
                this.e(n, e, f, g, false, h, k);
                this.f(c, m);
                this.f(d, n);
                if (i != null) {
                    this.b(a, m, i, k);
                    this.b(b, n, i, k);
                }
                else {
                    this.f(a, m);
                    this.f(b, n);
                }
            }
        }
    };
    CategoryLineRasterizer.prototype.i = function (a, b, c, d, e, f, g, h, i, j, k) {
        this.j(a, b, c, d, e, f, g, h, i, j, k, null);
    };
    CategoryLineRasterizer.prototype.j = function (a, b, c, d, e, f, g, h, i, j, k, l) {
        var m = new PathGeometry();
        var n = new PathGeometry();
        var o = new PathGeometry();
        var p = new PathGeometry();
        a.ak = m;
        b.ak = n;
        c.ak = o;
        d.ak = p;
        m.c = new PathFigureCollection();
        n.c = new PathFigureCollection();
        o.c = new PathFigureCollection();
        p.c = new PathFigureCollection();
        var q = new List$1(PolyLineSegment.$, 0);
        var r = new List$1(PolyLineSegment.$, 0);
        var s = new List$1(PolyLineSegment.$, 0);
        var t = new List$1(PolyLineSegment.$, 0);
        if (k == 0 || k == 1) {
            var u = k == 1 ? l : null;
            var v = 0;
            for (var w = 0; w < e; w++) {
                if (isNaN_(f._inner[w][1])) {
                    var x = w - v;
                    var y = (k == 0 && x > 0) || (k == 1 && x > 1);
                    if (y) {
                        if (k == 1 || r.count == 0) {
                            var z = new PolyLineSegment();
                            var aa = new PolyLineSegment();
                            var ab = new PolyLineSegment();
                            var ac = new PolyLineSegment();
                            q.add(z);
                            r.add(aa);
                            s.add(ab);
                            t.add(ac);
                        }
                        var ad = void 0;
                        var ae = void 0;
                        var af = void 0;
                        var ag = void 0;
                        if (l != null && k == 1) {
                            ad = new PointCollection(0);
                            ae = new PointCollection(0);
                            af = new PointCollection(0);
                            ag = new PointCollection(0);
                        }
                        else {
                            ad = q._inner[q.count - 1]._points;
                            ae = r._inner[r.count - 1]._points;
                            af = s._inner[s.count - 1]._points;
                            ag = t._inner[t.count - 1]._points;
                        }
                        this.g(ad, ae, af, ag, v, w - 1, f, g, null, h, i);
                        if (k == 1) {
                            j(ad, ae, af, ag, false);
                            if (l != null) {
                                this.c(q._inner[q.count - 1]._points, ad, l, i, true);
                                this.c(r._inner[r.count - 1]._points, ae, l, i, false);
                                this.c(s._inner[s.count - 1]._points, af, l, i, true);
                                this.c(t._inner[t.count - 1]._points, ag, l, i, false);
                            }
                        }
                    }
                    v = w + 1;
                }
            }
            if (k == 1 || r.count == 0) {
                var ah = new PolyLineSegment();
                var ai = new PolyLineSegment();
                var aj = new PolyLineSegment();
                var ak = new PolyLineSegment();
                q.add(ah);
                r.add(ai);
                s.add(aj);
                t.add(ak);
            }
            var al = void 0;
            var am = void 0;
            var an = void 0;
            var ao = void 0;
            if (l != null) {
                al = new PointCollection(0);
                this.f(al, q._inner[q.count - 1]._points);
                am = new PointCollection(0);
                this.f(am, r._inner[r.count - 1]._points);
                an = new PointCollection(0);
                this.f(an, s._inner[s.count - 1]._points);
                ao = new PointCollection(0);
                this.f(ao, t._inner[t.count - 1]._points);
                q._inner[q.count - 1]._points.clear();
                r._inner[r.count - 1]._points.clear();
                s._inner[s.count - 1]._points.clear();
                t._inner[t.count - 1]._points.clear();
            }
            else {
                al = q._inner[q.count - 1]._points;
                am = r._inner[r.count - 1]._points;
                an = s._inner[s.count - 1]._points;
                ao = t._inner[t.count - 1]._points;
            }
            this.g(al, am, an, ao, v, e - 1, f, g, null, h, i);
            j(al, am, an, ao, true);
            if (l != null) {
                this.c(q._inner[q.count - 1]._points, al, l, i, true);
                this.c(r._inner[r.count - 1]._points, am, l, i, false);
                this.c(s._inner[s.count - 1]._points, an, l, i, true);
                this.c(t._inner[t.count - 1]._points, ao, l, i, false);
            }
        }
        else {
            q.add(new PolyLineSegment());
            r.add(new PolyLineSegment());
            s.add(new PolyLineSegment());
            t.add(new PolyLineSegment());
            this.h(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, 0, e - 1, f, g, h, i);
            j(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, true);
        }
        var _loop_2 = function (ap) {
            var aq = q._inner[ap];
            var ar = r._inner[ap];
            var as = s._inner[ap];
            var at = t._inner[ap];
            if (aq._points.count > 0) {
                var au = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = aq._points._inner[0];
                    return $ret;
                })());
                au._segments.add(aq);
                m.c.add(au);
            }
            if (ar._points.count > 0) {
                var av = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = ar._points._inner[0];
                    return $ret;
                })());
                av._segments.add(ar);
                n.c.add(av);
            }
            if (as._points.count > 0) {
                var aw = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = as._points._inner[0];
                    return $ret;
                })());
                aw._segments.add(as);
                o.c.add(aw);
            }
            if (at._points.count > 0) {
                var ax = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = at._points._inner[0];
                    return $ret;
                })());
                ax._segments.add(at);
                p.c.add(ax);
            }
        };
        for (var ap = 0; ap < r.count; ap++) {
            _loop_2(ap);
        }
    };
    CategoryLineRasterizer.prototype.h = function (a, b, c, d, e, f, g, h, i, j) {
        this.g(a, b, c, d, e, f, g, h, null, i, j);
    };
    CategoryLineRasterizer.prototype.g = function (a, b, c, d, e, f, g, h, i, j, k) {
        this.o.clear();
        if (j == 1 && !this.a) {
            var l = FastFlattener.a(new List$1(Number_$type, 0), g, true, h, e, f, k);
            var m = l.count;
            var n = 0;
            var o = void 0;
            var p = void 0;
            var q = void 0;
            var r = new PointCollection(0);
            for (var s = 0; s < m; s++) {
                n = l.item(s);
                o = g._inner[n];
                p = o[0];
                q = o[1];
                r.add({ $type: Point_$type, x: p, y: q });
            }
            if (i != null) {
                this.c(a, r, i, k, true);
                this.c(d, r, i, k, false);
                this.c(this.o, r, i, k, false);
            }
            else {
                this.f(a, r);
                this.f(d, r);
                this.f(this.o, r);
            }
        }
        else {
            var t = FastFlattener.a(new List$1(Number_$type, 0), g, true, h, e, f, k);
            var u = FastFlattener.a(new List$1(Number_$type, 0), g, false, h, e, f, k);
            var v = t.count;
            var w = u.count;
            var x = 0;
            var y = void 0;
            var z = void 0;
            var aa = void 0;
            var ab = new PointCollection(0);
            var ac = new PointCollection(0);
            for (var ad = 0; ad < v; ad++) {
                x = t.item(ad);
                y = g._inner[x];
                z = y[0];
                aa = y[1];
                ab.add({ $type: Point_$type, x: z, y: aa });
                ac.add({ $type: Point_$type, x: z, y: aa });
            }
            var ae = new PointCollection(0);
            var af = void 0;
            var ag = void 0;
            for (var ah = w - 1; ah >= 0; ah--) {
                x = u.item(ah);
                y = g._inner[x];
                if (h) {
                    af = y[0];
                    ag = y[2];
                }
                else {
                    af = y[2];
                    ag = y[3];
                }
                ae.add({ $type: Point_$type, x: af, y: ag });
                ac.add({ $type: Point_$type, x: af, y: ag });
            }
            if (i != null) {
                this.c(a, ab, i, k, true);
                this.c(b, ab, i, k, false);
                this.c(d, ae, i, k, false);
                this.c(c, ac, i, k, true);
            }
            else {
                this.f(a, ab);
                this.f(b, ab);
                this.f(d, ae);
                this.f(c, ac);
            }
        }
    };
    CategoryLineRasterizer.prototype.f = function (a, b) {
        var c = b.count;
        for (var d = 0; d < c; d++) {
            a.add(b._inner[d]);
        }
    };
    CategoryLineRasterizer.$t = markType(CategoryLineRasterizer, 'CategoryLineRasterizer');
    return CategoryLineRasterizer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaSeries, _super);
    function AreaSeries() {
        var _this = _super.call(this) || this;
        _this.qi = null;
        _this.qi = new CategoryLineRasterizer();
        _this.ab = AreaSeries.$;
        _this.p1 = 0;
        return _this;
    }
    AreaSeries.prototype.bf = function () {
        return new AreaSeriesView(this);
    };
    AreaSeries.prototype.ng = function () {
        return 1;
    };
    AreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qh = a;
    };
    AreaSeries.prototype.get_ck = function () {
        return true;
    };
    AreaSeries.prototype.preferredCategoryMode = function (a) {
        return this.p1;
    };
    AreaSeries.prototype.dh = function (a, b) {
        var c = this.ll(this.lo(a), true, false);
        if (this.p8(a, c, b)) {
            return true;
        }
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    AreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    AreaSeries.prototype.oo = function (a, b) {
        var _this = this;
        _super.prototype.oo.call(this, a, b);
        var c = b.cn.d;
        var d = typeCast(AreaSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(d);
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var g = false;
        var h = this.ne.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bs, b.br, this.py.b8, f);
            this.ok(e, -1, this.valueColumn.count, this.py, i, b.n);
        }
        var j = d.de;
        var k = d.df;
        var l = d.dh;
        var m = d.dj;
        this.ne.ae(j, true, false, true, true);
        this.ne.ae(k, true, false, true, true);
        this.ne.ae(l, false, true, false, false);
        this.ne.ae(m, false, true, false, false);
        if (b.cr(a)) {
            d.c9(e.count, e, true, c, this.eu, function (n, o, p, q, r) { return _this.pi(n, a.f.count, b); }, this.unknownValuePlotting, e.count == 1 ? null : this.ox(e, e.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        var n = this.fetchYAxis();
        l._opacity = this.ne.i * this.d6;
        m._opacity = 0.5 * this.ne.i * this.d6;
    };
    AreaSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case AreaSeries.$$p[0]:
                this.nb.m = this.unknownValuePlotting == 0;
                this.jd(false);
                this.ik();
                break;
        }
    };
    Object.defineProperty(AreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    AreaSeries.$t = markType(AreaSeries, 'AreaSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    AreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting::qk', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return AreaSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var AreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaSeriesView, _super);
    function AreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.dg = new Path();
        _this.dk = new Path();
        _this.di = new Path();
        _this.dl = new Path();
        _this.da = new Path();
        _this.dc = new Path();
        _this.db = new Path();
        _this.dd = new Path();
        _this.c6 = a;
        return _this;
    }
    AreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(AreaSeriesView.prototype, "de", {
        get: function () {
            return this.dk;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "df", {
        get: function () {
            return this.dl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "dh", {
        get: function () {
            return this.dg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AreaSeriesView.prototype, "dj", {
        get: function () {
            return this.di;
        },
        enumerable: true,
        configurable: true
    });
    AreaSeriesView.prototype.c7 = function () {
        this.dg.ak = null;
        this.di.ak = null;
        this.dk.ak = null;
        this.dl.ak = null;
        this.an();
    };
    AreaSeriesView.prototype.c8 = function (a, b, c, d, e, f, g) {
        this.c9(a, b, c, d, e, f, g, null);
    };
    AreaSeriesView.prototype.c9 = function (a, b, c, d, e, f, g, h) {
        this.c6.qi.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qi.j(this.dg, this.dk, this.di, this.dl, a, b, c, d, e, f, g, h);
        this.an();
    };
    AreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.da.ak = this.dg.ak;
        this.dc.ak = this.dk.ak;
        this.db.ak = this.di.ak;
        this.dd.ak = this.dl.ak;
        var a = this.bl();
        this.da._fill = a;
        this.da._opacity = 1;
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
    };
    AreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
        }
        else {
            a.s(this.dg);
            a.s(this.di);
            a.s(this.dk);
            a.s(this.dl);
        }
    };
    AreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.dk, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dl, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.di, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.dg, "fillShape", ["Fill"]);
    };
    AreaSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 1;
        this.e.ex = -3;
    };
    AreaSeriesView.$t = markType(AreaSeriesView, 'AreaSeriesView', AnchoredCategorySeriesView.$);
    return AreaSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent area series.
 * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
*
* The `IgrAreaSeries` class represents a IgxDataChartComponent area series.Displays trend over time or ordered categories.
*
* Useful when there are many data points and the order is important.
*
* ```ts
* <IgrDataChart
* 	 width="100%"
*      height="100%"
* 	 chartTitle="COMPANY FINANCIAL PROJECTIONS"
*      dataSource={this.data}>
*
*
*     <IgrCategoryXAxis name="xAxisYears"
*     interval={12} labelLocation="OutsideBottom"
*     label="Year"  overlap={1} gap={0.4}  />
*
*     <IgrCategoryXAxis name="xAxisMonths"
*     interval={1}  labelLocation="OutsideBottom"
*     label="Month" overlap={1} gap={0.4}/>
*
*     <IgrNumericYAxis  name="yAxisLeft"
*     title="Expanse | Revenue"
*     minimumValue={-900} labelLocation="OutsideLeft"
*     maximumValue={900}
*     interval={300} />
*
*     <IgrNumericYAxis  name="yAxisRight"
*     title="Profit (%)"
*     minimumValue={0}  labelLocation="OutsideRight"
*     maximumValue={100} />
*
*
*     <IgrAreaSeries name="series1"
*     valueMemberPath="Revenue"
*     xAxisName="xAxisMonths"
*     yAxisName="yAxisLeft" />
*  </IgrDataChart>
* ```
*/
var IgrAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAreaSeries, _super);
    function IgrAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrAreaSeries.prototype.createImplementation = function () {
        return new AreaSeries();
    };
    Object.defineProperty(IgrAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAreaSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        *
        * The `isAreaOrLine` is used to check if the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAreaSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        *
        * The `unknownValuePlotting` property is used to determines how unknown values will be plotted on the chart.
        *
        * Null and Double.NaN are two examples of unknown values.
        *
        * ```ts
        * <IgrDataChart >
        *
        *
        *     <IgrCategoryXAxis name="xAxisYears"
        *     interval={12} labelLocation="OutsideBottom"
        *     label="Year"  overlap={1} gap={0.4}  />
        *
        *     <IgrCategoryXAxis name="xAxisMonths"
        *     interval={1}  labelLocation="OutsideBottom"
        *     label="Month" overlap={1} gap={0.4}/>
        *
        *     <IgrNumericYAxis  name="yAxisLeft"
        *     title="Expanse | Revenue"
        *     minimumValue={-900} labelLocation="OutsideLeft"
        *     maximumValue={900}
        *     interval={300} />
        *
        *     <IgrNumericYAxis  name="yAxisRight"
        *     title="Profit (%)"
        *     minimumValue={0}  labelLocation="OutsideRight"
        *     maximumValue={100} />
        *
        *
        *     <IgrAreaSeries name="series1"
        *     valueMemberPath="Revenue"
        *     xAxisName="xAxisMonths"
        *     yAxisName="yAxisLeft"
        * 	unknownValuePlotting="DontPlot" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
        * ```
        */
        get: function () {
            return this.i.unknownValuePlotting;
        },
        set: function (v) {
            this.i.unknownValuePlotting = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrAreaSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAreaSeriesModule() {
    }
    IgrAreaSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrAreaSeries", IgrAreaSeries);
        TypeRegistrar.register("AreaSeries", AreaSeries.$type);
    };
    return IgrAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnSeries, _super);
    function ColumnSeries() {
        var _this = _super.call(this) || this;
        _this.qn = null;
        _this.qi = 0;
        _this.ab = ColumnSeries.$;
        _this.p1 = 2;
        return _this;
    }
    ColumnSeries.prototype.bf = function () {
        return new ColumnSeriesView(this);
    };
    ColumnSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qh = a;
    };
    ColumnSeries.prototype.ng = function () {
        return 1;
    };
    ColumnSeries.prototype.get_nv = function () {
        return true;
    };
    ColumnSeries.prototype.preferredCategoryMode = function (a) {
        return this.p1;
    };
    ColumnSeries.prototype.lu = function (a) {
        if (this.qn == null) {
            this.qn = runOn(this, this.qk);
        }
        var b = this.p4 != null ? this.p4 : this.yAxis;
        var c = this.py;
        return this.o3.c$d(this, a, c, b, this.m7, this.n7(this.bi), this.n8(this.bi), this.qn);
    };
    ColumnSeries.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    ColumnSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a && c.c7 != null) {
            c.c7.count = 0;
        }
    };
    ColumnSeries.prototype.eg = function () {
        return this.py.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    ColumnSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = a.f;
        if (!b.q()) {
            return;
        }
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.p4.b8, f);
        g.b = this.eh();
        var h = new ScalerParams(0, d, e, this.py.b8, f);
        var i = this.p4;
        var j = i.dw(i.ke, g);
        var k = this.py.jr(d, e, f);
        var l = this.py;
        var m = b;
        if (isNaN_(k) || isInfinity(k)) {
            m.c7.count = 0;
            return;
        }
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        this.ne.p = this.ql;
        this.ne.q = this.qm;
        this.ne.j = this.ql;
        this.ne.k = this.qm;
        var n = false;
        var o = this.ne.c;
        if (o != null) {
            n = true;
        }
        var p = this.py.cd;
        var q = p ? this.py : null;
        var r = this.valueColumn.count;
        var s = this.n7(b);
        var t = 0;
        for (var u = 0; u < c.count; ++u) {
            var v = c._inner[u][0] - 0.5 * k;
            var w = this.qk(c._inner[u]);
            var x = j;
            w = Math.max(w, -100);
            x = Math.min(x, e.bottom + 100);
            var y = Math.abs(x - w);
            if (isInfinity(y)) {
                continue;
            }
            var z = m.c7.item(t);
            t++;
            z.width = k;
            z.height = y;
            if (n) {
                this.ok(c, u, r, l, h, b.n);
            }
            if (z.dataContext != null) {
                var aa = z.dataContext;
                if (s == 1) {
                    var ab = this.ne.a(r, u)[0];
                    if (ab >= 0 && ab < this.bz.count) {
                        if (q != null && q.i$b != null && q.i$b.count > ab) {
                            ab = q.i$b._inner[ab];
                        }
                        aa.item = this.bz.item(ab);
                    }
                }
                else {
                    aa.item = null;
                }
            }
            this.ne.ae(z, false, false, false, false);
            z.am = this.ne.j;
            z.an = this.ne.k;
            m.dc(z, v, Math.min(x, w));
        }
        m.c7.count = t;
        b.cu(a);
    };
    Object.defineProperty(ColumnSeries.prototype, "qj", {
        get: function () {
            return this.qi;
        },
        set: function (a) {
            if (this.qj != a) {
                var b = this.qj;
                this.qi = a;
                this.raisePropertyChanged("ConsolidatedColumnVerticalPosition", enumGetBox(ConsolidatedItemsPosition_$type, b), enumGetBox(ConsolidatedItemsPosition_$type, this.qj));
            }
        },
        enumerable: true,
        configurable: true
    });
    ColumnSeries.prototype.qk = function (a) {
        if (a == null || a.length < 3) {
            return NaN;
        }
        switch (this.qj) {
            case 0: return a[1];
            case 1: return a[2];
            case 2: return (a[1] + a[2]) / 2;
            case 3:
                var b = (a[1] + a[2]) / 2;
                if (this.yAxis == null) {
                    return b;
                }
                var c = this.yAxis.dz(b, new ScalerParams(1, this.bs.m4, this.bs.m3, this.yAxis.b8));
                if (c < this.yAxis.ke) {
                    return a[2];
                }
                else {
                    return a[1];
                }
            case 4:
                var d = (a[1] + a[2]) / 2;
                var e = this.yAxis.dz(d, new ScalerParams(1, this.bs.m4, this.bs.m3, this.yAxis.b8));
                if (this.yAxis == null) {
                    return d;
                }
                if (e < this.yAxis.ke) {
                    return a[1];
                }
                else {
                    return a[2];
                }
            default: return (a[1] + a[2]) / 2;
        }
    };
    Object.defineProperty(ColumnSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    ColumnSeries.$t = markType(ColumnSeries, 'ColumnSeries', HorizontalAnchoredCategorySeries.$);
    ColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ColumnSeries, 'raisePropertyChanged', ['RadiusX:ql:qr', [1, 2], 'RadiusY:qm:qs', [1, 2]]);
    return ColumnSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var ColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnSeriesView, _super);
    function ColumnSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c8 = null;
        _this.dd = new Rectangle();
        _this.c7 = null;
        _this.c6 = a;
        _this.c7 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.de);
            $ret.activate = runOn(_this, _this.c9);
            $ret.disactivate = runOn(_this, _this.db);
            $ret.destroy = runOn(_this, _this.da);
            return $ret;
        })());
        return _this;
    }
    ColumnSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    ColumnSeriesView.prototype.de = function () {
        var a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    };
    ColumnSeriesView.prototype.c9 = function (a) {
        a._visibility = 0;
    };
    ColumnSeriesView.prototype.db = function (a) {
        a._visibility = 1;
    };
    ColumnSeriesView.prototype.da = function (a) {
        this.c8.remove(a);
    };
    ColumnSeriesView.prototype.dc = function (a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    };
    ColumnSeriesView.prototype.z = function (a) {
        return this.c8._inner[a];
    };
    ColumnSeriesView.prototype.y = function (a) {
        var b = this.c8._inner[a];
        this.dd._visibility = b._visibility;
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        var c = this.bm(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.ey + 3;
        return this.dd;
    };
    ColumnSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.c8.count; c++) {
                var d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    ColumnSeriesView.prototype.ai = function (a) {
        var e_1, _a, e_2, _b;
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.c7.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        b++;
    };
    ColumnSeriesView.$t = markType(ColumnSeriesView, 'ColumnSeriesView', AnchoredCategorySeriesView.$);
    return ColumnSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent column series.
 * Compare values across categories by using vertical rectangles.Use it when the order of categories is not important or for displaying
 * item counts such as a histogram.
*
* ```ts
*  <IgrDataChart
* 		ref={this.onChartRef}
*         dataSource={this.data}>
*
*         <IgrCategoryXAxis name="xAxisYears"/>
*         <IgrCategoryXAxis name="xAxisMonths" />
*         <IgrNumericYAxis  name="yAxisLeft"  />
*         <IgrNumericYAxis  name="yAxisRight" />
*
*         <IgrColumnSeries name="series1"
*         valueMemberPath="volume"
*         xAxisName="xAxisMonths"
*         yAxisName="yAxisLeft"
*         isTransitionInEnabled="true" />
* </IgrDataChart>
* ```
*
* ```ts
* 	this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
* 	this.columnSeries1.dataSource = this.categoryData;
* 	this.columnSeries1.xAxis = this.categoryXAxis;
* 	this.columnSeries1.yAxis = this.numericYAxis;
* 	this.columnSeries1.xAxisName = "categoryXAxis";
* 	this.columnSeries1.yAxisName = "numericYAxis";
* 	this.columnSeries1.valueMemberPath = "volume";
* ```
*/
var IgrColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnSeries, _super);
    function IgrColumnSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrColumnSeries.prototype.createImplementation = function () {
        return new ColumnSeries();
    };
    Object.defineProperty(IgrColumnSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.ql;
        },
        set: function (v) {
            this.i.ql = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.qm;
        },
        set: function (v) {
            this.i.qm = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnSeries.prototype, "consolidatedColumnVerticalPosition", {
        /**
         * The positioning logic to use for columns which have been consolidated into a single visual element.
        */
        get: function () {
            return this.i.qj;
        },
        set: function (v) {
            this.i.qj = ensureEnum(ConsolidatedItemsPosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgrColumnSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrColumnSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrColumnSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnSeriesModule() {
    }
    IgrColumnSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrColumnSeries", IgrColumnSeries);
        TypeRegistrar.register("ColumnSeries", ColumnSeries.$type);
    };
    return IgrColumnSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineSeries, _super);
    function LineSeries() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this.qh = new CategoryLineRasterizer();
        _this.ab = LineSeries.$;
        _this.p1 = 0;
        return _this;
    }
    LineSeries.prototype.bf = function () {
        return new LineSeriesView(this);
    };
    LineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qi = a;
    };
    LineSeries.prototype.get_ck = function () {
        return true;
    };
    LineSeries.prototype.preferredCategoryMode = function (a) {
        return this.p1;
    };
    LineSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    LineSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = b.cn.d;
        var d = typeCast(LineSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var g = false;
        var h = this.ne.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bs, b.br, this.py.b8, f);
            this.ok(e, -1, this.valueColumn.count, this.py, i, b.n);
        }
        var j = d.dd;
        var k = d.de;
        var l = d.dc;
        this.ne.ae(j, true, false, true, false);
        this.ne.ae(k, true, false, true, false);
        this.ne.ae(l, false, true, false, false);
        l._opacity = 0.75 * this.ne.i;
        if (b.cr(a)) {
            d.c8(e.count, e, true, this.unknownValuePlotting, this.ow(e, e.count - 1, b.br, b.bs), c, this.eu);
            b.cu(a);
        }
    };
    LineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.nb.m = this.unknownValuePlotting == 0;
                this.jd(false);
                this.ik();
                break;
        }
    };
    Object.defineProperty(LineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    LineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::qk', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return LineSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var LineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineSeriesView, _super);
    function LineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.dg = new Path();
        _this.df = new Path();
        _this.dh = new Path();
        _this.db = new Path();
        _this.da = new Path();
        _this.c9 = new Path();
        _this.c6 = a;
        return _this;
    }
    Object.defineProperty(LineSeriesView.prototype, "dd", {
        get: function () {
            return this.dg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "de", {
        get: function () {
            return this.dh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "dc", {
        get: function () {
            return this.df;
        },
        enumerable: true,
        configurable: true
    });
    LineSeriesView.prototype.c7 = function () {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    };
    LineSeriesView.prototype.c8 = function (a, b, c, d, e, f, g) {
        this.c6.qh.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qh.m(this.dg, this.df, this.dh, a, b, c, d, e, f, g);
        this.an();
    };
    LineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
    };
    LineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.da.ak = this.dg.ak;
        this.db.ak = this.dh.ak;
        this.c9.ak = this.df.ak;
        var a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 1;
    };
    LineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c9);
                a.s(this.da);
                a.s(this.db);
            }
            else {
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
        }
    };
    LineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
    };
    LineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
    return LineSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent line series.
 * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
*
* `IgrLineSeries` belongs to a group of `IgrCategorySeries` and it is rendered using a collection of points connected by straight line segments.
*
* ```ts
* <IgrDataChart
* 	dataSource={this.data} >
* <IgrCategoryXAxis name="xAxis"
* 	label="Country" />
* <IgrNumericYAxis name="yAxis"
* 	minimumValue={0}  />
* <IgrLineSeries
* 	name="series1"
* 	xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Coal" />
*  </IgrDataChart>
* ```
*
* ```ts
* const series2 = new IgrLineSeries({ name: "series2" });
* series2.markerType = MarkerType.Circle;
* series2.valueMemberPath = "RUS";
* series2.title = "Russia";
* series2.xAxisName = "xAxis";
* series2.yAxisName = "yAxis";
* series2.thickness = 2;
* ```
*/
var IgrLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLineSeries, _super);
    function IgrLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrLineSeries.prototype.createImplementation = function () {
        return new LineSeries();
    };
    Object.defineProperty(IgrLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLineSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        *
        * Gets whether the `IgrSeries` shows an area or a line shape.
        *
        * ```ts
        * let isAreaOrLine: boolean = series.isAreaOrLine;
        * ```
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLineSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        *
        * Determines how unknown values will be plotted for the `IgrSeries`. This can be set to `LinearInterpolate` to create a continous shape or `DontPlot` to create breaks in the series.
        *
        * Null and Double.NaN are two examples of unknown values.
        *
        * ```ts
        * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
        * ```
        *
        * ```ts
        * <IgrDataChart
        * 	dataSource={this.data} >
        * <IgrCategoryXAxis name="xAxis"
        * 	label="Country" />
        * <IgrNumericYAxis name="yAxis"
        * 	minimumValue={0}  />
        * <IgrLineSeries
        * 	name="series1"
        * 	xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Coal"
        * 	unknownValuePlotting:"LinearInterpolate"/>
        * ```
        */
        get: function () {
            return this.i.unknownValuePlotting;
        },
        set: function (v) {
            this.i.unknownValuePlotting = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrLineSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrLineSeriesModule() {
    }
    IgrLineSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrLineSeries", IgrLineSeries);
        TypeRegistrar.register("LineSeries", LineSeries.$type);
    };
    return IgrLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of Spline calculations.
 */
var SplineType = /*@__PURE__*/ (function (SplineType) {
    /**
     * Calculates the spline using a natural spline calculation formula.
     */
    SplineType[SplineType["Natural"] = 0] = "Natural";
    /**
     * Calculated the spline using a clamped spline calculation formula.
     */
    SplineType[SplineType["Clamped"] = 1] = "Clamped";
    return SplineType;
})({});
/**
 * @hidden
 */
var SplineType_$type = /*@__PURE__*/ markEnum('SplineType', 'Natural,0|Clamped,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SafeEnumerable = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SafeEnumerable, _super);
    function SafeEnumerable(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    SafeEnumerable.prototype.c = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    SafeEnumerable.prototype._b = function () {
        var _a, _c, a, e_1_1;
        var e_1, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (this.a == null) {
                        return [2 /*return*/, undefined];
                    }
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(this.a)), _c = _a.next();
                    _e.label = 2;
                case 2:
                    if (!!_c.done)
                        return [3 /*break*/, 5];
                    a = _c.value;
                    return [4 /*yield*/, this.c(a)];
                case 3:
                    _e.sent();
                    _e.label = 4;
                case 4:
                    _c = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_c && !_c.done && (_d = _a.return))
                            _d.call(_a);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                    return [7 /*endfinally*/];
                case 8: return [2 /*return*/];
            }
        });
    };
    SafeEnumerable.prototype.b = function () {
        var _this = this;
        return toEnum(function () { return _this._b(); });
    };
    SafeEnumerable.prototype.getEnumerator = function () {
        return getEnumerator(this.b());
    };
    SafeEnumerable.prototype.getEnumeratorObject = function () {
        return this.getEnumerator();
    };
    SafeEnumerable.$t = markType(SafeEnumerable, 'SafeEnumerable', Base.$, [IEnumerable$1_$type.specialize(Number_$type)]);
    return SafeEnumerable;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SafeReadOnlyDoubleCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SafeReadOnlyDoubleCollection, _super);
    function SafeReadOnlyDoubleCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this.a = new ReadOnlyCollection$1(Number_$type, 1, c);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.a = new ReadOnlyCollection$1(Number_$type, 1, c);
                    _this.b = d;
                }
                break;
        }
        return _this;
    }
    SafeReadOnlyDoubleCollection.prototype.c = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return this.b;
        }
        return a;
    };
    SafeReadOnlyDoubleCollection.prototype.indexOf = function (a) {
        return this.a.indexOf(a);
    };
    SafeReadOnlyDoubleCollection.prototype.insert = function (a, b) {
        this.a.insert(a, b);
    };
    SafeReadOnlyDoubleCollection.prototype.removeAt = function (a) {
        this.a.removeAt(a);
    };
    SafeReadOnlyDoubleCollection.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            (typeCast(IList$1_$type.specialize(Number_$type), this.a)).item(a, b);
            return b;
        }
        else {
            return this.c(this.a.item(a));
        }
    };
    SafeReadOnlyDoubleCollection.prototype.add = function (a) {
        this.a.add(a);
    };
    SafeReadOnlyDoubleCollection.prototype.clear = function () {
        this.a.clear();
    };
    SafeReadOnlyDoubleCollection.prototype.contains = function (a) {
        return this.a.contains(a);
    };
    SafeReadOnlyDoubleCollection.prototype.copyTo = function (a, b) {
        for (var c = b; c < a.length; c++) {
            a[c] = this.item(c);
        }
    };
    Object.defineProperty(SafeReadOnlyDoubleCollection.prototype, "count", {
        get: function () {
            return this.a.count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SafeReadOnlyDoubleCollection.prototype, "isReadOnly", {
        get: function () {
            return this.a.isReadOnly;
        },
        enumerable: true,
        configurable: true
    });
    SafeReadOnlyDoubleCollection.prototype.remove = function (a) {
        return this.a.remove(a);
    };
    SafeReadOnlyDoubleCollection.prototype.getEnumerator = function () {
        return new SafeEnumerable(this.a).getEnumerator();
    };
    SafeReadOnlyDoubleCollection.prototype.getEnumeratorObject = function () {
        return this.getEnumerator();
    };
    SafeReadOnlyDoubleCollection.$t = markType(SafeReadOnlyDoubleCollection, 'SafeReadOnlyDoubleCollection', Base.$, [IList$1_$type.specialize(Number_$type)]);
    return SafeReadOnlyDoubleCollection;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SafeSortedReadOnlyDoubleCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SafeSortedReadOnlyDoubleCollection, _super);
    function SafeSortedReadOnlyDoubleCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.c = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.a = new SafeReadOnlyDoubleCollection(0, c);
                    _this.b = d;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    _this.a = new SafeReadOnlyDoubleCollection(1, c, e);
                    _this.b = d;
                    _this.c = e;
                }
                break;
        }
        return _this;
    }
    SafeSortedReadOnlyDoubleCollection.prototype.d = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return this.c;
        }
        return a;
    };
    SafeSortedReadOnlyDoubleCollection.prototype.indexOf = function (a) {
        var b = this.a.indexOf(a);
        return this.b.indexOf(b);
    };
    SafeSortedReadOnlyDoubleCollection.prototype.insert = function (a, b) {
        this.a.insert(a, b);
    };
    SafeSortedReadOnlyDoubleCollection.prototype.removeAt = function (a) {
        this.a.removeAt(a);
    };
    SafeSortedReadOnlyDoubleCollection.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            (typeCast(IList$1_$type.specialize(Number_$type), this.a)).item(a, b);
            return b;
        }
        else {
            var b_1 = this.b.item(a);
            return this.d(this.a.item(b_1));
        }
    };
    SafeSortedReadOnlyDoubleCollection.prototype.add = function (a) {
        this.a.add(a);
    };
    SafeSortedReadOnlyDoubleCollection.prototype.clear = function () {
        this.a.clear();
    };
    SafeSortedReadOnlyDoubleCollection.prototype.contains = function (a) {
        return this.a.contains(a);
    };
    SafeSortedReadOnlyDoubleCollection.prototype.copyTo = function (a, b) {
        for (var c = b; c < a.length; c++) {
            a[c] = this.item(c);
        }
    };
    Object.defineProperty(SafeSortedReadOnlyDoubleCollection.prototype, "count", {
        get: function () {
            return this.a.count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SafeSortedReadOnlyDoubleCollection.prototype, "isReadOnly", {
        get: function () {
            return this.a.isReadOnly;
        },
        enumerable: true,
        configurable: true
    });
    SafeSortedReadOnlyDoubleCollection.prototype.remove = function (a) {
        return this.a.remove(a);
    };
    SafeSortedReadOnlyDoubleCollection.prototype._getEnumerator = function () {
        var a;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = 0;
                    _a.label = 1;
                case 1:
                    if (!(a < this.a.count))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, this.item(a)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    a++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    SafeSortedReadOnlyDoubleCollection.prototype.getEnumerator = function () {
        var _this = this;
        return toEnum(function () { return _this._getEnumerator(); }).getEnumerator();
    };
    SafeSortedReadOnlyDoubleCollection.prototype.getEnumeratorObject = function () {
        return this.getEnumerator();
    };
    SafeSortedReadOnlyDoubleCollection.$t = markType(SafeSortedReadOnlyDoubleCollection, 'SafeSortedReadOnlyDoubleCollection', Base.$, [IList$1_$type.specialize(Number_$type)]);
    return SafeSortedReadOnlyDoubleCollection;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SplineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineSeriesBase, _super);
    function SplineSeriesBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.qh = null;
        return _this;
    }
    SplineSeriesBase.prototype.bf = function () {
        return new SplineSeriesBaseView(this);
    };
    SplineSeriesBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qi = a;
    };
    SplineSeriesBase.prototype.get_ck = function () {
        return true;
    };
    SplineSeriesBase.prototype.qo = function (a, b, c, d, e, f) {
        var _this = this;
        var g = typeCast(ISortingAxis_$type, d);
        var h = this.getEffectiveViewport1(f);
        if (g == null) {
            return;
        }
        var i = new ScalerParams(0, b, c, d.b8, h);
        var j = new ScalerParams(0, b, c, e.b8, h);
        j.b = this.eh();
        var k = this.l3();
        var l = 0;
        var m = this.qm(d, b, c, h);
        var n = function (o) { return o; };
        var o = function (p) { return _this.valueColumn.item(g.i$b._inner[p]); };
        var p = this.nf.cn.f;
        var q = this.nf.cn.e;
        var r = truncate(Math.ceil(c.width / (p - q)));
        var s = new CollisionAvoider();
        var t = this.nf.cn.d;
        if (t <= 0 || (q <= 0 && p <= 0)) {
            this.nf.cq.count = l;
            return;
        }
        var u = 0;
        var v = 0;
        for (var w = q; w < p + 1; ++w) {
            var x = null;
            var y = w * t;
            if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                y = g.i$b._inner[y];
            }
            if (w >= (this.valueColumn.count - 1)) {
                if (k && this.qk(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.bz.count - 1), l, f, u - 1)) {
                    ++l;
                }
                break;
            }
            var z = n(w);
            var aa = o(w);
            var ab = n(w + 1);
            var ac = o(w + 1);
            var ad = ab - z;
            var ae = this.qh[w];
            var af = this.qh[w + 1];
            var ag = g.i$d(g.i$b._inner[w]);
            var ah = d.dw(ag, i) + m;
            var ai = e.dw(aa, j);
            a.f.add([ah, ai, ai]);
            u++;
            v = u;
            for (var aj = 1; aj < r; ++aj) {
                var ak = aj / r;
                var al = z + ad * ak;
                var am = (ab - al) / ad;
                var an = (al - z) / ad;
                var ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                var ap = g.i$d(g.i$b._inner[w]);
                var aq = g.i$d(g.i$b._inner[w + 1]);
                var ar = ap + (aq - ap) * ak;
                al = d.dw(ar, i) + m;
                ao = e.dw(ao, j);
                a.f.add([al, ao, ao]);
                u++;
            }
            if (k) {
                x = [ah, ai, ai];
            }
            if (k && this.qk(a, x, s, Math.min(y, this.bz.count - 1), l, f, v - 1)) {
                ++l;
            }
        }
        f.cq.count = l;
    };
    SplineSeriesBase.prototype.qk = function (a, b, c, d, e, f, g) {
        var h = b[0];
        var i = b[1];
        var j = new Rect(0, h - 5, i - 5, 11, 11);
        if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
            a.m.add({ $type: Point_$type, x: h, y: i });
            var k = f.cq.item(e);
            k.content.item = this.bz.item(d);
            k.al = g;
            return true;
        }
        return false;
    };
    SplineSeriesBase.prototype.aj = function (a, b, c, d, e, f) {
        if (a == null || a.cd || this.n7(this.bi) > 1 || this.n7(this.bi) == 0) {
            return _super.prototype.aj.call(this, this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), e, f);
        }
        if (this.m7.f.count == 0) {
            return null;
        }
        var g = this.qi.cn.f;
        var h = this.bi.br;
        var i = truncate(Math.ceil(h.width / (g - d)));
        var j = -1;
        var k = -1;
        var l = this.eb(e);
        var m = this.fe(e, f);
        var n = this.fc(e, f);
        var o = truncate(Math.floor(m / this.n7(this.bi)));
        var p = truncate(Math.floor(n / this.n7(this.bi)));
        j = o - this.n8(this.bi);
        k = p - this.n8(this.bi);
        var q = j * i;
        var r = k * i;
        var s = 0;
        if (m != n) {
            s = (l - m) / (n - m);
        }
        var t = truncate(Math.floor(q + s * (r - q)));
        j = t;
        k = t + 1;
        if (j < 0) {
            j = 0;
        }
        if (j > this.m7.f.count - 1) {
            j = this.m7.f.count - 1;
        }
        if (k < 0) {
            k = 0;
        }
        if (k > this.m7.f.count - 1) {
            k = this.m7.f.count - 1;
        }
        var u = this.m7.f._inner[j];
        var v = this.m7.f._inner[k];
        var w = new Array(2);
        w[0] = u;
        w[1] = v;
        return w;
    };
    SplineSeriesBase.prototype.ol = function (a, b) {
        var _this = this;
        _super.prototype.ol.call(this, a, b);
        if (a.f.count <= 1) {
            return;
        }
        if (b.cn.d == 0) {
            return;
        }
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.py;
        var g = this.p4;
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, g.b8, e);
            $ret.b = _this.eh();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        var j = this.l3();
        var k = 0;
        var l = typeCast(ISortingAxis_$type, this.py);
        if (l != null && l.i$b.count != this.bz.count) {
            return;
        }
        var m = this.qm(f, c, d, e);
        var n = function (o) { return o; };
        var o = function (p) { return _this.valueColumn.item(p); };
        var p = b.cn.d;
        if ((this.qh == null || this.qh.length != this.valueColumn.count) && p == 1) {
            var q = this.qj == 0 ? NaN : 0;
            if (this.py != null && typeCast(ISortingAxis_$type, this.py) !== null && this.py.i$b != null) {
                var r_1 = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.py.i$b, NaN);
                o = function (s) { return r_1.item(s); };
            }
            this.qh = Numeric.c(this.valueColumn.count, n, o, q, q);
        }
        var s = b.cn.f;
        var t = b.cn.e;
        var u = truncate(Math.ceil(d.width / (s - t)));
        var v = new CollisionAvoider();
        if (l != null) {
            this.qo(a, c, d, f, g, b);
            return;
        }
        var w = b;
        w.c2();
        var x = 0;
        var y = 0;
        for (var z = t; z <= s; ++z) {
            var aa = null;
            if (p == 1) {
                if (z >= (this.valueColumn.count - 1)) {
                    if (j && this.qk(a, a.f._inner[a.f.count - 1], v, Math.min(z * p, this.bz.count - 1), k, b, x - 1)) {
                        ++k;
                    }
                    break;
                }
                var ab = n(z);
                var ac = o(z);
                var ad = n(z + 1);
                var ae = o(z + 1);
                var af = ad - ab;
                var ag = this.qh[z];
                var ah = this.qh[z + 1];
                var ai = f.dw(ab, h) + m;
                var aj = g.dw(ac, i);
                a.f.add([ai, aj, aj]);
                x++;
                y = x;
                for (var ak = 1; ak < u; ++ak) {
                    var al = ab + af * ak / u;
                    var am = (ad - al) / af;
                    var an = (al - ab) / af;
                    var ao = am * ac + an * ae + ((am * am * am - am) * ag + (an * an * an - an) * ah) * (af * af) / 6;
                    al = f.dw(al, h) + m;
                    ao = g.dw(ao, i);
                    a.f.add([al, ao, ao]);
                    x++;
                }
                if (j) {
                    aa = b.cn.getBucket(z);
                    aa[0] = (f.dw(aa[0], h) + m);
                    aa[1] = g.dw(aa[1], i);
                    aa[2] = g.dw(aa[2], i);
                }
            }
            else {
                aa = b.cn.getBucket(z);
                if (!isNaN_(aa[0])) {
                    aa[0] = (f.dw(aa[0], h) + m);
                    aa[1] = g.dw(aa[1], i);
                    aa[2] = g.dw(aa[2], i);
                    a.f.add(aa);
                    x++;
                }
            }
            if (j && this.qk(a, aa, v, Math.min(z * p, this.bz.count - 1), k, b, y - 1)) {
                ++k;
            }
        }
        w.c4();
        b.cq.count = k;
    };
    SplineSeriesBase.prototype.ql = function (a, b, c, d, e, f, g) {
        var h = d - b;
        var i = b + h * a;
        var j = (d - i) / h;
        var k = (i - b) / h;
        var l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
        return l;
    };
    SplineSeriesBase.prototype.ef = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        var k = e;
        var l = f;
        var m = i;
        var n = j;
        var o = NaN;
        var p = NaN;
        if (this.qh != null && e >= 0 && e < this.qh.length) {
            o = this.qh[e];
        }
        if (this.qh != null && f >= 0 && f < this.qh.length) {
            p = this.qh[f];
        }
        return this.ql(a, k, m, l, n, o, p);
    };
    SplineSeriesBase.prototype.qm = function (a, b, c, d) {
        var e = this.preferredCategoryMode(a);
        if (e == 0 && a.categoryMode != 0) {
            e = 1;
        }
        var f = 0;
        switch (e) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                f = a.getGroupCenter(this.fh, b, c, d);
                break;
        }
        if (a.b8) {
            f = -f;
        }
        return f;
    };
    SplineSeriesBase.prototype.qp = function () {
        this.qh = null;
    };
    SplineSeriesBase.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case "ValueColumn":
            case "FastItemsSource":
                this.qp();
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case SplineSeriesBase.$$p[0]:
                this.qp();
                this.jd(false);
                this.ik();
                break;
        }
    };
    SplineSeriesBase.prototype.hy = function (a, b, c, d) {
        this.qp();
        _super.prototype.hy.call(this, a, b, c, d);
    };
    Object.defineProperty(SplineSeriesBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineSeriesBase.$t = markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
    SplineSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['SplineType:qj:qq', [SplineType_$type, enumGetBox(SplineType_$type, 0)]]);
    return SplineSeriesBase;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var SplineSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineSeriesBaseView, _super);
    function SplineSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c6 = a;
        return _this;
    }
    SplineSeriesBaseView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    SplineSeriesBaseView.$t = markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);
    return SplineSeriesBaseView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaSeries, _super);
    function SplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.qr = null;
        _this.qr = new CategoryLineRasterizer();
        _this.ab = SplineAreaSeries.$;
        return _this;
    }
    SplineAreaSeries.prototype.bf = function () {
        return new SplineAreaSeriesView(this);
    };
    SplineAreaSeries.prototype.ng = function () {
        return 1;
    };
    SplineAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qs = a;
    };
    SplineAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    SplineAreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c8();
    };
    SplineAreaSeries.prototype.dh = function (a, b) {
        var c = this.ll(this.lo(a), true, false);
        if (this.p8(a, c, b)) {
            return true;
        }
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    SplineAreaSeries.prototype.oo = function (a, b) {
        var _this = this;
        _super.prototype.oo.call(this, a, b);
        var c = this.nf.cn.d;
        var d = typeCast(SplineAreaSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var g = false;
        var h = this.ne.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bs, b.br, this.py.b8, f);
            this.ok(e, -1, this.valueColumn.count, this.py, i, b.n);
        }
        var j = d.df;
        var k = d.dg;
        var l = d.di;
        var m = d.dk;
        this.ne.ae(j, true, false, true, true);
        this.ne.ae(k, true, false, true, true);
        this.ne.ae(l, false, true, false, false);
        this.ne.ae(m, false, true, false, false);
        l._opacity = this.ne.i * this.d6;
        m._opacity = 0.5 * this.ne.i * this.d6;
        if (b.cr(a)) {
            d.da(a.f.count, e, true, c, this.eu, function (n, o, p, q, r) { return _this.pi(n, a.f.count, b); }, 1, a.f.count == 1 ? null : this.ox(e, e.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        var n = this.fetchYAxis();
    };
    Object.defineProperty(SplineAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineAreaSeries.$t = markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
    return SplineAreaSeries;
}(SplineSeriesBase));
/**
 * @hidden
 */
var SplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaSeriesView, _super);
    function SplineAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c7 = null;
        _this.dh = new Path();
        _this.dl = new Path();
        _this.dj = new Path();
        _this.dm = new Path();
        _this.db = new Path();
        _this.dd = new Path();
        _this.dc = new Path();
        _this.de = new Path();
        _this.c7 = a;
        return _this;
    }
    SplineAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(SplineAreaSeriesView.prototype, "df", {
        get: function () {
            return this.dl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "dg", {
        get: function () {
            return this.dm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "di", {
        get: function () {
            return this.dh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineAreaSeriesView.prototype, "dk", {
        get: function () {
            return this.dj;
        },
        enumerable: true,
        configurable: true
    });
    SplineAreaSeriesView.prototype.c8 = function () {
        this.dh.ak = null;
        this.dj.ak = null;
        this.dl.ak = null;
        this.dm.ak = null;
        this.an();
    };
    SplineAreaSeriesView.prototype.c9 = function (a, b, c, d, e, f, g) {
        this.da(a, b, c, d, e, f, g, null);
    };
    SplineAreaSeriesView.prototype.da = function (a, b, c, d, e, f, g, h) {
        this.c7.qr.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c7.qr.j(this.dh, this.dl, this.dj, this.dm, a, b, c, d, e, f, g, h);
        this.an();
    };
    SplineAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.db.ak = this.dh.ak;
        this.dd.ak = this.dl.ak;
        this.dc.ak = this.dj.ak;
        this.de.ak = this.dm.ak;
        var a = this.bl();
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._fill = a;
        this.dc._opacity = 1;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
        this.de._stroke = a;
        this.de.ac = this.e.ey + 3;
    };
    SplineAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
            a.s(this.de);
        }
        else {
            a.s(this.dh);
            a.s(this.dj);
            a.s(this.dl);
            a.s(this.dm);
        }
    };
    SplineAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.dl, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dm, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.dj, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.dh, "fillShape", ["Fill"]);
    };
    SplineAreaSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 1;
        this.e.ex = -3;
    };
    SplineAreaSeriesView.$t = markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);
    return SplineAreaSeriesView;
}(SplineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
var IgrSplineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineSeriesBase, _super);
    function IgrSplineSeriesBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrSplineSeriesBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSplineSeriesBase.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSplineSeriesBase.prototype, "splineType", {
        /**
         * Gets or sets the type of spline to be rendered.
        *
        * ```ts
        * this.series.splineType = SplineType.Clamped;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrSplineAreaSeries
        *      name="series1"
        *      valueMemberPath="value"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qj;
        },
        set: function (v) {
            this.i.qj = ensureEnum(SplineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineSeriesBase;
}(IgrHorizontalAnchoredCategorySeries));

/**
 * Represents a IgxDataChartComponent spline area series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineAreaSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"
* />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSplineAreaSeries({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* ```
*/
var IgrSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineAreaSeries, _super);
    function IgrSplineAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrSplineAreaSeries.prototype.createImplementation = function () {
        return new SplineAreaSeries();
    };
    Object.defineProperty(IgrSplineAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineAreaSeries;
}(IgrSplineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSplineAreaSeriesModule() {
    }
    IgrSplineAreaSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrSplineAreaSeries", IgrSplineAreaSeries);
        TypeRegistrar.register("SplineAreaSeries", SplineAreaSeries.$type);
    };
    return IgrSplineAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineSeries, _super);
    function SplineSeries() {
        var _this = _super.call(this) || this;
        _this.qr = null;
        _this.qr = new CategoryLineRasterizer();
        _this.ab = SplineSeries.$;
        return _this;
    }
    SplineSeries.prototype.bf = function () {
        return new SplineSeriesView(this);
    };
    SplineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qs = a;
    };
    SplineSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    SplineSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c8();
    };
    SplineSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = b;
        var d = c.cn.d;
        var e = typeCast(SplineSeriesView.$, b);
        var f = a.f;
        var g = this.getEffectiveViewport1(b);
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var h = false;
        var i = this.ne.c;
        if (i != null) {
            h = true;
        }
        if (h) {
            var j = new ScalerParams(0, b.bs, b.br, this.py.b8, g);
            this.ok(f, -1, this.valueColumn.count, this.py, j, b.n);
        }
        var k = e.de;
        var l = e.df;
        var m = e.dd;
        this.ne.ae(k, true, false, true, false);
        this.ne.ae(l, true, false, true, false);
        this.ne.ae(m, false, true, false, false);
        m._opacity = 0.75 * this.ne.i;
        if (b.cr(a)) {
            e.c9(f.count, f, true, 1, this.ow(f, f.count - 1, b.br, b.bs), d, this.eu);
            b.cu(a);
        }
    };
    Object.defineProperty(SplineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineSeries.$t = markType(SplineSeries, 'SplineSeries', SplineSeriesBase.$);
    return SplineSeries;
}(SplineSeriesBase));
/**
 * @hidden
 */
var SplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineSeriesView, _super);
    function SplineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c7 = null;
        _this.dh = new Path();
        _this.dg = new Path();
        _this.di = new Path();
        _this.dc = new Path();
        _this.db = new Path();
        _this.da = new Path();
        _this.c7 = a;
        return _this;
    }
    Object.defineProperty(SplineSeriesView.prototype, "de", {
        get: function () {
            return this.dh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineSeriesView.prototype, "df", {
        get: function () {
            return this.di;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineSeriesView.prototype, "dd", {
        get: function () {
            return this.dg;
        },
        enumerable: true,
        configurable: true
    });
    SplineSeriesView.prototype.c8 = function () {
        this.dg.ak = null;
        this.dh.ak = null;
        this.di.ak = null;
        this.an();
    };
    SplineSeriesView.prototype.c9 = function (a, b, c, d, e, f, g) {
        this.c7.qr.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c7.qr.m(this.dh, this.dg, this.di, a, b, c, d, e, f, g);
        this.an();
    };
    SplineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.db.ak = this.dh.ak;
        this.dc.ak = this.di.ak;
        this.da.ak = this.dg.ak;
        var a = this.bl();
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.da._fill = a;
        this.da._opacity = 1;
    };
    SplineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.da);
                a.s(this.db);
                a.s(this.dc);
            }
            else {
                a.s(this.dg);
                a.s(this.dh);
                a.s(this.di);
            }
        }
    };
    SplineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.dh, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.di, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
    };
    SplineSeriesView.$t = markType(SplineSeriesView, 'SplineSeriesView', SplineSeriesBaseView.$);
    return SplineSeriesView;
}(SplineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent spline series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrSplineSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSplineAreaSeries({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* ```
*/
var IgrSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineSeries, _super);
    function IgrSplineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrSplineSeries.prototype.createImplementation = function () {
        return new SplineSeries();
    };
    Object.defineProperty(IgrSplineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineSeries;
}(IgrSplineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSplineSeriesModule() {
    }
    IgrSplineSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrSplineSeries", IgrSplineSeries);
        TypeRegistrar.register("SplineSeries", SplineSeries.$type);
    };
    return IgrSplineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StepAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepAreaSeries, _super);
    function StepAreaSeries() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this.qh = new CategoryLineRasterizer();
        _this.ab = StepAreaSeries.$;
        return _this;
    }
    StepAreaSeries.prototype.bf = function () {
        return new StepAreaSeriesView(this);
    };
    StepAreaSeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    StepAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qi = a;
    };
    StepAreaSeries.prototype.get_ck = function () {
        return true;
    };
    StepAreaSeries.prototype.preferredCategoryMode = function (a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    };
    StepAreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    StepAreaSeries.prototype.qj = function (a, b, c, d, e) {
        if (b) {
            if (e) {
                if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 1 ? -d : d);
        }
        if (e) {
            if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 0 ? -d : d);
    };
    StepAreaSeries.prototype.ng = function () {
        return 1;
    };
    StepAreaSeries.prototype.ef = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    };
    StepAreaSeries.prototype.bd = function () {
        if (this.be == 0) {
            return 2;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    StepAreaSeries.prototype.oo = function (a, b) {
        var _this = this;
        _super.prototype.oo.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = typeCast(ISortingAxis_$type, this.py) != null;
        var g = this.py != null ? 0.5 * this.py.getCategorySize(c, d, e) : 0;
        if (this.py != null && this.py.b8) {
            g = -g;
        }
        var h = a.f.count * 2;
        var i = new List$1(Array_$type, 2, h);
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var j = false;
        var k = this.ne.c;
        if (k != null) {
            j = true;
        }
        for (var l = 0; l < h; l++) {
            var m = new Array(4);
            m[0] = this.qj(l, false, a, g, f);
            m[1] = a.f._inner[(intDivide(l, 2))][1];
            m[2] = this.qj(l, true, a, g, f);
            m[3] = a.f._inner[(intDivide(l, 2))][2];
            i.add(m);
        }
        var n = this.nf.cn.d;
        if (j) {
            var o = new ScalerParams(0, b.bs, b.br, this.py.b8, e);
            this.ok(i, -1, this.valueColumn.count, this.py, o, b.n);
        }
        var p = typeCast(StepAreaSeriesView.$, b);
        var q = p.dj;
        var r = p.dl;
        var s = p.df;
        var t = p.dh;
        this.ne.ae(q, true, false, true, true);
        this.ne.ae(r, true, false, true, true);
        this.ne.ae(s, false, true, false, false);
        this.ne.ae(t, false, true, false, false);
        if (b.cr(a)) {
            p.c9(h, i, false, n, this.eu, function (u, v, w, x, y) { return _this.pi(u, 2 * a.f.count, b); }, 1, this.ox(i, i.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        var u = this.fetchYAxis();
        p.df._opacity = this.d6;
        p.dh._opacity = 0.5 * this.d6;
    };
    Object.defineProperty(StepAreaSeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(this.py);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StepAreaSeries.$t = markType(StepAreaSeries, 'StepAreaSeries', HorizontalAnchoredCategorySeries.$, [IIsCategoryBased_$type]);
    return StepAreaSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var StepAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepAreaSeriesView, _super);
    function StepAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.de = new Path();
        _this.di = new Path();
        _this.dg = new Path();
        _this.dk = new Path();
        _this.da = new Path();
        _this.dc = new Path();
        _this.db = new Path();
        _this.dd = new Path();
        _this.c6 = a;
        return _this;
    }
    StepAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(StepAreaSeriesView.prototype, "df", {
        get: function () {
            return this.de;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepAreaSeriesView.prototype, "dj", {
        get: function () {
            return this.di;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepAreaSeriesView.prototype, "dh", {
        get: function () {
            return this.dg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepAreaSeriesView.prototype, "dl", {
        get: function () {
            return this.dk;
        },
        enumerable: true,
        configurable: true
    });
    StepAreaSeriesView.prototype.c7 = function () {
        this.de.ak = null;
        this.dg.ak = null;
        this.di.ak = null;
        this.dk.ak = null;
        this.an();
    };
    StepAreaSeriesView.prototype.c8 = function (a, b, c, d, e, f, g) {
        this.c8(a, b, c, d, e, f, g);
    };
    StepAreaSeriesView.prototype.c9 = function (a, b, c, d, e, f, g, h) {
        this.c6.qh.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qh.j(this.de, this.di, this.dg, this.dk, a, b, c, d, e, f, g, h);
        this.an();
    };
    StepAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.da.ak = this.de.ak;
        this.dc.ak = this.di.ak;
        this.db.ak = this.dg.ak;
        this.dd.ak = this.dk.ak;
        var a = this.bl();
        this.da._fill = a;
        this.da._opacity = 1;
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
    };
    StepAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
        }
        else {
            a.s(this.de);
            a.s(this.dg);
            a.s(this.di);
            a.s(this.dk);
        }
    };
    StepAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.di, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dk, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.de, "fillShape", ["Fill"]);
    };
    StepAreaSeriesView.$t = markType(StepAreaSeriesView, 'StepAreaSeriesView', AnchoredCategorySeriesView.$);
    return StepAreaSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent step area series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrStepAreaSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		valueMemberPath="value" />
*  </IgrDataChart>
* ```
*
* ```ts
*   let series = new IgrStepAreaSeries({name:"series1"});
*   series.xAxis = this.xAxis;
*   series.yAxis = this.yAxis;
*   series.valueMemberPath="value";
*   this.chart.series.add(series);
* ```
*/
var IgrStepAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStepAreaSeries, _super);
    function IgrStepAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStepAreaSeries.prototype.createImplementation = function () {
        return new StepAreaSeries();
    };
    Object.defineProperty(IgrStepAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStepAreaSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStepAreaSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStepAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStepAreaSeriesModule() {
    }
    IgrStepAreaSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrStepAreaSeries", IgrStepAreaSeries);
        TypeRegistrar.register("StepAreaSeries", StepAreaSeries.$type);
    };
    return IgrStepAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StepLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepLineSeries, _super);
    function StepLineSeries() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this.qh = new CategoryLineRasterizer();
        _this.ab = StepLineSeries.$;
        return _this;
    }
    StepLineSeries.prototype.bf = function () {
        return new StepLineSeriesView(this);
    };
    StepLineSeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    StepLineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qi = a;
    };
    StepLineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    StepLineSeries.prototype.preferredCategoryMode = function (a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    };
    StepLineSeries.prototype.get_ck = function () {
        return true;
    };
    StepLineSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    StepLineSeries.prototype.bd = function () {
        if (this.be == 0) {
            return 2;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    StepLineSeries.prototype.ef = function (a, b, c, d, e, f, g, h) {
        var i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        var j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    };
    StepLineSeries.prototype.qj = function (a, b, c, d, e, f) {
        var g;
        if (b) {
            if (f) {
                g = (a & 1) == 0;
                if (g || (intDivide(a, 2)) + 1 < 0) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                if (c.f.count == (intDivide(a, 2)) + 1) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            g = (a & 1) == 0;
            return c.f._inner[(intDivide(a, 2))][0] + (g ? d : -d);
        }
        if (f) {
            g = (a & 1) == 0;
            if (g || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            if (c.f.count == (intDivide(a, 2)) + 1) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        g = (a & 1) == 0;
        return c.f._inner[(intDivide(a, 2))][0] + (g ? -d : d);
    };
    StepLineSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = typeCast(ISortingAxis_$type, this.py) != null;
        var g = this.py.b8;
        var h = 0;
        if (this.py != null) {
            h = 0.5 * this.py.getCategorySize(c, d, e);
        }
        var i = a.f;
        var j = 2 * i.count;
        var k = new List$1(Array_$type, 2, j);
        if (!this.py.b8) {
            for (var l = 0; l < j; l++) {
                var m = new Array(4);
                m[0] = this.qj(l, false, a, h, g, f);
                m[1] = a.f._inner[(intDivide(l, 2))][1];
                m[2] = this.qj(l, true, a, h, g, f);
                m[3] = a.f._inner[(intDivide(l, 2))][2];
                k.add(m);
            }
        }
        else {
            for (var n = 0; n < j; n++) {
                var o = new Array(4);
                o[0] = this.qj(n, true, a, h, g, f);
                o[1] = a.f._inner[(intDivide(n, 2))][1];
                o[2] = this.qj(n, true, a, h, g, f);
                o[3] = a.f._inner[(intDivide(n, 2))][2];
                k.add(o);
            }
        }
        var p = typeCast(StepLineSeriesView.$, b);
        var q = p.cn.d;
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        var r = false;
        var s = this.ne.c;
        if (s != null) {
            r = true;
        }
        if (r) {
            var t = new ScalerParams(0, b.bs, b.br, this.py.b8, e);
            this.ok(i, -1, this.valueColumn.count, this.py, t, b.n);
        }
        var u = p.dd;
        var v = p.de;
        var w = p.dc;
        this.ne.ae(u, true, false, true, false);
        this.ne.ae(v, true, false, true, false);
        this.ne.ae(w, false, true, false, false);
        w._opacity = 0.75 * this.ne.i;
        if (b.cr(a)) {
            p.c8(j, k, false, 1, this.ow(k, j - 1, b.br, b.bs), q, this.eu);
            b.cu(a);
        }
    };
    Object.defineProperty(StepLineSeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(this.py);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StepLineSeries.$t = markType(StepLineSeries, 'StepLineSeries', HorizontalAnchoredCategorySeries.$, [IIsCategoryBased_$type]);
    return StepLineSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var StepLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StepLineSeriesView, _super);
    function StepLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.dg = new Path();
        _this.df = new Path();
        _this.dh = new Path();
        _this.db = new Path();
        _this.da = new Path();
        _this.c9 = new Path();
        _this.c6 = a;
        return _this;
    }
    Object.defineProperty(StepLineSeriesView.prototype, "dd", {
        get: function () {
            return this.dg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "de", {
        get: function () {
            return this.dh;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StepLineSeriesView.prototype, "dc", {
        get: function () {
            return this.df;
        },
        enumerable: true,
        configurable: true
    });
    StepLineSeriesView.prototype.c7 = function () {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    };
    StepLineSeriesView.prototype.c8 = function (a, b, c, d, e, f, g) {
        this.c6.qh.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qh.m(this.dg, this.df, this.dh, a, b, c, d, e, f, g);
        this.an();
    };
    StepLineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.da.ak = this.dg.ak;
        this.db.ak = this.dh.ak;
        this.c9.ak = this.df.ak;
        var a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 1;
    };
    StepLineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c9);
                a.s(this.da);
                a.s(this.db);
            }
            else {
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
        }
    };
    StepLineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
    };
    StepLineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    StepLineSeriesView.$t = markType(StepLineSeriesView, 'StepLineSeriesView', AnchoredCategorySeriesView.$);
    return StepLineSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent step line series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrStepLineSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		valueMemberPath="value" />
*  </IgrDataChart>
* ```
*
* ```ts
*   let series = new IgrStepLineSeries({name:"series1"});
*   series.xAxis = this.xAxis;
*   series.yAxis = this.yAxis;
*   series.valueMemberPath="value";
*   this.chart.series.add(series);
* ```
*/
var IgrStepLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStepLineSeries, _super);
    function IgrStepLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStepLineSeries.prototype.createImplementation = function () {
        return new StepLineSeries();
    };
    Object.defineProperty(IgrStepLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStepLineSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStepLineSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStepLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStepLineSeriesModule() {
    }
    IgrStepLineSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrStepLineSeries", IgrStepLineSeries);
        TypeRegistrar.register("StepLineSeries", StepLineSeries.$type);
    };
    return IgrStepLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WaterfallSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WaterfallSeries, _super);
    function WaterfallSeries() {
        var _this = _super.call(this) || this;
        _this.ab = WaterfallSeries.$;
        return _this;
    }
    WaterfallSeries.prototype.bf = function () {
        return new WaterfallSeriesView(this);
    };
    WaterfallSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qh = a;
    };
    WaterfallSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    WaterfallSeries.prototype.get_cz = function () {
        return true;
    };
    WaterfallSeries.prototype.ji = function (a, b) {
        _super.prototype.ji.call(this, a, b);
        this.qs = a;
        this.qt = b;
    };
    WaterfallSeries.prototype.k9 = function () {
        return this.qs;
    };
    WaterfallSeries.prototype.get_nv = function () {
        return true;
    };
    WaterfallSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case WaterfallSeries.$$p[3]:
            case WaterfallSeries.$$p[2]:
            case WaterfallSeries.$$p[0]:
            case WaterfallSeries.$$p[1]:
                this.jd(false);
                break;
        }
    };
    WaterfallSeries.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    WaterfallSeries.prototype.lu = function (a) {
        var _this = this;
        if (this.qh == null || this.qh.c7 == null || this.qh.c7.count == 0 || this.xAxis == null) {
            return Rect.empty;
        }
        var b = this.qh.c7;
        var c = this.lg(a);
        var d = -1;
        var e = this.xAxis.b8;
        var f = this.ly.right * 2;
        if (e) {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, function (g) {
                var h = _this.qh.de(g);
                return (f - c.x) < (f - (h.left + h.width / 2)) ? -1 : ((f - c.x) > (f - (h.left + h.width / 2)) ? 1 : 0);
            });
        }
        else {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, function (g) {
                var h = _this.qh.de(g);
                return c.x < (h.left + h.width / 2) ? -1 : (c.x > (h.left + h.width / 2) ? 1 : 0);
            });
        }
        if (d < 0) {
            d = ~d;
            d--;
        }
        if (d < 0) {
            d = 0;
        }
        if (d > b.count - 1) {
            d = b.count - 1;
        }
        var g = d;
        var h = d;
        if (g < 0) {
            g--;
        }
        if (h < b.count - 1) {
            h++;
        }
        var i = this.qu(g);
        var j = this.qu(d);
        var k = this.qu(h);
        var l = i.left + i.width / 2;
        var m = j.left + j.width / 2;
        var n = k.left + k.width / 2;
        var o = Math.abs(l - c.x);
        var p = Math.abs(m - c.x);
        var q = Math.abs(n - c.x);
        var r = i.containsPoint(c);
        var s = j.containsPoint(c);
        var t = k.containsPoint(c);
        if (p <= o && p <= q) {
            if (!e && t) {
                return k;
            }
            if (e && r) {
                return i;
            }
            return j;
        }
        if (o <= p && o <= q) {
            if (!e && s) {
                return j;
            }
            return i;
        }
        if (q <= p && q <= o) {
            if (e && s) {
                return j;
            }
            return k;
        }
        return Rect.empty;
    };
    WaterfallSeries.prototype.qu = function (a) {
        return this.qh.dd(a);
    };
    WaterfallSeries.prototype.ng = function () {
        return 1;
    };
    WaterfallSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        this.qh.c7.count = 0;
    };
    WaterfallSeries.prototype.eg = function () {
        return this.py.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    WaterfallSeries.prototype.oo = function (a, b) {
        var c = b;
        _super.prototype.oo.call(this, a, b);
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = this.py.jr(d, e, f);
        var h = this.qi;
        var i = this.qj;
        var j;
        var k = this.o7(b);
        var l = NaN;
        var m = c.c7;
        var n;
        var o = 0;
        this.ne.x(this, this.nz(), this.py, runOn(this, this.m0), this.n7(b), this.n8(b));
        this.ne.p = this.qi;
        this.ne.q = this.qj;
        this.ne.j = this.qi;
        this.ne.k = this.qj;
        var p = false;
        var q = this.ne.c;
        if (q != null) {
            p = true;
        }
        var r = this.py.cd;
        var s = this.valueColumn.count;
        var t = a.f;
        var u = this.py;
        var v = new ScalerParams(0, d, e, this.py.b8, f);
        var w = this.k3;
        var x = this.qs;
        var y = this.k4;
        var z = this.qt || y;
        if (a.f.count > 0) {
            j = a.f._inner[0][0] - 0.5 * g;
            var aa = a.f._inner[0][1];
            if (!isNaN_(aa)) {
                if (aa > k) {
                    n = m.item(o);
                    o++;
                    c.dc(n, j, k);
                    n.width = g;
                    n.height = Math.abs(k - aa);
                    this.ne.al = x;
                    this.ne.ah = x;
                    this.ne.am = z;
                    this.ne.ai = z;
                    this.ne.f = true;
                    if (p) {
                        this.ok(t, 0, s, u, v, b.n);
                    }
                    this.ne.ae(n, false, false, false, false);
                    n.am = this.ne.j;
                    n.an = this.ne.k;
                }
                else {
                    n = m.item(o);
                    o++;
                    c.dc(n, j, aa);
                    n.width = g;
                    n.height = Math.abs(aa - k);
                    this.ne.al = w;
                    this.ne.ah = w;
                    this.ne.am = y;
                    this.ne.ai = y;
                    this.ne.f = false;
                    if (p) {
                        this.ok(t, 0, s, u, v, b.n);
                    }
                    this.ne.ae(n, false, false, false, false);
                    n.am = this.ne.j;
                    n.an = this.ne.k;
                }
                l = aa;
            }
            else {
                l = k;
            }
        }
        for (var ab = 1; ab < a.f.count; ++ab) {
            var ac = a.f._inner[ab];
            j = a.f._inner[ab][0] - 0.5 * g;
            var ad = ac[1];
            if (!isNaN_(ad)) {
                n = m.item(o);
                o++;
                c.dc(n, j, Math.min(l, ad));
                n.width = g;
                n.height = Math.abs(l - ad);
                this.ne.al = w;
                this.ne.ah = w;
                this.ne.am = y;
                this.ne.ai = y;
                this.ne.f = false;
                if (l > ad) {
                    if (p) {
                        this.ok(t, ab, s, u, v, b.n);
                    }
                }
                else {
                    this.ne.al = x;
                    this.ne.ah = x;
                    this.ne.am = z;
                    this.ne.ai = z;
                    this.ne.f = true;
                    if (p) {
                        this.ok(t, ab, s, u, v, b.n);
                    }
                }
                this.ne.ae(n, false, false, false, false);
                n.am = this.ne.j;
                n.an = this.ne.k;
                l = ad;
            }
        }
        m.count = o;
        b.cu(a);
    };
    Object.defineProperty(WaterfallSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    WaterfallSeries.$t = markType(WaterfallSeries, 'WaterfallSeries', HorizontalAnchoredCategorySeries.$);
    WaterfallSeries.$$p = markDep(DependencyProperty, PropertyMetadata, WaterfallSeries, 'raisePropertyChanged', ['NegativeBrush:qs:qo', [Brush.$, null], 'NegativeOutline:qt:qp', [Brush.$, null], 'RadiusX:qi:qq', [1, 2], 'RadiusY:qj:qr', [1, 2]]);
    return WaterfallSeries;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var WaterfallSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WaterfallSeriesView, _super);
    function WaterfallSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c8 = null;
        _this.df = new Rectangle();
        _this.c7 = null;
        _this.c6 = a;
        _this.c7 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.dg);
            $ret.activate = runOn(_this, _this.c9);
            $ret.disactivate = runOn(_this, _this.db);
            $ret.destroy = runOn(_this, _this.da);
            return $ret;
        })());
        return _this;
    }
    WaterfallSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.c6.qs = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.c6.qt = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.e.bj = 5;
        }
    };
    WaterfallSeriesView.prototype.dg = function () {
        var a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    };
    WaterfallSeriesView.prototype.c9 = function (a) {
        a._visibility = 0;
    };
    WaterfallSeriesView.prototype.db = function (a) {
        a._visibility = 1;
    };
    WaterfallSeriesView.prototype.da = function (a) {
        this.c8.remove(a);
    };
    WaterfallSeriesView.prototype.dc = function (a, b, c) {
        var d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    };
    WaterfallSeriesView.prototype.z = function (a) {
        return this.c8._inner[a];
    };
    WaterfallSeriesView.prototype.y = function (a) {
        var b = this.c8._inner[a];
        this.df._visibility = b._visibility;
        this.df.n = b.n;
        this.df.o = b.o;
        this.df.width = b.width;
        this.df.height = b.height;
        var c = this.bm(a);
        this.df._fill = c;
        this.df._stroke = c;
        this.df.ac = this.e.ey + 3;
        return this.df;
    };
    WaterfallSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.c8.count; c++) {
                var d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    WaterfallSeriesView.prototype.ai = function (a) {
        var e_1, _a, e_2, _b;
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.c7.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                var f = "Negative";
                if (e._fill == this.e.k3) {
                    f = "Positive";
                }
                this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", f]);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        b++;
    };
    WaterfallSeriesView.prototype.dd = function (a) {
        var b = this.c7.item(a);
        return new Rect(0, b.n, b.o, b.width, b.height);
    };
    WaterfallSeriesView.prototype.de = function (a) {
        return new Rect(0, a.n, a.o, a.width, a.height);
    };
    WaterfallSeriesView.$t = markType(WaterfallSeriesView, 'WaterfallSeriesView', AnchoredCategorySeriesView.$);
    return WaterfallSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent waterfall column series.
*
* `IgrWaterfallSeries` belongs to a group of `IgrCategorySeries` and it is rendered using a collection of vertical columns that show the difference between consecutive data points.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrWaterfallSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series= new IgrWaterfallSeries({name: "series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "value";
* this.chart.series.add(series);
* ```
*/
var IgrWaterfallSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrWaterfallSeries, _super);
    function IgrWaterfallSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrWaterfallSeries.prototype.createImplementation = function () {
        return new WaterfallSeries();
    };
    Object.defineProperty(IgrWaterfallSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWaterfallSeries.prototype, "isNegativeColorSupported", {
        /**
         * Overridden by derived series classes to indicate when negative colors are supported or not.
        */
        get: function () {
            return this.i.cz;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWaterfallSeries.prototype, "negativeBrush", {
        /**
         * Gets or sets the brush to use for negative portions of the series.
        *
        * Gets or sets the color used to draw negative declines in values for this `IgrWaterfallSeries`.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrWaterfallSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	negativeBrush="#ff0000"
        * 	valueMemberPath="Value"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.xAxis = this.xAxis;
        * series.yAxis = this.yAxis;
        * series.valueMemberPath = "value";
        * series.negativeBrush = "#ff0000";
        * this.chart.series.add(series);
        * ```
        */
        get: function () {
            return brushToString(this.i.qs);
        },
        set: function (v) {
            this.i.qs = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWaterfallSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        *
        * Gets or sets the amount to round corners in the direction of the X axis in this series.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrWaterfallSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	radiusX="15"
        *     radiusY="15"
        * 	valueMemberPath="Value"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.xAxis = this.xAxis;
        * series.yAxis = this.yAxis;
        * series.valueMemberPath = "value";
        * series.radiusX = 15;
        * series.radiusY = 15;
        * this.chart.series.add(series);
        * ```
        */
        get: function () {
            return this.i.qi;
        },
        set: function (v) {
            this.i.qi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWaterfallSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        *
        * Gets or sets the amount to round corners in the direction of the Y axis in this series.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrWaterfallSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	radiusX="15"
        *     radiusY="15"
        * 	valueMemberPath="Value"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.xAxis = this.xAxis;
        * series.yAxis = this.yAxis;
        * series.valueMemberPath = "value";
        * series.radiusX = 15;
        * series.radiusY = 15;
        * this.chart.series.add(series);
        * ```
        */
        get: function () {
            return this.i.qj;
        },
        set: function (v) {
            this.i.qj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWaterfallSeries.prototype, "negativeOutline", {
        /**
         * Brush to use for outlining negative elements in the waterfall series.
        *
        * Gets or sets the color used to draw borders of negative declines in values for this `IgrWaterfallSeries`.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrWaterfallSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	negativeOutline="#ff0000"
        * 	valueMemberPath="Value"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.xAxis = this.xAxis;
        * series.yAxis = this.yAxis;
        * series.valueMemberPath = "value";
        * series.negativeOutline = "#ff0000";
        * this.chart.series.add(series);
        * ```
        */
        get: function () {
            return brushToString(this.i.qt);
        },
        set: function (v) {
            this.i.qt = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrWaterfallSeries.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.ji(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * Returns a bounding box `Rect` for a data value given a `Point`.
    */
    IgrWaterfallSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * Returns the width of items in the `IgrWaterfallSeries`.
    *
    * ```ts
    * let itemSpan: number = series.GetItemSpan();
    * ```
    */
    IgrWaterfallSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrWaterfallSeries;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrWaterfallSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrWaterfallSeriesModule() {
    }
    IgrWaterfallSeriesModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrWaterfallSeries", IgrWaterfallSeries);
        TypeRegistrar.register("WaterfallSeries", WaterfallSeries.$type);
    };
    return IgrWaterfallSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available tooltip types to display in the chart.
 */
var ToolTipType = /*@__PURE__*/ (function (ToolTipType) {
    /**
     * Display default tooltip for each series in the chart.
     */
    ToolTipType[ToolTipType["Default"] = 0] = "Default";
    /**
     * Display individual tooltips for all series in the chart.
     */
    ToolTipType[ToolTipType["Item"] = 1] = "Item";
    /**
     * Display combined tooltip for all series in the chart.
     */
    ToolTipType[ToolTipType["Category"] = 2] = "Category";
    /**
     * Display no tooltips in the chart.
     */
    ToolTipType[ToolTipType["None"] = 3] = "None";
    return ToolTipType;
})({});
/**
 * @hidden
 */
var ToolTipType_$type = /*@__PURE__*/ markEnum('ToolTipType', 'Default,0|Item,1|Category,2|None,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available display modes of crosshairs lines in the chart.
 */
var CrosshairsDisplayMode = /*@__PURE__*/ (function (CrosshairsDisplayMode) {
    /**
     * Display default number of crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Default"] = 0] = "Default";
    /**
     * Display no crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["None"] = 1] = "None";
    /**
     * Display horizontal line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Horizontal"] = 2] = "Horizontal";
    /**
     * Display vertical line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Vertical"] = 3] = "Vertical";
    /**
     * Display both horizontal and vertical lines of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Both"] = 4] = "Both";
    return CrosshairsDisplayMode;
})({});
/**
 * @hidden
 */
var CrosshairsDisplayMode_$type = /*@__PURE__*/ markEnum('CrosshairsDisplayMode', 'Default,0|None,1|Horizontal,2|Vertical,3|Both,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChartSeriesEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartSeriesEventArgs, _super);
    function ChartSeriesEventArgs(a) {
        var _this = _super.call(this) || this;
        _this._series = null;
        _this.series = a;
        return _this;
    }
    Object.defineProperty(ChartSeriesEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartSeriesEventArgs.$t = markType(ChartSeriesEventArgs, 'ChartSeriesEventArgs');
    return ChartSeriesEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DomainChartSeriesPointerEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DomainChartSeriesPointerEventArgs, _super);
    function DomainChartSeriesPointerEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this._series = null;
        _this._item = null;
        _this.series = a;
        _this.item = b;
        return _this;
    }
    Object.defineProperty(DomainChartSeriesPointerEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChartSeriesPointerEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    DomainChartSeriesPointerEventArgs.$t = markType(DomainChartSeriesPointerEventArgs, 'DomainChartSeriesPointerEventArgs');
    return DomainChartSeriesPointerEventArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DomainChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DomainChart, _super);
    function DomainChart() {
        var _this = _super.call(this) || this;
        _this.di = null;
        _this.dh = null;
        _this.bz = null;
        _this.cd = NaN;
        _this.dg = null;
        _this.cm = 0;
        _this.cn = 0;
        _this.co = 0;
        _this.cl = 0;
        _this.ch = 0;
        _this.cj = 0;
        _this.ci = 0;
        _this.cg = 0;
        _this.hx = null;
        _this.hy = null;
        _this.cc = NaN;
        _this.cp = NaN;
        _this.cf = NaN;
        _this.cb = NaN;
        _this.db = 0;
        _this.a0 = null;
        _this.c7 = null;
        _this.bx = false;
        _this.af = null;
        _this.dw = null;
        _this.dy = null;
        _this.ay = null;
        _this.b3 = null;
        _this.propertyChanged = null;
        _this.da = 0;
        _this.br = false;
        _this.ab = null;
        _this.by = null;
        _this.seriesAdded = null;
        _this.seriesRemoved = null;
        _this.seriesPointerEnter = null;
        _this.seriesPointerLeave = null;
        _this.seriesPointerMove = null;
        _this.seriesPointerDown = null;
        _this.seriesPointerUp = null;
        _this.calloutStyleUpdating = null;
        _this.b2 = null;
        _this.a3 = null;
        _this.a6 = false;
        _this.b8 = null;
        _this.b = null;
        _this.a = null;
        _this.e = null;
        _this.h = null;
        _this.ad = null;
        _this.bc = true;
        _this.be = true;
        _this.bd = false;
        _this.h6 = new Rect(0, 0, 0, 1, 1);
        _this.dx = null;
        _this.dv = null;
        _this.hu = 1;
        _this.ht = 1;
        _this.aw = 0;
        _this.ce = 1;
        _this.ck = 1;
        _this.aj = null;
        _this.f = null;
        _this.g = null;
        _this.c9 = 400;
        _this.a5 = false;
        _this.i = null;
        _this.au = 0;
        _this.cq = 1.5;
        _this.a4 = true;
        _this.dc = 7;
        _this.as = 0;
        _this.s = 0;
        _this.ba = true;
        _this.a9 = false;
        _this.bb = false;
        _this.a8 = false;
        _this.a7 = false;
        _this.b7 = null;
        _this.dt = null;
        _this.du = null;
        _this.ds = "CalloutLabel";
        _this.dr = "CalloutContent";
        _this.b2 = new List$1(Delegate_$type, 0);
        _this.gh();
        _this.f3();
        return _this;
    }
    DomainChart.prototype.provideContainer = function (a) {
        if (a == null) {
            this.gx(function (b) { return b.provideContainer(null); });
            return;
        }
        var b = this.di;
        this.di = a;
        if (this.a3 != null && this.di != null && b == null) {
            this.di.setTimeout(this.a3, 0);
            this.a3 = null;
        }
        var c = ((function () {
            var $ret = new XamDataChart();
            $ret.ct = true;
            return $ret;
        })());
        c.provideContainer(a);
        this.dataChart = c;
        this.gi();
    };
    DomainChart.prototype.destroy = function () {
        this.provideContainer(null);
    };
    DomainChart.prototype.gi = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = this.dataChart.bn.i.e();
        this.j = a.a;
        this.n = a.f;
        this.l = a.b;
        this.m = a.c;
        this.o = a.g;
        this.c0 = DeviceUtils.g(1);
        this.gj();
    };
    DomainChart.prototype.gj = function () {
    };
    DomainChart.prototype.gf = function (a) {
        if (a == null) {
            return;
        }
        a.et = this.c4;
        a.er = this.c2;
        a.es = this.c3;
        a.eq = this.c1;
        a.mg = this.h4;
        a.en = this.cx;
        a.ep = this.cz;
        a.eo = this.cy;
        a.em = this.cw;
        a.mf = this.h3;
        if (!isNaN_(this.ct)) {
            a.ek = this.ct;
        }
    };
    DomainChart.prototype.gc = function () {
    };
    DomainChart.prototype.gl = function (a, b) {
        a.fi = this.de;
        a.bu = this.a1;
    };
    DomainChart.prototype.g4 = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "TitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.et = this.c4;
                }
                break;
            case "TitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.er = this.c2;
                }
                break;
            case "PixelScalingRatio":
                if (this.dataChart != null) {
                    this.gx(function (d) { return d.ek = _this.ct; });
                }
                break;
            case "TitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.es = this.c3;
                }
                break;
            case "TitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.eq = this.c1;
                }
                break;
            case "TitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.mg = this.h4;
                }
                break;
            case "SubtitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.en = this.cx;
                }
                break;
            case "SubtitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.ep = this.cz;
                }
                break;
            case "SubtitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.eo = this.cy;
                }
                break;
            case "SubtitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.em = this.cw;
                }
                break;
            case "SubtitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.mf = this.h3;
                }
                break;
            case "LeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.ej = this.cs;
                }
                break;
            case "TopMargin":
                if (this.dataChart != null) {
                    this.dataChart.eu = this.c5;
                }
                break;
            case "RightMargin":
                if (this.dataChart != null) {
                    this.dataChart.el = this.cv;
                }
                break;
            case "BottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ef = this.cr;
                }
                break;
            case "TransitionDuration":
                this.f8(function (d) { return d.fi = _this.de; });
                break;
            case "TransitionEasingFunction":
                this.f8(function (d) { return d.bu = _this.a1; });
                break;
        }
    };
    Object.defineProperty(DomainChart.prototype, "tooltipTemplate", {
        get: function () {
            return ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, 0);
        },
        set: function (a) {
            this.tooltipTemplates = a == null ? null : new List$1(Base.$, 1, [a]);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "tooltipTemplates", {
        get: function () {
            return this.bz;
        },
        set: function (a) {
            var b = this.tooltipTemplates;
            if (a != b) {
                this.bz = a;
                this.g3("TooltipTemplates", b, this.tooltipTemplates);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ct", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            if (a != b) {
                this.cd = a;
                this.g3("PixelScalingRatio", b, this.ct);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "toolTip", {
        get: function () {
            return this.dg;
        },
        set: function (a) {
            var b = this.toolTip;
            if (b != a) {
                this.dg = a;
                this.g3("ToolTip", b, this.toolTip);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c2", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.c2;
            if (a != b) {
                this.cm = a;
                this.g3("TitleLeftMargin", b, this.c2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c3", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.c3;
            if (a != b) {
                this.cn = a;
                this.g3("TitleRightMargin", b, this.c3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c4", {
        get: function () {
            return this.co;
        },
        set: function (a) {
            var b = this.c4;
            if (a != b) {
                this.co = a;
                this.g3("TitleTopMargin", b, this.c4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c1", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.c1;
            if (a != b) {
                this.cl = a;
                this.g3("TitleBottomMargin", b, this.c1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cx", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.cx;
            if (a != b) {
                this.ch = a;
                this.g3("SubtitleLeftMargin", b, this.cx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cz", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cz;
            if (a != b) {
                this.cj = a;
                this.g3("SubtitleTopMargin", b, this.cz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cy", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.cy;
            if (a != b) {
                this.ci = a;
                this.g3("SubtitleRightMargin", b, this.cy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cw", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cw;
            if (a != b) {
                this.cg = a;
                this.g3("SubtitleBottomMargin", b, this.cw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h3", {
        get: function () {
            return this.hx;
        },
        set: function (a) {
            var b = this.h3;
            if (a != b) {
                this.hx = a;
                this.g3("SubtitleTextColor", b, this.h3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h4", {
        get: function () {
            return this.hy;
        },
        set: function (a) {
            var b = this.h4;
            if (a != b) {
                this.hy = a;
                this.g3("TitleTextColor", b, this.h4);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_cs = function () {
        return this.cc;
    };
    DomainChart.prototype.set_cs = function (a) {
        var b = this.cs;
        if (a != b) {
            this.cc = a;
            this.g3("LeftMargin", b, this.cs);
        }
    };
    Object.defineProperty(DomainChart.prototype, "cs", {
        get: function () {
            return this.get_cs();
        },
        set: function (a) {
            this.set_cs(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c5", {
        get: function () {
            return this.cp;
        },
        set: function (a) {
            var b = this.c5;
            if (a != b) {
                this.cp = a;
                this.g3("TopMargin", b, this.c5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cv", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cv;
            if (a != b) {
                this.cf = a;
                this.g3("RightMargin", b, this.cv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "cr", {
        get: function () {
            return this.cb;
        },
        set: function (a) {
            var b = this.cr;
            if (a != b) {
                this.cb = a;
                this.g3("BottomMargin", b, this.cr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "de", {
        get: function () {
            return this.db;
        },
        set: function (a) {
            var b = this.de;
            if (a != b) {
                this.db = a;
                this.g3("TransitionDuration", b, this.de);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "a1", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a1;
            if (a != b) {
                this.a0 = a;
                this.g3("TransitionEasingFunction", b, this.a1);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.gg = function (a) {
        if (this.dataChart == null) {
            return;
        }
        a.gx = this.fk;
        a.gl = this.e9;
    };
    DomainChart.prototype.gm = function (a, b) {
        this.gn(a, b);
    };
    DomainChart.prototype.gd = function () {
    };
    DomainChart.prototype.gn = function (a, b) {
        if (a == null) {
            return;
        }
        var toolTipTemplate_ = ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, b);
        if (toolTipTemplate_ == null) {
            a.dd = true;
        }
        else {
            var series_ = a;
            a.dd = false;
            series_.externalObject.tooltipTemplate = toolTipTemplate_;
        }
    };
    DomainChart.prototype.hr = function (a, b, c) {
    };
    DomainChart.prototype.dk = function (a) {
        return a;
        return null;
    };
    DomainChart.prototype.c8 = function (a) {
        return null;
    };
    DomainChart.prototype.g5 = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "SubtitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gl = this.e9;
                }
                break;
            case "TitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.gx = this.fk;
                }
                break;
            case "TooltipTemplate":
                if (this.bx) {
                    return;
                }
                this.bx = true;
                this.tooltipTemplate = this.dk(this.tooltipTemplate);
                this.bx = false;
                if (this.dataChart != null) {
                    this.dataChart.e8 = this.tooltipTemplate;
                }
                this.toolTip = this.tooltipTemplate;
                break;
            case "ToolTip":
                this.f9(function (d, e) { return _this.gn(d, e); });
                break;
            case "TooltipTemplates":
                if (this.tooltipTemplates == null) {
                    break;
                }
                this.bx = true;
                this.f9(function (d, e) {
                    var f = _this.dk(ArrayExtension.getModulus$1(Base.$, _this.tooltipTemplates, e));
                    var series_ = d;
                    var templ_ = f;
                    series_.externalObject.tooltipTemplate = templ_;
                });
                this.bx = false;
                break;
        }
    };
    Object.defineProperty(DomainChart.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (a != b) {
                this.af = a;
                this.g3("Widget", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "e9", {
        get: function () {
            return this.dw;
        },
        set: function (a) {
            var b = this.e9;
            if (a != b) {
                this.dw = a;
                this.g3("SubtitleTextStyle", b, this.e9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "fk", {
        get: function () {
            return this.dy;
        },
        set: function (a) {
            var b = this.fk;
            if (a != b) {
                this.dy = a;
                this.g3("TitleTextStyle", b, this.fk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "dataChart", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.dataChart;
            if (b != a) {
                this.ay = a;
                this.g3("DataChart", b, this.dataChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.onDetachedFromUI = function () {
        this.gx(function (a) { return a.onDetachedFromUI(); });
    };
    DomainChart.prototype.onAttachedToUI = function () {
        this.gx(function (a) { return a.onAttachedToUI(); });
    };
    DomainChart.prototype.gh = function () {
        var e_1, _a, e_2, _b;
        this.b3 = new List$1(MarkerType_$type, 0);
        this.v = new DataSeriesAdapter().e;
        if (this.d != null) {
            this.v.includedProperties = this.d;
        }
        if (this.c != null) {
            this.v.excludedProperties = this.c;
        }
        this.v.supportedSeriesTypes = this.b5.toArray();
        this.v.rules.clear();
        try {
            for (var _c = __values(fromEnum(this.b4)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                this.v.rules.add(a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var b = new List$1(String_$type, 0);
        try {
            for (var _e = __values(fromEnum(this.v.rules)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                b.add(getInstanceType(c).typeName);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        var d = this.v.dataSeries;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.g0));
    };
    DomainChart.prototype.bt = function (a) {
        return a != 24 && this.b5.contains(a);
    };
    DomainChart.prototype.notifyResized = function () {
        this.gx(function (a) { return a.notifyContainerResized(); });
    };
    DomainChart.prototype.gv = function () {
        this.gx(function (a) {
            for (var b = 0; b < a.series.count; b++) {
                a.series._inner[b].im();
            }
        });
    };
    DomainChart.prototype.f7 = function () {
        if (this.dataChart == null) {
            return;
        }
        if (this.br) {
            this.hl();
        }
        this.dataChart.flush();
    };
    DomainChart.prototype.ga = function () {
        if (this.dataChart == null) {
            return;
        }
        this.dataChart.ho();
    };
    DomainChart.prototype.ha = function (a) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    DomainChart.prototype.f8 = function (a) {
        this.f9(function (b, c) { return a(b); });
    };
    DomainChart.prototype.f9 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            a(this.dataChart.series._inner[b], b);
        }
    };
    DomainChart.prototype.gx = function (a) {
        this.gy(a, true);
    };
    DomainChart.prototype.gy = function (a, b) {
        this.gz(a, b, null);
    };
    DomainChart.prototype.gz = function (a, b, c) {
        if (this.dataChart == null) {
            return;
        }
        a(this.dataChart);
    };
    DomainChart.prototype.bu = function (a) {
        if (!this.bt(a.suggestedSeries)) {
            return false;
        }
        var b = a.data;
        if (b == null) {
            return false;
        }
        return true;
    };
    DomainChart.prototype.bp = function () {
        if (this.dataChart == null) {
            return false;
        }
        return true;
    };
    DomainChart.prototype.el = function (a) {
        var b = "series_" + (this.dataChart.series.count + 1) + "_" + EnumUtil.getName(DataSeriesType_$type, a.suggestedSeries);
        return b;
    };
    DomainChart.prototype.em = function (a, b) {
        if (stringIsNullOrEmpty(a.title)) {
            var c = EnumUtil.getName(DataSeriesType_$type, b);
            return c + (this.dataChart.series.count + 1);
        }
        else {
            return a.title;
        }
    };
    DomainChart.prototype.ek = function () {
        return stringEmpty();
    };
    DomainChart.prototype.hl = function () {
        var e_3, _a, e_4, _b;
        if (this.dataChart == null) {
            return;
        }
        this.br = false;
        this.hn();
        if (this.itemsSource == null) {
            return;
        }
        var a = new List$1(MarkerType_$type, 0);
        try {
            for (var _c = __values(fromEnum(this.v.dataSeries)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                a.add(this.ah(b.suggestedMarker));
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.b3 = a;
        var c = 0;
        try {
            for (var _e = __values(fromEnum(this.v.dataSeries)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var d = _f.value;
                if (!this.bu(d)) {
                    continue;
                }
                if (d.index < 0) {
                    d.index = c;
                }
                this.hj(d);
                this.hk(d);
                c++;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.hs();
        this.f9(runOn(this, this.gk));
    };
    DomainChart.prototype.ar = function (seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    };
    DomainChart.prototype.al = function () {
        return this.ar(28);
    };
    DomainChart.prototype.an = function () {
        return this.ar(27);
    };
    DomainChart.prototype.ao = function () {
        return this.ar(29);
    };
    DomainChart.prototype.ap = function () {
        return this.ar(25);
    };
    DomainChart.prototype.am = function () {
        return this.ar(26);
    };
    Object.defineProperty(DomainChart.prototype, "ac", {
        get: function () {
            if (TypeRegistrar.isRegistered("AnnotationLayerProxy")) {
                return TypeRegistrar.create("AnnotationLayerProxy");
            }
            else {
                throw new BaseError(1, "annoation layer module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bn", {
        get: function () {
            return (TypeRegistrar.isRegistered("AnnotationLayerProxy"));
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.bo = function (a) {
        if (!this.bn) {
            return false;
        }
        return this.ac.matchesType(a);
    };
    DomainChart.prototype.hs = function () {
        var a = this.b1("", true);
        if (a != null) {
            for (var b = 0; b < a.count; b++) {
                this.dataChart.series.add(a._inner[b]);
            }
        }
    };
    DomainChart.prototype.b1 = function (a, b) {
        var e_5, _a, e_6, _b;
        if (!this.bn) {
            return null;
        }
        var c = new List$1(Series.$, 0);
        if (b) {
            if (this.a8) {
                var d = 1;
                if (this.b7 == null) {
                    try {
                        for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var e = _d.value;
                            var f = this.al();
                            this.ac.setTargetSeries(f, e);
                            this.ac.setCollisionChannel(f, "MainChartCollisionChannel");
                            this.hq(f, e, this.v.dataSeries._inner[d - 1]);
                            f.name = a + getInstanceType(f).typeName + d.toString();
                            c.add(f);
                            d++;
                        }
                    }
                    catch (e_5_1) {
                        e_5 = { error: e_5_1 };
                    }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return))
                                _a.call(_c);
                        }
                        finally {
                            if (e_5)
                                throw e_5.error;
                        }
                    }
                    ;
                }
                else {
                    var g = this.al();
                    this.hq(g, null, this.v.dataSeries._inner[d - 1]);
                    g.name = a + getInstanceType(g).typeName + d.toString();
                    c.add(g);
                }
            }
        }
        switch (this.s) {
            case 4:
            case 3:
            case 2:
                {
                    var h = this.an();
                    this.ac.setUseInterpolation(h, !this.ba);
                    this.ac.setHorizontalLineVisibility(h, (this.s == 2 || this.s == 4) ? 0 : 1);
                    this.ac.setVerticalLineVisibility(h, (this.s == 3 || this.s == 4) ? 0 : 1);
                    this.ac.setIsAxisAnnotationEnabled(h, this.a9);
                    c.add(h);
                    break;
                }
            case 1:
            case 0:
                {
                    break;
                }
        }
        if (this.bb) {
            var i = this.ao();
            c.add(i);
        }
        if (b) {
            switch (this.as) {
                case 1:
                    {
                        var j = this.ap();
                        c.add(j);
                        break;
                    }
                case 2:
                    {
                        var k = this.am();
                        c.add(k);
                        break;
                    }
                case 3:
                    {
                        this.f8(function (l) { return l.dd = false; });
                        break;
                    }
                case 0:
                    {
                        this.f8(function (l) { return l.dd = true; });
                        break;
                    }
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var l = _f.value;
                if (stringIsNullOrEmpty(l.name) == false) {
                    continue;
                }
                l.name = a + getInstanceType(l).typeName;
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        return c;
    };
    DomainChart.prototype.hq = function (a, b, c) {
        a.itemsSource = this.b7 != null ? this.b7 : b.itemsSource;
        this.ac.setXMemberPath(a, this.dt);
        this.ac.setYMemberPath(a, this.du);
        this.ac.setLabelMemberPath(a, this.ds);
        this.ac.setContentMemberPath(a, this.dr);
    };
    DomainChart.prototype.hn = function () {
        this.ho(this.dataChart);
    };
    DomainChart.prototype.ho = function (a) {
        var e_7, _a;
        var _this = this;
        if (a != null && a == this.dataChart) {
            this.hm();
        }
        if (a == null || a.series.count == 0) {
            return;
        }
        this.f8(function (b) {
            if (_this.bo(b) && _this.ac.isCalloutLayer(b)) {
                _this.ac.removeCalloutStyleUpdating(b, runOn(_this, _this.g9));
            }
            _this.hh(b);
        });
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                this.hp(b);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        a.series.clear();
    };
    DomainChart.prototype.hp = function (a) {
        a.itemsSource = null;
        a.legend = null;
        a.ht();
    };
    DomainChart.prototype.g0 = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        var c = b.oldItems == null ? "null" : b.oldItems.count.toString();
        var d = b.newItems == null ? "null" : b.newItems.count.toString();
        if (this.br) {
            return;
        }
        var e = this.g8(runOn(this, this.f5), this.br);
        this.br = e.p1;
    };
    DomainChart.prototype.f5 = function () {
        this.hl();
    };
    DomainChart.prototype.hz = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.j, a);
    };
    DomainChart.prototype.h2 = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.n, a);
    };
    DomainChart.prototype.h0 = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.l, a);
    };
    DomainChart.prototype.h1 = function (a) {
        return ArrayExtension.getModulus$1(Brush.$, this.m, a);
    };
    DomainChart.prototype.h5 = function (a) {
        var b = new Color();
        if (this.j == null || this.j.count == 0) {
            b = ArrayExtension.getModulus$1(Color.$, this.b0, a);
        }
        else {
            var c = ArrayExtension.getModulus$1(Brush.$, this.j, a);
            if (c == null) {
                b = ArrayExtension.getModulus$1(Color.$, this.b0, a);
            }
            else {
                b = ColorUtil.j(c);
            }
        }
        return b;
    };
    DomainChart.prototype.a2 = function (a) {
        var b = new ObservableColorCollection();
        b.add(ColorUtil.o(a, 0.5));
        b.add(a);
        return b;
    };
    DomainChart.prototype.k = function (a) {
        var b = this.a2(a);
        var c = BrushCollectionUtil.a(b);
        return c;
    };
    Object.defineProperty(DomainChart.prototype, "b0", {
        get: function () {
            if (this.by != null) {
                return this.by;
            }
            this.by = new List$1(Color.$, 0);
            this.by.add(ColorUtil.k("#FF7446B9"));
            this.by.add(ColorUtil.k("#FF9FB328"));
            this.by.add(ColorUtil.k("#FFF96232"));
            this.by.add(ColorUtil.k("#FF2E9CA6"));
            this.by.add(ColorUtil.k("#FFDC3F76"));
            this.by.add(ColorUtil.k("#FFFF9800"));
            this.by.add(ColorUtil.k("#FF3F51B5"));
            this.by.add(ColorUtil.k("#FF439C47"));
            this.by.add(ColorUtil.k("#FF795548"));
            this.by.add(ColorUtil.k("#FF494747"));
            return this.by;
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.dj = function () {
        if (this.dataChart == null) {
            return null;
        }
        return this.dataChart.oe();
    };
    DomainChart.prototype.go = function (a, b) {
    };
    DomainChart.prototype.gp = function (a, b, c) {
    };
    DomainChart.prototype.ah = function (a) {
        if (a == 2) {
            return 3;
        }
        else if (a == 12) {
            return 13;
        }
        else if (a == 6) {
            return 7;
        }
        else if (a == 8) {
            return 9;
        }
        else if (a == 11) {
            return 12;
        }
        else if (a == 1) {
            return 1;
        }
        else if (a == 7) {
            return 8;
        }
        else if (a == 10) {
            return 11;
        }
        else if (a == 4) {
            return 5;
        }
        else if (a == 5) {
            return 6;
        }
        else if (a == 9) {
            return 10;
        }
        else if (a == 3) {
            return 4;
        }
        return 2;
    };
    DomainChart.prototype.gu = function (source_, a, b, c) {
        if (this.v != null) {
            this.v.notifySetItem(source_, a, b, c);
        }
        if (this.dataChart != null) {
            this.dataChart.h0(source_, a, b, c);
        }
    };
    DomainChart.prototype.gq = function (source_) {
        if (this.v != null) {
            this.v.notifyClearItems(source_);
        }
        if (this.dataChart != null) {
            this.dataChart.hv(source_);
        }
    };
    DomainChart.prototype.gr = function (source_, a, b) {
        if (this.v != null) {
            this.v.notifyInsertItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hy(source_, a, b);
        }
    };
    DomainChart.prototype.gs = function (source_, a, b) {
        if (this.v != null) {
            this.v.notifyRemoveItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.hz(source_, a, b);
        }
    };
    DomainChart.prototype.hb = function (a) {
        if (this.seriesAdded != null && a != null) {
            this.seriesAdded(this, new ChartSeriesEventArgs(a));
        }
    };
    DomainChart.prototype.hh = function (a) {
        if (this.seriesRemoved != null && a != null) {
            this.seriesRemoved(this, new ChartSeriesEventArgs(a));
        }
    };
    DomainChart.prototype.hd = function (a, b) {
        if (this.seriesPointerEnter != null && a != null) {
            this.seriesPointerEnter(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.he = function (a, b) {
        if (this.seriesPointerLeave != null && a != null) {
            this.seriesPointerLeave(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.hf = function (a, b) {
        if (this.seriesPointerMove != null && a != null) {
            this.seriesPointerMove(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.hc = function (a, b) {
        if (this.seriesPointerDown != null && a != null) {
            this.seriesPointerDown(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.hg = function (a, b) {
        if (this.seriesPointerUp != null && a != null) {
            this.seriesPointerUp(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    };
    DomainChart.prototype.g9 = function (a, b) {
        if (this.calloutStyleUpdating != null && a != null) {
            this.calloutStyleUpdating(this, b);
        }
    };
    DomainChart.prototype.g7 = function (a) {
        var _this = this;
        if (!this.b2.contains(a)) {
            this.b2.add(a);
            var b = false;
            var c = this.g8(function () {
                a();
                _this.b2.remove(a);
            }, b);
            b = c.p1;
        }
    };
    DomainChart.prototype.g8 = function (a, b) {
        if (!b) {
            b = true;
            if (this.di != null) {
                this.di.setTimeout(a, 0);
            }
            else {
                this.a3 = a;
            }
        }
        return {
            p1: b
        };
    };
    DomainChart.prototype.get_bv = function () {
        return true;
    };
    Object.defineProperty(DomainChart.prototype, "bv", {
        get: function () {
            return this.get_bv();
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.ge = function (a) {
        var _this = this;
        var b = a == this.dataChart;
        if (b) {
            a.m9 = this.j;
        }
        if (b) {
            a.nc = this.n;
        }
        a.na = this.l;
        a.nb = this.m;
        a.legend = this.legend;
        a.nr = this.bq;
        a.nt = this.bw && this.bv;
        a.seriesMouseEnter = delegateCombine(a.seriesMouseEnter, function (c, d) { return _this.hd(d.series, d.item); });
        a.seriesMouseLeave = delegateCombine(a.seriesMouseLeave, function (c, d) { return _this.he(d.series, d.item); });
        a.seriesMouseMove = delegateCombine(a.seriesMouseMove, function (c, d) { return _this.hf(d.series, d.item); });
        a.seriesMouseLeftButtonDown = delegateCombine(a.seriesMouseLeftButtonDown, function (c, d) { return _this.hc(d.series, d.item); });
        a.seriesMouseLeftButtonUp = delegateCombine(a.seriesMouseLeftButtonUp, function (c, d) { return _this.hg(d.series, d.item); });
        if (b) {
            a.m4 = this.h8;
        }
        if (b) {
            a.gq = this.fd;
        }
        a.lz = this.hw;
        if (b) {
            a.ge = this.e2;
        }
        a.ly = this.hv;
        a.nn = this.bf;
        a.cd = this.bg;
        a.ej = this.cs;
        a.el = this.cv;
        a.eu = this.c5;
        a.ef = this.cr;
        if (a == this.dataChart) {
            this.hl();
        }
        this.gf(a);
        this.gg(a);
    };
    DomainChart.prototype.gk = function (a, b) {
        if (!isNaN_(this.cu)) {
            a.eu = this.cu;
        }
        a.ey = this.c0;
        if (a.isUsableInLegend) {
            a.legend = this.legend;
        }
        if (typeCast(IUnknownValuePlotting_$type, a) !== null) {
            a.unknownValuePlotting = this.ax;
        }
        a.cu = this.bs;
        if (this.bo(a) && this.ac.isCalloutLayer(a)) {
            this.ac.setCalloutStyleUpdatingEventEnabled(a, this.bi);
            this.ac.addCalloutStyleUpdating(a, runOn(this, this.g9));
        }
        this.f1(a, b);
        this.f2(a, b);
        this.gl(a, b);
        this.gm(a, b);
        this.hb(a);
    };
    Object.defineProperty(DomainChart.prototype, "bh", {
        get: function () {
            return this.a6;
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.f6 = function () {
        if (!this.a6) {
            this.a6 = true;
            this.gb();
        }
    };
    DomainChart.prototype.gb = function () {
        this.gc();
        this.gd();
    };
    DomainChart.prototype.hi = function (a) {
        this.ho(a);
    };
    DomainChart.prototype.f2 = function (a, b) {
        var c = typeCast(ITrendLineSeries_$type, a);
        if (c != null) {
            c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
            c.trendLineThickness = this.c6;
            c.trendLineType = this.av;
            c.trendLinePeriod = this.df;
        }
    };
    DomainChart.prototype.ai = function (a, b) {
        if (this.ak == null || this.ak.count == 0) {
            if (this.b3 == null || this.b3.count == 0) {
                return a != null && a.cy ? 1 : 2;
            }
            var c = ArrayExtension.getModulus$1(MarkerType_$type, this.b3, b);
            return c == 2 && a != null && a.cy ? 1 : c;
        }
        return ArrayExtension.getModulus$1(MarkerType_$type, this.ak, b);
    };
    DomainChart.prototype.g3 = function (a, b, c) {
        var _this = this;
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case "DataChart":
                this.hi(typeCast(XamDataChart.$, b));
                this.ge(typeCast(XamDataChart.$, c));
                break;
            case "ItemsSource":
                this.v.itemsSource = this.itemsSource;
                break;
            case "IncludedProperties":
                this.v.includedProperties = this.d;
                break;
            case "ExcludedProperties":
                this.v.excludedProperties = this.c;
                break;
            case "Brushes":
                this.gz(function (d) { return d.m9 = _this.j; }, true, a);
                break;
            case "Outlines":
                this.gz(function (d) { return d.nc = _this.n; }, true, a);
                break;
            case "Legend":
                this.gx(function (d) { return d.legend = _this.legend; });
                break;
            case "IsHorizontalZoomEnabled":
                this.gx(function (d) { return d.nr = _this.bq; });
                break;
            case "IsVerticalZoomEnabled":
                this.gx(function (d) { return d.nt = _this.bw; });
                break;
            case "WindowRect":
                this.gy(function (d) { return d.m4 = _this.h8; }, false);
                break;
            case "Title":
                this.gy(function (d) { return d.gq = _this.fd; }, false);
                break;
            case "Subtitle":
                this.gy(function (d) { return d.ge = _this.e2; }, false);
                break;
            case "TitleAlignment":
                this.gx(function (d) { return d.lz = _this.hw; });
                break;
            case "SubtitleAlignment":
                this.gx(function (d) { return d.ly = _this.hv; });
                break;
            case "UnknownValuePlotting":
                this.f8(function (d) {
                    if (typeCast(IUnknownValuePlotting_$type, d) !== null) {
                        d.unknownValuePlotting = _this.ax;
                    }
                });
                break;
            case "IsSeriesHighlightingEnabled":
                this.f8(function (d) { return d.cu = _this.bs; });
                break;
            case "Thickness":
                this.f8(function (d) { return d.ey = _this.c0; });
                break;
            case "Resolution":
                if (!isNaN_(this.cu)) {
                    this.f8(function (d) { return d.eu = _this.cu; });
                }
                break;
            case "TrendLineBrushes":
            case "TrendLineType":
            case "TrendLineThickness":
            case "TrendLinePeriod":
                this.f9(function (d, e) { return _this.f2(d, e); });
                break;
            case "MarkerMaxCount":
                this.f9(function (d, e) { return _this.f1(d, e); });
                break;
            case "MarkerTypes":
                var d = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), b);
                if (d != null) {
                    d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.g2));
                }
                var e = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), c);
                if (e != null) {
                    e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.g2));
                }
                this.f9(function (f, g) { return _this.f1(f, g); });
                break;
            case "MarkerBrushes":
                this.gx(function (f) { return f.na = _this.l; });
                break;
            case "MarkerOutlines":
                this.gx(function (f) { return f.nb = _this.m; });
                break;
            case "AlignsGridLinesToPixels":
                this.gx(function (f) { return f.nn = _this.bf; });
                break;
            case "AnimateSeriesWhenAxisRangeChanges":
                this.gx(function (f) { return f.cd = _this.bg; });
                break;
            case "ToolTipType":
            case "CrosshairsDisplayMode":
            case "CrosshairsSnapToData":
            case "CrosshairsAnnotationEnabled":
            case "FinalValueAnnotationsVisible":
            case "CalloutsVisible":
            case "CalloutsItemsSource":
            case "CalloutsXMemberPath":
            case "CalloutsYMemberPath":
            case "CalloutsLabelMemberPath":
            case "CalloutsContentMemberPath":
                var f = this.g8(runOn(this, this.f5), this.br);
                this.br = f.p1;
                break;
        }
        this.g4(a, b, c);
        this.g5(a, b, c);
    };
    DomainChart.prototype.g2 = function (a, b) {
        var _this = this;
        this.f9(function (c, d) { return _this.f1(c, d); });
    };
    Object.defineProperty(DomainChart.prototype, "itemsSource", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            var b = this.itemsSource;
            if (b != a) {
                this.b8 = a;
                this.g3("ItemsSource", b, this.itemsSource);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.g3("IncludedProperties", b, this.b);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g3("ExcludedProperties", b, this.a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "j", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.j;
            if (a != b) {
                this.e = a;
                this.g3("Brushes", b, this.j);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "n", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.n;
            if (a != b) {
                this.h = a;
                this.g3("Outlines", b, this.n);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "legend", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.legend;
            if (a != b) {
                this.ad = a;
                this.g3("Legend", b, this.legend);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bq = function () {
        return this.bc;
    };
    DomainChart.prototype.set_bq = function (a) {
        var b = this.bq;
        if (a != b) {
            this.bc = a;
            this.g3("IsHorizontalZoomEnabled", b, this.bq);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bq", {
        get: function () {
            return this.get_bq();
        },
        set: function (a) {
            this.set_bq(a);
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bw = function () {
        return this.be;
    };
    DomainChart.prototype.set_bw = function (a) {
        var b = this.bw;
        if (a != b) {
            this.be = a;
            this.g3("IsVerticalZoomEnabled", b, this.bw);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bw", {
        get: function () {
            return this.get_bw();
        },
        set: function (a) {
            this.set_bw(a);
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_bs = function () {
        return this.bd;
    };
    DomainChart.prototype.set_bs = function (a) {
        var b = this.bs;
        if (a != b) {
            this.bd = a;
            this.g3("IsSeriesHighlightingEnabled", b, this.bs);
        }
    };
    Object.defineProperty(DomainChart.prototype, "bs", {
        get: function () {
            return this.get_bs();
        },
        set: function (a) {
            this.set_bs(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h8", {
        get: function () {
            return this.h6;
        },
        set: function (a) {
            var b = this.h8;
            if (Rect.l_op_Inequality(a, b)) {
                this.h6 = a;
                this.g3("WindowRect", b, this.h8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "h7", {
        get: function () {
            return this.dataChart != null ? this.dataChart.m3 : Rect.empty;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "fd", {
        get: function () {
            return this.dx;
        },
        set: function (a) {
            var b = this.fd;
            if (a != b) {
                this.dx = a;
                this.g3("Title", b, this.fd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "e2", {
        get: function () {
            return this.dv;
        },
        set: function (a) {
            var b = this.e2;
            if (a != b) {
                this.dv = a;
                this.g3("Subtitle", b, this.e2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "hw", {
        get: function () {
            return this.hu;
        },
        set: function (a) {
            var b = this.hw;
            if (b != a) {
                this.hu = a;
                this.g3("TitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hw));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "hv", {
        get: function () {
            return this.ht;
        },
        set: function (a) {
            var b = this.hv;
            if (b != a) {
                this.ht = a;
                this.g3("SubtitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hv));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ax", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.ax;
            if (a != b) {
                this.aw = a;
                this.g3("UnknownValuePlotting", enumGetBox(UnknownValuePlotting_$type, b), enumGetBox(UnknownValuePlotting_$type, this.ax));
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.prototype.get_cu = function () {
        return this.ce;
    };
    DomainChart.prototype.set_cu = function (a) {
        var b = this.cu;
        if (a != b) {
            this.ce = a;
            this.g3("Resolution", b, this.cu);
        }
    };
    Object.defineProperty(DomainChart.prototype, "cu", {
        get: function () {
            return this.get_cu();
        },
        set: function (a) {
            this.set_cu(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c0", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.c0;
            if (a != b) {
                this.ck = a;
                this.g3("Thickness", b, this.c0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ak", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.ak;
            if (a != b) {
                this.aj = a;
                this.g3("MarkerTypes", b, this.ak);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "l", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.l;
            if (a != b) {
                this.f = a;
                this.g3("MarkerBrushes", b, this.l);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "m", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.m;
            if (!Base.equalsStatic(a, b)) {
                this.g = a;
                this.g3("MarkerOutlines", b, this.m);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "dd", {
        get: function () {
            return this.c9;
        },
        set: function (a) {
            var b = this.c9;
            if (a != b) {
                this.c9 = a;
                this.g3("MarkerMaxCount", b, this.c9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bg", {
        get: function () {
            return this.a5;
        },
        set: function (a) {
            var b = this.a5;
            if (a != b) {
                this.a5 = a;
                this.g3("AnimateSeriesWhenAxisRangeChanges", b, this.a5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "o", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.o;
            if (a != b) {
                this.i = a;
                this.g3("TrendLineBrushes", b, this.o);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "av", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.av;
            if (a != b) {
                this.au = a;
                this.g3("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.av));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "c6", {
        get: function () {
            return this.cq;
        },
        set: function (a) {
            var b = this.c6;
            if (a != b) {
                this.cq = a;
                this.g3("TrendLineThickness", b, this.c6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bf", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.bf;
            if (a != b) {
                this.a4 = a;
                this.g3("AlignsGridLinesToPixels", b, this.bf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "df", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            var b = this.df;
            if (a != b) {
                this.dc = a;
                this.g3("TrendLinePeriod", b, this.df);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "at", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.at;
            if (a != b) {
                this.as = a;
                this.g3("ToolTipType", enumGetBox(ToolTipType_$type, b), enumGetBox(ToolTipType_$type, this.at));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.t;
            if (a != b) {
                this.s = a;
                this.g3("CrosshairsDisplayMode", enumGetBox(CrosshairsDisplayMode_$type, b), enumGetBox(CrosshairsDisplayMode_$type, this.t));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bl", {
        get: function () {
            return this.ba;
        },
        set: function (a) {
            var b = this.bl;
            if (a != b) {
                this.ba = a;
                this.g3("CrosshairsSnapToData", b, this.bl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bk", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            var b = this.bk;
            if (a != b) {
                this.a9 = a;
                this.g3("CrosshairsAnnotationEnabled", b, this.bk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bm", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bm;
            if (a != b) {
                this.bb = a;
                this.g3("FinalValueAnnotationsVisible", b, this.bm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bj", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            var b = this.bj;
            if (a != b) {
                this.a8 = a;
                this.g3("CalloutsVisible", b, this.bj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "bi", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.bi;
            if (a != b) {
                this.a7 = a;
                this.g3("CalloutStyleUpdatingEventEnabled", b, this.bi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "calloutsItemsSource", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            var b = this.calloutsItemsSource;
            if (a != b) {
                this.b7 = a;
                this.g3("CalloutsItemsSource", b, this.calloutsItemsSource);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ea", {
        get: function () {
            return this.dt;
        },
        set: function (a) {
            var b = this.ea;
            if (a != b) {
                this.dt = a;
                this.g3("CalloutsXMemberPath", b, this.ea);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "ec", {
        get: function () {
            return this.du;
        },
        set: function (a) {
            var b = this.ec;
            if (a != b) {
                this.du = a;
                this.g3("CalloutsYMemberPath", b, this.ec);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d6", {
        get: function () {
            return this.ds;
        },
        set: function (a) {
            var b = this.d6;
            if (a != b) {
                this.ds = a;
                this.g3("CalloutsLabelMemberPath", b, this.d6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DomainChart.prototype, "d3", {
        get: function () {
            return this.dr;
        },
        set: function (a) {
            var b = this.d3;
            if (a != b) {
                this.dr = a;
                this.g3("CalloutsContentMemberPath", b, this.d3);
            }
        },
        enumerable: true,
        configurable: true
    });
    DomainChart.$t = markType(DomainChart, 'DomainChart', Base.$, [INotifyPropertyChanged_$type]);
    DomainChart.dq = new Random(0);
    return DomainChart;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ib = null;
        _this.ic = null;
        _this.iq = 0;
        _this.is = 5;
        _this.ir = 0;
        _this.ip = 5;
        _this.i7 = 5;
        _this.i9 = 0;
        _this.i8 = 5;
        _this.i6 = 0;
        _this.nl = null;
        _this.ns = null;
        _this.i1 = 0;
        _this.ji = 0;
        _this.i0 = NaN;
        _this.jh = NaN;
        _this.i3 = NaN;
        _this.jk = NaN;
        _this.i2 = NaN;
        _this.jj = NaN;
        _this.iz = NaN;
        _this.jg = NaN;
        _this.nr = null;
        _this.ny = null;
        _this.kr = null;
        _this.ku = null;
        _this.kt = null;
        _this.kw = null;
        _this.kn = null;
        _this.ko = null;
        _this.nm = null;
        _this.nt = null;
        _this.it = 1;
        _this.ja = 1;
        _this.iu = 1;
        _this.jb = 0;
        _this.no = null;
        _this.nv = null;
        _this.np = null;
        _this.nw = null;
        _this.iv = 1;
        _this.jc = 1;
        _this.iw = 5;
        _this.jd = 0;
        _this.nq = null;
        _this.nx = null;
        _this.ix = 2;
        _this.je = 2;
        _this.ks = null;
        _this.kv = null;
        _this.nn = null;
        _this.nu = null;
        _this.io = 0;
        _this.i5 = 0;
        _this.im = NaN;
        _this.i4 = NaN;
        _this.iy = 0;
        _this.jf = -90;
        _this.ii = false;
        _this.ij = false;
        _this.ng = 1;
        _this.of = 1;
        _this.nf = 1;
        _this.nh = 2;
        _this.od = 0;
        _this.oe = 1;
        _this.oj = 0;
        _this.ok = 0;
        _this.ig = 2;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.h9();
            var c = this.ia();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.gj = function () {
        _super.prototype.gj.call(this);
        var a = this.h9();
        var b = this.ia();
        if (a != null && a.aw != null) {
            this.nz = a.aw.textColor;
        }
        if (b != null && b.aw != null) {
            this.n6 = b.aw.textColor;
        }
    };
    XYChart.prototype.g4 = function (a, b, c) {
        var _this = this;
        _super.prototype.g4.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.m9(function (d) { return d.leftMargin = _this.js; });
                break;
            case "XAxisLabelTopMargin":
                this.m9(function (d) { return d.topMargin = _this.ju; });
                break;
            case "XAxisLabelRightMargin":
                this.m9(function (d) { return d.rightMargin = _this.jt; });
                break;
            case "XAxisLabelBottomMargin":
                this.m9(function (d) { return d.bottomMargin = _this.jr; });
                break;
            case "YAxisLabelLeftMargin":
                this.nd(function (d) { return d.leftMargin = _this.j9; });
                break;
            case "YAxisLabelTopMargin":
                this.nd(function (d) { return d.topMargin = _this.kb; });
                break;
            case "YAxisLabelRightMargin":
                this.nd(function (d) { return d.rightMargin = _this.ka; });
                break;
            case "YAxisLabelBottomMargin":
                this.nd(function (d) { return d.bottomMargin = _this.j8; });
                break;
            case "XAxisLabelTextColor":
                this.m9(function (d) { return d.textColor = _this.nz; });
                break;
            case "YAxisLabelTextColor":
                this.nd(function (d) { return d.textColor = _this.n6; });
                break;
            case "XAxisTitleMargin":
                this.na(function (d) { return d.margin = _this.j3; });
                break;
            case "YAxisTitleMargin":
                this.ne(function (d) { return d.margin = _this.kk; });
                break;
            case "XAxisTitleLeftMargin":
                this.na(function (d) { return d.leftMargin = _this.j2; });
                break;
            case "YAxisTitleLeftMargin":
                this.ne(function (d) { return d.leftMargin = _this.kj; });
                break;
            case "XAxisTitleTopMargin":
                this.na(function (d) { return d.topMargin = _this.j5; });
                break;
            case "YAxisTitleTopMargin":
                this.ne(function (d) { return d.topMargin = _this.km; });
                break;
            case "XAxisTitleRightMargin":
                this.na(function (d) { return d.rightMargin = _this.j4; });
                break;
            case "YAxisTitleRightMargin":
                this.ne(function (d) { return d.rightMargin = _this.kl; });
                break;
            case "XAxisTitleBottomMargin":
                this.na(function (d) { return d.bottomMargin = _this.j1; });
                break;
            case "YAxisTitleBottomMargin":
                this.ne(function (d) { return d.bottomMargin = _this.ki; });
                break;
            case "XAxisTitleTextColor":
                this.na(function (d) { return d.textColor = _this.n5; });
                break;
            case "YAxisTitleTextColor":
                this.ne(function (d) { return d.textColor = _this.oc; });
                break;
            case "XAxisFormatLabel":
                this.m7(function (d) { return d.ar = _this.id; });
                break;
            case "YAxisFormatLabel":
                this.nb(function (d) { return d.ar = _this.ie; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "id", {
        get: function () {
            return this.ib;
        },
        set: function (a) {
            var b = this.id;
            if (a != b) {
                this.ib = a;
                this.g3("XAxisFormatLabel", b, this.id);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ie", {
        get: function () {
            return this.ic;
        },
        set: function (a) {
            var b = this.ie;
            if (a != b) {
                this.ic = a;
                this.g3("YAxisFormatLabel", b, this.ie);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "js", {
        get: function () {
            return this.iq;
        },
        set: function (a) {
            var b = this.js;
            if (a != b) {
                this.iq = a;
                this.g3("XAxisLabelLeftMargin", b, this.js);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ju", {
        get: function () {
            return this.is;
        },
        set: function (a) {
            var b = this.ju;
            if (a != b) {
                this.is = a;
                this.g3("XAxisLabelTopMargin", b, this.ju);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jt", {
        get: function () {
            return this.ir;
        },
        set: function (a) {
            var b = this.jt;
            if (a != b) {
                this.ir = a;
                this.g3("XAxisLabelRightMargin", b, this.jt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jr", {
        get: function () {
            return this.ip;
        },
        set: function (a) {
            var b = this.jr;
            if (a != b) {
                this.ip = a;
                this.g3("XAxisLabelBottomMargin", b, this.jr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j9", {
        get: function () {
            return this.i7;
        },
        set: function (a) {
            var b = this.j9;
            if (a != b) {
                this.i7 = a;
                this.g3("YAxisLabelLeftMargin", b, this.j9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kb", {
        get: function () {
            return this.i9;
        },
        set: function (a) {
            var b = this.kb;
            if (a != b) {
                this.i9 = a;
                this.g3("YAxisLabelTopMargin", b, this.kb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ka", {
        get: function () {
            return this.i8;
        },
        set: function (a) {
            var b = this.ka;
            if (a != b) {
                this.i8 = a;
                this.g3("YAxisLabelRightMargin", b, this.ka);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j8", {
        get: function () {
            return this.i6;
        },
        set: function (a) {
            var b = this.j8;
            if (a != b) {
                this.i6 = a;
                this.g3("YAxisLabelBottomMargin", b, this.j8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nz", {
        get: function () {
            return this.nl;
        },
        set: function (a) {
            var b = this.nz;
            if (a != b) {
                this.nl = a;
                this.g3("XAxisLabelTextColor", b, this.nz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n6", {
        get: function () {
            return this.ns;
        },
        set: function (a) {
            var b = this.n6;
            if (a != b) {
                this.ns = a;
                this.g3("YAxisLabelTextColor", b, this.n6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j3", {
        get: function () {
            return this.i1;
        },
        set: function (a) {
            var b = this.j3;
            if (a != b) {
                this.i1 = a;
                this.g3("XAxisTitleMargin", b, this.j3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kk", {
        get: function () {
            return this.ji;
        },
        set: function (a) {
            var b = this.kk;
            if (a != b) {
                this.ji = a;
                this.g3("YAxisTitleMargin", b, this.kk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j2", {
        get: function () {
            return this.i0;
        },
        set: function (a) {
            var b = this.j2;
            if (a != b) {
                this.i0 = a;
                this.g3("XAxisTitleLeftMargin", b, this.j2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kj", {
        get: function () {
            return this.jh;
        },
        set: function (a) {
            var b = this.kj;
            if (a != b) {
                this.jh = a;
                this.g3("YAxisTitleLeftMargin", b, this.kj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j5", {
        get: function () {
            return this.i3;
        },
        set: function (a) {
            var b = this.j5;
            if (a != b) {
                this.i3 = a;
                this.g3("XAxisTitleTopMargin", b, this.j5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "km", {
        get: function () {
            return this.jk;
        },
        set: function (a) {
            var b = this.km;
            if (a != b) {
                this.jk = a;
                this.g3("YAxisTitleTopMargin", b, this.km);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j4", {
        get: function () {
            return this.i2;
        },
        set: function (a) {
            var b = this.j4;
            if (a != b) {
                this.i2 = a;
                this.g3("XAxisTitleRightMargin", b, this.j4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kl", {
        get: function () {
            return this.jj;
        },
        set: function (a) {
            var b = this.kl;
            if (a != b) {
                this.jj = a;
                this.g3("YAxisTitleRightMargin", b, this.kl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j1", {
        get: function () {
            return this.iz;
        },
        set: function (a) {
            var b = this.j1;
            if (a != b) {
                this.iz = a;
                this.g3("XAxisTitleBottomMargin", b, this.j1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ki", {
        get: function () {
            return this.jg;
        },
        set: function (a) {
            var b = this.ki;
            if (a != b) {
                this.jg = a;
                this.g3("YAxisTitleBottomMargin", b, this.ki);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n5", {
        get: function () {
            return this.nr;
        },
        set: function (a) {
            var b = this.n5;
            if (a != b) {
                this.nr = a;
                this.g3("XAxisTitleTextColor", b, this.n5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oc", {
        get: function () {
            return this.ny;
        },
        set: function (a) {
            var b = this.oc;
            if (a != b) {
                this.ny = a;
                this.g3("YAxisTitleTextColor", b, this.oc);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.g5 = function (a, b, c) {
        var _this = this;
        _super.prototype.g5.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.m9(function (d) { return d.textStyle = _this.k8; });
                break;
            case "YAxisLabelTextStyle":
                this.nd(function (d) { return d.textStyle = _this.ma; });
                break;
            case "XAxisTitleTextStyle":
                this.na(function (d) { return d.textStyle = _this.lw; });
                break;
            case "YAxisTitleTextStyle":
                this.ne(function (d) { return d.textStyle = _this.my; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "k8", {
        get: function () {
            return this.kr;
        },
        set: function (a) {
            var b = this.k8;
            if (a != b) {
                this.kr = a;
                this.g3("XAxisLabelTextStyle", b, this.k8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ma", {
        get: function () {
            return this.ku;
        },
        set: function (a) {
            var b = this.ma;
            if (a != b) {
                this.ku = a;
                this.g3("YAxisLabelTextStyle", b, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "lw", {
        get: function () {
            return this.kt;
        },
        set: function (a) {
            var b = this.lw;
            if (a != b) {
                this.kt = a;
                this.g3("XAxisTitleTextStyle", b, this.lw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "my", {
        get: function () {
            return this.kw;
        },
        set: function (a) {
            var b = this.my;
            if (a != b) {
                this.kw = a;
                this.g3("YAxisTitleTextStyle", b, this.my);
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.m4 = function (a) {
        var _this = this;
        this.m1(a, function (b) { return b.leftMargin = _this.js; });
        this.m1(a, function (b) { return b.topMargin = _this.ju; });
        this.m1(a, function (b) { return b.rightMargin = _this.jt; });
        this.m1(a, function (b) { return b.bottomMargin = _this.jr; });
        this.m1(a, function (b) { return b.textColor = _this.nz; });
        this.m2(a, function (b) { return b.textColor = _this.n5; });
        this.m2(a, function (b) { return b.leftMargin = _this.j2; });
        this.m2(a, function (b) { return b.topMargin = _this.j5; });
        this.m2(a, function (b) { return b.rightMargin = _this.j4; });
        this.m2(a, function (b) { return b.bottomMargin = _this.j1; });
        this.m1(a, function (b) { return b.textStyle = _this.k8; });
        this.m2(a, function (b) { return b.textStyle = _this.lw; });
    };
    XYChart.prototype.m6 = function (a) {
        var _this = this;
        this.m1(a, function (b) { return b.leftMargin = _this.j9; });
        this.m1(a, function (b) { return b.topMargin = _this.kb; });
        this.m1(a, function (b) { return b.rightMargin = _this.ka; });
        this.m1(a, function (b) { return b.bottomMargin = _this.j8; });
        this.m1(a, function (b) { return b.textColor = _this.n6; });
        this.m2(a, function (b) { return b.textColor = _this.oc; });
        this.m2(a, function (b) { return b.leftMargin = _this.kj; });
        this.m2(a, function (b) { return b.topMargin = _this.km; });
        this.m2(a, function (b) { return b.rightMargin = _this.kl; });
        this.m2(a, function (b) { return b.bottomMargin = _this.ki; });
        this.m1(a, function (b) { return b.textStyle = _this.ma; });
        this.m2(a, function (b) { return b.textStyle = _this.my; });
    };
    XYChart.prototype.hk = function (a) {
        var b = this.u(a);
        var c = this.aq(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.el(a);
        c.fx = this.em(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.m7 = function (a) {
        this.m8(a, null);
    };
    XYChart.prototype.m8 = function (a, b) {
        a(this.h9());
    };
    XYChart.prototype.nc = function (a, b) {
        a(this.ia());
    };
    XYChart.prototype.nb = function (a) {
        this.nc(a, true);
    };
    XYChart.prototype.na = function (a) {
        this.m2(this.h9(), a);
    };
    XYChart.prototype.ne = function (a) {
        this.m2(this.ia(), a);
    };
    XYChart.prototype.nd = function (a) {
        this.m1(this.ia(), a);
    };
    XYChart.prototype.m9 = function (a) {
        this.m1(this.h9(), a);
    };
    XYChart.prototype.jl = function (a) {
        var b = this.h9();
        return b.dw(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jn = function (a) {
        var b = this.h9();
        return b.dz(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jm = function (a) {
        var b = this.ia();
        return b.dw(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.jo = function (a) {
        var b = this.ia();
        return b.dz(a, new ScalerParams(1, this.h8, this.h7, b.b8));
    };
    XYChart.prototype.hi = function (a) {
        _super.prototype.hi.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.h9();
            var c = this.ia();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.kx = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.ge = function (a) {
        _super.prototype.ge.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.h9());
            this.dataChart.axes.add(this.ia());
        }
    };
    XYChart.prototype.m3 = function (a) {
        var _this = this;
        if (a != null && this.di != null && a.es == null) {
            a.provideRenderer(this.di);
        }
        a.ij = this.n0;
        a.d3 = this.jv;
        a.ik = this.n1;
        a.d6 = this.jw;
        a.im = this.n3;
        a.en = this.jx;
        a.il = this.n2;
        a.eo = this.jy;
        a.io = this.n4;
        a.ep = this.jz;
        a.co = true;
        var b = a == this.h9();
        if (b) {
            a.f7 = this.ln;
        }
        a.e7 = this.kp;
        this.m1(a, function (c) { return c.angle = _this.jq; });
        this.m1(a, function (c) {
            if (c.extent != _this.jp) {
                c.extent = _this.jp;
            }
        });
        this.m1(a, function (c) { return c.horizontalAlignment = _this.ni; });
        this.m1(a, function (c) { return c.verticalAlignment = _this.og; });
        this.m1(a, function (c) { return c.visibility = _this.ol; });
        this.m2(a, function (c) { return c.horizontalAlignment = _this.nj; });
        this.m2(a, function (c) { return c.angle = _this.j0; });
        this.m4(a);
    };
    XYChart.prototype.m5 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.di != null && a.es == null) {
            a.provideRenderer(this.di);
        }
        this.m1(a, function (b) { return b.angle = _this.j7; });
        this.m1(a, function (b) {
            if (b.extent != _this.j6) {
                b.extent = _this.j6;
            }
        });
        this.m1(a, function (b) { return b.horizontalAlignment = _this.nk; });
        this.m1(a, function (b) { return b.verticalAlignment = _this.oh; });
        this.m1(a, function (b) { return b.visibility = _this.om; });
        this.m1(a, function (b) { return b.location = _this.ih; });
        this.m2(a, function (b) { return b.verticalAlignment = _this.oi; });
        this.m2(a, function (b) { return b.angle = _this.kh; });
        a.ij = this.n7;
        a.d3 = this.kc;
        a.ik = this.n8;
        a.d6 = this.kd;
        a.im = this.oa;
        a.en = this.ke;
        a.il = this.n9;
        a.eo = this.kf;
        a.io = this.ob;
        a.ep = this.kg;
        var b = a == this.ia();
        if (b) {
            a.f7 = this.mp;
        }
        this.m6(a);
    };
    XYChart.prototype.gb = function () {
        _super.prototype.gb.call(this);
        this.m3(this.h9());
        this.m5(this.ia());
    };
    XYChart.prototype.m1 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.aw == null) {
            a.aw = new AxisLabelSettings();
            a.aw.angle = a.dk();
            a.aw.bottomMargin = a.dl();
            a.aw.leftMargin = a.dm();
            a.aw.rightMargin = a.dn();
            a.aw.topMargin = a.dp();
            a.aw.horizontalAlignment = a.id();
            a.aw.location = a.ax();
            a.aw.verticalAlignment = a.i8();
        }
        b(a.aw);
    };
    XYChart.prototype.m2 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.bc == null) {
            a.bc = new TitleSettings();
            a.bc.bottomMargin = a.dr();
            a.bc.leftMargin = a.ds();
            a.bc.rightMargin = a.dt();
            a.bc.topMargin = a.du();
            a.bc.location = a.ay();
            a.bc.angle = a.dq();
            a.bc.horizontalAlignment = a.ie();
            a.bc.verticalAlignment = a.i9();
        }
        b(a.bc);
    };
    XYChart.prototype.g3 = function (a, b, c) {
        var _this = this;
        _super.prototype.g3.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.m9(function (d) { return d.angle = _this.jq; });
                break;
            case "YAxisLabelAngle":
                this.nd(function (d) { return d.angle = _this.j7; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.m9(function (d) { return d.horizontalAlignment = _this.ni; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.nd(function (d) { return d.horizontalAlignment = _this.nk; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.m9(function (d) { return d.verticalAlignment = _this.og; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.nd(function (d) { return d.verticalAlignment = _this.oh; });
                break;
            case "XAxisLabelVisibility":
                this.m9(function (d) { return d.visibility = _this.ol; });
                break;
            case "YAxisLabelVisibility":
                this.nd(function (d) { return d.visibility = _this.om; });
                break;
            case "XAxisLabel":
                this.m7(function (d) { return d.e7 = _this.kp; });
                break;
            case "YAxisLabel":
                this.nb(function (d) { return d.e7 = _this.kq; });
                break;
            case "XAxisTitleAngle":
                this.na(function (d) { return d.angle = _this.j0; });
                break;
            case "YAxisTitleAngle":
                this.ne(function (d) { return d.angle = _this.kh; });
                break;
            case "XAxisTitleAlignment":
                this.na(function (d) { return d.horizontalAlignment = _this.nj; });
                break;
            case "YAxisTitleAlignment":
                this.ne(function (d) { return d.verticalAlignment = _this.oi; });
                break;
            case "XAxisTitle":
                this.m7(function (d) { return d.f7 = _this.ln; });
                break;
            case "YAxisTitle":
                this.nc(function (d) { return d.f7 = _this.mp; }, false);
                break;
            case "XAxisMajorStroke":
                this.m8(function (d) { return d.ij = _this.n0; }, a);
                break;
            case "YAxisMajorStroke":
                this.nb(function (d) { return d.ij = _this.n7; });
                break;
            case "XAxisMajorStrokeThickness":
                this.m8(function (d) { return d.d3 = _this.jv; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.nb(function (d) { return d.d3 = _this.kc; });
                break;
            case "XAxisMinorStroke":
                this.m7(function (d) { return d.ik = _this.n1; });
                break;
            case "YAxisMinorStroke":
                this.nb(function (d) { return d.ik = _this.n8; });
                break;
            case "XAxisMinorStrokeThickness":
                this.m7(function (d) { return d.d6 = _this.jw; });
                break;
            case "YAxisMinorStrokeThickness":
                this.nb(function (d) { return d.d6 = _this.kd; });
                break;
            case "XAxisTickLength":
                this.m7(function (d) { return d.eo = _this.jy; });
                break;
            case "YAxisTickLength":
                this.nb(function (d) { return d.eo = _this.kf; });
                break;
            case "XAxisTickStroke":
                this.m7(function (d) { return d.io = _this.n4; });
                break;
            case "YAxisTickStroke":
                this.nb(function (d) { return d.io = _this.ob; });
                break;
            case "XAxisTickStrokeThickness":
                this.m7(function (d) { return d.ep = _this.jz; });
                break;
            case "YAxisTickStrokeThickness":
                this.nb(function (d) { return d.ep = _this.kg; });
                break;
            case "XAxisStroke":
                this.m7(function (d) { return d.im = _this.n3; });
                break;
            case "YAxisStroke":
                this.nb(function (d) { return d.im = _this.oa; });
                break;
            case "XAxisStrokeThickness":
                this.m7(function (d) { return d.en = _this.jx; });
                break;
            case "YAxisStrokeThickness":
                this.nb(function (d) { return d.en = _this.ke; });
                break;
            case "XAxisExtent":
                this.m9(function (d) { return d.extent = _this.jp; });
                break;
            case "YAxisExtent":
                this.nd(function (d) { return d.extent = _this.j6; });
                break;
            case "XAxisStrip":
                this.m7(function (d) { return d.il = _this.n2; });
                break;
            case "YAxisStrip":
                this.nb(function (d) { return d.il = _this.n9; });
                break;
            case "XAxisInverted":
                this.m7(function (d) { return d.b8 = _this.ik; });
                break;
            case "YAxisInverted":
                this.nb(function (d) { return d.b8 = _this.il; });
                break;
            case "YAxisLabelLocation":
                this.nd(function (d) { return d.location = _this.ih; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "kp", {
        get: function () {
            return this.kn;
        },
        set: function (a) {
            var b = this.kp;
            if (a != b) {
                this.kn = a;
                this.g3("XAxisLabel", b, this.kp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kq", {
        get: function () {
            return this.ko;
        },
        set: function (a) {
            var b = this.kq;
            if (a != b) {
                this.ko = a;
                this.g3("YAxisLabel", b, this.kq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n0", {
        get: function () {
            return this.nm;
        },
        set: function (a) {
            var b = this.n0;
            if (a != b) {
                this.nm = a;
                this.g3("XAxisMajorStroke", b, this.n0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n7", {
        get: function () {
            return this.nt;
        },
        set: function (a) {
            var b = this.n7;
            if (a != b) {
                this.nt = a;
                this.g3("YAxisMajorStroke", b, this.n7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jv", {
        get: function () {
            return this.it;
        },
        set: function (a) {
            var b = this.jv;
            if (a != b) {
                this.it = a;
                this.g3("XAxisMajorStrokeThickness", b, this.jv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kc", {
        get: function () {
            return this.ja;
        },
        set: function (a) {
            var b = this.kc;
            if (a != b) {
                this.ja = a;
                this.g3("YAxisMajorStrokeThickness", b, this.kc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jw", {
        get: function () {
            return this.iu;
        },
        set: function (a) {
            var b = this.jw;
            if (a != b) {
                this.iu = a;
                this.g3("XAxisMinorStrokeThickness", b, this.jw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kd", {
        get: function () {
            return this.jb;
        },
        set: function (a) {
            var b = this.kd;
            if (a != b) {
                this.jb = a;
                this.g3("YAxisMinorStrokeThickness", b, this.kd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n2", {
        get: function () {
            return this.no;
        },
        set: function (a) {
            var b = this.n2;
            if (a != b) {
                this.no = a;
                this.g3("XAxisStrip", b, this.n2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n9", {
        get: function () {
            return this.nv;
        },
        set: function (a) {
            var b = this.n9;
            if (a != b) {
                this.nv = a;
                this.g3("YAxisStrip", b, this.n9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n3", {
        get: function () {
            return this.np;
        },
        set: function (a) {
            var b = this.n3;
            if (a != b) {
                this.np = a;
                this.g3("XAxisStroke", b, this.n3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oa", {
        get: function () {
            return this.nw;
        },
        set: function (a) {
            var b = this.oa;
            if (a != b) {
                this.nw = a;
                this.g3("YAxisStroke", b, this.oa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jx", {
        get: function () {
            return this.iv;
        },
        set: function (a) {
            var b = this.jx;
            if (a != b) {
                this.iv = a;
                this.g3("XAxisStrokeThickness", b, this.jx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ke", {
        get: function () {
            return this.jc;
        },
        set: function (a) {
            var b = this.ke;
            if (a != b) {
                this.jc = a;
                this.g3("YAxisStrokeThickness", b, this.ke);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jy", {
        get: function () {
            return this.iw;
        },
        set: function (a) {
            var b = this.jy;
            if (a != b) {
                this.iw = a;
                this.g3("XAxisTickLength", b, this.jy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kf", {
        get: function () {
            return this.jd;
        },
        set: function (a) {
            var b = this.kf;
            if (a != b) {
                this.jd = a;
                this.g3("YAxisTickLength", b, this.kf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n4", {
        get: function () {
            return this.nq;
        },
        set: function (a) {
            var b = this.n4;
            if (a != b) {
                this.nq = a;
                this.g3("XAxisTickStroke", b, this.n4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ob", {
        get: function () {
            return this.nx;
        },
        set: function (a) {
            var b = this.ob;
            if (a != b) {
                this.nx = a;
                this.g3("YAxisTickStroke", b, this.ob);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jz", {
        get: function () {
            return this.ix;
        },
        set: function (a) {
            var b = this.jz;
            if (a != b) {
                this.ix = a;
                this.g3("XAxisTickStrokeThickness", b, this.jz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kg", {
        get: function () {
            return this.je;
        },
        set: function (a) {
            var b = this.kg;
            if (a != b) {
                this.je = a;
                this.g3("YAxisTickStrokeThickness", b, this.kg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ln", {
        get: function () {
            return this.ks;
        },
        set: function (a) {
            var b = this.ln;
            if (a != b) {
                this.ks = a;
                this.g3("XAxisTitle", b, this.ln);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "mp", {
        get: function () {
            return this.kv;
        },
        set: function (a) {
            var b = this.mp;
            if (a != b) {
                this.kv = a;
                this.g3("YAxisTitle", b, this.mp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n1", {
        get: function () {
            return this.nn;
        },
        set: function (a) {
            var b = this.n1;
            if (a != b) {
                this.nn = a;
                this.g3("XAxisMinorStroke", b, this.n1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "n8", {
        get: function () {
            return this.nu;
        },
        set: function (a) {
            var b = this.n8;
            if (a != b) {
                this.nu = a;
                this.g3("YAxisMinorStroke", b, this.n8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jq", {
        get: function () {
            return this.io;
        },
        set: function (a) {
            var b = this.jq;
            if (a != b) {
                this.io = a;
                this.g3("XAxisLabelAngle", b, this.jq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j7", {
        get: function () {
            return this.i5;
        },
        set: function (a) {
            var b = this.j7;
            if (a != b) {
                this.i5 = a;
                this.g3("YAxisLabelAngle", b, this.j7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "jp", {
        get: function () {
            return this.im;
        },
        set: function (a) {
            var b = this.jp;
            if (a != b) {
                this.im = a;
                this.g3("XAxisExtent", b, this.jp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j6", {
        get: function () {
            return this.i4;
        },
        set: function (a) {
            var b = this.j6;
            if (a != b) {
                this.i4 = a;
                this.g3("YAxisExtent", b, this.j6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "j0", {
        get: function () {
            return this.iy;
        },
        set: function (a) {
            var b = this.j0;
            if (a != b) {
                this.iy = a;
                this.g3("XAxisTitleAngle", b, this.j0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "kh", {
        get: function () {
            return this.jf;
        },
        set: function (a) {
            var b = this.kh;
            if (a != b) {
                this.jf = a;
                this.g3("YAxisTitleAngle", b, this.kh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ik", {
        get: function () {
            return this.ii;
        },
        set: function (a) {
            var b = this.ik;
            if (a != b) {
                this.ii = a;
                this.g3("XAxisInverted", b, this.ik);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "il", {
        get: function () {
            return this.ij;
        },
        set: function (a) {
            var b = this.il;
            if (a != b) {
                this.ij = a;
                this.g3("YAxisInverted", b, this.il);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "nj", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            var b = this.nj;
            if (a != b) {
                this.ng = a;
                this.g3("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nj));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oi", {
        get: function () {
            return this.of;
        },
        set: function (a) {
            var b = this.oi;
            if (a != b) {
                this.of = a;
                this.g3("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oi));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ni", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.ni;
            if (a != b) {
                this.nf = a;
                this.g3("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.ni));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_nk = function () {
        return this.nh;
    };
    XYChart.prototype.set_nk = function (a) {
        var b = this.nk;
        if (a != b) {
            this.nh = a;
            this.g3("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nk));
        }
    };
    Object.defineProperty(XYChart.prototype, "nk", {
        get: function () {
            return this.get_nk();
        },
        set: function (a) {
            this.set_nk(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "og", {
        get: function () {
            return this.od;
        },
        set: function (a) {
            var b = this.og;
            if (a != b) {
                this.od = a;
                this.g3("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.og));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "oh", {
        get: function () {
            return this.oe;
        },
        set: function (a) {
            var b = this.oh;
            if (a != b) {
                this.oe = a;
                this.g3("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.oh));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ol", {
        get: function () {
            return this.oj;
        },
        set: function (a) {
            var b = this.ol;
            if (a != b) {
                this.oj = a;
                this.g3("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ol));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "om", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            var b = this.om;
            if (a != b) {
                this.ok = a;
                this.g3("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.om));
            }
        },
        enumerable: true,
        configurable: true
    });
    XYChart.prototype.get_ih = function () {
        return this.ig;
    };
    XYChart.prototype.set_ih = function (a) {
        var b = this.ih;
        if (a != b) {
            this.ig = a;
            this.g3("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.ih));
        }
    };
    Object.defineProperty(XYChart.prototype, "ih", {
        get: function () {
            return this.get_ih();
        },
        set: function (a) {
            this.set_ih(a);
        },
        enumerable: true,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of data visualizations in the Category Chart
 */
var CategoryChartType = /*@__PURE__*/ (function (CategoryChartType) {
    /**
     * Specifies category line series with markers at each data point
     */
    CategoryChartType[CategoryChartType["Line"] = 0] = "Line";
    /**
     * Specifies category area series
     */
    CategoryChartType[CategoryChartType["Area"] = 1] = "Area";
    /**
     * Specifies category column chart with vertical rectangles at each data point
     */
    CategoryChartType[CategoryChartType["Column"] = 2] = "Column";
    /**
     * Specifies category point chart with markers at each data point
     */
    CategoryChartType[CategoryChartType["Point"] = 3] = "Point";
    /**
     * Specifies category step line chart
     */
    CategoryChartType[CategoryChartType["StepLine"] = 4] = "StepLine";
    /**
     * Specifies category step area chart
     */
    CategoryChartType[CategoryChartType["StepArea"] = 5] = "StepArea";
    /**
     * Specifies category spline line series with markers at each data point
     */
    CategoryChartType[CategoryChartType["Spline"] = 6] = "Spline";
    /**
     * Specifies category spline area series
     */
    CategoryChartType[CategoryChartType["SplineArea"] = 7] = "SplineArea";
    /**
     * Specifies category waterfall chart
     */
    CategoryChartType[CategoryChartType["Waterfall"] = 8] = "Waterfall";
    /**
     * Specifies automatic selection of chart type based on suggestions from Data Adapter
     */
    CategoryChartType[CategoryChartType["Auto"] = 9] = "Auto";
    return CategoryChartType;
})({});
/**
 * @hidden
 */
var CategoryChartType_$type = /*@__PURE__*/ markEnum('CategoryChartType', 'Line,0|Area,1|Column,2|Point,3|StepLine,4|StepArea,5|Spline,6|SplineArea,7|Waterfall,8|Auto,9');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryChart, _super);
    function CategoryChart() {
        var _this = _super.call(this) || this;
        _this.p3 = 1000;
        _this.o7 = null;
        _this.or = 9;
        _this.ot = 1;
        _this.pb = false;
        _this.ov = 0;
        _this.o5 = 0;
        _this.pk = 0;
        _this.pl = 0;
        _this.pj = 0;
        _this.pm = 0;
        _this.pn = NaN;
        _this.pd = false;
        _this.p4 = 10;
        _this.pp = NaN;
        _this.po = NaN;
        _this.pq = 0;
        _this.on = null;
        _this.oo = null;
        _this.pc = true;
        _this.o9 = false;
        _this.pa = false;
        _this.f6();
        return _this;
    }
    CategoryChart.prototype.gj = function () {
        _super.prototype.gj.call(this);
        if (this.dataChart == null) {
            return;
        }
        var a = this.dataChart.bn.i.e();
        this.op = a.d;
        this.oq = a.e;
        if (this.nz == null) {
            this.nz = a.k;
        }
        if (this.n6 == null) {
            this.n6 = a.k;
        }
    };
    CategoryChart.prototype.gl = function (a, b) {
        _super.prototype.gl.call(this, a, b);
        a.fj = this.p5;
        a.bv = this.o8;
    };
    CategoryChart.prototype.g4 = function (a, b, c) {
        var _this = this;
        _super.prototype.g4.call(this, a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.qu(function (d) { return d.fj = _this.p5; });
                break;
            case "TransitionInEasingFunction":
                this.qu(function (d) { return d.bv = _this.o8; });
                break;
        }
    };
    Object.defineProperty(CategoryChart.prototype, "p5", {
        get: function () {
            return this.p3;
        },
        set: function (a) {
            var b = this.p5;
            if (a != b) {
                this.p3 = a;
                this.g3("TransitionInDuration", b, this.p5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "o8", {
        get: function () {
            return this.o7;
        },
        set: function (a) {
            var b = this.o8;
            if (a != b) {
                this.o7 = a;
                this.g3("TransitionInEasingFunction", b, this.o8);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryChart.prototype.p8 = function () {
        var cvd_ = this.dj();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    };
    CategoryChart.prototype.ge = function (a) {
        _super.prototype.ge.call(this, a);
        a.cd = this.bg;
    };
    CategoryChart.prototype.gk = function (a, b) {
        _super.prototype.gk.call(this, a, b);
        var c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.o0 = this.ou;
        c.ny = this.pg;
        c.nh = this.ow;
        c.bp = this.o6;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
        c.trendLineType = this.av;
        c.trendLineThickness = this.c6;
        c.l1 = this.ai(a, b);
        if (a.cz) {
            a.ji(ArrayExtension.getModulus$1(Brush.$, this.op, b), ArrayExtension.getModulus$1(Brush.$, this.oq, b));
        }
    };
    CategoryChart.prototype.ox = function () {
        return new CategoryXAxis();
    };
    CategoryChart.prototype.o1 = function () {
        return new NumericYAxis();
    };
    CategoryChart.prototype.f3 = function () {
        this.xAxis = this.ox();
        this.xAxis.name = "xAxis";
        var a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.qw));
        this.yAxis = this.o1();
        this.yAxis.name = "yAxis";
        var b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.qx));
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
    };
    CategoryChart.prototype.m5 = function (a) {
        _super.prototype.m5.call(this, a);
        a.jo = this.ph;
    };
    Object.defineProperty(CategoryChart.prototype, "os", {
        get: function () {
            return this.or;
        },
        set: function (a) {
            if (a != this.or) {
                var b = this.os;
                this.or = a;
                this.g3("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.os));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ou", {
        get: function () {
            return this.ot;
        },
        set: function (a) {
            var b = this.ou;
            if (a != b) {
                this.ot = a;
                this.g3("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.ou));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pg", {
        get: function () {
            return this.pb;
        },
        set: function (a) {
            var b = this.pg;
            if (a != b) {
                this.pb = a;
                this.g3("IsTransitionInEnabled", b, this.pg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ow", {
        get: function () {
            return this.ov;
        },
        set: function (a) {
            var b = this.ow;
            if (a != b) {
                this.ov = a;
                this.g3("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.ow));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "o6", {
        get: function () {
            return this.o5;
        },
        set: function (a) {
            var b = this.o6;
            if (a != b) {
                this.o5 = a;
                this.g3("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.o6));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pu", {
        get: function () {
            return this.pk;
        },
        set: function (a) {
            var b = this.pu;
            if (a != b) {
                this.pk = a;
                this.g3("XAxisInterval", b, this.pu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pv", {
        get: function () {
            return this.pl;
        },
        set: function (a) {
            var b = this.pv;
            if (a != b) {
                this.pl = a;
                this.g3("XAxisMinorInterval", b, this.pv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pt", {
        get: function () {
            return this.pj;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.pj = a;
                this.g3("XAxisGap", b, this.pt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pw", {
        get: function () {
            return this.pm;
        },
        set: function (a) {
            var b = this.pw;
            if (a != b) {
                this.pm = a;
                this.g3("XAxisOverlap", b, this.pw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pz", {
        get: function () {
            return this.pn;
        },
        set: function (a) {
            var b = this.pz;
            if (a != b) {
                this.pn = a;
                this.g3("YAxisInterval", b, this.pz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pi", {
        get: function () {
            return this.pd;
        },
        set: function (a) {
            var b = this.pi;
            if (a != b) {
                this.pd = a;
                this.g3("YAxisIsLogarithmic", b, this.pi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "p6", {
        get: function () {
            return this.p4;
        },
        set: function (a) {
            var b = this.p6;
            if (a != b) {
                this.p4 = a;
                this.g3("YAxisLogarithmBase", b, this.p6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "p1", {
        get: function () {
            return this.pp;
        },
        set: function (a) {
            var b = this.p1;
            if (a != b) {
                this.pp = a;
                this.g3("YAxisMinimumValue", b, this.p1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "p0", {
        get: function () {
            return this.po;
        },
        set: function (a) {
            var b = this.p0;
            if (a != b) {
                this.po = a;
                this.g3("YAxisMaximumValue", b, this.p0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "p2", {
        get: function () {
            return this.pq;
        },
        set: function (a) {
            var b = this.p2;
            if (a != b) {
                this.pq = a;
                this.g3("YAxisMinorInterval", b, this.p2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ps", {
        get: function () {
            return this.xAxis.lb;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pr", {
        get: function () {
            return this.xAxis.la;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "py", {
        get: function () {
            return this.yAxis.j4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "px", {
        get: function () {
            return this.yAxis.j3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "op", {
        get: function () {
            return this.on;
        },
        set: function (a) {
            var b = this.op;
            if (a != b) {
                this.on = a;
                this.g3("NegativeBrushes", b, this.op);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "oq", {
        get: function () {
            return this.oo;
        },
        set: function (a) {
            var b = this.oq;
            if (a != b) {
                this.oo = a;
                this.g3("NegativeOutlines", b, this.oq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "ph", {
        get: function () {
            return this.pc;
        },
        set: function (a) {
            var b = this.ph;
            if (a != b) {
                this.pc = a;
                this.g3("YAxisAbbreviateLargeNumbers", b, this.ph);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pe", {
        get: function () {
            return this.o9;
        },
        set: function (a) {
            var b = this.pe;
            if (a != b) {
                this.o9 = a;
                this.g3("IsCategoryHighlightingEnabled", b, this.pe);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "pf", {
        get: function () {
            return this.pa;
        },
        set: function (a) {
            var b = this.pf;
            if (a != b) {
                this.pa = a;
                this.g3("IsItemHighlightingEnabled", b, this.pf);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryChart.prototype.get_b5 = function () {
        var a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    };
    Object.defineProperty(CategoryChart.prototype, "b5", {
        get: function () {
            return this.get_b5();
        },
        enumerable: true,
        configurable: true
    });
    CategoryChart.prototype.qw = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.ha("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.ha("XAxisActualMaximum");
                break;
        }
    };
    CategoryChart.prototype.qx = function (a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.ha("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.ha("YAxisActualMaximum");
                break;
        }
    };
    CategoryChart.prototype.hl = function () {
        _super.prototype.hl.call(this);
        this.xAxis.e7 = this.kp == null ? XYChart.kx(this.xAxis, this.v.dataSeries) : this.kp;
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
    };
    Object.defineProperty(CategoryChart.prototype, "xAxis", {
        get: function () {
            return this._xAxis;
        },
        set: function (a) {
            this._xAxis = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryChart.prototype, "yAxis", {
        get: function () {
            return this._yAxis;
        },
        set: function (a) {
            this._yAxis = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryChart.prototype.o0 = function (a, b) {
        switch (a) {
            case 2: return this.ar(1);
            case 3: return this.ar(10);
            case 0: return this.ar(0);
            case 1: return this.ar(2);
            case 6: return this.ar(6);
            case 7: return this.ar(7);
            case 4: return this.ar(4);
            case 5: return this.ar(5);
            case 8: return this.ar(8);
            case 9: return this.oz(b);
            default: return this.ar(1);
        }
    };
    CategoryChart.prototype.oz = function (a) {
        return this.ar(a);
    };
    CategoryChart.prototype.u = function (a) {
        switch (this.os) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    };
    CategoryChart.prototype.aq = function (a, b) {
        var c = this.o0(this.os, a.suggestedSeries);
        c.pd = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    };
    CategoryChart.prototype.hj = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jt = true;
            this.yAxis.kg = 10;
        }
    };
    CategoryChart.prototype.hm = function () {
        this.yAxis.jt = this.pi;
        this.yAxis.kg = this.p6;
    };
    CategoryChart.prototype.get_b4 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(CategoryChart.prototype, "b4", {
        get: function () {
            return this.get_b4();
        },
        enumerable: true,
        configurable: true
    });
    CategoryChart.prototype.f1 = function (a, b) {
        var c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.o0 = this.ou;
            c.l1 = this.ai(a, b);
        }
    };
    CategoryChart.prototype.qu = function (a) {
        this.qv(function (b, c) { return a(b); });
    };
    CategoryChart.prototype.qv = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
            if (c == null) {
                continue;
            }
            a(c, b);
        }
    };
    CategoryChart.prototype.h9 = function () {
        return this.xAxis;
    };
    CategoryChart.prototype.ia = function () {
        return this.yAxis;
    };
    CategoryChart.prototype.o3 = function () {
        return this.ar(30);
    };
    CategoryChart.prototype.o4 = function () {
        return this.ar(31);
    };
    CategoryChart.prototype.b1 = function (a, b) {
        var c = _super.prototype.b1.call(this, a, b);
        if (c != null) {
            var d = new List$1(Series.$, 0);
            if (this.o9) {
                d.add(this.o3());
            }
            if (this.pa) {
                d.add(this.o4());
            }
            for (var e = 0; e < d.count; e++) {
                var f = d._inner[e];
                f.name = a + getInstanceType(f).typeName;
                c.add(f);
            }
        }
        return c;
    };
    CategoryChart.prototype.hq = function (a, b, c) {
        _super.prototype.hq.call(this, a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (stringIsNullOrEmpty(this.ea)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(16));
            }
            if (stringIsNullOrEmpty(this.ec)) {
                this.ac.setYMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d6)) {
                this.ac.setLabelMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d3)) {
                this.ac.setContentMemberPath(a, c.getMemberPathFor(0));
            }
        }
    };
    CategoryChart.prototype.g3 = function (a, b, c) {
        var _this = this;
        _super.prototype.g3.call(this, a, b, c);
        switch (a) {
            case "ChartType":
                this.hl();
                break;
            case "MarkerCollisionAvoidance":
                this.qu(function (d) { return d.o0 = _this.ou; });
                break;
            case "IsTransitionInEnabled":
                this.qu(function (d) { return d.ny = _this.pg; });
                break;
            case "TransitionInMode":
                this.qu(function (d) { return d.nh = _this.ow; });
                break;
            case "TransitionInSpeedType":
                this.qu(function (d) { return d.bp = _this.o6; });
                break;
            case "XAxisInterval":
                this.xAxis.k6 = this.pu;
                break;
            case "XAxisMinorInterval":
                this.xAxis.k7 = this.pv;
                break;
            case "XAxisGap":
                this.xAxis.jo = this.pt;
                break;
            case "XAxisOverlap":
                this.xAxis.jv = this.pw;
                break;
            case "YAxisInterval":
                this.yAxis.j8 = this.pz;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.jt = this.pi;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kg = this.p6;
                break;
            case "YAxisMinimumValue":
                this.yAxis.kc = this.p1;
                break;
            case "YAxisMaximumValue":
                this.yAxis.kb = this.p0;
                break;
            case "YAxisMinorInterval":
                this.yAxis.kd = this.p2;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.qv(function (d, e) {
                    if (d.cz) {
                        d.ji(ArrayExtension.getModulus$1(Brush.$, _this.op, e), ArrayExtension.getModulus$1(Brush.$, _this.oq, e));
                    }
                });
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.nb(function (d) { return d.jo = _this.ph; });
                break;
            case "IsCategoryHighlightingEnabled":
            case "IsItemHighlightingEnabled":
                this.hl();
                break;
        }
    };
    CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);
    return CategoryChart;
}(XYChart));

/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*/
var IgrChartSeriesEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrChartSeriesEventArgs() {
    }
    Object.defineProperty(IgrChartSeriesEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrChartSeriesEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrChartSeriesEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrChartSeriesEventArgs.prototype, "series", {
        /**
         * Gets the series.
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrChartSeriesEventArgs;
}());

/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*
* The `DomainChartSeriesPointerEventArgs` class provide events for chart's SeriesAdded and SeriesRemoved.
*
* `SeriesPointerDown` get fired when the pointer is press down over a Series.
*
* ```ts
*  <IgrFinancialChart
*     yAxisInterval={200}
*     yAxisMinorInterval={50}
*     yAxisMajorStroke="Black"
*     yAxisMinorStroke="Gray" >
*  </IgrFinancialChart>
* ```
*
* ```ts
* this.chart.seriesPointerDown = this.chart_seriesPointerDown();
* ```
*
* ```ts
* <IgrFinancialChart
*     width="100%"
*     height="400px"
*     chartType="Candle"
*     zoomSliderType="Candle"
*     volumeType="Column"
*     indicatorTypes="ForceIndex"
*     overlayTypes ="PriceChannel"
*     dataSource={this.data}
*     seriesPointerDown = {this.onseriesPointerDown} />
* ```
*
* ```ts
* public void onseriesPointerDown =(s: IgrDomainChart <IIgrDomainChartProps>, e: DomainChartSeriesPointerEventArgs)=>
* {
*
* }
* ```
*/
var IgrDomainChartSeriesPointerEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrDomainChartSeriesPointerEventArgs() {
    }
    Object.defineProperty(IgrDomainChartSeriesPointerEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDomainChartSeriesPointerEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrDomainChartSeriesPointerEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrDomainChartSeriesPointerEventArgs.prototype, "series", {
        /**
         * Gets the series hit by the pointer.
        *
        * Use the `series` property to get the series.
        *
        * ```ts
        *  var series= args.series;
        * ```
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChartSeriesPointerEventArgs.prototype, "item", {
        /**
         * Gets the item hit by the pointer.
        *
        * Use the `item` property to get the items.
        *
        * <https://www.infragistics.com/help/wpf/infragisticswpf.controls.charts.xamdatachart~infragistics.controls.charts.domainchartseriespointereventargs~item>
        *
        * ```ts
        * var Chartitem = args.item;
        * ```
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrDomainChartSeriesPointerEventArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerTypeCollection, _super);
    function MarkerTypeCollection() {
        return _super.call(this, MarkerType_$type, 0) || this;
    }
    MarkerTypeCollection.$t = markType(MarkerTypeCollection, 'MarkerTypeCollection', ObservableCollection$1.$.specialize(MarkerType_$type));
    return MarkerTypeCollection;
}(ObservableCollection$1));

var IgrMarkerTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMarkerTypeCollection, _super);
    function IgrMarkerTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrMarkerTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(MarkerType_$type, item);
    };
    IgrMarkerTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(MarkerType_$type, MarkerType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrMarkerTypeCollection;
}(IgCollection));

var IgrDomainChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDomainChart, _super);
    function IgrDomainChart(props) {
        var _this = _super.call(this, props) || this;
        _this._calloutsDataSource = null;
        _this._markerTypes = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._seriesAdded = null;
        _this._seriesAdded_wrapped = null;
        _this._seriesRemoved = null;
        _this._seriesRemoved_wrapped = null;
        _this._seriesPointerEnter = null;
        _this._seriesPointerEnter_wrapped = null;
        _this._seriesPointerLeave = null;
        _this._seriesPointerLeave_wrapped = null;
        _this._seriesPointerMove = null;
        _this._seriesPointerMove_wrapped = null;
        _this._seriesPointerDown = null;
        _this._seriesPointerDown_wrapped = null;
        _this._seriesPointerUp = null;
        _this._seriesPointerUp_wrapped = null;
        _this._calloutStyleUpdating = null;
        _this._calloutStyleUpdating_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrDomainChart.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrDomainChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDomainChart.prototype.onImplementationCreated = function () {
    };
    IgrDomainChart.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrDomainChart.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrDomainChart.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrDomainChart.prototype, "tooltipTemplate", {
        /**
        * Sets or gets the template reference to use for tooltips for all the series.
        *
        *
        */
        get: function () {
            return this.i.tooltipTemplate;
        },
        set: function (v) {
            this.i.tooltipTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "tooltipTemplates", {
        /**
        * Sets or gets the template references to use for tooltips for all the series, in order.
        *
        *
        */
        get: function () {
            var ret = [];
            if (this.i.tooltipTemplates) {
                for (var ii = 0; ii < this.i.tooltipTemplates.count; ii++) {
                    ret.push(this.i.tooltipTemplates.item(ii));
                }
            }
            return ret;
        },
        set: function (v) {
            this.i.tooltipTemplates.clear();
            if (v) {
                for (var ii = 0; ii < v.length; ii++) {
                    this.i.tooltipTemplates.add(v[ii]);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "legend", {
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsDataSource", {
        get: function () {
            return this._calloutsDataSource;
        },
        set: function (value) {
            this._calloutsDataSource = value;
            this.bindCalloutsData();
        },
        enumerable: true,
        configurable: true
    });
    IgrDomainChart.prototype.bindCalloutsData = function () {
        if (this.i != null && this.i !== undefined) {
            this.i.calloutsItemsSource = this._calloutsDataSource;
        }
    };
    Object.defineProperty(IgrDomainChart.prototype, "pixelScalingRatio", {
        /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
        get: function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleLeftMargin", {
        /**
         * Gets or sets the left margin of chart title
        *
        *  Use `titleLeftMargin` property for the left margin of chart title.
        *
        * ```ts
        * this.chart.titleLeftMargin = 10;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                    titleLeftMargin={20}>
        *  </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.c2;
        },
        set: function (v) {
            this.i.c2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleRightMargin", {
        /**
         * Gets or sets the right margin of chart title
        *
        *  Use `titleLeftMargin` property for the right margin of chart title.
        *
        * ```ts
        * this.chart.titleRightMargin = 10;
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 				dataSource={this.state.data}
        *                 titleRightMargin = 10>
        *  </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.c3;
        },
        set: function (v) {
            this.i.c3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleTopMargin", {
        /**
         * Gets or sets the top margin of chart title
        *
        *  Use `titleTopMargin` property for the top margin of chart title.
        *
        * ```ts
        * this.chart.titleTopMargin = 10;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                titleTopMargin={10} />
        * ```
        */
        get: function () {
            return this.i.c4;
        },
        set: function (v) {
            this.i.c4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleBottomMargin", {
        /**
         * Gets or sets the bottom margin of chart title
        *
        *  Use `titleBottomMargin` property for the bottom margin of chart title.
        *
        * ```ts
        *  this.chart.titleBottomMargin = 5;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleAlignment="Right"
        * 	titleBottomMargin={5}/>
        * ```
        */
        get: function () {
            return this.i.c1;
        },
        set: function (v) {
            this.i.c1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleLeftMargin", {
        /**
         * Gets or sets the left margin of chart subtitle
        *
        * Use `subtitleLeftMargin` property for the left margin of chart subtitle.
        *
        * ```ts
        * this.chart.subtitleLeftMargin = 20 ;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleLeftMargin= {20}/>
        * ```
        */
        get: function () {
            return this.i.cx;
        },
        set: function (v) {
            this.i.cx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleTopMargin", {
        /**
         * Gets or sets the top margin of chart subtitle
        *
        * Use `subtitleTopMargin` property for the top margin of chart subtitle.
        *
        * ```ts
        * this.chart.subtitleTopMargin = 10;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleTopMargin= {10}/>
        * ```
        */
        get: function () {
            return this.i.cz;
        },
        set: function (v) {
            this.i.cz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleRightMargin", {
        /**
         * Gets or sets the right margin of chart subtitle
        *
        * Use `subtitleRightMargin` property for the right margin of chart subtitle.
        *
        * ```ts
        *  this.chart.subtitleRightMargin = 20 ;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleAlignment="Right"
        * 	subtitleRightMargin ={20}/>
        * ```
        */
        get: function () {
            return this.i.cy;
        },
        set: function (v) {
            this.i.cy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleBottomMargin", {
        /**
         * Gets or sets the bottom margin of chart subtitle
        *
        * Use `subtitleBottomMargin` property for the bottom margin of chart subtitle.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleBottomMargin= {10}/>
        * ```
        *
        * ```ts
        * this.chart.subtitleBottomMargin = 10 ;
        * ```
        */
        get: function () {
            return this.i.cw;
        },
        set: function (v) {
            this.i.cw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleTextColor", {
        /**
         * Gets or sets color of chart subtitle
        *
        * Use `subtitleTextColor` property to color the subtitle.
        *
        * ```ts
        * this.chart.subtitleTextColor = "#ff0000" ;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleTextColor="#ff0000"/>
        * ```
        */
        get: function () {
            return brushToString(this.i.h3);
        },
        set: function (v) {
            this.i.h3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleTextColor", {
        /**
         * Gets or sets color of chart title
        *
        *  Use `titleTextColor` property to color the chart title
        *
        * ```ts
        *  this.chart.titleTextColor="red" ;
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 		dataSource={this.state.data}
        * 		width="700px"
        * 		height="500px"
        * 		xAxisTitle="Countries"
        * 		titleTextColor="Red" />
        *
        * ```
        */
        get: function () {
            return brushToString(this.i.h4);
        },
        set: function (v) {
            this.i.h4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "leftMargin", {
        /**
         * Gets or sets the left margin of the chart content.
        *
        * Use the 'leftMargin' property for the left margin of the chart content.
        *
        * ```ts
        *  this.chart.leftMargin = 20;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                    leftMargin= {20}/>
        * ```
        */
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "topMargin", {
        /**
         * Gets or sets the top margin of the chart content.
        *
        * Use `topMargin` property for the margin of the chart content.
        *
        * ```ts
        * this.chart.topMargin=20;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                topMargin={10} />
        * ```
        */
        get: function () {
            return this.i.c5;
        },
        set: function (v) {
            this.i.c5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "rightMargin", {
        /**
         * Gets or sets the right margin of the chart content.
        *
        * Use `rightMargin` property for the right margin of the chart content.
        *
        * ```ts
        *   this.chart.rightMargin = 20 ;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	rightMargin= {4}/>
        * ```
        */
        get: function () {
            return this.i.cv;
        },
        set: function (v) {
            this.i.cv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "bottomMargin", {
        /**
         * Gets or sets the bottom margin around the chart content.
        *
        * Use the `bottomMargin` property for the bottom margin around the chart content.
        *
        * ```ts
        * this.chart.bottomMargin=20;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                    bottomMargin= 20 />
        * ```
        */
        get: function () {
            return this.i.cr;
        },
        set: function (v) {
            this.i.cr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "transitionDuration", {
        /**
         * Gets or sets the duration used for animating series plots when the data is changing
        *
        * Use the `transitionDuration` property to animating between data values.
        *
        * ```ts
        * this.chart.transitionDuratio= 500;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                transitionDuratio={500} />
        * ```
        */
        get: function () {
            return this.i.de;
        },
        set: function (v) {
            this.i.de = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "transitionEasingFunction", {
        /**
         * Gets or sets the easing function used for animating series plots when the data is changing.
         * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
        *
        * The 'transitionInEasingFunction' property used for easing function for animating series plots when the chart is loading into view.
        *
        * ```ts
        * this.chart.transitionInEasingFunction=  this.cubicFunc;
        *
        * cubicFunc(time: number) : number
        *   {
        *     return time;
        *   }
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                transitionInEasingFunction="cubic" />
        * ```
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleTextStyle", {
        /**
         * Gets or sets CSS font property for the chart subtitle
        *
        * Use `subtitleTextStyle` property for the CSS font of the chart subtitle.
        *
        * ```ts
        * this.chart.subtitleTextStyle= "16pt Verdona";
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitleTextStyle="16pt Verdona"/>
        * ```
        */
        get: function () {
            return this.i.e9;
        },
        set: function (v) {
            this.i.e9 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleTextStyle", {
        /**
         * Gets or sets CSS font property for the chart title
        *
        * Use `titleTextStyle` property for the CSS font property of the chart title
        *
        * ```ts
        * this.chart.xAxisTitleTextStyle = "24pt Verdona";
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                 width="700px"
        *                 height="500px"
        *                 xAxisTitle="Countries"
        *                 xAxisTitleTextColor="gray"
        *                 xAxisTitleTextStyle="12pt Verdana"
        *                 xAxisTitleAngle={0}
        *                 yAxisTitle="Trillions of Watt-hours (TWh)"
        *                 yAxisTitleTextStyle="12pt Verdana"
        *                 yAxisTitleTextColor="gray"
        *                 yAxisTitleAngle={90}
        *                 yAxisTitleLeftMargin={5}>
        *  </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.fk;
        },
        set: function (v) {
            this.i.fk = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "includedProperties", {
        /**
         * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
        *
        * The `includedProperties` property used to include the properties for the consideration of the category chart.
        *
        * ```ts
        * this.chart.includedProperties = ["ProductName", "Cost"];
        * ```
        *
        * ```ts
        * 	<IgrCategoryChart
        * 		chartType="Line"
        * 		markerTypes={this.state.markersTypes}
        * 		dataSource={this.categoryData}
        * 		excludedProperties="value" />
        * ```
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "excludedProperties", {
        /**
         * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
        *
        * The `excludedProperties` property used for the property paths that should be excluded from consideration by the category chart.
        *
        * ```ts
        * this.chart.excludedProperties = ["ID", "Discount"];
        * ```
        *
        * ```ts
        * 	<IgrCategoryChart
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	excludedProperties="value" />
        * ```
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the chart series.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        *
        * Use the `brushes` property to  set the brushes.
        *
        * ```ts
        * this.chart.brushes = ["#ff0000","#00ff00"];
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.j);
        },
        set: function (v) {
            this.i.j = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the chart series.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        *
        *  Use the `outlines` property to sets the palette of brushes to use for outlines on the chart series
        *
        * ```ts
        * <IgrCategoryChart
        * 	chartType="Line"
        * 	outlines= "#ff0000"
        * 	dataSource={this.categoryData}/>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.n);
        },
        set: function (v) {
            this.i.n = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "isHorizontalZoomEnabled", {
        /**
         * Gets or sets whether the chart can be horizontally zoomed through user interactions.
        *
        * Use the `isHorizontalZoomEnabled` property to allow chart horizontally zoomed .
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                    width="700px"
        *                    height="500px"
        *                    xAxisLabelTextStyle="10pt Verdana"
        *                    xAxisLabelTopMargin={5}
        *                    xAxisLabelTextColor="gray"
        *                    yAxisLabelTextStyle="10pt Verdana"
        *                    yAxisLabelRightMargin={5}
        *                    yAxisLabelTextColor="gray"
        * 				   isHorizontalZoomEnabled= true/>
        * ```
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                    IsHorizontalZoomEnabled= true />
        * ```
        *
        * ```ts
        * this.chart.isHorizontalZoomEnabled = true;
        * ```
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "isVerticalZoomEnabled", {
        /**
         * Gets or sets whether the chart can be vertically zoomed through user interactions.
        *
        * Use the `isVerticalZoomEnabled` property to allow chart zoom vertically.
        *
        * ```ts
        *  this.chart.isVerticalZoomEnabled = true;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart dataSource={this.state.data}
        *                   isVerticalZoomEnabled= "true"/>
        * ```
        */
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "isSeriesHighlightingEnabled", {
        /**
         * Gets or sets whether the chart can highlight series through user interactions.
         * This property applies to Category Chart and Financial Chart controls.
        */
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "windowRect", {
        /**
         * Gets or sets the rectangle representing the current scroll and zoom state of the chart.
         * WindowRect is expressed as a Rectangle with coordinates and sizes between 0 and 1.
        *
        * Use `windowRect` property representing the current scroll and zoom state of the chart.
        *
        * ```ts
        * this.chart.windowRect =[0,0,1,1];
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                WindowRect={1,0,1,1} />
        * ```
        */
        get: function () {
            return fromRect(this.i.h8);
        },
        set: function (v) {
            this.i.h8 = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "viewport", {
        /**
         * Gets a rectangle representing the bounds of the plot area.
        *
        * `viewport` property representing the bounds of the plot area.
        *
        * ```ts
        * let viewport:Rect =  this.chart.viewport;
        * ```
        */
        get: function () {
            return fromRect(this.i.h7);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "chartTitle", {
        /**
         * Gets or sets text to display above the plot area.
        *
        * Use the `chartTitle` property to display the text above the plot area.
        *
        * ```ts
        *  this.chart.title= "This is a Title";
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	title= "CategoryChart Subtitle"	/>
        * ```
        */
        get: function () {
            return this.i.fd;
        },
        set: function (v) {
            this.i.fd = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitle", {
        /**
         * Gets or sets text to display below the Title, above the plot area.
        *
        * Use the `subtitle` property to display the text below  and above the plot area.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"/>
        * ```
        *
        * ```ts
        *  this.chart.subtitle ="CategoryChart Subtitle" ;
        * ```
        */
        get: function () {
            return this.i.e2;
        },
        set: function (v) {
            this.i.e2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "titleAlignment", {
        /**
         * Gets or sets horizontal alignment which determines the title position, relative to the left and right edges of the control.
        *
        * Use the `titleAlignment` property for the horizontal alignment of the title.
        *
        * ```ts
        * this.chart.titleAlignment = HorizontalAlignment.Center;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	titleAlignment= "Center"/>
        * ```
        */
        get: function () {
            return this.i.hw;
        },
        set: function (v) {
            this.i.hw = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "subtitleAlignment", {
        /**
         * Gets or sets horizontal alignment which determines the subtitle position, relative to the left and right edges of the control.
        *
        * Use the `subtitleAlignment` property to Gets or sets horizontal alignment.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	dataSource={this.categoryData}
        * 	subtitle= "CategoryChart Subtitle"
        * 	subtitleAlignment="Right"/>
        * ```
        *
        * ```ts
        * this.chart.subtitleAlignment = HorizontalAlignment.Right;
        * ```
        */
        get: function () {
            return this.i.hv;
        },
        set: function (v) {
            this.i.hv = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "unknownValuePlotting", {
        /**
         * Gets or sets the behavior that determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        *
        * Use the `unknownValuePlotting` property to determines the behavior that how unknown values will be plotted on the chart.
        *
        * ```ts
        * this.chart.unknownValuePlotting =UnknownValuePlotting.DontPlot;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                unknownValuePlotting= "dontPlot" />
        * ```
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "resolution", {
        /**
         * Gets or sets the rendering resolution for all series in this chart.
         * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
        *
        * Use the `resolution` property if the callouts should be display.
        *
        * ```ts
        *   this.chart.resolution = 2 ;
        * ```
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	calloutsVisible="true"
        * 	resolution= {2}/>
        * ```
        */
        get: function () {
            return this.i.cu;
        },
        set: function (v) {
            this.i.cu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "thickness", {
        /**
         * Gets or sets the thickness for all series in this chart. Depending on the ChartType, this can be the main brush used, or just the outline.
        *
        * Use the `thickness` property for the thickness of all the series in this chart.
        */
        get: function () {
            return this.i.c0;
        },
        set: function (v) {
            this.i.c0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "markerTypes", {
        /**
         * Gets or sets the marker shapes used for indicating location of data points in this chart.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        */
        get: function () {
            if (this._markerTypes === null) {
                var coll = new IgrMarkerTypeCollection();
                var innerColl = this.i.ak;
                if (!innerColl) {
                    innerColl = new MarkerTypeCollection();
                }
                this._markerTypes = coll._fromInner(innerColl);
                this.i.ak = innerColl;
            }
            return this._markerTypes;
        },
        set: function (v) {
            if (this._markerTypes !== null) {
                this._markerTypes._setSyncTarget(null);
                this._markerTypes = null;
            }
            var coll = new IgrMarkerTypeCollection();
            this._markerTypes = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(MarkerType_$type);
            var innerColl = this.i.ak;
            if (!innerColl) {
                innerColl = new MarkerTypeCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._markerTypes._setSyncTarget(syncColl);
            this.i.ak = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "markerBrushes", {
        /**
         * Gets or sets the palette of brushes used for rendering fill area of data point markers.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        *
        * `markerBrushes` property used for rendering fill area of data point markers.
        *
        * ```ts
        *  this.chart.markerBrushes=[ "#ff0000", "#ffff00", "#00ffff" ];
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        *     chartType="Line"
        *     markerBrushes ="#ffff00"
        *     dataSource={this.categoryData}/>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.l);
        },
        set: function (v) {
            this.i.l = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "markerOutlines", {
        /**
         * Gets or sets the palette of brushes used for rendering outlines of data point markers.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        *
        * `markerOutlines` property used for rendering outlines of data point markers.
        *
        * ```ts
        * this.chart.markerOutlines= ["#ff0000", "#ffff00", "#00ffff"] ;
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	chartType="Line"
        * 	markerOutlines= "#ff0000"
        * 	dataSource={this.categoryData}/>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.m);
        },
        set: function (v) {
            this.i.m = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "markerMaxCount", {
        /**
         * Gets or sets the maximum number of markers displyed in the plot area of the chart.
        *
        * `markerMaxCount` property used to display maximum number of markers in the plot area of the chart.
        *
        * ```ts
        *  this.chart.markerMaxCount = 100 ;
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	chartType="Line"
        * 	markerMaxCount= {2}
        * 	dataSource={this.categoryData}/>
        * ```
        */
        get: function () {
            return this.i.dd;
        },
        set: function (v) {
            this.i.dd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "animateSeriesWhenAxisRangeChanges", {
        /**
         * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "trendLineBrushes", {
        /**
         * Gets or sets the palette of brushes to used for coloring trend lines in this chart.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        *
        * Use the `trendLineBrushes` property for coloring trend lines in the chart.
        *
        * ```ts
        * this.chart.trendLineBrushes=["#ff0000", "#ffff00", "#00ffff"]	;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                trendLineBrushes="#ffff00" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.o);
        },
        set: function (v) {
            this.i.o = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "trendLineType", {
        /**
         * Gets or sets the formula used for calculating trend lines in this chart.
         * This property applies only to these chart types: point, line, spline, and bubble
        *
        * Use the `trendLineType` property for calculating trend lines.
        *
        * ```ts
        * this.chart.trendLineType = TrendLineType.CubicFit;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                trendLineType="CubicFit" />
        * ```
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the trend lines in this chart.
         * This property applies only to these chart types: point, line, spline, and bubble
        *
        * Use the `trendLineThickness` property for the thickness of the trend lines in the chart.
        *
        * ```ts
        * this.chart.trendLineThickness=2;
        * ```
        *
        * ```ts
        * <IgrCategoryChart dataSource={this.state.data}
        *                trendLineThickness={2} />
        * ```
        */
        get: function () {
            return this.i.c6;
        },
        set: function (v) {
            this.i.c6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "alignsGridLinesToPixels", {
        /**
         * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
        *
        * Use `alignsGridLinesToPixels` propert to indicat whether grid and tick lines are aligned to device pixels.
        *
        * ```ts
        *  this.chart.alignsGridLinesToPixels= true;
        * ```
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "trendLinePeriod", {
        get: function () {
            return this.i.df;
        },
        set: function (v) {
            this.i.df = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "toolTipType", {
        /**
         * Gets or sets the style of tooltip to be displayed.
        */
        get: function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = ensureEnum(ToolTipType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "crosshairsDisplayMode", {
        /**
         * Gets or sets the crosshairs to be displayed.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = ensureEnum(CrosshairsDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "crosshairsSnapToData", {
        /**
         * Gets or sets whether crosshairs will snap to the nearest data point.
        */
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "crosshairsAnnotationEnabled", {
        /**
         * Gets or sets whether annotations are shown along the axis for crosshair values
        */
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "finalValueAnnotationsVisible", {
        /**
         * Gets or sets whether annotations for the final value of each series is displayed on the axis.
        */
        get: function () {
            return this.i.bm;
        },
        set: function (v) {
            this.i.bm = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsVisible", {
        /**
         * Gets or sets if callouts should be displayed.
        */
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutStyleUpdatingEventEnabled", {
        /**
         * Gets or sets if event annotations should be displayed.
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsXMemberPath", {
        /**
         * Gets or sets the member path of the X data for the callouts.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsYMemberPath", {
        /**
         * Gets or sets the member path of the Y data for the callouts.
        */
        get: function () {
            return this.i.ec;
        },
        set: function (v) {
            this.i.ec = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsLabelMemberPath", {
        /**
         * Gets or sets the member path of the label data for the callouts.
        */
        get: function () {
            return this.i.d6;
        },
        set: function (v) {
            this.i.d6 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutsContentMemberPath", {
        /**
         * Gets or sets the member path of the content data for the callouts.
        */
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrDomainChart.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrDomainChart.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DomainChart");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Provides a container for this control

*
* `provideContainer` method provide container for the control.
*
* ```ts
*     this.chart.provideContainer("Container");
* ```
*/
    IgrDomainChart.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Destroy this control
    
    *
    * Use the `destroy` property to destroy the chart.
    *
    * ```ts
    * this.chart.destroy();
    * ```
    */
    IgrDomainChart.prototype.destroy = function () {
        this.i.destroy();
    };
    /**
     * Called when the control has been resized.
    
    *
    * `notifyResized` method Called when the control has been resized.
    *
    * ```ts
    * this.chart.notifyResized();
    * ```
    */
    IgrDomainChart.prototype.notifyResized = function () {
        this.i.notifyResized();
    };
    IgrDomainChart.prototype.notifyVisualPropertiesChanged = function () {
        this.i.gv();
    };
    /**
     * Forces any pending refresh to the chart to be finished.
    
    *
    * Method `flush` used to Forces any pending deferred work to render on the chart before continuing.
    *
    * ```ts
    * this.chart.flush();
    * ```
    */
    IgrDomainChart.prototype.flush = function () {
        this.i.f7();
    };
    /**
     * Hides the active main tooltip, if displayed.
    
    *
    * Use the `hideToolTip` method to hide the active tooltip.
    *
    * ```ts
    * this.chart.hideToolTip();
    * ```
    */
    IgrDomainChart.prototype.hideToolTip = function () {
        this.i.ga();
    };
    IgrDomainChart.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.gu(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    *
    * Use `notifyClearItems` method to notifies the chart that the items have been cleared from an associated data source.
    *
    * ```ts
    * this.chart.notifyClearItems(this.data);
    * ```
    */
    IgrDomainChart.prototype.notifyClearItems = function (source_) {
        this.i.gq(source_);
    };
    IgrDomainChart.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.gr(source_, index, newItem);
    };
    IgrDomainChart.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.gs(source_, index, oldItem);
    };
    Object.defineProperty(IgrDomainChart.prototype, "seriesAdded", {
        /**
         * Event raised when a series is initialized and added to this chart.
        *
        * `SeriesAdded` event raised when a series is initialized and added to this chart.
        *
        * ````ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesAdded={this.CategoryChart_SeriesAdded}/>
        * ``
        *
        * ```ts
        * CategoryChart_SeriesAdded(sender:any ,aregs:ChartSeriesEventArgs)
        * {
        * }
        * ````
        */
        get: function () {
            return this._seriesAdded;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesAdded_wrapped !== null) {
                this.i.seriesAdded = delegateRemove(this.i.seriesAdded, this._seriesAdded_wrapped);
                this._seriesAdded_wrapped = null;
                this._seriesAdded = null;
            }
            this._seriesAdded = ev;
            this._seriesAdded_wrapped = function (o, e) {
                var outerArgs = new IgrChartSeriesEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesAdded) {
                    _this.beforeSeriesAdded(_this, outerArgs);
                }
                if (_this._seriesAdded) {
                    _this._seriesAdded(_this, outerArgs);
                }
            };
            this.i.seriesAdded = delegateCombine(this.i.seriesAdded, this._seriesAdded_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesRemoved", {
        /**
         * Event raised when a series is removed from this chart.
        *
        * `SeriesRemoved` event raised when a series is removed from this chart.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesRemoved={this.CategoryChart_seriesRemoved}/>
        * ```
        *
        * ```ts
        *  CategoryChart_seriesRemoved(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ```
        */
        get: function () {
            return this._seriesRemoved;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesRemoved_wrapped !== null) {
                this.i.seriesRemoved = delegateRemove(this.i.seriesRemoved, this._seriesRemoved_wrapped);
                this._seriesRemoved_wrapped = null;
                this._seriesRemoved = null;
            }
            this._seriesRemoved = ev;
            this._seriesRemoved_wrapped = function (o, e) {
                var outerArgs = new IgrChartSeriesEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesRemoved) {
                    _this.beforeSeriesRemoved(_this, outerArgs);
                }
                if (_this._seriesRemoved) {
                    _this._seriesRemoved(_this, outerArgs);
                }
            };
            this.i.seriesRemoved = delegateCombine(this.i.seriesRemoved, this._seriesRemoved_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesPointerEnter", {
        /**
         * Occurs when the pointer enters a Series.
        *
        * `SeriesPointerEnter` event raised when the pointer enters a Series.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesPointerEnter={this.CategoryChart_seriesPointerDown}/>
        * ```
        *
        * ```ts
        * CategoryChart_seriesPointerEnter(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ```
        */
        get: function () {
            return this._seriesPointerEnter;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesPointerEnter_wrapped !== null) {
                this.i.seriesPointerEnter = delegateRemove(this.i.seriesPointerEnter, this._seriesPointerEnter_wrapped);
                this._seriesPointerEnter_wrapped = null;
                this._seriesPointerEnter = null;
            }
            this._seriesPointerEnter = ev;
            this._seriesPointerEnter_wrapped = function (o, e) {
                var outerArgs = new IgrDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesPointerEnter) {
                    _this.beforeSeriesPointerEnter(_this, outerArgs);
                }
                if (_this._seriesPointerEnter) {
                    _this._seriesPointerEnter(_this, outerArgs);
                }
            };
            this.i.seriesPointerEnter = delegateCombine(this.i.seriesPointerEnter, this._seriesPointerEnter_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesPointerLeave", {
        /**
         * Occurs when the pointer leaves a Series.
        *
        * `SeriesPointerLeave` event raised when the pointer leaves a Series.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesPointerLeave={this.CategoryChart_seriesPointerLeave}/>
        * ```
        *
        * ```ts
        * CategoryChart_seriesPointerLeave(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ```
        */
        get: function () {
            return this._seriesPointerLeave;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesPointerLeave_wrapped !== null) {
                this.i.seriesPointerLeave = delegateRemove(this.i.seriesPointerLeave, this._seriesPointerLeave_wrapped);
                this._seriesPointerLeave_wrapped = null;
                this._seriesPointerLeave = null;
            }
            this._seriesPointerLeave = ev;
            this._seriesPointerLeave_wrapped = function (o, e) {
                var outerArgs = new IgrDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesPointerLeave) {
                    _this.beforeSeriesPointerLeave(_this, outerArgs);
                }
                if (_this._seriesPointerLeave) {
                    _this._seriesPointerLeave(_this, outerArgs);
                }
            };
            this.i.seriesPointerLeave = delegateCombine(this.i.seriesPointerLeave, this._seriesPointerLeave_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesPointerMove", {
        /**
         * Occurs when the pointer moves over a Series.
        *
        * `SeriesPointerMove` event raised when the pointer moves over a Series.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesPointerMove={this.CategoryChart_seriesPointerMove}/>
        * ```
        *
        * ```ts
        *  CategoryChart_seriesPointerMove(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ```
        */
        get: function () {
            return this._seriesPointerMove;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesPointerMove_wrapped !== null) {
                this.i.seriesPointerMove = delegateRemove(this.i.seriesPointerMove, this._seriesPointerMove_wrapped);
                this._seriesPointerMove_wrapped = null;
                this._seriesPointerMove = null;
            }
            this._seriesPointerMove = ev;
            this._seriesPointerMove_wrapped = function (o, e) {
                var outerArgs = new IgrDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesPointerMove) {
                    _this.beforeSeriesPointerMove(_this, outerArgs);
                }
                if (_this._seriesPointerMove) {
                    _this._seriesPointerMove(_this, outerArgs);
                }
            };
            this.i.seriesPointerMove = delegateCombine(this.i.seriesPointerMove, this._seriesPointerMove_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesPointerDown", {
        /**
         * Occurs when the pointer is pressed down over a Series.
        *
        * `SeriesPointerDown` event raised when the pointer is pressed down over a Series
        *
        * ````ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesPointerDown={this.CategoryChart_seriesPointerDown}/>
        * ``
        *
        * ```ts
        * CategoryChart_seriesPointerDown(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ````
        */
        get: function () {
            return this._seriesPointerDown;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesPointerDown_wrapped !== null) {
                this.i.seriesPointerDown = delegateRemove(this.i.seriesPointerDown, this._seriesPointerDown_wrapped);
                this._seriesPointerDown_wrapped = null;
                this._seriesPointerDown = null;
            }
            this._seriesPointerDown = ev;
            this._seriesPointerDown_wrapped = function (o, e) {
                var outerArgs = new IgrDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesPointerDown) {
                    _this.beforeSeriesPointerDown(_this, outerArgs);
                }
                if (_this._seriesPointerDown) {
                    _this._seriesPointerDown(_this, outerArgs);
                }
            };
            this.i.seriesPointerDown = delegateCombine(this.i.seriesPointerDown, this._seriesPointerDown_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "seriesPointerUp", {
        /**
         * Occurs when the pointer is released over a Series.
        *
        * `SeriesPointerUp` event raised when the pointer is released over a Series.
        *
        * ```ts
        *  <IgrCategoryChart
        * 	width="100%"
        * 	height="100%"
        * 	chartType="Line"
        * 	markerTypes={this.state.markersTypes}
        * 	dataSource={this.categoryData}
        * 	seriesPointerUp={this.CategoryChart_seriesPointerUp}/>
        * ```
        *
        * ```ts
        *  CategoryChart_seriesPointerUp(sender: any , aregs: ChartSeriesEventArgs)
        *   {
        *
        *   }
        * ```
        */
        get: function () {
            return this._seriesPointerUp;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesPointerUp_wrapped !== null) {
                this.i.seriesPointerUp = delegateRemove(this.i.seriesPointerUp, this._seriesPointerUp_wrapped);
                this._seriesPointerUp_wrapped = null;
                this._seriesPointerUp = null;
            }
            this._seriesPointerUp = ev;
            this._seriesPointerUp_wrapped = function (o, e) {
                var outerArgs = new IgrDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesPointerUp) {
                    _this.beforeSeriesPointerUp(_this, outerArgs);
                }
                if (_this._seriesPointerUp) {
                    _this._seriesPointerUp(_this, outerArgs);
                }
            };
            this.i.seriesPointerUp = delegateCombine(this.i.seriesPointerUp, this._seriesPointerUp_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDomainChart.prototype, "calloutStyleUpdating", {
        /**
         * Occurs when the style of a callout is updated.
        */
        get: function () {
            return this._calloutStyleUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._calloutStyleUpdating_wrapped !== null) {
                this.i.calloutStyleUpdating = delegateRemove(this.i.calloutStyleUpdating, this._calloutStyleUpdating_wrapped);
                this._calloutStyleUpdating_wrapped = null;
                this._calloutStyleUpdating = null;
            }
            this._calloutStyleUpdating = ev;
            this._calloutStyleUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrCalloutStyleUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCalloutStyleUpdating) {
                    _this.beforeCalloutStyleUpdating(_this, outerArgs);
                }
                if (_this._calloutStyleUpdating) {
                    _this._calloutStyleUpdating(_this, outerArgs);
                }
            };
            this.i.calloutStyleUpdating = delegateCombine(this.i.calloutStyleUpdating, this._calloutStyleUpdating_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrDomainChart;
}(Component));

/**
 * Represents a base class for domain charts with X/Y axes
*/
var IgrXYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrXYChart, _super);
    function IgrXYChart(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrXYChart.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisFormatLabel", {
        /**
         * Gets or sets function which takes an context object and returns a formatted label for the X-axis.
        *
        * To customize the text of the x-axis label, set `xAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be your data item.
        *
        * ```ts
        * formatX(item: any): string {
        *     return "[ " + item.label + "! ]";
        * }
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisFormatLabel="formatX"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.id;
        },
        set: function (v) {
            this.i.id = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisFormatLabel", {
        /**
         * Gets or sets function which takes a context object and returns a formatted label for the Y-axis.
        *
        * To customize the text of the y-axis label, set `yAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be the numeric value corresponding to a position on the y-axis.
        *
        * ```ts
        * formatY(value: any): string {
        *     return "[ " + value+ "! ]";
        * }
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisFormatLabel="formatY"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ie;
        },
        set: function (v) {
            this.i.ie = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelLeftMargin", {
        /**
         * Gets or sets the left margin of labels on the X-axis
        *
        * Use the `xAxisLabelLeftMargin` property to apply a margin left of the x-axis labels.
        *
        * ```ts
        * this.chart.xAxisLabelLeftMargin ="100";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisLabelLeftMargin={100}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.js;
        },
        set: function (v) {
            this.i.js = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelTopMargin", {
        /**
         * Gets or sets the top margin of labels on the X-axis
        *
        * Use the `xAxisLabelTopMargin` property to apply a margin above the x-axis labels.
        *
        * ```ts
        * this.chart.xAxisTitleTopMargin="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleTopMargin	={250}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ju;
        },
        set: function (v) {
            this.i.ju = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelRightMargin", {
        /**
         * Gets or sets the right margin of labels on the X-axis
        *
        * Use the `xAxisLabelRightMargin` property to apply a margin right of the x-axis labels.
        *
        * ```ts
        * this.chart.xAxisLabelRightMargin="100";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisLabelRightMargin={250}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jt;
        },
        set: function (v) {
            this.i.jt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelBottomMargin", {
        /**
         * Gets or sets the bottom margin of labels on the X-axis
        *
        * Use the `xAxisLabelBottomMargin` property to apply a margin below the x-axis labels.
        *
        * ```ts
        * this.chart.xAxisLabelBottomMargin ="100";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisLabelBottomMargin={100}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jr;
        },
        set: function (v) {
            this.i.jr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelLeftMargin", {
        /**
         * Gets or sets the left margin of labels on the Y-axis
        *
        * Use the `yAxisLabelLeftMargin` property to apply a margin left of the y-axis labels.
        *
        * ```ts
        * this.chart. yAxisLabelLeftMargin="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 yAxisLabelLeftMargin={250}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j9;
        },
        set: function (v) {
            this.i.j9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelTopMargin", {
        /**
         * Gets or sets the top margin of labels on the Y-axis
        *
        * Use the `yAxisLabelTopMargin` property to apply a margin above the y-axis labels.
        *
        * ```ts
        * this.chart.yAxisLabelTopMargin="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelTopMargin	={250}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kb;
        },
        set: function (v) {
            this.i.kb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelRightMargin", {
        /**
         * Gets or sets the right margin of labels on the Y-axis
        *
        * Use the `yAxisLabelRightMargin` property to apply a margin right of the y-axis labels.
        *
        * ```ts
        * this.chart.yAxisLabelRightMargin="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelRightMargin={250}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ka;
        },
        set: function (v) {
            this.i.ka = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelBottomMargin", {
        /**
         * Gets or sets the bottom margin of labels on the Y-axis
        *
        * Use the `yAxisLabelBottomMargin` property to apply a margin below the y-axis labels.
        *
        * ```ts
        * this.chart.yAxisLabelBottomMargin="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelBottomMargin={250}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j8;
        },
        set: function (v) {
            this.i.j8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelTextColor", {
        /**
         * Gets or sets color of labels on the X-axis
        *
        * To change the color of x-axis labels, set the `xAxisLabelTextColor` property to a color string.
        *
        * ```ts
        * this.chart.xAxisLabelTextColor="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisLabelTextColor="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.nz);
        },
        set: function (v) {
            this.i.nz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelTextColor", {
        /**
         * Gets or sets color of labels on the Y-axis
        *
        * To change the color of y-axis labels, set the `yAxisLabelTextColor` property to a color string.
        *
        * ```ts
        * this.chart.yAxisLabelTextColor="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelTextColor="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n6);
        },
        set: function (v) {
            this.i.n6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleMargin", {
        /**
         * Gets or sets the margin around a title on the X-axis
        *
        * Use the `xAxisTitleMargin` property to set a margin around the y-axis title.
        */
        get: function () {
            return this.i.j3;
        },
        set: function (v) {
            this.i.j3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleMargin", {
        /**
         * Gets or sets the margin around a title on the Y-axis
        *
        * Use the `yAxisTitleMargin` property to set a margin around the y-axis title.
        */
        get: function () {
            return this.i.kk;
        },
        set: function (v) {
            this.i.kk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleLeftMargin", {
        /**
         * Gets or sets the left margin of a title on the X-axis
        *
        * Use the `xAxisTitleLeftMargin` property to apply a margin left of the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleLeftMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleLeftMargin={150}
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j2;
        },
        set: function (v) {
            this.i.j2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleLeftMargin", {
        /**
         * Gets or sets the left margin of a title on the Y-axis
        *
        * Use the `yAxisTitleLeftMargin` property to apply a margin left of the y-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleLeftMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleLeftMargin={150}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kj;
        },
        set: function (v) {
            this.i.kj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleTopMargin", {
        /**
         * Gets or sets the top margin of a title on the X-axis
        *
        * Use the `xAxisTitleTopMargin` property to apply a margin above the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleTopMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleTopMargin	={150}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j5;
        },
        set: function (v) {
            this.i.j5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleTopMargin", {
        /**
         * Gets or sets the top margin of a title on the Y-axis
        *
        * Use the `yAxisTitleTopMargin` property to apply a margin above the y-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleTopMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleTopMargin	={150}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.km;
        },
        set: function (v) {
            this.i.km = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleRightMargin", {
        /**
         * Gets or sets the right margin of a title on the X-axis
        *
        * Use the `xAxisTitleRightMargin` property to apply a margin right of the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleRightMargin="100";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleRightMargin="100"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j4;
        },
        set: function (v) {
            this.i.j4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleRightMargin", {
        /**
         * Gets or sets the right margin of a title on the Y-axis
        *
        * Use the `yAxisTitleRightMargin` property to apply a margin right of the y-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleRightMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleRightMargin={150}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kl;
        },
        set: function (v) {
            this.i.kl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleBottomMargin", {
        /**
         * Gets or sets the bottom margin of a title on the X-axis
        *
        * Use the `xAxisTitleBottomMargin` property to apply a margin below the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleBottomMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleBottomMargin={250}
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j1;
        },
        set: function (v) {
            this.i.j1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleBottomMargin", {
        /**
         * Gets or sets the bottom margin of a title on the Y-axis
        *
        * Use the `yAxisTitleBottomMargin` property to apply a margin below the y-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleBottomMargin="150";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleBottomMargin	={150}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ki;
        },
        set: function (v) {
            this.i.ki = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleTextColor", {
        /**
         * Gets or sets color of title on the X-axis
        *
        * To change the color of the x-axis title, set the `xAxisTitleTextColor` property to a color string.
        *
        * ```ts
        * this.chart.xAxisTitleTextColor="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisTitleTextColor="green"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n5);
        },
        set: function (v) {
            this.i.n5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleTextColor", {
        /**
         * Gets or sets color of title on the Y-axis
        *
        * To change the color of the y-axis title, set the `yAxisTitleTextColor` property to a color string.
        *
        * ```ts
        * this.chart.yAxisTitleTextColor="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleTextColor="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.oc);
        },
        set: function (v) {
            this.i.oc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelTextStyle", {
        /**
         * Gets or sets CSS font property for labels on X-axis
        *
        * To change the font of x-axis labels, set the `xAxisLabelTextStyle` property.
        *
        * ```ts
        * this.chart.xAxisLabelTextStyle="italic 15px arial, sans-serif";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisLabelTextStyle="italic 15px arial, sans-serif"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.k8;
        },
        set: function (v) {
            this.i.k8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelTextStyle", {
        /**
         * Gets or sets CSS font property for labels on Y-axis
        *
        * To change the font of x-axis labels, set the `yAxisLabelTextStyle` property.
        *
        * ```ts
        * this.chart. yAxisLabelTextStyle="italic 15px arial, sans-serif";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 yAxisLabelTextStyle="italic 15px arial, sans-serif"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ma;
        },
        set: function (v) {
            this.i.ma = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleTextStyle", {
        /**
         * Gets or sets CSS font property for title on X-axis
        *
        * To change the font of the x-axis title, set the `xAxisTitleTextStyle` property.
        *
        * ```ts
        * this.chart.xAxisTitleTextStyle="italic 15px arial, sans-serif";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleTextStyle="italic 15px arial, sans-serif"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.lw;
        },
        set: function (v) {
            this.i.lw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleTextStyle", {
        /**
         * Gets or sets CSS font property for title on Y-axis
        *
        * To change the font of the x-axis title, set the `yAxisTitleTextStyle` property.
        *
        * ```ts
        * this.chart.yAxisTitleTextStyle="italic 15px arial, sans-serif";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleTextStyle="italic 15px arial, sans-serif"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.my;
        },
        set: function (v) {
            this.i.my = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabel", {
        /**
         * Gets or sets the format for labels along the X-axis.
        */
        get: function () {
            return this.i.kp;
        },
        set: function (v) {
            this.i.kp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabel", {
        /**
         * Gets or sets the property or string from which the labels are derived.
        */
        get: function () {
            return this.i.kq;
        },
        set: function (v) {
            this.i.kq = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisMajorStroke", {
        /**
         * Gets or sets the color to apply to major gridlines along the X-axis.
        *
        * Set `xAxisMajorStroke` to control the color of major gridlines extending vertically from the x-axis.
        *
        * ```ts
        * this.chart.xAxisMajorStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisMajorStroke="green"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n0);
        },
        set: function (v) {
            this.i.n0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisMajorStroke", {
        /**
         * Gets or sets the color to apply to major gridlines along the Y-axis.
        *
        * Set `yAxisMajorStroke` to control the color of major gridlines extending horizontally from the y-axis.
        *
        * ```ts
        * this.chart.yAxisMajorStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        *     yAxisMajorStroke="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n7);
        },
        set: function (v) {
            this.i.n7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisMajorStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to major gridlines along the X-axis.
        *
        * Set `xAxisMajorStrokeThickness` to control the thickness of major gridlines extending vertically from the x-axis.
        *
        * ```ts
        * this.chart.xAxisMajorStrokeThickness="3" ;
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisMajorStrokeThickness="3"
        * 	xAxisExtent	={250}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jv;
        },
        set: function (v) {
            this.i.jv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisMajorStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to major gridlines along the Y-axis.
        *
        * Set `yAxisMajorStrokeThickness` to control the thickness of major gridlines extending horizontally from the y-axis.
        *
        * ```ts
        * this.chart.yAxisMajorStrokeThickness="2";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisMajorStrokeThickness={2}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kc;
        },
        set: function (v) {
            this.i.kc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisMinorStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to minor gridlines along the X-axis.
        *
        * Set `xAxisMinorStrokeThickness` to control the thickness of minor gridlines extending vertically from the x-axis.
        *
        * ```ts
        * this.chart.xAxisMinorStrokeThickness="3";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisMinorStrokeThickness="3"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jw;
        },
        set: function (v) {
            this.i.jw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisMinorStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to minor gridlines along the Y-axis.
        *
        * Set `yAxisMinorStrokeThickness` to control the thickness of minor gridlines extending horizontally from the y-axis.
        *
        * ```ts
        * this.chart.yAxisMinorStrokeThickness="3";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisMinorStrokeThickness={3}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kd;
        },
        set: function (v) {
            this.i.kd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisStrip", {
        /**
         * Gets or sets the color to apply to stripes along the X-axis.
        *
        * Set `xAxisStrip` to control the alternating color of stripes extending vertically from the x-axis.
        *
        * ```ts
        * this.chart.xAxisStrip="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisStrip="green"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n2);
        },
        set: function (v) {
            this.i.n2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisStrip", {
        /**
         * Gets or sets the color to apply to stripes along the Y-axis.
        *
        * Set `yAxisStrip` to control the alternating color of stripes extending horizontally from the y-axis.
        *
        * ```ts
        * this.chart.yAxisStrip="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisStrip="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n9);
        },
        set: function (v) {
            this.i.n9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisStroke", {
        /**
         * Gets or sets the color to apply to the X-axis line.
        *
        * Set `xAxisStroke` to control the color of the x-axis line.
        *
        * ```ts
        * this.chart.xAxisStroke="green"";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisStroke="green"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n3);
        },
        set: function (v) {
            this.i.n3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisStroke", {
        /**
         * Gets or sets the color to apply to the Y-axis line.
        *
        * Set `yAxisStroke` to control the color of the y-axis line.
        *
        * ```ts
        * this.chart.yAxisStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisStroke="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.oa);
        },
        set: function (v) {
            this.i.oa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to the X-axis line.
        *
        * Set `xAxisStrokeThickness` to control the thickness of the x-axis line.
        *
        * ```ts
        * this.chart.xAxisStrokeThickness="2";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisStrokeThickness={2}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jx;
        },
        set: function (v) {
            this.i.jx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to the Y-axis line.
        *
        * Set `yAxisStrokeThickness` to control the thickness of the y-axis line.
        *
        * ```ts
        * this.chart. yAxisStrokeThickness="2";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 yAxisStrokeThickness={2}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ke;
        },
        set: function (v) {
            this.i.ke = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTickLength", {
        /**
         * Gets or sets the length of tickmarks along the X-axis.
        *
        * Set `xAxisTickLength` to control the length of tickmarks extending vertically from the x-axis line.
        *
        * ```ts
        * this.chart.xAxisTickLength="25";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTickLength	={25}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jy;
        },
        set: function (v) {
            this.i.jy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTickLength", {
        /**
         * Gets or sets the length of tickmarks along the Y-axis.
        *
        * Set `yAxisTickLength` to control the length of tickmarks extending horizontally from the y-axis line.
        *
        * ```ts
        * this.chart.yAxisTickLength="25";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTickLength	={25}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kf;
        },
        set: function (v) {
            this.i.kf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTickStroke", {
        /**
         * Gets or sets the color to apply to tickmarks along the X-axis.
        *
        * Set `xAxisTickStroke` to control the color of tickmarks extending vertically from the x-axis line.
        *
        * ```ts
        * this.chart. xAxisTickStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisTickStroke="green"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n4);
        },
        set: function (v) {
            this.i.n4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTickStroke", {
        /**
         * Gets or sets the color to apply to tickmarks along the Y-axis.
        *
        * Set `yAxisTickStroke` to control the color of tickmarks extending horizontally from the y-axis line.
        *
        * ```ts
        * this.chart.yAxisTickStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTickStroke="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.ob);
        },
        set: function (v) {
            this.i.ob = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTickStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to tickmarks along the X-axis.
        *
        * Set `xAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the x-axis line.
        *
        * ```ts
        * this.chart.xAxisTickStrokeThickness="20";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTickStrokeThickness={20}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jz;
        },
        set: function (v) {
            this.i.jz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTickStrokeThickness", {
        /**
         * Gets or sets the thickness to apply to tickmarks along the Y-axis.
        *
        * Set `yAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the y-axis line.
        *
        * ```ts
        * this.chart.yAxisTickStrokeThickness="25";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTickStrokeThickness	={25}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kg;
        },
        set: function (v) {
            this.i.kg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitle", {
        /**
         * Gets or sets the Text to display below the X-axis.
        *
        * Set `xAxisTitle` to display a label adjacent to the x-axis.
        *
        * ```ts
        * this.chart. xAxisTitle="x axis";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitle="x axis"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ln;
        },
        set: function (v) {
            this.i.ln = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitle", {
        /**
         * Gets or sets the Text to display to the left of the Y-axis.
        *
        * Set `yAxisTitle` to display a label adjacent to the y-axis.
        *
        * ```ts
        * this.chart.yAxisTitle="y axis";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitle="y axis"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.mp;
        },
        set: function (v) {
            this.i.mp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisMinorStroke", {
        /**
         * Gets or sets the color to apply to minor gridlines along the X-axis.
        *
        * Set `xAxisMinorStroke` to control the color of minor gridlines extending vertically from the x-axis.
        *
        * ```ts
        * this.chart.xAxisExtent="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisMinorStroke="green"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n1);
        },
        set: function (v) {
            this.i.n1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisMinorStroke", {
        /**
         * Gets or sets the color to apply to minor gridlines along the Y-axis.
        *
        * Set `yAxisMinorStroke` to control the color of minor gridlines extending horizontally from the y-axis.
        *
        * ```ts
        * this.chart.yAxisMinorStroke="green";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisMinorStroke="green"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.n8);
        },
        set: function (v) {
            this.i.n8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelAngle", {
        /**
         * Gets or sets the angle of rotation for labels along the X-axis.
        *
        * To control the rotation of labels on the x-axis, set the `xAxisLabelAngle` property to a number of rotational degrees.
        *
        * ```ts
        * this.chart.xAxisLabelAngle="45";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisLabelAngle={45}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jq;
        },
        set: function (v) {
            this.i.jq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelAngle", {
        /**
         * Gets or sets the angle of rotation for labels along the Y-axis.
        *
        * To control the rotation of labels on the y-axis, set the `yAxisLabelAngle` property to a number of rotational degrees.
        *
        * ```ts
        * this.chart.yAxisLabelAngle="25";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelAngle	={25}
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j7;
        },
        set: function (v) {
            this.i.j7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisExtent", {
        /**
         * Gets or sets the distance between the X-axis and the bottom of the chart.
        *
        * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
        *
        * ```ts
        * this.chart.xAxisExtent="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisExtent	={250}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.jp;
        },
        set: function (v) {
            this.i.jp = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisExtent", {
        /**
         * Gets or sets the distance between the Y-axis and the left edge of the chart.
        *
        * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
        *
        * ```ts
        * this.chart.xAxisExtent="250";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisExtent	={250}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j6;
        },
        set: function (v) {
            this.i.j6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleAngle", {
        /**
         * Gets or sets the angle of rotation for the X-axis title.
        *
        * Set `xAxisTitleAngle` to control the rotation of the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleAngle="50";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisTitleAngle	={50}
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.j0;
        },
        set: function (v) {
            this.i.j0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleAngle", {
        /**
         * Gets or sets the angle of rotation for the Y-axis title.
        *
        * Set `yAxisTitleAngle` to control the rotation of the y-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleAngle="25";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleAngle	={24}
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.kh;
        },
        set: function (v) {
            this.i.kh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisInverted", {
        /**
         * Gets or sets whether to invert the direction of the X-axis by placing the first data items on the right side of the chart.
        *
        * To reverse the direction of items along the x-axis, set the `xAxisInverted` property to true.
        *
        * ```ts
        * this.chart.XAxisInverted="True";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	XAxisInverted="True"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ik;
        },
        set: function (v) {
            this.i.ik = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisInverted", {
        /**
         * Gets or sets whether to invert the direction of the Y-axis by placing the minimum numeric value at the top of the chart.
        *
        * You can use `yAxisInverted` to invert the scale of the y axis like this:
        *
        * ```ts
        * this.chart.yAxisInverted="true";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 yAxisInverted="true"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        *
        * The default value of `yAxisInverted` is false.
        */
        get: function () {
            return this.i.il;
        },
        set: function (v) {
            this.i.il = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisTitleAlignment", {
        /**
         * Gets or sets Horizontal alignment of the X-axis title.
        *
        * Set `xAxisTitleAlignment` to control the horizontal alignment of the x-axis title.
        *
        * ```ts
        * this.chart.xAxisTitleAlignment="right";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisTitleAlignment="right"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.nj;
        },
        set: function (v) {
            this.i.nj = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisTitleAlignment", {
        /**
         * Gets or sets Vertical alignment of the Y-axis title.
        *
        * Set `yAxisTitleAlignment` to control the vertical alignment of the x-axis title.
        *
        * ```ts
        * this.chart.yAxisTitleAlignment="bottom";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisTitleAlignment="bottom"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.oi;
        },
        set: function (v) {
            this.i.oi = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelHorizontalAlignment", {
        /**
         * Gets or sets Horizontal alignment of X-axis labels.
        */
        get: function () {
            return this.i.ni;
        },
        set: function (v) {
            this.i.ni = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelHorizontalAlignment", {
        /**
         * Gets or sets Horizontal alignment of Y-axis labels.
        *
        * Set the `yAxisLabelHorizontalAlignment` property to change the horizontal alignment of y-axis labels.
        */
        get: function () {
            return this.i.nk;
        },
        set: function (v) {
            this.i.nk = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelVerticalAlignment", {
        /**
         * Gets or sets Vertical alignment of X-axis labels.
        *
        * Use the `xAxisLabelVerticalAlignment` property to change the vertical position of x-axis labels.
        *
        * ```ts
        * this.chart.xAxisLabelVerticalAlignment="bottom";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	xAxisLabelVerticalAlignment="bottom"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.og;
        },
        set: function (v) {
            this.i.og = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelVerticalAlignment", {
        /**
         * Gets or sets Vertical alignment of Y-axis labels.
        */
        get: function () {
            return this.i.oh;
        },
        set: function (v) {
            this.i.oh = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "xAxisLabelVisibility", {
        /**
         * Gets or sets Visibility of X-axis labels.
        *
        * To hide the x-axis labels, set `xAxisLabelVisibility` to collapsed.
        *
        * ```ts
        * this.chart.xAxisLabelVisibility="collapsed";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	 xAxisLabelVisibility="collapsed"
        * 	dataSource={this.state.data}>
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ol;
        },
        set: function (v) {
            this.i.ol = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelVisibility", {
        /**
         * Gets or sets Visibility of Y-axis labels.
        *
        * To hide the y-axis labels, set `yAxisLabelVisibility` to collapsed.
        *
        * ```ts
        * this.chart.yAxisLabelVisibility="collapsed"";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelVisibility="collapsed"
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.om;
        },
        set: function (v) {
            this.i.om = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrXYChart.prototype, "yAxisLabelLocation", {
        /**
         * The location of Y-axis labels, relative to the plot area.
        *
        * Set the `yAxisLabelLocation` property to change the location of the y-axis and its labels.
        *
        * ```ts
        * this.chart.yAxisLabelLocation="outsideRight";
        * ```
        *
        * ```ts
        * <IgrCategoryChart
        * 	yAxisLabelLocation="outsideRight"
        * 	dataSource={this.state.data} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ih;
        },
        set: function (v) {
            this.i.ih = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    IgrXYChart.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Converts the given visual location to a data value.
    
    * @param unscaledValue  * The x-coordinate of the location to scale.
    */
    IgrXYChart.prototype.getScaledValueX = function (unscaledValue) {
        var iv = this.i.jl(unscaledValue);
        return (iv);
    };
    /**
     * Converts the given data value to a visual location.
    
    * @param scaledValue  * The data value to un-scale.
    */
    IgrXYChart.prototype.getUnscaledValueX = function (scaledValue) {
        var iv = this.i.jn(scaledValue);
        return (iv);
    };
    /**
     * Converts the given visual location to a data value.
    
    * @param unscaledValue  * The y-coordinate of the location to scale.
    */
    IgrXYChart.prototype.getScaledValueY = function (unscaledValue) {
        var iv = this.i.jm(unscaledValue);
        return (iv);
    };
    /**
     * Converts the given data value to a visual location.
    
    * @param scaledValue  * The data value to un-scale.
    */
    IgrXYChart.prototype.getUnscaledValueY = function (scaledValue) {
        var iv = this.i.jo(scaledValue);
        return (iv);
    };
    return IgrXYChart;
}(IgrDomainChart));

var defaultFont = "\"Verdana\", Arial, sans-serif";
var DataChartStylingDefaults = /*@__PURE__*/ (function () {
    var DataChartStylingDefaults = {
        "ui-chart-category-axis-tick": {
            "height": "5px",
            "color": "rgba(102, 102, 102, 0.2470)"
        },
        "ui-chart-area-fill-opacity": {
            "opacity": "0.7"
        },
        "ui-chart-aligned-gridlines": {
            "visibility": "visible"
        },
        "ui-chart-axis-stroke": {
            /* transparent is treated as auto */
            "border-top-color": "transparent"
        },
        "ui-chart-axis-major-line": {
            /* transparent is treated as auto */
            "border-top-color": "transparent"
        },
        "font-family": defaultFont,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "11px",
        "color": "#666666",
        "font-variant": "",
        "line-height": "",
        "default-font-height": 13
    };
    addPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-axis", null, "rgba(102, 102, 102, 0.2470)");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-title", defaultFont, "16px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-subtitle", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-horizontal-axis-title", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-vertical-axis-title", defaultFont, "11px", "#666", "0px", "0px", "5px", "0px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-horizontal-axis-labels", defaultFont, "12px", "#666", "0px", "5px", "0px", "5px", null, "top");
    addTextThemeEntry(DataChartStylingDefaults, "ui-vertical-axis-labels", defaultFont, "12px", "#666", "5px", "0px", "5px", "0px", "right");
    addTextThemeEntry(DataChartStylingDefaults, "ui-angular-axis-labels", null, null, "#666", "5px", "5px", "5px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-radial-axis-labels", null, null, "#666", "0px", "5px", "0px", "5px", null, "top");
    addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-palette", ["#7446B9", "#9FB328", "#F96232", "#2E9CA6", "#DC3F76", "#FF9800", "#3F51B5", "#439C47", "#795548", "#9A9A9A", "#C62828", "#9f725f"], null);
    addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-marker-palette", ["#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff"], ["#7446B9", "#9FB328", "#F96232", "#2E9CA6", "#DC3F76", "#FF9800", "#3F51B5", "#439C47", "#795548", "#9A9A9A", "#C62828", "#9f725f"]);
    return DataChartStylingDefaults;
})();

/**
 * Represents a IgxDataChartComponent category X axis.
*
* `IgrCategoryXAxis` class represents a IgxDataChartComponent category X axis.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrLineSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.columnSeries1 = new IgrLineSeries({ name: "Series1" });
* this.columnSeries1.dataSource = this.categoryData;
* this.columnSeries1.xAxis = this.categoryXAxis;
* this.columnSeries1.yAxis = this.numericYAxis;
* this.columnSeries1.xAxisName = "categoryXAxis";
* this.columnSeries1.yAxisName = "numericYAxis";
* this.columnSeries1.valueMemberPath = "USA";
* ```
*/
var IgrCategoryXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryXAxis, _super);
    function IgrCategoryXAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryXAxis.prototype.createImplementation = function () {
        return new CategoryXAxis();
    };
    Object.defineProperty(IgrCategoryXAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryXAxis.prototype, "interval", {
        /**
         * Gets or sets the frequency of displayed labels.
         * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        *
        * `interval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" interval="3" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.k6;
        },
        set: function (v) {
            this.i.k6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryXAxis.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        *
        * ```ts
        * let effectiveInterval: number = xAxis.actualInterval;
        * ```
        */
        get: function () {
            return this.i.k1;
        },
        set: function (v) {
            this.i.k1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryXAxis.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        *
        * `minorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
        *
        * `minorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `minorInterval` to 0.1.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis"
        * 		minorInterval={0.1}
        * 		minorStroke="green"
        * 		minorStrokeThickness={1} />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        * 		name="series1"
        * 		xAxisName="xAxis"
        * 		yAxisName="yAxis"
        * 		valueMemberPath="value"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.k7;
        },
        set: function (v) {
            this.i.k7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryXAxis.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        *
        * ```ts
        * let effectiveMinorInterval: number = xAxis.actualMinorInterval;
        * ```
        */
        get: function () {
            return this.i.k2;
        },
        set: function (v) {
            this.i.k2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Scrolls the specified item into view.
    
    * @param item  * Data item to scroll into view
    */
    IgrCategoryXAxis.prototype.scrollIntoView = function (item) {
        this.i.lg(item);
    };
    IgrCategoryXAxis.prototype.scrollRangeIntoView = function (minimum, maximum) {
        this.i.lh(minimum, maximum);
    };
    return IgrCategoryXAxis;
}(IgrCategoryAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgxCategoryChartComponent_PROVIDERS = [];
/**
 * Represents a chart with an ordinal X-axis and a numeric Y-axis.
*
* **Ignite UI for React Category Chart** - [Documentation](https://www.infragistics.com/products/ignite-ui-react/react/components/CategoryChart.html)
*
* The Ignite UI Category Chart is a lightweight, highly performant chart. It can be easily configured to display category data using an extremely simple and intuitive API. All you need to do is provide your data to the chart and it will take care of everything else.
*
* Example:
*
* ```ts
* <IgrCategoryChart
* 	dataSource={this.state.data} />
* ```
*/
var IgrCategoryChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryChart, _super);
    function IgrCategoryChart(props) {
        var _this = _super.call(this, props) || this;
        _this._dataSource = null;
        _this._defaultTooltips = null;
        _this._uniqueTooltipId = 0;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._tooltipRef = _this._tooltipRef.bind(_this);
        _this._activeTooltipElements = new Map();
        _this._activeTooltips = new Map();
        _this._currentTooltips = [];
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
        }
        var root;
        root = _this._container;
        if (_this._container != null) {
            root = _this._container;
        }
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this._wrapper = ren;
        var chart = _this.i;
        _this._chart = chart;
        if (chart.xAxis) {
            var x = new IgrCategoryXAxis(null);
            x._provideRenderer(ren);
            x._implementation = chart.xAxis;
            chart.xAxis.externalObject = x;
        }
        if (chart.yAxis) {
            var y = new IgrNumericYAxis(null);
            y._provideRenderer(ren);
            y._implementation = chart.yAxis;
            chart.yAxis.externalObject = y;
        }
        chart.provideContainer(ren);
        _this.bindData();
        chart.notifyResized();
        ren.addSizeWatcher(function () {
            _this._chart.notifyResized();
        });
        _this._initialized = true;
        return _this;
    }
    Object.defineProperty(IgrCategoryChart.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.width = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryChart.prototype._tooltipRef = function (t) {
        //console.log(t);
        if (t === null) {
            return;
        }
        if (t.currentOwner &&
            t.currentOwner.tooltipTemplate) {
            t.template = t.currentOwner.tooltipTemplate;
        }
        this._activeTooltips.set(t.currentOwner, t);
    };
    IgrCategoryChart.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrCategoryChart.prototype.render = function () {
        // if (!this._childrenDiffer(this.props.children)) {
        // 	let div = React.createElement("div", {
        // 		ref: (ref) => {
        // 			this._elRef = ref;
        // 		},
        // 		children: this.props.children
        // 	});
        // 	return div;
        // } else {
        var children = [];
        if (this._currentTooltips && this._currentTooltips.length > 0) {
            for (var i = 0; i < this._currentTooltips.length; i++) {
                var t = this._currentTooltips[i];
                if (this._activeTooltipElements.has(t)) {
                    children.push(this._activeTooltipElements.get(t));
                }
                else {
                    if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
                        continue;
                    }
                    var Tooltip = TypeRegistrar.get("IgrTooltipContainer");
                    var tEle = createElement(Tooltip, {
                        ref: this._tooltipRef,
                        key: this._currentTooltips[i].key,
                        owner: this._currentTooltips[i]
                    });
                    var portal = createPortal(tEle, t, this._currentTooltips[i].key);
                    this._activeTooltipElements.set(t, portal);
                    children.push(portal);
                }
            }
        }
        var div = createElement("div", {
            className: "ig-category-chart igr-category-chart",
            ref: this._getMainRef,
            children: children
        });
        return div;
        //}
    };
    IgrCategoryChart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container);
        this._chart.notifyResized();
        this.initializeContent();
    };
    IgrCategoryChart.prototype.componentWillUnmount = function () {
        this._chart.destroy();
        this._wrapper.destroy();
    };
    IgrCategoryChart.prototype.createImplementation = function () {
        return new CategoryChart();
    };
    Object.defineProperty(IgrCategoryChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryChart.prototype.createSeriesComponent = function (type) {
        if (TypeRegistrar.isRegistered(type)) {
            var s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this._wrapper);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    };
    IgrCategoryChart.prototype.createSeries = function (type) {
        switch (type) {
            case DataSeriesType.Area:
                return this.createSeriesComponent('IgrAreaSeries');
            case DataSeriesType.Column:
                return this.createSeriesComponent('IgrColumnSeries');
            case DataSeriesType.Line:
                return this.createSeriesComponent('IgrLineSeries');
            case DataSeriesType.Point:
                return this.createSeriesComponent('IgrPointSeries');
            case DataSeriesType.Spline:
                return this.createSeriesComponent('IgrSplineSeries');
            case DataSeriesType.SplineArea:
                return this.createSeriesComponent('IgrSplineAreaSeries');
            case DataSeriesType.StepArea:
                return this.createSeriesComponent('IgrStepAreaSeries');
            case DataSeriesType.StepLine:
                return this.createSeriesComponent('IgrStepLineSeries');
            case DataSeriesType.Waterfall:
                return this.createSeriesComponent('IgrWaterfallSeries');
            case DataSeriesType.ItemToolTipLayer:
                return this.createSeriesComponent('IgrItemToolTipLayer');
            case DataSeriesType.CategoryToolTipLayer:
                return this.createSeriesComponent('IgrCategoryToolTipLayer');
            case DataSeriesType.CrosshairLayer:
                return this.createSeriesComponent('IgrCrosshairLayer');
            case DataSeriesType.FinalValueLayer:
                return this.createSeriesComponent('IgrFinalValueLayer');
            case DataSeriesType.CalloutLayer:
                return this.createSeriesComponent('IgrCalloutLayer');
            case DataSeriesType.CategoryHighlightLayer:
                return this.createSeriesComponent('IgrCategoryHighlightLayer');
            case DataSeriesType.CategoryItemHighlightLayer:
                return this.createSeriesComponent('IgrCategoryItemHighlightLayer');
            default:
                return this.createSeriesComponent('IgrColumnSeries');
        }
    };
    Object.defineProperty(IgrCategoryChart.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryChart.prototype.bindData = function () {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    };
    IgrCategoryChart.prototype.initializeContent = function () {
        if (TypeRegistrar.isRegistered("IgrDataChartDefaultTooltips")) {
            var d = TypeRegistrar.create("IgrDataChartDefaultTooltips");
            this._defaultTooltips = d;
            this._onDefaultTooltipsReady(d);
            //this._container.appendChild(cr.location.nativeElement);
        }
        // supports angular themes or custom properties set in CSS 
        this._styling(this._elRef, this);
        this._chart.notifyResized();
    };
    IgrCategoryChart.prototype.createTooltip = function () {
        // if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
        // 	return null;
        // }
        // let Tooltip = TypeRegistrar.get("IgrTooltipContainer");
        var wrapper = this._wrapper.createElement("div");
        var ele = wrapper.getNativeElement();
        ele.key = "__tooltip_" + this._uniqueTooltipId;
        this._uniqueTooltipId++;
        this._currentTooltips = this._currentTooltips.slice(0);
        this._currentTooltips.push(ele);
        //let element = React.createElement(Tooltip,  );
        //let portal = ReactDOM.createPortal(element, ele);
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgrDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            if (self._activeTooltips.has(ele)) {
                var t = self._activeTooltips.get(ele);
                if (t.template === null &&
                    ele.tooltipTemplate !== null) {
                    t.template = ele.tooltipTemplate;
                }
                t.dataContext = c;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        this._updateTooltipState();
        return ele;
    };
    IgrCategoryChart.prototype._ensureTooltipCreated = function (series) {
        var _this = this;
        series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
            var wrapper = new ReactWrapper(ele, _this._wrapper);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            if (_this._activeTooltips.has(ele)) {
                var tCont = _this._activeTooltips.get(ele);
                tCont.template = ele.tooltipTemplate;
            }
            return wrapper;
        });
    };
    IgrCategoryChart.prototype._createXAxis = function () {
        var x = new IgrCategoryXAxis(null);
        x._provideRenderer(this._wrapper);
        return x.i;
    };
    IgrCategoryChart.prototype._createYAxis = function () {
        var y = new IgrNumericYAxis(null);
        y.provideRenderer(this._wrapper);
        return y.i;
    };
    IgrCategoryChart.prototype._ensureDefaultTooltip = function (series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips["ensureDefaultTooltip"](series);
    };
    IgrCategoryChart.prototype._onDefaultTooltipsReady = function (cr) {
        if (this.i.dataChart) {
            var currSeries = this.i.dataChart.series;
            for (var i = 0; i < currSeries.count; i++) {
                if (currSeries.item(i).externalObject.showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                }
            }
        }
    };
    IgrCategoryChart.prototype._updateTooltipState = function () {
        if (this._initialized) {
            this.setState({ tooltips: this._currentTooltips });
        }
    };
    Object.defineProperty(IgrCategoryChart.prototype, "transitionInDuration", {
        /**
     * Gets or sets the duration used for animating series plots when the chart is loading into view
    *
    * `transitionInDuration` controls the length of time taken by the transition-in animation.  Try setting it to 2 seconds:
    *
    * ```ts
    * <IgrCategoryChart
    * 	dataSource={this.state.data}
    * 	transitionInDuration={2000} />
    * ```
    */
        get: function () {
            return this.i.p5;
        },
        set: function (v) {
            this.i.p5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "transitionInEasingFunction", {
        /**
         * Gets or sets the easing function used for animating series plots when the chart is loading into view
         * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
        */
        get: function () {
            return this.i.o8;
        },
        set: function (v) {
            this.i.o8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "chartType", {
        /**
         * Gets or sets the type of chart series to generate from the data.
        *
        * The `chartType` property determines the type of data series to display.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	chartType="stepArea" />
        * ```
        */
        get: function () {
            return this.i.os;
        },
        set: function (v) {
            this.i.os = ensureEnum(CategoryChartType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "markerCollisionAvoidance", {
        /**
         * Gets or sets the behavior for markers in each series which are placed too close together for the current view, resulting in a collision.
        *
        * `markerCollisionAvoidance` controls the technique the chart uses to avoid overlapping markers.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	 markerCollisionAvoidance="none" />
        * ```
        */
        get: function () {
            return this.i.ou;
        },
        set: function (v) {
            this.i.ou = ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "isTransitionInEnabled", {
        /**
         * Gets or sets whether animation of series plots is enabled when the chart is loading into view
        *
        * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	 isTransitionInEnabled ="true" />
        * ```
        */
        get: function () {
            return this.i.pg;
        },
        set: function (v) {
            this.i.pg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "transitionInMode", {
        /**
         * Gets or sets the method that determines how to animate series plots when the chart is loading into view
        *
        * `transitionInMode` controls the direction of the transition-in animation.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	CategoryTransitionInMode="accordionfromRight" />
        * ```
        */
        get: function () {
            return this.i.ow;
        },
        set: function (v) {
            this.i.ow = ensureEnum(CategoryTransitionInMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "transitionInSpeedType", {
        /**
         * Gets or sets the arrival speed used for animating series plots when the chart is loading into view
        *
        * `transitionInSpeedType` controls the speed of the transition-in animation.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	 transitionInSpeedType="indexScaled" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = ensureEnum(TransitionInSpeedType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisInterval", {
        /**
         * Gets or sets the frequency of displayed labels along the X-axis.
         * Gets or sets the set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        *
        * `xAxisInterval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	xAxisInterval={3} />
        * ```
        */
        get: function () {
            return this.i.pu;
        },
        set: function (v) {
            this.i.pu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisMinorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines along the X-axis.
         * Gets or sets the set value is a factor that determines how the minor lines will be displayed.
        *
        * `xAxisMinorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
        *
        * `xAxisMinorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `xAxisMinorInterval` to 0.1.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	xAxisMinorInterval={0.1}
        *     xAxisMinorStroke="green"
        *     xAxisMinorStrokeThickness={1} />
        * ```
        */
        get: function () {
            return this.i.pv;
        },
        set: function (v) {
            this.i.pv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisGap", {
        /**
         * Gets or sets the amount of space between adjacent categories for the X-axis.
         * The gap is silently clamped to the range [0, 1] when used.
        *
        * Use the `xAxisGap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
        *
        * An `xAxisGap` of 0 allocates no space between items.  An `xAxisGap` of 1 allocates a space between items equal to the width of one item.
        *
        * To set the item spacing to 75% the width of one item, set the `xAxisGap` to 0.75, as in this code:
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	 xAxisGap={0.75} />
        * ```
        */
        get: function () {
            return this.i.pt;
        },
        set: function (v) {
            this.i.pt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisOverlap", {
        /**
         * Gets or sets the amount of overlap between adjacent categories for the X-axis.
         * Gets or sets the overlap is silently clamped to the range [-1, 1] when used.
        *
        * Use the `xAxisOverlap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
        *
        * An `xAxisOverlap` of 0 places grouped items adjacent to each other.  An `xAxisOverlap` of 1 places grouped items in the same axis space, completely overlapping.  An `xAxisOverlap` of -1 places a space between grouped items equal to the width of one item.
        *
        * To place grouped items with 75% overlap, set the `xAxisOverlap` to 0.75, as in this code:
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	xAxisOverlap={0} />
        * ```
        */
        get: function () {
            return this.i.pw;
        },
        set: function (v) {
            this.i.pw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisInterval", {
        /**
         * Gets or sets the distance between each label and grid line along the Y-axis.
        *
        * `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisInterval={10} />
        * ```
        */
        get: function () {
            return this.i.pz;
        },
        set: function (v) {
            this.i.pz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisIsLogarithmic", {
        /**
         * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
         * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
        *
        * Set `yAxisIsLogarithmic` to true if you want the y-axis to be a logarithmic scale.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisIsLogarithmic="true" />
        * ```
        */
        get: function () {
            return this.i.pi;
        },
        set: function (v) {
            this.i.pi = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisLogarithmBase", {
        /**
         * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
         * This property is effective only when YAxisIsLogarithmic is true.
        *
        * When `yAxisIsLogarithmic` is true, `yAxisLogarithmBase` sets the logarithm base of the y-axis scale.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisIsLogarithmic="true"
        *     yAxisLogarithmBase={2} />
        * ```
        */
        get: function () {
            return this.i.p6;
        },
        set: function (v) {
            this.i.p6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisMinimumValue", {
        /**
         * Gets or sets the data value corresponding to the minimum value of the Y-axis.
        *
        * `yAxisMaximumValue` determines the minimum of the y-axis.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisMinimumValue={42} />
        * ```
        */
        get: function () {
            return this.i.p1;
        },
        set: function (v) {
            this.i.p1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisMaximumValue", {
        /**
         * Gets or sets the data value corresponding to the maximum value of the Y-axis.
        *
        * `yAxisMaximumValue` determines the maximum of the y-axis.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisMaximumValue={150} />
        * ```
        */
        get: function () {
            return this.i.p0;
        },
        set: function (v) {
            this.i.p0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisMinorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines along the Y-axis.
        *
        * `yAxisMinorInterval` determines how often to show a minor gridline along the y-axis.  Set this property to a number less than the y-axis interval.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisMinorInterval={2}
        *     yAxisMinorStroke="green"
        *     yAxisMinorStrokeThickness={1} >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.p2;
        },
        set: function (v) {
            this.i.p2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisActualMinimum", {
        /**
         * Gets the current minimum value for the X-axis.
        */
        get: function () {
            return this.i.ps;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "xAxisActualMaximum", {
        /**
         * Gets the current maximum value for the X-axis.
        */
        get: function () {
            return this.i.pr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisActualMinimum", {
        /**
         * Gets the current minimum value for the Y-axis.
        */
        get: function () {
            return this.i.py;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisActualMaximum", {
        /**
         * Gets the current maximum value for the Y-axis.
        */
        get: function () {
            return this.i.px;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "negativeBrushes", {
        /**
         * Gets or sets the palette used for coloring negative items of Waterfall chart type.
        *
        * `negativeBrushes` controls the brushes used by the chart for negative data, when the `chartType` is one that supports negative brushes.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	negativeBrushes="#ff0000, #cc0000, #aa0000" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.op);
        },
        set: function (v) {
            this.i.op = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "negativeOutlines", {
        /**
         * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
        *
        * `negativeOutlines` controls the outlines used by the chart for negative data, when the `chartType` is one that supports negative brushes.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	negativeOutlines="#0000ff, #0000cc, #0000aa" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.oq);
        },
        set: function (v) {
            this.i.oq = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "yAxisAbbreviateLargeNumbers", {
        /**
         * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
        *
        * To abbreviate on the y-axis using formats like "1K" or "1M," set `yAxisAbbreviateLargeNumbers` to true.
        *
        * ```ts
        * <IgrCategoryChart
        * 	dataSource={this.state.data}
        * 	yAxisAbbreviateLargeNumbers="true" >
        * </IgrCategoryChart>
        * ```
        */
        get: function () {
            return this.i.ph;
        },
        set: function (v) {
            this.i.ph = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "isCategoryHighlightingEnabled", {
        /**
         * Gets or sets whether the category should be highlighted when hovered
        */
        get: function () {
            return this.i.pe;
        },
        set: function (v) {
            this.i.pe = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryChart.prototype, "isItemHighlightingEnabled", {
        /**
         * Gets or sets whether the item should be highlighted when hovered
        */
        get: function () {
            return this.i.pf;
        },
        set: function (v) {
            this.i.pf = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Export serialized visual data.

*/
    IgrCategoryChart.prototype.exportSerializedVisualData = function () {
        var iv = this.i.p8();
        return (iv);
    };
    return IgrCategoryChart;
}(IgrXYChart));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryXAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryXAxisModule() {
    }
    IgrCategoryXAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrCategoryXAxis", IgrCategoryXAxis);
        TypeRegistrar.register("CategoryXAxis", CategoryXAxis.$type);
    };
    return IgrCategoryXAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNumericYAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNumericYAxisModule() {
    }
    IgrNumericYAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrNumericYAxis", IgrNumericYAxis);
        TypeRegistrar.register("NumericYAxis", NumericYAxis.$type);
    };
    return IgrNumericYAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryChartCoreModule() {
    }
    IgrCategoryChartCoreModule.register = function () {
        TypeRegistrar.registerCons('IgrCategoryChart', IgrCategoryChart);
        IgrCategoryXAxisModule.register();
        IgrNumericYAxisModule.register();
    };
    return IgrCategoryChartCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var INumberAbbreviator_$type = /*@__PURE__*/ new Type(null, 'INumberAbbreviator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumberAbbreviator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumberAbbreviator, _super);
    function NumberAbbreviator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NumberAbbreviator.prototype.abbreviate = function (a) {
        var b = "0.#";
        var c = Math.abs(a);
        var d = ['Q', 'T', 'B', 'M', 'K'];
        var e = [1E+15, 1000000000000, 1000000000, 1000000, 1000];
        for (var f = 0; f < d.length; f++) {
            if (c >= e[f]) {
                return numberToString2((a / e[f]), b) + d[f];
            }
        }
        return a.toString();
    };
    NumberAbbreviator.$t = markType(NumberAbbreviator, 'NumberAbbreviator', Base.$, [INumberAbbreviator_$type]);
    return NumberAbbreviator;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNumberAbbreviatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNumberAbbreviatorModule() {
    }
    IgrNumberAbbreviatorModule.register = function () {
        TypeRegistrar.register('NumberAbbreviator', NumberAbbreviator.$type);
    };
    return IgrNumberAbbreviatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesInteractionManager, _super);
    function SeriesInteractionManager() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.a$o = null;
        _this.a$c = false;
        _this.i = false;
        _this.c = false;
        _this.d = false;
        _this.e = true;
        _this.f = false;
        _this._toolTipObject = null;
        _this.p = null;
        _this.s = null;
        _this.o = null;
        _this.j = false;
        _this.k = new Dictionary$2(String_$type, SeriesView.$, 0);
        return _this;
    }
    SeriesInteractionManager.prototype.a$i = function (a, b, c, d, e, f, g, h) {
        if (d == null) {
            return Number.POSITIVE_INFINITY;
        }
        if (c < 0 || c > g - 1) {
            return Number.POSITIVE_INFINITY;
        }
        var i;
        var j = NaN;
        var k = NaN;
        var l = NaN;
        var m = NaN;
        if (d.cd) {
            var n = d;
            i = h(b);
            var o = truncate(Math.floor(i));
            var p = truncate(Math.ceil(i));
            m = i - o;
            if (o >= 0 && o < g) {
                var q = n.i$d(n.i$b._inner[o]);
                j = d.dw(q, e) + f;
            }
            else {
                j = NaN;
            }
            if (p >= 0 && p < g) {
                var r = n.i$d(n.i$b._inner[p]);
                k = d.dw(r, e) + f;
            }
            else {
                k = NaN;
            }
            if (isNaN_(j) && !isNaN_(k)) {
                j = k;
            }
            if (isNaN_(k) && !isNaN_(j)) {
                k = j;
            }
            if (c >= 0 && c < g) {
                var s = n.i$d(n.i$b._inner[c]);
                l = d.dw(s, e) + f;
            }
        }
        else {
            i = a.eb(b);
            var t = truncate(Math.floor(i));
            var u = truncate(Math.ceil(i));
            m = i - t;
            if (t >= 0 && t < g) {
                j = d.dw(t, e) + f;
            }
            else {
                j = NaN;
            }
            if (u >= 0 && u < g) {
                k = d.dw(u, e) + f;
            }
            else {
                k = NaN;
            }
            if (isNaN_(j) && !isNaN_(k)) {
                j = k;
            }
            if (isNaN_(k) && !isNaN_(j)) {
                k = j;
            }
            if (c >= 0 && c < g) {
                l = d.dw(c, e) + f;
            }
        }
        var v = j + m * (k - j);
        return Math.abs(l - v);
    };
    SeriesInteractionManager.prototype.a$k = function (a, b, c, d, e, f, g, h, i) {
        var j = NaN;
        if (d >= 0 && d < c.count) {
            j = c.item(d);
        }
        var k = NaN;
        if (e >= 0 && e < c.count) {
            k = c.item(e);
        }
        if (g == 0) {
            return k;
        }
        if (f == c.count - 1) {
            return j;
        }
        if (isNaN_(k) && h != 0 && b <= 0.5 && !i) {
            return j;
        }
        if (isNaN_(j) && h != 0 && b >= 0.5 && !i) {
            return k;
        }
        return j * (1 - b) + k * b;
    };
    SeriesInteractionManager.prototype.a$a = function (a, b, c, d, e, f, g) {
        if (b == null) {
            return null;
        }
        var h = -1;
        var i = -1;
        if (b.cd) {
            var j = a.lg(f);
            var k = -1;
            var l = b.b8;
            var m = a.bi.br.right * 2;
            k = SeriesInteractionManager.n(c, j, l, m);
            if (k < 0) {
                k = ~k;
                k--;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > c.count - 1) {
                k = c.count - 1;
            }
            var n = k;
            var o = k + 1;
            if (o > c.count - 1) {
                o = c.count - 1;
            }
            h = n;
            i = o;
        }
        else {
            var p = a.fe(f, g);
            var q = a.fc(f, g);
            var r = truncate(Math.floor(p / d));
            var s = truncate(Math.floor(q / d));
            h = r - e;
            i = s - e;
            if (i == h) {
                i++;
            }
        }
        if (h < 0) {
            h = 0;
        }
        if (h > c.count - 1) {
            h = c.count - 1;
        }
        if (i < 0) {
            i = 0;
        }
        if (i > c.count - 1) {
            i = c.count - 1;
        }
        if (h < 0 || i < 0) {
            return null;
        }
        var t = c._inner[h];
        var u = c._inner[i];
        var v = new Array(2);
        v[0] = t;
        v[1] = u;
        return v;
    };
    SeriesInteractionManager.n = function (a, b, c, d) {
        var e = 0;
        var f = a.count - 1;
        while (e <= f) {
            var g = (e + ((f - e) >> 1));
            var h = void 0;
            var i = a.item(g);
            if (c) {
                h = (d - b.x) < (d - i[0]) ? -1 : ((d - b.x) > (d - i[0]) ? 1 : 0);
            }
            else {
                h = b.x < i[0] ? -1 : (b.x > i[0] ? 1 : 0);
            }
            if (h < 0) {
                f = g - 1;
            }
            else if (h > 0) {
                e = g + 1;
            }
            else {
                return g;
            }
        }
        return ~e;
    };
    SeriesInteractionManager.prototype.a$n = function (a, b, c, d, e, f) {
        if (d == null) {
            return -1;
        }
        var g = d.cd;
        var h = a.dv;
        var i = null;
        if (g) {
            i = d;
        }
        var j = -1;
        var k = -1;
        var l = -1;
        if (g) {
            j = e(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        else {
            j = a.eb(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        if (f == null) {
            return -1;
        }
        if (k < 0 || k > f.count - 1) {
            return -1;
        }
        if (!c) {
            return k;
        }
        var m = NaN;
        if (g && !h) {
            if (k < i.i$b.count && i.i$b._inner[k] < f.count) {
                m = f.item(i.i$b._inner[k]);
            }
        }
        else {
            m = f.item(k);
        }
        while (isNaN_(m)) {
            k--;
            if (k < 0 || k > f.count - 1) {
                return -1;
            }
            if (g && !h) {
                m = f.item(i.i$b._inner[k]);
            }
            else {
                m = f.item(k);
            }
        }
        return k;
    };
    SeriesInteractionManager.prototype.a$l = function (a, b, c, d, e, f, g, h, i) {
        if (b == null) {
            return NaN;
        }
        var j = a.dv;
        var k = a.ff(c, i, d, g, b);
        var l = a.fd(c, i, d, g, b);
        var m = a.d9(c, k, d, e, f);
        var n = a.d9(c, l, d, e, f);
        var o = k;
        var p = l;
        var q = d.cd;
        if (q && !j) {
            var r = d;
            if (k >= 0 && k < r.i$b.count) {
                k = r.i$b._inner[k];
            }
            if (l >= 0 && k < r.i$b.count) {
                l = r.i$b._inner[l];
            }
        }
        var s = m / (n + m);
        if (m == 0) {
            s = 0;
        }
        if (n == 0) {
            s = 1;
        }
        if (!h) {
            if (n <= m) {
                if (l >= 0 && l < b.count) {
                    return b.item(l);
                }
            }
            else {
                if (k >= 0 && k < b.count) {
                    return b.item(k);
                }
            }
            return NaN;
        }
        return a.ef(s, b, k, l, o, p, f, q);
    };
    SeriesInteractionManager.prototype.a$d = function (a, b, c) {
        var d = a.ai(b);
        var e = a.ah(b);
        if (d == null) {
            return false;
        }
        for (var f = 0; f < d.length; f++) {
            var g = d[f];
            if (g == null || g.length != 2) {
                continue;
            }
            if (GeometryUtil.a(b, g[0], g[1], a.ey / 2 + a.ee(c))) {
                return true;
            }
            if (e != null && f < e.length) {
                var h = e[f];
                if (h == null || h.length != 2) {
                    continue;
                }
                if (GeometryUtil.a(b, h[0], h[1], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                if (GeometryUtil.a(b, g[0], h[0], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                if (GeometryUtil.a(b, g[1], h[1], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                var i = new Array(5);
                i[0] = h[0];
                i[1] = h[1];
                i[2] = g[1];
                i[3] = g[0];
                i[4] = h[0];
                if (PolygonUtil.a(boxArray$1(i), b)) {
                    return true;
                }
            }
        }
        return false;
    };
    SeriesInteractionManager.prototype.a$e = function (a, b, c, d) {
        if (d == null) {
            return false;
        }
        for (var e = 0; e < d.c.count; e++) {
            var f = d.c._inner[e];
            for (var g = 0; g < f._segments.count; g++) {
                var h = f._segments._inner[g];
                if (GeometryUtil.b(b, f._startPoint, h._points, a.ee(c))) {
                    return true;
                }
            }
        }
        return false;
    };
    SeriesInteractionManager.prototype.a$f = function (a, b, c) {
        if (c == null) {
            return false;
        }
        if (c.c.count > 0) {
            var d = c.c._inner[0];
            if (d._segments.count > 0) {
                var e = d._segments._inner[0];
                if (PolygonUtil.a(e._points, b)) {
                    return true;
                }
            }
        }
        return false;
    };
    SeriesInteractionManager.prototype.a$m = function (a, b, c, d, e, f) {
        var g = a.dv;
        var h = d.cd;
        var i = null;
        if (h) {
            i = d;
        }
        var j = -1;
        var k = -1;
        var l = -1;
        if (h) {
            j = e(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        else {
            j = a.eb(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        if (f == null) {
            return -1;
        }
        if (l < 0 || l > f.count - 1) {
            return -1;
        }
        if (!c) {
            return l;
        }
        var m = NaN;
        if (h && !g) {
            if (l < i.i$b.count && i.i$b._inner[l] < f.count) {
                m = f.item(i.i$b._inner[l]);
            }
        }
        else {
            m = f.item(l);
        }
        while (isNaN_(m)) {
            l++;
            if (l < 0 || l > f.count - 1) {
                return -1;
            }
            if (h && !g) {
                m = f.item(i.i$b._inner[l]);
            }
            else {
                m = f.item(l);
            }
        }
        return l;
    };
    SeriesInteractionManager.prototype.a$j = function (a, b, c) {
        var d = a.bi.bs;
        var e = a.bi.br;
        if (d.isEmpty || e.isEmpty || c == null) {
            return -1;
        }
        var f = a.getEffectiveViewport1(a.bi);
        var g = null;
        if (c.cd) {
            g = c;
        }
        var h = new ScalerParams(0, d, e, c.b8, f);
        if (a.bs == null) {
            return -1;
        }
        h.c = a.getEffectiveViewport1(a.bi);
        var i = a.lq(a.bi);
        var j = 0;
        if (c.cf) {
            var k = c.dz(i.top, h);
            var l = c.dz(i.bottom, h);
            var m = (b.y - d.top) / d.height;
            j = k + ((l - k) * m);
        }
        else {
            if (c.b3) {
                var n = c.dz(i.left, h);
                var o = c.dz(i.right, h);
                var p = (b.x - d.left) / d.width;
                j = n + ((o - n) * p);
            }
            else {
                var q = new Rect(0, 0, 0, 1, 1);
                j = c.dz(b.x, new ScalerParams(1, q, q, c.b8));
            }
        }
        if (c.b5) {
        }
        var r = g.i$c(j);
        return r;
    };
    SeriesInteractionManager.prototype.a$g = function (a, b, c) {
        var d = a.lv(b);
        if (d.isEmpty) {
            return false;
        }
        var e = RectUtil.r(d, a.ee(c));
        return e.containsPoint(b);
    };
    SeriesInteractionManager.prototype.a$aj = function (a, b, c, d, e, f, g, h, i, j) {
        if (f == null || g == null || a.bi == null || a.bi.bs.isEmpty || a.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var k = a.getEffectiveViewport1(a.bi);
        var l = new ScalerParams(0, a.bi.bs, a.bi.br, f.b8, k);
        if (f.cf) {
            l.b = a.eh();
        }
        l.c = a.getEffectiveViewport1(a.bi);
        var m = a.bi;
        var n;
        if (g.cf) {
            n = b.y;
            n = m.br.top + m.br.height * (n - m.bs.top) / m.bs.height;
        }
        else {
            n = b.x;
            n = m.br.left + m.br.width * (n - m.bs.left) / m.bs.width;
        }
        if (!c && g != null) {
            var o = void 0;
            var p = void 0;
            if (i != null) {
                o = i(b, d);
            }
            else {
                o = a.fe(b, d);
            }
            if (j != null) {
                p = j(b, d);
            }
            else {
                p = a.fc(b, d);
            }
            if (o == -1 && p == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            var q = new ScalerParams(0, m.bs, m.br, g.b8, k);
            q.c = a.bs.m3;
            var r = a.d9(b, o, g, q, e);
            var s = a.d9(b, p, g, q, e);
            var t = p;
            var u = o;
            if (g.cd) {
                var v = g;
                if (t >= 0 && t < v.i$b.count) {
                    t = v.i$d(v.i$b._inner[truncate(t)]);
                }
                if (u >= 0 && u < v.i$b.count) {
                    u = v.i$d(v.i$b._inner[truncate(u)]);
                }
            }
            if ((s + r) != 0) {
                var w = s / (r + s);
                if (Math.abs(w - 0.5) < 1E-07) {
                    s = r;
                }
            }
            if (s <= r) {
                n = g.dw(t, q) + e;
            }
            else {
                n = g.dw(u, q) + e;
            }
        }
        else {
            if (g.b2 && !g.b5 && g.categoryMode != 0) {
                var x = 0.5 * g.getCategorySize(m.bs, m.br, a.getEffectiveViewport1(m));
                if (a.isVertical) {
                    x = x * -1;
                }
                if (g.b8) {
                    x = x * -1;
                }
                n -= x;
                n += e;
            }
        }
        var y;
        if (h != null) {
            y = h(b, c, d);
        }
        else {
            y = a.en(b, c, d);
        }
        var z = f.dw(y, l);
        if (g.cf) {
            return { $type: Point_$type, x: z, y: n };
        }
        else {
            return { $type: Point_$type, x: n, y: z };
        }
    };
    SeriesInteractionManager.prototype.a$t = function (a, b, c, d, e) {
        if (a.bs.c5() && !e) {
            return;
        }
        if (!a.b9) {
            return;
        }
        if (a.bs == null) {
            return;
        }
        var f = null;
        var g = null;
        var h = a.bs.az;
        var i = a.bs.bo;
        if (e && this.a != null) {
            f = this.a;
        }
        else {
            f = a.at(b, c);
            if (this.a != null && this.a != f) {
                if (a.bs != null) {
                    h.endHighlight(this.a);
                }
            }
            this.a = f;
        }
        if (a.hasMarkers) {
            if (e && this.b != null) {
                g = this.b;
            }
            else {
                g = a.au(b, c);
                if (this.b != null && this.b != g) {
                    h.endHighlight(this.b);
                }
                this.b = g;
            }
        }
        var j = true;
        if (e) {
            h.endHighlight(f);
            if (g != null) {
                h.endHighlight(g);
            }
        }
        else {
            if (d || !j) {
                h.startHighlight(f);
                if (g != null) {
                    h.startHighlight(g);
                }
            }
        }
        if (!i.f() && i.r > 0) {
            i.v();
        }
        if (i.r == 0) {
            a.bs.ke(1);
        }
    };
    SeriesInteractionManager.prototype.a$ai = function (a, b, c) {
        var d = b.d;
        d = d * 0.5;
        return this.r(c, d);
    };
    SeriesInteractionManager.prototype.r = function (a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, b);
    };
    SeriesInteractionManager.prototype.a$w = function (a, b, c, d) {
        var e = a.bi;
        e.aj();
        this.a$c = true;
        var f = a.fv(c, b);
        this.a$o = f;
        if (a.bs != null && !a.aq.c) {
            this.q(a, b, f, d);
        }
        this.c = false;
        if (a.db && f == null) {
            this.c = true;
        }
        if (a.bs != null && !this.c) {
            if (a.db) {
                this.d = true;
            }
            this.a$t(a, f, a.lo(b), true, false);
            a.bs.it(a, f, d);
        }
    };
    SeriesInteractionManager.prototype.a$ag = function (a, b) {
        var c = null;
        var d = null;
        var e;
        var f = ((function () { var g = a.bs.bn.e(b, false, e, false); e = g.p2; return g.ret; })());
        if (f != a) {
            if (this.a$c) {
                this.a$x(a, b, null, null);
            }
            return;
        }
        c = e;
        if (!this.a$c) {
            this.a$w(a, b, c, d);
        }
        this.a$z(a, b, c, d);
    };
    SeriesInteractionManager.prototype.a$z = function (a, b, c, d) {
        this.a$c = true;
        var e = a.fv(c, b);
        this.q(a, b, e, d);
        if (e != null) {
            this.a$o = e;
        }
        if (a.bs != null && e != null && this.c) {
            this.c = false;
            this.d = true;
            this.a$t(a, e, a.lo(b), true, false);
            a.bs.it(a, e, d);
        }
        if (a.bs != null && (!a.db || e != null) && !this.c) {
            this.a$t(a, e, a.lo(b), true, false);
            a.bs.ix(a, e, d);
        }
        if (e == null && !this.c && a.db) {
            this.a$t(a, e, a.lo(b), false, true);
            a.bs.iu(a, this.a$o, d);
            this.d = false;
            this.c = true;
        }
    };
    SeriesInteractionManager.prototype.a$x = function (a, b, c, d) {
        a.bi.ak();
        this.a$c = false;
        var e = this.a$o;
        a.bi.am();
        if (a.bs != null && (this.d || !a.db)) {
            this.d = false;
            this.c = false;
            this.a$t(a, e, a.lo(b), false, true);
            a.bs.iu(a, e, d);
        }
    };
    SeriesInteractionManager.prototype.a$u = function (a, b, c, d) {
        this.i = true;
        if (a.bs != null) {
            a.bs.iv(a, a.fv(c, b), d);
        }
    };
    SeriesInteractionManager.prototype.a$y = function (a, b, c, d) {
        this.i = false;
        if (a.bs != null) {
            a.bs.iw(a, a.fv(c, b), d);
        }
    };
    SeriesInteractionManager.prototype.a$v = function (a, b, c, d) {
        if (a.bi.p) {
            return;
        }
        if (this.i) {
            this.a$y(a, b, c, d);
        }
        if (this.a$c) {
            this.a$x(a, b, c, d);
        }
    };
    SeriesInteractionManager.prototype.a$aa = function (a, b, c, d) {
        if (a.bs != null) {
            a.bs.iy(a, a.fv(c, b), d);
        }
    };
    SeriesInteractionManager.prototype.a$ab = function (a, b, c, d) {
        if (a.bs != null) {
            a.bs.iz(a, a.fv(c, b), d);
        }
    };
    Object.defineProperty(SeriesInteractionManager.prototype, "g", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesInteractionManager.prototype, "a$b", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesInteractionManager.prototype.q = function (a, b, c, d) {
        var e = false;
        if (a.bs != null) {
            e = a.bs.cr;
        }
        if (e) {
            return;
        }
        if (a.bs == null || a.bs.ck) {
            return;
        }
        this.j = true;
        this.s = b;
        this.o = c;
        a.bi.d.item = c;
        a.bi.d.itemLabel = a.fr(c);
        var f = a.bs.mj();
        var pos_ = { $type: Point_$type, x: b.x + 15 + f.x, y: b.y + 15 + f.y };
        var context_ = a.bi.d;
        var g = false;
        if (this._toolTipObject != null) {
            g = (this._toolTipObject._inPointer);
            this._toolTipObject._inPointer = false;
        }
        if (this._toolTipObject != null) {
            if (this.f || g) {
                this.f = false;
                this._toolTipObject.remove();
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.addClass(a.bs.g0);
                a.bs.ha(this._toolTipObject);
                this._toolTipObject.hide();
            }
            if (this.e) {
                a.bs.ha(this._toolTipObject);
                this.e = false;
            }
            context_.hideOthers = true;
            if ((this._toolTipObject.updateToolTip && !this._toolTipObject.updateToolTip(context_))) {
                this.a$s(a);
            }
            var h = window.pageXOffset;
            var i = window.pageYOffset;
            var j = document.documentElement.clientWidth;
            var k = document.documentElement.clientHeight;
            var l = this._toolTipObject.outerWidthWithMargin();
            var m = this._toolTipObject.outerHeightWithMargin();
            var n = pos_.x;
            var o = pos_.y;
            var p = 5;
            var q = 30;
            if (l + n - h + p > j) {
                pos_.x -= q;
                pos_.x -= l;
            }
            if (m + o - i + p > k) {
                pos_.y -= q;
                pos_.y -= m;
            }
            this._toolTipObject.setOffset(pos_.x, pos_.y);
        }
    };
    SeriesInteractionManager.prototype.a$af = function (a, b, c) {
        this.j = true;
        var d = { $type: Point_$type, x: b.x + a.bi.br.left, y: b.y + a.bi.br.top };
        var e = a.fv(null, d);
        if (a.bi.d != null) {
            a.bi.d.series = a;
            a.bi.d.item = e;
        }
        var tooltip_ = this._toolTipObject;
        var context_ = a.bi.d;
        var f = false;
        if (this._toolTipObject != null) {
            f = (this._toolTipObject._inPointer);
            this._toolTipObject._inPointer = false;
        }
        if (context_ != null) {
            context_.hideOthers = false;
        }
        if ((!this.f || f) && tooltip_ != null) {
            this.f = true;
            tooltip_.remove();
            tooltip_.setStyleProperty("position", "relative");
            tooltip_.setStyleProperty("top", "");
            tooltip_.setStyleProperty("left", "");
            tooltip_.removeClass(a.bs.g0);
        }
        if (this._toolTipObject != null) {
            if (tooltip_.updateToolTip) {
                tooltip_.updateToolTip(context_);
            }
            ;
        }
        if (tooltip_ != null) {
            c(tooltip_);
        }
    };
    SeriesInteractionManager.prototype.a$p = function (a) {
        var b = "<div class='ui-chart-default-tooltip-content'><span";
        var c = this.a$q(a);
        if (!stringIsNullOrEmpty(c)) {
            b += " style='color:" + c + "'";
        }
        b += ">" + a.fx + "</span></div>";
        return b;
    };
    SeriesInteractionManager.prototype.h = function (a, b) {
        var c = a != null && Color.e(toNullable(Color.$, a.color), toNullable(Color.$, null));
        c = c && a.color.l > 0;
        c = c && Color.d(a.color, b);
        return !c;
    };
    SeriesInteractionManager.prototype.a$q = function (a) {
        var b = new Color();
        var c = a != null && a.bs != null && a.bs.bn != null && a.bs.bn.i != null ? a.bs.bn.i.ae : null;
        c.startCSSQuery();
        b.colorString = c.getCssDefaultPropertyValue("ui-chart-pointer-tooltip", "background-color");
        c.endCSSQuery();
        if (!this.h(a.k4, b)) {
            return a.k4._fill;
        }
        if (!this.h(a.k3, b)) {
            return a.k3._fill;
        }
        return null;
    };
    SeriesInteractionManager.prototype.a$s = function (a) {
        if (this._toolTipObject != null && this.j) {
            this.j = false;
            var context_ = a.bi.d;
            if (this._toolTipObject.hideToolTip) {
                this._toolTipObject.hideToolTip(context_);
            }
            ;
        }
    };
    SeriesInteractionManager.prototype.a$ah = function (a, b) {
        var c = this._toolTipObject;
        this.p = null;
        this._toolTipObject = null;
        if (typeof b === 'string') {
            this.p = b;
        }
        else {
            this._toolTipObject = b;
            if (this._toolTipObject != null) {
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.setStyleProperty("top", "0px");
                this._toolTipObject.setStyleProperty("left", "0px");
                this._toolTipObject.setStyleProperty("z-index", "10000");
                this._toolTipObject.setStyleProperty("pointer-events", "none");
                var d = a.k4 != null && Color.e(toNullable(Color.$, a.k4.color), toNullable(Color.$, null)) && a.k4.color.l > 0;
                if (d) {
                    this._toolTipObject.setStyleProperty("border-color", a.k4._fill);
                }
            }
            else {
                if (!this.e && c != null) {
                    a.bs.jz(c);
                    this.e = true;
                }
            }
        }
    };
    SeriesInteractionManager.prototype.a$ae = function (a) {
    };
    Object.defineProperty(SeriesInteractionManager.prototype, "a$h", {
        get: function () {
            return this.k;
        },
        enumerable: true,
        configurable: true
    });
    SeriesInteractionManager.prototype.a$r = function (a, b, c, d, e) {
        var _this = this;
        var f;
        if (!((function () { var g = _this.k.tryGetValue(d, f); f = g.p1; return g.ret; })())) {
            f = a.bg();
            f.n = true;
            f.m = true;
            if (a.bs != null) {
                f.a = a.bs.ag;
                a.bs.ag.l(f);
            }
            f.ap();
            f.aa = d;
            this.k.item(d, f);
        }
        f.s = e;
        f.br = b;
        f.bq = c;
    };
    SeriesInteractionManager.prototype.a$ad = function (a, b, c) {
        var _this = this;
        var d;
        var e = c;
        if (e == null) {
            e = a.bs;
        }
        if (((function () { var f = _this.k.tryGetValue(b, d); d = f.p1; return f.ret; })())) {
            if (e != null) {
                d.a = null;
                e.ag.r(d);
            }
            this.k.removeItem(b);
        }
    };
    SeriesInteractionManager.prototype.a$ac = function (a, b) {
        var e_1, _a;
        var c = new List$1(String_$type, 0);
        try {
            for (var _b = __values(fromEnum(this.k.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(d);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        for (var e = 0; e < c.count; e++) {
            this.a$ad(a, c._inner[e], b);
        }
    };
    SeriesInteractionManager.$t = markType(SeriesInteractionManager, 'SeriesInteractionManager', Base.$, [ISeriesInteractionManager_$type]);
    return SeriesInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IVerticalAnchoredCategorySeriesInteractionManager_$type = /*@__PURE__*/ new Type(null, 'IVerticalAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategorySeriesInteractionManager, _super);
    function CategorySeriesInteractionManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CategorySeriesInteractionManager.prototype.b$c = function (a, b) {
        var c = a.bi.bs;
        var d = a.bi.br;
        var e = a.ap();
        var f = a.getEffectiveViewport1(a.bi);
        var g = a.lq(a.bi);
        var h = -1;
        if (e != null && !c.isEmpty && !d.isEmpty) {
            var i = new ScalerParams(0, c, d, e.b8, f);
            var j = e.dz(g.left, i);
            var k = e.dz(g.right, i);
            var l = (b.x - c.left) / c.width;
            var m = j + (l * (k - j));
            if (e.categoryMode != 0) {
                m -= 0.5;
            }
            h = m;
        }
        return h;
    };
    CategorySeriesInteractionManager.prototype.b$f = function (a, b) {
        var c = 0;
        if (a.c1) {
            c = a.fa(b);
            if (c == -1) {
                return null;
            }
        }
        else if (b.x == 1 && a.bz != null) {
            c = a.bz.count - 1;
        }
        else {
            c = a.e8(b);
        }
        return c >= 0 && a.bz != null && c < a.bz.count ? a.bz.item(c) : null;
    };
    CategorySeriesInteractionManager.prototype.b$d = function (a, b) {
        var c = a.bi.bs;
        var d = a.bi.br;
        var e = a.getEffectiveViewport1(a.bi);
        if (c.isEmpty || d.isEmpty) {
            return -1;
        }
        if (isNaN_(b.x)) {
            return -1;
        }
        var f = a.ap();
        if (f == null) {
            return -1;
        }
        var g = typeCast(ISortingAxis_$type, f);
        var h = a.lq(a.bi);
        var i = new ScalerParams(0, c, d, f.b8, e);
        var j = 0;
        if (f.cb) {
            var k = (b.x - c.left) / c.width;
            var l = k * h.width + h.left;
            j = f.dz(l, i);
        }
        else {
            var m = f.dz(h.left, i);
            var n = f.dz(h.right, i);
            var o = (b.x - c.left) / c.width;
            j = m + ((n - m) * o);
        }
        var p = g.i$f(j);
        return p;
    };
    CategorySeriesInteractionManager.prototype.b$e = function (a, b, c) {
        var d = a.bi.br;
        var e = a.bi.bs;
        var f = a.ap();
        var g = 0;
        if (f.cf) {
            var h = (c.y - e.top) / e.height;
            g = h * d.height + d.top;
        }
        else {
            var i = (c.x - e.left) / e.width;
            g = i * d.width + d.left;
        }
        if (f.b8) {
            var j = b.count;
            var k = 0;
            for (k = j - 1; k >= 0; k--) {
                var l = b._inner[k];
                var m = null;
                if (k > 0) {
                    m = b._inner[k - 1];
                }
                if (l[0] <= g && m == null || m[0] >= g) {
                    if (m != null) {
                        if (Math.abs(l[0] - g) < Math.abs(m[0] - g)) {
                            return k;
                        }
                        else {
                            return k - 1;
                        }
                    }
                    else {
                        return k;
                    }
                }
            }
            return k;
        }
        else {
            var n = b.count;
            var o = 0;
            for (o = 0; o < n; o++) {
                var p = b._inner[o];
                var q = null;
                if (o < n - 1) {
                    q = b._inner[o + 1];
                }
                if (p[0] <= g && q == null || q[0] >= g) {
                    if (q != null) {
                        if (Math.abs(p[0] - g) < Math.abs(q[0] - g)) {
                            return o;
                        }
                        else {
                            return o + 1;
                        }
                    }
                    else {
                        return o;
                    }
                }
            }
            return o;
        }
    };
    CategorySeriesInteractionManager.prototype.b$a = function (a, b, c, d, e, f, g, h) {
        var i = a.bz.count;
        var j = a.ap();
        var k = -1;
        var l = -1;
        if (j.cd) {
            var m = this.b$e(a, b, g);
            k = m;
            l = m;
        }
        else {
            var n = a.e8(g);
            k = truncate(Math.floor((intDivide(n, e)))) * e;
            l = k + (e - 1);
        }
        if (h != null && h.f == k && h.e == l) {
            return h;
        }
        var o = new HighlightingInfo();
        o.b = a;
        o.f = k;
        o.e = l;
        return o;
    };
    CategorySeriesInteractionManager.prototype.b$b = function (a, b, c, d, e, f) {
        var g = a.lg(e);
        var h = b;
        if (h == null) {
            return null;
        }
        var i = h.count;
        if (i == 0) {
            return null;
        }
        var j = h._inner[0].al;
        if (a.isVertical) {
            var k = c._inner[h._inner[0].al][0];
            var l = (g.y - k) * (g.y - k);
            var m = void 0;
            for (var n = 0; n < i; n++) {
                k = c._inner[h._inner[n].al][0];
                m = (g.y - k) * (g.y - k);
                if (m <= l) {
                    l = m;
                    j = h._inner[n].al;
                }
            }
        }
        else {
            var o = c._inner[h._inner[0].al][0];
            var p = (g.x - o) * (g.x - o);
            var q = void 0;
            for (var r = 0; r < i; r++) {
                o = c._inner[h._inner[r].al][0];
                q = (g.x - o) * (g.x - o);
                if (q <= p) {
                    p = q;
                    j = h._inner[r].al;
                }
            }
        }
        var s = new HighlightingInfo();
        s.b = a;
        s.c = true;
        s.f = j;
        s.e = s.f;
        if (f != null && f.f == s.f && f.e == s.e) {
            return f;
        }
        return s;
    };
    CategorySeriesInteractionManager.$t = markType(CategorySeriesInteractionManager, 'CategorySeriesInteractionManager', Base.$, [ICategorySeriesInteractionManager_$type]);
    return CategorySeriesInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredCategorySeriesInteractionManager, _super);
    function AnchoredCategorySeriesInteractionManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnchoredCategorySeriesInteractionManager.prototype.c$b = function (a, b, c, d, e, f, g, h) {
        if (!g) {
            return h(b);
        }
        if (e == null || e.cd || f == null || d == null || isNaN_(b.x) || isNaN_(b.y)) {
            return h(b);
        }
        if (c <= 1) {
            return h(b);
        }
        var i = truncate(Math.round(a.eb(b)));
        if (i < 0 || i >= a.bz.count) {
            return h(b);
        }
        var j = intDivide(i, c);
        var k = c * j;
        var l = Math.min(k + c, d.count - 1);
        var m = a.lq(a.bi);
        var n = new ScalerParams(0, a.bs.m4, a.bs.m3, f.b8, a.bs.mu);
        var o = m.top;
        var p = m.bottom;
        var q = o + (p - o) * b.y;
        var r = f.dz(q, n);
        var s = 1.7976931348623157E+308;
        var t = k;
        for (var u = k; u <= l; u++) {
            var v = Math.abs(d.item(u) - r);
            if (v < s) {
                s = v;
                t = u;
            }
        }
        return a.bz.item(t);
    };
    AnchoredCategorySeriesInteractionManager.prototype.c$a = function (a, b, c, d, e, f) {
        var g = a.bi.bs;
        g = g.copy();
        var h = a.bi.br;
        var i = new Rect(0, 0, 0, 1, 1);
        var j = !g.isEmpty && !h.isEmpty && a.bz != null ? a.bz.indexOf(f) : -1;
        var k = a.ls(a.bi);
        var l = new ScalerParams(0, i, i, c.b8, k);
        var m = new ScalerParams(0, i, i, d.b8, k);
        m.b = a.eh();
        var n = c != null ? c.dw(j, l) : NaN;
        n += e;
        var o = d != null && b != null && j < b.count ? d.dw(b.item(j), m) : NaN;
        if (!isNaN_(n)) {
            if (n < g.left + 0.1 * g.width) {
                n = n + 0.4 * g.width;
                g.x = n - 0.5 * g.width;
            }
            if (n > g.right - 0.1 * g.width) {
                n = n - 0.4 * g.width;
                g.x = n - 0.5 * g.width;
            }
        }
        if (!isNaN_(o)) {
            if (o < g.top + 0.1 * g.height) {
                o = o + 0.4 * g.height;
                g.y = o - 0.5 * g.height;
            }
            if (o > g.bottom - 0.1 * g.height) {
                o = o - 0.4 * g.height;
                g.y = o - 0.5 * g.height;
            }
        }
        if (a.bn != null) {
            a.bn.ap(a.bs, g, true);
        }
        return j >= 0;
    };
    AnchoredCategorySeriesInteractionManager.prototype.c$c = function (a, b) {
        var c = "<div class='ui-chart-default-tooltip-content'>";
        var d = null;
        d = a.ap();
        if (d.b5) {
            var e = d;
            c += "<span>${item." + e.dateTimeMemberPath + "}</span><br/>";
        }
        else if (d != null && d.e7 != null) {
            c += "<span>${item." + d.e7 + "}</span><br/>";
        }
        c += "<span";
        var f = a.a0.a$q(a);
        if (!stringIsNullOrEmpty(f)) {
            c += " style='color:" + f + "'";
        }
        c += ">${series.title}: </span><span class='ui-priority-primary'>" + "${item." + b + "}</span></div>";
        return c;
    };
    AnchoredCategorySeriesInteractionManager.prototype.c$d = function (a, b, c, d, e, f, g, h) {
        if (c == null || d == null) {
            return Rect.empty;
        }
        var i = a.lg(b);
        var j = a.bi.bs;
        var k = a.bi.br;
        var l = a.getEffectiveViewport1(a.bi);
        var m = new ScalerParams(0, j, k, d.b8, l);
        m.b = a.eh();
        var n = a.aj(a.ap(), e.f, f, g, b, true);
        if (n == null) {
            return Rect.empty;
        }
        var o = n[0];
        var p = n[1];
        var q = Math.abs(i.x - o[0]);
        var r = Math.abs(i.x - p[0]);
        var s = d.dw(d.ke, m);
        var t = c.jr(j, k, l);
        if (q < r) {
            var u = o[0] - 0.5 * t;
            var v = h(o);
            var w = s;
            return new Rect(0, u, Math.min(v, w), t, Math.max(v, w) - Math.min(v, w));
        }
        else {
            var x = p[0] - 0.5 * t;
            var y = h(p);
            var z = s;
            return new Rect(0, x, Math.min(y, z), t, Math.max(y, z) - Math.min(y, z));
        }
    };
    AnchoredCategorySeriesInteractionManager.$t = markType(AnchoredCategorySeriesInteractionManager, 'AnchoredCategorySeriesInteractionManager', Base.$, [IAnchoredCategorySeriesInteractionManager_$type]);
    return AnchoredCategorySeriesInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalAnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAnchoredCategorySeriesInteractionManager, _super);
    function HorizontalAnchoredCategorySeriesInteractionManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$a = function (a, b, c, d, e) {
        var f = a.aj(a.ap(), b, c, d, a.lo(e), true);
        if (f == null) {
            return null;
        }
        var g = f[0];
        var h = f[1];
        var i = new Array(1);
        var j = new Array(2);
        j[0] = { $type: Point_$type, x: g[0], y: g[2] };
        j[1] = { $type: Point_$type, x: h[0], y: h[2] };
        i[0] = j;
        return i;
    };
    HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$b = function (a, b, c, d, e) {
        var f = a.aj(a.ap(), b, c, d, a.lo(e), true);
        if (f == null) {
            return null;
        }
        var g = f[0];
        var h = f[1];
        var i = new Array(1);
        var j = new Array(2);
        j[0] = { $type: Point_$type, x: g[0], y: g[1] };
        j[1] = { $type: Point_$type, x: h[0], y: h[1] };
        i[0] = j;
        return i;
    };
    HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$d = function (a, b, c, d) {
        var e = a.lg(c);
        var f = -1;
        var g = a.ap();
        var h = g.b8;
        var i = a.bi.br.right * 2;
        if (h) {
            f = ArrayExtension.binarySearch$11(Point_$type, b, function (j) { return (i - e.x) < (i - j.x) ? -1 : ((i - e.x) > (i - j.x) ? 1 : 0); });
        }
        else {
            f = ArrayExtension.binarySearch$11(Point_$type, b, function (j) { return e.x < j.x ? -1 : (e.x > j.x ? 1 : 0); });
        }
        if (f < 0) {
            f = ~f;
        }
        if (f < 0) {
            f = 0;
        }
        if (f > b.count - 1) {
            f = b.count - 1;
        }
        var j = f;
        var k = f;
        if (j > 0) {
            j--;
        }
        if (k < b.count - 1) {
            k++;
        }
        var l = b._inner[j].x;
        var m = b._inner[f].x;
        var n = b._inner[k].x;
        var o = Math.abs(l - e.x);
        var p = Math.abs(m - e.x);
        var q = Math.abs(n - e.x);
        var r = d(j);
        var s = d(f);
        var t = d(k);
        var u = r.containsPoint(e);
        var v = s.containsPoint(e);
        var w = t.containsPoint(e);
        if (p <= o && p <= q) {
            if (!h && w) {
                return t;
            }
            if (h && u) {
                return r;
            }
            return s;
        }
        if (o <= p && o <= q) {
            if (!h && v) {
                return s;
            }
            return d(j);
        }
        if (q <= p && q <= o) {
            if (h && v) {
                return s;
            }
            return d(k);
        }
        return Rect.empty;
    };
    HorizontalAnchoredCategorySeriesInteractionManager.prototype.d$c = function (a, b, c, d, e) {
        if (isNaN_(d.x) || isNaN_(d.y)) {
            return false;
        }
        var f = 0;
        if (b != null) {
            f = b.eb(b.ke);
        }
        if ((c.y >= f && c.y <= d.y) || (c.y <= f && c.y >= d.y)) {
            return true;
        }
        return false;
    };
    HorizontalAnchoredCategorySeriesInteractionManager.$t = markType(HorizontalAnchoredCategorySeriesInteractionManager, 'HorizontalAnchoredCategorySeriesInteractionManager', Base.$, [IHorizontalAnchoredCategorySeriesInteractionManager_$type]);
    return HorizontalAnchoredCategorySeriesInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VerticalAnchoredCategorySeriesInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAnchoredCategorySeriesInteractionManager, _super);
    function VerticalAnchoredCategorySeriesInteractionManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VerticalAnchoredCategorySeriesInteractionManager.prototype.e$a = function (a, b) {
        var c = a.bs != null ? a.bs.mq : Rect.empty;
        var d = a.bi.br;
        var e = a.lq(a.bi);
        var f = a.getEffectiveViewport1(a.bi);
        var g = a.ap();
        var h = -1;
        if (g != null && !c.isEmpty && !d.isEmpty) {
            var i = new ScalerParams(0, c, d, g.b8, f);
            var j = g.dz(e.top, i);
            var k = g.dz(e.bottom, i);
            var l = (b.y - c.top) / c.height;
            var m = j + (l * (k - j));
            if (g.categoryMode != 0) {
                m -= 0.5;
            }
            h = m;
        }
        return h;
    };
    VerticalAnchoredCategorySeriesInteractionManager.prototype.e$b = function (a, b, c, d) {
        var e = a.lg(c);
        var f = -1;
        var g = a.ap().b8;
        var h = a.bi.br.bottom * 2;
        if (g) {
            f = ArrayExtension.binarySearch$11(Point_$type, b, function (i) { return (h - e.y) < (h - i.y) ? -1 : ((h - e.y) > (h - i.y) ? 1 : 0); });
        }
        else {
            f = ArrayExtension.binarySearch$11(Point_$type, b, function (i) { return e.y < i.y ? -1 : (e.y > i.y ? 1 : 0); });
        }
        if (f < 0) {
            f = ~f;
        }
        if (f < 0) {
            f = 0;
        }
        if (f > b.count - 1) {
            f = b.count - 1;
        }
        var i = f;
        var j = f;
        if (i > 0) {
            i--;
        }
        if (j < b.count - 1) {
            j++;
        }
        var k = b._inner[i].y;
        var l = b._inner[f].y;
        var m = b._inner[j].y;
        var n = Math.abs(k - e.y);
        var o = Math.abs(l - e.y);
        var p = Math.abs(m - e.y);
        var q = d(i);
        var r = d(f);
        var s = d(j);
        var t = q.containsPoint(e);
        var u = r.containsPoint(e);
        var v = s.containsPoint(e);
        if (o <= n && o <= p) {
            if (!g && v) {
                return s;
            }
            if (g && t) {
                return q;
            }
            return r;
        }
        if (n <= o && n <= p) {
            if (!g && u) {
                return r;
            }
            return d(i);
        }
        if (p <= o && p <= n) {
            if (g && u) {
                return r;
            }
            return d(j);
        }
        return Rect.empty;
    };
    VerticalAnchoredCategorySeriesInteractionManager.$t = markType(VerticalAnchoredCategorySeriesInteractionManager, 'VerticalAnchoredCategorySeriesInteractionManager', Base.$, [IVerticalAnchoredCategorySeriesInteractionManager_$type]);
    return VerticalAnchoredCategorySeriesInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HighlightingManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighlightingManager, _super);
    function HighlightingManager() {
        var _this = _super.call(this) || this;
        _this.a = new Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 0);
        _this.c = new List$1(HighlightingInfo.$, 0);
        _this.d = 0;
        _this.e = 0;
        _this.f = 0;
        _this._dirtySeries = null;
        _this.b = new Dictionary$2(Series.$, Boolean_$type, 0);
        _this._inProgress = false;
        _this._maxHighlightingProgress = 0;
        _this._sumHighlightingProgress = 0;
        _this._maxMarkerHighlightingProgress = 0;
        _this._sumMarkerHighlightingProgress = 0;
        _this.dirtySeries = new List$1(Series.$, 0);
        return _this;
    }
    HighlightingManager.prototype.startHighlight = function (a) {
        if (a == null) {
            return;
        }
        this.inProgress = true;
        if (!this.a.containsKey(a)) {
            a.a = HighlightingState.inward;
            this.a.item(a, a);
            this.c.add(a);
        }
        if (a.a == HighlightingState.outward) {
            a.a = HighlightingState.inward;
        }
    };
    HighlightingManager.prototype.endHighlight = function (a) {
        if (a == null) {
            return;
        }
        if (!this.a.containsKey(a)) {
            return;
        }
        if (a.a == HighlightingState.inward) {
            if (a.d < 0.05) {
                if (a.c) {
                    this.e = this.e + a.d;
                }
                else {
                    this.d = this.d + a.d;
                }
                this.a.removeItem(a);
                this.c.remove(a);
                return;
            }
            a.a = HighlightingState.outward;
        }
        if (a.a == 2) {
            a.a = HighlightingState.outward;
            a.d = 1;
        }
    };
    HighlightingManager.prototype.clear = function () {
        this.c.clear();
        this.a.clear();
    };
    HighlightingManager.prototype.getHighlightingInfo = function (a, b, c, d, e, f) {
        for (var g = 0; g < this.c.count; g++) {
            var h = this.c._inner[g];
            var i = h.f;
            var j = h.e;
            if (d >= i && e <= j && h.c == f && a == h.b && (h.a == HighlightingState.inward || h.a == 2)) {
                return h;
            }
        }
        for (var k = 0; k < this.c.count; k++) {
            var l = this.c._inner[k];
            var m = l.f;
            var n = l.e;
            if (d >= m && e <= n && l.c == f && a == l.b && (l.a == HighlightingState.outward)) {
                return l;
            }
        }
        return null;
    };
    Object.defineProperty(HighlightingManager.prototype, "dirtySeries", {
        get: function () {
            return this._dirtySeries;
        },
        set: function (a) {
            this._dirtySeries = a;
        },
        enumerable: true,
        configurable: true
    });
    HighlightingManager.prototype.tick = function (a) {
        var e_1, _a;
        this.b.clear();
        this.dirtySeries.clear();
        var b = 0;
        if (this.f > a) {
            b = (1 - this.f) + a;
        }
        else {
            b = a - this.f;
        }
        this.f = a;
        var c = false;
        var d = new List$1(HighlightingInfo.$, 0);
        this.maxHighlightingProgress = 0;
        this.sumHighlightingProgress = 0;
        this.maxMarkerHighlightingProgress = 0;
        this.sumMarkerHighlightingProgress = 0;
        var e = false;
        var f = false;
        var g = 0;
        var h = 0;
        var i = 0;
        var j = 0;
        var k = 0;
        var l = 0;
        for (var m = 0; m < this.c.count; m++) {
            var n = this.c._inner[m];
            if (n.a == HighlightingState.inward) {
                if (n.c) {
                    e = true;
                    i = i + Math.min(1 - n.d, b);
                }
                else {
                    f = true;
                    g = g + Math.min(1 - n.d, b);
                }
            }
            if (n.a == HighlightingState.outward) {
                if (n.c) {
                    j = j + Math.min(n.d, b);
                    l++;
                }
                else {
                    h = h + Math.min(n.d, b);
                    k++;
                }
            }
        }
        h = h + this.d;
        this.d = 0;
        j = j + this.e;
        this.e = 0;
        var o = 1;
        var p = 1;
        if (f && h > g) {
            var q = h - g;
            o = g / h;
        }
        if (e && j > i) {
            var r = j - i;
            p = i / j;
        }
        var s;
        for (var t = 0; t < this.c.count; t++) {
            var u = this.c._inner[t];
            s = b;
            if (u.a == HighlightingState.outward) {
                s = Math.min(s, u.d);
                if (u.c) {
                    s = s * p;
                }
                else {
                    s = s * o;
                }
                u.d = u.d - s;
            }
            else {
                u.d = u.d + s;
            }
            if (u.a == 2) {
                u.d = 1;
            }
            if (u.d > 1) {
                u.d = 1;
            }
            if (u.d < 0) {
                u.d = 0;
            }
            if (u.c) {
                this.maxMarkerHighlightingProgress = Math.max(u.d, this.maxMarkerHighlightingProgress);
                this.sumMarkerHighlightingProgress = this.sumMarkerHighlightingProgress + u.d;
            }
            else {
                this.maxHighlightingProgress = Math.max(u.d, this.maxHighlightingProgress);
                this.sumHighlightingProgress = this.sumHighlightingProgress + u.d;
            }
            if (u.a != HighlightingState.outward && u.d != 1) {
                c = true;
            }
            if (u.a == HighlightingState.outward && u.d != 0) {
                c = true;
            }
            if (u.d == 1 && u.a == HighlightingState.inward) {
                u.a = 2;
            }
            if (u.d == 0 && u.a == HighlightingState.outward) {
                d.add(u);
            }
            if (!this.b.containsKey(u.b)) {
                this.b.addItem(u.b, true);
                this.dirtySeries.add(u.b);
            }
        }
        try {
            for (var _b = __values(fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var v = _c.value;
                this.a.removeItem(v);
                this.c.remove(v);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        if (this.a.count == 0) {
            this.inProgress = false;
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
        }
        if (!c) {
            this.f = 0;
        }
        return c;
    };
    Object.defineProperty(HighlightingManager.prototype, "inProgress", {
        get: function () {
            return this._inProgress;
        },
        set: function (a) {
            this._inProgress = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingManager.prototype, "maxHighlightingProgress", {
        get: function () {
            return this._maxHighlightingProgress;
        },
        set: function (a) {
            this._maxHighlightingProgress = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingManager.prototype, "sumHighlightingProgress", {
        get: function () {
            return this._sumHighlightingProgress;
        },
        set: function (a) {
            this._sumHighlightingProgress = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingManager.prototype, "maxMarkerHighlightingProgress", {
        get: function () {
            return this._maxMarkerHighlightingProgress;
        },
        set: function (a) {
            this._maxMarkerHighlightingProgress = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingManager.prototype, "sumMarkerHighlightingProgress", {
        get: function () {
            return this._sumMarkerHighlightingProgress;
        },
        set: function (a) {
            this._sumMarkerHighlightingProgress = a;
        },
        enumerable: true,
        configurable: true
    });
    HighlightingManager.$t = markType(HighlightingManager, 'HighlightingManager', Base.$, [IHighlightingManager_$type]);
    return HighlightingManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITileZoomTileInfo_$type = /*@__PURE__*/ new Type(null, 'ITileZoomTileInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TileZoomTileInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileZoomTileInfo, _super);
    function TileZoomTileInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._zoomLevel = 0;
        _this._xPosition = 0;
        _this._yPosition = 0;
        return _this;
    }
    Object.defineProperty(TileZoomTileInfo.prototype, "zoomLevel", {
        get: function () {
            return this._zoomLevel;
        },
        set: function (a) {
            this._zoomLevel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTileInfo.prototype, "xPosition", {
        get: function () {
            return this._xPosition;
        },
        set: function (a) {
            this._xPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTileInfo.prototype, "yPosition", {
        get: function () {
            return this._yPosition;
        },
        set: function (a) {
            this._yPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    TileZoomTileInfo.prototype.toString = function () {
        return this.zoomLevel + "_" + this.xPosition + "_" + this.yPosition;
    };
    TileZoomTileInfo.$t = markType(TileZoomTileInfo, 'TileZoomTileInfo', Base.$, [ITileZoomTileInfo_$type]);
    return TileZoomTileInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TileZoomInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileZoomInfo, _super);
    function TileZoomInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = null;
        _this.g = null;
        _this.e = 0;
        _this.d = 0;
        _this.c = 0;
        _this.b = 0;
        _this.a = 0;
        return _this;
    }
    TileZoomInfo.$t = markType(TileZoomInfo, 'TileZoomInfo');
    return TileZoomInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TileZoomManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileZoomManager, _super);
    function TileZoomManager(a, b, c) {
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.av = null;
        _this.aw = null;
        _this.au = null;
        _this.i = false;
        _this.v = 0;
        _this.k = null;
        _this.l = null;
        _this.n = null;
        _this.q = -1;
        _this.ao = null;
        _this.p = 1;
        _this.r = 1;
        _this.y = 0;
        _this.o = null;
        _this.m = null;
        _this.d = null;
        _this.f = false;
        _this.h = false;
        _this.e = a;
        var d = _this.e;
        d.actualWindowRectChanged = delegateCombine(d.actualWindowRectChanged, runOn(_this, _this.am));
        var e = _this.e;
        e.gridAreaRectChanged = delegateCombine(e.gridAreaRectChanged, runOn(_this, _this.an));
        _this.d = new TileZoomTileCache(c, _this);
        _this.o = new List$1(TileZoomTileInfo.$, 0);
        _this.m = new List$1(TileZoomTile.$, 0);
        _this.k = new Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
        _this.l = new Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
        _this.n = new List$1(ITileZoomTile_$type, 0);
        _this.h = b;
        _this.ai();
        return _this;
    }
    TileZoomManager.prototype.ai = function () {
        this.av = this.e.m3;
        this.ao = this.ap(this.av);
        var a = this.s();
        this.ac();
        this.ab();
        this.q = a;
        this.v = this.t(a);
        this.au = new Rect(0, 0, 0, a, a);
    };
    TileZoomManager.prototype.ap = function (a) {
        return new Rect(0, a.left, a.top, a.width * this.p, a.height * this.r);
    };
    TileZoomManager.prototype.t = function (a) {
        var b = a / 512;
        var c = logBase(b, 2);
        return c;
    };
    TileZoomManager.prototype.s = function () {
        var a = Math.max(this.ao.width, this.ao.height);
        var b = 1;
        var c = 512;
        while (c < a) {
            b++;
            c = 512 * b;
        }
        return c;
    };
    TileZoomManager.prototype.an = function (a, b) {
        this.ai();
        this.aj();
    };
    TileZoomManager.prototype.am = function (a, b) {
        this.aj();
    };
    TileZoomManager.prototype.aj = function () {
        this.f = true;
        this.aw = this.e.mq;
        if (this.i) {
            if (this.j(this.aw)) {
                this.ai();
            }
            this.af();
            this.ak();
            this.ag();
        }
    };
    TileZoomManager.prototype.j = function (a) {
        var b = 1;
        var c = 1;
        if (this.g(a)) {
            if (a.width > a.height) {
                var d = 1;
                if (a.height != 0) {
                    d = a.width / a.height;
                }
                var e = 0;
                var f = 1;
                while (f < d) {
                    e++;
                    f = truncate(Math.pow(3, e));
                }
                f = truncate(Math.pow(3, e - 1));
                c = f;
                if (c == 0 || isInfinity(c) || isNaN_(c)) {
                    c = 1;
                }
            }
            else {
                var g = 1;
                if (a.width != 0) {
                    g = a.height / a.width;
                }
                var h = 0;
                var i = 1;
                while (i < g) {
                    h++;
                    i = truncate(Math.pow(3, h));
                }
                i = truncate(Math.pow(3, h - 1));
                b = i;
                if (isInfinity(b) || isNaN_(b)) {
                    b = 1;
                }
            }
        }
        else {
            b = 1;
            c = 1;
        }
        var j = c != this.r || b != this.p;
        this.p = b;
        this.r = c;
        return j;
    };
    TileZoomManager.prototype.g = function (a) {
        return (a.width / a.height) > 3 || (a.height / a.width) > 3;
    };
    TileZoomManager.prototype.ag = function () {
        var e_1, _a;
        var a = this.a();
        for (var b = 0; b < this.m.count; b++) {
            this.aa(a, this.m._inner[b]);
        }
        var c = new Dictionary$2(Base.$, ITileZoomTile_$type, 0);
        try {
            for (var _b = __values(fromEnum(this.l.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.addItem(this.l.item(d).content, this.l.item(d));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.e.bn.b0(c, this.n, 512);
    };
    TileZoomManager.prototype.aa = function (a, b) {
        var c = this.as(b, a);
        var d = c.left * a.b;
        var e = c.top * a.a;
        var f = c.right * a.b;
        var g = c.bottom * a.a;
        var h = d - a.f.left;
        var i = e - a.f.top;
        var j = f - d;
        var k = g - e;
        b.xPosition = h / this.p;
        b.yPosition = i / this.r;
        b.width = j / this.p;
        b.height = k / this.r;
    };
    TileZoomManager.prototype.ak = function () {
        var e_2, _a;
        var a = this.a();
        this.k.clear();
        for (var b = 0; b < this.m.count; b++) {
            var c = this.m._inner[b];
            this.k.addItem(c, c);
        }
        this.m.clear();
        this.l.clear();
        this.n.clear();
        for (var d = 0; d < this.o.count; d++) {
            var e = this.o._inner[d];
            var f = this.d.b(e);
            if (f == null) {
                f = this.b(e, a);
                this.d.f(f);
            }
            if (this.k.containsKey(f)) {
                this.k.removeItem(f);
                this.l.addItem(f, f);
            }
            else {
                this.z(f);
                this.n.add(f);
            }
            this.m.add(f);
        }
        try {
            for (var _b = __values(fromEnum(this.k.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                this.ad(g);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    TileZoomManager.prototype.ad = function (a) {
    };
    TileZoomManager.prototype.z = function (a) {
    };
    TileZoomManager.prototype.b = function (a, b) {
        var c = this.c(a);
        var d = this.as(c, b);
        var e = this.ar();
        var f = 1 / e.width;
        var g = e.height;
        if (e.width > e.height) {
            f = e.width;
            g = 1 / e.height;
        }
        var h = (d.left - e.left) * f;
        var i = (d.top - e.top) * g;
        var j = (d.right - e.left) * f;
        var k = (d.bottom - e.top) * g;
        d = new Rect(0, h, i, j - h, k - i);
        var l = this.e.bn.bf(d, c, truncate(512));
        c.content = l;
        return c;
    };
    TileZoomManager.prototype.ar = function () {
        var a = this.e.m3;
        var b = this.e.mu;
        if (b.isEmpty) {
            return new Rect(0, 0, 0, 1, 1);
        }
        var c = (b.left - a.left) / a.width;
        var d = (b.top - a.top) / a.height;
        var e = (b.right - a.left) / a.width;
        var f = (b.bottom - a.top) / a.height;
        return new Rect(0, c, d, e - c, f - d);
    };
    TileZoomManager.prototype.as = function (a, b) {
        var c = a.info.xPosition * 512;
        var d = a.info.yPosition * 512;
        var e = c + 512;
        var f = d + 512;
        var g = c / b.d;
        var h = d / b.c;
        var i = 512 / b.d;
        var j = 512 / b.c;
        return new Rect(0, g, h, i, j);
    };
    TileZoomManager.prototype.c = function (a) {
        var b = 0;
        b = this.y;
        this.y++;
        var c = new TileZoomTile();
        c.info = a;
        c.iD = b;
        return c;
    };
    TileZoomManager.prototype.a = function () {
        var a = this.aq(this.aw);
        var b = this.x(a);
        var c = Math.pow(2, b) * 512;
        var d = c;
        var e = (this.ao.width / this.au.width) * c;
        var f = (this.ao.height / this.au.height) * d;
        var g = (this.ao.width / a.width);
        var h = (this.ao.height / a.height);
        var i = a.left * g;
        var j = a.top * h;
        var k = a.right * g;
        var l = a.bottom * h;
        var m = new TileZoomInfo();
        m.f = new Rect(0, i, j, k - i, l - j);
        var n = this.at(this.aw, m.f, b, g, h, e, f);
        var o = n.left * e;
        var p = n.top * f;
        var q = n.right * e;
        var r = n.bottom * f;
        m.g = new Rect(0, o, p, q - o, r - p);
        m.e = b;
        m.d = e;
        m.c = f;
        m.b = g;
        m.a = h;
        return m;
    };
    TileZoomManager.prototype.aq = function (a) {
        return a;
    };
    TileZoomManager.prototype.at = function (a, b, c, d, e, f, g) {
        var h = (a.left + a.right) / 2;
        var i = (a.top + a.bottom) / 2;
        var j = a.width;
        var k = a.height;
        j = j * d / f;
        k = k * e / g;
        var l = j / 2;
        var m = k / 2;
        return new Rect(0, h - l, i - m, j, k);
    };
    TileZoomManager.prototype.af = function () {
        var a = this.a();
        var b = 512 * a.b / a.d;
        var c = 512 * a.a / a.c;
        var d = truncate(Math.floor(a.f.left / b));
        var e = truncate(Math.floor(a.f.top / c));
        var f = truncate(Math.floor(a.f.right / b));
        var g = truncate(Math.floor(a.f.bottom / c));
        this.o.clear();
        var _loop_1 = function (h) {
            var _loop_2 = function (i) {
                this_1.o.add(((function () {
                    var $ret = new TileZoomTileInfo();
                    $ret.xPosition = i;
                    $ret.yPosition = h;
                    $ret.zoomLevel = a.e;
                    return $ret;
                })()));
            };
            for (var i = d; i <= f; i++) {
                _loop_2(i);
            }
        };
        var this_1 = this;
        for (var h = e; h <= g; h++) {
            _loop_1(h);
        }
    };
    TileZoomManager.prototype.x = function (a) {
        var b = 1 / a.width;
        var c = 1 / a.height;
        var d;
        var e;
        if (this.h) {
            d = Math.floor(logBase(b, 2));
            e = Math.floor(logBase(c, 2));
        }
        else {
            d = Math.ceil(logBase(b, 2));
            e = Math.ceil(logBase(c, 2));
        }
        var f = Math.min(d, e) + (this.v);
        return truncate(f);
    };
    TileZoomManager.prototype.ab = function () {
        if (!this.f) {
            return;
        }
        this.f = false;
        this.e.bn.bx();
        this.d.g();
    };
    TileZoomManager.prototype.al = function () {
        this.i = true;
    };
    TileZoomManager.prototype.ah = function () {
        this.i = false;
        this.e.bn.cf();
    };
    TileZoomManager.prototype.ae = function (a) {
        this.e.bn.by(a);
    };
    TileZoomManager.prototype.ac = function () {
        this.m.clear();
        this.o.clear();
        this.k.clear();
    };
    TileZoomManager.$t = markType(TileZoomManager, 'TileZoomManager');
    return TileZoomManager;
}(Base));
/**
 * @hidden
 */
var TileZoomTileCache = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileZoomTileCache, _super);
    function TileZoomTileCache(a, b) {
        var _this = _super.call(this) || this;
        _this.c = new Dictionary$2(String_$type, TileZoomTile.$, 0);
        _this.d = new LinkedList$1(TileZoomTile.$);
        _this.e = 0;
        _this.a = null;
        _this.e = a;
        _this.a = b;
        return _this;
    }
    TileZoomTileCache.prototype.g = function () {
        this.c.clear();
        this.d = new LinkedList$1(TileZoomTile.$);
    };
    TileZoomTileCache.prototype.i = function (a) {
        this.d.h(a.b);
        this.d.f(a);
        a.b = this.d.d;
    };
    TileZoomTileCache.prototype.f = function (a) {
        this.d.f(a);
        this.c.addItem(a.info.toString(), a);
        a.a = this;
        a.b = this.d.d;
        while (this.c.count > this.e) {
            this.h(this.d.c.c);
        }
    };
    TileZoomTileCache.prototype.h = function (a) {
        this.d.h(a.b);
        this.c.removeItem(a.info.toString());
        this.a.ae(a);
    };
    TileZoomTileCache.prototype.b = function (a) {
        if (this.c.containsKey(a.toString())) {
            var b = this.c.item(a.toString());
            b.touch();
            return b;
        }
        return null;
    };
    TileZoomTileCache.$t = markType(TileZoomTileCache, 'TileZoomTileCache');
    return TileZoomTileCache;
}(Base));
/**
 * @hidden
 */
var TileZoomTile = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileZoomTile, _super);
    function TileZoomTile() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._info = null;
        _this.a = null;
        _this.b = null;
        _this._content = null;
        _this._xPosition = 0;
        _this._width = 0;
        _this._yPosition = 0;
        _this._height = 0;
        _this._iD = 0;
        return _this;
    }
    Object.defineProperty(TileZoomTile.prototype, "info", {
        get: function () {
            return this._info;
        },
        set: function (a) {
            this._info = a;
        },
        enumerable: true,
        configurable: true
    });
    TileZoomTile.prototype.touch = function () {
        if (this.a == null) {
            return;
        }
        this.a.i(this);
    };
    Object.defineProperty(TileZoomTile.prototype, "content", {
        get: function () {
            return this._content;
        },
        set: function (a) {
            this._content = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTile.prototype, "xPosition", {
        get: function () {
            return this._xPosition;
        },
        set: function (a) {
            this._xPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTile.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTile.prototype, "yPosition", {
        get: function () {
            return this._yPosition;
        },
        set: function (a) {
            this._yPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTile.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TileZoomTile.prototype, "iD", {
        get: function () {
            return this._iD;
        },
        set: function (a) {
            this._iD = a;
        },
        enumerable: true,
        configurable: true
    });
    TileZoomTile.$t = markType(TileZoomTile, 'TileZoomTile', Base.$, [ITileZoomTile_$type]);
    return TileZoomTile;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesViewerInteractionManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerInteractionManager, _super);
    function SeriesViewerInteractionManager() {
        var _this = _super.call(this) || this;
        _this.r = 0;
        _this.s = 0;
        _this.af = null;
        _this.o = 0;
        _this.p = 0;
        _this.n = 0;
        _this.q = 0;
        _this.h = false;
        _this.ag = null;
        _this.ai = null;
        _this.j = false;
        _this.e = null;
        _this.b = null;
        _this.ah = null;
        _this.ak = null;
        _this.d = null;
        _this.a = null;
        _this.g = false;
        _this.ah = Rect.empty;
        _this.ag = Rect.empty;
        return _this;
    }
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "f$b", {
        get: function () {
            if (this.b == null) {
                this.b = new HighlightingManager();
            }
            return this.b;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerInteractionManager.prototype.f$a = function (a) {
        if (a.ap != 0) {
            return a.ap;
        }
        var b = 1;
        var c = false;
        var d = false;
        for (var e = 0; e < a.series.count; e++) {
            var f = a.series._inner[e];
            if (f.isStacked) {
                f.h7(function (g) {
                    if (g.bc == 2) {
                        c = true;
                    }
                    if (g.bc == 1) {
                        d = true;
                    }
                    return true;
                });
            }
            else {
                if (f.bc == 2) {
                    c = true;
                }
                if (f.bc == 1) {
                    d = true;
                }
            }
        }
        if (d) {
            b = 1;
        }
        if (c) {
            b = 2;
        }
        if (c && d) {
            b = 3;
        }
        return b;
    };
    SeriesViewerInteractionManager.prototype.f$al = function (a) {
        var b = a.mi;
        var c = b;
        var d = a.bn;
        var e = a.cc();
        var f = a.ce;
        var g = a.da;
        var h = a.df;
        if (!e) {
            c = { $type: Point_$type, x: NaN, y: NaN };
        }
        for (var i = 0; i < a.series.count; i++) {
            var j = a.series._inner[i];
            j.ic(c);
        }
        var k = a.bg == 0 && !a.cq && (a.ch || f) && !g && !h;
        var l = a.m3;
        if (k && !isNaN_(b.x) && !l.isEmpty) {
            var m = l.width * (b.x - a.mq.left) / a.mq.width;
            d.eg(l.left + m, l.top, l.left + m, l.bottom);
            d.d5();
            d.ea(m);
        }
        else {
            d.ce();
        }
        if (k && !isNaN_(b.y) && !l.isEmpty) {
            var n = l.height * (b.y - a.mq.top) / a.mq.height;
            d.d9(l.left, l.top + n, l.right, l.top + n);
            d.d1();
        }
        else {
            d.b9();
        }
    };
    SeriesViewerInteractionManager.prototype.f$ae = function (a) {
        switch (a.bg) {
            case 0:
                a.bn.dx();
                this.f$al(a);
                a.bn.b6();
                break;
            case 1:
                a.bn.dz();
                a.bn.cd();
                this.f$al(a);
                a.bn.b5();
                break;
            case 2:
                a.bn.dz();
                a.bn.cd();
                this.f$al(a);
                a.bn.b7();
                break;
        }
    };
    SeriesViewerInteractionManager.prototype.f$p = function (a, b) {
        if (b.x >= 0 && b.y >= 0 && b.x <= a.m3.width && b.y <= a.m3.height) {
            this.ab(a, b);
        }
        else {
            a.hn();
        }
    };
    SeriesViewerInteractionManager.prototype.ab = function (a, b) {
        var e_1, _a;
        var c = a.bn;
        var d = a.m3;
        if (a.cr || a.cq) {
            return;
        }
        if (a.ce && a.ch) {
            var e = d.height > d.width;
            c.bs(e);
            try {
                for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (f.isStacked) {
                        f.h7(function (g) {
                            if (g._visibility == 0) {
                                g.jj(b, runOn(c, c.bj));
                            }
                            return true;
                        });
                    }
                    else {
                        if (f._visibility == 0) {
                            f.jj(b, runOn(c, c.bj));
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            c.d2();
        }
    };
    SeriesViewerInteractionManager.prototype.aa = function (a, b) {
        if (a.ch || a.co) {
            a.ce = true;
            a.i5();
            this.ag = new Rect(0, b.x, b.y, 0, 0);
            this.ai = new Rect(0, b.x, b.y, 0, 0);
            a.bg = 0;
            a.hf(a.mk(b));
        }
    };
    SeriesViewerInteractionManager.prototype.f$ac = function (a, b) {
        this.aa(a, b);
        this.ab(a, b);
        this.f$al(a);
    };
    SeriesViewerInteractionManager.prototype.f$q = function (a, b, c) {
        if (!a.ce) {
            this.ad(a, b, c);
        }
    };
    SeriesViewerInteractionManager.prototype.f$o = function (a, b) {
        this.ah = Rect.empty;
        a.hn();
    };
    SeriesViewerInteractionManager.prototype.f$aj = function (a) {
        var b = a.bn;
        this.q = 1;
        a.ce = false;
        b.cc();
        b.b8();
        b.ca();
        a.hf({ $type: Point_$type, x: NaN, y: NaN });
        b.b9();
        b.ce();
        b.cd();
        a.bg = 0;
        this.h = true;
        a.da = true;
        a.i6();
    };
    SeriesViewerInteractionManager.prototype.f$ab = function (a, b) {
        this.f$aj(a);
    };
    SeriesViewerInteractionManager.prototype.f$ak = function (a, b, c, d, e) {
        this.r = b.x;
        this.s = b.y;
        this.o = c;
        this.p = d;
        this.n = e;
        this.af = a.mq;
        this.f$aj(a);
    };
    SeriesViewerInteractionManager.prototype.f$aa = function (a, b) {
        var c = a.bn;
        c.b9();
        c.ce();
        if (c.at) {
            this.w(a, b);
        }
        else {
            this.y(a, b);
            this.q = b;
        }
    };
    SeriesViewerInteractionManager.prototype.f$ag = function (a, b, c, d, e) {
        var f = a.bn;
        f.b9();
        f.ce();
        this.o = this.o * c;
        this.p = this.p * d;
        this.n = this.n * e;
        if (a.cw) {
            this.o = this.n;
            this.p = this.n;
        }
        var g = a.mq;
        var h = a.m3;
        var i = b.x - this.r;
        var j = b.y - this.s;
        this.r = b.x;
        this.s = b.y;
        var k = g.width;
        var l = g.height;
        var m = this.af.width / this.o;
        var n = this.af.height / this.p;
        if (m > 1) {
            m = 1;
        }
        if (n > 1) {
            n = 1;
        }
        var o = { $type: Point_$type, x: b.x, y: b.y };
        var p = { $type: Point_$type, x: (o.x - h.left) / h.width * g.width + g.left, y: (o.y - h.top) / h.height * g.height + g.top };
        var q = new Rect(0, g.left, g.top, m, n);
        var r = { $type: Point_$type, x: (p.x - q.left) / q.width * h.width + h.left, y: (p.y - q.top) / q.height * h.height + h.top };
        var s = (r.x - o.x) - i;
        var t = (r.y - o.y) - j;
        var u = s / h.width * q.width;
        var v = t / h.height * q.height;
        q = new Rect(0, q.left + u, q.top + v, q.width, q.height);
        g = q;
        a.kl(g, true);
    };
    SeriesViewerInteractionManager.prototype.f$x = function (a, b) {
        this.ag = new Rect(0, b.x, b.y, 0, 0);
        this.ai = new Rect(0, b.x, b.y, 0, 0);
    };
    SeriesViewerInteractionManager.prototype.x = function (a, b, c) {
        var d = a.mq.width;
        var e = a.mq.height;
        var f = a.mq.left + d / 2;
        var g = a.mq.top + e / 2;
        d = d / b;
        e = e / b;
        var h = f - d / 2;
        var i = g - e / 2;
        a.kl(new Rect(0, h, i, d, e), true);
    };
    SeriesViewerInteractionManager.prototype.f$z = function (a, b) {
        var c = a.bn;
        if (c.at) {
            this.w(a, b);
        }
        else {
            this.y(a, b);
        }
        this.ag = Rect.empty;
        a.da = false;
    };
    SeriesViewerInteractionManager.prototype.f$r = function (a, b) {
        a.da = false;
        this.ag = Rect.empty;
        a.hn();
    };
    SeriesViewerInteractionManager.prototype.f$af = function (a, b, c, d, e) {
        a.da = false;
        this.ag = Rect.empty;
        a.hn();
    };
    SeriesViewerInteractionManager.prototype.w = function (a, b) {
        var c = a.m4;
        var d = 1 / b;
        var e = { $type: Point_$type, x: c.x + c.width / 2, y: c.y + c.height / 2 };
        var f = { $type: Point_$type, x: c.x - e.x, y: c.y - e.y };
        var g = new Rect(0, f.x * d + e.x, f.y * d + e.y, c.width * d, c.height * d);
        a.kl(g, true);
    };
    SeriesViewerInteractionManager.prototype.y = function (a, b) {
        var c = a.m3;
        var d = a.m4;
        var e = b - this.q;
        if (e != 0) {
            var f = 0.03;
            var g = e < 0 ? 1 + f : 1 - f;
            var h = { $type: Point_$type, x: d.x + d.width / 2, y: d.y + d.height / 2 };
            var i = { $type: Point_$type, x: d.x - h.x, y: d.y - h.y };
            var j = new Rect(0, i.x * g + h.x, i.y * g + h.y, d.width * g, d.height * g);
            a.kl(j, true);
        }
    };
    SeriesViewerInteractionManager.prototype.f$m = function (a, b, c) {
        if (!a.da) {
            this.h = false;
        }
        this.ad(a, b, c);
    };
    SeriesViewerInteractionManager.prototype.ad = function (a, b, c) {
        var d;
        var e = a.bn;
        var f = a.bd(c);
        if (e.eq == 0) {
            switch (f) {
                case 1:
                    d = a.c2() ? f : 0;
                    break;
                default:
                    d = f;
                    break;
            }
        }
        else {
            if (e.eq == a.l0) {
                d = 1;
            }
            else if (e.eq == a.l1) {
                d = 2;
            }
            else {
                d = 0;
            }
        }
        switch (d) {
            case 1:
            case 2:
                a.bn.b3();
                a.bn.di();
                break;
        }
        a.bg = d;
        switch (a.bg) {
            case 1:
                a.hf({ $type: Point_$type, x: NaN, y: NaN });
                this.ag = new Rect(0, b.x, b.y, 0, 0);
                this.ai = new Rect(0, b.x, b.y, 0, 0);
                this.ah = new Rect(0, b.x, b.y, 0, 0);
                e.d0();
                e.d8(this.ag);
                a.jb(Rect.empty, true);
                break;
            case 2:
                this.ag = new Rect(0, b.x, b.y, 0, 0);
                this.ah = new Rect(0, b.x, b.y, 0, 0);
                break;
        }
        this.ak = a.mq;
    };
    SeriesViewerInteractionManager.prototype.f$ai = function (a) {
        a.j7();
        a.bn.dd();
    };
    SeriesViewerInteractionManager.prototype.f$ah = function (a) {
        a.hj();
        a.bn.dc();
    };
    SeriesViewerInteractionManager.prototype.f$am = function (a) {
        if (a.cb && !this.j) {
            this.j = true;
            this.ac(a);
        }
    };
    SeriesViewerInteractionManager.prototype.f$j = function (a) {
        if (this.j) {
            this.z(a);
            this.j = false;
        }
    };
    SeriesViewerInteractionManager.prototype.f$g = function (a) {
        if (this.e == null) {
            return;
        }
        this.f.ab();
    };
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerInteractionManager.prototype.ac = function (a) {
        if (this.e == null) {
            this.e = new TileZoomManager(a, true, a.e2);
            this.e.h = !a.db;
        }
        a.cn = true;
        a.ja();
        this.e.al();
        a.bn.bo();
        a.bn.bp();
    };
    SeriesViewerInteractionManager.prototype.z = function (a) {
        if (this.e == null) {
            return;
        }
        a.cn = false;
        a.bn.c8();
        this.e.ah();
        a.jt();
        a.bn.bv();
    };
    SeriesViewerInteractionManager.prototype.f$i = function (a) {
        a.hd();
        a.jv();
    };
    SeriesViewerInteractionManager.prototype.l = function (a) {
        return a.bg == 2;
    };
    SeriesViewerInteractionManager.prototype.m = function (a, b) {
        return a.ba == 1 || b || a.cb;
    };
    SeriesViewerInteractionManager.prototype.k = function (a) {
        return a.bg == 1;
    };
    SeriesViewerInteractionManager.prototype.f$l = function (a, b, c) {
        var d = a.bn;
        if (this.ag.isEmpty && c) {
            this.ad(a, b, c);
        }
        var e = 2;
        if (c) {
            e = 10;
        }
        var f = false;
        var g = new Rect(2, { $type: Point_$type, x: this.ag.x, y: this.ag.y }, b);
        var h = new Rect(0, 0, 0, 0, 0);
        if (!this.ah.isEmpty) {
            h = new Rect(2, { $type: Point_$type, x: this.ah.x, y: this.ah.y }, b);
        }
        if (h.width > e && h.height > e) {
            f = true;
        }
        if (!a.da) {
            if (f) {
                this.h = false;
            }
        }
        if (!a.da && (a.ce || !c)) {
            a.hf(a.mk(b));
        }
        if (this.k(a)) {
            if (f) {
                var i = a.m2(g);
                a.jb(i, true);
            }
            else {
                a.jb(Rect.empty, true);
            }
            d.d8(g);
        }
        var j = a.m3;
        var k = a.mq;
        if (this.l(a)) {
            var l = j;
            var m = k.left + k.width * (this.ag.x - b.x) / l.width;
            var n = k.top + k.height * (this.ag.y - b.y) / l.height;
            var o = new Rect(0, m, n, k.width, k.height);
            if (this.m(a, c)) {
                a.i6();
                a.jb(Rect.empty, true);
                a.kl(o, true);
                this.ag = new Rect(3, b, new Size(1, 0, 0));
                this.ai = new Rect(3, b, new Size(1, 0, 0));
            }
            else {
                a.jb(o, true);
            }
        }
        this.ai = new Rect(3, b, new Size(1, 0, 0));
        d.br(b);
    };
    SeriesViewerInteractionManager.prototype.f$k = function (a, b, c) {
        var d = a.bn;
        var e = 2;
        if (c) {
            e = 10;
        }
        var f = a.m3;
        var g = a.mq;
        if (!this.h) {
            var h = false;
            var i = new Rect(2, { $type: Point_$type, x: this.ag.x, y: this.ag.y }, b);
            if (i.width > e && i.height > e) {
                h = true;
            }
            if (a.bg == 1) {
                d.b8();
                if (h) {
                    a.kl(a.m2(i), true);
                }
            }
            if (a.bg == 2) {
                var j = f;
                var k = g.left + g.width * (this.ag.x - b.x) / j.width;
                var l = g.top + g.height * (this.ag.y - b.y) / j.height;
                a.kl(new Rect(0, k, l, g.width, g.height), true);
            }
        }
        var m = false;
        var n = new Rect(2, { $type: Point_$type, x: this.ah.x, y: this.ah.y }, b);
        if (n.width > e || n.height > e) {
            m = true;
        }
        if (m) {
            a.df = true;
        }
        a.bg = 0;
        a.jb(Rect.empty, true);
        d.bt();
        a.df = false;
        d.b9();
        d.ce();
        if (c) {
            d.cd();
            d.b9();
            d.ce();
            d.ca();
        }
        a.hn();
        a.i5();
    };
    SeriesViewerInteractionManager.prototype.f$ad = function (a) {
        if (this.f != null) {
            this.f.h = !a.db;
        }
    };
    SeriesViewerInteractionManager.prototype.f$d = function (a, b) {
        var c = a.bn;
        var d = a.mq;
        if (a.bg == 2 && b == 8) {
            c.bq();
            a.bg = 0;
            a.i5();
            a.jb(Rect.empty, true);
            if (a.ba == 1) {
                a.kl(this.ak, true);
            }
            return true;
        }
        if (a.bg == 1 && b == 8) {
            c.bq();
            a.bg = 0;
            a.i5();
            c.b8();
            a.jb(Rect.empty, true);
            return true;
        }
        var e = Rect.empty;
        var f = false;
        switch (b) {
            case 13:
                f = true;
                e = new Rect(0, 0, 0, 1, 1);
                break;
            case 11:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top - 0.1 * d.height, 1.2 * d.width, 1.2 * d.height);
                break;
            case 10:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top + 0.1 * d.height, 0.8 * d.width, 0.8 * d.height);
                break;
            case 14:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.min(e.left, 0);
                break;
            case 16:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.max(e.right - 1, 0);
                break;
            case 15:
                f = true;
                e = new Rect(0, d.left, d.top - 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.min(e.top, 0);
                break;
            case 17:
                f = true;
                e = new Rect(0, d.left, d.top + 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.max(e.bottom - 1, 0);
                break;
        }
        if (!e.isEmpty && Rect.l_op_Inequality(e, d)) {
            a.kl(e, true);
        }
        return f;
    };
    SeriesViewerInteractionManager.prototype.f$e = function (a, b, c) {
        var d = a.bn;
        var e = a.mq;
        var f = e.left + e.width * b.x / a.m3.width;
        var g = e.top + e.height * b.y / a.m3.height;
        var h = 1 - MathUtil.b(c, -0.5, 0.5);
        var i = Math.max(0, f - h * (f - e.left));
        var j = Math.min(1, g + h * (e.bottom - g));
        var k = Math.min(1, f + h * (e.right - f));
        var l = Math.max(0, g - h * (g - e.top));
        a.i6();
        this.v(a, 1000);
        a.kl(new Rect(0, i, l, k - i, j - l), true);
        return a.c2();
    };
    SeriesViewerInteractionManager.prototype.v = function (a, b) {
        a.bn.bw(b);
    };
    SeriesViewerInteractionManager.prototype.f$n = function (a, b) {
        var c = a.mq;
        var d = c.left + c.width * b.x / a.m3.width;
        var e = c.top + c.height * b.y / a.m3.height;
        var f = 0.7;
        var g = Math.max(0, d - f * (d - c.left));
        var h = Math.min(1, e + f * (c.bottom - e));
        var i = Math.min(1, d + f * (c.right - d));
        var j = Math.max(0, e - f * (e - c.top));
        a.kl(new Rect(0, g, j, i - g, h - j), true);
    };
    SeriesViewerInteractionManager.prototype.f$h = function (a) {
        this.f.ac();
    };
    SeriesViewerInteractionManager.prototype.aj = function () {
        return this.ai;
    };
    SeriesViewerInteractionManager.prototype.f$c = function (a, b, c, d, e, f, g) {
        var e_2, _a;
        var h = true;
        var i = false;
        var j = false;
        var k = a;
        if (k.ao == 1) {
            h = false;
            i = true;
        }
        if (k.ao == 3 || k.ao == 4) {
            i = true;
        }
        if (k.ao == 4) {
            j = true;
        }
        var l = truncate(Math.round(d.x));
        var m = truncate(Math.round(d.y));
        f = null;
        var n = -1;
        if (h && c != null) {
            var o = l;
            var p = m;
            if (a.ea != 1) {
                o = truncate(Math.round(d.x * a.ea));
                p = truncate(Math.round(d.y * a.ea));
            }
            var q = c.a(o, p);
            if (q == null || q.length == 0) {
                f = null;
                return {
                    ret: null,
                    p5: f
                };
            }
            if ((q[0] > 0 || q[1] > 0 || q[2] > 0) && q[3] == 255) {
                var num2_ = q[2];
                if (num2_ % 4 != 0) {
                    num2_ = num2_ + (4 - (num2_ % 4));
                }
                var num1_ = q[1];
                if (num1_ % 4 != 0) {
                    num1_ = num1_ + (4 - (num1_ % 4));
                }
                var num0_ = q[0];
                if (num0_ % 4 != 0) {
                    num0_ = num0_ + (4 - (num0_ % 4));
                }
                var num_ = 0;
                num_ = (num2_ >> 2);
                num_ = (num_ << 6);
                num_ = (num_ | (num1_ >> 2));
                num_ = (num_ << 6);
                num_ = (num_ | (num0_ >> 2));
                n = truncate(Math.floor((intDivide(num_, 1000))));
                n--;
            }
        }
        var r = null;
        var s = -1;
        if (n >= 0) {
            var t_1 = false;
            var u_1 = 0;
            try {
                for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var v = _c.value;
                    if (!v.c7) {
                        continue;
                    }
                    if (t_1) {
                        break;
                    }
                    if (v.isStacked) {
                        v.h7(function (w) {
                            if (w.fk == n) {
                                r = w;
                                s = u_1;
                                t_1 = true;
                                return false;
                            }
                            return true;
                        });
                    }
                    else if (v.fk == n) {
                        r = v;
                        s = u_1;
                        break;
                    }
                    u_1++;
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var w = null;
        if (i) {
            var x = false;
            for (var y = b.count - 1; y >= 0; y--) {
                var z = b._inner[y];
                var aa = z.bi;
                if (!z.dw(aa.br, aa.bs, aa)) {
                    continue;
                }
                if (!x && y < s && h && !j) {
                    if (r != null) {
                        w = r;
                        x = true;
                        break;
                    }
                }
                if (z != null && z.bc == 1) {
                    if (z.dh(d, g)) {
                        w = z;
                        break;
                    }
                }
            }
            if (h && !x) {
                if (r != null) {
                    w = r;
                    x = true;
                }
            }
        }
        else {
            w = r;
        }
        if (w != null) {
            var ab = w.ar({ $type: Point_$type, x: l, y: m }, g);
            if (ab != null) {
                f = ab;
            }
            return {
                ret: w,
                p5: f
            };
        }
        return {
            ret: null,
            p5: f
        };
    };
    SeriesViewerInteractionManager.prototype.f$f = function (a, b) {
        if (PointUtil.equals(b, null)) {
            return false;
        }
        var c = b.x;
        var d = b.y;
        if (c >= a.m3.left && d >= a.m3.top && c <= a.m3.left + a.m3.width && d <= a.m3.top + a.m3.height) {
            var e = a.bi;
            if (e != null && e.viewShouldInteract(b)) {
                return false;
            }
            return true;
        }
        return false;
    };
    SeriesViewerInteractionManager.prototype.c = function (a) {
        if (a != null) {
            return a.a6();
        }
        else {
            return null;
        }
    };
    SeriesViewerInteractionManager.prototype.f$v = function (a, b, c, d, e, f) {
        var _this = this;
        if (!f && a.ca) {
            this.ae(a, false);
        }
        var g = new MouseEventArgs();
        g.position = d;
        if (a.bg == 2 || a.bg == 1 || a.da || (a.bi != null && a.bi.isPinching)) {
            if (this.d != null) {
                this.d.a0.a$x(this.d, g.position, this.a, g);
                this.d = null;
            }
            return;
        }
        var h = null;
        var i = ((function () { var j = _this.f$c(a, b, c, d, !e, h, f); h = j.p5; return j.ret; })());
        this.a = h;
        var j = this.c(i);
        if (i != null) {
            var k = false;
            var l = false;
            if (this.d != i) {
                l = true;
            }
            if (this.d == null || l) {
                k = true;
            }
            if (k) {
                if (l) {
                    if (this.d != null) {
                        j = this.c(this.d);
                        this.d.a0.a$x(this.d, g.position, h, g);
                        if (j != null) {
                            j.a0.a$x(j, g.position, h, g);
                        }
                    }
                }
                this.d = i;
                i.ir(g.position, h, g);
                if (j != null) {
                    j.ir(g.position, h, g);
                }
            }
            else {
                this.d = i;
                i.a0.a$z(i, g.position, h, g);
                if (j != null) {
                    j.a0.a$z(j, g.position, h, g);
                }
            }
        }
        else {
            if (this.d != null) {
                j = this.c(this.d);
                this.d.a0.a$x(this.d, g.position, h, g);
                if (j != null) {
                    j.a0.a$x(j, g.position, h, g);
                }
                this.d = null;
            }
            for (var m = 0; m < a.series.count; m++) {
                var n = a.series._inner[m];
                if (n.a0.a$b) {
                    j = this.c(n);
                    n.a0.a$x(n, g.position, n.a0.a$o, g);
                    if (j != null) {
                        j.a0.a$x(j, g.position, n.a0.a$o, g);
                    }
                }
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$u = function (a, b) {
        if (this.d != null) {
            var c = this.c(this.d);
            var d = new MouseEventArgs();
            d.position = b;
            this.d.a0.a$x(this.d, d.position, null, d);
            if (c != null) {
                c.a0.a$x(c, d.position, null, d);
            }
            this.d = null;
        }
        a.im(b);
    };
    SeriesViewerInteractionManager.prototype.f$t = function (a, b, c) {
        if (this.d != null) {
            var d = new MouseButtonEventArgs();
            d.position = c;
            if (b.ai) {
                this.d.a0.a$aa(this.d, d.position, this.a, d);
            }
            else {
                this.d.a0.a$u(this.d, d.position, this.a, d);
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$w = function (a, b, c) {
        var d;
        var e = (this.d != null) ? this.d : ((function () { var f = a.bn.e(c, false, d, false); d = f.p2; return f.ret; })());
        if (e != null) {
            var f = new MouseButtonEventArgs();
            f.position = c;
            if (b.ai) {
                e.a0.a$ab(e, f.position, this.a, f);
            }
            else {
                e.a0.a$y(e, f.position, this.a, f);
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$s = function (a, b, c) {
        if (!c && a.c7) {
            this.ae(a, false);
        }
        if (c && !a.c7) {
            this.ae(a, true);
        }
        a.h7(b, c);
    };
    SeriesViewerInteractionManager.prototype.ae = function (a, b) {
        if (a != null) {
            if (!this.i) {
                a.ca = b;
            }
        }
    };
    SeriesViewerInteractionManager.prototype.f$y = function (a, b) {
        this.g = true;
    };
    Object.defineProperty(SeriesViewerInteractionManager.prototype, "i", {
        get: function () {
            return this.g;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerInteractionManager.$t = markType(SeriesViewerInteractionManager, 'SeriesViewerInteractionManager', Base.$, [ISeriesViewerInteractionManager_$type]);
    return SeriesViewerInteractionManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var InteractivityFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(InteractivityFactoryManager, _super);
    function InteractivityFactoryManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InteractivityFactoryManager.register = function () {
        if (!InteractivityFactoryManager.a) {
            TypeRegistrar.register("InteractivityFactoryManager", InteractivityFactoryManager.$);
            DVContainer.instance.registerFactory(ISeriesInteractionManager_$type, function () { return new SeriesInteractionManager(); });
            DVContainer.instance.registerFactory(ICategorySeriesInteractionManager_$type, function () { return new CategorySeriesInteractionManager(); });
            DVContainer.instance.registerFactory(IAnchoredCategorySeriesInteractionManager_$type, function () { return new AnchoredCategorySeriesInteractionManager(); });
            DVContainer.instance.registerFactory(IHorizontalAnchoredCategorySeriesInteractionManager_$type, function () { return new HorizontalAnchoredCategorySeriesInteractionManager(); });
            DVContainer.instance.registerFactory(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return new VerticalAnchoredCategorySeriesInteractionManager(); });
            DVContainer.instance.registerFactory(ISeriesViewerInteractionManager_$type, function () { return new SeriesViewerInteractionManager(); });
            InteractivityFactoryManager.a = true;
        }
    };
    InteractivityFactoryManager.$t = markType(InteractivityFactoryManager, 'InteractivityFactoryManager');
    InteractivityFactoryManager.a = false;
    return InteractivityFactoryManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function hasOpen(series) {
    return series.openMemberPath;
}
function getOpenValue(series, item) {
    return getItemValue(series, item, "openMemberPath");
}
function hasHigh(series) {
    return series.highMemberPath;
}
function getHighValue(series, item) {
    return getItemValue(series, item, "highMemberPath");
}
function hasLow(series) {
    return series.lowMemberPath;
}
function getLowValue(series, item) {
    return getItemValue(series, item, "lowMemberPath");
}
function hasClose(series) {
    return series.closeMemberPath;
}
function getCloseValue(series, item) {
    return getItemValue(series, item, "closeMemberPath");
}
function hasVolume(series) {
    return series.volumeMemberPath;
}
function getVolumeValue(series, item) {
    return getItemValue(series, item, "volumeMemberPath");
}
function getAnchoredValue(series, item) {
    return getItemValue(series, item, "valueMemberPath");
}
function getXValue(series, item) {
    return getItemValue(series, item, "xMemberPath");
}
function getYValue(series, item) {
    return getItemValue(series, item, "yMemberPath");
}
function hasRadius(series) {
    return series.radiusMemberPath !== undefined;
}
function getRadiusValue(series, item) {
    return getItemValue(series, item, "radiusMemberPath");
}
function getAngleValue(series, item) {
    return getItemValue(series, item, "angleMemberPath");
}
function hasValue(series) {
    return series.valueMemberPath;
}
function getBrush(series) {
    return series.actualBrush;
}
function hasXY(series, item) {
    return series.xMemberPath && series.yMemberPath && item[series.xMemberPath] && item[series.yMemberPath];
}
function hasColor(series) {
    return series.colorMemberPath;
}
function getColorValue(series, item) {
    return getItemValue(series, item, "colorMemberPath");
}
function getItemValue(series, item, memberPath) {
    return series.getItemValue(item, memberPath);
}
function asAny(item) {
    return item;
}
function format(value) {
    if (value == undefined || value == null) {
        return "";
    }
    if (value.getTime) {
        return shortDate(value);
    }
    return value.toString();
}
function shortDate(item) {
    if (item == undefined || item == null) {
        return "";
    }
    return item.toLocaleDateString() + " " + item.toLocaleTimeString();
}
var AnchoredCategoryTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var anc = props.dataContext.series;
    if (anc === null) {
        return null;
    }
    var s = anc;
    var catAxis = null;
    if (anc.isVertical) {
        catAxis = anc.yAxis;
    }
    else {
        catAxis = anc.xAxis;
    }
    if (catAxis == null) {
        return null;
    }
    var item = props.dataContext.item;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, catAxis.isDateTime && createElement("span", null, shortDate(catAxis.getItemValue(asAny(props.dataContext.item), "dateTimeMemberPath"))), catAxis.isDateTime && createElement("br", null), (!catAxis.isDateTime && catAxis.label) && createElement("span", null, format(asAny(item)[catAxis.label])), (!catAxis.isDateTime && catAxis.label) && createElement("br", null), createElement("span", { style: { color: getBrush(s) } }, s.title, ": "), createElement("span", { className: "ui-tooltip-priority" }, getAnchoredValue(s, item))));
};
var ScatterTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var ss = props.dataContext.series;
    if (ss === null) {
        return null;
    }
    var s = ss;
    var item = props.dataContext.item;
    if (hasRadius(s)) {
        return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, createElement("span", { style: { color: getBrush(s) } }, s.title), createElement("br", null), createElement("span", { className: "ui-tooltip-priority" }, "(", getXValue(s, item), ", ", getYValue(s, item), "), radius: ", getRadiusValue(s, item))));
    }
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, createElement("span", { style: { color: getBrush(s) } }, s.title), createElement("br", null), createElement("span", { className: "ui-tooltip-priority" }, "x: ", getXValue(s, item)), createElement("br", null), createElement("span", { className: "ui-tooltip-priority" }, "y: ", getYValue(s, item))));
};
var FinancialTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var fin = props.dataContext.series;
    if (fin === null) {
        return null;
    }
    var s = fin;
    var catAxis = fin.xAxis;
    if (catAxis == null) {
        return null;
    }
    var item = props.dataContext.item;
    var itemLabel = props.dataContext.itemLabel;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, catAxis.isDateTime && createElement("span", null, " ", itemLabel, " "), catAxis.isDateTime && createElement("br", null), (!catAxis.isDateTime && catAxis.label) && createElement("span", null, format(catAxis.getItemValue(asAny(item), "label"))), (!catAxis.isDateTime && catAxis.label) && createElement("br", null), createElement("span", { style: { color: getBrush(s) } }, s.title, ": "), createElement("table", null, createElement("tbody", null, hasOpen(s) ? createElement("tr", null, createElement("td", null, "Open: "), createElement("td", null, getOpenValue(s, item))) : null, hasHigh(s) ? createElement("tr", null, createElement("td", null, "High: "), createElement("td", null, getHighValue(s, item))) : null, hasLow(s) ? createElement("tr", null, createElement("td", null, "Low: "), createElement("td", null, getLowValue(s, item))) : null, hasClose(s) ? createElement("tr", null, createElement("td", null, "Close: "), createElement("td", null, getCloseValue(s, item))) : null, hasVolume(s) ? createElement("tr", null, createElement("td", null, "Volume: "), createElement("td", null, getVolumeValue(s, item))) : null))));
};
var PolarTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var ss = props.dataContext.series;
    if (ss === null) {
        return null;
    }
    var s = ss;
    var item = props.dataContext.item;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, createElement("span", { className: "ui-tooltip-priority" }, getAngleValue(s, item)), createElement("br", null), createElement("span", { style: { color: getBrush(s) } }, s.title, ": "), createElement("span", { className: "ui-tooltip-priority" }, getRadiusValue(s, item))));
};
var RadialTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var ss = props.dataContext.series;
    if (ss === null) {
        return null;
    }
    var angleAxis = ss.angleAxis;
    if (angleAxis == null) {
        return null;
    }
    var s = ss;
    var item = props.dataContext.item;
    var axisLabel = angleAxis.label;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, axisLabel && createElement("span", { className: "ui-tooltip-priority" }, axisLabel), axisLabel && createElement("br", null), createElement("span", { style: { color: getBrush(s) } }, s.title, ": "), createElement("span", { className: "ui-tooltip-priority" }, getAnchoredValue(s, item))));
};
var RangeCategoryTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var anc = props.dataContext.series;
    if (anc === null) {
        return null;
    }
    var s = anc;
    var catAxis = anc.xAxis;
    if (catAxis == null) {
        return null;
    }
    var item = props.dataContext.item;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, catAxis.isDateTime && createElement("span", null, shortDate(catAxis.getItemValue(asAny(props.dataContext.item), "dateTimeMemberPath"))), catAxis.isDateTime && createElement("br", null), (!catAxis.isDateTime && catAxis.label) && createElement("span", null, format(catAxis.getItemValue(asAny(item), "label"))), (!catAxis.isDateTime && catAxis.label) && createElement("br", null), createElement("span", { style: { color: getBrush(s) } }, s.title, ": "), createElement("span", { className: "ui-tooltip-priority" }, getLowValue(s, item), " - "), createElement("span", { className: "ui-tooltip-priority" }, getHighValue(s, item))));
};
var ShapeTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var ss = props.dataContext.series;
    if (ss === null) {
        return null;
    }
    var s = ss;
    var item = props.dataContext.item;
    var showXY = hasXY(s, item);
    return (createElement("div", { className: 'ui-chart-default-tooltip-content', style: { whiteSpace: "nowrap" } }, createElement("span", { style: { color: getBrush(s) } }, s.title), showXY && createElement("br", null), showXY && createElement("span", null, "(", getXValue(s, item), ", ", getYValue(s, item), ") "), hasColor(s) && createElement("br", null), hasColor(s) && createElement("span", null, "value: ", getColorValue(s, item)), hasValue(s) && createElement("br", null), hasValue(s) && createElement("span", null, "value: ", item)));
};
var IgrDataChartDefaultTooltips = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartDefaultTooltips() {
        this.anchoredCategoryTooltip = AnchoredCategoryTooltip;
        this.financialTooltip = FinancialTooltip;
        this.polarTooltip = PolarTooltip;
        this.radialTooltip = RadialTooltip;
        this.rangeCategoryTooltip = RangeCategoryTooltip;
        this.scatterTooltip = ScatterTooltip;
        this.shapeTooltip = ShapeTooltip;
    }
    IgrDataChartDefaultTooltips.prototype.ensureDefaultTooltip = function (series) {
        if (series.isPolar) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.polarTooltip;
            }
            else {
                if (series.tooltipTemplate === this.polarTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isRadial) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.radialTooltip;
            }
            else {
                if (series.tooltipTemplate === this.radialTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isShape) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.shapeTooltip;
            }
            else {
                if (series.tooltipTemplate === this.shapeTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isScatter) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.scatterTooltip;
            }
            else {
                if (series.tooltipTemplate === this.scatterTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isCategory &&
            !series.isFinancial) {
            if (!series.isRange) {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.anchoredCategoryTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.anchoredCategoryTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
            else {
                if (series.showDefaultTooltip) {
                    series.tooltipTemplate = this.rangeCategoryTooltip;
                }
                else {
                    if (series.tooltipTemplate === this.rangeCategoryTooltip) {
                        series.tooltipTemplate = null;
                    }
                }
            }
        }
        else if (series.isFinancial) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.financialTooltip;
            }
            else {
                if (series.tooltipTemplate === this.financialTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
    };
    IgrDataChartDefaultTooltips.register = function () {
        TypeRegistrar.registerCons("IgrDataChartDefaultTooltips", IgrDataChartDefaultTooltips);
    };
    return IgrDataChartDefaultTooltips;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartInteractivityModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartInteractivityModule() {
    }
    IgrDataChartInteractivityModule.register = function () {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        TypeRegistrar.registerCons('IgrDataChartDefaultTooltips', IgrDataChartDefaultTooltips);
        TypeRegistrar.registerCons('IgrDataChartDefaultTooltips', IgrDataChartDefaultTooltips);
        IgrDVInteractivityModule.register();
    };
    return IgrDataChartInteractivityModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrendLineManager_$type = /*@__PURE__*/ new Type(null, 'ITrendLineManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendLineManagerBase$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendLineManagerBase$1, _super);
    function TrendLineManagerBase$1($tTrendColumn) {
        var _this = _super.call(this) || this;
        _this.$tTrendColumn = null;
        _this.d = null;
        _this.a = null;
        _this.o = ((function () {
            var $ret = new Polyline();
            $ret.ab = false;
            return $ret;
        })());
        _this.$tTrendColumn = $tTrendColumn;
        _this.$type = _this.$type.specialize(_this.$tTrendColumn);
        _this.d = new List$1(_this.$tTrendColumn, 0);
        return _this;
    }
    Object.defineProperty(TrendLineManagerBase$1.prototype, "g$j", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    TrendLineManagerBase$1.prototype.g$g = function (a) {
        this.g$h(a, null);
    };
    TrendLineManagerBase$1.prototype.c = function (a) {
        return a == 1 || a == 2 || a == 3 || a == 4 || a == 5 || a == 6 || a == 7 || a == 8;
    };
    TrendLineManagerBase$1.prototype.b = function (a) {
        return a == 9 || a == 10 || a == 11 || a == 12 || a == 13;
    };
    TrendLineManagerBase$1.prototype.g$h = function (a, b) {
        var e_1, _a;
        this.g$j.ak.clear();
        if (b != null) {
            b.i = this.g$j.ak;
        }
        if (a != null) {
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (!isNaN_(c.x) && !isNaN_(c.y)) {
                        if (b != null) {
                            b.j(c);
                        }
                        else {
                            this.g$j.ak.add(c);
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        this.g$j.ab = this.g$j.ak.count > 0;
    };
    TrendLineManagerBase$1.prototype.m = function (a, b, c) {
        this.n(a, b, c, null);
    };
    TrendLineManagerBase$1.prototype.n = function (a, b, c, d) {
        var e_2, _a;
        if (d != null) {
            d.i = c;
        }
        try {
            for (var _b = __values(fromEnum(Flattener.d(a.count, function (f) { return a.item(f).x; }, function (f) { return a.item(f).y; }, b.b))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (d != null) {
                    d.j(a.item(e));
                }
                else {
                    c.add(a.item(e));
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    TrendLineManagerBase$1.prototype.g$c = function (a, b) {
        if (a == null || b == null) {
            return;
        }
        if (this.g$j.x != null) {
            this.g$f();
        }
        a.ab.add(this.g$j);
    };
    TrendLineManagerBase$1.prototype.g$f = function () {
        if (this.g$j == null) {
            return;
        }
        var a = typeCast(Panel.$, this.g$j.x);
        if (a != null) {
            a.ab.remove(this.g$j);
        }
    };
    TrendLineManagerBase$1.prototype.g$d = function () {
        this.g$j.ak.clear();
    };
    TrendLineManagerBase$1.prototype.g$i = function () {
        this.a = null;
        this.d.clear();
    };
    TrendLineManagerBase$1.prototype.g$e = function (a, b, c, d) {
        switch (a) {
            case 3:
            case 2:
            case 1:
            case 0:
            case 4:
                this.g$i();
                break;
        }
    };
    TrendLineManagerBase$1.prototype.g$b = function (a, b, c, d) {
        var e = false;
        switch (b) {
            case "TrendLineType":
            case "TrendLinePeriod":
                this.g$i();
                e = true;
                break;
            case "TrendLineThickness":
                e = true;
                break;
            case Series.$$p[8]:
                e = true;
                this.g$i();
                break;
        }
        return e;
    };
    TrendLineManagerBase$1.$t = markType(TrendLineManagerBase$1, 'TrendLineManagerBase$1', Base.$, [ITrendLineManager_$type]);
    return TrendLineManagerBase$1;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendResolutionParams = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendResolutionParams, _super);
    function TrendResolutionParams() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = 0;
        _this.e = 0;
        _this.c = 0;
        _this.f = null;
        _this.g = null;
        _this.b = 0;
        _this.a = 0;
        return _this;
    }
    TrendResolutionParams.$t = markType(TrendResolutionParams, 'TrendResolutionParams');
    return TrendResolutionParams;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTrendLineManagerBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTrendLineManagerBase, _super);
    function CategoryTrendLineManagerBase() {
        return _super.call(this, Number_$type) || this;
    }
    CategoryTrendLineManagerBase.prototype.get_g$a = function () {
        return 0;
    };
    Object.defineProperty(CategoryTrendLineManagerBase.prototype, "g$a", {
        get: function () {
            return this.get_g$a();
        },
        enumerable: true,
        configurable: true
    });
    CategoryTrendLineManagerBase.prototype.prepareLine = function (a, b, c, d) {
        var e = b.k;
        var f = new ScalerParams(0, b.m, b.l, b.b.j$a, e);
        var g = new ScalerParams(0, b.m, b.l, b.c.j$a, e);
        if (typeCast(Series.$, a) !== null) {
            g.b = a.eh();
        }
        var h = c.f;
        if (b.d != null && b.d.i$b != null) {
            h = new SafeSortedReadOnlyDoubleCollection(0, h, b.d.i$b);
        }
        var i = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.h;
            $ret.d = b.i;
            $ret.e = b.j;
            $ret.a = d;
            $ret.b = b.g;
            $ret.f = b.l;
            return $ret;
        })());
        if (a.trendLineType != 0) {
            if (a.isVertical) {
                this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, function (j) { return b.c.j$b(j, g); }, function (j) { return b.b.j$b(j, f); }, i);
            }
            else {
                this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, function (j) { return b.b.j$b(j, f); }, function (j) { return b.c.j$b(j, g); }, i);
            }
        }
    };
    CategoryTrendLineManagerBase.$t = markType(CategoryTrendLineManagerBase, 'CategoryTrendLineManagerBase', TrendLineManagerBase$1.$.specialize(Number_$type), [IPreparesCategoryTrendline_$type]);
    return CategoryTrendLineManagerBase;
}(TrendLineManagerBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendFitCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendFitCalculator, _super);
    function TrendFitCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TrendFitCalculator.a = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (d == null) {
            switch (b) {
                case 1:
                    d = LeastSquaresFit.k(e, f, g);
                    break;
                case 2:
                    d = LeastSquaresFit.o(e, f, g);
                    break;
                case 3:
                    d = LeastSquaresFit.i(e, f, g);
                    break;
                case 4:
                    d = LeastSquaresFit.p(e, f, g);
                    break;
                case 5:
                    d = LeastSquaresFit.q(e, f, g);
                    break;
                case 7:
                    d = LeastSquaresFit.j(e, f, g);
                    break;
                case 6:
                    d = LeastSquaresFit.l(e, f, g);
                    break;
                case 8:
                    d = LeastSquaresFit.n(e, f, g);
                    break;
                default: throw new NotImplementedException(0);
            }
        }
        if (d == null) {
            return null;
        }
        for (var l = 0; l < c.f.width; l += 2) {
            var m = l / (c.f.width - 1);
            var n = j + m * (k - j);
            var o = NaN;
            switch (b) {
                case 1:
                    o = LeastSquaresFit.ad(d, n);
                    break;
                case 2:
                    o = LeastSquaresFit.ah(d, n);
                    break;
                case 3:
                    o = LeastSquaresFit.ab(d, n);
                    break;
                case 4:
                    o = LeastSquaresFit.ai(d, n);
                    break;
                case 5:
                    o = LeastSquaresFit.aj(d, n);
                    break;
                case 7:
                    o = LeastSquaresFit.ac(d, n);
                    break;
                case 6:
                    o = LeastSquaresFit.ae(d, n);
                    break;
                case 8:
                    o = LeastSquaresFit.ag(d, n);
                    break;
                default: throw new NotImplementedException(0);
            }
            n = h(n);
            o = i(o);
            if (!isNaN_(o) && !isInfinity(o)) {
                a.add({ $type: Point_$type, x: n + c.a, y: o });
            }
        }
        return d;
    };
    TrendFitCalculator.$t = markType(TrendFitCalculator, 'TrendFitCalculator');
    return TrendFitCalculator;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendAverageCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendAverageCalculator, _super);
    function TrendAverageCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TrendAverageCalculator.a = function (a, b, c) {
        var d;
        switch (a) {
            case 9:
            case 10:
            case 11:
            case 13:
                if (c < 1) {
                    c = 1;
                }
                break;
        }
        switch (a) {
            case 9:
                d = TrendCalculators.e(b, c);
                break;
            case 10:
                d = TrendCalculators.b(b, c);
                break;
            case 11:
                d = TrendCalculators.c(b, c);
                break;
            case 12:
                d = TrendCalculators.a(b);
                break;
            case 13:
                d = TrendCalculators.g(b, c);
                break;
            default: throw new NotImplementedException(0);
        }
        return d;
    };
    TrendAverageCalculator.b = function (a, b, c, d) {
        var e_1, _a;
        if (b.count == 0) {
            var e = TrendAverageCalculator.a(a, c, d);
            try {
                for (var _b = __values(fromEnum(e)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    b.add(f);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    TrendAverageCalculator.c = function (a, b, c, d, e) {
        if (b.count == 0) {
            var f = getEnumerator(TrendAverageCalculator.a(a, c, e));
            var g = getEnumerator(TrendAverageCalculator.a(a, d, e));
            while (f.moveNext() && g.moveNext()) {
                b.add({ $type: Point_$type, x: f.current, y: g.current });
            }
        }
    };
    TrendAverageCalculator.$t = markType(TrendAverageCalculator, 'TrendAverageCalculator');
    return TrendAverageCalculator;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTrendLineManager, _super);
    function CategoryTrendLineManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CategoryTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
        var h = g.d * g.c;
        var i = g.e * g.c;
        var j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return (k + 1); }, function (k) { return c.item(k); }, function (k) { return e(k - 1); }, f, h + 1, i + 1);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (var k = g.d; k <= g.e; k += 1) {
                var l = k * g.c;
                if (l >= 0 && l < this.d.count) {
                    var m = e(l);
                    var n = f(this.d._inner[l]);
                    j.add({ $type: Point_$type, x: m + g.a, y: n });
                }
            }
        }
        this.m(j, g, a);
    };
    CategoryTrendLineManager.$t = markType(CategoryTrendLineManager, 'CategoryTrendLineManager', CategoryTrendLineManagerBase.$);
    return CategoryTrendLineManager;
}(CategoryTrendLineManagerBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SortingTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SortingTrendLineManager, _super);
    function SortingTrendLineManager(a, b) {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.q = null;
        _this.p = a;
        _this.q = b;
        return _this;
    }
    SortingTrendLineManager.prototype.get_g$a = function () {
        return 1;
    };
    SortingTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
        var _this = this;
        var h = g.d * g.c;
        var i = g.e * g.c;
        var j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return (k + 1); }, function (k) { return c.item(k); }, function (k) {
                var l = truncate(Math.floor(k));
                var m = truncate(Math.ceil(k));
                var n = k - l;
                var o;
                if (m <= i) {
                    o = _this.p(l) + n * (_this.p(m) - _this.p(l));
                }
                else {
                    o = _this.p(l) + n * (_this.p(truncate(i)) - _this.p(l));
                }
                return e(o);
            }, f, h, i);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (var k = g.d; k <= g.e; k += 1) {
                var l = k * g.c;
                var m = this.p(l);
                if (l >= 0 && l < this.d.count) {
                    var n = e(m);
                    var o = f(this.d._inner[l]);
                    j.add({ $type: Point_$type, x: n + g.a, y: o });
                }
            }
        }
        this.m(j, g, a);
    };
    SortingTrendLineManager.$t = markType(SortingTrendLineManager, 'SortingTrendLineManager', CategoryTrendLineManagerBase.$);
    return SortingTrendLineManager;
}(CategoryTrendLineManagerBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartCategoryTrendLineModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartCategoryTrendLineModule() {
    }
    IgrDataChartCategoryTrendLineModule.register = function () {
        TypeRegistrar.register('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory.$type);
        TypeRegistrar.register('CategoryTrendLineManager', CategoryTrendLineManager.$type);
        TypeRegistrar.register('SortingTrendLineManager', SortingTrendLineManager.$type);
    };
    return IgrDataChartCategoryTrendLineModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartAnnotationModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartAnnotationModule() {
    }
    IgrDataChartAnnotationModule.register = function () {
        TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
        IgrCrosshairLayerModule.register();
        IgrCategoryToolTipLayerModule.register();
        IgrItemToolTipLayerModule.register();
        IgrCategoryItemHighlightLayerModule.register();
        IgrCategoryHighlightLayerModule.register();
        IgrFinalValueLayerModule.register();
        IgrCalloutLayerModule.register();
    };
    return IgrDataChartAnnotationModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryChartModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryChartModule() {
    }
    IgrCategoryChartModule.register = function () {
        IgrCategoryChartCoreModule.register();
        IgrLineSeriesModule.register();
        IgrAreaSeriesModule.register();
        IgrColumnSeriesModule.register();
        IgrSplineSeriesModule.register();
        IgrSplineAreaSeriesModule.register();
        IgrStepLineSeriesModule.register();
        IgrStepAreaSeriesModule.register();
        IgrPointSeriesModule.register();
        IgrWaterfallSeriesModule.register();
        IgrCrosshairLayerModule.register();
        IgrCalloutLayerModule.register();
        IgrItemToolTipLayerModule.register();
        IgrCategoryToolTipLayerModule.register();
        IgrCategoryHighlightLayerModule.register();
        IgrCategoryItemHighlightLayerModule.register();
        IgrFinalValueLayerModule.register();
        IgrNumberAbbreviatorModule.register();
        IgrDataChartInteractivityModule.register();
        IgrDataChartCategoryTrendLineModule.register();
        IgrDataChartAnnotationModule.register();
    };
    return IgrCategoryChartModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeValueList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeValueList, _super);
    function RangeValueList(a, b) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.a = a;
        _this.b = b;
        return _this;
    }
    RangeValueList.prototype.indexOf = function (a) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.insert = function (a, b) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.removeAt = function (a) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            return b;
        }
        else {
            var b_1 = NaN;
            var c = NaN;
            if (this.a != null && a >= 0 && a < this.a.count) {
                b_1 = this.a.item(a);
            }
            if (this.b != null && a >= 0 && a < this.b.count) {
                c = this.b.item(a);
            }
            var d = isNaN_(b_1);
            var e = isNaN_(c);
            if (!d && !e) {
                return (b_1 + c) / 2;
            }
            if (!d) {
                return b_1;
            }
            if (!e) {
                return c;
            }
            return NaN;
        }
    };
    RangeValueList.prototype.add = function (a) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.clear = function () {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.contains = function (a) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.copyTo = function (a, b) {
        throw new NotImplementedException(0);
    };
    Object.defineProperty(RangeValueList.prototype, "count", {
        get: function () {
            var a = 0;
            var b = 0;
            if (this.a != null) {
                a = this.a.count;
            }
            if (this.b != null) {
                b = this.b.count;
            }
            var c = 0;
            c = Math.max(c, a);
            c = Math.max(c, b);
            return c;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeValueList.prototype, "isReadOnly", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    RangeValueList.prototype.remove = function (a) {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.getEnumerator = function () {
        throw new NotImplementedException(0);
    };
    RangeValueList.prototype.getEnumeratorObject = function () {
        throw new NotImplementedException(0);
    };
    RangeValueList.$t = markType(RangeValueList, 'RangeValueList', Base.$, [IList$1_$type.specialize(Number_$type)]);
    return RangeValueList;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Tooltip = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Tooltip, _super);
    function Tooltip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._updateToolTip = null;
        _this._hideToolTip = null;
        return _this;
    }
    Object.defineProperty(Tooltip.prototype, "updateToolTip", {
        get: function () {
            return this._updateToolTip;
        },
        set: function (a) {
            this._updateToolTip = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Tooltip.prototype, "hideToolTip", {
        get: function () {
            return this._hideToolTip;
        },
        set: function (a) {
            this._hideToolTip = a;
        },
        enumerable: true,
        configurable: true
    });
    Tooltip.$t = markType(Tooltip, 'Tooltip', HTMLElement.$);
    return Tooltip;
}(HTMLElement));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IDomainChartWidget_$type = /*@__PURE__*/ new Type(null, 'IDomainChartWidget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
function getSliceLabel(series, item) {
    return item[series.labelMemberPath];
}
function getValue(series, item) {
    return item[getValueMemberPath(series)];
}
function getValueMemberPath(series) {
    return series.valueMemberPath;
}
function getBrush$1(i) {
    if (i.slice.background)
        return i.slice.background.fill;
    return "black";
}
var DoughnutSliceTooltip = function (props) {
    if (!props.dataContext) {
        return null;
    }
    if (!props.dataContext.item) {
        return null;
    }
    var series = props.dataContext.series;
    var item = props.dataContext.item;
    return (createElement("div", { className: 'ui-chart-default-tooltip-content' }, createElement("span", { style: { color: getBrush$1(props.dataContext.i) } }, getSliceLabel(series, item)), createElement("br", null), createElement("span", { className: "ui-tooltip-priority" }, getValueMemberPath(series), " : ", getValue(series, item))));
};
var IgrDoughnutChartDefaultTooltips = /** @class */ /*@__PURE__*/ (function () {
    function IgrDoughnutChartDefaultTooltips() {
        this.doughnutSliceTooltip = DoughnutSliceTooltip;
    }
    IgrDoughnutChartDefaultTooltips.prototype.ensureDefaultTooltip = function (series) {
        if (series.showDefaultTooltip) {
            series.tooltipTemplate = this.doughnutSliceTooltip;
        }
        else {
            if (series.tooltipTemplate === this.doughnutSliceTooltip) {
                series.tooltipTemplate = null;
            }
        }
    };
    IgrDoughnutChartDefaultTooltips.register = function () {
        TypeRegistrar.registerCons("IgrDoughnutChartDefaultTooltips", IgrDoughnutChartDefaultTooltips);
    };
    return IgrDoughnutChartDefaultTooltips;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDoughnutChartInteractivityModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDoughnutChartInteractivityModule() {
    }
    IgrDoughnutChartInteractivityModule.register = function () {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        TypeRegistrar.registerCons('IgrDoughnutChartDefaultTooltips', IgrDoughnutChartDefaultTooltips);
        IgrDoughnutChartDefaultTooltips.register();
        IgrDVInteractivityModule.register();
    };
    return IgrDoughnutChartInteractivityModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions of labels.
 */
var LabelsPosition = /*@__PURE__*/ (function (LabelsPosition) {
    /**
     * No labels will be displayed.
     */
    LabelsPosition[LabelsPosition["None"] = 0] = "None";
    /**
     * Labels will be displayed in the center.
     */
    LabelsPosition[LabelsPosition["Center"] = 1] = "Center";
    /**
     * Labels will be displayed inside and by the edge of the container.
     */
    LabelsPosition[LabelsPosition["InsideEnd"] = 2] = "InsideEnd";
    /**
     * Labels will be displayed outside the container.
     */
    LabelsPosition[LabelsPosition["OutsideEnd"] = 3] = "OutsideEnd";
    /**
     * Labels will automatically decide their location.
     */
    LabelsPosition[LabelsPosition["BestFit"] = 4] = "BestFit";
    return LabelsPosition;
})({});
/**
 * @hidden
 */
var LabelsPosition_$type = /*@__PURE__*/ markEnum('LabelsPosition', 'None,0|Center,1|InsideEnd,2|OutsideEnd,3|BestFit,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of a callout line for the labels.
 */
var LeaderLineType = /*@__PURE__*/ (function (LeaderLineType) {
    /**
     * A straight line is drawn between the slice and its label.
     */
    LeaderLineType[LeaderLineType["Straight"] = 0] = "Straight";
    /**
     * A curved line is drawn between the slice and its label. The line follows makes a natural turn from the slice to the label.
     */
    LeaderLineType[LeaderLineType["Arc"] = 1] = "Arc";
    /**
     * A curved line is drawn between the slice and its label. The line starts radially from the slice and then turns to the label.
     */
    LeaderLineType[LeaderLineType["Spline"] = 2] = "Spline";
    return LeaderLineType;
})({});
/**
 * @hidden
 */
var LeaderLineType_$type = /*@__PURE__*/ markEnum('LeaderLineType', 'Straight,0|Arc,1|Spline,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for calculating and grouping slices into the Others slice.
 */
var OthersCategoryType = /*@__PURE__*/ (function (OthersCategoryType) {
    /**
     * Data value is compared directly to the value of OthersCategoryThreshold.
     */
    OthersCategoryType[OthersCategoryType["Number"] = 0] = "Number";
    /**
     * Data value is compared to OthersCategoryThreshold as a percentage of the total.
     */
    OthersCategoryType[OthersCategoryType["Percent"] = 1] = "Percent";
    return OthersCategoryType;
})({});
/**
 * @hidden
 */
var OthersCategoryType_$type = /*@__PURE__*/ markEnum('OthersCategoryType', 'Number,0|Percent,1');

/**
 * Represents a IgxDoughnutChartComponent base series.
*/
var IgrRingSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRingSeriesBase, _super);
    function IgrRingSeriesBase(props) {
        var _this = _super.call(this, props) || this;
        _this._dataSource = null;
        _this._tooltipTemplate = null;
        _this._tooltipContent = null;
        _this._tooltipContainerTemplate = null;
        _this._showDefaultTooltip = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._propertyUpdated = null;
        _this._propertyUpdated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrRingSeriesBase.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.bindData = function () {
        if (this.i != null && this.i !== undefined) {
            this.i.itemsSource = this._dataSource;
        }
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.onImplementationCreated = function () {
    };
    IgrRingSeriesBase.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    {
                        this[p] = this.props[p];
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrRingSeriesBase.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrRingSeriesBase.prototype.render = function () {
        return null;
    };
    IgrRingSeriesBase._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "legend", {
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "tooltipTemplate", {
        get: function () {
            return this._tooltipTemplate;
        },
        set: function (value) {
            this._tooltipTemplate = value;
            if (value == null) {
                if (this._tooltipContent !== null) {
                    //this._tooltipContent.destroy();
                    this._tooltipContent = null;
                }
            }
            if (this._tooltipContent != null) {
                this._tooltipContent.template = this._tooltipTemplate;
            }
            else {
                if (this.owner != null) {
                    this.owner._ensureTooltipCreated(this);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "tooltipContainerTemplate", {
        get: function () {
            return this._tooltipContainerTemplate;
        },
        set: function (value) {
            this._tooltipContainerTemplate = value;
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            var tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.tooltipTemplate = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip);
        }
    };
    IgrRingSeriesBase.prototype._ensureTooltipDestroyed = function () {
        if (this._tooltipContent !== null) {
            //this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "showDefaultTooltip", {
        /**
         * Gets or sets whether default tooltip will be shown.
        */
        get: function () {
            return this._showDefaultTooltip;
        },
        set: function (v) {
            this._showDefaultTooltip = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.sychronizeCollections = function () { };
    Object.defineProperty(IgrRingSeriesBase.prototype, "valueMemberPath", {
        /**
     * Gets or Sets the property name that contains the values.
    */
        get: function () {
            return this.i.b9;
        },
        set: function (v) {
            this.i.b9 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "labelMemberPath", {
        /**
         * Gets or sets the property name that contains the labels.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "legendLabelMemberPath", {
        /**
         * Gets or sets the property name that contains the legend labels.
        */
        get: function () {
            return this.i.br;
        },
        set: function (v) {
            this.i.br = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "labelsPosition", {
        /**
         * Gets or sets the position of chart labels.
        */
        get: function () {
            return this.i.aj;
        },
        set: function (v) {
            this.i.aj = ensureEnum(LabelsPosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineVisibility", {
        /**
         * Gets or sets whether the leader lines are visible.
        */
        get: function () {
            return this.i.dw;
        },
        set: function (v) {
            this.i.dw = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.dr ? this.i.dr.fill : null;
        },
        set: function (v) {
            this.ensureLeaderLineStyle();
            this.i.dr.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.dr ? this.i.dr.stroke : null;
        },
        set: function (v) {
            this.ensureLeaderLineStyle();
            this.i.dr.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.dr ? this.i.dr.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureLeaderLineStyle();
            this.i.dr.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.dr ? this.i.dr.opacity : NaN;
        },
        set: function (v) {
            this.ensureLeaderLineStyle();
            this.i.dr.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.ensureLeaderLineStyle = function () {
        if (this.i.dr) {
            return;
        }
        this.i.dr = new Style();
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineType", {
        /**
         * Gets or sets what type of leader lines will be used for the outside end labels.
        */
        get: function () {
            return this.i.ak;
        },
        set: function (v) {
            this.i.ak = ensureEnum(LeaderLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "leaderLineMargin", {
        /**
         * Gets or sets the margin between a label and its leader line. The default is 6 pixels.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryThreshold", {
        /**
         * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
        */
        get: function () {
            return this.i.a2;
        },
        set: function (v) {
            this.i.a2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryType", {
        /**
         * Gets or sets whether to use numeric or percent-based threshold value.
        */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = ensureEnum(OthersCategoryType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryText", {
        /**
         * Gets or sets the label of the Others slice.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "formatLegendLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
        */
        get: function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "labelExtent", {
        /**
         * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
        */
        get: function () {
            return this.i.a0;
        },
        set: function (v) {
            this.i.a0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "startAngle", {
        /**
         * Gets or sets the starting angle of the chart.
         * The default zero value is equivalent to 3 o'clock.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.ds ? this.i.ds.fill : null;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.ds.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.ds ? this.i.ds.stroke : null;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.ds.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.ds ? this.i.ds.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.ds.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "othersCategoryOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.ds ? this.i.ds.opacity : NaN;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.ds.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.ensureOthersCategoryStyle = function () {
        if (this.i.ds) {
            return;
        }
        this.i.ds = new Style();
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "selectedSliceFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.dt ? this.i.dt.fill : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.dt.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "selectedSliceStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.dt ? this.i.dt.stroke : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.dt.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "selectedSliceStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.dt ? this.i.dt.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.dt.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "selectedSliceOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.dt ? this.i.dt.opacity : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.dt.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.ensureSelectedStyle = function () {
        if (this.i.dt) {
            return;
        }
        this.i.dt = new Style();
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the slices.
        */
        get: function () {
            return fromBrushCollection(this.i.ag);
        },
        set: function (v) {
            this.i.ag = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the slices.
        */
        get: function () {
            return fromBrushCollection(this.i.ah);
        },
        set: function (v) {
            this.i.ah = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "labelOuterColor", {
        /**
         * Gets or sets the color for labels rendered outside of the pie chart.
        */
        get: function () {
            return brushToString(this.i.dp);
        },
        set: function (v) {
            this.i.dp = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "labelInnerColor", {
        /**
         * Gets or sets the color for labels rendered inside of the pie chart.
        */
        get: function () {
            return brushToString(this.i.dn);
        },
        set: function (v) {
            this.i.dn = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "radiusFactor", {
        /**
         * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeriesBase.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeriesBase.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrRingSeriesBase.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("RingSeriesBase");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    IgrRingSeriesBase.prototype.provideContainer = function (container) {
        this.i.cm(container);
    };
    Object.defineProperty(IgrRingSeriesBase.prototype, "propertyUpdated", {
        /**
         * Event raised when a property (including "effective" and non-dependency property) value changes.
        */
        get: function () {
            return this._propertyUpdated;
        },
        set: function (ev) {
            var _this = this;
            if (this._propertyUpdated_wrapped !== null) {
                this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
                this._propertyUpdated_wrapped = null;
                this._propertyUpdated = null;
            }
            this._propertyUpdated = ev;
            this._propertyUpdated_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyUpdatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePropertyUpdated) {
                    _this.beforePropertyUpdated(_this, outerArgs);
                }
                if (_this._propertyUpdated) {
                    _this._propertyUpdated(_this, outerArgs);
                }
            };
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrRingSeriesBase;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieChartStyleInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartStyleInfo, _super);
    function PieChartStyleInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.f = null;
        _this.g = null;
        _this.c = null;
        _this.h = null;
        _this.i = null;
        _this.e = 0;
        _this.d = 0;
        return _this;
    }
    PieChartStyleInfo.$t = markType(PieChartStyleInfo, 'PieChartStyleInfo');
    return PieChartStyleInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieSliceVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieSliceVisualData, _super);
    function PieSliceVisualData() {
        var _this = _super.call(this) || this;
        _this._startAngle = 0;
        _this._endAngle = 0;
        _this._origin = null;
        _this._explodedOrigin = null;
        _this._radius = 0;
        _this._explodedRadius = 0;
        _this._innerExtentStart = 0;
        _this._innerExtentEnd = 0;
        _this._isSelected = false;
        _this._isExploded = false;
        _this._isOthersSlice = false;
        _this._index = 0;
        _this._label = null;
        _this._labelAngle = 0;
        _this._labelBounds = null;
        _this._appearance = null;
        _this._labelAppearance = null;
        _this._leaderLineAppearance = null;
        _this._slicePath = null;
        _this._leaderLinePath = null;
        _this.labelBounds = RectData.empty;
        return _this;
    }
    Object.defineProperty(PieSliceVisualData.prototype, "startAngle", {
        get: function () {
            return this._startAngle;
        },
        set: function (a) {
            this._startAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "endAngle", {
        get: function () {
            return this._endAngle;
        },
        set: function (a) {
            this._endAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "origin", {
        get: function () {
            return this._origin;
        },
        set: function (a) {
            this._origin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "explodedOrigin", {
        get: function () {
            return this._explodedOrigin;
        },
        set: function (a) {
            this._explodedOrigin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "radius", {
        get: function () {
            return this._radius;
        },
        set: function (a) {
            this._radius = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "explodedRadius", {
        get: function () {
            return this._explodedRadius;
        },
        set: function (a) {
            this._explodedRadius = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "innerExtentStart", {
        get: function () {
            return this._innerExtentStart;
        },
        set: function (a) {
            this._innerExtentStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "innerExtentEnd", {
        get: function () {
            return this._innerExtentEnd;
        },
        set: function (a) {
            this._innerExtentEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "isSelected", {
        get: function () {
            return this._isSelected;
        },
        set: function (a) {
            this._isSelected = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "isExploded", {
        get: function () {
            return this._isExploded;
        },
        set: function (a) {
            this._isExploded = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "isOthersSlice", {
        get: function () {
            return this._isOthersSlice;
        },
        set: function (a) {
            this._isOthersSlice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "index", {
        get: function () {
            return this._index;
        },
        set: function (a) {
            this._index = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "labelAngle", {
        get: function () {
            return this._labelAngle;
        },
        set: function (a) {
            this._labelAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "labelBounds", {
        get: function () {
            return this._labelBounds;
        },
        set: function (a) {
            this._labelBounds = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "labelAppearance", {
        get: function () {
            return this._labelAppearance;
        },
        set: function (a) {
            this._labelAppearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "leaderLineAppearance", {
        get: function () {
            return this._leaderLineAppearance;
        },
        set: function (a) {
            this._leaderLineAppearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "slicePath", {
        get: function () {
            return this._slicePath;
        },
        set: function (a) {
            this._slicePath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceVisualData.prototype, "leaderLinePath", {
        get: function () {
            return this._leaderLinePath;
        },
        set: function (a) {
            this._leaderLinePath = a;
        },
        enumerable: true,
        configurable: true
    });
    PieSliceVisualData.prototype.scaleByViewport = function (a) {
        if (this.slicePath != null) {
            this.slicePath.scaleByViewport(a);
        }
        if (this.leaderLinePath != null) {
            this.leaderLinePath.scaleByViewport(a);
        }
        if (!this.labelBounds.isEmpty) {
            var b = (this.labelBounds.left - a.left) / a.width;
            var c = (this.labelBounds.top - a.top) / a.height;
            var d = ((this.labelBounds.left + this.labelBounds.width) - a.left) / a.width;
            var e = ((this.labelBounds.top + this.labelBounds.height) - a.top) / a.height;
            this.labelBounds = new RectData(b, c, d - b, e - c);
        }
        if (this.origin != null) {
            this.origin = new PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
        }
        if (this.explodedOrigin != null) {
            this.explodedOrigin = new PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
        }
    };
    PieSliceVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        if (this.leaderLineAppearance != null) {
            a.u("leaderLineAppearance: " + this.leaderLineAppearance.serialize() + ", ");
        }
        if (this.slicePath != null) {
            a.u("slicePath: " + this.slicePath.serialize() + ", ");
        }
        if (this.leaderLinePath != null) {
            var b = this.leaderLinePath.serialize();
            if (b != null) {
                a.u("leaderLinePath: " + b + ", ");
            }
        }
        a.u("labelAngle: " + this.labelAngle + ", ");
        a.u("labelBounds: { left: " + this.labelBounds.left + ", top: " + this.labelBounds.top + ", width: " + this.labelBounds.width + ", height: " + this.labelBounds.height + "}");
        a.u("}");
        return a.toString();
    };
    PieSliceVisualData.$t = markType(PieSliceVisualData, 'PieSliceVisualData');
    return PieSliceVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieSliceVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieSliceVisualDataList, _super);
    function PieSliceVisualDataList() {
        return _super.call(this, PieSliceVisualData.$, 0) || this;
    }
    PieSliceVisualDataList.$t = markType(PieSliceVisualDataList, 'PieSliceVisualDataList', List$1.$.specialize(PieSliceVisualData.$));
    return PieSliceVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartVisualData, _super);
    function PieChartVisualData() {
        var _this = _super.call(this) || this;
        _this._slices = null;
        _this._othersSlice = null;
        _this._name = null;
        _this._viewport = null;
        _this._width = 0;
        _this._height = 0;
        _this._others = null;
        _this._radiusFactor = 0;
        _this._leaderLineMargin = 0;
        _this._isViewportScaled = false;
        _this._dipScalingRatio = 0;
        _this.slices = new PieSliceVisualDataList();
        _this.others = new List$1(Base.$, 0);
        _this.dipScalingRatio = 1;
        return _this;
    }
    Object.defineProperty(PieChartVisualData.prototype, "slices", {
        get: function () {
            return this._slices;
        },
        set: function (a) {
            this._slices = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "othersSlice", {
        get: function () {
            return this._othersSlice;
        },
        set: function (a) {
            this._othersSlice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "others", {
        get: function () {
            return this._others;
        },
        set: function (a) {
            this._others = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "radiusFactor", {
        get: function () {
            return this._radiusFactor;
        },
        set: function (a) {
            this._radiusFactor = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "leaderLineMargin", {
        get: function () {
            return this._leaderLineMargin;
        },
        set: function (a) {
            this._leaderLineMargin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "isViewportScaled", {
        get: function () {
            return this._isViewportScaled;
        },
        set: function (a) {
            this._isViewportScaled = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartVisualData.prototype, "dipScalingRatio", {
        get: function () {
            return this._dipScalingRatio;
        },
        set: function (a) {
            this._dipScalingRatio = a;
        },
        enumerable: true,
        configurable: true
    });
    PieChartVisualData.prototype.scaleByViewport = function () {
        if (this.isViewportScaled) {
            return;
        }
        this.isViewportScaled = true;
        for (var a = 0; a < this.slices.count; a++) {
            this.slices._inner[a].scaleByViewport(this.viewport);
        }
        if (this.othersSlice != null) {
            this.othersSlice.scaleByViewport(this.viewport);
        }
    };
    PieChartVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: " + this.name + ",");
        a.u("leaderLineMargin: " + this.leaderLineMargin + ",");
        a.u("radiusFactor: " + this.radiusFactor + ",");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
        a.u("slices: [");
        for (var b = 0; b < this.slices.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.slices._inner[b].serialize());
        }
        a.u("],");
        a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}");
        a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    };
    PieChartVisualData.$t = markType(PieChartVisualData, 'PieChartVisualData');
    return PieChartVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndexCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndexCollection, _super);
    function IndexCollection() {
        return _super.call(this, Number_$type, 0) || this;
    }
    IndexCollection.prototype.r = function (a, b) {
        if (!this.contains(b)) {
            _super.prototype.r.call(this, a, b);
        }
    };
    IndexCollection.prototype.x = function (a, b) {
        if (this.contains(b)) {
            this.remove(b);
            this.r(a, b);
        }
        else {
            _super.prototype.x.call(this, a, b);
        }
    };
    IndexCollection.$t = markType(IndexCollection, 'IndexCollection', ObservableCollection$1.$.specialize(Number_$type));
    return IndexCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes for selecting slices.
 */
var SliceSelectionMode = /*@__PURE__*/ (function (SliceSelectionMode) {
    /**
     * Slices can be programmatically selected but cannot be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Manual"] = 0] = "Manual";
    /**
     * Single slice can be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Single"] = 1] = "Single";
    /**
     * Multiple slices can be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Multiple"] = 2] = "Multiple";
    return SliceSelectionMode;
})({});
/**
 * @hidden
 */
var SliceSelectionMode_$type = /*@__PURE__*/ markEnum('SliceSelectionMode', 'Manual,0|Single,1|Multiple,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SelectedItemChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SelectedItemChangedEventArgs, _super);
    function SelectedItemChangedEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this._oldItem = null;
        _this._newItem = null;
        _this.oldItem = a;
        _this.newItem = b;
        return _this;
    }
    Object.defineProperty(SelectedItemChangedEventArgs.prototype, "oldItem", {
        get: function () {
            return this._oldItem;
        },
        set: function (a) {
            this._oldItem = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectedItemChangedEventArgs.prototype, "newItem", {
        get: function () {
            return this._newItem;
        },
        set: function (a) {
            this._newItem = a;
        },
        enumerable: true,
        configurable: true
    });
    SelectedItemChangedEventArgs.$t = markType(SelectedItemChangedEventArgs, 'SelectedItemChangedEventArgs', EventArgs.$);
    return SelectedItemChangedEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SelectedItemChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SelectedItemChangingEventArgs, _super);
    function SelectedItemChangingEventArgs(a, b) {
        var _this = _super.call(this, a, b) || this;
        _this._cancel = false;
        return _this;
    }
    Object.defineProperty(SelectedItemChangingEventArgs.prototype, "cancel", {
        get: function () {
            return this._cancel;
        },
        set: function (a) {
            this._cancel = a;
        },
        enumerable: true,
        configurable: true
    });
    SelectedItemChangingEventArgs.$t = markType(SelectedItemChangingEventArgs, 'SelectedItemChangingEventArgs', SelectedItemChangedEventArgs.$);
    return SelectedItemChangingEventArgs;
}(SelectedItemChangedEventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SelectedItemsChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SelectedItemsChangedEventArgs, _super);
    function SelectedItemsChangedEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this._oldItems = null;
        _this._newItems = null;
        _this.oldItems = a;
        _this.newItems = b;
        return _this;
    }
    Object.defineProperty(SelectedItemsChangedEventArgs.prototype, "oldItems", {
        get: function () {
            return this._oldItems;
        },
        set: function (a) {
            this._oldItems = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectedItemsChangedEventArgs.prototype, "newItems", {
        get: function () {
            return this._newItems;
        },
        set: function (a) {
            this._newItems = a;
        },
        enumerable: true,
        configurable: true
    });
    SelectedItemsChangedEventArgs.$t = markType(SelectedItemsChangedEventArgs, 'SelectedItemsChangedEventArgs', EventArgs.$);
    return SelectedItemsChangedEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SelectedItemsChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SelectedItemsChangingEventArgs, _super);
    function SelectedItemsChangingEventArgs(a, b) {
        var _this = _super.call(this, a, b) || this;
        _this._cancel = false;
        return _this;
    }
    Object.defineProperty(SelectedItemsChangingEventArgs.prototype, "cancel", {
        get: function () {
            return this._cancel;
        },
        set: function (a) {
            this._cancel = a;
        },
        enumerable: true,
        configurable: true
    });
    SelectedItemsChangingEventArgs.$t = markType(SelectedItemsChangingEventArgs, 'SelectedItemsChangingEventArgs', SelectedItemsChangedEventArgs.$);
    return SelectedItemsChangingEventArgs;
}(SelectedItemsChangedEventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieLegendTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieLegendTemplates, _super);
    function PieLegendTemplates() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PieLegendTemplates.f = function (a) {
        var b = a.data;
        var c = b.series;
        var d = c.legendItemBadgeTemplate;
        var e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
        if (e == null) {
            e = "Pie Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    };
    PieLegendTemplates.c = function (a) {
        var b = a.data;
        var c = b.series;
        var d = c.legendItemBadgeTemplate;
        var e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
        if (e == null) {
            e = "Doughnut Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    };
    PieLegendTemplates.a = function (a) {
    };
    PieLegendTemplates.d = function (a) {
    };
    PieLegendTemplates.e = function (a) {
        var b = a.data;
        var c = a.context;
        var d = new RenderingContext(new CanvasViewRenderer(), c);
        var e = b.series;
        var f = b.itemBrush;
        var g = b.outline;
        var h = b.thickness;
        var i = new Rectangle();
        i.width = a.availableWidth - (h * 2) - 2;
        i.height = a.availableHeight - (h * 2);
        i.n = h + 1;
        i.o = h;
        i.ac = h;
        i._fill = f;
        i._stroke = g;
        d.v(i);
    };
    PieLegendTemplates.b = function (a) {
        var b = a.data;
        var c = a.context;
        var d = new RenderingContext(new CanvasViewRenderer(), c);
        var e = b.itemBrush;
        var f = b.outline;
        var g = b.thickness;
        var h = new Rectangle();
        h.width = a.availableWidth - (g * 2) - 2;
        h.height = a.availableHeight - (g * 2);
        h.n = g + 1;
        h.o = g;
        h.ac = g;
        h._fill = e;
        h._stroke = f;
        d.v(h);
    };
    PieLegendTemplates.$t = markType(PieLegendTemplates, 'PieLegendTemplates');
    return PieLegendTemplates;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PieChartViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartViewManager, _super);
    function PieChartViewManager(a) {
        var _this = _super.call(this) || this;
        _this.n = null;
        _this.p = null;
        _this.s = null;
        _this.r = null;
        _this.q = null;
        _this.k = 0;
        _this.j = 0;
        _this.l = 1;
        _this.ap = null;
        _this.e = null;
        _this.g = null;
        _this.f = null;
        _this.h = null;
        _this.a = null;
        _this.c = null;
        _this._toolTipObject = null;
        _this.u = null;
        _this.i = true;
        _this.a = a;
        return _this;
    }
    PieChartViewManager.prototype.aa = function () {
        var a = this.n.rootWrapper.width();
        var b = this.n.rootWrapper.height();
        this.ad(a, b);
    };
    PieChartViewManager.prototype.ad = function (a, b) {
        this.z();
        this.c.bf = new Rect(0, 0, 0, a, b);
        var c = this.a.a.cd;
        if (c == this.l && a == this.k && b == this.j) {
            return;
        }
        this.k = a;
        this.j = b;
        this.l = c;
        this.a.ba();
    };
    PieChartViewManager.prototype.ae = function () {
        if (this.c != null) {
            this.c.bb(this.p, "");
        }
    };
    PieChartViewManager.prototype.ab = function () {
        this.z();
        if (this.c != null) {
            this.c.ap(this.p, "");
        }
    };
    PieChartViewManager.prototype.z = function () {
        var a = this.a.a.cq;
        var b = this.a.a.cd;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.a.a.cd = window.devicePixelRatio;
        }
    };
    PieChartViewManager.prototype.w = function (a, b) {
        var c = this.a.a.cd;
        if (a != this.k || b != this.j || c != this.l) {
            this.k = a;
            this.j = b;
            this.l = this.a.a.cd;
            this.ao();
        }
    };
    PieChartViewManager.prototype.ao = function () {
        this.ap = new Rect(0, 0, 0, this.k, this.j);
        var a = this.k;
        var b = this.j;
        var c = this.l;
        if (c != 1) {
            a = Math.round(this.k * c);
            b = Math.round(this.j * c);
        }
        this.p.setAttribute("width", a.toString());
        this.p.setAttribute("height", b.toString());
        this.p.setStyleProperty("width", this.k.toString() + "px");
        this.p.setStyleProperty("height", this.j.toString() + "px");
        this.r.setAttribute("width", a.toString());
        this.r.setAttribute("height", b.toString());
        this.r.setStyleProperty("width", this.k.toString() + "px");
        this.r.setStyleProperty("height", this.j.toString() + "px");
        this.q.setAttribute("width", a.toString());
        this.q.setAttribute("height", b.toString());
        this.q.setStyleProperty("width", this.k.toString() + "px");
        this.q.setStyleProperty("height", this.j.toString() + "px");
        this.s.setAttribute("width", a.toString());
        this.s.setAttribute("height", b.toString());
        this.s.setStyleProperty("width", this.k.toString() + "px");
        this.s.setStyleProperty("height", this.j.toString() + "px");
        return this.ap;
    };
    PieChartViewManager.prototype.d = function () {
        return this.a.b.c;
    };
    PieChartViewManager.prototype.an = function () {
        var a = DOMEventProxy.cx(this.n.rootWrapper);
        return { $type: Point_$type, x: a.left, y: a.top };
    };
    PieChartViewManager.prototype.ah = function (a) {
        if (this.n != null) {
            this.n.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    PieChartViewManager.prototype.b = function () {
        var _this = this;
        var a = new PieChartStyleInfo();
        var b;
        var c;
        var d = BrushUtil.e("chart", this.n, b, c);
        b = d.p2;
        c = d.p3;
        a.a = b;
        a.b = c;
        this.n.startCSSQuery();
        a.f = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.n.getCssDefaultPropertyValue("ui-chart-innerlabels", "color");
            return $ret;
        })());
        a.g = ((function () {
            var $ret = new Brush();
            $ret.fill = _this.n.getCssDefaultPropertyValue("ui-chart-outerlabels", "color");
            return $ret;
        })());
        this.n.endCSSQuery();
        a.c = FontUtil.getFont(this.n);
        a.e = DeviceUtils.g(6);
        a.i = ((function () {
            var $ret = new Brush();
            $ret.fill = "#00000033";
            return $ret;
        })());
        a.d = 1;
        return a;
    };
    PieChartViewManager.prototype.ai = function (a) {
        a._stroke = ((function () {
            var $ret = new Brush();
            $ret.fill = "#000000";
            return $ret;
        })());
        a._fill = ((function () {
            var $ret = new Brush();
            $ret.fill = "#222222";
            return $ret;
        })());
    };
    PieChartViewManager.prototype.ac = function (a) {
        if (a == null) {
            if (this.c != null) {
                this.c.aq();
            }
            this.n = null;
            this.p = null;
            this.r = null;
            this.q = null;
            this.s = null;
            this.e = null;
            this.g = null;
            this.f = null;
            this.h = null;
            this.c = null;
            return;
        }
        var b = a;
        this.n = b;
        this.a.bb();
        this.a.bk();
        this.n.rootWrapper.setStyleProperty("position", "relative");
        this.n.rootWrapper.addClass("ui-corner-all");
        this.n.rootWrapper.addClass("ui-widget-content");
        this.p = this.n.createElement("canvas");
        this.p.setStyleProperty("position", "absolute");
        this.p.setStyleProperty("top", "0px");
        this.p.setStyleProperty("left", "0px");
        this.r = this.n.createElement("canvas");
        this.r.setStyleProperty("position", "absolute");
        this.r.setStyleProperty("top", "0px");
        this.r.setStyleProperty("left", "0px");
        this.q = this.n.createElement("canvas");
        this.q.setStyleProperty("position", "absolute");
        this.q.setStyleProperty("top", "0px");
        this.q.setStyleProperty("left", "0px");
        this.s = this.n.createElement("canvas");
        this.s.setStyleProperty("position", "absolute");
        this.s.setStyleProperty("top", "0px");
        this.s.setStyleProperty("left", "0px");
        this.n.append(this.p);
        this.n.append(this.r);
        this.n.append(this.q);
        this.n.append(this.s);
        this.e = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.p));
        this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.r));
        this.f = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
        this.h = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.s));
        this.c = new DOMEventProxy(this.s, this.n, false);
        var c = this.c;
        c.onMouseOver = delegateCombine(c.onMouseOver, runOn(this.a, this.a.aj));
        var d = this.c;
        d.onMouseLeave = delegateCombine(d.onMouseLeave, runOn(this.a, this.a.ai));
        var e = this.c;
        e.onMouseDown = delegateCombine(e.onMouseDown, runOn(this.a, this.a.ah));
        var f = this.c;
        f.onMouseUp = delegateCombine(f.onMouseUp, runOn(this.a, this.a.ak));
        this.c.ac = this.a.a.bv;
        this.ad(this.n.rootWrapper.width(), this.n.rootWrapper.height());
    };
    PieChartViewManager.prototype.v = function (a) {
        this.n.append(a);
    };
    PieChartViewManager.prototype.af = function (a) {
        if (this.c == null) {
            return;
        }
        this.c.ac = a;
    };
    PieChartViewManager.prototype.t = function () {
        return this.n;
    };
    PieChartViewManager.prototype.x = function (a) {
        a.width = this.k;
        a.height = this.j;
    };
    PieChartViewManager.prototype.ak = function (a) {
        this.u = null;
        this._toolTipObject = null;
        if (typeof a === 'string') {
            this.u = a;
        }
        else {
            this._toolTipObject = a;
            if (this._toolTipObject != null) {
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.setStyleProperty("white-space", "nowrap");
                this._toolTipObject.setStyleProperty("top", "0");
                this._toolTipObject.setStyleProperty("left", "0");
                this._toolTipObject.setStyleProperty("z-index", "10000");
            }
        }
    };
    PieChartViewManager.prototype.aj = function (pos_, context_) {
        if (this._toolTipObject != null) {
            if (this.i) {
                this.v(this._toolTipObject);
                this.i = false;
            }
            context_.hideOthers = true;
            if (this._toolTipObject.updateToolTip) {
                this._toolTipObject.updateToolTip(context_);
            }
            ;
            this._toolTipObject.setOffset(pos_.x, pos_.y);
        }
    };
    PieChartViewManager.prototype.y = function (a) {
        if (this._toolTipObject != null) {
            var context_ = a;
            if (this._toolTipObject.hideToolTip) {
                this._toolTipObject.hideToolTip(context_);
            }
            ;
        }
    };
    PieChartViewManager.prototype.al = function (style_) {
        var a = null;
        var fillColor_ = null;
        if (style_ != null) {
            if (style_.fill) {
                fillColor_ = style_.fill;
            }
            ;
            if (fillColor_ != null) {
                a = Brush.create(fillColor_);
            }
        }
        return a;
    };
    PieChartViewManager.prototype.am = function (style_) {
        var a = null;
        var outlineColor_ = null;
        if (style_ != null) {
            if (style_.stroke) {
                outlineColor_ = style_.stroke;
            }
            ;
            if (outlineColor_ != null) {
                a = Brush.create(outlineColor_);
            }
        }
        return a;
    };
    PieChartViewManager.prototype.m = function (style_) {
        var actualOutlineThickness_ = NaN;
        if (style_ != null) {
            if (style_.strokeThickness) {
                actualOutlineThickness_ = style_.strokeThickness;
            }
            ;
        }
        return actualOutlineThickness_;
    };
    PieChartViewManager.prototype.ag = function () {
    };
    PieChartViewManager.$t = markType(PieChartViewManager, 'PieChartViewManager');
    return PieChartViewManager;
}(Base));
/**
 * @hidden
 */
var LabelClickEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LabelClickEventArgs, _super);
    function LabelClickEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this._slice = null;
        _this.c = true;
        _this.slice = a;
        return _this;
    }
    Object.defineProperty(LabelClickEventArgs.prototype, "slice", {
        get: function () {
            return this._slice;
        },
        set: function (a) {
            this._slice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabelClickEventArgs.prototype, "item", {
        get: function () {
            if (this.slice != null) {
                return this.slice.dataContext;
            }
            else {
                return null;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LabelClickEventArgs.prototype, "allowSliceClick", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    LabelClickEventArgs.$t = markType(LabelClickEventArgs, 'LabelClickEventArgs', EventArgs.$);
    return LabelClickEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var SliceClickEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceClickEventArgs, _super);
    function SliceClickEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this._slice = null;
        _this.d = false;
        _this.c = false;
        _this._originalEvent = null;
        _this.slice = a;
        _this.originalEvent = b;
        if (a == null) {
            return _this;
        }
        _this.d = a.isSelected;
        _this.c = a.isExploded;
        return _this;
    }
    Object.defineProperty(SliceClickEventArgs.prototype, "slice", {
        get: function () {
            return this._slice;
        },
        set: function (a) {
            this._slice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "isSelected", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.slice.ai.fk(this.slice, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "isExploded", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
            this.slice.isExploded = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "isOthersSlice", {
        get: function () {
            return this.slice.isOthersSlice;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "dataContext", {
        get: function () {
            if (this.slice != null) {
                return this.slice.dataContext;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "originalEvent", {
        get: function () {
            return this._originalEvent;
        },
        set: function (a) {
            this._originalEvent = a;
        },
        enumerable: true,
        configurable: true
    });
    SliceClickEventArgs.$t = markType(SliceClickEventArgs, 'SliceClickEventArgs', EventArgs.$);
    return SliceClickEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var PieLabel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieLabel, _super);
    function PieLabel() {
        var _this = _super.call(this) || this;
        _this.ah = null;
        _this.ao = null;
        _this.ai = 0;
        _this.aj = null;
        _this.ap = null;
        _this.aq = null;
        _this.ag = 0;
        return _this;
    }
    PieLabel.prototype.ak = function (a) {
        if (a.a.ao == 3) {
            this.ao = a.b1(this);
            var b = typeCast(TextBlock.$, this.aj);
            var c = b.ak;
            a.a.fh();
            var d = this.ah.isExploded ? this.ah.b5 : this.ah.b7;
            var e = GeometryUtil.k(d, this.ai, this.ah.a2 + a.a.cm);
            var f = a.b2.width;
            if (a.y(b) + e.x > f && e.x < f) {
                while (c.length > 0 && a.y(b) + e.x > f) {
                    c = c.substr(0, c.length - 1);
                    b.ak = c;
                }
                if (c.length > 3) {
                    c = c.substr(0, c.length - 3);
                    c = c + "...";
                }
                else {
                    if (a.y("...") < this.ao.width) {
                        c = "...";
                    }
                    else {
                        c = stringEmpty();
                    }
                }
            }
            var g = new TextBlock();
            g.ak = c;
            this.aj = g;
        }
    };
    PieLabel.prototype.al = function () {
    };
    PieLabel.prototype.am = function () {
        this.ap._visibility = this.ah.ai.ha != 0 ? this.ah.ai.ha : this.ah.aj._visibility;
        var a;
        var b = this.ah.ai.cn;
        var c = GeometryUtil.k(this.ah.b6(), this.ai, this.ah.a2);
        this.ap.ak = c.x;
        this.ap.am = c.y;
        if (this.ai < 90 || this.ai >= 270) {
            a = { $type: Point_$type, x: this.ao.left, y: (this.ao.top + this.ao.bottom) / 2 };
        }
        else {
            a = { $type: Point_$type, x: this.ao.right, y: (this.ao.top + this.ao.bottom) / 2 };
        }
        if (b > 0) {
            var d = GeometryUtil.f(c, a);
            if (b < d) {
                a = GeometryUtil.m(a, c, b);
            }
            else {
                a = c;
            }
        }
        this.ap.al = a.x;
        this.ap.an = a.y;
    };
    PieLabel.prototype.an = function () {
        this.aq._visibility = this.ah.ai.ha != 0 ? this.ah.ai.ha : this.ah.aj._visibility;
        var a = this.ah.b6();
        var b = this.aq.ak.c._inner[0];
        var c = b._segments._inner[0];
        var d = this.ah.ai.cn;
        var e = (this.ao.top + this.ao.bottom) / 2;
        var f = GeometryUtil.k(a, this.ai, this.ah.a2);
        var g = GeometryUtil.k(a, this.ai, this.ah.a2 + this.ah.ai.cm / 2);
        var h;
        var i;
        var j;
        var k = e;
        if (this.ai < 90 && this.ai >= 0) {
            h = { $type: Point_$type, x: this.ao.left - 30, y: k };
            j = { $type: Point_$type, x: this.ao.left, y: e };
        }
        else if (this.ai < 180 && this.ai >= 90) {
            h = { $type: Point_$type, x: this.ao.right + 30, y: k };
            j = { $type: Point_$type, x: this.ao.right, y: e };
        }
        else if (this.ai < 270 && this.ai >= 180) {
            h = { $type: Point_$type, x: this.ao.right + 30, y: k };
            j = { $type: Point_$type, x: this.ao.right, y: e };
        }
        else {
            h = { $type: Point_$type, x: this.ao.left - 30, y: k };
            j = { $type: Point_$type, x: this.ao.left, y: e };
        }
        if (d > 0) {
            var l = GeometryUtil.f(f, j);
            if (d < l) {
                i = GeometryUtil.m(j, f, d);
                var m = g.x - f.x;
                var n = g.y - f.y;
                g = GeometryUtil.m(g, f, d);
                var o = g.x - f.x;
                var p = g.y - f.y;
                if ((m > 0 && o < 0) || (m < 0 && o > 0) || (n > 0 && p < 0) || (n < 0 && p > 0)) {
                    g = f;
                }
                h = GeometryUtil.m(h, f, d);
                var q = GeometryUtil.f(f, i) / GeometryUtil.f(f, j);
                h.x = f.x + (h.x - f.x) * q;
                h.y = f.y + (h.y - f.y) * q;
            }
            else {
                this.aq._visibility = 1;
                return;
            }
        }
        else {
            i = j;
        }
        if (this.ai < 180 && this.ai >= 0) {
            if (g.y > h.y) {
                g.y = f.y;
            }
        }
        else {
            if (g.y < h.y) {
                g.y = f.y;
            }
        }
        b._startPoint = f;
        if (this.ah.ai.ap == 1) {
            c.e = f;
        }
        else {
            c.e = g;
        }
        c.f = h;
        c.g = i;
    };
    PieLabel.$t = markType(PieLabel, 'PieLabel', Control.$);
    return PieLabel;
}(Control));
/**
 * @hidden
 */
var PieChartBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartBase, _super);
    function PieChartBase() {
        var _this = _super.call(this) || this;
        _this.as = null;
        _this.bh = false;
        _this.bk = false;
        _this.bj = false;
        _this.bl = false;
        _this.bi = false;
        _this.bo = false;
        _this.bn = false;
        _this.bm = false;
        _this.aw = null;
        _this.b5 = null;
        _this.b7 = null;
        _this.b6 = null;
        _this.b8 = null;
        _this.cv = null;
        _this.a9 = null;
        _this.cx = 0;
        _this.cp = 0;
        _this.cu = 0;
        _this.b2 = null;
        _this.b1 = null;
        _this.b0 = null;
        _this.cf = 0;
        _this.bz = null;
        _this.av = null;
        _this.a7 = null;
        _this.a8 = null;
        _this.aj = new IndexCollection();
        _this.ak = new IndexCollection();
        _this.ca = NaN;
        _this.b9 = 1;
        _this._selectedItems = null;
        _this.labelClick = null;
        _this.selectedItemChanging = null;
        _this.selectedItemsChanging = null;
        _this.selectedItemChanged = null;
        _this.selectedItemsChanged = null;
        _this.sliceClick = null;
        _this.bg = null;
        _this.bf = null;
        _this.g5 = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.c1 = null;
        _this.g5 = Rect.empty;
        var a = _this.ar();
        _this.e6(a);
        a.a1();
        _this.ab = PieChartBase.$;
        _this.b2 = new List$1(Number_$type, 0);
        _this.b1 = new List$1(Number_$type, 0);
        _this.b0 = new List$1(Base.$, 0);
        _this.aw = function (b, c) { return _this.fa(b, c.propertyName, c.oldValue, c.newValue); };
        _this.b5 = function (b, c) {
            _this.fh();
            _this.fg();
        };
        _this.b6 = function (b, c) {
            if (_this.bp) {
                _this.e9();
                _this.e8();
                _this.fh();
                _this.ff();
            }
        };
        _this.b7 = function (b, c) { return _this.fj(c); };
        _this.b8 = function (b, c) { return _this.e2(c); };
        _this.cv = function (b, c) { return _this.ei(c.action, c.position, c.count, c.propertyName); };
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, _this.aw);
        var b = _this.selectedSlices;
        b.collectionChanged = delegateCombine(b.collectionChanged, _this.b7);
        _this.bl = true;
        var c = _this.explodedSlices;
        c.collectionChanged = delegateCombine(c.collectionChanged, _this.b6);
        _this.bi = true;
        _this.selectedItems = new ObjectCollection(0);
        var d = _this.selectedItems;
        d.collectionChanged = delegateCombine(d.collectionChanged, _this.b8);
        _this.bg = ((function () {
            var $ret = new Pool$1(Slice.$);
            $ret.create = runOn(_this.as, _this.as.g);
            $ret.activate = runOn(_this.as, _this.as.be);
            $ret.disactivate = runOn(_this.as, _this.as.bg);
            $ret.destroy = runOn(_this.as, _this.as.bf);
            return $ret;
        })());
        _this.bf = ((function () {
            var $ret = new Pool$1(PieLabel.$);
            $ret.create = runOn(_this.as, _this.as.d);
            $ret.activate = runOn(_this.as, _this.as.ar);
            $ret.disactivate = runOn(_this.as, _this.as.at);
            $ret.destroy = runOn(_this.as, _this.as.as);
            return $ret;
        })());
        _this.av = new PieChartSliceSelector(_this);
        FastItemObjectColumn.m();
        return _this;
    }
    PieChartBase.prototype.ar = function () {
        return new PieChartBaseView(this);
    };
    PieChartBase.prototype.e6 = function (a) {
        this.as = a;
    };
    PieChartBase.prototype.onDetachedFromUI = function () {
        this.as.a0();
    };
    PieChartBase.prototype.onAttachedToUI = function () {
        this.as.ax();
    };
    Object.defineProperty(PieChartBase.prototype, "be", {
        get: function () {
            return this.a9;
        },
        set: function (a) {
            if (this.a9 != a) {
                var b = this.a9;
                this.a9 = a;
                this.fc("ValueColumn", b, this.a9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "cc", {
        get: function () {
            return Math.abs(this.cl) > 1 ? this.cl : this.cl * 100;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "cl", {
        get: function () {
            return this.c(PieChartBase.f2);
        },
        set: function (a) {
            var b = a;
            if (isNaN_(a) || isInfinity(a)) {
                b = 0;
            }
            if (a < 0) {
                b = 0;
            }
            if (a > 100) {
                b = 100;
            }
            this.h(PieChartBase.f2, b);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "ba", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            if (this.a7 != a) {
                var b = this.ba;
                this.a7 = a;
                this.fc("LabelColumn", b, this.ba);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "bb", {
        get: function () {
            return this.a8;
        },
        set: function (a) {
            if (this.a8 != a) {
                var b = this.bb;
                this.a8 = a;
                this.fc("LegendLabelColumn", b, this.bb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "cb", {
        get: function () {
            var a = this.cg;
            if (isNaN_(a) || isInfinity(a) || a < 0) {
                return 0;
            }
            if (a > 1) {
                return 1;
            }
            return a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "ce", {
        get: function () {
            var a = this.cr;
            if (isNaN_(a) || isInfinity(a) || a < 0) {
                return 0;
            }
            if (a > 1) {
                return 1;
            }
            return a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "explodedSlices", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            if (b != null) {
                var c = this.aj;
                c.collectionChanged = delegateRemove(c.collectionChanged, this.b6);
            }
            this.bi = false;
            this.aj = a;
            if (this.aj != null) {
                var d = this.aj;
                d.collectionChanged = delegateCombine(d.collectionChanged, this.b6);
                this.bi = true;
            }
            if (this.bp) {
                this.e9();
                this.e8();
                this.fh();
                this.ff();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "selectedSlices", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.ak;
            b.collectionChanged = delegateRemove(b.collectionChanged, this.b7);
            this.bl = false;
            this.ak = a;
            if (this.ak != null) {
                var c = this.ak;
                c.collectionChanged = delegateCombine(c.collectionChanged, this.b7);
                this.bl = true;
            }
            if (this.bq) {
                this.e9();
                this.e8();
                this.fh();
                this.ff();
                this.fg();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "fu", {
        get: function () {
            return typeCast(DataTemplate.$, this.c(PieChartBase.ga));
        },
        set: function (a) {
            this.h(PieChartBase.ga, a);
        },
        enumerable: true,
        configurable: true
    });
    PieChartBase.prototype.bs = function () {
        return this.at != null;
    };
    PieChartBase.prototype.bt = function () {
        return this.au != null;
    };
    Object.defineProperty(PieChartBase.prototype, "cq", {
        get: function () {
            return this.ca;
        },
        set: function (a) {
            var b = this.ca;
            this.ca = a;
            this.fc("PixelScalingRatio", b, this.ca);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "cd", {
        get: function () {
            return this.b9;
        },
        set: function (a) {
            var b = this.b9;
            this.b9 = a;
            this.fc("ActualPixelScalingRatio", b, this.b9);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "selectedItem", {
        get: function () {
            return this.c(PieChartBase.gp);
        },
        set: function (a) {
            this.h(PieChartBase.gp, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "selectedItems", {
        get: function () {
            return this._selectedItems;
        },
        set: function (a) {
            this._selectedItems = a;
        },
        enumerable: true,
        configurable: true
    });
    PieChartBase.prototype.ey = function (a, b) {
        if (this.labelClick != null) {
            this.labelClick(a, b);
        }
    };
    PieChartBase.prototype.e0 = function (a, b) {
        if (this.selectedItemChanging != null) {
            this.selectedItemChanging(a, b);
        }
    };
    PieChartBase.prototype.e3 = function (a, b) {
        if (this.selectedItemsChanging != null) {
            this.selectedItemsChanging(a, b);
        }
    };
    PieChartBase.prototype.ez = function (a, b) {
        if (this.selectedItemChanged != null) {
            this.selectedItemChanged(a, b);
        }
    };
    PieChartBase.prototype.e1 = function (a, b) {
        if (this.selectedItemsChanged != null) {
            this.selectedItemsChanged(a, b);
        }
    };
    PieChartBase.prototype.e5 = function (a, b) {
        if (this.sliceClick != null) {
            this.sliceClick(a, b);
        }
    };
    PieChartBase.prototype.ek = function (a, b) {
        if (!this.bi) {
            return;
        }
        if (!this.explodedSlices.contains(a.a5) && b) {
            this.explodedSlices.add(a.a5);
        }
        if (this.explodedSlices.contains(a.a5) && !b) {
            this.explodedSlices.remove(a.a5);
        }
    };
    PieChartBase.prototype.fk = function (a, b) {
        this.bn = true;
        if (!this.selectedSlices.contains(a.a5) && b) {
            this.selectedSlices.add(a.a5);
        }
        if (this.selectedSlices.contains(a.a5) && !b) {
            this.selectedSlices.remove(a.a5);
        }
        this.bn = false;
    };
    PieChartBase.prototype.fl = function (a) {
        this.as.bc(a);
    };
    PieChartBase.prototype.cy = function (a) {
        return this.as.ad(a);
    };
    PieChartBase.prototype.g4 = function (a, b) {
        var c = new Rect(0, 0, 0, 0, 0);
        return c;
    };
    PieChartBase.prototype.br = function (a, b) {
        var c = a.ah;
        if (c == null) {
            return false;
        }
        var d = c.b6();
        var e = this.gz == 1 ? c.a3 : c.ax;
        var f = this.gz == 1 ? c.ax : c.a3;
        var g = false;
        var h = false;
        var i = GeometryUtil.k(d, e, c.a2);
        var j = GeometryUtil.k(d, f, c.a2);
        e = PieChartBase.ch(i.x, d.x, i.y, d.y);
        f = PieChartBase.ch(j.x, d.x, j.y, d.y);
        if (this.bu(c)) {
            h = true;
        }
        var k;
        k = MathUtil.e(a.ao.right - d.x, a.ao.top - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.right - d.x, a.ao.bottom - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.left - d.x, a.ao.top - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.left - d.x, a.ao.bottom - d.y);
        if (k > c.a2) {
            return false;
        }
        if (h) {
            return true;
        }
        if (e > f) {
            e = e - 360;
            g = true;
        }
        var l;
        l = PieChartBase.ch(a.ao.right, d.x, a.ao.top, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.ch(a.ao.right, d.x, a.ao.bottom, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.ch(a.ao.left, d.x, a.ao.top, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.ch(a.ao.left, d.x, a.ao.bottom, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        return true;
    };
    PieChartBase.cs = function (a) {
        var b = Math.round(a * Math.pow(10, 5)) / Math.pow(10, 5);
        return b;
    };
    PieChartBase.prototype.bu = function (a) {
        return PieChartBase.cs(Math.abs(a.ax - a.a3)) == 360;
    };
    PieChartBase.ch = function (a, b, c, d) {
        var e = MathUtil.e(a - b, c - d);
        var f = Math.asin((c - d) / e) * 180 / Math.PI;
        if (a < b) {
            f = 180 - f;
        }
        if (a > b) {
            f = 360 + f;
        }
        if (f == 360) {
            f = 0;
        }
        return GeometryUtil.g(f);
    };
    PieChartBase.fq = function (a) {
        var b = new Array(a.count);
        for (var c = 0; c < a.count; c++) {
            var d = a._inner[c];
            var e = d.ah;
            var f = GeometryUtil.k(e.b7, d.ai, e.a2);
            b[c] = f.y;
        }
        for (var g = 0; g < a.count; g++) {
            for (var h = g + 1; h < a.count; h++) {
                if (b[g] >= b[h]) {
                    var i = a._inner[g];
                    a._inner[g] = a._inner[h];
                    a._inner[h] = i;
                    var j = b[g];
                    b[g] = b[h];
                    b[h] = j;
                }
            }
        }
    };
    PieChartBase.prototype.fi = function (a) {
        var e_1, _a, e_2, _b;
        if (a.count == 0) {
            return;
        }
        var b = this.as.b2.width;
        var c = this.as.b2.height;
        var d = a.count;
        var e = a._inner[0].ah.a2;
        var f = a._inner[0].ah.b6();
        var g = true;
        var h = 0;
        var i = Number.POSITIVE_INFINITY;
        var j = Number.NEGATIVE_INFINITY;
        for (var k = 0; k < d - 1; k++) {
            var l = a._inner[k];
            var m = a._inner[k + 1];
            if (l.ao.intersectsWith(m.ao)) {
                h++;
            }
        }
        var n = 0;
        try {
            for (var _c = __values(fromEnum(a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var o = _d.value;
                i = Math.min(i, o.ao.height);
                j = Math.max(j, o.ao.height);
                n += o.ao.height;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        if (n > c) {
            g = false;
        }
        if (g && h > 0) {
            for (var p = 0; p < d - 1; p++) {
                for (var q = p + 1; q < d; q++) {
                    var r = a._inner[p];
                    var s = a._inner[q];
                    if (r.ao.intersectsWith(s.ao)) {
                        var t = s.ao;
                        t.y = Math.min(r.ao.bottom + 0.01, c - i);
                        var u = this.cm + e;
                        var v = Math.abs(f.y - (t.y + i / 2));
                        var w = Math.sqrt(Math.abs(u * u - v * v));
                        var x = GeometryUtil.g(s.ai);
                        if (x > 90 && x < 270) {
                            w = (t.width + w) * -1;
                        }
                        t.x = f.x + w;
                        s.ao = t;
                    }
                }
            }
            for (var y = d - 1; y > 0; y--) {
                for (var z = y - 1; z >= 0; z--) {
                    var aa = a._inner[y];
                    var ab = a._inner[z];
                    if (aa.ao.intersectsWith(ab.ao)) {
                        var ac = ab.ao;
                        ac.y = Math.max(aa.ao.top - i - 0.01, 0);
                        var ad = this.cm + e;
                        var ae = Math.abs(f.y - (ac.y + i / 2));
                        var af = Math.sqrt(Math.abs(ad * ad - ae * ae));
                        var ag = GeometryUtil.g(ab.ai);
                        if (ag > 90 && ag < 270) {
                            af = (ac.width + af) * -1;
                        }
                        ac.x = f.x + af;
                        ab.ao = ac;
                    }
                }
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var ah = _f.value;
                var ai = ah.ao;
                if (ai.left > b || ai.right < 0) {
                    ah._visibility = 1;
                    if (this.ap == 0) {
                        ah.ap._visibility = 1;
                    }
                    else {
                        ah.aq._visibility = 1;
                    }
                }
                else if (ai.left < 0) {
                    var aj = Math.abs(ai.x);
                    ai.x = 0;
                    if (aj > ai.width) {
                        ai.width = 0;
                    }
                    else {
                    }
                    ah.ao = ai;
                }
                else if (ai.right > b) {
                    var ak = ai.right - b;
                    if (ak > ai.width) {
                        ai.width = 0;
                    }
                    else {
                        ai.width = ai.width - ak;
                    }
                    ah.ao = ai;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    PieChartBase.prototype.ei = function (a, b, c, d) {
        this.fe();
    };
    PieChartBase.prototype.fe = function () {
        this.e7();
        this.e9();
        this.e8();
        this.fh();
        this.ff();
        this.fg();
        this.as.br();
    };
    PieChartBase.prototype.e7 = function () {
        var e_3, _a;
        this.cu = 0;
        this.cp = 0;
        this.b2.clear();
        this.b1.clear();
        this.b0.clear();
        if (this.itemsSource == null || this.a5 == null) {
            return;
        }
        if (this.be == null || this.be.count == 0) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.be)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (isNaN_(a) || isInfinity(a) || a <= 0) {
                    continue;
                }
                this.cu = this.cu + a;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        for (var b = 0; b < this.be.count; b++) {
            var c = this.be.item(b);
            var d = c <= 0;
            if (isNaN_(c) || isInfinity(c) || d) {
                continue;
            }
            var e = this.aq == 1 ? c / this.cu : c;
            var f = this.aq == 1 ? this.co / 100 : this.co;
            var g = true;
            if (e <= f && g) {
                this.cp = this.cp + c;
                this.b1.add(b);
                this.b0.add1(this.a5.item(b));
            }
            else {
                this.b2.add(b);
            }
        }
    };
    PieChartBase.prototype.e9 = function () {
        if (this.itemsSource == null || this.a5 == null) {
            this.bg.count = 0;
            return;
        }
        var a = this.b2.count;
        var b = this.b1.count > 0;
        var c = PieChartBase.cs(this.cf);
        var d = PieChartBase.cs(this.cf);
        if (b) {
            a++;
        }
        this.cx = a;
        for (var e = 0; e < a; e++) {
            var f = false;
            var g = void 0;
            if (e == a - 1 && b) {
                g = this.cp;
                f = true;
            }
            else {
                g = this.be.item(this.b2._inner[e]);
            }
            if (this.gz == 1) {
                d += PieChartBase.cs(Math.abs(g) * 360 / this.cu);
            }
            else {
                d -= PieChartBase.cs(Math.abs(g) * 360 / this.cu);
            }
            var h = this.bg.item(e);
            h.aw = true;
            h.a3 = c;
            h.ax = d;
            h.a1 = h.a0 = this.cc;
            h.isOthersSlice = f;
            h.ay = this.cb;
            h.a5 = e;
            h.dataContext = f ? this.b0 : this.a5.item(this.b2._inner[e]);
            this.av.j(h);
            h.isExploded = this.bi ? this.explodedSlices.contains(e) : false;
            c = d;
            h.aw = false;
        }
        this.bg.count = a;
    };
    PieChartBase.prototype.e8 = function () {
        var _this = this;
        if (this.itemsSource == null || this.a5 == null) {
            this.bf.count = 0;
            return;
        }
        if (this.ba == null || this.ba.count == 0 || this.ao == 0) {
            this.bf.count = 0;
        }
        var a = this.b2.count;
        if (this.b1.count > 0) {
            a++;
        }
        this.as.au();
        var b = 0;
        var _loop_1 = function (c) {
            var d = stringEmpty();
            var e = false;
            var f;
            var g = null;
            if (c == a - 1 && this_1.b1.count > 0) {
                f = this_1.dz;
                e = true;
                if (this_1.bs()) {
                    var h = ((function () {
                        var $ret = new PieSliceDataContext();
                        $ret.series = _this;
                        $ret.item = e ? _this.b0 : _this.a5.item(_this.b2._inner[c]);
                        $ret.percentValue = _this.ck(_this.bg.item(c));
                        $ret.isOthersSlice = e;
                        return $ret;
                    })());
                    if (f != null) {
                        h.itemLabel = f.toString();
                        h.legendLabel = f.toString();
                    }
                    var i = h;
                    i = i.flatten();
                    f = this_1.at(i);
                }
                if (null != f) {
                    d = f.toString();
                }
                else {
                    d = this_1.dz;
                }
                d = this_1.dz;
            }
            else {
                if (this_1.ba != null && this_1.ba.count >= this_1.b2.count) {
                    f = this_1.ba.item(this_1.b2._inner[c]);
                }
                else {
                    f = null;
                }
                g = (this_1.bb != null && this_1.bb.count > 0) ? this_1.bb.item(this_1.b2._inner[c]) : null;
                if (this_1.bs()) {
                    var j = ((function () {
                        var $ret = new PieSliceDataContext();
                        $ret.series = _this;
                        $ret.item = e ? _this.b0 : _this.a5.item(_this.b2._inner[c]);
                        $ret.itemLabel = f != null ? f.toString() : null;
                        $ret.legendLabel = g != null ? g.toString() : f != null ? f.toString() : null;
                        $ret.percentValue = _this.ck(_this.bg.item(c));
                        $ret.isOthersSlice = e;
                        return $ret;
                    })());
                    var k = j;
                    k = k.flatten();
                    var formatedLabel_ = this_1.at(k);
                    if (null == formatedLabel_ && this_1.ba != null && this_1.ba.count > 0) {
                        f = this_1.ba.item(this_1.b2._inner[c]);
                    }
                    else {
                        f = formatedLabel_;
                    }
                }
                var label_ = f;
                var errorMsg_ = this_1.as.af;
                if (label_ === undefined) {
                    throw new Error(errorMsg_);
                }
                ;
                if (null != f) {
                    d = f.toString();
                }
                else {
                    d = null;
                }
            }
            if (this_1.ba != null && this_1.ba.count > 0) {
                var l = this_1.bf.item(c);
                var m = this_1.bg.item(c);
                m.aj = l;
                l.ai = GeometryUtil.g((m.a3 + m.ax) / 2);
                l.ah = m;
                l.aj = ((function () {
                    var $ret = new TextBlock();
                    $ret.ak = d;
                    return $ret;
                })());
                if (this_1.fu == null) {
                    l.dataContext = e ? this_1.b0 : this_1.a5.item(this_1.b2._inner[c]);
                    l.ak(this_1.as);
                }
                else {
                }
                l._visibility = 0;
                l.ao = this_1.as.b1(l);
                b++;
            }
            if (this_1.bb != null && this_1.bb.count > 0) {
                var n = this_1.bg.item(c);
                n.bf = g != null ? g.toString() : null;
            }
        };
        var this_1 = this;
        for (var c = 0; c < a; c++) {
            _loop_1(c);
        }
        this.bf.count = b;
    };
    PieChartBase.prototype.fh = function () {
        var e_4, _a;
        if (this.itemsSource == null || this.a5 == null) {
            return;
        }
        var a = this.as.b3();
        this.g5 = new Rect(0, 0, 0, a.width, a.height);
        var b = this.as.aa();
        var c = this.as.z(this.g8);
        b = isNaN_(b) ? 0 : b / 2;
        c = isNaN_(c) ? 0 : c / 2;
        b = Math.max(c, b);
        var d = Math.min(a.width / 2, a.height / 2);
        var e = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        var f = d * this.ce;
        var g = f + b;
        if (g > d) {
            var h = g - d;
            f = f - h;
        }
        try {
            for (var _b = __values(fromEnum(this.bg.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                var j = GeometryUtil.j(a.width, a.height, true, (i.a3 + i.ax) / 2, f * this.cb);
                i.aw = true;
                i.a1 = i.a0 = this.cc;
                i.a2 = f;
                i.ay = this.cb;
                i.b7 = e;
                i.b5 = j;
                this.fl(i);
                i.aw = false;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.as.br();
    };
    PieChartBase.prototype.ff = function () {
        var e_5, _a, e_6, _b, e_7, _c, e_8, _d, e_9, _e;
        var a = this.as.b2.width;
        var b = this.as.b2.height;
        if (b == 0 || a == 0) {
            return;
        }
        if (this.bf.a.count == 0 || this.ao == 0) {
            this.bf.count = 0;
            return;
        }
        var c = new List$1(PieLabel.$, 0);
        var d = new List$1(PieLabel.$, 0);
        var e = new List$1(PieLabel.$, 0);
        var f = new List$1(PieLabel.$, 0);
        try {
            for (var _f = __values(fromEnum(this.bf.a)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var g = _g.value;
                var h = g.ah;
                if (h == null) {
                    continue;
                }
                var i = h.b6();
                var j = g.ao.width;
                var k = g.ao.height;
                if (this.ao == 1 || this.ao == 4) {
                    var l = h.a2 * h.a1 / 100;
                    var m = GeometryUtil.k(i, g.ai, h.a2 - (h.a2 - l) / 2);
                    g.ao = new Rect(0, m.x - j / 2, m.y - k / 2, j, k);
                    var n = this.br(g, m);
                    if (n || this.ao == 1) {
                        if (this.gx == null) {
                            h.f(Slice.bp);
                        }
                        else {
                            h.b2 = this.gx;
                        }
                        h.au = true;
                        e.add(g);
                        g.ag = 1;
                        if (g.ah.ai.ap == 0) {
                            g.ap._visibility = 1;
                        }
                        else {
                            g.aq._visibility = 1;
                        }
                        if (!n && this.ao == 1) {
                            g._visibility = 1;
                        }
                        else {
                            g._visibility = 0;
                        }
                        continue;
                    }
                }
                if (this.ao == 2 || this.ao == 4) {
                    var o = PieChartBase.ci(i, h.a2, g);
                    var p = GeometryUtil.k(i, g.ai, o);
                    g.ao = new Rect(0, p.x - j / 2, p.y - k / 2, j, k);
                    var q = this.br(g, p);
                    if (q || this.ao == 2) {
                        if (this.gx == null) {
                            h.f(Slice.bp);
                        }
                        else {
                            h.b2 = this.gx;
                        }
                        h.au = true;
                        f.add(g);
                        g.ag = 2;
                        if (g.ah.ai.ap == 0) {
                            g.ap._visibility = 1;
                        }
                        else {
                            g.aq._visibility = 1;
                        }
                        if (!q && this.ao == 2) {
                            g._visibility = 1;
                        }
                        else {
                            g._visibility = 0;
                        }
                        continue;
                    }
                }
                if (this.gy == null) {
                    h.f(Slice.bp);
                }
                else {
                    h.b2 = this.gy;
                }
                h.au = false;
                var r = GeometryUtil.k(i, g.ai, h.a2 + this.cm);
                g.ag = 3;
                g._visibility = 0;
                g.al();
                if (g.ai < 90 && g.ai >= 0) {
                    g.ao = new Rect(0, r.x, r.y, j, k);
                    c.add(g);
                }
                else if (g.ai < 180 && g.ai >= 90) {
                    g.ao = new Rect(0, r.x - j, r.y, j, k);
                    d.add(g);
                }
                else if (g.ai < 270 && g.ai >= 180) {
                    g.ao = new Rect(0, r.x - j, r.y - k, j, k);
                    d.add(g);
                }
                else {
                    g.ao = new Rect(0, r.x, r.y - k, j, k);
                    c.add(g);
                }
                if (g.ao.y < 0) {
                    g.ao = new Rect(0, g.ao.x, 0, g.ao.width, g.ao.height);
                }
                if (g.ao.bottom > b) {
                    g.ao = new Rect(0, g.ao.x, b - g.ao.height, g.ao.width, g.ao.height);
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_a = _f.return))
                    _a.call(_f);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        PieChartBase.fq(c);
        this.fi(c);
        PieChartBase.fq(d);
        this.fi(d);
        try {
            for (var _h = __values(fromEnum(e)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var s = _j.value;
                this.as.bm(s, s.ao.x, s.ao.y);
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_b = _h.return))
                    _b.call(_h);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        try {
            for (var _k = __values(fromEnum(f)), _l = _k.next(); !_l.done; _l = _k.next()) {
                var t = _l.value;
                this.as.bm(t, t.ao.x, t.ao.y);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_l && !_l.done && (_c = _k.return))
                    _c.call(_k);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        try {
            for (var _m = __values(fromEnum(c)), _o = _m.next(); !_o.done; _o = _m.next()) {
                var u = _o.value;
                this.as.bm(u, u.ao.x, u.ao.y);
                if (u.ah.ai.ap == 0) {
                    u.am();
                }
                else {
                    u.an();
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_o && !_o.done && (_d = _m.return))
                    _d.call(_m);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _p = __values(fromEnum(d)), _q = _p.next(); !_q.done; _q = _p.next()) {
                var v = _q.value;
                this.as.bm(v, v.ao.x, v.ao.y);
                if (v.ah.ai.ap == 0) {
                    v.am();
                }
                else {
                    v.an();
                }
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_q && !_q.done && (_e = _p.return))
                    _e.call(_p);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        this.as.br();
    };
    PieChartBase.ci = function (a, b, c) {
        var d = c.ai * Math.PI / 180;
        var e = 1;
        var f = GeometryUtil.k({ $type: Point_$type, x: 0, y: 0 }, c.ai, e);
        var g = PieChartBase.g1(c);
        var h = Math.sqrt(g.x * g.x + g.y * g.y);
        var i = { $type: Point_$type, x: g.x / h, y: g.y / h };
        var j = PieChartBase.cj(f, i);
        var k = h / b;
        var l = j * k;
        var m = l;
        var n = GeometryUtil.e({ $type: Point_$type, x: 0, y: 0 }, f);
        var o = GeometryUtil.e({ $type: Point_$type, x: 0, y: 0 }, i);
        if (o < n) {
            m = -m;
        }
        var p = GeometryUtil.k(a, (d + m) * 180 / Math.PI, b);
        var q = PieChartBase.g0(c, p);
        var r = Math.sqrt((q.x - a.x) * (q.x - a.x) + (q.y - a.y) * (q.y - a.y));
        var s = r - 5;
        return s;
    };
    PieChartBase.g0 = function (a, b) {
        var c = GeometryUtil.g(a.ai);
        var d = a.ao.width / 2;
        var e = a.ao.height / 2;
        if (c >= 0 && c <= 90) {
            return { $type: Point_$type, x: b.x - d, y: b.y - e };
        }
        if (c >= 90 && c <= 180) {
            return { $type: Point_$type, x: b.x + d, y: b.y - e };
        }
        if (c >= 180 && c <= 270) {
            return { $type: Point_$type, x: b.x + d, y: b.y + e };
        }
        return { $type: Point_$type, x: b.x - d, y: b.y + e };
    };
    PieChartBase.cj = function (a, b) {
        var c = a.x * b.x + a.y * b.y;
        var d = Math.sqrt(a.x * a.x + a.y * a.y);
        var e = Math.sqrt(b.x * b.x + b.y * b.y);
        var f = Math.acos(c / (d * e));
        return f;
    };
    PieChartBase.g1 = function (a) {
        var b = GeometryUtil.g(a.ai);
        var c = a.ao.width / 2;
        var d = a.ao.height / 2;
        if (b >= 0 && b <= 90) {
            return { $type: Point_$type, x: c, y: d };
        }
        if (b >= 90 && b <= 180) {
            return { $type: Point_$type, x: -c, y: d };
        }
        if (b >= 180 && b <= 270) {
            return { $type: Point_$type, x: -c, y: -d };
        }
        return { $type: Point_$type, x: c, y: -d };
    };
    PieChartBase.prototype.fg = function () {
        var e_10, _a;
        var _this = this;
        if (this.legend == null || !this.legend.isItemwise) {
            return;
        }
        if ((this.ba == null || this.ba.count == 0) && (this.bb == null || this.bb.count == 0)) {
            this.legend.clearLegendItemsForSeries(this);
            return;
        }
        this.bz = new List$1(UIElement.$, 0);
        var _loop_2 = function (a) {
            var b = new ContentControl();
            var c = this_2.cy(a);
            var d = this_2.as.bt(a);
            var e = this_2.as.bu(a);
            b.content = ((function () {
                var $ret = new PieSliceDataContext();
                $ret.series = _this;
                $ret.slice = a;
                $ret.item = a.dataContext;
                $ret.itemBrush = d;
                $ret.outline = e;
                $ret.thickness = a.a4;
                $ret.itemLabel = c != null ? c.toString() : null;
                $ret.legendLabel = a.isOthersSlice ? _this.dz : a.bf != null ? a.bf : (c != null ? c.toString() : null);
                $ret.percentValue = _this.ck(a);
                $ret.isOthersSlice = a.isOthersSlice;
                return $ret;
            })());
            var f = b.content;
            if (this_2.bt()) {
                var g = this_2.au(b.content);
                if (g != null) {
                    f.legendLabel = g.toString();
                }
            }
            if (this_2.legendItemTemplate != null) {
                b.ah = this_2.legendItemTemplate;
            }
            this_2.bz.add(b);
        };
        var this_2 = this;
        try {
            for (var _b = __values(fromEnum(this.bg.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                _loop_2(a);
            }
        }
        catch (e_10_1) {
            e_10 = { error: e_10_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_10)
                    throw e_10.error;
            }
        }
        if (this.legend.isItemwise) {
            var h = this.legend;
            h.createItemwiseLegendItems(this.bz, this);
        }
    };
    PieChartBase.prototype.a4 = function () {
        var a = new PieChartVisualData();
        a.viewport = RectData.b(this.g5);
        this.as.an(a);
        for (var b = 0; b < this.bg.count; b++) {
            var c = this.bg.item(b).am();
            a.slices.add(c);
            if (this.bg.item(b).isOthersSlice) {
                a.othersSlice = this.bg.item(b).am();
            }
        }
        a.others = this.b0;
        a.name = this.name;
        a.radiusFactor = this.ce;
        a.leaderLineMargin = this.cn;
        return a;
    };
    PieChartBase.prototype.c8 = function () {
        var a = this.a4();
        a.scaleByViewport();
        return a.serialize();
    };
    PieChartBase.prototype.bc = function (a) {
        var b = null;
        return this.a5.registerColumn(a, b, false);
    };
    PieChartBase.prototype.bd = function (a) {
        var b = null;
        return this.a5.registerColumnObject(a, b, false);
    };
    PieChartBase.prototype.fa = function (a, b, c, d) {
        var e_11, _a;
        switch (b) {
            case PieChartBase.$$p[8]:
                this.a5 = ((function () {
                    var $ret = new FastItemsSource();
                    $ret.e = d;
                    return $ret;
                })());
                break;
            case PieChartBase.$$p[4]:
                if (typeCast(FastItemsSource.$, c) != null) {
                    var e = c;
                    e.event = delegateRemove(e.event, this.cv);
                    this.bj = false;
                    c.deregisterColumn(this.be);
                    c.deregisterColumn(this.ba);
                    this.be = null;
                    this.ba = null;
                    this.selectedItem = null;
                    this.selectedItems.clear();
                    if (this.selectedSlices != null) {
                        this.selectedSlices.clear();
                    }
                    (typeCast(FastItemsSource.$, c)).deregisterColumn(this.bb);
                    this.bb = null;
                }
                if (typeCast(FastItemsSource.$, d) != null) {
                    var f = d;
                    f.event = delegateCombine(f.event, this.cv);
                    this.bj = true;
                    this.be = this.bc(this.eg);
                    this.ba = this.bd(this.di);
                    this.bb = this.bd(this.dv);
                    this.e9();
                    if (this.selectedItem != null || this.selectedItems.count > 0) {
                        this.fs();
                    }
                    else if (this.selectedSlices != null && this.selectedSlices.count > 0) {
                        this.ft();
                    }
                }
                this.fe();
                break;
            case PieChartBase.$$p[34]:
                if (this.a5 != null) {
                    this.a5.deregisterColumn(this.be);
                    this.be = this.bc(this.eg);
                }
                break;
            case PieChartBase.$$p[20]:
                if (this.a5 != null) {
                    this.a5.deregisterColumn(this.bb);
                    this.bb = this.bd(this.dv);
                    this.e8();
                    this.ff();
                    this.fg();
                }
                break;
            case PieChartBase.$$p[6]:
                this.fg();
                break;
            case PieChartBase.$$p[5]:
            case PieChartBase.$$p[11]:
                if (this.a5 != null) {
                    this.a5.deregisterColumn(this.ba);
                    this.ba = this.bd(this.di);
                    this.e8();
                    this.ff();
                    this.fg();
                }
                break;
            case PieChartBase.$$p[30]:
                this.cf = d;
                this.e9();
                this.e8();
                this.fh();
                this.ff();
                break;
            case PieChartBase.$$p[32]:
                this.as.bp(this.c0);
                break;
            case PieChartBase.$$p[21]:
                var g = typeCast(IChartLegend_$type, c);
                if (g != null) {
                    g.clearLegendItemsForSeries(this);
                }
                this.fg();
                break;
            case PieChartBase.$$p[18]:
            case PieChartBase.$$p[19]:
                this.fg();
                break;
            case PieChartBase.$$p[27]:
            case PieChartBase.$$p[3]:
            case PieChartBase.$$p[31]:
                this.e9();
                this.e8();
                this.fh();
                this.ff();
                break;
            case PieChartBase.$$p[22]:
            case PieChartBase.$$p[28]:
                this.fh();
                this.fg();
                break;
            case PieChartBase.$$p[2]:
                if (c != null) {
                    var h = c;
                    h.collectionChanged = delegateRemove(h.collectionChanged, this.b5);
                    this.bh = false;
                }
                if (d != null) {
                    var i = d;
                    i.collectionChanged = delegateCombine(i.collectionChanged, this.b5);
                    this.bh = true;
                }
                this.fh();
                this.fg();
                break;
            case PieChartBase.$$p[26]:
                if (c != null) {
                    var j = c;
                    j.collectionChanged = delegateRemove(j.collectionChanged, this.b5);
                    this.bk = false;
                }
                if (d != null) {
                    var k = d;
                    k.collectionChanged = delegateCombine(k.collectionChanged, this.b5);
                    this.bk = true;
                }
                this.fh();
                this.fg();
                break;
            case "ValueColumn":
            case PieChartBase.$$p[24]:
            case PieChartBase.$$p[25]:
                this.fe();
                this.fs();
                this.ft();
                break;
            case PieChartBase.$$p[0]:
            case PieChartBase.$$p[1]:
                this.fe();
                break;
            case PieChartBase.$$p[13]:
                this.e8();
                this.ff();
                this.as.br();
                break;
            case PieChartBase.$$p[10]:
            case PieChartBase.$$p[12]:
            case PieChartBase.$$p[9]:
                this.e8();
                this.ff();
                break;
            case PieChartBase.$$p[23]:
                this.e8();
                this.ff();
                this.fg();
                break;
            case PieChartBase.$$p[17]:
                this.ff();
                break;
            case PieChartBase.$$p[15]:
                this.ff();
                break;
            case "TextStyle":
                this.as.bh();
                break;
            case "PixelScalingRatio":
                if (isNaN_(DeviceUtils.a(this.cq))) {
                    this.cd = 1;
                }
                else {
                    this.cd = DeviceUtils.a(this.cq);
                }
                break;
            case "ActualPixelScalingRatio":
                this.as.a3();
                break;
            case "LabelTemplate":
                this.e8();
                this.ff();
                break;
            case PieChartBase.$$p[16]:
            case PieChartBase.$$p[14]:
                this.bf.c(runOn(this.as, this.as.bl));
                this.ff();
                break;
            case PieChartBase.$$p[7]:
                this.as.a2();
                break;
            case "InnerExtent":
                this.fe();
                break;
            case "SelectedItem":
                if (!this.bn) {
                    this.e9();
                    this.fh();
                    this.fg();
                }
                break;
            case PieChartBase.$$p[29]:
                if (EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 1 && this.selectedItems != null && this.selectedItems.count > 1) {
                    this.selectedItems.clear();
                }
                else if (EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 2 && this.selectedItem != null && this.selectedItems != null) {
                    if (!this.selectedItems.contains1(this.selectedItem)) {
                        if (typeCast(PieSliceOthersContext.$, this.selectedItem) !== null) {
                            var l = typeCast(PieSliceOthersContext.$, this.selectedItem);
                            try {
                                for (var _b = __values(fromEn(l.data)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                    var m = _c.value;
                                    this.selectedItems.add1(m);
                                }
                            }
                            catch (e_11_1) {
                                e_11 = { error: e_11_1 };
                            }
                            finally {
                                try {
                                    if (_c && !_c.done && (_a = _b.return))
                                        _a.call(_b);
                                }
                                finally {
                                    if (e_11)
                                        throw e_11.error;
                                }
                            }
                        }
                        else {
                            this.selectedItems.add1(this.selectedItem);
                        }
                        this.ft();
                    }
                }
                this.fs();
                this.e9();
                this.fh();
                break;
        }
    };
    PieChartBase.prototype.fj = function (a) {
        if (this.bo) {
            return;
        }
        this.ft();
        if (this.bq) {
            this.e9();
            this.fh();
            this.fg();
        }
    };
    PieChartBase.prototype.e2 = function (a) {
        if (a.action == 4 && a.newItems == null && a.oldItems == null) {
            return;
        }
        if (this.bn) {
            return;
        }
        this.fs();
        if (this.bq) {
            this.e9();
            this.fh();
            this.fg();
        }
        this.e1(this, new SelectedItemsChangedEventArgs(a.oldItems, a.newItems));
    };
    PieChartBase.prototype.fc = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    PieChartBase.prototype.ft = function () {
        var e_12, _a, e_13, _b;
        if (this.itemsSource == null || this.bg.a.count == 0) {
            return;
        }
        this.bn = true;
        var a = this.selectedSlices.count;
        if (a == 0) {
            if (this.selectedItems.count > 0) {
                this.selectedItems.clear();
            }
            if (this.selectedItem != null) {
                this.selectedItem = null;
            }
        }
        if (this.a3 == 1) {
            if (a != 0) {
                var b_1 = this.bg.a._inner[this.selectedSlices._inner[a - 1]];
                if (b_1.isOthersSlice) {
                    this.selectedItem = ((function () {
                        var $ret = new PieSliceOthersContext();
                        $ret.data = typeCast(IList_$type, b_1.dataContext);
                        $ret.slice = b_1;
                        return $ret;
                    })());
                }
                else {
                    this.selectedItem = b_1.dataContext;
                }
            }
        }
        else if (this.a3 == 2) {
            if (a != 0) {
                this.selectedItems.clear();
                try {
                    for (var _c = __values(fromEnum(this.selectedSlices)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        var d = this.bg.a._inner[c];
                        if (d.isOthersSlice) {
                            var e = typeCast(IEnumerable_$type, d.dataContext);
                            try {
                                for (var _e = (e_13 = void 0, __values(fromEn(e))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                    var f = _f.value;
                                    this.av.e(f);
                                }
                            }
                            catch (e_13_1) {
                                e_13 = { error: e_13_1 };
                            }
                            finally {
                                try {
                                    if (_f && !_f.done && (_b = _e.return))
                                        _b.call(_e);
                                }
                                finally {
                                    if (e_13)
                                        throw e_13.error;
                                }
                            }
                        }
                        else {
                            this.av.e(d.dataContext);
                        }
                    }
                }
                catch (e_12_1) {
                    e_12 = { error: e_12_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_12)
                            throw e_12.error;
                    }
                }
                this.selectedItem = this.bg.a._inner[this.selectedSlices._inner[a - 1]].dataContext;
            }
        }
        this.bn = false;
    };
    PieChartBase.prototype.fs = function () {
        var e_14, _a;
        if (this.itemsSource == null || this.bg.a.count == 0) {
            return;
        }
        this.bo = true;
        this.selectedSlices.clear();
        try {
            for (var _b = __values(fromEnum(this.bg.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (this.av.d(a)) {
                    this.selectedSlices.add(a.a5);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.bo = false;
    };
    PieChartBase.prototype.fo = function (a, b) {
        this.fp(a, b, false);
    };
    PieChartBase.prototype.fp = function (a, b, c) {
        if (this.bq) {
            if (this.a3 == 1) {
                this.av.k(a);
            }
            else if (this.a3 == 2) {
                this.av.i(a);
            }
        }
        var d = new SliceClickEventArgs(a, this.as.ae(b));
        this.e5(this, d);
        if (!c) {
            this.as.bn(a, b);
        }
    };
    PieChartBase.prototype.fn = function (a) {
        this.as.ak(a);
    };
    PieChartBase.prototype.bw = function (a, b) {
        var c = new LabelClickEventArgs(a, this.as.ae(b));
        this.ey(this, c);
        return c.allowSliceClick;
    };
    PieChartBase.prototype.em = function (a, b) {
        this.as.bn(a, b);
    };
    PieChartBase.prototype.ep = function (a, b, c) {
        this.as.bn(a, b);
    };
    PieChartBase.prototype.eo = function (a, b) {
        this.ep(a, b, false);
    };
    PieChartBase.prototype.en = function (a, b) {
        this.as.al();
    };
    PieChartBase.prototype.e4 = function () {
        this.fe();
    };
    PieChartBase.prototype.provideContainer = function (a) {
        this.as.ay(a);
    };
    PieChartBase.prototype.ew = function (a, b) {
        this.as.az(a, b);
    };
    PieChartBase.prototype.notifyContainerResized = function () {
        this.as.aw();
    };
    PieChartBase.prototype.g3 = function () {
        return this.as.b0();
    };
    PieChartBase.prototype.g2 = function () {
        return this.as.bx();
    };
    PieChartBase.prototype.destroy = function () {
        this.fd();
        this.as.ay(null);
    };
    PieChartBase.prototype.el = function () {
        this.as.ao();
    };
    Object.defineProperty(PieChartBase.prototype, "eb", {
        get: function () {
            return this.c1;
        },
        set: function (a) {
            var b = this.c1;
            this.c1 = a;
            this.fc("TextStyle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "container", {
        get: function () {
            return this;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "isStacked", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "isVertical", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "hasMarkers", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "isUsableInLegend", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieChartBase.prototype, "hasSubItems", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    PieChartBase.prototype.ck = function (a) {
        if (a == null || this.be == null || this.b2 == null) {
            return NaN;
        }
        if (a.isOthersSlice) {
            return this.cp / this.cu * 100;
        }
        else {
            return this.be.item(this.b2._inner[a.a5]) / this.cu * 100;
        }
    };
    PieChartBase.prototype.eu = function (source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bx(source_)) {
            return;
        }
        var d = this.a5;
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    PieChartBase.prototype.eq = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bx(source_)) {
            return;
        }
        var a = this.a5;
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    };
    PieChartBase.prototype.bx = function (a) {
        return PieChartBase.by(a, this.itemsSource);
    };
    PieChartBase.by = function (a, b) {
        return a == b;
    };
    PieChartBase.prototype.es = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bx(source_)) {
            return;
        }
        var c = this.a5;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    PieChartBase.prototype.et = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bx(source_)) {
            return;
        }
        var c = this.a5;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    PieChartBase.prototype.fm = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        this.itemsSource = source_;
    };
    PieChartBase.prototype.fd = function () {
        this.itemsSource = null;
    };
    PieChartBase.prototype.fr = function () {
        this.as.bh();
    };
    PieChartBase.prototype.a6 = function () {
        return FontUtil.toFontInfo(this.as.c.n, this.eb);
    };
    PieChartBase.prototype.resolveLegendIndex = function () {
        return -1;
    };
    PieChartBase.prototype.forSubItems = function (a) {
    };
    PieChartBase.$t = markType(PieChartBase, 'PieChartBase', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type, ILegendSeries_$type, ILegendTemplateProvider_$type]);
    PieChartBase.f2 = DependencyProperty.i("InnerExtent", Number_$type, PieChartBase.$, new PropertyMetadata(2, 0, function (a, b) { return a.fc("InnerExtent", b.oldValue, b.newValue); }));
    PieChartBase.ga = DependencyProperty.i("LabelTemplate", DataTemplate.$, PieChartBase.$, new PropertyMetadata(2, null, function (a, b) { return a.fc("LabelTemplate", b.oldValue, b.newValue); }));
    PieChartBase.gp = DependencyProperty.i("SelectedItem", Base.$, PieChartBase.$, new PropertyMetadata(1, function (a, b) {
        var c = typeCast(PieChartBase.$, a);
        if (c.bm) {
            return;
        }
        var d = new SelectedItemChangingEventArgs(b.oldValue, b.newValue);
        c.e0(c, d);
        if (!d.cancel) {
            if (!c.bn) {
                c.fs();
            }
            c.fc("SelectedItem", b.oldValue, b.newValue);
            c.ez(a, new SelectedItemChangedEventArgs(b.oldValue, b.newValue));
        }
        else {
            c.bm = true;
            c.selectedItem = b.oldValue;
            c.bm = false;
        }
    }));
    PieChartBase.$$p = markDep(DependencyProperty, PropertyMetadata, PieChartBase, 'fc', ['AllowSliceExplosion:bp:fv', [0, true], 'AllowSliceSelection:bq:fw', [0, true], 'Brushes:ag:fx', [BrushCollection.$, null], 'ExplodedRadius:cg:fy', [1, 0.2], 'FastItemsSource:a5:fz', [FastItemsSource.$], 'FormatLabel:at:f0', [Delegate_$type], 'FormatLegendLabel:au:f1', [Delegate_$type], 'IsSurfaceInteractionDisabled:bv:f3', [0, false], 'ItemsSource::f4', [IEnumerable_$type, null], 'LabelExtent:cm:f5', [1, 10], 'LabelInnerColor:gx:f6', [Brush.$, null], 'LabelMemberPath:di:f7', [2], 'LabelOuterColor:gy:f8', [Brush.$, null], 'LabelsPosition:ao:f9', [LabelsPosition_$type, enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:cn:gb', [1, 6], 'LeaderLineStyle:g6:gc', [Style.$, null], 'LeaderLineType:ap:gd', [LeaderLineType_$type, enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:ha:ge', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'LegendItemBadgeTemplate::gf', [DataTemplate.$, null], 'LegendItemTemplate::gg', [DataTemplate.$, null], 'LegendLabelMemberPath:dv:gh', [2], 'Legend::gi', [IChartLegend_$type, null], 'OthersCategoryStyle:g7:gj', [Style.$, null], 'OthersCategoryText:dz:gk', [2, "Others"], 'OthersCategoryThreshold:co:gl', [1, 3], 'OthersCategoryType:aq:gm', [OthersCategoryType_$type, enumGetBox(OthersCategoryType_$type, 1)], 'Outlines:ah:gn', [BrushCollection.$, null], 'RadiusFactor:cr:go', [1, 0.9], 'SelectedStyle:g8:gq', [Style.$, null], 'SelectionMode:a3:gr', [SliceSelectionMode_$type, enumGetBox(SliceSelectionMode_$type, 1)], 'StartAngle:ct:gs', [1, 0], 'SweepDirection:gz:gt', [SweepDirection_$type, enumGetBox(SweepDirection_$type, 1)], 'ToolTip:c0:gu', [4, null], 'ToolTipStyle:g9:gv', [Style.$, null], 'ValueMemberPath:eg:gw', [2, null]]);
    return PieChartBase;
}(Control));
/**
 * @hidden
 */
var PieChartSliceSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartSliceSelector, _super);
    function PieChartSliceSelector(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    PieChartSliceSelector.prototype.d = function (a) {
        var b = a.dataContext;
        if (this.a.a3 == 1) {
            if (a.isOthersSlice) {
                var c = typeCast(IList_$type, b);
                if (c != null && c.contains(this.a.selectedItem)) {
                    return true;
                }
                if (typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                    return true;
                }
            }
            if (b == this.a.selectedItem) {
                return true;
            }
        }
        else if (this.a.a3 == 2) {
            if (this.c(a)) {
                return true;
            }
        }
        else if (this.a.a3 == 0) {
            if (this.a.selectedSlices.contains(a.a5)) {
                return true;
            }
        }
        return false;
    };
    PieChartSliceSelector.prototype.c = function (a) {
        var e_15, _a;
        var b = a.dataContext;
        if (a.isOthersSlice) {
            try {
                for (var _b = __values(fromEn(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.a.selectedItems.contains1(c)) {
                        return true;
                    }
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
        }
        else {
            if (this.a.selectedItems.contains1(b)) {
                return true;
            }
        }
        return false;
    };
    PieChartSliceSelector.prototype.h = function (a) {
        var b = a.dataContext;
        if (!a.isOthersSlice) {
            if (this.a.selectedItem != b) {
                return b;
            }
            else {
                return null;
            }
        }
        else {
            if (typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                return null;
            }
            else {
                return ((function () {
                    var $ret = new PieSliceOthersContext();
                    $ret.data = typeCast(IList_$type, a.dataContext);
                    $ret.slice = a;
                    return $ret;
                })());
            }
        }
    };
    PieChartSliceSelector.prototype.f = function (a, b) {
        var c = false;
        if (b) {
            if (this.a.selectedItems.contains1(a)) {
                c = this.g(a);
            }
        }
        else {
            if (!this.a.selectedItems.contains1(a)) {
                c = this.b(a);
            }
            else {
                c = this.g(a);
            }
        }
        return c;
    };
    PieChartSliceSelector.prototype.e = function (a) {
        return this.f(a, false);
    };
    PieChartSliceSelector.prototype.g = function (a) {
        var b = new SelectedItemsChangingEventArgs(this.a.selectedItems, ((function () {
            var $ret = new List$1(Base.$, 0);
            return $ret;
        })()));
        this.a.e3(this, b);
        if (!b.cancel) {
            this.a.selectedItems.remove1(a);
        }
        return b.cancel;
    };
    PieChartSliceSelector.prototype.b = function (a) {
        var b = new SelectedItemsChangingEventArgs(this.a.selectedItems, ((function () {
            var $ret = new List$1(Base.$, 0);
            $ret.add1(a);
            return $ret;
        })()));
        this.a.e3(this, b);
        if (!b.cancel) {
            this.a.selectedItems.add1(a);
        }
        return b.cancel;
    };
    PieChartSliceSelector.prototype.k = function (a) {
        this.a.selectedItem = this.h(a);
    };
    PieChartSliceSelector.prototype.i = function (a) {
        var e_16, _a, e_17, _b;
        var b = new List$1(Base.$, 1, this.a.selectedItems);
        if (a.isOthersSlice) {
            var c = typeCast(IList_$type, a.dataContext);
            var d = 0;
            try {
                for (var _c = __values(fromEn(c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var e = _d.value;
                    if (this.a.selectedItems.contains1(e)) {
                        d++;
                    }
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
            var f = d > 0 && d < c.count;
            try {
                for (var _e = __values(fromEn(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    this.f(g, f);
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
            if (this.c(a)) {
                this.a.selectedItem = ((function () {
                    var $ret = new PieSliceOthersContext();
                    $ret.data = typeCast(IList_$type, a.dataContext);
                    $ret.slice = a;
                    return $ret;
                })());
            }
            else {
                this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
            }
        }
        else {
            this.e(a.dataContext);
            this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
        }
    };
    PieChartSliceSelector.prototype.j = function (a) {
        if (a != null) {
            a.av = true;
            a.isSelected = this.d(a);
            a.av = false;
        }
    };
    PieChartSliceSelector.$t = markType(PieChartSliceSelector, 'PieChartSliceSelector');
    return PieChartSliceSelector;
}(Base));
/**
 * @hidden
 */
var PieSliceOthersContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieSliceOthersContext, _super);
    function PieSliceOthersContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._data = null;
        _this._slice = null;
        return _this;
    }
    Object.defineProperty(PieSliceOthersContext.prototype, "data", {
        get: function () {
            return this._data;
        },
        set: function (a) {
            this._data = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceOthersContext.prototype, "slice", {
        get: function () {
            return this._slice;
        },
        set: function (a) {
            this._slice = a;
        },
        enumerable: true,
        configurable: true
    });
    PieSliceOthersContext.$t = markType(PieSliceOthersContext, 'PieSliceOthersContext');
    return PieSliceOthersContext;
}(Base));
/**
 * @hidden
 */
var Slice = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Slice, _super);
    function Slice() {
        var _this = _super.call(this) || this;
        _this.al = null;
        _this.b8 = null;
        _this.ai = null;
        _this.aj = null;
        _this.bf = null;
        _this.b9 = null;
        _this.b3 = null;
        _this.aq = false;
        _this.au = false;
        _this.av = false;
        _this.an = false;
        _this.b0 = null;
        _this.b1 = null;
        var a = _this.ak();
        _this.bl(a);
        a.b();
        _this.av = false;
        return _this;
    }
    Slice.prototype.ak = function () {
        return new SliceView(this);
    };
    Slice.prototype.bl = function (a) {
        this.al = a;
    };
    Object.defineProperty(Slice.prototype, "isSelected", {
        get: function () {
            return this.c(Slice.bv);
        },
        set: function (a) {
            this.h(Slice.bv, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slice.prototype, "isExploded", {
        get: function () {
            return this.c(Slice.bt);
        },
        set: function (a) {
            this.h(Slice.bt, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slice.prototype, "isOthersSlice", {
        get: function () {
            return this.c(Slice.bu);
        },
        set: function (a) {
            this.h(Slice.bu, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Slice.prototype, "b2", {
        get: function () {
            return this.c(Slice.bp);
        },
        set: function (a) {
            this.h(Slice.bp, a);
        },
        enumerable: true,
        configurable: true
    });
    Slice.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.al.c();
    };
    Slice.prototype.az = function () {
        var a = Math.abs(PieChartBase.cs(this.ax - this.a3)) == 360;
        if (a) {
            return this.a2;
        }
        return this.a2;
    };
    Slice.prototype.cb = function () {
        var a = (this.ai != null && this.ai.bp) ? true : false;
        var b = this.az();
        if (this.isExploded && a && this.ai.cx > 1) {
            var c = new Rect(0, this.b5.x - b, this.b5.y - b, b * 2, b * 2);
            return c;
        }
        return new Rect(0, this.b7.x - b, this.b7.y - b, b * 2, b * 2);
    };
    Slice.prototype.b6 = function () {
        if (this.isExploded && this.ai != null && this.ai.bp && this.ai.cx > 1) {
            if (this.aq) {
                return this.b3;
            }
            return this.b5;
        }
        return this.b7;
    };
    Object.defineProperty(Slice.prototype, "aw", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b && !this.an) {
                this.bk();
            }
        },
        enumerable: true,
        configurable: true
    });
    Slice.prototype.bk = function () {
        var _this = this;
        if (this.aw) {
            return;
        }
        var a = this.al.f();
        var b = this.ai.g5;
        if (isNaN_(this.a3) || isNaN_(this.ax) || isNaN_(this.a2) || isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0) || this.a3 == this.ax) {
            return;
        }
        this.b8 = this.cb();
        var c = GeometryUtil.d(this.b8);
        var d = this.b8.height / 2;
        var e = this.az();
        var f = RectUtil.l(this.b8);
        var g = Slice.b4(MathUtil.k(this.a3), c, f, d, 100);
        var h = Slice.b4(MathUtil.k(this.ax), c, f, d, 100);
        var i = Slice.b4(MathUtil.k(this.ax), c, f, this.a2, this.a0);
        var j = Slice.b4(MathUtil.k(this.a3), c, f, this.a2, this.a1);
        var k = Math.abs(PieChartBase.cs(this.ax - this.a3)) == 360;
        if (k) {
            if (this.a0 == 0) {
                var l = ((function () {
                    var $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = _this.a2;
                    $ret.d = _this.a2;
                    return $ret;
                })());
                a.ak = l;
                return;
            }
            else if (this.a0 > 0) {
                var m_1 = new Size(1, this.a2, this.a2);
                var n_1 = new Size(1, this.a2 * this.a0 / 100, this.a2 * this.a0 / 100);
                var o_1 = ((function () {
                    var $ret = PointUtil.create();
                    $ret.x = f.x - _this.a2;
                    $ret.y = f.y;
                    return $ret;
                })());
                var p_1 = ((function () {
                    var $ret = PointUtil.create();
                    $ret.x = f.x + _this.a2;
                    $ret.y = f.y;
                    return $ret;
                })());
                var q_1 = ((function () {
                    var $ret = PointUtil.create();
                    $ret.x = f.x - _this.a2 * _this.a0 / 100;
                    $ret.y = f.y;
                    return $ret;
                })());
                var r_1 = ((function () {
                    var $ret = PointUtil.create();
                    $ret.x = f.x + _this.a2 * _this.a0 / 100;
                    $ret.y = f.y;
                    return $ret;
                })());
                var s_1 = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = o_1;
                    return $ret;
                })());
                var t = new PathSegmentCollection();
                var u = ((function () {
                    var $ret = new ArcSegment();
                    $ret.f = m_1;
                    $ret.d = 1;
                    $ret.e = p_1;
                    return $ret;
                })());
                t.add(u);
                s_1._segments = t;
                var v_1 = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = r_1;
                    return $ret;
                })());
                var w = new PathSegmentCollection();
                var x = ((function () {
                    var $ret = new ArcSegment();
                    $ret.f = n_1;
                    $ret.d = 0;
                    $ret.e = q_1;
                    return $ret;
                })());
                w.add(x);
                v_1._segments = w;
                var y_1 = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = o_1;
                    return $ret;
                })());
                var z = new PathSegmentCollection();
                var aa = ((function () {
                    var $ret = new ArcSegment();
                    $ret.f = m_1;
                    $ret.d = 0;
                    $ret.e = p_1;
                    return $ret;
                })());
                z.add(aa);
                y_1._segments = z;
                var ab_1 = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = r_1;
                    return $ret;
                })());
                var ac = new PathSegmentCollection();
                var ad = ((function () {
                    var $ret = new ArcSegment();
                    $ret.f = n_1;
                    $ret.d = 1;
                    $ret.e = q_1;
                    return $ret;
                })());
                ac.add(ad);
                ab_1._segments = ac;
                var ae_1 = ((function () {
                    var $ret = new PathFigureCollection();
                    $ret.add(s_1);
                    $ret.add(v_1);
                    $ret.add(y_1);
                    $ret.add(ab_1);
                    return $ret;
                })());
                var af = ((function () {
                    var $ret = new PathGeometry();
                    $ret.c = ae_1;
                    return $ret;
                })());
                var ag = new GeometryGroup();
                ag.d.add(af);
                a.ak = ag;
                return;
            }
            else {
                var ah = ((function () {
                    var $ret = new GeometryGroup();
                    $ret.c = 0;
                    return $ret;
                })());
                ah.d.add(((function () {
                    var $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = _this.a2;
                    $ret.d = _this.a2;
                    return $ret;
                })()));
                ah.d.add(((function () {
                    var $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = _this.a2 * _this.a0 / 100;
                    $ret.d = _this.a2 * _this.a0 / 100;
                    return $ret;
                })()));
                a.ak = ah;
                return;
            }
        }
        var ai = new PathGeometry();
        a.ak = ai;
        var aj = ((function () {
            var $ret = new PathFigure();
            $ret.isClosed = true;
            return $ret;
        })());
        ai.c = new PathFigureCollection();
        ai.c.add(aj);
        aj._startPoint = g;
        var ak = Math.abs(this.ax - this.a3) > 180;
        var al = new ArcSegment();
        al.e = h;
        al.f = new Size(1, this.b8.width / 2, this.b8.height / 2);
        al.b = ak;
        if (this.ax > this.a3) {
            al.d = 1;
        }
        else {
            al.d = 0;
        }
        aj._segments = new PathSegmentCollection();
        aj._segments.add(al);
        var am = new LineSegment(1);
        am.c = i;
        aj._segments.add(am);
        var an = Math.sqrt(Math.pow(i.x - h.x, 2) + Math.pow(i.y - h.y, 2));
        var ao = e - an;
        var ap = new ArcSegment();
        ap.e = j;
        if (ao < 0) {
            ao = 0.1;
        }
        ap.f = new Size(1, ao, ao);
        ap.b = al.b;
        ap.d = 0;
        aj._segments.add(ap);
        var aq = this.ca(a, g, h, this.a3, this.ax, f, e);
        var ar = true;
        if (ar && this.b8.height > 0 && this.b8.width > 0 && !b.containsRect(aq)) {
            var as = aq;
            var at = new Rect(0, 0, 0, b.width, b.height);
            at.intersect(as);
            var au = GeometryUtil.g((this.a3 + this.ax) / 2);
            var av = au / 180 * Math.PI;
            var aw = Math.abs((as.height - at.height) / Math.sin(av));
            var ax = Math.abs((as.width - at.width) / Math.cos(av));
            if (isNaN_(aw) || isInfinity(aw)) {
                aw = 0;
            }
            if (isNaN_(ax) || isInfinity(ax)) {
                ax = 0;
            }
            var ay = Math.max(aw, ax);
            var az = GeometryUtil.j(this.ai.g5.width, this.ai.g5.height, true, au, this.a2 * this.ai.cb - ay);
            this.al.d(az.x - this.b5.x, az.y - this.b5.y);
            this.aq = true;
            this.b3 = az;
            this.b9 = new Rect(0, as.x - (az.x - this.b5.x), as.y - (az.y - this.b5.y), as.width, as.height);
        }
        else {
            this.aq = false;
            this.al.e();
        }
    };
    Slice.prototype.ap = function (a) {
        var b = this.ai.g5;
        if (this._visibility == 1) {
            return false;
        }
        if (isNaN_(this.a3) || isNaN_(this.ax) || isNaN_(this.a2) || isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0)) {
            return false;
        }
        var c = this.az();
        var d = ((this.a0 / 100) * c);
        var e = c;
        var f = this.b7;
        if (this.isExploded && this.ai.bp && this.ai.cx > 1) {
            f = this.b5;
            if (this.aq) {
                f = this.b3;
            }
        }
        var g = d * d;
        var h = e * e;
        var i = Math.pow(a.x - f.x, 2) + Math.pow(a.y - f.y, 2);
        if (i < g || i > h) {
            return false;
        }
        var j = Math.atan2(a.y - f.y, a.x - f.x);
        j = j * 180 / Math.PI;
        return this.ao(j);
    };
    Slice.prototype.ao = function (a) {
        a = GeometryUtil.g(a);
        var b = Math.min(this.a3, this.ax);
        var c = Math.max(this.a3, this.ax);
        return (a > b && a < c) || (a - 360 > b && a - 360 < c) || (a + 360 > b && a + 360 < c);
    };
    Slice.prototype.ca = function (a, b, c, d, e, f, g) {
        var e_18, _a;
        var h = new List$1(Point_$type, 0);
        h.add(b);
        h.add(c);
        h.add(f);
        d = GeometryUtil.g(d);
        e = GeometryUtil.g(e);
        if ((0 > d && 0 < e) || (360 > d && 360 < e) || (e < d)) {
            h.add(GeometryUtil.k(f, 0, g));
        }
        if (90 > d && 90 < e) {
            h.add(GeometryUtil.k(f, 90, g));
        }
        if (180 > d && 180 < e) {
            h.add(GeometryUtil.k(f, 180, g));
        }
        if (270 > d && 270 < e) {
            h.add(GeometryUtil.k(f, 270, g));
        }
        var i = 1.7976931348623157E+308;
        var j = 1.7976931348623157E+308;
        var k = -1.7976931348623157E+308;
        var l = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(h)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var m = _c.value;
                i = Math.min(i, m.x);
                j = Math.min(j, m.y);
                k = Math.max(k, m.x);
                l = Math.max(l, m.y);
            }
        }
        catch (e_18_1) {
            e_18 = { error: e_18_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_18)
                    throw e_18.error;
            }
        }
        return new Rect(0, i, j, k - i, l - j);
    };
    Slice.prototype.am = function () {
        var a = new PieSliceVisualData();
        a.appearance = new PrimitiveAppearanceData();
        a.labelAppearance = new LabelAppearanceData();
        a.leaderLineAppearance = new PrimitiveAppearanceData();
        a.startAngle = this.a3;
        a.endAngle = this.ax;
        a.explodedOrigin = PointData.b(this.b5);
        a.explodedRadius = this.ay;
        a.origin = PointData.b(this.b7);
        a.radius = this.az();
        a.index = this.a5;
        a.innerExtentEnd = this.a0;
        a.innerExtentStart = this.a1;
        a.isExploded = this.isExploded;
        a.isOthersSlice = this.isOthersSlice;
        a.isSelected = this.isSelected;
        if (this.aj != null) {
            a.labelAppearance.angle = this.aj.ai;
            a.labelBounds = RectData.b(this.aj.ao);
            a.labelAngle = this.aj.ai;
            if (typeCast(TextBlock.$, this.aj.aj) !== null) {
                var b = typeCast(TextBlock.$, this.aj.aj);
                a.label = b.ak;
                var c = null;
                a.labelAppearance.labelBrush = AppearanceHelper.b(b.am);
                a.labelAppearance.text = b.ak;
                if (this.ai != null) {
                    c = this.ai.a6();
                    if (c == null) {
                        c = this.ai.as.b.c;
                    }
                }
                a.labelAppearance = AppearanceHelper.c(b, c);
                a.labelAppearance.visibility = this.aj._visibility == 0;
            }
            else {
                a.label = this.aj.aj.toString();
            }
            if (this.aj.ap != null) {
                a.leaderLineAppearance.fill = AppearanceHelper.b(this.aj.ap._fill);
                a.leaderLineAppearance.opacity = this.aj.ap._opacity;
                a.leaderLineAppearance.stroke = AppearanceHelper.b(this.aj.ap._stroke);
                a.leaderLineAppearance.strokeThickness = this.aj.ap.ac;
                a.leaderLineAppearance.isVisible = this.aj.ap._visibility == 0;
                a.leaderLinePath = new PathVisualData(2, "leaderLine", this.aj.ap);
            }
            else if (this.aj.aq != null) {
                a.leaderLineAppearance.fill = AppearanceHelper.b(this.aj.aq._fill);
                a.leaderLineAppearance.opacity = this.aj.aq._opacity;
                a.leaderLineAppearance.stroke = AppearanceHelper.b(this.aj.aq._stroke);
                a.leaderLineAppearance.strokeThickness = this.aj.aq.ac;
                a.leaderLineAppearance.isVisible = this.aj.aq._visibility == 0;
                a.leaderLinePath = new PathVisualData(1, "leaderLine", this.aj.aq);
            }
        }
        if (this.al != null) {
            var d = this.al.f();
            a.slicePath = new PathVisualData(1, "slicePath", d);
            a.appearance.fill = AppearanceHelper.b(d._fill);
            a.appearance.opacity = d._opacity;
            a.appearance.stroke = AppearanceHelper.b(d._stroke);
            a.appearance.strokeThickness = d.ac;
            a.appearance.isVisible = d._visibility == 0;
        }
        return a;
    };
    Slice.b4 = function (a, b, c, d, e) {
        if (d == 0) {
            return c;
        }
        var f = Math.cos(a);
        var g = Math.sin(a);
        var h = Math.sqrt(d * d / (1 - (b * Math.pow(f, 2))));
        h *= (e / 100);
        return { $type: Point_$type, x: h * f + c.x, y: h * g + c.y };
    };
    Slice.$t = markType(Slice, 'Slice', ContentControl.$);
    Slice.bv = DependencyProperty.i("IsSelected", Boolean_$type, Slice.$, new PropertyMetadata(2, false, function (a, b) {
        var c = typeCast(Slice.$, a);
        if (!c.av) {
            var d = b.newValue;
            if (c.ai != null) {
                c.ai.fk(c, d);
            }
        }
    }));
    Slice.bt = DependencyProperty.i("IsExploded", Boolean_$type, Slice.$, new PropertyMetadata(2, false, function (a, b) {
        var c = typeCast(Slice.$, a);
        var d = b.newValue;
        if (c.ai != null) {
            c.ai.ek(c, d);
        }
    }));
    Slice.bu = DependencyProperty.i("IsOtherSlice", Boolean_$type, Slice.$, new PropertyMetadata(2, false, function (a, b) { return a.bk(); }));
    Slice.bp = DependencyProperty.i("Foreground", Brush.$, Slice.$, new PropertyMetadata(1, null));
    Slice.$$p = markDep(DependencyProperty, PropertyMetadata, Slice, 'bk', ['EndAngle:ax:bm', [1, 0], 'ExplodedOrigin:b5:bn', [Point_$type, PointUtil.create()], 'ExplodedRadius:ay:bo', [1, 0], 'Index:a5:bq', [1, -1], 'InnerExtentEnd:a0:br', [1, 0], 'InnerExtentStart:a1:bs', [1, 0], 'Origin:b7:bw', [Point_$type, PointUtil.create()], 'Radius:a2:bx', [1, 0], 'StartAngle:a3:by', [1, 0], 'StrokeThickness:a4:bz', [1, 1]]);
    return Slice;
}(ContentControl));
/**
 * @hidden
 */
var PieChartBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieChartBaseView, _super);
    function PieChartBaseView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.bs = null;
        _this.b = null;
        _this.h = null;
        _this.j = null;
        _this.i = null;
        _this.k = null;
        _this.c = null;
        _this.b2 = null;
        _this.l = false;
        _this.bz = Rect.empty;
        _this.f = null;
        _this.u = null;
        _this.t = null;
        _this.v = 0;
        _this.by = null;
        _this.ag = null;
        _this.s = false;
        _this.e = null;
        _this.a = a;
        _this.c = new PieChartViewManager(_this);
        return _this;
    }
    PieChartBaseView.prototype.a1 = function () {
        this.e = new PieSliceDataContext();
        this.e.series = this.a;
        this.b2 = Rect.empty;
        this.u = new List$1(Slice.$, 0);
        this.t = new List$1(PieLabel.$, 0);
        this.a.legendItemTemplate = ((function () {
            var $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.f;
            $ret.measure = PieLegendTemplates.a;
            return $ret;
        })());
        this.a.legendItemBadgeTemplate = ((function () {
            var $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.e;
            $ret.measure = PieLegendTemplates.d;
            return $ret;
        })());
        this.c.z();
    };
    PieChartBaseView.prototype.bb = function () {
        var a = this.c.b();
        if (this.a.ag == null) {
            this.a.ag = a.a;
        }
        if (this.a.ah == null) {
            this.a.ah = a.b;
        }
        if (this.a.g8 == null) {
            this.a.g8 = ((function () {
                var $ret = new Style();
                $ret.fill = a.h != null ? a.h.color.colorString : null;
                $ret.stroke = a.i != null ? a.i.color.colorString : null;
                $ret.strokeThickness = a.e;
                $ret.opacity = a.d;
                return $ret;
            })());
        }
        this.b = a;
        if (this.a.eb != null) {
            this.b.c = this.a.a6();
        }
    };
    PieChartBaseView.prototype.ax = function () {
        this.c.ab();
    };
    PieChartBaseView.prototype.a0 = function () {
        this.c.ae();
    };
    PieChartBaseView.prototype.ay = function (a) {
        if (a == null) {
            this.l = false;
            this.c.ac(null);
            this.h = null;
            this.j = null;
            this.i = null;
            this.k = null;
            return;
        }
        this.c.ac(a);
        this.h = this.c.e;
        this.j = this.c.g;
        this.i = this.c.f;
        this.k = this.c.h;
    };
    PieChartBaseView.prototype.b0 = function () {
        return this.b2;
    };
    PieChartBaseView.prototype.bx = function () {
        return this.c.an();
    };
    PieChartBaseView.prototype.ba = function () {
        this.b2 = this.c.ao();
        this.a.e4();
    };
    PieChartBaseView.prototype.av = function () {
        if (!this.l) {
            this.l = true;
            this.c.ah(runOn(this, this.bi));
        }
    };
    PieChartBaseView.prototype.bi = function () {
        if (this.l) {
            this.l = false;
            this.a5();
        }
    };
    PieChartBaseView.prototype.a5 = function () {
        this.am();
        this.c.w(this.b2.width, this.b2.height);
        if (this.k != null && this.k.d) {
            if (this.a.cd != 1) {
                this.k.z();
                this.k.aa(this.a.cd, this.a.cd);
            }
            if (!this.bz.isEmpty) {
                this.k.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.i != null && this.i.d) {
            if (this.a.cd != 1) {
                this.i.z();
                this.i.aa(this.a.cd, this.a.cd);
            }
            if (!this.bz.isEmpty) {
                this.i.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.j != null && this.j.d) {
            if (this.a.cd != 1) {
                this.j.z();
                this.j.aa(this.a.cd, this.a.cd);
            }
            if (!this.bz.isEmpty) {
                this.j.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.h != null && this.h.d) {
            if (this.a.cd != 1) {
                this.h.z();
                this.h.aa(this.a.cd, this.a.cd);
            }
            if (!this.bz.isEmpty) {
                this.h.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        this.a6();
        if (!this.bz.isEmpty && this.a.cd != 1) {
            if (this.k != null && this.k.d) {
                this.k.y();
            }
            if (this.i != null && this.i.d) {
                this.i.y();
            }
            if (this.j != null && this.j.d) {
                this.j.y();
            }
            if (this.h != null && this.h.d) {
                this.h.y();
            }
        }
    };
    PieChartBaseView.prototype.a6 = function () {
        var e_19, _a;
        this.bz = this.b2;
        if (this.j != null && this.j.d) {
            this.a9();
            this.a7();
        }
        if (this.i != null && this.i.d) {
            var a = this.b.c;
            if (this.a.eb != null) {
                a = this.a.a6();
            }
            this.i.ac(a);
            try {
                for (var _b = __values(fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (b._visibility == 0) {
                        var c = b.aj;
                        if (c != null) {
                            {
                                if (b.ah.b2 == null) {
                                    if (b.ah.au) {
                                        c.am = this.b.f;
                                    }
                                    else {
                                        c.am = this.b.g;
                                    }
                                }
                                else {
                                    c.am = b.ah.b2;
                                }
                                this.i.w(c);
                            }
                        }
                        var d = b.ah.b0;
                        if (b.ah.y != null) {
                            var e = new Path();
                            this.j.i(e, b.ah.y);
                            if (e._fill != null) {
                                d = e._fill;
                            }
                        }
                        if (this.a.ap != 0 && b.aq != null) {
                            b.aq._stroke = d;
                            b.aq.ac = 1;
                            if (this.a.g6 != null) {
                                this.i.i(b.aq, this.a.g6);
                            }
                            this.i.s(b.aq);
                        }
                        if (this.a.ap == 0 && b.ap != null) {
                            b.ap._stroke = d;
                            b.ap.ac = 1;
                            if (this.a.g6 != null) {
                                this.i.i(b.ap, this.a.g6);
                            }
                            this.i.r(b.ap);
                        }
                    }
                }
            }
            catch (e_19_1) {
                e_19 = { error: e_19_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_19)
                        throw e_19.error;
                }
            }
        }
    };
    PieChartBaseView.prototype.a8 = function (a) {
        if (a._visibility != 0) {
            return;
        }
        var b = a.al.f();
        this.c.ai(b);
        b.ac = 1;
        b._opacity = a._opacity;
        if (a.b0 != null) {
            b._fill = a.b0;
        }
        if (a.b1 != null) {
            b._stroke = a.b1;
        }
        if (a.y != null) {
            this.j.i(b, a.y);
        }
        if (b.j != null) {
            this.j.z();
            this.j.j(b.j);
        }
        var c = b._fill;
        var d = b._stroke;
        var e = this.m(a, b, this.j);
        this.j.s(b);
        if (e) {
            b._fill = c;
            b._stroke = d;
        }
        if (b.j != null) {
            this.j.y();
        }
    };
    PieChartBaseView.prototype.a9 = function () {
        var e_20, _a;
        try {
            for (var _b = __values(fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (!a.isSelected) {
                    this.a8(a);
                }
            }
        }
        catch (e_20_1) {
            e_20 = { error: e_20_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_20)
                    throw e_20.error;
            }
        }
    };
    PieChartBaseView.prototype.a7 = function () {
        var e_21, _a;
        try {
            for (var _b = __values(fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (a.isSelected) {
                    this.a8(a);
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
    };
    PieChartBaseView.prototype.m = function (a, b, c) {
        return false;
    };
    PieChartBaseView.prototype.aj = function (a, b, c) {
        var d = this.f;
        this.bj(a);
        if (this.f == null && d != null) {
            var e = ((function () {
                var $ret = new MouseEventArgs();
                $ret.position = a;
                return $ret;
            })());
            this.a.en(this.f, e);
        }
        else if (this.f != null) {
            var f = ((function () {
                var $ret = new MouseEventArgs();
                $ret.position = a;
                return $ret;
            })());
            this.a.eo(this.f, f);
        }
    };
    PieChartBaseView.prototype.ai = function (a) {
        var b = this.f;
        this.bj(a);
        var c = ((function () {
            var $ret = new MouseEventArgs();
            $ret.position = a;
            return $ret;
        })());
        this.a.en(b, c);
    };
    PieChartBaseView.prototype.ah = function (a) {
        this.bj(a);
    };
    PieChartBaseView.prototype.ak = function (a) {
        this.ap(a);
    };
    PieChartBaseView.prototype.ap = function (a) {
        var e_22, _a;
        var b = ((function () {
            var $ret = new MouseButtonEventArgs();
            $ret.position = a;
            return $ret;
        })());
        var c = true;
        var d = null;
        try {
            for (var _b = __values(fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                var f = e.ao.containsPoint(a);
                if (f) {
                    d = e;
                    c = this.a.bw(e.ah, b);
                    break;
                }
            }
        }
        catch (e_22_1) {
            e_22 = { error: e_22_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_22)
                    throw e_22.error;
            }
        }
        this.bj(a);
        if (this.f == null && c && d != null) {
            this.a.fo(d.ah, b);
        }
        else if (this.f != null && c) {
            this.a.fo(this.f, b);
        }
    };
    PieChartBaseView.prototype.bj = function (a) {
        this.f = null;
        for (var b = 0; b < this.u.count; b++) {
            if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                this.f = this.u._inner[b];
                break;
            }
        }
    };
    PieChartBaseView.prototype.n = function (a) {
        var e_23, _a;
        try {
            for (var _b = __values(fromEnum(this.t)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = b.ao.containsPoint(a);
                if (c) {
                    return true;
                }
            }
        }
        catch (e_23_1) {
            e_23 = { error: e_23_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_23)
                    throw e_23.error;
            }
        }
        return false;
    };
    PieChartBaseView.prototype.p = function (a) {
        for (var b = 0; b < this.u.count; b++) {
            if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                return true;
            }
        }
        return false;
    };
    PieChartBaseView.prototype.o = function (a) {
        return this.n(a) || this.p(a);
    };
    PieChartBaseView.prototype.bd = function () {
        this.a.e4();
    };
    PieChartBaseView.prototype.al = function () {
        this.aq();
    };
    PieChartBaseView.prototype.bn = function (a, b) {
        var c = b;
        this.bo(c.position, a, b);
    };
    PieChartBaseView.prototype.g = function () {
        var a = new Slice();
        a.ai = this.a;
        this.u.add(a);
        return a;
    };
    PieChartBaseView.prototype.be = function (a) {
        a._visibility = 0;
    };
    PieChartBaseView.prototype.bg = function (a) {
        a._visibility = 1;
    };
    PieChartBaseView.prototype.bf = function (a) {
        a.ai = null;
        this.u.remove(a);
    };
    PieChartBaseView.prototype.d = function () {
        var a = new PieLabel();
        if (this.a.ap == 0) {
            a.ap = new Line();
        }
        else {
            a.aq = new Path();
            var b = new PathGeometry();
            b.c.add(new PathFigure());
            b.c._inner[0]._segments.add(new BezierSegment(0));
            a.aq.ak = b;
        }
        this.t.add(a);
        return a;
    };
    PieChartBaseView.prototype.ar = function (a) {
        a._visibility = 0;
    };
    PieChartBaseView.prototype.at = function (a) {
        a._visibility = 1;
    };
    PieChartBaseView.prototype.as = function (a) {
        this.t.remove(a);
    };
    PieChartBaseView.prototype.bl = function (a) {
        if ((this.a.ap != 0 && a.aq != null) || (this.a.ap == 0 && a.ap != null)) {
            return;
        }
        if (this.a.ap == 0) {
            a.aq = null;
            a.ap = new Line();
        }
        else {
            a.ap = null;
            a.aq = new Path();
            var b = new PathGeometry();
            var c = new PathFigure();
            c._startPoint = { $type: Point_$type, x: NaN, y: NaN };
            b.c.add(c);
            b.c._inner[0]._segments.add(new BezierSegment(0));
            a.aq.ak = b;
        }
    };
    PieChartBaseView.prototype.bc = function (a) {
        if (this.a.g7 != null && a.isOthersSlice) {
            a.b0 = this.bv(a.a5);
            a.b1 = this.bw(a.a5);
            a.y = this.a.g7;
        }
        else if (a.isSelected && this.a.bq && this.a.g8 != null) {
            a.y = this.a.g8;
        }
        else {
            a.y = null;
            a.b0 = this.bv(a.a5);
            a.b1 = this.bw(a.a5);
        }
    };
    PieChartBaseView.prototype.bv = function (a) {
        if (this.a.ag != null && a >= 0 && this.a.ag.count > 0) {
            return this.a.ag.item(a % this.a.ag.count);
        }
        return null;
    };
    PieChartBaseView.prototype.bw = function (a) {
        if (this.a.ah != null && a >= 0 && this.a.ah.count > 0) {
            return this.a.ah.item(a % this.a.ah.count);
        }
        return null;
    };
    PieChartBaseView.prototype.ad = function (a) {
        if (a == null || a.aj == null) {
            return this.a.di;
        }
        var b = a.aj;
        var c = b.aj;
        if (typeCast(TextBlock.$, c) !== null) {
            return c.ak;
        }
        return c;
    };
    PieChartBaseView.prototype.y = function (a) {
        var b = typeCast(TextBlock.$, a);
        if (b != null && b.ak != null && this.i != null) {
            return this.i.e(b) + 0;
        }
        return 0;
    };
    PieChartBaseView.prototype.bk = function () {
        this.v = FontUtil.getCurrentFontHeight(this.c.n, this.c.d());
    };
    PieChartBaseView.prototype.x = function (a) {
        return this.v + 0;
    };
    PieChartBaseView.prototype.b1 = function (a) {
        var b = a.aj;
        if (typeCast(TextBlock.$, b) !== null) {
            var c = this.y(b);
            var d = this.x(b);
            return new Rect(0, 0, 0, c, d);
        }
        return Rect.empty;
    };
    PieChartBaseView.prototype.b3 = function () {
        return new Size(1, this.b2.width, this.b2.height);
    };
    PieChartBaseView.prototype.bm = function (a, b, c) {
        var d = typeCast(TextBlock.$, a.aj);
        if (d != null) {
            d.n = b;
            d.o = c;
        }
        this.av();
    };
    PieChartBaseView.prototype.bp = function (a) {
        this.bq(a);
    };
    PieChartBaseView.prototype.br = function () {
        this.av();
    };
    PieChartBaseView.prototype.au = function () {
        this.am();
    };
    PieChartBaseView.prototype.am = function () {
        var a = this.b.c;
        if (this.a.eb != null) {
            a = this.a.a6();
        }
        if (this.i != null) {
            this.i.ac(a);
        }
    };
    PieChartBaseView.prototype.az = function (a, b) {
        this.c.ad(a, b);
    };
    PieChartBaseView.prototype.aw = function () {
        this.c.aa();
    };
    Object.defineProperty(PieChartBaseView.prototype, "af", {
        get: function () {
            return this.c != null && this.c.n != null ? this.c.n.getResourceString("invalidLabelBinding") : "There is no such value for the labels to bind.";
        },
        enumerable: true,
        configurable: true
    });
    PieChartBaseView.prototype.aq = function () {
        if (this.s == true) {
            this.s = false;
            this.c.y(this.e);
        }
    };
    PieChartBaseView.prototype.bq = function (a) {
        this.c.ak(a);
    };
    PieChartBaseView.prototype.bo = function (a, b, c) {
        this.s = true;
        this.by = a;
        if (b == null) {
            this.ag = null;
            this.e.item = null;
        }
        else {
            this.ag = b.dataContext;
            this.e.item = b.dataContext;
            this.e.slice = b;
        }
        var d = this.a.g2();
        var pos_ = { $type: Point_$type, x: a.x + 15 + d.x, y: a.y + 15 + d.y };
        var context_ = this.e;
        this.c.aj(pos_, context_);
    };
    PieChartBaseView.prototype.bh = function () {
        this.bb();
        this.bk();
        this.a.fe();
    };
    PieChartBaseView.prototype.a2 = function () {
        this.c.af(this.a.bv);
    };
    PieChartBaseView.prototype.ac = function () {
        return this.c.t();
    };
    PieChartBaseView.prototype.ao = function () {
        if (this.l) {
            this.bi();
        }
    };
    PieChartBaseView.prototype.r = function () {
        return this.ac() != null;
    };
    PieChartBaseView.prototype.an = function (a) {
        this.c.x(a);
    };
    PieChartBaseView.prototype.q = function () {
        return true;
    };
    PieChartBaseView.prototype.a4 = function () {
    };
    PieChartBaseView.prototype.bt = function (a) {
        var b = this.c.al(a.y);
        if (b != null) {
            return b;
        }
        return a.b0;
    };
    PieChartBaseView.prototype.bu = function (a) {
        var b = this.c.am(a.y);
        if (b != null) {
            return b;
        }
        return a.b1;
    };
    PieChartBaseView.prototype.w = function (a) {
        return this.c.m(a.y);
    };
    PieChartBaseView.prototype.z = function (a) {
        return this.c.m(a);
    };
    PieChartBaseView.prototype.aa = function () {
        var e_24, _a;
        try {
            for (var _b = __values(fromEnum(this.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (!a.isSelected) {
                    return a.a4;
                }
            }
        }
        catch (e_24_1) {
            e_24 = { error: e_24_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_24)
                    throw e_24.error;
            }
        }
        return NaN;
    };
    PieChartBaseView.prototype.a3 = function () {
        this.c.ag();
        this.av();
    };
    PieChartBaseView.prototype.ae = function (a) {
        return this.c.c.ao;
    };
    PieChartBaseView.$t = markType(PieChartBaseView, 'PieChartBaseView');
    return PieChartBaseView;
}(Base));
/**
 * @hidden
 */
var PieSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PieSliceDataContext, _super);
    function PieSliceDataContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._slice = null;
        _this._percentValue = 0;
        _this._isOthersSlice = false;
        return _this;
    }
    Object.defineProperty(PieSliceDataContext.prototype, "slice", {
        get: function () {
            return this._slice;
        },
        set: function (a) {
            this._slice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceDataContext.prototype, "percentValue", {
        get: function () {
            return this._percentValue;
        },
        set: function (a) {
            this._percentValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PieSliceDataContext.prototype, "isOthersSlice", {
        get: function () {
            return this._isOthersSlice;
        },
        set: function (a) {
            this._isOthersSlice = a;
        },
        enumerable: true,
        configurable: true
    });
    PieSliceDataContext.prototype.flatten = function () {
        var e_25, _a;
        var ret_ = _super.prototype.flatten.call(this);
        var percentValue_ = this.percentValue;
        var isOthersSlice_ = this.isOthersSlice;
        ret_.percentValue = percentValue_;
        ret_.isOthersSlice = isOthersSlice_;
        if (isOthersSlice_ && this.item != null) {
            var items_ = [];
            try {
                for (var _b = __values(fromEn(this.item)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var currItem_ = _c.value;
                    items_.push(currItem_);
                }
            }
            catch (e_25_1) {
                e_25 = { error: e_25_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_25)
                        throw e_25.error;
                }
            }
            ret_.item = items_;
        }
        return ret_;
    };
    PieSliceDataContext.$t = markType(PieSliceDataContext, 'PieSliceDataContext', DataContext.$);
    return PieSliceDataContext;
}(DataContext));
/**
 * @hidden
 */
var SliceView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceView, _super);
    function SliceView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.g = null;
        _this.a = a;
        return _this;
    }
    SliceView.prototype.b = function () {
        this.g = new Path();
        this.a.content = this.g;
    };
    SliceView.prototype.c = function () {
        this.a.bk();
    };
    SliceView.prototype.f = function () {
        return this.g;
    };
    SliceView.prototype.d = function (a, b) {
        this.g.j = ((function () {
            var $ret = new TranslateTransform();
            $ret.j = a;
            $ret.k = b;
            return $ret;
        })());
    };
    SliceView.prototype.e = function () {
        this.g.j = null;
    };
    SliceView.$t = markType(SliceView, 'SliceView');
    return SliceView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HoleDimensionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HoleDimensionsChangedEventArgs, _super);
    function HoleDimensionsChangedEventArgs(a, b) {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.b = 0;
        _this.d = a;
        _this.b = b;
        return _this;
    }
    Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "center", {
        get: function () {
            return this.d;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HoleDimensionsChangedEventArgs.prototype, "radius", {
        get: function () {
            return this.b;
        },
        enumerable: true,
        configurable: true
    });
    HoleDimensionsChangedEventArgs.$t = markType(HoleDimensionsChangedEventArgs, 'HoleDimensionsChangedEventArgs', EventArgs.$);
    return HoleDimensionsChangedEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DoughnutChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DoughnutChartVisualData, _super);
    function DoughnutChartVisualData() {
        var _this = _super.call(this) || this;
        _this._series = null;
        _this._height = 0;
        _this._width = 0;
        _this._holeRadius = 0;
        _this._dipScalingRatio = 0;
        _this._viewport = null;
        _this.dipScalingRatio = 1;
        return _this;
    }
    Object.defineProperty(DoughnutChartVisualData.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartVisualData.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartVisualData.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartVisualData.prototype, "holeRadius", {
        get: function () {
            return this._holeRadius;
        },
        set: function (a) {
            this._holeRadius = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartVisualData.prototype, "dipScalingRatio", {
        get: function () {
            return this._dipScalingRatio;
        },
        set: function (a) {
            this._dipScalingRatio = a;
        },
        enumerable: true,
        configurable: true
    });
    DoughnutChartVisualData.prototype.scaleByViewport = function () {
        var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
        if (this.series != null) {
            try {
                for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var a = _f.value;
                    try {
                        for (var _g = (e_2 = void 0, __values(fromEnum(a.rings))), _h = _g.next(); !_h.done; _h = _g.next()) {
                            var b = _h.value;
                            try {
                                for (var _j = (e_3 = void 0, __values(fromEnum(b.arcs))), _k = _j.next(); !_k.done; _k = _j.next()) {
                                    var c = _k.value;
                                    try {
                                        for (var _l = (e_4 = void 0, __values(fromEnum(c.a))), _m = _l.next(); !_m.done; _m = _l.next()) {
                                            var d = _m.value;
                                            d.scaleByViewport(this.viewport);
                                        }
                                    }
                                    catch (e_4_1) {
                                        e_4 = { error: e_4_1 };
                                    }
                                    finally {
                                        try {
                                            if (_m && !_m.done && (_d = _l.return))
                                                _d.call(_l);
                                        }
                                        finally {
                                            if (e_4)
                                                throw e_4.error;
                                        }
                                    }
                                }
                            }
                            catch (e_3_1) {
                                e_3 = { error: e_3_1 };
                            }
                            finally {
                                try {
                                    if (_k && !_k.done && (_c = _j.return))
                                        _c.call(_j);
                                }
                                finally {
                                    if (e_3)
                                        throw e_3.error;
                                }
                            }
                        }
                    }
                    catch (e_2_1) {
                        e_2 = { error: e_2_1 };
                    }
                    finally {
                        try {
                            if (_h && !_h.done && (_b = _g.return))
                                _b.call(_g);
                        }
                        finally {
                            if (e_2)
                                throw e_2.error;
                        }
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_a = _e.return))
                        _a.call(_e);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    DoughnutChartVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (!isNaN_(this.width)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("width: ");
            a.u(this.width.toString());
        }
        if (!isNaN_(this.height)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("height: ");
            a.u(this.height.toString());
        }
        if (!isNaN_(this.holeRadius)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("holeRadius: ");
            a.u(this.holeRadius.toString());
        }
        if (this.viewport != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("viewport: {");
            a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
            a.u("}");
        }
        if (this.series != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("series: [");
            for (var c = 0; c < this.series.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.series._inner[c].serialize());
            }
            a.u("]");
        }
        if (!b) {
            a.l(", ");
        }
        a.l("dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    };
    Object.defineProperty(DoughnutChartVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    DoughnutChartVisualData.$t = markType(DoughnutChartVisualData, 'DoughnutChartVisualData');
    return DoughnutChartVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RingSeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeriesVisualData, _super);
    function RingSeriesVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._name = null;
        _this._labelExtent = 0;
        _this._labelsPosition = null;
        _this._leaderLineType = null;
        _this._leaderLineVisibility = false;
        _this._leaderLineMargin = 0;
        _this._rings = null;
        return _this;
    }
    Object.defineProperty(RingSeriesVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "labelExtent", {
        get: function () {
            return this._labelExtent;
        },
        set: function (a) {
            this._labelExtent = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "labelsPosition", {
        get: function () {
            return this._labelsPosition;
        },
        set: function (a) {
            this._labelsPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineType", {
        get: function () {
            return this._leaderLineType;
        },
        set: function (a) {
            this._leaderLineType = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineVisibility", {
        get: function () {
            return this._leaderLineVisibility;
        },
        set: function (a) {
            this._leaderLineVisibility = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "leaderLineMargin", {
        get: function () {
            return this._leaderLineMargin;
        },
        set: function (a) {
            this._leaderLineMargin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesVisualData.prototype, "rings", {
        get: function () {
            return this._rings;
        },
        set: function (a) {
            this._rings = a;
        },
        enumerable: true,
        configurable: true
    });
    RingSeriesVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.name != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("name: ");
            a.u("'" + this.name + "'");
        }
        if (!isNaN_(this.labelExtent)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelExtent: ");
            a.u(this.labelExtent.toString());
        }
        if (this.labelsPosition != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelsPosition: ");
            a.u("'" + this.labelsPosition + "'");
        }
        if (this.leaderLineType != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLineType: ");
            a.u("'" + this.leaderLineType + "'");
        }
        a.l(", leaderLineVisibility: ");
        a.u(this.leaderLineVisibility ? "true" : "false");
        if (!isNaN_(this.leaderLineMargin)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLineMargin: ");
            a.u(this.leaderLineMargin.toString());
        }
        a.u(", rings: [");
        for (var c = 0; c < this.rings.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.rings._inner[c].serialize());
        }
        a.u("]}");
        return a.toString();
    };
    RingSeriesVisualData.$t = markType(RingSeriesVisualData, 'RingSeriesVisualData');
    return RingSeriesVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RingSeriesVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeriesVisualDataList, _super);
    function RingSeriesVisualDataList() {
        return _super.call(this, RingSeriesVisualData.$, 0) || this;
    }
    RingSeriesVisualDataList.$t = markType(RingSeriesVisualDataList, 'RingSeriesVisualDataList', List$1.$.specialize(RingSeriesVisualData.$));
    return RingSeriesVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SliceVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceVisualData, _super);
    function SliceVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._pieSlice = null;
        _this._outline = null;
        _this._labelVisualData = null;
        _this._backgroundPath = null;
        _this._origin = null;
        _this._explodedOrigin = null;
        _this._isExploded = false;
        _this._isSelected = false;
        _this._index = 0;
        _this._radius = 0;
        _this._startAngle = 0;
        _this._endAngle = 0;
        _this._visibility = false;
        return _this;
    }
    Object.defineProperty(SliceVisualData.prototype, "pieSlice", {
        get: function () {
            return this._pieSlice;
        },
        set: function (a) {
            this._pieSlice = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "outline", {
        get: function () {
            return this._outline;
        },
        set: function (a) {
            this._outline = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "labelVisualData", {
        get: function () {
            return this._labelVisualData;
        },
        set: function (a) {
            this._labelVisualData = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "backgroundPath", {
        get: function () {
            return this._backgroundPath;
        },
        set: function (a) {
            this._backgroundPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "origin", {
        get: function () {
            return this._origin;
        },
        set: function (a) {
            this._origin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "explodedOrigin", {
        get: function () {
            return this._explodedOrigin;
        },
        set: function (a) {
            this._explodedOrigin = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "isExploded", {
        get: function () {
            return this._isExploded;
        },
        set: function (a) {
            this._isExploded = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "isSelected", {
        get: function () {
            return this._isSelected;
        },
        set: function (a) {
            this._isSelected = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "index", {
        get: function () {
            return this._index;
        },
        set: function (a) {
            this._index = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "radius", {
        get: function () {
            return this._radius;
        },
        set: function (a) {
            this._radius = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "startAngle", {
        get: function () {
            return this._startAngle;
        },
        set: function (a) {
            this._startAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "endAngle", {
        get: function () {
            return this._endAngle;
        },
        set: function (a) {
            this._endAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceVisualData.prototype, "visibility", {
        get: function () {
            return this._visibility;
        },
        set: function (a) {
            this._visibility = a;
        },
        enumerable: true,
        configurable: true
    });
    SliceVisualData.prototype.scaleByViewport = function (a) {
        this.origin = new PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
        this.explodedOrigin = new PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
    };
    SliceVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.pieSlice != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("pieSlice: ");
            a.u(this.pieSlice.serialize());
        }
        if (this.labelVisualData != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelVisualData: ");
            a.u(this.labelVisualData.serialize());
        }
        if (this.backgroundPath != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("backgroundPath: ");
            a.u(this.backgroundPath.serialize());
        }
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("isExploded: ");
        a.u(this.isExploded.toString().toLowerCase());
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("isSelected: ");
        a.u(this.isSelected.toString().toLowerCase());
        if (!isNaN_(this.explodedOrigin.x) && !isNaN_(this.explodedOrigin.y)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("explodedOrigin: ");
            a.u("{ x: " + this.explodedOrigin.x.toString() + ", y: " + this.explodedOrigin.y.toString() + "}");
        }
        if (!isNaN_(this.origin.x) && !isNaN_(this.origin.y)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("origin: ");
            a.u("{ x: " + this.origin.x.toString() + ", y: " + this.origin.y.toString() + "}");
        }
        if (!isNaN_(this.index)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("index: ");
            a.u(this.index.toString());
        }
        if (!isNaN_(this.radius)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("radius: ");
            a.u(this.radius.toString());
        }
        a.l(", visibility: ");
        a.u(this.visibility ? "true" : "false");
        if (!isNaN_(this.startAngle)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("startAngle: ");
            a.u(this.startAngle.toString());
        }
        if (!isNaN_(this.endAngle)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("endAngle: ");
            a.u(this.endAngle.toString());
        }
        a.u("}");
        return a.toString();
    };
    SliceVisualData.$t = markType(SliceVisualData, 'SliceVisualData');
    return SliceVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RingVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingVisualData, _super);
    function RingVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._arcs = null;
        return _this;
    }
    Object.defineProperty(RingVisualData.prototype, "arcs", {
        get: function () {
            return this._arcs;
        },
        set: function (a) {
            this._arcs = a;
        },
        enumerable: true,
        configurable: true
    });
    RingVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.arcs != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("arcs: [");
            for (var c = 0; c < this.arcs.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.arcs._inner[c].c());
            }
            a.u("]");
        }
        a.u("}");
        return a.toString();
    };
    RingVisualData.$t = markType(RingVisualData, 'RingVisualData');
    return RingVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RingVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingVisualDataList, _super);
    function RingVisualDataList() {
        return _super.call(this, RingVisualData.$, 0) || this;
    }
    RingVisualDataList.$t = markType(RingVisualDataList, 'RingVisualDataList', List$1.$.specialize(RingVisualData.$));
    return RingVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ArcVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ArcVisualData, _super);
    function ArcVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        return _this;
    }
    ArcVisualData.prototype.d = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.scaleByViewport(a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    ArcVisualData.prototype.c = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.b != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLine: ");
            a.u(this.b.serialize());
        }
        if (this.a != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("slices: [");
            for (var c = 0; c < this.a.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.a._inner[c].serialize());
            }
        }
        a.u("]}");
        return a.toString();
    };
    ArcVisualData.$t = markType(ArcVisualData, 'ArcVisualData');
    return ArcVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ArcVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ArcVisualDataList, _super);
    function ArcVisualDataList() {
        return _super.call(this, ArcVisualData.$, 0) || this;
    }
    ArcVisualDataList.$t = markType(ArcVisualDataList, 'ArcVisualDataList', List$1.$.specialize(ArcVisualData.$));
    return ArcVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SliceVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceVisualDataList, _super);
    function SliceVisualDataList() {
        return _super.call(this, SliceVisualData.$, 0) || this;
    }
    SliceVisualDataList.$t = markType(SliceVisualDataList, 'SliceVisualDataList', List$1.$.specialize(SliceVisualData.$));
    return SliceVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DoughnutChartLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DoughnutChartLabelVisualData, _super);
    function DoughnutChartLabelVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._labelValue = null;
        _this._labelSize = null;
        _this._labelPosition = null;
        return _this;
    }
    Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelValue", {
        get: function () {
            return this._labelValue;
        },
        set: function (a) {
            this._labelValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelSize", {
        get: function () {
            return this._labelSize;
        },
        set: function (a) {
            this._labelSize = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DoughnutChartLabelVisualData.prototype, "labelPosition", {
        get: function () {
            return this._labelPosition;
        },
        set: function (a) {
            this._labelPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    DoughnutChartLabelVisualData.prototype.scaleByViewport = function (a) {
        this.labelPosition = new PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
        this.labelSize = new SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
    };
    DoughnutChartLabelVisualData.prototype.serialize = function () {
        var a = "{ labelValue: '";
        a += this.labelValue == null ? stringEmpty() : this.labelValue;
        a += "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}}";
        return a;
    };
    DoughnutChartLabelVisualData.$t = markType(DoughnutChartLabelVisualData, 'DoughnutChartLabelVisualData');
    return DoughnutChartLabelVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Arc = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Arc, _super);
    function Arc() {
        var _this = _super.call(this) || this;
        _this.hd = null;
        _this.hb = null;
        _this.hg = 0;
        _this.ab = Arc.$;
        return _this;
    }
    Arc.prototype.ar = function () {
        return new ArcView(this);
    };
    Arc.prototype.e6 = function (a) {
        _super.prototype.e6.call(this, a);
        this.hc = a;
    };
    Object.defineProperty(Arc.prototype, "he", {
        get: function () {
            return this.hd;
        },
        set: function (a) {
            var b = this.hd;
            this.hd = a;
            this.hc.b6(b, this.hd);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Arc.prototype, "hh", {
        get: function () {
            if (this.he != null) {
                return this.he.i;
            }
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Arc.prototype.e5 = function (a, b) {
        _super.prototype.e5.call(this, a, b);
        if (this.he != null) {
            this.he.c.at.bu(a, b);
        }
    };
    Arc.prototype.ek = function (a, b) {
        if (this.he != null && this.he.d != null) {
            _super.prototype.ek.call(this, a, b);
            var c = this.hf(a);
            if (c != null) {
                this.he.d.bj(c, b);
            }
        }
    };
    Arc.prototype.fk = function (a, b) {
        if (this.he != null && this.he.d != null) {
            _super.prototype.fk.call(this, a, b);
            var c = this.hf(a);
            if (c != null) {
                this.he.d.b5(c, b);
            }
        }
    };
    Arc.prototype.hf = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.hb.g)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b.b == a) {
                    return b;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    Arc.prototype.fj = function (a) {
        if (this.bq) {
            this.e9();
            this.fh();
            this.fg();
        }
    };
    Arc.prototype.e9 = function () {
        if (this.itemsSource == null || this.a5 == null) {
            this.bg.count = 0;
            return;
        }
        var a = this.b2.count;
        var b = this.b1.count > 0;
        var c = PieChartBase.cs(this.cf);
        var d = PieChartBase.cs(this.cf);
        this.cx = a;
        if (b) {
            a++;
        }
        for (var e = 0; e < a; e++) {
            var f = false;
            var g = void 0;
            if (e == a - 1 && b) {
                g = this.cp;
                f = true;
            }
            else {
                g = this.be.item(this.b2._inner[e]);
            }
            if (this.gz == 1) {
                d += PieChartBase.cs(Math.abs(g) * this.hi / this.cu);
            }
            else {
                d -= PieChartBase.cs(Math.abs(g) * this.hi / this.cu);
            }
            var h = this.bg.item(e);
            if (this.cc >= 100) {
                h._visibility = 1;
            }
            else {
                h._visibility = 0;
            }
            h.aw = true;
            h.a3 = c;
            h.ax = d;
            h.a1 = h.a0 = this.cc;
            h.isOthersSlice = f;
            h.ay = this.cb;
            h.a5 = e;
            h.dataContext = f ? this.b0 : this.a5.item(this.b2._inner[e]);
            h.isExploded = this.explodedSlices.contains(e);
            h.isSelected = this.selectedSlices.contains(e);
            c = d;
            h.aw = false;
        }
        this.bg.count = a;
        if (this.hb != null) {
            this.hb.q(this);
        }
    };
    Arc.prototype.fg = function () {
        var e_2, _a;
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.legend);
        if (a == null) {
            return;
        }
        if (this.ba == null || this.ba.count == 0 || ((this.he != null && this.he.c != null) && (this.he.d != null && !this.he.d.series.contains(this.he.c)))) {
            a.clearLegendItemsForSeries(this.he.c);
            return;
        }
        this.bz = new List$1(UIElement.$, 0);
        var _loop_1 = function (b) {
            var c = new ContentControl();
            var d = this_1.cy(b);
            var e = b.b0;
            var f = b.isOthersSlice ? this_1.dz : (this_1.bb != null && this_1.bb.count > 0) ? this_1.bb.item(this_1.b2._inner[b.a5]) : null;
            f = (f == null && this_1.ba.count > 0) ? this_1.ba.item(this_1.b2._inner[b.a5]) : f;
            c.content = ((function () {
                var $ret = new PieSliceDataContext();
                $ret.series = _this.he.c;
                $ret.slice = b;
                $ret.item = b.dataContext;
                $ret.itemBrush = e;
                $ret.legendLabel = f != null ? f.toString() : null;
                $ret.itemLabel = d != null ? d.toString() : null;
                $ret.percentValue = _this.ck(b);
                $ret.isOthersSlice = b.isOthersSlice;
                return $ret;
            })());
            var g = c.content;
            if (this_1.au != null) {
                var h = this_1.au(g);
                if (h != null) {
                    g.legendLabel = h.toString();
                }
            }
            if (this_1.legendItemTemplate != null) {
                c.ah = this_1.legendItemTemplate;
            }
            this_1.bz.add(c);
        };
        var this_1 = this;
        try {
            for (var _b = __values(fromEnum(this.bg.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                _loop_1(b);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        if (a.isItemwise) {
            var i = a;
            i.createLegendItemsInsert(this.bz, this.he.c);
        }
    };
    Arc.prototype.fa = function (a, b, c, d) {
        _super.prototype.fa.call(this, a, b, c, d);
        switch (b) {
            case Arc.$$p[0]:
                this.hg = d;
                this.e9();
                this.e8();
                this.fh();
                this.ff();
                break;
            case "RadiusFactor":
                if (this.he != null && this.he.d != null) {
                    this.he.d.bw();
                }
                break;
            case "Legend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null && this.he != null && this.he.c != null) {
                    e.clearLegendItemsForSeries(this.he.c);
                }
                break;
        }
    };
    Arc.prototype.hj = function () {
        return this.as.ac();
    };
    Arc.$t = markType(Arc, 'Arc', PieChartBase.$);
    Arc.$$p = markDep(DependencyProperty, PropertyMetadata, Arc, 'fc', ['EndAngle:hi:hl', [1, 360]]);
    return Arc;
}(PieChartBase));
/**
 * @hidden
 */
var ArcItem = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ArcItem, _super);
    function ArcItem() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.b = null;
        _this.n = null;
        _this.l = 0;
        _this.m = 0;
        _this.k = 0;
        _this.i = 0;
        _this.j = 0;
        _this.c = 0;
        _this.a = null;
        _this.g = null;
        _this.e = null;
        _this.h = null;
        _this.k = 0;
        _this.i = 360;
        _this.g = new List$1(SliceItem.$, 0);
        return _this;
    }
    ArcItem.prototype.o = function (a, b) {
        var e_3, _a;
        var c = 0;
        var d = 0;
        var e = new List$1(Number_$type, 0);
        var f = new List$1(Number_$type, 0);
        var g = new List$1(Base.$, 0);
        this.g.clear();
        if (this.h == null) {
            return;
        }
        var h = new FastItemsSource();
        h.e = this.h;
        var i = this.f(h, this.n);
        if (i == null || i.count == 0) {
            h.deregisterColumn(i);
            h.m();
            return;
        }
        try {
            for (var _b = __values(fromEnum(i)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                if (isNaN_(j) || isInfinity(j) || j <= 0) {
                    continue;
                }
                c = c + j;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        for (var k = 0; k < i.count; k++) {
            var l = i.item(k);
            if (isNaN_(l) || isInfinity(l) || l <= 0) {
                continue;
            }
            var m = this.c == 1 ? l / c : l;
            var n = this.c == 1 ? this.j / 100 : this.j;
            if (m <= n) {
                d = d + l;
                f.add(k);
                g.add1(h.item(k));
            }
            else {
                e.add(k);
            }
        }
        var o = e.count;
        var p = f.count > 0;
        var q = PieChartBase.cs(a);
        var r = PieChartBase.cs(a);
        if (p) {
            o++;
        }
        var _loop_2 = function (s) {
            var t = false;
            var u = void 0;
            if (s == o - 1 && p) {
                u = d;
                t = true;
            }
            else {
                u = i.item(e._inner[s]);
            }
            var v = 1;
            if (v == 1) {
                r += PieChartBase.cs(Math.abs(u) * b / c);
            }
            else {
                r -= PieChartBase.cs(Math.abs(u) * b / c);
            }
            this_2.g.add(((function () {
                var $ret = new SliceItem();
                $ret.e = q;
                $ret.d = r - q;
                $ret.g = t ? g : h.item(e._inner[s]);
                return $ret;
            })()));
            q = r;
        };
        var this_2 = this;
        for (var s = 0; s < o; s++) {
            _loop_2(s);
        }
        h.deregisterColumn(i);
        h.m();
    };
    ArcItem.prototype.f = function (a, b) {
        var c = null;
        return a.registerColumn(b, c, false);
    };
    ArcItem.prototype.p = function (a) {
        var b = this.e == null ? a : this.e.e;
        var c = this.e == null ? 360 : this.e.d;
        this.o(b, c);
    };
    ArcItem.prototype.q = function (a) {
        var _this = this;
        this.g.clear();
        var _loop_3 = function (b) {
            var c = a.bg.item(b);
            this_3.g.add(((function () {
                var $ret = new SliceItem();
                $ret.e = c.a3;
                $ret.d = c.ax - c.a3;
                $ret.f = b;
                $ret.a = _this;
                $ret.g = c.dataContext;
                $ret.c = c.isOthersSlice;
                $ret.b = c;
                return $ret;
            })()));
        };
        var this_3 = this;
        for (var b = 0; b < a.bg.count; b++) {
            _loop_3(b);
        }
    };
    ArcItem.$t = markType(ArcItem, 'ArcItem');
    return ArcItem;
}(Base));
/**
 * @hidden
 */
var RingSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeriesBase, _super);
    function RingSeriesBase() {
        var _this = _super.call(this) || this;
        _this.ao = null;
        _this.at = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.a7 = null;
        _this.aw = false;
        _this.av = false;
        _this.a5 = null;
        _this.dq = null;
        _this.as = null;
        _this.cq = null;
        _this.dq = { $type: Point_$type, x: 0, y: 0 };
        _this.ao = function (a, b) { return _this.cl(a, b.propertyName, b.oldValue, b.newValue); };
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, _this.ao);
        _this.as = _this.ar();
        _this.ci(_this.as);
        _this.as.k();
        _this.a5 = function (a, b) { return _this.cc(b.action, b.position, b.count, b.propertyName); };
        return _this;
    }
    RingSeriesBase.prototype.cn = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    Object.defineProperty(RingSeriesBase.prototype, "du", {
        get: function () {
            if (this.dt != null) {
                return this.dt;
            }
            if (this.at != null && this.at.cg != null) {
                return this.at.cg;
            }
            return null;
        },
        set: function (a) {
            var b = this.du;
            if (this.dt != null && a != this.dt) {
                a = this.dt;
            }
            this.cn("SelectedStyleResolved", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "b5", {
        get: function () {
            return this.a7;
        },
        set: function (a) {
            var b = this.a7;
            this.a7 = a;
            this.cn("TextStyle", b, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "cr", {
        get: function () {
            return typeCast(DataTemplate.$, this.c(RingSeriesBase.c3));
        },
        set: function (a) {
            this.h(RingSeriesBase.c3, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "ax", {
        get: function () {
            return this.c(RingSeriesBase.cw);
        },
        set: function (a) {
            this.aw = true;
            this.h(RingSeriesBase.cw, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "ay", {
        get: function () {
            if (!this.aw) {
                return this.at.ax;
            }
            else {
                return this.ax;
            }
        },
        enumerable: true,
        configurable: true
    });
    RingSeriesBase.prototype.cl = function (a, b, c, d) {
        if (b == RingSeriesBase.$$p[4]) {
            this.au = ((function () {
                var $ret = new FastItemsSource();
                $ret.e = d;
                return $ret;
            })());
        }
        if (b == RingSeriesBase.$$p[1]) {
            if (typeCast(FastItemsSource.$, c) != null) {
                var e = (typeCast(FastItemsSource.$, c));
                e.event = delegateRemove(e.event, this.a5);
                this.av = false;
            }
            if (typeCast(FastItemsSource.$, d) != null) {
                var f = (typeCast(FastItemsSource.$, d));
                f.event = delegateCombine(f.event, this.a5);
                this.av = true;
            }
            this.ck();
        }
        switch (b) {
            case RingSeriesBase.$$p[24]:
                this.du = d;
                break;
            case RingSeriesBase.$$p[28]:
                this.ck();
                break;
        }
    };
    Object.defineProperty(RingSeriesBase.prototype, "container", {
        get: function () {
            return this.at;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "isStacked", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "isVertical", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "isUsableInLegend", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "hasMarkers", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingSeriesBase.prototype, "hasSubItems", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    RingSeriesBase.prototype.cc = function (a, b, c, d) {
        this.ck();
    };
    RingSeriesBase.prototype.ar = function () {
        return new RingSeriesBaseView(this);
    };
    RingSeriesBase.prototype.ci = function (a) {
    };
    RingSeriesBase.prototype.cm = function (a) {
        this.as.n(a);
    };
    RingSeriesBase.prototype.cb = function () {
        if (this.as != null) {
            this.as.i();
        }
    };
    RingSeriesBase.prototype.cf = function (a, b) {
        this.cd(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    RingSeriesBase.prototype.ch = function (a, b, c) {
        this.cd(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    RingSeriesBase.prototype.ce = function () {
        this.cd(new NotifyCollectionChangedEventArgs(0, 4));
    };
    RingSeriesBase.prototype.cg = function (a, b) {
        this.cd(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    RingSeriesBase.prototype.cd = function (a) {
        if (this.au != null) {
            this.au.handleCollectionChanged(a);
        }
    };
    RingSeriesBase.prototype.resolveLegendIndex = function () {
        return -1;
    };
    RingSeriesBase.prototype.forSubItems = function (a) {
    };
    RingSeriesBase.$t = markType(RingSeriesBase, 'RingSeriesBase', Control.$, [INotifyPropertyChanged_$type, ILegendSeries_$type, ILegendTemplateProvider_$type]);
    RingSeriesBase.c3 = DependencyProperty.i("LabelTemplate", DataTemplate.$, RingSeriesBase.$, new PropertyMetadata(2, null, function (a, b) { return (typeCast(RingSeriesBase.$, a)).cn("LabelTemplate", b.oldValue, b.newValue); }));
    RingSeriesBase.cw = DependencyProperty.i("IsSurfaceInteractionDisabled", Boolean_$type, RingSeriesBase.$, new PropertyMetadata(2, false, function (a, b) { return a.cn("IsSurfaceInteractionDisabled", b.oldValue, b.newValue); }));
    RingSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, RingSeriesBase, 'cn', ['Brushes:ag:cs', [BrushCollection.$, null], 'FastItemsSource:au:ct', [FastItemsSource.$], 'FormatLabel:am:cu', [Delegate_$type], 'FormatLegendLabel:an:cv', [Delegate_$type], 'ItemsSource::cx', [IEnumerable_$type, null], 'LabelExtent:a0:cy', [1, 10], 'LabelInnerColor:dn:cz', [Brush.$, null], 'LabelMemberPath:bg:c0', [2], 'LabelOuterColor:dp:c1', [Brush.$, null], 'LabelsPosition:aj:c2', [LabelsPosition_$type, enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:a1:c4', [1, 6], 'LeaderLineStyle:dr:c5', [Style.$, null], 'LeaderLineType:ak:c6', [LeaderLineType_$type, enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:dw:c7', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'LegendItemBadgeTemplate::c8', [DataTemplate.$, null], 'LegendItemTemplate::c9', [DataTemplate.$, null], 'LegendLabelMemberPath:br:da', [2], 'Legend::db', [IChartLegend_$type, null], 'OthersCategoryStyle:ds:dc', [Style.$, null], 'OthersCategoryText:bv:dd', [2, "Others"], 'OthersCategoryThreshold:a2:de', [1, 3], 'OthersCategoryType:al:df', [OthersCategoryType_$type, enumGetBox(OthersCategoryType_$type, 1)], 'Outlines:ah:dg', [BrushCollection.$, null], 'RadiusFactor:a3:dh', [1, 0.9], 'SelectedStyle:dt:di', [Style.$, null], 'StartAngle:a4:dj', [1, 0], 'ToolTip::dk', [4, null], 'ToolTipStyle:dv:dl', [Style.$, null], 'ValueMemberPath:b9:dm', [2, null]]);
    return RingSeriesBase;
}(Control));
/**
 * @hidden
 */
var Ring = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Ring, _super);
    function Ring() {
        var _this = _super.call(this) || this;
        _this.j = 0;
        _this.h = 0;
        _this.q = new Size();
        _this.p = null;
        _this._ringControl = null;
        _this.b = null;
        _this.i = 0;
        _this.g = null;
        _this.d = null;
        _this.e = false;
        _this.p = { $type: Point_$type, x: 0, y: 0 };
        _this.q = new Size(1, 0, 0);
        _this.ringControl = ((function () {
            var $ret = new RingControl();
            $ret.ai = _this;
            return $ret;
        })());
        _this.g = new List$1(ArcItem.$, 0);
        _this.e = true;
        return _this;
    }
    Object.defineProperty(Ring.prototype, "ringControl", {
        get: function () {
            return this._ringControl;
        },
        set: function (a) {
            this._ringControl = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Ring.prototype, "c", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
            this.b.as.h(this.ringControl);
            if (this.ringControl != null) {
                this.ringControl.ak.s(a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Ring.prototype.f = function () {
        if (this.ringControl != null && this.ringControl.ak.d()) {
            var a = void 0, b = void 0;
            a = this.p.x - this.c.dq.x;
            b = this.p.y - this.c.dq.y;
            this.ringControl.ak.v(a, b);
            return this.ringControl.an();
        }
        return false;
    };
    Ring.prototype.o = function () {
        if (this.ringControl != null) {
            this.ringControl.width = this.q.width;
            this.ringControl.height = this.q.height;
            this.c.as.h(this.ringControl);
            this.ringControl.ao = this.g;
        }
    };
    Ring.prototype.l = function (source_, a, b) {
        this.ringControl.as(source_, a, b);
    };
    Ring.prototype.k = function (source_) {
        this.ringControl.ar(source_);
    };
    Ring.prototype.m = function (source_, a, b) {
        this.ringControl.at(source_, a, b);
    };
    Ring.prototype.n = function (source_, a, b, c) {
        this.ringControl.au(source_, a, b, c);
    };
    Ring.$t = markType(Ring, 'Ring');
    return Ring;
}(Base));
/**
 * @hidden
 */
var RingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingCollection, _super);
    function RingCollection() {
        return _super.call(this, Ring.$, 0) || this;
    }
    RingCollection.prototype.p = function () {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(this)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                if (a.e) {
                    var b = 0;
                    var c = a.ringControl.arcs.count;
                    while (b < c) {
                        a.ringControl.arcs.destroy(a.ringControl.arcs.item(b));
                        b++;
                    }
                    a.ringControl.arcs.count = 0;
                    a.ringControl = null;
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        _super.prototype.p.call(this);
    };
    RingCollection.prototype.u = function (a) {
        var b = this._inner[a];
        if (b.e) {
            b.ringControl.arcs.destroy(b.ringControl.arcs.item(a));
            b.ringControl.arcs.count = 0;
            b.ringControl = null;
        }
        _super.prototype.u.call(this, a);
    };
    RingCollection.$t = markType(RingCollection, 'RingCollection', ObservableCollection$1.$.specialize(Ring.$));
    return RingCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var RingControl = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingControl, _super);
    function RingControl() {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.ah = null;
        _this.arcs = null;
        _this.ao = null;
        _this.a0 = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.ab = RingControl.$;
        _this.ak = _this.aj();
        _this.ax(_this.ak);
        _this.ak.r();
        _this.arcs = ((function () {
            var $ret = new Pool$1(Arc.$);
            $ret.create = runOn(_this.ak, _this.ak.a);
            $ret.activate = runOn(_this.ak, _this.ak.l);
            $ret.disactivate = runOn(_this.ak, _this.ak.n);
            $ret.destroy = runOn(_this.ak, _this.ak.m);
            return $ret;
        })());
        return _this;
    }
    Object.defineProperty(RingControl.prototype, "al", {
        get: function () {
            return this.ai.c;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RingControl.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            this.ah = a;
            if (this.ah == null) {
                this.ak.s(null);
            }
            else {
                this.ak.s(this.ah.c);
            }
        },
        enumerable: true,
        configurable: true
    });
    RingControl.prototype.aj = function () {
        return new RingControlView(this);
    };
    RingControl.prototype.ax = function (a) {
    };
    RingControl.prototype.az = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    RingControl.prototype.aw = function () {
        this.an();
    };
    RingControl.prototype.an = function () {
        var e_5, _a;
        if (this.ao == null) {
            return false;
        }
        if (!this.ak.d()) {
            return false;
        }
        var a = 0;
        var b = false;
        try {
            for (var _b = __values(fromEnum(this.ao)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = this.arcs.item(a);
                d.hb = c;
                if (d.cl != this.ai.h) {
                    d.cl = this.ai.h;
                }
                if ((d.width != this.ai.q.width || d.height != this.ai.q.height) && d.as.r()) {
                    d.width = this.ai.q.width;
                    d.height = this.ai.q.height;
                    this.ak.ab(d);
                    b = true;
                }
                if (d.ct != c.k) {
                    d.ct = c.k;
                }
                if (d.hi != c.i) {
                    d.hi = c.i;
                }
                if (d.itemsSource != c.h) {
                    d.itemsSource = c.h;
                }
                if (d.ag != c.a) {
                    d.ag = c.a;
                }
                this.ak.t(d, 0, 0);
                a++;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.arcs.count = a;
        return b;
    };
    RingControl.prototype.ay = function (a) {
        this.ak.w(a);
    };
    RingControl.prototype.av = function () {
        this.ak.q();
    };
    RingControl.prototype.ap = function () {
        return this.ak.j();
    };
    RingControl.prototype.as = function (source_, a, b) {
        for (var c = 0; c < this.arcs.count; c++) {
            this.arcs.item(c).es(source_, a, b);
        }
    };
    RingControl.prototype.ar = function (source_) {
        for (var a = 0; a < this.arcs.count; a++) {
            this.arcs.item(a).eq(source_);
        }
    };
    RingControl.prototype.at = function (source_, a, b) {
        for (var c = 0; c < this.arcs.count; c++) {
            this.arcs.item(c).et(source_, a, b);
        }
    };
    RingControl.prototype.au = function (source_, a, b, c) {
        for (var d = 0; d < this.arcs.count; d++) {
            this.arcs.item(d).eu(source_, a, b, c);
        }
    };
    RingControl.$t = markType(RingControl, 'RingControl', Control.$, [INotifyPropertyChanged_$type]);
    return RingControl;
}(Control));
/**
 * @hidden
 */
var RingSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeriesCollection, _super);
    function RingSeriesCollection() {
        return _super.call(this, RingSeriesBase.$, 0) || this;
    }
    RingSeriesCollection.$t = markType(RingSeriesCollection, 'RingSeriesCollection', ObservableCollection$1.$.specialize(RingSeriesBase.$));
    return RingSeriesCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var SliceItem = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceItem, _super);
    function SliceItem() {
        var _this = _super.call(this) || this;
        _this.e = 0;
        _this.d = 0;
        _this.a = null;
        _this.f = 0;
        _this.b = null;
        _this.g = null;
        _this.c = false;
        return _this;
    }
    SliceItem.$t = markType(SliceItem, 'SliceItem');
    return SliceItem;
}(Base));
/**
 * @hidden
 */
var SliceCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceCollection, _super);
    function SliceCollection() {
        var _this = _super.call(this, SliceItem.$, 0) || this;
        _this.ae = false;
        _this.ag = false;
        return _this;
    }
    SliceCollection.prototype.r = function (a, b) {
        if (this.contains(b)) {
            return;
        }
        var c = this.ah(b.b);
        if (c != -1) {
            _super.prototype.x.call(this, c, b);
        }
        else {
            _super.prototype.r.call(this, a, b);
            if (this.ae) {
                if (this.ag) {
                    b.b.isSelected = true;
                }
                else {
                    b.b.isExploded = true;
                }
            }
        }
    };
    SliceCollection.prototype.x = function (a, b) {
        if (this.ae) {
            if (this.ag) {
                this._inner[a].b.isSelected = false;
            }
            else {
                this._inner[a].b.isExploded = false;
            }
        }
        _super.prototype.x.call(this, a, b);
    };
    SliceCollection.prototype.u = function (a) {
        var b = this._inner[a];
        _super.prototype.u.call(this, a);
        if (this.ae) {
            if (this.ag) {
                b.b.isSelected = false;
            }
            else {
                b.b.isExploded = false;
            }
        }
    };
    SliceCollection.prototype.remove = function (a) {
        var b = this.ah(a.b);
        if (b != -1) {
            this.u(b);
            return true;
        }
        else {
            return false;
        }
    };
    SliceCollection.prototype.p = function () {
        while (this.count > 0) {
            this.u(0);
        }
    };
    SliceCollection.prototype.ah = function (a) {
        for (var b = 0; b < this.count; b++) {
            if (this._inner[b].b == a) {
                return b;
            }
        }
        return -1;
    };
    SliceCollection.$t = markType(SliceCollection, 'SliceCollection', ObservableCollection$1.$.specialize(SliceItem.$));
    return SliceCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var XamDoughnutChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamDoughnutChart, _super);
    function XamDoughnutChart() {
        var _this = _super.call(this) || this;
        _this.al = new RingSeriesCollection();
        _this.aj = new RingCollection();
        _this.ap = ((function () {
            var $ret = new SliceCollection();
            $ret.ae = true;
            $ret.ag = true;
            return $ret;
        })());
        _this.ao = ((function () {
            var $ret = new SliceCollection();
            $ret.ae = true;
            $ret.ag = false;
            return $ret;
        })());
        _this.ah = null;
        _this.a0 = NaN;
        _this.az = 1;
        _this.au = null;
        _this.sliceClick = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.holeDimensionsChanged = null;
        var a = _this.at();
        _this.bv(a);
        a.s();
        _this.ab = XamDoughnutChart.$;
        _this.ah = function (b, c) { return _this.bz(b, c.propertyName, c.oldValue, c.newValue); };
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, _this.ah);
        var b = _this.series;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.b6));
        return _this;
    }
    Object.defineProperty(XamDoughnutChart.prototype, "ak", {
        get: function () {
            return this.aj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDoughnutChart.prototype, "series", {
        get: function () {
            return this.al;
        },
        enumerable: true,
        configurable: true
    });
    XamDoughnutChart.prototype.b6 = function (a, b) {
        var e_6, _a;
        var c = new List$1(RingSeriesBase.$, 0);
        if (b.oldItems != null) {
            try {
                for (var _b = __values(fromEn(b.oldItems)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (b.newItems == null || !b.newItems.contains(d)) {
                        d.cb();
                        this.au.w(d);
                    }
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        this.bx();
        this.b2();
    };
    Object.defineProperty(XamDoughnutChart.prototype, "a3", {
        get: function () {
            return this.c(XamDoughnutChart.cc);
        },
        set: function (a) {
            this.h(XamDoughnutChart.cc, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDoughnutChart.prototype, "ar", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            this.ap.clear();
            this.ap.ae = false;
            this.ap = a;
            this.ap.ae = true;
            this.ap.ag = true;
            for (var b = 0; b < this.ap.count; b++) {
                this.ap._inner[b].b.isSelected = true;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDoughnutChart.prototype, "aq", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            this.ao.clear();
            this.ao.ae = false;
            this.ao = a;
            this.ao.ae = true;
            this.ao.ag = false;
            for (var b = 0; b < this.ao.count; b++) {
                this.ao._inner[b].b.isExploded = true;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDoughnutChart.prototype, "a4", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            this.b1("PixelScalingRatio", b, this.a0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamDoughnutChart.prototype, "a1", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            this.b1("ActualPixelScalingRatio", b, this.az);
        },
        enumerable: true,
        configurable: true
    });
    XamDoughnutChart.prototype.destroy = function () {
        var e_7, _a;
        this.au.v(null);
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.cb();
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
    };
    XamDoughnutChart.prototype.b5 = function (a, b) {
        if (b) {
            this.ar.add(a);
        }
        else {
            this.ar.remove(a);
        }
    };
    XamDoughnutChart.prototype.bj = function (a, b) {
        if (b) {
            this.aq.add(a);
        }
        else {
            this.aq.remove(a);
        }
    };
    XamDoughnutChart.prototype.bz = function (a, b, c, d) {
        var e_8, _a, e_9, _b, e_10, _c, e_11, _d, e_12, _e;
        switch (b) {
            case XamDoughnutChart.$$p[5]:
                try {
                    for (var _f = __values(fromEnum(this.series)), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var e = _g.value;
                        e.du = d;
                    }
                }
                catch (e_8_1) {
                    e_8 = { error: e_8_1 };
                }
                finally {
                    try {
                        if (_g && !_g.done && (_a = _f.return))
                            _a.call(_f);
                    }
                    finally {
                        if (e_8)
                            throw e_8.error;
                    }
                }
                break;
            case XamDoughnutChart.$$p[0]:
                for (var f = 0; f < this.aj.count; f++) {
                    try {
                        for (var _h = (e_9 = void 0, __values(fromEnum(this.aj._inner[f].ringControl.arcs.a))), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var g = _j.value;
                            g.bp = this.av;
                        }
                    }
                    catch (e_9_1) {
                        e_9 = { error: e_9_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_b = _h.return))
                                _b.call(_h);
                        }
                        finally {
                            if (e_9)
                                throw e_9.error;
                        }
                    }
                }
                break;
            case XamDoughnutChart.$$p[1]:
                for (var h = 0; h < this.aj.count; h++) {
                    try {
                        for (var _k = (e_10 = void 0, __values(fromEnum(this.aj._inner[h].ringControl.arcs.a))), _l = _k.next(); !_l.done; _l = _k.next()) {
                            var i = _l.value;
                            i.bq = this.aw;
                        }
                    }
                    catch (e_10_1) {
                        e_10 = { error: e_10_1 };
                    }
                    finally {
                        try {
                            if (_l && !_l.done && (_c = _k.return))
                                _c.call(_k);
                        }
                        finally {
                            if (e_10)
                                throw e_10.error;
                        }
                    }
                }
                break;
            case "PixelScalingRatio":
                var j = DeviceUtils.a(this.a4);
                if (isNaN_(j)) {
                    this.a1 = 1;
                }
                else {
                    this.a1 = j;
                }
                break;
            case "ActualPixelScalingRatio":
                try {
                    for (var _m = __values(fromEnum(this.aj)), _o = _m.next(); !_o.done; _o = _m.next()) {
                        var k = _o.value;
                        try {
                            for (var _p = (e_12 = void 0, __values(fromEnum(k.ringControl.arcs.a))), _q = _p.next(); !_q.done; _q = _p.next()) {
                                var l = _q.value;
                                l.cd = this.a1;
                            }
                        }
                        catch (e_12_1) {
                            e_12 = { error: e_12_1 };
                        }
                        finally {
                            try {
                                if (_q && !_q.done && (_e = _p.return))
                                    _e.call(_p);
                            }
                            finally {
                                if (e_12)
                                    throw e_12.error;
                            }
                        }
                    }
                }
                catch (e_11_1) {
                    e_11 = { error: e_11_1 };
                }
                finally {
                    try {
                        if (_o && !_o.done && (_d = _m.return))
                            _d.call(_m);
                    }
                    finally {
                        if (e_11)
                            throw e_11.error;
                    }
                }
                break;
        }
    };
    XamDoughnutChart.prototype.at = function () {
        return new XamDoughnutChartView(this);
    };
    XamDoughnutChart.prototype.bv = function (a) {
        this.au = a;
    };
    XamDoughnutChart.prototype.b2 = function () {
        this.by();
        this.b4();
        this.b3();
        this.bw();
        this.au.z();
    };
    XamDoughnutChart.prototype.b4 = function () {
        var e_13, _a;
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.cp();
            }
        }
        catch (e_13_1) {
            e_13 = { error: e_13_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_13)
                    throw e_13.error;
            }
        }
    };
    XamDoughnutChart.prototype.bw = function () {
        var a = this.au.ab;
        if (a.isEmpty || a.width == 0 || a.height == 0) {
            return;
        }
        var b = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        var c = Math.min(a.width / 2, a.height / 2);
        var d = 0.9;
        if (this.series.count > 0) {
            d = this.series._inner[0].a3;
            if (isNaN_(d) || isInfinity(d) || d < 0) {
                d = 0;
            }
            else if (d > 1) {
                d = 1;
            }
        }
        var e = this.a3 * c / 100 * d;
        this.au.x(e * 2, e * 2);
        this.au.u(b.x - e, b.y - e);
    };
    XamDoughnutChart.prototype.b3 = function () {
        var e_14, _a, e_15, _b;
        var a = false;
        try {
            for (var _c = __values(fromEnum(this.aj)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (b.f()) {
                    a = true;
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        if (a) {
            try {
                for (var _e = __values(fromEnum(this.aj)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.c.as.l();
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
        }
    };
    XamDoughnutChart.prototype.by = function () {
        var e_16, _a;
        var a = this.au.ab;
        if (a.isEmpty || a.width == 0 || a.height == 0) {
            return;
        }
        var b = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        var c = Math.min(a.width / 2, a.height / 2);
        var d = Math.max(a.width / 2, a.height / 2);
        if (a.width > a.height) {
            c = c + d;
            d = c - d;
            c = c - d;
        }
        var e = ((100 - this.a3) / 100 * c) / this.aj.count;
        var f = ((100 - this.a3) / 100 * d) / this.aj.count;
        var g = this.a3 * c / 100;
        var h = this.a3 * d / 100;
        var i = 1;
        try {
            for (var _b = __values(fromEnum(this.aj)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                var k = (g + (e * i));
                var l = (h + (f * i));
                j.i = e;
                j.q = new Size(1, k * 2, l * 2);
                j.p = { $type: Point_$type, x: b.x - k, y: b.y - l };
                j.h = 100 - (e / k * 100);
                j.o();
                i++;
            }
        }
        catch (e_16_1) {
            e_16 = { error: e_16_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_16)
                    throw e_16.error;
            }
        }
    };
    XamDoughnutChart.prototype.bx = function () {
        var e_17, _a;
        this.aq.clear();
        this.ar.clear();
        this.aj.clear();
        this.au.j();
        this.au.i();
        var a = 0;
        for (var b = 0; b < this.series.count; b++) {
            var c = this.series._inner[b];
            c.at = this;
            this.au.h(c);
            var series_ = c;
            series_.externalObject.sychronizeCollections();
            var d = c.aq();
            try {
                for (var _b = (e_17 = void 0, __values(fromEnum(d))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    e.d = this;
                    e.j = a;
                    this.aj.add(e);
                    a++;
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
    };
    XamDoughnutChart.prototype.bt = function () {
        if (this.au != null) {
            this.height = this.au.ab.height;
            this.width = this.au.ab.width;
        }
        this.b2();
    };
    XamDoughnutChart.prototype.bu = function (a, b) {
        var c = a;
        var d = c.he.c;
        if (d.ay) {
            return;
        }
        if (this.sliceClick != null) {
            this.sliceClick(a, b);
        }
    };
    XamDoughnutChart.prototype.b1 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    XamDoughnutChart.prototype.onDetachedFromUI = function () {
        var e_18, _a, e_19, _b;
        this.au.r();
        for (var a = 0; a < this.aj.count; a++) {
            try {
                for (var _c = (e_18 = void 0, __values(fromEnum(this.aj._inner[a].ringControl.arcs.a))), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.onDetachedFromUI();
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
            try {
                for (var _e = (e_19 = void 0, __values(fromEnum(this.aj._inner[a].ringControl.arcs.b))), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.onDetachedFromUI();
                }
            }
            catch (e_19_1) {
                e_19 = { error: e_19_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_19)
                        throw e_19.error;
                }
            }
        }
    };
    XamDoughnutChart.prototype.onAttachedToUI = function () {
        var e_20, _a, e_21, _b;
        this.au.q();
        for (var a = 0; a < this.aj.count; a++) {
            try {
                for (var _c = (e_20 = void 0, __values(fromEnum(this.aj._inner[a].ringControl.arcs.a))), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.onAttachedToUI();
                }
            }
            catch (e_20_1) {
                e_20 = { error: e_20_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_20)
                        throw e_20.error;
                }
            }
            try {
                for (var _e = (e_21 = void 0, __values(fromEnum(this.aj._inner[a].ringControl.arcs.b))), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.onAttachedToUI();
                }
            }
            catch (e_21_1) {
                e_21 = { error: e_21_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_21)
                        throw e_21.error;
                }
            }
        }
    };
    XamDoughnutChart.prototype.provideContainer = function (a) {
        this.au.v(a);
    };
    XamDoughnutChart.prototype.notifyResized = function () {
        this.au.y();
    };
    XamDoughnutChart.prototype.bd = function () {
        return this.au.g();
    };
    XamDoughnutChart.prototype.cf = function () {
        return this.au.aa;
    };
    XamDoughnutChart.prototype.a2 = function () {
        return this.au.d;
    };
    XamDoughnutChart.prototype.bk = function () {
        var a;
        var b;
        for (var c = 0; c < this.series.count; c++) {
            b = this.series._inner[c].aq();
            for (var d = 0; d < b.count; d++) {
                a = b._inner[d].ringControl.ak.h();
                for (var e = 0; e < a.count; e++) {
                    a._inner[e].el();
                }
            }
        }
    };
    XamDoughnutChart.prototype.bs = function () {
        if (this.holeDimensionsChanged != null) {
            this.holeDimensionsChanged(this, new HoleDimensionsChangedEventArgs(this.cf(), this.a2()));
        }
    };
    XamDoughnutChart.prototype.as = function () {
        var a = new DoughnutChartVisualData();
        a.series = new RingSeriesVisualDataList();
        a.viewport = RectData.b(this.au.ab);
        this.au.o(a);
        return a;
    };
    XamDoughnutChart.prototype.bc = function () {
        var a = this.as();
        a.scaleByViewport();
        return a.serialize();
    };
    XamDoughnutChart.prototype._ay = function (a) {
        var _a, _b, b, e_22_1;
        var e_22, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 5, 6, 7]);
                    _a = __values(fromEnum(this.series)), _b = _a.next();
                    _d.label = 1;
                case 1:
                    if (!!_b.done)
                        return [3 /*break*/, 4];
                    b = _b.value;
                    if (!PieChartBase.by(a, b.itemsSource))
                        return [3 /*break*/, 3];
                    return [4 /*yield*/, b];
                case 2:
                    _d.sent();
                    _d.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_22_1 = _d.sent();
                    e_22 = { error: e_22_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_22)
                            throw e_22.error;
                    }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    XamDoughnutChart.prototype.ay = function (a) {
        var _this = this;
        return toEnum(function () { return _this._ay(a); });
    };
    XamDoughnutChart.prototype.bm = function (source_, a, b) {
        var e_23, _a;
        try {
            for (var _b = __values(fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.cf(a, b);
            }
        }
        catch (e_23_1) {
            e_23 = { error: e_23_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_23)
                    throw e_23.error;
            }
        }
    };
    XamDoughnutChart.prototype.bp = function (source_, a, b, c) {
        var e_24, _a;
        try {
            for (var _b = __values(fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                d.ch(a, b, c);
            }
        }
        catch (e_24_1) {
            e_24 = { error: e_24_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_24)
                    throw e_24.error;
            }
        }
    };
    XamDoughnutChart.prototype.bl = function (source_) {
        var e_25, _a;
        try {
            for (var _b = __values(fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ce();
            }
        }
        catch (e_25_1) {
            e_25 = { error: e_25_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_25)
                    throw e_25.error;
            }
        }
    };
    XamDoughnutChart.prototype.bn = function (source_, a, b) {
        var e_26, _a;
        try {
            for (var _b = __values(fromEnum(this.ay(source_))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.cg(a, b);
            }
        }
        catch (e_26_1) {
            e_26 = { error: e_26_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_26)
                    throw e_26.error;
            }
        }
    };
    XamDoughnutChart.$t = markType(XamDoughnutChart, 'XamDoughnutChart', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type]);
    XamDoughnutChart.cc = DependencyProperty.i("InnerExtent", Number_$type, XamDoughnutChart.$, new PropertyMetadata(2, 40, function (a, b) {
        var c = b.newValue;
        if (c < 0 || c > 100) {
            if (b.oldValue != null) {
                a.a3 = b.oldValue;
            }
            return;
        }
        a.b2();
        a.b1("InnerExtent", b.oldValue, b.newValue);
    }));
    XamDoughnutChart.$$p = markDep(DependencyProperty, PropertyMetadata, XamDoughnutChart, 'b1', ['AllowSliceExplosion:av:b8', [0, true], 'AllowSliceSelection:aw:b9', [0, true], 'CenterData:a5:ca', [4, null], 'CenterDataTemplate:b7:cb', [DataTemplate.$, null], 'IsSurfaceInteractionDisabled:ax:cd', [0, false], 'SelectedStyle:cg:ce', [Style.$, null]]);
    return XamDoughnutChart;
}(Control));
/**
 * @hidden
 */
var ArcView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ArcView, _super);
    function ArcView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b4 = a;
        return _this;
    }
    ArcView.prototype.b6 = function (a, b) {
        this.e.series = this.b4.he.c;
    };
    ArcView.prototype.b5 = function () {
        return this.f;
    };
    ArcView.prototype.b7 = function () {
        this.bb();
        this.bs = new Brush();
        var a = this.c.t();
        this.bs._fill = a.rootWrapper.getStyleProperty("color");
    };
    ArcView.$t = markType(ArcView, 'ArcView', PieChartBaseView.$);
    return ArcView;
}(PieChartBaseView));
/**
 * @hidden
 */
var RingControlView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingControlView, _super);
    function RingControlView(a) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.f = new List$1(Arc.$, 0);
        _this.g = new List$1(Arc.$, 0);
        _this.i = null;
        _this.e = new Dictionary$2(Arc.$, DomRenderer_$type, 0);
        _this.c = null;
        _this.b = a;
        return _this;
    }
    RingControlView.prototype.a = function () {
        var a = new Arc();
        a.o = 0;
        a.n = 0;
        a.he = this.b.ai;
        this.f.add(a);
        this.z(a);
        if (a.eb != this.b.al.b5) {
            a.eb = this.b.al.b5;
        }
        a.cm = this.b.al.a0;
        a.at = this.b.al.am;
        a.di = this.b.al.bg;
        a.ao = this.b.al.aj;
        a.fu = this.b.al.cr;
        a.eg = this.b.al.b9;
        if (this.b.al.toolTip != null) {
            a.c0 = this.b.al.toolTip;
        }
        a.ha = this.b.al.dw;
        a.g6 = this.b.al.dr;
        a.ap = this.b.al.ak;
        a.cn = this.b.al.a1;
        a.co = this.b.al.a2;
        a.aq = this.b.al.al;
        a.dz = this.b.al.bv;
        a.g7 = this.b.al.ds;
        a.legend = this.b.al.legend;
        a.legendItemTemplate = this.b.al.legendItemTemplate;
        a.legendItemBadgeTemplate = this.b.al.legendItemBadgeTemplate;
        a.ah = this.b.al.ah;
        a.gx = this.b.al.dn;
        a.gy = this.b.al.dp;
        a.ct = this.b.al.a4;
        a.ag = this.b.al.ag;
        a.g8 = this.b.al.du;
        a.bv = true;
        a.cr = this.b.al.a3;
        a.bp = this.b.al.at.av;
        a.bq = this.b.al.at.aw;
        a.au = this.b.al.an;
        a.dv = this.b.al.br;
        a.cd = this.b.al.at.a1;
        return a;
    };
    RingControlView.prototype.l = function (a) {
        var b = this.e.item(a).rootWrapper;
        if (b != null) {
            b.show();
        }
        this.g.add(a);
    };
    RingControlView.prototype.n = function (a) {
        var b = this.e.item(a).rootWrapper;
        if (b != null) {
            b.hide();
        }
        this.g.remove(a);
    };
    RingControlView.prototype.m = function (a) {
        this.o(a);
        this.f.remove(a);
    };
    RingControlView.prototype.h = function () {
        return this.f;
    };
    RingControlView.prototype.r = function () {
    };
    RingControlView.prototype.aa = function () {
        this.b.aw();
    };
    RingControlView.prototype.t = function (a, b, c) {
        b = b + this.b.n;
        c = c + this.b.o;
        if (this.c != null) {
            b = b + this.c.n;
            c = c + this.c.o;
        }
        if (a.n != b || a.o != c) {
            a.n = b;
            a.o = c;
            this.u(a, this.e.item(a).rootWrapper);
        }
    };
    RingControlView.prototype.w = function (a) {
        var e_27, _a, e_28, _b;
        if (a == null) {
            this.b.arcs.count = 0;
            try {
                for (var _c = __values(fromEnum(this.f)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.destroy();
                }
            }
            catch (e_27_1) {
                e_27 = { error: e_27_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_27)
                        throw e_27.error;
                }
            }
            this.f.clear();
            this.e.clear();
            this.g.clear();
            return;
        }
        this.i = a;
        this.i.rootWrapper.setStyleProperty("position", "relative");
        try {
            for (var _e = __values(fromEnum(this.f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                var d = this.e.item(c);
                this.i.append(d.rootWrapper);
                c.hc.b7();
            }
        }
        catch (e_28_1) {
            e_28 = { error: e_28_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_28)
                    throw e_28.error;
            }
        }
        this.aa();
    };
    RingControlView.prototype.z = function (a) {
        var b = this.i.createElement("div");
        b.setStyleProperty("position", "absolute");
        this.e.addItem(a, this.i.getSubRenderer(b));
        this.k(a, b);
        this.u(a, b);
        if (this.i != null) {
            this.i.append(b);
        }
        a.provideContainer(this.e.item(a));
        b.setStyleProperty("position", "absolute");
    };
    RingControlView.prototype.k = function (a, b) {
        b.setStyleProperty("width", a.width.toString() + "px");
        b.setStyleProperty("height", a.height.toString() + "px");
    };
    RingControlView.prototype.u = function (a, b) {
        b.setStyleProperty("top", a.o.toString() + "px");
        b.setStyleProperty("left", a.n.toString() + "px");
    };
    RingControlView.prototype.o = function (a) {
        var b = this.e.item(a);
        b.rootWrapper.remove();
        this.e.removeItem(a);
        a.provideContainer(null);
    };
    RingControlView.prototype.ab = function (a) {
        this.k(a, a.hj().rootWrapper);
        a.ew(a.width, a.height);
    };
    RingControlView.prototype.d = function () {
        return this.i != null;
    };
    RingControlView.prototype.q = function () {
    };
    RingControlView.prototype.s = function (a) {
        this.c = a;
        if (a != null) {
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y));
        }
    };
    RingControlView.prototype.y = function (a, b) {
        switch (b.propertyName) {
            case "LabelExtent":
                for (var c = 0; c < this.f.count; c++) {
                    this.f._inner[c].cm = b.newValue;
                }
                break;
            case "LabelMemberPath":
                for (var d = 0; d < this.f.count; d++) {
                    this.f._inner[d].di = b.newValue;
                }
                break;
            case "LabelsPosition":
                for (var e = 0; e < this.f.count; e++) {
                    this.f._inner[e].ao = EnumUtil.getEnumValue(LabelsPosition_$type, b.newValue);
                }
                break;
            case "LabelTemplate":
                for (var f = 0; f < this.f.count; f++) {
                    this.f._inner[f].fu = b.newValue;
                }
                break;
            case "ValueMemberPath":
                for (var g = 0; g < this.f.count; g++) {
                    this.f._inner[g].eg = b.newValue;
                }
                break;
            case "ToolTip":
                for (var h = 0; h < this.f.count; h++) {
                    this.f._inner[h].c0 = b.newValue;
                }
                break;
            case "LeaderLineVisibility":
                for (var i = 0; i < this.f.count; i++) {
                    this.f._inner[i].ha = EnumUtil.getEnumValue(Visibility_$type, b.newValue);
                }
                break;
            case "LeaderLineStyle":
                for (var j = 0; j < this.f.count; j++) {
                    this.f._inner[j].g6 = b.newValue;
                }
                break;
            case "LeaderLineType":
                for (var k = 0; k < this.f.count; k++) {
                    this.f._inner[k].ap = EnumUtil.getEnumValue(LeaderLineType_$type, b.newValue);
                }
                break;
            case "LeaderLineMargin":
                for (var l = 0; l < this.f.count; l++) {
                    this.f._inner[l].cn = b.newValue;
                }
                break;
            case "OthersCategoryThreshold":
                for (var m = 0; m < this.f.count; m++) {
                    this.f._inner[m].co = b.newValue;
                }
                break;
            case "OthersCategoryType":
                for (var n = 0; n < this.f.count; n++) {
                    this.f._inner[n].aq = EnumUtil.getEnumValue(OthersCategoryType_$type, b.newValue);
                }
                break;
            case "OthersCategoryText":
                for (var o = 0; o < this.f.count; o++) {
                    this.f._inner[o].dz = b.newValue;
                }
                break;
            case "OthersCategoryStyle":
                for (var p = 0; p < this.f.count; p++) {
                    this.f._inner[p].g7 = b.newValue;
                }
                break;
            case "Legend":
                for (var q = 0; q < this.f.count; q++) {
                    this.f._inner[q].legend = b.newValue;
                }
                break;
            case "LegendItemTemplate":
                for (var r = 0; r < this.f.count; r++) {
                    this.f._inner[r].legendItemTemplate = b.newValue;
                }
                break;
            case "LegendItemBadgeTemplate":
                for (var s = 0; s < this.f.count; s++) {
                    this.f._inner[s].legendItemBadgeTemplate = b.newValue;
                }
                break;
            case "Outlines":
                for (var t = 0; t < this.f.count; t++) {
                    this.f._inner[t].ah = b.newValue;
                }
                break;
            case "Brushes":
                for (var u = 0; u < this.f.count; u++) {
                    this.f._inner[u].ag = b.newValue;
                }
                break;
            case "SelectedStyle":
                for (var v = 0; v < this.f.count; v++) {
                    this.f._inner[v].g8 = b.newValue;
                }
                break;
            case "SelectedStyleResolved":
                for (var w = 0; w < this.f.count; w++) {
                    this.f._inner[w].g8 = b.newValue;
                }
                break;
            case "RadiusFactor":
                for (var x = 0; x < this.f.count; x++) {
                    this.f._inner[x].cr = b.newValue;
                }
                break;
        }
    };
    RingControlView.prototype.p = function () {
        var e_29, _a;
        try {
            for (var _b = __values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.el();
            }
        }
        catch (e_29_1) {
            e_29 = { error: e_29_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_29)
                    throw e_29.error;
            }
        }
    };
    RingControlView.prototype.j = function () {
        return this.i;
    };
    RingControlView.prototype.v = function (a, b) {
        this.b.n = a;
        this.b.o = b;
        this.x();
    };
    RingControlView.prototype.x = function () {
        for (var a = 0; a < this.f.count; a++) {
            var b = this.f._inner[a];
            this.t(b, 0, 0);
        }
    };
    RingControlView.$t = markType(RingControlView, 'RingControlView');
    return RingControlView;
}(Base));
/**
 * @hidden
 */
var RingSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeriesBaseView, _super);
    function RingSeriesBaseView(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.f = null;
        _this.g = null;
        _this.a = null;
        _this.b = null;
        _this.o = null;
        _this.d = null;
        _this.f = new List$1(RingControl.$, 0);
        _this.c = a;
        return _this;
    }
    RingSeriesBaseView.prototype.k = function () {
        this.c.legendItemTemplate = ((function () {
            var $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.c;
            $ret.measure = PieLegendTemplates.a;
            return $ret;
        })());
        this.c.legendItemBadgeTemplate = ((function () {
            var $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.b;
            $ret.measure = PieLegendTemplates.d;
            return $ret;
        })());
    };
    RingSeriesBaseView.prototype.h = function (a) {
        if (!this.f.contains(a)) {
            this.f.add(a);
        }
        if (this.g != null && (a.ap() != this.g)) {
            a.ay(this.g);
        }
    };
    RingSeriesBaseView.prototype.j = function (a, b, c, d, e) {
        var f = BrushUtil.e("chart", a, b, c);
        b = f.p2;
        c = f.p3;
        var g = new Array(b.count * 2);
        for (var h = 0; h < g.length; h += 2) {
            g[h] = "#fff";
            g[h + 1] = b.item(intDivide(h, 2))._fill;
        }
        var i = BrushUtil.e("doughnut", a, b, c, g);
        b = i.p2;
        c = i.p3;
        d = new Brush();
        d._fill = this.g.rootWrapper.getStyleProperty("color");
        e = FontUtil.getFont(a);
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    };
    RingSeriesBaseView.prototype.n = function (a) {
        var e_30, _a, e_31, _b;
        if (a == null) {
            try {
                for (var _c = __values(fromEnum(this.f)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    b.ay(null);
                }
            }
            catch (e_30_1) {
                e_30 = { error: e_30_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_30)
                        throw e_30.error;
                }
            }
            return;
        }
        this.g = a;
        var c;
        var d;
        var e;
        var f;
        var g = this.j(this.g, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        this.a = c;
        this.b = d;
        this.o = e;
        this.d = f;
        if (this.c.ag == null) {
            this.c.ag = this.a;
        }
        if (this.c.ah == null) {
            this.c.ah = this.b;
        }
        try {
            for (var _e = __values(fromEnum(this.f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var h = _f.value;
                h.ay(this.g);
            }
        }
        catch (e_31_1) {
            e_31 = { error: e_31_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_31)
                    throw e_31.error;
            }
        }
    };
    RingSeriesBaseView.prototype.e = function () {
        return true;
    };
    RingSeriesBaseView.prototype.i = function () {
        this.n(null);
    };
    RingSeriesBaseView.prototype.l = function () {
        for (var a = 0; a < this.f.count; a++) {
            var b = this.f._inner[a];
            for (var c = 0; c < b.arcs.a.count; c++) {
                var d = b.arcs.a._inner[c];
                d.el();
            }
        }
    };
    RingSeriesBaseView.prototype.m = function (a, b) {
        this.c.n = a;
        this.c.o = b;
        this.c.dq = { $type: Point_$type, x: a, y: b };
    };
    RingSeriesBaseView.$t = markType(RingSeriesBaseView, 'RingSeriesBaseView');
    return RingSeriesBaseView;
}(Base));
/**
 * @hidden
 */
var XamDoughnutChartView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamDoughnutChartView, _super);
    function XamDoughnutChartView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.aa = null;
        _this.d = 0;
        _this.c = null;
        _this.ab = null;
        _this.f = null;
        _this.e = null;
        _this.b = null;
        _this.ab = Rect.empty;
        _this.aa = { $type: Point_$type, x: 0, y: 0 };
        _this.d = 0;
        _this.c = new List$1(RingSeriesBase.$, 0);
        _this.a = a;
        return _this;
    }
    XamDoughnutChartView.prototype.s = function () {
        this.p();
    };
    XamDoughnutChartView.prototype.z = function () {
    };
    XamDoughnutChartView.prototype.h = function (a) {
        if (!this.c.contains(a)) {
            a.cm(this.e);
            this.c.add(a);
        }
    };
    XamDoughnutChartView.prototype.w = function (a) {
        if (this.c.contains(a)) {
            a.cm(null);
            this.c.remove(a);
        }
    };
    XamDoughnutChartView.prototype.i = function () {
    };
    XamDoughnutChartView.prototype.y = function () {
        if (this.e == null) {
            return;
        }
        this.p();
        var a = this.e.rootWrapper.width();
        var b = this.e.rootWrapper.height();
        this.ab = new Rect(0, 0, 0, a, b);
        if (this.b != null) {
            this.b.bf = this.ab;
        }
        this.a.bt();
    };
    XamDoughnutChartView.prototype.v = function (a) {
        if (a == null) {
            if (this.b != null) {
                this.b.aq();
            }
            return;
        }
        var b = a;
        this.e = b;
        var c = this.e.rootWrapper.width();
        var d = this.e.rootWrapper.height();
        this.ab = new Rect(0, 0, 0, c, d);
        this.b = new DOMEventProxy(this.e.rootWrapper, this.e, false);
        this.b.bf = this.ab;
        var e = this.b;
        e.onMouseOver = delegateCombine(e.onMouseOver, runOn(this, this.m));
        var f = this.b;
        f.onMouseLeave = delegateCombine(f.onMouseLeave, runOn(this, this.l));
        var g = this.b;
        g.onMouseDown = delegateCombine(g.onMouseDown, runOn(this, this.k));
        var h = this.b;
        h.onMouseUp = delegateCombine(h.onMouseUp, runOn(this, this.n));
        this.y();
    };
    XamDoughnutChartView.prototype.t = function (a, b, c) {
        for (var d = this.c.count - 1; d >= 0; d--) {
            var e = this.c._inner[d];
            if (e.ay) {
                continue;
            }
            var f = e.as.f;
            for (var g = 0; g < f.count; g++) {
                var h = f._inner[g];
                var i = h.arcs.a;
                for (var j = 0; j < i.count; j++) {
                    var k = i._inner[j];
                    var l = { $type: Point_$type, x: a.x - k.n, y: a.y - k.o };
                    b(k.as, l);
                    if (c == "mouseUp") {
                        var m = k.hc.b5();
                        if (m != null) {
                            return;
                        }
                    }
                }
            }
        }
    };
    XamDoughnutChartView.prototype.n = function (a) {
        this.t(a, function (b, c) { return b.ak(c); }, "mouseUp");
    };
    XamDoughnutChartView.prototype.k = function (a) {
        this.t(a, function (b, c) { return b.ah(c); }, "mouseDown");
    };
    XamDoughnutChartView.prototype.l = function (a) {
        this.t(a, function (b, c) { return b.ai(c); }, "mouseLeave");
    };
    XamDoughnutChartView.prototype.m = function (a, b, c) {
        this.t(a, function (d, e) { return d.aj(e, b, c); }, "mouseOver");
    };
    XamDoughnutChartView.prototype.g = function () {
        return this.e.rootWrapper.getAttribute("id");
    };
    XamDoughnutChartView.prototype.u = function (a, b) {
        if (!this.ab.isEmpty && this.ab.width != 0 && this.ab.height != 0) {
            var c = this.aa.x;
            var d = this.aa.y;
            this.aa.x = this.ab.width / 2;
            this.aa.y = this.ab.height / 2;
            if (this.aa.x != c || this.aa.y != d) {
                this.a.bs();
            }
        }
    };
    XamDoughnutChartView.prototype.x = function (a, b) {
        var c = this.d;
        this.d = a / 2;
        if (c != this.d) {
            this.a.bs();
        }
    };
    XamDoughnutChartView.prototype.j = function () {
    };
    XamDoughnutChartView.prototype.o = function (a) {
        a.width = this.a.width;
        a.height = this.a.height;
        a.holeRadius = this.a.a2();
        for (var b = 0; b < this.a.series.count; b++) {
            a.series.add(new RingSeriesVisualData());
            a.series._inner[b].rings = new RingVisualDataList();
            a.series._inner[b].name = this.a.series._inner[b].name;
            a.series._inner[b].labelExtent = this.a.series._inner[b].a0;
            a.series._inner[b].leaderLineMargin = this.a.series._inner[b].a1;
            a.series._inner[b].leaderLineType = EnumUtil.getName(LeaderLineType_$type, this.a.series._inner[b].ak);
            a.series._inner[b].labelsPosition = EnumUtil.getName(LabelsPosition_$type, this.a.series._inner[b].aj);
            a.series._inner[b].leaderLineVisibility = this.a.series._inner[b].dw == 0;
            for (var c = 0; c < this.a.series._inner[b].aq().count; c++) {
                a.series._inner[b].rings.add(new RingVisualData());
                a.series._inner[b].rings._inner[c].arcs = new ArcVisualDataList();
                for (var d = 0; d < this.a.series._inner[b].aq()._inner[c].g.count; d++) {
                    a.series._inner[b].rings._inner[c].arcs.add(new ArcVisualData());
                    a.series._inner[b].rings._inner[c].arcs._inner[d].a = new SliceVisualDataList();
                    var _loop_4 = function (e) {
                        if (null == this_4.a.series._inner[b].aq()._inner[c].g._inner[d].g._inner[e].b) {
                            return "continue";
                        }
                        a.series._inner[b].rings._inner[c].arcs._inner[d].a.add(new SliceVisualData());
                        var f = new SliceVisualData();
                        var g = this_4.a.series._inner[b].aq()._inner[c].g._inner[d].g._inner[e].b;
                        f.visibility = g._visibility == 0;
                        f.endAngle = g.ax;
                        f.startAngle = g.a3;
                        f.radius = g.a2;
                        f.origin = PointData.b(g.b7);
                        f.explodedOrigin = PointData.b(g.b5);
                        f.index = g.a5;
                        f.isExploded = g.isExploded;
                        f.isSelected = g.isSelected;
                        f.outline = AppearanceHelper.a(g.b1);
                        f.backgroundPath = new PathVisualData(1, "slicePath", g.al.f());
                        a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e] = f;
                        var h = g.aj;
                        if (null != h) {
                            a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData = ((function () {
                                var $ret = new DoughnutChartLabelVisualData();
                                $ret.labelSize = SizeData.b(RectUtil.z(h.ao));
                                $ret.labelValue = h.aj.ak;
                                return $ret;
                            })());
                            if (!isNaN_(h.n) && !isNaN_(h.o)) {
                                a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData.labelPosition = new PointData(h.n, h.o);
                            }
                        }
                    };
                    var this_4 = this;
                    for (var e = 0; e < this.a.series._inner[b].aq()._inner[c].g._inner[d].g.count; e++) {
                        _loop_4(e);
                    }
                }
            }
        }
    };
    XamDoughnutChartView.prototype.p = function () {
        var a = this.a.a4;
        var b = this.a.a1;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.a.a1 = window.devicePixelRatio;
        }
    };
    XamDoughnutChartView.prototype.r = function () {
        if (this.b != null) {
            this.b.bb(this.e.rootWrapper, "");
        }
    };
    XamDoughnutChartView.prototype.q = function () {
        this.p();
        if (this.b != null) {
            this.b.ap(this.e.rootWrapper, "");
        }
    };
    XamDoughnutChartView.$t = markType(XamDoughnutChartView, 'XamDoughnutChartView');
    return XamDoughnutChartView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents data for Ring.RingControl element.
*/
var IgrRing = /** @class */ /*@__PURE__*/ (function () {
    function IgrRing() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrRing.prototype.createImplementation = function () {
        return new Ring();
    };
    Object.defineProperty(IgrRing.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrRing.prototype.onImplementationCreated = function () {
    };
    IgrRing.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrRing.prototype, "index", {
        /**
         * Gets the index of ring in the chart.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRing.prototype, "innerExtend", {
        /**
         * Gets the inner extend of the ring in percentage.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRing.prototype, "controlSize", {
        /**
         * Gets the size of the ring.
        */
        get: function () {
            return fromSize(this.i.q);
        },
        set: function (v) {
            this.i.q = toSize(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRing.prototype, "center", {
        /**
         * Gets the center point of the ring.
        */
        get: function () {
            return fromPoint(this.i.p);
        },
        set: function (v) {
            this.i.p = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRing.prototype, "ringSeries", {
        /**
         * Gets reference to ring series.
        */
        get: function () {
            if (this.i.c == null) {
                return null;
            }
            if (!this.i.c.externalObject) {
                var e = IgrRingSeriesBase._createFromInternal(this.i.c);
                if (e) {
                    e._implementation = this.i.c;
                }
                this.i.c.externalObject = e;
            }
            return this.i.c.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRing.prototype, "ringBreadth", {
        /**
         * Gets the ring breadth.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Renders the arcs.
    
    */
    IgrRing.prototype.renderArcs = function () {
        var iv = this.i.f();
        return (iv);
    };
    /**
     * Prepares data needed to create Arcs.
    
    */
    IgrRing.prototype.prepareArcs = function () {
        this.i.o();
    };
    return IgrRing;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RingSeries, _super);
    function RingSeries() {
        var _this = _super.call(this) || this;
        _this.dx = null;
        _this.dx = ((function () {
            var $ret = new Ring();
            $ret.c = _this;
            $ret.e = false;
            return $ret;
        })());
        var a = ((function () {
            var $ret = new ArcItem();
            $ret.k = _this.a4;
            $ret.d = _this.dx;
            $ret.n = _this.b9;
            $ret.c = _this.al;
            $ret.j = _this.a2;
            return $ret;
        })());
        _this.dx.g.add(a);
        _this.ab = RingSeries.$;
        return _this;
    }
    RingSeries.prototype.cl = function (a, b, c, d) {
        _super.prototype.cl.call(this, a, b, c, d);
        if (b == RingSeriesBase.$$p[2]) {
            for (var e = 0; e < this.dx.ringControl.arcs.count; e++) {
                this.dx.ringControl.arcs.item(e).at = d;
            }
        }
        if (b == RingSeriesBase.$$p[3]) {
            for (var f = 0; f < this.dx.ringControl.arcs.count; f++) {
                this.dx.ringControl.arcs.item(f).au = d;
            }
        }
        if (b == RingSeriesBase.$$p[16]) {
            for (var g = 0; g < this.dx.ringControl.arcs.count; g++) {
                this.dx.ringControl.arcs.item(g).dv = this.br;
            }
        }
        if (b == RingSeriesBase.$$p[0]) {
            this.cj();
        }
        if (b == RingSeriesBase.$$p[25]) {
            if (this.dx.g != null && this.dx.g.count > 0) {
                this.dx.g._inner[0].k = this.a4;
            }
        }
        if (b == RingSeriesBase.$$p[28]) {
            if (this.dx.g != null && this.dx.g.count > 0) {
                this.dx.g._inner[0].n = this.b9;
                this.ck();
            }
        }
        if (this.dx != null && this.as.e()) {
            this.dx.o();
            if (this.dx.f()) {
                this.dx.c.as.l();
            }
        }
    };
    RingSeries.prototype.aq = function () {
        var a = new RingCollection();
        if (this.dx.g._inner[0].g.count > 0) {
            a.add(this.dx);
        }
        return a;
    };
    RingSeries.prototype.ck = function () {
        if (this.dx != null) {
            this.dx.g._inner[0].h = this.itemsSource;
            this.dx.g._inner[0].p(this.a4);
            if (this.at != null) {
                this.at.bx();
                this.at.b2();
            }
        }
    };
    RingSeries.prototype.cj = function () {
        if (this.dx != null) {
            this.dx.g._inner[0].a = this.ag;
        }
    };
    RingSeries.prototype.cp = function () {
        if (this.dx != null) {
            this.width = this.dx.q.width;
            this.height = this.dx.q.height;
            this.as.m(this.dx.p.x, this.dx.p.y);
        }
    };
    RingSeries.prototype.co = function () {
        var e_1, _a;
        if (this.dx != null) {
            try {
                for (var _b = __values(fromEnum(this.dx.ringControl.arcs.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.fg();
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    RingSeries.prototype.cf = function (a, b) {
        _super.prototype.cf.call(this, a, b);
        if (this.dx != null) {
            this.dx.l(this.itemsSource, a, b);
        }
    };
    RingSeries.prototype.ce = function () {
        _super.prototype.ce.call(this);
        if (this.dx != null) {
            this.dx.k(this.itemsSource);
        }
    };
    RingSeries.prototype.cg = function (a, b) {
        _super.prototype.cg.call(this, a, b);
        if (this.dx != null) {
            this.dx.m(this.itemsSource, a, b);
        }
    };
    RingSeries.prototype.ch = function (a, b, c) {
        _super.prototype.ch.call(this, a, b, c);
        if (this.dx != null) {
            this.dx.n(this.itemsSource, a, b, c);
        }
    };
    RingSeries.$t = markType(RingSeries, 'RingSeries', RingSeriesBase.$);
    return RingSeries;
}(RingSeriesBase));

var IgrIndexCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrIndexCollection, _super);
    function IgrIndexCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrIndexCollection.prototype._ensureOuter = function (item) {
        return +item;
    };
    IgrIndexCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(Number_$type, Number_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrIndexCollection;
}(IgCollection));

/**
 * Represents one ring in IgxDoughnutChartComponent series.
*/
var IgrRingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRingSeries, _super);
    function IgrRingSeries(props) {
        var _this = _super.call(this, props) || this;
        _this._explodedSlices = null;
        _this._selectedSlices = null;
        return _this;
    }
    IgrRingSeries.prototype.createImplementation = function () {
        return new RingSeries();
    };
    Object.defineProperty(IgrRingSeries.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeries.prototype, "explodedSlices", {
        /**
         * Gets or sets the collection of exploded slice indices.
        */
        get: function () {
            if (this._explodedSlices === null) {
                var coll = new IgrIndexCollection();
                var innerColl = void 0;
                if (this.ring.i.ringControl.arcs.count == 0) {
                    innerColl = new IndexCollection();
                }
                else {
                    innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                }
                this._explodedSlices = coll._fromInner(innerColl);
            }
            return this._explodedSlices;
        },
        set: function (v) {
            if (this._explodedSlices !== null) {
                this._explodedSlices._setSyncTarget(null);
                this._explodedSlices = null;
            }
            var coll = new IgrIndexCollection();
            this._explodedSlices = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Number_$type);
            var innerColl;
            if (this.ring.i.ringControl.arcs.count == 0) {
                innerColl = new IndexCollection();
            }
            else {
                innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._explodedSlices._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRingSeries.prototype, "selectedSlices", {
        /**
         * Gets or sets the collection of selected slice indices.
        */
        get: function () {
            if (this._selectedSlices === null) {
                var coll = new IgrIndexCollection();
                var innerColl = void 0;
                if (this.ring.i.ringControl.arcs.count == 0) {
                    innerColl = new IndexCollection();
                }
                else {
                    innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                }
                this._selectedSlices = coll._fromInner(innerColl);
            }
            return this._selectedSlices;
        },
        set: function (v) {
            if (this._selectedSlices !== null) {
                this._selectedSlices._setSyncTarget(null);
                this._selectedSlices = null;
            }
            var coll = new IgrIndexCollection();
            this._selectedSlices = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Number_$type);
            var innerColl;
            if (this.ring.i.ringControl.arcs.count == 0) {
                innerColl = new IndexCollection();
            }
            else {
                innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedSlices._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    IgrRingSeries.prototype.sychronizeCollections = function () {
        if (this._explodedSlices) {
            var inner = this._explodedSlices._inner;
            if (inner && inner !== this.ring.i.ringControl.arcs.item(0).explodedSlices) {
                this._explodedSlices._inner = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                for (var i = 0; i < inner.count; i++) {
                    this._explodedSlices.add(inner.item(i));
                }
            }
        }
        if (this._selectedSlices) {
            var inner = this._selectedSlices._inner;
            if (inner && inner !== this.ring.i.ringControl.arcs.item(0).selectedSlices) {
                this._selectedSlices._inner = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                for (var i = 0; i < inner.count; i++) {
                    this._selectedSlices.add(inner.item(i));
                }
            }
        }
    };
    Object.defineProperty(IgrRingSeries.prototype, "ring", {
        /**
     * Gets reference to the ring data.
    */
        get: function () {
            if (this.i.dx == null) {
                return null;
            }
            if (!this.i.dx.externalObject) {
                var e = new IgrRing();
                e._implementation = this.i.dx;
                this.i.dx.externalObject = e;
            }
            return this.i.dx.externalObject;
        },
        set: function (v) {
            v == null ? this.i.dx = null : this.i.dx = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrRingSeries;
}(IgrRingSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRingSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRingSeriesModule() {
    }
    IgrRingSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrRingSeries", IgrRingSeries);
        TypeRegistrar.register("RingSeries", RingSeries.$type);
    };
    return IgrRingSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Contains PieChart click event data.
*/
var IgrSliceClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSliceClickEventArgs() {
    }
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrSliceClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSliceClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "isSelected", {
        /**
         * Gets or sets whether the slice is selected.
        */
        get: function () {
            return this.i.isSelected;
        },
        set: function (v) {
            this.i.isSelected = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "isExploded", {
        /**
         * Gets or sets whether the slice is exploded.
        */
        get: function () {
            return this.i.isExploded;
        },
        set: function (v) {
            this.i.isExploded = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "isOthersSlice", {
        /**
         * Gets whether the current slice is part of the others slice.
        */
        get: function () {
            return this.i.isOthersSlice;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "dataContext", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.dataContext;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSliceClickEventArgs.prototype, "originalEvent", {
        /**
         * Holds a reference to the original event that triggered slice click.
        */
        get: function () {
            return this.i.originalEvent;
        },
        set: function (v) {
            this.i.originalEvent = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSliceClickEventArgs;
}());

/**
 * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
*/
var IgrHoleDimensionsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrHoleDimensionsChangedEventArgs() {
    }
    Object.defineProperty(IgrHoleDimensionsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrHoleDimensionsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrHoleDimensionsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrHoleDimensionsChangedEventArgs.prototype, "center", {
        /**
         * The center point of the hole.
        */
        get: function () {
            return fromPoint(this.i.center);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHoleDimensionsChangedEventArgs.prototype, "radius", {
        /**
         * The radius of the hole.
        */
        get: function () {
            return this.i.radius;
        },
        enumerable: true,
        configurable: true
    });
    return IgrHoleDimensionsChangedEventArgs;
}());

var IgrRingSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRingSeriesCollection, _super);
    function IgrRingSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrRingSeriesBase.$type) {
            IgrRingSeriesBase.$type = markType(IgrRingSeriesBase, "IgrRingSeriesBase");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrRingSeriesCollection.prototype._createInnerColl = function () {
        if (!IgrRingSeriesBase.$type) {
            IgrRingSeriesBase.$type = markType(IgrRingSeriesBase, "IgrRingSeriesBase");
        }
        var coll = new SyncableObservableCollection$2(IgrRingSeriesBase.$type, RingSeriesBase.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrRingSeriesBase._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrRingSeriesCollection;
}(IgCollection));

/**
 * Represents concentric circles divided on arcs  depending on data.
*/
var IgrDoughnutChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDoughnutChart, _super);
    function IgrDoughnutChart(props) {
        var _this = _super.call(this, props) || this;
        _this._contentChildren = null;
        _this._contentChildrenActual = null;
        _this._contentChildrenMap = null;
        _this._contentChildrenUnresolved = 0;
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        _this.actualSeries = [];
        _this._seriesAdapter = null;
        _this._series = null;
        _this._defaultTooltips = null;
        _this._uniqueTooltipId = 0;
        _this._initialized = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._sliceClick = null;
        _this._sliceClick_wrapped = null;
        _this._holeDimensionsChanged = null;
        _this._holeDimensionsChanged_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._tooltipRef = _this._tooltipRef.bind(_this);
        _this._activeTooltipElements = new Map();
        _this._activeTooltips = new Map();
        _this._currentTooltips = [];
        _this._contentChildrenManager = new ContentChildrenManager(function (ch) { return ch.key || ch.props.name; }, function (ch) { return ch.key || ch.props.name; }, function () { return _this._updateContentChildren(); });
        var container = null;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        _this._renderer = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this.container = _this._renderer.getWrapper(container);
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        _this._wrapper = _this._renderer;
        var chart = _this.i;
        _this._chart = chart;
        chart.provideContainer(_this._renderer);
        _this._renderer.addSizeWatcher(function () {
            _this._chart.notifyResized();
        });
        return _this;
    }
    Object.defineProperty(IgrDoughnutChart.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.width = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype._updateContentChildren = function () {
        this.contentSeries = [];
        var contentChildrenActual = this._contentChildrenManager.contentChildrenActual;
        for (var i = 0; i < contentChildrenActual.length; i++) {
            if ((RingSeriesBase.$type).isAssignableFrom(contentChildrenActual[i].i.$type)) {
                this.contentSeries.push(contentChildrenActual[i]);
            }
        }
        if (this._seriesAdapter !== null) {
            this._seriesAdapter.notifyContentChanged();
        }
    };
    IgrDoughnutChart.prototype._tooltipRef = function (t) {
        //console.log(t);
        if (t === null) {
            return;
        }
        if (t.currentOwner &&
            t.currentOwner.tooltipTemplate) {
            t.template = t.currentOwner.tooltipTemplate;
        }
        this._activeTooltips.set(t.currentOwner, t);
    };
    IgrDoughnutChart.prototype.render = function () {
        // if (!this._childrenDiffer(this.props.children)) {
        // 	let div = React.createElement("div", {
        // 		ref: (ref) => {
        // 			this._elRef = ref;
        // 		},
        // 		children: this.props.children
        // 	});
        // 	return div;
        // } else {
        var children = this._contentChildrenManager.getChildren(this.props.children);
        if (this._currentTooltips && this._currentTooltips.length > 0) {
            for (var i = 0; i < this._currentTooltips.length; i++) {
                var t = this._currentTooltips[i];
                if (this._activeTooltipElements.has(t)) {
                    children.push(this._activeTooltipElements.get(t));
                }
                else {
                    if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
                        continue;
                    }
                    var Tooltip = TypeRegistrar.get("IgrTooltipContainer");
                    var tEle = createElement(Tooltip, {
                        ref: this._tooltipRef,
                        key: this._currentTooltips[i].key,
                        owner: this._currentTooltips[i]
                    });
                    var portal = createPortal(tEle, t, this._currentTooltips[i].key);
                    this._activeTooltipElements.set(t, portal);
                    children.push(portal);
                }
            }
        }
        var div = createElement("div", {
            className: "ig-doughnut-chart igr-doughnut-chart",
            ref: this._getMainRef,
            children: children
        });
        return div;
        //}
    };
    IgrDoughnutChart.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    {
                        this[p] = this.props[p];
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this.container.getNativeElement());
        this._chart.notifyResized();
        this.initializeContent();
    };
    IgrDoughnutChart.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrDoughnutChart.prototype._getMainRef = function (div) {
        this._elRef = div;
    };
    IgrDoughnutChart.prototype.destroy = function () {
        this._chart.destroy();
        this._wrapper.destroy();
    };
    IgrDoughnutChart.prototype.initializeContent = function () {
        var _this = this;
        this._updateContentChildren();
        this._seriesAdapter = new CollectionAdapter(this.contentSeries, this.i.series, this.actualSeries, function (c) { return c.i; }, function (i) {
            i.owner = _this;
            // (<any>i)._provideRenderer(this._dataSource);
            if (_this.container && _this.container.getNativeElement().parentElement) {
                i._styling(_this.container.getNativeElement(), _this, _this);
            }
            _this._ensureDefaultTooltip(i);
            _this._ensureTooltipCreated(i);
            //(<any>i)._provideRenderer(this._wrapper); 
        }, function (i) {
            //(<any>i)._provideRenderer(null);
        });
        this._styling(this.container.getNativeElement(), this);
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i]._styling(this.container.getNativeElement(), this, this);
            }
        }
        this.i.notifyResized();
    };
    IgrDoughnutChart.prototype.componentWillUnmount = function () {
        //this._grid.destroy();
        this.destroy();
    };
    IgrDoughnutChart.prototype.onImplementationCreated = function () {
    };
    IgrDoughnutChart.prototype.createImplementation = function () {
        return new XamDoughnutChart();
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype.createSeriesComponent = function (type) {
        if (TypeRegistrar.isRegistered(type)) {
            var s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this._wrapper);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "series", {
        /**
         * A collection or manually added series for the chart.
        */
        get: function () {
            var _this = this;
            if (this._series === null) {
                var coll = new IgrRingSeriesCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._seriesAdapter.addManualItem(e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._seriesAdapter.clearManualItems();
                            break;
                    }
                });
                this._series = coll;
            }
            return this._series;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype._ensureTooltipCreated = function (series) {
        if (series.i.toolTip == null) {
            var tooltip = this.createTooltip();
            var ele = tooltip;
            if (tooltip == null) {
                return;
            }
            series._tooltipContent = tooltip;
            //(<any>tooltip.instance).template = this._tooltipTemplate;
            series.i.toolTip = this.createWrapper(tooltip);
            if (this._activeTooltips.has(ele)) {
                var tCont = this._activeTooltips.get(ele);
                tCont.template = ele.tooltipTemplate;
            }
        }
    };
    IgrDoughnutChart.prototype.createWrapper = function (ele) {
        var wrapper = new ReactWrapper(ele, this._wrapper);
        wrapper.updateToolTip = ele.updateToolTip;
        wrapper.hideToolTip = ele.hideToolTip;
        if (this._activeTooltips.has(ele)) {
            var tCont = this._activeTooltips.get(ele);
            tCont.template = ele.tooltipTemplate;
        }
        return wrapper;
    };
    IgrDoughnutChart.prototype._ensureDefaultTooltip = function (series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](series);
    };
    IgrDoughnutChart.prototype._onDefaultTooltipsReady = function (cr) {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                if (currSeries[i].showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries[i]);
                }
            }
        }
    };
    IgrDoughnutChart.prototype.createTooltip = function () {
        var wrapper = this._wrapper.createElement("div");
        var ele = wrapper.getNativeElement();
        ele.key = "__tooltip_" + this._uniqueTooltipId;
        this._uniqueTooltipId++;
        this._currentTooltips = this._currentTooltips.slice(0);
        this._currentTooltips.push(ele);
        //let element = React.createElement(Tooltip,  );
        //let portal = ReactDOM.createPortal(element, ele);
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgrDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self.container.getNativeElement()) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self.container.getNativeElement().appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            if (self._activeTooltips.has(ele)) {
                var t = self._activeTooltips.get(ele);
                if (t.template === null &&
                    ele.tooltipTemplate !== null) {
                    t.template = ele.tooltipTemplate;
                }
                t.dataContext = c;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        this._updateTooltipState();
        return ele;
    };
    IgrDoughnutChart.prototype._updateTooltipState = function () {
        if (this._initialized) {
            this.setState({ tooltips: this._currentTooltips });
        }
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "allowSliceSelection", {
        /**
     * Gets or sets whether the slices can be selected.
    */
        get: function () {
            return this.i.aw;
        },
        set: function (v) {
            this.i.aw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "allowSliceExplosion", {
        /**
         * Gets or sets whether the slices can be exploded.
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "innerExtent", {
        /**
         * Gets or sets the inner extent of the doughnut chart. It is percent from the outer ring's radius.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.cg ? this.i.cg.fill : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.cg.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.cg ? this.i.cg.stroke : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.cg.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.cg ? this.i.cg.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.cg.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "selectedSliceOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.cg ? this.i.cg.opacity : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.cg.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype.ensureSelectedStyle = function () {
        if (this.i.cg) {
            return;
        }
        this.i.cg = new Style();
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "actualPixelScalingRatio", {
        /**
         * Resolved pixel scaling ratio. Unless explicitly overridden by the IgxDoughnutChart.PixelScalingRatioComponent property,
         * this one returns the default ratio enforced by device. High resolution devices will initialize this property
         * to a higher value.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrDoughnutChart.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrDoughnutChart.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DoughnutChart");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    IgrDoughnutChart.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Called when the control has been resized.
    
    */
    IgrDoughnutChart.prototype.notifyResized = function () {
        this.i.notifyResized();
    };
    /**
     * Gets the ID of the UI container.
    
    */
    IgrDoughnutChart.prototype.getContainerID = function () {
        var iv = this.i.bd();
        return (iv);
    };
    /**
     * Gets the center coordinates of the doughnut chart's center presenter.
    
    */
    IgrDoughnutChart.prototype.getCenterCoordinates = function () {
        var iv = this.i.cf();
        return fromPoint(iv);
    };
    /**
     * Gets the hole radius of the doughnut chart's center presenter.
    
    */
    IgrDoughnutChart.prototype.getHoleRadius = function () {
        var iv = this.i.a2();
        return (iv);
    };
    /**
     * Use to force the doughnut chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the doughnut chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the doughnut chart.
    
    */
    IgrDoughnutChart.prototype.flush = function () {
        this.i.bk();
    };
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    IgrDoughnutChart.prototype.exportSerializedVisualData = function () {
        var iv = this.i.bc();
        return (iv);
    };
    IgrDoughnutChart.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.bm(source_, index, newItem);
    };
    IgrDoughnutChart.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.bp(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    */
    IgrDoughnutChart.prototype.notifyClearItems = function (source_) {
        this.i.bl(source_);
    };
    IgrDoughnutChart.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.bn(source_, index, oldItem);
    };
    Object.defineProperty(IgrDoughnutChart.prototype, "sliceClick", {
        /**
         * Raised when the slice is clicked.
        */
        get: function () {
            return this._sliceClick;
        },
        set: function (ev) {
            var _this = this;
            if (this._sliceClick_wrapped !== null) {
                this.i.sliceClick = delegateRemove(this.i.sliceClick, this._sliceClick_wrapped);
                this._sliceClick_wrapped = null;
                this._sliceClick = null;
            }
            this._sliceClick = ev;
            this._sliceClick_wrapped = function (o, e) {
                var outerArgs = new IgrSliceClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSliceClick) {
                    _this.beforeSliceClick(_this, outerArgs);
                }
                if (_this._sliceClick) {
                    _this._sliceClick(_this, outerArgs);
                }
            };
            this.i.sliceClick = delegateCombine(this.i.sliceClick, this._sliceClick_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDoughnutChart.prototype, "holeDimensionsChanged", {
        /**
         * Raised when the dimensions (center point or radius) of the doughnut hole change.
        */
        get: function () {
            return this._holeDimensionsChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._holeDimensionsChanged_wrapped !== null) {
                this.i.holeDimensionsChanged = delegateRemove(this.i.holeDimensionsChanged, this._holeDimensionsChanged_wrapped);
                this._holeDimensionsChanged_wrapped = null;
                this._holeDimensionsChanged = null;
            }
            this._holeDimensionsChanged = ev;
            this._holeDimensionsChanged_wrapped = function (o, e) {
                var outerArgs = new IgrHoleDimensionsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeHoleDimensionsChanged) {
                    _this.beforeHoleDimensionsChanged(_this, outerArgs);
                }
                if (_this._holeDimensionsChanged) {
                    _this._holeDimensionsChanged(_this, outerArgs);
                }
            };
            this.i.holeDimensionsChanged = delegateCombine(this.i.holeDimensionsChanged, this._holeDimensionsChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrDoughnutChart;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDoughnutChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDoughnutChartCoreModule() {
    }
    IgrDoughnutChartCoreModule.register = function () {
        IgrRingSeriesModule.register();
        TypeRegistrar.registerCons('IgrDoughnutChart', IgrDoughnutChart);
    };
    return IgrDoughnutChartCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDoughnutChartModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDoughnutChartModule() {
    }
    IgrDoughnutChartModule.register = function () {
        IgrDoughnutChartInteractivityModule.register();
        IgrDoughnutChartCoreModule.register();
    };
    return IgrDoughnutChartModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Node$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Node, _super);
    function Node(a, b) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.a = b;
        _this.b = a;
        return _this;
    }
    Node.$t = markType(Node, 'Node');
    return Node;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IgQueue$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgQueue$1, _super);
    function IgQueue$1($t) {
        var _this = _super.call(this) || this;
        _this.$t = null;
        _this.e = 0;
        _this.b = null;
        _this.a = null;
        _this.c = null;
        _this.$t = $t;
        _this.$type = _this.$type.specialize(_this.$t);
        return _this;
    }
    Object.defineProperty(IgQueue$1.prototype, "d", {
        get: function () {
            return (this.e == 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgQueue$1.prototype, "f", {
        get: function () {
            return this.e;
        },
        enumerable: true,
        configurable: true
    });
    IgQueue$1.prototype.h = function (a) {
        if (this.e == 0) {
            this.b = this.a = new Node$1(a, this.b);
        }
        else {
            this.a.a = new Node$1(a, this.a.a);
            this.a = this.a.a;
        }
        this.e++;
    };
    IgQueue$1.prototype.g = function (a) {
        this.c = this.b;
        if (this.e == 0) {
            throw new BaseError(1, "tried to serve from an empty Queue");
        }
        this.b = this.b.a;
        this.e--;
        a = typeCast(this.$t, this.c.b);
        return {
            p0: a
        };
    };
    IgQueue$1.$t = markType(IgQueue$1, 'IgQueue$1');
    return IgQueue$1;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HierarchicalRingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HierarchicalRingSeries, _super);
    function HierarchicalRingSeries() {
        var _this = _super.call(this) || this;
        _this.dy = null;
        _this.ab = HierarchicalRingSeries.$;
        return _this;
    }
    HierarchicalRingSeries.prototype.aq = function () {
        if (this.itemsSource == null) {
            return new RingCollection();
        }
        this.dy = this.dz(this.itemsSource);
        return this.dy;
    };
    HierarchicalRingSeries.prototype.cl = function (a, b, c, d) {
        var e_1, _a, e_2, _b, e_3, _c;
        _super.prototype.cl.call(this, a, b, c, d);
        switch (b) {
            case RingSeriesBase.$$p[25]:
                var e = c;
                var f = d;
                var g = f - e;
                if (this.dy != null && this.dy.count > 0) {
                    for (var h = 0; h < this.dy.count; h++) {
                        var i = this.dy._inner[h];
                        try {
                            for (var _d = (e_1 = void 0, __values(fromEnum(i.g))), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var j = _e.value;
                                j.k = j.k + g;
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_e && !_e.done && (_a = _d.return))
                                    _a.call(_d);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                }
                break;
            case RingSeriesBase.$$p[0]:
                this.cj();
                break;
            case HierarchicalRingSeries.$$p[0]:
                this.ck();
                break;
        }
        if (this.dy != null && this.as.e()) {
            var k = false;
            try {
                for (var _f = __values(fromEnum(this.dy)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var l = _g.value;
                    l.o();
                    if (l.f()) {
                        k = true;
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            if (k) {
                try {
                    for (var _h = __values(fromEnum(this.dy)), _j = _h.next(); !_j.done; _j = _h.next()) {
                        var m = _j.value;
                        m.c.as.l();
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_j && !_j.done && (_c = _h.return))
                            _c.call(_h);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
        }
    };
    HierarchicalRingSeries.prototype.ck = function () {
        if (this.at != null) {
            this.at.bx();
            this.at.b2();
        }
    };
    HierarchicalRingSeries.prototype.cj = function () {
        var e_4, _a, e_5, _b;
        if (this.dy != null) {
            try {
                for (var _c = __values(fromEnum(this.dy)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    try {
                        for (var _e = (e_5 = void 0, __values(fromEnum(a.g))), _f = _e.next(); !_f.done; _f = _e.next()) {
                            var b = _f.value;
                            this.d4(b);
                        }
                    }
                    catch (e_5_1) {
                        e_5 = { error: e_5_1 };
                    }
                    finally {
                        try {
                            if (_f && !_f.done && (_b = _e.return))
                                _b.call(_e);
                        }
                        finally {
                            if (e_5)
                                throw e_5.error;
                        }
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        }
    };
    HierarchicalRingSeries.prototype.cp = function () {
        if (this.dy != null && this.dy.count > 0) {
            var a = this.dy._inner[this.dy.count - 1];
            this.width = a.q.width;
            this.height = a.q.height;
            this.as.m(a.p.x, a.p.y);
        }
    };
    HierarchicalRingSeries.prototype.co = function () {
        var e_6, _a;
        for (var a = 0; a < this.dy.count; a++) {
            try {
                for (var _b = (e_6 = void 0, __values(fromEnum(this.dy._inner[a].ringControl.arcs.a))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.fg();
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
    };
    HierarchicalRingSeries.prototype.d1 = function (obj_) {
        var memberPath_ = this.d2;
        if ((obj_[memberPath_] !== undefined)) {
            return (obj_[memberPath_]);
        }
        return null;
    };
    HierarchicalRingSeries.prototype.dz = function (a) {
        var _this = this;
        var b = new IgQueue$1(ArcItem.$);
        var c = new IgQueue$1(ArcItem.$);
        var d = ((function () {
            var $ret = new ArcItem();
            $ret.m = 0;
            $ret.h = a;
            $ret.n = _this.b9;
            $ret.c = _this.al;
            $ret.j = _this.a2;
            return $ret;
        })());
        d.p(this.a4);
        var e = ((function () {
            var $ret = new ArcItem();
            $ret.m = -1;
            $ret.h = null;
            return $ret;
        })());
        c.h(d);
        b.h(e);
        var f = new RingCollection();
        var g = null;
        var h = -1;
        var _loop_1 = function () {
            var e_7, _a;
            var i;
            var j = c.g(i);
            i = j.p0;
            var k = void 0;
            var l = b.g(k);
            k = l.p0;
            if (i == null) {
                return "continue";
            }
            var m = 0;
            var _loop_2 = function (n) {
                var o = this_1.d1(n.g);
                if ((o != null && this_1.d0(o) == false) || n.c) {
                    var p = ((function () {
                        var $ret = new ArcItem();
                        $ret.m = i.m + 1;
                        $ret.h = n.c ? ((function () {
                            var $ret = new List$1(Number_$type, 0);
                            $ret.add(0);
                            return $ret;
                        })()) : o;
                        $ret.l = m;
                        $ret.b = i;
                        $ret.n = _this.b9;
                        $ret.e = n;
                        return $ret;
                    })());
                    p.p(this_1.a4);
                    c.h(p);
                    b.h(i);
                }
                m++;
            };
            try {
                for (var _b = (e_7 = void 0, __values(fromEnum(i.g))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var n = _c.value;
                    _loop_2(n);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            var q = this_1.dx(i, k, h, g);
            if (q != g) {
                f.add(q);
                g = q;
            }
            h = i.m;
        };
        var this_1 = this;
        while (c.f > 0) {
            _loop_1();
        }
        return f;
    };
    HierarchicalRingSeries.prototype.dx = function (a, b, c, d) {
        var _this = this;
        a.k = a.e == null ? this.a4 : a.e.e;
        a.i = a.e == null ? 360 : a.e.d;
        this.d4(a);
        if (a.m != c) {
            var e = ((function () {
                var $ret = new Ring();
                $ret.c = _this;
                return $ret;
            })());
            e.g.add(a);
            a.d = e;
            return e;
        }
        a.d = d;
        d.g.add(a);
        return d;
    };
    HierarchicalRingSeries.prototype.d0 = function (a) {
        var e_8, _a;
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                return false;
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        return true;
    };
    HierarchicalRingSeries.prototype.d4 = function (a) {
        if (a.b == null) {
            a.a = this.ag;
        }
        else if (a.b.m == 0) {
            a.a = new BrushCollection();
            if (a.b.a != null) {
                a.a.add(a.b.a.item(a.l % a.b.a.count));
            }
        }
        else {
            a.a = a.b.a;
        }
    };
    HierarchicalRingSeries.$t = markType(HierarchicalRingSeries, 'HierarchicalRingSeries', RingSeriesBase.$);
    HierarchicalRingSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HierarchicalRingSeries, 'cn', ['ChildrenMemberPath:d2:d5', [2]]);
    return HierarchicalRingSeries;
}(RingSeriesBase));

/**
 * Represents a IgxDoughnutChartComponent hierarchical series.
*/
var IgrHierarchicalRingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHierarchicalRingSeries, _super);
    function IgrHierarchicalRingSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrHierarchicalRingSeries.prototype.createImplementation = function () {
        return new HierarchicalRingSeries();
    };
    Object.defineProperty(IgrHierarchicalRingSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHierarchicalRingSeries.prototype, "childrenMemberPath", {
        /**
         * Gets or sets the property name that contains the children items collection.
        */
        get: function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrHierarchicalRingSeries;
}(IgrRingSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrHierarchicalRingSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrHierarchicalRingSeriesModule() {
    }
    IgrHierarchicalRingSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrHierarchicalRingSeries", IgrHierarchicalRingSeries);
        TypeRegistrar.register("HierarchicalRingSeries", HierarchicalRingSeries.$type);
    };
    return IgrHierarchicalRingSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisBreak = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisBreak, _super);
    function TimeAxisBreak() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new Date();
        _this.a = new Date();
        _this.h = (0);
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(TimeAxisBreak.prototype, "d", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.d;
            if (+a != +b) {
                this.b = a;
                this.j("Start", b, this.d);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBreak.prototype, "c", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.c;
            if (+a != +b) {
                this.a = a;
                this.j("End", b, this.c);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBreak.prototype, "i", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.i;
            if (a != b) {
                this.h = a;
                this.j("Interval", b, this.i);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBreak.prototype.j = function (a, b, c) {
        this.k(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    TimeAxisBreak.prototype.k = function (a, b, c) {
    };
    TimeAxisBreak.$t = markType(TimeAxisBreak, 'TimeAxisBreak', Base.$, [INotifyPropertyChanged_$type]);
    return TimeAxisBreak;
}(Base));

var IgrTimeAxisBreak = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisBreak, _super);
    function IgrTimeAxisBreak(props) {
        var _this = _super.call(this, props) || this;
        _this._renderer = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    Object.defineProperty(IgrTimeAxisBreak.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisBreak.prototype.onImplementationCreated = function () {
    };
    IgrTimeAxisBreak.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrTimeAxisBreak.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrTimeAxisBreak.prototype.render = function () {
        return null;
    };
    IgrTimeAxisBreak.prototype.createImplementation = function () {
        return new TimeAxisBreak();
    };
    IgrTimeAxisBreak.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
    };
    IgrTimeAxisBreak._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrTimeAxisBreak.prototype, "start", {
        /**
     * The start time of the axis break.
    *
    * Use `start` property for the start time of the axis break.
    *
    * ```ts
    *   <IgrDataChart
    *     dataSource={this.state.dataSource}
    *     width="700px"
    *     height="500px">
    *     <IgrTimeXAxis name="xAxis" label="Date"
    * 			dateTimeMemberPath="Date" >
    *  </IgrTimeXAxis>
    *  </IgrDataChart>
    * ```
    */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBreak.prototype, "end", {
        /**
         * The end time of the axis break.
        *
        * Use `end` property for the end time of the axis break.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis" label="Date"
        * 			dateTimeMemberPath="Date" >
        *
        *  </IgrTimeXAxis>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBreak.prototype, "interval", {
        /**
         * The interval at which to repeat this break, expressed as a TimeSpan.
        *
        * Use `interval` property to se the interval at which to repeat this break, expressed as a TimeSpan.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis" label="Date"
        * 			dateTimeMemberPath="Date" >
        *
        *  </IgrTimeXAxis>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBreak.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisBreak.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrTimeAxisBreak.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisBreak");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    return IgrTimeAxisBreak;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisBreakCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisBreakCollection, _super);
    function TimeAxisBreakCollection() {
        return _super.call(this, TimeAxisBreak.$, 0) || this;
    }
    TimeAxisBreakCollection.$t = markType(TimeAxisBreakCollection, 'TimeAxisBreakCollection', ObservableCollection$1.$.specialize(TimeAxisBreak.$));
    return TimeAxisBreakCollection;
}(ObservableCollection$1));

var IgrTimeAxisBreakCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisBreakCollection, _super);
    function IgrTimeAxisBreakCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrTimeAxisBreak.$type) {
            IgrTimeAxisBreak.$type = markType(IgrTimeAxisBreak, "IgrTimeAxisBreak");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrTimeAxisBreakCollection.prototype._createInnerColl = function () {
        if (!IgrTimeAxisBreak.$type) {
            IgrTimeAxisBreak.$type = markType(IgrTimeAxisBreak, "IgrTimeAxisBreak");
        }
        var coll = new SyncableObservableCollection$2(IgrTimeAxisBreak.$type, TimeAxisBreak.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrTimeAxisBreak(null);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrTimeAxisBreakCollection;
}(IgCollection));

var IgrTimeAxisBreakModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTimeAxisBreakModule() {
    }
    IgrTimeAxisBreakModule.register = function () {
        TypeRegistrar.registerCons("IgrTimeAxisBreak", IgrTimeAxisBreak);
        TypeRegistrar.registerCons("IgrTimeAxisBreakCollection", IgrTimeAxisBreakCollection);
        TypeRegistrar.register("TimeAxisBreak", TimeAxisBreak.$type);
        TypeRegistrar.register("TimeAxisBreakCollection", TimeAxisBreakCollection.$type);
    };
    return IgrTimeAxisBreakModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum representing a unit of time.
 */
var TimeAxisIntervalType = /*@__PURE__*/ (function (TimeAxisIntervalType) {
    /**
     * Ticks are ten millionths of seconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Ticks"] = 0] = "Ticks";
    /**
     * Milliseconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Milliseconds"] = 1] = "Milliseconds";
    /**
     * Seconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Seconds"] = 2] = "Seconds";
    /**
     * Minutes.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Minutes"] = 3] = "Minutes";
    /**
     * Hours.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Hours"] = 4] = "Hours";
    /**
     * Days.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Days"] = 5] = "Days";
    /**
     * Weeks.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Weeks"] = 6] = "Weeks";
    /**
     * Months.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Months"] = 7] = "Months";
    /**
     * Years.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Years"] = 8] = "Years";
    return TimeAxisIntervalType;
})({});
/**
 * @hidden
 */
var TimeAxisIntervalType_$type = /*@__PURE__*/ markEnum('TimeAxisIntervalType', 'Ticks,0|Milliseconds,1|Seconds,2|Minutes,3|Hours,4|Days,5|Weeks,6|Months,7|Years,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisInterval = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisInterval, _super);
    function TimeAxisInterval() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.j = (0);
        _this.e = 0;
        _this.a = 0;
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(TimeAxisInterval.prototype, "k", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.k;
            if (a != b) {
                this.j = a;
                this.l("Range", b, this.k);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisInterval.prototype, "f", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.f;
            if (a != b) {
                this.e = a;
                this.l("Interval", b, this.f);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisInterval.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.b;
            if (a != b) {
                this.a = a;
                this.l("Interval", enumGetBox(TimeAxisIntervalType_$type, b), enumGetBox(TimeAxisIntervalType_$type, this.b));
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisInterval.prototype.d = function (a) {
        var b;
        switch (this.b) {
            case 0:
                var c = 10000;
                return dateAddSeconds(a, 1 / c);
            case 1:
                b = dateAddSeconds(a, 1 / 1000);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), b.getMilliseconds());
            case 2:
                b = dateAddSeconds(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), 0);
            case 3:
                b = dateAddMinutes(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), 0, 0);
            case 4:
            case 5:
                b = dateAddHours(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), 0, 0, 0);
            case 6:
            case 7:
            case 8:
                b = dateAddDays(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), 0, 0, 0, 0);
            default: return a;
        }
    };
    TimeAxisInterval.prototype.c = function (a) {
        var b = +(dateMaxValue()) - +a;
        switch (this.b) {
            case 0:
                var c = 10000;
                if (b > timeSpanFromTicks(truncate(this.f))) {
                    return dateAddSeconds(a, this.f / c);
                }
                return dateMaxValue();
            case 1:
                if (b > timeSpanFromMilliseconds(this.f)) {
                    return dateAddSeconds(a, this.f / 1000);
                }
                return dateMaxValue();
            case 2:
                if (b > timeSpanFromSeconds(this.f)) {
                    return dateAddSeconds(a, this.f);
                }
                return dateMaxValue();
            case 3:
                if (b > timeSpanFromMinutes(this.f)) {
                    return dateAddMinutes(a, this.f);
                }
                return dateMaxValue();
            case 4:
                if (b > timeSpanFromHours(this.f)) {
                    return dateAddHours(a, this.f);
                }
                return dateMaxValue();
            case 5:
                if (b > timeSpanFromDays(this.f)) {
                    return dateAddDays(a, this.f);
                }
                return dateMaxValue();
            case 6:
                if (b > timeSpanFromDays(7 * this.f)) {
                    return dateAddDays(a, this.f * 7);
                }
                return dateMaxValue();
            case 7:
                if (b > timeSpanFromDays(31 * truncate(this.f))) {
                    return dateAddMonths(a, truncate(this.f));
                }
                return dateMaxValue();
            case 8:
                if (b > timeSpanFromDays(365 * truncate(this.f))) {
                    return dateAddYears(a, truncate(this.f));
                }
                return dateMaxValue();
            default: return a;
        }
    };
    TimeAxisInterval.prototype.l = function (a, b, c) {
        this.m(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    TimeAxisInterval.prototype.m = function (a, b, c) {
    };
    TimeAxisInterval.$t = markType(TimeAxisInterval, 'TimeAxisInterval', Base.$, [INotifyPropertyChanged_$type]);
    return TimeAxisInterval;
}(Base));

var IgrTimeAxisInterval = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisInterval, _super);
    function IgrTimeAxisInterval(props) {
        var _this = _super.call(this, props) || this;
        _this._renderer = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    Object.defineProperty(IgrTimeAxisInterval.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisInterval.prototype.onImplementationCreated = function () {
    };
    IgrTimeAxisInterval.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrTimeAxisInterval.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrTimeAxisInterval.prototype.render = function () {
        return null;
    };
    IgrTimeAxisInterval.prototype.createImplementation = function () {
        return new TimeAxisInterval();
    };
    IgrTimeAxisInterval.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
    };
    IgrTimeAxisInterval._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrTimeAxisInterval.prototype, "range", {
        /**
     * The visible axis range at which to apply this interval.
    *
    * Use `range` property for the visible axis range at which to apply this interval.
    */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisInterval.prototype, "interval", {
        /**
         * The interval, expressed as a multiple of IntervalType.
        *
        * Use the `interval` property expressed as a multiple of IntervalType.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrOrdinalTimeXAxis name="xAxis"
        * 	label="Date"
        * 	dateTimeMemberPath="Date" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
        * this.timeXAxis.title = "Time X Axis";
        * this.timeXAxis.dataSource = this.financialData;
        * this.timeXAxis.dateTimeMemberPath = "Time";
        * this.timeXAxis.intervals={2};
        * ```
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisInterval.prototype, "intervalType", {
        /**
         * The unit of time for this interval.
        *
        * The `intervalType` is the unit of time for this interval.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(TimeAxisIntervalType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisInterval.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisInterval.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrTimeAxisInterval.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisInterval");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    return IgrTimeAxisInterval;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisIntervalCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisIntervalCollection, _super);
    function TimeAxisIntervalCollection() {
        return _super.call(this, TimeAxisInterval.$, 0) || this;
    }
    TimeAxisIntervalCollection.$t = markType(TimeAxisIntervalCollection, 'TimeAxisIntervalCollection', ObservableCollection$1.$.specialize(TimeAxisInterval.$));
    return TimeAxisIntervalCollection;
}(ObservableCollection$1));

var IgrTimeAxisIntervalCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisIntervalCollection, _super);
    function IgrTimeAxisIntervalCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrTimeAxisInterval.$type) {
            IgrTimeAxisInterval.$type = markType(IgrTimeAxisInterval, "IgrTimeAxisInterval");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrTimeAxisIntervalCollection.prototype._createInnerColl = function () {
        if (!IgrTimeAxisInterval.$type) {
            IgrTimeAxisInterval.$type = markType(IgrTimeAxisInterval, "IgrTimeAxisInterval");
        }
        var coll = new SyncableObservableCollection$2(IgrTimeAxisInterval.$type, TimeAxisInterval.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrTimeAxisInterval(null);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrTimeAxisIntervalCollection;
}(IgCollection));

var IgrTimeAxisIntervalModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTimeAxisIntervalModule() {
    }
    IgrTimeAxisIntervalModule.register = function () {
        TypeRegistrar.registerCons("IgrTimeAxisInterval", IgrTimeAxisInterval);
        TypeRegistrar.registerCons("IgrTimeAxisIntervalCollection", IgrTimeAxisIntervalCollection);
        TypeRegistrar.register("TimeAxisInterval", TimeAxisInterval.$type);
        TypeRegistrar.register("TimeAxisIntervalCollection", TimeAxisIntervalCollection.$type);
    };
    return IgrTimeAxisIntervalModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisLabelFormat = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisLabelFormat, _super);
    function TimeAxisLabelFormat() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = (0);
        _this.a = null;
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(TimeAxisLabelFormat.prototype, "f", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.f;
            if (a != b) {
                this.e = a;
                this.g("Range", b, this.f);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisLabelFormat.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.b;
            if (a != b) {
                this.a = a;
                this.g("Format", b, this.b);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisLabelFormat.prototype.g = function (a, b, c) {
        this.h(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    TimeAxisLabelFormat.prototype.h = function (a, b, c) {
    };
    TimeAxisLabelFormat.$t = markType(TimeAxisLabelFormat, 'TimeAxisLabelFormat', Base.$, [INotifyPropertyChanged_$type]);
    return TimeAxisLabelFormat;
}(Base));

var IgrTimeAxisLabelFormat = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisLabelFormat, _super);
    function IgrTimeAxisLabelFormat(props) {
        var _this = _super.call(this, props) || this;
        _this._renderer = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    Object.defineProperty(IgrTimeAxisLabelFormat.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisLabelFormat.prototype.onImplementationCreated = function () {
    };
    IgrTimeAxisLabelFormat.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrTimeAxisLabelFormat.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrTimeAxisLabelFormat.prototype.render = function () {
        return null;
    };
    IgrTimeAxisLabelFormat.prototype.createImplementation = function () {
        return new TimeAxisLabelFormat();
    };
    IgrTimeAxisLabelFormat.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
    };
    IgrTimeAxisLabelFormat._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrTimeAxisLabelFormat.prototype, "range", {
        /**
     * The visible axis range at which to apply this label format.
    *
    * The `range` property provide the visible axis range at which to apply this label format.
    *
    * ```ts
    * let labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm:ss";
    * labelFormat.range = 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm";
    * labelFormat.range = 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "MMM-dd-yy";
    * labelFormat.range = 24 * 60 * 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * ```
    */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisLabelFormat.prototype, "format", {
        /**
         * The DateTime format string to apply.
         * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
        *
        * The `format` property provide the DateTime format string to apply.
        *
        * ```ts
        * let labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm:ss";
        * labelFormat.range = 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm";
        * labelFormat.range = 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "MMM-dd-yy";
        * labelFormat.range = 24 * 60 * 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * ```
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis" label="Date"
        * 			dateTimeMemberPath="Date" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisLabelFormat.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisLabelFormat.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrTimeAxisLabelFormat.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisLabelFormat");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    return IgrTimeAxisLabelFormat;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisLabelFormatCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisLabelFormatCollection, _super);
    function TimeAxisLabelFormatCollection() {
        return _super.call(this, TimeAxisLabelFormat.$, 0) || this;
    }
    TimeAxisLabelFormatCollection.$t = markType(TimeAxisLabelFormatCollection, 'TimeAxisLabelFormatCollection', ObservableCollection$1.$.specialize(TimeAxisLabelFormat.$));
    return TimeAxisLabelFormatCollection;
}(ObservableCollection$1));

var IgrTimeAxisLabelFormatCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisLabelFormatCollection, _super);
    function IgrTimeAxisLabelFormatCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrTimeAxisLabelFormat.$type) {
            IgrTimeAxisLabelFormat.$type = markType(IgrTimeAxisLabelFormat, "IgrTimeAxisLabelFormat");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrTimeAxisLabelFormatCollection.prototype._createInnerColl = function () {
        if (!IgrTimeAxisLabelFormat.$type) {
            IgrTimeAxisLabelFormat.$type = markType(IgrTimeAxisLabelFormat, "IgrTimeAxisLabelFormat");
        }
        var coll = new SyncableObservableCollection$2(IgrTimeAxisLabelFormat.$type, TimeAxisLabelFormat.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrTimeAxisLabelFormat(null);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrTimeAxisLabelFormatCollection;
}(IgCollection));

var IgrTimeAxisLabelFormatModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTimeAxisLabelFormatModule() {
    }
    IgrTimeAxisLabelFormatModule.register = function () {
        TypeRegistrar.registerCons("IgrTimeAxisLabelFormat", IgrTimeAxisLabelFormat);
        TypeRegistrar.registerCons("IgrTimeAxisLabelFormatCollection", IgrTimeAxisLabelFormatCollection);
        TypeRegistrar.register("TimeAxisLabelFormat", TimeAxisLabelFormat.$type);
        TypeRegistrar.register("TimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection.$type);
    };
    return IgrTimeAxisLabelFormatModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IAngleScaler_$type = /*@__PURE__*/ new Type(null, 'IAngleScaler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAxisRenderer, _super);
    function CategoryAxisRenderer(a) {
        return _super.call(this, a) || this;
    }
    CategoryAxisRenderer.prototype.ac = function (a, b, c, d, e) {
        var f = typeCast(CategoryAxisRenderingParameters.$, a);
        var g = 0;
        if (f != null) {
            g = f.ab;
        }
        var h = new LinearCategorySnapper(1, a.e.d, a.e.c, a.e.b, a.p, g, a.o);
        b = h.g;
        if (a.e.a != -1) {
            b = a.e.a;
        }
        var i = Math.floor((a.e.d - a.m) / b);
        var j = Math.ceil((a.e.c - a.m) / b);
        d = truncate(i);
        e = truncate(j);
        c = truncate(h.h);
        if (a.e.e != -1) {
            c = a.e.e;
        }
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    };
    CategoryAxisRenderer.prototype.w = function (a, b, c, d) {
        var e = typeCast(CategoryAxisRenderingParameters.$, a);
        if (e == null) {
            return null;
        }
        var f = 0;
        if (d >= 1) {
            f = c * truncate(Math.floor(d));
        }
        else {
            if ((c * d) * 2 % 2 == 0) {
                f = truncate(Math.floor(c * d));
            }
            else {
                f = -1;
            }
        }
        var g = null;
        if ((e.ae > 0 && f < e.ae && f >= 0) || e.ad) {
            while (f >= e.ae && e.ad) {
                f -= e.ae;
            }
            g = this.g(f);
        }
        return g;
    };
    CategoryAxisRenderer.prototype.ad = function (a, b, c, d, e, f) {
        var g = typeCast(CategoryAxisRenderingParameters.$, a);
        if (g.ab != 0 && g.af != 0) {
            for (var h = 0; h < truncate(b); h++) {
                for (var i = 0; i < g.af; i++) {
                    var j = this.f(i, a.aa, a.z, a.y);
                    if (g.ac) {
                        j = -j;
                    }
                    var k = this.m(a, h + e * b) + j;
                    a.b = a.d;
                    this.k(a, a.v, k);
                    a.b = null;
                }
            }
        }
    };
    CategoryAxisRenderer.$t = markType(CategoryAxisRenderer, 'CategoryAxisRenderer', AxisRendererBase.$);
    return CategoryAxisRenderer;
}(AxisRendererBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ViewportUtils = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ViewportUtils, _super);
    function ViewportUtils() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ViewportUtils.c = function (a, b, c) {
        return c.left + c.width * (a - b.left) / b.width;
    };
    ViewportUtils.a = function (a, b, c) {
        return ((a - c.left) * b.width / c.width) + b.left;
    };
    ViewportUtils.f = function (a, b, c) {
        return c.top + c.height * (a - b.top) / b.height;
    };
    ViewportUtils.e = function (a, b, c) {
        return ((a - c.top) * b.height / c.height) + b.top;
    };
    ViewportUtils.d = function (a, b, c) {
        return c.width * a / b.width;
    };
    ViewportUtils.b = function (a, b, c) {
        return b.width * a / c.width;
    };
    ViewportUtils.g = function (a, b, c) {
        return c.height * a / b.height;
    };
    ViewportUtils.$t = markType(ViewportUtils, 'ViewportUtils');
    return ViewportUtils;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IPolarRadialRenderingParameters_$type = /*@__PURE__*/ new Type(null, 'IPolarRadialRenderingParameters');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAxisRenderingParameters, _super);
    function PolarAxisRenderingParameters() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._minLength = 0;
        _this._maxLength = 0;
        _this._center = null;
        _this._minAngle = 0;
        _this._maxAngle = 0;
        _this._crossingAngleRadians = 0;
        _this._effectiveMaximum = 0;
        return _this;
    }
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "minLength", {
        get: function () {
            return this._minLength;
        },
        set: function (a) {
            this._minLength = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "maxLength", {
        get: function () {
            return this._maxLength;
        },
        set: function (a) {
            this._maxLength = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "center", {
        get: function () {
            return this._center;
        },
        set: function (a) {
            this._center = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "minAngle", {
        get: function () {
            return this._minAngle;
        },
        set: function (a) {
            this._minAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "maxAngle", {
        get: function () {
            return this._maxAngle;
        },
        set: function (a) {
            this._maxAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "crossingAngleRadians", {
        get: function () {
            return this._crossingAngleRadians;
        },
        set: function (a) {
            this._crossingAngleRadians = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarAxisRenderingParameters.prototype, "effectiveMaximum", {
        get: function () {
            return this._effectiveMaximum;
        },
        set: function (a) {
            this._effectiveMaximum = a;
        },
        enumerable: true,
        configurable: true
    });
    PolarAxisRenderingParameters.$t = markType(PolarAxisRenderingParameters, 'PolarAxisRenderingParameters', NumericAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);
    return PolarAxisRenderingParameters;
}(NumericAxisRenderingParameters));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialAxisRenderingParameters = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAxisRenderingParameters, _super);
    function RadialAxisRenderingParameters() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._minLength = 0;
        _this._maxLength = 0;
        _this._center = null;
        _this._crossingAngleRadians = 0;
        _this._minAngle = 0;
        _this._maxAngle = 0;
        _this._effectiveMaximum = 0;
        return _this;
    }
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "minLength", {
        get: function () {
            return this._minLength;
        },
        set: function (a) {
            this._minLength = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "maxLength", {
        get: function () {
            return this._maxLength;
        },
        set: function (a) {
            this._maxLength = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "center", {
        get: function () {
            return this._center;
        },
        set: function (a) {
            this._center = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "crossingAngleRadians", {
        get: function () {
            return this._crossingAngleRadians;
        },
        set: function (a) {
            this._crossingAngleRadians = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "minAngle", {
        get: function () {
            return this._minAngle;
        },
        set: function (a) {
            this._minAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "maxAngle", {
        get: function () {
            return this._maxAngle;
        },
        set: function (a) {
            this._maxAngle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisRenderingParameters.prototype, "effectiveMaximum", {
        get: function () {
            return this._effectiveMaximum;
        },
        set: function (a) {
            this._effectiveMaximum = a;
        },
        enumerable: true,
        configurable: true
    });
    RadialAxisRenderingParameters.$t = markType(RadialAxisRenderingParameters, 'RadialAxisRenderingParameters', CategoryAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);
    return RadialAxisRenderingParameters;
}(CategoryAxisRenderingParameters));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarAxisRenderingManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAxisRenderingManager, _super);
    function PolarAxisRenderingManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PolarAxisRenderingManager.prototype.p = function (a, b, c, d, e, f) {
        var g = ViewportUtils.d(a, e, f);
        var h = ViewportUtils.g(a, e, f);
        var i = ViewportUtils.c(b.x, e, f);
        var j = ViewportUtils.f(b.y, e, f);
        if (d - c < Math.PI && d - c > 0) {
            var k = { $type: Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(c), e, f), y: ViewportUtils.f(b.y + a * Math.sin(c), e, f) };
            var l_1 = { $type: Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(d), e, f), y: ViewportUtils.f(b.y + a * Math.sin(d), e, f) };
            var m = new PathFigure();
            m._startPoint = k;
            m._isClosed = false;
            m._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = l_1;
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            return m;
        }
        else {
            var n = new PathFigure();
            n._startPoint = { $type: Point_$type, x: i, y: j - h };
            n._isClosed = true;
            n._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: i, y: j + h };
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            n._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: i, y: j - h };
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            return n;
        }
    };
    PolarAxisRenderingManager.prototype.j = function (a, b, c, d, e, f, g, h) {
        var i = Math.min(b, c);
        var j = Math.max(b, c);
        var k = new PathGeometry();
        var l = null;
        var m = null;
        var n = null;
        var o = null;
        if (i > 0) {
            l = this.p(i, f, g, h, e, d);
            if (h - g < Math.PI && h - g > 0) {
                var p = typeCast(ArcSegment.$, l._segments._inner[0]);
                if (p != null) {
                    var q_1 = { $type: Point_$type, x: ViewportUtils.c(f.x + j * Math.cos(h), e, d), y: ViewportUtils.f(f.y + j * Math.sin(h), e, d) };
                    m = ((function () {
                        var $ret = new LineSegment(1);
                        $ret.c = q_1;
                        return $ret;
                    })());
                }
            }
        }
        if (j > 0) {
            n = this.p(j, f, g, h, e, d);
        }
        if (i > 0) {
            if (h - g < Math.PI && h - g > 0) {
                var r = n._startPoint;
                var s = typeCast(ArcSegment.$, n._segments._inner[0]);
                if (s != null) {
                    n._startPoint = s.e;
                    s.e = r;
                    s.d = 0;
                    var t_1 = { $type: Point_$type, x: ViewportUtils.c(f.x + i * Math.cos(g), e, d), y: ViewportUtils.f(f.y + i * Math.sin(g), e, d) };
                    o = ((function () {
                        var $ret = new LineSegment(1);
                        $ret.c = t_1;
                        return $ret;
                    })());
                }
            }
        }
        if (m != null && o != null) {
            l._segments.add(m);
            var u = n._segments._inner[0];
            n._segments.remove(u);
            l._segments.add(u);
            l._segments.add(o);
            l._isClosed = true;
            k.c.add(l);
        }
        else {
            if (l != null) {
                k.c.add(l);
                this.o(n);
            }
            if (n != null) {
                k.c.add(n);
            }
        }
        a.add(k);
    };
    PolarAxisRenderingManager.prototype.o = function (a) {
        if (a._segments.count > 1) {
            var b = typeCast(ArcSegment.$, a._segments._inner[0]);
            var c = typeCast(ArcSegment.$, a._segments._inner[1]);
            a._segments._inner[0] = c;
            a._segments._inner[1] = b;
            var d = c.e;
            var e = a._startPoint;
            var f = b.e;
            a._startPoint = d;
            c.e = f;
            b.e = e;
            b.d = 0;
            c.d = 0;
        }
        else {
            var g = a._startPoint;
            var h = typeCast(ArcSegment.$, a._segments._inner[0]);
            if (h != null) {
                a._startPoint = h.e;
                h.e = g;
                h.d = 0;
            }
        }
    };
    PolarAxisRenderingManager.prototype.i = function (a, b, c, d, e, f, g) {
        if (b > 0) {
            var h = new PathGeometry();
            h.c.add(this.p(b, e, f, g, d, c));
            a.add(h);
        }
    };
    PolarAxisRenderingManager.prototype.n = function (a, b, c, d, e, f, g, h) {
        var i = Math.min(b, c);
        var j = Math.max(b, c);
        var k = false;
        if (j - i > Math.PI) {
            k = true;
        }
        var l = Math.cos(i);
        var m = Math.sin(i);
        var n = h.x + l * f;
        var o = h.y + m * f;
        var p = h.x + l * g;
        var q = h.y + m * g;
        var r = Math.cos(j);
        var s = Math.sin(j);
        var t = h.x + r * f;
        var u = h.y + s * f;
        var v = h.x + r * g;
        var w = h.y + s * g;
        n = ViewportUtils.c(n, e, d);
        o = ViewportUtils.f(o, e, d);
        p = ViewportUtils.c(p, e, d);
        q = ViewportUtils.f(q, e, d);
        t = ViewportUtils.c(t, e, d);
        u = ViewportUtils.f(u, e, d);
        v = ViewportUtils.c(v, e, d);
        w = ViewportUtils.f(w, e, d);
        var x = new PathFigure();
        x._startPoint = { $type: Point_$type, x: n, y: o };
        x._isClosed = true;
        x._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = { $type: Point_$type, x: p, y: q };
            return $ret;
        })()));
        x._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = { $type: Point_$type, x: v, y: w };
            $ret.f = new Size(1, ViewportUtils.d(g, e, d), ViewportUtils.g(g, e, d));
            $ret.d = 1;
            $ret.b = k;
            return $ret;
        })()));
        x._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = { $type: Point_$type, x: t, y: u };
            return $ret;
        })()));
        x._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = { $type: Point_$type, x: n, y: o };
            $ret.f = new Size(1, ViewportUtils.d(f, e, d), ViewportUtils.g(f, e, d));
            $ret.d = 0;
            $ret.b = k;
            return $ret;
        })()));
        var y = new PathGeometry();
        y.c.add(x);
        a.add(y);
    };
    PolarAxisRenderingManager.prototype.m = function (a, b, c, d, e, f, g) {
        var h = new LineGeometry();
        var i = Math.cos(b);
        var j = Math.sin(b);
        var k = g.x + i * e;
        var l = g.y + j * e;
        var m = g.x + i * f;
        var n = g.y + j * f;
        k = ViewportUtils.c(k, d, c);
        l = ViewportUtils.f(l, d, c);
        m = ViewportUtils.c(m, d, c);
        n = ViewportUtils.f(n, d, c);
        h.d = { $type: Point_$type, x: k, y: l };
        h.c = { $type: Point_$type, x: m, y: n };
        a.add(h);
    };
    PolarAxisRenderingManager.prototype.a = function (a, b) {
        return a.x >= b.left && a.x <= b.right;
    };
    PolarAxisRenderingManager.prototype.b = function (a, b) {
        return a.y >= b.top && a.y <= b.bottom;
    };
    PolarAxisRenderingManager.prototype.c = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
        var d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
        var e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
        var f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
        return Math.min(c, Math.min(d, Math.min(e, f)));
    };
    PolarAxisRenderingManager.prototype.d = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
        var d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
        var e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
        var f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
        return Math.max(c, Math.max(d, Math.max(e, f)));
    };
    PolarAxisRenderingManager.prototype.f = function (a) {
        var b = { $type: Point_$type, x: 0.5, y: 0.5 };
        if (this.a(b, a) && this.b(b, a)) {
            return 0;
        }
        if (this.a(b, a)) {
            if (b.y < a.top) {
                return a.top - b.y;
            }
            else {
                return b.y - a.bottom;
            }
        }
        if (this.b(b, a)) {
            if (b.x < a.left) {
                return a.left - b.x;
            }
            else {
                return b.x - a.right;
            }
        }
        return this.c(b, a);
    };
    PolarAxisRenderingManager.prototype.g = function (a) {
        var b = { $type: Point_$type, x: 0.5, y: 0.5 };
        return this.d(b, a);
    };
    PolarAxisRenderingManager.prototype.e = function (a, b) {
        var c = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
        var d = Math.acos((b.x - a.x) / c);
        if ((b.y - a.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    PolarAxisRenderingManager.prototype.h = function (a, b) {
        return ((a.y - 0.5) * b.x) + ((0.5 - a.x) * b.y) + ((a.x * 0.5) - (0.5 * a.y));
    };
    PolarAxisRenderingManager.prototype.l = function (a, b, c) {
        var d = { $type: Point_$type, x: 0.5, y: 0.5 };
        if (this.a(d, a) && this.b(d, a)) {
            b = 0;
            c = Math.PI * 2;
            return {
                p1: b,
                p2: c
            };
        }
        var e = this.e(d, { $type: Point_$type, x: a.left, y: a.top });
        var f = this.e(d, { $type: Point_$type, x: a.right, y: a.top });
        var g = this.e(d, { $type: Point_$type, x: a.right, y: a.bottom });
        var h = this.e(d, { $type: Point_$type, x: a.left, y: a.bottom });
        if (this.b(d, a) && a.left > d.x) {
            b = e;
            c = 2 * Math.PI + h;
            return {
                p1: b,
                p2: c
            };
        }
        b = Math.min(e, Math.min(f, Math.min(g, h)));
        c = Math.max(e, Math.max(f, Math.max(g, h)));
        return {
            p1: b,
            p2: c
        };
    };
    PolarAxisRenderingManager.prototype.k = function (a, b, c, d, e, f, g) {
        var h;
        var i;
        var j = this.l(a, h, i);
        h = j.p1;
        i = j.p2;
        var k = Math.min(h, i);
        var l = Math.max(h, i);
        if (typeCast(PolarAxisRenderingParameters.$, b) !== null) {
            b.minAngle = k;
            b.maxAngle = l;
        }
        else if (typeCast(RadialAxisRenderingParameters.$, b) !== null) {
            b.minAngle = k;
            b.maxAngle = l;
        }
        if (h == 0 && i == Math.PI * 2) {
            var m = c;
            var n = d;
            var o_1 = Math.min(m, n);
            var p_1 = Math.max(m, n);
            b.k.add(((function () {
                var $ret = new RangeInfo();
                $ret.d = o_1;
                $ret.c = p_1;
                $ret.b = g;
                return $ret;
            })()));
            return;
        }
        else {
            if (i > Math.PI * 2) {
                i = i - Math.PI * 2;
            }
            var q = f(h);
            var r = f(i);
            if (q < c || q > d) {
                q = f(h + Math.PI * 2);
            }
            if (r < c || r > d) {
                r = f(i + Math.PI * 2);
            }
            var s_1 = Math.min(q, r);
            var t_2 = Math.max(q, r);
            if ((!e && q > r) || (e && q < r)) {
                var u_1 = (d - t_2);
                var v_1 = (s_1 - c);
                b.k.add(((function () {
                    var $ret = new RangeInfo();
                    $ret.d = t_2;
                    $ret.c = d;
                    $ret.b = (u_1 / (u_1 + v_1)) * g;
                    return $ret;
                })()));
                b.k.add(((function () {
                    var $ret = new RangeInfo();
                    $ret.d = c;
                    $ret.c = s_1;
                    $ret.b = (v_1 / (u_1 + v_1)) * g;
                    return $ret;
                })()));
            }
            else {
                b.k.add(((function () {
                    var $ret = new RangeInfo();
                    $ret.d = s_1;
                    $ret.c = t_2;
                    $ret.b = g;
                    return $ret;
                })()));
            }
        }
    };
    PolarAxisRenderingManager.$t = markType(PolarAxisRenderingManager, 'PolarAxisRenderingManager');
    return PolarAxisRenderingManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryTickmarkValues = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryTickmarkValues, _super);
    function CategoryTickmarkValues() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.v = 0;
        _this.z = 0;
        _this.aa = null;
        _this.ab = null;
        _this.x = false;
        _this.w = null;
        _this.y = 0;
        _this.t = null;
        _this.u = null;
        return _this;
    }
    CategoryTickmarkValues.prototype.s = function (a) {
        _super.prototype.s.call(this, a);
        var b = a.a;
        this.v = b;
        this.z = a.q;
        this.aa = a.r;
        this.ab = a.s;
        this.x = a.e;
        this.w = a.c;
        var c = new LinearCategorySnapper(1, a.n, a.m, a.k, a.l, b, a.h);
        var d = c.g;
        if (a.i != -1) {
            d = a.i;
        }
        var e = Math.floor((a.n - a.g) / d);
        var f = Math.ceil((a.m - a.g) / d);
        var g = truncate(e);
        var h = truncate(f);
        var i = truncate(c.h);
        if (a.p != -1) {
            i = a.p;
        }
        this.m = d;
        this.n = a.j;
        this.p = g;
        this.q = h;
        this.r = i;
        this.y = a.g;
    };
    CategoryTickmarkValues.prototype.j = function () {
        var a = this.p;
        var b = this.q - a + 1;
        if (b < 0) {
            b = 0;
        }
        if (this.t == null || this.t.length != b) {
            this.t = new Array(b);
        }
        var c = this.t;
        for (var d = 0; d < b; ++d) {
            var e = this.y + (d + a) * this.m;
            c[d] = e;
        }
        return c;
    };
    CategoryTickmarkValues.prototype.k = function () {
        var a = this.m;
        var b = this.q;
        var c = this.p;
        var d = this.z;
        var e = this.v;
        a = Math.min(a, 20);
        var f = 0;
        for (var g = c; g < b; ++g) {
            if (e != 0 && d != 0) {
                for (var h = 0; h < truncate(a); h++) {
                    for (var i = 0; i < d; i++) {
                        f++;
                    }
                }
            }
        }
        if (this.u == null || this.u.length != f) {
            this.u = new Array(f);
        }
        var j = this.u;
        var k = 0;
        for (var l = c; l < b; ++l) {
            if (e != 0 && d != 0) {
                for (var m = 0; m < truncate(a); m++) {
                    for (var n = 0; n < d; n++) {
                        var o = this.w(n);
                        var p = m + (l * a) + o;
                        j[k] = p;
                        k++;
                    }
                }
            }
        }
        return this.u;
    };
    CategoryTickmarkValues.$t = markType(CategoryTickmarkValues, 'CategoryTickmarkValues', TickmarkValues.$);
    return CategoryTickmarkValues;
}(TickmarkValues));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAxisLabelPanel, _super);
    function RadialAxisLabelPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.dh = null;
        _this.de = 0;
        _this.dd = new List$1(Number_$type, 0);
        return _this;
    }
    RadialAxisLabelPanel.prototype.ad = function () {
        return new RadialAxisLabelPanelView(this);
    };
    RadialAxisLabelPanel.prototype.b8 = function (a) {
        _super.prototype.b8.call(this, a);
        this.da = a;
    };
    Object.defineProperty(RadialAxisLabelPanel.prototype, "dc", {
        get: function () {
            return this.ac.aw != null && (this.ac.aw.c != 5 && this.ac.aw.c != 4);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RadialAxisLabelPanel.prototype, "db", {
        get: function () {
            return !this.dc;
        },
        enumerable: true,
        configurable: true
    });
    RadialAxisLabelPanel.prototype.cv = function () {
        return this.am && (!this.ap || this.bd() == -180);
    };
    RadialAxisLabelPanel.prototype.cw = function () {
        return !this.aq;
    };
    RadialAxisLabelPanel.prototype.bt = function (a) {
        _super.prototype.bt.call(this, a);
        if (this.de % 360 == 0 || this.dc) {
            this.da.a3();
        }
        else {
            this.da.a2(a);
        }
    };
    RadialAxisLabelPanel.prototype.bd = function () {
        var a = _super.prototype.bd.call(this);
        if (this.db) {
            a -= (this.de * 180) / Math.PI;
        }
        return a;
    };
    RadialAxisLabelPanel.prototype.cu = function () {
        return this.bd() % 360 != 0;
    };
    RadialAxisLabelPanel.prototype.ct = function () {
        if (this.dc) {
            return true;
        }
        var a = this.de * 180 / Math.PI;
        if (a < 30 || a > 330 || (a > 150 && a < 210)) {
            return true;
        }
        return false;
    };
    RadialAxisLabelPanel.prototype.cb = function (a, b) {
        var c = b * Math.PI / 180;
        var d = Math.abs(Math.sin(c));
        if (this.ac.aw != null && this.ac.aw.c == 4) {
            d = d * -1;
        }
        this.da.a4(a, b, d);
    };
    RadialAxisLabelPanel.prototype.dg = function () {
        var e_1, _a;
        var a = 1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(this.a2)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.min(b.c, a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return a;
    };
    RadialAxisLabelPanel.prototype.df = function () {
        var e_2, _a;
        var a = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(this.a2)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(b.c, a);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return a;
    };
    RadialAxisLabelPanel.prototype.c8 = function (a, b) {
        var c;
        if (this.ac.b8) {
            c = this.dg();
        }
        else {
            c = this.df();
        }
        var d = new List$1(Number_$type, 0);
        var e = new List$1(Boolean_$type, 0);
        for (var f = 0; f < this.a2.count; f++) {
            var g = this.a2._inner[f];
            if (g.c == c && !g.a) {
                d.add(this.a2.indexOf(g));
            }
        }
        this.dd = d;
        var h = new List$1(Rect.$, 0);
        for (var i = 0; i < a.count; i++) {
            var j = a._inner[i];
            var k = this.a2._inner[i].a;
            if (!this.dd.contains(i)) {
                h.add(j);
                e.add(k);
            }
        }
        this.am = this.al(h, e);
    };
    RadialAxisLabelPanel.prototype.ao = function (a, b) {
        if (this.dd.contains(a)) {
            return false;
        }
        else {
            return _super.prototype.ao.call(this, a, b);
        }
    };
    RadialAxisLabelPanel.prototype.c9 = function () {
        this.dd = new List$1(Number_$type, 0);
        _super.prototype.c9.call(this);
    };
    RadialAxisLabelPanel.prototype.ah = function () {
        return 5;
    };
    RadialAxisLabelPanel.prototype.as = function (a) {
        return a == 5 || a == 4 || a == 1 || a == 0;
    };
    RadialAxisLabelPanel.prototype.b0 = function () {
    };
    RadialAxisLabelPanel.$t = markType(RadialAxisLabelPanel, 'RadialAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
    return RadialAxisLabelPanel;
}(HorizontalAxisLabelPanelBase));
/**
 * @hidden
 */
var RadialAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAxisLabelPanelView, _super);
    function RadialAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.a1 = null;
        _this.a1 = a;
        return _this;
    }
    RadialAxisLabelPanelView.prototype.a4 = function (a, b, c) {
        var d = this.m(a);
        var e = this.l(a);
        var f = new TransformGroup();
        f.j.add(((function () {
            var $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = d / 2;
            $ret.l = e / 2;
            return $ret;
        })()));
        f.j.add(((function () {
            var $ret = new TranslateTransform();
            $ret.j = d / -2;
            $ret.k = d / 2 * c;
            return $ret;
        })()));
        a.j = f;
    };
    RadialAxisLabelPanelView.prototype.a3 = function () {
        this.a.j = null;
    };
    RadialAxisLabelPanelView.prototype.a2 = function (a) {
        var _this = this;
        var b = ViewportUtils.f(0.5, this.a.cp, this.a.co);
        this.a.j = ((function () {
            var $ret = new RotateTransform();
            $ret.j = (_this.a1.de * 180) / Math.PI;
            $ret.k = _this.a1.dh.x;
            $ret.l = (_this.a1.dh.y * a.height) + b;
            return $ret;
        })());
    };
    RadialAxisLabelPanelView.prototype.al = function () {
        _super.prototype.al.call(this);
        this.a.cq(new Size(1, this.a.cn.width, this.a.cn.height));
    };
    RadialAxisLabelPanelView.$t = markType(RadialAxisLabelPanelView, 'RadialAxisLabelPanelView', HorizontalAxisLabelPanelBaseView.$);
    return RadialAxisLabelPanelView;
}(HorizontalAxisLabelPanelBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AngleAxisLabelPanel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AngleAxisLabelPanel, _super);
    function AngleAxisLabelPanel() {
        var _this = _super.call(this) || this;
        _this.ct = false;
        _this.cz = null;
        _this.cx = 0;
        _this.cu = 0;
        _this.cw = 0;
        _this.cv = 0;
        return _this;
    }
    AngleAxisLabelPanel.prototype.ad = function () {
        return new AngleAxisLabelPanelView(this);
    };
    AngleAxisLabelPanel.prototype.b8 = function (a) {
        _super.prototype.b8.call(this, a);
        this.cs = a;
    };
    AngleAxisLabelPanel.prototype.ao = function (a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.i1.isEmpty) {
            return _super.prototype.ao.call(this, a, b);
        }
        return true;
    };
    AngleAxisLabelPanel.prototype.ay = function () {
        var a = new List$1(Rect.$, 0);
        var b = new List$1(Boolean_$type, 0);
        if (this.a3.count != this.a2.count) {
            return a;
        }
        this.cs.ay(a, b);
        var c = false;
        this.am = this.al(a, b);
        if (!this.ac.bz()) {
            c = true;
            this.a9 = this.cx / 2;
            this.a9 = this.a9 + this.cy();
        }
        else {
            c = true;
            this.cs.ac();
        }
        if (c) {
            for (var d = 0; d < a.count; d++) {
                var e = this.a3._inner[d];
                var f = this.a2._inner[d];
                var g = a._inner[d];
                var h = this.cz(f.c);
                var i = h.x - this.bc(e) / 2;
                var j = h.y - this.bb(e) / 2;
                g.x = i;
                g.y = j;
                a._inner[d] = g;
            }
        }
        return a;
    };
    AngleAxisLabelPanel.prototype.cy = function () {
        var a;
        var b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.bf);
        }
        if (a == null || b == null) {
            return 0;
        }
        var c = new List$1(Axis.$, 0);
        for (var d = 0; d < a.axes.count; d++) {
            var e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.at) !== null && e.at.a3.count > 0 && (!e.bz()) && !e.by() && (e.ag == null || this.ac.ag == null || e.ag.lj == b.ag.lj)) {
                c.add(e);
            }
        }
        var f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        var g = 0;
        var h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].at.a9;
            g += c._inner[f].at.a9 * 2 + h;
        }
        return g;
    };
    AngleAxisLabelPanel.prototype.ah = function () {
        return 4;
    };
    AngleAxisLabelPanel.prototype.as = function (a) {
        return a == 4 || a == 5;
    };
    AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
    return AngleAxisLabelPanel;
}(AxisLabelPanelBase));
/**
 * @hidden
 */
var CategoryAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAngleAxis, _super);
    function CategoryAngleAxis() {
        var _this = _super.call(this) || this;
        _this.k2 = null;
        _this.kz = null;
        _this.k3 = false;
        _this.k7 = NaN;
        _this.k0 = null;
        _this.k8 = 0;
        _this.k5 = 0;
        _this.k6 = 0;
        _this.lj = 1;
        _this.ab = CategoryAngleAxis.$;
        _this.kz = _this.ky();
        _this.k2 = new PolarAxisRenderingManager();
        return _this;
    }
    CategoryAngleAxis.prototype.a1 = function () {
        return new CategoryAngleAxisView(this);
    };
    CategoryAngleAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.kx = a;
    };
    CategoryAngleAxis.prototype.get_b0 = function () {
        return true;
    };
    CategoryAngleAxis.prototype.as = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.cz = function (b) {
            var c = _this.bf != null ? _this.bf.mq : Rect.empty;
            var d = !c.isEmpty ? _this.i1 : Rect.empty;
            return _this.lw(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.at.a9);
        };
        return a;
    };
    CategoryAngleAxis.prototype.lh = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    CategoryAngleAxis.prototype.ky = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new AxisLabelManager();
            $ret.a = _this;
            $ret.f = _this.cw;
            $ret.e = _this.cv;
            $ret.b = _this.at;
            return $ret;
        })());
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        var b = new CategoryAxisRenderer(a);
        b.u = function () {
            var c = _this.a2.ay();
            var d = _this.a2.a1();
            var e = _this.a2.az();
            var f = _this.a2.a0();
            _this.he();
            _this.gi(c);
            _this.gi(d);
            _this.gi(e);
            _this.gi(f);
        };
        b.o = function (c, d) { return !d.isEmpty && !c.isEmpty && _this.k1 != null; };
        b.d = function (c, d, e, f) { return _this.kw(c, d, e, f); };
        b.v = function () {
            if (!_this.k3) {
                _this.k3 = true;
                _this.k1.cl();
                _this.k3 = false;
            }
        };
        b.g = function (c) {
            var d = typeGetValue(c);
            if (d > _this.jf.count - 1) {
                d -= _this.jf.count;
            }
            var e = _this.jf.item(d);
            return _this.e6(e);
        };
        b.b.c = function (c) {
            var e_1, _a;
            if ((_this.aw == null || _this.aw.visibility == 0) && _this.k1 != null && _this.k7 != c) {
                var d = typeCast(XamDataChart.$, _this.bf);
                if (d == null) {
                    return;
                }
                _this.k7 = c;
                _this.at.a8 = c;
                d.ht();
                try {
                    for (var _b = __values(fromEnum(d.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        if (e != _this && typeCast(AngleAxisLabelPanel.$, e.at) !== null) {
                            e.a2.ad();
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        };
        b.k = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            _this.k2.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = function (c, d, e, f) {
            var g = typeCast(RadialAxisRenderingParameters.$, c);
            _this.k2.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = function (c, d) { return _this.getScaledAngle(d); };
        b.q = function (c, d) {
            if (_this.lh(d - _this.k8) < 0) {
                return false;
            }
            if (_this.lh(d - _this.k8 - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = function (c) {
            var d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                _this.k2.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = function (c) {
            c.n = _this.lb();
            c.r = c.n;
        };
        b.p = function (c, d, e) {
            var f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            var g = _this.lw(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = function (c, d, e, f) {
            var g = c.y;
            var h = new ScalerParams(0, c.aa, c.z, _this.b8, g);
            var i = d;
            if (_this.categoryMode != 0) {
                var j = (e * f) + 1;
                j = Math.min(j, _this.jy);
                var k = _this.dw(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.le);
        return b;
    };
    CategoryAngleAxis.prototype.lw = function (a, b, c, d, e) {
        var f = this.lb();
        var g = ViewportUtils.b(e, c, d);
        if (this.aw != null && (this.aw.c == 5 || this.aw.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    CategoryAngleAxis.prototype.lb = function () {
        if (this.k1 == null) {
            return 0;
        }
        if (!this.by()) {
            return this.k1.lo();
        }
        else {
            return this.k1.lp((this.e2));
        }
    };
    CategoryAngleAxis.prototype.kw = function (a, b, c, d) {
        if (this.jf == null) {
            return null;
        }
        var e = new RadialAxisRenderingParameters();
        var f = this.jf.count - 1;
        var g = this.a2.ay();
        var h = this.a2.a1();
        var i = this.a2.az();
        var j = this.a2.a0();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.k4();
        e.p = this.lf;
        e.o = this.d9();
        e.q = this.lg;
        e.s = this.e7;
        var k = this.k2.f(b);
        var l = this.k2.g(b);
        var m = 0.5 * this.k1.lj;
        var n = 0.5 * this.k1.li;
        var o = k;
        var p = l;
        var q = this.k1.lo();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        var r = a.width;
        this.k2.k(b, e, 0, this.jf.count, this.b8, runOn(this, this.getUnscaledAngle), r);
        var s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.jf.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.b8;
        e.af = this.j1;
        e.f = new CategoryTickmarkValues();
        e.j = this.cj;
        return e;
    };
    CategoryAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.k2.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    CategoryAngleAxis.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.g6(false);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "k1", {
        get: function () {
            if (this.k0 != null) {
                return this.k0;
            }
            var a = typeCast(XamDataChart.$, this.bf);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.k0;
        },
        set: function (a) {
            this.k0 = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.ah = function () {
        return this.k1;
    };
    CategoryAngleAxis.prototype.getCategorySize = function (a, b, c) {
        return 2 * Math.PI / this.jy;
    };
    CategoryAngleAxis.prototype.jr = function (a, b, c) {
        var d = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
        var e = 0;
        if (!isNaN_(this.jv)) {
            e = Math.min(this.jv, 1);
        }
        var f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.j1 - (this.j1 - 1) * e);
    };
    CategoryAngleAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.j1 > 1) {
            var f = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
            var g = 0;
            if (!isNaN_(this.jv)) {
                g = Math.min(this.jv, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.j1 - (this.j1 - 1) * g);
            var j = (h - i) / (this.j1 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryAngleAxis.prototype.le = function (a) {
        var b = 0.5;
        if (this.j1 > 1) {
            var c = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
            var d = 0;
            if (!isNaN_(this.jv)) {
                d = Math.min(this.jv, 1);
            }
            var e = 1 - 0.5 * c;
            var f = e / (this.j1 - (this.j1 - 1) * d);
            var g = (e - f) / (this.j1 - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    };
    CategoryAngleAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = this.kz.c(a, c, b, d, e);
        if (f != null) {
            this.k9 = f.f.m;
            this.la = f.f.l;
        }
    };
    CategoryAngleAxis.prototype.ld = function (a, b) {
        var c;
        var d;
        var e = this.k2.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.b8) {
                return this.jy;
            }
            else {
                return 0;
            }
        }
        var f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.jy) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.lc = function (a, b) {
        var c;
        var d;
        var e = this.k2.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.b8) {
                return 0;
            }
            else {
                return this.jy;
            }
        }
        var f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.jy) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    };
    CategoryAngleAxis.prototype.getScaledAngle = function (a) {
        var b = this.jy;
        var c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.b9) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.k8;
    };
    CategoryAngleAxis.prototype.getUnscaledAngle = function (a) {
        if (a < this.k8) {
            a += 2 * Math.PI;
        }
        var b = (a - this.k8) / (2 * Math.PI);
        if (this.b8) {
            b = 1 - b;
        }
        return b * (this.jy);
    };
    CategoryAngleAxis.prototype.dw = function (a, b) {
        return this.getScaledAngle(a);
    };
    CategoryAngleAxis.prototype.dz = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    CategoryAngleAxis.prototype.gu = function (a, b, c, d) {
        var e_2, _a, e_3, _b, e_4, _c;
        _super.prototype.gu.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.bf);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.ls(f);
                if (f != null) {
                    f.ly(this);
                }
                this.cg = true;
                this.g6(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.k8 = this.li;
                while (this.k8 < 0) {
                    this.k8 += 360;
                }
                while (this.k8 >= 360) {
                    this.k8 -= 360;
                }
                this.k8 = (this.k8 * Math.PI) / 180;
                this.cg = true;
                this.g6(false);
                try {
                    for (var _d = __values(fromEnum(this.cx)), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var g = _e.value;
                        g.jd(false);
                        g.ik();
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _f = __values(fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var h = _g.value;
                            h.cg = true;
                            h.g5();
                        }
                    }
                    catch (e_3_1) {
                        e_3 = { error: e_3_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_3)
                                throw e_3.error;
                        }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _h = __values(fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var i = _j.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.cg = true;
                                i.g5();
                            }
                        }
                    }
                    catch (e_4_1) {
                        e_4 = { error: e_4_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_4)
                                throw e_4.error;
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.kz = this.ky();
                this.lq();
                this.cg = true;
                this.g6(false);
                break;
        }
    };
    CategoryAngleAxis.prototype.lq = function () {
        this.k7 = NaN;
    };
    CategoryAngleAxis.prototype.ls = function (a) {
        this.k1 = a;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "lf", {
        get: function () {
            return this.c(CategoryAngleAxis.lt);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.lt, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "k9", {
        get: function () {
            return this.k5;
        },
        set: function (a) {
            if (this.k9 != a) {
                var b = this.k5;
                this.k5 = a;
                this.g0("ActualInterval", b, this.k9);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.d7 = function () {
        return this.k9;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "lg", {
        get: function () {
            return this.c(CategoryAngleAxis.lu);
        },
        set: function (a) {
            this.h(CategoryAngleAxis.lu, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryAngleAxis.prototype, "la", {
        get: function () {
            return this.k6;
        },
        set: function (a) {
            if (this.la != a) {
                var b = this.k6;
                this.k6 = a;
                this.g0("ActualMinorInterval", b, this.la);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.k4 = function () {
        return false;
    };
    CategoryAngleAxis.prototype.get_az = function () {
        return 2;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.cn = function () {
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        if (this.jf == null) {
            return false;
        }
        var a = this.jf.count;
        if (a != this.lk) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.lk, a);
            this.lk = a;
            this.g1(b);
            return true;
        }
        return false;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "lk", {
        get: function () {
            return this.lj;
        },
        set: function (a) {
            this.lj = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.it = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        var f = typeCast(RadialAxisRenderingParameters.$, this.kz.d(c, b, d, e));
        if (f == null) {
            return null;
        }
        var g = Math.cos(a);
        var h = Math.sin(a);
        var i = f.center.x + g * f.minLength;
        var j = f.center.y + h * f.minLength;
        var k = f.center.x + g * f.maxLength;
        var l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        var m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    CategoryAngleAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(CategoryAngleAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
    CategoryAngleAxis.lt = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.g0("Interval", b.oldValue, b.newValue);
        a.g6(false);
    }));
    CategoryAngleAxis.lu = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryAngleAxis.$, a)).g0("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryAngleAxis.$, a)).g6(false);
    }));
    CategoryAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'g0', ['StartAngleOffset:li:lv', [1, 0]]);
    return CategoryAngleAxis;
}(CategoryAxisBase));
/**
 * @hidden
 */
var NumericAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAngleAxis, _super);
    function NumericAngleAxis() {
        var _this = _super.call(this) || this;
        _this.lf = null;
        _this.lg = false;
        _this.lh = NaN;
        _this.li = 0;
        _this.ld = null;
        _this.ab = NumericAngleAxis.$;
        _this.lf = new PolarAxisRenderingManager();
        _this.jf = _this.jd();
        return _this;
    }
    NumericAngleAxis.prototype.a1 = function () {
        return new NumericAngleAxisView(this);
    };
    NumericAngleAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.lc = a;
    };
    NumericAngleAxis.prototype.get_b0 = function () {
        return true;
    };
    NumericAngleAxis.prototype.as = function () {
        var _this = this;
        var a = new AngleAxisLabelPanel();
        a.cz = function (b) {
            var c = _this.bf != null ? _this.bf.mq : Rect.empty;
            var d = !c.isEmpty ? _this.i1 : Rect.empty;
            return _this.ls(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, _this.at.a9);
        };
        return a;
    };
    NumericAngleAxis.prototype.lj = function () {
        if (this.le == null) {
            return 0;
        }
        if (!this.by()) {
            return this.le.lo();
        }
        else {
            return this.le.lp((this.e2));
        }
    };
    NumericAngleAxis.prototype.ll = function (a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    };
    NumericAngleAxis.prototype.jd = function () {
        var _this = this;
        var a = _super.prototype.jd.call(this);
        a.b.c = function (b) {
            var e_5, _a;
            if ((_this.aw == null || _this.aw.visibility == 0) && _this.le != null && _this.lh != b) {
                var c = typeCast(XamDataChart.$, _this.bf);
                if (c == null) {
                    return;
                }
                _this.lh = b;
                _this.at.a8 = b;
                c.ht();
                try {
                    for (var _b = __values(fromEnum(c.axes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var d = _c.value;
                        if (d != _this && typeCast(AngleAxisLabelPanel.$, d.at) !== null) {
                            d.a2.ad();
                        }
                    }
                }
                catch (e_5_1) {
                    e_5 = { error: e_5_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_5)
                            throw e_5.error;
                    }
                }
            }
        };
        a.e = function (b) {
            b.n = _this.lj();
            b.r = b.n;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                _this.lf.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.lf.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.lf.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = function (b, c, d, e) {
            var f = typeCast(PolarAxisRenderingParameters.$, _this.jg(b, c, d, e));
            return f;
        };
        a.v = function () {
            if (!_this.lg) {
                _this.lg = true;
                _this.le.cl();
                _this.lg = false;
            }
        };
        a.m = function (b, c) { return _this.getScaledAngle(c); };
        a.o = function (b, c) { return !c.isEmpty && !b.isEmpty && _this.le != null; };
        a.q = function (b, c) {
            if (_this.ll(c - _this.li) < 0) {
                return false;
            }
            if (_this.ll(c - _this.li - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            var f = _this.ls(_this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            var g = _this.ls(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = function (b, c, d, e) {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericAngleAxis.prototype.ls = function (a, b, c, d, e) {
        var f = this.lj();
        var g = ViewportUtils.b(e, c, d);
        if (this.aw != null && (this.aw.c == 5 || this.aw.c == 1)) {
            g *= -1;
        }
        var h = b.x + (f + g) * Math.cos(a);
        var i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    };
    NumericAngleAxis.prototype.dw = function (a, b) {
        return this.getScaledAngle(a);
    };
    NumericAngleAxis.prototype.getScaledAngle1 = function (a, b, c) {
        var d = 0;
        if (b) {
            d = (Math.log(a) - this.ka) / (this.j9 - this.ka);
        }
        else {
            d = (a - this.j4) / (this.j3 - this.j4);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.li;
    };
    NumericAngleAxis.prototype.getScaledAngle = function (a) {
        return this.getScaledAngle1(a, this.ju, this.b9);
    };
    NumericAngleAxis.prototype.dz = function (a, b) {
        return this.getUnscaledAngle(a);
    };
    NumericAngleAxis.prototype.getUnscaledAngle = function (a) {
        var b = (a - this.li) / (2 * Math.PI);
        if (this.b8) {
            b = 1 - b;
        }
        if (this.ju) {
            return Math.exp(b * (this.j9 - this.ka) + this.ka);
        }
        else {
            return this.j4 + b * (this.j3 - this.j4);
        }
    };
    NumericAngleAxis.prototype.gu = function (a, b, c, d) {
        var e_6, _a, e_7, _b, e_8, _c;
        _super.prototype.gu.call(this, a, b, c, d);
        var e = typeCast(XamDataChart.$, this.bf);
        switch (b) {
            case "CrossingAxis":
                var f = typeCast(NumericRadiusAxis.$, d);
                this.lq(f);
                if (f != null) {
                    f.ly(this);
                }
                this.g6(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.li = this.lm;
                while (this.li < 0) {
                    this.li += 360;
                }
                while (this.li >= 360) {
                    this.li -= 360;
                }
                this.li = (this.lm * Math.PI) / 180;
                this.g6(false);
                try {
                    for (var _d = __values(fromEnum(this.cu())), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var g = _e.value;
                        g.jd(false);
                        g.ik();
                    }
                }
                catch (e_6_1) {
                    e_6 = { error: e_6_1 };
                }
                finally {
                    try {
                        if (_e && !_e.done && (_a = _d.return))
                            _a.call(_d);
                    }
                    finally {
                        if (e_6)
                            throw e_6.error;
                    }
                }
                break;
            case "Label":
                if (e != null) {
                    try {
                        for (var _f = __values(fromEnum(e.axes)), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var h = _g.value;
                            h.g5();
                        }
                    }
                    catch (e_7_1) {
                        e_7 = { error: e_7_1 };
                    }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return))
                                _b.call(_f);
                        }
                        finally {
                            if (e_7)
                                throw e_7.error;
                        }
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    try {
                        for (var _h = __values(fromEnum(e.axes)), _j = _h.next(); !_j.done; _j = _h.next()) {
                            var i = _j.value;
                            if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                                i.g5();
                            }
                        }
                    }
                    catch (e_8_1) {
                        e_8 = { error: e_8_1 };
                    }
                    finally {
                        try {
                            if (_j && !_j.done && (_c = _h.return))
                                _c.call(_h);
                        }
                        finally {
                            if (e_8)
                                throw e_8.error;
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.jf = this.jd();
                this.lo();
                this.cg = true;
                this.g6(false);
                break;
        }
    };
    NumericAngleAxis.prototype.lo = function () {
        this.lh = NaN;
    };
    NumericAngleAxis.prototype.jh = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericAngleAxis.prototype.jg = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.jg.call(this, a, b, c, d));
        var f = this.lf.f(b);
        var g = this.lf.g(b);
        var h = 0.5 * this.le.lj;
        var i = 0.5 * this.le.li;
        var j = f;
        var k = g;
        var l = this.le.lo();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        var m = a.width;
        this.lf.k(b, e, this.j4, this.j3, this.b8, runOn(this, this.getUnscaledAngle), m);
        var n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    };
    NumericAngleAxis.prototype.getMinMaxAngle = function (a, b, c) {
        var d = this.lf.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    };
    NumericAngleAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = this.jf.c(a, c, b, d, e);
        if (f != null) {
            this.j2 = f.f.m;
            this.j5 = f.f.l;
        }
    };
    Object.defineProperty(NumericAngleAxis.prototype, "le", {
        get: function () {
            if (this.ld != null) {
                return this.ld;
            }
            var a = typeCast(XamDataChart.$, this.bf);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (a.axes._inner[b].cc) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.ld;
        },
        set: function (a) {
            this.ld = a;
        },
        enumerable: true,
        configurable: true
    });
    NumericAngleAxis.prototype.ah = function () {
        return this.le;
    };
    NumericAngleAxis.prototype.lq = function (a) {
        this.le = a;
    };
    NumericAngleAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cl();
        }
    };
    NumericAngleAxis.prototype.get_az = function () {
        return 2;
    };
    Object.defineProperty(NumericAngleAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    NumericAngleAxis.prototype.it = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        if (this.le == null) {
            return null;
        }
        var f = typeCast(PolarAxisRenderingParameters.$, this.jg(c, b, d, e));
        if (f == null) {
            return null;
        }
        var g = Math.cos(a);
        var h = Math.sin(a);
        var i = f.center.x + g * f.minLength;
        var j = f.center.y + h * f.minLength;
        var k = f.center.x + g * f.maxLength;
        var l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        var m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    };
    NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
    NumericAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'g0', ['StartAngleOffset:lm:lr', [1, 0]]);
    return NumericAngleAxis;
}(NumericAxisBase));
/**
 * @hidden
 */
var NumericRadiusAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericRadiusAxis, _super);
    function NumericRadiusAxis() {
        var _this = _super.call(this) || this;
        _this.lf = null;
        _this.lg = false;
        _this.lh = NaN;
        _this.lj = 0;
        _this.li = 0;
        _this.ll = 0;
        _this.lc = null;
        _this.ab = NumericRadiusAxis.$;
        _this.lj = _this.lt;
        _this.li = _this.ls;
        _this.lf = new PolarAxisRenderingManager();
        _this.jf = _this.jd();
        return _this;
    }
    NumericRadiusAxis.prototype.a1 = function () {
        return new NumericRadiusAxisView(this);
    };
    NumericRadiusAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.le = a;
    };
    NumericRadiusAxis.prototype.get_cc = function () {
        return true;
    };
    NumericRadiusAxis.prototype.dv = function () {
        var a = this.lj;
        var b = this.li;
        var c = Math.min(this.ln(), this.lm()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    };
    NumericRadiusAxis.prototype.ln = function () {
        return this.i1.width;
    };
    NumericRadiusAxis.prototype.lm = function () {
        return this.i1.height;
    };
    NumericRadiusAxis.prototype.as = function () {
        return new RadialAxisLabelPanel();
    };
    NumericRadiusAxis.prototype.lk = function (a) {
        if (a == null) {
            return 0;
        }
        return a;
    };
    NumericRadiusAxis.prototype.jd = function () {
        var _this = this;
        var a = _super.prototype.jd.call(this);
        a.b.c = function (b) {
            if ((_this.aw == null || _this.aw.visibility == 0) && _this.ld != null) {
                if ((_this.aw == null || (_this.aw.c == 4 || _this.aw.c == 5)) && _this.lh != b) {
                    _this.lh = b;
                    _this.at.a8 = b;
                    _this.bf.ht();
                }
            }
        };
        a.k = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            _this.lf.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = function (b, c, d, e) {
            if (d == e) {
                return;
            }
            var f = typeCast(PolarAxisRenderingParameters.$, b);
            _this.lf.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = function (b, c) { return _this.lp(c); };
        a.q = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = function (b) {
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            _this.lf.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = function (b) {
            b.n = _this.aw == null || (_this.aw.c == 4 || _this.aw.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            var c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (_this.lk(_this.e2) * Math.PI) / 180;
            if (_this.aw == null || (_this.aw.c == 4 || _this.aw.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                var d = typeCast(RadialAxisLabelPanel.$, _this.at);
                if (d != null) {
                    var e = 0;
                    if (_this.aw != null && _this.aw.c == 4) {
                        e = 1;
                    }
                    d.dh = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.de = c.crossingAngleRadians;
                }
            }
        };
        a.p = function (b, c, d) {
            var e = typeCast(PolarAxisRenderingParameters.$, b);
            if (_this.ld == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            var f = false;
            f = _this.aw == null || (_this.aw.c == 4 || _this.aw.c == 5);
            var g = 0;
            if (f) {
                g = _this.ll;
            }
            var h = e.center.x + c * Math.cos(g);
            var i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = function (b, c) {
            var d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = function (b, c, d, e) {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    };
    NumericRadiusAxis.prototype.dw = function (a, b) {
        return this.lp(a);
    };
    NumericRadiusAxis.prototype.lq = function (a, b, c, d, e) {
        var f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.j4) - this.ka) / (this.j9 - this.ka);
            }
            else {
                f = (Math.log(a) - this.ka) / (this.j9 - this.ka);
            }
        }
        else {
            f = (a - this.j4) / (this.j3 - this.j4);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    };
    NumericRadiusAxis.prototype.lp = function (a) {
        return this.lq(a, this.ju, this.b9, this.lj, this.li);
    };
    NumericRadiusAxis.prototype.lr = function (a) {
        var b = a * 2;
        b = (b - this.li) / (this.lj - this.li);
        if (this.b8) {
            b = 1 - b;
        }
        if (this.ju) {
            return Math.exp(b * (this.j9 - this.ka) + this.ka);
        }
        else {
            return this.j4 + b * (this.j3 - this.j4);
        }
    };
    NumericRadiusAxis.prototype.dz = function (a, b) {
        return this.lr(a);
    };
    NumericRadiusAxis.prototype.gu = function (a, b, c, d) {
        var e_9, _a, e_10, _b;
        switch (b) {
            case "CrossingValue":
                this.ll = this.lk(this.e2) * Math.PI / 180;
                break;
        }
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.lj = this.lt;
                if (this.lj < 0) {
                    this.lj = 0.1;
                }
                if (this.lj > 1) {
                    this.lj = 1;
                }
                if (this.li >= this.lj) {
                    this.li = this.lj - 0.01;
                    if (this.li < 0) {
                        this.li = 0;
                        this.lj = 0.01;
                    }
                }
                this.cg = true;
                this.g6(false);
                if (this.ld != null) {
                    this.ld.g5();
                }
                try {
                    for (var _c = __values(fromEnum(this.cu())), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        e.jd(false);
                    }
                }
                catch (e_9_1) {
                    e_9 = { error: e_9_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_9)
                            throw e_9.error;
                    }
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.li = this.ls;
                if (this.li < 0) {
                    this.li = 0.1;
                }
                if (this.li > 1) {
                    this.li = 1;
                }
                if (this.li >= this.lj) {
                    this.li = this.lj - 0.01;
                    if (this.li < 0) {
                        this.li = 0;
                        this.lj = 0.01;
                    }
                }
                this.cg = true;
                this.g6(false);
                if (this.ld != null) {
                    this.ld.g5();
                }
                try {
                    for (var _e = __values(fromEnum(this.cu())), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var f = _f.value;
                        f.dl = true;
                        f.jd(false);
                    }
                }
                catch (e_10_1) {
                    e_10 = { error: e_10_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_10)
                            throw e_10.error;
                    }
                }
                if (this.bf != null) {
                    this.bf.h1();
                }
                break;
            case "CrossingAxis":
                var g = typeCast(NumericAngleAxis.$, d);
                var h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.ly(null);
                }
                if (g != null) {
                    this.ly(g);
                    g.lq(this);
                }
                if (h != null) {
                    this.ly(h);
                    h.ls(this);
                }
                this.cg = true;
                this.g6(false);
                break;
            case "IsInverted":
                if (this.ld != null) {
                    this.ld.cg = true;
                    this.ld.g6(false);
                }
                break;
        }
    };
    NumericRadiusAxis.prototype.ly = function (a) {
        this.ld = a;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "ld", {
        get: function () {
            if (this.lc != null) {
                return this.lc;
            }
            var a = typeCast(XamDataChart.$, this.bf);
            if (a != null) {
                for (var b = 0; b < a.axes.count; b++) {
                    if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                        return a.axes._inner[b];
                    }
                }
            }
            return this.lc;
        },
        set: function (a) {
            this.lc = a;
        },
        enumerable: true,
        configurable: true
    });
    NumericRadiusAxis.prototype.ah = function () {
        return this.ld;
    };
    NumericRadiusAxis.prototype.jh = function () {
        return new PolarAxisRenderingParameters();
    };
    NumericRadiusAxis.prototype.jg = function (a, b, c, d) {
        var e = typeCast(PolarAxisRenderingParameters.$, _super.prototype.jg.call(this, a, b, c, d));
        var f = this.lf.f(b);
        var g = this.lf.g(b);
        var h = 0.5 * this.lj;
        var i = 0.5 * this.li;
        var j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.m0)) {
            k = this.j3;
            j = this.j4;
        }
        else {
            k = Math.min(g, h);
            j = this.lr(f);
            k = this.lr(k);
            var l = this.lz(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        var m = { $type: Point_$type, x: 0.5, y: 0.5 };
        var n = f;
        var o = g;
        var p = Math.min(a.width, a.height) * (this.lj - this.li) / 2;
        e.center = m;
        var q = Math.max(o, n);
        var r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        var s = Math.min(j, k);
        var t = Math.max(j, k);
        if (s < this.j4) {
            s = this.j4;
        }
        if (t > this.j3) {
            t = this.j3;
        }
        this.j7 = s;
        this.j6 = t;
        e.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        var u = typeCast(IAngleScaler_$type, this.ld);
        if (u != null) {
            var v = void 0;
            var w = void 0;
            var x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        var y = this.lo();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.jk;
        var z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.lu(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    };
    NumericRadiusAxis.prototype.lz = function (a, b, c, d) {
        var e = { $type: Point_$type, x: 0.5, y: 0.5 };
        var f = 0;
        if (this.b8) {
            f = this.lp(this.j4);
        }
        else {
            f = this.lp(this.j3);
        }
        var g = 0;
        if (this.e2 != null) {
            g = this.ll;
        }
        var h = e.x + f * Math.cos(g);
        var i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.b8) {
                d = this.j4;
            }
            else {
                d = this.j3;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.b8) {
                c = this.j3;
            }
            else {
                c = this.j4;
            }
        }
        return {
            p2: c,
            p3: d
        };
    };
    NumericRadiusAxis.prototype.lu = function (a, b, c, d, e) {
        var f = ViewportUtils.d(c - b, d, e);
        var g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    };
    NumericRadiusAxis.prototype.lo = function () {
        var a = 0;
        if (!this.b8) {
            a = this.lp(this.j3);
        }
        else {
            a = this.lp(this.j4);
        }
        return a;
    };
    NumericRadiusAxis.prototype.k2 = function (a) {
        if (this.ld != null) {
            this.ld.g5();
        }
    };
    NumericRadiusAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = this.jf.c(a, c, b, d, e);
        if (f != null) {
            this.j2 = f.f.m;
            this.j5 = f.f.l;
        }
    };
    NumericRadiusAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cl();
        }
    };
    NumericRadiusAxis.prototype.lx = function (a, b, c, d, e) {
        var f = typeCast(IPolarRadialRenderingParameters_$type, this.jg(b, c, d, e));
        if (f == null) {
            return;
        }
        this.lf.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    };
    NumericRadiusAxis.prototype.get_az = function () {
        return 3;
    };
    Object.defineProperty(NumericRadiusAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    NumericRadiusAxis.prototype.it = function (a, b, c, d, e) {
        if (d === void 0) {
            d = null;
        }
        if (e === void 0) {
            e = null;
        }
        var f = typeCast(PolarAxisRenderingParameters.$, this.jg(c, b, d, e));
        var g = a;
        var h = new PathGeometry();
        var i = ViewportUtils.d(g, b, c);
        var j = ViewportUtils.g(g, b, c);
        if (i <= 0 || j <= 0) {
            return null;
        }
        var k = ViewportUtils.c(f.center.x, b, c);
        var l = ViewportUtils.f(f.center.y, b, c);
        if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
            var m = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
            var n_1 = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
            var o = new PathFigure();
            o._startPoint = m;
            o._isClosed = false;
            o._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = n_1;
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(o);
        }
        else {
            var p = new PathFigure();
            p._startPoint = { $type: Point_$type, x: k, y: l - j };
            p._isClosed = true;
            p._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l + j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            p._segments.add(((function () {
                var $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l - j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(p);
        }
        return h;
    };
    NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
    NumericRadiusAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'g0', ['InnerRadiusExtentScale:ls:l0', [1, 0], 'RadiusExtentScale:lt:l1', [1, 0.75]]);
    return NumericRadiusAxis;
}(NumericAxisBase));
/**
 * @hidden
 */
var AngleAxisLabelPanelView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AngleAxisLabelPanelView, _super);
    function AngleAxisLabelPanelView(a) {
        var _this = _super.call(this, a) || this;
        _this.ax = null;
        _this.ax = a;
        return _this;
    }
    AngleAxisLabelPanelView.prototype.am = function () {
        _super.prototype.am.call(this);
        this.ax.ct = true;
    };
    AngleAxisLabelPanelView.prototype.ay = function (a, b) {
        this.ax.cx = -1.7976931348623157E+308;
        this.ax.cu = -1.7976931348623157E+308;
        this.ax.cw = -1.7976931348623157E+308;
        this.ax.cv = -1.7976931348623157E+308;
        for (var c = 0; c < this.a.a3.count; c++) {
            var d = this.a.a3._inner[c];
            var e = this.a.a2._inner[c];
            var f = e.a;
            var g = this.ax.cz(e.c);
            var h = this.m(d);
            var i = this.l(d);
            var j = h + this.p() + this.q();
            var k = i + this.r() + this.o();
            var l = g.x - j / 2;
            var m = g.y - k / 2;
            this.ax.cw = Math.max(h, this.ax.cw);
            this.ax.cv = Math.max(i, this.ax.cv);
            this.ax.cx = Math.max(j, this.ax.cx);
            this.ax.cu = Math.max(k, this.ax.cu);
            var n = new Rect(0, l, m, j, k);
            a.add(n);
            b.add(f);
        }
    };
    AngleAxisLabelPanelView.prototype.o = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.p = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.q = function () {
        return 0;
    };
    AngleAxisLabelPanelView.prototype.r = function () {
        return 0;
    };
    AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
    return AngleAxisLabelPanelView;
}(AxisLabelPanelBaseView));
/**
 * @hidden
 */
var CategoryAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryAngleAxisView, _super);
    function CategoryAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
    return CategoryAngleAxisView;
}(CategoryAxisBaseView));
/**
 * @hidden
 */
var NumericAngleAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericAngleAxisView, _super);
    function NumericAngleAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
    return NumericAngleAxisView;
}(NumericAxisBaseView));
/**
 * @hidden
 */
var NumericRadiusAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericRadiusAxisView, _super);
    function NumericRadiusAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
    return NumericRadiusAxisView;
}(NumericAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories.
*
* `IgrCategoryAngleAxis` represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories
*
* ```ts
* <IgrDataChart
* 	ref={this.onChartRef}
* 	dataSource={this.state.dataSource}
* 	width="100%"
* 	height="100%" >
*
*     <IgrCategoryAngleAxis name="angleAxis" label="Department" />
*     <IgrNumericRadiusAxis name="radiusAxis" />
*
* </IgrDataChart>
* ```
*/
var IgrCategoryAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryAngleAxis, _super);
    function IgrCategoryAngleAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryAngleAxis.prototype.createImplementation = function () {
        return new CategoryAngleAxis();
    };
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "isAngular", {
        /**
         * Checks if the axis is of angular type
        */
        get: function () {
            return this.i.b0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "startAngleOffset", {
        /**
         * Indicates the angle in degress that the chart's 0th angle should be offset.
        *
        * Indicates the angle in degress that the chart's 0th angle should be offset.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}   >
        *
        *     <IgrCategoryAngleAxis name="angleAxis" startAngleOffset ={30} />
        *     <IgrNumericRadiusAxis name="radiusAxis" />
        *
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.li;
        },
        set: function (v) {
            this.i.li = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "interval", {
        /**
         * Gets or sets the frequency of displayed labels.
         * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        *
        * Gets or sets the frequency of displayed labels.The set value is a factor that determines which labels will be hidden.
        * For example, an interval of 2 will display every other label.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}   >
        *
        *     <IgrCategoryAngleAxis name="angleAxis" interval ={2} />
        *     <IgrNumericRadiusAxis name="radiusAxis" />
        *
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.lf;
        },
        set: function (v) {
            this.i.lf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        *
        * Gets the effective value for the current Interval.
        *
        * ```ts
        *
        * 	<IgrDataChart
        * 	ref={this.onChartRef}
        * 	dataSource={this.state.dataSource}
        * 	width="100%"
        * 	height="100%" >
        *
        *     <IgrCategoryAngleAxis name="angleAxis" label="Department" actualInterval={5} />
        *     <IgrNumericRadiusAxis name="radiusAxis" />
        *
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.k9;
        },
        set: function (v) {
            this.i.k9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        *
        * Gets or sets the frequency of displayed minor lines. The set value is a factor that determines how the minor lines will be displayed.
        *
        * ```ts
        *    <IgrDataChart
        * 	ref={this.onChartRef}
        * 	dataSource={this.state.dataSource}
        * 	width="100%"
        * 	height="100%" >
        *
        *     <IgrCategoryAngleAxis name="angleAxis" label="Department" minorInterval={5} />
        *     <IgrNumericRadiusAxis name="radiusAxis" />
        *
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.lg;
        },
        set: function (v) {
            this.i.lg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryAngleAxis.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        *
        * Get the effective value for the current minorInterval.
        *
        * ```ts
        *    <IgrDataChart
        * 	ref={this.onChartRef}
        * 	dataSource={this.state.dataSource}
        * 	width="100%"
        * 	height="100%" >
        *
        *     <IgrCategoryAngleAxis name="angleAxis" label="Department" actualMinorInterval={5} />
        *     <IgrNumericRadiusAxis name="radiusAxis" />
        *
        * </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.la;
        },
        set: function (v) {
            this.i.la = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the scaled angle in radians from the raw axis value.
    
    * @param unscaledAngle  * The raw axis value.
    */
    IgrCategoryAngleAxis.prototype.getScaledAngle = function (unscaledAngle) {
        var iv = this.i.getScaledAngle(unscaledAngle);
        return (iv);
    };
    /**
     * Gets the raw axis value from the scaled angle in radians.
    
    */
    IgrCategoryAngleAxis.prototype.getUnscaledAngle = function (scaledAngle) {
        var iv = this.i.getUnscaledAngle(scaledAngle);
        return (iv);
    };
    return IgrCategoryAngleAxis;
}(IgrCategoryAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryAngleAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryAngleAxisModule() {
    }
    IgrCategoryAngleAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrCategoryAngleAxis", IgrCategoryAngleAxis);
        TypeRegistrar.register("CategoryAngleAxis", CategoryAngleAxis.$type);
    };
    return IgrCategoryAngleAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SortedListView$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SortedListView$1, _super);
    function SortedListView$1($t, a, b) {
        var _this = _super.call(this) || this;
        _this.$t = null;
        _this.c = null;
        _this.d = null;
        _this.$t = $t;
        _this.$type = _this.$type.specialize(_this.$t);
        _this.c = b;
        _this.d = a;
        return _this;
    }
    SortedListView$1.prototype.add = function (a) {
        throw new NotImplementedException(0);
    };
    SortedListView$1.prototype.clear = function () {
        throw new NotImplementedException(0);
    };
    SortedListView$1.prototype.contains = function (a) {
        return this.d.contains(a);
    };
    SortedListView$1.prototype.indexOf = function (a) {
        return this.c.indexOf(this.d.indexOf(a));
    };
    SortedListView$1.prototype.insert = function (a, b) {
        throw new NotImplementedException(0);
    };
    Object.defineProperty(SortedListView$1.prototype, "a", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SortedListView$1.prototype, "isReadOnly", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    SortedListView$1.prototype.remove = function (a) {
        throw new NotImplementedException(0);
    };
    SortedListView$1.prototype.removeAt = function (a) {
        throw new NotImplementedException(0);
    };
    SortedListView$1.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            throw new NotImplementedException(0);
            return b;
        }
        else {
            return this.d.item(this.c.item(a));
        }
    };
    Object.defineProperty(SortedListView$1.prototype, "count", {
        get: function () {
            return this.d.count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SortedListView$1.prototype, "b", {
        get: function () {
            throw new NotImplementedException(0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SortedListView$1.prototype, "e", {
        get: function () {
            throw new NotImplementedException(0);
        },
        enumerable: true,
        configurable: true
    });
    SortedListView$1.prototype._getEnumeratorObject = function () {
        var a;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = 0;
                    _a.label = 1;
                case 1:
                    if (!(a < this.count))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, getBoxIfEnum(this.$t, this.item(a))];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    a++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    SortedListView$1.prototype.getEnumeratorObject = function () {
        var _this = this;
        return toEnum(function () { return _this._getEnumeratorObject(); }).getEnumeratorObject();
    };
    SortedListView$1.prototype._getEnumerator = function () {
        var a;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    a = 0;
                    _a.label = 1;
                case 1:
                    if (!(a < this.count))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, this.item(a)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    a++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    SortedListView$1.prototype.getEnumerator = function () {
        var _this = this;
        return toEnum(function () { return _this._getEnumerator(); }).getEnumerator();
    };
    SortedListView$1.prototype.copyTo = function (a, b) {
        throw new NotImplementedException(0);
    };
    SortedListView$1.$t = markType(SortedListView$1, 'SortedListView$1', Base.$, [IList$1_$type.specialize(0)]);
    return SortedListView$1;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeAxisBase, _super);
    function TimeAxisBase() {
        var _this = _super.call(this) || this;
        _this.kw = null;
        _this.k5 = null;
        _this.k0 = false;
        _this.k8 = dateMaxValue();
        _this.k7 = dateMinValue();
        FastItemDateTimeColumn.o();
        return _this;
    }
    TimeAxisBase.prototype.dw = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.ld(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ld(a, b.e, b.d, b.c);
    };
    TimeAxisBase.prototype.e4 = function (a, b) {
        var c = this.fv(b);
        if (c == this.dateTimeMemberPath) {
            return this.e5(a, b, this.dateTimeMemberPath);
        }
        return _super.prototype.e4.call(this, a, b);
    };
    TimeAxisBase.prototype.ld = function (a, b, c, d) {
        var e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.b8) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    };
    TimeAxisBase.prototype.le = function (a, b, c) {
        var d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var e = 0;
        if (this.b8) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    };
    TimeAxisBase.prototype.dz = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.d.left;
            var d = b.d.width;
            if (this.categoryMode != 0) {
                var e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            var f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (this.b8) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    };
    TimeAxisBase.prototype.i$h = function () {
        this.lt();
    };
    TimeAxisBase.prototype.lt = function () {
        var a = this.bf != null ? this.bf.mq : Rect.empty;
        var b = !a.isEmpty ? this.i1 : Rect.empty;
        var c = (new Date());
        var d = (new Date());
        var e = false;
        if (!a.isEmpty && !b.isEmpty && this.kx != null) {
            var f = typeCast(FastItemDateTimeColumn.$, this.kx);
            if (f != null) {
                if (this.k6 == null) {
                    this.lu();
                }
            }
            else {
                this.k6 = null;
            }
            if (this.kx.count > 0) {
                e = true;
                var g = this.k6 == null ? 0 : this.k6._inner[0];
                var h = this.k6 == null ? this.kx.count - 1 : this.k6._inner[this.kx.count - 1];
                c = this.kx.item(g);
                d = this.kx.item(h);
                this.k1 = false;
                if (this.categoryMode == 2) {
                    var i = this.lr(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.k4()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.k3()) {
            e = true;
            d = this.maximumValue;
        }
        var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            var k = this.actualMinimumValue;
            var l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.ly();
        }
    };
    TimeAxisBase.prototype.ly = function () {
    };
    Object.defineProperty(TimeAxisBase.prototype, "kx", {
        get: function () {
            return this.kw;
        },
        set: function (a) {
            if (this.kw != a) {
                var b = this.kw;
                this.kw = a;
                this.g0("DateTimeColumn", b, this.kw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "k6", {
        get: function () {
            return this.k5;
        },
        set: function (a) {
            this.k5 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$b", {
        get: function () {
            if (this.k6 == null) {
                var a = typeCast(FastItemDateTimeColumn.$, this.kx);
                if (a != null) {
                    this.lu();
                }
                else {
                    this.k6 = null;
                }
            }
            return this.k6;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.lu = function () {
        if (this.k2) {
            this.k6 = new List$1(Number_$type, 0);
            var a = this.k6;
            var b = this.kx.count;
            for (var c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            var d = typeCast(FastItemDateTimeColumn.$, this.kx);
            this.k6 = d.h();
        }
    };
    TimeAxisBase.prototype.i$e = function (a, b, c, d) {
        return this.lg(a, b, c, d);
    };
    TimeAxisBase.prototype.lg = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.b8, c);
        var g, h;
        if (this.b8) {
            h = this.dz(e.left, f);
            g = this.dz(e.right, f);
        }
        else {
            g = this.dz(e.left, f);
            h = this.dz(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.lf(dateFromTicks(i));
    };
    TimeAxisBase.prototype.lf = function (a) {
        if (this.kx == null || this.k6.count != this.kx.count) {
            return -1;
        }
        for (var b = 0; b < this.k6.count; b++) {
            var c = this.kx.item(this.k6._inner[b]);
            if (c >= a) {
                return Math.max(b - 1, 0);
            }
        }
        return this.k6.count - 1;
    };
    TimeAxisBase.prototype.i$g = function (a, b, c, d) {
        return this.lj(a, b, c, d);
    };
    TimeAxisBase.prototype.lj = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.b8, c);
        var g, h;
        if (this.b8) {
            h = this.dz(e.left, f);
            g = this.dz(e.right, f);
        }
        else {
            g = this.dz(e.left, f);
            h = this.dz(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.li(dateFromTicks(i));
    };
    TimeAxisBase.prototype.li = function (a) {
        if (this.kx == null || this.k6.count != this.kx.count) {
            return -1;
        }
        for (var b = this.k6.count - 1; b >= 0; b--) {
            var c = this.k6._inner[b];
            var d = this.kx.item(c);
            if (d < a) {
                return b == this.k6.count - 1 ? b : b + 1;
            }
        }
        return 0;
    };
    TimeAxisBase.prototype.i$d = function (a) {
        if (this.kx == null) {
            return NaN;
        }
        var b = this.kw.item(a);
        var c = b.getTime();
        var d = c;
        return d;
    };
    TimeAxisBase.prototype.i$c = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.kx, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.lh(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var diff1_ = d.getTime() - c.item(e - 1).getTime();
            var diff2_ = c.item(e).getTime() - d.getTime();
            var f = e - 1;
            var g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            var h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        var i = this.iw();
        if (e == b.i$b.count && this.bf != null && this.dw(a, new ScalerParams(0, this.bf.mq, this.i1, this.b8, i)) < (this.i1.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bf != null && Math.abs(this.dw(a, new ScalerParams(0, this.bf.mq, this.i1, this.b8, i)) - this.i1.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.lh = function (a, b) {
        var c = this;
        if (this.kx == null || c.i$b == null) {
            return -1;
        }
        var d = -1;
        var e = ArrayExtension.binarySearch$11(Date_$type, b, function (f) {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    };
    TimeAxisBase.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null || this.kx == null || b.i$b.count != this.kx.count) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.kx, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.lh(d, c);
        var f = this.iw();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var g = +d - +(c.item(e - 1));
            var h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bf != null && this.dw(a, new ScalerParams(0, this.bf.mq, this.i1, this.b8, f)) < (this.i1.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bf != null && Math.abs(this.dw(a, new ScalerParams(0, this.bf.mq, this.i1, this.b8, f)) - this.i1.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.i$i = function () {
        this.k6 = null;
        this.g5();
    };
    TimeAxisBase.prototype.get_k1 = function () {
        return this.k0;
    };
    TimeAxisBase.prototype.set_k1 = function (a) {
        this.k0 = a;
    };
    Object.defineProperty(TimeAxisBase.prototype, "k1", {
        get: function () {
            return this.get_k1();
        },
        set: function (a) {
            this.set_k1(a);
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.gw = function (a) {
        _super.prototype.gw.call(this, a);
        this.dateTimeMemberPath = a;
    };
    TimeAxisBase.prototype.gz = function (a) {
        _super.prototype.gz.call(this, a);
        this.minimumValue = a;
    };
    TimeAxisBase.prototype.gy = function (a) {
        _super.prototype.gz.call(this, a);
        this.maximumValue = a;
    };
    TimeAxisBase.prototype.cn = function () {
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        var a = this.actualMinimumValue.getTime();
        var b = this.actualMaximumValue.getTime();
        this.lt();
        var c = !this.k4() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        var d = !this.k3() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        var e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.g1(e);
        return true;
    };
    TimeAxisBase.prototype.k4 = function () {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    };
    TimeAxisBase.prototype.k3 = function () {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
        get: function () {
            return this.k8;
        },
        set: function (a) {
            var b = +(this.k8) != +a;
            if (b) {
                var c = this.k8;
                this.k8 = a;
                this.g0("ActualMinimumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.e9 = function () {
        return this.actualMinimumValue;
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
        get: function () {
            return this.k7;
        },
        set: function (a) {
            var b = +(this.k7) != +a;
            if (b) {
                var c = this.k7;
                this.k7 = a;
                this.g0("ActualMaximumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.e8 = function () {
        return this.maximumValue;
    };
    TimeAxisBase.prototype.lv = function (a) {
        var e_1, _a;
        this.g7(a);
        if (this.jf == null) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.jd(a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    TimeAxisBase.prototype.gu = function (a, b, c, d) {
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.kx);
                    this.kx = null;
                    e.event = delegateRemove(e.event, runOn(this, this.ls));
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.k6 = null;
                    this.kx = this.ky(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.ls));
                }
                this.lv(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.jf != null) {
                    this.jf.deregisterColumn(this.kx);
                    this.kx = this.ky(this.dateTimeMemberPath);
                    this.k6 = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cl();
                this.lv(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cl();
                this.lv(false);
                break;
            case "DateTimeColumn":
                this.lt();
                break;
        }
    };
    TimeAxisBase.prototype.ls = function (a, b) {
        this.k6 = null;
    };
    TimeAxisBase.prototype.ky = function (a) {
        return TimeAxisBase.kz(a, this);
    };
    TimeAxisBase.kz = function (a, b) {
        if (a == null) {
            return b.jf.registerColumnDateTime(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.bb(a, b.coercionMethods);
        c = d.a;
        return b.jf.registerColumnDateTime(a, c, b.expectFunctions);
    };
    TimeAxisBase.prototype.as = function () {
        if (this.cp) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    TimeAxisBase.prototype.get_az = function () {
        return 0;
    };
    Object.defineProperty(TimeAxisBase.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.a2.ay();
        var c = this.a2.a1();
        var d = this.a2.az();
        var e = this.a2.a0();
        var f = this.a2.e();
        var g = this.a2.f();
        var h = this.a2.g();
        this.he();
        this.gi(b);
        this.gi(c);
        this.gi(d);
        this.gi(e);
        this.cv.clear();
        this.cw.clear();
        this.jm.clear();
        this.at.ac = this;
        var i = this.bf != null ? this.bf.mq : Rect.empty;
        var j = !i.isEmpty ? this.i1 : Rect.empty;
        this.at.cp = i;
        this.at.co = j;
        if (i.isEmpty || j.isEmpty) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
        }
        if (this.bo.count == 0) {
            this.at.ab.clear();
        }
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        this.lt();
    };
    TimeAxisBase.prototype.get_b5 = function () {
        return true;
    };
    TimeAxisBase.prototype.startCursor = function () {
    };
    TimeAxisBase.prototype.resetCursor = function () {
    };
    TimeAxisBase.prototype.StartTimeCursor = function () {
        this.startCursor();
    };
    TimeAxisBase.prototype.ResetTimeCursor = function () {
        this.resetCursor();
    };
    TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
        if (this.jy == 0) {
            return 0;
        }
        var d = this.iz(b, c);
        return d.width / (this.jy * a.width);
    };
    TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    };
    TimeAxisBase.prototype.jr = function (a, b, c) {
        var d = !isNaN_(this.jo) ? MathUtil.b(this.jo, 0, 1) : 0;
        var e = 1 - 0.5 * d;
        var f = this.getCategorySize(a, b, c) * e;
        return f;
    };
    TimeAxisBase.prototype.get_cd = function () {
        return true;
    };
    TimeAxisBase.prototype.lr = function (a, b) {
        return (0);
    };
    TimeAxisBase.prototype.preferredCategoryMode = function (a) {
        return this.b3 ? 0 : 1;
    };
    Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(TimeAxisBase.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$a", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'g0', ['DateTimeMemberPath::lz', [2, null], 'IsDataPreSorted:k2:l0', [0, false], 'MaximumValue::l1', [3, null], 'MinimumValue::l2', [3, null]]);
    return TimeAxisBase;
}(CategoryAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for displaying of gridlines, tickmarks, and labels on a time axis.
 */
var TimeAxisDisplayType = /*@__PURE__*/ (function (TimeAxisDisplayType) {
    /**
     * Points occur at even intervals, even where data is not present at a given point.
     */
    TimeAxisDisplayType[TimeAxisDisplayType["Continuous"] = 0] = "Continuous";
    /**
     * Points occur when data is present, possibly at uneven intervals.
     */
    TimeAxisDisplayType[TimeAxisDisplayType["Discrete"] = 1] = "Discrete";
    return TimeAxisDisplayType;
})({});
/**
 * @hidden
 */
var TimeAxisDisplayType_$type = /*@__PURE__*/ markEnum('TimeAxisDisplayType', 'Continuous,0|Discrete,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryDateTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryDateTimeXAxis, _super);
    function CategoryDateTimeXAxis() {
        var _this = _super.call(this) || this;
        _this.l9 = 0;
        _this.ma = 0;
        _this.ab = CategoryDateTimeXAxis.$;
        _this.actualMinimumValue = (new Date());
        _this.actualMaximumValue = (new Date());
        return _this;
    }
    CategoryDateTimeXAxis.prototype.get_b4 = function () {
        return this.l4 == 0;
    };
    CategoryDateTimeXAxis.prototype.a1 = function () {
        return new CategoryDateTimeXAxisView(this);
    };
    CategoryDateTimeXAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.l3 = a;
    };
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "mb", {
        get: function () {
            return this.l9;
        },
        set: function (a) {
            if (this.mb != a) {
                var b = this.l9;
                this.l9 = a;
                this.g0("ActualInterval", b, this.mb);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryDateTimeXAxis.prototype.d7 = function () {
        return this.mb;
    };
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "mf", {
        get: function () {
            return typeGetValue(this.c(CategoryDateTimeXAxis.mq));
        },
        set: function (a) {
            this.h(CategoryDateTimeXAxis.mq, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "mc", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            if (this.mc != a) {
                var b = this.ma;
                this.ma = a;
                this.g0("ActualMinorInterval", b, this.mc);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryDateTimeXAxis.prototype.cr = function (a, b, c) {
        var d = _super.prototype.cr.call(this, a, b, c);
        if (!d) {
            return false;
        }
        return +(this.actualMinimumValue) != +(this.actualMaximumValue);
    };
    CategoryDateTimeXAxis.prototype.dj = function () {
        return this.mb;
    };
    CategoryDateTimeXAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = new ScalerParams(0, b, c, this.b8, d);
        if (this.kx == null && !this.k3() && !this.k4()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty && (this.l4 != 1 || this.kx != null)) {
            var g = c.bottom;
            var h = g - c.top;
            if (this.ag != null) {
                var i = typeCast(NumericYAxis.$, this.ag);
                if (i != null) {
                    var j = this.ha(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.gq(this.a2.ay(), g, c, this.a2.e(), true);
            this.at.a8 = h;
            var k = this.a2.a1();
            var l = this.a2.f();
            var m = this.a2.az();
            var n = this.a2.a0();
            var o = this.a2.g();
            if (this.l4 == 1) {
                var p = this.i$e(b, c, d, e);
                var q = this.i$g(b, c, d, e);
                if (p < 0 || q < 0) {
                    return;
                }
                var r = NaN;
                for (var s = p; s <= q; s++) {
                    var t = this.k6 == null ? s : this.k6._inner[s];
                    var u = this.dw(this.kx.item(t).getTime(), f);
                    if (u == r) {
                        continue;
                    }
                    r = u;
                    if (this.categoryMode == 2) {
                        u += this.b8 ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                    }
                    if (u < e.left || u > e.right) {
                        continue;
                    }
                    this.hf(m, u, c, l, false);
                    this.jm.add(u);
                    if (this.jf != null && s < this.jf.count) {
                        var v = this.jf.item(t);
                        var w = _super.prototype.e6.call(this, v);
                        if (!isNaN_(u) && !isInfinity(u) && w != null) {
                            if ((typeof w === 'string') && Base.equalsStatic(w, "")) {
                            }
                            else {
                                this.cv.add1(w);
                                this.cw.add(new LabelPosition(u));
                            }
                        }
                    }
                }
            }
            else {
                var x = this.dz(e.left, f);
                var y = this.dz(e.right, f);
                var z = Math.min(x, y);
                var aa = Math.max(x, y);
                var ab = new LinearNumericSnapper(0, z, aa, e.width, this.d9());
                var ac = this.k1 ? this.l8() : ab.g;
                this.mm(truncate(ac));
                var ad = truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                var ae = truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                var af = 0;
                if (this.categoryMode == 2) {
                    af = this.getGroupCenter(0, b, c, d);
                    af = this.b8 ? -af : af;
                }
                var ag = truncate(Math.ceil(e.right));
                var ah = truncate(Math.floor(e.left));
                var ai = this.dw(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                for (var aj = ad; aj <= ae; aj++) {
                    var ak = this.dw(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                    if (!isNaN_(ai) && !isInfinity(ai)) {
                        var al = truncate(Math.round(ai));
                        if (al <= ag) {
                            if (aj % 2 == 0) {
                                this.hg(k, ai, ak, c);
                            }
                            this.hf(m, ai, c, l, false);
                            this.jm.add(ai);
                            if (this.cj) {
                                var am = this.md();
                                if (am > 0 && am < ac) {
                                    if (ac / am < 20) {
                                        var an = ai;
                                        var ao = Math.abs(this.dw(this.actualMinimumValue.getTime() + am, f) - this.dw(this.actualMinimumValue.getTime(), f));
                                        while (an + ao < ak) {
                                            if (Math.abs(an + ao - ak) < 0.0001) {
                                                break;
                                            }
                                            an += ao;
                                            if (an > 0) {
                                                this.hf(n, an, c, o, false);
                                            }
                                        }
                                        this.mn(am);
                                    }
                                }
                                else {
                                    for (var ap = 1; ap < ab.i; ++ap) {
                                        var aq = this.dw(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                        this.hf(n, aq, c, o, false);
                                    }
                                    if (ab.i > 0) {
                                        this.mn(truncate((ac / ab.i)));
                                    }
                                }
                            }
                        }
                        if (al >= ah && al <= ag) {
                            var ar = this.actualMinimumValue.getTime() + aj * ac;
                            var ticks_ = truncate(Math.floor(ar));
                            var as = (new Date(ticks_));
                            var at = this.e6(as);
                            if (at != null) {
                                this.cv.add1(at);
                                this.cw.add(new LabelPosition(ai));
                            }
                        }
                    }
                    ai = ak;
                }
            }
            if ((this.aw == null || this.aw.visibility == 0) && this.ag != null) {
                if (this.aw != null && (this.aw.location == 4 || this.aw.location == 5)) {
                    this.bf.ht();
                }
            }
            this.at.a1 = this.cv;
            this.at.a2 = this.cw;
            this.km();
        }
    };
    CategoryDateTimeXAxis.prototype.l8 = function () {
        return this.mb;
    };
    CategoryDateTimeXAxis.prototype.md = function () {
        return this.mf;
    };
    CategoryDateTimeXAxis.prototype.mm = function (a) {
        this.mb = a;
    };
    CategoryDateTimeXAxis.prototype.mn = function (a) {
        this.mc = a;
    };
    CategoryDateTimeXAxis.prototype.l6 = function () {
        return this.me != 0;
    };
    CategoryDateTimeXAxis.prototype.l5 = function () {
        return this.mb == 0;
    };
    CategoryDateTimeXAxis.prototype.l7 = function (a) {
        return this.kx == null ? dateMinValue() : this.kx.item(a);
    };
    CategoryDateTimeXAxis.prototype.ml = function (a, b) {
        if (a > b || this.jf == null || this.jf.count == 0) {
            return;
        }
        var c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        var d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        this.bf.m4 = new Rect(0, c, this.bf.m4.y, d - c, this.bf.m4.height);
    };
    CategoryDateTimeXAxis.prototype.gu = function (a, b, c, d) {
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case CategoryDateTimeXAxis.$$p[0]:
                this.cg = true;
                this.at.ak = this.l4 == 1;
                this.g6(false);
                break;
            case CategoryDateTimeXAxis.$$p[1]:
                this.cg = true;
                this.g6(false);
                break;
        }
    };
    CategoryDateTimeXAxis.prototype.lt = function () {
        _super.prototype.lt.call(this);
        if (this.l6()) {
            this.mb = this.me;
            var a = this.bf != null ? this.bf.mq : Rect.empty;
            var b = !a.isEmpty ? this.i1 : Rect.empty;
            var c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.k1 = this.l5() || (this.l4 == 1) || (1 * c / this.l8() > (b.width / a.width)) ? false : true;
        }
        else {
            this.k1 = false;
        }
    };
    CategoryDateTimeXAxis.prototype.lr = function (a, b) {
        var c = b.getTime() - a.getTime();
        var timeOffset_ = truncate(Math.round(intDivide(c, this.jy) / 2));
        return timeOffset_ == 0 ? timeSpanFromMilliseconds(1) : timeSpanFromMilliseconds(timeOffset_);
    };
    CategoryDateTimeXAxis.prototype.get_b3 = function () {
        return true;
    };
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    CategoryDateTimeXAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    CategoryDateTimeXAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryDateTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    CategoryDateTimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    CategoryDateTimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryDateTimeXAxis.prototype, "i$a", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    CategoryDateTimeXAxis.$t = markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
    CategoryDateTimeXAxis.mq = DependencyProperty.i("MinorInterval", Number_$type, CategoryDateTimeXAxis.$, new PropertyMetadata(2, 0, function (a, b) {
        (typeCast(CategoryDateTimeXAxis.$, a)).g0("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryDateTimeXAxis.$, a)).g6(false);
    }));
    CategoryDateTimeXAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryDateTimeXAxis, 'g0', ['DisplayType:l4:mo', [TimeAxisDisplayType_$type, enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:me:mp', [1, 0]]);
    return CategoryDateTimeXAxis;
}(TimeAxisBase));
/**
 * @hidden
 */
var CategoryDateTimeXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryDateTimeXAxisView, _super);
    function CategoryDateTimeXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryDateTimeXAxisView.prototype.o = function (a) {
        var b = this.n(dateFromTicks(truncate(a)));
        return b;
    };
    CategoryDateTimeXAxisView.$t = markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);
    return CategoryDateTimeXAxisView;
}(CategoryAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an category-based horizontal X axis that uses a DateTime scale.
*
* Represents horizontal axis that uses a DateTime scale.
*
* ```ts
*   <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*     <IgrTimeXAxis name="xAxis"
* 	label="Date"
* 	dateTimeMemberPath="Date" />
*  </IgrDataChart>
* ```
*
* ```ts
* timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
* timeXAxis.title = "Time X Axis";
* timeXAxis.dataSource = data;
* timeXAxis.dateTimeMemberPath = "date";
* timeXAxis.label = "Date";
* this.chart.axes.add(xAxis);
* ```
*/
var IgrTimeAxisBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeAxisBase, _super);
    function IgrTimeAxisBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrTimeAxisBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "dateTimeMemberPath", {
        /**
         * Gets or sets the DateTime mapping property for the axis.
        *
        * Use `dateTimeMemberPath` property for DateTime mapping with the axis.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis"
        * 	label="Date"
        * 	dateTimeMemberPath="Date" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
        * timeXAxis.title = "Time X Axis";
        * timeXAxis.dataSource = data;
        * timeXAxis.dateTimeMemberPath = "date";
        * timeXAxis.label = "Date";
        * this.chart.axes.add(xAxis);
        * ```
        */
        get: function () {
            return this.i.dateTimeMemberPath;
        },
        set: function (v) {
            this.i.dateTimeMemberPath = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "isDataPreSorted", {
        /**
         * Gets or sets whether the data assigned to the date time axis should be considered pre-sorted by date/time.
        *
        * Use `isDataPreSorted` property to decide if the data assigned to the date time axis should be considered pre-sorted by date/time.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis"
        * 	label="Date"
        * 	isDataPreSorted={true}
        * 	dateTimeMemberPath="Date" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
        * timeXAxis.title = "Time X Axis";
        * timeXAxis.dataSource = data;
        * timeXAxis.dateTimeMemberPath = "date";
        * timeXAxis.isDataPreSorted= true ;
        * ```
        */
        get: function () {
            return this.i.k2;
        },
        set: function (v) {
            this.i.k2 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "actualMinimumValue", {
        /**
         * Gets the coerced minimum value.
        *
        * Use `actualMinimumValue` to get the coerced maximum value.
        */
        get: function () {
            return this.i.actualMinimumValue;
        },
        set: function (v) {
            this.i.actualMinimumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "actualMaximumValue", {
        /**
         * Gets the coerced maximum value.
        *
        * Use `actualMaximumValue` to get the  coerced maximum value
        */
        get: function () {
            return this.i.actualMaximumValue;
        },
        set: function (v) {
            this.i.actualMaximumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "minimumValue", {
        /**
         * Gets or sets the axis MinimumValue.
        *
        * Use `minimumValue` property for axis minimum value.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis"
        * 	label="Date"
        * 	maximumValue="2019-12-26"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.timeXAxis.maximumValue="2019-12-26";
        * ```
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "maximumValue", {
        /**
         * Gets or sets the axis MaximumValue.
        *
        * Use `maximumValue` property for axis maximum value.
        *
        * ```ts
        * <IgrDataChart
        * dataSource={this.state.dataSource}
        * width="700px"
        * height="500px">
        * <IgrTimeXAxis name="xAxis"
        * label="Date"
        * dateTimeMemberPath="Date"
        * maximumValue ="2019-12-26"
        * />
        * ```
        *
        * ```ts
        * this.timeXAxis.maximumValue="2019-12-26";
        * ```
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "isDateTime", {
        /**
         * Checks if the axis is of date time axis type
        *
        * Use `isDateTime` property to Checks if the axis is of date time axis type.
        *
        * ```ts
        * const isDT = this.timeXAxis.isDateTime;
        * ```
        */
        get: function () {
            return this.i.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeAxisBase.prototype, "isSorting", {
        /**
         * Checks if axis requires sorting of items
        *
        * Use `isSorting` property to Checks if axis requires sorting of items.
        *
        * ```ts
        * const isDT = this.timeXAxis.isDateTime;
        * ```
        */
        get: function () {
            return this.i.cd;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeAxisBase.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.e4(item, memberPathName);
        return (iv);
    };
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    IgrTimeAxisBase.prototype.getIndexClosestToUnscaledValue = function (unscaledValue) {
        var iv = this.i.i$f(unscaledValue);
        return (iv);
    };
    /**
     * Updates the axis when the data has been changed.
    
    */
    IgrTimeAxisBase.prototype.notifyDataChanged = function () {
        this.i.i$i();
    };
    return IgrTimeAxisBase;
}(IgrCategoryAxisBase));

/**
 * Represents a category-based horizontal X axis that uses a DateTime scale.
*
* `IgrCategoryDateTimeXAxis` class represents a category-based horizontal X axis that uses a DateTime scale.
*
* ```ts
*   <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*     <IgrTimeXAxis name="xAxis"
* 			label="Time"
* 			dateTimeMemberPath="time" />
*  </IgrDataChart>
* ```
*
* ```ts
* 	this.timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
* 	this.timeXAxis.title = "Time X Axis";
* 	this.timeXAxis.dataSource = this.financialData;
* 	this.timeXAxis.dateTimeMemberPath = "Time";
* 	this.timeXAxis.label = "Date";
* ```
*/
var IgrCategoryDateTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryDateTimeXAxis, _super);
    function IgrCategoryDateTimeXAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryDateTimeXAxis.prototype.createImplementation = function () {
        return new CategoryDateTimeXAxis();
    };
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "isContinuous", {
        /**
         * Gets if the current axis is a continuous rather than a discrete scale
        */
        get: function () {
            return this.i.b4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "displayType", {
        /**
         * Gets or sets the axis display type.
         * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points.
         * Discrete display type will not use a constant interval, but will align each label with its data point.
        *
        * `displayType` property is used for axis display type.
        *
        * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points. Discrete display type will not use a constant interval, but will align each label with its data point.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis" label="Date"
        * 			dateTimeMemberPath="Date"
        * 			displayType ="continuous" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
        * this.xAxis.dataTimeMemberPath="date";
        * this.xAxis.displayType ="continuous"
        * ```
        */
        get: function () {
            return this.i.l4;
        },
        set: function (v) {
            this.i.l4 = ensureEnum(TimeAxisDisplayType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "interval", {
        /**
         * Gets or sets the X axis time interval.
        *
        * `interval` property is used to get/sets the frequency of displayed labels.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 		width="700px"
        * 		height="500px">
        *     <IgrTimeXAxis name="xAxis"
        * 		label="Date"
        * 		interval={2}
        * 		dateTimeMemberPath="Date" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
        * This.xAxis.dataTimeMemberPath="date";
        * this.xAxis.interval=2 ;
        * ```
        */
        get: function () {
            return this.i.me;
        },
        set: function (v) {
            this.i.me = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        */
        get: function () {
            return this.i.mb;
        },
        set: function (v) {
            this.i.mb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        */
        get: function () {
            return this.i.mf;
        },
        set: function (v) {
            this.i.mf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        */
        get: function () {
            return this.i.mc;
        },
        set: function (v) {
            this.i.mc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryDateTimeXAxis.prototype, "isCategoryDateTime", {
        /**
         * Gets if the current axis is of category date time axis type
        */
        get: function () {
            return this.i.b3;
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryDateTimeXAxis.prototype.scrollIntoView = function (minimum, maximum) {
        this.i.ml(minimum, maximum);
    };
    return IgrCategoryDateTimeXAxis;
}(IgrTimeAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryDateTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryDateTimeXAxisModule() {
    }
    IgrCategoryDateTimeXAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrCategoryDateTimeXAxis", IgrCategoryDateTimeXAxis);
        TypeRegistrar.register("CategoryDateTimeXAxis", CategoryDateTimeXAxis.$type);
    };
    return IgrCategoryDateTimeXAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent angle based axis for polar series.
*/
var IgrNumericAngleAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumericAngleAxis, _super);
    function IgrNumericAngleAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrNumericAngleAxis.prototype.createImplementation = function () {
        return new NumericAngleAxis();
    };
    Object.defineProperty(IgrNumericAngleAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAngleAxis.prototype, "isAngular", {
        /**
         * Gets if the current axis is of angular axis type
        */
        get: function () {
            return this.i.b0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericAngleAxis.prototype, "startAngleOffset", {
        /**
         * Indicates the angle in degress that the chart's 0th angle should be offset.
        */
        get: function () {
            return this.i.lm;
        },
        set: function (v) {
            this.i.lm = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the scaled angle value in radians based on the raw input.
    
    * @param unscaledValue  * The raw input value.
    */
    IgrNumericAngleAxis.prototype.getScaledAngle = function (unscaledValue) {
        var iv = this.i.getScaledAngle(unscaledValue);
        return (iv);
    };
    /**
     * Gets the raw axis value back from the angle that would be used on the chart.
    
    * @param scaledValue  * The chart angle value.
    */
    IgrNumericAngleAxis.prototype.getUnscaledAngle = function (scaledValue) {
        var iv = this.i.getUnscaledAngle(scaledValue);
        return (iv);
    };
    return IgrNumericAngleAxis;
}(IgrNumericAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNumericAngleAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNumericAngleAxisModule() {
    }
    IgrNumericAngleAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrNumericAngleAxis", IgrNumericAngleAxis);
        TypeRegistrar.register("NumericAngleAxis", NumericAngleAxis.$type);
    };
    return IgrNumericAngleAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent radius axis for polar and radial series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}   >
*
*     <IgrCategoryAngleAxis name="angleAxis" label="Department" />
*     <IgrNumericRadiusAxis name="radiusAxis" />
*
* </IgrDataChart>
* ```
*
* ```ts
* this.series1.angleAxisName = "AngleAxis";
* this.series1.valueAxisName = "numericYAxis";
* ```
*/
var IgrNumericRadiusAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumericRadiusAxis, _super);
    function IgrNumericRadiusAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrNumericRadiusAxis.prototype.createImplementation = function () {
        return new NumericRadiusAxis();
    };
    Object.defineProperty(IgrNumericRadiusAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericRadiusAxis.prototype, "isRadial", {
        /**
         * Checks if the axis is of radial axis type
        *
        * ```ts
        * let isRadial: boolean = this.series.isRadial;
        * ```
        */
        get: function () {
            return this.i.cc;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericRadiusAxis.prototype, "radiusExtentScale", {
        /**
         * Defines the percentage of the maximum radius extent to use as the maximum radius. Should be
         * a value between 0.0 and 1.0.
        */
        get: function () {
            return this.i.lt;
        },
        set: function (v) {
            this.i.lt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrNumericRadiusAxis.prototype, "innerRadiusExtentScale", {
        /**
         * Defines the percentage of the maximum radius extent to leave blank at the center of the chart. Should be
         * a value between 0.0 and 1.0.
        */
        get: function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Returns a world coordinates radius length (0 - 0.5) from a raw axis value.
    
    * @param unscaledValue  * The raw axis value.
    */
    IgrNumericRadiusAxis.prototype.getScaledValue = function (unscaledValue) {
        var iv = this.i.lp(unscaledValue);
        return (iv);
    };
    /**
     * Returns a raw axis value from the world coordinates radius length provided.
    
    * @param scaledValue  * The scaled world coordinates radius length.
    *
    * Class containing several properties which are used as parameters passed to scaling operations in a `IgrSeriesViewer`.
    */
    IgrNumericRadiusAxis.prototype.getUnscaledValue = function (scaledValue) {
        var iv = this.i.lr(scaledValue);
        return (iv);
    };
    return IgrNumericRadiusAxis;
}(IgrNumericAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNumericRadiusAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNumericRadiusAxisModule() {
    }
    IgrNumericRadiusAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrNumericRadiusAxis", IgrNumericRadiusAxis);
        TypeRegistrar.register("NumericRadiusAxis", NumericRadiusAxis.$type);
    };
    return IgrNumericRadiusAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITimeRangeSelectorAxis_$type = /*@__PURE__*/ new Type(null, 'ITimeRangeSelectorAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OrderedDictionary = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OrderedDictionary, _super);
    function OrderedDictionary() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OrderedDictionary.$t = markType(OrderedDictionary, 'OrderedDictionary');
    return OrderedDictionary;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OrderedDictionary$2 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OrderedDictionary$2, _super);
    function OrderedDictionary$2($tKey, $tValue) {
        var _this = _super.call(this) || this;
        _this.$tKey = null;
        _this.$tValue = null;
        _this.e = null;
        _this.f = null;
        _this.$tKey = $tKey;
        _this.$tValue = $tValue;
        _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue);
        _this.e = new Dictionary$2(_this.$tKey, _this.$tValue, 0);
        _this.f = new List$1(_this.$tKey, 0);
        return _this;
    }
    OrderedDictionary$2.prototype.item1 = function (a) {
        return this.f._inner[a];
    };
    OrderedDictionary$2.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            var c = this.f.indexOf(a);
            this.f._inner[c] = a;
            this.e.item(a, b);
            return b;
        }
        else {
            return this.e.item(a);
        }
    };
    OrderedDictionary$2.prototype.get_a = function () {
        return this.count;
    };
    Object.defineProperty(OrderedDictionary$2.prototype, "a", {
        get: function () {
            return this.get_a();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrderedDictionary$2.prototype, "count", {
        get: function () {
            return this.e.count;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrderedDictionary$2.prototype, "isReadOnly", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrderedDictionary$2.prototype, "keys", {
        get: function () {
            return this.f;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrderedDictionary$2.prototype, "values", {
        get: function () {
            return this.e.values;
        },
        enumerable: true,
        configurable: true
    });
    OrderedDictionary$2.prototype.add = function (a) {
        this.addItem(a.key, a.value);
    };
    OrderedDictionary$2.prototype.addItem = function (a, b) {
        this.e.addItem(a, b);
        this.f.add(a);
    };
    OrderedDictionary$2.prototype.clear = function () {
        this.e.clear();
        this.f.clear();
    };
    OrderedDictionary$2.prototype.contains = function (a) {
        return this.e.contains(a);
    };
    OrderedDictionary$2.prototype.containsKey = function (a) {
        return this.e.containsKey(a);
    };
    OrderedDictionary$2.prototype.copyTo = function (a, b) {
        this.e.copyTo(a, b);
    };
    OrderedDictionary$2.prototype.getEnumerator = function () {
        return new OrderedDictionary_Enumerator$2(this.$tKey, this.$tValue, this);
    };
    OrderedDictionary$2.prototype.remove = function (a) {
        return this.removeItem(a.key);
    };
    OrderedDictionary$2.prototype.removeItem = function (a) {
        return this.e.removeItem(a) && this.f.remove(a);
    };
    OrderedDictionary$2.prototype.tryGetValue = function (a, b) {
        if (this.e.containsKey(a)) {
            b = this.e.item(a);
            return {
                ret: true,
                p1: b
            };
        }
        b = Type.getDefaultValue(this.$tValue);
        return {
            ret: false,
            p1: b
        };
    };
    OrderedDictionary$2.prototype.getEnumeratorObject = function () {
        return new OrderedDictionary_Enumerator$2(this.$tKey, this.$tValue, this);
    };
    OrderedDictionary$2.prototype.b = function (a) {
        return getBoxIfEnum(this.$tKey, this.item1(a));
    };
    OrderedDictionary$2.prototype.c = function (a) {
        return this.item(a);
    };
    OrderedDictionary$2.$t = markType(OrderedDictionary$2, 'OrderedDictionary$2', OrderedDictionary.$, [IDictionary$2_$type.specialize(0, 1), IDictionary_$type]);
    return OrderedDictionary$2;
}(OrderedDictionary));
/**
 * @hidden
 */
var OrderedDictionary_Enumerator$2 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OrderedDictionary_Enumerator$2, _super);
    function OrderedDictionary_Enumerator$2($tKey, $tValue, a) {
        var _this = _super.call(this) || this;
        _this.$tKey = null;
        _this.$tValue = null;
        _this.b = 0;
        _this.a = null;
        _this.$tKey = $tKey;
        _this.$tValue = $tValue;
        _this.$type = _this.$type.specialize(_this.$tKey, _this.$tValue);
        _this.b = -1;
        _this.a = a;
        return _this;
    }
    Object.defineProperty(OrderedDictionary_Enumerator$2.prototype, "currentObject", {
        get: function () {
            return getBoxIfEnum(this.$tValue, this.a.item(this.a.item1(this.b)));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrderedDictionary_Enumerator$2.prototype, "current", {
        get: function () {
            var a = this.a.item1(this.b);
            return new KeyValuePair$2(this.$tKey, this.$tValue, 1, a, this.a.item(a));
        },
        enumerable: true,
        configurable: true
    });
    OrderedDictionary_Enumerator$2.prototype.moveNext = function () {
        this.b++;
        return this.b < this.a.count;
    };
    OrderedDictionary_Enumerator$2.prototype.reset = function () {
        this.b = -1;
    };
    OrderedDictionary_Enumerator$2.prototype.dispose = function () {
    };
    OrderedDictionary_Enumerator$2.$t = markType(OrderedDictionary_Enumerator$2, 'OrderedDictionary_Enumerator$2', Base.$, [IEnumerator$1_$type.specialize(KeyValuePair$2.$.specialize(0, 1)), IEnumerator_$type]);
    return OrderedDictionary_Enumerator$2;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TimeXAxis, _super);
    function TimeXAxis() {
        var _this = _super.call(this) || this;
        _this.mm = 0;
        _this.l6 = null;
        _this.mc = null;
        _this._omission = 0;
        _this.l4 = null;
        _this.ma = null;
        _this.my = 0;
        _this.mi = dateMaxValue();
        _this.mh = dateMinValue();
        _this.mw = 0;
        _this.visibleRangeChanged = null;
        _this.ab = TimeXAxis.$;
        _this.omission = (0);
        _this.mm = -2147483648;
        _this.l6 = new TimeAxisBreakCollection();
        var a = _this.breaks;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.m1));
        _this.ma = new TimeAxisIntervalCollection();
        var b = _this.intervals;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.m2));
        _this.mc = new TimeAxisLabelFormatCollection();
        var c = _this.labelFormats;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(_this, _this.m3));
        _this.my = (0);
        return _this;
    }
    TimeXAxis.prototype.get_cb = function () {
        return this.breaks != null && this.breaks.count > 0;
    };
    TimeXAxis.prototype.dw = function (a, b) {
        var c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        var d = this.mm != -2147483648 ? this.mm : 0;
        var e = this.l4 != null ? this.l4.count : 0;
        while (d < e) {
            var f = this.l4.item1(d);
            if (f.d.getTime() <= a && f.c.getTime() >= a) {
                return NaN;
            }
            if (f.c.getTime() <= a) {
                c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type, 1, f, this.l4.item(f));
                d++;
            }
            else {
                break;
            }
        }
        if (d > 0) {
            d -= 1;
        }
        if (this.mm != -2147483648) {
            this.mm = d;
        }
        var g;
        var h;
        if (c.key != null) {
            g = c.value;
            h = c.key.c;
        }
        else {
            g = 0;
            h = this.actualMinimumValue;
        }
        var fromPrecedingBreak_ = +(dateFromTicks(truncate(a))) - +h;
        var i = (fromPrecedingBreak_ / ((this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime()) - this.omission));
        var j = g + i;
        j -= b.e.left;
        j /= b.e.width;
        var k = b.d.left;
        var l = b.d.right;
        var m = b.d.width;
        if (this.categoryMode != 0) {
            var n = this.getCategorySize(b.e, b.d, b.c);
            k += n / 2;
            l -= n / 2;
            m -= n;
        }
        if (this.b8) {
            return l - m * j;
        }
        return k + m * j;
    };
    TimeXAxis.prototype.gn = function (a, b, c, d) {
        this.mm = 0;
        for (var e = b; e < c; e++) {
            a.item(e, this.dw(a.item(e), d));
        }
        this.mm = -2147483648;
    };
    TimeXAxis.prototype.startCursor = function () {
        this.mm = 0;
    };
    TimeXAxis.prototype.resetCursor = function () {
        this.mm = -2147483648;
    };
    TimeXAxis.prototype.dz = function (a, b) {
        var e_1, _a;
        var c = b.d.left;
        var d = b.d.width;
        if (this.categoryMode != 0) {
            var e = this.getCategorySize(b.e, b.d, b.c);
            c += e / 2;
            d -= e;
        }
        var f = b.e.left + b.e.width * (a - c) / d;
        if (this.b8) {
            f = 1 - f;
        }
        var g = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        if (this.l4 != null) {
            try {
                for (var _b = __values(fromEnum(this.l4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var h = _c.value;
                    if (h.value >= f && h.value <= f) {
                        return h.key.d.getTime();
                    }
                    if (h.value < f && h.value > g.value) {
                        g = h;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        var precedingBreakEnd_;
        var i;
        if (g.key != null) {
            i = g.value;
            precedingBreakEnd_ = g.key.c;
        }
        else {
            i = 0;
            precedingBreakEnd_ = this.actualMinimumValue;
        }
        var portionFromPrecedingBreak_ = f - i;
        var actualRange_ = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        return (precedingBreakEnd_.getTime() + portionFromPrecedingBreak_ * actualRange_);
    };
    Object.defineProperty(TimeXAxis.prototype, "breaks", {
        get: function () {
            return this.l6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "labelFormats", {
        get: function () {
            return this.mc;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.gu = function (a, b, c, d) {
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case "ActualMaximumValue":
                this.m0();
                break;
            case "DateTimeColumn":
                this.mw = this.mu();
                break;
        }
    };
    TimeXAxis.prototype.hi = function (a, b) {
        _super.prototype.hi.call(this, a, b);
        this.mz();
        this.ly();
    };
    TimeXAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        this.mz();
        this.ly();
    };
    TimeXAxis.prototype.cn = function () {
        var a = _super.prototype.cn.call(this);
        this.mz();
        return a;
    };
    Object.defineProperty(TimeXAxis.prototype, "omission", {
        get: function () {
            return this._omission;
        },
        set: function (a) {
            this._omission = a;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.m0 = function () {
        var e_2, _a;
        var a = this.mf(this.breaks);
        var b = (0);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                b += (+(c.c) - +(c.d));
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.omission = b;
    };
    TimeXAxis.prototype.mf = function (a) {
        var e_3, _a;
        var b = new List$1(TimeAxisBreak.$, 0);
        if (a == null || +(this.actualMaximumValue) == +(dateMaxValue())) {
            return b;
        }
        var _loop_1 = function (c) {
            if (c.c >= this_1.actualMinimumValue && c.d <= this_1.actualMaximumValue) {
                b.add(c);
            }
            if (c.i != (0)) {
                var d = +(c.c) - +(c.d);
                var e_4 = dateAdd(+(c.d), +(c.i));
                var _loop_2 = function () {
                    var f = this_1.mj(e_4, d);
                    var g = ((function () {
                        var $ret = new TimeAxisBreak();
                        $ret.d = e_4;
                        $ret.c = f;
                        return $ret;
                    })());
                    if (g.c >= this_1.actualMinimumValue && g.d <= this_1.actualMaximumValue) {
                        b.add(g);
                    }
                    if (dateSubtract(+(dateMaxValue()), +(c.i)) < g.d) {
                        return "break";
                    }
                    e_4 = this_1.mj(g.d, c.i);
                };
                while (e_4 <= this_1.actualMaximumValue) {
                    var state_1 = _loop_2();
                    if (state_1 === "break")
                        break;
                }
            }
        };
        var this_1 = this;
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                _loop_1(c);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    TimeXAxis.prototype.mj = function (a, b) {
        var c = dateFromTicks(a.getTime());
        c.setMilliseconds(c.getMilliseconds() + b);
        return c;
    };
    TimeXAxis.prototype.mz = function () {
        var e_5, _a;
        this.l4 = new OrderedDictionary$2(TimeAxisBreak.$, Number_$type);
        if (+(this.actualMaximumValue) == +(dateMaxValue()) || this.breaks == null || this.breaks.count == 0 || this.bf == null) {
            return;
        }
        var a = new List$1(TimeAxisBreak.$, 1, this.mf(this.breaks));
        a.aa(function (b, c) { return b.d < c.d ? -1 : b.d > c.d ? 1 : 0; });
        var b = this.bf.mq;
        var c = new ScalerParams(0, this.bf.mq, this.bf.m3, this.b8, this.bf.mu);
        var d = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        var e = 0;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                var g = timeSpanTicks((+(f.d) - +(this.actualMinimumValue))) / timeSpanTicks(d);
                var h = timeSpanTicks((+(f.c) - +(this.actualMinimumValue))) / timeSpanTicks(d);
                if (h < 0 || g - e > 1) {
                    continue;
                }
                this.l4.addItem(f, g - e);
                e += (h - g);
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    TimeXAxis.prototype.fj = function (a) {
        if (isNaN_(a)) {
            return null;
        }
        var ticks_ = truncate(a);
        var b = (new Date(ticks_));
        var c = this.e6(b);
        if (c == null) {
            return null;
        }
        return c.toString();
    };
    TimeXAxis.prototype.e6 = function (a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return _super.prototype.e6.call(this, a);
        }
        var b = TimeXAxis.mn(a, this.my, this.labelFormats, this.er);
        return b == null ? _super.prototype.e6.call(this, a) : b;
    };
    TimeXAxis.mn = function (a, b, c, d) {
        var e_6, _a;
        var e = null;
        if (b == (0)) {
            return null;
        }
        var f;
        if (c == null || c.count == 0) {
            f = TimeXAxis.mq(b);
        }
        else {
            try {
                for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    if (g.f > b) {
                        continue;
                    }
                    if (e == null || g.f > e.f) {
                        e = g;
                    }
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            if (e == null) {
                return null;
            }
            f = e.b;
        }
        return dateToStringFormat(a, f, d);
    };
    TimeXAxis.prototype.get_k1 = function () {
        return _super.prototype.get_k1.call(this) || (this.intervals != null && this.intervals.count > 0);
    };
    TimeXAxis.prototype.set_k1 = function (a) {
        _super.prototype.set_k1.call(this, a);
    };
    Object.defineProperty(TimeXAxis.prototype, "intervals", {
        get: function () {
            return this.ma;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.mp = function () {
        return TimeXAxis.mq(this.my);
    };
    TimeXAxis.mq = function (a) {
        a = Math.abs(a);
        if (a > timeSpanInit3(1825, 0, 0, 0)) {
            return "yyyy";
        }
        if (a > timeSpanInit3(365, 0, 0, 0)) {
            return "MMM yyyy";
        }
        if (a > timeSpanInit3(4, 0, 0, 0)) {
            return "MMM dd";
        }
        if (a > timeSpanInit3(1, 0, 0, 0)) {
            return "MMM dd hh:mmtt";
        }
        if (a > timeSpanInit1(0, 10, 0)) {
            return "hh:mm";
        }
        return "hh:mm:ss";
    };
    TimeXAxis.l5 = function () {
        if (TimeXAxis.l3 == null) {
            TimeXAxis.l3 = ((function () {
                var $ret = new OrderedDictionary$2(Number_$type, TimeAxisInterval.$);
                $ret.addItem((0), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 0;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMilliseconds(1), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 1;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromSeconds(1), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 2;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromSeconds(30), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 2;
                    $ret.f = 30;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMinutes(2), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 2;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMinutes(5), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 5;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromHours(1), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 4;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(1), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(2), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 2;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(5), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 5;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(10), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 10;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(30), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(60), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 3;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(365), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(365 * 10), ((function () {
                    var $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 10;
                    return $ret;
                })()));
                return $ret;
            })());
        }
        return TimeXAxis.l3;
    };
    TimeXAxis.prototype.l8 = function () {
        var e_7, _a;
        if (this.co && (this.aw == null || this.aw.angle == 0)) {
            var a = this.d8();
            var b = this.i1.width;
            var c = truncate(Math.floor(b / a));
            var d = Number.MAX_VALUE;
            var e = c == 0 ? d : timeSpanFromTicks((intDivide(timeSpanTicks(this.my), c)));
            var f = null;
            try {
                for (var _b = __values(fromEnum(TimeXAxis.l5())), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    f = g.value;
                    if (g.key > e) {
                        break;
                    }
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            return f;
        }
        var h = this.my;
        if (h == (0)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(365 * 100)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 10;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(365 * 5)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(365 * 2)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 7;
                $ret.f = 3;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(150)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 7;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(60)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 10;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(30)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 5;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(20)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 2;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(4)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (h >= timeSpanFromDays(1)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 4;
                $ret.f = 12;
                return $ret;
            })());
        }
        if (h >= timeSpanFromHours(6)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 4;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (h >= timeSpanFromMinutes(30)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 3;
                $ret.f = 5;
                return $ret;
            })());
        }
        if (h >= timeSpanFromMinutes(10)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 3;
                $ret.f = 2;
                return $ret;
            })());
        }
        return ((function () {
            var $ret = new TimeAxisInterval();
            $ret.b = 2;
            $ret.f = 30;
            return $ret;
        })());
    };
    TimeXAxis.prototype.l9 = function () {
        var e_8, _a;
        if (this.intervals == null || this.intervals.count == 0) {
            return this.l8();
        }
        if (this.my == (0)) {
            return ((function () {
                var $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        var a = null;
        try {
            for (var _b = __values(fromEnum(this.intervals)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b.k > this.my) {
                    continue;
                }
                if (a == null || b.k > a.k) {
                    a = b;
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        return a == null ? this.l8() : a;
    };
    TimeXAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = new ScalerParams(0, b, c, this.b8, d);
        if (this.kx == null && !this.k3() && !this.k4()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var g = c.bottom;
            var h = g - c.top;
            if (this.ag != null) {
                var i = typeCast(NumericYAxis.$, this.ag);
                if (i != null) {
                    var j = this.ha(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.gq(this.a2.ay(), g, c, this.a2.e(), true);
            this.at.a8 = h;
            var k = truncate(Math.ceil(e.right));
            var l = truncate(Math.floor(e.left));
            var m = this.a2.a1();
            var n = this.a2.f();
            var o = this.a2.az();
            this.ly();
            var p = new List$1(Date_$type, 1, this.me());
            var q = new List$1(Number_$type, 0);
            for (var r = 0; r < p.count; r++) {
                q.add(p._inner[r].getTime());
            }
            this.gn(q, 0, q.count, f);
            for (var s = 0; s < p.count; s++) {
                var t = p._inner[s];
                var u = q._inner[s];
                var v = truncate(Math.round(u));
                if (v <= k) {
                    if (s % 2 == 0) {
                        var w = s < q.count - 1 ? q._inner[s + 1] : e.right;
                        this.hg(m, u, w, c);
                    }
                    this.hf(o, u, c, n, false);
                    this.jm.add(u);
                }
                if (v >= l && v <= k) {
                    var x = this.e6(t);
                    if (x != null) {
                        this.cv.add1(x);
                        this.cw.add(new LabelPosition(u));
                    }
                }
            }
        }
        if ((this.aw == null || this.aw.visibility == 0) && this.ag != null) {
            if (this.aw != null && (this.aw.location == 4 || this.aw.location == 5)) {
                this.bf.ht();
            }
        }
        this.at.a1 = this.cv;
        this.at.a2 = this.cw;
        this.km();
    };
    TimeXAxis.prototype.me = function () {
        var a = this.bf != null ? this.bf.mq : Rect.empty;
        var b = !a.isEmpty ? this.i1 : Rect.empty;
        var c = this.iw();
        var d = this.iv();
        var e = new ScalerParams(0, a, b, this.b8, c);
        var f = this.l9();
        var g = this.visibleMinimum;
        if (!this.k4() && f != null) {
            if (f.b == 7 && g.getDate() != 1) {
                g = dateAddMonths(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), 1, 0, 0, 0, 0);
            }
            else if (f.b == 5 && dateGetTimeOfDay(g) != (0)) {
                g = dateAddDays(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), 0, 0, 0, 0);
            }
            else if (f.b == 4 && g.getMinutes() != 0) {
                g = dateAddHours(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), g.getHours(), 0, 0, 0);
            }
        }
        var h = new List$1(Date_$type, 0);
        var i = 0;
        var j = 10000;
        if (f.f == 0) {
            return h;
        }
        while (g <= this.visibleMaximum && i++ < j) {
            var k = this.mg(g);
            var l = g;
            if (k.key != null) {
                l = f.d(k.key.c);
            }
            h.add(l);
            while (g <= l) {
                g = f.c(g);
            }
        }
        return h;
    };
    TimeXAxis.prototype.mg = function (a) {
        var e_9, _a;
        if (this.l4 == null) {
            return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        }
        try {
            for (var _b = __values(fromEnum(this.l4)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b.key.d <= a && b.key.c >= a) {
                    return b;
                }
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
    };
    Object.defineProperty(TimeXAxis.prototype, "visibleMinimum", {
        get: function () {
            return this.mi;
        },
        set: function (a) {
            this.mi = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "visibleMaximum", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            this.mh = a;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.ly = function () {
        _super.prototype.ly.call(this);
        if (this.bf == null || !Extensions.b(this.bf.m3)) {
            return;
        }
        var a = new ScalerParams(0, this.bf.mq, this.bf.m3, this.b8, this.bf.mu);
        var b = this.bf.m3.left;
        var c = this.bf.m3.right;
        if (this.categoryMode != 0) {
            var d = this.getCategorySize(a.e, a.d, a.c);
            b += d / 2;
            c -= d / 2;
        }
        var e = truncate(this.dz(b, a));
        var f = truncate(this.dz(c, a));
        if (e < 0 || f < 0) {
            this.my = (0);
            return;
        }
        e = Math.min(dateMaxValue().getTime(), e);
        f = Math.min(dateMaxValue().getTime(), f);
        var g = dateFromTicks(Math.min(e, f));
        var h = dateFromTicks(Math.max(e, f));
        var i = +(this.visibleMinimum) != +g || +(this.visibleMaximum) != +h;
        this.visibleMinimum = g;
        this.visibleMaximum = h;
        if (i && this.visibleRangeChanged != null) {
            this.visibleRangeChanged(this, EventArgs.empty);
        }
        this.my = +(this.visibleMaximum) - +(this.visibleMinimum);
    };
    TimeXAxis.prototype.jt = function (a, b, c, d, e) {
        return 0;
    };
    TimeXAxis.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.kx, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.lh(d, c);
        e = Math.max(0, Math.min(b.i$b.count - 1, e));
        var f = c.item(e);
        var g;
        var h;
        if (f < d) {
            g = e;
            h = g + 1;
        }
        else {
            h = e;
            g = e - 1;
        }
        if (g < 0) {
            return h;
        }
        if (h >= b.i$b.count) {
            return g;
        }
        var i = c.item(g);
        var j = c.item(h);
        var k = new ScalerParams(0, this.bf.m4, this.i1, this.b8, this.bf.mu);
        this.startCursor();
        var l = this.dw(i.getTime(), k);
        var m = this.dw(a, k);
        var n = this.dw(j.getTime(), k);
        this.resetCursor();
        if (i < this.visibleMinimum && j <= this.visibleMaximum) {
            return this.k6._inner[h];
        }
        if (j > this.visibleMaximum && i >= this.visibleMinimum) {
            return this.k6._inner[g];
        }
        if (Math.abs(l - m) < Math.abs(n - m)) {
            return this.k6._inner[g];
        }
        else {
            return this.k6._inner[h];
        }
    };
    TimeXAxis.prototype.m1 = function (a, b) {
        var e_10, _a;
        this.m0();
        this.mz();
        if (this.at != null) {
            this.at.ak = this.breaks.count > 0;
        }
        this.g6(false);
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.jd(false);
            }
        }
        catch (e_10_1) {
            e_10 = { error: e_10_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_10)
                    throw e_10.error;
            }
        }
    };
    TimeXAxis.prototype.m3 = function (a, b) {
        this.g6(false);
    };
    TimeXAxis.prototype.m2 = function (a, b) {
        this.g6(false);
    };
    TimeXAxis.prototype.get_b3 = function () {
        return false;
    };
    TimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
        var c = +(this.actualMaximumValue) - +(this.actualMinimumValue);
        var d = timeSpanTotalMilliseconds((+a - +(this.actualMinimumValue))) / timeSpanTotalMilliseconds(c);
        var e = 1 - (timeSpanTotalMilliseconds((+(this.actualMaximumValue) - +b)) / timeSpanTotalMilliseconds(c));
        e = Math.min(1, e);
        return new Rect(0, d, NaN, Math.max(0, e - d), NaN);
    };
    TimeXAxis.prototype.getCategorySize = function (a, b, c) {
        if (this.my != (0)) {
            var d = timeSpanFromTicks(truncate((timeSpanTicks(this.my) * (a.width / (this.bf != null ? this.bf.mq.width : 1)))));
            var e = timeSpanTicks(d) / timeSpanTicks(this.mw);
            var f = b.width / 4;
            return Math.min(f, b.width / (e + 1));
        }
        return _super.prototype.getCategorySize.call(this, a, b, c);
    };
    TimeXAxis.mv = function (a, b) {
        var c = Math.min(5, b);
        var d = a(0);
        var e = new Dictionary$2(Number_$type, Number_$type, 0);
        var f = 0;
        var g = (0);
        for (var h = 0; h < c; h++) {
            var i = a(h);
            var j = +i - +d;
            if (!e.containsKey(j)) {
                e.addItem(j, 0);
            }
            e.item(j, e.item(j) + 1);
            if (e.item(j) > f) {
                f = e.item(j);
                g = j;
            }
            d = i;
        }
        return g;
    };
    TimeXAxis.prototype.mu = function () {
        var _this = this;
        if (this.kx == null || this.kx.count < 2 || this.k6 == null) {
            return (0);
        }
        return TimeXAxis.mv(function (a) { return _this.kx.item(_this.k6._inner[a]); }, this.kx.count);
    };
    TimeXAxis.prototype.lu = function () {
        _super.prototype.lu.call(this);
        this.mw = this.mu();
    };
    TimeXAxis.ms = function (a) {
        if (a >= timeSpanFromDays(1)) {
            return "D";
        }
        return "g";
    };
    TimeXAxis.prototype.itemLabelFormat = function () {
        return TimeXAxis.ms(this.mw);
    };
    TimeXAxis.prototype.lg = function (a, b, c, d) {
        return this.lf(this.visibleMinimum);
    };
    TimeXAxis.prototype.lj = function (a, b, c, d) {
        return this.li(this.visibleMaximum);
    };
    Object.defineProperty(TimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    TimeXAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    TimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    TimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    TimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(TimeXAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeXAxis.prototype, "i$a", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    TimeXAxis.$t = markType(TimeXAxis, 'TimeXAxis', TimeAxisBase.$, [ITimeRangeSelectorAxis_$type]);
    TimeXAxis.l3 = null;
    return TimeXAxis;
}(TimeAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OrdinalTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OrdinalTimeXAxis, _super);
    function OrdinalTimeXAxis() {
        var _this = _super.call(this) || this;
        _this.lp = dateMaxValue();
        _this.lo = dateMinValue();
        _this.lt = dateMaxValue();
        _this.ls = dateMinValue();
        _this.ly = null;
        _this.lm = null;
        _this.lk = null;
        _this.l5 = 0;
        _this.lr = dateMinValue();
        _this.lq = dateMaxValue();
        _this.visibleRangeChanged = null;
        FastItemDateTimeColumn.o();
        _this.lk = new TimeAxisLabelFormatCollection();
        var a = _this.ll;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.l7));
        _this.lb = 0;
        return _this;
    }
    OrdinalTimeXAxis.prototype.dy = function (a, b, c) {
        return this.dw(a, new ScalerParams(0, b, c, this.b8, this.iw()));
    };
    OrdinalTimeXAxis.prototype.dx = function (a, b, c) {
        return this.dw(a, b);
    };
    OrdinalTimeXAxis.prototype.dw = function (a, b) {
        var c = this.la;
        var d = this.lb;
        var e = this.la - this.lb;
        var f = e >= 1 ? (a - d) / (c - d) : e == 0 ? 0.5 : NaN;
        if (this.b9) {
            f = 1 - f;
        }
        var g = b.d;
        var h = b.e;
        return g.left + g.width * (f - h.left) / h.width;
    };
    OrdinalTimeXAxis.prototype.gm = function (a, b, c, d, e) {
        var f = this.kw(a);
        var g = f != null;
        for (var h = 0; h < b.count; h++) {
            for (var i = c; i < d; i++) {
                var j = g ? f[i] : a.item(i);
                j[h] = this.dw(j[h], e);
            }
        }
    };
    OrdinalTimeXAxis.prototype.gn = function (a, b, c, d) {
        for (var e = b; e < c; e++) {
            a.item(e, this.dw(a.item(e), d));
        }
    };
    OrdinalTimeXAxis.prototype.d1 = function (a, b, c) {
        return this.dz(a, new ScalerParams(0, b, this.i1, this.b8, this.iw()));
    };
    OrdinalTimeXAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        return this.dz(a, new ScalerParams(0, b, this.i1, this.b8, this.iw()));
    };
    OrdinalTimeXAxis.prototype.dz = function (a, b) {
        var c = b.e;
        var d = b.d;
        var e = c.left + (a - d.left) * c.width / d.width;
        if (this.b9) {
            e = 1 - e;
        }
        return this.lb + e * (this.la - this.lb);
    };
    OrdinalTimeXAxis.prototype.d0 = function (a, b, c) {
        return this.dz(a, b);
    };
    OrdinalTimeXAxis.prototype.go = function (a, b, c, d) {
        for (var e = b; e < c; e++) {
            a.item(e, this.dz(a.item(e), d));
        }
    };
    OrdinalTimeXAxis.prototype.gu = function (a, b, c, d) {
        _super.prototype.gu.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.ln);
                    this.ln = null;
                }
                if (this.jf != null) {
                    this.ln = TimeAxisBase.kz(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeMemberPath":
                if (this.jf != null) {
                    this.jf.deregisterColumn(this.ln);
                    this.ln = TimeAxisBase.kz(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeColumn":
                this.cl();
                this.l5 = this.l4();
                break;
            case "MinimumValue":
            case "MaximumValue":
                this.cl();
                this.g5();
                break;
        }
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMinimumValue", {
        get: function () {
            return this.lp;
        },
        set: function (a) {
            this.lp = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMaximumValue", {
        get: function () {
            return this.lo;
        },
        set: function (a) {
            this.lo = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMinimum", {
        get: function () {
            return this.lt;
        },
        set: function (a) {
            this.lt = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMaximum", {
        get: function () {
            return this.ls;
        },
        set: function (a) {
            this.ls = a;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.l8 = function () {
        if (this.ln == null || this.ln.count == 0 || this.ln.count < this.lb - 1) {
            this.actualMinimumValue = dateMinValue();
            this.actualMaximumValue = dateMaxValue();
            return;
        }
        var a = Math.max(0, Math.min(this.lb, this.ln.count - 1));
        var b = Math.max(0, Math.min(this.la, this.ln.count - 1));
        var c = +(this.actualMinimumValue) != +(this.ln.item(a)) || +(this.actualMaximumValue) != +(this.ln.item(b));
        if (c) {
            var d = this.actualMinimumValue;
            var e = this.actualMaximumValue;
            this.actualMinimumValue = this.ln.item(a);
            this.actualMaximumValue = this.ln.item(b);
            this.l9();
        }
    };
    OrdinalTimeXAxis.prototype.l9 = function () {
        if (this.ln == null || this.ln.count == 0 || this.bf == null) {
            var a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
            this.visibleMinimum = this.actualMinimumValue;
            this.visibleMaximum = this.actualMaximumValue;
            if (a && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
            return;
        }
        var b = new ScalerParams(1, this.bf.m4, this.bf.m3, this.b8);
        var c = truncate(Math.ceil(this.dz(this.bf.m3.left, b)));
        var d = truncate(Math.ceil(this.dz(this.bf.m3.right, b)));
        var e = c >= 0 && c < this.ln.count ? this.ln.item(c) : this.actualMinimumValue;
        var f = d >= 0 && d < this.ln.count ? this.ln.item(d) : this.actualMaximumValue;
        var g = +(this.visibleMinimum) != +e || +(this.visibleMaximum) != +f;
        this.visibleMinimum = e;
        this.visibleMaximum = f;
        if (g && this.visibleRangeChanged != null) {
            this.visibleRangeChanged(this, EventArgs.empty);
        }
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "dateTimeMemberPath", {
        get: function () {
            return this.ly;
        },
        set: function (a) {
            var b = this.dateTimeMemberPath;
            if (a != b) {
                this.ly = a;
                this.g0("DateTimeMemberPath", b, this.dateTimeMemberPath);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "ln", {
        get: function () {
            return this.lm;
        },
        set: function (a) {
            if (this.lm != a) {
                var b = this.lm;
                this.lm = a;
                this.g0("DateTimeColumn", b, this.lm);
            }
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.hi = function (a, b) {
        _super.prototype.hi.call(this, a, b);
        this.l9();
    };
    OrdinalTimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
        if (this.ln == null) {
            return Rect.empty;
        }
        var c = a > b;
        var d = c ? b : a;
        var e = c ? a : b;
        var f = -1;
        while (++f < this.ln.count && this.ln.item(f) < d) {
            ;
        }
        var g = this.ln.count;
        while (--g >= 0 && this.ln.item(g) > e) {
            ;
        }
        var h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.b8, this.bf.mu);
        var i = this.dw(f, h);
        var j = this.dw(g + 1, h);
        return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "ll", {
        get: function () {
            return this.lk;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.l7 = function (a, b) {
        this.g6(false);
    };
    OrdinalTimeXAxis.prototype.gw = function (a) {
        _super.prototype.gw.call(this, a);
        this.dateTimeMemberPath = a;
    };
    OrdinalTimeXAxis.prototype.e6 = function (a) {
        if (this.ar != null) {
            return this.ar(a);
        }
        if (!(typeCast(Date_$type, a) !== null)) {
            return _super.prototype.e6.call(this, a);
        }
        var b = TimeXAxis.mn(a, this.l6, this.ll, this.er);
        return b == null ? _super.prototype.e6.call(this, a) : b;
    };
    OrdinalTimeXAxis.prototype.fj = function (a) {
        var b = 0;
        if (this.categoryMode == 0) {
            b = truncate(Math.round(a));
        }
        else {
            b = truncate(Math.floor(a));
        }
        if (b < 0 || b > this.jz - 1) {
            return _super.prototype.fj.call(this, a);
        }
        var c = this.ln.item(b);
        var d = this.e6(c);
        if (d == null) {
            return null;
        }
        return d.toString();
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "l6", {
        get: function () {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.ky = function () {
        return this.ln;
    };
    OrdinalTimeXAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        this.l9();
    };
    OrdinalTimeXAxis.prototype.k4 = function (a, b) {
        var c = this.categoryMode == 0 ? 0 : 0.5;
        return _super.prototype.k4.call(this, a + c, b);
    };
    OrdinalTimeXAxis.prototype.k3 = function (a, b, c, d) {
        return b;
    };
    OrdinalTimeXAxis.prototype.l4 = function () {
        var _this = this;
        if (this.ln == null || this.ln.count < 2) {
            return (0);
        }
        return TimeXAxis.mv(function (a) { return _this.ln.item(a); }, this.ln.count);
    };
    OrdinalTimeXAxis.prototype.itemLabelFormat = function () {
        return TimeXAxis.ms(this.l5);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "minimumValue", {
        get: function () {
            return this.lr;
        },
        set: function (a) {
            var b = this.minimumValue;
            if (+a != +b) {
                this.lr = a;
                this.gu(this, "MinimumValue", b, this.minimumValue);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "maximumValue", {
        get: function () {
            return this.lq;
        },
        set: function (a) {
            var b = this.maximumValue;
            if (+a != +b) {
                this.lq = a;
                this.gu(this, "MaximumValue", b, this.maximumValue);
            }
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.cn = function () {
        if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
            return _super.prototype.cn.call(this);
        }
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        if (this.jf == null || this.ln == null) {
            return false;
        }
        var a = this.lb;
        if (+(this.minimumValue) != +(dateMinValue())) {
            var b = -1;
            while (b++ <= this.ln.count) {
                if (this.ln.item(b) >= this.minimumValue) {
                    break;
                }
            }
            a = b;
        }
        var c = this.categoryMode == 0 ? this.jf.count - 1 : this.jf.count;
        if (+(this.maximumValue) != +(dateMaxValue())) {
            var d = this.jf.count;
            while (d-- > 0) {
                if (this.ln.item(d) <= this.maximumValue) {
                    break;
                }
            }
            c = d;
        }
        if (a != this.lb || c != this.la) {
            var e = new AxisRangeChangedEventArgs(0, this.lb, a, this.la, c);
            this.lb = a;
            this.la = c;
            this.g1(e);
            this.l8();
            this.kb();
            return true;
        }
        return false;
    };
    OrdinalTimeXAxis.prototype.kk = function (a) {
        _super.prototype.kk.call(this, a);
        this.cm(true);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
    return OrdinalTimeXAxis;
}(CategoryXAxis));

/**
 * A horizontal axis that uses an ordinal DateTime scale.
 * On an ordinal time axis, datapoints are aligned according to their order in the ItemsSource, like a category axis.
*
* You can use the `IgrOrdinalTimeXAxis` to display dates at equidistant.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis name="yAxis" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.series.xAxis = this.ordinalTimeXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "xAxis";
* this.series.yAxisName = "YAxis";
* ```
*/
var IgrOrdinalTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrOrdinalTimeXAxis, _super);
    function IgrOrdinalTimeXAxis(props) {
        var _this = _super.call(this, props) || this;
        _this._labelFormats = null;
        return _this;
    }
    IgrOrdinalTimeXAxis.prototype.createImplementation = function () {
        return new OrdinalTimeXAxis();
    };
    Object.defineProperty(IgrOrdinalTimeXAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrOrdinalTimeXAxis.prototype, "dateTimeMemberPath", {
        /**
         * Gets or sets the DateTime mapping property for the axis.
        */
        get: function () {
            return this.i.dateTimeMemberPath;
        },
        set: function (v) {
            this.i.dateTimeMemberPath = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrOrdinalTimeXAxis.prototype, "labelFormats", {
        /**
         * A list of axis label formats to apply, which are selected according to the visible axis range.
         * The label format selected will be the one with the largest range smaller than the visible range of the axis.
        *
        * You can use the `labelFormats` for adjusting the labels depending on the range of the time shown by the chart.
        *
        * ```ts
        * let labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm:ss";
        * labelFormat.range = 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "hh:mm";
        * labelFormat.range = 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "MMM-dd-yy";
        * labelFormat.range = 24 * 60 * 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "MMM yy";
        * labelFormat.range = 365.24 * 24 * 60 * 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * labelFormat = new TimeAxisLabelFormat();
        * labelFormat.format = "yyyy";
        * labelFormat.range = 5 * 365 * 24 * 60 * 60 * 1000;
        * this.xAxis.labelFormats.add(labelFormat);
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrOrdinalTimeXAxis name="xAxis"
        * 				label="Date"
        * 				labelFormats="labelFormats" />
        *     <IgrNumericYAxis name="yAxis" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            if (this._labelFormats === null) {
                var coll = new IgrTimeAxisLabelFormatCollection();
                var innerColl = this.i.ll;
                if (!innerColl) {
                    innerColl = new TimeAxisLabelFormatCollection();
                }
                this._labelFormats = coll._fromInner(innerColl);
            }
            return this._labelFormats;
        },
        set: function (v) {
            if (this._labelFormats !== null) {
                this._labelFormats._setSyncTarget(null);
                this._labelFormats = null;
            }
            var coll = new IgrTimeAxisLabelFormatCollection();
            this._labelFormats = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
            var innerColl = this.i.ll;
            if (!innerColl) {
                innerColl = new TimeAxisLabelFormatCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._labelFormats._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrOrdinalTimeXAxis.prototype, "minimumValue", {
        /**
         * Sets the minimum DateTime value to be displayed on this axis.
         * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrOrdinalTimeXAxis.prototype, "maximumValue", {
        /**
         * Sets the maximum DateTime value to be displayed on this axis.
         * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrOrdinalTimeXAxis.prototype.getValueLabel = function (value) {
        var iv = this.i.fj(value);
        return (iv);
    };
    return IgrOrdinalTimeXAxis;
}(IgrCategoryXAxis));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrOrdinalTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrOrdinalTimeXAxisModule() {
    }
    IgrOrdinalTimeXAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrOrdinalTimeXAxis", IgrOrdinalTimeXAxis);
        TypeRegistrar.register("OrdinalTimeXAxis", OrdinalTimeXAxis.$type);
    };
    return IgrOrdinalTimeXAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentChangeAxisRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentChangeAxisRenderer, _super);
    function PercentChangeAxisRenderer(a) {
        return _super.call(this, a) || this;
    }
    PercentChangeAxisRenderer.prototype.w = function (a, b, c, d) {
        var e = _super.prototype.w.call(this, a, b, c, d);
        if (a.s == null) {
            e += "%";
        }
        return e;
    };
    PercentChangeAxisRenderer.$t = markType(PercentChangeAxisRenderer, 'PercentChangeAxisRenderer', NumericAxisRenderer.$);
    return PercentChangeAxisRenderer;
}(NumericAxisRenderer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentChangeYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentChangeYAxis, _super);
    function PercentChangeYAxis() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentChangeYAxis.prototype.ji = function () {
        return new VerticalPercentChangeScaler(this);
    };
    PercentChangeYAxis.prototype.jb = function () {
        var e_1, _a;
        var a = 1.7976931348623157E+308;
        var b = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(this.cu())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.an(this);
                if (d == null) {
                    continue;
                }
                var e = c.eh();
                if (isNaN_(e) || e == 0) {
                    continue;
                }
                var f = d.b - e;
                var g = e - d.c;
                var h = Math.abs(f / e * 100);
                var i = Math.abs(g / e * 100);
                a = Math.min(a, -i);
                b = Math.max(b, h);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return new AxisRange(a, b);
    };
    PercentChangeYAxis.prototype.je = function (a) {
        return new PercentChangeAxisRenderer(a);
    };
    PercentChangeYAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    PercentChangeYAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(PercentChangeYAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    PercentChangeYAxis.$t = markType(PercentChangeYAxis, 'PercentChangeYAxis', NumericYAxis.$);
    return PercentChangeYAxis;
}(NumericYAxis));
/**
 * @hidden
 */
var VerticalPercentChangeScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalPercentChangeScaler, _super);
    function VerticalPercentChangeScaler(a) {
        var _this = _super.call(this) || this;
        _this.ad = null;
        _this.ad = a;
        return _this;
    }
    VerticalPercentChangeScaler.prototype.t = function (a, b, c, d, e) {
        var f = AutoRangeCalculator.a(this.ad, b, c, false, -1, d, e);
        d = f.p5;
        e = f.p6;
        return {
            p3: d,
            p4: e
        };
    };
    VerticalPercentChangeScaler.prototype.p = function (a, b) {
        var c;
        if (isNaN_(b.b)) {
            c = a;
        }
        else {
            var d = (a - b.b) / Math.abs(b.b) * 100;
            c = d;
        }
        var e = (c - this.o) / this.m;
        if (!b.a) {
            e = 1 - e;
        }
        return b.d.top + b.d.height * (e - b.e.top) / b.e.height;
    };
    VerticalPercentChangeScaler.prototype.q = function (a, b) {
        var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
        if (!b.a) {
            c = 1 - c;
        }
        return this.o + c * (this.m);
    };
    VerticalPercentChangeScaler.$t = markType(VerticalPercentChangeScaler, 'VerticalPercentChangeScaler', NumericScaler.$);
    return VerticalPercentChangeScaler;
}(NumericScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * A horizontal axis that uses a DateTime scale.
*
* You can use the `IgrPercentChangeYAxis` show percentage values.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrPercentChangeYAxis name="yAxis" />
*  </IgrDataChart>
* ```
*/
var IgrPercentChangeYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPercentChangeYAxis, _super);
    function IgrPercentChangeYAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrPercentChangeYAxis.prototype.createImplementation = function () {
        return new PercentChangeYAxis();
    };
    Object.defineProperty(IgrPercentChangeYAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPercentChangeYAxis;
}(IgrNumericYAxis));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPercentChangeYAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPercentChangeYAxisModule() {
    }
    IgrPercentChangeYAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrPercentChangeYAxis", IgrPercentChangeYAxis);
        TypeRegistrar.register("PercentChangeYAxis", PercentChangeYAxis.$type);
    };
    return IgrPercentChangeYAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarAxes = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAxes, _super);
    function PolarAxes(a, b) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.g = { $type: Point_$type, x: 0.5, y: 0.5 };
        _this.b = a;
        _this.a = b;
        return _this;
    }
    PolarAxes.prototype.c = function (a, b, c, d, e) {
        var f = this.g.x + (b * e(a));
        return ViewportUtils.c(f, c, d);
    };
    PolarAxes.prototype.h = function (a, b, c, d, e, f, g, h, i, j) {
        var k = this.a.getScaledAngle1(a, e, f);
        var l = this.b.lq(b, g, h, i, j);
        var m = this.g.x;
        var n = this.g.y;
        var o = m + (l * Math.cos(k));
        var p = n + (l * Math.sin(k));
        o = d.left + d.width * (o - c.left) / c.width;
        p = d.top + d.height * (p - c.top) / c.height;
        return { $type: Point_$type, x: o, y: p };
    };
    PolarAxes.prototype.e = function (a, b, c, d, e, f, g, h) {
        var i = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
        a.clear();
        var j;
        var k;
        var l = this.g.x;
        var m = this.g.y;
        var n;
        var o;
        var p = Math.min(this.a.j4, this.a.j3);
        var q = Math.max(this.a.j4, this.a.j3);
        var r = Math.min(this.b.j3, this.b.j4);
        var s = Math.max(this.b.j3, this.b.j4);
        var t = this.a.ju;
        var u = this.a.b8;
        var v = this.b.ju;
        var w = this.b.b8;
        var x = this.b.lj;
        var y = this.b.li;
        for (var z = 0; z < i; z++) {
            if ((b.item(z) <= q && b.item(z) >= p && c.item(z) <= s && c.item(z) >= r) || (isNaN_(b.item(z)) || isNaN_(c.item(z)))) {
                j = this.a.getScaledAngle1(b.item(z), t, u);
                k = this.b.lq(c.item(z), v, w, x, y);
                n = l + (k * f(z, j));
                o = m + (k * g(z, j));
                n = e.left + e.width * (n - d.left) / d.width;
                o = e.top + e.height * (o - d.top) / d.height;
                a.add({ $type: Point_$type, x: n, y: o });
            }
            else {
                a.add({ $type: Point_$type, x: NaN, y: NaN });
            }
        }
    };
    PolarAxes.prototype.f = function (a, b, c, d, e, f) {
        var g = ViewportUtils.a(a, c, d);
        var h = ViewportUtils.e(b, c, d);
        var i = Math.sqrt(Math.pow(g - this.g.x, 2) + Math.pow(h - this.g.y, 2));
        var j = Math.acos((g - this.g.x) / i);
        if ((h - this.g.y) < 0) {
            j = (2 * Math.PI) - j;
        }
        e = this.a.getUnscaledAngle(j);
        f = this.b.lr(i);
        return {
            p4: e,
            p5: f
        };
    };
    PolarAxes.prototype.d = function (a, b, c, d, e) {
        var f = this.g.y + (b * e(a));
        return ViewportUtils.f(f, c, d);
    };
    PolarAxes.$t = markType(PolarAxes, 'PolarAxes');
    return PolarAxes;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialAxes = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAxes, _super);
    function RadialAxes(a, b) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.h = { $type: Point_$type, x: 0.5, y: 0.5 };
        _this.b = a;
        _this.a = b;
        return _this;
    }
    RadialAxes.prototype.d = function (a, b, c, d) {
        var e = this.h.x + (b * Math.cos(a));
        return ViewportUtils.c(e, c, d);
    };
    RadialAxes.prototype.f = function (a, b, c, d, e, f, g) {
        var h = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
        var i = false;
        if (a.count == h) {
            i = true;
        }
        var j;
        var k;
        var l = this.h.x;
        var m = this.h.y;
        var n;
        var o;
        for (var p = 0; p < h; p++) {
            j = this.a.getScaledAngle(b.item(p));
            k = this.b.lp(c.item(p));
            n = l + (k * f(p, j));
            o = m + (k * g(p, j));
            n = e.left + e.width * (n - d.left) / d.width;
            o = e.top + e.height * (o - d.top) / d.height;
            if (!i) {
                a.add({ $type: Point_$type, x: n, y: o });
            }
            else {
                a.item(p, { $type: Point_$type, x: n, y: o });
            }
        }
    };
    RadialAxes.prototype.g = function (a, b, c, d, e, f) {
        var g = ViewportUtils.a(a, c, d);
        var h = ViewportUtils.e(b, c, d);
        var i = Math.sqrt(Math.pow(g - this.h.x, 2) + Math.pow(h - this.h.y, 2));
        var j = Math.acos((g - this.h.x) / i);
        if ((h - this.h.y) < 0) {
            j = (2 * Math.PI) - j;
        }
        e = this.a.getUnscaledAngle(j);
        f = this.b.lr(i);
        return {
            p4: e,
            p5: f
        };
    };
    RadialAxes.prototype.e = function (a, b, c, d) {
        var e = this.h.y + (b * Math.sin(a));
        return ViewportUtils.f(e, c, d);
    };
    RadialAxes.prototype.c = function (a) {
        var b = Math.sqrt(Math.pow(a.x - this.h.x, 2) + Math.pow(a.y - this.h.y, 2));
        var c = Math.acos((a.x - this.h.x) / b);
        if ((a.y - this.h.y) < 0) {
            c = (2 * Math.PI) - c;
        }
        return c;
    };
    RadialAxes.$t = markType(RadialAxes, 'RadialAxes');
    return RadialAxes;
}(Base));

/**
 * A horizontal axis that uses a DateTime scale.
*
* The `IgrTimeXAxis` is a horizontal axis that uses a DateTime scale.
*
* ```ts
*   <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*     <IgrTimeXAxis name="xAxis" label="Date"
* 			dateTimeMemberPath="Date" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.timeXAxis = new IgrTimeXAxis({name: "timeXAxis"});
* this.timeXAxis.title = "Time X Axis";
* this.timeXAxis.dataSource = this.financialData;
* this.timeXAxis.dateTimeMemberPath = "Time";
* ```
*/
var IgrTimeXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTimeXAxis, _super);
    function IgrTimeXAxis(props) {
        var _this = _super.call(this, props) || this;
        _this._breaks = null;
        _this._labelFormats = null;
        _this._intervals = null;
        return _this;
    }
    IgrTimeXAxis.prototype.createImplementation = function () {
        return new TimeXAxis();
    };
    Object.defineProperty(IgrTimeXAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeXAxis.prototype, "isPiecewise", {
        get: function () {
            return this.i.cb;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeXAxis.prototype, "breaks", {
        /**
         * TimeAxisBreaks to apply to this axis, representing spans of time to omit, such as weekends.
        *
        * The `breaks` to apply to this axis, representing spans of time to omit, such as weekends.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *     <IgrTimeXAxis name="xAxis" label="Date"
        * 			dateTimeMemberPath="Date" >
        *  </IgrTimeXAxis>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            if (this._breaks === null) {
                var coll = new IgrTimeAxisBreakCollection();
                var innerColl = this.i.breaks;
                if (!innerColl) {
                    innerColl = new TimeAxisBreakCollection();
                }
                this._breaks = coll._fromInner(innerColl);
            }
            return this._breaks;
        },
        set: function (v) {
            if (this._breaks !== null) {
                this._breaks._setSyncTarget(null);
                this._breaks = null;
            }
            var coll = new IgrTimeAxisBreakCollection();
            this._breaks = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(TimeAxisBreak.$type);
            var innerColl = this.i.breaks;
            if (!innerColl) {
                innerColl = new TimeAxisBreakCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._breaks._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeXAxis.prototype, "labelFormats", {
        /**
         * A list of axis label formats to apply, which are selected according to the visible axis range.
         * The label format selected will be the one with the largest range smaller than the visible range of the axis.
        */
        get: function () {
            if (this._labelFormats === null) {
                var coll = new IgrTimeAxisLabelFormatCollection();
                var innerColl = this.i.labelFormats;
                if (!innerColl) {
                    innerColl = new TimeAxisLabelFormatCollection();
                }
                this._labelFormats = coll._fromInner(innerColl);
            }
            return this._labelFormats;
        },
        set: function (v) {
            if (this._labelFormats !== null) {
                this._labelFormats._setSyncTarget(null);
                this._labelFormats = null;
            }
            var coll = new IgrTimeAxisLabelFormatCollection();
            this._labelFormats = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
            var innerColl = this.i.labelFormats;
            if (!innerColl) {
                innerColl = new TimeAxisLabelFormatCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._labelFormats._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeXAxis.prototype, "intervals", {
        /**
         * A list of axis label intervals to apply, which are selected according to the visible axis range.
         * The interval selected will be the one with the largest range smaller than the visible range of the axis.
        */
        get: function () {
            if (this._intervals === null) {
                var coll = new IgrTimeAxisIntervalCollection();
                var innerColl = this.i.intervals;
                if (!innerColl) {
                    innerColl = new TimeAxisIntervalCollection();
                }
                this._intervals = coll._fromInner(innerColl);
            }
            return this._intervals;
        },
        set: function (v) {
            if (this._intervals !== null) {
                this._intervals._setSyncTarget(null);
                this._intervals = null;
            }
            var coll = new IgrTimeAxisIntervalCollection();
            this._intervals = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(TimeAxisInterval.$type);
            var innerColl = this.i.intervals;
            if (!innerColl) {
                innerColl = new TimeAxisIntervalCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._intervals._setSyncTarget(syncColl);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTimeXAxis.prototype, "isCategoryDateTime", {
        /**
         * Gets if the current axis is of category date time axis type
        */
        get: function () {
            return this.i.b3;
        },
        enumerable: true,
        configurable: true
    });
    IgrTimeXAxis.prototype.getValueLabel = function (value) {
        var iv = this.i.fj(value);
        return (iv);
    };
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    IgrTimeXAxis.prototype.getIndexClosestToUnscaledValue = function (unscaledValue) {
        var iv = this.i.i$f(unscaledValue);
        return (iv);
    };
    return IgrTimeXAxis;
}(IgrTimeAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTimeXAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTimeXAxisModule() {
    }
    IgrTimeXAxisModule.register = function () {
        IgrTimeAxisBreakModule.register();
        IgrTimeAxisIntervalModule.register();
        IgrTimeAxisLabelFormatModule.register();
        TypeRegistrar.registerCons("IgrTimeXAxis", IgrTimeXAxis);
        TypeRegistrar.register("TimeXAxis", TimeXAxis.$type);
    };
    return IgrTimeXAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AngleRadiusPair = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AngleRadiusPair, _super);
    function AngleRadiusPair() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 0;
        _this.a = 0;
        _this.b = 0;
        return _this;
    }
    AngleRadiusPair.$t = markType(AngleRadiusPair, 'AngleRadiusPair');
    return AngleRadiusPair;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarLinePlanner = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLinePlanner, _super);
    function PolarLinePlanner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = false;
        _this.b = 0;
        _this.m = null;
        _this.n = null;
        _this.o = null;
        _this.p = null;
        _this.l = 0;
        _this.q = 0;
        _this.z = null;
        _this.aa = null;
        _this.a = null;
        _this.c = false;
        _this.d = false;
        _this.i = null;
        return _this;
    }
    Object.defineProperty(PolarLinePlanner.prototype, "ab", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            this.z = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarLinePlanner.prototype, "ac", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            this.aa = a;
        },
        enumerable: true,
        configurable: true
    });
    PolarLinePlanner.prototype.g = function () {
        if (this.m == null || this.n == null || this.o == null || this.p == null || Rect.l_op_Equality(this.ab, Rect.empty) || Rect.l_op_Equality(this.ac, Rect.empty)) {
            return false;
        }
        return true;
    };
    PolarLinePlanner.prototype.k = function (a, b, c, d) {
        var e = a(d) - a(c);
        var f = b(d) - b(c);
        return e * e + f * f;
    };
    PolarLinePlanner.prototype.h = function (a) {
        var b = new List$1(AngleRadiusPair.$, 0);
        var c = this.l * this.l;
        var d;
        if (a != null) {
            d = a;
        }
        else {
            var e = new List$1(Number_$type, 0);
            for (var f = 0; f < this.q; f++) {
                e.add(f);
            }
            d = e;
        }
        var g = getEnumerator(d);
        var h = true;
        h = g.moveNext();
        var i = 0;
        if (h) {
            i = g.current;
        }
        while (h) {
            var j = i;
            h = g.moveNext();
            i = g.current;
            while (h && this.k(this.o, this.p, j, i) < c) {
                h = g.moveNext();
                i = g.current;
            }
            var k = new AngleRadiusPair();
            k.c = j;
            if (!this.f) {
                k.a = this.m(j);
                k.b = this.n(j);
            }
            b.add(k);
        }
        return b;
    };
    PolarLinePlanner.prototype.v = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.h(a))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (isNaN_(b.a) || isInfinity(b.a) || isNaN_(b.b) || isInfinity(b.b)) {
                    this.s({ $type: Point_$type, x: NaN, y: NaN });
                    continue;
                }
                this.s({ $type: Point_$type, x: this.o(b.c), y: this.p(b.c) });
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    PolarLinePlanner.prototype.j = function () {
        return Math.pow(this.l / (Math.max(this.ab.width / this.ac.width, this.ab.height / this.ac.height)), 2);
    };
    PolarLinePlanner.prototype.r = function (a, b) {
        var c = 0.5 + b * Math.cos(a);
        var d = 0.5 + b * Math.sin(a);
        c = this.z.left + this.z.width * (c - this.aa.left) / this.aa.width;
        d = this.z.top + this.z.height * (d - this.aa.top) / this.aa.height;
        this.s({ $type: Point_$type, x: c, y: d });
    };
    PolarLinePlanner.prototype.y = function (a) {
        var b = this.j();
        var c = this.h(a);
        var d = c.item(0).a;
        var e = c.item(0).b;
        var f = c.item(0).c;
        for (var g = 1; g < c.count; g++) {
            var h = c.item(g).a;
            var i = c.item(g).b;
            var j = c.item(g).c;
            if (isNaN_(h) || isInfinity(h) || isNaN_(i) || isInfinity(i)) {
                this.s({ $type: Point_$type, x: NaN, y: NaN });
                if (this.b != 0) {
                    g++;
                    if (g < c.count) {
                        d = c.item(g).a;
                        e = c.item(g).b;
                    }
                }
                continue;
            }
            this.t(h, i, d, e, g, b, f > j);
            d = h;
            e = i;
            f = j;
        }
    };
    PolarLinePlanner.prototype.t = function (a, b, c, d, e, f, g) {
        var h = false;
        if ((a < c && !g) || (a > c && g)) {
            h = true;
            var i = a;
            a = c;
            c = i;
            i = b;
            b = d;
            d = i;
        }
        var j = SpiralFlattener.a(c, d, a, b, f);
        if (h) {
            var k = new List$1(Number_$type, 2, j.count);
            for (var l = j.count - 1; l >= 0; l--) {
                k.add(j._inner[l]);
            }
            j = k;
        }
        for (var m = 0; m < j.count; m++) {
            var n = j._inner[m];
            var o = c + n * (a - c);
            var p = d + n * (b - d);
            this.r(o, p);
        }
    };
    PolarLinePlanner.prototype.u = function (a) {
        var _this = this;
        var b = this.ab.top - 10;
        var c = this.ab.bottom + 10;
        var d = this.ab.left - 10;
        var e = this.ab.right + 10;
        if (this.a == null) {
            this.a = ((function () {
                var $ret = new Clipper(1, d, c, e, b, _this.d);
                $ret.i = a;
                return $ret;
            })());
        }
    };
    PolarLinePlanner.prototype.e = function (a) {
        return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
    };
    PolarLinePlanner.prototype.s = function (a) {
        if (this.b == 0 && !this.e(a)) {
            return;
        }
        if (this.c) {
            this.i.add(a);
        }
        else {
            this.a.j(a);
        }
    };
    PolarLinePlanner.prototype.w = function (a) {
        this.x(null, null);
    };
    PolarLinePlanner.prototype.x = function (a, b) {
        this.i = a;
        if (!this.g()) {
            return;
        }
        if (this.q > 1) {
            this.u(a);
            if (this.f) {
                this.v(b);
            }
            else {
                this.y(b);
            }
            this.a.i = null;
        }
    };
    PolarLinePlanner.$t = markType(PolarLinePlanner, 'PolarLinePlanner');
    return PolarLinePlanner;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IOverlayProxy_$type = /*@__PURE__*/ new Type(null, 'IOverlayProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OverlayProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OverlayProxy, _super);
    function OverlayProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OverlayProxy.prototype.matchesType = function (a) {
        if (stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return true;
        }
        return false;
    };
    OverlayProxy.prototype.setCloseMemberPath = function (a, b) {
        a.oc = b;
    };
    OverlayProxy.prototype.setHighMemberPath = function (a, b) {
        a.of = b;
    };
    OverlayProxy.prototype.setLowMemberPath = function (a, b) {
        a.ok = b;
    };
    OverlayProxy.prototype.setMultiplier = function (a, b) {
        if (getInstanceType(a).typeName == "BollingerBandsOverlay") {
            var s_ = a;
            var p_ = b;
            s_['multiplier'] = p_;
        }
    };
    OverlayProxy.prototype.setOpenMemberPath = function (a, b) {
        a.oo = b;
    };
    OverlayProxy.prototype.setVolumeMemberPath = function (a, b) {
        a.os = b;
    };
    OverlayProxy.prototype.setXAxis = function (a, b) {
        a.l8 = b;
    };
    OverlayProxy.prototype.setYAxis = function (a, b) {
        a.mt = b;
    };
    OverlayProxy.$t = markType(OverlayProxy, 'OverlayProxy', Base.$, [IOverlayProxy_$type]);
    return OverlayProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrOverlayProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrOverlayProxyModule() {
    }
    IgrOverlayProxyModule.register = function () {
        TypeRegistrar.register('OverlayProxy', OverlayProxy.$type);
    };
    return IgrOverlayProxyModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IIndicatorProxy_$type = /*@__PURE__*/ new Type(null, 'IIndicatorProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IShortPeriodLongPeriod_$type = /*@__PURE__*/ new Type(null, 'IShortPeriodLongPeriod');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialValueList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialValueList, _super);
    function FinancialValueList(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.b = null;
        _this.a = null;
        _this.c = null;
        _this.e = null;
        _this.d = a;
        _this.b = b;
        _this.a = d;
        _this.c = c;
        _this.e = e;
        return _this;
    }
    FinancialValueList.prototype.indexOf = function (a) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.insert = function (a, b) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.removeAt = function (a) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            return b;
        }
        else {
            var b_1 = NaN;
            var c = NaN;
            var d = NaN;
            var e = NaN;
            var f = NaN;
            if (this.d != null && a >= 0 && a < this.d.count) {
                b_1 = this.d.item(a);
            }
            if (this.b != null && a >= 0 && a < this.b.count) {
                c = this.b.item(a);
            }
            if (this.c != null && a >= 0 && a < this.c.count) {
                d = this.c.item(a);
            }
            if (this.a != null && a >= 0 && a < this.a.count) {
                e = this.a.item(a);
            }
            if (this.e != null && a >= 0 && a < this.e.count) {
                f = this.e.item(a);
            }
            var g = isNaN_(b_1);
            var h = isNaN_(c);
            var i = isNaN_(d);
            var j = isNaN_(e);
            var k = isNaN_(f);
            if (!h && !i && !j) {
                return (c + d + e) / 3;
            }
            if (!h && !i) {
                return (c + d) / 2;
            }
            if (!g && !j) {
                return (b_1 + e) / 2;
            }
            if (!g) {
                return b_1;
            }
            if (!h) {
                return c;
            }
            if (!i) {
                return d;
            }
            if (!j) {
                return e;
            }
            return NaN;
        }
    };
    FinancialValueList.prototype.add = function (a) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.clear = function () {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.contains = function (a) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.copyTo = function (a, b) {
        throw new NotImplementedException(0);
    };
    Object.defineProperty(FinancialValueList.prototype, "count", {
        get: function () {
            var a = 0;
            var b = 0;
            var c = 0;
            var d = 0;
            var e = 0;
            if (this.d != null) {
                a = this.d.count;
            }
            if (this.b != null) {
                b = this.b.count;
            }
            if (this.c != null) {
                c = this.c.count;
            }
            if (this.a != null) {
                d = this.a.count;
            }
            if (this.e != null) {
                e = this.e.count;
            }
            var f = 0;
            f = Math.max(f, a);
            f = Math.max(f, b);
            f = Math.max(f, c);
            f = Math.max(f, d);
            f = Math.max(f, e);
            return f;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialValueList.prototype, "isReadOnly", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    FinancialValueList.prototype.remove = function (a) {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.getEnumerator = function () {
        throw new NotImplementedException(0);
    };
    FinancialValueList.prototype.getEnumeratorObject = function () {
        throw new NotImplementedException(0);
    };
    FinancialValueList.$t = markType(FinancialValueList, 'FinancialValueList', Base.$, [IList$1_$type.specialize(Number_$type)]);
    return FinancialValueList;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalculatedColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalculatedColumn, _super);
    function CalculatedColumn(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this._valuesProvider = null;
        _this.c = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [];
                    for (var b = 1; b < _rest.length; b++) {
                        d[b - 1] = _rest[b];
                    }
                    _this._valuesProvider = c;
                    _this.c = new List$1(String_$type, 1, d);
                }
                break;
            case 1:
                {
                    var d = _rest[0];
                    var e = _rest[1];
                    _this._valuesProvider = d;
                    _this.c = new List$1(String_$type, 1, e);
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(CalculatedColumn.prototype, "basedOn", {
        get: function () {
            return this.c;
        },
        enumerable: true,
        configurable: true
    });
    CalculatedColumn.prototype.getEnumerator = function () {
        return getEnumerator(this._valuesProvider);
    };
    CalculatedColumn.prototype.getEnumeratorObject = function () {
        return getEnumerator(this._valuesProvider);
    };
    CalculatedColumn.$t = markType(CalculatedColumn, 'CalculatedColumn', Base.$, [IEnumerable$1_$type.specialize(Number_$type)]);
    return CalculatedColumn;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SupportingCalculation$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SupportingCalculation$1, _super);
    function SupportingCalculation$1($tCalculationStrategy, a) {
        var _rest = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            _rest[_i - 2] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.$tCalculationStrategy = null;
        _this.a = null;
        _this.d = null;
        _this.$tCalculationStrategy = $tCalculationStrategy;
        _this.$type = _this.$type.specialize(_this.$tCalculationStrategy);
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this.a = c;
                    _this.d = new List$1(String_$type, 0);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.a = c;
                    _this.d = new List$1(String_$type, 1, d);
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(SupportingCalculation$1.prototype, "b", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SupportingCalculation$1.prototype, "c", {
        get: function () {
            return this.d;
        },
        enumerable: true,
        configurable: true
    });
    SupportingCalculation$1.$t = markType(SupportingCalculation$1, 'SupportingCalculation$1');
    return SupportingCalculation$1;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ColumnSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnSupportingCalculation, _super);
    function ColumnSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    ColumnSupportingCalculation.$t = markType(ColumnSupportingCalculation, 'ColumnSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return ColumnSupportingCalculation;
}(SupportingCalculation$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var FinancialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bw.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bs;
        var c = this.a.br;
        var d = this.a.br;
        if (this.a.bw != null) {
            d = this.a.bw.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bw.l8 == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.bw.l8 != null) ? this.a.bw.l8.b8 : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.bw.lq(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.bw.l8);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.bw.l8.dz(g.left, f));
            var j = Math.ceil(this.a.bw.l8.dz(g.right, f));
            if (this.a.bw.l8.b8) {
                j = Math.ceil(this.a.bw.l8.dz(g.left, f));
                i = Math.floor(this.a.bw.l8.dz(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
/**
 * @hidden
 */
var FinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.m1 = null;
        _this.mx = null;
        _this.mz = null;
        _this.mv = null;
        _this.m4 = null;
        _this.m8 = false;
        _this.assigningCategoryStyle = null;
        _this.mg = null;
        _this.nj = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.nk = new Dictionary$2(String_$type, String_$type, 0);
        _this.m7 = false;
        _this.mr = null;
        _this.mb = null;
        _this.md = null;
        _this.ma = null;
        _this.mj = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.m6 = false;
        _this.nw = null;
        _this.nu = null;
        _this.nv = null;
        _this.nt = null;
        _this.nx = null;
        _this.mc = null;
        _this.l9 = null;
        _this.me = 0;
        _this.ms = null;
        _this.mu = null;
        _this.mg = new CategorySeriesRenderManager();
        _this.m8 = false;
        _this.mj = new CategoryTransitionSourceFramePreparer();
        _this.mc = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.mf = 0;
        return _this;
    }
    FinancialSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.mo = a;
    };
    FinancialSeries.prototype.get_cr = function () {
        return true;
    };
    FinancialSeries.prototype.ag = function () {
        return [this.l8, this.mt];
    };
    FinancialSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == FinancialSeries.$$p[6]) {
            return this.ft(a, b, this.oo);
        }
        if (c == FinancialSeries.$$p[1]) {
            return this.ft(a, b, this.of);
        }
        if (c == FinancialSeries.$$p[4]) {
            return this.ft(a, b, this.ok);
        }
        if (c == FinancialSeries.$$p[0]) {
            return this.ft(a, b, this.oc);
        }
        if (c == FinancialSeries.$$p[8]) {
            return this.ft(a, b, this.os);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    FinancialSeries.prototype.n8 = function () {
        return 2;
    };
    FinancialSeries.prototype.n6 = function () {
        return 4;
    };
    FinancialSeries.prototype.ah = function (a) {
        var b = this.aj(this.l8, this.ma.f, this.n5(this.bi), this.n7(this.bi), this.lo(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.n8();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ai = function (a) {
        var b = this.aj(this.l8, this.ma.f, this.n5(this.bi), this.n7(this.bi), this.lo(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.k9 = function () {
        return this.pe;
    };
    FinancialSeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.l8 = null;
        this.mt = null;
    };
    Object.defineProperty(FinancialSeries.prototype, "m2", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            if (this.m1 != a) {
                var b = this.m1;
                this.m1 = a;
                this.raisePropertyChanged("OpenColumn", b, this.m1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "my", {
        get: function () {
            return this.mx;
        },
        set: function (a) {
            if (this.mx != a) {
                var b = this.mx;
                this.mx = a;
                this.raisePropertyChanged("HighColumn", b, this.mx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "m0", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            if (this.mz != a) {
                var b = this.mz;
                this.mz = a;
                this.raisePropertyChanged("LowColumn", b, this.mz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mw", {
        get: function () {
            return this.mv;
        },
        set: function (a) {
            if (this.mv != a) {
                var b = this.mv;
                this.mv = a;
                this.raisePropertyChanged("CloseColumn", b, this.mv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "m5", {
        get: function () {
            return this.m4;
        },
        set: function (a) {
            if (this.m4 != a) {
                var b = this.m4;
                this.m4 = a;
                this.raisePropertyChanged("VolumeColumn", b, this.m4);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ng = function () {
        return (this.assigningCategoryStyle != null && this.m8) || this.cu;
    };
    FinancialSeries.prototype.o0 = function (a) {
        if (this.assigningCategoryStyle != null && this.m8) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.oy = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.mg.ac(a, b, c, d, e, f, g);
        var h = this.mg.c;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.o0(h);
        this.mg.aa(i, f, g);
    };
    FinancialSeries.prototype.ny = function (a) {
        return this.ed(a, this.l8);
    };
    FinancialSeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.l8, runOn(this, this.ny), new FinancialValueList(this.m2, this.my, this.m0, this.mw, this.m5));
    };
    FinancialSeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.l8, runOn(this, this.ny), new FinancialValueList(this.m2, this.my, this.m0, this.mw, this.m5));
    };
    FinancialSeries.prototype.d9 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.l8.jy;
        return this.ea(a, b, this.l8, d, e, f, runOn(this, this.ny));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.l8.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    FinancialSeries.prototype.ll = function (a, b, c) {
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, null, null, null);
    };
    FinancialSeries.prototype.en = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(new FinancialValueList(this.m2, this.my, this.m0, this.mw, this.m5), a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.ej = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(this.my, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.el = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(this.m0, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.n0 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(this.mw, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.n1 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(this.m2, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.n2 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        return this.ep(this.m5, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialSeries.prototype.lh = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, runOn(this, this.ej), function (d, e) { return _this.ff(d, e, _this.l8, runOn(_this, _this.ny), _this.my); }, function (d, e) { return _this.fd(d, e, _this.l8, runOn(_this, _this.ny), _this.my); });
    };
    FinancialSeries.prototype.lj = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, runOn(this, this.el), function (d, e) { return _this.ff(d, e, _this.l8, runOn(_this, _this.ny), _this.m0); }, function (d, e) { return _this.fd(d, e, _this.l8, runOn(_this, _this.ny), _this.m0); });
    };
    FinancialSeries.prototype.pg = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, runOn(this, this.n1), function (d, e) { return _this.ff(d, e, _this.l8, runOn(_this, _this.ny), _this.m2); }, function (d, e) { return _this.fd(d, e, _this.l8, runOn(_this, _this.ny), _this.m2); });
    };
    FinancialSeries.prototype.pf = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, runOn(this, this.n0), function (d, e) { return _this.ff(d, e, _this.l8, runOn(_this, _this.ny), _this.mw); }, function (d, e) { return _this.fd(d, e, _this.l8, runOn(_this, _this.ny), _this.mw); });
    };
    FinancialSeries.prototype.ph = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.nz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.mt, this.l8, runOn(this, this.n2), function (d, e) { return _this.ff(d, e, _this.l8, runOn(_this, _this.ny), _this.m5); }, function (d, e) { return _this.fd(d, e, _this.l8, runOn(_this, _this.ny), _this.m5); });
    };
    FinancialSeries.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.l8 != null) {
            this.l8.g6(false);
        }
        if (this.mt != null) {
            this.mt.g6(false);
        }
    };
    FinancialSeries.prototype.jt = function (a, b) {
        this.mo.bu.e(this.eu);
        this.jd(false);
    };
    FinancialSeries.prototype.js = function (a, b) {
        if (this.dm && this.ez < 0.05) {
            this.dn = true;
        }
        this.mo.bu.e(this.eu);
        this.jd(false);
    };
    FinancialSeries.prototype.m3 = function (a, b, c) {
        var d = this.bw(b);
        this.nj.addItem(d, b);
        this.nk.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.ox = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.nj.item(b);
        this.nk.removeItem(c);
        this.nj.removeItem(b);
    };
    FinancialSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.l8 != null) {
                        this.l8.bv(this);
                    }
                    if (this.mt != null) {
                        this.mt.bv(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.l8 != null) {
                        this.l8.ci(this);
                    }
                    if (this.mt != null) {
                        this.mt.ci(this);
                    }
                }
                this.mo.bu.e(this.eu);
                this.jd(false);
                break;
            case "FastItemsSource":
                this.m7 = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.ox(typeCast(IFastItemsSource_$type, c), this.m2);
                    this.ox(typeCast(IFastItemsSource_$type, c), this.my);
                    this.ox(typeCast(IFastItemsSource_$type, c), this.m0);
                    this.ox(typeCast(IFastItemsSource_$type, c), this.mw);
                    this.ox(typeCast(IFastItemsSource_$type, c), this.m5);
                    this.m2 = null;
                    this.my = null;
                    this.m0 = null;
                    this.mw = null;
                    this.m5 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (stringIsNullOrEmpty(this.oo) == false) {
                        this.m2 = this.m3(typeCast(IFastItemsSource_$type, d), this.oo, "OpenColumn");
                    }
                    if (stringIsNullOrEmpty(this.of) == false) {
                        this.my = this.m3(typeCast(IFastItemsSource_$type, d), this.of, "HighColumn");
                    }
                    if (stringIsNullOrEmpty(this.ok) == false) {
                        this.m0 = this.m3(typeCast(IFastItemsSource_$type, d), this.ok, "LowColumn");
                    }
                    if (stringIsNullOrEmpty(this.oc) == false) {
                        this.mw = this.m3(typeCast(IFastItemsSource_$type, d), this.oc, "CloseColumn");
                    }
                    if (stringIsNullOrEmpty(this.os) == false) {
                        this.m5 = this.m3(typeCast(IFastItemsSource_$type, d), this.os, "VolumeColumn");
                    }
                }
                this.m7 = false;
                if (this.mt != null && !this.mt.cl()) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.bz != null) {
                    this.ox(this.bz, this.m2);
                    this.m2 = this.m3(this.bz, this.oo, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.mt != null && !this.mt.cl() && !this.m7) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.bz != null) {
                    this.ox(this.bz, this.my);
                    this.my = this.m3(this.bz, this.of, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.mt != null && !this.mt.cl() && !this.m7) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.bz != null) {
                    this.ox(this.bz, this.m0);
                    this.m0 = this.m3(this.bz, this.ok, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.mt != null && !this.mt.cl() && !this.m7) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.bz != null) {
                    this.ox(this.bz, this.mw);
                    this.mw = this.m3(this.bz, this.oc, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.mt != null && !this.mt.cl() && !this.m7) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                this.o2();
                break;
            case FinancialSeries.$$p[8]:
                if (this.bz != null) {
                    this.ox(this.bz, this.m5);
                    this.m5 = this.m3(this.bz, this.os, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.mt != null && !this.mt.cl() && !this.m7) {
                    this.mo.bu.e(this.eu);
                    this.jd(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.mo.bu.e(this.eu);
                this.jd(false);
                this.ik();
                this.ms = typeCast(ITimeRangeSelectorAxis_$type, this.l8);
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.mo.bu.e(this.eu);
                if (this.mt != null) {
                    this.mt.cl();
                }
                {
                    this.jd(false);
                }
                this.ik();
                break;
            case "TransitionProgress":
                this.md.c(this.ez, this.mb, this.ma);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.ma.v();
                    this.o1(this.ma, this.mo);
                    if (this.dm) {
                        this.dm = false;
                        this.hw();
                        this.bt.r = truncate(this.eq());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.o1(this.md, this.mo);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.jd(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.m8 = this.nb();
                this.jd(false);
                break;
            case "CategoryMode":
                if (this.l8 != null) {
                    this.l8.kn(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.na = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.m9 = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.l1 = function (a, b, c) {
        if (b < a || a < 0 || a > this.bz.count || b < 0 || b > this.bz.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cd;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.n5 = function (a) {
        return a.bu.b;
    };
    FinancialSeries.prototype.n7 = function (a) {
        return a.bu.c;
    };
    FinancialSeries.prototype.l0 = function (a, b) {
        return this.l1(a, b, this.mt);
    };
    FinancialSeries.prototype.get_nc = function () {
        return false;
    };
    Object.defineProperty(FinancialSeries.prototype, "nc", {
        get: function () {
            return this.get_nc();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_cv = function () {
        return true;
    };
    FinancialSeries.prototype.at = function (a, b) {
        if (this.nc) {
            var c = this.mq(a, b, this.mr);
            this.mr = c;
            return c;
        }
        else {
            var d = this.mp(a, b, this.mr);
            this.mr = d;
            return d;
        }
    };
    FinancialSeries.prototype.n9 = function (a) {
        var b = this.ma;
        if (this.ca()) {
            b = this.md;
        }
        var c = this.bi.br;
        var d = this.bi.bs;
        var e = this.l8;
        var f = 0;
        if (e.cf) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.mq = function (a, b, c) {
        var d = this.bz.count;
        var e = this.mo.bu.c;
        var f = this.mo.bu.d;
        var g = this.mo.bu.b;
        var h = this.l8;
        var i = -1;
        var j = -1;
        if (h.cd) {
            var k = this.ma;
            if (this.ca()) {
                k = this.md;
            }
            var l = this.n9(b);
            i = l;
            j = l;
        }
        else {
            var m = this.e8(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    };
    FinancialSeries.prototype.mp = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.nb = function () {
        return this.ne;
    };
    FinancialSeries.prototype.eb = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.l8 != null) {
            var e = this.getEffectiveViewport1(this.bi);
            var f = new ScalerParams(0, b, c, this.l8.b8, e);
            var g = this.lq(this.bi);
            var h = this.l8.dz(g.left, f);
            var i = this.l8.dz(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.l8.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.e8 = function (a) {
        return truncate(Math.round(this.eb(a)));
    };
    FinancialSeries.prototype.get_c1 = function () {
        return typeCast(ISortingAxis_$type, this.l8) !== null;
    };
    FinancialSeries.prototype.ap = function () {
        return this.l8;
    };
    FinancialSeries.prototype.fa = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.l8.b8, d);
        var g = typeCast(ISortingAxis_$type, this.l8);
        var h = this.lq(this.bi);
        var i = h.left;
        var j = h.right;
        var k = this.lg(a).x;
        var l = this.l8.dz(k, f);
        var m = this.l8.dz(i, f);
        var n = this.l8.dz(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.fp = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.l8) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    FinancialSeries.prototype.nz = function (a, b, c) {
        if (this.l8 == null) {
            return 0;
        }
        return this.l8.js(a, b, c, this.fh);
    };
    FinancialSeries.prototype.dc = function () {
        return this.nf;
    };
    FinancialSeries.prototype.mh = function () {
        return 11;
    };
    FinancialSeries.prototype.bo = function () {
        return 3;
    };
    FinancialSeries.prototype.o1 = function (a, b) {
        this.lp = a.aa;
        b.ar();
    };
    FinancialSeries.prototype.oz = function (a, b) {
        a.u();
    };
    FinancialSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = c;
        if (this.bz == null || this.bz.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.l8 == null || this.mt == null || e.bu.b < 1 || this.l8.bf == null || this.mt.bf == null || this.mt.j4 == this.mt.j3 || this.l8.itemsSource == null || this.l8.jy < 1) {
            e.bu.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.bi.bs;
        a = this.bi.br;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.n3 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(this.bi);
        if (!c.isEmpty && !d.isEmpty && this.mt != null) {
            var f = new ScalerParams(0, c, d, this.mt.b8, e);
            f.b = this.eh();
            b = this.mt.dw(this.mt.ke, f);
        }
        return b;
    };
    FinancialSeries.prototype.hw = function () {
        _super.prototype.hw.call(this);
        this.mb.v();
        this.ma.v();
        this.md.v();
    };
    FinancialSeries.prototype.je = function (a) {
        var _this = this;
        _super.prototype.je.call(this, a);
        this.mo.bu.e(this.eu);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.de) {
            if (this.ca()) {
                this.o1(this.md, this.mo);
            }
            else {
                this.o1(this.ma, this.mo);
            }
            return;
        }
        if (this.da(a)) {
            var b = this.mb;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.mb = this.md;
                this.md = b;
            }
            else {
                this.mb = this.ma;
                this.ma = b;
            }
            this.oz(this.ma, this.mo);
            if (this.dp) {
                this.bt.w();
                this.bt.r = truncate(this.er());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.mj.p(this.mb, this.ma, this.isVertical, this.l8, this.mt, this.mi, this.mh(), this.bp, this.bo(), function () { return _this.n3(_this.mo); }, this.mo.br);
            }
            this.hs();
            this.jl();
            if (this.dp) {
                this.dn = false;
                this.dm = true;
            }
        }
        else {
            this.oz(this.ma, this.mo);
            this.o1(this.ma, this.mo);
        }
    };
    FinancialSeries.prototype.nh = function (a) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                switch (b) {
                    case "HighColumn":
                        if (this.my == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.m0 == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.m2 == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.mw == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.m5 == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "ni", {
        get: function () {
            return this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.nd = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.ow = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "nq", {
        get: function () {
            return this.nn();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._nn = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h;
        var e_2, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.nd())
                        return [3 /*break*/, 8];
                    b = this.mk(0, this.bz.count);
                    this.ow(new FinancialEventArgs(0, this.bz.count, b, this.ml(b), this));
                    if (!(b.typicalColumn != null))
                        return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = __values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done)
                        return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return))
                            _c.call(_a);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a)
                        return [3 /*break*/, 17];
                    if (!(this.ni && this.l8.i$b != null))
                        return [3 /*break*/, 13];
                    d = this.bz.count;
                    e = this.l8.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d))
                        return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.my.item(e.item(f)) + this.m0.item(e.item(f)) + this.mw.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.bz.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g))
                        return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.my.item(h) + this.m0.item(h) + this.mw.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.nn = function () {
        var _this = this;
        return toEnum(function () { return _this._nn(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "np", {
        get: function () {
            return this.nm();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._nm = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.ni && this.l8.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.my.count;
                    b = this.l8.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.n4(this.my.item(b.item(0)) - this.m0.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.n4(this.my.item(b.item(c)) - this.m0.item(b.item(c))), Math.max(this.n4(Math.abs(this.my.item(b.item(c)) - this.mw.item(b.item(c - 1)))), this.n4(Math.abs(this.m0.item(b.item(c)) - this.mw.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.my.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.n4(this.my.item(0) - this.m0.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.n4(this.my.item(e) - this.m0.item(e)), Math.max(this.n4(Math.abs(this.my.item(e) - this.mw.item(e - 1))), this.n4(Math.abs(this.m0.item(e) - this.mw.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.nm = function () {
        var _this = this;
        return toEnum(function () { return _this._nm(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "no", {
        get: function () {
            return this.nl();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._nl = function () {
        var a, b, c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.ni && this.l8.i$b != null))
                        return [3 /*break*/, 7];
                    a = this.m0.count;
                    b = this.l8.i$b;
                    if (!(a > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, this.n4(this.m0.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.n4(this.m0.item(b.item(c))), this.n4(this.mw.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.m0.count;
                    if (!(d > 0))
                        return [3 /*break*/, 9];
                    return [4 /*yield*/, this.n4(this.m0.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d))
                        return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.n4(this.m0.item(e)), this.n4(this.mw.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.nl = function () {
        var _this = this;
        return toEnum(function () { return _this._nl(); });
    };
    FinancialSeries.prototype.ns = function (a) {
        if (a == null) {
            return null;
        }
        if (this.ni && this.l8.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.l8.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.nr = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.bz != null && !this.m6) {
            this.m6 = true;
            var b = this.mk(0, this.bz.count);
            this.m6 = false;
            var c = new FinancialEventArgs(0, this.bz.count, b, this.ml(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.m2 == null) {
            return null;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            if (this.nw != null) {
                return this.nw.asArray();
            }
            var a = new List$1(Number_$type, 2, this.m2.count);
            var b = this.l8.i$b;
            var c = this.m2.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nw = a;
            return this.nw.asArray();
        }
        else {
            return this.m2.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.my == null) {
            return null;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            if (this.nu != null) {
                return this.nu.asArray();
            }
            var a = new List$1(Number_$type, 2, this.my.count);
            var b = this.l8.i$b;
            var c = this.my.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nu = a;
            return this.nu.asArray();
        }
        else {
            return this.my.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.m0 == null) {
            return null;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            if (this.nv != null) {
                return this.nv.asArray();
            }
            var a = new List$1(Number_$type, 2, this.m0.count);
            var b = this.l8.i$b;
            var c = this.m0.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nv = a;
            return this.nv.asArray();
        }
        else {
            return this.m0.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.mw == null) {
            return null;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            if (this.nt != null) {
                return this.nt.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mw.count);
            var b = this.l8.i$b;
            var c = this.mw.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nt = a;
            return this.nt.asArray();
        }
        else {
            return this.mw.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.m5 == null) {
            return null;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            if (this.nx != null) {
                return this.nx.asArray();
            }
            var a = new List$1(Number_$type, 2, this.m5.count);
            var b = this.l8.i$b;
            var c = this.m5.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nx = a;
            return this.nx.asArray();
        }
        else {
            return this.m5.asArray();
        }
    };
    FinancialSeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        if (this.l8 == null || !(typeCast(ISortingAxis_$type, this.l8) !== null)) {
            return;
        }
        var e = this.l8.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.nw != null) {
                        this.nw.insert(f, this.m2.item(g));
                    }
                    if (this.nu != null) {
                        this.nu.insert(f, this.my.item(g));
                    }
                    if (this.nv != null) {
                        this.nv.insert(f, this.m0.item(g));
                    }
                    if (this.nt != null) {
                        this.nt.insert(f, this.mw.item(g));
                    }
                    if (this.nx != null) {
                        this.nx.insert(f, this.m5.item(g));
                    }
                }
                break;
            case 0:
                if (this.nw != null) {
                    this.nw.v(b, c);
                }
                if (this.nu != null) {
                    this.nu.v(b, c);
                }
                if (this.nv != null) {
                    this.nv.v(b, c);
                }
                if (this.nt != null) {
                    this.nt.v(b, c);
                }
                if (this.nx != null) {
                    this.nx.v(b, c);
                }
                break;
            case 4:
                if (this.nw != null) {
                    this.nw = new List$1(Number_$type, 0);
                }
                if (this.nu != null) {
                    this.nu = new List$1(Number_$type, 0);
                }
                if (this.nv != null) {
                    this.nv = new List$1(Number_$type, 0);
                }
                if (this.nt != null) {
                    this.nt = new List$1(Number_$type, 0);
                }
                if (this.nx != null) {
                    this.nx = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.nw != null) {
                        this.nw._inner[h] = this.m2.item(i);
                    }
                    if (this.nu != null) {
                        this.nu._inner[h] = this.my.item(i);
                    }
                    if (this.nv != null) {
                        this.nv._inner[h] = this.m0.item(i);
                    }
                    if (this.nt != null) {
                        this.nt._inner[h] = this.mw.item(i);
                    }
                    if (this.nx != null) {
                        this.nx._inner[h] = this.m5.item(i);
                    }
                }
                break;
        }
        this.o2();
        this.jq();
    };
    FinancialSeries.prototype.mk = function (a, b) {
        var _this = this;
        var c = this.ns(this.m2);
        var d = this.ns(this.mw);
        var e = this.ns(this.my);
        var f = this.ns(this.m0);
        var g = this.ns(this.m5);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.nq), _this.nr());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.np), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.no), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.bz != null ? _this.bz.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.n4 = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.ml = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.d1;
            $ret.j = Series.d0;
            $ret.i = runOn(_this, _this.n4);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.l8;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.bh);
        this.bi.az(b);
        c.bu.e(this.eu);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.df) {
            this.oz(this.mc, c);
        }
        this.df = false;
        this.o1(this.mc, c);
        this.dl = false;
    };
    FinancialSeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.bu.e(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.l9 == null) {
            this.l9 = new CategoryFrame(3);
        }
        this.l9.u();
        this.oz(this.l9, g);
        this.o1(this.l9, g);
    };
    FinancialSeries.prototype.am = function (a) {
        if (this.l8 == a) {
            return this.mt;
        }
        if (this.mt == a) {
            return this.l8;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.l8);
        return b != null ? b.preferredCategoryMode(this) : this.mf;
    };
    Object.defineProperty(FinancialSeries.prototype, "mf", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            var b = this.mf;
            if (a != b) {
                this.me = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.mf));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_cz = function () {
        return true;
    };
    FinancialSeries.prototype.ji = function (a, b) {
        _super.prototype.ji.call(this, a, b);
        this.pe = a;
    };
    FinancialSeries.prototype.o2 = function () {
        this.d8 = this.mw == null || this.mw.count == 0 ? NaN : this.mw.item(this.mw.count - 1);
    };
    FinancialSeries.prototype.fr = function (a) {
        if (this.ms != null && a != null) {
            if (this.mu == null || this.mu.propertyName != this.ms.dateTimeMemberPath) {
                this.mu = new FastReflectionHelper(false, this.ms.dateTimeMemberPath);
            }
            var b = this.mu.getPropertyValue(a);
            if (typeCast(Date_$type, b) !== null) {
                return dateToStringFormat(b, this.ms.itemLabelFormat());
            }
        }
        return _super.prototype.fr.call(this, a);
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:oc:o3', [2, null], 'HighMemberPath:of:o4', [2, null], 'IsCustomCategoryStyleAllowed:ne:o5', [0, false], 'IsTransitionInEnabled:nf:o6', [0, false], 'LowMemberPath:ok:o7', [2, null], 'NegativeBrush:pe:o8', [Brush.$, null], 'OpenMemberPath:oo:o9', [2, null], 'TransitionInMode:mi:pa', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:os:pb', [2, null], 'XAxis:l8:pc', [CategoryAxisBase.$, null], 'YAxis:mt:pd', [NumericYAxis.$, null]]);
    return FinancialSeries;
}(Series));
/**
 * @hidden
 */
var FinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
/**
 * @hidden
 */
var DataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
/**
 * @hidden
 */
var FinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
/**
 * @hidden
 */
var FinancialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bw = null;
        _this.bu = null;
        _this.by = 0;
        _this.by = -1;
        _this.bw = a;
        _this.bu = _this.bv();
        return _this;
    }
    FinancialSeriesView.prototype.bx = function (a) {
        if (this.by != a.t) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.bz = function (a) {
        this.by = a.t;
    };
    FinancialSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 6;
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bw.l8.b5) {
            a += "<span>${itemLabel}</span><br/>";
        }
        else if (this.bw.l8.e7 != null) {
            a += "<span>${item." + this.bw.l8.e7 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        var c = new SRProvider(this.t);
        var d = c.al("financialSeries_Open");
        var e = c.al("financialSeries_High");
        var f = c.al("financialSeries_Low");
        var g = c.al("financialSeries_Close");
        d = stringIsNullOrEmpty(d) ? "Open" : d;
        e = stringIsNullOrEmpty(e) ? "High" : e;
        f = stringIsNullOrEmpty(f) ? "Low" : f;
        g = stringIsNullOrEmpty(g) ? "Close" : g;
        a += ">" + this.bw.fx + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bw.oo + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bw.of + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bw.ok + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bw.oc + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bw.os)) {
            var h = c.al("financialSeries_Volume");
            h = stringIsNullOrEmpty(h) ? "Volume" : h;
            a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bw.os + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 2;
        this.e.ex = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available display types for financial indicators.
 */
var IndicatorDisplayType = /*@__PURE__*/ (function (IndicatorDisplayType) {
    /**
     * Display indicator as a line chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Line"] = 0] = "Line";
    /**
     * Display indicator as an area chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Area"] = 1] = "Area";
    /**
     * Display indicator as a column chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Column"] = 2] = "Column";
    return IndicatorDisplayType;
})({});
/**
 * @hidden
 */
var IndicatorDisplayType_$type = /*@__PURE__*/ markEnum('IndicatorDisplayType', 'Line,0|Area,1|Column,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DelegateClipper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DelegateClipper, _super);
    function DelegateClipper(a, b, c, d) {
        var e_1, _b, e_2, _c;
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.d = null;
        var e = new List$1(Point_$type, 0);
        try {
            for (var _d = __values(fromEnum(DelegateClipper.a(0, c))), _e = _d.next(); !_e.done; _e = _d.next()) {
                var f = _e.value;
                e.add({ $type: Point_$type, x: a(f), y: b(f) });
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_b = _d.return))
                    _b.call(_d);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        _this.b = new List$1(Point_$type, 0);
        _this.c = function (g) { return _this.b.count > g ? _this.b._inner[g].x : NaN; };
        _this.d = function (g) { return _this.b.count > g ? _this.b._inner[g].y : NaN; };
        d.i = _this.b;
        try {
            for (var _f = __values(fromEnum(e)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var g = _g.value;
                d.j(g);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_c = _f.return))
                    _c.call(_f);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        d.i = null;
        return _this;
    }
    Object.defineProperty(DelegateClipper.prototype, "e", {
        get: function () {
            return this.b.count;
        },
        enumerable: true,
        configurable: true
    });
    DelegateClipper._a = function (a, b) {
        var c;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    c = a;
                    _b.label = 1;
                case 1:
                    if (!(c < a + b))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, c];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3:
                    c++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    DelegateClipper.a = function (a, b) {
        return toEnum(function () { return DelegateClipper._a(a, b); });
    };
    DelegateClipper.$t = markType(DelegateClipper, 'DelegateClipper');
    return DelegateClipper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndicatorRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndicatorRenderer, _super);
    function IndicatorRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IndicatorRenderer.h = function (a, b, c, d) {
        var e_1, _c;
        var e = new PathFigure();
        var f = IndicatorRenderer.b(a, b, c, d);
        var _loop_1 = function (g) {
            e._segments.add(((function () {
                var $ret = new LineSegment(1);
                $ret.c = g;
                return $ret;
            })()));
        };
        try {
            for (var _d = __values(fromEnum(f)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var g = _e.value;
                _loop_1(g);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_c = _d.return))
                    _c.call(_d);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        e._startPoint = e._segments._inner[0].c;
        return e;
    };
    IndicatorRenderer.g = function (a, b, c, d, e, f, g, h, i, j, k) {
        var l = g.ak.c;
        var m = h.ak.c;
        if (a > 1) {
            var n = new DelegateClipper(b, c, a, k);
            b = n.c;
            c = n.d;
            a = n.e;
        }
        if (i == 1) {
            var o = new List$1(Number_$type, 0);
            var p = l;
            var q = 0;
            o.add(0);
            for (var r = 0, s = 1; s < a; r = s++) {
                var t = q;
                var u = c(s) - c(r);
                if (d && !isNaN_(u)) {
                    t = Math.sign(u);
                }
                if (t != 0 && t != q) {
                    p.add(IndicatorRenderer.h(o, b, c, j));
                    q = t;
                    p = q == 1 ? m : l;
                    o.clear();
                    o.add(r);
                }
                o.add(s);
            }
            p.add(IndicatorRenderer.h(o, b, c, j));
        }
        else {
            var v = new List$1(Number_$type, 0);
            var w = l;
            var x = 0;
            v.add(0);
            for (var y = 0, z = 1; z < a; y = z++) {
                var aa = x;
                var ab = c(z) - c(y);
                if (d && !isNaN_(ab)) {
                    aa = Math.sign(ab);
                }
                if (aa != 0 && aa != x) {
                    if (v.count > 0) {
                        w.add(IndicatorRenderer.h(v, b, c, j));
                    }
                    x = aa;
                    w = x == 1 ? m : l;
                    v.clear();
                    v.add(y);
                }
                v.add(z);
            }
            if (v.count > 0) {
                w.add(IndicatorRenderer.h(v, b, c, j));
            }
        }
    };
    IndicatorRenderer.e = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n) {
        var o = new List$1(List$1.$.specialize(Point_$type), 0);
        var p = new List$1(List$1.$.specialize(Point_$type), 0);
        var q = new List$1(List$1.$.specialize(Point_$type), 0);
        var r = new List$1(List$1.$.specialize(Point_$type), 0);
        if (a <= 1) {
            n = null;
        }
        k = Math.max(f.top, Math.min(f.bottom, k));
        if (l == 1) {
            var s = new List$1(Number_$type, 0);
            var t = o;
            var u = p;
            var v = 0;
            s.add(0);
            for (var w = 0, x = 1; x < a; w = x++) {
                var y = v;
                var z = c(x) - c(w);
                if (d && !isNaN_(z)) {
                    y = Math.sign(z);
                }
                if (y != 0 && y != v) {
                    if (s.count > 0) {
                        var aa = new List$1(Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
                        var ab = new List$1(Point_$type, 1, aa);
                        ab.add({ $type: Point_$type, x: aa._inner[aa.count - 1].x, y: k });
                        ab.add({ $type: Point_$type, x: aa._inner[0].x, y: k });
                        t.add(aa);
                        u.add(ab);
                    }
                    v = y;
                    t = v == 1 ? q : o;
                    u = v == 1 ? r : p;
                    s.clear();
                    s.add(w);
                }
                s.add(x);
            }
            var ac = new List$1(Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
            var ad = new List$1(Point_$type, 1, ac);
            ad.add({ $type: Point_$type, x: ac._inner[ac.count - 1].x, y: k });
            ad.add({ $type: Point_$type, x: ac._inner[0].x, y: k });
            t.add(ac);
            u.add(ad);
        }
        else {
            var ae = new List$1(Number_$type, 0);
            var af = o;
            var ag = p;
            var ah = 0;
            ae.add(0);
            for (var ai = 0, aj = 1; aj < a; ai = aj++) {
                var ak = ah;
                var al = c(aj) - c(ai);
                if (d && !isNaN_(al)) {
                    ak = Math.sign(al);
                }
                if (ak != 0 && ak != ah) {
                    if (ae.count > 0) {
                        var am = new List$1(Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
                        var an = new List$1(Point_$type, 1, am);
                        an.add({ $type: Point_$type, x: am._inner[am.count - 1].x, y: k });
                        an.add({ $type: Point_$type, x: am._inner[0].x, y: k });
                        af.add(am);
                        ag.add(an);
                    }
                    ah = ak;
                    af = ah == 1 ? q : o;
                    ag = ah == 1 ? r : p;
                    ae.clear();
                    ae.add(ai);
                }
                ae.add(aj);
            }
            var ao = new List$1(Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
            var ap = new List$1(Point_$type, 1, ao);
            ap.add({ $type: Point_$type, x: ao._inner[ao.count - 1].x, y: k });
            ap.add({ $type: Point_$type, x: ao._inner[0].x, y: k });
            af.add(ao);
            ag.add(ap);
        }
        if (n != null) {
            o = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), o, function (aq) { return IndicatorRenderer.c(n, aq, false); }));
            p = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), p, function (aq) { return IndicatorRenderer.c(n, aq, true); }));
            q = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), q, function (aq) { return IndicatorRenderer.c(n, aq, false); }));
            r = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), r, function (aq) { return IndicatorRenderer.c(n, aq, true); }));
        }
        var aq = g.ak.c;
        var ar = h.ak.c;
        var as = i.ak.c;
        var at = j.ak.c;
        IndicatorRenderer.d(aq, o);
        IndicatorRenderer.d(ar, p);
        IndicatorRenderer.d(as, q);
        IndicatorRenderer.d(at, r);
    };
    IndicatorRenderer.f = function (a, b, c, d, e, f, g, h, i) {
        var j = typeCast(GeometryGroup.$, h.ak);
        var k = typeCast(GeometryGroup.$, i.ak);
        var l = c;
        var m = b;
        var n = function (o) { return Math.max(e.left, Math.min(e.right, o)); };
        var o = function (p) { return Math.max(e.top, Math.min(e.bottom, p)); };
        b = function (p) { return n(m(p)); };
        c = function (p) { return o(l(p)); };
        f = o(f);
        for (var p = 0; p < a; ++p) {
            var q = g.item(p);
            q.d = { $type: Point_$type, x: b(p), y: f };
            q.c = { $type: Point_$type, x: b(p), y: c(p) };
            var r = false;
            if (p > 0) {
                if (c(p) <= c(p - 1)) {
                    r = true;
                }
            }
            else {
                if (a > 1) {
                    if (c(p + 1) <= c(p)) {
                        r = true;
                    }
                }
            }
            if (r) {
                j.d.add(q);
            }
            else {
                k.d.add(q);
            }
        }
        g.count = a;
    };
    IndicatorRenderer._b = function (a, b, c, d) {
        var e, f, g;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    e = Flattener.a(new List$1(Number_$type, 0), a, b, c, 0, a.count - 1, d);
                    f = 0;
                    _c.label = 1;
                case 1:
                    if (!(f < e.count))
                        return [3 /*break*/, 4];
                    g = e.item(f);
                    return [4 /*yield*/, { $type: Point_$type, x: b(g), y: c(g) }];
                case 2:
                    _c.sent();
                    _c.label = 3;
                case 3:
                    f++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    IndicatorRenderer.b = function (a, b, c, d) {
        return toEnum(function () { return IndicatorRenderer._b(a, b, c, d); });
    };
    IndicatorRenderer.d = function (a, b) {
        var e_2, _c;
        var _loop_2 = function (c) {
            var e_3, _c;
            if (c.count == 0) {
                return "continue";
            }
            var d = ((function () {
                var $ret = new PathFigure();
                $ret.startPoint = c._inner[0];
                return $ret;
            })());
            var _loop_3 = function (e) {
                d._segments.add(((function () {
                    var $ret = new LineSegment(1);
                    $ret.c = e;
                    return $ret;
                })()));
            };
            try {
                for (var _d = (e_3 = void 0, __values(fromEnum(c))), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var e = _e.value;
                    _loop_3(e);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_c = _d.return))
                        _c.call(_d);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            a.add(d);
        };
        try {
            for (var _d = __values(fromEnum(b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                _loop_2(c);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_c = _d.return))
                    _c.call(_d);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    IndicatorRenderer.c = function (a, b, c) {
        var d = a.f;
        a.f = c;
        var e = new List$1(Point_$type, 0);
        a.i = e;
        a.k(b, false);
        a.i = null;
        a.f = d;
        return e;
    };
    IndicatorRenderer._a = function ($tSource, $tResult, a, b) {
        var _c, _d, c, e_4_1;
        var e_4, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    _f.trys.push([0, 5, 6, 7]);
                    _c = __values(fromEnum(a)), _d = _c.next();
                    _f.label = 1;
                case 1:
                    if (!!_d.done)
                        return [3 /*break*/, 4];
                    c = _d.value;
                    return [4 /*yield*/, b(c)];
                case 2:
                    _f.sent();
                    _f.label = 3;
                case 3:
                    _d = _c.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_4_1 = _f.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_d && !_d.done && (_e = _c.return))
                            _e.call(_c);
                    }
                    finally {
                        if (e_4)
                            throw e_4.error;
                    }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    IndicatorRenderer.a = function ($tSource, $tResult, a, b) {
        return toEnum(function () { return IndicatorRenderer._a($tSource, $tResult, a, b); });
    };
    IndicatorRenderer.$t = markType(IndicatorRenderer, 'IndicatorRenderer');
    return IndicatorRenderer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicator, _super);
    function FinancialIndicator() {
        var _this = _super.call(this) || this;
        _this._indicatorColumn = null;
        _this.pi = null;
        _this.mb = new CategoryFrame(3);
        _this.md = new CategoryFrame(3);
        _this.ma = new CategoryFrame(3);
        _this.indicatorColumn = new List$1(Number_$type, 0);
        _this.pi = new AxisRange(-100, 100);
        return _this;
    }
    FinancialIndicator.prototype.bf = function () {
        return new FinancialIndicatorView(this);
    };
    FinancialIndicator.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pj = a;
    };
    FinancialIndicator.prototype.pv = function (a) {
        if (this.mt != null && !this.mt.cl()) {
            this.jd(true);
        }
    };
    FinancialIndicator.prototype.pn = function (a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        var d = this.mt;
        var e = 0;
        if (d != null) {
            e = d.eb(d.ke);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    FinancialIndicator.prototype.lu = function (a) {
        if (this.l8 == null || this.mt == null) {
            return Rect.empty;
        }
        var b = this.lg(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = new ScalerParams(0, c, d, this.mt.b8, e);
        f.b = this.eh();
        var g = this.aj(this.l8, this.ma.f, this.n5(this.bi), this.n7(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.mt.dw(this.mt.ke, f);
        var m = 1;
        if (j < k) {
            var n = h[0] - 0.5 * m;
            var o = h[1];
            var p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            var q = i[0] - 0.5 * m;
            var r = i[1];
            var s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    };
    FinancialIndicator.prototype.dh = function (a, b) {
        var c = this.ll(this.lo(a), true, false);
        if (this.pk == 1) {
            if (this.pn(a, c, b)) {
                return true;
            }
        }
        if (this.pk == 1 || this.pk == 0) {
            if (this.dg(a, b)) {
                return true;
            }
        }
        if (this.pk == 2) {
            if (this.dk(a, b)) {
                return true;
            }
        }
        return false;
    };
    FinancialIndicator.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            this.l8.i$i();
        }
        if (this.pj.b4) {
            this.pj.b2.g$e(a, b, c, d);
        }
        if (d != null && this.nk.containsKey(d)) {
            var e = this.nk.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            a = 4;
            b = 0;
            c = this.bz.count;
        }
        switch (a) {
            case 3:
                if (this.pm(b, c, d)) {
                    this.px(b, c, d);
                    this.pv(true);
                }
                break;
            case 2:
                if (this.pm(b, this.bz.count - b, d)) {
                    this.px(b, this.bz.count - b, d);
                    this.pv(true);
                }
                break;
            case 1:
                if (this.pm(b, this.bz.count - b, d)) {
                    var f = new Array(c);
                    for (var g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.px(b, this.bz.count - b, d);
                    this.pv(true);
                }
                break;
            case 0:
                if (this.pm(b, this.bz.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.px(b, this.bz.count - b, d);
                    this.pv(true);
                }
                break;
            case 4:
                if (this.pm(b, this.bz.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var h = new Array(c);
                    for (var i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.px(b, this.bz.count - b, d);
                    this.pv(true);
                }
                break;
        }
    };
    Object.defineProperty(FinancialIndicator.prototype, "p8", {
        get: function () {
            return this.c(FinancialIndicator.py);
        },
        set: function (a) {
            this.h(FinancialIndicator.py, a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.ps = function () {
        return -1;
    };
    Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.pj.ca();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pj.b2 = CategoryTrendLineManagerFactory.a(this.pj.b2, this.l8, this.jx, this, this.b2);
                }
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.pj.b4 && this.pj.b2.g$b(a, b, c, d)) {
            this.jd(false);
            var f = typeCast(FinancialIndicatorView.$, this.bh);
            if (f != null && f.b4) {
                f.b2.g$b(a, b, c, d);
            }
            this.ik();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.bz != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var g = new Array(this.bz.count);
                    for (var h = 0; h < this.bz.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.px(0, this.bz.count, null);
                    if (this.mt != null && !this.mt.cl()) {
                        this.mo.bu.e(this.eu);
                        this.jd(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case FinancialIndicator.$$p[0]:
                this.hv(true, this.bi);
                this.jd(false);
                this.ik();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.bz != null) {
                    if (this.indicatorColumn.count != this.bz.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                        var i = new Array(this.bz.count);
                        for (var j = 0; j < this.bz.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.pm(0, this.bz.count - 1, b)) {
                        this.pw();
                    }
                }
                break;
            case "XAxis":
                if (this.l8 != null && (typeCast(ISortingAxis_$type, this.l8) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.pw();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.pw();
                this.ik();
                break;
            case "TrendLineType":
                this.ik();
                break;
        }
    };
    FinancialIndicator.prototype.en = function (a, b, c) {
        if (this.indicatorColumn == null) {
            return _super.prototype.en.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        f.c = this.bs.m3;
        return this.ep(this.indicatorColumn, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    FinancialIndicator.prototype.fe = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.fe.call(this, a, b);
        }
        return this.ff(a, b, this.l8, runOn(this, this.ny), this.indicatorColumn);
    };
    FinancialIndicator.prototype.fc = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.fc.call(this, a, b);
        }
        return this.fd(a, b, this.l8, runOn(this, this.ny), this.indicatorColumn);
    };
    FinancialIndicator.prototype.get_dv = function () {
        return true;
    };
    FinancialIndicator.prototype.pm = function (a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.po(a, b).contains(c)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.px = function (a, b, c) {
        this.pl(a, b);
    };
    FinancialIndicator.prototype.an = function (a) {
        if (this.bz == null) {
            return null;
        }
        if (a != null && a == this.mt) {
            return this.pi;
        }
        return null;
    };
    FinancialIndicator.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bi.bs;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ls(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.l8 != null) {
                var g = new ScalerParams(0, e, e, this.l8.b8, f);
                var h = this.l8.dw(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.mt != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                var i = new ScalerParams(0, e, e, this.mt.b8, f);
                i.b = this.eh();
                var j = this.mt.dw(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    FinancialIndicator.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    };
    FinancialIndicator.prototype.oz = function (a, b) {
        var _this = this;
        _super.prototype.oz.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l8;
        var g = this.mt;
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = new ScalerParams(0, c, d, g.b8, e);
        i.b = this.eh();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.l8);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.nz(c, d, e);
        var l = this.ps();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        var m = typeCast(FinancialIndicatorView.$, b);
        if (m.b4) {
            m.b2.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, function (n) { return _this.l8.dw(n, h); }, function (n) { return _this.mt.dw(n, i); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.bu.b;
                $ret.d = b.bu.c;
                $ret.e = b.bu.d;
                $ret.a = j;
                $ret.b = _this.eu;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        var n = this.l8.dz(2, h) - this.l8.dz(1, h);
        for (var o = b.bu.c; o <= b.bu.d; ++o) {
            var p = void 0;
            if (k == null) {
                p = b.bu.getBucket(o);
            }
            else {
                var q = k.i$b._inner[o];
                var r = k.i$d(q);
                var s = this.indicatorColumn._inner[o];
                var t = s;
                var u = r;
                while (o < b.bu.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    var v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                var w = NaN;
                if (!isNaN_(r)) {
                    w = this.l8.dw(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dw(p[0], h) + j;
                }
                p[1] = g.dw(p[1], i);
                if (b.bu.b > 1 || k != null) {
                    p[2] = g.dw(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    };
    FinancialIndicator.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.b5(a);
        if (c.b4) {
            c.b2.g$d();
        }
    };
    FinancialIndicator.prototype.mh = function () {
        switch (this.pk) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    };
    FinancialIndicator.prototype.o1 = function (a, b) {
        _super.prototype.o1.call(this, a, b);
        var c = typeCast(FinancialIndicatorView.$, b);
        var d = function (e) { return a.f._inner[e][0]; };
        var e = function (f) { return a.f._inner[f][1]; };
        if (c.b4) {
            c.b2.g$d();
            c.b2.g$g(a.p);
        }
        var f = b.br;
        var g = this.getEffectiveViewport1(b);
        var h = 0;
        var i = this.k3;
        var j = this.pe;
        if (b.bx(a)) {
            c.b5(false);
            if (a.f.count > 0) {
                switch (this.pk) {
                    case 0:
                        var k = CategorySeries.m1(a.f, a.f.count - 1, f, b.bs, false);
                        c.b9(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.mt != null) {
                            h = this.n3(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        var l = CategorySeries.m1(a.f, a.f.count - 1, f, b.bs, false);
                        c.b7(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.n3(b);
                        c.b8(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.bz(a);
        }
        var m = a.f;
        var n = this.bz.count;
        this.mg.x(this, this.ng(), this.l8, runOn(this, this.l0), this.n5(b), this.n7(b));
        var o = false;
        var p = this.mg.c;
        if (p != null) {
            o = true;
        }
        this.mg.al = i;
        this.mg.ah = i;
        if (o) {
            var q = new ScalerParams(0, b.bs, b.br, this.l8.b8, g);
            this.mg.f = false;
            this.oy(m, -1, n, this.l8, q, b.n);
        }
        this.mg.ae(c.cr, true, false, true, false);
        this.mg.ae(c.ct, true, false, true, false);
        this.mg.ae(c.cs, false, true, false, false);
        c.cs._opacity = 0.8 * this.mg.i * this.d6;
        this.mg.ae(c.cq, true, false, false, false);
        this.mg.al = j;
        this.mg.ah = j;
        if (o) {
            var r = new ScalerParams(0, b.bs, b.br, this.l8.b8, g);
            this.mg.f = true;
            this.oy(m, -1, n, this.l8, r, b.n);
        }
        this.mg.ae(c.cn, true, false, true, false);
        this.mg.ae(c.cp, true, false, true, false);
        this.mg.ae(c.co, false, true, false, false);
        c.co._opacity = 0.8 * this.mg.i * this.d6;
        this.mg.ae(c.cm, true, false, false, false);
        c.cb();
    };
    FinancialIndicator.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        if (this.pj.b4) {
            this.pj.cc();
        }
    };
    FinancialIndicator.prototype.pw = function () {
        if (this.pj.b4) {
            this.pj.b2.g$i();
        }
        this.pl(0, this.indicatorColumn.count);
        if (this.mt != null && !this.mt.cl()) {
            this.jd(false);
        }
    };
    FinancialIndicator.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportTrendlineData(this, a, this.pj.b2.g$j);
    };
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.py = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:pk:pz', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:pq:p0', [1, 0], 'TrendLineType::p6', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::p5', [1, 1.5], 'TrendLinePeriod::p4', [1, 7], 'TrendLineBrush::p1', [Brush.$, null], 'TrendLineZIndex:pr:p7', [1, 1001], 'TrendLineDashArray:p9:p2', [DoubleCollection.$], 'TrendLineDashCap:qa:p3', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
}(FinancialSeries));
/**
 * @hidden
 */
var FinancialIndicatorBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorBucketCalculator, _super);
    function FinancialIndicatorBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.f.b0.indicatorColumn.count - 1);
        var d = NaN;
        var e = NaN;
        for (var f = b; f <= c; ++f) {
            var g = this.f.b0.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    };
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
}(FinancialBucketCalculator));
/**
 * @hidden
 */
var FinancialIndicatorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorView, _super);
    function FinancialIndicatorView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b3 = null;
        _this.cr = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cn = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cs = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.co = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.ct = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cp = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cq = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.cm = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.b1 = null;
        _this.cj = new Path();
        _this.cl = new Path();
        _this.ck = new Path();
        _this.ci = new Path();
        _this.cf = new Path();
        _this.ch = new Path();
        _this.cg = new Path();
        _this.ce = new Path();
        _this.b0 = a;
        _this.b3 = ((function () {
            var $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(_this, _this.cd);
            $ret.destroy = runOn(_this, _this.b6);
            return $ret;
        })());
        return _this;
    }
    FinancialIndicatorView.prototype.bv = function () {
        return new FinancialIndicatorBucketCalculator(this);
    };
    FinancialIndicatorView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.bw.pe = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.bw.ey = 2;
        }
    };
    FinancialIndicatorView.prototype.cd = function () {
        return new LineGeometry();
    };
    FinancialIndicatorView.prototype.b6 = function (a) {
    };
    Object.defineProperty(FinancialIndicatorView.prototype, "b2", {
        get: function () {
            if (this.b1 == null) {
                this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jx, this.e, this.e.b2);
            }
            return this.b1;
        },
        set: function (a) {
            this.b1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialIndicatorView.prototype, "b4", {
        get: function () {
            return this.b1 != null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicatorView.prototype.b5 = function (a) {
        Extensions.e(this.cr.ak);
        Extensions.e(this.cs.ak);
        Extensions.e(this.ct.ak);
        Extensions.e(this.cn.ak);
        Extensions.e(this.co.ak);
        Extensions.e(this.cp.ak);
        Extensions.d(this.cq.ak);
        Extensions.d(this.cm.ak);
        if (a) {
            this.b3.count = 0;
        }
        this.an();
    };
    FinancialIndicatorView.prototype.cb = function () {
    };
    FinancialIndicatorView.prototype.b9 = function (a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bs, this.br, this.cr, this.cn, this.bu.b, this.e.eu, e);
        this.an();
    };
    FinancialIndicatorView.prototype.b7 = function (a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bs, this.br, this.cr, this.cs, this.cn, this.co, e, this.bu.b, this.e.eu, f);
        this.an();
    };
    FinancialIndicatorView.prototype.b8 = function (a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.br, e, this.b3, this.cq, this.cm);
        this.an();
    };
    FinancialIndicatorView.prototype.cc = function () {
        this.b0.p8 = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.p8 = this.b0.trendLineBrush;
        }
        else {
            this.b0.p8 = this.b0.k3;
        }
    };
    FinancialIndicatorView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.cj.ak = this.cr.ak;
        this.cl.ak = this.ct.ak;
        this.ck.ak = this.cs.ak;
        this.ci.ak = this.cq.ak;
        this.cf.ak = this.cn.ak;
        this.ch.ak = this.cp.ak;
        this.cg.ak = this.co.ak;
        this.ce.ak = this.cm.ak;
        this.cj._stroke = a;
        this.cl._stroke = a;
        this.cj.ac = this.e.ey + 3;
        this.cl.ac = this.e.ey + 3;
        this.ck._fill = a;
        this.ck._opacity = 1;
        this.ci._stroke = a;
        this.ci.ac = this.e.ey + 3;
        this.cf._stroke = a;
        this.ch._stroke = a;
        this.cf.ac = this.e.ey + 3;
        this.ch.ac = this.e.ey + 3;
        this.cg._fill = a;
        this.cg._opacity = 1;
        this.ce._stroke = a;
        this.ce.ac = this.e.ey + 3;
    };
    FinancialIndicatorView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                if (this.b0.pk == 2) {
                    a.s(this.ci);
                    a.s(this.ce);
                }
                else {
                    a.s(this.ck);
                    a.s(this.cj);
                    a.s(this.cl);
                    a.s(this.cg);
                    a.s(this.cf);
                    a.s(this.ch);
                }
            }
            else {
                if (this.b0.pk == 2) {
                    a.s(this.cq);
                    a.s(this.cm);
                }
                else {
                    a.s(this.cs);
                    a.s(this.cr);
                    a.s(this.ct);
                    a.s(this.co);
                    a.s(this.cn);
                    a.s(this.cp);
                }
            }
        }
    };
    FinancialIndicatorView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                var c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.p8;
                c.ad = this.b0.qa;
                c.ai = this.b0.p9;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    FinancialIndicatorView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.cq, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cm, "negativeColumnsShape", ["Negative"]);
        this.e.a2.exportPathData(a, this.cr, "positive0", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.ct, "positive1", ["Positive"]);
        this.e.a2.exportPathData(a, this.cs, "positive01", ["PositiveFill"]);
        this.e.a2.exportPathData(a, this.cn, "negative0", ["Negative", "Main"]);
        this.e.a2.exportPathData(a, this.cp, "negative1", ["Negative"]);
        this.e.a2.exportPathData(a, this.co, "negative01", ["NegativeFill"]);
    };
    FinancialIndicatorView.prototype.ca = function () {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jx, this.e, this.e.b2);
        }
    };
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
}(FinancialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.qq();
        return _this;
    }
    StrategyBasedIndicator.prototype.qq = function () {
        this.qb = this.qc;
        this.ab = this.qp;
    };
    StrategyBasedIndicator.prototype.qi = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.qr = function (a) {
    };
    StrategyBasedIndicator.prototype.qk = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.qh = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.qv = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.qf.add(c);
        return d;
    };
    StrategyBasedIndicator.qu = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "Period");
    };
    StrategyBasedIndicator.qs = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.qw = function (a, b) {
        return StrategyBasedIndicator.qv(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.po = function (a, b) {
        var c = this.mk(a, b);
        var d = this.ml(c);
        return this.qb.b(c, d);
    };
    StrategyBasedIndicator.prototype.pl = function (a, b) {
        var c = this.mk(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.nh(this.po(a, b))) {
            return false;
        }
        var d = this.ml(c);
        if (this.pi != null) {
            c.minimumValue = this.pi.c;
            c.maximumValue = this.pi.b;
        }
        var e = this.qb.a(c, d);
        for (var f = 0; f < this.pq && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.mt != null && this.qe(c)) {
            this.mt.cl();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.qe = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.pi;
            this.pi = new AxisRange(a.minimumValue, a.maximumValue);
            return this.qd(b, this.pi);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = this.pi;
        this.pi = new AxisRange(c, d);
        return this.qd(f, this.pi);
    };
    StrategyBasedIndicator.prototype.qd = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.qj = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.mk = function (a, b) {
        var c = _super.prototype.mk.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.qj(this.qi());
        c.shortPeriod = this.qj(this.qk());
        c.longPeriod = this.qj(this.qh());
        c.multiplier = this.qg();
        return c;
    };
    StrategyBasedIndicator.prototype.qg = function () {
        return 1;
    };
    StrategyBasedIndicator.qt = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.qf.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (StrategyBasedIndicator.qf.contains(b)) {
            if (this.mt != null && !this.mt.cl()) {
                this.mo.bu.e(this.eu);
                this.pl(0, this.indicatorColumn.count);
                if (this.pj.b4) {
                    this.pj.b2.g$i();
                }
                this.jd(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.qf = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndicatorProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndicatorProxy, _super);
    function IndicatorProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IndicatorProxy.prototype.matchesType = function (a) {
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator")) {
            return true;
        }
        return false;
    };
    IndicatorProxy.prototype.setCloseMemberPath = function (a, b) {
        a.oc = b;
    };
    IndicatorProxy.prototype.setDisplayType = function (a, b) {
        a.pk = b;
    };
    IndicatorProxy.prototype.setHighMemberPath = function (a, b) {
        a.of = b;
    };
    IndicatorProxy.prototype.setLongPeriod = function (a, b) {
        if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
            a.longPeriod = b;
        }
    };
    IndicatorProxy.prototype.setLowMemberPath = function (a, b) {
        a.ok = b;
    };
    IndicatorProxy.prototype.setNegativeBrush = function (a, b) {
        a.pe = b;
    };
    IndicatorProxy.prototype.setOpenMemberPath = function (a, b) {
        a.oo = b;
    };
    IndicatorProxy.prototype.setPeriodOverride = function (a, b) {
        if (typeCast(StrategyBasedIndicator.$, a) !== null) {
            a.qr(b);
        }
    };
    IndicatorProxy.prototype.setShortPeriod = function (a, b) {
        if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
            a.shortPeriod = b;
        }
    };
    IndicatorProxy.prototype.setSignalPeriod = function (a, b) {
        if (getInstanceType(a).typeName == "MovingAverageConvergenceDivergenceIndicator") {
            var s_ = a;
            var p_ = b;
            s_['signalPeriod'] = p_;
        }
    };
    IndicatorProxy.prototype.setSmoothingPeriod = function (a, b) {
        if (getInstanceType(a).typeName == "FullStochasticOscillatorIndicator") {
            var s_ = a;
            var p_ = b;
            s_['smoothingPeriod'] = p_;
        }
    };
    IndicatorProxy.prototype.setVolumeMemberPath = function (a, b) {
        a.os = b;
    };
    IndicatorProxy.prototype.setXAxis = function (a, b) {
        a.l8 = b;
    };
    IndicatorProxy.prototype.setYAxis = function (a, b) {
        a.mt = b;
    };
    IndicatorProxy.prototype.handleCustomIndicatorEvent = function (a, b) {
        if (getInstanceType(a).typeName == "CustomIndicator") {
            var s_ = a;
            var p_ = b;
            s_['indicator'] = p_;
        }
    };
    IndicatorProxy.$t = markType(IndicatorProxy, 'IndicatorProxy', Base.$, [IIndicatorProxy_$type]);
    return IndicatorProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrIndicatorProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrIndicatorProxyModule() {
    }
    IgrIndicatorProxyModule.register = function () {
        TypeRegistrar.register('IndicatorProxy', IndicatorProxy.$type);
    };
    return IgrIndicatorProxyModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the data contract between a financial series and the
 * decoupled calculation responsibilities which implement its mathmatical logic.
 * The FinancialCalculationDataSource contract represents the subset
 * of data which needs to be provided in order to test or run a calculation,
 * and its intentionally a subset of the information available to the series,
 * in order to make calculation strategies more easily testable and usable in isolation to
 * the financial series container.
*/
var IgrFinancialCalculationDataSource = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialCalculationDataSource() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrFinancialCalculationDataSource.prototype.createImplementation = function () {
        return new FinancialCalculationDataSource();
    };
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialCalculationDataSource.prototype.onImplementationCreated = function () {
    };
    IgrFinancialCalculationDataSource.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this.i.series.getOpenColumnAsArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this.i.series.getHighColumnAsArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this.i.series.getLowColumnAsArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this.i.series.getCloseColumnAsArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this.i.series.getVolumeColumnAsArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this.i.series.indicatorColumn.asArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "typicalColumn", {
        /**
     * An enumerable list of typical prices provided by the series to use
     * in calculations.
    */
        get: function () {
            if (this.i.typicalColumn == null) {
                return null;
            }
            return this.i.typicalColumn.externalObject;
        },
        set: function (v) {
            v == null ? this.i.typicalColumn = null : this.i.typicalColumn = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "trueRange", {
        /**
         * And enumerable list of true range values provided by the series to use
         * in calculations.
        */
        get: function () {
            if (this.i.trueRange == null) {
                return null;
            }
            return this.i.trueRange.externalObject;
        },
        set: function (v) {
            v == null ? this.i.trueRange = null : this.i.trueRange = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "trueLow", {
        /**
         * An enumerable list of true low values provided by the series to use
         * in calculations.
        */
        get: function () {
            if (this.i.trueLow == null) {
                return null;
            }
            return this.i.trueLow.externalObject;
        },
        set: function (v) {
            v == null ? this.i.trueLow = null : this.i.trueLow = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "period", {
        /**
         * The period to use when calculating, if applicable.
        */
        get: function () {
            return this.i.period;
        },
        set: function (v) {
            this.i.period = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "shortPeriod", {
        /**
         * The short period to use when calculating, if applicable.
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "longPeriod", {
        /**
         * The long period to use when calculating, if applicable.
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "count", {
        /**
         * The count of the values in the series.
        */
        get: function () {
            return this.i.count;
        },
        set: function (v) {
            this.i.count = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "calculateFrom", {
        /**
         * The starting index from which to calculate
        */
        get: function () {
            return this.i.calculateFrom;
        },
        set: function (v) {
            this.i.calculateFrom = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "calculateCount", {
        /**
         * The number of items from the starting index from which to calculate
        */
        get: function () {
            return this.i.calculateCount;
        },
        set: function (v) {
            this.i.calculateCount = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "multiplier", {
        /**
         * If the calculation supports some sort of scaling factor,
         * this value will be used.
        */
        get: function () {
            return this.i.multiplier;
        },
        set: function (v) {
            this.i.multiplier = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "minimumValue", {
        /**
         * If the calculation determines the range of indicator values,
         * it will set the minimum and maximux properties.
         * This will contain the previous minimum value when the indicator
         * calculation is called again, in case this makes the update of the
         * value speedier.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "maximumValue", {
        /**
         * If the calculation determines the range of indicator values,
         * it will set the minimum and maximux properties.
         * This will contain the previous minimum value when the indicator
         * calculation is called again, in case this makes the update of the
         * value speedier.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationDataSource.prototype, "specifiesRange", {
        /**
         * The calculation strategy should set this to true if it
         * specifes the minimum and maximum value properties.
        */
        get: function () {
            return this.i.specifiesRange;
        },
        set: function (v) {
            this.i.specifiesRange = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialCalculationDataSource;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a contract between the financial series and the calculation strategies
 * detailing the supporting calculation strategies that the financial series will
 * provide in order for the indicator calculations to be performed.
*/
var IgrFinancialCalculationSupportingCalculations = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialCalculationSupportingCalculations() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrFinancialCalculationSupportingCalculations.prototype.createImplementation = function () {
        return new FinancialCalculationSupportingCalculations();
    };
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialCalculationSupportingCalculations.prototype.onImplementationCreated = function () {
    };
    IgrFinancialCalculationSupportingCalculations.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "eMA", {
        /**
         * The strategy provided to calculate an exponential moving average for a collection.
        */
        get: function () {
            if (this.i.a == null) {
                return null;
            }
            return this.i.a.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "sMA", {
        /**
         * The strategy provided to calculate a simple moving average for a collection.
        */
        get: function () {
            if (this.i.c == null) {
                return null;
            }
            return this.i.c.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "sTDEV", {
        /**
         * The strategy provided to calculate a standard deviation for a collection.
        */
        get: function () {
            if (this.i.d == null) {
                return null;
            }
            return this.i.d.externalObject;
        },
        set: function (v) {
            v == null ? this.i.d = null : this.i.d = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "movingSum", {
        /**
         * The strategy provided to calculate a moving sum for a collection.
        */
        get: function () {
            if (this.i.b == null) {
                return null;
            }
            return this.i.b.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "shortVolumeOscillatorAverage", {
        /**
         * The strategy provided to calculate the short period moving average for volume oscillator indicators.
        */
        get: function () {
            if (this.i.h == null) {
                return null;
            }
            return this.i.h.externalObject;
        },
        set: function (v) {
            v == null ? this.i.h = null : this.i.h = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "longVolumeOscillatorAverage", {
        /**
         * The strategy provided to calculate the long period moving average for volume oscillator indicators.
        */
        get: function () {
            if (this.i.f == null) {
                return null;
            }
            return this.i.f.externalObject;
        },
        set: function (v) {
            v == null ? this.i.f = null : this.i.f = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "shortPriceOscillatorAverage", {
        /**
         * The strategy provided to calculate the short period moving average for price oscillator indicators.
        */
        get: function () {
            if (this.i.g == null) {
                return null;
            }
            return this.i.g.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "longPriceOscillatorAverage", {
        /**
         * The strategy provided to calculate the long period moving average for price oscillator indicators.
        */
        get: function () {
            if (this.i.e == null) {
                return null;
            }
            return this.i.e.externalObject;
        },
        set: function (v) {
            v == null ? this.i.e = null : this.i.e = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialCalculationSupportingCalculations.prototype, "makeSafe", {
        /**
         * The strategy provided to make doubles safe for plotting, by default will just make zero if the value
         * is invalid.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialCalculationSupportingCalculations;
}());

/**
 * Parameterizes a financial calculation event.
*/
var IgrFinancialEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialEventArgs() {
    }
    Object.defineProperty(IgrFinancialEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrFinancialEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrFinancialEventArgs.prototype, "basedOn", {
        get: function () {
            var ret = null;
            if (this.i.basedOn) {
                ret = [];
                for (var i = 0; i < this.i.basedOn.count; i++) {
                    ret.push(this.i.basedOn[i]);
                }
            }
            return ret;
        },
        set: function (v) {
            if (!v) {
                this.i.basedOn = null;
                return;
            }
            var list = new List$1(String_$type, 0);
            for (var i = 0; i < v.length; i++) {
                list.add(v[i]);
            }
            this.i.basedOn = list;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialEventArgs.prototype, "position", {
        /**
     * The beginning position that should be calculated from.
    */
        get: function () {
            return this.i.position;
        },
        set: function (v) {
            this.i.position = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialEventArgs.prototype, "count", {
        /**
         * The number of positions that should be calculated from the start.
        */
        get: function () {
            return this.i.count;
        },
        set: function (v) {
            this.i.count = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialEventArgs.prototype, "dataSource", {
        /**
         * The data to use for the calculation.
        */
        get: function () {
            if (this.i.dataSource == null) {
                return null;
            }
            if (!this.i.dataSource.externalObject) {
                var e = new IgrFinancialCalculationDataSource();
                e._implementation = this.i.dataSource;
                this.i.dataSource.externalObject = e;
            }
            return this.i.dataSource.externalObject;
        },
        set: function (v) {
            v == null ? this.i.dataSource = null : this.i.dataSource = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialEventArgs.prototype, "supportingCalculations", {
        /**
         * The supporting calculations to use in the calculation.
        */
        get: function () {
            if (this.i.supportingCalculations == null) {
                return null;
            }
            if (!this.i.supportingCalculations.externalObject) {
                var e = new IgrFinancialCalculationSupportingCalculations();
                e._implementation = this.i.supportingCalculations;
                this.i.supportingCalculations.externalObject = e;
            }
            return this.i.supportingCalculations.externalObject;
        },
        set: function (v) {
            v == null ? this.i.supportingCalculations = null : this.i.supportingCalculations = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialEventArgs;
}());

/**
 * Represents the base class for all financial indicator and overlay series.
*
* The `IgrFinancialSeries` represents the base class for all financial indicator and overlay series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFinancialPriceSeries
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*
*  </IgrDataChart>
* ```
*
* ```ts
* this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
* this.financialSeries.dataSource = this.financialData;
* this.financialSeries.xAxis = this.timeXAxis;
* this.financialSeries.yAxis = this.numericYAxis;
* this.financialSeries.xAxisName = "timeXAxis";
* this.financialSeries.yAxisName = "numericYAxis";
* this.financialSeries.highMemberPath="High" ;
* this.financialSeries.lowMemberPath="Low" ;
* this.financialSeries.closeMemberPath="Close" ;
* this.financialSeries.openMemberPath="Open";
* this.financialSeries.volumeMemberPath="Volume";
* ```
*/
var IgrFinancialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialSeries, _super);
    function IgrFinancialSeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        _this._assigningCategoryStyle = null;
        _this._assigningCategoryStyle_wrapped = null;
        _this._typical = null;
        _this._typical_wrapped = null;
        _this._typicalBasedOn = null;
        _this._typicalBasedOn_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgrFinancialSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "isFinancial", {
        /**
         * Gets whether the current series is a financial type series.
        */
        get: function () {
            return this.i.cr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "negativeBrush", {
        /**
         * Gets or sets the brush to use for negative portions of the series.
        *
        * The `negativeBrush` property is used to brush the negative portions of the series.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	negativeBrush="Red" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.negativeBrush="red";
        * ```
        */
        get: function () {
            return brushToString(this.i.pe);
        },
        set: function (v) {
            this.i.pe = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current FinancialSeries object.
        *
        * Use `xAxis` property to set effective x-axis for the current FinancialSeries object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        * this.financialSeries.dataSource = this.financialData;
        * this.financialSeries.xAxis = this.timeXAxis;
        * this.financialSeries.yAxis = this.numericYAxis;
        * this.financialSeries.xAxisName = "timeXAxis";
        * this.financialSeries.yAxisName = "numericYAxis";
        * this.financialSeries.highMemberPath="High" ;
        * this.financialSeries.lowMemberPath="Low";
        * this.financialSeries.closeMemberPath="Close";
        * this.financialSeries.openMemberPath="Open";
        * this.financialSeries.volumeMemberPath="Volume";
        * ```
        */
        get: function () {
            if (this.i.l8 == null) {
                return null;
            }
            if (!this.i.l8.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.l8);
                if (e) {
                    e._implementation = this.i.l8;
                }
                this.i.l8.externalObject = e;
            }
            return this.i.l8.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l8 = null : this.i.l8 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current FinancialSeries object.
        *
        * Use `yAxis` property to set the effective y-axis for the current FinancialSeries object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *     this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        *     this.financialSeries.dataSource = this.financialData;
        *     this.financialSeries.xAxis = this.timeXAxis;
        *     this.financialSeries.yAxis = this.numericYAxis;
        *     this.financialSeries.xAxisName = "timeXAxis";
        *     this.financialSeries.yAxisName = "numericYAxis";
        *     this.financialSeries.highMemberPath="High" ;
        *     this.financialSeries.lowMemberPath="Low";
        *     this.financialSeries.closeMemberPath="Close";
        *     this.financialSeries.openMemberPath="Open";
        *     this.financialSeries.volumeMemberPath="Volume";
        * ```
        */
        get: function () {
            if (this.i.mt == null) {
                return null;
            }
            if (!this.i.mt.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.mt);
                if (e) {
                    e._implementation = this.i.mt;
                }
                this.i.mt.externalObject = e;
            }
            return this.i.mt.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.mt = null : this.i.mt = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "openMemberPath", {
        /**
         * Gets or sets the open mapping property for the current series object.
        *
        * The `openMemberPath` property is used for open mapping of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series = new IgrFinancialPriceSeries({name: "series"});
        * this.series.dataSource = this.financialData;
        * this.series.xAxis = this.timeXAxis;
        * this.series.yAxis = this.numericYAxis;
        * this.series.xAxisName = "timeXAxis";
        * this.series.yAxisName = "numericYAxis";
        * this.series.highMemberPath="High"
        * this.series.lowMemberPath="Low"
        * this.series.closeMemberPath="Close"
        * this.series.openMemberPath="Open"
        * this.series.volumeMemberPath="Volume"
        * ```
        */
        get: function () {
            return this.i.oo;
        },
        set: function (v) {
            this.i.oo = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "highMemberPath", {
        /**
         * Gets or sets the high mapping property for the current series object.
        *
        * Use `highMemberPath` propert for high mapping of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *     this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        *     this.financialSeries.dataSource = this.financialData;
        *     this.financialSeries.xAxis = this.timeXAxis;
        *     this.financialSeries.yAxis = this.numericYAxis;
        *     this.financialSeries.xAxisName = "timeXAxis";
        *     this.financialSeries.yAxisName = "numericYAxis";
        *     this.financialSeries.highMemberPath="High" ;
        *     this.financialSeries.lowMemberPath="Low";
        *     this.financialSeries.closeMemberPath="Close";
        *     this.financialSeries.openMemberPath="Open";
        *     this.financialSeries.volumeMemberPath="Volume";
        * ```
        */
        get: function () {
            return this.i.of;
        },
        set: function (v) {
            this.i.of = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "lowMemberPath", {
        /**
         * Gets or sets the low mapping property for the current series object.
        *
        * The `lowMemberPath` is used for low mapping property of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *     this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        *     this.financialSeries.dataSource = this.financialData;
        *     this.financialSeries.xAxis = this.timeXAxis;
        *     this.financialSeries.yAxis = this.numericYAxis;
        *     this.financialSeries.xAxisName = "timeXAxis";
        *     this.financialSeries.yAxisName = "numericYAxis";
        *     this.financialSeries.highMemberPath="High" ;
        *     this.financialSeries.lowMemberPath="Low";
        *     this.financialSeries.closeMemberPath="Close";
        *     this.financialSeries.openMemberPath="Open";
        *     this.financialSeries.volumeMemberPath="Volume";
        * ```
        */
        get: function () {
            return this.i.ok;
        },
        set: function (v) {
            this.i.ok = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "closeMemberPath", {
        /**
         * Gets or sets the close mapping property for the current series object.
        *
        * Use `closeMemberPath` property for the close mapping of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        * this.financialSeries.dataSource = this.financialData;
        * this.financialSeries.xAxis = this.timeXAxis;
        * this.financialSeries.yAxis = this.numericYAxis;
        * this.financialSeries.xAxisName = "timeXAxis";
        * this.financialSeries.yAxisName = "numericYAxis";
        * this.financialSeries.highMemberPath="High"
        * this.financialSeries.lowMemberPath="Low"
        * this.financialSeries.closeMemberPath="Close"
        * this.financialSeries.openMemberPath="Open"
        * this.financialSeries.volumeMemberPath="Volume"
        * ```
        */
        get: function () {
            return this.i.oc;
        },
        set: function (v) {
            this.i.oc = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "volumeMemberPath", {
        /**
         * Gets or sets the volume mapping property for the current series object.
        *
        * The `volumeMemberPath` property is used for the volume mapping property of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *     this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
        *     this.financialSeries.dataSource = this.financialData;
        *     this.financialSeries.xAxis = this.timeXAxis;
        *     this.financialSeries.yAxis = this.numericYAxis;
        *     this.financialSeries.xAxisName = "timeXAxis";
        *     this.financialSeries.yAxisName = "numericYAxis";
        *     this.financialSeries.highMemberPath="High" ;
        *     this.financialSeries.lowMemberPath="Low";
        *     this.financialSeries.closeMemberPath="Close";
        *     this.financialSeries.openMemberPath="Open";
        *     this.financialSeries.volumeMemberPath="Volume";
        * ```
        */
        get: function () {
            return this.i.os;
        },
        set: function (v) {
            this.i.os = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "isCustomCategoryStyleAllowed", {
        /**
         * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
        *
        * The `isCustomCategoryStyleAllowed` property is used to check if the category series should allow custom style.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	isCustomCategoryStyleAllowed="True" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.isCustomCategoryStyleAllowed= true;
        * ```
        */
        get: function () {
            return this.i.ne;
        },
        set: function (v) {
            this.i.ne = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "transitionInMode", {
        /**
         * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
         * Note: Transitions are not currently supported for stacked series.
        *
        * The `transitionInMode` property is used to gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	transitionInMode="Auto"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.transitionInMode =CategoryTransitionInMode.Auto;
        * ```
        */
        get: function () {
            return this.i.mi;
        },
        set: function (v) {
            this.i.mi = ensureEnum(CategoryTransitionInMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "isTransitionInEnabled", {
        /**
         * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
         * Note: Transitions are not currently supported for stacked series.
        *
        * The `isTransitionInEnabled` property is used to check if the series should transition into the plot area when a new data source is assigned.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	isTransitionInEnabled="true" />
        *
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.isTransitionInEnabled= true;
        * ```
        */
        get: function () {
            return this.i.nf;
        },
        set: function (v) {
            this.i.nf = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "isNegativeColorSupported", {
        /**
         * Overridden by derived series classes to indicate when negative colors are supported or not.
        */
        get: function () {
            return this.i.cz;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialSeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrFinancialSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrFinancialSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    IgrFinancialSeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * The `getOffsetValue` method returns the offset value for this series if grouped on a category axis.
    *
    * ```ts
    * number offset= series.getOffsetValue();
    * ```
    */
    IgrFinancialSeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * The `getCategoryWidth` method returns the width of the category grouping this series is in.
    *
    * ```ts
    * number width = series.getCategoryWidth();
    * ```
    */
    IgrFinancialSeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrFinancialSeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesCloseValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.n0(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesOpenValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.n1(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesVolumeValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.n2(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialSeries.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lh(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrFinancialSeries.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lj(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrFinancialSeries.prototype.getSeriesOpenValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.pg(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrFinancialSeries.prototype.getSeriesCloseValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.pf(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrFinancialSeries.prototype.getSeriesVolumeValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ph(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * Use `canUseAsYAxis` method to determine if the object can be used as YAxis.
    *
    * ```ts
    *   boolean canY =series.canUseAsYAxis(yAxis);
    * ```
    */
    IgrFinancialSeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.na(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * Use `canUseAsXAxis` method to determine if the object can be used as XAxis.
    *
    * ```ts
    *   boolean canX =series.canUseAsXAxis(xAxis);
    * ```
    */
    IgrFinancialSeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.m9(axis);
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    *
    * The `getExactItemIndex` method gets the precise item index, if possible, based on the closeness to the previous or next whole integer.
    *
    * If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    *
    * ```ts
    * number index = series.getExactItemIndex(world);
    * ```
    */
    IgrFinancialSeries.prototype.getExactItemIndex = function (world) {
        var iv = this.i.eb(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    *
    * The `getItemIndex` method gets the index of the item that resides at the provided world coordinates.
    *
    * ```ts
    * number itemindex= series.getItemIndex(world);
    * ```
    */
    IgrFinancialSeries.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * The `getItem` method gets the item that is the best match for the specified world coordinates.
    */
    IgrFinancialSeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    IgrFinancialSeries.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.ji(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    Object.defineProperty(IgrFinancialSeries.prototype, "assigningCategoryStyle", {
        /**
         * Event raised when Assigning Category Style
        *
        * The `AssigningCategoryStyle` event raised when assigning Category Style.
        *
        * ```ts
        * series.assigningCategoryStyle= this.chart_AssigningCategoryStyle;
        * chart_AssigningCategoryStyle(sender :any,args: AssigningCategoryStyleEventArgs )
        *   {
        *
        *
        *   }
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     ref={this.onChartRef}
        *     dataSource={this.data}
        *     width="100%"
        *     height="100%" >
        *
        *     <IgrCategoryXAxis name="xAxis" label="Label" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrFinancialPriceSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        *         closeMemberPath="Close"
        *         openMemberPath="Open"
        *         volumeMemberPath="Volume"
        *         trendLineType={this.state.trendLineType}
        *         displayType= "Candlestick"
        *         trendLinePeriod = {2}
        *         actualTrendLineBrush= "blue"
        *         assigningCategoryStyle ={this.chart_assigningCategoryStyle}/>
        *
        * </IgrDataChart>
        * ```
        *
        * ```ts
        * series.assigningCategoryStyle= this.chart_AssigningCategoryStyle;
        * chart_AssigningCategoryStyle(sender :IgrFinancialSeries,args: AssigningCategoryStyleEventArgs )
        *   {
        *
        *
        *   }
        * ```
        */
        get: function () {
            return this._assigningCategoryStyle;
        },
        set: function (ev) {
            var _this = this;
            if (this._assigningCategoryStyle_wrapped !== null) {
                this.i.assigningCategoryStyle = delegateRemove(this.i.assigningCategoryStyle, this._assigningCategoryStyle_wrapped);
                this._assigningCategoryStyle_wrapped = null;
                this._assigningCategoryStyle = null;
            }
            this._assigningCategoryStyle = ev;
            this._assigningCategoryStyle_wrapped = function (o, e) {
                var outerArgs = new IgrAssigningCategoryStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeAssigningCategoryStyle) {
                    _this.beforeAssigningCategoryStyle(_this, outerArgs);
                }
                if (_this._assigningCategoryStyle) {
                    _this._assigningCategoryStyle(_this, outerArgs);
                }
            };
            this.i.assigningCategoryStyle = delegateCombine(this.i.assigningCategoryStyle, this._assigningCategoryStyle_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "typical", {
        /**
         * Handle this event in order to perform a custom typical price calculation.
        *
        * Use `Typical` event to perform a custom typical price calculation.
        *
        * ```ts
        * series.typical= this.chart_typical;
        *
        *   chart_typical(sender :any,args: FinancialEventArgs )
        *   {
        *
        *
        *   }
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     ref={this.onChartRef}
        *     dataSource={this.data}
        *     width="100%"
        *     height="100%" >
        *
        *     <IgrCategoryXAxis name="xAxis" label="Label" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrFinancialPriceSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        *         closeMemberPath="Close"
        *         openMemberPath="Open"
        *         volumeMemberPath="Volume"
        *         trendLineType={this.state.trendLineType}
        *         displayType= "Candlestick"
        *         trendLinePeriod = {2}
        *         actualTrendLineBrush= "blue"
        *         typical ={this.chart_typical}/>
        *
        * </IgrDataChart>
        * ```
        *
        * ```ts
        *  this.financialSeries.typical=this.chart_typical;
        *     }
        *     public chart_typical =( s:IgrFinancialSeries, e: FinancialEventArgs) => {
        *
        *        }
        * ```
        */
        get: function () {
            return this._typical;
        },
        set: function (ev) {
            var _this = this;
            if (this._typical_wrapped !== null) {
                this.i.typical = delegateRemove(this.i.typical, this._typical_wrapped);
                this._typical_wrapped = null;
                this._typical = null;
            }
            this._typical = ev;
            this._typical_wrapped = function (o, e) {
                var outerArgs = new IgrFinancialEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeTypical) {
                    _this.beforeTypical(_this, outerArgs);
                }
                if (_this._typical) {
                    _this._typical(_this, outerArgs);
                }
            };
            this.i.typical = delegateCombine(this.i.typical, this._typical_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialSeries.prototype, "typicalBasedOn", {
        /**
         * Handle this event in order to specify which columns the Typical price calculation is based on.
        *
        * Use `TypicalBasedOn` event to specify which columns the Typical price calculation is based on.
        *
        * ```ts
        *    series.typicalBasedOn= this.chart_typicalBasedOn;
        *     chart_typicalBasedOn(sender :any,args: FinancialEventArgs )
        *   {
        *
        *   }
        * ```
        *
        * ````ts
        *    <IgrDataChart
        *        ref={this.onChartRef}
        *        dataSource={this.data}
        *        width="100%"
        *        height="100%" >
        *
        *        <IgrCategoryXAxis name="xAxis" label="Label" />
        *        <IgrNumericYAxis name="yAxis" />
        *
        *        <IgrFinancialPriceSeries
        *            name="series1"
        *            xAxisName="xAxis"
        *            yAxisName="yAxis"
        *            highMemberPath="High"
        *            lowMemberPath="Low"
        *            closeMemberPath="Close"
        *            openMemberPath="Open"
        *            volumeMemberPath="Volume"
        *            trendLineType={this.state.trendLineType}
        *            displayType= "Candlestick"
        *            trendLinePeriod = {2}
        *            actualTrendLineBrush= "blue"
        *            typicalBasedOn ={this.chart_typicalBasedOn}/>
        *
        *    </IgrDataChart>
        * 	```
        *
        * ```ts
        * this.financialSeries.typicalBasedOn=this.chart_typicalBasedOn;
        * public chart_typicalBasedOn =( s:IgrFinancialSeries, e: FinancialEventArgs) => {
        *
        * }
        * ````
        */
        get: function () {
            return this._typicalBasedOn;
        },
        set: function (ev) {
            var _this = this;
            if (this._typicalBasedOn_wrapped !== null) {
                this.i.typicalBasedOn = delegateRemove(this.i.typicalBasedOn, this._typicalBasedOn_wrapped);
                this._typicalBasedOn_wrapped = null;
                this._typicalBasedOn = null;
            }
            this._typicalBasedOn = ev;
            this._typicalBasedOn_wrapped = function (o, e) {
                var outerArgs = new IgrFinancialEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeTypicalBasedOn) {
                    _this.beforeTypicalBasedOn(_this, outerArgs);
                }
                if (_this._typicalBasedOn) {
                    _this._typicalBasedOn(_this, outerArgs);
                }
            };
            this.i.typicalBasedOn = delegateCombine(this.i.typicalBasedOn, this._typicalBasedOn_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialSeries;
}(IgrSeries));

/**
 * Represents the base functionality for a IgxDataChartComponent financial indicator series.
*
* The `IgrFinancialIndicator` class represents the base functionality for a IgxDataChartComponent financial indicator series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis name="yAxis" />
*
*    <IgrMassIndexIndicator
*     name="series3"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*/
var IgrFinancialIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialIndicator, _super);
    function IgrFinancialIndicator(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrFinancialIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "displayType", {
        /**
         * Gets or sets the display for the current FinancialIndicator object.
        *
        * The `displayType` property is used to display the current FinancialIndicator object.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	displayType="Column"  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.displayType= IndicatorDisplayType.Column;
        * ```
        */
        get: function () {
            return this.i.pk;
        },
        set: function (v) {
            this.i.pk = ensureEnum(IndicatorDisplayType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "ignoreFirst", {
        /**
         * Gets or sets the number of values to hide at the beginning of the indicator.
        *
        * Use the `ignoreFirst` propert to hide the number of values at the beginning of the indicator.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	ignoreFirst="2"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.ignoreFirst  = 2;
        * ```
        */
        get: function () {
            return this.i.pq;
        },
        set: function (v) {
            this.i.pq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current indicator series.
        *
        * Use `trendLineType` property to get the trend type for the current indicator series.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineType="CubicFit"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineType= TrendLineType.CubicFit;
        * ```
        */
        get: function () {
            return this.i.trendLineType;
        },
        set: function (v) {
            this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush to use to draw the trend line.
        *
        * Use the `trendLineBrush` propert to draw the trend line.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineBrush="Red"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.trendLineBrush);
        },
        set: function (v) {
            this.i.trendLineBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this indicator.
        *
        * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
        */
        get: function () {
            return brushToString(this.i.p8);
        },
        set: function (v) {
            this.i.p8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current indicator object's trend line.
        *
        * Use `trendLineThickness` property for the thickness of the current indicator object's trend line.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineThickness="2"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *  series.trendLineThickness=2 ;
        * ```
        */
        get: function () {
            return this.i.trendLineThickness;
        },
        set: function (v) {
            this.i.trendLineThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialIndicator.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the trend line period for the current series.
         * The typical, and initial, value for trend line period is 7.
        *
        * Use `trendLinePeriod` property for the trend line period of the current series.
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *    <IgrMassIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLinePeriod="30"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLinePeriod  =30;
        * ```
        */
        get: function () {
            return this.i.trendLinePeriod;
        },
        set: function (v) {
            this.i.trendLinePeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method returns the best available value bounding box within the series that has the best value match for the world position provided.
    */
    IgrFinancialIndicator.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    IgrFinancialIndicator.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrFinancialIndicator.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrFinancialIndicator.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` method scrolls the series to display the item for the specified data item.
    */
    IgrFinancialIndicator.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    return IgrFinancialIndicator;
}(IgrFinancialSeries));

/**
 * A base class for indicator series with simple calculations that separates the calculation
 * responsibility from the other responsibilities of the financial series, this enables
 * easier unit testing and decoupling of individual calculation strategies.
 * A contract is defined between the financial series and these simple indicator calculations
 * detailing the data which the series agrees to provide the simple indicator calculations,
 * this contract is defined by FinancialCalculationDataSource. If more
 * complex interactions are needed between the indicator calculation and the series, the
 * indicators should instead derive from FinancialIndicator directly, or some
 * derivative other than StrategyBasedIndicator
*/
var IgrStrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStrategyBasedIndicator, _super);
    function IgrStrategyBasedIndicator(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrStrategyBasedIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStrategyBasedIndicator;
}(IgrFinancialIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndicatorCalculationStrategy, _super);
    function IndicatorCalculationStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IndicatorCalculationStrategy.$t = markType(IndicatorCalculationStrategy, 'IndicatorCalculationStrategy');
    return IndicatorCalculationStrategy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AbsoluteVolumeOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AbsoluteVolumeOscillatorIndicatorStrategy, _super);
    function AbsoluteVolumeOscillatorIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AbsoluteVolumeOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(b.h.c);
        c.o(b.f.c);
        return c;
    };
    AbsoluteVolumeOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(b.h.b(a));
        var d = getEnumerator(b.f.b(a));
        var e = a.indicatorColumn;
        var f = 0;
        while (c.moveNext() && d.moveNext()) {
            var g = c.current - d.current;
            e.item(f, b.i(g));
            ++f;
        }
        return true;
    };
    AbsoluteVolumeOscillatorIndicatorStrategy.$t = markType(AbsoluteVolumeOscillatorIndicatorStrategy, 'AbsoluteVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return AbsoluteVolumeOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AbsoluteVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AbsoluteVolumeOscillatorIndicator, _super);
    function AbsoluteVolumeOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AbsoluteVolumeOscillatorIndicator.prototype.get_qc = function () {
        return new AbsoluteVolumeOscillatorIndicatorStrategy();
    };
    Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    AbsoluteVolumeOscillatorIndicator.prototype.get_qp = function () {
        return AbsoluteVolumeOscillatorIndicator.$;
    };
    Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(AbsoluteVolumeOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    AbsoluteVolumeOscillatorIndicator.prototype.qk = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(AbsoluteVolumeOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qx));
        },
        set: function (a) {
            this.h(AbsoluteVolumeOscillatorIndicator.qx, a);
        },
        enumerable: true,
        configurable: true
    });
    AbsoluteVolumeOscillatorIndicator.prototype.qh = function () {
        return this.longPeriod;
    };
    AbsoluteVolumeOscillatorIndicator.$t = markType(AbsoluteVolumeOscillatorIndicator, 'AbsoluteVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    AbsoluteVolumeOscillatorIndicator.qy = StrategyBasedIndicator.qw(10, AbsoluteVolumeOscillatorIndicator.$);
    AbsoluteVolumeOscillatorIndicator.qx = StrategyBasedIndicator.qs(30, AbsoluteVolumeOscillatorIndicator.$);
    return AbsoluteVolumeOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Absolute Volume Oscillator indicator series.
 * Default required members: Volume
*
* You can use the `IgrAbsoluteVolumeOscillatorIndicator` to identify whether volume trands are increasing or decreasing.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*    <IgrAbsoluteVolumeOscillatorIndicator
*     name="series3"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgxAbsoluteVolumeOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*
* ```ts
* let series = new IgrAbsoluteVolumeOscillatorIndicator({name:"series3"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrAbsoluteVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAbsoluteVolumeOscillatorIndicator, _super);
    function IgrAbsoluteVolumeOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrAbsoluteVolumeOscillatorIndicator.prototype.createImplementation = function () {
        return new AbsoluteVolumeOscillatorIndicator();
    };
    Object.defineProperty(IgrAbsoluteVolumeOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAbsoluteVolumeOscillatorIndicator.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
         * The typical, and initial, value for short AVO periods is 10.
        *
        * You can use the `shortPeriod` to set the short moving average period.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrAbsoluteVolumeOscillatorIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	shortPeriod="10" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.shortPeriod = 10;
        * ```
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAbsoluteVolumeOscillatorIndicator.prototype, "longPeriod", {
        /**
         * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
         * The typical, and initial, value for long AVO periods is 30.
        *
        * You can use the `longPeriod` to set the long moving average period.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrAbsoluteVolumeOscillatorIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	longPeriod=30/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.longPeriod = 30;
        * ```
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAbsoluteVolumeOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAbsoluteVolumeOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAbsoluteVolumeOscillatorIndicatorModule() {
    }
    IgrAbsoluteVolumeOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrAbsoluteVolumeOscillatorIndicator", IgrAbsoluteVolumeOscillatorIndicator);
        TypeRegistrar.register("AbsoluteVolumeOscillatorIndicator", AbsoluteVolumeOscillatorIndicator.$type);
    };
    return IgrAbsoluteVolumeOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StreamingIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StreamingIndicatorCalculationStrategy, _super);
    function StreamingIndicatorCalculationStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StreamingIndicatorCalculationStrategy.$t = markType(StreamingIndicatorCalculationStrategy, 'StreamingIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);
    return StreamingIndicatorCalculationStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AccumulationDistributionIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AccumulationDistributionIndicatorStrategy, _super);
    function AccumulationDistributionIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AccumulationDistributionIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("LowColumn");
        c.add("HighColumn");
        c.add("VolumeColumn");
        return c;
    };
    AccumulationDistributionIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                var d = _d.value;
                a.indicatorColumn.item(c, d);
                c++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    AccumulationDistributionIndicatorStrategy.prototype._c = function (a, b) {
        var c, d, e, f, g, h, i, j, k, l, m, n, o, p;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = 0;
                    d = Number.POSITIVE_INFINITY;
                    e = Number.NEGATIVE_INFINITY;
                    f = a.indicatorColumn != null ? a.indicatorColumn.count : 0;
                    g = a.closeColumn != null ? a.closeColumn.count : 0;
                    h = a.highColumn != null ? a.highColumn.count : 0;
                    i = a.volumeColumn != null ? a.volumeColumn.count : 0;
                    j = Math.min(f, Math.min(g, Math.min(h, i)));
                    k = 0;
                    _a.label = 1;
                case 1:
                    if (!(k < j))
                        return [3 /*break*/, 4];
                    l = a.closeColumn.item(k);
                    m = a.lowColumn.item(k);
                    n = a.highColumn.item(k);
                    o = a.volumeColumn.item(k);
                    p = ((l - m) - (n - l)) / (n - m);
                    c += b.i(p * o);
                    d = Math.min(d, c);
                    e = Math.max(e, c);
                    return [4 /*yield*/, c];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    ++k;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    AccumulationDistributionIndicatorStrategy.prototype.c = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._c(a, b); });
    };
    AccumulationDistributionIndicatorStrategy.$t = markType(AccumulationDistributionIndicatorStrategy, 'AccumulationDistributionIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);
    return AccumulationDistributionIndicatorStrategy;
}(StreamingIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AccumulationDistributionIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AccumulationDistributionIndicator, _super);
    function AccumulationDistributionIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AccumulationDistributionIndicator.prototype.get_qc = function () {
        return new AccumulationDistributionIndicatorStrategy();
    };
    Object.defineProperty(AccumulationDistributionIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    AccumulationDistributionIndicator.prototype.get_qp = function () {
        return AccumulationDistributionIndicator.$;
    };
    Object.defineProperty(AccumulationDistributionIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    AccumulationDistributionIndicator.$t = markType(AccumulationDistributionIndicator, 'AccumulationDistributionIndicator', StrategyBasedIndicator.$);
    return AccumulationDistributionIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
 * Default required members: Close, Low, High, Volume
*
* You can use the `IgrAccumulationDistributionIndicator` to evaluate the suppy and demand of a stock, security, or index.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrAccumulationDistributionIndicator
* 	name="series1"
* 	xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume"/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrAccumulationDistributionIndicator({name:"series3"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrAccumulationDistributionIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAccumulationDistributionIndicator, _super);
    function IgrAccumulationDistributionIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrAccumulationDistributionIndicator.prototype.createImplementation = function () {
        return new AccumulationDistributionIndicator();
    };
    Object.defineProperty(IgrAccumulationDistributionIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAccumulationDistributionIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAccumulationDistributionIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAccumulationDistributionIndicatorModule() {
    }
    IgrAccumulationDistributionIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrAccumulationDistributionIndicator", IgrAccumulationDistributionIndicator);
        TypeRegistrar.register("AccumulationDistributionIndicator", AccumulationDistributionIndicator.$type);
    };
    return IgrAccumulationDistributionIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AverageDirectionalIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AverageDirectionalIndexIndicatorStrategy, _super);
    function AverageDirectionalIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AverageDirectionalIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("LowColumn");
        c.add("HighColumn");
        c.o(a.trueRange.basedOn);
        c.o(b.a.c);
        return c;
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.j = function (a, b, c) {
        return b.item(a) - b.item(a - 1);
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.i = function (a, b, c) {
        return c.item(a - 1) - c.item(a);
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._h = function (a, b) {
        var c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, 0];
                case 1:
                    _a.sent();
                    c = 0;
                    d = 0;
                    e = 1;
                    _a.label = 2;
                case 2:
                    if (!(e < a.count))
                        return [3 /*break*/, 7];
                    c = this.j(e, a, b);
                    d = this.i(e, a, b);
                    if (!(c > d && c > 0))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, c];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 4: return [4 /*yield*/, 0];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6:
                    e++;
                    return [3 /*break*/, 2];
                case 7: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.h = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._h(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._f = function (a, b) {
        var c, d, e;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, 0];
                case 1:
                    _a.sent();
                    c = 0;
                    d = 0;
                    e = 1;
                    _a.label = 2;
                case 2:
                    if (!(e < a.count))
                        return [3 /*break*/, 7];
                    c = this.j(e, a, b);
                    d = this.i(e, a, b);
                    if (!(d > c && d > 0))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, d];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 4: return [4 /*yield*/, 0];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6:
                    e++;
                    return [3 /*break*/, 2];
                case 7: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.f = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._f(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._g = function (a, b) {
        var c, d;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = getEnumerator(b.a.b(this.h(a.highColumn, a.lowColumn), a.period));
                    d = getEnumerator(b.a.b(a.trueRange, a.period));
                    _a.label = 1;
                case 1:
                    if (!(c.moveNext() && d.moveNext()))
                        return [3 /*break*/, 3];
                    return [4 /*yield*/, b.i(c.current / d.current)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 1];
                case 3: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.g = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._g(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._e = function (a, b) {
        var c, d;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = getEnumerator(b.a.b(this.f(a.highColumn, a.lowColumn), a.period));
                    d = getEnumerator(b.a.b(a.trueRange, a.period));
                    _a.label = 1;
                case 1:
                    if (!(c.moveNext() && d.moveNext()))
                        return [3 /*break*/, 3];
                    return [4 /*yield*/, b.i(c.current / d.current)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 1];
                case 3: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.e = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._e(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._d = function (a, b) {
        var c, d;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = getEnumerator(this.g(a, b));
                    d = getEnumerator(this.e(a, b));
                    c.moveNext();
                    d.moveNext();
                    _a.label = 1;
                case 1:
                    if (!(c.moveNext() && d.moveNext()))
                        return [3 /*break*/, 3];
                    return [4 /*yield*/, Math.abs(b.i((c.current - d.current) / (c.current + d.current)))];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 1];
                case 3: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.d = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._d(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype._c = function (a, b) {
        var c;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = getEnumerator(b.a.b(this.d(a, b), a.period));
                    return [4 /*yield*/, 0];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    if (!c.moveNext())
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, c.current * 100];
                case 3:
                    _a.sent();
                    return [3 /*break*/, 2];
                case 4: return [2 /*return*/];
            }
        });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.c = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._c(a, b); });
    };
    AverageDirectionalIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(this.c(a, b));
        var d = a.indicatorColumn;
        for (var e = 0; e < d.count; e++) {
            if (c.moveNext()) {
                d.item(e, c.current);
            }
        }
        return true;
    };
    AverageDirectionalIndexIndicatorStrategy.$t = markType(AverageDirectionalIndexIndicatorStrategy, 'AverageDirectionalIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return AverageDirectionalIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AverageDirectionalIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AverageDirectionalIndexIndicator, _super);
    function AverageDirectionalIndexIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AverageDirectionalIndexIndicator.prototype.get_qc = function () {
        return new AverageDirectionalIndexIndicatorStrategy();
    };
    Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    AverageDirectionalIndexIndicator.prototype.get_qp = function () {
        return AverageDirectionalIndexIndicator.$;
    };
    Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AverageDirectionalIndexIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(AverageDirectionalIndexIndicator.qy));
        },
        set: function (a) {
            this.h(AverageDirectionalIndexIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    AverageDirectionalIndexIndicator.prototype.qi = function () {
        return this.qx;
    };
    AverageDirectionalIndexIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    AverageDirectionalIndexIndicator.$t = markType(AverageDirectionalIndexIndicator, 'AverageDirectionalIndexIndicator', StrategyBasedIndicator.$);
    AverageDirectionalIndexIndicator.qy = StrategyBasedIndicator.qu(14, AverageDirectionalIndexIndicator.$);
    return AverageDirectionalIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Average Directional indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgrAverageDirectionalIndexIndicator` to measures trend strength without regard to trend direction.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrAverageDirectionalIndexIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrAverageDirectionalIndexIndicator();
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrAverageDirectionalIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAverageDirectionalIndexIndicator, _super);
    function IgrAverageDirectionalIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrAverageDirectionalIndexIndicator.prototype.createImplementation = function () {
        return new AverageDirectionalIndexIndicator();
    };
    Object.defineProperty(IgrAverageDirectionalIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAverageDirectionalIndexIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
         * The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
        *
        * You can use the `period` to set the moving average.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrAverageDirectionalIndexIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        * 		volumeMemberPath="Volume"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period="14"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 14;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAverageDirectionalIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAverageDirectionalIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAverageDirectionalIndexIndicatorModule() {
    }
    IgrAverageDirectionalIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrAverageDirectionalIndexIndicator", IgrAverageDirectionalIndexIndicator);
        TypeRegistrar.register("AverageDirectionalIndexIndicator", AverageDirectionalIndexIndicator.$type);
    };
    return IgrAverageDirectionalIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AverageTrueRangeIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AverageTrueRangeIndicatorStrategy, _super);
    function AverageTrueRangeIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AverageTrueRangeIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.trueRange.basedOn);
        c.o(b.a.c);
        return c;
    };
    AverageTrueRangeIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(b.a.b(a.trueRange, a.period))), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                a.indicatorColumn.item(c, d);
                ++c;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    AverageTrueRangeIndicatorStrategy.$t = markType(AverageTrueRangeIndicatorStrategy, 'AverageTrueRangeIndicatorStrategy', IndicatorCalculationStrategy.$);
    return AverageTrueRangeIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AverageTrueRangeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AverageTrueRangeIndicator, _super);
    function AverageTrueRangeIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AverageTrueRangeIndicator.prototype.get_qc = function () {
        return new AverageTrueRangeIndicatorStrategy();
    };
    Object.defineProperty(AverageTrueRangeIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    AverageTrueRangeIndicator.prototype.get_qp = function () {
        return AverageTrueRangeIndicator.$;
    };
    Object.defineProperty(AverageTrueRangeIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AverageTrueRangeIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(AverageTrueRangeIndicator.qy));
        },
        set: function (a) {
            this.h(AverageTrueRangeIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    AverageTrueRangeIndicator.prototype.qi = function () {
        return this.qx;
    };
    AverageTrueRangeIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
    AverageTrueRangeIndicator.qy = StrategyBasedIndicator.qu(14, AverageTrueRangeIndicator.$);
    return AverageTrueRangeIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Average True Range indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgrAverageTrueRangeIndicator` to measures a security's degree of price movement or volatility within a given period of time.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrAverageTrueRangeIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrAverageTrueRangeIndicator({name:"series3"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrAverageTrueRangeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAverageTrueRangeIndicator, _super);
    function IgrAverageTrueRangeIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrAverageTrueRangeIndicator.prototype.createImplementation = function () {
        return new AverageTrueRangeIndicator();
    };
    Object.defineProperty(IgrAverageTrueRangeIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAverageTrueRangeIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
         * The typical, and initial, value for AverageTrueRange periods is 14.
        *
        * You can use the `period` to set the moving average.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrAverageTrueRangeIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        * 		volumeMemberPath="Volume"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period="14" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 14;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAverageTrueRangeIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAverageTrueRangeIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAverageTrueRangeIndicatorModule() {
    }
    IgrAverageTrueRangeIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrAverageTrueRangeIndicator", IgrAverageTrueRangeIndicator);
        TypeRegistrar.register("AverageTrueRangeIndicator", AverageTrueRangeIndicator.$type);
    };
    return IgrAverageTrueRangeIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BollingerBandWidthIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandWidthIndicatorStrategy, _super);
    function BollingerBandWidthIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BollingerBandWidthIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.c.c);
        c.o(b.d.c);
        return c;
    };
    BollingerBandWidthIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(b.c.b(a.typicalColumn, a.period));
        var d = getEnumerator(b.d.b(a.typicalColumn, a.period));
        var e = a.multiplier;
        var f = a.indicatorColumn;
        var g = 0;
        while (c.moveNext() && d.moveNext()) {
            var h = d.current * e;
            var i = c.current + h;
            var j = c.current - h;
            var k = c.current;
            var l = b.i((i - j) / k);
            f.item(g, l);
            g++;
        }
        return true;
    };
    BollingerBandWidthIndicatorStrategy.$t = markType(BollingerBandWidthIndicatorStrategy, 'BollingerBandWidthIndicatorStrategy', IndicatorCalculationStrategy.$);
    return BollingerBandWidthIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BollingerBandWidthIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandWidthIndicator, _super);
    function BollingerBandWidthIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BollingerBandWidthIndicator.prototype.get_qc = function () {
        return new BollingerBandWidthIndicatorStrategy();
    };
    Object.defineProperty(BollingerBandWidthIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    BollingerBandWidthIndicator.prototype.get_qp = function () {
        return BollingerBandWidthIndicator.$;
    };
    Object.defineProperty(BollingerBandWidthIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BollingerBandWidthIndicator.prototype, "qy", {
        get: function () {
            return typeGetValue(this.c(BollingerBandWidthIndicator.q1));
        },
        set: function (a) {
            this.h(BollingerBandWidthIndicator.q1, a);
        },
        enumerable: true,
        configurable: true
    });
    BollingerBandWidthIndicator.prototype.qi = function () {
        return this.qy;
    };
    Object.defineProperty(BollingerBandWidthIndicator.prototype, "qx", {
        get: function () {
            return this.c(BollingerBandWidthIndicator.q0);
        },
        set: function (a) {
            this.h(BollingerBandWidthIndicator.q0, a);
        },
        enumerable: true,
        configurable: true
    });
    BollingerBandWidthIndicator.prototype.qg = function () {
        return this.qx;
    };
    BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
    BollingerBandWidthIndicator.q1 = StrategyBasedIndicator.qu(20, BollingerBandWidthIndicator.$);
    BollingerBandWidthIndicator.q0 = StrategyBasedIndicator.qt(2, BollingerBandWidthIndicator.$);
    return BollingerBandWidthIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
 * Represents the normalized width of the Bollinger bands for each provided value.
 * For more info see: BollingerBandsOverlay
 * Default required members: High, Low, Close
*
* You can use the `IgrBollingerBandWidthIndicator` to represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFinancialPriceSeries
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*
*     <IgrBollingerBandsOverlay
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*
*     <IgrBollingerBandWidthIndicator
*     name="series3"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*/
var IgrBollingerBandWidthIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBollingerBandWidthIndicator, _super);
    function IgrBollingerBandWidthIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrBollingerBandWidthIndicator.prototype.createImplementation = function () {
        return new BollingerBandWidthIndicator();
    };
    Object.defineProperty(IgrBollingerBandWidthIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBollingerBandWidthIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the Bollinger Band Width Indicator.
         * The typical, and initial, value for CCI periods is 20.
        *
        * You can use the `period` to set the moving average.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandsOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandWidthIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period= {14} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 14;
        * ```
        */
        get: function () {
            return this.i.qy;
        },
        set: function (v) {
            this.i.qy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBollingerBandWidthIndicator.prototype, "multiplier", {
        /**
         * Gets or sets the multiplier for the Bollinger Band width.
         * The typical, and initial, value for Bollinger Band width multiplier is 2.
        *
        * Use the `multiplier` property for the Bollinger Band width. The typical, and initial, value for Bollinger Band width multiplier is 2.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandsOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandWidthIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	Multiplier= {2} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.multiplier = 14;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrBollingerBandWidthIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBollingerBandWidthIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBollingerBandWidthIndicatorModule() {
    }
    IgrBollingerBandWidthIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrBollingerBandWidthIndicator", IgrBollingerBandWidthIndicator);
        TypeRegistrar.register("BollingerBandWidthIndicator", BollingerBandWidthIndicator.$type);
    };
    return IgrBollingerBandWidthIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChaikinOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChaikinOscillatorIndicatorStrategy, _super);
    function ChaikinOscillatorIndicatorStrategy() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = new AccumulationDistributionIndicatorStrategy();
        return _this;
    }
    ChaikinOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    };
    ChaikinOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.indicatorColumn;
        var d = this.c.c(a, b);
        var e = getEnumerator(b.a.b(d, a.shortPeriod));
        var f = getEnumerator(b.a.b(d, a.longPeriod));
        var g = 0;
        while (e.moveNext() && f.moveNext()) {
            var h = e.current - f.current;
            c.item(g, h);
            g++;
        }
        return true;
    };
    ChaikinOscillatorIndicatorStrategy.$t = markType(ChaikinOscillatorIndicatorStrategy, 'ChaikinOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return ChaikinOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChaikinOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChaikinOscillatorIndicator, _super);
    function ChaikinOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChaikinOscillatorIndicator.prototype.get_qc = function () {
        return new ChaikinOscillatorIndicatorStrategy();
    };
    Object.defineProperty(ChaikinOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    ChaikinOscillatorIndicator.prototype.get_qp = function () {
        return ChaikinOscillatorIndicator.$;
    };
    Object.defineProperty(ChaikinOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChaikinOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(ChaikinOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(ChaikinOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    ChaikinOscillatorIndicator.prototype.qk = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(ChaikinOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(ChaikinOscillatorIndicator.qx));
        },
        set: function (a) {
            this.h(ChaikinOscillatorIndicator.qx, a);
        },
        enumerable: true,
        configurable: true
    });
    ChaikinOscillatorIndicator.prototype.qh = function () {
        return this.longPeriod;
    };
    ChaikinOscillatorIndicator.$t = markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    ChaikinOscillatorIndicator.qy = StrategyBasedIndicator.qw(3, ChaikinOscillatorIndicator.$);
    ChaikinOscillatorIndicator.qx = StrategyBasedIndicator.qs(10, ChaikinOscillatorIndicator.$);
    return ChaikinOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents the IgxDataChartComponent Chaikin Oscillator indicator series.
 * Default required members: Close, Low, High, Volume
*
* `IgrChaikinOscillatorIndicator` class specify the series as Chaikin Oscillator Indicator series.
*
* ```ts
* <IgrDataChart
* 	ref={this.onChartRef}
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*    <IgrChaikinOscillatorIndicator
*     name="series3"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume"
* 	longPeriod={30}/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series1 = new IgrAbsoluteVolumeOscillatorIndicator({ name: ""});
* series1.xAxis = this.categoryXAxis;
* series1.yAxis = this.numericYAxis;
* series1.xAxisName = "XAxis";
* series1.yAxisName = "YAxis";
* series1.valueMemberPath = "Volume";
* series1.openMemberPath = "open";
* series1.highMemberPath = "high";
* series1.lowMemberPath = "low";
* series1.closeMemberPath = "close";
* ```
*/
var IgrChaikinOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrChaikinOscillatorIndicator, _super);
    function IgrChaikinOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrChaikinOscillatorIndicator.prototype.createImplementation = function () {
        return new ChaikinOscillatorIndicator();
    };
    Object.defineProperty(IgrChaikinOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChaikinOscillatorIndicator.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current ChaikinOscillatorIndicator object.
         * The typical, and initial, value for short CHO periods is 3.
        *
        * Set the `shortPeriod` property if you wish to change the short moving average period for the indicator.
        *
        * ```ts
        * this.series.shortPeriod = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrChaikinOscillatorIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	ShortPeriod ={5}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChaikinOscillatorIndicator.prototype, "longPeriod", {
        /**
         * Gets or sets the long moving average period for the current ChaikinOscillatorIndicator object.
         * The typical, and initial, value for long CHO periods is 10.
        *
        * Set the `longPeriod` property if you wish to change the long moving average period for the indicator.
        *
        * ```ts
        * this.series.longPeriod = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrChaikinOscillatorIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	longPeriod={30}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrChaikinOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrChaikinOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrChaikinOscillatorIndicatorModule() {
    }
    IgrChaikinOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrChaikinOscillatorIndicator", IgrChaikinOscillatorIndicator);
        TypeRegistrar.register("ChaikinOscillatorIndicator", ChaikinOscillatorIndicator.$type);
    };
    return IgrChaikinOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChaikinVolatilityIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChaikinVolatilityIndicatorStrategy, _super);
    function ChaikinVolatilityIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChaikinVolatilityIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.o(b.a.c);
        return c;
    };
    ChaikinVolatilityIndicatorStrategy.prototype.a = function (a, b) {
        var c = b.j(function (d) { return a.highColumn.item(d) - a.lowColumn.item(d); }, a.count);
        var d = getEnumerator(b.a.b(c, a.period));
        var e = a.indicatorColumn;
        var f = new Array(a.period);
        for (var g = 0; g < a.period; g++) {
            f[g] = 0;
        }
        var h = 0;
        while (d.moveNext()) {
            var i = h % a.period;
            var j = b.i((d.current - f[i]) / (f[i] * 100));
            if (h < a.period) {
                e.item(h, 0);
            }
            else {
                e.item(h, j);
            }
            f[i] = d.current;
            h++;
        }
        return true;
    };
    ChaikinVolatilityIndicatorStrategy.$t = markType(ChaikinVolatilityIndicatorStrategy, 'ChaikinVolatilityIndicatorStrategy', IndicatorCalculationStrategy.$);
    return ChaikinVolatilityIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChaikinVolatilityIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChaikinVolatilityIndicator, _super);
    function ChaikinVolatilityIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChaikinVolatilityIndicator.prototype.get_qc = function () {
        return new ChaikinVolatilityIndicatorStrategy();
    };
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    ChaikinVolatilityIndicator.prototype.get_qp = function () {
        return ChaikinVolatilityIndicator.$;
    };
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(ChaikinVolatilityIndicator.qy));
        },
        set: function (a) {
            this.h(ChaikinVolatilityIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    ChaikinVolatilityIndicator.prototype.qi = function () {
        return this.qx;
    };
    ChaikinVolatilityIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
    ChaikinVolatilityIndicator.qy = StrategyBasedIndicator.qu(10, ChaikinVolatilityIndicator.$);
    return ChaikinVolatilityIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Chaikin Volatility indicator series.
 * The ChaikinVolatility indicator attempts to show volatility by displaying the spread between
 * the high and low values.
 * Default required members: High, Low
*
* `IgrChaikinVolatilityIndicator` class specify the series as Chaikin Volitility Indicator series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrChaikinVolatilityIndicator
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume" />
*  </IgrDataChart>
* ```
*/
var IgrChaikinVolatilityIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrChaikinVolatilityIndicator, _super);
    function IgrChaikinVolatilityIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrChaikinVolatilityIndicator.prototype.createImplementation = function () {
        return new ChaikinVolatilityIndicator();
    };
    Object.defineProperty(IgrChaikinVolatilityIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChaikinVolatilityIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current ChaikinVolatilityIndicator object.
         * The typical, and initial, value for ChaikinVolatilityIndicator periods is 10.
        *
        * Set the `period` property if you wish to change the moving average period for the indicator.
        *
        * ```ts
        * this.series.longPeriod = 30;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrChaikinVolatilityIndicator
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	openMemberPath="open"
        *     highMemberPath="high"
        *     lowMemberPath="low"
        *     closeMemberPath="close"
        *     volumeMemberPath="volume"
        *     period={30} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrChaikinVolatilityIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrChaikinVolatilityIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrChaikinVolatilityIndicatorModule() {
    }
    IgrChaikinVolatilityIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrChaikinVolatilityIndicator", IgrChaikinVolatilityIndicator);
        TypeRegistrar.register("ChaikinVolatilityIndicator", ChaikinVolatilityIndicator.$type);
    };
    return IgrChaikinVolatilityIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CommodityChannelIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CommodityChannelIndexIndicatorStrategy, _super);
    function CommodityChannelIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommodityChannelIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.c.c);
        return c;
    };
    CommodityChannelIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.period;
        var d = a.typicalColumn;
        var e = a.indicatorColumn;
        var f = getEnumerator(b.c.b(d, c));
        var g = getEnumerator(d);
        var h = new Array(c);
        for (var i = 0; i < c; i++) {
            h[i] = 0;
        }
        var j = 0;
        while (g.moveNext() && f.moveNext()) {
            h[j % c] = g.current;
            var k = 0;
            for (var l = 0; l < c; ++l) {
                k += Math.abs(f.current - h[l]);
            }
            k /= c;
            e.item(j, b.i((g.current - f.current) / (0.015 * k)));
            ++j;
        }
        return true;
    };
    CommodityChannelIndexIndicatorStrategy.$t = markType(CommodityChannelIndexIndicatorStrategy, 'CommodityChannelIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return CommodityChannelIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CommodityChannelIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CommodityChannelIndexIndicator, _super);
    function CommodityChannelIndexIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CommodityChannelIndexIndicator.prototype.get_qc = function () {
        return new CommodityChannelIndexIndicatorStrategy();
    };
    Object.defineProperty(CommodityChannelIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    CommodityChannelIndexIndicator.prototype.get_qp = function () {
        return CommodityChannelIndexIndicator.$;
    };
    Object.defineProperty(CommodityChannelIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CommodityChannelIndexIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(CommodityChannelIndexIndicator.qy));
        },
        set: function (a) {
            this.h(CommodityChannelIndexIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    CommodityChannelIndexIndicator.prototype.qi = function () {
        return this.qx;
    };
    CommodityChannelIndexIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    CommodityChannelIndexIndicator.$t = markType(CommodityChannelIndexIndicator, 'CommodityChannelIndexIndicator', StrategyBasedIndicator.$);
    CommodityChannelIndexIndicator.qy = StrategyBasedIndicator.qu(20, CommodityChannelIndexIndicator.$);
    return CommodityChannelIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Commodity Channel Index indicator series.
 * Default required members: High, Low, Close
*
* `IgrCommodityChannelIndexIndicator` class specify the series as Commodity Channel Index Indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrCommodityChannelIndexIndicator
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Line"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" 	/>
*  </IgrDataChart>
* ```
*
* ```ts
* series1 = new IgrCommodityChannelIndexIndicator({ name: "colSeries1" });
* series1.dataSource = this.categoryData;
* series1.xAxis = this.categoryXAxis;
* series1.yAxis = this.numericYAxis;
* series1.xAxisName = "categoryXAxis";
* series1.yAxisName = "numericYAxis";
* series1.valueMemberPath = "Volume";
* series1.openMemberPath = "open";
* series1.highMemberPath = "high";
* series1.lowMemberPath = "low";
* series1.closeMemberPath = "close";
* ```
*/
var IgrCommodityChannelIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCommodityChannelIndexIndicator, _super);
    function IgrCommodityChannelIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrCommodityChannelIndexIndicator.prototype.createImplementation = function () {
        return new CommodityChannelIndexIndicator();
    };
    Object.defineProperty(IgrCommodityChannelIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCommodityChannelIndexIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current CCISeries object.
         * The typical, and initial, value for CCI periods is 20.
        *
        * ```ts
        * this.series.period = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *    <IgrCommodityChannelIndexIndicator
        *     name="series3"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Line"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period= {30}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCommodityChannelIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCommodityChannelIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCommodityChannelIndexIndicatorModule() {
    }
    IgrCommodityChannelIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrCommodityChannelIndexIndicator", IgrCommodityChannelIndexIndicator);
        TypeRegistrar.register("CommodityChannelIndexIndicator", CommodityChannelIndexIndicator.$type);
    };
    return IgrCommodityChannelIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DetrendedPriceOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DetrendedPriceOscillatorIndicatorStrategy, _super);
    function DetrendedPriceOscillatorIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetrendedPriceOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.o(b.c.c);
        return c;
    };
    DetrendedPriceOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.period;
        var d = a.closeColumn;
        var e = a.indicatorColumn;
        var f = getEnumerator(b.c.b(d, c));
        var g = (intDivide(c, 2)) + 1;
        var h = new Array(g);
        for (var i = 0; i < g; i++) {
            h[i] = 0;
        }
        for (var j = 1; j < Math.min(g + 1, e.count); ++j) {
            var k = j % g;
            e.item(j, 0);
            f.moveNext();
            h[k] = f.current;
        }
        for (var l = g + 1; l < e.count; l++) {
            var m = l % g;
            e.item(l, d.item(l) - h[m]);
            f.moveNext();
            h[m] = f.current;
        }
        return true;
    };
    DetrendedPriceOscillatorIndicatorStrategy.$t = markType(DetrendedPriceOscillatorIndicatorStrategy, 'DetrendedPriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return DetrendedPriceOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DetrendedPriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DetrendedPriceOscillatorIndicator, _super);
    function DetrendedPriceOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetrendedPriceOscillatorIndicator.prototype.get_qc = function () {
        return new DetrendedPriceOscillatorIndicatorStrategy();
    };
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    DetrendedPriceOscillatorIndicator.prototype.get_qp = function () {
        return DetrendedPriceOscillatorIndicator.$;
    };
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(DetrendedPriceOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(DetrendedPriceOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    DetrendedPriceOscillatorIndicator.prototype.qi = function () {
        return this.qx;
    };
    DetrendedPriceOscillatorIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    DetrendedPriceOscillatorIndicator.$t = markType(DetrendedPriceOscillatorIndicator, 'DetrendedPriceOscillatorIndicator', StrategyBasedIndicator.$);
    DetrendedPriceOscillatorIndicator.qy = StrategyBasedIndicator.qu(20, DetrendedPriceOscillatorIndicator.$);
    return DetrendedPriceOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
 * Default required members: Close
*
* The `IgrDetrendedPriceOscillatorIndicator` class represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrDetrendedPriceOscillatorIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		highMemberPath="High"
*         lowMemberPath="Low"
* 		period= {30} />
*  </IgrDataChart>
* ```
*/
var IgrDetrendedPriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDetrendedPriceOscillatorIndicator, _super);
    function IgrDetrendedPriceOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrDetrendedPriceOscillatorIndicator.prototype.createImplementation = function () {
        return new DetrendedPriceOscillatorIndicator();
    };
    Object.defineProperty(IgrDetrendedPriceOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDetrendedPriceOscillatorIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current DetrendedPriceOscillatorIndicator object.
         * The typical, and initial, value for DPO periods is 20.
        *
        * You can use the `period` to set the current moving average period.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrDetrendedPriceOscillatorIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period=30 />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrDetrendedPriceOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDetrendedPriceOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDetrendedPriceOscillatorIndicatorModule() {
    }
    IgrDetrendedPriceOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrDetrendedPriceOscillatorIndicator", IgrDetrendedPriceOscillatorIndicator);
        TypeRegistrar.register("DetrendedPriceOscillatorIndicator", DetrendedPriceOscillatorIndicator.$type);
    };
    return IgrDetrendedPriceOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var EaseOfMovementIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(EaseOfMovementIndicatorStrategy, _super);
    function EaseOfMovementIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EaseOfMovementIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("VolumeColumn");
        return c;
    };
    EaseOfMovementIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.indicatorColumn;
        var d = a.highColumn;
        var e = a.lowColumn;
        var f = a.volumeColumn;
        var g = a.count;
        if (g > 0) {
            c.item(0, 0);
        }
        for (var h = 1; h < g; h++) {
            var i = (d.item(h) + e.item(h)) / 2;
            var j = (d.item(h - 1) + e.item(h - 1)) / 2;
            var k = i - j;
            var l = 10000;
            var m = b.i((f.item(h) / l) / (d.item(h) - e.item(h)));
            c.item(h, b.i(k / m));
        }
        return true;
    };
    EaseOfMovementIndicatorStrategy.$t = markType(EaseOfMovementIndicatorStrategy, 'EaseOfMovementIndicatorStrategy', IndicatorCalculationStrategy.$);
    return EaseOfMovementIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var EaseOfMovementIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(EaseOfMovementIndicator, _super);
    function EaseOfMovementIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EaseOfMovementIndicator.prototype.get_qc = function () {
        return new EaseOfMovementIndicatorStrategy();
    };
    Object.defineProperty(EaseOfMovementIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    EaseOfMovementIndicator.prototype.get_qp = function () {
        return EaseOfMovementIndicator.$;
    };
    Object.defineProperty(EaseOfMovementIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    EaseOfMovementIndicator.$t = markType(EaseOfMovementIndicator, 'EaseOfMovementIndicator', StrategyBasedIndicator.$);
    return EaseOfMovementIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Ease of Movement indicator series.
 * The ease of movement indicator by Richard W. Arms, Jr relates the price change of an asset to
 * its volume. Normally smoothed with a moving average.
 * Default required members: Low, High, Volume
*
* The ease of movment indicator is used to analyze relationships between a price changes and volume. One would usually plot this in a separate chart below the main price chart. It can be added to a chart like this:
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrEaseOfMovementIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*/
var IgrEaseOfMovementIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrEaseOfMovementIndicator, _super);
    function IgrEaseOfMovementIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrEaseOfMovementIndicator.prototype.createImplementation = function () {
        return new EaseOfMovementIndicator();
    };
    Object.defineProperty(IgrEaseOfMovementIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrEaseOfMovementIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrEaseOfMovementIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrEaseOfMovementIndicatorModule() {
    }
    IgrEaseOfMovementIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrEaseOfMovementIndicator", IgrEaseOfMovementIndicator);
        TypeRegistrar.register("EaseOfMovementIndicator", EaseOfMovementIndicator.$type);
    };
    return IgrEaseOfMovementIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentKCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentKCalculationStrategy, _super);
    function PercentKCalculationStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentKCalculationStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    };
    PercentKCalculationStrategy.prototype._c = function (a, b) {
        var c, d, e, f, g, h, i, j;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = a.period;
                    d = a.highColumn;
                    e = a.lowColumn;
                    f = 0;
                    _a.label = 1;
                case 1:
                    if (!(f < a.count))
                        return [3 /*break*/, 4];
                    g = Math.min(c, f);
                    h = -1.7976931348623157E+308;
                    i = 1.7976931348623157E+308;
                    for (j = 0; j < g; j++) {
                        if (!isNaN_(d.item(f - j))) {
                            h = Math.max(h, d.item(f - j));
                        }
                        if (!isNaN_(e.item(f - j))) {
                            i = Math.min(i, e.item(f - j));
                        }
                    }
                    return [4 /*yield*/, b.i((a.closeColumn.item(f) - i) / (h - i) * 100)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    f++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    PercentKCalculationStrategy.prototype.c = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._c(a, b); });
    };
    PercentKCalculationStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                var d = _d.value;
                a.indicatorColumn.item(c, d);
                c++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    PercentKCalculationStrategy.$t = markType(PercentKCalculationStrategy, 'PercentKCalculationStrategy', StreamingIndicatorCalculationStrategy.$);
    return PercentKCalculationStrategy;
}(StreamingIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FastStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FastStochasticOscillatorIndicatorStrategy, _super);
    function FastStochasticOscillatorIndicatorStrategy() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = new PercentKCalculationStrategy();
        return _this;
    }
    FastStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        return c;
    };
    FastStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = this.c.c(a, b);
        var d = 0;
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                a.indicatorColumn.item(d, e);
                d++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    FastStochasticOscillatorIndicatorStrategy.$t = markType(FastStochasticOscillatorIndicatorStrategy, 'FastStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return FastStochasticOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FastStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FastStochasticOscillatorIndicator, _super);
    function FastStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    FastStochasticOscillatorIndicator.prototype.get_qc = function () {
        return new FastStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    FastStochasticOscillatorIndicator.prototype.get_qp = function () {
        return FastStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FastStochasticOscillatorIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(FastStochasticOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(FastStochasticOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    FastStochasticOscillatorIndicator.prototype.qi = function () {
        return this.qx;
    };
    FastStochasticOscillatorIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    FastStochasticOscillatorIndicator.$t = markType(FastStochasticOscillatorIndicator, 'FastStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    FastStochasticOscillatorIndicator.qy = StrategyBasedIndicator.qu(14, FastStochasticOscillatorIndicator.$);
    return FastStochasticOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Fast Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*/
var IgrFastStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFastStochasticOscillatorIndicator, _super);
    function IgrFastStochasticOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrFastStochasticOscillatorIndicator.prototype.createImplementation = function () {
        return new FastStochasticOscillatorIndicator();
    };
    Object.defineProperty(IgrFastStochasticOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFastStochasticOscillatorIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current FastStochasticOscillatorIndicator object.
         * The typical, and initial, value for FastStochasticOscillatorIndicator periods is 14.
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFastStochasticOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFastStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFastStochasticOscillatorIndicatorModule() {
    }
    IgrFastStochasticOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrFastStochasticOscillatorIndicator", IgrFastStochasticOscillatorIndicator);
        TypeRegistrar.register("FastStochasticOscillatorIndicator", FastStochasticOscillatorIndicator.$type);
    };
    return IgrFastStochasticOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ForceIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ForceIndexIndicatorStrategy, _super);
    function ForceIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ForceIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        c.o(b.a.c);
        return c;
    };
    ForceIndexIndicatorStrategy.prototype._c = function (a) {
        var b, c, d, e, f;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    b = 0;
                    c = a.closeColumn;
                    d = a.volumeColumn;
                    e = a.indicatorColumn;
                    if (c != null && d != null) {
                        b = Math.min(c.count, d.count);
                    }
                    if (!(b > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, 0];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    f = 1;
                    _a.label = 3;
                case 3:
                    if (!(f < b))
                        return [3 /*break*/, 6];
                    return [4 /*yield*/, d.item(f) * (c.item(f) - c.item(f - 1))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++f;
                    return [3 /*break*/, 3];
                case 6: return [2 /*return*/];
            }
        });
    };
    ForceIndexIndicatorStrategy.prototype.c = function (a) {
        var _this = this;
        return toEnum(function () { return _this._c(a); });
    };
    ForceIndexIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = this.c(a);
        var d = a.period;
        var e = a.indicatorColumn;
        if (d != 0 && !isNaN_(d) && !isInfinity(d)) {
            c = b.a.b(c, a.period);
        }
        var f = 0;
        try {
            for (var _b = __values(fromEnum(c)), _d = _b.next(); !_d.done; _d = _b.next()) {
                var g = _d.value;
                e.item(f, g);
                ++f;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    ForceIndexIndicatorStrategy.$t = markType(ForceIndexIndicatorStrategy, 'ForceIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return ForceIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ForceIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ForceIndexIndicator, _super);
    function ForceIndexIndicator() {
        var _this = _super.call(this) || this;
        _this.pk = 1;
        return _this;
    }
    ForceIndexIndicator.prototype.get_qc = function () {
        return new ForceIndexIndicatorStrategy();
    };
    Object.defineProperty(ForceIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    ForceIndexIndicator.prototype.get_qp = function () {
        return ForceIndexIndicator.$;
    };
    Object.defineProperty(ForceIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ForceIndexIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(ForceIndexIndicator.qy));
        },
        set: function (a) {
            this.h(ForceIndexIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    ForceIndexIndicator.prototype.qi = function () {
        return this.qx;
    };
    ForceIndexIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    ForceIndexIndicator.$t = markType(ForceIndexIndicator, 'ForceIndexIndicator', StrategyBasedIndicator.$);
    ForceIndexIndicator.qy = StrategyBasedIndicator.qu(0, ForceIndexIndicator.$);
    return ForceIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Force Index indicator series.
 * Default required members: Close, Volume
*
* The `IgrForceIndexIndicator` represents a IgxDataChartComponent Force Index indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrForceIndexIndicator
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.financialSeries = new IgrForceIndexIndicator({name: "financialSeries"});
* this.financialSeries.dataSource = this.financialData;
* this.financialSeries.xAxis = this.timeXAxis;
* this.financialSeries.yAxis = this.numericYAxis;
* this.financialSeries.xAxisName = "timeXAxis";
* this.financialSeries.yAxisName = "numericYAxis";
* this.financialSeries.highMemberPath="High"
* this.financialSeries.lowMemberPath="Low"
* this.financialSeries.closeMemberPath="Close"
* this.financialSeries.openMemberPath="Open"
* this.financialSeries.volumeMemberPath="Volume"
* ```
*/
var IgrForceIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrForceIndexIndicator, _super);
    function IgrForceIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrForceIndexIndicator.prototype.createImplementation = function () {
        return new ForceIndexIndicator();
    };
    Object.defineProperty(IgrForceIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrForceIndexIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
         * The typical, and initial, value for ForceIndiex periods is 0.
        *
        * You can use the `period` property to get the moving average period of the current FullStochasticOscillatorIndicator object
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrForceIndexIndicator
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period= {30} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrForceIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrForceIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrForceIndexIndicatorModule() {
    }
    IgrForceIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrForceIndexIndicator", IgrForceIndexIndicator);
        TypeRegistrar.register("ForceIndexIndicator", ForceIndexIndicator.$type);
    };
    return IgrForceIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FullStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FullStochasticOscillatorIndicatorStrategy, _super);
    function FullStochasticOscillatorIndicatorStrategy() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = new PercentKCalculationStrategy();
        return _this;
    }
    FullStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    };
    FullStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = this.c.c(a, b);
        var d = b.a.b(c, a.shortPeriod);
        var e = 0;
        try {
            for (var _b = __values(fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                a.indicatorColumn.item(e, f);
                e++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    FullStochasticOscillatorIndicatorStrategy.$t = markType(FullStochasticOscillatorIndicatorStrategy, 'FullStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return FullStochasticOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FullStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FullStochasticOscillatorIndicator, _super);
    function FullStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    FullStochasticOscillatorIndicator.prototype.get_qc = function () {
        return new FullStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.get_qp = function () {
        return FullStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q2));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q2, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qi = function () {
        return this.qx;
    };
    FullStochasticOscillatorIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "smoothingPeriod", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q3));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q3, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qk = function () {
        return this.smoothingPeriod;
    };
    Object.defineProperty(FullStochasticOscillatorIndicator.prototype, "qz", {
        get: function () {
            return typeGetValue(this.c(FullStochasticOscillatorIndicator.q4));
        },
        set: function (a) {
            this.h(FullStochasticOscillatorIndicator.q4, a);
        },
        enumerable: true,
        configurable: true
    });
    FullStochasticOscillatorIndicator.prototype.qh = function () {
        return this.qz;
    };
    FullStochasticOscillatorIndicator.prototype.ps = function () {
        return this.qz;
    };
    FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    FullStochasticOscillatorIndicator.q2 = StrategyBasedIndicator.qu(14, FullStochasticOscillatorIndicator.$);
    FullStochasticOscillatorIndicator.q3 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
    FullStochasticOscillatorIndicator.q4 = StrategyBasedIndicator.qv(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
    return FullStochasticOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*
* The `IgrFullStochasticOscillatorIndicator` class represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFullStochasticOscillatorIndicator
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrFullStochasticOscillatorIndicator({name: "series"});
* this.series.dataSource = this.financialData;
* this.series.xAxis = this.timeXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "timeXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.highMemberPath="High"
* this.series.lowMemberPath="Low"
* this.series.closeMemberPath="Close"
* this.series.openMemberPath="Open"
* this.series.volumeMemberPath="Volume"
* ```
*/
var IgrFullStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFullStochasticOscillatorIndicator, _super);
    function IgrFullStochasticOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrFullStochasticOscillatorIndicator.prototype.createImplementation = function () {
        return new FullStochasticOscillatorIndicator();
    };
    Object.defineProperty(IgrFullStochasticOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFullStochasticOscillatorIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator periods is 14.
        *
        * You can use the `period` property for the moving average period of the current FullStochasticOscillatorIndicator object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFullStochasticOscillatorIndicator
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period={30} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFullStochasticOscillatorIndicator.prototype, "smoothingPeriod", {
        /**
         * Gets or sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator SmoothingPeriod is 3.
        *
        * The `smoothingPeriod` property to fets/sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFullStochasticOscillatorIndicator
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	smoothingPeriod={30} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.smoothingPeriod=30;
        * ```
        */
        get: function () {
            return this.i.smoothingPeriod;
        },
        set: function (v) {
            this.i.smoothingPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFullStochasticOscillatorIndicator.prototype, "triggerPeriod", {
        /**
         * Gets or sets the moving average TriggerPeriod for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator TriggerPeriod is 3.
        *
        * You can use the `period` to set the current moving average period.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFullStochasticOscillatorIndicator
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	triggerPeriod={30} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.triggerPeriod = 30;
        * ```
        */
        get: function () {
            return this.i.qz;
        },
        set: function (v) {
            this.i.qz = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFullStochasticOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFullStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFullStochasticOscillatorIndicatorModule() {
    }
    IgrFullStochasticOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrFullStochasticOscillatorIndicator", IgrFullStochasticOscillatorIndicator);
        TypeRegistrar.register("FullStochasticOscillatorIndicator", FullStochasticOscillatorIndicator.$type);
    };
    return IgrFullStochasticOscillatorIndicatorModule;
}());

/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
var IgrItemwiseStrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrItemwiseStrategyBasedIndicator, _super);
    function IgrItemwiseStrategyBasedIndicator(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrItemwiseStrategyBasedIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrItemwiseStrategyBasedIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemwiseStrategyCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemwiseStrategyCalculationStrategy, _super);
    function ItemwiseStrategyCalculationStrategy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        return _this;
    }
    ItemwiseStrategyCalculationStrategy.prototype.b = function (a, b) {
        return this.c.b(a, b);
    };
    ItemwiseStrategyCalculationStrategy.prototype.a = function (a, b) {
        var c = true;
        for (var d = a.calculateFrom; d < a.calculateFrom + a.calculateCount; d++) {
            c = this.c.a(a, b, d);
            if (!c) {
                return false;
            }
        }
        return c;
    };
    ItemwiseStrategyCalculationStrategy.$t = markType(ItemwiseStrategyCalculationStrategy, 'ItemwiseStrategyCalculationStrategy', IndicatorCalculationStrategy.$);
    return ItemwiseStrategyCalculationStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemwiseStrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemwiseStrategyBasedIndicator, _super);
    function ItemwiseStrategyBasedIndicator() {
        return _super.call(this) || this;
    }
    ItemwiseStrategyBasedIndicator.prototype.get_qc = function () {
        return new ItemwiseStrategyCalculationStrategy();
    };
    Object.defineProperty(ItemwiseStrategyBasedIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    ItemwiseStrategyBasedIndicator.prototype.qq = function () {
        _super.prototype.qq.call(this);
        this.qx = this.qy;
        this.qb.c = this.qx;
    };
    ItemwiseStrategyBasedIndicator.$t = markType(ItemwiseStrategyBasedIndicator, 'ItemwiseStrategyBasedIndicator', StrategyBasedIndicator.$);
    return ItemwiseStrategyBasedIndicator;
}(StrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemwiseIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemwiseIndicatorCalculationStrategy, _super);
    function ItemwiseIndicatorCalculationStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ItemwiseIndicatorCalculationStrategy.$t = markType(ItemwiseIndicatorCalculationStrategy, 'ItemwiseIndicatorCalculationStrategy');
    return ItemwiseIndicatorCalculationStrategy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarketFacilitationIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarketFacilitationIndexIndicatorStrategy, _super);
    function MarketFacilitationIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MarketFacilitationIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("VolumeColumn");
        return c;
    };
    MarketFacilitationIndexIndicatorStrategy.prototype.a = function (a, b, c) {
        a.indicatorColumn.item(c, b.i((a.highColumn.item(c) - a.lowColumn.item(c)) / a.volumeColumn.item(c)));
        return true;
    };
    MarketFacilitationIndexIndicatorStrategy.$t = markType(MarketFacilitationIndexIndicatorStrategy, 'MarketFacilitationIndexIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
    return MarketFacilitationIndexIndicatorStrategy;
}(ItemwiseIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarketFacilitationIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarketFacilitationIndexIndicator, _super);
    function MarketFacilitationIndexIndicator() {
        var _this = _super.call(this) || this;
        _this.pk = 1;
        return _this;
    }
    MarketFacilitationIndexIndicator.prototype.get_qy = function () {
        return new MarketFacilitationIndexIndicatorStrategy();
    };
    Object.defineProperty(MarketFacilitationIndexIndicator.prototype, "qy", {
        get: function () {
            return this.get_qy();
        },
        enumerable: true,
        configurable: true
    });
    MarketFacilitationIndexIndicator.prototype.get_qp = function () {
        return MarketFacilitationIndexIndicator.$;
    };
    Object.defineProperty(MarketFacilitationIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    MarketFacilitationIndexIndicator.$t = markType(MarketFacilitationIndexIndicator, 'MarketFacilitationIndexIndicator', ItemwiseStrategyBasedIndicator.$);
    return MarketFacilitationIndexIndicator;
}(ItemwiseStrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Market Facilitation Index indicator series.
 * The Market Facilitation Index (MFI) indicator is represented by
 * the difference of the high and the low for a bar divided by the volume.
 * Default required members: High, Low, Volume
*
* The Market Facilitation Index (MFI) indicator is represented by the difference of the high and the low for a bar divided by the volume.
*
* Example:
*/
var IgrMarketFacilitationIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMarketFacilitationIndexIndicator, _super);
    function IgrMarketFacilitationIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMarketFacilitationIndexIndicator.prototype.createImplementation = function () {
        return new MarketFacilitationIndexIndicator();
    };
    Object.defineProperty(IgrMarketFacilitationIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMarketFacilitationIndexIndicator;
}(IgrItemwiseStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrMarketFacilitationIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrMarketFacilitationIndexIndicatorModule() {
    }
    IgrMarketFacilitationIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrMarketFacilitationIndexIndicator", IgrMarketFacilitationIndexIndicator);
        TypeRegistrar.register("MarketFacilitationIndexIndicator", MarketFacilitationIndexIndicator.$type);
    };
    return IgrMarketFacilitationIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MassIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MassIndexIndicatorStrategy, _super);
    function MassIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MassIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.o(b.a.c);
        return c;
    };
    MassIndexIndicatorStrategy.prototype.c = function (a, b) {
        var c = new List$1(Number_$type, 0);
        for (var d = 0; d < (Math.min(a.count, b.count)); d++) {
            c.add(a.item(d) - b.item(d));
        }
        return c;
    };
    MassIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = 9;
        var d = a.highColumn;
        var e = a.lowColumn;
        var f = a.indicatorColumn;
        var g = getEnumerator(b.a.b(this.c(d, e), c));
        var h = getEnumerator(b.a.b(b.a.b(this.c(d, e), c), c));
        var i = new Array(c);
        for (var j = 0; j < c; j++) {
            i[j] = 0;
        }
        var k = 0;
        for (var l = 0; l < f.count; l++) {
            var m = l % c;
            k -= i[m];
            g.moveNext();
            h.moveNext();
            var n = b.i(g.current / h.current);
            k += n;
            f.item(l, k);
            i[m] = n;
        }
        return true;
    };
    MassIndexIndicatorStrategy.$t = markType(MassIndexIndicatorStrategy, 'MassIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return MassIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MassIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MassIndexIndicator, _super);
    function MassIndexIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MassIndexIndicator.prototype.get_qc = function () {
        return new MassIndexIndicatorStrategy();
    };
    Object.defineProperty(MassIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    MassIndexIndicator.prototype.get_qp = function () {
        return MassIndexIndicator.$;
    };
    Object.defineProperty(MassIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    MassIndexIndicator.$t = markType(MassIndexIndicator, 'MassIndexIndicator', StrategyBasedIndicator.$);
    return MassIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Mass Index indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Mass Index indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMassIndexIndicator
* 	name="series1"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMassIndexIndicator ({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "categoryXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.volumeMemberPath="Volume" ;
* this.series.highMemberPath= "High" ;
* this.series.lowMemberPath="Low" ;
* ```
*/
var IgrMassIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMassIndexIndicator, _super);
    function IgrMassIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMassIndexIndicator.prototype.createImplementation = function () {
        return new MassIndexIndicator();
    };
    Object.defineProperty(IgrMassIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMassIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrMassIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrMassIndexIndicatorModule() {
    }
    IgrMassIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrMassIndexIndicator", IgrMassIndexIndicator);
        TypeRegistrar.register("MassIndexIndicator", MassIndexIndicator.$type);
    };
    return IgrMassIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MedianPriceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MedianPriceIndicatorStrategy, _super);
    function MedianPriceIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MedianPriceIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        return c;
    };
    MedianPriceIndicatorStrategy.prototype.a = function (a, b, c) {
        a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c)) / 2);
        return true;
    };
    MedianPriceIndicatorStrategy.$t = markType(MedianPriceIndicatorStrategy, 'MedianPriceIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
    return MedianPriceIndicatorStrategy;
}(ItemwiseIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MedianPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MedianPriceIndicator, _super);
    function MedianPriceIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MedianPriceIndicator.prototype.get_qy = function () {
        return new MedianPriceIndicatorStrategy();
    };
    Object.defineProperty(MedianPriceIndicator.prototype, "qy", {
        get: function () {
            return this.get_qy();
        },
        enumerable: true,
        configurable: true
    });
    MedianPriceIndicator.prototype.get_qp = function () {
        return MedianPriceIndicator.$;
    };
    Object.defineProperty(MedianPriceIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    MedianPriceIndicator.$t = markType(MedianPriceIndicator, 'MedianPriceIndicator', ItemwiseStrategyBasedIndicator.$);
    return MedianPriceIndicator;
}(ItemwiseStrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Median Price indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Median Price indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMedianPriceIndicator
* 	name="series1"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMedianPriceIndicator({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.volumeMemberPath="Volume" ;
* this.series.highMemberPath="High";
* this.series.lowMemberPath="Low";
* ```
*/
var IgrMedianPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMedianPriceIndicator, _super);
    function IgrMedianPriceIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMedianPriceIndicator.prototype.createImplementation = function () {
        return new MedianPriceIndicator();
    };
    Object.defineProperty(IgrMedianPriceIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMedianPriceIndicator;
}(IgrItemwiseStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrMedianPriceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrMedianPriceIndicatorModule() {
    }
    IgrMedianPriceIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrMedianPriceIndicator", IgrMedianPriceIndicator);
        TypeRegistrar.register("MedianPriceIndicator", MedianPriceIndicator.$type);
    };
    return IgrMedianPriceIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MoneyFlowIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MoneyFlowIndexIndicatorStrategy, _super);
    function MoneyFlowIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MoneyFlowIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.add("VolumeColumn");
        return c;
    };
    MoneyFlowIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.typicalColumn.getEnumerator();
        var d = getEnumerator(a.volumeColumn);
        var e = a.period;
        var f = 0;
        var g = new Array(e);
        for (f = 0; f < e; f++) {
            g[f] = 0;
        }
        var h = 0;
        var i = new Array(e);
        for (f = 0; f < e; f++) {
            i[f] = 0;
        }
        var j = 0;
        var k = 0;
        f = 0;
        while (c.moveNext() && d.moveNext()) {
            var l = f % e;
            var m = c.current * d.current;
            h -= g[l];
            j -= i[l];
            switch (Math.sign(m - k)) {
                case -1:
                    g[l] = 0;
                    i[l] = m;
                    break;
                case 0:
                    g[l] = 0;
                    i[l] = 0;
                    break;
                case 1:
                    g[l] = m;
                    i[l] = 0;
                    break;
            }
            h += g[l];
            j += i[l];
            var n = b.i(100 * h / (h + j));
            a.indicatorColumn.item(f, n);
            k = m;
            ++f;
        }
        return true;
    };
    MoneyFlowIndexIndicatorStrategy.$t = markType(MoneyFlowIndexIndicatorStrategy, 'MoneyFlowIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return MoneyFlowIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MoneyFlowIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MoneyFlowIndexIndicator, _super);
    function MoneyFlowIndexIndicator() {
        var _this = _super.call(this) || this;
        _this.pk = 1;
        return _this;
    }
    MoneyFlowIndexIndicator.prototype.get_qc = function () {
        return new MoneyFlowIndexIndicatorStrategy();
    };
    Object.defineProperty(MoneyFlowIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    MoneyFlowIndexIndicator.prototype.get_qp = function () {
        return MoneyFlowIndexIndicator.$;
    };
    Object.defineProperty(MoneyFlowIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MoneyFlowIndexIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(MoneyFlowIndexIndicator.qy));
        },
        set: function (a) {
            this.h(MoneyFlowIndexIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    MoneyFlowIndexIndicator.prototype.qi = function () {
        return this.qx;
    };
    MoneyFlowIndexIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    MoneyFlowIndexIndicator.$t = markType(MoneyFlowIndexIndicator, 'MoneyFlowIndexIndicator', StrategyBasedIndicator.$);
    MoneyFlowIndexIndicator.qy = StrategyBasedIndicator.qu(14, MoneyFlowIndexIndicator.$);
    return MoneyFlowIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Money Flow Index indicator series.
 * Default required members: Close, Low, High, Volume
*
* Represents a Ignite UIDataChart Money Flow Index indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMoneyFlowIndexIndicator
* 	name="series1"
* 	openMemberPath="open"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"
* 	closeMemberPath="close"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrrMoneyFlowIndexIndicator ({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.volumeMemberPath="Volume" ;
* this.series.highMemberPath= "High" ;
* this.series.lowMemberPath="Low" ;
* this.series.closeMemberPath="close"
* ```
*/
var IgrMoneyFlowIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMoneyFlowIndexIndicator, _super);
    function IgrMoneyFlowIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMoneyFlowIndexIndicator.prototype.createImplementation = function () {
        return new MoneyFlowIndexIndicator();
    };
    Object.defineProperty(IgrMoneyFlowIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMoneyFlowIndexIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
         * The typical, and initial, value for MoneyFlowIndexIndicator periods is 14.
        *
        * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
        *
        * Example:
        *
        * ```ts
        * this.series.period = 14;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrMoneyFlowIndexIndicator
        * 	name="series1"
        * 	openMemberPath="open"
        * 	volumeMemberPath="Volume"
        * 	highMemberPath="High"
        * 	lowMemberPath="Low"
        * 	closeMemberPath="close"
        * 	period="14"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMoneyFlowIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrMoneyFlowIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrMoneyFlowIndexIndicatorModule() {
    }
    IgrMoneyFlowIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrMoneyFlowIndexIndicator", IgrMoneyFlowIndexIndicator);
        TypeRegistrar.register("MoneyFlowIndexIndicator", MoneyFlowIndexIndicator.$type);
    };
    return IgrMoneyFlowIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MovingAverageConvergenceDivergenceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MovingAverageConvergenceDivergenceIndicatorStrategy, _super);
    function MovingAverageConvergenceDivergenceIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MovingAverageConvergenceDivergenceIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.a.c);
        return c;
    };
    MovingAverageConvergenceDivergenceIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.typicalColumn;
        var d = a.indicatorColumn;
        var e = a.shortPeriod;
        var f = a.longPeriod;
        var g = getEnumerator(b.a.b(c, e));
        var h = getEnumerator(b.a.b(c, f));
        var i = 0;
        while (g.moveNext() && h.moveNext()) {
            var j = b.i(g.current - h.current);
            d.item(i, j);
            i++;
        }
        return true;
    };
    MovingAverageConvergenceDivergenceIndicatorStrategy.$t = markType(MovingAverageConvergenceDivergenceIndicatorStrategy, 'MovingAverageConvergenceDivergenceIndicatorStrategy', IndicatorCalculationStrategy.$);
    return MovingAverageConvergenceDivergenceIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MovingAverageConvergenceDivergenceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MovingAverageConvergenceDivergenceIndicator, _super);
    function MovingAverageConvergenceDivergenceIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 9;
        _this.pk = 1;
        return _this;
    }
    MovingAverageConvergenceDivergenceIndicator.prototype.get_qc = function () {
        return new MovingAverageConvergenceDivergenceIndicatorStrategy();
    };
    Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    MovingAverageConvergenceDivergenceIndicator.prototype.get_qp = function () {
        return MovingAverageConvergenceDivergenceIndicator.$;
    };
    Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.q0));
        },
        set: function (a) {
            this.h(MovingAverageConvergenceDivergenceIndicator.q0, a);
        },
        enumerable: true,
        configurable: true
    });
    MovingAverageConvergenceDivergenceIndicator.prototype.qk = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.qz));
        },
        set: function (a) {
            this.h(MovingAverageConvergenceDivergenceIndicator.qz, a);
        },
        enumerable: true,
        configurable: true
    });
    MovingAverageConvergenceDivergenceIndicator.prototype.qh = function () {
        return this.longPeriod;
    };
    Object.defineProperty(MovingAverageConvergenceDivergenceIndicator.prototype, "signalPeriod", {
        get: function () {
            return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.q1));
        },
        set: function (a) {
            this.h(MovingAverageConvergenceDivergenceIndicator.q1, a);
        },
        enumerable: true,
        configurable: true
    });
    MovingAverageConvergenceDivergenceIndicator.prototype.ps = function () {
        return this.signalPeriod;
    };
    MovingAverageConvergenceDivergenceIndicator.$t = markType(MovingAverageConvergenceDivergenceIndicator, 'MovingAverageConvergenceDivergenceIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    MovingAverageConvergenceDivergenceIndicator.q0 = StrategyBasedIndicator.qw(10, MovingAverageConvergenceDivergenceIndicator.$);
    MovingAverageConvergenceDivergenceIndicator.qz = StrategyBasedIndicator.qs(30, MovingAverageConvergenceDivergenceIndicator.$);
    MovingAverageConvergenceDivergenceIndicator.q1 = StrategyBasedIndicator.qv(9, MovingAverageConvergenceDivergenceIndicator.$, "SignalPeriod");
    return MovingAverageConvergenceDivergenceIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Moving Average Convergence/Divergence (MACD) indicator series.
 * Default required members: High, Low, Close
*
* Represents a Ignite UIDataChart Moving Average Convergence/Divergence (MACD) indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMovingAverageConvergenceDivergenceIndicator
* 	name="series1"
* 	openMemberPath="open"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"
* 	closeMemberPath="close"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMovingAverageConvergenceDivergenceIndicator ({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "categoryXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.openMemberPath = "open";
* this.series.highMemberPath = "high";
* this.series.lowMemberPath = "low";
* this.series.closeMemberPath = "close";
* ```
*/
var IgrMovingAverageConvergenceDivergenceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrMovingAverageConvergenceDivergenceIndicator, _super);
    function IgrMovingAverageConvergenceDivergenceIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrMovingAverageConvergenceDivergenceIndicator.prototype.createImplementation = function () {
        return new MovingAverageConvergenceDivergenceIndicator();
    };
    Object.defineProperty(IgrMovingAverageConvergenceDivergenceIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMovingAverageConvergenceDivergenceIndicator.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
         * The typical, and initial, value for short MACD periods is 10.
        *
        * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
        *
        * Example:
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrMovingAverageConvergenceDivergenceIndicator
        * 	name="series1"
        * 	openMemberPath="open"
        * 	volumeMemberPath="Volume"
        * 	highMemberPath="High"
        * 	lowMemberPath="Low"
        * 	closeMemberPath="close"
        * 	shortPeriod="30"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMovingAverageConvergenceDivergenceIndicator.prototype, "longPeriod", {
        /**
         * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
         * The typical, and initial, value for long MACD periods is 30.
        *
        * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
        *
        * Example:
        *
        * ```ts
        * this.series.longPeriod="30" ;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrMovingAverageConvergenceDivergenceIndicator
        * 	name="series1"
        * 	openMemberPath="open"
        * 	volumeMemberPath="Volume"
        * 	highMemberPath="High"
        * 	lowMemberPath="Low"
        * 	closeMemberPath="close"
        * 	longPeriod="30"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrMovingAverageConvergenceDivergenceIndicator.prototype, "signalPeriod", {
        /**
         * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
         * The typical, and initial, value for long PVO periods is 30.
        *
        * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
        *
        * Example:
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrMovingAverageConvergenceDivergenceIndicator
        * 	name="series1"
        * 	openMemberPath="open"
        * 	volumeMemberPath="Volume"
        * 	highMemberPath="High"
        * 	lowMemberPath="Low"
        * 	closeMemberPath="close"
        * 	signalPeriod="30"/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.signalPeriod;
        },
        set: function (v) {
            this.i.signalPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrMovingAverageConvergenceDivergenceIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrMovingAverageConvergenceDivergenceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrMovingAverageConvergenceDivergenceIndicatorModule() {
    }
    IgrMovingAverageConvergenceDivergenceIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrMovingAverageConvergenceDivergenceIndicator", IgrMovingAverageConvergenceDivergenceIndicator);
        TypeRegistrar.register("MovingAverageConvergenceDivergenceIndicator", MovingAverageConvergenceDivergenceIndicator.$type);
    };
    return IgrMovingAverageConvergenceDivergenceIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NegativeVolumeIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NegativeVolumeIndexIndicatorStrategy, _super);
    function NegativeVolumeIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NegativeVolumeIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    };
    NegativeVolumeIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.closeColumn;
        var d = a.volumeColumn;
        var e = a.indicatorColumn;
        var f = 0;
        var g = 0;
        var h = 0;
        if (e.count > 0) {
            e.item(0, f);
        }
        for (var i = 1; i < e.count; i++) {
            if (d.item(i) < d.item(i - 1)) {
                g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                if (h != 0) {
                    f += g * h;
                }
                else {
                    f += g;
                }
            }
            e.item(i, f);
            h = f;
        }
        return true;
    };
    NegativeVolumeIndexIndicatorStrategy.$t = markType(NegativeVolumeIndexIndicatorStrategy, 'NegativeVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return NegativeVolumeIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NegativeVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NegativeVolumeIndexIndicator, _super);
    function NegativeVolumeIndexIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NegativeVolumeIndexIndicator.prototype.get_qc = function () {
        return new NegativeVolumeIndexIndicatorStrategy();
    };
    Object.defineProperty(NegativeVolumeIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    NegativeVolumeIndexIndicator.prototype.get_qp = function () {
        return NegativeVolumeIndexIndicator.$;
    };
    Object.defineProperty(NegativeVolumeIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    NegativeVolumeIndexIndicator.$t = markType(NegativeVolumeIndexIndicator, 'NegativeVolumeIndexIndicator', StrategyBasedIndicator.$);
    return NegativeVolumeIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Negative Volume Index indicator (NVI) series.
 * Default required members: Close, Volume
*
* The `IgrNegativeVolumeIndexIndicator` (NVI) is a finacial indicator frequently used in combination with the PositiveVolumeIndexIndicator. This calculation can be used to identify bull markets. These two indicators are based on the premise that smart money trades on low volume days and less informed or overly optimistic investors trade on high volume days.
*
* Using this indicator requires setting both the `CloseMemberPath` and `VolumeMemberPath`.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*    <IgrOrdinalTimeXAxis name="xAxis" label="Date" />
*    <IgrNumericYAxis  name="yAxis" />
*
*     <IgrNegativeVolumeIndexIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		volumeMemberPath="Volume"
*         closeMemberPath = "Close"/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrNegativeVolumeIndexIndicator({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.volumeMemberPath= "volume" ;
* series.closeMemberPath = "close";
* ```
*/
var IgrNegativeVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNegativeVolumeIndexIndicator, _super);
    function IgrNegativeVolumeIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrNegativeVolumeIndexIndicator.prototype.createImplementation = function () {
        return new NegativeVolumeIndexIndicator();
    };
    Object.defineProperty(IgrNegativeVolumeIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrNegativeVolumeIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNegativeVolumeIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNegativeVolumeIndexIndicatorModule() {
    }
    IgrNegativeVolumeIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrNegativeVolumeIndexIndicator", IgrNegativeVolumeIndexIndicator);
        TypeRegistrar.register("NegativeVolumeIndexIndicator", NegativeVolumeIndexIndicator.$type);
    };
    return IgrNegativeVolumeIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OnBalanceVolumeIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OnBalanceVolumeIndicatorStrategy, _super);
    function OnBalanceVolumeIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OnBalanceVolumeIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    };
    OnBalanceVolumeIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.closeColumn;
        var d = a.volumeColumn;
        var e = a.indicatorColumn;
        var f = 0;
        if (c != null && d != null) {
            f = Math.min(c.count, d.count);
        }
        var g = 0;
        if (f > 0) {
            g = d.item(0);
            e.item(0, g);
        }
        for (var h = 1; h < f; ++h) {
            switch (Math.sign(c.item(h) - c.item(h - 1))) {
                case -1:
                    g -= d.item(h);
                    break;
                case 1:
                    g += d.item(h);
                    break;
            }
            e.item(h, g);
        }
        return true;
    };
    OnBalanceVolumeIndicatorStrategy.$t = markType(OnBalanceVolumeIndicatorStrategy, 'OnBalanceVolumeIndicatorStrategy', IndicatorCalculationStrategy.$);
    return OnBalanceVolumeIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OnBalanceVolumeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OnBalanceVolumeIndicator, _super);
    function OnBalanceVolumeIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OnBalanceVolumeIndicator.prototype.get_qc = function () {
        return new OnBalanceVolumeIndicatorStrategy();
    };
    Object.defineProperty(OnBalanceVolumeIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    OnBalanceVolumeIndicator.prototype.get_qp = function () {
        return OnBalanceVolumeIndicator.$;
    };
    Object.defineProperty(OnBalanceVolumeIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    OnBalanceVolumeIndicator.$t = markType(OnBalanceVolumeIndicator, 'OnBalanceVolumeIndicator', StrategyBasedIndicator.$);
    return OnBalanceVolumeIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent On Balance Bolume indicator series.
 * Default required members: Close, Volume
*
* You can use the `IgrOnBalanceVolumeIndicator` to calculate a running total of sales volume for a stock.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrOnBalanceVolumeIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		closeMemberPath="Close"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrOnBalanceVolumeIndicator({ name: "series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "xAxis";
* this.series.yAxisName = "yAxis";
* this.series.openMemberPath = "open";
* this.series.highMemberPath = "high";
* this.series.lowMemberPath = "low";
* this.series.closeMemberPath = "close";
* ```
*/
var IgrOnBalanceVolumeIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrOnBalanceVolumeIndicator, _super);
    function IgrOnBalanceVolumeIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrOnBalanceVolumeIndicator.prototype.createImplementation = function () {
        return new OnBalanceVolumeIndicator();
    };
    Object.defineProperty(IgrOnBalanceVolumeIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrOnBalanceVolumeIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrOnBalanceVolumeIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrOnBalanceVolumeIndicatorModule() {
    }
    IgrOnBalanceVolumeIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrOnBalanceVolumeIndicator", IgrOnBalanceVolumeIndicator);
        TypeRegistrar.register("OnBalanceVolumeIndicator", OnBalanceVolumeIndicator.$type);
    };
    return IgrOnBalanceVolumeIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentagePriceOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentagePriceOscillatorIndicatorStrategy, _super);
    function PercentagePriceOscillatorIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentagePriceOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(b.g.c);
        c.o(b.e.c);
        return c;
    };
    PercentagePriceOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.indicatorColumn;
        var d = getEnumerator(b.g.b(a));
        var e = getEnumerator(b.e.b(a));
        var f = 0;
        while (d.moveNext() && e.moveNext()) {
            var g = b.i(100 * (d.current - e.current) / e.current);
            c.item(f, g);
            ++f;
        }
        return true;
    };
    PercentagePriceOscillatorIndicatorStrategy.$t = markType(PercentagePriceOscillatorIndicatorStrategy, 'PercentagePriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return PercentagePriceOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentagePriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentagePriceOscillatorIndicator, _super);
    function PercentagePriceOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentagePriceOscillatorIndicator.prototype.get_qc = function () {
        return new PercentagePriceOscillatorIndicatorStrategy();
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.get_qp = function () {
        return PercentagePriceOscillatorIndicator.$;
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(PercentagePriceOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.qk = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qx));
        },
        set: function (a) {
            this.h(PercentagePriceOscillatorIndicator.qx, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.qh = function () {
        return this.longPeriod;
    };
    PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    PercentagePriceOscillatorIndicator.qy = StrategyBasedIndicator.qw(10, PercentagePriceOscillatorIndicator.$);
    PercentagePriceOscillatorIndicator.qx = StrategyBasedIndicator.qs(30, PercentagePriceOscillatorIndicator.$);
    return PercentagePriceOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent percentage price oscillator series.
 * Default required members: High, Low, Volume
*
* You can use the `IgrPercentagePriceOscillatorIndicator` to show the difference between two moving averages.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrPercentagePriceOscillatorIndicator
*     name="series"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrPercentagePriceOscillatorIndicator({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.xAxis = this.categoryXAxis;
* series.yAxis = this.numericYAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* ```
*/
var IgrPercentagePriceOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPercentagePriceOscillatorIndicator, _super);
    function IgrPercentagePriceOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrPercentagePriceOscillatorIndicator.prototype.createImplementation = function () {
        return new PercentagePriceOscillatorIndicator();
    };
    Object.defineProperty(IgrPercentagePriceOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPercentagePriceOscillatorIndicator.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current PercentagePriceOscillatorIndicator object.
         * The typical, and initial, value for short PPO periods is 10.
        *
        * You can use the `shortPeriod` to set the short moving average period.
        *
        * ```ts
        * this.series.shortPeriod = 10;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *    <IgrPercentagePriceOscillatorIndicator
        *     name="series"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     shortPeriod = {10}/>
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPercentagePriceOscillatorIndicator.prototype, "longPeriod", {
        /**
         * Gets or sets the long moving average period for the current PercentagePriceOscillatorIndicator object.
         * The typical, and initial, value for long PVO periods is 30.
        *
        * You can use the `longPeriod` to set the long moving average period.
        *
        * ```ts
        * this.series.longPeriod = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *    <IgrPercentagePriceOscillatorIndicator
        *     name="series"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        * 	longPeriod = {30} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPercentagePriceOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPercentagePriceOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPercentagePriceOscillatorIndicatorModule() {
    }
    IgrPercentagePriceOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrPercentagePriceOscillatorIndicator", IgrPercentagePriceOscillatorIndicator);
        TypeRegistrar.register("PercentagePriceOscillatorIndicator", PercentagePriceOscillatorIndicator.$type);
    };
    return IgrPercentagePriceOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentageVolumeOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentageVolumeOscillatorIndicatorStrategy, _super);
    function PercentageVolumeOscillatorIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentageVolumeOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(b.h.c);
        c.o(b.f.c);
        return c;
    };
    PercentageVolumeOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(b.h.b(a));
        var d = getEnumerator(b.f.b(a));
        var e = a.indicatorColumn;
        var f = 0;
        while (c.moveNext() && d.moveNext()) {
            var g = b.i(100 * (c.current - d.current) / d.current);
            e.item(f, g);
            ++f;
        }
        return true;
    };
    PercentageVolumeOscillatorIndicatorStrategy.$t = markType(PercentageVolumeOscillatorIndicatorStrategy, 'PercentageVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return PercentageVolumeOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PercentageVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PercentageVolumeOscillatorIndicator, _super);
    function PercentageVolumeOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentageVolumeOscillatorIndicator.prototype.get_qc = function () {
        return new PercentageVolumeOscillatorIndicatorStrategy();
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.get_qp = function () {
        return PercentageVolumeOscillatorIndicator.$;
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(PercentageVolumeOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.qk = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(PercentageVolumeOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.qx));
        },
        set: function (a) {
            this.h(PercentageVolumeOscillatorIndicator.qx, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentageVolumeOscillatorIndicator.prototype.qh = function () {
        return this.longPeriod;
    };
    PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    PercentageVolumeOscillatorIndicator.qy = StrategyBasedIndicator.qw(10, PercentageVolumeOscillatorIndicator.$);
    PercentageVolumeOscillatorIndicator.qx = StrategyBasedIndicator.qs(30, PercentageVolumeOscillatorIndicator.$);
    return PercentageVolumeOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Percentage Volume Oscillator (PVO) series.
 * Default required members: Volume
*
* You can use the `IgrPercentageVolumeOscillatorIndicator` to show the percentage difference volume.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*    <IgrPercentageVolumeOscillatorIndicator
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrPercentageVolumeOscillatorIndicator({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.xAxis = this.categoryXAxis;
* series.yAxis = this.numericYAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* ```
*/
var IgrPercentageVolumeOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPercentageVolumeOscillatorIndicator, _super);
    function IgrPercentageVolumeOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrPercentageVolumeOscillatorIndicator.prototype.createImplementation = function () {
        return new PercentageVolumeOscillatorIndicator();
    };
    Object.defineProperty(IgrPercentageVolumeOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPercentageVolumeOscillatorIndicator.prototype, "shortPeriod", {
        /**
         * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
         * The typical, and initial, value for short PVO periods is 10.
        *
        * You can use the `shortPeriod` to set the short moving average period.
        *
        * ```ts
        * this.series.shortPeriod = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrPercentageVolumeOscillatorIndicator
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     shortPeriod = {30} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.shortPeriod;
        },
        set: function (v) {
            this.i.shortPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPercentageVolumeOscillatorIndicator.prototype, "longPeriod", {
        /**
         * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
         * The typical, and initial, value for long PVO periods is 30.
        *
        * You can use the `longPeriod` to set the long moving average period.
        *
        * ```ts
        * this.series.longPeriod = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *    <IgrPercentageVolumeOscillatorIndicator
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     longPeriod = {30} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.longPeriod;
        },
        set: function (v) {
            this.i.longPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPercentageVolumeOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPercentageVolumeOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPercentageVolumeOscillatorIndicatorModule() {
    }
    IgrPercentageVolumeOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrPercentageVolumeOscillatorIndicator", IgrPercentageVolumeOscillatorIndicator);
        TypeRegistrar.register("PercentageVolumeOscillatorIndicator", PercentageVolumeOscillatorIndicator.$type);
    };
    return IgrPercentageVolumeOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PositiveVolumeIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PositiveVolumeIndexIndicatorStrategy, _super);
    function PositiveVolumeIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PositiveVolumeIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    };
    PositiveVolumeIndexIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.closeColumn;
        var d = a.volumeColumn;
        var e = a.indicatorColumn;
        var f = 0;
        var g = 0;
        var h = 0;
        if (e.count > 0) {
            e.item(0, f);
        }
        for (var i = 1; i < e.count; i++) {
            if (d.item(i) > d.item(i - 1)) {
                g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                if (h != 0) {
                    f += g * h;
                }
                else {
                    f += g;
                }
            }
            e.item(i, f);
            h = f;
        }
        return true;
    };
    PositiveVolumeIndexIndicatorStrategy.$t = markType(PositiveVolumeIndexIndicatorStrategy, 'PositiveVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);
    return PositiveVolumeIndexIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PositiveVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PositiveVolumeIndexIndicator, _super);
    function PositiveVolumeIndexIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PositiveVolumeIndexIndicator.prototype.get_qc = function () {
        return new PositiveVolumeIndexIndicatorStrategy();
    };
    Object.defineProperty(PositiveVolumeIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    PositiveVolumeIndexIndicator.prototype.get_qp = function () {
        return PositiveVolumeIndexIndicator.$;
    };
    Object.defineProperty(PositiveVolumeIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    PositiveVolumeIndexIndicator.$t = markType(PositiveVolumeIndexIndicator, 'PositiveVolumeIndexIndicator', StrategyBasedIndicator.$);
    return PositiveVolumeIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Positive Volume Index (PVI) indicator series.
 * Default required members: Close, Volume
*
* You can use the `IgrPositiveVolumeIndexIndicator` with the 'NegativeVolumeIndexIndicator' to identify bull markets.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrPositiveVolumeIndexIndicator
*      name="series1"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrPositiveVolumeIndexIndicator ({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.xAxis = this.categoryXAxis;
* series.yAxis = this.numericYAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* ```
*/
var IgrPositiveVolumeIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPositiveVolumeIndexIndicator, _super);
    function IgrPositiveVolumeIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrPositiveVolumeIndexIndicator.prototype.createImplementation = function () {
        return new PositiveVolumeIndexIndicator();
    };
    Object.defineProperty(IgrPositiveVolumeIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPositiveVolumeIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPositiveVolumeIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPositiveVolumeIndexIndicatorModule() {
    }
    IgrPositiveVolumeIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrPositiveVolumeIndexIndicator", IgrPositiveVolumeIndexIndicator);
        TypeRegistrar.register("PositiveVolumeIndexIndicator", PositiveVolumeIndexIndicator.$type);
    };
    return IgrPositiveVolumeIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PriceVolumeTrendIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceVolumeTrendIndicatorStrategy, _super);
    function PriceVolumeTrendIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PriceVolumeTrendIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("VolumeColumn");
        c.add("CloseColumn");
        return c;
    };
    PriceVolumeTrendIndicatorStrategy.prototype.a = function (a, b) {
        var c = 0;
        var d = a.indicatorColumn;
        var e = a.volumeColumn;
        var f = a.closeColumn;
        var g = a.count;
        if (g > 0) {
            d.item(0, c);
        }
        for (var h = 1; h < g; ++h) {
            c = c + b.i(e.item(h) * (f.item(h) - f.item(h - 1)) / f.item(h - 1));
            d.item(h, c);
        }
        return true;
    };
    PriceVolumeTrendIndicatorStrategy.$t = markType(PriceVolumeTrendIndicatorStrategy, 'PriceVolumeTrendIndicatorStrategy', IndicatorCalculationStrategy.$);
    return PriceVolumeTrendIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PriceVolumeTrendIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceVolumeTrendIndicator, _super);
    function PriceVolumeTrendIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PriceVolumeTrendIndicator.prototype.get_qc = function () {
        return new PriceVolumeTrendIndicatorStrategy();
    };
    Object.defineProperty(PriceVolumeTrendIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    PriceVolumeTrendIndicator.prototype.get_qp = function () {
        return PriceVolumeTrendIndicator.$;
    };
    Object.defineProperty(PriceVolumeTrendIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    PriceVolumeTrendIndicator.$t = markType(PriceVolumeTrendIndicator, 'PriceVolumeTrendIndicator', StrategyBasedIndicator.$);
    return PriceVolumeTrendIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Price Volume Trend Indicator series.
 * Default required members: Volume, Close
*
* You can use the `IgrPriceVolumeTrendIndicator` to measure money flow by adding or subtracting a portion of the daily volume.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrPriceVolumeTrendIndicator
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrPriceVolumeTrendIndicator({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.xAxis = this.categoryXAxis;
* series.yAxis = this.numericYAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* series.volumeMemberPath="Volume" ;
* ```
*/
var IgrPriceVolumeTrendIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPriceVolumeTrendIndicator, _super);
    function IgrPriceVolumeTrendIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrPriceVolumeTrendIndicator.prototype.createImplementation = function () {
        return new PriceVolumeTrendIndicator();
    };
    Object.defineProperty(IgrPriceVolumeTrendIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPriceVolumeTrendIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPriceVolumeTrendIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPriceVolumeTrendIndicatorModule() {
    }
    IgrPriceVolumeTrendIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrPriceVolumeTrendIndicator", IgrPriceVolumeTrendIndicator);
        TypeRegistrar.register("PriceVolumeTrendIndicator", PriceVolumeTrendIndicator.$type);
    };
    return IgrPriceVolumeTrendIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RateOfChangeAndMomentumIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RateOfChangeAndMomentumIndicatorStrategy, _super);
    function RateOfChangeAndMomentumIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RateOfChangeAndMomentumIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        return c;
    };
    RateOfChangeAndMomentumIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = a.closeColumn;
        var d = a.indicatorColumn;
        var e = a.period;
        var f = 0;
        var g = new Array(e);
        for (f = 0; f < e; f++) {
            g[f] = 0;
        }
        f = 0;
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                var i = f % e;
                var j = b.i(100 * (h - g[i]) / g[i]);
                d.item(f, j);
                g[i] = h;
                ++f;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    RateOfChangeAndMomentumIndicatorStrategy.$t = markType(RateOfChangeAndMomentumIndicatorStrategy, 'RateOfChangeAndMomentumIndicatorStrategy', IndicatorCalculationStrategy.$);
    return RateOfChangeAndMomentumIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RateOfChangeAndMomentumIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RateOfChangeAndMomentumIndicator, _super);
    function RateOfChangeAndMomentumIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RateOfChangeAndMomentumIndicator.prototype.get_qc = function () {
        return new RateOfChangeAndMomentumIndicatorStrategy();
    };
    Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    RateOfChangeAndMomentumIndicator.prototype.get_qp = function () {
        return RateOfChangeAndMomentumIndicator.$;
    };
    Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RateOfChangeAndMomentumIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(RateOfChangeAndMomentumIndicator.qy));
        },
        set: function (a) {
            this.h(RateOfChangeAndMomentumIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    RateOfChangeAndMomentumIndicator.prototype.qi = function () {
        return this.qx;
    };
    RateOfChangeAndMomentumIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    RateOfChangeAndMomentumIndicator.$t = markType(RateOfChangeAndMomentumIndicator, 'RateOfChangeAndMomentumIndicator', StrategyBasedIndicator.$);
    RateOfChangeAndMomentumIndicator.qy = StrategyBasedIndicator.qu(14, RateOfChangeAndMomentumIndicator.$);
    return RateOfChangeAndMomentumIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Rate of Change and Momentum indicator series.
 * Default required members: Close
*
* `IgrRateOfChangeAndMomentumIndicator` class represents a Rate of Change and Momentum indicator series for the IgxDataChartComponent.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRateOfChangeAndMomentumIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrRateOfChangeAndMomentumIndicator({name :"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrRateOfChangeAndMomentumIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRateOfChangeAndMomentumIndicator, _super);
    function IgrRateOfChangeAndMomentumIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrRateOfChangeAndMomentumIndicator.prototype.createImplementation = function () {
        return new RateOfChangeAndMomentumIndicator();
    };
    Object.defineProperty(IgrRateOfChangeAndMomentumIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRateOfChangeAndMomentumIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
         * The typical, and initial, value for AverageTrueRange periods is 14.
        *
        * You can use the `period` property for the current AverageTrueRangeSeries object.
        *
        * The typical, and initial, value for AverageTrueRange periods is 14.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRateOfChangeAndMomentumIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        * 		volumeMemberPath="Volume"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period=30 />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrRateOfChangeAndMomentumIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRateOfChangeAndMomentumIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRateOfChangeAndMomentumIndicatorModule() {
    }
    IgrRateOfChangeAndMomentumIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrRateOfChangeAndMomentumIndicator", IgrRateOfChangeAndMomentumIndicator);
        TypeRegistrar.register("RateOfChangeAndMomentumIndicator", RateOfChangeAndMomentumIndicator.$type);
    };
    return IgrRateOfChangeAndMomentumIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RelativeStrengthIndexIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RelativeStrengthIndexIndicatorStrategy, _super);
    function RelativeStrengthIndexIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RelativeStrengthIndexIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        return c;
    };
    RelativeStrengthIndexIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(this.c(a, b))), _d = _b.next(); !_d.done; _d = _b.next()) {
                var d = _d.value;
                a.indicatorColumn.item(c, d);
                c++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    RelativeStrengthIndexIndicatorStrategy.prototype._c = function (a, b) {
        var c, d, e, f, g, h, i, j, k, l, m, n, o, p;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = a.period;
                    d = 2 / (c + 1);
                    e = 0;
                    f = 0;
                    g = a.indicatorColumn;
                    h = a.closeColumn;
                    if (!(g.count > 0))
                        return [3 /*break*/, 2];
                    return [4 /*yield*/, 0];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    i = 1;
                    _a.label = 3;
                case 3:
                    if (!(i < Math.min(a.period, g.count)))
                        return [3 /*break*/, 6];
                    j = h.item(i) - h.item(i - 1);
                    k = j > 0 ? j : 0;
                    l = j > 0 ? 0 : -j;
                    e += k / (c - 1);
                    f += l / (c - 1);
                    return [4 /*yield*/, 0];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++i;
                    return [3 /*break*/, 3];
                case 6:
                    m = a.period;
                    _a.label = 7;
                case 7:
                    if (!(m < g.count))
                        return [3 /*break*/, 10];
                    n = h.item(m) - h.item(m - 1);
                    o = n > 0 ? n : 0;
                    p = n > 0 ? 0 : -n;
                    e = (e * (c - 1) + o) / c;
                    f = (f * (c - 1) + p) / c;
                    return [4 /*yield*/, b.i(e != 0 ? 100 * e / (e + f) : 0)];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    ++m;
                    return [3 /*break*/, 7];
                case 10: return [2 /*return*/];
            }
        });
    };
    RelativeStrengthIndexIndicatorStrategy.prototype.c = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._c(a, b); });
    };
    RelativeStrengthIndexIndicatorStrategy.$t = markType(RelativeStrengthIndexIndicatorStrategy, 'RelativeStrengthIndexIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);
    return RelativeStrengthIndexIndicatorStrategy;
}(StreamingIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RelativeStrengthIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RelativeStrengthIndexIndicator, _super);
    function RelativeStrengthIndexIndicator() {
        var _this = _super.call(this) || this;
        _this.pk = 1;
        return _this;
    }
    RelativeStrengthIndexIndicator.prototype.get_qc = function () {
        return new RelativeStrengthIndexIndicatorStrategy();
    };
    Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    RelativeStrengthIndexIndicator.prototype.get_qp = function () {
        return RelativeStrengthIndexIndicator.$;
    };
    Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RelativeStrengthIndexIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(RelativeStrengthIndexIndicator.qy));
        },
        set: function (a) {
            this.h(RelativeStrengthIndexIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    RelativeStrengthIndexIndicator.prototype.qi = function () {
        return this.qx;
    };
    RelativeStrengthIndexIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    RelativeStrengthIndexIndicator.$t = markType(RelativeStrengthIndexIndicator, 'RelativeStrengthIndexIndicator', StrategyBasedIndicator.$);
    RelativeStrengthIndexIndicator.qy = StrategyBasedIndicator.qu(14, RelativeStrengthIndexIndicator.$);
    return RelativeStrengthIndexIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Relative Strength Index indicator series.
 * Default required members: Close
*
* The `IgrRelativeStrengthIndexIndicator` class represents Relative Strength Index indicator series for the IgxDataChartComponent .
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRelativeStrengthIndexIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrRelativeStrengthIndexIndicator({name :"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* ```
*/
var IgrRelativeStrengthIndexIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRelativeStrengthIndexIndicator, _super);
    function IgrRelativeStrengthIndexIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrRelativeStrengthIndexIndicator.prototype.createImplementation = function () {
        return new RelativeStrengthIndexIndicator();
    };
    Object.defineProperty(IgrRelativeStrengthIndexIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRelativeStrengthIndexIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current RelativeStrengthIndexIndicator object.
         * The typical, and initial, value for RSI periods is 14.
        *
        * You can use the `period` property for the current RelativeStrengthIndexIndicator object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRelativeStrengthIndexIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        * 		volumeMemberPath="Volume"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period=30 />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrRelativeStrengthIndexIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRelativeStrengthIndexIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRelativeStrengthIndexIndicatorModule() {
    }
    IgrRelativeStrengthIndexIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrRelativeStrengthIndexIndicator", IgrRelativeStrengthIndexIndicator);
        TypeRegistrar.register("RelativeStrengthIndexIndicator", RelativeStrengthIndexIndicator.$type);
    };
    return IgrRelativeStrengthIndexIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SlowStochasticOscillatorIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SlowStochasticOscillatorIndicatorStrategy, _super);
    function SlowStochasticOscillatorIndicatorStrategy() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = new PercentKCalculationStrategy();
        return _this;
    }
    SlowStochasticOscillatorIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    };
    SlowStochasticOscillatorIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = this.c.c(a, b);
        var d = b.a.b(c, 3);
        var e = 0;
        try {
            for (var _b = __values(fromEnum(d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                a.indicatorColumn.item(e, f);
                e++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    SlowStochasticOscillatorIndicatorStrategy.$t = markType(SlowStochasticOscillatorIndicatorStrategy, 'SlowStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);
    return SlowStochasticOscillatorIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SlowStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SlowStochasticOscillatorIndicator, _super);
    function SlowStochasticOscillatorIndicator() {
        var _this = _super.call(this) || this;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 10;
        _this.trendLinePeriod = 3;
        return _this;
    }
    SlowStochasticOscillatorIndicator.prototype.get_qc = function () {
        return new SlowStochasticOscillatorIndicatorStrategy();
    };
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    SlowStochasticOscillatorIndicator.prototype.get_qp = function () {
        return SlowStochasticOscillatorIndicator.$;
    };
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SlowStochasticOscillatorIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(SlowStochasticOscillatorIndicator.qy));
        },
        set: function (a) {
            this.h(SlowStochasticOscillatorIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    SlowStochasticOscillatorIndicator.prototype.qi = function () {
        return this.qx;
    };
    SlowStochasticOscillatorIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    SlowStochasticOscillatorIndicator.$t = markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
    SlowStochasticOscillatorIndicator.qy = StrategyBasedIndicator.qu(14, SlowStochasticOscillatorIndicator.$);
    return SlowStochasticOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Slow Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*
* `IgrSlowStochasticOscillatorIndicator` (SSO) displays the closing price relative to the high-low range over a given period of time. There are three types of Stochastic Oscillators: Fast, Slow, and Full. The Stochastic Oscillator is a momentum indicator that shows the relation of the current close price relative to the high/low range over a given time period using a scale of 0 to 100. It is based on the premise that prices will close near 100 in a rising market and closer to 0 in a declining market.
*
* The Fast Stochastic Oscillator Indicator is used to identify buying or selling divergences. The Slow Stochastic Oscillator uses a 3-day SMA and the Full Stochastic Oscillator is the Slow Stochastic Oscillator with time period.
*
* Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `VolumeMemberPath`.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrSlowStochasticOscillatorIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         volumeMemberPath="Volume"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrSlowStochasticOscillatorIndicator({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.volumeMemberPath = "Volume";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* this.chart.series.add(series);
* ```
*/
var IgrSlowStochasticOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSlowStochasticOscillatorIndicator, _super);
    function IgrSlowStochasticOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrSlowStochasticOscillatorIndicator.prototype.createImplementation = function () {
        return new SlowStochasticOscillatorIndicator();
    };
    Object.defineProperty(IgrSlowStochasticOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSlowStochasticOscillatorIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current SlowStochasticOscillatorIndicator object.
         * The typical, and initial, value for SlowStochasticOscillatorIndicator periods is 14.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrSlowStochasticOscillatorIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         volumeMemberPath="Volume"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period={10} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSlowStochasticOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSlowStochasticOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSlowStochasticOscillatorIndicatorModule() {
    }
    IgrSlowStochasticOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrSlowStochasticOscillatorIndicator", IgrSlowStochasticOscillatorIndicator);
        TypeRegistrar.register("SlowStochasticOscillatorIndicator", SlowStochasticOscillatorIndicator.$type);
    };
    return IgrSlowStochasticOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StandardDeviationIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StandardDeviationIndicatorStrategy, _super);
    function StandardDeviationIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StandardDeviationIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.d.c);
        return c;
    };
    StandardDeviationIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(b.d.b(a.typicalColumn, a.period));
        var d = a.indicatorColumn;
        var e = 0;
        while (c.moveNext()) {
            d.item(e, c.current);
            e++;
        }
        return true;
    };
    StandardDeviationIndicatorStrategy.$t = markType(StandardDeviationIndicatorStrategy, 'StandardDeviationIndicatorStrategy', IndicatorCalculationStrategy.$);
    return StandardDeviationIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StandardDeviationIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StandardDeviationIndicator, _super);
    function StandardDeviationIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StandardDeviationIndicator.prototype.get_qc = function () {
        return new StandardDeviationIndicatorStrategy();
    };
    Object.defineProperty(StandardDeviationIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    StandardDeviationIndicator.prototype.get_qp = function () {
        return StandardDeviationIndicator.$;
    };
    Object.defineProperty(StandardDeviationIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StandardDeviationIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(StandardDeviationIndicator.qy));
        },
        set: function (a) {
            this.h(StandardDeviationIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    StandardDeviationIndicator.prototype.qi = function () {
        return this.qx;
    };
    StandardDeviationIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    StandardDeviationIndicator.$t = markType(StandardDeviationIndicator, 'StandardDeviationIndicator', StrategyBasedIndicator.$);
    StandardDeviationIndicator.qy = StrategyBasedIndicator.qu(20, StandardDeviationIndicator.$);
    return StandardDeviationIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Standard Deviation indicator series.
 * Default required members: High, Low, Close
*
* `IgrStandardDeviationIndicator` (SDI) measures statistical variation in stock prices or volatility. The difference between an individual security’s closing price and the average security closing price is called the dispersion. The larger the dispersion is the higher the standard deviation will be and therefore the volatility. The smaller the dispersion is (the difference between an individual closing price and the average price), the smaller the standard deviation and the lower the price volatility.
*
* Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `CloseMemberPath`.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrStandardDeviationIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		closeMemberPath="Close"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrStandardDeviationIndicator({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.closeMemberPath="Close";
* series.highMemberPath="High";
* series.lowMemberPath="Low";
* ```
*/
var IgrStandardDeviationIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStandardDeviationIndicator, _super);
    function IgrStandardDeviationIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrStandardDeviationIndicator.prototype.createImplementation = function () {
        return new StandardDeviationIndicator();
    };
    Object.defineProperty(IgrStandardDeviationIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStandardDeviationIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current StandardDeviationIndicator object.
         * The typical, and initial, value for STDEV periods is 20.
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStandardDeviationIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStandardDeviationIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStandardDeviationIndicatorModule() {
    }
    IgrStandardDeviationIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrStandardDeviationIndicator", IgrStandardDeviationIndicator);
        TypeRegistrar.register("StandardDeviationIndicator", StandardDeviationIndicator.$type);
    };
    return IgrStandardDeviationIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StochRSIIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StochRSIIndicatorStrategy, _super);
    function StochRSIIndicatorStrategy() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = new RelativeStrengthIndexIndicatorStrategy();
        return _this;
    }
    StochRSIIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        return c;
    };
    StochRSIIndicatorStrategy.prototype.a = function (a, b) {
        var c = getEnumerator(this.c.c(a, b));
        var d = a.period;
        var e = 0;
        var f = new Array(d);
        for (e = 0; e < d; e++) {
            f[e] = 0;
        }
        e = 0;
        while (c.moveNext()) {
            var g = Math.min(d, e);
            var h = -1.7976931348623157E+308;
            var i = 1.7976931348623157E+308;
            var j = e % d;
            for (var k = 0; k < g; k++) {
                if (!isNaN_(f[g - k - 1])) {
                    h = Math.max(h, f[g - k - 1]);
                }
                if (!isNaN_(f[g - k - 1])) {
                    i = Math.min(i, f[g - k - 1]);
                }
            }
            f[j] = c.current;
            var l = b.i((c.current - i) / (h - i));
            a.indicatorColumn.item(e, l);
            e++;
        }
        return true;
    };
    StochRSIIndicatorStrategy.$t = markType(StochRSIIndicatorStrategy, 'StochRSIIndicatorStrategy', IndicatorCalculationStrategy.$);
    return StochRSIIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StochRSIIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StochRSIIndicator, _super);
    function StochRSIIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StochRSIIndicator.prototype.get_qc = function () {
        return new StochRSIIndicatorStrategy();
    };
    Object.defineProperty(StochRSIIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    StochRSIIndicator.prototype.get_qp = function () {
        return StochRSIIndicator.$;
    };
    Object.defineProperty(StochRSIIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StochRSIIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(StochRSIIndicator.qy));
        },
        set: function (a) {
            this.h(StochRSIIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    StochRSIIndicator.prototype.qi = function () {
        return this.qx;
    };
    StochRSIIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    StochRSIIndicator.$t = markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
    StochRSIIndicator.qy = StrategyBasedIndicator.qu(14, StochRSIIndicator.$);
    return StochRSIIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent StochRSI indicator series.
 * Default required members: Close
*
* `IgrStochRSIIndicator` or Stochastic Relative Strength IndexI Indicator (SRSI) measures when a security is overbought or oversold within a specified period of time. The values range from 0 to 1. The StochRSI Indicator is calculated by applying the Stochastic Oscillator formula to RelativeStrengthIndexIndicator (RSI) data.
*
* Using this indicator requires setting the `CloseMemberPath`.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrOrdinalTimeXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrStochRSIIndicator
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	closeMemberPath="Close"/>
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrStochRSIIndicator({name:"series1"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrStochRSIIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStochRSIIndicator, _super);
    function IgrStochRSIIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrStochRSIIndicator.prototype.createImplementation = function () {
        return new StochRSIIndicator();
    };
    Object.defineProperty(IgrStochRSIIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStochRSIIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current StochRSIIndicator object.
         * The typical, and initial, value for StochRSI periods is 14.
        *
        * ```ts
        * this.series.period = 10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrOrdinalTimeXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrStochRSIIndicator
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	closeMemberPath="Close"
        * 	period={10} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStochRSIIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStochRSIIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStochRSIIndicatorModule() {
    }
    IgrStochRSIIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrStochRSIIndicator", IgrStochRSIIndicator);
        TypeRegistrar.register("StochRSIIndicator", StochRSIIndicator.$type);
    };
    return IgrStochRSIIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TRIXIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TRIXIndicatorStrategy, _super);
    function TRIXIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TRIXIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.o(b.a.c);
        return c;
    };
    TRIXIndicatorStrategy.prototype.a = function (a, b) {
        var c = b.a.b(a.closeColumn, a.period);
        var d = b.a.b(c, a.period);
        var e = getEnumerator(b.a.b(d, a.period));
        var f = a.indicatorColumn;
        if (f.count > 0) {
            f.item(0, 0);
        }
        var g = 1;
        e.moveNext();
        var h = e.current;
        while (e.moveNext()) {
            f.item(g, b.i((e.current - h) / h));
            h = e.current;
            g++;
        }
        return true;
    };
    TRIXIndicatorStrategy.$t = markType(TRIXIndicatorStrategy, 'TRIXIndicatorStrategy', IndicatorCalculationStrategy.$);
    return TRIXIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TRIXIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TRIXIndicator, _super);
    function TRIXIndicator() {
        var _this = _super.call(this) || this;
        _this.pk = 0;
        _this.trendLineBrush = ((function () {
            var $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        _this.trendLineType = 9;
        _this.trendLinePeriod = 9;
        return _this;
    }
    TRIXIndicator.prototype.get_qc = function () {
        return new TRIXIndicatorStrategy();
    };
    Object.defineProperty(TRIXIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    TRIXIndicator.prototype.get_qp = function () {
        return TRIXIndicator.$;
    };
    Object.defineProperty(TRIXIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TRIXIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(TRIXIndicator.qy));
        },
        set: function (a) {
            this.h(TRIXIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    TRIXIndicator.prototype.qi = function () {
        return this.qx;
    };
    TRIXIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    TRIXIndicator.$t = markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
    TRIXIndicator.qy = StrategyBasedIndicator.qu(15, TRIXIndicator.$);
    return TRIXIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent TRIX indicator series.
 * Default required members: Close
*
* The `IgrTRIXIndicator` class specify the series as Trix Indicator series.
*
* ```ts
*   <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
* <IgrTRIXIndicator
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrTRIXIndicator({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrTRIXIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTRIXIndicator, _super);
    function IgrTRIXIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrTRIXIndicator.prototype.createImplementation = function () {
        return new TRIXIndicator();
    };
    Object.defineProperty(IgrTRIXIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTRIXIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current TRIXIndicator object.
         * The typical, and initial, value for TRIX periods is 15.
        *
        * The `period` property is used for moving average period of the current TRIXIndicator object.
        *
        * ```ts
        *   <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        * <IgrTRIXIndicator
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period="7"  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 30;
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrTRIXIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTRIXIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTRIXIndicatorModule() {
    }
    IgrTRIXIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrTRIXIndicator", IgrTRIXIndicator);
        TypeRegistrar.register("TRIXIndicator", TRIXIndicator.$type);
    };
    return IgrTRIXIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypicalPriceIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TypicalPriceIndicatorStrategy, _super);
    function TypicalPriceIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TypicalPriceIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        return c;
    };
    TypicalPriceIndicatorStrategy.prototype.a = function (a, b) {
        var e_1, _a;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(a.typicalColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                a.indicatorColumn.item(c, d);
                c++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    TypicalPriceIndicatorStrategy.$t = markType(TypicalPriceIndicatorStrategy, 'TypicalPriceIndicatorStrategy', IndicatorCalculationStrategy.$);
    return TypicalPriceIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TypicalPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TypicalPriceIndicator, _super);
    function TypicalPriceIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TypicalPriceIndicator.prototype.get_qc = function () {
        return new TypicalPriceIndicatorStrategy();
    };
    Object.defineProperty(TypicalPriceIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    TypicalPriceIndicator.prototype.get_qp = function () {
        return TypicalPriceIndicator.$;
    };
    Object.defineProperty(TypicalPriceIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    TypicalPriceIndicator.$t = markType(TypicalPriceIndicator, 'TypicalPriceIndicator', StrategyBasedIndicator.$);
    return TypicalPriceIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Typical Price indicator series.
 * The typical price indicator is represented as a arithmetic average
 * of the High, Low, and Close for a day.
 * Default required members: High, Low, Close
*
* The `IgrTypicalPriceIndicator` class represents a IgxDataChartComponent Typical Price indicator series.
*
* ```ts
*   <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
* 		<IgrCategoryXAxis name="xAxis" label="Date" />
* 		<IgrNumericYAxis  name="yAxis" />
* <IgrTypicalPriceIndicator
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrTypicalPriceIndicator({name: "series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrTypicalPriceIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTypicalPriceIndicator, _super);
    function IgrTypicalPriceIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrTypicalPriceIndicator.prototype.createImplementation = function () {
        return new TypicalPriceIndicator();
    };
    Object.defineProperty(IgrTypicalPriceIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrTypicalPriceIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTypicalPriceIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTypicalPriceIndicatorModule() {
    }
    IgrTypicalPriceIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrTypicalPriceIndicator", IgrTypicalPriceIndicator);
        TypeRegistrar.register("TypicalPriceIndicator", TypicalPriceIndicator.$type);
    };
    return IgrTypicalPriceIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var UltimateOscillatorIndicatorCalculationStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltimateOscillatorIndicatorCalculationStrategy, _super);
    function UltimateOscillatorIndicatorCalculationStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltimateOscillatorIndicatorCalculationStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.o(a.trueLow.basedOn);
        c.add("CloseColumn");
        c.o(a.trueRange.basedOn);
        c.o(b.b.c);
        return c;
    };
    UltimateOscillatorIndicatorCalculationStrategy.prototype.c = function (a) {
        var b = 0;
        var c = new List$1(Number_$type, 0);
        var d = a.trueLow.getEnumerator();
        while (d.moveNext()) {
            c.add(a.closeColumn.item(b) - d.current);
            b++;
        }
        return c;
    };
    UltimateOscillatorIndicatorCalculationStrategy.prototype.a = function (a, b) {
        var c = this.c(a);
        var d = a.trueRange;
        var e = getEnumerator(b.b.b(c, 7));
        var f = getEnumerator(b.b.b(d, 7));
        var g = getEnumerator(b.b.b(c, 14));
        var h = getEnumerator(b.b.b(d, 14));
        var i = getEnumerator(b.b.b(c, 28));
        var j = getEnumerator(b.b.b(d, 28));
        var k = 0;
        while (e.moveNext() && f.moveNext() && g.moveNext() && h.moveNext() && i.moveNext() && j.moveNext()) {
            var l = b.i(4 * (e.current / f.current) + 2 * (g.current / h.current) + (i.current / j.current));
            var m = (l / (4 + 2 + 1)) * 100;
            a.indicatorColumn.item(k, m);
            k++;
        }
        return true;
    };
    UltimateOscillatorIndicatorCalculationStrategy.$t = markType(UltimateOscillatorIndicatorCalculationStrategy, 'UltimateOscillatorIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);
    return UltimateOscillatorIndicatorCalculationStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var UltimateOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltimateOscillatorIndicator, _super);
    function UltimateOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltimateOscillatorIndicator.prototype.get_qc = function () {
        return new UltimateOscillatorIndicatorCalculationStrategy();
    };
    Object.defineProperty(UltimateOscillatorIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    UltimateOscillatorIndicator.prototype.get_qp = function () {
        return UltimateOscillatorIndicator.$;
    };
    Object.defineProperty(UltimateOscillatorIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    UltimateOscillatorIndicator.$t = markType(UltimateOscillatorIndicator, 'UltimateOscillatorIndicator', StrategyBasedIndicator.$);
    return UltimateOscillatorIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Ultimate Oscillator indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgrUltimateOscillatorIndicator` which represents a IgxDataChartComponent Ultimate Oscillator indicator series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrUltimateOscillatorIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		closeMemberPath="close"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrUltimateOscillatorIndicator({name: "series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrUltimateOscillatorIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrUltimateOscillatorIndicator, _super);
    function IgrUltimateOscillatorIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrUltimateOscillatorIndicator.prototype.createImplementation = function () {
        return new UltimateOscillatorIndicator();
    };
    Object.defineProperty(IgrUltimateOscillatorIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrUltimateOscillatorIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrUltimateOscillatorIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrUltimateOscillatorIndicatorModule() {
    }
    IgrUltimateOscillatorIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrUltimateOscillatorIndicator", IgrUltimateOscillatorIndicator);
        TypeRegistrar.register("UltimateOscillatorIndicator", UltimateOscillatorIndicator.$type);
    };
    return IgrUltimateOscillatorIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WeightedCloseIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WeightedCloseIndicatorStrategy, _super);
    function WeightedCloseIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WeightedCloseIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    };
    WeightedCloseIndicatorStrategy.prototype.a = function (a, b, c) {
        a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c) + (a.closeColumn.item(c) * 2)) / 4);
        return true;
    };
    WeightedCloseIndicatorStrategy.$t = markType(WeightedCloseIndicatorStrategy, 'WeightedCloseIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);
    return WeightedCloseIndicatorStrategy;
}(ItemwiseIndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WeightedCloseIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WeightedCloseIndicator, _super);
    function WeightedCloseIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WeightedCloseIndicator.prototype.get_qy = function () {
        return new WeightedCloseIndicatorStrategy();
    };
    Object.defineProperty(WeightedCloseIndicator.prototype, "qy", {
        get: function () {
            return this.get_qy();
        },
        enumerable: true,
        configurable: true
    });
    WeightedCloseIndicator.prototype.get_qp = function () {
        return WeightedCloseIndicator.$;
    };
    Object.defineProperty(WeightedCloseIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    WeightedCloseIndicator.$t = markType(WeightedCloseIndicator, 'WeightedCloseIndicator', ItemwiseStrategyBasedIndicator.$);
    return WeightedCloseIndicator;
}(ItemwiseStrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Weigted Close indicator series.
 * The weighted close indicator shows an average of the high low and close
 * for a day but with the closing price counted twice in the average.
 * Default required members: High, Low, Close
*
* The `IgrWeightedCloseIndicator` is similar to the `IgrTypicalPriceIndicator` in that it represents an average of the high price, low price, and closing price for a day.
* However, with the `IgrWeightedCloseIndicator`, more emphasis is placed on the closing price and it is included twice when calculating the arithmetic average.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrWeightedCloseIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		closeMemberPath="close"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrWeightedCloseIndicator({name:"series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrWeightedCloseIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrWeightedCloseIndicator, _super);
    function IgrWeightedCloseIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrWeightedCloseIndicator.prototype.createImplementation = function () {
        return new WeightedCloseIndicator();
    };
    Object.defineProperty(IgrWeightedCloseIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrWeightedCloseIndicator;
}(IgrItemwiseStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrWeightedCloseIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrWeightedCloseIndicatorModule() {
    }
    IgrWeightedCloseIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrWeightedCloseIndicator", IgrWeightedCloseIndicator);
        TypeRegistrar.register("WeightedCloseIndicator", WeightedCloseIndicator.$type);
    };
    return IgrWeightedCloseIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WilliamsPercentRIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WilliamsPercentRIndicatorStrategy, _super);
    function WilliamsPercentRIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WilliamsPercentRIndicatorStrategy.prototype.b = function (a, b) {
        var c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    };
    WilliamsPercentRIndicatorStrategy.prototype.a = function (a, b) {
        var c = a.period;
        var d = a.highColumn;
        var e = a.lowColumn;
        for (var f = 0; f < a.count; f++) {
            var g = Math.min(c, f);
            var h = -1.7976931348623157E+308;
            var i = 1.7976931348623157E+308;
            for (var j = 0; j < g; j++) {
                if (!isNaN_(d.item(f - j))) {
                    h = Math.max(h, d.item(f - j));
                }
                if (!isNaN_(e.item(f - j))) {
                    i = Math.min(i, e.item(f - j));
                }
            }
            a.indicatorColumn.item(f, b.i((a.closeColumn.item(f) - h) / (h - i) * 100));
        }
        return true;
    };
    WilliamsPercentRIndicatorStrategy.$t = markType(WilliamsPercentRIndicatorStrategy, 'WilliamsPercentRIndicatorStrategy', IndicatorCalculationStrategy.$);
    return WilliamsPercentRIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WilliamsPercentRIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WilliamsPercentRIndicator, _super);
    function WilliamsPercentRIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WilliamsPercentRIndicator.prototype.get_qc = function () {
        return new WilliamsPercentRIndicatorStrategy();
    };
    Object.defineProperty(WilliamsPercentRIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    WilliamsPercentRIndicator.prototype.get_qp = function () {
        return WilliamsPercentRIndicator.$;
    };
    Object.defineProperty(WilliamsPercentRIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(WilliamsPercentRIndicator.prototype, "qx", {
        get: function () {
            return typeGetValue(this.c(WilliamsPercentRIndicator.qy));
        },
        set: function (a) {
            this.h(WilliamsPercentRIndicator.qy, a);
        },
        enumerable: true,
        configurable: true
    });
    WilliamsPercentRIndicator.prototype.qi = function () {
        return this.qx;
    };
    WilliamsPercentRIndicator.prototype.qr = function (a) {
        this.qx = a;
    };
    WilliamsPercentRIndicator.$t = markType(WilliamsPercentRIndicator, 'WilliamsPercentRIndicator', StrategyBasedIndicator.$);
    WilliamsPercentRIndicator.qy = StrategyBasedIndicator.qu(14, WilliamsPercentRIndicator.$);
    return WilliamsPercentRIndicator;
}(StrategyBasedIndicator));

/**
 * Represents a IgxDataChartComponent Williams %R indicator series.
 * Default required members: High, Low, Close
*
* The `IgrWilliamsPercentRIndicator` scale ranges from 0 to -100. It is useful for identifying overbought and oversold securities.
* The `IgrWilliamsPercentRIndicator` is calculated by dividing the difference between the highest high for the period and the current close by the highest high minus the lowest low for the period.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrWilliamsPercentRIndicator
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
* 		openMemberPath="Open"
* 		closeMemberPath="close"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrWilliamsPercentRIndicator({name: "series"});
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
var IgrWilliamsPercentRIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrWilliamsPercentRIndicator, _super);
    function IgrWilliamsPercentRIndicator(props) {
        return _super.call(this, props) || this;
    }
    IgrWilliamsPercentRIndicator.prototype.createImplementation = function () {
        return new WilliamsPercentRIndicator();
    };
    Object.defineProperty(IgrWilliamsPercentRIndicator.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrWilliamsPercentRIndicator.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current StandardDeviationIndicator object.
         * The typical, and initial, value for Williams %R periods is 14.
        *
        * Gets or sets the `period` for the moving average period.
        *
        * The typical, and initial, value for Williams %R periods is 14.
        *
        * ```ts
        * this.series.period = 30;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrWilliamsPercentRIndicator
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        * 		openMemberPath="Open"
        * 		closeMemberPath="close"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		period={30} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.qx;
        },
        set: function (v) {
            this.i.qx = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrWilliamsPercentRIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrWilliamsPercentRIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrWilliamsPercentRIndicatorModule() {
    }
    IgrWilliamsPercentRIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrWilliamsPercentRIndicator", IgrWilliamsPercentRIndicator);
        TypeRegistrar.register("WilliamsPercentRIndicator", WilliamsPercentRIndicator.$type);
    };
    return IgrWilliamsPercentRIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomIndicatorStrategy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomIndicatorStrategy, _super);
    function CustomIndicatorStrategy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CustomIndicatorStrategy.prototype.a = function (a, b) {
        return true;
    };
    CustomIndicatorStrategy.prototype.b = function (a, b) {
        return new List$1(String_$type, 0);
    };
    CustomIndicatorStrategy.$t = markType(CustomIndicatorStrategy, 'CustomIndicatorStrategy', IndicatorCalculationStrategy.$);
    return CustomIndicatorStrategy;
}(IndicatorCalculationStrategy));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomIndicator, _super);
    function CustomIndicator() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.qy = null;
        _this.qx = null;
        return _this;
    }
    CustomIndicator.prototype.get_qc = function () {
        return new CustomIndicatorStrategy();
    };
    Object.defineProperty(CustomIndicator.prototype, "qc", {
        get: function () {
            return this.get_qc();
        },
        enumerable: true,
        configurable: true
    });
    CustomIndicator.prototype.get_qp = function () {
        return CustomIndicator.$;
    };
    Object.defineProperty(CustomIndicator.prototype, "qp", {
        get: function () {
            return this.get_qp();
        },
        enumerable: true,
        configurable: true
    });
    CustomIndicator.prototype.po = function (a, b) {
        var e_1, _a;
        var c = this.mk(a, b);
        var d = this.ml(c);
        var e = new List$1(String_$type, 0);
        if (this.qx != null) {
            var f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
            this.qx(this, f);
            if (f.basedOn != null) {
                try {
                    for (var _b = __values(fromEnum(f.basedOn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var g = _c.value;
                        e.add(g);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        }
        return e;
    };
    Object.defineProperty(CustomIndicator.prototype, "indicator", {
        get: function () {
            return this.qy;
        },
        set: function (a) {
            this.qy = a;
            this.pw();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CustomIndicator.prototype, "basedOnColumns", {
        get: function () {
            return this.qx;
        },
        set: function (a) {
            this.qx = a;
        },
        enumerable: true,
        configurable: true
    });
    CustomIndicator.prototype.pl = function (a, b) {
        _super.prototype.pl.call(this, a, b);
        if (this.qy != null) {
            var c = this.mk(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.nh(this.po(a, b))) {
                return false;
            }
            this.qy(this, new FinancialEventArgs(a, b, c, this.ml(c), this));
            if (this.qe(c) && this.mt != null) {
                this.mt.cl();
            }
            return true;
        }
        return false;
    };
    CustomIndicator.$t = markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);
    return CustomIndicator;
}(StrategyBasedIndicator));

var IgrCustomIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCustomIndicator, _super);
    function IgrCustomIndicator(props) {
        var _this = _super.call(this, props) || this;
        _this._indicator = null;
        _this._indicator_wrapped = null;
        _this._basedOnColumns = null;
        _this._basedOnColumns_wrapped = null;
        return _this;
    }
    IgrCustomIndicator.prototype.createImplementation = function () {
        return new CustomIndicator();
    };
    Object.defineProperty(IgrCustomIndicator.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomIndicator.prototype, "indicator", {
        /**
         * Event raised when the indicator values need to be computed.
        */
        get: function () {
            return this._indicator;
        },
        set: function (ev) {
            var _this = this;
            if (this._indicator !== null) {
                this.i.indicator = delegateRemove(this.i.indicator, this._indicator_wrapped);
                this._indicator_wrapped = null;
                this._indicator = null;
            }
            this._indicator = ev;
            this._indicator_wrapped = function (o, e) {
                var outerArgs = new IgrFinancialEventArgs();
                outerArgs._provideImplementation(e);
                _this._indicator(_this, outerArgs);
            };
            this.i.indicator = delegateCombine(this.i.indicator, this._indicator_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomIndicator.prototype, "basedOnColumns", {
        /**
         * Event raised when the basedOnColumns values need to be computed.
        */
        get: function () {
            return this._basedOnColumns;
        },
        set: function (ev) {
            var _this = this;
            if (this._basedOnColumns !== null) {
                this.i.basedOnColumns = delegateRemove(this.i.basedOnColumns, this._basedOnColumns_wrapped);
                this._basedOnColumns_wrapped = null;
                this._basedOnColumns = null;
            }
            this._basedOnColumns = ev;
            this._basedOnColumns_wrapped = function (o, e) {
                var outerArgs = new IgrFinancialEventArgs();
                outerArgs._provideImplementation(e);
                _this._basedOnColumns(_this, outerArgs);
            };
            this.i.basedOnColumns = delegateCombine(this.i.basedOnColumns, this._basedOnColumns_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrCustomIndicator;
}(IgrStrategyBasedIndicator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCustomIndicatorModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCustomIndicatorModule() {
    }
    IgrCustomIndicatorModule.register = function () {
        IgrIndicatorProxyModule.register();
        TypeRegistrar.registerCons("IgrCustomIndicator", IgrCustomIndicator);
        TypeRegistrar.register("CustomIndicator", CustomIndicator.$type);
    };
    return IgrCustomIndicatorModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrIndicatorsModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrIndicatorsModule() {
    }
    IgrIndicatorsModule.register = function () {
        IgrAbsoluteVolumeOscillatorIndicatorModule.register();
        IgrAccumulationDistributionIndicatorModule.register();
        IgrAverageDirectionalIndexIndicatorModule.register();
        IgrAverageTrueRangeIndicatorModule.register();
        IgrBollingerBandWidthIndicatorModule.register();
        IgrChaikinOscillatorIndicatorModule.register();
        IgrChaikinVolatilityIndicatorModule.register();
        IgrCommodityChannelIndexIndicatorModule.register();
        IgrDetrendedPriceOscillatorIndicatorModule.register();
        IgrEaseOfMovementIndicatorModule.register();
        IgrFastStochasticOscillatorIndicatorModule.register();
        IgrForceIndexIndicatorModule.register();
        IgrFullStochasticOscillatorIndicatorModule.register();
        IgrMarketFacilitationIndexIndicatorModule.register();
        IgrMassIndexIndicatorModule.register();
        IgrMedianPriceIndicatorModule.register();
        IgrMoneyFlowIndexIndicatorModule.register();
        IgrMovingAverageConvergenceDivergenceIndicatorModule.register();
        IgrNegativeVolumeIndexIndicatorModule.register();
        IgrOnBalanceVolumeIndicatorModule.register();
        IgrPercentagePriceOscillatorIndicatorModule.register();
        IgrPercentageVolumeOscillatorIndicatorModule.register();
        IgrPositiveVolumeIndexIndicatorModule.register();
        IgrPriceVolumeTrendIndicatorModule.register();
        IgrRateOfChangeAndMomentumIndicatorModule.register();
        IgrRelativeStrengthIndexIndicatorModule.register();
        IgrSlowStochasticOscillatorIndicatorModule.register();
        IgrStandardDeviationIndicatorModule.register();
        IgrStochRSIIndicatorModule.register();
        IgrTRIXIndicatorModule.register();
        IgrTypicalPriceIndicatorModule.register();
        IgrUltimateOscillatorIndicatorModule.register();
        IgrWeightedCloseIndicatorModule.register();
        IgrWilliamsPercentRIndicatorModule.register();
        IgrCustomIndicatorModule.register();
    };
    return IgrIndicatorsModule;
}());

/**
 * Represents the base functionality for a IgxDataChartComponent financial overlay series.
 * The difference between a FinancialIndicator and a FinancialOverlay is small.
 * Overlays are usually drawn against the same axes as the price, but they don't
 * have to be. Overlays mostly display multiple values, but not all of them, and so
 * so some indicators.
*
* The `IgrFinancialOverlay` class represents the base functionality for a IgxDataChartComponent financial overlay series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
* 	ref={this.onChartRef}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFinancialPriceSeries
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.financialSeries = new IgrFinancialPriceSeries({name: "financialSeries"});
* this.financialSeries.dataSource = this.financialData;
* this.financialSeries.xAxis = this.timeXAxis;
* this.financialSeries.yAxis = this.numericYAxis;
* this.financialSeries.xAxisName = "timeXAxis";
* this.financialSeries.yAxisName = "numericYAxis";
* this.financialSeries.highMemberPath="High" ;
* this.financialSeries.lowMemberPath="Low";
* this.financialSeries.closeMemberPath="Close";
* this.financialSeries.openMemberPath="Open";
* this.financialSeries.volumeMemberPath="Volume";
* ```
*/
var IgrFinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialOverlay, _super);
    function IgrFinancialOverlay(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrFinancialOverlay.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialOverlay.prototype, "ignoreFirst", {
        /**
         * Gets or sets the number of values to hide at the beginning of the indicator.
        *
        * Use the `ignoreFirst` property to sets the number of values to hide at the beginning of the indicator.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandsOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	IgnoreFirst={2} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        *  series.ignoreFirst=2;
        * ```
        */
        get: function () {
            return this.i.pk;
        },
        set: function (v) {
            this.i.pk = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * Use the `scrollIntoView` method to scrolls the series to display the item for the specified data item.
    */
    IgrFinancialOverlay.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    return IgrFinancialOverlay;
}(IgrFinancialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialOverlay, _super);
    function FinancialOverlay() {
        var _this = _super.call(this) || this;
        _this.pi = false;
        _this.pi = false;
        return _this;
    }
    FinancialOverlay.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            this.l8.i$i();
        }
        this.mo.bu.e(this.eu);
        this.pj();
        if (this.mt != null) {
            this.mt.cl();
        }
        this.jd(true);
    };
    FinancialOverlay.prototype.get_dv = function () {
        return true;
    };
    FinancialOverlay.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.pi = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.pi = false;
                this.jd(false);
                this.ik();
                break;
            case "XAxis":
                this.pi = false;
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
    };
    FinancialOverlay.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    FinancialOverlay.prototype.dh = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        return false;
    };
    FinancialOverlay.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    FinancialOverlay.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bi.bs;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ls(this.bi);
        var g = new ScalerParams(0, e, e, this.l8.b8, f);
        var h = new ScalerParams(0, e, e, this.mt.b8, f);
        h.b = this.eh();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.l8 != null) {
                var i = this.l8.dw(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.mt != null && this.m0 != null && this.my != null && b < this.m0.count && b < this.my.count) {
                var j = this.mt.dw(this.m0.item(b), h);
                var k = this.mt.dw(this.my.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    FinancialOverlay.prototype.an = function (a) {
        if (a != null && a == this.mt && this.m0 != null && this.my != null) {
            return new AxisRange(this.m0.minimum, this.my.maximum);
        }
        return null;
    };
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:pk:pm', [1, 0]]);
    return FinancialOverlay;
}(FinancialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PriceChannelOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelOverlay, _super);
    function PriceChannelOverlay() {
        var _this = _super.call(this) || this;
        _this.pp = new List$1(Number_$type, 0);
        _this.po = new List$1(Number_$type, 0);
        _this.ab = PriceChannelOverlay.$;
        _this.mb = new CategoryFrame(3);
        _this.md = new CategoryFrame(3);
        _this.ma = new CategoryFrame(3);
        return _this;
    }
    PriceChannelOverlay.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case "HighColumn":
            case "LowColumn":
                this.pi = false;
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case PriceChannelOverlay.$$p[0]:
                this.pi = false;
                this.jd(false);
                break;
        }
    };
    PriceChannelOverlay.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.my == null || this.m0 == null) {
            d = false;
        }
        return d;
    };
    PriceChannelOverlay.prototype.pj = function () {
        this.pp.clear();
        this.po.clear();
        var a = truncate(MathUtil.b(this.pq, 0, this.bz.count));
        var b = Math.min(this.my.count, this.m0.count);
        var c = this.ns(this.my);
        var d = this.ns(this.m0);
        for (var e = 0; e < b; e++) {
            var f = Math.min(a, e);
            var g = -1.7976931348623157E+308;
            var h = 1.7976931348623157E+308;
            for (var i = 0; i < f; i++) {
                if (!isNaN_(c.item(e - i))) {
                    g = Math.max(g, c.item(e - i));
                }
                if (!isNaN_(d.item(e - i))) {
                    h = Math.min(h, d.item(e - i));
                }
            }
            if (e == 0) {
                h = d.item(0);
                g = c.item(0);
            }
            this.pp.add(g);
            this.po.add(h);
        }
        return true;
    };
    PriceChannelOverlay.prototype.oz = function (a, b) {
        _super.prototype.oz.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = new ScalerParams(0, c, d, this.l8.b8, e);
        var g = new ScalerParams(0, c, d, this.mt.b8, e);
        g.b = this.eh();
        var h = this.l8;
        var i = this.mt;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.l8);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.nz(c, d, e);
        if (!this.pi) {
            this.pi = this.pj();
        }
        g.b = this.eh();
        var l = this.l8.dz(2, f) - this.l8.dz(1, f);
        for (var m = b.bu.c; m <= b.bu.d; ++m) {
            var n = void 0;
            if (k == null) {
                n = b.bu.getBucket(m);
            }
            else {
                var o = k.i$b._inner[m];
                var p = k.i$d(o);
                var q = this.pp._inner[m];
                var r = this.po._inner[m];
                var s = q;
                var t = r;
                var u = p;
                while (m < b.bu.d) {
                    o = k.i$b._inner[m + 1];
                    u = k.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s = Math.max(q, this.pp._inner[m]);
                    t = Math.min(r, this.po._inner[m]);
                }
                if (!isInfinity(t) && !isInfinity(s)) {
                    var v = NaN;
                    if (!isNaN_(p)) {
                        v = this.l8.dw(p, f);
                    }
                    n = [v, t, s];
                }
                else {
                    n = [NaN, NaN, NaN];
                }
            }
            var w = Math.max(1, l);
            if (!isNaN_(n[0]) && m * w >= this.pk) {
                if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
                    n[0] = n[0] + j;
                }
                else {
                    n[0] = h.dw(n[0], f) + j;
                }
                n[1] = i.dw(n[1], g);
                n[2] = i.dw(n[2], g);
                a.f.add(n);
            }
        }
    };
    PriceChannelOverlay.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (c != null) {
            c.b1();
        }
    };
    PriceChannelOverlay.prototype.o1 = function (a, b) {
        _super.prototype.o1.call(this, a, b);
        var c = typeCast(PriceChannelOverlayView.$, b);
        if (c == null) {
            return;
        }
        var d = this.getEffectiveViewport1(b);
        if (b.bx(a)) {
            c.b1();
            var e_1 = a.f.count;
            var f = function (g) { return a.f._inner[g][0]; };
            var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
            var h = function (i) { return a.f._inner[i][1]; };
            var i = function (j) { return a.f._inner[e_1 - 1 - j][2]; };
            c.b2(e_1, f, g, h, i);
            b.bz(a);
        }
        this.mg.x(this, this.ng(), this.l8, runOn(this, this.l0), this.n5(b), this.n7(b));
        var j = false;
        var k = this.mg.c;
        var l = a.f;
        var m = this.bz.count;
        if (k != null) {
            j = true;
        }
        if (j) {
            var n = new ScalerParams(0, b.bs, b.br, this.l8.b8, d);
            this.oy(l, -1, m, this.l8, n, b.n);
        }
        var o = c.b8;
        var p = c.b9;
        var q = c.b4;
        this.mg.ae(o, true, false, true, true);
        this.mg.ae(p, true, false, true, true);
        this.mg.ae(q, false, true, false, false);
        q._opacity = this.mg.i * this.d6;
    };
    PriceChannelOverlay.prototype.bf = function () {
        return new PriceChannelOverlayView(this);
    };
    PriceChannelOverlay.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pn = typeCast(PriceChannelOverlayView.$, a);
    };
    PriceChannelOverlay.prototype.en = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mq, this.bi.br, this.l8.b8, d);
        var f = this.nz(this.bs.mq, this.bi.br, d);
        return this.ep(new RangeValueList(this.pp, this.po), a, this.l8, e, f, runOn(this, this.ny), b, c);
    };
    PriceChannelOverlay.prototype.fc = function (a, b) {
        if (this.pp == null || this.po == null) {
            return _super.prototype.fc.call(this, a, b);
        }
        return this.fd(a, b, this.l8, runOn(this, this.ny), new RangeValueList(this.pp, this.po));
    };
    PriceChannelOverlay.prototype.fe = function (a, b) {
        if (this.pp == null || this.po == null) {
            return _super.prototype.fe.call(this, a, b);
        }
        return this.ff(a, b, this.l8, runOn(this, this.ny), new RangeValueList(this.pp, this.po));
    };
    PriceChannelOverlay.prototype.eh = function () {
        return Series.ei(this.po, null);
    };
    PriceChannelOverlay.$t = markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
    PriceChannelOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:pq:ps', [1, 14]]);
    return PriceChannelOverlay;
}(FinancialOverlay));
/**
 * @hidden
 */
var PriceChannelBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelBucketCalculator, _super);
    function PriceChannelBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    PriceChannelBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c) {
            var d = -1.7976931348623157E+308;
            var e = 1.7976931348623157E+308;
            var f = 0;
            for (var g = b; g <= c; ++g) {
                if (!isNaN_(this.f.b0.pp._inner[g]) && !isNaN_(this.f.b0.po._inner[g])) {
                    d = Math.max(d, this.f.b0.pp._inner[g]);
                    e = Math.min(e, this.f.b0.po._inner[g]);
                    ++f;
                }
            }
            if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                return [0.5 * (b + c), e, d];
            }
        }
        return [NaN, NaN, NaN];
    };
    PriceChannelBucketCalculator.$t = markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
    return PriceChannelBucketCalculator;
}(FinancialBucketCalculator));
/**
 * @hidden
 */
var PriceChannelOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PriceChannelOverlayView, _super);
    function PriceChannelOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b5 = new Polygon();
        _this.ca = new Polyline();
        _this.cb = new Polyline();
        _this.b0 = null;
        _this.b3 = new Polygon();
        _this.b6 = new Polyline();
        _this.b7 = new Polyline();
        _this.b0 = a;
        return _this;
    }
    Object.defineProperty(PriceChannelOverlayView.prototype, "b4", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PriceChannelOverlayView.prototype, "b8", {
        get: function () {
            return this.ca;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PriceChannelOverlayView.prototype, "b9", {
        get: function () {
            return this.cb;
        },
        enumerable: true,
        configurable: true
    });
    PriceChannelOverlayView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    PriceChannelOverlayView.prototype.bv = function () {
        return new PriceChannelBucketCalculator(this);
    };
    PriceChannelOverlayView.prototype.b1 = function () {
        this.b5.ak.clear();
        this.ca.ak.clear();
        this.cb.ak.clear();
        this.an();
    };
    PriceChannelOverlayView.prototype.b2 = function (a, b, c, d, e) {
        var e_2, _a, e_3, _b;
        try {
            for (var _c = __values(fromEnum(Flattener.d(a, b, d, this.e.eu))), _d = _c.next(); !_d.done; _d = _c.next()) {
                var f = _d.value;
                this.b5.ak.add({ $type: Point_$type, x: b(f), y: d(f) });
                this.ca.ak.add({ $type: Point_$type, x: b(f), y: d(f) });
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(Flattener.d(a, c, e, this.e.eu))), _f = _e.next(); !_f.done; _f = _e.next()) {
                var g = _f.value;
                this.b5.ak.add({ $type: Point_$type, x: c(g), y: e(g) });
                this.cb.ak.add({ $type: Point_$type, x: c(g), y: e(g) });
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.an();
    };
    PriceChannelOverlayView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.b3.ak = this.b5.ak;
        this.b6.ak = this.ca.ak;
        this.b7.ak = this.cb.ak;
        var a = this.bl();
        this.b3._fill = a;
        this.b3._opacity = 1;
        this.b6._stroke = a;
        this.b6.ac = this.e.ey + 3;
        this.b7._stroke = a;
        this.b7.ac = this.e.ey + 3;
    };
    PriceChannelOverlayView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.b3);
                a.u(this.b6);
                a.u(this.b7);
            }
            else {
                a.t(this.b5);
                a.u(this.ca);
                a.u(this.cb);
            }
        }
    };
    PriceChannelOverlayView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPolygonData(a, this.b5, "fill", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.ca, "bottom", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.cb, "top", ["Upper"]);
    };
    PriceChannelOverlayView.$t = markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);
    return PriceChannelOverlayView;
}(FinancialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent Financial Price Channel Overlay series.
 * Default required members: High, Low
*
* You can use the `IgrPriceChannelOverlay` to display price volatility.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*    <IgrPriceChannelOverlay
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrPriceChannelOverlay({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.xAxis = this.categoryXAxis;
* series.yAxis = this.numericYAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* ```
*/
var IgrPriceChannelOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPriceChannelOverlay, _super);
    function IgrPriceChannelOverlay(props) {
        return _super.call(this, props) || this;
    }
    IgrPriceChannelOverlay.prototype.createImplementation = function () {
        return new PriceChannelOverlay();
    };
    Object.defineProperty(IgrPriceChannelOverlay.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPriceChannelOverlay.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current PriceChannelOverlay object.
         * The typical, and initial, value for Bollinger band periods is 14.
        *
        * You can use the `period` to set the moving average.
        *
        * ```ts
        * this.series.period = 14;
        * ```
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *    <IgrPriceChannelOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period = {14} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.pq;
        },
        set: function (v) {
            this.i.pq = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrPriceChannelOverlay.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrPriceChannelOverlay.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrPriceChannelOverlay.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    return IgrPriceChannelOverlay;
}(IgrFinancialOverlay));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPriceChannelOverlayModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPriceChannelOverlayModule() {
    }
    IgrPriceChannelOverlayModule.register = function () {
        IgrOverlayProxyModule.register();
        TypeRegistrar.registerCons("IgrPriceChannelOverlay", IgrPriceChannelOverlay);
        TypeRegistrar.register("PriceChannelOverlay", PriceChannelOverlay.$type);
    };
    return IgrPriceChannelOverlayModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BollingerBandsOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlay, _super);
    function BollingerBandsOverlay() {
        var _this = _super.call(this) || this;
        _this.pq = 0;
        _this.pr = 0;
        _this.po = new List$1(Number_$type, 0);
        _this.pp = new List$1(Number_$type, 0);
        _this.ab = BollingerBandsOverlay.$;
        _this.mb = new CategoryFrame(4);
        _this.md = new CategoryFrame(4);
        _this.ma = new CategoryFrame(4);
        return _this;
    }
    BollingerBandsOverlay.prototype.iz = function (a, b, c, d) {
        if (this.nr().contains(b)) {
            this.pi = false;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.pi = false;
                this.jd(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.jd(false);
                break;
        }
    };
    BollingerBandsOverlay.prototype.pj = function () {
        this.po.clear();
        this.pp.clear();
        var a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.nq), this.pt));
        var b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.nq), this.pt));
        this.pr = 1.7976931348623157E+308;
        this.pq = -1.7976931348623157E+308;
        var c = true;
        var d = true;
        var e = this.ps;
        while (c || d) {
            if (a.moveNext()) {
                this.po.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.pp.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.pr = Math.min(this.pr, a.current - b.current * e);
                this.pq = Math.max(this.pq, a.current + b.current * e);
            }
        }
        return true;
    };
    BollingerBandsOverlay.prototype.an = function (a) {
        if (this.po == null || this.pp == null || a == null || this.bz == null || a != this.mt) {
            return null;
        }
        var b = new AxisRange(this.pr, this.pq);
        return b;
    };
    BollingerBandsOverlay.prototype.oz = function (a, b) {
        _super.prototype.oz.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l8;
        var g = this.mt;
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = new ScalerParams(0, c, d, g.b8, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = typeCast(ISortingAxis_$type, this.l8);
        if (j != null && j.i$b.count != this.bz.count) {
            return;
        }
        var k = 0;
        k = this.nz(c, d, e);
        if (!this.pi) {
            this.pi = this.pj();
            if (this.mt != null) {
                this.mt.cm(true);
            }
        }
        i.b = this.eh();
        var l = this.l8.dz(2, h) - this.l8.dz(1, h);
        for (var m = b.bu.c; m <= b.bu.d; ++m) {
            var n = void 0;
            if (j == null) {
                n = b.bu.getBucket(m);
            }
            else {
                var o = j.i$b._inner[m];
                var p = j.i$d(o);
                var q = this.po._inner[m];
                var r = this.pp._inner[m];
                var s = q;
                var t = r;
                var u = p;
                var v = 1;
                while (m < b.bu.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.po._inner[m];
                    t += this.pp._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                var w = s - t * this.ps;
                var x = s;
                var y = s + t * this.ps;
                var z = NaN;
                if (!isNaN_(p)) {
                    z = this.l8.dw(p, h);
                }
                n = [z, w, x, y];
            }
            var aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.pk) {
                if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.dw(n[0], h) + k;
                }
                n[1] = g.dw(n[1], i);
                n[2] = g.dw(n[2], i);
                n[3] = g.dw(n[3], i);
                a.f.add(n);
            }
        }
    };
    BollingerBandsOverlay.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (c != null) {
            c.b1();
        }
    };
    BollingerBandsOverlay.prototype.en = function (a, b, c) {
        if (this.po == null) {
            return _super.prototype.en.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nz(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l8.b8, d);
        f.c = this.bs.m3;
        return this.ep(this.po, a, this.l8, f, e, runOn(this, this.ny), b, c);
    };
    BollingerBandsOverlay.prototype.fe = function (a, b) {
        if (this.po == null) {
            return _super.prototype.fe.call(this, a, b);
        }
        return this.ff(a, b, this.l8, runOn(this, this.ny), this.po);
    };
    BollingerBandsOverlay.prototype.fc = function (a, b) {
        if (this.po == null) {
            return _super.prototype.fc.call(this, a, b);
        }
        return this.fd(a, b, this.l8, runOn(this, this.ny), this.po);
    };
    BollingerBandsOverlay.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (!this.nh(this.nr())) {
            d = false;
        }
        return d;
    };
    BollingerBandsOverlay.prototype.o1 = function (a, b) {
        _super.prototype.o1.call(this, a, b);
        var c = typeCast(BollingerBandsOverlayView.$, b);
        var d = this.getEffectiveViewport1(b);
        if (b.bx(a)) {
            c.b1();
            var e_1 = a.f.count;
            var f = function (g) { return a.f._inner[g][0]; };
            var g = function (h) { return a.f._inner[e_1 - 1 - h][0]; };
            var h = function (i) { return a.f._inner[i][1]; };
            var i = function (j) { return a.f._inner[j][2]; };
            var j = function (k) { return a.f._inner[e_1 - 1 - k][3]; };
            c.b2(e_1, f, g, h, i, j);
            b.bz(a);
        }
        this.mg.x(this, this.ng(), this.l8, runOn(this, this.l0), this.n5(b), this.n7(b));
        var k = false;
        var l = this.mg.c;
        var m = a.f;
        var n = this.bz.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            var o = new ScalerParams(0, b.bs, b.br, this.l8.b8, d);
            this.oy(m, -1, n, this.l8, o, b.n);
        }
        var p = c.b9;
        var q = c.ca;
        var r = c.cb;
        var s = c.b4;
        this.mg.ae(q, true, false, true, true);
        this.mg.ao = null;
        this.mg.an = null;
        this.mg.ae(p, true, false, false, true);
        this.mg.ae(r, true, false, false, true);
        this.mg.ae(s, false, true, false, false);
        s._opacity = this.mg.i * this.d6;
    };
    BollingerBandsOverlay.prototype.bf = function () {
        return new BollingerBandsOverlayView(this);
    };
    BollingerBandsOverlay.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pn = typeCast(BollingerBandsOverlayView.$, a);
    };
    BollingerBandsOverlay.prototype.n8 = function () {
        return 3;
    };
    BollingerBandsOverlay.prototype.eh = function () {
        return Series.ei(this.po, null);
    };
    BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
    BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:ps:pw', [1, 2], 'Period:pt:px', [1, 14]]);
    return BollingerBandsOverlay;
}(FinancialOverlay));
/**
 * @hidden
 */
var BollingerBandsBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsBucketCalculator, _super);
    function BollingerBandsBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    BollingerBandsBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c) {
            var d = this.f.b0.ps;
            var e = 0;
            var f = 0;
            var g = 0;
            for (var h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b0.po._inner[h]) && !isNaN_(this.f.b0.pp._inner[h])) {
                    e += this.f.b0.po._inner[h];
                    f += this.f.b0.pp._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    };
    BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
    return BollingerBandsBucketCalculator;
}(FinancialBucketCalculator));
/**
 * @hidden
 */
var BollingerBandsOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BollingerBandsOverlayView, _super);
    function BollingerBandsOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b5 = new Polygon();
        _this.cc = new Polyline();
        _this.cd = new Polyline();
        _this.ce = new Polyline();
        _this.b3 = new Polygon();
        _this.b6 = new Polyline();
        _this.b7 = new Polyline();
        _this.b8 = new Polyline();
        _this.b0 = a;
        return _this;
    }
    BollingerBandsOverlayView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    BollingerBandsOverlayView.prototype.bv = function () {
        return new BollingerBandsBucketCalculator(this);
    };
    BollingerBandsOverlayView.prototype.b2 = function (a, b, c, d, e, f) {
        var e_2, _a, e_3, _b, e_4, _c;
        try {
            for (var _d = __values(fromEnum(Flattener.d(a, b, d, this.e.eu))), _e = _d.next(); !_e.done; _e = _d.next()) {
                var g = _e.value;
                this.b5.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
                this.cc.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _f = __values(fromEnum(Flattener.d(a, b, e, this.e.eu))), _g = _f.next(); !_g.done; _g = _f.next()) {
                var h = _g.value;
                this.cd.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        try {
            for (var _h = __values(fromEnum(Flattener.d(a, c, f, this.e.eu))), _j = _h.next(); !_j.done; _j = _h.next()) {
                var i = _j.value;
                this.b5.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
                this.ce.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.an();
    };
    BollingerBandsOverlayView.prototype.b1 = function () {
        this.b5.ak.clear();
        this.cc.ak.clear();
        this.cd.ak.clear();
        this.ce.ak.clear();
        this.an();
    };
    Object.defineProperty(BollingerBandsOverlayView.prototype, "b4", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "b9", {
        get: function () {
            return this.cc;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "ca", {
        get: function () {
            return this.cd;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BollingerBandsOverlayView.prototype, "cb", {
        get: function () {
            return this.ce;
        },
        enumerable: true,
        configurable: true
    });
    BollingerBandsOverlayView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.b3.ak = this.b5.ak;
        this.b6.ak = this.cc.ak;
        this.b7.ak = this.cd.ak;
        this.b8.ak = this.ce.ak;
        var a = this.bl();
        this.b3._fill = a;
        this.b3._opacity = 1;
        this.b6._stroke = a;
        this.b6.ac = this.e.ey + 3;
        this.b7._stroke = a;
        this.b7.ac = this.e.ey + 3;
        this.b8._stroke = a;
        this.b8.ac = this.e.ey + 3;
    };
    BollingerBandsOverlayView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.b3);
                a.u(this.b6);
                a.u(this.b7);
                a.u(this.b8);
            }
            else {
                a.t(this.b5);
                a.u(this.cc);
                a.u(this.cd);
                a.u(this.ce);
            }
        }
    };
    BollingerBandsOverlayView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPolygonData(a, this.b5, "FillShape", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.cc, "BottomLine", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.cd, "CentralLine", ["Central"]);
        this.e.a2.exportPolylineData(a, this.ce, "TopLine", ["Upper"]);
    };
    BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
    return BollingerBandsOverlayView;
}(FinancialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent Bollinger Bands financial overlay series.
 * Default required members: High, Low, Close
*
* You can use the `IgrBollingerBandsOverlay` class represents a IgxDataChartComponent Bollinger Bands financial overlay series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFinancialPriceSeries
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*
*     <IgrBollingerBandsOverlay
*     name="series1"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
*  const s = new IgrBollingerBandsOverlay({ name: "", xAxisName: "" });
* ```
*/
var IgrBollingerBandsOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBollingerBandsOverlay, _super);
    function IgrBollingerBandsOverlay(props) {
        return _super.call(this, props) || this;
    }
    IgrBollingerBandsOverlay.prototype.createImplementation = function () {
        return new BollingerBandsOverlay();
    };
    Object.defineProperty(IgrBollingerBandsOverlay.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBollingerBandsOverlay.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current BollingerBandOverlay object.
         * The typical, and initial, value for Bollinger band periods is 14.
        *
        * You can use the `period` property for moving average of the current BollingerBandOverlay object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandsOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	period={7} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.series.period = 7;
        * ```
        */
        get: function () {
            return this.i.pt;
        },
        set: function (v) {
            this.i.pt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBollingerBandsOverlay.prototype, "multiplier", {
        /**
         * Gets or sets the moving average period for the current BollingerBandOverlay object.
         * The typical, and initial, value for Bollinger band multipliers is 2.
        *
        * You can use the `IgrBollingerBandsOverlay`
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume" />
        *
        *     <IgrBollingerBandsOverlay
        *     name="series1"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	multiplier= {2} />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ps;
        },
        set: function (v) {
            this.i.ps = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrBollingerBandsOverlay.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrBollingerBandsOverlay.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrBollingerBandsOverlay.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    return IgrBollingerBandsOverlay;
}(IgrFinancialOverlay));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBollingerBandsOverlayModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBollingerBandsOverlayModule() {
    }
    IgrBollingerBandsOverlayModule.register = function () {
        IgrOverlayProxyModule.register();
        TypeRegistrar.registerCons("IgrBollingerBandsOverlay", IgrBollingerBandsOverlay);
        TypeRegistrar.register("BollingerBandsOverlay", BollingerBandsOverlay.$type);
    };
    return IgrBollingerBandsOverlayModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrOverlaysModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrOverlaysModule() {
    }
    IgrOverlaysModule.register = function () {
        IgrPriceChannelOverlayModule.register();
        IgrBollingerBandsOverlayModule.register();
    };
    return IgrOverlaysModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a column that is calculated based on the values of other columns.
*/
var IgrCalculatedColumn = /** @class */ /*@__PURE__*/ (function () {
    function IgrCalculatedColumn() {
    }
    Object.defineProperty(IgrCalculatedColumn.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCalculatedColumn.prototype.onImplementationCreated = function () {
    };
    IgrCalculatedColumn.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    IgrCalculatedColumn.prototype[Symbol.iterator] = function () {
        return new EnumeratorWrapper(this.i.getEnumerator());
    };
    return IgrCalculatedColumn;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IFinancialPriceSeriesProxy_$type = /*@__PURE__*/ new Type(null, 'IFinancialPriceSeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialPriceSeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeriesProxy, _super);
    function FinancialPriceSeriesProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinancialPriceSeriesProxy.prototype.getCloseMemberPath = function (a) {
        return a.oc;
    };
    FinancialPriceSeriesProxy.prototype.getHighMemberPath = function (a) {
        return a.of;
    };
    FinancialPriceSeriesProxy.prototype.getLowMemberPath = function (a) {
        return a.ok;
    };
    FinancialPriceSeriesProxy.prototype.getOpenMemberPath = function (a) {
        return a.oo;
    };
    FinancialPriceSeriesProxy.prototype.getVolumeMemberPath = function (a) {
        return a.os;
    };
    FinancialPriceSeriesProxy.prototype.matchesType = function (a) {
        if (!a.cr) {
            return false;
        }
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator") || stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return false;
        }
        return true;
    };
    FinancialPriceSeriesProxy.prototype.setCategoryMode = function (a, b) {
        a.mf = b;
    };
    FinancialPriceSeriesProxy.prototype.setCloseMemberPath = function (a, b) {
        a.oc = b;
    };
    FinancialPriceSeriesProxy.prototype.setDisplayType = function (a, b) {
        a.pk = b;
    };
    FinancialPriceSeriesProxy.prototype.setHighMemberPath = function (a, b) {
        a.of = b;
    };
    FinancialPriceSeriesProxy.prototype.setLowMemberPath = function (a, b) {
        a.ok = b;
    };
    FinancialPriceSeriesProxy.prototype.setOpenMemberPath = function (a, b) {
        a.oo = b;
    };
    FinancialPriceSeriesProxy.prototype.setVolumeMemberPath = function (a, b) {
        a.os = b;
    };
    FinancialPriceSeriesProxy.prototype.setXAxis = function (a, b) {
        a.l8 = b;
    };
    FinancialPriceSeriesProxy.prototype.setYAxis = function (a, b) {
        a.mt = b;
    };
    FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);
    return FinancialPriceSeriesProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinancialPriceSeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialPriceSeriesProxyModule() {
    }
    IgrFinancialPriceSeriesProxyModule.register = function () {
        TypeRegistrar.register('FinancialPriceSeriesProxy', FinancialPriceSeriesProxy.$type);
        TypeRegistrar.register('FinancialEventArgs', FinancialEventArgs.$type);
        TypeRegistrar.registerCons('igr-financial-event-args', IgrFinancialEventArgs);
    };
    return IgrFinancialPriceSeriesProxyModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialPriceBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceBucketCalculator, _super);
    function FinancialPriceBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    FinancialPriceBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c && b >= 0 && c >= 0) {
            var d = this.a.bw.m2.item(b);
            var e = Number.NEGATIVE_INFINITY;
            var f = Number.POSITIVE_INFINITY;
            var g = this.a.bw.mw.item(c);
            for (var h = b; h <= c; ++h) {
                e = Math.max(e, this.a.bw.my.item(h));
                f = Math.min(f, this.a.bw.m0.item(h));
            }
            f = Math.min(d, f);
            e = Math.max(g, e);
            return [0.5 * (b + c), d, e, f, g];
        }
        return [NaN, NaN, NaN, NaN, NaN];
    };
    FinancialPriceBucketCalculator.$t = markType(FinancialPriceBucketCalculator, 'FinancialPriceBucketCalculator', FinancialBucketCalculator.$);
    return FinancialPriceBucketCalculator;
}(FinancialBucketCalculator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available display types of financial price series.
 */
var PriceDisplayType = /*@__PURE__*/ (function (PriceDisplayType) {
    /**
     * Displays prices as a Japanese Candlestick.
     */
    PriceDisplayType[PriceDisplayType["Candlestick"] = 0] = "Candlestick";
    /**
     * Displays prices as an OHLC bar.
     */
    PriceDisplayType[PriceDisplayType["OHLC"] = 1] = "OHLC";
    return PriceDisplayType;
})({});
/**
 * @hidden
 */
var PriceDisplayType_$type = /*@__PURE__*/ markEnum('PriceDisplayType', 'Candlestick,0|OHLC,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialPriceSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeries, _super);
    function FinancialPriceSeries() {
        var _this = _super.call(this) || this;
        _this.ab = FinancialPriceSeries.$;
        _this.mb = new CategoryFrame(5);
        _this.md = new CategoryFrame(5);
        _this.ma = new CategoryFrame(5);
        return _this;
    }
    FinancialPriceSeries.prototype.bf = function () {
        return new FinancialPriceSeriesView(this);
    };
    FinancialPriceSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pj = a;
    };
    Object.defineProperty(FinancialPriceSeries.prototype, "p3", {
        get: function () {
            return this.c(FinancialPriceSeries.pt);
        },
        set: function (a) {
            this.h(FinancialPriceSeries.pt, a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialPriceSeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        if (this.l8 != null && typeCast(ISortingAxis_$type, this.l8) !== null) {
            this.l8.i$i();
        }
        this.pj.bu.e(this.eu);
        if (this.pj.b4) {
            this.pj.b2.g$e(a, b, c, d);
        }
        if (this.mt != null) {
            this.mt.cl();
        }
        this.jd(true);
    };
    FinancialPriceSeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    FinancialPriceSeries.prototype.lu = function (a) {
        if (this.ma == null || this.ma.f.count == 0) {
            return Rect.empty;
        }
        var b = this.lg(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = this.aj(this.l8, this.ma.f, this.n5(this.bi), this.n7(this.bi), a, true);
        var g = f[0];
        var h = f[1];
        var i = Math.abs(b.x - g[0]);
        var j = Math.abs(b.x - h[0]);
        var k = this.pl(this.mo, e);
        k = Math.max(k, 3);
        var l = (k - 1) / 2;
        if (i < j) {
            var m = g[0] - l;
            var n = g[0];
            var o = g[0] + l;
            var p = g[1];
            var q = g[2];
            var r = g[3];
            var s = g[4];
            var t = Math.min(Math.min(Math.min(p, q), r), s);
            var u = Math.max(Math.max(Math.max(p, q), r), s);
            return new Rect(0, m, t, Math.abs(o - m), u - t);
        }
        else {
            var v = h[0] - l;
            var w = h[0];
            var x = h[0] + l;
            var y = h[1];
            var z = h[2];
            var aa = h[3];
            var ab = h[4];
            var ac = Math.min(Math.min(Math.min(y, z), aa), ab);
            var ad = Math.max(Math.max(Math.max(y, z), aa), ab);
            return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
        }
    };
    FinancialPriceSeries.prototype.pi = function (a, b) {
        var c = a[0] - b;
        var d = a[0];
        var e = a[0] + b;
        var f = a[1];
        var g = a[2];
        var h = a[3];
        var i = a[4];
        var j = Math.min(Math.min(Math.min(f, g), h), i);
        var k = Math.max(Math.max(Math.max(f, g), h), i);
        var l = Math.min(g, h);
        var m = Math.max(g, h);
        var n = Math.min(f, i);
        var o = Math.max(f, i);
        if (this.pk == 1) {
            var p = new Array(3);
            var q = new Rect(0, c, f, b, 0);
            var r = new Rect(0, d, i, b, 0);
            var s = new Rect(0, d, l, 0, m - l);
            p[0] = q;
            p[1] = r;
            p[2] = s;
            return p;
        }
        else {
            var t = new Array(2);
            var u = new Rect(0, d, l, 0, m - l);
            var v = new Rect(0, c, n, b * 2, o - n);
            t[0] = u;
            t[1] = v;
            return t;
        }
    };
    FinancialPriceSeries.prototype.ak = function (a) {
        var b = new List$1(Rect.$, 0);
        var c = this.lg(a);
        var d = this.bi.bs;
        var e = this.bi.br;
        var f = this.getEffectiveViewport1(this.bi);
        var g = this.aj(this.l8, this.ma.f, this.n5(this.bi), this.n7(this.bi), a, true);
        var h = g[0];
        var i = g[1];
        var j = Math.abs(c.x - h[0]);
        var k = Math.abs(c.x - i[0]);
        var l = this.pl(this.mo, f);
        l = Math.max(l, 3);
        var m = (l - 1) / 2;
        if (j < k) {
            return this.pi(h, m);
        }
        else {
            return this.pi(i, m);
        }
    };
    FinancialPriceSeries.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        return false;
    };
    FinancialPriceSeries.prototype.dk = function (a, b) {
        var c = this.lv(a);
        if (c.isEmpty) {
            return false;
        }
        var d = RectUtil.r(c, (this.ey / 2) + this.ee(b));
        if (d.containsPoint(a)) {
            var e = this.al(a);
            if (e != null) {
                for (var f = 0; f < e.length; f++) {
                    var g = e[f];
                    var h = RectUtil.r(g, (this.ey / 2) + this.ee(b));
                    if (h.containsPoint(a)) {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    FinancialPriceSeries.prototype.iz = function (a, b, c, d) {
        switch (b) {
            case FinancialSeries.$$p[9]:
                this.pj.ca();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pj.b2 = CategoryTrendLineManagerFactory.a(this.pj.b2, this.l8, this.jx, this, this.b2);
                }
                break;
        }
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.pj.b4 && this.pj.b2 != null && this.pj.b2.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        switch (b) {
            case FinancialPriceSeries.$$p[0]:
                if (this.jx != null) {
                    this.ps();
                    this.ma.w();
                    this.o1(this.ma, this.pj);
                }
                this.ik();
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case "TrendLineType":
                this.ik();
                break;
            case FinancialSeries.$$p[5]:
            case FinancialPriceSeries.$$p[1]:
                this.iw();
                break;
        }
    };
    FinancialPriceSeries.prototype.ps = function () {
        this.pj.ce();
        if (this.bh != null) {
            this.bh.ce();
        }
    };
    FinancialPriceSeries.prototype.an = function (a) {
        if (a != null && a == this.mt && this.m0 != null && !isNaN_(this.m0.minimum) && this.my != null && !isNaN_(this.my.maximum)) {
            return new AxisRange(this.m0.minimum, this.my.maximum);
        }
        return null;
    };
    FinancialPriceSeries.prototype.ao = function () {
        if (this.m0 == null || this.my == null) {
            return null;
        }
        var a = new ScalerParams(0, this.bs.mq, this.bs.m3, this.l8.b8, this.getEffectiveViewport());
        var b = (this.l8.dz(this.bs.m3.left, a));
        var c = (this.l8.dz(this.bs.m3.right, a));
        var d = null;
        if (this.l8.cd) {
            d = this.l8;
            b = d.i$f(b);
            c = d.i$f(c);
        }
        else {
            b = Math.floor(b);
            c = Math.ceil(c);
        }
        b = Math.max(0, Math.min(this.m0.count - 1, b));
        c = Math.max(0, Math.min(this.m0.count - 1, c));
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        for (var g = truncate(b); g <= truncate(c); g++) {
            var h = g;
            if (d != null) {
                h = d.i$b._inner[g];
            }
            e = Math.min(e, this.m0.item(h));
            f = Math.max(f, this.my.item(h));
        }
        return new AxisRange(e, f);
    };
    FinancialPriceSeries.prototype.eh = function () {
        return Series.ei(this.m2, typeCast(ISortingAxis_$type, this.l8));
    };
    FinancialPriceSeries.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bi.bs;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ls(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.l8 != null) {
                var g = new ScalerParams(0, e, e, this.l8.b8, f);
                var h = this.l8.dw(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.mt != null && this.m0 != null && this.my != null && b < this.m0.count && b < this.my.count) {
                var i = new ScalerParams(0, e, e, this.mt.b8, f);
                i.b = this.eh();
                var j = this.mt.dw(this.m0.item(b), i);
                var k = this.mt.dw(this.my.item(b), i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    FinancialPriceSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.m2 == null || this.mw == null || this.my == null || this.m0 == null) {
            d = false;
        }
        return d;
    };
    FinancialPriceSeries.prototype.oz = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.oz.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l8;
        var g = this.mt;
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, g.b8, e);
            $ret.b = _this.eh();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.l8);
        if (k != null && (k.i$b == null || k.i$b.count != this.bz.count)) {
            return;
        }
        j = this.nz(c, d, e);
        var l = typeCast(FinancialPriceSeriesView.$, b);
        var m = this.eu;
        if (this.trendLineType != 0) {
            var n = new Array(this.bz.count);
            var o = 0;
            try {
                for (var _b = __values(fromEnum(this.nq)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var p = _c.value;
                    n[o] = p;
                    o++;
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (this.pj.b4) {
                this.pj.b2.prepareLineCore(a.p, this.trendLineType, boxArray$1(n), this.trendLinePeriod, function (q) { return _this.l8.dw(q, h); }, function (q) { return _this.mt.dw(q, i); }, ((function () {
                    var $ret = new TrendResolutionParams();
                    $ret.c = b.bu.b;
                    $ret.d = b.bu.c;
                    $ret.e = b.bu.d;
                    $ret.a = j;
                    $ret.b = m;
                    $ret.f = d;
                    return $ret;
                })()));
            }
        }
        var q = this.l8.dz(2, h) - this.l8.dz(1, h);
        for (var r = b.bu.c; r <= b.bu.d; ++r) {
            var s = void 0;
            if (k == null) {
                s = b.bu.getBucket(r);
            }
            else {
                var t = k.i$b._inner[r];
                var u = k.i$d(t);
                var v = this.m2.item(t);
                var w = this.my.item(t);
                var x = this.m0.item(t);
                var y = this.mw.item(t);
                var z = v;
                var aa = w;
                var ab = x;
                var ac = y;
                var ad = u;
                while (r < b.bu.d) {
                    t = k.i$b._inner[r + 1];
                    ad = k.i$d(t);
                    if (ad - u > q * m) {
                        break;
                    }
                    r++;
                    aa = Math.max(aa, this.my.item(t));
                    ab = Math.min(ab, this.m0.item(t));
                    ac = this.mw.item(t);
                }
                var ae = NaN;
                if (!isNaN_(u)) {
                    ae = this.l8.dw(u, h);
                }
                s = [ae, z, aa, ab, ac];
            }
            if (!isNaN_(s[0])) {
                if (k != null) {
                    s[0] = s[0] + j;
                }
                else {
                    s[0] = f.dw(s[0], h) + j;
                }
                s[1] = g.dw(s[1], i);
                s[2] = g.dw(s[2], i);
                s[3] = g.dw(s[3], i);
                s[4] = g.dw(s[4], i);
                a.f.add(s);
            }
        }
        return;
    };
    FinancialPriceSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = typeCast(FinancialPriceSeriesView.$, b);
        c.b8();
        if (a) {
            c.b3.count = 0;
        }
        if (c.b4 && c.b2 != null) {
            c.b2.g$d();
        }
    };
    FinancialPriceSeries.prototype.get_nc = function () {
        return true;
    };
    FinancialPriceSeries.prototype.o1 = function (a, b) {
        _super.prototype.o1.call(this, a, b);
        if (this.l8 == null || this.mt == null) {
            return;
        }
        var c = false;
        if (b.bx(a)) {
            c = true;
            b.bz(a);
        }
        this.mg.x(this, this.ng(), this.l8, runOn(this, this.l0), this.n5(b), this.n7(b));
        var d = false;
        var e = this.mg.c;
        if (e != null) {
            d = true;
        }
        var f = typeCast(FinancialPriceSeriesView.$, b);
        f.b7();
        f.b5 = false;
        if (f.b4) {
            f.b2.g$d();
        }
        if (this.trendLineType != 0) {
            f.b2.g$g(a.p);
        }
        if (d) {
            this.pr(a, b, c);
        }
        else {
            f.b3.count = 0;
            this.pq(a, b);
        }
    };
    FinancialPriceSeries.prototype.eg = function () {
        var a = this.getEffectiveViewport1(this.bi);
        return this.pl(this.mo, a);
    };
    FinancialPriceSeries.prototype.pr = function (a, b, c) {
        var d = this.pk;
        var e = this.getEffectiveViewport1(b);
        var f = this.pl(b, e);
        var g = (f - 1) / 2;
        var h = typeCast(FinancialPriceSeriesView.$, b);
        h.b5 = true;
        var i = a.f;
        var j = 0;
        var k = this.bz.count;
        var l = this.l8;
        var m = new ScalerParams(0, b.bs, b.br, l.b8, e);
        var n = this.k3;
        var o = this.pe;
        if (o == null) {
            o = n;
        }
        var p = this.k4;
        var q = this.p4;
        if (q == null) {
            q = p;
        }
        var _loop_1 = function (r) {
            var s = i._inner[r][0] - g;
            var t = i._inner[r][0];
            var u = i._inner[r][0] + g;
            var v = i._inner[r][1];
            var w = i._inner[r][2];
            var x = i._inner[r][3];
            var y = i._inner[r][4];
            if (isNaN_(v) || isNaN_(w) || isNaN_(x) || isNaN_(y)) {
                return "continue";
            }
            var z = h.b3.item(j);
            j++;
            var aa = v < y;
            var ab = new PathGeometry();
            if (c) {
                switch (d) {
                    case 0:
                        if (aa) {
                            var ac = v;
                            v = y;
                            y = ac;
                        }
                        var ad = new PathFigure();
                        ad._startPoint = { $type: Point_$type, x: t, y: x };
                        ad._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        var ae = new PathFigure();
                        ae._startPoint = { $type: Point_$type, x: s, y: y };
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: y };
                            return $ret;
                        })()));
                        var af = new PathFigure();
                        af._startPoint = { $type: Point_$type, x: t, y: y };
                        af._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        ab.c.add(ad);
                        ab.c.add(ae);
                        ab.c.add(af);
                        break;
                    case 1:
                        var ag = new PathFigure();
                        ag._startPoint = { $type: Point_$type, x: s, y: v };
                        ag._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        var ah = new PathFigure();
                        ah._startPoint = { $type: Point_$type, x: t, y: x };
                        ah._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        var ai = new PathFigure();
                        ai._startPoint = { $type: Point_$type, x: t, y: y };
                        ai._segments.add(((function () {
                            var $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ab.c.add(ag);
                        ab.c.add(ah);
                        ab.c.add(ai);
                        break;
                }
            }
            if (aa) {
                this_1.mg.al = o;
                this_1.mg.ah = o;
                this_1.mg.am = this_1.mg.ai = q;
                this_1.mg.f = true;
            }
            else {
                this_1.mg.al = n;
                this_1.mg.ah = n;
                this_1.mg.am = this_1.mg.ai = p;
                this_1.mg.f = false;
            }
            this_1.oy(i, r, k, l, m, b.n);
            if (d == 1) {
                this_1.mg.ae(z, true, false, false, false);
            }
            else {
                this_1.mg.ae(z, false, false, false, false);
            }
            if (c) {
                z.ak = ab;
            }
        };
        var this_1 = this;
        for (var r = 0; r < i.count; ++r) {
            _loop_1(r);
        }
        h.b3.count = j;
        h.b9();
    };
    FinancialPriceSeries.prototype.pl = function (a, b) {
        var c = this.l8.jr(a.bs, a.br, b);
        c = Math.max(c, this.eu * 0.9);
        c = Math.max(c, 3);
        return c;
    };
    FinancialPriceSeries.prototype.pq = function (a, b) {
        var c = this.pk;
        var d = this.getEffectiveViewport1(b);
        var e = this.pl(b, d);
        var f = (e - 1) / 2;
        var g = typeCast(FinancialPriceSeriesView.$, b);
        var h = g.ch();
        var i = g.cg();
        var j = a.f;
        var _loop_2 = function (k) {
            var l = j._inner[k][0] - f;
            var m = j._inner[k][0];
            var n = j._inner[k][0] + f;
            var o = j._inner[k][1];
            var p = j._inner[k][2];
            var q = j._inner[k][3];
            var r = j._inner[k][4];
            if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                return "continue";
            }
            var s = o < r;
            var t = s ? i : h;
            switch (c) {
                case 0:
                    if (s) {
                        var u = o;
                        o = r;
                        r = u;
                    }
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new RectangleGeometry();
                        $ret.e = new Rect(0, l, r, n - l, o - r);
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    break;
                case 1:
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: l, y: o };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    t.d.add(((function () {
                        var $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: n, y: r };
                        return $ret;
                    })()));
                    break;
            }
        };
        for (var k = 0; k < j.count; ++k) {
            _loop_2(k);
        }
    };
    FinancialPriceSeries.prototype.fv = function (a, b) {
        if (this.pj.b4 && a == this.pj.b2.g$j) {
            return null;
        }
        return _super.prototype.fv.call(this, a, b);
    };
    FinancialPriceSeries.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.pj.cf();
    };
    FinancialPriceSeries.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        if (this.pj.b4) {
            this.a2.exportTrendlineData(this, a, this.pj.b2.g$j);
        }
    };
    FinancialPriceSeries.prototype.ji = function (a, b) {
        _super.prototype.ji.call(this, a, b);
        this.p4 = b;
    };
    FinancialPriceSeries.$t = markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialPriceSeries.pt = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialPriceSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:pk:pu', [PriceDisplayType_$type, enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:p4:pv', [Brush.$, null], 'TrendLineType::p1', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::p0', [1, 1.5], 'TrendLinePeriod::pz', [1, 7], 'TrendLineBrush::pw', [Brush.$, null], 'TrendLineZIndex:pn:p2', [1, 1001], 'TrendLineDashArray:p5:px', [DoubleCollection.$], 'TrendLineDashCap:p6:py', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialPriceSeries;
}(FinancialSeries));
/**
 * @hidden
 */
var FinancialPriceSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialPriceSeriesView, _super);
    function FinancialPriceSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b3 = null;
        _this.b6 = null;
        _this.ck = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.cj = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.b1 = null;
        _this.ci = new Path();
        _this.b5 = false;
        _this.b0 = a;
        _this.b6 = new List$1(Path.$, 0);
        _this.b3 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.cl);
            $ret.activate = runOn(_this, _this.cb);
            $ret.disactivate = runOn(_this, _this.cd);
            $ret.destroy = runOn(_this, _this.cc);
            return $ret;
        })());
        return _this;
    }
    FinancialPriceSeriesView.prototype.cl = function () {
        var a = new Path();
        this.b6.add(a);
        a._visibility = 1;
        return a;
    };
    FinancialPriceSeriesView.prototype.cb = function (a) {
        a._visibility = 0;
    };
    FinancialPriceSeriesView.prototype.cd = function (a) {
        a._visibility = 1;
    };
    FinancialPriceSeriesView.prototype.cc = function (a) {
        this.b6.remove(a);
    };
    FinancialPriceSeriesView.prototype.bv = function () {
        return new FinancialPriceBucketCalculator(this);
    };
    FinancialPriceSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.bw.pe = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.b0.p4 = this.bw.pe;
            this.bw.eu = 5;
            this.bw.ey = 1;
        }
    };
    Object.defineProperty(FinancialPriceSeriesView.prototype, "b2", {
        get: function () {
            if (this.b1 == null) {
                this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jx, this.e, this.e.b2);
            }
            return this.b1;
        },
        set: function (a) {
            this.b1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialPriceSeriesView.prototype, "b4", {
        get: function () {
            return this.b1 != null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialPriceSeriesView.prototype.ce = function () {
        if (this.b0.pk == 1) {
            this.ck._stroke = this.e.k3;
        }
        else {
            this.ck._stroke = this.e.k4;
        }
        if (this.b0.pk == 1) {
            this.cj._stroke = this.bw.pe;
        }
        else {
            this.cj._stroke = this.b0.p4;
        }
    };
    FinancialPriceSeriesView.prototype.b8 = function () {
        this.an();
        this.b3.count = 0;
        this.b7();
    };
    FinancialPriceSeriesView.prototype.b7 = function () {
        var a = typeCast(GeometryGroup.$, this.ck.ak);
        var b = typeCast(GeometryGroup.$, this.cj.ak);
        Extensions.d(a);
        Extensions.d(b);
    };
    FinancialPriceSeriesView.prototype.ch = function () {
        this.an();
        return typeCast(GeometryGroup.$, this.ck.ak);
    };
    FinancialPriceSeriesView.prototype.cg = function () {
        this.an();
        return typeCast(GeometryGroup.$, this.cj.ak);
    };
    FinancialPriceSeriesView.prototype.cf = function () {
        this.b0.p3 = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.p3 = this.b0.trendLineBrush;
        }
        else {
            this.b0.p3 = this.b0.k3;
        }
    };
    FinancialPriceSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.ck.ac = this.e.ey;
        this.ck.ai = this.e.lb;
        this.ck.ad = this.e.lc;
        if (this.b0.pk == 1) {
            this.ck._stroke = this.e.k3;
        }
        else {
            this.ck._stroke = this.e.k4;
            this.ck._fill = this.e.k3;
        }
        this.cj.ac = this.e.ey;
        this.cj.ai = this.e.lb;
        this.cj.ad = this.e.lc;
        if (this.b0.pk == 1) {
            this.cj._stroke = this.bw.pe;
        }
        else {
            this.cj._stroke = this.b0.p4;
            this.cj._fill = this.bw.pe;
        }
    };
    FinancialPriceSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.ck.ac = this.e.ey + 3;
        if (this.b0.pk == 1) {
            this.ck._stroke = a;
        }
        else {
            this.ck._stroke = a;
            this.ck._fill = a;
        }
        this.cj.ac = this.e.ey + 3;
        if (this.b0.pk == 1) {
            this.cj._stroke = a;
        }
        else {
            this.cj._stroke = a;
            this.cj._fill = a;
        }
    };
    FinancialPriceSeriesView.prototype.z = function (a) {
        return this.b6._inner[a];
    };
    FinancialPriceSeriesView.prototype.y = function (a) {
        var b = this.b6._inner[a];
        this.ci._visibility = b._visibility;
        this.ci.ak = b.ak;
        var c = this.bm(a);
        this.ci._fill = c;
        this.ci._stroke = c;
        this.ci.ac = this.e.ey + 3;
        return this.ci;
    };
    FinancialPriceSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (this.b5) {
                for (var c = 0; c < this.b6.count; c++) {
                    var d = this.x(c, b);
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
            else {
                a.s(this.ck);
                a.s(this.cj);
            }
        }
    };
    FinancialPriceSeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                var c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.p3;
                c.ai = this.b0.p5;
                c.ad = this.b0.p6;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    FinancialPriceSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.ck, "positivePathShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cj, "negativePathShape", ["Negative"]);
    };
    FinancialPriceSeriesView.prototype.b9 = function () {
        this.an();
    };
    FinancialPriceSeriesView.prototype.ca = function () {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.jx, this.e, this.e.b2);
        }
    };
    FinancialPriceSeriesView.$t = markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
    return FinancialPriceSeriesView;
}(FinancialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
 * Default required members: Open, Low, High, Close
*
* The `IgrFinancialPriceSeries` class represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*
*     <IgrCategoryXAxis name="xAxis" label="Date" />
*     <IgrNumericYAxis  name="yAxis" />
*
*
*     <IgrFinancialPriceSeries
*     name="series2"
*     xAxisName="xAxis"
*     yAxisName="yAxis"
*     displayType="Candlestick"
*     lowMemberPath="Low"
*     highMemberPath="High"
*     openMemberPath="Open"
*     closeMemberPath="Close"
*     volumeMemberPath="Volume" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrFinancialPriceSeries({name: "series"});
* this.series.dataSource = this.financialData;
* this.series.xAxis = this.timeXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "timeXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.highMemberPath="High" ;
* this.series.lowMemberPath="Low";
* this.series.closeMemberPath="Close";
* this.series.openMemberPath="Open";
* this.series.volumeMemberPath="Volume";
* ```
*/
var IgrFinancialPriceSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialPriceSeries, _super);
    function IgrFinancialPriceSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrFinancialPriceSeries.prototype.createImplementation = function () {
        return new FinancialPriceSeries();
    };
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current financial series.
        *
        * Use the `trendLineType` property for the trend type of the current financial series.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineType={this.state.trendLineType}  />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineType= "CubicFit";
        * ```
        */
        get: function () {
            return this.i.trendLineType;
        },
        set: function (v) {
            this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush to use to draw the trend line.
        *
        * Use the `trendLineBrush` property to brush the the trend line.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineBrush="Blue" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineBrush="red";
        * ```
        */
        get: function () {
            return brushToString(this.i.trendLineBrush);
        },
        set: function (v) {
            this.i.trendLineBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this FinancialPriceSeries.
        *
        * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
        *
        * ````ts
        * <IgrDataChart
        *         ref={this.onChartRef}
        *         dataSource={this.data}
        *         width="100%"
        *         height="100%" >
        *
        *         <IgrCategoryXAxis name="xAxis" label="Label" />
        *         <IgrNumericYAxis name="yAxis" />
        *
        *         <IgrFinancialPriceSeries
        *             name="series1"
        *             xAxisName="xAxis"
        *             yAxisName="yAxis"
        *             highMemberPath="High"
        *             lowMemberPath="Low"
        *             closeMemberPath="Close"
        *             openMemberPath="Open"
        *             volumeMemberPath="Volume"
        *             trendLineType={this.state.trendLineType}
        *             displayType= "Candlestick"
        *             trendLinePeriod = {2}
        *             actualTrendLineBrush= "blue"/>
        *
        *     </IgrDataChart>
        *
        * 	```
        * ````
        */
        get: function () {
            return brushToString(this.i.p3);
        },
        set: function (v) {
            this.i.p3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current FinancialPriceSeries object's trend line.
        *
        * Use the `trendLineThickness` property for the thickness of the current FinancialPriceSeries object's trend line.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLineThickness="3"/>
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLineThickness=5;
        * ```
        */
        get: function () {
            return this.i.trendLineThickness;
        },
        set: function (v) {
            this.i.trendLineThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the trend line period for the current series.
         * The typical, and initial, value for trend line period is 7.
        *
        * Use the `trendLinePeriod` property for the periodo the the current series.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	trendLinePeriod={7} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.trendLinePeriod= 7;
        * ```
        */
        get: function () {
            return this.i.trendLinePeriod;
        },
        set: function (v) {
            this.i.trendLinePeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "displayType", {
        /**
         * Gets or sets the display type for the current FinancialPriceSeries object.
        *
        * Use the `displayType` property for the display type of the current FinancialPriceSeries object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.displayType=PriceDisplayType.Candlestick;
        * ```
        */
        get: function () {
            return this.i.pk;
        },
        set: function (v) {
            this.i.pk = ensureEnum(PriceDisplayType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialPriceSeries.prototype, "negativeOutline", {
        /**
         * Brush to use for outlining negative elements in the series.
        *
        * Use the `negativeOutline` property to brush the outline negative elements in the series.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *
        *     <IgrCategoryXAxis name="xAxis" label="Date" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *
        *     <IgrFinancialPriceSeries
        *     name="series2"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     displayType="Candlestick"
        *     lowMemberPath="Low"
        *     highMemberPath="High"
        *     openMemberPath="Open"
        *     closeMemberPath="Close"
        *     volumeMemberPath="Volume"
        * 	negativeOutline="Red" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.negativeOutline="red";
        * ```
        */
        get: function () {
            return brushToString(this.i.p4);
        },
        set: function (v) {
            this.i.p4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method return the best available value bounding box within the series that has the best value match for the world position provided.
    */
    IgrFinancialPriceSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The categorySeries is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` methos scrolls the series to display the item for the specified data item.
    */
    IgrFinancialPriceSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * The `getItemSpan` method is used For a category plotted series, returns the current width of the items within the categories.
    *
    * This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned
    */
    IgrFinancialPriceSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    IgrFinancialPriceSeries.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.ji(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    return IgrFinancialPriceSeries;
}(IgrFinancialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinancialPriceSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialPriceSeriesModule() {
    }
    IgrFinancialPriceSeriesModule.register = function () {
        IgrFinancialPriceSeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrFinancialPriceSeries", IgrFinancialPriceSeries);
        TypeRegistrar.register("FinancialPriceSeries", FinancialPriceSeries.$type);
    };
    return IgrFinancialPriceSeriesModule;
}());

/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
var IgrColumnSupportingCalculation = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnSupportingCalculation() {
    }
    Object.defineProperty(IgrColumnSupportingCalculation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrColumnSupportingCalculation.prototype.onImplementationCreated = function () {
    };
    IgrColumnSupportingCalculation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return IgrColumnSupportingCalculation;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*
* `DataSourceSupportingCalculation` class Represents a calculation strategy that uses the calculation data source to product a column of values.
*
*     DataSourceSupportingCalculation SC = new DataSourceSupportingCalculation();
*/
var IgrDataSourceSupportingCalculation = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataSourceSupportingCalculation() {
    }
    Object.defineProperty(IgrDataSourceSupportingCalculation.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDataSourceSupportingCalculation.prototype.onImplementationCreated = function () {
    };
    IgrDataSourceSupportingCalculation.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return IgrDataSourceSupportingCalculation;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndicatorPane = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndicatorPane, _super);
    function IndicatorPane() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.d = null;
        _this.a = null;
        return _this;
    }
    IndicatorPane.prototype.h = function (a) {
        this.c = a;
        if (this.c == null) {
            return;
        }
        this.d = this.c.createElement("div");
        this.d.setStyleProperty("height", "100%");
        this.d.setStyleProperty("width", "100%");
        this.d.setStyleProperty("display", "grid");
        this.d.setStyleProperty("display", "-ms-grid");
        this.d.setStyleProperty("-ms-grid-columns", "100%");
        this.c.append(this.d);
        this.i();
    };
    IndicatorPane.prototype.i = function () {
        if (this.d == null) {
            return;
        }
        this.d.removeChildren();
        if (this.b == null) {
            return;
        }
        var a = "";
        for (var b = 0; b < this.b.count; b++) {
            var c = this.b._inner[b];
            var d = this.c.createElement("div");
            d.setStyleProperty("grid-row", (b + 1).toString());
            d.setStyleProperty("grid-column", (1).toString());
            d.setStyleProperty("-ms-grid-row", (b + 1).toString());
            d.setStyleProperty("-ms-grid-column", (1).toString());
            this.d.append(d);
            var e = this.c.getSubRenderer(d);
            c.provideContainer(e);
            a += " 1fr";
        }
        a = a.trim();
        this.d.setStyleProperty("-ms-grid-rows", a);
    };
    Object.defineProperty(IndicatorPane.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.b;
            if (a != b) {
                this.a = a;
                this.g("IndicatorCharts", b, this.b);
            }
        },
        enumerable: true,
        configurable: true
    });
    IndicatorPane.prototype.g = function (a, b, c) {
        switch (a) {
            case "IndicatorCharts":
                this.i();
                break;
        }
    };
    IndicatorPane.prototype.f = function () {
        var e_1, _a;
        if (this.b == null || this.c == null) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.notifyContainerResized();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IndicatorPane.$t = markType(IndicatorPane, 'IndicatorPane');
    return IndicatorPane;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available series types to display in the volume pane.
 */
var FinancialChartVolumeType = /*@__PURE__*/ (function (FinancialChartVolumeType) {
    /**
     * Do not display the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["None"] = 0] = "None";
    /**
     * Display column series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Column"] = 1] = "Column";
    /**
     * Display line series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Line"] = 2] = "Line";
    /**
     * Display area series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Area"] = 3] = "Area";
    return FinancialChartVolumeType;
})({});
/**
 * @hidden
 */
var FinancialChartVolumeType_$type = /*@__PURE__*/ markEnum('FinancialChartVolumeType', 'None,0|Column,1|Line,2|Area,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available X axis types in the Financial Chart.
 */
var FinancialChartXAxisMode = /*@__PURE__*/ (function (FinancialChartXAxisMode) {
    /**
     * An ordinal scale with time labels.
     * Items on an ordinal scale are consecutive and equidistant.
     */
    FinancialChartXAxisMode[FinancialChartXAxisMode["Ordinal"] = 0] = "Ordinal";
    /**
     * A time scale.
     * Items on a time scale are positioned according to their time values.
     */
    FinancialChartXAxisMode[FinancialChartXAxisMode["Time"] = 1] = "Time";
    return FinancialChartXAxisMode;
})({});
/**
 * @hidden
 */
var FinancialChartXAxisMode_$type = /*@__PURE__*/ markEnum('FinancialChartXAxisMode', 'Ordinal,0|Time,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available Y axis types in the Financial Chart.
 */
var FinancialChartYAxisMode = /*@__PURE__*/ (function (FinancialChartYAxisMode) {
    /**
     * A linear or logarithmic numeric scale.
     */
    FinancialChartYAxisMode[FinancialChartYAxisMode["Numeric"] = 0] = "Numeric";
    /**
     * A numeric scale where all values are scaled proportionally to a reference value.
     */
    FinancialChartYAxisMode[FinancialChartYAxisMode["PercentChange"] = 1] = "PercentChange";
    return FinancialChartYAxisMode;
})({});
/**
 * @hidden
 */
var FinancialChartYAxisMode_$type = /*@__PURE__*/ markEnum('FinancialChartYAxisMode', 'Numeric,0|PercentChange,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available price series types to display in the main chart.
 */
var FinancialChartType = /*@__PURE__*/ (function (FinancialChartType) {
    /**
     * Automatically determine the price series type to display in the main chart.
     */
    FinancialChartType[FinancialChartType["Auto"] = 0] = "Auto";
    /**
     * Display financial bar series in the main chart.
     */
    FinancialChartType[FinancialChartType["Bar"] = 1] = "Bar";
    /**
     * Display candlestick series in the main chart.
     */
    FinancialChartType[FinancialChartType["Candle"] = 2] = "Candle";
    /**
     * Display column series in the main chart.
     */
    FinancialChartType[FinancialChartType["Column"] = 3] = "Column";
    /**
     * Display line series in the main chart.
     */
    FinancialChartType[FinancialChartType["Line"] = 4] = "Line";
    return FinancialChartType;
})({});
/**
 * @hidden
 */
var FinancialChartType_$type = /*@__PURE__*/ markEnum('FinancialChartType', 'Auto,0|Bar,1|Candle,2|Column,3|Line,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available series types to display in the zoom slider pane.
 */
var FinancialChartZoomSliderType = /*@__PURE__*/ (function (FinancialChartZoomSliderType) {
    /**
     * Do not display the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["None"] = 0] = "None";
    /**
     * In the zoom slider pane, match the series type in the price pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Auto"] = 1] = "Auto";
    /**
     * Display financial bar series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Bar"] = 2] = "Bar";
    /**
     * Display candle series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Candle"] = 3] = "Candle";
    /**
     * Display column series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Column"] = 4] = "Column";
    /**
     * Display line series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Line"] = 5] = "Line";
    /**
     * Display an area series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Area"] = 6] = "Area";
    return FinancialChartZoomSliderType;
})({});
/**
 * @hidden
 */
var FinancialChartZoomSliderType_$type = /*@__PURE__*/ markEnum('FinancialChartZoomSliderType', 'None,0|Auto,1|Bar,2|Candle,3|Column,4|Line,5|Area,6');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the time range presets on a financial chart range selector.
 */
var FinancialChartRangeSelectorOption = /*@__PURE__*/ (function (FinancialChartRangeSelectorOption) {
    /**
     * Include a preset button for one month in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneMonth"] = 0] = "OneMonth";
    /**
     * Include a preset button for three months in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["ThreeMonths"] = 1] = "ThreeMonths";
    /**
     * Include a preset button for six months in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["SixMonths"] = 2] = "SixMonths";
    /**
     * Include a preset button for year-to-date in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["YearToDate"] = 3] = "YearToDate";
    /**
     * Include a preset button for one year in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneYear"] = 4] = "OneYear";
    /**
     * Include a preset button for all data in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["All"] = 5] = "All";
    return FinancialChartRangeSelectorOption;
})({});
/**
 * @hidden
 */
var FinancialChartRangeSelectorOption_$type = /*@__PURE__*/ markEnum('FinancialChartRangeSelectorOption', 'OneMonth,0|ThreeMonths,1|SixMonths,2|YearToDate,3|OneYear,4|All,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartRangeSelectorOptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelectorOptionCollection, _super);
    function FinancialChartRangeSelectorOptionCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, FinancialChartRangeSelectorOption_$type, 0) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialChartRangeSelectorOption_$type, 1, c) || this;
                }
                break;
        }
        return _this;
    }
    FinancialChartRangeSelectorOptionCollection.$t = markType(FinancialChartRangeSelectorOptionCollection, 'FinancialChartRangeSelectorOptionCollection', ObservableCollection$1.$.specialize(FinancialChartRangeSelectorOption_$type));
    return FinancialChartRangeSelectorOptionCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TemplatedHtmlControl = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TemplatedHtmlControl, _super);
    function TemplatedHtmlControl(a, b, c) {
        var _this = _super.call(this) || this;
        _this.j = null;
        _this.i = null;
        _this.e = null;
        _this.d = null;
        _this.i = TemplatedHtmlControl.h(b, a, c);
        _this.j = a;
        return _this;
    }
    TemplatedHtmlControl.f = function (a, b) {
        for (var c = 0; c < a.getChildCount(); c++) {
            var d = a.getChildAt(c);
            if (d.getNativeElement() != null) {
                var ele_ = d.getNativeElement();
                if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                    return d;
                }
                var e = TemplatedHtmlControl.f(d, b);
                if (e != null) {
                    return e;
                }
            }
        }
        return null;
    };
    TemplatedHtmlControl.a = function (a, b) {
        var c = new List$1(DomWrapper_$type, 0);
        for (var d = 0; d < a.getChildCount(); d++) {
            var e = a.getChildAt(d);
            if (e.getNativeElement() != null) {
                var ele_ = e.getNativeElement();
                if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                    c.add(e);
                }
                var f = TemplatedHtmlControl.a(e, b);
                if (f != null) {
                    c.o(f);
                }
            }
        }
        return c;
    };
    TemplatedHtmlControl.h = function (a, b, c) {
        return a;
    };
    Object.defineProperty(TemplatedHtmlControl.prototype, "g", {
        get: function () {
            if (this.e == null && this.d != null) {
                return this.d.rootWrapper;
            }
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: true,
        configurable: true
    });
    TemplatedHtmlControl.prototype.l = function (a) {
        if (a == null) {
            if (this.g != null) {
                this.g.remove();
            }
            return;
        }
        this.d = a;
    };
    TemplatedHtmlControl.c = function (a) {
        return null;
    };
    TemplatedHtmlControl.n = function (a, b, c, d) {
        TemplatedHtmlControl.m(a, d.al(b), c);
    };
    TemplatedHtmlControl.m = function (a, b, c) {
        if (c == null) {
            return;
        }
        var d = c.querySelector(a);
        if (d == null) {
            return;
        }
        d.setText(b);
    };
    TemplatedHtmlControl.prototype.b = function () {
        if (this.d == null || this.d.rootWrapper == null) {
            return NaN;
        }
        var a = this.d.rootWrapper.getOffset();
        return this.d.rootWrapper.width() + (a == null ? 0 : a.left);
    };
    TemplatedHtmlControl.prototype.k = function () {
        if (this.d == null || this.d.rootWrapper == null) {
            return;
        }
        this.d.rootWrapper.hide();
    };
    TemplatedHtmlControl.$t = markType(TemplatedHtmlControl, 'TemplatedHtmlControl');
    return TemplatedHtmlControl;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartContext, _super);
    function FinancialChartContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._vm = null;
        _this._template = null;
        _this._container = null;
        _this._toolbarContainer = null;
        _this._legendContainer = null;
        _this._indicatorsContainer = null;
        _this._volumeContainer = null;
        _this._zoomContainer = null;
        return _this;
    }
    Object.defineProperty(FinancialChartContext.prototype, "vm", {
        get: function () {
            return this._vm;
        },
        set: function (a) {
            this._vm = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "template", {
        get: function () {
            return this._template;
        },
        set: function (a) {
            this._template = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "container", {
        get: function () {
            return this._container;
        },
        set: function (a) {
            this._container = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "toolbarContainer", {
        get: function () {
            return this._toolbarContainer;
        },
        set: function (a) {
            this._toolbarContainer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "legendContainer", {
        get: function () {
            return this._legendContainer;
        },
        set: function (a) {
            this._legendContainer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "indicatorsContainer", {
        get: function () {
            return this._indicatorsContainer;
        },
        set: function (a) {
            this._indicatorsContainer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "volumeContainer", {
        get: function () {
            return this._volumeContainer;
        },
        set: function (a) {
            this._volumeContainer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartContext.prototype, "zoomContainer", {
        get: function () {
            return this._zoomContainer;
        },
        set: function (a) {
            this._zoomContainer = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartContext.$t = markType(FinancialChartContext, 'FinancialChartContext');
    return FinancialChartContext;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartToolbarContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbarContext, _super);
    function FinancialChartToolbarContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._vm = null;
        _this._template = null;
        _this._container = null;
        return _this;
    }
    Object.defineProperty(FinancialChartToolbarContext.prototype, "vm", {
        get: function () {
            return this._vm;
        },
        set: function (a) {
            this._vm = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarContext.prototype, "template", {
        get: function () {
            return this._template;
        },
        set: function (a) {
            this._template = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarContext.prototype, "container", {
        get: function () {
            return this._container;
        },
        set: function (a) {
            this._container = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbarContext.$t = markType(FinancialChartToolbarContext, 'FinancialChartToolbarContext');
    return FinancialChartToolbarContext;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartViewModel, _super);
    function FinancialChartViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._toolbar = null;
        return _this;
    }
    Object.defineProperty(FinancialChartViewModel.prototype, "toolbar", {
        get: function () {
            return this._toolbar;
        },
        set: function (a) {
            this._toolbar = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartViewModel.$t = markType(FinancialChartViewModel, 'FinancialChartViewModel');
    return FinancialChartViewModel;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartToolbarViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbarViewModel, _super);
    function FinancialChartToolbarViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._financialChartRangeSelector = null;
        _this._financialChartTypePicker = null;
        _this._financialChartIndicatorMenu = null;
        _this._isIndicatorMenuVisible = false;
        return _this;
    }
    Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartRangeSelector", {
        get: function () {
            return this._financialChartRangeSelector;
        },
        set: function (a) {
            this._financialChartRangeSelector = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartTypePicker", {
        get: function () {
            return this._financialChartTypePicker;
        },
        set: function (a) {
            this._financialChartTypePicker = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarViewModel.prototype, "financialChartIndicatorMenu", {
        get: function () {
            return this._financialChartIndicatorMenu;
        },
        set: function (a) {
            this._financialChartIndicatorMenu = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarViewModel.prototype, "isIndicatorMenuVisible", {
        get: function () {
            return this._isIndicatorMenuVisible;
        },
        set: function (a) {
            this._isIndicatorMenuVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbarViewModel.$t = markType(FinancialChartToolbarViewModel, 'FinancialChartToolbarViewModel');
    return FinancialChartToolbarViewModel;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var FinancialOverlayType = /*@__PURE__*/ (function (FinancialOverlayType) {
    /**
     * Bollinger bands overlay.
     */
    FinancialOverlayType[FinancialOverlayType["BollingerBands"] = 0] = "BollingerBands";
    /**
     * Price channel overlay.
     */
    FinancialOverlayType[FinancialOverlayType["PriceChannel"] = 1] = "PriceChannel";
    return FinancialOverlayType;
})({});
/**
 * @hidden
 */
var FinancialOverlayType_$type = /*@__PURE__*/ markEnum('FinancialOverlayType', 'BollingerBands,0|PriceChannel,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var FinancialIndicatorType = /*@__PURE__*/ (function (FinancialIndicatorType) {
    /**
     * Absolute volume oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AbsoluteVolumeOscillator"] = 0] = "AbsoluteVolumeOscillator";
    /**
     * Accumulation distribution indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AccumulationDistribution"] = 1] = "AccumulationDistribution";
    /**
     * Average directional index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AverageDirectionalIndex"] = 2] = "AverageDirectionalIndex";
    /**
     * Average true range indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AverageTrueRange"] = 3] = "AverageTrueRange";
    /**
     * Bollinger band width indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["BollingerBandWidth"] = 4] = "BollingerBandWidth";
    /**
     * Chaikin oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ChaikinOscillator"] = 5] = "ChaikinOscillator";
    /**
     * Chaikin volatility indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ChaikinVolatility"] = 6] = "ChaikinVolatility";
    /**
     * Commodity channel index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["CommodityChannelIndex"] = 7] = "CommodityChannelIndex";
    /**
     * Detrended price oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["DetrendedPriceOscillator"] = 8] = "DetrendedPriceOscillator";
    /**
     * Ease of movement indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["EaseOfMovement"] = 9] = "EaseOfMovement";
    /**
     * Fast stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["FastStochasticOscillator"] = 10] = "FastStochasticOscillator";
    /**
     * Force index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ForceIndex"] = 11] = "ForceIndex";
    /**
     * Full stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["FullStochasticOscillator"] = 12] = "FullStochasticOscillator";
    /**
     * Market facilitation index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MarketFacilitationIndex"] = 13] = "MarketFacilitationIndex";
    /**
     * Mass index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MassIndex"] = 14] = "MassIndex";
    /**
     * Median price indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MedianPrice"] = 15] = "MedianPrice";
    /**
     * Money flow index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MoneyFlowIndex"] = 16] = "MoneyFlowIndex";
    /**
     * Moving average convergence divergence (MACD) indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MovingAverageConvergenceDivergence"] = 17] = "MovingAverageConvergenceDivergence";
    /**
     * Negative volume index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["NegativeVolumeIndex"] = 18] = "NegativeVolumeIndex";
    /**
     * On balance volume indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["OnBalanceVolume"] = 19] = "OnBalanceVolume";
    /**
     * Percentage price oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PercentagePriceOscillator"] = 20] = "PercentagePriceOscillator";
    /**
     * Percentage volume oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PercentageVolumeOscillator"] = 21] = "PercentageVolumeOscillator";
    /**
     * Positive volume index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PositiveVolumeIndex"] = 22] = "PositiveVolumeIndex";
    /**
     * Price volume trend indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PriceVolumeTrend"] = 23] = "PriceVolumeTrend";
    /**
     * Rate of change and momentum indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["RateOfChangeAndMomentum"] = 24] = "RateOfChangeAndMomentum";
    /**
     * Relative strength index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["RelativeStrengthIndex"] = 25] = "RelativeStrengthIndex";
    /**
     * Slow stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["SlowStochasticOscillator"] = 26] = "SlowStochasticOscillator";
    /**
     * Standard deviation indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["StandardDeviation"] = 27] = "StandardDeviation";
    /**
     * StochRSI indicator.
     * Stochastic Relative Strength Index.
     */
    FinancialIndicatorType[FinancialIndicatorType["StochRSI"] = 28] = "StochRSI";
    /**
     * TRIX indicator.
     * TRIple eXponential.
     */
    FinancialIndicatorType[FinancialIndicatorType["TRIX"] = 29] = "TRIX";
    /**
     * Typical price indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["TypicalPrice"] = 30] = "TypicalPrice";
    /**
     * Ultimate oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["UltimateOscillator"] = 31] = "UltimateOscillator";
    /**
     * Weighted close indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["WeightedClose"] = 32] = "WeightedClose";
    /**
     * Williams %R indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["WilliamsPercentR"] = 33] = "WilliamsPercentR";
    return FinancialIndicatorType;
})({});
/**
 * @hidden
 */
var FinancialIndicatorType_$type = /*@__PURE__*/ markEnum('FinancialIndicatorType', 'AbsoluteVolumeOscillator,0|AccumulationDistribution,1|AverageDirectionalIndex,2|AverageTrueRange,3|BollingerBandWidth,4|ChaikinOscillator,5|ChaikinVolatility,6|CommodityChannelIndex,7|DetrendedPriceOscillator,8|EaseOfMovement,9|FastStochasticOscillator,10|ForceIndex,11|FullStochasticOscillator,12|MarketFacilitationIndex,13|MassIndex,14|MedianPrice,15|MoneyFlowIndex,16|MovingAverageConvergenceDivergence,17|NegativeVolumeIndex,18|OnBalanceVolume,19|PercentagePriceOscillator,20|PercentageVolumeOscillator,21|PositiveVolumeIndex,22|PriceVolumeTrend,23|RateOfChangeAndMomentum,24|RelativeStrengthIndex,25|SlowStochasticOscillator,26|StandardDeviation,27|StochRSI,28|TRIX,29|TypicalPrice,30|UltimateOscillator,31|WeightedClose,32|WilliamsPercentR,33');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartRangeSelectorVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelectorVisualData, _super);
    function FinancialChartRangeSelectorVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._visibility = null;
        _this._buttonVisibilities = null;
        _this._buttonLabels = null;
        _this._buttonsChecked = null;
        _this._buttonLefts = null;
        _this._buttonTops = null;
        _this._buttonWidths = null;
        _this._buttonHeights = null;
        _this._left = 0;
        _this._top = 0;
        _this._width = 0;
        _this._height = 0;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "visibility", {
        get: function () {
            return this._visibility;
        },
        set: function (a) {
            this._visibility = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonVisibilities", {
        get: function () {
            return this._buttonVisibilities;
        },
        set: function (a) {
            this._buttonVisibilities = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonLabels", {
        get: function () {
            return this._buttonLabels;
        },
        set: function (a) {
            this._buttonLabels = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonsChecked", {
        get: function () {
            return this._buttonsChecked;
        },
        set: function (a) {
            this._buttonsChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonLefts", {
        get: function () {
            return this._buttonLefts;
        },
        set: function (a) {
            this._buttonLefts = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonTops", {
        get: function () {
            return this._buttonTops;
        },
        set: function (a) {
            this._buttonTops = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonWidths", {
        get: function () {
            return this._buttonWidths;
        },
        set: function (a) {
            this._buttonWidths = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "buttonHeights", {
        get: function () {
            return this._buttonHeights;
        },
        set: function (a) {
            this._buttonHeights = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "left", {
        get: function () {
            return this._left;
        },
        set: function (a) {
            this._left = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "top", {
        get: function () {
            return this._top;
        },
        set: function (a) {
            this._top = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorVisualData.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorVisualData.prototype.serialize = function () {
        return FinancialChartVisualData.y(["buttonLabels", "buttonsChecked", "buttonLefts", "buttonTops", "buttonWidths", "buttonHeights", "left", "top", "width", "height"], [this.buttonLabels, this.buttonsChecked, this.buttonLefts, this.buttonTops, this.buttonWidths, this.buttonHeights, this.left, this.top, this.width, this.height]);
    };
    FinancialChartRangeSelectorVisualData.$t = markType(FinancialChartRangeSelectorVisualData, 'FinancialChartRangeSelectorVisualData');
    return FinancialChartRangeSelectorVisualData;
}(Base));
/**
 * @hidden
 */
var FinancialChartEnumPickerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartEnumPickerVisualData, _super);
    function FinancialChartEnumPickerVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.g = null;
        _this.d = 0;
        _this.e = 0;
        _this.f = 0;
        _this.c = 0;
        _this.b = false;
        return _this;
    }
    FinancialChartEnumPickerVisualData.prototype.h = function () {
        return FinancialChartVisualData.y(["items", "selectedItem", "left", "top", "width", "height", "isVisible"], [this.a, this.g, this.d, this.e, this.f, this.c, this.b]);
    };
    FinancialChartEnumPickerVisualData.$t = markType(FinancialChartEnumPickerVisualData, 'FinancialChartEnumPickerVisualData');
    return FinancialChartEnumPickerVisualData;
}(Base));
/**
 * @hidden
 */
var FinancialChartToolbarVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbarVisualData, _super);
    function FinancialChartToolbarVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._chartTypePicker = null;
        _this._rangeSelector = null;
        return _this;
    }
    Object.defineProperty(FinancialChartToolbarVisualData.prototype, "chartTypePicker", {
        get: function () {
            return this._chartTypePicker;
        },
        set: function (a) {
            this._chartTypePicker = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbarVisualData.prototype, "rangeSelector", {
        get: function () {
            return this._rangeSelector;
        },
        set: function (a) {
            this._rangeSelector = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbarVisualData.prototype.serialize = function () {
        return FinancialChartVisualData.y(["chartTypePicker", "rangeSelector"], [this.chartTypePicker == null ? null : this.chartTypePicker.h(), this.rangeSelector == null ? null : this.rangeSelector.serialize()]);
    };
    FinancialChartToolbarVisualData.$t = markType(FinancialChartToolbarVisualData, 'FinancialChartToolbarVisualData');
    return FinancialChartToolbarVisualData;
}(Base));
/**
 * @hidden
 */
var FinancialChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartVisualData, _super);
    function FinancialChartVisualData() {
        var _this = _super.call(this) || this;
        _this._mainChart = null;
        _this._volumeChart = null;
        _this._indicatorCharts = null;
        _this._toolbar = null;
        _this._zoomChart = null;
        _this._mainChartLeft = 0;
        _this._mainChartTop = 0;
        _this._volumeChartLeft = 0;
        _this._volumeChartTop = 0;
        _this._indicatorChartLefts = null;
        _this._indicatorChartTops = null;
        _this._zoomChartLeft = 0;
        _this._zoomChartTop = 0;
        _this._toolbarLeft = 0;
        _this._toolbarTop = 0;
        _this._toolbarWidth = 0;
        _this._toolbarHeight = 0;
        _this._legendLeft = 0;
        _this._legendTop = 0;
        _this._legendWidth = 0;
        _this._legendHeight = 0;
        _this._legend = null;
        _this.mainChartLeft = NaN;
        _this.mainChartTop = NaN;
        _this.volumeChartLeft = NaN;
        _this.volumeChartTop = NaN;
        _this.zoomChartLeft = NaN;
        _this.zoomChartTop = NaN;
        _this.indicatorChartLefts = new List$1(Number_$type, 0);
        _this.indicatorChartTops = new List$1(Number_$type, 0);
        return _this;
    }
    Object.defineProperty(FinancialChartVisualData.prototype, "mainChart", {
        get: function () {
            return this._mainChart;
        },
        set: function (a) {
            this._mainChart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "volumeChart", {
        get: function () {
            return this._volumeChart;
        },
        set: function (a) {
            this._volumeChart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "indicatorCharts", {
        get: function () {
            return this._indicatorCharts;
        },
        set: function (a) {
            this._indicatorCharts = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "toolbar", {
        get: function () {
            return this._toolbar;
        },
        set: function (a) {
            this._toolbar = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "zoomChart", {
        get: function () {
            return this._zoomChart;
        },
        set: function (a) {
            this._zoomChart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "mainChartLeft", {
        get: function () {
            return this._mainChartLeft;
        },
        set: function (a) {
            this._mainChartLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "mainChartTop", {
        get: function () {
            return this._mainChartTop;
        },
        set: function (a) {
            this._mainChartTop = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "volumeChartLeft", {
        get: function () {
            return this._volumeChartLeft;
        },
        set: function (a) {
            this._volumeChartLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "volumeChartTop", {
        get: function () {
            return this._volumeChartTop;
        },
        set: function (a) {
            this._volumeChartTop = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "indicatorChartLefts", {
        get: function () {
            return this._indicatorChartLefts;
        },
        set: function (a) {
            this._indicatorChartLefts = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "indicatorChartTops", {
        get: function () {
            return this._indicatorChartTops;
        },
        set: function (a) {
            this._indicatorChartTops = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "zoomChartLeft", {
        get: function () {
            return this._zoomChartLeft;
        },
        set: function (a) {
            this._zoomChartLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "zoomChartTop", {
        get: function () {
            return this._zoomChartTop;
        },
        set: function (a) {
            this._zoomChartTop = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "toolbarLeft", {
        get: function () {
            return this._toolbarLeft;
        },
        set: function (a) {
            this._toolbarLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "toolbarTop", {
        get: function () {
            return this._toolbarTop;
        },
        set: function (a) {
            this._toolbarTop = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "toolbarWidth", {
        get: function () {
            return this._toolbarWidth;
        },
        set: function (a) {
            this._toolbarWidth = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "toolbarHeight", {
        get: function () {
            return this._toolbarHeight;
        },
        set: function (a) {
            this._toolbarHeight = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "legendLeft", {
        get: function () {
            return this._legendLeft;
        },
        set: function (a) {
            this._legendLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "legendTop", {
        get: function () {
            return this._legendTop;
        },
        set: function (a) {
            this._legendTop = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "legendWidth", {
        get: function () {
            return this._legendWidth;
        },
        set: function (a) {
            this._legendWidth = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "legendHeight", {
        get: function () {
            return this._legendHeight;
        },
        set: function (a) {
            this._legendHeight = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartVisualData.prototype, "legend", {
        get: function () {
            return this._legend;
        },
        set: function (a) {
            this._legend = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartVisualData.prototype.ab = function (a) {
        if (a != null) {
            var chart_ = a;
            chart_.scaleByViewport();
        }
    };
    FinancialChartVisualData.prototype.scaleByViewport = function () {
        this.ab(this.mainChart);
        this.ab(this.volumeChart);
        if (this.indicatorCharts != null) {
            for (var a = 0; a < this.indicatorCharts.count; a++) {
                this.ab(this.indicatorCharts._inner[a]);
            }
        }
        this.ab(this.zoomChart);
    };
    FinancialChartVisualData.prototype.w = function (a) {
        if (a != null) {
            var chart_ = a;
            return (chart_.serialize());
        }
        return null;
    };
    FinancialChartVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        if (this.volumeChart != null) {
            a.u("volumeChart: " + this.w(this.volumeChart) + ",");
        }
        if (this.zoomChart != null) {
            a.u("zoomChart: " + this.w(this.zoomChart) + ",");
        }
        if (this.indicatorCharts != null) {
            a.u("indicatorCharts: [");
            for (var b = 0; b < this.indicatorCharts.count; b++) {
                if (b > 0) {
                    a.u(",");
                }
                a.l(this.w(this.indicatorCharts._inner[b]));
            }
            a.t();
            a.u("],");
        }
        if (this.toolbar != null) {
            a.u("toolbar: " + this.toolbar.serialize() + ",");
        }
        if (this.mainChart != null) {
            a.u("mainChart: " + this.w(this.mainChart) + ",");
        }
        a.u("mainChartLeft: " + this.mainChartLeft.toString() + ",");
        a.u("mainChartTop: " + this.mainChartTop.toString() + ",");
        a.u("volumeChartLeft: " + this.volumeChartLeft.toString() + ",");
        a.u("volumeChartTop: " + this.volumeChartTop.toString() + ",");
        a.u("zoomChartLeft: " + this.zoomChartLeft.toString() + ",");
        a.u("zoomChartTop: " + this.zoomChartTop.toString() + ",");
        a.u("toolbarLeft: " + this.toolbarLeft.toString() + ",");
        a.u("toolbarTop: " + this.toolbarTop.toString() + ",");
        a.u("toolbarWidth: " + this.toolbarWidth.toString() + ",");
        a.u("toolbarHeight: " + this.toolbarHeight.toString() + ",");
        a.u("indicatorChartLefts: [");
        for (var c = 0; c < this.indicatorChartLefts.count; c++) {
            if (c > 0) {
                a.u(",");
            }
            a.k(this.indicatorChartLefts._inner[c]);
        }
        a.t();
        a.u("],");
        a.u("indicatorChartTops: [");
        for (var d = 0; d < this.indicatorChartTops.count; d++) {
            if (d > 0) {
                a.u(",");
            }
            a.k(this.indicatorChartTops._inner[d]);
        }
        a.t();
        a.u("],");
        a.u(stringFormat("legendLeft: {0},", this.legendLeft));
        a.u(stringFormat("legendTop: {0},", this.legendTop));
        a.u(stringFormat("legendWidth: {0},", this.legendWidth));
        a.u(stringFormat("legendHeight: {0},", this.legendHeight));
        var e;
        if (this.legend != null) {
            e = (this.legend.serialize());
        }
        else {
            e = "null";
        }
        a.u(stringFormat("legend: {0}", e));
        a.u("}");
        return a.toString();
    };
    FinancialChartVisualData.y = function (a, b) {
        var c = new StringBuilder(0);
        c.u("{");
        for (var d = 0; d < a.length; d++) {
            c.l(a[d] + ": " + FinancialChartVisualData.aa(b[d]));
            if (d < a.length - 1) {
                c.l(", ");
            }
            c.t();
        }
        c.l("}");
        return c.toString();
    };
    FinancialChartVisualData.aa = function (a) {
        if (a == null) {
            return "null";
        }
        if (typeof a === 'string' && !stringStartsWith(a, "{")) {
            return "\"" + a + "\"";
        }
        if (typeCast(IList_$type, a) !== null) {
            return FinancialChartVisualData.z(a);
        }
        if (typeCast(Array_$type, a) !== null) {
            return FinancialChartVisualData.z(boxArray$1(a));
        }
        return a.toString();
    };
    FinancialChartVisualData.z = function (a) {
        var e_1, _a;
        if (a == null) {
            return "null";
        }
        var b = new StringBuilder(0);
        b.l("[");
        var c = 0;
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.l(FinancialChartVisualData.aa(d));
                if (++c < a.count) {
                    b.l(", ");
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        b.l("]");
        return b.toString();
    };
    FinancialChartVisualData.$t = markType(FinancialChartVisualData, 'FinancialChartVisualData');
    return FinancialChartVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartCustomIndicatorArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartCustomIndicatorArgs, _super);
    function FinancialChartCustomIndicatorArgs(a, b, c) {
        var _this = _super.call(this) || this;
        _this._indicatorInfo = null;
        _this._series = null;
        _this._index = 0;
        _this.index = c;
        _this.indicatorInfo = a;
        _this.series = b;
        return _this;
    }
    Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "indicatorInfo", {
        get: function () {
            return this._indicatorInfo;
        },
        set: function (a) {
            this._indicatorInfo = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartCustomIndicatorArgs.prototype, "index", {
        get: function () {
            return this._index;
        },
        set: function (a) {
            this._index = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartCustomIndicatorArgs.$t = markType(FinancialChartCustomIndicatorArgs, 'FinancialChartCustomIndicatorArgs', EventArgs.$);
    return FinancialChartCustomIndicatorArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartDropDownControl = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartDropDownControl, _super);
    function FinancialChartDropDownControl(a, b, c) {
        var _this = _super.call(this, a, b, c) || this;
        _this.selectionChanged = null;
        _this.o = null;
        _this.p = null;
        return _this;
    }
    FinancialChartDropDownControl.prototype.v = function () {
        if (this.selectionChanged != null) {
            this.selectionChanged(this, EventArgs.empty);
        }
    };
    FinancialChartDropDownControl.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.o.f(this.d, this.p, this.s, this.t);
    };
    FinancialChartDropDownControl.prototype.get_q = function () {
        return false;
    };
    Object.defineProperty(FinancialChartDropDownControl.prototype, "q", {
        get: function () {
            return this.get_q();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartDropDownControl.prototype.u = function (a) {
        if (this.p.isOpen) {
            var b = a.target;
            var c = b.matches(this.s + " *");
            var d = c || (this.q && b.matches(this.t + " *"));
            if (!d) {
                this.p.isOpen = false;
                this.p.updateUI();
            }
        }
    };
    FinancialChartDropDownControl.$t = markType(FinancialChartDropDownControl, 'FinancialChartDropDownControl', TemplatedHtmlControl.$);
    return FinancialChartDropDownControl;
}(TemplatedHtmlControl));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartDropDownControlViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartDropDownControlViewModel, _super);
    function FinancialChartDropDownControlViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._onSelectionChanged = null;
        _this._isOpen = false;
        _this._notifyChanged = null;
        _this.a = null;
        return _this;
    }
    Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "onSelectionChanged", {
        get: function () {
            return this._onSelectionChanged;
        },
        set: function (a) {
            this._onSelectionChanged = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "isOpen", {
        get: function () {
            return this._isOpen;
        },
        set: function (a) {
            this._isOpen = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartDropDownControlViewModel.prototype, "notifyChanged", {
        get: function () {
            return this._notifyChanged;
        },
        set: function (a) {
            this._notifyChanged = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartDropDownControlViewModel.prototype.updateUI = function () {
        if (this.notifyChanged != null) {
            this.notifyChanged();
        }
    };
    FinancialChartDropDownControlViewModel.prototype.onButtonPressed = function () {
        this.isOpen = !this.isOpen;
        this.updateUI();
    };
    FinancialChartDropDownControlViewModel.prototype.handleDropDownClick = function (a) {
        if (this.a != null) {
            this.a(a);
        }
    };
    FinancialChartDropDownControlViewModel.$t = markType(FinancialChartDropDownControlViewModel, 'FinancialChartDropDownControlViewModel');
    return FinancialChartDropDownControlViewModel;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartTypePickerViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartTypePickerViewModel, _super);
    function FinancialChartTypePickerViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._chartType = 0;
        return _this;
    }
    Object.defineProperty(FinancialChartTypePickerViewModel.prototype, "chartType", {
        get: function () {
            return this._chartType;
        },
        set: function (a) {
            this._chartType = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartTypePickerViewModel.prototype, "chartTypeString", {
        get: function () {
            return EnumUtil.getName(FinancialChartType_$type, this.chartType);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePickerViewModel.$t = markType(FinancialChartTypePickerViewModel, 'FinancialChartTypePickerViewModel', FinancialChartDropDownControlViewModel.$);
    return FinancialChartTypePickerViewModel;
}(FinancialChartDropDownControlViewModel));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartDropDownControlView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartDropDownControlView, _super);
    function FinancialChartDropDownControlView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = false;
        _this.c = false;
        _this.d = null;
        _this.e = null;
        _this.a = null;
        return _this;
    }
    FinancialChartDropDownControlView.prototype.i = function (a) {
        if (!this.b && !this.c) {
            this.g();
        }
        this.b = false;
        this.c = false;
    };
    FinancialChartDropDownControlView.prototype.h = function (a) {
        this.b = true;
    };
    FinancialChartDropDownControlView.prototype.k = function (a) {
    };
    FinancialChartDropDownControlView.prototype.j = function (a) {
        this.c = true;
        this.k(a.target);
    };
    FinancialChartDropDownControlView.prototype.f = function (a, b, c, d) {
        this.a = b;
        this.a.a = runOn(this, this.j);
        this.d = a.querySelector(c);
        this.d.listen("click", runOn(this, this.h));
        this.e = a.querySelector(d);
        this.e.setStyleProperty("display", "none");
        this.e.listen("click", runOn(this, this.j));
        document.addEventListener("click", runOn(this, this.i), false);
    };
    FinancialChartDropDownControlView.prototype.g = function () {
        this.a.isOpen = false;
        this.a.updateUI();
    };
    FinancialChartDropDownControlView.$t = markType(FinancialChartDropDownControlView, 'FinancialChartDropDownControlView');
    return FinancialChartDropDownControlView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartTypePickerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartTypePickerView, _super);
    function FinancialChartTypePickerView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(FinancialChartTypePickerView.prototype, "l", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePickerView.prototype.k = function (a) {
        _super.prototype.k.call(this, a);
        var b = a;
        var c = b.parentNode;
        for (var d = 0; d < c.children.length; d++) {
            var e = c.children.item(d);
            if (e != b) {
                e.classList.remove("checked");
            }
        }
        var f = b.getAttribute("data-value");
        if (stringIsNullOrEmpty(f)) {
            return;
        }
        var g = EnumUtil.parse(FinancialChartType_$type, f, true);
        this.l.chartType = EnumUtil.getEnumValue(FinancialChartType_$type, g);
        this.g();
        this.a.onSelectionChanged();
    };
    FinancialChartTypePickerView.$t = markType(FinancialChartTypePickerView, 'FinancialChartTypePickerView', FinancialChartDropDownControlView.$);
    return FinancialChartTypePickerView;
}(FinancialChartDropDownControlView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartTypePicker = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartTypePicker, _super);
    function FinancialChartTypePicker(a) {
        var _this = _super.call(this, "financialChartTypePicker", a, FinancialChartTypePicker.z) || this;
        _this.o = new FinancialChartTypePickerView();
        _this.p = new FinancialChartTypePickerViewModel();
        _this.p.onSelectionChanged = runOn(_this, _this.v);
        _this.p.a = runOn(_this.o, _this.o.j);
        _this.o.a = _this.p;
        return _this;
    }
    Object.defineProperty(FinancialChartTypePicker.prototype, "w", {
        get: function () {
            return this.y.chartType;
        },
        set: function (a) {
            this.y.chartType = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartTypePicker.prototype, "x", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartTypePicker.prototype, "y", {
        get: function () {
            return this.p;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePicker.prototype.get_s = function () {
        return ".financialChartTypePickerDropDownButton";
    };
    Object.defineProperty(FinancialChartTypePicker.prototype, "s", {
        get: function () {
            return this.get_s();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePicker.prototype.get_t = function () {
        return ".financialChartTypePickerDropDownMenu";
    };
    Object.defineProperty(FinancialChartTypePicker.prototype, "t", {
        get: function () {
            return this.get_t();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePicker.$t = markType(FinancialChartTypePicker, 'FinancialChartTypePicker', FinancialChartDropDownControl.$);
    FinancialChartTypePicker.z = "<button class='financialChartTypePickerDropDownButton' data-value='Auto'>\r\n\t\t<span class='ui-icon ui-icon-changeable'></span>\r\n\t\t<span class='ui-icon-toolbar-dd'></span>\r\n\t</button>\r\n\r\n\t<div class='financialChartTypePickerDropDownMenu'>\r\n\t\t<ul>\r\n\t\t\t<li class='financialChartListItem' data-value='Auto'>\r\n\t\t\t<span class='ui-icon ui-icon-chartAuto'></span>\r\n\t\t\t<span>Auto</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Bar'>\r\n\t\t\t\t<span class='ui-icon ui-icon-BarIcon'></span>\r\n\t\t\t\t<span>Bar</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Line'>\r\n\t\t\t\t<span class='ui-icon ui-icon-LineIcon'></span>\r\n\t\t\t\t<span>Line</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Candle'>\r\n\t\t\t\t<span class='ui-icon ui-icon-CandleIcon'></span>\r\n\t\t\t\t<span>Candle</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Column'>\r\n\t\t\t\t<span class='ui-icon ui-icon-ColumnIcon'></span>\r\n\t\t\t\t<span>Column</span>\r\n\t\t\t</li>\r\n\t\t</ul>\r\n\t</div>";
    return FinancialChartTypePicker;
}(FinancialChartDropDownControl));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenuViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenuViewModel, _super);
    function FinancialChartIndicatorMenuViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = null;
        _this.j = null;
        _this.k = 0;
        _this.h = 0;
        return _this;
    }
    FinancialChartIndicatorMenuViewModel.$t = markType(FinancialChartIndicatorMenuViewModel, 'FinancialChartIndicatorMenuViewModel', FinancialChartDropDownControlViewModel.$);
    return FinancialChartIndicatorMenuViewModel;
}(FinancialChartDropDownControlViewModel));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenuItem = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenuItem, _super);
    function FinancialChartIndicatorMenuItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.c = 0;
        _this.f = null;
        _this.g = null;
        _this.a = false;
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(FinancialChartIndicatorMenuItem.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.b;
            if (a != b) {
                this.a = a;
                if (this.propertyChanged != null) {
                    this.propertyChanged(this, new PropertyChangedEventArgs("IsChecked"));
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuItem.$t = markType(FinancialChartIndicatorMenuItem, 'FinancialChartIndicatorMenuItem', Base.$, [INotifyPropertyChanged_$type]);
    return FinancialChartIndicatorMenuItem;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenuItems = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenuItems, _super);
    function FinancialChartIndicatorMenuItems(a) {
        var _this = _super.call(this, FinancialChartIndicatorMenuItem.$, 0) || this;
        _this.ak = null;
        _this.ac = null;
        _this.ad = null;
        _this.ae = null;
        _this.af = null;
        _this.ak = a;
        _this.am(FinancialOverlayType_$type, _this.al("FinancialChart_IndicatorMenu_OverlaysCategoryHeader", "Overlays"));
        _this.am(TrendLineType_$type, _this.al("FinancialChart_IndicatorMenu_TrendlinesCategoryHeader", "Trendlines"));
        _this.am(FinancialChartVolumeType_$type, _this.al("FinancialChart_IndicatorMenu_VolumeCategoryHeader", "Volume"));
        _this.am(FinancialIndicatorType_$type, _this.al("FinancialChart_IndicatorMenu_IndicatorsCategoryHeader", "Standalone Indicators"));
        return _this;
    }
    FinancialChartIndicatorMenuItems.prototype.al = function (a, b) {
        var c = this.ak.al(a);
        return stringIsNullOrEmpty(c) ? b : c;
    };
    FinancialChartIndicatorMenuItems.prototype.am = function ($t, a) {
        this.add(((function () {
            var $ret = new FinancialChartIndicatorMenuItem();
            $ret.d = a;
            $ret.f = a;
            return $ret;
        })()));
        this.an($t);
    };
    FinancialChartIndicatorMenuItems.prototype.an = function ($t) {
        var e_1, _a;
        var a = new List$1(Base.$, 0);
        var b = new Dictionary$2(Base.$, String_$type, 0);
        var c = new Dictionary$2(Base.$, Type.$, 0);
        var d = function (e) {
            for (var f = 0; f < e.a; f++) {
                var g = typeGetValue(e.b(f));
                a.add1(g);
                var h = e.c(g);
                b.addItem(g, h);
                c.addItem(g, $t);
            }
        };
        if ($t == FinancialOverlayType_$type) {
            d(this.ah);
        }
        else if ($t == TrendLineType_$type) {
            d(this.ai);
        }
        else if ($t == FinancialIndicatorType_$type) {
            d(this.ag);
        }
        else if ($t == FinancialChartVolumeType_$type) {
            d(this.aj);
        }
        else {
            var e = EnumUtil.getNames($t);
            var f = EnumUtil.getValues($t);
            for (var g = 0; g < f.length; g++) {
                var h = void 0;
                var i = void 0;
                h = f[g];
                i = e[g];
                i = i.charAt(0).toUpperCase() + i.substr(1);
                if (i == "None") {
                    continue;
                }
                a.add1(h);
                b.addItem(h, i);
                c.addItem(h, $t);
            }
        }
        var _loop_1 = function (j) {
            this_1.add(((function () {
                var $ret = new FinancialChartIndicatorMenuItem();
                $ret.d = j;
                $ret.f = b.containsKey(j) ? b.item(j) : j.toString();
                $ret.c = 1;
                $ret.g = c.containsKey(j) ? c.item(j) : null;
                return $ret;
            })()));
        };
        var this_1 = this;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                _loop_1(j);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ag", {
        get: function () {
            if (this.ac == null) {
                this.ao();
            }
            return this.ac;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuItems.prototype.ao = function () {
        var _this = this;
        this.ac = ((function () {
            var $ret = new OrderedDictionary$2(FinancialIndicatorType_$type, String_$type);
            $ret.addItem(0, _this.al("FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator", "Absolute Volume Oscillator"));
            $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution", "Accumulation Distribution"));
            $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex", "Average Directional Index"));
            $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange", "Average True Range"));
            $ret.addItem(4, _this.al("FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth", "Bollinger Band Width"));
            $ret.addItem(5, _this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator", "Chaikin Oscillator"));
            $ret.addItem(6, _this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility", "Chaikin Volatility"));
            $ret.addItem(7, _this.al("FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex", "Commodity Channel Index"));
            $ret.addItem(8, _this.al("FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator", "Detrended Price Oscillator"));
            $ret.addItem(9, _this.al("FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement", "Ease Of Movement"));
            $ret.addItem(10, _this.al("FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator", "Fast Stochastic Oscillator"));
            $ret.addItem(11, _this.al("FinancialChart_IndicatorsMenu_Indicator_ForceIndex", "Force Index"));
            $ret.addItem(12, _this.al("FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator", "Full Stochastic Oscillator"));
            $ret.addItem(13, _this.al("FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex", "Market Facilitation Index"));
            $ret.addItem(14, _this.al("FinancialChart_IndicatorsMenu_Indicator_MassIndex", "Mass Index"));
            $ret.addItem(15, _this.al("FinancialChart_IndicatorsMenu_Indicator_MedianPrice", "Median Price"));
            $ret.addItem(16, _this.al("FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex", "Money Flow Index"));
            $ret.addItem(17, _this.al("FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence", "MACD"));
            $ret.addItem(18, _this.al("FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex", "Negative Volume Index"));
            $ret.addItem(19, _this.al("FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume", "On Balance Volume"));
            $ret.addItem(20, _this.al("FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator", "Percentage Price Oscillator"));
            $ret.addItem(21, _this.al("FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator", "Percentage Volume Oscillator"));
            $ret.addItem(22, _this.al("FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex", "Positive Volume Index"));
            $ret.addItem(23, _this.al("FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend", "Price Volume Trend"));
            $ret.addItem(24, _this.al("FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum", "ROC"));
            $ret.addItem(25, _this.al("FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex", "RSI"));
            $ret.addItem(26, _this.al("FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator", "Slow Stochastic Oscillator"));
            $ret.addItem(27, _this.al("FinancialChart_IndicatorsMenu_Indicator_StandardDeviation", "Standard Deviation"));
            $ret.addItem(28, _this.al("FinancialChart_IndicatorsMenu_Indicator_StochRSI", "Stoch RSI"));
            $ret.addItem(29, _this.al("FinancialChart_IndicatorsMenu_Indicator_TRIX", "TRIX"));
            $ret.addItem(30, _this.al("FinancialChart_IndicatorsMenu_Indicator_TypicalPrice", "Typical Price"));
            $ret.addItem(31, _this.al("FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator", "Ultimate Oscillator"));
            $ret.addItem(32, _this.al("FinancialChart_IndicatorsMenu_Indicator_WeightedClose", "Weighted Close"));
            $ret.addItem(33, _this.al("FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR", "Williams %R"));
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ah", {
        get: function () {
            if (this.ad == null) {
                this.ap();
            }
            return this.ad;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuItems.prototype.ap = function () {
        var _this = this;
        this.ad = ((function () {
            var $ret = new OrderedDictionary$2(FinancialOverlayType_$type, String_$type);
            $ret.addItem(0, _this.al("FinancialChart_IndicatorsMenu_Overlay_BollingerBands", "Bollinger Bands"));
            $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Overlay_PriceChannel", "Price Channel"));
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "ai", {
        get: function () {
            if (this.ae == null) {
                this.aq();
            }
            return this.ae;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuItems.prototype.aq = function () {
        var _this = this;
        this.ae = ((function () {
            var $ret = new OrderedDictionary$2(TrendLineType_$type, String_$type);
            $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_TrendLine_LinearFit", "Linear Fit"));
            $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit", "Quadratic Fit"));
            $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_TrendLine_CubicFit", "Cubic Fit"));
            $ret.addItem(4, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuarticFit", "Quartic Fit"));
            $ret.addItem(5, _this.al("FinancialChart_IndicatorsMenu_TrendLine_QuinticFit", "Quintic Fit"));
            $ret.addItem(6, _this.al("FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit", "Logarithmic Fit"));
            $ret.addItem(7, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit", "Exponential Fit"));
            $ret.addItem(8, _this.al("FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit", "Power LawFit"));
            $ret.addItem(9, _this.al("FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage", "Simple Average"));
            $ret.addItem(10, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage", "Exponential Average"));
            $ret.addItem(11, _this.al("FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage", "Modified Average"));
            $ret.addItem(12, _this.al("FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage", "Cumulative Average"));
            $ret.addItem(13, _this.al("FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage", "Weighted Average"));
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartIndicatorMenuItems.prototype, "aj", {
        get: function () {
            if (this.af == null) {
                this.ar();
            }
            return this.af;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuItems.prototype.ar = function () {
        var _this = this;
        this.af = ((function () {
            var $ret = new OrderedDictionary$2(FinancialChartVolumeType_$type, String_$type);
            $ret.addItem(3, _this.al("FinancialChart_IndicatorsMenu_Volume_Area", "Area"));
            $ret.addItem(1, _this.al("FinancialChart_IndicatorsMenu_Volume_Column", "Column"));
            $ret.addItem(2, _this.al("FinancialChart_IndicatorsMenu_Volume_Line", "Line"));
            return $ret;
        })());
    };
    FinancialChartIndicatorMenuItems.$t = markType(FinancialChartIndicatorMenuItems, 'FinancialChartIndicatorMenuItems', List$1.$.specialize(FinancialChartIndicatorMenuItem.$));
    return FinancialChartIndicatorMenuItems;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialIndicatorTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialIndicatorTypeCollection, _super);
    function FinancialIndicatorTypeCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, FinancialIndicatorType_$type, 0) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialIndicatorType_$type, 1, c) || this;
                }
                break;
        }
        return _this;
    }
    FinancialIndicatorTypeCollection.$t = markType(FinancialIndicatorTypeCollection, 'FinancialIndicatorTypeCollection', ObservableCollection$1.$.specialize(FinancialIndicatorType_$type));
    return FinancialIndicatorTypeCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialOverlayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialOverlayTypeCollection, _super);
    function FinancialOverlayTypeCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, FinancialOverlayType_$type, 0) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialOverlayType_$type, 1, c) || this;
                }
                break;
        }
        return _this;
    }
    FinancialOverlayTypeCollection.$t = markType(FinancialOverlayTypeCollection, 'FinancialOverlayTypeCollection', ObservableCollection$1.$.specialize(FinancialOverlayType_$type));
    return FinancialOverlayTypeCollection;
}(ObservableCollection$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenuView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenuView, _super);
    function FinancialChartIndicatorMenuView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinancialChartIndicatorMenuView.prototype.f = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.f.call(this, a, b, c, d);
        var e = new SRProvider(a);
        TemplatedHtmlControl.n(".financialChartIndicatorMenuLabel", "FinancialChart_IndicatorMenu_Header", a, e);
        TemplatedHtmlControl.n(".financialChartIndicatorMenuDropDownMenu li[data-value='FinancialOverlayType'] span", "FinancialChart_IndicatorMenu_OverlaysCategoryHeader", a, e);
        TemplatedHtmlControl.n(".financialChartIndicatorMenuDropDownMenu li[data-value='TrendLineType'] span", "FinancialChart_IndicatorMenu_TrendlinesCategoryHeader", a, e);
        TemplatedHtmlControl.n(".financialChartIndicatorMenuDropDownMenu li[data-value='FinancialChartVolumeType'] span", "FinancialChart_IndicatorMenu_VolumeCategoryHeader", a, e);
        TemplatedHtmlControl.n(".financialChartIndicatorMenuDropDownMenu li[data-value='FinancialIndicatorType'] span", "FinancialChart_IndicatorMenu_IndicatorsCategoryHeader", a, e);
        var f = new FinancialChartIndicatorMenuItems(e);
        var g = new Dictionary$2(Type.$, Array_$type, 0);
        try {
            for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                if (h.c < 1) {
                    continue;
                }
                var i = typeGetValue(h.d);
                if (!g.containsKey(h.g)) {
                    g.addItem(h.g, EnumUtil.getNames(h.g));
                }
                var j = g.item(h.g)[i];
                if (stringIsNullOrEmpty(j)) {
                    continue;
                }
                j = j.charAt(0).toUpperCase() + j.substr(1);
                var k = stringFormat(".financialChartIndicatorMenuDropDownMenuList li[data-value='{0}']", j);
                TemplatedHtmlControl.m(k, h.f, a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    FinancialChartIndicatorMenuView.prototype.k = function (a) {
        _super.prototype.k.call(this, a);
        var b = a;
        if (b.tagName != "LI") {
            return;
        }
        var c = b.parentNode.parentNode;
        var d;
        var e = false;
        switch (c.getAttribute("data-value")) {
            case "FinancialOverlayType":
                d = FinancialOverlayType_$type;
                e = false;
                break;
            case "TrendLineType":
                d = TrendLineType_$type;
                e = true;
                break;
            case "FinancialChartVolumeType":
                d = FinancialChartVolumeType_$type;
                e = true;
                break;
            default:
            case "FinancialIndicatorType":
                d = FinancialIndicatorType_$type;
                e = false;
                break;
        }
        var f = b.classList.toggle("checked");
        var g = b.parentNode;
        if (e) {
            for (var h = 0; h < g.children.length; h++) {
                var i = g.children.item(h);
                if (i != b) {
                    i.classList.remove("checked");
                }
            }
            var j = f ? b.getAttribute("data-value") : "None";
            if (stringIsNullOrEmpty(j)) {
                return;
            }
            var k = EnumUtil.parse(d, j, true);
            if (d == FinancialChartVolumeType_$type) {
                this.l.h = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, k);
            }
            else {
                this.l.k = EnumUtil.getEnumValue(TrendLineType_$type, k);
            }
        }
        else {
            if (d == FinancialIndicatorType_$type) {
                this.l.i = new FinancialIndicatorTypeCollection(0);
                ;
            }
            else {
                this.l.j = new FinancialOverlayTypeCollection(0);
            }
            for (var l = 0; l < g.children.length; l++) {
                var m = g.children.item(l);
                if (m.classList.contains("checked")) {
                    var n = m.getAttribute("data-value");
                    if (stringIsNullOrEmpty(n)) {
                        continue;
                    }
                    var o = EnumUtil.parse(d, n, true);
                    if (d == FinancialIndicatorType_$type) {
                        var p = EnumUtil.getEnumValue(FinancialIndicatorType_$type, o);
                        this.l.i.add(p);
                    }
                    else {
                        var q = EnumUtil.getEnumValue(FinancialOverlayType_$type, o);
                        this.l.j.add(q);
                    }
                }
            }
        }
        this.a.onSelectionChanged();
    };
    Object.defineProperty(FinancialChartIndicatorMenuView.prototype, "l", {
        get: function () {
            return this.a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuView.$t = markType(FinancialChartIndicatorMenuView, 'FinancialChartIndicatorMenuView', FinancialChartDropDownControlView.$);
    return FinancialChartIndicatorMenuView;
}(FinancialChartDropDownControlView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenu = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenu, _super);
    function FinancialChartIndicatorMenu(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [null];
                    {
                        var e = c[0];
                        _this = _super.call(this, "financialChartIndicatorMenu", e, "") || this;
                        _this.o = new FinancialChartIndicatorMenuView();
                        _this.p = new FinancialChartIndicatorMenuViewModel();
                        _this.p.onSelectionChanged = runOn(_this, _this.v);
                        _this.p.a = runOn(_this.o, _this.o.j);
                        _this.o.a = _this.p;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, "financialChartIndicatorMenu", c, "") || this;
                    _this.o = new FinancialChartIndicatorMenuView();
                    _this.p = new FinancialChartIndicatorMenuViewModel();
                    _this.p.onSelectionChanged = runOn(_this, _this.v);
                    _this.p.a = runOn(_this.o, _this.o.j);
                    _this.o.a = _this.p;
                }
                break;
        }
        return _this;
    }
    FinancialChartIndicatorMenu.prototype.get_s = function () {
        return ".financialChartIndicatorMenuDropDownButton";
    };
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "s", {
        get: function () {
            return this.get_s();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenu.prototype.get_t = function () {
        return ".financialChartIndicatorMenuDropDownMenu";
    };
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "t", {
        get: function () {
            return this.get_t();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "y", {
        get: function () {
            return this.w.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "z", {
        get: function () {
            return this.w.j;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "aa", {
        get: function () {
            return this.w.k;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "x", {
        get: function () {
            return this.w.h;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenu.prototype, "w", {
        get: function () {
            return this.p;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenu.prototype.get_q = function () {
        return true;
    };
    FinancialChartIndicatorMenu.$t = markType(FinancialChartIndicatorMenu, 'FinancialChartIndicatorMenu', FinancialChartDropDownControl.$);
    return FinancialChartIndicatorMenu;
}(FinancialChartDropDownControl));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartIndicatorMenuContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartIndicatorMenuContext, _super);
    function FinancialChartIndicatorMenuContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._vm = null;
        _this._template = null;
        return _this;
    }
    Object.defineProperty(FinancialChartIndicatorMenuContext.prototype, "vm", {
        get: function () {
            return this._vm;
        },
        set: function (a) {
            this._vm = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartIndicatorMenuContext.prototype, "template", {
        get: function () {
            return this._template;
        },
        set: function (a) {
            this._template = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartIndicatorMenuContext.$t = markType(FinancialChartIndicatorMenuContext, 'FinancialChartIndicatorMenuContext');
    return FinancialChartIndicatorMenuContext;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartTypePickerContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartTypePickerContext, _super);
    function FinancialChartTypePickerContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._vm = null;
        _this._template = null;
        return _this;
    }
    Object.defineProperty(FinancialChartTypePickerContext.prototype, "vm", {
        get: function () {
            return this._vm;
        },
        set: function (a) {
            this._vm = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartTypePickerContext.prototype, "template", {
        get: function () {
            return this._template;
        },
        set: function (a) {
            this._template = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartTypePickerContext.$t = markType(FinancialChartTypePickerContext, 'FinancialChartTypePickerContext');
    return FinancialChartTypePickerContext;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartRangeSelectorContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelectorContext, _super);
    function FinancialChartRangeSelectorContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._vm = null;
        _this._template = null;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelectorContext.prototype, "vm", {
        get: function () {
            return this._vm;
        },
        set: function (a) {
            this._vm = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorContext.prototype, "template", {
        get: function () {
            return this._template;
        },
        set: function (a) {
            this._template = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorContext.$t = markType(FinancialChartRangeSelectorContext, 'FinancialChartRangeSelectorContext');
    return FinancialChartRangeSelectorContext;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartRangeSelectorViewModel = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelectorViewModel, _super);
    function FinancialChartRangeSelectorViewModel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._notifyChanged = null;
        _this._options = null;
        _this.t = dateMaxValue();
        _this.s = dateMinValue();
        _this._oneMonthChecked = false;
        _this._threeMonthsChecked = false;
        _this._sixMonthsChecked = false;
        _this._yearToDateChecked = false;
        _this._oneYearChecked = false;
        _this._allChecked = false;
        _this._oneMonthVisible = false;
        _this._threeMonthsVisible = false;
        _this._sixMonthsVisible = false;
        _this._yearToDateVisible = false;
        _this._oneYearVisible = false;
        _this._allVisible = false;
        _this.r = dateMinValue();
        _this.q = dateMaxValue();
        _this._onRangeChanged = null;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "notifyChanged", {
        get: function () {
            return this._notifyChanged;
        },
        set: function (a) {
            this._notifyChanged = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "options", {
        get: function () {
            return this._options;
        },
        set: function (a) {
            this._options = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "selectionStart", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            this.t = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "selectionEnd", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            this.s = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthChecked", {
        get: function () {
            return this._oneMonthChecked;
        },
        set: function (a) {
            this._oneMonthChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsChecked", {
        get: function () {
            return this._threeMonthsChecked;
        },
        set: function (a) {
            this._threeMonthsChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsChecked", {
        get: function () {
            return this._sixMonthsChecked;
        },
        set: function (a) {
            this._sixMonthsChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "yearToDateChecked", {
        get: function () {
            return this._yearToDateChecked;
        },
        set: function (a) {
            this._yearToDateChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearChecked", {
        get: function () {
            return this._oneYearChecked;
        },
        set: function (a) {
            this._oneYearChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "allChecked", {
        get: function () {
            return this._allChecked;
        },
        set: function (a) {
            this._allChecked = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthVisible", {
        get: function () {
            return this._oneMonthVisible;
        },
        set: function (a) {
            this._oneMonthVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsVisible", {
        get: function () {
            return this._threeMonthsVisible;
        },
        set: function (a) {
            this._threeMonthsVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsVisible", {
        get: function () {
            return this._sixMonthsVisible;
        },
        set: function (a) {
            this._sixMonthsVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "yearToDateVisible", {
        get: function () {
            return this._yearToDateVisible;
        },
        set: function (a) {
            this._yearToDateVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearVisible", {
        get: function () {
            return this._oneYearVisible;
        },
        set: function (a) {
            this._oneYearVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "allVisible", {
        get: function () {
            return this._allVisible;
        },
        set: function (a) {
            this._allVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorViewModel.prototype.af = function () {
        if (this.options == null) {
            return;
        }
        this.oneMonthVisible = this.options.contains(0);
        this.threeMonthsVisible = this.options.contains(1);
        this.sixMonthsVisible = this.options.contains(2);
        this.yearToDateVisible = this.options.contains(3);
        this.oneYearVisible = this.options.contains(4);
        this.allVisible = this.options.contains(5);
    };
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "rangeStart", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.r = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "rangeEnd", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorViewModel.prototype.onPropertiesChanged = function () {
        var a = false;
        var b = +(this.selectionEnd) == +(this.rangeEnd);
        if (this.allChecked != ((+(this.selectionStart) == +(this.rangeStart)) && b)) {
            this.allChecked = (+(this.selectionStart) == +(this.rangeStart)) && b;
            a = true;
        }
        if (this.oneYearChecked != ((+(this.selectionStart) == +(this.oneYearFromEnd)) && b)) {
            this.oneYearChecked = (+(this.selectionStart) == +(this.oneYearFromEnd)) && b;
            a = true;
        }
        if (this.yearToDateChecked != ((+(this.selectionStart) == +(this.firstDayOfEndYear)) && b)) {
            this.yearToDateChecked = (+(this.selectionStart) == +(this.firstDayOfEndYear)) && b;
            a = true;
        }
        if (this.sixMonthsChecked != ((+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b)) {
            this.sixMonthsChecked = (+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b;
            a = true;
        }
        if (this.threeMonthsChecked != ((+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b)) {
            this.threeMonthsChecked = (+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b;
            a = true;
        }
        if (this.oneMonthChecked != ((+(this.selectionStart) == +(this.oneMonthFromEnd)) && b)) {
            this.oneMonthChecked = (+(this.selectionStart) == +(this.oneMonthFromEnd)) && b;
            a = true;
        }
        if (a) {
            if (this.notifyChanged != null) {
                this.notifyChanged();
            }
        }
        return a;
    };
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneYearFromEnd", {
        get: function () {
            return dateAddYears(this.rangeEnd, -1);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "firstDayOfEndYear", {
        get: function () {
            return dateFromValues(this.rangeEnd.getFullYear(), 1, 1, 0, 0, 0, 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "sixMonthsFromEnd", {
        get: function () {
            return dateAddMonths(this.rangeEnd, -6);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "threeMonthsFromEnd", {
        get: function () {
            return dateAddMonths(this.rangeEnd, -3);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "oneMonthFromEnd", {
        get: function () {
            return dateAddMonths(this.rangeEnd, -1);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorViewModel.prototype.changeSelection = function (a) {
        this.allChecked = false;
        this.oneMonthChecked = false;
        this.threeMonthsChecked = false;
        this.sixMonthsChecked = false;
        this.yearToDateChecked = false;
        this.oneYearChecked = false;
        if (a == "1m") {
            this.oneMonthChecked = true;
        }
        else if (a == "3m") {
            this.threeMonthsChecked = true;
        }
        else if (a == "6m") {
            this.sixMonthsChecked = true;
        }
        else if (a == "YTD") {
            this.yearToDateChecked = true;
        }
        else if (a == "1y") {
            this.oneYearChecked = true;
        }
        else if (a == "all") {
            this.allChecked = true;
        }
        this.onRadioButtonChanged();
    };
    FinancialChartRangeSelectorViewModel.prototype.onRadioButtonChanged = function () {
        var a = dateFromTicks(this.selectionStart.getTime());
        var b = dateFromTicks(this.selectionEnd.getTime());
        this.selectionEnd = this.rangeEnd;
        if (this.oneMonthChecked) {
            this.selectionStart = this.oneMonthFromEnd;
        }
        if (this.threeMonthsChecked) {
            this.selectionStart = this.threeMonthsFromEnd;
        }
        if (this.sixMonthsChecked) {
            this.selectionStart = this.sixMonthsFromEnd;
        }
        if (this.yearToDateChecked) {
            this.selectionStart = this.firstDayOfEndYear;
        }
        if (this.oneYearChecked) {
            this.selectionStart = this.oneYearFromEnd;
        }
        if (this.allChecked) {
            this.selectionStart = this.rangeStart;
        }
        if (+(this.selectionStart) != +a || +(this.selectionEnd) != +b) {
            this.onRangeChanged();
            if (this.notifyChanged != null) {
                this.notifyChanged();
            }
        }
    };
    Object.defineProperty(FinancialChartRangeSelectorViewModel.prototype, "onRangeChanged", {
        get: function () {
            return this._onRangeChanged;
        },
        set: function (a) {
            this._onRangeChanged = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelectorViewModel.$t = markType(FinancialChartRangeSelectorViewModel, 'FinancialChartRangeSelectorViewModel');
    return FinancialChartRangeSelectorViewModel;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartRangeSelectorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelectorView, _super);
    function FinancialChartRangeSelectorView() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FinancialChartRangeSelectorView.prototype.d = function (a, b) {
    };
    FinancialChartRangeSelectorView.prototype.f = function (a, b, c) {
        TemplatedHtmlControl.n(".rangeSelector" + b + " span", "FinancialChart_RangeSelector_" + b, a, c);
    };
    FinancialChartRangeSelectorView.prototype.e = function (a) {
    };
    FinancialChartRangeSelectorView.prototype.c = function (a) {
        var b = new List$1(String_$type, 0);
        var c = new List$1(Boolean_$type, 0);
        var d = new List$1(Number_$type, 0);
        var e = new List$1(Number_$type, 0);
        var f = new List$1(Boolean_$type, 0);
        var g = new List$1(Number_$type, 0);
        var h = new List$1(Number_$type, 0);
        var k = this.a(a);
        for (var j = 0; j < k.length; j++) {
            var i = k[j];
            var l = i.parent() != null ? i.parent().getText() : "not found";
            l = l != null ? l.trim() : null;
            b.add(l);
            c.add1(i.getProperty("checked"));
            d.add(i.getOffset().left);
            e.add(i.getOffset().top);
            var m = i.parent().getNativeElement();
            var n = m.offsetParent != null;
            g.add(m.offsetWidth);
            h.add(m.offsetHeight);
            f.add(n);
        }
        ;
        return ((function () {
            var $ret = new FinancialChartRangeSelectorVisualData();
            $ret.buttonLabels = b.toArray();
            $ret.buttonsChecked = c.toArray();
            $ret.buttonLefts = d.toArray();
            $ret.buttonTops = e.toArray();
            $ret.buttonVisibilities = f.toArray();
            $ret.buttonWidths = g.toArray();
            $ret.buttonHeights = h.toArray();
            $ret.visibility = a.getStyleProperty("visibility");
            $ret.left = parseFloat(a.getStyleProperty("offsetLeft"));
            $ret.top = parseFloat(a.getStyleProperty("offsetTop"));
            $ret.width = parseFloat(a.getStyleProperty("offsetWidth"));
            $ret.height = parseFloat(a.getStyleProperty("offsetHeight"));
            return $ret;
        })());
    };
    FinancialChartRangeSelectorView.prototype.b = function (a) {
        return 5;
    };
    FinancialChartRangeSelectorView.prototype.g = function (a) {
    };
    FinancialChartRangeSelectorView.prototype.a = function (a) {
        return TemplatedHtmlControl.a(a, "input").toArray();
    };
    FinancialChartRangeSelectorView.$t = markType(FinancialChartRangeSelectorView, 'FinancialChartRangeSelectorView');
    return FinancialChartRangeSelectorView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.qf = null;
        _this.sx = null;
        _this.sv = null;
        _this.ss = null;
        _this.su = null;
        _this.sw = null;
        _this.st = null;
        _this.pl = null;
        _this.tf = null;
        _this.tg = null;
        _this.tc = null;
        _this.th = null;
        _this.ti = null;
        _this.td = null;
        _this.te = null;
        _this.q3 = null;
        _this.r8 = 40;
        _this.p9 = null;
        _this.p7 = null;
        _this.qb = null;
        _this.qg = null;
        _this.tq = null;
        _this.qz = null;
        _this.rn = false;
        _this.rm = false;
        _this.rs = false;
        _this.q9 = false;
        _this.s3 = 10;
        _this.sa = NaN;
        _this.sc = NaN;
        _this.sb = NaN;
        _this.sd = 0;
        _this.pr = 0;
        _this.pu = 0;
        _this.pw = 0;
        _this.q6 = true;
        _this.pn = 0;
        _this.q7 = false;
        _this.p1 = null;
        _this.p3 = null;
        _this.ru = null;
        _this.q8 = true;
        _this.q0 = null;
        _this.py = 1;
        _this.op = null;
        _this.oq = null;
        _this.or = null;
        _this.os = null;
        _this.ou = null;
        _this.ot = null;
        _this.oo = null;
        _this.on = null;
        _this.r9 = 1;
        _this.r7 = 1;
        _this.r6 = 1;
        _this.qd = null;
        _this.sz = -2147483648;
        _this.r5 = 2;
        _this.s2 = 3;
        _this.s0 = 10;
        _this.sy = 30;
        _this.s1 = 9;
        _this.pi = null;
        _this.pj = null;
        _this.pe = null;
        _this.applyCustomIndicators = null;
        _this.xa = null;
        _this.se = 1;
        _this.q5 = false;
        _this.p5 = null;
        _this.r2 = dateMinValue();
        _this.r1 = dateMaxValue();
        _this.rz = null;
        _this.f6();
        _this.rz = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.wz(); });
        }
        _this.wk();
        return _this;
    }
    FinancialChart.prototype.g5 = function (a, b, c) {
        _super.prototype.g5.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.pm = new FinancialChartToolbar(this, this.tn);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.v8));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.wb));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.wc));
                    d.l(null);
                }
                if (this.pm != null) {
                    this.pm.ac = this.pt;
                    this.pm.ai = this.av;
                    this.pm.y = this.po;
                    this.pm.al = this.rk;
                    if (this.su != null) {
                        this.pm.l(this.su);
                    }
                    var e = this.pm;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.v8));
                    ;
                    var f = this.pm;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.wb));
                    var g = this.pm;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.wc));
                }
                break;
            case "ChartType":
                if (this.pm != null) {
                    this.pm.y = this.po;
                }
                break;
            case "VolumeType":
                if (this.pm != null) {
                    this.pm.ac = this.pt;
                }
                break;
            case "TrendLineType":
                if (this.pm != null) {
                    this.pm.ai = this.av;
                }
                break;
            case "IsToolbarVisible":
                if (this.pm == null) {
                    break;
                }
                this.pm.al = this.rk;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.wc = function (a, b) {
        this.pt = this.pm.ac;
    };
    FinancialChart.prototype.wb = function (a, b) {
        this.av = this.pm.ai;
    };
    FinancialChart.prototype.v8 = function (a, b) {
        this.po = this.pm.y;
    };
    FinancialChart.prototype.wk = function () {
        this.qf = new IndicatorPane();
        this.p6 = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.sx = a;
        this.w5();
        this.setGridRows();
        if (this.pm != null) {
            this.pm.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.pm != null) {
            this.pm.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.pm.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.di;
        b.toolbarContainer = this.su;
        b.legendContainer = this.st;
        b.indicatorsContainer = this.ss;
        b.volumeContainer = this.sv;
        b.zoomContainer = this.sw;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.pm == null) {
                this.pm = new FinancialChartToolbar(this, this.tn);
            }
            this.pm.w.isIndicatorMenuVisible = this.rb && this.rc;
            this.su = b.getSubRenderer(d);
            this.pm.l(this.su);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.st = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ss = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.sv = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.sw = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.su = null;
            if (this.pm != null) {
                this.pm.l(null);
            }
            if (this.q4 != null) {
                this.q4.provideContainer(null);
                this.q4 = null;
            }
            if (this.p6 != null) {
                this.p6.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.sv);
            }
            if (this.qf != null) {
                this.qf.h(this.ss);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.sw);
                if (a != null) {
                    this.vs();
                }
                else {
                    this.q4 = null;
                }
            }
            if (this.p6 != null) {
                this.p6.provideContainer(this.st);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.wv = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.w9 = function (a, b) {
        this.wv(a, b, this.sw);
        if (b == null) {
            return;
        }
        this.vs();
    };
    FinancialChart.prototype.vs = function () {
        var _this = this;
        if (this.sw == null) {
            return;
        }
        if (this.q4 != null) {
            this.q4.provideContainer(null);
        }
        this.q4 = TypeRegistrar.create("ZoomSlider");
        this.q4.provideContainer(this.sw);
        var a = this.q4;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.m4 = new Rect(0, _this.q4.windowRect.left, _this.dataChart.mq.top, _this.q4.windowRect.width, _this.dataChart.mq.height);
            }
        });
        this.vt();
    };
    FinancialChart.prototype.w7 = function (a, b) {
        this.wv(a, b, this.sv);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.sx == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.rk ? this.sj : 0) + "px";
        a[1] = this.rg ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.q4 != null) {
            if (a[5] == "0px") {
                this.q4.hide();
            }
            else {
                this.q4.show();
            }
        }
        this.sx.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spread([" "], a)), "auto", "1fr"));
        this.sx.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spread([" "], a)));
        if (this.di == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.qf != null) {
            this.qf.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.q4 != null) {
            this.q4.notifySizeChanged();
        }
    };
    FinancialChart.prototype.gj = function () {
        _super.prototype.gj.call(this);
        this.ih = 3;
        this.nk = 0;
        this.cu = NaN;
        this.cs = 30;
        this.bq = true;
        this.bw = false;
        if (this.dataChart != null) {
            var a = this.dataChart.bn.i.e();
            this.ox = a.d;
            this.oy = a.e;
            this.ow = a.d;
            this.xb = this.dataChart.pm;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.oz = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.o0 = c;
    };
    FinancialChart.prototype.wr = function () {
        if (this.qf != null) {
            this.qf.b = null;
            this.qf.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ws = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.w1 = function () {
        this.wr();
    };
    FinancialChart.prototype.vr = function () {
        if (this.q4 == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.di.rootWrapper.width();
        var b = this.dataChart.m3.left + this.dataChart.m3.width;
        var c = this.dataChart.m3.left;
        var d = a - b;
        this.q4.startInset = c - this.q4.trackStartInset;
        this.q4.endInset = d - this.q4.trackEndInset;
        if (this.q4.endInset < 0) {
            var e = this.q4.endInset;
            this.q4.endInset = 0;
            this.dataChart.el += (e * -1);
        }
        if (this.q4.startInset < 0) {
            var f = this.q4.startInset;
            this.q4.startInset = 0;
            this.dataChart.ej += (f * -1);
        }
        this.zoomSliderChart.ej = c;
        this.zoomSliderChart.el = d;
        this.zoomSliderChart.ef = this.q4.barExtent;
    };
    FinancialChart.prototype.wi = function () {
        this.vr();
    };
    FinancialChart.prototype.gg = function (a) {
        _super.prototype.gg.call(this, a);
        if (a != null) {
            a.ee = 0;
        }
    };
    FinancialChart.prototype.xc = function (a) {
        return a.mj();
    };
    FinancialChart.prototype.xf = function () {
        return this.st == null ? null : this.xe(this.st.rootWrapper);
    };
    FinancialChart.prototype.xd = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.xe(a.d.rootWrapper);
    };
    FinancialChart.prototype.xe = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.sf = function () {
        if (this.sx == null) {
            return NaN;
        }
        var a = this.sx.getOffset();
        return this.sx.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.gr = function (source_, a, b) {
        _super.prototype.gr.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hy(source_, a, b);
        }
    };
    FinancialChart.prototype.gs = function (source_, a, b) {
        _super.prototype.gs.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hz(source_, a, b);
        }
    };
    FinancialChart.prototype.gq = function (source_) {
        _super.prototype.gq.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_);
        }
    };
    FinancialChart.prototype.gu = function (source_, a, b, c) {
        _super.prototype.gu.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.h0(source_, a, b, c);
        }
    };
    FinancialChart.prototype.gm = function (a, b) {
        _super.prototype.gm.call(this, a, b);
        if (this.rh(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "pm", {
        get: function () {
            return this.pl;
        },
        set: function (a) {
            var b = this.pm;
            if (a != b) {
                this.pl = a;
                this.g3("Toolbar", b, this.pm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tm", {
        get: function () {
            return this.tf;
        },
        set: function (a) {
            var b = this.tm;
            if (a != b) {
                this.tf = a;
                this.g3("RangeSelectorTemplate", b, this.tm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tn", {
        get: function () {
            return this.tg;
        },
        set: function (a) {
            var b = this.tn;
            if (a != b) {
                this.tg = a;
                this.g3("ToolbarTemplate", b, this.tn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tj", {
        get: function () {
            return this.tc;
        },
        set: function (a) {
            var b = this.tj;
            if (a != b) {
                this.tc = a;
                this.g3("ChartTypePickerTemplate", b, this.tj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "to", {
        get: function () {
            return this.th;
        },
        set: function (a) {
            var b = this.to;
            if (a != b) {
                this.th = a;
                this.g3("TrendLineTypePickerTemplate", b, this.to);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tp", {
        get: function () {
            return this.ti;
        },
        set: function (a) {
            var b = this.tp;
            if (a != b) {
                this.ti = a;
                this.g3("VolumeTypePickerTemplate", b, this.tp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tk", {
        get: function () {
            return this.td;
        },
        set: function (a) {
            var b = this.tk;
            if (a != b) {
                this.td = a;
                this.g3("IndicatorMenuTemplate", b, this.tk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tl", {
        get: function () {
            return this.te;
        },
        set: function (a) {
            var b = this.tl;
            if (a != b) {
                this.te = a;
                this.g3("OverlayPickerTemplate", b, this.tl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q4", {
        get: function () {
            return this.q3;
        },
        set: function (a) {
            var b = this.q4;
            if (a != b) {
                this.q3 = a;
                this.g3("ZoomSlider", b, this.q4);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cs = function () {
        return _super.prototype.get_cs.call(this);
    };
    FinancialChart.prototype.set_cs = function (a) {
        _super.prototype.set_cs.call(this, a);
    };
    FinancialChart.prototype.get_bq = function () {
        return _super.prototype.get_bq.call(this);
    };
    FinancialChart.prototype.set_bq = function (a) {
        _super.prototype.set_bq.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "sj", {
        get: function () {
            return this.r8;
        },
        set: function (a) {
            var b = this.sj;
            if (a != b) {
                this.r8 = a;
                this.g3("ToolbarHeight", b, this.sj);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.h9 = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.ia = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.q4 != null) {
            this.q4.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.q4 != null) {
            this.q4.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.u = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_b5 = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b5", {
        get: function () {
            return this.get_b5();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_b4 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "b4", {
        get: function () {
            return this.get_b4();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.o8 = function (a) {
        return this.o9(a);
    };
    FinancialChart.prototype.qm = function (a) {
        return this.qn(a);
    };
    FinancialChart.prototype.o7 = function (a) {
        var b = this.o8(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.f3 = function () {
        this.xAxis = this.o7("xAxis");
        this.yAxis = this.qm(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.qm(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.o7("volumeXAxis");
        this.rw = new List$1(NumericYAxis.$, 0);
        this.ry = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.qm(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.o7("indicatorXAxis_0");
        this.rw.add(this.indicatorAxis);
        this.ry.add(this.indicatorXAxis);
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeXAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorAxis.aw == null) {
            this.indicatorAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.aw == null) {
            this.indicatorXAxis.aw = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.qm(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.o7("zoomSliderXAxis");
        if (this.zoomSliderAxis.aw == null) {
            this.zoomSliderAxis.aw = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.aw == null) {
            this.zoomSliderXAxis.aw = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.f1 = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.l1 = this.ai(a, b);
        }
    };
    FinancialChart.prototype.hj = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jt = true;
            this.yAxis.kg = 10;
        }
    };
    FinancialChart.prototype.hm = function () {
        this.yAxis.jt = this.rp;
        this.yAxis.kg = this.tb;
    };
    FinancialChart.prototype.pq = function (a) {
        var b;
        if (this.po == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.po;
        }
        b = this.pp(b);
        return b;
    };
    FinancialChart.prototype.pp = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.pz = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ps = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.tx = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.o9 = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qn = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.qt = function () {
        return this.ar(1);
    };
    FinancialChart.prototype.qu = function () {
        return this.ar(0);
    };
    FinancialChart.prototype.qs = function () {
        return this.ar(2);
    };
    FinancialChart.prototype.qv = function () {
        return this.ar(20);
    };
    Object.defineProperty(FinancialChart.prototype, "ra", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qa", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rd", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p8", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rb", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qc", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rc", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qh", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.aq = function (a, b) {
        var c = this.tx(a);
        switch (this.pq(a)) {
            case 3:
                var d = this.qt();
                this.qa.setValueMemberPath(d, c);
                this.qa.setXAxis(d, this.xAxis);
                this.qa.setYAxis(d, this.yAxis);
                this.qa.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.qu();
                this.qa.setValueMemberPath(e, c);
                this.qa.setXAxis(e, this.xAxis);
                this.qa.setYAxis(e, this.yAxis);
                this.qa.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.qv();
                this.p8.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.p8.setHighMemberPath(f, a.getMemberPathFor(12));
                this.p8.setLowMemberPath(f, a.getMemberPathFor(13));
                this.p8.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.p8.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.p8.setXAxis(f, this.xAxis);
                this.p8.setYAxis(f, this.yAxis);
                this.p8.setDisplayType(f, this.po == 1 ? 1 : 0);
                this.p8.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.hl = function () {
        _super.prototype.hl.call(this);
        this.wg(this.xAxis);
        this.w3(false);
        if (this.pt != 0 && this.volumeChart != null) {
            this.wm();
        }
        this.wg(this.volumeXAxis);
        this.wg(this.indicatorXAxis);
        this.w0();
        this.w2();
        if (this.p0 != 0) {
            this.wn();
            this.wg(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.m8 = function (a, b) {
        var e_1, _a;
        _super.prototype.m8.call(this, a, b);
        a(this.volumeXAxis);
        if (this.ry != null) {
            try {
                for (var _b = __values(fromEnum(this.ry)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.nc = function (a, b) {
        var e_2, _a;
        _super.prototype.nc.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.rw != null) {
                try {
                    for (var _b = __values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.na = function (a) {
        _super.prototype.na.call(this, a);
        this.m2(this.volumeXAxis, a);
        this.m2(this.indicatorXAxis, a);
        this.m2(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ne = function (a) {
        _super.prototype.ne.call(this, a);
        this.m2(this.volumeAxis, a);
        this.m2(this.indicatorAxis, a);
        this.m2(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.nd = function (a) {
        _super.prototype.nd.call(this, a);
        this.m1(this.volumeAxis, a);
        this.m1(this.indicatorAxis, a);
        this.m1(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.m9 = function (a) {
        _super.prototype.m9.call(this, a);
        this.m1(this.volumeXAxis, a);
        this.m1(this.indicatorXAxis, a);
        this.m1(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.gf = function (a) {
        var _this = this;
        _super.prototype.gf.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nr = a.nt = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.m9 = this.dataChart.m9;
                a.nc = this.dataChart.nc;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.ur();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    };
    FinancialChart.prototype.ur = function () {
        if (this.tq == null) {
            FinancialChart.ta++;
            this.tq = FinancialChart.ta.toString();
        }
        return this.tq;
    };
    FinancialChart.prototype.v2 = function (a, b) {
        this.vo();
        this.wi();
    };
    FinancialChart.prototype.vo = function () {
        var e_3, _a;
        if (this.yAxis.bz()) {
            return;
        }
        var a = this.yAxis.at.a5;
        if (this.pt != 0) {
            a = Math.max(a, this.volumeAxis.at.a5);
        }
        try {
            for (var _b = __values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.at.a5);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.vp(a);
    };
    FinancialChart.prototype.vp = function (a) {
        var e_4, _a;
        if (this.yAxis.bz()) {
            return;
        }
        this.yAxis.d4 = this.volumeAxis.d4 = a;
        try {
            for (var _b = __values(fromEnum(this.rw)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.d4 = a;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.zoomSliderAxis.d4 = this.yAxis.d4;
    };
    FinancialChart.prototype.vu = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.vx = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.vv = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.rh(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.vw = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rh(d)) {
                continue;
            }
            var e = this.s4(d, c);
            a(d, e);
        }
        if (b) {
            this.vy(a);
        }
    };
    FinancialChart.prototype.vy = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.s4 = function (a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        var c = this.v == null || this.v.dataSeries == null ? 0 : this.v.dataSeries.count;
        var d = this.p4 == null ? 0 : this.p4.count;
        return b - (c * d);
    };
    FinancialChart.prototype.f9 = function (a) {
        _super.prototype.f9.call(this, a);
        this.vx(a);
        this.vu(a);
        this.vy(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.qz;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.qz = a;
                this.g3("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.wm = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.rh(d) || d.cj) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.pt;
            f = this.ps(f);
            switch (f) {
                case 2:
                    e = this.qu();
                    break;
                case 3:
                    e = this.qs();
                    break;
                default:
                case 1:
                    e = this.qt();
                    break;
            }
            this.qa.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.qa.setXAxis(e, this.volumeXAxis);
            this.qa.setYAxis(e, this.volumeAxis);
            this.qa.setValueMemberPath(e, this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > b ? this.v.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fx = d.fx + " Volume";
            e.k5 = ArrayExtension.getModulus$1(Brush.$, this.o1, b);
            e.k8 = ArrayExtension.getModulus$1(Brush.$, this.o2, b);
            e.ey = this.sk;
            a.add(e);
        }
        var g = this.b1("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.gk(i, h);
        }
    };
    FinancialChart.prototype.re = function (a) {
        if (!this.ra) {
            return false;
        }
        return this.qa.matchesType(a);
    };
    FinancialChart.prototype.ri = function (a) {
        if (!this.rd) {
            return false;
        }
        return this.p8.matchesType(a);
    };
    FinancialChart.prototype.rf = function (a) {
        if (!this.rb) {
            return false;
        }
        return this.qc.matchesType(a);
    };
    FinancialChart.prototype.rh = function (a) {
        if (!this.rc) {
            return false;
        }
        return this.qh.matchesType(a);
    };
    FinancialChart.prototype.wl = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.p2 == null ? 0 : this.p2.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.p2._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.rh(l) || l.cj) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.qw("Custom");
                    this.qc.handleCustomIndicatorEvent(n, runOn(this, this.v0));
                    m = n;
                }
                else {
                    m = this.qy(this.p2._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.qc.setXAxis(m, this.ry._inner[e]);
                this.qc.setYAxis(m, this.rw._inner[e]);
                m.itemsSource = l.itemsSource;
                this.qc.setOpenMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(11));
                this.qc.setHighMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(12));
                this.qc.setLowMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(13));
                this.qc.setCloseMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(14));
                this.qc.setVolumeMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(15));
                m.fx = l.fx + " " + i;
                m.k5 = ArrayExtension.getModulus$1(Brush.$, this.ov, e);
                m.ey = this.sh;
                if (this.rf(m)) {
                    this.qc.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ow, e));
                    this.qc.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.qe, e));
                }
                if (this.s6 != -2147483648 && this.rf(m)) {
                    this.qc.setPeriodOverride(m, this.s6);
                }
                if (this.rf(m)) {
                    this.qc.setSmoothingPeriod(m, this.s9);
                }
                if (this.rf(m)) {
                    this.qc.setSignalPeriod(m, this.s8);
                }
                if (this.rf(m)) {
                    this.qc.setShortPeriod(m, this.s7);
                    this.qc.setLongPeriod(m, this.s5);
                }
                this.gk(m, e);
                f.add(m);
            }
            var o = this.b1(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.gk(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.qw = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.qy = function (a) {
        return this.qw(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.w3 = function (a) {
        if (this.pm == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.pm.as = b.actualMinimumValue;
        this.pm.ar = b.actualMaximumValue;
        if (a) {
            this.pm.au = b.visibleMinimum;
            this.pm.at = b.visibleMaximum;
        }
        this.pm.bn();
    };
    FinancialChart.prototype.dj = function () {
        var e_5, _a, e_6, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.dj.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.oe();
            $ret.toolbar = _this.pm == null ? null : _this.pm.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.oe();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.oe());
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.xc(this.dataChart).x;
            a.mainChartTop = this.xc(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.xc(this.volumeChart).x;
            a.volumeChartTop = this.xc(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.xc(this.zoomSliderChart).x;
            a.zoomChartTop = this.xc(this.zoomSliderChart).y;
        }
        if (this.pm != null) {
            var c = this.xd(this.pm);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.xc(d).x);
                    a.indicatorChartTops.add(this.xc(d).y);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        var e = this.xf();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.p6 == null ? null : this.p6.exportVisualData();
        return a;
    };
    FinancialChart.prototype.tv = function () {
        var a = this.dj();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.qx = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.w2 = function () {
        var e_7, _a, e_8, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.rh(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        if (this.p4 == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.rh(g) || g.cj) {
                continue;
            }
            e++;
            for (var h = 0; h < this.p4.count; h++) {
                var i = this.p4._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.qx(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.qx(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.qh.setXAxis(j, this.xAxis);
                this.qh.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.p4.count + h;
                j.k5 = ArrayExtension.getModulus$1(Brush.$, this.oz, k);
                j.k8 = ArrayExtension.getModulus$1(Brush.$, this.o0, k);
                j.ey = this.si;
                j.fx = g.fx + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.v.dataSeries._inner[e];
                this.qh.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.qh.setHighMemberPath(j, m.getMemberPathFor(12));
                this.qh.setLowMemberPath(j, m.getMemberPathFor(13));
                this.qh.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.qh.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].fh = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.gk(q, p);
        }
    };
    FinancialChart.prototype.w0 = function () {
        var e_9, _a;
        if (this.rn) {
            return;
        }
        this.rn = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.wh(b);
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
        }
        if ((this.p2 == null || this.p2.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.rw != null) {
                this.rw.clear();
            }
            if (this.ry != null) {
                this.ry.clear();
            }
            this.wr();
            this.w1();
            this.rn = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.rw.clear();
        this.ry.clear();
        var c = this.p2 == null ? 0 : this.p2.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.wf(g);
            var h = f >= c;
            g.gq = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.p2._inner[f]);
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b5) {
                        j = this.o8(0);
                    }
                    else {
                        j = this.o8(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.rw.add(i);
                this.ry.add(j);
                if (this.bh) {
                    this.m5(i);
                }
                if (this.bh) {
                    this.m3(j);
                }
            }
        }
        this.wl();
        this.wr();
        if (this.pm != null) {
            this.pm.ae = this.p2;
        }
        this.vq();
        this.w1();
        this.rn = false;
    };
    FinancialChart.prototype.gc = function () {
        var e_10, _a, e_11, _b;
        _super.prototype.gc.call(this);
        this.m3(this.xAxis);
        this.m3(this.volumeXAxis);
        if (this.ry != null) {
            try {
                for (var _c = __values(fromEnum(this.ry)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.m3(a);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        this.m5(this.yAxis);
        this.m5(this.volumeAxis);
        if (this.rw != null) {
            try {
                for (var _e = __values(fromEnum(this.rw)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.m5(b);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.m3(this.zoomSliderXAxis);
        this.m5(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_bv = function () {
        return !this.rl;
    };
    Object.defineProperty(FinancialChart.prototype, "rr", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.w8 = function (a, b) {
        this.wu(a, b);
        this.vq();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.wn();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.ws();
        this.w9(a, b);
    };
    FinancialChart.prototype.wn = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.rh(c) || c.cj) {
                continue;
            }
            var d = void 0;
            var e = this.p0;
            e = this.pz(e);
            var f = this.s4(c, b);
            if (e == 1) {
                switch (this.pq(this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.qv();
                    this.p8.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.qv();
                    this.p8.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.qu();
                    break;
                case 6:
                    d = this.qs();
                    break;
                default:
                case 4:
                    d = this.qt();
                    break;
            }
            var g = this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null;
            if (d.cl && !d.cr) {
                this.qa.setCategoryMode(d, 1);
                this.qa.setXAxis(d, this.zoomSliderXAxis);
                this.qa.setYAxis(d, this.zoomSliderAxis);
                this.qa.setValueMemberPath(d, g == null ? null : this.tx(g));
            }
            else if (d.cr) {
                this.p8.setCategoryMode(d, 1);
                this.p8.setXAxis(d, this.zoomSliderXAxis);
                this.p8.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.p8.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.p8.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.p8.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.p8.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.p8.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.fx = c.fx;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.gk(i, h);
        }
    };
    FinancialChart.prototype.gz = function (a, b, c) {
        var e_12, _a;
        _super.prototype.gz.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.v0 = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.p2 == null ? 0 : this.p2.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.ww = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bh) {
            this.m3(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rq", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.v1 = function (a, b) {
        this.w0();
    };
    FinancialChart.prototype.rj = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.wq = function () {
        var e_13, _a;
        var a = this.pk != null ? this.pk : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.rj(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_13_1) {
            e_13 = { error: e_13_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_13)
                    throw e_13.error;
            }
        }
        this.pj = b;
        if (this.pm != null) {
            this.pm.u = this.pj;
        }
    };
    FinancialChart.prototype.v5 = function (a, b) {
        this.wq();
    };
    FinancialChart.prototype.wa = function (a, b) {
        this.p4 = this.pm.ag;
    };
    FinancialChart.prototype.v9 = function (a, b) {
        this.p2 = this.pm.ae;
    };
    FinancialChart.prototype.v3 = function (a, b) {
        this.w0();
    };
    FinancialChart.prototype.v4 = function (a, b) {
        this.w2();
    };
    FinancialChart.prototype.we = function (a, b) {
        var c = a;
        if (c.bd == null) {
            return;
        }
        if (this.rl) {
            this.wp(c.bd);
        }
    };
    FinancialChart.prototype.wh = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.v2));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d4 = this.volumeAxis.d4 = this.indicatorAxis.d4 = 0;
            this.xAxis.aw.visibility = this.ol;
        }
    };
    FinancialChart.prototype.wf = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.m4 = new Rect(0, this.dataChart.mq.x, a.m4.y, this.dataChart.mq.width, a.m4.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.v2));
        this.ge(a);
    };
    FinancialChart.prototype.vq = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.m1(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.ry._inner[a];
            var c = a < this_1.ry.count - 1 || this_1.volumeChart != null;
            this_1.m1(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.ry.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.wu = function (a, b) {
        if (a != null) {
            this.wh(a);
        }
        if (b != null) {
            this.wf(b);
        }
    };
    FinancialChart.prototype.w6 = function (a, b) {
        this.wu(a, b);
        this.vq();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.wm();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.w7(a, b);
    };
    FinancialChart.prototype.v6 = function (a, b) {
        this.w4();
    };
    FinancialChart.prototype.w4 = function () {
        if (this.pm == null || +(this.pm.au) == +(dateMaxValue()) || +(this.pm.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.pm.au, this.pm.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.rm = true;
        this.dataChart.m4 = new Rect(0, b.left, this.dataChart.m4.top, b.width, this.dataChart.m4.height);
        if (this.q4 != null) {
            this.q4.windowRect = this.dataChart.mq;
        }
        if (this.rl) {
            this.wp(this.dataChart);
        }
        this.rm = false;
    };
    FinancialChart.prototype.wd = function (a, b) {
        this.wq();
        this.w3(!this.rm);
    };
    FinancialChart.prototype.vz = function (a, b) {
        var _this = this;
        if (!this.rm) {
            if (this.rl) {
                this.wp(a);
            }
            var c = false;
            var d = this.g8(function () { return _this.w3(true); }, c);
            c = d.p1;
            if (this.q4 != null) {
                this.q4.windowRect = this.dataChart.mq;
            }
        }
    };
    FinancialChart.prototype.wy = function (a, b, c, d) {
        var e_14, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.rm = true;
            a.m4 = new Rect(0, d, a.mq.top, c, a.mq.height);
            this.rm = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.b8, a.mu);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.eh();
                var j = i.ao();
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dw(j.c, h);
                var m = b.dw(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        var n = a.mq.width;
        if (c != -1) {
            n = c;
        }
        var o = a.mq.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.rm = true;
        var p = new Rect(0, o, e, n, f - e);
        a.m4 = p;
        this.rm = false;
    };
    FinancialChart.prototype.wx = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.wy(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.wy(this.volumeChart, this.volumeAxis, this.dataChart.mq.width, this.dataChart.mq.left);
            }
        }
        else if (a == this.volumeChart) {
            this.wy(this.volumeChart, this.volumeAxis, -1, -1);
            this.wy(this.dataChart, this.yAxis, this.volumeChart.mq.width, this.volumeChart.mq.left);
        }
    };
    FinancialChart.prototype.wp = function (a) {
        var _this = this;
        this.g7(function () { return _this.wx(a); });
    };
    FinancialChart.prototype.v7 = function (a, b) {
        if (this.rl) {
            this.wp(a);
        }
    };
    FinancialChart.prototype.w5 = function () {
        if (!this.rr) {
            return;
        }
        this.vt();
        if (this.p0 == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.wn();
        }
    };
    FinancialChart.prototype.vt = function () {
        var container_ = this.sw.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.q4 != null && containerParent_ != null && !this.rs) {
            this.rs = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.q4;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.wz = function () {
        var _this = this;
        if (this.pv != 1) {
            return;
        }
        this.m7(function (a) {
            var e_15, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_15_1) {
                e_15 = { error: e_15_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_15)
                        throw e_15.error;
                }
            }
        });
    };
    FinancialChart.prototype.hq = function (a, b, c) {
        _super.prototype.hq.call(this, a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (this.pv == 1 && stringIsNullOrEmpty(this.ea)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.ec)) {
                this.ac.setYMemberPath(a, this.tx(c));
            }
            if (stringIsNullOrEmpty(this.d6)) {
                this.ac.setLabelMemberPath(a, this.tx(c));
            }
            if (stringIsNullOrEmpty(this.d3)) {
                this.ac.setContentMemberPath(a, this.tx(c));
            }
        }
    };
    FinancialChart.prototype.m3 = function (a) {
        var e_16, _a;
        _super.prototype.m3.call(this, a);
        var b = a;
        this.wg(b);
        if (a.bd != null) {
            try {
                for (var _b = __values(fromEnum(a.bd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.re(c)) {
                        this.qa.setXAxis(c, b);
                    }
                    else if (this.ri(c)) {
                        this.p8.setXAxis(c, b);
                    }
                    else if (this.rf(c)) {
                        this.qc.setXAxis(c, b);
                    }
                    else if (this.rh(c)) {
                        this.qh.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.ij = this.xb;
            a.d3 = this.sr;
            this.m1(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.r4;
        e.maximumValue = this.r3;
    };
    FinancialChart.prototype.m5 = function (a) {
        var e_17, _a;
        _super.prototype.m5.call(this, a);
        if (a.bd != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bd.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.re(b)) {
                        this.qa.setYAxis(b, this.yAxis);
                    }
                    else if (this.ri(b)) {
                        this.p8.setYAxis(b, this.yAxis);
                    }
                    else if (this.rf(b)) {
                        this.qc.setYAxis(b, this.yAxis);
                    }
                    else if (this.rh(b)) {
                        this.qh.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        a.jo = this.ro;
        a.kc = this.sp;
        a.kb = this.so;
        if (a == this.yAxis) {
            a.j8 = this.sn;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.m1(a, function (d) { return d.visibility = 1; });
        }
    };
    FinancialChart.prototype.wg = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e7 = XYChart.kx(a, this.v.dataSeries);
        if (this.v.dataSeries.count > 0) {
            var b = this.v.dataSeries._inner[0].getMemberPathFor(17);
            a.gw(b);
        }
    };
    FinancialChart.prototype.gk = function (a, b) {
        _super.prototype.gk.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cz) {
            a.ji(this.ox != null ? ArrayExtension.getModulus$1(Brush.$, this.ox, b) : null, this.oy != null ? ArrayExtension.getModulus$1(Brush.$, this.oy, b) : null);
        }
        var d = this.zoomSliderChart == a.bq;
        var e = this.rf(a);
        if (this.rh(a)) {
            a.k5 = this.oz != null ? ArrayExtension.getModulus$1(Brush.$, this.oz, b) : null;
            a.k8 = this.o0 != null ? ArrayExtension.getModulus$1(Brush.$, this.o0, b) : null;
            a.ey = this.si;
        }
        else if (e) {
            a.k5 = this.ov != null ? ArrayExtension.getModulus$1(Brush.$, this.ov, b) : null;
            a.ey = this.sh;
        }
        else if (!a.cj && (c || d)) {
            a.k5 = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.k8 = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.bq;
        if (f) {
            a.ey = this.sk;
        }
        a.legend = d || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.rg ? this.p6 : null;
    };
    FinancialChart.prototype.g3 = function (a, b, c) {
        var e_18, _a, e_19, _b;
        var _this = this;
        _super.prototype.g3.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.jt = this.rp;
                if (this.volumeAxis != null) {
                    this.volumeAxis.jt = this.rp;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.jt = this.rp;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kg = this.tb;
                if (this.volumeAxis != null) {
                    this.volumeAxis.kg = this.tb;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.kg = this.tb;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.pt == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.wm();
                }
                break;
            case "VolumeChart":
                this.w6(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.v2));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.vz));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.v7));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.v2));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.vz));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.v7));
                }
                this.w5();
                break;
            case "XAxisMode":
                this.xAxis = this.o8(this.pv);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.o8(this.pv);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.o8(this.pv);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.o8(this.pv);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.m1(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.vq();
                if (this.pv == 1) {
                    this.wz();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.qm(this.px);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.qm(this.px);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.qm(this.px);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.v6));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.v9));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.wa));
                }
                if (this.pm != null) {
                    this.pm.ae = this.p2;
                    this.pm.ag = this.p4;
                    this.pm.u = this.pj;
                    this.w3(true);
                    var j = this.pm;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.v6));
                    var k = this.pm;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.v9));
                    var l = this.pm;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.wa));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.wd));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bh) {
                    this.m3(this.xAxis);
                    this.f7();
                }
                this.w3(false);
                this.w4();
                this.wq();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.wd));
                break;
            case "ChartType":
                this.hl();
                break;
            case "VolumeXAxis":
                this.ww(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.ww(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.w0();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bh) {
                    this.m5(this.yAxis);
                    this.m5(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.we));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.wm();
                }
                if (this.bh) {
                    this.m5(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.we));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_18 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) {
                            e_18 = { error: e_18_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_18)
                                    throw e_18.error;
                            }
                        }
                        try {
                            for (var _e = (e_19 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.px == 1) {
                            y = this.qm(this.px);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bh) {
                            this.m5(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nt = this.bw && this.bv;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nt = this.bw && this.bv;
                }
                if (this.rl) {
                    this.wx(this.dataChart);
                }
                else {
                    this.volumeChart.oc = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.v3));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.v3));
                }
                this.w0();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.v4));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.v4));
                }
                this.w2();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.nb(function (ad) { return ad.jo = _this.ro; });
                break;
            case "YAxisMinimumValue":
                this.nc(function (ad) { return ad.kc = _this.sp; }, false);
                break;
            case "YAxisMaximumValue":
                this.nc(function (ad) { return ad.kb = _this.so; }, false);
                break;
            case "YAxisInterval":
                this.nc(function (ad) { return ad.j8 = _this.sn; }, false);
                break;
            case "ZoomSliderType":
                this.w5();
                break;
            case "ZoomSliderChart":
                if (!this.rq) {
                    return;
                }
                this.w8(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.vw(function (ad, ae) {
                    if (ad.cz) {
                        ad.ji(_this.ox != null ? ArrayExtension.getModulus$1(Brush.$, _this.ox, ae) : null, _this.oy != null ? ArrayExtension.getModulus$1(Brush.$, _this.oy, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.k5 = _this.oz != null ? ArrayExtension.getModulus$1(Brush.$, _this.oz, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.k8 = _this.o0 != null ? ArrayExtension.getModulus$1(Brush.$, _this.o0, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.f9(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    ad.ey = _this.si;
                });
                break;
            case "VolumeBrushes":
                this.vx(function (ad, ae) { return ad.k5 = ArrayExtension.getModulus$1(Brush.$, _this.o1, ae); });
                break;
            case "VolumeOutlines":
                this.vx(function (ad, ae) { return ad.k8 = ArrayExtension.getModulus$1(Brush.$, _this.o2, ae); });
                break;
            case "VolumeThickness":
                this.vx(function (ad, ae) { return ad.ey = _this.sk; });
                break;
            case "IndicatorNegativeBrushes":
                this.vu(function (ad, ae) { return _this.qc.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.ow, ae)); });
                break;
            case "IndicatorBrushes":
                this.vu(function (ad, ae) { return ad.k5 = ArrayExtension.getModulus$1(Brush.$, _this.ov, ae); });
                break;
            case "IndicatorThickness":
                this.vu(function (ad, ae) { return ad.ey = _this.sh; });
                break;
            case "IndicatorDisplayTypes":
                this.vu(function (ad, ae) { return _this.qc.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.qe, ae)); });
                break;
            case "IndicatorPeriod":
                this.vu(function (ad, ae) {
                    if (_this.s6 == -2147483648 || !(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setPeriodOverride(ad, _this.s6);
                });
                break;
            case "IndicatorMultiplier":
                this.vu(function (ad, ae) {
                    if (!(_this.rh(ad))) {
                        return;
                    }
                    _this.qh.setMultiplier(ad, _this.sg);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setSmoothingPeriod(ad, _this.s9);
                });
                break;
            case "IndicatorShortPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setShortPeriod(ad, _this.s7);
                });
                break;
            case "IndicatorLongPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setLongPeriod(ad, _this.s5);
                });
                break;
            case "IndicatorSignalPeriod":
                this.vu(function (ad, ae) {
                    if (!(_this.rf(ad))) {
                        return;
                    }
                    _this.qc.setSignalPeriod(ad, _this.s8);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.v5));
                }
                if (this.pk != null) {
                    var ae = this.pk;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.v5));
                }
                this.wq();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.v1));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.v1));
                }
                this.w0();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.vw(function (ah, ai) { return ah.k5 = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null; }, true);
                break;
            case "Outlines":
                this.vw(function (ah, ai) { return ah.k8 = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ol == 0 && this.zoomSliderXAxis != null) {
                    this.m1(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.vq();
                break;
            case "YAxisLabelVisibility":
                if (this.om != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.m1(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.ij = this.xb;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d3 = this.sr;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.rg && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.p6 : null;
                        }
                    };
                    this.vw(ai, false);
                    this.vv(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.wn();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bh) {
                        this.m5(this.zoomSliderAxis);
                    }
                    this.m1(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.m7(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.r4;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.m7(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.r3;
                    }
                });
                break;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "rp", {
        get: function () {
            return this.q9;
        },
        set: function (a) {
            var b = this.rp;
            if (a != b) {
                this.q9 = a;
                this.g3("YAxisIsLogarithmic", b, this.rp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "tb", {
        get: function () {
            return this.s3;
        },
        set: function (a) {
            var b = this.tb;
            if (a != b) {
                this.s3 = a;
                this.g3("YAxisLogarithmBase", b, this.tb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sn", {
        get: function () {
            return this.sa;
        },
        set: function (a) {
            var b = this.sn;
            if (a != b) {
                this.sa = a;
                this.g3("YAxisInterval", b, this.sn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sp", {
        get: function () {
            return this.sc;
        },
        set: function (a) {
            var b = this.sp;
            if (a != b) {
                this.sc = a;
                this.g3("YAxisMinimumValue", b, this.sp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "so", {
        get: function () {
            return this.sb;
        },
        set: function (a) {
            var b = this.so;
            if (a != b) {
                this.sb = a;
                this.g3("YAxisMaximumValue", b, this.so);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sq", {
        get: function () {
            return this.sd;
        },
        set: function (a) {
            var b = this.sq;
            if (a != b) {
                this.sd = a;
                this.g3("YAxisMinorInterval", b, this.sq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sm", {
        get: function () {
            return this.yAxis.j4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sl", {
        get: function () {
            return this.yAxis.j3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pt", {
        get: function () {
            return this.pr;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.pr = a;
                this.g3("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.pt));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pv", {
        get: function () {
            return this.pu;
        },
        set: function (a) {
            var b = this.pv;
            if (a != b) {
                this.pu = a;
                this.g3("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.pv));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "px", {
        get: function () {
            return this.pw;
        },
        set: function (a) {
            var b = this.px;
            if (a != b) {
                this.pw = a;
                this.g3("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.px));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rk", {
        get: function () {
            return this.q6;
        },
        set: function (a) {
            var b = this.rk;
            if (a != b) {
                this.q6 = a;
                this.g3("IsToolbarVisible", b, this.rk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "po", {
        get: function () {
            return this.pn;
        },
        set: function (a) {
            var b = this.po;
            if (a != b) {
                this.pn = a;
                this.g3("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.po));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_nk = function () {
        return _super.prototype.get_nk.call(this);
    };
    FinancialChart.prototype.set_nk = function (a) {
        _super.prototype.set_nk.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "rl", {
        get: function () {
            return this.q7;
        },
        set: function (a) {
            var b = this.rl;
            if (a != b) {
                this.q7 = a;
                this.g3("IsWindowSyncedToVisibleRange", b, this.rl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p2", {
        get: function () {
            return this.p1;
        },
        set: function (a) {
            var b = this.p2;
            if (a != b) {
                this.p1 = a;
                this.g3("IndicatorTypes", b, this.p2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p4", {
        get: function () {
            return this.p3;
        },
        set: function (a) {
            var b = this.p4;
            if (a != b) {
                this.p3 = a;
                this.g3("OverlayTypes", b, this.p4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.ru;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.ru = a;
                this.g3("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ro", {
        get: function () {
            return this.q8;
        },
        set: function (a) {
            var b = this.ro;
            if (a != b) {
                this.q8 = a;
                this.g3("YAxisAbbreviateLargeNumbers", b, this.ro);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_cu = function () {
        return _super.prototype.get_cu.call(this);
    };
    FinancialChart.prototype.set_cu = function (a) {
        _super.prototype.set_cu.call(this, a);
    };
    FinancialChart.prototype.get_ih = function () {
        return _super.prototype.get_ih.call(this);
    };
    FinancialChart.prototype.set_ih = function (a) {
        _super.prototype.set_ih.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.q0 = a;
                this.g3("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.ql;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.ql = a;
                this.g3("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.o6;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.o6 = a;
                this.g3("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p0", {
        get: function () {
            return this.py;
        },
        set: function (a) {
            var b = this.p0;
            if (a != b) {
                this.py = a;
                this.g3("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.p0));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ox", {
        get: function () {
            return this.op;
        },
        set: function (a) {
            var b = this.ox;
            if (a != b) {
                this.op = a;
                this.g3("NegativeBrushes", b, this.ox);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oy", {
        get: function () {
            return this.oq;
        },
        set: function (a) {
            var b = this.oy;
            if (a != b) {
                this.oq = a;
                this.g3("NegativeOutlines", b, this.oy);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oz", {
        get: function () {
            return this.or;
        },
        set: function (a) {
            var b = this.oz;
            if (a != b) {
                this.or = a;
                this.g3("OverlayBrushes", b, this.oz);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o0", {
        get: function () {
            return this.os;
        },
        set: function (a) {
            var b = this.o0;
            if (a != b) {
                this.os = a;
                this.g3("OverlayOutlines", b, this.o0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o2", {
        get: function () {
            return this.ou;
        },
        set: function (a) {
            var b = this.o2;
            if (a != b) {
                this.ou = a;
                this.g3("VolumeOutlines", b, this.o2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "o1", {
        get: function () {
            return this.ot;
        },
        set: function (a) {
            var b = this.o1;
            if (a != b) {
                this.ot = a;
                this.g3("VolumeBrushes", b, this.o1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ow", {
        get: function () {
            return this.oo;
        },
        set: function (a) {
            var b = this.ow;
            if (a != b) {
                this.oo = a;
                this.g3("IndicatorNegativeBrushes", b, this.ow);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ov", {
        get: function () {
            return this.on;
        },
        set: function (a) {
            var b = this.ov;
            if (a != b) {
                this.on = a;
                this.g3("IndicatorBrushes", b, this.ov);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sk", {
        get: function () {
            return this.r9;
        },
        set: function (a) {
            var b = this.sk;
            if (a != b) {
                this.r9 = a;
                this.g3("VolumeThickness", b, this.sk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "si", {
        get: function () {
            return this.r7;
        },
        set: function (a) {
            var b = this.si;
            if (a != b) {
                this.r7 = a;
                this.g3("OverlayThickness", b, this.si);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sh", {
        get: function () {
            return this.r6;
        },
        set: function (a) {
            var b = this.sh;
            if (a != b) {
                this.r6 = a;
                this.g3("IndicatorThickness", b, this.sh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qe", {
        get: function () {
            return this.qd;
        },
        set: function (a) {
            var b = this.qe;
            if (a != b) {
                this.qd = a;
                this.g3("IndicatorDisplayTypes", b, this.qe);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s6", {
        get: function () {
            return this.sz;
        },
        set: function (a) {
            var b = this.s6;
            if (a != b) {
                this.sz = a;
                this.g3("IndicatorPeriod", b, this.s6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sg", {
        get: function () {
            return this.r5;
        },
        set: function (a) {
            var b = this.sg;
            if (a != b) {
                this.r5 = a;
                this.g3("IndicatorMultiplier", b, this.sg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s9", {
        get: function () {
            return this.s2;
        },
        set: function (a) {
            var b = this.s9;
            if (a != b) {
                this.s2 = a;
                this.g3("IndicatorSmoothingPeriod", b, this.s9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s7", {
        get: function () {
            return this.s0;
        },
        set: function (a) {
            var b = this.s7;
            if (a != b) {
                this.s0 = a;
                this.g3("IndicatorShortPeriod", b, this.s7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s5", {
        get: function () {
            return this.sy;
        },
        set: function (a) {
            var b = this.s5;
            if (a != b) {
                this.sy = a;
                this.g3("IndicatorLongPeriod", b, this.s5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "s8", {
        get: function () {
            return this.s1;
        },
        set: function (a) {
            var b = this.s8;
            if (a != b) {
                this.s1 = a;
                this.g3("IndicatorSignalPeriod", b, this.s8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pk", {
        get: function () {
            return this.pi;
        },
        set: function (a) {
            var b = this.pk;
            if (a != b) {
                this.pi = a;
                this.g3("RangeSelectorOptions", b, this.pk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.pe;
        },
        set: function (a) {
            var b = this.pe;
            if (a != b) {
                this.pe = a;
                this.g3("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_bw = function () {
        return _super.prototype.get_bw.call(this);
    };
    FinancialChart.prototype.set_bw = function (a) {
        _super.prototype.set_bw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "xb", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = this.xb;
            if (a != b) {
                this.xa = a;
                this.g3("ZoomSliderXAxisMajorStroke", b, this.xb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "sr", {
        get: function () {
            return this.se;
        },
        set: function (a) {
            var b = this.sr;
            if (a != b) {
                this.se = a;
                this.g3("ZoomSliderXAxisMajorStrokeThickness", b, this.sr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rg", {
        get: function () {
            return this.q5;
        },
        set: function (a) {
            var b = this.rg;
            if (a != b) {
                this.q5 = a;
                this.g3("IsLegendVisible", b, this.rg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p6", {
        get: function () {
            return this.p5;
        },
        set: function (a) {
            var b = this.p6;
            if (a != b) {
                this.p5 = a;
                this.g3("FinancialChartLegend", b, this.p6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.o5;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.o5 = a;
                this.g3("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.qk;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.qk = a;
                this.g3("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.qj;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.qj = a;
                this.g3("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.o4;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.o4 = a;
                this.g3("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.qi;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.qi = a;
                this.g3("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.o3;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.o3 = a;
                this.g3("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rw", {
        get: function () {
            return this.rt;
        },
        set: function (a) {
            var b = this.rw;
            if (a != b) {
                this.rt = a;
                this.g3("IndicatorAxes", b, this.rw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ry", {
        get: function () {
            return this.rv;
        },
        set: function (a) {
            var b = this.ry;
            if (a != b) {
                this.rv = a;
                this.g3("IndicatorXAxes", b, this.ry);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r4", {
        get: function () {
            return this.r2;
        },
        set: function (a) {
            var b = this.r4;
            if (+a != +b) {
                this.r2 = a;
                this.g3("XAxisMinimumValue", b, this.r4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "r3", {
        get: function () {
            return this.r1;
        },
        set: function (a) {
            var b = this.r3;
            if (+a != +b) {
                this.r1 = a;
                this.g3("XAxisMaximumValue", b, this.r3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.rz;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ta = 0;
    return FinancialChart;
}(XYChart));
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.tm : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.tj : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.tk : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_20, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_20_1) {
            e_20 = { error: e_20_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_20)
                    throw e_20.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.e(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.d(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.c(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.af();
        }
        if (this.p != null) {
            this.p.g(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var requiredStyle = "\n.ui-financialchart-container {\n    font-family: \"Segoe UI\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Segoe UI\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n    border-width: 0;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n    -webkit-tap-highlight-color: var(--financial-highlight-color, rgba(0,0,0,0));\n}\n\n.ui-financialchart-mainChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.ui-financialchart-volumeChart {\n    margin-left: 15px;\n    margin-left: var(--financial-pane-margin-left, 15px);\n}\n\n.financialChartMainGrid {\n    height: 100%;\n    width: 100%;\n    display: grid;\n    display: -ms-grid;\n    -ms-grid-columns: 100%;\n}\n\n.financialChartPrice {\n    grid-row: 3;\n    -ms-grid-row: 3;\n    margin-top: 10px;\n    margin-top: var(--financial-pane-margin-top, 10px);\n}\n.financialChartPrice, .financialChartPrice > div {\n    min-height: 100px;\n}\n.financialChartIndicators {\n    grid-row: 4;\n    -ms-grid-row: 4;\n}\n.financialChartVolume {\n    grid-row: 5;\n    -ms-grid-row: 5;\n}\n.financialChartZoomSlider {\n    grid-row: 6;\n    -ms-grid-row: 6;\n}\n\n/*\n/////////////////////\n*/\n/* Toolbar styles */\n/*\n/////////////////////\n*/\n\n.financialChartToolbar {\n    height: 100%;\n    display: grid;\n    display: -ms-grid;\n    grid-row: 1;\n    -ms-grid-rows: 100%;\n    -ms-grid-row: 1;\n    -ms-grid-columns: 100%;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-font-size, 12px);\n}\n\n/* scrollbar styles */\n.financialChartToolbar ::-webkit-scrollbar\n{\n    width: 14px;\n    width: var(--financial-toolbar-scrollbar-width, 14px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-background, #eee);\n}\n.financialChartToolbar ::-webkit-scrollbar-track\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-track-radius, 1px);\n    background-color: #eee;\n    background-color: var(--financial-toolbar-scrollbar-track-background, #eee);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-track-shadow-radius, 6px) var(--financial-toolbar-scrollbar-track-shadow-color, rgba(0,0,0,0.3));\n}\n.financialChartToolbar ::-webkit-scrollbar-thumb\n{\n    border-radius: 1px;\n    border-radius: var(--financial-toolbar-scrollbar-thumb-radius, 1px);\n    background-color: #838383;\n    background-color: var(--financial-toolbar-scrollbar-thumb-background, #838383);\n    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);\n    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-thumb-shadow-radius, 6px) var(--financial-toolbar-scrollbar-thumb-shadow-color, rgba(0,0,0,0.3));\n}\n\n.financialChartToolbar .financialChartToolbar {\n    display: flex;\n    display: -ms-flexbox;\n    align-items: center;\n    border: 1px solid #dadada;\n    border: var(--financial-toolbar-border-thickness, 1px) solid var(--financial-toolbar-border-color, #dadada);\n    color: black;\n    color: var(--financial-toolbar-text-color, black);\n    max-height: 45px;\n    max-height: var(--financial-toolbar-max-height, 45px);\n    background: #eeeeee;\n    background: var(--financial-toolbar-background, #eeeeee);\n}\n\n.financialChartToolbar,\n.financialChartToolbar button {\n    font: 400 13px \"Segoe UI\", Arial, sans-serif!important;\n    font: var(--financial-toolbar-range-button-font, 400 13px \"Segoe UI\", Arial, sans-serif!important);\n}\n\n.financialChartRangeSelector {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    text-transform: uppercase;\n    height: 100%;\n}\n\n.financialChartRangeSelector input {\n    display: none;\n}\n\n.financialChartRangeSelectorLabel {\n    cursor: pointer;\n    height: 100%;\n}\n.financialChartRangeSelectorLabel:hover .financialChartRangeSelectorLabelSpan {\n    color: #4897AA;\n    color: var(--financial-toolbar-range-button-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-range-button-hover-background, transparent);\n}\n\n.financialChartRangeSelectorLabel input:checked + span {\n    color: #444444;\n    color: var(--financial-toolbar-range-button-check-color, #444444);\n    background-color: #dadada;\n    background-color: var(--financial-toolbar-range-button-check-background, #dadada);\n}\n\n.financialChartRangeSelectorLabelSpan {\n    height: 100%;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    padding: 10px;\n    padding: var(--financial-toolbar-range-button-padding, 10px);\n    box-sizing: border-box;\n}\n\n.financialChartRangeSelectorLastOption {\n    border: none;\n    padding-right: 0;\n    padding-right: var(--financial-toolbar-range-button-padding-right, 0px);\n}\n\n.financialChartIndicatorMenu,\n.financialChartTypePicker {\n    position: relative;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePicker {\n    margin-left: auto;\n    height: 100%;\n    border-left: 1px solid #dadada;\n    border-left: var(--financial-toolbar-border-thickness, 1px) solid\n                 var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenu {\n    height: 100%;\n    padding:0 10px;\n    border-right: 1px solid #dadada;\n    border-right: var(--financial-toolbar-border-thickness, 1px) solid\n                  var(--financial-toolbar-border-color, #dadada);\n}\n\n.financialChartIndicatorMenuDropDownMenu,\n.financialChartTypePickerDropDownMenu {\n    background: #fff;\n    background: var(--financial-toolbar-dropdown-background-color, #fff);\n    color: black;\n    color: var(--financial-toolbar-dropdown-text-color, black);\n    display: flex;\n    flex-direction: column;\n    z-index: 1;\n    position: absolute;\n    top: calc(100% + 1px);\n    top: calc(100% + var(--financial-toolbar-dropdown-top-offset, 1px));\n    box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22);\n    box-shadow: var(--financial-toolbar-dropdown-shadow,  0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22));\n    white-space: nowrap;\n    font-family: \"Verdana\",Arial,sans-serif;\n    font-family: var(--financial-toolbar-dropdown-font-family, \"Verdana\",Arial,sans-serif);\n    font-size: 12px;\n    font-size: var(--financial-toolbar-dropdown-font-size, 12px);\n}\n\n.financialChartIndicatorMenuDropDownMenu {\n    left: 0;\n    min-width: 100px;\n    min-width: var(--financial-toolbar-dropdown-min-width, 100px);\n    height: 300px;\n    height: var(--financial-toolbar-dropdown-height, 300px);\n    overflow: auto;\n}\n\n.financialChartTypePickerDropDownMenu {\n    right: 0;\n}\n\n.financialChartListItem {\n    cursor: pointer;\n    cursor: var(--financial-toolbar-dropdown-item-cursor, pointer);\n}\n\n.financialChartListItem:hover,\n.financialChartListItem:focus {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-hover-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-hover-background, transparent);\n}\n\n.financialChartListItem span {\n    position: relative;\n    /* TODO: figure out why we need z-index here */\n    z-index: -1;\n}\n\n.financialChartTypePickerDropDownMenu .financialChartListItem {\n    display: flex;\n    align-items: center;\n    justify-content: flex-start;\n}\n.financialChartTypePickerDropDownMenu .ui-icon {\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-icon-margin-right, 5px);\n}\n\n.financialChartIndicatorMenuDropDownButton,\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-indicators-background-color, transparent);\n    border: none;\n    outline: none;\n    cursor: pointer;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.financialChartIndicatorMenuDropDownMenuList {\n    font-weight: bold;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked,\n.financialChartTypePickerDropDownMenu li.checked {\n    color: #4897AA;\n    color: var(--financial-toolbar-dropdown-item-check-color, #4897AA);\n    background: transparent;\n    background: var(--financial-toolbar-dropdown-item-check-background, transparent);\n}\n\n.financialChartIndicatorMenuDropDownMenu ul,\n.financialChartTypePickerDropDownMenu ul {\n    list-style-type: none;\n    margin: 0;\n    padding: 8px;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul ul,\n.financialChartTypePickerDropDownMenu ul ul {\n    padding-left: 15px;\n    padding-left: var(--financial-toolbar-dropdown-list-padding-left, 15px);\n    font-weight: normal;\n}\n\n.financialChartIndicatorMenuDropDownMenu ul li,\n.financialChartTypePickerDropDownMenu ul li {\n    padding-top: 4px;\n    padding-top: var(--financial-toolbar-dropdown-list-padding-top, 4px);\n    position: relative;\n}\n\n.financialChartIndicatorMenuDropDownMenu li.checked:before{\n    margin-left: -15px;\n    margin-left:  var(--financial-toolbar-dropdown-list-margin-left, -15px);\n    margin-right: 5px;\n    margin-right: var(--financial-toolbar-dropdown-list-margin-right, 5px);\n    content: \"\\2713\";\n    position: absolute;\n}\n\n.financialChartLegend {\n    grid-row: 2;\n    -ms-grid-row: 2;\n}\n\n.ui-ChartButtonWrapper {\n    display: flex;\n    align-items: center;\n    justify-content: center;\n}\n\n.financialChartTypePickerDropDownButton .ui-icon-triangle-1-s,\n.ui-ChartButtonWrapper .ui-icon-triangle-1-s {\n    font-size: 10px;\n    font-size: var(--financial-toolbar-icon-font-size, 10px);\n}\n\n.financialChartTypePickerDropDownButton {\n    background-color: transparent;\n    background-color: var(--financial-toolbar-chart-picker-background, transparent);\n    height: 100%;\n    padding: 0 10px;\n    padding: var(--financial-toolbar-chart-picker-padding, 0 10px);\n}\n\n.financialChartIndicatorMenuLabel {\n    margin: 0 5px;\n    margin: var(--financial-toolbar-indicators-label-margin, 0 5px);\n    color: inherit;\n    color: var(--financial-toolbar-indicators-label-normal-color, inherit);\n}\n\n\n/* Icon styles if no theme is included */\n.financialChartToolbar .ui-icon {\n    color: #888888;\n    color: var(--financial-toolbar-icon-color, #888888);\n    width: 16px;\n    width: var(--financial-toolbar-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    text-indent: -99999px;\n    overflow: hidden;\n    position: relative;\n}\n.financialChartToolbar .ui-icon:before {\n    display: block;\n    height: 1em;\n    left: 50%;\n    line-height: 1;\n    margin-left: -0.5em;\n    margin-top: -0.5em;\n    position: absolute;\n    text-indent: 0;\n    top: 50%;\n    width: 1em;\n}\n\n.ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-IndicatorsIcon:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-IndicatorsIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-indicators-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .financialChartIndicatorMenuLabel,\n.financialChartIndicatorMenuDropDownButton:focus .financialChartIndicatorMenuLabel {\n    color: #4897AA;\n    color: var(--financial-toolbar-indicators-label-hover-color, #4897AA);\n}\n\n.ui-icon-toolbar-dd {\n    position: relative;\n    width: 16px;\n    width: var(--financial-toolbar-dropdown-icon-width, 16px);\n    height: 16px;\n    height: var(--financial-toolbar-dropdown-icon-height, 16px);\n    display: flex;\n    justify-content: center;\n    align-items: center;\n}\n\n.ui-icon-toolbar-dd:before {\n    content: '';\n    position: absolute;\n    width: 0;\n    height: 0;\n    border-style: solid;\n    border-width: 5px 4px 0 4px;\n    border-color: #666 transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-normal-color, #666) transparent transparent transparent;\n}\n\n.financialChartIndicatorMenuDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartIndicatorMenuDropDownButton:focus .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:hover .ui-icon-toolbar-dd:before,\n.financialChartTypePickerDropDownButton:focus .ui-icon-toolbar-dd:before {\n    content: '';\n    border-color: #4897AA transparent transparent transparent;\n    border-color: var(--financial-toolbar-dropdown-icon-hover-color, #4897AA) transparent transparent transparent;\n}\n\n.financialChartListItem[data-value='Auto'] {\n    padding-bottom: 5px;\n    padding-bottom: var(--financial-toolbar-dropdown-border-bottom-padding, 5px)\n    border-bottom: 1px solid #ddd;\n    border-bottom: 1px solid var(--financial-toolbar-dropdown-border-bottom-color, #ddd)\n    margin-bottom: 3px;\n    margin-bottom: var(--financial-toolbar-dropdown-border-bottom-margin, 3px)\n}\n\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-changeable:before,\n.financialChartListItem[data-value='Auto'] .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value=\"Auto\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Auto']:hover .ui-icon-chartAuto:before,\n.financialChartListItem[data-value='Auto']:focus .ui-icon-chartAuto:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Auto']:focus .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-auto-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Bar'] .ui-icon-BarIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Bar\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Bar']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Bar']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Bar\"]:hover .ui-icon-BarIcon:before,\n.financialChartListItem[data-value=\"Bar\"]:focus .ui-icon-BarIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-bar-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Line'] .ui-icon-LineIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Line\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Line']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Line']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Line\"]:hover .ui-icon-LineIcon:before,\n.financialChartListItem[data-value=\"Line\"]:focus .ui-icon-LineIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-line-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Candle'] .ui-icon-CandleIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Candle\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Candle']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Candle']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Candle\"]:hover .ui-icon-CandleIcon:before,\n.financialChartListItem[data-value=\"Candle\"]:focus .ui-icon-CandleIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-candle-hover-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n\n.financialChartListItem[data-value='Column'] .ui-icon-ColumnIcon:before,\n.financialChartTypePickerDropDownButton[data-value=\"Column\"] .ui-icon-changeable:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-normal-icon,\n             url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E\");\n    );\n}\n\n.financialChartTypePickerDropDownButton[data-value='Column']:hover .ui-icon-changeable:before,\n.financialChartTypePickerDropDownButton[data-value='Column']:focus .ui-icon-changeable:before,\n.financialChartListItem[data-value=\"Column\"]:hover .ui-icon-ColumnIcon:before,\n.financialChartListItem[data-value=\"Column\"]:focus .ui-icon-ColumnIcon:before {\n    content: url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\");\n    content: var(--financial-toolbar-chart-column-hover-icon,\n        url(\"data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E\")\n    );\n}\n";
var checked = /*@__PURE__*/ new WeakMap();
function ensureCss() {
    if (!document) {
        return;
    }
    if (checked.has(document)) {
        return;
    }
    for (var i = 0; i < document.head.children.length; i++) {
        var child = document.head.children[i];
        if (child.tagName == "link" && child.hasAttribute("data-ig-financial-default-templates-style")) {
            return;
        }
    }
    var link = document.createElement("link");
    link.setAttribute('rel', 'stylesheet');
    link.setAttribute('type', 'text/css');
    link.setAttribute('href', 'data:text/css;charset=UTF-8,' + encodeURIComponent(requiredStyle));
    link.setAttribute('data-ig-financial-default-templates-style', 'true');
    document.head.appendChild(link);
    checked.set(document, true);
}
var RangeSelectorTemplate = function (props) {
    if (!props.dataContext || !props.dataContext.vm) {
        return null;
    }
    var onChange = function (e) {
        props.dataContext.vm.changeSelection.call(props.dataContext.vm, e.target.value);
        if (props.dataContext.vm.notifyChanged) {
            props.dataContext.vm.notifyChanged();
        }
    };
    return (createElement("div", { className: 'financialChartRangeSelector' }, props.dataContext.vm.oneMonthVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorOneMonth' }, createElement("input", { type: 'radio', value: '1m', checked: props.dataContext.vm.oneMonthChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "1m")) : null, props.dataContext.vm.threeMonthsVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorThreeMonths' }, createElement("input", { type: 'radio', value: '3m', checked: props.dataContext.vm.threeMonthsChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "3m")) : null, props.dataContext.vm.sixMonthsVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorSixMonths' }, createElement("input", { type: 'radio', value: '6m', checked: props.dataContext.vm.sixMonthsChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "6m")) : null, props.dataContext.vm.yearToDateVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorYTD' }, createElement("input", { type: 'radio', value: 'YTD', checked: props.dataContext.vm.yearToDateChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "YTD")) : null, props.dataContext.vm.oneYearVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorOneYear' }, createElement("input", { type: 'radio', value: '1y', checked: props.dataContext.vm.oneYearChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "1y")) : null, props.dataContext.vm.allVisible ? createElement("label", { className: 'financialChartRangeSelectorLabel rangeSelectorAll' }, createElement("input", { type: 'radio', value: 'all', checked: props.dataContext.vm.allChecked, onChange: onChange }), createElement("span", { className: "financialChartRangeSelectorLabelSpan" }, "all")) : null));
};
var ChartTypePickerTemplate = function (props) {
    if (!props.dataContext || !props.dataContext.vm) {
        return null;
    }
    var onClick = function (e) {
        props.dataContext.vm.onButtonPressed.call(props.dataContext.vm);
    };
    var onDropDownClick = function (e) {
        props.dataContext.vm.handleDropDownClick.call(props.dataContext.vm, e);
    };
    return (createElement(Fragment, null, createElement("button", { className: 'financialChartTypePickerDropDownButton', onClick: onClick, "data-value": props.dataContext.vm.chartTypeString }, createElement("span", { className: 'ui-icon ui-icon-changeable' }), createElement("span", { className: 'ui-icon-toolbar-dd' })), createElement("div", { className: 'financialChartTypePickerDropDownMenu', style: { display: props.dataContext.vm.isOpen ? 'block' : 'none' }, onClick: onDropDownClick }, createElement("ul", null, createElement("li", { className: 'financialChartListItem', "data-value": 'Auto' }, createElement("span", { className: 'ui-icon ui-icon-chartAuto' }), createElement("span", null, "Auto")), createElement("li", { className: 'financialChartListItem', "data-value": 'Bar' }, createElement("span", { className: 'ui-icon ui-icon-BarIcon' }), createElement("span", null, "Bar")), createElement("li", { className: 'financialChartListItem', "data-value": 'Line' }, createElement("span", { className: 'ui-icon ui-icon-LineIcon' }), createElement("span", null, "Line")), createElement("li", { className: 'financialChartListItem', "data-value": 'Candle' }, createElement("span", { className: 'ui-icon ui-icon-CandleIcon' }), createElement("span", null, "Candle")), createElement("li", { className: 'financialChartListItem', "data-value": 'Column' }, createElement("span", { className: 'ui-icon ui-icon-ColumnIcon' }), createElement("span", null, "Column"))))));
};
var IndicatorMenuTemplate = function (props) {
    if (!props.dataContext || !props.dataContext.vm) {
        return null;
    }
    var onClick = function (e) {
        props.dataContext.vm.onButtonPressed.call(props.dataContext.vm);
    };
    var onDropDownClick = function (e) {
        props.dataContext.vm.handleDropDownClick.call(props.dataContext.vm, e);
    };
    return (createElement(Fragment, null, createElement("button", { className: 'financialChartIndicatorMenuDropDownButton', onClick: onClick }, createElement("div", { className: 'ui-ChartButtonWrapper' }, createElement("span", { className: 'ui-icon ui-icon-IndicatorsIcon' }), createElement("span", { className: 'financialChartIndicatorMenuLabel' }, "Indicators"), createElement("span", { className: 'ui-icon-toolbar-dd' }))), createElement("div", { className: 'financialChartIndicatorMenuDropDownMenu', style: { display: props.dataContext.vm.isOpen ? 'block' : 'none' }, onClick: onDropDownClick }, createElement("ul", { className: 'financialChartIndicatorMenuDropDownMenuList' }, createElement("li", { "data-value": 'FinancialOverlayType' }, createElement("span", null, "Overlays"), createElement("ul", null, createElement("li", { className: 'financialChartListItem', "data-value": 'BollingerBands' }, "BollingerBands"), createElement("li", { className: 'financialChartListItem', "data-value": 'PriceChannel' }, "PriceChannel"))), createElement("li", { "data-value": 'TrendLineType' }, createElement("span", null, "Trendlines"), createElement("ul", null, createElement("li", { className: 'financialChartListItem', "data-value": 'LinearFit' }, "LinearFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'QuadraticFit' }, "QuadraticFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'CubicFit' }, "CubicFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'QuarticFit' }, "QuarticFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'QuinticFit' }, "QuinticFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'LogarithmicFit' }, "LogarithmicFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'ExponentialFit' }, "ExponentialFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'PowerLawFit' }, "PowerLawFit"), createElement("li", { className: 'financialChartListItem', "data-value": 'SimpleAverage' }, "SimpleAverage"), createElement("li", { className: 'financialChartListItem', "data-value": 'ExponentialAverage' }, "ExponentialAverage"), createElement("li", { className: 'financialChartListItem', "data-value": 'ModifiedAverage' }, "ModifiedAverage"), createElement("li", { className: 'financialChartListItem', "data-value": 'CumulativeAverage' }, "CumulativeAverage"), createElement("li", { className: 'financialChartListItem', "data-value": 'WeightedAverage' }, "WeightedAverage"))), createElement("li", { "data-value": 'FinancialChartVolumeType' }, createElement("span", null, "Volume"), createElement("ul", null, createElement("li", { className: 'financialChartListItem', "data-value": 'Column' }, "Column"), createElement("li", { className: 'financialChartListItem', "data-value": 'Line' }, "Line"), createElement("li", { className: 'financialChartListItem', "data-value": 'Area' }, "Area"))), createElement("li", { "data-value": 'FinancialIndicatorType' }, createElement("span", null, "Standalone Indicators"), createElement("ul", null, createElement("li", { className: 'financialChartListItem', "data-value": 'AbsoluteVolumeOscillator' }, "AbsoluteVolumeOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'AccumulationDistribution' }, "AccumulationDistribution"), createElement("li", { className: 'financialChartListItem', "data-value": 'AverageDirectionalIndex' }, "AverageDirectionalIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'AverageTrueRange' }, "AverageTrueRange"), createElement("li", { className: 'financialChartListItem', "data-value": 'BollingerBandWidth' }, "BollingerBandWidth"), createElement("li", { className: 'financialChartListItem', "data-value": 'ChaikinOscillator' }, "ChaikinOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'ChaikinVolatility' }, "ChaikinVolatility"), createElement("li", { className: 'financialChartListItem', "data-value": 'CommodityChannelIndex' }, "CommodityChannelIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'DetrendedPriceOscillator' }, "DetrendedPriceOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'EaseOfMovement' }, "EaseOfMovement"), createElement("li", { className: 'financialChartListItem', "data-value": 'FastStochasticOscillator' }, "FastStochasticOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'ForceIndex' }, "ForceIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'FullStochasticOscillator' }, "FullStochasticOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'MarketFacilitationIndex' }, "MarketFacilitationIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'MassIndex' }, "MassIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'MedianPrice' }, "MedianPrice"), createElement("li", { className: 'financialChartListItem', "data-value": 'MoneyFlowIndex' }, "MoneyFlowIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'MovingAverageConvergenceDivergence' }, "MovingAverageConvergenceDivergence"), createElement("li", { className: 'financialChartListItem', "data-value": 'NegativeVolumeIndex' }, "NegativeVolumeIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'OnBalanceVolume' }, "OnBalanceVolume"), createElement("li", { className: 'financialChartListItem', "data-value": 'PercentagePriceOscillator' }, "PercentagePriceOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'PercentageVolumeOscillator' }, "PercentageVolumeOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'PositiveVolumeIndex' }, "PositiveVolumeIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'PriceVolumeTrend' }, "PriceVolumeTrend"), createElement("li", { className: 'financialChartListItem', "data-value": 'RateOfChangeAndMomentum' }, "RateOfChangeAndMomentum"), createElement("li", { className: 'financialChartListItem', "data-value": 'RelativeStrengthIndex' }, "RelativeStrengthIndex"), createElement("li", { className: 'financialChartListItem', "data-value": 'SlowStochasticOscillator' }, "SlowStochasticOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'StandardDeviation' }, "StandardDeviation"), createElement("li", { className: 'financialChartListItem', "data-value": 'StochRSI' }, "StochRSI"), createElement("li", { className: 'financialChartListItem', "data-value": 'TRIX' }, "TRIX"), createElement("li", { className: 'financialChartListItem', "data-value": 'TypicalPrice' }, "TypicalPrice"), createElement("li", { className: 'financialChartListItem', "data-value": 'UltimateOscillator' }, "UltimateOscillator"), createElement("li", { className: 'financialChartListItem', "data-value": 'WeightedClose' }, "WeightedClose"), createElement("li", { className: 'financialChartListItem', "data-value": 'WilliamsPercentR' }, "WilliamsPercentR")))))));
};
var ToolbarTemplate = function (props) {
    if (!props.dataContext || !props.dataContext.vm) {
        return null;
    }
    var onChange = function (e) {
        props.dataContext.vm.changeSelection(e.target.Value);
    };
    var IndicatorMenu = props.dataContext.vm.financialChartIndicatorMenu.template;
    var RangeSelector = props.dataContext.vm.financialChartRangeSelector.template;
    var TypePicker = props.dataContext.vm.financialChartTypePicker.template;
    return (createElement("div", { className: 'financialChartToolbar' }, createElement("div", { className: 'financialChartToolbar' }, props.dataContext.vm.isIndicatorMenuVisible && createElement("div", { className: 'financialChartIndicatorMenu' }, IndicatorMenu ? createElement(IndicatorMenu, { dataContext: props.dataContext.vm.financialChartIndicatorMenu }) : createElement("div", null)), createElement("div", { className: 'financialChartRangeSelector' }, RangeSelector ? createElement(RangeSelector, { dataContext: props.dataContext.vm.financialChartRangeSelector }) : createElement("div", null)), createElement("div", { className: 'financialChartTypePicker' }, TypePicker ? createElement(TypePicker, { dataContext: props.dataContext.vm.financialChartTypePicker }) : createElement("div", null)))));
};
var IgrFinancialChartDefaultTemplates = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialChartDefaultTemplates() {
        //getSelection(ele: HTMLSelectElement): string[] {
        //    let ret: string[] = [];
        //    for (let i = 0; i < ele.options.length; i++) {
        //        if (ele.options[i].selected) {
        //            ret.push(ele.options[i].value);
        //        }
        //    }
        //    return ret;
        //}
        this.financialChartRangeSelectorTemplate = RangeSelectorTemplate;
        this.financialChartTypePickerTemplate = ChartTypePickerTemplate;
        this.financialChartIndicatorMenuTemplate = IndicatorMenuTemplate;
        this.financialChartToolbarTemplate = ToolbarTemplate;
        ensureCss();
    }
    IgrFinancialChartDefaultTemplates.register = function () {
        TypeRegistrar.registerCons("IgrFinancialChartDefaultTemplates", IgrFinancialChartDefaultTemplates);
    };
    return IgrFinancialChartDefaultTemplates;
}());

var IgrFinancialIndicatorTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialIndicatorTypeCollection, _super);
    function IgrFinancialIndicatorTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrFinancialIndicatorTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(FinancialIndicatorType_$type, item);
    };
    IgrFinancialIndicatorTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(FinancialIndicatorType_$type, FinancialIndicatorType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrFinancialIndicatorTypeCollection;
}(IgCollection));

var IgrFinancialOverlayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialOverlayTypeCollection, _super);
    function IgrFinancialOverlayTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrFinancialOverlayTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(FinancialOverlayType_$type, item);
    };
    IgrFinancialOverlayTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(FinancialOverlayType_$type, FinancialOverlayType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrFinancialOverlayTypeCollection;
}(IgCollection));

var IgrIndicatorDisplayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrIndicatorDisplayTypeCollection, _super);
    function IgrIndicatorDisplayTypeCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrIndicatorDisplayTypeCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(IndicatorDisplayType_$type, item);
    };
    IgrIndicatorDisplayTypeCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(IndicatorDisplayType_$type, IndicatorDisplayType_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrIndicatorDisplayTypeCollection;
}(IgCollection));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IndicatorDisplayTypeCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IndicatorDisplayTypeCollection, _super);
    function IndicatorDisplayTypeCollection() {
        return _super.call(this, IndicatorDisplayType_$type, 0) || this;
    }
    IndicatorDisplayTypeCollection.$t = markType(IndicatorDisplayTypeCollection, 'IndicatorDisplayTypeCollection', ObservableCollection$1.$.specialize(IndicatorDisplayType_$type));
    return IndicatorDisplayTypeCollection;
}(ObservableCollection$1));

var IgrFinancialChartRangeSelectorOptionCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialChartRangeSelectorOptionCollection, _super);
    function IgrFinancialChartRangeSelectorOptionCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrFinancialChartRangeSelectorOptionCollection.prototype._ensureOuter = function (item) {
        return ensureEnum(FinancialChartRangeSelectorOption_$type, item);
    };
    IgrFinancialChartRangeSelectorOptionCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorOption_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrFinancialChartRangeSelectorOptionCollection;
}(IgCollection));

/**
 * Event arguments for the Financial Chart's custom indicator event.
*/
var IgrFinancialChartCustomIndicatorArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialChartCustomIndicatorArgs() {
    }
    Object.defineProperty(IgrFinancialChartCustomIndicatorArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialChartCustomIndicatorArgs.prototype.onImplementationCreated = function () {
    };
    IgrFinancialChartCustomIndicatorArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrFinancialChartCustomIndicatorArgs.prototype, "indicatorInfo", {
        get: function () {
            if (!this.i.indicatorInfo) {
                return null;
            }
            if (!this.i.indicatorInfo.externalObject && TypeRegistrar.isRegistered("igr-financial-event-args")) {
                var e = TypeRegistrar.create("igr-financial-event-args");
                e._implementation = this.i.indicatorInfo;
                this.i.indicatorInfo.externalObject = e;
            }
            if (this.i.indicatorInfo.externalObject) {
                return this.i.indicatorInfo.externalObject;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChartCustomIndicatorArgs.prototype, "series", {
        /**
     * The Series in context.
    */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChartCustomIndicatorArgs.prototype, "index", {
        /**
         * An integer representing the position of the associated custom indicator in its host.
        */
        get: function () {
            return this.i.index;
        },
        set: function (v) {
            this.i.index = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialChartCustomIndicatorArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomIndicatorNameCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomIndicatorNameCollection, _super);
    function CustomIndicatorNameCollection(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, String_$type, 0) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, String_$type, 1, c) || this;
                }
                break;
        }
        return _this;
    }
    CustomIndicatorNameCollection.$t = markType(CustomIndicatorNameCollection, 'CustomIndicatorNameCollection', ObservableCollection$1.$.specialize(String_$type));
    return CustomIndicatorNameCollection;
}(ObservableCollection$1));

var IgrCustomIndicatorNameCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCustomIndicatorNameCollection, _super);
    function IgrCustomIndicatorNameCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrCustomIndicatorNameCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(String_$type, String_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgrCustomIndicatorNameCollection;
}(IgCollection));

var fg = window && window.CSS && window.CSS.supports &&
    /*@__PURE__*/ window.CSS.supports("display", "grid");
var financialChartToolbarStyle = {
    gridRow: 1,
    msGridRow: 1
};
var financialChartPriceStyle = {
    gridRow: 3,
    msGridRow: 3
};
var financialChartIndicatorsStyle = {
    gridRow: 4,
    msGridRow: 4
};
var financialChartVolumeStyle = {
    gridRow: 5,
    msGridRow: 5
};
var financialChartZoomSliderStyle = {
    gridRow: 6,
    msGridRow: 6
};
var financialChartMainGridStyle = {
    height: '100%',
    width: '100%',
    textAlign: 'left',
    display: fg ? 'grid' : '-ms-grid',
    msGridColumns: '100%'
};
var financialChartLegendStyle = {
    gridRow: 2,
    msGridRow: 2
};
var IgrFinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialChart, _super);
    function IgrFinancialChart(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this._initialized = false;
        _this._toolbarElement = null;
        _this._dataSource = null;
        _this._defaultTooltips = null;
        _this._dynamicContent = {};
        _this._uniqueTooltipId = 0;
        _this._xAxisBreaks = null;
        _this._indicatorTypes = null;
        _this._overlayTypes = null;
        _this._indicatorDisplayTypes = null;
        _this._rangeSelectorOptions = null;
        _this._customIndicatorNames = null;
        _this._applyCustomIndicators = null;
        _this._applyCustomIndicators_wrapped = null;
        _this._toolTemplateRef = _this._toolTemplateRef.bind(_this);
        _this._tooltipRef = _this._tooltipRef.bind(_this);
        _this._mainGridRef = _this._mainGridRef.bind(_this);
        _this._mainRef = _this._mainRef.bind(_this);
        _this._toolbarRef = _this._toolbarRef.bind(_this);
        _this._activeTooltipElements = new Map();
        _this._activeTooltips = new Map();
        _this._currentTooltips = [];
        _this.onDocumentClick = _this.onDocumentClick.bind(_this);
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
            document.addEventListener("click", _this.onDocumentClick);
        }
        var root;
        root = _this._container;
        if (_this._container != null) {
            root = _this._container;
        }
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this._wrapper = ren;
        var chart = _this.i;
        _this._chart = chart;
        if (chart.xAxis) {
            _this.rewrapAxis(chart.xAxis);
        }
        if (chart.yAxis) {
            _this.rewrapAxis(chart.yAxis);
        }
        if (chart.volumeAxis) {
            _this.rewrapAxis(chart.volumeAxis);
        }
        if (chart.volumeXAxis) {
            _this.rewrapAxis(chart.volumeXAxis);
        }
        if (chart.indicatorAxis) {
            _this.rewrapAxis(chart.indicatorAxis);
        }
        if (chart.indicatorXAxis) {
            _this.rewrapAxis(chart.indicatorXAxis);
        }
        if (chart.zoomSliderAxis) {
            _this.rewrapAxis(chart.zoomSliderAxis);
        }
        if (chart.zoomSliderXAxis) {
            _this.rewrapAxis(chart.zoomSliderXAxis);
        }
        chart.provideContainer(ren);
        _this.bindData();
        chart.notifyResized();
        ren.addSizeWatcher(function () {
            _this._checkToolbarSize();
            _this._chart.notifyResized();
        });
        _this._initialized = true;
        return _this;
    }
    IgrFinancialChart.prototype.render = function () {
        var outerChildren = [];
        var children = [
            createElement('div', {
                key: 'financialChartToolbarArea',
                className: 'financialChartToolbarArea',
                style: financialChartToolbarStyle,
                ref: this._toolbarRef
            }, createElement(IgrTemplateContainer, {
                ref: this._toolTemplateRef,
            })),
            createElement('div', { key: 'financialChartLegend', className: 'financialChartLegend', style: financialChartLegendStyle }),
            createElement('div', { key: 'financialChartPrice', className: 'financialChartPrice', style: financialChartPriceStyle }),
            createElement('div', { key: 'financialChartIndicators', className: 'financialChartIndicators', style: financialChartIndicatorsStyle }),
            createElement('div', { key: 'financialChartVolume', className: 'financialChartVolume', style: financialChartVolumeStyle }),
            createElement('div', { key: 'financialChartZoomSlider', className: 'financialChartZoomSlider', style: financialChartZoomSliderStyle })
        ];
        if (this._sliderPortal) {
            children.push(this._sliderPortal);
        }
        if (this._currentTooltips && this._currentTooltips.length > 0) {
            for (var i = 0; i < this._currentTooltips.length; i++) {
                var t = this._currentTooltips[i];
                if (this._activeTooltipElements.has(t)) {
                    var active = this._activeTooltipElements.get(t);
                    outerChildren.push(active);
                }
                else {
                    if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
                        continue;
                    }
                    var Tooltip = TypeRegistrar.get("IgrTooltipContainer");
                    var tEle = createElement(Tooltip, {
                        ref: this._tooltipRef,
                        key: this._currentTooltips[i].key,
                        owner: this._currentTooltips[i]
                    });
                    var portal = createPortal(tEle, t, this._currentTooltips[i].key);
                    this._activeTooltipElements.set(t, portal);
                    outerChildren.push(portal);
                }
            }
        }
        var mainGrid = createElement('div', {
            key: 'financialChartMainGrid',
            className: 'financialChartMainGrid',
            style: financialChartMainGridStyle,
            children: children,
            ref: this._mainGridRef,
        });
        outerChildren.splice(0, 0, mainGrid);
        var mainDiv = createElement('div', {
            className: "ig-financial-chart igr-financial-chart",
            key: "financialChartMainDiv",
            children: outerChildren,
            ref: this._mainRef
        });
        return mainDiv;
    };
    IgrFinancialChart.prototype._tooltipRef = function (t) {
        console.log(t);
        if (t === null) {
            return;
        }
        if (t.currentOwner &&
            t.currentOwner.tooltipTemplate) {
            t.template = t.currentOwner.tooltipTemplate;
        }
        this._activeTooltips.set(t.currentOwner, t);
    };
    IgrFinancialChart.prototype._toolbarRef = function (t) {
        this._toolbarElement = t;
    };
    IgrFinancialChart.prototype._toolTemplateRef = function (t) {
        this._toolbarTemplateComponent = t;
    };
    IgrFinancialChart.prototype._mainGridRef = function (t) {
        this._mainGridElement = t;
    };
    IgrFinancialChart.prototype._mainRef = function (t) {
        this._mainElement = t;
        this._container = t;
        if (!t) {
            return;
        }
        this._wrapper.updateRoot(this._wrapper.getWrapper(this._container));
    };
    Object.defineProperty(IgrFinancialChart.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._mainElement) {
                this._mainElement.style.height = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._mainElement) {
                this._mainElement.style.height = value;
                this._chart.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "rangeSelectorTemplate", {
        get: function () {
            return this._rangeSelectorTemplate;
        },
        set: function (value) {
            this._rangeSelectorTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "chartTypePickerTemplate", {
        get: function () {
            return this._chartTypePickerTemplate;
        },
        set: function (value) {
            this._chartTypePickerTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorMenuTemplate", {
        get: function () {
            return this._indicatorMenuTemplate;
        },
        set: function (value) {
            this._indicatorMenuTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "toolbarTemplate", {
        get: function () {
            return this._toolbarTemplate;
        },
        set: function (value) {
            this._toolbarTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "chartTemplate", {
        get: function () {
            return this._chartTemplate;
        },
        set: function (value) {
            this._chartTemplate = value;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialChart.prototype._checkToolbarSize = function () {
        if (this._toolbarElement) {
            var start = this._toolbarElement;
            if (start.children.length == 1) {
                start = start.children[0];
            }
            if (start.children.length == 1) {
                start = start.children[0];
            }
            var toolbarRoot = start.querySelector(".financialChartToolbar");
            var rootRect = toolbarRoot.getBoundingClientRect();
            var hideRemaining = false;
            for (var i = 0; i < toolbarRoot.children.length; i++) {
                var child = toolbarRoot.children[i];
                if (child.nodeType == Node.ELEMENT_NODE) {
                    if (!hideRemaining) {
                        child.style.display = "";
                    }
                    var childRect = child.getBoundingClientRect();
                    if (hideRemaining ||
                        childRect.left + childRect.width >
                            rootRect.left + rootRect.width) {
                        child.style.display = "none";
                        hideRemaining = true;
                    }
                    else {
                        child.style.display = "";
                    }
                }
            }
        }
    };
    IgrFinancialChart.prototype.componentWillUnmount = function () {
        this._chart.destroy();
        this._wrapper.destroy();
        if (document) {
            document.removeEventListener("click", this.onDocumentClick);
        }
    };
    IgrFinancialChart.prototype.onDocumentClick = function (ev) {
        this._chart.onDocumentClick(ev);
    };
    IgrFinancialChart.prototype.rewrapAxis = function (axis) {
        var axisName = axis.$type.name;
        var componentName = "Igr" + axisName;
        if (TypeRegistrar.isRegistered(componentName)) {
            var x = TypeRegistrar.create(componentName);
            x._implementation = axis;
            axis.externalObject = x;
        }
        else {
            throw new Error("Axis type not loaded: " + componentName);
        }
    };
    IgrFinancialChart.prototype.createImplementation = function () {
        return new FinancialChart();
    };
    Object.defineProperty(IgrFinancialChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialChart.prototype.createSeriesComponent = function (type) {
        if (TypeRegistrar.isRegistered(type)) {
            var s = TypeRegistrar.create(type);
            s.owner = this;
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    };
    IgrFinancialChart.prototype.createIndicator = function (typeName) {
        return this.createSeriesComponent("Igr" + typeName);
    };
    IgrFinancialChart.prototype.createOverlay = function (typeName) {
        return this.createSeriesComponent("Igr" + typeName);
    };
    IgrFinancialChart.prototype.createSeries = function (type) {
        switch (type) {
            case DataSeriesType.Area:
                return this.createSeriesComponent('IgrAreaSeries');
            case DataSeriesType.Column:
                return this.createSeriesComponent('IgrColumnSeries');
            case DataSeriesType.Line:
                return this.createSeriesComponent('IgrLineSeries');
            case DataSeriesType.FinancialPrice:
                return this.createSeriesComponent('IgrFinancialPriceSeries');
            case DataSeriesType.ItemToolTipLayer:
                return this.createSeriesComponent('IgrItemToolTipLayer');
            case DataSeriesType.CategoryToolTipLayer:
                return this.createSeriesComponent('IgrCategoryToolTipLayer');
            case DataSeriesType.CrosshairLayer:
                return this.createSeriesComponent('IgrCrosshairLayer');
            case DataSeriesType.FinalValueLayer:
                return this.createSeriesComponent('IgrFinalValueLayer');
            case DataSeriesType.CalloutLayer:
                return this.createSeriesComponent('IgrCalloutLayer');
            default:
                return this.createSeriesComponent('IgrColumnSeries');
        }
    };
    IgrFinancialChart.prototype.createXAxis = function (type) {
        switch (type) {
            case FinancialChartXAxisMode.Ordinal:
                if (TypeRegistrar.isRegistered("IgrOrdinalTimeXAxis")) {
                    return TypeRegistrar.create("IgrOrdinalTimeXAxis");
                }
                else if (TypeRegistrar.isRegistered("IgrTimeXAxis")) {
                    return TypeRegistrar.create("IgrTimeXAxis");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
            case FinancialChartXAxisMode.Time:
                if (TypeRegistrar.isRegistered("IgrTimeXAxis")) {
                    return TypeRegistrar.create("IgrTimeXAxis");
                }
                else if (TypeRegistrar.isRegistered("IgrOrdinalTimeXAxis")) {
                    return TypeRegistrar.create("IgrOrdinalTimeXAxis");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
        }
    };
    IgrFinancialChart.prototype.createYAxis = function (type) {
        switch (type) {
            case FinancialChartYAxisMode.Numeric:
                if (TypeRegistrar.isRegistered("IgrNumericYAxis")) {
                    return TypeRegistrar.create("IgrNumericYAxis");
                }
                else if (TypeRegistrar.isRegistered("IgrPercentChangeYAxis")) {
                    return TypeRegistrar.create("IgrPercentChangeYAxis");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
            case FinancialChartYAxisMode.PercentChange:
                if (TypeRegistrar.isRegistered("IgrPercentChangeYAxis")) {
                    return TypeRegistrar.create("IgrPercentChangeYAxis");
                }
                else if (TypeRegistrar.isRegistered("IgrNumericYAxis")) {
                    return TypeRegistrar.create("IgrNumericYAxis");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
        }
    };
    Object.defineProperty(IgrFinancialChart.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: true,
        configurable: true
    });
    IgrFinancialChart.prototype.bindData = function () {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    };
    IgrFinancialChart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        if (this._mainElement) {
            if (this._width) {
                this._mainElement.style.width = this._width;
            }
            if (this._height) {
                this._mainElement.style.height = this._height;
            }
        }
        this.initializeContent();
        this._chart.notifyResized();
    };
    IgrFinancialChart.prototype.initializeContent = function () {
        var _this = this;
        if (TypeRegistrar.isRegistered("IgrDataChartDefaultTooltips")) {
            var d = TypeRegistrar.create("IgrDataChartDefaultTooltips");
            this._defaultTooltips = d;
            this._onDefaultTooltipsReady(d);
            //this._container.appendChild(cr.location.nativeElement);
        }
        var context = this._chart.getContext();
        if (!this._defaultTemplates) {
            this._defaultTemplates = new IgrFinancialChartDefaultTemplates();
        }
        var toolbarArea = this._toolbarTemplateComponent;
        var toolbarContext = context.vm.toolbar;
        toolbarContext.vm.financialChartIndicatorMenu.template = this.indicatorMenuTemplate ? this.indicatorMenuTemplate : this._defaultTemplates.financialChartIndicatorMenuTemplate;
        toolbarContext.vm.financialChartIndicatorMenu.vm.notifyChanged = function () { toolbarArea.dataContext = toolbarContext; };
        toolbarContext.vm.financialChartTypePicker.template = this.chartTypePickerTemplate ? this.chartTypePickerTemplate : this._defaultTemplates.financialChartTypePickerTemplate;
        toolbarContext.vm.financialChartTypePicker.vm.notifyChanged = function () { toolbarArea.dataContext = toolbarContext; };
        toolbarContext.vm.financialChartRangeSelector.template = this.rangeSelectorTemplate ? this.rangeSelectorTemplate : this._defaultTemplates.financialChartRangeSelectorTemplate;
        toolbarContext.vm.financialChartRangeSelector.vm.notifyChanged = function () {
            toolbarArea.dataContext = toolbarContext;
        };
        toolbarContext.template = this.toolbarTemplate ? this.toolbarTemplate : this._defaultTemplates.financialChartToolbarTemplate;
        var toolContainer = this._toolbarElement;
        //let toolbarArea = this._templates.toArray()[0];
        //let mainArea = this._templates.toArray()[1];
        toolbarArea.contentReady = function () {
            toolbarArea.contentReady = null;
            _this._chart.provideGrid(gridWrapper);
            _this._checkToolbarSize();
        };
        toolbarArea.dataContext = toolbarContext;
        toolbarArea.template = toolbarContext.template;
        var ele = this._toolbarElement;
        //ele.style.width = "100%";
        //ele.style.height = "100%";
        //if (ele.parentElement != null) {
        //    ele.parentElement.removeChild(ele);
        //}
        //toolContainer.appendChild(ele);
        //this._wrapper.setStyleProperty(ele, "display", "")
        ele.style.display = "";
        var legendContainer = context.legendContainer.rootWrapper.getNativeElement();
        var mainContainer = context.container.rootWrapper.getNativeElement();
        var indicatorContainer = context.indicatorsContainer.rootWrapper.getNativeElement();
        var volumeContainer = context.volumeContainer.rootWrapper.getNativeElement();
        var zoomSliderContainer = context.zoomContainer.rootWrapper.getNativeElement();
        var main = this._mainGridElement;
        var templateMain = main.querySelector(".financialChartPrice");
        var templateToolbar = main.querySelector(".financialChartToolbar");
        var templateLegend = main.querySelector(".financialChartLegend");
        var templateIndicator = main.querySelector(".financialChartIndicators");
        var templateVolume = main.querySelector(".financialChartVolume");
        var templateZoomSlider = main.querySelector(".financialChartZoomSlider");
        var grid = main; // main.querySelector(".financialChartMainGrid");
        var gridWrapper = new ReactWrapper(grid, this._wrapper);
        templateMain.appendChild(mainContainer);
        //templateToolbar.appendChild(toolContainer);
        templateLegend.appendChild(legendContainer);
        templateIndicator.appendChild(indicatorContainer);
        templateVolume.appendChild(volumeContainer);
        templateZoomSlider.appendChild(zoomSliderContainer);
        this._styling(this._container, this);
        //this._mainElement.nativeElement.parentElement.removeChild(this._mainElement.nativeElement);
        //this.container.appendChild(this._mainElement.nativeElement);
    };
    IgrFinancialChart.prototype._createZoomSlider = function (hostEle, onReady) {
        if (!TypeRegistrar.isRegistered("IgrZoomSlider")) {
            //shouldn't happen.
            throw new Error("zoom slider component isn't loaded");
        }
        var Slider = TypeRegistrar.get("IgrZoomSlider");
        var ele = createElement(Slider, {
            width: '100%', height: '100%', ref: function (r) {
                onReady(r);
            }
        });
        var portal = createPortal(ele, hostEle);
        hostEle.className = "test";
        hostEle.style.width = "100%";
        hostEle.style.height = "100%";
        this._sliderPortal = portal;
    };
    IgrFinancialChart.prototype.createTooltip = function () {
        // if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
        // 	return null;
        // }
        // let Tooltip = TypeRegistrar.get("IgrTooltipContainer");
        var wrapper = this._wrapper.createElement("div");
        var ele = wrapper.getNativeElement();
        ele.key = "__tooltip_" + this._uniqueTooltipId;
        this._uniqueTooltipId++;
        this._currentTooltips = this._currentTooltips.slice(0);
        this._currentTooltips.push(ele);
        //let element = React.createElement(Tooltip,  );
        //let portal = ReactDOM.createPortal(element, ele);
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgrDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            if (self._activeTooltips.has(ele)) {
                var t = self._activeTooltips.get(ele);
                t.dataContext = c;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        this._updateTooltipState();
        return ele;
    };
    IgrFinancialChart.prototype._ensureTooltipCreated = function (series) {
        var _this = this;
        series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
            var wrapper = new ReactWrapper(ele, _this._wrapper);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            if (_this._activeTooltips.has(ele)) {
                var tCont = _this._activeTooltips.get(ele);
                tCont.template = ele.tooltipTemplate;
            }
            return wrapper;
        });
    };
    // private _createXAxis(): any {
    //     let x = new IgxCategoryXAxisComponent();
    //     return x.i;
    // }
    // private _createYAxis(): any {
    //     let y = new IgxNumericYAxisComponent();
    //     return y.i;
    // }
    IgrFinancialChart.prototype._ensureDefaultTooltip = function (series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips["ensureDefaultTooltip"](series);
    };
    IgrFinancialChart.prototype._onDefaultTooltipsReady = function (cr) {
        if (this.i.dataChart) {
            var currSeries = this.i.dataChart.series;
            for (var i = 0; i < currSeries.count; i++) {
                if (currSeries.item(i).externalObject.showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                }
            }
        }
    };
    IgrFinancialChart.prototype._updateTooltipState = function () {
        if (this._initialized) {
            this.setState({ tooltips: this._currentTooltips });
        }
    };
    Object.defineProperty(IgrFinancialChart.prototype, "xAxisBreaks", {
        /**
         * TimeAxisBreaks to apply to this chart when in time axis mode, representing spans of time to omit, such as weekends.
        */
        get: function () {
            if (this._xAxisBreaks === null) {
                if (!TypeRegistrar.isRegistered("IgrTimeAxisBreakCollection")) {
                    return null;
                }
                var coll = TypeRegistrar.create("IgrTimeAxisBreakCollection");
                var innerColl = this.i.xAxisBreaks;
                if (!innerColl) {
                    innerColl = TypeRegistrar.create("TimeAxisBreakCollection");
                }
                this._xAxisBreaks = coll._fromInner(innerColl);
                this.i._xAxisBreaks = innerColl;
            }
            return this._xAxisBreaks;
        },
        set: function (v) {
            if (this._xAxisBreaks !== null) {
                this._xAxisBreaks._setSyncTarget(null);
                this._xAxisBreaks = null;
            }
            if (!TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection")) {
                return;
            }
            var coll = TypeRegistrar.create("IgxTimeAxisBreakCollection");
            var t = TypeRegistrar.get("TimeAxisBreak");
            this._xAxisBreaks = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(t.$type);
            var innerColl = this.i.xAxisBreaks;
            if (!innerColl) {
                innerColl = TypeRegistrar.create("TimeAxisBreakCollection");
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._xAxisBreaks._setSyncTarget(syncColl);
            this.i._xAxisBreaks = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "leftMargin", {
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "isHorizontalZoomEnabled", {
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "toolbarHeight", {
        get: function () {
            return this.i.sj;
        },
        set: function (v) {
            this.i.sj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisIsLogarithmic", {
        /**
         * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
         * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
        */
        get: function () {
            return this.i.rp;
        },
        set: function (v) {
            this.i.rp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisLogarithmBase", {
        /**
         * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
         * This property is effective only when YAxisIsLogarithmic is true.
        */
        get: function () {
            return this.i.tb;
        },
        set: function (v) {
            this.i.tb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisInterval", {
        /**
         * Gets or sets the distance between each label and grid line along the Y-axis.
        *
        * The `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	yAxisInterval={20}
        *  />
        * ```
        */
        get: function () {
            return this.i.sn;
        },
        set: function (v) {
            this.i.sn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisMinimumValue", {
        /**
         * Gets or sets the data value corresponding to the minimum value of the Y-axis.
        *
        * The `yAxisMinimumValue` determines starting value of labels, tickmarks, and gridlines on the y-axis.
        *
        * ```ts
        * <IgrFinancialChart
        *     yAxisMinimumValue={-200}
        *     yAxisMaximumValue={1000}
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.sp;
        },
        set: function (v) {
            this.i.sp = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisMaximumValue", {
        /**
         * Gets or sets the data value corresponding to the maximum value of the Y-axis.
        *
        * The `yAxisMaximumValue` determines ending value of labels, tickmarks, and gridlines on the y-axis.
        *
        * ```ts
        * <IgrFinancialChart
        *  yAxisMinimumValue={-200}
        *     yAxisMaximumValue={100}
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.so;
        },
        set: function (v) {
            this.i.so = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisMinorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines along the Y-axis.
        *
        * The `yAxisMinorInterval` determines how often to show minor gridline along the y-axis.  Set this property to a number less than the `yAxisInterval` and the numeric range of the y-axis.
        *
        * ```ts
        * <IgrFinancialChart
        *      yAxisMinorInterval={50}
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.sq;
        },
        set: function (v) {
            this.i.sq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisActualMinimum", {
        /**
         * Gets the current minimum value for the Y-axis.
        */
        get: function () {
            return this.i.sm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisActualMaximum", {
        /**
         * Gets the current maximum value for the Y-axis.
        */
        get: function () {
            return this.i.sl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "volumeType", {
        /**
         * The type of series to display in the volume pane.
        *
        * Use the `volumeType` property to set a type of all series that will be rendered in the volume pane, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	volumeType="Column" />
        * ```
        */
        get: function () {
            return this.i.pt;
        },
        set: function (v) {
            this.i.pt = ensureEnum(FinancialChartVolumeType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "xAxisMode", {
        /**
         * The scaling mode of the X-axis.
        *
        * Use the `xAxisMode` property to plot data items without any breaks in data range (Ordinal mode) or with breaks in data range (Time mode) such as weekends/holidays. Note that the Ordinal axis mode is less expensive to use in the financial chart than the Time axis mode.
        *
        * ```ts
        * <IgrFinancialChart
        *      xAxisMode="time"
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.pv;
        },
        set: function (v) {
            this.i.pv = ensureEnum(FinancialChartXAxisMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisMode", {
        /**
         * The scaling mode of the Y-axis.
        *
        * Use the `yAxisMode` property to plot data items using their actual values (Numeric) or using percent changes from the first data point (PercentChange), e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *      yAxisMode={this.state.yAxisMode}
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.px;
        },
        set: function (v) {
            this.i.px = ensureEnum(FinancialChartYAxisMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "isToolbarVisible", {
        /**
         * A boolean property controlling the visibility of the toolbar.
        */
        get: function () {
            return this.i.rk;
        },
        set: function (v) {
            this.i.rk = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "chartType", {
        /**
         * The type of price series to display in the main chart.
        *
        * Use the `chartType` property to set a type of series that will be used to render prices in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *   width="100%"
        *   height="400px"
        * 	chartType="Candle"
        *   dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.po;
        },
        set: function (v) {
            this.i.po = ensureEnum(FinancialChartType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisLabelHorizontalAlignment", {
        /**
         * Gets or sets Horizontal alignment of Y-axis labels.
        */
        get: function () {
            return this.i.nk;
        },
        set: function (v) {
            this.i.nk = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "isWindowSyncedToVisibleRange", {
        /**
         * A boolean indicating whether the chart should automatically zoom in vertically on the currently visible range of data.
         * When this property is set to true, panning and zooming along the X-axis will result in a corresponding zoom on the Y-axis, so that the visible range of data fills the zoom window as fully as possible.
        */
        get: function () {
            return this.i.rl;
        },
        set: function (v) {
            this.i.rl = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorTypes", {
        /**
         * A collection indicating what financial indicator types to display on the Financial Chart.
        *
        * Use the `indicatorTypes` property to set types of indicators that will be rendered below the price pane in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorTypes="ForceIndex" />
        * ```
        */
        get: function () {
            if (this._indicatorTypes === null) {
                var coll = new IgrFinancialIndicatorTypeCollection();
                var innerColl = this.i.p2;
                if (!innerColl) {
                    innerColl = new FinancialIndicatorTypeCollection(0);
                }
                this._indicatorTypes = coll._fromInner(innerColl);
                this.i.p2 = innerColl;
            }
            return this._indicatorTypes;
        },
        set: function (v) {
            if (this._indicatorTypes !== null) {
                this._indicatorTypes._setSyncTarget(null);
                this._indicatorTypes = null;
            }
            var coll = new IgrFinancialIndicatorTypeCollection();
            this._indicatorTypes = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(FinancialIndicatorType_$type);
            var innerColl = this.i.p2;
            if (!innerColl) {
                innerColl = new FinancialIndicatorTypeCollection(0);
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._indicatorTypes._setSyncTarget(syncColl);
            this.i.p2 = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "overlayTypes", {
        /**
         * A collection indicating what financial overlay types to display on the Financial Chart.
        *
        * Use the `overlayTypes` property to set types of overlays that will be rendered behind price series in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	overlayType ="PriceChannel" />
        * ```
        */
        get: function () {
            if (this._overlayTypes === null) {
                var coll = new IgrFinancialOverlayTypeCollection();
                var innerColl = this.i.p4;
                if (!innerColl) {
                    innerColl = new FinancialOverlayTypeCollection(0);
                }
                this._overlayTypes = coll._fromInner(innerColl);
                this.i.p4 = innerColl;
            }
            return this._overlayTypes;
        },
        set: function (v) {
            if (this._overlayTypes !== null) {
                this._overlayTypes._setSyncTarget(null);
                this._overlayTypes = null;
            }
            var coll = new IgrFinancialOverlayTypeCollection();
            this._overlayTypes = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(FinancialOverlayType_$type);
            var innerColl = this.i.p4;
            if (!innerColl) {
                innerColl = new FinancialOverlayTypeCollection(0);
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._overlayTypes._setSyncTarget(syncColl);
            this.i.p4 = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisAbbreviateLargeNumbers", {
        /**
         * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
        */
        get: function () {
            return this.i.ro;
        },
        set: function (v) {
            this.i.ro = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "resolution", {
        /**
         * Gets or sets the rendering resolution for all series in this chart.
         * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
        */
        get: function () {
            return this.i.cu;
        },
        set: function (v) {
            this.i.cu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "yAxisLabelLocation", {
        /**
         * Gets or sets the location of Y-axis labels, relative to the plot area.
        */
        get: function () {
            return this.i.ih;
        },
        set: function (v) {
            this.i.ih = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "zoomSliderType", {
        /**
         * Gets or sets type of series to display in the zoom slider pane.
        *
        * Use the `zoomSliderType` property to set a type of all series that will be rendered in the zoom pane, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     zoomSliderType="Candle"
        *     dataSource={this.data} />
        * ```
        */
        get: function () {
            return this.i.p0;
        },
        set: function (v) {
            this.i.p0 = ensureEnum(FinancialChartZoomSliderType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "negativeBrushes", {
        /**
         * Gets or sets the palette used for coloring negative items of Waterfall chart type.
        *
        * Use the `negativeBrushes` property to set a collection of brushes that will be used to render fill area of negative elements in the price pane, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	negativeBrushes="Red" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.ox);
        },
        set: function (v) {
            this.i.ox = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "negativeOutlines", {
        /**
         * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
        *
        * Use the `negativeOutlines` property to set a collection of brushes that will be used to render outline of negative elements in the price pane, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	negativeOutlines= "Green"/>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.oy);
        },
        set: function (v) {
            this.i.oy = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "overlayBrushes", {
        /**
         * Brushes to use for filling financial overlays.
        *
        * Use the `overlayBrushes` property to set a collection of brushes that will be used to render fill area of overlays in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	overlayBrushes="Green" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.oz);
        },
        set: function (v) {
            this.i.oz = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "overlayOutlines", {
        /**
         * Brushes to use for outlining financial overlays.
        *
        * Use the `overlayOutlines` property to set a collection of brushes that will be used to render outlines of overlays in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	overlayOutlines="Red" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.o0);
        },
        set: function (v) {
            this.i.o0 = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "volumeOutlines", {
        /**
         * Brushes to use for outlining volume series in the volume pane.
        *
        * Use the `volumeOutlines` property to set a collection of brushes that will be used to render outline of multiple series in the volume pane of the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	volumeOutlines="Green" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.o2);
        },
        set: function (v) {
            this.i.o2 = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "volumeBrushes", {
        /**
         * Brushes to use for filling volume series in the volume pane.
        *
        * Use the `volumeBrushes` property to set a collection of brushes that will be used to render fill area of multiple series in the volume pane of the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	volumeBrushes="Green" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.o1);
        },
        set: function (v) {
            this.i.o1 = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorNegativeBrushes", {
        /**
         * Brushes to use for negative elements in financial indicators.
        *
        * Use the `indicatorNegativeBrushes` property to set a collection of brushes that will be used to render negative elements of indicators in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorNegativeBrushes="Red"/>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.ow);
        },
        set: function (v) {
            this.i.ow = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorBrushes", {
        /**
         * Brushes to use for financial indicators.
        *
        * Use the `indicatorBrushes` property to set a collection of brushes that will be used to render positive elements of indicators in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorBrushes="Green" />
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.ov);
        },
        set: function (v) {
            this.i.ov = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "volumeThickness", {
        /**
         * The outline thickness of volume series in the volume pane.
        *
        * Use the `volumeThickness` property to set a number that will be used to render outline thickness of all series in the volume pane, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	volumeThickness= {2.5}/>
        * ```
        */
        get: function () {
            return this.i.sk;
        },
        set: function (v) {
            this.i.sk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "overlayThickness", {
        /**
         * The outline thickness of financial overlays.
        *
        * Use the `overlayThickness` property to set a number that will be used to render outline thickness of all overlays in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	overlayThickness ={2.5}  />
        * ```
        */
        get: function () {
            return this.i.si;
        },
        set: function (v) {
            this.i.si = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorThickness", {
        /**
         * The outline or stroke thickness of financial indicators.
        *
        * Use the `indicatorThickness` property to set a number that will be used to render outline thickness of all indicators in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorThickness={2.5}  />
        * ```
        */
        get: function () {
            return this.i.sh;
        },
        set: function (v) {
            this.i.sh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorDisplayTypes", {
        /**
         * The display types of financial indicators.
        *
        * Use the `indicatorDisplayTypes` property to set display types that will determine whether render all indicators as area, lines, or columns in the Financial Chart control, e.g.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorDisplayTypes="line" />
        * ```
        */
        get: function () {
            if (this._indicatorDisplayTypes === null) {
                var coll = new IgrIndicatorDisplayTypeCollection();
                var innerColl = this.i.qe;
                if (!innerColl) {
                    innerColl = new IndicatorDisplayTypeCollection();
                }
                this._indicatorDisplayTypes = coll._fromInner(innerColl);
                this.i.qe = innerColl;
            }
            return this._indicatorDisplayTypes;
        },
        set: function (v) {
            if (this._indicatorDisplayTypes !== null) {
                this._indicatorDisplayTypes._setSyncTarget(null);
                this._indicatorDisplayTypes = null;
            }
            var coll = new IgrIndicatorDisplayTypeCollection();
            this._indicatorDisplayTypes = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(IndicatorDisplayType_$type);
            var innerColl = this.i.qe;
            if (!innerColl) {
                innerColl = new IndicatorDisplayTypeCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._indicatorDisplayTypes._setSyncTarget(syncColl);
            this.i.qe = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorPeriod", {
        /**
         * The period of financial indicators, where applicable.
        *
        * The `indicatorPeriod` property applies to only the `BollingerBands` overlay as well as to these indicators types: `AverageDirectionalIndex`, `AverageTrueRange`, `BollingerBandWidth`, `ChaikinVolatility`, `CommodityChannelIndex`, `DetrendedPriceOscillator`, `FastStochasticOscillator`, `ForceIndex`, `FullStochasticOscillator`, `MoneyFlowIndex`, `IgrPriceChannelOverlay`, `RateOfChangeAndMomentum`, `RelativeStrengthIndex`, `SlowStochasticOscillator`, `StandardDeviation`, `StochRSI`, `TRIX`, `WilliamsPercentR`
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorPeriod={8} />
        * ```
        */
        get: function () {
            return this.i.s6;
        },
        set: function (v) {
            this.i.s6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorMultiplier", {
        /**
         * The multiplier of financial indicators, where applicable.
        *
        * The `indicatorMultiplier` property applies to only to BollingerBandWidth indicator type.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorMultiplier= {8} />
        * ```
        */
        get: function () {
            return this.i.sg;
        },
        set: function (v) {
            this.i.sg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorSmoothingPeriod", {
        /**
         * The smoothing period of financial indicators, where applicable.
        *
        * The `indicatorSmoothingPeriod` property applies to only to `FullStochasticOscillator` indicator type.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorSmoothingPeriod={8}     />
        * ```
        */
        get: function () {
            return this.i.s9;
        },
        set: function (v) {
            this.i.s9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorShortPeriod", {
        /**
         * The short period of financial indicators, where applicable.
        *
        * The `indicatorShortPeriod` property applies only to these indicator types:
        *
        * -   AbsoluteVolumeOscillator,
        * -   ChaikinOscillator,
        * -   MovingAverageConvergenceDivergence,
        * -   PercentagePriceOscillator,
        * -   PercentageVolumeOscillator,
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorShortPeriod={8} />
        * ```
        */
        get: function () {
            return this.i.s7;
        },
        set: function (v) {
            this.i.s7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorLongPeriod", {
        /**
         * The long period of financial indicators, where applicable.
        *
        * The `indicatorLongPeriod` property applies only to these indicator types:
        *
        * -   AbsoluteVolumeOscillator,
        * -   ChaikinOscillator,
        * -   MovingAverageConvergenceDivergence,
        * -   PercentagePriceOscillator,
        * -   PercentageVolumeOscillator,
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorLongPeriod={8} />
        * ```
        */
        get: function () {
            return this.i.s5;
        },
        set: function (v) {
            this.i.s5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "indicatorSignalPeriod", {
        /**
         * The signal period of financial indicators, where applicable.
        *
        * The `indicatorSignalPeriod` property applies to only to MovingAverageConvergenceDivergence indicator type.
        *
        * ```ts
        * <IgrFinancialChart
        *     width="100%"
        *     height="400px"
        *     dataSource={this.data}
        * 	indicatorSignalPeriod ={8} />
        * ```
        */
        get: function () {
            return this.i.s8;
        },
        set: function (v) {
            this.i.s8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "rangeSelectorOptions", {
        /**
         * A FinancialChartRangeSelectorOptionCollection containing the available range selector options on the toolbar.
        */
        get: function () {
            if (this._rangeSelectorOptions === null) {
                var coll = new IgrFinancialChartRangeSelectorOptionCollection();
                var innerColl = this.i.pk;
                if (!innerColl) {
                    innerColl = new FinancialChartRangeSelectorOptionCollection(0);
                }
                this._rangeSelectorOptions = coll._fromInner(innerColl);
                this.i.pk = innerColl;
            }
            return this._rangeSelectorOptions;
        },
        set: function (v) {
            if (this._rangeSelectorOptions !== null) {
                this._rangeSelectorOptions._setSyncTarget(null);
                this._rangeSelectorOptions = null;
            }
            var coll = new IgrFinancialChartRangeSelectorOptionCollection();
            this._rangeSelectorOptions = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(FinancialChartRangeSelectorOption_$type);
            var innerColl = this.i.pk;
            if (!innerColl) {
                innerColl = new FinancialChartRangeSelectorOptionCollection(0);
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._rangeSelectorOptions._setSyncTarget(syncColl);
            this.i.pk = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "customIndicatorNames", {
        /**
         * The names of custom indicators to add to the chart.
         * When CustomIndicatorNames is set, the ApplyCustomIndicators event will be raised for each custom indicator name.
        */
        get: function () {
            if (this._customIndicatorNames === null) {
                var coll = new IgrCustomIndicatorNameCollection();
                var innerColl = this.i.customIndicatorNames;
                if (!innerColl) {
                    innerColl = new CustomIndicatorNameCollection(0);
                }
                this._customIndicatorNames = coll._fromInner(innerColl);
                this.i.customIndicatorNames = innerColl;
            }
            return this._customIndicatorNames;
        },
        set: function (v) {
            if (this._customIndicatorNames !== null) {
                this._customIndicatorNames._setSyncTarget(null);
                this._customIndicatorNames = null;
            }
            var coll = new IgrCustomIndicatorNameCollection();
            this._customIndicatorNames = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(String_$type);
            var innerColl = this.i.customIndicatorNames;
            if (!innerColl) {
                innerColl = new CustomIndicatorNameCollection(0);
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._customIndicatorNames._setSyncTarget(syncColl);
            this.i.customIndicatorNames = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "isVerticalZoomEnabled", {
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "zoomSliderXAxisMajorStroke", {
        /**
         * Gets or sets stroke brush of major gridlines on x-axis of the zoom slider pane
        */
        get: function () {
            return brushToString(this.i.xb);
        },
        set: function (v) {
            this.i.xb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "zoomSliderXAxisMajorStrokeThickness", {
        /**
         * Gets or sets thickness of major gridlines on x-axis of the zoom slider pane
        */
        get: function () {
            return this.i.sr;
        },
        set: function (v) {
            this.i.sr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "isLegendVisible", {
        /**
         * Gets or sets weather or not a legend is visible between toolbar and chart's plot area
        */
        get: function () {
            return this.i.rg;
        },
        set: function (v) {
            this.i.rg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "xAxisMinimumValue", {
        /**
         * Gets or sets minimum value on x-axis
        */
        get: function () {
            return this.i.r4;
        },
        set: function (v) {
            this.i.r4 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialChart.prototype, "xAxisMaximumValue", {
        /**
         * Gets or sets maximum value on x-axis
        */
        get: function () {
            return this.i.r3;
        },
        set: function (v) {
            this.i.r3 = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    IgrFinancialChart.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    IgrFinancialChart.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.gr(source_, index, newItem);
    };
    IgrFinancialChart.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.gs(source_, index, oldItem);
    };
    IgrFinancialChart.prototype.notifyClearItems = function (source_) {
        this.i.gq(source_);
    };
    IgrFinancialChart.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.gu(source_, index, oldItem, newItem);
    };
    /**
     * Returns visuals as a serialized string.
    
    */
    IgrFinancialChart.prototype.exportSerializedVisualData = function () {
        var iv = this.i.tv();
        return (iv);
    };
    Object.defineProperty(IgrFinancialChart.prototype, "applyCustomIndicators", {
        /**
         * Event raised by the chart when custom indicator data is needed from the application.
         * During series rendering, event will be raised once for each value in the CustomIndicatorNames collection.
        */
        get: function () {
            return this._applyCustomIndicators;
        },
        set: function (ev) {
            var _this = this;
            if (this._applyCustomIndicators_wrapped !== null) {
                this.i.applyCustomIndicators = delegateRemove(this.i.applyCustomIndicators, this._applyCustomIndicators_wrapped);
                this._applyCustomIndicators_wrapped = null;
                this._applyCustomIndicators = null;
            }
            this._applyCustomIndicators = ev;
            this._applyCustomIndicators_wrapped = function (o, e) {
                var outerArgs = new IgrFinancialChartCustomIndicatorArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeApplyCustomIndicators) {
                    _this.beforeApplyCustomIndicators(_this, outerArgs);
                }
                if (_this._applyCustomIndicators) {
                    _this._applyCustomIndicators(_this, outerArgs);
                }
            };
            this.i.applyCustomIndicators = delegateCombine(this.i.applyCustomIndicators, this._applyCustomIndicators_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialChart;
}(IgrXYChart));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinancialChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialChartCoreModule() {
    }
    IgrFinancialChartCoreModule.register = function () {
        TypeRegistrar.registerCons('IgrFinancialChart', IgrFinancialChart);
        TypeRegistrar.registerCons('IgrFinancialChartDefaultTemplates', IgrFinancialChartDefaultTemplates);
        IgrTemplateContentModule.register();
    };
    return IgrFinancialChartCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ZoomSliderOrientation = /*@__PURE__*/ (function (ZoomSliderOrientation) {
    ZoomSliderOrientation[ZoomSliderOrientation["Horizontal"] = 0] = "Horizontal";
    ZoomSliderOrientation[ZoomSliderOrientation["Vertical"] = 1] = "Vertical";
    return ZoomSliderOrientation;
})({});
/**
 * @hidden
 */
var ZoomSliderOrientation_$type = /*@__PURE__*/ markEnum('ZoomSliderOrientation', 'Horizontal,0|Vertical,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ZoomSliderResolvingAxisValueEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ZoomSliderResolvingAxisValueEventArgs, _super);
    function ZoomSliderResolvingAxisValueEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._position = 0;
        _this._value = null;
        return _this;
    }
    Object.defineProperty(ZoomSliderResolvingAxisValueEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSliderResolvingAxisValueEventArgs.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (a) {
            this._value = a;
        },
        enumerable: true,
        configurable: true
    });
    ZoomSliderResolvingAxisValueEventArgs.$t = markType(ZoomSliderResolvingAxisValueEventArgs, 'ZoomSliderResolvingAxisValueEventArgs');
    return ZoomSliderResolvingAxisValueEventArgs;
}(Base));

var IgrZoomSliderResolvingAxisValueEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrZoomSliderResolvingAxisValueEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrZoomSliderResolvingAxisValueEventArgs.prototype.createImplementation = function () {
        return new ZoomSliderResolvingAxisValueEventArgs();
    };
    Object.defineProperty(IgrZoomSliderResolvingAxisValueEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrZoomSliderResolvingAxisValueEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrZoomSliderResolvingAxisValueEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrZoomSliderResolvingAxisValueEventArgs.prototype, "position", {
        get: function () {
            return this.i.position;
        },
        set: function (v) {
            this.i.position = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSliderResolvingAxisValueEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrZoomSliderResolvingAxisValueEventArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackThumbVisual_$type = /*@__PURE__*/ new Type(null, 'ITrackThumbVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultTrackThumbVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultTrackThumbVisual, _super);
    function DefaultTrackThumbVisual() {
        var _this = _super.call(this) || this;
        _this._translateX = 0;
        _this._translateY = 0;
        _this.c = -1;
        _this.a = 0;
        _this.b = -1;
        _this._thumbBox = null;
        _this._thumbRidges = null;
        _this._allPaths = null;
        _this.thumbBox = new Path();
        _this.thumbRidges = new Path();
        _this.allPaths = new List$1(Path.$, 0);
        _this.allPaths.add(_this.thumbBox);
        _this.allPaths.add(_this.thumbRidges);
        _this.width = _this.getTrackThumbDefaultWidth();
        _this.height = _this.getTrackThumbDefaultHeight();
        _this.thumbBox._stroke = _this.getThumbBoxDefaultStroke();
        _this.thumbBox.ac = _this.getThumbBoxDefaultStrokeThickness();
        _this.thumbBox._fill = _this.getThumbBoxDefaultBrush();
        _this.thumbRidges._stroke = _this.getThumbRidgesDefaultStroke();
        _this.thumbRidges.ac = 1;
        return _this;
    }
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "translateX", {
        get: function () {
            return this._translateX;
        },
        set: function (a) {
            this._translateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "translateY", {
        get: function () {
            return this._translateY;
        },
        set: function (a) {
            this._translateY = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbVisual.prototype.getTrackThumbDefaultWidth = function () {
        return 10;
    };
    DefaultTrackThumbVisual.prototype.getTrackThumbDefaultHeight = function () {
        return 22;
    };
    DefaultTrackThumbVisual.prototype.getThumbBoxDefaultStroke = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    };
    DefaultTrackThumbVisual.prototype.getThumbBoxDefaultStrokeThickness = function () {
        return 1;
    };
    DefaultTrackThumbVisual.prototype.getThumbBoxDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 249, 249, 249);
            return $ret;
        })());
    };
    DefaultTrackThumbVisual.prototype.getThumbRidgesDefaultStroke = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 119, 119, 119);
            return $ret;
        })());
    };
    DefaultTrackThumbVisual.prototype.e = function () {
        if (this.orientation == 0) {
            var a = new PathGeometry();
            var b = new PathFigure();
            var c = new LineSegment(1);
            b._isClosed = false;
            b._isFilled = false;
            b._startPoint = { $type: Point_$type, x: -1.5, y: -4 };
            c.c = { $type: Point_$type, x: -1.5, y: 4 };
            b._segments.add(c);
            a.c.add(b);
            var d = new PathFigure();
            var e = new LineSegment(1);
            d._isClosed = false;
            d._isFilled = false;
            d._startPoint = { $type: Point_$type, x: 1.5, y: -4 };
            e.c = { $type: Point_$type, x: 1.5, y: 4 };
            d._segments.add(e);
            a.c.add(d);
            this.thumbRidges.ak = a;
        }
        else {
            var f = new PathGeometry();
            var g = new PathFigure();
            var h = new LineSegment(1);
            g._isClosed = false;
            g._isFilled = false;
            g._startPoint = { $type: Point_$type, x: -4, y: -1.5 };
            h.c = { $type: Point_$type, x: 4, y: -1.5 };
            g._segments.add(h);
            f.c.add(g);
            var i = new PathFigure();
            var j = new LineSegment(1);
            i._isClosed = false;
            i._isFilled = false;
            i._startPoint = { $type: Point_$type, x: -4, y: 1.5 };
            j.c = { $type: Point_$type, x: 4, y: 1.5 };
            i._segments.add(j);
            f.c.add(i);
            this.thumbRidges.ak = f;
        }
    };
    DefaultTrackThumbVisual.prototype.d = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.thumbBox.ak = a;
    };
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "width", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbVisual.prototype.f = function () {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    };
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "orientation", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "height", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "thumbBox", {
        get: function () {
            return this._thumbBox;
        },
        set: function (a) {
            this._thumbBox = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "thumbRidges", {
        get: function () {
            return this._thumbRidges;
        },
        set: function (a) {
            this._thumbRidges = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbVisual.prototype, "allPaths", {
        get: function () {
            return this._allPaths;
        },
        set: function (a) {
            this._allPaths = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbVisual.$t = markType(DefaultTrackThumbVisual, 'DefaultTrackThumbVisual', Base.$, [ITrackThumbVisual_$type]);
    return DefaultTrackThumbVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackRangeVisual_$type = /*@__PURE__*/ new Type(null, 'ITrackRangeVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultTrackRangeVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultTrackRangeVisual, _super);
    function DefaultTrackRangeVisual() {
        var _this = _super.call(this) || this;
        _this._translateX = 0;
        _this._translateY = 0;
        _this.a = 0;
        _this.c = -1;
        _this.b = -1;
        _this._thumbBox = null;
        _this._thumbRidges = null;
        _this._allPaths = null;
        _this.thumbBox = new Path();
        _this.thumbRidges = new Path();
        _this.allPaths = new List$1(Path.$, 0);
        _this.allPaths.add(_this.thumbBox);
        _this.allPaths.add(_this.thumbRidges);
        _this.thumbBox._stroke = _this.getThumbBoxDefaultStroke();
        _this.thumbBox.ac = 1;
        _this.thumbBox._fill = _this.getThumbBoxDefaultBrush();
        _this.thumbRidges._stroke = _this.getThumbRidgesDefaultStroke();
        _this.thumbRidges.ac = 1;
        return _this;
    }
    DefaultTrackRangeVisual.prototype.getThumbBoxDefaultStroke = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    };
    DefaultTrackRangeVisual.prototype.getThumbBoxDefaultStrokeThickness = function () {
        return 1;
    };
    DefaultTrackRangeVisual.prototype.getThumbBoxDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 249, 249, 249);
            return $ret;
        })());
    };
    DefaultTrackRangeVisual.prototype.getThumbRidgesDefaultStroke = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 119, 119, 119);
            return $ret;
        })());
    };
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "translateX", {
        get: function () {
            return this._translateX;
        },
        set: function (a) {
            this._translateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "translateY", {
        get: function () {
            return this._translateY;
        },
        set: function (a) {
            this._translateY = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackRangeVisual.prototype.e = function () {
        if (this.orientation == 0) {
            var a = new PathGeometry();
            var b = new PathFigure();
            var c = new LineSegment(1);
            b._isClosed = false;
            b._isFilled = false;
            b._startPoint = { $type: Point_$type, x: -3, y: (this.height / -2) * 0.5 };
            c.c = { $type: Point_$type, x: -3, y: (this.height / 2) * 0.5 };
            b._segments.add(c);
            a.c.add(b);
            var d = new PathFigure();
            var e = new LineSegment(1);
            d._isClosed = false;
            d._isFilled = false;
            d._startPoint = { $type: Point_$type, x: 0, y: (this.height / -2) * 0.5 };
            e.c = { $type: Point_$type, x: 0, y: (this.height / 2) * 0.5 };
            d._segments.add(e);
            a.c.add(d);
            var f = new PathFigure();
            var g = new LineSegment(1);
            f._isClosed = false;
            f._isFilled = false;
            f._startPoint = { $type: Point_$type, x: 3, y: (this.height / -2) * 0.5 };
            g.c = { $type: Point_$type, x: 3, y: (this.height / 2) * 0.5 };
            f._segments.add(g);
            a.c.add(f);
            this.thumbRidges.ak = a;
        }
        else {
            var h = new PathGeometry();
            var i = new PathFigure();
            var j = new LineSegment(1);
            i._isClosed = false;
            i._isFilled = false;
            i._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: -3 };
            j.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: -3 };
            i._segments.add(j);
            h.c.add(i);
            var k = new PathFigure();
            var l = new LineSegment(1);
            k._isClosed = false;
            k._isFilled = false;
            k._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: 0 };
            l.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: 0 };
            k._segments.add(l);
            h.c.add(k);
            var m = new PathFigure();
            var n = new LineSegment(1);
            m._isClosed = false;
            m._isFilled = false;
            i._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: 3 };
            j.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: 3 };
            m._segments.add(n);
            h.c.add(m);
            this.thumbRidges.ak = h;
        }
    };
    DefaultTrackRangeVisual.prototype.d = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.thumbBox.ak = a;
    };
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "orientation", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "width", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackRangeVisual.prototype.f = function () {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    };
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "height", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "thumbBox", {
        get: function () {
            return this._thumbBox;
        },
        set: function (a) {
            this._thumbBox = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "thumbRidges", {
        get: function () {
            return this._thumbRidges;
        },
        set: function (a) {
            this._thumbRidges = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackRangeVisual.prototype, "allPaths", {
        get: function () {
            return this._allPaths;
        },
        set: function (a) {
            this._allPaths = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackRangeVisual.$t = markType(DefaultTrackRangeVisual, 'DefaultTrackRangeVisual', Base.$, [ITrackRangeVisual_$type]);
    return DefaultTrackRangeVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackBarVisual_$type = /*@__PURE__*/ new Type(null, 'ITrackBarVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultTrackBarVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultTrackBarVisual, _super);
    function DefaultTrackBarVisual() {
        var _this = _super.call(this) || this;
        _this._translateX = 0;
        _this._translateY = 0;
        _this.b = -1;
        _this.a = -1;
        _this._barBox = null;
        _this._allPaths = null;
        _this.barBox = new Path();
        _this.allPaths = new List$1(Path.$, 0);
        _this.allPaths.add(_this.barBox);
        _this.barBox._fill = _this.getBarBoxDefaultBrush();
        return _this;
    }
    Object.defineProperty(DefaultTrackBarVisual.prototype, "translateX", {
        get: function () {
            return this._translateX;
        },
        set: function (a) {
            this._translateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackBarVisual.prototype, "translateY", {
        get: function () {
            return this._translateY;
        },
        set: function (a) {
            this._translateY = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackBarVisual.prototype.getBarBoxDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 218, 218, 218);
            return $ret;
        })());
    };
    DefaultTrackBarVisual.prototype.getBarBoxDefaultOutline = function () {
        return null;
    };
    DefaultTrackBarVisual.prototype.getBarBoxDefaultStrokeThickness = function () {
        return 0;
    };
    DefaultTrackBarVisual.prototype.c = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.barBox.ak = a;
    };
    Object.defineProperty(DefaultTrackBarVisual.prototype, "width", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (b != this.b) {
                this.d();
            }
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackBarVisual.prototype.d = function () {
        if (this.width > 0 && this.height > 0) {
            this.c();
        }
    };
    Object.defineProperty(DefaultTrackBarVisual.prototype, "height", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.d();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackBarVisual.prototype, "barBox", {
        get: function () {
            return this._barBox;
        },
        set: function (a) {
            this._barBox = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackBarVisual.prototype, "allPaths", {
        get: function () {
            return this._allPaths;
        },
        set: function (a) {
            this._allPaths = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackBarVisual.$t = markType(DefaultTrackBarVisual, 'DefaultTrackBarVisual', Base.$, [ITrackBarVisual_$type]);
    return DefaultTrackBarVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackShadeVisual_$type = /*@__PURE__*/ new Type(null, 'ITrackShadeVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultTrackShadeVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultTrackShadeVisual, _super);
    function DefaultTrackShadeVisual() {
        var _this = _super.call(this) || this;
        _this._translateX = 0;
        _this._translateY = 0;
        _this.a = 0;
        _this.c = -1;
        _this.b = -1;
        _this._shadeBox = null;
        _this._shadeOutline = null;
        _this._allPaths = null;
        _this.shadeBox = new Path();
        _this.shadeOutline = new Path();
        _this.allPaths = new List$1(Path.$, 0);
        _this.allPaths.add(_this.shadeBox);
        _this.allPaths.add(_this.shadeOutline);
        _this.shadeBox._fill = _this.getShadeBoxDefaultBrush();
        _this.shadeOutline._stroke = _this.getShadeOutlineDefaultBrush();
        _this.shadeOutline.ac = _this.getShadeOutlineDefaultStrokeThickness();
        return _this;
    }
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "translateX", {
        get: function () {
            return this._translateX;
        },
        set: function (a) {
            this._translateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "translateY", {
        get: function () {
            return this._translateY;
        },
        set: function (a) {
            this._translateY = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackShadeVisual.prototype.getShadeBoxDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(128, 255, 255, 255);
            return $ret;
        })());
    };
    DefaultTrackShadeVisual.prototype.getShadeOutlineDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    };
    DefaultTrackShadeVisual.prototype.getShadeOutlineDefaultStrokeThickness = function () {
        return 1;
    };
    DefaultTrackShadeVisual.prototype.d = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.shadeBox.ak = a;
    };
    DefaultTrackShadeVisual.prototype.e = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = false;
        b._isFilled = false;
        switch (this.orientation) {
            case 0:
                b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
                break;
            case 1:
                b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / 2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
                break;
            case 2:
                b._startPoint = { $type: Point_$type, x: this.width / 2, y: this.height / 2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                break;
            case 3:
                b._startPoint = { $type: Point_$type, x: this.width / 2, y: this.height / -2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
                break;
        }
        b._segments.add(c);
        a.c.add(b);
        this.shadeOutline.ak = a;
    };
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "orientation", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "width", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackShadeVisual.prototype.f = function () {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    };
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "height", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "shadeBox", {
        get: function () {
            return this._shadeBox;
        },
        set: function (a) {
            this._shadeBox = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "shadeOutline", {
        get: function () {
            return this._shadeOutline;
        },
        set: function (a) {
            this._shadeOutline = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackShadeVisual.prototype, "allPaths", {
        get: function () {
            return this._allPaths;
        },
        set: function (a) {
            this._allPaths = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackShadeVisual.$t = markType(DefaultTrackShadeVisual, 'DefaultTrackShadeVisual', Base.$, [ITrackShadeVisual_$type]);
    return DefaultTrackShadeVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackThumbCalloutVisual_$type = /*@__PURE__*/ new Type(null, 'ITrackThumbCalloutVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultTrackThumbCalloutVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultTrackThumbCalloutVisual, _super);
    function DefaultTrackThumbCalloutVisual() {
        var _this = _super.call(this) || this;
        _this._translateX = 0;
        _this._translateY = 0;
        _this._textTranslateX = 0;
        _this._textTranslateY = 0;
        _this.c = -1;
        _this.b = -1;
        _this.a = false;
        _this._calloutBox = null;
        _this._calloutText = null;
        _this._allPaths = null;
        _this.calloutBox = new Path();
        _this.calloutBox._visibility = 1;
        _this.calloutText = new TextBlock();
        _this.calloutText._visibility = 1;
        _this.allPaths = new List$1(Path.$, 0);
        _this.allPaths.add(_this.calloutBox);
        _this.height = 22;
        _this.width = 10;
        _this.calloutBox._stroke = _this.getCalloutBoxDefaultStroke();
        _this.calloutBox.ac = _this.getCalloutBoxDefaultStrokeThickness();
        _this.calloutBox._fill = _this.getCalloutBoxDefaultBrush();
        _this.calloutText.am = _this.getCalloutTextDefaultBrush();
        _this.calloutText.ak = "";
        return _this;
    }
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "translateX", {
        get: function () {
            return this._translateX;
        },
        set: function (a) {
            this._translateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "translateY", {
        get: function () {
            return this._translateY;
        },
        set: function (a) {
            this._translateY = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "textTranslateX", {
        get: function () {
            return this._textTranslateX;
        },
        set: function (a) {
            this._textTranslateX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "textTranslateY", {
        get: function () {
            return this._textTranslateY;
        },
        set: function (a) {
            this._textTranslateY = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultStroke = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    };
    DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultStrokeThickness = function () {
        return 1;
    };
    DefaultTrackThumbCalloutVisual.prototype.getCalloutBoxDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(200, 255, 255, 255);
            return $ret;
        })());
    };
    DefaultTrackThumbCalloutVisual.prototype.getCalloutTextDefaultBrush = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    };
    DefaultTrackThumbCalloutVisual.prototype.e = function () {
    };
    DefaultTrackThumbCalloutVisual.prototype.d = function () {
        var a = new PathGeometry();
        var b = new PathFigure();
        var c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: 0, y: 0 };
        c._points.add({ $type: Point_$type, x: this.width, y: 0 });
        c._points.add({ $type: Point_$type, x: this.width, y: this.height });
        c._points.add({ $type: Point_$type, x: 0, y: this.height });
        b._segments.add(c);
        a.c.add(b);
        this.calloutBox.ak = a;
    };
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "width", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbCalloutVisual.prototype.f = function () {
        if (this.width > 0 && this.height > 0) {
            this.e();
            this.d();
        }
    };
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "height", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            var b = this.b;
            this.b = a;
            if (this.b != b) {
                this.f();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "isVisible", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (this.a != b) {
                this.calloutBox._visibility = this.a ? 0 : 1;
                this.calloutText._visibility = this.a ? 0 : 1;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "calloutBox", {
        get: function () {
            return this._calloutBox;
        },
        set: function (a) {
            this._calloutBox = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "calloutText", {
        get: function () {
            return this._calloutText;
        },
        set: function (a) {
            this._calloutText = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultTrackThumbCalloutVisual.prototype, "allPaths", {
        get: function () {
            return this._allPaths;
        },
        set: function (a) {
            this._allPaths = a;
        },
        enumerable: true,
        configurable: true
    });
    DefaultTrackThumbCalloutVisual.$t = markType(DefaultTrackThumbCalloutVisual, 'DefaultTrackThumbCalloutVisual', Base.$, [ITrackThumbCalloutVisual_$type]);
    return DefaultTrackThumbCalloutVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITrackOwner_$type = /*@__PURE__*/ new Type(null, 'ITrackOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ThumbRangePosition = /*@__PURE__*/ (function (ThumbRangePosition) {
    ThumbRangePosition[ThumbRangePosition["PinnedLower"] = 0] = "PinnedLower";
    ThumbRangePosition[ThumbRangePosition["PinnedHigher"] = 1] = "PinnedHigher";
    return ThumbRangePosition;
})({});
/**
 * @hidden
 */
var ThumbRangePosition_$type = /*@__PURE__*/ markEnum('ThumbRangePosition', 'PinnedLower,0|PinnedHigher,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrackThumbRange = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrackThumbRange, _super);
    function TrackThumbRange() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = 0;
        _this.j = 0;
        _this.h = 0;
        _this.g = 1;
        _this.d = null;
        _this.c = null;
        _this.a = null;
        _this.propertyChanged = null;
        return _this;
    }
    TrackThumbRange.prototype.t = function (a, b, c) {
        this.u(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    TrackThumbRange.prototype.u = function (a, b, c) {
        this.s();
    };
    TrackThumbRange.prototype.s = function () {
        if (this.b == null) {
            return;
        }
        this.b.trackDirty();
    };
    Object.defineProperty(TrackThumbRange.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.t("Owner", b, this.a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumbRange.prototype, "n", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.t("Position", b, this.i);
            }
        },
        enumerable: true,
        configurable: true
    });
    TrackThumbRange.prototype.o = function (a) {
        if (a > 0 && this.n + (this.r / 2) + a > 1) {
            a = 1 - (this.n + (this.r / 2));
        }
        if (a < 0 && (this.n - (this.r / 2)) + a < 0) {
            a = (this.n - (this.r / 2)) * -1;
        }
        this.f.i += a;
        this.e.i += a;
        this.n += a;
        return a;
    };
    TrackThumbRange.prototype.p = function (a) {
        a = this.k(a);
        var b = this.n - this.r / 2;
        this.r += a;
        this.n = b + this.r / 2;
        return a;
    };
    TrackThumbRange.prototype.k = function (a) {
        if (a < 0) {
            var b = this.r + a;
            if (b < this.m) {
                b = this.m;
                a = (b - this.r);
            }
        }
        if (a > 0) {
            var c = this.r + a;
            if (c > this.l) {
                c = this.l;
                a = (c - this.r);
            }
        }
        return a;
    };
    TrackThumbRange.prototype.q = function (a) {
        a = -1 * this.k(a * -1);
        var b = this.n + this.r / 2;
        this.r -= a;
        this.n = b - this.r / 2;
        return a;
    };
    Object.defineProperty(TrackThumbRange.prototype, "r", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.t("Width", b, this.j);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumbRange.prototype, "m", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.t("MinWidth", b, this.h);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumbRange.prototype, "l", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.t("MaxWidth", b, this.g);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumbRange.prototype, "f", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.t("LowerThumb", b, this.d);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumbRange.prototype, "e", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.t("HigherThumb", b, this.c);
            }
        },
        enumerable: true,
        configurable: true
    });
    TrackThumbRange.$t = markType(TrackThumbRange, 'TrackThumbRange', Base.$, [INotifyPropertyChanged_$type]);
    return TrackThumbRange;
}(Base));
/**
 * @hidden
 */
var TrackThumb = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrackThumb, _super);
    function TrackThumb() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = 0;
        _this.h = 0;
        _this.c = 1;
        _this.e = null;
        _this.a = null;
        _this.propertyChanged = null;
        return _this;
    }
    Object.defineProperty(TrackThumb.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.m("Owner", b, this.a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TrackThumb.prototype.m = function (a, b, c) {
        this.n(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    TrackThumb.prototype.n = function (a, b, c) {
        this.l();
    };
    TrackThumb.prototype.j = function (a) {
        if (this.i + a > 1) {
            a = 1 - this.i;
        }
        if (this.i + a < 0) {
            a = -this.i;
        }
        if (this.f != null) {
            if (this.d == 0) {
                a = this.f.q(a);
            }
            else {
                a = this.f.p(a);
            }
        }
        this.i += a;
        return a;
    };
    TrackThumb.prototype.l = function () {
        if (this.b == null) {
            return;
        }
        this.b.trackDirty();
    };
    Object.defineProperty(TrackThumb.prototype, "i", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.m("Position", b, this.g);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumb.prototype, "k", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.m("Width", b, this.h);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumb.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.m("RangePosition", enumGetBox(ThumbRangePosition_$type, b), enumGetBox(ThumbRangePosition_$type, this.c));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TrackThumb.prototype, "f", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.m("Range", b, this.e);
            }
        },
        enumerable: true,
        configurable: true
    });
    TrackThumb.$t = markType(TrackThumb, 'TrackThumb', Base.$, [INotifyPropertyChanged_$type]);
    return TrackThumb;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ZoomSliderView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ZoomSliderView, _super);
    function ZoomSliderView(a) {
        var _this = _super.call(this) || this;
        _this.q = false;
        _this.i = null;
        _this.h = null;
        _this.c = null;
        _this.b = null;
        _this.e = null;
        _this.d = null;
        _this.g = null;
        _this.f = null;
        _this.j = null;
        _this.u = null;
        _this.v = null;
        _this.o = null;
        _this.t = 0;
        _this.r = false;
        _this.x = 0;
        _this.w = 0;
        _this.m = null;
        _this.a = null;
        _this.l = null;
        _this.y = -1;
        _this.s = 10;
        _this.k = 0;
        _this.z = -1;
        _this.p = true;
        _this.j = a;
        _this.i = new DefaultTrackThumbVisual();
        _this.h = new DefaultTrackThumbVisual();
        _this.c = new DefaultTrackRangeVisual();
        _this.b = new DefaultTrackBarVisual();
        _this.e = new DefaultTrackShadeVisual();
        _this.d = new DefaultTrackShadeVisual();
        _this.g = new DefaultTrackThumbCalloutVisual();
        _this.f = new DefaultTrackThumbCalloutVisual();
        _this.m = _this.n();
        _this.an();
        return _this;
    }
    ZoomSliderView.prototype.ar = function () {
        this.p = true;
        this.an();
        if (this.a != null) {
            this.a.ap(this.u.rootWrapper, "");
        }
        if (this.z == -1) {
            this.z = this.u.setTimeout(runOn(this, this.al), 200);
        }
    };
    ZoomSliderView.prototype.as = function () {
        this.p = false;
        if (this.a != null) {
            this.a.bb(this.u.rootWrapper, "");
        }
        if (this.z != -1) {
            window.clearTimeout(this.z);
            this.z = -1;
        }
    };
    ZoomSliderView.prototype.ao = function () {
        if (!this.q) {
            if (this.u != null) {
                this.q = true;
                this.u.setTimeout(runOn(this, this.a2), 0);
            }
        }
    };
    ZoomSliderView.prototype.aj = function () {
        this.a2();
    };
    ZoomSliderView.prototype.a2 = function () {
        if (!this.q) {
            return;
        }
        this.q = false;
        this.j.d6();
        this.aw();
    };
    ZoomSliderView.prototype.aw = function () {
        if (this.o == null) {
            return;
        }
        var a = this.j.fj.width;
        var b = this.j.fj.height;
        var c = Math.round(a * this.t);
        var d = Math.round(b * this.t);
        if (this.x != c || this.w != d) {
            this.v.setAttribute("width", c.toString());
            this.v.setAttribute("height", d.toString());
            this.v.setStyleProperty("width", a.toString() + "px");
            this.v.setStyleProperty("height", b.toString() + "px");
            this.x = truncate(Math.round(c));
            this.w = truncate(Math.round(d));
        }
        if (this.o.d && this.t != 1) {
            this.o.z();
            this.o.aa(this.t, this.t);
        }
        this.o.k(this.j.fj.left, this.j.fj.top, this.j.fj.width, this.j.fj.height);
        this.a0(this.i.allPaths, this.i.translateX, this.i.translateY);
        this.a0(this.h.allPaths, this.h.translateX, this.h.translateY);
        this.a0(this.c.allPaths, this.c.translateX, this.c.translateY);
        this.a0(this.b.allPaths, this.b.translateX, this.b.translateY);
        this.a0(this.e.allPaths, this.e.translateX, this.e.translateY);
        this.a0(this.d.allPaths, this.d.translateX, this.d.translateY);
        this.a0(this.g.allPaths, this.g.translateX, this.g.translateY);
        this.a0(this.f.allPaths, this.f.translateX, this.f.translateY);
        this.a1(this.g.calloutText, this.g.textTranslateX, this.g.textTranslateY);
        this.a1(this.f.calloutText, this.f.textTranslateX, this.f.textTranslateY);
        this.ax(this.b.allPaths);
        this.ax(this.c.allPaths);
        this.ax(this.e.allPaths);
        this.ax(this.d.allPaths);
        this.ax(this.i.allPaths);
        this.ax(this.h.allPaths);
        this.ax(this.g.allPaths);
        this.ax(this.f.allPaths);
        this.ay(this.g.calloutText);
        this.ay(this.f.calloutText);
        if (this.o.d && this.t != 1) {
            this.o.y();
        }
    };
    ZoomSliderView.prototype.ay = function (a) {
        if (a.j != null) {
            this.o.z();
        }
        this.o.j(a.j);
        this.o.w(a);
        if (a.j != null) {
            this.o.y();
        }
    };
    ZoomSliderView.prototype.ax = function (a) {
        for (var b = 0; b < a.count; b++) {
            var c = a.item(b);
            if (c.j != null) {
                this.o.z();
            }
            this.o.j(c.j);
            this.o.s(c);
            if (c.j != null) {
                this.o.y();
            }
        }
    };
    ZoomSliderView.prototype.a1 = function (a, b, c) {
        if (a.j == null) {
            a.j = new TranslateTransform();
        }
        var d = a.j;
        d.j = b;
        d.k = c;
    };
    ZoomSliderView.prototype.a0 = function (a, b, c) {
        for (var d = 0; d < a.count; d++) {
            var e = a.item(d);
            if (e.j == null) {
                e.j = new TranslateTransform();
            }
            var f = e.j;
            f.j = b;
            f.k = c;
        }
    };
    ZoomSliderView.prototype.an = function () {
        var a = this.j.bi;
        var b = this.j.a4;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.j.a4 = window.devicePixelRatio;
        }
    };
    ZoomSliderView.prototype.au = function (a) {
        var _this = this;
        if (a == null) {
            var b = this.u;
            this.v = null;
            this.u = null;
            this.o = null;
            this.ab();
            if (this.z != -1) {
                if (b != null) {
                    b.clearTimeout(this.z);
                }
                else {
                    window.clearTimeout(this.z);
                }
                this.z = -1;
            }
            return;
        }
        this.t = (isNaN_(this.j.bi) ? this.j.a4 : this.j.bi);
        var c = a;
        this.u = c;
        this.j.l.u(this.u);
        this.u.rootWrapper.addClass("ui-zoomslider-container");
        var d = this.t;
        var e = Math.round(c.rootWrapper.width());
        var f = Math.round(c.rootWrapper.height());
        var g = e * d;
        var h = f * d;
        this.u.rootWrapper.setStyleProperty("position", "relative");
        var i = this.u.createElement("canvas");
        i.setStyleProperty("position", "absolute");
        this.u.append(i);
        this.x = truncate(Math.round(g));
        this.w = truncate(Math.round(h));
        i.setAttribute("width", g.toString());
        i.setAttribute("height", h.toString());
        i.setStyleProperty("width", e.toString() + "px");
        i.setStyleProperty("height", f.toString() + "px");
        this.v = i;
        var j = this.u.get2DCanvasContext(this.v);
        this.o = new RenderingContext(new CanvasViewRenderer(), j);
        this.o.ac(this.m);
        this.ab();
        this.a = new CanvasGestureDOMEventProxy(this.u.rootWrapper, this.u, false);
        this.a.bf = this.j.fj;
        var k = this.a;
        k.onContactStarted = delegateCombine(k.onContactStarted, runOn(this, this.ai));
        var l = this.a;
        l.onContactMoved = delegateCombine(l.onContactMoved, runOn(this, this.ah));
        var m = this.a;
        m.onContactCompleted = delegateCombine(m.onContactCompleted, runOn(this, this.ag));
        this.a.ak = function (n) { return _this.j.fh.containsPoint(n); };
        this.j.de(0, 0, e, f);
        this.s = FontUtil.getCurrentFontHeight(this.u, this.m);
        this.j.trackDirty();
        this.z = this.u.setTimeout(runOn(this, this.al), 200);
    };
    ZoomSliderView.prototype.ag = function (a, b) {
        this.j.c8(a, b);
    };
    ZoomSliderView.prototype.ah = function (a, b) {
        this.j.c9(a);
    };
    ZoomSliderView.prototype.ai = function (a, b) {
        this.j.ae(a, b);
    };
    ZoomSliderView.prototype.ab = function () {
        if (this.a != null) {
            var a = this.a;
            a.onContactStarted = delegateRemove(a.onContactStarted, runOn(this, this.ai));
            var b = this.a;
            b.onContactMoved = delegateRemove(b.onContactMoved, runOn(this, this.ah));
            var c = this.a;
            c.onContactCompleted = delegateRemove(c.onContactCompleted, runOn(this, this.ag));
            this.a.ak = null;
            this.a.aq();
        }
    };
    ZoomSliderView.prototype.av = function () {
    };
    ZoomSliderView.prototype.ap = function () {
        this.aq(true);
    };
    ZoomSliderView.prototype.aq = function (a) {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.an();
        var b = Math.round(this.u.rootWrapper.width());
        var c = Math.round(this.u.rootWrapper.height());
        var d = b != this.j.fj.width || c != this.j.fj.height;
        if (a || d) {
            this.j.de(0, 0, b, c);
            if (this.a != null) {
                this.a.bf = this.j.fj;
            }
        }
    };
    ZoomSliderView.prototype.ak = function () {
    };
    ZoomSliderView.prototype.n = function () {
        return ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 10;
            return $ret;
        })());
    };
    ZoomSliderView.prototype.a3 = function (a, b, c) {
        if (a.ak != b) {
            a.ak = b;
        }
        if (this.l != c) {
            this.l = c;
            this.m = this.l;
            this.s = FontUtil.getCurrentFontHeight(this.u, this.m);
            this.o.ac(this.l);
            this.j.trackDirty();
        }
    };
    ZoomSliderView.prototype.ad = function () {
        if (this.k != 3) {
            this.k = 3;
            this.u.rootWrapper.setStyleProperty("cursor", "move");
        }
    };
    ZoomSliderView.prototype.af = function () {
        if (this.k != 2) {
            this.k = 2;
            this.u.rootWrapper.setStyleProperty("cursor", "ns-resize");
        }
    };
    ZoomSliderView.prototype.ac = function () {
        if (this.k != 0) {
            this.k = 0;
            this.u.rootWrapper.setStyleProperty("cursor", "inherit");
        }
    };
    ZoomSliderView.prototype.ae = function () {
        if (this.k != 1) {
            this.k = 1;
            this.u.rootWrapper.setStyleProperty("cursor", "ew-resize");
        }
    };
    ZoomSliderView.prototype.a4 = function (a) {
        var b = this.s;
        var c = this.o.f(a.ak);
        return new Size(1, c, b);
    };
    ZoomSliderView.prototype.at = function () {
        this.t = this.j.a4;
        this.ao();
    };
    ZoomSliderView.prototype.az = function () {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.u.rootWrapper.show();
    };
    ZoomSliderView.prototype.am = function () {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.u.rootWrapper.hide();
    };
    ZoomSliderView.prototype.al = function () {
        this.z = -1;
        if (this.u == null) {
            return;
        }
        if (!this.p) {
            return;
        }
        this.aq(false);
        this.z = this.u.setTimeout(runOn(this, this.al), 200);
    };
    ZoomSliderView.$t = markType(ZoomSliderView, 'ZoomSliderView');
    return ZoomSliderView;
}(Base));
/**
 * @hidden
 */
var ZoomSlider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ZoomSlider, _super);
    function ZoomSlider() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.c = null;
        _this.g = null;
        _this.propertyChanged = null;
        _this.bk = 500;
        _this.ax = 1;
        _this.az = NaN;
        _this.ag = 1;
        _this.resolvingAxisValue = null;
        _this.fg = new Rect(0, 0, 0, 1, 1);
        _this.w = false;
        _this.af = false;
        _this.windowRectChanged = null;
        _this.i = 0;
        _this.h = 0;
        _this.ff = null;
        _this.fe = null;
        _this.fk = new Thickness(1, 5, 5, 5, 5);
        _this.fj = null;
        _this.fh = null;
        _this.fi = null;
        _this.ay = 1E-05;
        _this.a1 = 0;
        _this.al = 0;
        _this.a3 = 5;
        _this.a2 = 5;
        _this.ah = 16;
        _this.d = 0;
        _this.en = null;
        _this.av = 1;
        _this.ap = 1;
        _this.ef = null;
        _this.eo = null;
        _this.eg = null;
        _this.ep = null;
        _this.eh = null;
        _this.aw = 10;
        _this.aq = 10;
        _this.au = 22;
        _this.ao = 22;
        _this.el = null;
        _this.em = null;
        _this.at = 1;
        _this.ed = null;
        _this.ee = null;
        _this.an = 1;
        _this.d8 = null;
        _this.d9 = null;
        _this.ai = 0;
        _this.eq = null;
        _this.er = null;
        _this.a0 = 1;
        _this.es = null;
        _this.ei = null;
        _this.ek = null;
        _this.ej = null;
        _this.as = 1;
        _this.ea = null;
        _this.ec = null;
        _this.eb = null;
        _this.am = 1;
        _this.q = false;
        _this.m = null;
        _this.o = null;
        _this.k = null;
        _this.ak = 0;
        _this.aj = 0;
        _this.ar = 0;
        _this.p = false;
        _this.h = 6;
        _this.fj = Rect.empty;
        _this.fh = Rect.empty;
        _this.fi = Rect.empty;
        _this.g = new ZoomSliderView(_this);
        _this.m = _this.g.n();
        _this.b = new TrackThumb();
        _this.b.d = 0;
        _this.a = new TrackThumb();
        _this.a.d = 1;
        _this.c = new TrackThumbRange();
        _this.c.f = _this.b;
        _this.c.e = _this.a;
        _this.b.i = 0;
        _this.a.i = 1;
        _this.c.r = 1;
        _this.c.n = 0.5;
        _this.c.m = 0;
        _this.c.l = 1;
        _this.b.f = _this.c;
        _this.a.f = _this.c;
        _this.c.f = _this.b;
        _this.c.e = _this.a;
        _this.b.b = _this;
        _this.a.b = _this;
        _this.c.b = _this;
        _this.k = new DoubleAnimator(0, 1, _this.bl);
        var a = _this.k;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(_this, _this.cx));
        _this.k.b = EasingFunctions.exponentialEase;
        return _this;
    }
    ZoomSlider.prototype.onDetachedFromUI = function () {
        this.g.as();
    };
    ZoomSlider.prototype.onAttachedToUI = function () {
        this.g.ar();
    };
    Object.defineProperty(ZoomSlider.prototype, "bl", {
        get: function () {
            return this.bk;
        },
        set: function (a) {
            var b = this.bk;
            this.bk = a;
            if (b != this.bk) {
                this.dc("PanTransitionDuration", b, this.bk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bg", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.dc("MaxZoomWidth", b, this.ax);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bi", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.dc("PixelScalingRatio", b, this.az);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a4", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.dc("ActualPixelScalingRatio", b, this.ag);
            }
        },
        enumerable: true,
        configurable: true
    });
    ZoomSlider.prototype.de = function (a, b, c, d) {
        this.fj = new Rect(0, a, b, c, d);
        if (this.e == 0) {
            var e = Math.max(0, this.fj.width - (this.startInset + this.endInset));
            this.fh = new Rect(0, this.fj.left + this.startInset, this.fj.top, e, this.fj.height);
            var f = Math.max(0, this.fh.width - (this.trackStartInset + this.trackEndInset));
            this.fi = new Rect(0, this.fh.left + this.trackStartInset, this.fh.top, f, Math.max(0, this.fh.height - this.barExtent));
        }
        else {
            this.fh = new Rect(0, this.fj.left, this.fj.top + this.startInset, this.fj.width, this.fj.height - (this.startInset + this.endInset));
            this.fi = new Rect(0, this.fh.left, this.fh.top + this.trackStartInset, this.fh.width - this.barExtent, this.fh.height - (this.trackStartInset + this.trackEndInset));
        }
        this.trackDirty();
    };
    ZoomSlider.prototype.d6 = function () {
        if (!this.p) {
            return;
        }
        this.p = false;
        var a = this.g.i;
        var b = this.g.h;
        var c = this.g.c;
        var d = this.g.b;
        var e = this.g.e;
        var f = this.g.d;
        if (this.ab) {
            var g = this.bn();
            var h = this.bm();
            this.ds(g, this.b);
            this.dr(h, this.b.i);
            this.ds(h, this.a);
            this.dr(h, this.a.i);
        }
        else {
            this.d5(a, this.b);
            this.d5(b, this.a);
        }
        if (this.z) {
        }
        else {
            this.d3(c, this.c);
        }
        if (this.y) {
        }
        else {
            this.dp(d);
        }
        if (this.aa) {
        }
        else {
            this.dz(e);
            this.du(f);
        }
        this.d7();
    };
    Object.defineProperty(ZoomSlider.prototype, "windowRect", {
        get: function () {
            return this.fg;
        },
        set: function (a) {
            var b = this.fg;
            this.fg = a;
            if (Rect.l_op_Inequality(b, this.fg)) {
                this.dc("WindowRect", b, this.fg);
            }
        },
        enumerable: true,
        configurable: true
    });
    ZoomSlider.prototype.d7 = function () {
        var a = this.windowRect.width;
        var b = this.windowRect.height;
        var c = this.windowRect.left;
        var d = this.windowRect.top;
        var e = c;
        var f = d;
        var g = a;
        var h = b;
        if (this.e == 0) {
            e = this.b.i;
            g = this.c.r;
        }
        else {
            f = this.b.i;
            h = this.c.r;
        }
        if (e != c || f != d || g != a || h != b) {
            this.w = true;
            var i = this.windowRect;
            this.windowRect = new Rect(0, e, f, g, h);
            this.dg(i, this.windowRect);
            this.w = false;
        }
    };
    ZoomSlider.prototype.dg = function (a, b) {
        if (this.af) {
            return;
        }
        if (this.windowRectChanged != null) {
            this.windowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    };
    ZoomSlider.prototype.c8 = function (a, b) {
        if (this.h != 6) {
            this.g.av();
        }
        this.i = this.j(a, b);
        this.h = 6;
        this.c0();
        this.c1();
    };
    ZoomSlider.prototype.c1 = function () {
        this.g.g.isVisible = false;
        this.g.ao();
    };
    ZoomSlider.prototype.c0 = function () {
        this.g.f.isVisible = false;
        this.g.ao();
    };
    ZoomSlider.prototype.da = function (a, b) {
        this.i = this.j(a, false);
    };
    ZoomSlider.prototype.ae = function (a, b) {
        this.i = this.j(a, b);
        if (this.i == 6) {
            return false;
        }
        this.cy();
        if (this.ac(this.i)) {
            this.dm(a, this.i);
            this.g.ak();
            return true;
        }
        if (this.x(this.i)) {
            return this.ad(a, this.i);
        }
        return false;
    };
    ZoomSlider.prototype.ad = function (a, b) {
        switch (b) {
            case 5:
            case 2:
            case 3:
                this.di(a);
                return true;
        }
        return false;
    };
    ZoomSlider.prototype.di = function (a) {
        var b;
        if (this.e == 0) {
            b = (a.x - this.fi.left) / this.fi.width;
        }
        else {
            b = (a.y - this.fi.top) / this.fi.height;
        }
        if (b < 0 || b > 1) {
            return;
        }
        if (b + (this.c.r / 2) > 1) {
            b = 1 - (this.c.r / 2);
        }
        if (b - (this.c.r / 2) < 0) {
            b = (this.c.r / 2);
        }
        if (this.bl > 0) {
            this.dn(b);
        }
        else {
            this.c.n = b;
        }
    };
    ZoomSlider.prototype.dm = function (a, b) {
        this.h = b;
        this.ff = a;
        this.fe = a;
    };
    ZoomSlider.prototype.ac = function (a) {
        switch (a) {
            case 0:
            case 1:
            case 4: return true;
        }
        return false;
    };
    ZoomSlider.prototype.x = function (a) {
        switch (a) {
            case 5:
            case 2:
            case 3: return true;
        }
        return false;
    };
    ZoomSlider.prototype.c9 = function (a) {
        this.i = this.j(a, false);
        if (this.h != 6) {
            if (this.e == 0) {
                this.c4(a);
            }
            else {
                this.dd(a);
            }
        }
        else {
            this.c2();
        }
    };
    ZoomSlider.prototype.c2 = function () {
        if (this.i == 4) {
            this.g.ad();
        }
        else if (this.i == 0 || this.i == 1) {
            if (this.e == 1) {
                this.g.af();
            }
            else {
                this.g.ae();
            }
        }
        else {
            this.g.ac();
        }
    };
    ZoomSlider.prototype.dd = function (a) {
        var b = a.y - this.fe.y;
        b = b / this.fi.height;
        this.fe = a;
        switch (this.h) {
            case 0:
                this.b.j(b);
                this.d1(this.b);
                this.c3();
                break;
            case 1:
                this.a.j(b);
                this.dw(this.a);
                this.c3();
                break;
            case 4:
                this.c.o(b);
                this.d1(this.b);
                this.dw(this.a);
                this.c3();
                break;
        }
    };
    ZoomSlider.prototype.dw = function (a) {
        var b;
        var c;
        if (this.e == 0) {
            b = a.i;
            c = a.i * this.fi.width + this.fi.left;
            if (this.q) {
                var d_1 = b;
                if (this.resolvingAxisValue != null) {
                    var e = ((function () {
                        var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = d_1;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, e);
                    d_1 = e.value;
                }
                this.dk(c, this.fi.top, d_1);
            }
        }
        else {
            b = a.i;
            c = a.i * this.fi.height + this.fi.top;
            if (this.q) {
                var f_1 = b;
                if (this.resolvingAxisValue != null) {
                    var g = ((function () {
                        var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = f_1;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, g);
                    f_1 = g.value;
                }
                this.dk(c, this.fi.top, f_1);
            }
        }
    };
    ZoomSlider.prototype.dk = function (a, b, c) {
        var d = this.g.f;
        d.isVisible = true;
        var e = "";
        if (c != null) {
            e = c.toString();
        }
        this.g.a3(d.calloutText, e, this.n());
        var f = this.g.a4(d.calloutText);
        var g = this.fl();
        f = new Size(1, f.width + g.left + g.right, f.height + g.top + g.bottom);
        var h = this.a.i * this.fi.width + this.fi.left;
        var i = this.b.i * this.fi.width + this.fi.left;
        var j = 0;
        var k = 0;
        if ((this.fj.right - h) <= f.width) {
            j = h - f.width;
        }
        else {
            j = h;
        }
        if (j < i) {
            k = this.fi.top;
        }
        else {
            k = this.fi.bottom - f.height;
        }
        d.width = f.width;
        d.height = f.height;
        d.translateX = j;
        d.translateY = k;
        d.textTranslateX = j + g.left;
        d.textTranslateY = k + g.top;
    };
    ZoomSlider.prototype.d1 = function (a) {
        var b;
        var c;
        if (this.e == 0) {
            b = a.i;
            c = a.i * this.fi.width + this.fi.left;
            if (this.q) {
                var d_2 = b;
                if (this.resolvingAxisValue != null) {
                    var e = ((function () {
                        var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = d_2;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, e);
                    d_2 = e.value;
                }
                this.dl(c, this.fi.top, d_2);
            }
        }
        else {
            b = a.i;
            c = a.i * this.fi.height + this.fi.top;
            if (this.q) {
                var f_2 = b;
                if (this.resolvingAxisValue != null) {
                    var g = ((function () {
                        var $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = f_2;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, g);
                    f_2 = g.value;
                }
                this.dl(c, this.fi.top, f_2);
            }
        }
    };
    ZoomSlider.prototype.fl = function () {
        return this.fk;
    };
    ZoomSlider.prototype.dl = function (a, b, c) {
        var d = this.g.g;
        d.isVisible = true;
        var e = "";
        if (c != null) {
            e = c.toString();
        }
        this.g.a3(d.calloutText, e, this.n());
        var f = this.g.a4(d.calloutText);
        var g = this.fl();
        f = new Size(1, f.width + g.left + g.right, f.height + g.top + g.bottom);
        var h = this.b.i * this.fi.width + this.fi.left;
        var i = this.a.i * this.fi.width + this.fi.left;
        var j = 0;
        var k = 0;
        if (h >= f.width) {
            j = h - f.width;
        }
        else {
            j = h;
        }
        if (j > i) {
            k = this.fi.top;
        }
        else {
            k = this.fi.bottom - f.height;
        }
        d.width = f.width;
        d.height = f.height;
        d.translateX = j;
        d.translateY = k;
        d.textTranslateX = j + g.left;
        d.textTranslateY = k + g.top;
    };
    ZoomSlider.prototype.n = function () {
        if (this.o != null) {
            return this.o;
        }
        return this.m;
    };
    ZoomSlider.prototype.c4 = function (a) {
        var b = a.x - this.fe.x;
        this.fe = a;
        b = b / this.fi.width;
        switch (this.h) {
            case 0:
                this.b.j(b);
                this.d1(this.b);
                this.c3();
                break;
            case 1:
                this.a.j(b);
                this.dw(this.a);
                this.c3();
                break;
            case 4:
                this.c.o(b);
                this.d1(this.b);
                this.dw(this.a);
                this.c3();
                break;
        }
    };
    ZoomSlider.prototype.c6 = function (a) {
        this.i = this.j(a, false);
    };
    ZoomSlider.prototype.c7 = function (a) {
        this.i = this.j(a, false);
    };
    ZoomSlider.prototype.j = function (a, b) {
        if (this.v(a, this.b, this.g.i, b)) {
            return 0;
        }
        if (this.v(a, this.a, this.g.h, b)) {
            return 1;
        }
        if (this.u(a, this.c, this.g.c)) {
            return 4;
        }
        if (this.t(a, this.b)) {
            return 2;
        }
        if (this.s(a, this.a)) {
            return 3;
        }
        if (this.r(a)) {
            return 5;
        }
        return 6;
    };
    ZoomSlider.prototype.r = function (a) {
        if (this.e == 0) {
            if (a.y > this.fi.bottom && a.x >= this.fi.left && a.x <= this.fi.right && a.y <= this.fh.bottom) {
                return true;
            }
        }
        else {
            if (a.x > this.fi.right && a.y >= this.fi.top && a.y <= this.fi.bottom && a.x <= this.fh.right) {
                return true;
            }
        }
        return false;
    };
    ZoomSlider.prototype.u = function (a, b, c) {
        if (this.e == 0) {
            var d = (b.n) * this.fi.width + this.fi.left;
            var e = d - c.width / 2;
            var f = d + c.width / 2;
            if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= e && a.x <= f) {
                return true;
            }
        }
        else {
            var g = (b.n) * this.fi.height + this.fi.top;
            var h = g - c.height / 2;
            var i = g + c.height / 2;
            if (a.x >= this.fh.left && a.x <= this.fh.right && a.y >= h && a.y <= i) {
                return true;
            }
        }
        return false;
    };
    ZoomSlider.prototype.t = function (a, b) {
        if (this.e == 0) {
            var c = b.i * this.fi.width + this.fi.left;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x <= c && a.y <= this.fi.bottom) {
                return true;
            }
        }
        else {
            var d = b.i * this.fi.height + this.fi.top;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.y <= d && a.x <= this.fi.right) {
                return true;
            }
        }
        return false;
    };
    ZoomSlider.prototype.s = function (a, b) {
        if (this.e == 0) {
            var c = b.i * this.fi.width + this.fi.left;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x >= c && a.y <= this.fi.bottom) {
                return true;
            }
        }
        else {
            var d = b.i * this.fi.height + this.fi.top;
            if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= this.fh.left && a.x <= this.fh.right && a.y >= d && a.x <= this.fi.right) {
                return true;
            }
        }
        return false;
    };
    ZoomSlider.prototype.v = function (a, b, c, d) {
        var e = 40;
        if (this.e == 0) {
            var f = b.i * this.fi.width + this.fi.left;
            var g = this.fi.top + this.fi.height / 2;
            var h = new Rect(0, f - c.width / 2, g - c.height / 2, c.width, c.height);
            if (d) {
                if (h.width < e) {
                    h.inflate((e - h.width) / 2, 0);
                }
                if (h.height < e) {
                    h.inflate(0, (e - h.height) / 2);
                }
            }
            if (h.containsPoint(a)) {
                return true;
            }
        }
        else {
            var i = b.i * this.fi.height + this.fi.top;
            var j = this.fi.left + this.fi.width / 2;
            var k = new Rect(0, j - c.width / 2, i - c.height / 2, c.width, c.height);
            if (d) {
                if (k.width < e) {
                    k.inflate((e - k.width) / 2, 0);
                }
                if (k.height < e) {
                    k.inflate(0, (e - k.height) / 2);
                }
            }
            if (k.containsPoint(a)) {
                return true;
            }
        }
        return false;
    };
    ZoomSlider.prototype.d3 = function (a, b) {
        if (this.e == 0) {
            a.orientation = this.e;
            a.width = Math.max(15, this.fi.width * b.r);
            a.height = this.barExtent;
            a.translateX = (this.fi.left + this.fi.width * b.n);
            a.translateY = this.fi.bottom + this.barExtent / 2;
        }
        else {
            a.orientation = this.e;
            a.height = Math.max(15, this.fi.height * b.r);
            a.width = this.barExtent;
            a.translateY = (this.fi.top + this.fi.height * b.n);
            a.translateX = this.fi.right + this.barExtent / 2;
        }
    };
    ZoomSlider.prototype.du = function (a) {
        var b = this.a.i;
        if (this.e == 0) {
            var c = this.fi.left + b * this.fi.width;
            a.height = this.fi.height;
            a.translateX = c + (this.fh.right - c) / 2;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.width = (this.fh.right - c);
            a.orientation = 1;
        }
        else {
            var d = this.fi.top + b * this.fi.height;
            a.width = this.fi.width;
            a.translateY = d + (this.fh.bottom - d) / 2;
            a.translateX = this.fh.left + this.fi.width / 2;
            a.height = (this.fh.bottom - d);
            a.orientation = 3;
        }
    };
    ZoomSlider.prototype.dz = function (a) {
        var b = this.b.i;
        if (this.e == 0) {
            var c = this.fi.left + b * this.fi.width;
            a.height = this.fi.height;
            a.translateX = c - (c - this.fh.left) / 2;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.width = c - this.fh.left;
            a.orientation = 0;
        }
        else {
            var d = this.fi.top + b * this.fi.height;
            a.width = this.fi.width;
            a.translateY = d - (d - this.fh.top) / 2;
            a.translateX = this.fh.left + this.fi.width / 2;
            a.height = d - this.fh.top;
            a.orientation = 2;
        }
    };
    ZoomSlider.prototype.dp = function (a) {
        if (this.e == 0) {
            a.height = this.barExtent;
            a.width = this.fi.width;
            a.translateX = this.fi.left + this.fi.width / 2;
            a.translateY = this.fh.bottom - this.barExtent / 2;
        }
        else {
            a.width = this.barExtent;
            a.height = this.fi.height;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.translateX = this.fh.right - this.barExtent / 2;
        }
    };
    ZoomSlider.prototype.d5 = function (a, b) {
        if (this.e == 0) {
            a.orientation = this.e;
            a.translateX = this.fi.left + this.fi.width * b.i;
            a.translateY = this.fi.top + this.fi.height / 2;
        }
        else {
            a.orientation = this.e;
            a.translateY = this.fi.top + this.fi.height * b.i;
            a.translateX = this.fi.left + this.fi.width / 2;
        }
    };
    ZoomSlider.prototype.ds = function (a, b) {
    };
    ZoomSlider.prototype.dr = function (a, b) {
    };
    ZoomSlider.prototype.bm = function () {
        throw new NotImplementedException(0);
    };
    ZoomSlider.prototype.bn = function () {
        throw new NotImplementedException(0);
    };
    Object.defineProperty(ZoomSlider.prototype, "bh", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.dc("MinZoomWidth", b, this.ay);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "startInset", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.dc("StartInset", b, this.a1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "endInset", {
        get: function () {
            return this.al;
        },
        set: function (a) {
            var b = this.al;
            this.al = a;
            if (b != this.al) {
                this.dc("EndInset", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "trackStartInset", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.dc("TrackStartInset", b, this.a3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "trackEndInset", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.dc("TrackEndInset", b, this.a2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "barExtent", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.dc("BarExtent", b, this.ah);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.dc("Orientation", enumGetBox(ZoomSliderOrientation_$type, b), enumGetBox(ZoomSliderOrientation_$type, this.d));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e8", {
        get: function () {
            return this.en;
        },
        set: function (a) {
            var b = this.en;
            this.en = a;
            if (b != this.en) {
                this.dc("LowerThumbBrush", b, this.en);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "be", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.av;
            this.av = a;
            if (b != this.av) {
                this.dc("LowerThumbStrokeThickness", b, this.av);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a9", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.dc("HigherThumbStrokeThickness", b, this.ap);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e0", {
        get: function () {
            return this.ef;
        },
        set: function (a) {
            var b = this.ef;
            this.ef = a;
            if (b != this.ef) {
                this.dc("HigherThumbBrush", b, this.ef);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e9", {
        get: function () {
            return this.eo;
        },
        set: function (a) {
            var b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.dc("LowerThumbOutline", b, this.eo);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e1", {
        get: function () {
            return this.eg;
        },
        set: function (a) {
            var b = this.eg;
            this.eg = a;
            if (b != this.eg) {
                this.dc("HigherThumbOutline", b, this.eg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "fa", {
        get: function () {
            return this.ep;
        },
        set: function (a) {
            var b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.dc("LowerThumbRidgesBrush", b, this.ep);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e2", {
        get: function () {
            return this.eh;
        },
        set: function (a) {
            var b = this.eh;
            this.eh = a;
            if (b != this.eh) {
                this.dc("HigherThumbRidgesBrush", b, this.eh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bf", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.dc("LowerThumbWidth", b, this.aw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ba", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.dc("HigherThumbWidth", b, this.aq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bd", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.au;
            this.au = a;
            if (b != this.au) {
                this.dc("LowerThumbHeight", b, this.au);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a8", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.dc("HigherThumbHeight", b, this.ao);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e6", {
        get: function () {
            return this.el;
        },
        set: function (a) {
            var b = this.el;
            this.el = a;
            if (b != this.el) {
                this.dc("LowerShadeBrush", b, this.el);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e7", {
        get: function () {
            return this.em;
        },
        set: function (a) {
            var b = this.em;
            this.em = a;
            if (b != this.em) {
                this.dc("LowerShadeOutline", b, this.em);
            }
        },
        enumerable: true,
        configurable: true
    });
    ZoomSlider.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Object.defineProperty(ZoomSlider.prototype, "bc", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.dc("LowerShadeStrokeThickness", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ey", {
        get: function () {
            return this.ed;
        },
        set: function (a) {
            var b = this.ed;
            this.ed = a;
            if (b != this.ed) {
                this.dc("HigherShadeBrush", b, this.ed);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ez", {
        get: function () {
            return this.ee;
        },
        set: function (a) {
            var b = this.ee;
            this.ee = a;
            if (b != this.ee) {
                this.dc("HigherShadeOutline", b, this.ee);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a7", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.an;
            this.an = a;
            if (b != this.an) {
                this.dc("HigherShadeStrokeThickness", b, this.an);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "et", {
        get: function () {
            return this.d8;
        },
        set: function (a) {
            var b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.dc("BarBrush", b, this.d8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "eu", {
        get: function () {
            return this.d9;
        },
        set: function (a) {
            var b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.dc("BarOutline", b, this.d9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a5", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.dc("BarStrokeThickness", b, this.ai);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "fb", {
        get: function () {
            return this.eq;
        },
        set: function (a) {
            var b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.dc("RangeThumbBrush", b, this.eq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "fc", {
        get: function () {
            return this.er;
        },
        set: function (a) {
            var b = this.er;
            this.er = a;
            if (b != this.er) {
                this.dc("RangeThumbOutline", b, this.er);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bj", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.dc("RangeThumbStrokeThickness", b, this.a0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "fd", {
        get: function () {
            return this.es;
        },
        set: function (a) {
            var b = this.es;
            this.es = a;
            if (b != this.es) {
                this.dc("RangeThumbRidgesBrush", b, this.es);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e3", {
        get: function () {
            return this.ei;
        },
        set: function (a) {
            var b = this.ei;
            this.ei = a;
            if (b != this.ei) {
                this.dc("LowerCalloutBrush", b, this.ei);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e5", {
        get: function () {
            return this.ek;
        },
        set: function (a) {
            var b = this.ek;
            this.ek = a;
            if (b != this.ek) {
                this.dc("LowerCalloutTextColor", b, this.ek);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "e4", {
        get: function () {
            return this.ej;
        },
        set: function (a) {
            var b = this.ej;
            this.ej = a;
            if (b != this.ej) {
                this.dc("LowerCalloutOutline", b, this.ej);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "bb", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.dc("LowerCalloutStrokeThickness", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ev", {
        get: function () {
            return this.ea;
        },
        set: function (a) {
            var b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.dc("HigherCalloutBrush", b, this.ea);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ex", {
        get: function () {
            return this.ec;
        },
        set: function (a) {
            var b = this.ec;
            this.ec = a;
            if (b != this.ec) {
                this.dc("HigherCalloutTextColor", b, this.ec);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ew", {
        get: function () {
            return this.eb;
        },
        set: function (a) {
            var b = this.eb;
            this.eb = a;
            if (b != this.eb) {
                this.dc("HigherCalloutOutline", b, this.eb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "a6", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.am;
            this.am = a;
            if (b != this.am) {
                this.dc("HigherCalloutStrokeThickness", b, this.am);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "ab", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "z", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "y", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ZoomSlider.prototype, "aa", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    ZoomSlider.prototype.dc = function (a, b, c) {
        this.dj(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    ZoomSlider.prototype.dj = function (a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.a4 = this.bi;
                break;
            case "ActualPixelScalingRatio":
                if (this.g != null) {
                    this.g.at();
                }
                break;
            case "Orientation":
                this.db();
                this.trackDirty();
                break;
            case "TrackStartInset":
            case "TrackEndInset":
            case "StartInset":
            case "EndInset":
                this.c5();
                this.trackDirty();
                break;
            case "MaxZoomWidth":
            case "MinZoomWidth":
                this.dh();
                this.trackDirty();
                break;
            case "WindowRect":
                if (!this.w) {
                    this.af = true;
                    this.df();
                    this.trackDirty();
                    this.c3();
                    this.af = false;
                }
                break;
            case "LowerThumbBrush":
            case "LowerThumbOutline":
            case "LowerThumbRidgesBrush":
            case "LowerThumbStrokeThickness":
                this.d2();
                this.g.ao();
                break;
            case "LowerThumbWidth":
            case "LowerThumbHeight":
                this.g.i.width = this.bf;
                this.g.i.height = this.bd;
                this.trackDirty();
                break;
            case "HigherThumbBrush":
            case "HigherThumbOutline":
            case "HigherThumbRidgesBrush":
            case "HigherThumbStrokeThickness":
                this.dx();
                this.g.ao();
                break;
            case "HigherThumbWidth":
            case "HigherThumbHeight":
                this.g.i.width = this.bf;
                this.g.i.height = this.bd;
                this.trackDirty();
                break;
            case "LowerShadeBrush":
            case "LowerShadeOutline":
            case "LowerShadeStrokeThickness":
                this.d0();
                this.g.ao();
                break;
            case "HigherShadeBrush":
            case "HigherShadeOutline":
            case "HigherShadeStrokeThickness":
                this.dv();
                this.g.ao();
                break;
            case "RangeThumbBrush":
            case "RangeThumbOutline":
            case "RangeThumbRidgesBrush":
            case "RangeThumbStrokeThickness":
                this.d4();
                this.g.ao();
                break;
            case "BarBrush":
            case "BarOutline":
            case "BarStrokeThickness":
                this.dq();
                this.g.ao();
                break;
            case "LowerCalloutBrush":
            case "LowerCalloutOutline":
            case "LowerCalloutTextColor":
            case "LowerCalloutStrokeThickness":
                this.dy();
                this.g.ao();
                break;
            case "HigherCalloutBrush":
            case "HigherCalloutOutline":
            case "HigherCalloutTextColor":
            case "HigherCalloutStrokeThickness":
                this.dt();
                this.g.ao();
                break;
        }
    };
    ZoomSlider.prototype.dq = function () {
        var a = this.g.b;
        if (this.et == null) {
            a.barBox._fill = a.getBarBoxDefaultBrush();
        }
        else {
            a.barBox._fill = this.et;
        }
        if (this.eu == null) {
            a.barBox._stroke = a.getBarBoxDefaultOutline();
        }
        else {
            a.barBox._stroke = this.eu;
        }
        if (this.a5 == NaN) {
            a.barBox.ac = a.getBarBoxDefaultStrokeThickness();
        }
        else {
            a.barBox.ac = this.a5;
        }
    };
    ZoomSlider.prototype.dy = function () {
        var a = this.g.g;
        if (this.e3 == null) {
            a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
        }
        else {
            a.calloutBox._fill = this.e3;
        }
        if (this.e4 == null) {
            a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
        }
        else {
            a.calloutBox._stroke = this.e4;
        }
        if (this.e5 == null) {
            a.calloutText.am = a.getCalloutTextDefaultBrush();
        }
        else {
            a.calloutText.am = this.e5;
        }
        if (this.bb == NaN) {
            a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
        }
        else {
            a.calloutBox.ac = this.bb;
        }
    };
    ZoomSlider.prototype.dt = function () {
        var a = this.g.f;
        if (this.ev == null) {
            a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
        }
        else {
            a.calloutBox._fill = this.ev;
        }
        if (this.ew == null) {
            a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
        }
        else {
            a.calloutBox._stroke = this.ew;
        }
        if (this.ex == null) {
            a.calloutText.am = a.getCalloutTextDefaultBrush();
        }
        else {
            a.calloutText.am = this.ex;
        }
        if (this.a6 == NaN) {
            a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
        }
        else {
            a.calloutBox.ac = this.a6;
        }
    };
    ZoomSlider.prototype.d2 = function () {
        var a = this.g.i;
        if (this.e8 == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.e8;
        }
        if (this.e9 == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.e9;
        }
        if (this.fa == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.fa;
        }
        if (this.be == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.be;
        }
    };
    ZoomSlider.prototype.d4 = function () {
        var a = this.g.c;
        if (this.fb == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.fb;
        }
        if (this.fc == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.fc;
        }
        if (this.fd == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.fd;
        }
        if (this.bj == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.bj;
        }
    };
    ZoomSlider.prototype.d0 = function () {
        var a = this.g.e;
        if (this.e6 == null) {
            a.shadeBox._fill = a.getShadeBoxDefaultBrush();
        }
        else {
            a.shadeBox._fill = this.e6;
        }
        if (this.e7 == null) {
            a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
        }
        else {
            a.shadeOutline._stroke = this.e7;
        }
        if (this.bc == NaN) {
            a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
        }
        else {
            a.shadeOutline.ac = this.bc;
        }
    };
    ZoomSlider.prototype.dv = function () {
        var a = this.g.d;
        if (this.ey == null) {
            a.shadeBox._fill = a.getShadeBoxDefaultBrush();
        }
        else {
            a.shadeBox._fill = this.ey;
        }
        if (this.ez == null) {
            a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
        }
        else {
            a.shadeOutline._stroke = this.ez;
        }
        if (this.a7 == NaN) {
            a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
        }
        else {
            a.shadeOutline.ac = this.a7;
        }
    };
    ZoomSlider.prototype.dx = function () {
        var a = this.g.h;
        if (this.e0 == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.e0;
        }
        if (this.e1 == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.e1;
        }
        if (this.e2 == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.e2;
        }
        if (this.a9 == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.a9;
        }
    };
    ZoomSlider.prototype.df = function () {
        if (this.w) {
            return;
        }
        if (this.e == 0) {
            this.b.i = this.windowRect.left;
            this.a.i = this.windowRect.right;
            this.c.r = this.windowRect.width;
            this.c.n = this.windowRect.left + this.windowRect.width / 2;
        }
        else {
            this.b.i = this.windowRect.top;
            this.a.i = this.windowRect.bottom;
            this.c.r = this.windowRect.height;
            this.c.n = this.windowRect.top + this.windowRect.height / 2;
        }
    };
    ZoomSlider.prototype.dh = function () {
        this.c.m = this.bh;
        this.c.l = this.bg;
    };
    ZoomSlider.prototype.c5 = function () {
        if (this.fj.isEmpty) {
            return;
        }
        this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
    };
    ZoomSlider.prototype.db = function () {
        if (this.e == 0) {
            this.g.i.width = this.bf;
            this.g.i.height = this.bd;
            this.g.h.width = this.ba;
            this.g.h.height = this.a8;
        }
        else {
            this.g.i.height = this.bf;
            this.g.i.width = this.bd;
            this.g.h.height = this.ba;
            this.g.h.width = this.a8;
        }
        if (this.fj.isEmpty) {
            return;
        }
        this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
    };
    ZoomSlider.prototype.provideContainer = function (a) {
        this.g.au(a);
    };
    ZoomSlider.prototype.notifySizeChanged = function () {
        this.g.ap();
    };
    Object.defineProperty(ZoomSlider.prototype, "l", {
        get: function () {
            return this.k;
        },
        enumerable: true,
        configurable: true
    });
    ZoomSlider.prototype.dn = function (a) {
        this.ak = a;
        this.aj = this.c.n;
        this.ar = this.aj;
        this.k.v();
    };
    ZoomSlider.prototype.cy = function () {
        if (this.k.f()) {
            this.k.w();
        }
    };
    ZoomSlider.prototype.cx = function (a, b) {
        var c = this.k.o;
        var d = this.aj + c * (this.ak - this.aj);
        var e = d - this.ar;
        this.ar = d;
        this.c.o(e);
        if (this.k.f()) {
            this.d1(this.b);
            this.dw(this.a);
            this.c3();
        }
        else {
            this.c1();
            this.c0();
        }
    };
    ZoomSlider.prototype.c3 = function () {
        this.g.aj();
    };
    ZoomSlider.prototype.trackDirty = function () {
        this.p = true;
        if (this.g == null) {
            return;
        }
        this.g.ao();
    };
    ZoomSlider.prototype.show = function () {
        if (this.g != null) {
            this.g.az();
        }
    };
    ZoomSlider.prototype.hide = function () {
        if (this.g != null) {
            this.g.am();
        }
    };
    ZoomSlider.$t = markType(ZoomSlider, 'ZoomSlider', Base.$, [ITrackOwner_$type, INotifyPropertyChanged_$type, IZoomSlider_$type]);
    return ZoomSlider;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxZoomSliderComponent_PROVIDERS = [];
var ZoomSliderStylingDefaults = {};
var IgrZoomSlider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrZoomSlider, _super);
    function IgrZoomSlider(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this._implementation = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._resolvingAxisValue = null;
        _this._resolvingAxisValue_wrapped = null;
        _this._windowRectChanged = null;
        _this._windowRectChanged_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._implementation = _this.createImplementation();
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
        }
        var root;
        root = _this._container;
        if (_this._container != null) {
            root = _this._container;
        }
        var ren = new ReactRenderer(root, document, true, ZoomSliderStylingDefaults);
        _this._wrapper = ren;
        var zoomSlider = _this.i;
        _this._zoomSlider = zoomSlider;
        zoomSlider.provideContainer(ren);
        zoomSlider.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        ren.addSizeWatcher(function () {
            _this._zoomSlider.notifySizeChanged();
        });
        return _this;
    }
    Object.defineProperty(IgrZoomSlider.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._zoomSlider.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._zoomSlider.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrZoomSlider.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrZoomSlider.prototype.render = function () {
        var div = createElement("div", {
            className: "ig-zoom-slider igr-zoom-slider",
            ref: this._getMainRef
        });
        //}
        return div;
    };
    IgrZoomSlider.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrZoomSlider.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrZoomSlider.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrZoomSlider.prototype.componentWillUnmount = function () {
        this._zoomSlider.destroy();
        this._wrapper.destroy();
    };
    IgrZoomSlider.prototype.componentDidMount = function () {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container);
        this._zoomSlider.notifySizeChanged();
        this.initializeContent();
    };
    IgrZoomSlider.prototype.initializeContent = function () {
        this.updateStyle();
    };
    IgrZoomSlider.prototype.createImplementation = function () {
        return new ZoomSlider();
    };
    Object.defineProperty(IgrZoomSlider.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrZoomSlider._staticStyling = function (container, component, parent) {
        var genericPrefix = "";
        var typeName = (component.i ? component.i : component).$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ZoomSlider");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = (component.i ? component.i : component).$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, component, genericPrefix + "-", new Set(), false, additionalPrefixes);
    };
    Object.defineProperty(IgrZoomSlider.prototype, "panTransitionDuration", {
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "maxZoomWidth", {
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "actualPixelScalingRatio", {
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "windowRect", {
        get: function () {
            return fromRect(this.i.windowRect);
        },
        set: function (v) {
            this.i.windowRect = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "minZoomWidth", {
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "startInset", {
        get: function () {
            return this.i.startInset;
        },
        set: function (v) {
            this.i.startInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "endInset", {
        get: function () {
            return this.i.endInset;
        },
        set: function (v) {
            this.i.endInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "trackStartInset", {
        get: function () {
            return this.i.trackStartInset;
        },
        set: function (v) {
            this.i.trackStartInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "trackEndInset", {
        get: function () {
            return this.i.trackEndInset;
        },
        set: function (v) {
            this.i.trackEndInset = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "barExtent", {
        get: function () {
            return this.i.barExtent;
        },
        set: function (v) {
            this.i.barExtent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "orientation", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureEnum(ZoomSliderOrientation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbBrush", {
        get: function () {
            return brushToString(this.i.e8);
        },
        set: function (v) {
            this.i.e8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbStrokeThickness", {
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbStrokeThickness", {
        get: function () {
            return this.i.a9;
        },
        set: function (v) {
            this.i.a9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbBrush", {
        get: function () {
            return brushToString(this.i.e0);
        },
        set: function (v) {
            this.i.e0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbOutline", {
        get: function () {
            return brushToString(this.i.e9);
        },
        set: function (v) {
            this.i.e9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbOutline", {
        get: function () {
            return brushToString(this.i.e1);
        },
        set: function (v) {
            this.i.e1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.fa);
        },
        set: function (v) {
            this.i.fa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.e2);
        },
        set: function (v) {
            this.i.e2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbWidth", {
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbWidth", {
        get: function () {
            return this.i.ba;
        },
        set: function (v) {
            this.i.ba = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerThumbHeight", {
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherThumbHeight", {
        get: function () {
            return this.i.a8;
        },
        set: function (v) {
            this.i.a8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerShadeBrush", {
        get: function () {
            return brushToString(this.i.e6);
        },
        set: function (v) {
            this.i.e6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerShadeOutline", {
        get: function () {
            return brushToString(this.i.e7);
        },
        set: function (v) {
            this.i.e7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerShadeStrokeThickness", {
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherShadeBrush", {
        get: function () {
            return brushToString(this.i.ey);
        },
        set: function (v) {
            this.i.ey = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherShadeOutline", {
        get: function () {
            return brushToString(this.i.ez);
        },
        set: function (v) {
            this.i.ez = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherShadeStrokeThickness", {
        get: function () {
            return this.i.a7;
        },
        set: function (v) {
            this.i.a7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "barBrush", {
        get: function () {
            return brushToString(this.i.et);
        },
        set: function (v) {
            this.i.et = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "barOutline", {
        get: function () {
            return brushToString(this.i.eu);
        },
        set: function (v) {
            this.i.eu = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "barStrokeThickness", {
        get: function () {
            return this.i.a5;
        },
        set: function (v) {
            this.i.a5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "rangeThumbBrush", {
        get: function () {
            return brushToString(this.i.fb);
        },
        set: function (v) {
            this.i.fb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "rangeThumbOutline", {
        get: function () {
            return brushToString(this.i.fc);
        },
        set: function (v) {
            this.i.fc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "rangeThumbStrokeThickness", {
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "rangeThumbRidgesBrush", {
        get: function () {
            return brushToString(this.i.fd);
        },
        set: function (v) {
            this.i.fd = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerCalloutBrush", {
        get: function () {
            return brushToString(this.i.e3);
        },
        set: function (v) {
            this.i.e3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerCalloutTextColor", {
        get: function () {
            return brushToString(this.i.e5);
        },
        set: function (v) {
            this.i.e5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerCalloutOutline", {
        get: function () {
            return brushToString(this.i.e4);
        },
        set: function (v) {
            this.i.e4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "lowerCalloutStrokeThickness", {
        get: function () {
            return this.i.bb;
        },
        set: function (v) {
            this.i.bb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherCalloutBrush", {
        get: function () {
            return brushToString(this.i.ev);
        },
        set: function (v) {
            this.i.ev = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherCalloutTextColor", {
        get: function () {
            return brushToString(this.i.ex);
        },
        set: function (v) {
            this.i.ex = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherCalloutOutline", {
        get: function () {
            return brushToString(this.i.ew);
        },
        set: function (v) {
            this.i.ew = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "higherCalloutStrokeThickness", {
        get: function () {
            return this.i.a6;
        },
        set: function (v) {
            this.i.a6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "isCustomThumbProvided", {
        get: function () {
            return this.i.ab;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "isCustomRangeThumbProvided", {
        get: function () {
            return this.i.z;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "isCustomBarProvided", {
        get: function () {
            return this.i.y;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "isCustomShadeProvided", {
        get: function () {
            return this.i.aa;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "areThumbCalloutsEnabled", {
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "thumbCalloutTextStyle", {
        get: function () {
            if (this.i.o == null) {
                return null;
            }
            return this.i.o.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.o = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrZoomSlider.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrZoomSlider.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ZoomSlider");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrZoomSlider.prototype.onDetachedFromUI = function () {
        this.i.onDetachedFromUI();
    };
    IgrZoomSlider.prototype.onAttachedToUI = function () {
        this.i.onAttachedToUI();
    };
    /**
     * Release any resources held by the ZoomSlider.
    
    */
    IgrZoomSlider.prototype.destroy = function () {
        this.i.destroy();
    };
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    IgrZoomSlider.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    IgrZoomSlider.prototype.flush = function () {
        this.i.c3();
    };
    IgrZoomSlider.prototype.trackDirty = function () {
        this.i.trackDirty();
    };
    /**
     * Shows the ZoomSlider.
    
    */
    IgrZoomSlider.prototype.show = function () {
        this.i.show();
    };
    /**
     * Hides the ZoomSlider.
    
    */
    IgrZoomSlider.prototype.hide = function () {
        this.i.hide();
    };
    Object.defineProperty(IgrZoomSlider.prototype, "resolvingAxisValue", {
        get: function () {
            return this._resolvingAxisValue;
        },
        set: function (ev) {
            var _this = this;
            if (this._resolvingAxisValue_wrapped !== null) {
                this.i.resolvingAxisValue = delegateRemove(this.i.resolvingAxisValue, this._resolvingAxisValue_wrapped);
                this._resolvingAxisValue_wrapped = null;
                this._resolvingAxisValue = null;
            }
            this._resolvingAxisValue = ev;
            this._resolvingAxisValue_wrapped = function (o, e) {
                var outerArgs = new IgrZoomSliderResolvingAxisValueEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeResolvingAxisValue) {
                    _this.beforeResolvingAxisValue(_this, outerArgs);
                }
                if (_this._resolvingAxisValue) {
                    _this._resolvingAxisValue(_this, outerArgs);
                }
            };
            this.i.resolvingAxisValue = delegateCombine(this.i.resolvingAxisValue, this._resolvingAxisValue_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrZoomSlider.prototype, "windowRectChanged", {
        /**
         * Occurs just after the current ZoomSlider's window rectangle is changed.
        */
        get: function () {
            return this._windowRectChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._windowRectChanged_wrapped !== null) {
                this.i.windowRectChanged = delegateRemove(this.i.windowRectChanged, this._windowRectChanged_wrapped);
                this._windowRectChanged_wrapped = null;
                this._windowRectChanged = null;
            }
            this._windowRectChanged = ev;
            this._windowRectChanged_wrapped = function (o, e) {
                var outerArgs = new IgrRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeWindowRectChanged) {
                    _this.beforeWindowRectChanged(_this, outerArgs);
                }
                if (_this._windowRectChanged) {
                    _this._windowRectChanged(_this, outerArgs);
                }
            };
            this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, this._windowRectChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrZoomSlider;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrZoomSliderModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrZoomSliderModule() {
    }
    IgrZoomSliderModule.register = function () {
        TypeRegistrar.registerCons('IgrZoomSlider', IgrZoomSlider);
        TypeRegistrar.registerCons('IgrZoomSlider', IgrZoomSlider);
        TypeRegistrar.register('ZoomSlider', ZoomSlider.$type);
    };
    return IgrZoomSliderModule;
}());

var LegendBaseStyles = ["\n:host {\n    display: block;\n}\n.ig-legend {\n    border: none;\n    border: var(--legend-border, none);\n    overflow: auto;\n    overflow: var(--legend-item-overflow, auto);\n}\n.ig-chart-legend-item-text {\n    font: 12px Verdana, Arial, sans-serif;\n    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);\n    vertical-align: middle;\n    vertical-align: var(--legend-item-vertical-align, middle);\n}\n.ig-chart-legend-items-list\n{\n    padding: 5px;\n    padding: var(--legend-item-padding, 5px);\n    margin: 0px;\n    margin: var(--legend-item-margin, 0px);\n    background-color: transparent;\n    background-color: var(--legend-list-background-color, transparent);\n}\n.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas\n{\n    vertical-align: middle;\n    vertical-align: var(--legend-item-badge-vertical-align, middle);\n}\n.ig-chart-legend-item\n{\n    background-color: transparent;\n    background-color: var(--legend-item-background-color, transparent);\n}\n"];
/**
 * Represents the base class for a legend in IgxDataChartComponent.
*/
var IgrLegendBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLegendBase, _super);
    function IgrLegendBase(props) {
        var _this = _super.call(this, props) || this;
        _this._zoneRunner = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        IgrLegendBase.ensureCss();
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        if (document) {
            //introduce styles globally for now.
        }
        return _this;
    }
    Object.defineProperty(IgrLegendBase.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrLegendBase.prototype.onImplementationCreated = function () {
    };
    IgrLegendBase.ensureCss = function () {
        if (!document) {
            return;
        }
        if (IgrLegendBase._checked.has(document)) {
            return;
        }
        for (var i = 0; i < document.head.children.length; i++) {
            var child = document.head.children[i];
            if (child.tagName == "link" && child.hasAttribute("data-ig-legend-style")) {
                return;
            }
        }
        var link = document.createElement("link");
        link.setAttribute('rel', 'stylesheet');
        link.setAttribute('type', 'text/css');
        link.setAttribute('href', 'data:text/css;charset=UTF-8,' + encodeURIComponent(LegendBaseStyles[0]));
        link.setAttribute('data-ig-legend-style', 'true');
        document.head.appendChild(link);
        IgrLegendBase._checked.set(document, true);
    };
    IgrLegendBase.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    {
                        this[p] = this.props[p];
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrLegendBase.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrLegendBase.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrLegendBase.prototype, "isItemwise", {
        /**
     * Gets if the legend is item-wise.
    */
        get: function () {
            return this.i.isItemwise;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendBase.prototype, "isFinancial", {
        /**
         * Gets if the legend is a financial legend.
        */
        get: function () {
            return this.i.isFinancial;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendBase.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrLegendBase.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrLegendBase.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LegendBase");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrLegendBase._checked = new WeakMap();
    return IgrLegendBase;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendMouseButtonEventArgs, _super);
    function LegendMouseButtonEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._originalEvent = null;
        _this._item = null;
        _this._series = null;
        _this._chart = null;
        _this._legendItem = null;
        _this.chart = a;
        _this.series = b;
        _this.item = c;
        _this.originalEvent = d;
        _this.legendItem = e;
        return _this;
    }
    LegendMouseButtonEventArgs.prototype.toString = function () {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    };
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "originalEvent", {
        get: function () {
            return this._originalEvent;
        },
        set: function (a) {
            this._originalEvent = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "handled", {
        get: function () {
            return this.originalEvent.handled;
        },
        set: function (a) {
            this.originalEvent.handled = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendMouseButtonEventArgs.prototype.getPosition = function (a) {
        return this.originalEvent.getPosition(a);
    };
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "originalSource", {
        get: function () {
            return this.originalEvent.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "chart", {
        get: function () {
            return this._chart;
        },
        set: function (a) {
            this._chart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "legendItem", {
        get: function () {
            return this._legendItem;
        },
        set: function (a) {
            this._legendItem = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendMouseButtonEventArgs.$t = markType(LegendMouseButtonEventArgs, 'LegendMouseButtonEventArgs', EventArgs.$);
    return LegendMouseButtonEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendMouseEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendMouseEventArgs, _super);
    function LegendMouseEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._originalEvent = null;
        _this._item = null;
        _this._series = null;
        _this._chart = null;
        _this._legendItem = null;
        _this.chart = a;
        _this.series = b;
        _this.item = c;
        _this.originalEvent = d;
        _this.legendItem = e;
        return _this;
    }
    LegendMouseEventArgs.prototype.toString = function () {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    };
    Object.defineProperty(LegendMouseEventArgs.prototype, "originalEvent", {
        get: function () {
            return this._originalEvent;
        },
        set: function (a) {
            this._originalEvent = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendMouseEventArgs.prototype.getPosition = function (a) {
        return this.originalEvent.getPosition(a);
    };
    Object.defineProperty(LegendMouseEventArgs.prototype, "originalSource", {
        get: function () {
            return this.originalEvent.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseEventArgs.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseEventArgs.prototype, "chart", {
        get: function () {
            return this._chart;
        },
        set: function (a) {
            this._chart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseEventArgs.prototype, "legendItem", {
        get: function () {
            return this._legendItem;
        },
        set: function (a) {
            this._legendItem = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendMouseEventArgs.$t = markType(LegendMouseEventArgs, 'LegendMouseEventArgs', EventArgs.$);
    return LegendMouseEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendItemVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendItemVisualData, _super);
    function LegendItemVisualData() {
        var _this = _super.call(this) || this;
        _this._label = null;
        _this._labelBounds = null;
        _this._appearance = null;
        _this._labelAppearance = null;
        _this._bounds = null;
        _this._badgeBounds = null;
        _this.labelBounds = RectData.empty;
        _this.appearance = new PrimitiveAppearanceData();
        return _this;
    }
    Object.defineProperty(LegendItemVisualData.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "labelBounds", {
        get: function () {
            return this._labelBounds;
        },
        set: function (a) {
            this._labelBounds = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "labelAppearance", {
        get: function () {
            return this._labelAppearance;
        },
        set: function (a) {
            this._labelAppearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "bounds", {
        get: function () {
            return this._bounds;
        },
        set: function (a) {
            this._bounds = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "badgeBounds", {
        get: function () {
            return this._badgeBounds;
        },
        set: function (a) {
            this._badgeBounds = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendItemVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        var b = function (c) { return "{ left: " + c.left + ", top: " + c.top + ", width: " + c.width + ", height: " + c.height + "}"; };
        a.q("bounds: {0},\r\n", b(this.bounds));
        a.q("badgeBounds: {0},\r\n", b(this.badgeBounds));
        a.q("labelBounds: {0}\r\n", b(this.labelBounds));
        a.u("}");
        return a.toString();
    };
    LegendItemVisualData.$t = markType(LegendItemVisualData, 'LegendItemVisualData');
    return LegendItemVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendVisualDataList, _super);
    function LegendVisualDataList() {
        return _super.call(this, LegendItemVisualData.$, 0) || this;
    }
    LegendVisualDataList.$t = markType(LegendVisualDataList, 'LegendVisualDataList', List$1.$.specialize(LegendItemVisualData.$));
    return LegendVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendVisualData, _super);
    function LegendVisualData() {
        var _this = _super.call(this) || this;
        _this._items = null;
        _this._viewport = null;
        _this._width = 0;
        _this._height = 0;
        _this.items = new LegendVisualDataList();
        return _this;
    }
    Object.defineProperty(LegendVisualData.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (a) {
            this._items = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendVisualData.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendVisualData.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("items: [");
        for (var b = 0; b < this.items.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.items._inner[b].serialize());
        }
        a.u("],");
        a.u("}");
        return a.toString();
    };
    LegendVisualData.$t = markType(LegendVisualData, 'LegendVisualData');
    return LegendVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendBaseViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendBaseViewManager, _super);
    function LegendBaseViewManager(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.l = null;
        _this.g = null;
        _this.d = false;
        _this.f = null;
        _this.m = null;
        _this.c = null;
        _this.a = a;
        _this.f = new Dictionary$2(Base.$, DomWrapper_$type, 0);
        _this.p();
        return _this;
    }
    LegendBaseViewManager.prototype.p = function () {
        var a = LegendItemHelper.b;
        if (window.devicePixelRatio != undefined && (isNaN_(a) || window.devicePixelRatio != a)) {
            LegendItemHelper.b = window.devicePixelRatio;
            this.a.al();
        }
    };
    LegendBaseViewManager.prototype.u = function () {
    };
    LegendBaseViewManager.prototype.s = function () {
        this.p();
    };
    LegendBaseViewManager.prototype.t = function (a) {
        if (a == null) {
            this.l = null;
            this.g = null;
            return;
        }
        this.g = a;
        this.l = this.i();
        this.l.addClass(this.a.s);
        this.g.append(this.l);
    };
    LegendBaseViewManager.prototype.i = function () {
        return this.g.createElement("table");
    };
    LegendBaseViewManager.prototype.h = function () {
        var a = this.g.createElement("tr");
        a.addClass(this.a.t);
        var b = this.a.k;
        if (b) {
            a.setStyleProperty("display", "block");
            a.setStyleProperty("float", "left");
            a.setStyleProperty("margin", "0px");
            a.setStyleProperty("margin-right", "8px");
        }
        return a;
    };
    LegendBaseViewManager.prototype.j = function (a) {
        return this.k(a, this.l);
    };
    LegendBaseViewManager.prototype.k = function (a, b) {
        var c = typeCast(ContentControl.$, a);
        var d = this.h();
        if (c != null) {
            var e = typeCast(ILegendContext_$type, c.content);
            if (e != null && c.ah != null) {
                var f = new DataTemplatePassInfo();
                f.context = d;
                f.passID = "LegendItem";
                var g = new DataTemplateMeasureInfo();
                g.passInfo = f;
                g.width = NaN;
                g.height = NaN;
                g.data = e;
                g.context = d;
                var h = new DataTemplateRenderInfo();
                h.passInfo = f;
                if (c.ah.measure != null) {
                    c.ah.measure(g);
                }
                h.context = this.g.getSubRenderer(d);
                h.availableWidth = g.width;
                h.availableHeight = g.height;
                h.data = e;
                h.xPosition = 0;
                h.yPosition = 0;
                c.ah.render(h);
                var i = d.findByClass(".ui-legend-item-badge");
                for (var j = 0; j < i.length; j++) {
                    i[j].removeClass("ui-legend-item-badge").addClass(this.a.r);
                }
                i = d.findByClass(".ui-legend-item-text");
                for (var k = 0; k < i.length; k++) {
                    if (this.a.k) {
                        i[k].setStyleProperty("white-space", "nowrap");
                    }
                    i[k].removeClass("ui-legend-item-text").addClass(this.a.u);
                }
            }
        }
        return d;
    };
    LegendBaseViewManager.prototype.o = function (a, b) {
        var c = this.k(a, this.l);
        c.listen("mouseup", runOn(this.a, this.a.ae));
        c.listen("mousedown", runOn(this.a, this.a.ab));
        c.listen("mouseleave", runOn(this.a, this.a.ac));
        c.listen("mousemove", runOn(this.a, this.a.ad));
        this.f.addItem(a, c);
        if ((this.l.getChildCount() == 0) || (b >= this.l.getChildCount())) {
            this.l.append(c);
        }
        else {
            var d = this.l.getChildAt(b);
            d.before(c);
        }
    };
    LegendBaseViewManager.prototype.w = function (a) {
    };
    LegendBaseViewManager.prototype.x = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.f.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
            b.unlistenAll();
            b.remove();
            this.f.removeItem(a);
        }
    };
    LegendBaseViewManager.prototype.n = function (visual_) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var pair_ = _c.value;
                if (pair_.value.getNativeElement() === visual_) {
                    return pair_.key;
                }
                ;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    LegendBaseViewManager.prototype.e = function (a) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(this.f.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(ContentControl.$, b);
                if (c != null && c.content != null) {
                    var d = typeCast(ILegendContext_$type, c.content);
                    if (d != null && d.itemLabel == a.itemLabel && d.legendLabel == a.legendLabel && d.series == a.series && d.itemBrush == a.itemBrush) {
                        return true;
                    }
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return false;
    };
    LegendBaseViewManager.prototype.b = function (a) {
        var b = this.g.rootWrapper.width();
        var c = this.g.rootWrapper.height();
        this.l.remove();
        var d = this.g.createElement("div");
        d.setStyleProperty("position", "relative");
        this.m = this.g.createElement("<canvas style=\"position : absolute; top : 0; left : 0\" />");
        this.m.setStyleProperty("position", "absolute");
        this.m.setStyleProperty("top", "0px");
        this.m.setStyleProperty("left", "0px");
        this.g.append(d);
        d.append(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), this.g.get2DCanvasContext(this.m));
        this.m.setAttribute("width", b.toString());
        this.m.setAttribute("height", c.toString());
        return this.c;
    };
    LegendBaseViewManager.prototype.ab = function () {
        return new Size(1, this.g.rootWrapper.width(), Math.max(10, this.g.rootWrapper.height() - 15));
    };
    LegendBaseViewManager.prototype.y = function (a, b, c, d) {
        var e_3, _a;
        var e = a.g();
        e.beginPath();
        e.moveTo(b.ak._inner[0].x, b.ak._inner[0].y);
        for (var f = 1; f < b.ak.count; f++) {
            e.lineTo(b.ak._inner[f].x, b.ak._inner[f].y);
        }
        e.lineTo(b.ak._inner[0].x, b.ak._inner[0].y);
        var g = e.createLinearGradient(d.left, d.top, d.left, d.top + d.height);
        try {
            for (var _b = __values(fromEnum(c.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                g.addColorStop(h.a, h.b._fill);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        e.fillStyle = g;
        e.fill();
    };
    LegendBaseViewManager.prototype.q = function () {
    };
    LegendBaseViewManager.prototype.r = function () {
    };
    LegendBaseViewManager.prototype.v = function (a) {
        var b = this.l == null ? 0 : this.l.getChildCount();
        for (var c = 0; c < b; c++) {
            var d = this.l.getChildAt(c);
            d.setStyleProperty("display", a ? "block" : "");
            d.setStyleProperty("float", a ? "left" : "");
            d.setStyleProperty("margin", a ? "0px" : "");
            d.setStyleProperty("margin-right", a ? "8px" : "");
            d.getChildAt(1).setStyleProperty("white-space", a ? "nowrap" : "");
        }
    };
    LegendBaseViewManager.prototype.z = function (a) {
        this.l.setStyleProperty("color", a);
    };
    LegendBaseViewManager.prototype.aa = function (a) {
        var b = FontUtil.getFontInfoFromString(this.g, a);
        this.l.setStyleProperty("font-family", b.n);
        this.l.setStyleProperty("font-size", b.d + "px");
        this.l.setStyleProperty("font-style", b.q);
    };
    LegendBaseViewManager.$t = markType(LegendBaseViewManager, 'LegendBaseViewManager');
    return LegendBaseViewManager;
}(Base));
/**
 * @hidden
 */
var LegendBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendBase, _super);
    function LegendBase() {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.at = null;
        _this._seriesOwner = null;
        _this._chartOwner = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.legendItemMouseLeftButtonDown = null;
        _this.legendItemMouseLeftButtonUp = null;
        _this.legendItemMouseEnter = null;
        _this.legendItemMouseLeave = null;
        _this.legendItemMouseMove = null;
        var a = _this.aj();
        _this.a8(a);
        a.ak();
        _this.at = new ObservableCollection$1(UIElement.$, 0);
        _this.aw = "ig-chart-legend-items-list";
        _this.ax = "ig-chart-legend-item";
        _this.av = "ig-chart-legend-item-badge";
        _this.ay = "ig-chart-legend-item-text";
        return _this;
    }
    LegendBase.prototype.onDetachedFromUI = function () {
        this.ak.aj();
    };
    LegendBase.prototype.onAttachedToUI = function () {
        this.ak.ah();
    };
    LegendBase.prototype.aj = function () {
        return new LegendBaseView(this);
    };
    LegendBase.prototype.a8 = function (a) {
        this.ak = a;
    };
    LegendBase.prototype.addChildInOrder = function (a, b) {
    };
    LegendBase.prototype.a0 = function (a, b) {
    };
    Object.defineProperty(LegendBase.prototype, "seriesOwner", {
        get: function () {
            return this._seriesOwner;
        },
        set: function (a) {
            this._seriesOwner = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "chartOwner", {
        get: function () {
            return this._chartOwner;
        },
        set: function (a) {
            this._chartOwner = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.get_isItemwise = function () {
        return false;
    };
    Object.defineProperty(LegendBase.prototype, "isItemwise", {
        get: function () {
            return this.get_isItemwise();
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.get_isScale = function () {
        return false;
    };
    Object.defineProperty(LegendBase.prototype, "isScale", {
        get: function () {
            return this.get_isScale();
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.clearLegendItemsForSeries = function (a) {
        var e_4, _a, e_5, _b;
        if (a == null || this.at == null || this.at.count == 0) {
            return;
        }
        var b = new ObservableCollection$1(UIElement.$, 0);
        try {
            for (var _c = __values(fromEnum(this.at)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var c = _d.value;
                var d = typeCast(ContentControl.$, c);
                if (d != null && d.content != null) {
                    var e = typeCast(ILegendContext_$type, d.content);
                    if (e != null && e.series == a) {
                        b.add(c);
                    }
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var f = _f.value;
                this.at.remove(f);
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    LegendBase.prototype.containsChild = function (a) {
        return this.at.contains(a);
    };
    LegendBase.prototype.removeChild = function (a) {
        this.at.remove(a);
    };
    Object.defineProperty(LegendBase.prototype, "ai", {
        get: function () {
            if (this.seriesOwner != null) {
                return this.seriesOwner;
            }
            else {
                return this.chartOwner;
            }
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.a9 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    LegendBase.prototype.a5 = function (a) {
        if (this.legendItemMouseLeftButtonDown != null) {
            this.legendItemMouseLeftButtonDown(this, a);
        }
    };
    LegendBase.prototype.a6 = function (a) {
        if (this.legendItemMouseLeftButtonUp != null) {
            this.legendItemMouseLeftButtonUp(this, a);
        }
    };
    LegendBase.prototype.a3 = function (a) {
        if (this.legendItemMouseEnter != null) {
            this.legendItemMouseEnter(this, a);
        }
    };
    LegendBase.prototype.a4 = function (a) {
        if (this.legendItemMouseLeave != null) {
            this.legendItemMouseLeave(this, a);
        }
    };
    LegendBase.prototype.a7 = function (a) {
        if (this.legendItemMouseMove != null) {
            this.legendItemMouseMove(this, a);
        }
    };
    LegendBase.prototype.provideContainer = function (a) {
        this.ak.ai(a);
    };
    Object.defineProperty(LegendBase.prototype, "aw", {
        get: function () {
            return this.ak.s;
        },
        set: function (a) {
            this.ak.s = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "ax", {
        get: function () {
            return this.ak.t;
        },
        set: function (a) {
            this.ak.t = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "av", {
        get: function () {
            return this.ak.r;
        },
        set: function (a) {
            this.ak.r = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "ay", {
        get: function () {
            return this.ak.u;
        },
        set: function (a) {
            this.ak.u = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.exportVisualData = function () {
        return this.ak.f();
    };
    LegendBase.prototype.exportSerializedVisualData = function () {
        return this.exportVisualData().serialize();
    };
    LegendBase.prototype.get_isFinancial = function () {
        return false;
    };
    Object.defineProperty(LegendBase.prototype, "isFinancial", {
        get: function () {
            return this.get_isFinancial();
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.$t = markType(LegendBase, 'LegendBase', ContentControl.$, [INotifyPropertyChanged_$type, IChartLegend_$type]);
    return LegendBase;
}(ContentControl));
/**
 * @hidden
 */
var LegendBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendBaseView, _super);
    function LegendBaseView(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.b = null;
        _this.s = null;
        _this.t = null;
        _this.r = null;
        _this.u = null;
        _this.l = false;
        _this.i = false;
        _this.p = null;
        _this.q = null;
        _this.b = a;
        _this.c = new LegendBaseViewManager(_this);
        return _this;
    }
    LegendBaseView.prototype.aj = function () {
        this.c.u();
    };
    LegendBaseView.prototype.ah = function () {
        this.c.s();
    };
    LegendBaseView.prototype.ak = function () {
    };
    LegendBaseView.prototype.get_j = function () {
        return false;
    };
    Object.defineProperty(LegendBaseView.prototype, "j", {
        get: function () {
            return this.get_j();
        },
        enumerable: true,
        configurable: true
    });
    LegendBaseView.prototype.d = function (a) {
        var b;
        var c;
        var d;
        var e = this.aa(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        var f = new MouseButtonEventArgs();
        var g = new LegendMouseButtonEventArgs(b, c, d, f, a);
        return g;
    };
    LegendBaseView.prototype.e = function (a) {
        var b;
        var c;
        var d;
        var e = this.aa(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        var f = new MouseEventArgs();
        var g = new LegendMouseEventArgs(b, c, d, f, a);
        return g;
    };
    LegendBaseView.prototype.aa = function (a, b, c, d) {
        b = this.b.ai;
        c = null;
        d = null;
        if (a != null) {
            var e = typeCast(ContentControl.$, a);
            if (e != null && e.content != null && typeCast(ILegendContext_$type, e.content) !== null) {
                var f = typeCast(ILegendContext_$type, e.content);
                c = typeCast(ILegendSeries_$type, f.series);
                if (c != null) {
                    b = c.container;
                }
                d = f.item;
            }
        }
        return {
            p1: b,
            p2: c,
            p3: d
        };
    };
    LegendBaseView.prototype.z = function () {
    };
    LegendBaseView.prototype.m = function () {
        return true;
    };
    LegendBaseView.prototype.y = function (a) {
    };
    LegendBaseView.prototype.am = function (a) {
    };
    LegendBaseView.prototype.ai = function (a) {
        this.c.t(a);
    };
    LegendBaseView.prototype.an = function (a) {
        this.c.x(a);
    };
    LegendBaseView.prototype.x = function (a) {
        var b = this.b.at.indexOf(a);
        this.c.o(a, b);
    };
    LegendBaseView.prototype.af = function () {
        this.c.q();
    };
    LegendBaseView.prototype.ag = function () {
        this.c.r();
    };
    Object.defineProperty(LegendBaseView.prototype, "k", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            this.i = a;
            this.c.v(this.i);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBaseView.prototype, "v", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
            this.c.z(this.p);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBaseView.prototype, "w", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
            this.c.aa(this.q);
        },
        enumerable: true,
        configurable: true
    });
    LegendBaseView.prototype.al = function () {
        this.c.p();
    };
    LegendBaseView.prototype.n = function (e_) {
        var ev_ = e_.originalEvent;
        return ev_.currentTarget;
    };
    LegendBaseView.prototype.o = function (e_) {
        return this.c.n(this.n(e_));
    };
    LegendBaseView.prototype.ad = function (a) {
        if (!this.l) {
            this.b.a3(this.e(this.o(a)));
        }
        this.l = true;
    };
    LegendBaseView.prototype.ac = function (a) {
        if (this.l) {
            this.b.a4(this.e(this.o(a)));
        }
        this.l = false;
    };
    LegendBaseView.prototype.ab = function (a) {
        this.b.a5(this.d(this.o(a)));
    };
    LegendBaseView.prototype.ae = function (a) {
        this.b.a6(this.d(this.o(a)));
    };
    LegendBaseView.prototype.h = function (a) {
        var b = a.querySelectorAll("span *");
        var c = Rect.empty;
        for (var e = 0; e < b.length; e++) {
            var d = b[e];
            if (stringIsNullOrEmpty(d.getText())) {
                continue;
            }
            var f = new Rect(0, d.getOffset().left, d.getOffset().top, d.width(), d.height());
            f.union(c);
            c = f;
        }
        return RectData.b(c);
    };
    LegendBaseView.prototype.g = function (a) {
        var b = a.querySelectorAll("canvas");
        var c = b.length > 0 ? b[0] : null;
        return c != null ? new RectData(c.getOffset().left, c.getOffset().top, c.width(), c.height()) : null;
    };
    LegendBaseView.prototype.a = function (a) {
        if (this.b == null || this.b.at == null || this.b.at.count <= a) {
            return null;
        }
        var b = this.b.at._inner[a];
        if (b == null) {
            return null;
        }
        var c = b.content;
        if (c == null) {
            return null;
        }
        var d = c.actualItemBrush != null ? c.actualItemBrush : c.itemBrush;
        return AppearanceHelper.b(d);
    };
    LegendBaseView.prototype.f = function () {
        var a = new LegendVisualData();
        var b = this.c.l;
        var c = b.getChildCount();
        for (var d = 0; d < c; d++) {
            var e = new LegendItemVisualData();
            var f = b.getChildAt(d);
            e.label = f.getText();
            e.label = e.label != null ? e.label.trim() : null;
            e.bounds = new RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
            e.labelBounds = this.h(f);
            e.badgeBounds = this.g(f);
            a.items.add(e);
        }
        for (var g = 0; g < this.b.at.count; g++) {
            a.items._inner[g].appearance.fill = this.a(g);
        }
        return a;
    };
    LegendBaseView.$t = markType(LegendBaseView, 'LegendBaseView');
    return LegendBaseView;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendItemInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendItemInfo, _super);
    function LegendItemInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.c = null;
        _this.a = null;
        _this.b = null;
        return _this;
    }
    LegendItemInfo.$t = markType(LegendItemInfo, 'LegendItemInfo');
    return LegendItemInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Legend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Legend, _super);
    function Legend() {
        var _this = _super.call(this) || this;
        _this.ab = Legend.$;
        var a = _this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) {
            var e_1, _a, e_2, _b;
            if (b.oldItems != null) {
                try {
                    for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        _this.bc.an(c);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var d = _f.value;
                        _this.bc.x(d);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        });
        return _this;
    }
    Legend.prototype.aj = function () {
        return new LegendView(this);
    };
    Legend.prototype.a8 = function (a) {
        _super.prototype.a8.call(this, a);
        this.bc = a;
    };
    Legend.prototype.bd = function (a) {
        return a.resolveLegendIndex();
    };
    Legend.prototype.bf = function (a) {
        return this.be(a);
    };
    Legend.prototype.addChildInOrder = function (a, b) {
        var e_3, _a;
        if (b.isStacked) {
            return;
        }
        if (!b.isUsableInLegend) {
            return;
        }
        var c = 0;
        try {
            for (var _b = __values(fromEnum(this.at)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                var e = void 0;
                var f = void 0;
                var g = void 0;
                var h = this.ak.aa(d, e, f, g);
                e = h.p1;
                f = h.p2;
                g = h.p3;
                if (b.container != null && e != null && (this.bf(b.container) < this.bf(e) || (this.bf(b.container) == -1 && this.bf(e) == -1 && Base.getHashCodeStatic(b.container) < Base.getHashCodeStatic(e)))) {
                    break;
                }
                if (b.container != null && e != null && b.container == e && f != null) {
                    var i = this.bd(b);
                    var j = this.bd(f);
                    var k = this.bf(b);
                    var l = this.bf(f);
                    if (f.isVertical && !f.isStacked) {
                        if (l == -1 && k == -1) {
                            c = 0;
                            break;
                        }
                        if (k < l || l == -1) {
                            break;
                        }
                    }
                    if (i <= j) {
                        break;
                    }
                }
                c++;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.at.insert(c, a);
        var m = new LegendItemInfo();
        m.c = a;
        m.a = b;
        var n = typeCast(ContentControl.$, a);
        if (n != null && n.content != null) {
            var o = typeCast(ILegendContext_$type, n.content);
            if (o != null) {
                m.b = o;
                m.d = o.itemLabel;
            }
        }
    };
    Object.defineProperty(Legend.prototype, "bb", {
        get: function () {
            return this.ak.k ? 0 : 0;
        },
        set: function (a) {
            this.ak.k = a == 0;
        },
        enumerable: true,
        configurable: true
    });
    Legend.prototype.be = function (a) {
        return -1;
    };
    Object.defineProperty(Legend.prototype, "bh", {
        get: function () {
            return this.ak.v;
        },
        set: function (a) {
            this.ak.v = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Legend.prototype, "bi", {
        get: function () {
            return this.ak.w;
        },
        set: function (a) {
            this.ak.w = a;
        },
        enumerable: true,
        configurable: true
    });
    Legend.$t = markType(Legend, 'Legend', LegendBase.$);
    return Legend;
}(LegendBase));
/**
 * @hidden
 */
var LegendView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendView, _super);
    function LegendView(a) {
        var _this = _super.call(this, a) || this;
        _this.ao = null;
        _this.ao = a;
        return _this;
    }
    LegendView.prototype.ak = function () {
        _super.prototype.ak.call(this);
    };
    LegendView.$t = markType(LegendView, 'LegendView', LegendBaseView.$);
    return LegendView;
}(LegendBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
var IgrFinancialLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFinancialLegend, _super);
    function IgrFinancialLegend(props) {
        var _this = _super.call(this, props) || this;
        var container;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this.container = ren.getWrapper(container);
        _this._wrapper = ren;
        _this.i.provideContainer(ren);
        return _this;
    }
    IgrFinancialLegend.prototype.render = function () {
        var div = createElement("div", {
            className: "ig-financial-legend igr-financial-legend",
            ref: this._getMainRef
        });
        return div;
    };
    IgrFinancialLegend.prototype._getMainRef = function (div) {
        this._elRef = div;
    };
    IgrFinancialLegend.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.initializeContent();
    };
    IgrFinancialLegend.prototype.initializeContent = function () {
        this._elRef.appendChild(this.container.getNativeElement());
    };
    IgrFinancialLegend.prototype.destroy = function () {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    };
    IgrFinancialLegend.prototype.createImplementation = function () {
        return new Legend();
    };
    Object.defineProperty(IgrFinancialLegend.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFinancialLegend.prototype, "isFinancial", {
        /**
     * Gets if the legend is a financial legend.
    */
        get: function () {
            return this.i.isFinancial;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFinancialLegend;
}(IgrLegendBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LegendTemplates = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LegendTemplates, _super);
    function LegendTemplates() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LegendTemplates.d = function (a) {
        var b = a.data;
        var c = b.series;
        var d = c.legendItemBadgeTemplate;
        if (d == null) {
            d = LegendTemplates.ab(c.bj);
        }
        var e = c.fx;
        if (e == null) {
            e = "Series Title";
        }
        LegendItemHelper.d(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo, c.aw != null && c.aw.isFinancial, c.d8, c.et);
    };
    LegendTemplates.resolveLegendItemTemplate = function (a) {
        switch (a) {
            case 0: return LegendTemplates.q;
            case 1: return LegendTemplates.r;
        }
        return LegendTemplates.q;
    };
    LegendTemplates.b = function (a) {
        var b = a.data;
        var c = b.series;
        var d = c.legendItemBadgeTemplate;
        if (d == null) {
            d = LegendTemplates.ab(c.bj);
        }
        var e = b.itemLabel;
        if (e == null) {
            e = "Series Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    };
    LegendTemplates.h = function (a) {
        var b = a.data;
        var c = a.context;
        var d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.k3;
        }
        var e = new RenderingContext(new CanvasViewRenderer(), c);
        var f = new Line();
        f.ak = 0;
        f.am = a.availableHeight / 2;
        f.al = a.availableWidth;
        f.an = a.availableHeight / 2;
        f.ac = d.ey;
        f._stroke = b.actualItemBrush;
        f.ai = d.lb;
        e.r(f);
        var g = typeCast(MarkerSeries.$, b.series);
        if (g != null && g.mi != null && g.mi.render != null) {
            b.outline = g.mw;
            b.thickness = 2;
            LegendTemplates.n(g.mi, a);
        }
    };
    LegendTemplates.n = function (a, b) {
        var c = new DataTemplateMeasureInfo();
        c.passInfo = b.passInfo;
        c.width = 11;
        c.height = 11;
        c.data = b.data;
        c.context = b.context;
        c.renderContext = b.renderContext;
        var d = b.data;
        var e = d.actualItemBrush;
        var f = d.itemBrush;
        if (typeCast(Series.$, d.series) !== null) {
            if (d.itemBrush == null) {
                var g = d.series;
                d.actualItemBrush = g.k6();
            }
        }
        if (a.measure != null) {
            a.measure(c);
            if (isNaN_(c.width) || isInfinity(c.width) || c.width > 11) {
                c.width = 11;
            }
            if (isNaN_(c.height) || isInfinity(c.height) || c.height > 11) {
                c.height = 11;
            }
        }
        var h = new DataTemplateRenderInfo();
        h.passInfo = b.passInfo;
        h.availableWidth = c.width;
        h.availableHeight = c.height;
        h.xPosition = b.availableWidth / 2;
        h.yPosition = b.availableHeight / 2;
        h.data = b.data;
        h.context = b.context;
        h.renderContext = b.renderContext;
        a.render(h);
        d.itemBrush = f;
        d.actualItemBrush = e;
    };
    LegendTemplates.p = function (a) {
        var b = null;
        if (typeCast(Series.$, a.series) !== null) {
            b = a.series;
        }
        if (a.itemBrush != null) {
            a.actualItemBrush = a.itemBrush;
        }
        else {
            if (b != null) {
                a.actualItemBrush = b.k3;
            }
            else {
                a.actualItemBrush = a.itemBrush;
            }
        }
    };
    LegendTemplates.c = function (a) {
    };
    LegendTemplates.a = function (a) {
    };
    LegendTemplates.g = function (a) {
    };
    LegendTemplates.m = function (a) {
        var b = a.data;
        var c = a.context;
        LegendTemplates.p(b);
        var d = new RenderingContext(new CanvasViewRenderer(), c);
        var e = new Path();
        var f = new PathGeometry();
        var g = new PathFigure();
        g._isFilled = true;
        var h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.k4;
            e.ai = b.series.lb;
        }
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        g._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        d.s(e);
        var i = typeCast(MarkerSeries.$, b.series);
        if (i != null && i.mi != null && i.mi.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.k4;
            }
            LegendTemplates.n(i.mi, a);
        }
    };
    LegendTemplates.j = function (a) {
        var b = a.data;
        var c = a.context;
        LegendTemplates.p(b);
        var d = new Path();
        var e = new PathGeometry();
        var f = new PathFigure();
        var g = 0;
        if (typeCast(Series.$, b.series) !== null) {
            g = b.series.ey / 2;
            d.ac = b.series.ey;
            d._stroke = b.series.k4;
            d.ai = b.series.lb;
        }
        f._isFilled = true;
        f._startPoint = { $type: Point_$type, x: g, y: 5 };
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: g, y: 14 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        f._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: g }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: g }));
        f._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: g, y: 5 };
            return $ret;
        })()));
        e.c.add(f);
        d.ak = e;
        d._fill = b.actualItemBrush;
        var h = new RenderingContext(new CanvasViewRenderer(), c);
        h.s(d);
    };
    LegendTemplates.i = function (a) {
        var b = a.data;
        var c = a.context;
        var d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.k3;
        }
        var e = new Line();
        e.ak = 0;
        e.am = a.availableHeight / 2;
        e.al = a.availableWidth;
        e.an = a.availableHeight / 2;
        e.ac = d.ey;
        e.ai = d.lb;
        e._stroke = b.actualItemBrush;
        var f = new RenderingContext(new CanvasViewRenderer(), c);
        f.r(e);
    };
    LegendTemplates.k = function (a) {
        var b = a.data;
        LegendTemplates.p(b);
        var c = typeCast(MarkerSeries.$, b.series);
        if (c != null && c.mi != null && c.mi.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.k7();
            }
            LegendTemplates.n(c.mi, a);
        }
    };
    LegendTemplates.l = function (a) {
        var b = a.data;
        var c = a.context;
        var d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.k3;
        }
        var e = new Path();
        var f = new PathGeometry();
        var g = new PathFigure();
        var h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.k4;
            e.ai = b.series.lb;
        }
        g._isFilled = true;
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        var i = new Path();
        var j = new PathGeometry();
        var k = new PathFigure();
        var l = 0;
        var m = null;
        if (typeCast(Series.$, b.series) !== null) {
            l = b.series.ey / 2;
            i.ac = b.series.ey;
            i._stroke = b.series.k4;
            m = b.series.k9();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        var n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
        var o = typeCast(MarkerSeries.$, b.series);
        if (o != null && o.mi != null && o.mi.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.k4;
            }
            LegendTemplates.n(o.mi, a);
        }
    };
    LegendTemplates.e = function (a) {
        var b = a.data;
        var c = a.context;
        var d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.k3;
        }
        var e = new Path();
        var f = new PathGeometry();
        var g = 0;
        if (typeCast(Series.$, b.series) !== null) {
            g = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.k4;
            e.ai = b.series.lb;
        }
        var h = new PathFigure();
        h._isFilled = true;
        h._startPoint = { $type: Point_$type, x: g, y: 5 };
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: g, y: 14 }));
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: g }));
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: g }));
        h._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: g, y: 5 };
            return $ret;
        })()));
        f.c.add(h);
        e.ak = f;
        e._fill = b.actualItemBrush;
        var i = new Path();
        var j = new PathGeometry();
        var k = new PathFigure();
        var l = 0;
        var m = null;
        if (typeCast(Series.$, b.series) !== null) {
            i.ac = b.series.ey;
            i._stroke = b.series.k4;
            i.ai = b.series.lb;
            m = b.series.k9();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        var n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
    };
    LegendTemplates.f = function (a) {
        var b = a.data;
        var c = a.context;
        var d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.k3;
        }
        var e = new Path();
        var f = new PathGeometry();
        var g = new PathFigure();
        var h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.k4;
            e.ai = b.series.lb;
        }
        g._isFilled = true;
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        var i = new Path();
        var j = new PathGeometry();
        var k = new PathFigure();
        var l = 0;
        var m = null;
        if (typeCast(Series.$, b.series) !== null) {
            l = b.series.ey / 2;
            i.ac = b.series.ey;
            i._stroke = b.series.k4;
            i.ai = b.series.lb;
            m = b.series.k9();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        var n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
    };
    LegendTemplates.o = function (a) {
        var b = a.data;
        var c = a.context;
        LegendTemplates.p(b);
        var d = typeCast(Series.$, b.series) !== null ? b.series : null;
        if (d != null) {
            b.outline = d.k4;
        }
        var e = new PathGeometry();
        var f = ((function () {
            var $ret = new PathFigure();
            $ret.isClosed = true;
            $ret.isFilled = true;
            return $ret;
        })());
        f._startPoint = { $type: Point_$type, x: 0, y: 0 };
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: 0 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: 16 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 0, y: 16 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 0, y: 0 }));
        e.c.add(f);
        var g = ((function () {
            var $ret = new Path();
            $ret.ak = e;
            $ret.fill = b.actualItemBrush;
            return $ret;
        })());
        var h = new RenderingContext(new CanvasViewRenderer(), c);
        h.s(g);
        h.r(((function () {
            var $ret = new Line();
            $ret.ak = 8;
            $ret.al = 8;
            $ret.am = 0;
            $ret.an = 16;
            $ret.stroke = b.outline;
            $ret.ac = 2;
            return $ret;
        })()));
    };
    LegendTemplates.ab = function (a) {
        switch (a) {
            case 0: return LegendTemplates.u;
            case 1: return LegendTemplates.z;
            case 4: return LegendTemplates.x;
            case 6: return LegendTemplates.s;
            case 7: return LegendTemplates.t;
            case 2: return LegendTemplates.v;
            case 3: return LegendTemplates.w;
            case 5: return LegendTemplates.y;
            case 8: return LegendTemplates.aa;
        }
        return LegendTemplates.z;
    };
    LegendTemplates.$t = markType(LegendTemplates, 'LegendTemplates');
    LegendTemplates.q = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.d;
        return $ret;
    })());
    LegendTemplates.r = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.a;
        $ret.render = LegendTemplates.b;
        return $ret;
    })());
    LegendTemplates.u = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.h;
        return $ret;
    })());
    LegendTemplates.z = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.m;
        return $ret;
    })());
    LegendTemplates.x = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.k;
        return $ret;
    })());
    LegendTemplates.s = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.e;
        return $ret;
    })());
    LegendTemplates.t = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.f;
        return $ret;
    })());
    LegendTemplates.v = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.j;
        return $ret;
    })());
    LegendTemplates.w = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.i;
        return $ret;
    })());
    LegendTemplates.y = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.l;
        return $ret;
    })());
    LegendTemplates.aa = ((function () {
        var $ret = new DataTemplate();
        $ret.measure = LegendTemplates.c;
        $ret.render = LegendTemplates.o;
        return $ret;
    })());
    return LegendTemplates;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialLegendViewManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialLegendViewManager, _super);
    function FinancialLegendViewManager(a) {
        return _super.call(this, a) || this;
    }
    FinancialLegendViewManager.prototype.i = function () {
        if (this.g == null) {
            return null;
        }
        var a = this.g.createElement("div");
        return a;
    };
    FinancialLegendViewManager.prototype.h = function () {
        if (this.g == null) {
            return null;
        }
        var a = this.g.createElement("span");
        a.setStyleProperty("display", "inline-block");
        a.setStyleProperty("padding", "5px 2px 5px 2px");
        a.setStyleProperty("margin", "2px");
        return a;
    };
    FinancialLegendViewManager.$t = markType(FinancialLegendViewManager, 'FinancialLegendViewManager', LegendBaseViewManager.$);
    return FinancialLegendViewManager;
}(LegendBaseViewManager));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialLegend, _super);
    function FinancialLegend() {
        var _this = _super.call(this) || this;
        _this.ab = FinancialLegend.$;
        var a = _this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) {
            var e_1, _a, e_2, _b;
            if (b.oldItems != null) {
                try {
                    for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        _this.bb.an(c);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var d = _f.value;
                        _this.bb.x(d);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        });
        return _this;
    }
    FinancialLegend.prototype.aj = function () {
        return new FinancialLegendView(this);
    };
    Object.defineProperty(FinancialLegend.prototype, "bb", {
        get: function () {
            return this.ak;
        },
        enumerable: true,
        configurable: true
    });
    FinancialLegend.prototype.addChildInOrder = function (a, b) {
        this.at.add(a);
    };
    FinancialLegend.prototype.get_isFinancial = function () {
        return true;
    };
    FinancialLegend.$t = markType(FinancialLegend, 'FinancialLegend', LegendBase.$);
    return FinancialLegend;
}(LegendBase));
/**
 * @hidden
 */
var FinancialLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialLegendView, _super);
    function FinancialLegendView(a) {
        var _this = _super.call(this, a) || this;
        _this.c = new FinancialLegendViewManager(_this);
        return _this;
    }
    FinancialLegendView.$t = markType(FinancialLegendView, 'FinancialLegendView', LegendBaseView.$);
    return FinancialLegendView;
}(LegendBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinancialLegendModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialLegendModule() {
    }
    IgrFinancialLegendModule.register = function () {
        TypeRegistrar.registerCons('IgrFinancialLegend', IgrFinancialLegend);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        TypeRegistrar.register('FinancialLegend', FinancialLegend.$type);
    };
    return IgrFinancialLegendModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrFinancialChartModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrFinancialChartModule() {
    }
    IgrFinancialChartModule.register = function () {
        IgrFinancialChartCoreModule.register();
        IgrLineSeriesModule.register();
        IgrAreaSeriesModule.register();
        IgrColumnSeriesModule.register();
        IgrNumericYAxisModule.register();
        IgrTimeXAxisModule.register();
        IgrCategoryXAxisModule.register();
        IgrOrdinalTimeXAxisModule.register();
        IgrPercentChangeYAxisModule.register();
        IgrFinancialPriceSeriesModule.register();
        IgrDataChartCategoryTrendLineModule.register();
        IgrIndicatorsModule.register();
        IgrOverlaysModule.register();
        IgrZoomSliderModule.register();
        IgrCrosshairLayerModule.register();
        IgrCalloutLayerModule.register();
        IgrItemToolTipLayerModule.register();
        IgrCategoryToolTipLayerModule.register();
        IgrCategoryHighlightLayerModule.register();
        IgrCategoryItemHighlightLayerModule.register();
        IgrFinalValueLayerModule.register();
        IgrNumberAbbreviatorModule.register();
        IgrDataChartInteractivityModule.register();
        IgrDataChartAnnotationModule.register();
        IgrFinancialLegendModule.register();
    };
    return IgrFinancialChartModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ITimeXAxis_$type = /*@__PURE__*/ new Type(null, 'ITimeXAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TemplatePicker = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TemplatePicker, _super);
    function TemplatePicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TemplatePicker.a = function (a, b) {
        if (a != null) {
            return a;
        }
        return a;
    };
    TemplatePicker.$t = markType(TemplatePicker, 'TemplatePicker');
    return TemplatePicker;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FinancialChartEnumCollectionPickerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartEnumCollectionPickerVisualData, _super);
    function FinancialChartEnumCollectionPickerVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.k = 0;
        _this.l = 0;
        _this.m = 0;
        _this.j = 0;
        _this.f = 0;
        _this.g = 0;
        _this.h = 0;
        _this.e = 0;
        _this.n = 0;
        _this.i = 0;
        _this.d = false;
        _this.c = false;
        return _this;
    }
    FinancialChartEnumCollectionPickerVisualData.prototype.o = function () {
        return FinancialChartVisualData.y(["items", "selectedItems", "pickerLeft", "pickerTop", "pickerWidth", "pickerHeight", "buttonLeft", "buttonTop", "buttonWidth", "buttonHeight", "width", "height", "isVisible", "isPickerVisible"], [this.a, this.b, this.k, this.l, this.m, this.j, this.f, this.g, this.h, this.e, this.n, this.i, this.d, this.c]);
    };
    FinancialChartEnumCollectionPickerVisualData.$t = markType(FinancialChartEnumCollectionPickerVisualData, 'FinancialChartEnumCollectionPickerVisualData');
    return FinancialChartEnumCollectionPickerVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHorizontalRangeCategorySeriesProxy_$type = /*@__PURE__*/ new Type(null, 'IHorizontalRangeCategorySeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IHasHighLowValueCategory_$type = /*@__PURE__*/ new Type(null, 'IHasHighLowValueCategory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultHighLowValueProvider = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultHighLowValueProvider, _super);
    function DefaultHighLowValueProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefaultHighLowValueProvider.prototype, "highColumn", {
        get: function () {
            return new List$1(Number_$type, 0);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DefaultHighLowValueProvider.prototype, "lowColumn", {
        get: function () {
            return new List$1(Number_$type, 0);
        },
        enumerable: true,
        configurable: true
    });
    DefaultHighLowValueProvider.$t = markType(DefaultHighLowValueProvider, 'DefaultHighLowValueProvider', Base.$, [IHasHighLowValueCategory_$type]);
    return DefaultHighLowValueProvider;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HighLowValuesHolder = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighLowValuesHolder, _super);
    function HighLowValuesHolder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = null;
        _this.g = null;
        return _this;
    }
    HighLowValuesHolder.prototype.get_e = function () {
        if (this.f == null || this.g == null) {
            return 0;
        }
        return Math.min(this.f.count, this.g.count);
    };
    Object.defineProperty(HighLowValuesHolder.prototype, "e", {
        get: function () {
            return this.get_e();
        },
        enumerable: true,
        configurable: true
    });
    HighLowValuesHolder.$t = markType(HighLowValuesHolder, 'HighLowValuesHolder', ValuesHolder.$);
    return HighLowValuesHolder;
}(ValuesHolder));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeCategoryFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeCategoryFramePreparer, _super);
    function RangeCategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = null;
                        _this.ab = null;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ab = new DefaultHighLowValueProvider();
                        if (typeCast(IHasHighLowValueCategory_$type, f) !== null) {
                            _this.ab = typeCast(IHasHighLowValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = null;
                    _this.ab = null;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ab = new DefaultHighLowValueProvider();
                    if (typeCast(IHasHighLowValueCategory_$type, c) !== null) {
                        _this.ab = typeCast(IHasHighLowValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    RangeCategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = b[2];
        if (!isNaN_(g) && !isNaN_(h) && !isNaN_(i)) {
            a.m.add({ $type: Point_$type, x: g, y: (h + i) / 2 });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    RangeCategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = e.g;
        var h = f.item(b);
        var i = g.item(b);
        var j = Math.max(h, i);
        var k = Math.min(h, i);
        if (c) {
            e.c = k;
            e.d = j;
        }
        else {
            e.b = j;
            e.a = k;
        }
    };
    RangeCategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        var f = d.g;
        var g = e.item(b);
        var h = f.item(b);
        if (!isNaN_(g)) {
            d.b = Math.max(d.b, g);
            d.a = Math.min(d.a, g);
        }
        if (!isNaN_(h)) {
            d.b = Math.max(d.b, h);
            d.a = Math.min(d.a, h);
        }
    };
    RangeCategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    RangeCategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        b[2] = a.c.j$b(b[2], f);
    };
    RangeCategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        n.add(2);
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (var p = 0; p < l; p++) {
                k._inner[p][0] = k._inner[p][0] + b;
            }
        }
    };
    RangeCategoryFramePreparer.prototype.j = function (a) {
        var b = new HighLowValuesHolder();
        b.f = this.ab.highColumn;
        b.g = this.ab.lowColumn;
        return b;
    };
    RangeCategoryFramePreparer.$t = markType(RangeCategoryFramePreparer, 'RangeCategoryFramePreparer', CategoryFramePreparerBase.$);
    return RangeCategoryFramePreparer;
}(CategoryFramePreparerBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeCategoryBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeCategoryBucketCalculator, _super);
    function RangeCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.j = null;
        _this.l = 0;
        _this.k = 0;
        _this.i = null;
        _this.h = null;
        _this.j = a;
        return _this;
    }
    RangeCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = false;
        var c = this.i;
        var d = this.h;
        var e = this.l;
        var f = this.k;
        var g = Math.min(e, f);
        var h = a * this.d;
        var i = Math.min(h + this.d - 1, g - 1);
        var j = 1.7976931348623157E+308;
        var k = -1.7976931348623157E+308;
        var l = true;
        var m = 0;
        var n = 0;
        var o;
        var p;
        for (var q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                j = j < o ? j : o;
                k = k > o ? k : o;
                j = j < p ? j : p;
                k = k > p ? k : p;
            }
            else {
                j = Math.min(j, o);
                k = Math.max(k, o);
                k = Math.max(k, p);
                j = Math.min(j, p);
                l = false;
            }
        }
        if (b && n < m) {
            var r = j;
            j = k;
            k = r;
        }
        if (!l) {
            var s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        var t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    };
    RangeCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = false;
        var c = this.i;
        var d = this.h;
        var e = this.l;
        var f = this.k;
        var g = Math.min(e, f);
        var h = a * this.d;
        var i = Math.min(h + this.d - 1, g - 1);
        var j = NaN;
        var k = NaN;
        var l = true;
        var m = 0;
        var n = 0;
        var o;
        var p;
        for (var q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                if (!isNaN_(o)) {
                    j = j < o ? j : o;
                    k = k > o ? k : o;
                }
                if (!isNaN_(p)) {
                    j = j < p ? j : p;
                    k = k > p ? k : p;
                }
            }
            else {
                if (!isNaN_(o)) {
                    if (isNaN_(j)) {
                        j = o;
                    }
                    else {
                        j = Math.min(j, o);
                    }
                    if (!isNaN_(k)) {
                        k = Math.max(k, o);
                    }
                }
                if (!isNaN_(p)) {
                    if (isNaN_(k)) {
                        k = p;
                    }
                    else {
                        k = Math.max(k, p);
                    }
                    if (!isNaN_(j)) {
                        j = Math.min(j, p);
                    }
                }
                if (!isNaN_(j) && !isNaN_(k)) {
                    l = false;
                }
            }
        }
        if (n < m && b) {
            var r = j;
            j = k;
            k = r;
        }
        if (!l) {
            var s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        var t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    };
    RangeCategoryBucketCalculator.prototype.cacheValues = function () {
        this.l = this.j.cw.lowColumn.count;
        this.k = this.j.cw.highColumn.count;
        this.i = this.j.cw.lowColumn.asArray();
        this.h = this.j.cw.highColumn.asArray();
    };
    RangeCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.i = null;
        this.h = null;
    };
    RangeCategoryBucketCalculator.$t = markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
    return RangeCategoryBucketCalculator;
}(CategoryBucketCalculator));
/**
 * @hidden
 */
var RangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeCategorySeries, _super);
    function RangeCategorySeries() {
        var _this = _super.call(this) || this;
        _this._RangeFramePreparer = null;
        _this.o0 = null;
        _this.oy = null;
        _this.ov = null;
        _this.RangeFramePreparer = new RangeCategoryFramePreparer(1, _this, _this.ox, _this, _this, _this.ox.cn);
        return _this;
    }
    RangeCategorySeries.prototype.bf = function () {
        return new RangeCategorySeriesView(this);
    };
    RangeCategorySeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    RangeCategorySeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.ox = a;
    };
    Object.defineProperty(RangeCategorySeries.prototype, "RangeFramePreparer", {
        get: function () {
            return this._RangeFramePreparer;
        },
        set: function (a) {
            this._RangeFramePreparer = a;
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == RangeCategorySeries.$$p[0]) {
            return this.ft(a, b, this.o3);
        }
        if (c == RangeCategorySeries.$$p[0]) {
            return this.ft(a, b, this.o3);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(RangeCategorySeries.prototype, "lowColumn", {
        get: function () {
            return this.o0;
        },
        set: function (a) {
            if (this.o0 != a) {
                var b = this.o0;
                this.o0 = a;
                this.raisePropertyChanged("LowColumn", b, this.o0);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "highColumn", {
        get: function () {
            return this.oy;
        },
        set: function (a) {
            if (this.oy != a) {
                var b = this.oy;
                this.oy = a;
                this.raisePropertyChanged("HighColumn", b, this.oy);
            }
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.ng = function () {
        return 11;
    };
    RangeCategorySeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        b.b0 = true;
        CategoryMarkerManager.b(this, a.m, b.cq, this.l5);
        this.oi(b, a);
    };
    RangeCategorySeries.prototype.o8 = function (a, b, c, d, e, f) {
        this.ox.cx(a, b, c, d, e, f);
    };
    RangeCategorySeries.prototype.c9 = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.bi != null ? this.bi.bs : Rect.empty;
        c = c.copy();
        var d = this.bi != null ? this.bi.br : Rect.empty;
        var e = !c.isEmpty && !d.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        var f = this.fetchXAxis();
        var g = this.fetchYAxis();
        var h = this.ls(this.bi);
        var i;
        if (f != null) {
            var j = new ScalerParams(0, b, b, f.b8, h);
            i = f.dw(e, j);
        }
        else {
            i = NaN;
        }
        var k = f != null ? this.RangeFramePreparer.r(typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
        i += k;
        if (e >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (!isNaN_(i)) {
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (g != null && this.highColumn != null && e < this.highColumn.count) {
                var l = new ScalerParams(0, b, b, g.b8, h);
                l.b = this.eh();
                var m = g.dw(this.highColumn.item(e), l);
                var n = g.dw(this.lowColumn.item(e), l);
                if (!isNaN_(m) && !isNaN_(n)) {
                    var o = Math.abs(n - m);
                    if (c.height < o) {
                        c.height = o;
                        c.y = Math.min(n, m);
                    }
                    else {
                        if (n < c.top + 0.1 * c.height) {
                            n = n + 0.4 * c.height;
                        }
                        if (n > c.bottom - 0.1 * c.height) {
                            n = n - 0.4 * c.height;
                        }
                        c.y = n - 0.5 * c.height;
                    }
                }
            }
            if (this.bn != null) {
                this.bn.ap(this.bs, c, true);
            }
        }
        return e >= 0;
    };
    RangeCategorySeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.lowColumn);
                    c.deregisterColumn(this.highColumn);
                    this.lowColumn = null;
                    this.highColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.lowColumn = this.bw(this.o6);
                    this.highColumn = this.bw(this.o3);
                }
                if (!this.n1()) {
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case RangeCategorySeries.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.lowColumn);
                    this.lowColumn = this.bw(this.o6);
                }
                break;
            case "LowColumn":
                if (!this.n1()) {
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case RangeCategorySeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.highColumn);
                    this.highColumn = this.bw(this.o3);
                }
                break;
            case "HighColumn":
                if (!this.n1()) {
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                }
                break;
        }
    };
    RangeCategorySeries.prototype.an = function (a) {
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            var b = Math.min(this.lowColumn.count, this.highColumn.count);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            var c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
            var d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
            return new AxisRange(Math.min(c, d), Math.max(c, d));
        }
        return null;
    };
    RangeCategorySeries.prototype.hy = function (a, b, c, d) {
        if (this.fetchXAxis() != null && typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
            this.fetchXAxis().i$i();
        }
        var e = this.fetchXAxis();
        switch (a) {
            case 3:
                if (d == this.o6 || d == this.o3) {
                    if (e != null) {
                        e.cl();
                    }
                    if (!this.n1()) {
                        this.jd(true);
                    }
                }
                break;
            case 1:
                if (e != null) {
                    e.cl();
                }
                this.nf.cn.g(this.eu);
                if (!this.n1()) {
                    this.jd(true);
                }
                break;
            case 0:
                if (e != null) {
                    e.cl();
                }
                this.nf.cn.g(this.eu);
                if (!this.n1()) {
                    this.jd(true);
                }
                break;
            case 2:
                if (e != null) {
                    e.cl();
                }
                if (this.o6 != null && this.o3 != null && this.nf.cn.d > 0 && !this.n1()) {
                    this.jd(true);
                }
                break;
            case 4:
                if (e != null) {
                    e.cl();
                }
                this.nf.cn.g(this.eu);
                if (!this.n1()) {
                    this.jd(true);
                }
                break;
        }
    };
    RangeCategorySeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            d = false;
        }
        return d;
    };
    RangeCategorySeries.prototype.ol = function (a, b) {
        _super.prototype.ol.call(this, a, b);
        this.RangeFramePreparer.d(a, b);
    };
    Object.defineProperty(RangeCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.nf.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.n9();
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.provideCollisionDetector = function () {
        return new CollisionAvoider();
    };
    Object.defineProperty(RangeCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.jf = function (a, b) {
        var c = this.dl;
        _super.prototype.jf.call(this, a, b);
        if (!c) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var d = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, this.bh), this.bs.bn.m, this, this.bh.cn);
        if (!this.df) {
            this.m9 = new CategoryFrame(3);
            this.m9.u();
            d.d(this.m9, this.bh);
        }
        this.df = false;
        this.oo(this.m9, this.bh);
        this.dl = false;
    };
    RangeCategorySeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.cn.g(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        var h = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, f), f, this, f.cn);
        if (this.ov == null) {
            this.ov = new CategoryFrame(3);
        }
        this.ov.u();
        h.d(this.ov, g);
        this.oo(this.ov, g);
    };
    RangeCategorySeries.prototype.eh = function () {
        return Series.ei(this.lowColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    };
    Object.defineProperty(RangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.$t = markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
    RangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:o3:o9', [2, null], 'LowMemberPath:o6:pa', [2, null]]);
    return RangeCategorySeries;
}(CategorySeries));
/**
 * @hidden
 */
var RangeCategorySeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeCategorySeriesView, _super);
    function RangeCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cw = a;
        return _this;
    }
    RangeCategorySeriesView.prototype.cx = function (a, b, c, d, e, f) {
        a.ak.clear();
        b.ak.clear();
        c.ak.clear();
        var g = FastFlattener.b(d, e, true, f, this.e.eu);
        var h = FastFlattener.b(d, e, false, f, this.e.eu);
        var i = g.count;
        var j = h.count;
        var k;
        var l;
        var m;
        var n;
        for (var o = 0; o < i; o++) {
            k = g.item(o);
            l = e._inner[k];
            m = l[0];
            n = l[1];
            a.ak.add({ $type: Point_$type, x: m, y: n });
            b.ak.add({ $type: Point_$type, x: m, y: n });
        }
        var p;
        var q;
        for (var r = 0; r < j; r++) {
            k = h.item(r);
            l = e._inner[k];
            if (f) {
                p = l[0];
                q = l[2];
            }
            else {
                p = l[2];
                q = l[3];
            }
            c.ak.add({ $type: Point_$type, x: p, y: q });
            b.ak.add({ $type: Point_$type, x: p, y: q });
        }
        a.ab = a.ak.count > 0;
        b.ab = b.ak.count > 0;
        c.ab = c.ak.count > 0;
    };
    RangeCategorySeriesView.prototype.co = function () {
        return new RangeCategoryBucketCalculator(this);
    };
    RangeCategorySeriesView.$t = markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);
    return RangeCategorySeriesView;
}(CategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.ah = function (a) {
        var b = this.aj(this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), this.lo(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ai = function (a) {
        var b = this.aj(this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), this.lo(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_c3 = function () {
        return true;
    };
    HorizontalRangeCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalRangeCategorySeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.xAxis, runOn(this, this.n5), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.xAxis, runOn(this, this.n5), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.d9 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.jy;
        return this.ea(a, b, this.xAxis, d, e, f, runOn(this, this.n5));
    };
    HorizontalRangeCategorySeries.prototype.en = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.ep(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.n5), b, c);
    };
    HorizontalRangeCategorySeries.prototype.el = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.ep(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.n5), b, c);
    };
    HorizontalRangeCategorySeries.prototype.ej = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mq, this.bi.br, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mq, this.bi.br, d);
        return this.ep(this.highColumn, a, this.xAxis, e, f, runOn(this, this.n5), b, c);
    };
    HorizontalRangeCategorySeries.prototype.lh = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ej), function (d, e) { return _this.ff(d, e, _this.xAxis, runOn(_this, _this.n5), _this.highColumn); }, function (d, e) { return _this.fd(d, e, _this.xAxis, runOn(_this, _this.n5), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.lj = function (a, b, c) {
        var _this = this;
        return this.ln(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.el), function (d, e) { return _this.ff(d, e, _this.xAxis, runOn(_this, _this.n5), _this.lowColumn); }, function (d, e) { return _this.fd(d, e, _this.xAxis, runOn(_this, _this.n5), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.ll = function (a, b, c) {
        return this.ln(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.n1 = function () {
        return this.yAxis != null && this.yAxis.cl();
    };
    HorizontalRangeCategorySeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hz(typeCast(Axis.$, c));
                this.i4(typeCast(Axis.$, d));
                this.nf.cn.g(this.eu);
                this.jd(false);
                this.ik();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hz(typeCast(Axis.$, c));
                this.i4(typeCast(Axis.$, d));
                this.nf.cn.g(this.eu);
                this.n1();
                this.jd(false);
                this.ik();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.pe = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.pd = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::ph', [CategoryAxisBase.$, null], 'YAxis::pi', [NumericYAxis.$, null]]);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalRangeCategorySeriesProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalRangeCategorySeriesProxy, _super);
    function HorizontalRangeCategorySeriesProxy() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeriesProxy.prototype.matchesType = function (a) {
        return typeCast(HorizontalRangeCategorySeries.$, a) !== null;
    };
    HorizontalRangeCategorySeriesProxy.prototype.setHighMemberPath = function (a, b) {
        a.o3 = b;
    };
    HorizontalRangeCategorySeriesProxy.prototype.setLowMemberPath = function (a, b) {
        a.o6 = b;
    };
    HorizontalRangeCategorySeriesProxy.prototype.setXAxis = function (a, b) {
        a.xAxis = b;
    };
    HorizontalRangeCategorySeriesProxy.prototype.setYAxis = function (a, b) {
        a.yAxis = b;
    };
    HorizontalRangeCategorySeriesProxy.$t = markType(HorizontalRangeCategorySeriesProxy, 'HorizontalRangeCategorySeriesProxy', Base.$, [IHorizontalRangeCategorySeriesProxy_$type]);
    return HorizontalRangeCategorySeriesProxy;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrHorizontalRangeCategorySeriesProxyModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrHorizontalRangeCategorySeriesProxyModule() {
    }
    IgrHorizontalRangeCategorySeriesProxyModule.register = function () {
        TypeRegistrar.register('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy.$type);
    };
    return IgrHorizontalRangeCategorySeriesProxyModule;
}());

/**
 * Represents the base class for all IgxDataChartComponent ranged category/value series.
*
* The `IgrRangeCategorySeries` represents the base class for all IgxDataChartComponent ranged category/value series.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series1 = new IgrRangeColumnSeries({ name: "series1" });
* series1.highMemberPath = "High";
* series1.lowMemberPath  = "Low";
* series1.xAxisName = "xAxis";
* series1.yAxisName = "yAxis";
* this.chart.series.add(series1);
* ```
*/
var IgrRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRangeCategorySeries, _super);
    function IgrRangeCategorySeries(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrRangeCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRangeCategorySeries.prototype, "lowMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        *
        * The `lowMemberPath` is used for low mapping property of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRangeColumnSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * const series1 = new IgrRangeColumnSeries({ name: "series1" });
        * series1.highMemberPath = "High";
        * series1.lowMemberPath  = "Low";
        * ```
        */
        get: function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRangeCategorySeries.prototype, "highMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        *
        * Use `highMemberPath` propert for high mapping of the current series object.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRangeColumnSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.highMemberPath = "high";
        * ```
        *
        * ```ts
        * const series1 = new IgrRangeColumnSeries({ name: "series1" });
        * series1.highMemberPath = "High";
        * series1.lowMemberPath  = "Low";
        * ```
        */
        get: function () {
            return this.i.o3;
        },
        set: function (v) {
            this.i.o3 = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrRangeCategorySeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * `scrollIntoView` method Scrolls the series to display the item for the specified data item.
    */
    IgrRangeCategorySeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    return IgrRangeCategorySeries;
}(IgrCategorySeries));

/**
 * Base class for ranged category series with a category X-axis and a numeric Y-axis.
*
* Instantiate HorizontalAnchoredCategorySeries
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrColumnSeries
*      name="series1"
*     xAxisName="xAxis"
* 	yAxisName="yAxis"
* 	valueMemberPath="Value" />
*  </IgrDataChart>
* ```
*
* ```ts
* this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
* this.columnSeries1.dataSource = this.categoryData;
* this.columnSeries1.xAxis = this.categoryXAxis;
* this.columnSeries1.yAxis = this.numericYAxis;
* this.columnSeries1.xAxisName = "categoryXAxis";
* this.columnSeries1.yAxisName = "numericYAxis";
* this.columnSeries1.valueMemberPath = "USA";
* ```
*/
var IgrHorizontalRangeCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHorizontalRangeCategorySeries, _super);
    function IgrHorizontalRangeCategorySeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current CategorySeries object.
        *
        * Instantiate xAxis
        *
        * ```ts
        * this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
        * this.columnSeries1.dataSource = this.categoryData;
        * this.columnSeries1.xAxis = this.categoryXAxis;
        * this.columnSeries1.yAxis = this.numericYAxis;
        * this.columnSeries1.xAxisName = "categoryXAxis";
        * this.columnSeries1.yAxisName = "numericYAxis";
        * this.columnSeries1.valueMemberPath = "USA";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current CategorySeries object.
        *
        * Instantiate yAxis
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * this.columnSeries1 = new IgrColumnSeries({ name: "colSeries1" });
        * this.columnSeries1.dataSource = this.categoryData;
        * this.columnSeries1.xAxis = this.categoryXAxis;
        * this.columnSeries1.yAxis = this.numericYAxis;
        * this.columnSeries1.xAxisName = "categoryXAxis";
        * this.columnSeries1.yAxisName = "numericYAxis";
        * this.columnSeries1.valueMemberPath = "USA";
        * ```
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalRangeCategorySeries.prototype, "isRange", {
        /**
         * Checks if this series is a range series
        *
        * You can use the `isRange` to get the current series is a range type series.
        *
        * <!-- Angular JS -->
        *
        * ```ts
        *   var r = this.series.isRange;
        * ```
        */
        get: function () {
            return this.i.c3;
        },
        enumerable: true,
        configurable: true
    });
    IgrHorizontalRangeCategorySeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrHorizontalRangeCategorySeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
    *
    * <!-- Angular JS -->
    *
    *       var g = series.getOffsetValue();
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    IgrHorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lh(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lj(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgrHorizontalRangeCategorySeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
    */
    IgrHorizontalRangeCategorySeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.pe(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    */
    IgrHorizontalRangeCategorySeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.pd(axis);
        return (iv);
    };
    return IgrHorizontalRangeCategorySeries;
}(IgrRangeCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeAreaSeries, _super);
    function RangeAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RangeAreaSeries.$;
        return _this;
    }
    RangeAreaSeries.prototype.bf = function () {
        return new RangeAreaSeriesView(this);
    };
    RangeAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pj = a;
    };
    RangeAreaSeries.prototype.get_ck = function () {
        return true;
    };
    RangeAreaSeries.prototype.pk = function (a, b, c, d) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        if (isNaN_(c.x) || isNaN_(c.y)) {
            return false;
        }
        if ((a.y <= b.y && a.y >= c.y)) {
            return true;
        }
        return false;
    };
    RangeAreaSeries.prototype.dh = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    RangeAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    RangeAreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.cz();
    };
    RangeAreaSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = a.f.count;
        var d = new List$1(Array_$type, 2, c);
        for (var e = 0; e < c; e++) {
            var f = a.f._inner[e];
            var g = new Array(4);
            g[0] = f[0];
            g[1] = f[1];
            var h = a.f._inner[a.f.count - 1 - e];
            g[2] = h[0];
            g[3] = h[2];
            d.add(g);
        }
        var i = typeCast(RangeAreaSeriesView.$, b);
        var j = this.getEffectiveViewport1(i);
        this.ne.x(this, this.nz(), this.xAxis, runOn(this, this.m0), this.n7(b), this.n8(b));
        var k = false;
        var l = this.ne.c;
        if (l != null) {
            k = true;
        }
        if (k) {
            var m = new ScalerParams(0, b.bs, b.br, this.xAxis.b8, j);
            this.ok(d, -1, this.lowColumn.count, this.xAxis, m, b.n);
        }
        var n = i.c7;
        var o = i.c9;
        var p = i.c3;
        this.ne.ae(n, true, false, true, true);
        this.ne.ae(o, true, false, true, true);
        this.ne.ae(p, false, true, false, false);
        if (b.cr(a)) {
            i.c0(a.f.count, d, false);
            b.cu(a);
        }
        i.c3._opacity = this.ne.i * this.d6;
    };
    Object.defineProperty(RangeAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    RangeAreaSeries.$t = markType(RangeAreaSeries, 'RangeAreaSeries', HorizontalRangeCategorySeries.$);
    return RangeAreaSeries;
}(HorizontalRangeCategorySeries));
/**
 * @hidden
 */
var RangeAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeAreaSeriesView, _super);
    function RangeAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.c6 = new Polyline();
        _this.c2 = new Polygon();
        _this.c8 = new Polyline();
        _this.c5 = new Polyline();
        _this.c4 = new Polyline();
        _this.c1 = new Polygon();
        _this.cy = a;
        return _this;
    }
    RangeAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(RangeAreaSeriesView.prototype, "c7", {
        get: function () {
            return this.c6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeAreaSeriesView.prototype, "c3", {
        get: function () {
            return this.c2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeAreaSeriesView.prototype, "c9", {
        get: function () {
            return this.c8;
        },
        enumerable: true,
        configurable: true
    });
    RangeAreaSeriesView.prototype.cz = function () {
        this.c2.ak.clear();
        this.c6.ak.clear();
        this.c8.ak.clear();
    };
    RangeAreaSeriesView.prototype.c0 = function (a, b, c) {
        this.cx(this.c6, this.c2, this.c8, a, b, c);
        this.an();
    };
    RangeAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.c4.ak = this.c6.ak;
        this.c5.ak = this.c8.ak;
        this.c1.ak = this.c2.ak;
        var a = this.bl();
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
        this.c5._stroke = a;
        this.c5.ac = this.e.ey + 3;
        this.c1._fill = a;
        this.c1._opacity = 1;
    };
    RangeAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.t(this.c1);
                a.u(this.c4);
                a.u(this.c5);
            }
            else {
                a.t(this.c2);
                a.u(this.c6);
                a.u(this.c8);
            }
        }
    };
    RangeAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPolylineData(a, this.c6, "lowerShape", ["Lower"]);
        this.e.a2.exportPolylineData(a, this.c8, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPolygonData(a, this.c2, "fillShape", ["Fill"]);
    };
    RangeAreaSeriesView.$t = markType(RangeAreaSeriesView, 'RangeAreaSeriesView', RangeCategorySeriesView.$);
    return RangeAreaSeriesView;
}(RangeCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent range area series.
*
* The `IgrRangeAreaSeries` class represents the range area series of the IgxDataChartComponent.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeAreaSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* let series = new IgrRangeAreaSeries({name:"series1"});
* series.xAxisName = this.xAxis;
* series.yAxisName = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* ```
*/
var IgrRangeAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRangeAreaSeries, _super);
    function IgrRangeAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRangeAreaSeries.prototype.createImplementation = function () {
        return new RangeAreaSeries();
    };
    Object.defineProperty(IgrRangeAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRangeAreaSeries.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        *
        * Use the `isAreaOrLine` property to check if the current series shows an area or line shape.
        *
        * ```ts
        * var x= series.isAreaOrLine;
        * ```
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrRangeAreaSeries;
}(IgrHorizontalRangeCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRangeAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRangeAreaSeriesModule() {
    }
    IgrRangeAreaSeriesModule.register = function () {
        IgrHorizontalRangeCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrRangeAreaSeries", IgrRangeAreaSeries);
        TypeRegistrar.register("RangeAreaSeries", RangeAreaSeries.$type);
    };
    return IgrRangeAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RangeColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeColumnSeries, _super);
    function RangeColumnSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RangeColumnSeries.$;
        return _this;
    }
    RangeColumnSeries.prototype.bf = function () {
        return new RangeColumnSeriesView(this);
    };
    RangeColumnSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pj = a;
    };
    RangeColumnSeries.prototype.get_nv = function () {
        return true;
    };
    RangeColumnSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    RangeColumnSeries.prototype.lu = function (a) {
        if (this.xAxis == null || this.yAxis == null) {
            return Rect.empty;
        }
        var b = this.lg(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = new ScalerParams(0, c, d, this.yAxis.b8, e);
        f.b = this.eh();
        var g = this.aj(this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.xAxis.jr(c, d, e);
        if (j < k) {
            var m = h[0] - 0.5 * l;
            var n = h[1];
            var o = h[2];
            return new Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
        }
        else {
            var p = i[0] - 0.5 * l;
            var q = i[1];
            var r = i[2];
            return new Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
        }
    };
    RangeColumnSeries.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    RangeColumnSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a && c.cz != null) {
            c.cz.count = 0;
        }
    };
    RangeColumnSeries.prototype.eg = function () {
        return this.xAxis.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    RangeColumnSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = typeCast(RangeColumnSeriesView.$, b);
        var d = a.f;
        var e = b.bs;
        var f = b.br;
        var g = this.getEffectiveViewport1(b);
        var h = this.xAxis.jr(e, f, g);
        if (isNaN_(h) || isInfinity(h)) {
            c.cz.count = 0;
            return;
        }
        this.ne.x(this, this.nz(), this.xAxis, runOn(this, this.m0), this.n7(b), this.n8(b));
        this.ne.p = this.pk;
        this.ne.q = this.pl;
        this.ne.j = this.pk;
        this.ne.k = this.pl;
        var i = false;
        var j = this.ne.c;
        if (j != null) {
            i = true;
        }
        var k = this.xAxis.cd;
        var l = this.lowColumn.count;
        var m = this.xAxis;
        var n = new ScalerParams(0, e, f, this.xAxis.b8, g);
        var o = 0;
        for (var p = 0; p < d.count; ++p) {
            var q = d._inner[p][0] - 0.5 * h;
            var r = Math.min(d._inner[p][1], d._inner[p][2]);
            var s = Math.max(d._inner[p][1], d._inner[p][2]);
            var t = Math.abs(s - r);
            if (isInfinity(t)) {
                continue;
            }
            var u = c.cz.item(o);
            o++;
            u.width = h;
            u.height = t;
            if (i) {
                this.ok(d, p, l, m, n, b.n);
            }
            this.ne.ae(u, false, false, false, false);
            u.am = this.ne.j;
            u.an = this.ne.k;
            c.c4(u, q, r);
        }
        c.cz.count = o;
        b.cu(a);
    };
    Object.defineProperty(RangeColumnSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    RangeColumnSeries.$t = markType(RangeColumnSeries, 'RangeColumnSeries', HorizontalRangeCategorySeries.$);
    RangeColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeColumnSeries, 'raisePropertyChanged', ['RadiusX:pk:po', [1, 2], 'RadiusY:pl:pp', [1, 2]]);
    return RangeColumnSeries;
}(HorizontalRangeCategorySeries));
/**
 * @hidden
 */
var RangeColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeColumnSeriesView, _super);
    function RangeColumnSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.cz = null;
        _this.c0 = null;
        _this.c5 = new Rectangle();
        _this.cy = a;
        _this.cz = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.c6);
            $ret.activate = runOn(_this, _this.c1);
            $ret.disactivate = runOn(_this, _this.c3);
            $ret.destroy = runOn(_this, _this.c2);
            return $ret;
        })());
        return _this;
    }
    RangeColumnSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.c0 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    RangeColumnSeriesView.prototype.c6 = function () {
        var a = new Rectangle();
        this.c0.add(a);
        a._visibility = 1;
        return a;
    };
    RangeColumnSeriesView.prototype.c1 = function (a) {
        a._visibility = 0;
    };
    RangeColumnSeriesView.prototype.c3 = function (a) {
        a._visibility = 1;
    };
    RangeColumnSeriesView.prototype.c2 = function (a) {
        this.c0.remove(a);
    };
    RangeColumnSeriesView.prototype.c4 = function (a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    };
    RangeColumnSeriesView.prototype.z = function (a) {
        return this.c0._inner[a];
    };
    RangeColumnSeriesView.prototype.y = function (a) {
        var b = this.c0._inner[a];
        this.c5._visibility = b._visibility;
        this.c5.n = b.n;
        this.c5.o = b.o;
        this.c5.width = b.width;
        this.c5.height = b.height;
        var c = this.bm(a);
        this.c5._fill = c;
        this.c5._stroke = c;
        this.c5.ac = this.e.ey + 3;
        return this.c5;
    };
    RangeColumnSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.c0.count; c++) {
                var d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    RangeColumnSeriesView.prototype.ai = function (a) {
        var e_1, _a, e_2, _b;
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.cz.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        b++;
    };
    RangeColumnSeriesView.$t = markType(RangeColumnSeriesView, 'RangeColumnSeriesView', RangeCategorySeriesView.$);
    return RangeColumnSeriesView;
}(RangeCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent range column series.
*
* The `IgrRangeColumnSeries` class represents range column series of the IgxDataChartComponent.
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low" />
*  </IgrDataChart>
* ```
*
* ```ts
* const series1 = new IgrRangeColumnSeries({ name: "series1" });
* series1.highMemberPath = "High";
* series1.lowMemberPath  = "Low";
* series1.xAxisName = "xAxis";
* series1.yAxisName = "yAxis";
* this.chart.series.add(series1);
* ```
*/
var IgrRangeColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRangeColumnSeries, _super);
    function IgrRangeColumnSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRangeColumnSeries.prototype.createImplementation = function () {
        return new RangeColumnSeries();
    };
    Object.defineProperty(IgrRangeColumnSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRangeColumnSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        *
        * Use the `radiusX` property to round the corners of the column.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRangeColumnSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		radiusX={10} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.radiusX=10;
        * ```
        */
        get: function () {
            return this.i.pk;
        },
        set: function (v) {
            this.i.pk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRangeColumnSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        *
        * Use the `radiusY` property for the y-radius of the ellipse that is used to round the corners of the column.
        *
        * ```ts
        * <IgrDataChart
        *     dataSource={this.state.dataSource}
        *     width="700px"
        *     height="500px">
        *
        *     <IgrCategoryXAxis name="xAxis" label="Year" />
        *     <IgrNumericYAxis  name="yAxis" />
        *
        *     <IgrRangeColumnSeries
        *         name="series1"
        *         xAxisName="xAxis"
        *         yAxisName="yAxis"
        *         highMemberPath="High"
        *         lowMemberPath="Low"
        * 		radiusY={10} />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * series.radiusY=10;
        * ```
        */
        get: function () {
            return this.i.pl;
        },
        set: function (v) {
            this.i.pl = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method return the best available value of the bounding box within the series.
    */
    IgrRangeColumnSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * The `getItemSpan` method returns the current width of the items within the categories.
    *
    * ```ts
    * var x =series.getItemSpan();
    * ```
    */
    IgrRangeColumnSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrRangeColumnSeries;
}(IgrHorizontalRangeCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRangeColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRangeColumnSeriesModule() {
    }
    IgrRangeColumnSeriesModule.register = function () {
        IgrHorizontalRangeCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrRangeColumnSeries", IgrRangeColumnSeries);
        TypeRegistrar.register("RangeColumnSeries", RangeColumnSeries.$type);
    };
    return IgrRangeColumnSeriesModule;
}());

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
var IgrChartCursorEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrChartCursorEventArgs() {
    }
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrChartCursorEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrChartCursorEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChartCursorEventArgs.prototype, "seriesViewer", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            if (this.i.seriesViewer == null) {
                return null;
            }
            return this.i.seriesViewer.externalObject;
        },
        set: function (v) {
            v == null ? this.i.seriesViewer = null : this.i.seriesViewer = v.i;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    IgrChartCursorEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    return IgrChartCursorEventArgs;
}());

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*
* `DataChartMouseButtonEventHandler` class represents the method that will handle IgxDataChartComponent mouse button related events.
*
* ```ts
* this.chart.seriesMouseLeftButtonDown.subscribe(this.chart_seriesMouseLeftButtonDown);
* chart_seriesMouseLeftButtonDown(sender :any,args: DataChartMouseButtonEventArgs )
*   {
*   }
* ```
*/
var IgrDataChartMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartMouseButtonEventArgs() {
    }
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrDataChartMouseButtonEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrDataChartMouseButtonEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "handled", {
        /**
         * Gets or sets a value that indicates the present state of the event handling for a routed
         * event as it travels the route.
         * ChartMouseButton events are not routed events; setting this property effects the underlying
         * MouseButtonEvent.
        *
        * Use the `handled` property to indicates the present state of the event handling for a routed event.
        */
        get: function () {
            return this.i.handled;
        },
        set: function (v) {
            this.i.handled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        *
        * Use the `originalSource` property for the raised object event.
        *
        * ```ts
        * args.originalSource;
        * ```
        */
        get: function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        *
        * Use the `item` property to get the ItemsSource item associated with the current event.
        *
        * ```ts
        * var item1= args.item;
        * ```
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        *
        * Use the `series` property for the associated current event.
        *
        * ```ts
        *  var DataSeries= args.series;
        * ```
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChartMouseButtonEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        *
        * Use the `chart` property to get the chart associated with the current event.
        *
        * ```ts
        * var dataChart=  args.chart;
        * ```
        */
        get: function () {
            if (this.i.chart == null) {
                return null;
            }
            return this.i.chart.externalObject;
        },
        set: function (v) {
            v == null ? this.i.chart = null : this.i.chart = v.i;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    *
    * Use the `toString` property to provides a human readable discription.
    *
    * ```ts
    *   var item= args.item.label.toString();
    * ```
    */
    IgrDataChartMouseButtonEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    *
    * To get mouse X and Y position.
    *
    * ```ts
    *    var args.getPosition;
    * ```
    */
    IgrDataChartMouseButtonEventArgs.prototype.getPosition = function (relativeTo) {
        var iv = this.i.getPosition(relativeTo);
        return fromPoint(iv);
    };
    return IgrDataChartMouseButtonEventArgs;
}());

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
var IgrChartMouseEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrChartMouseEventArgs() {
    }
    Object.defineProperty(IgrChartMouseEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrChartMouseEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrChartMouseEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrChartMouseEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChartMouseEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChartMouseEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            if (this.i.series == null) {
                return null;
            }
            if (!this.i.series.externalObject) {
                var e = IgrSeries._createFromInternal(this.i.series);
                if (e) {
                    e._implementation = this.i.series;
                }
                this.i.series.externalObject = e;
            }
            return this.i.series.externalObject;
        },
        set: function (v) {
            v == null ? this.i.series = null : this.i.series = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrChartMouseEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            if (this.i.chart == null) {
                return null;
            }
            return this.i.chart.externalObject;
        },
        set: function (v) {
            v == null ? this.i.chart = null : this.i.chart = v.i;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    IgrChartMouseEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    */
    IgrChartMouseEventArgs.prototype.getPosition = function (relativeTo) {
        var iv = this.i.getPosition(relativeTo);
        return fromPoint(iv);
    };
    return IgrChartMouseEventArgs;
}());

/**
 * Represents a control for viewing series objects.
*/
var IgrSeriesViewer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSeriesViewer, _super);
    function IgrSeriesViewer(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._seriesCursorMouseMove = null;
        _this._seriesCursorMouseMove_wrapped = null;
        _this._seriesMouseLeftButtonDown = null;
        _this._seriesMouseLeftButtonDown_wrapped = null;
        _this._seriesMouseLeftButtonUp = null;
        _this._seriesMouseLeftButtonUp_wrapped = null;
        _this._seriesMouseMove = null;
        _this._seriesMouseMove_wrapped = null;
        _this._seriesMouseEnter = null;
        _this._seriesMouseEnter_wrapped = null;
        _this._seriesMouseLeave = null;
        _this._seriesMouseLeave_wrapped = null;
        _this._windowRectChanged = null;
        _this._windowRectChanged_wrapped = null;
        _this._sizeChanged = null;
        _this._sizeChanged_wrapped = null;
        _this._actualWindowRectChanged = null;
        _this._actualWindowRectChanged_wrapped = null;
        _this._gridAreaRectChanged = null;
        _this._gridAreaRectChanged_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrSeriesViewer.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrSeriesViewer.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrSeriesViewer._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrSeriesViewer.prototype.onImplementationCreated = function () {
    };
    IgrSeriesViewer.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrSeriesViewer.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrSeriesViewer.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrSeriesViewer.prototype, "crosshairPoint", {
        /**
         * Gets or sets the cross hair point (in world coordinates)
         * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
         * case the relevant crosshair line is hidden.
        *
        * The `crosshairPoint` property is used to gets/sets the cross hair point (in world coordinates).
        *
        * ```ts
        * this.chart.crosshairPoint = {x:.8,y:.2};
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	crosshairVisibility="visible"
        *     crosshairPoint={x:.8,y:.2} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return fromPoint(this.i.mi);
        },
        set: function (v) {
            this.i.mi = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "animateSeriesWhenAxisRangeChanges", {
        /**
         * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
        *
        * `animateSeriesWhenAxisRangeChanges` is a Boolean property to override the default behavior in which series do not animate if an axis range changes.
        *
        * ```ts
        * this.chart.animateSeriesWhenAxisRangeChanges = true;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	animateSeriesWhenAxisRangeChanges={true}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.cd;
        },
        set: function (v) {
            this.i.cd = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "viewportRect", {
        /**
         * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
        */
        get: function () {
            return fromRect(this.i.m3);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "effectiveViewport", {
        /**
         * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
        *
        *  ``ts
        * let viewport: IgxRect = this.chart.effectiveViewport;
        *
        * ```
        *
        * ```
        */
        get: function () {
            return fromRect(this.i.mu);
        },
        set: function (v) {
            this.i.mu = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "contentViewport", {
        /**
         * Represents the subset area within the viewport into which content should be mapped.
         * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
        */
        get: function () {
            return fromRect(this.i.mt);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowRect", {
        /**
         * A rectangle representing the portion of the SeriesViewer currently in view.
         * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
        *
        * You can set the `windowRect` to zoom in on an area of interest in the chart.
        *
        * ```ts
        * this.chart.windowRect = {left:0, top:1, width: .5, height: .5};
        * ```
        */
        get: function () {
            return fromRect(this.i.m4);
        },
        set: function (v) {
            this.i.m4 = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "useTiledZooming", {
        /**
         * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
        */
        get: function () {
            return this.i.dj;
        },
        set: function (v) {
            this.i.dj = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "preferHigherResolutionTiles", {
        /**
         * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
        */
        get: function () {
            return this.i.db;
        },
        set: function (v) {
            this.i.db = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "zoomTileCacheSize", {
        /**
         * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
        */
        get: function () {
            return this.i.e6;
        },
        set: function (v) {
            this.i.e6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "highlightingTransitionDuration", {
        /**
         * Gets or sets the duration the highlighting/de-highlighting effects.
        *
        * The `highlightingTransitionDuration` property is used to set the time for highlighting transition in milliseconds .
        *
        * ```ts
        * chart.HighlightingTransitionDuration=500;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	HighlightingTransitionDuration={500} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.e5;
        },
        set: function (v) {
            this.i.e5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "isPagePanningAllowed", {
        /**
         * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
        */
        get: function () {
            return this.i.cy;
        },
        set: function (v) {
            this.i.cy = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "contentHitTestMode", {
        /**
         * Determines the method of hit testing used when mousing over elements in the chart.
        *
        * ```ts
        * this.chart.contentHitTestMode = ChartHitTestMode.Computational;
        * ```
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureEnum(ChartHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualContentHitTestMode", {
        /**
         * Resolved method of hit testing used when the pointer is over elements in the chart.
        *
        * ```ts
        * let actualContentHitTestMode: ChartHitTestMode  =this.chart.actualContentHitTestMode;
        * ```
        */
        get: function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = ensureEnum(ChartHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        *
        * The `isSurfaceInteractionDisabled` property is used to enable/disable interactions with the plot surface.
        *
        * ```ts
        * chart.isSurfaceInteractionDisabled=true;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	 isSurfaceInteractionDisabled={true} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.cz;
        },
        set: function (v) {
            this.i.cz = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "isMap", {
        /**
         * Indicates if this SeriesViewer is a map.
        */
        get: function () {
            return this.i.cx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowResponse", {
        /**
         * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
        *
        * The `windowResponse` property is used to set the response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.
        * The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
        *
        * ```ts
        * this.chart.windowResponse="deferred";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	windowResponse="deferred">
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ba;
        },
        set: function (v) {
            this.i.ba = ensureEnum(WindowResponse_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowRectMinWidth", {
        /**
         * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
        *
        * The `windowRectMinWidth` property is used to set or get the minimum width that the window rect is allowed to reach before being clamped.
        *
        * ```ts
        * this.chart.WindowRectMinWidth=".2";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	WindowRectMinWidth=".2">
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ex;
        },
        set: function (v) {
            this.i.ex = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "crosshairVisibility", {
        /**
         * Gets or sets the current SeriesViewer's crosshair visibility override.
        *
        * The `crosshairVisibility` property is used to gets or sets the current Chart's crosshair visibility override. Note: setting this property does not affect the mobile browser version of the chart.
        *
        * ```ts
        * this.chart.crosshairVisibility = Visibility.Visible;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	crosshairVisibility="visible"
        *     crosshairPoint={x:.8,y:.2} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.m7;
        },
        set: function (v) {
            this.i.m7 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "plotAreaBackground", {
        /**
         * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
        *
        * `plotAreaBackground` property set the background brush to the current Chart object's plot area.
        *
        * ```ts
        * this.chart.plotAreaBackground="#F0F8FF";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	dataSource={this.state.dataSource}
        * 	plotAreaBackground="#F0F8FF" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.md);
        },
        set: function (v) {
            this.i.md = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "defaultInteraction", {
        /**
         * Gets or sets the DefaultInteraction property.
         * The default interaction state defines the SeriesViewer's response to mouse events.
        *
        * The default interaction state defines the chart's response to mouse events.
        *
        * ```ts
        * this.chart.defaultInteraction = InteractionState.DragPan;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	defaultInteraction="dragPan" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = ensureEnum(InteractionState_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "rightButtonDefaultInteraction", {
        /**
         * Gets or sets the RightButtonDefaultInteraction property.
         * The default interaction state defines the SeriesViewer's response to right button mouse events.
        */
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = ensureEnum(InteractionState_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "dragModifier", {
        /**
         * Gets or sets the current SeriesViewer's DragModifier property.
        *
        * `dragModifier` is useful to enable zooming when zooming is not the default interaction.
        *
        * ```ts
        * this.chart.dragModifier = ModifierKeys.Alt;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	isHorizontalZoomEnabled=true
        *     defaultInteraction="dragPan"
        *     dragModifier="alt" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.l0;
        },
        set: function (v) {
            this.i.l0 = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "panModifier", {
        /**
         * Gets or sets the current SeriesViewer's PanModifier property.
        *
        * `panModifier` is useful to enable panning when panning is not the default interaction.
        *
        * ```ts
        * this.chart.panModifier = ModifierKeys.Alt;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	dataSource={this.state.dataSource}
        * 	isHorizontalZoomEnabled=true
        * 	defaultInteraction="dragZoom"
        * 	panModifier="alt" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.l1;
        },
        set: function (v) {
            this.i.l1 = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "previewRect", {
        /**
         * Gets or sets the preview rectangle.
         * The preview rectangle may be set to Rect.Empty, in which case the visible preview
         * strokePath is hidden.
        *
        * `previewRect` can be used to highlight an area of importance.
        *
        * ```ts
        * this.chart.previewRect = {left:0,top:0,height:.5,width:.5};
        * ```
        */
        get: function () {
            return fromRect(this.i.mz);
        },
        set: function (v) {
            this.i.mz = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the X position of the WindowRect property.
        *
        * ```ts
        * this.chart.windowPositionHorizontal = .2;
        * ```
        */
        get: function () {
            return this.i.ev;
        },
        set: function (v) {
            this.i.ev = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Y position of the WindowRect property.
        *
        * ```ts
        * this.chart.windowPositionVertical = .2;
        * ```
        */
        get: function () {
            return this.i.ew;
        },
        set: function (v) {
            this.i.ew = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "chartTitle", {
        /**
         * Text to display above the plot area.
        *
        * The `chartTitle` property is used to set the title to display for the component.
        *
        * ```ts
        * this.chart.title="Items Sold";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	title="Items Sold" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.gq;
        },
        set: function (v) {
            this.i.gq = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleHorizontalAlignment", {
        /**
         * Gets or sets the TitleHorizontalAlignment property.
        *
        * The `subtitleHorizontalAlignment` property is used to set horizontal alignment for the subtitle.
        *
        * ```ts
        * this.chart.titleHorizontalAlignment="left";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	titleHorizontalAlignment="left"
        *     subtitleHorizontalAlignment="left" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.lz;
        },
        set: function (v) {
            this.i.lz = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleHorizontalAlignment", {
        /**
         * Gets or sets the SubtitleHorizontalAlignment property.
        *
        * The `subtitleBottomMargin` property is used to set the horizontal alignment for the subtitle.
        *
        * ```ts
        * this.chart.subtitleHorizontalAlignment="left";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	subtitleHorizontalAlignment="left"	>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ly;
        },
        set: function (v) {
            this.i.ly = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleTextStyle", {
        /**
         * Font settings for the title.
        */
        get: function () {
            return this.i.gx;
        },
        set: function (v) {
            this.i.gx = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleTextStyle", {
        /**
         * Font settings for the subtitle.
        */
        get: function () {
            return this.i.gl;
        },
        set: function (v) {
            this.i.gl = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleTextColor", {
        /**
         * Gets or sets the Color used for the Title Text.
        *
        * The `titleTextColor` property is used to set the title brush.
        *
        * ```ts
        * this.chart.titleTextColor="blue" ;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	titleTextColor="blue" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.mg);
        },
        set: function (v) {
            this.i.mg = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleTextColor", {
        /**
         * Gets or sets the Color used for the Subtitle Text.
        *
        * The `subtitleTextColor` property is used to set the color for the subtitle.
        *
        * ```ts
        * this.chart.subtitleTextColor="blue";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	title="Date of Sale: 1/1/2018"
        *     subtitleTextColor="blue">
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return brushToString(this.i.mf);
        },
        set: function (v) {
            this.i.mf = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleTopMargin", {
        /**
         * Margin applied above the title.
        *
        * The `titleTopMargin` property is used to set the top margin for the title.
        *
        * ```ts
        * this.chart.titleTopMargin=10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	titleLeftMarging= {10}
        *     titleTopMargin= {10 }
        *     titleRightMargin= {10}
        *     titleBottomMargin= {20}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleLeftMargin", {
        /**
         * Margin applied to the left of the title.
        *
        * The `titleLeftMarging` property is used to set the left margin for the title.
        *
        * ```ts
        * this.chart.titleLeftMarging=10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	title="Items Sold"
        *     titleLeftMarging={10}
        *     titleTopMargin={10}
        *     titleRightMargin={10}
        *     titleBottomMargin= {20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleRightMargin", {
        /**
         * Margin applied to the right of the title.
        *
        * The `titleRightMargin` property is used to set the right margin for the title.
        *
        * ```ts
        * this.chart.titleRightMargin=10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	titleLeftMarging= {10}
        *     titleTopMargin= {10 }
        *     titleRightMargin= {10}
        *     titleBottomMargin= {20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.es;
        },
        set: function (v) {
            this.i.es = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "titleBottomMargin", {
        /**
         * Margin applied below the title.
        *
        * The `titleBottomMargin` property is used to set the bottom margin for the title.
        *
        * ```ts
        * this.chart.titleBottomMargin=20;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	title="Items Sold"
        * 	titleLeftMarging= {10}
        *     titleTopMargin= {10 }
        *     titleRightMargin= {10}
        *     titleBottomMargin= {20}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.eq;
        },
        set: function (v) {
            this.i.eq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleTopMargin", {
        /**
         * Margin applied above the subtitle.
        *
        * The `subtitleTopMargin` property is used to set the top margin for the subtitle.
        *
        * ```ts
        * this.chart.subtitleTopMargin =10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	subtitleLeftMarging= {10}
        *     subtitleTopMargin={10}
        *     subtitleRightMargin={10}
        *     subtitleBottomMargin={20}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleLeftMargin", {
        /**
         * Margin applied to the left of the subtitle.
        *
        * The `subtitleLeftMarging` property is used to set the left margin for the subtitle.
        *
        * ```ts
        * this.chart.subtitleLeftMarging=10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	subtitleLeftMarging= {10}
        *     subtitleTopMargin={10}
        *     subtitleRightMargin={10}
        *     subtitleBottomMargin={20}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.en;
        },
        set: function (v) {
            this.i.en = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleRightMargin", {
        /**
         * Margin applied to the right of the subtitle.
        *
        * The `subTitleRightMargin` property is used to set the right margin for the subtitle.
        *
        * ```ts
        * this.chart.subtitleLeftMarging=10;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	subtitleLeftMarging= {10}
        *     subtitleTopMargin= {10}
        *     subtitleRightMargin={10}
        *     subtitleBottomMargin={20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitleBottomMargin", {
        /**
         * Margin applied below the subtitle.
        *
        * The `subtitleBottomMargin` property is used to set the bottom margin for the subtitle.
        *
        * ```ts
        * this.chart.subtitleBottomMargin = 20;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	 subtitleBottomMargin={20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.em;
        },
        set: function (v) {
            this.i.em = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "subtitle", {
        /**
         * Gets or sets the Subtitle property.
         * The Title property defines the Subtitle of the chart
        *
        * The `subtitle` property is used to display subtitle for the component.
        *
        * ```ts
        * this.chart.subtitle="Date of Sale: 1/1/2018";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	dataSource={this.state.dataSource}
        * 	subtitle="Date of Sale: 1/1/2018" >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ge;
        },
        set: function (v) {
            this.i.ge = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "topMargin", {
        /**
         * Sets or gets the top margin to use around the chart content.
        *
        * The `topMargin` property is used to set the top margin.
        *
        * ```ts
        * this.chart.topMargin=30;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	leftMargin= {20}
        *     rightMargin={20}
        *     topMargin={30}
        *     bottomMargin= {20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.eu;
        },
        set: function (v) {
            this.i.eu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "leftMargin", {
        /**
         * Sets or gets the left margin to use around the chart content.
        *
        * The `leftMargin` property is used to set the left margin.
        *
        * ```ts
        *  this.chart.leftMargin = 20;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	 leftMargin={20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        * />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ej;
        },
        set: function (v) {
            this.i.ej = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "rightMargin", {
        /**
         * Sets or gets the right margin to use around the chart content.
        *
        * The `rightMargin` property is used to set the left margin around the chart content in the canvas.
        *
        * ```ts
        * this.chart.rightMargin=20;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	leftMargin= {20}
        * 	rightMargin={20}
        * 	topMargin={30}
        * 	bottomMargin={20} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.el;
        },
        set: function (v) {
            this.i.el = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "bottomMargin", {
        /**
         * Sets or gets the bottom margin to use around the chart content.
        *
        * The `bottomMargin` property is used to gets/set the bottom margin around the chart content in the canvas.
        *
        * ```ts
        * this.chart.bottomMargin = 50;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	 bottomMargin={50} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ef;
        },
        set: function (v) {
            this.i.ef = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "autoMarginWidth", {
        /**
         * Sets or gets the automatic width to add when automatically adding margins to the chart.
        *
        * The `autoMarginWidth` propertry is used find the automatic width to add when automatically adding margins to the chart.
        *
        * ```ts
        * this.chart.autoMarginWidth = 50;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	autoMarginWidth={50} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ee;
        },
        set: function (v) {
            this.i.ee = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "autoMarginHeight", {
        /**
         * Sets or gets the automatic height to add when automatically adding margins to the chart.
        *
        * ```ts
        *  this.chart.autoMarginHeight = 50;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	autoMarginHeight={50}
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrAreaSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value"
        *     brush="Gray"
        *     outline="Black" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ed;
        },
        set: function (v) {
            this.i.ed = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "isAntiAliasingEnabledDuringInteraction", {
        /**
         * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
        */
        get: function () {
            return this.i.cp;
        },
        set: function (v) {
            this.i.cp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.ek;
        },
        set: function (v) {
            this.i.ek = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "interactionPixelScalingRatio", {
        /**
         * Method of pixel scaling to use during end user interaction with the chart.
        */
        get: function () {
            return this.i.ei;
        },
        set: function (v) {
            this.i.ei = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the resolved pixel scaling ratio.
        *
        * A higher scaling ratio will produce crisper visuals at the expense of memory. Lower values will cause the control to appear blurry
        *
        * ```ts
        * let actualPixelScalingRatio: number = this.chart.actualPixelScalingRatio;
        * ```
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualInteractionPixelScalingRatio", {
        /**
         * Resolved method of pixel scaling to use during end user interaction with the chart.
        *
        * ```ts
        * let actualInteractionPixelScalingRatio: number = this.chart.actualInteractionPixelScalingRatio;
        * ```
        */
        get: function () {
            return this.i.d9;
        },
        set: function (v) {
            this.i.d9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualWindowRect", {
        /**
         * Gets the actual value of the window rectangle, which represents the current zoom level.
        */
        get: function () {
            return fromRect(this.i.mq);
        },
        set: function (v) {
            this.i.mq = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualWindowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the Left of the ActualWindowRect property.
        *
        * ```ts
        * let actualWindowPositionHorizontal: number = this.chart.actualWindowPositionHorizontal;
        * ```
        */
        get: function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualWindowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Top of the ActualWindowRect property.
        *
        * ```ts
        * let actualWindowPositionVertical: number = this.chart.actualWindowPositionVertical;
        * ``
        * ```
        */
        get: function () {
            return this.i.ec;
        },
        set: function (v) {
            this.i.ec = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrSeriesViewer.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrSeriesViewer.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SeriesViewer");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
     * Hides the active main tooltip, if displayed.
    
    *
    * ```ts
    * this.chart.hideToolTip();
    * ```
    */
    IgrSeriesViewer.prototype.hideToolTip = function () {
        this.i.ho();
    };
    /**
     * Manually starts a tiled zoom if one isn't already running.
    
    */
    IgrSeriesViewer.prototype.startTiledZoomingIfNecessary = function () {
        this.i.j7();
    };
    /**
     * Manually ends a tiled zoom if one is running.
    
    */
    IgrSeriesViewer.prototype.endTiledZoomingIfRunning = function () {
        this.i.hj();
    };
    /**
     * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
    
    */
    IgrSeriesViewer.prototype.clearTileZoomCache = function () {
        this.i.hd();
    };
    /**
     * Resets the zoom level to default.
    
    */
    IgrSeriesViewer.prototype.resetZoom = function () {
        this.i.j1();
    };
    /**
     * Gets actual window scale for horizontal dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleHorizontal: number = chart.getActualWindowScaleHorizontal();
    * ```
    */
    IgrSeriesViewer.prototype.getActualWindowScaleHorizontal = function () {
        var iv = this.i.eg();
        return (iv);
    };
    /**
     * Gets actual window scale for vertical dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleVertical: number = chart.getActualWindowScaleVertical();
    * ```
    */
    IgrSeriesViewer.prototype.getActualWindowScaleVertical = function () {
        var iv = this.i.eh();
        return (iv);
    };
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    IgrSeriesViewer.prototype.notifyContainerResized = function () {
        this.i.notifyContainerResized();
    };
    /**
     * Attaches the given series to the chart.
    
    * @param s  * The series to attach to the chart.
    */
    IgrSeriesViewer.prototype.attachSeries = function (s) {
        this.i.hb((s == null ? null : s.i));
    };
    IgrSeriesViewer.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.h0(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    *
    * ```ts
    * this.chart.notifyClearItems(this.data);
    * ```
    */
    IgrSeriesViewer.prototype.notifyClearItems = function (source_) {
        this.i.hv(source_);
    };
    IgrSeriesViewer.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.hy(source_, index, newItem);
    };
    IgrSeriesViewer.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.hz(source_, index, oldItem);
    };
    /**
     * Release any resources held by the control.
    
    */
    IgrSeriesViewer.prototype.destroy = function () {
        this.i.destroy();
    };
    /**
     * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the SeriesViewer.
    
    *
    * ```ts
    * this.chart.flush();
    * ```
    */
    IgrSeriesViewer.prototype.flush = function () {
        this.i.flush();
    };
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesCursorMouseMove", {
        /**
         * Occurs when the cursors are moved over a series in this SeriesViewer.
        */
        get: function () {
            return this._seriesCursorMouseMove;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesCursorMouseMove_wrapped !== null) {
                this.i.seriesCursorMouseMove = delegateRemove(this.i.seriesCursorMouseMove, this._seriesCursorMouseMove_wrapped);
                this._seriesCursorMouseMove_wrapped = null;
                this._seriesCursorMouseMove = null;
            }
            this._seriesCursorMouseMove = ev;
            this._seriesCursorMouseMove_wrapped = function (o, e) {
                var outerArgs = new IgrChartCursorEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesCursorMouseMove) {
                    _this.beforeSeriesCursorMouseMove(_this, outerArgs);
                }
                if (_this._seriesCursorMouseMove) {
                    _this._seriesCursorMouseMove(_this, outerArgs);
                }
            };
            this.i.seriesCursorMouseMove = delegateCombine(this.i.seriesCursorMouseMove, this._seriesCursorMouseMove_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesMouseLeftButtonDown", {
        /**
         * Occurs when the left mouse button is pressed while the mouse pointer is over a Series.
        *
        * The `SeriesMouseLeftButtonDown` event occurs when the left mouse button is pressed while the mouse pointer is over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseLeftButtonDown(event: {sender: any, args: DataChartMouseButtonEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	seriesMouseLeftButtonDown= {this.onSeriesMouseLeftButtonDown}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this._seriesMouseLeftButtonDown;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesMouseLeftButtonDown_wrapped !== null) {
                this.i.seriesMouseLeftButtonDown = delegateRemove(this.i.seriesMouseLeftButtonDown, this._seriesMouseLeftButtonDown_wrapped);
                this._seriesMouseLeftButtonDown_wrapped = null;
                this._seriesMouseLeftButtonDown = null;
            }
            this._seriesMouseLeftButtonDown = ev;
            this._seriesMouseLeftButtonDown_wrapped = function (o, e) {
                var outerArgs = new IgrDataChartMouseButtonEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesMouseLeftButtonDown) {
                    _this.beforeSeriesMouseLeftButtonDown(_this, outerArgs);
                }
                if (_this._seriesMouseLeftButtonDown) {
                    _this._seriesMouseLeftButtonDown(_this, outerArgs);
                }
            };
            this.i.seriesMouseLeftButtonDown = delegateCombine(this.i.seriesMouseLeftButtonDown, this._seriesMouseLeftButtonDown_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesMouseLeftButtonUp", {
        /**
         * Occurs when the left mouse button is released while the mouse pointer is over a Series.
        *
        * The `SeriesMouseLeftButtonUp` event occurs when the left mouse button is released while the mouse pointer is over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseLeftButtonUp(event: {sender: any, args: DataChartMouseButtonEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	seriesMouseLeftButtonUp ={this.onSeriesMouseLeftButtonUp}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * public onSeriesMouseLeftButtonUp =(event: any, args: DataChartMouseButtonEventArgs )
        * {
        *
        * }
        * ```
        */
        get: function () {
            return this._seriesMouseLeftButtonUp;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesMouseLeftButtonUp_wrapped !== null) {
                this.i.seriesMouseLeftButtonUp = delegateRemove(this.i.seriesMouseLeftButtonUp, this._seriesMouseLeftButtonUp_wrapped);
                this._seriesMouseLeftButtonUp_wrapped = null;
                this._seriesMouseLeftButtonUp = null;
            }
            this._seriesMouseLeftButtonUp = ev;
            this._seriesMouseLeftButtonUp_wrapped = function (o, e) {
                var outerArgs = new IgrDataChartMouseButtonEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesMouseLeftButtonUp) {
                    _this.beforeSeriesMouseLeftButtonUp(_this, outerArgs);
                }
                if (_this._seriesMouseLeftButtonUp) {
                    _this._seriesMouseLeftButtonUp(_this, outerArgs);
                }
            };
            this.i.seriesMouseLeftButtonUp = delegateCombine(this.i.seriesMouseLeftButtonUp, this._seriesMouseLeftButtonUp_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesMouseMove", {
        /**
         * Occurs when the mouse pointer moves while over a Series.
        *
        * The `SeriesMouseMove` event occurs when the left mouse pointer moves while over an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseMove(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	seriesMouseMove={this.onSeriesMouseMove} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * public onSeriesMouseMove =( event: any, args: ChartMouseEventArgs) => {
        *                  }
        * ```
        */
        get: function () {
            return this._seriesMouseMove;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesMouseMove_wrapped !== null) {
                this.i.seriesMouseMove = delegateRemove(this.i.seriesMouseMove, this._seriesMouseMove_wrapped);
                this._seriesMouseMove_wrapped = null;
                this._seriesMouseMove = null;
            }
            this._seriesMouseMove = ev;
            this._seriesMouseMove_wrapped = function (o, e) {
                var outerArgs = new IgrChartMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesMouseMove) {
                    _this.beforeSeriesMouseMove(_this, outerArgs);
                }
                if (_this._seriesMouseMove) {
                    _this._seriesMouseMove(_this, outerArgs);
                }
            };
            this.i.seriesMouseMove = delegateCombine(this.i.seriesMouseMove, this._seriesMouseMove_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesMouseEnter", {
        /**
         * Occurs when the mouse pointer enters a Series.
        *
        * The `SeriesMouseEnter` event occurs when the left mouse pointer enters an element of this chart.
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * public onSeriesMouseEnter(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	seriesMouseEnter={this.onSeriesMouseEnter}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this._seriesMouseEnter;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesMouseEnter_wrapped !== null) {
                this.i.seriesMouseEnter = delegateRemove(this.i.seriesMouseEnter, this._seriesMouseEnter_wrapped);
                this._seriesMouseEnter_wrapped = null;
                this._seriesMouseEnter = null;
            }
            this._seriesMouseEnter = ev;
            this._seriesMouseEnter_wrapped = function (o, e) {
                var outerArgs = new IgrChartMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesMouseEnter) {
                    _this.beforeSeriesMouseEnter(_this, outerArgs);
                }
                if (_this._seriesMouseEnter) {
                    _this._seriesMouseEnter(_this, outerArgs);
                }
            };
            this.i.seriesMouseEnter = delegateCombine(this.i.seriesMouseEnter, this._seriesMouseEnter_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "seriesMouseLeave", {
        /**
         * Occurs when the mouse pointer leaves a Series.
        *
        * The `SeriesMouseLeave` event occurs when the left mouse pointer leaves an element of this chart.
        *
        * ```ts
        * public onSeriesMouseLeave(event: {sender: any, args: ChartMouseEventArgs})
        * {
        *     var item = event.args.item;
        * }
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	 seriesMouseLeave ={this.onSeriesMouseLeave}>
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this._seriesMouseLeave;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesMouseLeave_wrapped !== null) {
                this.i.seriesMouseLeave = delegateRemove(this.i.seriesMouseLeave, this._seriesMouseLeave_wrapped);
                this._seriesMouseLeave_wrapped = null;
                this._seriesMouseLeave = null;
            }
            this._seriesMouseLeave = ev;
            this._seriesMouseLeave_wrapped = function (o, e) {
                var outerArgs = new IgrChartMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesMouseLeave) {
                    _this.beforeSeriesMouseLeave(_this, outerArgs);
                }
                if (_this._seriesMouseLeave) {
                    _this._seriesMouseLeave(_this, outerArgs);
                }
            };
            this.i.seriesMouseLeave = delegateCombine(this.i.seriesMouseLeave, this._seriesMouseLeave_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "windowRectChanged", {
        /**
         * Occurs just after the current SeriesViewer's window rectangle is changed.
        *
        * &lt;-- position: content member-->
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        * <IgrDataChart
        * 	width="100%"
        * 	height="100%"
        * 	dataSource={this.data}
        * 	windowRectChanged={this.onWindowRectChanged} >
        * <IgrCategoryXAxis name="xAxis" label="Year"/>
        * <IgrNumericYAxis name="yAxis" minimumValue={0} />
        * <IgrLineSeries name="series3" title="Russia"
        *     valueMemberPath="Russia"
        *     xAxisName="xAxis"
        *     yAxisName="yAxis"
        *     markerType={this.state.markersType} />
        * </IgrDataChart>
        * ```
        *
        * ```ts
        * public onWindowRectChanged =( s:any, e: RectChangedEventArgs) => {
        *
        *        }
        * ```
        */
        get: function () {
            return this._windowRectChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._windowRectChanged_wrapped !== null) {
                this.i.windowRectChanged = delegateRemove(this.i.windowRectChanged, this._windowRectChanged_wrapped);
                this._windowRectChanged_wrapped = null;
                this._windowRectChanged = null;
            }
            this._windowRectChanged = ev;
            this._windowRectChanged_wrapped = function (o, e) {
                var outerArgs = new IgrRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeWindowRectChanged) {
                    _this.beforeWindowRectChanged(_this, outerArgs);
                }
                if (_this._windowRectChanged) {
                    _this._windowRectChanged(_this, outerArgs);
                }
            };
            this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, this._windowRectChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "sizeChanged", {
        /**
         * Occurs after the size of the series viewer changes.
        *
        * &lt;-- position: content member-->
        *
        * &lt;-- position: content member-->
        *
        * ```ts
        *  <IgrDataChart
        *     dataSource={this.state.dataSource}
        * 	sizeChanged={this.onSizeChanged=} >
        *
        *     <IgrNumericXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrLineSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        *
        * ```ts
        * public onSizeChanged =(event: any, args: RectChangedEventArgs}){
        *
        * }
        * ```
        */
        get: function () {
            return this._sizeChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._sizeChanged_wrapped !== null) {
                this.i.sizeChanged = delegateRemove(this.i.sizeChanged, this._sizeChanged_wrapped);
                this._sizeChanged_wrapped = null;
                this._sizeChanged = null;
            }
            this._sizeChanged = ev;
            this._sizeChanged_wrapped = function (o, e) {
                var outerArgs = new IgrRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSizeChanged) {
                    _this.beforeSizeChanged(_this, outerArgs);
                }
                if (_this._sizeChanged) {
                    _this._sizeChanged(_this, outerArgs);
                }
            };
            this.i.sizeChanged = delegateCombine(this.i.sizeChanged, this._sizeChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "actualWindowRectChanged", {
        /**
         * Raised when the actual window rectangle of the SeriesViewer changes.
        */
        get: function () {
            return this._actualWindowRectChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._actualWindowRectChanged_wrapped !== null) {
                this.i.actualWindowRectChanged = delegateRemove(this.i.actualWindowRectChanged, this._actualWindowRectChanged_wrapped);
                this._actualWindowRectChanged_wrapped = null;
                this._actualWindowRectChanged = null;
            }
            this._actualWindowRectChanged = ev;
            this._actualWindowRectChanged_wrapped = function (o, e) {
                var outerArgs = new IgrRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeActualWindowRectChanged) {
                    _this.beforeActualWindowRectChanged(_this, outerArgs);
                }
                if (_this._actualWindowRectChanged) {
                    _this._actualWindowRectChanged(_this, outerArgs);
                }
            };
            this.i.actualWindowRectChanged = delegateCombine(this.i.actualWindowRectChanged, this._actualWindowRectChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSeriesViewer.prototype, "gridAreaRectChanged", {
        /**
         * Occurs just after the current SeriesViewer's grid area rectangle is changed.
         * The grid area may change as the result of the SeriesViewer being resized, or
         * of an axis being added or changing size, possibly in another SeriesViewer.
        */
        get: function () {
            return this._gridAreaRectChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._gridAreaRectChanged_wrapped !== null) {
                this.i.gridAreaRectChanged = delegateRemove(this.i.gridAreaRectChanged, this._gridAreaRectChanged_wrapped);
                this._gridAreaRectChanged_wrapped = null;
                this._gridAreaRectChanged = null;
            }
            this._gridAreaRectChanged = ev;
            this._gridAreaRectChanged_wrapped = function (o, e) {
                var outerArgs = new IgrRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeGridAreaRectChanged) {
                    _this.beforeGridAreaRectChanged(_this, outerArgs);
                }
                if (_this._gridAreaRectChanged) {
                    _this._gridAreaRectChanged(_this, outerArgs);
                }
            };
            this.i.gridAreaRectChanged = delegateCombine(this.i.gridAreaRectChanged, this._gridAreaRectChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSeriesViewer;
}(Component));

var IgrSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSeriesCollection, _super);
    function IgrSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrSeries.$type) {
            IgrSeries.$type = markType(IgrSeries, "IgrSeries");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrSeriesCollection.prototype._createInnerColl = function () {
        if (!IgrSeries.$type) {
            IgrSeries.$type = markType(IgrSeries, "IgrSeries");
        }
        var coll = new SyncableObservableCollection$2(IgrSeries.$type, Series.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrSeries._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrSeriesCollection;
}(IgCollection));

var IgrAxisCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAxisCollection, _super);
    function IgrAxisCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrAxis.$type) {
            IgrAxis.$type = markType(IgrAxis, "IgrAxis");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrAxisCollection.prototype._createInnerColl = function () {
        if (!IgrAxis.$type) {
            IgrAxis.$type = markType(IgrAxis, "IgrAxis");
        }
        var coll = new SyncableObservableCollection$2(IgrAxis.$type, Axis.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgrAxis._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrAxisCollection;
}(IgCollection));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents a chart area containing axes, series, an optional legend and other hosted content.
*/
var IgrDataChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataChart, _super);
    function IgrDataChart(props) {
        var _this = _super.call(this, props) || this;
        _this.contentAxes = [];
        _this.contentSeries = [];
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing React to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        _this.actualSeries = [];
        /**
         * The axes actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing React to reproject the child content.
         * Or adding and removing axes from the manual axes collection on the axes property.
         */
        _this.actualAxes = [];
        _this._series = null;
        _this._axes = null;
        _this._initialized = false;
        _this._axesAdapter = null;
        _this._seriesAdapter = null;
        _this._defaultTooltips = null;
        _this._uniqueTooltipId = 0;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._tooltipRef = _this._tooltipRef.bind(_this);
        _this._activeTooltipElements = new Map();
        _this._activeTooltips = new Map();
        _this._currentTooltips = [];
        _this._contentChildrenManager = new ContentChildrenManager(function (ch) { return ch.key || ch.props.name; }, function (ch) { return ch.key || ch.props.name; }, function () { return _this._updateContentChildren(); });
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
        }
        var root;
        root = _this._container;
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this._wrapper = ren;
        var chart = _this.i;
        _this._chart = chart;
        _this._axesAdapter = new CollectionAdapter(_this.contentAxes, _this.i.axes, _this.actualAxes, function (c) { return c.i; }, function (i) {
            i._provideRenderer(_this._wrapper);
            i.provideData(_this._dataSource);
            if (_this._container && _this._container.parentElement) {
                i._styling(_this._container, _this, _this);
            }
            _this._checkCrossing();
        }, function (i) { i._provideRenderer(null); i.provideData(null); });
        _this._seriesAdapter = new CollectionAdapter(_this.contentSeries, _this.i.series, _this.actualSeries, function (c) { return c.i; }, function (i) {
            i.owner = _this;
            i._provideRenderer(_this._wrapper);
            i.provideData(_this._dataSource);
            if (_this._container && _this._container.parentElement) {
                i._styling(_this._container, _this, _this);
            }
            i.bindAxes(_this.actualAxes);
            _this._ensureDefaultTooltip(i);
            _this._ensureTooltipCreated(i);
        }, function (i) { i._provideRenderer(null); i.provideData(null); });
        chart.provideContainer(ren);
        ren.addSizeWatcher(function () {
            _this._chart.notifyContainerResized();
        });
        _this._initialized = true;
        return _this;
    }
    Object.defineProperty(IgrDataChart.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._chart.notifyContainerResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "legend", {
        /**
         * Gets or sets the legend used for the current chart.
        */
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: true,
        configurable: true
    });
    IgrDataChart.prototype._updateContentChildren = function () {
        this.contentAxes.length = 0;
        this.contentSeries.length = 0;
        var contentChildrenActual = this._contentChildrenManager.contentChildrenActual;
        for (var i = 0; i < contentChildrenActual.length; i++) {
            if ((Axis.$type).isAssignableFrom(contentChildrenActual[i].i.$type)) {
                this.contentAxes.push(contentChildrenActual[i]);
            }
            else {
                this.contentSeries.push(contentChildrenActual[i]);
            }
        }
        if (this._axesAdapter !== null) {
            this._axesAdapter.notifyContentChanged();
        }
        if (this._seriesAdapter !== null) {
            this._seriesAdapter.notifyContentChanged();
        }
    };
    // private _childrenDiffer(children: any): boolean {
    //     if (this._contentChildren === null) {
    //         return true;
    //     }
    //     if (React.Children.count(children) != this._contentChildren.length) {
    //         return true;
    //     }
    //     let arr = React.Children.toArray(children);
    //     for (let i = 0; i < arr.length; i++) {
    //         if ((arr[i] as any).props.name !== this._contentChildren[i].props.name) {
    //             return true;
    //         }
    //     }
    //     return false;
    // }
    IgrDataChart.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrDataChart.prototype.render = function () {
        // if (!this._childrenDiffer(this.props.children)) {
        // 	let div = React.createElement("div", {
        // 		ref: (ref) => {
        // 			this._elRef = ref;
        // 		},
        // 		children: this.props.children
        // 	});
        // 	return div;
        // } else {
        var children = this._contentChildrenManager.getChildren(this.props.children);
        //this._contentChildrenUnresolved = this._contentChildrenMap.size;
        if (this._currentTooltips && this._currentTooltips.length > 0) {
            //children = React.Children.toArray(this.props.children);
            for (var i = 0; i < this._currentTooltips.length; i++) {
                var t = this._currentTooltips[i];
                if (this._activeTooltipElements.has(t)) {
                    children.push(this._activeTooltipElements.get(t));
                }
                else {
                    if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
                        continue;
                    }
                    var Tooltip = TypeRegistrar.get("IgrTooltipContainer");
                    var tEle = createElement(Tooltip, {
                        ref: this._tooltipRef,
                        key: this._currentTooltips[i].key,
                        owner: this._currentTooltips[i]
                    });
                    var portal = createPortal(tEle, t, this._currentTooltips[i].key);
                    this._activeTooltipElements.set(t, portal);
                    children.push(portal);
                }
            }
        }
        var div = createElement("div", {
            className: "ig-data-chart igr-data-chart",
            ref: this._getMainRef,
            children: children
        });
        return div;
        //}
    };
    IgrDataChart.prototype._tooltipRef = function (t) {
        //console.log(t);
        if (t === null) {
            return;
        }
        if (t.currentOwner &&
            t.currentOwner.tooltipTemplate) {
            t.template = t.currentOwner.tooltipTemplate;
        }
        this._activeTooltips.set(t.currentOwner, t);
    };
    IgrDataChart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container);
        this._chart.notifyContainerResized();
        this.initializeContent();
    };
    Object.defineProperty(IgrDataChart.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.width = value;
                this._chart.notifyContainerResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "series", {
        /**
         * A collection or manually added series for the chart.
        */
        get: function () {
            var _this = this;
            if (this._series === null) {
                var coll = new IgrSeriesCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._seriesAdapter.clearManualItems();
                            break;
                    }
                });
                this._series = coll;
            }
            return this._series;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "axes", {
        /**
         * A collection or manually added axes for the chart.
        */
        get: function () {
            var _this = this;
            if (this._axes === null) {
                var coll = new IgrAxisCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._axesAdapter.clearManualItems();
                            break;
                    }
                });
                this._axes = coll;
            }
            return this._axes;
        },
        enumerable: true,
        configurable: true
    });
    IgrDataChart.prototype.componentWillUnmount = function () {
        this._chart.destroy();
        this._wrapper.destroy();
    };
    IgrDataChart.prototype.createImplementation = function () {
        return new XamDataChart();
    };
    Object.defineProperty(IgrDataChart.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: true,
        configurable: true
    });
    IgrDataChart.prototype.bindData = function () {
        //console.log("binding data: " + this._dataSource);
        if (this.actualAxes && this.actualAxes.length > 0) {
            var currAxes = this.actualAxes;
            for (var i = 0; i < currAxes.length; i++) {
                currAxes[i].provideData(this._dataSource);
            }
        }
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i].provideData(this._dataSource);
            }
        }
    };
    IgrDataChart.prototype.initializeContent = function () {
        if (TypeRegistrar.isRegistered("IgrDataChartDefaultTooltips")) {
            var d = TypeRegistrar.create("IgrDataChartDefaultTooltips");
            this._defaultTooltips = d;
            this._onDefaultTooltipsReady(d);
            //this._container.appendChild(cr.location.nativeElement);
        }
        this._styling(this._container, this);
        if (this.actualAxes && this.actualAxes.length > 0) {
            var currAxes = this.actualAxes;
            for (var i = 0; i < currAxes.length; i++) {
                currAxes[i]._styling(this._container, this, this);
            }
        }
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i]._styling(this._container, this, this);
            }
        }
        this.i.notifyContainerResized();
    };
    IgrDataChart.prototype._checkCrossing = function () {
        var toBind = [];
        var byName = new Map();
        for (var i = 0; i < this.actualAxes.length; i++) {
            byName.set(this.actualAxes[i].name, this.actualAxes[i]);
            if (this.actualAxes[i].crossingAxisName) {
                toBind.push(this.actualAxes[i]);
            }
        }
        for (var i = 0; i < toBind.length; i++) {
            if (byName.has(toBind[i].crossingAxisName)) {
                if (toBind[i].crossingAxis !== byName.get(toBind[i].crossingAxisName)) {
                    toBind[i].crossingAxis = byName.get(toBind[i].crossingAxisName);
                }
            }
        }
    };
    IgrDataChart.prototype._ensureTooltipCreated = function (series) {
        var _this = this;
        series._ensureTooltipCreated(function () { return _this.createTooltip(); }, function (ele) {
            var wrapper = new ReactWrapper(ele, _this._wrapper);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            if (_this._activeTooltips.has(ele)) {
                var tCont = _this._activeTooltips.get(ele);
                tCont.template = ele.tooltipTemplate;
            }
            return wrapper;
        });
    };
    IgrDataChart.prototype._ensureDefaultTooltip = function (series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips["ensureDefaultTooltip"](series);
    };
    IgrDataChart.prototype._onDefaultTooltipsReady = function (cr) {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                if (currSeries[i].showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries[i]);
                }
            }
        }
    };
    IgrDataChart.prototype.createTooltip = function () {
        // if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
        // 	return null;
        // }
        // let Tooltip = TypeRegistrar.get("IgrTooltipContainer");
        var wrapper = this._wrapper.createElement("div");
        var ele = wrapper.getNativeElement();
        ele.key = "__tooltip_" + this._uniqueTooltipId;
        this._uniqueTooltipId++;
        this._currentTooltips = this._currentTooltips.slice(0);
        this._currentTooltips.push(ele);
        //let element = React.createElement(Tooltip,  );
        //let portal = ReactDOM.createPortal(element, ele);
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgrDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            if (self._activeTooltips.has(ele)) {
                var t = self._activeTooltips.get(ele);
                t.dataContext = c;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        this._updateTooltipState();
        return ele;
    };
    IgrDataChart.prototype._updateTooltipState = function () {
        if (this._initialized) {
            this.setState({ tooltips: this._currentTooltips });
        }
    };
    Object.defineProperty(IgrDataChart.prototype, "syncChannel", {
        /**
         * Gets or sets the channel with which to synchronize.
        *
        * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
        */
        get: function () {
            return this.i.syncChannel;
        },
        set: function (v) {
            var newLink = null;
            if (v && v.length > 0) {
                newLink = SyncLinkManager.instance().getLink(v);
            }
            var oldLink = this.i.actualSyncLink;
            if (oldLink) {
                SyncLinkManager.instance().releaseLink(oldLink);
            }
            if (newLink) {
                this.i.actualSyncLink = newLink;
            }
            else {
                this.i.actualSyncLink = new SyncLink();
            }
            this.i.syncChannel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "synchronizeVertically", {
        /**
         * Gets or sets the bool used to display the window preview shadow.
        *
        * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
        */
        get: function () {
            return this.i.syncSettings ? this.i.syncSettings.synchronizeVertically : false;
        },
        set: function (v) {
            this.i.syncSettings.synchronizeVertically = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "synchronizeHorizontally", {
        /**
         * Gets or sets the bool used to display the window preview shadow.
        *
        * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
        */
        get: function () {
            return this.i.syncSettings ? this.i.syncSettings.synchronizeHorizontally : false;
        },
        set: function (v) {
            this.i.syncSettings.synchronizeHorizontally = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "i", {
        /**
                                 * @hidden
                                 */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "isSquare", {
        /**
     * Gets or sets whether to use a square aspect ratio for the chart. This is locked to true for polar and radial charts.
    *
    * Set `isSquare` to true to constrain the chart to a square, using the minimum of its height and width.
    *
    * ```ts
    *  this.chart.isSquare="True";
    * ```
    *
    * ```ts
    *  <IgrDataChart
    * 	IsHorizontalZoomEnabled="True"
    *     dataSource={this.state.dataSource} >
    *
    *     <IgrCategoryXAxis name="xAxis" />
    *     <IgrNumericYAxis name="yAxis" />
    *
    *     <IgrColumnSeries
    *      name="series1"
    *     xAxisName="xAxis"
    * 	yAxisName="yAxis"
    * 	valueMemberPath="Value" />
    *  </IgrDataChart>
    * ```
    */
        get: function () {
            return this.i.ns;
        },
        set: function (v) {
            this.i.ns = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "windowScaleHorizontal", {
        /**
         * A number between 0 and 1 determining the scale of the horizontal zoom.
         * This property is effectively a shortcut to the Width of the WindowRect property.
        *
        * To programmatically change the horizontal zoom level, set `windowScaleHorizontal` to a value between 0 and 1.
        *
        * ```ts
        * this.chart.windowScaleHorizontal="0.75";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	windowScaleHorizontal="0.75"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.ob;
        },
        set: function (v) {
            this.i.ob = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "windowScaleVertical", {
        /**
         * A number between 0 and 1 determining the scale of the vertical zoom.
         * This property is effectively a shortcut to the Height of the WindowRect property.
        *
        * To programmatically change the vertical zoom level, set `windowScaleVertical` to a value between 0 and 1.
        *
        * ```ts
        * this.chart.windowScaleVertical="0.75";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	windowScaleVertical="0.75"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.oc;
        },
        set: function (v) {
            this.i.oc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "actualWindowScaleHorizontal", {
        /**
         * A number between 0 and 1 determining the scale of the horizontal zoom.
         * This property is effectively a shortcut to the Width of the ActualWindowRect property.
        */
        get: function () {
            return this.i.n3;
        },
        set: function (v) {
            this.i.n3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "actualWindowScaleVertical", {
        /**
         * A number between 0 and 1 determining the scale of the vertical zoom.
         * This property is effectively a shortcut to the Height of the ActualWindowRect property.
        */
        get: function () {
            return this.i.n4;
        },
        set: function (v) {
            this.i.n4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "isHorizontalZoomEnabled", {
        /**
         * Gets or sets horizontal zoomability of the current control
        *
        * Set `isHorizontalZoomEnabled` to enable or disable horizontal zooming.
        *
        * ```ts
        * this.chart.IsHorizontalZoomEnabled= true;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	IsHorizontalZoomEnabled="True"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.nr;
        },
        set: function (v) {
            this.i.nr = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "isVerticalZoomEnabled", {
        /**
         * Gets or sets vertical zoomability of the current control
        *
        * Set `isVerticalZoomEnabled` to enable or disable vertical zooming.
        *
        * ```ts
        * this.chart.isVerticalZoomEnabled="True";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	IsVerticalZoomEnabled="True"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return this.i.nt;
        },
        set: function (v) {
            this.i.nt = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "gridMode", {
        /**
         * Gets or sets how grid lines are rendered in relation to series.
        *
        *  Try setting the `gridMode` property to bring your grid lines in front of the data series.
        */
        get: function () {
            return this.i.ng;
        },
        set: function (v) {
            this.i.ng = ensureEnum(GridMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "alignsGridLinesToPixels", {
        /**
         * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
        */
        get: function () {
            return this.i.nn;
        },
        set: function (v) {
            this.i.nn = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the chart series.
        *
        * `brushes` can be set declaratively to a list of color strings.
        *
        * ```ts
        * this.chart.brushes="red" ;
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	brushes="red"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.m9);
        },
        set: function (v) {
            this.i.m9 = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "markerBrushes", {
        /**
         * Gets or sets the MarkerBrushes property.
         * The brushes property defines the palette from which automatically assigned series brushes are selected.
        *
        * `markerBrushes` can be set declaratively to a list of color strings.
        *
        * ```ts
        * this.chart.markerBrushes="red,green,blue";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        * 	MarkerBrushes="red,green,blue"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.na);
        },
        set: function (v) {
            this.i.na = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the chart series.
        *
        * `outlines` can be set declaratively to a list of color strings.
        *
        * ```ts
        * this.chart.outlines="red,green,blue";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     outlines="red,green,blue"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.nc);
        },
        set: function (v) {
            this.i.nc = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "markerOutlines", {
        /**
         * Gets or sets the MarkerOutlines property.
         * The brushes property defines the palette from which automatically assigned series brushes are selected.
        *
        * `markerOutlines` can be set declaratively to a list of color strings.
        *
        * ```ts
        * this.chart.markerOutlines="red,green,blue";
        * ```
        *
        * ```ts
        *  <IgrDataChart
        *     markerOutlines="red,green,blue"
        *     dataSource={this.state.dataSource} >
        *
        *     <IgrCategoryXAxis name="xAxis" />
        *     <IgrNumericYAxis name="yAxis" />
        *
        *     <IgrColumnSeries
        *      name="series1"
        *     xAxisName="xAxis"
        * 	yAxisName="yAxis"
        * 	valueMemberPath="Value" />
        *  </IgrDataChart>
        * ```
        */
        get: function () {
            return fromBrushCollection(this.i.nb);
        },
        set: function (v) {
            this.i.nb = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "defaultAxisStroke", {
        /**
         * Gets or sets the DefaultAxisStroke property.
         * The DefaultAxisStroke property defines the brush which is used by the axes when no Axis.Stroke is set.
        */
        get: function () {
            return brushToString(this.i.po);
        },
        set: function (v) {
            this.i.po = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "defaultAxisMajorStroke", {
        /**
         * Gets or sets the DefaultAxisMajorStroke property.
         * The DefaultAxisMajorStroke property defines the brush which is used by the axes when no Axis.MajorStroke is set.
        */
        get: function () {
            return brushToString(this.i.pm);
        },
        set: function (v) {
            this.i.pm = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "defaultAxisMinorStroke", {
        /**
         * Gets or sets the DefaultAxisMinorStroke property.
         * The DefaultAxisMinorStroke property defines the brush which is used by the axes when no Axis.MinorStroke is set.
        */
        get: function () {
            return brushToString(this.i.pn);
        },
        set: function (v) {
            this.i.pn = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "plotAreaMarginLeft", {
        /**
         * Margin applied to the left of the plot area.
        */
        get: function () {
            return this.i.n8;
        },
        set: function (v) {
            this.i.n8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "plotAreaMarginTop", {
        /**
         * Margin applied above the plot area.
        */
        get: function () {
            return this.i.oa;
        },
        set: function (v) {
            this.i.oa = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "plotAreaMarginRight", {
        /**
         * Margin applied to the right of the plot area.
        */
        get: function () {
            return this.i.n9;
        },
        set: function (v) {
            this.i.n9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrDataChart.prototype, "plotAreaMarginBottom", {
        /**
         * Margin applied below the plot area.
        */
        get: function () {
            return this.i.n7;
        },
        set: function (v) {
            this.i.n7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Notifies the chart that the CSS styles in effect have been updated.

*/
    IgrDataChart.prototype.styleUpdated = function () {
        this.i.o4();
    };
    /**
     * Export serialized visual data.
    
    */
    IgrDataChart.prototype.exportSerializedVisualData = function () {
        var iv = this.i.om();
        return (iv);
    };
    return IgrDataChart;
}(IgrSeriesViewer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartCoreModule() {
    }
    IgrDataChartCoreModule.register = function () {
        TypeRegistrar.registerCons('IgrDataChart', IgrDataChart);
        TypeRegistrar.register('XamDataChart', XamDataChart.$type);
    };
    return IgrDataChartCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartCategoryCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartCategoryCoreModule() {
    }
    IgrDataChartCategoryCoreModule.register = function () {
        IgrCategoryXAxisModule.register();
        IgrNumericYAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartCategoryCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartCategoryModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartCategoryModule() {
    }
    IgrDataChartCategoryModule.register = function () {
        IgrLineSeriesModule.register();
        IgrAreaSeriesModule.register();
        IgrColumnSeriesModule.register();
        IgrSplineSeriesModule.register();
        IgrSplineAreaSeriesModule.register();
        IgrStepLineSeriesModule.register();
        IgrStepAreaSeriesModule.register();
        IgrPointSeriesModule.register();
        IgrWaterfallSeriesModule.register();
        IgrRangeAreaSeriesModule.register();
        IgrRangeColumnSeriesModule.register();
        IgrDataChartCategoryCoreModule.register();
    };
    return IgrDataChartCategoryModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartPolarCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartPolarCoreModule() {
    }
    IgrDataChartPolarCoreModule.register = function () {
        IgrNumericAngleAxisModule.register();
        IgrNumericRadiusAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartPolarCoreModule;
}());

/**
 * Represents the base class from which all IgxDataChartComponent polar series are derived.
*/
var IgrPolarBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarBase, _super);
    function IgrPolarBase(props) {
        var _this = _super.call(this, props) || this;
        _this._angleAxisName = null;
        _this._radiusAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrPolarBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "isPolar", {
        /**
         * Checks if this series is a polar series
        */
        get: function () {
            return this.i.c0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "angleMemberPath", {
        /**
         * Gets or sets the path to use to find the angle values for the series.
        */
        get: function () {
            return this.i.nw;
        },
        set: function (v) {
            this.i.nw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "radiusMemberPath", {
        /**
         * Gets or sets the path to use to get the radius values for the series.
        */
        get: function () {
            return this.i.n2;
        },
        set: function (v) {
            this.i.n2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "angleAxis", {
        /**
         * Gets the effective angle axis for the current series object.
        */
        get: function () {
            if (this.i.m3 == null) {
                return null;
            }
            if (!this.i.m3.externalObject) {
                var e = IgrNumericAngleAxis._createFromInternal(this.i.m3);
                if (e) {
                    e._implementation = this.i.m3;
                }
                this.i.m3.externalObject = e;
            }
            return this.i.m3.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m3 = null : this.i.m3 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "angleAxisName", {
        /**
        * Gets or sets the name to use to resolve angleAxis from markup.
        */
        get: function () {
            return this._angleAxisName;
        },
        set: function (v) {
            this._angleAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "radiusAxis", {
        /**
         * Gets the effective radius axis for the current series object.
        */
        get: function () {
            if (this.i.m4 == null) {
                return null;
            }
            if (!this.i.m4.externalObject) {
                var e = IgrNumericRadiusAxis._createFromInternal(this.i.m4);
                if (e) {
                    e._implementation = this.i.m4;
                }
                this.i.m4.externalObject = e;
            }
            return this.i.m4.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m4 = null : this.i.m4 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "radiusAxisName", {
        /**
        * Gets or sets the name to use to resolve radiusAxis from markup.
        */
        get: function () {
            return this._radiusAxisName;
        },
        set: function (v) {
            this._radiusAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "useCartesianInterpolation", {
        /**
         * Gets or sets whether Cartesian Interpolation should be used rather than Archimedian
         * spiral based interpolation.
        */
        get: function () {
            return this.i.no;
        },
        set: function (v) {
            this.i.no = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "maximumMarkers", {
        /**
         * Gets or sets the maximum number of markers displayed by the current series.
         * If more than the specified number of markers are visible, the polar series will automatically
         * choose a representative set.
        */
        get: function () {
            return this.i.nr;
        },
        set: function (v) {
            this.i.nr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current series object.
        */
        get: function () {
            return this.i.nf;
        },
        set: function (v) {
            this.i.nf = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush that specifies how the current series
         * object's trend line is drawn.
        */
        get: function () {
            return brushToString(this.i.os);
        },
        set: function (v) {
            this.i.os = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this series.
        */
        get: function () {
            return brushToString(this.i.or);
        },
        set: function (v) {
            this.i.or = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current series object's trend line.
        */
        get: function () {
            return this.i.nq;
        },
        set: function (v) {
            this.i.nq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the moving average period for the current series object.
        */
        get: function () {
            return this.i.ns;
        },
        set: function (v) {
            this.i.ns = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "trendLineZIndex", {
        /**
         * Sets or Gets the Trendline Z index.
        */
        get: function () {
            return this.i.nt;
        },
        set: function (v) {
            this.i.nt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarBase.prototype, "clipSeriesToBounds", {
        /**
         * Gets or sets whether to clip the series to the bounds.
         * Setting this to true can effect performance.
        */
        get: function () {
            return this.i.nm;
        },
        set: function (v) {
            this.i.nm = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrPolarBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.angleAxisName && this.angleAxisName.length > 0 &&
                axes[i].name == this.angleAxisName) {
                this.angleAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.radiusAxisName && this.radiusAxisName.length > 0 &&
                axes[i].name == this.radiusAxisName) {
                this.radiusAxis = axes[i];
            }
        }
    };
    IgrPolarBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.angleAxis && this.angleAxis._styling) {
            this.angleAxis._styling(container, component, this);
        }
        if (this.radiusAxis && this.radiusAxis._styling) {
            this.radiusAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Scrolls the requested item into view, if possible.
    
    * @param item  * The item to scroll into view.
    */
    IgrPolarBase.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrPolarBase.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    IgrPolarBase.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    IgrPolarBase.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Determine if object can be used as RadiusAxis
    
    * @param axis  * The object to check
    */
    IgrPolarBase.prototype.canUseAsRadiusAxis = function (axis) {
        var iv = this.i.nl(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as AngleAxis
    
    * @param axis  * The object to check
    */
    IgrPolarBase.prototype.canUseAsAngleAxis = function (axis) {
        var iv = this.i.nk(axis);
        return (iv);
    };
    return IgrPolarBase;
}(IgrMarkerSeries));

/**
 * Represents the base class from which all IgxDataChartComponent polar line series are derived.
*/
var IgrPolarLineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarLineSeriesBase, _super);
    function IgrPolarLineSeriesBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrPolarLineSeriesBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarLineSeriesBase;
}(IgrPolarBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAxisInfoCache, _super);
    function PolarAxisInfoCache(a, b, c) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.e = false;
        _this.g = false;
        _this.d = false;
        _this.f = false;
        _this.c = null;
        _this.i = 0;
        _this.h = 0;
        _this.a = a;
        _this.b = b;
        _this.e = _this.a.ju;
        _this.d = _this.a.b8;
        _this.g = _this.b.ju;
        _this.f = _this.b.b8;
        _this.i = _this.b.lj;
        _this.h = _this.b.li;
        _this.c = c;
        return _this;
    }
    PolarAxisInfoCache.$t = markType(PolarAxisInfoCache, 'PolarAxisInfoCache');
    return PolarAxisInfoCache;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesRenderer$2 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesRenderer$2, _super);
    function SeriesRenderer$2($tFrame, $tView, a) {
        var _rest = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            _rest[_i - 3] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.$tFrame = null;
        _this.$tView = null;
        _this.c = null;
        _this.d = null;
        _this.a = null;
        _this.e = null;
        _this.f = null;
        _this.b = null;
        _this.$tFrame = $tFrame;
        _this.$tView = $tView;
        _this.$type = _this.$type.specialize(_this.$tFrame, _this.$tView);
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this.c = c;
                    _this.d = d;
                    _this.a = function (h) {
                    };
                    _this.f = e;
                    _this.e = f;
                    _this.b = g;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    var h = _rest[5];
                    _this.c = c;
                    _this.d = d;
                    _this.a = h;
                    _this.f = e;
                    _this.e = f;
                    _this.b = g;
                }
                break;
        }
        return _this;
    }
    SeriesRenderer$2.prototype.g = function (a, b, c, d, e) {
        var f = 0;
        f = a.c;
        if (a.a && f > 0 && !a.b) {
            var g = b;
            if (this.f()) {
                this.b();
                b = d;
                d = g;
            }
            else {
                b = c;
                c = g;
            }
            this.a(c);
            this.c(c, e);
            this.e();
        }
        else {
            if (!a.b) {
                this.a(c);
                this.c(c, e);
            }
            this.d(c, e);
        }
        return {
            p1: b,
            p2: c,
            p3: d
        };
    };
    SeriesRenderer$2.$t = markType(SeriesRenderer$2, 'SeriesRenderer$2');
    return SeriesRenderer$2;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var OwnedPoint = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OwnedPoint, _super);
    function OwnedPoint() {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.a = null;
        _this.b = null;
        _this.b = { $type: Point_$type, x: 0, y: 0 };
        return _this;
    }
    OwnedPoint.$t = markType(OwnedPoint, 'OwnedPoint');
    return OwnedPoint;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterFrameBase$1 = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterFrameBase$1, _super);
    function ScatterFrameBase$1($t) {
        var _this = _super.call(this) || this;
        _this.$t = null;
        _this.f = null;
        _this.o = null;
        _this.j = null;
        _this.g = null;
        _this.m = null;
        _this.n = null;
        _this.h = null;
        _this.l = null;
        _this.i = null;
        _this.k = null;
        _this.$t = $t;
        _this.$type = _this.$type.specialize(_this.$t);
        _this.m = new List$1(Point_$type, 0);
        _this.g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        _this.j = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        _this.n = new List$1(Point_$type, 0);
        _this.h = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        _this.l = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        _this.i = new Dictionary$2(Base.$, Array_$type, 0);
        _this.k = new Dictionary$2(Base.$, Array_$type, 0);
        _this.o = function (a, b, c) { return a; };
        _this.f = new DictInterpolator$3(Base.$, OwnedPoint.$, _this.$t, runOn(_this, _this.s), function (a) { return a.a; }, function (a) { return !isNaN_(a.c.x) && !isNaN_(a.c.y); }, function () { return new OwnedPoint(); });
        return _this;
    }
    ScatterFrameBase$1.prototype.c = function (a, b, c) {
        var d = b;
        var e = c;
        if (d == null || e == null) {
            return;
        }
        this.f.e(this.g, a, d.g, e.g, d, e);
        Frame.a(this.m, a, d.m, e.m);
        this.f.e(this.j, a, d.j, e.j, d, e);
        this.f.e(this.h, a, d.h, e.h, d, e);
        this.f.e(this.l, a, d.l, e.l, d, e);
        this.p(this.j, a, d, e);
        Frame.a(this.n, a, d.n, e.n);
        this.i = e.i;
        this.k = e.k;
        this.r(a, d, e);
    };
    ScatterFrameBase$1.prototype.r = function (a, b, c) {
    };
    ScatterFrameBase$1.prototype.p = function (a, b, c, d) {
        var e_1, _a;
        var _loop_1 = function (e) {
            if (a.containsKey(e.a)) {
                return "continue";
            }
            var f;
            if (!((function () { var g = d.g.tryGetValue(e.a, f); f = g.p1; return g.ret; })()) || (f.b.x == e.b.x && f.b.y == e.b.y)) {
                return "continue";
            }
            var g = new OwnedPoint();
            this_1.s(g, b, e, f, c, d);
            if (isNaN_(g.c.x) || isNaN_(g.c.y)) {
                return "continue";
            }
            a.addItem(g.a, g);
        };
        var this_1 = this;
        try {
            for (var _b = __values(fromEnum(c.g.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                _loop_1(e);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    ScatterFrameBase$1.prototype.q = function (a, b, c, d) {
        if (c != null) {
            a.b = { $type: Point_$type, x: c.b.x, y: c.b.y };
        }
        else if (d != null) {
            a.b = { $type: Point_$type, x: d.b.x, y: d.b.y };
        }
    };
    ScatterFrameBase$1.prototype.s = function (a, b, c, d, e, f) {
        var g;
        var h;
        if (c == null) {
            if (d != null) {
                var i_1;
                if (((function () { var j = e.g.tryGetValue(d.a, i_1); i_1 = j.p1; return j.ret; })())) {
                    g = i_1;
                }
                else {
                    g = this.o(d, e, f);
                }
            }
            else {
                a.c = { $type: Point_$type, x: NaN, y: NaN };
                return;
            }
        }
        else {
            g = c;
            if (a.a == null) {
                a.a = c.a;
            }
        }
        if (d == null) {
            if (c != null) {
                var j_1;
                if (((function () { var k = f.g.tryGetValue(c.a, j_1); j_1 = k.p1; return k.ret; })())) {
                    h = j_1;
                }
                else {
                    a.c = { $type: Point_$type, x: NaN, y: NaN };
                    return;
                }
            }
            else {
                a.c = { $type: Point_$type, x: NaN, y: NaN };
                return;
            }
        }
        else {
            h = d;
            if (a.a == null) {
                a.a = d.a;
            }
        }
        this.q(a, b, g, h);
        if (isNaN_(g.c.x) || isNaN_(g.c.y)) {
            g = h;
        }
        this.t(a, b, g, h);
    };
    ScatterFrameBase$1.prototype.t = function (a, b, c, d) {
        var e = 1 - b;
        a.c = { $type: Point_$type, x: c.c.x * e + d.c.x * b, y: c.c.y * e + d.c.y * b };
    };
    ScatterFrameBase$1.$t = markType(ScatterFrameBase$1, 'ScatterFrameBase$1', Frame.$);
    return ScatterFrameBase$1;
}(Frame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarFrame, _super);
    function PolarFrame() {
        var _this = _super.call(this, PolarFrame.$) || this;
        _this.w = null;
        _this.v = false;
        _this.x = null;
        _this.w = new List$1(Point_$type, 0);
        _this.v = true;
        return _this;
    }
    PolarFrame.prototype.r = function (a, b, c) {
        var d = typeCast(PolarFrame.$, b);
        var e = typeCast(PolarFrame.$, c);
        if (d == null || e == null) {
            return;
        }
        Frame.a(this.w, a, d.w, e.w);
    };
    PolarFrame.prototype.q = function (a, b, c, d) {
        if (this.v) {
            _super.prototype.q.call(this, a, b, c, d);
        }
        else {
            _super.prototype.q.call(this, a, b, c, d);
            if (c != null && d != null && (c.b.x != d.b.x || c.b.y != d.b.y)) {
                var e = 1 - b;
                a.b = { $type: Point_$type, x: c.b.x * e + d.b.x * b, y: c.b.y * e + d.b.y * b };
            }
        }
    };
    PolarFrame.prototype.u = function (a) {
        return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
    };
    PolarFrame.prototype.t = function (a, b, c, d) {
        if (this.v) {
            _super.prototype.t.call(this, a, b, c, d);
        }
        else {
            if (c != null && d != null && (c.c.x != d.c.x || c.c.y != d.c.y) && this.u(a.b)) {
                a.c = this.x(a.b);
            }
            else {
                _super.prototype.t.call(this, a, b, c, d);
            }
        }
    };
    PolarFrame.$t = markType(PolarFrame, 'PolarFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();
    return PolarFrame;
}(ScatterFrameBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesRenderingArguments = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesRenderingArguments, _super);
    function SeriesRenderingArguments(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this.e = null;
        _this.f = null;
        _this.c = 0;
        _this.a = false;
        _this.d = null;
        _this.b = false;
        _this.c = a.fi;
        _this.d = a;
        _this.e = b;
        _this.f = c;
        _this.a = d;
        _this.b = e;
        return _this;
    }
    SeriesRenderingArguments.$t = markType(SeriesRenderingArguments, 'SeriesRenderingArguments');
    return SeriesRenderingArguments;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarTrendLineManager, _super);
    function PolarTrendLineManager() {
        var _this = _super.call(this, Point_$type) || this;
        _this.q = false;
        _this.p = 0;
        _this.s = 0;
        _this.r = 0;
        _this.t = null;
        _this.u = null;
        return _this;
    }
    PolarTrendLineManager.prototype.get_g$a = function () {
        return 2;
    };
    Object.defineProperty(PolarTrendLineManager.prototype, "g$a", {
        get: function () {
            return this.get_g$a();
        },
        enumerable: true,
        configurable: true
    });
    PolarTrendLineManager.prototype.v = function (a, b, c, d, e, f, g, h, i, j, k) {
        var e_1, _a;
        var l = j;
        var m = k;
        var n = new List$1(Point_$type, 0);
        if (!h.g.isEmpty && !h.f.isEmpty) {
            var o_1 = c;
            var p_1 = d;
            var q = 0;
            if (o_1 != null) {
                q = o_1.count;
            }
            if (p_1 != null) {
                q = Math.min(q, p_1.count);
            }
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(n, b, h, this.a, q, function (r) { return o_1.item(r); }, function (r) { return p_1.item(r); }, f, g, l, m);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.c(b, this.d, c, d, e);
                try {
                    for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var r = _c.value;
                        var s = f(r.x);
                        var t = g(r.y);
                        if (!isNaN_(s) && !isNaN_(t)) {
                            n.add({ $type: Point_$type, x: s, y: t });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            if (n.count > 0) {
                this.n(n, h, a, i);
            }
        }
    };
    PolarTrendLineManager.prototype.n = function (a, b, c, d) {
        var _this = this;
        if (d != null) {
            d.i = c;
        }
        var e = ((function () {
            var $ret = new PolarLinePlanner();
            $ret.m = function (f) { return a.item(f).x; };
            $ret.n = function (f) { return a.item(f).y; };
            $ret.a = d;
            $ret.q = a.count;
            $ret.l = b.b;
            $ret.o = function (f) { return _this.t(a.item(f).x, a.item(f).y); };
            $ret.p = function (f) { return _this.u(a.item(f).x, a.item(f).y); };
            $ret.f = _this.q;
            $ret.b = _this.p;
            $ret.ab = b.f;
            $ret.ac = b.g;
            return $ret;
        })());
        e.x(null, null);
    };
    PolarTrendLineManager.$t = markType(PolarTrendLineManager, 'PolarTrendLineManager', TrendLineManagerBase$1.$.specialize(Point_$type));
    return PolarTrendLineManager;
}(TrendLineManagerBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerManagerBucket = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerManagerBucket, _super);
    function MarkerManagerBucket() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.c = null;
        return _this;
    }
    Object.defineProperty(MarkerManagerBucket.prototype, "d", {
        get: function () {
            if (this.b == null) {
                this.b = new List$1(Number_$type, 0);
            }
            return this.b;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerManagerBucket.prototype, "e", {
        get: function () {
            if (this.c == null) {
                this.c = new List$1(Number_$type, 0);
            }
            return this.c;
        },
        enumerable: true,
        configurable: true
    });
    MarkerManagerBucket.prototype.f = function (a) {
        if (this.e.count > 0) {
            var b = this.e._inner[this.e.count - 1];
            this.e.removeAt(this.e.count - 1);
            a = true;
            return {
                ret: b,
                p0: a
            };
        }
        var c = this.d._inner[this.d.count - 1];
        this.d.removeAt(this.d.count - 1);
        a = false;
        return {
            ret: c,
            p0: a
        };
    };
    Object.defineProperty(MarkerManagerBucket.prototype, "a", {
        get: function () {
            return this.d.count == 0 && this.e.count == 0;
        },
        enumerable: true,
        configurable: true
    });
    MarkerManagerBucket.$t = markType(MarkerManagerBucket, 'MarkerManagerBucket');
    return MarkerManagerBucket;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerManagerBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerManagerBase, _super);
    function MarkerManagerBase(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this.f = null;
        _this.h = null;
        _this.a = null;
        _this.g = null;
        _this.e = null;
        _this.h = a;
        _this.g = b;
        _this.a = c;
        _this.f = d;
        _this.e = e;
        return _this;
    }
    MarkerManagerBase.prototype.d = function (a, b) {
        var e_1, _a;
        var c = new List$1(Number_$type, 0);
        var d = new List$1(Number_$type, 0);
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (a.item(e).e.count > 0) {
                    c.add(e);
                }
                else {
                    d.add(e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = new List$1(Number_$type, 0);
        f.o(c);
        f.o(d);
        return f;
    };
    MarkerManagerBase.prototype.k = function (a, b, c, d) {
        var e_2, _a;
        while (a > 0) {
            if (a < c.count) {
                if (!MarkerManagerBase.b) {
                    var e = c;
                    ArrayExtension.shuffle$1(Number_$type, e);
                }
                c = this.d(b, c);
                var f = a;
                var _loop_1 = function (g) {
                    var h = g;
                    var i = b.item(c._inner[h]);
                    var j;
                    var k = ((function () { var l = i.f(j); j = l.p0; return l.ret; })());
                    d.add(k);
                    a--;
                    if (i.a) {
                        b.removeItem(c._inner[h]);
                    }
                };
                for (var g = 0; g < f; g++) {
                    _loop_1(g);
                }
            }
            else {
                var _loop_2 = function (l) {
                    var m = b.item(l);
                    var n;
                    var o = ((function () { var p = m.f(n); n = p.p0; return p.ret; })());
                    d.add(o);
                    a--;
                    if (m.a) {
                        b.removeItem(l);
                    }
                };
                try {
                    for (var _b = (e_2 = void 0, __values(fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var l = _c.value;
                        _loop_2(l);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                c = new List$1(Number_$type, 1, b.keys);
            }
        }
    };
    MarkerManagerBase.prototype.i = function (a, b, c, d) {
        var e = b.left;
        var f = b.right;
        var g = b.top;
        var h = b.bottom;
        if (!a.isEmpty && !b.isEmpty) {
            for (var i = 0; i < c.count; ++i) {
                var j = c.item(i).x;
                if (isNaN_(j)) {
                    continue;
                }
                var k = c.item(i).y;
                if (isNaN_(k)) {
                    continue;
                }
                if (j < e || j > f) {
                    continue;
                }
                if (k < g || k > h) {
                    continue;
                }
                d.add(i);
            }
        }
    };
    MarkerManagerBase.prototype.c = function (a, b, c, d) {
        var e_3, _a, e_4, _b;
        var e = new Array(d.count);
        try {
            for (var _c = __values(fromEnum(this.e())), _d = _c.next(); !_d.done; _d = _c.next()) {
                var f = _d.value;
                if (f != -1) {
                    e[f] = true;
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        var g = truncate(Math.floor(a.width / c));
        var h = new Dictionary$2(Number_$type, MarkerManagerBucket.$, 0);
        var _loop_3 = function (i) {
            var j = d.item(i).x;
            var k = d.item(i).y;
            var l = truncate(Math.floor(k / c));
            var m = truncate(Math.floor(j / c));
            var n = (l * g) + m;
            var o;
            if (!((function () { var p = h.tryGetValue(n, o); o = p.p1; return p.ret; })())) {
                o = new MarkerManagerBucket();
                h.addItem(n, o);
            }
            if (e[i]) {
                o.e.add(i);
            }
            else {
                o.d.add(i);
            }
        };
        try {
            for (var _e = __values(fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var i = _f.value;
                _loop_3(i);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        return h;
    };
    MarkerManagerBase.$t = markType(MarkerManagerBase, 'MarkerManagerBase');
    MarkerManagerBase.b = false;
    return MarkerManagerBase;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumericMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericMarkerManager, _super);
    function NumericMarkerManager(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    var h = [c, d, e, f, g, function () { return 0; }];
                    {
                        var j = h[0];
                        var k = h[1];
                        var l = h[2];
                        var m = h[3];
                        var n = h[4];
                        var o = h[5];
                        _this = _super.call(this, j, k, l, m, n) || this;
                        _this.n = false;
                        _this.p = null;
                        _this.o = null;
                        _this.q = null;
                        _this.m = null;
                        _this.n = false;
                        _this.p = function (p) { return ({ $type: Point_$type, x: 0, y: 0 }); };
                        _this.o = o;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    var h = _rest[5];
                    _this = _super.call(this, c, d, e, f, g) || this;
                    _this.n = false;
                    _this.p = null;
                    _this.o = null;
                    _this.q = null;
                    _this.m = null;
                    _this.n = false;
                    _this.p = function (i) { return ({ $type: Point_$type, x: 0, y: 0 }); };
                    _this.o = h;
                }
                break;
        }
        return _this;
    }
    NumericMarkerManager.prototype.l = function (a, b, c, d, e) {
        var f = this.f();
        a.clear();
        var g = new List$1(Number_$type, 0);
        b = Math.max(0, b);
        var h = null;
        this.i(c, d, boxArray$1(f), g);
        if (b >= g.count) {
            h = g;
        }
        else {
            h = new List$1(Number_$type, 0);
            var i = Math.max(8, e);
            var j = this.c(d, g, i, boxArray$1(f));
            var k = new List$1(Number_$type, 1, j.keys);
            if (MarkerManagerBase.b) {
                k.y();
            }
            this.k(b, j, k, h);
        }
        this.r(a, f, h);
    };
    NumericMarkerManager.prototype.r = function (a, b, c) {
        for (var d = 0; d < c.count; ++d) {
            var e = c._inner[d];
            var f = b[e];
            var g = this.g(e);
            var h = this.h(g);
            if (h.content != null) {
                h.content.item = g;
            }
            var i = new OwnedPoint();
            if (this.n) {
                i.b = this.p(e);
            }
            i.a = g;
            i.c = { $type: Point_$type, x: f.x, y: f.y };
            if (!a.containsKey(g)) {
                a.addItem(g, i);
            }
        }
    };
    NumericMarkerManager.prototype.j = function (a, b) {
        var e_1, _a;
        var c = a.keys;
        if (MarkerManagerBase.b) {
            var d = new List$1(Base.$, 1, a.keys);
            d.aa(function (e, f) {
                var g = a.item(e);
                var h = a.item(f);
                var i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                var j = Math.pow(h.c.x, 2) + Math.pow(h.c.y, 2);
                return CompareUtil.compareToObject(i, j);
            });
            c = d;
        }
        var e = null;
        var f = null;
        switch (this.o()) {
            case 0: break;
            case 1:
                e = ((function () {
                    var $ret = new SmartPlacer();
                    $ret.c = 0.3;
                    $ret.b = 0;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                f.f = true;
                break;
            case 2:
                e = ((function () {
                    var $ret = new SmartPlacer();
                    $ret.c = 0.6;
                    $ret.b = 2;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                f.f = true;
                break;
            case 3:
                e = ((function () {
                    var $ret = new SmartPlacer();
                    $ret.c = 0.3;
                    $ret.b = 0;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                break;
            case 4:
                e = ((function () {
                    var $ret = new SmartPlacer();
                    $ret.c = 0.6;
                    $ret.b = 2;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                break;
        }
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                var h = a.item(g);
                var i = this.h(h.a);
                if (e != null && f != null) {
                    f.d = i;
                    f.j = this.q(i);
                    f.i = h.c;
                    e.d(f);
                    if (f.opacity == 0) {
                        f.smartPosition = f.smartPosition;
                    }
                    h.c = f.g;
                }
                else {
                    i._opacity = 1;
                    i._visibility = 0;
                }
                this.s(i, h, b);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.a(a);
    };
    NumericMarkerManager.prototype.s = function (a, b, c) {
        a.n = b.c.x;
        a.o = b.c.y;
    };
    NumericMarkerManager.$t = markType(NumericMarkerManager, 'NumericMarkerManager', MarkerManagerBase.$);
    return NumericMarkerManager;
}(MarkerManagerBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.m8 = null;
        _this.m1 = null;
        _this.m6 = null;
        _this.oy = null;
        _this.ox = null;
        _this.ne = null;
        _this.ng = null;
        _this.nh = null;
        _this.nb = new PolarFrame();
        _this.nd = new PolarFrame();
        _this.na = new PolarFrame();
        _this.m5 = null;
        _this.nc = null;
        _this.m9 = null;
        _this.nc = new PolarFrame();
        _this.nd.x = runOn(_this, _this.ow);
        _this.nb.x = runOn(_this, _this.ow);
        _this.na.x = runOn(_this, _this.ow);
        _this.ne = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.n9), runOn(_this, _this.ob), runOn(_this, _this.ca), runOn(_this, _this.jl), runOn(_this, _this.n7));
        return _this;
    }
    PolarBase.prototype.bf = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m7 = a;
    };
    PolarBase.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.m3 = null;
        this.m4 = null;
    };
    PolarBase.prototype.get_c0 = function () {
        return true;
    };
    PolarBase.prototype.nn = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.m3;
        var c = new ScalerParams(1, this.bs.mq, this.ly, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.m4;
        var e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l0.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.ly.left || h > _this.ly.right || i < _this.ly.top || i > _this.ly.bottom) {
                    return;
                }
                g.b = b.dz(h, c);
                g.c = d.dz(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    PolarBase.prototype.n7 = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    PolarBase.prototype.n8 = function () {
        this.m5.e(this.m8.w, this.ni, this.nj, this.oy, this.ox, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "ni", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            if (this.ng != a) {
                var b = this.ni;
                this.ng = a;
                this.raisePropertyChanged("AngleColumn", b, this.ni);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "nj", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            if (this.nh != a) {
                var b = this.nj;
                this.nh = a;
                this.raisePropertyChanged("RadiusColumn", b, this.nj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "or", {
        get: function () {
            return this.c(PolarBase.oc);
        },
        set: function (a) {
            this.h(PolarBase.oc, a);
        },
        enumerable: true,
        configurable: true
    });
    PolarBase.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.m4 != null) {
            this.m4.g6(false);
        }
        if (this.m3 != null) {
            this.m3.g6(false);
        }
    };
    PolarBase.prototype.hy = function (a, b, c, d) {
        var e = false;
        this.m7.cr.g$e(a, b, c, d);
        if (this.m3 != null && !this.m3.cl()) {
            e = true;
        }
        if (this.m4 != null && !this.m4.cl()) {
            e = true;
        }
        if (e) {
            this.jd(true);
        }
    };
    PolarBase.prototype.js = function (a, b) {
        this.jd(false);
    };
    PolarBase.prototype.jt = function (a, b) {
        this.jd(false);
    };
    PolarBase.prototype.dw = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dw.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.m3 == null || this.m4 == null || this.ni == null || this.nj == null || this.ni.count == 0 || this.nj.count == 0 || this.bz == null || this.bz.count != this.ni.count || this.bz.count != this.nj.count || this.m5 == null || this.m3.bf == null || this.m4.bf == null || this.m3.j4 == this.m3.j3 || this.m4.j4 == this.m4.j3) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.je = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.hv(true, this.bi);
            return;
        }
        this.oy = b;
        this.ox = c;
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        var e = new SeriesRenderingArguments(this, c, b, a, this.de);
        var f = this.ne.g(e, this.nb, this.na, this.nd, this.m7);
        this.nb = f.p1;
        this.na = f.p2;
        this.nd = f.p3;
    };
    PolarBase.prototype.ow = function (a) {
        var b = this.m5.h(a.x, a.y, this.oy, this.ox, this.m6.e, this.m6.d, this.m6.g, this.m6.f, this.m6.i, this.m6.h);
        return b;
    };
    PolarBase.prototype.an = function (a) {
        if (a != null && a == this.m3 && this.ni != null) {
            return new AxisRange(this.ni.minimum, this.ni.maximum);
        }
        if (a != null && a == this.m4 && this.nj != null) {
            return new AxisRange(this.nj.minimum, this.nj.maximum);
        }
        return null;
    };
    PolarBase.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.m3 == null || this.ni == null || this.m4 == null || this.nj == null) {
            return false;
        }
        if (d < 0 || d > this.ni.count - 1 || d > this.nj.count - 1) {
            return false;
        }
        var e = this.m3.getScaledAngle(this.ni.item(d));
        var f = this.m4.lp(this.nj.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.fp = function (a) {
        return null;
    };
    PolarBase.prototype.e8 = function (a) {
        return -1;
    };
    PolarBase.prototype.ag = function () {
        return [this.m3, this.m4];
    };
    PolarBase.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == PolarBase.$$p[1]) {
            return this.ft(a, b, this.nw);
        }
        if (c == PolarBase.$$p[5]) {
            return this.ft(a, b, this.n2);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    PolarBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.m7.cr.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.ni);
                    c.deregisterColumn(this.nj);
                    this.ni = null;
                    this.nj = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.ni = this.bw(this.nw);
                    this.nj = this.bw(this.n2);
                }
                if ((this.m4 != null && !this.m4.cl()) || (this.m3 != null && !this.m3.cl())) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.m3 != null && this.m4 != null) {
                    this.m5 = new PolarAxes(this.m4, this.m3);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if (this.m3 != null && !this.m3.cl()) {
                    this.jd(false);
                }
                else if (c != null && d == null) {
                    this.hv(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.m3 != null && this.m4 != null) {
                    this.m5 = new PolarAxes(this.m4, this.m3);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if (this.m4 != null && !this.m4.cl()) {
                    this.jd(false);
                }
                else if (c != null && d == null) {
                    this.hv(true, this.bi);
                }
                if (this.m3 != null && !this.m3.cl()) {
                    this.m3.g2();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ni);
                    this.ni = this.bw(this.nw);
                }
                break;
            case "AngleColumn":
                this.m7.cr.g$i();
                if (this.m3 != null && !this.m3.cl()) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nj);
                    this.nj = this.bw(this.n2);
                }
                break;
            case "RadiusColumn":
                this.m7.cr.g$i();
                if (this.m4 != null && !this.m4.cl()) {
                    this.jd(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.jd(false);
                this.ik();
                break;
            case PolarBase.$$p[3]:
                this.jd(false);
                this.ik();
                break;
            case "TransitionProgress":
                this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
                this.oy = this.bi.bs;
                this.ox = this.bi.br;
                this.nd.v = this.no;
                this.nd.c(this.ez, this.nb, this.na);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.ob(this.na, this.m7);
                }
                else {
                    this.ob(this.nd, this.m7);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case PolarBase.$$p[2]:
                this.jd(false);
                this.ik();
                break;
            case "TrendLineType":
                this.ik();
                break;
        }
    };
    PolarBase.prototype.nl = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.nk = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    };
    PolarBase.prototype.m2 = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.n6 = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.bz;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.ni.item(f), y: this_1.nj.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.n9 = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.ni != null ? this.ni.count : 0, this.nj != null ? this.nj.count : 0);
        if (e < 1) {
            return;
        }
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        this.m8 = a;
        this.ox = d;
        this.oy = c;
        b.cp.l(a.j, this.nr, c, d, this.eu);
        if (e <= this.nr) {
            this.n6(a, e, c, d);
        }
        var f = this.m2(d, a.n);
        var g = Math.min(this.m3.j4, this.m3.j3);
        var h = Math.max(this.m3.j3, this.m3.j4);
        b.cr.q = this.no;
        b.cr.p = 0;
        b.cr.s = this.m4.lj;
        b.cr.r = this.m4.li;
        b.cr.t = function (i, j) { return _this.m5.c(i, j, c, d, Math.cos); };
        b.cr.u = function (i, j) { return _this.m5.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.ni.count; j++) {
            if (this.ni.item(j) >= g && this.ni.item(j) <= h) {
                i.add(this.ni.item(j));
            }
        }
        var k = this.nj;
        if (i.count != this.ni.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.ni.count; l++) {
                if (this.ni.item(l) >= g && this.ni.item(l) <= h) {
                    k.add(this.nj.item(l));
                }
            }
        }
        b.cr.v(a.n, this.nf, i, k, this.ns, runOn(this.m3, this.m3.getScaledAngle), runOn(this.m4, this.m4.lp), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.ob = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.lq(b);
        this.m6 = new PolarAxisInfoCache(this.m3, this.m4, this.bz);
        b.cp.j(a.j, this.l5);
        b.cj();
        var g = this.m2(d, b.cr.g$j.ak);
        b.cr.g$h(a.n, g);
        this.n5(d, c, e, f, b);
    };
    PolarBase.prototype.n5 = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    PolarBase.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.m7.cw();
    };
    PolarBase.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = this.bh;
        if (!this.df) {
            this.nc = new PolarFrame();
            this.n9(this.nc, c);
        }
        this.df = false;
        this.ob(this.nc, c);
        this.dl = false;
    };
    PolarBase.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.m9 == null) {
            this.m9 = new PolarFrame();
        }
        this.n9(this.m9, g);
        this.ob(this.m9, g);
    };
    PolarBase.prototype.oa = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    PolarBase.prototype.m0 = function (a, b, c) {
        this.n8();
        return this.m8.w.toArray();
    };
    PolarBase.prototype.np = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.bz;
        try {
            for (var _b = __values(fromEnum(this.m7.cs.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    PolarBase.prototype.ov = function (a) {
        return { $type: Point_$type, x: this.ni.item(a), y: this.nj.item(a) };
    };
    PolarBase.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportTrendlineData(this, a, this.m7.cr.g$j);
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.oc = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    PolarBase.$$p = markDep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:m3:od', [NumericAngleAxis.$, null], 'AngleMemberPath:nw:oe', [2], 'ClipSeriesToBounds:nm:of', [0, false], 'MaximumMarkers:nr:og', [1, 400], 'RadiusAxis:m4:oh', [NumericRadiusAxis.$, null], 'RadiusMemberPath:n2:oi', [2], 'UseCartesianInterpolation:no:oq', [0, true], 'TrendLineType:nf:oo', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:nq:on', [1, 1.5], 'TrendLinePeriod:ns:om', [1, 7], 'TrendLineZIndex:nt:op', [1, 1], 'TrendLineBrush:os:oj', [Brush.$, null], 'TrendLineDashArray:ot:ok', [DoubleCollection.$], 'TrendLineDashCap:ou:ol', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return PolarBase;
}(MarkerSeries));
/**
 * @hidden
 */
var PolarBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cq = null;
        _this.cp = null;
        _this.cr = null;
        _this.cs = null;
        _this.cq = a;
        _this.cs = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cs);
        _this.cr = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cp = this.co();
        if (!this.n) {
            this.cq.nr = 1000;
            this.by.l1 = 2;
        }
    };
    PolarBaseView.prototype.co = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cs.item(b); }, function (b) { return _this.cq.m6.c.item(b); }, runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.ov);
        return a;
    };
    PolarBaseView.prototype.cv = function (a) {
        this.cq.oa(a, this.cs);
    };
    PolarBaseView.prototype.cn = function () {
        return this.cq.m0(this.cs, this.bs, this.br);
    };
    PolarBaseView.prototype.ct = function () {
        return this.cq.np(this.cs);
    };
    PolarBaseView.prototype.cu = function (a, b, c, d) {
        if (this.cq.nm) {
            var e = new GeometryGroup();
            this.cq.m4.lx(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.cw = function () {
        if (this.cq.os != null) {
            this.cq.or = this.cq.os;
        }
        else {
            this.cq.or = this.cq.k3;
        }
    };
    PolarBaseView.prototype.cc = function (a) {
        this.cs.f(a);
    };
    PolarBaseView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cq.nf != 0 && !b) {
                var c = this.cr.g$j;
                c.ac = this.cq.nq;
                c._stroke = this.cq.or;
                c.ad = this.cq.ou;
                c.ai = this.cq.ot;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    PolarBaseView.prototype.cx = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.nw + "}" + "</span><br/><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.n2 + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NaNSegmenter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NaNSegmenter, _super);
    function NaNSegmenter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NaNSegmenter.c = function (a, b) {
        var c = new List$1(IList$1_$type.specialize(Point_$type), 0);
        var d = getEnumerator(a);
        var e = new List$1(Point_$type, 0);
        var f = true;
        while (d.moveNext()) {
            if (NaNSegmenter.a(d.current)) {
                if (!f && b == 1) {
                    f = true;
                    var g = e;
                    e = new List$1(Point_$type, 0);
                    c.add(new ReadOnlyCollection$1(Point_$type, 1, g));
                }
            }
            else {
                f = false;
                e.add(d.current);
            }
        }
        c.add(new ReadOnlyCollection$1(Point_$type, 1, e));
        return c;
    };
    NaNSegmenter.a = function (a) {
        return (isNaN_(a.x) || isNaN_(a.y) || isInfinity(a.x) || isInfinity(a.y));
    };
    NaNSegmenter.b = function (a) {
        return !NaNSegmenter.a(a);
    };
    NaNSegmenter.$t = markType(NaNSegmenter, 'NaNSegmenter');
    return NaNSegmenter;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PathRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PathRenderer, _super);
    function PathRenderer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this.b = 1;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this.a = c;
                }
                break;
        }
        return _this;
    }
    PathRenderer.prototype.d = function (a, b, c) {
        var e_1, _a;
        var d = NaNSegmenter.c(b, this.b);
        var e = this.c(d, c);
        var f = new PathGeometry();
        try {
            for (var _b = __values(fromEnum(e)), _d = _b.next(); !_d.done; _d = _b.next()) {
                var g = _d.value;
                f.c.add(g);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        a.ak = f;
    };
    PathRenderer.prototype._c = function (a, b) {
        var c, d, e, f, g;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    c = 0;
                    _a.label = 1;
                case 1:
                    if (!(c < a.count))
                        return [3 /*break*/, 4];
                    d = a.item(c);
                    if (!(d.count >= 2))
                        return [3 /*break*/, 3];
                    e = new PathFigure();
                    f = d.item(0);
                    e._startPoint = f;
                    g = this.e(d, b);
                    e._segments.add(g);
                    return [4 /*yield*/, e];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    c++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    PathRenderer.prototype.c = function (a, b) {
        var _this = this;
        return toEnum(function () { return _this._c(a, b); });
    };
    PathRenderer.prototype.e = function (a, b) {
        var c = new PolyLineSegment();
        if (this.a == null) {
            for (var d = 1; d < a.count; d++) {
                var e = a.item(d);
                c._points.add(e);
            }
        }
        else {
            var f = this.a.flatten(a, b);
            for (var g = 1; g < f.count; g++) {
                var h = f.item(g);
                c._points.add(h);
            }
        }
        return c;
    };
    PathRenderer.$t = markType(PathRenderer, 'PathRenderer');
    return PathRenderer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IFlattener_$type = /*@__PURE__*/ new Type(null, 'IFlattener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DefaultFlattener = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DefaultFlattener, _super);
    function DefaultFlattener() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DefaultFlattener.prototype.a = function (a, b, c, d, e, f) {
        var g = new List$1(Number_$type, 0);
        var h = d;
        var i = e;
        var j = i - h + 1;
        while (j > 0) {
            if (j <= 512) {
                Flattener.c(g, b, c, h, i, f);
                h = i + 1;
            }
            else {
                var k = h + 512 - 1;
                Flattener.c(g, b, c, h, k, f);
                h = k + 1;
            }
            j = i - h + 1;
        }
        return g;
    };
    DefaultFlattener.prototype.d = function (a, b, c, d, e) {
        var f = new List$1(Number_$type, 0);
        var g = c;
        var h = d;
        var i = h - g + 1;
        while (i > 0) {
            if (i <= 512) {
                FastFlattener.e(f, a, b, g, h, e);
                g = h + 1;
            }
            else {
                var j = g + 512 - 1;
                FastFlattener.e(f, a, b, g, j, e);
                g = j + 1;
            }
            i = h - g + 1;
        }
        return f;
    };
    DefaultFlattener.prototype.flatten = function (a, b) {
        var _this = this;
        var c = function (d) { return _this.f(a, d); };
        var d = function (e) { return _this.g(a, e); };
        return this.b(a, b, c, d);
    };
    DefaultFlattener.prototype.c = function (a, b, c, d) {
        return this.e(a, b, c, d);
    };
    DefaultFlattener.prototype.b = function (a, b, c, d) {
        var e = this.a(new List$1(Number_$type, 0), c, d, 0, a.count - 1, b);
        var f = new RearrangedList$1(Point_$type, a, e);
        return f;
    };
    DefaultFlattener.prototype.e = function (a, b, c, d) {
        var e = this.d(a, b, 0, c - 1, d);
        var f = new List$1(Point_$type, 0);
        for (var g = 0; g < e.count; g++) {
            f.add({ $type: Point_$type, x: a[e._inner[g]], y: b[e._inner[g]] });
        }
        return f;
    };
    DefaultFlattener.prototype.f = function (a, b) {
        return a.item(b).x;
    };
    DefaultFlattener.prototype.g = function (a, b) {
        return a.item(b).y;
    };
    DefaultFlattener.$t = markType(DefaultFlattener, 'DefaultFlattener', Base.$, [IFlattener_$type]);
    return DefaultFlattener;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarLineSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeriesBase, _super);
    function PolarLineSeriesBase() {
        var _this = _super.call(this) || this;
        _this.oz = null;
        _this.o1 = null;
        _this.o0 = null;
        _this.oz = new PathRenderer(1, new DefaultFlattener());
        _this.o1 = new PathRenderer(0);
        return _this;
    }
    PolarLineSeriesBase.prototype.bf = function () {
        return new PolarLineSeriesBaseView(this);
    };
    PolarLineSeriesBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.o2 = a;
    };
    PolarLineSeriesBase.prototype.o3 = function () {
        return 1;
    };
    PolarLineSeriesBase.prototype.get_o6 = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "o6", {
        get: function () {
            return this.get_o6();
        },
        enumerable: true,
        configurable: true
    });
    PolarLineSeriesBase.prototype.get_o8 = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "o8", {
        get: function () {
            return this.get_o8();
        },
        enumerable: true,
        configurable: true
    });
    PolarLineSeriesBase.prototype.n9 = function (a, b) {
        var _this = this;
        _super.prototype.n9.call(this, a, b);
        a.m.clear();
        var c = b.bs;
        var d = b.br;
        var e = this.ni != null ? this.ni.count : 0;
        var f = this.nj != null ? this.nj.count : 0;
        var g = Math.min(e, f);
        var h = ((function () {
            var $ret = new PolarLinePlanner();
            $ret.m = function (i) { return _this.m6.a.getScaledAngle1(_this.ni.item(i), _this.m6.e, _this.m6.d); };
            $ret.q = g;
            $ret.n = function (i) { return _this.m4.lq(_this.nj.item(i), _this.m6.g, _this.m6.f, _this.m6.i, _this.m6.h); };
            $ret.l = _this.eu;
            $ret.f = _this.no;
            $ret.b = _this.o3();
            $ret.o = function (i) { return _this.o9(a, i); };
            $ret.p = function (i) { return _this.pa(a, i); };
            $ret.ab = d;
            $ret.ac = c;
            $ret.d = _this.o8;
            $ret.c = _this.o6;
            return $ret;
        })());
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < g; j++) {
            if (this.o7(j)) {
                i.add(j);
            }
        }
        if (this.o8 && i.count > 0) {
            i.add(i._inner[0]);
        }
        h.x(a.m, i);
    };
    PolarLineSeriesBase.prototype.o9 = function (a, b) {
        return a.w._inner[b].x;
    };
    PolarLineSeriesBase.prototype.pa = function (a, b) {
        return a.w._inner[b].y;
    };
    PolarLineSeriesBase.prototype.o5 = function () {
        return !this.o4();
    };
    PolarLineSeriesBase.prototype.o4 = function () {
        var a = this.bs.mq;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    PolarLineSeriesBase.prototype.o7 = function (a) {
        return (this.ni.item(a) >= this.m6.a.j4 && this.ni.item(a) <= this.m6.a.j3 && this.nj.item(a) >= this.m6.b.j4 && this.nj.item(a) <= this.m6.b.j3) || (isNaN_(this.ni.item(a)) || isNaN_(this.nj.item(a)));
    };
    PolarLineSeriesBase.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        this.pb(b);
    };
    PolarLineSeriesBase.prototype.ob = function (a, b) {
        _super.prototype.ob.call(this, a, b);
        if (this.no) {
            this.o0 = this.oz;
        }
        else {
            this.o0 = this.o1;
        }
        this.o0.b = this.o3();
        this.pb(b);
        this.pc(a, b);
    };
    PolarLineSeriesBase.$t = markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
    return PolarLineSeriesBase;
}(PolarBase));
/**
 * @hidden
 */
var PolarLineSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeriesBaseView, _super);
    function PolarLineSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.cy = a;
        return _this;
    }
    PolarLineSeriesBaseView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    PolarLineSeriesBaseView.$t = markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);
    return PolarLineSeriesBaseView;
}(PolarBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAreaSeries, _super);
    function PolarAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarAreaSeries.$;
        return _this;
    }
    PolarAreaSeries.prototype.bf = function () {
        return new PolarAreaSeriesView(this);
    };
    PolarAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pd = a;
    };
    PolarAreaSeries.prototype.pb = function (a) {
        var b = a;
        b.c0();
    };
    PolarAreaSeries.prototype.pc = function (a, b) {
        if (a.m.count > 0) {
            var c = a.m._inner[0];
            var d = a.m._inner[a.m.count - 1];
            var e = c.x == d.x && c.y == d.y;
            if (!e) {
                a.m.add(a.m._inner[0]);
            }
        }
        var f = b;
        f.c3._opacity = this.d6;
        f.c1(a.m, this.eu);
    };
    PolarAreaSeries.prototype.get_o8 = function () {
        return true;
    };
    PolarAreaSeries.prototype.o3 = function () {
        return this.pe;
    };
    PolarAreaSeries.$t = markType(PolarAreaSeries, 'PolarAreaSeries', PolarLineSeriesBase.$);
    PolarAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:pe:pg', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return PolarAreaSeries;
}(PolarLineSeriesBase));
/**
 * @hidden
 */
var PolarAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarAreaSeriesView, _super);
    function PolarAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cz = null;
        _this.c4 = new Path();
        _this.c2 = new Path();
        _this.cz = a;
        return _this;
    }
    PolarAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(PolarAreaSeriesView.prototype, "c3", {
        get: function () {
            return this.c2;
        },
        enumerable: true,
        configurable: true
    });
    PolarAreaSeriesView.prototype.c0 = function () {
        this.c2.ak = null;
        this.c4.ak = null;
        this.an();
    };
    PolarAreaSeriesView.prototype.c1 = function (a, b) {
        var c = new List$1(Point_$type, 1, a);
        this.cz.o0.d(this.c4, c, b);
        this.cz.o0.d(this.c2, c, b);
        this.an();
    };
    PolarAreaSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c4._stroke = this.e.k4;
        this.c4.ac = this.e.ey;
        this.c4.ai = this.e.lb;
        this.c4.ad = this.e.lc;
        this.c2._fill = this.e.k3;
        this.c2._opacity = this.e.d6;
    };
    PolarAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
        this.c2._fill = a;
        this.c2._opacity = 1;
    };
    PolarAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c2);
            a.s(this.c4);
        }
    };
    PolarAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c4, "polarShape", ["Main"]);
        this.e.a2.exportPathData(a, this.c2, "fillShape", ["Fill"]);
    };
    PolarAreaSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    };
    PolarAreaSeriesView.$t = markType(PolarAreaSeriesView, 'PolarAreaSeriesView', PolarLineSeriesBaseView.$);
    return PolarAreaSeriesView;
}(PolarLineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent polar area series.
*/
var IgrPolarAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarAreaSeries, _super);
    function IgrPolarAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPolarAreaSeries.prototype.createImplementation = function () {
        return new PolarAreaSeries();
    };
    Object.defineProperty(IgrPolarAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarAreaSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.pe;
        },
        set: function (v) {
            this.i.pe = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarAreaSeries;
}(IgrPolarLineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPolarAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPolarAreaSeriesModule() {
    }
    IgrPolarAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrPolarAreaSeries", IgrPolarAreaSeries);
        TypeRegistrar.register("PolarAreaSeries", PolarAreaSeries.$type);
    };
    return IgrPolarAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeries, _super);
    function PolarLineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarLineSeries.$;
        return _this;
    }
    PolarLineSeries.prototype.bf = function () {
        return new PolarLineSeriesView(this);
    };
    PolarLineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pd = a;
    };
    PolarLineSeries.prototype.pb = function (a) {
        var b = a;
        b.c0();
    };
    PolarLineSeries.prototype.pc = function (a, b) {
        var c = b;
        c.c1(a.m, this.eu);
    };
    PolarLineSeries.prototype.o3 = function () {
        return this.pe;
    };
    PolarLineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case PolarLineSeries.$$p[0]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    PolarLineSeries.$t = markType(PolarLineSeries, 'PolarLineSeries', PolarLineSeriesBase.$);
    PolarLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:pe:pg', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return PolarLineSeries;
}(PolarLineSeriesBase));
/**
 * @hidden
 */
var PolarLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarLineSeriesView, _super);
    function PolarLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cz = null;
        _this.c2 = new Path();
        _this.cz = a;
        return _this;
    }
    PolarLineSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
    };
    PolarLineSeriesView.prototype.c0 = function () {
        this.c2.ak = null;
        this.an();
    };
    PolarLineSeriesView.prototype.c1 = function (a, b) {
        this.cz.o0.d(this.c2, a, b);
        this.an();
    };
    PolarLineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c2._stroke = this.e.k3;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.lb;
        this.c2.ad = this.e.lc;
    };
    PolarLineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
    };
    PolarLineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        a.s(this.c2);
    };
    PolarLineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c2, "polarShape", ["Main"]);
    };
    PolarLineSeriesView.$t = markType(PolarLineSeriesView, 'PolarLineSeriesView', PolarLineSeriesBaseView.$);
    return PolarLineSeriesView;
}(PolarLineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent polar line series.
*/
var IgrPolarLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarLineSeries, _super);
    function IgrPolarLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPolarLineSeries.prototype.createImplementation = function () {
        return new PolarLineSeries();
    };
    Object.defineProperty(IgrPolarLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarLineSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.pe;
        },
        set: function (v) {
            this.i.pe = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarLineSeries;
}(IgrPolarLineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPolarLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPolarLineSeriesModule() {
    }
    IgrPolarLineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrPolarLineSeries", IgrPolarLineSeries);
        TypeRegistrar.register("PolarLineSeries", PolarLineSeries.$type);
    };
    return IgrPolarLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarScatterSeries, _super);
    function PolarScatterSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarScatterSeries.$;
        return _this;
    }
    PolarScatterSeries.prototype.bf = function () {
        return new PolarScatterSeriesView(this);
    };
    PolarScatterSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oz = a;
    };
    PolarScatterSeries.$t = markType(PolarScatterSeries, 'PolarScatterSeries', PolarBase.$);
    return PolarScatterSeries;
}(PolarBase));
/**
 * @hidden
 */
var PolarScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarScatterSeriesView, _super);
    function PolarScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.cy = a;
        return _this;
    }
    PolarScatterSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    PolarScatterSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    };
    PolarScatterSeriesView.$t = markType(PolarScatterSeriesView, 'PolarScatterSeriesView', PolarBaseView.$);
    return PolarScatterSeriesView;
}(PolarBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent polar scatter series.
*/
var IgrPolarScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarScatterSeries, _super);
    function IgrPolarScatterSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPolarScatterSeries.prototype.createImplementation = function () {
        return new PolarScatterSeries();
    };
    Object.defineProperty(IgrPolarScatterSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarScatterSeries;
}(IgrPolarBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPolarScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPolarScatterSeriesModule() {
    }
    IgrPolarScatterSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrPolarScatterSeries", IgrPolarScatterSeries);
        TypeRegistrar.register("PolarScatterSeries", PolarScatterSeries.$type);
    };
    return IgrPolarScatterSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineSeries, _super);
    function PolarSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarSplineSeries.$;
        return _this;
    }
    PolarSplineSeries.prototype.bf = function () {
        return new PolarSplineSeriesView(this);
    };
    PolarSplineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pd = a;
    };
    PolarSplineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case PolarSplineSeries.$$p[0]:
                this.jd(false);
                break;
        }
    };
    PolarSplineSeries.prototype.pb = function (a) {
        var b = a;
        b.c0();
    };
    PolarSplineSeries.prototype.pc = function (a, b) {
        this.pb(b);
        var c = b;
        c.c1(a.m, this.pe);
    };
    PolarSplineSeries.$t = markType(PolarSplineSeries, 'PolarSplineSeries', PolarLineSeriesBase.$);
    PolarSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineSeries, 'raisePropertyChanged', ['Stiffness:pe:pg', [1, 0.5]]);
    return PolarSplineSeries;
}(PolarLineSeriesBase));
/**
 * @hidden
 */
var PolarSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineSeriesView, _super);
    function PolarSplineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cz = null;
        _this.c2 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cz = a;
        return _this;
    }
    PolarSplineSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        var a = new PathGeometry();
        a.c.add(((function () {
            var $ret = new PathFigure();
            return $ret;
        })()));
        this.c2.ak = a;
    };
    PolarSplineSeriesView.prototype.c0 = function () {
        Extensions.e(this.c2.ak);
        this.an();
    };
    PolarSplineSeriesView.prototype.c1 = function (a, b) {
        this.c2.ak.c = Numeric.h(a.count, function (c) { return a._inner[c].x; }, function (c) { return a._inner[c].y; }, b);
        this.an();
    };
    PolarSplineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c2._stroke = this.e.k3;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.lb;
        this.c2.ad = this.e.lc;
    };
    PolarSplineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
    };
    PolarSplineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        a.s(this.c2);
    };
    PolarSplineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c2, "polarShape", ["Main"]);
    };
    PolarSplineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    PolarSplineSeriesView.$t = markType(PolarSplineSeriesView, 'PolarSplineSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineSeriesView;
}(PolarLineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent polar spline series.
*/
var IgrPolarSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarSplineSeries, _super);
    function IgrPolarSplineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPolarSplineSeries.prototype.createImplementation = function () {
        return new PolarSplineSeries();
    };
    Object.defineProperty(IgrPolarSplineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarSplineSeries.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: function () {
            return this.i.pe;
        },
        set: function (v) {
            this.i.pe = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarSplineSeries;
}(IgrPolarLineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPolarSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPolarSplineSeriesModule() {
    }
    IgrPolarSplineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrPolarSplineSeries", IgrPolarSplineSeries);
        TypeRegistrar.register("PolarSplineSeries", PolarSplineSeries.$type);
    };
    return IgrPolarSplineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolarSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineAreaSeries, _super);
    function PolarSplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarSplineAreaSeries.$;
        return _this;
    }
    PolarSplineAreaSeries.prototype.bf = function () {
        return new PolarSplineAreaSeriesView(this);
    };
    PolarSplineAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.pd = a;
    };
    PolarSplineAreaSeries.prototype.pb = function (a) {
        var b = a;
        b.c0();
    };
    PolarSplineAreaSeries.prototype.pc = function (a, b) {
        this.pb(b);
        if (a.m.count < 1) {
            return;
        }
        var c = b;
        c.c3._opacity = this.d6;
        c.c1(a.m, this.pe);
    };
    PolarSplineAreaSeries.prototype.get_o8 = function () {
        return true;
    };
    PolarSplineAreaSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case PolarSplineAreaSeries.$$p[0]:
                this.jd(false);
                break;
        }
    };
    PolarSplineAreaSeries.$t = markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
    PolarSplineAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:pe:pg', [1, 0.5]]);
    return PolarSplineAreaSeries;
}(PolarLineSeriesBase));
/**
 * @hidden
 */
var PolarSplineAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolarSplineAreaSeriesView, _super);
    function PolarSplineAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cz = null;
        _this.c4 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.c2 = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cz = a;
        return _this;
    }
    PolarSplineAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(PolarSplineAreaSeriesView.prototype, "c3", {
        get: function () {
            return this.c2;
        },
        enumerable: true,
        configurable: true
    });
    PolarSplineAreaSeriesView.prototype.c0 = function () {
        Extensions.e(this.c2.ak);
        Extensions.e(this.c4.ak);
        this.an();
    };
    PolarSplineAreaSeriesView.prototype.c1 = function (a, b) {
        this.c4.ak.c = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.c2.ak.c = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.an();
    };
    PolarSplineAreaSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c2._fill = this.e.k3;
        this.c2._opacity = this.e.d6;
        this.c4._stroke = this.e.k4;
        this.c4.ac = this.e.ey;
        this.c4.ai = this.e.lb;
        this.c4.ad = this.e.lc;
    };
    PolarSplineAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c2._fill = a;
        this.c2._opacity = 1;
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
    };
    PolarSplineAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c2);
            a.s(this.c4);
        }
    };
    PolarSplineAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c4, "polarShape", ["Main"]);
        this.e.a2.exportPathData(a, this.c2, "fillShape", ["Fill"]);
    };
    PolarSplineAreaSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    };
    PolarSplineAreaSeriesView.$t = markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineAreaSeriesView;
}(PolarLineSeriesBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent polar spline area series.
*/
var IgrPolarSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPolarSplineAreaSeries, _super);
    function IgrPolarSplineAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrPolarSplineAreaSeries.prototype.createImplementation = function () {
        return new PolarSplineAreaSeries();
    };
    Object.defineProperty(IgrPolarSplineAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPolarSplineAreaSeries.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: function () {
            return this.i.pe;
        },
        set: function (v) {
            this.i.pe = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPolarSplineAreaSeries;
}(IgrPolarLineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPolarSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPolarSplineAreaSeriesModule() {
    }
    IgrPolarSplineAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrPolarSplineAreaSeries", IgrPolarSplineAreaSeries);
        TypeRegistrar.register("PolarSplineAreaSeries", PolarSplineAreaSeries.$type);
    };
    return IgrPolarSplineAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartPolarModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartPolarModule() {
    }
    IgrDataChartPolarModule.register = function () {
        IgrPolarAreaSeriesModule.register();
        IgrPolarLineSeriesModule.register();
        IgrPolarScatterSeriesModule.register();
        IgrPolarSplineSeriesModule.register();
        IgrPolarSplineAreaSeriesModule.register();
        IgrDataChartPolarCoreModule.register();
    };
    return IgrDataChartPolarModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartRadialCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartRadialCoreModule() {
    }
    IgrDataChartRadialCoreModule.register = function () {
        IgrCategoryAngleAxisModule.register();
        IgrNumericRadiusAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartRadialCoreModule;
}());

/**
 * Represents the base class for all IgxDataChartComponent radial series
*/
var IgrRadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRadialBase, _super);
    function IgrRadialBase(props) {
        var _this = _super.call(this, props) || this;
        _this._angleAxisName = null;
        _this._valueAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrRadialBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "isRadial", {
        /**
         * Checks if this series is a radial series
        */
        get: function () {
            return this.i.c2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "angleAxis", {
        /**
         * Gets the effective angle axis for the current series object.
        */
        get: function () {
            if (this.i.m0 == null) {
                return null;
            }
            if (!this.i.m0.externalObject) {
                var e = IgrCategoryAngleAxis._createFromInternal(this.i.m0);
                if (e) {
                    e._implementation = this.i.m0;
                }
                this.i.m0.externalObject = e;
            }
            return this.i.m0.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m0 = null : this.i.m0 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "angleAxisName", {
        /**
        * Gets or sets the name to use to resolve angleAxis from markup.
        */
        get: function () {
            return this._angleAxisName;
        },
        set: function (v) {
            this._angleAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "valueAxis", {
        /**
         * Gets the effective value axis for the current series object.
        */
        get: function () {
            if (this.i.m2 == null) {
                return null;
            }
            if (!this.i.m2.externalObject) {
                var e = IgrNumericRadiusAxis._createFromInternal(this.i.m2);
                if (e) {
                    e._implementation = this.i.m2;
                }
                this.i.m2.externalObject = e;
            }
            return this.i.m2.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.m2 = null : this.i.m2 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "valueAxisName", {
        /**
        * Gets or sets the name to use to resolve valueAxis from markup.
        */
        get: function () {
            return this._valueAxisName;
        },
        set: function (v) {
            this._valueAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialBase.prototype, "clipSeriesToBounds", {
        /**
         * Gets or sets whether to clip the series to the bounds.
         * Setting this property to true will decrease chart performance.
        */
        get: function () {
            return this.i.nb;
        },
        set: function (v) {
            this.i.nb = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgrRadialBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.angleAxisName && this.angleAxisName.length > 0 &&
                axes[i].name == this.angleAxisName) {
                this.angleAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.valueAxisName && this.valueAxisName.length > 0 &&
                axes[i].name == this.valueAxisName) {
                this.valueAxis = axes[i];
            }
        }
    };
    IgrRadialBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.angleAxis && this.angleAxis._styling) {
            this.angleAxis._styling(container, component, this);
        }
        if (this.valueAxis && this.valueAxis._styling) {
            this.valueAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Determine if object can be used as ValueAxis
    
    * @param axis  * The object to check
    */
    IgrRadialBase.prototype.canUseAsValueAxis = function (axis) {
        var iv = this.i.na(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as AngleAxis
    
    * @param axis  * The object to check
    */
    IgrRadialBase.prototype.canUseAsAngleAxis = function (axis) {
        var iv = this.i.m9(axis);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrRadialBase.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Gets the angle to the provided world position from the center of the radial series.
    
    * @param world  * The world position to get the angle for
    */
    IgrRadialBase.prototype.getAngleFromWorld = function (world) {
        var iv = this.i.nd(toPoint(world));
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    IgrRadialBase.prototype.getExactItemIndex = function (world) {
        var iv = this.i.ne(toPoint(world));
        return (iv);
    };
    /**
     * Get the index of the item near the provided world coordinates.
    
    * @param world  * The world coordinates for which to getch the item index.
    */
    IgrRadialBase.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Scrolls the specified item into the view.
    
    * @param item  * The item to scroll into view.
    */
    IgrRadialBase.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrRadialBase.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrRadialBase.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    return IgrRadialBase;
}(IgrMarkerSeries));

/**
 * Represents the base class for all IgxDataChartComponent anchored radial category series.
*/
var IgrAnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAnchoredRadialSeries, _super);
    function IgrAnchoredRadialSeries(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "valueMemberPath", {
        /**
         * Gets or sets the item path that provides the values for the current series.
        */
        get: function () {
            return this.i.n8;
        },
        set: function (v) {
            this.i.n8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current series object.
        */
        get: function () {
            return this.i.nu;
        },
        set: function (v) {
            this.i.nu = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush that specifies how to the current series
         * object's Trend line is drawn.
        */
        get: function () {
            return brushToString(this.i.om);
        },
        set: function (v) {
            this.i.om = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this series.
        */
        get: function () {
            return brushToString(this.i.ol);
        },
        set: function (v) {
            this.i.ol = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current series object's trend line.
        */
        get: function () {
            return this.i.n4;
        },
        set: function (v) {
            this.i.n4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the trend line period for the current series.
         * The typical, and initial, value for bollinger band periods is 20.
        */
        get: function () {
            return this.i.n5;
        },
        set: function (v) {
            this.i.n5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAnchoredRadialSeries.prototype, "trendLineZIndex", {
        /**
         * Sets or Gets the Z index of the trendline.
        */
        get: function () {
            return this.i.n6;
        },
        set: function (v) {
            this.i.n6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrAnchoredRadialSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    IgrAnchoredRadialSeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrAnchoredRadialSeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrAnchoredRadialSeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrAnchoredRadialSeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrAnchoredRadialSeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrAnchoredRadialSeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    /**
     * Scrolls the specified item into the view.
    
    * @param item  * The item to scroll into view.
    */
    IgrAnchoredRadialSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    return IgrAnchoredRadialSeries;
}(IgrRadialBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialFrame, _super);
    function RadialFrame(a) {
        return _super.call(this, a) || this;
    }
    RadialFrame.$t = markType(RadialFrame, 'RadialFrame', CategoryFrame.$);
    return RadialFrame;
}(CategoryFrame));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBucketCalculator, _super);
    function RadialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        _this.a = a;
        return _this;
    }
    RadialBucketCalculator.prototype.getBucket = function (a) {
        throw new NotImplementedException(0);
    };
    RadialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    RadialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    RadialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cn.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    RadialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bs;
        var c = this.a.br;
        var d = this.a.cn.m0;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cn.bz == null || this.a.cn.bz.count == 0) {
            this.b = 0;
            return;
        }
        var e = Math.floor(d.ld(c, b));
        var f = Math.ceil(d.lc(c, b));
        if (d.b8) {
            f = Math.ceil(d.ld(c, b));
            e = Math.floor(d.lc(c, b));
        }
        if (f < e) {
            f = d.jy + f;
        }
        var g = this.a.cn.m2;
        var h = g != null ? g.lj : 0.75;
        var i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        var j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    };
    RadialBucketCalculator.prototype.cacheValues = function () {
    };
    RadialBucketCalculator.prototype.unCacheValues = function () {
    };
    RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
    return RadialBucketCalculator;
}(Base));
/**
 * @hidden
 */
var RadialBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBase, _super);
    function RadialBase() {
        var _this = _super.call(this) || this;
        _this.m8 = null;
        _this.m6 = new RadialFrame(3);
        _this.m7 = new RadialFrame(3);
        _this.m5 = new RadialFrame(3);
        _this.m3 = null;
        _this.m8 = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(_this, _this.nk), runOn(_this, _this.nl), runOn(_this, _this.ca), runOn(_this, _this.jl), runOn(_this, _this.nj), function (a) { return _this.m4.co.e(_this.eu); });
        return _this;
    }
    RadialBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m4 = a;
    };
    RadialBase.prototype.nj = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    Object.defineProperty(RadialBase.prototype, "categoryAxis", {
        get: function () {
            return this.m0;
        },
        enumerable: true,
        configurable: true
    });
    RadialBase.prototype.ap = function () {
        return this.m0;
    };
    RadialBase.prototype.nc = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.m0;
        var c = new ScalerParams(1, this.bs.mq, this.ly, b.b8);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.m2;
        var e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l0.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.ly.left || h > _this.ly.right || i < _this.ly.top || i > _this.ly.bottom) {
                    return;
                }
                g.b = b.dz(h, c);
                g.c = d.dz(i, e);
                g.d = b.fj(f.ak);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    RadialBase.prototype.get_c2 = function () {
        return true;
    };
    RadialBase.prototype.ag = function () {
        return [this.m0, this.m2];
    };
    RadialBase.prototype.jt = function (a, b) {
        this.m4.co.e(this.eu);
        this.jd(false);
    };
    RadialBase.prototype.js = function (a, b) {
        this.m4.co.e(this.eu);
        this.jd(false);
    };
    RadialBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.m0 != null) {
                        this.m0.bv(this);
                    }
                    if (this.m2 != null) {
                        this.m2.bv(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.m0 != null) {
                        this.m0.ci(this);
                    }
                    if (this.m2 != null) {
                        this.m2.ci(this);
                    }
                }
                this.m4.co.e(this.eu);
                this.jd(false);
                break;
            case RadialBase.$$p[0]:
                if (this.m0 != null && this.m2 != null) {
                    this.m3 = new RadialAxes(this.m2, this.m0);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.m4.co.e(this.eu);
                this.jd(false);
                break;
            case RadialBase.$$p[2]:
                if (this.m0 != null && this.m2 != null) {
                    this.m3 = new RadialAxes(this.m2, this.m0);
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.m4.co.e(this.eu);
                if (this.m2 == null || !this.m2.cl()) {
                    this.jd(false);
                }
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.m4.co.e(this.eu);
                    this.jd(false);
                }
                break;
            case "TransitionProgress":
                this.m7.c(this.ez, this.m6, this.m5);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.nl(this.m5, this.m4);
                }
                else {
                    this.nl(this.m7, this.m4);
                }
                if (this.bs != null) {
                    this.bs.jj(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.jd(false);
                this.ik();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.m4.co.e(this.eu);
                }
                break;
        }
    };
    RadialBase.prototype.na = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.m9 = function (a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    RadialBase.prototype.fp = function (a) {
        var b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    RadialBase.prototype.nd = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        if (this.m0 != null && !b.isEmpty && !c.isEmpty && this.m3 != null) {
            var d = this.m3.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    };
    RadialBase.prototype.ne = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = -1;
        if (this.m0 != null && !b.isEmpty && !c.isEmpty && this.m3 != null) {
            var e = this.m3.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            var f = this.m0.getUnscaledAngle(e);
            if (this.m0.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    };
    RadialBase.prototype.e8 = function (a) {
        var b = truncate(Math.round(this.ne(a)));
        if (this.bz != null && b == this.bz.count) {
            b = 0;
        }
        return b;
    };
    RadialBase.prototype.c9 = function (a) {
        return false;
    };
    RadialBase.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.m0 != null) {
            this.m0.g6(false);
        }
        if (this.m2 != null) {
            this.m2.g6(false);
        }
    };
    RadialBase.prototype.dw = function (a, b, c) {
        var d = true;
        var e = c;
        if (!_super.prototype.dw.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.m0 == null || this.m0.itemsSource == null || this.m2 == null || this.m3 == null || this.bz == null || this.m0.bf == null || this.m2.bf == null || this.m2.j4 == this.m2.j3) {
            e.co.b = 0;
            d = false;
        }
        return d;
    };
    RadialBase.prototype.je = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.hv(true, this.bi);
            return;
        }
        var e = new SeriesRenderingArguments(this, c, b, a, this.de);
        var f = this.m8.g(e, this.m6, this.m5, this.m7, this.m4);
        this.m6 = f.p1;
        this.m5 = f.p2;
        this.m7 = f.p3;
    };
    RadialBase.prototype.nf = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(RadialBase.$, b);
                if (c != null && c.m0 == this.m0 && c.preferredCategoryMode(c.m0) == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
    RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:m0:nm', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:nb:nn', [0, false], 'ValueAxis:m2:no', [NumericRadiusAxis.$, null]]);
    return RadialBase;
}(MarkerSeries));
/**
 * @hidden
 */
var RadialBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialBaseView, _super);
    function RadialBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.co = null;
        _this.cn = null;
        _this.cp = null;
        _this.cq = 0;
        _this.cr = null;
        _this.cn = a;
        _this.cp = new Pool$1(Marker.$);
        _this.cf(_this.cp);
        return _this;
    }
    RadialBaseView.prototype.cc = function (a) {
        this.cp.c(a);
    };
    RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);
    return RadialBaseView;
}(MarkerSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialTrendLineManager, _super);
    function RadialTrendLineManager() {
        var _this = _super.call(this, Number_$type) || this;
        _this.q = 0;
        _this.p = 0;
        _this.r = null;
        _this.s = null;
        return _this;
    }
    RadialTrendLineManager.prototype.get_g$a = function () {
        return 3;
    };
    Object.defineProperty(RadialTrendLineManager.prototype, "g$a", {
        get: function () {
            return this.get_g$a();
        },
        enumerable: true,
        configurable: true
    });
    RadialTrendLineManager.prototype.t = function (a, b, c, d, e, f, g, h) {
        var i = g.d * g.c;
        var j = g.e * g.c;
        var k = new List$1(Point_$type, 0);
        if (!g.g.isEmpty && !g.f.isEmpty) {
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(k, b, g, this.a, c.count, function (l) { return (l + 1); }, function (l) { return c.item(l); }, function (l) { return e(l - 1); }, f, i + 1, j + 1);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.b(b, this.d, c, d);
                for (var l = g.d; l <= g.e; l += 1) {
                    var m = (l % c.count) * g.c;
                    if (m >= 0 && m < this.d.count) {
                        var n = e(m);
                        var o = f(this.d._inner[m]);
                        if (!isNaN_(n) && !isNaN_(o)) {
                            k.add({ $type: Point_$type, x: n + g.a, y: o });
                        }
                    }
                }
            }
            if (k.count > 0) {
                this.n(k, g, a, h);
            }
        }
    };
    RadialTrendLineManager.prototype.m = function (a, b, c) {
        this.n(a, b, c, null);
    };
    RadialTrendLineManager.prototype.n = function (a, b, c, d) {
        var _this = this;
        if (d != null) {
            d.i = c;
        }
        var e = ((function () {
            var $ret = new PolarLinePlanner();
            $ret.m = function (f) { return a.item(f).x; };
            $ret.n = function (f) { return a.item(f).y; };
            $ret.a = d;
            $ret.q = a.count;
            $ret.l = b.b;
            $ret.o = function (f) { return _this.r(a.item(f).x, a.item(f).y); };
            $ret.p = function (f) { return _this.s(a.item(f).x, a.item(f).y); };
            $ret.f = true;
            $ret.ab = b.f;
            $ret.ac = b.g;
            return $ret;
        })());
        e.x(null, null);
    };
    RadialTrendLineManager.$t = markType(RadialTrendLineManager, 'RadialTrendLineManager', TrendLineManagerBase$1.$.specialize(Number_$type));
    return RadialTrendLineManager;
}(TrendLineManagerBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cs.nw;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.nr = null;
        _this.nv = null;
        _this.op = { $type: Point_$type, x: 0, y: 0 };
        _this.nt = null;
        _this.ns = null;
        _this.nt = new RadialFrame(3);
        _this.nr = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bf = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.m0 = null;
        this.m2 = null;
    };
    AnchoredRadialSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.ft(a, b, this.n8);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.nq = a;
    };
    AnchoredRadialSeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.m0, null, this.nw);
    };
    AnchoredRadialSeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.m0, null, this.nw);
    };
    AnchoredRadialSeries.prototype.d9 = function (a, b, c, d, e) {
        if (this.nw == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.m0, d, e, this.nw.count, null);
    };
    AnchoredRadialSeries.prototype.en = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.n1(this.m0, this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.m0.b8, d);
        f.c = this.bs.m3;
        return this.ep(this.nw, a, this.m0, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.ll = function (a, b, c) {
        if (this.m2 == null || this.m0 == null || this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bi.bs, this.bi.br, this.m2.b8, d);
        e.c = this.getEffectiveViewport1(this.bi);
        var f = this.en(a, b, c);
        f = this.m2.dw(f, e);
        var g = this.m3.c(a);
        if (!b && this.m0 != null) {
            var h = this.fe(a, c);
            var i = this.fc(a, c);
            var j = this.n1(this.m0, this.bi.bs, this.bi.br, d);
            var k = new ScalerParams(0, this.bi.bs, this.bi.br, this.m0.b8, d);
            k.c = this.bs.m3;
            var l = this.d9(a, h, this.m0, k, j);
            var m = this.d9(a, i, this.m0, k, j);
            if (m <= l) {
                g = this.m0.dw(i, k) + j;
            }
            else {
                g = this.m0.dw(h, k) + j;
            }
        }
        var n = this.m3.d(g, f, this.bi.bs, this.bi.br);
        var o = this.m3.e(g, f, this.bi.bs, this.bi.br);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "nw", {
        get: function () {
            return this.nv;
        },
        set: function (a) {
            if (this.nv != a) {
                var b = this.nv;
                this.nv = a;
                this.raisePropertyChanged("ValueColumn", b, this.nv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredRadialSeries.prototype, "ol", {
        get: function () {
            return this.c(AnchoredRadialSeries.oc);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.oc, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.an = function (a) {
        if (a != null && a == this.m0 && this.nw != null && this.nw.count > 0) {
            return new AxisRange(0, this.nw.count - 1);
        }
        if (a != null && a == this.m2 && this.nw != null && this.nw.count > 0) {
            return new AxisRange(this.nw.minimum, this.nw.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.nq.ct.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        var e = typeCast(NumericAxisBase.$, this.m2);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.nw);
                    this.nw = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.nw = this.bw(this.n8);
                    this.nq.co.e(this.eu);
                }
                if (e != null && !e.cl()) {
                    this.nq.co.e(this.eu);
                    this.jd(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nw);
                    this.nw = this.bw(this.n8);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.cl()) {
                    this.nq.co.e(this.eu);
                    this.jd(false);
                }
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case "TrendLineType":
                this.ik();
                break;
        }
    };
    AnchoredRadialSeries.prototype.hy = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.nq.co.e(this.eu);
                break;
        }
        this.nq.ct.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.m2 != null && !this.m2.cl()) {
                    this.jd(true);
                }
                break;
            case 1:
                if (this.m2 != null && !this.m2.cl()) {
                    this.jd(true);
                }
                break;
            case 0:
                if (this.m2 != null && !this.m2.cl()) {
                    this.jd(true);
                }
                break;
            case 2:
                if (this.n8 != null && this.nq.co.b > 0 && this.m2 != null && !this.m2.cl()) {
                    this.jd(true);
                }
                break;
            case 3:
                if (d == this.n8) {
                    if (this.m2 != null && !this.m2.cl()) {
                        this.jd(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = c;
        if (this.bz == null || this.bz.count == 0 || this.m0 == null || this.nw == null || this.m0.jy == 0 || this.m2 == null || isInfinity(this.m2.j4) || isInfinity(this.m2.j3) || e.co.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.n1(this.m0, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.m0.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.get_nz = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "nz", {
        get: function () {
            return this.get_nz();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.n1 = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.nf(), b, c, d);
                break;
        }
        if (a.b8) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.nk = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.m0;
        var g = this.m2;
        var h = g.j4;
        var i = g.j3;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.l3();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.co.d;
        n = this.n1(f, c, d, e);
        l.ct.q = this.m2.lj;
        l.ct.p = this.m2.li;
        l.ct.r = function (p, q) { return _this.n2(p, q, c, d); };
        l.ct.s = function (p, q) { return _this.n3(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.co.b;
            $ret.d = b.co.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.ct.t(a.p, this.nu, this.nw, this.n5, function (r) { return _this.m0.getScaledAngle(r); }, function (r) { return _this.m2.lp(r); }, q, p);
        var r = true;
        if (this.n0(b)) {
            o--;
        }
        for (var s = b.co.c; s <= o; ++s) {
            var t = s;
            if (t * b.co.b >= this.m0.jy) {
                t -= intDivide((this.m0.jy), b.co.b);
            }
            var u = b.co.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.lp(u[1]);
                if (b.co.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.lp(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.nz && this.ny()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.co.b, this.bz.count - 1);
                    var w = this.m3.d(u[0], u[1], c, d);
                    var x = this.m3.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.cp.item(k);
                        z.ak = v;
                        z.content.item = this.bz.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.nz && this.ny()) {
                    o++;
                }
            }
        }
        b.cp.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.n2 = function (a, b, c, d) {
        return this.m3.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.n3 = function (a, b, c, d) {
        return this.m3.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.n0 = function (a) {
        var b = a;
        return !this.nz && b.co.c == 0 && b.co.d == this.m0.jy;
    };
    AnchoredRadialSeries.prototype.np = function (a, b, c) {
        var d = null;
        var e = c.bs;
        var f = c.br;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.ob = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.nx()) {
                a.add(this.op);
                a.add(a._inner[0]);
                d.add(this.op);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.ny = function () {
        return !this.nx();
    };
    AnchoredRadialSeries.prototype.nx = function () {
        var a = this.bi.bs;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a) {
            c.cp.clear();
        }
        c.ct.g$d();
    };
    AnchoredRadialSeries.prototype.nl = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.lq(b);
        var g = b;
        g.ct.g$g(a.p);
        CategoryMarkerManager.b(this, a.m, g.cp, this.l5);
        g.cj();
        this.oa(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.oa = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.nq.cv();
    };
    AnchoredRadialSeries.prototype.fv = function (a, b) {
        if (a == this.nq.ct.g$j) {
            return null;
        }
        return _super.prototype.fv.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.m0 == null || this.nw == null || this.m2 == null) {
            return false;
        }
        if (d < 0 || d > this.nw.count - 1) {
            return false;
        }
        var e = this.m0.getScaledAngle(d);
        var f = this.m2.lp(this.nw.item(d));
        if (isNaN_(f)) {
            f = (this.m2.li + this.m2.lj) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.bh);
        c.co.e(this.eu);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.df) {
            this.nt = new RadialFrame(3);
            this.nk(this.nt, c);
        }
        this.df = false;
        this.nl(this.nt, c);
        this.dl = false;
    };
    AnchoredRadialSeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.co.e(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.ns == null) {
            this.ns = new RadialFrame(3);
        }
        this.ns.u();
        this.nk(this.ns, g);
        this.nl(this.ns, g);
    };
    AnchoredRadialSeries.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportTrendlineData(this, a, this.nq.ct.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.oc = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:n8:ok', [2, null], 'TrendLineType:nu:oi', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:n4:oh', [1, 1.5], 'TrendLinePeriod:n5:og', [1, 7], 'TrendLineZIndex:n6:oj', [1, 1], 'TrendLineBrush:om:od', [Brush.$, null], 'TrendLineDashArray:on:oe', [DoubleCollection.$], 'TrendLineDashCap:oo:of', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.ct = null;
        _this.co = new AnchoredRadialBucketCalculator(_this);
        _this.cs = a;
        _this.ct = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cu = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cv = function () {
        this.cs.ol = null;
        if (this.cs.om != null) {
            this.cs.ol = this.cs.om;
        }
        else {
            this.cs.ol = this.cs.k3;
        }
    };
    AnchoredRadialSeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cs.nu != 0 && !b) {
                var c = this.ct.g$j;
                c.ac = this.cs.n4;
                c._stroke = this.cs.ol;
                c.ai = this.cs.on;
                c.ad = this.cs.oo;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cs.m0.e7 != null) {
            a += "<span>${item." + this.cs.m0.e7 + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cs.n8 + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAreaSeries, _super);
    function RadialAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RadialAreaSeries.$;
        return _this;
    }
    RadialAreaSeries.prototype.bf = function () {
        return new RadialAreaSeriesView(this);
    };
    RadialAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oq = a;
    };
    RadialAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    RadialAreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        this.oq.cx();
    };
    RadialAreaSeries.prototype.nl = function (a, b) {
        _super.prototype.nl.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = b;
        if (b.l() && !c.isEmpty && !d.isEmpty && this.m0 != null && this.m2 != null) {
            var f = a.f;
            var g = f.count;
            var h = new List$1(Array_$type, 2, g);
            var i = 0;
            for (var j = 0; j < g; j++) {
                var k = new Array(4);
                h.add(k);
                k[0] = this.m3.d(a.f._inner[j][0], a.f._inner[j][1], c, d);
                k[1] = this.m3.e(a.f._inner[j][0], a.f._inner[j][1], c, d);
                k[2] = this.m3.d(a.f._inner[j][0], a.f._inner[j][2], c, d);
                var l = a.f._inner[j][2];
                k[3] = this.m3.e(a.f._inner[j][0], l, c, d);
                if (l > i) {
                    i = l;
                }
            }
            var m = ViewportUtils.c(0.5, c, d);
            var n = ViewportUtils.f(0.5, c, d);
            this.op = { $type: Point_$type, x: m, y: n };
            e.cy(a.f.count, h, false, this.oq.co.b, this.eu, runOn(this, this.ob), this.or);
            e.cz._opacity = this.d6;
            e.c0._opacity = this.d6 * 0.5;
        }
    };
    RadialAreaSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case RadialAreaSeries.$$p[0]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    RadialAreaSeries.prototype.get_nz = function () {
        return true;
    };
    RadialAreaSeries.$t = markType(RadialAreaSeries, 'RadialAreaSeries', AnchoredRadialSeries.$);
    RadialAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:or:ot', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialAreaSeries;
}(AnchoredRadialSeries));
/**
 * @hidden
 */
var RadialAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialAreaSeriesView, _super);
    function RadialAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cz = new Path();
        _this.c1 = new Path();
        _this.c0 = new Path();
        _this.c2 = new Path();
        _this.cw = a;
        return _this;
    }
    RadialAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    RadialAreaSeriesView.prototype.cx = function () {
        this.cz.ak = null;
        this.c1.ak = null;
        this.c0.ak = null;
        this.c2.ak = null;
        this.an();
    };
    RadialAreaSeriesView.prototype.cy = function (a, b, c, d, e, f, g) {
        this.cs.nr.i(this.cz, this.c1, this.c0, this.c2, a, b, c, d, e, f, g);
        this.an();
    };
    RadialAreaSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.cz._fill = this.e.k3;
        this.cz._opacity = this.e.d6;
        this.c0._fill = this.e.k3;
        this.c0._opacity = this.e.d6 * 0.5;
        this.c1._stroke = this.e.k4;
        this.c1.ac = this.e.ey;
        this.c1.ai = this.e.lb;
        this.c1.ad = this.e.lc;
        this.c2._stroke = this.e.k4;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.lb;
        this.c2.ad = this.e.lc;
    };
    RadialAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c1._stroke = a;
        this.c1.ac = this.e.ey + 3;
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
        this.cz._fill = a;
        this.cz._opacity = 1;
        this.c0._fill = a;
        this.c0._opacity = 1;
    };
    RadialAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.cz);
            a.s(this.c0);
            a.s(this.c1);
            a.s(this.c2);
        }
    };
    RadialAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c1, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.c2, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.c0, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.cz, "fillShape", ["Fill"]);
    };
    RadialAreaSeriesView.$t = markType(RadialAreaSeriesView, 'RadialAreaSeriesView', AnchoredRadialSeriesView.$);
    return RadialAreaSeriesView;
}(AnchoredRadialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent radial area series.
*/
var IgrRadialAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRadialAreaSeries, _super);
    function IgrRadialAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRadialAreaSeries.prototype.createImplementation = function () {
        return new RadialAreaSeries();
    };
    Object.defineProperty(IgrRadialAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialAreaSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.or;
        },
        set: function (v) {
            this.i.or = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrRadialAreaSeries;
}(IgrAnchoredRadialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRadialAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRadialAreaSeriesModule() {
    }
    IgrRadialAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrRadialAreaSeries", IgrRadialAreaSeries);
        TypeRegistrar.register("RadialAreaSeries", RadialAreaSeries.$type);
    };
    return IgrRadialAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialColumnSeries, _super);
    function RadialColumnSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RadialColumnSeries.$;
        return _this;
    }
    RadialColumnSeries.prototype.bf = function () {
        return new RadialColumnSeriesView(this);
    };
    RadialColumnSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oq = a;
    };
    RadialColumnSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    RadialColumnSeries.prototype.preferredCategoryMode = function (a) {
        return a != null && a == this.m0 ? 2 : 0;
    };
    RadialColumnSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a) {
            c.cx.count = 0;
        }
    };
    RadialColumnSeries.prototype.eg = function () {
        return this.m0.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    RadialColumnSeries.prototype.nl = function (a, b) {
        _super.prototype.nl.call(this, a, b);
        var c = a.f;
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = this.lq(b);
        var h = this.m2.jg(e, d, f, g);
        var i = b;
        var j = this.m2;
        var k = Math.max(0, 0.5 * j.li);
        k = Math.max(k, h.minLength * 0.9);
        var l = ViewportUtils.d(k, d, e);
        var m = this.m0.jr(d, e, f);
        var n = Math.max(0.1 * this.m2.lj, k);
        var o = this.m3.d(0, n, d, e);
        var p = this.m3.e(0, n, d, e);
        var q = this.m3.d(m, n, d, e);
        var r = this.m3.e(m, n, d, e);
        var s = Math.sqrt((o - q) * (o - q) + (p - r) * (p - r));
        var t = { $type: Point_$type, x: ViewportUtils.c(0.5, d, e), y: ViewportUtils.f(0.5, d, e) };
        for (var u = 0; u < c.count; ++u) {
            var v = Math.min(a.f._inner[u][2], h.maxLength * 1.1);
            var w = this.m3.d(a.f._inner[u][0], v, d, e);
            var x = this.m3.e(a.f._inner[u][0], v, d, e);
            var y = Math.sqrt((w - t.x) * (w - t.x) + (x - t.y) * (x - t.y));
            var z = y;
            var aa = l;
            var ab = a.f._inner[u][0] - (Math.PI / 2);
            var ac = i.cx.item(u);
            var ad = 0 - (s / 2);
            var ae = (s / 2);
            var af = Math.max(aa, z);
            var ag = Math.min(aa, z);
            var ah = Math.cos(ab);
            var ai = Math.sin(ab);
            var aj = { $type: Point_$type, x: t.x + (ad * ah - af * ai), y: t.y + (ad * ai + af * ah) };
            var ak = { $type: Point_$type, x: t.x + (ae * ah - af * ai), y: t.y + (ae * ai + af * ah) };
            var al = { $type: Point_$type, x: t.x + (ae * ah - ag * ai), y: t.y + (ae * ai + ag * ah) };
            var am = { $type: Point_$type, x: t.x + (ad * ah - ag * ai), y: t.y + (ad * ai + ag * ah) };
            var an = new PathGeometry();
            var ao = new PathFigure();
            ao._startPoint = aj;
            ao._isClosed = true;
            var ap = new PolyLineSegment();
            ap._points.add(ak);
            ap._points.add(al);
            ap._points.add(am);
            ao._segments.add(ap);
            an.c.add(ao);
            ac.ak = an;
        }
        i.cx.count = c.count;
        this.oq.c2();
    };
    RadialColumnSeries.$t = markType(RadialColumnSeries, 'RadialColumnSeries', AnchoredRadialSeries.$);
    RadialColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialColumnSeries, 'raisePropertyChanged', ['RadiusX:or:ov', [1, 2], 'RadiusY:os:ow', [1, 2]]);
    return RadialColumnSeries;
}(AnchoredRadialSeries));
/**
 * @hidden
 */
var RadialColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialColumnSeriesView, _super);
    function RadialColumnSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cy = null;
        _this.cw = a;
        _this.cx = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.c4);
            $ret.activate = runOn(_this, _this.cz);
            $ret.disactivate = runOn(_this, _this.c1);
            $ret.destroy = runOn(_this, _this.c0);
            return $ret;
        })());
        return _this;
    }
    RadialColumnSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cy = new List$1(Path.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    RadialColumnSeriesView.prototype.c4 = function () {
        var a = new Path();
        this.cy.add(a);
        a._visibility = 1;
        return a;
    };
    RadialColumnSeriesView.prototype.cz = function (a) {
        a._visibility = 0;
    };
    RadialColumnSeriesView.prototype.c1 = function (a) {
        a._visibility = 1;
    };
    RadialColumnSeriesView.prototype.c0 = function (a) {
        this.cy.remove(a);
    };
    RadialColumnSeriesView.prototype.c3 = function (a, b, c, d, e, f) {
        this.an();
    };
    RadialColumnSeriesView.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._fill = this.e.k3;
        c._stroke = this.e.k4;
        c.ac = this.e.ey;
        c.ai = this.e.lb;
        c.ad = this.e.lc;
    };
    RadialColumnSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    };
    RadialColumnSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.cy.count; c++) {
                var d = this.cy._inner[c];
                this.ba(d, c, b);
                a.s(d);
            }
        }
    };
    RadialColumnSeriesView.prototype.ai = function (a) {
        var e_1, _a;
        _super.prototype.ai.call(this, a);
        var b = 0;
        try {
            for (var _b = __values(fromEnum(this.cx.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                this.e.a2.exportPathData(a, c, "column" + b, ["Main", "Fill"]);
                b++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    RadialColumnSeriesView.prototype.c2 = function () {
        this.an();
    };
    RadialColumnSeriesView.$t = markType(RadialColumnSeriesView, 'RadialColumnSeriesView', AnchoredRadialSeriesView.$);
    return RadialColumnSeriesView;
}(AnchoredRadialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent radial column series.
 * Compare values across categories by using radial rectangles.
*/
var IgrRadialColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRadialColumnSeries, _super);
    function IgrRadialColumnSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRadialColumnSeries.prototype.createImplementation = function () {
        return new RadialColumnSeries();
    };
    Object.defineProperty(IgrRadialColumnSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialColumnSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.or;
        },
        set: function (v) {
            this.i.or = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialColumnSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.os;
        },
        set: function (v) {
            this.i.os = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    IgrRadialColumnSeries.prototype.onApplyTemplate = function () {
        this.i.ac();
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrRadialColumnSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrRadialColumnSeries;
}(IgrAnchoredRadialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRadialColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRadialColumnSeriesModule() {
    }
    IgrRadialColumnSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrRadialColumnSeries", IgrRadialColumnSeries);
        TypeRegistrar.register("RadialColumnSeries", RadialColumnSeries.$type);
    };
    return IgrRadialColumnSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialLineSeries, _super);
    function RadialLineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RadialLineSeries.$;
        return _this;
    }
    RadialLineSeries.prototype.bf = function () {
        return new RadialLineSeriesView(this);
    };
    RadialLineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oq = a;
    };
    RadialLineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    RadialLineSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    RadialLineSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.cx();
    };
    RadialLineSeries.prototype.nl = function (a, b) {
        _super.prototype.nl.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = a.f;
        var f = e.count;
        var g = new List$1(Array_$type, 2, f);
        var h = 0;
        for (var i = 0; i < f; i++) {
            var j = new Array(4);
            g.add(j);
            j[0] = this.m3.d(a.f._inner[i][0], a.f._inner[i][1], c, d);
            j[1] = this.m3.e(a.f._inner[i][0], a.f._inner[i][1], c, d);
            j[2] = this.m3.d(a.f._inner[i][0], a.f._inner[i][2], c, d);
            var k = a.f._inner[i][2];
            j[3] = this.m3.e(a.f._inner[i][0], k, c, d);
            if (k > h) {
                h = k;
            }
        }
        var l = b;
        l.cy(f, g, false, this.or, this.np(g, f - 1, b), l.co.b, this.eu);
    };
    RadialLineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case RadialLineSeries.$$p[0]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    RadialLineSeries.prototype.get_nz = function () {
        return true;
    };
    RadialLineSeries.$t = markType(RadialLineSeries, 'RadialLineSeries', AnchoredRadialSeries.$);
    RadialLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:or:ot', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialLineSeries;
}(AnchoredRadialSeries));
/**
 * @hidden
 */
var RadialLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialLineSeriesView, _super);
    function RadialLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.c0 = new Path();
        _this.cz = new Path();
        _this.c1 = new Path();
        _this.cw = a;
        return _this;
    }
    RadialLineSeriesView.prototype.cx = function () {
        this.c0.ak = null;
        this.cz.ak = null;
        this.c1.ak = null;
        this.an();
    };
    RadialLineSeriesView.prototype.cy = function (a, b, c, d, e, f, g) {
        this.cs.nr.m(this.c0, this.cz, this.c1, a, b, c, d, e, f, g);
        this.an();
    };
    RadialLineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c0._stroke = this.e.k3;
        this.c0.ac = this.e.ey;
        this.c0.ai = this.e.lb;
        this.c0.ad = this.e.lc;
        this.c1._stroke = this.e.k3;
        this.c1.ac = this.e.ey;
        this.c1.ai = this.e.lb;
        this.c1.ad = this.e.lc;
        this.cz._fill = this.e.k3;
        this.cz._opacity = 0.75;
    };
    RadialLineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c0._stroke = a;
        this.c0.ac = this.e.ey + 3;
        this.c1._stroke = a;
        this.c1.ac = this.e.ey + 3;
        this.cz._fill = a;
        this.cz._opacity = 1;
    };
    RadialLineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.cz);
            a.s(this.c0);
            a.s(this.c1);
        }
    };
    RadialLineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c0, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.c1, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.cz, "translucentShape", ["Translucent"]);
    };
    RadialLineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    RadialLineSeriesView.$t = markType(RadialLineSeriesView, 'RadialLineSeriesView', AnchoredRadialSeriesView.$);
    return RadialLineSeriesView;
}(AnchoredRadialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent radial line series.
*/
var IgrRadialLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRadialLineSeries, _super);
    function IgrRadialLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRadialLineSeries.prototype.createImplementation = function () {
        return new RadialLineSeries();
    };
    Object.defineProperty(IgrRadialLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialLineSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.or;
        },
        set: function (v) {
            this.i.or = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    IgrRadialLineSeries.prototype.onApplyTemplate = function () {
        this.i.ac();
    };
    return IgrRadialLineSeries;
}(IgrAnchoredRadialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRadialLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRadialLineSeriesModule() {
    }
    IgrRadialLineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrRadialLineSeries", IgrRadialLineSeries);
        TypeRegistrar.register("RadialLineSeries", RadialLineSeries.$type);
    };
    return IgrRadialLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SliceCoords = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceCoords, _super);
    function SliceCoords() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.f = null;
        _this.h = null;
        _this.j = null;
        _this.e = null;
        _this.g = null;
        _this.i = null;
        _this.k = null;
        _this.c = false;
        _this.n = new Size();
        _this.m = new Size();
        _this.l = new Size();
        return _this;
    }
    SliceCoords.b = function (a, b, c, d, e, f, g) {
        var h = Math.min(c, d);
        var i = Math.max(c, d);
        var j = Math.cos(h);
        var k = Math.sin(h);
        var l = Math.max(0, e);
        var m = f;
        var n = g.x + j * l;
        var o = g.y + k * l;
        var p = g.x + j * m;
        var q = g.y + k * m;
        var r = Math.cos(i);
        var s = Math.sin(i);
        var t = g.x + r * l;
        var u = g.y + s * l;
        var v = g.x + r * m;
        var w = g.y + s * m;
        n = ViewportUtils.c(n, a, b);
        o = ViewportUtils.f(o, a, b);
        p = ViewportUtils.c(p, a, b);
        q = ViewportUtils.f(q, a, b);
        t = ViewportUtils.c(t, a, b);
        u = ViewportUtils.f(u, a, b);
        v = ViewportUtils.c(v, a, b);
        w = ViewportUtils.f(w, a, b);
        var x = { $type: Point_$type, x: n, y: o };
        var y = { $type: Point_$type, x: p, y: q };
        var z = { $type: Point_$type, x: v, y: w };
        var aa = { $type: Point_$type, x: t, y: u };
        var ab = ViewportUtils.d(m, a, b);
        var ac = ViewportUtils.g(m, a, b);
        var ad = ViewportUtils.d(l, a, b);
        var ae = ViewportUtils.g(l, a, b);
        return ((function () {
            var $ret = new SliceCoords();
            $ret.d = x;
            $ret.f = y;
            $ret.h = z;
            $ret.j = aa;
            $ret.c = ((i - h) > Math.PI);
            $ret.n = new Size(1, ab, ac);
            $ret.m = new Size(1, ad, ae);
            return $ret;
        })());
    };
    SliceCoords.a = function (a, b, c, d, e, f, g, h, i) {
        var j = ViewportUtils.b(i, a, b);
        var k = f - e;
        if (k < 0) {
            return null;
        }
        if (ViewportUtils.d(k, a, b) < 2) {
            return null;
        }
        if (j * 2 > k) {
            j = k / 2;
            i = ViewportUtils.d(j, a, b);
        }
        var l = ViewportUtils.b(h, a, b);
        var m = l / (f - j);
        var n = Math.atan(m);
        if (n * 2 > Math.abs(d - c)) {
            n = Math.abs(d - c) / 2;
            h = ViewportUtils.d(Math.tan(n) * (f - j), a, b);
        }
        var o = SliceCoords.b(a, b, c + n, d - n, e, f, g);
        var p = SliceCoords.b(a, b, c, d, e + (j * (e / f)), f - j, g);
        o.g = o.f;
        o.k = o.j;
        o.e = p.d;
        o.f = p.f;
        o.i = p.h;
        o.j = p.j;
        o.l = new Size(1, h, i);
        return o;
    };
    SliceCoords.$t = markType(SliceCoords, 'SliceCoords');
    return SliceCoords;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RadialPieSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialPieSeries, _super);
    function RadialPieSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RadialPieSeries.$;
        return _this;
    }
    RadialPieSeries.prototype.bf = function () {
        return new RadialPieSeriesView(this);
    };
    RadialPieSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oq = a;
    };
    RadialPieSeries.prototype.preferredCategoryMode = function (a) {
        return a != null && a == this.m0 ? 2 : 0;
    };
    RadialPieSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a && c.cx != null) {
            c.cx.count = 0;
        }
    };
    RadialPieSeries.prototype.eg = function () {
        return this.m0.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    RadialPieSeries.prototype.nl = function (a, b) {
        _super.prototype.nl.call(this, a, b);
        var c = b;
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = this.lq(b);
        var h = this.m2.jg(e, d, f, g);
        var i = a.f;
        var j = this.m2;
        var k = Math.max(0, 0.5 * j.li);
        var l = k;
        l = Math.max(l, h.minLength);
        var m = this.m0.jr(d, e, f);
        var n = { $type: Point_$type, x: 0.5, y: 0.5 };
        var o = this.or;
        var p = this.os;
        var q = (o > 0 && p > 0);
        var r = 0;
        for (var s = 0; s < i.count; ++s) {
            var t = c.cx.item(s);
            var u = i._inner[s][0];
            var v = Math.min(i._inner[s][2], h.maxLength);
            var w = null;
            if (q) {
                w = this.ox(d, e, u - (m * 0.5), u + (m * 0.5), l, v, n, o, p);
            }
            else {
                w = this.oy(d, e, u - (m * 0.5), u + (m * 0.5), l, v, n);
            }
            t.ak = w;
            var x = i._inner[s][2];
            if (x > r) {
                r = x;
            }
        }
        c.cq = ViewportUtils.d(r, d, e);
        c.cr = { $type: Point_$type, x: ViewportUtils.c(n.x, d, e), y: ViewportUtils.f(n.y, d, e) };
        c.cx.count = i.count;
        c.c2();
    };
    RadialPieSeries.prototype.oy = function (a, b, c, d, e, f, g) {
        var h = SliceCoords.b(a, b, c, d, e, f, g);
        var i = new PathFigure();
        i._startPoint = h.d;
        i._isClosed = true;
        i._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = h.f;
            return $ret;
        })()));
        i._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = h.h;
            $ret.f = h.n;
            $ret.d = 1;
            $ret.b = h.c;
            return $ret;
        })()));
        i._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = h.j;
            return $ret;
        })()));
        i._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = h.d;
            $ret.f = h.m;
            $ret.d = 0;
            $ret.b = h.c;
            return $ret;
        })()));
        var j = new PathGeometry();
        j.c.add(i);
        return j;
    };
    RadialPieSeries.prototype.ox = function (a, b, c, d, e, f, g, h, i) {
        var j = SliceCoords.a(a, b, c, d, e, f, g, h, i);
        if (j == null) {
            return this.oy(a, b, c, d, e, f, g);
        }
        var k = new PathFigure();
        k._startPoint = j.d;
        k._isClosed = true;
        var l = ((c + ((d - c) * 0.5)) * 180 / Math.PI) + 90;
        var m = new Size(1, j.l.width * (e / f), j.l.height * (e / f));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.e;
            $ret.f = m;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = j.f;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.g;
            $ret.f = j.l;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.h;
            $ret.f = j.n;
            $ret.d = 1;
            $ret.b = j.c;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.i;
            $ret.f = j.l;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new LineSegment(1);
            $ret.c = j.j;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.k;
            $ret.f = m;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((function () {
            var $ret = new ArcSegment();
            $ret.e = j.d;
            $ret.f = j.m;
            $ret.d = 0;
            $ret.b = j.c;
            return $ret;
        })()));
        var n = new PathGeometry();
        n.c.add(k);
        return n;
    };
    RadialPieSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case RadialPieSeries.$$p[0]:
            case RadialPieSeries.$$p[1]:
                this.jd(false);
                break;
        }
    };
    RadialPieSeries.$t = markType(RadialPieSeries, 'RadialPieSeries', AnchoredRadialSeries.$);
    RadialPieSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialPieSeries, 'raisePropertyChanged', ['RadiusX:or:ov', [1, 2], 'RadiusY:os:ow', [1, 2]]);
    return RadialPieSeries;
}(AnchoredRadialSeries));
/**
 * @hidden
 */
var RadialPieSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RadialPieSeriesView, _super);
    function RadialPieSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cy = null;
        _this.cw = a;
        _this.cx = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.c3);
            $ret.activate = runOn(_this, _this.cz);
            $ret.disactivate = runOn(_this, _this.c1);
            $ret.destroy = runOn(_this, _this.c0);
            return $ret;
        })());
        return _this;
    }
    RadialPieSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cy = new List$1(Path.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    RadialPieSeriesView.prototype.c3 = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new Path();
            $ret.dataContext = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
            return $ret;
        })());
        this.cy.add(a);
        a._visibility = 1;
        return a;
    };
    RadialPieSeriesView.prototype.cz = function (a) {
        a._visibility = 0;
    };
    RadialPieSeriesView.prototype.c1 = function (a) {
        a._visibility = 1;
    };
    RadialPieSeriesView.prototype.c0 = function (a) {
        this.cy.remove(a);
    };
    RadialPieSeriesView.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._stroke = this.e.k4;
        c.ac = this.e.ey;
        c._fill = this.e.k3;
        c.ai = this.e.lb;
        c.ad = this.e.lc;
    };
    RadialPieSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._stroke = d;
        c.ac = this.e.ey;
        c._fill = d;
    };
    RadialPieSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.cy.count; c++) {
                var d = this.cy._inner[c];
                this.ba(d, c, b);
                a.s(d);
            }
        }
    };
    RadialPieSeriesView.prototype.c2 = function () {
        this.an();
    };
    RadialPieSeriesView.prototype.ai = function (a) {
        var e_1, _a;
        _super.prototype.ai.call(this, a);
        var b = 0;
        try {
            for (var _b = __values(fromEnum(this.cx.a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                this.e.a2.exportPathData(a, c, "slice" + b, ["Main", "Fill"]);
                b++;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    RadialPieSeriesView.$t = markType(RadialPieSeriesView, 'RadialPieSeriesView', AnchoredRadialSeriesView.$);
    return RadialPieSeriesView;
}(AnchoredRadialSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent radial pie series.
 * Compare values across categories by using radial pie slices.
*/
var IgrRadialPieSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrRadialPieSeries, _super);
    function IgrRadialPieSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrRadialPieSeries.prototype.createImplementation = function () {
        return new RadialPieSeries();
    };
    Object.defineProperty(IgrRadialPieSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialPieSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.or;
        },
        set: function (v) {
            this.i.or = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrRadialPieSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.os;
        },
        set: function (v) {
            this.i.os = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrRadialPieSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrRadialPieSeries;
}(IgrAnchoredRadialSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrRadialPieSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrRadialPieSeriesModule() {
    }
    IgrRadialPieSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrRadialPieSeries", IgrRadialPieSeries);
        TypeRegistrar.register("RadialPieSeries", RadialPieSeries.$type);
    };
    return IgrRadialPieSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartRadialModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartRadialModule() {
    }
    IgrDataChartRadialModule.register = function () {
        IgrRadialAreaSeriesModule.register();
        IgrRadialColumnSeriesModule.register();
        IgrRadialLineSeriesModule.register();
        IgrRadialPieSeriesModule.register();
        IgrDataChartRadialCoreModule.register();
    };
    return IgrDataChartRadialModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalLogarithmicScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalLogarithmicScaler, _super);
    function HorizontalLogarithmicScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalLogarithmicScaler.prototype.q = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.ag(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ag(a, b.e, b.d, b.a);
    };
    HorizontalLogarithmicScaler.prototype.p = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.af(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.af(a, b.e, b.d, b.a);
    };
    HorizontalLogarithmicScaler.prototype.ag = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (d) {
            e = 1 - e;
        }
        return Math.exp(e * (this.ad - this.ae) + this.ae);
    };
    HorizontalLogarithmicScaler.prototype.af = function (a, b, c, d) {
        if (isNaN_(a)) {
            return NaN;
        }
        var e = 0;
        if (a <= 0) {
            e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
        }
        else {
            e = (Math.log(a) - this.ae) / (this.ad - this.ae);
        }
        if (d) {
            e = 1 - e;
        }
        return c.left + c.width * (e - b.left) / b.width;
    };
    HorizontalLogarithmicScaler.$t = markType(HorizontalLogarithmicScaler, 'HorizontalLogarithmicScaler', LogarithmicScaler.$);
    return HorizontalLogarithmicScaler;
}(LogarithmicScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalLinearScaler, _super);
    function HorizontalLinearScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalLinearScaler.prototype.q = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.ae(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ae(a, b.e, b.d, b.a);
    };
    HorizontalLinearScaler.prototype.p = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.ad(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ad(a, b.e, b.d, b.a);
    };
    HorizontalLinearScaler.prototype.v = function (a, b, c, d) {
        var e;
        var f = d.e;
        var g = d.d;
        var h = d.c;
        var i = d.a;
        var j = !h.isEmpty;
        var k = this.m;
        var l = this.o;
        var m = h.left;
        var n = h.width;
        var o = f.left;
        var p = f.width;
        var q = g.left;
        var r = g.width;
        var s = 0;
        var t = 1;
        var u = ArrayAccessHelper.b(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        for (var w = b; w < c; w++) {
            if (v) {
                e = u[w];
            }
            else {
                e = a.item(w);
            }
            if (j) {
                var x = (e - l) / (k);
                if (i) {
                    x = 1 - x;
                }
                x = m + n * (x - s) / t;
                var y = (x - (o * r)) / p;
                if (v) {
                    u[w] = y;
                }
                else {
                    a.item(w, y);
                }
            }
            else {
                var z = (e - l) / (k);
                if (i) {
                    z = 1 - z;
                }
                z = q + r * (z - o) / p;
                if (v) {
                    u[w] = z;
                }
                else {
                    a.item(w, z);
                }
            }
        }
    };
    HorizontalLinearScaler.prototype.ae = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (d) {
            e = 1 - e;
        }
        return this.o + e * (this.m);
    };
    HorizontalLinearScaler.prototype.ad = function (a, b, c, d) {
        var e = (a - this.o) / (this.m);
        if (d) {
            e = 1 - e;
        }
        return c.left + c.width * (e - b.left) / b.width;
    };
    HorizontalLinearScaler.$t = markType(HorizontalLinearScaler, 'HorizontalLinearScaler', LinearScaler.$);
    return HorizontalLinearScaler;
}(LinearScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FastHorizontalLinearScaler = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FastHorizontalLinearScaler, _super);
    function FastHorizontalLinearScaler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FastHorizontalLinearScaler.prototype.u = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.m;
        var m = this.o;
        var n = i.left;
        var o = i.width;
        var p = g.left;
        var q = g.width;
        var r = h.left;
        var s = h.width;
        var t = 0;
        var u = 1;
        var v = ArrayAccessHelper.a(a);
        var w = false;
        if (v != null) {
            w = true;
        }
        var x;
        for (var y = 0; y < b.count; y++) {
            x = b.item(y);
            for (var z = c; z < d; z++) {
                if (w) {
                    f = v[z];
                }
                else {
                    f = a.item(z);
                }
                if (k) {
                    var aa = (f[x] - m) / (l);
                    if (j) {
                        aa = 1 - aa;
                    }
                    aa = n + o * (aa - t) / u;
                    var ab = (aa - (p * s)) / q;
                    f[x] = ab;
                }
                else {
                    var ac = (f[x] - m) / (l);
                    if (j) {
                        ac = 1 - ac;
                    }
                    ac = r + s * (ac - p) / q;
                    f[x] = ac;
                }
            }
        }
    };
    FastHorizontalLinearScaler.$t = markType(FastHorizontalLinearScaler, 'FastHorizontalLinearScaler', HorizontalLinearScaler.$);
    return FastHorizontalLinearScaler;
}(HorizontalLinearScaler));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumericXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericXAxis, _super);
    function NumericXAxis() {
        var _this = _super.call(this) || this;
        _this.ab = NumericXAxis.$;
        _this.jf = _this.jd();
        return _this;
    }
    NumericXAxis.prototype.a1 = function () {
        return new NumericXAxisView(this);
    };
    NumericXAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.lv = a;
    };
    NumericXAxis.prototype.as = function () {
        if (this.cp) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    NumericXAxis.prototype.jd = function () {
        var _this = this;
        var a = _super.prototype.jd.call(this);
        a.b.c = function (b) {
            if ((_this.aw == null || _this.aw.visibility == 0) && _this.ag != null) {
                _this.at.a8 = b;
                if (_this.aw != null && (_this.aw.location == 4 || _this.aw.location == 5)) {
                    _this.bf.ht();
                }
            }
        };
        a.k = function (b, c, d) { return _this.hf(c, d, b.z, b.b, false); };
        a.l = function (b, c, d, e) { return _this.hg(c, d, e, b.z); };
        a.m = function (b, c) {
            var d = b.y;
            var e = new ScalerParams(0, b.aa, b.z, _this.b9, d);
            return _this.dw(c, e);
        };
        a.q = function (b, c) { return true; };
        a.j = function (b) { return _this.gq(b.t, b.n, b.z, b.a, true); };
        a.e = function (b) {
            b.n = b.z.bottom;
            if (_this.ag != null && _this.ag.bf != null) {
                var c = b.n;
                var d = b.r;
                var e = _this.ha(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = function (b, c, d) {
            var e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    };
    NumericXAxis.prototype.dw = function (a, b) {
        if (this.le != null) {
            return this.le.p(a, b);
        }
        return this.ld.p(a, b);
    };
    NumericXAxis.prototype.dz = function (a, b) {
        if (this.le != null) {
            return this.le.q(a, b);
        }
        return this.ld.q(a, b);
    };
    NumericXAxis.prototype.gn = function (a, b, c, d) {
        if (this.le != null) {
            this.le.v(a, b, c, d);
            return;
        }
        this.ld.v(a, b, c, d);
    };
    NumericXAxis.prototype.gm = function (a, b, c, d, e) {
        if (this.le != null) {
            this.le.u(a, b, c, d, e);
            return;
        }
        this.ld.u(a, b, c, d, e);
    };
    NumericXAxis.prototype.go = function (a, b, c, d) {
        if (this.le != null) {
            this.le.j(a, b, c, d);
            return;
        }
        this.ld.j(a, b, c, d);
    };
    NumericXAxis.prototype.lw = function (a, b) {
        if (this.bf == null || a == NaN || b == NaN) {
            return;
        }
        var c = this.lj(a, this);
        var d = this.lj(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bf.m4 = new Rect(0, c, this.bf.m4.y, d - c, this.bf.m4.height);
    };
    NumericXAxis.prototype.jg = function (a, b, c, d) {
        var e = d;
        var f = _super.prototype.jg.call(this, a, b, c, d);
        var g = new ScalerParams(0, b, a, this.b8, c);
        var h = NaN;
        var i = NaN;
        if (!this.b8 && b.right == 1) {
            i = this.j3;
        }
        else if (this.b8 && b.left == 0) {
            h = this.j3;
        }
        if (isNaN_(h)) {
            h = this.dz(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.dz(e.right, g);
        }
        var j = Math.min(h, i);
        var k = Math.max(h, i);
        this.j7 = j;
        this.j6 = k;
        f.k.add(((function () {
            var $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    };
    NumericXAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = !b.isEmpty ? this.i1 : Rect.empty;
        var d = this.iw();
        var e = this.iv();
        var f = this.jf.c(a, c, b, d, e);
        if (f != null) {
            this.j2 = f.f.m;
            this.j5 = f.f.l;
        }
    };
    NumericXAxis.prototype.hh = function (a, b) {
        _super.prototype.hh.call(this, a, b);
        if (b.height != a.height) {
            this.cl();
        }
    };
    NumericXAxis.prototype.get_az = function () {
        return 0;
    };
    Object.defineProperty(NumericXAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    NumericXAxis.prototype.ji = function () {
        if (this.jt) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.lc) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    };
    NumericXAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    NumericXAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    NumericXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    NumericXAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    NumericXAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(NumericXAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
    return NumericXAxis;
}(StraightNumericAxisBase));
/**
 * @hidden
 */
var NumericXAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumericXAxisView, _super);
    function NumericXAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bi = null;
        _this.bi = a;
        return _this;
    }
    NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);
    return NumericXAxisView;
}(StraightNumericAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent numeric X axis.
*
* The `IgrNumericXAxis` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `XMemberPath` property of Scatter Series or `ValueMemberPath` property of Bar Series.
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrNumericXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis"
* 		 crossingAxis= "xAxis"
* 		crossingValue= {700}/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrColumnSeries({ name: "series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.numericXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "xAxis";
* this.series.yAxisName = "yAxis";
* ```
*/
var IgrNumericXAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrNumericXAxis, _super);
    function IgrNumericXAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrNumericXAxis.prototype.createImplementation = function () {
        return new NumericXAxis();
    };
    Object.defineProperty(IgrNumericXAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrNumericXAxis.prototype.scrollRangeIntoView = function (minimum, maximum) {
        this.i.lw(minimum, maximum);
    };
    return IgrNumericXAxis;
}(IgrStraightNumericAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrNumericXAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrNumericXAxisModule() {
    }
    IgrNumericXAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrNumericXAxis", IgrNumericXAxis);
        TypeRegistrar.register("NumericXAxis", NumericXAxis.$type);
    };
    return IgrNumericXAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartScatterCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartScatterCoreModule() {
    }
    IgrDataChartScatterCoreModule.register = function () {
        IgrNumericXAxisModule.register();
        IgrNumericYAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartScatterCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SizeScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SizeScale, _super);
    function SizeScale() {
        var _this = _super.call(this) || this;
        _this.l = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.l = new List$1(Series.$, 0);
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.t(a, b.propertyName, b.oldValue, b.newValue); });
        return _this;
    }
    SizeScale.prototype.u = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    SizeScale.prototype.t = function (a, b, c, d) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.l)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                e.jd(false);
                if (e.bs != null) {
                    e.ik();
                    e.ij();
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    SizeScale.$t = markType(SizeScale, 'SizeScale', DependencyObject.$, [INotifyPropertyChanged_$type]);
    SizeScale.$$p = markDep(DependencyProperty, PropertyMetadata, SizeScale, 'u', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
    return SizeScale;
}(DependencyObject));

/**
 * Represents a scale that is used determine an object's size.
*/
var IgrSizeScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSizeScale, _super);
    function IgrSizeScale(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._propertyUpdated = null;
        _this._propertyUpdated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrSizeScale.prototype.createImplementation = function () {
        return new SizeScale();
    };
    Object.defineProperty(IgrSizeScale.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrSizeScale._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrSizeScale.prototype.onImplementationCreated = function () {
    };
    IgrSizeScale.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrSizeScale.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrSizeScale.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrSizeScale.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value for this scale.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSizeScale.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value for this scale.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSizeScale.prototype, "isLogarithmic", {
        /**
         * Gets or sets whether the scale is logarithmic.
        */
        get: function () {
            return this.i.isLogarithmic;
        },
        set: function (v) {
            this.i.isLogarithmic = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSizeScale.prototype, "logarithmBase", {
        /**
         * Gets or sets the logarithm base for this scale.
        */
        get: function () {
            return this.i.logarithmBase;
        },
        set: function (v) {
            this.i.logarithmBase = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSizeScale.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrSizeScale.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrSizeScale.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SizeScale");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    Object.defineProperty(IgrSizeScale.prototype, "propertyUpdated", {
        /**
         * Event raised when a property (including "effective" and non-dependency property) value changes.
        */
        get: function () {
            return this._propertyUpdated;
        },
        set: function (ev) {
            var _this = this;
            if (this._propertyUpdated_wrapped !== null) {
                this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
                this._propertyUpdated_wrapped = null;
                this._propertyUpdated = null;
            }
            this._propertyUpdated = ev;
            this._propertyUpdated_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyUpdatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePropertyUpdated) {
                    _this.beforePropertyUpdated(_this, outerArgs);
                }
                if (_this._propertyUpdated) {
                    _this._propertyUpdated(_this, outerArgs);
                }
            };
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSizeScale;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSizeScaleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSizeScaleModule() {
    }
    IgrSizeScaleModule.register = function () {
        TypeRegistrar.registerCons("IgrSizeScale", IgrSizeScale);
        TypeRegistrar.register("SizeScale", SizeScale.$type);
    };
    return IgrSizeScaleModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BrushScale, _super);
    function BrushScale() {
        var _this = _super.call(this) || this;
        _this.j = null;
        _this.o = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.o = new List$1(Series.$, 0);
        _this.brushes = new BrushCollection();
        var a = _this.brushes;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.p));
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (b, c) { return _this.q(b, c.propertyName, c.oldValue, c.newValue); });
        return _this;
    }
    BrushScale.prototype.p = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.jd(false);
                c.id();
                c.ik();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    Object.defineProperty(BrushScale.prototype, "brushes", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var e_2, _a;
            var b = this.j;
            if (this.j != null) {
                var c = this.j;
                c.collectionChanged = delegateRemove(c.collectionChanged, runOn(this, this.p));
            }
            this.j = a;
            if (this.j != null) {
                var d = this.j;
                d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.p));
            }
            try {
                for (var _b = __values(fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var e = _c.value;
                    e.jd(false);
                    e.id();
                    e.ik();
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    BrushScale.prototype.registerSeries = function (a) {
        var b = this.o.contains(a);
        if (!b) {
            this.o.add(a);
        }
    };
    BrushScale.prototype.unregisterSeries = function (a) {
        var b = this.o.contains(a);
        if (b) {
            this.o.remove(a);
        }
    };
    BrushScale.prototype.getBrush = function (a) {
        if (this.brushes == null || a < 0 || a >= this.brushes.count) {
            return null;
        }
        return this.brushes.item(a);
    };
    BrushScale.prototype.get_isReady = function () {
        return true;
    };
    Object.defineProperty(BrushScale.prototype, "isReady", {
        get: function () {
            return this.get_isReady();
        },
        enumerable: true,
        configurable: true
    });
    BrushScale.prototype.v = function (a) {
        if (this.brushes == null || this.brushes.count == 0 || a < 0) {
            return null;
        }
        return BrushCollectionUtil.b(this.brushes, a);
    };
    BrushScale.prototype.r = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    BrushScale.prototype.q = function (a, b, c, d) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(this.o)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                e.jd(false);
                e.id();
                e.ik();
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    BrushScale.prototype.get_isBrushScale = function () {
        return true;
    };
    Object.defineProperty(BrushScale.prototype, "isBrushScale", {
        get: function () {
            return this.get_isBrushScale();
        },
        enumerable: true,
        configurable: true
    });
    BrushScale.$t = markType(BrushScale, 'BrushScale', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return BrushScale;
}(DependencyObject));

/**
 * Represents a base class for brush scales.
*/
var IgrBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBrushScale, _super);
    function IgrBrushScale(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._propertyUpdated = null;
        _this._propertyUpdated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrBrushScale.prototype.createImplementation = function () {
        return new BrushScale();
    };
    Object.defineProperty(IgrBrushScale.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrBrushScale._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrBrushScale.prototype.onImplementationCreated = function () {
    };
    IgrBrushScale.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrBrushScale.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrBrushScale.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrBrushScale.prototype, "brushes", {
        /**
         * Gets the brushes collection used by this scale.
        */
        get: function () {
            return fromBrushCollection(this.i.brushes);
        },
        set: function (v) {
            this.i.brushes = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBrushScale.prototype, "isReady", {
        /**
         * Gets the status of the scale
        */
        get: function () {
            return this.i.isReady;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBrushScale.prototype, "isBrushScale", {
        /**
         * Checks if this item is a BrushScale
        */
        get: function () {
            return this.i.isBrushScale;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBrushScale.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrBrushScale.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrBrushScale.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("BrushScale");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
     * Registers a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to register with the scale.
    */
    IgrBrushScale.prototype.registerSeries = function (series) {
        this.i.registerSeries((series == null ? null : series.i));
    };
    /**
     * Unregisters a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to unregister from the scale.
    */
    IgrBrushScale.prototype.unregisterSeries = function (series) {
        this.i.unregisterSeries((series == null ? null : series.i));
    };
    /**
     * Gets a brush from the brushes collection by index.
    
    */
    IgrBrushScale.prototype.getBrush = function (index) {
        var iv = this.i.getBrush(index);
        return brushToString(iv);
    };
    Object.defineProperty(IgrBrushScale.prototype, "propertyUpdated", {
        /**
         * Event raised when a property (including "effective" and non-dependency property) value changes.
        */
        get: function () {
            return this._propertyUpdated;
        },
        set: function (ev) {
            var _this = this;
            if (this._propertyUpdated_wrapped !== null) {
                this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
                this._propertyUpdated_wrapped = null;
                this._propertyUpdated = null;
            }
            this._propertyUpdated = ev;
            this._propertyUpdated_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyUpdatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePropertyUpdated) {
                    _this.beforePropertyUpdated(_this, outerArgs);
                }
                if (_this._propertyUpdated) {
                    _this._propertyUpdated(_this, outerArgs);
                }
            };
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrBrushScale;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBrushScaleModule() {
    }
    IgrBrushScaleModule.register = function () {
        TypeRegistrar.registerCons("IgrBrushScale", IgrBrushScale);
        TypeRegistrar.register("BrushScale", BrushScale.$type);
    };
    return IgrBrushScaleModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ValueBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueBrushScale, _super);
    function ValueBrushScale() {
        var _this = _super.call(this) || this;
        _this.w = false;
        _this.aa = 10;
        return _this;
    }
    ValueBrushScale.prototype.getBrushByIndex = function (a, b) {
        if (b == null || this.brushes == null || this.brushes.count == 0 || a < 0 || a >= b.count) {
            return null;
        }
        if (b.count == 0) {
            return this.brushes.item(0);
        }
        var c = isNaN_(this.minimumValue) || isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
        var d = isNaN_(this.maximumValue) || isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
        var e = b.item(a);
        if (c == d) {
            return e == c ? this.brushes.item(0) : null;
        }
        return this.an(c, d, e);
    };
    ValueBrushScale.prototype.getBrushByValue = function (a, b) {
        if (b == null || this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (b.count <= 1) {
            return this.brushes.item(0);
        }
        var c = isNaN_(this.minimumValue) || isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
        var d = isNaN_(this.maximumValue) || isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
        if (a < c) {
            return null;
        }
        if (a > d) {
            return null;
        }
        return this.an(c, d, a);
    };
    ValueBrushScale.prototype.an = function (a, b, c) {
        if (this.w && this.aa > 0) {
            var d = logBase(a, this.aa);
            var e = logBase(b, this.aa);
            var f = logBase(c, this.aa);
            return this.am(d, e, f);
        }
        return this.am(a, b, c);
    };
    ValueBrushScale.prototype.am = function (a, b, c) {
        if (c < a || c > b) {
            return null;
        }
        var d = (c - a) / (b - a);
        var e = d * (this.brushes.count - 1);
        return this.v(e);
    };
    ValueBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    ValueBrushScale.prototype.q = function (a, b, c, d) {
        switch (b) {
            case ValueBrushScale.$$p[1]:
                this.aa = typeGetValue(d);
                break;
            case ValueBrushScale.$$p[0]:
                this.w = d;
                break;
        }
        _super.prototype.q.call(this, a, b, c, d);
    };
    ValueBrushScale.$t = markType(ValueBrushScale, 'ValueBrushScale', BrushScale.$);
    ValueBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, ValueBrushScale, 'r', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
    return ValueBrushScale;
}(BrushScale));

/**
 * Represents a brush scale that uses value-based brush selection.
*/
var IgrValueBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrValueBrushScale, _super);
    function IgrValueBrushScale(props) {
        return _super.call(this, props) || this;
    }
    IgrValueBrushScale.prototype.createImplementation = function () {
        return new ValueBrushScale();
    };
    Object.defineProperty(IgrValueBrushScale.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value for this scale.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value for this scale.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "isLogarithmic", {
        /**
         * Gets or sets whether the scale is logarithmic.
        */
        get: function () {
            return this.i.isLogarithmic;
        },
        set: function (v) {
            this.i.isLogarithmic = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "logarithmBase", {
        /**
         * Gets or sets the logarithm base for this scale.
        */
        get: function () {
            return this.i.logarithmBase;
        },
        set: function (v) {
            this.i.logarithmBase = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrValueBrushScale.prototype, "isReady", {
        /**
         * Checks if the value brush scale is ready for usage in the chart
        */
        get: function () {
            return this.i.isReady;
        },
        enumerable: true,
        configurable: true
    });
    return IgrValueBrushScale;
}(IgrBrushScale));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrValueBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrValueBrushScaleModule() {
    }
    IgrValueBrushScaleModule.register = function () {
        TypeRegistrar.registerCons("IgrValueBrushScale", IgrValueBrushScale);
        TypeRegistrar.register("ValueBrushScale", ValueBrushScale.$type);
    };
    return IgrValueBrushScaleModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors of selecting a brush from a brush collection.
 */
var BrushSelectionMode = /*@__PURE__*/ (function (BrushSelectionMode) {
    /**
     * alternates between brushes sequentially.
     */
    BrushSelectionMode[BrushSelectionMode["Select"] = 0] = "Select";
    /**
     * Uses index-based interpolation.
     */
    BrushSelectionMode[BrushSelectionMode["Interpolate"] = 1] = "Interpolate";
    return BrushSelectionMode;
})({});
/**
 * @hidden
 */
var BrushSelectionMode_$type = /*@__PURE__*/ markEnum('BrushSelectionMode', 'Select,0|Interpolate,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterAxisInfoCache, _super);
    function ScatterAxisInfoCache() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.d = false;
        _this.e = false;
        _this.c = null;
        return _this;
    }
    ScatterAxisInfoCache.$t = markType(ScatterAxisInfoCache, 'ScatterAxisInfoCache');
    return ScatterAxisInfoCache;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of collision avoidance of series' markers.
 */
var CollisionAvoidanceType = /*@__PURE__*/ (function (CollisionAvoidanceType) {
    /**
     * Collision avoidance is disabled.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["None"] = 0] = "None";
    /**
     * Items colliding with other items will be hidden from view.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["Omit"] = 1] = "Omit";
    /**
     * Items colliding with other items will be partially hidden from view by reducing their opacity.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["Fade"] = 2] = "Fade";
    /**
     * Items colliding with other items will be either hidden from view or moved to new positions.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["OmitAndShift"] = 3] = "OmitAndShift";
    /**
     * Items colliding with other items will be either partially hidden from view by reducing their opacity, or moved to new positions, or a combination of both.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["FadeAndShift"] = 4] = "FadeAndShift";
    return CollisionAvoidanceType;
})({});
/**
 * @hidden
 */
var CollisionAvoidanceType_$type = /*@__PURE__*/ markEnum('CollisionAvoidanceType', 'None,0|Omit,1|Fade,2|OmitAndShift,3|FadeAndShift,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ErrorBarSettingsBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ErrorBarSettingsBase, _super);
    function ErrorBarSettingsBase() {
        var _this = _super.call(this) || this;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.n = new Style();
        return _this;
    }
    ErrorBarSettingsBase.prototype.l = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    ErrorBarSettingsBase.$t = markType(ErrorBarSettingsBase, 'ErrorBarSettingsBase', DependencyObject.$, [INotifyPropertyChanged_$type]);
    ErrorBarSettingsBase.$$p = markDep(DependencyProperty, PropertyMetadata, ErrorBarSettingsBase, 'l', ['DefaultErrorBarStyle:n:m', [Style.$, null]]);
    return ErrorBarSettingsBase;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types for enabling error bars
 */
var EnableErrorBars = /*@__PURE__*/ (function (EnableErrorBars) {
    /**
     * No error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["None"] = 0] = "None";
    /**
     * Both error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Both"] = 1] = "Both";
    /**
     * Positive error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Positive"] = 2] = "Positive";
    /**
     * Negative error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Negative"] = 3] = "Negative";
    return EnableErrorBars;
})({});
/**
 * @hidden
 */
var EnableErrorBars_$type = /*@__PURE__*/ markEnum('EnableErrorBars', 'None,0|Both,1|Positive,2|Negative,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterErrorBarSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterErrorBarSettings, _super);
    function ScatterErrorBarSettings() {
        var _this = _super.call(this) || this;
        _this.q = null;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, runOn(_this, _this.ap));
        return _this;
    }
    Object.defineProperty(ScatterErrorBarSettings.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            this.q = a;
        },
        enumerable: true,
        configurable: true
    });
    ScatterErrorBarSettings.prototype.ap = function (a, b) {
        switch (b.propertyName) {
            case ScatterErrorBarSettings.$$p[2]:
            case ScatterErrorBarSettings.$$p[8]:
                var c = typeCast(IErrorBarCalculator_$type, b.oldValue);
                if (c != null) {
                    c.changed = delegateRemove(c.changed, runOn(this, this.ao));
                }
                if (this.r != null) {
                    this.r.jd(false);
                    if (this.r.bs != null) {
                        this.r.ik();
                    }
                }
                var d = typeCast(IErrorBarCalculator_$type, b.newValue);
                if (d != null) {
                    d.changed = delegateCombine(d.changed, runOn(this, this.ao));
                }
                break;
            case ScatterErrorBarSettings.$$p[0]:
            case ScatterErrorBarSettings.$$p[1]:
            case ScatterErrorBarSettings.$$p[3]:
            case ScatterErrorBarSettings.$$p[4]:
            case ScatterErrorBarSettings.$$p[5]:
            case ScatterErrorBarSettings.$$p[6]:
            case ScatterErrorBarSettings.$$p[7]:
            case ScatterErrorBarSettings.$$p[9]:
            case ScatterErrorBarSettings.$$p[10]:
            case ScatterErrorBarSettings.$$p[11]:
            case ScatterErrorBarSettings.$$p[12]:
            case ScatterErrorBarSettings.$$p[13]:
                if (this.r != null) {
                    this.r.jd(false);
                    if (this.r.bs != null) {
                        this.r.ik();
                    }
                }
                break;
        }
    };
    ScatterErrorBarSettings.prototype.ao = function (a, b) {
        var c = typeCast(IErrorBarCalculator_$type, a);
        if (c != null) {
            c.changed = delegateRemove(c.changed, runOn(this, this.ao));
            if (this.r != null) {
                this.r.jd(false);
            }
            c.changed = delegateCombine(c.changed, runOn(this, this.ao));
        }
    };
    ScatterErrorBarSettings.$t = markType(ScatterErrorBarSettings, 'ScatterErrorBarSettings', ErrorBarSettingsBase.$);
    ScatterErrorBarSettings.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterErrorBarSettings, 'l', ['EnableErrorBarsHorizontal:o:aq', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'EnableErrorBarsVertical:p:ar', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'HorizontalCalculator:u:as', [IErrorBarCalculator_$type, null], 'HorizontalCalculatorReference:s:at', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 0)], 'HorizontalErrorBarCapLength:y:au', [1, 6], 'HorizontalErrorBarStyle:a6:av', [Style.$, null], 'HorizontalStroke:a4:aw', [Brush.$, null], 'HorizontalStrokeThickness:w:ax', [1, 1], 'VerticalCalculator:v:ay', [IErrorBarCalculator_$type, null], 'VerticalCalculatorReference:t:az', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 1)], 'VerticalErrorBarCapLength:z:a0', [1, 6], 'VerticalErrorBarStyle:a7:a1', [Style.$, null], 'VerticalStroke:a5:a2', [Brush.$, null], 'VerticalStrokeThickness:x:a3', [1, 1]]);
    return ScatterErrorBarSettings;
}(ErrorBarSettingsBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterFrame, _super);
    function ScatterFrame() {
        var _this = _super.call(this, ScatterFrame.$) || this;
        _this.u = null;
        _this.u = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        return _this;
    }
    ScatterFrame.prototype.r = function (a, b, c) {
        _super.prototype.r.call(this, a, b, c);
        var d = typeCast(ScatterFrame.$, b);
        var e = typeCast(ScatterFrame.$, c);
        if (d == null || e == null) {
            return;
        }
        this.f.e(this.u, a, d.u, e.u, d, e);
    };
    ScatterFrame.$t = markType(ScatterFrame, 'ScatterFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();
    return ScatterFrame;
}(ScatterFrameBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterTrendLineManager, _super);
    function ScatterTrendLineManager() {
        return _super.call(this, Point_$type) || this;
    }
    ScatterTrendLineManager.prototype.get_g$a = function () {
        return 4;
    };
    Object.defineProperty(ScatterTrendLineManager.prototype, "g$a", {
        get: function () {
            return this.get_g$a();
        },
        enumerable: true,
        configurable: true
    });
    ScatterTrendLineManager.prototype.p = function (a, b, c, d, e, f, g, h, i, j, k) {
        var e_1, _a;
        var l = j;
        var m = k;
        var n = new List$1(Point_$type, 0);
        var o = 0;
        if (c != null) {
            o = c.count;
        }
        if (d != null) {
            o = Math.min(o, d.count);
        }
        if (!h.g.isEmpty && !h.f.isEmpty) {
            if (b == 0) {
                this.a = null;
                this.d.clear();
            }
            else if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(n, b, h, this.a, o, function (p) { return c.item(p); }, function (p) { return d.item(p); }, f, g, l, m);
            }
            else if (this.b(b)) {
                this.a = null;
                this.d.clear();
                TrendAverageCalculator.c(b, this.d, c, d, e);
                try {
                    for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var p = _c.value;
                        var q = f(p.x);
                        var r = g(p.y);
                        if (!isNaN_(q) && !isNaN_(r)) {
                            n.add({ $type: Point_$type, x: q, y: r });
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            this.n(n, h, a, i);
        }
    };
    ScatterTrendLineManager.$t = markType(ScatterTrendLineManager, 'ScatterTrendLineManager', TrendLineManagerBase$1.$.specialize(Point_$type));
    return ScatterTrendLineManager;
}(TrendLineManagerBase$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ErrorBarsHelper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ErrorBarsHelper, _super);
    function ErrorBarsHelper(a, b) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.b = a;
        _this.a = b;
        return _this;
    }
    ErrorBarsHelper.prototype.c = function (a) {
        var b = a.getCalculatorType();
        if (b == 1 || b == 2) {
            return false;
        }
        else {
            return true;
        }
    };
    ErrorBarsHelper.prototype.i = function (a, b) {
        if (a.hasConstantPosition()) {
            b = a.getPosition();
        }
        return {
            p1: b
        };
    };
    ErrorBarsHelper.prototype.k = function (a, b, c, d, e) {
        var f;
        var g;
        var h;
        var i = this.a.getViewInfo(g, f);
        g = i.p0;
        f = i.p1;
        h = this.a.getEffectiveViewport();
        var j = new ScalerParams(0, f, g, c.b8, h);
        var k = c.dw(a, j);
        var l = b.getIndependentValue();
        d = Math.abs(Math.round(c.dw(a + l, j) - k));
        e = Math.abs(Math.round(c.dw(a - l, j) - k));
        return {
            p3: d,
            p4: e
        };
    };
    ErrorBarsHelper.prototype.j = function (a, b, c, d, e) {
        var f;
        var g;
        var h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        var i = new ScalerParams(1, f, g, c.b8);
        var j = c.dz(a, i);
        var k = b.getIndependentValue();
        d = Math.abs(Math.round(c.dw(j + k, i) - a));
        e = Math.abs(Math.round(c.dw(j - k, i) - a));
        return {
            p3: d,
            p4: e
        };
    };
    ErrorBarsHelper.prototype.g = function (a, b, c, d, e) {
        var f;
        var g;
        var h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        var i = new ScalerParams(1, f, g, c.b8);
        var j = c.dz(a, i);
        var k = b.getDependentValue(j);
        d = Math.abs(Math.round(c.dw(j + k, i) - a));
        e = Math.abs(Math.round(c.dw(j - k, i) - a));
        return {
            p3: d,
            p4: e
        };
    };
    ErrorBarsHelper.prototype.f = function (a, b, c, d, e, f) {
        var g;
        var h;
        var i = this.a.getViewInfo(h, g);
        h = i.p0;
        g = i.p1;
        var j = new ScalerParams(1, g, h, c.b8);
        var k = new ScalerParams(1, g, h, d.b8);
        var l = c.dz(a, j);
        var m = b.getDependentValue(l);
        e = Math.abs(Math.round(c.dw(l + m, k) - a));
        f = Math.abs(Math.round(c.dw(l - m, k) - a));
        return {
            p4: e,
            p5: f
        };
    };
    ErrorBarsHelper.prototype.h = function (a, b, c, d, e) {
        var f;
        var g;
        var h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        var i = new ScalerParams(1, f, g, c.b8);
        var j = c.dz(a, i);
        d = Math.abs(Math.round(c.dw(j + b, i) - a));
        e = Math.abs(Math.round(c.dw(j - b, i) - a));
        return {
            p3: d,
            p4: e
        };
    };
    ErrorBarsHelper.prototype.e = function (a, b, c, d) {
    };
    ErrorBarsHelper.prototype.d = function (a, b, c, d) {
    };
    ErrorBarsHelper.prototype.l = function (a, b, c, d) {
        var e = PointUtil.create();
        if (a.getCalculatorType() == 3) {
            var f = void 0;
            var g = void 0;
            var h = void 0;
            var i = this.a.getViewInfo(g, f);
            g = i.p0;
            f = i.p1;
            h = this.a.getEffectiveViewport();
            var j = new ScalerParams(0, f, g, b.b8, h);
            e.x = Math.round(b.dw(d, j));
            e.y = Math.round(c.y);
        }
        else {
            e.x = Math.round(c.x);
            e.y = Math.round(c.y);
        }
        return e;
    };
    ErrorBarsHelper.prototype.m = function (a, b, c, d) {
        var e = PointUtil.create();
        if (a.getCalculatorType() == 3) {
            var f = void 0;
            var g = void 0;
            var h = void 0;
            var i = this.a.getViewInfo(g, f);
            g = i.p0;
            f = i.p1;
            h = this.a.getEffectiveViewport();
            var j = new ScalerParams(0, f, g, b.b8, h);
            e.x = Math.round(c.x);
            e.y = Math.round(b.dw(d, j));
        }
        else {
            e.x = Math.round(c.x);
            e.y = Math.round(c.y);
        }
        return e;
    };
    ErrorBarsHelper.$t = markType(ErrorBarsHelper, 'ErrorBarsHelper');
    return ErrorBarsHelper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBase, _super);
    function ScatterBase() {
        var _this = _super.call(this) || this;
        _this.m4 = null;
        _this.nc = null;
        _this.ne = null;
        _this.ov = null;
        _this.ow = null;
        _this.m9 = null;
        _this.nb = null;
        _this.m8 = null;
        _this.na = null;
        _this.m7 = null;
        _this.na = new ScatterFrame();
        _this.ow = Rect.empty;
        _this.ov = Rect.empty;
        return _this;
    }
    ScatterBase.prototype.bf = function () {
        return new ScatterBaseView(this);
    };
    ScatterBase.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    ScatterBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.m5 = a;
    };
    ScatterBase.prototype.get_c4 = function () {
        return true;
    };
    ScatterBase.prototype.ag = function () {
        return [this.xAxis, this.yAxis];
    };
    ScatterBase.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == ScatterBase.$$p[4]) {
            return this.ft(a, b, this.nr);
        }
        if (c == ScatterBase.$$p[6]) {
            return this.ft(a, b, this.nv);
        }
        return null;
    };
    ScatterBase.prototype.ch = function (a, b, c) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var d = this.xAxis;
        var e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        var f = this.yAxis;
        var g = new ScalerParams(1, this.bs.mq, this.ly, f.b8);
        g.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.l0.cc(function (h) {
            if (h._visibility == 0) {
                var i = new SeriesPointOfInterest();
                var j = h.n;
                var k = h.o;
                if (j < _this.ly.left || j > _this.ly.right || k < _this.ly.top || k > _this.ly.bottom) {
                    return;
                }
                i.b = d.dz(j, e);
                i.c = f.dz(k, g);
                i.a = h.content;
                a.add(i);
            }
        });
        return true;
    };
    ScatterBase.prototype.bd = function () {
        if (this.be == 0) {
            if (this.nk <= 2000) {
                return 1;
            }
            else {
                return _super.prototype.bd.call(this);
            }
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    ScatterBase.prototype.lw = function (a) {
        if (!this.hasMarkers || !this.l3()) {
            return Rect.empty;
        }
        var b = this.l0.bv(this.lg(a));
        if (b != null) {
            return this.l0.cm(b);
        }
        return Rect.empty;
    };
    ScatterBase.prototype.dh = function (a, b) {
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    Object.defineProperty(ScatterBase.prototype, "nd", {
        get: function () {
            return this.nc;
        },
        set: function (a) {
            if (this.nc != a) {
                var b = this.nd;
                this.nc = a;
                this.raisePropertyChanged("XColumn", b, this.nd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "nf", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            if (this.ne != a) {
                var b = this.nf;
                this.ne = a;
                this.raisePropertyChanged("YColumn", b, this.nf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "os", {
        get: function () {
            return this.c(ScatterBase.od);
        },
        set: function (a) {
            this.h(ScatterBase.od, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.xAxis;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterBase.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.yAxis;
        },
        enumerable: true,
        configurable: true
    });
    ScatterBase.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.xAxis != null) {
            this.xAxis.g6(false);
        }
        if (this.yAxis != null) {
            this.yAxis.g6(false);
        }
    };
    ScatterBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.m5.ct.g$b(a, b, c, d)) {
            this.jd(false);
            this.ik();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nd);
                    c.deregisterColumn(this.nf);
                    this.nd = null;
                    this.nf = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nd = this.bw(this.nr);
                    this.nf = this.bw(this.nv);
                }
                if ((this.yAxis != null && !this.yAxis.cl()) || (this.xAxis != null && !this.xAxis.cl())) {
                    this.jd(false);
                }
                break;
            case ScatterBase.$$p[3]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if ((this.xAxis != null && !this.xAxis.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                this.ik();
                break;
            case ScatterBase.$$p[5]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if ((this.yAxis != null && !this.yAxis.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                this.ik();
                break;
            case ScatterBase.$$p[4]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nd);
                    this.nd = this.bw(this.nr);
                }
                break;
            case "XColumn":
                this.m5.ct.g$i();
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(false);
                }
                break;
            case ScatterBase.$$p[6]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nf);
                    this.nf = this.bw(this.nv);
                }
                break;
            case "YColumn":
                this.m5.ct.g$i();
                if (this.yAxis != null && !this.yAxis.cl()) {
                    this.jd(false);
                }
                break;
            case ScatterBase.$$p[1]:
                this.jd(false);
                this.ik();
                break;
            case ScatterBase.$$p[2]:
                this.jd(false);
                this.ik();
                break;
            case "TransitionProgress":
                this.nb.c(this.ez, this.m9, this.m8);
                this.nx();
                try {
                    if (this.cc(this.bi)) {
                        return;
                    }
                    if ((Math.round(this.ez * 100000) / 100000) == 1) {
                        this.ob(this.m8, this.m5);
                    }
                    else {
                        this.ob(this.nb, this.m5);
                    }
                    if (this.bs != null) {
                        this.bs.jj(this);
                    }
                }
                finally {
                    this.oc();
                }
                break;
            case "TrendLineBrush":
                this.jo();
                break;
            case ScatterBase.$$p[0]:
                if (this.m6 != null) {
                    this.m6.r = this;
                }
                this.jd(false);
                this.ik();
                break;
            case "TrendLineType":
                this.ik();
                break;
        }
    };
    ScatterBase.prototype.nh = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.ng = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.oc = function () {
        this.ov = Rect.empty;
        this.ow = Rect.empty;
    };
    ScatterBase.prototype.nx = function () {
        var a = this.getViewInfo(this.ov, this.ow);
        this.ov = a.p0;
        this.ow = a.p1;
    };
    ScatterBase.prototype.ni = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.nr == a || this.nv == a) {
            return true;
        }
        return false;
    };
    ScatterBase.prototype.hy = function (a, b, c, d) {
        var e = false;
        if (!this.ni(d, a)) {
            return;
        }
        this.m5.ct.g$e(a, b, c, d);
        if (this.xAxis != null && !this.xAxis.cl()) {
            e = true;
        }
        if (this.yAxis != null && !this.yAxis.cl()) {
            e = true;
        }
        if (e) {
            this.jd(true);
        }
    };
    ScatterBase.prototype.n5 = function (a) {
        this.n6(a, null);
    };
    ScatterBase.prototype.n6 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = this.nd != null ? this.nd.count : 0;
        var d = this.nf != null ? this.nf.count : 0;
        var e = Math.min(c, d);
        if (e <= this.nk) {
            a.m.clear();
            var f = new List$1(OwnedPoint.$, 0);
            try {
                for (var _c = __values(fromEnum(a.u.values)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var g = _d.value;
                    f.add(g);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            var h_1 = this.bz;
            f.aa(function (i, j) {
                var k = h_1.indexOf(i.a);
                var l = h_1.indexOf(j.a);
                if (k < l) {
                    return -1;
                }
                if (k > l) {
                    return 1;
                }
                return 0;
            });
            if (b != null) {
                b.i = a.m;
            }
            try {
                for (var _e = __values(fromEnum(f)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var i = _f.value;
                    if (h_1.indexOf(i.a) >= 0) {
                        if (b != null) {
                            b.j(i.c);
                        }
                        else {
                            a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                        }
                    }
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    ScatterBase.prototype.an = function (a) {
        if (a != null && a == this.xAxis && this.nd != null) {
            return new AxisRange(this.nd.minimum, this.nd.maximum);
        }
        if (a != null && a == this.yAxis && this.nf != null) {
            return new AxisRange(this.nf.minimum, this.nf.maximum);
        }
        return null;
    };
    ScatterBase.prototype.fp = function (a) {
        return null;
    };
    ScatterBase.prototype.e8 = function (a) {
        return -1;
    };
    ScatterBase.prototype.c9 = function (a) {
        var _this = this;
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        b = b.copy();
        var c = this.bs != null ? this.bs.m3 : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.ls(this.bi);
        var f = new ScalerParams(0, d, d, this.xAxis.b8, e);
        var g = ((function () {
            var $ret = new ScalerParams(0, d, d, _this.yAxis.b8, e);
            $ret.b = _this.eh();
            return $ret;
        })());
        var h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        var i = this.xAxis != null && this.nd != null && h < this.nd.count ? this.xAxis.dw(this.nd.item(h), f) : NaN;
        var j = this.yAxis != null && this.nf != null && h < this.nf.count ? this.yAxis.dw(this.nf.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    };
    ScatterBase.prototype.js = function (a, b) {
        this.jd(false);
    };
    ScatterBase.prototype.jt = function (a, b) {
        this.jd(false);
    };
    ScatterBase.prototype.ny = function (a, b, c, d, e) {
        var _this = this;
        b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        var f = this.getEffectiveViewport1(a);
        var g = this.bz;
        var h;
        var i;
        var j = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.m4.d, f);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var k = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.m4.e, f);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.eh();
            return $ret;
        })());
        var _loop_1 = function (l) {
            h = this_1.nd.item(l);
            i = this_1.nf.item(l);
            var m = { $type: Point_$type, x: this_1.m4.a.dw(h, j), y: this_1.m4.b.dw(i, k) };
            if (!isInfinity(m.x) && !isInfinity(m.y)) {
                var n_1 = g.item(l);
                if (!b.g.containsKey(n_1)) {
                    var o_1 = { $type: Point_$type, x: h, y: i };
                    var p_1 = { $type: Point_$type, x: m.x, y: m.y };
                    b.g.addItem(n_1, ((function () {
                        var $ret = new OwnedPoint();
                        $ret.a = n_1;
                        $ret.b = o_1;
                        $ret.c = p_1;
                        return $ret;
                    })()));
                }
            }
        };
        var this_1 = this;
        for (var l = 0; l < c; l++) {
            _loop_1(l);
        }
    };
    ScatterBase.prototype.n2 = function (a, b) {
        var _this = this;
        a.j.clear();
        a.n.clear();
        a.h.clear();
        a.l.clear();
        a.i.clear();
        a.k.clear();
        var c = Math.min(this.nd != null ? this.nd.count : 0, this.nf != null ? this.nf.count : 0);
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.xAxis.b8, f);
        g.c = this.getEffectiveViewport1(b);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.b8, f);
            $ret.b = _this.eh();
            return $ret;
        })());
        ;
        h.c = this.getEffectiveViewport1(b);
        if (c < 1) {
            return;
        }
        this.m4 = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.b8;
            $ret.e = _this.yAxis.b8;
            $ret.c = _this.bz;
            return $ret;
        })());
        var i = b;
        if (c <= this.nk) {
            this.ny(i, a, c, d, e);
        }
        if (this.l3()) {
            b.cr.l(a.j, this.nk, d, e, this.eu);
        }
        var j = ((function () {
            var $ret = new Clipper(0, e, false);
            $ret.i = a.n;
            return $ret;
        })());
        var k = this.lq(b);
        var l = this.xAxis.dz(k.left, g);
        var m = this.xAxis.dz(k.right, g);
        b.ct.p(a.n, this.trendLineType, this.nd, this.nf, this.trendLinePeriod, function (n) { return _this.xAxis.dw(n, g); }, function (n) { return _this.yAxis.dw(n, h); }, ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.eu;
            $ret.f = e;
            $ret.g = d;
            return $ret;
        })()), j, l, m);
        this.n0(a, b);
    };
    ScatterBase.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c0(a);
    };
    ScatterBase.prototype.ob = function (a, b) {
        var _this = this;
        var c = b.br;
        this.m4 = ((function () {
            var $ret = new ScatterAxisInfoCache();
            $ret.a = _this.xAxis;
            $ret.b = _this.yAxis;
            $ret.d = _this.xAxis.b8;
            $ret.e = _this.yAxis.b8;
            return $ret;
        })());
        if (this.l3()) {
            b.cr.j(a.j, this.l5);
        }
        b.cj();
        var d = ((function () {
            var $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
            $ret.i = b.ct.g$j.ak;
            return $ret;
        })());
        b.ct.g$h(a.n, d);
        this.n8(a, b);
    };
    ScatterBase.prototype.n0 = function (a, b) {
        var e_3, _a;
        var c = new ErrorBarsHelper(this, b);
        if (this.m6 == null) {
            return;
        }
        var d = this.m6.u;
        var e = this.m6.v;
        var f = 0;
        var g = 0;
        var h = 0;
        var i = 0;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var j = _c.value;
                var k = a.j.item(j);
                if (d != null) {
                    switch (d.getCalculatorType()) {
                        case 1:
                            var l = this.n3(k, c, d, h, i, true);
                            h = l.p3;
                            i = l.p4;
                            break;
                        case 0:
                            var m = this.n1(k, c, d, h, i, true);
                            h = m.p3;
                            i = m.p4;
                            break;
                        case 2:
                            var n = this.nz(k, c, d, j, h, i, true);
                            h = n.p4;
                            i = n.p5;
                            break;
                        case 3:
                            var o = this.n4(c, d, f, h, i, true);
                            f = o.p2;
                            h = o.p3;
                            i = o.p4;
                            break;
                        case 4:
                            var p = this.n1(k, c, d, h, i, true);
                            h = p.p3;
                            i = p.p4;
                            break;
                    }
                    ;
                    var q = new OwnedPoint();
                    q.c = c.l(d, this.m4.a, k.c, f);
                    ;
                    q.a = k.a;
                    a.h.addItem(j, q);
                    a.i.addItem(j, [h, i]);
                }
                if (e != null) {
                    switch (e.getCalculatorType()) {
                        case 1:
                            var r = this.n3(k, c, e, h, i, false);
                            h = r.p3;
                            i = r.p4;
                            break;
                        case 0:
                            var s = this.n1(k, c, e, h, i, false);
                            h = s.p3;
                            i = s.p4;
                            break;
                        case 2:
                            var t = this.nz(k, c, e, j, h, i, false);
                            h = t.p4;
                            i = t.p5;
                            break;
                        case 3:
                            var u = this.n4(c, e, g, h, i, false);
                            g = u.p2;
                            h = u.p3;
                            i = u.p4;
                            break;
                        case 4:
                            var v = this.n1(k, c, e, h, i, false);
                            h = v.p3;
                            i = v.p4;
                            break;
                    }
                    ;
                    var w = new OwnedPoint();
                    w.c = c.m(e, this.m4.b, k.c, g);
                    ;
                    w.a = k.a;
                    a.l.addItem(j, w);
                    a.k.addItem(j, [h, i]);
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    ScatterBase.prototype.n3 = function (a, b, c, d, e, f) {
        if (f) {
            var g = void 0;
            var h = void 0, i = void 0;
            i = this.m4.a;
            if (this.m6.s == 0) {
                g = a.c.x;
                h = this.m4.a;
            }
            else {
                g = a.c.y;
                h = this.m4.b;
            }
            var j = b.f(g, c, h, i, d, e);
            d = j.p4;
            e = j.p5;
        }
        else {
            var k = void 0;
            var l = void 0, m = void 0;
            m = this.m4.b;
            if (this.m6.t == 0) {
                k = a.c.x;
                l = this.m4.a;
            }
            else {
                k = a.c.y;
                l = this.m4.b;
            }
            var n = b.f(k, c, l, m, d, e);
            d = n.p4;
            e = n.p5;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.n1 = function (a, b, c, d, e, f) {
        if (f) {
            var g = b.j(a.c.x, c, this.m4.a, d, e);
            d = g.p3;
            e = g.p4;
        }
        else {
            var h = b.j(a.c.y, c, this.m4.b, d, e);
            d = h.p3;
            e = h.p4;
        }
        return {
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.nz = function (a, b, c, d, e, f, g) {
        var h = c.getItemColumn();
        var i = this.bz.indexOf(d);
        if (h != null && i < h.count) {
            var j = h.item(i);
            if (g) {
                var k = b.h(a.c.x, j, this.m4.a, e, f);
                e = k.p3;
                f = k.p4;
            }
            else {
                var l = b.h(a.c.y, j, this.m4.b, e, f);
                e = l.p3;
                f = l.p4;
            }
        }
        else {
            e = f = NaN;
        }
        return {
            p4: e,
            p5: f
        };
    };
    ScatterBase.prototype.n4 = function (a, b, c, d, e, f) {
        var g = a.i(b, c);
        c = g.p1;
        if (f) {
            var h = a.k(c, b, this.m4.a, d, e);
            d = h.p3;
            e = h.p4;
        }
        else {
            var i = a.k(c, b, this.m4.b, d, e);
            d = i.p3;
            e = i.p4;
        }
        return {
            p2: c,
            p3: d,
            p4: e
        };
    };
    ScatterBase.prototype.n8 = function (a, b) {
        if (!b.l() || this.m6 == null) {
            b.c1();
            return;
        }
        this.n9(a, b);
        this.oa(a, b);
    };
    ScatterBase.prototype.n9 = function (a, b) {
        var e_4, _a;
        b.cy();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.m6.u;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.i.containsKey(f)) {
                    var g = a.i.item(f)[0];
                    var h = a.i.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.h.item(f).c;
                        if (this.m6.o == 1 || this.m6.o == 2) {
                            c.d(d, i, g, true);
                        }
                        if (this.m6.o == 1 || this.m6.o == 3) {
                            c.d(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        b.c2(d);
    };
    ScatterBase.prototype.oa = function (a, b) {
        var e_5, _a;
        b.cz();
        var c = new ErrorBarsHelper(this, b);
        var d = new PathGeometry();
        var e = this.m6.v;
        try {
            for (var _b = __values(fromEnum(a.j.keys)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if (e != null && a.k.containsKey(f)) {
                    var g = a.k.item(f)[0];
                    var h = a.k.item(f)[1];
                    if (!isNaN_(g) && !isNaN_(h)) {
                        var i = a.l.item(f).c;
                        if (this.m6.p == 1 || this.m6.p == 2) {
                            c.e(d, i, g, true);
                        }
                        if (this.m6.p == 1 || this.m6.p == 3) {
                            c.e(d, i, h, false);
                        }
                    }
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterBase.prototype.dw = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dw.call(this, a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bf == null || this.yAxis.bf == null || this.nd == null || this.nf == null || this.nd.count == 0 || this.nf.count == 0 || this.bz == null || this.bz.count != this.nd.count || this.bz.count != this.nf.count || this.xAxis.bf == null || this.yAxis.bf == null || this.xAxis.j4 == this.xAxis.j3 || this.yAxis.j4 == this.yAxis.j3) {
            d = false;
        }
        return d;
    };
    ScatterBase.prototype.getViewInfo = function (a, b) {
        if (!this.ov.isEmpty && !this.ow.isEmpty) {
            a = this.ov;
            b = this.ow;
            return {
                p0: a,
                p1: b
            };
        }
        a = this.bi.br;
        b = this.bi.bs;
        return {
            p0: a,
            p1: b
        };
    };
    ScatterBase.prototype.je = function (a) {
        this.nx();
        try {
            if (this.cc(this.bi)) {
                return;
            }
            if (this.bz != null && this.bz.count > this.nk) {
                a = false;
            }
            if (this.da(a) && !this.de) {
                var b = this.m9;
                if (this.ca()) {
                    if (this.bt.g) {
                        this.bt.t();
                    }
                    this.m9 = this.nb;
                    this.nb = b;
                }
                else {
                    this.m9 = this.m8;
                    this.m8 = b;
                }
                this.n2(this.m8, this.m5);
                this.jl();
            }
            else {
                if (!this.de) {
                    this.n2(this.m8, this.m5);
                }
                this.ob(this.m8, this.m5);
            }
        }
        finally {
            this.oc();
        }
    };
    ScatterBase.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.fh < 0) {
            return;
        }
        this.m5.c5();
    };
    ScatterBase.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = typeCast(ScatterBaseView.$, this.bh);
        if (!this.df) {
            this.na = new ScatterFrame();
            this.n2(this.na, c);
        }
        this.df = false;
        this.ob(this.na, c);
        this.dl = false;
    };
    ScatterBase.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.m7 == null) {
            this.m7 = new ScatterFrame();
        }
        this.n2(this.m7, g);
        this.ob(this.m7, g);
    };
    ScatterBase.prototype.n7 = function (a, b) {
        var e_6, _a, e_7, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
    };
    ScatterBase.prototype.m0 = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.m4.c.count) {
            c = new Array(this.m4.c.count);
            for (var f = 0; f < this.m4.c.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = this.getEffectiveViewport1(a);
        var h = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.xAxis.b8, g);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = ((function () {
            var $ret = new ScalerParams(0, d, e, _this.yAxis.b8, g);
            $ret.c = _this.getEffectiveViewport1(a);
            $ret.b = _this.eh();
            return $ret;
        })());
        var j = this.lq(a);
        var k = this.m4.a.dz(j.left, h);
        var l = this.m4.a.dz(j.right, h);
        var m = this.m4.b.dz(j.bottom, i);
        var n = this.m4.b.dz(j.top, i);
        if (this.m4.d) {
            var o = k;
            k = l;
            l = o;
        }
        if (this.m4.e) {
            var p = m;
            m = n;
            n = p;
        }
        var q = this.m4;
        var r = q.a;
        var s = q.b;
        var t;
        var u;
        var v = this.nd;
        var w = this.nf;
        for (var x = 0; x < this.m4.c.count; x++) {
            t = v.item(x);
            u = w.item(x);
            if (t >= k && t <= l && u >= m && u <= n) {
                c[x].x = r.dw(t, h);
                c[x].y = s.dw(u, i);
            }
            else {
                c[x].x = NaN;
                c[x].y = NaN;
            }
        }
        return c;
    };
    ScatterBase.prototype.nj = function (a, b) {
        var e_8, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.bz;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        return b;
    };
    ScatterBase.prototype.h4 = function (a) {
        _super.prototype.h4.call(this, a);
        this.a2.exportTrendlineData(this, a, this.m5.ct.g$j);
    };
    ScatterBase.prototype.eh = function () {
        return Series.ei(this.nf, null);
    };
    ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
    ScatterBase.od = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:m6:oe', [ScatterErrorBarSettings.$, null], 'MarkerCollisionAvoidance:m1:of', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:nk:og', [1, 400], 'XAxis::oo', [NumericXAxis.$, null], 'XMemberPath:nr:op', [2, null], 'YAxis::oq', [NumericYAxis.$, null], 'YMemberPath:nv:or', [2, null], 'TrendLineType::om', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::ol', [1, 1.5], 'TrendLinePeriod::ok', [1, 7], 'TrendLineBrush::oh', [Brush.$, null], 'TrendLineZIndex:nl:on', [1, 1001], 'TrendLineDashArray:ot:oi', [DoubleCollection.$], 'TrendLineDashCap:ou:oj', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return ScatterBase;
}(MarkerSeries));
/**
 * @hidden
 */
var ScatterBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterBaseView, _super);
    function ScatterBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cr = null;
        _this.cp = null;
        _this.cs = null;
        _this.cx = null;
        _this.c7 = null;
        _this.c8 = null;
        _this.ct = null;
        _this.c6 = null;
        _this.cu = null;
        _this.cs = a;
        _this.cu = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cu);
        _this.ct = new ScatterTrendLineManager();
        return _this;
    }
    ScatterBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cr = this.cq();
        this.c7 = new Path();
        this.c8 = new Path();
        if (!this.n) {
            this.cs.nk = 2000;
        }
    };
    ScatterBaseView.prototype.c9 = function (a) {
        if (this.c6 == null) {
            this.c6 = new DataTemplateMeasureInfo();
            this.c6.context = this.h.g();
        }
        this.c6.width = a.width;
        this.c6.height = a.height;
        this.c6.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.c6);
        }
        return new Size(1, this.c6.width, this.c6.height);
    };
    ScatterBaseView.prototype.cq = function () {
        var _this = this;
        var a = new NumericMarkerManager(1, function (b) { return _this.cu.item(b); }, function (b) { return _this.cs.m4.c.item(b); }, runOn(this, this.c4), runOn(this, this.cn), runOn(this, this.cv), function () { return _this.cs.m1; });
        a.q = runOn(this, this.c9);
        return a;
    };
    ScatterBaseView.prototype.c4 = function (a) {
        this.cs.n7(a, this.cu);
    };
    ScatterBaseView.prototype.cw = function () {
        return this.b1;
    };
    ScatterBaseView.prototype.co = function () {
        return this.cp;
    };
    ScatterBaseView.prototype.cn = function () {
        this.cp = this.cs.m0(this, this.cu, this.cp, this.bs, this.br);
        return this.cp;
    };
    ScatterBaseView.prototype.cv = function () {
        this.cx = this.cs.nj(this.cu, this.cx);
        return this.cx;
    };
    ScatterBaseView.prototype.cy = function () {
    };
    ScatterBaseView.prototype.c2 = function (a) {
    };
    ScatterBaseView.prototype.cz = function () {
    };
    ScatterBaseView.prototype.c3 = function (a) {
    };
    ScatterBaseView.prototype.c5 = function () {
        if (this.cs.trendLineBrush != null) {
            this.cs.os = this.cs.trendLineBrush;
        }
        else {
            this.cs.os = this.cs.k3;
        }
    };
    ScatterBaseView.prototype.cc = function (a) {
        this.cu.f(a);
    };
    ScatterBaseView.prototype.c1 = function () {
    };
    ScatterBaseView.prototype.a2 = function (a, b) {
        _super.prototype.a2.call(this, a, b);
        if (a.d) {
            if (this.cs.trendLineType != 0 && !b) {
                var c = this.ct.g$j;
                c.ac = this.cs.trendLineThickness;
                c._stroke = this.cs.os;
                c.ai = this.cs.ot;
                c.ad = this.cs.ou;
                a.u(c);
            }
        }
    };
    ScatterBaseView.prototype.c0 = function (a) {
        if (a) {
            this.c1();
            this.cu.clear();
        }
        this.ct.g$d();
        this.an();
    };
    ScatterBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fx + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cs.nr + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cs.nv + "}</span></div>";
        return a;
    };
    ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);
    return ScatterBaseView;
}(MarkerSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BubbleMarkerManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleMarkerManager, _super);
    function BubbleMarkerManager(a, b, c, d, e) {
        var _this = _super.call(this, a, b, c, d, e) || this;
        _this.m = null;
        _this.o = null;
        _this.n = null;
        _this.o = new List$1(Number_$type, 0);
        _this.n = new List$1(Marker.$, 0);
        return _this;
    }
    BubbleMarkerManager.prototype.l = function (a, b, c, d, e) {
        var f = this.f();
        a.clear();
        this.o.clear();
        this.n.clear();
        var g = new List$1(Number_$type, 0);
        b = Math.max(0, b);
        var h = null;
        this.i(c, d, boxArray$1(f), g);
        if (b >= g.count) {
            h = g;
        }
        else {
            h = new List$1(Number_$type, 0);
            var i = Math.max(8, e);
            var j = this.c(d, g, i, boxArray$1(f));
            var k = new List$1(Number_$type, 1, j.keys);
            if (MarkerManagerBase.b) {
                k.y();
            }
            this.k(b, j, k, h);
        }
        for (var l = 0; l < h.count; ++l) {
            var m = f[h._inner[l]].x;
            var n = f[h._inner[l]].y;
            var o = this.m.item(h._inner[l]);
            this.o.add(o);
            var p = this.h(this.g(h._inner[l]));
            p.content.item = this.g(h._inner[l]);
            var q = new OwnedPoint();
            q.a = p.content.item;
            q.c = { $type: Point_$type, x: m, y: n };
            if (!a.containsKey(q.a)) {
                a.addItem(q.a, q);
                this.n.add(p);
            }
        }
    };
    BubbleMarkerManager.prototype.j = function (a, b) {
        var e_1, _a;
        var c = new List$1(Base.$, 1, a.keys);
        if (MarkerManagerBase.b) {
            c.aa(function (d, e) {
                var f = a.item(d);
                var g = a.item(e);
                var h = Math.pow(f.c.x, 2) + Math.pow(f.c.y, 2);
                var i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                return CompareUtil.compareToObject(h, i);
            });
        }
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                var e = a.item(d);
                var f = this.h(e.a);
                f.s = c.indexOf1(d);
                f.n = e.c.x;
                f.o = e.c.y;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.a(a);
    };
    BubbleMarkerManager.$t = markType(BubbleMarkerManager, 'BubbleMarkerManager', MarkerManagerBase.$);
    return BubbleMarkerManager;
}(MarkerManagerBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeries, _super);
    function BubbleSeries() {
        var _this = _super.call(this) || this;
        _this.pw = null;
        _this.pv = null;
        _this.o7 = null;
        _this.o2 = null;
        _this.o1 = null;
        _this.o0 = null;
        _this.ab = BubbleSeries.$;
        _this.m9 = new ScatterFrame();
        _this.nb = new ScatterFrame();
        _this.m8 = new ScatterFrame();
        return _this;
    }
    BubbleSeries.prototype.bf = function () {
        return new BubbleSeriesView(this);
    };
    BubbleSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.oy = a;
    };
    BubbleSeries.prototype.isAttachedTo = function (a) {
        return this.aw == a;
    };
    BubbleSeries.prototype.ci = function () {
        return true;
    };
    BubbleSeries.prototype.h6 = function (a) {
        _super.prototype.h6.call(this, a);
        if (this.o5 != null && this.o7 != null && this.o7.count > 0) {
            for (var b = 0; b < this.o7.count; b++) {
                a(this.o7._inner[b]);
            }
        }
    };
    Object.defineProperty(BubbleSeries.prototype, "o4", {
        get: function () {
            return this.o6;
        },
        enumerable: true,
        configurable: true
    });
    BubbleSeries.prototype.pu = function (a) {
        var b = typeCast(CustomPaletteBrushScale.$, this.ox);
        var c = typeCast(ValueBrushScale.$, this.ox);
        var d = this.ox;
        if (b != null && this.bz != null) {
            return b.getBrush1(a, this.bz.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.o3);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    };
    Object.defineProperty(BubbleSeries.prototype, "legendReady", {
        get: function () {
            return this.o6 != null && this.o6.count != 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "minScaleText", {
        get: function () {
            return (Math.round(this.o6.minimum * 1000) / 1000).toString();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "maxScaleText", {
        get: function () {
            return (Math.round(this.o6.maximum * 1000) / 1000).toString();
        },
        enumerable: true,
        configurable: true
    });
    BubbleSeries.prototype.forScaleColors = function (a) {
        for (var b = 0; b < this.o6.count; b++) {
            if (this.ox == null || !this.ox.isReady) {
                return false;
            }
            var c = NaN;
            if (this.o3 != null) {
                c = (this.o3.item(b) - this.o3.minimum) / (this.o3.maximum - this.o3.minimum);
            }
            var d = (this.o6.item(b) - this.o6.minimum) / (this.o6.maximum - this.o6.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            var e = this.mv;
            var f = this.pu(b);
            var g = f != null ? f : e;
            a(g, d);
        }
        return true;
    };
    BubbleSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == BubbleSeries.$$p[2]) {
            return this.ft(a, b, this.pf);
        }
        if (c == BubbleSeries.$$p[3]) {
            return this.ft(a, b, this.pi);
        }
        if (c == ScatterBase.$$p[4]) {
            return this.ft(a, b, this.nr);
        }
        if (c == ScatterBase.$$p[6]) {
            return this.ft(a, b, this.nv);
        }
        if (c == BubbleSeries.$$p[0]) {
            return this.ft(a, b, this.pb);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(BubbleSeries.prototype, "o6", {
        get: function () {
            return this.o2;
        },
        set: function (a) {
            if (this.o2 != a) {
                var b = this.o6;
                this.o2 = a;
                this.raisePropertyChanged("RadiusColumn", b, this.o6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "o5", {
        get: function () {
            return this.o1;
        },
        set: function (a) {
            if (this.o1 != a) {
                var b = this.o5;
                this.o1 = a;
                this.raisePropertyChanged("LabelColumn", b, this.o5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BubbleSeries.prototype, "o3", {
        get: function () {
            return this.o0;
        },
        set: function (a) {
            if (this.o0 != a) {
                var b = this.o3;
                this.o0 = a;
                this.raisePropertyChanged("FillColumn", b, this.o3);
            }
        },
        enumerable: true,
        configurable: true
    });
    BubbleSeries.prototype.ny = function (a, b, c, d, e) {
        if (c <= this.nk) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        var f = this.nk;
        var g = this.bz;
        var h;
        var i;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(0, d, e, this.m4.d, j);
        var l = new ScalerParams(0, d, e, this.m4.e, j);
        var _loop_1 = function (m) {
            h = this_1.nd.item(m);
            i = this_1.nf.item(m);
            var n = { $type: Point_$type, x: this_1.m4.a.dw(h, k), y: this_1.m4.b.dw(i, l) };
            if (!isInfinity(n.x) && !isInfinity(n.y)) {
                var o_1 = g.item(m);
                if (c <= f) {
                    if (!b.g.containsKey(o_1)) {
                        var p_1 = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(o_1, ((function () {
                            var $ret = new OwnedPoint();
                            $ret.a = o_1;
                            $ret.b = p_1;
                            $ret.c = n;
                            return $ret;
                        })()));
                    }
                }
            }
        };
        var this_1 = this;
        for (var m = 0; m < c; m++) {
            _loop_1(m);
        }
    };
    BubbleSeries.prototype.n2 = function (a, b) {
        var c = typeCast(BubbleSeriesView.$, b);
        var d = c.cr;
        d.m = this.o6;
        _super.prototype.n2.call(this, a, b);
        var e = Math.min(this.nd != null ? this.nd.count : 0, this.nf != null ? this.nf.count : 0);
        if (e < 1) {
            return;
        }
        c.dc();
        c.dd();
    };
    BubbleSeries.prototype.pm = function () {
        if (this.bs == null) {
            return;
        }
        if (this.aw == null) {
            return;
        }
        if (this.aw.isItemwise) {
            var a = this.aw;
            this.aw.clearLegendItemsForSeries(this);
            this.pl();
            a.renderItemwiseContent(this);
        }
        if (this.aw.isScale) {
            var b = this.aw;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    };
    BubbleSeries.o8 = function (a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        var f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    };
    BubbleSeries.o9 = function (a, b, c, d, logBase_, e) {
        var f = logBase(e, logBase_);
        var g = logBase(a, logBase_);
        var h = logBase(b, logBase_);
        return BubbleSeries.o8(g, h, c, d, f);
    };
    BubbleSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.o6 == null || this.bz == null || this.o6.count == 0 || this.bz.count != this.o6.count) {
            d = false;
        }
        return d;
    };
    BubbleSeries.prototype.ni = function (a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.nr == a || this.nv == a || this.pi == a) {
            return true;
        }
        return false;
    };
    BubbleSeries.prototype.pl = function () {
        var _this = this;
        var a = typeCast(IChartLegend_$type, this.aw);
        if (a == null || this.bz == null) {
            return;
        }
        this.o7 = new List$1(UIElement.$, 0);
        var b = this.bz;
        var _loop_2 = function (c) {
            var d = null;
            if (typeCast(ValueBrushScale.$, this_2.ox) !== null && this_2.o3 != null) {
                d = this_2.ox.getBrushByIndex(c, this_2.o3);
            }
            else if (typeCast(CustomPaletteBrushScale.$, this_2.ox) !== null) {
                d = this_2.ox.getBrush1(c, b.count);
            }
            else if (this_2.ox != null) {
                d = this_2.ox.getBrush(c);
            }
            var e = new ContentControl();
            var f = this_2.o5 != null && this_2.o5.item(c) != null ? this_2.o5.item(c).toString() : "";
            e.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this;
                $ret.item = b.item(c);
                $ret.itemBrush = d;
                $ret.itemLabel = f;
                return $ret;
            })());
            var g = this_2.jy;
            if (g == null) {
                g = this_2.bi.bi(this_2.bk);
            }
            e.ah = g;
            this_2.o7.add(e);
        };
        var this_2 = this;
        for (var c = 0; c < b.count; c++) {
            _loop_2(c);
        }
    };
    BubbleSeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        this.pm();
    };
    BubbleSeries.prototype.id = function () {
        _super.prototype.id.call(this);
        this.pm();
    };
    BubbleSeries.prototype.ij = function () {
        _super.prototype.ij.call(this);
        this.pm();
    };
    BubbleSeries.prototype.iz = function (a, b, c, d) {
        var e_1, _a;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.o6);
                    c.deregisterColumn(this.o3);
                    c.deregisterColumn(this.o5);
                    this.o6 = null;
                    this.o3 = null;
                    this.o5 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.o6 = this.bw(this.pi);
                    if (!stringIsNullOrEmpty(this.pb)) {
                        this.o3 = this.bw(this.pb);
                    }
                    this.o5 = this.by(this.pf);
                }
                this.jd(false);
                this.pm();
                break;
            case BubbleSeries.$$p[3]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.o6);
                    this.o6 = this.bw(this.pi);
                    this.pm();
                }
                break;
            case "RadiusColumn":
                this.m5.ct.g$i();
                this.jd(false);
                this.il();
                break;
            case BubbleSeries.$$p[4]:
                this.jd(false);
                this.ik();
                break;
            case "DiscreteLegendItemTemplate":
                this.pm();
                break;
            case BubbleSeries.$$p[1]:
                this.jd(false);
                this.pm();
                this.ik();
                break;
            case "FillColumn":
                this.jd(false);
                this.ik();
                break;
            case BubbleSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.o3);
                    this.o3 = this.bw(this.pb);
                    this.pm();
                }
                break;
            case BubbleSeries.$$p[2]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.o5);
                    this.o5 = this.by(this.pf);
                    this.pm();
                }
                break;
            case "ActualLegend":
                var e = typeCast(IChartLegend_$type, c);
                if (e != null) {
                    e.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    var f = e;
                    var g = true;
                    var h = null;
                    if (this.bs != null) {
                        try {
                            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                                var i = _c.value;
                                if (i.legend == f) {
                                    h = i;
                                    g = false;
                                }
                            }
                        }
                        catch (e_1_1) {
                            e_1 = { error: e_1_1 };
                        }
                        finally {
                            try {
                                if (_c && !_c.done && (_a = _b.return))
                                    _a.call(_b);
                            }
                            finally {
                                if (e_1)
                                    throw e_1.error;
                            }
                        }
                    }
                    if (g) {
                        f.restoreOriginalState();
                    }
                    else {
                        f.initializeLegend(typeCast(IScaleLegendSeries_$type, h));
                    }
                }
                this.pm();
                break;
            case "SeriesViewer":
                this.pm();
                break;
        }
    };
    BubbleSeries.prototype.po = function (a, b, c, d) {
        var e = this.o6.minimum;
        var f = this.o6.maximum;
        var g = c.width;
        if (!this.bi.br.isEmpty) {
            g = this.bi.br.width;
        }
        else if (this.bs != null && !this.bs.m3.isEmpty) {
            g = this.bs.m3.width;
        }
        var h = DeviceUtils.c(g);
        var i = this.oz || ((function () {
            var $ret = new SizeScale();
            $ret.minimumValue = h / 10;
            $ret.maximumValue = h / 5;
            return $ret;
        })());
        if (i != null) {
            var j = i.minimumValue;
            var k = i.maximumValue;
            var l = i.logarithmBase;
            if (!i.l.contains(this)) {
                i.l.add(this);
            }
            if (i.isLogarithmic) {
                for (var m = 0; m < b.count; m++) {
                    b._inner[m] = BubbleSeries.o9(e, f, j, k, l, b._inner[m]);
                }
            }
            else {
                for (var n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.o8(e, f, j, k, b._inner[n]);
                }
            }
        }
        var o = 1;
        o = DeviceUtils.d();
        var p = this.oz == null;
        if (d) {
            var q = c.width / g;
            for (var r = 0; r < b.count; r++) {
                if (p) {
                    b._inner[r] = b._inner[r] / o;
                }
                b._inner[r] = b._inner[r] * q;
            }
        }
        for (var s = 0; s < a.count; s++) {
            var t = a._inner[s];
            if (p && !d) {
                t.width = Math.max(0, b._inner[s] / o);
                t.height = Math.max(0, b._inner[s] / o);
            }
            else {
                t.width = Math.max(0, b._inner[s]);
                t.height = Math.max(0, b._inner[s]);
            }
        }
    };
    BubbleSeries.prototype.pn = function (a) {
        if (this.ox != null && !this.ox.o.contains(this)) {
            this.ox.o.add(this);
        }
        var b = typeCast(CustomPaletteBrushScale.$, this.ox);
        var c = typeCast(ValueBrushScale.$, this.ox);
        var d = this.ox;
        var e = this.ox == null || !this.ox.isReady || (c != null && this.pb == null);
        if (e) {
            this.oy.db();
            var f = typeCast(BubbleSeriesView.$, this.bh);
            if (f != null) {
                f.db();
            }
            return;
        }
        var g = a.count;
        var h = this.bz;
        for (var i = 0; i < g; i++) {
            var j = a._inner[i];
            var k = typeCast(DataContext.$, j.content);
            if (k != null) {
                var l = null;
                var m = h.indexOf(k.item);
                if (b != null) {
                    l = b.getBrush1(m, h.count);
                }
                else if (c != null) {
                    l = c.getBrushByIndex(m, this.o3);
                }
                else if (d != null) {
                    l = d.getBrush(m);
                }
                k.itemBrush = l;
            }
        }
    };
    BubbleSeries.prototype.get_cy = function () {
        return false;
    };
    Object.defineProperty(BubbleSeries.prototype, "actualMarkerBrush", {
        get: function () {
            return this.mv;
        },
        enumerable: true,
        configurable: true
    });
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:pb:pp', [2], 'FillScale:ox:pq', [BrushScale.$], 'LabelMemberPath:pf:pr', [2], 'RadiusMemberPath:pi:ps', [2, null], 'RadiusScale:oz:pt', [SizeScale.$]]);
    return BubbleSeries;
}(ScatterBase));
/**
 * @hidden
 */
var CustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteBrushScale, _super);
    function CustomPaletteBrushScale() {
        return _super.call(this) || this;
    }
    CustomPaletteBrushScale.prototype.getBrush1 = function (a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return _super.prototype.getBrush.call(this, a % this.brushes.count);
        }
        var c = BubbleSeries.o8(0, b - 1, 0, this.brushes.count - 1, a);
        return this.v(c);
    };
    CustomPaletteBrushScale.prototype.get_isReady = function () {
        return this.brushes != null && this.brushes.count > 0;
    };
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'r', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
}(BrushScale));
/**
 * @hidden
 */
var BubbleSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BubbleSeriesView, _super);
    function BubbleSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.da = a;
        _this.ct = new ScatterTrendLineManager();
        return _this;
    }
    BubbleSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.by.l1 = 2;
            this.e.bj = 4;
        }
    };
    BubbleSeriesView.prototype.cq = function () {
        var _this = this;
        return new BubbleMarkerManager(function (a) { return _this.cu.item(a); }, function (a) { return _this.cs.m4.c.item(a); }, runOn(this, this.c4), runOn(this, this.cn), runOn(this, this.cv));
    };
    BubbleSeriesView.prototype.dc = function () {
        var a = this.cr;
        this.da.po(a.n, a.o, this.br, this == this.e.bh);
        this.an();
    };
    BubbleSeriesView.prototype.dd = function () {
        var a = this.cr;
        this.da.pn(a.n);
    };
    BubbleSeriesView.prototype.db = function () {
        var e_2, _a;
        var a = this.cr;
        try {
            for (var _b = __values(fromEnum(a.n)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    BubbleSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.da.fx + "</span><br/><span>" + "(${item." + this.da.nr + "}, ${item." + this.da.nv + "})</span>";
        if (!stringIsNullOrEmpty(this.da.pi)) {
            a += "<span>, Radius: ${item." + this.da.pi + "}</span>";
        }
        a += "</div>";
        return a;
    };
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
}(ScatterBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
var IgrCustomPaletteBrushScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCustomPaletteBrushScale, _super);
    function IgrCustomPaletteBrushScale(props) {
        return _super.call(this, props) || this;
    }
    IgrCustomPaletteBrushScale.prototype.createImplementation = function () {
        return new CustomPaletteBrushScale();
    };
    Object.defineProperty(IgrCustomPaletteBrushScale.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteBrushScale.prototype, "brushSelectionMode", {
        /**
         * Gets or sets the brush selection mode.
        */
        get: function () {
            return this.i.brushSelectionMode;
        },
        set: function (v) {
            this.i.brushSelectionMode = ensureEnum(BrushSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteBrushScale.prototype, "isReady", {
        /**
         * Checks if this scale is ready for useage with a series
        */
        get: function () {
            return this.i.isReady;
        },
        enumerable: true,
        configurable: true
    });
    IgrCustomPaletteBrushScale.prototype.getBrush1 = function (index, total) {
        var iv = this.i.getBrush1(index, total);
        return brushToString(iv);
    };
    return IgrCustomPaletteBrushScale;
}(IgrBrushScale));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCustomPaletteBrushScaleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCustomPaletteBrushScaleModule() {
    }
    IgrCustomPaletteBrushScaleModule.register = function () {
        TypeRegistrar.registerCons("IgrCustomPaletteBrushScale", IgrCustomPaletteBrushScale);
        TypeRegistrar.register("CustomPaletteBrushScale", CustomPaletteBrushScale.$type);
    };
    return IgrCustomPaletteBrushScaleModule;
}());

/**
 * Represents the base class for all IgxDataChartComponent scatter series
*/
var IgrScatterBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterBase, _super);
    function IgrScatterBase(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrScatterBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "isScatter", {
        /**
         * Checks if this series is a scatter series
        */
        get: function () {
            return this.i.c4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current object.
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current object.
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "xMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        */
        get: function () {
            return this.i.nr;
        },
        set: function (v) {
            this.i.nr = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "yMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        */
        get: function () {
            return this.i.nv;
        },
        set: function (v) {
            this.i.nv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "trendLineType", {
        /**
         * Gets or sets the trend type for the current scatter series.
        */
        get: function () {
            return this.i.trendLineType;
        },
        set: function (v) {
            this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "trendLineBrush", {
        /**
         * Gets or sets the brush to use to draw the trend line.
        */
        get: function () {
            return brushToString(this.i.trendLineBrush);
        },
        set: function (v) {
            this.i.trendLineBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "actualTrendLineBrush", {
        /**
         * Gets the effective TrendLineBrush for this series.
        */
        get: function () {
            return brushToString(this.i.os);
        },
        set: function (v) {
            this.i.os = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the current scatter series object's trend line.
        */
        get: function () {
            return this.i.trendLineThickness;
        },
        set: function (v) {
            this.i.trendLineThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the moving average period for the current scatter series object.
         * The typical, and initial, value for trend line period is 7.
        */
        get: function () {
            return this.i.trendLinePeriod;
        },
        set: function (v) {
            this.i.trendLinePeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "markerCollisionAvoidance", {
        /**
         * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
        */
        get: function () {
            return this.i.m1;
        },
        set: function (v) {
            this.i.m1 = ensureEnum(CollisionAvoidanceType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "trendLineZIndex", {
        /**
         * Gets or sets the Z-Index of the trend line.  Values greater than 1000 will result in the trend line being rendered in front of the series data.
        */
        get: function () {
            return this.i.nl;
        },
        set: function (v) {
            this.i.nl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterBase.prototype, "maximumMarkers", {
        /**
         * Gets or sets the maximum number of markerItems displayed by the current series.
         * If more than the specified number of markerItems are visible, the series will automatically
         * choose a representative set.
        */
        get: function () {
            return this.i.nk;
        },
        set: function (v) {
            this.i.nk = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrScatterBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrScatterBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrScatterBase.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    IgrScatterBase.prototype.getSeriesValueMarkerBoundingBox = function (world) {
        var iv = this.i.lw(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrScatterBase.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.nh(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrScatterBase.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.ng(axis);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrScatterBase.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    IgrScatterBase.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgrScatterBase.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    return IgrScatterBase;
}(IgrMarkerSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent bubble series.
*/
var IgrBubbleSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBubbleSeries, _super);
    function IgrBubbleSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrBubbleSeries.prototype.createImplementation = function () {
        return new BubbleSeries();
    };
    Object.defineProperty(IgrBubbleSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "radiusMemberPath", {
        /**
         * Gets or sets the radius mapping property for the current series object.
        */
        get: function () {
            return this.i.pi;
        },
        set: function (v) {
            this.i.pi = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "radiusScale", {
        /**
         * Gets or sets the radius size scale for the bubbles.
        */
        get: function () {
            if (this.i.oz == null) {
                return null;
            }
            if (!this.i.oz.externalObject) {
                var e = IgrSizeScale._createFromInternal(this.i.oz);
                if (e) {
                    e._implementation = this.i.oz;
                }
                this.i.oz.externalObject = e;
            }
            return this.i.oz.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.oz = null : this.i.oz = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "labelMemberPath", {
        /**
         * Gets or sets the Label mapping property for the current series object.
        */
        get: function () {
            return this.i.pf;
        },
        set: function (v) {
            this.i.pf = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "fillMemberPath", {
        /**
         * Gets or sets the fill mapping property for the current series object.
        */
        get: function () {
            return this.i.pb;
        },
        set: function (v) {
            this.i.pb = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "fillScale", {
        /**
         * Gets or sets the brush scale for the marker brush.
        */
        get: function () {
            if (this.i.ox == null) {
                return null;
            }
            if (!this.i.ox.externalObject) {
                var e = IgrBrushScale._createFromInternal(this.i.ox);
                if (e) {
                    e._implementation = this.i.ox;
                }
                this.i.ox.externalObject = e;
            }
            return this.i.ox.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ox = null : this.i.ox = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBubbleSeries.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    IgrBubbleSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.radiusScale && this.radiusScale._styling) {
            this.radiusScale._styling(container, component, this);
        }
        if (this.fillScale && this.fillScale._styling) {
            this.fillScale._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrBubbleSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    return IgrBubbleSeries;
}(IgrScatterBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBubbleSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBubbleSeriesModule() {
    }
    IgrBubbleSeriesModule.register = function () {
        IgrSizeScaleModule.register();
        IgrBrushScaleModule.register();
        IgrValueBrushScaleModule.register();
        IgrCustomPaletteBrushScaleModule.register();
        TypeRegistrar.registerCons("IgrBubbleSeries", IgrBubbleSeries);
        TypeRegistrar.register("BubbleSeries", BubbleSeries.$type);
    };
    return IgrBubbleSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSeries, _super);
    function ScatterSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterSeries.$;
        _this.m9 = new ScatterFrame();
        _this.nb = new ScatterFrame();
        _this.m8 = new ScatterFrame();
        return _this;
    }
    ScatterSeries.prototype.bf = function () {
        return new ScatterSeriesView(this);
    };
    ScatterSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.ox = a;
    };
    ScatterSeries.prototype.get_cy = function () {
        return false;
    };
    ScatterSeries.$t = markType(ScatterSeries, 'ScatterSeries', ScatterBase.$);
    return ScatterSeries;
}(ScatterBase));
/**
 * @hidden
 */
var ScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSeriesView, _super);
    function ScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.da = a;
        return _this;
    }
    ScatterSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.by.l1 = 2;
            this.e.bj = 4;
        }
    };
    ScatterSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    };
    ScatterSeriesView.$t = markType(ScatterSeriesView, 'ScatterSeriesView', ScatterBaseView.$);
    return ScatterSeriesView;
}(ScatterBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent scatter series
*/
var IgrScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterSeries, _super);
    function IgrScatterSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterSeries.prototype.createImplementation = function () {
        return new ScatterSeries();
    };
    Object.defineProperty(IgrScatterSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterSeries.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterSeries;
}(IgrScatterBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterSeriesModule() {
    }
    IgrScatterSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterSeries", IgrScatterSeries);
        TypeRegistrar.register("ScatterSeries", ScatterSeries.$type);
    };
    return IgrScatterSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterLineSeriesView, _super);
    function ScatterLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = new Path();
        return _this;
    }
    ScatterLineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.da._stroke = this.e.k3;
        this.da.ac = this.e.ey;
    };
    ScatterLineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
    };
    ScatterLineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.da);
        }
    };
    ScatterLineSeriesView.prototype.c0 = function (a) {
        _super.prototype.c0.call(this, a);
        this.da.ak = null;
    };
    ScatterLineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.da, "shape", ["Main"]);
    };
    ScatterLineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    ScatterLineSeriesView.$t = markType(ScatterLineSeriesView, 'ScatterLineSeriesView', ScatterBaseView.$);
    return ScatterLineSeriesView;
}(ScatterBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterLineSeries, _super);
    function ScatterLineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterLineSeries.$;
        _this.m9 = new ScatterFrame();
        _this.nb = new ScatterFrame();
        _this.m8 = new ScatterFrame();
        var a = function (b, c, d) {
            var e = _this.bz.indexOf(b.a);
            if (e == -1 || e == 0) {
                return b;
            }
            var f = _this.bz.item(e - 1);
            var g;
            if (!((function () { var h = c.g.tryGetValue(f, g); g = h.p1; return h.ret; })())) {
                return b;
            }
            return g;
        };
        _this.m9.o = a;
        _this.nb.o = a;
        _this.m8.o = a;
        return _this;
    }
    ScatterLineSeries.prototype.bf = function () {
        return new ScatterLineSeriesView(this);
    };
    ScatterLineSeries.prototype.dh = function (a, b) {
        if (this.l4(a, b)) {
            return true;
        }
        if (this.oy(a, b)) {
            return true;
        }
        return false;
    };
    ScatterLineSeries.prototype.oy = function (a, b) {
        var c = this.bi;
        var d = c.da;
        return this.di(a, b, d.ak);
    };
    ScatterLineSeries.prototype.n2 = function (a, b) {
        var _this = this;
        _super.prototype.n2.call(this, a, b);
        a.m.clear();
        a.u.clear();
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.eu * this.eu;
        var g = 0;
        if (this.nd != null) {
            g = this.nd.count;
        }
        if (this.nf != null) {
            g = Math.min(this.nf.count, g);
        }
        var h = new ScalerParams(0, c, d, this.m4.d, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, _this.m4.e, e);
            $ret.b = _this.eh();
            return $ret;
        })());
        var j = arrayShallowClone(this.nd.asArray());
        var k = arrayShallowClone(this.nf.asArray());
        this.xAxis.gn(boxArray$1(j), 0, j.length, h);
        this.yAxis.gn(boxArray$1(k), 0, k.length, i);
        var l = d.top - 10;
        var m = d.bottom + 10;
        var n = d.left - 10;
        var o = d.right + 10;
        var p = ((function () {
            var $ret = new Clipper(1, n, m, o, l, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (var q = 0; q < g;) {
            var r = q;
            ++q;
            if (g > this.nk) {
                while (q < g) {
                    var s = j[q] - j[r];
                    var t = k[q] - k[r];
                    var u = s * s + t * t;
                    if (u >= f) {
                        break;
                    }
                    ++q;
                }
                p.j(this.o5(j, k, r, q - 1));
            }
            else {
                var v = new OwnedPoint();
                v.c = { $type: Point_$type, x: j[r], y: k[r] };
                v.a = this.bz.item(r);
                if (!a.u.containsKey(v.a)) {
                    a.u.addItem(v.a, v);
                }
            }
        }
        if (g > this.nk) {
            p.i = null;
        }
    };
    ScatterLineSeries.prototype.o5 = function (a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a[c], y: b[c] };
        }
        var e = 0;
        var f = 0;
        var g = (d - c + 1);
        for (var h = c; h <= d; ++h) {
            e += a[h];
            f += b[h];
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    };
    ScatterLineSeries.prototype.ob = function (a, b) {
        b.c0(false);
        _super.prototype.ob.call(this, a, b);
        var c = new Rect(0, b.br.left, b.br.top, b.br.width, b.br.height);
        c = RectUtil.t(c, this.ey, this.ey);
        this.n6(a, new Clipper(0, c, false));
        var d = typeCast(ScatterLineSeriesView.$, b);
        this.o3(d.da, a.m.count, function (e) { return a.m._inner[e].x; }, function (e) { return a.m._inner[e].y; }, this.ox, this.eu);
    };
    ScatterLineSeries.prototype.o3 = function (a, b, c, d, e, f) {
        var g = new PathGeometry();
        a.ak = g;
        g.c = new PathFigureCollection();
        var h = new List$1(PolyLineSegment.$, 0);
        var i = 0;
        for (var j = 0; j < b; j++) {
            if (isNaN_(c(j)) || isNaN_(d(j))) {
                var k = j - i;
                if (k > 0) {
                    if (e == 1 || h.count == 0) {
                        var l = new PolyLineSegment();
                        h.add(l);
                    }
                    this.o2(h._inner[h.count - 1]._points, i, j - 1, c, d, f);
                }
                i = j + 1;
            }
        }
        if (e == 1 || h.count == 0) {
            var m = new PolyLineSegment();
            h.add(m);
        }
        this.o2(h._inner[h.count - 1]._points, i, b - 1, c, d, f);
        var _loop_1 = function (n) {
            var o = h._inner[n];
            if (o._points.count > 0) {
                var p = ((function () {
                    var $ret = new PathFigure();
                    $ret.startPoint = o._points._inner[0];
                    return $ret;
                })());
                p._segments.add(o);
                g.c.add(p);
            }
        };
        for (var n = 0; n < h.count; n++) {
            _loop_1(n);
        }
    };
    ScatterLineSeries.prototype.oz = function (a, b, c, d, e, f) {
        var g = new List$1(Number_$type, 0);
        var h = d;
        var i = e;
        var j = i - h + 1;
        while (j > 0) {
            if (j <= 512) {
                Flattener.c(g, b, c, h, i, f);
                h = i + 1;
            }
            else {
                var k = h + 512 - 1;
                Flattener.c(g, b, c, h, k, f);
                h = k + 1;
            }
            j = i - h + 1;
        }
        return g;
    };
    ScatterLineSeries.prototype.o2 = function (a, b, c, d, e, f) {
        if (c > -1) {
            var g = this.eu;
            var h = this.oz(new List$1(Number_$type, 0), d, e, b, c, g);
            var i = void 0;
            for (var j = 0; j < h.count; j++) {
                i = h.item(j);
                a.add({ $type: Point_$type, x: d(i), y: e(i) });
            }
        }
    };
    ScatterLineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ScatterLineSeries.$$p[0]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterLineSeries.$t = markType(ScatterLineSeries, 'ScatterLineSeries', ScatterBase.$);
    ScatterLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:ox:o4', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return ScatterLineSeries;
}(ScatterBase));

/**
 * Represents a IgxDataChartComponent scatter line series
*/
var IgrScatterLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterLineSeries, _super);
    function IgrScatterLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterLineSeries.prototype.createImplementation = function () {
        return new ScatterLineSeries();
    };
    Object.defineProperty(IgrScatterLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterLineSeries.prototype, "unknownValuePlotting", {
        /**
         * Determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: function () {
            return this.i.ox;
        },
        set: function (v) {
            this.i.ox = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterLineSeries;
}(IgrScatterBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterLineSeriesModule() {
    }
    IgrScatterLineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterLineSeries", IgrScatterLineSeries);
        TypeRegistrar.register("ScatterLineSeries", ScatterLineSeries.$type);
    };
    return IgrScatterLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterSplineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSplineSeriesView, _super);
    function ScatterSplineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = new Path();
        return _this;
    }
    ScatterSplineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.da._stroke = this.e.k3;
        this.da.ac = this.e.ey;
    };
    ScatterSplineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
    };
    ScatterSplineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.da);
        }
    };
    ScatterSplineSeriesView.prototype.c0 = function (a) {
        _super.prototype.c0.call(this, a);
        this.da.ak = null;
    };
    ScatterSplineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.da, "shape", ["Main"]);
    };
    ScatterSplineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    };
    ScatterSplineSeriesView.$t = markType(ScatterSplineSeriesView, 'ScatterSplineSeriesView', ScatterBaseView.$);
    return ScatterSplineSeriesView;
}(ScatterBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterSplineSeries, _super);
    function ScatterSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterSplineSeries.$;
        _this.m9 = new ScatterFrame();
        _this.nb = new ScatterFrame();
        _this.m8 = new ScatterFrame();
        return _this;
    }
    ScatterSplineSeries.prototype.bf = function () {
        return new ScatterSplineSeriesView(this);
    };
    ScatterSplineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterSplineSeries.prototype.bd = function () {
        if (this.be == 0) {
            return 2;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    ScatterSplineSeries.prototype.n2 = function (a, b) {
        var _this = this;
        _super.prototype.n2.call(this, a, b);
        a.m.clear();
        a.u.clear();
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.eu * this.eu;
        var g = Math.min(this.nd != null ? this.nd.count : 0, this.nf != null ? this.nf.count : 0);
        var h = new ScalerParams(0, c, d, this.m4.d, e);
        var i = ((function () {
            var $ret = new ScalerParams(0, c, d, _this.m4.e, e);
            $ret.b = _this.eh();
            return $ret;
        })());
        var j = function (k) { return _this.m4.a.dw(_this.nd.item(k), h); };
        var k = function (l) { return _this.m4.b.dw(_this.nf.item(l), i); };
        var l = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (var m = 0; m < g;) {
            var n = m;
            ++m;
            while (m < g && this.ox(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.nk) {
                l.j(this.o1(j, k, n, m - 1));
            }
            else {
                var o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.bz.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.nk) {
            l.i = null;
        }
    };
    ScatterSplineSeries.prototype.o1 = function (a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        var e = 0;
        var f = 0;
        var g = (d - c + 1);
        for (var h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    };
    ScatterSplineSeries.prototype.ox = function (a, b, c, d) {
        var e = a(d) - a(c);
        var f = b(d) - b(c);
        return e * e + f * f;
    };
    ScatterSplineSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        c.c0(false);
    };
    ScatterSplineSeries.prototype.ob = function (a, b) {
        this.hv(false, b);
        _super.prototype.ob.call(this, a, b);
        this.n5(a);
        var c = typeCast(ScatterSplineSeriesView.$, b);
        c.da.ak = new PathGeometry();
        c.da.ak.c = Numeric.h(a.m.count, function (d) { return a.m._inner[d].x; }, function (d) { return a.m._inner[d].y; }, this.oy);
    };
    ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
    ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:oy:o0', [1, 0.5]]);
    return ScatterSplineSeries;
}(ScatterBase));

/**
 * Represents a IgxDataChartComponent scatter spline series
*/
var IgrScatterSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterSplineSeries, _super);
    function IgrScatterSplineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterSplineSeries.prototype.createImplementation = function () {
        return new ScatterSplineSeries();
    };
    Object.defineProperty(IgrScatterSplineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterSplineSeries.prototype, "stiffness", {
        /**
         * Gets or sets the Stiffness property.
        */
        get: function () {
            return this.i.oy;
        },
        set: function (v) {
            this.i.oy = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterSplineSeries;
}(IgrScatterBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterSplineSeriesModule() {
    }
    IgrScatterSplineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterSplineSeries", IgrScatterSplineSeries);
        TypeRegistrar.register("ScatterSplineSeries", ScatterSplineSeries.$type);
    };
    return IgrScatterSplineSeriesModule;
}());

/**
 * Provides information about the progressive load progress of the HighDensityScatterSeries.
*/
var IgrProgressiveLoadStatusEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrProgressiveLoadStatusEventArgs() {
    }
    Object.defineProperty(IgrProgressiveLoadStatusEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrProgressiveLoadStatusEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrProgressiveLoadStatusEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrProgressiveLoadStatusEventArgs.prototype, "currentStatus", {
        /**
         * The current status from 0 to 100 of the progressive load.
        */
        get: function () {
            return this.i.currentStatus;
        },
        set: function (v) {
            this.i.currentStatus = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrProgressiveLoadStatusEventArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KDTreeNode2D = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KDTreeNode2D, _super);
    function KDTreeNode2D() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = false;
        _this.f = false;
        _this.h = 0;
        _this.b = null;
        _this.c = null;
        _this.d = null;
        _this.a = null;
        _this.e = null;
        return _this;
    }
    KDTreeNode2D.$t = markType(KDTreeNode2D, 'KDTreeNode2D');
    return KDTreeNode2D;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KDTreeThunk = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KDTreeThunk, _super);
    function KDTreeThunk() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = 0;
        _this.b = 0;
        _this.c = 0;
        _this.d = 0;
        _this.a = null;
        return _this;
    }
    KDTreeThunk.$t = markType(KDTreeThunk, 'KDTreeThunk');
    return KDTreeThunk;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KNearestResult = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KNearestResult, _super);
    function KNearestResult() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = 0;
        _this.b = false;
        _this.c = 0;
        _this.d = 0;
        _this.a = null;
        return _this;
    }
    KNearestResult.$t = markType(KNearestResult, 'KNearestResult');
    return KNearestResult;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SearchData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SearchData, _super);
    function SearchData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = false;
        _this.d = 0;
        _this.b = 0;
        _this.e = 0;
        _this.c = 0;
        return _this;
    }
    SearchData.$t = markType(SearchData, 'SearchData');
    return SearchData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KDTree2D = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KDTree2D, _super);
    function KDTree2D(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.h = null;
        _this.g = null;
        _this.k = 0;
        _this.o = {};
        _this.progressiveThunkCompleted = null;
        _this.e = false;
        _this.q = new Random(0);
        _this.d = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this.d = _this.c(c, 0, c.length - 1, 0, d);
                }
                break;
            case 1: break;
        }
        return _this;
    }
    Object.defineProperty(KDTree2D.prototype, "p", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    KDTree2D.b = function (a, b) {
        var c = new KDTree2D(1);
        c.d = new KDTreeNode2D();
        c.d.g = true;
        c.a = a;
        c.h = new Stack$1(KDTreeThunk.$);
        c.g = new List$1(KDTreeThunk.$, 0);
        var d = new KDTreeThunk();
        d.e = 0;
        d.b = a.length - 1;
        d.c = 0;
        d.d = b;
        d.a = c.d;
        c.h.h(d);
        return c;
    };
    KDTree2D.prototype.f = function (a) {
        if (this.h.f == 0 && this.g.count == 0) {
            this.a = null;
            return false;
        }
        if (this.h.f == 0 && this.g.count > 0) {
            return true;
        }
        this.k = this.h.d().c;
        while (this.h.f > 0 && this.h.d().c == this.k) {
            this.g.add(this.h.e());
        }
        if (a != null) {
            a.setTimeout(runOn(this, this.y), 0);
        }
        else {
            window.setTimeout(runOn(this, this.y), 0);
        }
        return true;
    };
    KDTree2D.prototype.s = function () {
        this.e = true;
    };
    KDTree2D.prototype.y = function () {
        var a;
        for (var b = 0; b < this.g.count; b++) {
            if (this.e || this.a == null) {
                return;
            }
            if (this.a.length == 0) {
                continue;
            }
            a = this.g._inner[b];
            this.v(a.a, this.a, a.e, a.b, a.c, a.d);
        }
        this.g.clear();
        if (this.progressiveThunkCompleted != null) {
            this.progressiveThunkCompleted(this, new EventArgs());
        }
    };
    KDTree2D.prototype.v = function (a, b, c, d, e, f) {
        a.g = false;
        a.f = (e % 2) == 0;
        a.h = (d - c);
        if (c == d) {
            a.b = b[c];
            return;
        }
        if (c > d) {
            a.g = true;
            return;
        }
        if ((d - c) + 1 <= f) {
            a.b = b[c];
            a.a = new Array((d - c) + 1);
            var g = 0;
            for (var h = c; h <= d; h++) {
                a.a[g++] = b[h];
            }
            return;
        }
        var i = Math.max(intDivide((d - c), 2), 1);
        var j = this.m(b, c, d, a.f, i);
        a.b = b[j];
        if (c <= j - 1) {
            a.c = ((function () {
                var $ret = new KDTreeNode2D();
                $ret.g = true;
                return $ret;
            })());
            a.c.h = ((j - 1) - c) + 1;
            this.h.h(((function () {
                var $ret = new KDTreeThunk();
                $ret.e = c;
                $ret.b = j - 1;
                $ret.c = e + 1;
                $ret.d = f;
                $ret.a = a.c;
                return $ret;
            })()));
        }
        else {
            a.c = null;
        }
        if (j + 1 <= d) {
            a.d = ((function () {
                var $ret = new KDTreeNode2D();
                $ret.g = true;
                return $ret;
            })());
            a.d.h = (d - (j + 1)) + 1;
            this.h.h(((function () {
                var $ret = new KDTreeThunk();
                $ret.e = j + 1;
                $ret.b = d;
                $ret.c = e + 1;
                $ret.d = f;
                $ret.a = a.d;
                return $ret;
            })()));
        }
        else {
            a.d = null;
        }
    };
    KDTree2D.prototype.c = function (a, b, c, d, e) {
        var f = new KDTreeNode2D();
        f.f = (d % 2) == 0;
        f.h = (c - b);
        if (b == c) {
            f.b = a[b];
            return f;
        }
        if (b > c) {
            return null;
        }
        if ((c - b) + 1 <= e) {
            f.b = a[b];
            f.a = new Array(c - b + 1);
            var g = 0;
            for (var h = b; h <= c; h++) {
                f.a[g++] = a[h];
            }
            return f;
        }
        var i = Math.max(intDivide((c - b), 2), 1);
        var j = this.m(a, b, c, f.f, i);
        f.b = a[j];
        f.c = this.c(a, b, j - 1, d + 1, e);
        f.d = this.c(a, j + 1, c, d + 1, e);
        return f;
    };
    KDTree2D.prototype.l = function (a, b, c, d, e) {
        var f = b ? a[e].a : a[e].b;
        var g = a[e];
        a[e] = a[d];
        a[d] = g;
        var h = c;
        for (var i = c; i < d; i++) {
            var j = void 0;
            if (b) {
                j = a[i].a;
            }
            else {
                j = a[i].b;
            }
            if (j <= f) {
                g = a[h];
                a[h] = a[i];
                a[i] = g;
                h++;
            }
        }
        g = a[d];
        a[d] = a[h];
        a[h] = g;
        return h;
    };
    KDTree2D.prototype.m = function (a, b, c, d, e) {
        if (b == c) {
            return b;
        }
        var f = this.q.next2(b, c);
        var g = this.l(a, d, b, c, f);
        var h = g - b + 1;
        if (h == e) {
            return g;
        }
        else if (e < h) {
            return this.m(a, b, g - 1, d, e);
        }
        else {
            return this.m(a, g + 1, c, d, e - h);
        }
    };
    KDTree2D.prototype.w = function (a, b, c, d) {
        this.x(a, b, c, d, this.d);
    };
    KDTree2D.prototype.x = function (a, b, c, d, e) {
        if (e == null || e.g) {
            return;
        }
        if (e.c == null && e.d == null) {
            this.r(a, b, c, e, e.b, true, 0, d);
            if (a.a) {
                return;
            }
            if (e.a != null && e.a.length > 0) {
                for (var f = 0; f < e.a.length; f++) {
                    this.r(a, b, c, e, e.a[f], false, f, d);
                    if (a.a) {
                        return;
                    }
                }
            }
            return;
        }
        this.r(a, b, c, e, e.b, true, 0, d);
        if (a.a) {
            return;
        }
        if (e.f) {
            if (b <= e.b.a) {
                this.x(a, b, c, d, e.c);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, e.b.a, c) < a.c) {
                    this.x(a, b, c, d, e.d);
                }
                if (a.a) {
                    return;
                }
            }
            else {
                this.x(a, b, c, d, e.d);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, e.b.a, c) < a.c) {
                    this.x(a, b, c, d, e.c);
                }
                if (a.a) {
                    return;
                }
            }
        }
        else {
            if (c <= e.b.b) {
                this.x(a, b, c, d, e.c);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, b, e.b.b) < a.c) {
                    this.x(a, b, c, d, e.d);
                }
                if (a.a) {
                    return;
                }
            }
            else {
                this.x(a, b, c, d, e.d);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, b, e.b.b) < a.c) {
                    this.x(a, b, c, d, e.c);
                }
                if (a.a) {
                    return;
                }
            }
        }
    };
    KDTree2D.prototype.r = function (a, b, c, d, e, f, g, h) {
        if (a.a) {
            return;
        }
        if (a.e > a.f) {
            a.a = true;
            return;
        }
        if (a.b.count < h) {
            if (isNaN_(a.d)) {
                a.d = this.i(b, c, e.a, e.b);
                a.c = a.d;
                a.g = 0;
            }
            a.b.add(((function () {
                var $ret = new KNearestResult();
                $ret.b = f;
                $ret.e = g;
                $ret.a = d;
                $ret.c = e.a;
                $ret.d = e.b;
                return $ret;
            })()));
            a.e++;
            var i = this.i(b, c, e.a, e.b);
            if (i < a.d) {
                a.d = i;
            }
            if (i > a.c) {
                a.c = i;
                a.g = a.b.count - 1;
            }
            return;
        }
        var j = 0;
        if (j < a.c) {
            if (j < a.d) {
                a.d = j;
            }
            a.b._inner[a.g] = ((function () {
                var $ret = new KNearestResult();
                $ret.b = f;
                $ret.e = g;
                $ret.a = d;
                $ret.c = e.a;
                $ret.d = e.b;
                return $ret;
            })());
            var k = 0;
            var l = 0;
            for (var m = 0; m < a.b.count; m++) {
                var n = this.i(b, c, a.b._inner[m].c, a.b._inner[m].d);
                if (n > k) {
                    k = n;
                    l = m;
                }
            }
            a.e++;
        }
    };
    KDTree2D.prototype.i = function (a, b, c, d) {
        return (a - c) * (a - c) + (b - d) * (b - d);
    };
    KDTree2D.prototype.t = function (a, b, c, d, e, f) {
        this.u(a, this.d, b, c, d, e, f, false, 0);
    };
    KDTree2D.prototype.u = function (a, b, c, d, e, f, g, h, i) {
        if (b == null) {
            return;
        }
        var j = b.e;
        if (i > c.g || ((g - f) < c.f && (e - d) < c.e)) {
            if (b.e == null) {
                b.e = new SearchData();
            }
            j = b.e;
            j.a = true;
            j.d = d;
            j.b = e;
            j.e = f;
            j.c = g;
            a.add(b);
            return;
        }
        if (j != null) {
            j.a = false;
        }
        if (b.c == null && b.d == null) {
            a.add(b);
            return;
        }
        var k;
        var l;
        var m;
        var n;
        var o;
        var p;
        var q;
        var r;
        if (b.f) {
            k = d;
            l = b.b.a;
            m = f;
            n = g;
            o = b.b.a;
            p = e;
            q = f;
            r = g;
        }
        else {
            k = d;
            l = e;
            m = f;
            n = b.b.b;
            o = d;
            p = e;
            q = b.b.b;
            r = g;
        }
        if (h) {
            a.add(b);
            this.u(a, b.c, c, k, l, m, n, true, i + 1);
            this.u(a, b.d, c, o, p, q, r, true, i + 1);
        }
        else {
            var s = false;
            if (k >= c.c && l <= c.a && m >= c.d && n <= c.b) {
                s = true;
                a.add(b);
                this.u(a, b.c, c, k, l, m, n, true, i + 1);
            }
            else if (!(c.c > l || c.a < k || c.d > n || c.b < m)) {
                s = true;
                a.add(b);
                this.u(a, b.c, c, k, l, m, n, false, i + 1);
            }
            if (o >= c.c && p <= c.a && q >= c.d && r <= c.b) {
                if (!s) {
                    a.add(b);
                }
                this.u(a, b.d, c, o, p, q, r, true, i + 1);
            }
            else if (!(c.c > p || c.a < o || c.d > r || c.b < q)) {
                if (!s) {
                    a.add(b);
                }
                this.u(a, b.d, c, o, p, q, r, false, i + 1);
            }
        }
    };
    KDTree2D.prototype.z = function () {
        this.n(this.d);
    };
    KDTree2D.prototype.n = function (a) {
        if (a == null) {
            return 0;
        }
        if (this.n(a.c) + this.n(a.d) != a.h) {
            var b = 0;
        }
        return a.h + 1;
    };
    KDTree2D.$t = markType(KDTree2D, 'KDTree2D');
    return KDTree2D;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KDPointData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KDPointData, _super);
    function KDPointData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = 0;
        _this.b = 0;
        _this.c = 0;
        return _this;
    }
    KDPointData.$t = markType(KDPointData, 'KDPointData');
    return KDPointData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ProgressiveLoadStatusEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ProgressiveLoadStatusEventArgs, _super);
    function ProgressiveLoadStatusEventArgs(a) {
        var _this = _super.call(this) || this;
        _this._currentStatus = 0;
        _this.currentStatus = a;
        return _this;
    }
    Object.defineProperty(ProgressiveLoadStatusEventArgs.prototype, "currentStatus", {
        get: function () {
            return this._currentStatus;
        },
        set: function (a) {
            this._currentStatus = a;
        },
        enumerable: true,
        configurable: true
    });
    ProgressiveLoadStatusEventArgs.$t = markType(ProgressiveLoadStatusEventArgs, 'ProgressiveLoadStatusEventArgs', EventArgs.$);
    return ProgressiveLoadStatusEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SearchArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SearchArgs, _super);
    function SearchArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 0;
        _this.d = 0;
        _this.a = 0;
        _this.b = 0;
        _this.e = 0;
        _this.f = 0;
        _this.g = 0;
        return _this;
    }
    SearchArgs.$t = markType(SearchArgs, 'SearchArgs');
    return SearchArgs;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeries, _super);
    function HighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.md = null;
        _this.mf = null;
        _this.nl = 0;
        _this.mh = false;
        _this.m1 = 0;
        _this.m0 = 0;
        _this.mz = 0;
        _this.my = 255;
        _this.mx = 0;
        _this.mw = 0;
        _this.m4 = 255;
        _this.m3 = 0;
        _this.m2 = 0;
        _this.l5 = null;
        _this.ma = null;
        _this.mb = null;
        _this.l6 = null;
        _this.l8 = null;
        _this.mj = false;
        _this.nm = 0;
        _this.no = 0;
        _this.ni = 0;
        _this.nh = 0;
        _this.progressiveLoadStatusChanged = null;
        _this.mo = null;
        _this.mu = 0;
        _this.mt = 0;
        _this.mv = 0;
        _this.m7 = 0;
        _this.m5 = 0;
        _this.m6 = 0;
        _this.m8 = 0;
        _this.na = 0;
        _this.nc = 0;
        _this.nb = 0;
        _this.m9 = 0;
        _this.mq = 0;
        _this.mr = 0;
        _this.ms = 0;
        _this.mp = 0;
        _this.nk = 0;
        _this.nj = 0;
        _this.l2 = null;
        _this.nn = 0;
        _this.mi = false;
        _this._itemIndexes = null;
        _this.l3 = null;
        _this.l0 = null;
        _this.mc = null;
        _this.ab = HighDensityScatterSeries.$;
        _this.c7 = false;
        return _this;
    }
    HighDensityScatterSeries.prototype.get_c4 = function () {
        return true;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "me", {
        get: function () {
            return this.md;
        },
        set: function (a) {
            if (this.md != a) {
                var b = this.me;
                this.md = a;
                this.raisePropertyChanged("XColumn", b, this.me);
            }
        },
        enumerable: true,
        configurable: true
    });
    HighDensityScatterSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == HighDensityScatterSeries.$$p[8]) {
            return this.ft(a, b, this.n3);
        }
        if (c == HighDensityScatterSeries.$$p[10]) {
            return this.ft(a, b, this.n7);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "mg", {
        get: function () {
            return this.mf;
        },
        set: function (a) {
            if (this.mf != a) {
                var b = this.mg;
                this.mf = a;
                this.raisePropertyChanged("YColumn", b, this.mg);
            }
        },
        enumerable: true,
        configurable: true
    });
    HighDensityScatterSeries.prototype.ol = function () {
        if (this.l5 == null) {
            return;
        }
        this.l5.s();
        var a = this.l5;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.n9));
        this.l5 = null;
    };
    HighDensityScatterSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (this.bs != null) {
                    var e = this.getEffectiveViewport1(this.bi);
                    this.mi = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.ol();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.me);
                    c.deregisterColumn(this.mg);
                    this.me = null;
                    this.mg = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.me = this.bw(this.n3);
                    this.mg = this.bw(this.n7);
                }
                if ((this.l9 != null && !this.l9.cl()) || (this.l7 != null && !this.l7.cl())) {
                    this.jd(false);
                }
                this.il();
                break;
            case HighDensityScatterSeries.$$p[7]:
                var f = this.l6;
                this.l6 = this.l7;
                this.ol();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.oc));
                }
                if (this.l6 != null) {
                    var g = this.l6;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.oc));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if ((this.l7 != null && !this.l7.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                break;
            case HighDensityScatterSeries.$$p[9]:
                var h = this.l8;
                this.l8 = this.l9;
                this.ol();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.oc));
                }
                if (this.l8 != null) {
                    var i = this.l8;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.oc));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if ((this.l9 != null && !this.l9.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                break;
            case "MouseOverEnabled":
                this.mj = this.c7;
                this.jd(false);
                break;
            case HighDensityScatterSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.me);
                    this.me = this.bw(this.n3);
                }
                break;
            case "XColumn":
                this.ol();
                if (this.l7 != null && !this.l7.cl()) {
                    this.jd(false);
                }
                this.il();
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mg);
                    this.mg = this.bw(this.n7);
                }
                break;
            case "YColumn":
                this.ol();
                if (this.l9 != null && !this.l9.cl()) {
                    this.jd(false);
                }
                this.il();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.ol();
                this.jd(false);
                this.ik();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.jd(false);
                this.ik();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.jd(false);
                this.ik();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.l4.by(this.o0, this.oz)) {
                    return;
                }
                this.m1 = this.o0.o;
                this.m0 = this.o0.n;
                this.mz = this.o0.m;
                this.my = this.oz.o;
                this.mx = this.oz.n;
                this.mw = this.oz.m;
                this.m4 = this.my - this.m1;
                this.m3 = this.mx - this.m0;
                this.m2 = this.mw - this.mz;
                this.jd(false);
                this.ik();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.nl = Math.max(typeGetValue(d) - 1, 0);
                this.mh = this.nl > 0;
                this.jd(false);
                this.ik();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    HighDensityScatterSeries.prototype.ml = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.mk = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.oc = function (a, b) {
        this.ol();
        this.jd(false);
    };
    HighDensityScatterSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.l9 == null || this.l7 == null || this.l7.bf == null || this.l9.bf == null || this.mg == null || this.me == null || this.mg.count < 1 || this.me.count < 1 || this.mg.count != this.me.count || this.l7.j4 == this.l7.j3 || this.l9.j4 == this.l9.j3 || this.ly.isEmpty) {
            d = false;
        }
        return d;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "ns", {
        get: function () {
            return this.nm;
        },
        set: function (a) {
            var b = this.nm;
            this.nm = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.nm);
        },
        enumerable: true,
        configurable: true
    });
    HighDensityScatterSeries.prototype.je = function (a) {
        _super.prototype.je.call(this, a);
        this.oe(a, this.bi);
    };
    HighDensityScatterSeries.prototype.oe = function (a, b) {
        if (this.cc(b)) {
            return;
        }
        if (this.l5 == null && !this.mn) {
            var c = new List$1(KDPointData.$, 2, this.me.count);
            var d = this.l7;
            var e = this.l9;
            var f = new Rect(0, 0, 0, 1, 1);
            var g = new Rect(0, 0, 0, 1, 1);
            var h = new ScalerParams(1, f, g, d.b8);
            var i = new ScalerParams(1, f, g, e.b8);
            var j_1;
            var k_1;
            var _loop_1 = function (l) {
                j_1 = d.dw(this_1.me.item(l), h);
                k_1 = e.dw(this_1.mg.item(l), i);
                if (!isNaN_(j_1) && !isNaN_(k_1) && !isInfinity(j_1) && !isInfinity(k_1)) {
                    c.add(((function () {
                        var $ret = new KDPointData();
                        $ret.a = j_1;
                        $ret.b = k_1;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            };
            var this_1 = this;
            for (var l = 0; l < this.me.count; l++) {
                _loop_1(l);
            }
            if (this.mm) {
                this.nh = 1;
                this.ni = truncate(logBase(c.count, 2)) + 3;
                this.ns = truncate(((this.nh / this.ni) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.ns));
                }
                this.l5 = KDTree2D.b(c.toArray(), 1);
                var m = this.l5;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.n9));
                if (!this.l5.f(this.e4)) {
                    var n = this.l5;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.n9));
                }
                this.ik();
            }
            else {
                var o = dateNow();
                this.l5 = new KDTree2D(0, c.toArray(), 1);
                var p = dateNow();
            }
        }
        if (this.mm && !this.mn) {
            this.of(b);
        }
        else {
            this.og(b);
        }
    };
    HighDensityScatterSeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        this.ol();
        var e = false;
        if (this.l7 != null && !this.l7.cl()) {
            e = true;
        }
        if (this.l9 != null && !this.l9.cl()) {
            e = true;
        }
        if (e) {
            this.jd(false);
        }
        this.il();
    };
    HighDensityScatterSeries.prototype.ob = function (a) {
        var b = a;
        var c = this.nk * this.nj;
        if (this.mj) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (var d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (var e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    };
    HighDensityScatterSeries.prototype.og = function (a) {
        var b;
        var c;
        var d = null;
        if (a.n) {
            d = this._itemIndexes;
        }
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        var f = a;
        var g = this.getEffectiveViewport1(a);
        this.ma = new ScalerParams(0, b, c, this.l6.b8, g);
        this.mb = new ScalerParams(0, b, c, this.l8.b8, g);
        this.oa(a);
        this.ob(a);
        var h = this.nk * this.nj;
        if (this.l3 == null || this.l3.length != h) {
            this.l3 = new Array(h);
            this.l0 = new Array(h);
        }
        var i = this.l3.length;
        var j = this.l3;
        var k = this.l0;
        for (var l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.no = truncate(Math.round(this.eu));
        this.l2 = f.bv();
        var m = this.l2.length;
        var n = this.l2;
        for (var o = 0; o < m; o++) {
            n[o] = 0;
        }
        var p = this.nf;
        var q = this.ne;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.mu = Math.min(p, q);
        this.mt = Math.max(p, q);
        if (this.mu < 0) {
            this.mu = 0;
        }
        if (this.mt < 0) {
            this.mt = 0;
        }
        this.mv = this.mt - this.mu;
        if (this.mn) {
            this.od(a);
        }
        else {
            this.on(a);
        }
        f.b6();
        if (a.n) {
            this._itemIndexes = d;
            this.l4.b7();
        }
    };
    HighDensityScatterSeries.prototype.of = function (a) {
        if (this.l5 == null) {
            return;
        }
        this.og(a);
    };
    HighDensityScatterSeries.prototype.n9 = function (a, b) {
        var _this = this;
        this.l4.b5(function () {
            if (_this.nh < _this.ni - 1) {
                _this.nh++;
            }
            _this.ns = truncate(((_this.nh / _this.ni) * 100));
            if (_this.progressiveLoadStatusChanged != null) {
                _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.ns));
            }
            _this.of(_this.bi);
            _this.ik();
            if (_this.l5 != null) {
                if (!_this.l5.f(_this.e4)) {
                    var c = _this.l5;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(_this, _this.n9));
                    _this.ns = 100;
                    if (_this.progressiveLoadStatusChanged != null) {
                        _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.ns));
                    }
                }
            }
        });
    };
    HighDensityScatterSeries.prototype.od = function (a) {
        var b = arrayShallowClone(this.me.asArray());
        this.l7.gn(boxArray$1(b), 0, b.length, this.ma);
        var c = arrayShallowClone(this.mg.asArray());
        this.nn = 0;
        var d = this.nl;
        var e = this.mh;
        var f = this.l3.length;
        this.l9.gn(boxArray$1(c), 0, c.length, this.mb);
        var g = 255 << 24 | truncate(this.m1) << 16 | truncate(this.m0) << 8 | truncate(this.mz);
        for (var h = 0; h < b.length; h++) {
            var i = truncate(b[h]);
            var j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.nk || j < 0 || j >= this.nj) {
                continue;
            }
            if (e) {
                var k = i - d;
                var l = i + d;
                l = l > (this.nk - 1) ? (this.nk - 1) : l;
                k = k < 0 ? 0 : k;
                var m = j + d;
                var n = j - d;
                for (var o = k; o <= l; o++) {
                    for (var p = n; p <= m; p++) {
                        var q = (p * this.nk) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.l3[q] = this.l3[q] + 1;
                        this.l0[q] = 1;
                        this.nn++;
                        if (this.mj) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                var r = (j * this.nk) + i;
                this.l3[r] = this.l3[r] + 1;
                this.l0[r] = 1;
                this.nn++;
                if (this.mj) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.oh();
    };
    HighDensityScatterSeries.prototype.on = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.l5 == null) {
            return;
        }
        if (this.mo == null) {
            this.mo = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.mo.clear();
        }
        var e = c.left;
        var f = c.right;
        var g = c.top;
        var h = c.bottom;
        this.nb = c.top;
        this.m9 = c.height;
        this.na = c.left;
        this.nc = c.width;
        this.m7 = b.top;
        this.m5 = b.height;
        this.m6 = b.left;
        this.m8 = b.width;
        var i = this.getEffectiveViewport1(a);
        this.mq = (i.left - this.m6) / this.m8;
        this.mr = (i.top - this.m7) / this.m5;
        var j = (i.right - this.m6) / this.m8;
        this.ms = j - this.mq;
        var k = (i.bottom - this.m7) / this.m5;
        this.mp = k - this.mr;
        if (this.mi) {
            e = (e - this.mq) / this.ms;
            f = (f - this.mq) / this.ms;
            g = (g - this.mr) / this.mp;
            h = (h - this.mr) / this.mp;
        }
        var l = this.eu / b.width * c.width;
        var m = this.eu / b.height * c.height;
        var n = Math.min(l, m);
        var o = ((function () {
            var $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.l5.t(this.mo, o, 0, 1, 0, 1);
        var p;
        this.nn = 0;
        for (var q = 0; q < this.mo.count; q++) {
            p = this.mo._inner[q];
            this.oi(p);
        }
        this.oh();
    };
    HighDensityScatterSeries.prototype.oi = function (a) {
        if (a.g) {
            return;
        }
        var b = a.e != null && a.e.a;
        var c = a.a == null ? 0 : a.a.length;
        var d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.ok(a.b, d, b, a.e);
        if (c > 0 && !b) {
            var e = void 0;
            for (var f = 0; f < c; f++) {
                e = a.a[f];
                this.ok(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    };
    HighDensityScatterSeries.prototype.c9 = function (a) {
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        var c = this.bs != null ? this.bs.m3 : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.ls(this.bi);
        var f = new ScalerParams(0, d, d, this.l7.b8, e);
        var g = new ScalerParams(0, d, d, this.l9.b8, e);
        var h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        var i = this.l7 != null && this.me != null && h < this.me.count ? this.l7.dw(this.me.item(h), f) : NaN;
        var j = this.l9 != null && this.mg != null && h < this.mg.count ? this.l9.dw(this.mg.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    };
    HighDensityScatterSeries.prototype.ok = function (a, b, c, d) {
        var e = this.nq(b);
        var f = a.c;
        var g = this.nl;
        if (c) {
            var h = d.d;
            var i = d.b;
            var j = d.e;
            var k = d.c;
            if (this.mi) {
                h = this.mq + this.ms * h;
                i = this.mq + this.ms * i;
                j = this.mr + this.mp * j;
                k = this.mr + this.mp * k;
            }
            var l = truncate((this.m6 + this.m8 * (h - this.na) / this.nc));
            var m = truncate((this.m6 + this.m8 * (i - this.na) / this.nc));
            var n = truncate((this.m7 + this.m5 * (j - this.nb) / this.m9));
            var o = truncate((this.m7 + this.m5 * (k - this.nb) / this.m9));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.mh) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            var p = ((m - l) + 1) * ((o - n) + 1);
            var q = b / p;
            var r = q;
            for (var s = l; s <= m; s++) {
                for (var t = n; t <= o; t++) {
                    this.oj(f, s, t, q, r);
                }
            }
        }
        else {
            var u = a.a;
            var v = a.b;
            if (this.mi) {
                u = this.mq + this.ms * u;
                v = this.mr + this.mp * v;
            }
            var w = truncate((this.m6 + this.m8 * (u - this.na) / this.nc));
            var x = truncate((this.m7 + this.m5 * (v - this.nb) / this.m9));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.mh) {
                var y = w - g;
                var z = w + g;
                var aa = x + g;
                var ab = x - g;
                var ac = ((z - y) + 1) * ((aa - ab) + 1);
                var ad = b / ac;
                var ae = ad;
                for (var af = y; af <= z; af++) {
                    for (var ag = ab; ag <= aa; ag++) {
                        this.oj(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.oj(f, w, x, b, 1);
            }
        }
    };
    HighDensityScatterSeries.prototype.np = function (a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.m1 + a * this.m4))) << 16 | truncate(Math.floor(b * (this.m0 + a * this.m3))) << 8 | truncate(Math.floor(b * (this.mz + a * this.m2)));
    };
    HighDensityScatterSeries.prototype.nq = function (a) {
        return 255 << 24 | truncate(Math.floor((this.m1 + a * this.m4))) << 16 | truncate(Math.floor((this.m0 + a * this.m3))) << 8 | truncate(Math.floor((this.mz + a * this.m2)));
    };
    HighDensityScatterSeries.prototype.nd = function (a) {
        return (a >> 24 & 255) / 255;
    };
    HighDensityScatterSeries.prototype.oj = function (a, b, c, d, e) {
        if (b < 0 || b >= this.nk || c < 0 || c >= this.nj) {
            return;
        }
        var f = (c * this.nk) + b;
        this.l3[f] = this.l3[f] + d;
        this.l0[f] = this.l0[f] + e;
        if (this.mj) {
            this._itemIndexes[f] = a + 1;
        }
        this.nn += truncate(d);
    };
    HighDensityScatterSeries.prototype.oh = function () {
        var a = 0;
        var b = 0;
        var c = this.mv;
        var d = this.mu;
        var e = this.mt;
        var f = this.l3.length;
        var g = this.l3;
        var h = this.l0;
        var i = this.l2;
        var j = NaN;
        var k = NaN;
        var l = 0;
        var m = 0;
        for (var n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.np(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    };
    HighDensityScatterSeries.prototype.oa = function (a) {
        var b = a;
        b.b3();
    };
    HighDensityScatterSeries.prototype.bf = function () {
        return new HighDensityScatterSeriesView(this);
    };
    HighDensityScatterSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.l4 = a;
    };
    HighDensityScatterSeries.prototype.an = function (a) {
        if (a != null && a == this.l7 && this.me != null) {
            return new AxisRange(this.me.minimum, this.me.maximum);
        }
        if (a != null && a == this.l9 && this.mg != null) {
            return new AxisRange(this.mg.minimum, this.mg.maximum);
        }
        return null;
    };
    HighDensityScatterSeries.prototype.js = function (a, b) {
        if (this.bs != null) {
            var c = this.getEffectiveViewport1(this.bi);
            this.mi = !c.isEmpty;
        }
        this.jd(false);
    };
    HighDensityScatterSeries.prototype.jt = function (a, b) {
        this.jd(false);
    };
    HighDensityScatterSeries.prototype.fp = function (a) {
        if (!this.mj || this._itemIndexes == null || this.bs == null || this.bz == null || this._itemIndexes.length != (this.nk * this.nj)) {
            return null;
        }
        var b = this.bs.mq;
        var c = (a.x - b.left) / b.width;
        var d = (a.y - b.top) / b.height;
        var e = truncate(Math.round(this.ly.left + (this.ly.width * c)));
        var f = truncate(Math.round(this.ly.top + (this.ly.height * d)));
        var g = this.nt(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        var h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.bz.count) {
            return null;
        }
        return this.bz.item(h);
    };
    HighDensityScatterSeries.prototype.nt = function (a, b) {
        var c = (this.nk * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        var d = 1;
        c = (this.nk * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nk * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    };
    HighDensityScatterSeries.prototype.om = function (a, b, c) {
        this.l2 = a;
        this.nk = b;
        this.nj = c;
    };
    HighDensityScatterSeries.prototype.get_dq = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.set_dq = function (a) {
        _super.prototype.set_dq.call(this, a);
    };
    HighDensityScatterSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        this.l4.b4();
        if (this.bh != null) {
            this.bh.b4();
        }
        this.ik();
    };
    HighDensityScatterSeries.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = typeCast(HighDensityScatterSeriesView.$, this.bh);
        var d = new ScatterFrame();
        this.oe(false, c);
        this.dl = false;
    };
    HighDensityScatterSeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.mc == null) {
            this.mc = new ScatterFrame();
        }
        this.oe(false, f);
    };
    HighDensityScatterSeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.l7 = null;
        this.l9 = null;
    };
    HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    HighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:oz:oo', [Color.$, null], 'HeatMaximum:ne:op', [1, 50], 'HeatMinimumColor:o0:oq', [Color.$, null], 'HeatMinimum:nf:or', [1, 0], 'PointExtent:nr:os', [1, 1], 'ProgressiveLoad:mm:ot', [0, true], 'UseBruteForce:mn:ou', [0, false], 'XAxis:l7:ov', [NumericXAxis.$, null], 'XMemberPath:n3:ow', [2, null], 'YAxis:l9:ox', [NumericYAxis.$, null], 'YMemberPath:n7:oy', [2, null]]);
    return HighDensityScatterSeries;
}(Series));
/**
 * @hidden
 */
var HighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HighDensityScatterSeriesView, _super);
    function HighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bw = null;
        _this.bu = null;
        _this.b2 = 0;
        _this.b1 = 0;
        _this.bz = null;
        _this.b0 = null;
        _this.bx = null;
        _this.bw = a;
        return _this;
    }
    HighDensityScatterSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.eu = 4;
            this.bw.o0 = Color.u(255, 0, 0, 0);
            this.bw.oz = Color.u(255, 255, 0, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.b7 = function () {
        this.bw.om(this.bu, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.prototype.b3 = function () {
        if (this.bz == null) {
            this.bz = this.e.e4.createElement("canvas");
            var a = this.e.e4.get2DCanvasContext(this.bz);
            this.bx = new RenderingContext(new CanvasViewRenderer(), a);
        }
        var b;
        if (this.m) {
            b = this.br;
        }
        else {
            b = this.e.bs.mv();
        }
        var c = truncate(Math.round(b.left));
        var d = truncate(Math.round(b.top));
        var e = truncate(Math.round(b.width));
        var f = truncate(Math.round(b.height));
        var g = this.b2;
        var h = this.b1;
        this.b2 = e;
        this.b1 = f;
        if (g != this.b2 || h != this.b1 || this.bu == null) {
            this.bz.setAttribute("width", e.toString());
            this.bz.setAttribute("height", f.toString());
            this.b0 = this.bx.g().getImageData(0, 0, e, f);
            var imageDataArray_ = this.b0.data;
            this.bu = imageDataArray_;
        }
        this.bw.om(this.bu, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.prototype.bv = function () {
        return this.bu;
    };
    HighDensityScatterSeriesView.prototype.b6 = function () {
        var a = truncate(Math.round(this.br.left));
        var b = truncate(Math.round(this.br.left));
        var c = truncate(Math.round(this.br.width));
        var d = truncate(Math.round(this.br.height));
        this.bx.g().putImageData(this.b0, 0, 0);
        this.an();
    };
    HighDensityScatterSeriesView.prototype.b5 = function (a) {
        if (this.e.e4 != null) {
            this.e.e4.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            if (!this.bw.c7) {
                return;
            }
            var c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
            return;
        }
        if (this.bz == null) {
            return;
        }
        var d = truncate(Math.round(this.br.left));
        var e = truncate(Math.round(this.br.top));
        var f = truncate(Math.round(this.br.width));
        var g = truncate(Math.round(this.br.height));
        this.h.n(this.bz.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    };
    HighDensityScatterSeriesView.prototype.by = function (a, b) {
        return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
    };
    HighDensityScatterSeriesView.prototype.b4 = function () {
        if (this.bu != null) {
            for (var a = 0; a < this.bu.length; a++) {
                this.bu[a] = 0;
            }
            this.b6();
        }
    };
    HighDensityScatterSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        if (this.bu == null) {
            this.e.a2.exportSeriesPixelsData(a, null, this.b2, this.b1);
            return;
        }
        var b = new Array(intDivide(this.bu.length, 4));
        var c;
        for (var d = 0; d < intDivide(this.bu.length, 4); d++) {
            c = d * 4;
            b[d] = this.bu[c + 3] << 24 | this.bu[c] << 16 | this.bu[c + 1] << 8 | this.bu[c + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, b, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent series where a high volume of scatter points can be displayed.
*/
var IgrHighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHighDensityScatterSeries, _super);
    function IgrHighDensityScatterSeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        _this._progressiveLoadStatusChanged = null;
        _this._progressiveLoadStatusChanged_wrapped = null;
        return _this;
    }
    IgrHighDensityScatterSeries.prototype.createImplementation = function () {
        return new HighDensityScatterSeries();
    };
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "isScatter", {
        /**
         * Checks if this series is a scatter series
        */
        get: function () {
            return this.i.c4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current object.
        */
        get: function () {
            if (this.i.l7 == null) {
                return null;
            }
            if (!this.i.l7.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.l7);
                if (e) {
                    e._implementation = this.i.l7;
                }
                this.i.l7.externalObject = e;
            }
            return this.i.l7.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l7 = null : this.i.l7 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current object.
        */
        get: function () {
            if (this.i.l9 == null) {
                return null;
            }
            if (!this.i.l9.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.l9);
                if (e) {
                    e._implementation = this.i.l9;
                }
                this.i.l9.externalObject = e;
            }
            return this.i.l9.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l9 = null : this.i.l9 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "xMemberPath", {
        /**
         * Gets or sets the x value mapping property for the current series object.
        */
        get: function () {
            return this.i.n3;
        },
        set: function (v) {
            this.i.n3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "yMemberPath", {
        /**
         * Gets or sets the y value mapping property for the current series object.
        */
        get: function () {
            return this.i.n7;
        },
        set: function (v) {
            this.i.n7 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "useBruteForce", {
        /**
         * Gets or sets the whether to use use brute force mode.
        */
        get: function () {
            return this.i.mn;
        },
        set: function (v) {
            this.i.mn = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "progressiveLoad", {
        /**
         * Gets or sets the whether to progressively load the data into the chart.
        */
        get: function () {
            return this.i.mm;
        },
        set: function (v) {
            this.i.mm = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "heatMinimum", {
        /**
         * Gets or sets the density value that maps to the minimum heat color.
        */
        get: function () {
            return this.i.nf;
        },
        set: function (v) {
            this.i.nf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "heatMaximum", {
        /**
         * Gets or sets the value that maps to the maximum heat color.
        */
        get: function () {
            return this.i.ne;
        },
        set: function (v) {
            this.i.ne = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "heatMinimumColor", {
        /**
         * Gets or sets the color to use for the minimum end of the scale.
        */
        get: function () {
            return colorToString(this.i.o0);
        },
        set: function (v) {
            this.i.o0 = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "heatMaximumColor", {
        /**
         * Gets or sets the color to use for the maximum end of the scale.
        */
        get: function () {
            return colorToString(this.i.oz);
        },
        set: function (v) {
            this.i.oz = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "pointExtent", {
        /**
         * Gets or sets the the pixel extent of the square data points that are rendered.
        */
        get: function () {
            return this.i.nr;
        },
        set: function (v) {
            this.i.nr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "progressiveStatus", {
        /**
         * Represents the current status of the progressive load of the series. It will range from 0 to 100, where 100 is fully loaded.
        */
        get: function () {
            return this.i.ns;
        },
        set: function (v) {
            this.i.ns = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrHighDensityScatterSeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrHighDensityScatterSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrHighDensityScatterSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrHighDensityScatterSeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.ml(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrHighDensityScatterSeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.mk(axis);
        return (iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgrHighDensityScatterSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrHighDensityScatterSeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    Object.defineProperty(IgrHighDensityScatterSeries.prototype, "progressiveLoadStatusChanged", {
        /**
         * Raised when the progressive loading state of the series has changed.
        */
        get: function () {
            return this._progressiveLoadStatusChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._progressiveLoadStatusChanged_wrapped !== null) {
                this.i.progressiveLoadStatusChanged = delegateRemove(this.i.progressiveLoadStatusChanged, this._progressiveLoadStatusChanged_wrapped);
                this._progressiveLoadStatusChanged_wrapped = null;
                this._progressiveLoadStatusChanged = null;
            }
            this._progressiveLoadStatusChanged = ev;
            this._progressiveLoadStatusChanged_wrapped = function (o, e) {
                var outerArgs = new IgrProgressiveLoadStatusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeProgressiveLoadStatusChanged) {
                    _this.beforeProgressiveLoadStatusChanged(_this, outerArgs);
                }
                if (_this._progressiveLoadStatusChanged) {
                    _this._progressiveLoadStatusChanged(_this, outerArgs);
                }
            };
            this.i.progressiveLoadStatusChanged = delegateCombine(this.i.progressiveLoadStatusChanged, this._progressiveLoadStatusChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrHighDensityScatterSeries;
}(IgrSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrHighDensityScatterSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrHighDensityScatterSeriesModule() {
    }
    IgrHighDensityScatterSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrHighDensityScatterSeries", IgrHighDensityScatterSeries);
        TypeRegistrar.register("HighDensityScatterSeries", HighDensityScatterSeries.$type);
    };
    return IgrHighDensityScatterSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartScatterModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartScatterModule() {
    }
    IgrDataChartScatterModule.register = function () {
        IgrBubbleSeriesModule.register();
        IgrScatterSeriesModule.register();
        IgrScatterLineSeriesModule.register();
        IgrScatterSplineSeriesModule.register();
        IgrHighDensityScatterSeriesModule.register();
        IgrDataChartScatterCoreModule.register();
    };
    return IgrDataChartScatterModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartShapeCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartShapeCoreModule() {
    }
    IgrDataChartShapeCoreModule.register = function () {
        IgrNumericXAxisModule.register();
        IgrNumericYAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartShapeCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes of interpolation on a color scale.
 */
var ColorScaleInterpolationMode = /*@__PURE__*/ (function (ColorScaleInterpolationMode) {
    /**
     * Select one of the colors in the palette.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["Select"] = 0] = "Select";
    /**
     * Interpolate between colors in the palette using RGB interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateRGB"] = 1] = "InterpolateRGB";
    /**
     * Interpolate between colors in the palette using HSV interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateHSV"] = 2] = "InterpolateHSV";
    return ColorScaleInterpolationMode;
})({});
/**
 * @hidden
 */
var ColorScaleInterpolationMode_$type = /*@__PURE__*/ markEnum('ColorScaleInterpolationMode', 'Select,0|InterpolateRGB,1|InterpolateHSV,2');

/**
 * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
*/
var IgrColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColorScale, _super);
    function IgrColorScale(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._propertyUpdated = null;
        _this._propertyUpdated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrColorScale.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrColorScale.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrColorScale._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrColorScale.prototype.onImplementationCreated = function () {
    };
    IgrColorScale.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrColorScale.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrColorScale.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrColorScale.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrColorScale.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrColorScale.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ColorScale");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    Object.defineProperty(IgrColorScale.prototype, "propertyUpdated", {
        /**
         * Event raised when a property (including "effective" and non-dependency property) value changes.
        */
        get: function () {
            return this._propertyUpdated;
        },
        set: function (ev) {
            var _this = this;
            if (this._propertyUpdated_wrapped !== null) {
                this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
                this._propertyUpdated_wrapped = null;
                this._propertyUpdated = null;
            }
            this._propertyUpdated = ev;
            this._propertyUpdated_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyUpdatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePropertyUpdated) {
                    _this.beforePropertyUpdated(_this, outerArgs);
                }
                if (_this._propertyUpdated) {
                    _this._propertyUpdated(_this, outerArgs);
                }
            };
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrColorScale;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColorScale, _super);
    function ColorScale() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        return _this;
    }
    ColorScale.prototype.l = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    ColorScale.prototype.k = function (a, b, c, d) {
    };
    ColorScale.$t = markType(ColorScale, 'ColorScale', DependencyObject.$, [INotifyPropertyChanged_$type]);
    return ColorScale;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomPaletteColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomPaletteColorScale, _super);
    function CustomPaletteColorScale() {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.ag = new Color();
        _this.u = NaN;
        _this.t = NaN;
        _this.s = true;
        _this.r = true;
        _this.n = 0;
        _this.ag = Color.u(0, 0, 0, 0);
        _this.p = new ObservableColorCollection();
        var a = _this.p;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.ab));
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (b, c) { return _this.k(b, c.propertyName, c.oldValue, c.newValue); });
        return _this;
    }
    Object.defineProperty(CustomPaletteColorScale.prototype, "palette", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p;
            if (this.p != null) {
                var c = this.p;
                c.collectionChanged = delegateRemove(c.collectionChanged, runOn(this, this.ab));
            }
            this.p = a;
            if (this.p != null) {
                var d = this.p;
                d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.ab));
            }
            this.l("Palette", b, this.palette);
        },
        enumerable: true,
        configurable: true
    });
    CustomPaletteColorScale.prototype.ab = function (a, b) {
        this.l("Palette", this.palette, this.palette);
    };
    CustomPaletteColorScale.prototype.k = function (a, b, c, d) {
        _super.prototype.k.call(this, a, b, c, d);
        switch (b) {
            case CustomPaletteColorScale.$$p[2]:
                this.u = this.minimumValue;
                this.s = isNaN_(this.u);
                break;
            case CustomPaletteColorScale.$$p[1]:
                this.t = this.maximumValue;
                this.r = isNaN_(this.t);
                break;
            case CustomPaletteColorScale.$$p[0]:
                this.n = this.interpolationMode;
                break;
        }
    };
    CustomPaletteColorScale.prototype.getColor = function (a, b, c, d) {
        if (((this.p == null) || (this.p.count == 0)) || d == null) {
            return this.ag;
        }
        var e = this.s ? b : this.u;
        var f = this.r ? c : this.t;
        var g = (a - e) / (f - e);
        if (isNaN_(g) || g < 0 || g > 1) {
            return this.ag;
        }
        var h = g * (this.p.count - 1);
        if (this.n == 2 || this.n == 1) {
            var i = Math.floor(h);
            var j = Math.ceil(h);
            var k = this.p._inner[truncate(i)];
            var l = this.p._inner[truncate(j)];
            var m = h - i;
            var n = this.n == 2 ? 1 : 0;
            return ColorUtil.n(k, m, l, n);
        }
        else {
            var o = truncate(Math.round(h));
            return this.p._inner[o];
        }
    };
    CustomPaletteColorScale.prototype.providePalette = function (a) {
        var b = new ObservableColorCollection();
        var _loop_1 = function (d) {
            var c = a[d];
            var e = ((function () {
                var $ret = new Color();
                $ret.colorString = c;
                return $ret;
            })());
            b.add(e);
        };
        for (var d = 0; d < a.length; d++) {
            _loop_1(d);
        }
        this.palette = b;
    };
    CustomPaletteColorScale.$t = markType(CustomPaletteColorScale, 'CustomPaletteColorScale', ColorScale.$);
    CustomPaletteColorScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteColorScale, 'l', ['InterpolationMode', [ColorScaleInterpolationMode_$type, enumGetBox(ColorScaleInterpolationMode_$type, 0)], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);
    return CustomPaletteColorScale;
}(ColorScale));

/**
 * ColorScale class for selecting a color from a given palette, or interpolating between adjacent colors in that palette.
*/
var IgrCustomPaletteColorScale = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCustomPaletteColorScale, _super);
    function IgrCustomPaletteColorScale(props) {
        return _super.call(this, props) || this;
    }
    IgrCustomPaletteColorScale.prototype.createImplementation = function () {
        return new CustomPaletteColorScale();
    };
    Object.defineProperty(IgrCustomPaletteColorScale.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteColorScale.prototype, "minimumValue", {
        /**
         * The lowest value to assign a color.  Any given value less than this value will be made Transparent.
        */
        get: function () {
            return this.i.minimumValue;
        },
        set: function (v) {
            this.i.minimumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteColorScale.prototype, "maximumValue", {
        /**
         * The highest value to assign a color.  Any given value greater than this value will be made Transparent.
        */
        get: function () {
            return this.i.maximumValue;
        },
        set: function (v) {
            this.i.maximumValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteColorScale.prototype, "palette", {
        /**
         * A list of colors to select from or interpolate between.
        */
        get: function () {
            return fromColorCollection(this.i.palette);
        },
        set: function (v) {
            this.i.palette = toColorCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomPaletteColorScale.prototype, "interpolationMode", {
        /**
         * The approach to use when getting a color from the palette.
        */
        get: function () {
            return this.i.interpolationMode;
        },
        set: function (v) {
            this.i.interpolationMode = ensureEnum(ColorScaleInterpolationMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgrCustomPaletteColorScale.prototype.providePalette = function (colors) {
        this.i.providePalette(colors);
    };
    return IgrCustomPaletteColorScale;
}(IgrColorScale));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCustomPaletteColorScaleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCustomPaletteColorScaleModule() {
    }
    IgrCustomPaletteColorScaleModule.register = function () {
        TypeRegistrar.registerCons("IgrCustomPaletteColorScale", IgrCustomPaletteColorScale);
        TypeRegistrar.register("CustomPaletteColorScale", CustomPaletteColorScale.$type);
    };
    return IgrCustomPaletteColorScaleModule;
}());

/**
 * Base class for series which triangulate XY data prior to rendering.
*/
var IgrScatterTriangulationSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterTriangulationSeries, _super);
    function IgrScatterTriangulationSeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        _this._triangulationStatusChanged = null;
        _this._triangulationStatusChanged_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "xMemberPath", {
        /**
         * The name of the property from which to extract the X-coordinate for each item in the ItemsSource.
        */
        get: function () {
            return this.i.my;
        },
        set: function (v) {
            this.i.my = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "yMemberPath", {
        /**
         * The name of the property from which to extract the Y-coordinate for each item in the ItemsSource.
        */
        get: function () {
            return this.i.m2;
        },
        set: function (v) {
            this.i.m2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "xAxis", {
        /**
         * The X-Axis for this series.
        */
        get: function () {
            if (this.i.l0 == null) {
                return null;
            }
            if (!this.i.l0.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.l0);
                if (e) {
                    e._implementation = this.i.l0;
                }
                this.i.l0.externalObject = e;
            }
            return this.i.l0.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l0 = null : this.i.l0 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "yAxis", {
        /**
         * The Y-Axis for this series.
        */
        get: function () {
            if (this.i.l1 == null) {
                return null;
            }
            if (!this.i.l1.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.l1);
                if (e) {
                    e._implementation = this.i.l1;
                }
                this.i.l1.externalObject = e;
            }
            return this.i.l1.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l1 = null : this.i.l1 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "trianglesSource", {
        /**
         * The source of triangulation data.
         * This property is optional.  If it is left as null, the triangulation will be created based on the items in the ItemsSource.  Triangulation is a demanding operation, so the runtime performance will be better when specifying a TriangulationSource, especially when a large number of data items are present.
        */
        get: function () {
            return this.i.trianglesSource;
        },
        set: function (v) {
            this.i.trianglesSource = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "triangleVertexMemberPath1", {
        /**
         * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the first vertex point in the ItemsSource.
        */
        get: function () {
            return this.i.mq;
        },
        set: function (v) {
            this.i.mq = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "triangleVertexMemberPath2", {
        /**
         * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the second vertex point in the ItemsSource.
        */
        get: function () {
            return this.i.ms;
        },
        set: function (v) {
            this.i.ms = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "triangleVertexMemberPath3", {
        /**
         * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the third vertex point in the ItemsSource.
        */
        get: function () {
            return this.i.mu;
        },
        set: function (v) {
            this.i.mu = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "isShape", {
        /**
         * Gets whether or not this series is a shape series
        */
        get: function () {
            return this.i.c5;
        },
        enumerable: true,
        configurable: true
    });
    IgrScatterTriangulationSeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrScatterTriangulationSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrScatterTriangulationSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrScatterTriangulationSeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.mi(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrScatterTriangulationSeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.mh(axis);
        return (iv);
    };
    Object.defineProperty(IgrScatterTriangulationSeries.prototype, "triangulationStatusChanged", {
        /**
         * Raised when the status of an ongoing Triangulation has changed.
        */
        get: function () {
            return this._triangulationStatusChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._triangulationStatusChanged_wrapped !== null) {
                this.i.triangulationStatusChanged = delegateRemove(this.i.triangulationStatusChanged, this._triangulationStatusChanged_wrapped);
                this._triangulationStatusChanged_wrapped = null;
                this._triangulationStatusChanged = null;
            }
            this._triangulationStatusChanged = ev;
            this._triangulationStatusChanged_wrapped = function (o, e) {
                var outerArgs = new IgrTriangulationStatusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeTriangulationStatusChanged) {
                    _this.beforeTriangulationStatusChanged(_this, outerArgs);
                }
                if (_this._triangulationStatusChanged) {
                    _this._triangulationStatusChanged(_this, outerArgs);
                }
            };
            this.i.triangulationStatusChanged = delegateCombine(this.i.triangulationStatusChanged, this._triangulationStatusChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterTriangulationSeries;
}(IgrSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterTriangulationSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterTriangulationSeries, _super);
    function ScatterTriangulationSeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.l7 = null;
        _this.l8 = null;
        _this.mg = false;
        _this.l3 = null;
        _this.triangulationStatusChanged = null;
        _this.mj = null;
        _this.l4 = null;
        _this.l5 = null;
        _this.l6 = null;
        return _this;
    }
    ScatterTriangulationSeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.l0 = null;
        this.l1 = null;
    };
    ScatterTriangulationSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == ScatterTriangulationSeries.$$p[6]) {
            return this.ft(a, b, this.my);
        }
        if (c == ScatterTriangulationSeries.$$p[8]) {
            return this.ft(a, b, this.m2);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(ScatterTriangulationSeries.prototype, "md", {
        get: function () {
            return this.l7;
        },
        set: function (a) {
            var b = this.md != a;
            if (b) {
                var c = this.md;
                this.l7 = a;
                this.raisePropertyChanged("XColumn", c, this.md);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "me", {
        get: function () {
            return this.l8;
        },
        set: function (a) {
            var b = this.me != a;
            if (b) {
                var c = this.me;
                this.l8 = a;
                this.raisePropertyChanged("YColumn", c, this.me);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterTriangulationSeries.prototype.je = function (a) {
        var b = this.bz != null && this.mf == null && this.mj == null && this.md != null && this.me != null && this.md.count >= 3 && this.me.count >= 3 && !this.mg;
        if (b) {
            this.m6();
            this.mg = true;
        }
    };
    ScatterTriangulationSeries.prototype.m6 = function () {
        this.l3 = new Triangulator(this.bz.count, this.md, this.me);
        var a = this.l3;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.m7));
        this.l3.y();
    };
    ScatterTriangulationSeries.prototype.m4 = function () {
        if (this.l3 == null) {
            return;
        }
        this.l3.r();
        var a = this.l3;
        a.triangulationStatusChanged = delegateRemove(a.triangulationStatusChanged, runOn(this, this.m7));
        this.l3 = null;
    };
    ScatterTriangulationSeries.prototype.m7 = function (a, b) {
        var _this = this;
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(b.currentStatus));
        }
        if (b.currentStatus >= 100) {
            if (this.l3 == null) {
                return;
            }
            var c = this.l3;
            c.triangulationStatusChanged = delegateRemove(c.triangulationStatusChanged, runOn(this, this.m7));
            this.mj = this.l3.n();
            this.l3 = null;
            var d = ((function () {
                var $ret = new FastItemsSource();
                $ret.e = _this.mj;
                return $ret;
            })());
            this.ma = this.l9(d, "v1");
            this.mb = this.l9(d, "v2");
            this.mc = this.l9(d, "v3");
            this.jd(false);
        }
    };
    ScatterTriangulationSeries.prototype.l9 = function (a, b) {
        if (b == null) {
            return a.registerColumnInt(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.bb(b, this.coercionMethods);
        c = d.a;
        return a.registerColumnInt(b, c, this.expectFunctions);
    };
    ScatterTriangulationSeries.prototype.iz = function (a, b, c, d) {
        var _this = this;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.md);
                    e.deregisterColumn(this.me);
                    this.md = null;
                    this.me = null;
                }
                this.m5();
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.md = this.bw(this.my);
                    this.me = this.bw(this.m2);
                }
                this.jd(false);
                break;
            case ScatterTriangulationSeries.$$p[6]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.md);
                    this.md = this.bw(this.my);
                }
                this.m5();
                this.jd(false);
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.me);
                    this.me = this.bw(this.m2);
                }
                this.m5();
                this.jd(false);
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[5]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bv(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).ci(this);
                }
                if ((this.l0 != null && !this.l0.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[7]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bv(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).ci(this);
                }
                if ((this.l1 != null && !this.l1.cl()) || (d == null && c != null)) {
                    this.jd(false);
                }
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[1]:
                if (this.trianglesSource != null) {
                    this.m4();
                    this.mf = ((function () {
                        var $ret = new FastItemsSource();
                        $ret.e = _this.trianglesSource;
                        return $ret;
                    })());
                }
                else {
                    this.mf = null;
                }
                break;
            case ScatterTriangulationSeries.$$p[0]:
                var g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.ma);
                    g.deregisterColumn(this.mb);
                    g.deregisterColumn(this.mc);
                    this.ma = null;
                    this.mb = null;
                    this.mc = null;
                }
                var h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.ma = this.l9(h, this.mq);
                    this.mb = this.l9(h, this.ms);
                    this.mc = this.l9(h, this.mu);
                }
                this.jd(false);
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[2]:
                if (this.mf != null) {
                    this.mf.deregisterColumn(this.ma);
                    this.ma = this.l9(this.mf, this.mq);
                }
                this.jd(false);
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[3]:
                if (this.mf != null) {
                    this.mf.deregisterColumn(this.mb);
                    this.mb = this.l9(this.mf, this.ms);
                }
                this.jd(false);
                this.ik();
                break;
            case ScatterTriangulationSeries.$$p[4]:
                if (this.mf != null) {
                    this.mf.deregisterColumn(this.mc);
                    this.mc = this.l9(this.mf, this.mu);
                }
                this.jd(false);
                this.ik();
                break;
            case "XColumn":
                if (this.l0 != null) {
                    this.l0.cl();
                }
                break;
            case "YColumn":
                if (this.l1 != null) {
                    this.l1.cl();
                }
                break;
        }
    };
    ScatterTriangulationSeries.prototype.mi = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterTriangulationSeries.prototype.mh = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ScatterTriangulationSeries.prototype.dw = function (a, b, c) {
        return _super.prototype.dw.call(this, a, b, c) && this.bz != null && this.l0 != null && this.l1 != null && this.l0.bf != null && this.l1.bf != null && a.width > 0 && a.height > 0 && this.ma != null && this.ma.count > 0 && this.mb != null && this.mb.count > 0 && this.mc != null && this.mc.count > 0 && this.md != null && this.md.count > 0 && this.me != null && this.me.count > 0;
    };
    ScatterTriangulationSeries.prototype.m5 = function () {
        if (this.trianglesSource == null) {
            this.mj = null;
            this.ma = null;
            this.mb = null;
            this.mc = null;
            this.mg = false;
        }
    };
    ScatterTriangulationSeries.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.l0 != null) {
            this.l0.g5();
        }
        if (this.l1 != null) {
            this.l1.g5();
        }
    };
    ScatterTriangulationSeries.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        this.m5();
        this.jd(false);
    };
    ScatterTriangulationSeries.prototype.an = function (a) {
        if (a != null && a == this.l0 && this.md != null) {
            return new AxisRange(this.md.minimum, this.md.maximum);
        }
        if (a != null && a == this.l1 && this.me != null) {
            return new AxisRange(this.me.minimum, this.me.maximum);
        }
        return null;
    };
    ScatterTriangulationSeries.prototype.jt = function (a, b) {
        this.jd(false);
    };
    ScatterTriangulationSeries.prototype.js = function (a, b) {
        this.jd(false);
    };
    Object.defineProperty(ScatterTriangulationSeries.prototype, "ma", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            var b = this.ma != a;
            if (b) {
                var c = this.ma;
                this.l4 = a;
                this.raisePropertyChanged("TriangleVertexColumn1", c, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "mb", {
        get: function () {
            return this.l5;
        },
        set: function (a) {
            var b = this.mb != a;
            if (b) {
                var c = this.mb;
                this.l5 = a;
                this.raisePropertyChanged("TriangleVertexColumn2", c, this.mb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScatterTriangulationSeries.prototype, "mc", {
        get: function () {
            return this.l6;
        },
        set: function (a) {
            var b = this.mc != a;
            if (b) {
                var c = this.mc;
                this.l6 = a;
                this.raisePropertyChanged("TriangleVertexColumn3", c, this.mc);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterTriangulationSeries.prototype.get_c5 = function () {
        return true;
    };
    ScatterTriangulationSeries.$t = markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
    ScatterTriangulationSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:mf:m8', [IFastItemsSource_$type, null], 'TrianglesSource::m9', [IEnumerable_$type, null], 'TriangleVertexMemberPath1:mq:na', [2, null], 'TriangleVertexMemberPath2:ms:nb', [2, null], 'TriangleVertexMemberPath3:mu:nc', [2, null], 'XAxis:l0:nd', [NumericXAxis.$, null], 'XMemberPath:my:ne', [2, null], 'YAxis:l1:nf', [NumericYAxis.$, null], 'YMemberPath:m2:ng', [2, null]]);
    return ScatterTriangulationSeries;
}(Series));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TriangleRasterizer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TriangleRasterizer, _super);
    function TriangleRasterizer(a, b, c, d, e, f, g) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.k = 0;
        _this.j = 0;
        _this.g = 0;
        _this.f = 0;
        _this.b = null;
        _this.d = null;
        if (a == null || b == null || e == null) {
            throw new BaseError(0);
        }
        _this.a = a;
        _this.c = b;
        _this.e = e;
        _this.m = f;
        _this.l = g;
        _this.g = c;
        _this.f = d;
        return _this;
    }
    Object.defineProperty(TriangleRasterizer.prototype, "m", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            this.k = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TriangleRasterizer.prototype, "l", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TriangleRasterizer.prototype, "i", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TriangleRasterizer.prototype, "h", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TriangleRasterizer.prototype, "c", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TriangleRasterizer.prototype, "e", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    TriangleRasterizer.prototype.p = function (a, b, c, d, e, f, g, h) {
        var i = this.k;
        var j = this.j;
        var k;
        var l;
        if (d.y > e.y) {
            k = d;
            d = e;
            e = k;
            l = g;
            g = h;
            h = l;
        }
        if (c.y > e.y) {
            k = c;
            c = e;
            e = k;
            l = f;
            f = h;
            h = l;
        }
        if (c.y > d.y) {
            k = c;
            c = d;
            d = k;
            l = f;
            f = g;
            g = l;
        }
        var m = truncate(Math.round(c.y));
        var n = truncate(Math.round(d.y));
        var o = truncate(Math.round(e.y));
        if (o == m) {
            return;
        }
        if (isNaN_(f) || isNaN_(g) || isNaN_(h)) {
            return;
        }
        var p = (d.x - c.x) * (e.y - c.y) - (e.x - c.x) * (d.y - c.y) >= 0;
        var q = Math.max(0, m);
        var r = Math.min(j - 1, n);
        for (var s = q; s < r; ++s) {
            var t = (s - m) / (n - m);
            var u = c.x + t * (d.x - c.x);
            var v = f + t * (g - f);
            var w = (s - m) / (o - m);
            var x = c.x + w * (e.x - c.x);
            var y = f + w * (h - f);
            if (p) {
                this.o(a, b, s, truncate(Math.floor(x)), truncate(Math.ceil(u)), y, v);
            }
            else {
                this.o(a, b, s, truncate(Math.floor(u)), truncate(Math.ceil(x)), v, y);
            }
        }
        {
            var z = Math.min(j - 1, Math.max(0, n));
            var aa = Math.min(j - 1, o);
            var ab = 0;
            var ac = d.x + ab * (e.x - d.x);
            var ad = g + ab * (h - g);
            var ae = z;
            var af = (o - m);
            var ag = (ae - m) / af;
            var ah = c.x + ag * (e.x - c.x);
            var ai = f + ag * (h - f);
            do {
                if (p) {
                    this.o(a, b, ae, truncate(Math.floor(ah)), truncate(Math.ceil(ac)), ai, ad);
                }
                else {
                    this.o(a, b, ae, truncate(Math.floor(ac)), truncate(Math.ceil(ah)), ad, ai);
                }
                ++ae;
                ab = (ae - n) / (o - n);
                ac = d.x + ab * (e.x - d.x);
                ad = g + ab * (h - g);
                ag = (ae - m) / af;
                ah = c.x + ag * (e.x - c.x);
                ai = f + ag * (h - f);
            } while (ae < aa);
        }
    };
    TriangleRasterizer.prototype.o = function (a, b, c, d, e, f, g) {
        var h = this.k;
        var i = d > 0 ? d : 0;
        var j = e < h - 1 ? e : h - 1;
        var k = c * h * 4 + (i * 4);
        var l = g - f;
        var m = 1 / (e - d);
        var n = this.d;
        var o = this.g;
        var p = this.f;
        var q = c * h;
        for (var r = i; r <= j; r++) {
            var s = f + l * (r - d) * m;
            var color_ = this.b.getColor(s, o, p, n);
            this.a[k] = (color_._r);
            this.a[k + 1] = (color_._g);
            this.a[k + 2] = (color_._b);
            this.a[k + 3] = (color_._a);
            b[q + r] = a + 1;
            k += 4;
        }
    };
    TriangleRasterizer.prototype.n = function () {
    };
    TriangleRasterizer.$t = markType(TriangleRasterizer, 'TriangleRasterizer');
    return TriangleRasterizer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterAreaSeries, _super);
    function ScatterAreaSeries() {
        var _this = _super.call(this) || this;
        _this.nk = null;
        _this.np = null;
        _this.ni = null;
        _this.nj = null;
        _this.nh = [Color.u(255, 0, 0, 255), Color.u(255, 0, 255, 0), Color.u(255, 255, 0, 0)];
        FastItemIntColumn.m();
        _this.ab = ScatterAreaSeries.$;
        return _this;
    }
    Object.defineProperty(ScatterAreaSeries.prototype, "nl", {
        get: function () {
            return this.nk;
        },
        set: function (a) {
            var b = this.nk != a;
            if (b) {
                var c = this.nk;
                if (this.nk != null) {
                    var d = this.nk;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.ny));
                }
                this.nk = a;
                if (this.nk != null) {
                    var e = this.nk;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.ny));
                }
                this.raisePropertyChanged("ColorScale", c, this.nk);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterAreaSeries.prototype.ny = function (a, b) {
        this.jd(false);
    };
    ScatterAreaSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == ScatterAreaSeries.$$p[0]) {
            return this.ft(a, b, this.nt);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    Object.defineProperty(ScatterAreaSeries.prototype, "nq", {
        get: function () {
            return this.np;
        },
        set: function (a) {
            var b = this.nq != a;
            if (b) {
                var c = this.nq;
                this.np = a;
                this.raisePropertyChanged("ColorColumn", c, this.nq);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterAreaSeries.prototype.get_dq = function () {
        return true;
    };
    ScatterAreaSeries.prototype.set_dq = function (a) {
        _super.prototype.set_dq.call(this, a);
    };
    ScatterAreaSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.nq);
                    this.nq = null;
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.nq = this.bw(this.nt);
                }
                this.jd(false);
                break;
            case ScatterAreaSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nq);
                    this.nq = this.bw(this.nt);
                }
                this.jd(false);
                this.ik();
                break;
            case "ColorScale":
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterAreaSeries.prototype.je = function (a) {
        _super.prototype.je.call(this, a);
        this.nz(this.bi);
    };
    ScatterAreaSeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.nz(f);
    };
    ScatterAreaSeries.prototype.nz = function (a) {
        if (this.cc(a)) {
            return;
        }
        var b;
        var c;
        var d = a.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        var e = a;
        var f = null;
        var g = null;
        var h = this.l0;
        var i = this.l1;
        var j = this.getEffectiveViewport1(a);
        var k = new ScalerParams(1, b, c, h.b8);
        k.c = j;
        var l = new ScalerParams(1, b, c, i.b8);
        l.c = j;
        g = this.no(a, k, l);
        if (g != null) {
            e.b5(g);
        }
        else {
            e.b8(f);
        }
    };
    ScatterAreaSeries.prototype.nw = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        var e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
        var f = a.bx;
        if (f == null || f.length != e) {
            f = new Array(e);
            for (var g = 0; g < e; g++) {
                f[g] = 0;
            }
        }
        else {
            for (var h = 0; h < e; h++) {
                f[h] = 0;
            }
        }
        a.bx = f;
    };
    ScatterAreaSeries.prototype.fp = function (a) {
        var b = truncate(Math.round(this.ly.width));
        var c = truncate(Math.round(this.ly.height));
        var d = this.bi.bx;
        if (d == null || d.length != (b * c) || this.ma == null || this.ma.count < 1 || this.mb == null || this.mb.count < 1 || this.mc == null || this.mc.count < 1) {
            return null;
        }
        var e = this.bs.m4;
        var f = (a.x - e.left) / e.width;
        var g = (a.y - e.top) / e.height;
        var h = truncate(Math.round(b * f));
        var i = truncate(Math.round(c * g));
        var j = (b * i) + h;
        if (j < 0 || j > d.length - 1) {
            return null;
        }
        var k = d[j] - 1;
        if (k < 0 || k > this.ma.count) {
            return null;
        }
        var l = this.ni.length;
        var m = this.ma.item(k);
        var n = this.mb.item(k);
        var o = this.mc.item(k);
        if ((m >= l) || (n >= l) || (o >= l)) {
            return null;
        }
        var p = (this.ni[m] - this.ly.left) / this.ly.width;
        var q = (this.nj[m] - this.ly.top) / this.ly.height;
        var r = (this.ni[n] - this.ly.left) / this.ly.width;
        var s = (this.nj[n] - this.ly.top) / this.ly.height;
        var t = (this.ni[o] - this.ly.left) / this.ly.width;
        var u = (this.nj[o] - this.ly.top) / this.ly.height;
        var v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
        var w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
        var x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
        if (v < w && v < x) {
            return this.bz.item(m);
        }
        if (w < v && w < x) {
            return this.bz.item(n);
        }
        if (x < v && x < w) {
            return this.bz.item(o);
        }
        return this.bz.item(m);
    };
    ScatterAreaSeries.prototype.no = function (a, b, c) {
        var d;
        var e;
        var f = a.getViewInfo(e, d);
        e = f.p0;
        d = f.p1;
        e = new Rect(0, 0, 0, e.width, e.height);
        b = new ScalerParams(0, b.e, e, b.a, b.c);
        c = new ScalerParams(0, c.e, e, c.a, c.c);
        c.b = this.eh();
        var g = a;
        var h = this.l0;
        var i = this.l1;
        var j = this.ma.count;
        var k;
        var xArr_ = this.md.asArray();
        k = (xArr_.slice(0));
        var l;
        var yArr_ = this.me.asArray();
        l = (yArr_.slice(0));
        var m = this.nq.asArray();
        var n = this.ma.asArray();
        var o = this.mb.asArray();
        var p = this.mc.asArray();
        this.ni = k;
        this.nj = l;
        h.gn(boxArray$1(k), 0, k.length, b);
        i.gn(boxArray$1(l), 0, l.length, c);
        var q = this.nm();
        var r = g.bz(b.d, q, this.nq);
        var s = e.top;
        var t = e.left;
        var u = e.right;
        var v = e.bottom;
        var w;
        var x;
        var y;
        var z;
        this.nw(g);
        var aa = g.bx;
        var ab = k.length;
        for (var ac = 0; ac < j; ac++) {
            var ad = n[ac];
            var ae = o[ac];
            var af = p[ac];
            if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                continue;
            }
            var ag = k[ad];
            var ah = l[ad];
            var ai = { $type: Point_$type, x: ag, y: ah };
            var aj = k[ae];
            var ak = l[ae];
            var al = { $type: Point_$type, x: aj, y: ak };
            var am = k[af];
            var an = l[af];
            var ao = { $type: Point_$type, x: am, y: an };
            w = al.y < ao.y ? al.y : ao.y;
            w = ai.y < w ? ai.y : w;
            x = al.y > ao.y ? al.y : ao.y;
            x = ai.y > x ? ai.y : x;
            y = al.x < ao.x ? al.x : ao.x;
            y = ai.x < y ? ai.x : y;
            z = al.x > ao.x ? al.x : ao.x;
            z = ai.x > z ? ai.x : z;
            if (w < v && x > s && y < u && z > t) {
                var ap = m[ad];
                var aq = m[ae];
                var ar = m[af];
                r.p(ac, aa, ai, al, ao, ap, aq, ar);
            }
        }
        return r;
    };
    ScatterAreaSeries.prototype.nr = function () {
        var a = new Color();
        var b = this.k3;
        if (b == null) {
            a = this.nh[this.fh % this.nh.length];
        }
        else {
            a = ColorUtil.j(b);
        }
        var c = new ObservableColorCollection();
        c.add(ColorUtil.o(a, -0.5));
        c.add(a);
        return c;
    };
    ScatterAreaSeries.prototype.nm = function () {
        var _this = this;
        var a = this.nl;
        if (a == null) {
            a = ((function () {
                var $ret = new CustomPaletteColorScale();
                $ret.palette = _this.nr();
                $ret.interpolationMode = 2;
                return $ret;
            })());
        }
        else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
            var b = a;
            if (b.palette == null || b.palette.count == 0) {
                b.palette = this.nr();
            }
            a = b;
        }
        return a;
    };
    ScatterAreaSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.b4();
    };
    ScatterAreaSeries.prototype.bf = function () {
        return new ScatterAreaSeriesView(this);
    };
    ScatterAreaSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.nn = typeCast(ScatterAreaSeriesView.$, a);
    };
    ScatterAreaSeries.prototype.nx = function (a) {
        if (this.nn != null) {
            this.nn.b3(a);
        }
    };
    ScatterAreaSeries.$t = markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ColorMemberPath:nt:n0', [2, null]]);
    return ScatterAreaSeries;
}(ScatterTriangulationSeries));
/**
 * @hidden
 */
var ScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterAreaSeriesView, _super);
    function ScatterAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.by = null;
        _this.bu = null;
        _this.b2 = null;
        _this.b1 = null;
        _this.b0 = null;
        _this.by = a;
        return _this;
    }
    Object.defineProperty(ScatterAreaSeriesView.prototype, "bx", {
        get: function () {
            return this.bu;
        },
        set: function (a) {
            this.bu = a;
        },
        enumerable: true,
        configurable: true
    });
    ScatterAreaSeriesView.prototype.b7 = function (a, b) {
    };
    ScatterAreaSeriesView.prototype.b3 = function (a) {
    };
    ScatterAreaSeriesView.prototype.bv = function () {
        return this.bw(true);
    };
    ScatterAreaSeriesView.prototype.bw = function (a) {
        this.b6();
        var b = truncate(Math.round(this.br.left));
        var c = truncate(Math.round(this.br.left));
        var d = truncate(Math.round(this.br.width));
        var e = truncate(Math.round(this.br.height));
        var f = d.toString();
        var g = e.toString();
        if (this.b1.getAttribute("width") != f) {
            this.b1.setAttribute("width", d.toString());
        }
        if (this.b1.getAttribute("height") != g) {
            this.b1.setAttribute("height", e.toString());
        }
        var h = this.b0.g();
        if (a) {
            h.clearRect(0, 0, d, e);
        }
        this.b2 = h.getImageData(0, 0, d, e);
        var imageDataArray_ = this.b2.data;
        return imageDataArray_;
    };
    ScatterAreaSeriesView.prototype.b6 = function () {
        if (this.b1 == null) {
            this.b1 = this.e.e4.createElement("canvas");
            var a = this.e.e4.get2DCanvasContext(this.b1);
            this.b0 = new RenderingContext(new CanvasViewRenderer(), a);
        }
    };
    ScatterAreaSeriesView.prototype.bz = function (a, b, c) {
        var d = truncate(Math.round(this.br.left));
        var e = truncate(Math.round(this.br.left));
        var f = truncate(Math.round(this.br.width));
        var g = truncate(Math.round(this.br.height));
        return new TriangleRasterizer(this.bv(), b, c.minimum, c.maximum, c, f, g);
    };
    ScatterAreaSeriesView.prototype.b5 = function (a) {
        this.b8(null);
    };
    ScatterAreaSeriesView.prototype.b4 = function () {
        if (this.b0 != null) {
            this.b0.k(this.br.left, this.br.top, this.br.width, this.br.height);
        }
        this.an();
    };
    ScatterAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (this.b1 == null) {
            return;
        }
        if (b) {
            var c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
        }
        else {
            var d = truncate(Math.round(this.br.left));
            var e = truncate(Math.round(this.br.top));
            var f = truncate(Math.round(this.br.width));
            var g = truncate(Math.round(this.br.height));
            a.m(this.b1.getNativeElement(), 1, d, e, f, g);
        }
    };
    ScatterAreaSeriesView.prototype.b8 = function (a) {
        var b = truncate(Math.round(this.br.left));
        var c = truncate(Math.round(this.br.left));
        var d = truncate(Math.round(this.br.width));
        var e = truncate(Math.round(this.br.height));
        this.b6();
        this.b0.g().putImageData(this.b2, 0, 0);
        this.an();
    };
    ScatterAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        var b = truncate(Math.round(this.br.width));
        var c = truncate(Math.round(this.br.height));
        var d = this.bw(false);
        if (d == null || d.length == 0) {
            this.e.a2.exportSeriesPixelsData(a, null, b, c);
            return;
        }
        var e = new Array(intDivide(d.length, 4));
        var f;
        for (var g = 0; g < intDivide(d.length, 4); g++) {
            f = g * 4;
            e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, e, b, c);
    };
    ScatterAreaSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.by.fx + "</span><br/><span>" + "(${item." + this.by.my + "}, ${item." + this.by.m2 + "})</span>";
        if (!stringIsNullOrEmpty(this.by.nt)) {
            a += "<span>, Value: ${item." + this.by.nt + "}</span>";
        }
        a += "</div>";
        return a;
    };
    ScatterAreaSeriesView.$t = markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Series class which draws a colored 2D surface based on a triangulation of XY data with numeric values assigned to each point.
*/
var IgrScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterAreaSeries, _super);
    function IgrScatterAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterAreaSeries.prototype.createImplementation = function () {
        return new ScatterAreaSeries();
    };
    Object.defineProperty(IgrScatterAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterAreaSeries.prototype, "colorScale", {
        /**
         * Gets or sets ColorScale used to resolve the color values of points in the series.
        */
        get: function () {
            if (this.i.nl == null) {
                return null;
            }
            if (!this.i.nl.externalObject) {
                var e = IgrColorScale._createFromInternal(this.i.nl);
                if (e) {
                    e._implementation = this.i.nl;
                }
                this.i.nl.externalObject = e;
            }
            return this.i.nl.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.nl = null : this.i.nl = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterAreaSeries.prototype, "colorMemberPath", {
        /**
         * Gets or sets the name of the property on each data item containing a numeric value which can be converted to a color by the ColorScale.
        */
        get: function () {
            return this.i.nt;
        },
        set: function (v) {
            this.i.nt = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrScatterAreaSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.colorScale && this.colorScale._styling) {
            this.colorScale._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrScatterAreaSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrScatterAreaSeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Attaches an image to the view of this series
    
    */
    IgrScatterAreaSeries.prototype.attachImage = function (image) {
        this.i.nx(image);
    };
    return IgrScatterAreaSeries;
}(IgrScatterTriangulationSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterAreaSeriesModule() {
    }
    IgrScatterAreaSeriesModule.register = function () {
        IgrCustomPaletteColorScaleModule.register();
        TypeRegistrar.registerCons("IgrScatterAreaSeries", IgrScatterAreaSeries);
        TypeRegistrar.register("ScatterAreaSeries", ScatterAreaSeries.$type);
    };
    return IgrScatterAreaSeriesModule;
}());

/**
 * Class used to determine the numeric values of contour lines, given a larger list of numeric values.
*/
var IgrContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrContourValueResolver, _super);
    function IgrContourValueResolver(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrContourValueResolver.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrContourValueResolver.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrContourValueResolver._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrContourValueResolver.prototype.onImplementationCreated = function () {
    };
    IgrContourValueResolver.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrContourValueResolver.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrContourValueResolver.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrContourValueResolver.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrContourValueResolver.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrContourValueResolver.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ContourValueResolver");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    return IgrContourValueResolver;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContourValueResolver, _super);
    function ContourValueResolver() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.updated = null;
        return _this;
    }
    ContourValueResolver.prototype.l = function (a, b, c) {
        if (this.updated != null) {
            this.updated(this, EventArgs.empty);
        }
    };
    ContourValueResolver.$t = markType(ContourValueResolver, 'ContourValueResolver', DependencyObject.$);
    return ContourValueResolver;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var LinearContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LinearContourValueResolver, _super);
    function LinearContourValueResolver() {
        return _super.call(this) || this;
    }
    LinearContourValueResolver.prototype._j = function (a) {
        var b;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    b = 0;
                    _a.label = 1;
                case 1:
                    if (!(b < this.valueCount))
                        return [3 /*break*/, 4];
                    return [4 /*yield*/, a.minimum + (a.maximum - a.minimum) * (b + 1) / (this.valueCount + 1)];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3:
                    b++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    };
    LinearContourValueResolver.prototype.j = function (a) {
        var _this = this;
        return toEnum(function () { return _this._j(a); });
    };
    LinearContourValueResolver.$t = markType(LinearContourValueResolver, 'LinearContourValueResolver', ContourValueResolver.$);
    LinearContourValueResolver.$$p = markDep(DependencyProperty, PropertyMetadata, LinearContourValueResolver, 'l', ['ValueCount::o', [1, 10]]);
    return LinearContourValueResolver;
}(ContourValueResolver));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolylineBuilder = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolylineBuilder, _super);
    function PolylineBuilder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        _this.b = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        return _this;
    }
    PolylineBuilder.prototype.e = function () {
        this.a.clear();
        this.b.clear();
    };
    PolylineBuilder.prototype.c = function () {
        var e_1, _a;
        var a = new List$1(List$1.$.specialize(Number_$type), 0);
        try {
            for (var _b = __values(fromEnum(this.a.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a.add(b);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return a;
    };
    PolylineBuilder.prototype.d = function (a, b) {
        var c = null;
        var d = null;
        var e = this.b.tryGetValue(a, c);
        c = e.p1;
        var f = this.a.tryGetValue(b, d);
        d = f.p1;
        if (c == null && d == null) {
            var g = new List$1(Number_$type, 0);
            g.add(a);
            g.add(b);
            this.a.addItem(a, g);
            this.b.addItem(b, g);
        }
        if (c == null && d != null) {
            this.a.removeItem(b);
            d.insert(0, a);
            this.a.addItem(a, d);
        }
        if (c != null && d == null) {
            this.b.removeItem(a);
            c.add(b);
            this.b.addItem(b, c);
        }
        if (c != null && d != null) {
            if (c == d) {
                c.add(b);
                this.b.removeItem(a);
            }
            else {
                this.a.removeItem(d._inner[0]);
                this.b.removeItem(d._inner[d.count - 1]);
                this.b.removeItem(c._inner[c.count - 1]);
                c.o(d);
                this.b.addItem(c._inner[c.count - 1], c);
            }
        }
    };
    PolylineBuilder.$t = markType(PolylineBuilder, 'PolylineBuilder');
    return PolylineBuilder;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ContourBuilder = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContourBuilder, _super);
    function ContourBuilder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = new Dictionary$2(Number_$type, Number_$type, 0);
        _this.i = new List$1(Number_$type, 0);
        _this.j = new List$1(Number_$type, 0);
        return _this;
    }
    ContourBuilder.prototype.e = function () {
        _super.prototype.e.call(this);
        this.f.clear();
        this.i.clear();
        this.j.clear();
    };
    Object.defineProperty(ContourBuilder.prototype, "g", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ContourBuilder.prototype, "h", {
        get: function () {
            return this.j;
        },
        enumerable: true,
        configurable: true
    });
    ContourBuilder.prototype.k = function (a, b, c, d, e, f, g, h, i) {
        var _this = this;
        var j = Math.min(a, e) + 0x100000000 * Math.max(a, e);
        var k = -1;
        if (!((function () { var l = _this.f.tryGetValue(j, k); k = l.p1; return l.ret; })())) {
            k = this.i.count;
            var l = (i - d) / (h - d);
            this.f.addItem(j, k);
            this.i.add((b + l * (f - b)));
            this.j.add((c + l * (g - c)));
        }
        return k;
    };
    ContourBuilder.$t = markType(ContourBuilder, 'ContourBuilder', PolylineBuilder.$);
    return ContourBuilder;
}(PolylineBuilder));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterContourSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterContourSeries, _super);
    function ScatterContourSeries() {
        var _this = _super.call(this) || this;
        _this.nl = null;
        _this.nh = null;
        FastItemIntColumn.m();
        _this.ab = ScatterContourSeries.$;
        _this.ni = new LinearContourValueResolver();
        return _this;
    }
    ScatterContourSeries.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == ScatterContourSeries.$$p[1]) {
            return this.ft(a, b, this.np);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    ScatterContourSeries.prototype.bf = function () {
        this.nj = new ScatterContourSeriesView(this);
        return this.nj;
    };
    Object.defineProperty(ScatterContourSeries.prototype, "nm", {
        get: function () {
            return this.nl;
        },
        set: function (a) {
            var b = this.nm != a;
            if (b) {
                var c = this.nm;
                this.nl = a;
                this.raisePropertyChanged("ValueColumn", c, this.nm);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterContourSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.nm);
                    this.nm = null;
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.nm = this.bw(this.np);
                }
                this.jd(false);
                break;
            case ScatterContourSeries.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nm);
                    this.nm = this.bw(this.np);
                }
                this.jd(false);
                this.ik();
                break;
            case "ValueResolver":
                this.jd(false);
                this.ik();
                break;
            case ScatterContourSeries.$$p[0]:
                var g = c;
                var h = d;
                if (g != null) {
                    g.unregisterSeries(this);
                }
                if (h != null) {
                    h.registerSeries(this);
                }
                this.jd(false);
                this.ik();
                break;
            case "ActualBrush":
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterContourSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        if (a) {
            b.b0(a);
        }
    };
    ScatterContourSeries.prototype.je = function (a) {
        _super.prototype.je.call(this, a);
        this.ns(this.bi);
    };
    ScatterContourSeries.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.ns(f);
    };
    ScatterContourSeries.prototype.ns = function (a) {
        var e_1, _a;
        if (this.cc(a)) {
            return;
        }
        var b;
        var c;
        var d = a;
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        var f = new ScalerParams(1, b, c, this.l0.b8);
        f.c = this.getEffectiveViewport1(a);
        var g = new ScalerParams(1, b, c, this.l1.b8);
        g.c = this.getEffectiveViewport1(a);
        var h = this.l0;
        var i = this.l1;
        var j = this.ma.count;
        var k;
        var xArr_ = this.md.asArray();
        k = (xArr_.slice(0));
        var l;
        var yArr_ = this.me.asArray();
        l = (yArr_.slice(0));
        var m = this.nm.asArray();
        var n = this.ma.asArray();
        var o = this.mb.asArray();
        var p = this.mc.asArray();
        var q = this.ni.j(this.nm);
        var r = new List$1(Number_$type, 1, q).toArray();
        h.gn(boxArray$1(k), 0, k.length, f);
        i.gn(boxArray$1(l), 0, l.length, g);
        var s = r.length;
        var t = new Array(s);
        for (var u = 0; u < s; ++u) {
            t[u] = new ContourBuilder();
        }
        var v = c.top;
        var w = c.left;
        var x = c.right;
        var y = c.bottom;
        var z;
        var aa;
        var ab;
        var ac;
        var ad = k.length;
        for (var ae = 0; ae < j; ae++) {
            var af = n[ae];
            var ag = o[ae];
            var ah = p[ae];
            if ((af >= ad) || (ag >= ad) || (ah >= ad) || (af < 0) || (ag < 0) || (ah < 0)) {
                continue;
            }
            var ai = k[af];
            var aj = l[af];
            var ak = { $type: Point_$type, x: ai, y: aj };
            var al = k[ag];
            var am = l[ag];
            var an = { $type: Point_$type, x: al, y: am };
            var ao = k[ah];
            var ap = l[ah];
            var aq = { $type: Point_$type, x: ao, y: ap };
            z = an.y < aq.y ? an.y : aq.y;
            z = ak.y < z ? ak.y : z;
            aa = an.y > aq.y ? an.y : aq.y;
            aa = ak.y > aa ? ak.y : aa;
            ab = an.x < aq.x ? an.x : aq.x;
            ab = ak.x < ab ? ak.x : ab;
            ac = an.x > aq.x ? an.x : aq.x;
            ac = ak.x > ac ? ak.x : ac;
            if (z < y && aa > v && ab < x && ac > w) {
                var ar = m[af];
                var as = m[ag];
                var at = m[ah];
                if (isNaN_(ar) || isNaN_(as) || isNaN_(at)) {
                    continue;
                }
                for (var au = 0; au < s; au++) {
                    var av = r[au];
                    var aw = t[au];
                    switch ((ar < av ? 1 : 0) | (as < av ? 2 : 0) | (at < av ? 4 : 0)) {
                        case 0: break;
                        case 1:
                            aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                            break;
                        case 2:
                            aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                            break;
                        case 3:
                            aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                            break;
                        case 4:
                            aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                            break;
                        case 5:
                            aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                            break;
                        case 6:
                            aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                            break;
                        case 7: break;
                    }
                }
            }
        }
        var ax = new Clipper(0, RectUtil.r(c, 2), false);
        var ay = new List$1(List$1.$.specialize(List$1.$.specialize(Point_$type)), 0);
        for (var az = 0; az < s; ++az) {
            var a0 = t[az];
            var a1 = new List$1(List$1.$.specialize(Point_$type), 0);
            var a2 = a0.c();
            for (var a3 = 0; a3 < a2.count; a3++) {
                var a4 = a2._inner[a3];
                var a5 = new List$1(Point_$type, 0);
                ax.i = a5;
                try {
                    for (var _b = (e_1 = void 0, __values(fromEnum(a4))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var a6 = _c.value;
                        ax.j({ $type: Point_$type, x: a0.g.item(a6), y: a0.h.item(a6) });
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
                ax.i = null;
                a1.add(a5);
            }
            ay.add(a1);
        }
        d.bz(ay, r);
    };
    Object.defineProperty(ScatterContourSeries.prototype, "ni", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            var b = a != this.ni;
            if (b) {
                if (this.nh != null) {
                    var c = this.nh;
                    c.updated = delegateRemove(c.updated, runOn(this, this.nt));
                }
                var d = this.nh;
                this.nh = a;
                if (this.nh != null) {
                    var e = this.nh;
                    e.updated = delegateCombine(e.updated, runOn(this, this.nt));
                }
                this.raisePropertyChanged("ValueResolver", d, a);
                this.jd(false);
            }
        },
        enumerable: true,
        configurable: true
    });
    ScatterContourSeries.prototype.nt = function (a, b) {
        this.jd(false);
    };
    ScatterContourSeries.prototype.dw = function (a, b, c) {
        return _super.prototype.dw.call(this, a, b, c) && this.ni != null && this.md != null && this.me != null && this.ma != null && this.mb != null && this.mc != null && this.md.count > 0 && this.me.count > 0 && this.ma.count > 0 && this.mb.count > 0 && this.mc.count > 0;
    };
    ScatterContourSeries.prototype.ar = function (a, b) {
        var c = this.nj.b4(a, b);
        if (c != null) {
            return c.dataContext;
        }
        return null;
    };
    ScatterContourSeries.$t = markType(ScatterContourSeries, 'ScatterContourSeries', ScatterTriangulationSeries.$);
    ScatterContourSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterContourSeries, 'raisePropertyChanged', ['FillScale:nk:nu', [ValueBrushScale.$, null], 'ValueMemberPath:np:nv', [2, null]]);
    return ScatterContourSeries;
}(ScatterTriangulationSeries));
/**
 * @hidden
 */
var ScatterContourSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterContourSeriesView, _super);
    function ScatterContourSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bw = null;
        _this.bv = null;
        _this.by = null;
        _this.bx = new List$1(Brush.$, 0);
        _this.bu = null;
        _this.by = new List$1(Path.$, 0);
        _this.bv = a;
        _this.bw = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.b5);
            $ret.destroy = runOn(_this, _this.b3);
            $ret.activate = runOn(_this, _this.b1);
            $ret.disactivate = runOn(_this, _this.b2);
            return $ret;
        })());
        return _this;
    }
    ScatterContourSeriesView.prototype.b5 = function () {
        var _this = this;
        var a = new Path();
        a.dataContext = ((function () {
            var $ret = new DataContext();
            $ret.series = _this.e;
            return $ret;
        })());
        this.by.add(a);
        return a;
    };
    ScatterContourSeriesView.prototype.b1 = function (a) {
        a._visibility = 0;
    };
    ScatterContourSeriesView.prototype.b2 = function (a) {
        a._visibility = 1;
    };
    ScatterContourSeriesView.prototype.b3 = function (a) {
        this.by.remove(a);
    };
    ScatterContourSeriesView.prototype.bz = function (a, b) {
        var c = 0;
        this.bu = b;
        this.bx.clear();
        var d = this.bv.nk;
        if (d == null) {
            d = new ValueBrushScale();
            d.brushes.add(BrushUtil.l(this.e.k3, -0.5));
            d.brushes.add(this.e.k3);
        }
        else if (d.brushes == null) {
            d.brushes = new BrushCollection();
            d.brushes.add(BrushUtil.l(this.e.k3, -0.5));
            d.brushes.add(this.e.k3);
        }
        else if (d.brushes.count == 0) {
            d.brushes.add(BrushUtil.l(this.e.k3, -0.5));
            d.brushes.add(this.e.k3);
        }
        for (var e = 0; e < b.length; e++) {
            var f = b[e];
            var g = a._inner[c];
            var h = new PathGeometry();
            var _loop_1 = function (i) {
                var j = g._inner[i];
                if (j.count == 0) {
                    return "continue";
                }
                var k = PointCollectionUtil.f(j);
                var l = ((function () {
                    var $ret = new PathFigure();
                    $ret.isClosed = false;
                    $ret.isFilled = false;
                    $ret.startPoint = k._inner[0];
                    return $ret;
                })());
                l._segments.add(((function () {
                    var $ret = new PolyLineSegment();
                    $ret.points = k;
                    return $ret;
                })()));
                h.c.add(l);
            };
            for (var i = 0; i < g.count; i++) {
                _loop_1(i);
            }
            this.bw.item(c).ak = h;
            if (this.bw.item(c).dataContext != null) {
                this.bw.item(c).dataContext.item = f;
            }
            if (d != null) {
                var m = d.getBrushByValue(f, this.bv.nm);
                if (m == null) {
                    m = this.e.k3;
                }
                this.bx.add(m);
            }
            else {
                this.bx.add(this.e.k3);
            }
            c++;
        }
        this.bw.count = c;
        this.an();
    };
    ScatterContourSeriesView.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._stroke = this.bx._inner[b];
        c.ac = this.e.ey;
        if (c.y != null) {
            this.h.i(c, c.y);
        }
    };
    ScatterContourSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._stroke = d;
        c.ac = this.e.ey + 3;
    };
    ScatterContourSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        for (var c = 0; c < this.by.count; c++) {
            var d = this.by._inner[c];
            if (d._visibility != 1) {
                this.ba(d, c, b);
                a.s(d);
            }
        }
    };
    ScatterContourSeriesView.prototype.b0 = function (a) {
        this.bw.count = 0;
        this.an();
    };
    ScatterContourSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        var b = new List$1(Tuple$2.$.specialize(Number_$type, Path.$), 0);
        if (this.bu != null) {
            for (var c = 0; c < this.bw.count; c++) {
                b.add(new Tuple$2(Number_$type, Path.$, this.bu[c], this.bw.item(c)));
            }
        }
        b.aa(function (d, e) {
            if (d.c < e.c) {
                return -1;
            }
            else if (d.c > e.c) {
                return 1;
            }
            return 0;
        });
        for (var d = 0; d < b.count; d++) {
            var e = typeCast(Path.$, b._inner[d].d);
            if (e._visibility != 1) {
                this.e.a2.exportPathData(a, e, "contour" + d, ["Main "]);
            }
        }
    };
    ScatterContourSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.bv.fx + "</span><br/>";
        if (!stringIsNullOrEmpty(this.bv.np)) {
            a += "<span>Value: ${item}</span>";
        }
        a += "</div>";
        return a;
    };
    ScatterContourSeriesView.prototype.b4 = function (a, b) {
        for (var c = 0; c < this.by.count; c++) {
            var d = this.by._inner[c];
            var e = typeCast(PathGeometry.$, d.ak);
            if (e != null) {
                for (var f = 0; f < e.c.count; f++) {
                    var g = e.c._inner[f];
                    var h = e.c._inner[f]._startPoint;
                    for (var i = 0; i < g._segments.count; i++) {
                        var j = typeCast(PolyLineSegment.$, g._segments._inner[i]);
                        if (j != null) {
                            var k = this.bv.ey / 2 + this.bv.ee(b);
                            if (j._points.count > 0 && GeometryUtil.b(a, h, j._points, k)) {
                                return d;
                            }
                        }
                    }
                }
            }
        }
        return null;
    };
    ScatterContourSeriesView.$t = markType(ScatterContourSeriesView, 'ScatterContourSeriesView', SeriesView.$);
    return ScatterContourSeriesView;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Series class for rendering isarithmic contours based on a triangulation of X+Y+Value points in the ItemsSource.
*/
var IgrScatterContourSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterContourSeries, _super);
    function IgrScatterContourSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterContourSeries.prototype.createImplementation = function () {
        return new ScatterContourSeries();
    };
    Object.defineProperty(IgrScatterContourSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterContourSeries.prototype, "valueMemberPath", {
        /**
         * Gets or set the name of the property from which to retrieve the numeric values from the ItemsSource items.
        */
        get: function () {
            return this.i.np;
        },
        set: function (v) {
            this.i.np = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterContourSeries.prototype, "fillScale", {
        /**
         * Gets or sets the ValueBrushScale to use when determining Brushes for each contour line, based on the values found in ValueMemberPath.
        */
        get: function () {
            if (this.i.nk == null) {
                return null;
            }
            if (!this.i.nk.externalObject) {
                var e = IgrValueBrushScale._createFromInternal(this.i.nk);
                if (e) {
                    e._implementation = this.i.nk;
                }
                this.i.nk.externalObject = e;
            }
            return this.i.nk.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.nk = null : this.i.nk = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterContourSeries.prototype, "valueResolver", {
        /**
         * Gets or set the ContourValueResolver used to determine the numeric values of contours.
        */
        get: function () {
            if (this.i.ni == null) {
                return null;
            }
            if (!this.i.ni.externalObject) {
                var e = IgrContourValueResolver._createFromInternal(this.i.ni);
                if (e) {
                    e._implementation = this.i.ni;
                }
                this.i.ni.externalObject = e;
            }
            return this.i.ni.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.ni = null : this.i.ni = v.i;
        },
        enumerable: true,
        configurable: true
    });
    IgrScatterContourSeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.fillScale && this.fillScale._styling) {
            this.fillScale._styling(container, component, this);
        }
        if (this.valueResolver && this.valueResolver._styling) {
            this.valueResolver._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrScatterContourSeries.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    return IgrScatterContourSeries;
}(IgrScatterTriangulationSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterContourSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterContourSeriesModule() {
    }
    IgrScatterContourSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterContourSeries", IgrScatterContourSeries);
        TypeRegistrar.register("ScatterContourSeries", ScatterContourSeries.$type);
    };
    return IgrScatterContourSeriesModule;
}());

var IgrStyleShapeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrStyleShapeEventArgs() {
    }
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrStyleShapeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrStyleShapeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "shapeFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.shapeStyle ? this.i.shapeStyle.fill : null;
        },
        set: function (v) {
            this.ensureShapeStyle();
            this.i.shapeStyle.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "shapeStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.shapeStyle ? this.i.shapeStyle.stroke : null;
        },
        set: function (v) {
            this.ensureShapeStyle();
            this.i.shapeStyle.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "shapeStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.shapeStyle ? this.i.shapeStyle.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureShapeStyle();
            this.i.shapeStyle.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStyleShapeEventArgs.prototype, "shapeOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.shapeStyle ? this.i.shapeStyle.opacity : NaN;
        },
        set: function (v) {
            this.ensureShapeStyle();
            this.i.shapeStyle.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrStyleShapeEventArgs.prototype.ensureShapeStyle = function () {
        if (this.i.shapeStyle) {
            return;
        }
        this.i.shapeStyle = new Style();
    };
    return IgrStyleShapeEventArgs;
}());

/**
 * Series class for rendering polygons.
*/
var IgrShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrShapeSeriesBase, _super);
    function IgrShapeSeriesBase(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        _this._styleShape = null;
        _this._styleShape_wrapped = null;
        return _this;
    }
    Object.defineProperty(IgrShapeSeriesBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "shapeMemberPath", {
        /**
         * The name of the property on ItemsSource items which, for each shape, contains a list of points to be converted to a polygon.
         * To be consistent with the Shapefile technical description, it is expected that each list of points is defined as an IEnumerable of IEnumerable of Point, or in other words, a list of lists of points.
        */
        get: function () {
            return this.i.mt;
        },
        set: function (v) {
            this.i.mt = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current ScatterBase object.
        */
        get: function () {
            if (this.i.l6 == null) {
                return null;
            }
            if (!this.i.l6.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.l6);
                if (e) {
                    e._implementation = this.i.l6;
                }
                this.i.l6.externalObject = e;
            }
            return this.i.l6.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l6 = null : this.i.l6 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current ScatterBase object.
        */
        get: function () {
            if (this.i.l8 == null) {
                return null;
            }
            if (!this.i.l8.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.l8);
                if (e) {
                    e._implementation = this.i.l8;
                }
                this.i.l8.externalObject = e;
            }
            return this.i.l8.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.l8 = null : this.i.l8 = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "shapeFilterResolution", {
        /**
         * The resolution at which to filter out shapes in the series.  For example, if the ShapeFilterResolution is set to 3, then elements with a bounding rectangle smaller than 3 X 3 pixels will be filtered out.
         * In the case of ScatterPolylineSeries, the resolution is compared to either dimension, rather than both.  In other words, a polyline will not be filtered if its height or its width exceeds the value of this property.  Whereas with a ShapeSeries, both the height and the width must exceed the value of this property.
        */
        get: function () {
            return this.i.mn;
        },
        set: function (v) {
            this.i.mn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrShapeSeriesBase.prototype, "isShape", {
        /**
         * Gets whether or not this series is a shape series
        */
        get: function () {
            return this.i.c5;
        },
        enumerable: true,
        configurable: true
    });
    IgrShapeSeriesBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrShapeSeriesBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    IgrShapeSeriesBase.prototype.getItemValue = function (item, memberPathName) {
        var iv = this.i.fs(item, memberPathName);
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrShapeSeriesBase.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.md(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrShapeSeriesBase.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.mc(axis);
        return (iv);
    };
    Object.defineProperty(IgrShapeSeriesBase.prototype, "styleShape", {
        /**
         * Raised when tile's image URI should be provided
        */
        get: function () {
            return this._styleShape;
        },
        set: function (ev) {
            var _this = this;
            if (this._styleShape_wrapped !== null) {
                this.i.styleShape = delegateRemove(this.i.styleShape, this._styleShape_wrapped);
                this._styleShape_wrapped = null;
                this._styleShape = null;
            }
            this._styleShape = ev;
            this._styleShape_wrapped = function (o, e) {
                var outerArgs = new IgrStyleShapeEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeStyleShape) {
                    _this.beforeStyleShape(_this, outerArgs);
                }
                if (_this._styleShape) {
                    _this._styleShape(_this, outerArgs);
                }
            };
            this.i.styleShape = delegateCombine(this.i.styleShape, this._styleShape_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrShapeSeriesBase;
}(IgrSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var FlattenedShape = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FlattenedShape, _super);
    function FlattenedShape() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.c = null;
        return _this;
    }
    FlattenedShape.$t = markType(FlattenedShape, 'FlattenedShape');
    return FlattenedShape;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StyleShapeEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StyleShapeEventArgs, _super);
    function StyleShapeEventArgs(a, b, c) {
        var _this = _super.call(this) || this;
        _this._item = null;
        _this._container = null;
        _this._shapeStyle = null;
        _this.item = a;
        _this.container = b;
        _this.shapeStyle = c;
        return _this;
    }
    Object.defineProperty(StyleShapeEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StyleShapeEventArgs.prototype, "container", {
        get: function () {
            return this._container;
        },
        set: function (a) {
            this._container = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StyleShapeEventArgs.prototype, "shapeStyle", {
        get: function () {
            return this._shapeStyle;
        },
        set: function (a) {
            this._shapeStyle = a;
        },
        enumerable: true,
        configurable: true
    });
    StyleShapeEventArgs.prototype.d = function () {
        return this.shapeStyle;
    };
    StyleShapeEventArgs.$t = markType(StyleShapeEventArgs, 'StyleShapeEventArgs', EventArgs.$);
    return StyleShapeEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ShapeHitRegion = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeHitRegion, _super);
    function ShapeHitRegion() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.a = null;
        _this.b = 0;
        _this.c = null;
        return _this;
    }
    ShapeHitRegion.$t = markType(ShapeHitRegion, 'ShapeHitRegion');
    return ShapeHitRegion;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeSeriesBase, _super);
    function ShapeSeriesBase() {
        var _this = _super.call(this) || this;
        _this.ma = null;
        _this.l5 = null;
        _this.l7 = null;
        _this.mm = 0;
        _this.mi = null;
        _this.l1 = null;
        _this.l3 = null;
        _this.l2 = null;
        _this.l0 = null;
        _this.m7 = null;
        _this.mo = 0;
        _this.styleShape = null;
        FastItemObjectColumn.m();
        _this.mo = _this.mn;
        _this.m7 = Rect.empty;
        return _this;
    }
    ShapeSeriesBase.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.l6 = null;
        this.l8 = null;
    };
    ShapeSeriesBase.prototype.ag = function () {
        return [this.l6, this.l8];
    };
    ShapeSeriesBase.prototype.fs = function (a, b) {
        var c = this.gu(b);
        if (c == ShapeSeriesBase.$$p[1]) {
            return this.ft(a, b, this.mt);
        }
        return null;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "mb", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            var b = this.mb != a;
            if (b) {
                var c = this.mb;
                this.ma = a;
                this.raisePropertyChanged("ShapeColumn", c, this.mb);
            }
        },
        enumerable: true,
        configurable: true
    });
    ShapeSeriesBase.prototype.me = function (array_) {
        var a = (Array.isArray(array_));
        return a;
    };
    ShapeSeriesBase.prototype.convertToListList = function (a) {
        if (a == null) {
            return null;
        }
        var b = new List$1(List$1.$.specialize(Point_$type), 0);
        var c;
        var curr_;
        var d;
        var e;
        for (var f = 0; f < a.length; f++) {
            c = a[f];
            var g = new List$1(Point_$type, 0);
            for (var h = 0; h < c.length; h++) {
                curr_ = c[h];
                d = (curr_.x);
                e = (curr_.y);
                g.add({ $type: Point_$type, x: d, y: e });
            }
            b.add(g);
        }
        return b;
    };
    ShapeSeriesBase.prototype.by = function (a) {
        if (this.bz != null && this.me(this.itemsSource) && a != null && a.split('!').length != 2) {
            if (this.coercionMethods == null) {
                this.coercionMethods = {};
            }
            var methods_ = this.coercionMethods;
            methods_.convertToListList = this.convertToListList;
            a += "!convertToListList";
        }
        return _super.prototype.by.call(this, a);
    };
    ShapeSeriesBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        var e = false;
        var f = false;
        switch (b) {
            case "FastItemsSource":
                var g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.mb);
                    this.mb = null;
                }
                var h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.mb = this.by(this.mt);
                }
                e = this.l6 != null && !this.l6.cl();
                f = this.l8 != null && !this.l8.cl();
                if (e || f) {
                    this.jd(false);
                }
                break;
            case ShapeSeriesBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mb);
                    this.mb = this.by(this.mt);
                }
                break;
            case "ShapeColumn":
                this.m0();
                e = this.l6 != null && !this.l6.cl();
                f = this.l8 != null && !this.l8.cl();
                if (e || f) {
                    this.jd(false);
                }
                this.ik();
                break;
            case ShapeSeriesBase.$$p[2]:
            case ShapeSeriesBase.$$p[3]:
                this.l5 = this.l6;
                this.l7 = this.l8;
                var i = c;
                var j = d;
                this.m1(i);
                this.my(j);
                if ((j != null && !j.cl()) || (j == null && i != null)) {
                    this.jd(false);
                }
                this.ik();
                break;
            case "Resolution":
                this.mm = this.eu;
                this.ik();
                break;
            case "ActualBrush":
                this.jd(false);
                break;
            case ShapeSeriesBase.$$p[0]:
                this.mo = this.mn;
                this.jd(false);
                this.ik();
                break;
            case "Thickness":
                this.jd(false);
                this.ik();
                break;
        }
    };
    ShapeSeriesBase.prototype.md = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ShapeSeriesBase.prototype.mc = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    ShapeSeriesBase.prototype.m0 = function () {
        this.mi = null;
        if (this.mb == null) {
            return;
        }
        this.mi = new List$1(Rect.$, 2, this.mb.count);
        for (var a = 0; a < this.mb.count; a++) {
            this.mi.add(PointCollectionUtil.j(this.mb.item(a)));
        }
    };
    ShapeSeriesBase.prototype.m8 = function (a) {
        if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
            return PointCollectionUtil.h(a);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
            return PointCollectionUtil.g(a);
        }
        return Rect.empty;
    };
    ShapeSeriesBase.prototype.mk = function (a, b, c, d, e) {
        var e_1, _a;
        return this.ml(a, b, c, d, e);
        if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
            return this.ml(a, b, c, d, e);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
            var f = c;
            var g = new List$1(FlattenedShape.$, 0);
            var h = null;
            try {
                for (var _b = __values(fromEnum(f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var i = _c.value;
                    h = this.l4(a, b, PointCollectionUtil.b(i), d, e);
                    if (h == null) {
                        continue;
                    }
                    g.add(h);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            return g;
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
            var j = c;
            var k = this.l4(a, b, PointCollectionUtil.b(j), d, e);
            var l = new List$1(FlattenedShape.$, 0);
            if (k != null) {
                l.add(k);
            }
            return l;
        }
        else {
            throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
        }
    };
    ShapeSeriesBase.prototype.get_mf = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "mf", {
        get: function () {
            return this.get_mf();
        },
        enumerable: true,
        configurable: true
    });
    ShapeSeriesBase.prototype.mh = function () {
        return false;
    };
    ShapeSeriesBase.prototype.je = function (a) {
        this.mz(this.bi);
    };
    ShapeSeriesBase.prototype.jc = function (a, b, c, d, e) {
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.mz(f);
    };
    ShapeSeriesBase.prototype.mz = function (a) {
        if (this.cc(a)) {
            return;
        }
        var b;
        var c;
        var d = a;
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        if (c.width < 1 || c.height < 1 || this.mb == null) {
            return;
        }
        var f = this.l6;
        var g = this.l8;
        var h = this.getEffectiveViewport1(a);
        var i = new ScalerParams(1, b, c, f.b8);
        i.c = h;
        var j = new ScalerParams(1, b, c, g.b8);
        j.c = h;
        d.cj();
        var k = new Rect(0, 0, 0, 0, 0);
        var l;
        var m;
        var n;
        var o;
        var p = this.mb.count;
        if (this.l3 == null || this.l3.length != p) {
            this.l3 = new Array(p);
            this.l1 = new Array(p);
            this.l2 = new Array(p);
            this.l0 = new Array(p);
        }
        var q = this.l3;
        var r = this.l1;
        var s = this.l2;
        var t = this.l0;
        var u;
        for (var v = 0; v < p; v++) {
            u = this.mi._inner[v];
            q[v] = u.top;
            r[v] = u.left;
            s[v] = u.right;
            t[v] = u.bottom;
        }
        this.l5.gn(boxArray$1(r), 0, r.length, i);
        this.l5.gn(boxArray$1(s), 0, s.length, i);
        this.l7.gn(boxArray$1(q), 0, q.length, j);
        this.l7.gn(boxArray$1(t), 0, t.length, j);
        d.ck(r, q, s, t);
        var w = this.mb;
        var x = this.bz;
        this.m2(d);
        var y = c.left;
        var z = c.right;
        var aa = c.top;
        var ab = c.bottom;
        var ac = null;
        if (this.m7.isEmpty) {
            ac = null;
        }
        else {
            ac = new Clipper(1, this.m7.left, this.m7.bottom, this.m7.right, this.m7.top, this.mf);
        }
        var ad = this.mh();
        if (ad) {
            d.b3.clear();
        }
        var ae;
        for (var af = 0; af < p; af++) {
            n = r[af];
            l = q[af];
            m = t[af];
            o = s[af];
            k.x = Math.min(n, o);
            k.y = Math.min(l, m);
            k.width = Math.max(n, o) - k.x;
            k.height = Math.max(l, m) - k.y;
            if (k.intersectsWith(c)) {
                if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                    ae = ac;
                }
                else {
                    ae = null;
                }
                var ag = this.mk(a, ae, w.item(af), i, j);
                if (ad) {
                    var ah = 0;
                    var ai = null;
                    for (var aj = 0; aj < ag.count; aj++) {
                        var ak = ag._inner[aj];
                        var al = ak.b.width * ak.b.height;
                        if (al > ah) {
                            ah = al;
                            ai = ak;
                        }
                    }
                    d.b3.addItem(af, ai);
                }
                d.b8(af, x.item(af), k, ag);
            }
        }
        d.ci();
    };
    ShapeSeriesBase.prototype.ib = function () {
        _super.prototype.ib.call(this);
        if (this.l6 != null) {
            this.l6.g5();
        }
        if (this.l8 != null) {
            this.l8.g5();
        }
    };
    ShapeSeriesBase.prototype.jt = function (a, b) {
        this.jd(false);
    };
    ShapeSeriesBase.prototype.js = function (a, b) {
        this.jd(false);
    };
    ShapeSeriesBase.prototype.hy = function (a, b, c, d) {
        _super.prototype.hy.call(this, a, b, c, d);
        switch (a) {
            case 3:
                if (d == this.mt) {
                    this.mi._inner[b] = this.m8(this.mb.item(b));
                }
                break;
            case 1:
                for (var e = b; e < b + c; e++) {
                    this.mi.insert(e, this.m8(this.mb.item(e)));
                }
                break;
            case 0:
                this.mi.v(b, c);
                break;
            case 2:
                for (var f = b; f < b + c; f++) {
                    this.mi._inner[f] = this.m8(this.mb.item(f));
                }
                break;
            case 4:
                this.m0();
                break;
        }
        this.jd(false);
    };
    ShapeSeriesBase.prototype.dw = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dw.call(this, a, b, c) || (this.mg && this.mb == null) || b.isEmpty || a.isEmpty || this.l6 == null || this.l8 == null || this.l6.bf == null || this.l8.bf == null || this.l6.j4 == this.l6.j3 || this.l8.j4 == this.l8.j3 || this.mb == null || this.mb.count == 0 || this.mi == null || this.mi.count == 0 || this.mi.count != this.mb.count) {
            d = false;
        }
        return d;
    };
    ShapeSeriesBase.prototype.get_mg = function () {
        return true;
    };
    Object.defineProperty(ShapeSeriesBase.prototype, "mg", {
        get: function () {
            return this.get_mg();
        },
        enumerable: true,
        configurable: true
    });
    ShapeSeriesBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.l9 = typeCast(ShapeSeriesViewBase.$, a);
    };
    ShapeSeriesBase.prototype.ml = function (a, b, c, d, e) {
        var f = new List$1(FlattenedShape.$, 0);
        var g;
        var h = c.count;
        for (var i = 0; i < h; i++) {
            g = c._inner[i];
            var j = this.l4(a, b, g, d, e);
            if (j == null) {
                continue;
            }
            f.add(j);
        }
        return f;
    };
    ShapeSeriesBase.prototype.l4 = function (a, b, c, d, e) {
        var f = this.mx(c, d, e);
        var g = f.c;
        var h = f.d;
        var i = g.length;
        var j = 1.7976931348623157E+308;
        var k = 1.7976931348623157E+308;
        var l = -1.7976931348623157E+308;
        var m = -1.7976931348623157E+308;
        var n;
        var o;
        for (var p = 0; p < i; p++) {
            n = g[p];
            o = h[p];
            j = n < j ? n : j;
            k = o < k ? o : k;
            l = n > l ? n : l;
            m = o > m ? o : m;
        }
        var q = !(j > this.m7.right || l < this.m7.left || k > this.m7.bottom || m < this.m7.top);
        if (!q) {
            return null;
        }
        var r = b != null && (j < this.m7.left || k < this.m7.top || l > this.m7.right || m > this.m7.bottom);
        var s = new Rect(0, j, k, l - j, m - k);
        if (!a.b2(s)) {
            return null;
        }
        j = j < this.m7.left ? this.m7.left : j;
        l = l > this.m7.right ? this.m7.right : l;
        k = k < this.m7.top ? this.m7.top : k;
        m = m > this.m7.bottom ? this.m7.bottom : m;
        var t = PolySimplification.b(f, this.eu);
        var u = new DefaultFlattener().c(f.c, f.d, t, this.mm);
        var v = u.count;
        if (r) {
            var w = new List$1(Point_$type, 0);
            b.i = w;
            for (var x = 0; x < v; x++) {
                b.j(u._inner[x]);
            }
            b.i = null;
            u = w;
        }
        if (u == null || u.count == 0) {
            return null;
        }
        var y = new FlattenedShape();
        y.a = u;
        y.b = new Rect(0, j, k, l - j, m - k);
        y.c = s;
        return y;
    };
    ShapeSeriesBase.prototype.mx = function (a, b, c) {
        var d = this.l5;
        var e = this.l7;
        var f = a.count;
        var g = new Array(f);
        var h = new Array(f);
        for (var i = 0; i < f; i++) {
            g[i] = a._inner[i].x;
            h[i] = a._inner[i].y;
        }
        d.gn(boxArray$1(g), 0, g.length, b);
        e.gn(boxArray$1(h), 0, h.length, c);
        return new Tuple$2(Array_$type, Array_$type, g, h);
    };
    ShapeSeriesBase.prototype.m2 = function (a) {
        a.cp();
    };
    ShapeSeriesBase.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.cd();
    };
    ShapeSeriesBase.prototype.my = function (a) {
        if (a != null) {
            a.ci(this);
        }
    };
    ShapeSeriesBase.prototype.m1 = function (a) {
        if (a != null) {
            a.bv(this);
        }
    };
    ShapeSeriesBase.prototype.ar = function (a, b) {
        var c = this.l9.cr(a, b);
        var d = null;
        if (c != null) {
            d = c.dataContext;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.ar.call(this, a, b);
    };
    ShapeSeriesBase.prototype.mq = function (a) {
        return this.bz.item(a);
    };
    ShapeSeriesBase.prototype.get_dq = function () {
        return true;
    };
    ShapeSeriesBase.prototype.set_dq = function (a) {
        _super.prototype.set_dq.call(this, a);
    };
    ShapeSeriesBase.prototype.an = function (a) {
        var e_2, _a, e_3, _b;
        if (typeCast(NumericXAxis.$, a) !== null && this.mi != null) {
            var b = 1.7976931348623157E+308;
            var c = -1.7976931348623157E+308;
            try {
                for (var _c = __values(fromEnum(this.mi)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var d = _d.value;
                    b = Math.min(b, d.left);
                    c = Math.max(c, d.right);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            return new AxisRange(b, c);
        }
        if (typeCast(NumericYAxis.$, a) !== null && this.mi != null) {
            var e = 1.7976931348623157E+308;
            var f = -1.7976931348623157E+308;
            try {
                for (var _e = __values(fromEnum(this.mi)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var g = _f.value;
                    e = Math.min(e, g.top);
                    f = Math.max(f, g.bottom);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return new AxisRange(e, f);
        }
        return null;
    };
    ShapeSeriesBase.prototype.get_c5 = function () {
        return true;
    };
    ShapeSeriesBase.prototype.m9 = function (a, b, c) {
        if (this.styleShape != null) {
            if (this.l9.cx != null && c == this.l9.cx) {
                c = new Style();
                var d = this.l9.cx;
                c.fill = d.fill;
                c.opacity = d.opacity;
                c.stroke = d.stroke;
                c.strokeThickness = d.strokeThickness;
            }
            else {
                if (c != null) {
                    var e = new Style();
                    e.fill = c.fill;
                    e.opacity = c.opacity;
                    e.stroke = c.stroke;
                    e.strokeThickness = c.strokeThickness;
                    c = e;
                }
                else {
                    c = new Style();
                }
            }
            var f = new StyleShapeEventArgs(a, b, c);
            this.styleShape(this, f);
            return f.d();
        }
        return null;
    };
    ShapeSeriesBase.$t = markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
    ShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['ShapeFilterResolution:mn:m3', [1, 2], 'ShapeMemberPath:mt:m4', [2, null], 'XAxis:l6:m5', [NumericXAxis.$, null], 'YAxis:l8:m6', [NumericYAxis.$, null]]);
    return ShapeSeriesBase;
}(Series));
/**
 * @hidden
 */
var ShapeSeriesViewBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeSeriesViewBase, _super);
    function ShapeSeriesViewBase(a) {
        var _this = _super.call(this, a) || this;
        _this.b3 = null;
        _this.by = null;
        _this.b4 = new List$1(ShapeHitRegion.$, 0);
        _this.b7 = 0;
        _this.b6 = null;
        _this.b1 = null;
        _this.bz = null;
        _this.cw = null;
        _this.bv = null;
        _this.bx = null;
        _this.bw = null;
        _this.bu = null;
        _this.by = a;
        _this.b1 = _this.b0();
        _this.b6 = new List$1(Path.$, 0);
        _this.b3 = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
        return _this;
    }
    ShapeSeriesViewBase.prototype.b0 = function () {
        var _this = this;
        return ((function () {
            var $ret = new Pool$1(FrameworkElement.$);
            $ret.create = runOn(_this, _this.cq);
            $ret.activate = runOn(_this, _this.cf);
            $ret.disactivate = runOn(_this, _this.cg);
            $ret.destroy = runOn(_this, _this.ch);
            return $ret;
        })());
    };
    ShapeSeriesViewBase.prototype.b2 = function (a) {
        return a.width >= this.by.mo && a.height >= this.by.mo;
    };
    ShapeSeriesViewBase.b5 = function (a) {
        var b = new List$1(PointCollection.$, 0);
        var c;
        var d = a.count;
        for (var e = 0; e < d; e++) {
            c = a._inner[e];
            var f = new PointCollection(1, c.a);
            b.add(f);
        }
        return b;
    };
    ShapeSeriesViewBase.prototype.b8 = function (a, b, c, d) {
        if (d != null && d.count > 0) {
            var e = ShapeSeriesViewBase.b5(d);
            c.intersect(this.br);
            if (!this.b2(c)) {
            }
            else {
                var f = this.cu(a, e);
                if (f != null) {
                    var g = this.ct(this.b7, b);
                    for (var h = 0; h < d.count; h++) {
                        var i = new ShapeHitRegion();
                        i.d = d._inner[h].b;
                        i.a = d._inner[h].a;
                        i.b = a;
                        i.c = g;
                        this.b4.add(i);
                    }
                    this.ce(g);
                    this.ca(g, f);
                    this.cc(g, b);
                    this.b7 = this.b7 + 1;
                }
            }
        }
    };
    ShapeSeriesViewBase.prototype.ct = function (a, b) {
        var c = this.b1.item(this.b7);
        if (c.dataContext != null) {
            c.dataContext.item = b;
        }
        return c;
    };
    ShapeSeriesViewBase.cb = function (a, b, c) {
        if (b._fill == null) {
            b._fill = a.e.k3;
        }
        if (b._stroke == null) {
            b._stroke = a.e.k4;
        }
        if (b.y == null) {
            b.ac = a.e.ey;
        }
    };
    ShapeSeriesViewBase.prototype.cc = function (a, b) {
        if (a == null) {
            return;
        }
        var c = false;
        if (this.bz != null) {
            var d = this.bz.selectStyle(b, a);
            if (d != null) {
                c = true;
            }
            a.y = d;
        }
        if (!c) {
            a.y = this.cw;
        }
        a.y = this.by.m9(b, a, a.y);
    };
    ShapeSeriesViewBase.prototype.ce = function (a) {
    };
    ShapeSeriesViewBase.prototype.b9 = function (a, b) {
        var c = truncate(Math.floor(a.left));
        var d = truncate(Math.ceil(a.right));
        var e = truncate(Math.floor(a.top));
        var f = truncate(Math.ceil(a.bottom));
        for (var g = c; g < d; g++) {
            for (var h = e; h < f; h++) {
                this.cm(g, h, b);
            }
        }
    };
    ShapeSeriesViewBase.prototype.cm = function (a, b, c) {
    };
    ShapeSeriesViewBase.prototype.cj = function () {
        this.b7 = 0;
    };
    ShapeSeriesViewBase.prototype.ci = function () {
        this.b1.count = this.b7;
        this.an();
    };
    ShapeSeriesViewBase.prototype.cl = function (a, b) {
    };
    ShapeSeriesViewBase.prototype.cd = function () {
        this.b1.count = 0;
        this.an();
    };
    ShapeSeriesViewBase.prototype.cq = function () {
        var a = this.by;
        var b = ((function () {
            var $ret = new Path();
            $ret.dataContext = ((function () {
                var $ret = new DataContext();
                $ret.series = a;
                return $ret;
            })());
            return $ret;
        })());
        this.b6.add(b);
        return b;
    };
    ShapeSeriesViewBase.prototype.cf = function (a) {
        a._visibility = 0;
    };
    ShapeSeriesViewBase.prototype.cg = function (a) {
        a.dataContext.item = null;
        a._visibility = 1;
    };
    ShapeSeriesViewBase.prototype.ch = function (a) {
        this.b6.remove(a);
    };
    ShapeSeriesViewBase.prototype.cv = function (a, b, c) {
        if (b == null) {
            return null;
        }
        var d = new PathGeometry();
        var e;
        var f = b.count;
        for (var g = 0; g < f; g++) {
            e = b._inner[g];
            if (e.count < 1) {
                continue;
            }
            var h = new PolyLineSegment();
            h._points = e;
            var i = new PathFigure();
            i._isFilled = c;
            i._isClosed = c;
            i._startPoint = e._inner[0];
            i._segments.add(h);
            d.c.add(i);
        }
        return d;
    };
    ShapeSeriesViewBase.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._fill = this.e.k3;
        c._stroke = this.e.k4;
        c.ac = this.e.ey;
        if (c.y != null) {
            this.h.i(c, c.y);
        }
    };
    ShapeSeriesViewBase.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    };
    ShapeSeriesViewBase.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        for (var c = 0; c < this.b6.count; c++) {
            var d = this.b6._inner[c];
            if (d._visibility != 1) {
                this.ba(d, c, b);
                a.s(d);
            }
        }
    };
    Object.defineProperty(ShapeSeriesViewBase.prototype, "cx", {
        get: function () {
            return this.cw;
        },
        enumerable: true,
        configurable: true
    });
    ShapeSeriesViewBase.prototype.co = function (a) {
        this.bz = a;
    };
    ShapeSeriesViewBase.prototype.cn = function (a) {
        this.cw = a;
    };
    ShapeSeriesViewBase.prototype.cr = function (a, b) {
        return this.cs(a, b, false);
    };
    ShapeSeriesViewBase.prototype.cs = function (a, b, c) {
        if (this.b4.count == 0) {
            return null;
        }
        var d = a.x;
        var e = a.y;
        var f = this.b4.count;
        var g = this.b4;
        var h = null;
        for (var i = 0; i < f; i++) {
            h = g._inner[i];
            if (h.a == null || h.a.count == 0) {
                continue;
            }
            if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                if (c) {
                    var j = this.by.ey / 2 + this.by.ee(b);
                    if (GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                        return h.c;
                    }
                }
                else {
                    if (PolygonUtil.a(h.a, a)) {
                        return h.c;
                    }
                }
            }
        }
        return null;
    };
    ShapeSeriesViewBase.prototype.ck = function (a, b, c, d) {
        this.bv = a;
        this.bx = b;
        this.bw = c;
        this.bu = d;
        this.b4.clear();
    };
    ShapeSeriesViewBase.prototype.cp = function () {
        var _this = this;
        var a = this.br;
        var b = ((function () {
            var $ret = new Path();
            $ret.y = _this.cw;
            return $ret;
        })());
        b.ac = 1;
        if (this.h != null) {
            this.h.i(b, b.y);
        }
        this.by.m7 = RectUtil.r(a, b.ac);
    };
    ShapeSeriesViewBase.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        if (this.b1.a == null) {
            return;
        }
        for (var b = 0; b < this.b1.a.count; b++) {
            var c = typeCast(Path.$, this.b1.a._inner[b]);
            if (c._visibility != 1) {
                this.e.a2.exportPathData(a, c, "shape" + b, ["Main "]);
            }
        }
    };
    ShapeSeriesViewBase.$t = markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
    return ShapeSeriesViewBase;
}(SeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ShapeAxisInfoCache = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ShapeAxisInfoCache, _super);
    function ShapeAxisInfoCache() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.b = null;
        _this.e = false;
        _this.f = false;
        _this.d = null;
        _this.c = null;
        return _this;
    }
    ShapeAxisInfoCache.$t = markType(ShapeAxisInfoCache, 'ShapeAxisInfoCache');
    return ShapeAxisInfoCache;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StyleSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StyleSelector, _super);
    function StyleSelector() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StyleSelector.prototype.selectStyle = function (a, b) {
        return null;
    };
    StyleSelector.$t = markType(StyleSelector, 'StyleSelector');
    return StyleSelector;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerVisualData, _super);
    function MarkerVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._x = 0;
        _this._y = 0;
        _this._index = 0;
        _this._markerAppearance = null;
        _this._markerType = null;
        _this._contentTemplate = null;
        _this._isVisible = false;
        _this._bounds = null;
        return _this;
    }
    Object.defineProperty(MarkerVisualData.prototype, "x", {
        get: function () {
            return this._x;
        },
        set: function (a) {
            this._x = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "y", {
        get: function () {
            return this._y;
        },
        set: function (a) {
            this._y = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "index", {
        get: function () {
            return this._index;
        },
        set: function (a) {
            this._index = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "markerAppearance", {
        get: function () {
            return this._markerAppearance;
        },
        set: function (a) {
            this._markerAppearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "markerType", {
        get: function () {
            return this._markerType;
        },
        set: function (a) {
            this._markerType = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "contentTemplate", {
        get: function () {
            return this._contentTemplate;
        },
        set: function (a) {
            this._contentTemplate = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MarkerVisualData.prototype, "isVisible", {
        get: function () {
            return this._isVisible;
        },
        set: function (a) {
            this._isVisible = a;
        },
        enumerable: true,
        configurable: true
    });
    MarkerVisualData.prototype.serialize = function () {
        return "{ x: " + this.x + ", y: " + this.y + ", index: " + this.index + ", markerAppearance: " + (this.markerAppearance != null ? this.markerAppearance.serialize() : "null") + ", markerType: \"" + this.markerType + "\", isVisible: " + (this.isVisible ? "true" : "false") + ", " + "bounds: { left: " + this.bounds.left + ", top:" + this.bounds.top + ", width:" + this.bounds.width + ", height: " + this.bounds.height + "} }";
    };
    MarkerVisualData.prototype.i = function (a) {
        this.x = (this.x - a.left) / a.width;
        this.y = (this.y - a.top) / a.height;
        if (this.bounds != null) {
            var b = (this.bounds.left - a.left) / a.width;
            var c = (this.bounds.top - a.top) / a.height;
            var d = ((this.bounds.left + this.bounds.width) - a.left) / a.width;
            var e = ((this.bounds.top + this.bounds.height) - a.top) / a.height;
            this.bounds = new RectData(b, c, d - b, e - c);
        }
    };
    Object.defineProperty(MarkerVisualData.prototype, "bounds", {
        get: function () {
            return this._bounds;
        },
        set: function (a) {
            this._bounds = a;
        },
        enumerable: true,
        configurable: true
    });
    MarkerVisualData.$t = markType(MarkerVisualData, 'MarkerVisualData');
    return MarkerVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeries, _super);
    function ScatterPolygonSeries() {
        var _this = _super.call(this) || this;
        _this.nh = null;
        _this.ne = new ScalerParams(1, ScatterPolygonSeries.od, ScatterPolygonSeries.od, false);
        _this.nf = new ScalerParams(1, ScatterPolygonSeries.od, ScatterPolygonSeries.od, false);
        _this.ab = ScatterPolygonSeries.$;
        return _this;
    }
    ScatterPolygonSeries.prototype.mh = function () {
        return this.nj();
    };
    ScatterPolygonSeries.prototype.mz = function (a) {
        var _this = this;
        var b = a;
        b.cn(this.of);
        b.co(this.ni);
        _super.prototype.mz.call(this, a);
        if (this.cc(a)) {
            return;
        }
        var c, d;
        var e = a.getViewInfo(c, d);
        c = e.p0;
        d = e.p1;
        var f = this.getEffectiveViewport1(a);
        this.ne = new ScalerParams(1, d, c, this.l6.b8);
        this.ne.c = f;
        this.nf = new ScalerParams(1, d, c, this.l8.b8);
        this.nf.c = f;
        if (c.width < 1 || c.height < 1) {
            return;
        }
        this.nh = ((function () {
            var $ret = new ShapeAxisInfoCache();
            $ret.a = _this.l6;
            $ret.b = _this.l8;
            $ret.e = _this.l6.b8;
            $ret.f = _this.l8.b8;
            $ret.d = _this.bz;
            $ret.c = _this.mb;
            return $ret;
        })());
        if (this.nj()) {
            var g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
            b.c5.l(g, 400, d, c, this.eu);
            b.c5.j(g, false);
        }
    };
    ScatterPolygonSeries.prototype.nj = function () {
        return this.nw != null && ((this.nd != 1 && this.nd != 0) || this.nx != null);
    };
    ScatterPolygonSeries.prototype.bf = function () {
        return new ScatterPolygonSeriesView(this);
    };
    ScatterPolygonSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.ng = a;
    };
    ScatterPolygonSeries.prototype.get_hasMarkers = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.k6 = function () {
        return this.n9;
    };
    ScatterPolygonSeries.prototype.k7 = function () {
        return this.oa;
    };
    ScatterPolygonSeries.prototype.jz = function () {
        return this.nw;
    };
    ScatterPolygonSeries.prototype.jo = function () {
        _super.prototype.jo.call(this);
        if (this.nx != null) {
            this.ng.dd();
        }
        else {
            var a = MarkerSeries.l2(this, this.nd);
            var b = MarkerSeries.ma(a);
            if (b == null) {
                this.nw = MarkerSeries.ml;
            }
            else {
                this.ng.da(b);
            }
        }
        if (this.ob != null) {
            this.ng.db();
        }
        else {
            this.n9 = this.bs == null ? null : this.bs.ma(this.fh);
        }
        if (this.oc != null) {
            this.ng.dc();
        }
        else {
            this.oa = this.bs == null ? null : this.bs.mb(this.fh);
        }
    };
    ScatterPolygonSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ScatterPolygonSeries.$$p[3]:
            case ScatterPolygonSeries.$$p[8]:
            case ScatterPolygonSeries.$$p[5]:
            case ScatterPolygonSeries.$$p[7]:
                this.jo();
                this.jd(false);
                break;
            case ScatterPolygonSeries.$$p[2]:
                if (c == MarkerSeries.ml || d == MarkerSeries.ml || (c == null || d != null)) {
                    this.ng.df();
                    this.jd(false);
                }
                this.jd(false);
                this.ik();
                break;
            case ScatterPolygonSeries.$$p[9]:
                this.ng.cn(this.of);
                this.jd(false);
                this.ik();
                break;
            case ScatterPolygonSeries.$$p[10]:
                this.ng.co(this.ni);
                this.jd(false);
                this.ik();
                break;
            case ScatterPolygonSeries.$$p[4]:
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterPolygonSeries.prototype.ar = function (a, b) {
        var c = this.ng.c2(a);
        var d = null;
        if (c != null) {
            d = c.content;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.ar.call(this, a, b);
    };
    ScatterPolygonSeries.prototype.nv = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    ScatterPolygonSeries.prototype.ch = function (a, b, c) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var d = this.l6;
        var e = new ScalerParams(1, this.bs.mq, this.ly, d.b8);
        e.c = this.getEffectiveViewport1(this.bi);
        var f = this.l8;
        var g = new ScalerParams(1, this.bs.mq, this.ly, f.b8);
        g.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ng.de(function (h) {
            if (h._visibility == 0) {
                var i = new SeriesPointOfInterest();
                var j = h.n;
                var k = h.o;
                if (j < _this.ly.left || j > _this.ly.right || k < _this.ly.top || k > _this.ly.bottom) {
                    return;
                }
                i.b = d.dz(j, e);
                i.c = f.dz(k, g);
                i.a = h.content;
                a.add(i);
            }
        });
        return true;
    };
    ScatterPolygonSeries.prototype.nb = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.nh.d.count) {
            c = new Array(this.nh.d.count);
            for (var f = 0; f < this.nh.d.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.l6.b8);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var h = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.l8.b8);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = this.nh.a.dz(g.d.left, g);
        var j = this.nh.a.dz(g.d.right, g);
        var k = this.nh.b.dz(h.d.bottom, h);
        var l = this.nh.b.dz(h.d.top, h);
        if (this.nh.e) {
            var m = i;
            i = j;
            j = m;
        }
        if (this.nh.f) {
            var n = k;
            k = l;
            l = n;
        }
        var o = this.nh;
        var p = o.a;
        var q = o.b;
        var r;
        var s;
        var t = g.d.left;
        var u = g.d.right;
        var v = h.d.top;
        var w = h.d.bottom;
        for (var x = 0; x < this.nh.d.count; x++) {
            r = 0;
            s = 0;
            var y = null;
            var z = a.b3.tryGetValue(x, y);
            y = z.p1;
            if (y == null) {
                c[x].x = NaN;
                c[x].y = NaN;
            }
            else {
                var aa = y.c;
                var ab = RectUtil.l(aa);
                r = ab.x;
                s = ab.y;
                if (r >= t && r <= u && s >= v && s <= w) {
                    c[x].x = r;
                    c[x].y = s;
                }
                else {
                    c[x].x = NaN;
                    c[x].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterPolygonSeries.prototype.na = function (a, b) {
        var e_3, _a;
        if (b == null || b.length != a.e) {
            b = new Array(a.e);
        }
        var c = 0;
        var d = this.bz;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b[c] = d.indexOf(e);
                c++;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.od = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:n9:ny', [Brush.$], 'ActualMarkerOutline:oa:nz', [Brush.$], 'ActualMarkerTemplate:nw:n0', [DataTemplate.$, null], 'MarkerBrush:ob:n1', [Brush.$], 'MarkerCollisionAvoidance:nc:n2', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerOutline:oc:n3', [Brush.$], 'MarkerStyle:oe:n4', [Style.$], 'MarkerTemplate:nx:n5', [DataTemplate.$, null], 'MarkerType:nd:n6', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:of:n7', [Style.$, null], 'ShapeStyleSelector:ni:n8', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
}(ShapeSeriesBase));
/**
 * @hidden
 */
var ScatterPolygonSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeriesView, _super);
    function ScatterPolygonSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c1 = null;
        _this.c0 = null;
        _this.c6 = null;
        _this.c4 = null;
        _this.c8 = false;
        _this.c7 = null;
        _this.c9 = null;
        _this.dm = null;
        _this.c6 = a;
        _this.c7 = new HashPool$2(Base.$, Marker.$);
        _this.c9 = new List$1(Marker.$, 0);
        _this.dg(_this.c7);
        _this.c4 = new NumericMarkerManager(1, function (b) { return _this.c7.item(b); }, function (b) { return _this.c6.nh.d.item(b); }, runOn(_this, _this.dk), runOn(_this, _this.cz), runOn(_this, _this.cy), function () { return _this.c6.nc; });
        _this.c4.q = runOn(_this, _this.dn);
        return _this;
    }
    ScatterPolygonSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 8;
        }
    };
    Object.defineProperty(ScatterPolygonSeriesView.prototype, "c5", {
        get: function () {
            return this.c4;
        },
        enumerable: true,
        configurable: true
    });
    ScatterPolygonSeriesView.prototype.dk = function (a) {
        this.c6.nv(a, this.c7);
    };
    ScatterPolygonSeriesView.prototype.cz = function () {
        this.c1 = this.c6.nb(this, this.c7, this.c1, this.bs, this.br);
        return this.c1;
    };
    ScatterPolygonSeriesView.prototype.cy = function () {
        this.c0 = this.c6.na(this.c7, this.c0);
        return this.c0;
    };
    ScatterPolygonSeriesView.prototype.cu = function (a, b) {
        return this.cv(a, b, true);
    };
    ScatterPolygonSeriesView.prototype.cc = function (a, b) {
        _super.prototype.cc.call(this, a, b);
        ShapeSeriesViewBase.cb(this, a, b);
    };
    ScatterPolygonSeriesView.prototype.ca = function (a, b) {
        var c = a;
        if (c == null) {
            return;
        }
        c.ak = b;
    };
    ScatterPolygonSeriesView.prototype.de = function (a) {
        this.c7.f(a);
    };
    ScatterPolygonSeriesView.prototype.dg = function (a) {
        a.create = runOn(this, this.c3);
        a.destroy = runOn(this, this.di);
        a.activate = runOn(this, this.dh);
        a.disactivate = runOn(this, this.dj);
    };
    ScatterPolygonSeriesView.prototype.c3 = function () {
        var _this = this;
        var a = new Marker();
        if (!this.c8) {
            a.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
        }
        a.ah = this.e.nw;
        this.c9.add(a);
        return a;
    };
    ScatterPolygonSeriesView.prototype.di = function (a) {
        a.content = null;
        this.c9.remove(a);
    };
    ScatterPolygonSeriesView.prototype.dh = function (a) {
        a._visibility = 0;
    };
    ScatterPolygonSeriesView.prototype.dj = function (a) {
        if (a.content != null) {
            (typeCast(DataContext.$, a.content)).item = null;
        }
        a._visibility = 1;
    };
    ScatterPolygonSeriesView.prototype.dl = function (a) {
        this.c8 = a;
    };
    ScatterPolygonSeriesView.prototype.be = function (a, b) {
        _super.prototype.be.call(this, a, b);
        var c = a;
        var d = c.content;
        if (d != null) {
            if (this.c6.n9 != null) {
                d.actualItemBrush = this.c6.n9;
            }
            else {
                d.actualItemBrush = this.by.k3;
            }
            if (this.c6.n9 != null) {
                d.outline = this.c6.oa;
            }
            else {
                d.outline = this.by.k4;
            }
            d.thickness = 0.5;
        }
    };
    ScatterPolygonSeriesView.prototype.bf = function (a, b) {
        _super.prototype.bf.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        var e = c.content;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = 1 + 3;
        }
    };
    ScatterPolygonSeriesView.prototype.a2 = function (a, b) {
        _super.prototype.a2.call(this, a, b);
        var c = new DataTemplatePassInfo();
        c.isHitTestRender = b;
        c.context = a.g();
        c.viewportTop = this.br.top;
        c.viewportLeft = this.br.left;
        c.viewportWidth = this.br.width;
        c.viewportHeight = this.br.height;
        c.passID = "Markers";
        var d = new DataTemplateRenderInfo();
        d.passInfo = c;
        d.isHitTestRender = b;
        var e = new DataTemplateMeasureInfo();
        e.passInfo = c;
        var f = false;
        var g = a.g();
        e.context = g;
        d.context = g;
        var h = 0;
        var i = 0;
        if (this.c6.nw != null && this.c6.nw.passStarting != null) {
            this.c6.nw.passStarting(c);
        }
        for (var j = 0; j < this.c9.count; j++) {
            var k = this.c9._inner[j];
            if (k._visibility == 1) {
                continue;
            }
            this.bd(k, j, b);
            if (!f) {
                e.width = k.width;
                e.height = k.height;
                e.renderOffsetX = 0;
                e.renderOffsetY = 0;
                e.renderContext = a;
                var l = k.ah;
                if (l.measure != null) {
                    e.data = k.content;
                    l.measure(e);
                    f = e.isConstant;
                    if (f) {
                        h = e.width;
                        i = e.height;
                    }
                }
                d.availableWidth = e.width;
                d.availableHeight = e.height;
                d.renderOffsetX = e.renderOffsetX;
                d.renderOffsetY = e.renderOffsetY;
                d.renderContext = a;
            }
            else {
                d.availableWidth = h;
                d.availableHeight = i;
            }
            if (!isNaN_(k.width) && !isInfinity(k.width)) {
                d.availableWidth = k.width;
            }
            if (!isNaN_(k.height) && !isInfinity(k.height)) {
                d.availableHeight = k.height;
            }
            a.p(d, k);
            k.m = d.availableWidth;
            k.l = d.availableHeight;
            k.ai = d.renderOffsetX;
            k.aj = d.renderOffsetY;
        }
        if (this.c6.nw != null && this.c6.nw.passCompleted != null) {
            this.c6.nw.passCompleted(c);
        }
    };
    ScatterPolygonSeriesView.prototype.dd = function () {
        this.c6.nw = null;
        this.c6.nw = this.c6.nx;
    };
    ScatterPolygonSeriesView.prototype.db = function () {
        this.c6.n9 = null;
        this.c6.n9 = this.c6.ob;
    };
    ScatterPolygonSeriesView.prototype.dc = function () {
        this.c6.oa = null;
        this.c6.oa = this.c6.oc;
    };
    ScatterPolygonSeriesView.prototype.da = function (a) {
        switch (a) {
            case "CircleMarkerTemplate":
                this.c6.nw = this.c6.bs.kn;
                break;
            case "TriangleMarkerTemplate":
                this.c6.nw = this.c6.bs.kw;
                break;
            case "PyramidMarkerTemplate":
                this.c6.nw = this.c6.bs.kt;
                break;
            case "SquareMarkerTemplate":
                this.c6.nw = this.c6.bs.ku;
                break;
            case "DiamondMarkerTemplate":
                this.c6.nw = this.c6.bs.ko;
                break;
            case "PentagonMarkerTemplate":
                this.c6.nw = this.c6.bs.kr;
                break;
            case "HexagonMarkerTemplate":
                this.c6.nw = this.c6.bs.kp;
                break;
            case "TetragramMarkerTemplate":
                this.c6.nw = this.c6.bs.kr;
                break;
            case "PentagramMarkerTemplate":
                this.c6.nw = this.c6.bs.ks;
                break;
            case "HexagramMarkerTemplate":
                this.c6.nw = this.c6.bs.kq;
                break;
        }
    };
    ScatterPolygonSeriesView.prototype.df = function () {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(this.c9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ah = this.c6.nw;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.an();
    };
    ScatterPolygonSeriesView.prototype.dn = function (a) {
        if (this.dm == null) {
            this.dm = new DataTemplateMeasureInfo();
            this.dm.context = this.h.g();
        }
        this.dm.width = a.width;
        this.dm.height = a.height;
        this.dm.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.dm);
        }
        return new Size(1, this.dm.width, this.dm.height);
    };
    ScatterPolygonSeriesView.prototype.c2 = function (a) {
        var b;
        var c;
        var d;
        var e;
        for (var f = this.c9.count - 1; f >= 0; f--) {
            var g = this.c9._inner[f];
            if (g._visibility == 1 || g._opacity == 0) {
                continue;
            }
            b = (g.m / 2) + 3;
            c = (g.l / 2) + 3;
            d = g.ai;
            e = g.aj;
            if ((g.n + d) - b <= a.x && (g.n + d) + b >= a.x && (g.o + e) - c <= a.y && (g.o + e) + c >= a.y) {
                return g;
            }
        }
        return null;
    };
    ScatterPolygonSeriesView.prototype.ai = function (a) {
        var e_5, _a;
        var b = a;
        _super.prototype.ai.call(this, b);
        try {
            for (var _b = __values(fromEnum(this.c7.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = this.c7.item(c);
                if (d._visibility != 1) {
                    var e = typeCast(ScatterPolygonSeries.$, this.e);
                    var f = this.e.a2.getMarkerVisualData(e, d, e.nw);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.c6.fx + "</span><br/>";
        a += "</div>";
        return a;
    };
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
}(ShapeSeriesViewBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Series class which renders polygons as Paths based on lists of points in the ItemsSource.
*/
var IgrScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterPolygonSeries, _super);
    function IgrScatterPolygonSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterPolygonSeries.prototype.createImplementation = function () {
        return new ScatterPolygonSeries();
    };
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "hasMarkers", {
        /**
         * Returns whether the current series supports visual markers.
        */
        get: function () {
            return this.i.hasMarkers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "shapeStyle", {
        /**
         * The default style to apply to all Shapes in the series.
        */
        get: function () {
            if (this.i.of == null) {
                return null;
            }
            if (!this.i.of.externalObject) {
                var e = new IgrStyle();
                e._implementation = this.i.of;
                this.i.of.externalObject = e;
            }
            return this.i.of.externalObject;
        },
        set: function (v) {
            v == null ? this.i.of = null : this.i.of = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "markerType", {
        /**
         * Gets or sets the marker type for the current series object.
         * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
        */
        get: function () {
            return this.i.nd;
        },
        set: function (v) {
            this.i.nd = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "markerTemplate", {
        /**
         * Gets or sets the MarkerTemplate for the current series object.
        */
        get: function () {
            return this.i.nx;
        },
        set: function (v) {
            this.i.nx = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "actualMarkerTemplate", {
        /**
         * Gets the effective marker template for the current series object.
        */
        get: function () {
            return this.i.nw;
        },
        set: function (v) {
            this.i.nw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "markerBrush", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
        */
        get: function () {
            return brushToString(this.i.ob);
        },
        set: function (v) {
            this.i.ob = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "actualMarkerBrush", {
        /**
         * Gets the effective marker brush for the current series object.
        */
        get: function () {
            return brushToString(this.i.n9);
        },
        set: function (v) {
            this.i.n9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "markerOutline", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
        */
        get: function () {
            return brushToString(this.i.oc);
        },
        set: function (v) {
            this.i.oc = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "actualMarkerOutline", {
        /**
         * Gets the effective marker outline for the current series object.
        */
        get: function () {
            return brushToString(this.i.oa);
        },
        set: function (v) {
            this.i.oa = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolygonSeries.prototype, "markerCollisionAvoidance", {
        /**
         * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
        */
        get: function () {
            return this.i.nc;
        },
        set: function (v) {
            this.i.nc = ensureEnum(CollisionAvoidanceType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterPolygonSeries;
}(IgrShapeSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterPolygonSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterPolygonSeriesModule() {
    }
    IgrScatterPolygonSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterPolygonSeries", IgrScatterPolygonSeries);
        TypeRegistrar.register("ScatterPolygonSeries", ScatterPolygonSeries.$type);
    };
    return IgrScatterPolygonSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScatterPolylineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolylineSeries, _super);
    function ScatterPolylineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = ScatterPolylineSeries.$;
        return _this;
    }
    ScatterPolylineSeries.prototype.bf = function () {
        return new ScatterPolylineSeriesView(this);
    };
    ScatterPolylineSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.na = a;
    };
    ScatterPolylineSeries.prototype.get_mf = function () {
        return false;
    };
    ScatterPolylineSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case ScatterPolylineSeries.$$p[0]:
                this.na.cn(this.ng);
                this.jd(false);
                this.ik();
                break;
            case ScatterPolylineSeries.$$p[1]:
                this.na.co(this.nb);
                this.jd(false);
                this.ik();
                break;
        }
    };
    ScatterPolylineSeries.prototype.mz = function (a) {
        var b = a;
        b.cn(this.ng);
        b.co(this.nb);
        _super.prototype.mz.call(this, a);
    };
    ScatterPolylineSeries.prototype.ar = function (a, b) {
        var c = this.na.cs(a, b, true);
        if (c != null) {
            return c.dataContext;
        }
        return _super.prototype.ar.call(this, a, b);
    };
    ScatterPolylineSeries.$t = markType(ScatterPolylineSeries, 'ScatterPolylineSeries', ShapeSeriesBase.$);
    ScatterPolylineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolylineSeries, 'raisePropertyChanged', ['ShapeStyle:ng:ne', [Style.$, null], 'ShapeStyleSelector:nb:nf', [StyleSelector.$, null]]);
    return ScatterPolylineSeries;
}(ShapeSeriesBase));
/**
 * @hidden
 */
var ScatterPolylineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolylineSeriesView, _super);
    function ScatterPolylineSeriesView(a) {
        return _super.call(this, a) || this;
    }
    ScatterPolylineSeriesView.prototype.cu = function (a, b) {
        return this.cv(a, b, false);
    };
    ScatterPolylineSeriesView.prototype.cc = function (a, b) {
        _super.prototype.cc.call(this, a, b);
        ShapeSeriesViewBase.cb(this, a, b);
    };
    ScatterPolylineSeriesView.prototype.ca = function (a, b) {
        var c = typeCast(Path.$, a);
        if (c == null) {
            return;
        }
        c.ak = b;
    };
    ScatterPolylineSeriesView.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._fill = null;
    };
    ScatterPolylineSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        c._fill = null;
    };
    ScatterPolylineSeriesView.prototype.b2 = function (a) {
        return a.width >= this.by.mo || a.height >= this.by.mo;
    };
    ScatterPolylineSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.by.fx + "</span><br/>";
        a += "</div>";
        return a;
    };
    ScatterPolylineSeriesView.$t = markType(ScatterPolylineSeriesView, 'ScatterPolylineSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolylineSeriesView;
}(ShapeSeriesViewBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
var IgrScatterPolylineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScatterPolylineSeries, _super);
    function IgrScatterPolylineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrScatterPolylineSeries.prototype.createImplementation = function () {
        return new ScatterPolylineSeries();
    };
    Object.defineProperty(IgrScatterPolylineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrScatterPolylineSeries.prototype, "shapeStyle", {
        /**
         * The default style to apply to all Shapes in the series.
        */
        get: function () {
            if (this.i.ng == null) {
                return null;
            }
            if (!this.i.ng.externalObject) {
                var e = new IgrStyle();
                e._implementation = this.i.ng;
                this.i.ng.externalObject = e;
            }
            return this.i.ng.externalObject;
        },
        set: function (v) {
            v == null ? this.i.ng = null : this.i.ng = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrScatterPolylineSeries;
}(IgrShapeSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScatterPolylineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScatterPolylineSeriesModule() {
    }
    IgrScatterPolylineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrScatterPolylineSeries", IgrScatterPolylineSeries);
        TypeRegistrar.register("ScatterPolylineSeries", ScatterPolylineSeries.$type);
    };
    return IgrScatterPolylineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartShapeModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartShapeModule() {
    }
    IgrDataChartShapeModule.register = function () {
        IgrScatterAreaSeriesModule.register();
        IgrScatterContourSeriesModule.register();
        IgrScatterPolygonSeriesModule.register();
        IgrScatterPolylineSeriesModule.register();
        IgrDataChartShapeCoreModule.register();
    };
    return IgrDataChartShapeModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryYAxis, _super);
    function CategoryYAxis() {
        var _this = _super.call(this) || this;
        _this.ky = 0;
        _this.k0 = 0;
        _this.k6 = 1;
        _this.k5 = 1;
        _this.jm = new List$1(Number_$type, 0);
        _this.ab = CategoryYAxis.$;
        return _this;
    }
    CategoryYAxis.prototype.a1 = function () {
        return new CategoryYAxisView(this);
    };
    CategoryYAxis.prototype.gs = function (a) {
        _super.prototype.gs.call(this, a);
        this.kx = a;
    };
    CategoryYAxis.prototype.get_cf = function () {
        return true;
    };
    CategoryYAxis.prototype.dv = function () {
        return this.i1.height;
    };
    CategoryYAxis.prototype.ku = function (a, b, c) {
        return this.kv(a, b, c, true);
    };
    CategoryYAxis.prototype.kw = function (a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    };
    CategoryYAxis.prototype.gm = function (a, b, c, d, e) {
        var f;
        var g = e.e;
        var h = e.d;
        var i = e.c;
        var j = e.a;
        var k = !i.isEmpty;
        var l = this.categoryMode == 0 ? this.jy - 1 : this.jy;
        if (l < 0) {
            l = 0;
        }
        var m = i.top;
        var n = i.height;
        var o = g.top;
        var p = g.height;
        var q = h.top;
        var r = h.height;
        var s = 0;
        var t = 1;
        var u = this.kw(a);
        var v = false;
        if (u != null) {
            v = true;
        }
        var w;
        for (var x = 0; x < b.count; x++) {
            w = b.item(x);
            for (var y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    var z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    var aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    var ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    };
    Object.defineProperty(CategoryYAxis.prototype, "k3", {
        get: function () {
            return this.c(CategoryYAxis.lf);
        },
        set: function (a) {
            this.h(CategoryYAxis.lf, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "kz", {
        get: function () {
            return this.ky;
        },
        set: function (a) {
            if (this.kz != a) {
                var b = this.ky;
                this.ky = a;
                this.g0("ActualInterval", b, this.kz);
            }
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.d7 = function () {
        return this.kz;
    };
    Object.defineProperty(CategoryYAxis.prototype, "k4", {
        get: function () {
            return this.c(CategoryYAxis.lg);
        },
        set: function (a) {
            this.h(CategoryYAxis.lg, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "k1", {
        get: function () {
            return this.k0;
        },
        set: function (a) {
            if (this.k1 != a) {
                var b = this.k0;
                this.k0 = a;
                this.g0("ActualMinorInterval", b, this.k1);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "k8", {
        get: function () {
            return this.k6;
        },
        set: function (a) {
            this.k6 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "k7", {
        get: function () {
            return this.k5;
        },
        set: function (a) {
            this.k5 = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.dw = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.k2(a, NumericScaler.ac, b.c);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.k2(a, b.e, b.d);
    };
    CategoryYAxis.prototype.k2 = function (a, b, c) {
        var d = this.categoryMode == 0 ? this.jy - 1 : this.jy;
        if (d < 0) {
            d = 0;
        }
        var e = d >= 1 ? (a) / (d) : d == 0 ? 0.5 : NaN;
        if (!this.b9) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    };
    CategoryYAxis.prototype.dz = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    CategoryYAxis.prototype.d0 = function (a, b, c) {
        if (!b.c.isEmpty) {
            var d = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            d = (d * b.d.height) + b.d.top;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    };
    CategoryYAxis.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.top + (a - c.top) * b.height / c.height;
        if (!this.b9) {
            e = 1 - e;
        }
        var f = d == 0 ? this.jy - 1 : this.jy;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    };
    CategoryYAxis.prototype.le = function (a, b) {
        if (a == NaN || b == NaN || this.jf == null || this.jf.count == 0) {
            return;
        }
        var c = a / this.jf.count;
        var d = b / this.jf.count;
        this.bf.m4 = new Rect(0, this.bf.m4.x, 1 - d, this.bf.m4.width, d - c);
    };
    CategoryYAxis.prototype.as = function () {
        return new VerticalAxisLabelPanel();
    };
    CategoryYAxis.prototype.dj = function () {
        return this.k3;
    };
    CategoryYAxis.prototype.getCategorySize = function (a, b, c) {
        var d = this.iz(b, c);
        return d.height / (this.jy * a.height);
    };
    CategoryYAxis.prototype.jr = function (a, b, c) {
        var d = 0;
        if (!isNaN_(this.jo)) {
            d = MathUtil.b(this.jo, 0, 1);
        }
        var e = 0;
        if (!isNaN_(this.jv)) {
            e = Math.min(this.jv, 1);
        }
        var f = 1 - 0.5 * d;
        var g = this.getCategorySize(a, b, c) * f / (this.j1 - (this.j1 - 1) * e);
        return g;
    };
    CategoryYAxis.prototype.getGroupCenter = function (a, b, c, d) {
        var e = 0.5;
        if (this.j1 > 1) {
            var f = 0;
            if (!isNaN_(this.jo)) {
                f = MathUtil.b(this.jo, 0, 1);
            }
            var g = 0;
            if (!isNaN_(this.jv)) {
                g = Math.min(this.jv, 1);
            }
            var h = 1 - 0.5 * f;
            var i = h / (this.j1 - (this.j1 - 1) * g);
            var j = (h - i) / (this.j1 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    };
    CategoryYAxis.prototype.ld = function (a) {
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        b = b.copy();
        var c = this.i1;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.iy();
        var f = new ScalerParams(0, d, d, this.b8, e);
        var g = !b.isEmpty && !c.isEmpty && this.jf != null ? this.jf.indexOf(a) : -1;
        var h = g > -1 ? this.dw(g, f) : NaN;
        if (!isNaN_(h) && this.bf.c0) {
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            this.bf.km(b, false, true);
        }
    };
    CategoryYAxis.prototype.cn = function () {
        if (this.cg && this.co) {
            this.a9 = this.a8();
        }
        if (this.jf == null) {
            return false;
        }
        var a = this.jf.count;
        if (a != this.k7) {
            var b = new AxisRangeChangedEventArgs(0, 1, 1, this.k7, a);
            this.k7 = a;
            this.g1(b);
            return true;
        }
        return false;
    };
    CategoryYAxis.prototype.ji = function (a) {
        if (a == null) {
            return false;
        }
        var b = this.bb();
        if (b == null) {
            return false;
        }
        return b.synchronizeVertically;
    };
    CategoryYAxis.prototype.g7 = function (a) {
        _super.prototype.g7.call(this, a);
        var b = this.bf != null ? this.bf.mq : Rect.empty;
        var c = this.i1;
        var d = this.iw();
        var e = this.iv();
        var f = new ScalerParams(0, b, c, this.b8, d);
        var g = this.a2.ay();
        var h = this.a2.a1();
        var i = this.a2.az();
        var j = this.a2.a0();
        var k = this.a2.e();
        var l = this.a2.f();
        var m = this.a2.g();
        this.he();
        this.gi(g);
        this.gi(h);
        this.gi(i);
        this.gi(j);
        this.cv.clear();
        this.cw.clear();
        this.jm.clear();
        this.a2.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
        }
        if (this.bo.count == 0 && this.bn.count == 0) {
            this.a2.y();
        }
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        if (this.itemsSource == null || this.jf == null || this.jf.count == 0) {
            this.bo.count = 0;
            this.bn.count = 0;
            this.bm.count = 0;
            this.a2.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            var n = this.dz(e.top, f);
            var o = this.dz(e.bottom, f);
            if (!this.b8) {
                n = Math.ceil(n);
                o = Math.floor(o);
            }
            else {
                n = Math.floor(n);
                o = Math.ceil(o);
            }
            var p = c.left;
            var q = 0;
            if (this.ag != null) {
                var r = typeCast(NumericXAxis.$, this.ag);
                if (r != null) {
                    var s = this.ha(p, q, b, c, d, c.left, c.right);
                    p = s.p0;
                    q = s.p1;
                }
            }
            this.hf(g, p, c, k, true);
            this.a2.ao(q);
            var t = Math.min(n, o);
            var u = Math.max(n, o);
            var v = new LinearCategorySnapper(1, t, u, e.height, this.k3, this.categoryMode, this.d9());
            var w = Math.floor((t - 0) / v.g);
            var x = Math.ceil((u - 0) / v.g);
            if (!isNaN_(w) && !isNaN_(x)) {
                var y = truncate(w);
                var z = truncate(x);
                var aa = this.dw(0 + y * v.g, f);
                var ab = Math.abs(this.dw(v.g, f) - this.dw(0, f));
                this.at.bn = this.dw(v.g, f);
                for (var ac = y; ac <= z; ++ac) {
                    var ad = this.dw(0 + (ac + 1) * v.g, f);
                    if (aa <= e.bottom) {
                        if (ac % 2 == 0) {
                            this.gr(h, aa, ad, c);
                        }
                        this.gq(i, aa, c, l, false);
                        this.jm.add(aa);
                    }
                    if (this.categoryMode != 0 && this.j1 != 0 && this.cj) {
                        if (this.k4 > 0 && this.k4 < v.g) {
                            var ae = ab * this.k4;
                            if (!this.b8) {
                                var af = aa;
                                while (af - ae > ad) {
                                    af -= ae;
                                    if (Math.abs(af - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gq(j, af, c, m, false);
                                }
                            }
                            else {
                                var ag = aa;
                                while (ag + ae < ad) {
                                    ag += ae;
                                    if (Math.abs(ag - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gq(j, ag, c, m, false);
                                }
                            }
                            this.k1 = this.k4;
                        }
                        else {
                            for (var ah = 0; ah < truncate(v.g); ah++) {
                                for (var ai = 0; ai < this.j1; ai++) {
                                    var aj = this.getGroupCenter(ai, b, c, d);
                                    if (!this.b8) {
                                        aj = -aj;
                                    }
                                    var ak = this.dw(ah + ac * v.g, f) + aj;
                                    this.gq(j, ak, c, m, false);
                                }
                            }
                            this.k1 = 0.5;
                        }
                    }
                    var al = aa;
                    if (this.categoryMode != 0) {
                        var am = this.dw(ac * v.g + 1, f);
                        al = (aa + am) / 2;
                    }
                    if (al <= e.bottom && al >= e.top) {
                        var an = 0;
                        if (v.g >= 1) {
                            an = ac * truncate(Math.floor(v.g));
                        }
                        else {
                            if ((ac * v.g) * 2 % 2 == 0) {
                                an = truncate(Math.floor(ac * v.g));
                            }
                            else {
                                an = -1;
                            }
                        }
                        if (this.jf != null && an < this.jf.count && an >= 0) {
                            var ao = this.jf.item(an);
                            var ap = this.e6(ao);
                            if (!isNaN_(al) && !isInfinity(al) && ap != null) {
                                if ((typeof ap === 'string') && Base.equalsStatic(ap, "")) {
                                }
                                else {
                                    this.cv.add1(ap);
                                    this.cw.add(new LabelPosition(al));
                                }
                            }
                        }
                    }
                    aa = ad;
                }
            }
            this.kz = v.g;
            if ((this.aw == null || this.aw.visibility == 0) && this.ag != null) {
                if (this.aw != null && (this.aw.location == 6 || this.aw.location == 7)) {
                    this.bf.ht();
                }
            }
            this.a2.au(this.cv, this.cw);
            this.km();
        }
    };
    CategoryYAxis.prototype.get_az = function () {
        return 1;
    };
    Object.defineProperty(CategoryYAxis.prototype, "az", {
        get: function () {
            return this.get_az();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategoryYAxis.prototype, "isVertical", {
        get: function () {
            return this.cf;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.prototype.j$c = function (a, b) {
        return this.dz.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$b = function (a, b) {
        return this.dw.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$d = function (a, b, c, d, e) {
        this.gm.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$e = function (a, b, c, d) {
        this.gn.apply(this, arguments);
    };
    CategoryYAxis.prototype.j$f = function (a, b, c, d) {
        this.go.apply(this, arguments);
    };
    Object.defineProperty(CategoryYAxis.prototype, "j$a", {
        get: function () {
            return this.b8;
        },
        enumerable: true,
        configurable: true
    });
    CategoryYAxis.$t = markType(CategoryYAxis, 'CategoryYAxis', CategoryAxisBase.$);
    CategoryYAxis.lf = DependencyProperty.i("Interval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        a.g0("Interval", b.oldValue, b.newValue);
        a.g6(false);
    }));
    CategoryYAxis.lg = DependencyProperty.i("MinorInterval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, function (a, b) {
        (typeCast(CategoryYAxis.$, a)).g0("MinorInterval", b.oldValue, b.newValue);
        (typeCast(CategoryYAxis.$, a)).g6(false);
    }));
    return CategoryYAxis;
}(CategoryAxisBase));
/**
 * @hidden
 */
var CategoryYAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryYAxisView, _super);
    function CategoryYAxisView(a) {
        var _this = _super.call(this, a) || this;
        _this.bg = null;
        _this.bg = a;
        return _this;
    }
    CategoryYAxisView.$t = markType(CategoryYAxisView, 'CategoryYAxisView', CategoryAxisBaseView.$);
    return CategoryYAxisView;
}(CategoryAxisBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent category Y axis.
*/
var IgrCategoryYAxis = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCategoryYAxis, _super);
    function IgrCategoryYAxis(props) {
        return _super.call(this, props) || this;
    }
    IgrCategoryYAxis.prototype.createImplementation = function () {
        return new CategoryYAxis();
    };
    Object.defineProperty(IgrCategoryYAxis.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryYAxis.prototype, "isVertical", {
        /**
         * Gets if the current axis is a vertical axis.
        */
        get: function () {
            return this.i.cf;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryYAxis.prototype, "interval", {
        /**
         * Gets or sets the frequency of displayed labels.
         * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
        */
        get: function () {
            return this.i.k3;
        },
        set: function (v) {
            this.i.k3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryYAxis.prototype, "actualInterval", {
        /**
         * Gets the effective value for the current Interval.
        */
        get: function () {
            return this.i.kz;
        },
        set: function (v) {
            this.i.kz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryYAxis.prototype, "minorInterval", {
        /**
         * Gets or sets the frequency of displayed minor lines.
         * The set value is a factor that determines how the minor lines will be displayed.
        */
        get: function () {
            return this.i.k4;
        },
        set: function (v) {
            this.i.k4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCategoryYAxis.prototype, "actualMinorInterval", {
        /**
         * Gets the effective value for the current MinorInterval.
        */
        get: function () {
            return this.i.k1;
        },
        set: function (v) {
            this.i.k1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrCategoryYAxis.prototype.getCategoryBoundingBox = function (point, useInterpolation, singularWidth) {
        var iv = this.i.ku(toPoint(point), useInterpolation, singularWidth);
        return fromRect(iv);
    };
    IgrCategoryYAxis.prototype.scrollRangeIntoView = function (minimum, maximum) {
        this.i.le(minimum, maximum);
    };
    /**
     * Scrolls the specified item into view.
    
    * @param item  * Data item to scroll into view
    */
    IgrCategoryYAxis.prototype.scrollIntoView = function (item) {
        this.i.ld(item);
    };
    return IgrCategoryYAxis;
}(IgrCategoryAxisBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCategoryYAxisModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCategoryYAxisModule() {
    }
    IgrCategoryYAxisModule.register = function () {
        TypeRegistrar.registerCons("IgrCategoryYAxis", IgrCategoryYAxis);
        TypeRegistrar.register("CategoryYAxis", CategoryYAxis.$type);
    };
    return IgrCategoryYAxisModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartVerticalCategoryCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartVerticalCategoryCoreModule() {
    }
    IgrDataChartVerticalCategoryCoreModule.register = function () {
        IgrNumericXAxisModule.register();
        IgrCategoryYAxisModule.register();
        IgrDataChartCoreModule.register();
    };
    return IgrDataChartVerticalCategoryCoreModule;
}());

/**
 * Represents a vertically laid out category based series.
*/
var IgrVerticalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrVerticalAnchoredCategorySeries, _super);
    function IgrVerticalAnchoredCategorySeries(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current CategorySeries object.
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current CategorySeries object.
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrCategoryYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalAnchoredCategorySeries.prototype, "isVertical", {
        /**
         * Gets whether or not the current series is vertical series
        */
        get: function () {
            return this.i.isVertical;
        },
        enumerable: true,
        configurable: true
    });
    IgrVerticalAnchoredCategorySeries.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrVerticalAnchoredCategorySeries.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrVerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrVerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgrVerticalAnchoredCategorySeries.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgrVerticalAnchoredCategorySeries.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    IgrVerticalAnchoredCategorySeries.prototype.getSeriesValueMarkerBoundingBox = function (world) {
        var iv = this.i.lw(toPoint(world));
        return fromRect(iv);
    };
    IgrVerticalAnchoredCategorySeries.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgrVerticalAnchoredCategorySeries.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ll(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    IgrVerticalAnchoredCategorySeries.prototype.getExactItemIndex = function (world) {
        var iv = this.i.eb(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    IgrVerticalAnchoredCategorySeries.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrVerticalAnchoredCategorySeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrVerticalAnchoredCategorySeries.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.p3(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrVerticalAnchoredCategorySeries.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.p2(axis);
        return (iv);
    };
    return IgrVerticalAnchoredCategorySeries;
}(IgrAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VerticalAnchoredCategorySeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAnchoredCategorySeries, _super);
    function VerticalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.pz = null;
        return _this;
    }
    VerticalAnchoredCategorySeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "p0", {
        get: function () {
            var _this = this;
            if (this.pz == null) {
                this.pz = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.pz;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
        return true;
    };
    VerticalAnchoredCategorySeries.prototype.m6 = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.nq = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.nb.r(this.m6(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.m6(), runOn(this, this.n5), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.d9 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.n5));
    };
    VerticalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    VerticalAnchoredCategorySeries.prototype.lw = function (a) {
        if (!this.hasMarkers || !this.l3()) {
            return Rect.empty;
        }
        return this.p0.e$b(this, this.m7.m, a, runOn(this, this.p8));
    };
    VerticalAnchoredCategorySeries.prototype.p8 = function (a) {
        return this.oy.c5(a);
    };
    VerticalAnchoredCategorySeries.prototype.dh = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.en = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.m6();
        var f = new ScalerParams(0, this.bs.mq, this.bi.br, e.b8, d);
        var g = this.nb.r(e, this.bs.mq, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.n5), b, c);
    };
    VerticalAnchoredCategorySeries.prototype.ll = function (a, b, c) {
        var d = this.m6();
        return this.ln(a, b, c, this.nb.r(d, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.nq(), d, null, null, null);
    };
    VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.pg = function (a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.ph = function (a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.n1 = function () {
        return this.xAxis != null && this.xAxis.cl();
    };
    VerticalAnchoredCategorySeries.prototype.m0 = function (a, b) {
        return this.ov(a, b, this.yAxis);
    };
    VerticalAnchoredCategorySeries.prototype.eb = function (a) {
        return this.p0.e$a(this, a);
    };
    VerticalAnchoredCategorySeries.prototype.n5 = function (a) {
        return this.ed(a, this.m6());
    };
    VerticalAnchoredCategorySeries.prototype.e8 = function (a) {
        return truncate(Math.round(this.eb(a)));
    };
    VerticalAnchoredCategorySeries.prototype.fp = function (a) {
        var b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    VerticalAnchoredCategorySeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                    this.ik();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.n1();
                    this.jd(false);
                    this.ik();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.oy.cy = CategoryTrendLineManagerFactory.a(this.oy.cy, this.yAxis, this.jx, this, this.b2);
                }
                break;
        }
    };
    VerticalAnchoredCategorySeries.prototype.p3 = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.p2 = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::p6', [NumericXAxis.$, null], 'YAxis::p7', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
}(AnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IBarSeries_$type = /*@__PURE__*/ new Type(null, 'IBarSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BarFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarFramePreparer, _super);
    function BarFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    BarFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[1];
        var h = b[0];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    BarFramePreparer.prototype.w = function (a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        var d = a.k;
        var e = new ScalerParams(0, a.m, a.l, a.b.j$a, d);
        var f = new ScalerParams(0, a.m, a.l, a.c.j$a, d);
        var g = b.f;
        if (a.d != null && a.d.i$b != null) {
            g = new SafeSortedReadOnlyDoubleCollection(0, g, a.d.i$b);
        }
        var h = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = a.h;
            $ret.d = a.i;
            $ret.e = a.j;
            $ret.a = c;
            $ret.b = a.g;
            $ret.f = a.l;
            return $ret;
        })());
        if (this.aa.trendLineType != 0) {
            this.aa.trendlinePreparer.prepareLineCore(a.a.p, this.aa.trendLineType, g, this.aa.trendLinePeriod, function (i) { return a.c.j$b(i, f); }, function (i) { return a.b.j$b(i, e); }, h);
        }
    };
    BarFramePreparer.$t = markType(BarFramePreparer, 'BarFramePreparer', CategoryFramePreparer.$);
    return BarFramePreparer;
}(CategoryFramePreparer));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BarTrendFitCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarTrendFitCalculator, _super);
    function BarTrendFitCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BarTrendFitCalculator.a = function (a, b, c, d, e, f, g, h, i, j, k) {
        if (d == null) {
            switch (b) {
                case 1:
                    d = LeastSquaresFit.k(e, g, f);
                    break;
                case 2:
                    d = LeastSquaresFit.o(e, g, f);
                    break;
                case 3:
                    d = LeastSquaresFit.i(e, g, f);
                    break;
                case 4:
                    d = LeastSquaresFit.p(e, g, f);
                    break;
                case 5:
                    d = LeastSquaresFit.q(e, g, f);
                    break;
                case 7:
                    d = LeastSquaresFit.j(e, g, f);
                    break;
                case 6:
                    d = LeastSquaresFit.l(e, g, f);
                    break;
                case 8:
                    d = LeastSquaresFit.n(e, g, f);
                    break;
                default: throw new NotImplementedException(0);
            }
        }
        if (d == null) {
            return null;
        }
        for (var l = 0; l < c.f.height; l += 2) {
            var m = l / (c.f.height - 1);
            var n = j + m * (k - j);
            var o = NaN;
            switch (b) {
                case 1:
                    o = LeastSquaresFit.ad(d, n);
                    break;
                case 2:
                    o = LeastSquaresFit.ah(d, n);
                    break;
                case 3:
                    o = LeastSquaresFit.ab(d, n);
                    break;
                case 4:
                    o = LeastSquaresFit.ai(d, n);
                    break;
                case 5:
                    o = LeastSquaresFit.aj(d, n);
                    break;
                case 7:
                    o = LeastSquaresFit.ac(d, n);
                    break;
                case 6:
                    o = LeastSquaresFit.ae(d, n);
                    break;
                case 8:
                    o = LeastSquaresFit.ag(d, n);
                    break;
                default: throw new NotImplementedException(0);
            }
            o = h(o);
            n = i(n);
            if (!isNaN_(o) && !isInfinity(o)) {
                a.add({ $type: Point_$type, x: o, y: n + c.a });
            }
        }
        return d;
    };
    BarTrendFitCalculator.$t = markType(BarTrendFitCalculator, 'BarTrendFitCalculator');
    return BarTrendFitCalculator;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BarTrendLineManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarTrendLineManager, _super);
    function BarTrendLineManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BarTrendLineManager.prototype.prepareLineCore = function (a, b, c, d, e, f, g) {
        var h = g.d * g.c;
        var i = g.e * g.c;
        var j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = BarTrendFitCalculator.a(j, b, g, this.a, c.count, function (k) { return c.item(k); }, function (k) { return k + 1; }, e, function (k) { return f(k - 1); }, h + 1, i + 1);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (var k = g.d; k <= g.e; k += 1) {
                var l = k * g.c;
                if (l >= 0 && l < this.d.count) {
                    var m = e(this.d._inner[l]);
                    var n = f(l);
                    j.add({ $type: Point_$type, x: m, y: n + g.a });
                }
            }
        }
        this.m(j, g, a);
    };
    BarTrendLineManager.$t = markType(BarTrendLineManager, 'BarTrendLineManager', CategoryTrendLineManager.$);
    return BarTrendLineManager;
}(CategoryTrendLineManager));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarSeries, _super);
    function BarSeries() {
        var _this = _super.call(this) || this;
        _this.ab = BarSeries.$;
        _this.nb = new BarFramePreparer(1, _this, _this.p9, _this, _this, _this.p9.cn);
        return _this;
    }
    BarSeries.prototype.bf = function () {
        return new BarSeriesView(this);
    };
    BarSeries.prototype.ng = function () {
        return 1;
    };
    BarSeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    BarSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.p9 = a;
    };
    BarSeries.prototype.get_nv = function () {
        return true;
    };
    BarSeries.prototype.lu = function (a) {
        if (this.xAxis == null || this.yAxis == null || this.m7.f.count == 0) {
            return Rect.empty;
        }
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, b, c, this.xAxis.b8, d);
        var f = this.lg(a);
        var g = this.fe(a, true);
        var h = this.fc(a, true);
        var i = truncate(Math.floor(g / this.n7(this.bi)));
        var j = truncate(Math.floor(h / this.n7(this.bi)));
        var k = i - this.n8(this.bi);
        var l = j - this.n8(this.bi);
        if (k < 0) {
            k = 0;
        }
        if (k > this.m7.f.count - 1) {
            k = this.m7.f.count - 1;
        }
        if (l < 0) {
            l = 0;
        }
        if (l > this.m7.f.count - 1) {
            l = this.m7.f.count - 1;
        }
        var m = this.m7.f._inner[k];
        var n = this.m7.f._inner[l];
        var o = Math.abs(f.y - m[0]);
        var p = Math.abs(f.y - n[0]);
        var q = this.o7(this.nf);
        var r = this.yAxis.jr(b, c, d);
        if (o < p) {
            var s = m[0] - 0.5 * r;
            var t = m[1];
            var u = q;
            return new Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
        }
        else {
            var v = n[0] - 0.5 * r;
            var w = n[1];
            var x = q;
            return new Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
        }
    };
    BarSeries.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    BarSeries.prototype.nc = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), b, this, b.cn);
            }
            else {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.bs.bn.m, this, b.cn);
            }
        }
        else {
            return this.nb;
        }
    };
    BarSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
    };
    BarSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    BarSeries.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = typeCast(BarSeriesView.$, b);
        if (a && c != null && c.c7 != null) {
            c.c7.count = 0;
        }
    };
    BarSeries.prototype.n9 = function () {
        var e_1, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(IBarSeries_$type, b);
                if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                    a++;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return -1;
    };
    BarSeries.prototype.o7 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(a);
        if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
            var f = new ScalerParams(0, c, d, this.xAxis.b8, e);
            b = this.xAxis.dw(this.xAxis.ke, f);
        }
        return b;
    };
    BarSeries.prototype.an = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.xAxis) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    BarSeries.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        var f = this.ls(this.bi);
        var g = new ScalerParams(0, d, d, this.xAxis.b8, f);
        var h = new ScalerParams(0, d, d, this.yAxis.b8, f);
        var i = this.yAxis != null ? this.yAxis.dw(e, h) : NaN;
        var j = this.yAxis != null ? this.nb.r(this.yAxis, d, d, f) : 0;
        i += j;
        var k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.dw(this.valueColumn.item(e), g) : NaN;
        if (!isNaN_(k)) {
            if (k < b.left + 0.1 * b.width) {
                k = k + 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
            if (k > b.right - 0.1 * b.width) {
                k = k - 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
        }
        if (!isNaN_(i)) {
            if (i < b.top + 0.1 * b.height) {
                i = i + 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
            if (i > b.bottom - 0.1 * b.height) {
                i = i - 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return e >= 0;
    };
    BarSeries.prototype.eg = function () {
        return this.yAxis.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    BarSeries.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = a.f;
        if (!b.l()) {
            return;
        }
        var d = b.bs;
        var e = b.br;
        var f = this.getEffectiveViewport1(b);
        var g = new ScalerParams(0, d, e, this.xAxis.b8, f);
        var h = this.yAxis;
        var i = new ScalerParams(0, d, e, this.yAxis.b8, f);
        var j = this.xAxis;
        var k = j.dw(j.ke, g);
        var l = this.yAxis.jr(d, e, f);
        var m = typeCast(BarSeriesView.$, b);
        if (isNaN_(l) || isInfinity(l) || isNaN_(k)) {
            m.c7.count = 0;
            return;
        }
        this.ne.x(this, this.nz(), this.yAxis, runOn(this, this.m0), this.n7(b), this.n8(b));
        this.ne.p = this.qa;
        this.ne.q = this.qb;
        this.ne.j = this.qa;
        this.ne.k = this.qb;
        var n = false;
        var o = this.ne.c;
        if (o != null) {
            n = true;
        }
        var p = this.xAxis.cd;
        var q = this.valueColumn.count;
        for (var r = 0; r < c.count; ++r) {
            var s = c._inner[r][0] - 0.5 * l;
            var t = c._inner[r][1];
            var u = k;
            u = Math.max(u, -100);
            t = Math.min(t, e.right + 100);
            var v = m.c7.item(r);
            v.height = l;
            v.width = Math.abs(t - u);
            if (n) {
                this.ok(c, r, q, h, i, b.n);
            }
            this.ne.ae(v, false, false, false, false);
            v.am = this.ne.j;
            v.an = this.ne.k;
            m.dc(v, Math.min(t, u), s);
        }
        m.c7.count = c.count;
        b.cu(a);
    };
    BarSeries.prototype.hy = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.oy.cn.g(this.eu);
                break;
        }
        if (this.oy.cz) {
            this.oy.cy.g$e(a, b, c, d);
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 2:
                if (this.pd != null && this.oy.cn.d > 0) {
                    this.jd(true);
                }
                break;
            case 3:
                if (d == this.pd) {
                    if (this.xAxis != null && !this.xAxis.cl()) {
                        this.jd(true);
                    }
                }
                break;
        }
    };
    BarSeries.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                this.oy.cn.g(this.eu);
                if (this.xAxis != null && this.xAxis.cl()) {
                    this.jd(false);
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ci(this);
                }
                if (this.oy.cz) {
                    this.oy.cy = CategoryTrendLineManagerFactory.a(this.oy.cy, this.yAxis, this.jx, this, this.b2);
                }
                this.oy.cn.g(this.eu);
                this.jd(false);
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.oy.cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case "ValueColumn":
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.oy.cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.hz(this.xAxis);
                    this.hz(this.yAxis);
                }
                if (c == null && d != null) {
                    this.i4(this.xAxis);
                    this.i4(this.yAxis);
                }
                this.oy.cn.g(this.eu);
                this.jd(false);
                break;
        }
    };
    BarSeries.prototype.getPreferredCategoryMode = function () {
        return this.preferredCategoryMode(this.yAxis);
    };
    Object.defineProperty(BarSeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(this.yAxis);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarSeries.prototype, "scaler", {
        get: function () {
            return this.yAxis;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarSeries.prototype, "yScaler", {
        get: function () {
            return this.xAxis;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    BarSeries.$t = markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IIsCategoryBased_$type, IBarSeries_$type]);
    BarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:qa:qe', [1, 2], 'RadiusY:qb:qf', [1, 2]]);
    return BarSeries;
}(VerticalAnchoredCategorySeries));
/**
 * @hidden
 */
var BarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarBucketCalculator, _super);
    function BarBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    BarBucketCalculator.prototype.g = function (a) {
        var b = this.c.bs;
        var c = this.c.br;
        var d = this.c.cp.bz;
        if (b.isEmpty || c.isEmpty || this.i.c6.yAxis == null || d == null || d.count == 0) {
            this.d = 0;
            return;
        }
        var e = typeCast(BarSeries.$, this.c.cp);
        var f = e.lq(this.c);
        var g = e.getEffectiveViewport1(this.c);
        var h = new ScalerParams(0, b, c, e.yAxis.b8, g);
        var i = Math.floor(e.yAxis.d0(f.top, h, 0));
        var j = Math.ceil(e.yAxis.d0(f.bottom, h, 0));
        if (!e.yAxis.b8) {
            j = Math.ceil(e.yAxis.d0(f.top, h, 0));
            i = Math.floor(e.yAxis.d0(f.bottom, h, 0));
        }
        var k = Math.floor((j - i + 1) * a / f.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    };
    BarBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            Math.max(h, k);
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    BarBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = NaN;
        var h = NaN;
        for (var i = d; i <= e; ++i) {
            var j = b[i];
            if (!isNaN_(g)) {
                if (!isNaN_(j)) {
                    g = Math.min(g, j);
                    h = Math.max(h, j);
                }
            }
            else {
                g = j;
                h = j;
            }
        }
        if (!isNaN_(g)) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    BarBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.c6.valueColumn.count;
        this.h = this.i.c6.valueColumn.asArray();
    };
    BarBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    BarBucketCalculator.$t = markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
    return BarBucketCalculator;
}(CategoryBucketCalculator));
/**
 * @hidden
 */
var BarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarSeriesView, _super);
    function BarSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c7 = null;
        _this.c8 = null;
        _this.dd = new Rectangle();
        _this.c6 = a;
        _this.c7 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.de);
            $ret.activate = runOn(_this, _this.c9);
            $ret.disactivate = runOn(_this, _this.db);
            $ret.destroy = runOn(_this, _this.da);
            return $ret;
        })());
        _this.cy = new BarTrendLineManager();
        return _this;
    }
    BarSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    };
    BarSeriesView.prototype.de = function () {
        var a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    };
    BarSeriesView.prototype.c9 = function (a) {
        a._visibility = 0;
    };
    BarSeriesView.prototype.db = function (a) {
        a._visibility = 1;
    };
    BarSeriesView.prototype.da = function (a) {
        this.c8.remove(a);
    };
    BarSeriesView.prototype.dc = function (a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    };
    BarSeriesView.prototype.co = function () {
        return new BarBucketCalculator(this);
    };
    BarSeriesView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey;
    };
    BarSeriesView.prototype.z = function (a) {
        return this.c8._inner[a];
    };
    BarSeriesView.prototype.y = function (a) {
        var b = this.c8._inner[a];
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        var c = this.bm(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.ey + 3;
        return this.dd;
    };
    BarSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.c8.count; c++) {
                var d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    BarSeriesView.prototype.ai = function (a) {
        var e_2, _a, e_3, _b;
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.c7.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.aa(function (e, f) {
            if (e.o > f.o) {
                return -1;
            }
            else if (e.o < f.o) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        b++;
    };
    BarSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.la = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = -5;
    };
    BarSeriesView.$t = markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);
    return BarSeriesView;
}(AnchoredCategorySeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent bar series.
*/
var IgrBarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBarSeries, _super);
    function IgrBarSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrBarSeries.prototype.createImplementation = function () {
        return new BarSeries();
    };
    Object.defineProperty(IgrBarSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBarSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.qa;
        },
        set: function (v) {
            this.i.qa = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBarSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.qb;
        },
        set: function (v) {
            this.i.qb = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgrBarSeries.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgrBarSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrBarSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrBarSeries;
}(IgrVerticalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBarSeriesModule() {
    }
    IgrBarSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrBarSeries", IgrBarSeries);
        TypeRegistrar.register("BarSeries", BarSeries.$type);
    };
    return IgrBarSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartVerticalCategoryModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartVerticalCategoryModule() {
    }
    IgrDataChartVerticalCategoryModule.register = function () {
        IgrBarSeriesModule.register();
        IgrDataChartVerticalCategoryCoreModule.register();
    };
    return IgrDataChartVerticalCategoryModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var IStacked100Series_$type = /*@__PURE__*/ new Type(null, 'IStacked100Series');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StackedSeriesCreatedEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesCreatedEventArgs, _super);
    function StackedSeriesCreatedEventArgs(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.c = a;
        return _this;
    }
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "brush", {
        get: function () {
            return this.c.fu;
        },
        set: function (a) {
            this.c.fu = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemTemplate", {
        get: function () {
            return this.c.dv;
        },
        set: function (a) {
            this.c.dv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemBadgeTemplate", {
        get: function () {
            return this.c.du;
        },
        set: function (a) {
            this.c.du = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemVisibility", {
        get: function () {
            return this.c.ge;
        },
        set: function (a) {
            this.c.ge = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "outline", {
        get: function () {
            return this.c.fy;
        },
        set: function (a) {
            this.c.fy = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "dashArray", {
        get: function () {
            return this.c.f3;
        },
        set: function (a) {
            this.c.f3 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "dashCap", {
        get: function () {
            return this.c.f7;
        },
        set: function (a) {
            this.c.f7 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "index", {
        get: function () {
            return this.c.av;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "thickness", {
        get: function () {
            return this.c.at;
        },
        set: function (a) {
            this.c.at = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "title", {
        get: function () {
            return this.c.ax;
        },
        set: function (a) {
            this.c.ax = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerBrush", {
        get: function () {
            return this.c.fv;
        },
        set: function (a) {
            this.c.fv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerOutline", {
        get: function () {
            return this.c.fw;
        },
        set: function (a) {
            this.c.fw = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerStyle", {
        get: function () {
            return this.c.gb;
        },
        set: function (a) {
            this.c.gb = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerTemplate", {
        get: function () {
            return this.c.dw;
        },
        set: function (a) {
            this.c.dw = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerType", {
        get: function () {
            return this.c.l;
        },
        set: function (a) {
            this.c.l = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "startCap", {
        get: function () {
            return this.c.f6;
        },
        set: function (a) {
            this.c.f9 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "endCap", {
        get: function () {
            return this.c.f5;
        },
        set: function (a) {
            this.c.f8 = a;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesCreatedEventArgs.$t = markType(StackedSeriesCreatedEventArgs, 'StackedSeriesCreatedEventArgs', EventArgs.$);
    return StackedSeriesCreatedEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var FragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FragmentBase, _super);
    function FragmentBase() {
        var _this = _super.call(this) || this;
        _this.qh = null;
        _this._logicalSeriesLink = null;
        _this.qj = null;
        _this.qh = new CategoryLineRasterizer();
        return _this;
    }
    Object.defineProperty(FragmentBase.prototype, "logicalSeriesLink", {
        get: function () {
            return this._logicalSeriesLink;
        },
        set: function (a) {
            this._logicalSeriesLink = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FragmentBase.prototype, "parentSeries", {
        get: function () {
            return this.qj;
        },
        set: function (a) {
            this.qj = a;
        },
        enumerable: true,
        configurable: true
    });
    FragmentBase.prototype.get_cv = function () {
        return false;
    };
    FragmentBase.prototype.get_cq = function () {
        return false;
    };
    FragmentBase.prototype.get_cs = function () {
        return true;
    };
    FragmentBase.prototype.e7 = function () {
        var a = this.parentSeries;
        if (a.fh == -1 || a.o3 == null || a.o3.f.indexOf(this) == -1) {
            return -1;
        }
        return a.o3.f.indexOf(this);
    };
    FragmentBase.prototype.fb = function () {
        var a = this.parentSeries;
        if (a.fh == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
            return -1;
        }
        return a.series.indexOf(this.logicalSeriesLink);
    };
    FragmentBase.prototype.resolveLegendIndex = function () {
        var a = this.parentSeries;
        if (a.o6) {
            return -1 + a.fh + a.oz.count - a.o3.f.indexOf(this);
        }
        return _super.prototype.resolveLegendIndex.call(this);
    };
    FragmentBase.prototype.a6 = function () {
        return this.parentSeries;
    };
    FragmentBase.prototype.m6 = function () {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchXAxis();
    };
    FragmentBase.prototype.nq = function () {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    };
    FragmentBase.prototype.ql = function (a, b, c, d, e, f, g, h) {
        var i = c[0];
        var j = c[1];
        var k = new Rect(0, i - 5, j - 5, 11, 11);
        if (!isNaN_(i) && !isNaN_(j) && !isInfinity(i) && !isInfinity(j) && d.tryAdd(k)) {
            b.m.add({ $type: Point_$type, x: i, y: j });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    };
    FragmentBase.prototype.ol = function (a, b) {
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
            return;
        }
        if (this.logicalSeriesLink.ad.count == 0 || this.logicalSeriesLink.ac.count == 0) {
            return;
        }
        this.nc(b).d(a, b);
    };
    FragmentBase.prototype.qn = function (a, b, c) {
        var d = this.o7(c);
        var e = d;
        var f = this.logicalSeriesLink.y;
        var g = f ? this.parentSeries.o3.e : this.parentSeries.o3.d;
        var h = g.indexOf(this);
        if (a.count == 0) {
            return;
        }
        if (h == -1) {
            return;
        }
        var i = false;
        for (var j = h; j >= 0; j--) {
            if (i) {
                break;
            }
            if (j == 0) {
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
                break;
            }
            var k = typeCast(FragmentBase.$, g._inner[j - 1]);
            if (k != null && k.qh != null && k.qh.o.count > 0 && this.bi != null && k.dw(this.bi.br, this.bi.bs, this.bi)) {
                i = true;
                for (var l = k.qh.o.count - 1; l >= 0; l--) {
                    a.add(k.qh.o._inner[l]);
                }
            }
        }
    };
    FragmentBase.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        var f = this.parentSeries.fetchYAxis();
        if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.bz == null || e.bf == null || f.bf == null) {
            d = false;
        }
        if (this.valueColumn == null) {
            return false;
        }
        if (isInfinity(this.valueColumn.minimum) && isInfinity(this.valueColumn.maximum)) {
            d = false;
        }
        if (isNaN_(this.valueColumn.minimum) && isNaN_(this.valueColumn.maximum)) {
            d = false;
        }
        return d;
    };
    FragmentBase.prototype.o7 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(a);
        var f = new ScalerParams(0, c, d, this.yAxis.b8, e);
        f.b = this.eh();
        if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
            b = this.yAxis.dw(0, f);
        }
        return b;
    };
    FragmentBase.prototype.an = function (a) {
        return null;
    };
    FragmentBase.prototype.qm = function () {
        if (this.parentSeries == null) {
            return -1;
        }
        var a = this.parentSeries.fh;
        var b = 0;
        var c = 1;
        if (this.parentSeries.o6) {
            b = this.parentSeries.oz.count - 1;
            c = -1;
        }
        for (var d = b; this.parentSeries.o6 ? d >= 0 : d < this.parentSeries.oz.count; d += c) {
            var e = this.parentSeries.oz._inner[d];
            if (e.visualSeriesLink == this) {
                return a;
            }
            if (this.parentSeries.aw == null || e.gd != 0 || e.gc != 0) {
                continue;
            }
            a++;
        }
        return -1;
    };
    FragmentBase.prototype.qo = function (a) {
        if (a == null) {
        }
    };
    FragmentBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.parentSeries == null) {
            return;
        }
        var e = typeCast(NumericAxisBase.$, this.parentSeries.fetchYAxis());
        if (e == null) {
            return;
        }
        switch (b) {
            case "ValueColumn":
                if (this.oy.cz) {
                    this.oy.cy.g$i();
                }
                if (e != null && !e.cl()) {
                    this.parentSeries.oy().cn.g(this.eu);
                    this.jd(false);
                }
                break;
            case "ActualBrush":
                if (this.logicalSeriesLink != null) {
                    this.logicalSeriesLink.fp = this.k3;
                }
                break;
        }
    };
    FragmentBase.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
    };
    Object.defineProperty(FragmentBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    FragmentBase.$t = markType(FragmentBase, 'FragmentBase', HorizontalAnchoredCategorySeries.$);
    return FragmentBase;
}(HorizontalAnchoredCategorySeries));
/**
 * @hidden
 */
var AreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaFragment, _super);
    function AreaFragment() {
        var _this = _super.call(this) || this;
        _this.ab = AreaFragment.$;
        return _this;
    }
    AreaFragment.prototype.bf = function () {
        return new AreaFragmentView(this);
    };
    AreaFragment.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qp = a;
    };
    AreaFragment.prototype.get_ck = function () {
        return true;
    };
    AreaFragment.prototype.qr = function (a, b) {
        var c = this.qp.c8.ak;
        if (this.dj(a, c)) {
            return true;
        }
        var d = this.qp.c9.ak;
        if (this.dj(a, d)) {
            return true;
        }
        return false;
    };
    AreaFragment.prototype.dh = function (a, b) {
        if (this.qq(a, b)) {
            return true;
        }
        if (this.qr(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    AreaFragment.prototype.qq = function (a, b) {
        var c = this.qp.da.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        var d = this.qp.db.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    };
    AreaFragment.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    AreaFragment.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    AreaFragment.prototype.oo = function (a, b) {
        var _this = this;
        _super.prototype.oo.call(this, a, b);
        this.qh.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        var c = typeCast(AreaFragmentView.$, b);
        var d = c.cn.d;
        this.qh.i(c.c8, c.da, c.c9, c.db, a.f.count, a.f, true, d, this.eu, function (e, f, g, h, i) { return _this.qn(e, a.f, b); }, 0);
        c.c8._opacity = this.d6;
        c.c9._opacity = 0.5 * this.d6;
    };
    AreaFragment.prototype.jn = function () {
        var a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? this.parentSeries.d6 : this.d7;
        }
    };
    Object.defineProperty(AreaFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    AreaFragment.$t = markType(AreaFragment, 'AreaFragment', FragmentBase.$);
    return AreaFragment;
}(FragmentBase));
/**
 * @hidden
 */
var ColumnFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnFragment, _super);
    function ColumnFragment() {
        var _this = _super.call(this) || this;
        _this.ab = ColumnFragment.$;
        return _this;
    }
    ColumnFragment.prototype.bf = function () {
        return new ColumnFragmentView(this);
    };
    ColumnFragment.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qq = a;
    };
    Object.defineProperty(ColumnFragment.prototype, "fragmentXAxis", {
        get: function () {
            return this.parentSeries != null ? typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis()) : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColumnFragment.prototype, "fragmentYAxis", {
        get: function () {
            return this.parentSeries != null ? typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis()) : null;
        },
        enumerable: true,
        configurable: true
    });
    ColumnFragment.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    ColumnFragment.prototype.m6 = function () {
        return this.fragmentXAxis;
    };
    ColumnFragment.prototype.nq = function () {
        return this.fragmentYAxis;
    };
    ColumnFragment.prototype.fetchXAxis = function () {
        return null;
    };
    ColumnFragment.prototype.fetchYAxis = function () {
        return null;
    };
    ColumnFragment.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        if (a && c.c7 != null) {
            this.m7.m.clear();
            c.c7.count = 0;
        }
    };
    ColumnFragment.prototype.an = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
    };
    ColumnFragment.prototype.dw = function (a, b, c) {
        if (this.parentSeries == null) {
            return false;
        }
        return this.parentSeries.o7(this, a, b, this.qs(c));
    };
    ColumnFragment.prototype.dt = function () {
        return true;
    };
    ColumnFragment.prototype.n7 = function (a) {
        if (this.parentSeries != null) {
            return this.parentSeries.n7(this.parentSeries.bi);
        }
        return _super.prototype.n7.call(this, a);
    };
    ColumnFragment.prototype.n8 = function (a) {
        if (this.parentSeries != null) {
            return this.parentSeries.n8(this.parentSeries.bi);
        }
        return _super.prototype.n7.call(this, a);
    };
    ColumnFragment.prototype.lu = function (a) {
        if (this.m6() == null || this.fragmentYAxis == null) {
            return Rect.empty;
        }
        var b = this.lg(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = new ScalerParams(0, c, d, this.fragmentYAxis.b8, e);
        var g = this.aj(this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.m6().jr(c, d, e);
        if (j < k) {
            var m = h[0] - 0.5 * l;
            var n = h[1];
            var o = h[2];
            return new Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
        }
        else {
            var p = i[0] - 0.5 * l;
            var q = i[1];
            var r = i[2];
            return new Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
        }
    };
    ColumnFragment.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    ColumnFragment.prototype.dk = function (a, b) {
        var c = this.lv(a);
        if (c.isEmpty) {
            return false;
        }
        var d = this.qz(c, this.ee(b));
        return d.containsPoint(a);
    };
    ColumnFragment.prototype.qz = function (a, b) {
        var c = a.left + a.width / 2;
        var d = a.top + a.height / 2;
        var e = c - ((a.width / 2) + b);
        var f = d - (a.height / 2);
        var g = a.height;
        var h = a.width + b * 2;
        return new Rect(0, e, f, h, g);
    };
    ColumnFragment.prototype.fv = function (a, b) {
        var c = typeCast(FrameworkElement.$, a);
        var d = c != null ? typeCast(DataContext.$, c.dataContext) : null;
        var e = d != null ? d.item : null;
        if (e == null) {
            var f = this.bi.br;
            var g = this.bs != null ? this.bs.mq : Rect.empty;
            var h = { $type: Point_$type, x: g.left + g.width * (b.x - f.left) / f.width, y: g.top + g.height * (b.y - f.top) / f.height };
            e = this.fp(h);
        }
        return e;
    };
    ColumnFragment.prototype.fp = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.m6()) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    ColumnFragment.prototype.fa = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = this.m6();
        var f = new ScalerParams(0, b, c, e.b8, d);
        var g = typeCast(ISortingAxis_$type, this.fragmentXAxis);
        var h = this.lq(this.bi);
        var i = e.dz(h.left, f);
        var j = e.dz(h.right, f);
        var k = (a.x - b.left) / b.width;
        var l = i + ((j - i) * k);
        if (truncate(l) <= dateMinValue().getTime() || truncate(l) >= dateMaxValue().getTime()) {
            return -1;
        }
        var m = g.i$f(l);
        return m;
    };
    ColumnFragment.prototype.e8 = function (a) {
        if (this.parentSeries == null) {
            return -1;
        }
        return this.parentSeries.pd(a);
    };
    ColumnFragment.prototype.ql = function (a, b, c, d, e, f, g, h) {
        var i = 0;
        var j = c[0];
        var k = e < i ? c[2] : c[1];
        var l = new Rect(0, j - 5, k - 5, 11, 11);
        if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k) && d.tryAdd(l)) {
            b.m.add({ $type: Point_$type, x: j, y: k });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    };
    ColumnFragment.prototype.qs = function (a) {
        if (a.m) {
            return this.parentSeries.a0.a$h.item(a.aa);
        }
        else if (a == this.bh) {
            return this.parentSeries.bh;
        }
        else {
            return this.parentSeries.nf;
        }
    };
    ColumnFragment.prototype.jc = function (a, b, c, d, e) {
        this.a0.a$r(this, a, b, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        var h = this.qs(f);
        h.cn.g(this.eu);
        if (this.cc(g)) {
            return;
        }
        if (this.oz == null) {
            this.oz = new CategoryFrame(3);
        }
        this.oz.u();
        this.ol(this.oz, g);
        this.oo(this.oz, g);
    };
    ColumnFragment.prototype.ol = function (a, b) {
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null || this.logicalSeriesLink.ac.count == 0 || this.logicalSeriesLink.ad.count == 0) {
            return;
        }
        var c;
        if (b.m) {
            c = this.parentSeries.ox;
        }
        else if (b == this.bh) {
            c = this.parentSeries.m9;
        }
        else {
            c = this.parentSeries.m7;
        }
        var d = typeCast(CategorySeriesView.$, this.qs(b));
        a.f.clear();
        a.m.clear();
        var e = d.cn.e;
        var f = d.cn.f;
        var g = this.parentSeries.nb.h.yScaler;
        var h = typeCast(ISortingAxis_$type, this.parentSeries.nb.h.scaler);
        var i = typeCast(NumericAxisBase.$, g) !== null && g.ju;
        var j = typeCast(StackedBucketCalculator.$, d.cn);
        var k = d.cn.d;
        var l = 0;
        for (var m = e; m <= f; m++) {
            var n = m * k;
            if (this._visibility != 0) {
                break;
            }
            if (m >= this.valueColumn.count || m >= c.f.count + e) {
                continue;
            }
            var o = this.valueColumn.item(m);
            var p = !i || (i && o > 0);
            var q = void 0;
            if (h == null) {
                q = j.getBucket1(this, m, m, b.bs, b.br, c);
            }
            else {
                q = j.getBucket1(this, m, h.i$b._inner[m], b.bs, b.br, c);
            }
            a.f.add(q);
            if (p) {
                if (this.ql(b, a, q, this.nb.h.provideCollisionDetector(), o, n, l, m)) {
                    l++;
                }
            }
        }
        b.cq.count = l;
    };
    ColumnFragment.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        if (this.parentSeries == null) {
            return;
        }
        this.parentSeries.pm(this, a, b);
        CategoryMarkerManager.b(this, a.m, b.cq, this.l5);
    };
    ColumnFragment.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
    };
    Object.defineProperty(ColumnFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    ColumnFragment.$t = markType(ColumnFragment, 'ColumnFragment', FragmentBase.$);
    ColumnFragment.$$p = markDep(DependencyProperty, PropertyMetadata, ColumnFragment, 'raisePropertyChanged', ['RadiusX:qt:qx', [1, 2], 'RadiusY:qu:qy', [1, 2]]);
    return ColumnFragment;
}(FragmentBase));
/**
 * @hidden
 */
var BarFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BarFragment, _super);
    function BarFragment() {
        var _this = _super.call(this) || this;
        _this.ab = BarFragment.$;
        return _this;
    }
    Object.defineProperty(BarFragment.prototype, "barFragmentXAxis", {
        get: function () {
            return this.parentSeries != null ? this.parentSeries.xAxis : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BarFragment.prototype, "barFragmentYAxis", {
        get: function () {
            return this.parentSeries != null ? this.parentSeries.yAxis : null;
        },
        enumerable: true,
        configurable: true
    });
    BarFragment.prototype.m6 = function () {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    };
    BarFragment.prototype.eb = function (a) {
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        var c = this.bi.br;
        var d = this.lq(this.bi);
        var e = this.getEffectiveViewport1(this.bi);
        var f = this.m6();
        var g = -1;
        if (f != null && !b.isEmpty && !c.isEmpty) {
            var h = new ScalerParams(0, b, c, f.b8, e);
            var i = f.dz(d.top, h);
            var j = f.dz(d.bottom, h);
            var k = (a.y - b.top) / b.height;
            var l = i + (k * (j - i));
            if (f.categoryMode != 0) {
                l -= 0.5;
            }
            g = l;
        }
        return g;
    };
    BarFragment.prototype.nq = function () {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    };
    BarFragment.prototype.qz = function (a, b) {
        var c = a.left + a.width / 2;
        var d = a.top + a.height / 2;
        var e = c - (a.width / 2);
        var f = d - ((a.height / 2) + b);
        var g = a.height + b * 2;
        var h = a.width;
        return new Rect(0, e, f, h, g);
    };
    BarFragment.prototype.lu = function (a) {
        if (this.m6() == null) {
            return Rect.empty;
        }
        var b = this.lg(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = this.m6();
        var g = new ScalerParams(0, c, d, f.b8, e);
        var h = this.aj(this.m6(), this.m7.f, this.n7(this.bi), this.n8(this.bi), a, true);
        if (h == null) {
            return Rect.empty;
        }
        var i = h[0];
        var j = h[1];
        var k = Math.abs(b.y - i[0]);
        var l = Math.abs(b.y - j[0]);
        var m = f.jr(c, d, e);
        if (k < l) {
            var n = i[0] - 0.5 * m;
            var o = i[2];
            var p = i[1];
            return new Rect(0, o, n, Math.max(p, o) - Math.min(p, o), m);
        }
        else {
            var q = j[0] - 0.5 * m;
            var r = j[2];
            var s = j[1];
            return new Rect(0, r, q, Math.max(s, r) - Math.min(s, r), m);
        }
    };
    BarFragment.prototype.dh = function (a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    BarFragment.prototype.ql = function (a, b, c, d, e, f, g, h) {
        var i = c[0];
        var j = e < 0 ? c[2] : c[1];
        var k = new Rect(0, j - 5, i - 5, 11, 11);
        if (!isNaN_(j) && !isNaN_(i) && !isInfinity(j) && !isInfinity(i) && d.tryAdd(k)) {
            b.m.add({ $type: Point_$type, x: j, y: i });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    };
    BarFragment.prototype.fp = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.barFragmentYAxis) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    BarFragment.prototype.fa = function (a) {
        var b = this.bi.bs;
        var c = this.bi.br;
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, b, c, this.barFragmentYAxis.b8, d);
        var f = typeCast(ISortingAxis_$type, this.barFragmentYAxis);
        var g = this.lq(this.bi);
        var h = this.barFragmentYAxis.dz(g.top, e);
        var i = this.barFragmentYAxis.dz(g.bottom, e);
        var j = (a.y - b.top) / b.height;
        var k = h + ((i - h) * j);
        if (truncate(k) <= dateMinValue().getTime() || truncate(k) >= dateMaxValue().getTime()) {
            return -1;
        }
        var l = f.i$f(k);
        return l;
    };
    BarFragment.prototype.o7 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(a);
        var f = new ScalerParams(0, c, d, this.barFragmentXAxis.b8, e);
        if (!c.isEmpty && !d.isEmpty && this.barFragmentXAxis != null) {
            b = this.barFragmentXAxis.dw(0, f);
        }
        return b;
    };
    BarFragment.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        if (this.parentSeries == null || this.barFragmentXAxis == null) {
            return;
        }
        var e = this.barFragmentXAxis;
        switch (b) {
            case "ValueColumn":
                if (this.oy.cz) {
                    this.oy.cy.g$i();
                }
                if (e != null && !e.cl()) {
                    this.parentSeries.oy().cn.g(this.eu);
                    this.jd(false);
                }
                break;
        }
    };
    Object.defineProperty(BarFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    BarFragment.$t = markType(BarFragment, 'BarFragment', ColumnFragment.$);
    return BarFragment;
}(ColumnFragment));
/**
 * @hidden
 */
var AreaFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaFragmentBucketCalculator, _super);
    function AreaFragmentBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    AreaFragmentBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    AreaFragmentBucketCalculator.prototype.getBucket = function (a) {
        var b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        var c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        var d = NaN;
        var e = NaN;
        var f = this.i.cw;
        var g = f.parentSeries;
        var h = typeCast(IStacked100Series_$type, g) !== null;
        var i = this.i.cw.valueColumn;
        var j = g.ov;
        var k = g.ow;
        var l = f.logicalSeriesLink.ad;
        var m = f.logicalSeriesLink.ac;
        for (var n = b; n <= c; ++n) {
            var o = i.item(n);
            if (isNaN_(o) || isInfinity(o)) {
                o = 0;
            }
            var p = Math.abs(k[n]) + j[n];
            if (h) {
                if (p == 0) {
                    o = 0;
                }
                else if (o < 0) {
                    o = (l._inner[n] + o) / p * 100;
                }
                else {
                    o = (m._inner[n] + o) / p * 100;
                }
            }
            else {
                o = o < 0 ? l._inner[n] + o : m._inner[n] + o;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(o)) {
                    d = Math.min(d, o);
                    e = Math.max(e, o);
                }
            }
            else {
                d = o;
                e = o;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    };
    AreaFragmentBucketCalculator.$t = markType(AreaFragmentBucketCalculator, 'AreaFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
    return AreaFragmentBucketCalculator;
}(AnchoredCategoryBucketCalculator));
/**
 * @hidden
 */
var LineFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineFragmentBucketCalculator, _super);
    function LineFragmentBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    LineFragmentBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    LineFragmentBucketCalculator.prototype.getBucket = function (a) {
        var b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        var c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        var d = NaN;
        var e = NaN;
        var f = typeCast(FragmentBase.$, this.i.cw);
        var g = f.parentSeries;
        for (var h = b; h <= c; ++h) {
            var i = this.i.cw.valueColumn.item(h);
            var j = Math.abs(g.ow[h]) + g.ov[h];
            if (isNaN_(i) || isInfinity(i)) {
                i = 0;
            }
            if (typeCast(IStacked100Series_$type, g) !== null) {
                if (j == 0) {
                    i = 0;
                }
                else if (i < 0) {
                    i = (f.logicalSeriesLink.ad._inner[h] + i) / j * 100;
                }
                else {
                    i = (f.logicalSeriesLink.ac._inner[h] + i) / j * 100;
                }
            }
            else {
                i = i < 0 ? f.logicalSeriesLink.ad._inner[h] + i : f.logicalSeriesLink.ac._inner[h] + i;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(i)) {
                    d = Math.min(d, i);
                    e = Math.max(e, i);
                }
            }
            else {
                d = i;
                e = i;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    };
    LineFragmentBucketCalculator.$t = markType(LineFragmentBucketCalculator, 'LineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
    return LineFragmentBucketCalculator;
}(AnchoredCategoryBucketCalculator));
/**
 * @hidden
 */
var SplineFragmentBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineFragmentBucketCalculator, _super);
    function SplineFragmentBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    SplineFragmentBucketCalculator.prototype.getBucket = function (a) {
        var b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        var c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        var d = NaN;
        var e = NaN;
        var f = typeCast(SplineFragmentBase.$, this.i.cw);
        var g = f.parentSeries;
        for (var h = b; h <= c; ++h) {
            var i = this.i.cw.valueColumn.item(h);
            var j = Math.abs(g.ow[h]) + g.ov[h];
            if (isNaN_(i) || isInfinity(i)) {
                i = 0;
            }
            if (typeCast(IStacked100Series_$type, g) !== null) {
                if (j == 0) {
                    i = 0;
                }
                else if (i < 0) {
                    i = (f.logicalSeriesLink.ad._inner[h] + i) / j * 100;
                }
                else {
                    i = (f.logicalSeriesLink.ac._inner[h] + i) / j * 100;
                }
            }
            else {
                i = i < 0 ? f.logicalSeriesLink.ad._inner[h] + i : f.logicalSeriesLink.ac._inner[h] + i;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(i)) {
                    d = Math.min(d, i);
                    e = Math.max(e, i);
                }
            }
            else {
                d = i;
                e = i;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    };
    SplineFragmentBucketCalculator.$t = markType(SplineFragmentBucketCalculator, 'SplineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
    return SplineFragmentBucketCalculator;
}(AnchoredCategoryBucketCalculator));
/**
 * @hidden
 */
var StackedBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedBucketCalculator, _super);
    function StackedBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    StackedBucketCalculator.prototype.getBucket = function (a) {
        var b = typeCast(StackedSeriesBase.$, this.c.cp);
        var c = Math.min(b.ow != null ? b.ow.length : 0, b.ov != null ? b.ov.length : 0);
        var d = Math.min(a * this.d, c - 1);
        var e = Math.min(d + this.d - 1, c - 1);
        var f = NaN;
        var g = NaN;
        for (var h = d; h <= e; ++h) {
            var i = Math.min(b.ow[h], b.ov[h]);
            var j = Math.max(b.ow[h], b.ov[h]);
            if (!isNaN_(f)) {
                if (!isNaN_(i)) {
                    f = Math.min(f, i);
                    g = Math.max(g, i);
                }
                if (!isNaN_(j)) {
                    f = Math.min(f, j);
                    g = Math.max(g, j);
                }
            }
            else {
                f = i;
                g = j;
            }
        }
        if (!isNaN_(f) && !isNaN_(g)) {
            return [0.5 * (d + e), f, g];
        }
        return [NaN, NaN, NaN];
    };
    StackedBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
        return null;
    };
    StackedBucketCalculator.$t = markType(StackedBucketCalculator, 'StackedBucketCalculator', CategoryBucketCalculator.$);
    return StackedBucketCalculator;
}(CategoryBucketCalculator));
/**
 * @hidden
 */
var StackedBarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedBarBucketCalculator, _super);
    function StackedBarBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    StackedBarBucketCalculator.prototype.g = function (a) {
        var b = this.c.bs;
        var c = this.c.br;
        var d = typeCast(StackedBarSeries.$, this.c.cp);
        var e = this.c.cp.bz;
        if (b.isEmpty || c.isEmpty || d.yAxis == null || e == null || e.count == 0) {
            this.d = 0;
            return;
        }
        var f = d.getEffectiveViewport1(this.c);
        var g = new ScalerParams(0, b, c, d.yAxis.b8, f);
        var h = d.lq(this.c);
        var i = Math.floor(d.yAxis.d0(h.top, g, 0));
        var j = Math.ceil(d.yAxis.d0(h.bottom, g, 0));
        if (!d.yAxis.b8) {
            j = Math.ceil(d.yAxis.d0(h.top, g, 0));
            i = Math.floor(d.yAxis.d0(h.bottom, g, 0));
        }
        var k = Math.floor((j - i + 1) * a / h.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    };
    StackedBarBucketCalculator.prototype.getBucket = function (a) {
        return _super.prototype.getBucket.call(this, a);
    };
    StackedBarBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
        var g = [NaN, NaN, NaN];
        var h = typeCast(BarFragment.$, a);
        if (h == null || h.logicalSeriesLink == null) {
            return g;
        }
        var i = typeCast(StackedBarSeries.$, this.c.cp);
        var j = a.valueColumn.item(c);
        var k = 0;
        var l = NaN;
        var m = NaN;
        var n = Number.NEGATIVE_INFINITY;
        var o = Number.POSITIVE_INFINITY;
        var p = i.getEffectiveViewport1(this.c);
        var q = Math.min(i.ow != null ? i.ow.length : 0, i.ov != null ? i.ov.length : 0);
        var r = c * this.d;
        var s = Math.min(r + this.d - 1, q - 1);
        for (var t = r; t <= s; ++t) {
            j = a.valueColumn.item(t);
            if (j < k) {
                o = Math.min(o, h.logicalSeriesLink.ad._inner[t] + j);
                n = Math.max(n, h.logicalSeriesLink.ad._inner[t]);
            }
            else {
                o = Math.min(o, h.logicalSeriesLink.ac._inner[t]);
                n = Math.max(n, h.logicalSeriesLink.ac._inner[t] + j);
            }
            if (!isNaN_(l)) {
                if (!isNaN_(o)) {
                    l = Math.min(l, o);
                    m = Math.max(m, o);
                }
                if (!isNaN_(n)) {
                    l = Math.min(l, n);
                    m = Math.max(m, n);
                }
            }
            else {
                l = o;
                m = n;
            }
        }
        var u = new ScalerParams(0, d, e, i.xAxis.b8, p);
        g = [f.f._inner[b - this.e][0], i.xAxis.dw(m, u), i.xAxis.dw(l, u)];
        return g;
    };
    StackedBarBucketCalculator.$t = markType(StackedBarBucketCalculator, 'StackedBarBucketCalculator', StackedBucketCalculator.$);
    return StackedBarBucketCalculator;
}(StackedBucketCalculator));
/**
 * @hidden
 */
var StackedColumnBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedColumnBucketCalculator, _super);
    function StackedColumnBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    StackedColumnBucketCalculator.prototype.getBucket = function (a) {
        return _super.prototype.getBucket.call(this, a);
    };
    StackedColumnBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
        var g = [NaN, NaN, NaN];
        var h = typeCast(ColumnFragment.$, a);
        if (h == null || h.logicalSeriesLink == null) {
            return g;
        }
        var i = typeCast(StackedColumnSeries.$, this.c.cp);
        var j = a.valueColumn.item(c);
        var k = 0;
        var l = NaN;
        var m = NaN;
        var n = Number.NEGATIVE_INFINITY;
        var o = Number.POSITIVE_INFINITY;
        var p = i.getEffectiveViewport1(this.c);
        var q = Math.min(i.ow != null ? i.ow.length : 0, i.ov != null ? i.ov.length : 0);
        var r = c * this.d;
        var s = Math.min(r + this.d - 1, q - 1);
        for (var t = r; t <= s; ++t) {
            j = a.valueColumn.item(t);
            if (j < k) {
                o = Math.min(o, h.logicalSeriesLink.ad._inner[t] + j);
                n = Math.max(n, h.logicalSeriesLink.ad._inner[t]);
            }
            else {
                o = Math.min(o, h.logicalSeriesLink.ac._inner[t]);
                n = Math.max(n, h.logicalSeriesLink.ac._inner[t] + j);
            }
            if (!isNaN_(l)) {
                if (!isNaN_(o)) {
                    l = Math.min(l, o);
                    m = Math.max(m, o);
                }
                if (!isNaN_(n)) {
                    l = Math.min(l, n);
                    m = Math.max(m, n);
                }
            }
            else {
                l = o;
                m = n;
            }
        }
        var u = new ScalerParams(0, d, e, i.yAxis.b8, p);
        g = [f.f._inner[b - this.e][0], i.yAxis.dw(m, u), i.yAxis.dw(l, u)];
        return g;
    };
    StackedColumnBucketCalculator.$t = markType(StackedColumnBucketCalculator, 'StackedColumnBucketCalculator', StackedBucketCalculator.$);
    return StackedColumnBucketCalculator;
}(StackedBucketCalculator));
/**
 * @hidden
 */
var LineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineFragment, _super);
    function LineFragment() {
        var _this = _super.call(this) || this;
        _this.ab = LineFragment.$;
        return _this;
    }
    LineFragment.prototype.bf = function () {
        return new LineFragmentView(this);
    };
    LineFragment.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qp = a;
    };
    LineFragment.prototype.qr = function (a, b) {
        var c = this.qp.c8.ak;
        if (this.dj(a, c)) {
            return true;
        }
        return false;
    };
    LineFragment.prototype.get_ck = function () {
        return true;
    };
    LineFragment.prototype.dh = function (a, b) {
        if (this.qq(a, b)) {
            return true;
        }
        if (this.qr(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    LineFragment.prototype.qq = function (a, b) {
        var c = this.qp.c9.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        var d = this.qp.da.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    };
    LineFragment.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    LineFragment.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c7();
    };
    LineFragment.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        var c = function (d) { return a.f._inner[d][0]; };
        var d = function (e) { return a.f._inner[e][1]; };
        var e = function (f) { return a.f._inner[f][0]; };
        var f = function (g) { return a.f._inner[g][2]; };
        this.qh.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        var g = b.cn.d;
        var h = typeCast(LineFragmentView.$, b);
        this.qh.m(h.c9, h.c8, h.da, a.f.count, a.f, true, 0, this.ow(a.f, a.f.count - 1, b.br, b.bs), g, this.eu);
    };
    Object.defineProperty(LineFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    LineFragment.$t = markType(LineFragment, 'LineFragment', FragmentBase.$);
    return LineFragment;
}(FragmentBase));
/**
 * @hidden
 */
var SplineFragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineFragmentBase, _super);
    function SplineFragmentBase() {
        var _this = _super.call(this) || this;
        _this._logicalSeriesLink = null;
        _this.qr = null;
        _this.qt = null;
        _this.qr = new CategoryLineRasterizer();
        return _this;
    }
    Object.defineProperty(SplineFragmentBase.prototype, "logicalSeriesLink", {
        get: function () {
            return this._logicalSeriesLink;
        },
        set: function (a) {
            this._logicalSeriesLink = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SplineFragmentBase.prototype, "parentSeries", {
        get: function () {
            return this.qt;
        },
        set: function (a) {
            this.qt = a;
        },
        enumerable: true,
        configurable: true
    });
    SplineFragmentBase.prototype.get_cq = function () {
        return false;
    };
    SplineFragmentBase.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    SplineFragmentBase.prototype.get_cs = function () {
        return true;
    };
    SplineFragmentBase.prototype.e7 = function () {
        var a = this.parentSeries;
        if (a.fh == -1 || a.o3 == null || a.o3.f.indexOf(this) == -1) {
            return -1;
        }
        return a.o3.f.indexOf(this);
    };
    SplineFragmentBase.prototype.resolveLegendIndex = function () {
        var a = this.parentSeries;
        if (a.o6) {
            return -1 + a.fh + a.oz.count - a.o3.f.indexOf(this);
        }
        return _super.prototype.resolveLegendIndex.call(this);
    };
    SplineFragmentBase.prototype.fb = function () {
        var a = this.parentSeries;
        if (a.fh == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
            return -1;
        }
        return a.series.indexOf(this.logicalSeriesLink);
    };
    SplineFragmentBase.prototype.a6 = function () {
        return this.parentSeries;
    };
    SplineFragmentBase.prototype.qk = function (a, b, c, d, e, f, g) {
        var h = b[0];
        var i = b[1];
        var j = new Rect(0, h - 5, i - 5, 11, 11);
        if (!isNaN_(h) && !isNaN_(i) && !isInfinity(h) && !isInfinity(i) && c.tryAdd(j)) {
            a.m.add({ $type: Point_$type, x: h, y: i });
            var k = f.cq.item(e);
            k.content.item = this.bz.item(d);
            k.al = g;
            return true;
        }
        return false;
    };
    SplineFragmentBase.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        var f = this.parentSeries.fetchYAxis();
        if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.bz == null || e.bf == null || f.bf == null) {
            d = false;
        }
        if (this.valueColumn == null) {
            return false;
        }
        if (isInfinity(this.valueColumn.minimum) && isInfinity(this.valueColumn.maximum)) {
            d = false;
        }
        if (isNaN_(this.valueColumn.minimum) && isNaN_(this.valueColumn.maximum)) {
            d = false;
        }
        return d;
    };
    SplineFragmentBase.prototype.an = function (a) {
        return null;
    };
    SplineFragmentBase.prototype.qv = function (a, b, c, d, e, f) {
        var _this = this;
        var g = typeCast(ISortingAxis_$type, d);
        if (g == null) {
            return;
        }
        var h = this.getEffectiveViewport1(f);
        var i = new ScalerParams(0, b, c, d.b8, h);
        var j = new ScalerParams(0, b, c, e.b8, h);
        var k = d.dz(2, i) - d.dz(1, i);
        var l = this.l3();
        var m = 0;
        var n = this.qm(d, b, c, h);
        var o = function (p) { return Math.abs(_this.parentSeries.ow[p]) + _this.parentSeries.ov[p]; };
        var p = function (q) { return q; };
        var q = function (r) {
            var s = g.i$b._inner[r];
            if (typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                return _this.valueColumn.item(s) < 0 ? (_this.logicalSeriesLink.ad._inner[s] + _this.valueColumn.item(s)) / o(s) * 100 : (_this.logicalSeriesLink.ac._inner[s] + _this.valueColumn.item(s)) / o(s) * 100;
            }
            else {
                return _this.valueColumn.item(s) < 0 ? _this.logicalSeriesLink.ad._inner[s] + _this.valueColumn.item(s) : _this.logicalSeriesLink.ac._inner[s] + _this.valueColumn.item(s);
            }
        };
        var r = this.nf.cn.f;
        var s = this.nf.cn.e;
        var t = truncate(Math.ceil(c.width / (r - s)));
        var u = new CollisionAvoider();
        var v = this.nf.cn.d;
        if (v <= 0 || (s <= 0 && r <= 0)) {
            this.nf.cq.count = m;
            return;
        }
        var w = 0;
        for (var x = s; x < r + 1; ++x) {
            var y = null;
            var z = x * v;
            if (g != null && g.i$b != null && z >= 0 && z < g.i$b.count) {
                z = g.i$b._inner[z];
            }
            if (x >= (this.valueColumn.count - 1)) {
                if (l && this.qk(a, a.f._inner[a.f.count - 1], u, Math.min(z, this.bz.count - 1), m, f, w - 1)) {
                    ++m;
                }
                break;
            }
            var aa = p(x);
            var ab = q(x);
            var ac = p(x + 1);
            var ad = q(x + 1);
            var ae = ac - aa;
            var af = this.qh[x];
            var ag = this.qh[x + 1];
            var ah = g.i$d(g.i$b._inner[x]);
            var ai = d.dw(ah, i) + n;
            var aj = e.dw(ab, j);
            a.f.add([ai, aj, aj]);
            w++;
            for (var ak = 1; ak < t; ++ak) {
                var al = ak / t;
                var am = aa + ae * al;
                var an = (ac - am) / ae;
                var ao = (am - aa) / ae;
                var ap = an * ab + ao * ad + ((an * an * an - an) * af + (ao * ao * ao - ao) * ag) * (ae * ae) / 6;
                var aq = g.i$d(g.i$b._inner[x]);
                var ar = g.i$d(g.i$b._inner[x + 1]);
                if (aq == ar && ab == ad) {
                    break;
                }
                var as = aq + (ar - aq) * al;
                am = d.dw(as, i) + n;
                ap = e.dw(ap, j);
                a.f.add([am, ap, ap]);
                w++;
            }
            if (l) {
                y = [ai, aj, aj];
            }
            if (l && this.qk(a, y, u, Math.min(z, this.bz.count - 1), m, f, w - 1)) {
                ++m;
            }
        }
        this.nf.cq.count = m;
    };
    SplineFragmentBase.prototype.ol = function (a, b) {
        var _this = this;
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
            return;
        }
        if (this.logicalSeriesLink.ad.count == 0 || this.logicalSeriesLink.ac.count == 0) {
            return;
        }
        if (this.nf.cn.d == 0) {
            return;
        }
        _super.prototype.ol.call(this, a, b);
        if (a.f.count <= 1) {
            return;
        }
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        var g = typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis());
        var h = new ScalerParams(0, c, d, f.b8, e);
        var i = new ScalerParams(0, c, d, g.b8, e);
        a.f.clear();
        a.m.clear();
        var j = this.l3();
        var k = 0;
        var l;
        var m;
        if (b.m) {
            l = this.parentSeries.ox;
            m = this.parentSeries.a0.a$h.item(b.aa);
        }
        else if (b == this.bh) {
            l = this.parentSeries.m9;
            m = typeCast(CategorySeriesView.$, this.parentSeries.bh);
        }
        else {
            l = this.parentSeries.m7;
            m = this.parentSeries.nf;
        }
        var n = m.cn.d;
        var o = typeCast(ISortingAxis_$type, f);
        if (o != null && o.i$b.count != this.bz.count) {
            return;
        }
        var p = this.preferredCategoryMode(f);
        if (p == 0 && f.categoryMode != 0) {
            p = 1;
        }
        var q = 0;
        switch (p) {
            case 0:
                q = 0;
                break;
            case 1:
                q = 0.5 * f.getCategorySize(c, d, e);
                break;
            case 2:
                var r = this.fh;
                q = f.getGroupCenter(this.fh, c, d, e);
                break;
        }
        if (f.b8) {
            q = -q;
        }
        var s = function (t) { return Math.abs(_this.parentSeries.ow[t]) + _this.parentSeries.ov[t]; };
        var t = function (u) { return u; };
        var u = function (v) {
            var w = _this.valueColumn.item(v);
            if (isNaN_(w) || isInfinity(w)) {
                w = 0;
            }
            if (typeCast(IStacked100Series_$type, _this.parentSeries) !== null) {
                if (s(v) == 0) {
                    return 0;
                }
                return w < 0 ? (_this.logicalSeriesLink.ad._inner[v] + w) / s(v) * 100 : (_this.logicalSeriesLink.ac._inner[v] + w) / s(v) * 100;
            }
            return w < 0 ? _this.logicalSeriesLink.ad._inner[v] + w : _this.logicalSeriesLink.ac._inner[v] + w;
        };
        var v = b.cn.d;
        var w = this.qj == 0 ? NaN : 0;
        if (f != null && typeCast(ISortingAxis_$type, f) !== null && f.i$b != null) {
            var x_1 = new SafeSortedReadOnlyDoubleCollection(0, this.valueColumn, f.i$b);
            u = function (y) { return x_1.item(y); };
        }
        this.qh = Numeric.c(this.valueColumn.count, t, u, w, w);
        var y = m.cn.e;
        var z = m.cn.f;
        var aa = truncate(Math.ceil(d.width / (z - y)));
        var ab = new CollisionAvoider();
        if (o != null) {
            this.qv(a, c, d, f, g, b);
            return;
        }
        var ac = 0;
        var ad = 0;
        for (var ae = y; ae < z + 1; ++ae) {
            if (ae >= this.valueColumn.count) {
                break;
            }
            var af = null;
            if (v == 1) {
                if (ae >= (this.valueColumn.count - 1)) {
                    if (j && a.f.count > 0 && this.qk(a, a.f._inner[a.f.count - 1], ab, Math.min(ae * v, this.bz.count - 1), k, b, ac - 1)) {
                        ++k;
                    }
                    break;
                }
                var ag = t(ae);
                var ah = t(ae + 1);
                var ai = u(ae);
                var aj = u(ae + 1);
                var ak = ah - ag;
                var al = this.qh[ae];
                var am = this.qh[ae + 1];
                var an = f.dw(ag, h) + q;
                var ao = g.dw(ai, i);
                a.f.add([an, ao, ao]);
                ac++;
                ad = ac;
                for (var ap = 1; ap < aa; ++ap) {
                    var aq = ag + ak * ap / aa;
                    var ar = (ah - aq) / ak;
                    var as = (aq - ag) / ak;
                    var at = ar * ai + as * aj + ((ar * ar * ar - ar) * al + (as * as * as - as) * am) * (ak * ak) / 6;
                    aq = f.dw(aq, h) + q;
                    at = g.dw(at, i);
                    a.f.add([aq, at, at]);
                    ac++;
                }
                if (j) {
                    af = [an, ao, ao];
                }
            }
            else {
                af = b.cn.getBucket(ae);
                if (!isNaN_(af[0])) {
                    af[0] = f.dw(af[0], h) + q;
                    af[1] = g.dw(af[1], i);
                    af[2] = g.dw(af[2], i);
                    a.f.add(af);
                }
            }
            if (j && this.qk(a, af, ab, Math.min(ae * v, this.bz.count - 1), k, b, ad - 1)) {
                ++k;
            }
        }
        b.cq.count = k;
    };
    SplineFragmentBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "ActualBrush":
                if (this.logicalSeriesLink != null) {
                    this.logicalSeriesLink.fp = this.k3;
                }
                break;
        }
    };
    Object.defineProperty(SplineFragmentBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineFragmentBase.$t = markType(SplineFragmentBase, 'SplineFragmentBase', SplineSeriesBase.$);
    return SplineFragmentBase;
}(SplineSeriesBase));
/**
 * @hidden
 */
var SplineAreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaFragment, _super);
    function SplineAreaFragment() {
        var _this = _super.call(this) || this;
        _this.q0 = null;
        _this.ab = SplineAreaFragment.$;
        return _this;
    }
    SplineAreaFragment.prototype.bf = function () {
        return new SplineAreaFragmentView(this);
    };
    SplineAreaFragment.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qw = typeCast(SplineAreaFragmentView.$, a);
    };
    SplineAreaFragment.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    SplineAreaFragment.prototype.get_ck = function () {
        return true;
    };
    SplineAreaFragment.prototype.qy = function (a, b) {
        var c = this.qw.c9.ak;
        if (this.dj(a, c)) {
            return true;
        }
        var d = this.qw.da.ak;
        if (this.dj(a, d)) {
            return true;
        }
        return false;
    };
    SplineAreaFragment.prototype.dh = function (a, b) {
        if (this.qx(a, b)) {
            return true;
        }
        if (this.qy(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    SplineAreaFragment.prototype.qx = function (a, b) {
        var c = this.qw.db.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        var d = this.qw.dc.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    };
    SplineAreaFragment.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c8();
    };
    SplineAreaFragment.prototype.oo = function (a, b) {
        var _this = this;
        _super.prototype.oo.call(this, a, b);
        this.qr.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        var c = typeCast(SplineAreaFragmentView.$, b);
        var d = b.cn.d;
        this.qr.i(c.c9, c.db, c.da, c.dc, a.f.count, a.f, true, d, this.eu, function (e, f, g, h, i) { return _this.qz(e, a.f, b); }, 1);
        c.c9._opacity = this.d6;
        c.da._opacity = 0.5 * this.d6;
    };
    SplineAreaFragment.prototype.jf = function (a, b) {
        _super.prototype.jf.call(this, a, b);
    };
    SplineAreaFragment.prototype.qz = function (a, b, c) {
        var d = this.o7(c);
        var e = d;
        var f = this.logicalSeriesLink.y;
        var g = f ? this.parentSeries.o3.e : this.parentSeries.o3.d;
        var h = g.indexOf(this);
        if (a.count == 0) {
            return;
        }
        if (h == -1) {
            return;
        }
        var i = false;
        for (var j = h; j >= 0; j--) {
            if (i) {
                break;
            }
            if (j == 0) {
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
                break;
            }
            var k = typeCast(SplineFragmentBase.$, g._inner[j - 1]);
            if (k != null && k.qr != null && k.qr.o.count > 0 && this.bi != null && k.dw(this.bi.br, this.bi.bs, this.bi)) {
                i = true;
                for (var l = k.qr.o.count - 1; l >= 0; l--) {
                    a.add(k.qr.o._inner[l]);
                }
            }
        }
    };
    SplineAreaFragment.prototype.o7 = function (a) {
        var b = 0;
        var c = a.bs;
        var d = a.br;
        var e = this.getEffectiveViewport1(a);
        var f = new ScalerParams(0, c, d, this.yAxis.b8, e);
        if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
            b = this.yAxis.dw(0, f);
        }
        return b;
    };
    SplineAreaFragment.prototype.jn = function () {
        var a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? this.parentSeries.d6 : this.d7;
        }
    };
    Object.defineProperty(SplineAreaFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineAreaFragment.$t = markType(SplineAreaFragment, 'SplineAreaFragment', SplineFragmentBase.$);
    return SplineAreaFragment;
}(SplineFragmentBase));
/**
 * @hidden
 */
var SplineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineFragment, _super);
    function SplineFragment() {
        var _this = _super.call(this) || this;
        _this.ab = SplineFragment.$;
        return _this;
    }
    SplineFragment.prototype.bf = function () {
        return new SplineFragmentView(this);
    };
    SplineFragment.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.qw = a;
    };
    SplineFragment.prototype.qy = function (a, b) {
        var c = this.qw.c9.ak;
        if (this.dj(a, c)) {
            return true;
        }
        return false;
    };
    SplineFragment.prototype.get_ck = function () {
        return true;
    };
    SplineFragment.prototype.dh = function (a, b) {
        if (this.qx(a, b)) {
            return true;
        }
        if (this.qy(a, b)) {
            return true;
        }
        if (this.l4(a, b)) {
            return true;
        }
        return false;
    };
    SplineFragment.prototype.qx = function (a, b) {
        var c = this.qw.da.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        var d = this.qw.db.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    };
    SplineFragment.prototype.hv = function (a, b) {
        _super.prototype.hv.call(this, a, b);
        var c = b;
        c.c8();
    };
    SplineFragment.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        this.qr.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        var c = typeCast(SplineFragmentView.$, b);
        var d = c.cn.d;
        this.qr.m(c.da, c.c9, c.db, a.f.count, a.f, true, 1, this.ow(a.f, a.f.count - 1, b.br, b.bs), d, this.eu);
    };
    Object.defineProperty(SplineFragment.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    SplineFragment.$t = markType(SplineFragment, 'SplineFragment', SplineFragmentBase.$);
    return SplineFragment;
}(SplineFragmentBase));
/**
 * @hidden
 */
var StackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesBase, _super);
    function StackedSeriesBase() {
        var _this = _super.call(this) || this;
        _this._series = null;
        _this.seriesCreated = null;
        _this.pc = 0;
        _this.pb = 0;
        _this.ov = null;
        _this.ow = null;
        _this.o3 = null;
        _this.o0 = null;
        _this.o8 = new Dictionary$2(String_$type, Boolean_$type, 0);
        _this.ox = null;
        _this.series = new StackedSeriesCollection();
        var a = _this.series;
        a.collectionResetting = delegateCombine(a.collectionResetting, runOn(_this, _this.po));
        var b = _this.series;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(_this, _this.pn));
        _this.nb = new StackedSeriesFramePreparer(1, _this, _this.o4, _this, _this, _this.o4.cn);
        _this.o3 = new StackedSeriesManager(_this);
        _this.o0 = new StackedSeriesCollection();
        var c = _this.o0;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(_this, _this.pn));
        var d = _this.o0;
        d.collectionResetting = delegateCombine(d.collectionResetting, runOn(_this, _this.pi));
        return _this;
    }
    StackedSeriesBase.prototype.get_cv = function () {
        return false;
    };
    StackedSeriesBase.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    StackedSeriesBase.prototype.bf = function () {
        return new StackedSeriesView(this);
    };
    StackedSeriesBase.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.o4 = a;
    };
    StackedSeriesBase.prototype.iv = function (a, b) {
        var e_1, _a;
        _super.prototype.iv.call(this, a, b);
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.visualSeriesLink.bi.br = b;
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    Object.defineProperty(StackedSeriesBase.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesBase.prototype.fg = function () {
        if (this.series == null) {
            return -1;
        }
        return this.series.count;
    };
    StackedSeriesBase.prototype.h7 = function (a) {
        for (var b = 0; b < this.o3.f.count; b++) {
            var c = this.o3.f._inner[b];
            if (!a(c)) {
                break;
            }
        }
    };
    StackedSeriesBase.prototype.get_isStacked = function () {
        return true;
    };
    Object.defineProperty(StackedSeriesBase.prototype, "oz", {
        get: function () {
            return this.o5 ? this.o0 : this.series;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesBase.prototype.pi = function (a, b) {
        var e_2, _a;
        try {
            for (var _b = __values(fromEnum(this.o0)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (this.o3 != null && this.o3.c.contains(c)) {
                    c.parentSeries = null;
                    this.o3.c.remove(c);
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    StackedSeriesBase.prototype.po = function (a, b) {
        var e_3, _a;
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (this.o3 != null && this.o3.c.contains(c)) {
                    c.parentSeries = null;
                    this.o3.c.remove(c);
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    StackedSeriesBase.prototype.pn = function (a, b) {
        var e_4, _a, e_5, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    if (this.o3 != null && this.o3.c.contains(c)) {
                        c.parentSeries = null;
                        this.o3.c.remove(c);
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        }
        if (b.newItems != null) {
            var d = b.newStartingIndex;
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    if (this.o3 != null && !this.o3.c.contains(e)) {
                        e.parentSeries = this;
                        e.c1();
                        e.dg();
                        e.dh();
                        e.dp();
                        e.di();
                        e.dj();
                        e.cx();
                        e.cy();
                        e.cz();
                        e.c0();
                        e.c2();
                        e.c3();
                        e.c4();
                        e.c5();
                        e.c9();
                        e.da();
                        e.c6();
                        e.c7();
                        e.c8();
                        e.c9();
                        e.db();
                        e.dc();
                        e.dd();
                        e.cw();
                        e.de();
                        e.df();
                        e.dk();
                        e.dl();
                        e.dm();
                        e.dn();
                        e.dq();
                        if (!this.o5) {
                            this.o3.c.insert(d, e);
                            d++;
                        }
                    }
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
        }
        if (!this.o5) {
            this.pp();
        }
    };
    StackedSeriesBase.prototype.jk = function (a) {
        this.bq.bn.c1(a, true, false);
    };
    StackedSeriesBase.prototype.nc = function (a) {
        if (a != null && a.n) {
            if (a.m) {
                return new StackedSeriesFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, a), a, this, a.cn);
            }
            else {
                var b = typeCast(CategorySeriesView.$, this.bh);
                return new StackedSeriesFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.bs.bn.m, this, b.cn);
            }
        }
        else {
            return this.nb;
        }
    };
    StackedSeriesBase.prototype.ol = function (a, b) {
        a.u();
        this.pl();
        this.nc(b).d(a, b);
    };
    StackedSeriesBase.prototype.hv = function (a, b) {
        var e_6, _a;
        _super.prototype.hv.call(this, a, b);
        try {
            for (var _b = __values(fromEnum(this.oz)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (c.visualSeriesLink != null) {
                    c.visualSeriesLink.hv(a, c.visualSeriesLink.bi);
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
    };
    StackedSeriesBase.prototype.pj = function () {
        this.pl();
    };
    StackedSeriesBase.prototype.pp = function () {
        var a = this.fetchXAxis();
        if (a != null) {
            a.cm(true);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.cm(true);
        }
    };
    StackedSeriesBase.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bs != null ? this.bs.mq : Rect.empty;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ls(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            var g = this.fetchXAxis();
            if (g != null) {
                var h = new ScalerParams(0, e, e, g.b8, f);
                var i = g.dw(b, h);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            var j = this.fetchYAxis();
            if (j != null && this.ov != null && b < this.ov.length) {
                var k = new ScalerParams(0, e, e, j.b8, f);
                var l = j.dw(this.ov[b], k);
                var m = j.dw(this.ow[b], k);
                if (!isNaN_(l) && !isNaN_(m)) {
                    var n = Math.abs(m - l);
                    if (c.height < n) {
                        c.height = n;
                        c.y = Math.min(m, l);
                    }
                    else {
                        if (m < c.top + 0.1 * c.height) {
                            m = m + 0.4 * c.height;
                        }
                        if (m > c.bottom - 0.1 * c.height) {
                            m = m - 0.4 * c.height;
                        }
                        c.y = m - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    StackedSeriesBase.prototype.an = function (a) {
        if (this.ow == null || this.ow.length == 0 || this.ov == null || this.ov.length == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            var b = Math.min(this.ow.length, this.ov.length);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedSeriesBase.prototype.l3 = function () {
        return false;
    };
    StackedSeriesBase.prototype.hy = function (a, b, c, d) {
        this.pl();
        this.n1();
        this.jd(false);
    };
    StackedSeriesBase.prototype.oy = function () {
        return this.o4;
    };
    StackedSeriesBase.prototype.o9 = function () {
        var a = 0;
        var b = this.bi.bs;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        var e = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!b.isEmpty && !c.isEmpty && e != null) {
            var f = new ScalerParams(0, b, c, e.b8, d);
            a = e.dw(e.ke, f);
        }
        return a;
    };
    StackedSeriesBase.prototype.pa = function () {
        var a = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (a != null) {
            return a.ke;
        }
        return 0;
    };
    StackedSeriesBase.prototype.pe = function (a) {
        return this.fh < 0 || this.oz == null || this.oz.count == 0 ? -1 : this.fh + this.oz.indexOf(a);
    };
    StackedSeriesBase.prototype.pd = function (a) {
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        var e = typeCast(CategoryAxisBase.$, this.fetchXAxis());
        var f = -1;
        if (e != null && !b.isEmpty && !c.isEmpty) {
            var g = new ScalerParams(0, b, c, e.b8, d);
            var h = this.lq(this.bi);
            var i = e.dz(h.left, g);
            var j = e.dz(h.right, g);
            var k = (a.x - b.left) / b.width;
            var l = i + (k * (j - i));
            if (e.categoryMode != 0) {
                l -= 0.5;
            }
            var m = truncate(Math.round(l));
            f = m;
        }
        return f;
    };
    StackedSeriesBase.prototype.o7 = function (a, b, c, d) {
        var e = true;
        var f = typeCast(CategoryAxisBase.$, this.fetchXAxis());
        var g = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!d.l() || c.isEmpty || b.isEmpty || f == null || f.itemsSource == null || g == null || this.bz == null || f.bf == null || g.bf == null || g.j4 == g.j3) {
            e = false;
        }
        var h = d;
        var i = h.cn.d;
        if (a.valueColumn == null || a.valueColumn.count == 0 || i < 1 || a._visibility != 0) {
            e = false;
        }
        return e;
    };
    StackedSeriesBase.prototype.pk = function () {
        var e_7, _a;
        if (this.bs == null || this.o3 == null) {
            return;
        }
        if (!this.o5) {
            this.o0.clear();
            try {
                for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    if (!this.o3.c.contains(a)) {
                        this.o3.c.add(a);
                    }
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
            this.pp();
            return;
        }
    };
    StackedSeriesBase.prototype.oo = function (a, b) {
        _super.prototype.oo.call(this, a, b);
        this.o3.h();
    };
    StackedSeriesBase.prototype.pm = function (a, b, c) {
    };
    StackedSeriesBase.prototype.pl = function () {
        var e_8, _a;
        if (this.bz == null) {
            return;
        }
        var a = this.bz.count;
        this.ov = new Array(a);
        this.ow = new Array(a);
        for (var b = 0; b < a; b++) {
            this.ov[b] = 0;
            this.ow[b] = 0;
        }
        this.pc = Number.POSITIVE_INFINITY;
        this.pb = Number.NEGATIVE_INFINITY;
        var c = 0;
        try {
            for (var _b = __values(fromEnum(this.oz)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                this.bz.deregisterColumn(d.p);
                d.p = this.bw(d.cq);
                if (d.visualSeriesLink != null) {
                    d.visualSeriesLink.o6 = true;
                    d.visualSeriesLink.valueColumn = d.p;
                    d.visualSeriesLink.o6 = false;
                }
                d.y = true;
                if (d.p != null) {
                    d.ac.clear();
                    d.ad.clear();
                    for (var e = 0; e < d.p.count; e++) {
                        var f = d.p.item(e);
                        if (f < c) {
                            d.ac.add(c);
                            d.ad.add(this.ow[e]);
                            this.ow[e] = this.ow[e] + f;
                            if (d.y) {
                                d.y = false;
                            }
                        }
                        else if (f >= c) {
                            d.ac.add(this.ov[e]);
                            d.ad.add(c);
                            this.ov[e] = this.ov[e] + f;
                        }
                        else if (isNaN_(f) || isInfinity(f)) {
                            d.ac.add(this.ov[e]);
                            d.ad.add(this.ow[e]);
                        }
                    }
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        for (var g = 0; g < a; g++) {
            this.pc = Math.min(this.pc, this.ow[g]);
            this.pb = Math.max(this.pb, this.ov[g]);
        }
    };
    StackedSeriesBase.prototype.iz = function (a, b, c, d) {
        var e_9, _a, e_10, _b, e_11, _c, e_12, _d, e_13, _e, e_14, _f, e_15, _g, e_16, _h, e_17, _j, e_18, _k, e_19, _l, e_20, _m, e_21, _o, e_22, _p, e_23, _q, e_24, _r, e_25, _s, e_26, _t, e_27, _u, e_28, _v, e_29, _w, e_30, _x, e_31, _y, e_32, _z, e_33, _0, e_34, _1, e_35, _2, e_36, _3, e_37, _4, e_38, _5;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.hz(this.fetchXAxis());
                    this.hz(this.fetchYAxis());
                }
                if (c == null && d != null) {
                    this.i4(this.fetchXAxis());
                    this.i4(this.fetchYAxis());
                }
                if (this.oz != null) {
                    try {
                        for (var _6 = __values(fromEnum(this.oz)), _7 = _6.next(); !_7.done; _7 = _6.next()) {
                            var e = _7.value;
                            e.o = this.bs;
                        }
                    }
                    catch (e_9_1) {
                        e_9 = { error: e_9_1 };
                    }
                    finally {
                        try {
                            if (_7 && !_7.done && (_a = _6.return))
                                _a.call(_6);
                        }
                        finally {
                            if (e_9)
                                throw e_9.error;
                        }
                    }
                    this.jd(false);
                }
                break;
            case "ItemsSource":
                if (this.oz != null) {
                    try {
                        for (var _8 = __values(fromEnum(this.oz)), _9 = _8.next(); !_9.done; _9 = _8.next()) {
                            var f = _9.value;
                            if (f.visualSeriesLink != null) {
                                f.visualSeriesLink.itemsSource = d;
                            }
                        }
                    }
                    catch (e_10_1) {
                        e_10 = { error: e_10_1 };
                    }
                    finally {
                        try {
                            if (_9 && !_9.done && (_b = _8.return))
                                _b.call(_8);
                        }
                        finally {
                            if (e_10)
                                throw e_10.error;
                        }
                    }
                }
                break;
            case "FastItemsSource":
                if (this.o5) {
                    this.pk();
                }
                if (!this.n1()) {
                    this.o4.cn.g(this.eu);
                }
                this.jd(false);
                break;
            case StackedSeriesBase.$$p[0]:
                this.pk();
                break;
            case StackedSeriesBase.$$p[1]:
                if (this.bs != null) {
                    this.bs.ij(this.o3.f);
                }
                break;
            case StackedSeriesBase.$$p[2]:
                try {
                    for (var _10 = __values(fromEnum(this.oz)), _11 = _10.next(); !_11.done; _11 = _10.next()) {
                        var g = _11.value;
                        g.dq();
                    }
                }
                catch (e_11_1) {
                    e_11 = { error: e_11_1 };
                }
                finally {
                    try {
                        if (_11 && !_11.done && (_c = _10.return))
                            _c.call(_10);
                    }
                    finally {
                        if (e_11)
                            throw e_11.error;
                    }
                }
                break;
            case "Brush":
                try {
                    for (var _12 = __values(fromEnum(this.oz)), _13 = _12.next(); !_13.done; _13 = _12.next()) {
                        var h = _13.value;
                        h.cx();
                    }
                }
                catch (e_12_1) {
                    e_12 = { error: e_12_1 };
                }
                finally {
                    try {
                        if (_13 && !_13.done && (_d = _12.return))
                            _d.call(_12);
                    }
                    finally {
                        if (e_12)
                            throw e_12.error;
                    }
                }
                break;
            case "DashArray":
                try {
                    for (var _14 = __values(fromEnum(this.oz)), _15 = _14.next(); !_15.done; _15 = _14.next()) {
                        var i = _15.value;
                        i.cy();
                    }
                }
                catch (e_13_1) {
                    e_13 = { error: e_13_1 };
                }
                finally {
                    try {
                        if (_15 && !_15.done && (_e = _14.return))
                            _e.call(_14);
                    }
                    finally {
                        if (e_13)
                            throw e_13.error;
                    }
                }
                break;
            case "DashCap":
                try {
                    for (var _16 = __values(fromEnum(this.oz)), _17 = _16.next(); !_17.done; _17 = _16.next()) {
                        var j = _17.value;
                        j.cz();
                    }
                }
                catch (e_14_1) {
                    e_14 = { error: e_14_1 };
                }
                finally {
                    try {
                        if (_17 && !_17.done && (_f = _16.return))
                            _f.call(_16);
                    }
                    finally {
                        if (e_14)
                            throw e_14.error;
                    }
                }
                break;
            case "IsDropShadowEnabled":
                try {
                    for (var _18 = __values(fromEnum(this.oz)), _19 = _18.next(); !_19.done; _19 = _18.next()) {
                        var k = _19.value;
                        k.c1();
                    }
                }
                catch (e_15_1) {
                    e_15 = { error: e_15_1 };
                }
                finally {
                    try {
                        if (_19 && !_19.done && (_g = _18.return))
                            _g.call(_18);
                    }
                    finally {
                        if (e_15)
                            throw e_15.error;
                    }
                }
                break;
            case "ShadowBlur":
                try {
                    for (var _20 = __values(fromEnum(this.oz)), _21 = _20.next(); !_21.done; _21 = _20.next()) {
                        var l = _21.value;
                        l.dg();
                    }
                }
                catch (e_16_1) {
                    e_16 = { error: e_16_1 };
                }
                finally {
                    try {
                        if (_21 && !_21.done && (_h = _20.return))
                            _h.call(_20);
                    }
                    finally {
                        if (e_16)
                            throw e_16.error;
                    }
                }
                break;
            case "ShadowColor":
                try {
                    for (var _22 = __values(fromEnum(this.oz)), _23 = _22.next(); !_23.done; _23 = _22.next()) {
                        var m = _23.value;
                        m.dh();
                    }
                }
                catch (e_17_1) {
                    e_17 = { error: e_17_1 };
                }
                finally {
                    try {
                        if (_23 && !_23.done && (_j = _22.return))
                            _j.call(_22);
                    }
                    finally {
                        if (e_17)
                            throw e_17.error;
                    }
                }
                break;
            case "UseSingleShadow":
                try {
                    for (var _24 = __values(fromEnum(this.oz)), _25 = _24.next(); !_25.done; _25 = _24.next()) {
                        var n = _25.value;
                        n.dp();
                    }
                }
                catch (e_18_1) {
                    e_18 = { error: e_18_1 };
                }
                finally {
                    try {
                        if (_25 && !_25.done && (_k = _24.return))
                            _k.call(_24);
                    }
                    finally {
                        if (e_18)
                            throw e_18.error;
                    }
                }
                break;
            case "ShadowOffsetX":
                try {
                    for (var _26 = __values(fromEnum(this.oz)), _27 = _26.next(); !_27.done; _27 = _26.next()) {
                        var o = _27.value;
                        o.di();
                    }
                }
                catch (e_19_1) {
                    e_19 = { error: e_19_1 };
                }
                finally {
                    try {
                        if (_27 && !_27.done && (_l = _26.return))
                            _l.call(_26);
                    }
                    finally {
                        if (e_19)
                            throw e_19.error;
                    }
                }
                break;
            case "ShadowOffsetY":
                try {
                    for (var _28 = __values(fromEnum(this.oz)), _29 = _28.next(); !_29.done; _29 = _28.next()) {
                        var p = _29.value;
                        p.dj();
                    }
                }
                catch (e_20_1) {
                    e_20 = { error: e_20_1 };
                }
                finally {
                    try {
                        if (_29 && !_29.done && (_m = _28.return))
                            _m.call(_28);
                    }
                    finally {
                        if (e_20)
                            throw e_20.error;
                    }
                }
                break;
            case "EndCap":
                try {
                    for (var _30 = __values(fromEnum(this.oz)), _31 = _30.next(); !_31.done; _31 = _30.next()) {
                        var q = _31.value;
                        q.c0();
                    }
                }
                catch (e_21_1) {
                    e_21 = { error: e_21_1 };
                }
                finally {
                    try {
                        if (_31 && !_31.done && (_o = _30.return))
                            _o.call(_30);
                    }
                    finally {
                        if (e_21)
                            throw e_21.error;
                    }
                }
                break;
            case "IsHitTestVisible":
                try {
                    for (var _32 = __values(fromEnum(this.oz)), _33 = _32.next(); !_33.done; _33 = _32.next()) {
                        var r = _33.value;
                        r.c2();
                    }
                }
                catch (e_22_1) {
                    e_22 = { error: e_22_1 };
                }
                finally {
                    try {
                        if (_33 && !_33.done && (_p = _32.return))
                            _p.call(_32);
                    }
                    finally {
                        if (e_22)
                            throw e_22.error;
                    }
                }
                break;
            case "LegendItemBadgeTemplate":
                try {
                    for (var _34 = __values(fromEnum(this.oz)), _35 = _34.next(); !_35.done; _35 = _34.next()) {
                        var s = _35.value;
                        s.c3();
                    }
                }
                catch (e_23_1) {
                    e_23 = { error: e_23_1 };
                }
                finally {
                    try {
                        if (_35 && !_35.done && (_q = _34.return))
                            _q.call(_34);
                    }
                    finally {
                        if (e_23)
                            throw e_23.error;
                    }
                }
                break;
            case "LegendItemTemplate":
                try {
                    for (var _36 = __values(fromEnum(this.oz)), _37 = _36.next(); !_37.done; _37 = _36.next()) {
                        var t = _37.value;
                        t.c4();
                    }
                }
                catch (e_24_1) {
                    e_24 = { error: e_24_1 };
                }
                finally {
                    try {
                        if (_37 && !_37.done && (_r = _36.return))
                            _r.call(_36);
                    }
                    finally {
                        if (e_24)
                            throw e_24.error;
                    }
                }
                break;
            case "LegendItemVisibility":
                try {
                    for (var _38 = __values(fromEnum(this.oz)), _39 = _38.next(); !_39.done; _39 = _38.next()) {
                        var u = _39.value;
                        u.c5();
                    }
                }
                catch (e_25_1) {
                    e_25 = { error: e_25_1 };
                }
                finally {
                    try {
                        if (_39 && !_39.done && (_s = _38.return))
                            _s.call(_38);
                    }
                    finally {
                        if (e_25)
                            throw e_25.error;
                    }
                }
                break;
            case "MarkerTemplate":
                try {
                    for (var _40 = __values(fromEnum(this.oz)), _41 = _40.next(); !_41.done; _41 = _40.next()) {
                        var v = _41.value;
                        v.c9();
                    }
                }
                catch (e_26_1) {
                    e_26 = { error: e_26_1 };
                }
                finally {
                    try {
                        if (_41 && !_41.done && (_t = _40.return))
                            _t.call(_40);
                    }
                    finally {
                        if (e_26)
                            throw e_26.error;
                    }
                }
                break;
            case "MarkerType":
                try {
                    for (var _42 = __values(fromEnum(this.oz)), _43 = _42.next(); !_43.done; _43 = _42.next()) {
                        var w = _43.value;
                        w.da();
                    }
                }
                catch (e_27_1) {
                    e_27 = { error: e_27_1 };
                }
                finally {
                    try {
                        if (_43 && !_43.done && (_u = _42.return))
                            _u.call(_42);
                    }
                    finally {
                        if (e_27)
                            throw e_27.error;
                    }
                }
                break;
            case "MarkerBrush":
                try {
                    for (var _44 = __values(fromEnum(this.oz)), _45 = _44.next(); !_45.done; _45 = _44.next()) {
                        var x = _45.value;
                        x.c6();
                    }
                }
                catch (e_28_1) {
                    e_28 = { error: e_28_1 };
                }
                finally {
                    try {
                        if (_45 && !_45.done && (_v = _44.return))
                            _v.call(_44);
                    }
                    finally {
                        if (e_28)
                            throw e_28.error;
                    }
                }
                break;
            case "MarkerOutline":
                try {
                    for (var _46 = __values(fromEnum(this.oz)), _47 = _46.next(); !_47.done; _47 = _46.next()) {
                        var y = _47.value;
                        y.c7();
                    }
                }
                catch (e_29_1) {
                    e_29 = { error: e_29_1 };
                }
                finally {
                    try {
                        if (_47 && !_47.done && (_w = _46.return))
                            _w.call(_46);
                    }
                    finally {
                        if (e_29)
                            throw e_29.error;
                    }
                }
                break;
            case "MarkerStyle":
                try {
                    for (var _48 = __values(fromEnum(this.oz)), _49 = _48.next(); !_49.done; _49 = _48.next()) {
                        var z = _49.value;
                        z.c8();
                    }
                }
                catch (e_30_1) {
                    e_30 = { error: e_30_1 };
                }
                finally {
                    try {
                        if (_49 && !_49.done && (_x = _48.return))
                            _x.call(_48);
                    }
                    finally {
                        if (e_30)
                            throw e_30.error;
                    }
                }
                break;
            case "Opacity":
                try {
                    for (var _50 = __values(fromEnum(this.oz)), _51 = _50.next(); !_51.done; _51 = _50.next()) {
                        var aa = _51.value;
                        aa.db();
                    }
                }
                catch (e_31_1) {
                    e_31 = { error: e_31_1 };
                }
                finally {
                    try {
                        if (_51 && !_51.done && (_y = _50.return))
                            _y.call(_50);
                    }
                    finally {
                        if (e_31)
                            throw e_31.error;
                    }
                }
                break;
            case "OpacityMask":
                try {
                    for (var _52 = __values(fromEnum(this.oz)), _53 = _52.next(); !_53.done; _53 = _52.next()) {
                        var ab = _53.value;
                        ab.dc();
                    }
                }
                catch (e_32_1) {
                    e_32 = { error: e_32_1 };
                }
                finally {
                    try {
                        if (_53 && !_53.done && (_z = _52.return))
                            _z.call(_52);
                    }
                    finally {
                        if (e_32)
                            throw e_32.error;
                    }
                }
                break;
            case "AreaFillOpacity":
                try {
                    for (var _54 = __values(fromEnum(this.oz)), _55 = _54.next(); !_55.done; _55 = _54.next()) {
                        var ac = _55.value;
                        ac.cw();
                    }
                }
                catch (e_33_1) {
                    e_33 = { error: e_33_1 };
                }
                finally {
                    try {
                        if (_55 && !_55.done && (_0 = _54.return))
                            _0.call(_54);
                    }
                    finally {
                        if (e_33)
                            throw e_33.error;
                    }
                }
                break;
            case "Outline":
                try {
                    for (var _56 = __values(fromEnum(this.oz)), _57 = _56.next(); !_57.done; _57 = _56.next()) {
                        var ad = _57.value;
                        ad.dd();
                    }
                }
                catch (e_34_1) {
                    e_34 = { error: e_34_1 };
                }
                finally {
                    try {
                        if (_57 && !_57.done && (_1 = _56.return))
                            _1.call(_56);
                    }
                    finally {
                        if (e_34)
                            throw e_34.error;
                    }
                }
                break;
            case "StartCap":
                try {
                    for (var _58 = __values(fromEnum(this.oz)), _59 = _58.next(); !_59.done; _59 = _58.next()) {
                        var ae = _59.value;
                        ae.dk();
                    }
                }
                catch (e_35_1) {
                    e_35 = { error: e_35_1 };
                }
                finally {
                    try {
                        if (_59 && !_59.done && (_2 = _58.return))
                            _2.call(_58);
                    }
                    finally {
                        if (e_35)
                            throw e_35.error;
                    }
                }
                break;
            case "Thickness":
                try {
                    for (var _60 = __values(fromEnum(this.oz)), _61 = _60.next(); !_61.done; _61 = _60.next()) {
                        var af = _61.value;
                        af.dl();
                    }
                }
                catch (e_36_1) {
                    e_36 = { error: e_36_1 };
                }
                finally {
                    try {
                        if (_61 && !_61.done && (_3 = _60.return))
                            _3.call(_60);
                    }
                    finally {
                        if (e_36)
                            throw e_36.error;
                    }
                }
                break;
            case "ToolTip":
                try {
                    for (var _62 = __values(fromEnum(this.oz)), _63 = _62.next(); !_63.done; _63 = _62.next()) {
                        var ag = _63.value;
                        ag.dm();
                    }
                }
                catch (e_37_1) {
                    e_37 = { error: e_37_1 };
                }
                finally {
                    try {
                        if (_63 && !_63.done && (_4 = _62.return))
                            _4.call(_62);
                    }
                    finally {
                        if (e_37)
                            throw e_37.error;
                    }
                }
                break;
            case "UseLightweightMarkers":
                try {
                    for (var _64 = __values(fromEnum(this.oz)), _65 = _64.next(); !_65.done; _65 = _64.next()) {
                        var ah = _65.value;
                        ah.dn();
                    }
                }
                catch (e_38_1) {
                    e_38 = { error: e_38_1 };
                }
                finally {
                    try {
                        if (_65 && !_65.done && (_5 = _64.return))
                            _5.call(_64);
                    }
                    finally {
                        if (e_38)
                            throw e_38.error;
                    }
                }
                break;
        }
    };
    Object.defineProperty(StackedSeriesBase.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesBase.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesBase.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesBase.prototype, "bucketizer", {
        get: function () {
            return this.nf.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesBase.prototype, "currentMode2Index", {
        get: function () {
            return this.n9();
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesBase.prototype.provideCollisionDetector = function () {
        return new CollisionAvoider();
    };
    StackedSeriesBase.prototype.dc = function () {
        return false;
    };
    StackedSeriesBase.prototype.get_cq = function () {
        return false;
    };
    StackedSeriesBase.prototype.jf = function (a, b) {
        var e_39, _a;
        var c = this.dl;
        _super.prototype.jf.call(this, a, b);
        if (!c) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                d.visualSeriesLink.jf(a, b);
            }
        }
        catch (e_39_1) {
            e_39 = { error: e_39_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_39)
                    throw e_39.error;
            }
        }
        this.dl = false;
    };
    StackedSeriesBase.prototype.jc = function (a, b, c, d, e) {
        var e_40, _a;
        _super.prototype.jc.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        f.cn.g(this.eu);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        if (this.ox == null) {
            this.ox = new CategoryFrame(3);
        }
        this.ox.u();
        this.pl();
        this.nc(f).d(this.ox, f);
        this.oo(this.ox, f);
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                g.visualSeriesLink.jc(a, b, c, d, e);
            }
        }
        catch (e_40_1) {
            e_40 = { error: e_40_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_40)
                    throw e_40.error;
            }
        }
    };
    StackedSeriesBase.prototype.fo = function () {
        var e_41, _a;
        var a = this.a2.exportStackedVisualData(this, this.ly);
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                var c = this.a2.createFragmentVisualData(this, this.ly, getInstanceType(b).typeName, b.b8);
                b.visualSeriesLink.bi.ai(c);
                this.a2.addSubSeriesVisualData(a, c);
            }
        }
        catch (e_41_1) {
            e_41 = { error: e_41_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_41)
                    throw e_41.error;
            }
        }
        this.h4(a);
        this.bi.ai(a);
        return a;
    };
    Object.defineProperty(StackedSeriesBase.prototype, "mayContainUnknowns", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesBase.$t = markType(StackedSeriesBase, 'StackedSeriesBase', CategorySeries.$, [IIsCategoryBased_$type]);
    StackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, StackedSeriesBase, 'raisePropertyChanged', ['AutoGenerateSeries:o5:pq', [0, false], 'ReverseLegendOrder:o6:pr', [0, false], 'SeriesVisibility:pt:ps', [Visibility_$type, enumGetBox(Visibility_$type, 0)]]);
    return StackedSeriesBase;
}(CategorySeries));
/**
 * @hidden
 */
var HorizontalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalStackedSeriesBase, _super);
    function HorizontalStackedSeriesBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalStackedSeriesBase.prototype.getOffsetValue = function () {
        return this.nb.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalStackedSeriesBase.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    HorizontalStackedSeriesBase.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalStackedSeriesBase.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalStackedSeriesBase.prototype.ag = function () {
        return [this.fetchXAxis(), this.fetchYAxis()];
    };
    HorizontalStackedSeriesBase.prototype.n1 = function () {
        return this.yAxis != null && this.yAxis.cl();
    };
    HorizontalStackedSeriesBase.prototype.jn = function () {
        var e_42, _a;
        var a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? a.nj.fe : this.d7;
            try {
                for (var _b = __values(fromEnum(this.oz)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    b.cw();
                }
            }
            catch (e_42_1) {
                e_42 = { error: e_42_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_42)
                        throw e_42.error;
                }
            }
        }
    };
    HorizontalStackedSeriesBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case HorizontalStackedSeriesBase.$$p[0]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                    this.ik();
                }
                break;
            case HorizontalStackedSeriesBase.$$p[1]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.n1();
                    this.jd(false);
                    this.ik();
                }
                break;
        }
    };
    HorizontalStackedSeriesBase.prototype.px = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalStackedSeriesBase.prototype.pw = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalStackedSeriesBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalStackedSeriesBase.$t = markType(HorizontalStackedSeriesBase, 'HorizontalStackedSeriesBase', StackedSeriesBase.$);
    HorizontalStackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::p0', [CategoryAxisBase.$, null], 'YAxis::p1', [NumericYAxis.$, null]]);
    return HorizontalStackedSeriesBase;
}(StackedSeriesBase));
/**
 * @hidden
 */
var StackedAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedAreaSeries, _super);
    function StackedAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedAreaSeries.$;
        return _this;
    }
    StackedAreaSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    StackedAreaSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(StackedAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedAreaSeries.$t = markType(StackedAreaSeries, 'StackedAreaSeries', HorizontalStackedSeriesBase.$);
    return StackedAreaSeries;
}(HorizontalStackedSeriesBase));
/**
 * @hidden
 */
var VerticalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalStackedSeriesBase, _super);
    function VerticalStackedSeriesBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VerticalStackedSeriesBase.prototype.m6 = function () {
        return this.yAxis;
    };
    VerticalStackedSeriesBase.prototype.nq = function () {
        return this.xAxis;
    };
    VerticalStackedSeriesBase.prototype.getOffsetValue = function () {
        return this.nb.r(this.yAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalStackedSeriesBase.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalStackedSeriesBase.prototype.get_isVertical = function () {
        return true;
    };
    VerticalStackedSeriesBase.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalStackedSeriesBase.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalStackedSeriesBase.prototype.n1 = function () {
        return this.xAxis != null && this.xAxis.cl();
    };
    VerticalStackedSeriesBase.prototype.iz = function (a, b, c, d) {
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case VerticalStackedSeriesBase.$$p[0]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.jd(false);
                    this.ik();
                }
                break;
            case VerticalStackedSeriesBase.$$p[1]:
                if (c != d) {
                    this.hz(typeCast(Axis.$, c));
                    this.i4(typeCast(Axis.$, d));
                    this.nf.cn.g(this.eu);
                    this.n1();
                    this.jd(false);
                    this.ik();
                }
                break;
        }
    };
    VerticalStackedSeriesBase.prototype.px = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalStackedSeriesBase.prototype.pw = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalStackedSeriesBase.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    VerticalStackedSeriesBase.$t = markType(VerticalStackedSeriesBase, 'VerticalStackedSeriesBase', StackedSeriesBase.$);
    VerticalStackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::p0', [NumericXAxis.$, null], 'YAxis::p1', [CategoryYAxis.$, null]]);
    return VerticalStackedSeriesBase;
}(StackedSeriesBase));
/**
 * @hidden
 */
var StackedBarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedBarSeries, _super);
    function StackedBarSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedBarSeries.$;
        return _this;
    }
    StackedBarSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    StackedBarSeries.prototype.bf = function () {
        return new StackedBarSeriesView(this);
    };
    StackedBarSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.p2 = a;
    };
    StackedBarSeries.prototype.getHostReferenceValue = function () {
        return this.eh();
    };
    StackedBarSeries.prototype.oy = function () {
        return this.p2;
    };
    StackedBarSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    StackedBarSeries.prototype.n9 = function () {
        var e_43, _a;
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                if (b == this) {
                    return a;
                }
                var c = typeCast(IBarSeries_$type, b);
                if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                    a++;
                }
            }
        }
        catch (e_43_1) {
            e_43 = { error: e_43_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_43)
                    throw e_43.error;
            }
        }
        return -1;
    };
    StackedBarSeries.prototype.o9 = function () {
        var a = 0;
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        var c = this.bi.br;
        if (!b.isEmpty && !c.isEmpty && this.xAxis != null) {
            var d = this.getEffectiveViewport1(this.bi);
            var e = new ScalerParams(0, b, c, this.xAxis.b8, d);
            a = this.xAxis.dw(this.xAxis.ke, e);
        }
        return a;
    };
    StackedBarSeries.prototype.pa = function () {
        if (this.xAxis != null) {
            return this.xAxis.ke;
        }
        return 0;
    };
    StackedBarSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.xAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedBarSeries.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bs != null ? this.bs.mq : Rect.empty;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.ls(this.bi);
        var g = new ScalerParams(0, e, e, this.xAxis.b8, f);
        var h = new ScalerParams(0, e, e, this.yAxis.b8, f);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.yAxis != null) {
                var i = this.yAxis.dw(b, h);
                if (i < c.top + 0.1 * c.height) {
                    i = i + 0.4 * c.height;
                }
                if (i > c.bottom - 0.1 * c.height) {
                    i = i - 0.4 * c.height;
                }
                c.y = i - 0.5 * c.height;
            }
            if (this.xAxis != null && this.ov != null && b < this.ov.length) {
                var j = this.xAxis.dw(this.ov[b], g);
                var k = this.xAxis.dw(this.ow[b], g);
                if (!isNaN_(j) && !isNaN_(k)) {
                    var l = Math.abs(k - j);
                    if (c.width < l) {
                        c.width = l;
                        c.x = Math.min(k, j);
                    }
                    else {
                        if (k < c.left + 0.1 * c.width) {
                            k = k + 0.4 * c.width;
                        }
                        if (k > c.right - 0.1 * c.width) {
                            k = k - 0.4 * c.width;
                        }
                        c.x = k - 0.5 * c.width;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    StackedBarSeries.prototype.dw = function (a, b, c) {
        var d = true;
        var e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.bz == null || this.xAxis.bf == null || this.yAxis.bf == null || this.xAxis.j4 == this.xAxis.j3) {
            e.cn.d = 0;
            d = false;
        }
        return d;
    };
    StackedBarSeries.prototype.hy = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.nf.cn.g(this.eu);
                break;
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
            case 2:
                if (this.nf.cn.d > 0) {
                    this.jd(true);
                }
                break;
            case 3:
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.jd(true);
                }
                break;
        }
    };
    StackedBarSeries.prototype.e8 = function (a) {
        var b = this.bs != null ? this.bs.mq : Rect.empty;
        var c = this.bi.br;
        var d = this.getEffectiveViewport1(this.bi);
        var e = -1;
        if (this.yAxis != null && !b.isEmpty && !c.isEmpty) {
            var f = new ScalerParams(0, b, c, this.yAxis.b8, d);
            var g = this.lq(this.bi);
            var h = this.yAxis.dz(g.top, f);
            var i = this.yAxis.dz(g.bottom, f);
            var j = (a.y - b.top) / b.height;
            var k = h + (j * (i - h));
            if (this.yAxis.categoryMode != 0) {
                k -= 0.5;
            }
            var l = truncate(Math.round(k));
            e = l;
        }
        return e;
    };
    StackedBarSeries.prototype.fp = function (a) {
        var b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    StackedBarSeries.prototype.pp = function () {
        if (this.xAxis != null) {
            this.xAxis.cm(true);
        }
        if (this.yAxis != null) {
            this.yAxis.cm(true);
        }
    };
    StackedBarSeries.prototype.pd = function (a) {
        return this.e8(a);
    };
    StackedBarSeries.prototype.o7 = function (a, b, c, d) {
        var e = true;
        if (!d.l() || c.isEmpty || b.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.bz == null || this.xAxis.bf == null || this.yAxis.bf == null) {
            e = false;
        }
        var f = d;
        if (a.valueColumn == null || a.valueColumn.count == 0 || f.cn.d < 1) {
            e = false;
        }
        return e;
    };
    StackedBarSeries.prototype.eg = function () {
        return this.yAxis.jr(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    StackedBarSeries.prototype.pm = function (a, b, c) {
        var e_44, _a;
        var d = typeCast(BarFragment.$, a);
        var e = typeCast(ColumnFragmentView.$, c);
        if (!this.dw(c.br, c.bs, c) || d == null || e == null) {
            return;
        }
        var f = this.yAxis.jr(c.bs, c.br, this.getEffectiveViewport1(c));
        if (isNaN_(f) || isInfinity(f)) {
            d.qq.c7.count = 0;
            return;
        }
        var g = 0;
        try {
            for (var _b = __values(fromEnum(b.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var h = _c.value;
                if (isInfinity(h[0]) || isNaN_(h[0]) || isInfinity(h[1]) || isInfinity(h[2]) || isNaN_(h[1]) || isNaN_(h[2])) {
                    continue;
                }
                var i = h[0] - 0.5 * f;
                var j = h[1];
                var k = h[2];
                k = Math.max(k, -100);
                j = Math.min(j, c.br.right + 100);
                var l = e.c7.item(g);
                l.height = f;
                l.width = Math.abs(j - k);
                e.de(l, Math.min(j, k), i);
                g++;
            }
        }
        catch (e_44_1) {
            e_44 = { error: e_44_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_44)
                    throw e_44.error;
            }
        }
        e.c7.count = g;
    };
    StackedBarSeries.prototype.iz = function (a, b, c, d) {
        var e_45, _a;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case StackedBarSeries.$$p[0]:
            case StackedBarSeries.$$p[1]:
                try {
                    for (var _b = __values(fromEnum(this.oz)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        e.de();
                        e.df();
                    }
                }
                catch (e_45_1) {
                    e_45 = { error: e_45_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_45)
                            throw e_45.error;
                    }
                }
                this.jd(false);
                break;
            case "SyncLink":
                if (this.xAxis != null) {
                    this.xAxis.cl();
                }
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cl()) {
                    this.p2.cn.g(this.eu);
                }
                this.jd(false);
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.hz(this.xAxis);
                    this.hz(this.yAxis);
                }
                if (c == null && d != null) {
                    this.i4(this.xAxis);
                    this.i4(this.yAxis);
                }
                this.p2.cn.g(this.eu);
                this.jd(false);
                if (this.xAxis != null) {
                    this.xAxis.cl();
                }
                break;
        }
    };
    StackedBarSeries.prototype.getPreferredCategoryMode = function () {
        return this.preferredCategoryMode(this.yAxis);
    };
    Object.defineProperty(StackedBarSeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(this.yAxis);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedBarSeries.prototype, "scaler", {
        get: function () {
            return this.yAxis;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedBarSeries.prototype, "yScaler", {
        get: function () {
            return this.xAxis;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedBarSeries.prototype, "mayContainUnknowns", {
        get: function () {
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedBarSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedBarSeries.$t = markType(StackedBarSeries, 'StackedBarSeries', VerticalStackedSeriesBase.$, [IIsCategoryBased_$type, IBarSeries_$type]);
    StackedBarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedBarSeries, 'raisePropertyChanged', ['RadiusX:p3:p7', [1, 2], 'RadiusY:p4:p8', [1, 2]]);
    return StackedBarSeries;
}(VerticalStackedSeriesBase));
/**
 * @hidden
 */
var StackedColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedColumnSeries, _super);
    function StackedColumnSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedColumnSeries.$;
        return _this;
    }
    StackedColumnSeries.prototype.bf = function () {
        return new StackedColumnSeriesView(this);
    };
    StackedColumnSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.p2 = a;
    };
    StackedColumnSeries.prototype.oy = function () {
        return this.p2;
    };
    StackedColumnSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    StackedColumnSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedColumnSeries.prototype.eg = function () {
        var a = this.getEffectiveViewport1(this.bi);
        return this.xAxis.jr(this.bi.bs, this.bi.br, a);
    };
    StackedColumnSeries.prototype.pm = function (a, b, c) {
        var e_46, _a;
        var d = typeCast(ColumnFragment.$, a);
        var e = typeCast(ColumnFragmentView.$, c);
        if (!this.dw(c.br, c.bs, c) || d == null || e == null) {
            return;
        }
        if (d == null) {
            return;
        }
        var f = this.getEffectiveViewport1(c);
        var g = this.xAxis.jr(c.bs, c.br, f);
        if (isNaN_(g) || isInfinity(g)) {
            d.qq.c7.count = 0;
            return;
        }
        var h = 0;
        try {
            for (var _b = __values(fromEnum(b.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                if (isInfinity(i[0]) || isNaN_(i[0]) || isInfinity(i[1]) || isInfinity(i[2]) || isNaN_(i[1]) || isNaN_(i[2])) {
                    continue;
                }
                var j = i[0] - 0.5 * g;
                var k = i[1];
                var l = i[2];
                k = Math.max(k, -100);
                l = Math.min(l, c.br.bottom + 100);
                var m = e.c7.item(h);
                m.width = g;
                m.height = Math.abs(l - k);
                e.de(m, j, Math.min(l, k));
                h++;
            }
        }
        catch (e_46_1) {
            e_46 = { error: e_46_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_46)
                    throw e_46.error;
            }
        }
        e.c7.count = h;
    };
    StackedColumnSeries.prototype.iz = function (a, b, c, d) {
        var e_47, _a;
        _super.prototype.iz.call(this, a, b, c, d);
        switch (b) {
            case StackedColumnSeries.$$p[0]:
            case StackedColumnSeries.$$p[1]:
                try {
                    for (var _b = __values(fromEnum(this.oz)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var e = _c.value;
                        e.de();
                        e.df();
                    }
                }
                catch (e_47_1) {
                    e_47 = { error: e_47_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_47)
                            throw e_47.error;
                    }
                }
                this.jd(false);
                break;
            case "SyncLink":
                if (this.yAxis != null) {
                    this.yAxis.cl();
                }
                break;
            case "SeriesViewer":
                if (this.yAxis != null) {
                    this.yAxis.cl();
                }
                break;
        }
    };
    Object.defineProperty(StackedColumnSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedColumnSeries.$t = markType(StackedColumnSeries, 'StackedColumnSeries', HorizontalStackedSeriesBase.$);
    StackedColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedColumnSeries, 'raisePropertyChanged', ['RadiusX:p3:p7', [1, 2], 'RadiusY:p4:p8', [1, 2]]);
    return StackedColumnSeries;
}(HorizontalStackedSeriesBase));
/**
 * @hidden
 */
var StackedLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedLineSeries, _super);
    function StackedLineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedLineSeries.$;
        return _this;
    }
    StackedLineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    StackedLineSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedLineSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(StackedLineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedLineSeries.$t = markType(StackedLineSeries, 'StackedLineSeries', HorizontalStackedSeriesBase.$);
    return StackedLineSeries;
}(HorizontalStackedSeriesBase));
/**
 * @hidden
 */
var StackedSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSplineAreaSeries, _super);
    function StackedSplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedSplineAreaSeries.$;
        return _this;
    }
    StackedSplineAreaSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    StackedSplineAreaSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedSplineAreaSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(StackedSplineAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedSplineAreaSeries.$t = markType(StackedSplineAreaSeries, 'StackedSplineAreaSeries', HorizontalStackedSeriesBase.$);
    return StackedSplineAreaSeries;
}(HorizontalStackedSeriesBase));
/**
 * @hidden
 */
var StackedSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSplineSeries, _super);
    function StackedSplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = StackedSplineSeries.$;
        return _this;
    }
    StackedSplineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    StackedSplineSeries.prototype.an = function (a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.pl();
            return new AxisRange(this.pc, this.pb);
        }
        return null;
    };
    StackedSplineSeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(StackedSplineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    StackedSplineSeries.$t = markType(StackedSplineSeries, 'StackedSplineSeries', HorizontalStackedSeriesBase.$);
    return StackedSplineSeries;
}(HorizontalStackedSeriesBase));
/**
 * @hidden
 */
var StackedFragmentSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedFragmentSeries, _super);
    function StackedFragmentSeries() {
        var _this = _super.call(this) || this;
        _this.q = false;
        _this.r = false;
        _this._parentSeries = null;
        _this.av = 0;
        _this.o = null;
        _this.p = null;
        _this._visualSeriesLink = null;
        _this.ac = null;
        _this.ad = null;
        _this.ab = null;
        _this.y = false;
        _this.au = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.ac = new List$1(Number_$type, 0);
        _this.ad = new List$1(Number_$type, 0);
        _this.ab = new List$1(Array_$type, 0);
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, function (a, b) { return _this.ct(a, b.propertyName, b.oldValue, b.newValue); });
        return _this;
    }
    Object.defineProperty(StackedFragmentSeries.prototype, "parentSeries", {
        get: function () {
            return this._parentSeries;
        },
        set: function (a) {
            this._parentSeries = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedFragmentSeries.prototype, "visualSeriesLink", {
        get: function () {
            return this._visualSeriesLink;
        },
        set: function (a) {
            this._visualSeriesLink = a;
        },
        enumerable: true,
        configurable: true
    });
    StackedFragmentSeries.prototype.provideRenderer = function (a) {
        this.au = a;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.provideRenderer(a);
        }
    };
    StackedFragmentSeries.prototype.dq = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.gd = this.parentSeries._visibility != 0 ? 1 : this.gf;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink._visibility = this.gd;
        }
    };
    StackedFragmentSeries.prototype.c9 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.dt = this.dw != null ? this.dw : this.parentSeries.mk;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.mk = this.dt;
        }
    };
    StackedFragmentSeries.prototype.da = function () {
        if (this.parentSeries == null) {
            return;
        }
        var a = this.l == 0 ? 1 : this.l;
        this.k = this.l == 0 ? this.parentSeries.l1 : a;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.l1 = this.k;
        }
    };
    StackedFragmentSeries.prototype.cx = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.fz = this.fu != null ? this.fu : this.parentSeries.k5;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.k5 = this.fz;
        }
    };
    StackedFragmentSeries.prototype.cy = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.f2 = this.f3 != null ? this.f3 : this.parentSeries.lb;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.lb = this.f2;
        }
    };
    StackedFragmentSeries.prototype.cz = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.f4 = this.f7;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.lc = this.f4;
        }
    };
    StackedFragmentSeries.prototype.c1 = function () {
        if (this.parentSeries == null) {
            return;
        }
        if (!this.q) {
            this.s = this.parentSeries.cp;
        }
        else {
            this.s = this.w;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.cp = this.s;
        }
    };
    StackedFragmentSeries.prototype.dg = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.ai = !isNaN_(this.aq) ? this.aq : this.parentSeries.ev;
        if (this.visualSeriesLink != null && !isNaN_(this.ai)) {
            this.visualSeriesLink.ev = this.ai;
        }
    };
    StackedFragmentSeries.prototype.dh = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.f0 = Color.e(toNullable(Color.$, this.f1), toNullable(Color.$, null)) ? this.f1 : this.parentSeries.la;
        if (this.visualSeriesLink != null && Color.e(toNullable(Color.$, this.f0), toNullable(Color.$, null))) {
            this.visualSeriesLink.la = this.f0;
        }
    };
    StackedFragmentSeries.prototype.dp = function () {
        if (this.parentSeries == null) {
            return;
        }
        if (!this.r) {
            this.v = this.parentSeries.du;
        }
        else {
            this.v = this.aa;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.du = this.v;
        }
    };
    StackedFragmentSeries.prototype.di = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.aj = !isNaN_(this.ar) ? this.ar : this.parentSeries.ew;
        if (this.visualSeriesLink != null && !isNaN_(this.aj)) {
            this.visualSeriesLink.ew = this.aj;
        }
    };
    StackedFragmentSeries.prototype.dj = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.ak = !isNaN_(this.as) ? this.as : this.parentSeries.ex;
        if (this.visualSeriesLink != null && !isNaN_(this.ak)) {
            this.visualSeriesLink.ex = this.ak;
        }
    };
    StackedFragmentSeries.prototype.c0 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.f5 = this.f8;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ld = this.f5;
        }
    };
    StackedFragmentSeries.prototype.c2 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.t = this.x;
    };
    StackedFragmentSeries.prototype.c3 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.dr = this.du != null ? this.du : this.parentSeries.legendItemBadgeTemplate;
        if (this.visualSeriesLink != null) {
            if (this.dr != null) {
                this.visualSeriesLink.legendItemBadgeTemplate = this.dr;
            }
            else {
                this.visualSeriesLink.legendItemBadgeTemplate = null;
            }
        }
    };
    StackedFragmentSeries.prototype.c4 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.ds = this.dv != null ? this.dv : this.parentSeries.legendItemTemplate;
        if (this.visualSeriesLink != null) {
            if (this.ds != null) {
                this.visualSeriesLink.legendItemTemplate = this.ds;
            }
            else {
                this.visualSeriesLink.legendItemTemplate = null;
            }
        }
    };
    StackedFragmentSeries.prototype.c5 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.gc = this.parentSeries.lz != 0 ? 1 : this.ge;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.lz = this.gc;
        }
    };
    StackedFragmentSeries.prototype.c6 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.fq = this.fv != null ? this.fv : this.parentSeries.mx;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.mx = this.fq;
        }
    };
    StackedFragmentSeries.prototype.c7 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.fr = this.fw != null ? this.fw : this.parentSeries.my;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.my = this.fr;
        }
    };
    StackedFragmentSeries.prototype.c8 = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.ga = this.gb != null ? this.gb : this.parentSeries.mz;
        if (this.visualSeriesLink != null) {
            if (this.ga != null) {
                this.visualSeriesLink.mz = this.ga;
            }
            else {
                this.visualSeriesLink.mz = null;
            }
        }
    };
    StackedFragmentSeries.prototype.db = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.af = !isNaN_(this.an) ? this.an : this.parentSeries._opacity;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink._opacity = this.af;
        }
    };
    StackedFragmentSeries.prototype.dc = function () {
    };
    StackedFragmentSeries.prototype.dd = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.ft = this.fy != null ? this.fy : this.parentSeries.k8;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.k8 = this.ft;
        }
    };
    StackedFragmentSeries.prototype.cw = function () {
        if (this.parentSeries == null) {
            return;
        }
        var a = NaN;
        if (typeCast(StackedAreaSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.d6;
        }
        if (typeCast(StackedSplineAreaSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.d6;
        }
        this.ae = !isNaN_(this.am) ? this.am : a;
        if (this.visualSeriesLink != null) {
            if (typeCast(AreaFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.d7 = this.ae;
            }
            if (typeCast(SplineAreaFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.d7 = this.ae;
            }
        }
    };
    StackedFragmentSeries.prototype.de = function () {
        if (this.parentSeries == null) {
            return;
        }
        var a = NaN;
        if (typeCast(StackedColumnSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.p3;
        }
        if (typeCast(StackedBarSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.p3;
        }
        this.ag = !isNaN_(a) ? a : this.ao;
        if (this.visualSeriesLink != null) {
            if (typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.qt = this.ag;
            }
            if (typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.qt = this.ag;
            }
        }
    };
    StackedFragmentSeries.prototype.df = function () {
        if (this.parentSeries == null) {
            return;
        }
        var a = NaN;
        if (typeCast(StackedColumnSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.p4;
        }
        if (typeCast(StackedBarSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.p4;
        }
        this.ah = !isNaN_(a) ? a : this.ap;
        if (this.visualSeriesLink != null) {
            if (typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.qu = this.ah;
            }
            if (typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.qu = this.ah;
            }
        }
    };
    StackedFragmentSeries.prototype.dk = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.f6 = this.f9;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.le = this.f6;
        }
    };
    StackedFragmentSeries.prototype.dl = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.al = !isNaN_(this.at) ? this.at : this.parentSeries.ey;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ey = this.al;
        }
    };
    StackedFragmentSeries.prototype.dm = function () {
        if (this.parentSeries == null) {
            return;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.toolTip = this.ay;
        }
    };
    StackedFragmentSeries.prototype.dn = function () {
        if (this.parentSeries == null) {
            return;
        }
        this.u = this.z;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.l5 = this.u;
        }
    };
    StackedFragmentSeries.prototype.cv = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    StackedFragmentSeries.prototype.ct = function (a, b, c, d) {
        if (this.parentSeries == null) {
            return;
        }
        switch (b) {
            case StackedFragmentSeries.$$p[58]:
                if (this.parentSeries == null || this.visualSeriesLink == null) {
                    return;
                }
                this.visualSeriesLink.fx = d;
                break;
            case StackedFragmentSeries.$$p[63]:
                this.dq();
                break;
            case StackedFragmentSeries.$$p[31]:
                this.cx();
                break;
            case StackedFragmentSeries.$$p[32]:
                this.cy();
                break;
            case StackedFragmentSeries.$$p[33]:
                this.cz();
                break;
            case StackedFragmentSeries.$$p[35]:
                this.q = true;
                this.c1();
                break;
            case StackedFragmentSeries.$$p[52]:
                this.dg();
                break;
            case StackedFragmentSeries.$$p[53]:
                this.dh();
                break;
            case StackedFragmentSeries.$$p[61]:
                this.q = true;
                this.dp();
                break;
            case StackedFragmentSeries.$$p[54]:
                this.di();
                break;
            case StackedFragmentSeries.$$p[55]:
                this.dj();
                break;
            case StackedFragmentSeries.$$p[34]:
                this.c0();
                break;
            case StackedFragmentSeries.$$p[36]:
                this.c2();
                break;
            case StackedFragmentSeries.$$p[43]:
                this.c9();
                break;
            case StackedFragmentSeries.$$p[44]:
                this.da();
                break;
            case StackedFragmentSeries.$$p[37]:
                this.c3();
                break;
            case StackedFragmentSeries.$$p[38]:
                this.c4();
                break;
            case StackedFragmentSeries.$$p[39]:
                this.c5();
                break;
            case StackedFragmentSeries.$$p[40]:
                this.c6();
                break;
            case StackedFragmentSeries.$$p[41]:
                this.c7();
                break;
            case StackedFragmentSeries.$$p[42]:
                this.c8();
                break;
            case StackedFragmentSeries.$$p[47]:
                this.db();
                break;
            case StackedFragmentSeries.$$p[46]:
                this.dc();
                break;
            case StackedFragmentSeries.$$p[48]:
                this.dd();
                break;
            case StackedFragmentSeries.$$p[30]:
                this.cw();
                break;
            case StackedFragmentSeries.$$p[50]:
                this.de();
                break;
            case StackedFragmentSeries.$$p[51]:
                this.df();
                break;
            case StackedFragmentSeries.$$p[56]:
                this.dk();
                break;
            case StackedFragmentSeries.$$p[57]:
                this.dl();
                break;
            case StackedFragmentSeries.$$p[59]:
                this.dm();
                break;
            case StackedFragmentSeries.$$p[60]:
                this.dn();
                break;
        }
        this.parentSeries.jd(false);
    };
    StackedFragmentSeries.$t = markType(StackedFragmentSeries, 'StackedFragmentSeries', DependencyObject.$, [INotifyPropertyChanged_$type]);
    StackedFragmentSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedFragmentSeries, 'cv', ['ActualAreaFillOpacity:ae:dx', [1, 1], 'ActualBrush:fp:dy', [Brush.$], 'ActualDashArray:f2:dz', [DoubleCollection.$], 'ActualDashCap:f4:d0', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'ActualEndCap:f5:d1', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'ActualIsDropShadowEnabled:s:d2', [0, false], 'ActualIsHitTestVisible:t:d3', [0, true], 'ActualLegendItemBadgeTemplate:dr:d4', [DataTemplate.$], 'ActualLegendItemTemplate:ds:d5', [DataTemplate.$], 'ActualLegendItemVisibility:gc:d6', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'ActualMarkerBrush:fq:d7', [Brush.$], 'ActualMarkerOutline:fr:d8', [Brush.$], 'ActualMarkerStyle:ga:d9', [Style.$], 'ActualMarkerTemplate:dt:ea', [DataTemplate.$], 'ActualMarkerType:k:eb', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ActualOpacityMask:fs:ec', [Brush.$], 'ActualOpacity:af:ed', [1, 1], 'ActualOutline:ft:ee', [Brush.$], 'ActualRadiusX:ag:ef', [1, 0], 'ActualRadiusY:ah:eg', [1, 0], 'ActualShadowBlur:ai:eh', [1, NaN], 'ActualShadowColor:f0:ei', [Color.$], 'ActualShadowOffsetX:aj:ej', [1, NaN], 'ActualShadowOffsetY:ak:ek', [1, NaN], 'ActualStartCap:f6:el', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'ActualThickness:al:em', [1, 1], 'ActualToolTip:aw:en', [4], 'ActualUseLightweightMarkers:u:eo', [0, false], 'ActualUseSingleShadow:v:ep', [0, true], 'ActualVisibility:gd:eq', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'AreaFillOpacity:am:er', [1, NaN], 'Brush:fu:es', [Brush.$], 'DashArray:f3:et', [DoubleCollection.$], 'DashCap:f7:eu', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'EndCap:f8:ev', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'IsDropShadowEnabled:w:ew', [0], 'IsHitTestVisible:x:ex', [0, true], 'LegendItemBadgeTemplate:du:ey', [DataTemplate.$, null], 'LegendItemTemplate:dv:ez', [DataTemplate.$, null], 'LegendItemVisibility:ge:e0', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'MarkerBrush:fv:e1', [Brush.$], 'MarkerOutline:fw:e2', [Brush.$], 'MarkerStyle:gb:e3', [Style.$], 'MarkerTemplate:dw:e4', [DataTemplate.$, null], 'MarkerType:l:e5', [MarkerType_$type, enumGetBox(MarkerType_$type, 0)], 'Name:b8:e6', [2], 'OpacityMask:fx:e7', [Brush.$], 'Opacity:an:e8', [1, 1], 'Outline:fy:e9', [Brush.$, null], 'ParentOrLocalBrush:fz:fa', [Brush.$], 'RadiusX:ao:fb', [1, 2], 'RadiusY:ap:fc', [1, 2], 'ShadowBlur:aq:fd', [1, NaN], 'ShadowColor:f1:fe', [Color.$], 'ShadowOffsetX:ar:ff', [1, NaN], 'ShadowOffsetY:as:fg', [1, NaN], 'StartCap:f9:fh', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'Thickness:at:fi', [1, 1.5], 'Title:ax:fj', [4, "Series Title"], 'ToolTip:ay:fk', [4, null], 'UseLightweightMarkers:z:fl', [0, false], 'UseSingleShadow:aa:fm', [0], 'ValueMemberPath:cq:fn', [2, null], 'Visibility:gf:fo', [Visibility_$type, enumGetBox(Visibility_$type, 0)]]);
    return StackedFragmentSeries;
}(DependencyObject));
/**
 * @hidden
 */
var StackedSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesCollection, _super);
    function StackedSeriesCollection() {
        var _this = _super.call(this, StackedFragmentSeries.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    StackedSeriesCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    StackedSeriesCollection.$t = markType(StackedSeriesCollection, 'StackedSeriesCollection', ObservableCollection$1.$.specialize(StackedFragmentSeries.$));
    return StackedSeriesCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var StackedSeriesFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesFramePreparer, _super);
    function StackedSeriesFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                }
                break;
        }
        return _this;
    }
    StackedSeriesFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        if (typeCast(StackedColumnSeries.$, this.h) !== null || typeCast(StackedBarSeries.$, this.h) !== null) {
            var c = typeCast(StackedSeriesBase.$, this.h);
            if (c.oz.count > 0) {
                b.f = c.oz._inner[0].p;
            }
            return b;
        }
        var d = this.ab.valueColumn;
        b.f = d;
        return b;
    };
    StackedSeriesFramePreparer.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h;
        var i = a.d != null;
        var j = this.h.provideCollisionDetector();
        var k = a.f;
        var l = a.k;
        var m = this.h.mayContainUnknowns;
        var n = new ScalerParams(0, a.m, a.l, a.b.j$a, l);
        var o = new ScalerParams(0, a.m, a.l, a.c.j$a, l);
        o.b = this.h.getHostReferenceValue();
        var p = (a.b.j$c(2, n) - a.b.j$c(1, n));
        var q = a.m;
        var r = a.l;
        var s = typeCast(NumericAxisBase.$, a.c) !== null && a.c.ju;
        var _loop_1 = function (t) {
            var u = void 0;
            if (a.d == null) {
                if (!m) {
                    u = this_1.g.getBucketWithoutUnknowns(t);
                }
                else {
                    u = this_1.g.getBucket(t);
                }
            }
            else {
                u = ((function () { var v = _this.f(a, t, b, p, g, h, c); t = v.p1; g = v.p4; h = v.p5; return v.ret; })());
            }
            var v = !s || (s && u[1] > 0);
            var w = u[0];
            if (!isNaN_(u[0])) {
                this_1.x(a, u, c, i, n, o);
                a.a.f.add(u);
                var x = t * a.h;
                var y = x;
                if (a.d != null && a.d.i$b != null && x >= 0 && x < a.d.i$b.count) {
                    x = a.d.i$b._inner[x];
                }
                var z = u;
                if (k && x < b.e) {
                    z = new Array(u.length);
                    z[0] = w;
                    this_1.z(b, x, true, a.e);
                    z[1] = b.c;
                    z[2] = b.d;
                    this_1.x(a, z, c, i, n, o);
                }
                if (d && v && this_1.l(a.a, z, j, Math.min(x, b.e - 1), f, a.a.f.count - 1)) {
                    ++f;
                }
            }
            out_t_1 = t;
        };
        var this_1 = this, out_t_1;
        for (var t = a.i; t <= a.j; ++t) {
            _loop_1(t);
            t = out_t_1;
        }
        return f;
    };
    StackedSeriesFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        if (typeCast(IBarSeries_$type, this.c) !== null) {
            h = b[0];
            g = b[1];
        }
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    StackedSeriesFramePreparer.$t = markType(StackedSeriesFramePreparer, 'StackedSeriesFramePreparer', CategoryFramePreparer.$);
    return StackedSeriesFramePreparer;
}(CategoryFramePreparer));
/**
 * @hidden
 */
var AreaFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaFragmentView, _super);
    function AreaFragmentView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c8 = new Path();
        _this.da = new Path();
        _this.c9 = new Path();
        _this.db = new Path();
        _this.c6 = a;
        return _this;
    }
    AreaFragmentView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    AreaFragmentView.prototype.c7 = function () {
        this.c8.ak = null;
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
    };
    AreaFragmentView.prototype.co = function () {
        return new AreaFragmentBucketCalculator(this);
    };
    AreaFragmentView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c8._fill = this.e.k3;
        this.c9._fill = this.e.k3;
        this.c8._opacity = this.e.d6;
        this.c9._opacity = 0.5 * this.e.d6;
        this.da._stroke = this.e.k4;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.lb;
        this.da.ad = this.e.lc;
        this.db._stroke = this.e.k4;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.lb;
        this.db.ad = this.e.lc;
    };
    AreaFragmentView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c8._fill = a;
        this.c9._fill = a;
        this.c8._opacity = 1;
        this.c9._opacity = 1;
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
    };
    AreaFragmentView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        a.s(this.c8);
        a.s(this.c9);
        a.s(this.da);
        a.s(this.db);
    };
    AreaFragmentView.prototype.get_index = function () {
        var a = this.c6.parentSeries;
        var b = a.series.count;
        var c = a.series.indexOf(this.c6.logicalSeriesLink);
        var d = (b - 1) - c;
        var e = a.bi.index;
        return e + d;
    };
    AreaFragmentView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.da, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.db, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.c9, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.c8, "fillShape", ["Fill"]);
    };
    AreaFragmentView.$t = markType(AreaFragmentView, 'AreaFragmentView', AnchoredCategorySeriesView.$);
    return AreaFragmentView;
}(AnchoredCategorySeriesView));
/**
 * @hidden
 */
var ColumnFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnFragmentView, _super);
    function ColumnFragmentView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.da = null;
        _this.c7 = null;
        _this.c8 = null;
        _this.c9 = null;
        _this.c6 = a;
        _this.c8 = new List$1(Number_$type, 0);
        _this.c9 = new List$1(Number_$type, 0);
        _this.c7 = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.df);
            $ret.activate = runOn(_this, _this.db);
            $ret.disactivate = runOn(_this, _this.dd);
            $ret.destroy = runOn(_this, _this.dc);
            return $ret;
        })());
        _this.da = new List$1(Rectangle.$, 0);
        return _this;
    }
    ColumnFragmentView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    ColumnFragmentView.prototype.df = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new Rectangle();
            $ret.dataContext = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
            return $ret;
        })());
        this.da.add(a);
        a._visibility = 1;
        return a;
    };
    ColumnFragmentView.prototype.db = function (a) {
        a._visibility = 0;
    };
    ColumnFragmentView.prototype.dd = function (a) {
        a._visibility = 1;
    };
    ColumnFragmentView.prototype.dc = function (a) {
        this.da.remove(a);
    };
    ColumnFragmentView.prototype.bb = function (a, b) {
        _super.prototype.bb.call(this, a, b);
        var c = a;
        c._fill = this.e.k3;
        c._stroke = this.e.k4;
        c.ac = this.e.ey;
        c.ai = this.e.lb;
        c.ad = this.e.lc;
        c.am = this.c6.qt;
        c.an = this.c6.qu;
    };
    ColumnFragmentView.prototype.de = function (a, b, c) {
        var d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    };
    ColumnFragmentView.prototype.bc = function (a, b) {
        _super.prototype.bc.call(this, a, b);
        var c = a;
        var d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    };
    ColumnFragmentView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.da.count; c++) {
                var d = this.da._inner[c];
                this.ba(d, c, b);
                a.v(d);
            }
        }
    };
    ColumnFragmentView.prototype.get_index = function () {
        var a = this.c6.parentSeries;
        var b = a.series.count;
        var c = a.series.indexOf(this.c6.logicalSeriesLink);
        var d = (b - 1) - c;
        var e = a.bi.index;
        return e + d;
    };
    ColumnFragmentView.prototype.ai = function (a) {
        var e_48, _a, e_49, _b;
        _super.prototype.ai.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.c7.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_48_1) {
            e_48 = { error: e_48_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_48)
                    throw e_48.error;
            }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_49_1) {
            e_49 = { error: e_49_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_49)
                    throw e_49.error;
            }
        }
        b++;
    };
    ColumnFragmentView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        var b = null;
        if (this.c6.m6().b2) {
            b = this.c6.fragmentXAxis;
        }
        else if (this.c6.fragmentYAxis.b2) {
            b = this.c6.fragmentYAxis;
        }
        if (b.b5) {
            var c = b;
            a += "<span>${item." + c.dateTimeMemberPath + "}</span><br/>";
        }
        if (b != null && b.e7 != null) {
            a += "<span>${item." + b.e7 + "}</span><br/>";
        }
        a += "<span";
        var d = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(d)) {
            a += " style='color:" + d + "'";
        }
        a += ">" + this.c6.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.c6.pd + "}</span></div>";
        return a;
    };
    ColumnFragmentView.$t = markType(ColumnFragmentView, 'ColumnFragmentView', AnchoredCategorySeriesView.$);
    return ColumnFragmentView;
}(AnchoredCategorySeriesView));
/**
 * @hidden
 */
var LineFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(LineFragmentView, _super);
    function LineFragmentView(a) {
        var _this = _super.call(this, a) || this;
        _this.c6 = null;
        _this.c9 = new Path();
        _this.c8 = new Path();
        _this.da = new Path();
        _this.c6 = a;
        return _this;
    }
    LineFragmentView.prototype.c7 = function () {
        this.c8.ak = null;
        this.c9.ak = null;
        this.da.ak = null;
    };
    LineFragmentView.prototype.co = function () {
        return new LineFragmentBucketCalculator(this);
    };
    LineFragmentView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c9._stroke = this.e.k3;
        this.c9.ac = this.e.ey;
        this.c9.ai = this.e.lb;
        this.c9.ad = this.e.lc;
        this.da._stroke = this.e.k3;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.lb;
        this.da.ad = this.e.lc;
        this.c8._fill = this.e.k3;
        this.c8._opacity = 0.75;
    };
    LineFragmentView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c9._stroke = a;
        this.c9.ac = this.e.ey + 3;
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.c8._fill = a;
        this.c8._opacity = 1;
    };
    LineFragmentView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c8);
            a.s(this.c9);
            a.s(this.da);
        }
    };
    LineFragmentView.prototype.get_index = function () {
        var a = this.c6.parentSeries;
        var b = a.series.count;
        var c = a.series.indexOf(this.c6.logicalSeriesLink);
        var d = (b - 1) - c;
        var e = a.bi.index;
        return e + d;
    };
    LineFragmentView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c9, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.da, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.c8, "translucentShape", ["Translucent"]);
    };
    LineFragmentView.$t = markType(LineFragmentView, 'LineFragmentView', AnchoredCategorySeriesView.$);
    return LineFragmentView;
}(AnchoredCategorySeriesView));
/**
 * @hidden
 */
var SplineAreaFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineAreaFragmentView, _super);
    function SplineAreaFragmentView(a) {
        var _this = _super.call(this, a) || this;
        _this.c7 = null;
        _this.c9 = new Path();
        _this.db = new Path();
        _this.da = new Path();
        _this.dc = new Path();
        _this.c7 = a;
        return _this;
    }
    SplineAreaFragmentView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    SplineAreaFragmentView.prototype.c8 = function () {
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
        this.dc.ak = null;
    };
    SplineAreaFragmentView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c9._fill = this.e.k3;
        this.da._fill = this.e.k3;
        this.c9._opacity = this.e.d6;
        this.da._opacity = 0.5 * this.e.d6;
        this.db._stroke = this.e.k4;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.lb;
        this.db.ad = this.e.lc;
        this.dc._stroke = this.e.k4;
        this.dc.ac = this.e.ey;
        this.dc.ai = this.e.lb;
        this.dc.ad = this.e.lc;
    };
    SplineAreaFragmentView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c9._fill = a;
        this.da._fill = a;
        this.da._opacity = 1;
        this.c9._opacity = 1;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
    };
    SplineAreaFragmentView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
        }
    };
    SplineAreaFragmentView.prototype.get_index = function () {
        var a = this.c7.parentSeries;
        var b = a.series.count;
        var c = a.series.indexOf(this.c7.logicalSeriesLink);
        var d = (b - 1) - c;
        var e = a.bi.index;
        return e + d;
    };
    SplineAreaFragmentView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.db, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dc, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.da, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.c9, "fillShape", ["Fill"]);
    };
    SplineAreaFragmentView.$t = markType(SplineAreaFragmentView, 'SplineAreaFragmentView', SplineSeriesBaseView.$);
    return SplineAreaFragmentView;
}(SplineSeriesBaseView));
/**
 * @hidden
 */
var SplineFragmentView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SplineFragmentView, _super);
    function SplineFragmentView(a) {
        var _this = _super.call(this, a) || this;
        _this.c7 = null;
        _this.da = new Path();
        _this.c9 = new Path();
        _this.db = new Path();
        _this.c7 = a;
        return _this;
    }
    SplineFragmentView.prototype.co = function () {
        return new SplineFragmentBucketCalculator(this);
    };
    SplineFragmentView.prototype.c8 = function () {
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
    };
    SplineFragmentView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.da._stroke = this.e.k3;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.lb;
        this.da.ad = this.e.lc;
        this.db._stroke = this.e.k3;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.lb;
        this.db.ad = this.e.lc;
        this.c9._fill = this.e.k3;
        this.c9._opacity = 0.75;
    };
    SplineFragmentView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 0.75;
    };
    SplineFragmentView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
        }
    };
    SplineFragmentView.prototype.get_index = function () {
        var a = this.c7.parentSeries;
        var b = a.series.count;
        var c = a.series.indexOf(this.c7.logicalSeriesLink);
        var d = (b - 1) - c;
        var e = a.bi.index;
        return e + d;
    };
    SplineFragmentView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.da, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.db, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.c9, "translucentShape", ["Translucent"]);
    };
    SplineFragmentView.$t = markType(SplineFragmentView, 'SplineFragmentView', SplineSeriesBaseView.$);
    return SplineFragmentView;
}(SplineSeriesBaseView));
/**
 * @hidden
 */
var StackedSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesView, _super);
    function StackedSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = new Canvas();
        _this.cz = new Panel();
        _this.cw = a;
        return _this;
    }
    Object.defineProperty(StackedSeriesView.prototype, "cy", {
        get: function () {
            return this.cx;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesView.prototype, "c0", {
        get: function () {
            return this.cz;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesView.prototype.co = function () {
        return new StackedBucketCalculator(this);
    };
    StackedSeriesView.prototype.am = function () {
        _super.prototype.am.call(this);
        for (var a = 0; a < this.cw.o3.f.count; a++) {
            this.cw.o3.f._inner[a].bi.am();
        }
    };
    StackedSeriesView.prototype.ao = function (a, b) {
        var e_50, _a;
        _super.prototype.ao.call(this, a, b);
        try {
            for (var _b = __values(fromEnum(this.cw.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.visualSeriesLink.bi.ao(a, b);
            }
        }
        catch (e_50_1) {
            e_50 = { error: e_50_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_50)
                    throw e_50.error;
            }
        }
    };
    StackedSeriesView.prototype.ac = function () {
        var a = "rgba(95,95,95,0.5)";
        var b = true;
        var c = 5, d = 5, e = 5;
        var f = this.e;
        if (typeCast(StackedAreaSeries.$, f) !== null || typeCast(StackedSplineAreaSeries.$, f) !== null) {
            d = 1;
            e = -3;
        }
        else if (typeCast(StackedLineSeries.$, f) !== null || typeCast(StackedSplineSeries.$, f) !== null) {
            c = 3;
            d = 1;
            e = 4;
            b = false;
        }
        else if (typeCast(StackedColumnSeries.$, f) !== null) {
            d = 5;
            e = 0;
        }
        var g = new Color();
        g.colorString = a;
        f.la = g;
        f.ev = c;
        f.ew = d;
        f.ex = e;
        f.du = b;
    };
    StackedSeriesView.$t = markType(StackedSeriesView, 'StackedSeriesView', CategorySeriesView.$);
    return StackedSeriesView;
}(CategorySeriesView));
/**
 * @hidden
 */
var StackedBarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedBarSeriesView, _super);
    function StackedBarSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c1 = null;
        _this.c1 = a;
        return _this;
    }
    StackedBarSeriesView.prototype.co = function () {
        return new StackedBarBucketCalculator(this);
    };
    StackedBarSeriesView.$t = markType(StackedBarSeriesView, 'StackedBarSeriesView', StackedSeriesView.$);
    return StackedBarSeriesView;
}(StackedSeriesView));
/**
 * @hidden
 */
var StackedColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedColumnSeriesView, _super);
    function StackedColumnSeriesView(a) {
        return _super.call(this, a) || this;
    }
    StackedColumnSeriesView.prototype.co = function () {
        return new StackedColumnBucketCalculator(this);
    };
    StackedColumnSeriesView.$t = markType(StackedColumnSeriesView, 'StackedColumnSeriesView', StackedSeriesView.$);
    return StackedColumnSeriesView;
}(StackedSeriesView));
/**
 * @hidden
 */
var StackedSeriesManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesManager, _super);
    function StackedSeriesManager(a) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.f = null;
        _this.c = null;
        _this.e = null;
        _this.d = null;
        _this.j = null;
        _this.k = null;
        if (a == null) {
            return _this;
        }
        _this.b = a;
        _this.f = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        _this.c = new StackedSeriesCollection();
        _this.e = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        _this.d = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        _this.j = _this.b.o4.cy;
        _this.k = _this.b.o4.c0;
        var b = _this.c;
        b.collectionChanged = delegateCombine(b.collectionChanged, function (b, c) {
            var e_51, _a, e_52, _b;
            if (c.oldItems != null) {
                try {
                    for (var _c = __values(fromEn(c.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var d = _d.value;
                        if (_this.f.contains(d.visualSeriesLink)) {
                            _this.f.remove(d.visualSeriesLink);
                        }
                    }
                }
                catch (e_51_1) {
                    e_51 = { error: e_51_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_51)
                            throw e_51.error;
                    }
                }
            }
            if (c.newItems != null) {
                var e = c.newStartingIndex;
                try {
                    for (var _e = __values(fromEn(c.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var f = _f.value;
                        var g = _this.a(f);
                        _this.f.insert(e, g);
                        e++;
                    }
                }
                catch (e_52_1) {
                    e_52 = { error: e_52_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_52)
                            throw e_52.error;
                    }
                }
            }
        });
        var c = _this.f;
        c.collectionChanged = delegateCombine(c.collectionChanged, function (c, d) {
            var e_53, _a, e_54, _b;
            if (d.oldItems != null) {
                try {
                    for (var _c = __values(fromEn(d.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var e = _d.value;
                        e.hv(true, e.bi);
                        e.bs = null;
                        e.bn = null;
                        e.itemsSource = null;
                        e.legend = null;
                        if (_this.k != null && _this.k.ab.contains(e)) {
                            _this.k.ab.remove(e);
                        }
                        if (_this.b.bs != null) {
                            _this.b.bs.jx(e);
                        }
                    }
                }
                catch (e_53_1) {
                    e_53 = { error: e_53_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_53)
                            throw e_53.error;
                    }
                }
            }
            if (d.newItems != null) {
                try {
                    for (var _e = __values(fromEn(d.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var f = _f.value;
                        f.bs = _this.b.bs;
                        f.bn = _this.b.bn;
                        if (!_this.k.ab.contains(f)) {
                            _this.k.ab.add(f);
                        }
                        if (_this.b.bs != null) {
                            _this.b.bs.hb(f);
                        }
                    }
                }
                catch (e_54_1) {
                    e_54 = { error: e_54_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_54)
                            throw e_54.error;
                    }
                }
            }
            _this.b.jd(false);
        });
        return _this;
    }
    StackedSeriesManager.prototype.a = function (a) {
        if (typeCast(StackedLineSeries.$, this.b) !== null) {
            var b = new LineFragment();
            b.provideRenderer(a.au);
            b.parentSeries = this.b;
            a.visualSeriesLink = b;
            b.logicalSeriesLink = a;
            b.bi.br = this.b.bi.br;
            this.i(b, a);
            this.g(b);
            return b;
        }
        if (typeCast(StackedColumnSeries.$, this.b) !== null) {
            var c = new ColumnFragment();
            c.provideRenderer(a.au);
            c.parentSeries = this.b;
            a.visualSeriesLink = c;
            c.logicalSeriesLink = a;
            c.bi.br = this.b.bi.br;
            this.i(c, a);
            this.g(c);
            return c;
        }
        if (typeCast(StackedBarSeries.$, this.b) !== null) {
            var d = new BarFragment();
            d.provideRenderer(a.au);
            d.parentSeries = typeCast(StackedBarSeries.$, this.b);
            a.visualSeriesLink = d;
            d.logicalSeriesLink = a;
            d.bi.br = this.b.bi.br;
            this.i(d, a);
            this.g(d);
            return d;
        }
        if (typeCast(StackedAreaSeries.$, this.b) !== null) {
            var e = new AreaFragment();
            e.provideRenderer(a.au);
            e.parentSeries = this.b;
            a.visualSeriesLink = e;
            e.logicalSeriesLink = a;
            e.bi.br = this.b.bi.br;
            this.i(e, a);
            this.g(e);
            return e;
        }
        if (typeCast(StackedSplineSeries.$, this.b) !== null) {
            var f = new SplineFragment();
            f.provideRenderer(a.au);
            f.parentSeries = this.b;
            a.visualSeriesLink = f;
            f.logicalSeriesLink = a;
            f.bi.br = this.b.bi.br;
            this.i(f, a);
            this.g(f);
            return f;
        }
        if (typeCast(StackedSplineAreaSeries.$, this.b) !== null) {
            var g = new SplineAreaFragment();
            g.provideRenderer(a.au);
            g.parentSeries = this.b;
            a.visualSeriesLink = g;
            g.logicalSeriesLink = a;
            g.bi.br = this.b.bi.br;
            this.i(g, a);
            this.g(g);
            return g;
        }
        return null;
    };
    StackedSeriesManager.prototype.i = function (a, b) {
        a.k5 = b.fz;
        a.lb = b.f2;
        a.lc = b.f4;
        a.ld = b.f5;
        a.itemsSource = this.b.itemsSource;
        a.legend = this.b.aw;
        a.legendItemTemplate = b.ds;
        a.lz = b.gc;
        a.mx = b.fq;
        a.my = b.fr;
        a.mz = b.ga;
        a.mk = b.dt;
        a.l1 = b.k;
        a.es = this.b.es;
        a._opacity = b.an;
        a.k8 = b.ft;
        a.eu = this.b.eu;
        a.le = b.f6;
        a.ey = b.al;
        a.fx = b.ax;
        a.l5 = b.u;
        a.pd = b.cq;
        a._visibility = b.gd;
        var c = typeCast(AreaFragment.$, a);
        if (c != null) {
            c.d6 = b.ae;
        }
        var d = typeCast(SplineAreaFragment.$, a);
        if (d != null) {
            d.d6 = b.ae;
        }
        var e = typeCast(ColumnFragment.$, a);
        if (e != null) {
            e.qt = b.ag;
            e.qu = b.ah;
        }
        var f = typeCast(BarFragment.$, a);
        if (f != null) {
            f.qt = b.ag;
            f.qu = b.ah;
        }
        a.toolTip = b.ay;
        a.cp = b.s;
        a.du = b.v;
        b.dg();
        b.dh();
        b.di();
        b.dj();
    };
    StackedSeriesManager.prototype.h = function () {
        var e_55, _a;
        this.e.clear();
        this.d.clear();
        var a = 0;
        try {
            for (var _b = __values(fromEnum(this.f)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.dl = true;
                b.fh = this.b.pe(this.c._inner[a]);
                b.bn = this.b.bn;
                b.bs = this.b.bs;
                if (this.c._inner[a].y) {
                    this.e.add(b);
                }
                else {
                    this.d.add(b);
                }
                if (typeCast(StackedLineSeries.$, this.b) !== null || typeCast(StackedAreaSeries.$, this.b) !== null || typeCast(StackedSplineSeries.$, this.b) !== null || typeCast(StackedSplineAreaSeries.$, this.b) !== null) {
                    b.pg(this.b.fetchXAxis());
                    b.ph(this.b.fetchYAxis());
                }
                b.jd(false);
                a++;
            }
        }
        catch (e_55_1) {
            e_55 = { error: e_55_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_55)
                    throw e_55.error;
            }
        }
    };
    StackedSeriesManager.prototype.g = function (a) {
        var fragment_ = a;
        fragment_.externalObject = TypeRegistrar.createFromInternal(fragment_, PlatformConstants.Prefix, PlatformConstants.Postfix);
        fragment_.externalObject._implementation = fragment_;
    };
    StackedSeriesManager.$t = markType(StackedSeriesManager, 'StackedSeriesManager');
    return StackedSeriesManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a non-visual child of StackedSeriesBase.
*/
var IgrStackedFragmentSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedFragmentSeries, _super);
    function IgrStackedFragmentSeries(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._propertyUpdated = null;
        _this._propertyUpdated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrStackedFragmentSeries.prototype.createImplementation = function () {
        return new StackedFragmentSeries();
    };
    IgrStackedFragmentSeries.prototype.onImplementationCreated = function () {
    };
    IgrStackedFragmentSeries.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrStackedFragmentSeries.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrStackedFragmentSeries.prototype.render = function () {
        return null;
    };
    IgrStackedFragmentSeries.prototype.provideRenderer = function (renderer) {
        this._renderer = renderer;
        this.i.visualSeriesLink.provideRenderer(renderer);
    };
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrStackedFragmentSeries._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "brush", {
        /**
     * Gets or sets the brush of the stacked fragment.
    */
        get: function () {
            return brushToString(this.i.fu);
        },
        set: function (v) {
            this.i.fu = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualBrush", {
        /**
         * Gets the actual brush used by the series.
        */
        get: function () {
            return brushToString(this.i.fp);
        },
        set: function (v) {
            this.i.fp = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "isDropShadowEnabled", {
        /**
         * Gets or sets whether drop shadow should be enabled for this series.
        */
        get: function () {
            return this.i.w;
        },
        set: function (v) {
            this.i.w = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualIsDropShadowEnabled", {
        /**
         * Gets whether drop shadow is actually enabled for this series.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "shadowBlur", {
        /**
         * Gets or sets the shadow blur.
         * This property is ignored when StackedFragmentSeries.UseSingleShadow is set to true.
        */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualShadowBlur", {
        /**
         * Gets the actual shadow blur used by the series.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "shadowColor", {
        /**
         * Gets or sets the drop shadow color.
        */
        get: function () {
            return colorToString(this.i.f1);
        },
        set: function (v) {
            this.i.f1 = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualShadowColor", {
        /**
         * Gets actual the drop shadow color used by the series.
        */
        get: function () {
            return colorToString(this.i.f0);
        },
        set: function (v) {
            this.i.f0 = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "useSingleShadow", {
        /**
         * Gets or sets whether drop shadow is applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
         * When this property is set to true, no StackedFragmentSeries.ShadowBlur is applied.
        */
        get: function () {
            return this.i.aa;
        },
        set: function (v) {
            this.i.aa = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualUseSingleShadow", {
        /**
         * Gets whether drop shadow is actually applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
        */
        get: function () {
            return this.i.v;
        },
        set: function (v) {
            this.i.v = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "shadowOffsetX", {
        /**
         * Gets or sets the drop shadow x-offset.
        */
        get: function () {
            return this.i.ar;
        },
        set: function (v) {
            this.i.ar = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualShadowOffsetX", {
        /**
         * Gets the actual drop shadow x-offset applied to the series.
        */
        get: function () {
            return this.i.aj;
        },
        set: function (v) {
            this.i.aj = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "shadowOffsetY", {
        /**
         * Gets or sets the drop shadow y-offset.
        */
        get: function () {
            return this.i.as;
        },
        set: function (v) {
            this.i.as = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualShadowOffsetY", {
        /**
         * Gets the actual drop shadow y-offset applied to the series.
        */
        get: function () {
            return this.i.ak;
        },
        set: function (v) {
            this.i.ak = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.du;
        },
        set: function (v) {
            this.i.du = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualLegendItemBadgeTemplate", {
        /**
         * Gets the actual legend item badge template used by the series.
        */
        get: function () {
            return this.i.dr;
        },
        set: function (v) {
            this.i.dr = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.dv;
        },
        set: function (v) {
            this.i.dv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualLegendItemTemplate", {
        /**
         * Gets the actual legend item template used by the series.
        */
        get: function () {
            return this.i.ds;
        },
        set: function (v) {
            this.i.ds = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the legend item visibility for the current series object.
        */
        get: function () {
            return this.i.ge;
        },
        set: function (v) {
            this.i.ge = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualLegendItemVisibility", {
        /**
         * Gets the actual visibility of the legend items in the series.
        */
        get: function () {
            return this.i.gc;
        },
        set: function (v) {
            this.i.gc = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "markerBrush", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
        */
        get: function () {
            return brushToString(this.i.fv);
        },
        set: function (v) {
            this.i.fv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualMarkerBrush", {
        /**
         * Gets the actual marker brush of the series.
        */
        get: function () {
            return brushToString(this.i.fq);
        },
        set: function (v) {
            this.i.fq = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "markerOutline", {
        /**
         * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
        */
        get: function () {
            return brushToString(this.i.fw);
        },
        set: function (v) {
            this.i.fw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualMarkerOutline", {
        /**
         * Gets the actual marker outline of the series.
        */
        get: function () {
            return brushToString(this.i.fr);
        },
        set: function (v) {
            this.i.fr = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "markerTemplate", {
        /**
         * Gets or sets the MarkerTemplate for the current series object.
        */
        get: function () {
            return this.i.dw;
        },
        set: function (v) {
            this.i.dw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualMarkerTemplate", {
        /**
         * Gets the actual marker template used by the series.
        */
        get: function () {
            return this.i.dt;
        },
        set: function (v) {
            this.i.dt = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "markerType", {
        /**
         * Gets or sets the marker type for the current series object.
         * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualMarkerType", {
        /**
         * Gets the actual marker type set used in the series.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "name", {
        /**
         * Gets or sets the Name of the stacked fragment.
        */
        get: function () {
            return this.i.b8;
        },
        set: function (v) {
            this.i.b8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "opacity", {
        /**
         * Gets or sets the Opacity of the stacked fragment.
        */
        get: function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualOpacity", {
        /**
         * Gets the series opacity.
        */
        get: function () {
            return this.i.af;
        },
        set: function (v) {
            this.i.af = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "outline", {
        /**
         * Gets or sets the brush to use for the outline of the series.
         * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
        */
        get: function () {
            return brushToString(this.i.fy);
        },
        set: function (v) {
            this.i.fy = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualOutline", {
        /**
         * Gets the series outline.
        */
        get: function () {
            return brushToString(this.i.ft);
        },
        set: function (v) {
            this.i.ft = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "areaFillOpacity", {
        /**
         * Gets or sets the AreaFillOpacity of the stacked fragment. This property only applies for area-like series.
        */
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualAreaFillOpacity", {
        /**
         * Gets the series ActualAreaFillOpacity.  This property only applies for area-like series.
        */
        get: function () {
            return this.i.ae;
        },
        set: function (v) {
            this.i.ae = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
        */
        get: function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualRadiusX", {
        /**
         * Gets the actual corner radius of the series
        */
        get: function () {
            return this.i.ag;
        },
        set: function (v) {
            this.i.ag = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualRadiusY", {
        /**
         * Gets the actual corner radius of the series
        */
        get: function () {
            return this.i.ah;
        },
        set: function (v) {
            this.i.ah = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "thickness", {
        /**
         * Gets or sets the width of the current series object's line thickness.
        */
        get: function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualThickness", {
        /**
         * Gets or sets the thickness of this stacked fragment.
        */
        get: function () {
            return this.i.al;
        },
        set: function (v) {
            this.i.al = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "title", {
        /**
         * Gets or sets the Title property.
         * The legend item control is created according to the Title on-demand by
         * the series object itself.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "valueMemberPath", {
        /**
         * Gets or sets the value mapping property for the current series object.
        */
        get: function () {
            return this.i.cq;
        },
        set: function (v) {
            this.i.cq = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "visibility", {
        /**
         * Gets or sets the Visibility of the stacked fragment.
        */
        get: function () {
            return this.i.gf;
        },
        set: function (v) {
            this.i.gf = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "actualVisibility", {
        /**
         * Gets the actual visibility of the stacked fragment.
        */
        get: function () {
            return this.i.gd;
        },
        set: function (v) {
            this.i.gd = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "parentOrLocalBrush", {
        /**
         * Gets the resolved brush used between the local series and the parent series.
        */
        get: function () {
            return brushToString(this.i.fz);
        },
        set: function (v) {
            this.i.fz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrStackedFragmentSeries.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrStackedFragmentSeries.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("StackedFragmentSeries");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    Object.defineProperty(IgrStackedFragmentSeries.prototype, "propertyUpdated", {
        /**
         * Event raised when a property (including "effective" and non-dependency property) value changes.
        */
        get: function () {
            return this._propertyUpdated;
        },
        set: function (ev) {
            var _this = this;
            if (this._propertyUpdated_wrapped !== null) {
                this.i.propertyUpdated = delegateRemove(this.i.propertyUpdated, this._propertyUpdated_wrapped);
                this._propertyUpdated_wrapped = null;
                this._propertyUpdated = null;
            }
            this._propertyUpdated = ev;
            this._propertyUpdated_wrapped = function (o, e) {
                var outerArgs = new IgrPropertyUpdatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforePropertyUpdated) {
                    _this.beforePropertyUpdated(_this, outerArgs);
                }
                if (_this._propertyUpdated) {
                    _this._propertyUpdated(_this, outerArgs);
                }
            };
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, this._propertyUpdated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedFragmentSeries;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedFragmentSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedFragmentSeriesModule() {
    }
    IgrStackedFragmentSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedFragmentSeries", IgrStackedFragmentSeries);
        TypeRegistrar.register("StackedFragmentSeries", StackedFragmentSeries.$type);
    };
    return IgrStackedFragmentSeriesModule;
}());

/**
 * Provides data for IgxDataChartComponent stacked series.
*/
var IgrStackedSeriesCreatedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedSeriesCreatedEventArgs() {
    }
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrStackedSeriesCreatedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrStackedSeriesCreatedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "brush", {
        /**
         * Gets or sets the series brush.
        */
        get: function () {
            return brushToString(this.i.brush);
        },
        set: function (v) {
            this.i.brush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the series legend item template.
        */
        get: function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the series legend item badge templae.
        */
        get: function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the visibility of the series legend.
        */
        get: function () {
            return this.i.legendItemVisibility;
        },
        set: function (v) {
            this.i.legendItemVisibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "outline", {
        /**
         * Gets or sets the series outline brush.
        */
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "index", {
        /**
         * Gets the index of the series.
        */
        get: function () {
            return this.i.index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "thickness", {
        /**
         * Gets or sets the series outline thickness.
        */
        get: function () {
            return this.i.thickness;
        },
        set: function (v) {
            this.i.thickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "title", {
        /**
         * Gets or sets the series title.
        */
        get: function () {
            return this.i.title;
        },
        set: function (v) {
            this.i.title = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "markerBrush", {
        /**
         * Gets or sets the series marker brush.
        */
        get: function () {
            return brushToString(this.i.markerBrush);
        },
        set: function (v) {
            this.i.markerBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "markerOutline", {
        /**
         * Gets or sets the series marker outline.
        */
        get: function () {
            return brushToString(this.i.markerOutline);
        },
        set: function (v) {
            this.i.markerOutline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "markerStyle", {
        /**
         * Gets or sets the series marker style.
        */
        get: function () {
            if (this.i.markerStyle == null) {
                return null;
            }
            if (!this.i.markerStyle.externalObject) {
                var e = new IgrStyle();
                e._implementation = this.i.markerStyle;
                this.i.markerStyle.externalObject = e;
            }
            return this.i.markerStyle.externalObject;
        },
        set: function (v) {
            v == null ? this.i.markerStyle = null : this.i.markerStyle = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "markerTemplate", {
        /**
         * Gets or sets the series marker template.
        */
        get: function () {
            return this.i.markerTemplate;
        },
        set: function (v) {
            this.i.markerTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesCreatedEventArgs.prototype, "markerType", {
        /**
         * Gets or sets the series marker type.
        */
        get: function () {
            return this.i.markerType;
        },
        set: function (v) {
            this.i.markerType = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedSeriesCreatedEventArgs;
}());

var IgrStackedSeriesCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedSeriesCollection, _super);
    function IgrStackedSeriesCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrStackedFragmentSeries.$type) {
            IgrStackedFragmentSeries.$type = markType(IgrStackedFragmentSeries, "IgrStackedFragmentSeries");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrStackedSeriesCollection.prototype._createInnerColl = function () {
        if (!IgrStackedFragmentSeries.$type) {
            IgrStackedFragmentSeries.$type = markType(IgrStackedFragmentSeries, "IgrStackedFragmentSeries");
        }
        var coll = new SyncableObservableCollection$2(IgrStackedFragmentSeries.$type, StackedFragmentSeries.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrStackedFragmentSeries(null);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrStackedSeriesCollection;
}(IgCollection));

/**
 * Represents a base class for stacked series.
*/
var IgrStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedSeriesBase, _super);
    function IgrStackedSeriesBase(props) {
        var _this = _super.call(this, props) || this;
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing React to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        _this.actualSeries = [];
        _this.contentSeries = [];
        _this._series = null;
        _this._seriesAdapter = null;
        _this._seriesCreated = null;
        _this._seriesCreated_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._seriesAdapter = new CollectionAdapter(_this.contentSeries, _this.i.series, _this.actualSeries, function (c) { return c.i; }, function (i) {
            i.owner = _this;
            i.provideRenderer(_this._renderer);
            // i.provideData(this._dataSource);
            // i.bindAxes(this.actualAxes);
            // this._ensureDefaultTooltip(i);
            // this._ensureTooltipCreated(i);
        }, function (i) {
            i.provideRenderer(null);
            // i.provideData(null); 
        });
        _this._contentChildrenManager = new ContentChildrenManager(function (ch) { return ch.key || ch.props.name; }, function (ch) { return ch.key || ch.props.name; }, function () { return _this._updateContentChildren(); });
        return _this;
    }
    IgrStackedSeriesBase.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrStackedSeriesBase.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrStackedSeriesBase.prototype.initializeProperties = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrStackedSeriesBase.prototype.componentDidMount = function () {
        this.initializeProperties();
    };
    IgrStackedSeriesBase.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrStackedSeriesBase.prototype.render = function () {
        var children = this._contentChildrenManager.getChildren(this.props.children);
        var div = createElement("div", {
            children: children
        });
        return div;
    };
    IgrStackedSeriesBase._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrStackedSeriesBase.prototype._updateContentChildren = function () {
        this.contentSeries.length = 0;
        var contentChildrenActual = this._contentChildrenManager.contentChildrenActual;
        for (var i = 0; i < contentChildrenActual.length; i++) {
            this.contentSeries.push(contentChildrenActual[i]);
        }
        if (this._seriesAdapter !== null) {
            this._seriesAdapter.notifyContentChanged();
        }
    };
    Object.defineProperty(IgrStackedSeriesBase.prototype, "series", {
        /**
         * A collection or manually added series for the chart.
        */
        get: function () {
            var _this = this;
            if (this._series === null) {
                var coll = new IgrStackedSeriesCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._seriesAdapter.clearManualItems();
                            break;
                    }
                });
                this._series = coll;
            }
            return this._series;
        },
        enumerable: true,
        configurable: true
    });
    IgrStackedSeriesBase.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        if (this.actualSeries != null) {
            for (var i = 0; i < this.actualSeries.length; i++) {
                this.actualSeries[i].provideRenderer(renderer);
            }
        }
    };
    Object.defineProperty(IgrStackedSeriesBase.prototype, "autoGenerateSeries", {
        /**
     * Gets or sets whether series should be automatically generated. Reqiures the use of GroupBy as the ItemsSource.
    */
        get: function () {
            return this.i.o5;
        },
        set: function (v) {
            this.i.o5 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesBase.prototype, "reverseLegendOrder", {
        /**
         * Gets or sets whether the order of the fragment series should be reversed in the legend.
        */
        get: function () {
            return this.i.o6;
        },
        set: function (v) {
            this.i.o6 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedSeriesBase.prototype, "isStacked", {
        /**
         * Checks if this series is a stacked series
        */
        get: function () {
            return this.i.isStacked;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Simulates a pointer hover over the series surface.

* @param point  * The pointer position relative to the series viewport over which to hover.
*/
    IgrStackedSeriesBase.prototype.simulateHover = function (point) {
        this.i.jk(toPoint(point));
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgrStackedSeriesBase.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    Object.defineProperty(IgrStackedSeriesBase.prototype, "seriesCreated", {
        /**
         * Event raised when a new fragment series is automatically generated.
        */
        get: function () {
            return this._seriesCreated;
        },
        set: function (ev) {
            var _this = this;
            if (this._seriesCreated_wrapped !== null) {
                this.i.seriesCreated = delegateRemove(this.i.seriesCreated, this._seriesCreated_wrapped);
                this._seriesCreated_wrapped = null;
                this._seriesCreated = null;
            }
            this._seriesCreated = ev;
            this._seriesCreated_wrapped = function (o, e) {
                var outerArgs = new IgrStackedSeriesCreatedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSeriesCreated) {
                    _this.beforeSeriesCreated(_this, outerArgs);
                }
                if (_this._seriesCreated) {
                    _this._seriesCreated(_this, outerArgs);
                }
            };
            this.i.seriesCreated = delegateCombine(this.i.seriesCreated, this._seriesCreated_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedSeriesBase;
}(IgrCategorySeries));

/**
 * Base class for stacked series with a category x-axis and a numeric y-axis.
*/
var IgrHorizontalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrHorizontalStackedSeriesBase, _super);
    function IgrHorizontalStackedSeriesBase(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrHorizontalStackedSeriesBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalStackedSeriesBase.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for this series.
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalStackedSeriesBase.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalStackedSeriesBase.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for this series.
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrNumericYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrHorizontalStackedSeriesBase.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    IgrHorizontalStackedSeriesBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrHorizontalStackedSeriesBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrHorizontalStackedSeriesBase.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrHorizontalStackedSeriesBase.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrHorizontalStackedSeriesBase.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.px(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrHorizontalStackedSeriesBase.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.pw(axis);
        return (iv);
    };
    return IgrHorizontalStackedSeriesBase;
}(IgrStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked area series.
*/
var IgrStackedAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedAreaSeries, _super);
    function IgrStackedAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedAreaSeries.prototype.createImplementation = function () {
        return new StackedAreaSeries();
    };
    Object.defineProperty(IgrStackedAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedAreaSeries;
}(IgrHorizontalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100DataPreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100DataPreparer, _super);
    function Stacked100DataPreparer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Stacked100DataPreparer.a = function (a) {
        if (a.bz == null) {
            return;
        }
        var b = Number.POSITIVE_INFINITY;
        var c = Number.NEGATIVE_INFINITY;
        for (var d = 0; d < a.bz.count; d++) {
            var e = Math.abs(a.ow[d]) + a.ov[d];
            if (e == 0) {
                b = Math.min(b, 0);
                c = Math.max(c, 0);
                continue;
            }
            b = Math.min(b, a.ow[d] / e * 100);
            c = Math.max(c, a.ov[d] / e * 100);
        }
        a.pc = b;
        a.pb = c;
    };
    Stacked100DataPreparer.$t = markType(Stacked100DataPreparer, 'Stacked100DataPreparer');
    return Stacked100DataPreparer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100AreaSeries, _super);
    function Stacked100AreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100AreaSeries.$;
        return _this;
    }
    Stacked100AreaSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100AreaSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100AreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100AreaSeries.$t = markType(Stacked100AreaSeries, 'Stacked100AreaSeries', StackedAreaSeries.$, [IStacked100Series_$type]);
    return Stacked100AreaSeries;
}(StackedAreaSeries));

/**
 * Represents a stacked area series, where values are presented as percentages of the total.
*/
var IgrStacked100AreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100AreaSeries, _super);
    function IgrStacked100AreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100AreaSeries.prototype.createImplementation = function () {
        return new Stacked100AreaSeries();
    };
    Object.defineProperty(IgrStacked100AreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100AreaSeries;
}(IgrStackedAreaSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100AreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100AreaSeriesModule() {
    }
    IgrStacked100AreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100AreaSeries", IgrStacked100AreaSeries);
        TypeRegistrar.register("Stacked100AreaSeries", Stacked100AreaSeries.$type);
    };
    return IgrStacked100AreaSeriesModule;
}());

/**
 * Base class for stacked series with a numeric x-axis and a category y-axis.
*/
var IgrVerticalStackedSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrVerticalStackedSeriesBase, _super);
    function IgrVerticalStackedSeriesBase(props) {
        var _this = _super.call(this, props) || this;
        _this._xAxisName = null;
        _this._yAxisName = null;
        return _this;
    }
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "xAxis", {
        /**
         * Gets or sets the effective x-axis for the current CategorySeries object.
        */
        get: function () {
            if (this.i.xAxis == null) {
                return null;
            }
            if (!this.i.xAxis.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.xAxis);
                if (e) {
                    e._implementation = this.i.xAxis;
                }
                this.i.xAxis.externalObject = e;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "xAxisName", {
        /**
        * Gets or sets the name to use to resolve xAxis from markup.
        */
        get: function () {
            return this._xAxisName;
        },
        set: function (v) {
            this._xAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current CategorySeries object.
        */
        get: function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = IgrCategoryYAxis._createFromInternal(this.i.yAxis);
                if (e) {
                    e._implementation = this.i.yAxis;
                }
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            if (v != null && this._stylingContainer && v._styling)
                v._styling(this._stylingContainer, this, this);
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "yAxisName", {
        /**
        * Gets or sets the name to use to resolve yAxis from markup.
        */
        get: function () {
            return this._yAxisName;
        },
        set: function (v) {
            this._yAxisName = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrVerticalStackedSeriesBase.prototype, "isVertical", {
        /**
         * Gets whether or not the current series is vertical series
        */
        get: function () {
            return this.i.isVertical;
        },
        enumerable: true,
        configurable: true
    });
    IgrVerticalStackedSeriesBase.prototype.bindAxes = function (axes) {
        _super.prototype.bindAxes.call(this, axes);
        for (var i = 0; i < axes.length; i++) {
            if (this.xAxisName && this.xAxisName.length > 0 &&
                axes[i].name == this.xAxisName) {
                this.xAxis = axes[i];
            }
        }
        for (var i = 0; i < axes.length; i++) {
            if (this.yAxisName && this.yAxisName.length > 0 &&
                axes[i].name == this.yAxisName) {
                this.yAxis = axes[i];
            }
        }
    };
    IgrVerticalStackedSeriesBase.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    IgrVerticalStackedSeriesBase.prototype.getOffsetValue = function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    IgrVerticalStackedSeriesBase.prototype.getCategoryWidth = function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    IgrVerticalStackedSeriesBase.prototype.canUseAsYAxis = function (axis) {
        var iv = this.i.px(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    IgrVerticalStackedSeriesBase.prototype.canUseAsXAxis = function (axis) {
        var iv = this.i.pw(axis);
        return (iv);
    };
    return IgrVerticalStackedSeriesBase;
}(IgrStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked bar series.
*/
var IgrStackedBarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedBarSeries, _super);
    function IgrStackedBarSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedBarSeries.prototype.createImplementation = function () {
        return new StackedBarSeries();
    };
    Object.defineProperty(IgrStackedBarSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedBarSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.p3;
        },
        set: function (v) {
            this.i.p3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedBarSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.p4;
        },
        set: function (v) {
            this.i.p4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgrStackedBarSeries.prototype.scrollIntoView = function (item) {
        var iv = this.i.c9(item);
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    IgrStackedBarSeries.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrStackedBarSeries.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrStackedBarSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrStackedBarSeries;
}(IgrVerticalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100BarBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100BarBucketCalculator, _super);
    function Stacked100BarBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    Stacked100BarBucketCalculator.prototype.getBucket = function (a) {
        return _super.prototype.getBucket.call(this, a);
    };
    Stacked100BarBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
        var g = typeCast(StackedBarSeries.$, this.c.cp);
        var h = [NaN, NaN, NaN];
        var i = typeCast(BarFragment.$, a);
        if (i == null || i.logicalSeriesLink == null) {
            return h;
        }
        var j = a.valueColumn.item(c);
        var k = 0;
        var l = 0;
        var m = NaN;
        var n = NaN;
        var o = Number.NEGATIVE_INFINITY;
        var p = Number.POSITIVE_INFINITY;
        var q = g.getEffectiveViewport1(this.c);
        var r = Math.min(g.ow != null ? g.ow.length : 0, g.ov != null ? g.ov.length : 0);
        var s = c * this.d;
        var t = Math.min(s + this.d - 1, r - 1);
        for (var u = s; u <= t; ++u) {
            j = a.valueColumn.item(u);
            k = Math.abs(g.ow[u]) + g.ov[u];
            if (j < l) {
                p = Math.min(p, (i.logicalSeriesLink.ad._inner[u] + j) / k * 100);
                o = Math.max(o, i.logicalSeriesLink.ad._inner[u] / k * 100);
            }
            else {
                p = Math.min(p, i.logicalSeriesLink.ac._inner[u] / k * 100);
                o = Math.max(o, (i.logicalSeriesLink.ac._inner[u] + j) / k * 100);
            }
            if (!isNaN_(m)) {
                if (!isNaN_(p)) {
                    m = Math.min(m, p);
                    n = Math.max(n, p);
                }
                if (!isNaN_(o)) {
                    m = Math.min(m, o);
                    n = Math.max(n, o);
                }
            }
            else {
                m = p;
                n = o;
            }
        }
        var v = new ScalerParams(0, d, e, g.xAxis.b8, q);
        h = [f.f._inner[b - this.e][0], g.xAxis.dw(n, v), g.xAxis.dw(m, v)];
        return h;
    };
    Stacked100BarBucketCalculator.$t = markType(Stacked100BarBucketCalculator, 'Stacked100BarBucketCalculator', StackedBarBucketCalculator.$);
    return Stacked100BarBucketCalculator;
}(StackedBarBucketCalculator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100BarSeries, _super);
    function Stacked100BarSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100BarSeries.$;
        return _this;
    }
    Stacked100BarSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100BarSeries.prototype.bf = function () {
        return new Stacked100BarSeriesView(this);
    };
    Stacked100BarSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.p9 = a;
    };
    Stacked100BarSeries.prototype.oy = function () {
        return this.p9;
    };
    Stacked100BarSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100BarSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100BarSeries.$t = markType(Stacked100BarSeries, 'Stacked100BarSeries', StackedBarSeries.$, [IStacked100Series_$type]);
    return Stacked100BarSeries;
}(StackedBarSeries));
/**
 * @hidden
 */
var Stacked100BarSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100BarSeriesView, _super);
    function Stacked100BarSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c2 = null;
        _this.c2 = a;
        return _this;
    }
    Stacked100BarSeriesView.prototype.co = function () {
        return new Stacked100BarBucketCalculator(this);
    };
    Stacked100BarSeriesView.$t = markType(Stacked100BarSeriesView, 'Stacked100BarSeriesView', StackedBarSeriesView.$);
    return Stacked100BarSeriesView;
}(StackedBarSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked100 bar series.
*/
var IgrStacked100BarSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100BarSeries, _super);
    function IgrStacked100BarSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100BarSeries.prototype.createImplementation = function () {
        return new Stacked100BarSeries();
    };
    Object.defineProperty(IgrStacked100BarSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100BarSeries;
}(IgrStackedBarSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100BarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100BarSeriesModule() {
    }
    IgrStacked100BarSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100BarSeries", IgrStacked100BarSeries);
        TypeRegistrar.register("Stacked100BarSeries", Stacked100BarSeries.$type);
    };
    return IgrStacked100BarSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked column series.
*/
var IgrStackedColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedColumnSeries, _super);
    function IgrStackedColumnSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedColumnSeries.prototype.createImplementation = function () {
        return new StackedColumnSeries();
    };
    Object.defineProperty(IgrStackedColumnSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedColumnSeries.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.p3;
        },
        set: function (v) {
            this.i.p3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrStackedColumnSeries.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.p4;
        },
        set: function (v) {
            this.i.p4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgrStackedColumnSeries.prototype.getItemSpan = function () {
        var iv = this.i.eg();
        return (iv);
    };
    return IgrStackedColumnSeries;
}(IgrHorizontalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100ColumnBucketCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100ColumnBucketCalculator, _super);
    function Stacked100ColumnBucketCalculator(a) {
        return _super.call(this, a) || this;
    }
    Stacked100ColumnBucketCalculator.prototype.getBucket = function (a) {
        return _super.prototype.getBucket.call(this, a);
    };
    Stacked100ColumnBucketCalculator.prototype.getBucket1 = function (a, b, c, d, e, f) {
        var g = typeCast(StackedSeriesBase.$, this.c.cp);
        var h = [NaN, NaN, NaN];
        var i = typeCast(ColumnFragment.$, a);
        if (i == null || i.logicalSeriesLink == null) {
            return h;
        }
        var j = g.getEffectiveViewport1(this.c);
        var k = a.valueColumn.item(c);
        var l = 0;
        var m = NaN;
        var n = NaN;
        var o = Number.NEGATIVE_INFINITY;
        var p = Number.POSITIVE_INFINITY;
        var q = 0;
        var r = Math.min(g.ow != null ? g.ow.length : 0, g.ov != null ? g.ov.length : 0);
        var s = c * this.d;
        var t = Math.min(s + this.d - 1, r - 1);
        for (var u = s; u <= t; ++u) {
            k = a.valueColumn.item(u);
            q = Math.abs(g.ow[u]) + g.ov[u];
            if (k < l) {
                p = Math.min(p, (i.logicalSeriesLink.ad._inner[u] + k) / q * 100);
                o = Math.max(o, i.logicalSeriesLink.ad._inner[u] / q * 100);
            }
            else {
                p = Math.min(p, i.logicalSeriesLink.ac._inner[u] / q * 100);
                o = Math.max(o, (i.logicalSeriesLink.ac._inner[u] + k) / q * 100);
            }
            if (!isNaN_(m)) {
                if (!isNaN_(p)) {
                    m = Math.min(m, p);
                    n = Math.max(n, p);
                }
                if (!isNaN_(o)) {
                    m = Math.min(m, o);
                    n = Math.max(n, o);
                }
            }
            else {
                m = p;
                n = o;
            }
        }
        var v = new ScalerParams(0, d, e, i.fragmentYAxis.b8, j);
        h = [f.f._inner[b - this.e][0], i.fragmentYAxis.dw(n, v), i.fragmentYAxis.dw(m, v)];
        return h;
    };
    Stacked100ColumnBucketCalculator.$t = markType(Stacked100ColumnBucketCalculator, 'Stacked100ColumnBucketCalculator', StackedColumnBucketCalculator.$);
    return Stacked100ColumnBucketCalculator;
}(StackedColumnBucketCalculator));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100ColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100ColumnSeries, _super);
    function Stacked100ColumnSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100ColumnSeries.$;
        return _this;
    }
    Stacked100ColumnSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100ColumnSeries.prototype.bf = function () {
        return new Stacked100ColumnSeriesView(this);
    };
    Stacked100ColumnSeries.prototype.iu = function (a) {
        _super.prototype.iu.call(this, a);
        this.p9 = a;
    };
    Stacked100ColumnSeries.prototype.oy = function () {
        return this.p9;
    };
    Stacked100ColumnSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100ColumnSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100ColumnSeries.$t = markType(Stacked100ColumnSeries, 'Stacked100ColumnSeries', StackedColumnSeries.$, [IStacked100Series_$type]);
    return Stacked100ColumnSeries;
}(StackedColumnSeries));
/**
 * @hidden
 */
var Stacked100ColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100ColumnSeriesView, _super);
    function Stacked100ColumnSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c1 = null;
        _this.c1 = a;
        return _this;
    }
    Stacked100ColumnSeriesView.prototype.co = function () {
        return new Stacked100ColumnBucketCalculator(this);
    };
    Stacked100ColumnSeriesView.$t = markType(Stacked100ColumnSeriesView, 'Stacked100ColumnSeriesView', StackedColumnSeriesView.$);
    return Stacked100ColumnSeriesView;
}(StackedColumnSeriesView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked100 column series.
*/
var IgrStacked100ColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100ColumnSeries, _super);
    function IgrStacked100ColumnSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100ColumnSeries.prototype.createImplementation = function () {
        return new Stacked100ColumnSeries();
    };
    Object.defineProperty(IgrStacked100ColumnSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100ColumnSeries;
}(IgrStackedColumnSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100ColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100ColumnSeriesModule() {
    }
    IgrStacked100ColumnSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100ColumnSeries", IgrStacked100ColumnSeries);
        TypeRegistrar.register("Stacked100ColumnSeries", Stacked100ColumnSeries.$type);
    };
    return IgrStacked100ColumnSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a stacked series, where the points in each series are connected with a line.
*/
var IgrStackedLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedLineSeries, _super);
    function IgrStackedLineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedLineSeries.prototype.createImplementation = function () {
        return new StackedLineSeries();
    };
    Object.defineProperty(IgrStackedLineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedLineSeries;
}(IgrHorizontalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100LineSeries, _super);
    function Stacked100LineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100LineSeries.$;
        return _this;
    }
    Stacked100LineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100LineSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100LineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100LineSeries.$t = markType(Stacked100LineSeries, 'Stacked100LineSeries', StackedLineSeries.$, [IStacked100Series_$type]);
    return Stacked100LineSeries;
}(StackedLineSeries));

/**
 * Represents a IgxDataChartComponent stacked100 line series.
*/
var IgrStacked100LineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100LineSeries, _super);
    function IgrStacked100LineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100LineSeries.prototype.createImplementation = function () {
        return new Stacked100LineSeries();
    };
    Object.defineProperty(IgrStacked100LineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100LineSeries;
}(IgrStackedLineSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100LineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100LineSeriesModule() {
    }
    IgrStacked100LineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100LineSeries", IgrStacked100LineSeries);
        TypeRegistrar.register("Stacked100LineSeries", Stacked100LineSeries.$type);
    };
    return IgrStacked100LineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked spline series.
*/
var IgrStackedSplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedSplineSeries, _super);
    function IgrStackedSplineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedSplineSeries.prototype.createImplementation = function () {
        return new StackedSplineSeries();
    };
    Object.defineProperty(IgrStackedSplineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedSplineSeries;
}(IgrHorizontalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100SplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100SplineSeries, _super);
    function Stacked100SplineSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100SplineSeries.$;
        return _this;
    }
    Stacked100SplineSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100SplineSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100SplineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100SplineSeries.$t = markType(Stacked100SplineSeries, 'Stacked100SplineSeries', StackedSplineSeries.$, [IStacked100Series_$type]);
    return Stacked100SplineSeries;
}(StackedSplineSeries));

/**
 * Represents a IgxDataChartComponent stacked100 spline series.
*/
var IgrStacked100SplineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100SplineSeries, _super);
    function IgrStacked100SplineSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100SplineSeries.prototype.createImplementation = function () {
        return new Stacked100SplineSeries();
    };
    Object.defineProperty(IgrStacked100SplineSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100SplineSeries;
}(IgrStackedSplineSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100SplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100SplineSeriesModule() {
    }
    IgrStacked100SplineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100SplineSeries", IgrStacked100SplineSeries);
        TypeRegistrar.register("Stacked100SplineSeries", Stacked100SplineSeries.$type);
    };
    return IgrStacked100SplineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a IgxDataChartComponent stacked spline area series.
*/
var IgrStackedSplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStackedSplineAreaSeries, _super);
    function IgrStackedSplineAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStackedSplineAreaSeries.prototype.createImplementation = function () {
        return new StackedSplineAreaSeries();
    };
    Object.defineProperty(IgrStackedSplineAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStackedSplineAreaSeries;
}(IgrHorizontalStackedSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Stacked100SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Stacked100SplineAreaSeries, _super);
    function Stacked100SplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = Stacked100SplineAreaSeries.$;
        return _this;
    }
    Stacked100SplineAreaSeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.jd(false);
    };
    Stacked100SplineAreaSeries.prototype.pl = function () {
        _super.prototype.pl.call(this);
        Stacked100DataPreparer.a(this);
    };
    Object.defineProperty(Stacked100SplineAreaSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.n2;
        },
        enumerable: true,
        configurable: true
    });
    Stacked100SplineAreaSeries.$t = markType(Stacked100SplineAreaSeries, 'Stacked100SplineAreaSeries', StackedSplineAreaSeries.$, [IStacked100Series_$type]);
    return Stacked100SplineAreaSeries;
}(StackedSplineAreaSeries));

/**
 * Represents a IgxDataChartComponent stacked100 spline area series.
*/
var IgrStacked100SplineAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrStacked100SplineAreaSeries, _super);
    function IgrStacked100SplineAreaSeries(props) {
        return _super.call(this, props) || this;
    }
    IgrStacked100SplineAreaSeries.prototype.createImplementation = function () {
        return new Stacked100SplineAreaSeries();
    };
    Object.defineProperty(IgrStacked100SplineAreaSeries.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrStacked100SplineAreaSeries;
}(IgrStackedSplineAreaSeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStacked100SplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStacked100SplineAreaSeriesModule() {
    }
    IgrStacked100SplineAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStacked100SplineAreaSeries", IgrStacked100SplineAreaSeries);
        TypeRegistrar.register("Stacked100SplineAreaSeries", Stacked100SplineAreaSeries.$type);
    };
    return IgrStacked100SplineAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedAreaSeriesModule() {
    }
    IgrStackedAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedAreaSeries", IgrStackedAreaSeries);
        TypeRegistrar.register("StackedAreaSeries", StackedAreaSeries.$type);
    };
    return IgrStackedAreaSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedBarSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedBarSeriesModule() {
    }
    IgrStackedBarSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedBarSeries", IgrStackedBarSeries);
        TypeRegistrar.register("StackedBarSeries", StackedBarSeries.$type);
    };
    return IgrStackedBarSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedColumnSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedColumnSeriesModule() {
    }
    IgrStackedColumnSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedColumnSeries", IgrStackedColumnSeries);
        TypeRegistrar.register("StackedColumnSeries", StackedColumnSeries.$type);
    };
    return IgrStackedColumnSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedLineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedLineSeriesModule() {
    }
    IgrStackedLineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedLineSeries", IgrStackedLineSeries);
        TypeRegistrar.register("StackedLineSeries", StackedLineSeries.$type);
    };
    return IgrStackedLineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedSplineSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedSplineSeriesModule() {
    }
    IgrStackedSplineSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedSplineSeries", IgrStackedSplineSeries);
        TypeRegistrar.register("StackedSplineSeries", StackedSplineSeries.$type);
    };
    return IgrStackedSplineSeriesModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrStackedSplineAreaSeriesModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrStackedSplineAreaSeriesModule() {
    }
    IgrStackedSplineAreaSeriesModule.register = function () {
        TypeRegistrar.registerCons("IgrStackedSplineAreaSeries", IgrStackedSplineAreaSeries);
        TypeRegistrar.register("StackedSplineAreaSeries", StackedSplineAreaSeries.$type);
    };
    return IgrStackedSplineAreaSeriesModule;
}());

/**
 * Represents one part of a stacked series.
*/
var IgrFragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFragmentBase, _super);
    function IgrFragmentBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrFragmentBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrFragmentBase.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        */
        get: function () {
            return this.i.cs;
        },
        enumerable: true,
        configurable: true
    });
    return IgrFragmentBase;
}(IgrHorizontalAnchoredCategorySeries));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents one part of a StackedAreaSeries.
*/
var IgrAreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrAreaFragment, _super);
    function IgrAreaFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrAreaFragment.prototype.createImplementation = function () {
        return new AreaFragment();
    };
    Object.defineProperty(IgrAreaFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrAreaFragment.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAreaFragment;
}(IgrFragmentBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrAreaFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrAreaFragmentModule() {
    }
    IgrAreaFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrAreaFragment", IgrAreaFragment);
        TypeRegistrar.register("AreaFragment", AreaFragment.$type);
    };
    return IgrAreaFragmentModule;
}());

/**
 * Represents one part of a StackedColumnSeries.
*/
var IgrColumnFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnFragment, _super);
    function IgrColumnFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrColumnFragment.prototype.createImplementation = function () {
        return new ColumnFragment();
    };
    Object.defineProperty(IgrColumnFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnFragment.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.qt;
        },
        set: function (v) {
            this.i.qt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnFragment.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.qu;
        },
        set: function (v) {
            this.i.qu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnFragment.prototype, "fragmentXAxis", {
        /**
         * Gets or sets the effective x-axis for this series.
        */
        get: function () {
            if (this.i.fragmentXAxis == null) {
                return null;
            }
            if (!this.i.fragmentXAxis.externalObject) {
                var e = IgrCategoryAxisBase._createFromInternal(this.i.fragmentXAxis);
                if (e) {
                    e._implementation = this.i.fragmentXAxis;
                }
                this.i.fragmentXAxis.externalObject = e;
            }
            return this.i.fragmentXAxis.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrColumnFragment.prototype, "fragmentYAxis", {
        /**
         * Gets or sets the effective y-axis for this series.
        */
        get: function () {
            if (this.i.fragmentYAxis == null) {
                return null;
            }
            if (!this.i.fragmentYAxis.externalObject) {
                var e = IgrNumericAxisBase._createFromInternal(this.i.fragmentYAxis);
                if (e) {
                    e._implementation = this.i.fragmentYAxis;
                }
                this.i.fragmentYAxis.externalObject = e;
            }
            return this.i.fragmentYAxis.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    IgrColumnFragment.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.fragmentXAxis && this.fragmentXAxis._styling) {
            this.fragmentXAxis._styling(container, component, this);
        }
        if (this.fragmentYAxis && this.fragmentYAxis._styling) {
            this.fragmentYAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgrColumnFragment.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrColumnFragment.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    IgrColumnFragment.prototype.getItemIndex = function (world) {
        var iv = this.i.e8(toPoint(world));
        return (iv);
    };
    return IgrColumnFragment;
}(IgrFragmentBase));

/**
 * Represents one part of a StackedBarSeries.
*/
var IgrBarFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrBarFragment, _super);
    function IgrBarFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrBarFragment.prototype.createImplementation = function () {
        return new BarFragment();
    };
    Object.defineProperty(IgrBarFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBarFragment.prototype, "barFragmentXAxis", {
        /**
         * The X-Axis for this BarFragment.
        */
        get: function () {
            if (this.i.barFragmentXAxis == null) {
                return null;
            }
            if (!this.i.barFragmentXAxis.externalObject) {
                var e = IgrNumericXAxis._createFromInternal(this.i.barFragmentXAxis);
                if (e) {
                    e._implementation = this.i.barFragmentXAxis;
                }
                this.i.barFragmentXAxis.externalObject = e;
            }
            return this.i.barFragmentXAxis.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrBarFragment.prototype, "barFragmentYAxis", {
        /**
         * The Y-Axis for this BarFragment.
        */
        get: function () {
            if (this.i.barFragmentYAxis == null) {
                return null;
            }
            if (!this.i.barFragmentYAxis.externalObject) {
                var e = IgrCategoryYAxis._createFromInternal(this.i.barFragmentYAxis);
                if (e) {
                    e._implementation = this.i.barFragmentYAxis;
                }
                this.i.barFragmentYAxis.externalObject = e;
            }
            return this.i.barFragmentYAxis.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    IgrBarFragment.prototype._styling = function (container, component, parent) {
        _super.prototype._styling.call(this, container, component, parent);
        this._inStyling = true;
        if (this.barFragmentXAxis && this.barFragmentXAxis._styling) {
            this.barFragmentXAxis._styling(container, component, this);
        }
        if (this.barFragmentYAxis && this.barFragmentYAxis._styling) {
            this.barFragmentYAxis._styling(container, component, this);
        }
        this._inStyling = false;
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    IgrBarFragment.prototype.getExactItemIndex = function (world) {
        var iv = this.i.eb(toPoint(world));
        return (iv);
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgrBarFragment.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.lu(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    IgrBarFragment.prototype.getItem = function (world) {
        var iv = this.i.fp(toPoint(world));
        return (iv);
    };
    return IgrBarFragment;
}(IgrColumnFragment));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrBarFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrBarFragmentModule() {
    }
    IgrBarFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrBarFragment", IgrBarFragment);
        TypeRegistrar.register("BarFragment", BarFragment.$type);
    };
    return IgrBarFragmentModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrColumnFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnFragmentModule() {
    }
    IgrColumnFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrColumnFragment", IgrColumnFragment);
        TypeRegistrar.register("ColumnFragment", ColumnFragment.$type);
    };
    return IgrColumnFragmentModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents one part of a StackedLineSeries.
*/
var IgrLineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLineFragment, _super);
    function IgrLineFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrLineFragment.prototype.createImplementation = function () {
        return new LineFragment();
    };
    Object.defineProperty(IgrLineFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLineFragment.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrLineFragment;
}(IgrFragmentBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrLineFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrLineFragmentModule() {
    }
    IgrLineFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrLineFragment", IgrLineFragment);
        TypeRegistrar.register("LineFragment", LineFragment.$type);
    };
    return IgrLineFragmentModule;
}());

/**
 * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
*/
var IgrSplineFragmentBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineFragmentBase, _super);
    function IgrSplineFragmentBase(props) {
        return _super.call(this, props) || this;
    }
    Object.defineProperty(IgrSplineFragmentBase.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSplineFragmentBase.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        */
        get: function () {
            return this.i.cs;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineFragmentBase;
}(IgrSplineSeriesBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents one part of a StackedSplineSeries.
*/
var IgrSplineFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineFragment, _super);
    function IgrSplineFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrSplineFragment.prototype.createImplementation = function () {
        return new SplineFragment();
    };
    Object.defineProperty(IgrSplineFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSplineFragment.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineFragment;
}(IgrSplineFragmentBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSplineFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSplineFragmentModule() {
    }
    IgrSplineFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrSplineFragment", IgrSplineFragment);
        TypeRegistrar.register("SplineFragment", SplineFragment.$type);
    };
    return IgrSplineFragmentModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents one part of a StackedSplineAreaSeries.
*/
var IgrSplineAreaFragment = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSplineAreaFragment, _super);
    function IgrSplineAreaFragment(props) {
        return _super.call(this, props) || this;
    }
    IgrSplineAreaFragment.prototype.createImplementation = function () {
        return new SplineAreaFragment();
    };
    Object.defineProperty(IgrSplineAreaFragment.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSplineAreaFragment.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSplineAreaFragment;
}(IgrSplineFragmentBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSplineAreaFragmentModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSplineAreaFragmentModule() {
    }
    IgrSplineAreaFragmentModule.register = function () {
        IgrHorizontalAnchoredCategorySeriesProxyModule.register();
        TypeRegistrar.registerCons("IgrSplineAreaFragment", IgrSplineAreaFragment);
        TypeRegistrar.register("SplineAreaFragment", SplineAreaFragment.$type);
    };
    return IgrSplineAreaFragmentModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrDataChartStackedModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrDataChartStackedModule() {
    }
    IgrDataChartStackedModule.register = function () {
        IgrStackedFragmentSeriesModule.register();
        IgrStacked100AreaSeriesModule.register();
        IgrStacked100BarSeriesModule.register();
        IgrStacked100ColumnSeriesModule.register();
        IgrStacked100LineSeriesModule.register();
        IgrStacked100SplineSeriesModule.register();
        IgrStacked100SplineAreaSeriesModule.register();
        IgrStackedAreaSeriesModule.register();
        IgrStackedBarSeriesModule.register();
        IgrStackedColumnSeriesModule.register();
        IgrStackedLineSeriesModule.register();
        IgrStackedSplineSeriesModule.register();
        IgrStackedSplineAreaSeriesModule.register();
        IgrAreaFragmentModule.register();
        IgrBarFragmentModule.register();
        IgrColumnFragmentModule.register();
        IgrLineFragmentModule.register();
        IgrSplineFragmentModule.register();
        IgrSplineAreaFragmentModule.register();
        IgrDataChartCategoryCoreModule.register();
        IgrDataChartVerticalCategoryCoreModule.register();
    };
    return IgrDataChartStackedModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ISeriesViewerWidgetOptions_$type = /*@__PURE__*/ new Type(null, 'ISeriesViewerWidgetOptions');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ISeriesViewerWidget_$type = /*@__PURE__*/ new Type(null, 'ISeriesViewerWidget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumeration of options for the usage of the surface.
 */
var ViewerSurfaceUsage = /*@__PURE__*/ (function (ViewerSurfaceUsage) {
    /**
     * Normal surface usage.
     */
    ViewerSurfaceUsage[ViewerSurfaceUsage["Normal"] = 0] = "Normal";
    /**
     * Minimal surface usage.
     */
    ViewerSurfaceUsage[ViewerSurfaceUsage["Minimal"] = 1] = "Minimal";
    return ViewerSurfaceUsage;
})({});
/**
 * @hidden
 */
var ViewerSurfaceUsage_$type = /*@__PURE__*/ markEnum('ViewerSurfaceUsage', 'Normal,0|Minimal,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DataSourceManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataSourceManager, _super);
    function DataSourceManager() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.c = null;
        _this.b = null;
        _this.a = null;
        _this.d = new Dictionary$2(Base.$, Base.$, 0);
        _this.c = new Dictionary$2(Base.$, Base.$, 0);
        _this.b = new Dictionary$2(Base.$, Number_$type, 0);
        _this.a = new Dictionary$2(String_$type, Base.$, 0);
        return _this;
    }
    DataSourceManager.prototype.e = function (target_, dataSource_) {
        if (this.d.containsKey(target_)) {
            this.f(target_);
        }
        this.d.addItem(target_, dataSource_);
        var arr_ = dataSource_.dataView();
        if (this.c.containsKey(arr_)) {
            this.c.removeItem(arr_);
        }
        this.c.addItem(arr_, dataSource_);
        var a = (dataSource_.id);
        if (this.a.containsKey(a)) {
            this.a.removeItem(a);
        }
        this.a.addItem(a, dataSource_);
        if (!this.b.containsKey(dataSource_)) {
            this.b.addItem(dataSource_, 1);
        }
        else {
            this.b.item(dataSource_, this.b.item(dataSource_) + 1);
        }
        target_.itemsSource(arr_);
    };
    DataSourceManager.prototype.f = function (target_) {
        var curr_ = target_.itemsSource();
        this.d.removeItem(target_);
        if (!this.c.containsKey(curr_)) {
            return;
        }
        var ds_ = this.c.item(curr_);
        this.b.item(ds_, this.b.item(ds_) - 1);
        if (this.b.item(ds_) == 0) {
            this.b.removeItem(ds_);
            this.c.removeItem(curr_);
            var a = (ds_.id);
            this.a.removeItem(a);
        }
    };
    DataSourceManager.$t = markType(DataSourceManager, 'DataSourceManager');
    return DataSourceManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesViewerSurfaceViewer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesViewerSurfaceViewer, _super);
    function SeriesViewerSurfaceViewer(a, b) {
        var _this = _super.call(this) || this;
        _this.m = null;
        _this.o = false;
        _this.k = null;
        _this.x = null;
        _this.n = true;
        _this.q = null;
        _this.j = 0;
        _this.propertyChanged = null;
        if (a == null || b == null) {
            throw new ArgumentNullException(0, "model");
        }
        _this.l = a;
        var c = _this.l;
        c.windowRectChanged = delegateCombine(c.windowRectChanged, runOn(_this, _this.u));
        _this.m = b;
        _this.x = new Canvas();
        _this.w();
        return _this;
    }
    SeriesViewerSurfaceViewer.prototype.u = function (a, b) {
        var c = this.o;
        this.o = true;
        this.zoomLevel = 1 - Math.min(b.newRect.height, b.newRect.width);
        this.o = c;
    };
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "l", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            if (this.k != null) {
                var b = typeCast(INotifyPropertyChanged_$type, this.k);
                if (b != null) {
                    b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.t));
                }
            }
            this.k = a;
            if (this.k != null) {
                var c = typeCast(INotifyPropertyChanged_$type, this.k);
                if (c != null) {
                    c.propertyChanged = delegateCombine(c.propertyChanged, runOn(this, this.t));
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerSurfaceViewer.prototype.t = function (a, b) {
        if (b.propertyName == "DefaultInteraction") {
            this.j = this.l.bc;
            this.v(b.propertyName, enumGetBox(InteractionState_$type, this.defaultInteraction), enumGetBox(InteractionState_$type, this.defaultInteraction));
        }
    };
    SeriesViewerSurfaceViewer.prototype.zoomTo100 = function () {
        this.l.m4 = XamDataChart.m0;
    };
    SeriesViewerSurfaceViewer.prototype.scaleToFit = function () {
        this.l.m4 = XamDataChart.m0;
    };
    SeriesViewerSurfaceViewer.prototype.renderPreview = function () {
        if (!this.isDirty) {
            return;
        }
        var a = new RenderSurface();
        a.a = this.m.l.viewThumbnailContext;
        if (a.a != null && a.a.d) {
            var b = this.m.l.viewThumbnailSize;
            this.m.b4(b.width, b.height, a);
        }
        this.isDirty = false;
    };
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "worldRect", {
        get: function () {
            return XamDataChart.m0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "viewportRect", {
        get: function () {
            return this.l.m3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "minimumZoomLevel", {
        get: function () {
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "maximumZoomLevel", {
        get: function () {
            if (this.l.ex == 0.0001) {
                return 0.9;
            }
            else {
                return 1 - this.l.ex;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "isDirty", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            this.n = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "isIsoScaled", {
        get: function () {
            if (this.k == null) {
                return false;
            }
            return this.k.cw;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerSurfaceViewer.prototype.v = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case SeriesViewerSurfaceViewer.$$p[0]:
                if (c - this.minimumZoomLevel < -1E-05) {
                    this.zoomLevel = this.minimumZoomLevel;
                    return;
                }
                if (c - this.maximumZoomLevel > 0.0001) {
                    this.zoomLevel = this.maximumZoomLevel;
                    return;
                }
                var d = this.l != null && this.l.bi != null && this.l.bi.updatingSliderRanges;
                if (!this.o && !d) {
                    var e = 1 - this.zoomLevel;
                    var f = RectUtil.l(this.l.mq);
                    var g = new Rect(0, f.x - e / 2, f.y - e / 2, e, e);
                    this.l.m4 = SeriesViewerSurfaceViewer.z(this.l.m4, g, this.l.c3(), this.l.c4(), this.worldRect);
                }
                this.w();
                if (this.l.bi != null) {
                    this.l.bi.pushZoomLevel(this.zoomLevel);
                }
                break;
        }
    };
    SeriesViewerSurfaceViewer.prototype.w = function () {
        var a = Math.round(100 * (1 / (1 - this.zoomLevel)));
        if (a <= 1000) {
            this.zoomLevelDisplayText = a.toString();
        }
        else {
            this.zoomLevelDisplayText = "> 1000";
        }
    };
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "zoomLevelDisplayText", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.zoomLevelDisplayText != a;
            if (b) {
                var c = this.zoomLevelDisplayText;
                this.q = a;
                this.v("ZoomLevelDisplayText", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesViewerSurfaceViewer.prototype, "defaultInteraction", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
            this.l.bc = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesViewerSurfaceViewer.z = function (a, b, c, d, e) {
        var f, g, h, i;
        if (c) {
            f = b.left;
            h = b.width;
        }
        else {
            f = a.left;
            h = a.width;
        }
        if (d) {
            g = b.top;
            i = b.height;
        }
        else {
            g = a.top;
            i = a.height;
        }
        var j = f + h;
        var k = g + i;
        var l = Math.max(0, e.left - f);
        var m = Math.max(0, j - e.right);
        var n = Math.max(0, e.top - g);
        var o = Math.max(0, k - e.bottom);
        f += l - m;
        g += n - o;
        var p = new Rect(0, f, g, h, i);
        p.intersect(e);
        return p;
    };
    SeriesViewerSurfaceViewer.$t = markType(SeriesViewerSurfaceViewer, 'SeriesViewerSurfaceViewer', DependencyObject.$, [IOverviewPlusDetailControl_$type, INotifyPropertyChanged_$type]);
    SeriesViewerSurfaceViewer.$$p = markDep(DependencyProperty, PropertyMetadata, SeriesViewerSurfaceViewer, 'v', ['ZoomLevel::y', [1, 0]]);
    return SeriesViewerSurfaceViewer;
}(DependencyObject));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumeration that determines whether the axis extent measures in pixels or percentage.
 */
var AxisExtentType = /*@__PURE__*/ (function (AxisExtentType) {
    /**
     * Axis extent measured in pixels
     */
    AxisExtentType[AxisExtentType["Pixel"] = 0] = "Pixel";
    /**
     * Axis extent measured as a percentage of the chart's size
     */
    AxisExtentType[AxisExtentType["Percent"] = 1] = "Percent";
    return AxisExtentType;
})({});
/**
 * @hidden
 */
var AxisExtentType_$type = /*@__PURE__*/ markEnum('AxisExtentType', 'Pixel,0|Percent,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisLabelInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelInfo, _super);
    function AxisLabelInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = 0;
        return _this;
    }
    AxisLabelInfo.$t = markType(AxisLabelInfo, 'AxisLabelInfo');
    return AxisLabelInfo;
}(Base));

/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgrSeriesViewer`.
*/
var IgrScalerParams = /** @class */ /*@__PURE__*/ (function () {
    function IgrScalerParams() {
    }
    Object.defineProperty(IgrScalerParams.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrScalerParams.prototype.onImplementationCreated = function () {
    };
    IgrScalerParams.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrScalerParams.prototype, "referenceValue", {
        /**
         * The series reference value.
         * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrScalerParams;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for series highlighting depending on distance of mouse on hover operation.
 */
var HighlightingMode = /*@__PURE__*/ (function (HighlightingMode) {
    /**
     * Specifies the highlight starts on closest element of series
     */
    HighlightingMode[HighlightingMode["Closest"] = 0] = "Closest";
    /**
     * Specifies the highlight starts when directly over element of series
     */
    HighlightingMode[HighlightingMode["DirectlyOver"] = 1] = "DirectlyOver";
    return HighlightingMode;
})({});
/**
 * @hidden
 */
var HighlightingMode_$type = /*@__PURE__*/ markEnum('HighlightingMode', 'Closest,0|DirectlyOver,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SyncSettingsConverter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SyncSettingsConverter, _super);
    function SyncSettingsConverter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SyncSettingsConverter.$t = markType(SyncSettingsConverter, 'SyncSettingsConverter');
    return SyncSettingsConverter;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendLineManagerType_$type = /*@__PURE__*/ markEnum('TrendLineManagerType', 'Category,0|Sorting,1|Polar,2|Radial,3|Scatter,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available orientations for an axis.
 */
var AxisOrientation = /*@__PURE__*/ (function (AxisOrientation) {
    /**
     * Specifies a horizontal axis.
     */
    AxisOrientation[AxisOrientation["Horizontal"] = 0] = "Horizontal";
    /**
     * Specifies a vertical axis.
     */
    AxisOrientation[AxisOrientation["Vertical"] = 1] = "Vertical";
    /**
     * Specifies an angular axis used by the polar series.
     */
    AxisOrientation[AxisOrientation["Angular"] = 2] = "Angular";
    /**
     * Specifies a radial axis used by radial series.
     */
    AxisOrientation[AxisOrientation["Radial"] = 3] = "Radial";
    return AxisOrientation;
})({});
/**
 * @hidden
 */
var AxisOrientation_$type = /*@__PURE__*/ markEnum('AxisOrientation', 'Horizontal,0|Vertical,1|Angular,2|Radial,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CategoryErrorBarSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CategoryErrorBarSettings, _super);
    function CategoryErrorBarSettings() {
        var _this = _super.call(this) || this;
        _this.p = null;
        _this.propertyUpdated = delegateCombine(_this.propertyUpdated, runOn(_this, _this.ab));
        return _this;
    }
    Object.defineProperty(CategoryErrorBarSettings.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
        },
        enumerable: true,
        configurable: true
    });
    CategoryErrorBarSettings.prototype.ab = function (a, b) {
        switch (b.propertyName) {
            case CategoryErrorBarSettings.$$p[0]:
                var c = typeCast(IErrorBarCalculator_$type, b.oldValue);
                if (c != null) {
                    c.changed = delegateRemove(c.changed, runOn(this, this.aa));
                }
                if (this.q != null) {
                    this.q.jd(false);
                    if (this.q.bs != null) {
                        this.q.ik();
                    }
                }
                var d = typeCast(IErrorBarCalculator_$type, b.newValue);
                if (d != null) {
                    d.changed = delegateCombine(d.changed, runOn(this, this.aa));
                }
                break;
            case CategoryErrorBarSettings.$$p[1]:
            case CategoryErrorBarSettings.$$p[2]:
            case CategoryErrorBarSettings.$$p[3]:
            case CategoryErrorBarSettings.$$p[4]:
            case CategoryErrorBarSettings.$$p[5]:
                if (this.q != null) {
                    this.q.jd(false);
                    if (this.q.bs != null) {
                        this.q.ik();
                    }
                }
                break;
        }
    };
    CategoryErrorBarSettings.prototype.aa = function (a, b) {
        var c = typeCast(IErrorBarCalculator_$type, a);
        if (c != null) {
            c.changed = delegateRemove(c.changed, runOn(this, this.aa));
            if (this.q != null) {
                this.q.jd(false);
            }
            c.changed = delegateCombine(c.changed, runOn(this, this.aa));
        }
    };
    CategoryErrorBarSettings.$t = markType(CategoryErrorBarSettings, 'CategoryErrorBarSettings', ErrorBarSettingsBase.$);
    CategoryErrorBarSettings.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryErrorBarSettings, 'l', ['Calculator:r:ac', [IErrorBarCalculator_$type, null], 'EnableErrorBars:o:ad', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'ErrorBarCapLength:t:ae', [1, 6], 'ErrorBarStyle:aj:af', [Style.$, null], 'Stroke:ai:ag', [Brush.$, null], 'StrokeThickness:s:ah', [1, 1]]);
    return CategoryErrorBarSettings;
}(ErrorBarSettingsBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Used to indicate the orientation of the legend
 */
var LegendOrientation = /*@__PURE__*/ (function (LegendOrientation) {
    /**
     */
    LegendOrientation[LegendOrientation["Horizontal"] = 0] = "Horizontal";
    /**
     */
    LegendOrientation[LegendOrientation["Vertical"] = 1] = "Vertical";
    return LegendOrientation;
})({});
/**
 * @hidden
 */
var LegendOrientation_$type = /*@__PURE__*/ markEnum('LegendOrientation', 'Horizontal,0|Vertical,1');

/**
 * Represents a legend in a IgxDataChartComponent control.
*
* The `IgrLegend` helps end-user identify visuals of chart series with contextual information related to the data plotted in the chart control.
*
* ```ts
* <IgrDataChart
* 	dataSource={this.data}
* 	ref={this.onChartRef} width="100%" height="400px">
* <IgrCategoryXAxis name="xAxis" label="Country" />
* <IgrNumericYAxis name="yAxis" minimumValue={0}  />
*
* <IgrLegend ref={this.onLegendRef}
*            orientation="Horizontal" />
* ```
*
* ```ts
* public onChartRef(chart: IgrDataChart) {
*     this.chart = chart;
*     if (this.legend) {
*         this.chart.legend = this.legend;
*     }
* }
*
* public onLegendRef(legend: IgrLegend) {
*     this.legend = legend;
*     if (this.chart) {
*         this.chart.legend = this.legend;
*     }
* }
* ```
*/
var IgrLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLegend, _super);
    function IgrLegend(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        var container;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this.container = ren.getWrapper(container);
        _this._wrapper = ren;
        _this.i.provideContainer(ren);
        return _this;
    }
    IgrLegend.prototype.render = function () {
        var div = createElement("div", {
            className: "ig-legend igr-legend",
            ref: this._getMainRef
        });
        return div;
    };
    IgrLegend.prototype._getMainRef = function (div) {
        this._elRef = div;
    };
    IgrLegend.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.initializeContent();
    };
    IgrLegend.prototype.initializeContent = function () {
        this._elRef.appendChild(this.container.getNativeElement());
    };
    IgrLegend.prototype.destroy = function () {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    };
    IgrLegend.prototype.createImplementation = function () {
        return new Legend();
    };
    Object.defineProperty(IgrLegend.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegend.prototype, "orientation", {
        /**
     * Gets or sets the current Legend object's orientation.
    *
    * ```ts
    * <IgrLegend ref={this.onLegendRef}
    * 	orientation="Horizontal" />
    * ```
    */
        get: function () {
            return this.i.bb;
        },
        set: function (v) {
            this.i.bb = ensureEnum(LegendOrientation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegend.prototype, "textColor", {
        /**
         * Gets or sets color of text
        *
        * ```ts
        *  <IgrLegend ref={this.onLegendRef}
        *             textColor= "red"  />
        * ```
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegend.prototype, "textStyle", {
        /**
         * Gets or sets style of text.
        *
        * ```ts
        *  <IgrLegend ref={this.onLegendRef}
        *             textStyle= "9pt Verdana" />
        * ```
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrLegend;
}(IgrLegendBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrLegendModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrLegendModule() {
    }
    IgrLegendModule.register = function () {
        TypeRegistrar.registerCons('IgrLegend', IgrLegend);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    };
    return IgrLegendModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ItemLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemLegend, _super);
    function ItemLegend() {
        var _this = _super.call(this) || this;
        _this.bb = null;
        _this.bc = null;
        _this.ab = ItemLegend.$;
        _this.bb = _this.ak;
        var a = _this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) {
            var e_1, _a, e_2, _b;
            if (b.oldItems != null) {
                try {
                    for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var c = _d.value;
                        _this.bb.an(c);
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
            if (b.newItems != null) {
                try {
                    for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var d = _f.value;
                        _this.bb.x(d);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        });
        return _this;
    }
    ItemLegend.prototype.aj = function () {
        return new ItemLegendView(this);
    };
    ItemLegend.prototype.a8 = function (a) {
        _super.prototype.a8.call(this, a);
        this.bb = a;
    };
    ItemLegend.prototype.addChildInOrder = function (a, b) {
        if (!this.ak.m()) {
            return;
        }
        this.bg(b);
    };
    ItemLegend.prototype.get_isItemwise = function () {
        return true;
    };
    ItemLegend.prototype.createItemwiseLegendItems = function (a, b) {
        this.a0(a, b);
    };
    ItemLegend.prototype.a0 = function (a, b) {
        var e_3, _a;
        this.ak.af();
        this.clearLegendItemsForSeries(b);
        if (b == null || a == null || a.count == 0) {
            return;
        }
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = typeCast(ContentControl.$, c);
                if (d != null && d.content != null) {
                    var e = typeCast(ILegendContext_$type, d.content);
                    if (e != null && !this.bd(e)) {
                        this.at.add(c);
                        var f = new LegendItemInfo();
                        f.b = e;
                        f.c = c;
                        f.a = b;
                        if (e.legendLabel != null) {
                            f.d = e.legendLabel;
                        }
                        else {
                            f.d = e.itemLabel;
                        }
                    }
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        this.ak.ag();
    };
    ItemLegend.prototype.createLegendItemsInsert = function (a, b) {
        this.bf(a, b);
    };
    ItemLegend.prototype.bf = function (a, b) {
        var e_4, _a;
        this.ak.af();
        try {
            var c = this.be(b);
            if (b == null || a == null || a.count == 0) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    var e = typeCast(ContentControl.$, d);
                    if (e != null && e.content != null) {
                        var f = typeCast(ILegendContext_$type, e.content);
                        if (f != null && !this.bd(f)) {
                            this.at.insert(c, d);
                            c++;
                            var g = new LegendItemInfo();
                            g.b = f;
                            g.c = d;
                            g.a = b;
                            g.d = f.legendLabel != null ? f.legendLabel.toString() : f.itemLabel;
                        }
                    }
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
        }
        finally {
            this.ak.ag();
        }
    };
    ItemLegend.prototype.renderItemwiseContent = function (a) {
        this.bg(a);
    };
    ItemLegend.prototype.bg = function (a) {
        var _this = this;
        this.clearLegendItemsForSeries(a);
        if (a.hasSubItems) {
            a.forSubItems(function (b) {
                var c = typeCast(ContentControl.$, b);
                if (c != null && c.content != null) {
                    var d = typeCast(ILegendContext_$type, c.content);
                    if (d != null && !_this.bd(d)) {
                        _this.at.add(b);
                        var e = new LegendItemInfo();
                        e.b = d;
                        e.c = b;
                        e.a = a;
                        e.d = d.itemLabel;
                    }
                }
            });
        }
    };
    ItemLegend.prototype.be = function (a) {
        var e_5, _a, e_6, _b;
        if (a == null || this.at == null || this.at.count == 0) {
            return 0;
        }
        var b = new ObservableCollection$1(UIElement.$, 0);
        var c = -1;
        var d = 0;
        try {
            for (var _c = __values(fromEnum(this.at)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var e = _d.value;
                var f = typeCast(ContentControl.$, e);
                if (f != null && f.content != null) {
                    var g = typeCast(ILegendContext_$type, f.content);
                    if (g != null && g.series == a) {
                        if (c == -1) {
                            c = d;
                        }
                        b.add(e);
                    }
                }
                d++;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(b)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var h = _f.value;
                this.at.remove(h);
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        if (c == -1) {
            return this.at.count;
        }
        return c;
    };
    ItemLegend.prototype.bd = function (a) {
        return this.bb.ap(a);
    };
    ItemLegend.$t = markType(ItemLegend, 'ItemLegend', LegendBase.$, [IChartItemLegend_$type]);
    return ItemLegend;
}(LegendBase));
/**
 * @hidden
 */
var ItemLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ItemLegendView, _super);
    function ItemLegendView(a) {
        var _this = _super.call(this, a) || this;
        _this.ao = null;
        _this.ao = a;
        return _this;
    }
    ItemLegendView.prototype.ak = function () {
        _super.prototype.ak.call(this);
    };
    ItemLegendView.prototype.get_j = function () {
        return true;
    };
    ItemLegendView.prototype.ap = function (a) {
        return this.c.e(a);
    };
    ItemLegendView.prototype.f = function () {
        var a = new LegendVisualData();
        var b = this.c.g.rootWrapper;
        b = b.getChildAt(0);
        var c = b.getChildCount();
        for (var d = 0; d < c; d++) {
            var e = new LegendItemVisualData();
            var f = b.getChildAt(d);
            e.label = f.getText();
            e.label = e.label != null ? e.label.trim() : null;
            e.bounds = new RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
            e.labelBounds = this.h(f);
            e.badgeBounds = this.g(f);
            a.items.add(e);
        }
        for (var g = 0; g < c; g++) {
            a.items._inner[g].appearance.fill = this.a(g);
        }
        return a;
    };
    ItemLegendView.$t = markType(ItemLegendView, 'ItemLegendView', LegendBaseView.$);
    return ItemLegendView;
}(LegendBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgrItemLegend` to display a legend item for each data member bound to the `IgrBubbleSeries`
*
* ```ts
*   <IgrItemLegend ref={this.onLegendRef} />
* ```
*
* ```ts
* this.onLegendRef = this.onLegendRef.bind(this);
* public onLegendRef(legend: IgrItemLegend) {
*         this.legend = legend;
*         if (this.chart) {
*             this.chart.actualSeries[0].legend = this.legend;
*         }
*     }
* ```
*/
var IgrItemLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrItemLegend, _super);
    function IgrItemLegend(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        var container;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this.container = ren.getWrapper(container);
        _this._wrapper = ren;
        _this.i.provideContainer(ren);
        return _this;
    }
    IgrItemLegend.prototype.render = function () {
        var div = createElement("div", {
            className: "ig-item-legend igr-item-legend",
            ref: this._getMainRef
        });
        return div;
    };
    IgrItemLegend.prototype._getMainRef = function (div) {
        this._elRef = div;
    };
    IgrItemLegend.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this.initializeContent();
    };
    IgrItemLegend.prototype.initializeContent = function () {
        this._elRef.appendChild(this.container.getNativeElement());
    };
    IgrItemLegend.prototype.destroy = function () {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    };
    IgrItemLegend.prototype.createImplementation = function () {
        return new ItemLegend();
    };
    Object.defineProperty(IgrItemLegend.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrItemLegend.prototype.createItemwiseLegendItems = function (legendItems, series) {
        this.i.createItemwiseLegendItems(legendItems, series);
    };
    IgrItemLegend.prototype.exportVisualData = function () {
        return this.i.exportVisualData();
    };
    IgrItemLegend.prototype.exportSerializedVisualData = function () {
        return this.i.exportSerializedVisualData();
    };
    Object.defineProperty(IgrItemLegend.prototype, "isItemwise", {
        /**
     * Gets whether or not this legend supports itemwise visuals
    */
        get: function () {
            return this.i.isItemwise;
        },
        enumerable: true,
        configurable: true
    });
    return IgrItemLegend;
}(IgrLegendBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrItemLegendModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrItemLegendModule() {
    }
    IgrItemLegendModule.register = function () {
        TypeRegistrar.registerCons('IgrItemLegend', IgrItemLegend);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    };
    return IgrItemLegendModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var GradientStopData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GradientStopData, _super);
    function GradientStopData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = 0;
        _this.b = null;
        return _this;
    }
    GradientStopData.$t = markType(GradientStopData, 'GradientStopData');
    return GradientStopData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var GradientData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GradientData, _super);
    function GradientData() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = new List$1(GradientStopData.$, 0);
        return _this;
    }
    GradientData.prototype.b = function () {
        this.a.aa(function (a, b) { return Base.compareSimple(a.a, b.a); });
    };
    GradientData.$t = markType(GradientData, 'GradientData');
    return GradientData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ScaleLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScaleLegend, _super);
    function ScaleLegend() {
        var _this = _super.call(this) || this;
        _this.bd = null;
        _this.bf = 0;
        _this.be = 0;
        _this.bb = null;
        _this.ab = ScaleLegend.$;
        return _this;
    }
    ScaleLegend.prototype.aj = function () {
        return new ScaleLegendView(this);
    };
    ScaleLegend.prototype.a8 = function (a) {
        _super.prototype.a8.call(this, a);
        this.bd = a;
    };
    Object.defineProperty(ScaleLegend.prototype, "legendScaleElement", {
        get: function () {
            return this.bd.ba;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScaleLegend.prototype, "minText", {
        get: function () {
            return this.bd.a6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScaleLegend.prototype, "maxText", {
        get: function () {
            return this.bd.a5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ScaleLegend.prototype, "bc", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            this.bb = a;
        },
        enumerable: true,
        configurable: true
    });
    ScaleLegend.prototype.bi = function () {
        this.bd.a2();
    };
    ScaleLegend.prototype.restoreOriginalState = function () {
        this.bi();
    };
    ScaleLegend.prototype.bl = function (a) {
        if (a == null) {
            return this.bd.a9();
        }
        return ColorUtil.m(a);
    };
    ScaleLegend.prototype.bg = function (a) {
        this.bc = a;
        this.bh();
    };
    ScaleLegend.prototype.initializeLegend = function (a) {
        this.bg(a);
    };
    ScaleLegend.prototype.get_isScale = function () {
        return true;
    };
    ScaleLegend.prototype.bh = function () {
        var _this = this;
        if (this.legendScaleElement == null || this.bc == null || !this.bc.legendReady) {
            return;
        }
        if (this.bc == null || !this.bc.isAttachedTo(this)) {
            return;
        }
        var a = false;
        var b = typeCast(Shape.$, this.legendScaleElement);
        if (b != null) {
            var c_1 = this.bd.aw();
            if (!this.bc.forScaleColors(function (d, e) { return _this.bd.ay(c_1, _this.bl(d), e); })) {
                a = true;
            }
            this.bd.a3(b, a, c_1);
        }
        if (this.minText != null) {
            this.minText.ak = this.bc.minScaleText;
        }
        if (this.maxText != null) {
            this.maxText.ak = this.bc.maxScaleText;
        }
    };
    ScaleLegend.$t = markType(ScaleLegend, 'ScaleLegend', LegendBase.$, [IChartScaleLegend_$type]);
    return ScaleLegend;
}(LegendBase));
/**
 * @hidden
 */
var ScaleLegendView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScaleLegendView, _super);
    function ScaleLegendView(a) {
        var _this = _super.call(this, a) || this;
        _this.ap = null;
        _this.ba = null;
        _this.a6 = null;
        _this.a5 = null;
        _this.ao = null;
        _this.aq = null;
        _this.bb = new Size();
        _this.ar = false;
        _this.as = 0;
        _this.a8 = null;
        _this.a7 = null;
        _this.ap = a;
        _this.a6 = new TextBlock();
        _this.a5 = new TextBlock();
        _this.ba = new Polygon();
        return _this;
    }
    ScaleLegendView.prototype.a2 = function () {
    };
    ScaleLegendView.prototype.z = function () {
    };
    ScaleLegendView.prototype.a9 = function () {
        return Color.u(0, 0, 0, 0);
    };
    ScaleLegendView.prototype.aw = function () {
        return new GradientData();
    };
    ScaleLegendView.prototype.ay = function (a, b, c) {
        var d = a;
        d.a.add(((function () {
            var $ret = new GradientStopData();
            $ret.b = ((function () {
                var $ret = new Brush();
                $ret.color = b;
                return $ret;
            })());
            $ret.a = c;
            return $ret;
        })()));
    };
    ScaleLegendView.prototype.a3 = function (a, b, c) {
        if (b) {
            this.a7 = this.ap.bc.actualMarkerBrush;
            this.ao = null;
        }
        else {
            this.a7 = null;
            this.ao = c;
            this.ao.b();
        }
        this.az();
    };
    ScaleLegendView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.aq = this.c.b(a);
        this.bb = this.c.ab();
        this.az();
    };
    ScaleLegendView.prototype.az = function () {
        if (!this.ar) {
            this.ar = true;
            if (this.c.g != null) {
                this.c.g.setTimeout(runOn(this, this.a4), 0);
            }
            else {
                window.setTimeout(runOn(this, this.a4), 0);
            }
        }
    };
    ScaleLegendView.prototype.a4 = function () {
        if (this.ar) {
            this.ar = false;
            this.a1();
        }
    };
    ScaleLegendView.prototype.a1 = function () {
        if (this.aq == null) {
            return;
        }
        this.a0();
    };
    ScaleLegendView.prototype.au = function (a) {
        var b = typeCast(TextBlock.$, a);
        if (b != null && b.ak != null) {
            return this.aq.e(b) + 0;
        }
        return 0;
    };
    ScaleLegendView.prototype.at = function (a) {
        return this.as + 0;
    };
    ScaleLegendView.prototype.a0 = function () {
        if (this.ap.bc == null || this.ap.bc.container == null || (this.ao == null && this.a7 == null)) {
            return;
        }
        if (this.aq.d) {
            var a = typeCast(IInternalLegendOwner_$type, this.ap.bc.container);
            this.aq.ac(a.getFontInfo());
            this.as = a.getFontHeight();
            this.a8 = a.getFontBrush();
            var b = this.au(this.a6);
            var c = this.au(this.a5);
            var d = Math.max(b, c) + 4;
            if (d >= this.bb.width) {
                d = 0;
            }
            var e = this.bb.width - d;
            var f = 2;
            var g = 2;
            e = e - 4;
            var h = this.bb.height - 4;
            var i = f + e + 4;
            var j = g;
            var k = h;
            var l = { $type: Point_$type, x: f + (3 / 5) * e, y: g };
            var m = { $type: Point_$type, x: f + (5 / 5) * e, y: g };
            var n = { $type: Point_$type, x: f + (5 / 5) * e, y: h };
            var o = { $type: Point_$type, x: f, y: h };
            var p = this.ba;
            p.ak.clear();
            p.ak.add(l);
            p.ak.add(m);
            p.ak.add(n);
            p.ak.add(o);
            this.a6.n = i;
            this.a6.o = j;
            this.a6.am = this.a8;
            this.a5.n = i;
            this.a5.o = j + k - (this.at(this.a6));
            this.a5.am = this.a8;
            this.aq.k(0, 0, this.bb.width, this.bb.height);
            if (this.ao == null && this.a7 != null) {
                p._fill = this.a7;
                this.aq.t(p);
            }
            else {
                this.c.y(this.aq, p, this.ao, new Rect(0, g, f, e, h));
            }
            if (d > 0) {
                this.aq.w(this.a6);
                this.aq.w(this.a5);
            }
        }
    };
    ScaleLegendView.prototype.al = function () {
        _super.prototype.al.call(this);
    };
    ScaleLegendView.$t = markType(ScaleLegendView, 'ScaleLegendView', LegendBaseView.$);
    return ScaleLegendView;
}(LegendBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a legend that indicates the size and the color scale for a collection of series.
*/
var IgrScaleLegend = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrScaleLegend, _super);
    function IgrScaleLegend(props) {
        return _super.call(this, props) || this;
    }
    IgrScaleLegend.prototype.createImplementation = function () {
        return new ScaleLegend();
    };
    Object.defineProperty(IgrScaleLegend.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrScaleLegend;
}(IgrLegendBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrScaleLegendModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrScaleLegendModule() {
    }
    IgrScaleLegendModule.register = function () {
        TypeRegistrar.registerCons('IgrScaleLegend', IgrScaleLegend);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    };
    return IgrScaleLegendModule;
}());

/**
 * Provides data for legend mouse button related events.
*/
var IgrLegendMouseEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrLegendMouseEventArgs() {
    }
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrLegendMouseEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrLegendMouseEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            return this.i.series;
        },
        set: function (v) {
            this.i.series = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            return this.i.chart;
        },
        set: function (v) {
            this.i.chart = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseEventArgs.prototype, "legendItem", {
        /**
         * The legend item in context.
        */
        get: function () {
            return this.i.legendItem;
        },
        set: function (v) {
            this.i.legendItem = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    IgrLegendMouseEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    return IgrLegendMouseEventArgs;
}());

/**
 * Provides data for legend mouse button related events.
*/
var IgrLegendMouseButtonEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrLegendMouseButtonEventArgs() {
    }
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrLegendMouseButtonEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrLegendMouseButtonEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "handled", {
        /**
         * Gets or sets a value that indicates the present state of the event handling for a routed
         * event as it travels the route.
         * ChartMouseButton events are not routed events; setting this property effects the underlying
         * MouseButtonEvent.
        */
        get: function () {
            return this.i.handled;
        },
        set: function (v) {
            this.i.handled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: function () {
            return this.i.series;
        },
        set: function (v) {
            this.i.series = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: function () {
            return this.i.chart;
        },
        set: function (v) {
            this.i.chart = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLegendMouseButtonEventArgs.prototype, "legendItem", {
        /**
         * The legend item that was the target of the mouse event.
        */
        get: function () {
            return this.i.legendItem;
        },
        set: function (v) {
            this.i.legendItem = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    IgrLegendMouseButtonEventArgs.prototype.toString = function () {
        var iv = this.i.toString();
        return (iv);
    };
    return IgrLegendMouseButtonEventArgs;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Contains PieChart label click event data.
*/
var IgrLabelClickEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrLabelClickEventArgs() {
    }
    Object.defineProperty(IgrLabelClickEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrLabelClickEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrLabelClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrLabelClickEventArgs.prototype, "item", {
        /**
         * Gets the slice data context.
        */
        get: function () {
            return this.i.item;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLabelClickEventArgs.prototype, "allowSliceClick", {
        /**
         * Gets and sets whether or not the owning pie chart should fire its SliceClick event
        */
        get: function () {
            return this.i.allowSliceClick;
        },
        set: function (v) {
            this.i.allowSliceClick = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrLabelClickEventArgs;
}());

/**
 * Provides data for the SelectedItemChanged event.
*/
var IgrSelectedItemChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSelectedItemChangedEventArgs() {
    }
    Object.defineProperty(IgrSelectedItemChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrSelectedItemChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSelectedItemChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrSelectedItemChangedEventArgs.prototype, "oldItem", {
        /**
         * The previously selected item.
        */
        get: function () {
            return this.i.oldItem;
        },
        set: function (v) {
            this.i.oldItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSelectedItemChangedEventArgs.prototype, "newItem", {
        /**
         * The newly selected item.
        */
        get: function () {
            return this.i.newItem;
        },
        set: function (v) {
            this.i.newItem = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrSelectedItemChangedEventArgs;
}());

/**
 * Provides data for the SelectedItemChanging event.
*/
var IgrSelectedItemChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSelectedItemChangingEventArgs, _super);
    function IgrSelectedItemChangingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgrSelectedItemChangingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSelectedItemChangingEventArgs.prototype, "cancel", {
        /**
         * Set this to true in order to stop the SelectedItem from changing.
        */
        get: function () {
            return this.i.cancel;
        },
        set: function (v) {
            this.i.cancel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSelectedItemChangingEventArgs;
}(IgrSelectedItemChangedEventArgs));

/**
 * Provides data for the SelectedItemsChanged event.
*/
var IgrSelectedItemsChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSelectedItemsChangedEventArgs() {
    }
    Object.defineProperty(IgrSelectedItemsChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrSelectedItemsChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSelectedItemsChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return IgrSelectedItemsChangedEventArgs;
}());

/**
 * Provides data for the SelectedItemsChanging event.
*/
var IgrSelectedItemsChangingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSelectedItemsChangingEventArgs, _super);
    function IgrSelectedItemsChangingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgrSelectedItemsChangingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSelectedItemsChangingEventArgs.prototype, "cancel", {
        /**
         * Set this to true in order to stop the SelectedItems collection from changing.
        */
        get: function () {
            return this.i.cancel;
        },
        set: function (v) {
            this.i.cancel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrSelectedItemsChangingEventArgs;
}(IgrSelectedItemsChangedEventArgs));

/**
 * Represents the base class for the pie chart.
*/
var IgrPieChartBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPieChartBase, _super);
    function IgrPieChartBase(props) {
        var _this = _super.call(this, props) || this;
        _this._explodedSlices = null;
        _this._selectedItems = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._labelClick = null;
        _this._labelClick_wrapped = null;
        _this._selectedItemChanging = null;
        _this._selectedItemChanging_wrapped = null;
        _this._selectedItemsChanging = null;
        _this._selectedItemsChanging_wrapped = null;
        _this._selectedItemChanged = null;
        _this._selectedItemChanged_wrapped = null;
        _this._selectedItemsChanged = null;
        _this._selectedItemsChanged_wrapped = null;
        _this._sliceClick = null;
        _this._sliceClick_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrPieChartBase.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrPieChartBase.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrPieChartBase._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrPieChartBase.prototype.onImplementationCreated = function () {
    };
    IgrPieChartBase.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrPieChartBase.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrPieChartBase.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrPieChartBase.prototype, "innerExtent", {
        /**
         * Gets or sets the amount of space between the center and the start of the arc. This property should be set between 0 and 1.
         * If InnerExtent is set to a value greater than 1, it will be interpreted as a percentage, effectively divided by 100.
        */
        get: function () {
            return this.i.cl;
        },
        set: function (v) {
            this.i.cl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "valueMemberPath", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: function () {
            return this.i.eg;
        },
        set: function (v) {
            this.i.eg = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "labelMemberPath", {
        /**
         * Gets or sets the property name that contains the labels.
        */
        get: function () {
            return this.i.di;
        },
        set: function (v) {
            this.i.di = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "legendLabelMemberPath", {
        /**
         * Gets or sets the property name that contains the legend labels.
        */
        get: function () {
            return this.i.dv;
        },
        set: function (v) {
            this.i.dv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "labelsPosition", {
        /**
         * Gets or sets the position of chart labels.
        */
        get: function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = ensureEnum(LabelsPosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "labelOuterColor", {
        /**
         * Gets or sets the color for labels rendered outside of the pie chart.
        */
        get: function () {
            return brushToString(this.i.gy);
        },
        set: function (v) {
            this.i.gy = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "labelInnerColor", {
        /**
         * Gets or sets the color for labels rendered inside of the pie chart.
        */
        get: function () {
            return brushToString(this.i.gx);
        },
        set: function (v) {
            this.i.gx = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "leaderLineVisibility", {
        /**
         * Gets or sets whether the leader lines are visible.
        */
        get: function () {
            return this.i.ha;
        },
        set: function (v) {
            this.i.ha = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "leaderLineType", {
        /**
         * Gets or sets what type of leader lines will be used for the outside end labels.
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureEnum(LeaderLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "leaderLineMargin", {
        /**
         * Gets or sets the margin between a label and the end of its leader line. The default is 6 pixels.
        */
        get: function () {
            return this.i.cn;
        },
        set: function (v) {
            this.i.cn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "toolTip", {
        /**
         * Gets or sets the ToolTip for the chart.
        */
        get: function () {
            return this.i.c0;
        },
        set: function (v) {
            this.i.c0 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryThreshold", {
        /**
         * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
        */
        get: function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryType", {
        /**
         * Gets or sets whether to use numeric or percent-based threshold value.
        */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = ensureEnum(OthersCategoryType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryText", {
        /**
         * Gets or sets the label of the Others slice.
        */
        get: function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "explodedRadius", {
        /**
         * Determines how much the exploded slice is offset from the center. Value between 0 and 1.
        */
        get: function () {
            return this.i.cg;
        },
        set: function (v) {
            this.i.cg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "radiusFactor", {
        /**
         * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
        */
        get: function () {
            return this.i.cr;
        },
        set: function (v) {
            this.i.cr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "allowSliceSelection", {
        /**
         * Gets or sets whether the slices can be selected.
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "allowSliceExplosion", {
        /**
         * Gets or sets whether the slices can be exploded.
        */
        get: function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "explodedSlices", {
        /**
         * Gets or sets the collection of exploded slice indices.
        */
        get: function () {
            if (this._explodedSlices === null) {
                var coll = new IgrIndexCollection();
                var innerColl = this.i.explodedSlices;
                if (!innerColl) {
                    innerColl = new IndexCollection();
                }
                this._explodedSlices = coll._fromInner(innerColl);
                this.i.explodedSlices = innerColl;
            }
            return this._explodedSlices;
        },
        set: function (v) {
            if (this._explodedSlices !== null) {
                this._explodedSlices._setSyncTarget(null);
                this._explodedSlices = null;
            }
            var coll = new IgrIndexCollection();
            this._explodedSlices = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Number_$type);
            var innerColl = this.i.explodedSlices;
            if (!innerColl) {
                innerColl = new IndexCollection();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._explodedSlices._setSyncTarget(syncColl);
            this.i.explodedSlices = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "labelExtent", {
        /**
         * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
        */
        get: function () {
            return this.i.cm;
        },
        set: function (v) {
            this.i.cm = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "startAngle", {
        /**
         * Gets or sets the starting angle of the chart.
         * The default zero value is equivalent to 3 o'clock.
        */
        get: function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "sweepDirection", {
        /**
         * Gets or sets the rotational direction of the chart.
        */
        get: function () {
            return this.i.gz;
        },
        set: function (v) {
            this.i.gz = ensureEnum(SweepDirection_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.g7 ? this.i.g7.fill : null;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.g7.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.g7 ? this.i.g7.stroke : null;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.g7.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.g7 ? this.i.g7.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.g7.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "othersCategoryOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.g7 ? this.i.g7.opacity : NaN;
        },
        set: function (v) {
            this.ensureOthersCategoryStyle();
            this.i.g7.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChartBase.prototype.ensureOthersCategoryStyle = function () {
        if (this.i.g7) {
            return;
        }
        this.i.g7 = new Style();
    };
    Object.defineProperty(IgrPieChartBase.prototype, "selectedSliceFill", {
        /**
         * Gets or sets the fill brush.
        */
        get: function () {
            return this.i.g8 ? this.i.g8.fill : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.g8.fill = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedSliceStroke", {
        /**
         * Gets or sets the stroke brush.
        */
        get: function () {
            return this.i.g8 ? this.i.g8.stroke : null;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.g8.stroke = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedSliceStrokeThickness", {
        /**
         * Gets or sets the stroke thickness.
        */
        get: function () {
            return this.i.g8 ? this.i.g8.strokeThickness : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.g8.strokeThickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedSliceOpacity", {
        /**
         * Gets or sets the opacity.
        */
        get: function () {
            return this.i.g8 ? this.i.g8.opacity : NaN;
        },
        set: function (v) {
            this.ensureSelectedStyle();
            this.i.g8.opacity = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChartBase.prototype.ensureSelectedStyle = function () {
        if (this.i.g8) {
            return;
        }
        this.i.g8 = new Style();
    };
    Object.defineProperty(IgrPieChartBase.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the slices.
        */
        get: function () {
            return fromBrushCollection(this.i.ag);
        },
        set: function (v) {
            this.i.ag = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the slices.
        */
        get: function () {
            return fromBrushCollection(this.i.ah);
        },
        set: function (v) {
            this.i.ah = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the chart object itself.
        */
        get: function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the chart object itself.
        */
        get: function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
        get: function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "formatLegendLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
        */
        get: function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.cq;
        },
        set: function (v) {
            this.i.cq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "actualPixelScalingRatio", {
        /**
         * Resolved pixel scaling ratio. Unless explicitly overridden by the PieChartBase.PixelScalingRatio property,
         * this one returns the default ratio enforced by device. High resolution devices will initialize this property
         * to a higher value.
        */
        get: function () {
            return this.i.cd;
        },
        set: function (v) {
            this.i.cd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectionMode", {
        /**
         * Gets or sets which mode to use for selecting slices.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = ensureEnum(SliceSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItem", {
        /**
         * Gets or sets the currently selected data item.  If a different data item is provided the pie chart
         * will select the slice associated with the new item.
        */
        get: function () {
            return this.i.selectedItem;
        },
        set: function (v) {
            this.i.selectedItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItems", {
        /**
         * Gets the currently selected data items.  Adding or removing data items from this collection will
         * select or deselect the slices associated with those items.
        */
        get: function () {
            if (this._selectedItems === null) {
                var coll = new IgrObjectCollection();
                var innerColl = this.i.selectedItems;
                if (!innerColl) {
                    innerColl = new ObjectCollection(0);
                }
                this._selectedItems = coll._fromInner(innerColl);
                this.i.selectedItems = innerColl;
            }
            return this._selectedItems;
        },
        set: function (v) {
            if (this._selectedItems !== null) {
                this._selectedItems._setSyncTarget(null);
                this._selectedItems = null;
            }
            var coll = new IgrObjectCollection();
            this._selectedItems = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(Base.$type);
            var innerColl = this.i.selectedItems;
            if (!innerColl) {
                innerColl = new ObjectCollection(0);
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._selectedItems._setSyncTarget(syncColl);
            this.i.selectedItems = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "textStyle", {
        /**
         * Manually overrides the style to use for the labels.
        */
        get: function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChartBase.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrPieChartBase.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("PieChartBase");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    IgrPieChartBase.prototype.exportSerializedVisualData = function () {
        var iv = this.i.c8();
        return (iv);
    };
    /**
     * Simulates a mouse click action at the specified point.
    
    * @param point  * The point to click at.
    */
    IgrPieChartBase.prototype.simulateLeftClick = function (point) {
        this.i.fn(toPoint(point));
    };
    /**
     * Invoked by the containing object to provide reference to the container.
    
    * @param container  * Reference to the container.
    */
    IgrPieChartBase.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    IgrPieChartBase.prototype.notifyContainerResized = function () {
        this.i.notifyContainerResized();
    };
    /**
     * Invoked when the instance is being destroyed.
    
    */
    IgrPieChartBase.prototype.destroy = function () {
        this.i.destroy();
    };
    /**
     * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the pie chart.
    
    */
    IgrPieChartBase.prototype.flush = function () {
        this.i.el();
    };
    IgrPieChartBase.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.eu(source_, index, oldItem, newItem);
    };
    /**
     * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the pie chart is bound to is already observable.
    
    * @param source_  * The data source.
    */
    IgrPieChartBase.prototype.notifyClearItems = function (source_) {
        this.i.eq(source_);
    };
    IgrPieChartBase.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.es(source_, index, newItem);
    };
    IgrPieChartBase.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.et(source_, index, oldItem);
    };
    /**
     * Assigns data source for the items.
    
    * @param source_  * Array of the data source items.
    */
    IgrPieChartBase.prototype.setWidgetLevelDataSource = function (source_) {
        this.i.fm(source_);
    };
    /**
     * Resets items data source.
    
    */
    IgrPieChartBase.prototype.removeWidgetLevelDataSource = function () {
        this.i.fd();
    };
    /**
     * Invoked when style is updated.
    
    */
    IgrPieChartBase.prototype.styleUpdated = function () {
        this.i.fr();
    };
    Object.defineProperty(IgrPieChartBase.prototype, "labelClick", {
        /**
         * Raised when the slice's label is clicked.
        */
        get: function () {
            return this._labelClick;
        },
        set: function (ev) {
            var _this = this;
            if (this._labelClick_wrapped !== null) {
                this.i.labelClick = delegateRemove(this.i.labelClick, this._labelClick_wrapped);
                this._labelClick_wrapped = null;
                this._labelClick = null;
            }
            this._labelClick = ev;
            this._labelClick_wrapped = function (o, e) {
                var outerArgs = new IgrLabelClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeLabelClick) {
                    _this.beforeLabelClick(_this, outerArgs);
                }
                if (_this._labelClick) {
                    _this._labelClick(_this, outerArgs);
                }
            };
            this.i.labelClick = delegateCombine(this.i.labelClick, this._labelClick_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItemChanging", {
        /**
         * Raised when the SelectedItem property is changing.  This event is cancelable.
        */
        get: function () {
            return this._selectedItemChanging;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedItemChanging_wrapped !== null) {
                this.i.selectedItemChanging = delegateRemove(this.i.selectedItemChanging, this._selectedItemChanging_wrapped);
                this._selectedItemChanging_wrapped = null;
                this._selectedItemChanging = null;
            }
            this._selectedItemChanging = ev;
            this._selectedItemChanging_wrapped = function (o, e) {
                var outerArgs = new IgrSelectedItemChangingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedItemChanging) {
                    _this.beforeSelectedItemChanging(_this, outerArgs);
                }
                if (_this._selectedItemChanging) {
                    _this._selectedItemChanging(_this, outerArgs);
                }
            };
            this.i.selectedItemChanging = delegateCombine(this.i.selectedItemChanging, this._selectedItemChanging_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItemsChanging", {
        /**
         * Raised when the SelectedItems collection is changing.  This event is cancelable.
        */
        get: function () {
            return this._selectedItemsChanging;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedItemsChanging_wrapped !== null) {
                this.i.selectedItemsChanging = delegateRemove(this.i.selectedItemsChanging, this._selectedItemsChanging_wrapped);
                this._selectedItemsChanging_wrapped = null;
                this._selectedItemsChanging = null;
            }
            this._selectedItemsChanging = ev;
            this._selectedItemsChanging_wrapped = function (o, e) {
                var outerArgs = new IgrSelectedItemsChangingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedItemsChanging) {
                    _this.beforeSelectedItemsChanging(_this, outerArgs);
                }
                if (_this._selectedItemsChanging) {
                    _this._selectedItemsChanging(_this, outerArgs);
                }
            };
            this.i.selectedItemsChanging = delegateCombine(this.i.selectedItemsChanging, this._selectedItemsChanging_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItemChanged", {
        /**
         * Raised when the SelectedItem property has changed.
        */
        get: function () {
            return this._selectedItemChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedItemChanged_wrapped !== null) {
                this.i.selectedItemChanged = delegateRemove(this.i.selectedItemChanged, this._selectedItemChanged_wrapped);
                this._selectedItemChanged_wrapped = null;
                this._selectedItemChanged = null;
            }
            this._selectedItemChanged = ev;
            this._selectedItemChanged_wrapped = function (o, e) {
                var outerArgs = new IgrSelectedItemChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedItemChanged) {
                    _this.beforeSelectedItemChanged(_this, outerArgs);
                }
                if (_this._selectedItemChanged) {
                    _this._selectedItemChanged(_this, outerArgs);
                }
            };
            this.i.selectedItemChanged = delegateCombine(this.i.selectedItemChanged, this._selectedItemChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "selectedItemsChanged", {
        /**
         * Raised when the SelectedItems collection has changed.
        */
        get: function () {
            return this._selectedItemsChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._selectedItemsChanged_wrapped !== null) {
                this.i.selectedItemsChanged = delegateRemove(this.i.selectedItemsChanged, this._selectedItemsChanged_wrapped);
                this._selectedItemsChanged_wrapped = null;
                this._selectedItemsChanged = null;
            }
            this._selectedItemsChanged = ev;
            this._selectedItemsChanged_wrapped = function (o, e) {
                var outerArgs = new IgrSelectedItemsChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSelectedItemsChanged) {
                    _this.beforeSelectedItemsChanged(_this, outerArgs);
                }
                if (_this._selectedItemsChanged) {
                    _this._selectedItemsChanged(_this, outerArgs);
                }
            };
            this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, this._selectedItemsChanged_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChartBase.prototype, "sliceClick", {
        /**
         * Raised when the slice is clicked.
        */
        get: function () {
            return this._sliceClick;
        },
        set: function (ev) {
            var _this = this;
            if (this._sliceClick_wrapped !== null) {
                this.i.sliceClick = delegateRemove(this.i.sliceClick, this._sliceClick_wrapped);
                this._sliceClick_wrapped = null;
                this._sliceClick = null;
            }
            this._sliceClick = ev;
            this._sliceClick_wrapped = function (o, e) {
                var outerArgs = new IgrSliceClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeSliceClick) {
                    _this.beforeSliceClick(_this, outerArgs);
                }
                if (_this._sliceClick) {
                    _this._sliceClick(_this, outerArgs);
                }
            };
            this.i.sliceClick = delegateCombine(this.i.sliceClick, this._sliceClick_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrPieChartBase;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var XamPieChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamPieChart, _super);
    function XamPieChart() {
        var _this = _super.call(this) || this;
        _this.hb = null;
        _this.ab = XamPieChart.$;
        return _this;
    }
    XamPieChart.prototype.ar = function () {
        return new XamPieChartView(this);
    };
    XamPieChart.prototype.e6 = function (a) {
        _super.prototype.e6.call(this, a);
        this.hb = a;
    };
    XamPieChart.$t = markType(XamPieChart, 'XamPieChart', PieChartBase.$);
    return XamPieChart;
}(PieChartBase));
/**
 * @hidden
 */
var XamPieChartView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamPieChartView, _super);
    function XamPieChartView(a) {
        var _this = _super.call(this, a) || this;
        _this.b4 = null;
        _this.b4 = a;
        return _this;
    }
    XamPieChartView.$t = markType(XamPieChartView, 'XamPieChartView', PieChartBaseView.$);
    return XamPieChartView;
}(PieChartBaseView));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgrPieChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPieChart, _super);
    function IgrPieChart(props) {
        var _this = _super.call(this, props) || this;
        _this._dataSource = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        var container;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this.container = ren.getWrapper(container);
        _this._wrapper = ren;
        var chart = _this.i;
        _this._chart = chart;
        chart.provideContainer(ren);
        _this.bindData();
        chart.notifyContainerResized();
        ren.addSizeWatcher(function () {
            _this._chart.notifyContainerResized();
        });
        return _this;
    }
    Object.defineProperty(IgrPieChart.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._chart.notifyContainerResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieChart.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.width = value;
                this._chart.notifyContainerResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChart.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrPieChart.prototype.render = function () {
        var div = createElement("div", {
            className: "ig-pie-chart igr-pie-chart",
            ref: this._getMainRef
        });
        return div;
    };
    IgrPieChart.prototype.destroy = function () {
        this._chart.destroy();
        this._wrapper.destroy();
    };
    IgrPieChart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this.container.getNativeElement());
        this._styling(this._elRef, this);
        this._chart.notifyContainerResized();
    };
    IgrPieChart.prototype.componentWillUnmount = function () {
        this.destroy();
    };
    IgrPieChart.prototype.createImplementation = function () {
        return new XamPieChart();
    };
    Object.defineProperty(IgrPieChart.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChart.prototype.createSeriesComponent = function (type) {
        if (TypeRegistrar.isRegistered(type)) {
            var s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this._wrapper);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    };
    Object.defineProperty(IgrPieChart.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.bindData();
        },
        enumerable: true,
        configurable: true
    });
    IgrPieChart.prototype.bindData = function () {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    };
    Object.defineProperty(IgrPieChart.prototype, "legend", {
        /**
         * Gets or sets the legend used for the current chart.
        */
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrPieChart;
}(IgrPieChartBase));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPieChartCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPieChartCoreModule() {
    }
    IgrPieChartCoreModule.register = function () {
        TypeRegistrar.registerCons('IgrPieChart', IgrPieChart);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    };
    return IgrPieChartCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrPieChartModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrPieChartModule() {
    }
    IgrPieChartModule.register = function () {
        IgrPieChartCoreModule.register();
        IgrDataChartInteractivityModule.register();
    };
    return IgrPieChartModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the selected data contained inside the Others slice.
*/
var IgrPieSliceOthersContext = /** @class */ /*@__PURE__*/ (function () {
    function IgrPieSliceOthersContext() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrPieSliceOthersContext.prototype.createImplementation = function () {
        return new PieSliceOthersContext();
    };
    Object.defineProperty(IgrPieSliceOthersContext.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrPieSliceOthersContext.prototype.onImplementationCreated = function () {
    };
    IgrPieSliceOthersContext.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    return IgrPieSliceOthersContext;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * DataContext for a pie slice.
*/
var IgrPieSliceDataContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPieSliceDataContext, _super);
    function IgrPieSliceDataContext() {
        return _super.call(this) || this;
    }
    IgrPieSliceDataContext.prototype.createImplementation = function () {
        return new PieSliceDataContext();
    };
    Object.defineProperty(IgrPieSliceDataContext.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieSliceDataContext.prototype, "percentValue", {
        /**
         * Gets or sets the value of this slice as a percentage of the total pie.
        */
        get: function () {
            return this.i.percentValue;
        },
        set: function (v) {
            this.i.percentValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrPieSliceDataContext.prototype, "isOthersSlice", {
        /**
         * Gets or sets whether this slice is an Others slice or not.
        */
        get: function () {
            return this.i.isOthersSlice;
        },
        set: function (v) {
            this.i.isOthersSlice = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrPieSliceDataContext;
}(IgrDataContext));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MouseMoveThunk = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MouseMoveThunk, _super);
    function MouseMoveThunk() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.c = null;
        _this.b = 0;
        _this.a = null;
        return _this;
    }
    MouseMoveThunk.$t = markType(MouseMoveThunk, 'MouseMoveThunk');
    return MouseMoveThunk;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var KNearestResults = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(KNearestResults, _super);
    function KNearestResults() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = 0;
        _this.f = 0;
        _this.b = null;
        _this.a = false;
        _this.d = 0;
        _this.c = 0;
        _this.g = 0;
        return _this;
    }
    KNearestResults.$t = markType(KNearestResults, 'KNearestResults');
    return KNearestResults;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomContourValueResolverEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomContourValueResolverEventArgs, _super);
    function CustomContourValueResolverEventArgs(a) {
        var _this = _super.call(this) || this;
        _this._valueColumn = null;
        _this._contourValuesEnumerable = null;
        _this.b = null;
        _this.valueColumn = a;
        return _this;
    }
    Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "valueColumn", {
        get: function () {
            return this._valueColumn;
        },
        set: function (a) {
            this._valueColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "contourValuesEnumerable", {
        get: function () {
            return this._contourValuesEnumerable;
        },
        set: function (a) {
            this._contourValuesEnumerable = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "values", {
        get: function () {
            if (this.valueColumn == null) {
                return [];
            }
            return this.valueColumn.asArray();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CustomContourValueResolverEventArgs.prototype, "contourValues", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            if (a == null) {
                this.contourValuesEnumerable = null;
            }
            else {
                this.contourValuesEnumerable = a;
            }
        },
        enumerable: true,
        configurable: true
    });
    CustomContourValueResolverEventArgs.$t = markType(CustomContourValueResolverEventArgs, 'CustomContourValueResolverEventArgs', EventArgs.$);
    return CustomContourValueResolverEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CustomContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CustomContourValueResolver, _super);
    function CustomContourValueResolver() {
        var _this = _super.call(this) || this;
        _this.getCustomContourValues = null;
        return _this;
    }
    CustomContourValueResolver.prototype.j = function (a) {
        var b = new CustomContourValueResolverEventArgs(a);
        this.n(b);
        if (b.contourValuesEnumerable != null) {
            return b.contourValuesEnumerable;
        }
        return [];
    };
    CustomContourValueResolver.prototype.n = function (a) {
        if (this.getCustomContourValues != null) {
            this.getCustomContourValues(this, a);
        }
    };
    CustomContourValueResolver.$t = markType(CustomContourValueResolver, 'CustomContourValueResolver', ContourValueResolver.$);
    return CustomContourValueResolver;
}(ContourValueResolver));

/**
 * Provides data for GetCustomContourValues event.
*/
var IgrCustomContourValueResolverEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrCustomContourValueResolverEventArgs() {
    }
    Object.defineProperty(IgrCustomContourValueResolverEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrCustomContourValueResolverEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrCustomContourValueResolverEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrCustomContourValueResolverEventArgs.prototype, "values", {
        get: function () {
            return this.i.values;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomContourValueResolverEventArgs.prototype, "contourValues", {
        get: function () {
            return this.i.contourValues;
        },
        set: function (v) {
            this.i.contourValues = v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrCustomContourValueResolverEventArgs;
}());

/**
 * ContourValueResolver class which fires an event to resolve the contour values.
*/
var IgrCustomContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrCustomContourValueResolver, _super);
    function IgrCustomContourValueResolver(props) {
        var _this = _super.call(this, props) || this;
        _this._getCustomContourValues = null;
        _this._getCustomContourValues_wrapped = null;
        return _this;
    }
    IgrCustomContourValueResolver.prototype.createImplementation = function () {
        return new CustomContourValueResolver();
    };
    Object.defineProperty(IgrCustomContourValueResolver.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrCustomContourValueResolver.prototype, "getCustomContourValues", {
        /**
         * Event raised when retrieving the contour values.
        */
        get: function () {
            return this._getCustomContourValues;
        },
        set: function (ev) {
            var _this = this;
            if (this._getCustomContourValues_wrapped !== null) {
                this.i.getCustomContourValues = delegateRemove(this.i.getCustomContourValues, this._getCustomContourValues_wrapped);
                this._getCustomContourValues_wrapped = null;
                this._getCustomContourValues = null;
            }
            this._getCustomContourValues = ev;
            this._getCustomContourValues_wrapped = function (o, e) {
                var outerArgs = new IgrCustomContourValueResolverEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeGetCustomContourValues) {
                    _this.beforeGetCustomContourValues(_this, outerArgs);
                }
                if (_this._getCustomContourValues) {
                    _this._getCustomContourValues(_this, outerArgs);
                }
            };
            this.i.getCustomContourValues = delegateCombine(this.i.getCustomContourValues, this._getCustomContourValues_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrCustomContourValueResolver;
}(IgrContourValueResolver));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrCustomContourValueResolverModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrCustomContourValueResolverModule() {
    }
    IgrCustomContourValueResolverModule.register = function () {
        TypeRegistrar.registerCons("IgrCustomContourValueResolver", IgrCustomContourValueResolver);
        TypeRegistrar.register("CustomContourValueResolver", CustomContourValueResolver.$type);
    };
    return IgrCustomContourValueResolverModule;
}());

/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
var IgrLinearContourValueResolver = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrLinearContourValueResolver, _super);
    function IgrLinearContourValueResolver(props) {
        return _super.call(this, props) || this;
    }
    IgrLinearContourValueResolver.prototype.createImplementation = function () {
        return new LinearContourValueResolver();
    };
    Object.defineProperty(IgrLinearContourValueResolver.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrLinearContourValueResolver.prototype, "valueCount", {
        /**
         * Gets or sets how many contour values to return.
        */
        get: function () {
            return this.i.valueCount;
        },
        set: function (v) {
            this.i.valueCount = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrLinearContourValueResolver;
}(IgrContourValueResolver));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrLinearContourValueResolverModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrLinearContourValueResolverModule() {
    }
    IgrLinearContourValueResolverModule.register = function () {
        TypeRegistrar.registerCons("IgrLinearContourValueResolver", IgrLinearContourValueResolver);
        TypeRegistrar.register("LinearContourValueResolver", LinearContourValueResolver.$type);
    };
    return IgrLinearContourValueResolverModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TriangleRasterizer_PointAndValue = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TriangleRasterizer_PointAndValue, _super);
    function TriangleRasterizer_PointAndValue() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = 0;
        return _this;
    }
    TriangleRasterizer_PointAndValue.$t = markType(TriangleRasterizer_PointAndValue, 'TriangleRasterizer_PointAndValue');
    return TriangleRasterizer_PointAndValue;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PointerTooltipVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointerTooltipVisualData, _super);
    function PointerTooltipVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._boxShape = null;
        _this._pointerFillShape = null;
        _this._pointerOutlineShape = null;
        _this._offsetX = 0;
        _this._offsetY = 0;
        _this._categoryNames = null;
        _this._viewport = null;
        return _this;
    }
    Object.defineProperty(PointerTooltipVisualData.prototype, "boxShape", {
        get: function () {
            return this._boxShape;
        },
        set: function (a) {
            this._boxShape = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltipVisualData.prototype, "pointerFillShape", {
        get: function () {
            return this._pointerFillShape;
        },
        set: function (a) {
            this._pointerFillShape = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltipVisualData.prototype, "pointerOutlineShape", {
        get: function () {
            return this._pointerOutlineShape;
        },
        set: function (a) {
            this._pointerOutlineShape = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltipVisualData.prototype, "offsetX", {
        get: function () {
            return this._offsetX;
        },
        set: function (a) {
            this._offsetX = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltipVisualData.prototype, "offsetY", {
        get: function () {
            return this._offsetY;
        },
        set: function (a) {
            this._offsetY = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PointerTooltipVisualData.prototype, "categoryNames", {
        get: function () {
            return this._categoryNames;
        },
        set: function (a) {
            this._categoryNames = a;
        },
        enumerable: true,
        configurable: true
    });
    PointerTooltipVisualData.prototype.serialize = function () {
        var e_1, _a;
        var a = "";
        if (this.categoryNames != null) {
            try {
                for (var _b = __values(fromEnum(this.categoryNames)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    a += "\"" + b + "\",";
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (a != "") {
                a = a.substr(0, a.length - 1);
            }
        }
        var c = new StringBuilder(0);
        c.u("{");
        c.u("offsetX: " + this.offsetX + ", ");
        c.u("offsetY: " + this.offsetY + ", ");
        c.u("boxShape: " + this.boxShape.serialize() + ", ");
        c.u("pointerFillShape: " + this.pointerFillShape.serialize() + ", ");
        c.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
        c.u("pointerOutlineShape: " + this.pointerOutlineShape.serialize() + ", ");
        c.u("categoryNames: [" + a + "]");
        c.u("}");
        return c.toString();
    };
    PointerTooltipVisualData.prototype.scaleByViewport = function (a) {
        this.boxShape.scaleByViewport(this.viewport);
        this.pointerFillShape.scaleByViewport(this.viewport);
        this.pointerOutlineShape.scaleByViewport(this.viewport);
        this.offsetX = (this.offsetX - a.left) / a.width;
        this.offsetY = (this.offsetY - a.top) / a.height;
    };
    Object.defineProperty(PointerTooltipVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    PointerTooltipVisualData.$t = markType(PointerTooltipVisualData, 'PointerTooltipVisualData');
    return PointerTooltipVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PointerTooltipVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PointerTooltipVisualDataList, _super);
    function PointerTooltipVisualDataList() {
        return _super.call(this, PointerTooltipVisualData.$, 0) || this;
    }
    PointerTooltipVisualDataList.$t = markType(PointerTooltipVisualDataList, 'PointerTooltipVisualDataList', List$1.$.specialize(PointerTooltipVisualData.$));
    return PointerTooltipVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerVisualDataList, _super);
    function MarkerVisualDataList() {
        return _super.call(this, MarkerVisualData.$, 0) || this;
    }
    MarkerVisualDataList.$t = markType(MarkerVisualDataList, 'MarkerVisualDataList', List$1.$.specialize(MarkerVisualData.$));
    return MarkerVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutVisualData, _super);
    function CalloutVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._background = null;
        _this._text = null;
        _this._line = null;
        _this._left = 0;
        _this._top = 0;
        _this._marginLeft = 0;
        _this._marginTop = 0;
        return _this;
    }
    Object.defineProperty(CalloutVisualData.prototype, "background", {
        get: function () {
            return this._background;
        },
        set: function (a) {
            this._background = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "text", {
        get: function () {
            return this._text;
        },
        set: function (a) {
            this._text = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "line", {
        get: function () {
            return this._line;
        },
        set: function (a) {
            this._line = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "left", {
        get: function () {
            return this._left;
        },
        set: function (a) {
            this._left = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "top", {
        get: function () {
            return this._top;
        },
        set: function (a) {
            this._top = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "marginLeft", {
        get: function () {
            return this._marginLeft;
        },
        set: function (a) {
            this._marginLeft = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CalloutVisualData.prototype, "marginTop", {
        get: function () {
            return this._marginTop;
        },
        set: function (a) {
            this._marginTop = a;
        },
        enumerable: true,
        configurable: true
    });
    CalloutVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("left: " + this.left.toString() + ",");
        a.u("top: " + this.top.toString() + ",");
        a.u("marginLeft: " + this.marginLeft.toString() + ",");
        a.u("marginTop: " + this.marginTop.toString() + ",");
        a.u("background: " + this.background.serialize() + ",");
        a.u("text: " + this.text.serialize() + ",");
        a.u("line: " + this.line.serialize());
        a.u("}");
        return a.toString();
    };
    CalloutVisualData.prototype.scaleByViewport = function (a) {
        this.left = (this.left - a.left) / a.width;
        this.top = (this.top - a.top) / a.height;
        this.marginLeft = this.marginLeft / a.width;
        this.marginTop = this.marginTop / a.height;
        this.background.scaleByViewport(a);
        this.line.scaleByViewport(a);
    };
    CalloutVisualData.$t = markType(CalloutVisualData, 'CalloutVisualData');
    return CalloutVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var CalloutVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CalloutVisualDataList, _super);
    function CalloutVisualDataList() {
        return _super.call(this, CalloutVisualData.$, 0) || this;
    }
    CalloutVisualDataList.$t = markType(CalloutVisualDataList, 'CalloutVisualDataList', List$1.$.specialize(CalloutVisualData.$));
    return CalloutVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesVisualData, _super);
    function SeriesVisualData() {
        var _this = _super.call(this) || this;
        _this._name = null;
        _this._type = null;
        _this._viewport = null;
        _this._opacity = 0;
        _this._shapes = null;
        _this._pointerTooltips = null;
        _this._markerShapes = null;
        _this._calloutShapes = null;
        _this._pixels = null;
        _this._pixelWidth = 0;
        _this._pixelHeight = 0;
        _this.shapes = new PrimitiveVisualDataList();
        _this.markerShapes = new MarkerVisualDataList();
        _this.pointerTooltips = new PointerTooltipVisualDataList();
        _this.calloutShapes = new CalloutVisualDataList();
        return _this;
    }
    Object.defineProperty(SeriesVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (a) {
            this._type = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "opacity", {
        get: function () {
            return this._opacity;
        },
        set: function (a) {
            this._opacity = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "shapes", {
        get: function () {
            return this._shapes;
        },
        set: function (a) {
            this._shapes = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "pointerTooltips", {
        get: function () {
            return this._pointerTooltips;
        },
        set: function (a) {
            this._pointerTooltips = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "markerShapes", {
        get: function () {
            return this._markerShapes;
        },
        set: function (a) {
            this._markerShapes = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "calloutShapes", {
        get: function () {
            return this._calloutShapes;
        },
        set: function (a) {
            this._calloutShapes = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "pixels", {
        get: function () {
            return this._pixels;
        },
        set: function (a) {
            this._pixels = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "pixelWidth", {
        get: function () {
            return this._pixelWidth;
        },
        set: function (a) {
            this._pixelWidth = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SeriesVisualData.prototype, "pixelHeight", {
        get: function () {
            return this._pixelHeight;
        },
        set: function (a) {
            this._pixelHeight = a;
        },
        enumerable: true,
        configurable: true
    });
    SeriesVisualData.prototype.m = function () {
        var e_1, _a, e_2, _b, e_3, _c, e_4, _d;
        try {
            for (var _e = __values(fromEnum(this.shapes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var a = _f.value;
                a.scaleByViewport(this.viewport);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_a = _e.return))
                    _a.call(_e);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _g = __values(fromEnum(this.markerShapes)), _h = _g.next(); !_h.done; _h = _g.next()) {
                var b = _h.value;
                b.i(this.viewport);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_h && !_h.done && (_b = _g.return))
                    _b.call(_g);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        try {
            for (var _j = __values(fromEnum(this.pointerTooltips)), _k = _j.next(); !_k.done; _k = _j.next()) {
                var c = _k.value;
                c.scaleByViewport(this.viewport);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_k && !_k.done && (_c = _j.return))
                    _c.call(_j);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        try {
            for (var _l = __values(fromEnum(this.calloutShapes)), _m = _l.next(); !_m.done; _m = _l.next()) {
                var d = _m.value;
                d.scaleByViewport(this.viewport);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_m && !_m.done && (_d = _l.return))
                    _d.call(_l);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
    };
    SeriesVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\",");
        a.u("type: \"" + this.type + "\", ");
        a.u("opacity: " + this.opacity + ", ");
        a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
        a.u("shapes: [");
        for (var b = 0; b < this.shapes.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.shapes._inner[b].serialize());
        }
        a.u("],");
        a.u("pointerTooltips: [");
        for (var c = 0; c < this.pointerTooltips.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.pointerTooltips._inner[c].serialize());
        }
        a.u("],");
        if (this.calloutShapes != null && this.calloutShapes.count > 0) {
            a.u("calloutshapes: [");
            for (var d = 0; d < this.calloutShapes.count; d++) {
                if (d != 0) {
                    a.l(", ");
                }
                a.l(this.calloutShapes._inner[d].serialize());
            }
            a.u("],");
        }
        a.u("markerShapes: [");
        for (var e = 0; e < this.markerShapes.count; e++) {
            if (e != 0) {
                a.l(", ");
            }
            a.l(this.markerShapes._inner[e].serialize());
        }
        a.u("]");
        if (this.pixels != null) {
            a.u(", pixels: [");
            for (var f = 0; f < this.pixels.length; f++) {
                if (f != 0) {
                    a.l(", ");
                }
                a.l(this.pixels[f].toString());
            }
            a.u("], ");
            a.u("pixelWidth: " + this.pixelWidth + ", ");
        }
        a.u("}");
        return a.toString();
    };
    SeriesVisualData.$t = markType(SeriesVisualData, 'SeriesVisualData');
    return SeriesVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesVisualDataList, _super);
    function SeriesVisualDataList() {
        return _super.call(this, SeriesVisualData.$, 0) || this;
    }
    SeriesVisualDataList.$t = markType(SeriesVisualDataList, 'SeriesVisualDataList', List$1.$.specialize(SeriesVisualData.$));
    return SeriesVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var StackedSeriesVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StackedSeriesVisualData, _super);
    function StackedSeriesVisualData() {
        var _this = _super.call(this) || this;
        _this._fragmentSeries = null;
        _this.fragmentSeries = new SeriesVisualDataList();
        return _this;
    }
    Object.defineProperty(StackedSeriesVisualData.prototype, "fragmentSeries", {
        get: function () {
            return this._fragmentSeries;
        },
        set: function (a) {
            this._fragmentSeries = a;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesVisualData.$t = markType(StackedSeriesVisualData, 'StackedSeriesVisualData', SeriesVisualData.$);
    return StackedSeriesVisualData;
}(SeriesVisualData));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SeriesVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SeriesVisualDataManager, _super);
    function SeriesVisualDataManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SeriesVisualDataManager.prototype.addSubSeriesVisualData = function (a, b) {
        var c = a;
        var d = b;
        c.fragmentSeries.add(d);
    };
    SeriesVisualDataManager.prototype.copyVisualData = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = a;
        var d = b;
        try {
            for (var _c = __values(fromEnum(d.shapes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var e = _d.value;
                c.shapes.add(e);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(d.markerShapes)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var f = _f.value;
                c.markerShapes.add(f);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        c.pixels = d.pixels;
        c.pixelWidth = d.pixelWidth;
    };
    SeriesVisualDataManager.prototype.createFragmentVisualData = function (a, b, c, d) {
        var e = new SeriesVisualData();
        e.viewport = RectData.b(b);
        e.type = c;
        e.name = d;
        return e;
    };
    SeriesVisualDataManager.prototype.exportMarkerVisualData = function (a, b) {
        var _this = this;
        var c = b;
        a.l0.cc(function (d) {
            var e = _this.getMarkerVisualData(a, d, a.mj);
            c.markerShapes.add(typeCast(MarkerVisualData.$, e));
        });
    };
    SeriesVisualDataManager.prototype.getMarkerVisualData = function (a, b, c) {
        var d = new MarkerVisualData();
        var e = new PrimitiveAppearanceData();
        d.x = b.n;
        d.y = b.o;
        d.bounds = new RectData(b.n - (b.m / 2), b.o - (b.l / 2), b.m, b.l);
        e.fill = ColorData.a_1(Color.u(0, 0, 0, 0));
        e.stroke = ColorData.a_1(Color.u(0, 0, 0, 0));
        d.index = -1;
        d.contentTemplate = b.ah;
        if (b.content != null && typeCast(DataContext.$, b.content) !== null && b._visibility == 0) {
            var f = b.content;
            e.fill = AppearanceHelper.b(f.actualItemBrush);
            e.fillExtended = AppearanceHelper.a(f.actualItemBrush);
            e.stroke = AppearanceHelper.b(f.outline);
            e.strokeExtended = AppearanceHelper.a(f.outline);
            e.strokeThickness = a.ey;
            if (f.item != null) {
                d.index = a.bz.indexOf(f.item);
            }
        }
        e.isVisible = b._visibility == 0;
        d.isVisible = b._visibility == 0;
        d.markerAppearance = e;
        d.markerType = this.a(a, c);
        return d;
    };
    SeriesVisualDataManager.prototype.a = function (a, b) {
        if (b == a.bs.kn) {
            return "Circle";
        }
        else if (b == a.bs.ko) {
            return "Diamond";
        }
        else if (b == a.bs.kp) {
            return "Hexagon";
        }
        else if (b == a.bs.kq) {
            return "Hexagram";
        }
        else if (b == a.bs.kr) {
            return "Pentagon";
        }
        else if (b == a.bs.ks) {
            return "Pentagram";
        }
        else if (b == a.bs.kt) {
            return "Pyramid";
        }
        else if (b == a.bs.ku) {
            return "Square";
        }
        else if (b == a.bs.kv) {
            return "Tetragram";
        }
        else if (b == a.bs.kw) {
            return "Triangle";
        }
        else {
            return "None";
        }
    };
    SeriesVisualDataManager.prototype.exportMarkerVisualDataFromMarker = function (a, b, c) {
        var d = b;
        var e = new MarkerVisualData();
        var f = new PrimitiveAppearanceData();
        e.x = c.n;
        e.y = c.o;
        e.bounds = new RectData(c.n - (c.m / 2), c.o - (c.l / 2), c.m, c.l);
        e.index = -1;
        e.contentTemplate = c.ah;
        if (typeCast(DataContext.$, c.content) !== null) {
            var g = c.content;
            f.fill = AppearanceHelper.b(g.actualItemBrush);
            f.stroke = AppearanceHelper.b(g.outline);
        }
        e.isVisible = c._visibility == 0;
        e.markerAppearance = f;
        if (c.ah == a.bs.kn) {
            e.markerType = "Circle";
        }
        else if (c.ah == a.bs.ko) {
            e.markerType = "Diamond";
        }
        else if (c.ah == a.bs.kp) {
            e.markerType = "Hexagon";
        }
        else if (c.ah == a.bs.kq) {
            e.markerType = "Hexagram";
        }
        else if (c.ah == a.bs.kr) {
            e.markerType = "Pentagon";
        }
        else if (c.ah == a.bs.ks) {
            e.markerType = "Pentagram";
        }
        else if (c.ah == a.bs.kt) {
            e.markerType = "Pyramid";
        }
        else if (c.ah == a.bs.ku) {
            e.markerType = "Square";
        }
        else if (c.ah == a.bs.kv) {
            e.markerType = "Tetragram";
        }
        else if (c.ah == a.bs.kw) {
            e.markerType = "Triangle";
        }
        else {
            e.markerType = "None";
        }
        d.markerShapes.add(e);
    };
    SeriesVisualDataManager.prototype.exportPathData = function (a, b, c, d) {
        var e = a;
        var f = new PathVisualData(1, c, b);
        if (d != null) {
            for (var g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    };
    SeriesVisualDataManager.prototype.exportPolygonData = function (a, b, c, d) {
        var e = a;
        var f = new PolygonVisualData(1, c, b);
        if (d != null) {
            for (var g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    };
    SeriesVisualDataManager.prototype.exportPolylineData = function (a, b, c, d) {
        var e = a;
        var f = new PolyLineVisualData(1, c, b);
        if (d != null) {
            for (var g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    };
    SeriesVisualDataManager.prototype.exportRectangleData = function (a, b, c, d) {
        var e = a;
        var f = new RectangleVisualData(1, c, b);
        if (d != null) {
            for (var g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    };
    SeriesVisualDataManager.prototype.exportStackedVisualData = function (a, b) {
        var c = new StackedSeriesVisualData();
        c.viewport = RectData.b(b);
        c.type = getInstanceType(a).typeName;
        c.name = a.name;
        return c;
    };
    SeriesVisualDataManager.prototype.exportTrendlineData = function (a, b, c) {
        var d = b;
        var e = new PolyLineVisualData(1, "trendLine", c);
        e.tags.add("Trend");
        d.shapes.add(e);
    };
    SeriesVisualDataManager.prototype.exportVisualData = function (a, b) {
        var c = new SeriesVisualData();
        c.viewport = RectData.b(b);
        c.type = this.b(getInstanceType(a).typeName);
        c.name = a.name;
        c.opacity = a._opacity;
        return c;
    };
    SeriesVisualDataManager.prototype.exportSeriesPixelsData = function (a, b, c, d) {
        var e = a;
        e.pixels = b;
        e.pixelWidth = c;
        e.pixelHeight = d;
    };
    SeriesVisualDataManager.prototype.b = function (a) {
        return a;
    };
    SeriesVisualDataManager.prototype.addPointerTooltipData = function (a, b, c, d, e) {
        if (b == null) {
            return;
        }
        var f = a;
        var g = b;
        g.offsetX = c;
        g.offsetY = d;
        g.categoryNames = e;
        f.pointerTooltips.add(g);
    };
    SeriesVisualDataManager.prototype.exportPointerTooltipData = function (a, b, c, d) {
        var e = new PointerTooltipVisualData();
        e.pointerFillShape = new PolygonVisualData(1, "fillShape", a);
        e.pointerOutlineShape = new PolyLineVisualData(1, "outlineShape", b);
        e.boxShape = new RectangleVisualData(1, "boxShape", c);
        e.viewport = RectData.b(d);
        return e;
    };
    SeriesVisualDataManager.prototype.exportCalloutData = function (a, b, c, d, e, f, g, h, i, j, k) {
        var l = new CalloutVisualData();
        l.left = a;
        l.top = b;
        l.marginLeft = c;
        l.marginTop = d;
        l.background = new RectangleVisualData(1, "calloutBackground", f);
        l.text = AppearanceHelper.c(g, h);
        l.line = new LineVisualData(1, "calloutLeaderLine", i);
        e.calloutShapes.add(l);
    };
    SeriesVisualDataManager.$t = markType(SeriesVisualDataManager, 'SeriesVisualDataManager', Base.$, [ISeriesVisualDataManager_$type]);
    return SeriesVisualDataManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VisualExportHelper = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VisualExportHelper, _super);
    function VisualExportHelper() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VisualExportHelper.a = function (a) {
        var e_1, _a;
        var b = { $type: Point_$type, x: a.n, y: a.o };
        var c = new Rect(0, b.x, b.y, a.m, a.l);
        var d = a.j;
        if (d == null) {
            return c;
        }
        var e = 0;
        var f = 0;
        var g = 0;
        var h = null;
        if (typeCast(RotateTransform.$, d) !== null) {
            h = typeCast(RotateTransform.$, d);
            e = h.j;
        }
        else if (typeCast(TransformGroup.$, d) !== null) {
            var i = typeCast(TransformGroup.$, d);
            try {
                for (var _b = __values(fromEnum(i.j)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var j = _c.value;
                    if (typeCast(RotateTransform.$, j) !== null) {
                        h = typeCast(RotateTransform.$, j);
                        e = h.j;
                    }
                    if (typeCast(TranslateTransform.$, j) !== null) {
                        var k = typeCast(TranslateTransform.$, j);
                        f = k.j;
                        g = k.k;
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
        if (h != null) {
            c = RectUtil.x(c, h.k, h.l, e);
        }
        c.x = c.x + f;
        c.y = c.y + g;
        return c;
    };
    VisualExportHelper.$t = markType(VisualExportHelper, 'VisualExportHelper');
    return VisualExportHelper;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChartTitleVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartTitleVisualData, _super);
    function ChartTitleVisualData() {
        var _this = _super.call(this) || this;
        _this._viewport = null;
        _this._textPlotArea = null;
        _this._appearance = null;
        _this.appearance = new LabelAppearanceData();
        return _this;
    }
    Object.defineProperty(ChartTitleVisualData.prototype, "width", {
        get: function () {
            return this.viewport.width;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartTitleVisualData.prototype, "height", {
        get: function () {
            return this.viewport.height;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartTitleVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartTitleVisualData.prototype, "textPlotArea", {
        get: function () {
            return this._textPlotArea;
        },
        set: function (a) {
            this._textPlotArea = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartTitleVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartTitleVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("viewport: " + this.viewport.serialize() + ", ");
        a.u("textPlotArea: " + this.textPlotArea.serialize() + ", ");
        a.u("appearance: " + this.appearance.serialize());
        a.u("}");
        return a.toString();
    };
    ChartTitleVisualData.prototype.h = function (a) {
        var b = (this.textPlotArea.left - a.left) / a.width;
        var c = (this.textPlotArea.top - a.top) / a.height;
        var d = this.textPlotArea.width / a.width;
        var e = this.textPlotArea.height / a.height;
        this.textPlotArea = new RectData(b, c, d, e);
    };
    ChartTitleVisualData.prototype.g = function () {
        var a = (this.textPlotArea.left - this.viewport.left) / this.viewport.width;
        var b = (this.textPlotArea.top - this.viewport.top) / this.viewport.height;
        var c = this.textPlotArea.width / this.viewport.width;
        var d = this.textPlotArea.height / this.viewport.height;
        this.textPlotArea = new RectData(a, b, c, d);
    };
    ChartTitleVisualData.prototype.j = function (a) {
        var b = this.textPlotArea.left * a.width;
        var c = this.textPlotArea.top * a.height;
        var d = this.textPlotArea.width * a.width;
        var e = this.textPlotArea.height * a.height;
        this.textPlotArea = new RectData(b, c, d, e);
    };
    ChartTitleVisualData.prototype.i = function () {
        var a = this.textPlotArea.left * this.viewport.width;
        var b = this.textPlotArea.top * this.viewport.height;
        var c = this.textPlotArea.width * this.viewport.width;
        var d = this.textPlotArea.height * this.viewport.height;
        this.textPlotArea = new RectData(a, b, c, d);
    };
    ChartTitleVisualData.$t = markType(ChartTitleVisualData, 'ChartTitleVisualData');
    return ChartTitleVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelVisualData, _super);
    function AxisLabelVisualData() {
        var _this = _super.call(this) || this;
        _this._labelValue = null;
        _this._labelPosition = 0;
        _this._position = null;
        _this._panelPosition = null;
        _this._appearance = null;
        _this._size = null;
        _this.position = new PointData(NaN, NaN);
        _this.size = new SizeData(NaN, NaN);
        _this.panelPosition = new PointData(NaN, NaN);
        return _this;
    }
    Object.defineProperty(AxisLabelVisualData.prototype, "labelValue", {
        get: function () {
            return this._labelValue;
        },
        set: function (a) {
            this._labelValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelVisualData.prototype, "labelPosition", {
        get: function () {
            return this._labelPosition;
        },
        set: function (a) {
            this._labelPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelVisualData.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelVisualData.prototype, "panelPosition", {
        get: function () {
            return this._panelPosition;
        },
        set: function (a) {
            this._panelPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisLabelVisualData.prototype, "size", {
        get: function () {
            return this._size;
        },
        set: function (a) {
            this._size = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisLabelVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("position: " + "{ x: " + this.position.x + ", y: " + this.position.y + "},");
        a.u("size: " + "{ width: " + this.size.width + ", height: " + this.size.height + "},");
        a.u("labelPosition: " + this.labelPosition + ",");
        a.u("appearance: " + (this.appearance != null ? this.appearance.serialize() : "null"));
        a.u("}");
        return a.toString();
    };
    AxisLabelVisualData.prototype.h = function (a, b) {
        if (b) {
            this.labelPosition = (this.labelPosition - a.left) / a.width;
        }
        else {
            this.labelPosition = (this.labelPosition - a.top) / a.height;
        }
        var c = (this.position.x - a.left) / a.width;
        var d = (this.position.y - a.top) / a.height;
        this.position = new PointData(c, d);
        var e = (this.size.width) / a.width;
        var f = (this.size.height) / a.height;
        this.size = new SizeData(e, f);
        ;
    };
    AxisLabelVisualData.$t = markType(AxisLabelVisualData, 'AxisLabelVisualData');
    return AxisLabelVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisLabelVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisLabelVisualDataList, _super);
    function AxisLabelVisualDataList() {
        return _super.call(this, AxisLabelVisualData.$, 0) || this;
    }
    AxisLabelVisualDataList.$t = markType(AxisLabelVisualDataList, 'AxisLabelVisualDataList', List$1.$.specialize(AxisLabelVisualData.$));
    return AxisLabelVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisVisualData, _super);
    function AxisVisualData() {
        var _this = _super.call(this) || this;
        _this._name = null;
        _this._type = null;
        _this._viewport = null;
        _this._tickMarksLength = 0;
        _this._tickMarks = null;
        _this._labels = null;
        _this._axisLine = null;
        _this._majorLines = null;
        _this._minorLines = null;
        _this._strips = null;
        _this._labelsPlotArea = null;
        _this._labelsViewport = null;
        _this._title = null;
        _this._annotationBackings = null;
        _this.tickMarksLength = 0;
        _this.labels = new AxisLabelVisualDataList();
        _this.title = new ChartTitleVisualData();
        return _this;
    }
    Object.defineProperty(AxisVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "type", {
        get: function () {
            return this._type;
        },
        set: function (a) {
            this._type = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "tickMarksLength", {
        get: function () {
            return this._tickMarksLength;
        },
        set: function (a) {
            this._tickMarksLength = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "tickMarks", {
        get: function () {
            return this._tickMarks;
        },
        set: function (a) {
            this._tickMarks = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "labels", {
        get: function () {
            return this._labels;
        },
        set: function (a) {
            this._labels = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "axisLine", {
        get: function () {
            return this._axisLine;
        },
        set: function (a) {
            this._axisLine = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "majorLines", {
        get: function () {
            return this._majorLines;
        },
        set: function (a) {
            this._majorLines = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "minorLines", {
        get: function () {
            return this._minorLines;
        },
        set: function (a) {
            this._minorLines = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "strips", {
        get: function () {
            return this._strips;
        },
        set: function (a) {
            this._strips = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "labelsPlotArea", {
        get: function () {
            return this._labelsPlotArea;
        },
        set: function (a) {
            this._labelsPlotArea = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "labelsViewport", {
        get: function () {
            return this._labelsViewport;
        },
        set: function (a) {
            this._labelsViewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "title", {
        get: function () {
            return this._title;
        },
        set: function (a) {
            this._title = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AxisVisualData.prototype, "annotationBackings", {
        get: function () {
            return this._annotationBackings;
        },
        set: function (a) {
            this._annotationBackings = a;
        },
        enumerable: true,
        configurable: true
    });
    AxisVisualData.prototype.p = function () {
        var e_1, _a, e_2, _b;
        var a = true;
        if (Base.equalsStatic(this.type, "NumericYAxis") || Base.equalsStatic(this.type, "CategoryYAxis") || Base.equalsStatic(this.type, "PercentChangeYAxis")) {
            a = false;
        }
        try {
            for (var _c = __values(fromEnum(this.labels)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                b.h(this.labelsViewport, a);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.tickMarks.scaleByViewport(this.labelsViewport);
        this.axisLine.scaleByViewport(this.labelsViewport);
        if (this.title != null) {
            this.title.h(this.labelsViewport);
        }
        this.majorLines.scaleByViewport(this.viewport);
        this.minorLines.scaleByViewport(this.viewport);
        this.strips.scaleByViewport(this.viewport);
        if (this.annotationBackings != null) {
            try {
                for (var _e = __values(fromEnum(this.annotationBackings)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var c = _f.value;
                    c.scaleByViewport(this.labelsViewport);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
    };
    AxisVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\",");
        a.u("type: \"" + this.type + "\", ");
        a.u("tickMarksLength: \"" + this.tickMarksLength.toString() + "\", ");
        a.u("viewport: " + this.viewport.serialize() + ", ");
        a.u("labelsViewport: " + this.labelsViewport.serialize() + ", ");
        if (this.labelsPlotArea != null) {
            a.u("labelsPlotArea: " + this.labelsPlotArea.serialize() + ", ");
        }
        a.u("labels: [");
        for (var b = 0; b < this.labels.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.labels._inner[b].serialize());
        }
        a.u("],");
        if (this.title != null) {
            a.u("title: " + ((this.title != null) ? this.title.serialize() : "null") + ", ");
        }
        a.u("axisLine: " + ((this.axisLine != null) ? this.axisLine.serialize() : "null") + ", ");
        a.u("tickMarks: " + ((this.tickMarks != null) ? this.tickMarks.serialize() : "null") + ", ");
        if (this.annotationBackings != null) {
            a.u("annotationBackings: [");
            for (var c = 0; c < this.annotationBackings.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.annotationBackings._inner[c].serialize());
            }
            a.u("],");
        }
        if (this.axisLine != null) {
            a.u("majorLines: " + ((this.majorLines != null) ? this.majorLines.serialize() : "null") + ", ");
            a.u("minorLines: " + ((this.minorLines != null) ? this.minorLines.serialize() : "null") + ", ");
            a.u("strips: " + ((this.strips != null) ? this.strips.serialize() : "null"));
        }
        a.u("}");
        return a.toString();
    };
    AxisVisualData.$t = markType(AxisVisualData, 'AxisVisualData');
    return AxisVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisVisualDataManager, _super);
    function AxisVisualDataManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AxisVisualDataManager.prototype.c = function (a) {
        return a;
    };
    AxisVisualDataManager.prototype.d = function (a, b) {
        var c = VisualExportHelper.a(b);
        return c;
    };
    AxisVisualDataManager.prototype.a = function (a, b, c, d) {
        var e = new ChartTitleVisualData();
        var f = a.a2;
        var g = f.a6();
        e.viewport = RectData.b(g);
        var h = this.d(a, d);
        e.textPlotArea = RectData.b(h);
        var i = d._visibility == 0 && d.x != null;
        var j = a.at.ae.d();
        var k = f.bd(d);
        var l = this.b(a, d, j);
        var m = AppearanceHelper.c(d, l);
        m.marginLeft = k.left;
        m.marginRight = k.right;
        m.marginTop = k.top;
        m.marginBottom = k.bottom;
        m.fontStretch = "Normal";
        m.textWrapping = "Wrap";
        m.visibility = i;
        if (a.bc != null) {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, a.bc.horizontalAlignment);
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, a.bc.verticalAlignment);
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, a.bc.position);
        }
        else {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, (0));
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, (1));
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, (0));
        }
        e.appearance = m;
        return e;
    };
    AxisVisualDataManager.prototype.exportVisualData = function (a) {
        var b = new AxisVisualData();
        b.viewport = RectData.b(a.i1);
        b.labelsViewport = RectData.b(a.a2.a6());
        b.type = this.c(getInstanceType(a).typeName);
        b.name = a.name;
        var c = new PathVisualData(1, "axisLine", a.a2.a7);
        b.axisLine = c;
        b.tickMarks = new PathVisualData(1, "tickMarks", a.at.ae.av);
        if (!a.at.ab.contains(a.at.ae.av)) {
            b.tickMarks.data.clear();
        }
        b.minorLines = new PathVisualData(1, "minorLines", a.a2.a9);
        b.majorLines = new PathVisualData(1, "majorLines", a.a2.a8);
        b.strips = new PathVisualData(1, "strips", a.a2.ba);
        if (a.f7 != null) {
            var d = this.a(a, a.bf, b.type, a.hk);
            b.title = d;
        }
        else {
            b.title = null;
        }
        var e = a.bf.getFontInfo();
        if (a.aw != null && a.aw.textStyle != null) {
            e = a.aw.g(a.bf.bn.i.ae);
        }
        var f, g, h, i;
        var j = a.at.ae.av.ak.d;
        for (var k = 1; k < j.count; k++) {
            var l = j._inner[k];
            var m = j._inner[k - 1];
            f = l.d.x - l.c.x;
            g = l.d.y - l.c.y;
            h = m.d.x - m.c.x;
            i = m.d.y - m.c.y;
            if (1 == k) {
                b.tickMarksLength = Math.sqrt(Math.pow(f, 2) + Math.pow(g, 2));
            }
        }
        var n = a.at.a2;
        var o = a.at.ae.g();
        var _loop_1 = function (p) {
            var e_1, _a;
            var q = a.at.a2._inner[p];
            var r = a.at.a1._inner[p];
            var s = ((function () {
                var $ret = new AxisLabelVisualData();
                $ret.labelPosition = q.c;
                $ret.labelValue = r;
                $ret.panelPosition = PointData.b(a.a2.a3());
                return $ret;
            })());
            var t = new List$1(TextBlock.$, 0);
            try {
                for (var _b = (e_1 = void 0, __values(fromEnum(o))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var u = _c.value;
                    t.add(u);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
            if (p < t.count) {
                var v = this_1.b(a, t._inner[p], e);
                s.appearance = AppearanceHelper.c(t._inner[p], v);
                s.position = PointData.b(a.a2.a2(t._inner[p]));
                s.size = SizeData.b(new Size(1, t._inner[p].m, t._inner[p].l));
            }
            b.labels.add(s);
        };
        var this_1 = this;
        for (var p = 0; p < n.count; p++) {
            _loop_1(p);
        }
        var w = null;
        for (var x = 0; x < a.bm.a.count; x++) {
            if (w == null) {
                w = new List$1(RectangleVisualData.$, 0);
            }
            var y = new RectangleVisualData(1, "annotationBacking_" + x, a.bm.item(x));
            y.appearance.canvasLeft = a.bm.item(x).n;
            y.appearance.canvasTop = a.bm.item(x).o;
            w.add(y);
        }
        b.annotationBackings = w;
        return b;
    };
    AxisVisualDataManager.prototype.b = function (a, b, c) {
        return FontUtil.getFontInfo(a.bf.bn.i.ae, b, c);
    };
    AxisVisualDataManager.$t = markType(AxisVisualDataManager, 'AxisVisualDataManager', Base.$, [IAxisVisualDataManager_$type]);
    return AxisVisualDataManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisVisualDataList, _super);
    function AxisVisualDataList() {
        return _super.call(this, AxisVisualData.$, 0) || this;
    }
    AxisVisualDataList.$t = markType(AxisVisualDataList, 'AxisVisualDataList', List$1.$.specialize(AxisVisualData.$));
    return AxisVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChartVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartVisualData, _super);
    function ChartVisualData() {
        var _this = _super.call(this) || this;
        _this._axes = null;
        _this._series = null;
        _this._title = null;
        _this._subtitle = null;
        _this._width = 0;
        _this._height = 0;
        _this._contentArea = null;
        _this._centralArea = null;
        _this._plotArea = null;
        _this._name = null;
        _this._isViewportScaled = false;
        _this._dipScalingRatio = 0;
        _this.dipScalingRatio = 1;
        _this.axes = new AxisVisualDataList();
        _this.series = new SeriesVisualDataList();
        return _this;
    }
    Object.defineProperty(ChartVisualData.prototype, "axes", {
        get: function () {
            return this._axes;
        },
        set: function (a) {
            this._axes = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "title", {
        get: function () {
            return this._title;
        },
        set: function (a) {
            this._title = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "subtitle", {
        get: function () {
            return this._subtitle;
        },
        set: function (a) {
            this._subtitle = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (a) {
            this._width = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (a) {
            this._height = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "contentArea", {
        get: function () {
            return this._contentArea;
        },
        set: function (a) {
            this._contentArea = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "centralArea", {
        get: function () {
            return this._centralArea;
        },
        set: function (a) {
            this._centralArea = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "plotArea", {
        get: function () {
            return this._plotArea;
        },
        set: function (a) {
            this._plotArea = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartVisualData.prototype, "isViewportScaled", {
        get: function () {
            return this._isViewportScaled;
        },
        set: function (a) {
            this._isViewportScaled = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartVisualData.prototype.scaleByViewport = function () {
        var e_1, _a, e_2, _b;
        try {
            for (var _c = __values(fromEnum(this.axes)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var a = _d.value;
                a.p();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var b = _f.value;
                b.m();
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        if (this.title != null) {
            this.title.g();
        }
        if (this.subtitle != null) {
            this.subtitle.g();
        }
    };
    ChartVisualData.prototype.getBounds = function () {
        return new RectData(0, 0, this.width, this.height);
    };
    ChartVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: '" + this.name + "',");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("plotArea: { left: " + this.plotArea.left + ", top: " + this.plotArea.top + ", width: " + this.plotArea.width + ", height: " + this.plotArea.height + "}, ");
        a.u("contentArea: { left: " + this.contentArea.left + ", top: " + this.contentArea.top + ", width: " + this.contentArea.width + ", height: " + this.contentArea.height + "}, ");
        a.u("centralArea: { left: " + this.centralArea.left + ", top: " + this.centralArea.top + ", width: " + this.centralArea.width + ", height: " + this.centralArea.height + "}, ");
        a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
        a.u("axes: [");
        for (var b = 0; b < this.axes.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.axes._inner[b].serialize());
        }
        a.u("],");
        a.u("series: [");
        for (var c = 0; c < this.series.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.series._inner[c].serialize());
        }
        a.u("]");
        if (this.title != null) {
            a.u(", title: " + this.title.serialize());
        }
        if (this.subtitle != null) {
            a.u(", subtitle: " + this.subtitle.serialize());
        }
        a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    };
    ChartVisualData.prototype.getSerializedSeriesPoints = function (a, b, c) {
        var d = new List$1(List$1.$.specialize(PointData.$), 0);
        for (var e = 0; e < this.series.count; e++) {
            if (this.series._inner[e].name == a) {
                var f = this.series._inner[e].shapes.containingTag(b);
                for (var g = 0; g < f.count; g++) {
                    var h = f._inner[e];
                    h.getPointsOverride(d, c);
                }
            }
        }
        var i = new StringBuilder(0);
        i.u("[");
        for (var j = 0; j < d.count; j++) {
            var k = d._inner[j];
            i.u("[");
            for (var l = 0; l < k.count; l++) {
                if (l != 0) {
                    i.l(", ");
                }
                i.l("{ x: " + k._inner[l].x + ", y: " + k._inner[l].y + "}");
            }
            i.u("]");
        }
        i.u("]");
        return i.toString();
    };
    Object.defineProperty(ChartVisualData.prototype, "dipScalingRatio", {
        get: function () {
            return this._dipScalingRatio;
        },
        set: function (a) {
            this._dipScalingRatio = a;
        },
        enumerable: true,
        configurable: true
    });
    ChartVisualData.$t = markType(ChartVisualData, 'ChartVisualData');
    return ChartVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DataChartVisualDataManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataChartVisualDataManager, _super);
    function DataChartVisualDataManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DataChartVisualDataManager.prototype.exportVisualData = function (a) {
        var b = new ChartVisualData();
        for (var c = 0; c < a.axes.count; c++) {
            var d = a.axes._inner[c].e3();
            b.axes.add1(d);
        }
        for (var e = 0; e < a.series.count; e++) {
            var f = a.series._inner[e].fo();
            b.series.add1(f);
        }
        b.name = a.name;
        this.b(a, b);
        this.c(a, b);
        return b;
    };
    DataChartVisualDataManager.prototype.c = function (a, b) {
        var c = a.bn;
        b.width = c.a6;
        b.height = c.a5;
        b.contentArea = RectData.b(c.e3());
        b.centralArea = new RectData(c.a2, 0, c.a6 - (c.a2 + c.a3), c.a5 - (c.a4 + c.a1));
        b.plotArea = RectData.b(a.m3);
    };
    DataChartVisualDataManager.prototype.d = function (a, b) {
        var c = VisualExportHelper.a(a);
        return c;
    };
    DataChartVisualDataManager.prototype.b = function (a, b) {
        var c = a.bn;
        var d = null;
        b.title = null;
        b.subtitle = null;
        var e = c.fb();
        var f = 0;
        var g = 0;
        if (c.en != null) {
            d = c.t();
            var h = this.a(c, c.en, d);
            var i = { $type: Point_$type, x: 0, y: 0 };
            g = c.en.l + e.bottom + e.top;
            var j = new ChartTitleVisualData();
            var k = c.e3();
            j.viewport = new RectData(k.left, k.top, k.width, g);
            j.textPlotArea = RectData.b(this.d(c.en, a));
            j.textPlotArea = new RectData(c.en.n, c.en.o, c.en.m, c.en.l);
            f = j.height;
            j.appearance = AppearanceHelper.c(c.en, h);
            var l = c.fb();
            j.appearance.marginTop = l.top;
            j.appearance.marginLeft = l.left;
            j.appearance.marginRight = l.right;
            j.appearance.marginBottom = l.bottom;
            var m = c.ep();
            j.appearance.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, m);
            b.title = j;
        }
        if (c.em != null) {
            d = c.s();
            var n = this.a(c, c.em, d);
            var o = { $type: Point_$type, x: 0, y: f };
            var p = c.fa();
            var q = c.em.l + p.bottom + p.top;
            var r = new ChartTitleVisualData();
            var s = c.e3();
            r.viewport = new RectData(s.left, s.top + g, s.width, q);
            r.textPlotArea = RectData.b(this.d(c.em, a));
            r.appearance = AppearanceHelper.c(c.em, n);
            var t = c.fa();
            r.appearance.marginTop = t.top;
            r.appearance.marginLeft = t.left;
            r.appearance.marginRight = t.right;
            r.appearance.marginBottom = t.bottom;
            var u = c.eo();
            r.appearance.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, u);
            b.subtitle = r;
        }
    };
    DataChartVisualDataManager.prototype.a = function (a, b, c) {
        return FontUtil.getFontInfo(a.i.ae, b, c);
    };
    DataChartVisualDataManager.$t = markType(DataChartVisualDataManager, 'DataChartVisualDataManager', Base.$, [IDataChartVisualDataManager_$type]);
    return DataChartVisualDataManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VisualDataFactoryManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VisualDataFactoryManager, _super);
    function VisualDataFactoryManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VisualDataFactoryManager.register = function () {
        if (!VisualDataFactoryManager.a) {
            DVContainer.instance.registerFactory(IDataChartVisualDataManager_$type, function () { return new DataChartVisualDataManager(); });
            DVContainer.instance.registerFactory(IAxisVisualDataManager_$type, function () { return new AxisVisualDataManager(); });
            DVContainer.instance.registerFactory(ISeriesVisualDataManager_$type, function () { return new SeriesVisualDataManager(); });
            VisualDataFactoryManager.a = true;
        }
    };
    VisualDataFactoryManager.$t = markType(VisualDataFactoryManager, 'VisualDataFactoryManager');
    VisualDataFactoryManager.a = false;
    return VisualDataFactoryManager;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ChartTitleVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ChartTitleVisualDataList, _super);
    function ChartTitleVisualDataList() {
        return _super.call(this, ChartTitleVisualData.$, 0) || this;
    }
    ChartTitleVisualDataList.$t = markType(ChartTitleVisualDataList, 'ChartTitleVisualDataList', List$1.$.specialize(ChartTitleVisualData.$));
    return ChartTitleVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VisualDataSerializer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VisualDataSerializer, _super);
    function VisualDataSerializer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VisualDataSerializer.a = function (a) {
        var b = "{ left: " + a.left + ", top: " + a.top + ", width: " + a.width + ", height: " + a.height + " }";
        return b;
    };
    VisualDataSerializer.$t = markType(VisualDataSerializer, 'VisualDataSerializer');
    return VisualDataSerializer;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapVisualData, _super);
    function TreemapVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._nodes = null;
        _this._name = null;
        _this._viewport = null;
        return _this;
    }
    Object.defineProperty(TreemapVisualData.prototype, "nodes", {
        get: function () {
            return this._nodes;
        },
        set: function (a) {
            this._nodes = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapVisualData.prototype.scaleByViewport = function () {
        var e_1, _a;
        if (this.nodes != null) {
            try {
                for (var _b = __values(fromEnum(this.nodes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    a.e(this.viewport);
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    TreemapVisualData.prototype.serialize = function () {
        var e_2, _a;
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.nodes != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            var c = true;
            a.l("Nodes: [");
            try {
                for (var _b = __values(fromEnum(this.nodes)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var d = _c.value;
                    if (c) {
                        c = false;
                    }
                    else {
                        a.l(", ");
                    }
                    a.u(d.d());
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
            a.u("]");
        }
        if (this.name != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("name: '");
            a.l(this.name);
            a.u("'");
        }
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("viewport: {");
        a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
        a.u("}");
        a.u("}");
        return a.toString();
    };
    Object.defineProperty(TreemapVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapVisualData.$t = markType(TreemapVisualData, 'TreemapVisualData');
    return TreemapVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapVisual = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapVisual, _super);
    function TreemapVisual() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.i = null;
        _this.l = null;
        _this.j = null;
        _this.n = null;
        _this.o = null;
        _this.g = null;
        _this.k = null;
        _this.m = null;
        _this.t = 0;
        _this.c = null;
        _this.f = 0;
        _this.b = false;
        _this.e = 0;
        _this.d = 0;
        _this.q = 0;
        _this.s = 0;
        _this.r = 0;
        _this.h = 0;
        _this.p = 0;
        _this.c = new List$1(Base.$, 0);
        return _this;
    }
    TreemapVisual.$t = markType(TreemapVisual, 'TreemapVisual');
    return TreemapVisual;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapNodeVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeVisualData, _super);
    function TreemapNodeVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.b = null;
        _this.a = null;
        return _this;
    }
    TreemapNodeVisualData.prototype.e = function (a) {
        if (this.c != null) {
            this.c.scaleByViewport(a);
        }
        if (this.b != null) {
            this.b.scaleByViewport(a);
        }
        if (this.a != null) {
            this.a.scaleByViewport(a);
        }
    };
    TreemapNodeVisualData.prototype.d = function () {
        var a = new StringBuilder(0);
        var b = true;
        a.u("{");
        if (this.c != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("nodeRect: ");
            a.l(this.c.serialize());
        }
        if (this.b != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("headerRect: ");
            a.l(this.b.serialize());
        }
        if (this.a != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("label: ");
            a.l(this.a.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    };
    TreemapNodeVisualData.$t = markType(TreemapNodeVisualData, 'TreemapNodeVisualData');
    return TreemapNodeVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapLabelVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapLabelVisualData, _super);
    function TreemapLabelVisualData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._labelValue = null;
        _this._labelSize = null;
        _this._labelPosition = null;
        _this._appearance = null;
        return _this;
    }
    Object.defineProperty(TreemapLabelVisualData.prototype, "labelValue", {
        get: function () {
            return this._labelValue;
        },
        set: function (a) {
            this._labelValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapLabelVisualData.prototype, "labelSize", {
        get: function () {
            return this._labelSize;
        },
        set: function (a) {
            this._labelSize = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapLabelVisualData.prototype, "labelPosition", {
        get: function () {
            return this._labelPosition;
        },
        set: function (a) {
            this._labelPosition = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapLabelVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapLabelVisualData.prototype.scaleByViewport = function (a) {
        this.labelPosition = new PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
        this.labelSize = new SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
    };
    TreemapLabelVisualData.prototype.serialize = function () {
        return "{ labelValue: '" + this.labelValue + "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}, appearance: " + this.appearance.serialize() + "}";
    };
    TreemapLabelVisualData.$t = markType(TreemapLabelVisualData, 'TreemapLabelVisualData');
    return TreemapLabelVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapOrientation = /*@__PURE__*/ (function (TreemapOrientation) {
    TreemapOrientation[TreemapOrientation["Horizontal"] = 0] = "Horizontal";
    TreemapOrientation[TreemapOrientation["Vertical"] = 1] = "Vertical";
    return TreemapOrientation;
})({});
/**
 * @hidden
 */
var TreemapOrientation_$type = /*@__PURE__*/ markEnum('TreemapOrientation', 'Horizontal,0|Vertical,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AreaInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AreaInfo, _super);
    function AreaInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.a = 0;
        return _this;
    }
    AreaInfo.$t = markType(AreaInfo, 'AreaInfo');
    return AreaInfo;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapFillScaleMode = /*@__PURE__*/ (function (TreemapFillScaleMode) {
    TreemapFillScaleMode[TreemapFillScaleMode["Sum"] = 0] = "Sum";
    TreemapFillScaleMode[TreemapFillScaleMode["GlobalSum"] = 1] = "GlobalSum";
    TreemapFillScaleMode[TreemapFillScaleMode["Value"] = 2] = "Value";
    TreemapFillScaleMode[TreemapFillScaleMode["GlobalValue"] = 3] = "GlobalValue";
    return TreemapFillScaleMode;
})({});
/**
 * @hidden
 */
var TreemapFillScaleMode_$type = /*@__PURE__*/ markEnum('TreemapFillScaleMode', 'Sum,0|GlobalSum,1|Value,2|GlobalValue,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLabelVerticalFitMode = /*@__PURE__*/ (function (TreemapLabelVerticalFitMode) {
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Auto"] = 0] = "Auto";
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Show"] = 1] = "Show";
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Hide"] = 2] = "Hide";
    return TreemapLabelVerticalFitMode;
})({});
/**
 * @hidden
 */
var TreemapLabelVerticalFitMode_$type = /*@__PURE__*/ markEnum('TreemapLabelVerticalFitMode', 'Auto,0|Show,1|Hide,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLabelHorizontalFitMode = /*@__PURE__*/ (function (TreemapLabelHorizontalFitMode) {
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Auto"] = 0] = "Auto";
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Ellipsis"] = 1] = "Ellipsis";
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Hide"] = 2] = "Hide";
    return TreemapLabelHorizontalFitMode;
})({});
/**
 * @hidden
 */
var TreemapLabelHorizontalFitMode_$type = /*@__PURE__*/ markEnum('TreemapLabelHorizontalFitMode', 'Auto,0|Ellipsis,1|Hide,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapHeaderDisplayMode = /*@__PURE__*/ (function (TreemapHeaderDisplayMode) {
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Auto"] = 0] = "Auto";
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Header"] = 1] = "Header";
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Overlay"] = 2] = "Overlay";
    return TreemapHeaderDisplayMode;
})({});
/**
 * @hidden
 */
var TreemapHeaderDisplayMode_$type = /*@__PURE__*/ markEnum('TreemapHeaderDisplayMode', 'Auto,0|Header,1|Overlay,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLayoutType = /*@__PURE__*/ (function (TreemapLayoutType) {
    TreemapLayoutType[TreemapLayoutType["Squarified"] = 0] = "Squarified";
    TreemapLayoutType[TreemapLayoutType["SliceAndDice"] = 1] = "SliceAndDice";
    TreemapLayoutType[TreemapLayoutType["Stripped"] = 2] = "Stripped";
    return TreemapLayoutType;
})({});
/**
 * @hidden
 */
var TreemapLayoutType_$type = /*@__PURE__*/ markEnum('TreemapLayoutType', 'Squarified,0|SliceAndDice,1|Stripped,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapNodeVisualDataList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeVisualDataList, _super);
    function TreemapNodeVisualDataList() {
        return _super.call(this, TreemapNodeVisualData.$, 0) || this;
    }
    TreemapNodeVisualDataList.$t = markType(TreemapNodeVisualDataList, 'TreemapNodeVisualDataList', List$1.$.specialize(TreemapNodeVisualData.$));
    return TreemapNodeVisualDataList;
}(List$1));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapValueMappingMode = /*@__PURE__*/ (function (TreemapValueMappingMode) {
    TreemapValueMappingMode[TreemapValueMappingMode["Sum"] = 0] = "Sum";
    TreemapValueMappingMode[TreemapValueMappingMode["Value"] = 1] = "Value";
    TreemapValueMappingMode[TreemapValueMappingMode["CustomValue"] = 2] = "CustomValue";
    return TreemapValueMappingMode;
})({});
/**
 * @hidden
 */
var TreemapValueMappingMode_$type = /*@__PURE__*/ markEnum('TreemapValueMappingMode', 'Sum,0|Value,1|CustomValue,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapNodePointerEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodePointerEventArgs, _super);
    function TreemapNodePointerEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._value = 0;
        _this._sum = 0;
        _this._customValue = null;
        _this._item = null;
        _this._parentItem = null;
        _this._position = null;
        _this._isRightButton = false;
        _this._isHandled = false;
        _this._isOverHeader = false;
        _this._label = null;
        _this._parentValue = 0;
        _this._parentLabel = null;
        _this._parentSum = 0;
        return _this;
    }
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (a) {
            this._value = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "sum", {
        get: function () {
            return this._sum;
        },
        set: function (a) {
            this._sum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "customValue", {
        get: function () {
            return this._customValue;
        },
        set: function (a) {
            this._customValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentItem", {
        get: function () {
            return this._parentItem;
        },
        set: function (a) {
            this._parentItem = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isRightButton", {
        get: function () {
            return this._isRightButton;
        },
        set: function (a) {
            this._isRightButton = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isHandled", {
        get: function () {
            return this._isHandled;
        },
        set: function (a) {
            this._isHandled = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isOverHeader", {
        get: function () {
            return this._isOverHeader;
        },
        set: function (a) {
            this._isOverHeader = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentValue", {
        get: function () {
            return this._parentValue;
        },
        set: function (a) {
            this._parentValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentLabel", {
        get: function () {
            return this._parentLabel;
        },
        set: function (a) {
            this._parentLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentSum", {
        get: function () {
            return this._parentSum;
        },
        set: function (a) {
            this._parentSum = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodePointerEventArgs.$t = markType(TreemapNodePointerEventArgs, 'TreemapNodePointerEventArgs', EventArgs.$);
    return TreemapNodePointerEventArgs;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapNodeStyleMappingTargetType = /*@__PURE__*/ (function (TreemapNodeStyleMappingTargetType) {
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["All"] = 0] = "All";
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Parent"] = 1] = "Parent";
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Child"] = 2] = "Child";
    return TreemapNodeStyleMappingTargetType;
})({});
/**
 * @hidden
 */
var TreemapNodeStyleMappingTargetType_$type = /*@__PURE__*/ markEnum('TreemapNodeStyleMappingTargetType', 'All,0|Parent,1|Child,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TreemapView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapView, _super);
    function TreemapView() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.m = false;
        _this.ac = null;
        _this.j = null;
        _this.aa = null;
        _this.q = 0;
        _this.p = 0;
        _this.e = null;
        _this.ab = null;
        _this.t = 1;
        _this.z = null;
        _this.c = null;
        _this.r = 0;
        _this.s = 0;
        _this.a1 = null;
        _this.g = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        _this.f = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        _this.o = null;
        _this.k = null;
        _this.a2 = ((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(0,0,0, 0.0)";
            return $ret;
        })());
        _this.d = ((function () {
            var $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        _this.l = true;
        _this.b = new TreemapViewRenderer();
        _this.b.j = ((function () {
            var $ret = new Brush();
            $ret.fill = "white";
            return $ret;
        })());
        return _this;
    }
    TreemapView.prototype.au = function () {
    };
    TreemapView.prototype.ay = function () {
        this.ax();
    };
    TreemapView.prototype.az = function () {
        if (!this.m) {
            this.m = true;
            if (this.aa != null) {
                this.aa.setTimeout(runOn(this, this.ad), 0);
            }
            else {
                window.setTimeout(runOn(this, this.ad), 0);
            }
        }
    };
    TreemapView.prototype.ad = function () {
        if (this.m) {
            this.m = false;
            this.a.hf();
        }
    };
    TreemapView.prototype.n = function () {
        return true;
    };
    TreemapView.prototype.av = function () {
        this.t = this.a.cp;
        this.az();
    };
    TreemapView.prototype.ar = function (a) {
        if (a == null) {
            this.ac = null;
            this.aa = null;
            this.j = null;
            if (this.z != null) {
                window.removeEventListener("resize", this.z, false);
                this.z = null;
            }
            this.ae();
            return;
        }
        this.aa = a;
        this.ab = a;
        var b = this.ab.rootWrapper.width();
        var c = this.ab.rootWrapper.height();
        this.ao();
        this.t = (isNaN_(this.a.di) ? this.a.cp : this.a.di);
        var d = this.t;
        var e = Math.round(a.rootWrapper.width());
        var f = Math.round(a.rootWrapper.height());
        var g = e * d;
        var h = f * d;
        this.aa.rootWrapper.setStyleProperty("position", "relative");
        var i = a.createElement("canvas");
        i.setStyleProperty("position", "absolute");
        this.aa.rootWrapper.append(i);
        this.q = b;
        this.p = c;
        i.setAttribute("width", g.toString());
        i.setAttribute("height", h.toString());
        i.setStyleProperty("width", e.toString() + "px");
        i.setStyleProperty("height", f.toString() + "px");
        this.k = i.listen("contextmenu", function (j) { return j.preventDefault(); });
        this.a.io = new Rect(0, 0, 0, e, f);
        this.ac = i;
        var j = this.aa.get2DCanvasContext(this.ac);
        this.j = new RenderingContext(new CanvasViewRenderer(), j);
        this.an();
        this.a0();
        this.j.ac(this.e);
        this.ax();
        this.c = new CanvasGestureDOMEventProxy(this.ac, this.aa, true);
        this.c.ak = function (k) { return true; };
        this.c.bf = this.a.io;
        var k = this.c;
        k.onMouseOver = delegateCombine(k.onMouseOver, runOn(this, this.aj));
        var l = this.c;
        l.onMouseUp = delegateCombine(l.onMouseUp, runOn(this, this.ak));
        var m = this.c;
        m.onMouseDown = delegateCombine(m.onMouseDown, runOn(this, this.ag));
        var n = this.c;
        n.onMouseEnter = delegateCombine(n.onMouseEnter, runOn(this, this.ah));
        var o = this.c;
        o.onMouseLeave = delegateCombine(o.onMouseLeave, runOn(this, this.ai));
    };
    TreemapView.prototype.ai = function (a) {
        this.a.g4(a);
    };
    TreemapView.prototype.al = function (a) {
        this.b.e(a, this.o, this);
    };
    TreemapView.prototype.ah = function (a) {
        this.a.g3(a);
    };
    TreemapView.prototype.ao = function () {
        var _this = this;
        if (this.z == null) {
            this.z = function (a) {
                var b = _this.a.di;
                var c = _this.a.cp;
                if (!isNaN_(b) && b != 0) {
                    return;
                }
                if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                    _this.a.cp = window.devicePixelRatio;
                }
            };
            var e_ = this.z;
            window.addEventListener("resize", e_, false);
        }
        this.z(null);
    };
    TreemapView.prototype.ae = function () {
        if (this.k != null) {
            this.k();
            this.k = null;
        }
        if (this.c != null) {
            var a = this.c;
            a.onMouseOver = delegateRemove(a.onMouseOver, runOn(this, this.aj));
            var b = this.c;
            b.onMouseUp = delegateRemove(b.onMouseUp, runOn(this, this.ak));
            var c = this.c;
            c.onMouseDown = delegateRemove(c.onMouseDown, runOn(this, this.ag));
            var d = this.c;
            d.onMouseEnter = delegateRemove(d.onMouseEnter, runOn(this, this.ah));
            var e = this.c;
            e.onMouseLeave = delegateRemove(e.onMouseLeave, runOn(this, this.ai));
            this.c.ak = null;
            this.c.aq();
        }
    };
    TreemapView.prototype.ag = function (a) {
        if (this.c.ai) {
            this.a.g8(a);
        }
        else {
            this.a.g2(a);
        }
    };
    TreemapView.prototype.ak = function (a) {
        if (this.c.ai) {
            this.a.g9(a);
        }
        else {
            this.a.g6(a);
        }
    };
    TreemapView.prototype.aj = function (a, b, c) {
        this.a.g5(a);
    };
    TreemapView.prototype.an = function () {
    };
    TreemapView.prototype.i = function () {
        return this.b.b;
    };
    TreemapView.prototype.a0 = function () {
        this.e = FontUtil.getFont(this.aa);
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
        this.a1 = new Brush();
        this.a1._fill = this.aa.rootWrapper.getStyleProperty("color");
        if (this.j != null) {
            this.j.ac(this.e);
        }
    };
    TreemapView.prototype.ap = function () {
        var a = this.ab.rootWrapper.width();
        var b = this.ab.rootWrapper.height();
        this.a.io = new Rect(0, 0, 0, a, b);
        this.ao();
    };
    TreemapView.prototype.am = function () {
        if (this.m) {
            this.ad();
        }
    };
    TreemapView.prototype.ax = function () {
        if (this.j == null) {
            return;
        }
        var a = this.a.io.width;
        var b = this.a.io.height;
        var c = Math.round(a * this.t);
        var d = Math.round(b * this.t);
        if (this.q != c || this.p != d) {
            this.ac.setAttribute("width", c.toString());
            this.ac.setAttribute("height", d.toString());
            this.ac.setStyleProperty("width", a.toString() + "px");
            this.ac.setStyleProperty("height", b.toString() + "px");
            this.q = truncate(Math.round(c));
            this.p = truncate(Math.round(d));
        }
        if (this.j.d && this.t != 1) {
            this.j.z();
            this.j.aa(this.t, this.t);
        }
        this.b.f(this.j, this.a.io, this.o, this.r);
        if (this.j.d && this.t != 1) {
            this.j.y();
        }
    };
    TreemapView.prototype.at = function (a) {
        this.g = a;
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
    };
    TreemapView.prototype.aw = function (a) {
        this.f = a;
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
    };
    TreemapView.prototype.af = function (a) {
        this.o = a;
        this.ax();
    };
    TreemapView.prototype.y = function (a) {
        if (a != null) {
            if (this.f != null) {
                this.j.ac(this.f);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    };
    TreemapView.prototype.w = function (a) {
        if (a != null) {
            if (this.g != null) {
                this.j.ac(this.g);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    };
    TreemapView.prototype.u = function (a) {
        return FontUtil.getCurrentFontHeight(this.aa, a);
    };
    TreemapView.prototype.x = function (a) {
        return this.r;
    };
    TreemapView.prototype.v = function (a) {
        return this.s;
    };
    TreemapView.prototype.a4 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(220,220,220)";
            return $ret;
        })());
    };
    TreemapView.prototype.a6 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(240, 240, 240)";
            return $ret;
        })());
    };
    TreemapView.prototype.a5 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(102, 102, 102)";
            return $ret;
        })());
    };
    TreemapView.prototype.bc = function () {
        return this.a2;
    };
    TreemapView.prototype.a8 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "black";
            return $ret;
        })());
    };
    TreemapView.prototype.a7 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(240,240,240)";
            return $ret;
        })());
    };
    TreemapView.prototype.bb = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(240, 240, 240)";
            return $ret;
        })());
    };
    TreemapView.prototype.a3 = function () {
        return ((function () {
            var $ret = new Brush();
            $ret.fill = "rgb(102, 102, 102)";
            return $ret;
        })());
    };
    TreemapView.prototype.h = function () {
        return this.d;
    };
    TreemapView.prototype.a9 = function () {
        return BrushUtil.g(153, 25, 25, 25);
    };
    TreemapView.prototype.ba = function () {
        return BrushUtil.g(153, 45, 45, 45);
    };
    TreemapView.prototype.aq = function () {
        this.l = true;
        this.ao();
        if (this.c != null) {
            this.c.ap(this.aa.rootWrapper, "");
        }
    };
    TreemapView.prototype.as = function () {
        this.l = false;
        if (this.c != null) {
            this.c.bb(this.aa.rootWrapper, "");
        }
    };
    TreemapView.$t = markType(TreemapView, 'TreemapView');
    return TreemapView;
}(Base));
/**
 * @hidden
 */
var TreemapViewRenderer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapViewRenderer, _super);
    function TreemapViewRenderer() {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.j = null;
        _this.c = new List$1(TreemapVisual.$, 0);
        _this.b = ((function () {
            var $ret = new Pool$1(TreemapVisual.$);
            $ret.create = runOn(_this, _this.a);
            $ret.activate = runOn(_this, _this.g);
            $ret.disactivate = runOn(_this, _this.i);
            $ret.destroy = runOn(_this, _this.h);
            return $ret;
        })());
        return _this;
    }
    TreemapViewRenderer.prototype.a = function () {
        var a = new TreemapVisual();
        this.c.add(a);
        return a;
    };
    TreemapViewRenderer.prototype.g = function (a) {
        a.t = 0;
    };
    TreemapViewRenderer.prototype.i = function (a) {
        a.t = 1;
    };
    TreemapViewRenderer.prototype.h = function (a) {
        this.c.remove(a);
    };
    TreemapViewRenderer.prototype.d = function (a) {
        if (a.c.count != 3) {
            a.c.add1(new Rectangle());
            a.c.add1(new Rectangle());
            a.c.add1(new TextBlock());
        }
    };
    TreemapViewRenderer.prototype.f = function (a, b, c, d) {
        a.k(b.left, b.top, b.width, b.height);
        if (c != null) {
            for (var e = 0; e < c.count; e++) {
                var f = c._inner[e];
                this.d(f);
                var g = f.c._inner[0];
                var h = f.c._inner[1];
                var i = f.c._inner[2];
                g._fill = f.i;
                g._stroke = f.l;
                g.ac = f.f;
                g.width = f.m.width;
                g.height = f.m.height;
                g.n = f.m.left;
                g.o = f.m.top;
                a.ac(f.a);
                var j = a.f(f.g);
                if (f.b) {
                    i.ak = f.g;
                    switch (f.h) {
                        case 0:
                            i.n = f.m.left + f.o.left;
                            break;
                        case 1:
                        case 3:
                            i.n = f.m.left + f.m.width / 2 - f.e / 2;
                            break;
                        case 2:
                            i.n = Math.max(f.m.left + f.o.left, f.m.right - (j + f.o.right));
                            break;
                    }
                    switch (f.p) {
                        case 0:
                            i.o = f.m.top + f.o.top;
                            break;
                        case 1:
                        case 3:
                            i.o = f.m.top + f.m.height / 2 - f.d / 2;
                            break;
                        case 2:
                            i.o = Math.max(f.m.top + f.o.top, f.m.bottom - (d + f.o.bottom));
                            break;
                    }
                    i.am = f.k;
                }
                else {
                    h._fill = f.j;
                    h._stroke = f.l;
                    h.ac = f.f;
                    h.width = f.m.width;
                    h.height = f.d;
                    h.n = f.m.left;
                    h.o = f.m.top;
                    if (f.s == 0) {
                        h.width = j + f.n.left + f.n.right;
                    }
                    i.n = f.m.left + f.n.left;
                    i.o = f.m.top + f.n.top;
                    i.ak = f.g;
                    i.am = f.k;
                }
                a.v(g);
                if (f.s != 0) {
                    if (!f.b) {
                        a.v(h);
                    }
                }
                a.z();
                a.ae(f.m);
                if (f.s == 0) {
                    if (!f.b) {
                        a.v(h);
                    }
                }
                a.w(i);
                a.y();
            }
        }
    };
    TreemapViewRenderer.prototype.e = function (a, b, c) {
        if (b != null) {
            for (var d = 0; d < b.count; d++) {
                var e = b._inner[d];
                this.d(e);
                var f = e.c._inner[0];
                var g = e.c._inner[1];
                var h = e.c._inner[2];
                var i = new TreemapNodeVisualData();
                i.c = new RectangleVisualData(1, "NodePath", f);
                i.b = new RectangleVisualData(1, "HeaderRect", g);
                var j = new TreemapLabelVisualData();
                j.labelPosition = new PointData(h.n, h.o);
                if (e.b) {
                    j.labelSize = new SizeData(c.y(h.ak), c.x(h.ak));
                }
                else {
                    j.labelSize = new SizeData(c.w(h.ak), c.v(h.ak));
                }
                j.labelValue = h.ak;
                j.appearance = AppearanceHelper.c(h, e.a);
                i.a = j;
                a.nodes.add(i);
            }
        }
    };
    TreemapViewRenderer.$t = markType(TreemapViewRenderer, 'TreemapViewRenderer');
    return TreemapViewRenderer;
}(Base));
/**
 * @hidden
 */
var TreemapLayoutCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapLayoutCalculator, _super);
    function TreemapLayoutCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TreemapLayoutCalculator.c = function (a, b, c, d) {
        var e = a.e();
        var f = d.f;
        var g = f * f / (b.width * b.height);
        if (e / c < g) {
            return true;
        }
        return false;
    };
    TreemapLayoutCalculator.a = function (a, b, c, d, e) {
        for (var f = 0; f < c.count; f++) {
            var g = c._inner[f];
            if (!a.contains(g)) {
                return false;
            }
        }
        return true;
    };
    TreemapLayoutCalculator.b = function (a, b) {
        if (a.width < b.f || a.height < b.f) {
            return true;
        }
        return false;
    };
    TreemapLayoutCalculator.prototype.h = function (a, b, c) {
        return a.o(b);
    };
    TreemapLayoutCalculator.prototype.i = function (a, b, c) {
        var d = a.o(b);
        if (d.isEmpty) {
            return d;
        }
        if (b.b != null && b.b.count > 0) {
            var e = c.i;
            var f = e.left + e.right;
            var g = e.top + e.bottom;
            var h = a.b(b);
            if (!h) {
                return d;
            }
            var i = new Rect(0, d.left - e.left, d.top - e.top, d.width + f, d.height + g);
            return i;
        }
        else {
            return d;
        }
    };
    TreemapLayoutCalculator.prototype.g = function (a, b, c, d) {
        if (b.b != null && b.b.count > 0) {
            var e = d.i;
            var f = e.left + e.right;
            var g = e.top + e.bottom;
            if (c.width < f || c.height < g) {
                a.m(b, c);
                return;
            }
            var h = new Rect(0, c.left + e.left, c.top + e.top, c.width - f, c.height - g);
            a.m(b, h);
            a.n(b, true);
        }
        else {
            a.m(b, c);
        }
    };
    TreemapLayoutCalculator.prototype.f = function (a, b, c, d, e, f) {
        var e_1, _a;
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                var g = 0;
                try {
                    for (var _b = (e_1 = void 0, __values(fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        if (a.contains(h)) {
                            continue;
                        }
                        if (d > 0) {
                            var i = (d > 1) ? 1 : d;
                            var j = this.i(b, h, f);
                            if (j.isEmpty) {
                                continue;
                            }
                            this.g(b, h, new Rect(0, j.x + g, j.y, j.width + i, j.height), f);
                            d -= i;
                            g += i;
                        }
                        else {
                            var k = this.i(b, h, f);
                            if (k.isEmpty) {
                                continue;
                            }
                            this.g(b, h, new Rect(0, k.x + g, k.y, k.width, k.height), f);
                        }
                    }
                }
                catch (e_1_1) {
                    e_1 = { error: e_1_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_1)
                            throw e_1.error;
                    }
                }
            }
        }
    };
    TreemapLayoutCalculator.prototype.e = function (a, b, c, d, e, f) {
        var e_2, _a;
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                var g = 0;
                try {
                    for (var _b = (e_2 = void 0, __values(fromEnum(c))), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var h = _c.value;
                        if (a.contains(h)) {
                            continue;
                        }
                        if (d > 0) {
                            var i = (d > 1) ? 1 : d;
                            var j = this.i(b, h, f);
                            if (j.isEmpty) {
                                continue;
                            }
                            this.g(b, h, new Rect(0, j.x, j.y + g, j.width, j.height + i), f);
                            d -= i;
                            g += i;
                        }
                        else {
                            var k = this.i(b, h, f);
                            if (k.isEmpty) {
                                continue;
                            }
                            this.g(b, h, new Rect(0, k.x, k.y + g, k.width, k.height), f);
                        }
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
            }
        }
    };
    TreemapLayoutCalculator.$t = markType(TreemapLayoutCalculator, 'TreemapLayoutCalculator');
    return TreemapLayoutCalculator;
}(Base));
/**
 * @hidden
 */
var StrippedCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrippedCalculator, _super);
    function StrippedCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StrippedCalculator.prototype.d = function (a, b) {
        a.g();
        this.o(a, b.b.a, b.h, b, 0);
    };
    StrippedCalculator.prototype.q = function (a, b, c) {
        return c.j;
    };
    StrippedCalculator.prototype.o = function (a, b, c, d, e) {
        var e_3, _a;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _b = __values(fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    this.o(a, g, c, d, e + 1);
                }
            }
            catch (e_3_1) {
                e_3 = { error: e_3_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_3)
                        throw e_3.error;
                }
            }
            return;
        }
        var h = this.q(b, c, d);
        var i = h.left + h.right;
        var j = h.top + h.bottom;
        var k = new Rect(0, c.left, c.top, c.width, c.height);
        var l = d.a;
        if (i >= k.width || j >= k.height) {
            return;
        }
        k.x = k.x + h.left;
        k.width = k.width - i;
        k.y = k.y + h.top;
        k.height = k.height - j;
        var m = new HashSet$1(TreemapTreeNode.$, 0);
        StrippedCalculator.p(m, d, b.b, k);
        var n = 0;
        for (var o = 0; o < b.b.count; o++) {
            var p = b.b._inner[o];
            if (!m.contains(p)) {
                n += p.e();
            }
        }
        var q = n;
        var r = (k.width * k.height) / q;
        var s = l == 0 ? k.width : k.height;
        var t = new List$1(TreemapTreeNode.$, 0);
        var u = new List$1(TreemapTreeNode.$, 0);
        for (var v = 0; v < b.b.count; v++) {
            var w = b.b._inner[v];
            if (m.contains(w) || isNaN_(w.e())) {
                continue;
            }
            var x = StrippedCalculator.j(u, s, r);
            u.add(w);
            var y = StrippedCalculator.j(u, s, r);
            if (x < y) {
                if (t.count > 0) {
                    var z = this.m(m, a, d, t, r, k, l, false);
                    k = z.p5;
                }
                u.removeAt(u.count - 1);
                t.o(u);
                u.clear();
                u.add(w);
            }
        }
        var aa = StrippedCalculator.j(t, s, r);
        var ab = StrippedCalculator.j(u, s, r);
        var ac = new List$1(TreemapTreeNode.$, 0);
        ac.o(t);
        ac.o(u);
        var ad = StrippedCalculator.j(ac, s, r);
        if (ad < (aa + ab) / 2 || k.height < d.f * 2) {
            var ae = this.m(m, a, d, ac, r, k, l, true);
            k = ae.p5;
        }
        else {
            var af = this.m(m, a, d, t, r, k, l, false);
            k = af.p5;
            var ag = this.m(m, a, d, u, r, k, l, true);
            k = ag.p5;
        }
        for (var ah = 0; ah < b.b.count; ah++) {
            var ai = b.b._inner[ah];
            if (m.contains(ai)) {
                continue;
            }
            var aj = this.h(a, ai, d);
            if (aj.isEmpty) {
                continue;
            }
            var ak = new Rect(0, aj.left, aj.top + d.e, aj.width, Math.max(aj.height - d.e, 0));
            this.o(a, ai, ak, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    StrippedCalculator.prototype.m = function (a, b, c, d, e, f, g, h) {
        if (d.count == 0) {
            return {
                p5: f
            };
        }
        if (g == 0) {
            var i = this.l(a, b, c, d, e, f, h);
            f = i.p5;
        }
        else {
            var j = this.n(a, b, c, d, e, f, h);
            f = j.p5;
        }
        return {
            p5: f
        };
    };
    StrippedCalculator.prototype.l = function (a, b, c, d, e, f, g) {
        var h = StrippedCalculator.k(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        var i = f.width;
        var j = (h * e) / i;
        var k = f.x;
        var l = 0;
        for (var m = 0; m < d.count; ++m) {
            var n = d._inner[m];
            var o = Math.floor((n.e() / h) * i);
            var p = new Rect(0, k, f.y, o, j);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.right;
                this.g(b, n, p, c);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        this.f(a, b, d, f.right - k, f, c);
        f.y = f.y + j;
        if (f.height < j) {
            f.height = 0;
        }
        else {
            f.height = f.height - j;
        }
        d.clear();
        return {
            p5: f
        };
    };
    StrippedCalculator.prototype.n = function (a, b, c, d, e, f, g) {
        var h = StrippedCalculator.k(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        var i = f.height;
        var j = (h * e) / i;
        var k = f.y;
        var l = 0;
        for (var m = 0; m < d.count; ++m) {
            var n = d._inner[m];
            var o = Math.floor((n.e() / h) * i);
            var p = new Rect(0, f.x, k, j, o);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.bottom;
                this.g(b, n, p, c);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        this.e(a, b, d, f.bottom - k, f, c);
        f.x = f.x + j;
        if (f.width < j) {
            f.width = 0;
        }
        else {
            f.width = f.width - j;
        }
        d.clear();
        return {
            p5: f
        };
    };
    StrippedCalculator.j = function (a, b, c) {
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        var d = StrippedCalculator.k(a);
        var e = (d * c) / b;
        var f = 0;
        for (var g = 0; g < a.count; g++) {
            var h = a._inner[g];
            var i = (h.e() / d) * b;
            f += Math.max(i / e, e / i);
        }
        f /= a.count;
        return f;
    };
    StrippedCalculator.k = function (a) {
        var b = 0;
        for (var c = 0; c < a.count; c++) {
            var d = a._inner[c];
            b += d.e();
        }
        return b;
    };
    StrippedCalculator.p = function (a, b, c, d) {
        var e = 0;
        for (var f = 0; f < c.count; f++) {
            var g = c._inner[f];
        }
        var h = e;
        var i = b.f * b.f / (d.width * d.height);
        for (var j = 0; j < c.count; j++) {
            var k = c._inner[j];
            if (k.e() / h < i) {
                a.add_1(k);
            }
        }
    };
    StrippedCalculator.$t = markType(StrippedCalculator, 'StrippedCalculator', TreemapLayoutCalculator.$);
    return StrippedCalculator;
}(TreemapLayoutCalculator));
/**
 * @hidden
 */
var SliceAndDiceCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SliceAndDiceCalculator, _super);
    function SliceAndDiceCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SliceAndDiceCalculator.prototype.d = function (a, b) {
        a.g();
        this.m(a, b.b.a, b.h, b, 0);
    };
    SliceAndDiceCalculator.prototype.o = function (a, b, c) {
        return c.j;
    };
    SliceAndDiceCalculator.prototype.m = function (a, b, c, d, e) {
        var e_4, _a;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _b = __values(fromEnum(b.b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var g = _c.value;
                    this.m(a, g, c, d, e + 1);
                }
            }
            catch (e_4_1) {
                e_4 = { error: e_4_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_4)
                        throw e_4.error;
                }
            }
            return;
        }
        var h = this.o(b, c, d);
        var i = SliceAndDiceCalculator.j(b, d, e);
        var j = h.left + h.right;
        var k = h.top + h.bottom;
        var l = new Rect(0, c.left, c.top, c.width, c.height);
        if (j >= l.width || k >= l.height) {
            return;
        }
        l.x = l.x + h.left;
        l.width = l.width - j;
        l.y = l.y + h.top;
        l.height = l.height - k;
        var m = new Size(1, l.width, l.height);
        var n = l.left;
        var o = l.top;
        var p = new HashSet$1(TreemapTreeNode.$, 0);
        var q = SliceAndDiceCalculator.k(b.b, b, d, m, p);
        if (q) {
            SliceAndDiceCalculator.n(b.b, b, d, m, p);
        }
        var r = 0;
        for (var s = 0; s < b.b.count; s++) {
            var t = b.b._inner[s];
            if (!p.contains(t)) {
                r += t.e();
            }
        }
        var u = (i == 0) ? m.height : m.width;
        var v = new Rect(4);
        for (var w = 0; w < b.b.count; w++) {
            var x = b.b._inner[w];
            if (p.contains(x) || isNaN_(x.e())) {
                continue;
            }
            if (r <= 0 || u <= 0) {
                break;
            }
            var y = x.e() / r;
            v.x = n;
            v.y = o;
            if (i == 0) {
                v.width = m.width;
                v.height = Math.round(u * y);
            }
            else {
                v.width = Math.round(u * y);
                v.height = m.height;
            }
            this.g(a, x, new Rect(0, v.left, v.top, v.width, v.height), d);
            if (i == 0) {
                o += v.height;
                u -= v.height;
            }
            else {
                n += v.width;
                u -= v.width;
            }
            r -= x.e();
            var z = this.h(a, x, d);
            if (z.isEmpty) {
                continue;
            }
            var aa = new Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
            this.m(a, x, aa, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    SliceAndDiceCalculator.j = function (a, b, c) {
        var d = 0;
        if (b.a == 0) {
            d = (c % 2 == 0) ? 0 : 1;
        }
        else {
            d = (c % 2 == 0) ? 1 : 0;
        }
        return d;
    };
    SliceAndDiceCalculator.k = function (a, b, c, d, e) {
        var f = true;
        var g = b.e();
        var h = Math.min(d.width, d.height);
        for (var i = 0; i < a.count; i++) {
            var j = a._inner[i];
            if (Math.round(j.e() / g * h) < c.f) {
                if (!e.contains(j)) {
                    e.add_1(j);
                }
            }
            else {
                f = false;
            }
        }
        return f;
    };
    SliceAndDiceCalculator.n = function (a, b, c, d, e) {
        var f = new List$1(TreemapTreeNode.$, 0);
        f.o(a);
        f.aa(function (g, h) {
            if (g.e() > h.e()) {
                return 1;
            }
            else if (g.e() < h.e()) {
                return -1;
            }
            return 0;
        });
        var g = 0;
        var h = Math.min(d.width, d.height);
        for (var i = 0; i < f.count; i++) {
            var j = f._inner[i];
            if (isNaN_(j.e())) {
                continue;
            }
            g += j.e();
            if (j.e() / g * h < c.f) {
                break;
            }
            else {
                if (e.contains(j)) {
                    e.remove(j);
                }
            }
        }
    };
    SliceAndDiceCalculator.$t = markType(SliceAndDiceCalculator, 'SliceAndDiceCalculator', TreemapLayoutCalculator.$);
    SliceAndDiceCalculator.l = null;
    return SliceAndDiceCalculator;
}(TreemapLayoutCalculator));
/**
 * @hidden
 */
var TreemapLayoutSettings = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapLayoutSettings, _super);
    function TreemapLayoutSettings() {
        var _this = _super.call(this) || this;
        _this.a = 0;
        _this.h = null;
        _this.b = null;
        _this.j = null;
        _this.i = null;
        _this.e = 0;
        _this.f = 0;
        _this.g = 0;
        _this.c = null;
        _this.d = false;
        _this.g = -1;
        _this.d = false;
        return _this;
    }
    TreemapLayoutSettings.$t = markType(TreemapLayoutSettings, 'TreemapLayoutSettings');
    return TreemapLayoutSettings;
}(Base));
/**
 * @hidden
 */
var SquarifiedCalculator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SquarifiedCalculator, _super);
    function SquarifiedCalculator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SquarifiedCalculator.prototype.n = function (a, b, c, d, e) {
        var e_5, _a, e_6, _b, e_7, _c;
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            var f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            try {
                for (var _d = __values(fromEnum(b.b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var g = _e.value;
                    this.n(a, g, c, d, e + 1);
                }
            }
            catch (e_5_1) {
                e_5 = { error: e_5_1 };
            }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return))
                        _a.call(_d);
                }
                finally {
                    if (e_5)
                        throw e_5.error;
                }
            }
            return;
        }
        var h = this.o(b, c, d);
        var i = new Rect(0, c.left, c.top, c.width, c.height);
        var j = h.left + h.right;
        var k = h.top + h.bottom;
        if (j >= i.width || k >= i.height) {
            return;
        }
        i.x = i.x + h.left;
        i.width = i.width - j;
        i.y = i.y + h.top;
        i.height = i.height - k;
        var l = i.left;
        var m = i.top;
        var n = new List$1(TreemapTreeNode.$, 0);
        var o = b.e();
        var p = new Rect(0, i.left, i.top, i.width, i.height);
        var q = (i.width * i.height) / o;
        var r = new List$1(TreemapTreeNode.$, 1, b.b);
        r.aa(function (s, t) {
            if (t.e() < s.e()) {
                return -1;
            }
            if (t.e() > s.e()) {
                return 1;
            }
            return 0;
        });
        var s = new AreaInfo();
        s.b = i;
        s.a = o;
        var t = new HashSet$1(TreemapTreeNode.$, 0);
        try {
            for (var _f = __values(fromEnum(r)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var u = _g.value;
                if (TreemapLayoutCalculator.c(u, p, o, d) || isNaN_(u.e())) {
                    t.add_1(u);
                    continue;
                }
                var v = Math.min(i.width, i.height);
                var w = SquarifiedCalculator.j(n, v, q);
                n.add(u);
                var x = SquarifiedCalculator.j(n, v, q);
                if (w <= x) {
                    n.removeAt(n.count - 1);
                    this.l(t, a, n, s, d);
                    i = s.b;
                    n.add(u);
                }
            }
        }
        catch (e_6_1) {
            e_6 = { error: e_6_1 };
        }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return))
                    _b.call(_f);
            }
            finally {
                if (e_6)
                    throw e_6.error;
            }
        }
        this.l(t, a, n, s, d);
        i = s.b;
        try {
            for (var _h = __values(fromEnum(b.b)), _j = _h.next(); !_j.done; _j = _h.next()) {
                var y = _j.value;
                if (t.contains(y)) {
                    continue;
                }
                var z = this.h(a, y, d);
                if (z.isEmpty) {
                    continue;
                }
                var aa = new Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
                this.n(a, y, aa, d, e + 1);
            }
        }
        catch (e_7_1) {
            e_7 = { error: e_7_1 };
        }
        finally {
            try {
                if (_j && !_j.done && (_c = _h.return))
                    _c.call(_h);
            }
            finally {
                if (e_7)
                    throw e_7.error;
            }
        }
        if (b == d.c) {
            d.d = false;
        }
    };
    SquarifiedCalculator.prototype.o = function (a, b, c) {
        return c.j;
    };
    SquarifiedCalculator.j = function (a, b, c) {
        var e_8, _a;
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        var d = 0;
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                var h = g.e() * c;
                if (e > h) {
                    e = h;
                }
                if (f < h) {
                    f = h;
                }
                d += h;
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        var i = (b * b * f) / (d * d);
        var j = (d * d) / (b * b * e);
        return Math.max(i, j);
    };
    SquarifiedCalculator.prototype.l = function (a, b, c, d, e) {
        if (c.count < 1) {
            return;
        }
        var f = 0;
        for (var g = 0; g < c.count; ++g) {
            f += c._inner[g].e();
        }
        if (f <= 0) {
            return;
        }
        if (d.b.width > d.b.height) {
            this.k(a, b, c, f, d, e);
        }
        else {
            this.m(a, b, c, f, d, e);
        }
    };
    SquarifiedCalculator.prototype.m = function (a, b, c, d, e, f) {
        var g = e.b;
        var h = e.a;
        var i = Math.round((d / h) * g.height);
        var j = g.x;
        for (var k = 0; k < c.count; ++k) {
            var l = c._inner[k];
            if (g.right < j) {
                a.add_1(l);
                continue;
            }
            var m = Math.floor((l.e() / d) * g.width);
            var n = new Rect(0, j, g.y, m, i);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            this.g(b, l, n, f);
            j += n.width;
        }
        this.f(a, b, c, g.right - j, g, f);
        g.y = g.y + i;
        if (g.height < i) {
            g.height = 0;
        }
        else {
            g.height = g.height - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    };
    SquarifiedCalculator.prototype.k = function (a, b, c, d, e, f) {
        var g = e.b;
        var h = e.a;
        var i = Math.round((d / h) * g.width);
        var j = g.y;
        for (var k = 0; k < c.count; ++k) {
            var l = c._inner[k];
            if (g.bottom < j) {
                a.add_1(l);
                continue;
            }
            var m = Math.floor((l.e() / d) * g.height);
            var n = new Rect(0, g.x, j, i, m);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            this.g(b, l, n, f);
            j += n.height;
        }
        this.e(a, b, c, g.bottom - j, g, f);
        g.x = g.x + i;
        if (g.width < i) {
            g.width = 0;
        }
        else {
            g.width = g.width - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    };
    SquarifiedCalculator.prototype.d = function (a, b) {
        a.g();
        this.n(a, b.b.a, b.h, b, 0);
    };
    SquarifiedCalculator.$t = markType(SquarifiedCalculator, 'SquarifiedCalculator', TreemapLayoutCalculator.$);
    return SquarifiedCalculator;
}(TreemapLayoutCalculator));
/**
 * @hidden
 */
var TreemapTreeData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapTreeData, _super);
    function TreemapTreeData() {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.b = null;
        _this.d = null;
        _this.c = null;
        _this.b = new Dictionary$2(String_$type, TreemapTreeNode.$, 0);
        _this.d = new List$1(String_$type, 0);
        _this.c = new Dictionary$2(String_$type, List$1.$.specialize(TreemapTreeNode.$), 0);
        _this.a = new TreemapTreeNode();
        return _this;
    }
    TreemapTreeData.prototype.e = function (a) {
        var e_9, _a;
        var _this = this;
        this.b.addItem(a.i, a);
        this.d.add(a.i);
        if (a.k == null) {
            this.a.b.add(a);
        }
        else if (this.b.containsKey(a.k)) {
            this.b.item(a.k).b.add(a);
        }
        else {
            var b_1;
            if (!((function () { var c = _this.c.tryGetValue(a.k, b_1); b_1 = c.p1; return c.ret; })())) {
                b_1 = new List$1(TreemapTreeNode.$, 0);
                this.c.item(a.k, b_1);
            }
            b_1.add(a);
        }
        if (this.c.containsKey(a.i)) {
            try {
                for (var _b = __values(fromEnum(this.c.item(a.i))), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a.b.add(c);
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            this.c.removeItem(a.i);
        }
    };
    TreemapTreeData.prototype.g = function (a) {
        if (isNaN_(a.f)) {
            if (a.b.count > 0) {
                a.d = 0;
            }
            for (var b = 0; b < a.b.count; b++) {
                var c = a.b._inner[b];
                this.g(c);
                if (isNaN_(c.f)) {
                    a.d = a.d + c.d;
                }
                else {
                    a.d = a.d + c.f;
                }
            }
        }
    };
    TreemapTreeData.prototype.f = function () {
        this.g(this.a);
    };
    TreemapTreeData.$t = markType(TreemapTreeData, 'TreemapTreeData');
    return TreemapTreeData;
}(Base));
/**
 * @hidden
 */
var TreemapTreeNode = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapTreeNode, _super);
    function TreemapTreeNode() {
        var _this = _super.call(this) || this;
        _this.i = null;
        _this.k = null;
        _this.b = null;
        _this.c = null;
        _this.f = 0;
        _this.g = null;
        _this.d = 0;
        _this.j = null;
        _this.h = null;
        _this.a = false;
        _this.b = new List$1(TreemapTreeNode.$, 0);
        _this.f = NaN;
        _this.g = null;
        _this.c = new List$1(TreemapNodeStyleMapping.$, 0);
        _this.d = 0;
        return _this;
    }
    TreemapTreeNode.prototype.e = function () {
        if (isNaN_(this.f)) {
            return this.d;
        }
        return this.f;
    };
    TreemapTreeNode.$t = markType(TreemapTreeNode, 'TreemapTreeNode');
    return TreemapTreeNode;
}(Base));
/**
 * @hidden
 */
var Treemap = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Treemap, _super);
    function Treemap() {
        var _this = _super.call(this) || this;
        _this.g = null;
        _this.f = null;
        _this.e = null;
        _this.ba = false;
        _this.an = null;
        _this.il = null;
        _this.ap = null;
        _this.ea = null;
        _this.d9 = "Root";
        _this.d4 = " : ";
        _this.d8 = null;
        _this.d7 = null;
        _this.d5 = null;
        _this.d6 = null;
        _this.bq = null;
        _this.a = new BrushCollection();
        _this.ae = new TreemapNodeStyleMappingCollection();
        _this.c = 0;
        _this.bb = false;
        _this.dw = 10;
        _this.bx = NaN;
        _this.bw = NaN;
        _this.n = 0;
        _this.k = 0;
        _this.hx = null;
        _this.hr = null;
        _this.hp = null;
        _this.hw = null;
        _this.hu = null;
        _this.hq = null;
        _this.hy = null;
        _this.ho = null;
        _this.ht = null;
        _this.hs = null;
        _this.at = null;
        _this.as = null;
        _this.h = 0;
        _this.b0 = DeviceUtils.g(5);
        _this.b2 = DeviceUtils.g(3);
        _this.b1 = DeviceUtils.g(5);
        _this.bz = DeviceUtils.g(3);
        _this.ca = DeviceUtils.g(10);
        _this.cc = DeviceUtils.g(10);
        _this.cb = DeviceUtils.g(10);
        _this.b9 = DeviceUtils.g(10);
        _this.b5 = DeviceUtils.g(5);
        _this.b7 = DeviceUtils.g(3);
        _this.b6 = DeviceUtils.g(5);
        _this.b4 = DeviceUtils.g(3);
        _this.cf = DeviceUtils.g(0);
        _this.cj = DeviceUtils.g(0);
        _this.ch = DeviceUtils.g(0);
        _this.cd = DeviceUtils.g(0);
        _this.cg = DeviceUtils.g(3);
        _this.ck = DeviceUtils.g(3);
        _this.ci = DeviceUtils.g(3);
        _this.ce = DeviceUtils.g(3);
        _this.hl = 1;
        _this.ip = 1;
        _this.by = NaN;
        _this.hv = null;
        _this.cm = NaN;
        _this.ah = 0;
        _this.r = 0;
        _this.b8 = DeviceUtils.g(3);
        _this.dx = 500;
        _this.cn = 0;
        _this.dv = null;
        _this.aq = null;
        _this.a1 = null;
        _this.ax = null;
        _this.a0 = null;
        _this.ay = null;
        _this.az = null;
        _this.cl = NaN;
        _this.bt = 1;
        _this.b3 = NaN;
        _this.bs = 0.5;
        _this.a9 = false;
        _this.bf = false;
        _this.bi = false;
        _this.be = false;
        _this.aj = null;
        _this.q = null;
        _this.bu = NaN;
        _this.bv = DeviceUtils.g(1);
        _this.propertyChanged = null;
        _this.w = null;
        _this.t = null;
        _this.d2 = null;
        _this.am = null;
        _this.al = null;
        _this.ik = null;
        _this.nodeStyling = null;
        _this.nodePointerOver = null;
        _this.nodePointerEnter = null;
        _this.nodePointerLeave = null;
        _this.nodePointerPressed = null;
        _this.nodePointerReleased = null;
        var a = new TreemapView();
        a.a = _this;
        _this.q = new SquarifiedCalculator();
        _this.an = a;
        _this.an.au();
        _this.dv = function (b, c) { return _this.go(c.action, c.position, c.count, c.propertyName); };
        _this.il = Rect.empty;
        _this.g = new TreemapFrame();
        _this.f = new TreemapFrame();
        _this.e = new TreemapFrame();
        _this.bf = true;
        _this.ap = new DoubleAnimator(0, 1, _this.d1);
        _this.ap.b = EasingFunctions.cubicEase;
        var b = _this.ap;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(_this, _this.gn));
        var c = _this.ae;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(_this, _this.gl));
        var d = _this.ae;
        d.collectionResetting = delegateCombine(d.collectionResetting, runOn(_this, _this.gm));
        return _this;
    }
    Treemap.prototype.gm = function (a, b) {
        var e_10, _a;
        try {
            for (var _b = __values(fromEnum(this.styleMappings)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                c.propertyChanged = delegateRemove(c.propertyChanged, runOn(this, this.hh));
            }
        }
        catch (e_10_1) {
            e_10 = { error: e_10_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_10)
                    throw e_10.error;
            }
        }
        this.bf = true;
        this.bi = true;
        this.an.az();
    };
    Treemap.prototype.gl = function (a, b) {
        var e_11, _a, e_12, _b;
        if (b.oldItems != null) {
            try {
                for (var _c = __values(fromEn(b.oldItems)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var c = _d.value;
                    var d = c;
                    if (d != null) {
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.hh));
                    }
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        if (b.newItems != null) {
            try {
                for (var _e = __values(fromEn(b.newItems)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var e = _f.value;
                    var f = e;
                    if (f != null) {
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.hh));
                    }
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.bf = true;
        this.bi = true;
        this.an.az();
    };
    Treemap.prototype.hh = function (a, b) {
        this.bf = true;
        this.bi = true;
        this.an.az();
    };
    Treemap.prototype.go = function (a, b, c, d) {
        this.aj = null;
        this.bf = true;
        this.be = true;
        this.bi = true;
        this.an.az();
    };
    Treemap.prototype.notifySizeChanged = function () {
        this.an.ap();
    };
    Treemap.prototype.destroy = function () {
        this.provideContainer(null);
    };
    Treemap.prototype.ao = function () {
        var a = new TreemapVisualData();
        a.viewport = new RectData(this.io.left, this.io.top, this.io.width, this.io.height);
        a.nodes = new TreemapNodeVisualDataList();
        this.an.al(a);
        return a;
    };
    Treemap.prototype.ej = function () {
        var a = this.ao();
        a.scaleByViewport();
        return a.serialize();
    };
    Treemap.prototype.g7 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.hc(a, b, c);
    };
    Treemap.prototype.hc = function (a, b, c) {
        var _this = this;
        switch (a) {
            case "FocusItem":
                this.g1();
                break;
            case "LayoutType":
                {
                    switch (EnumUtil.getEnumValue(TreemapLayoutType_$type, c)) {
                        case 0:
                            this.q = new SquarifiedCalculator();
                            break;
                        case 1:
                            this.q = new SliceAndDiceCalculator();
                            break;
                        case 2:
                            this.q = new StrippedCalculator();
                            break;
                    }
                    this.bf = true;
                    this.an.az();
                }
                break;
            case "BreadcrumbSequence":
                this.bf = true;
                this.an.az();
                break;
            case "RootTitle":
                this.bf = true;
                this.an.az();
                break;
            case "ValueMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a8);
                    this.a8 = this.a6(this.gi);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "CustomValueMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a2);
                    this.a2 = this.a7(this.eg);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "IdMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a3);
                    this.a3 = this.a7(this.e5);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "LabelMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a4);
                    this.a4 = this.a7(this.ff);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "ParentIdMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a5);
                    this.a5 = this.a7(this.fw);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "ItemsSource":
                this.ar = ((function () {
                    var $ret = new FastItemsSource();
                    $ret.e = _this.dataSource;
                    return $ret;
                })());
                break;
            case "HeaderLabelLeftMargin":
            case "HeaderLabelTopMargin":
            case "HeaderLabelRightMargin":
            case "HeaderLabelBottomMargin":
            case "LabelLeftMargin":
            case "LabelTopMargin":
            case "LabelRightMargin":
            case "LabelBottomMargin":
            case "ParentNodeLeftMargin":
            case "ParentNodeTopMargin":
            case "ParentNodeRightMargin":
            case "ParentNodeBottomMargin":
            case "ParentNodeLeftPadding":
            case "ParentNodeTopPadding":
            case "ParentNodeRightPadding":
            case "ParentNodeBottomPadding":
            case "HeaderTextColor":
            case "HeaderHoverTextColor":
            case "OverlayHeaderHoverBackground":
            case "HeaderHoverBackground":
            case "StrokeThickness":
            case "Outline":
            case "FillBrushes":
            case "IsFillScaleLogarithmic":
            case "FillScaleMinimumValue":
            case "FillScaleMaximumValue":
            case "HeaderBackground":
            case "OverlayHeaderBackground":
            case "HeaderHeight":
            case "FillScaleLogarithmBase":
            case "FillScaleMode":
            case "MinimumDisplaySize":
            case "LayoutOrientation":
            case "LabelHorizontalAlignment":
            case "LabelVerticalAlignment":
            case "HeaderDisplayMode":
            case "LabelHorizontalFitMode":
            case "LabelVerticalFitMode":
                this.bf = true;
                this.an.az();
                break;
            case "TextStyle":
                this.an.aw(this.aw);
                this.bf = true;
                this.an.az();
                break;
            case "HeaderTextStyle":
                this.an.at(this.au);
                this.bf = true;
                this.an.az();
                break;
            case "PixelScalingRatio":
                if (!isNaN_(c)) {
                    this.cp = c;
                }
                break;
            case "ActualPixelScalingRatio":
                if (isNaN_(this.c0)) {
                    this.co = this.cp / 2;
                }
                if (this.an != null) {
                    this.an.av();
                }
                break;
            case "InteractionPixelScalingRatio":
                if (!isNaN_(c)) {
                    this.co = c;
                }
                break;
            case "ActualInteractionPixelScalingRatio":
                if (this.an != null) {
                    this.an.av();
                }
                break;
            case "TransitionProgress":
                if (this.du >= 1) {
                    this.ap.w();
                    this.an.av();
                    var d = this.f;
                    this.f = this.g;
                    this.g = d;
                    this.hb();
                    this.he(this.f);
                    this.an.ay();
                    this.an.az();
                    return;
                }
                this.e.h(this.du, this.g, this.f);
                this.he(this.e);
                this.an.ay();
                break;
            case "Viewport":
                this.bf = true;
                this.an.az();
                break;
            case "FastItemsSource":
                var e = b;
                var f = c;
                if (b != null) {
                    e.event = delegateRemove(e.event, this.dv);
                    this.a9 = false;
                    e.deregisterColumn(this.a8);
                    e.deregisterColumn(this.a3);
                    e.deregisterColumn(this.a5);
                    e.deregisterColumn(this.a4);
                    e.deregisterColumn(this.a2);
                    this.a8 = null;
                    this.a3 = null;
                    this.a5 = null;
                    this.a4 = null;
                    this.aj = null;
                }
                if (c != null) {
                    f.event = delegateCombine(f.event, this.dv);
                    this.a9 = true;
                    this.a8 = this.a6(this.gi);
                    this.a3 = this.a7(this.e5);
                    this.a5 = this.a7(this.fw);
                    this.a4 = this.a7(this.ff);
                    this.a2 = this.a7(this.eg);
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "TransitionDuration":
                this.ap.r = this.d1;
                break;
        }
    };
    Treemap.prototype.g1 = function () {
        if (this.ba) {
            return;
        }
        if (this.aj == null) {
            return;
        }
        if (this.d3 == null) {
            this.al = null;
            this.bf = true;
            this.an.az();
            return;
        }
        for (var a = 0; a < this.aj.d.count; a++) {
            var b = this.aj.b.item(this.aj.d._inner[a]);
            if (b.h == this.d3) {
                this.al = b;
                this.bf = true;
                this.an.az();
                break;
            }
        }
    };
    Object.defineProperty(Treemap.prototype, "io", {
        get: function () {
            return this.il;
        },
        set: function (a) {
            var b = this.il;
            this.il = a;
            if (!b.equals1(this.il)) {
                this.g7("Viewport", b, this.il);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.gn = function (a, b) {
        this.du = this.ap.o;
    };
    Object.defineProperty(Treemap.prototype, "gi", {
        get: function () {
            return this.ea;
        },
        set: function (a) {
            var b = this.ea;
            this.ea = a;
            if (b != this.ea) {
                this.hc("ValueMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "f8", {
        get: function () {
            return this.d9;
        },
        set: function (a) {
            var b = this.d9;
            this.d9 = a;
            if (b != this.d9) {
                this.hc("RootTitle", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ed", {
        get: function () {
            return this.d4;
        },
        set: function (a) {
            var b = this.d4;
            this.d4 = a;
            if (b != this.d9) {
                this.hc("BreadcrumbSequence", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "fw", {
        get: function () {
            return this.d8;
        },
        set: function (a) {
            var b = this.d8;
            this.d8 = a;
            if (b != this.d8) {
                this.g7("ParentIdMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ff", {
        get: function () {
            return this.d7;
        },
        set: function (a) {
            var b = this.d7;
            this.d7 = a;
            if (b != this.d7) {
                this.g7("LabelMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "eg", {
        get: function () {
            return this.d5;
        },
        set: function (a) {
            var b = this.d5;
            this.d5 = a;
            if (b != this.d5) {
                this.g7("CustomValueMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "e5", {
        get: function () {
            return this.d6;
        },
        set: function (a) {
            var b = this.d6;
            this.d6 = a;
            if (b != this.d6) {
                this.g7("IdMemberPath", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dataSource", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            if (b != this.bq) {
                this.g7("ItemsSource", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "b", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            var b = this.a;
            this.a = a;
            if (b != this.a) {
                this.g7("FillBrushes", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "styleMappings", {
        get: function () {
            return this.ae;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            var b = this.c;
            this.c = a;
            if (b != this.c) {
                this.g7("FillScaleMode", enumGetBox(TreemapFillScaleMode_$type, b), enumGetBox(TreemapFillScaleMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "bg", {
        get: function () {
            return this.bb;
        },
        set: function (a) {
            var b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.g7("IsFillScaleLogarithmic", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dy", {
        get: function () {
            return this.dw;
        },
        set: function (a) {
            var b = this.dw;
            this.dw = a;
            if (b != this.dw) {
                this.g7("FillScaleLogarithmBase", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ct", {
        get: function () {
            return this.bx;
        },
        set: function (a) {
            var b = this.bx;
            this.bx = a;
            if (b != this.bx) {
                this.g7("FillScaleMinimumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cs", {
        get: function () {
            return this.bw;
        },
        set: function (a) {
            var b = this.bw;
            this.bw = a;
            if (b != this.bw) {
                this.g7("FillScaleMaximumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "p", {
        get: function () {
            return this.n;
        },
        set: function (a) {
            var b = this.n;
            this.n = a;
            if (b != this.n) {
                this.g7("LabelVerticalFitMode", enumGetBox(TreemapLabelVerticalFitMode_$type, b), enumGetBox(TreemapLabelVerticalFitMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "o", {
        get: function () {
            return this.p == 0 ? 1 : this.p;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "m", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.g7("LabelHorizontalFitMode", enumGetBox(TreemapLabelHorizontalFitMode_$type, b), enumGetBox(TreemapLabelHorizontalFitMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "l", {
        get: function () {
            return this.m == 0 ? 1 : this.m;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h8", {
        get: function () {
            return this.hx;
        },
        set: function (a) {
            var b = this.hx;
            this.hx = a;
            if (b != this.hx) {
                this.g7("OverlayHeaderHoverBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h2", {
        get: function () {
            return this.hr;
        },
        set: function (a) {
            var b = this.hr;
            this.hr = a;
            if (b != this.hr) {
                this.g7("HeaderHoverBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h0", {
        get: function () {
            return this.hp;
        },
        set: function (a) {
            var b = this.hp;
            this.hp = a;
            if (b != this.hp) {
                this.g7("HeaderBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h7", {
        get: function () {
            return this.hw;
        },
        set: function (a) {
            var b = this.hw;
            this.hw = a;
            if (b != this.hw) {
                this.g7("OverlayHeaderBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h5", {
        get: function () {
            return this.hu;
        },
        set: function (a) {
            var b = this.hu;
            this.hu = a;
            if (b != this.hu) {
                this.g7("HeaderTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h1", {
        get: function () {
            return this.hq;
        },
        set: function (a) {
            var b = this.hq;
            this.hq = a;
            if (b != this.hq) {
                this.g7("HeaderDarkTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ij", {
        get: function () {
            return this.hy;
        },
        set: function (a) {
            var b = this.hy;
            this.hy = a;
            if (b != this.hy) {
                this.g7("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "hz", {
        get: function () {
            return this.ho;
        },
        set: function (a) {
            var b = this.ho;
            this.ho = a;
            if (b != this.ho) {
                this.g7("DarkTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h4", {
        get: function () {
            return this.ht;
        },
        set: function (a) {
            var b = this.ht;
            this.ht = a;
            if (b != this.ht) {
                this.g7("HeaderHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h3", {
        get: function () {
            return this.hs;
        },
        set: function (a) {
            var b = this.hs;
            this.hs = a;
            if (b != this.hs) {
                this.g7("HeaderHoverDarkTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "aw", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.at;
            this.at = a;
            if (b != this.at) {
                this.g7("TextStyle", b, this.at);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "au", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.as;
            this.as = a;
            if (b != this.as) {
                this.g7("HeaderTextStyle", b, this.as);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "j", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.g7("HeaderDisplayMode", enumGetBox(TreemapHeaderDisplayMode_$type, b), enumGetBox(TreemapHeaderDisplayMode_$type, this.h));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "i", {
        get: function () {
            return this.j == 0 ? 1 : this.j;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cx", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            if (b != this.b0) {
                this.g7("HeaderLabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cz", {
        get: function () {
            return this.b2;
        },
        set: function (a) {
            var b = this.b2;
            this.b2 = a;
            if (b != this.b2) {
                this.g7("HeaderLabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cy", {
        get: function () {
            return this.b1;
        },
        set: function (a) {
            var b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.g7("HeaderLabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cw", {
        get: function () {
            return this.bz;
        },
        set: function (a) {
            var b = this.bz;
            this.bz = a;
            if (b != this.bz) {
                this.g7("HeaderLabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c7", {
        get: function () {
            return this.ca;
        },
        set: function (a) {
            var b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.g7("OverlayHeaderLabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c9", {
        get: function () {
            return this.cc;
        },
        set: function (a) {
            var b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.g7("OverlayHeaderLabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c8", {
        get: function () {
            return this.cb;
        },
        set: function (a) {
            var b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.g7("OverlayHeaderLabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c6", {
        get: function () {
            return this.b9;
        },
        set: function (a) {
            var b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.g7("OverlayHeaderLabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c2", {
        get: function () {
            return this.b5;
        },
        set: function (a) {
            var b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.g7("LabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c4", {
        get: function () {
            return this.b7;
        },
        set: function (a) {
            var b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.g7("LabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c3", {
        get: function () {
            return this.b6;
        },
        set: function (a) {
            var b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.g7("LabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c1", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            var b = this.b4;
            this.b4 = a;
            if (b != this.b4) {
                this.g7("LabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dc", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.g7("ParentNodeLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dg", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            var b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.g7("ParentNodeTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "de", {
        get: function () {
            return this.ch;
        },
        set: function (a) {
            var b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.g7("ParentNodeRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "da", {
        get: function () {
            return this.cd;
        },
        set: function (a) {
            var b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.g7("ParentNodeBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dd", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            var b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.g7("ParentNodeLeftPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dh", {
        get: function () {
            return this.ck;
        },
        set: function (a) {
            var b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.g7("ParentNodeTopPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "df", {
        get: function () {
            return this.ci;
        },
        set: function (a) {
            var b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.g7("ParentNodeRightPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "db", {
        get: function () {
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.g7("ParentNodeBottomPadding", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "hm", {
        get: function () {
            return this.hl;
        },
        set: function (a) {
            var b = this.hl;
            this.hl = a;
            if (b != this.hl) {
                this.g7("LabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "iq", {
        get: function () {
            return this.ip;
        },
        set: function (a) {
            var b = this.ip;
            this.ip = a;
            if (b != this.ip) {
                this.g7("LabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cv", {
        get: function () {
            return this.by;
        },
        set: function (a) {
            var b = this.by;
            this.by = a;
            if (b != this.by) {
                this.g7("HeaderHeight", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "h6", {
        get: function () {
            return this.hv;
        },
        set: function (a) {
            var b = this.hv;
            this.hv = a;
            if (b != this.hv) {
                this.g7("Outline", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "dt", {
        get: function () {
            return this.cm;
        },
        set: function (a) {
            var b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.g7("StrokeThickness", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.g7("LayoutOrientation", enumGetBox(TreemapOrientation_$type, b), enumGetBox(TreemapOrientation_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.r;
            this.r = a;
            if (b != this.r) {
                this.g7("LayoutType", enumGetBox(TreemapLayoutType_$type, b), enumGetBox(TreemapLayoutType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c5", {
        get: function () {
            return this.b8;
        },
        set: function (a) {
            var b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.g7("MinimumDisplaySize", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "d1", {
        get: function () {
            return this.dx;
        },
        set: function (a) {
            var b = this.dx;
            this.dx = a;
            if (b != this.dx) {
                this.g7("TransitionDuration", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "du", {
        get: function () {
            return this.cn;
        },
        set: function (a) {
            var b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.g7("TransitionProgress", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "ar", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.g7("FastItemsSource", b, this.aq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a8", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            this.a1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a2", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            this.ax = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a5", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            this.a0 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a3", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            this.ay = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "a4", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            this.az = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "di", {
        get: function () {
            return this.cl;
        },
        set: function (a) {
            var b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.g7("PixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "cp", {
        get: function () {
            return this.bt;
        },
        set: function (a) {
            var b = this.bt;
            this.bt = a;
            if (b != this.bt) {
                this.g7("ActualPixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "c0", {
        get: function () {
            return this.b3;
        },
        set: function (a) {
            var b = this.b3;
            this.b3 = a;
            if (b != this.b3) {
                this.g7("InteractionPixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Treemap.prototype, "co", {
        get: function () {
            return this.bs;
        },
        set: function (a) {
            var b = this.bs;
            this.bs = a;
            if (b != this.bs) {
                this.g7("ActualInteractionPixelScalingRatio", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.a6 = function (a) {
        var b = null;
        return this.ar.registerColumn(a, b, false);
    };
    Treemap.prototype.a7 = function (a) {
        var b = null;
        return this.ar.registerColumnObject(a, b, false);
    };
    Treemap.prototype.gt = function () {
        this.bf = true;
        this.an.az();
    };
    Object.defineProperty(Treemap.prototype, "bc", {
        get: function () {
            return this.ap.f();
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.ak = function () {
        var a = new TreemapTreeData();
        if (this.a8 == null || (this.a4 == null && this.a3 == null)) {
            return null;
        }
        for (var b = 0; b < this.ar.count; b++) {
            var c = null;
            if (this.a2 != null && this.a2.count > b) {
                c = this.a2.item(b);
            }
            var d = this.a8.item(b);
            var e = null;
            var f = "";
            if (this.a4 != null) {
                f = this.a4.item(b) != null ? this.a4.item(b).toString() : "";
            }
            if (this.a3 != null) {
                if (this.a3.item(b) == null) {
                    continue;
                }
                e = stringReplace(this.a3.item(b).toString(), " ", "_");
            }
            if (e == null) {
                e = stringReplace(f, " ", "_");
                if (stringIsNullOrEmpty(e)) {
                    continue;
                }
            }
            var g = null;
            if (this.a5 != null) {
                g = this.a5.item(b) != null ? stringReplace(this.a5.item(b).toString(), " ", "_") : null;
            }
            var h = new TreemapTreeNode();
            h.i = e;
            h.k = g;
            h.h = this.ar.item(b);
            h.f = d;
            h.g = c;
            h.j = f;
            a.e(h);
        }
        a.f();
        return a;
    };
    Treemap.prototype.hb = function () {
        if (this.aj == null) {
            this.aj = this.ak();
            if (this.aj == null) {
                return;
            }
            this.g1();
        }
        if (this.bi) {
            this.bi = false;
            for (var a = 0; a < this.aj.d.count; a++) {
                var b = this.aj.b.item(this.aj.d._inner[a]);
                b.c.clear();
                for (var c = 0; c < this.styleMappings.count; c++) {
                    if (this.bd(this.styleMappings._inner[c], b)) {
                        b.c.add(this.styleMappings._inner[c]);
                    }
                }
            }
        }
        if (!this.an.n()) {
            return;
        }
        var d = new TreemapLayoutSettings();
        d.b = this.aj;
        if (this.al != null && !this.aj.b.containsKey(this.al.i)) {
            this.al = null;
            this.hi(null);
        }
        else {
            if (this.al != null) {
                var e = this.aj.b.item(this.al.i);
                if (e != this.al) {
                    this.al = e;
                    this.hi(this.al);
                }
            }
        }
        d.h = this.io;
        d.c = this.al;
        d.f = this.c5;
        d.a = this.ai;
        var f = this.i;
        var g = this.dk();
        var h = this.dm();
        var i = this.dl();
        var j = this.dj();
        var k = this.dp();
        var l = this.dr();
        var m = this.dq();
        var n = this.dn();
        var o = this.hn();
        var p = this.ir();
        var q = this.an.v("M");
        var r = this.an.x("M");
        var s = q + h + j;
        var t = r + l + n;
        d.j = new Thickness(1, this.dd, this.dh, this.df, this.db);
        d.i = new Thickness(1, this.dc, this.dg, this.de, this.da);
        if (!isNaN_(this.cv)) {
            s = this.cv;
        }
        d.e = s;
        if (f == 2) {
            d.e = 0;
        }
        d.d = this.al == null;
        this.q.d(this.f, d);
        var u = 1.7976931348623157E+308;
        var v = -1.7976931348623157E+308;
        if (this.d == 1 || this.d == 3) {
            for (var w = 0; w < this.aj.d.count; w++) {
                var x = 0;
                if (this.d == 1) {
                    x = this.aj.b.item(this.aj.d._inner[w]).e();
                }
                else {
                    x = this.aj.b.item(this.aj.d._inner[w]).f;
                }
                if (!isNaN_(x)) {
                    u = Math.min(x, u);
                    v = Math.max(x, v);
                }
            }
        }
        else {
            for (var y = 0; y < this.f.e.count; y++) {
                var z = 0;
                if (this.d == 0) {
                    z = this.aj.b.item(this.f.e._inner[y]).e();
                }
                else {
                    z = this.aj.b.item(this.f.e._inner[y]).f;
                }
                if (!isNaN_(z)) {
                    u = Math.min(z, u);
                    v = Math.max(z, v);
                }
            }
        }
        for (var aa = 0; aa < this.f.e.count; aa++) {
            var ab = this.f.e._inner[aa];
            var ac = this.aj.b.item(ab);
            var ad = this.h9(ac, u, v);
            var ae = this.ie(ac);
            var af = this.ia(ac);
            var ag = this.ds(ac);
            var ah = this.f7(this.f, ac, g, i, k, m, s, t);
            var ai = this.id(ac, ad, af);
            var aj = this.av(ac);
            var ak = 0;
            if (this.bh(ac)) {
                ak = this.an.w(ah);
            }
            else {
                ak = this.an.y(ah);
            }
            var al = 0;
            if (this.bh(ac)) {
                al = s;
            }
            else {
                al = this.an.x(ah);
            }
            this.f.l(ac, ah, ad, ae, af, ai, ag, f, ak, al, g, h, i, j, k, l, m, n, o, p);
            if (ac.c.count > 0) {
                for (var am = 0; am < ac.c.count; am++) {
                    var an = ac.b != null && ac.b.count > 0;
                    if (ac.c._inner[am].bf == 2 && an) {
                        continue;
                    }
                    this.f.f(ac, ac.c._inner[am], runOn(this, this.id));
                }
            }
            if (this.nodeStyling != null) {
                var ao = new TreemapNodeStylingEventArgs();
                ao.item = ac.h;
                if (ac.k != null) {
                    if (this.aj.b.containsKey(ac.k)) {
                        var ap = this.aj.b.item(ac.k);
                        ao.parentItem = ap.h;
                        ao.parentLabel = ap.j;
                        ao.parentSum = ap.e();
                        ao.parentValue = ap.f;
                    }
                }
                ao.sum = ac.e();
                ao.value = ac.f;
                ao.label = ac.j;
                ao.customValue = ac.g;
                if (ac.b != null && ac.b.count > 0) {
                    ao.isParent = true;
                }
                ao.style = new TreemapNodeStyle();
                this.nodeStyling(this, ao);
                this.f.f(ac, ao.style, runOn(this, this.id));
            }
        }
    };
    Treemap.prototype.bh = function (a) {
        return a.b != null && a.b.count > 0;
    };
    Treemap.prototype.dn = function () {
        return this.c1;
    };
    Treemap.prototype.dq = function () {
        return this.c3;
    };
    Treemap.prototype.dr = function () {
        return this.c4;
    };
    Treemap.prototype.dp = function () {
        return this.c2;
    };
    Treemap.prototype.hn = function () {
        return this.hm;
    };
    Treemap.prototype.ir = function () {
        return this.iq;
    };
    Treemap.prototype.dj = function () {
        if (this.i == 2) {
            return this.c6;
        }
        return this.cw;
    };
    Treemap.prototype.dl = function () {
        if (this.i == 2) {
            return this.c8;
        }
        return this.cy;
    };
    Treemap.prototype.dm = function () {
        if (this.i == 2) {
            return this.c9;
        }
        return this.cz;
    };
    Treemap.prototype.dk = function () {
        if (this.i == 2) {
            return this.c6;
        }
        return this.cx;
    };
    Treemap.prototype.gg = function (a, b, c, d, e) {
        var f = b.length;
        var g = b;
        var h = ("\u2026");
        if (isNaN_(this.bu)) {
            if (this.bh(a)) {
                this.bu = this.an.w(h);
            }
            else {
                this.bu = this.an.y(h);
            }
        }
        if (c <= (this.bu + d + e)) {
            if (this.l == 2) {
                return "";
            }
            return h;
        }
        var i = 0;
        if (this.bh(a)) {
            i = this.an.w(b);
        }
        else {
            i = this.an.y(b);
        }
        if (i + d + e <= c) {
            return b;
        }
        var j = c / (i + d + e);
        var k = truncate(Math.ceil(f * j));
        var l = b.substr(0, k) + h;
        var m = 0;
        if (this.bh(a)) {
            m = this.an.w(l);
        }
        else {
            m = this.an.y(l);
        }
        if ((m + d + e) > c) {
            f = k;
        }
        else {
            k = k + 1;
            l = b.substr(0, k) + h;
            if (this.bh(a)) {
                m = this.an.w(l);
            }
            else {
                m = this.an.y(l);
            }
            if ((m + d + e) > c) {
                f = k;
            }
        }
        while ((i + d + e) > c && f > 0) {
            f--;
            b = b.substr(0, f) + h;
            if (this.l == 2) {
                return "";
            }
            if (this.bh(a)) {
                i = this.an.w(b);
            }
            else {
                i = this.an.y(b);
            }
        }
        return b;
    };
    Treemap.prototype.f7 = function (a, b, c, d, e, f, g, h) {
        if (b == null) {
            if (this.ed != null && this.f8 != null && !stringIsNullOrEmpty(this.f8)) {
                return this.f8 + this.ed;
            }
            return "";
        }
        var i = a.o(b);
        var j = i.width;
        var k = i.height;
        var l = b.j;
        if (this.al != null && this.al == b && this.ed != null) {
            var m = null;
            var n = b;
            while (n.k != null) {
                if (this.aj.b.containsKey(n.k)) {
                    m = this.aj.b.item(n.k);
                    if (m.j != null) {
                        l = m.j + this.ed + l;
                    }
                    n = m;
                }
            }
            if (this.f8 != null && !stringIsNullOrEmpty(this.f8)) {
                l = this.f8 + this.ed + l;
            }
        }
        var o = 0;
        var p = 0;
        if (a.c(b.i)) {
            var q = a.a(b.i);
            if (b.b.count > 0) {
                o = c;
                p = d;
                if (this.o == 2) {
                    if (k < g) {
                        return "";
                    }
                }
            }
            else {
                o = e;
                p = f;
                if (this.o == 2) {
                    if (k < h) {
                        return "";
                    }
                }
            }
        }
        return this.gg(b, l, j, o, p);
    };
    Treemap.prototype.ds = function (a) {
        if (!isNaN_(this.dt)) {
            return this.dt;
        }
        return this.bv;
    };
    Treemap.prototype.ia = function (a) {
        if (this.i == 2) {
            return this.ig(a);
        }
        if (a == this.am) {
            return this.ib(a);
        }
        if (this.h0 != null) {
            return this.h0;
        }
        return this.an.a4();
    };
    Treemap.prototype.ig = function (a) {
        if (a == this.am) {
            return this.ih(a);
        }
        if (this.h7 != null) {
            return this.h7;
        }
        return this.an.a9();
    };
    Treemap.prototype.id = function (a, b, c) {
        if (a.b.count > 0) {
            if (a == this.am) {
                return this.ic(a, c);
            }
            var d = this.an.a5();
            var e = this.an.a6();
            if (this.h5 != null) {
                e = this.h5;
            }
            if (this.h1 != null) {
                d = this.h1;
            }
            return BrushUtil.i(c, d, e);
        }
        else {
            var f = this.an.a3();
            var g = this.an.bb();
            if (this.ij != null) {
                g = this.ij;
            }
            if (this.hz != null) {
                f = this.hz;
            }
            return BrushUtil.i(b, f, g);
        }
    };
    Treemap.prototype.av = function (a) {
        if (a.b.count > 0) {
            if (this.au != null) {
                return this.au;
            }
            return this.an.h();
        }
        else {
            if (this.aw != null) {
                return this.aw;
            }
            return this.an.h();
        }
    };
    Treemap.prototype.onDetachedFromUI = function () {
        this.an.as();
    };
    Treemap.prototype.onAttachedToUI = function () {
        this.an.aq();
    };
    Treemap.prototype.ib = function (a) {
        if (this.h2 != null) {
            return this.h2;
        }
        return this.an.a7();
    };
    Treemap.prototype.ih = function (a) {
        if (this.h8 != null) {
            return this.h8;
        }
        return this.an.ba();
    };
    Treemap.prototype.ic = function (a, b) {
        var c = this.an.a5();
        var d = this.an.a6();
        if (this.h5 != null) {
            d = this.h5;
        }
        if (this.h1 != null) {
            c = this.h1;
        }
        if (this.h4 != null) {
            d = this.h4;
        }
        if (this.h3 != null) {
            c = this.h3;
        }
        return BrushUtil.i(b, c, d);
    };
    Treemap.prototype.ie = function (a) {
        if (this.h6 != null) {
            return this.h6;
        }
        return this.an.a8();
    };
    Treemap.prototype.h9 = function (a, b, c) {
        if (this.b == null || this.b.count == 0) {
            return this.ii(a);
        }
        var d = this.cu(a);
        if (isNaN_(d)) {
            return this.ii(a);
        }
        var e = 0;
        if (this.bg && this.dy > 0) {
            if (d > 0) {
                e = (logBase(d, this.dy) - logBase(b, this.dy)) / (logBase(c, this.dy) - logBase(b, this.dy));
            }
            else {
                return this.ii(a);
            }
        }
        else {
            e = (d - b) / (c - b);
        }
        e = e * (this.b.count - 1);
        return BrushCollectionUtil.b(this.b, e);
    };
    Treemap.prototype.cu = function (a) {
        switch (this.d) {
            case 0:
            case 1: return a.e();
            case 2:
            case 3: return a.f;
        }
        return a.e();
    };
    Treemap.prototype.ii = function (a) {
        return this.an.a4();
    };
    Treemap.prototype.he = function (a) {
        var b = new List$1(TreemapVisual.$, 0);
        var c = this.an.i();
        var d = 0;
        if (this.i == 2) {
            d = this.d0(a, false, d, c, function (e) { return true; }, b);
            d = this.d0(a, true, d, c, function (e) { return e.e.b != null && e.e.b.count > 0; }, b);
        }
        else {
            d = this.d0(a, false, d, c, function (e) { return true; }, b);
        }
        c.count = d;
        this.an.af(b);
    };
    Treemap.prototype.d0 = function (a, b, c, d, e, f) {
        for (var g = 0; g < a.e.count; g++) {
            var h = a.e._inner[g];
            var i = a.a(h);
            if (!e(i)) {
                continue;
            }
            var j = d.item(c);
            if (i.y.isEmpty || (i.y.width == 0 && i.y.height == 0)) {
                j.t = 1;
                continue;
            }
            c++;
            f.add(j);
            var k = i.e.b.count == 0;
            var l = !k && i.a == 2;
            j.a = this.av(i.e);
            j.i = i.u;
            j.l = i.x;
            j.j = i.v;
            j.n = new Thickness(1, i.i, i.k, i.j, i.h);
            j.o = new Thickness(1, i.n, i.p, i.o, i.m);
            j.k = i.w;
            j.g = i.s;
            j.f = i.q;
            j.t = 0;
            j.m = this.im(i.y, i.q);
            j.b = k;
            j.q = !k && !l ? 0 : 1;
            j.s = !k && l ? 0 : 1;
            j.r = k ? 0 : 1;
            j.e = i.l;
            j.d = i.g;
            j.h = i.t;
            j.p = i.z;
            if (!b && !k && l) {
                j.s = 1;
            }
            if (b && !k && l) {
                j.i = null;
                j.l = null;
            }
        }
        return c;
    };
    Treemap.prototype.im = function (a, b) {
        var c = this.cq(Math.floor(a.left), b);
        var d = this.cq(Math.floor(a.right), b);
        var e = this.cq(Math.floor(a.top), b);
        var f = this.cq(Math.floor(a.bottom), b);
        return new Rect(0, c, e, d - c, f - e);
    };
    Treemap.prototype.cq = function (a, b) {
        var c = a;
        if (b > 0) {
            var d = b % 2;
            if (d == 0 || d == 1) {
                var e = 1;
                c = Math.floor(a);
                if (c + 0.5 < a) {
                    e = -1;
                    c = Math.ceil(a);
                }
                if (d == 1) {
                    c += 0.5 * e;
                }
            }
        }
        return c;
    };
    Treemap.prototype.bm = function () {
        return !this.io.isEmpty && this.an.n();
    };
    Treemap.prototype.hf = function () {
        if (!this.bm()) {
            return;
        }
        if (this.bf) {
            var a = this.g;
            if (this.bc) {
                if (this.ap.g) {
                    this.ap.t();
                }
                this.g = this.e;
                this.e = a;
            }
            else {
                this.g = this.f;
                this.f = a;
            }
        }
        else if (this.bc) {
            this.e.h(this.du, this.g, this.f);
            this.he(this.e);
        }
        if (this.bf) {
            this.hb();
        }
        if (this.bf && this.bn) {
            this.hg();
            this.e.h(this.du, this.g, this.f);
            this.he(this.e);
        }
        else {
            if (this.bf) {
                this.he(this.f);
            }
        }
        this.bf = false;
        this.an.ay();
    };
    Treemap.prototype.bd = function (a, b) {
        var c = null;
        switch (a.bh) {
            case 1:
                c = b.f;
                break;
            case 0:
                c = b.e();
                break;
            case 2:
                c = b.g;
                break;
        }
        if (this.bj(c)) {
            var d = this.cr(c);
            if (a.bn != null) {
                if (this.bj(a.bn)) {
                    var e = this.cr(a.bn);
                    if (isNaN_(e) && isNaN_(d)) {
                        return true;
                    }
                    if (d == e) {
                        return true;
                    }
                }
            }
            else if (!isNaN_(a.bl) || !isNaN_(a.bk)) {
                var f = a.bl;
                var g = a.bk;
                if (d >= f && d <= g) {
                    return true;
                }
            }
        }
        else if (this.bl(c)) {
            if (a.bn != null) {
                if (this.bl(a.bn)) {
                    var h = (a.bn);
                    if (Base.equalsStatic(h, c)) {
                        return true;
                    }
                }
            }
        }
        else {
            if (Base.equalsStatic(c, a.bn)) {
                return true;
            }
        }
        return false;
    };
    Treemap.prototype.bl = function (a) {
        return typeof a === 'string';
    };
    Treemap.prototype.cr = function (a) {
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        return NaN;
    };
    Treemap.prototype.bj = function (a) {
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        return false;
    };
    Treemap.prototype.u = function (a) {
        var e_13, _a;
        var _this = this;
        var b = this.f;
        if (this.bc) {
            b = this.e;
        }
        var c = new List$1(TreemapNodeFrame.$, 0);
        for (var d = 0; d < b.e.count; d++) {
            var e = b.e._inner[d];
            var f = b.a(e);
            if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                c.add(f);
            }
        }
        c.aa(function (g, h) {
            var i = _this.dz(h);
            var j = _this.dz(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        try {
            for (var _b = __values(fromEnum(c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var g = _c.value;
                if (g.e.b.count > 0) {
                    return g;
                }
            }
        }
        catch (e_13_1) {
            e_13 = { error: e_13_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_13)
                    throw e_13.error;
            }
        }
        return null;
    };
    Treemap.prototype.dz = function (a) {
        var b = a.e;
        var c = 0;
        while (b.k != null) {
            if (this.aj == null) {
                break;
            }
            if (this.aj.b.containsKey(b.k)) {
                c++;
                b = this.aj.b.item(b.k);
            }
            else {
                break;
            }
        }
        return c;
    };
    Treemap.prototype.v = function (a) {
        var e_14, _a, e_15, _b;
        var _this = this;
        var b = this.f;
        if (this.bc) {
            b = this.e;
        }
        var c = new List$1(TreemapNodeFrame.$, 0);
        for (var d = 0; d < b.e.count; d++) {
            var e = b.e._inner[d];
            var f = b.a(e);
            if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                c.add(f);
            }
        }
        c.aa(function (g, h) {
            var i = _this.dz(h);
            var j = _this.dz(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        if (this.i == 2) {
            try {
                for (var _c = __values(fromEnum(c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var g = _d.value;
                    if (g.e.b.count > 0) {
                        if (this.bk(a, g)) {
                            return g;
                        }
                    }
                }
            }
            catch (e_14_1) {
                e_14 = { error: e_14_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_14)
                        throw e_14.error;
                }
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var h = _f.value;
                return h;
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        return null;
    };
    Treemap.prototype.hg = function () {
        this.cn = 0;
        this.ap.w();
        this.ap.v();
        this.an.av();
    };
    Object.defineProperty(Treemap.prototype, "bn", {
        get: function () {
            return this.d1 > 0;
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.provideContainer = function (a) {
        this.an.ar(a);
        this.ap.u(a);
    };
    Treemap.prototype.gr = function () {
        this.an.am();
    };
    Object.defineProperty(Treemap.prototype, "x", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != a) {
                this.gs(b);
                this.gq(a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.gq = function (a) {
        if (a != null) {
            if (this.nodePointerEnter != null) {
                this.nodePointerEnter(this, this.y(a));
            }
        }
    };
    Treemap.prototype.gs = function (a) {
        if (a != null) {
            if (this.nodePointerLeave != null) {
                this.nodePointerLeave(this, this.y(a));
            }
        }
    };
    Treemap.prototype.y = function (a) {
        var b = new TreemapNodePointerEventArgs();
        if (a != null) {
            b.customValue = a.e.g;
            b.item = a.e.h;
            b.position = this.ik;
            b.sum = a.e.e();
            b.value = a.e.f;
            b.label = a.e.j;
            b.isOverHeader = this.bk(this.ik, a);
            if (a.e.k != null && this.aj != null && this.aj.b.containsKey(a.e.k)) {
                var c = this.aj.b.item(a.e.k);
                b.parentItem = c.h;
                b.parentSum = c.e();
                b.parentValue = c.f;
                b.parentLabel = c.j;
            }
        }
        b.isRightButton = false;
        return b;
    };
    Object.defineProperty(Treemap.prototype, "d3", {
        get: function () {
            return this.d2;
        },
        set: function (a) {
            var b = this.d2;
            this.d2 = a;
            if (b != this.d2) {
                this.g7("FocusItem", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Treemap.prototype.g2 = function (a) {
        this.hk(a);
        if (this.nodePointerPressed != null && this.x != null) {
            var b = this.y(this.x);
            this.nodePointerPressed(this, b);
        }
    };
    Treemap.prototype.g6 = function (a) {
        this.hk(a);
        var b = false;
        if (this.nodePointerReleased != null && this.x != null) {
            var c = this.y(this.x);
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            if (this.w != null) {
                if (this.w.e == this.al && this.bk(a, this.w)) {
                    this.al = null;
                    this.bf = true;
                    this.an.az();
                    this.hi(null);
                    return;
                }
                this.al = this.w.e;
                this.hi(this.w.e);
                this.bf = true;
                this.an.az();
            }
            else {
                this.al = null;
                this.bf = true;
                this.hi(null);
                this.an.az();
            }
        }
    };
    Treemap.prototype.hi = function (a) {
        try {
            this.ba = true;
            if (a == null) {
                this.d3 = null;
            }
            else {
                this.d3 = a.h;
            }
            this.ba = false;
        }
        finally {
            this.ba = false;
        }
    };
    Treemap.prototype.bk = function (a, b) {
        var c = this.f;
        if (this.bc) {
            c = this.e;
        }
        if (b == null) {
            return false;
        }
        var d = b;
        if (a.x >= d.y.left && a.x <= d.y.right && a.y >= d.y.top && a.y <= d.y.bottom) {
            if (a.y - d.y.top <= d.g) {
                return true;
            }
        }
        return false;
    };
    Treemap.prototype.gx = function (source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        var d = this.ar;
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    };
    Treemap.prototype.gu = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        var a = this.ar;
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    };
    Treemap.prototype.bo = function (a) {
        return Treemap.bp(a, this.dataSource);
    };
    Treemap.bp = function (a, b) {
        return a == b;
    };
    Treemap.prototype.gv = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        var c = this.ar;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    };
    Treemap.prototype.gw = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        var c = this.ar;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    };
    Treemap.prototype.g3 = function (a) {
        this.hk(a);
    };
    Treemap.prototype.g4 = function (a) {
        this.hk(a);
        this.w = null;
        this.x = null;
        if (!this.bc) {
            this.bf = true;
            this.an.az();
        }
    };
    Treemap.prototype.hk = function (a) {
        this.ik = { $type: Point_$type, x: a.x, y: a.y };
        this.w = this.u(a);
        this.x = this.v(a);
        this.hj(a);
    };
    Treemap.prototype.g5 = function (a) {
        this.hk(a);
        if (this.x != null) {
            if (this.nodePointerOver != null) {
                this.nodePointerOver(this, this.y(this.x));
            }
        }
    };
    Treemap.prototype.hj = function (a) {
        if (!this.bc) {
            if (this.bk(a, this.w)) {
                var b = this.am;
                this.am = this.w.e;
                if (this.am != b) {
                    this.bf = true;
                    this.an.az();
                }
            }
            else {
                var c = this.am;
                this.am = null;
                if (this.am != c) {
                    this.bf = true;
                    this.an.az();
                }
            }
        }
    };
    Treemap.prototype.g8 = function (a) {
        this.hk(a);
        if (this.nodePointerPressed != null && this.x != null) {
            var b = this.y(this.x);
            b.isRightButton = true;
            this.nodePointerPressed(this, b);
        }
    };
    Treemap.prototype.g9 = function (a) {
        this.hk(a);
        var b = false;
        if (this.nodePointerReleased != null && this.x != null) {
            var c = this.y(this.x);
            c.isRightButton = true;
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            this.w = null;
            this.al = null;
            this.hi(null);
            this.bf = true;
            this.an.az();
        }
    };
    Treemap.prototype.ha = function (a) {
        this.bf = true;
        this.an.az();
    };
    Treemap.$t = markType(Treemap, 'Treemap', Base.$, [INotifyPropertyChanged_$type]);
    return Treemap;
}(Base));
/**
 * @hidden
 */
var TreemapNodeStyle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeStyle, _super);
    function TreemapNodeStyle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = new HashSet$1(String_$type, 0);
        _this.a0 = null;
        _this.az = null;
        _this.a2 = null;
        _this.x = null;
        _this.a4 = null;
        _this.a1 = null;
        _this.f = DeviceUtils.g(5);
        _this.h = DeviceUtils.g(3);
        _this.g = DeviceUtils.g(5);
        _this.e = DeviceUtils.g(3);
        _this.j = DeviceUtils.g(5);
        _this.l = DeviceUtils.g(3);
        _this.k = DeviceUtils.g(5);
        _this.i = DeviceUtils.g(3);
        _this.d = NaN;
        _this.aw = 1;
        _this.bc = 1;
        _this.ay = null;
        _this.a3 = null;
        _this.m = NaN;
        _this.propertyChanged = null;
        return _this;
    }
    TreemapNodeStyle.prototype.au = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.av(a, b, c);
    };
    TreemapNodeStyle.prototype.at = function () {
        this.c.clear();
    };
    TreemapNodeStyle.prototype.b = function (a) {
        return this.c.contains(a);
    };
    TreemapNodeStyle.prototype.av = function (a, b, c) {
        if (!this.c.contains(a)) {
            this.c.add_1(a);
        }
        if (this.a != null) {
            this.a.ha(this);
        }
    };
    Object.defineProperty(TreemapNodeStyle.prototype, "a7", {
        get: function () {
            return this.a0;
        },
        set: function (a) {
            var b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.au("HeaderHoverBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "a6", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.au("HeaderBackground", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "a9", {
        get: function () {
            return this.a2;
        },
        set: function (a) {
            var b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.au("HeaderTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "ai", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.x;
            this.x = a;
            if (b != this.x) {
                this.au("Label", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "bb", {
        get: function () {
            return this.a4;
        },
        set: function (a) {
            var b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.au("TextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "a8", {
        get: function () {
            return this.a1;
        },
        set: function (a) {
            var b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.au("HeaderHoverTextColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "p", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            var b = this.f;
            this.f = a;
            if (b != this.f) {
                this.au("HeaderLabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "r", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            var b = this.h;
            this.h = a;
            if (b != this.h) {
                this.au("HeaderLabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "q", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            if (b != this.g) {
                this.au("HeaderLabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "o", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            var b = this.e;
            this.e = a;
            if (b != this.e) {
                this.au("HeaderLabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "t", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            var b = this.j;
            this.j = a;
            if (b != this.j) {
                this.au("LabelLeftMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "v", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            var b = this.l;
            this.l = a;
            if (b != this.l) {
                this.au("LabelTopMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "u", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            var b = this.k;
            this.k = a;
            if (b != this.k) {
                this.au("LabelRightMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "s", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            if (b != this.i) {
                this.au("LabelBottomMargin", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "n", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            var b = this.d;
            this.d = a;
            if (b != this.d) {
                this.au("HeaderHeight", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "ax", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            var b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.au("LabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "bd", {
        get: function () {
            return this.bc;
        },
        set: function (a) {
            var b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.au("LabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "a5", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.au("Fill", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "ba", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            var b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.au("Outline", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyle.prototype, "w", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            var b = this.m;
            this.m = a;
            if (b != this.m) {
                this.au("StrokeThickness", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStyle.$t = markType(TreemapNodeStyle, 'TreemapNodeStyle', Base.$, [INotifyPropertyChanged_$type]);
    return TreemapNodeStyle;
}(Base));
/**
 * @hidden
 */
var TreemapNodeStyleMapping = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeStyleMapping, _super);
    function TreemapNodeStyleMapping() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.be = 0;
        _this.bo = null;
        _this.bj = NaN;
        _this.bi = NaN;
        _this.bm = null;
        _this.bg = 1;
        return _this;
    }
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bf", {
        get: function () {
            return this.be;
        },
        set: function (a) {
            var b = this.be;
            this.be = a;
            if (b != this.be) {
                this.au("TargetType", enumGetBox(TreemapNodeStyleMappingTargetType_$type, b), enumGetBox(TreemapNodeStyleMappingTargetType_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bs", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            var b = this.bo;
            this.bo = a;
            if (b != this.bo) {
                this.au("Name", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bl", {
        get: function () {
            return this.bj;
        },
        set: function (a) {
            var b = this.bj;
            this.bj = a;
            if (b != this.bj) {
                this.au("MinimumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bk", {
        get: function () {
            return this.bi;
        },
        set: function (a) {
            var b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.au("MaximumValue", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bn", {
        get: function () {
            return this.bm;
        },
        set: function (a) {
            var b = this.bm;
            this.bm = a;
            if (b != this.bm) {
                this.au("Value", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStyleMapping.prototype, "bh", {
        get: function () {
            return this.bg;
        },
        set: function (a) {
            var b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.au("MappingMode", enumGetBox(TreemapValueMappingMode_$type, b), enumGetBox(TreemapValueMappingMode_$type, a));
            }
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStyleMapping.$t = markType(TreemapNodeStyleMapping, 'TreemapNodeStyleMapping', TreemapNodeStyle.$);
    return TreemapNodeStyleMapping;
}(TreemapNodeStyle));
/**
 * @hidden
 */
var TreemapNodeStyleMappingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeStyleMappingCollection, _super);
    function TreemapNodeStyleMappingCollection() {
        var _this = _super.call(this, TreemapNodeStyleMapping.$, 0) || this;
        _this.collectionResetting = null;
        return _this;
    }
    TreemapNodeStyleMappingCollection.prototype.p = function () {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        _super.prototype.p.call(this);
    };
    TreemapNodeStyleMappingCollection.$t = markType(TreemapNodeStyleMappingCollection, 'TreemapNodeStyleMappingCollection', ObservableCollection$1.$.specialize(TreemapNodeStyleMapping.$));
    return TreemapNodeStyleMappingCollection;
}(ObservableCollection$1));
/**
 * @hidden
 */
var TreemapNodeStylingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeStylingEventArgs, _super);
    function TreemapNodeStylingEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._value = 0;
        _this._sum = 0;
        _this._customValue = null;
        _this._item = null;
        _this._parentItem = null;
        _this._label = null;
        _this._parentValue = 0;
        _this._parentLabel = null;
        _this._parentSum = 0;
        _this._isParent = false;
        _this._style = null;
        return _this;
    }
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "value", {
        get: function () {
            return this._value;
        },
        set: function (a) {
            this._value = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "sum", {
        get: function () {
            return this._sum;
        },
        set: function (a) {
            this._sum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "customValue", {
        get: function () {
            return this._customValue;
        },
        set: function (a) {
            this._customValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "item", {
        get: function () {
            return this._item;
        },
        set: function (a) {
            this._item = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentItem", {
        get: function () {
            return this._parentItem;
        },
        set: function (a) {
            this._parentItem = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentValue", {
        get: function () {
            return this._parentValue;
        },
        set: function (a) {
            this._parentValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentLabel", {
        get: function () {
            return this._parentLabel;
        },
        set: function (a) {
            this._parentLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "parentSum", {
        get: function () {
            return this._parentSum;
        },
        set: function (a) {
            this._parentSum = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "isParent", {
        get: function () {
            return this._isParent;
        },
        set: function (a) {
            this._isParent = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodeStylingEventArgs.prototype, "style", {
        get: function () {
            return this._style;
        },
        set: function (a) {
            this._style = a;
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodeStylingEventArgs.$t = markType(TreemapNodeStylingEventArgs, 'TreemapNodeStylingEventArgs', EventArgs.$);
    return TreemapNodeStylingEventArgs;
}(EventArgs));
/**
 * @hidden
 */
var TreemapFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapFrame, _super);
    function TreemapFrame() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.e = null;
        _this.e = new List$1(String_$type, 0);
        _this.d = new Dictionary$2(String_$type, TreemapNodeFrame.$, 0);
        return _this;
    }
    TreemapFrame.prototype.h = function (a, b, c) {
        this.g();
        this.k(a, b, c);
        this.j(a, b, c);
        this.i(a, b, c);
    };
    TreemapFrame.prototype.i = function (a, b, c) {
        for (var d = 0; d < b.e.count; d++) {
            var e = b.e._inner[d];
            if (c.d.containsKey(e)) {
                var f = TreemapNodeFrame.b(a, b.d.item(e), c.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    };
    TreemapFrame.prototype.j = function (a, b, c) {
        for (var d = 0; d < c.e.count; d++) {
            var e = c.e._inner[d];
            if (!b.d.containsKey(e)) {
                var f = TreemapNodeFrame.c(a, c.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    };
    TreemapFrame.prototype.k = function (a, b, c) {
        for (var d = 0; d < b.e.count; d++) {
            var e = b.e._inner[d];
            if (!c.d.containsKey(e)) {
                var f = TreemapNodeFrame.d(a, b.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    };
    TreemapFrame.prototype.m = function (a, b) {
        var _this = this;
        var c;
        if (!((function () { var d = _this.d.tryGetValue(a.i, c); c = d.p1; return d.ret; })())) {
            c = new TreemapNodeFrame();
            c.r = a.i;
            c.e = a;
            this.d.item(c.r, c);
            this.e.add(c.r);
        }
        c.y = b;
    };
    TreemapFrame.prototype.n = function (a, b) {
        this.d.item(a.i).f = b;
    };
    TreemapFrame.prototype.b = function (a) {
        if (!this.d.containsKey(a.i)) {
            return false;
        }
        return this.d.item(a.i).f;
    };
    TreemapFrame.prototype.o = function (a) {
        var _this = this;
        var b;
        if (!((function () { var c = _this.d.tryGetValue(a.i, b); b = c.p1; return c.ret; })())) {
            return Rect.empty;
        }
        return b.y;
    };
    TreemapFrame.prototype.l = function (a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t) {
        var _this = this;
        var u;
        if (!((function () { var v = _this.d.tryGetValue(a.i, u); u = v.p1; return v.ret; })())) {
            return;
        }
        u.s = b;
        u.u = c;
        u.x = d;
        u.q = g;
        u.v = e;
        u.a = h;
        u.l = i;
        u.g = j;
        u.w = f;
        u.i = k;
        u.k = l;
        u.j = m;
        u.h = n;
        u.n = o;
        u.p = p;
        u.o = q;
        u.m = r;
        u.t = s;
        u.z = t;
    };
    TreemapFrame.prototype.g = function () {
        this.e.clear();
        this.d.clear();
    };
    TreemapFrame.prototype.c = function (a) {
        return this.d.containsKey(a);
    };
    TreemapFrame.prototype.a = function (a) {
        return this.d.item(a);
    };
    TreemapFrame.prototype.f = function (a, b, c) {
        var _this = this;
        var d;
        if (!((function () { var e = _this.d.tryGetValue(a.i, d); d = e.p1; return e.ret; })())) {
            return;
        }
        var e = a.b != null && a.b.count > 0;
        if (b.b("Label")) {
            d.s = b.ai;
        }
        if (b.b("Fill")) {
            d.u = b.a5;
        }
        if (b.b("LabelHorizontalAlignment")) {
            d.t = b.ax;
        }
        if (b.b("Outline")) {
            d.x = b.ba;
        }
        if (b.b("StrokeThickness")) {
            d.q = b.w;
        }
        if (b.b("HeaderBackground")) {
            d.v = b.a6;
        }
        if (e) {
            if (b.b("HeaderTextColor")) {
                d.w = b.a9;
            }
            else if (b.b("Fill") || b.b("HeaderBackground")) {
                d.w = c(a, d.u, d.v);
            }
        }
        else {
            if (b.b("TextColor")) {
                d.w = b.bb;
            }
            else if (b.b("Fill") || b.b("HeaderBackground")) {
                d.w = c(a, d.u, d.v);
            }
        }
        if (b.b("HeaderLabelLeftMargin")) {
            d.i = b.p;
        }
        if (b.b("HeaderLabelTopMargin")) {
            d.k = b.r;
        }
        if (b.b("HeaderLabelRightMargin")) {
            d.j = b.q;
        }
        if (b.b("HeaderLabelBottomMargin")) {
            d.h = b.o;
        }
        if (b.b("LabelLeftMargin")) {
            d.n = b.t;
        }
        if (b.b("LabelTopMargin")) {
            d.p = b.v;
        }
        if (b.b("LabelRightMargin")) {
            d.o = b.u;
        }
        if (b.b("LabelBottomMargin")) {
            d.m = b.s;
        }
    };
    TreemapFrame.$t = markType(TreemapFrame, 'TreemapFrame');
    return TreemapFrame;
}(Base));
/**
 * @hidden
 */
var TreemapNodeFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TreemapNodeFrame, _super);
    function TreemapNodeFrame() {
        var _this = _super.call(this) || this;
        _this.y = null;
        _this.e = null;
        _this.r = null;
        _this.s = null;
        _this.u = null;
        _this.x = null;
        _this.q = 0;
        _this.i = 0;
        _this.k = 0;
        _this.j = 0;
        _this.h = 0;
        _this.n = 0;
        _this.p = 0;
        _this.o = 0;
        _this.m = 0;
        _this.w = null;
        _this.v = null;
        _this.a = 0;
        _this.l = 0;
        _this.g = 0;
        _this.t = 0;
        _this.z = 0;
        _this.f = false;
        _this.y = Rect.empty;
        return _this;
    }
    TreemapNodeFrame.b = function (a, b, c) {
        var d = new TreemapNodeFrame();
        d.e = c.e;
        d.r = c.r;
        d.s = c.s;
        var e = c.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        var f = b.y;
        if (f.isEmpty) {
            f = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, f.left + (e.left - f.left) * a, f.top + (e.top - f.top) * a, f.width + (e.width - f.width) * a, f.height + (e.height - f.height) * a);
        d.u = BrushUtil.k(b.u, a, c.u, 0);
        d.x = BrushUtil.k(b.x, a, c.x, 0);
        d.v = BrushUtil.k(b.v, a, c.v, 0);
        d.w = BrushUtil.k(b.w, a, c.w, 0);
        d.q = b.q + (c.q - b.q) * a;
        d.i = b.i + (c.i - b.i) * a;
        d.k = b.k + (c.k - b.k) * a;
        d.j = b.j + (c.j - b.j) * a;
        d.h = b.h + (c.h - b.h) * a;
        d.n = b.n + (c.n - b.n) * a;
        d.p = b.p + (c.p - b.p) * a;
        d.o = b.o + (c.o - b.o) * a;
        d.m = b.m + (c.m - b.m) * a;
        d.l = b.l + (c.l - b.l) * a;
        d.g = b.g + (c.g - b.g) * a;
        d.t = a < 0.5 ? b.t : c.t;
        d.z = a < 0.5 ? b.z : c.z;
        d.a = a < 0.5 ? b.a : c.a;
        return d;
    };
    TreemapNodeFrame.d = function (a, b) {
        var c = new Rect(0, 0, 0, 0, 0);
        var d = new TreemapNodeFrame();
        d.e = b.e;
        d.s = b.s;
        d.r = b.r;
        var e = b.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, e.left + (c.left - e.left) * a, e.top + (c.top - e.top) * a, e.width + (c.width - e.width) * a, e.height + (c.height - e.height) * a);
        d.u = BrushUtil.k(b.u, a, null, 0);
        d.x = BrushUtil.k(b.x, a, null, 0);
        d.v = BrushUtil.k(b.v, a, null, 0);
        d.w = BrushUtil.k(b.w, a, null, 0);
        d.q = b.q + (0 - b.q) * a;
        d.i = b.i + (0 - b.i) * a;
        d.k = b.k + (0 - b.k) * a;
        d.j = b.j + (0 - b.j) * a;
        d.h = b.h + (0 - b.h) * a;
        d.n = b.n + (0 - b.n) * a;
        d.p = b.p + (0 - b.p) * a;
        d.o = b.o + (0 - b.o) * a;
        d.m = b.m + (0 - b.m) * a;
        d.l = b.l + (0 - b.l) * a;
        d.g = b.g + (0 - b.g) * a;
        d.t = b.t;
        d.z = b.z;
        d.a = b.a;
        return d;
    };
    TreemapNodeFrame.c = function (a, b) {
        var c = new Rect(0, 0, 0, 0, 0);
        var d = new TreemapNodeFrame();
        d.e = b.e;
        d.s = b.s;
        d.r = b.r;
        var e = b.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, c.left + (e.left - c.left) * a, c.top + (e.top - c.top) * a, c.width + (e.width - c.width) * a, c.height + (e.height - c.height) * a);
        d.u = BrushUtil.k(null, a, b.u, 0);
        d.x = BrushUtil.k(null, a, b.x, 0);
        d.v = BrushUtil.k(null, a, b.v, 0);
        d.w = BrushUtil.k(null, a, b.w, 0);
        d.q = 0 + (b.q - 0) * a;
        d.i = 0 + (b.i - 0) * a;
        d.k = 0 + (b.k - 0) * a;
        d.j = 0 + (b.j - 0) * a;
        d.h = 0 + (b.h - 0) * a;
        d.n = 0 + (b.n - 0) * a;
        d.p = 0 + (b.p - 0) * a;
        d.o = 0 + (b.o - 0) * a;
        d.m = 0 + (b.m - 0) * a;
        d.l = 0 + (b.l - 0) * a;
        d.g = 0 + (b.g - 0) * a;
        d.t = b.t;
        d.z = b.z;
        d.a = b.a;
        return d;
    };
    TreemapNodeFrame.$t = markType(TreemapNodeFrame, 'TreemapNodeFrame');
    return TreemapNodeFrame;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a style to apply to a treemap node.
*/
var IgrTreemapNodeStyle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTreemapNodeStyle, _super);
    function IgrTreemapNodeStyle(props) {
        var _this = _super.call(this, props) || this;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        return _this;
    }
    IgrTreemapNodeStyle.prototype.createImplementation = function () {
        return new TreemapNodeStyle();
    };
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrTreemapNodeStyle._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrTreemapNodeStyle.prototype.onImplementationCreated = function () {
    };
    IgrTreemapNodeStyle.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrTreemapNodeStyle.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrTreemapNodeStyle.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerHoverBackground", {
        /**
         * Gets or sets the background to use for the header when it is hovered.
        */
        get: function () {
            return brushToString(this.i.a7);
        },
        set: function (v) {
            this.i.a7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerBackground", {
        /**
         * Gets or sets the background to use for the header.
        */
        get: function () {
            return brushToString(this.i.a6);
        },
        set: function (v) {
            this.i.a6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerTextColor", {
        /**
         * Gets or sets the text color to use for the header.
        */
        get: function () {
            return brushToString(this.i.a9);
        },
        set: function (v) {
            this.i.a9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "label", {
        /**
         * Gets or sets the label to use for the node.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "textColor", {
        /**
         * Gets or sets the text color to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.bb);
        },
        set: function (v) {
            this.i.bb = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerHoverTextColor", {
        /**
         * Gets or sets the text color to use for the header.
        */
        get: function () {
            return brushToString(this.i.a8);
        },
        set: function (v) {
            this.i.a8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerLabelLeftMargin", {
        /**
         * Gets or sets the left margin to use for the header.
        */
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerLabelTopMargin", {
        /**
         * Gets or sets the top margin to use for the header.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerLabelRightMargin", {
        /**
         * Gets or sets the right margin to use for the header.
        */
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerLabelBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the labels.
        */
        get: function () {
            return this.i.o;
        },
        set: function (v) {
            this.i.o = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelLeftMargin", {
        /**
         * Gets or sets the left margin to use for the labels.
        */
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelTopMargin", {
        /**
         * Gets or sets the top margin to use for the labels.
        */
        get: function () {
            return this.i.v;
        },
        set: function (v) {
            this.i.v = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelRightMargin", {
        /**
         * Gets or sets the right margin to use for the labels.
        */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the labels.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "headerHeight", {
        /**
         * Gets or sets the height to use for the header.
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment to use for the node labels.
        */
        get: function () {
            return this.i.ax;
        },
        set: function (v) {
            this.i.ax = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "labelVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment to use for the node labels.
        */
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "fill", {
        /**
         * Gets or sets the fill color to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.a5);
        },
        set: function (v) {
            this.i.a5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "outline", {
        /**
         * Gets or sets the outline to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.ba);
        },
        set: function (v) {
            this.i.ba = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "strokeThickness", {
        /**
         * Gets or sets the stroke thickness to use for the node outline.
        */
        get: function () {
            return this.i.w;
        },
        set: function (v) {
            this.i.w = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyle.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemapNodeStyle.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrTreemapNodeStyle.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TreemapNodeStyle");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    return IgrTreemapNodeStyle;
}(Component));

/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
var IgrTreemapNodeStyleMapping = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTreemapNodeStyleMapping, _super);
    function IgrTreemapNodeStyleMapping(props) {
        return _super.call(this, props) || this;
    }
    IgrTreemapNodeStyleMapping.prototype.createImplementation = function () {
        return new TreemapNodeStyleMapping();
    };
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "targetType", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "name", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "value", {
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get: function () {
            return this.i.bn;
        },
        set: function (v) {
            this.i.bn = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "mappingMode", {
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = ensureEnum(TreemapValueMappingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemapNodeStyleMapping;
}(IgrTreemapNodeStyle));

var IgrTreemapNodeStyleMappingCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTreemapNodeStyleMappingCollection, _super);
    function IgrTreemapNodeStyleMappingCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgrTreemapNodeStyleMapping.$type) {
            IgrTreemapNodeStyleMapping.$type = markType(IgrTreemapNodeStyleMapping, "IgrTreemapNodeStyleMapping");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgrTreemapNodeStyleMappingCollection.prototype._createInnerColl = function () {
        if (!IgrTreemapNodeStyleMapping.$type) {
            IgrTreemapNodeStyleMapping.$type = markType(IgrTreemapNodeStyleMapping, "IgrTreemapNodeStyleMapping");
        }
        var coll = new SyncableObservableCollection$2(IgrTreemapNodeStyleMapping.$type, TreemapNodeStyleMapping.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new IgrTreemapNodeStyleMapping(null);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgrTreemapNodeStyleMappingCollection;
}(IgCollection));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgrTreemapNodeStylingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrTreemapNodeStylingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrTreemapNodeStylingEventArgs.prototype.createImplementation = function () {
        return new TreemapNodeStylingEventArgs();
    };
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemapNodeStylingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrTreemapNodeStylingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "sum", {
        get: function () {
            return this.i.sum;
        },
        set: function (v) {
            this.i.sum = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "customValue", {
        get: function () {
            return this.i.customValue;
        },
        set: function (v) {
            this.i.customValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "parentItem", {
        get: function () {
            return this.i.parentItem;
        },
        set: function (v) {
            this.i.parentItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "label", {
        get: function () {
            return this.i.label;
        },
        set: function (v) {
            this.i.label = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "parentValue", {
        get: function () {
            return this.i.parentValue;
        },
        set: function (v) {
            this.i.parentValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "parentLabel", {
        get: function () {
            return this.i.parentLabel;
        },
        set: function (v) {
            this.i.parentLabel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "parentSum", {
        get: function () {
            return this.i.parentSum;
        },
        set: function (v) {
            this.i.parentSum = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "isParent", {
        get: function () {
            return this.i.isParent;
        },
        set: function (v) {
            this.i.isParent = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStylingEventArgs.prototype, "style", {
        get: function () {
            if (this.i.style == null) {
                return null;
            }
            if (!this.i.style.externalObject) {
                var e = IgrTreemapNodeStyle._createFromInternal(this.i.style);
                if (e) {
                    e._implementation = this.i.style;
                }
                this.i.style.externalObject = e;
            }
            return this.i.style.externalObject;
        },
        set: function (v) {
            v == null ? this.i.style = null : this.i.style = v.i;
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemapNodeStylingEventArgs;
}());

var IgrTreemapNodePointerEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrTreemapNodePointerEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrTreemapNodePointerEventArgs.prototype.createImplementation = function () {
        return new TreemapNodePointerEventArgs();
    };
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemapNodePointerEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrTreemapNodePointerEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "sum", {
        get: function () {
            return this.i.sum;
        },
        set: function (v) {
            this.i.sum = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "customValue", {
        get: function () {
            return this.i.customValue;
        },
        set: function (v) {
            this.i.customValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "parentItem", {
        get: function () {
            return this.i.parentItem;
        },
        set: function (v) {
            this.i.parentItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "position", {
        get: function () {
            return fromPoint(this.i.position);
        },
        set: function (v) {
            this.i.position = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "isRightButton", {
        get: function () {
            return this.i.isRightButton;
        },
        set: function (v) {
            this.i.isRightButton = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "isHandled", {
        get: function () {
            return this.i.isHandled;
        },
        set: function (v) {
            this.i.isHandled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "isOverHeader", {
        get: function () {
            return this.i.isOverHeader;
        },
        set: function (v) {
            this.i.isOverHeader = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "label", {
        get: function () {
            return this.i.label;
        },
        set: function (v) {
            this.i.label = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "parentValue", {
        get: function () {
            return this.i.parentValue;
        },
        set: function (v) {
            this.i.parentValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "parentLabel", {
        get: function () {
            return this.i.parentLabel;
        },
        set: function (v) {
            this.i.parentLabel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodePointerEventArgs.prototype, "parentSum", {
        get: function () {
            return this.i.parentSum;
        },
        set: function (v) {
            this.i.parentSum = +v;
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemapNodePointerEventArgs;
}());

var IgrTreemap = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTreemap, _super);
    function IgrTreemap(props) {
        var _this = _super.call(this, props) || this;
        _this._wrapper = null;
        _this.contentStyleMappings = [];
        /**
        * The style mappings actually present in the treemap. Do not directly modify this array.
        * This array's contents can be modified by causing React to reproject the child content.
        * Or adding and removing ranges from the manual ranges collection on the ranges property.
        */
        _this.actualStyleMappings = [];
        _this._styleMappings = null;
        _this._styleMappingsAdapter = null;
        _this._implementation = null;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._nodeStyling = null;
        _this._nodeStyling_wrapped = null;
        _this._nodePointerOver = null;
        _this._nodePointerOver_wrapped = null;
        _this._nodePointerEnter = null;
        _this._nodePointerEnter_wrapped = null;
        _this._nodePointerLeave = null;
        _this._nodePointerLeave_wrapped = null;
        _this._nodePointerPressed = null;
        _this._nodePointerPressed_wrapped = null;
        _this._nodePointerReleased = null;
        _this._nodePointerReleased_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._contentChildrenManager = new ContentChildrenManager(function (ch) { return ch.key || ch.props.name; }, function (ch) { return ch.key || ch.props.name; }, function () { return _this._updateContentChildren(); });
        _this._implementation = _this.createImplementation();
        if (document) {
            _this._container = document.createElement("div");
            _this._container.style.display = "block";
            _this._container.style.width = "100%";
            _this._container.style.height = "100%";
        }
        var root;
        root = _this._container;
        if (_this._container != null) {
            root = _this._container;
        }
        var ren = new ReactRenderer(root, document, true, DataChartStylingDefaults);
        _this._wrapper = ren;
        var treemap = _this.i;
        _this._treeMap = treemap;
        _this._styleMappingsAdapter = new CollectionAdapter(_this.contentStyleMappings, _this.i.styleMappings, _this.actualStyleMappings, function (c) { return c.i; }, function (i) {
            if (_this._container && _this._container.parentElement) {
                i._styling(_this._container, _this, _this);
            }
        }, function (i) { });
        treemap.provideContainer(ren);
        treemap.notifySizeChanged();
        if (props) {
            _this.initializeProperties();
        }
        ren.addSizeWatcher(function () {
            _this._treeMap.notifySizeChanged();
        });
        return _this;
    }
    Object.defineProperty(IgrTreemap.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._treeMap.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this._treeMap.notifySizeChanged();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemap.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrTreemap.prototype._updateContentChildren = function () {
        this.contentStyleMappings.length = 0;
        var contentChildrenActual = this._contentChildrenManager.contentChildrenActual;
        for (var i = 0; i < contentChildrenActual.length; i++) {
            if ((TreemapNodeStyleMapping.$type).isAssignableFrom(contentChildrenActual[i].i.$type)) {
                this.contentStyleMappings.push(contentChildrenActual[i]);
            }
        }
        if (this._styleMappingsAdapter !== null) {
            this._styleMappingsAdapter.notifyContentChanged();
        }
    };
    Object.defineProperty(IgrTreemap.prototype, "styleMappings", {
        /**
         * A collection of manually added style mappings for the treemap.
        */
        get: function () {
            var _this = this;
            if (this._styleMappings === null) {
                var coll = new IgrTreemapNodeStyleMappingCollection();
                var inner = coll._innerColl;
                inner.addListener(function (sender, e) {
                    switch (e.action) {
                        case NotifyCollectionChangedAction.Add:
                            _this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Remove:
                            _this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                            break;
                        case NotifyCollectionChangedAction.Replace:
                            _this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                            _this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                            break;
                        case NotifyCollectionChangedAction.Reset:
                            _this._styleMappingsAdapter.clearManualItems();
                            break;
                    }
                });
                this._styleMappings = coll;
            }
            return this._styleMappings;
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemap.prototype.render = function () {
        var children = this._contentChildrenManager.getChildren(this.props.children);
        var div = createElement("div", {
            className: "ig-treemap igr-treemap",
            ref: this._getMainRef,
            children: children
        });
        //}
        return div;
    };
    IgrTreemap.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_1, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return true;
    };
    IgrTreemap.prototype.initializeProperties = function () {
        var e_2, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    // supports angular themes or custom properties set in CSS
    IgrTreemap.prototype.updateStyle = function () {
        this._styling(this._elRef, this);
    };
    IgrTreemap.prototype.componentWillUnmount = function () {
        this._treeMap.destroy();
        this._wrapper.destroy();
    };
    IgrTreemap.prototype.componentDidMount = function () {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container);
        this._treeMap.notifySizeChanged();
        this.initializeContent();
    };
    IgrTreemap.prototype.initializeContent = function () {
        this._styling(this._container, this);
        if (this.actualStyleMappings && this.actualStyleMappings.length > 0) {
            var currStyleMapping = this.actualStyleMappings;
            for (var i = 0; i < currStyleMapping.length; i++) {
                currStyleMapping[i]._styling(this._container, this, this);
            }
        }
        this._updateContentChildren();
        this.updateStyle();
        this.i.notifySizeChanged();
    };
    IgrTreemap.prototype.createImplementation = function () {
        return new Treemap();
    };
    Object.defineProperty(IgrTreemap.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "valueMemberPath", {
        /**
     * Gets or sets path to use to get the values from the items.
    */
        get: function () {
            return this.i.gi;
        },
        set: function (v) {
            this.i.gi = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "rootTitle", {
        /**
         * Gets or sets the root title to use for breadcrumbs.
        */
        get: function () {
            return this.i.f8;
        },
        set: function (v) {
            this.i.f8 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "breadcrumbSequence", {
        /**
         * Gets or sets the root title to use for breadcrumbs.
        */
        get: function () {
            return this.i.ed;
        },
        set: function (v) {
            this.i.ed = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentIdMemberPath", {
        /**
         * Gets or sets the path to use to get the Parent of the items.
        */
        get: function () {
            return this.i.fw;
        },
        set: function (v) {
            this.i.fw = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelMemberPath", {
        /**
         * Gets or sets the path to use to get the Label of the items.
        */
        get: function () {
            return this.i.ff;
        },
        set: function (v) {
            this.i.ff = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "customValueMemberPath", {
        /**
         * Gets or sets the path to use to get the custom value of the items.
        */
        get: function () {
            return this.i.eg;
        },
        set: function (v) {
            this.i.eg = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "idMemberPath", {
        /**
         * Gets or sets the path to use to get the id of the items.
        */
        get: function () {
            return this.i.e5;
        },
        set: function (v) {
            this.i.e5 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "dataSource", {
        /**
         * Gets or sets the (possibly hierarchical) data to assign to the TreeMap.
        */
        get: function () {
            return this.i.dataSource;
        },
        set: function (v) {
            this.i.dataSource = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "fillBrushes", {
        /**
         * Gets or sets brushes to use for the fill scale.
        */
        get: function () {
            return fromBrushCollection(this.i.b);
        },
        set: function (v) {
            this.i.b = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "fillScaleMode", {
        /**
         * Gets or sets mode to use for the fill scale.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureEnum(TreemapFillScaleMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "isFillScaleLogarithmic", {
        /**
         * Gets or sets whether the fill scale is logarithmic.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "fillScaleLogarithmBase", {
        /**
         * Gets or sets the logarithm base to use if the fill scale is logarithmic.
        */
        get: function () {
            return this.i.dy;
        },
        set: function (v) {
            this.i.dy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "fillScaleMinimumValue", {
        /**
         * Gets or sets the minimum value to use for the fill scale.
        */
        get: function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "fillScaleMaximumValue", {
        /**
         * Gets or sets the maximum value to use for the fill scale.
        */
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelVerticalFitMode", {
        /**
         * Gets or sets the vertical fit mode to use for the node labels.
        */
        get: function () {
            return this.i.p;
        },
        set: function (v) {
            this.i.p = ensureEnum(TreemapLabelVerticalFitMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelHorizontalFitMode", {
        /**
         * Gets or sets the horizontal fit mode to use for the node labels.
        */
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = ensureEnum(TreemapLabelHorizontalFitMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderHoverBackground", {
        /**
         * Gets or sets the background to use for the overlay header when it is hovered.
        */
        get: function () {
            return brushToString(this.i.h8);
        },
        set: function (v) {
            this.i.h8 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerHoverBackground", {
        /**
         * Gets or sets the background to use for the header when it is hovered.
        */
        get: function () {
            return brushToString(this.i.h2);
        },
        set: function (v) {
            this.i.h2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerBackground", {
        /**
         * Gets or sets the background to use for the header.
        */
        get: function () {
            return brushToString(this.i.h0);
        },
        set: function (v) {
            this.i.h0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderBackground", {
        /**
         * Gets or sets the background to use for the overlay header.
        */
        get: function () {
            return brushToString(this.i.h7);
        },
        set: function (v) {
            this.i.h7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerTextColor", {
        /**
         * Gets or sets the text color to use for the header.
        */
        get: function () {
            return brushToString(this.i.h5);
        },
        set: function (v) {
            this.i.h5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerDarkTextColor", {
        /**
         * Gets or sets the dark text color to use for the header.
        */
        get: function () {
            return brushToString(this.i.h1);
        },
        set: function (v) {
            this.i.h1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "textColor", {
        /**
         * Gets or sets the text color to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.ij);
        },
        set: function (v) {
            this.i.ij = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "darkTextColor", {
        /**
         * Gets or sets the dark text color to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.hz);
        },
        set: function (v) {
            this.i.hz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerHoverTextColor", {
        /**
         * Gets or sets the text color to use for the header.
        */
        get: function () {
            return brushToString(this.i.h4);
        },
        set: function (v) {
            this.i.h4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerHoverDarkTextColor", {
        /**
         * Gets or sets the dark text color to use for the header when hovered.
        */
        get: function () {
            return brushToString(this.i.h3);
        },
        set: function (v) {
            this.i.h3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "textStyle", {
        /**
         * Gets or sets the font to use for content nodes
        */
        get: function () {
            if (this.i.aw == null) {
                return null;
            }
            return this.i.aw.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.aw = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerTextStyle", {
        /**
         * Gets or sets the font to use for header nodes
        */
        get: function () {
            if (this.i.au == null) {
                return null;
            }
            return this.i.au.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.au = fi;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerDisplayMode", {
        /**
         * Gets or sets the font to use for header nodes
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = ensureEnum(TreemapHeaderDisplayMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerLabelLeftMargin", {
        /**
         * Gets or sets the left margin to use for the header.
        */
        get: function () {
            return this.i.cx;
        },
        set: function (v) {
            this.i.cx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerLabelTopMargin", {
        /**
         * Gets or sets the top margin to use for the header.
        */
        get: function () {
            return this.i.cz;
        },
        set: function (v) {
            this.i.cz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerLabelRightMargin", {
        /**
         * Gets or sets the right margin to use for the header.
        */
        get: function () {
            return this.i.cy;
        },
        set: function (v) {
            this.i.cy = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerLabelBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the header.
        */
        get: function () {
            return this.i.cw;
        },
        set: function (v) {
            this.i.cw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderLabelLeftMargin", {
        /**
         * Gets or sets the left margin to use for the overlay header.
        */
        get: function () {
            return this.i.c7;
        },
        set: function (v) {
            this.i.c7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderLabelTopMargin", {
        /**
         * Gets or sets the top margin to use for the overlay header.
        */
        get: function () {
            return this.i.c9;
        },
        set: function (v) {
            this.i.c9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderLabelRightMargin", {
        /**
         * Gets or sets the right margin to use for the overlay header.
        */
        get: function () {
            return this.i.c8;
        },
        set: function (v) {
            this.i.c8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "overlayHeaderLabelBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the overlay header.
        */
        get: function () {
            return this.i.c6;
        },
        set: function (v) {
            this.i.c6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelLeftMargin", {
        /**
         * Gets or sets the left margin to use for the labels.
        */
        get: function () {
            return this.i.c2;
        },
        set: function (v) {
            this.i.c2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelTopMargin", {
        /**
         * Gets or sets the top margin to use for the labels.
        */
        get: function () {
            return this.i.c4;
        },
        set: function (v) {
            this.i.c4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelRightMargin", {
        /**
         * Gets or sets the right margin to use for the labels.
        */
        get: function () {
            return this.i.c3;
        },
        set: function (v) {
            this.i.c3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the labels.
        */
        get: function () {
            return this.i.c1;
        },
        set: function (v) {
            this.i.c1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeLeftMargin", {
        /**
         * Gets or sets the left margin to use for the parent nodes.
        */
        get: function () {
            return this.i.dc;
        },
        set: function (v) {
            this.i.dc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeTopMargin", {
        /**
         * Gets or sets the top margin to use for the parent nodes.
        */
        get: function () {
            return this.i.dg;
        },
        set: function (v) {
            this.i.dg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeRightMargin", {
        /**
         * Gets or sets the right margin to use for the parent nodes.
        */
        get: function () {
            return this.i.de;
        },
        set: function (v) {
            this.i.de = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeBottomMargin", {
        /**
         * Gets or sets the bottom margin to use for the parent nodes.
        */
        get: function () {
            return this.i.da;
        },
        set: function (v) {
            this.i.da = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeLeftPadding", {
        /**
         * Gets or sets the left padding to use for the parent nodes.
        */
        get: function () {
            return this.i.dd;
        },
        set: function (v) {
            this.i.dd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeTopPadding", {
        /**
         * Gets or sets the top padding to use for the parent nodes.
        */
        get: function () {
            return this.i.dh;
        },
        set: function (v) {
            this.i.dh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeRightPadding", {
        /**
         * Gets or sets the right padding to use for the parent nodes.
        */
        get: function () {
            return this.i.df;
        },
        set: function (v) {
            this.i.df = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "parentNodeBottomPadding", {
        /**
         * Gets or sets the bottom padding to use for the parent nodes.
        */
        get: function () {
            return this.i.db;
        },
        set: function (v) {
            this.i.db = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment to use for the node labels.
        */
        get: function () {
            return this.i.hm;
        },
        set: function (v) {
            this.i.hm = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "labelVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment to use for the node labels.
        */
        get: function () {
            return this.i.iq;
        },
        set: function (v) {
            this.i.iq = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "headerHeight", {
        /**
         * Gets or sets the height to use for the header.
        */
        get: function () {
            return this.i.cv;
        },
        set: function (v) {
            this.i.cv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "outline", {
        /**
         * Gets or sets the outline to use for the nodes.
        */
        get: function () {
            return brushToString(this.i.h6);
        },
        set: function (v) {
            this.i.h6 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "strokeThickness", {
        /**
         * Gets or sets the stroke thickness to use for the node outline.
        */
        get: function () {
            return this.i.dt;
        },
        set: function (v) {
            this.i.dt = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "layoutOrientation", {
        /**
         * Gets or sets the orientation to use for the stripped and slice and dice layout types.
        */
        get: function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = ensureEnum(TreemapOrientation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "layoutType", {
        /**
         * Gets or sets the type of layout to use for the nodes.
        */
        get: function () {
            return this.i.s;
        },
        set: function (v) {
            this.i.s = ensureEnum(TreemapLayoutType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "minimumDisplaySize", {
        /**
         * Gets or sets the minimum size (width or height) to display a node.
        */
        get: function () {
            return this.i.c5;
        },
        set: function (v) {
            this.i.c5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "transitionDuration", {
        /**
         * Gets or sets the number of milliseconds over which changes to the gauge should be animated.
        */
        get: function () {
            return this.i.d1;
        },
        set: function (v) {
            this.i.d1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.di;
        },
        set: function (v) {
            this.i.di = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "actualPixelScalingRatio", {
        get: function () {
            return this.i.cp;
        },
        set: function (v) {
            this.i.cp = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "interactionPixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control while it is animating.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.c0;
        },
        set: function (v) {
            this.i.c0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "actualInteractionPixelScalingRatio", {
        /**
         * Gets or sets the resolved scaling value used to affect the pixel density of the control while it is animating.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "animating", {
        get: function () {
            return this.i.bc;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "focusItem", {
        /**
         * Gets or sets the item to drill to in the treemap.
        */
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrTreemap.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrTreemap.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Treemap");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Returns visuals as a serialized string.

*/
    IgrTreemap.prototype.exportSerializedVisualData = function () {
        var iv = this.i.ej();
        return (iv);
    };
    IgrTreemap.prototype.markDirty = function () {
        this.i.gt();
    };
    IgrTreemap.prototype.onDetachedFromUI = function () {
        this.i.onDetachedFromUI();
    };
    IgrTreemap.prototype.onAttachedToUI = function () {
        this.i.onAttachedToUI();
    };
    IgrTreemap.prototype.flush = function () {
        this.i.gr();
    };
    IgrTreemap.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.gx(source_, index, oldItem, newItem);
    };
    /**
     * Manually notifies the treemap's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the pie chart is bound to is already observable.
    
    * @param source_  * The data source.
    */
    IgrTreemap.prototype.notifyClearItems = function (source_) {
        this.i.gu(source_);
    };
    IgrTreemap.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.gv(source_, index, newItem);
    };
    IgrTreemap.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.gw(source_, index, oldItem);
    };
    Object.defineProperty(IgrTreemap.prototype, "nodeStyling", {
        /**
         * Fired when a node is being styled. Provides an opportunity to customize node styling.
        */
        get: function () {
            return this._nodeStyling;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodeStyling_wrapped !== null) {
                this.i.nodeStyling = delegateRemove(this.i.nodeStyling, this._nodeStyling_wrapped);
                this._nodeStyling_wrapped = null;
                this._nodeStyling = null;
            }
            this._nodeStyling = ev;
            this._nodeStyling_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodeStylingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodeStyling) {
                    _this.beforeNodeStyling(_this, outerArgs);
                }
                if (_this._nodeStyling) {
                    _this._nodeStyling(_this, outerArgs);
                }
            };
            this.i.nodeStyling = delegateCombine(this.i.nodeStyling, this._nodeStyling_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "nodePointerOver", {
        /**
         * Fired with the pointer is moving over a node.
        */
        get: function () {
            return this._nodePointerOver;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodePointerOver_wrapped !== null) {
                this.i.nodePointerOver = delegateRemove(this.i.nodePointerOver, this._nodePointerOver_wrapped);
                this._nodePointerOver_wrapped = null;
                this._nodePointerOver = null;
            }
            this._nodePointerOver = ev;
            this._nodePointerOver_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodePointerOver) {
                    _this.beforeNodePointerOver(_this, outerArgs);
                }
                if (_this._nodePointerOver) {
                    _this._nodePointerOver(_this, outerArgs);
                }
            };
            this.i.nodePointerOver = delegateCombine(this.i.nodePointerOver, this._nodePointerOver_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "nodePointerEnter", {
        /**
         * Fired when the pointer enters a node.
        */
        get: function () {
            return this._nodePointerEnter;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodePointerEnter_wrapped !== null) {
                this.i.nodePointerEnter = delegateRemove(this.i.nodePointerEnter, this._nodePointerEnter_wrapped);
                this._nodePointerEnter_wrapped = null;
                this._nodePointerEnter = null;
            }
            this._nodePointerEnter = ev;
            this._nodePointerEnter_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodePointerEnter) {
                    _this.beforeNodePointerEnter(_this, outerArgs);
                }
                if (_this._nodePointerEnter) {
                    _this._nodePointerEnter(_this, outerArgs);
                }
            };
            this.i.nodePointerEnter = delegateCombine(this.i.nodePointerEnter, this._nodePointerEnter_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "nodePointerLeave", {
        /**
         * Fired when the pointer leaved a node.
        */
        get: function () {
            return this._nodePointerLeave;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodePointerLeave_wrapped !== null) {
                this.i.nodePointerLeave = delegateRemove(this.i.nodePointerLeave, this._nodePointerLeave_wrapped);
                this._nodePointerLeave_wrapped = null;
                this._nodePointerLeave = null;
            }
            this._nodePointerLeave = ev;
            this._nodePointerLeave_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodePointerLeave) {
                    _this.beforeNodePointerLeave(_this, outerArgs);
                }
                if (_this._nodePointerLeave) {
                    _this._nodePointerLeave(_this, outerArgs);
                }
            };
            this.i.nodePointerLeave = delegateCombine(this.i.nodePointerLeave, this._nodePointerLeave_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "nodePointerPressed", {
        /**
         * Fired when the pointer is pressed on a node.
        */
        get: function () {
            return this._nodePointerPressed;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodePointerPressed_wrapped !== null) {
                this.i.nodePointerPressed = delegateRemove(this.i.nodePointerPressed, this._nodePointerPressed_wrapped);
                this._nodePointerPressed_wrapped = null;
                this._nodePointerPressed = null;
            }
            this._nodePointerPressed = ev;
            this._nodePointerPressed_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodePointerPressed) {
                    _this.beforeNodePointerPressed(_this, outerArgs);
                }
                if (_this._nodePointerPressed) {
                    _this._nodePointerPressed(_this, outerArgs);
                }
            };
            this.i.nodePointerPressed = delegateCombine(this.i.nodePointerPressed, this._nodePointerPressed_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemap.prototype, "nodePointerReleased", {
        /**
         * Fired when the pointer is released on a node.
        */
        get: function () {
            return this._nodePointerReleased;
        },
        set: function (ev) {
            var _this = this;
            if (this._nodePointerReleased_wrapped !== null) {
                this.i.nodePointerReleased = delegateRemove(this.i.nodePointerReleased, this._nodePointerReleased_wrapped);
                this._nodePointerReleased_wrapped = null;
                this._nodePointerReleased = null;
            }
            this._nodePointerReleased = ev;
            this._nodePointerReleased_wrapped = function (o, e) {
                var outerArgs = new IgrTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeNodePointerReleased) {
                    _this.beforeNodePointerReleased(_this, outerArgs);
                }
                if (_this._nodePointerReleased) {
                    _this._nodePointerReleased(_this, outerArgs);
                }
            };
            this.i.nodePointerReleased = delegateCombine(this.i.nodePointerReleased, this._nodePointerReleased_wrapped);
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemap;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTreemapNodeStyleModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTreemapNodeStyleModule() {
    }
    IgrTreemapNodeStyleModule.register = function () {
        TypeRegistrar.registerCons("IgrTreemapNodeStyle", IgrTreemapNodeStyle);
        TypeRegistrar.register("TreemapNodeStyle", TreemapNodeStyle.$type);
    };
    return IgrTreemapNodeStyleModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTreemapNodeStyleMappingModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTreemapNodeStyleMappingModule() {
    }
    IgrTreemapNodeStyleMappingModule.register = function () {
        TypeRegistrar.registerCons("IgrTreemapNodeStyleMapping", IgrTreemapNodeStyleMapping);
        TypeRegistrar.register("TreemapNodeStyleMapping", TreemapNodeStyleMapping.$type);
    };
    return IgrTreemapNodeStyleMappingModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrTreemapModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrTreemapModule() {
    }
    IgrTreemapModule.register = function () {
        TypeRegistrar.registerCons('IgrTreemap', IgrTreemap);
        TypeRegistrar.registerCons('IgrTreemap', IgrTreemap);
        IgrTreemapNodeStyleModule.register();
        IgrTreemapNodeStyleMappingModule.register();
        TypeRegistrar.register('Treemap', Treemap.$type);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    };
    return IgrTreemapModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ServiceProvider_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ServiceProvider_Spark, _super);
    function ServiceProvider_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = DictionaryUtil.dictionaryCreate();
        return _this;
    }
    ServiceProvider_Spark.prototype.addService = function (a, b) {
        this.a.set(a, b);
    };
    ServiceProvider_Spark.prototype.getService = function (a) {
        return this.a.get(a);
    };
    ServiceProvider_Spark.$t = markType(ServiceProvider_Spark, 'ServiceProvider_Spark');
    return ServiceProvider_Spark;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Message_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Message_Spark, _super);
    function Message_Spark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Message_Spark.prototype.toString = function () {
        return getInstanceType(this).toString();
    };
    Message_Spark.$t = markType(Message_Spark, 'Message_Spark');
    return Message_Spark;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MessageChannel_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MessageChannel_Spark, _super);
    function MessageChannel_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = new Queue$1(Message_Spark.$);
        _this.messageSent = null;
        _this.a = null;
        return _this;
    }
    MessageChannel_Spark.prototype.sendMessage = function (a) {
        if (this.messageSent != null) {
            this.messageSent(a);
        }
        else {
            this.c.g(a);
        }
    };
    MessageChannel_Spark.prototype.attachTarget = function (a) {
        this.messageSent = delegateCombine(this.messageSent, a);
        while (this.c.count > 0) {
            var b = this.c.b();
            this.messageSent(b);
        }
    };
    MessageChannel_Spark.prototype.detachTarget = function (a) {
        this.messageSent = delegateRemove(this.messageSent, a);
    };
    MessageChannel_Spark.prototype.connectTo = function (a) {
        this.a = a;
        this.attachTarget(runOn(this, this.sendToNext));
    };
    MessageChannel_Spark.prototype.detachFromNext = function () {
        if (this.a == null) {
            return;
        }
        this.detachTarget(runOn(this, this.sendToNext));
        this.a = null;
    };
    MessageChannel_Spark.prototype.sendToNext = function (a) {
        if (this.a != null) {
            this.a.sendMessage(a);
        }
    };
    MessageChannel_Spark.prototype.toString = function () {
        return "MessageQueue";
    };
    MessageChannel_Spark.$t = markType(MessageChannel_Spark, 'MessageChannel_Spark');
    return MessageChannel_Spark;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var RenderingMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RenderingMessage_Spark, _super);
    function RenderingMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        return _this;
    }
    RenderingMessage_Spark.$t = markType(RenderingMessage_Spark, 'RenderingMessage_Spark', Message_Spark.$);
    return RenderingMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var AxisRenderMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(AxisRenderMessage_Spark, _super);
    function AxisRenderMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = false;
        return _this;
    }
    AxisRenderMessage_Spark.$t = markType(AxisRenderMessage_Spark, 'AxisRenderMessage_Spark', RenderingMessage_Spark.$);
    return AxisRenderMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ContainerResizedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContainerResizedMessage_Spark, _super);
    function ContainerResizedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = 0;
        _this.d = 0;
        _this.f = 0;
        _this.e = 0;
        _this.h = null;
        _this.i = null;
        _this.j = null;
        _this.k = null;
        _this.b = null;
        _this.c = null;
        return _this;
    }
    ContainerResizedMessage_Spark.$t = markType(ContainerResizedMessage_Spark, 'ContainerResizedMessage_Spark', Message_Spark.$);
    return ContainerResizedMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var InteractionMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(InteractionMessage_Spark, _super);
    function InteractionMessage_Spark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    InteractionMessage_Spark.$t = markType(InteractionMessage_Spark, 'InteractionMessage_Spark', Message_Spark.$);
    return InteractionMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ViewportChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ViewportChangedMessage_Spark, _super);
    function ViewportChangedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = 0;
        _this.c = 0;
        _this.e = 0;
        _this.b = 0;
        return _this;
    }
    Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newTop", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newLeft", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newWidth", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ViewportChangedMessage_Spark.prototype, "newHeight", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    ViewportChangedMessage_Spark.prototype.toString = function () {
        return "ViewportChangedMessage[" + this.newTop.toString() + ", " + this.newLeft.toString() + ", " + this.newWidth.toString() + ", " + this.newHeight.toString() + "]";
    };
    ViewportChangedMessage_Spark.$t = markType(ViewportChangedMessage_Spark, 'ViewportChangedMessage_Spark', InteractionMessage_Spark.$);
    return ViewportChangedMessage_Spark;
}(InteractionMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PixelRatioMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PixelRatioMessage_Spark, _super);
    function PixelRatioMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        return _this;
    }
    PixelRatioMessage_Spark.$t = markType(PixelRatioMessage_Spark, 'PixelRatioMessage_Spark', Message_Spark.$);
    return PixelRatioMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SparklineAxisVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparklineAxisVisualData, _super);
    function SparklineAxisVisualData() {
        var _this = _super.call(this) || this;
        _this._name = null;
        _this._minLabel = null;
        _this._maxLabel = null;
        _this._axisLine = null;
        return _this;
    }
    Object.defineProperty(SparklineAxisVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineAxisVisualData.prototype, "minLabel", {
        get: function () {
            return this._minLabel;
        },
        set: function (a) {
            this._minLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineAxisVisualData.prototype, "maxLabel", {
        get: function () {
            return this._maxLabel;
        },
        set: function (a) {
            this._maxLabel = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineAxisVisualData.prototype, "axisLine", {
        get: function () {
            return this._axisLine;
        },
        set: function (a) {
            this._axisLine = a;
        },
        enumerable: true,
        configurable: true
    });
    SparklineAxisVisualData.prototype.scaleByViewport = function (a) {
    };
    SparklineAxisVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\"");
        if (this.minLabel != null) {
            a.u(",");
            a.l("minLabel: " + this.minLabel.serialize());
        }
        if (this.maxLabel != null) {
            a.u(",");
            a.l("maxLabel: " + this.maxLabel.serialize());
        }
        if (this.axisLine != null) {
            a.u(",");
            a.l("axisLine: " + this.axisLine.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    };
    SparklineAxisVisualData.$t = markType(SparklineAxisVisualData, 'SparklineAxisVisualData');
    return SparklineAxisVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ClearMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ClearMessage_Spark, _super);
    function ClearMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = false;
        return _this;
    }
    ClearMessage_Spark.$t = markType(ClearMessage_Spark, 'ClearMessage_Spark', RenderingMessage_Spark.$);
    return ClearMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PolygonMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PolygonMessage_Spark, _super);
    function PolygonMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        return _this;
    }
    Object.defineProperty(PolygonMessage_Spark.prototype, "points", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    PolygonMessage_Spark.$t = markType(PolygonMessage_Spark, 'PolygonMessage_Spark', RenderingMessage_Spark.$);
    return PolygonMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ColumnMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ColumnMessage_Spark, _super);
    function ColumnMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.g = null;
        _this.k = null;
        _this.l = null;
        _this.f = null;
        _this.e = null;
        _this.i = 0;
        _this.h = 0;
        _this.j = 0;
        _this.c = 0;
        return _this;
    }
    ColumnMessage_Spark.$t = markType(ColumnMessage_Spark, 'ColumnMessage_Spark', RenderingMessage_Spark.$);
    return ColumnMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var WinLossColumnMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(WinLossColumnMessage_Spark, _super);
    function WinLossColumnMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = null;
        _this.g = null;
        _this.k = null;
        _this.l = null;
        _this.f = null;
        _this.e = null;
        _this.i = 0;
        _this.h = 0;
        _this.j = 0;
        _this.c = 0;
        return _this;
    }
    WinLossColumnMessage_Spark.$t = markType(WinLossColumnMessage_Spark, 'WinLossColumnMessage_Spark', RenderingMessage_Spark.$);
    return WinLossColumnMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MarkerMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MarkerMessage_Spark, _super);
    function MarkerMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.e = null;
        _this.f = null;
        _this.m = null;
        _this.n = null;
        _this.d = null;
        _this.c = null;
        _this.k = 0;
        _this.g = 0;
        _this.i = 0;
        _this.h = 0;
        _this.j = 0;
        _this.l = 0;
        return _this;
    }
    MarkerMessage_Spark.$t = markType(MarkerMessage_Spark, 'MarkerMessage_Spark', RenderingMessage_Spark.$);
    return MarkerMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NormalRangeMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NormalRangeMessage_Spark, _super);
    function NormalRangeMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = 0;
        _this.h = 0;
        _this.f = 0;
        _this.e = 0;
        _this.c = false;
        return _this;
    }
    Object.defineProperty(NormalRangeMessage_Spark.prototype, "k", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NormalRangeMessage_Spark.prototype, "l", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NormalRangeMessage_Spark.prototype, "j", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NormalRangeMessage_Spark.prototype, "i", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NormalRangeMessage_Spark.prototype, "d", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    NormalRangeMessage_Spark.$t = markType(NormalRangeMessage_Spark, 'NormalRangeMessage_Spark', RenderingMessage_Spark.$);
    return NormalRangeMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrendLineMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TrendLineMessage_Spark, _super);
    function TrendLineMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        return _this;
    }
    Object.defineProperty(TrendLineMessage_Spark.prototype, "points", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    TrendLineMessage_Spark.$t = markType(TrendLineMessage_Spark, 'TrendLineMessage_Spark', RenderingMessage_Spark.$);
    return TrendLineMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TooltipMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TooltipMessage_Spark, _super);
    function TooltipMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 0;
        _this.d = 0;
        _this.g = null;
        return _this;
    }
    Object.defineProperty(TooltipMessage_Spark.prototype, "xOffset", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TooltipMessage_Spark.prototype, "yOffset", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TooltipMessage_Spark.prototype, "context", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: true,
        configurable: true
    });
    TooltipMessage_Spark.$t = markType(TooltipMessage_Spark, 'TooltipMessage_Spark', RenderingMessage_Spark.$);
    return TooltipMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ToooltipTemplateMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ToooltipTemplateMessage_Spark, _super);
    function ToooltipTemplateMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        return _this;
    }
    Object.defineProperty(ToooltipTemplateMessage_Spark.prototype, "template", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    ToooltipTemplateMessage_Spark.$t = markType(ToooltipTemplateMessage_Spark, 'ToooltipTemplateMessage_Spark', RenderingMessage_Spark.$);
    return ToooltipTemplateMessage_Spark;
}(RenderingMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ContainerMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContainerMessage_Spark, _super);
    function ContainerMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    ContainerMessage_Spark.$t = markType(ContainerMessage_Spark, 'ContainerMessage_Spark', Message_Spark.$);
    return ContainerMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var BrushChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BrushChangedMessage_Spark, _super);
    function BrushChangedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = null;
        _this.b = null;
        return _this;
    }
    BrushChangedMessage_Spark.$t = markType(BrushChangedMessage_Spark, 'BrushChangedMessage_Spark', Message_Spark.$);
    return BrushChangedMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var VisibilityMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VisibilityMessage_Spark, _super);
    function VisibilityMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 0;
        _this.b = null;
        return _this;
    }
    VisibilityMessage_Spark.$t = markType(VisibilityMessage_Spark, 'VisibilityMessage_Spark', Message_Spark.$);
    return VisibilityMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var NumberChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(NumberChangedMessage_Spark, _super);
    function NumberChangedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        _this.c = null;
        return _this;
    }
    NumberChangedMessage_Spark.$t = markType(NumberChangedMessage_Spark, 'NumberChangedMessage_Spark', Message_Spark.$);
    return NumberChangedMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ContainerSizeChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ContainerSizeChangedMessage_Spark, _super);
    function ContainerSizeChangedMessage_Spark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContainerSizeChangedMessage_Spark.$t = markType(ContainerSizeChangedMessage_Spark, 'ContainerSizeChangedMessage_Spark', InteractionMessage_Spark.$);
    return ContainerSizeChangedMessage_Spark;
}(InteractionMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MouseMoveMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MouseMoveMessage_Spark, _super);
    function MouseMoveMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        return _this;
    }
    Object.defineProperty(MouseMoveMessage_Spark.prototype, "position", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    MouseMoveMessage_Spark.$t = markType(MouseMoveMessage_Spark, 'MouseMoveMessage_Spark', InteractionMessage_Spark.$);
    return MouseMoveMessage_Spark;
}(InteractionMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MouseLeaveMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MouseLeaveMessage_Spark, _super);
    function MouseLeaveMessage_Spark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MouseLeaveMessage_Spark.$t = markType(MouseLeaveMessage_Spark, 'MouseLeaveMessage_Spark', InteractionMessage_Spark.$);
    return MouseLeaveMessage_Spark;
}(InteractionMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SparklineToolTipContext = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparklineToolTipContext, _super);
    function SparklineToolTipContext() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._high = 0;
        _this._low = 0;
        _this._first = 0;
        _this._last = 0;
        return _this;
    }
    Object.defineProperty(SparklineToolTipContext.prototype, "high", {
        get: function () {
            return this._high;
        },
        set: function (a) {
            this._high = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineToolTipContext.prototype, "low", {
        get: function () {
            return this._low;
        },
        set: function (a) {
            this._low = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineToolTipContext.prototype, "first", {
        get: function () {
            return this._first;
        },
        set: function (a) {
            this._first = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineToolTipContext.prototype, "last", {
        get: function () {
            return this._last;
        },
        set: function (a) {
            this._last = a;
        },
        enumerable: true,
        configurable: true
    });
    SparklineToolTipContext.$t = markType(SparklineToolTipContext, 'SparklineToolTipContext', EventArgs.$);
    return SparklineToolTipContext;
}(EventArgs));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SparklineVisualData = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparklineVisualData, _super);
    function SparklineVisualData() {
        var _this = _super.call(this) || this;
        _this._name = null;
        _this._horizontalAxis = null;
        _this._verticalAxis = null;
        _this._sparkPath = null;
        _this._negativeSparkPath = null;
        _this._trendLinePath = null;
        _this._rangePath = null;
        _this._markersPath = null;
        _this._negativeMarkersPath = null;
        _this._lowMarkersPath = null;
        _this._highMarkersPath = null;
        _this._firstMarkerPath = null;
        _this._lastMarkerPath = null;
        _this._viewport = null;
        _this._marginViewport = null;
        return _this;
    }
    Object.defineProperty(SparklineVisualData.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (a) {
            this._name = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "horizontalAxis", {
        get: function () {
            return this._horizontalAxis;
        },
        set: function (a) {
            this._horizontalAxis = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "verticalAxis", {
        get: function () {
            return this._verticalAxis;
        },
        set: function (a) {
            this._verticalAxis = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "sparkPath", {
        get: function () {
            return this._sparkPath;
        },
        set: function (a) {
            this._sparkPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "negativeSparkPath", {
        get: function () {
            return this._negativeSparkPath;
        },
        set: function (a) {
            this._negativeSparkPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "trendLinePath", {
        get: function () {
            return this._trendLinePath;
        },
        set: function (a) {
            this._trendLinePath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "rangePath", {
        get: function () {
            return this._rangePath;
        },
        set: function (a) {
            this._rangePath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "markersPath", {
        get: function () {
            return this._markersPath;
        },
        set: function (a) {
            this._markersPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "negativeMarkersPath", {
        get: function () {
            return this._negativeMarkersPath;
        },
        set: function (a) {
            this._negativeMarkersPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "lowMarkersPath", {
        get: function () {
            return this._lowMarkersPath;
        },
        set: function (a) {
            this._lowMarkersPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "highMarkersPath", {
        get: function () {
            return this._highMarkersPath;
        },
        set: function (a) {
            this._highMarkersPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "firstMarkerPath", {
        get: function () {
            return this._firstMarkerPath;
        },
        set: function (a) {
            this._firstMarkerPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "lastMarkerPath", {
        get: function () {
            return this._lastMarkerPath;
        },
        set: function (a) {
            this._lastMarkerPath = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "viewport", {
        get: function () {
            return this._viewport;
        },
        set: function (a) {
            this._viewport = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineVisualData.prototype, "marginViewport", {
        get: function () {
            return this._marginViewport;
        },
        set: function (a) {
            this._marginViewport = a;
        },
        enumerable: true,
        configurable: true
    });
    SparklineVisualData.prototype.scaleByViewport = function () {
        this.horizontalAxis.scaleByViewport(this.viewport);
        this.verticalAxis.scaleByViewport(this.viewport);
        if (this.sparkPath != null) {
            this.sparkPath.scaleByViewport(this.marginViewport);
        }
        if (this.negativeSparkPath != null) {
            this.negativeSparkPath.scaleByViewport(this.marginViewport);
        }
        if (this.trendLinePath != null) {
            this.trendLinePath.scaleByViewport(this.marginViewport);
        }
        if (this.rangePath != null) {
            this.rangePath.scaleByViewport(this.marginViewport);
        }
        if (this.markersPath != null) {
            this.markersPath.scaleByViewport(this.marginViewport);
        }
        if (this.negativeMarkersPath != null) {
            this.negativeMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.lowMarkersPath != null) {
            this.lowMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.highMarkersPath != null) {
            this.highMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.firstMarkerPath != null) {
            this.firstMarkerPath.scaleByViewport(this.marginViewport);
        }
        if (this.lastMarkerPath != null) {
            this.lastMarkerPath.scaleByViewport(this.marginViewport);
        }
    };
    SparklineVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\"");
        if (this.horizontalAxis != null) {
            a.u(",");
            a.l("horizontalAxis: " + this.horizontalAxis.serialize());
        }
        if (this.horizontalAxis != null) {
            a.u(",");
            a.l("verticalAxis: " + this.verticalAxis.serialize());
        }
        if (this.sparkPath != null) {
            a.u(",");
            a.l("sparkPath: " + this.sparkPath.serialize());
        }
        if (this.negativeSparkPath != null) {
            a.u(",");
            a.l("negativeSparkPath: " + this.negativeSparkPath.serialize());
        }
        if (this.trendLinePath != null) {
            a.u(",");
            a.l("trendLinePath: " + this.trendLinePath.serialize());
        }
        if (this.rangePath != null) {
            a.u(",");
            a.l("rangePath: " + this.rangePath.serialize());
        }
        if (this.markersPath != null) {
            a.u(",");
            a.l("markersPath: " + this.markersPath.serialize());
        }
        if (this.negativeMarkersPath != null) {
            a.u(",");
            a.l("negativeMarkersPath: " + this.negativeMarkersPath.serialize());
        }
        if (this.lowMarkersPath != null) {
            a.u(",");
            a.l("lowMarkersPath: " + this.lowMarkersPath.serialize());
        }
        if (this.highMarkersPath != null) {
            a.u(",");
            a.l("highMarkersPath: " + this.highMarkersPath.serialize());
        }
        if (this.firstMarkerPath != null) {
            a.u(",");
            a.l("firstMarkerPath: " + this.firstMarkerPath.serialize());
        }
        if (this.lastMarkerPath != null) {
            a.u(",");
            a.l("lastMarkerPath: " + this.lastMarkerPath.serialize());
        }
        if (this.viewport != null) {
            a.l(",");
            a.l("viewPort:" + this.viewport.serialize());
        }
        if (this.marginViewport != null) {
            a.l(",");
            a.l("marginViewPort:" + this.marginViewport.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    };
    SparklineVisualData.$t = markType(SparklineVisualData, 'SparklineVisualData');
    return SparklineVisualData;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents the type of sparkline
 */
var SparklineDisplayType = /*@__PURE__*/ (function (SparklineDisplayType) {
    /**
     * Display the sparkline as a line.
     */
    SparklineDisplayType[SparklineDisplayType["Line"] = 0] = "Line";
    /**
     * Display the sparkline as a filled polygon.
     */
    SparklineDisplayType[SparklineDisplayType["Area"] = 1] = "Area";
    /**
     * Display the sparkline as a set of columns.
     */
    SparklineDisplayType[SparklineDisplayType["Column"] = 2] = "Column";
    /**
     * Display the sparkline as a set of columns on a boolean scale.
     */
    SparklineDisplayType[SparklineDisplayType["WinLoss"] = 3] = "WinLoss";
    return SparklineDisplayType;
})({});
/**
 * @hidden
 */
var SparklineDisplayType_$type = /*@__PURE__*/ markEnum('SparklineDisplayType', 'Line,0|Area,1|Column,2|WinLoss,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SparkFrame = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparkFrame, _super);
    function SparkFrame() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = new List$1(Array_$type, 0);
        _this.f = new List$1(Point_$type, 0);
        _this.d = new List$1(Point_$type, 0);
        _this.e = new List$1(Point_$type, 0);
        _this.c = new List$1(Point_$type, 0);
        _this.b = new List$1(Point_$type, 0);
        _this.m = null;
        _this.n = null;
        return _this;
    }
    Object.defineProperty(SparkFrame.prototype, "g", {
        get: function () {
            return this.a;
        },
        set: function (a) {
            this.a = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparkFrame.prototype, "l", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparkFrame.prototype, "j", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparkFrame.prototype, "k", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparkFrame.prototype, "i", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparkFrame.prototype, "h", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    SparkFrame.$t = markType(SparkFrame, 'SparkFrame');
    return SparkFrame;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ConfigurationMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ConfigurationMessage_Spark, _super);
    function ConfigurationMessage_Spark() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ConfigurationMessage_Spark.$t = markType(ConfigurationMessage_Spark, 'ConfigurationMessage_Spark', Message_Spark.$);
    return ConfigurationMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var PropertyChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PropertyChangedMessage_Spark, _super);
    function PropertyChangedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.f = null;
        _this.c = null;
        _this.b = null;
        return _this;
    }
    Object.defineProperty(PropertyChangedMessage_Spark.prototype, "propertyName", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PropertyChangedMessage_Spark.prototype, "oldValue", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PropertyChangedMessage_Spark.prototype, "newValue", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: true,
        configurable: true
    });
    PropertyChangedMessage_Spark.prototype.toString = function () {
        var a = "null";
        var b = "null";
        if (this.oldValue != null) {
            a = this.oldValue.toString();
        }
        if (this.newValue != null) {
            b = this.newValue.toString();
        }
        return "PropertyChangedMessage[" + this.propertyName + ", " + a + ", " + b + "]";
    };
    PropertyChangedMessage_Spark.$t = markType(PropertyChangedMessage_Spark, 'PropertyChangedMessage_Spark', ConfigurationMessage_Spark.$);
    return PropertyChangedMessage_Spark;
}(ConfigurationMessage_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var DataChangedMessage_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DataChangedMessage_Spark, _super);
    function DataChangedMessage_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.c = 0;
        _this.e = null;
        _this.d = null;
        _this.b = 0;
        return _this;
    }
    DataChangedMessage_Spark.$t = markType(DataChangedMessage_Spark, 'DataChangedMessage_Spark', Message_Spark.$);
    return DataChangedMessage_Spark;
}(Message_Spark));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var HorizontalAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HorizontalAxisView, _super);
    function HorizontalAxisView(a) {
        var _this = _super.call(this) || this;
        _this.j = null;
        _this.w = null;
        _this.m = null;
        _this.l = null;
        _this.s = 0;
        _this.v = 0;
        _this.u = 0;
        _this.k = null;
        _this.r = -1;
        _this.ag = null;
        _this.af = null;
        _this.ah = null;
        _this.a = ["border-top-width", "border-top-color", "color"];
        _this.n = false;
        _this.q = 1;
        _this.g = null;
        _this.o = new Dictionary$2(Type.$, Delegate_$type, 0);
        _this.d = null;
        _this.c = null;
        _this.p.item(AxisRenderMessage_Spark.$, function (b) { return _this.ac(typeCast(AxisRenderMessage_Spark.$, b)); });
        _this.p.item(ContainerResizedMessage_Spark.$, function (b) { return _this.y(typeCast(ContainerResizedMessage_Spark.$, b)); });
        _this.p.item(ViewportChangedMessage_Spark.$, function (b) { return _this.ae(typeCast(ViewportChangedMessage_Spark.$, b)); });
        _this.p.item(PixelRatioMessage_Spark.$, function (b) { return _this.ab(typeCast(PixelRatioMessage_Spark.$, b)); });
        _this.j = a;
        return _this;
    }
    HorizontalAxisView.prototype.b = function () {
        if (!this.n) {
            this.n = true;
            this.k.a("ui-sparkline-axis-x", this.a);
        }
        return this.a;
    };
    HorizontalAxisView.prototype.t = function () {
        var a = this.r;
        if (a >= 0) {
            return a;
        }
        var b = this.b()[0];
        if (b != null) {
            a = parseInt(b);
        }
        this.r = a = (a < 1) ? 1 : a;
        return a;
    };
    Object.defineProperty(HorizontalAxisView.prototype, "h", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            this.k = a.getService("View");
            this.aa(b, this.g);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAxisView.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            this.o = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAxisView.prototype, "f", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HorizontalAxisView.prototype, "e", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalAxisView.prototype.z = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.p.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    };
    HorizontalAxisView.prototype.aa = function (a, b) {
        if (a != null) {
            this.f.detachTarget(runOn(this, this.z));
        }
        if (b != null) {
            this.f = b.getService("RenderingMessages");
            this.e = b.getService("InteractionMessages");
            this.f.attachTarget(runOn(this, this.z));
        }
    };
    HorizontalAxisView.prototype.y = function (a) {
        this.w = a.j;
        this.m = a.b;
        this.l = this.k.n("ui-sparkline-axis-x");
        if (this.l == null) {
            this.l = FontUtil.getFont(a.h);
        }
        if (this.m != null) {
            this.m.ac(this.l);
        }
        this.s = FontUtil.getCurrentFontHeight(a.h, this.l);
        if (this.j != null && this.j.e8 != 1) {
            a.d = a.d - this.s;
            a.e = this.t();
        }
    };
    HorizontalAxisView.prototype.ae = function (a) {
        this.v = this.w.width();
        this.u = this.s + this.t();
    };
    HorizontalAxisView.prototype.ac = function (a) {
        this.ad(a.c);
    };
    HorizontalAxisView.prototype.ad = function (a) {
        this.ah = null;
        var b = (!a || this.j == null) ? null : this.m;
        if (b == null || !b.d) {
            return;
        }
        b.k(0, 0, this.v, this.u);
        if (this.l != null) {
            b.ac(this.l);
        }
        if (this.q != 1) {
            b.z();
            b.aa(this.q, this.q);
        }
        var c = this.t(), d = c / 2;
        var e = this.j.ar == null || this.j.ar.count == 0;
        if (e) {
            this.u = 0;
        }
        var f = e ? null : this.x(this.j.ar.item(0));
        var g = f == null ? "" : f.toString();
        this.ag = new TextBlock();
        this.ag.ak = g;
        this.ag.n = 2;
        this.af = new TextBlock();
        var h = e ? null : this.x(this.j.ar.item(this.j.ar.count - 1));
        this.af.ak = g = h == null ? "" : h.toString();
        this.af.o = this.ag.o = c;
        this.af.n = this.v - b.f(g) - 4;
        var i = this.j.ex;
        var j = i == null ? null : i._fill;
        var k = new Color();
        var l = true;
        if (i != null) {
            l = false;
            k = i.color;
        }
        i = new Brush();
        if (l) {
            i._fill = (this.a[2] == null) ? "#000000" : this.a[2];
        }
        else {
            i.color = k;
        }
        this.ag.am = this.af.am = i;
        b.w(this.ag);
        b.w(this.af);
        if (c < 0.5) {
            return;
        }
        i = new Brush();
        if (j == null) {
            j = this.a[1];
        }
        i._fill = (j == null) ? "#000000" : j;
        this.ah = new Line();
        this.ah.ak = 0;
        this.ah.al = this.w.width();
        this.ah.am = d;
        this.ah.an = d;
        this.ah._stroke = i;
        this.ah.ac = c;
        b.r(this.ah);
        if (this.q != 1) {
            b.y();
        }
    };
    HorizontalAxisView.prototype.x = function (dataItem_) {
        if (this.j.at()) {
            return this.j.cu(dataItem_);
        }
        var label_ = this.j.bn;
        return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
        ;
    };
    HorizontalAxisView.prototype.i = function () {
        var a = new SparklineAxisVisualData();
        if (this.ah != null) {
            a.axisLine = new LineVisualData(1, "HorizontalAxisLine", this.ah);
            a.axisLine.appearance.isVisible = this.w.height() > 0;
        }
        var b = this.l;
        if (this.ag != null) {
            a.minLabel = AppearanceHelper.c(this.ag, this.l);
        }
        if (this.af != null) {
            a.maxLabel = AppearanceHelper.c(this.af, this.l);
        }
        return a;
    };
    HorizontalAxisView.prototype.ab = function (a) {
        this.q = a.b;
    };
    HorizontalAxisView.$t = markType(HorizontalAxisView, 'HorizontalAxisView');
    return HorizontalAxisView;
}(Base));
/**
 * @hidden
 */
var VerticalAxisView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(VerticalAxisView, _super);
    function VerticalAxisView(a) {
        var _this = _super.call(this) || this;
        _this.ad = null;
        _this.ac = null;
        _this.al = null;
        _this.ak = null;
        _this.am = null;
        _this.w = -1;
        _this.u = -1;
        _this.j = null;
        _this.aa = null;
        _this.m = null;
        _this.l = null;
        _this.t = 0;
        _this.v = 0;
        _this.z = 0;
        _this.y = 0;
        _this.k = null;
        _this.s = -1;
        _this.a = ["border-top-width", "border-top-color", "color", "text-align"];
        _this.n = false;
        _this.g = null;
        _this.p = new Dictionary$2(Type.$, Delegate_$type, 0);
        _this.d = null;
        _this.c = null;
        _this.r = 1;
        _this.q.item(AxisRenderMessage_Spark.$, function (b) { return _this.ai(typeCast(AxisRenderMessage_Spark.$, b)); });
        _this.q.item(ContainerResizedMessage_Spark.$, function (b) { return _this.ae(typeCast(ContainerResizedMessage_Spark.$, b)); });
        _this.q.item(ViewportChangedMessage_Spark.$, function (b) { return _this.aj(typeCast(ViewportChangedMessage_Spark.$, b)); });
        _this.q.item(PixelRatioMessage_Spark.$, function (b) { return _this.ah(typeCast(PixelRatioMessage_Spark.$, b)); });
        _this.j = a;
        return _this;
    }
    VerticalAxisView.prototype.b = function () {
        if (!this.n) {
            this.n = true;
            this.k.a("ui-sparkline-axis-y", this.a);
        }
        return this.a;
    };
    VerticalAxisView.prototype.x = function () {
        var a = this.s;
        if (a >= 0) {
            return a;
        }
        var b = this.b()[0];
        if (b != null) {
            a = parseInt(b);
        }
        this.s = a = (a < 1) ? 1 : a;
        return a;
    };
    Object.defineProperty(VerticalAxisView.prototype, "h", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            var b = this.g;
            this.g = a;
            this.k = a.getService("View");
            this.ag(b, this.g);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VerticalAxisView.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            this.p = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VerticalAxisView.prototype, "f", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VerticalAxisView.prototype, "e", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAxisView.prototype.af = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.q.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    };
    VerticalAxisView.prototype.ag = function (a, b) {
        if (a != null) {
            this.f.detachTarget(runOn(this, this.af));
        }
        if (b != null) {
            this.f = b.getService("RenderingMessages");
            this.e = b.getService("InteractionMessages");
            this.f.attachTarget(runOn(this, this.af));
        }
    };
    VerticalAxisView.prototype.ae = function (a) {
        this.aa = a.k;
        this.m = a.c;
        this.l = this.k.n("ui-sparkline-axis-y");
        if (this.l == null) {
            this.l = FontUtil.getFont(a.h);
        }
        if (this.m != null) {
            this.m.ac(this.l);
        }
        this.t = FontUtil.getCurrentFontHeight(a.h, this.l);
        if (this.j != null && this.j.ff != 1) {
            this.o(false);
            a.g = a.g - this.v;
            a.f = this.x();
        }
    };
    VerticalAxisView.prototype.aj = function (a) {
        this.z = this.v + this.x();
        this.y = this.aa.height();
    };
    VerticalAxisView.prototype.ai = function (a) {
        if (this.o(a.c)) {
            var b = new ClearMessage_Spark();
            b.c = true;
            this.f.sendMessage(b);
        }
    };
    VerticalAxisView.prototype.o = function (a) {
        this.am = null;
        if (this.j == null || this.m == null || !this.m.d || (a && this.ak == null)) {
            return false;
        }
        var b = this.m;
        if (a) {
            b.k(0, 0, this.z, this.y);
        }
        var c = false;
        if (b != null && this.l != null) {
            b.ac(this.l);
        }
        if (!a) {
            this.al = new TextBlock();
            this.ak = new TextBlock();
            var d = this.ab(this.j.a0);
            this.al.ak = this.ad = d == null ? "" : d.toString();
            var e = this.ab(this.j.az);
            this.ak.ak = this.ac = e == null ? "" : e.toString();
            if (b != null) {
                this.w = b.f(this.ad) + 3;
                if (this.w > this.v) {
                    c = true;
                    this.v = this.w;
                }
                this.u = b.f(this.ac) + 3;
                if (this.u > this.v) {
                    c = true;
                    this.v = this.u;
                }
            }
            if (!c) {
                var f = Math.max(this.w, this.u);
                if (f < this.v) {
                    this.v = f;
                    c = true;
                }
            }
            if (c) {
                this.z = this.v;
            }
        }
        else if (b != null) {
            if (this.r != 1) {
                b.z();
                b.aa(this.r, this.r);
            }
            var g = this.j.e5;
            var h = 1;
            var i = g == null ? null : g._fill;
            var j = this.b()[3];
            if (j == "left") {
                h = 0;
            }
            else if (j == "center") {
                h = 0.5;
            }
            this.ak.o = 2;
            this.ak.n = (this.v - this.u) * h + 1;
            this.al.n = (this.v - this.w) * h + 1;
            this.al.o = this.y - this.t - 2;
            var k = new Color();
            var l = true;
            if (g != null) {
                k = g.color;
                l = false;
            }
            g = new Brush();
            if (l) {
                g._fill = (this.a[2] == null) ? "#000000" : this.a[2];
            }
            else {
                g.color = k;
            }
            this.al.am = this.ak.am = g;
            b.w(this.al);
            b.w(this.ak);
            var m = this.x(), n = m / 2;
            if (m >= 0.5) {
                g = new Brush();
                if (i == null) {
                    i = this.a[1];
                }
                g._fill = (i == null) ? "#000000" : i;
                this.am = new Line();
                this.am.ak = this.z - n;
                this.am.al = this.z - n;
                this.am.am = 0;
                this.am.an = this.y;
                this.am._stroke = g;
                this.am.ac = m;
                b.r(this.am);
            }
            if (this.r != 1) {
                b.y();
            }
        }
        return c;
    };
    VerticalAxisView.prototype.ab = function (dataItem_) {
        if (this.j.at()) {
            return this.j.cu(dataItem_);
        }
        var label_ = this.j.bp;
        return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
        ;
    };
    VerticalAxisView.prototype.i = function () {
        var a = new SparklineAxisVisualData();
        if (this.am != null) {
            a.axisLine = new LineVisualData(1, "VerticalAxisLine", this.am);
            a.axisLine.appearance.isVisible = this.aa.width() > 0;
        }
        if (this.al != null) {
            a.minLabel = AppearanceHelper.c(this.al, this.l);
        }
        if (this.ak != null) {
            a.maxLabel = AppearanceHelper.c(this.ak, this.l);
        }
        return a;
    };
    VerticalAxisView.prototype.ah = function (a) {
        this.r = a.b;
    };
    VerticalAxisView.$t = markType(VerticalAxisView, 'VerticalAxisView');
    return VerticalAxisView;
}(Base));
/**
 * @hidden
 */
var XamSparklineView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamSparklineView, _super);
    function XamSparklineView() {
        var _this = _super.call(this) || this;
        _this.bm = null;
        _this.bl = null;
        _this.ad = null;
        _this.ae = null;
        _this.af = null;
        _this.ag = null;
        _this.o = null;
        _this.p = null;
        _this.q = null;
        _this.m = null;
        _this.t = false;
        _this.b = new Array(6);
        _this.x = -1;
        _this.bv = new Path();
        _this.bt = new Path();
        _this.bw = new Path();
        _this.bu = new Path();
        _this.br = new Path();
        _this.bs = new Path();
        _this.bq = new Path();
        _this.bo = new Path();
        _this.bn = new Path();
        _this.bp = new Path();
        _this.i = null;
        _this.e = null;
        _this.f = null;
        _this.u = new Dictionary$2(Type.$, Delegate_$type, 0);
        _this.k = null;
        _this.r = false;
        _this.ah = null;
        _this.d = null;
        _this.c = null;
        _this.s = false;
        _this.w = 1;
        _this.br._visibility = 1;
        _this.bs._visibility = 1;
        _this.bq._visibility = 1;
        _this.bo._visibility = 1;
        _this.bn._visibility = 1;
        _this.bp._visibility = 1;
        _this.bu._visibility = 1;
        var a = _this.v;
        a.item(ClearMessage_Spark.$, function (b) { return _this.ai(typeCast(ClearMessage_Spark.$, b)); });
        a.item(PolygonMessage_Spark.$, function (b) { return _this.bb(typeCast(PolygonMessage_Spark.$, b)); });
        a.item(ColumnMessage_Spark.$, function (b) { return _this.a4(typeCast(ColumnMessage_Spark.$, b)); });
        a.item(WinLossColumnMessage_Spark.$, function (b) { return _this.bi(typeCast(WinLossColumnMessage_Spark.$, b)); });
        a.item(MarkerMessage_Spark.$, function (b) { return _this.a7(typeCast(MarkerMessage_Spark.$, b)); });
        a.item(NormalRangeMessage_Spark.$, function (b) { return _this.bc(typeCast(NormalRangeMessage_Spark.$, b)); });
        a.item(TrendLineMessage_Spark.$, function (b) { return _this.bf(typeCast(TrendLineMessage_Spark.$, b)); });
        a.item(TooltipMessage_Spark.$, function (b) { return _this.bd(typeCast(TooltipMessage_Spark.$, b)); });
        a.item(ToooltipTemplateMessage_Spark.$, function (b) { return _this.be(typeCast(ToooltipTemplateMessage_Spark.$, b)); });
        a.item(ContainerMessage_Spark.$, function (b) { return _this.aj(typeCast(ContainerMessage_Spark.$, b)); });
        a.item(PixelRatioMessage_Spark.$, function (b) { return _this.av(typeCast(PixelRatioMessage_Spark.$, b)); });
        a.item(BrushChangedMessage_Spark.$, function (b) { return _this.a2(typeCast(BrushChangedMessage_Spark.$, b)); });
        a.item(ContainerResizedMessage_Spark.$, function (b) { return _this.as(); });
        a.item(VisibilityMessage_Spark.$, function (b) { return _this.bh(typeCast(VisibilityMessage_Spark.$, b)); });
        a.item(NumberChangedMessage_Spark.$, function (b) { return _this.ba(typeCast(NumberChangedMessage_Spark.$, b)); });
        a.item(ContainerSizeChangedMessage_Spark.$, function (b) { return _this.as(); });
        _this.c = new CanvasRenderScheduler();
        _this.c.l(_this);
        return _this;
    }
    XamSparklineView.prototype.av = function (a) {
        this.w = a.b;
    };
    Object.defineProperty(XamSparklineView.prototype, "j", {
        get: function () {
            return this.i;
        },
        set: function (a) {
            var b = this.i;
            this.i = a;
            this.au(b, this.i);
            this.k = null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparklineView.prototype, "g", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparklineView.prototype, "h", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparklineView.prototype, "v", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            this.u = a;
        },
        enumerable: true,
        configurable: true
    });
    XamSparklineView.prototype.au = function (a, b) {
        if (a != null) {
            this.h.detachTarget(runOn(this, this.aq));
            this.g = null;
        }
        if (b != null) {
            this.h = b.getService("RenderingMessages");
            this.g = b.getService("InteractionMessages");
            this.h.attachTarget(runOn(this, this.aq));
            this.a1(this.g);
        }
    };
    XamSparklineView.prototype.a1 = function (a) {
        this.g = a;
    };
    XamSparklineView.prototype.aq = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.v.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    };
    Object.defineProperty(XamSparklineView.prototype, "l", {
        get: function () {
            if (this.k == null) {
                this.k = this.j.getService("Controller");
            }
            return this.k;
        },
        enumerable: true,
        configurable: true
    });
    XamSparklineView.prototype.a0 = function (a, b, c) {
        var d = new MouseMoveMessage_Spark();
        d.position = a;
        this.g.sendMessage(d);
    };
    XamSparklineView.prototype.az = function (a) {
        var b = new MouseLeaveMessage_Spark();
        this.g.sendMessage(b);
    };
    XamSparklineView.prototype.a2 = function (a) {
        this.a3(a.b, a.c, null, -1, -1);
    };
    XamSparklineView.prototype.a3 = function (a, b, c, d, e) {
        var f = null;
        var g = true, h = true;
        switch (a) {
            case "sparkpath":
            case XamSparkline.$$p[0]:
                f = this.bv;
                break;
            case "negativesparkpath":
            case XamSparkline.$$p[27]:
                f = this.bt;
                break;
            case "markers":
            case XamSparkline.$$p[22]:
                f = this.br;
                break;
            case "firstmarker":
            case XamSparkline.$$p[3]:
                f = this.bn;
                break;
            case "lastmarker":
            case XamSparkline.$$p[15]:
                f = this.bp;
                break;
            case "highmarker":
            case XamSparkline.$$p[7]:
                f = this.bo;
                break;
            case "lowmarker":
            case XamSparkline.$$p[19]:
                f = this.bq;
                break;
            case "negativemarkers":
            case XamSparkline.$$p[28]:
                f = this.bs;
                break;
            case "trendline":
            case XamSparkline.$$p[36]:
                f = this.bw;
                h = false;
                break;
            case "range":
            case XamSparkline.$$p[31]:
                f = this.bu;
                g = false;
                break;
        }
        if (f == null) {
            return;
        }
        if (b == null && c != null) {
            b = new Brush();
            b._fill = c;
        }
        if (b != null) {
            if (h && (c == null || f._fill == null)) {
                f._fill = b;
            }
            if (g && (c == null || f._stroke == null)) {
                f._stroke = b;
            }
        }
        if (d > 0 && d < 1) {
            f._opacity = d;
        }
        if (e > 0 && (c == null || f.ac <= 0)) {
            f.ac = e;
        }
        this.ap();
    };
    XamSparklineView.prototype.bh = function (a) {
        switch (a.b) {
            case XamSparkline.$$p[24]:
                this.br._visibility = a.c;
                break;
            case XamSparkline.$$p[5]:
                this.bn._visibility = a.c;
                break;
            case XamSparkline.$$p[17]:
                this.bp._visibility = a.c;
                break;
            case XamSparkline.$$p[9]:
                this.bo._visibility = a.c;
                break;
            case XamSparkline.$$p[21]:
                this.bq._visibility = a.c;
                break;
            case XamSparkline.$$p[30]:
                this.bs._visibility = a.c;
                break;
            case XamSparkline.$$p[34]:
                this.bu._visibility = a.c;
                break;
            case XamSparkline.$$p[35]:
                this.t = a.c == 0;
                break;
        }
        this.ap();
    };
    XamSparklineView.prototype.ba = function (a) {
        var b = a.b;
        if (b <= 0) {
            return;
        }
        switch (a.c) {
            case XamSparkline.$$p[18]:
                this.bv.ac = this.bt.ac = b;
                break;
            case XamSparkline.$$p[38]:
                this.bw.ac = b;
                break;
        }
        this.ap();
    };
    XamSparklineView.prototype.aj = function (a) {
        if (a.b == null) {
            if (this.m != null) {
                this.m.aq();
                var b = this.m;
                b.onMouseLeave = delegateRemove(b.onMouseLeave, runOn(this, this.az));
                var c = this.m;
                c.onMouseOver = delegateRemove(c.onMouseOver, runOn(this, this.a0));
                this.m = null;
            }
            this.ad = null;
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.o = this.p = this.q = null;
            this.c.j(null);
            return;
        }
        var d = a.b;
        this.c.j(d);
        this.ad = d;
        this.ad.rootWrapper.setStyleProperty("position", "relative");
        this.ae = this.ad.createElement("canvas");
        this.ae.setStyleProperty("position", "absolute");
        this.af = this.ad.createElement("canvas");
        this.af.setStyleProperty("position", "absolute");
        this.ag = this.ad.createElement("canvas");
        this.ag.setStyleProperty("position", "absolute");
        this.ad.append(this.ae);
        this.ad.append(this.af);
        this.ad.append(this.ag);
        this.o = new RenderingContext(new CanvasViewRenderer(), this.ad.get2DCanvasContext(this.ae));
        this.p = new RenderingContext(new CanvasViewRenderer(), this.ad.get2DCanvasContext(this.af));
        this.q = new RenderingContext(new CanvasViewRenderer(), this.ad.get2DCanvasContext(this.ag));
        this.m = new CanvasGestureDOMEventProxy(this.ae, this.ad, false);
        var e = this.m;
        e.onMouseLeave = delegateCombine(e.onMouseLeave, runOn(this, this.az));
        var f = this.m;
        f.onMouseOver = delegateCombine(f.onMouseOver, runOn(this, this.a0));
        this.m.al = function (g) { return false; };
        this.an();
        this.as();
    };
    XamSparklineView.prototype.an = function () {
        var a = ["sparkpath", "negativesparkpath", "trendline", "markers", "firstmarker", "lastmarker", "highmarker", "lowmarker", "negativemarkers", "range"];
        var b = ["#7446B9", "#C62828", "#565656", "#9FB328", "#2E9CA6", "#DC3F76", "#F96232", "#3F51B5", "#C62828", "#66666666"];
        for (var c = 0; c < 10; c++) {
            var d = a[c];
            var e = ["background-color", "opacity", "border-top-width"];
            this.a("ui-sparkline-" + d, e);
            var f = XamSparklineView.ac(e[2], (c < 3) ? (c < 2 ? 2 : 1.5) : -1);
            if (c > 2 && c < 9) {
                this.b[c - 3] = f;
            }
            this.a3(d, null, (e[0] == null) ? b[c] : e[0], XamSparklineView.ac(e[1], -1), c < 3 ? f : -1);
        }
    };
    XamSparklineView.ac = function (v_, a) {
        var d_ = (v_ == null || v_.length < 1) ? null : parseFloat(v_);
        return (d_ == null || d_.toString() == "NaN") ? a : d_;
    };
    XamSparklineView.prototype.a = function (a, b) {
        this.ad.startCSSQuery();
        for (var c = 0; c < b.length; c++) {
            b[c] = this.ad.getCssDefaultPropertyValue(a, b[c]);
        }
        this.ad.endCSSQuery();
        return b;
    };
    XamSparklineView.prototype.as = function () {
        if (this.ad == null || this.r) {
            return;
        }
        this.r = true;
        this.ao(this.l.q);
        var a = this.ad.rootWrapper.width(), b = this.ad.rootWrapper.height();
        var c, d, e;
        c = this.ae;
        d = this.af;
        e = this.ag;
        var f = new ContainerResizedMessage_Spark();
        f.g = a;
        f.d = b;
        f.b = this.p;
        f.h = this.ad;
        f.c = this.q;
        f.f = 0;
        f.e = 0;
        f.j = d;
        f.i = c;
        f.k = e;
        this.h.sendMessage(f);
        var g = f.e, h = f.f, i = f.g - h, j = f.d - g;
        var k = i, l = a - i, m = j, n = b - j;
        c.setStyleProperty("width", k.toString() + "px");
        c.setStyleProperty("height", m.toString() + "px");
        c.setAttribute("width", (k * this.w).toString());
        c.setAttribute("height", (m * this.w).toString());
        c.setStyleProperty("marginLeft", l + "px");
        k = (i + h);
        this.ay(d, k, n, k * this.w, n * this.w);
        d.setStyleProperty("marginTop", m + "px");
        d.setStyleProperty("marginLeft", (a - i - h).toString() + "px");
        this.ay(e, l, m, l * this.w, m * this.w);
        this.bm = new Rect(0, 0, 0, i, j);
        if (this.m != null) {
            this.m.bf = this.bm;
        }
        this.bg();
        var o = new ViewportChangedMessage_Spark();
        o.newLeft = this.bm.left;
        o.newTop = this.bm.top;
        o.newHeight = this.bm.height;
        o.newWidth = this.bm.width;
        this.h.sendMessage(o);
        this.r = false;
    };
    XamSparklineView.prototype.ak = function (a) {
        if (a) {
            this.x = -1;
        }
        else if (this.x < 0) {
            this.bg();
        }
    };
    XamSparklineView.prototype.bg = function () {
        var a = this.bm.left;
        var b = this.bm.width;
        var c = this.bm.height;
        var d = this.aa(true);
        var e = new Rect(0, a + d, d, b - d * 2, c - d * 2);
        var f = new ViewportChangedMessage_Spark();
        f.newLeft = e.left;
        f.newTop = e.top;
        f.newHeight = e.height;
        f.newWidth = e.width;
        this.bl = e;
        this.g.sendMessage(f);
    };
    XamSparklineView.prototype.ai = function (a) {
        if (Rect.l_op_Equality(this.bm, null)) {
            return;
        }
        switch (a.b) {
            case 2:
                this.br.ak = null;
                this.bn.ak = null;
                this.bp.ak = null;
                this.bo.ak = null;
                this.bq.ak = null;
                this.bs.ak = null;
                break;
            case 8:
                this.bu.ak = null;
                break;
            case 1:
                this.bv.ak = null;
                this.bt.ak = null;
                break;
            case 4:
                this.al(null);
                break;
            case 16:
                this.bw.ak = null;
                break;
        }
        if (a.c) {
            this.as();
        }
    };
    XamSparklineView.prototype.aa = function (a) {
        if (a) {
            this.x = -1;
        }
        var b = this.x;
        if (b >= 0) {
            return b;
        }
        b = 0;
        var c = this.l.q;
        if (c.fb == 0) {
            b = this.ab(b, c.a9, 0);
        }
        if (c.e6 == 0) {
            b = this.ab(b, c.a2, 1);
        }
        if (c.e9 == 0) {
            b = this.ab(b, c.a4, 2);
        }
        if (c.e7 == 0) {
            b = this.ab(b, c.a3, 3);
        }
        if (c.fa == 0) {
            b = this.ab(b, c.a8, 4);
        }
        if (c.fc == 0) {
            b = this.ab(b, c.be, 5);
        }
        this.x = b;
        return b;
    };
    XamSparklineView.prototype.ab = function (a, b, c) {
        if (b >= 0) {
            return b > a ? b : a;
        }
        return this.b[c] > a ? this.b[c] : a;
    };
    XamSparklineView.prototype.a7 = function (a) {
        this.a8(this.br, a.e, a.k, 0);
        this.a8(this.bs, a.f, a.l, 5);
        this.a8(this.bq, a.d, a.j, 4);
        this.a8(this.bo, a.c, a.h, 3);
        this.a9(this.bn, a.m, a.g, 1);
        this.a9(this.bp, a.n, a.i, 2);
        this.ap();
    };
    XamSparklineView.prototype.a9 = function (a, b, c, d) {
        var e = ((function () {
            var $ret = new List$1(Point_$type, 0);
            $ret.add(b);
            return $ret;
        })());
        this.a8(a, e, c, d);
    };
    XamSparklineView.prototype.a8 = function (a, b, c, d) {
        if (c < 0) {
            c = this.b[d];
        }
        a.ak = this.bk(b, c < 0.1 ? DeviceUtils.g(3) : c);
        if (this.l.q.am != 3) {
            var e = new TranslateTransform();
            e.j = this.l.o.d;
            a.j = e;
        }
        else {
            a.j = null;
        }
    };
    XamSparklineView.prototype.bk = function (a, b) {
        var e_1, _a;
        var c = new GeometryGroup();
        c.c = 1;
        var d = this.bm.right;
        var e = this.bm.bottom;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var f = _c.value;
                if ((!f)) {
                    continue;
                }
                if (f.x < 0 || f.y < 0 || f.x > d || f.y > e) {
                    continue;
                }
                var g = new EllipseGeometry();
                g.c = b;
                g.d = b;
                g.e = f;
                c.d.add(g);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return c;
    };
    XamSparklineView.prototype.bb = function (a) {
        var e_2, _a;
        var b = new PathGeometry();
        var c = this.l.q.am == 1;
        try {
            for (var _b = __values(fromEnum(a.points)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                var e = d.length;
                if (e == 0) {
                    continue;
                }
                var f = new PathFigure();
                f._isClosed = f._isFilled = c;
                f._startPoint = d[0];
                for (var g = 1; g < e; g++) {
                    var h = new LineSegment(1);
                    h.c = d[g];
                    f._segments.add(h);
                }
                b.c.add(f);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.bv.ak = b;
        this.ap();
    };
    XamSparklineView.prototype.bj = function (a, b) {
        var e_3, _a;
        var c = typeCast(WinLossColumnMessage_Spark.$, b);
        var d = typeCast(ColumnMessage_Spark.$, b);
        var e = new GeometryGroup();
        var f = c != null ? c.i : d.i;
        var g = c != null ? c.h : d.h;
        var h = f * 0.1;
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                var j = f * 2 - h * 2;
                var k = Math.abs(g - i.y);
                var l = i.x + h;
                var m = (i.y > g ? g : i.y);
                var n = new RectangleGeometry();
                n.e = new Rect(0, l, m, j, k);
                e.d.add(n);
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return e;
    };
    XamSparklineView.prototype.a4 = function (a) {
        this.a5(this.bv, a.d, a);
        this.a5(this.bt, a.g, a);
        this.ap();
    };
    XamSparklineView.prototype.a6 = function (a, b, c) {
        var d = ((function () {
            var $ret = new List$1(Point_$type, 0);
            $ret.add(b);
            return $ret;
        })());
        this.a5(a, d, c);
    };
    XamSparklineView.prototype.a5 = function (a, b, c) {
        a.ak = this.bj(b, c);
    };
    XamSparklineView.prototype.bi = function (a) {
        this.a5(this.bv, a.d, a);
        this.a5(this.bt, a.g, a);
        this.ap();
    };
    XamSparklineView.prototype.bc = function (a) {
        var b = new RectangleGeometry();
        b.e = new Rect(0, a.k, a.l, a.j, a.i);
        this.bu.ak = b;
        this.ap();
    };
    XamSparklineView.prototype.bf = function (a) {
        if (a.points.length == 0) {
            return;
        }
        var b = new PathGeometry();
        var c = new PathFigure();
        c._isClosed = c._isFilled = false;
        c._startPoint = a.points[0];
        var d = a.points.length;
        for (var e = 1; e < d; e++) {
            var f = new LineSegment(1);
            f.c = a.points[e];
            c._segments.add(f);
        }
        b.c.add(c);
        this.bw.ak = b;
        this.ap();
    };
    XamSparklineView.prototype.be = function (a) {
        this.ah = a.template;
    };
    XamSparklineView.prototype.bd = function (a) {
        if (!this.t) {
            this.al(null);
            return;
        }
        var b = truncate(Math.round(a.xOffset - 10));
        var c = truncate(Math.round(a.yOffset - 10));
        b = truncate(Math.round(b * this.w));
        c = truncate(Math.round(c * this.w));
        var d = this.o.a(b, c);
        if (d[3] > 0) {
            this.al(a);
        }
        else {
            this.al(null);
        }
    };
    XamSparklineView.prototype.al = function (a) {
        var x_ = 0, y_ = 0;
        var v_ = null, t_ = null, i_ = this.ad;
        {
            if (a != null) {
                t_ = this.ah;
                x_ = a.xOffset + 6;
                y_ = a.yOffset + 6;
                var b = a.context;
                var f_ = b.first, l_ = b.last, o_ = b.low, h_ = b.high;
                v_ = { First: f_, Last: l_, Low: o_, High: h_ };
            }
            var ren_ = this.ad;
            if (this.d == null) {
                this.d = new DataContext();
            }
            var dc_ = this.d;
            dc_.item = v_;
            dc_.series = this;
            var tt_ = this.ah;
            if (tt_ != null) {
                if (v_ != null) {
                    tt_.updateToolTip(dc_);
                    tt_.setRawPosition(x_, y_);
                }
                else {
                    tt_.hideToolTip();
                }
            }
        }
    };
    Object.defineProperty(XamSparklineView.prototype, "isDirty", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            this.s = a;
        },
        enumerable: true,
        configurable: true
    });
    XamSparklineView.prototype.ap = function () {
        if (!this.isDirty) {
            this.isDirty = true;
            this.c.o(this.o, null);
        }
    };
    XamSparklineView.prototype.undirty = function (a) {
        this.s = false;
        this.aw();
    };
    Object.defineProperty(XamSparklineView.prototype, "index", {
        get: function () {
            return 10;
        },
        enumerable: true,
        configurable: true
    });
    XamSparklineView.prototype.ax = function (a, b) {
        b.s(a);
    };
    XamSparklineView.prototype.aw = function () {
        var a = this.o;
        if (a != null && a.d) {
            if (this.w != 1) {
                a.z();
                a.aa(this.w, this.w);
            }
            a.k(this.bm.left, this.bm.top, this.bm.width, this.bm.height);
            a.s(this.bv);
            a.s(this.bt);
            this.ax(this.br, a);
            this.ax(this.bs, a);
            this.ax(this.bo, a);
            this.ax(this.bq, a);
            this.ax(this.bn, a);
            this.ax(this.bp, a);
            a.s(this.bu);
            a.s(this.bw);
            if (this.w != 1) {
                a.y();
            }
        }
        var b = new AxisRenderMessage_Spark();
        b.c = true;
        this.h.sendMessage(b);
        this.postRender();
    };
    XamSparklineView.prototype.postRender = function () {
    };
    XamSparklineView.prototype.am = function (a) {
        a.viewport = new RectData(this.bm.left, this.bm.top, this.bm.width, this.bm.height);
        a.marginViewport = new RectData(this.bl.left, this.bl.top, this.bl.width, this.bl.height);
        a.sparkPath = new PathVisualData(1, "SparkPath", this.bv);
        a.negativeSparkPath = new PathVisualData(1, "NegativeSparkPath", this.bt);
        a.trendLinePath = new PathVisualData(1, "TrendLinePath", this.bw);
        a.rangePath = new PathVisualData(1, "RangePath", this.bu);
        a.markersPath = new PathVisualData(1, "MarkersPath", this.br);
        a.negativeMarkersPath = new PathVisualData(1, "NegativeMarkersPath", this.bs);
        a.lowMarkersPath = new PathVisualData(1, "LowMarkersPath", this.bq);
        a.highMarkersPath = new PathVisualData(1, "HighMarkersPath", this.bo);
        a.firstMarkerPath = new PathVisualData(1, "FirstMarkerPath", this.bn);
        a.lastMarkerPath = new PathVisualData(1, "LastMarkerPath", this.bp);
    };
    XamSparklineView.prototype.preRender = function () {
    };
    XamSparklineView.prototype.isValid = function () {
        return true;
    };
    XamSparklineView.prototype.n = function (a) {
        return FontUtil.getFontForClass(this.ad, a);
    };
    XamSparklineView.prototype.ay = function (a, b, c, d, e) {
        a.setStyleProperty("width", b + "px");
        a.setStyleProperty("height", c + "px");
        a.setAttribute("width", d.toString());
        a.setAttribute("height", e.toString());
    };
    XamSparklineView.prototype.ao = function (a) {
        var b = a.bh;
        var c = a.a1;
        if (!isNaN_(b) && b != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
            a.a1 = window.devicePixelRatio;
        }
    };
    XamSparklineView.prototype.at = function () {
        if (this.m != null) {
            this.m.bb(this.ae, "");
        }
    };
    XamSparklineView.prototype.ar = function () {
        this.ao(this.k.q);
        if (this.m != null) {
            this.m.ap(this.ae, "");
        }
    };
    XamSparklineView.$t = markType(XamSparklineView, 'XamSparklineView', Base.$, [ISchedulableRender_$type]);
    return XamSparklineView;
}(Base));
/**
 * @hidden
 */
var SparkFramePreparer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparkFramePreparer, _super);
    function SparkFramePreparer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = null;
        _this.d = 0;
        _this.c = 0;
        return _this;
    }
    SparkFramePreparer.prototype.e = function (a) {
        var e_4, _a;
        var _this = this;
        this.b.r.ak(false);
        a.g.clear();
        a.l.clear();
        a.j.clear();
        a.k.clear();
        a.i.clear();
        a.h.clear();
        var b = this.b.t;
        if (b == null) {
            return;
        }
        var c = b.count;
        var d = this.b.a3.top;
        var e = this.b.a3.left;
        var f = this.b.a3.width;
        var g = this.b.a3.height;
        var h = this.b.a3.bottom;
        var i = Math.floor((c + 1) / f);
        var j = truncate(Math.max(1, i));
        var k = 0;
        var l = truncate(Math.ceil(1 * c / j));
        var m = 0;
        var n = new List$1(Number_$type, 0);
        var o = this.b.q.an;
        var p = this.b.q.am;
        var q = this.b.q.bm;
        var r = o != 0 && q >= 1;
        var s = null;
        var t = null;
        if (p == 1 || p == 0) {
            this.d = 0;
        }
        else {
            if (l == 0) {
                this.d = 0;
            }
            else {
                this.d = f / l / 2;
            }
        }
        if (r) {
            var u = function (v) { return v + 1; };
            var v = function (w) { return b.item(w); };
            var w = function (x) { return _this.b.y(x); };
            var x = function (y) { return _this.b.z(y); };
            switch (this.b.q.an) {
                case 9:
                    s = TrendCalculators.e(b, q);
                    break;
                case 10:
                    s = TrendCalculators.b(b, q);
                    break;
                case 11:
                    s = TrendCalculators.c(b, q);
                    break;
                case 12:
                    s = TrendCalculators.a(b);
                    break;
                case 13:
                    s = TrendCalculators.g(b, q);
                    break;
                case 1:
                    t = LeastSquaresFit.k(c, u, v);
                    break;
                case 2:
                    t = LeastSquaresFit.o(c, u, v);
                    break;
                case 3:
                    t = LeastSquaresFit.i(c, u, v);
                    break;
                case 4:
                    t = LeastSquaresFit.p(c, u, v);
                    break;
                case 5:
                    t = LeastSquaresFit.q(c, u, v);
                    break;
                case 7:
                    t = LeastSquaresFit.j(c, u, v);
                    break;
                case 6:
                    t = LeastSquaresFit.l(c, u, v);
                    break;
                case 8:
                    t = LeastSquaresFit.n(c, u, v);
                    break;
            }
            if (s != null) {
                try {
                    for (var _b = __values(fromEnum(s)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var y = _c.value;
                        n.add(y);
                    }
                }
                catch (e_4_1) {
                    e_4 = { error: e_4_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_4)
                            throw e_4.error;
                    }
                }
            }
            if (t != null) {
                var z = k * j;
                var aa = l * j;
                if (p == 1 || p == 0) {
                    aa = aa - 1;
                }
                var ab = 0 + this.d;
                var ac = f - this.d;
                var ad = 0;
                if (this.d != 0) {
                    ad = 0.5;
                }
                for (var ae = ab; ae <= ac; ae += 2) {
                    var af = ae / (f - 1);
                    var ag = z + af * (aa - z);
                    var ah = NaN;
                    switch (o) {
                        case 1:
                            ah = LeastSquaresFit.ad(t, ag - ad);
                            break;
                        case 2:
                            ah = LeastSquaresFit.ah(t, ag - ad);
                            break;
                        case 3:
                            ah = LeastSquaresFit.ab(t, ag - ad);
                            break;
                        case 4:
                            ah = LeastSquaresFit.ai(t, ag - ad);
                            break;
                        case 5:
                            ah = LeastSquaresFit.aj(t, ag - ad);
                            break;
                        case 7:
                            ah = LeastSquaresFit.ac(t, ag - ad);
                            break;
                        case 6:
                            ah = LeastSquaresFit.ae(t, ag - ad);
                            break;
                        case 8:
                            ah = LeastSquaresFit.ag(t, ag - ad);
                            break;
                    }
                    ag = w(ag);
                    ah = x(ah);
                    if (!isNaN_(ah) && !isInfinity(ah)) {
                        a.l.add({ $type: Point_$type, x: ag, y: ah });
                    }
                }
            }
        }
        var ai = this.b.t.minimum;
        var aj = this.b.t.maximum;
        var ak = this.b.q.a0;
        var al = this.b.q.az;
        this.c = h - (m - ak) / (al - ak) * g;
        if (this.c < 0) {
            this.c = 0;
        }
        else if (this.c > h) {
            this.c = h;
        }
        var am = this.c;
        var an;
        for (var ao = k; ao < l; ao++) {
            var ap = this.a(ao, j, c);
            var aq = ap[1];
            var ar = ap[2];
            this.f(ap, c, this.b.a3, ak, al);
            an = ap[1];
            if (ap[2] < am) {
                an = ap[2];
            }
            a.g.add(ap);
            if (!isNaN_(ap[0]) && !isNaN_(ap[1])) {
                a.j.add({ $type: Point_$type, x: ap[0], y: an });
            }
            if (r && s != null) {
                var as = ao * j;
                var at = h - (((n._inner[as] - ai) / (aj - ai)) * g);
                a.l.add({ $type: Point_$type, x: ap[0] + this.d, y: at });
            }
            if (aq < m) {
                a.k.add({ $type: Point_$type, x: ap[0], y: ap[1] });
            }
            if (ai == aq) {
                a.i.add({ $type: Point_$type, x: ap[0], y: ap[1] });
            }
            if (aj == ar) {
                a.h.add({ $type: Point_$type, x: ap[0], y: ap[2] });
            }
        }
        if (a.j.count == 0) {
            a.m = a.n = { $type: Point_$type, x: NaN, y: NaN };
        }
        else {
            a.m = a.j._inner[0];
            a.n = a.j._inner[a.j.count - 1];
        }
    };
    SparkFramePreparer.prototype.a = function (a, b, c) {
        var d = Math.min(a * b, c - 1);
        var e = Math.min(d + b - 1, c - 1);
        var f = true;
        var g = 0;
        var h = 0;
        for (var i = d; i <= e; ++i) {
            var j = this.b.t.item(i);
            if (f) {
                f = false;
                g = j;
                h = j;
            }
            else {
                g = Math.min(g, j);
                h = Math.max(h, j);
            }
        }
        var k = [0, 0, 0];
        k[0] = (0.5 * (d + e));
        k[1] = g;
        k[2] = h;
        return k;
    };
    SparkFramePreparer.prototype.f = function (a, b, c, d, e) {
        var f = c.left;
        var g = c.top;
        var h = c.width;
        var i = c.height;
        if (this.b.q.am == 1 || this.b.q.am == 0) {
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        var j = b > 0 ? a[0] / b : b == 0 ? 0.5 : NaN;
        a[0] = f + j * h;
        if (this.b.q.am == 3) {
            if (a[1] > 0) {
                a[1] = g;
                a[2] = g;
            }
            else if (a[1] < 0) {
                a[1] = g + i;
                a[2] = g + i;
            }
            else {
                a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
                a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
            }
        }
        else {
            a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
            a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
        }
    };
    SparkFramePreparer.$t = markType(SparkFramePreparer, 'SparkFramePreparer');
    return SparkFramePreparer;
}(Base));
/**
 * @hidden
 */
var SparklineConnector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparklineConnector, _super);
    function SparklineConnector(a, b) {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.b = null;
        _this.e = null;
        _this.a = null;
        _this.c = null;
        _this.e = b;
        if (a == null) {
            return _this;
        }
        _this.d = typeCast(XamSparkline.$, a);
        _this.a = _this.d.ag;
        _this.c = _this.d.ap;
        b.ao(_this.d);
        var c = new ServiceProvider_Spark();
        c.addService("ConfigurationMessages", new MessageChannel_Spark());
        c.addService("RenderingMessages", new MessageChannel_Spark());
        c.addService("InteractionMessages", new MessageChannel_Spark());
        c.addService("Model", _this.d);
        c.addService("View", _this.e);
        c.addService("HorizontalAxis", _this.a);
        c.addService("VerticalAxis", _this.c);
        _this.d.ak = c;
        _this.e.j = c;
        _this.a.h = c;
        _this.c.h = c;
        _this.b = new SparklineController(c);
        c.addService("Controller", _this.b);
        return _this;
    }
    SparklineConnector.$t = markType(SparklineConnector, 'SparklineConnector');
    return SparklineConnector;
}(Base));
/**
 * @hidden
 */
var SparklineController = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(SparklineController, _super);
    function SparklineController(a) {
        var _this = _super.call(this) || this;
        _this.k = null;
        _this.m = null;
        _this.l = null;
        _this.p = null;
        _this.r = null;
        _this.t = null;
        _this.s = null;
        _this.o = new SparkFramePreparer();
        _this.n = new SparkFrame();
        _this.a3 = Rect.empty;
        _this.aa = null;
        _this.k = a.getService("ConfigurationMessages");
        _this.m = a.getService("RenderingMessages");
        _this.l = a.getService("InteractionMessages");
        _this.aa = function (b, c) { return _this.ah(c.action, c.position, c.count, c.propertyName); };
        _this.q = a.getService("Model");
        _this.r = a.getService("View");
        _this.k.attachTarget(runOn(_this, _this.ag));
        _this.l.attachTarget(runOn(_this, _this.aj));
        return _this;
    }
    Object.defineProperty(SparklineController.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.p != a;
            if (b) {
                this.p = a;
                this.an(runOn(this, this.aw));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineController.prototype, "x", {
        get: function () {
            return this.q != null ? this.q.itemsSource : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineController.prototype, "u", {
        get: function () {
            return this.c(SparklineController.a2);
        },
        set: function (a) {
            this.h(SparklineController.a2, a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineController.prototype, "ad", {
        get: function () {
            return this.q != null ? this.q.c2 : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineController.prototype, "ac", {
        get: function () {
            return this.q != null ? this.q.b7 : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SparklineController.prototype, "ab", {
        get: function () {
            return this.q != null ? this.q.toolTip : null;
        },
        enumerable: true,
        configurable: true
    });
    SparklineController.prototype.y = function (a) {
        var b = this.t.count;
        if (this.q.am == 1 || this.q.am == 0) {
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        var c = b > 0 ? a / b : b == 0 ? 0.5 : NaN;
        c = this.a3.left + (c) * this.a3.width;
        return c;
    };
    SparklineController.prototype.z = function (a) {
        var b = ((a - this.q.a0) / (this.q.az - this.q.a0));
        b = (1 - b);
        b = this.a3.top + (b) * this.a3.height;
        return b;
    };
    SparklineController.prototype.w = function () {
        return !this.a3.isEmpty && this.a3.width > 0 && this.a3.height > 0 && this.q != null && this.q.a0 != this.q.az;
    };
    SparklineController.prototype.v = function (a) {
        if (a.oldValue != a.newValue) {
            return true;
        }
        return false;
    };
    SparklineController.prototype.av = function (a, b) {
        var _this = this;
        if (this.aa == null) {
            this.aa = function (c, d) { return _this.ah(d.action, d.position, d.count, d.propertyName); };
        }
        var c = typeCast(FastItemsSource.$, a);
        if (c != null) {
            c.event = delegateRemove(c.event, this.aa);
        }
        var d = typeCast(FastItemsSource.$, b);
        if (d != null) {
            d.event = delegateCombine(d.event, this.aa);
        }
    };
    SparklineController.prototype.ay = function () {
        if (this.q != null) {
            if (this.t == null) {
                this.q.a0 = this.q.az = NaN;
            }
            else {
                if (isNaN_(this.q.bd)) {
                    this.q.a0 = this.t.minimum;
                }
                else {
                    this.q.a0 = this.q.bd;
                }
                if (isNaN_(this.q.bc)) {
                    this.q.az = this.t.maximum;
                }
                else {
                    this.q.az = this.q.bc;
                }
                if (this.q.a0 == this.q.az) {
                    if (!isNaN_(this.q.bc) && isNaN_(this.q.bd)) {
                        this.q.a0 = this.q.az - 1;
                    }
                    else if (isNaN_(this.q.bc) && !isNaN_(this.q.bd)) {
                        this.q.az = this.q.a0 + 1;
                    }
                    else {
                        if (Math.floor(this.q.a0) < this.q.a0) {
                            this.q.a0 = Math.floor(this.q.a0);
                        }
                        else {
                            this.q.a0 = Math.floor(this.q.a0) - 1;
                        }
                        if (Math.ceil(this.q.az) > this.q.az) {
                            this.q.az = Math.ceil(this.q.az);
                        }
                        else {
                            this.q.az = Math.ceil(this.q.az) + 1;
                        }
                    }
                }
            }
        }
    };
    SparklineController.prototype.a0 = function () {
        if (this.u != null) {
            this.u.deregisterColumn(this.t);
            this.t = this.u.registerColumn(this.ad, null, false);
        }
        else {
            this.t = null;
        }
    };
    SparklineController.prototype.ax = function () {
        if (this.u != null) {
            this.u.deregisterColumn(this.s);
            this.s = this.u.registerColumnObject(this.ac, null, false);
            this.q.ar = this.s;
        }
        else {
            this.q.ar = this.s = null;
        }
    };
    SparklineController.prototype.au = function () {
        var a = new AxisRenderMessage_Spark();
        this.m.sendMessage(a);
    };
    SparklineController.prototype.an = function (a) {
        a();
    };
    SparklineController.prototype.aw = function () {
        this.u = this.getFastItemsSource(this.x);
        this.a0();
        this.ax();
        this.ay();
        this.au();
    };
    SparklineController.prototype.ah = function (a, b, c, d) {
        this.a0();
        this.ax();
        this.ay();
        this.au();
        this.an(runOn(this, this.ao));
    };
    SparklineController.prototype.az = function () {
        var a = new ToooltipTemplateMessage_Spark();
        a.template = this.ab;
        this.m.sendMessage(a);
    };
    SparklineController.prototype.ag = function (a) {
        if (typeCast(PropertyChangedMessage_Spark.$, a) !== null) {
            this.am(a);
        }
        else if (typeCast(ContainerSizeChangedMessage_Spark.$, a) !== null) {
            this.m.sendMessage(a);
        }
        else if (typeCast(DataChangedMessage_Spark.$, a) !== null) {
            this.ai(a);
        }
    };
    SparklineController.prototype.ai = function (a) {
        var b = this.u;
        if (b == null) {
            return;
        }
        switch (a.b) {
            case 2:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, a.d, a.e, a.c));
                break;
            case 0:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, a.d, a.c));
                break;
            case 1:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, a.e, a.c));
                break;
            case 4:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
                break;
        }
        this.an(runOn(this, this.aw));
    };
    SparklineController.prototype.aj = function (a) {
        var b = a;
        if (typeCast(ViewportChangedMessage_Spark.$, b) !== null) {
            this.a1(b);
        }
        else if (typeCast(MouseLeaveMessage_Spark.$, b) !== null) {
            this.ak(b);
        }
        else if (typeCast(MouseMoveMessage_Spark.$, b) !== null) {
            this.al(b);
        }
        else if (typeCast(ContainerSizeChangedMessage_Spark.$, b) !== null) {
            this.m.sendMessage(a);
        }
    };
    SparklineController.prototype.am = function (a) {
        switch (a.propertyName) {
            case XamSparkline.$$p[13]:
                this.an(runOn(this, this.aw));
                break;
            case XamSparkline.$$p[41]:
                this.an(runOn(this, this.aw));
                break;
            case XamSparkline.$$p[14]:
                this.an(runOn(this, this.aw));
                break;
            case "ToolTip":
                this.az();
                break;
            case XamSparkline.$$p[26]:
            case XamSparkline.$$p[25]:
                this.ay();
                this.au();
                break;
            case XamSparkline.$$p[11]:
            case XamSparkline.$$p[43]:
                this.au();
                break;
            case XamSparkline.$$p[0]:
            case XamSparkline.$$p[27]:
            case XamSparkline.$$p[22]:
            case XamSparkline.$$p[3]:
            case XamSparkline.$$p[15]:
            case XamSparkline.$$p[7]:
            case XamSparkline.$$p[19]:
            case XamSparkline.$$p[28]:
            case XamSparkline.$$p[36]:
            case XamSparkline.$$p[31]:
                var b = new BrushChangedMessage_Spark();
                b.c = typeCast(Brush.$, a.newValue);
                b.b = a.propertyName;
                this.m.sendMessage(b);
                break;
            case XamSparkline.$$p[24]:
            case XamSparkline.$$p[5]:
            case XamSparkline.$$p[17]:
            case XamSparkline.$$p[9]:
            case XamSparkline.$$p[21]:
            case XamSparkline.$$p[30]:
            case XamSparkline.$$p[34]:
            case XamSparkline.$$p[35]:
                var c = new VisibilityMessage_Spark();
                c.c = EnumUtil.getEnumValue(Visibility_$type, a.newValue);
                c.b = a.propertyName;
                this.m.sendMessage(c);
                this.r.ak(true);
                break;
            case XamSparkline.$$p[23]:
            case XamSparkline.$$p[4]:
            case XamSparkline.$$p[16]:
            case XamSparkline.$$p[8]:
            case XamSparkline.$$p[20]:
            case XamSparkline.$$p[29]:
                this.r.ak(true);
                break;
            case XamSparkline.$$p[18]:
            case XamSparkline.$$p[38]:
                var d = new NumberChangedMessage_Spark();
                d.b = a.newValue;
                d.c = a.propertyName;
                this.m.sendMessage(d);
                break;
            case XamSparkline.$$p[10]:
            case XamSparkline.$$p[42]:
            case XamSparkline.$$p[12]:
            case XamSparkline.$$p[44]:
                this.at();
                break;
            case "Container":
                var e = new ContainerMessage_Spark();
                e.b = a.newValue;
                this.m.sendMessage(e);
                break;
            case "ActualPixelScalingRatio":
                {
                    var f = new PixelRatioMessage_Spark();
                    f.b = a.newValue;
                    this.m.sendMessage(f);
                }
                break;
        }
        if (this.v(a)) {
            this.an(runOn(this, this.ao));
        }
    };
    SparklineController.prototype.at = function () {
        var a = new ClearMessage_Spark();
        a.c = true;
        this.m.sendMessage(a);
    };
    SparklineController.prototype.a1 = function (a) {
        this.a3 = new Rect(0, a.newLeft, a.newTop, a.newWidth, a.newHeight);
        this.an(runOn(this, this.ao));
    };
    SparklineController.prototype.al = function (a) {
        var b = new ClearMessage_Spark();
        b.b = 4;
        this.m.sendMessage(b);
        var c = new TooltipMessage_Spark();
        c.b = 4;
        c.xOffset = a.position.x + 10;
        c.yOffset = a.position.y + 10;
        if (this.t != null && this.t.count > 0) {
            var d = new SparklineToolTipContext();
            d.high = this.t.maximum;
            d.low = this.t.minimum;
            d.first = this.t.item(0);
            d.last = this.t.item(this.t.count - 1);
            c.context = d;
        }
        this.m.sendMessage(c);
    };
    SparklineController.prototype.ak = function (a) {
        var b = new ClearMessage_Spark();
        b.b = 4;
        this.m.sendMessage(b);
    };
    SparklineController.prototype.af = function (a) {
        var b = new ClearMessage_Spark();
        b.b = a;
        this.m.sendMessage(b);
    };
    SparklineController.prototype.ae = function () {
        this.af(1);
        this.af(2);
        this.af(16);
        this.af(8);
    };
    SparklineController.prototype.ao = function () {
        this.ae();
        if (!this.w()) {
            return;
        }
        this.o.b = this;
        this.o.e(this.n);
        switch (this.q.am) {
            case 2:
                this.ap();
                break;
            case 3:
                this.as();
                break;
            case 0:
            case 1:
                this.ar();
                break;
        }
        var a = new NormalRangeMessage_Spark();
        a.k = this.a3.left;
        a.l = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bf)));
        a.j = this.a3.width;
        var b = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bg)));
        a.i = Math.abs(b - a.l);
        a.l = Math.min(a.l, b);
        a.d = this.q.as;
        this.m.sendMessage(a);
        var c = new TrendLineMessage_Spark();
        c.points = this.n.l.toArray();
        this.m.sendMessage(c);
    };
    SparklineController.prototype.ap = function () {
        var a = new ColumnMessage_Spark();
        a.d = this.n.j;
        a.g = this.n.k;
        a.f = this.n.i;
        a.e = this.n.h;
        a.k = this.n.m;
        a.l = this.n.n;
        a.j = this.n.g.count;
        a.h = this.o.c;
        a.i = this.o.d;
        a.c = this.q.am;
        this.m.sendMessage(a);
        this.aq();
    };
    SparklineController.prototype.as = function () {
        var a = new WinLossColumnMessage_Spark();
        a.d = this.n.j;
        a.g = this.n.k;
        a.f = this.n.i;
        a.e = this.n.h;
        a.k = this.n.m;
        a.l = this.n.n;
        a.j = this.n.g.count;
        a.h = this.o.c;
        a.i = this.o.d;
        a.c = this.q.am;
        this.m.sendMessage(a);
    };
    SparklineController.prototype.ar = function () {
        var e_5, _a, e_6, _b, e_7, _c;
        if (this.n.g.count == 0) {
            return;
        }
        var a = new List$1(List$1.$.specialize(Array_$type), 0);
        var b = new List$1(Array_$type, 0);
        var c = true;
        try {
            for (var _d = __values(fromEnum(this.n.g)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var d = _e.value;
                if (isNaN_(d[1]) || isInfinity(d[1])) {
                    if (!c) {
                        a.add(b);
                    }
                    c = true;
                    continue;
                }
                if (c) {
                    b = new List$1(Array_$type, 0);
                    c = false;
                }
                b.add(d);
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return))
                    _a.call(_d);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        if (!c) {
            a.add(b);
        }
        var e = new PolygonMessage_Spark();
        e.points = new List$1(Array_$type, 0);
        if (this.q.ao == 0) {
            var f = new List$1(Array_$type, 0);
            try {
                for (var _f = __values(fromEnum(a)), _g = _f.next(); !_g.done; _g = _f.next()) {
                    var g = _g.value;
                    f.o(g);
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_g && !_g.done && (_b = _f.return))
                        _b.call(_f);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
            var h = this.j(f);
            e.points.add(h);
        }
        else {
            try {
                for (var _h = __values(fromEnum(a)), _j = _h.next(); !_j.done; _j = _h.next()) {
                    var i = _j.value;
                    var j = this.j(i);
                    e.points.add(j);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_j && !_j.done && (_c = _h.return))
                        _c.call(_h);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        this.m.sendMessage(e);
        this.aq();
    };
    SparklineController.prototype.j = function (a) {
        var e_8, _a, e_9, _b;
        var b = this.o.c;
        var c = new List$1(Point_$type, 0);
        var d;
        var e = this.q.am == 1;
        try {
            for (var _c = __values(fromEnum(a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var f = _d.value;
                d = f[1];
                if (e) {
                    if (f[2] <= b) {
                        d = f[2];
                    }
                }
                c.add({ $type: Point_$type, x: f[0], y: d });
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        if (this.q.am == 0) {
            var g = new List$1(Point_$type, 0);
            try {
                for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var h = _f.value;
                    g.add({ $type: Point_$type, x: h[0], y: h[2] });
                }
            }
            catch (e_9_1) {
                e_9 = { error: e_9_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_9)
                        throw e_9.error;
                }
            }
            g.w();
            c.o(g);
        }
        if (this.q.am == 1 && c.count > 0) {
            var i = c._inner[0];
            var j = c._inner[c.count - 1];
            c.add({ $type: Point_$type, x: j.x, y: this.o.c });
            c.add({ $type: Point_$type, x: i.x, y: this.o.c });
        }
        return c.toArray();
    };
    SparklineController.prototype.aq = function () {
        var a = new MarkerMessage_Spark();
        a.e = this.n.j;
        a.f = this.n.k;
        a.d = this.n.i;
        a.c = this.n.h;
        a.m = this.n.m;
        a.n = this.n.n;
        a.k = this.q.a9;
        a.g = this.q.a2;
        a.i = this.q.a4;
        a.h = this.q.a3;
        a.j = this.q.a8;
        a.l = this.q.be;
        this.m.sendMessage(a);
    };
    SparklineController.prototype.getFastItemsSource = function (a) {
        var b = null;
        if (this.x != null) {
            var c = null;
            b = new FastItemsSource();
            b.e = this.x;
            c = new FastItemsSourceReference(b);
            c.b++;
            b = c.a;
        }
        return b;
    };
    SparklineController.prototype.releaseFastItemsSource = function (a) {
        if (a != null) {
            var b = null;
            --b.b;
        }
        return null;
    };
    SparklineController.$t = markType(SparklineController, 'SparklineController', DependencyObject.$, [IFastItemsSourceProvider_$type]);
    SparklineController.a2 = DependencyProperty.i("FastItemsSource", IFastItemsSource_$type, SparklineController.$, new PropertyMetadata(1, function (a, b) { return (typeCast(SparklineController.$, a)).av(b.oldValue, b.newValue); }));
    return SparklineController;
}(DependencyObject));
/**
 * @hidden
 */
var XamSparkline = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamSparkline, _super);
    function XamSparkline() {
        var _this = _super.call(this) || this;
        _this.al = null;
        _this.aj = null;
        _this.ah = new MessageChannel_Spark();
        _this.aw = NaN;
        _this.av = NaN;
        _this.ar = null;
        _this.ag = null;
        _this.ap = null;
        _this.ay = NaN;
        _this.ax = 1;
        _this.ab = XamSparkline.$;
        _this.ap = new VerticalAxisView(_this);
        _this.ag = new HorizontalAxisView(_this);
        _this.al = new SparklineConnector(_this, new XamSparklineView());
        return _this;
    }
    Object.defineProperty(XamSparkline.prototype, "toolTip", {
        get: function () {
            return this.c(XamSparkline.ej);
        },
        set: function (a) {
            this.h(XamSparkline.ej, a);
            this.fe = a == null || a.toString().length == 0 ? 1 : 0;
        },
        enumerable: true,
        configurable: true
    });
    XamSparkline.prototype.at = function () {
        return this.bl != null;
    };
    XamSparkline.prototype.cu = function (a) {
        return this.bl(a);
    };
    Object.defineProperty(XamSparkline.prototype, "ak", {
        get: function () {
            return this.aj;
        },
        set: function (a) {
            var b = this.aj;
            this.aj = a;
            this.dh(b, this.aj);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparkline.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            this.ah = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparkline.prototype, "a0", {
        get: function () {
            return this.aw;
        },
        set: function (a) {
            this.aw = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparkline.prototype, "az", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            this.av = a;
        },
        enumerable: true,
        configurable: true
    });
    XamSparkline.prototype.dh = function (a, b) {
        if (a != null) {
            this.ai.detachFromNext();
        }
        if (b != null) {
            this.ai.connectTo(b.getService("ConfigurationMessages"));
        }
    };
    XamSparkline.prototype.onDetachedFromUI = function () {
        this.al.e.at();
    };
    XamSparkline.prototype.onAttachedToUI = function () {
        this.al.e.ar();
    };
    XamSparkline.prototype.dg = function (a, b, c) {
        if (a == "PixelScalingRatio") {
            if (!isNaN_(DeviceUtils.a(this.bh))) {
                this.a1 = DeviceUtils.a(this.bh);
            }
        }
        this.ai.sendMessage(((function () {
            var $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = a;
            $ret.oldValue = b;
            $ret.newValue = c;
            return $ret;
        })()));
    };
    XamSparkline.prototype.destroy = function () {
        this.ai.sendMessage(((function () {
            var $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = "Container";
            $ret.newValue = null;
            return $ret;
        })()));
    };
    XamSparkline.prototype.provideContainer = function (a) {
        this.ai.sendMessage(((function () {
            var $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = "Container";
            $ret.newValue = a;
            return $ret;
        })()));
    };
    XamSparkline.prototype.notifyResized = function () {
        this.ai.sendMessage(new ContainerSizeChangedMessage_Spark());
    };
    XamSparkline.prototype.dd = function (source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.ai.sendMessage(((function () {
            var $ret = new DataChangedMessage_Spark();
            $ret.b = 2;
            $ret.e = b;
            $ret.d = c;
            $ret.c = a;
            return $ret;
        })()));
    };
    XamSparkline.prototype.c9 = function (source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.ai.sendMessage(((function () {
            var $ret = new DataChangedMessage_Spark();
            $ret.b = 4;
            return $ret;
        })()));
    };
    XamSparkline.prototype.da = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.ai.sendMessage(((function () {
            var $ret = new DataChangedMessage_Spark();
            $ret.b = 0;
            $ret.d = b;
            $ret.c = a;
            return $ret;
        })()));
    };
    XamSparkline.prototype.db = function (source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.ai.sendMessage(((function () {
            var $ret = new DataChangedMessage_Spark();
            $ret.b = 1;
            $ret.e = b;
            $ret.c = a;
            return $ret;
        })()));
    };
    XamSparkline.prototype.aq = function () {
        var a = new SparklineVisualData();
        a.name = "SparklineVisualData";
        a.horizontalAxis = this.ag.i();
        a.verticalAxis = this.ap.i();
        this.al.e.am(a);
        return a;
    };
    XamSparkline.prototype.bu = function () {
        var a = this.aq();
        a.scaleByViewport();
        return a.serialize();
    };
    Object.defineProperty(XamSparkline.prototype, "bh", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            this.dg("PixelScalingRatio", b, this.ay);
            if (this.ay != b) {
                this.dg("PixelScalingRatio", b, this.ay);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XamSparkline.prototype, "a1", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (this.ax != b) {
                this.dg("ActualPixelScalingRatio", b, this.ax);
            }
        },
        enumerable: true,
        configurable: true
    });
    XamSparkline.$t = markType(XamSparkline, 'XamSparkline', Control.$);
    XamSparkline.bb = -1;
    XamSparkline.a7 = -1;
    XamSparkline.ej = DependencyProperty.i("ToolTip", Base.$, XamSparkline.$, new PropertyMetadata(2, null, function (a, b) { return (typeCast(XamSparkline.$, a)).dg("ToolTip", b.oldValue, b.newValue); }));
    XamSparkline.bk = -1;
    XamSparkline.$$p = markDep(DependencyProperty, PropertyMetadata, XamSparkline, 'dg', ['Brush:eu:dj', [Brush.$, null], 'DisplayNormalRangeInFront:as:dk', [0, true], 'DisplayType:am:dl', [SparklineDisplayType_$type, enumGetBox(SparklineDisplayType_$type, 0)], 'FirstMarkerBrush:ev:dm', [Brush.$, null], 'FirstMarkerSize:a2:dn', [1, XamSparkline.bb], 'FirstMarkerVisibility:e6:dp', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'FormatLabel:bl:dq', [Delegate_$type], 'HighMarkerBrush:ew:dr', [Brush.$, null], 'HighMarkerSize:a3:ds', [1, XamSparkline.bb], 'HighMarkerVisibility:e7:dt', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'HorizontalAxisBrush:ex:du', [Brush.$, null], 'HorizontalAxisLabel:bn:dv', [4, "{0}"], 'HorizontalAxisVisibility:e8:dw', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'ItemsSource::dx', [IEnumerable_$type, null], 'LabelMemberPath:b7:dy', [2, null], 'LastMarkerBrush:ey:dz', [Brush.$, null], 'LastMarkerSize:a4:d0', [1, XamSparkline.bb], 'LastMarkerVisibility:e9:d1', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'LineThickness:a5:d2', [1, XamSparkline.a7], 'LowMarkerBrush:ez:d3', [Brush.$, null], 'LowMarkerSize:a8:d4', [1, XamSparkline.bb], 'LowMarkerVisibility:fa:d5', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'MarkerBrush:e0:d6', [Brush.$, null], 'MarkerSize:a9:d7', [1, XamSparkline.bb], 'MarkerVisibility:fb:d8', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'Maximum:bc:d9', [1, NaN], 'Minimum:bd:ea', [1, NaN], 'NegativeBrush:e1:eb', [Brush.$, null], 'NegativeMarkerBrush:e2:ec', [Brush.$, null], 'NegativeMarkerSize:be:ed', [1, XamSparkline.bb], 'NegativeMarkerVisibility:fc:ee', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'NormalRangeFill:e3:ef', [Brush.$, null], 'NormalRangeMaximum:bf:eg', [1, 0], 'NormalRangeMinimum:bg:eh', [1, 0], 'NormalRangeVisibility:fd:ei', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'ToolTipVisibility:fe:ek', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'TrendLineBrush:e4:el', [Brush.$, null], 'TrendLinePeriod:bm:em', [1, 7], 'TrendLineThickness:bi:en', [1, XamSparkline.bk], 'TrendLineType:an:eo', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'UnknownValuePlotting:ao:ep', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)], 'ValueMemberPath:c2:eq', [2, null], 'VerticalAxisBrush:e5:er', [Brush.$, null], 'VerticalAxisLabel:bp:es', [4, "{0:n}"], 'VerticalAxisVisibility:ff:et', [Visibility_$type, enumGetBox(Visibility_$type, 1)]]);
    return XamSparkline;
}(Control));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var defaultFont$1 = "Verdana, \"Segoe UI\", Arial, \"Myriad Pro\", sans-serif";
var SparklineStylingDefaults = {
    //"ui-lineargauge-backing": {
    //    "background-color": "#ffffff",
    //    "border-color": "#ffffff"
    //},
    "ui-sparkline-axis": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    "ui-sparkline-axis-x": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    "ui-sparkline-axis-y": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    //.ui-chart-tooltip
    //{
    //    -moz-box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    -webkit-box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    padding: 5px 8px;
    //    font-size: 12px;
    //    font-family:"Segoe UI", Arial, sans-serif;
    //}
    "font-family": defaultFont$1,
    "font-style": "normal",
    "font-weight": "normal",
    "font-size": "13px",
    "color": "#666666",
    "font-variant": "",
    "line-height": ""
};

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSparkline = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSparkline, _super);
    function IgrSparkline(props) {
        var _this = _super.call(this, props) || this;
        _this._dataSource = null;
        _this._initialized = false;
        _this._tooltipTemplate = null;
        _this._tooltipContent = null;
        _this._defaultTooltips = null;
        _this._uniqueTooltipId = 0;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._getMainRef = _this._getMainRef.bind(_this);
        _this._tooltipRef = _this._tooltipRef.bind(_this);
        _this._activeTooltipElements = new Map();
        _this._activeTooltips = new Map();
        _this._currentTooltips = [];
        var container = null;
        if (document) {
            container = document.createElement("div");
            container.style.display = "block";
            container.style.width = "100%";
            container.style.height = "100%";
        }
        var root;
        root = container;
        _this._renderer = new ReactRenderer(root, document, true, SparklineStylingDefaults);
        _this._implementation = _this.createImplementation();
        _this._container = _this._renderer.getWrapper(container);
        //this._renderer.rootWrapper.append(this._container);
        //this._container.setStyleProperty("display", "block");
        //this._container.setStyleProperty("width", "100%");
        //this._container.setStyleProperty("height", "100%");
        _this._wrapper = _this._renderer;
        //var root: any;
        //root = this._container;
        //if (this._container.nativeElement != null) {
        //    root = this._container.nativeElement;
        //}
        var sparkline = _this.i;
        _this._sparkline = sparkline;
        sparkline.provideContainer(_this._renderer);
        _this._renderer.addSizeWatcher(function () {
            _this._sparkline.notifyResized();
        });
        _this._initialized = true;
        return _this;
    }
    Object.defineProperty(IgrSparkline.prototype, "height", {
        get: function () {
            return this._height;
        },
        set: function (value) {
            this._height = value;
            if (this._elRef) {
                this._elRef.style.height = value;
                this.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "width", {
        get: function () {
            return this._width;
        },
        set: function (value) {
            this._width = value;
            if (this._elRef) {
                this._elRef.style.width = value;
                this.notifyResized();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrSparkline.prototype.render = function () {
        // if (!this._childrenDiffer(this.props.children)) {
        // 	let div = React.createElement("div", {
        // 		ref: (ref) => {
        // 			this._elRef = ref;
        // 		},
        // 		children: this.props.children
        // 	});
        // 	return div;
        // } else {
        var children = [];
        Children.forEach(this.props.children, function (ch) {
            children.push(ch);
        });
        if (this._currentTooltips && this._currentTooltips.length > 0) {
            for (var i = 0; i < this._currentTooltips.length; i++) {
                var t = this._currentTooltips[i];
                if (this._activeTooltipElements.has(t)) {
                    children.push(this._activeTooltipElements.get(t));
                }
                else {
                    if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
                        continue;
                    }
                    var Tooltip = TypeRegistrar.get("IgrTooltipContainer");
                    var tEle = createElement(Tooltip, {
                        ref: this._tooltipRef,
                        key: this._currentTooltips[i].key,
                        owner: this._currentTooltips[i]
                    });
                    var portal = createPortal(tEle, t, this._currentTooltips[i].key);
                    this._activeTooltipElements.set(t, portal);
                    children.push(portal);
                }
            }
        }
        var div = createElement("div", {
            className: "ig-sparkline igr-sparkline",
            ref: this._getMainRef,
            children: children
        });
        return div;
        //}
    };
    IgrSparkline.prototype._tooltipRef = function (t) {
        //console.log(t);
        if (t === null) {
            return;
        }
        if (t.currentOwner &&
            t.currentOwner.tooltipTemplate) {
            t.template = t.currentOwner.tooltipTemplate;
        }
        this._activeTooltips.set(t.currentOwner, t);
    };
    IgrSparkline.prototype.componentDidMount = function () {
        var e_1, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    {
                        this[p] = this.props[p];
                    }
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this._elRef.appendChild(this._container.getNativeElement());
        this.notifyResized();
        this.initializeContent();
    };
    IgrSparkline.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    Object.defineProperty(IgrSparkline.prototype, "dataSource", {
        get: function () {
            if (this._dataSource != null) {
                return this._dataSource;
            }
            return this.i.itemsSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.i.itemsSource = this._dataSource;
            //console.log("setting axis data source: " + value)
        },
        enumerable: true,
        configurable: true
    });
    IgrSparkline.prototype._getMainRef = function (div) {
        this._elRef = div;
    };
    IgrSparkline.prototype.destroy = function () {
        this._sparkline.destroy();
        this._wrapper.destroy();
    };
    IgrSparkline.prototype.createImplementation = function () {
        return new XamSparkline();
    };
    IgrSparkline.prototype.initializeContent = function () {
        this._styling(this._container.getNativeElement(), this);
        this.i.notifyResized();
    };
    IgrSparkline.prototype.componentWillUnmount = function () {
        //this._grid.destroy();
        this.destroy();
    };
    IgrSparkline.prototype.initializeProperties = function () {
        var e_3, _a;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
    };
    Object.defineProperty(IgrSparkline.prototype, "tooltipTemplate", {
        get: function () {
            return this._tooltipTemplate;
        },
        set: function (value) {
            this._tooltipTemplate = value;
            if (value == null) {
                if (this._tooltipContent !== null) {
                    this._tooltipContent.destroy();
                    this._tooltipContent = null;
                }
            }
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.template = this._tooltipTemplate;
            }
            else {
                this._ensureTooltipCreated();
            }
        },
        enumerable: true,
        configurable: true
    });
    IgrSparkline.prototype.createWrapper = function (ele) {
        var wrapper = new ReactWrapper(ele, this._renderer);
        wrapper.updateToolTip = ele.updateToolTip;
        wrapper.hideToolTip = ele.hideToolTip;
        return wrapper;
    };
    IgrSparkline.prototype._ensureDefaultTooltip = function () {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips["ensureDefaultTooltip"](this);
    };
    IgrSparkline.prototype._onDefaultTooltipsReady = function (cr) {
        this._ensureDefaultTooltip();
    };
    IgrSparkline.prototype._updateTooltipState = function () {
        if (this._initialized) {
            this.setState({ tooltips: this._currentTooltips });
        }
    };
    IgrSparkline.prototype.createTooltip = function () {
        // if (!TypeRegistrar.isRegistered("IgrTooltipContainer")) {
        // 	return null;
        // }
        // let Tooltip = TypeRegistrar.get("IgrTooltipContainer");
        var wrapper = this._wrapper.createElement("div");
        var ele = wrapper.getNativeElement();
        ele.key = "__tooltip_" + this._uniqueTooltipId;
        this._uniqueTooltipId++;
        this._currentTooltips = this._currentTooltips.slice(0);
        this._currentTooltips.push(ele);
        //let element = React.createElement(Tooltip,  );
        //let portal = ReactDOM.createPortal(element, ele);
        var self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                var ext = new IgrDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container.getNativeElement()) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.getNativeElement().appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            if (self._activeTooltips.has(ele)) {
                var t = self._activeTooltips.get(ele);
                if (t.template === null &&
                    self.tooltipTemplate !== null) {
                    t.template = self.tooltipTemplate;
                }
                t.dataContext = c;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        this._updateTooltipState();
        return ele;
    };
    IgrSparkline.prototype._ensureTooltipCreated = function () {
        if (this.i.toolTip == null) {
            var tooltip = this.createTooltip();
            var ele = tooltip;
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            //(<any>tooltip.instance).template = this._tooltipTemplate;
            this.i.toolTip = this.createWrapper(tooltip);
            if (this._activeTooltips.has(ele)) {
                var tCont = this._activeTooltips.get(ele);
                tCont.template = ele.tooltipTemplate;
            }
        }
    };
    Object.defineProperty(IgrSparkline.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: true,
        configurable: true
    });
    IgrSparkline._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgrSparkline.prototype, "brush", {
        /**
     * Gets or sets the sparkline brush.
    */
        get: function () {
            return brushToString(this.i.eu);
        },
        set: function (v) {
            this.i.eu = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "negativeBrush", {
        /**
         * Gets or sets the negative brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e1);
        },
        set: function (v) {
            this.i.e1 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "markerBrush", {
        /**
         * Gets or sets the marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e0);
        },
        set: function (v) {
            this.i.e0 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "negativeMarkerBrush", {
        /**
         * Gets or sets the negative marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e2);
        },
        set: function (v) {
            this.i.e2 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "firstMarkerBrush", {
        /**
         * Gets or sets the first marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.ev);
        },
        set: function (v) {
            this.i.ev = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lastMarkerBrush", {
        /**
         * Gets or sets the last marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.ey);
        },
        set: function (v) {
            this.i.ey = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "highMarkerBrush", {
        /**
         * Gets or sets the high marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.ew);
        },
        set: function (v) {
            this.i.ew = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lowMarkerBrush", {
        /**
         * Gets or sets the low marker brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.ez);
        },
        set: function (v) {
            this.i.ez = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "trendLineBrush", {
        /**
         * Gets or sets the trendline brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e4);
        },
        set: function (v) {
            this.i.e4 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "horizontalAxisBrush", {
        /**
         * Gets or sets the horizontal axis line brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.ex);
        },
        set: function (v) {
            this.i.ex = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "verticalAxisBrush", {
        /**
         * Gets or sets the vertical axis line brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e5);
        },
        set: function (v) {
            this.i.e5 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "normalRangeFill", {
        /**
         * Gets or sets the normal range brush of the sparkline.
        */
        get: function () {
            return brushToString(this.i.e3);
        },
        set: function (v) {
            this.i.e3 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "horizontalAxisVisibility", {
        /**
         * Gets or sets the display state of the horizontal axis.
        */
        get: function () {
            return this.i.e8;
        },
        set: function (v) {
            this.i.e8 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "verticalAxisVisibility", {
        /**
         * Gets or sets the display state of the vertical axis.
        */
        get: function () {
            return this.i.ff;
        },
        set: function (v) {
            this.i.ff = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "markerVisibility", {
        /**
         * Gets or sets the marker visibility of the sparkline.
        */
        get: function () {
            return this.i.fb;
        },
        set: function (v) {
            this.i.fb = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "negativeMarkerVisibility", {
        /**
         * Gets or sets the negative marker visibility of the sparkline.
        */
        get: function () {
            return this.i.fc;
        },
        set: function (v) {
            this.i.fc = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "firstMarkerVisibility", {
        /**
         * Gets or sets the first marker visibility of the sparkline.
        */
        get: function () {
            return this.i.e6;
        },
        set: function (v) {
            this.i.e6 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lastMarkerVisibility", {
        /**
         * Gets or sets the last marker visibility of the sparkline.
        */
        get: function () {
            return this.i.e9;
        },
        set: function (v) {
            this.i.e9 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lowMarkerVisibility", {
        /**
         * Gets or sets the low marker visibility of the sparkline.
        */
        get: function () {
            return this.i.fa;
        },
        set: function (v) {
            this.i.fa = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "highMarkerVisibility", {
        /**
         * Gets or sets the high marker visibility of the sparkline.
        */
        get: function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "normalRangeVisibility", {
        /**
         * Gets or sets the normal range visibility of the sparkline.
        */
        get: function () {
            return this.i.fd;
        },
        set: function (v) {
            this.i.fd = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "displayNormalRangeInFront", {
        /**
         * Gets or sets the position of the normal range on the sparkline.
        */
        get: function () {
            return this.i.as;
        },
        set: function (v) {
            this.i.as = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "markerSize", {
        /**
         * Gets or sets the marker size of the sparkline.
        */
        get: function () {
            return this.i.a9;
        },
        set: function (v) {
            this.i.a9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "firstMarkerSize", {
        /**
         * Gets or sets the first marker size of the sparkline.
        */
        get: function () {
            return this.i.a2;
        },
        set: function (v) {
            this.i.a2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lastMarkerSize", {
        /**
         * Gets or sets the last marker size of the sparkline.
        */
        get: function () {
            return this.i.a4;
        },
        set: function (v) {
            this.i.a4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "highMarkerSize", {
        /**
         * Gets or sets the high marker size of the sparkline.
        */
        get: function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lowMarkerSize", {
        /**
         * Gets or sets the low marker size of the sparkline.
        */
        get: function () {
            return this.i.a8;
        },
        set: function (v) {
            this.i.a8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "negativeMarkerSize", {
        /**
         * Gets or sets the negative marker size of the sparkline.
        */
        get: function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "lineThickness", {
        /**
         * Gets or sets the line thickness of the sparkline.
        */
        get: function () {
            return this.i.a5;
        },
        set: function (v) {
            this.i.a5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "minimum", {
        /**
         * Gets or sets the minimum value of the y axis.
        */
        get: function () {
            return this.i.bd;
        },
        set: function (v) {
            this.i.bd = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "maximum", {
        /**
         * Gets or sets the maximum value of the y axis.
        */
        get: function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "valueMemberPath", {
        /**
         * Gets or sets the string path to the value column.
        */
        get: function () {
            return this.i.c2;
        },
        set: function (v) {
            this.i.c2 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "labelMemberPath", {
        /**
         * String identifier of a column or property name to get labels from on each item in the data source.  These labels will be retrieved from the first and last item, and displayed by the horizontal axis.
        */
        get: function () {
            return this.i.b7;
        },
        set: function (v) {
            this.i.b7 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "trendLineType", {
        /**
         * Gets or sets the type of trendline used by the sparkline.
        */
        get: function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "trendLinePeriod", {
        /**
         * Gets or sets the trendline period used by the sparkline.
        */
        get: function () {
            return this.i.bm;
        },
        set: function (v) {
            this.i.bm = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the sparkline's trendline.
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "normalRangeMinimum", {
        /**
         * Gets or sets the minimum value of the normal range.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "normalRangeMaximum", {
        /**
         * Gets or sets the maximum value of the normal range.
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "displayType", {
        /**
         * Gets or sets the display type of the sparkline.
        */
        get: function () {
            return this.i.am;
        },
        set: function (v) {
            this.i.am = ensureEnum(SparklineDisplayType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "unknownValuePlotting", {
        /**
         * Gets or sets the way null values are interpreted.
        */
        get: function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "verticalAxisLabel", {
        /**
         * The value or content to display on the vertical axis.
         * This can be set to a formatted string, such as "{0:n}", or it can be set to a DataTemplate.
        */
        get: function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "horizontalAxisLabel", {
        /**
         * The value or content to display on the horizontal axis.
         * This can be set to a formatted string, such as "{0}", or it can be set to a DataTemplate.
        */
        get: function () {
            return this.i.bn;
        },
        set: function (v) {
            this.i.bn = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the actual scaling value used by the component to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: function () {
            return this.i.a1;
        },
        set: function (v) {
            this.i.a1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrSparkline.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: true,
        configurable: true
    });
    IgrSparkline.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrSparkline.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Sparkline");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    /**
 * Provides a container to the sparkline control.

* @param container  * The container.
*/
    IgrSparkline.prototype.provideContainer = function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Notify that the control has resized.
    
    */
    IgrSparkline.prototype.notifyResized = function () {
        this.i.notifyResized();
    };
    IgrSparkline.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.dd(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the IgxSparklineComponent that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    */
    IgrSparkline.prototype.notifyClearItems = function (source_) {
        this.i.c9(source_);
    };
    IgrSparkline.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.da(source_, index, newItem);
    };
    IgrSparkline.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.db(source_, index, oldItem);
    };
    /**
     * Returns the sparkline visuals expressed as a SparklineVisualData object.
    
    */
    IgrSparkline.prototype.exportVisualData = function () {
        var iv = this.i.aq();
        return (iv);
    };
    /**
     * Returns visuals as a serialized string.
    
    */
    IgrSparkline.prototype.exportSerializedVisualData = function () {
        var iv = this.i.bu();
        return (iv);
    };
    return IgrSparkline;
}(Component));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSparklineCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSparklineCoreModule() {
    }
    IgrSparklineCoreModule.register = function () {
        TypeRegistrar.registerCons('IgrSparkline', IgrSparkline);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    };
    return IgrSparklineCoreModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgrSparklineModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrSparklineModule() {
    }
    IgrSparklineModule.register = function () {
        IgrSparklineCoreModule.register();
        IgrDataChartInteractivityModule.register();
    };
    return IgrSparklineModule;
}());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var SparkLayerType_$type = /*@__PURE__*/ markEnum('SparkLayerType', 'SparkLayer,1|MarkerLayer,2|ToolTipLayer,4|RangeLayer,8|TrendLayer,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var MessageHandler_Spark = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(MessageHandler_Spark, _super);
    function MessageHandler_Spark() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = DictionaryUtil.dictionaryCreate();
        return _this;
    }
    MessageHandler_Spark.prototype.addHandler = function (a, b) {
        this.a.set(a.typeName, b);
    };
    MessageHandler_Spark.prototype.messageReceived = function (a) {
        var b;
        var c = getInstanceType(a).typeName;
        if (this.a.has(c)) {
            b = this.a.get(c);
            b(a);
        }
    };
    MessageHandler_Spark.$t = markType(MessageHandler_Spark, 'MessageHandler_Spark');
    return MessageHandler_Spark;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ZoomSliderCursor_$type = /*@__PURE__*/ markEnum('ZoomSliderCursor', 'Default,0|LeftRight,1|UpDown,2|Move,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var TrackShadeOrientation_$type = /*@__PURE__*/ markEnum('TrackShadeOrientation', 'HorizontalLower,0|HorizontalHigher,1|VerticalLower,2|VerticalHigher,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var ZoomSliderVisualArea_$type = /*@__PURE__*/ markEnum('ZoomSliderVisualArea', 'LowerThumb,0|HigherThumb,1|LowerShade,2|HigherShade,3|RangeThumb,4|Bar,5|None,6');

export { AbsoluteVolumeOscillatorIndicator, AbsoluteVolumeOscillatorIndicatorStrategy, AccumulationDistributionIndicator, AccumulationDistributionIndicatorStrategy, AnchoredCategoryBucketCalculator, AnchoredCategorySeries, AnchoredCategorySeriesInteractionManager, AnchoredCategorySeriesView, AnchoredRadialBucketCalculator, AnchoredRadialSeries, AnchoredRadialSeriesView, AngleAxisLabelPanel, AngleAxisLabelPanelView, AngleRadiusPair, AnnotationFactoryManager, AnnotationInfoProvider, AnnotationLayer, AnnotationLayerProxy, AnnotationLayerView, Arc, ArcItem, ArcView, ArcVisualData, ArcVisualDataList, AreaFragment, AreaFragmentBucketCalculator, AreaFragmentView, AreaInfo, AreaSeries, AreaSeriesView, AssigningCategoryMarkerStyleEventArgs, AssigningCategoryStyleEventArgs, AssigningCategoryStyleEventArgsBase, AutoRangeCalculator, AverageDirectionalIndexIndicator, AverageDirectionalIndexIndicatorStrategy, AverageTrueRangeIndicator, AverageTrueRangeIndicatorStrategy, Axis, AxisAnnotation, AxisAnnotationFrame, AxisAnnotationFrameManager, AxisAnnotationManager, AxisCollection, AxisComponentsForView, AxisComponentsFromView, AxisExtentType, AxisExtentType_$type, AxisLabelInfo, AxisLabelManager, AxisLabelPanelBase, AxisLabelPanelBaseView, AxisLabelSettings, AxisLabelVisualData, AxisLabelVisualDataList, AxisLabelsLocation, AxisLabelsLocation_$type, AxisOrientation, AxisOrientation_$type, AxisRange, AxisRangeChangedEventArgs, AxisRenderMessage_Spark, AxisRendererBase, AxisRenderingParametersBase, AxisTitlePosition, AxisTitlePosition_$type, AxisView, AxisVisualData, AxisVisualDataList, AxisVisualDataManager, BarBucketCalculator, BarFragment, BarFramePreparer, BarSeries, BarSeriesView, BarTrendFitCalculator, BarTrendLineManager, BollingerBandWidthIndicator, BollingerBandWidthIndicatorStrategy, BollingerBandsBucketCalculator, BollingerBandsOverlay, BollingerBandsOverlayView, BrushChangedMessage_Spark, BrushScale, BrushSelectionMode, BrushSelectionMode_$type, BubbleMarkerManager, BubbleSeries, BubbleSeriesView, CalculatedColumn, CalloutAnnotation, CalloutAnnotationCollection, CalloutAnnotationWrapper, CalloutCollisionMode, CalloutCollisionMode_$type, CalloutContentUpdatingEventArgs, CalloutKey, CalloutLabelUpdatingEventArgs, CalloutLayer, CalloutLayerFrame, CalloutLayerView, CalloutSeriesSelectingEventArgs, CalloutStyleUpdatingEventArgs, CalloutView, CalloutViewHelper, CalloutVisualData, CalloutVisualDataList, CategoryAngleAxis, CategoryAngleAxisView, CategoryAxisBase, CategoryAxisBaseView, CategoryAxisRenderer, CategoryAxisRenderingParameters, CategoryBucketCalculator, CategoryChart, CategoryChartType, CategoryChartType_$type, CategoryDateTimeXAxis, CategoryDateTimeXAxisView, CategoryErrorBarSettings, CategoryFrame, CategoryFramePreparer, CategoryFramePreparerBase, CategoryHighlightFrameRect, CategoryHighlightLayer, CategoryHighlightLayerFrame, CategoryHighlightLayerView, CategoryItemHighlightLayer, CategoryItemHighlightLayerFrame, CategoryItemHighlightLayerView, CategoryItemHighlightType, CategoryItemHighlightType_$type, CategoryLineRasterizer, CategoryMarkerManager, CategoryMode_$type, CategorySeries, CategorySeriesInteractionManager, CategorySeriesMarkerCollisionAvoidance, CategorySeriesMarkerCollisionAvoidance_$type, CategorySeriesRenderManager, CategorySeriesView, CategoryTickmarkValues, CategoryToolTipCollisionInfo, CategoryToolTipLayer, CategoryToolTipLayerFrame, CategoryToolTipLayerView, CategoryTooltipLayerPosition, CategoryTooltipLayerPosition_$type, CategoryTooltipSeriesInfo, CategoryTransitionInMode, CategoryTransitionInMode_$type, CategoryTransitionSourceFramePreparer, CategoryTrendLineManager, CategoryTrendLineManagerBase, CategoryTrendLineManagerFactory, CategoryXAxis, CategoryXAxisView, CategoryYAxis, CategoryYAxisView, ChaikinOscillatorIndicator, ChaikinOscillatorIndicatorStrategy, ChaikinVolatilityIndicator, ChaikinVolatilityIndicatorStrategy, ChartAxisRangeChangedEventArgs, ChartCollection, ChartContentManager, ChartContentType_$type, ChartCursorEventArgs, ChartHitTestMode, ChartHitTestMode_$type, ChartMouseEventArgs, ChartSeriesEventArgs, ChartTitleVisualData, ChartTitleVisualDataList, ChartVisualData, ClearMessage_Spark, CoercionInfo, CollisionAvoidanceType, CollisionAvoidanceType_$type, CollisionAvoider, ColorScale, ColorScaleInterpolationMode, ColorScaleInterpolationMode_$type, ColumnFragment, ColumnFragmentView, ColumnMessage_Spark, ColumnSeries, ColumnSeriesView, ColumnSupportingCalculation, CommodityChannelIndexIndicator, CommodityChannelIndexIndicatorStrategy, ConfigurationMessage_Spark, ConsolidatedItemHitTestBehavior, ConsolidatedItemHitTestBehavior_$type, ConsolidatedItemsPosition, ConsolidatedItemsPosition_$type, ContainerMessage_Spark, ContainerResizedMessage_Spark, ContainerSizeChangedMessage_Spark, ContentInfo, ContourBuilder, ContourValueResolver, CrosshairLayer, CrosshairLayerFrame, CrosshairLayerView, CrosshairsDisplayMode, CrosshairsDisplayMode_$type, CustomContourValueResolver, CustomContourValueResolverEventArgs, CustomIndicator, CustomIndicatorNameCollection, CustomIndicatorStrategy, CustomPaletteBrushScale, CustomPaletteColorScale, DataChangedMessage_Spark, DataChartMouseButtonEventArgs, DataChartStylingDefaults, DataChartVisualDataManager, DataSourceManager, DataSourceSupportingCalculation, DefaultCategoryTrendlineHost, DefaultCategoryTrendlinePreparer, DefaultFlattener, DefaultHighLowValueProvider, DefaultPaletteInfo, DefaultProvidesViewport, DefaultSingleValueProvider, DefaultSupportsErrorBars, DefaultSupportsMarkers, DefaultTrackBarVisual, DefaultTrackRangeVisual, DefaultTrackShadeVisual, DefaultTrackThumbCalloutVisual, DefaultTrackThumbVisual, DelegateClipper, DetrendedPriceOscillatorIndicator, DetrendedPriceOscillatorIndicatorStrategy, DictInterpolator$3, DomainChart, DomainChartSeriesPointerEventArgs, DoughnutChartLabelVisualData, DoughnutChartVisualData, EaseOfMovementIndicator, EaseOfMovementIndicatorStrategy, EnableErrorBars, EnableErrorBars_$type, ErrorBarSettingsBase, ErrorBarsHelper, FastHorizontalLinearScaler, FastStochasticOscillatorIndicator, FastStochasticOscillatorIndicatorStrategy, FastVerticalLinearScaler, FinalValueLayer, FinalValueLayerFrame, FinalValueLayerView, FinalValueSelectionMode, FinalValueSelectionMode_$type, FinancialBucketCalculator, FinancialCalculationDataSource, FinancialCalculationSupportingCalculations, FinancialChart, FinancialChartContext, FinancialChartCustomIndicatorArgs, FinancialChartDropDownControl, FinancialChartDropDownControlView, FinancialChartDropDownControlViewModel, FinancialChartEnumCollectionPickerVisualData, FinancialChartEnumPickerVisualData, FinancialChartIndicatorMenu, FinancialChartIndicatorMenuContext, FinancialChartIndicatorMenuItem, FinancialChartIndicatorMenuItems, FinancialChartIndicatorMenuView, FinancialChartIndicatorMenuViewModel, FinancialChartRangeSelector, FinancialChartRangeSelectorContext, FinancialChartRangeSelectorOption, FinancialChartRangeSelectorOptionCollection, FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorView, FinancialChartRangeSelectorViewModel, FinancialChartRangeSelectorVisualData, FinancialChartToolbar, FinancialChartToolbarContext, FinancialChartToolbarViewModel, FinancialChartToolbarVisualData, FinancialChartType, FinancialChartTypePicker, FinancialChartTypePickerContext, FinancialChartTypePickerView, FinancialChartTypePickerViewModel, FinancialChartType_$type, FinancialChartViewModel, FinancialChartVisualData, FinancialChartVolumeType, FinancialChartVolumeType_$type, FinancialChartXAxisMode, FinancialChartXAxisMode_$type, FinancialChartYAxisMode, FinancialChartYAxisMode_$type, FinancialChartZoomSliderType, FinancialChartZoomSliderType_$type, FinancialEventArgs, FinancialIndicator, FinancialIndicatorBucketCalculator, FinancialIndicatorType, FinancialIndicatorTypeCollection, FinancialIndicatorType_$type, FinancialIndicatorView, FinancialLegend, FinancialLegendView, FinancialLegendViewManager, FinancialOverlay, FinancialOverlayType, FinancialOverlayTypeCollection, FinancialOverlayType_$type, FinancialPriceBucketCalculator, FinancialPriceSeries, FinancialPriceSeriesProxy, FinancialPriceSeriesView, FinancialSeries, FinancialSeriesView, FinancialValueList, FlattenedShape, ForceIndexIndicator, ForceIndexIndicatorStrategy, FragmentBase, Frame, FrameExtended, FramePreparer, FullStochasticOscillatorIndicator, FullStochasticOscillatorIndicatorStrategy, GradientData, GradientStopData, GridMode, GridMode_$type, HierarchicalRingSeries, HighDensityScatterSeries, HighDensityScatterSeriesView, HighLowValuesHolder, HighlightingInfo, HighlightingManager, HighlightingMode, HighlightingMode_$type, HighlightingState, HighlightingState_$type, HoleDimensionsChangedEventArgs, HorizontalAnchoredCategorySeries, HorizontalAnchoredCategorySeriesInteractionManager, HorizontalAnchoredCategorySeriesProxy, HorizontalAxisLabelPanel, HorizontalAxisLabelPanelBase, HorizontalAxisLabelPanelBaseView, HorizontalAxisView, HorizontalLinearScaler, HorizontalLogarithmicScaler, HorizontalRangeCategorySeries, HorizontalRangeCategorySeriesProxy, HorizontalStackedSeriesBase, IAnchoredCategorySeriesInteractionManager_$type, IAngleScaler_$type, IAnnotationInfoProvider_$type, IAnnotationLayerProxy_$type, IAxisAnnotationManager_$type, IAxisAnnotation_$type, IAxisVisualDataManager_$type, IBarSeries_$type, IBucketizer_$type, ICategoryScaler_$type, ICategorySeriesInteractionManager_$type, IDataChartVisualDataManager_$type, IDateTimeAxis_$type, IDetectsCollisions_$type, IDomainChartWidget_$type, IFinancialPriceSeriesProxy_$type, IFlattener_$type, IHasCategoryAxis_$type, IHasCategoryModePreference_$type, IHasCategoryTrendline_$type, IHasHighLowValueCategory_$type, IHasSingleValueCategory_$type, IHasTrendline_$type, IHighlightingManager_$type, IHorizontalAnchoredCategorySeriesInteractionManager_$type, IHorizontalAnchoredCategorySeriesProxy_$type, IHorizontalRangeCategorySeriesProxy_$type, IIndicatorProxy_$type, IIsCategoryBased_$type, INumberAbbreviator_$type, IOverlayProxy_$type, IPolarRadialRenderingParameters_$type, IPreparesCategoryTrendline_$type, IProvidesViewport_$type, IScaler_$type, ISeriesInteractionManager_$type, ISeriesViewerInteractionManager_$type, ISeriesViewerWidgetOptions_$type, ISeriesViewerWidget_$type, ISeriesVisualDataManager_$type, IShortPeriodLongPeriod_$type, ISortingAxis_$type, IStacked100Series_$type, ISupportsErrorBars_$type, ISupportsMarkers_$type, ITileZoomTileInfo_$type, ITileZoomTile_$type, ITimeRangeSelectorAxis_$type, ITimeXAxis_$type, ITrackBarVisual_$type, ITrackOwner_$type, ITrackRangeVisual_$type, ITrackShadeVisual_$type, ITrackThumbCalloutVisual_$type, ITrackThumbVisual_$type, ITrendLineManager_$type, ITrendLineSeries_$type, IVerticalAnchoredCategorySeriesInteractionManager_$type, IgQueue$1, IgrAbsoluteVolumeOscillatorIndicator, IgrAbsoluteVolumeOscillatorIndicatorModule, IgrAccumulationDistributionIndicator, IgrAccumulationDistributionIndicatorModule, IgrAnchoredCategorySeries, IgrAnchoredRadialSeries, IgrAnnotationLayer, IgrAnnotationLayerProxyModule, IgrAreaFragment, IgrAreaFragmentModule, IgrAreaSeries, IgrAreaSeriesModule, IgrAssigningCategoryMarkerStyleEventArgs, IgrAssigningCategoryStyleEventArgs, IgrAssigningCategoryStyleEventArgsBase, IgrAverageDirectionalIndexIndicator, IgrAverageDirectionalIndexIndicatorModule, IgrAverageTrueRangeIndicator, IgrAverageTrueRangeIndicatorModule, IgrAxis, IgrAxisAnnotation, IgrAxisAnnotationCollection, IgrAxisCollection, IgrAxisRangeChangedEventArgs, IgrBarFragment, IgrBarFragmentModule, IgrBarSeries, IgrBarSeriesModule, IgrBollingerBandWidthIndicator, IgrBollingerBandWidthIndicatorModule, IgrBollingerBandsOverlay, IgrBollingerBandsOverlayModule, IgrBrushScale, IgrBrushScaleModule, IgrBubbleSeries, IgrBubbleSeriesModule, IgrCalculatedColumn, IgrCalloutAnnotation, IgrCalloutAnnotationCollection, IgrCalloutContentUpdatingEventArgs, IgrCalloutLabelUpdatingEventArgs, IgrCalloutLayer, IgrCalloutLayerModule, IgrCalloutSeriesSelectingEventArgs, IgrCalloutStyleUpdatingEventArgs, IgrCategoryAngleAxis, IgrCategoryAngleAxisModule, IgrCategoryAxisBase, IgrCategoryChart, IgrCategoryChartCoreModule, IgrCategoryChartModule, IgrCategoryDateTimeXAxis, IgrCategoryDateTimeXAxisModule, IgrCategoryHighlightLayer, IgrCategoryHighlightLayerModule, IgrCategoryItemHighlightLayer, IgrCategoryItemHighlightLayerModule, IgrCategorySeries, IgrCategoryToolTipLayer, IgrCategoryToolTipLayerModule, IgrCategoryXAxis, IgrCategoryXAxisModule, IgrCategoryYAxis, IgrCategoryYAxisModule, IgrChaikinOscillatorIndicator, IgrChaikinOscillatorIndicatorModule, IgrChaikinVolatilityIndicator, IgrChaikinVolatilityIndicatorModule, IgrChartCursorEventArgs, IgrChartMouseEventArgs, IgrChartSeriesEventArgs, IgrColorScale, IgrColumnFragment, IgrColumnFragmentModule, IgrColumnSeries, IgrColumnSeriesModule, IgrColumnSupportingCalculation, IgrCommodityChannelIndexIndicator, IgrCommodityChannelIndexIndicatorModule, IgrContourValueResolver, IgrCrosshairLayer, IgrCrosshairLayerModule, IgrCustomContourValueResolver, IgrCustomContourValueResolverEventArgs, IgrCustomContourValueResolverModule, IgrCustomIndicator, IgrCustomIndicatorModule, IgrCustomIndicatorNameCollection, IgrCustomPaletteBrushScale, IgrCustomPaletteBrushScaleModule, IgrCustomPaletteColorScale, IgrCustomPaletteColorScaleModule, IgrDataChart, IgrDataChartAnnotationModule, IgrDataChartCategoryCoreModule, IgrDataChartCategoryModule, IgrDataChartCategoryTrendLineModule, IgrDataChartCoreModule, IgrDataChartDefaultTooltips, IgrDataChartInteractivityModule, IgrDataChartMouseButtonEventArgs, IgrDataChartPolarCoreModule, IgrDataChartPolarModule, IgrDataChartRadialCoreModule, IgrDataChartRadialModule, IgrDataChartScatterCoreModule, IgrDataChartScatterModule, IgrDataChartShapeCoreModule, IgrDataChartShapeModule, IgrDataChartStackedModule, IgrDataChartVerticalCategoryCoreModule, IgrDataChartVerticalCategoryModule, IgrDataSourceSupportingCalculation, IgrDetrendedPriceOscillatorIndicator, IgrDetrendedPriceOscillatorIndicatorModule, IgrDomainChart, IgrDomainChartSeriesPointerEventArgs, IgrDoughnutChart, IgrDoughnutChartCoreModule, IgrDoughnutChartDefaultTooltips, IgrDoughnutChartInteractivityModule, IgrDoughnutChartModule, IgrEaseOfMovementIndicator, IgrEaseOfMovementIndicatorModule, IgrFastStochasticOscillatorIndicator, IgrFastStochasticOscillatorIndicatorModule, IgrFinalValueLayer, IgrFinalValueLayerModule, IgrFinancialCalculationDataSource, IgrFinancialCalculationSupportingCalculations, IgrFinancialChart, IgrFinancialChartCoreModule, IgrFinancialChartCustomIndicatorArgs, IgrFinancialChartDefaultTemplates, IgrFinancialChartModule, IgrFinancialChartRangeSelectorOptionCollection, IgrFinancialEventArgs, IgrFinancialIndicator, IgrFinancialIndicatorTypeCollection, IgrFinancialLegend, IgrFinancialLegendModule, IgrFinancialOverlay, IgrFinancialOverlayTypeCollection, IgrFinancialPriceSeries, IgrFinancialPriceSeriesModule, IgrFinancialPriceSeriesProxyModule, IgrFinancialSeries, IgrForceIndexIndicator, IgrForceIndexIndicatorModule, IgrFragmentBase, IgrFullStochasticOscillatorIndicator, IgrFullStochasticOscillatorIndicatorModule, IgrHierarchicalRingSeries, IgrHierarchicalRingSeriesModule, IgrHighDensityScatterSeries, IgrHighDensityScatterSeriesModule, IgrHighlightingInfo, IgrHoleDimensionsChangedEventArgs, IgrHorizontalAnchoredCategorySeries, IgrHorizontalAnchoredCategorySeriesProxyModule, IgrHorizontalRangeCategorySeries, IgrHorizontalRangeCategorySeriesProxyModule, IgrHorizontalStackedSeriesBase, IgrIndexCollection, IgrIndicatorDisplayTypeCollection, IgrIndicatorProxyModule, IgrIndicatorsModule, IgrItemLegend, IgrItemLegendModule, IgrItemToolTipLayer, IgrItemToolTipLayerModule, IgrItemwiseStrategyBasedIndicator, IgrLabelClickEventArgs, IgrLegend, IgrLegendBase, IgrLegendModule, IgrLegendMouseButtonEventArgs, IgrLegendMouseEventArgs, IgrLineFragment, IgrLineFragmentModule, IgrLineSeries, IgrLineSeriesModule, IgrLinearContourValueResolver, IgrLinearContourValueResolverModule, IgrMarkerSeries, IgrMarkerTypeCollection, IgrMarketFacilitationIndexIndicator, IgrMarketFacilitationIndexIndicatorModule, IgrMassIndexIndicator, IgrMassIndexIndicatorModule, IgrMedianPriceIndicator, IgrMedianPriceIndicatorModule, IgrMoneyFlowIndexIndicator, IgrMoneyFlowIndexIndicatorModule, IgrMovingAverageConvergenceDivergenceIndicator, IgrMovingAverageConvergenceDivergenceIndicatorModule, IgrNegativeVolumeIndexIndicator, IgrNegativeVolumeIndexIndicatorModule, IgrNumberAbbreviatorModule, IgrNumericAngleAxis, IgrNumericAngleAxisModule, IgrNumericAxisBase, IgrNumericRadiusAxis, IgrNumericRadiusAxisModule, IgrNumericXAxis, IgrNumericXAxisModule, IgrNumericYAxis, IgrNumericYAxisModule, IgrOnBalanceVolumeIndicator, IgrOnBalanceVolumeIndicatorModule, IgrOrdinalTimeXAxis, IgrOrdinalTimeXAxisModule, IgrOverlayProxyModule, IgrOverlaysModule, IgrPercentChangeYAxis, IgrPercentChangeYAxisModule, IgrPercentagePriceOscillatorIndicator, IgrPercentagePriceOscillatorIndicatorModule, IgrPercentageVolumeOscillatorIndicator, IgrPercentageVolumeOscillatorIndicatorModule, IgrPieChart, IgrPieChartBase, IgrPieChartCoreModule, IgrPieChartModule, IgrPieSliceDataContext, IgrPieSliceOthersContext, IgrPointSeries, IgrPointSeriesModule, IgrPolarAreaSeries, IgrPolarAreaSeriesModule, IgrPolarBase, IgrPolarLineSeries, IgrPolarLineSeriesBase, IgrPolarLineSeriesModule, IgrPolarScatterSeries, IgrPolarScatterSeriesModule, IgrPolarSplineAreaSeries, IgrPolarSplineAreaSeriesModule, IgrPolarSplineSeries, IgrPolarSplineSeriesModule, IgrPositiveVolumeIndexIndicator, IgrPositiveVolumeIndexIndicatorModule, IgrPriceChannelOverlay, IgrPriceChannelOverlayModule, IgrPriceVolumeTrendIndicator, IgrPriceVolumeTrendIndicatorModule, IgrProgressiveLoadStatusEventArgs, IgrRadialAreaSeries, IgrRadialAreaSeriesModule, IgrRadialBase, IgrRadialColumnSeries, IgrRadialColumnSeriesModule, IgrRadialLineSeries, IgrRadialLineSeriesModule, IgrRadialPieSeries, IgrRadialPieSeriesModule, IgrRangeAreaSeries, IgrRangeAreaSeriesModule, IgrRangeCategorySeries, IgrRangeColumnSeries, IgrRangeColumnSeriesModule, IgrRateOfChangeAndMomentumIndicator, IgrRateOfChangeAndMomentumIndicatorModule, IgrRelativeStrengthIndexIndicator, IgrRelativeStrengthIndexIndicatorModule, IgrRenderRequestedEventArgs, IgrRing, IgrRingSeries, IgrRingSeriesBase, IgrRingSeriesCollection, IgrRingSeriesModule, IgrScaleLegend, IgrScaleLegendModule, IgrScalerParams, IgrScatterAreaSeries, IgrScatterAreaSeriesModule, IgrScatterBase, IgrScatterContourSeries, IgrScatterContourSeriesModule, IgrScatterLineSeries, IgrScatterLineSeriesModule, IgrScatterPolygonSeries, IgrScatterPolygonSeriesModule, IgrScatterPolylineSeries, IgrScatterPolylineSeriesModule, IgrScatterSeries, IgrScatterSeriesModule, IgrScatterSplineSeries, IgrScatterSplineSeriesModule, IgrScatterTriangulationSeries, IgrSelectedItemChangedEventArgs, IgrSelectedItemChangingEventArgs, IgrSelectedItemsChangedEventArgs, IgrSelectedItemsChangingEventArgs, IgrSeries, IgrSeriesCollection, IgrSeriesViewer, IgrShapeSeriesBase, IgrSizeScale, IgrSizeScaleModule, IgrSliceClickEventArgs, IgrSlowStochasticOscillatorIndicator, IgrSlowStochasticOscillatorIndicatorModule, IgrSparkline, IgrSparklineCoreModule, IgrSparklineModule, IgrSplineAreaFragment, IgrSplineAreaFragmentModule, IgrSplineAreaSeries, IgrSplineAreaSeriesModule, IgrSplineFragment, IgrSplineFragmentBase, IgrSplineFragmentModule, IgrSplineSeries, IgrSplineSeriesBase, IgrSplineSeriesModule, IgrStacked100AreaSeries, IgrStacked100AreaSeriesModule, IgrStacked100BarSeries, IgrStacked100BarSeriesModule, IgrStacked100ColumnSeries, IgrStacked100ColumnSeriesModule, IgrStacked100LineSeries, IgrStacked100LineSeriesModule, IgrStacked100SplineAreaSeries, IgrStacked100SplineAreaSeriesModule, IgrStacked100SplineSeries, IgrStacked100SplineSeriesModule, IgrStackedAreaSeries, IgrStackedAreaSeriesModule, IgrStackedBarSeries, IgrStackedBarSeriesModule, IgrStackedColumnSeries, IgrStackedColumnSeriesModule, IgrStackedFragmentSeries, IgrStackedFragmentSeriesModule, IgrStackedLineSeries, IgrStackedLineSeriesModule, IgrStackedSeriesBase, IgrStackedSeriesCollection, IgrStackedSeriesCreatedEventArgs, IgrStackedSplineAreaSeries, IgrStackedSplineAreaSeriesModule, IgrStackedSplineSeries, IgrStackedSplineSeriesModule, IgrStandardDeviationIndicator, IgrStandardDeviationIndicatorModule, IgrStepAreaSeries, IgrStepAreaSeriesModule, IgrStepLineSeries, IgrStepLineSeriesModule, IgrStochRSIIndicator, IgrStochRSIIndicatorModule, IgrStraightNumericAxisBase, IgrStrategyBasedIndicator, IgrStyleShapeEventArgs, IgrTRIXIndicator, IgrTRIXIndicatorModule, IgrTimeAxisBase, IgrTimeAxisBreak, IgrTimeAxisBreakCollection, IgrTimeAxisBreakModule, IgrTimeAxisInterval, IgrTimeAxisIntervalCollection, IgrTimeAxisIntervalModule, IgrTimeAxisLabelFormat, IgrTimeAxisLabelFormatCollection, IgrTimeAxisLabelFormatModule, IgrTimeXAxis, IgrTimeXAxisModule, IgrTreemap, IgrTreemapModule, IgrTreemapNodePointerEventArgs, IgrTreemapNodeStyle, IgrTreemapNodeStyleMapping, IgrTreemapNodeStyleMappingCollection, IgrTreemapNodeStyleMappingModule, IgrTreemapNodeStyleModule, IgrTreemapNodeStylingEventArgs, IgrTypicalPriceIndicator, IgrTypicalPriceIndicatorModule, IgrUltimateOscillatorIndicator, IgrUltimateOscillatorIndicatorModule, IgrValueBrushScale, IgrValueBrushScaleModule, IgrValueOverlay, IgrValueOverlayModule, IgrVerticalAnchoredCategorySeries, IgrVerticalStackedSeriesBase, IgrWaterfallSeries, IgrWaterfallSeriesModule, IgrWeightedCloseIndicator, IgrWeightedCloseIndicatorModule, IgrWilliamsPercentRIndicator, IgrWilliamsPercentRIndicatorModule, IgrXYChart, IgrZoomSlider, IgrZoomSliderModule, IgrZoomSliderResolvingAxisValueEventArgs, IgxCategoryChartComponent_PROVIDERS, IgxZoomSliderComponent_PROVIDERS, IndexCollection, IndicatorCalculationStrategy, IndicatorDisplayType, IndicatorDisplayTypeCollection, IndicatorDisplayType_$type, IndicatorPane, IndicatorProxy, IndicatorRenderer, InteractionMessage_Spark, InteractivityFactoryManager, ItemHighlightFrameRect, ItemLegend, ItemLegendView, ItemToolTipLayer, ItemToolTipLayerView, ItemTooltipCollisionInfo, ItemTooltipLayerFrame, ItemwiseIndicatorCalculationStrategy, ItemwiseStrategyBasedIndicator, ItemwiseStrategyCalculationStrategy, KDPointData, KDTree2D, KDTreeNode2D, KDTreeThunk, KNearestResult, KNearestResults, LabelClickEventArgs, LabelFontHeuristics, LabelPanelArranger, LabelPanelsArrangeState, LabelPosition, LabelsPosition, LabelsPosition_$type, LeaderLineType, LeaderLineType_$type, Legend, LegendBase, LegendBaseStyles, LegendBaseView, LegendBaseViewManager, LegendItemInfo, LegendItemVisualData, LegendMouseButtonEventArgs, LegendMouseEventArgs, LegendOrientation, LegendOrientation_$type, LegendTemplates, LegendView, LegendVisualData, LegendVisualDataList, LineFragment, LineFragmentBucketCalculator, LineFragmentView, LineSeries, LineSeriesView, LinearCategorySnapper, LinearContourValueResolver, LinearNumericSnapper, LinearScaler, LinearTickmarkValues, LogarithmicNumericSnapper, LogarithmicScaler, LogarithmicTickmarkValues, Marker, MarkerManagerBase, MarkerManagerBucket, MarkerMessage_Spark, MarkerSeries, MarkerSeriesView, MarkerTemplates, MarkerType, MarkerTypeCollection, MarkerType_$type, MarkerVisualData, MarkerVisualDataList, MarketFacilitationIndexIndicator, MarketFacilitationIndexIndicatorStrategy, MassIndexIndicator, MassIndexIndicatorStrategy, MedianPriceIndicator, MedianPriceIndicatorStrategy, MessageChannel_Spark, MessageHandler_Spark, Message_Spark, MoneyFlowIndexIndicator, MoneyFlowIndexIndicatorStrategy, MouseLeaveMessage_Spark, MouseMoveMessage_Spark, MouseMoveThunk, MovingAverageConvergenceDivergenceIndicator, MovingAverageConvergenceDivergenceIndicatorStrategy, NaNSegmenter, NegativeVolumeIndexIndicator, NegativeVolumeIndexIndicatorStrategy, Node$1 as Node, NonCollisionAvoider, NormalRangeMessage_Spark, NumberAbbreviator, NumberAbbreviatorFactory, NumberChangedMessage_Spark, NumericAngleAxis, NumericAngleAxisView, NumericAxisBase, NumericAxisBaseView, NumericAxisRenderer, NumericAxisRenderingParameters, NumericMarkerManager, NumericRadiusAxis, NumericRadiusAxisView, NumericScaleMode, NumericScaleMode_$type, NumericScaler, NumericXAxis, NumericXAxisView, NumericYAxis, NumericYAxisView, OnBalanceVolumeIndicator, OnBalanceVolumeIndicatorStrategy, OrderedDictionary, OrderedDictionary$2, OrderedDictionary_Enumerator$2, OrdinalTimeXAxis, OthersCategoryType, OthersCategoryType_$type, OverlayProxy, OverviewPlusDetailViewportHost, OwnedPoint, PathRenderer, PathRenderingInfo, PercentChangeAxisRenderer, PercentChangeYAxis, PercentKCalculationStrategy, PercentagePriceOscillatorIndicator, PercentagePriceOscillatorIndicatorStrategy, PercentageVolumeOscillatorIndicator, PercentageVolumeOscillatorIndicatorStrategy, PieChartBase, PieChartBaseView, PieChartSliceSelector, PieChartStyleInfo, PieChartViewManager, PieChartVisualData, PieLabel, PieLegendTemplates, PieSliceDataContext, PieSliceOthersContext, PieSliceVisualData, PieSliceVisualDataList, PixelRatioMessage_Spark, PointSeries, PointSeriesView, PointerTooltip, PointerTooltipPointerLocation, PointerTooltipPointerLocation_$type, PointerTooltipStyle, PointerTooltipView, PointerTooltipVisualData, PointerTooltipVisualDataList, PolarAreaSeries, PolarAreaSeriesView, PolarAxes, PolarAxisInfoCache, PolarAxisRenderingManager, PolarAxisRenderingParameters, PolarBase, PolarBaseView, PolarFrame, PolarLinePlanner, PolarLineSeries, PolarLineSeriesBase, PolarLineSeriesBaseView, PolarLineSeriesView, PolarScatterSeries, PolarScatterSeriesView, PolarSplineAreaSeries, PolarSplineAreaSeriesView, PolarSplineSeries, PolarSplineSeriesView, PolarTrendLineManager, PolygonMessage_Spark, PolylineBuilder, PositiveVolumeIndexIndicator, PositiveVolumeIndexIndicatorStrategy, PreparationParams, PriceChannelBucketCalculator, PriceChannelOverlay, PriceChannelOverlayView, PriceDisplayType, PriceDisplayType_$type, PriceVolumeTrendIndicator, PriceVolumeTrendIndicatorStrategy, ProgressiveLoadStatusEventArgs, PropertyChangedMessage_Spark, RadialAreaSeries, RadialAreaSeriesView, RadialAxes, RadialAxisLabelPanel, RadialAxisLabelPanelView, RadialAxisRenderingParameters, RadialBase, RadialBaseView, RadialBucketCalculator, RadialColumnSeries, RadialColumnSeriesView, RadialFrame, RadialLineSeries, RadialLineSeriesView, RadialPieSeries, RadialPieSeriesView, RadialTrendLineManager, RangeAreaSeries, RangeAreaSeriesView, RangeCategoryBucketCalculator, RangeCategoryFramePreparer, RangeCategorySeries, RangeCategorySeriesView, RangeColumnSeries, RangeColumnSeriesView, RangeInfo, RangeValueList, RateOfChangeAndMomentumIndicator, RateOfChangeAndMomentumIndicatorStrategy, RelativeStrengthIndexIndicator, RelativeStrengthIndexIndicatorStrategy, RenderRequestedEventArgs, RenderSurface, RenderingMessage_Spark, Ring, RingCollection, RingControl, RingControlView, RingSeries, RingSeriesBase, RingSeriesBaseView, RingSeriesCollection, RingSeriesVisualData, RingSeriesVisualDataList, RingVisualData, RingVisualDataList, SafeEnumerable, SafeReadOnlyDoubleCollection, SafeSortedReadOnlyDoubleCollection, ScaleLegend, ScaleLegendView, ScalerParams, ScatterAreaSeries, ScatterAreaSeriesView, ScatterAxisInfoCache, ScatterBase, ScatterBaseView, ScatterContourSeries, ScatterContourSeriesView, ScatterErrorBarSettings, ScatterFrame, ScatterFrameBase$1, ScatterLineSeries, ScatterLineSeriesView, ScatterPolygonSeries, ScatterPolygonSeriesView, ScatterPolylineSeries, ScatterPolylineSeriesView, ScatterSeries, ScatterSeriesView, ScatterSplineSeries, ScatterSplineSeriesView, ScatterTrendLineManager, ScatterTriangulationSeries, SearchArgs, SearchData, SelectedItemChangedEventArgs, SelectedItemChangingEventArgs, SelectedItemsChangedEventArgs, SelectedItemsChangingEventArgs, Series, SeriesCollection, SeriesComponentsForView, SeriesComponentsFromView, SeriesHitTestMode, SeriesHitTestMode_$type, SeriesInteractionManager, SeriesPointOfInterest, SeriesRenderer$2, SeriesRenderingArguments, SeriesView, SeriesViewer, SeriesViewerComponentsForView, SeriesViewerComponentsFromView, SeriesViewerInteractionManager, SeriesViewerSurfaceViewer, SeriesViewerView, SeriesViewerViewManager, SeriesVisualData, SeriesVisualDataList, SeriesVisualDataManager, ServiceProvider_Spark, ShapeAxisInfoCache, ShapeHitRegion, ShapeSeriesBase, ShapeSeriesViewBase, SingleValuesHolder, SizeScale, Slice, SliceAndDiceCalculator, SliceClickEventArgs, SliceCollection, SliceCoords, SliceItem, SliceSelectionMode, SliceSelectionMode_$type, SliceView, SliceVisualData, SliceVisualDataList, SlowStochasticOscillatorIndicator, SlowStochasticOscillatorIndicatorStrategy, Snapper, SortedListView$1, SortingTrendLineManager, SparkFrame, SparkFramePreparer, SparkLayerType_$type, SparklineAxisVisualData, SparklineConnector, SparklineController, SparklineDisplayType, SparklineDisplayType_$type, SparklineStylingDefaults, SparklineToolTipContext, SparklineVisualData, SplineAreaFragment, SplineAreaFragmentView, SplineAreaSeries, SplineAreaSeriesView, SplineFragment, SplineFragmentBase, SplineFragmentBucketCalculator, SplineFragmentView, SplineSeries, SplineSeriesBase, SplineSeriesBaseView, SplineSeriesView, SplineType, SplineType_$type, SquarifiedCalculator, Stacked100AreaSeries, Stacked100BarBucketCalculator, Stacked100BarSeries, Stacked100BarSeriesView, Stacked100ColumnBucketCalculator, Stacked100ColumnSeries, Stacked100ColumnSeriesView, Stacked100DataPreparer, Stacked100LineSeries, Stacked100SplineAreaSeries, Stacked100SplineSeries, StackedAreaSeries, StackedBarBucketCalculator, StackedBarSeries, StackedBarSeriesView, StackedBucketCalculator, StackedColumnBucketCalculator, StackedColumnSeries, StackedColumnSeriesView, StackedFragmentSeries, StackedLineSeries, StackedSeriesBase, StackedSeriesCollection, StackedSeriesCreatedEventArgs, StackedSeriesFramePreparer, StackedSeriesManager, StackedSeriesView, StackedSeriesVisualData, StackedSplineAreaSeries, StackedSplineSeries, StandardDeviationIndicator, StandardDeviationIndicatorStrategy, StepAreaSeries, StepAreaSeriesView, StepLineSeries, StepLineSeriesView, StochRSIIndicator, StochRSIIndicatorStrategy, StraightNumericAxisBase, StraightNumericAxisBaseView, StrategyBasedIndicator, StreamingIndicatorCalculationStrategy, StrippedCalculator, StyleSelector, StyleShapeEventArgs, SupportingCalculation$1, SyncLink, SyncLinkManager, SyncManager, SyncSettings, SyncSettingsConverter, TRIXIndicator, TRIXIndicatorStrategy, TemplatePicker, TemplatedHtmlControl, ThumbRangePosition, ThumbRangePosition_$type, TickmarkValues, TickmarkValuesInitializationParameters, TileZoomInfo, TileZoomManager, TileZoomTile, TileZoomTileCache, TileZoomTileInfo, TimeAxisBase, TimeAxisBreak, TimeAxisBreakCollection, TimeAxisDisplayType, TimeAxisDisplayType_$type, TimeAxisInterval, TimeAxisIntervalCollection, TimeAxisIntervalType, TimeAxisIntervalType_$type, TimeAxisLabelFormat, TimeAxisLabelFormatCollection, TimeXAxis, TitleSettings, ToolTipType, ToolTipType_$type, Tooltip, TooltipMessage_Spark, ToooltipTemplateMessage_Spark, TrackShadeOrientation_$type, TrackThumb, TrackThumbRange, TransitionInSpeedType, TransitionInSpeedType_$type, Treemap, TreemapFillScaleMode, TreemapFillScaleMode_$type, TreemapFrame, TreemapHeaderDisplayMode, TreemapHeaderDisplayMode_$type, TreemapLabelHorizontalFitMode, TreemapLabelHorizontalFitMode_$type, TreemapLabelVerticalFitMode, TreemapLabelVerticalFitMode_$type, TreemapLabelVisualData, TreemapLayoutCalculator, TreemapLayoutSettings, TreemapLayoutType, TreemapLayoutType_$type, TreemapNodeFrame, TreemapNodePointerEventArgs, TreemapNodeStyle, TreemapNodeStyleMapping, TreemapNodeStyleMappingCollection, TreemapNodeStyleMappingTargetType, TreemapNodeStyleMappingTargetType_$type, TreemapNodeStylingEventArgs, TreemapNodeVisualData, TreemapNodeVisualDataList, TreemapOrientation, TreemapOrientation_$type, TreemapTreeData, TreemapTreeNode, TreemapValueMappingMode, TreemapValueMappingMode_$type, TreemapView, TreemapViewRenderer, TreemapVisual, TreemapVisualData, TrendAverageCalculator, TrendFitCalculator, TrendLineManagerBase$1, TrendLineManagerType_$type, TrendLineMessage_Spark, TrendResolutionParams, TriangleRasterizer, TriangleRasterizer_PointAndValue, TypicalPriceIndicator, TypicalPriceIndicatorStrategy, UltimateOscillatorIndicator, UltimateOscillatorIndicatorCalculationStrategy, ValueBrushScale, ValueOverlay, ValueOverlayView, ValuesHolder, VerticalAnchoredCategorySeries, VerticalAnchoredCategorySeriesInteractionManager, VerticalAxisLabelPanel, VerticalAxisLabelPanelView, VerticalAxisView, VerticalLinearScaler, VerticalLogarithmicScaler, VerticalPercentChangeScaler, VerticalStackedSeriesBase, ViewerSurfaceUsage, ViewerSurfaceUsage_$type, ViewportChangedMessage_Spark, ViewportUtils, VisibilityMessage_Spark, VisualDataFactoryManager, VisualDataSerializer, VisualExportHelper, WaterfallSeries, WaterfallSeriesView, WeightedCloseIndicator, WeightedCloseIndicatorStrategy, WilliamsPercentRIndicator, WilliamsPercentRIndicatorStrategy, WinLossColumnMessage_Spark, WindowResponse, WindowResponse_$type, XYChart, XamDataChart, XamDataChartView, XamDoughnutChart, XamDoughnutChartView, XamPieChart, XamPieChartView, XamSparkline, XamSparklineView, ZoomSlider, ZoomSliderCursor_$type, ZoomSliderOrientation, ZoomSliderOrientation_$type, ZoomSliderResolvingAxisValueEventArgs, ZoomSliderView, ZoomSliderVisualArea_$type };
//# sourceMappingURL=igniteui-react-charts.js.map
